/*===========================================================================*/
/*   (Llib/thread.scm)                                                       */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -unsafe -safee -copt -fPIC -copt -IPosix Llib/thread.scm -o objs/thread.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z62exceptionz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_z62exceptionz62_bglt;

typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
} *BgL_threadz00_bglt;

typedef struct BgL_terminatedzd2threadzd2exceptionz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_terminatedzd2threadzd2exceptionz00_bglt;

typedef struct BgL_fthreadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
} *BgL_fthreadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
} *BgL_schedulerz00_bglt;

typedef struct BgL_z52sigjoinz52_bgl {
   header_t header;
   obj_t widening;
   struct BgL_fthreadz00_bgl * BgL_threadz00;
} *BgL_z52sigjoinz52_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_schedulerz00;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_z52cleanupz52;
   obj_t BgL_z52specificz52;
   obj_t BgL_bodyz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_strictzd2orderzf3z21;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_threadszd2runnablezd2lastzd2pairzd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
   obj_t BgL_currentzd2tokenzd2;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52sigasyncz52_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_spawnedz00;
   obj_t BgL_idz00;
   obj_t BgL_thunkz00;
} *BgL_z52sigasyncz52_bglt;

typedef struct BgL_joinzd2timeoutzd2exceptionz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
} *BgL_joinzd2timeoutzd2exceptionz00_bglt;


BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitza2z12z62zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2specificzd2fthr1151z62zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_z62threadzd2resumez12za2zz__ft_threadz00(obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
static obj_t BGl_z62threadzd2joinz12zd2fthread1143z70zz__ft_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__ft_threadz00();
BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_libraryzd2multithreadzd2setz12z12zz__libraryz00(bool_t);
BGL_IMPORT obj_t BGl_z62exceptionz62zz__objectz00;
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__ft_threadz00();
static obj_t BGl_z62threadzd2cleanupzd2fthre1155z62zz__ft_threadz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
extern obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
BGL_IMPORT obj_t BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00;
BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitz12zc0zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadzd2startz12zc0zz__threadz00(BgL_threadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__ft_threadz00();
static obj_t BGl_z62threadzd2suspendz12za2zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_displayza2za2zz__r4_output_6_10_3z00(obj_t);
static obj_t BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_fthreadz00_bglt, obj_t, bool_t);
extern obj_t BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt, int);
static obj_t BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
extern obj_t BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(BgL_fthreadz00_bglt, obj_t);
static obj_t BGl_z62threadzd2startz12zd2fthrea1147z70zz__ft_threadz00(obj_t, obj_t, obj_t);
extern obj_t BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(obj_t, obj_t);
static obj_t BGl_z62objectzd2equalzf3zd2z52sigjo1141zc3zz__ft_threadz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_threadz00 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ft_threadz00();
static obj_t BGl_z62zc3z04anonymousza31696ze3ze5zz__ft_threadz00(obj_t);
static obj_t BGl_genericzd2initzd2zz__ft_threadz00();
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_fthreadz00_bglt);
static obj_t BGl_z62threadzd2awaitz12za2zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62objectzd2writezd2fthread1145z62zz__ft_threadz00(obj_t, obj_t, obj_t);
extern obj_t BGl_fthreadz00zz__ft_typesz00;
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
extern obj_t BGl_z52sigjoinz52zz__ft_typesz00;
extern obj_t BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(BgL_fthreadz00_bglt);
extern bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_fthreadz00_bglt);
extern obj_t BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(obj_t, obj_t, BgL_threadz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(obj_t);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52envz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pth_threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__libraryz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62threadzd2terminatez12zd2ft1149z70zz__ft_threadz00(obj_t, obj_t);
extern obj_t BGl_z52sigasyncz52zz__ft_z52typesz52;
BGL_IMPORT obj_t BGl_currentzd2threadzd2zz__threadz00();
static obj_t BGl_z62zc3z04anonymousza31535ze3ze5zz__ft_threadz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31179ze3ze5zz__ft_threadz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__ft_threadz00();
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_threadz00();
extern obj_t BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(BgL_fthreadz00_bglt);
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_threadz00();
BGL_EXPORTED_DECL obj_t BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_fthreadz00_bglt);
static BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1523z62zz__ft_threadz00(obj_t, obj_t, obj_t, obj_t);
static BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1527z62zz__ft_threadz00(obj_t);
static obj_t BGl_z62threadzd2specificzd2setz121153z70zz__ft_threadz00(obj_t, obj_t, obj_t);
extern obj_t BGl_signalzd2lookupzd2zz__ft_signalz00(obj_t, obj_t);
static obj_t BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62threadzd2cleanupzd2setz12zd21157za2zz__ft_threadz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(obj_t, obj_t);
extern obj_t BGl_signalzd2valuezd2zz__ft_signalz00(obj_t, obj_t);
extern obj_t BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(obj_t);
extern obj_t BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(BgL_fthreadz00_bglt);
BGL_IMPORT bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_threadz00zz__threadz00;
extern obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
static obj_t __cnst[ 11 ] ;


BGL_IMPORT obj_t BGl_threadzd2startz12zd2envz12zz__threadz00;
BGL_IMPORT obj_t BGl_objectzd2writezd2envz00zz__objectz00;
BGL_IMPORT obj_t BGl_threadzd2specificzd2envz00zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitzd2valuesza2z12zd2envz62zz__ft_threadz00, BgL_bgl_za762threadza7d2awai1971z00, va_generic_entry, BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1937z00zz__ft_threadz00, BgL_bgl_za762za7c3za704anonymo1972za7, BGl_z62zc3z04anonymousza31535ze3ze5zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1938z00zz__ft_threadz00, BgL_bgl_za762lambda1527za7621973z00, BGl_z62lambda1527z62zz__ft_threadz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1939z00zz__ft_threadz00, BgL_bgl_za762lambda1523za7621974z00, BGl_z62lambda1523z62zz__ft_threadz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1940z00zz__ft_threadz00, BgL_bgl_za762objectza7d2equa1975z00, BGl_z62objectzd2equalzf3zd2z52sigjo1141zc3zz__ft_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1942z00zz__ft_threadz00, BgL_bgl_za762threadza7d2join1976z00, va_generic_entry, BGl_z62threadzd2joinz12zd2fthread1143z70zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1944z00zz__ft_threadz00, BgL_bgl_za762objectza7d2writ1977z00, va_generic_entry, BGl_z62objectzd2writezd2fthread1145z62zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1946z00zz__ft_threadz00, BgL_bgl_za762threadza7d2star1978z00, va_generic_entry, BGl_z62threadzd2startz12zd2fthrea1147z70zz__ft_threadz00, BUNSPEC, -2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1948z00zz__ft_threadz00, BgL_bgl_za762threadza7d2term1979z00, BGl_z62threadzd2terminatez12zd2ft1149z70zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1950z00zz__ft_threadz00, BgL_bgl_za762threadza7d2spec1980z00, BGl_z62threadzd2specificzd2fthr1151z62zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1952z00zz__ft_threadz00, BgL_bgl_za762threadza7d2spec1981z00, BGl_z62threadzd2specificzd2setz121153z70zz__ft_threadz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1954z00zz__ft_threadz00, BgL_bgl_za762threadza7d2clea1982z00, BGl_z62threadzd2cleanupzd2fthre1155z62zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc1956z00zz__ft_threadz00, BgL_bgl_za762threadza7d2clea1983z00, BGl_z62threadzd2cleanupzd2setz12zd21157za2zz__ft_threadz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_threadzd2terminatez12zd2envz12zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2getzd2valuesz12zd2envzc0zz__ft_threadz00, BgL_bgl_za762threadza7d2getza71984za7, BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2resumez12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2resu1985z00, BGl_z62threadzd2resumez12za2zz__ft_threadz00, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_threadzd2cleanupzd2envz00zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitz12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2awai1986z00, va_generic_entry, BGl_z62threadzd2awaitz12za2zz__ft_threadz00, BUNSPEC, -2 );
BGL_IMPORT obj_t BGl_threadzd2joinz12zd2envz12zz__threadz00;
DEFINE_STRING( BGl_string1922z00zz__ft_threadz00, BgL_bgl_string1922za700za7za7_1987za7, "Llib/thread.scm", 15 );
DEFINE_STRING( BGl_string1923z00zz__ft_threadz00, BgL_bgl_string1923za700za7za7_1988za7, "thread-await", 12 );
DEFINE_STRING( BGl_string1924z00zz__ft_threadz00, BgL_bgl_string1924za700za7za7_1989za7, "Illegal timeout", 15 );
DEFINE_STRING( BGl_string1925z00zz__ft_threadz00, BgL_bgl_string1925za700za7za7_1990za7, "unattached thread", 17 );
DEFINE_STRING( BGl_string1926z00zz__ft_threadz00, BgL_bgl_string1926za700za7za7_1991za7, "no such thread", 14 );
DEFINE_STRING( BGl_string1927z00zz__ft_threadz00, BgL_bgl_string1927za700za7za7_1992za7, "thread-await*", 13 );
DEFINE_STRING( BGl_string1928z00zz__ft_threadz00, BgL_bgl_string1928za700za7za7_1993za7, "/builddir/build/BUILD/bigloo-4.4a/api/fthread/src/Llib/thread.scm", 65 );
DEFINE_STRING( BGl_string1929z00zz__ft_threadz00, BgL_bgl_string1929za700za7za7_1994za7, "&thread-await*!", 15 );
DEFINE_STRING( BGl_string1930z00zz__ft_threadz00, BgL_bgl_string1930za700za7za7_1995za7, "pair", 4 );
DEFINE_STRING( BGl_string1931z00zz__ft_threadz00, BgL_bgl_string1931za700za7za7_1996za7, "&thread-get-values*!", 20 );
DEFINE_STRING( BGl_string1932z00zz__ft_threadz00, BgL_bgl_string1932za700za7za7_1997za7, "&thread-await-values*!", 22 );
DEFINE_STRING( BGl_string1933z00zz__ft_threadz00, BgL_bgl_string1933za700za7za7_1998za7, "Unattached thread", 17 );
DEFINE_STRING( BGl_string1934z00zz__ft_threadz00, BgL_bgl_string1934za700za7za7_1999za7, "&thread-suspend!", 16 );
DEFINE_STRING( BGl_string1935z00zz__ft_threadz00, BgL_bgl_string1935za700za7za7_2000za7, "fthread", 7 );
DEFINE_STRING( BGl_string1936z00zz__ft_threadz00, BgL_bgl_string1936za700za7za7_2001za7, "&thread-resume!", 15 );
DEFINE_STRING( BGl_string1941z00zz__ft_threadz00, BgL_bgl_string1941za700za7za7_2002za7, "object-equal?", 13 );
DEFINE_STRING( BGl_string1943z00zz__ft_threadz00, BgL_bgl_string1943za700za7za7_2003za7, "thread-join!", 12 );
DEFINE_STRING( BGl_string1945z00zz__ft_threadz00, BgL_bgl_string1945za700za7za7_2004za7, "object-write", 12 );
DEFINE_STRING( BGl_string1947z00zz__ft_threadz00, BgL_bgl_string1947za700za7za7_2005za7, "thread-start!", 13 );
DEFINE_STRING( BGl_string1949z00zz__ft_threadz00, BgL_bgl_string1949za700za7za7_2006za7, "thread-terminate!", 17 );
DEFINE_STRING( BGl_string1951z00zz__ft_threadz00, BgL_bgl_string1951za700za7za7_2007za7, "thread-specific", 15 );
DEFINE_STRING( BGl_string1953z00zz__ft_threadz00, BgL_bgl_string1953za700za7za7_2008za7, "thread-specific-set!", 20 );
DEFINE_STRING( BGl_string1955z00zz__ft_threadz00, BgL_bgl_string1955za700za7za7_2009za7, "thread-cleanup", 14 );
DEFINE_STRING( BGl_string1957z00zz__ft_threadz00, BgL_bgl_string1957za700za7za7_2010za7, "thread-cleanup-set!", 19 );
DEFINE_STRING( BGl_string1958z00zz__ft_threadz00, BgL_bgl_string1958za700za7za7_2011za7, "thread already running", 22 );
DEFINE_STRING( BGl_string1959z00zz__ft_threadz00, BgL_bgl_string1959za700za7za7_2012za7, ">", 1 );
DEFINE_STRING( BGl_string1960z00zz__ft_threadz00, BgL_bgl_string1960za700za7za7_2013za7, " signals=", 9 );
DEFINE_STRING( BGl_string1961z00zz__ft_threadz00, BgL_bgl_string1961za700za7za7_2014za7, " timeout=", 9 );
DEFINE_STRING( BGl_string1962z00zz__ft_threadz00, BgL_bgl_string1962za700za7za7_2015za7, " state=", 7 );
DEFINE_STRING( BGl_string1963z00zz__ft_threadz00, BgL_bgl_string1963za700za7za7_2016za7, "#<fthread:", 10 );
DEFINE_STRING( BGl_string1964z00zz__ft_threadz00, BgL_bgl_string1964za700za7za7_2017za7, "thread-join", 11 );
DEFINE_STRING( BGl_string1965z00zz__ft_threadz00, BgL_bgl_string1965za700za7za7_2018za7, "integer", 7 );
DEFINE_STRING( BGl_string1966z00zz__ft_threadz00, BgL_bgl_string1966za700za7za7_2019za7, "__ft_thread", 11 );
DEFINE_STRING( BGl_string1967z00zz__ft_threadz00, BgL_bgl_string1967za700za7za7_2020za7, "dead terminated started thread-start! thread-terminate! __ft_thread join-timeout-exception thread-resume! thread-suspend! end init ", 131 );
BGL_IMPORT obj_t BGl_objectzd2equalzf3zd2envzf3zz__objectz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2getzd2valuesza2z12zd2envz62zz__ft_threadz00, BgL_bgl_za762threadza7d2getza72021za7, BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2suspendz12zd2envz12zz__ft_threadz00, BgL_bgl_za762threadza7d2susp2022z00, BGl_z62threadzd2suspendz12za2zz__ft_threadz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitza2z12zd2envzb0zz__ft_threadz00, BgL_bgl_za762threadza7d2awai2023z00, va_generic_entry, BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00, BUNSPEC, -2 );
BGL_IMPORT obj_t BGl_threadzd2specificzd2setz12zd2envzc0zz__threadz00;
BGL_IMPORT obj_t BGl_threadzd2cleanupzd2setz12zd2envzc0zz__threadz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_threadzd2awaitzd2valuesz12zd2envzc0zz__ft_threadz00, BgL_bgl_za762threadza7d2awai2024z00, va_generic_entry, BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00, BUNSPEC, -2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__ft_threadz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long BgL_checksumz00_749, char * BgL_fromz00_750)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_threadz00))
{ 
BGl_requirezd2initializa7ationz75zz__ft_threadz00 = 
BBOOL(((bool_t)0)); 
BGL_GC_INIT(); 
BGl_gczd2rootszd2initz00zz__ft_threadz00(); 
BGl_libraryzd2moduleszd2initz00zz__ft_threadz00(); 
BGl_cnstzd2initzd2zz__ft_threadz00(); 
BGl_importedzd2moduleszd2initz00zz__ft_threadz00(); 
BGl_objectzd2initzd2zz__ft_threadz00(); 
BGl_methodzd2initzd2zz__ft_threadz00(); 
return 
BGl_toplevelzd2initzd2zz__ft_threadz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__libraryz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__ft_thread"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__ft_thread"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 15 */
obj_t BgL_cportz00_649;
{ /* Llib/thread.scm 15 */
obj_t BgL_stringz00_657;
BgL_stringz00_657 = BGl_string1967z00zz__ft_threadz00; 
{ /* Llib/thread.scm 15 */
obj_t BgL_startz00_658;
BgL_startz00_658 = 
BINT(((long)0)); 
{ /* Llib/thread.scm 15 */
obj_t BgL_endz00_659;
BgL_endz00_659 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_657))); 
{ /* Llib/thread.scm 15 */

BgL_cportz00_649 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_657, BgL_startz00_658, BgL_endz00_659); } } } } 
{ 
long BgL_iz00_650;
BgL_iz00_650 = ((long)10); 
BgL_loopz00_651:
if(
(BgL_iz00_650==((long)-1)))
{ /* Llib/thread.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 15 */
obj_t BgL_arg1969z00_653;
{ /* Llib/thread.scm 15 */

{ /* Llib/thread.scm 15 */
obj_t BgL_locationz00_655;
BgL_locationz00_655 = 
BBOOL(((bool_t)0)); 
{ /* Llib/thread.scm 15 */

BgL_arg1969z00_653 = 
BGl_readz00zz__readerz00(BgL_cportz00_649, BgL_locationz00_655); } } } 
{ /* Llib/thread.scm 15 */
int BgL_tmpz00_786;
BgL_tmpz00_786 = 
(int)(BgL_iz00_650); 
CNST_TABLE_SET(BgL_tmpz00_786, BgL_arg1969z00_653); } } 
{ /* Llib/thread.scm 15 */
int BgL_auxz00_656;
BgL_auxz00_656 = 
(int)(
(BgL_iz00_650-((long)1))); 
{ 
long BgL_iz00_791;
BgL_iz00_791 = 
(long)(BgL_auxz00_656); 
BgL_iz00_650 = BgL_iz00_791; 
goto BgL_loopz00_651;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__pth_threadz00(((long)0), 
BSTRING_TO_STRING(BGl_string1922z00zz__ft_threadz00)); 
BGl_libraryzd2multithreadzd2setz12z12zz__libraryz00(((bool_t)1)); 
return BUNSPEC;} 

}



/* thread-await! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitz12zc0zz__ft_threadz00(obj_t BgL_sigz00_7, obj_t BgL_argz00_8)
{
{ /* Llib/thread.scm 107 */
{ /* Llib/thread.scm 108 */
obj_t BgL_tz00_42;
BgL_tz00_42 = 
BGl_currentzd2threadzd2zz__threadz00(); 
{ /* Llib/thread.scm 108 */

{ 
BgL_schedulerz00_bglt BgL_scdlz00_79;obj_t BgL_sigz00_80;obj_t BgL_timeoutz00_81;BgL_schedulerz00_bglt BgL_scdlz00_53;obj_t BgL_sigz00_54;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_42, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 159 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))
{ /* Llib/thread.scm 161 */
if(
PAIRP(BgL_argz00_8))
{ /* Llib/thread.scm 165 */
obj_t BgL_arg1164z00_49;obj_t BgL_arg1166z00_50;
BgL_arg1164z00_49 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))->BgL_schedulerz00); 
BgL_arg1166z00_50 = 
CAR(BgL_argz00_8); 
BgL_scdlz00_79 = 
((BgL_schedulerz00_bglt)BgL_arg1164z00_49); 
BgL_sigz00_80 = BgL_sigz00_7; 
BgL_timeoutz00_81 = BgL_arg1166z00_50; 
{ /* Llib/thread.scm 137 */
bool_t BgL_test2030z00_810;
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_timeoutz00_81))
{ /* Llib/thread.scm 137 */
if(
INTEGERP(BgL_timeoutz00_81))
{ /* Llib/thread.scm 137 */
BgL_test2030z00_810 = 
(
(long)CINT(BgL_timeoutz00_81)>((long)0))
; }  else 
{ /* Llib/thread.scm 137 */
BgL_test2030z00_810 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_timeoutz00_81, 
BINT(((long)0)))
; } }  else 
{ /* Llib/thread.scm 137 */
BgL_test2030z00_810 = ((bool_t)0)
; } 
if(BgL_test2030z00_810)
{ /* Llib/thread.scm 140 */
bool_t BgL_test2033z00_819;
{ /* Llib/thread.scm 140 */
obj_t BgL_arg1200z00_96;
BgL_arg1200z00_96 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BgL_test2033z00_819 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_80, BgL_arg1200z00_96)); } 
if(BgL_test2033z00_819)
{ /* Llib/thread.scm 140 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_80, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 140 */
{ /* Llib/thread.scm 144 */
obj_t BgL_arg1192z00_90;
BgL_arg1192z00_90 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_sigz00_80, BgL_arg1192z00_90, 
((BgL_threadz00_bglt)BgL_tz00_42)); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_80, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/thread.scm 147 */
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_79), 
((BgL_z52sigasyncz52_bglt)BgL_sigz00_80)); }  else 
{ /* Llib/thread.scm 147 */BFALSE; } 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42), 
CINT(BgL_timeoutz00_81)); 
{ /* Llib/thread.scm 152 */
bool_t BgL_test2035z00_836;
{ /* Llib/thread.scm 152 */
obj_t BgL_arg1199z00_95;
BgL_arg1199z00_95 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2); 
BgL_test2035z00_836 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_80, BgL_arg1199z00_95)); } 
if(BgL_test2035z00_836)
{ /* Llib/thread.scm 152 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_80, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_79))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 152 */
return BFALSE;} } } }  else 
{ /* Llib/thread.scm 137 */
return 
BGl_errorz00zz__errorz00(BGl_string1923z00zz__ft_threadz00, BGl_string1924z00zz__ft_threadz00, BgL_timeoutz00_81);} } }  else 
{ /* Llib/thread.scm 168 */
obj_t BgL_arg1167z00_52;
BgL_arg1167z00_52 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_42))))->BgL_schedulerz00); 
BgL_scdlz00_53 = 
((BgL_schedulerz00_bglt)BgL_arg1167z00_52); 
BgL_sigz00_54 = BgL_sigz00_7; 
{ /* Llib/thread.scm 113 */
bool_t BgL_test2036z00_847;
{ /* Llib/thread.scm 113 */
obj_t BgL_arg1182z00_78;
BgL_arg1182z00_78 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2); 
BgL_test2036z00_847 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_sigz00_54, BgL_arg1182z00_78)); } 
if(BgL_test2036z00_847)
{ /* Llib/thread.scm 113 */
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_54, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2));}  else 
{ /* Llib/thread.scm 116 */
bool_t BgL_test2037z00_853;
if(
BGl_isazf3zf3zz__objectz00(BgL_sigz00_54, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* Llib/thread.scm 116 */
if(
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_spawnedz00))
{ /* Llib/thread.scm 118 */
BgL_test2037z00_853 = ((bool_t)0)
; }  else 
{ /* Llib/thread.scm 118 */
BgL_test2037z00_853 = ((bool_t)1)
; } }  else 
{ /* Llib/thread.scm 116 */
BgL_test2037z00_853 = ((bool_t)0)
; } 
if(BgL_test2037z00_853)
{ /* Llib/thread.scm 116 */
((((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_spawnedz00)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/thread.scm 123 */
obj_t BgL_arg1177z00_65;
BgL_arg1177z00_65 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_idz00); 
BGl_z52threadzd2asynchroniza7ez12z35zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42), BgL_arg1177z00_65); } 
{ /* Llib/thread.scm 124 */
obj_t BgL_resz00_66;
{ /* Llib/thread.scm 124 */
obj_t BgL_exitd1083z00_67;
BgL_exitd1083z00_67 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/thread.scm 126 */
obj_t BgL_zc3z04anonymousza31179ze3z87_542;
BgL_zc3z04anonymousza31179ze3z87_542 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31179ze3ze5zz__ft_threadz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31179ze3z87_542, 
(int)(((long)0)), BgL_tz00_42); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1083z00_67, BgL_zc3z04anonymousza31179ze3z87_542); 
{ /* Llib/thread.scm 125 */
obj_t BgL_tmp1085z00_69;
{ /* Llib/thread.scm 125 */
obj_t BgL_fun1178z00_70;
BgL_fun1178z00_70 = 
(((BgL_z52sigasyncz52_bglt)COBJECT(
((BgL_z52sigasyncz52_bglt)BgL_sigz00_54)))->BgL_thunkz00); 
BgL_tmp1085z00_69 = 
PROCEDURE_ENTRY(BgL_fun1178z00_70)(BgL_fun1178z00_70, BEOA); } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1083z00_67); 
BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(BgL_tz00_42); 
BgL_resz00_66 = BgL_tmp1085z00_69; } } } 
BGl_z52broadcastz12z40zz__ft_z52schedulerz52(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_53), BgL_sigz00_54, BgL_resz00_66); 
return BgL_resz00_66;} }  else 
{ /* Llib/thread.scm 116 */
{ /* Llib/thread.scm 131 */
obj_t BgL_arg1180z00_73;
BgL_arg1180z00_73 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_sigz00_54, BgL_arg1180z00_73, 
((BgL_threadz00_bglt)BgL_tz00_42)); } 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_42)); 
return 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_sigz00_54, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_scdlz00_53))->BgL_envzb2zb2));} } } } }  else 
{ /* Llib/thread.scm 161 */
return 
BGl_errorz00zz__errorz00(BGl_string1923z00zz__ft_threadz00, BGl_string1925z00zz__ft_threadz00, BgL_tz00_42);} }  else 
{ /* Llib/thread.scm 159 */
return 
BGl_errorz00zz__errorz00(BGl_string1923z00zz__ft_threadz00, BGl_string1926z00zz__ft_threadz00, BgL_tz00_42);} } } } } 

}



/* &thread-await! */
obj_t BGl_z62threadzd2awaitz12za2zz__ft_threadz00(obj_t BgL_envz00_543, obj_t BgL_sigz00_544, obj_t BgL_argz00_545)
{
{ /* Llib/thread.scm 107 */
return 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_sigz00_544, BgL_argz00_545);} 

}



/* &<@anonymous:1179> */
obj_t BGl_z62zc3z04anonymousza31179ze3ze5zz__ft_threadz00(obj_t BgL_envz00_546)
{
{ /* Llib/thread.scm 124 */
return 
BGl_z52threadzd2synchroniza7ez12z35zz__ft_z52threadz52(
PROCEDURE_REF(BgL_envz00_546, 
(int)(((long)0))));} 

}



/* thread-await*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitza2z12z62zz__ft_threadz00(obj_t BgL_sza2za2_9, obj_t BgL_argz00_10)
{
{ /* Llib/thread.scm 173 */
{ /* Llib/thread.scm 174 */
obj_t BgL_tz00_101;
BgL_tz00_101 = 
BGl_currentzd2threadzd2zz__threadz00(); 
{ /* Llib/thread.scm 174 */

{ 
obj_t BgL_eza2za2_143;obj_t BgL_sz00_144;obj_t BgL_timeoutz00_145;obj_t BgL_eza2za2_112;obj_t BgL_sz00_113;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_101, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 215 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))
{ /* Llib/thread.scm 217 */
if(
PAIRP(BgL_argz00_10))
{ /* Llib/thread.scm 221 */
obj_t BgL_arg1204z00_108;obj_t BgL_arg1205z00_109;
BgL_arg1204z00_108 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))->BgL_schedulerz00); 
BgL_arg1205z00_109 = 
CAR(BgL_argz00_10); 
BgL_eza2za2_143 = BgL_sza2za2_9; 
BgL_sz00_144 = BgL_arg1204z00_108; 
BgL_timeoutz00_145 = BgL_arg1205z00_109; 
{ /* Llib/thread.scm 194 */
bool_t BgL_test2043z00_908;
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_timeoutz00_145))
{ /* Llib/thread.scm 194 */
if(
INTEGERP(BgL_timeoutz00_145))
{ /* Llib/thread.scm 194 */
BgL_test2043z00_908 = 
(
(long)CINT(BgL_timeoutz00_145)>=((long)0))
; }  else 
{ /* Llib/thread.scm 194 */
BgL_test2043z00_908 = 
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_timeoutz00_145, 
BINT(((long)0)))
; } }  else 
{ /* Llib/thread.scm 194 */
BgL_test2043z00_908 = ((bool_t)0)
; } 
if(BgL_test2043z00_908)
{ /* Llib/thread.scm 196 */
obj_t BgL_g1093z00_151;
BgL_g1093z00_151 = 
CNST_TABLE_REF(((long)0)); 
{ 
obj_t BgL_esz00_153;obj_t BgL_stagez00_154;
BgL_esz00_153 = BgL_eza2za2_143; 
BgL_stagez00_154 = BgL_g1093z00_151; 
BgL_zc3z04anonymousza31246ze3z87_155:
if(
NULLP(BgL_esz00_153))
{ /* Llib/thread.scm 199 */
if(
(BgL_stagez00_154==
CNST_TABLE_REF(((long)0))))
{ /* Llib/thread.scm 200 */
{ /* Llib/thread.scm 202 */
BgL_schedulerz00_bglt BgL_i1095z00_159;
BgL_i1095z00_159 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_schedulerz00)); 
{ 
obj_t BgL_l1124z00_161;
BgL_l1124z00_161 = BgL_eza2za2_143; 
BgL_zc3z04anonymousza31249ze3z87_162:
if(
PAIRP(BgL_l1124z00_161))
{ /* Llib/thread.scm 203 */
{ /* Llib/thread.scm 204 */
obj_t BgL_ez00_164;
BgL_ez00_164 = 
CAR(BgL_l1124z00_161); 
{ /* Llib/thread.scm 204 */
obj_t BgL_arg1260z00_165;
BgL_arg1260z00_165 = 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1095z00_159))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_ez00_164, BgL_arg1260z00_165, 
((BgL_threadz00_bglt)BgL_tz00_101)); } } 
{ 
obj_t BgL_l1124z00_932;
BgL_l1124z00_932 = 
CDR(BgL_l1124z00_161); 
BgL_l1124z00_161 = BgL_l1124z00_932; 
goto BgL_zc3z04anonymousza31249ze3z87_162;} }  else 
{ /* Llib/thread.scm 203 */((bool_t)1); } } } 
BGl_z52threadzd2timeoutz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_101), 
CINT(BgL_timeoutz00_145)); 
{ 
obj_t BgL_stagez00_938;obj_t BgL_esz00_937;
BgL_esz00_937 = BgL_eza2za2_143; 
BgL_stagez00_938 = 
CNST_TABLE_REF(((long)1)); 
BgL_stagez00_154 = BgL_stagez00_938; 
BgL_esz00_153 = BgL_esz00_937; 
goto BgL_zc3z04anonymousza31246ze3z87_155;} }  else 
{ /* Llib/thread.scm 200 */
{ /* Llib/thread.scm 208 */
int BgL_res1778z00_454;
{ /* Llib/thread.scm 208 */
int BgL_tmpz00_940;
BgL_tmpz00_940 = 
(int)(((long)2)); 
BgL_res1778z00_454 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_940); } BgL_res1778z00_454; } 
{ /* Llib/thread.scm 208 */
int BgL_tmpz00_943;
BgL_tmpz00_943 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_943, BFALSE); } 
return BFALSE;} }  else 
{ /* Llib/thread.scm 209 */
bool_t BgL_test2049z00_946;
{ /* Llib/thread.scm 209 */
obj_t BgL_arg1321z00_178;obj_t BgL_arg1322z00_179;
BgL_arg1321z00_178 = 
CAR(
((obj_t)BgL_esz00_153)); 
BgL_arg1322z00_179 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_144)))->BgL_envzb2zb2); 
BgL_test2049z00_946 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_arg1321z00_178, BgL_arg1322z00_179)); } 
if(BgL_test2049z00_946)
{ /* Llib/thread.scm 210 */
obj_t BgL_val0_1128z00_173;obj_t BgL_val1_1129z00_174;
{ /* Llib/thread.scm 210 */
obj_t BgL_arg1268z00_175;obj_t BgL_arg1301z00_176;
BgL_arg1268z00_175 = 
CAR(
((obj_t)BgL_esz00_153)); 
BgL_arg1301z00_176 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_144)))->BgL_envzb2zb2); 
BgL_val0_1128z00_173 = 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_arg1268z00_175, BgL_arg1301z00_176); } 
BgL_val1_1129z00_174 = 
CAR(
((obj_t)BgL_esz00_153)); 
{ /* Llib/thread.scm 210 */
int BgL_res1779z00_458;
{ /* Llib/thread.scm 210 */
int BgL_tmpz00_960;
BgL_tmpz00_960 = 
(int)(((long)2)); 
BgL_res1779z00_458 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_960); } BgL_res1779z00_458; } 
{ /* Llib/thread.scm 210 */
int BgL_tmpz00_963;
BgL_tmpz00_963 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_963, BgL_val1_1129z00_174); } 
return BgL_val0_1128z00_173;}  else 
{ /* Llib/thread.scm 212 */
obj_t BgL_arg1304z00_177;
BgL_arg1304z00_177 = 
CDR(
((obj_t)BgL_esz00_153)); 
{ 
obj_t BgL_esz00_968;
BgL_esz00_968 = BgL_arg1304z00_177; 
BgL_esz00_153 = BgL_esz00_968; 
goto BgL_zc3z04anonymousza31246ze3z87_155;} } } } }  else 
{ /* Llib/thread.scm 194 */
return 
BGl_errorz00zz__errorz00(BGl_string1927z00zz__ft_threadz00, BGl_string1924z00zz__ft_threadz00, BgL_timeoutz00_145);} } }  else 
{ /* Llib/thread.scm 224 */
obj_t BgL_arg1207z00_111;
BgL_arg1207z00_111 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_101))))->BgL_schedulerz00); 
BgL_eza2za2_112 = BgL_sza2za2_9; 
BgL_sz00_113 = BgL_arg1207z00_111; 
{ 
obj_t BgL_esz00_117;
BgL_esz00_117 = BgL_eza2za2_112; 
BgL_zc3z04anonymousza31209ze3z87_118:
if(
NULLP(BgL_esz00_117))
{ /* Llib/thread.scm 180 */
{ 
obj_t BgL_l1118z00_122;
BgL_l1118z00_122 = BgL_eza2za2_112; 
BgL_zc3z04anonymousza31211ze3z87_123:
if(
PAIRP(BgL_l1118z00_122))
{ /* Llib/thread.scm 182 */
{ /* Llib/thread.scm 183 */
obj_t BgL_ez00_125;
BgL_ez00_125 = 
CAR(BgL_l1118z00_122); 
{ /* Llib/thread.scm 183 */
obj_t BgL_arg1213z00_126;
BgL_arg1213z00_126 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BGl_signalzd2registerzd2threadz12z12zz__ft_signalz00(BgL_ez00_125, BgL_arg1213z00_126, 
((BgL_threadz00_bglt)BgL_tz00_101)); } } 
{ 
obj_t BgL_l1118z00_982;
BgL_l1118z00_982 = 
CDR(BgL_l1118z00_122); 
BgL_l1118z00_122 = BgL_l1118z00_982; 
goto BgL_zc3z04anonymousza31211ze3z87_123;} }  else 
{ /* Llib/thread.scm 182 */((bool_t)1); } } 
BGl_z52threadzd2cooperatez80zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_101)); 
{ /* Llib/thread.scm 187 */
obj_t BgL_val0_1120z00_130;obj_t BgL_val1_1121z00_131;
BgL_val0_1120z00_130 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_z52awakezd2valuez80); 
BgL_val1_1121z00_131 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_101)))->BgL_z52awakezd2signalz80); 
{ /* Llib/thread.scm 187 */
int BgL_res1772z00_441;
{ /* Llib/thread.scm 187 */
int BgL_tmpz00_990;
BgL_tmpz00_990 = 
(int)(((long)2)); 
BgL_res1772z00_441 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_990); } BgL_res1772z00_441; } 
{ /* Llib/thread.scm 187 */
int BgL_tmpz00_993;
BgL_tmpz00_993 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_993, BgL_val1_1121z00_131); } 
return BgL_val0_1120z00_130;} }  else 
{ /* Llib/thread.scm 188 */
bool_t BgL_test2052z00_996;
{ /* Llib/thread.scm 188 */
obj_t BgL_arg1233z00_140;obj_t BgL_arg1236z00_141;
BgL_arg1233z00_140 = 
CAR(
((obj_t)BgL_esz00_117)); 
BgL_arg1236z00_141 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BgL_test2052z00_996 = 
CBOOL(
BGl_signalzd2lookupzd2zz__ft_signalz00(BgL_arg1233z00_140, BgL_arg1236z00_141)); } 
if(BgL_test2052z00_996)
{ /* Llib/thread.scm 189 */
obj_t BgL_val0_1122z00_135;obj_t BgL_val1_1123z00_136;
{ /* Llib/thread.scm 189 */
obj_t BgL_arg1228z00_137;obj_t BgL_arg1230z00_138;
BgL_arg1228z00_137 = 
CAR(
((obj_t)BgL_esz00_117)); 
BgL_arg1230z00_138 = 
(((BgL_schedulerz00_bglt)COBJECT(
((BgL_schedulerz00_bglt)BgL_sz00_113)))->BgL_envzb2zb2); 
BgL_val0_1122z00_135 = 
BGl_signalzd2valuezd2zz__ft_signalz00(BgL_arg1228z00_137, BgL_arg1230z00_138); } 
BgL_val1_1123z00_136 = 
CAR(
((obj_t)BgL_esz00_117)); 
{ /* Llib/thread.scm 189 */
int BgL_res1773z00_445;
{ /* Llib/thread.scm 189 */
int BgL_tmpz00_1010;
BgL_tmpz00_1010 = 
(int)(((long)2)); 
BgL_res1773z00_445 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_1010); } BgL_res1773z00_445; } 
{ /* Llib/thread.scm 189 */
int BgL_tmpz00_1013;
BgL_tmpz00_1013 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_1013, BgL_val1_1123z00_136); } 
return BgL_val0_1122z00_135;}  else 
{ /* Llib/thread.scm 191 */
obj_t BgL_arg1232z00_139;
BgL_arg1232z00_139 = 
CDR(
((obj_t)BgL_esz00_117)); 
{ 
obj_t BgL_esz00_1018;
BgL_esz00_1018 = BgL_arg1232z00_139; 
BgL_esz00_117 = BgL_esz00_1018; 
goto BgL_zc3z04anonymousza31209ze3z87_118;} } } } } }  else 
{ /* Llib/thread.scm 217 */
return 
BGl_errorz00zz__errorz00(BGl_string1923z00zz__ft_threadz00, BGl_string1925z00zz__ft_threadz00, BgL_tz00_101);} }  else 
{ /* Llib/thread.scm 215 */
return 
BGl_errorz00zz__errorz00(BGl_string1923z00zz__ft_threadz00, BGl_string1926z00zz__ft_threadz00, BgL_tz00_101);} } } } } 

}



/* &thread-await*! */
obj_t BGl_z62threadzd2awaitza2z12z00zz__ft_threadz00(obj_t BgL_envz00_548, obj_t BgL_sza2za2_549, obj_t BgL_argz00_550)
{
{ /* Llib/thread.scm 173 */
{ /* Llib/thread.scm 174 */
obj_t BgL_auxz00_1021;
if(
PAIRP(BgL_sza2za2_549))
{ /* Llib/thread.scm 174 */
BgL_auxz00_1021 = BgL_sza2za2_549
; }  else 
{ 
obj_t BgL_auxz00_1024;
BgL_auxz00_1024 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1928z00zz__ft_threadz00, 
BINT(((long)6510)), BGl_string1929z00zz__ft_threadz00, BGl_string1930z00zz__ft_threadz00, BgL_sza2za2_549); 
FAILURE(BgL_auxz00_1024,BFALSE,BFALSE);} 
return 
BGl_threadzd2awaitza2z12z62zz__ft_threadz00(BgL_auxz00_1021, BgL_argz00_550);} } 

}



/* thread-get-values! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(obj_t BgL_sz00_11)
{
{ /* Llib/thread.scm 229 */
{ /* Llib/thread.scm 230 */
obj_t BgL_tz00_185;
BgL_tz00_185 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_185, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 231 */
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_185))); 
{ /* Llib/thread.scm 234 */
BgL_schedulerz00_bglt BgL_i1099z00_188;
BgL_i1099z00_188 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_185))))->BgL_schedulerz00)); 
return 
BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(BgL_sz00_11, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1099z00_188))->BgL_envzb2zb2));} }  else 
{ /* Llib/thread.scm 231 */
return BFALSE;} } } 

}



/* &thread-get-values! */
obj_t BGl_z62threadzd2getzd2valuesz12z70zz__ft_threadz00(obj_t BgL_envz00_551, obj_t BgL_sz00_552)
{
{ /* Llib/thread.scm 229 */
return 
BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(BgL_sz00_552);} 

}



/* thread-get-values*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(obj_t BgL_sza2za2_12)
{
{ /* Llib/thread.scm 240 */
{ /* Llib/thread.scm 241 */
obj_t BgL_tz00_190;
BgL_tz00_190 = 
BGl_currentzd2threadzd2zz__threadz00(); 
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_190, BGl_threadz00zz__threadz00))
{ /* Llib/thread.scm 242 */
BGl_z52threadzd2yieldz12z92zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)
((BgL_threadz00_bglt)BgL_tz00_190))); 
{ /* Llib/thread.scm 244 */
obj_t BgL_head1132z00_194;
{ /* Llib/thread.scm 244 */
obj_t BgL_res1782z00_463;
BgL_res1782z00_463 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1132z00_194 = BgL_res1782z00_463; } 
{ 
obj_t BgL_l1130z00_196;obj_t BgL_tail1133z00_197;
BgL_l1130z00_196 = BgL_sza2za2_12; 
BgL_tail1133z00_197 = BgL_head1132z00_194; 
BgL_zc3z04anonymousza31334ze3z87_198:
if(
NULLP(BgL_l1130z00_196))
{ /* Llib/thread.scm 244 */
return 
CDR(BgL_head1132z00_194);}  else 
{ /* Llib/thread.scm 244 */
obj_t BgL_newtail1134z00_200;
{ /* Llib/thread.scm 244 */
obj_t BgL_arg1338z00_202;
{ /* Llib/thread.scm 244 */
obj_t BgL_sz00_203;
BgL_sz00_203 = 
CAR(
((obj_t)BgL_l1130z00_196)); 
{ /* Llib/thread.scm 246 */
BgL_schedulerz00_bglt BgL_i1101z00_205;
BgL_i1101z00_205 = 
((BgL_schedulerz00_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_190)))->BgL_schedulerz00)); 
BgL_arg1338z00_202 = 
MAKE_YOUNG_PAIR(BgL_sz00_203, 
BGl_signalzd2lastzd2valuesz00zz__ft_signalz00(BgL_sz00_203, 
(((BgL_schedulerz00_bglt)COBJECT(BgL_i1101z00_205))->BgL_envzb2zb2))); } } 
{ /* Llib/thread.scm 244 */
obj_t BgL_res1784z00_467;
BgL_res1784z00_467 = 
MAKE_YOUNG_PAIR(BgL_arg1338z00_202, BNIL); 
BgL_newtail1134z00_200 = BgL_res1784z00_467; } } 
SET_CDR(BgL_tail1133z00_197, BgL_newtail1134z00_200); 
{ /* Llib/thread.scm 244 */
obj_t BgL_arg1336z00_201;
BgL_arg1336z00_201 = 
CDR(
((obj_t)BgL_l1130z00_196)); 
{ 
obj_t BgL_tail1133z00_1065;obj_t BgL_l1130z00_1064;
BgL_l1130z00_1064 = BgL_arg1336z00_201; 
BgL_tail1133z00_1065 = BgL_newtail1134z00_200; 
BgL_tail1133z00_197 = BgL_tail1133z00_1065; 
BgL_l1130z00_196 = BgL_l1130z00_1064; 
goto BgL_zc3z04anonymousza31334ze3z87_198;} } } } } }  else 
{ /* Llib/thread.scm 242 */
return BFALSE;} } } 

}



/* &thread-get-values*! */
obj_t BGl_z62threadzd2getzd2valuesza2z12zd2zz__ft_threadz00(obj_t BgL_envz00_553, obj_t BgL_sza2za2_554)
{
{ /* Llib/thread.scm 240 */
{ /* Llib/thread.scm 241 */
obj_t BgL_auxz00_1066;
if(
PAIRP(BgL_sza2za2_554))
{ /* Llib/thread.scm 241 */
BgL_auxz00_1066 = BgL_sza2za2_554
; }  else 
{ 
obj_t BgL_auxz00_1069;
BgL_auxz00_1069 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1928z00zz__ft_threadz00, 
BINT(((long)8929)), BGl_string1931z00zz__ft_threadz00, BGl_string1930z00zz__ft_threadz00, BgL_sza2za2_554); 
FAILURE(BgL_auxz00_1069,BFALSE,BFALSE);} 
return 
BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(BgL_auxz00_1066);} } 

}



/* thread-await-values! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(obj_t BgL_sz00_13, obj_t BgL_tmtz00_14)
{
{ /* Llib/thread.scm 253 */
{ /* Llib/thread.scm 254 */
obj_t BgL_runner1344z00_470;
{ /* Llib/thread.scm 254 */
obj_t BgL_list1342z00_471;
BgL_list1342z00_471 = 
MAKE_YOUNG_PAIR(BgL_tmtz00_14, BNIL); 
BgL_runner1344z00_470 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_sz00_13, BgL_list1342z00_471); } 
{ /* Llib/thread.scm 254 */
obj_t BgL_aux1343z00_472;
BgL_aux1343z00_472 = 
CAR(BgL_runner1344z00_470); 
BgL_runner1344z00_470 = 
CDR(BgL_runner1344z00_470); 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_aux1343z00_472, BgL_runner1344z00_470); } } 
return 
BGl_threadzd2getzd2valuesz12z12zz__ft_threadz00(BgL_sz00_13);} 

}



/* &thread-await-values! */
obj_t BGl_z62threadzd2awaitzd2valuesz12z70zz__ft_threadz00(obj_t BgL_envz00_555, obj_t BgL_sz00_556, obj_t BgL_tmtz00_557)
{
{ /* Llib/thread.scm 253 */
return 
BGl_threadzd2awaitzd2valuesz12z12zz__ft_threadz00(BgL_sz00_556, BgL_tmtz00_557);} 

}



/* thread-await-values*! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(obj_t BgL_sza2za2_15, obj_t BgL_tmtz00_16)
{
{ /* Llib/thread.scm 260 */
{ /* Llib/thread.scm 261 */
obj_t BgL_runner1347z00_475;
{ /* Llib/thread.scm 261 */
obj_t BgL_list1345z00_476;
BgL_list1345z00_476 = 
MAKE_YOUNG_PAIR(BgL_tmtz00_16, BNIL); 
BgL_runner1347z00_475 = 
BGl_consza2za2zz__r4_pairs_and_lists_6_3z00(BgL_sza2za2_15, BgL_list1345z00_476); } 
{ /* Llib/thread.scm 261 */
obj_t BgL_aux1346z00_477;
BgL_aux1346z00_477 = 
CAR(BgL_runner1347z00_475); 
BgL_runner1347z00_475 = 
CDR(BgL_runner1347z00_475); 
BGl_threadzd2awaitza2z12z62zz__ft_threadz00(BgL_aux1346z00_477, BgL_runner1347z00_475); } } 
return 
BGl_threadzd2getzd2valuesza2z12zb0zz__ft_threadz00(BgL_sza2za2_15);} 

}



/* &thread-await-values*! */
obj_t BGl_z62threadzd2awaitzd2valuesza2z12zd2zz__ft_threadz00(obj_t BgL_envz00_558, obj_t BgL_sza2za2_559, obj_t BgL_tmtz00_560)
{
{ /* Llib/thread.scm 260 */
{ /* Llib/thread.scm 261 */
obj_t BgL_auxz00_1087;
if(
PAIRP(BgL_sza2za2_559))
{ /* Llib/thread.scm 261 */
BgL_auxz00_1087 = BgL_sza2za2_559
; }  else 
{ 
obj_t BgL_auxz00_1090;
BgL_auxz00_1090 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1928z00zz__ft_threadz00, 
BINT(((long)9790)), BGl_string1932z00zz__ft_threadz00, BGl_string1930z00zz__ft_threadz00, BgL_sza2za2_559); 
FAILURE(BgL_auxz00_1090,BFALSE,BFALSE);} 
return 
BGl_threadzd2awaitzd2valuesza2z12zb0zz__ft_threadz00(BgL_auxz00_1087, BgL_tmtz00_560);} } 

}



/* thread-suspend/resume! */
obj_t BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_22, obj_t BgL_whoz00_23, bool_t BgL_valz00_24)
{
{ /* Llib/thread.scm 341 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_tz00_22))
{ /* Llib/thread.scm 346 */
bool_t BgL_test2060z00_1097;
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_tz00_22, BNIL))
{ /* Llib/thread.scm 346 */
BgL_test2060z00_1097 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 346 */
if(
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_tz00_22, BNIL))
{ /* Llib/thread.scm 347 */
BgL_test2060z00_1097 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 347 */
BgL_test2060z00_1097 = 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_tz00_22, BNIL)
; } } 
if(BgL_test2060z00_1097)
{ /* Llib/thread.scm 346 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 355 */
BgL_z52schedulerz52_bglt BgL_i1110z00_225;
BgL_i1110z00_225 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(BgL_tz00_22))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_1105;
{ /* Llib/thread.scm 356 */
obj_t BgL_arg1391z00_226;obj_t BgL_arg1392z00_227;
BgL_arg1391z00_226 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_22), 
BBOOL(BgL_valz00_24)); 
BgL_arg1392z00_227 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1110z00_225))->BgL_tosuspendzf2resumezf2); 
BgL_auxz00_1105 = 
MAKE_YOUNG_PAIR(BgL_arg1391z00_226, BgL_arg1392z00_227); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1110z00_225))->BgL_tosuspendzf2resumezf2)=((obj_t)BgL_auxz00_1105),BUNSPEC);} } }  else 
{ /* Llib/thread.scm 343 */
return 
BGl_errorz00zz__errorz00(BgL_whoz00_23, BGl_string1933z00zz__ft_threadz00, 
((obj_t)BgL_tz00_22));} } 

}



/* thread-suspend! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_25)
{
{ /* Llib/thread.scm 361 */
return 
BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_tz00_25, 
CNST_TABLE_REF(((long)2)), ((bool_t)1));} 

}



/* &thread-suspend! */
obj_t BGl_z62threadzd2suspendz12za2zz__ft_threadz00(obj_t BgL_envz00_561, obj_t BgL_tz00_562)
{
{ /* Llib/thread.scm 361 */
{ /* Llib/thread.scm 362 */
BgL_fthreadz00_bglt BgL_auxz00_1116;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_562, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/thread.scm 362 */
BgL_auxz00_1116 = 
((BgL_fthreadz00_bglt)BgL_tz00_562)
; }  else 
{ 
obj_t BgL_auxz00_1120;
BgL_auxz00_1120 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1928z00zz__ft_threadz00, 
BINT(((long)14254)), BGl_string1934z00zz__ft_threadz00, BGl_string1935z00zz__ft_threadz00, BgL_tz00_562); 
FAILURE(BgL_auxz00_1120,BFALSE,BFALSE);} 
return 
BGl_threadzd2suspendz12zc0zz__ft_threadz00(BgL_auxz00_1116);} } 

}



/* thread-resume! */
BGL_EXPORTED_DEF obj_t BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_fthreadz00_bglt BgL_tz00_26)
{
{ /* Llib/thread.scm 367 */
return 
BGl_threadzd2suspendzf2resumez12z32zz__ft_threadz00(BgL_tz00_26, 
CNST_TABLE_REF(((long)3)), ((bool_t)0));} 

}



/* &thread-resume! */
obj_t BGl_z62threadzd2resumez12za2zz__ft_threadz00(obj_t BgL_envz00_563, obj_t BgL_tz00_564)
{
{ /* Llib/thread.scm 367 */
{ /* Llib/thread.scm 368 */
BgL_fthreadz00_bglt BgL_auxz00_1127;
if(
BGl_isazf3zf3zz__objectz00(BgL_tz00_564, BGl_fthreadz00zz__ft_typesz00))
{ /* Llib/thread.scm 368 */
BgL_auxz00_1127 = 
((BgL_fthreadz00_bglt)BgL_tz00_564)
; }  else 
{ 
obj_t BgL_auxz00_1131;
BgL_auxz00_1131 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1928z00zz__ft_threadz00, 
BINT(((long)14555)), BGl_string1936z00zz__ft_threadz00, BGl_string1935z00zz__ft_threadz00, BgL_tz00_564); 
FAILURE(BgL_auxz00_1131,BFALSE,BFALSE);} 
return 
BGl_threadzd2resumez12zc0zz__ft_threadz00(BgL_auxz00_1127);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
{ /* Llib/thread.scm 31 */
obj_t BgL_arg1517z00_236;obj_t BgL_arg1522z00_237;
{ /* Llib/thread.scm 31 */
obj_t BgL_v1135z00_250;
BgL_v1135z00_250 = 
create_vector(((long)0)); 
BgL_arg1517z00_236 = BgL_v1135z00_250; } 
{ /* Llib/thread.scm 31 */
obj_t BgL_v1136z00_251;
BgL_v1136z00_251 = 
create_vector(((long)0)); 
BgL_arg1522z00_237 = BgL_v1136z00_251; } 
return ( 
BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)4)), 
CNST_TABLE_REF(((long)5)), BGl_z62exceptionz62zz__objectz00, ((long)60409), BGl_proc1939z00zz__ft_threadz00, BGl_proc1938z00zz__ft_threadz00, BFALSE, BGl_proc1937z00zz__ft_threadz00, BFALSE, BgL_arg1517z00_236, BgL_arg1522z00_237), BUNSPEC) ;} } 

}



/* &<@anonymous:1535> */
obj_t BGl_z62zc3z04anonymousza31535ze3ze5zz__ft_threadz00(obj_t BgL_envz00_568, obj_t BgL_new1065z00_569)
{
{ /* Llib/thread.scm 31 */
{ 
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_auxz00_1141;
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1065z00_569))))->BgL_fnamez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1065z00_569))))->BgL_locationz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1065z00_569))))->BgL_stackz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_1141 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BgL_new1065z00_569); 
return 
((obj_t)BgL_auxz00_1141);} } 

}



/* &lambda1527 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1527z62zz__ft_threadz00(obj_t BgL_envz00_570)
{
{ /* Llib/thread.scm 31 */
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1064z00_663;
BgL_new1064z00_663 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 31 */
long BgL_arg1534z00_664;
{ /* Llib/thread.scm 31 */
long BgL_res1786z00_665;
BgL_res1786z00_665 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BgL_arg1534z00_664 = BgL_res1786z00_665; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_663), BgL_arg1534z00_664); } 
return BgL_new1064z00_663;} } 

}



/* &lambda1523 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BGl_z62lambda1523z62zz__ft_threadz00(obj_t BgL_envz00_571, obj_t BgL_fname1061z00_572, obj_t BgL_location1062z00_573, obj_t BgL_stack1063z00_574)
{
{ /* Llib/thread.scm 31 */
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1116z00_666;
{ /* Llib/thread.scm 31 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1115z00_667;
BgL_new1115z00_667 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 31 */
long BgL_arg1526z00_668;
{ /* Llib/thread.scm 31 */
long BgL_res1785z00_669;
BgL_res1785z00_669 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BgL_arg1526z00_668 = BgL_res1785z00_669; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1115z00_667), BgL_arg1526z00_668); } 
BgL_new1116z00_666 = BgL_new1115z00_667; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1116z00_666)))->BgL_fnamez00)=((obj_t)BgL_fname1061z00_572),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1116z00_666)))->BgL_locationz00)=((obj_t)BgL_location1062z00_573),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1116z00_666)))->BgL_stackz00)=((obj_t)BgL_stack1063z00_574),BUNSPEC); 
return BgL_new1116z00_666;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2equalzf3zd2envzf3zz__objectz00, BGl_z52sigjoinz52zz__ft_typesz00, BGl_proc1940z00zz__ft_threadz00, BGl_string1941z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2joinz12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1942z00zz__ft_threadz00, BGl_string1943z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2writezd2envz00zz__objectz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1944z00zz__ft_threadz00, BGl_string1945z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2startz12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1946z00zz__ft_threadz00, BGl_string1947z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2terminatez12zd2envz12zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1948z00zz__ft_threadz00, BGl_string1949z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2specificzd2envz00zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1950z00zz__ft_threadz00, BGl_string1951z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2specificzd2setz12zd2envzc0zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1952z00zz__ft_threadz00, BGl_string1953z00zz__ft_threadz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2cleanupzd2envz00zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1954z00zz__ft_threadz00, BGl_string1955z00zz__ft_threadz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_threadzd2cleanupzd2setz12zd2envzc0zz__threadz00, BGl_fthreadz00zz__ft_typesz00, BGl_proc1956z00zz__ft_threadz00, BGl_string1957z00zz__ft_threadz00);} 

}



/* &thread-cleanup-set!-1157 */
obj_t BGl_z62threadzd2cleanupzd2setz12zd21157za2zz__ft_threadz00(obj_t BgL_envz00_585, obj_t BgL_thz00_586, obj_t BgL_vz00_587)
{
{ /* Llib/thread.scm 394 */
return 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_586)))->BgL_z52cleanupz52)=((obj_t)BgL_vz00_587),BUNSPEC);} 

}



/* &thread-cleanup-fthre1155 */
obj_t BGl_z62threadzd2cleanupzd2fthre1155z62zz__ft_threadz00(obj_t BgL_envz00_588, obj_t BgL_thz00_589)
{
{ /* Llib/thread.scm 387 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_589)))->BgL_z52cleanupz52);} 

}



/* &thread-specific-set!1153 */
obj_t BGl_z62threadzd2specificzd2setz121153z70zz__ft_threadz00(obj_t BgL_envz00_590, obj_t BgL_thz00_591, obj_t BgL_vz00_592)
{
{ /* Llib/thread.scm 380 */
return 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_591)))->BgL_z52specificz52)=((obj_t)BgL_vz00_592),BUNSPEC);} 

}



/* &thread-specific-fthr1151 */
obj_t BGl_z62threadzd2specificzd2fthr1151z62zz__ft_threadz00(obj_t BgL_envz00_593, obj_t BgL_thz00_594)
{
{ /* Llib/thread.scm 373 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_thz00_594)))->BgL_z52specificz52);} 

}



/* &thread-terminate!-ft1149 */
obj_t BGl_z62threadzd2terminatez12zd2ft1149z70zz__ft_threadz00(obj_t BgL_envz00_595, obj_t BgL_tz00_596)
{
{ /* Llib/thread.scm 309 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_596)))
{ /* Llib/thread.scm 318 */
if(
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_596), BNIL))
{ /* Llib/thread.scm 321 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 321 */
if(
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_596), BNIL))
{ /* Llib/thread.scm 324 */
return BUNSPEC;}  else 
{ /* Llib/thread.scm 324 */
{ /* Llib/thread.scm 329 */
obj_t BgL_list1738z00_675;
BgL_list1738z00_675 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_596), BgL_list1738z00_675); } 
{ 
obj_t BgL_auxz00_1196;
{ /* Llib/thread.scm 331 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1107z00_676;
{ /* Llib/thread.scm 331 */
BgL_terminatedzd2threadzd2exceptionz00_bglt BgL_new1106z00_677;
BgL_new1106z00_677 = 
((BgL_terminatedzd2threadzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_terminatedzd2threadzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 331 */
long BgL_arg1755z00_678;
{ /* Llib/thread.scm 331 */
long BgL_res1799z00_679;
{ /* Llib/thread.scm 331 */
obj_t BgL_classz00_680;
BgL_classz00_680 = BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00; 
BgL_res1799z00_679 = 
BGL_CLASS_INDEX(BgL_classz00_680); } 
BgL_arg1755z00_678 = BgL_res1799z00_679; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1106z00_677), BgL_arg1755z00_678); } 
BgL_new1107z00_676 = BgL_new1106z00_677; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1107z00_676)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1107z00_676)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1206;
{ /* Llib/thread.scm 331 */
obj_t BgL_arg1741z00_681;
{ /* Llib/thread.scm 331 */
obj_t BgL_arg1754z00_682;
{ /* Llib/thread.scm 331 */
obj_t BgL_res1800z00_683;
{ /* Llib/thread.scm 331 */
obj_t BgL_classz00_684;
BgL_classz00_684 = BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00; 
BgL_res1800z00_683 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_684); } 
BgL_arg1754z00_682 = BgL_res1800z00_683; } 
BgL_arg1741z00_681 = 
VECTOR_REF(BgL_arg1754z00_682,((long)2)); } 
BgL_auxz00_1206 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1741z00_681); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1107z00_676)))->BgL_stackz00)=((obj_t)BgL_auxz00_1206),BUNSPEC); } 
BgL_auxz00_1196 = 
((obj_t)BgL_new1107z00_676); } 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_596)))->BgL_z52exczd2resultz80)=((obj_t)BgL_auxz00_1196),BUNSPEC); } 
{ /* Llib/thread.scm 334 */
BgL_z52schedulerz52_bglt BgL_i1108z00_685;
BgL_i1108z00_685 = 
((BgL_z52schedulerz52_bglt)
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_596)))->BgL_schedulerz00)); 
{ 
obj_t BgL_auxz00_1217;
{ /* Llib/thread.scm 336 */
obj_t BgL_arg1757z00_686;
BgL_arg1757z00_686 = 
(((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1108z00_685))->BgL_toterminatez00); 
BgL_auxz00_1217 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_596)), BgL_arg1757z00_686); } 
return 
((((BgL_z52schedulerz52_bglt)COBJECT(BgL_i1108z00_685))->BgL_toterminatez00)=((obj_t)BgL_auxz00_1217),BUNSPEC);} } } } }  else 
{ /* Llib/thread.scm 318 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string1933z00zz__ft_threadz00, 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_596)));} } 

}



/* &thread-start!-fthrea1147 */
obj_t BGl_z62threadzd2startz12zd2fthrea1147z70zz__ft_threadz00(obj_t BgL_envz00_597, obj_t BgL_tz00_598, obj_t BgL_oz00_599)
{
{ /* Llib/thread.scm 280 */
if(
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(
((BgL_fthreadz00_bglt)BgL_tz00_598)))
{ /* Llib/thread.scm 286 */
return 
BGl_errorz00zz__errorz00(BGl_string1947z00zz__ft_threadz00, BGl_string1958z00zz__ft_threadz00, 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_598)));}  else 
{ /* Llib/thread.scm 288 */
BgL_schedulerz00_bglt BgL_scdlz00_688;
BgL_scdlz00_688 = 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(
CNST_TABLE_REF(((long)7)), BgL_oz00_599); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_598)))->BgL_schedulerz00)=((obj_t)
((obj_t)BgL_scdlz00_688)),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_598)))->BgL_z52builtinz52)=((obj_t)
BGl_z52pthreadzd2newz80zz__ft_z52pthreadz52(
((BgL_fthreadz00_bglt)BgL_tz00_598))),BUNSPEC); 
((((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_598)))->BgL_z52statez52)=((obj_t)
CNST_TABLE_REF(((long)8))),BUNSPEC); 
{ /* Llib/thread.scm 295 */
obj_t BgL_arg1724z00_689;
BgL_arg1724z00_689 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_598)))->BgL_z52builtinz52); 
BGl_threadzd2startz12zc0zz__threadz00(
((BgL_threadz00_bglt)BgL_arg1724z00_689), BNIL); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_688)))->BgL_z52livezd2threadzd2numberz52)=((int)
(int)(
(((long)1)+
(long)(
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_688)))->BgL_z52livezd2threadzd2numberz52))))),BUNSPEC); 
{ 
obj_t BgL_auxz00_1256;
{ /* Llib/thread.scm 302 */
obj_t BgL_arg1731z00_690;
BgL_arg1731z00_690 = 
(((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_688)))->BgL_tostartz00); 
BgL_auxz00_1256 = 
MAKE_YOUNG_PAIR(
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_598)), BgL_arg1731z00_690); } 
((((BgL_z52schedulerz52_bglt)COBJECT(
((BgL_z52schedulerz52_bglt)BgL_scdlz00_688)))->BgL_tostartz00)=((obj_t)BgL_auxz00_1256),BUNSPEC); } 
return 
((obj_t)
((BgL_fthreadz00_bglt)BgL_tz00_598));} } 

}



/* &object-write-fthread1145 */
obj_t BGl_z62objectzd2writezd2fthread1145z62zz__ft_threadz00(obj_t BgL_envz00_600, obj_t BgL_oz00_601, obj_t BgL_portz00_602)
{
{ /* Llib/thread.scm 267 */
{ /* Llib/thread.scm 268 */
obj_t BgL_arg1693z00_692;
if(
PAIRP(BgL_portz00_602))
{ /* Llib/thread.scm 268 */
BgL_arg1693z00_692 = 
CAR(BgL_portz00_602); }  else 
{ /* Llib/thread.scm 268 */
obj_t BgL_res1797z00_693;
{ /* Llib/thread.scm 268 */
obj_t BgL_tmpz00_1269;
BgL_tmpz00_1269 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res1797z00_693 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1269); } 
BgL_arg1693z00_692 = BgL_res1797z00_693; } 
{ /* Llib/thread.scm 270 */
obj_t BgL_zc3z04anonymousza31696ze3z87_694;
BgL_zc3z04anonymousza31696ze3z87_694 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31696ze3ze5zz__ft_threadz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31696ze3z87_694, 
(int)(((long)0)), 
((obj_t)
((BgL_fthreadz00_bglt)BgL_oz00_601))); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1693z00_692, BgL_zc3z04anonymousza31696ze3z87_694);} } } 

}



/* &<@anonymous:1696> */
obj_t BGl_z62zc3z04anonymousza31696ze3ze5zz__ft_threadz00(obj_t BgL_envz00_603)
{
{ /* Llib/thread.scm 269 */
{ /* Llib/thread.scm 270 */
BgL_fthreadz00_bglt BgL_oz00_604;
BgL_oz00_604 = 
((BgL_fthreadz00_bglt)
PROCEDURE_REF(BgL_envz00_603, 
(int)(((long)0)))); 
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1697z00_695;obj_t BgL_arg1699z00_696;int BgL_arg1700z00_697;obj_t BgL_arg1706z00_698;
BgL_arg1697z00_695 = 
(((BgL_threadz00_bglt)COBJECT(
((BgL_threadz00_bglt)BgL_oz00_604)))->BgL_namez00); 
BgL_arg1699z00_696 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_604))->BgL_z52statez52); 
BgL_arg1700z00_697 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_604))->BgL_z52timeoutz52); 
BgL_arg1706z00_698 = 
(((BgL_fthreadz00_bglt)COBJECT(BgL_oz00_604))->BgL_z52signalsz52); 
{ /* Llib/thread.scm 271 */
obj_t BgL_list1707z00_699;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1708z00_700;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1709z00_701;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1710z00_702;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1711z00_703;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1712z00_704;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1713z00_705;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1714z00_706;
{ /* Llib/thread.scm 271 */
obj_t BgL_arg1720z00_707;
BgL_arg1720z00_707 = 
MAKE_YOUNG_PAIR(BGl_string1959z00zz__ft_threadz00, BNIL); 
BgL_arg1714z00_706 = 
MAKE_YOUNG_PAIR(BgL_arg1706z00_698, BgL_arg1720z00_707); } 
BgL_arg1713z00_705 = 
MAKE_YOUNG_PAIR(BGl_string1960z00zz__ft_threadz00, BgL_arg1714z00_706); } 
BgL_arg1712z00_704 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1700z00_697), BgL_arg1713z00_705); } 
BgL_arg1711z00_703 = 
MAKE_YOUNG_PAIR(BGl_string1961z00zz__ft_threadz00, BgL_arg1712z00_704); } 
BgL_arg1710z00_702 = 
MAKE_YOUNG_PAIR(BgL_arg1699z00_696, BgL_arg1711z00_703); } 
BgL_arg1709z00_701 = 
MAKE_YOUNG_PAIR(BGl_string1962z00zz__ft_threadz00, BgL_arg1710z00_702); } 
BgL_arg1708z00_700 = 
MAKE_YOUNG_PAIR(BgL_arg1697z00_695, BgL_arg1709z00_701); } 
BgL_list1707z00_699 = 
MAKE_YOUNG_PAIR(BGl_string1963z00zz__ft_threadz00, BgL_arg1708z00_700); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1707z00_699);} } } } 

}



/* &thread-join!-fthread1143 */
obj_t BGl_z62threadzd2joinz12zd2fthread1143z70zz__ft_threadz00(obj_t BgL_envz00_605, obj_t BgL_tz00_606, obj_t BgL_argsz00_607)
{
{ /* Llib/thread.scm 59 */
{ /* Llib/thread.scm 61 */
bool_t BgL_test2070z00_1299;
if(
(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52statez52)==
CNST_TABLE_REF(((long)9))))
{ /* Llib/thread.scm 61 */
BgL_test2070z00_1299 = ((bool_t)1)
; }  else 
{ /* Llib/thread.scm 61 */
BgL_test2070z00_1299 = 
(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52statez52)==
CNST_TABLE_REF(((long)10)))
; } 
if(BgL_test2070z00_1299)
{ /* Llib/thread.scm 61 */
if(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2raisedz80))
{ /* Llib/thread.scm 62 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 62 */
return 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52resultz52);} }  else 
{ 
obj_t BgL_toz00_737;obj_t BgL_tozd2valzd2_738;obj_t BgL_toz00_719;
if(
PAIRP(BgL_argsz00_607))
{ /* Llib/thread.scm 65 */
obj_t BgL_cdrzd2110zd2_747;
BgL_cdrzd2110zd2_747 = 
CDR(BgL_argsz00_607); 
if(
PAIRP(BgL_cdrzd2110zd2_747))
{ /* Llib/thread.scm 65 */
if(
NULLP(
CDR(BgL_cdrzd2110zd2_747)))
{ /* Llib/thread.scm 65 */
BgL_toz00_737 = 
CAR(BgL_argsz00_607); 
BgL_tozd2valzd2_738 = 
CAR(BgL_cdrzd2110zd2_747); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_toz00_737))
{ /* Llib/thread.scm 69 */
obj_t BgL_vz00_739;
{ /* Llib/thread.scm 69 */
BgL_z52sigjoinz52_bglt BgL_arg1635z00_740;
{ /* Llib/thread.scm 69 */
BgL_z52sigjoinz52_bglt BgL_new1070z00_741;
{ /* Llib/thread.scm 70 */
BgL_z52sigjoinz52_bglt BgL_new1069z00_742;
BgL_new1069z00_742 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 70 */
long BgL_arg1638z00_743;
{ /* Llib/thread.scm 70 */
long BgL_res1787z00_744;
BgL_res1787z00_744 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BgL_arg1638z00_743 = BgL_res1787z00_744; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1069z00_742), BgL_arg1638z00_743); } 
BgL_new1070z00_741 = BgL_new1069z00_742; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1070z00_741))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_606)),BUNSPEC); 
BgL_arg1635z00_740 = BgL_new1070z00_741; } 
{ /* Llib/thread.scm 69 */
obj_t BgL_list1636z00_745;
BgL_list1636z00_745 = 
MAKE_YOUNG_PAIR(BgL_toz00_737, BNIL); 
BgL_vz00_739 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1635z00_740), BgL_list1636z00_745); } } 
{ /* Llib/thread.scm 74 */
bool_t BgL_test2077z00_1336;
{ /* Llib/thread.scm 74 */
obj_t BgL_arg1634z00_746;
BgL_arg1634z00_746 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80); 
BgL_test2077z00_1336 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1634z00_746, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2077z00_1336)
{ /* Llib/thread.scm 74 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 74 */
if(
CBOOL(BgL_vz00_739))
{ /* Llib/thread.scm 76 */
return BgL_vz00_739;}  else 
{ /* Llib/thread.scm 76 */
return BgL_tozd2valzd2_738;} } } }  else 
{ /* Llib/thread.scm 67 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string1964z00zz__ft_threadz00, BGl_string1965z00zz__ft_threadz00, BgL_toz00_737);} }  else 
{ /* Llib/thread.scm 65 */
BgL_tagzd2103zd2_709:
{ /* Llib/thread.scm 95 */
obj_t BgL_vz00_712;
{ /* Llib/thread.scm 95 */
BgL_z52sigjoinz52_bglt BgL_arg1684z00_713;
{ /* Llib/thread.scm 95 */
BgL_z52sigjoinz52_bglt BgL_new1078z00_714;
{ /* Llib/thread.scm 96 */
BgL_z52sigjoinz52_bglt BgL_new1077z00_715;
BgL_new1077z00_715 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 96 */
long BgL_arg1687z00_716;
{ /* Llib/thread.scm 96 */
long BgL_res1791z00_717;
BgL_res1791z00_717 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BgL_arg1687z00_716 = BgL_res1791z00_717; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1077z00_715), BgL_arg1687z00_716); } 
BgL_new1078z00_714 = BgL_new1077z00_715; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1078z00_714))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_606)),BUNSPEC); 
BgL_arg1684z00_713 = BgL_new1078z00_714; } 
BgL_vz00_712 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1684z00_713), BNIL); } 
{ /* Llib/thread.scm 99 */
bool_t BgL_test2079z00_1356;
{ /* Llib/thread.scm 99 */
obj_t BgL_arg1682z00_718;
BgL_arg1682z00_718 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80); 
BgL_test2079z00_1356 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1682z00_718, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2079z00_1356)
{ /* Llib/thread.scm 99 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 99 */
return BgL_vz00_712;} } } } }  else 
{ /* Llib/thread.scm 65 */
if(
NULLP(BgL_cdrzd2110zd2_747))
{ /* Llib/thread.scm 65 */
BgL_toz00_719 = 
CAR(BgL_argsz00_607); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_toz00_719))
{ /* Llib/thread.scm 83 */
obj_t BgL_vz00_720;
{ /* Llib/thread.scm 83 */
BgL_z52sigjoinz52_bglt BgL_arg1668z00_721;
{ /* Llib/thread.scm 83 */
BgL_z52sigjoinz52_bglt BgL_new1073z00_722;
{ /* Llib/thread.scm 84 */
BgL_z52sigjoinz52_bglt BgL_new1072z00_723;
BgL_new1072z00_723 = 
((BgL_z52sigjoinz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52sigjoinz52_bgl) ))); 
{ /* Llib/thread.scm 84 */
long BgL_arg1675z00_724;
{ /* Llib/thread.scm 84 */
long BgL_res1788z00_725;
BgL_res1788z00_725 = 
BGL_CLASS_INDEX(BGl_z52sigjoinz52zz__ft_typesz00); 
BgL_arg1675z00_724 = BgL_res1788z00_725; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1072z00_723), BgL_arg1675z00_724); } 
BgL_new1073z00_722 = BgL_new1072z00_723; } 
((((BgL_z52sigjoinz52_bglt)COBJECT(BgL_new1073z00_722))->BgL_threadz00)=((BgL_fthreadz00_bglt)
((BgL_fthreadz00_bglt)BgL_tz00_606)),BUNSPEC); 
BgL_arg1668z00_721 = BgL_new1073z00_722; } 
{ /* Llib/thread.scm 83 */
obj_t BgL_list1669z00_726;
BgL_list1669z00_726 = 
MAKE_YOUNG_PAIR(BgL_toz00_719, BNIL); 
BgL_vz00_720 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(
((obj_t)BgL_arg1668z00_721), BgL_list1669z00_726); } } 
{ /* Llib/thread.scm 88 */
bool_t BgL_test2082z00_1376;
{ /* Llib/thread.scm 88 */
obj_t BgL_arg1667z00_727;
BgL_arg1667z00_727 = 
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80); 
BgL_test2082z00_1376 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1667z00_727, BGl_terminatedzd2threadzd2exceptionz00zz__pth_threadz00); } 
if(BgL_test2082z00_1376)
{ /* Llib/thread.scm 88 */
return 
BGl_raisez00zz__errorz00(
(((BgL_fthreadz00_bglt)COBJECT(
((BgL_fthreadz00_bglt)BgL_tz00_606)))->BgL_z52exczd2resultz80));}  else 
{ /* Llib/thread.scm 88 */
if(
CBOOL(BgL_vz00_720))
{ /* Llib/thread.scm 90 */
return BgL_vz00_720;}  else 
{ /* Llib/thread.scm 93 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_arg1652z00_728;
{ /* Llib/thread.scm 93 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1076z00_729;
{ /* Llib/thread.scm 93 */
BgL_joinzd2timeoutzd2exceptionz00_bglt BgL_new1075z00_730;
BgL_new1075z00_730 = 
((BgL_joinzd2timeoutzd2exceptionz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_joinzd2timeoutzd2exceptionz00_bgl) ))); 
{ /* Llib/thread.scm 93 */
long BgL_arg1659z00_731;
{ /* Llib/thread.scm 93 */
long BgL_res1789z00_732;
BgL_res1789z00_732 = 
BGL_CLASS_INDEX(BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00); 
BgL_arg1659z00_731 = BgL_res1789z00_732; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1075z00_730), BgL_arg1659z00_731); } 
BgL_new1076z00_729 = BgL_new1075z00_730; } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1076z00_729)))->BgL_fnamez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1076z00_729)))->BgL_locationz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_1393;
{ /* Llib/thread.scm 93 */
obj_t BgL_arg1655z00_733;
{ /* Llib/thread.scm 93 */
obj_t BgL_arg1658z00_734;
{ /* Llib/thread.scm 93 */
obj_t BgL_res1790z00_735;
{ /* Llib/thread.scm 93 */
obj_t BgL_classz00_736;
BgL_classz00_736 = BGl_joinzd2timeoutzd2exceptionz00zz__ft_threadz00; 
BgL_res1790z00_735 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_736); } 
BgL_arg1658z00_734 = BgL_res1790z00_735; } 
BgL_arg1655z00_733 = 
VECTOR_REF(BgL_arg1658z00_734,((long)2)); } 
BgL_auxz00_1393 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1655z00_733); } 
((((BgL_z62exceptionz62_bglt)COBJECT(
((BgL_z62exceptionz62_bglt)BgL_new1076z00_729)))->BgL_stackz00)=((obj_t)BgL_auxz00_1393),BUNSPEC); } 
BgL_arg1652z00_728 = BgL_new1076z00_729; } 
return 
BGl_raisez00zz__errorz00(
((obj_t)BgL_arg1652z00_728));} } } }  else 
{ /* Llib/thread.scm 81 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string1964z00zz__ft_threadz00, BGl_string1965z00zz__ft_threadz00, BgL_toz00_719);} }  else 
{ /* Llib/thread.scm 65 */
goto BgL_tagzd2103zd2_709;} } }  else 
{ /* Llib/thread.scm 65 */
goto BgL_tagzd2103zd2_709;} } } } 

}



/* &object-equal?-%sigjo1141 */
obj_t BGl_z62objectzd2equalzf3zd2z52sigjo1141zc3zz__ft_threadz00(obj_t BgL_envz00_608, obj_t BgL_o1z00_609, obj_t BgL_o2z00_610)
{
{ /* Llib/thread.scm 50 */
{ /* Llib/thread.scm 51 */
bool_t BgL_tmpz00_1403;
if(
BGl_isazf3zf3zz__objectz00(BgL_o2z00_610, BGl_z52sigjoinz52zz__ft_typesz00))
{ /* Llib/thread.scm 51 */
BgL_tmpz00_1403 = 
(
((obj_t)
(((BgL_z52sigjoinz52_bglt)COBJECT(
((BgL_z52sigjoinz52_bglt)BgL_o1z00_609)))->BgL_threadz00))==
((obj_t)
(((BgL_z52sigjoinz52_bglt)COBJECT(
((BgL_z52sigjoinz52_bglt)BgL_o2z00_610)))->BgL_threadz00)))
; }  else 
{ /* Llib/thread.scm 51 */
BgL_tmpz00_1403 = ((bool_t)0)
; } 
return 
BBOOL(BgL_tmpz00_1403);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_threadz00()
{
{ /* Llib/thread.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)414892231), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)0), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)536506551), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)427827924), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)398966781), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_envz00(((long)360853588), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52envz52(((long)471565042), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00)); 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)295112118), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_z52pthreadz52(((long)486290710), 
BSTRING_TO_STRING(BGl_string1966z00zz__ft_threadz00));} 

}

#ifdef __cplusplus
}
#endif
