/*===========================================================================*/
/*   (Llib/uvtypes.scm)                                                      */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -srfi libuv -copt  -DBGL_DUMMY -safee -unsafe -copt -fPIC -copt -IClib Llib/uvtypes.scm -o objs/uvtypes.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <uv.h>
#include <buv.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z52uvz52_bgl {
   header_t header;
   obj_t widening;
} *BgL_z52uvz52_bglt;

typedef struct BgL_uvhandlez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
} *BgL_uvhandlez00_bglt;

typedef struct BgL_uvloopz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   obj_t BgL_z52mutexz52;
} *BgL_uvloopz00_bglt;

typedef struct BgL_uvwatcherz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvwatcherz00_bglt;

typedef struct BgL_uvstreamz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
} *BgL_uvstreamz00_bglt;

typedef struct BgL_uvtcpz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
} *BgL_uvtcpz00_bglt;

typedef struct BgL_uvudpz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   obj_t BgL_z52procmz52;
} *BgL_uvudpz00_bglt;

typedef struct BgL_uvpipez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   bool_t BgL_ipcz00;
} *BgL_uvpipez00_bglt;

typedef struct BgL_uvttyz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_z52allocz52;
   obj_t BgL_z52offsetz52;
   obj_t BgL_z52procaz52;
   obj_t BgL_z52proccz52;
   obj_t BgL_z52callbackz52;
   int BgL_fdz00;
   bool_t BgL_readablez00;
} *BgL_uvttyz00_bglt;

typedef struct BgL_uvtimerz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
   uint64_t BgL_repeatz00;
   bool_t BgL_refz00;
} *BgL_uvtimerz00_bglt;

typedef struct BgL_uvidlez00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvidlez00_bglt;

typedef struct BgL_uvasyncz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvasyncz00_bglt;

typedef struct BgL_uvpollz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
   int BgL_fdz00;
} *BgL_uvpollz00_bglt;

typedef struct BgL_uvfilez00_bgl {
   header_t header;
   obj_t widening;
   int BgL_fdz00;
   obj_t BgL_pathz00;
} *BgL_uvfilez00_bglt;

typedef struct BgL_uvfseventz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvfseventz00_bglt;

typedef struct BgL_uvfspollz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvfspollz00_bglt;

typedef struct BgL_uvcheckz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   struct BgL_uvloopz00_bgl * BgL_loopz00;
   obj_t BgL_cbz00;
} *BgL_uvcheckz00_bglt;

typedef struct BgL_uvprocessz00_bgl {
   header_t header;
   obj_t widening;
   uv_handle_t * BgL_z42builtinz42;
   obj_t BgL_z52onclosez52;
   obj_t BgL_z52gcmarksheadz52;
   obj_t BgL_z52gcmarkstailz52;
   bool_t BgL_closedz00;
   obj_t BgL_z42onexitz42;
} *BgL_uvprocessz00_bglt;

typedef struct BgL_uvprocessoptionsz00_bgl {
   header_t header;
   obj_t widening;
   uv_process_options_t * BgL_z42builtinz42;
} *BgL_uvprocessoptionsz00_bglt;

typedef struct BgL_uvworkz00_bgl {
   header_t header;
   obj_t widening;
   uv_work_t * BgL_z42builtinz42;
   obj_t BgL_z52workzd2cbz80;
   obj_t BgL_z52afterzd2cbz80;
} *BgL_uvworkz00_bglt;


static BgL_uvtimerz00_bglt BGl_z62lambda1921z62zz__libuv_typesz00(obj_t);
static BgL_uvfilez00_bglt BGl_z62uvzd2newzd2filez62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1928z62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1767z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1929z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62z52uvzd2initze2zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1935z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1774z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1936z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1775z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31846ze3ze5zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32100ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvwatcherz00_bglt BGl_z62lambda1781z62zz__libuv_typesz00(obj_t);
static BgL_uvidlez00_bglt BGl_z62lambda1943z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvidlez00_bglt BGl_z62lambda1946z62zz__libuv_typesz00(obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1787z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1788z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32101ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static BgL_uvasyncz00_bglt BGl_z62lambda1954z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1793z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1794z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_guess_handle(int);
static BgL_uvasyncz00_bglt BGl_z62lambda1957z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31937ze3ze5zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_handle_type_symbol(int);
static obj_t BGl_z62zc3z04anonymousza31970ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvpollz00_bglt BGl_z62lambda1965z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31776ze3ze5zz__libuv_typesz00(obj_t);
static BgL_uvpollz00_bglt BGl_z62lambda1968z62zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvFsEventz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1974z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1975z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL bool_t BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(BgL_uvhandlez00_bglt);
static BgL_uvfilez00_bglt BGl_z62lambda1981z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvfilez00_bglt BGl_z62lambda1983z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1989z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32105ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62lambda1990z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1994z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1995z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(BgL_uvhandlez00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza31795ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31868ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32106ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32017ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31886ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31959ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32051ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvHandlez00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_z52uvzd2initz80zz__libuv_typesz00(BgL_z52uvz52_bglt);
BGL_EXPORTED_DEF obj_t BGl_UvLoopz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_methodzd2initzd2zz__libuv_typesz00();
BGL_EXPORTED_DEF obj_t BGl_UvPipez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32126ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2namez00zz__objectz00(obj_t);
static obj_t BGl_z62uvzd2idzb0zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32055ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32039ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32129ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvWorkz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32146ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvProcessz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32090ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTcpz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32091ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
extern obj_t bgl_uv_process_options_env_get(uv_process_options_t *);
static obj_t BGl_z62zc3z04anonymousza32076ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32149ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32166ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvPollz00zz__libuv_typesz00 = BUNSPEC;
extern void bgl_uv_process_options_env_set(uv_process_options_t *, obj_t);
static obj_t BGl_z62zc3z04anonymousza32095ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza32096ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32169ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31902ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31651ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_uvzd2strerrorzd2zz__libuv_typesz00(int);
static obj_t BGl_z62objectzd2printzd2UvHandl1340z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_uvworkz00_bglt BGl_z62lambda2187z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2namezd2zz__objectz00(obj_t);
BGL_IMPORT obj_t void_star_to_obj(void *);
static BgL_uvworkz00_bglt BGl_z62lambda2190z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda2197z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2198z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31832ze3ze5zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static BgL_uvstreamz00_bglt BGl_z62lambda1801z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvstreamz00_bglt BGl_z62lambda1804z62zz__libuv_typesz00(obj_t);
static BgL_z52uvz52_bglt BGl_z62lambda1644z62zz__libuv_typesz00(obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1810z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1811z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1816z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1817z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31923ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31818ze3ze5zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_z52Uvz52zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1823z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1824z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvhandlez00_bglt BGl_z62lambda1668z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1830z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1831z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31690ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1837z62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvhandlez00_bglt BGl_z62lambda1676z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1838z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1844z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1845z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1688z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1689z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2strerrorzb0zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bgl_uv_pop_gcmark(BgL_uvhandlez00_bglt, obj_t);
static BgL_uvtcpz00_bglt BGl_z62lambda1852z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvtcpz00_bglt BGl_z62lambda1855z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1695z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1696z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvudpz00_bglt BGl_z62lambda1863z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvudpz00_bglt BGl_z62lambda1866z62zz__libuv_typesz00(obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DECL char * BGl_uvzd2versionzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza31839ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1873z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1874z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31783ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31678ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
static obj_t BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTtyz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62z52uvzd2init1337ze2zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32110ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvFsPollz00zz__libuv_typesz00 = BUNSPEC;
static BgL_uvpipez00_bglt BGl_z62lambda1881z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvpipez00_bglt BGl_z62lambda1884z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31857ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62uvzd2versionzb0zz__libuv_typesz00(obj_t);
static obj_t BGl_toplevelzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza32111ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32006ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1890z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1891z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static BgL_uvttyz00_bglt BGl_z62lambda1897z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31769ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31875ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_genericzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza31948ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31697ze3ze5zz__libuv_typesz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00(obj_t, obj_t, obj_t);
extern void bgl_uv_process_options_args_set(uv_process_options_t *, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvIdlez00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DECL int BGl_uvzd2idzd2zz__libuv_typesz00(BgL_uvhandlez00_bglt);
BGL_EXPORTED_DEF obj_t BGl_UvFilez00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32116ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_mutexzd2nilzd2zz__threadz00();
BGL_EXPORTED_DEF obj_t BGl_UvAsyncz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32028ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31985ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32046ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32119ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32136ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvfseventz00_bglt BGl_z62lambda2001z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvfseventz00_bglt BGl_z62lambda2004z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32080ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvfspollz00_bglt BGl_z62lambda2012z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvfspollz00_bglt BGl_z62lambda2015z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32081ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_nilzf3zf3zz__objectz00(BgL_objectz00_bglt);
BGL_IMPORT obj_t BGl_callzd2virtualzd2setterz00zz__objectz00(BgL_objectz00_bglt, int, obj_t);
static BgL_uvcheckz00_bglt BGl_z62lambda2023z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvcheckz00_bglt BGl_z62lambda2026z62zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvStreamz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_UvWatcherz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32139ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
extern obj_t bgl_uv_process_options_args_get(uv_process_options_t *);
static obj_t BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static BgL_uvprocessz00_bglt BGl_z62lambda2034z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31710ze3ze5zz__libuv_typesz00(obj_t);
static BgL_uvprocessz00_bglt BGl_z62lambda2037z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvProcessOptionsz00zz__libuv_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda2203z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2204z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2044z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2045z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2208z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2209z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__libuv_typesz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_callzd2virtualzd2getterz00zz__objectz00(BgL_objectz00_bglt, int);
static obj_t BGl_z62zc3z04anonymousza32085ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32069ze3ze5zz__libuv_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvUdpz00zz__libuv_typesz00 = BUNSPEC;
static BgL_uvprocessoptionsz00_bglt BGl_z62lambda2064z62zz__libuv_typesz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long, long);
static BgL_uvprocessoptionsz00_bglt BGl_z62lambda2067z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32086ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32159ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2074z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2075z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__libuv_typesz00();
static obj_t BGl_z62zc3z04anonymousza32192ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32176ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00();
BGL_EXPORTED_DECL obj_t BGl_uvzd2errzd2namez00zz__libuv_typesz00(int);
static obj_t BGl_z62zc3z04anonymousza31731ze3ze5zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvTimerz00zz__libuv_typesz00 = BUNSPEC;
BGL_EXPORTED_DECL BgL_uvfilez00_bglt bgl_uv_new_file(int, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62zc3z04anonymousza31806ze3ze5zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31717ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32179ze3ze5zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1708z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1709z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1715z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1716z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31930ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1729z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31825ze3ze5zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1730z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32199ze3ze5zz__libuv_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_UvCheckz00zz__libuv_typesz00 = BUNSPEC;
static BgL_uvttyz00_bglt BGl_z62lambda1900z62zz__libuv_typesz00(obj_t);
static obj_t BGl_z62lambda1906z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1907z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1911z62zz__libuv_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1912z62zz__libuv_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62uvzd2errzd2namez62zz__libuv_typesz00(obj_t, obj_t);
static BgL_uvloopz00_bglt BGl_z62lambda1756z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_uvtimerz00_bglt BGl_z62lambda1918z62zz__libuv_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 71 ] ;


BGL_IMPORT obj_t BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2guesszd2handlezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2guessza7d22472za7, BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2400z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2473za7, BGl_z62zc3z04anonymousza32017ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2401z00zz__libuv_typesz00, BgL_bgl_za762lambda2015za7622474z00, BGl_z62lambda2015z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2402z00zz__libuv_typesz00, BgL_bgl_za762lambda2012za7622475z00, BGl_z62lambda2012z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2403z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2476za7, BGl_z62zc3z04anonymousza32028ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2404z00zz__libuv_typesz00, BgL_bgl_za762lambda2026za7622477z00, BGl_z62lambda2026z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2405z00zz__libuv_typesz00, BgL_bgl_za762lambda2023za7622478z00, BGl_z62lambda2023z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2406z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2479za7, BGl_z62zc3z04anonymousza32046ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2407z00zz__libuv_typesz00, BgL_bgl_za762lambda2045za7622480z00, BGl_z62lambda2045z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2408z00zz__libuv_typesz00, BgL_bgl_za762lambda2044za7622481z00, BGl_z62lambda2044z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2409z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2482za7, BGl_z62zc3z04anonymousza32051ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2410z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2483za7, BGl_z62zc3z04anonymousza32050ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2411z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2484za7, BGl_z62zc3z04anonymousza32055ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2412z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2485za7, BGl_z62zc3z04anonymousza32039ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2413z00zz__libuv_typesz00, BgL_bgl_za762lambda2037za7622486z00, BGl_z62lambda2037z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2414z00zz__libuv_typesz00, BgL_bgl_za762lambda2034za7622487z00, BGl_z62lambda2034z62zz__libuv_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2415z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2488za7, BGl_z62zc3z04anonymousza32076ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2416z00zz__libuv_typesz00, BgL_bgl_za762lambda2075za7622489z00, BGl_z62lambda2075z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2417z00zz__libuv_typesz00, BgL_bgl_za762lambda2074za7622490z00, BGl_z62lambda2074z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2418z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2491za7, BGl_z62zc3z04anonymousza32081ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2419z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2492za7, BGl_z62zc3z04anonymousza32080ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2420z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2493za7, BGl_z62zc3z04anonymousza32086ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2421z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2494za7, BGl_z62zc3z04anonymousza32085ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2422z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2495za7, BGl_z62zc3z04anonymousza32091ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2423z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2496za7, BGl_z62zc3z04anonymousza32090ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2424z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2497za7, BGl_z62zc3z04anonymousza32096ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2425z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2498za7, BGl_z62zc3z04anonymousza32095ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2426z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2499za7, BGl_z62zc3z04anonymousza32101ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2427z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2500za7, BGl_z62zc3z04anonymousza32100ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2428z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2501za7, BGl_z62zc3z04anonymousza32106ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2429z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2502za7, BGl_z62zc3z04anonymousza32105ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2430z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2503za7, BGl_z62zc3z04anonymousza32111ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2431z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2504za7, BGl_z62zc3z04anonymousza32110ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2432z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2505za7, BGl_z62zc3z04anonymousza32116ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2433z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2506za7, BGl_z62zc3z04anonymousza32119ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2434z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2507za7, BGl_z62zc3z04anonymousza32126ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2435z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2508za7, BGl_z62zc3z04anonymousza32129ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2436z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2509za7, BGl_z62zc3z04anonymousza32136ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2437z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2510za7, BGl_z62zc3z04anonymousza32139ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2438z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2511za7, BGl_z62zc3z04anonymousza32146ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2439z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2512za7, BGl_z62zc3z04anonymousza32149ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2440z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2513za7, BGl_z62zc3z04anonymousza32156ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2441z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2514za7, BGl_z62zc3z04anonymousza32159ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2442z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2515za7, BGl_z62zc3z04anonymousza32166ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2443z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2516za7, BGl_z62zc3z04anonymousza32169ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2444z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2517za7, BGl_z62zc3z04anonymousza32176ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2445z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2518za7, BGl_z62zc3z04anonymousza32179ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2446z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2519za7, BGl_z62zc3z04anonymousza32069ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2447z00zz__libuv_typesz00, BgL_bgl_za762lambda2067za7622520z00, BGl_z62lambda2067z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2448z00zz__libuv_typesz00, BgL_bgl_za762lambda2064za7622521z00, BGl_z62lambda2064z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2449z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2522za7, BGl_z62zc3z04anonymousza32199ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2450z00zz__libuv_typesz00, BgL_bgl_za762lambda2198za7622523z00, BGl_z62lambda2198z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2451z00zz__libuv_typesz00, BgL_bgl_za762lambda2197za7622524z00, BGl_z62lambda2197z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2452z00zz__libuv_typesz00, BgL_bgl_za762lambda2204za7622525z00, BGl_z62lambda2204z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2453z00zz__libuv_typesz00, BgL_bgl_za762lambda2203za7622526z00, BGl_z62lambda2203z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2454z00zz__libuv_typesz00, BgL_bgl_za762lambda2209za7622527z00, BGl_z62lambda2209z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2455z00zz__libuv_typesz00, BgL_bgl_za762lambda2208za7622528z00, BGl_z62lambda2208z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2456z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2529za7, BGl_z62zc3z04anonymousza32192ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2457z00zz__libuv_typesz00, BgL_bgl_za762lambda2190za7622530z00, BGl_z62lambda2190z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2458z00zz__libuv_typesz00, BgL_bgl_za762lambda2187za7622531z00, BGl_z62lambda2187z62zz__libuv_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2296z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2532za7, BGl_z62zc3z04anonymousza31651ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2459z00zz__libuv_typesz00, BgL_bgl_za762za752uvza7d2init12533za7, BGl_z62z52uvzd2init1337ze2zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2297z00zz__libuv_typesz00, BgL_bgl_za762lambda1644za7622534z00, BGl_z62lambda1644z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2298z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2535za7, BGl_z62zc3z04anonymousza31690ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2299z00zz__libuv_typesz00, BgL_bgl_za762lambda1689za7622536z00, BGl_z62lambda1689z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2461z00zz__libuv_typesz00, BgL_bgl_za762objectza7d2prin2537z00, BGl_z62objectzd2printzd2UvHandl1340z62zz__libuv_typesz00, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2gcmarkszd2emptyzf3zd2envz21zz__libuv_typesz00, BgL_bgl_za762uvza7d2gcmarksza72538za7, BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2errzd2namezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2errza7d2na2539za7, BGl_z62uvzd2errzd2namez62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2pushzd2gcmarkz12zd2envzc0zz__libuv_typesz00, BgL_bgl_za762uvza7d2pushza7d2g2540za7, BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2newzd2filezd2envzd2zz__libuv_typesz00, BgL_bgl_za762uvza7d2newza7d2fi2541za7, BGl_z62uvzd2newzd2filez62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2idzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2idza7b0za7za7_2542za7, BGl_z62uvzd2idzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2strerrorzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2strerror2543z00, BGl_z62uvzd2strerrorzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2300z00zz__libuv_typesz00, BgL_bgl_za762lambda1688za7622544z00, BGl_z62lambda1688z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2301z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2545za7, BGl_z62zc3z04anonymousza31697ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2302z00zz__libuv_typesz00, BgL_bgl_za762lambda1696za7622546z00, BGl_z62lambda1696z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2303z00zz__libuv_typesz00, BgL_bgl_za762lambda1695za7622547z00, BGl_z62lambda1695z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2304z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2548za7, BGl_z62zc3z04anonymousza31710ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2305z00zz__libuv_typesz00, BgL_bgl_za762lambda1709za7622549z00, BGl_z62lambda1709z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2306z00zz__libuv_typesz00, BgL_bgl_za762lambda1708za7622550z00, BGl_z62lambda1708z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2307z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2551za7, BGl_z62zc3z04anonymousza31717ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2308z00zz__libuv_typesz00, BgL_bgl_za762lambda1716za7622552z00, BGl_z62lambda1716z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2309z00zz__libuv_typesz00, BgL_bgl_za762lambda1715za7622553z00, BGl_z62lambda1715z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2310z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2554za7, BGl_z62zc3z04anonymousza31731ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2311z00zz__libuv_typesz00, BgL_bgl_za762lambda1730za7622555z00, BGl_z62lambda1730z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2312z00zz__libuv_typesz00, BgL_bgl_za762lambda1729za7622556z00, BGl_z62lambda1729z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2313z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2557za7, BGl_z62zc3z04anonymousza31678ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2314z00zz__libuv_typesz00, BgL_bgl_za762lambda1676za7622558z00, BGl_z62lambda1676z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2315z00zz__libuv_typesz00, BgL_bgl_za762lambda1668za7622559z00, BGl_z62lambda1668z62zz__libuv_typesz00, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2316z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2560za7, BGl_z62zc3z04anonymousza31776ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2317z00zz__libuv_typesz00, BgL_bgl_za762lambda1775za7622561z00, BGl_z62lambda1775z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2318z00zz__libuv_typesz00, BgL_bgl_za762lambda1774za7622562z00, BGl_z62lambda1774z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2319z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2563za7, BGl_z62zc3z04anonymousza31769ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2320z00zz__libuv_typesz00, BgL_bgl_za762lambda1767za7622564z00, BGl_z62lambda1767z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2321z00zz__libuv_typesz00, BgL_bgl_za762lambda1756za7622565z00, BGl_z62lambda1756z62zz__libuv_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2322z00zz__libuv_typesz00, BgL_bgl_za762lambda1788za7622566z00, BGl_z62lambda1788z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2323z00zz__libuv_typesz00, BgL_bgl_za762lambda1787za7622567z00, BGl_z62lambda1787z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2324z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2568za7, BGl_z62zc3z04anonymousza31795ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2325z00zz__libuv_typesz00, BgL_bgl_za762lambda1794za7622569z00, BGl_z62lambda1794z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2326z00zz__libuv_typesz00, BgL_bgl_za762lambda1793za7622570z00, BGl_z62lambda1793z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2327z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2571za7, BGl_z62zc3z04anonymousza31783ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2328z00zz__libuv_typesz00, BgL_bgl_za762lambda1781za7622572z00, BGl_z62lambda1781z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2329z00zz__libuv_typesz00, BgL_bgl_za762lambda1811za7622573z00, BGl_z62lambda1811z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2330z00zz__libuv_typesz00, BgL_bgl_za762lambda1810za7622574z00, BGl_z62lambda1810z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2331z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2575za7, BGl_z62zc3z04anonymousza31818ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2332z00zz__libuv_typesz00, BgL_bgl_za762lambda1817za7622576z00, BGl_z62lambda1817z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2333z00zz__libuv_typesz00, BgL_bgl_za762lambda1816za7622577z00, BGl_z62lambda1816z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2334z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2578za7, BGl_z62zc3z04anonymousza31825ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2335z00zz__libuv_typesz00, BgL_bgl_za762lambda1824za7622579z00, BGl_z62lambda1824z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2336z00zz__libuv_typesz00, BgL_bgl_za762lambda1823za7622580z00, BGl_z62lambda1823z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2337z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2581za7, BGl_z62zc3z04anonymousza31832ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2338z00zz__libuv_typesz00, BgL_bgl_za762lambda1831za7622582z00, BGl_z62lambda1831z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2339z00zz__libuv_typesz00, BgL_bgl_za762lambda1830za7622583z00, BGl_z62lambda1830z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2340z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2584za7, BGl_z62zc3z04anonymousza31839ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2341z00zz__libuv_typesz00, BgL_bgl_za762lambda1838za7622585z00, BGl_z62lambda1838z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2342z00zz__libuv_typesz00, BgL_bgl_za762lambda1837za7622586z00, BGl_z62lambda1837z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2343z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2587za7, BGl_z62zc3z04anonymousza31846ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2344z00zz__libuv_typesz00, BgL_bgl_za762lambda1845za7622588z00, BGl_z62lambda1845z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2345z00zz__libuv_typesz00, BgL_bgl_za762lambda1844za7622589z00, BGl_z62lambda1844z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2346z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2590za7, BGl_z62zc3z04anonymousza31806ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2347z00zz__libuv_typesz00, BgL_bgl_za762lambda1804za7622591z00, BGl_z62lambda1804z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2348z00zz__libuv_typesz00, BgL_bgl_za762lambda1801za7622592z00, BGl_z62lambda1801z62zz__libuv_typesz00, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2349z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2593za7, BGl_z62zc3z04anonymousza31857ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2popzd2gcmarkz12zd2envzc0zz__libuv_typesz00, BgL_bgl_za762uvza7d2popza7d2gc2594za7, BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2350z00zz__libuv_typesz00, BgL_bgl_za762lambda1855za7622595z00, BGl_z62lambda1855z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2351z00zz__libuv_typesz00, BgL_bgl_za762lambda1852za7622596z00, BGl_z62lambda1852z62zz__libuv_typesz00, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2352z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2597za7, BGl_z62zc3z04anonymousza31875ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2353z00zz__libuv_typesz00, BgL_bgl_za762lambda1874za7622598z00, BGl_z62lambda1874z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2354z00zz__libuv_typesz00, BgL_bgl_za762lambda1873za7622599z00, BGl_z62lambda1873z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2355z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2600za7, BGl_z62zc3z04anonymousza31868ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2356z00zz__libuv_typesz00, BgL_bgl_za762lambda1866za7622601z00, BGl_z62lambda1866z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2357z00zz__libuv_typesz00, BgL_bgl_za762lambda1863za7622602z00, BGl_z62lambda1863z62zz__libuv_typesz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2358z00zz__libuv_typesz00, BgL_bgl_za762lambda1891za7622603z00, BGl_z62lambda1891z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2359z00zz__libuv_typesz00, BgL_bgl_za762lambda1890za7622604z00, BGl_z62lambda1890z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2360z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2605za7, BGl_z62zc3z04anonymousza31886ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2361z00zz__libuv_typesz00, BgL_bgl_za762lambda1884za7622606z00, BGl_z62lambda1884z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2362z00zz__libuv_typesz00, BgL_bgl_za762lambda1881za7622607z00, BGl_z62lambda1881z62zz__libuv_typesz00, 0L, BUNSPEC, 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2363z00zz__libuv_typesz00, BgL_bgl_za762lambda1907za7622608z00, BGl_z62lambda1907z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2364z00zz__libuv_typesz00, BgL_bgl_za762lambda1906za7622609z00, BGl_z62lambda1906z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2365z00zz__libuv_typesz00, BgL_bgl_za762lambda1912za7622610z00, BGl_z62lambda1912z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2366z00zz__libuv_typesz00, BgL_bgl_za762lambda1911za7622611z00, BGl_z62lambda1911z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2367z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2612za7, BGl_z62zc3z04anonymousza31902ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2368z00zz__libuv_typesz00, BgL_bgl_za762lambda1900za7622613z00, BGl_z62lambda1900z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2369z00zz__libuv_typesz00, BgL_bgl_za762lambda1897za7622614z00, BGl_z62lambda1897z62zz__libuv_typesz00, 0L, BUNSPEC, 13 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string2295z00zz__libuv_typesz00, BgL_bgl_string2295za700za7za7_2615za7, "", 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2370z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2616za7, BGl_z62zc3z04anonymousza31930ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2371z00zz__libuv_typesz00, BgL_bgl_za762lambda1929za7622617z00, BGl_z62lambda1929z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2372z00zz__libuv_typesz00, BgL_bgl_za762lambda1928za7622618z00, BGl_z62lambda1928z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2373z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2619za7, BGl_z62zc3z04anonymousza31937ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2374z00zz__libuv_typesz00, BgL_bgl_za762lambda1936za7622620z00, BGl_z62lambda1936z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2460z00zz__libuv_typesz00, BgL_bgl_string2460za700za7za7_2621za7, "%uv-init1337", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2375z00zz__libuv_typesz00, BgL_bgl_za762lambda1935za7622622z00, BGl_z62lambda1935z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2376z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2623za7, BGl_z62zc3z04anonymousza31923ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2462z00zz__libuv_typesz00, BgL_bgl_string2462za700za7za7_2624za7, "object-print", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2377z00zz__libuv_typesz00, BgL_bgl_za762lambda1921za7622625z00, BGl_z62lambda1921z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2463z00zz__libuv_typesz00, BgL_bgl_string2463za700za7za7_2626za7, " [", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2378z00zz__libuv_typesz00, BgL_bgl_za762lambda1918za7622627z00, BGl_z62lambda1918z62zz__libuv_typesz00, 0L, BUNSPEC, 9 );
DEFINE_STRING( BGl_string2464z00zz__libuv_typesz00, BgL_bgl_string2464za700za7za7_2628za7, "#|", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2379z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2629za7, BGl_z62zc3z04anonymousza31948ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2465z00zz__libuv_typesz00, BgL_bgl_string2465za700za7za7_2630za7, " (0x", 4 );
DEFINE_STRING( BGl_string2466z00zz__libuv_typesz00, BgL_bgl_string2466za700za7za7_2631za7, ")", 1 );
DEFINE_STRING( BGl_string2467z00zz__libuv_typesz00, BgL_bgl_string2467za700za7za7_2632za7, " nil|", 5 );
DEFINE_STRING( BGl_string2468z00zz__libuv_typesz00, BgL_bgl_string2468za700za7za7_2633za7, "(#\\$ #\\%) UvWork %after-cb %work-cb $uv_work_t UvProcessOptions gid uid flags cwd env args file $uv_process_options_t UvProcess pid $onexit UvCheck UvFsPoll UvFsEvent UvFile bstring path UvPoll UvAsync UvIdle UvTimer ref uint64 repeat UvTty readable int fd UvPipe ipc UvUdp %procm UvTcp UvStream %callback %procc %proca %offset %alloc UvWatcher procedure cb loop UvLoop mutex %mutex UvHandle bool closed %gcmarkstail pair-nil %gcmarkshead obj %onclose $uv_handle_t $builtin __libuv_types %Uv UNDEFINED UNKNOWN FILE PIPE UDP TTY TCP ", 532 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2380z00zz__libuv_typesz00, BgL_bgl_za762lambda1946za7622634z00, BGl_z62lambda1946z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2381z00zz__libuv_typesz00, BgL_bgl_za762lambda1943za7622635z00, BGl_z62lambda1943z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2382z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2636za7, BGl_z62zc3z04anonymousza31959ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2383z00zz__libuv_typesz00, BgL_bgl_za762lambda1957za7622637z00, BGl_z62lambda1957z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2384z00zz__libuv_typesz00, BgL_bgl_za762lambda1954za7622638z00, BGl_z62lambda1954z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2385z00zz__libuv_typesz00, BgL_bgl_za762lambda1975za7622639z00, BGl_z62lambda1975z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2386z00zz__libuv_typesz00, BgL_bgl_za762lambda1974za7622640z00, BGl_z62lambda1974z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2387z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2641za7, BGl_z62zc3z04anonymousza31970ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2388z00zz__libuv_typesz00, BgL_bgl_za762lambda1968za7622642z00, BGl_z62lambda1968z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2389z00zz__libuv_typesz00, BgL_bgl_za762lambda1965za7622643z00, BGl_z62lambda1965z62zz__libuv_typesz00, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2390z00zz__libuv_typesz00, BgL_bgl_za762lambda1990za7622644z00, BGl_z62lambda1990z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2391z00zz__libuv_typesz00, BgL_bgl_za762lambda1989za7622645z00, BGl_z62lambda1989z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2392z00zz__libuv_typesz00, BgL_bgl_za762lambda1995za7622646z00, BGl_z62lambda1995z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2393z00zz__libuv_typesz00, BgL_bgl_za762lambda1994za7622647z00, BGl_z62lambda1994z62zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2394z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2648za7, BGl_z62zc3z04anonymousza31985ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2395z00zz__libuv_typesz00, BgL_bgl_za762lambda1983za7622649z00, BGl_z62lambda1983z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2396z00zz__libuv_typesz00, BgL_bgl_za762lambda1981za7622650z00, BGl_z62lambda1981z62zz__libuv_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2397z00zz__libuv_typesz00, BgL_bgl_za762za7c3za704anonymo2651za7, BGl_z62zc3z04anonymousza32006ze3ze5zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2398z00zz__libuv_typesz00, BgL_bgl_za762lambda2004za7622652z00, BGl_z62lambda2004z62zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2399z00zz__libuv_typesz00, BgL_bgl_za762lambda2001za7622653z00, BGl_z62lambda2001z62zz__libuv_typesz00, 0L, BUNSPEC, 7 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
DEFINE_EXPORT_BGL_GENERIC( BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BgL_bgl_za762za752uvza7d2initza72654z00, BGl_z62z52uvzd2initze2zz__libuv_typesz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2versionzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2versionza72655za7, BGl_z62uvzd2versionzb0zz__libuv_typesz00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_uvzd2handlezd2typezd2symbolzd2envz00zz__libuv_typesz00, BgL_bgl_za762uvza7d2handleza7d2656za7, BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_UvFsEventz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvHandlez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvLoopz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvPipez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvWorkz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvProcessz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTcpz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvPollz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_z52Uvz52zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTtyz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvFsPollz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvIdlez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvFilez00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvAsyncz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvStreamz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvWatcherz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvProcessOptionsz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvUdpz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvTimerz00zz__libuv_typesz00) );
ADD_ROOT( (void *)(&BGl_UvCheckz00zz__libuv_typesz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__libuv_typesz00(long BgL_checksumz00_2784, char * BgL_fromz00_2785)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__libuv_typesz00))
{ 
BGl_requirezd2initializa7ationz75zz__libuv_typesz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__libuv_typesz00(); 
BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00(); 
BGl_cnstzd2initzd2zz__libuv_typesz00(); 
BGl_objectzd2initzd2zz__libuv_typesz00(); 
BGl_genericzd2initzd2zz__libuv_typesz00(); 
BGl_methodzd2initzd2zz__libuv_typesz00(); 
return 
BGl_toplevelzd2initzd2zz__libuv_typesz00();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__libuv_types"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__libuv_types"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_cportz00_2362;
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_stringz00_2370;
BgL_stringz00_2370 = BGl_string2468z00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_startz00_2371;
BgL_startz00_2371 = 
BINT(((long)0)); 
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_endz00_2372;
BgL_endz00_2372 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2370))); 
{ /* Llib/uvtypes.scm 15 */

BgL_cportz00_2362 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2370, BgL_startz00_2371, BgL_endz00_2372); } } } } 
{ 
long BgL_iz00_2363;
BgL_iz00_2363 = ((long)70); 
BgL_loopz00_2364:
if(
(BgL_iz00_2363==((long)-1)))
{ /* Llib/uvtypes.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 15 */
obj_t BgL_arg2470z00_2366;
{ /* Llib/uvtypes.scm 15 */

{ /* Llib/uvtypes.scm 15 */
obj_t BgL_locationz00_2368;
BgL_locationz00_2368 = 
BBOOL(((bool_t)0)); 
{ /* Llib/uvtypes.scm 15 */

BgL_arg2470z00_2366 = 
BGl_readz00zz__readerz00(BgL_cportz00_2362, BgL_locationz00_2368); } } } 
{ /* Llib/uvtypes.scm 15 */
int BgL_tmpz00_2816;
BgL_tmpz00_2816 = 
(int)(BgL_iz00_2363); 
CNST_TABLE_SET(BgL_tmpz00_2816, BgL_arg2470z00_2366); } } 
{ /* Llib/uvtypes.scm 15 */
int BgL_auxz00_2369;
BgL_auxz00_2369 = 
(int)(
(BgL_iz00_2363-((long)1))); 
{ 
long BgL_iz00_2821;
BgL_iz00_2821 = 
(long)(BgL_auxz00_2369); 
BgL_iz00_2363 = BgL_iz00_2821; 
goto BgL_loopz00_2364;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
return BUNSPEC;} 

}



/* uv-version */
BGL_EXPORTED_DEF char * BGl_uvzd2versionzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 174 */
return 
(char *)uv_version_string();} 

}



/* &uv-version */
obj_t BGl_z62uvzd2versionzb0zz__libuv_typesz00(obj_t BgL_envz00_1711)
{
{ /* Llib/uvtypes.scm 174 */
return 
string_to_bstring(
BGl_uvzd2versionzd2zz__libuv_typesz00());} 

}



/* uv-id */
BGL_EXPORTED_DEF int BGl_uvzd2idzd2zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_3)
{
{ /* Llib/uvtypes.scm 180 */
{ /* Llib/uvtypes.scm 182 */
uv_handle_t * BgL_arg1346z00_1233;
BgL_arg1346z00_1233 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_3))->BgL_z42builtinz42); 
return 
(int)(
(long)(BgL_arg1346z00_1233));} } 

}



/* &uv-id */
obj_t BGl_z62uvzd2idzb0zz__libuv_typesz00(obj_t BgL_envz00_1712, obj_t BgL_oz00_1713)
{
{ /* Llib/uvtypes.scm 180 */
return 
BINT(
BGl_uvzd2idzd2zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1713)));} 

}



/* uv-new-file */
BGL_EXPORTED_DEF BgL_uvfilez00_bglt bgl_uv_new_file(int BgL_fdz00_8, obj_t BgL_pathz00_9)
{
{ /* Llib/uvtypes.scm 228 */
{ /* Llib/uvtypes.scm 229 */
BgL_uvfilez00_bglt BgL_new1242z00_1234;
{ /* Llib/uvtypes.scm 230 */
BgL_uvfilez00_bglt BgL_new1241z00_1235;
BgL_new1241z00_1235 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 230 */
long BgL_arg1355z00_1236;
{ /* Llib/uvtypes.scm 230 */
long BgL_res2223z00_1238;
BgL_res2223z00_1238 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BgL_arg1355z00_1236 = BgL_res2223z00_1238; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1241z00_1235), BgL_arg1355z00_1236); } 
BgL_new1242z00_1234 = BgL_new1241z00_1235; } 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1242z00_1234))->BgL_fdz00)=((int)BgL_fdz00_8),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1242z00_1234))->BgL_pathz00)=((obj_t)BgL_pathz00_9),BUNSPEC); 
return BgL_new1242z00_1234;} } 

}



/* &uv-new-file */
BgL_uvfilez00_bglt BGl_z62uvzd2newzd2filez62zz__libuv_typesz00(obj_t BgL_envz00_1714, obj_t BgL_fdz00_1715, obj_t BgL_pathz00_1716)
{
{ /* Llib/uvtypes.scm 228 */
return 
bgl_uv_new_file(
CINT(BgL_fdz00_1715), BgL_pathz00_1716);} 

}



/* uv-strerror */
BGL_EXPORTED_DEF obj_t BGl_uvzd2strerrorzd2zz__libuv_typesz00(int BgL_errnoz00_10)
{
{ /* Llib/uvtypes.scm 236 */
{ /* Llib/uvtypes.scm 237 */
char * BgL_sz00_1241;
BgL_sz00_1241 = 
(char *)uv_strerror(BgL_errnoz00_10); 
if(
((char *)0L) ==(BgL_sz00_1241))
{ /* Llib/uvtypes.scm 238 */
return BGl_string2295z00zz__libuv_typesz00;}  else 
{ /* Llib/uvtypes.scm 238 */
return 
string_to_bstring(BgL_sz00_1241);} } } 

}



/* &uv-strerror */
obj_t BGl_z62uvzd2strerrorzb0zz__libuv_typesz00(obj_t BgL_envz00_1717, obj_t BgL_errnoz00_1718)
{
{ /* Llib/uvtypes.scm 236 */
return 
BGl_uvzd2strerrorzd2zz__libuv_typesz00(
CINT(BgL_errnoz00_1718));} 

}



/* uv-err-name */
BGL_EXPORTED_DEF obj_t BGl_uvzd2errzd2namez00zz__libuv_typesz00(int BgL_errnoz00_11)
{
{ /* Llib/uvtypes.scm 245 */
{ /* Llib/uvtypes.scm 246 */
char * BgL_sz00_1243;
BgL_sz00_1243 = 
(char *)uv_err_name(BgL_errnoz00_11); 
if(
((char *)0L) ==(BgL_sz00_1243))
{ /* Llib/uvtypes.scm 247 */
return BGl_string2295z00zz__libuv_typesz00;}  else 
{ /* Llib/uvtypes.scm 247 */
return 
string_to_bstring(BgL_sz00_1243);} } } 

}



/* &uv-err-name */
obj_t BGl_z62uvzd2errzd2namez62zz__libuv_typesz00(obj_t BgL_envz00_1719, obj_t BgL_errnoz00_1720)
{
{ /* Llib/uvtypes.scm 245 */
return 
BGl_uvzd2errzd2namez00zz__libuv_typesz00(
CINT(BgL_errnoz00_1720));} 

}



/* uv-guess-handle */
BGL_EXPORTED_DEF obj_t bgl_uv_guess_handle(int BgL_fdz00_12)
{
{ /* Llib/uvtypes.scm 254 */
{ /* Llib/uvtypes.scm 255 */
int BgL_arg1391z00_1245;
BgL_arg1391z00_1245 = 
uv_guess_handle(BgL_fdz00_12); 
return 
bgl_uv_handle_type_symbol(BgL_arg1391z00_1245);} } 

}



/* &uv-guess-handle */
obj_t BGl_z62uvzd2guesszd2handlez62zz__libuv_typesz00(obj_t BgL_envz00_1721, obj_t BgL_fdz00_1722)
{
{ /* Llib/uvtypes.scm 254 */
return 
bgl_uv_guess_handle(
CINT(BgL_fdz00_1722));} 

}



/* uv-handle-type-symbol */
BGL_EXPORTED_DEF obj_t bgl_uv_handle_type_symbol(int BgL_rz00_13)
{
{ /* Llib/uvtypes.scm 260 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_TCP)))
{ /* Llib/uvtypes.scm 262 */
return 
CNST_TABLE_REF(((long)0));}  else 
{ /* Llib/uvtypes.scm 262 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_TTY)))
{ /* Llib/uvtypes.scm 263 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/uvtypes.scm 263 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_UDP)))
{ /* Llib/uvtypes.scm 264 */
return 
CNST_TABLE_REF(((long)2));}  else 
{ /* Llib/uvtypes.scm 264 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_NAMED_PIPE)))
{ /* Llib/uvtypes.scm 265 */
return 
CNST_TABLE_REF(((long)3));}  else 
{ /* Llib/uvtypes.scm 265 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_FILE)))
{ /* Llib/uvtypes.scm 266 */
return 
CNST_TABLE_REF(((long)4));}  else 
{ /* Llib/uvtypes.scm 266 */
if(
(
(long)(BgL_rz00_13)==
(long)(UV_UNKNOWN_HANDLE)))
{ /* Llib/uvtypes.scm 267 */
return 
CNST_TABLE_REF(((long)5));}  else 
{ /* Llib/uvtypes.scm 267 */
return 
CNST_TABLE_REF(((long)6));} } } } } } } 

}



/* &uv-handle-type-symbol */
obj_t BGl_z62uvzd2handlezd2typezd2symbolzb0zz__libuv_typesz00(obj_t BgL_envz00_1723, obj_t BgL_rz00_1724)
{
{ /* Llib/uvtypes.scm 260 */
return 
bgl_uv_handle_type_symbol(
CINT(BgL_rz00_1724));} 

}



/* uv-push-gcmark! */
BGL_EXPORTED_DEF obj_t BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_14, obj_t BgL_valz00_15)
{
{ /* Llib/uvtypes.scm 273 */
if(
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 275 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarksheadz52)=((obj_t)
MAKE_YOUNG_PAIR(BgL_valz00_15, BNIL)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)=((obj_t)
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarksheadz52)),BUNSPEC); }  else 
{ /* Llib/uvtypes.scm 275 */
{ /* Llib/uvtypes.scm 280 */
obj_t BgL_arg1516z00_2375;obj_t BgL_arg1517z00_2376;
BgL_arg1516z00_2375 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52); 
BgL_arg1517z00_2376 = 
MAKE_YOUNG_PAIR(BgL_valz00_15, BNIL); 
{ /* Llib/uvtypes.scm 280 */
obj_t BgL_tmpz00_2899;
BgL_tmpz00_2899 = 
((obj_t)BgL_arg1516z00_2375); 
SET_CDR(BgL_tmpz00_2899, BgL_arg1517z00_2376); } } 
{ 
obj_t BgL_auxz00_2902;
{ /* Llib/uvtypes.scm 281 */
obj_t BgL_pairz00_2377;
BgL_pairz00_2377 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52); 
BgL_auxz00_2902 = 
CDR(BgL_pairz00_2377); } 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_14))->BgL_z52gcmarkstailz52)=((obj_t)BgL_auxz00_2902),BUNSPEC); } } 
return BUNSPEC;} 

}



/* &uv-push-gcmark! */
obj_t BGl_z62uvzd2pushzd2gcmarkz12z70zz__libuv_typesz00(obj_t BgL_envz00_1725, obj_t BgL_oz00_1726, obj_t BgL_valz00_1727)
{
{ /* Llib/uvtypes.scm 273 */
return 
BGl_uvzd2pushzd2gcmarkz12z12zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1726), BgL_valz00_1727);} 

}



/* uv-pop-gcmark! */
BGL_EXPORTED_DEF obj_t bgl_uv_pop_gcmark(BgL_uvhandlez00_bglt BgL_oz00_16, obj_t BgL_valz00_17)
{
{ /* Llib/uvtypes.scm 287 */
if(
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)))
{ /* Llib/uvtypes.scm 289 */
return BFALSE;}  else 
{ /* Llib/uvtypes.scm 289 */
if(
(BgL_valz00_17==
CAR(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52))))
{ /* Llib/uvtypes.scm 290 */
if(
(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)==
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 291 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC);}  else 
{ 
obj_t BgL_auxz00_2921;
{ /* Llib/uvtypes.scm 295 */
obj_t BgL_pairz00_1275;
BgL_pairz00_1275 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52); 
BgL_auxz00_2921 = 
CDR(BgL_pairz00_1275); } 
return 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52)=((obj_t)BgL_auxz00_2921),BUNSPEC);} }  else 
{ 
obj_t BgL_pz00_64;
BgL_pz00_64 = 
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarksheadz52); 
BgL_zc3z04anonymousza31570ze3z87_65:
{ /* Llib/uvtypes.scm 297 */
obj_t BgL_nz00_66;
BgL_nz00_66 = 
CDR(
((obj_t)BgL_pz00_64)); 
if(
PAIRP(BgL_nz00_66))
{ /* Llib/uvtypes.scm 298 */
if(
(
CAR(BgL_nz00_66)==BgL_valz00_17))
{ /* Llib/uvtypes.scm 299 */
if(
(BgL_nz00_66==
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)))
{ /* Llib/uvtypes.scm 301 */
((((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_16))->BgL_z52gcmarkstailz52)=((obj_t)BgL_pz00_64),BUNSPEC); }  else 
{ /* Llib/uvtypes.scm 301 */BFALSE; } 
{ /* Llib/uvtypes.scm 303 */
obj_t BgL_arg1600z00_73;
BgL_arg1600z00_73 = 
CDR(BgL_nz00_66); 
{ /* Llib/uvtypes.scm 303 */
obj_t BgL_tmpz00_2937;
BgL_tmpz00_2937 = 
((obj_t)BgL_pz00_64); 
return 
SET_CDR(BgL_tmpz00_2937, BgL_arg1600z00_73);} } }  else 
{ 
obj_t BgL_pz00_2940;
BgL_pz00_2940 = BgL_nz00_66; 
BgL_pz00_64 = BgL_pz00_2940; 
goto BgL_zc3z04anonymousza31570ze3z87_65;} }  else 
{ /* Llib/uvtypes.scm 298 */
return BFALSE;} } } } } 

}



/* &uv-pop-gcmark! */
obj_t BGl_z62uvzd2popzd2gcmarkz12z70zz__libuv_typesz00(obj_t BgL_envz00_1728, obj_t BgL_oz00_1729, obj_t BgL_valz00_1730)
{
{ /* Llib/uvtypes.scm 287 */
return 
bgl_uv_pop_gcmark(
((BgL_uvhandlez00_bglt)BgL_oz00_1729), BgL_valz00_1730);} 

}



/* uv-gcmarks-empty? */
BGL_EXPORTED_DEF bool_t BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(BgL_uvhandlez00_bglt BgL_oz00_18)
{
{ /* Llib/uvtypes.scm 309 */
return 
NULLP(
(((BgL_uvhandlez00_bglt)COBJECT(BgL_oz00_18))->BgL_z52gcmarksheadz52));} 

}



/* &uv-gcmarks-empty? */
obj_t BGl_z62uvzd2gcmarkszd2emptyzf3z91zz__libuv_typesz00(obj_t BgL_envz00_1731, obj_t BgL_oz00_1732)
{
{ /* Llib/uvtypes.scm 309 */
return 
BBOOL(
BGl_uvzd2gcmarkszd2emptyzf3zf3zz__libuv_typesz00(
((BgL_uvhandlez00_bglt)BgL_oz00_1732)));} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_arg1638z00_83;obj_t BgL_arg1643z00_84;
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_v1297z00_90;
BgL_v1297z00_90 = 
create_vector(((long)0)); 
BgL_arg1638z00_83 = BgL_v1297z00_90; } 
{ /* Llib/uvtypes.scm 23 */
obj_t BgL_v1298z00_91;
BgL_v1298z00_91 = 
create_vector(((long)0)); 
BgL_arg1643z00_84 = BgL_v1298z00_91; } 
BGl_z52Uvz52zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)7)), 
CNST_TABLE_REF(((long)8)), BGl_objectz00zz__objectz00, ((long)23172), BFALSE, BGl_proc2297z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2296z00zz__libuv_typesz00, BFALSE, BgL_arg1638z00_83, BgL_arg1643z00_84); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1659z00_97;obj_t BgL_arg1667z00_98;
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_v1299z00_114;
BgL_v1299z00_114 = 
create_vector(((long)5)); 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1681z00_115;
BgL_arg1681z00_115 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2300z00zz__libuv_typesz00, BGl_proc2299z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2298z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1299z00_114,((long)0),BgL_arg1681z00_115); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1691z00_128;
BgL_arg1691z00_128 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)11)), BGl_proc2303z00zz__libuv_typesz00, BGl_proc2302z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2301z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1299z00_114,((long)1),BgL_arg1691z00_128); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1699z00_141;
BgL_arg1699z00_141 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc2306z00zz__libuv_typesz00, BGl_proc2305z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2304z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1299z00_114,((long)2),BgL_arg1699z00_141); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1711z00_154;
BgL_arg1711z00_154 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc2309z00zz__libuv_typesz00, BGl_proc2308z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2307z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1299z00_114,((long)3),BgL_arg1711z00_154); } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_arg1720z00_167;
BgL_arg1720z00_167 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)16)), BGl_proc2312z00zz__libuv_typesz00, BGl_proc2311z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2310z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1299z00_114,((long)4),BgL_arg1720z00_167); } 
BgL_arg1659z00_97 = BgL_v1299z00_114; } 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_v1300z00_180;
BgL_v1300z00_180 = 
create_vector(((long)0)); 
BgL_arg1667z00_98 = BgL_v1300z00_180; } 
BGl_UvHandlez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)18)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)35888), BGl_proc2315z00zz__libuv_typesz00, BGl_proc2314z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2313z00zz__libuv_typesz00, BFALSE, BgL_arg1659z00_97, BgL_arg1667z00_98); } 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_arg1754z00_187;obj_t BgL_arg1755z00_188;
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_v1301z00_205;
BgL_v1301z00_205 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_arg1770z00_206;
BgL_arg1770z00_206 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)19)), BGl_proc2318z00zz__libuv_typesz00, BGl_proc2317z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2316z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)20))); 
VECTOR_SET(BgL_v1301z00_205,((long)0),BgL_arg1770z00_206); } 
BgL_arg1754z00_187 = BgL_v1301z00_205; } 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_v1302z00_220;
BgL_v1302z00_220 = 
create_vector(((long)0)); 
BgL_arg1755z00_188 = BgL_v1302z00_220; } 
BGl_UvLoopz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)21)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)33044), BGl_proc2321z00zz__libuv_typesz00, BGl_proc2320z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2319z00zz__libuv_typesz00, BFALSE, BgL_arg1754z00_187, BgL_arg1755z00_188); } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1779z00_226;obj_t BgL_arg1780z00_227;
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_v1303z00_233;
BgL_v1303z00_233 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1784z00_234;
BgL_arg1784z00_234 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc2323z00zz__libuv_typesz00, BGl_proc2322z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_UvLoopz00zz__libuv_typesz00); 
VECTOR_SET(BgL_v1303z00_233,((long)0),BgL_arg1784z00_234); } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_arg1789z00_244;
BgL_arg1789z00_244 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc2326z00zz__libuv_typesz00, BGl_proc2325z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2324z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1303z00_233,((long)1),BgL_arg1789z00_244); } 
BgL_arg1779z00_226 = BgL_v1303z00_233; } 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_v1304z00_257;
BgL_v1304z00_257 = 
create_vector(((long)0)); 
BgL_arg1780z00_227 = BgL_v1304z00_257; } 
BGl_UvWatcherz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)25)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)54945), BFALSE, BGl_proc2328z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2327z00zz__libuv_typesz00, BFALSE, BgL_arg1779z00_226, BgL_arg1780z00_227); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1799z00_263;obj_t BgL_arg1800z00_264;
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_v1305z00_286;
BgL_v1305z00_286 = 
create_vector(((long)6)); 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1807z00_287;
BgL_arg1807z00_287 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc2330z00zz__libuv_typesz00, BGl_proc2329z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_UvLoopz00zz__libuv_typesz00); 
VECTOR_SET(BgL_v1305z00_286,((long)0),BgL_arg1807z00_287); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1812z00_297;
BgL_arg1812z00_297 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc2333z00zz__libuv_typesz00, BGl_proc2332z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2331z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)1),BgL_arg1812z00_297); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1819z00_310;
BgL_arg1819z00_310 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc2336z00zz__libuv_typesz00, BGl_proc2335z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2334z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)2),BgL_arg1819z00_310); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1826z00_323;
BgL_arg1826z00_323 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc2339z00zz__libuv_typesz00, BGl_proc2338z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2337z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)3),BgL_arg1826z00_323); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1833z00_336;
BgL_arg1833z00_336 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc2342z00zz__libuv_typesz00, BGl_proc2341z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2340z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)4),BgL_arg1833z00_336); } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_arg1840z00_349;
BgL_arg1840z00_349 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)30)), BGl_proc2345z00zz__libuv_typesz00, BGl_proc2344z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2343z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1305z00_286,((long)5),BgL_arg1840z00_349); } 
BgL_arg1799z00_263 = BgL_v1305z00_286; } 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_v1306z00_362;
BgL_v1306z00_362 = 
create_vector(((long)0)); 
BgL_arg1800z00_264 = BgL_v1306z00_362; } 
BGl_UvStreamz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)31)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)11213), BGl_proc2348z00zz__libuv_typesz00, BGl_proc2347z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2346z00zz__libuv_typesz00, BFALSE, BgL_arg1799z00_263, BgL_arg1800z00_264); } 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_arg1850z00_369;obj_t BgL_arg1851z00_370;
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_v1307z00_392;
BgL_v1307z00_392 = 
create_vector(((long)0)); 
BgL_arg1850z00_369 = BgL_v1307z00_392; } 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_v1308z00_393;
BgL_v1308z00_393 = 
create_vector(((long)0)); 
BgL_arg1851z00_370 = BgL_v1308z00_393; } 
BGl_UvTcpz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)32)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)12954), BGl_proc2351z00zz__libuv_typesz00, BGl_proc2350z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2349z00zz__libuv_typesz00, BFALSE, BgL_arg1850z00_369, BgL_arg1851z00_370); } 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_arg1861z00_400;obj_t BgL_arg1862z00_401;
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_v1309z00_424;
BgL_v1309z00_424 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_arg1869z00_425;
BgL_arg1869z00_425 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc2354z00zz__libuv_typesz00, BGl_proc2353z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2352z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1309z00_424,((long)0),BgL_arg1869z00_425); } 
BgL_arg1861z00_400 = BgL_v1309z00_424; } 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_v1310z00_438;
BgL_v1310z00_438 = 
create_vector(((long)0)); 
BgL_arg1862z00_401 = BgL_v1310z00_438; } 
BGl_UvUdpz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)34)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)61109), BGl_proc2357z00zz__libuv_typesz00, BGl_proc2356z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2355z00zz__libuv_typesz00, BFALSE, BgL_arg1861z00_400, BgL_arg1862z00_401); } 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_arg1879z00_445;obj_t BgL_arg1880z00_446;
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_v1311z00_469;
BgL_v1311z00_469 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_arg1887z00_470;
BgL_arg1887z00_470 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc2359z00zz__libuv_typesz00, BGl_proc2358z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1311z00_469,((long)0),BgL_arg1887z00_470); } 
BgL_arg1879z00_445 = BgL_v1311z00_469; } 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_v1312z00_480;
BgL_v1312z00_480 = 
create_vector(((long)0)); 
BgL_arg1880z00_446 = BgL_v1312z00_480; } 
BGl_UvPipez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)36)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)59181), BGl_proc2362z00zz__libuv_typesz00, BGl_proc2361z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2360z00zz__libuv_typesz00, BFALSE, BgL_arg1879z00_445, BgL_arg1880z00_446); } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1895z00_487;obj_t BgL_arg1896z00_488;
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_v1313z00_512;
BgL_v1313z00_512 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1903z00_513;
BgL_arg1903z00_513 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2364z00zz__libuv_typesz00, BGl_proc2363z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1313z00_512,((long)0),BgL_arg1903z00_513); } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_arg1908z00_523;
BgL_arg1908z00_523 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)39)), BGl_proc2366z00zz__libuv_typesz00, BGl_proc2365z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1313z00_512,((long)1),BgL_arg1908z00_523); } 
BgL_arg1895z00_487 = BgL_v1313z00_512; } 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_v1314z00_533;
BgL_v1314z00_533 = 
create_vector(((long)0)); 
BgL_arg1896z00_488 = BgL_v1314z00_533; } 
BGl_UvTtyz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)40)), 
CNST_TABLE_REF(((long)8)), BGl_UvStreamz00zz__libuv_typesz00, ((long)33590), BGl_proc2369z00zz__libuv_typesz00, BGl_proc2368z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2367z00zz__libuv_typesz00, BFALSE, BgL_arg1895z00_487, BgL_arg1896z00_488); } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1916z00_540;obj_t BgL_arg1917z00_541;
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_v1315z00_561;
BgL_v1315z00_561 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1924z00_562;
BgL_arg1924z00_562 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc2372z00zz__libuv_typesz00, BGl_proc2371z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2370z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)42))); 
VECTOR_SET(BgL_v1315z00_561,((long)0),BgL_arg1924z00_562); } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_arg1931z00_575;
BgL_arg1931z00_575 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc2375z00zz__libuv_typesz00, BGl_proc2374z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2373z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1315z00_561,((long)1),BgL_arg1931z00_575); } 
BgL_arg1916z00_540 = BgL_v1315z00_561; } 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_v1316z00_588;
BgL_v1316z00_588 = 
create_vector(((long)0)); 
BgL_arg1917z00_541 = BgL_v1316z00_588; } 
BGl_UvTimerz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)44)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)47319), BGl_proc2378z00zz__libuv_typesz00, BGl_proc2377z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2376z00zz__libuv_typesz00, BFALSE, BgL_arg1916z00_540, BgL_arg1917z00_541); } 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_arg1941z00_595;obj_t BgL_arg1942z00_596;
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_v1317z00_614;
BgL_v1317z00_614 = 
create_vector(((long)0)); 
BgL_arg1941z00_595 = BgL_v1317z00_614; } 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_v1318z00_615;
BgL_v1318z00_615 = 
create_vector(((long)0)); 
BgL_arg1942z00_596 = BgL_v1318z00_615; } 
BGl_UvIdlez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)45)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)3653), BGl_proc2381z00zz__libuv_typesz00, BGl_proc2380z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2379z00zz__libuv_typesz00, BFALSE, BgL_arg1941z00_595, BgL_arg1942z00_596); } 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_arg1952z00_622;obj_t BgL_arg1953z00_623;
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_v1319z00_641;
BgL_v1319z00_641 = 
create_vector(((long)0)); 
BgL_arg1952z00_622 = BgL_v1319z00_641; } 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_v1320z00_642;
BgL_v1320z00_642 = 
create_vector(((long)0)); 
BgL_arg1953z00_623 = BgL_v1320z00_642; } 
BGl_UvAsyncz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)46)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)42502), BGl_proc2384z00zz__libuv_typesz00, BGl_proc2383z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2382z00zz__libuv_typesz00, BFALSE, BgL_arg1952z00_622, BgL_arg1953z00_623); } 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_arg1963z00_649;obj_t BgL_arg1964z00_650;
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_v1321z00_669;
BgL_v1321z00_669 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_arg1971z00_670;
BgL_arg1971z00_670 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2386z00zz__libuv_typesz00, BGl_proc2385z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1321z00_669,((long)0),BgL_arg1971z00_670); } 
BgL_arg1963z00_649 = BgL_v1321z00_669; } 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_v1322z00_680;
BgL_v1322z00_680 = 
create_vector(((long)0)); 
BgL_arg1964z00_650 = BgL_v1322z00_680; } 
BGl_UvPollz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)47)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)5964), BGl_proc2389z00zz__libuv_typesz00, BGl_proc2388z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2387z00zz__libuv_typesz00, BFALSE, BgL_arg1963z00_649, BgL_arg1964z00_650); } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg1979z00_687;obj_t BgL_arg1980z00_688;
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_v1323z00_700;
BgL_v1323z00_700 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg1986z00_701;
BgL_arg1986z00_701 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc2391z00zz__libuv_typesz00, BGl_proc2390z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1323z00_700,((long)0),BgL_arg1986z00_701); } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_arg1991z00_711;
BgL_arg1991z00_711 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc2393z00zz__libuv_typesz00, BGl_proc2392z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)49))); 
VECTOR_SET(BgL_v1323z00_700,((long)1),BgL_arg1991z00_711); } 
BgL_arg1979z00_687 = BgL_v1323z00_700; } 
{ /* Llib/uvtypes.scm 71 */
obj_t BgL_v1324z00_721;
BgL_v1324z00_721 = 
create_vector(((long)0)); 
BgL_arg1980z00_688 = BgL_v1324z00_721; } 
BGl_UvFilez00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)50)), 
CNST_TABLE_REF(((long)8)), BGl_objectz00zz__objectz00, ((long)50244), BGl_proc2396z00zz__libuv_typesz00, BGl_proc2395z00zz__libuv_typesz00, BFALSE, BGl_proc2394z00zz__libuv_typesz00, BFALSE, BgL_arg1979z00_687, BgL_arg1980z00_688); } 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_arg1999z00_728;obj_t BgL_arg2000z00_729;
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_v1325z00_747;
BgL_v1325z00_747 = 
create_vector(((long)0)); 
BgL_arg1999z00_728 = BgL_v1325z00_747; } 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_v1326z00_748;
BgL_v1326z00_748 = 
create_vector(((long)0)); 
BgL_arg2000z00_729 = BgL_v1326z00_748; } 
BGl_UvFsEventz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)51)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)49445), BGl_proc2399z00zz__libuv_typesz00, BGl_proc2398z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2397z00zz__libuv_typesz00, BFALSE, BgL_arg1999z00_728, BgL_arg2000z00_729); } 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_arg2010z00_755;obj_t BgL_arg2011z00_756;
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_v1327z00_774;
BgL_v1327z00_774 = 
create_vector(((long)0)); 
BgL_arg2010z00_755 = BgL_v1327z00_774; } 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_v1328z00_775;
BgL_v1328z00_775 = 
create_vector(((long)0)); 
BgL_arg2011z00_756 = BgL_v1328z00_775; } 
BGl_UvFsPollz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)52)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)33289), BGl_proc2402z00zz__libuv_typesz00, BGl_proc2401z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2400z00zz__libuv_typesz00, BFALSE, BgL_arg2010z00_755, BgL_arg2011z00_756); } 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_arg2021z00_782;obj_t BgL_arg2022z00_783;
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_v1329z00_801;
BgL_v1329z00_801 = 
create_vector(((long)0)); 
BgL_arg2021z00_782 = BgL_v1329z00_801; } 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_v1330z00_802;
BgL_v1330z00_802 = 
create_vector(((long)0)); 
BgL_arg2022z00_783 = BgL_v1330z00_802; } 
BGl_UvCheckz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)53)), 
CNST_TABLE_REF(((long)8)), BGl_UvWatcherz00zz__libuv_typesz00, ((long)52454), BGl_proc2405z00zz__libuv_typesz00, BGl_proc2404z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2403z00zz__libuv_typesz00, BFALSE, BgL_arg2021z00_782, BgL_arg2022z00_783); } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2032z00_809;obj_t BgL_arg2033z00_810;
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_v1331z00_827;
BgL_v1331z00_827 = 
create_vector(((long)2)); 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2040z00_828;
BgL_arg2040z00_828 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc2408z00zz__libuv_typesz00, BGl_proc2407z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2406z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1331z00_827,((long)0),BgL_arg2040z00_828); } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_arg2047z00_841;
BgL_arg2047z00_841 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc2410z00zz__libuv_typesz00, BGl_proc2409z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)38))); 
VECTOR_SET(BgL_v1331z00_827,((long)1),BgL_arg2047z00_841); } 
BgL_arg2032z00_809 = BgL_v1331z00_827; } 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_v1332z00_851;
BgL_v1332z00_851 = 
create_vector(((long)1)); 
{ /* Llib/uvtypes.scm 85 */
obj_t BgL_arg2052z00_852;
{ /* Llib/uvtypes.scm 85 */
obj_t BgL_arg2053z00_853;
BgL_arg2053z00_853 = 
MAKE_YOUNG_PAIR(BGl_proc2411z00zz__libuv_typesz00, BFALSE); 
BgL_arg2052z00_852 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg2053z00_853); } 
VECTOR_SET(BgL_v1332z00_851,((long)0),BgL_arg2052z00_852); } 
BgL_arg2033z00_810 = BgL_v1332z00_851; } 
BGl_UvProcessz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)56)), 
CNST_TABLE_REF(((long)8)), BGl_UvHandlez00zz__libuv_typesz00, ((long)11543), BGl_proc2414z00zz__libuv_typesz00, BGl_proc2413z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2412z00zz__libuv_typesz00, BFALSE, BgL_arg2032z00_809, BgL_arg2033z00_810); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2062z00_871;obj_t BgL_arg2063z00_872;
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_v1333z00_884;
BgL_v1333z00_884 = 
create_vector(((long)8)); 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2070z00_885;
BgL_arg2070z00_885 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2417z00zz__libuv_typesz00, BGl_proc2416z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc2415z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)57))); 
VECTOR_SET(BgL_v1333z00_884,((long)0),BgL_arg2070z00_885); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2077z00_898;
BgL_arg2077z00_898 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc2419z00zz__libuv_typesz00, BGl_proc2418z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)1),BgL_arg2077z00_898); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2082z00_908;
BgL_arg2082z00_908 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc2421z00zz__libuv_typesz00, BGl_proc2420z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)2),BgL_arg2082z00_908); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2087z00_918;
BgL_arg2087z00_918 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc2423z00zz__libuv_typesz00, BGl_proc2422z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)3),BgL_arg2087z00_918); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2092z00_928;
BgL_arg2092z00_928 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc2425z00zz__libuv_typesz00, BGl_proc2424z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)4),BgL_arg2092z00_928); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2097z00_938;
BgL_arg2097z00_938 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)62)), BGl_proc2427z00zz__libuv_typesz00, BGl_proc2426z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)5),BgL_arg2097z00_938); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2102z00_948;
BgL_arg2102z00_948 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc2429z00zz__libuv_typesz00, BGl_proc2428z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)6),BgL_arg2102z00_948); } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_arg2107z00_958;
BgL_arg2107z00_958 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc2431z00zz__libuv_typesz00, BGl_proc2430z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)1), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)12))); 
VECTOR_SET(BgL_v1333z00_884,((long)7),BgL_arg2107z00_958); } 
BgL_arg2062z00_871 = BgL_v1333z00_884; } 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_v1334z00_968;
BgL_v1334z00_968 = 
create_vector(((long)7)); 
{ /* Llib/uvtypes.scm 94 */
obj_t BgL_arg2112z00_969;
{ /* Llib/uvtypes.scm 94 */
obj_t BgL_arg2113z00_970;
BgL_arg2113z00_970 = 
MAKE_YOUNG_PAIR(BGl_proc2432z00zz__libuv_typesz00, BGl_proc2433z00zz__libuv_typesz00); 
BgL_arg2112z00_969 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BgL_arg2113z00_970); } 
VECTOR_SET(BgL_v1334z00_968,((long)0),BgL_arg2112z00_969); } 
{ /* Llib/uvtypes.scm 102 */
obj_t BgL_arg2122z00_993;
{ /* Llib/uvtypes.scm 102 */
obj_t BgL_arg2123z00_994;
BgL_arg2123z00_994 = 
MAKE_YOUNG_PAIR(BGl_proc2434z00zz__libuv_typesz00, BGl_proc2435z00zz__libuv_typesz00); 
BgL_arg2122z00_993 = 
MAKE_YOUNG_PAIR(
BINT(((long)1)), BgL_arg2123z00_994); } 
VECTOR_SET(BgL_v1334z00_968,((long)1),BgL_arg2122z00_993); } 
{ /* Llib/uvtypes.scm 110 */
obj_t BgL_arg2132z00_1017;
{ /* Llib/uvtypes.scm 110 */
obj_t BgL_arg2133z00_1018;
BgL_arg2133z00_1018 = 
MAKE_YOUNG_PAIR(BGl_proc2436z00zz__libuv_typesz00, BGl_proc2437z00zz__libuv_typesz00); 
BgL_arg2132z00_1017 = 
MAKE_YOUNG_PAIR(
BINT(((long)2)), BgL_arg2133z00_1018); } 
VECTOR_SET(BgL_v1334z00_968,((long)2),BgL_arg2132z00_1017); } 
{ /* Llib/uvtypes.scm 118 */
obj_t BgL_arg2142z00_1041;
{ /* Llib/uvtypes.scm 118 */
obj_t BgL_arg2143z00_1042;
BgL_arg2143z00_1042 = 
MAKE_YOUNG_PAIR(BGl_proc2438z00zz__libuv_typesz00, BGl_proc2439z00zz__libuv_typesz00); 
BgL_arg2142z00_1041 = 
MAKE_YOUNG_PAIR(
BINT(((long)3)), BgL_arg2143z00_1042); } 
VECTOR_SET(BgL_v1334z00_968,((long)3),BgL_arg2142z00_1041); } 
{ /* Llib/uvtypes.scm 126 */
obj_t BgL_arg2152z00_1065;
{ /* Llib/uvtypes.scm 126 */
obj_t BgL_arg2153z00_1066;
BgL_arg2153z00_1066 = 
MAKE_YOUNG_PAIR(BGl_proc2440z00zz__libuv_typesz00, BGl_proc2441z00zz__libuv_typesz00); 
BgL_arg2152z00_1065 = 
MAKE_YOUNG_PAIR(
BINT(((long)4)), BgL_arg2153z00_1066); } 
VECTOR_SET(BgL_v1334z00_968,((long)4),BgL_arg2152z00_1065); } 
{ /* Llib/uvtypes.scm 134 */
obj_t BgL_arg2162z00_1089;
{ /* Llib/uvtypes.scm 134 */
obj_t BgL_arg2163z00_1090;
BgL_arg2163z00_1090 = 
MAKE_YOUNG_PAIR(BGl_proc2442z00zz__libuv_typesz00, BGl_proc2443z00zz__libuv_typesz00); 
BgL_arg2162z00_1089 = 
MAKE_YOUNG_PAIR(
BINT(((long)5)), BgL_arg2163z00_1090); } 
VECTOR_SET(BgL_v1334z00_968,((long)5),BgL_arg2162z00_1089); } 
{ /* Llib/uvtypes.scm 142 */
obj_t BgL_arg2172z00_1113;
{ /* Llib/uvtypes.scm 142 */
obj_t BgL_arg2173z00_1114;
BgL_arg2173z00_1114 = 
MAKE_YOUNG_PAIR(BGl_proc2444z00zz__libuv_typesz00, BGl_proc2445z00zz__libuv_typesz00); 
BgL_arg2172z00_1113 = 
MAKE_YOUNG_PAIR(
BINT(((long)6)), BgL_arg2173z00_1114); } 
VECTOR_SET(BgL_v1334z00_968,((long)6),BgL_arg2172z00_1113); } 
BgL_arg2063z00_872 = BgL_v1334z00_968; } 
BGl_UvProcessOptionsz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)65)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)33914), BGl_proc2448z00zz__libuv_typesz00, BGl_proc2447z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2446z00zz__libuv_typesz00, BFALSE, BgL_arg2062z00_871, BgL_arg2063z00_872); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2185z00_1143;obj_t BgL_arg2186z00_1144;
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_v1335z00_1158;
BgL_v1335z00_1158 = 
create_vector(((long)3)); 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2193z00_1159;
BgL_arg2193z00_1159 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc2451z00zz__libuv_typesz00, BGl_proc2450z00zz__libuv_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2449z00zz__libuv_typesz00, 
CNST_TABLE_REF(((long)66))); 
VECTOR_SET(BgL_v1335z00_1158,((long)0),BgL_arg2193z00_1159); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2200z00_1172;
BgL_arg2200z00_1172 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc2453z00zz__libuv_typesz00, BGl_proc2452z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1335z00_1158,((long)1),BgL_arg2200z00_1172); } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_arg2205z00_1182;
BgL_arg2205z00_1182 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)68)), BGl_proc2455z00zz__libuv_typesz00, BGl_proc2454z00zz__libuv_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1335z00_1158,((long)2),BgL_arg2205z00_1182); } 
BgL_arg2185z00_1143 = BgL_v1335z00_1158; } 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_v1336z00_1192;
BgL_v1336z00_1192 = 
create_vector(((long)0)); 
BgL_arg2186z00_1144 = BgL_v1336z00_1192; } 
return ( 
BGl_UvWorkz00zz__libuv_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)69)), 
CNST_TABLE_REF(((long)8)), BGl_z52Uvz52zz__libuv_typesz00, ((long)37711), BGl_proc2458z00zz__libuv_typesz00, BGl_proc2457z00zz__libuv_typesz00, BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2456z00zz__libuv_typesz00, BFALSE, BgL_arg2185z00_1143, BgL_arg2186z00_1144), BUNSPEC) ;} } 

}



/* &<@anonymous:2192> */
obj_t BGl_z62zc3z04anonymousza32192ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1901, obj_t BgL_new1239z00_1902)
{
{ /* Llib/uvtypes.scm 149 */
{ 
BgL_uvworkz00_bglt BgL_auxz00_3223;
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1239z00_1902)))->BgL_z42builtinz42)=((uv_work_t *)
0L),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1239z00_1902)))->BgL_z52workzd2cbz80)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_new1239z00_1902)))->BgL_z52afterzd2cbz80)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3223 = 
((BgL_uvworkz00_bglt)BgL_new1239z00_1902); 
return 
((obj_t)BgL_auxz00_3223);} } 

}



/* &lambda2190 */
BgL_uvworkz00_bglt BGl_z62lambda2190z62zz__libuv_typesz00(obj_t BgL_envz00_1903)
{
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1238z00_2379;
BgL_new1238z00_2379 = 
((BgL_uvworkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvworkz00_bgl) ))); 
{ /* Llib/uvtypes.scm 149 */
long BgL_arg2191z00_2380;
{ /* Llib/uvtypes.scm 149 */
long BgL_res2272z00_2381;
BgL_res2272z00_2381 = 
BGL_CLASS_INDEX(BGl_UvWorkz00zz__libuv_typesz00); 
BgL_arg2191z00_2380 = BgL_res2272z00_2381; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1238z00_2379), BgL_arg2191z00_2380); } 
return BgL_new1238z00_2379;} } 

}



/* &lambda2187 */
BgL_uvworkz00_bglt BGl_z62lambda2187z62zz__libuv_typesz00(obj_t BgL_envz00_1904, obj_t BgL_z42builtin1235z42_1905, obj_t BgL_z52workzd2cb1236z80_1906, obj_t BgL_z52afterzd2cb1237z80_1907)
{
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
uv_work_t * BgL_z42builtin1235z42_2382;
BgL_z42builtin1235z42_2382 = 
FOREIGN_TO_COBJ(BgL_z42builtin1235z42_1905); 
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1296z00_2385;
{ /* Llib/uvtypes.scm 149 */
BgL_uvworkz00_bglt BgL_new1295z00_2386;
BgL_new1295z00_2386 = 
((BgL_uvworkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvworkz00_bgl) ))); 
{ /* Llib/uvtypes.scm 149 */
long BgL_arg2189z00_2387;
{ /* Llib/uvtypes.scm 149 */
long BgL_res2271z00_2388;
BgL_res2271z00_2388 = 
BGL_CLASS_INDEX(BGl_UvWorkz00zz__libuv_typesz00); 
BgL_arg2189z00_2387 = BgL_res2271z00_2388; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1295z00_2386), BgL_arg2189z00_2387); } 
BgL_new1296z00_2385 = BgL_new1295z00_2386; } 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1296z00_2385))->BgL_z42builtinz42)=((uv_work_t *)BgL_z42builtin1235z42_2382),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1296z00_2385))->BgL_z52workzd2cbz80)=((obj_t)
((obj_t)BgL_z52workzd2cb1236z80_1906)),BUNSPEC); 
((((BgL_uvworkz00_bglt)COBJECT(BgL_new1296z00_2385))->BgL_z52afterzd2cbz80)=((obj_t)
((obj_t)BgL_z52afterzd2cb1237z80_1907)),BUNSPEC); 
{ /* Llib/uvtypes.scm 149 */
obj_t BgL_fun2188z00_2389;
BgL_fun2188z00_2389 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvWorkz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2188z00_2389)(BgL_fun2188z00_2389, 
((obj_t)BgL_new1296z00_2385), BEOA); } 
return BgL_new1296z00_2385;} } } 

}



/* &lambda2209 */
obj_t BGl_z62lambda2209z62zz__libuv_typesz00(obj_t BgL_envz00_1908, obj_t BgL_oz00_1909, obj_t BgL_vz00_1910)
{
{ /* Llib/uvtypes.scm 149 */
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1909)))->BgL_z52afterzd2cbz80)=((obj_t)
((obj_t)BgL_vz00_1910)),BUNSPEC);} 

}



/* &lambda2208 */
obj_t BGl_z62lambda2208z62zz__libuv_typesz00(obj_t BgL_envz00_1911, obj_t BgL_oz00_1912)
{
{ /* Llib/uvtypes.scm 149 */
return 
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1912)))->BgL_z52afterzd2cbz80);} 

}



/* &lambda2204 */
obj_t BGl_z62lambda2204z62zz__libuv_typesz00(obj_t BgL_envz00_1913, obj_t BgL_oz00_1914, obj_t BgL_vz00_1915)
{
{ /* Llib/uvtypes.scm 149 */
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1914)))->BgL_z52workzd2cbz80)=((obj_t)
((obj_t)BgL_vz00_1915)),BUNSPEC);} 

}



/* &lambda2203 */
obj_t BGl_z62lambda2203z62zz__libuv_typesz00(obj_t BgL_envz00_1916, obj_t BgL_oz00_1917)
{
{ /* Llib/uvtypes.scm 149 */
return 
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1917)))->BgL_z52workzd2cbz80);} 

}



/* &<@anonymous:2199> */
obj_t BGl_z62zc3z04anonymousza32199ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1918)
{
{ /* Llib/uvtypes.scm 149 */
return 
void_star_to_obj(0L);} 

}



/* &lambda2198 */
obj_t BGl_z62lambda2198z62zz__libuv_typesz00(obj_t BgL_envz00_1919, obj_t BgL_oz00_1920, obj_t BgL_vz00_1921)
{
{ /* Llib/uvtypes.scm 149 */
{ /* Llib/uvtypes.scm 149 */
uv_work_t * BgL_vz00_2397;
BgL_vz00_2397 = 
FOREIGN_TO_COBJ(BgL_vz00_1921); 
return 
((((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1920)))->BgL_z42builtinz42)=((uv_work_t *)BgL_vz00_2397),BUNSPEC);} } 

}



/* &lambda2197 */
obj_t BGl_z62lambda2197z62zz__libuv_typesz00(obj_t BgL_envz00_1922, obj_t BgL_oz00_1923)
{
{ /* Llib/uvtypes.scm 149 */
return 
void_star_to_obj(
(((BgL_uvworkz00_bglt)COBJECT(
((BgL_uvworkz00_bglt)BgL_oz00_1923)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:2069> */
obj_t BGl_z62zc3z04anonymousza32069ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1924, obj_t BgL_new1233z00_1925)
{
{ /* Llib/uvtypes.scm 89 */
{ 
BgL_uvprocessoptionsz00_bglt BgL_auxz00_3270;
((((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_new1233z00_1925)))->BgL_z42builtinz42)=((uv_process_options_t *)
0L),BUNSPEC); 
BgL_auxz00_3270 = 
((BgL_uvprocessoptionsz00_bglt)BgL_new1233z00_1925); 
return 
((obj_t)BgL_auxz00_3270);} } 

}



/* &lambda2067 */
BgL_uvprocessoptionsz00_bglt BGl_z62lambda2067z62zz__libuv_typesz00(obj_t BgL_envz00_1926)
{
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1232z00_2400;
BgL_new1232z00_2400 = 
((BgL_uvprocessoptionsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessoptionsz00_bgl) ))); 
{ /* Llib/uvtypes.scm 89 */
long BgL_arg2068z00_2401;
{ /* Llib/uvtypes.scm 89 */
long BgL_res2270z00_2402;
BgL_res2270z00_2402 = 
BGL_CLASS_INDEX(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
BgL_arg2068z00_2401 = BgL_res2270z00_2402; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1232z00_2400), BgL_arg2068z00_2401); } 
return BgL_new1232z00_2400;} } 

}



/* &lambda2064 */
BgL_uvprocessoptionsz00_bglt BGl_z62lambda2064z62zz__libuv_typesz00(obj_t BgL_envz00_1927, obj_t BgL_z42builtin1231z42_1928)
{
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
uv_process_options_t * BgL_z42builtin1231z42_2403;
BgL_z42builtin1231z42_2403 = 
FOREIGN_TO_COBJ(BgL_z42builtin1231z42_1928); 
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1280z00_2404;
{ /* Llib/uvtypes.scm 89 */
BgL_uvprocessoptionsz00_bglt BgL_new1279z00_2405;
BgL_new1279z00_2405 = 
((BgL_uvprocessoptionsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessoptionsz00_bgl) ))); 
{ /* Llib/uvtypes.scm 89 */
long BgL_arg2066z00_2406;
{ /* Llib/uvtypes.scm 89 */
long BgL_res2269z00_2407;
BgL_res2269z00_2407 = 
BGL_CLASS_INDEX(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
BgL_arg2066z00_2406 = BgL_res2269z00_2407; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1279z00_2405), BgL_arg2066z00_2406); } 
BgL_new1280z00_2404 = BgL_new1279z00_2405; } 
((((BgL_uvprocessoptionsz00_bglt)COBJECT(BgL_new1280z00_2404))->BgL_z42builtinz42)=((uv_process_options_t *)BgL_z42builtin1231z42_2403),BUNSPEC); 
{ /* Llib/uvtypes.scm 89 */
obj_t BgL_fun2065z00_2408;
BgL_fun2065z00_2408 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvProcessOptionsz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2065z00_2408)(BgL_fun2065z00_2408, 
((obj_t)BgL_new1280z00_2404), BEOA); } 
return BgL_new1280z00_2404;} } } 

}



/* &<@anonymous:2179> */
obj_t BGl_z62zc3z04anonymousza32179ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1929, obj_t BgL_oz00_1930, obj_t BgL_vz00_1931)
{
{ /* Llib/uvtypes.scm 140 */
{ /* Llib/uvtypes.scm 146 */
uv_process_options_t * BgL_arg2180z00_2409;
BgL_arg2180z00_2409 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1930)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 146 */
int BgL_tmpz00_3294;
BgL_tmpz00_3294 = 
CINT(BgL_vz00_1931); 
BGL_UV_PROCESS_OPTIONS_GID_SET(BgL_arg2180z00_2409, BgL_tmpz00_3294); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2176> */
obj_t BGl_z62zc3z04anonymousza32176ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1932, obj_t BgL_oz00_1933)
{
{ /* Llib/uvtypes.scm 140 */
{ /* Llib/uvtypes.scm 142 */
int BgL_tmpz00_3297;
{ /* Llib/uvtypes.scm 143 */
uv_process_options_t * BgL_arg2177z00_2410;
BgL_arg2177z00_2410 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1933)))->BgL_z42builtinz42); 
BgL_tmpz00_3297 = 
BGL_UV_PROCESS_OPTIONS_GID_GET(BgL_arg2177z00_2410); } 
return 
BINT(BgL_tmpz00_3297);} } 

}



/* &<@anonymous:2169> */
obj_t BGl_z62zc3z04anonymousza32169ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1934, obj_t BgL_oz00_1935, obj_t BgL_vz00_1936)
{
{ /* Llib/uvtypes.scm 132 */
{ /* Llib/uvtypes.scm 138 */
uv_process_options_t * BgL_arg2170z00_2411;
BgL_arg2170z00_2411 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1935)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 138 */
int BgL_tmpz00_3304;
BgL_tmpz00_3304 = 
CINT(BgL_vz00_1936); 
BGL_UV_PROCESS_OPTIONS_UID_SET(BgL_arg2170z00_2411, BgL_tmpz00_3304); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2166> */
obj_t BGl_z62zc3z04anonymousza32166ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1937, obj_t BgL_oz00_1938)
{
{ /* Llib/uvtypes.scm 132 */
{ /* Llib/uvtypes.scm 134 */
int BgL_tmpz00_3307;
{ /* Llib/uvtypes.scm 135 */
uv_process_options_t * BgL_arg2167z00_2412;
BgL_arg2167z00_2412 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1938)))->BgL_z42builtinz42); 
BgL_tmpz00_3307 = 
BGL_UV_PROCESS_OPTIONS_UID_GET(BgL_arg2167z00_2412); } 
return 
BINT(BgL_tmpz00_3307);} } 

}



/* &<@anonymous:2159> */
obj_t BGl_z62zc3z04anonymousza32159ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1939, obj_t BgL_oz00_1940, obj_t BgL_vz00_1941)
{
{ /* Llib/uvtypes.scm 124 */
{ /* Llib/uvtypes.scm 130 */
uv_process_options_t * BgL_arg2160z00_2413;
BgL_arg2160z00_2413 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1940)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 130 */
int BgL_tmpz00_3314;
BgL_tmpz00_3314 = 
CINT(BgL_vz00_1941); 
BGL_UV_PROCESS_OPTIONS_FLAGS_SET(BgL_arg2160z00_2413, BgL_tmpz00_3314); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2156> */
obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1942, obj_t BgL_oz00_1943)
{
{ /* Llib/uvtypes.scm 124 */
{ /* Llib/uvtypes.scm 126 */
int BgL_tmpz00_3317;
{ /* Llib/uvtypes.scm 127 */
uv_process_options_t * BgL_arg2157z00_2414;
BgL_arg2157z00_2414 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1943)))->BgL_z42builtinz42); 
BgL_tmpz00_3317 = 
BGL_UV_PROCESS_OPTIONS_FLAGS_GET(BgL_arg2157z00_2414); } 
return 
BINT(BgL_tmpz00_3317);} } 

}



/* &<@anonymous:2149> */
obj_t BGl_z62zc3z04anonymousza32149ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1944, obj_t BgL_oz00_1945, obj_t BgL_vz00_1946)
{
{ /* Llib/uvtypes.scm 116 */
{ /* Llib/uvtypes.scm 122 */
uv_process_options_t * BgL_arg2150z00_2415;
BgL_arg2150z00_2415 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1945)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 122 */
char * BgL_tmpz00_3324;
BgL_tmpz00_3324 = 
BSTRING_TO_STRING(BgL_vz00_1946); 
BGL_UV_PROCESS_OPTIONS_CWD_SET(BgL_arg2150z00_2415, BgL_tmpz00_3324); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2146> */
obj_t BGl_z62zc3z04anonymousza32146ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1947, obj_t BgL_oz00_1948)
{
{ /* Llib/uvtypes.scm 116 */
{ /* Llib/uvtypes.scm 118 */
char * BgL_tmpz00_3327;
{ /* Llib/uvtypes.scm 119 */
uv_process_options_t * BgL_arg2147z00_2416;
BgL_arg2147z00_2416 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1948)))->BgL_z42builtinz42); 
BgL_tmpz00_3327 = 
BGL_UV_PROCESS_OPTIONS_CWD_GET(BgL_arg2147z00_2416); } 
return 
string_to_bstring(BgL_tmpz00_3327);} } 

}



/* &<@anonymous:2139> */
obj_t BGl_z62zc3z04anonymousza32139ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1949, obj_t BgL_oz00_1950, obj_t BgL_vz00_1951)
{
{ /* Llib/uvtypes.scm 108 */
{ /* Llib/uvtypes.scm 114 */
uv_process_options_t * BgL_arg2140z00_2417;
BgL_arg2140z00_2417 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1950)))->BgL_z42builtinz42); 
bgl_uv_process_options_env_set(BgL_arg2140z00_2417, BgL_vz00_1951); BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2136> */
obj_t BGl_z62zc3z04anonymousza32136ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1952, obj_t BgL_oz00_1953)
{
{ /* Llib/uvtypes.scm 108 */
{ /* Llib/uvtypes.scm 111 */
uv_process_options_t * BgL_arg2137z00_2418;
BgL_arg2137z00_2418 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1953)))->BgL_z42builtinz42); 
return 
bgl_uv_process_options_env_get(BgL_arg2137z00_2418);} } 

}



/* &<@anonymous:2129> */
obj_t BGl_z62zc3z04anonymousza32129ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1954, obj_t BgL_oz00_1955, obj_t BgL_vz00_1956)
{
{ /* Llib/uvtypes.scm 100 */
{ /* Llib/uvtypes.scm 106 */
uv_process_options_t * BgL_arg2130z00_2419;
BgL_arg2130z00_2419 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1955)))->BgL_z42builtinz42); 
bgl_uv_process_options_args_set(BgL_arg2130z00_2419, BgL_vz00_1956); BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2126> */
obj_t BGl_z62zc3z04anonymousza32126ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1957, obj_t BgL_oz00_1958)
{
{ /* Llib/uvtypes.scm 100 */
{ /* Llib/uvtypes.scm 103 */
uv_process_options_t * BgL_arg2127z00_2420;
BgL_arg2127z00_2420 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1958)))->BgL_z42builtinz42); 
return 
bgl_uv_process_options_args_get(BgL_arg2127z00_2420);} } 

}



/* &<@anonymous:2119> */
obj_t BGl_z62zc3z04anonymousza32119ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1959, obj_t BgL_oz00_1960, obj_t BgL_vz00_1961)
{
{ /* Llib/uvtypes.scm 92 */
{ /* Llib/uvtypes.scm 98 */
uv_process_options_t * BgL_arg2120z00_2421;
BgL_arg2120z00_2421 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1960)))->BgL_z42builtinz42); 
{ /* Llib/uvtypes.scm 98 */
char * BgL_tmpz00_3346;
BgL_tmpz00_3346 = 
BSTRING_TO_STRING(BgL_vz00_1961); 
BGL_UV_PROCESS_OPTIONS_FILE_SET(BgL_arg2120z00_2421, BgL_tmpz00_3346); } BUNSPEC; } 
return BUNSPEC;} 

}



/* &<@anonymous:2116> */
obj_t BGl_z62zc3z04anonymousza32116ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1962, obj_t BgL_oz00_1963)
{
{ /* Llib/uvtypes.scm 92 */
{ /* Llib/uvtypes.scm 94 */
char * BgL_tmpz00_3349;
{ /* Llib/uvtypes.scm 95 */
uv_process_options_t * BgL_arg2117z00_2422;
BgL_arg2117z00_2422 = 
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_1963)))->BgL_z42builtinz42); 
BgL_tmpz00_3349 = 
BGL_UV_PROCESS_OPTIONS_FILE_GET(BgL_arg2117z00_2422); } 
return 
string_to_bstring(BgL_tmpz00_3349);} } 

}



/* &<@anonymous:2111> */
obj_t BGl_z62zc3z04anonymousza32111ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1964, obj_t BgL_oz00_1965, obj_t BgL_vz00_1966)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1965), 
(int)(((long)6)), BgL_vz00_1966);} 

}



/* &<@anonymous:2110> */
obj_t BGl_z62zc3z04anonymousza32110ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1967, obj_t BgL_oz00_1968)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1968), 
(int)(((long)6)));} 

}



/* &<@anonymous:2106> */
obj_t BGl_z62zc3z04anonymousza32106ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1969, obj_t BgL_oz00_1970, obj_t BgL_vz00_1971)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1970), 
(int)(((long)5)), BgL_vz00_1971);} 

}



/* &<@anonymous:2105> */
obj_t BGl_z62zc3z04anonymousza32105ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1972, obj_t BgL_oz00_1973)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1973), 
(int)(((long)5)));} 

}



/* &<@anonymous:2101> */
obj_t BGl_z62zc3z04anonymousza32101ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1974, obj_t BgL_oz00_1975, obj_t BgL_vz00_1976)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1975), 
(int)(((long)4)), BgL_vz00_1976);} 

}



/* &<@anonymous:2100> */
obj_t BGl_z62zc3z04anonymousza32100ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1977, obj_t BgL_oz00_1978)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1978), 
(int)(((long)4)));} 

}



/* &<@anonymous:2096> */
obj_t BGl_z62zc3z04anonymousza32096ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1979, obj_t BgL_oz00_1980, obj_t BgL_vz00_1981)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1980), 
(int)(((long)3)), BgL_vz00_1981);} 

}



/* &<@anonymous:2095> */
obj_t BGl_z62zc3z04anonymousza32095ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1982, obj_t BgL_oz00_1983)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1983), 
(int)(((long)3)));} 

}



/* &<@anonymous:2091> */
obj_t BGl_z62zc3z04anonymousza32091ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1984, obj_t BgL_oz00_1985, obj_t BgL_vz00_1986)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1985), 
(int)(((long)2)), BgL_vz00_1986);} 

}



/* &<@anonymous:2090> */
obj_t BGl_z62zc3z04anonymousza32090ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1987, obj_t BgL_oz00_1988)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1988), 
(int)(((long)2)));} 

}



/* &<@anonymous:2086> */
obj_t BGl_z62zc3z04anonymousza32086ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1989, obj_t BgL_oz00_1990, obj_t BgL_vz00_1991)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1990), 
(int)(((long)1)), BgL_vz00_1991);} 

}



/* &<@anonymous:2085> */
obj_t BGl_z62zc3z04anonymousza32085ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1992, obj_t BgL_oz00_1993)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1993), 
(int)(((long)1)));} 

}



/* &<@anonymous:2081> */
obj_t BGl_z62zc3z04anonymousza32081ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1994, obj_t BgL_oz00_1995, obj_t BgL_vz00_1996)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1995), 
(int)(((long)0)), BgL_vz00_1996);} 

}



/* &<@anonymous:2080> */
obj_t BGl_z62zc3z04anonymousza32080ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1997, obj_t BgL_oz00_1998)
{
{ /* Llib/uvtypes.scm 89 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_1998), 
(int)(((long)0)));} 

}



/* &<@anonymous:2076> */
obj_t BGl_z62zc3z04anonymousza32076ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_1999)
{
{ /* Llib/uvtypes.scm 89 */
return 
void_star_to_obj(
((uv_process_options_t *)GC_MALLOC( sizeof( uv_process_options_t ) )));} 

}



/* &lambda2075 */
obj_t BGl_z62lambda2075z62zz__libuv_typesz00(obj_t BgL_envz00_2000, obj_t BgL_oz00_2001, obj_t BgL_vz00_2002)
{
{ /* Llib/uvtypes.scm 89 */
{ /* Llib/uvtypes.scm 89 */
uv_process_options_t * BgL_vz00_2424;
BgL_vz00_2424 = 
FOREIGN_TO_COBJ(BgL_vz00_2002); 
return 
((((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_2001)))->BgL_z42builtinz42)=((uv_process_options_t *)BgL_vz00_2424),BUNSPEC);} } 

}



/* &lambda2074 */
obj_t BGl_z62lambda2074z62zz__libuv_typesz00(obj_t BgL_envz00_2003, obj_t BgL_oz00_2004)
{
{ /* Llib/uvtypes.scm 89 */
return 
void_star_to_obj(
(((BgL_uvprocessoptionsz00_bglt)COBJECT(
((BgL_uvprocessoptionsz00_bglt)BgL_oz00_2004)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:2039> */
obj_t BGl_z62zc3z04anonymousza32039ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2005, obj_t BgL_new1229z00_2006)
{
{ /* Llib/uvtypes.scm 81 */
{ 
BgL_uvprocessz00_bglt BgL_auxz00_3404;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2006))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2006))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2006))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2006))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_new1229z00_2006))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_new1229z00_2006)))->BgL_z42onexitz42)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_3404 = 
((BgL_uvprocessz00_bglt)BgL_new1229z00_2006); 
return 
((obj_t)BgL_auxz00_3404);} } 

}



/* &lambda2037 */
BgL_uvprocessz00_bglt BGl_z62lambda2037z62zz__libuv_typesz00(obj_t BgL_envz00_2007)
{
{ /* Llib/uvtypes.scm 81 */
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1228z00_2427;
BgL_new1228z00_2427 = 
((BgL_uvprocessz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessz00_bgl) ))); 
{ /* Llib/uvtypes.scm 81 */
long BgL_arg2038z00_2428;
{ /* Llib/uvtypes.scm 81 */
long BgL_res2268z00_2429;
BgL_res2268z00_2429 = 
BGL_CLASS_INDEX(BGl_UvProcessz00zz__libuv_typesz00); 
BgL_arg2038z00_2428 = BgL_res2268z00_2429; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1228z00_2427), BgL_arg2038z00_2428); } 
return BgL_new1228z00_2427;} } 

}



/* &lambda2034 */
BgL_uvprocessz00_bglt BGl_z62lambda2034z62zz__libuv_typesz00(obj_t BgL_envz00_2008, obj_t BgL_z42builtin1222z42_2009, obj_t BgL_z52onclose1223z52_2010, obj_t BgL_z52gcmarkshead1224z52_2011, obj_t BgL_z52gcmarkstail1225z52_2012, obj_t BgL_closed1226z00_2013, obj_t BgL_z42onexit1227z42_2014)
{
{ /* Llib/uvtypes.scm 81 */
{ /* Llib/uvtypes.scm 81 */
uv_handle_t * BgL_z42builtin1222z42_2430;bool_t BgL_closed1226z00_2433;
BgL_z42builtin1222z42_2430 = 
FOREIGN_TO_COBJ(BgL_z42builtin1222z42_2009); 
BgL_closed1226z00_2433 = 
CBOOL(BgL_closed1226z00_2013); 
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1277z00_2434;
{ /* Llib/uvtypes.scm 81 */
BgL_uvprocessz00_bglt BgL_new1276z00_2435;
BgL_new1276z00_2435 = 
((BgL_uvprocessz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvprocessz00_bgl) ))); 
{ /* Llib/uvtypes.scm 81 */
long BgL_arg2036z00_2436;
{ /* Llib/uvtypes.scm 81 */
long BgL_res2267z00_2437;
BgL_res2267z00_2437 = 
BGL_CLASS_INDEX(BGl_UvProcessz00zz__libuv_typesz00); 
BgL_arg2036z00_2436 = BgL_res2267z00_2437; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1276z00_2435), BgL_arg2036z00_2436); } 
BgL_new1277z00_2434 = BgL_new1276z00_2435; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2434)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1222z42_2430),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2434)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1223z52_2010),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2434)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1224z52_2011)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2434)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1225z52_2012)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1277z00_2434)))->BgL_closedz00)=((bool_t)BgL_closed1226z00_2433),BUNSPEC); 
((((BgL_uvprocessz00_bglt)COBJECT(BgL_new1277z00_2434))->BgL_z42onexitz42)=((obj_t)BgL_z42onexit1227z42_2014),BUNSPEC); 
{ /* Llib/uvtypes.scm 81 */
obj_t BgL_fun2035z00_2438;
BgL_fun2035z00_2438 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvProcessz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2035z00_2438)(BgL_fun2035z00_2438, 
((obj_t)BgL_new1277z00_2434), BEOA); } 
return BgL_new1277z00_2434;} } } 

}



/* &<@anonymous:2055> */
obj_t BGl_z62zc3z04anonymousza32055ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2015, obj_t BgL_oz00_2016)
{
{ /* Llib/uvtypes.scm 83 */
{ /* Llib/uvtypes.scm 85 */
int BgL_tmpz00_3454;
{ /* Llib/uvtypes.scm 86 */
uv_process_t * BgL_arg2056z00_2439;
{ /* Llib/uvtypes.scm 86 */
uv_handle_t * BgL_arg2057z00_2440;
BgL_arg2057z00_2440 = 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvprocessz00_bglt)BgL_oz00_2016))))->BgL_z42builtinz42); 
BgL_arg2056z00_2439 = 
(uv_process_t *)(BgL_arg2057z00_2440); } 
BgL_tmpz00_3454 = 
(BgL_arg2056z00_2439->pid); } 
return 
BINT(BgL_tmpz00_3454);} } 

}



/* &<@anonymous:2051> */
obj_t BGl_z62zc3z04anonymousza32051ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2017, obj_t BgL_oz00_2018, obj_t BgL_vz00_2019)
{
{ /* Llib/uvtypes.scm 81 */
return 
BGl_callzd2virtualzd2setterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2018), 
(int)(((long)0)), BgL_vz00_2019);} 

}



/* &<@anonymous:2050> */
obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2020, obj_t BgL_oz00_2021)
{
{ /* Llib/uvtypes.scm 81 */
return 
BGl_callzd2virtualzd2getterz00zz__objectz00(
((BgL_objectz00_bglt)BgL_oz00_2021), 
(int)(((long)0)));} 

}



/* &<@anonymous:2046> */
obj_t BGl_z62zc3z04anonymousza32046ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2022)
{
{ /* Llib/uvtypes.scm 81 */
return BUNSPEC;} 

}



/* &lambda2045 */
obj_t BGl_z62lambda2045z62zz__libuv_typesz00(obj_t BgL_envz00_2023, obj_t BgL_oz00_2024, obj_t BgL_vz00_2025)
{
{ /* Llib/uvtypes.scm 81 */
return 
((((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_oz00_2024)))->BgL_z42onexitz42)=((obj_t)BgL_vz00_2025),BUNSPEC);} 

}



/* &lambda2044 */
obj_t BGl_z62lambda2044z62zz__libuv_typesz00(obj_t BgL_envz00_2026, obj_t BgL_oz00_2027)
{
{ /* Llib/uvtypes.scm 81 */
return 
(((BgL_uvprocessz00_bglt)COBJECT(
((BgL_uvprocessz00_bglt)BgL_oz00_2027)))->BgL_z42onexitz42);} 

}



/* &<@anonymous:2028> */
obj_t BGl_z62zc3z04anonymousza32028ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2028, obj_t BgL_new1220z00_2029)
{
{ /* Llib/uvtypes.scm 79 */
{ 
BgL_uvcheckz00_bglt BgL_auxz00_3471;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2029))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2029))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2029))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2029))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2029))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3488;
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_classz00_2444;
BgL_classz00_2444 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL__ortest_1106z00_2445;
BgL__ortest_1106z00_2445 = 
BGL_CLASS_NIL(BgL_classz00_2444); 
if(
CBOOL(BgL__ortest_1106z00_2445))
{ /* Llib/uvtypes.scm 79 */
BgL_auxz00_3488 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2445)
; }  else 
{ /* Llib/uvtypes.scm 79 */
BgL_auxz00_3488 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2444))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2029))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3488),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvcheckz00_bglt)BgL_new1220z00_2029))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3471 = 
((BgL_uvcheckz00_bglt)BgL_new1220z00_2029); 
return 
((obj_t)BgL_auxz00_3471);} } 

}



/* &lambda2026 */
BgL_uvcheckz00_bglt BGl_z62lambda2026z62zz__libuv_typesz00(obj_t BgL_envz00_2030)
{
{ /* Llib/uvtypes.scm 79 */
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1219z00_2446;
BgL_new1219z00_2446 = 
((BgL_uvcheckz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvcheckz00_bgl) ))); 
{ /* Llib/uvtypes.scm 79 */
long BgL_arg2027z00_2447;
{ /* Llib/uvtypes.scm 79 */
long BgL_res2266z00_2448;
BgL_res2266z00_2448 = 
BGL_CLASS_INDEX(BGl_UvCheckz00zz__libuv_typesz00); 
BgL_arg2027z00_2447 = BgL_res2266z00_2448; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1219z00_2446), BgL_arg2027z00_2447); } 
return BgL_new1219z00_2446;} } 

}



/* &lambda2023 */
BgL_uvcheckz00_bglt BGl_z62lambda2023z62zz__libuv_typesz00(obj_t BgL_envz00_2031, obj_t BgL_z42builtin1212z42_2032, obj_t BgL_z52onclose1213z52_2033, obj_t BgL_z52gcmarkshead1214z52_2034, obj_t BgL_z52gcmarkstail1215z52_2035, obj_t BgL_closed1216z00_2036, obj_t BgL_loop1217z00_2037, obj_t BgL_cb1218z00_2038)
{
{ /* Llib/uvtypes.scm 79 */
{ /* Llib/uvtypes.scm 79 */
uv_handle_t * BgL_z42builtin1212z42_2449;bool_t BgL_closed1216z00_2452;
BgL_z42builtin1212z42_2449 = 
FOREIGN_TO_COBJ(BgL_z42builtin1212z42_2032); 
BgL_closed1216z00_2452 = 
CBOOL(BgL_closed1216z00_2036); 
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1275z00_2455;
{ /* Llib/uvtypes.scm 79 */
BgL_uvcheckz00_bglt BgL_new1274z00_2456;
BgL_new1274z00_2456 = 
((BgL_uvcheckz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvcheckz00_bgl) ))); 
{ /* Llib/uvtypes.scm 79 */
long BgL_arg2025z00_2457;
{ /* Llib/uvtypes.scm 79 */
long BgL_res2265z00_2458;
BgL_res2265z00_2458 = 
BGL_CLASS_INDEX(BGl_UvCheckz00zz__libuv_typesz00); 
BgL_arg2025z00_2457 = BgL_res2265z00_2458; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1274z00_2456), BgL_arg2025z00_2457); } 
BgL_new1275z00_2455 = BgL_new1274z00_2456; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2455)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1212z42_2449),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2455)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1213z52_2033),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2455)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1214z52_2034)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2455)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1215z52_2035)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1275z00_2455)))->BgL_closedz00)=((bool_t)BgL_closed1216z00_2452),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1275z00_2455)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1217z00_2037)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1275z00_2455)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1218z00_2038)),BUNSPEC); 
{ /* Llib/uvtypes.scm 79 */
obj_t BgL_fun2024z00_2459;
BgL_fun2024z00_2459 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvCheckz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2024z00_2459)(BgL_fun2024z00_2459, 
((obj_t)BgL_new1275z00_2455), BEOA); } 
return BgL_new1275z00_2455;} } } 

}



/* &<@anonymous:2017> */
obj_t BGl_z62zc3z04anonymousza32017ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2039, obj_t BgL_new1210z00_2040)
{
{ /* Llib/uvtypes.scm 77 */
{ 
BgL_uvfspollz00_bglt BgL_auxz00_3537;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2040))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2040))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2040))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2040))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2040))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3554;
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_classz00_2461;
BgL_classz00_2461 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL__ortest_1106z00_2462;
BgL__ortest_1106z00_2462 = 
BGL_CLASS_NIL(BgL_classz00_2461); 
if(
CBOOL(BgL__ortest_1106z00_2462))
{ /* Llib/uvtypes.scm 77 */
BgL_auxz00_3554 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2462)
; }  else 
{ /* Llib/uvtypes.scm 77 */
BgL_auxz00_3554 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2461))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2040))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3554),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfspollz00_bglt)BgL_new1210z00_2040))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3537 = 
((BgL_uvfspollz00_bglt)BgL_new1210z00_2040); 
return 
((obj_t)BgL_auxz00_3537);} } 

}



/* &lambda2015 */
BgL_uvfspollz00_bglt BGl_z62lambda2015z62zz__libuv_typesz00(obj_t BgL_envz00_2041)
{
{ /* Llib/uvtypes.scm 77 */
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1209z00_2463;
BgL_new1209z00_2463 = 
((BgL_uvfspollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfspollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 77 */
long BgL_arg2016z00_2464;
{ /* Llib/uvtypes.scm 77 */
long BgL_res2264z00_2465;
BgL_res2264z00_2465 = 
BGL_CLASS_INDEX(BGl_UvFsPollz00zz__libuv_typesz00); 
BgL_arg2016z00_2464 = BgL_res2264z00_2465; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1209z00_2463), BgL_arg2016z00_2464); } 
return BgL_new1209z00_2463;} } 

}



/* &lambda2012 */
BgL_uvfspollz00_bglt BGl_z62lambda2012z62zz__libuv_typesz00(obj_t BgL_envz00_2042, obj_t BgL_z42builtin1202z42_2043, obj_t BgL_z52onclose1203z52_2044, obj_t BgL_z52gcmarkshead1204z52_2045, obj_t BgL_z52gcmarkstail1205z52_2046, obj_t BgL_closed1206z00_2047, obj_t BgL_loop1207z00_2048, obj_t BgL_cb1208z00_2049)
{
{ /* Llib/uvtypes.scm 77 */
{ /* Llib/uvtypes.scm 77 */
uv_handle_t * BgL_z42builtin1202z42_2466;bool_t BgL_closed1206z00_2469;
BgL_z42builtin1202z42_2466 = 
FOREIGN_TO_COBJ(BgL_z42builtin1202z42_2043); 
BgL_closed1206z00_2469 = 
CBOOL(BgL_closed1206z00_2047); 
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1273z00_2472;
{ /* Llib/uvtypes.scm 77 */
BgL_uvfspollz00_bglt BgL_new1272z00_2473;
BgL_new1272z00_2473 = 
((BgL_uvfspollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfspollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 77 */
long BgL_arg2014z00_2474;
{ /* Llib/uvtypes.scm 77 */
long BgL_res2263z00_2475;
BgL_res2263z00_2475 = 
BGL_CLASS_INDEX(BGl_UvFsPollz00zz__libuv_typesz00); 
BgL_arg2014z00_2474 = BgL_res2263z00_2475; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1272z00_2473), BgL_arg2014z00_2474); } 
BgL_new1273z00_2472 = BgL_new1272z00_2473; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2472)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1202z42_2466),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2472)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1203z52_2044),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2472)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1204z52_2045)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2472)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1205z52_2046)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1273z00_2472)))->BgL_closedz00)=((bool_t)BgL_closed1206z00_2469),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1273z00_2472)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1207z00_2048)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1273z00_2472)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1208z00_2049)),BUNSPEC); 
{ /* Llib/uvtypes.scm 77 */
obj_t BgL_fun2013z00_2476;
BgL_fun2013z00_2476 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvFsPollz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2013z00_2476)(BgL_fun2013z00_2476, 
((obj_t)BgL_new1273z00_2472), BEOA); } 
return BgL_new1273z00_2472;} } } 

}



/* &<@anonymous:2006> */
obj_t BGl_z62zc3z04anonymousza32006ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2050, obj_t BgL_new1200z00_2051)
{
{ /* Llib/uvtypes.scm 75 */
{ 
BgL_uvfseventz00_bglt BgL_auxz00_3603;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2051))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2051))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2051))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2051))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2051))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3620;
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_classz00_2478;
BgL_classz00_2478 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL__ortest_1106z00_2479;
BgL__ortest_1106z00_2479 = 
BGL_CLASS_NIL(BgL_classz00_2478); 
if(
CBOOL(BgL__ortest_1106z00_2479))
{ /* Llib/uvtypes.scm 75 */
BgL_auxz00_3620 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2479)
; }  else 
{ /* Llib/uvtypes.scm 75 */
BgL_auxz00_3620 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2478))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2051))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3620),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvfseventz00_bglt)BgL_new1200z00_2051))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3603 = 
((BgL_uvfseventz00_bglt)BgL_new1200z00_2051); 
return 
((obj_t)BgL_auxz00_3603);} } 

}



/* &lambda2004 */
BgL_uvfseventz00_bglt BGl_z62lambda2004z62zz__libuv_typesz00(obj_t BgL_envz00_2052)
{
{ /* Llib/uvtypes.scm 75 */
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1199z00_2480;
BgL_new1199z00_2480 = 
((BgL_uvfseventz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfseventz00_bgl) ))); 
{ /* Llib/uvtypes.scm 75 */
long BgL_arg2005z00_2481;
{ /* Llib/uvtypes.scm 75 */
long BgL_res2262z00_2482;
BgL_res2262z00_2482 = 
BGL_CLASS_INDEX(BGl_UvFsEventz00zz__libuv_typesz00); 
BgL_arg2005z00_2481 = BgL_res2262z00_2482; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1199z00_2480), BgL_arg2005z00_2481); } 
return BgL_new1199z00_2480;} } 

}



/* &lambda2001 */
BgL_uvfseventz00_bglt BGl_z62lambda2001z62zz__libuv_typesz00(obj_t BgL_envz00_2053, obj_t BgL_z42builtin1192z42_2054, obj_t BgL_z52onclose1193z52_2055, obj_t BgL_z52gcmarkshead1194z52_2056, obj_t BgL_z52gcmarkstail1195z52_2057, obj_t BgL_closed1196z00_2058, obj_t BgL_loop1197z00_2059, obj_t BgL_cb1198z00_2060)
{
{ /* Llib/uvtypes.scm 75 */
{ /* Llib/uvtypes.scm 75 */
uv_handle_t * BgL_z42builtin1192z42_2483;bool_t BgL_closed1196z00_2486;
BgL_z42builtin1192z42_2483 = 
FOREIGN_TO_COBJ(BgL_z42builtin1192z42_2054); 
BgL_closed1196z00_2486 = 
CBOOL(BgL_closed1196z00_2058); 
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1271z00_2489;
{ /* Llib/uvtypes.scm 75 */
BgL_uvfseventz00_bglt BgL_new1270z00_2490;
BgL_new1270z00_2490 = 
((BgL_uvfseventz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfseventz00_bgl) ))); 
{ /* Llib/uvtypes.scm 75 */
long BgL_arg2003z00_2491;
{ /* Llib/uvtypes.scm 75 */
long BgL_res2261z00_2492;
BgL_res2261z00_2492 = 
BGL_CLASS_INDEX(BGl_UvFsEventz00zz__libuv_typesz00); 
BgL_arg2003z00_2491 = BgL_res2261z00_2492; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1270z00_2490), BgL_arg2003z00_2491); } 
BgL_new1271z00_2489 = BgL_new1270z00_2490; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2489)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1192z42_2483),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2489)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1193z52_2055),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2489)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1194z52_2056)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2489)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1195z52_2057)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1271z00_2489)))->BgL_closedz00)=((bool_t)BgL_closed1196z00_2486),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1271z00_2489)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1197z00_2059)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1271z00_2489)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1198z00_2060)),BUNSPEC); 
{ /* Llib/uvtypes.scm 75 */
obj_t BgL_fun2002z00_2493;
BgL_fun2002z00_2493 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvFsEventz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun2002z00_2493)(BgL_fun2002z00_2493, 
((obj_t)BgL_new1271z00_2489), BEOA); } 
return BgL_new1271z00_2489;} } } 

}



/* &<@anonymous:1985> */
obj_t BGl_z62zc3z04anonymousza31985ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2061, obj_t BgL_new1190z00_2062)
{
{ /* Llib/uvtypes.scm 71 */
{ 
BgL_uvfilez00_bglt BgL_auxz00_3669;
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_new1190z00_2062)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_new1190z00_2062)))->BgL_pathz00)=((obj_t)BGl_string2295z00zz__libuv_typesz00),BUNSPEC); 
BgL_auxz00_3669 = 
((BgL_uvfilez00_bglt)BgL_new1190z00_2062); 
return 
((obj_t)BgL_auxz00_3669);} } 

}



/* &lambda1983 */
BgL_uvfilez00_bglt BGl_z62lambda1983z62zz__libuv_typesz00(obj_t BgL_envz00_2063)
{
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1189z00_2495;
BgL_new1189z00_2495 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 71 */
long BgL_arg1984z00_2496;
{ /* Llib/uvtypes.scm 71 */
long BgL_res2260z00_2497;
BgL_res2260z00_2497 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BgL_arg1984z00_2496 = BgL_res2260z00_2497; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1189z00_2495), BgL_arg1984z00_2496); } 
return BgL_new1189z00_2495;} } 

}



/* &lambda1981 */
BgL_uvfilez00_bglt BGl_z62lambda1981z62zz__libuv_typesz00(obj_t BgL_envz00_2064, obj_t BgL_fd1187z00_2065, obj_t BgL_path1188z00_2066)
{
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
int BgL_fd1187z00_2498;
BgL_fd1187z00_2498 = 
CINT(BgL_fd1187z00_2065); 
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1269z00_2500;
{ /* Llib/uvtypes.scm 71 */
BgL_uvfilez00_bglt BgL_new1268z00_2501;
BgL_new1268z00_2501 = 
((BgL_uvfilez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvfilez00_bgl) ))); 
{ /* Llib/uvtypes.scm 71 */
long BgL_arg1982z00_2502;
{ /* Llib/uvtypes.scm 71 */
long BgL_res2259z00_2503;
BgL_res2259z00_2503 = 
BGL_CLASS_INDEX(BGl_UvFilez00zz__libuv_typesz00); 
BgL_arg1982z00_2502 = BgL_res2259z00_2503; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1268z00_2501), BgL_arg1982z00_2502); } 
BgL_new1269z00_2500 = BgL_new1268z00_2501; } 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1269z00_2500))->BgL_fdz00)=((int)BgL_fd1187z00_2498),BUNSPEC); 
((((BgL_uvfilez00_bglt)COBJECT(BgL_new1269z00_2500))->BgL_pathz00)=((obj_t)
((obj_t)BgL_path1188z00_2066)),BUNSPEC); 
return BgL_new1269z00_2500;} } } 

}



/* &lambda1995 */
obj_t BGl_z62lambda1995z62zz__libuv_typesz00(obj_t BgL_envz00_2067, obj_t BgL_oz00_2068, obj_t BgL_vz00_2069)
{
{ /* Llib/uvtypes.scm 71 */
return 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2068)))->BgL_pathz00)=((obj_t)
((obj_t)BgL_vz00_2069)),BUNSPEC);} 

}



/* &lambda1994 */
obj_t BGl_z62lambda1994z62zz__libuv_typesz00(obj_t BgL_envz00_2070, obj_t BgL_oz00_2071)
{
{ /* Llib/uvtypes.scm 71 */
return 
(((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2071)))->BgL_pathz00);} 

}



/* &lambda1990 */
obj_t BGl_z62lambda1990z62zz__libuv_typesz00(obj_t BgL_envz00_2072, obj_t BgL_oz00_2073, obj_t BgL_vz00_2074)
{
{ /* Llib/uvtypes.scm 71 */
{ /* Llib/uvtypes.scm 71 */
int BgL_vz00_2508;
BgL_vz00_2508 = 
CINT(BgL_vz00_2074); 
return 
((((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2073)))->BgL_fdz00)=((int)BgL_vz00_2508),BUNSPEC);} } 

}



/* &lambda1989 */
obj_t BGl_z62lambda1989z62zz__libuv_typesz00(obj_t BgL_envz00_2075, obj_t BgL_oz00_2076)
{
{ /* Llib/uvtypes.scm 71 */
return 
BINT(
(((BgL_uvfilez00_bglt)COBJECT(
((BgL_uvfilez00_bglt)BgL_oz00_2076)))->BgL_fdz00));} 

}



/* &<@anonymous:1970> */
obj_t BGl_z62zc3z04anonymousza31970ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2077, obj_t BgL_new1185z00_2078)
{
{ /* Llib/uvtypes.scm 68 */
{ 
BgL_uvpollz00_bglt BgL_auxz00_3700;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2078))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2078))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2078))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2078))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2078))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3717;
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_classz00_2511;
BgL_classz00_2511 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL__ortest_1106z00_2512;
BgL__ortest_1106z00_2512 = 
BGL_CLASS_NIL(BgL_classz00_2511); 
if(
CBOOL(BgL__ortest_1106z00_2512))
{ /* Llib/uvtypes.scm 68 */
BgL_auxz00_3717 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2512)
; }  else 
{ /* Llib/uvtypes.scm 68 */
BgL_auxz00_3717 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2511))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2078))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3717),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvpollz00_bglt)BgL_new1185z00_2078))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_new1185z00_2078)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
BgL_auxz00_3700 = 
((BgL_uvpollz00_bglt)BgL_new1185z00_2078); 
return 
((obj_t)BgL_auxz00_3700);} } 

}



/* &lambda1968 */
BgL_uvpollz00_bglt BGl_z62lambda1968z62zz__libuv_typesz00(obj_t BgL_envz00_2079)
{
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1184z00_2513;
BgL_new1184z00_2513 = 
((BgL_uvpollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 68 */
long BgL_arg1969z00_2514;
{ /* Llib/uvtypes.scm 68 */
long BgL_res2258z00_2515;
BgL_res2258z00_2515 = 
BGL_CLASS_INDEX(BGl_UvPollz00zz__libuv_typesz00); 
BgL_arg1969z00_2514 = BgL_res2258z00_2515; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1184z00_2513), BgL_arg1969z00_2514); } 
return BgL_new1184z00_2513;} } 

}



/* &lambda1965 */
BgL_uvpollz00_bglt BGl_z62lambda1965z62zz__libuv_typesz00(obj_t BgL_envz00_2080, obj_t BgL_z42builtin1176z42_2081, obj_t BgL_z52onclose1177z52_2082, obj_t BgL_z52gcmarkshead1178z52_2083, obj_t BgL_z52gcmarkstail1179z52_2084, obj_t BgL_closed1180z00_2085, obj_t BgL_loop1181z00_2086, obj_t BgL_cb1182z00_2087, obj_t BgL_fd1183z00_2088)
{
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
uv_handle_t * BgL_z42builtin1176z42_2516;bool_t BgL_closed1180z00_2519;int BgL_fd1183z00_2522;
BgL_z42builtin1176z42_2516 = 
FOREIGN_TO_COBJ(BgL_z42builtin1176z42_2081); 
BgL_closed1180z00_2519 = 
CBOOL(BgL_closed1180z00_2085); 
BgL_fd1183z00_2522 = 
CINT(BgL_fd1183z00_2088); 
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1267z00_2523;
{ /* Llib/uvtypes.scm 68 */
BgL_uvpollz00_bglt BgL_new1266z00_2524;
BgL_new1266z00_2524 = 
((BgL_uvpollz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpollz00_bgl) ))); 
{ /* Llib/uvtypes.scm 68 */
long BgL_arg1967z00_2525;
{ /* Llib/uvtypes.scm 68 */
long BgL_res2257z00_2526;
BgL_res2257z00_2526 = 
BGL_CLASS_INDEX(BGl_UvPollz00zz__libuv_typesz00); 
BgL_arg1967z00_2525 = BgL_res2257z00_2526; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1266z00_2524), BgL_arg1967z00_2525); } 
BgL_new1267z00_2523 = BgL_new1266z00_2524; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2523)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1176z42_2516),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2523)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1177z52_2082),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2523)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1178z52_2083)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2523)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1179z52_2084)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1267z00_2523)))->BgL_closedz00)=((bool_t)BgL_closed1180z00_2519),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1267z00_2523)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1181z00_2086)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1267z00_2523)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1182z00_2087)),BUNSPEC); 
((((BgL_uvpollz00_bglt)COBJECT(BgL_new1267z00_2523))->BgL_fdz00)=((int)BgL_fd1183z00_2522),BUNSPEC); 
{ /* Llib/uvtypes.scm 68 */
obj_t BgL_fun1966z00_2527;
BgL_fun1966z00_2527 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvPollz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1966z00_2527)(BgL_fun1966z00_2527, 
((obj_t)BgL_new1267z00_2523), BEOA); } 
return BgL_new1267z00_2523;} } } 

}



/* &lambda1975 */
obj_t BGl_z62lambda1975z62zz__libuv_typesz00(obj_t BgL_envz00_2089, obj_t BgL_oz00_2090, obj_t BgL_vz00_2091)
{
{ /* Llib/uvtypes.scm 68 */
{ /* Llib/uvtypes.scm 68 */
int BgL_vz00_2529;
BgL_vz00_2529 = 
CINT(BgL_vz00_2091); 
return 
((((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_oz00_2090)))->BgL_fdz00)=((int)BgL_vz00_2529),BUNSPEC);} } 

}



/* &lambda1974 */
obj_t BGl_z62lambda1974z62zz__libuv_typesz00(obj_t BgL_envz00_2092, obj_t BgL_oz00_2093)
{
{ /* Llib/uvtypes.scm 68 */
return 
BINT(
(((BgL_uvpollz00_bglt)COBJECT(
((BgL_uvpollz00_bglt)BgL_oz00_2093)))->BgL_fdz00));} 

}



/* &<@anonymous:1959> */
obj_t BGl_z62zc3z04anonymousza31959ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2094, obj_t BgL_new1174z00_2095)
{
{ /* Llib/uvtypes.scm 66 */
{ 
BgL_uvasyncz00_bglt BgL_auxz00_3777;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2095))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2095))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2095))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2095))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2095))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3794;
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_classz00_2532;
BgL_classz00_2532 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL__ortest_1106z00_2533;
BgL__ortest_1106z00_2533 = 
BGL_CLASS_NIL(BgL_classz00_2532); 
if(
CBOOL(BgL__ortest_1106z00_2533))
{ /* Llib/uvtypes.scm 66 */
BgL_auxz00_3794 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2533)
; }  else 
{ /* Llib/uvtypes.scm 66 */
BgL_auxz00_3794 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2532))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2095))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3794),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvasyncz00_bglt)BgL_new1174z00_2095))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3777 = 
((BgL_uvasyncz00_bglt)BgL_new1174z00_2095); 
return 
((obj_t)BgL_auxz00_3777);} } 

}



/* &lambda1957 */
BgL_uvasyncz00_bglt BGl_z62lambda1957z62zz__libuv_typesz00(obj_t BgL_envz00_2096)
{
{ /* Llib/uvtypes.scm 66 */
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1173z00_2534;
BgL_new1173z00_2534 = 
((BgL_uvasyncz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvasyncz00_bgl) ))); 
{ /* Llib/uvtypes.scm 66 */
long BgL_arg1958z00_2535;
{ /* Llib/uvtypes.scm 66 */
long BgL_res2256z00_2536;
BgL_res2256z00_2536 = 
BGL_CLASS_INDEX(BGl_UvAsyncz00zz__libuv_typesz00); 
BgL_arg1958z00_2535 = BgL_res2256z00_2536; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1173z00_2534), BgL_arg1958z00_2535); } 
return BgL_new1173z00_2534;} } 

}



/* &lambda1954 */
BgL_uvasyncz00_bglt BGl_z62lambda1954z62zz__libuv_typesz00(obj_t BgL_envz00_2097, obj_t BgL_z42builtin1166z42_2098, obj_t BgL_z52onclose1167z52_2099, obj_t BgL_z52gcmarkshead1168z52_2100, obj_t BgL_z52gcmarkstail1169z52_2101, obj_t BgL_closed1170z00_2102, obj_t BgL_loop1171z00_2103, obj_t BgL_cb1172z00_2104)
{
{ /* Llib/uvtypes.scm 66 */
{ /* Llib/uvtypes.scm 66 */
uv_handle_t * BgL_z42builtin1166z42_2537;bool_t BgL_closed1170z00_2540;
BgL_z42builtin1166z42_2537 = 
FOREIGN_TO_COBJ(BgL_z42builtin1166z42_2098); 
BgL_closed1170z00_2540 = 
CBOOL(BgL_closed1170z00_2102); 
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1265z00_2543;
{ /* Llib/uvtypes.scm 66 */
BgL_uvasyncz00_bglt BgL_new1264z00_2544;
BgL_new1264z00_2544 = 
((BgL_uvasyncz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvasyncz00_bgl) ))); 
{ /* Llib/uvtypes.scm 66 */
long BgL_arg1956z00_2545;
{ /* Llib/uvtypes.scm 66 */
long BgL_res2255z00_2546;
BgL_res2255z00_2546 = 
BGL_CLASS_INDEX(BGl_UvAsyncz00zz__libuv_typesz00); 
BgL_arg1956z00_2545 = BgL_res2255z00_2546; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1264z00_2544), BgL_arg1956z00_2545); } 
BgL_new1265z00_2543 = BgL_new1264z00_2544; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2543)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1166z42_2537),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2543)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1167z52_2099),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2543)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1168z52_2100)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2543)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1169z52_2101)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1265z00_2543)))->BgL_closedz00)=((bool_t)BgL_closed1170z00_2540),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1265z00_2543)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1171z00_2103)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1265z00_2543)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1172z00_2104)),BUNSPEC); 
{ /* Llib/uvtypes.scm 66 */
obj_t BgL_fun1955z00_2547;
BgL_fun1955z00_2547 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvAsyncz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1955z00_2547)(BgL_fun1955z00_2547, 
((obj_t)BgL_new1265z00_2543), BEOA); } 
return BgL_new1265z00_2543;} } } 

}



/* &<@anonymous:1948> */
obj_t BGl_z62zc3z04anonymousza31948ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2105, obj_t BgL_new1164z00_2106)
{
{ /* Llib/uvtypes.scm 64 */
{ 
BgL_uvidlez00_bglt BgL_auxz00_3843;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2106))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2106))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2106))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2106))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2106))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3860;
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_classz00_2549;
BgL_classz00_2549 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL__ortest_1106z00_2550;
BgL__ortest_1106z00_2550 = 
BGL_CLASS_NIL(BgL_classz00_2549); 
if(
CBOOL(BgL__ortest_1106z00_2550))
{ /* Llib/uvtypes.scm 64 */
BgL_auxz00_3860 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2550)
; }  else 
{ /* Llib/uvtypes.scm 64 */
BgL_auxz00_3860 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2549))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2106))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3860),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvidlez00_bglt)BgL_new1164z00_2106))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_3843 = 
((BgL_uvidlez00_bglt)BgL_new1164z00_2106); 
return 
((obj_t)BgL_auxz00_3843);} } 

}



/* &lambda1946 */
BgL_uvidlez00_bglt BGl_z62lambda1946z62zz__libuv_typesz00(obj_t BgL_envz00_2107)
{
{ /* Llib/uvtypes.scm 64 */
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1163z00_2551;
BgL_new1163z00_2551 = 
((BgL_uvidlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvidlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 64 */
long BgL_arg1947z00_2552;
{ /* Llib/uvtypes.scm 64 */
long BgL_res2254z00_2553;
BgL_res2254z00_2553 = 
BGL_CLASS_INDEX(BGl_UvIdlez00zz__libuv_typesz00); 
BgL_arg1947z00_2552 = BgL_res2254z00_2553; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1163z00_2551), BgL_arg1947z00_2552); } 
return BgL_new1163z00_2551;} } 

}



/* &lambda1943 */
BgL_uvidlez00_bglt BGl_z62lambda1943z62zz__libuv_typesz00(obj_t BgL_envz00_2108, obj_t BgL_z42builtin1156z42_2109, obj_t BgL_z52onclose1157z52_2110, obj_t BgL_z52gcmarkshead1158z52_2111, obj_t BgL_z52gcmarkstail1159z52_2112, obj_t BgL_closed1160z00_2113, obj_t BgL_loop1161z00_2114, obj_t BgL_cb1162z00_2115)
{
{ /* Llib/uvtypes.scm 64 */
{ /* Llib/uvtypes.scm 64 */
uv_handle_t * BgL_z42builtin1156z42_2554;bool_t BgL_closed1160z00_2557;
BgL_z42builtin1156z42_2554 = 
FOREIGN_TO_COBJ(BgL_z42builtin1156z42_2109); 
BgL_closed1160z00_2557 = 
CBOOL(BgL_closed1160z00_2113); 
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1263z00_2560;
{ /* Llib/uvtypes.scm 64 */
BgL_uvidlez00_bglt BgL_new1262z00_2561;
BgL_new1262z00_2561 = 
((BgL_uvidlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvidlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 64 */
long BgL_arg1945z00_2562;
{ /* Llib/uvtypes.scm 64 */
long BgL_res2253z00_2563;
BgL_res2253z00_2563 = 
BGL_CLASS_INDEX(BGl_UvIdlez00zz__libuv_typesz00); 
BgL_arg1945z00_2562 = BgL_res2253z00_2563; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1262z00_2561), BgL_arg1945z00_2562); } 
BgL_new1263z00_2560 = BgL_new1262z00_2561; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2560)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1156z42_2554),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2560)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1157z52_2110),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2560)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1158z52_2111)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2560)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1159z52_2112)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1263z00_2560)))->BgL_closedz00)=((bool_t)BgL_closed1160z00_2557),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1263z00_2560)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1161z00_2114)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1263z00_2560)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1162z00_2115)),BUNSPEC); 
{ /* Llib/uvtypes.scm 64 */
obj_t BgL_fun1944z00_2564;
BgL_fun1944z00_2564 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvIdlez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1944z00_2564)(BgL_fun1944z00_2564, 
((obj_t)BgL_new1263z00_2560), BEOA); } 
return BgL_new1263z00_2560;} } } 

}



/* &<@anonymous:1923> */
obj_t BGl_z62zc3z04anonymousza31923ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2116, obj_t BgL_new1154z00_2117)
{
{ /* Llib/uvtypes.scm 60 */
{ 
BgL_uvtimerz00_bglt BgL_auxz00_3909;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_3926;
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_classz00_2566;
BgL_classz00_2566 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL__ortest_1106z00_2567;
BgL__ortest_1106z00_2567 = 
BGL_CLASS_NIL(BgL_classz00_2566); 
if(
CBOOL(BgL__ortest_1106z00_2567))
{ /* Llib/uvtypes.scm 60 */
BgL_auxz00_3926 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2567)
; }  else 
{ /* Llib/uvtypes.scm 60 */
BgL_auxz00_3926 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2566))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_3926),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117))))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117)))->BgL_repeatz00)=((uint64_t)
0L),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117)))->BgL_refz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_3909 = 
((BgL_uvtimerz00_bglt)BgL_new1154z00_2117); 
return 
((obj_t)BgL_auxz00_3909);} } 

}



/* &lambda1921 */
BgL_uvtimerz00_bglt BGl_z62lambda1921z62zz__libuv_typesz00(obj_t BgL_envz00_2118)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1153z00_2568;
BgL_new1153z00_2568 = 
((BgL_uvtimerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtimerz00_bgl) ))); 
{ /* Llib/uvtypes.scm 60 */
long BgL_arg1922z00_2569;
{ /* Llib/uvtypes.scm 60 */
long BgL_res2252z00_2570;
BgL_res2252z00_2570 = 
BGL_CLASS_INDEX(BGl_UvTimerz00zz__libuv_typesz00); 
BgL_arg1922z00_2569 = BgL_res2252z00_2570; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1153z00_2568), BgL_arg1922z00_2569); } 
return BgL_new1153z00_2568;} } 

}



/* &lambda1918 */
BgL_uvtimerz00_bglt BGl_z62lambda1918z62zz__libuv_typesz00(obj_t BgL_envz00_2119, obj_t BgL_z42builtin1144z42_2120, obj_t BgL_z52onclose1145z52_2121, obj_t BgL_z52gcmarkshead1146z52_2122, obj_t BgL_z52gcmarkstail1147z52_2123, obj_t BgL_closed1148z00_2124, obj_t BgL_loop1149z00_2125, obj_t BgL_cb1150z00_2126, obj_t BgL_repeat1151z00_2127, obj_t BgL_ref1152z00_2128)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uv_handle_t * BgL_z42builtin1144z42_2571;bool_t BgL_closed1148z00_2574;uint64_t BgL_repeat1151z00_2577;bool_t BgL_ref1152z00_2578;
BgL_z42builtin1144z42_2571 = 
FOREIGN_TO_COBJ(BgL_z42builtin1144z42_2120); 
BgL_closed1148z00_2574 = 
CBOOL(BgL_closed1148z00_2124); 
BgL_repeat1151z00_2577 = 
BGL_BINT64_TO_INT64(BgL_repeat1151z00_2127); 
BgL_ref1152z00_2578 = 
CBOOL(BgL_ref1152z00_2128); 
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1261z00_2579;
{ /* Llib/uvtypes.scm 60 */
BgL_uvtimerz00_bglt BgL_new1260z00_2580;
BgL_new1260z00_2580 = 
((BgL_uvtimerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtimerz00_bgl) ))); 
{ /* Llib/uvtypes.scm 60 */
long BgL_arg1920z00_2581;
{ /* Llib/uvtypes.scm 60 */
long BgL_res2251z00_2582;
BgL_res2251z00_2582 = 
BGL_CLASS_INDEX(BGl_UvTimerz00zz__libuv_typesz00); 
BgL_arg1920z00_2581 = BgL_res2251z00_2582; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1260z00_2580), BgL_arg1920z00_2581); } 
BgL_new1261z00_2579 = BgL_new1260z00_2580; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2579)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1144z42_2571),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2579)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1145z52_2121),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2579)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1146z52_2122)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2579)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1147z52_2123)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1261z00_2579)))->BgL_closedz00)=((bool_t)BgL_closed1148z00_2574),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1261z00_2579)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1149z00_2125)),BUNSPEC); 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1261z00_2579)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_cb1150z00_2126)),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(BgL_new1261z00_2579))->BgL_repeatz00)=((uint64_t)BgL_repeat1151z00_2577),BUNSPEC); 
((((BgL_uvtimerz00_bglt)COBJECT(BgL_new1261z00_2579))->BgL_refz00)=((bool_t)BgL_ref1152z00_2578),BUNSPEC); 
{ /* Llib/uvtypes.scm 60 */
obj_t BgL_fun1919z00_2583;
BgL_fun1919z00_2583 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTimerz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1919z00_2583)(BgL_fun1919z00_2583, 
((obj_t)BgL_new1261z00_2579), BEOA); } 
return BgL_new1261z00_2579;} } } 

}



/* &<@anonymous:1937> */
obj_t BGl_z62zc3z04anonymousza31937ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2129)
{
{ /* Llib/uvtypes.scm 60 */
return 
BBOOL(((bool_t)1));} 

}



/* &lambda1936 */
obj_t BGl_z62lambda1936z62zz__libuv_typesz00(obj_t BgL_envz00_2130, obj_t BgL_oz00_2131, obj_t BgL_vz00_2132)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
bool_t BgL_vz00_2585;
BgL_vz00_2585 = 
CBOOL(BgL_vz00_2132); 
return 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2131)))->BgL_refz00)=((bool_t)BgL_vz00_2585),BUNSPEC);} } 

}



/* &lambda1935 */
obj_t BGl_z62lambda1935z62zz__libuv_typesz00(obj_t BgL_envz00_2133, obj_t BgL_oz00_2134)
{
{ /* Llib/uvtypes.scm 60 */
return 
BBOOL(
(((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2134)))->BgL_refz00));} 

}



/* &<@anonymous:1930> */
obj_t BGl_z62zc3z04anonymousza31930ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2135)
{
{ /* Llib/uvtypes.scm 60 */
return 
BGL_UINT64_TO_BUINT64((uint64_t)(0));} 

}



/* &lambda1929 */
obj_t BGl_z62lambda1929z62zz__libuv_typesz00(obj_t BgL_envz00_2136, obj_t BgL_oz00_2137, obj_t BgL_vz00_2138)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uint64_t BgL_vz00_2588;
BgL_vz00_2588 = 
BGL_BINT64_TO_INT64(BgL_vz00_2138); 
return 
((((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2137)))->BgL_repeatz00)=((uint64_t)BgL_vz00_2588),BUNSPEC);} } 

}



/* &lambda1928 */
obj_t BGl_z62lambda1928z62zz__libuv_typesz00(obj_t BgL_envz00_2139, obj_t BgL_oz00_2140)
{
{ /* Llib/uvtypes.scm 60 */
{ /* Llib/uvtypes.scm 60 */
uint64_t BgL_tmpz00_3995;
BgL_tmpz00_3995 = 
(((BgL_uvtimerz00_bglt)COBJECT(
((BgL_uvtimerz00_bglt)BgL_oz00_2140)))->BgL_repeatz00); 
return 
BGL_UINT64_TO_BUINT64(BgL_tmpz00_3995);} } 

}



/* &<@anonymous:1902> */
obj_t BGl_z62zc3z04anonymousza31902ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2141, obj_t BgL_new1142z00_2142)
{
{ /* Llib/uvtypes.scm 56 */
{ 
BgL_uvttyz00_bglt BgL_auxz00_3999;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4016;
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_classz00_2591;
BgL_classz00_2591 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL__ortest_1106z00_2592;
BgL__ortest_1106z00_2592 = 
BGL_CLASS_NIL(BgL_classz00_2591); 
if(
CBOOL(BgL__ortest_1106z00_2592))
{ /* Llib/uvtypes.scm 56 */
BgL_auxz00_4016 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2592)
; }  else 
{ /* Llib/uvtypes.scm 56 */
BgL_auxz00_4016 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2591))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4016),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvttyz00_bglt)BgL_new1142z00_2142))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_new1142z00_2142)))->BgL_fdz00)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_new1142z00_2142)))->BgL_readablez00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_3999 = 
((BgL_uvttyz00_bglt)BgL_new1142z00_2142); 
return 
((obj_t)BgL_auxz00_3999);} } 

}



/* &lambda1900 */
BgL_uvttyz00_bglt BGl_z62lambda1900z62zz__libuv_typesz00(obj_t BgL_envz00_2143)
{
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1141z00_2593;
BgL_new1141z00_2593 = 
((BgL_uvttyz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvttyz00_bgl) ))); 
{ /* Llib/uvtypes.scm 56 */
long BgL_arg1901z00_2594;
{ /* Llib/uvtypes.scm 56 */
long BgL_res2250z00_2595;
BgL_res2250z00_2595 = 
BGL_CLASS_INDEX(BGl_UvTtyz00zz__libuv_typesz00); 
BgL_arg1901z00_2594 = BgL_res2250z00_2595; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2593), BgL_arg1901z00_2594); } 
return BgL_new1141z00_2593;} } 

}



/* &lambda1897 */
BgL_uvttyz00_bglt BGl_z62lambda1897z62zz__libuv_typesz00(obj_t BgL_envz00_2144, obj_t BgL_z42builtin1128z42_2145, obj_t BgL_z52onclose1129z52_2146, obj_t BgL_z52gcmarkshead1130z52_2147, obj_t BgL_z52gcmarkstail1131z52_2148, obj_t BgL_closed1132z00_2149, obj_t BgL_loop1133z00_2150, obj_t BgL_z52alloc1134z52_2151, obj_t BgL_z52offset1135z52_2152, obj_t BgL_z52proca1136z52_2153, obj_t BgL_z52procc1137z52_2154, obj_t BgL_z52callback1138z52_2155, obj_t BgL_fd1139z00_2156, obj_t BgL_readable1140z00_2157)
{
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
uv_handle_t * BgL_z42builtin1128z42_2596;bool_t BgL_closed1132z00_2599;int BgL_fd1139z00_2601;bool_t BgL_readable1140z00_2602;
BgL_z42builtin1128z42_2596 = 
FOREIGN_TO_COBJ(BgL_z42builtin1128z42_2145); 
BgL_closed1132z00_2599 = 
CBOOL(BgL_closed1132z00_2149); 
BgL_fd1139z00_2601 = 
CINT(BgL_fd1139z00_2156); 
BgL_readable1140z00_2602 = 
CBOOL(BgL_readable1140z00_2157); 
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1259z00_2603;
{ /* Llib/uvtypes.scm 56 */
BgL_uvttyz00_bglt BgL_new1258z00_2604;
BgL_new1258z00_2604 = 
((BgL_uvttyz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvttyz00_bgl) ))); 
{ /* Llib/uvtypes.scm 56 */
long BgL_arg1899z00_2605;
{ /* Llib/uvtypes.scm 56 */
long BgL_res2249z00_2606;
BgL_res2249z00_2606 = 
BGL_CLASS_INDEX(BGl_UvTtyz00zz__libuv_typesz00); 
BgL_arg1899z00_2605 = BgL_res2249z00_2606; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1258z00_2604), BgL_arg1899z00_2605); } 
BgL_new1259z00_2603 = BgL_new1258z00_2604; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2603)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1128z42_2596),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2603)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1129z52_2146),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2603)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1130z52_2147)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2603)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1131z52_2148)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1259z00_2603)))->BgL_closedz00)=((bool_t)BgL_closed1132z00_2599),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2603)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1133z00_2150)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2603)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1134z52_2151),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2603)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1135z52_2152),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2603)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1136z52_2153),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2603)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1137z52_2154),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1259z00_2603)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1138z52_2155),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(BgL_new1259z00_2603))->BgL_fdz00)=((int)BgL_fd1139z00_2601),BUNSPEC); 
((((BgL_uvttyz00_bglt)COBJECT(BgL_new1259z00_2603))->BgL_readablez00)=((bool_t)BgL_readable1140z00_2602),BUNSPEC); 
{ /* Llib/uvtypes.scm 56 */
obj_t BgL_fun1898z00_2607;
BgL_fun1898z00_2607 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTtyz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1898z00_2607)(BgL_fun1898z00_2607, 
((obj_t)BgL_new1259z00_2603), BEOA); } 
return BgL_new1259z00_2603;} } } 

}



/* &lambda1912 */
obj_t BGl_z62lambda1912z62zz__libuv_typesz00(obj_t BgL_envz00_2158, obj_t BgL_oz00_2159, obj_t BgL_vz00_2160)
{
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
bool_t BgL_vz00_2609;
BgL_vz00_2609 = 
CBOOL(BgL_vz00_2160); 
return 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2159)))->BgL_readablez00)=((bool_t)BgL_vz00_2609),BUNSPEC);} } 

}



/* &lambda1911 */
obj_t BGl_z62lambda1911z62zz__libuv_typesz00(obj_t BgL_envz00_2161, obj_t BgL_oz00_2162)
{
{ /* Llib/uvtypes.scm 56 */
return 
BBOOL(
(((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2162)))->BgL_readablez00));} 

}



/* &lambda1907 */
obj_t BGl_z62lambda1907z62zz__libuv_typesz00(obj_t BgL_envz00_2163, obj_t BgL_oz00_2164, obj_t BgL_vz00_2165)
{
{ /* Llib/uvtypes.scm 56 */
{ /* Llib/uvtypes.scm 56 */
int BgL_vz00_2612;
BgL_vz00_2612 = 
CINT(BgL_vz00_2165); 
return 
((((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2164)))->BgL_fdz00)=((int)BgL_vz00_2612),BUNSPEC);} } 

}



/* &lambda1906 */
obj_t BGl_z62lambda1906z62zz__libuv_typesz00(obj_t BgL_envz00_2166, obj_t BgL_oz00_2167)
{
{ /* Llib/uvtypes.scm 56 */
return 
BINT(
(((BgL_uvttyz00_bglt)COBJECT(
((BgL_uvttyz00_bglt)BgL_oz00_2167)))->BgL_fdz00));} 

}



/* &<@anonymous:1886> */
obj_t BGl_z62zc3z04anonymousza31886ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2168, obj_t BgL_new1126z00_2169)
{
{ /* Llib/uvtypes.scm 53 */
{ 
BgL_uvpipez00_bglt BgL_auxz00_4105;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4122;
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_classz00_2615;
BgL_classz00_2615 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL__ortest_1106z00_2616;
BgL__ortest_1106z00_2616 = 
BGL_CLASS_NIL(BgL_classz00_2615); 
if(
CBOOL(BgL__ortest_1106z00_2616))
{ /* Llib/uvtypes.scm 53 */
BgL_auxz00_4122 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2616)
; }  else 
{ /* Llib/uvtypes.scm 53 */
BgL_auxz00_4122 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2615))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4122),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvpipez00_bglt)BgL_new1126z00_2169))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_new1126z00_2169)))->BgL_ipcz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4105 = 
((BgL_uvpipez00_bglt)BgL_new1126z00_2169); 
return 
((obj_t)BgL_auxz00_4105);} } 

}



/* &lambda1884 */
BgL_uvpipez00_bglt BGl_z62lambda1884z62zz__libuv_typesz00(obj_t BgL_envz00_2170)
{
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1125z00_2617;
BgL_new1125z00_2617 = 
((BgL_uvpipez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpipez00_bgl) ))); 
{ /* Llib/uvtypes.scm 53 */
long BgL_arg1885z00_2618;
{ /* Llib/uvtypes.scm 53 */
long BgL_res2248z00_2619;
BgL_res2248z00_2619 = 
BGL_CLASS_INDEX(BGl_UvPipez00zz__libuv_typesz00); 
BgL_arg1885z00_2618 = BgL_res2248z00_2619; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_2617), BgL_arg1885z00_2618); } 
return BgL_new1125z00_2617;} } 

}



/* &lambda1881 */
BgL_uvpipez00_bglt BGl_z62lambda1881z62zz__libuv_typesz00(obj_t BgL_envz00_2171, obj_t BgL_z42builtin1113z42_2172, obj_t BgL_z52onclose1114z52_2173, obj_t BgL_z52gcmarkshead1115z52_2174, obj_t BgL_z52gcmarkstail1116z52_2175, obj_t BgL_closed1117z00_2176, obj_t BgL_loop1118z00_2177, obj_t BgL_z52alloc1119z52_2178, obj_t BgL_z52offset1120z52_2179, obj_t BgL_z52proca1121z52_2180, obj_t BgL_z52procc1122z52_2181, obj_t BgL_z52callback1123z52_2182, obj_t BgL_ipc1124z00_2183)
{
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
uv_handle_t * BgL_z42builtin1113z42_2620;bool_t BgL_closed1117z00_2623;bool_t BgL_ipc1124z00_2625;
BgL_z42builtin1113z42_2620 = 
FOREIGN_TO_COBJ(BgL_z42builtin1113z42_2172); 
BgL_closed1117z00_2623 = 
CBOOL(BgL_closed1117z00_2176); 
BgL_ipc1124z00_2625 = 
CBOOL(BgL_ipc1124z00_2183); 
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1257z00_2626;
{ /* Llib/uvtypes.scm 53 */
BgL_uvpipez00_bglt BgL_new1256z00_2627;
BgL_new1256z00_2627 = 
((BgL_uvpipez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvpipez00_bgl) ))); 
{ /* Llib/uvtypes.scm 53 */
long BgL_arg1883z00_2628;
{ /* Llib/uvtypes.scm 53 */
long BgL_res2247z00_2629;
BgL_res2247z00_2629 = 
BGL_CLASS_INDEX(BGl_UvPipez00zz__libuv_typesz00); 
BgL_arg1883z00_2628 = BgL_res2247z00_2629; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1256z00_2627), BgL_arg1883z00_2628); } 
BgL_new1257z00_2626 = BgL_new1256z00_2627; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2626)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1113z42_2620),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2626)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1114z52_2173),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2626)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1115z52_2174)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2626)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1116z52_2175)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1257z00_2626)))->BgL_closedz00)=((bool_t)BgL_closed1117z00_2623),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2626)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1118z00_2177)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2626)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1119z52_2178),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2626)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1120z52_2179),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2626)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1121z52_2180),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2626)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1122z52_2181),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1257z00_2626)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1123z52_2182),BUNSPEC); 
((((BgL_uvpipez00_bglt)COBJECT(BgL_new1257z00_2626))->BgL_ipcz00)=((bool_t)BgL_ipc1124z00_2625),BUNSPEC); 
{ /* Llib/uvtypes.scm 53 */
obj_t BgL_fun1882z00_2630;
BgL_fun1882z00_2630 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvPipez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1882z00_2630)(BgL_fun1882z00_2630, 
((obj_t)BgL_new1257z00_2626), BEOA); } 
return BgL_new1257z00_2626;} } } 

}



/* &lambda1891 */
obj_t BGl_z62lambda1891z62zz__libuv_typesz00(obj_t BgL_envz00_2184, obj_t BgL_oz00_2185, obj_t BgL_vz00_2186)
{
{ /* Llib/uvtypes.scm 53 */
{ /* Llib/uvtypes.scm 53 */
bool_t BgL_vz00_2632;
BgL_vz00_2632 = 
CBOOL(BgL_vz00_2186); 
return 
((((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_oz00_2185)))->BgL_ipcz00)=((bool_t)BgL_vz00_2632),BUNSPEC);} } 

}



/* &lambda1890 */
obj_t BGl_z62lambda1890z62zz__libuv_typesz00(obj_t BgL_envz00_2187, obj_t BgL_oz00_2188)
{
{ /* Llib/uvtypes.scm 53 */
return 
BBOOL(
(((BgL_uvpipez00_bglt)COBJECT(
((BgL_uvpipez00_bglt)BgL_oz00_2188)))->BgL_ipcz00));} 

}



/* &<@anonymous:1868> */
obj_t BGl_z62zc3z04anonymousza31868ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2189, obj_t BgL_new1111z00_2190)
{
{ /* Llib/uvtypes.scm 50 */
{ 
BgL_uvudpz00_bglt BgL_auxz00_4200;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4217;
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_classz00_2635;
BgL_classz00_2635 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL__ortest_1106z00_2636;
BgL__ortest_1106z00_2636 = 
BGL_CLASS_NIL(BgL_classz00_2635); 
if(
CBOOL(BgL__ortest_1106z00_2636))
{ /* Llib/uvtypes.scm 50 */
BgL_auxz00_4217 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2636)
; }  else 
{ /* Llib/uvtypes.scm 50 */
BgL_auxz00_4217 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2635))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4217),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvudpz00_bglt)BgL_new1111z00_2190))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_new1111z00_2190)))->BgL_z52procmz52)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_4200 = 
((BgL_uvudpz00_bglt)BgL_new1111z00_2190); 
return 
((obj_t)BgL_auxz00_4200);} } 

}



/* &lambda1866 */
BgL_uvudpz00_bglt BGl_z62lambda1866z62zz__libuv_typesz00(obj_t BgL_envz00_2191)
{
{ /* Llib/uvtypes.scm 50 */
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1110z00_2637;
BgL_new1110z00_2637 = 
((BgL_uvudpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvudpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 50 */
long BgL_arg1867z00_2638;
{ /* Llib/uvtypes.scm 50 */
long BgL_res2246z00_2639;
BgL_res2246z00_2639 = 
BGL_CLASS_INDEX(BGl_UvUdpz00zz__libuv_typesz00); 
BgL_arg1867z00_2638 = BgL_res2246z00_2639; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1110z00_2637), BgL_arg1867z00_2638); } 
return BgL_new1110z00_2637;} } 

}



/* &lambda1863 */
BgL_uvudpz00_bglt BGl_z62lambda1863z62zz__libuv_typesz00(obj_t BgL_envz00_2192, obj_t BgL_z42builtin1098z42_2193, obj_t BgL_z52onclose1099z52_2194, obj_t BgL_z52gcmarkshead1100z52_2195, obj_t BgL_z52gcmarkstail1101z52_2196, obj_t BgL_closed1102z00_2197, obj_t BgL_loop1103z00_2198, obj_t BgL_z52alloc1104z52_2199, obj_t BgL_z52offset1105z52_2200, obj_t BgL_z52proca1106z52_2201, obj_t BgL_z52procc1107z52_2202, obj_t BgL_z52callback1108z52_2203, obj_t BgL_z52procm1109z52_2204)
{
{ /* Llib/uvtypes.scm 50 */
{ /* Llib/uvtypes.scm 50 */
uv_handle_t * BgL_z42builtin1098z42_2640;bool_t BgL_closed1102z00_2643;
BgL_z42builtin1098z42_2640 = 
FOREIGN_TO_COBJ(BgL_z42builtin1098z42_2193); 
BgL_closed1102z00_2643 = 
CBOOL(BgL_closed1102z00_2197); 
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1255z00_2646;
{ /* Llib/uvtypes.scm 50 */
BgL_uvudpz00_bglt BgL_new1254z00_2647;
BgL_new1254z00_2647 = 
((BgL_uvudpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvudpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 50 */
long BgL_arg1865z00_2648;
{ /* Llib/uvtypes.scm 50 */
long BgL_res2245z00_2649;
BgL_res2245z00_2649 = 
BGL_CLASS_INDEX(BGl_UvUdpz00zz__libuv_typesz00); 
BgL_arg1865z00_2648 = BgL_res2245z00_2649; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1254z00_2647), BgL_arg1865z00_2648); } 
BgL_new1255z00_2646 = BgL_new1254z00_2647; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2646)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1098z42_2640),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2646)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1099z52_2194),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2646)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1100z52_2195)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2646)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1101z52_2196)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1255z00_2646)))->BgL_closedz00)=((bool_t)BgL_closed1102z00_2643),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2646)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1103z00_2198)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2646)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1104z52_2199),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2646)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1105z52_2200),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2646)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1106z52_2201),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2646)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1107z52_2202),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1255z00_2646)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1108z52_2203),BUNSPEC); 
((((BgL_uvudpz00_bglt)COBJECT(BgL_new1255z00_2646))->BgL_z52procmz52)=((obj_t)
((obj_t)BgL_z52procm1109z52_2204)),BUNSPEC); 
{ /* Llib/uvtypes.scm 50 */
obj_t BgL_fun1864z00_2650;
BgL_fun1864z00_2650 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvUdpz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1864z00_2650)(BgL_fun1864z00_2650, 
((obj_t)BgL_new1255z00_2646), BEOA); } 
return BgL_new1255z00_2646;} } } 

}



/* &<@anonymous:1875> */
obj_t BGl_z62zc3z04anonymousza31875ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2205)
{
{ /* Llib/uvtypes.scm 50 */
return BNIL;} 

}



/* &lambda1874 */
obj_t BGl_z62lambda1874z62zz__libuv_typesz00(obj_t BgL_envz00_2206, obj_t BgL_oz00_2207, obj_t BgL_vz00_2208)
{
{ /* Llib/uvtypes.scm 50 */
return 
((((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_oz00_2207)))->BgL_z52procmz52)=((obj_t)
((obj_t)BgL_vz00_2208)),BUNSPEC);} 

}



/* &lambda1873 */
obj_t BGl_z62lambda1873z62zz__libuv_typesz00(obj_t BgL_envz00_2209, obj_t BgL_oz00_2210)
{
{ /* Llib/uvtypes.scm 50 */
return 
(((BgL_uvudpz00_bglt)COBJECT(
((BgL_uvudpz00_bglt)BgL_oz00_2210)))->BgL_z52procmz52);} 

}



/* &<@anonymous:1857> */
obj_t BGl_z62zc3z04anonymousza31857ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2211, obj_t BgL_new1096z00_2212)
{
{ /* Llib/uvtypes.scm 48 */
{ 
BgL_uvtcpz00_bglt BgL_auxz00_4294;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4311;
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_classz00_2655;
BgL_classz00_2655 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL__ortest_1106z00_2656;
BgL__ortest_1106z00_2656 = 
BGL_CLASS_NIL(BgL_classz00_2655); 
if(
CBOOL(BgL__ortest_1106z00_2656))
{ /* Llib/uvtypes.scm 48 */
BgL_auxz00_4311 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2656)
; }  else 
{ /* Llib/uvtypes.scm 48 */
BgL_auxz00_4311 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2655))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4311),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212))))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4294 = 
((BgL_uvtcpz00_bglt)BgL_new1096z00_2212); 
return 
((obj_t)BgL_auxz00_4294);} } 

}



/* &lambda1855 */
BgL_uvtcpz00_bglt BGl_z62lambda1855z62zz__libuv_typesz00(obj_t BgL_envz00_2213)
{
{ /* Llib/uvtypes.scm 48 */
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1095z00_2657;
BgL_new1095z00_2657 = 
((BgL_uvtcpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtcpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 48 */
long BgL_arg1856z00_2658;
{ /* Llib/uvtypes.scm 48 */
long BgL_res2244z00_2659;
BgL_res2244z00_2659 = 
BGL_CLASS_INDEX(BGl_UvTcpz00zz__libuv_typesz00); 
BgL_arg1856z00_2658 = BgL_res2244z00_2659; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1095z00_2657), BgL_arg1856z00_2658); } 
return BgL_new1095z00_2657;} } 

}



/* &lambda1852 */
BgL_uvtcpz00_bglt BGl_z62lambda1852z62zz__libuv_typesz00(obj_t BgL_envz00_2214, obj_t BgL_z42builtin1084z42_2215, obj_t BgL_z52onclose1085z52_2216, obj_t BgL_z52gcmarkshead1086z52_2217, obj_t BgL_z52gcmarkstail1087z52_2218, obj_t BgL_closed1088z00_2219, obj_t BgL_loop1089z00_2220, obj_t BgL_z52alloc1090z52_2221, obj_t BgL_z52offset1091z52_2222, obj_t BgL_z52proca1092z52_2223, obj_t BgL_z52procc1093z52_2224, obj_t BgL_z52callback1094z52_2225)
{
{ /* Llib/uvtypes.scm 48 */
{ /* Llib/uvtypes.scm 48 */
uv_handle_t * BgL_z42builtin1084z42_2660;bool_t BgL_closed1088z00_2663;
BgL_z42builtin1084z42_2660 = 
FOREIGN_TO_COBJ(BgL_z42builtin1084z42_2215); 
BgL_closed1088z00_2663 = 
CBOOL(BgL_closed1088z00_2219); 
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1253z00_2665;
{ /* Llib/uvtypes.scm 48 */
BgL_uvtcpz00_bglt BgL_new1252z00_2666;
BgL_new1252z00_2666 = 
((BgL_uvtcpz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvtcpz00_bgl) ))); 
{ /* Llib/uvtypes.scm 48 */
long BgL_arg1854z00_2667;
{ /* Llib/uvtypes.scm 48 */
long BgL_res2243z00_2668;
BgL_res2243z00_2668 = 
BGL_CLASS_INDEX(BGl_UvTcpz00zz__libuv_typesz00); 
BgL_arg1854z00_2667 = BgL_res2243z00_2668; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1252z00_2666), BgL_arg1854z00_2667); } 
BgL_new1253z00_2665 = BgL_new1252z00_2666; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2665)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1084z42_2660),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2665)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1085z52_2216),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2665)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1086z52_2217)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2665)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1087z52_2218)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1253z00_2665)))->BgL_closedz00)=((bool_t)BgL_closed1088z00_2663),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2665)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1089z00_2220)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2665)))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1090z52_2221),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2665)))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1091z52_2222),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2665)))->BgL_z52procaz52)=((obj_t)BgL_z52proca1092z52_2223),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2665)))->BgL_z52proccz52)=((obj_t)BgL_z52procc1093z52_2224),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1253z00_2665)))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1094z52_2225),BUNSPEC); 
{ /* Llib/uvtypes.scm 48 */
obj_t BgL_fun1853z00_2669;
BgL_fun1853z00_2669 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvTcpz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1853z00_2669)(BgL_fun1853z00_2669, 
((obj_t)BgL_new1253z00_2665), BEOA); } 
return BgL_new1253z00_2665;} } } 

}



/* &<@anonymous:1806> */
obj_t BGl_z62zc3z04anonymousza31806ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2226, obj_t BgL_new1082z00_2227)
{
{ /* Llib/uvtypes.scm 40 */
{ 
BgL_uvstreamz00_bglt BgL_auxz00_4379;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4396;
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_classz00_2671;
BgL_classz00_2671 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL__ortest_1106z00_2672;
BgL__ortest_1106z00_2672 = 
BGL_CLASS_NIL(BgL_classz00_2671); 
if(
CBOOL(BgL__ortest_1106z00_2672))
{ /* Llib/uvtypes.scm 40 */
BgL_auxz00_4396 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2672)
; }  else 
{ /* Llib/uvtypes.scm 40 */
BgL_auxz00_4396 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2671))
; } } } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227)))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4396),BUNSPEC); } 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227)))->BgL_z52allocz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227)))->BgL_z52offsetz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227)))->BgL_z52procaz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227)))->BgL_z52proccz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227)))->BgL_z52callbackz52)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4379 = 
((BgL_uvstreamz00_bglt)BgL_new1082z00_2227); 
return 
((obj_t)BgL_auxz00_4379);} } 

}



/* &lambda1804 */
BgL_uvstreamz00_bglt BGl_z62lambda1804z62zz__libuv_typesz00(obj_t BgL_envz00_2228)
{
{ /* Llib/uvtypes.scm 40 */
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1081z00_2673;
BgL_new1081z00_2673 = 
((BgL_uvstreamz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvstreamz00_bgl) ))); 
{ /* Llib/uvtypes.scm 40 */
long BgL_arg1805z00_2674;
{ /* Llib/uvtypes.scm 40 */
long BgL_res2242z00_2675;
BgL_res2242z00_2675 = 
BGL_CLASS_INDEX(BGl_UvStreamz00zz__libuv_typesz00); 
BgL_arg1805z00_2674 = BgL_res2242z00_2675; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1081z00_2673), BgL_arg1805z00_2674); } 
return BgL_new1081z00_2673;} } 

}



/* &lambda1801 */
BgL_uvstreamz00_bglt BGl_z62lambda1801z62zz__libuv_typesz00(obj_t BgL_envz00_2229, obj_t BgL_z42builtin1070z42_2230, obj_t BgL_z52onclose1071z52_2231, obj_t BgL_z52gcmarkshead1072z52_2232, obj_t BgL_z52gcmarkstail1073z52_2233, obj_t BgL_closed1074z00_2234, obj_t BgL_loop1075z00_2235, obj_t BgL_z52alloc1076z52_2236, obj_t BgL_z52offset1077z52_2237, obj_t BgL_z52proca1078z52_2238, obj_t BgL_z52procc1079z52_2239, obj_t BgL_z52callback1080z52_2240)
{
{ /* Llib/uvtypes.scm 40 */
{ /* Llib/uvtypes.scm 40 */
uv_handle_t * BgL_z42builtin1070z42_2676;bool_t BgL_closed1074z00_2679;
BgL_z42builtin1070z42_2676 = 
FOREIGN_TO_COBJ(BgL_z42builtin1070z42_2230); 
BgL_closed1074z00_2679 = 
CBOOL(BgL_closed1074z00_2234); 
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1251z00_2681;
{ /* Llib/uvtypes.scm 40 */
BgL_uvstreamz00_bglt BgL_new1250z00_2682;
BgL_new1250z00_2682 = 
((BgL_uvstreamz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvstreamz00_bgl) ))); 
{ /* Llib/uvtypes.scm 40 */
long BgL_arg1803z00_2683;
{ /* Llib/uvtypes.scm 40 */
long BgL_res2241z00_2684;
BgL_res2241z00_2684 = 
BGL_CLASS_INDEX(BGl_UvStreamz00zz__libuv_typesz00); 
BgL_arg1803z00_2683 = BgL_res2241z00_2684; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1250z00_2682), BgL_arg1803z00_2683); } 
BgL_new1251z00_2681 = BgL_new1250z00_2682; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2681)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1070z42_2676),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2681)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1071z52_2231),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2681)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1072z52_2232)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2681)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1073z52_2233)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1251z00_2681)))->BgL_closedz00)=((bool_t)BgL_closed1074z00_2679),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2681))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_loop1075z00_2235)),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2681))->BgL_z52allocz52)=((obj_t)BgL_z52alloc1076z52_2236),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2681))->BgL_z52offsetz52)=((obj_t)BgL_z52offset1077z52_2237),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2681))->BgL_z52procaz52)=((obj_t)BgL_z52proca1078z52_2238),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2681))->BgL_z52proccz52)=((obj_t)BgL_z52procc1079z52_2239),BUNSPEC); 
((((BgL_uvstreamz00_bglt)COBJECT(BgL_new1251z00_2681))->BgL_z52callbackz52)=((obj_t)BgL_z52callback1080z52_2240),BUNSPEC); 
{ /* Llib/uvtypes.scm 40 */
obj_t BgL_fun1802z00_2685;
BgL_fun1802z00_2685 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvStreamz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1802z00_2685)(BgL_fun1802z00_2685, 
((obj_t)BgL_new1251z00_2681), BEOA); } 
return BgL_new1251z00_2681;} } } 

}



/* &<@anonymous:1846> */
obj_t BGl_z62zc3z04anonymousza31846ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2241)
{
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1845 */
obj_t BGl_z62lambda1845z62zz__libuv_typesz00(obj_t BgL_envz00_2242, obj_t BgL_oz00_2243, obj_t BgL_vz00_2244)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2243)))->BgL_z52callbackz52)=((obj_t)BgL_vz00_2244),BUNSPEC);} 

}



/* &lambda1844 */
obj_t BGl_z62lambda1844z62zz__libuv_typesz00(obj_t BgL_envz00_2245, obj_t BgL_oz00_2246)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2246)))->BgL_z52callbackz52);} 

}



/* &<@anonymous:1839> */
obj_t BGl_z62zc3z04anonymousza31839ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2247)
{
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1838 */
obj_t BGl_z62lambda1838z62zz__libuv_typesz00(obj_t BgL_envz00_2248, obj_t BgL_oz00_2249, obj_t BgL_vz00_2250)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2249)))->BgL_z52proccz52)=((obj_t)BgL_vz00_2250),BUNSPEC);} 

}



/* &lambda1837 */
obj_t BGl_z62lambda1837z62zz__libuv_typesz00(obj_t BgL_envz00_2251, obj_t BgL_oz00_2252)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2252)))->BgL_z52proccz52);} 

}



/* &<@anonymous:1832> */
obj_t BGl_z62zc3z04anonymousza31832ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2253)
{
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1831 */
obj_t BGl_z62lambda1831z62zz__libuv_typesz00(obj_t BgL_envz00_2254, obj_t BgL_oz00_2255, obj_t BgL_vz00_2256)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2255)))->BgL_z52procaz52)=((obj_t)BgL_vz00_2256),BUNSPEC);} 

}



/* &lambda1830 */
obj_t BGl_z62lambda1830z62zz__libuv_typesz00(obj_t BgL_envz00_2257, obj_t BgL_oz00_2258)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2258)))->BgL_z52procaz52);} 

}



/* &<@anonymous:1825> */
obj_t BGl_z62zc3z04anonymousza31825ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2259)
{
{ /* Llib/uvtypes.scm 40 */
return 
BINT(((long)0));} 

}



/* &lambda1824 */
obj_t BGl_z62lambda1824z62zz__libuv_typesz00(obj_t BgL_envz00_2260, obj_t BgL_oz00_2261, obj_t BgL_vz00_2262)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2261)))->BgL_z52offsetz52)=((obj_t)BgL_vz00_2262),BUNSPEC);} 

}



/* &lambda1823 */
obj_t BGl_z62lambda1823z62zz__libuv_typesz00(obj_t BgL_envz00_2263, obj_t BgL_oz00_2264)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2264)))->BgL_z52offsetz52);} 

}



/* &<@anonymous:1818> */
obj_t BGl_z62zc3z04anonymousza31818ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2265)
{
{ /* Llib/uvtypes.scm 40 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1817 */
obj_t BGl_z62lambda1817z62zz__libuv_typesz00(obj_t BgL_envz00_2266, obj_t BgL_oz00_2267, obj_t BgL_vz00_2268)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2267)))->BgL_z52allocz52)=((obj_t)BgL_vz00_2268),BUNSPEC);} 

}



/* &lambda1816 */
obj_t BGl_z62lambda1816z62zz__libuv_typesz00(obj_t BgL_envz00_2269, obj_t BgL_oz00_2270)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2270)))->BgL_z52allocz52);} 

}



/* &lambda1811 */
obj_t BGl_z62lambda1811z62zz__libuv_typesz00(obj_t BgL_envz00_2271, obj_t BgL_oz00_2272, obj_t BgL_vz00_2273)
{
{ /* Llib/uvtypes.scm 40 */
return 
((((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2272)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_vz00_2273)),BUNSPEC);} 

}



/* &lambda1810 */
BgL_uvloopz00_bglt BGl_z62lambda1810z62zz__libuv_typesz00(obj_t BgL_envz00_2274, obj_t BgL_oz00_2275)
{
{ /* Llib/uvtypes.scm 40 */
return 
(((BgL_uvstreamz00_bglt)COBJECT(
((BgL_uvstreamz00_bglt)BgL_oz00_2275)))->BgL_loopz00);} 

}



/* &<@anonymous:1783> */
obj_t BGl_z62zc3z04anonymousza31783ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2276, obj_t BgL_new1068z00_2277)
{
{ /* Llib/uvtypes.scm 36 */
{ 
BgL_uvwatcherz00_bglt BgL_auxz00_4482;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2277))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2277))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2277))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2277))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2277))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ 
BgL_uvloopz00_bglt BgL_auxz00_4499;
{ /* Llib/uvtypes.scm 36 */
obj_t BgL_classz00_2700;
BgL_classz00_2700 = BGl_UvLoopz00zz__libuv_typesz00; 
{ /* Llib/uvtypes.scm 36 */
obj_t BgL__ortest_1106z00_2701;
BgL__ortest_1106z00_2701 = 
BGL_CLASS_NIL(BgL_classz00_2700); 
if(
CBOOL(BgL__ortest_1106z00_2701))
{ /* Llib/uvtypes.scm 36 */
BgL_auxz00_4499 = 
((BgL_uvloopz00_bglt)BgL__ortest_1106z00_2701)
; }  else 
{ /* Llib/uvtypes.scm 36 */
BgL_auxz00_4499 = 
((BgL_uvloopz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_2700))
; } } } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2277)))->BgL_loopz00)=((BgL_uvloopz00_bglt)BgL_auxz00_4499),BUNSPEC); } 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2277)))->BgL_cbz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_4482 = 
((BgL_uvwatcherz00_bglt)BgL_new1068z00_2277); 
return 
((obj_t)BgL_auxz00_4482);} } 

}



/* &lambda1781 */
BgL_uvwatcherz00_bglt BGl_z62lambda1781z62zz__libuv_typesz00(obj_t BgL_envz00_2278)
{
{ /* Llib/uvtypes.scm 36 */
{ /* Llib/uvtypes.scm 36 */
BgL_uvwatcherz00_bglt BgL_new1067z00_2702;
BgL_new1067z00_2702 = 
((BgL_uvwatcherz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvwatcherz00_bgl) ))); 
{ /* Llib/uvtypes.scm 36 */
long BgL_arg1782z00_2703;
{ /* Llib/uvtypes.scm 36 */
long BgL_res2240z00_2704;
BgL_res2240z00_2704 = 
BGL_CLASS_INDEX(BGl_UvWatcherz00zz__libuv_typesz00); 
BgL_arg1782z00_2703 = BgL_res2240z00_2704; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1067z00_2702), BgL_arg1782z00_2703); } 
return BgL_new1067z00_2702;} } 

}



/* &<@anonymous:1795> */
obj_t BGl_z62zc3z04anonymousza31795ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2279)
{
{ /* Llib/uvtypes.scm 36 */
return BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;} 

}



/* &lambda1794 */
obj_t BGl_z62lambda1794z62zz__libuv_typesz00(obj_t BgL_envz00_2280, obj_t BgL_oz00_2281, obj_t BgL_vz00_2282)
{
{ /* Llib/uvtypes.scm 36 */
return 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2281)))->BgL_cbz00)=((obj_t)
((obj_t)BgL_vz00_2282)),BUNSPEC);} 

}



/* &lambda1793 */
obj_t BGl_z62lambda1793z62zz__libuv_typesz00(obj_t BgL_envz00_2283, obj_t BgL_oz00_2284)
{
{ /* Llib/uvtypes.scm 36 */
return 
(((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2284)))->BgL_cbz00);} 

}



/* &lambda1788 */
obj_t BGl_z62lambda1788z62zz__libuv_typesz00(obj_t BgL_envz00_2285, obj_t BgL_oz00_2286, obj_t BgL_vz00_2287)
{
{ /* Llib/uvtypes.scm 36 */
return 
((((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2286)))->BgL_loopz00)=((BgL_uvloopz00_bglt)
((BgL_uvloopz00_bglt)BgL_vz00_2287)),BUNSPEC);} 

}



/* &lambda1787 */
BgL_uvloopz00_bglt BGl_z62lambda1787z62zz__libuv_typesz00(obj_t BgL_envz00_2288, obj_t BgL_oz00_2289)
{
{ /* Llib/uvtypes.scm 36 */
return 
(((BgL_uvwatcherz00_bglt)COBJECT(
((BgL_uvwatcherz00_bglt)BgL_oz00_2289)))->BgL_loopz00);} 

}



/* &<@anonymous:1769> */
obj_t BGl_z62zc3z04anonymousza31769ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2290, obj_t BgL_new1065z00_2291)
{
{ /* Llib/uvtypes.scm 33 */
{ 
BgL_uvloopz00_bglt BgL_auxz00_4526;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2291))))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2291))))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2291))))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2291))))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)
((BgL_uvloopz00_bglt)BgL_new1065z00_2291))))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_new1065z00_2291)))->BgL_z52mutexz52)=((obj_t)
BGl_mutexzd2nilzd2zz__threadz00()),BUNSPEC); 
BgL_auxz00_4526 = 
((BgL_uvloopz00_bglt)BgL_new1065z00_2291); 
return 
((obj_t)BgL_auxz00_4526);} } 

}



/* &lambda1767 */
BgL_uvloopz00_bglt BGl_z62lambda1767z62zz__libuv_typesz00(obj_t BgL_envz00_2292)
{
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1064z00_2712;
BgL_new1064z00_2712 = 
((BgL_uvloopz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvloopz00_bgl) ))); 
{ /* Llib/uvtypes.scm 33 */
long BgL_arg1768z00_2713;
{ /* Llib/uvtypes.scm 33 */
long BgL_res2239z00_2714;
BgL_res2239z00_2714 = 
BGL_CLASS_INDEX(BGl_UvLoopz00zz__libuv_typesz00); 
BgL_arg1768z00_2713 = BgL_res2239z00_2714; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_2712), BgL_arg1768z00_2713); } 
return BgL_new1064z00_2712;} } 

}



/* &lambda1756 */
BgL_uvloopz00_bglt BGl_z62lambda1756z62zz__libuv_typesz00(obj_t BgL_envz00_2293, obj_t BgL_z42builtin1058z42_2294, obj_t BgL_z52onclose1059z52_2295, obj_t BgL_z52gcmarkshead1060z52_2296, obj_t BgL_z52gcmarkstail1061z52_2297, obj_t BgL_closed1062z00_2298, obj_t BgL_z52mutex1063z52_2299)
{
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 33 */
uv_handle_t * BgL_z42builtin1058z42_2715;bool_t BgL_closed1062z00_2718;
BgL_z42builtin1058z42_2715 = 
FOREIGN_TO_COBJ(BgL_z42builtin1058z42_2294); 
BgL_closed1062z00_2718 = 
CBOOL(BgL_closed1062z00_2298); 
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1249z00_2720;
{ /* Llib/uvtypes.scm 33 */
BgL_uvloopz00_bglt BgL_new1248z00_2721;
BgL_new1248z00_2721 = 
((BgL_uvloopz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvloopz00_bgl) ))); 
{ /* Llib/uvtypes.scm 33 */
long BgL_arg1766z00_2722;
{ /* Llib/uvtypes.scm 33 */
long BgL_res2238z00_2723;
BgL_res2238z00_2723 = 
BGL_CLASS_INDEX(BGl_UvLoopz00zz__libuv_typesz00); 
BgL_arg1766z00_2722 = BgL_res2238z00_2723; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1248z00_2721), BgL_arg1766z00_2722); } 
BgL_new1249z00_2720 = BgL_new1248z00_2721; } 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2720)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1058z42_2715),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2720)))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1059z52_2295),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2720)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1060z52_2296)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2720)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1061z52_2297)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1249z00_2720)))->BgL_closedz00)=((bool_t)BgL_closed1062z00_2718),BUNSPEC); 
((((BgL_uvloopz00_bglt)COBJECT(BgL_new1249z00_2720))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_z52mutex1063z52_2299)),BUNSPEC); 
{ /* Llib/uvtypes.scm 33 */
obj_t BgL_fun1757z00_2724;
BgL_fun1757z00_2724 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvLoopz00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1757z00_2724)(BgL_fun1757z00_2724, 
((obj_t)BgL_new1249z00_2720), BEOA); } 
return BgL_new1249z00_2720;} } } 

}



/* &<@anonymous:1776> */
obj_t BGl_z62zc3z04anonymousza31776ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2300)
{
{ /* Llib/uvtypes.scm 33 */
{ /* Llib/uvtypes.scm 34 */

{ /* Llib/uvtypes.scm 34 */
obj_t BgL_namez00_2725;
BgL_namez00_2725 = 
BGl_gensymz00zz__r4_symbols_6_4z00(
CNST_TABLE_REF(((long)20))); 
{ /* Llib/uvtypes.scm 34 */

{ /* Llib/uvtypes.scm 34 */
obj_t BgL_res2237z00_2726;
BgL_res2237z00_2726 = 
bgl_make_mutex(BgL_namez00_2725); 
return BgL_res2237z00_2726;} } } } } 

}



/* &lambda1775 */
obj_t BGl_z62lambda1775z62zz__libuv_typesz00(obj_t BgL_envz00_2301, obj_t BgL_oz00_2302, obj_t BgL_vz00_2303)
{
{ /* Llib/uvtypes.scm 33 */
return 
((((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_oz00_2302)))->BgL_z52mutexz52)=((obj_t)
((obj_t)BgL_vz00_2303)),BUNSPEC);} 

}



/* &lambda1774 */
obj_t BGl_z62lambda1774z62zz__libuv_typesz00(obj_t BgL_envz00_2304, obj_t BgL_oz00_2305)
{
{ /* Llib/uvtypes.scm 33 */
return 
(((BgL_uvloopz00_bglt)COBJECT(
((BgL_uvloopz00_bglt)BgL_oz00_2305)))->BgL_z52mutexz52);} 

}



/* &<@anonymous:1678> */
obj_t BGl_z62zc3z04anonymousza31678ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2306, obj_t BgL_new1056z00_2307)
{
{ /* Llib/uvtypes.scm 26 */
{ 
BgL_uvhandlez00_bglt BgL_auxz00_4586;
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2307)))->BgL_z42builtinz42)=((uv_handle_t *)
0L),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2307)))->BgL_z52onclosez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2307)))->BgL_z52gcmarksheadz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2307)))->BgL_z52gcmarkstailz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_new1056z00_2307)))->BgL_closedz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_4586 = 
((BgL_uvhandlez00_bglt)BgL_new1056z00_2307); 
return 
((obj_t)BgL_auxz00_4586);} } 

}



/* &lambda1676 */
BgL_uvhandlez00_bglt BGl_z62lambda1676z62zz__libuv_typesz00(obj_t BgL_envz00_2308)
{
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1055z00_2731;
BgL_new1055z00_2731 = 
((BgL_uvhandlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvhandlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 26 */
long BgL_arg1677z00_2732;
{ /* Llib/uvtypes.scm 26 */
long BgL_res2236z00_2733;
BgL_res2236z00_2733 = 
BGL_CLASS_INDEX(BGl_UvHandlez00zz__libuv_typesz00); 
BgL_arg1677z00_2732 = BgL_res2236z00_2733; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1055z00_2731), BgL_arg1677z00_2732); } 
return BgL_new1055z00_2731;} } 

}



/* &lambda1668 */
BgL_uvhandlez00_bglt BGl_z62lambda1668z62zz__libuv_typesz00(obj_t BgL_envz00_2309, obj_t BgL_z42builtin1050z42_2310, obj_t BgL_z52onclose1051z52_2311, obj_t BgL_z52gcmarkshead1052z52_2312, obj_t BgL_z52gcmarkstail1053z52_2313, obj_t BgL_closed1054z00_2314)
{
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
uv_handle_t * BgL_z42builtin1050z42_2734;bool_t BgL_closed1054z00_2737;
BgL_z42builtin1050z42_2734 = 
FOREIGN_TO_COBJ(BgL_z42builtin1050z42_2310); 
BgL_closed1054z00_2737 = 
CBOOL(BgL_closed1054z00_2314); 
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1247z00_2738;
{ /* Llib/uvtypes.scm 26 */
BgL_uvhandlez00_bglt BgL_new1246z00_2739;
BgL_new1246z00_2739 = 
((BgL_uvhandlez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_uvhandlez00_bgl) ))); 
{ /* Llib/uvtypes.scm 26 */
long BgL_arg1675z00_2740;
{ /* Llib/uvtypes.scm 26 */
long BgL_res2235z00_2741;
BgL_res2235z00_2741 = 
BGL_CLASS_INDEX(BGl_UvHandlez00zz__libuv_typesz00); 
BgL_arg1675z00_2740 = BgL_res2235z00_2741; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1246z00_2739), BgL_arg1675z00_2740); } 
BgL_new1247z00_2738 = BgL_new1246z00_2739; } 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2738))->BgL_z42builtinz42)=((uv_handle_t *)BgL_z42builtin1050z42_2734),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2738))->BgL_z52onclosez52)=((obj_t)BgL_z52onclose1051z52_2311),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2738))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_z52gcmarkshead1052z52_2312)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2738))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_z52gcmarkstail1053z52_2313)),BUNSPEC); 
((((BgL_uvhandlez00_bglt)COBJECT(BgL_new1247z00_2738))->BgL_closedz00)=((bool_t)BgL_closed1054z00_2737),BUNSPEC); 
{ /* Llib/uvtypes.scm 26 */
obj_t BgL_fun1669z00_2742;
BgL_fun1669z00_2742 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_UvHandlez00zz__libuv_typesz00); 
PROCEDURE_ENTRY(BgL_fun1669z00_2742)(BgL_fun1669z00_2742, 
((obj_t)BgL_new1247z00_2738), BEOA); } 
return BgL_new1247z00_2738;} } } 

}



/* &<@anonymous:1731> */
obj_t BGl_z62zc3z04anonymousza31731ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2315)
{
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1730 */
obj_t BGl_z62lambda1730z62zz__libuv_typesz00(obj_t BgL_envz00_2316, obj_t BgL_oz00_2317, obj_t BgL_vz00_2318)
{
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
bool_t BgL_vz00_2744;
BgL_vz00_2744 = 
CBOOL(BgL_vz00_2318); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2317)))->BgL_closedz00)=((bool_t)BgL_vz00_2744),BUNSPEC);} } 

}



/* &lambda1729 */
obj_t BGl_z62lambda1729z62zz__libuv_typesz00(obj_t BgL_envz00_2319, obj_t BgL_oz00_2320)
{
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2320)))->BgL_closedz00));} 

}



/* &<@anonymous:1717> */
obj_t BGl_z62zc3z04anonymousza31717ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2321)
{
{ /* Llib/uvtypes.scm 26 */
return BNIL;} 

}



/* &lambda1716 */
obj_t BGl_z62lambda1716z62zz__libuv_typesz00(obj_t BgL_envz00_2322, obj_t BgL_oz00_2323, obj_t BgL_vz00_2324)
{
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2323)))->BgL_z52gcmarkstailz52)=((obj_t)
((obj_t)BgL_vz00_2324)),BUNSPEC);} 

}



/* &lambda1715 */
obj_t BGl_z62lambda1715z62zz__libuv_typesz00(obj_t BgL_envz00_2325, obj_t BgL_oz00_2326)
{
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2326)))->BgL_z52gcmarkstailz52);} 

}



/* &<@anonymous:1710> */
obj_t BGl_z62zc3z04anonymousza31710ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2327)
{
{ /* Llib/uvtypes.scm 26 */
return BNIL;} 

}



/* &lambda1709 */
obj_t BGl_z62lambda1709z62zz__libuv_typesz00(obj_t BgL_envz00_2328, obj_t BgL_oz00_2329, obj_t BgL_vz00_2330)
{
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2329)))->BgL_z52gcmarksheadz52)=((obj_t)
((obj_t)BgL_vz00_2330)),BUNSPEC);} 

}



/* &lambda1708 */
obj_t BGl_z62lambda1708z62zz__libuv_typesz00(obj_t BgL_envz00_2331, obj_t BgL_oz00_2332)
{
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2332)))->BgL_z52gcmarksheadz52);} 

}



/* &<@anonymous:1697> */
obj_t BGl_z62zc3z04anonymousza31697ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2333)
{
{ /* Llib/uvtypes.scm 26 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1696 */
obj_t BGl_z62lambda1696z62zz__libuv_typesz00(obj_t BgL_envz00_2334, obj_t BgL_oz00_2335, obj_t BgL_vz00_2336)
{
{ /* Llib/uvtypes.scm 26 */
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2335)))->BgL_z52onclosez52)=((obj_t)BgL_vz00_2336),BUNSPEC);} 

}



/* &lambda1695 */
obj_t BGl_z62lambda1695z62zz__libuv_typesz00(obj_t BgL_envz00_2337, obj_t BgL_oz00_2338)
{
{ /* Llib/uvtypes.scm 26 */
return 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2338)))->BgL_z52onclosez52);} 

}



/* &<@anonymous:1690> */
obj_t BGl_z62zc3z04anonymousza31690ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2339)
{
{ /* Llib/uvtypes.scm 26 */
return 
void_star_to_obj(0L);} 

}



/* &lambda1689 */
obj_t BGl_z62lambda1689z62zz__libuv_typesz00(obj_t BgL_envz00_2340, obj_t BgL_oz00_2341, obj_t BgL_vz00_2342)
{
{ /* Llib/uvtypes.scm 26 */
{ /* Llib/uvtypes.scm 26 */
uv_handle_t * BgL_vz00_2755;
BgL_vz00_2755 = 
FOREIGN_TO_COBJ(BgL_vz00_2342); 
return 
((((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2341)))->BgL_z42builtinz42)=((uv_handle_t *)BgL_vz00_2755),BUNSPEC);} } 

}



/* &lambda1688 */
obj_t BGl_z62lambda1688z62zz__libuv_typesz00(obj_t BgL_envz00_2343, obj_t BgL_oz00_2344)
{
{ /* Llib/uvtypes.scm 26 */
return 
void_star_to_obj(
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_oz00_2344)))->BgL_z42builtinz42));} 

}



/* &<@anonymous:1651> */
obj_t BGl_z62zc3z04anonymousza31651ze3ze5zz__libuv_typesz00(obj_t BgL_envz00_2345, obj_t BgL_new1048z00_2346)
{
{ /* Llib/uvtypes.scm 23 */
return 
((obj_t)
((BgL_z52uvz52_bglt)BgL_new1048z00_2346));} 

}



/* &lambda1644 */
BgL_z52uvz52_bglt BGl_z62lambda1644z62zz__libuv_typesz00(obj_t BgL_envz00_2347)
{
{ /* Llib/uvtypes.scm 23 */
{ /* Llib/uvtypes.scm 23 */
BgL_z52uvz52_bglt BgL_new1047z00_2758;
BgL_new1047z00_2758 = 
((BgL_z52uvz52_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52uvz52_bgl) ))); 
{ /* Llib/uvtypes.scm 23 */
long BgL_arg1650z00_2759;
{ /* Llib/uvtypes.scm 23 */
long BgL_res2234z00_2760;
BgL_res2234z00_2760 = 
BGL_CLASS_INDEX(BGl_z52Uvz52zz__libuv_typesz00); 
BgL_arg1650z00_2759 = BgL_res2234z00_2760; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1047z00_2758), BgL_arg1650z00_2759); } 
return BgL_new1047z00_2758;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, BGl_proc2459z00zz__libuv_typesz00, BGl_z52Uvz52zz__libuv_typesz00, BGl_string2460z00zz__libuv_typesz00);} 

}



/* &%uv-init1337 */
obj_t BGl_z62z52uvzd2init1337ze2zz__libuv_typesz00(obj_t BgL_envz00_2351, obj_t BgL_oz00_2352)
{
{ /* Llib/uvtypes.scm 187 */
return 
((obj_t)
((BgL_z52uvz52_bglt)BgL_oz00_2352));} 

}



/* %uv-init */
BGL_EXPORTED_DEF obj_t BGl_z52uvzd2initz80zz__libuv_typesz00(BgL_z52uvz52_bglt BgL_oz00_4)
{
{ /* Llib/uvtypes.scm 187 */
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_method1338z00_1200;
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_res2283z00_1664;
{ /* Llib/uvtypes.scm 187 */
long BgL_objzd2classzd2numz00_1629;
{ /* Llib/uvtypes.scm 187 */
long BgL_res2273z00_1632;
BgL_res2273z00_1632 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_4)); 
BgL_objzd2classzd2numz00_1629 = BgL_res2273z00_1632; } 
{ /* Llib/uvtypes.scm 187 */
obj_t BgL_arg1759z00_1630;
BgL_arg1759z00_1630 = 
PROCEDURE_REF(BGl_z52uvzd2initzd2envz52zz__libuv_typesz00, 
(int)(((long)1))); 
{ /* Llib/uvtypes.scm 187 */
int BgL_offsetz00_1634;
BgL_offsetz00_1634 = 
(int)(BgL_objzd2classzd2numz00_1629); 
{ /* Llib/uvtypes.scm 187 */
long BgL_offsetz00_1635;
BgL_offsetz00_1635 = 
(
(long)(BgL_offsetz00_1634)-OBJECT_TYPE); 
{ /* Llib/uvtypes.scm 187 */
long BgL_modz00_1636;
BgL_modz00_1636 = 
(BgL_offsetz00_1635 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/uvtypes.scm 187 */
long BgL_restz00_1638;
BgL_restz00_1638 = 
(BgL_offsetz00_1635 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/uvtypes.scm 187 */

{ /* Llib/uvtypes.scm 187 */
obj_t BgL_bucketz00_1640;
BgL_bucketz00_1640 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_1630),BgL_modz00_1636); 
BgL_res2283z00_1664 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1640),BgL_restz00_1638); } } } } } } } } 
BgL_method1338z00_1200 = BgL_res2283z00_1664; } 
return 
PROCEDURE_ENTRY(BgL_method1338z00_1200)(BgL_method1338z00_1200, 
((obj_t)BgL_oz00_4), BEOA);} } 

}



/* &%uv-init */
obj_t BGl_z62z52uvzd2initze2zz__libuv_typesz00(obj_t BgL_envz00_2348, obj_t BgL_oz00_2349)
{
{ /* Llib/uvtypes.scm 187 */
return 
BGl_z52uvzd2initz80zz__libuv_typesz00(
((BgL_z52uvz52_bglt)BgL_oz00_2349));} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__libuv_typesz00()
{
{ /* Llib/uvtypes.scm 15 */
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_UvHandlez00zz__libuv_typesz00, BGl_proc2461z00zz__libuv_typesz00, BGl_string2462z00zz__libuv_typesz00);} 

}



/* &object-print-UvHandl1340 */
obj_t BGl_z62objectzd2printzd2UvHandl1340z62zz__libuv_typesz00(obj_t BgL_envz00_2354, obj_t BgL_objz00_2355, obj_t BgL_portz00_2356, obj_t BgL_printzd2slotzd2_2357)
{
{ /* Llib/uvtypes.scm 193 */
{ 
obj_t BgL_fieldz00_2765;
{ /* Llib/uvtypes.scm 207 */
obj_t BgL_classz00_2771;
{ /* Llib/uvtypes.scm 207 */
long BgL_arg1762z00_2772;
{ /* Llib/uvtypes.scm 207 */
long BgL_arg1763z00_2773;
{ /* Llib/uvtypes.scm 207 */
long BgL_res2286z00_2774;
BgL_res2286z00_2774 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)
((BgL_uvhandlez00_bglt)BgL_objz00_2355))); 
BgL_arg1763z00_2773 = BgL_res2286z00_2774; } 
BgL_arg1762z00_2772 = 
(BgL_arg1763z00_2773-OBJECT_TYPE); } 
BgL_classz00_2771 = 
VECTOR_REF(BGl_za2classesza2z00zz__objectz00,BgL_arg1762z00_2772); } 
{ /* Llib/uvtypes.scm 207 */
obj_t BgL_classzd2namezd2_2775;
BgL_classzd2namezd2_2775 = 
BGl_classzd2namezd2zz__objectz00(BgL_classz00_2771); 
{ /* Llib/uvtypes.scm 208 */
obj_t BgL_fieldsz00_2776;
{ /* Llib/uvtypes.scm 209 */
obj_t BgL_res2288z00_2777;
{ /* Llib/uvtypes.scm 209 */
obj_t BgL_tmpz00_4700;
BgL_tmpz00_4700 = 
((obj_t)BgL_classz00_2771); 
BgL_res2288z00_2777 = 
BGL_CLASS_ALL_FIELDS(BgL_tmpz00_4700); } 
BgL_fieldsz00_2776 = BgL_res2288z00_2777; } 
{ /* Llib/uvtypes.scm 210 */

{ /* Llib/uvtypes.scm 211 */
obj_t BgL_tmpz00_4703;
BgL_tmpz00_4703 = 
((obj_t)BgL_portz00_2356); 
bgl_display_string(BGl_string2464z00zz__libuv_typesz00, BgL_tmpz00_4703); } 
bgl_display_obj(BgL_classzd2namezd2_2775, BgL_portz00_2356); 
{ /* Llib/uvtypes.scm 213 */
obj_t BgL_tmpz00_4707;
BgL_tmpz00_4707 = 
((obj_t)BgL_portz00_2356); 
bgl_display_string(BGl_string2465z00zz__libuv_typesz00, BgL_tmpz00_4707); } 
{ /* Llib/uvtypes.scm 214 */
obj_t BgL_arg2211z00_2778;
{ /* Llib/uvtypes.scm 214 */
int BgL_arg2212z00_2779;
{ /* Llib/uvtypes.scm 214 */
int BgL_res2289z00_2780;
{ /* Llib/uvtypes.scm 182 */
uv_handle_t * BgL_arg1346z00_2781;
BgL_arg1346z00_2781 = 
(((BgL_uvhandlez00_bglt)COBJECT(
((BgL_uvhandlez00_bglt)BgL_objz00_2355)))->BgL_z42builtinz42); 
BgL_res2289z00_2780 = 
(int)(
(long)(BgL_arg1346z00_2781)); } 
BgL_arg2212z00_2779 = BgL_res2289z00_2780; } 
BgL_arg2211z00_2778 = 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
(long)(BgL_arg2212z00_2779), ((long)16)); } 
bgl_display_obj(BgL_arg2211z00_2778, BgL_portz00_2356); } 
{ /* Llib/uvtypes.scm 215 */
obj_t BgL_tmpz00_4717;
BgL_tmpz00_4717 = 
((obj_t)BgL_portz00_2356); 
bgl_display_string(BGl_string2466z00zz__libuv_typesz00, BgL_tmpz00_4717); } 
if(
BGl_nilzf3zf3zz__objectz00(
((BgL_objectz00_bglt)
((BgL_uvhandlez00_bglt)BgL_objz00_2355))))
{ /* Llib/uvtypes.scm 217 */
obj_t BgL_tmpz00_4724;
BgL_tmpz00_4724 = 
((obj_t)BgL_portz00_2356); 
return 
bgl_display_string(BGl_string2467z00zz__libuv_typesz00, BgL_tmpz00_4724);}  else 
{ 
long BgL_iz00_2783;
BgL_iz00_2783 = ((long)0); 
BgL_loopz00_2782:
if(
(BgL_iz00_2783==
VECTOR_LENGTH(BgL_fieldsz00_2776)))
{ /* Llib/uvtypes.scm 220 */
obj_t BgL_tmpz00_4730;
BgL_tmpz00_4730 = 
((obj_t)BgL_portz00_2356); 
return 
bgl_display_char(((unsigned char)'|'), BgL_tmpz00_4730);}  else 
{ /* Llib/uvtypes.scm 219 */
BgL_fieldz00_2765 = 
VECTOR_REF(BgL_fieldsz00_2776,BgL_iz00_2783); 
{ /* Llib/uvtypes.scm 196 */
obj_t BgL_namez00_2766;
BgL_namez00_2766 = 
BGl_classzd2fieldzd2namez00zz__objectz00(BgL_fieldz00_2765); 
{ /* Llib/uvtypes.scm 196 */
obj_t BgL_getzd2valuezd2_2767;
BgL_getzd2valuezd2_2767 = 
BGl_classzd2fieldzd2accessorz00zz__objectz00(BgL_fieldz00_2765); 
{ /* Llib/uvtypes.scm 197 */
obj_t BgL_sz00_2768;
{ /* Llib/uvtypes.scm 198 */
obj_t BgL_res2284z00_2769;
BgL_res2284z00_2769 = 
SYMBOL_TO_STRING(BgL_namez00_2766); 
BgL_sz00_2768 = BgL_res2284z00_2769; } 
{ /* Llib/uvtypes.scm 198 */

if(
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(
BCHAR(
STRING_REF(BgL_sz00_2768, ((long)0))), 
CNST_TABLE_REF(((long)70)))))
{ /* Llib/uvtypes.scm 199 */BFALSE; }  else 
{ /* Llib/uvtypes.scm 199 */
{ /* Llib/uvtypes.scm 200 */
obj_t BgL_tmpz00_4742;
BgL_tmpz00_4742 = 
((obj_t)BgL_portz00_2356); 
bgl_display_string(BGl_string2463z00zz__libuv_typesz00, BgL_tmpz00_4742); } 
bgl_display_obj(BgL_namez00_2766, BgL_portz00_2356); 
{ /* Llib/uvtypes.scm 202 */
obj_t BgL_tmpz00_4746;
BgL_tmpz00_4746 = 
((obj_t)BgL_portz00_2356); 
bgl_display_char(((unsigned char)':'), BgL_tmpz00_4746); } 
{ /* Llib/uvtypes.scm 203 */
obj_t BgL_tmpz00_4749;
BgL_tmpz00_4749 = 
((obj_t)BgL_portz00_2356); 
bgl_display_char(((unsigned char)' '), BgL_tmpz00_4749); } 
{ /* Llib/uvtypes.scm 204 */
obj_t BgL_arg2221z00_2770;
BgL_arg2221z00_2770 = 
PROCEDURE_ENTRY(BgL_getzd2valuezd2_2767)(BgL_getzd2valuezd2_2767, 
((obj_t)
((BgL_uvhandlez00_bglt)BgL_objz00_2355)), BEOA); 
{ /* Llib/uvtypes.scm 204 */
obj_t BgL_tmpfunz00_4763;
BgL_tmpfunz00_4763 = 
((obj_t)BgL_printzd2slotzd2_2357); 
PROCEDURE_ENTRY(BgL_tmpfunz00_4763)(
((obj_t)BgL_printzd2slotzd2_2357), BgL_arg2221z00_2770, BgL_portz00_2356, BEOA); } } 
{ /* Llib/uvtypes.scm 205 */
obj_t BgL_tmpz00_4765;
BgL_tmpz00_4765 = 
((obj_t)BgL_portz00_2356); 
bgl_display_char(((unsigned char)']'), BgL_tmpz00_4765); } } } } } } 
{ 
long BgL_iz00_4769;
BgL_iz00_4769 = 
(BgL_iz00_2783+((long)1)); 
BgL_iz00_2783 = BgL_iz00_4769; 
goto BgL_loopz00_2782;} } } } } } } } } 

}

#ifdef __cplusplus
}
#endif
