/*===========================================================================*/
/*   (Llib/midi.scm)                                                         */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -unsafe -safee -copt -fPIC -copt -IUnix Llib/midi.scm -o objs/midi.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_midiscorez00_bgl {
   header_t header;
   obj_t widening;
   long BgL_formatz00;
   long BgL_tempoz00;
   long BgL_ppqz00;
   obj_t BgL_tracksz00;
} *BgL_midiscorez00_bglt;

typedef struct BgL_miditrackz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52streamz52;
   struct BgL_midireaderz00_bgl * BgL_z52readerz52;
   obj_t BgL_z52closez52;
   bool_t BgL_z52eotz52;
   uint32_t BgL_z52wtickz52;
   long BgL_z52statusz52;
   int32_t BgL_lenz00;
   long BgL_tempoz00;
   obj_t BgL_ipz00;
   long BgL_startz00;
   long BgL_datastartz00;
   uint32_t BgL_wtickz00;
   long BgL_statusz00;
   bool_t BgL_eotz00;
} *BgL_miditrackz00_bglt;

typedef struct BgL_midireaderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_peekzd2bytezd2;
   obj_t BgL_readzd2bytezd2;
   obj_t BgL_readzd2int16zd2;
   obj_t BgL_readzd2int32zd2;
   obj_t BgL_readzd2intzd2;
   obj_t BgL_readzd2vlqzd2;
   obj_t BgL_readzd2charszd2;
} *BgL_midireaderz00_bglt;

typedef struct BgL_midiplayerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_errz00;
   obj_t BgL_cdelayz00;
   obj_t BgL_noteoffz00;
   obj_t BgL_noteonz00;
   obj_t BgL_aftertouchz00;
   obj_t BgL_ctrlchangez00;
   obj_t BgL_prgmchangez00;
   obj_t BgL_afterzd2touchzd2;
   obj_t BgL_pitchz00;
   obj_t BgL_sysexz00;
   obj_t BgL_metazd2seqnumzd2;
   obj_t BgL_metazd2textzd2;
   obj_t BgL_metazd2copyrightzd2;
   obj_t BgL_metazd2trackzd2;
   obj_t BgL_metazd2instrumentzd2;
   obj_t BgL_metazd2lyriczd2;
   obj_t BgL_metazd2markerzd2;
   obj_t BgL_metazd2cuezd2;
   obj_t BgL_metazd2prgmnamezd2;
   obj_t BgL_metazd2devnamezd2;
   obj_t BgL_metazd2channprefzd2;
   obj_t BgL_metazd2midiportzd2;
   obj_t BgL_metazd2eotzd2;
   obj_t BgL_metazd2tempozd2;
   obj_t BgL_metazd2smtpezd2;
   obj_t BgL_metazd2timesigzd2;
   obj_t BgL_metazd2keysigzd2;
   obj_t BgL_metazd2seqspeczd2;
} *BgL_midiplayerz00_bglt;

typedef struct BgL_midisinkz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_streamz00;
   obj_t BgL_usleepz00;
   obj_t BgL_writezd2bytezd2;
   obj_t BgL_writezd2stringzd2;
   obj_t BgL_flushz00;
} *BgL_midisinkz00_bglt;


static obj_t BGl_z62lambda2490z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2491z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31683ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32485ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2498z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2499z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long);
static long BGl_readzd2intzd2zz__multimediazd2midizd2(long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt);
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
BGL_EXPORTED_DEF obj_t BGl_midiscorez00zz__multimediazd2midizd2 = BUNSPEC;
static BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(obj_t, long);
static obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
BGL_IMPORT obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2();
static int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32211ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midireaderz00zz__multimediazd2midizd2 = BUNSPEC;
static int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32140ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midireaderzd2init1233zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32232ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_midisinkz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32500ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32128ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
static obj_t BGl_z62zc3z04anonymousza32501ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31270ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32218ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32324ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31271ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31272ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32147ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiscorezd2init1229zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2init1235zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32253ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32415ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31273ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt);
static BgL_midiscorez00_bglt BGl_z62lambda2123z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_midiscorez00_bglt BGl_z62lambda2126z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32165ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31274ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2132z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2133z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2138z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2139z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32271ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31542ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32239ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2300z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2301z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2305z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2145z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2146z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32450ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31543ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32345ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t create_struct(obj_t, int);
static BgL_midiplayerz00_bglt BGl_z62lambda2312z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2152z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2153z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midiplayerz00_bglt BGl_z62lambda2315z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32540ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31544ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32508ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_miditrackz00_bglt BGl_z62lambda2160z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2322z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2323z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2();
static BgL_miditrackz00_bglt BGl_z62lambda2163z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2329z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32436ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31545ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2330z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2170z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2171z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2336z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2337z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2176z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32380ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2177z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32526ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2343z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2182z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2344z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2506z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2183z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2507z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2188z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62lambda2189z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2350z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2351z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2513z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2514z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2195z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2357z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32471ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2196z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2358z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32366ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static BgL_midisinkz00_bglt BGl_z62lambda2521z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_midisinkz00_bglt BGl_z62lambda2524z62zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2364z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2365z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2;
static obj_t BGl_z62lambda2531z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2532z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2371z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2372z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2538z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2539z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static obj_t BGl_z62lambda2378z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2379z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32457ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62lambda2545z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2546z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2385z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2386z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32563ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2553z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2392z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2554z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2393z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32548ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2399z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2561z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2562z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32387ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long);
static obj_t BGl_z62zc3z04anonymousza32493ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32478ze3ze5zz__multimediazd2midizd2(obj_t);
static BgL_midisinkz00_bglt BGl_midisinkzd2nullzd2zz__multimediazd2midizd2;
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, BgL_miditrackz00_bglt, long, long, long);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_writezd2stringzd2zz__r4_output_6_10_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2();
BGL_EXPORTED_DEF obj_t BGl_midiplayerz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32204ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, BGL_LONGLONG_T);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_miditrackz00zz__multimediazd2midizd2 = BUNSPEC;
static obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charzd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32401ze3ze5zz__multimediazd2midizd2(obj_t);
static bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
static bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt, BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t, long, long);
static obj_t BGl_z62zc3z04anonymousza32225ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32331ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32154ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32260ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32422ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32317ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT BGL_LONGLONG_T bgl_current_microseconds();
static BgL_midiplayerz00_bglt BGl_midiplayerzd2readzd2zz__multimediazd2midizd2;
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32172ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2202z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2203z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2209z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, long, long, long);
static BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32246ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32408ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31266ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
static obj_t BGl_z62lambda2210z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2216z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2217z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32190ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32352ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31518ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31267ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2223z62zz__multimediazd2midizd2(obj_t, obj_t);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t, long);
static obj_t BGl_z62lambda2224z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32515ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31519ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31268ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2230z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2231z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midisinkzd2init1237zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2237z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2238z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2();
static obj_t BGl_z62zc3z04anonymousza32443ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32338ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31269ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2();
static obj_t BGl_z62lambda2400z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2244z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2406z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2245z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2407z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32533ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2251z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2413z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2252z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2414z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62lambda2258z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2259z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32429ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62miditrackzd2init1231zb0zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2420z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2421z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2427z62zz__multimediazd2midizd2(obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2266z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2428z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32373ze3ze5zz__multimediazd2midizd2(obj_t);
static BgL_midireaderz00_bglt BGl_z62lambda2269z62zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62lambda2434z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2435z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2275z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2276z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2441z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2280z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2442z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2281z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2285z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2286z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2448z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2449z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32464ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32197ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32359ze3ze5zz__multimediazd2midizd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt);
static obj_t BGl_z62lambda2290z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2291z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2455z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2456z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_z62lambda2295z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2296z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static BgL_midireaderz00_bglt BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2;
static obj_t BGl_z62lambda2462z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2463z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32555ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62lambda2469z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2470z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2476z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2477z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32394ze3ze5zz__multimediazd2midizd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32556ze3ze5zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt);
BGL_EXPORTED_DECL BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt, BgL_midisinkz00_bglt, long, obj_t);
static obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2483z62zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t BGl_z62lambda2484z62zz__multimediazd2midizd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31682ze3ze5zz__multimediazd2midizd2(obj_t, obj_t);
static obj_t __cnst[ 76 ] ;


BGL_IMPORT obj_t BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_EXPORT_BGL_GENERIC( BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3337z00, BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3338z00, BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3134z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2133za7623339z00, BGl_z62lambda2133z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23340z00, BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3135z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2132za7623341z00, BGl_z62lambda2132z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3136z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3342za7, BGl_z62zc3z04anonymousza32140ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3137z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2139za7623343z00, BGl_z62lambda2139z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3138z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2138za7623344z00, BGl_z62lambda2138z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3139z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3345za7, BGl_z62zc3z04anonymousza32147ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3300z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2538za7623346z00, BGl_z62lambda2538z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3301z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3347za7, BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3302z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2546za7623348z00, BGl_z62lambda2546z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3140z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2146za7623349z00, BGl_z62lambda2146z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3303z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2545za7623350z00, BGl_z62lambda2545z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3141z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2145za7623351z00, BGl_z62lambda2145z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3304z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3352za7, BGl_z62zc3z04anonymousza32555ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3142z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3353za7, BGl_z62zc3z04anonymousza32154ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3305z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2554za7623354z00, BGl_z62lambda2554z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3143z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2153za7623355z00, BGl_z62lambda2153z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3306z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2553za7623356z00, BGl_z62lambda2553z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3144z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2152za7623357z00, BGl_z62lambda2152z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3307z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3358za7, BGl_z62zc3z04anonymousza32563ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3145z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3359za7, BGl_z62zc3z04anonymousza32128ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3308z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2562za7623360z00, BGl_z62lambda2562z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3146z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2126za7623361z00, BGl_z62lambda2126z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3309z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2561za7623362z00, BGl_z62lambda2561z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3147z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2123za7623363z00, BGl_z62lambda2123z62zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3148z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3364za7, BGl_z62zc3z04anonymousza32172ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3149z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2171za7623365z00, BGl_z62lambda2171z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3310z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3366za7, BGl_z62zc3z04anonymousza32526ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3311z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2524za7623367z00, BGl_z62lambda2524z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3312z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2521za7623368z00, BGl_z62lambda2521z62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3150z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2170za7623369z00, BGl_z62lambda2170z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3313z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3370za7, BGl_z62zc3z04anonymousza32556ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3151z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2177za7623371z00, BGl_z62lambda2177z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3314z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3372za7, BGl_z62zc3z04anonymousza32548ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3152z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2176za7623373z00, BGl_z62lambda2176z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3315z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3374za7, BGl_z62zc3z04anonymousza32501ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3153z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2183za7623375z00, BGl_z62lambda2183z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3316z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3376za7, BGl_z62zc3z04anonymousza32493ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3154z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2182za7623377z00, BGl_z62lambda2182z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3317z00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3378z00, BGl_z62midiscorezd2init1229zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3155z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3379za7, BGl_z62zc3z04anonymousza32190ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3156z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2189za7623380z00, BGl_z62lambda2189z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3319z00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3381z00, BGl_z62miditrackzd2init1231zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3157z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2188za7623382z00, BGl_z62lambda2188z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3080z00zz__multimediazd2midizd2, BgL_bgl_string3080za700za7za7_3383za7, "midiscore-file", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3158z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3384za7, BGl_z62zc3z04anonymousza32197ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3081z00zz__multimediazd2midizd2, BgL_bgl_string3081za700za7za7_3385za7, "format not supported", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3159z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2196za7623386z00, BGl_z62lambda2196z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3082z00zz__multimediazd2midizd2, BgL_bgl_string3082za700za7za7_3387za7, "midiplayer-file", 15 );
DEFINE_STRING( BGl_string3083z00zz__multimediazd2midizd2, BgL_bgl_string3083za700za7za7_3388za7, "bad midi format", 15 );
DEFINE_STRING( BGl_string3084z00zz__multimediazd2midizd2, BgL_bgl_string3084za700za7za7_3389za7, "/builddir/build/BUILD/bigloo-4.4a/api/multimedia/src/Llib/midi.scm", 66 );
DEFINE_STRING( BGl_string3085z00zz__multimediazd2midizd2, BgL_bgl_string3085za700za7za7_3390za7, "&midiscore-file", 15 );
DEFINE_STRING( BGl_string3086z00zz__multimediazd2midizd2, BgL_bgl_string3086za700za7za7_3391za7, "bstring", 7 );
DEFINE_STRING( BGl_string3087z00zz__multimediazd2midizd2, BgL_bgl_string3087za700za7za7_3392za7, "&miditrack-input-port", 21 );
DEFINE_STRING( BGl_string3088z00zz__multimediazd2midizd2, BgL_bgl_string3088za700za7za7_3393za7, "input-port", 10 );
DEFINE_STRING( BGl_string3089z00zz__multimediazd2midizd2, BgL_bgl_string3089za700za7za7_3394za7, "bint", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2vlqza7b03395za7, BGl_z62readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3321z00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23396z00, BGl_z62midireaderzd2init1233zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3160z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2195za7623397z00, BGl_z62lambda2195z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3323z00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23398z00, BGl_z62midiplayerzd2init1235zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3161z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3399za7, BGl_z62zc3z04anonymousza32204ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3162z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2203za7623400z00, BGl_z62lambda2203z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3325z00zz__multimediazd2midizd2, BgL_bgl_za762midisinkza7d2in3401z00, BGl_z62midisinkzd2init1237zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3163z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2202za7623402z00, BGl_z62lambda2202z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3164z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3403za7, BGl_z62zc3z04anonymousza32211ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3165z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2210za7623404z00, BGl_z62lambda2210z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3166z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2209za7623405z00, BGl_z62lambda2209z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3167z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3406za7, BGl_z62zc3z04anonymousza32218ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3090z00zz__multimediazd2midizd2, BgL_bgl_string3090za700za7za7_3407za7, "&miditrack-file", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3168z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2217za7623408z00, BGl_z62lambda2217z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3169z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2216za7623409z00, BGl_z62lambda2216z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3092z00zz__multimediazd2midizd2, BgL_bgl_string3092za700za7za7_3410za7, "&miditrack-string", 17 );
DEFINE_STRING( BGl_string3093z00zz__multimediazd2midizd2, BgL_bgl_string3093za700za7za7_3411za7, "midiscore-play", 14 );
DEFINE_STRING( BGl_string3094z00zz__multimediazd2midizd2, BgL_bgl_string3094za700za7za7_3412za7, "&midiscore-play", 15 );
DEFINE_STRING( BGl_string3095z00zz__multimediazd2midizd2, BgL_bgl_string3095za700za7za7_3413za7, "midiscore", 9 );
DEFINE_STRING( BGl_string3096z00zz__multimediazd2midizd2, BgL_bgl_string3096za700za7za7_3414za7, "midiplayer", 10 );
DEFINE_STRING( BGl_string3097z00zz__multimediazd2midizd2, BgL_bgl_string3097za700za7za7_3415za7, "midisink", 8 );
DEFINE_STRING( BGl_string3098z00zz__multimediazd2midizd2, BgL_bgl_string3098za700za7za7_3416za7, "~x:~x", 5 );
DEFINE_STRING( BGl_string3099z00zz__multimediazd2midizd2, BgL_bgl_string3099za700za7za7_3417za7, "midiplay", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3170z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3418za7, BGl_z62zc3z04anonymousza32225ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3171z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2224za7623419z00, BGl_z62lambda2224z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3172z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2223za7623420z00, BGl_z62lambda2223z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3173z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3421za7, BGl_z62zc3z04anonymousza32232ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3174z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2231za7623422z00, BGl_z62lambda2231z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3175z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2230za7623423z00, BGl_z62lambda2230z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3176z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3424za7, BGl_z62zc3z04anonymousza32239ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3177z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2238za7623425z00, BGl_z62lambda2238z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3178z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2237za7623426z00, BGl_z62lambda2237z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3179z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3427za7, BGl_z62zc3z04anonymousza32246ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3180z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2245za7623428z00, BGl_z62lambda2245z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3181z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2244za7623429z00, BGl_z62lambda2244z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3430z00, BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3182z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3431za7, BGl_z62zc3z04anonymousza32253ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3183z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2252za7623432z00, BGl_z62lambda2252z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3184z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2251za7623433z00, BGl_z62lambda2251z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3185z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3434za7, BGl_z62zc3z04anonymousza32260ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3186z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2259za7623435z00, BGl_z62lambda2259z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3187z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2258za7623436z00, BGl_z62lambda2258z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3188z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3437za7, BGl_z62zc3z04anonymousza32165ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3189z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2163za7623438z00, BGl_z62lambda2163z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3190z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2160za7623439z00, BGl_z62lambda2160z62zz__multimediazd2midizd2, 0L, BUNSPEC, 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3191z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2276za7623440z00, BGl_z62lambda2276z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2playzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2p3441z00, BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3192z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2275za7623442z00, BGl_z62lambda2275z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3193z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2281za7623443z00, BGl_z62lambda2281z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3194z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2280za7623444z00, BGl_z62lambda2280z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3195z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2286za7623445z00, BGl_z62lambda2286z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3196z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2285za7623446z00, BGl_z62lambda2285z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3197z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2291za7623447z00, BGl_z62lambda2291z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3198z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2290za7623448z00, BGl_z62lambda2290z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3199z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2296za7623449z00, BGl_z62lambda2296z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int32za73450za7, BGl_z62readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midireaderza7d23451z00, BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2stringzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2s3452z00, BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2notezd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2noteza7d3453za7, BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23454z00, BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23455z00, BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2int16za73456za7, BGl_z62readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23457z00, BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_errorzd2envzd2zz__errorz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23458z00, BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_GENERIC( BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2i3459z00, BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2f3460z00, BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3100z00zz__multimediazd2midizd2, BgL_bgl_string3100za700za7za7_3461za7, "illegal meta-event", 18 );
DEFINE_STRING( BGl_string3101z00zz__multimediazd2midizd2, BgL_bgl_string3101za700za7za7_3462za7, "illegal event", 13 );
DEFINE_STRING( BGl_string3102z00zz__multimediazd2midizd2, BgL_bgl_string3102za700za7za7_3463za7, "MThd", 4 );
DEFINE_STRING( BGl_string3103z00zz__multimediazd2midizd2, BgL_bgl_string3103za700za7za7_3464za7, "read-midi-mthd", 14 );
DEFINE_STRING( BGl_string3104z00zz__multimediazd2midizd2, BgL_bgl_string3104za700za7za7_3465za7, "invalid number of SMPTE frames per second", 41 );
DEFINE_STRING( BGl_string3105z00zz__multimediazd2midizd2, BgL_bgl_string3105za700za7za7_3466za7, "Bad header", 10 );
DEFINE_STRING( BGl_string3106z00zz__multimediazd2midizd2, BgL_bgl_string3106za700za7za7_3467za7, "MTrk", 4 );
DEFINE_STRING( BGl_string3107z00zz__multimediazd2midizd2, BgL_bgl_string3107za700za7za7_3468za7, "read-midi-mtrk", 14 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23469z00, BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string3108z00zz__multimediazd2midizd2, BgL_bgl_string3108za700za7za7_3470za7, "&read-int", 9 );
DEFINE_STRING( BGl_string3109z00zz__multimediazd2midizd2, BgL_bgl_string3109za700za7za7_3471za7, "&string-stream-peek-byte", 24 );
BGL_IMPORT obj_t BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00;
DEFINE_STRING( BGl_string3110z00zz__multimediazd2midizd2, BgL_bgl_string3110za700za7za7_3472za7, "struct", 6 );
DEFINE_STRING( BGl_string3111z00zz__multimediazd2midizd2, BgL_bgl_string3111za700za7za7_3473za7, "&string-stream-read-byte", 24 );
DEFINE_STRING( BGl_string3112z00zz__multimediazd2midizd2, BgL_bgl_string3112za700za7za7_3474za7, "&string-stream-read-int16", 25 );
DEFINE_STRING( BGl_string3113z00zz__multimediazd2midizd2, BgL_bgl_string3113za700za7za7_3475za7, "&string-stream-read-int32", 25 );
DEFINE_STRING( BGl_string3114z00zz__multimediazd2midizd2, BgL_bgl_string3114za700za7za7_3476za7, "&string-stream-read-int", 23 );
DEFINE_STRING( BGl_string3115z00zz__multimediazd2midizd2, BgL_bgl_string3115za700za7za7_3477za7, "&string-stream-read-chars", 25 );
DEFINE_STRING( BGl_string3116z00zz__multimediazd2midizd2, BgL_bgl_string3116za700za7za7_3478za7, "&midiplayer-cdelay", 18 );
DEFINE_STRING( BGl_string3117z00zz__multimediazd2midizd2, BgL_bgl_string3117za700za7za7_3479za7, "miditrack", 9 );
DEFINE_STRING( BGl_string3118z00zz__multimediazd2midizd2, BgL_bgl_string3118za700za7za7_3480za7, "&midiplayer-ignore", 18 );
DEFINE_STRING( BGl_string3119z00zz__multimediazd2midizd2, BgL_bgl_string3119za700za7za7_3481za7, "&midiplayer-noteoff", 19 );
DEFINE_STRING( BGl_string3120z00zz__multimediazd2midizd2, BgL_bgl_string3120za700za7za7_3482za7, "&midiplayer-noteon", 18 );
DEFINE_STRING( BGl_string3121z00zz__multimediazd2midizd2, BgL_bgl_string3121za700za7za7_3483za7, "&midiplayer-aftertouch", 22 );
DEFINE_STRING( BGl_string3122z00zz__multimediazd2midizd2, BgL_bgl_string3122za700za7za7_3484za7, "&midiplayer-ctrlchange", 22 );
DEFINE_STRING( BGl_string3123z00zz__multimediazd2midizd2, BgL_bgl_string3123za700za7za7_3485za7, "&midiplayer-prgmchange", 22 );
DEFINE_STRING( BGl_string3124z00zz__multimediazd2midizd2, BgL_bgl_string3124za700za7za7_3486za7, "&midiplayer-after-touch", 23 );
DEFINE_STRING( BGl_string3125z00zz__multimediazd2midizd2, BgL_bgl_string3125za700za7za7_3487za7, "&midiplayer-pitch", 17 );
DEFINE_STRING( BGl_string3126z00zz__multimediazd2midizd2, BgL_bgl_string3126za700za7za7_3488za7, "&midiplayer-sysex", 17 );
DEFINE_STRING( BGl_string3127z00zz__multimediazd2midizd2, BgL_bgl_string3127za700za7za7_3489za7, "~a[~a]", 6 );
DEFINE_STRING( BGl_string3128z00zz__multimediazd2midizd2, BgL_bgl_string3128za700za7za7_3490za7, "&midi-note-name", 15 );
DEFINE_STRING( BGl_string3129z00zz__multimediazd2midizd2, BgL_bgl_string3129za700za7za7_3491za7, "unknown controller", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3200z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2295za7623492z00, BGl_z62lambda2295z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3201z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2301za7623493z00, BGl_z62lambda2301z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3202z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2300za7623494z00, BGl_z62lambda2300z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3203z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2306za7623495z00, BGl_z62lambda2306z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3204z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2305za7623496z00, BGl_z62lambda2305z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3205z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3497za7, BGl_z62zc3z04anonymousza32271ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3206z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2269za7623498z00, BGl_z62lambda2269z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3207z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2266za7623499z00, BGl_z62lambda2266z62zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STRING( BGl_string3130z00zz__multimediazd2midizd2, BgL_bgl_string3130za700za7za7_3500za7, "&midi-controller-name", 21 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3208z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3501za7, BGl_z62zc3z04anonymousza32324ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3131z00zz__multimediazd2midizd2, BgL_bgl_string3131za700za7za7_3502za7, "unknown program", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3209z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2323za7623503z00, BGl_z62lambda2323z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3132z00zz__multimediazd2midizd2, BgL_bgl_string3132za700za7za7_3504za7, "&midi-program-name", 18 );
DEFINE_STRING( BGl_string3133z00zz__multimediazd2midizd2, BgL_bgl_string3133za700za7za7_3505za7, "&midi-program-index", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3210z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2322za7623506z00, BGl_z62lambda2322z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3211z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3507za7, BGl_z62zc3z04anonymousza32331ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3212z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2330za7623508z00, BGl_z62lambda2330z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3213z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2329za7623509z00, BGl_z62lambda2329z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3214z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3510za7, BGl_z62zc3z04anonymousza32338ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3215z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2337za7623511z00, BGl_z62lambda2337z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3216z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2336za7623512z00, BGl_z62lambda2336z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3217z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3513za7, BGl_z62zc3z04anonymousza32345ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3218z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2344za7623514z00, BGl_z62lambda2344z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3219z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2343za7623515z00, BGl_z62lambda2343z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3220z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3516za7, BGl_z62zc3z04anonymousza32352ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3221z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2351za7623517z00, BGl_z62lambda2351z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3222z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2350za7623518z00, BGl_z62lambda2350z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3223z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3519za7, BGl_z62zc3z04anonymousza32359ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3224z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2358za7623520z00, BGl_z62lambda2358z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3225z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2357za7623521z00, BGl_z62lambda2357z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3226z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3522za7, BGl_z62zc3z04anonymousza32366ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3227z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2365za7623523z00, BGl_z62lambda2365z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3065z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3524za7, BGl_z62zc3z04anonymousza31266ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3228z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2364za7623525z00, BGl_z62lambda2364z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3066z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3526za7, BGl_z62zc3z04anonymousza31267ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3229z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3527za7, BGl_z62zc3z04anonymousza32373ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3067z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3528za7, BGl_z62zc3z04anonymousza31268ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3068z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3529za7, BGl_z62zc3z04anonymousza31269ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3069z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3530za7, BGl_z62zc3z04anonymousza31270ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STRING( BGl_string3318z00zz__multimediazd2midizd2, BgL_bgl_string3318za700za7za7_3531za7, "midiscore-init1229", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3230z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2372za7623532z00, BGl_z62lambda2372z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3231z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2371za7623533z00, BGl_z62lambda2371z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3232z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3534za7, BGl_z62zc3z04anonymousza32380ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3070z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3535za7, BGl_z62zc3z04anonymousza31271ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3233z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2379za7623536z00, BGl_z62lambda2379z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3071z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3537za7, BGl_z62zc3z04anonymousza31272ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3234z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2378za7623538z00, BGl_z62lambda2378z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3072z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3539za7, BGl_z62zc3z04anonymousza31273ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23540z00, BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3320z00zz__multimediazd2midizd2, BgL_bgl_string3320za700za7za7_3541za7, "miditrack-init1231", 18 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3235z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3542za7, BGl_z62zc3z04anonymousza32387ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3073z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3543za7, BGl_z62zc3z04anonymousza31274ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3236z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2386za7623544z00, BGl_z62lambda2386z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3074z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3545za7, BGl_z62zc3z04anonymousza31518ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 8 );
DEFINE_STRING( BGl_string3322z00zz__multimediazd2midizd2, BgL_bgl_string3322za700za7za7_3546za7, "midireader-init1233", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3237z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2385za7623547z00, BGl_z62lambda2385z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3075z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3548za7, BGl_z62zc3z04anonymousza31519ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3238z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3549za7, BGl_z62zc3z04anonymousza32394ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3076z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3550za7, BGl_z62zc3z04anonymousza31542ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3324z00zz__multimediazd2midizd2, BgL_bgl_string3324za700za7za7_3551za7, "midiplayer-init1235", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3239z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2393za7623552z00, BGl_z62lambda2393z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3077z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3553za7, BGl_z62zc3z04anonymousza31543ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3078z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3554za7, BGl_z62zc3z04anonymousza31544ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3326z00zz__multimediazd2midizd2, BgL_bgl_string3326za700za7za7_3555za7, "midisink-init1237", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3079z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3556za7, BGl_z62zc3z04anonymousza31545ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3327z00zz__multimediazd2midizd2, BgL_bgl_string3327za700za7za7_3557za7, "&midiscore-init", 15 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2controllerzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2contro3558z00, BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3328z00zz__multimediazd2midizd2, BgL_bgl_string3328za700za7za7_3559za7, "&miditrack-init", 15 );
DEFINE_STRING( BGl_string3329z00zz__multimediazd2midizd2, BgL_bgl_string3329za700za7za7_3560za7, "&midireader-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3240z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2392za7623561z00, BGl_z62lambda2392z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3241z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3562za7, BGl_z62zc3z04anonymousza32401ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3242z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2400za7623563z00, BGl_z62lambda2400z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3243z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2399za7623564z00, BGl_z62lambda2399z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3565z00, BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3244z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3566za7, BGl_z62zc3z04anonymousza32408ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3330z00zz__multimediazd2midizd2, BgL_bgl_string3330za700za7za7_3567za7, "midireader", 10 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3245z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2407za7623568z00, BGl_z62lambda2407z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3331z00zz__multimediazd2midizd2, BgL_bgl_string3331za700za7za7_3569za7, "&midiplayer-init", 16 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3246z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2406za7623570z00, BGl_z62lambda2406z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3332z00zz__multimediazd2midizd2, BgL_bgl_string3332za700za7za7_3571za7, "&midisink-init", 14 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3247z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3572za7, BGl_z62zc3z04anonymousza32415ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3333z00zz__multimediazd2midizd2, BgL_bgl_string3333za700za7za7_3573za7, "#() midisink flush write-string write-byte usleep stream midiplayer meta-seqspec meta-keysig meta-timesig meta-smtpe meta-tempo meta-eot meta-midiport meta-channpref meta-devname meta-prgmname meta-cue meta-marker meta-lyric meta-instrument meta-track meta-copyright meta-text meta-seqnum sysex pitch after-touch prgmchange ctrlchange aftertouch noteon noteoff cdelay err midireader read-chars read-vlq read-int read-int32 read-int16 read-byte peek-byte miditrack eot status wtick datastart start ip int32 len %status uint32 %wtick bool %eot procedure %close %reader obj %stream __multimedia-midi midiscore vector tracks ppq tempo long format string-stream #(\"C\" \"C#\" \"D\" \"D#\" \"E\" \"F\" \"F#\" \"G\" \"G#\" \"A\" \"A#\" \"B\") #(\"\" \"Acoustic Grand Piano\" \"Bright Acoustic Piano\" \"Electric Grand Piano\" \"Honky-tonk Piano\" \"Electric Piano 1\" \"Electric Piano 2\" \"Harpsichord\" \"Clavinet\" \"Celesta\" \"Glockenspiel\" \"Music Box\" \"Vibraphone\" \"Marimba\" \"Xylophone\" \"Tubular Bells\" \"Dulcimer"
"\" \"Drawbar Organ\" \"Percussive Organ\" \"Rock Organ\" \"Church Organ\" \"Reed Organ\" \"Accordion\" \"Harmonica\" \"Tango Accordion\" \"Acoustic Guitar (nylon)\" \"Acoustic Guitar (steel)\" \"Electric Guitar (jazz)\" \"Electric Guitar (clean)\" \"Electric Guitar (muted)\" \"Overdriven Guitar\" \"Distortion Guitar\" \"Guitar harmonics\" \"Acoustic Bass\" \"Electric Bass (finger)\" \"Electric Bass (pick)\" \"Fretless Bass\" \"Slap Bass 1\" \"Slap Bass 2\" \"Synth Bass 1\" \"Synth Bass 2\" \"Violin\" \"Viola\" \"Cello\" \"Contrabass\" \"Tremolo Strings\" \"Pizzicato Strings\" \"Orchestral Harp\" \"Timpani\" \"String Ensemble 1\" \"String Ensemble 2\" \"Synth Strings 1\" \"Synth Strings 2\" \"Choir Aahs\" \"Voice Oohs\" \"Synth Voice\" \"Orchestra Hit\" \"Trumpet\" \"Trombone\" \"Tuba\" \"Muted Trumpet\" \"French Horn\" \"Brass Section\" \"Synth Brass 1\" \"Synth Brass 2\" \"Soprano Sax\" \"Alto Sax\" \"Tenor Sax\" \"Baritone Sax\" \"Oboe\" \"English Horn\" \"Bassoon\" \"Clarinet\" \"Piccolo\" \"Flute\" \"Reco"
"rder\" \"Pan Flute\" \"Blown Bottle\" \"Shakuhachi\" \"Whistle\" \"Ocarina\" \"Lead 1 (square)\" \"Lead 2 (sawtooth)\" \"Lead 3 (calliope)\" \"Lead 4 (chiff)\" \"Lead 5 (charang)\" \"Lead 6 (voice)\" \"Lead 7 (fifths)\" \"Lead 8 (bass + lead)\" \"Pad 1 (new age)\" \"Pad 2 (warm)\" \"Pad 3 (polysynth)\" \"Pad 4 (choir)\" \"Pad 5 (bowed)\" \"Pad 6 (metallic)\" \"Pad 7 (halo)\" \"Pad 8 (sweep)\" \"FX 1 (rain)\" \"FX 2 (soundtrack)\" \"FX 3 (crystal)\" \"FX 4 (atmosphere)\" \"FX 5 (brightness)\" \"FX 6 (goblins)\" \"FX 7 (echoes)\" \"FX 8 (sci-fi)\" \"Sitar\" \"Banjo\" \"Shamisen\" \"Koto\" \"Kalimba\" \"Bag pipe\" \"Fiddle\" \"Shanai\" \"Tinkle Bell\" \"Agogo\" \"Steel Drums\" \"Woodblock\" \"Taiko Drum\" \"Melodic Tom\" \"Synth Drum\" \"Reverse Cymbal\" \"Guitar Fret Noise\" \"Breath Noise\" \"Seashore\" \"Bird Tweet\" \"Telephone Ring\" \"Helicopter\" \"Applause\" \"Gunshot\") #(\"Bank Select\" \"Modulation Wheel or Lever\" \"Breath Controller\" \"Undefined\" \"Foot Controller\" \"Portamento Time\" \"Data Entr"
"y MSB\" \"Channel Volume\" \"Balance\" \"Undefined\" \"Pan\" \"Expression Controller\" \"Effect Control 1\" \"Effect Control 2\" \"Undefined\" \"Undefined\" \"General Purpose Controller 1\" \"General Purpose Controller 2\" \"General Purpose Controller 3\" \"General Purpose Controller 4\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"LSB for Control 0\" \"LSB for Control 1\" \"LSB for Control 2\" \"LSB for Control 3\" \"LSB for Control 4\" \"LSB for Control 5\" \"LSB for Control 6\" \"LSB for Control 7\" \"LSB for Control 8\" \"LSB for Control 9\" \"LSB for Control 10\" \"LSB for Control 11\" \"LSB for Control 12\" \"LSB for Control 13\" \"LSB for Control 14\" \"LSB for Control 15\" \"LSB for Control 16\" \"LSB for Control 17\" \"LSB for Control 18\" \"LSB for Control 19\" \"LSB for Control 20\" \"LSB for Control 21\" \"LSB for Control 22\" \"LSB for Control 23\" \"LSB for Control 24\" \""
"LSB for Control 25\" \"LSB for Control 26\" \"LSB for Control 27\" \"LSB for Control 28\" \"LSB for Control 29\" \"LSB for Control 30\" \"LSB for Control 31\" \"Damper Pedal on/off (Sustain)\" \"Portamento On/Off\" \"Sostenuto On/Off\" \"Soft Pedal On/Off\" \"Legato Footswitch\" \"Hold 2\" \"Sound Controller 1 (default: Sound Variation)\" \"Sound Controller 2 (default: Timbre/Harmonic Intens.)\" \"Sound Controller 3 (default: Release Time)\" \"Sound Controller 4 (default: Attack Time)\" \"Sound Controller 5 (default: Brightness)\" \"Sound Controller 6 (default: Decay Time - see MMA RP-021)\" \"Sound Controller 7 (default: Vibrato Rate - see MMA RP-021)\" \"Sound Controller 8 (default: Vibrato Depth - see MMA RP-021)\" \"Sound Controller 9 (default: Vibrato Delay - see MMA RP-021)\" \"Sound Controller 10 (default undefined - see MMA RP-021)\" \"General Purpose Controller 5\" \"General Purpose Controller 6\" \"General Purpose Controller 7\" \"General Purpose Controller 8\" \"Portamento Control\" \"Undefined\" "
"\"Undefined\" \"Undefined\" \"High Resolution Velocity Prefix\" \"Undefined\" \"Undefined\" \"Effects 1 Depth\" \"Effects 2 Depth\" \"Effects 3 Depth\" \"Effects 4 Depth\" \"Effects 5 Depth\" \"Data Increment\" \"Data Decrement\" \"Non-Registered Parameter Number (NRPN)\" \"Non-Registered Parameter Number (NRPN)\" \"Registered Parameter Number (RPN)\" \"Registered Parameter Number (RPN)\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"Undefined\" \"[Channel Mode Message] All Sound Off\" \"[Channel Mode Message] Reset All Controllers\" \"[Channel Mode Message] Local Control On/Off\" \"[Channel Mode Message] All Notes Off\" \"[Channel Mode Message] Omni Mode Off (+ all notes off)\" \"[Channel Mode Message] Omni Mode On (+ all notes off)\" \"[Channel Mode Message] Mono Mode On (+ poly off, + all notes off)\" \"[Channel Mod"
"e Message] Poly Mode On (+ mono off, +all notes off)\") #(\"\" \"text\" \"copyright\" \"track\" \"instrument\" \"lyric\" \"marker\" \"cue\") ", 5730 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3248z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2414za7623574z00, BGl_z62lambda2414z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3249z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2413za7623575z00, BGl_z62lambda2413z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3250z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3576za7, BGl_z62zc3z04anonymousza32422ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3251z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2421za7623577z00, BGl_z62lambda2421z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3252z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2420za7623578z00, BGl_z62lambda2420z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3253z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3579za7, BGl_z62zc3z04anonymousza32429ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3091z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3580za7, BGl_z62zc3z04anonymousza31683ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3254z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2428za7623581z00, BGl_z62lambda2428z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3255z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2427za7623582z00, BGl_z62lambda2427z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3256z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3583za7, BGl_z62zc3z04anonymousza32436ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3257z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2435za7623584z00, BGl_z62lambda2435z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3258z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2434za7623585z00, BGl_z62lambda2434z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3259z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3586za7, BGl_z62zc3z04anonymousza32443ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23587z00, BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2, 0L, BUNSPEC, 5 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3260z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2442za7623588z00, BGl_z62lambda2442z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3261z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2441za7623589z00, BGl_z62lambda2441z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3262z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3590za7, BGl_z62zc3z04anonymousza32450ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3263z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2449za7623591z00, BGl_z62lambda2449z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3264z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2448za7623592z00, BGl_z62lambda2448z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3265z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3593za7, BGl_z62zc3z04anonymousza32457ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3266z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2456za7623594z00, BGl_z62lambda2456z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3267z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2455za7623595z00, BGl_z62lambda2455z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3268z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3596za7, BGl_z62zc3z04anonymousza32464ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3269z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2463za7623597z00, BGl_z62lambda2463z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3270z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2462za7623598z00, BGl_z62lambda2462z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3271z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3599za7, BGl_z62zc3z04anonymousza32471ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3272z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2470za7623600z00, BGl_z62lambda2470z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3273z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2469za7623601z00, BGl_z62lambda2469z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3274z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3602za7, BGl_z62zc3z04anonymousza32478ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3275z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2477za7623603z00, BGl_z62lambda2477z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3276z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2476za7623604z00, BGl_z62lambda2476z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3277z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3605za7, BGl_z62zc3z04anonymousza32485ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3278z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2484za7623606z00, BGl_z62lambda2484z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3279z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2483za7623607z00, BGl_z62lambda2483z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3280z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3608za7, BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3281z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2491za7623609z00, BGl_z62lambda2491z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3282z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2490za7623610z00, BGl_z62lambda2490z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3283z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3611za7, BGl_z62zc3z04anonymousza32500ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3284z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2499za7623612z00, BGl_z62lambda2499z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3285z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2498za7623613z00, BGl_z62lambda2498z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3286z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3614za7, BGl_z62zc3z04anonymousza32508ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3287z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2507za7623615z00, BGl_z62lambda2507z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3288z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2506za7623616z00, BGl_z62lambda2506z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3289z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3617za7, BGl_z62zc3z04anonymousza32515ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3290z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2514za7623618z00, BGl_z62lambda2514z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3291z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2513za7623619z00, BGl_z62lambda2513z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3292z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3620za7, BGl_z62zc3z04anonymousza32317ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3293z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2315za7623621z00, BGl_z62lambda2315z62zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3294z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2312za7623622z00, BGl_z62lambda2312z62zz__multimediazd2midizd2, 0L, BUNSPEC, 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3295z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3623za7, BGl_z62zc3z04anonymousza32533ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3296z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2532za7623624z00, BGl_z62lambda2532z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3297z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2531za7623625z00, BGl_z62lambda2531z62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3298z00zz__multimediazd2midizd2, BgL_bgl_za762za7c3za704anonymo3626za7, BGl_z62zc3z04anonymousza32540ze3ze5zz__multimediazd2midizd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3299z00zz__multimediazd2midizd2, BgL_bgl_za762lambda2539za7623627z00, BGl_z62lambda2539z62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3628z00, BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_miditrackzd2inputzd2portzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762miditrackza7d2i3629z00, BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762readza7d2intza7b03630za7, BGl_z62readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3631z00, BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
BGL_IMPORT obj_t BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3632z00, BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_sleepzd2envzd2zz__osz00;
BGL_IMPORT obj_t BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiscorezd2filezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiscoreza7d2f3633z00, BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2indexzd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3634z00, BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23635z00, BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23636z00, BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midizd2programzd2namezd2envzd2zz__multimediazd2midizd2, BgL_bgl_za762midiza7d2progra3637z00, BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3638z00, BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2, BgL_bgl_za762midiplayerza7d23639z00, BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2, BgL_bgl_za762stringza7d2stre3640z00, BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_midiscorez00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2textzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2notezd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midisinkzd2nullzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midizd2programzd2namesz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_miditrackz00zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midiplayerzd2readzd2zz__multimediazd2midizd2) );
ADD_ROOT( (void *)(&BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2midizd2(long BgL_checksumz00_4510, char * BgL_fromz00_4511)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2midizd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2midizd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2(); 
BGl_cnstzd2initzd2zz__multimediazd2midizd2(); 
BGl_objectzd2initzd2zz__multimediazd2midizd2(); 
BGl_genericzd2initzd2zz__multimediazd2midizd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2midizd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)0), "__multimedia-midi"); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)0), "__multimedia-midi"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_cportz00_4143;
{ /* Llib/midi.scm 15 */
obj_t BgL_stringz00_4151;
BgL_stringz00_4151 = BGl_string3333z00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 15 */
obj_t BgL_startz00_4152;
BgL_startz00_4152 = 
BINT(((long)0)); 
{ /* Llib/midi.scm 15 */
obj_t BgL_endz00_4153;
BgL_endz00_4153 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_4151))); 
{ /* Llib/midi.scm 15 */

BgL_cportz00_4143 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_4151, BgL_startz00_4152, BgL_endz00_4153); } } } } 
{ 
long BgL_iz00_4144;
BgL_iz00_4144 = ((long)75); 
BgL_loopz00_4145:
if(
(BgL_iz00_4144==((long)-1)))
{ /* Llib/midi.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 15 */
obj_t BgL_arg3335z00_4147;
{ /* Llib/midi.scm 15 */

{ /* Llib/midi.scm 15 */
obj_t BgL_locationz00_4149;
BgL_locationz00_4149 = 
BBOOL(((bool_t)0)); 
{ /* Llib/midi.scm 15 */

BgL_arg3335z00_4147 = 
BGl_readz00zz__readerz00(BgL_cportz00_4143, BgL_locationz00_4149); } } } 
{ /* Llib/midi.scm 15 */
int BgL_tmpz00_4548;
BgL_tmpz00_4548 = 
(int)(BgL_iz00_4144); 
CNST_TABLE_SET(BgL_tmpz00_4548, BgL_arg3335z00_4147); } } 
{ /* Llib/midi.scm 15 */
int BgL_auxz00_4150;
BgL_auxz00_4150 = 
(int)(
(BgL_iz00_4144-((long)1))); 
{ 
long BgL_iz00_4553;
BgL_iz00_4553 = 
(long)(BgL_auxz00_4150); 
BgL_iz00_4144 = BgL_iz00_4553; 
goto BgL_loopz00_4145;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 133 */
BgL_midireaderz00_bglt BgL_new1120z00_143;
{ /* Llib/midi.scm 134 */
BgL_midireaderz00_bglt BgL_new1119z00_145;
BgL_new1119z00_145 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 134 */
long BgL_arg1240z00_146;
{ /* Llib/midi.scm 134 */
long BgL_res2570z00_1865;
BgL_res2570z00_1865 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg1240z00_146 = BgL_res2570z00_1865; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_145), BgL_arg1240z00_146); } 
BgL_new1120z00_143 = BgL_new1119z00_145; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_peekzd2bytezd2)=((obj_t)BGl_peekzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2bytezd2)=((obj_t)BGl_readzd2bytezd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2int16zd2)=((obj_t)BGl_readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2int32zd2)=((obj_t)BGl_readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2intzd2)=((obj_t)BGl_readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2vlqzd2)=((obj_t)BGl_readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1120z00_143))->BgL_readzd2charszd2)=((obj_t)BGl_readzd2charszd2envz00zz__r4_input_6_10_2z00),BUNSPEC); 
{ /* Llib/midi.scm 133 */
obj_t BgL_fun1239z00_144;
BgL_fun1239z00_144 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1239z00_144)(BgL_fun1239z00_144, 
((obj_t)BgL_new1120z00_143), BEOA); } 
BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2 = BgL_new1120z00_143; } 
{ /* Llib/midi.scm 146 */
BgL_midireaderz00_bglt BgL_new1122z00_147;
{ /* Llib/midi.scm 147 */
BgL_midireaderz00_bglt BgL_new1121z00_149;
BgL_new1121z00_149 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 147 */
long BgL_arg1260z00_150;
{ /* Llib/midi.scm 147 */
long BgL_res2571z00_1869;
BgL_res2571z00_1869 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg1260z00_150 = BgL_res2571z00_1869; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1121z00_149), BgL_arg1260z00_150); } 
BgL_new1122z00_147 = BgL_new1121z00_149; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_peekzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2peekzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2bytezd2)=((obj_t)BGl_stringzd2streamzd2readzd2bytezd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2int16zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int16zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2int32zd2)=((obj_t)BGl_stringzd2streamzd2readzd2int32zd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2intzd2)=((obj_t)BGl_stringzd2streamzd2readzd2intzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2vlqzd2)=((obj_t)BGl_stringzd2streamzd2readzd2vlqzd2envz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1122z00_147))->BgL_readzd2charszd2)=((obj_t)BGl_stringzd2streamzd2readzd2charszd2envz00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 146 */
obj_t BgL_fun1241z00_148;
BgL_fun1241z00_148 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1241z00_148)(BgL_fun1241z00_148, 
((obj_t)BgL_new1122z00_147), BEOA); } 
BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2 = BgL_new1122z00_147; } 
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1124z00_151;
{ /* Llib/midi.scm 159 */
BgL_midiplayerz00_bglt BgL_new1123z00_264;
BgL_new1123z00_264 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 159 */
long BgL_arg1541z00_265;
{ /* Llib/midi.scm 159 */
long BgL_res2572z00_1873;
BgL_res2572z00_1873 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg1541z00_265 = BgL_res2572z00_1873; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1123z00_264), BgL_arg1541z00_265); } 
BgL_new1124z00_151 = BgL_new1123z00_264; } 
{ 
obj_t BgL_auxz00_4594;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1264z00_152;
{ /* Llib/midi.scm 159 */
obj_t BgL_arg1265z00_153;
{ /* Llib/midi.scm 159 */
obj_t BgL_res2573z00_1877;
{ /* Llib/midi.scm 159 */
obj_t BgL_classz00_1876;
BgL_classz00_1876 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2573z00_1877 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1876); } 
BgL_arg1265z00_153 = BgL_res2573z00_1877; } 
BgL_arg1264z00_152 = 
VECTOR_REF(BgL_arg1265z00_153,((long)0)); } 
BgL_auxz00_4594 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1264z00_152); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_errz00)=((obj_t)BgL_auxz00_4594),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_cdelayz00)=((obj_t)BGl_proc3065z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_noteoffz00)=((obj_t)BGl_proc3066z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_noteonz00)=((obj_t)BGl_proc3067z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_aftertouchz00)=((obj_t)BGl_proc3068z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_ctrlchangez00)=((obj_t)BGl_proc3069z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_prgmchangez00)=((obj_t)BGl_proc3070z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_afterzd2touchzd2)=((obj_t)BGl_proc3071z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_pitchz00)=((obj_t)BGl_proc3072z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_sysexz00)=((obj_t)BGl_proc3073z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4608;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1301z00_214;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1304z00_215;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2574z00_1880;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1879;
BgL_classz00_1879 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2574z00_1880 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1879); } 
BgL_arg1304z00_215 = BgL_res2574z00_1880; } 
BgL_arg1301z00_214 = 
VECTOR_REF(BgL_arg1304z00_215,((long)10)); } 
BgL_auxz00_4608 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1301z00_214); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2seqnumzd2)=((obj_t)BgL_auxz00_4608),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4613;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1321z00_216;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1322z00_217;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2575z00_1883;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1882;
BgL_classz00_1882 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2575z00_1883 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1882); } 
BgL_arg1322z00_217 = BgL_res2575z00_1883; } 
BgL_arg1321z00_216 = 
VECTOR_REF(BgL_arg1322z00_217,((long)11)); } 
BgL_auxz00_4613 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1321z00_216); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2textzd2)=((obj_t)BgL_auxz00_4613),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4618;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1330z00_218;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1331z00_219;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2576z00_1886;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1885;
BgL_classz00_1885 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2576z00_1886 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1885); } 
BgL_arg1331z00_219 = BgL_res2576z00_1886; } 
BgL_arg1330z00_218 = 
VECTOR_REF(BgL_arg1331z00_219,((long)12)); } 
BgL_auxz00_4618 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1330z00_218); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2copyrightzd2)=((obj_t)BgL_auxz00_4618),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4623;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1335z00_220;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1336z00_221;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2577z00_1889;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1888;
BgL_classz00_1888 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2577z00_1889 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1888); } 
BgL_arg1336z00_221 = BgL_res2577z00_1889; } 
BgL_arg1335z00_220 = 
VECTOR_REF(BgL_arg1336z00_221,((long)13)); } 
BgL_auxz00_4623 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1335z00_220); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2trackzd2)=((obj_t)BgL_auxz00_4623),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4628;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1338z00_222;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1339z00_223;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2578z00_1892;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1891;
BgL_classz00_1891 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2578z00_1892 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1891); } 
BgL_arg1339z00_223 = BgL_res2578z00_1892; } 
BgL_arg1338z00_222 = 
VECTOR_REF(BgL_arg1339z00_223,((long)14)); } 
BgL_auxz00_4628 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1338z00_222); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2instrumentzd2)=((obj_t)BgL_auxz00_4628),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4633;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1341z00_224;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1342z00_225;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2579z00_1895;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1894;
BgL_classz00_1894 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2579z00_1895 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1894); } 
BgL_arg1342z00_225 = BgL_res2579z00_1895; } 
BgL_arg1341z00_224 = 
VECTOR_REF(BgL_arg1342z00_225,((long)15)); } 
BgL_auxz00_4633 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1341z00_224); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2lyriczd2)=((obj_t)BgL_auxz00_4633),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4638;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1345z00_226;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1346z00_227;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2580z00_1898;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1897;
BgL_classz00_1897 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2580z00_1898 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1897); } 
BgL_arg1346z00_227 = BgL_res2580z00_1898; } 
BgL_arg1345z00_226 = 
VECTOR_REF(BgL_arg1346z00_227,((long)16)); } 
BgL_auxz00_4638 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1345z00_226); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2markerzd2)=((obj_t)BgL_auxz00_4638),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4643;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1355z00_228;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1356z00_229;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2581z00_1901;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1900;
BgL_classz00_1900 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2581z00_1901 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1900); } 
BgL_arg1356z00_229 = BgL_res2581z00_1901; } 
BgL_arg1355z00_228 = 
VECTOR_REF(BgL_arg1356z00_229,((long)17)); } 
BgL_auxz00_4643 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1355z00_228); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2cuezd2)=((obj_t)BgL_auxz00_4643),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4648;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1357z00_230;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1358z00_231;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2582z00_1904;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1903;
BgL_classz00_1903 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2582z00_1904 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1903); } 
BgL_arg1358z00_231 = BgL_res2582z00_1904; } 
BgL_arg1357z00_230 = 
VECTOR_REF(BgL_arg1358z00_231,((long)18)); } 
BgL_auxz00_4648 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1357z00_230); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2prgmnamezd2)=((obj_t)BgL_auxz00_4648),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4653;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1359z00_232;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1360z00_233;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2583z00_1907;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1906;
BgL_classz00_1906 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2583z00_1907 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1906); } 
BgL_arg1360z00_233 = BgL_res2583z00_1907; } 
BgL_arg1359z00_232 = 
VECTOR_REF(BgL_arg1360z00_233,((long)19)); } 
BgL_auxz00_4653 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1359z00_232); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2devnamezd2)=((obj_t)BgL_auxz00_4653),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4658;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1361z00_234;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1362z00_235;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2584z00_1910;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1909;
BgL_classz00_1909 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2584z00_1910 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1909); } 
BgL_arg1362z00_235 = BgL_res2584z00_1910; } 
BgL_arg1361z00_234 = 
VECTOR_REF(BgL_arg1362z00_235,((long)20)); } 
BgL_auxz00_4658 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1361z00_234); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2channprefzd2)=((obj_t)BgL_auxz00_4658),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4663;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1391z00_236;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1392z00_237;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2585z00_1913;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1912;
BgL_classz00_1912 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2585z00_1913 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1912); } 
BgL_arg1392z00_237 = BgL_res2585z00_1913; } 
BgL_arg1391z00_236 = 
VECTOR_REF(BgL_arg1392z00_237,((long)21)); } 
BgL_auxz00_4663 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1391z00_236); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2midiportzd2)=((obj_t)BgL_auxz00_4663),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4668;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1434z00_238;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1435z00_239;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2586z00_1916;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1915;
BgL_classz00_1915 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2586z00_1916 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1915); } 
BgL_arg1435z00_239 = BgL_res2586z00_1916; } 
BgL_arg1434z00_238 = 
VECTOR_REF(BgL_arg1435z00_239,((long)22)); } 
BgL_auxz00_4668 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1434z00_238); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2eotzd2)=((obj_t)BgL_auxz00_4668),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4673;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1516z00_240;
{ /* Llib/midi.scm 168 */
obj_t BgL_arg1517z00_241;
{ /* Llib/midi.scm 168 */
obj_t BgL_res2587z00_1919;
{ /* Llib/midi.scm 168 */
obj_t BgL_classz00_1918;
BgL_classz00_1918 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2587z00_1919 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1918); } 
BgL_arg1517z00_241 = BgL_res2587z00_1919; } 
BgL_arg1516z00_240 = 
VECTOR_REF(BgL_arg1517z00_241,((long)23)); } 
BgL_auxz00_4673 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1516z00_240); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2tempozd2)=((obj_t)BgL_auxz00_4673),BUNSPEC); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2smtpezd2)=((obj_t)BGl_proc3074z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2timesigzd2)=((obj_t)BGl_proc3075z00zz__multimediazd2midizd2),BUNSPEC); 
{ 
obj_t BgL_auxz00_4680;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1522z00_259;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1526z00_260;
{ /* Llib/midi.scm 83 */
obj_t BgL_res2588z00_1922;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1921;
BgL_classz00_1921 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2588z00_1922 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1921); } 
BgL_arg1526z00_260 = BgL_res2588z00_1922; } 
BgL_arg1522z00_259 = 
VECTOR_REF(BgL_arg1526z00_260,((long)26)); } 
BgL_auxz00_4680 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1522z00_259); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2keysigzd2)=((obj_t)BgL_auxz00_4680),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4685;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1527z00_261;
{ /* Llib/midi.scm 83 */
obj_t BgL_arg1534z00_262;
{ /* Llib/midi.scm 83 */
obj_t BgL_res2589z00_1925;
{ /* Llib/midi.scm 83 */
obj_t BgL_classz00_1924;
BgL_classz00_1924 = BGl_midiplayerz00zz__multimediazd2midizd2; 
BgL_res2589z00_1925 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1924); } 
BgL_arg1534z00_262 = BgL_res2589z00_1925; } 
BgL_arg1527z00_261 = 
VECTOR_REF(BgL_arg1534z00_262,((long)27)); } 
BgL_auxz00_4685 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_arg1527z00_261); } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1124z00_151))->BgL_metazd2seqspeczd2)=((obj_t)BgL_auxz00_4685),BUNSPEC); } 
{ /* Llib/midi.scm 159 */
obj_t BgL_fun1535z00_263;
BgL_fun1535z00_263 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1535z00_263)(BgL_fun1535z00_263, 
((obj_t)BgL_new1124z00_151), BEOA); } 
BGl_midiplayerzd2readzd2zz__multimediazd2midizd2 = BgL_new1124z00_151; } 
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1126z00_266;
{ /* Llib/midi.scm 174 */
BgL_midisinkz00_bglt BgL_new1125z00_278;
BgL_new1125z00_278 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 174 */
long BgL_arg1549z00_279;
{ /* Llib/midi.scm 174 */
long BgL_res2590z00_1928;
BgL_res2590z00_1928 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg1549z00_279 = BgL_res2590z00_1928; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_278), BgL_arg1549z00_279); } 
BgL_new1126z00_266 = BgL_new1125z00_278; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_streamz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_usleepz00)=((obj_t)BGl_proc3076z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_writezd2bytezd2)=((obj_t)BGl_proc3077z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_writezd2stringzd2)=((obj_t)BGl_proc3078z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1126z00_266))->BgL_flushz00)=((obj_t)BGl_proc3079z00zz__multimediazd2midizd2),BUNSPEC); 
{ /* Llib/midi.scm 174 */
obj_t BgL_fun1546z00_277;
BgL_fun1546z00_277 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1546z00_277)(BgL_fun1546z00_277, 
((obj_t)BgL_new1126z00_266), BEOA); } 
BGl_midisinkzd2nullzd2zz__multimediazd2midizd2 = BgL_new1126z00_266; } 
BGl_midizd2textzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)0)); 
BGl_midizd2controllerzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)1)); 
BGl_midizd2programzd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)2)); 
BGl_midizd2notezd2namesz00zz__multimediazd2midizd2 = 
CNST_TABLE_REF(((long)3)); 
return BUNSPEC;} 

}



/* &<@anonymous:1545> */
obj_t BGl_z62zc3z04anonymousza31545ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3040, obj_t BgL_opz00_3041)
{
{ /* Llib/midi.scm 178 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1544> */
obj_t BGl_z62zc3z04anonymousza31544ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3042, obj_t BgL_opz00_3043, obj_t BgL_bz00_3044)
{
{ /* Llib/midi.scm 177 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1543> */
obj_t BGl_z62zc3z04anonymousza31543ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3045, obj_t BgL_opz00_3046, obj_t BgL_bz00_3047)
{
{ /* Llib/midi.scm 176 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1542> */
obj_t BGl_z62zc3z04anonymousza31542ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3048, obj_t BgL_sz00_3049)
{
{ /* Llib/midi.scm 175 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1519> */
obj_t BGl_z62zc3z04anonymousza31519ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3050, obj_t BgL_mpz00_3051, obj_t BgL_msz00_3052, obj_t BgL_tickz00_3053, obj_t BgL_nnz00_3054, obj_t BgL_ddz00_3055, obj_t BgL_ccz00_3056, obj_t BgL_bbz00_3057)
{
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1518> */
obj_t BGl_z62zc3z04anonymousza31518ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3058, obj_t BgL_mpz00_3059, obj_t BgL_msz00_3060, obj_t BgL_tickz00_3061, obj_t BgL_hrz00_3062, obj_t BgL_mmz00_3063, obj_t BgL_sez00_3064, obj_t BgL_frz00_3065, obj_t BgL_ffz00_3066)
{
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1274> */
obj_t BGl_z62zc3z04anonymousza31274ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3067, obj_t BgL_mpz00_3068, obj_t BgL_msz00_3069, obj_t BgL_tickz00_3070, obj_t BgL_sz00_3071)
{
{ /* Llib/midi.scm 168 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1273> */
obj_t BGl_z62zc3z04anonymousza31273ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3072, obj_t BgL_mpz00_3073, obj_t BgL_msz00_3074, obj_t BgL_tickz00_3075, obj_t BgL_xz00_3076, obj_t BgL_yz00_3077, obj_t BgL_za7za7_3078)
{
{ /* Llib/midi.scm 167 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1272> */
obj_t BGl_z62zc3z04anonymousza31272ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3079, obj_t BgL_mpz00_3080, obj_t BgL_msz00_3081, obj_t BgL_tickz00_3082, obj_t BgL_xz00_3083, obj_t BgL_yz00_3084)
{
{ /* Llib/midi.scm 166 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1271> */
obj_t BGl_z62zc3z04anonymousza31271ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3085, obj_t BgL_mpz00_3086, obj_t BgL_msz00_3087, obj_t BgL_tickz00_3088, obj_t BgL_xz00_3089, obj_t BgL_yz00_3090)
{
{ /* Llib/midi.scm 165 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1270> */
obj_t BGl_z62zc3z04anonymousza31270ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3091, obj_t BgL_mpz00_3092, obj_t BgL_msz00_3093, obj_t BgL_tickz00_3094, obj_t BgL_xz00_3095, obj_t BgL_yz00_3096, obj_t BgL_za7za7_3097)
{
{ /* Llib/midi.scm 164 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1269> */
obj_t BGl_z62zc3z04anonymousza31269ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3098, obj_t BgL_mpz00_3099, obj_t BgL_msz00_3100, obj_t BgL_tickz00_3101, obj_t BgL_xz00_3102, obj_t BgL_yz00_3103, obj_t BgL_za7za7_3104)
{
{ /* Llib/midi.scm 163 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1268> */
obj_t BGl_z62zc3z04anonymousza31268ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3105, obj_t BgL_mpz00_3106, obj_t BgL_msz00_3107, obj_t BgL_tickz00_3108, obj_t BgL_xz00_3109, obj_t BgL_yz00_3110, obj_t BgL_za7za7_3111)
{
{ /* Llib/midi.scm 162 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1267> */
obj_t BGl_z62zc3z04anonymousza31267ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3112, obj_t BgL_mpz00_3113, obj_t BgL_msz00_3114, obj_t BgL_tickz00_3115, obj_t BgL_xz00_3116, obj_t BgL_yz00_3117, obj_t BgL_za7za7_3118)
{
{ /* Llib/midi.scm 161 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:1266> */
obj_t BGl_z62zc3z04anonymousza31266ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3119, obj_t BgL_mpz00_3120, obj_t BgL_msz00_3121, obj_t BgL_tickz00_3122, obj_t BgL_trackz00_3123, obj_t BgL_ppqz00_3124, obj_t BgL_dtz00_3125, obj_t BgL_usz00_3126)
{
{ /* Llib/midi.scm 160 */
return 
BBOOL(((bool_t)0));} 

}



/* midiscore-file */
BGL_EXPORTED_DEF BgL_midiscorez00_bglt BGl_midiscorezd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_13)
{
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_ipz00_299;
{ /* Llib/midi.scm 184 */

BgL_ipz00_299 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filenamez00_13, BTRUE, 
BINT(((long)5000000))); } 
{ /* Llib/midi.scm 185 */
obj_t BgL_sza7za7_300;
BgL_sza7za7_300 = 
BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(BgL_ipz00_299); 
{ /* Llib/midi.scm 186 */
obj_t BgL_fmtz00_301;obj_t BgL_tckz00_302;obj_t BgL_tempoz00_303;obj_t BgL_ppqz00_304;
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4733;
BgL_tmpz00_4733 = 
(int)(((long)1)); 
BgL_fmtz00_301 = 
BGL_MVALUES_VAL(BgL_tmpz00_4733); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4736;
BgL_tmpz00_4736 = 
(int)(((long)2)); 
BgL_tckz00_302 = 
BGL_MVALUES_VAL(BgL_tmpz00_4736); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4739;
BgL_tmpz00_4739 = 
(int)(((long)3)); 
BgL_tempoz00_303 = 
BGL_MVALUES_VAL(BgL_tmpz00_4739); } 
{ /* Llib/midi.scm 187 */
int BgL_tmpz00_4742;
BgL_tmpz00_4742 = 
(int)(((long)4)); 
BgL_ppqz00_304 = 
BGL_MVALUES_VAL(BgL_tmpz00_4742); } 
{ /* Llib/midi.scm 187 */
obj_t BgL_tracksz00_305;
if(
INTEGERP(BgL_fmtz00_301))
{ /* Llib/midi.scm 187 */
switch( 
(long)CINT(BgL_fmtz00_301)) { case ((long)0) : 

{ /* Llib/midi.scm 188 */
obj_t BgL_v1185z00_313;
BgL_v1185z00_313 = 
create_vector(((long)1)); 
{ /* Llib/midi.scm 188 */
BgL_miditrackz00_bglt BgL_arg1601z00_314;
BgL_arg1601z00_314 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_299, 
(long)CINT(BgL_tempoz00_303)); 
VECTOR_SET(BgL_v1185z00_313,((long)0),
((obj_t)BgL_arg1601z00_314)); } 
BgL_tracksz00_305 = BgL_v1185z00_313; } break;case ((long)1) : 

BgL_tracksz00_305 = 
BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_299, 
(long)CINT(BgL_tempoz00_303), BgL_tckz00_302); break;case ((long)2) : 

BgL_tracksz00_305 = 
BGl_errorz00zz__errorz00(BGl_string3080z00zz__multimediazd2midizd2, BGl_string3081z00zz__multimediazd2midizd2, BgL_fmtz00_301); break;
default: 
BgL_tracksz00_305 = 
BGl_errorz00zz__errorz00(BGl_string3082z00zz__multimediazd2midizd2, BGl_string3083z00zz__multimediazd2midizd2, BgL_fmtz00_301); } }  else 
{ /* Llib/midi.scm 187 */
BgL_tracksz00_305 = 
BGl_errorz00zz__errorz00(BGl_string3082z00zz__multimediazd2midizd2, BGl_string3083z00zz__multimediazd2midizd2, BgL_fmtz00_301); } 
{ /* Llib/midi.scm 192 */
BgL_midiscorez00_bglt BgL_new1130z00_306;
{ /* Llib/midi.scm 193 */
BgL_midiscorez00_bglt BgL_new1129z00_308;
BgL_new1129z00_308 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 193 */
long BgL_arg1599z00_309;
{ /* Llib/midi.scm 193 */
long BgL_res2591z00_1940;
BgL_res2591z00_1940 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg1599z00_309 = BgL_res2591z00_1940; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1129z00_308), BgL_arg1599z00_309); } 
BgL_new1130z00_306 = BgL_new1129z00_308; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1130z00_306))->BgL_formatz00)=((long)
(long)CINT(BgL_fmtz00_301)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1130z00_306))->BgL_tempoz00)=((long)
(long)CINT(BgL_tempoz00_303)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1130z00_306))->BgL_ppqz00)=((long)
(long)CINT(BgL_ppqz00_304)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1130z00_306))->BgL_tracksz00)=((obj_t)BgL_tracksz00_305),BUNSPEC); 
{ /* Llib/midi.scm 192 */
obj_t BgL_fun1587z00_307;
BgL_fun1587z00_307 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1587z00_307)(BgL_fun1587z00_307, 
((obj_t)BgL_new1130z00_306), BEOA); } 
return BgL_new1130z00_306;} } } } } } 

}



/* &midiscore-file */
BgL_midiscorez00_bglt BGl_z62midiscorezd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3159, obj_t BgL_filenamez00_3160)
{
{ /* Llib/midi.scm 183 */
{ /* Llib/midi.scm 184 */
obj_t BgL_auxz00_4776;
if(
STRINGP(BgL_filenamez00_3160))
{ /* Llib/midi.scm 184 */
BgL_auxz00_4776 = BgL_filenamez00_3160
; }  else 
{ 
obj_t BgL_auxz00_4779;
BgL_auxz00_4779 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)8489)), BGl_string3085z00zz__multimediazd2midizd2, BGl_string3086z00zz__multimediazd2midizd2, BgL_filenamez00_3160); 
FAILURE(BgL_auxz00_4779,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4776);} } 

}



/* miditrack-input-port */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_15, long BgL_tempoz00_16)
{
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
BgL_miditrackz00_bglt BgL_new1134z00_331;
{ /* Llib/midi.scm 213 */
BgL_miditrackz00_bglt BgL_new1133z00_333;
BgL_new1133z00_333 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 213 */
long BgL_arg1632z00_334;
{ /* Llib/midi.scm 213 */
long BgL_res2592z00_1944;
BgL_res2592z00_1944 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg1632z00_334 = BgL_res2592z00_1944; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1133z00_333), BgL_arg1632z00_334); } 
BgL_new1134z00_331 = BgL_new1133z00_333; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_z52streamz52)=((obj_t)BgL_ipz00_15),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2inputzd2portz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_z52closez52)=((obj_t)BGl_closezd2inputzd2portzd2envzd2zz__r4_ports_6_10_1z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4794;
{ /* Llib/midi.scm 216 */
obj_t BgL_tmpz00_4795;
BgL_tmpz00_4795 = 
BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(BgL_ipz00_15); 
BgL_auxz00_4794 = 
BGL_BINT32_TO_INT32(BgL_tmpz00_4795); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_lenz00)=((int32_t)BgL_auxz00_4794),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_tempoz00)=((long)BgL_tempoz00_16),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1134z00_331))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 212 */
obj_t BgL_fun1628z00_332;
BgL_fun1628z00_332 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1628z00_332)(BgL_fun1628z00_332, 
((obj_t)BgL_new1134z00_331), BEOA); } 
return BgL_new1134z00_331;} } 

}



/* &miditrack-input-port */
BgL_miditrackz00_bglt BGl_z62miditrackzd2inputzd2portz62zz__multimediazd2midizd2(obj_t BgL_envz00_3161, obj_t BgL_ipz00_3162, obj_t BgL_tempoz00_3163)
{
{ /* Llib/midi.scm 211 */
{ /* Llib/midi.scm 212 */
long BgL_auxz00_4819;obj_t BgL_auxz00_4812;
{ /* Llib/midi.scm 212 */
obj_t BgL_tmpz00_4820;
if(
INTEGERP(BgL_tempoz00_3163))
{ /* Llib/midi.scm 212 */
BgL_tmpz00_4820 = BgL_tempoz00_3163
; }  else 
{ 
obj_t BgL_auxz00_4823;
BgL_auxz00_4823 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string3087z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tempoz00_3163); 
FAILURE(BgL_auxz00_4823,BFALSE,BFALSE);} 
BgL_auxz00_4819 = 
(long)CINT(BgL_tmpz00_4820); } 
if(
INPUT_PORTP(BgL_ipz00_3162))
{ /* Llib/midi.scm 212 */
BgL_auxz00_4812 = BgL_ipz00_3162
; }  else 
{ 
obj_t BgL_auxz00_4815;
BgL_auxz00_4815 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)9695)), BGl_string3087z00zz__multimediazd2midizd2, BGl_string3088z00zz__multimediazd2midizd2, BgL_ipz00_3162); 
FAILURE(BgL_auxz00_4815,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_auxz00_4812, BgL_auxz00_4819);} } 

}



/* miditracks-input-port */
obj_t BGl_miditrackszd2inputzd2portz00zz__multimediazd2midizd2(obj_t BgL_ipz00_17, long BgL_tempoz00_18, obj_t BgL_tnumz00_19)
{
{ /* Llib/midi.scm 222 */
{ 
obj_t BgL_ipz00_361;long BgL_tempoz00_362;
{ /* Llib/midi.scm 241 */
BgL_miditrackz00_bglt BgL_t0z00_337;
BgL_ipz00_361 = BgL_ipz00_17; 
BgL_tempoz00_362 = BgL_tempoz00_18; 
{ /* Llib/midi.scm 225 */
BgL_miditrackz00_bglt BgL_trackz00_364;
BgL_trackz00_364 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_361, BgL_tempoz00_362); 
{ /* Llib/midi.scm 227 */
BgL_midireaderz00_bglt BgL_i1136z00_366;
BgL_i1136z00_366 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_364))->BgL_z52readerz52); 
{ 

BgL_zc3z04anonymousza31669ze3z87_368:
{ /* Llib/midi.scm 229 */
obj_t BgL_fun1676z00_369;
BgL_fun1676z00_369 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1136z00_366))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 229 */
obj_t BgL_arg1675z00_370;
BgL_arg1675z00_370 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_364))->BgL_z52streamz52); 
PROCEDURE_ENTRY(BgL_fun1676z00_369)(BgL_fun1676z00_369, BgL_arg1675z00_370, BEOA); } } 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_364, BGl_midiplayerzd2readzd2zz__multimediazd2midizd2, BGl_midisinkzd2nullzd2zz__multimediazd2midizd2, ((long)0), ((long)0), ((long)0), 
LONG_TO_LLONG(((long)0))); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_364))->BgL_z52eotz52))
{ /* Llib/midi.scm 232 */
BgL_t0z00_337 = BgL_trackz00_364; }  else 
{ /* Llib/midi.scm 232 */
goto BgL_zc3z04anonymousza31669ze3z87_368;} } } } 
{ /* Llib/midi.scm 243 */
obj_t BgL_filez00_339;
{ /* Llib/midi.scm 243 */
obj_t BgL_res2593z00_1952;
BgL_res2593z00_1952 = 
INPUT_PORT_NAME(BgL_ipz00_17); 
BgL_filez00_339 = BgL_res2593z00_1952; } 
{ /* Llib/midi.scm 244 */
long BgL_g1139z00_340;
{ /* Llib/midi.scm 245 */
long BgL_res2594z00_1954;
BgL_res2594z00_1954 = 
INPUT_PORT_FILEPOS(BgL_ipz00_17); 
BgL_g1139z00_340 = BgL_res2594z00_1954; } 
{ 
long BgL_iz00_343;long BgL_posz00_344;obj_t BgL_tksz00_345;
BgL_iz00_343 = ((long)1); 
BgL_posz00_344 = BgL_g1139z00_340; 
BgL_tksz00_345 = BNIL; 
BgL_zc3z04anonymousza31633ze3z87_346:
if(
(BgL_iz00_343==
(long)CINT(BgL_tnumz00_19)))
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1635z00_348;
{ /* Llib/midi.scm 248 */
obj_t BgL_arg1638z00_349;
BgL_arg1638z00_349 = 
bgl_reverse_bang(BgL_tksz00_345); 
BgL_arg1635z00_348 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_t0z00_337), BgL_arg1638z00_349); } 
return 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg1635z00_348);}  else 
{ /* Llib/midi.scm 249 */
obj_t BgL_ipz00_350;
{ /* Llib/midi.scm 237 */
obj_t BgL_portz00_1958;
{ /* Llib/midi.scm 237 */

BgL_portz00_1958 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BgL_filez00_339, BTRUE, 
BINT(((long)5000000))); } 
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_portz00_1958, BgL_posz00_344); 
BgL_ipz00_350 = BgL_portz00_1958; } 
{ /* Llib/midi.scm 249 */
BgL_miditrackz00_bglt BgL_tz00_351;
BgL_tz00_351 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_350, 
(((BgL_miditrackz00_bglt)COBJECT(BgL_t0z00_337))->BgL_tempoz00)); 
{ /* Llib/midi.scm 250 */

{ /* Llib/midi.scm 252 */
long BgL_arg1643z00_353;long BgL_arg1650z00_354;obj_t BgL_arg1652z00_355;
BgL_arg1643z00_353 = 
(BgL_iz00_343+((long)1)); 
{ /* Llib/midi.scm 253 */
long BgL_arg1655z00_356;long BgL_arg1658z00_357;
{ /* Llib/midi.scm 253 */
long BgL_res2597z00_1965;
{ /* Llib/midi.scm 253 */
obj_t BgL_tmpz00_4856;
BgL_tmpz00_4856 = 
((obj_t)BgL_ipz00_350); 
BgL_res2597z00_1965 = 
INPUT_PORT_FILEPOS(BgL_tmpz00_4856); } 
BgL_arg1655z00_356 = BgL_res2597z00_1965; } 
{ /* Llib/midi.scm 253 */
int32_t BgL_arg1659z00_358;
BgL_arg1659z00_358 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_tz00_351))->BgL_lenz00); 
{ /* Llib/midi.scm 253 */
long BgL_res2599z00_1970;
{ /* Llib/midi.scm 253 */
long BgL_arg1426z00_1967;
BgL_arg1426z00_1967 = 
(long)(BgL_arg1659z00_358); 
{ /* Llib/midi.scm 253 */
long BgL_res2598z00_1969;
BgL_res2598z00_1969 = 
(long)(BgL_arg1426z00_1967); 
BgL_res2599z00_1970 = BgL_res2598z00_1969; } } 
BgL_arg1658z00_357 = BgL_res2599z00_1970; } } 
BgL_arg1650z00_354 = 
(BgL_arg1655z00_356+BgL_arg1658z00_357); } 
BgL_arg1652z00_355 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_tz00_351), BgL_tksz00_345); 
{ 
obj_t BgL_tksz00_4867;long BgL_posz00_4866;long BgL_iz00_4865;
BgL_iz00_4865 = BgL_arg1643z00_353; 
BgL_posz00_4866 = BgL_arg1650z00_354; 
BgL_tksz00_4867 = BgL_arg1652z00_355; 
BgL_tksz00_345 = BgL_tksz00_4867; 
BgL_posz00_344 = BgL_posz00_4866; 
BgL_iz00_343 = BgL_iz00_4865; 
goto BgL_zc3z04anonymousza31633ze3z87_346;} } } } } } } } } } } 

}



/* miditrack-file */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2filezd2zz__multimediazd2midizd2(obj_t BgL_filenamez00_20, long BgL_offsetz00_21, long BgL_tempoz00_22)
{
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
obj_t BgL_zc3z04anonymousza31682ze3z87_3166;
BgL_zc3z04anonymousza31682ze3z87_3166 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31682ze3ze5zz__multimediazd2midizd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31682ze3z87_3166, 
(int)(((long)0)), 
BINT(BgL_offsetz00_21)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31682ze3z87_3166, 
(int)(((long)1)), 
BINT(BgL_tempoz00_22)); 
return 
((BgL_miditrackz00_bglt)
BGl_callzd2withzd2inputzd2filezd2zz__r4_ports_6_10_1z00(BgL_filenamez00_20, BgL_zc3z04anonymousza31682ze3z87_3166));} } 

}



/* &miditrack-file */
BgL_miditrackz00_bglt BGl_z62miditrackzd2filezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3167, obj_t BgL_filenamez00_3168, obj_t BgL_offsetz00_3169, obj_t BgL_tempoz00_3170)
{
{ /* Llib/midi.scm 259 */
{ /* Llib/midi.scm 262 */
long BgL_auxz00_4895;long BgL_auxz00_4886;obj_t BgL_auxz00_4879;
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4896;
if(
INTEGERP(BgL_tempoz00_3170))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4896 = BgL_tempoz00_3170
; }  else 
{ 
obj_t BgL_auxz00_4899;
BgL_auxz00_4899 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3090z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tempoz00_3170); 
FAILURE(BgL_auxz00_4899,BFALSE,BFALSE);} 
BgL_auxz00_4895 = 
(long)CINT(BgL_tmpz00_4896); } 
{ /* Llib/midi.scm 262 */
obj_t BgL_tmpz00_4887;
if(
INTEGERP(BgL_offsetz00_3169))
{ /* Llib/midi.scm 262 */
BgL_tmpz00_4887 = BgL_offsetz00_3169
; }  else 
{ 
obj_t BgL_auxz00_4890;
BgL_auxz00_4890 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3090z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_offsetz00_3169); 
FAILURE(BgL_auxz00_4890,BFALSE,BFALSE);} 
BgL_auxz00_4886 = 
(long)CINT(BgL_tmpz00_4887); } 
if(
STRINGP(BgL_filenamez00_3168))
{ /* Llib/midi.scm 262 */
BgL_auxz00_4879 = BgL_filenamez00_3168
; }  else 
{ 
obj_t BgL_auxz00_4882;
BgL_auxz00_4882 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)11501)), BGl_string3090z00zz__multimediazd2midizd2, BGl_string3086z00zz__multimediazd2midizd2, BgL_filenamez00_3168); 
FAILURE(BgL_auxz00_4882,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2filezd2zz__multimediazd2midizd2(BgL_auxz00_4879, BgL_auxz00_4886, BgL_auxz00_4895);} } 

}



/* &<@anonymous:1682> */
obj_t BGl_z62zc3z04anonymousza31682ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3171, obj_t BgL_ipz00_3174)
{
{ /* Llib/midi.scm 261 */
{ /* Llib/midi.scm 262 */
long BgL_offsetz00_3172;long BgL_tempoz00_3173;
BgL_offsetz00_3172 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_3171, 
(int)(((long)0)))); 
BgL_tempoz00_3173 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_3171, 
(int)(((long)1)))); 
{ 
BgL_miditrackz00_bglt BgL_auxz00_4911;
BGl_setzd2inputzd2portzd2positionz12zc0zz__r4_ports_6_10_1z00(BgL_ipz00_3174, BgL_offsetz00_3172); 
BgL_auxz00_4911 = 
BGl_miditrackzd2inputzd2portz00zz__multimediazd2midizd2(BgL_ipz00_3174, BgL_tempoz00_3173); 
return 
((obj_t)BgL_auxz00_4911);} } } 

}



/* miditrack-string */
BGL_EXPORTED_DEF BgL_miditrackz00_bglt BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(obj_t BgL_stringz00_23, long BgL_tempoz00_24)
{
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
BgL_miditrackz00_bglt BgL_new1143z00_386;
{ /* Llib/midi.scm 270 */
BgL_miditrackz00_bglt BgL_new1142z00_390;
BgL_new1142z00_390 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 270 */
long BgL_arg1687z00_391;
{ /* Llib/midi.scm 270 */
long BgL_res2601z00_1977;
BgL_res2601z00_1977 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg1687z00_391 = BgL_res2601z00_1977; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1142z00_390), BgL_arg1687z00_391); } 
BgL_new1143z00_386 = BgL_new1142z00_390; } 
{ 
obj_t BgL_auxz00_4919;
{ /* Llib/midi.scm 127 */
obj_t BgL_newz00_1980;
BgL_newz00_1980 = 
create_struct(
CNST_TABLE_REF(((long)4)), 
(int)(((long)2))); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_4925;int BgL_tmpz00_4923;
BgL_auxz00_4925 = 
BINT(((long)0)); 
BgL_tmpz00_4923 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_1980, BgL_tmpz00_4923, BgL_auxz00_4925); } 
{ /* Llib/midi.scm 127 */
int BgL_tmpz00_4928;
BgL_tmpz00_4928 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_1980, BgL_tmpz00_4928, BgL_stringz00_23); } 
BgL_auxz00_4919 = BgL_newz00_1980; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52streamz52)=((obj_t)BgL_auxz00_4919),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BGl_midireaderzd2stringzd2streamz00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52closez52)=((obj_t)BGl_proc3091z00zz__multimediazd2midizd2),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52wtickz52)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
{ 
int32_t BgL_auxz00_4937;
{ /* Llib/midi.scm 273 */
long BgL_tmpz00_4938;
BgL_tmpz00_4938 = 
STRING_LENGTH(BgL_stringz00_23); 
BgL_auxz00_4937 = 
(int32_t)(BgL_tmpz00_4938); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_lenz00)=((int32_t)BgL_auxz00_4937),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_tempoz00)=((long)BgL_tempoz00_24),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_ipz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_wtickz00)=((uint32_t)(uint32_t)(0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_statusz00)=((long)((long)-1)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1143z00_386))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
{ /* Llib/midi.scm 269 */
obj_t BgL_fun1684z00_389;
BgL_fun1684z00_389 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun1684z00_389)(BgL_fun1684z00_389, 
((obj_t)BgL_new1143z00_386), BEOA); } 
return BgL_new1143z00_386;} } 

}



/* &miditrack-string */
BgL_miditrackz00_bglt BGl_z62miditrackzd2stringzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3176, obj_t BgL_stringz00_3177, obj_t BgL_tempoz00_3178)
{
{ /* Llib/midi.scm 268 */
{ /* Llib/midi.scm 269 */
long BgL_auxz00_4962;obj_t BgL_auxz00_4955;
{ /* Llib/midi.scm 269 */
obj_t BgL_tmpz00_4963;
if(
INTEGERP(BgL_tempoz00_3178))
{ /* Llib/midi.scm 269 */
BgL_tmpz00_4963 = BgL_tempoz00_3178
; }  else 
{ 
obj_t BgL_auxz00_4966;
BgL_auxz00_4966 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string3092z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tempoz00_3178); 
FAILURE(BgL_auxz00_4966,BFALSE,BFALSE);} 
BgL_auxz00_4962 = 
(long)CINT(BgL_tmpz00_4963); } 
if(
STRINGP(BgL_stringz00_3177))
{ /* Llib/midi.scm 269 */
BgL_auxz00_4955 = BgL_stringz00_3177
; }  else 
{ 
obj_t BgL_auxz00_4958;
BgL_auxz00_4958 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)11847)), BGl_string3092z00zz__multimediazd2midizd2, BGl_string3086z00zz__multimediazd2midizd2, BgL_stringz00_3177); 
FAILURE(BgL_auxz00_4958,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2stringzd2zz__multimediazd2midizd2(BgL_auxz00_4955, BgL_auxz00_4962);} } 

}



/* &<@anonymous:1683> */
obj_t BGl_z62zc3z04anonymousza31683ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3179, obj_t BgL_sz00_3180)
{
{ /* Llib/midi.scm 272 */
return 
BBOOL(((bool_t)0));} 

}



/* midiscore-play */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_25, BgL_midiplayerz00_bglt BgL_mplayerz00_26, BgL_midisinkz00_bglt BgL_msinkz00_27)
{
{ /* Llib/midi.scm 279 */
{ 

{ /* Llib/midi.scm 281 */
long BgL_aux1146z00_394;
BgL_aux1146z00_394 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
switch( BgL_aux1146z00_394) { case ((long)0) : 

return 
BBOOL(
BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;case ((long)1) : 

return 
BBOOL(
BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_mscorez00_25, BgL_mplayerz00_26, BgL_msinkz00_27));break;
default: 
{ /* Llib/midi.scm 284 */
long BgL_arg1691z00_396;
BgL_arg1691z00_396 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_25))->BgL_formatz00); 
return 
BGl_errorz00zz__errorz00(BGl_string3093z00zz__multimediazd2midizd2, BGl_string3083z00zz__multimediazd2midizd2, 
BINT(BgL_arg1691z00_396));} } } } } 

}



/* &midiscore-play */
obj_t BGl_z62midiscorezd2playzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3181, obj_t BgL_mscorez00_3182, obj_t BgL_mplayerz00_3183, obj_t BgL_msinkz00_3184)
{
{ /* Llib/midi.scm 279 */
{ /* Llib/midi.scm 280 */
BgL_midisinkz00_bglt BgL_auxz00_4998;BgL_midiplayerz00_bglt BgL_auxz00_4990;BgL_midiscorez00_bglt BgL_auxz00_4982;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3184, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4998 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3184)
; }  else 
{ 
obj_t BgL_auxz00_5002;
BgL_auxz00_5002 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3094z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msinkz00_3184); 
FAILURE(BgL_auxz00_5002,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3183, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4990 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3183)
; }  else 
{ 
obj_t BgL_auxz00_4994;
BgL_auxz00_4994 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3094z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mplayerz00_3183); 
FAILURE(BgL_auxz00_4994,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3182, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 280 */
BgL_auxz00_4982 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3182)
; }  else 
{ 
obj_t BgL_auxz00_4986;
BgL_auxz00_4986 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)12346)), BGl_string3094z00zz__multimediazd2midizd2, BGl_string3095z00zz__multimediazd2midizd2, BgL_mscorez00_3182); 
FAILURE(BgL_auxz00_4986,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2playzd2zz__multimediazd2midizd2(BgL_auxz00_4982, BgL_auxz00_4990, BgL_auxz00_4998);} } 

}



/* midiscore-play0 */
bool_t BGl_midiscorezd2play0zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_28, BgL_midiplayerz00_bglt BgL_mplayerz00_29, BgL_midisinkz00_bglt BgL_msinkz00_30)
{
{ /* Llib/midi.scm 289 */
{ /* Llib/midi.scm 291 */
obj_t BgL_trackz00_398;
BgL_trackz00_398 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_tracksz00),((long)0)); 
{ /* Llib/midi.scm 293 */
BgL_midireaderz00_bglt BgL_i1149z00_400;
BgL_i1149z00_400 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_398)))->BgL_z52readerz52); 
{ 
uint32_t BgL_tickz00_402;
BgL_tickz00_402 = (uint32_t)(0); 
BgL_zc3z04anonymousza31692ze3z87_403:
{ /* Llib/midi.scm 295 */
BGL_LONGLONG_T BgL_t0z00_404;
BgL_t0z00_404 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 295 */
obj_t BgL_dtz00_405;
{ /* Llib/midi.scm 296 */
obj_t BgL_fun1700z00_410;
BgL_fun1700z00_410 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1149z00_400))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 296 */
obj_t BgL_arg1699z00_411;
BgL_arg1699z00_411 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_398)))->BgL_z52streamz52); 
BgL_dtz00_405 = 
PROCEDURE_ENTRY(BgL_fun1700z00_410)(BgL_fun1700z00_410, BgL_arg1699z00_411, BEOA); } } 
{ /* Llib/midi.scm 296 */

{ /* Llib/midi.scm 298 */
long BgL_arg1693z00_406;long BgL_arg1694z00_407;
{ /* Llib/midi.scm 298 */
long BgL_res2604z00_1988;
BgL_res2604z00_1988 = 
(long)(BgL_tickz00_402); 
BgL_arg1693z00_406 = BgL_res2604z00_1988; } 
BgL_arg1694z00_407 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_28))->BgL_ppqz00); 
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_398), BgL_mplayerz00_29, BgL_msinkz00_30, BgL_arg1693z00_406, BgL_arg1694z00_407, 
(long)CINT(BgL_dtz00_405), BgL_t0z00_404); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_398)))->BgL_z52eotz52))
{ /* Llib/midi.scm 299 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 300 */
uint32_t BgL_arg1697z00_409;
BgL_arg1697z00_409 = 
(BgL_tickz00_402+
(uint32_t)(((long)1))); 
{ 
uint32_t BgL_tickz00_5029;
BgL_tickz00_5029 = BgL_arg1697z00_409; 
BgL_tickz00_402 = BgL_tickz00_5029; 
goto BgL_zc3z04anonymousza31692ze3z87_403;} } } } } } } } } 

}



/* midiscore-play1 */
bool_t BGl_midiscorezd2play1zd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_31, BgL_midiplayerz00_bglt BgL_mplayerz00_32, BgL_midisinkz00_bglt BgL_msinkz00_33)
{
{ /* Llib/midi.scm 305 */
{ /* Llib/midi.scm 307 */
obj_t BgL_v1191z00_415;
BgL_v1191z00_415 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
{ /* Llib/midi.scm 307 */

{ 
long BgL_i1190z00_418;
BgL_i1190z00_418 = ((long)0); 
BgL_zc3z04anonymousza31707ze3z87_419:
if(
(BgL_i1190z00_418<
VECTOR_LENGTH(BgL_v1191z00_415)))
{ /* Llib/midi.scm 307 */
{ /* Llib/midi.scm 308 */
obj_t BgL_trackz00_421;
BgL_trackz00_421 = 
VECTOR_REF(BgL_v1191z00_415,BgL_i1190z00_418); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_421)))->BgL_z52eotz52))
{ /* Llib/midi.scm 309 */BFALSE; }  else 
{ /* Llib/midi.scm 310 */
BgL_midireaderz00_bglt BgL_i1152z00_424;
BgL_i1152z00_424 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_421)))->BgL_z52readerz52); 
{ /* Llib/midi.scm 311 */
obj_t BgL_dtz00_425;
{ /* Llib/midi.scm 311 */
obj_t BgL_fun1713z00_426;
BgL_fun1713z00_426 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1152z00_424))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 311 */
obj_t BgL_arg1712z00_427;
BgL_arg1712z00_427 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_421)))->BgL_z52streamz52); 
BgL_dtz00_425 = 
PROCEDURE_ENTRY(BgL_fun1713z00_426)(BgL_fun1713z00_426, BgL_arg1712z00_427, BEOA); } } 
{ 
uint32_t BgL_auxz00_5047;
{ /* Llib/midi.scm 312 */
int32_t BgL_res2607z00_1999;
{ /* Llib/midi.scm 312 */
long BgL_xz00_1998;
BgL_xz00_1998 = 
(long)CINT(BgL_dtz00_425); 
BgL_res2607z00_1999 = 
(int32_t)(BgL_xz00_1998); } 
BgL_auxz00_5047 = 
(uint32_t)(BgL_res2607z00_1999); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_421)))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_5047),BUNSPEC); } } } } 
{ 
long BgL_i1190z00_5053;
BgL_i1190z00_5053 = 
(BgL_i1190z00_418+((long)1)); 
BgL_i1190z00_418 = BgL_i1190z00_5053; 
goto BgL_zc3z04anonymousza31707ze3z87_419;} }  else 
{ /* Llib/midi.scm 307 */((bool_t)0); } } } } 
{ /* Llib/midi.scm 314 */
long BgL_resz00_430;
{ /* Llib/midi.scm 314 */
BgL_miditrackz00_bglt BgL_i1153z00_459;
{ /* Llib/midi.scm 314 */
obj_t BgL_arg1767z00_462;
BgL_arg1767z00_462 = 
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00); 
BgL_i1153z00_459 = 
((BgL_miditrackz00_bglt)
VECTOR_REF(BgL_arg1767z00_462,((long)0))); } 
BgL_resz00_430 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_i1153z00_459))->BgL_tempoz00)/
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_ppqz00)); } 
{ 
uint32_t BgL_tickz00_432;
BgL_tickz00_432 = (uint32_t)(0); 
BgL_zc3z04anonymousza31715ze3z87_433:
{ /* Llib/midi.scm 317 */
BGL_LONGLONG_T BgL_t0z00_434;
BgL_t0z00_434 = 
bgl_current_microseconds(); 
{ /* Llib/midi.scm 317 */
bool_t BgL_eosz00_435;
BgL_eosz00_435 = ((bool_t)1); 
{ /* Llib/midi.scm 318 */

{ /* Llib/midi.scm 319 */
long BgL_g1154z00_436;
{ /* Llib/midi.scm 319 */
long BgL_arg1731z00_449;
BgL_arg1731z00_449 = 
VECTOR_LENGTH(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00)); 
BgL_g1154z00_436 = 
(BgL_arg1731z00_449-((long)1)); } 
{ 
long BgL_iz00_438;
BgL_iz00_438 = BgL_g1154z00_436; 
BgL_zc3z04anonymousza31716ze3z87_439:
if(
(BgL_iz00_438>((long)0)))
{ /* Llib/midi.scm 320 */
{ /* Llib/midi.scm 321 */
obj_t BgL_trackz00_441;
BgL_trackz00_441 = 
VECTOR_REF(
(((BgL_midiscorez00_bglt)COBJECT(BgL_mscorez00_31))->BgL_tracksz00),BgL_iz00_438); 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_441)))->BgL_z52eotz52))
{ /* Llib/midi.scm 323 */BFALSE; }  else 
{ /* Llib/midi.scm 323 */
{ /* Llib/midi.scm 325 */
long BgL_arg1720z00_444;
{ /* Llib/midi.scm 325 */
long BgL_res2613z00_2015;
BgL_res2613z00_2015 = 
(long)(BgL_tickz00_432); 
BgL_arg1720z00_444 = BgL_res2613z00_2015; } 
BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(
((BgL_miditrackz00_bglt)BgL_trackz00_441), BgL_mplayerz00_32, BgL_msinkz00_33, BgL_arg1720z00_444); } 
if(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_trackz00_441)))->BgL_z52eotz52))
{ /* Llib/midi.scm 326 */BFALSE; }  else 
{ /* Llib/midi.scm 326 */
BgL_eosz00_435 = ((bool_t)0); } } } 
{ 
long BgL_iz00_5078;
BgL_iz00_5078 = 
(BgL_iz00_438-((long)1)); 
BgL_iz00_438 = BgL_iz00_5078; 
goto BgL_zc3z04anonymousza31716ze3z87_439;} }  else 
{ /* Llib/midi.scm 320 */((bool_t)0); } } } 
if(BgL_eosz00_435)
{ /* Llib/midi.scm 328 */
return ((bool_t)0);}  else 
{ /* Llib/midi.scm 329 */
long BgL_usz00_451;
{ /* Llib/midi.scm 329 */
BGL_LONGLONG_T BgL_arg1754z00_456;
BgL_arg1754z00_456 = 
(
bgl_current_microseconds()-BgL_t0z00_434); 
{ /* Llib/midi.scm 329 */
long BgL_res2617z00_2023;
BgL_res2617z00_2023 = 
LLONG_TO_LONG(BgL_arg1754z00_456); 
BgL_usz00_451 = BgL_res2617z00_2023; } } 
{ /* Llib/midi.scm 331 */
obj_t BgL_fun1736z00_453;
BgL_fun1736z00_453 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_33))->BgL_usleepz00); 
{ /* Llib/midi.scm 331 */
long BgL_arg1735z00_454;
BgL_arg1735z00_454 = 
(BgL_resz00_430-BgL_usz00_451); 
PROCEDURE_ENTRY(BgL_fun1736z00_453)(BgL_fun1736z00_453, 
BINT(BgL_arg1735z00_454), BEOA); } } 
{ 
uint32_t BgL_tickz00_5091;
BgL_tickz00_5091 = 
(BgL_tickz00_432+(uint32_t)(1)); 
BgL_tickz00_432 = BgL_tickz00_5091; 
goto BgL_zc3z04anonymousza31715ze3z87_433;} } } } } } } } 

}



/* miditrack-wait-event */
obj_t BGl_miditrackzd2waitzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_34, BgL_midiplayerz00_bglt BgL_mplayerz00_35, BgL_midisinkz00_bglt BgL_msinkz00_36, long BgL_tickz00_37)
{
{ /* Llib/midi.scm 337 */
{ /* Llib/midi.scm 340 */
BgL_midireaderz00_bglt BgL_i1158z00_464;
BgL_i1158z00_464 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52readerz52); 
{ /* Llib/midi.scm 341 */
bool_t BgL_test3664z00_5094;
{ /* Llib/midi.scm 341 */
uint32_t BgL_n2z00_2031;
BgL_n2z00_2031 = 
(uint32_t)(BgL_tickz00_37); 
BgL_test3664z00_5094 = 
(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)<=BgL_n2z00_2031); } 
if(BgL_test3664z00_5094)
{ 

BgL_zc3z04anonymousza31770ze3z87_468:
BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_trackz00_34, BgL_mplayerz00_35, BgL_msinkz00_36, BgL_tickz00_37, ((long)0), ((long)0), ((BGL_LONGLONG_T)0)); 
if(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52eotz52))
{ /* Llib/midi.scm 344 */
return BFALSE;}  else 
{ /* Llib/midi.scm 345 */
obj_t BgL_dtz00_470;
{ /* Llib/midi.scm 345 */
obj_t BgL_fun1775z00_473;
BgL_fun1775z00_473 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1158z00_464))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 345 */
obj_t BgL_arg1774z00_474;
BgL_arg1774z00_474 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52streamz52); 
BgL_dtz00_470 = 
PROCEDURE_ENTRY(BgL_fun1775z00_473)(BgL_fun1775z00_473, BgL_arg1774z00_474, BEOA); } } 
if(
(
(long)CINT(BgL_dtz00_470)==((long)0)))
{ /* Llib/midi.scm 346 */
goto BgL_zc3z04anonymousza31770ze3z87_468;}  else 
{ 
uint32_t BgL_auxz00_5110;
{ /* Llib/midi.scm 348 */
int32_t BgL_arg1773z00_472;
{ /* Llib/midi.scm 348 */
int32_t BgL_res2622z00_2036;
{ /* Llib/midi.scm 348 */
long BgL_xz00_2035;
BgL_xz00_2035 = 
(long)CINT(BgL_dtz00_470); 
BgL_res2622z00_2036 = 
(int32_t)(BgL_xz00_2035); } 
BgL_arg1773z00_472 = BgL_res2622z00_2036; } 
{ /* Llib/midi.scm 348 */
uint32_t BgL_za71za7_2037;uint32_t BgL_za72za7_2038;
BgL_za71za7_2037 = 
(uint32_t)(BgL_tickz00_37); 
BgL_za72za7_2038 = 
(uint32_t)(BgL_arg1773z00_472); 
BgL_auxz00_5110 = 
(BgL_za71za7_2037+BgL_za72za7_2038); } } 
return 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_34))->BgL_z52wtickz52)=((uint32_t)BgL_auxz00_5110),BUNSPEC);} } }  else 
{ /* Llib/midi.scm 341 */
return BFALSE;} } } } 

}



/* miditrack-play-event */
obj_t BGl_miditrackzd2playzd2eventz00zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_trackz00_38, BgL_midiplayerz00_bglt BgL_mplayerz00_39, BgL_midisinkz00_bglt BgL_msinkz00_40, long BgL_tickz00_41, long BgL_ppqz00_42, long BgL_dtz00_43, BGL_LONGLONG_T BgL_t0z00_44)
{
{ /* Llib/midi.scm 353 */
{ /* Llib/midi.scm 357 */
BgL_midireaderz00_bglt BgL_i1160z00_478;
BgL_i1160z00_478 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52readerz52); 
{ /* Llib/midi.scm 372 */
obj_t BgL_statusz00_480;
{ /* Llib/midi.scm 372 */
bool_t BgL_test3667z00_5118;
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1983z00_714;
{ /* Llib/midi.scm 372 */
obj_t BgL_fun1985z00_715;
BgL_fun1985z00_715 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_peekzd2bytezd2); 
{ /* Llib/midi.scm 372 */
obj_t BgL_arg1984z00_716;
BgL_arg1984z00_716 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1983z00_714 = 
PROCEDURE_ENTRY(BgL_fun1985z00_715)(BgL_fun1985z00_715, BgL_arg1984z00_716, BEOA); } } 
BgL_test3667z00_5118 = 
(
(long)CINT(BgL_arg1983z00_714)<((long)128)); } 
if(BgL_test3667z00_5118)
{ /* Llib/midi.scm 372 */
BgL_statusz00_480 = 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)); }  else 
{ /* Llib/midi.scm 374 */
obj_t BgL_sz00_711;
{ /* Llib/midi.scm 374 */
obj_t BgL_fun1982z00_712;
BgL_fun1982z00_712 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 374 */
obj_t BgL_arg1981z00_713;
BgL_arg1981z00_713 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sz00_711 = 
PROCEDURE_ENTRY(BgL_fun1982z00_712)(BgL_fun1982z00_712, BgL_arg1981z00_713, BEOA); } } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52statusz52)=((long)
(long)CINT(BgL_sz00_711)),BUNSPEC); 
BgL_statusz00_480 = BgL_sz00_711; } } 
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)8)))
{ /* Llib/midi.scm 380 */
long BgL_kkz00_483;
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1788z00_494;
{ /* Llib/midi.scm 380 */
obj_t BgL_fun1790z00_495;
BgL_fun1790z00_495 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 380 */
obj_t BgL_arg1789z00_496;
BgL_arg1789z00_496 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1788z00_494 = 
PROCEDURE_ENTRY(BgL_fun1790z00_495)(BgL_fun1790z00_495, BgL_arg1789z00_496, BEOA); } } 
BgL_kkz00_483 = 
(((long)127) & 
(long)CINT(BgL_arg1788z00_494)); } 
{ /* Llib/midi.scm 380 */
long BgL_vvz00_484;
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1785z00_491;
{ /* Llib/midi.scm 381 */
obj_t BgL_fun1787z00_492;
BgL_fun1787z00_492 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 381 */
obj_t BgL_arg1786z00_493;
BgL_arg1786z00_493 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1785z00_491 = 
PROCEDURE_ENTRY(BgL_fun1787z00_492)(BgL_fun1787z00_492, BgL_arg1786z00_493, BEOA); } } 
BgL_vvz00_484 = 
(((long)127) & 
(long)CINT(BgL_arg1785z00_491)); } 
{ /* Llib/midi.scm 381 */

{ /* Llib/midi.scm 382 */
obj_t BgL_fun1780z00_485;
BgL_fun1780z00_485 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 383 */
long BgL_arg1779z00_486;
{ /* Llib/midi.scm 383 */
BGL_LONGLONG_T BgL_arg1781z00_487;
BgL_arg1781z00_487 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 383 */
long BgL_res2631z00_2057;
BgL_res2631z00_2057 = 
LLONG_TO_LONG(BgL_arg1781z00_487); 
BgL_arg1779z00_486 = BgL_res2631z00_2057; } } 
PROCEDURE_ENTRY(BgL_fun1780z00_485)(BgL_fun1780z00_485, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1779z00_486), BEOA); } } 
{ /* Llib/midi.scm 384 */
obj_t BgL_fun1784z00_489;
BgL_fun1784z00_489 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteoffz00); 
{ /* Llib/midi.scm 384 */
long BgL_arg1783z00_490;
BgL_arg1783z00_490 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1784z00_489)(BgL_fun1784z00_489, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1783z00_490), 
BINT(BgL_kkz00_483), 
BINT(BgL_vvz00_484), BEOA); } } } } }  else 
{ /* Llib/midi.scm 378 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)9)))
{ /* Llib/midi.scm 387 */
long BgL_kkz00_499;
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1803z00_510;
{ /* Llib/midi.scm 387 */
obj_t BgL_fun1805z00_511;
BgL_fun1805z00_511 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 387 */
obj_t BgL_arg1804z00_512;
BgL_arg1804z00_512 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1803z00_510 = 
PROCEDURE_ENTRY(BgL_fun1805z00_511)(BgL_fun1805z00_511, BgL_arg1804z00_512, BEOA); } } 
BgL_kkz00_499 = 
(((long)127) & 
(long)CINT(BgL_arg1803z00_510)); } 
{ /* Llib/midi.scm 387 */
long BgL_vvz00_500;
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1800z00_507;
{ /* Llib/midi.scm 388 */
obj_t BgL_fun1802z00_508;
BgL_fun1802z00_508 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 388 */
obj_t BgL_arg1801z00_509;
BgL_arg1801z00_509 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1800z00_507 = 
PROCEDURE_ENTRY(BgL_fun1802z00_508)(BgL_fun1802z00_508, BgL_arg1801z00_509, BEOA); } } 
BgL_vvz00_500 = 
(((long)127) & 
(long)CINT(BgL_arg1800z00_507)); } 
{ /* Llib/midi.scm 388 */

{ /* Llib/midi.scm 389 */
obj_t BgL_fun1794z00_501;
BgL_fun1794z00_501 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 390 */
long BgL_arg1793z00_502;
{ /* Llib/midi.scm 390 */
BGL_LONGLONG_T BgL_arg1795z00_503;
BgL_arg1795z00_503 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 390 */
long BgL_res2639z00_2075;
BgL_res2639z00_2075 = 
LLONG_TO_LONG(BgL_arg1795z00_503); 
BgL_arg1793z00_502 = BgL_res2639z00_2075; } } 
PROCEDURE_ENTRY(BgL_fun1794z00_501)(BgL_fun1794z00_501, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1793z00_502), BEOA); } } 
{ /* Llib/midi.scm 391 */
obj_t BgL_fun1799z00_505;
BgL_fun1799z00_505 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_noteonz00); 
{ /* Llib/midi.scm 391 */
long BgL_arg1797z00_506;
BgL_arg1797z00_506 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1799z00_505)(BgL_fun1799z00_505, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1797z00_506), 
BINT(BgL_kkz00_499), 
BINT(BgL_vvz00_500), BEOA); } } } } }  else 
{ /* Llib/midi.scm 385 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)10)))
{ /* Llib/midi.scm 394 */
long BgL_ccz00_515;
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1817z00_526;
{ /* Llib/midi.scm 394 */
obj_t BgL_fun1819z00_527;
BgL_fun1819z00_527 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 394 */
obj_t BgL_arg1818z00_528;
BgL_arg1818z00_528 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1817z00_526 = 
PROCEDURE_ENTRY(BgL_fun1819z00_527)(BgL_fun1819z00_527, BgL_arg1818z00_528, BEOA); } } 
BgL_ccz00_515 = 
(((long)127) & 
(long)CINT(BgL_arg1817z00_526)); } 
{ /* Llib/midi.scm 394 */
long BgL_vvz00_516;
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1814z00_523;
{ /* Llib/midi.scm 395 */
obj_t BgL_fun1816z00_524;
BgL_fun1816z00_524 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 395 */
obj_t BgL_arg1815z00_525;
BgL_arg1815z00_525 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1814z00_523 = 
PROCEDURE_ENTRY(BgL_fun1816z00_524)(BgL_fun1816z00_524, BgL_arg1815z00_525, BEOA); } } 
BgL_vvz00_516 = 
(((long)127) & 
(long)CINT(BgL_arg1814z00_523)); } 
{ /* Llib/midi.scm 395 */

{ /* Llib/midi.scm 396 */
obj_t BgL_fun1809z00_517;
BgL_fun1809z00_517 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 397 */
long BgL_arg1808z00_518;
{ /* Llib/midi.scm 397 */
BGL_LONGLONG_T BgL_arg1810z00_519;
BgL_arg1810z00_519 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 397 */
long BgL_res2647z00_2093;
BgL_res2647z00_2093 = 
LLONG_TO_LONG(BgL_arg1810z00_519); 
BgL_arg1808z00_518 = BgL_res2647z00_2093; } } 
PROCEDURE_ENTRY(BgL_fun1809z00_517)(BgL_fun1809z00_517, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1808z00_518), BEOA); } } 
{ /* Llib/midi.scm 398 */
obj_t BgL_fun1813z00_521;
BgL_fun1813z00_521 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_aftertouchz00); 
{ /* Llib/midi.scm 398 */
long BgL_arg1812z00_522;
BgL_arg1812z00_522 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1813z00_521)(BgL_fun1813z00_521, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1812z00_522), 
BINT(BgL_ccz00_515), 
BINT(BgL_vvz00_516), BEOA); } } } } }  else 
{ /* Llib/midi.scm 392 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)11)))
{ /* Llib/midi.scm 401 */
long BgL_ccz00_531;
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1831z00_542;
{ /* Llib/midi.scm 401 */
obj_t BgL_fun1833z00_543;
BgL_fun1833z00_543 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 401 */
obj_t BgL_arg1832z00_544;
BgL_arg1832z00_544 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1831z00_542 = 
PROCEDURE_ENTRY(BgL_fun1833z00_543)(BgL_fun1833z00_543, BgL_arg1832z00_544, BEOA); } } 
BgL_ccz00_531 = 
(((long)127) & 
(long)CINT(BgL_arg1831z00_542)); } 
{ /* Llib/midi.scm 401 */
long BgL_nnz00_532;
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1828z00_539;
{ /* Llib/midi.scm 402 */
obj_t BgL_fun1830z00_540;
BgL_fun1830z00_540 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 402 */
obj_t BgL_arg1829z00_541;
BgL_arg1829z00_541 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1828z00_539 = 
PROCEDURE_ENTRY(BgL_fun1830z00_540)(BgL_fun1830z00_540, BgL_arg1829z00_541, BEOA); } } 
BgL_nnz00_532 = 
(((long)127) & 
(long)CINT(BgL_arg1828z00_539)); } 
{ /* Llib/midi.scm 402 */

{ /* Llib/midi.scm 403 */
obj_t BgL_fun1823z00_533;
BgL_fun1823z00_533 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 404 */
long BgL_arg1822z00_534;
{ /* Llib/midi.scm 404 */
BGL_LONGLONG_T BgL_arg1824z00_535;
BgL_arg1824z00_535 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 404 */
long BgL_res2655z00_2111;
BgL_res2655z00_2111 = 
LLONG_TO_LONG(BgL_arg1824z00_535); 
BgL_arg1822z00_534 = BgL_res2655z00_2111; } } 
PROCEDURE_ENTRY(BgL_fun1823z00_533)(BgL_fun1823z00_533, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1822z00_534), BEOA); } } 
{ /* Llib/midi.scm 405 */
obj_t BgL_fun1827z00_537;
BgL_fun1827z00_537 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_ctrlchangez00); 
{ /* Llib/midi.scm 405 */
long BgL_arg1826z00_538;
BgL_arg1826z00_538 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1827z00_537)(BgL_fun1827z00_537, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1826z00_538), 
BINT(BgL_ccz00_531), 
BINT(BgL_nnz00_532), BEOA); } } } } }  else 
{ /* Llib/midi.scm 399 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)12)))
{ /* Llib/midi.scm 408 */
long BgL_ppz00_547;
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1842z00_554;
{ /* Llib/midi.scm 408 */
obj_t BgL_fun1844z00_555;
BgL_fun1844z00_555 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 408 */
obj_t BgL_arg1843z00_556;
BgL_arg1843z00_556 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1842z00_554 = 
PROCEDURE_ENTRY(BgL_fun1844z00_555)(BgL_fun1844z00_555, BgL_arg1843z00_556, BEOA); } } 
BgL_ppz00_547 = 
(((long)127) & 
(long)CINT(BgL_arg1842z00_554)); } 
{ /* Llib/midi.scm 409 */
obj_t BgL_fun1837z00_548;
BgL_fun1837z00_548 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 410 */
long BgL_arg1836z00_549;
{ /* Llib/midi.scm 410 */
BGL_LONGLONG_T BgL_arg1838z00_550;
BgL_arg1838z00_550 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 410 */
long BgL_res2662z00_2126;
BgL_res2662z00_2126 = 
LLONG_TO_LONG(BgL_arg1838z00_550); 
BgL_arg1836z00_549 = BgL_res2662z00_2126; } } 
PROCEDURE_ENTRY(BgL_fun1837z00_548)(BgL_fun1837z00_548, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1836z00_549), BEOA); } } 
{ /* Llib/midi.scm 411 */
obj_t BgL_fun1841z00_552;
BgL_fun1841z00_552 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_prgmchangez00); 
{ /* Llib/midi.scm 411 */
long BgL_arg1840z00_553;
BgL_arg1840z00_553 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1841z00_552)(BgL_fun1841z00_552, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1840z00_553), 
BINT(BgL_ppz00_547), BEOA); } } }  else 
{ /* Llib/midi.scm 406 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)13)))
{ /* Llib/midi.scm 414 */
long BgL_ppz00_559;
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1853z00_566;
{ /* Llib/midi.scm 414 */
obj_t BgL_fun1855z00_567;
BgL_fun1855z00_567 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 414 */
obj_t BgL_arg1854z00_568;
BgL_arg1854z00_568 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1853z00_566 = 
PROCEDURE_ENTRY(BgL_fun1855z00_567)(BgL_fun1855z00_567, BgL_arg1854z00_568, BEOA); } } 
BgL_ppz00_559 = 
(((long)127) & 
(long)CINT(BgL_arg1853z00_566)); } 
{ /* Llib/midi.scm 415 */
obj_t BgL_fun1848z00_560;
BgL_fun1848z00_560 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 416 */
long BgL_arg1847z00_561;
{ /* Llib/midi.scm 416 */
BGL_LONGLONG_T BgL_arg1849z00_562;
BgL_arg1849z00_562 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 416 */
long BgL_res2669z00_2141;
BgL_res2669z00_2141 = 
LLONG_TO_LONG(BgL_arg1849z00_562); 
BgL_arg1847z00_561 = BgL_res2669z00_2141; } } 
PROCEDURE_ENTRY(BgL_fun1848z00_560)(BgL_fun1848z00_560, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1847z00_561), BEOA); } } 
{ /* Llib/midi.scm 417 */
obj_t BgL_fun1852z00_564;
BgL_fun1852z00_564 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_afterzd2touchzd2); 
{ /* Llib/midi.scm 417 */
long BgL_arg1851z00_565;
BgL_arg1851z00_565 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1852z00_564)(BgL_fun1852z00_564, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1851z00_565), 
BINT(BgL_ppz00_559), BEOA); } } }  else 
{ /* Llib/midi.scm 412 */
if(
(
(
(long)CINT(BgL_statusz00_480) >> 
(int)(((long)4)))==((long)14)))
{ /* Llib/midi.scm 420 */
long BgL_ccz00_571;
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1867z00_582;
{ /* Llib/midi.scm 420 */
obj_t BgL_fun1869z00_583;
BgL_fun1869z00_583 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 420 */
obj_t BgL_arg1868z00_584;
BgL_arg1868z00_584 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1867z00_582 = 
PROCEDURE_ENTRY(BgL_fun1869z00_583)(BgL_fun1869z00_583, BgL_arg1868z00_584, BEOA); } } 
BgL_ccz00_571 = 
(((long)127) & 
(long)CINT(BgL_arg1867z00_582)); } 
{ /* Llib/midi.scm 420 */
long BgL_vvz00_572;
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1864z00_579;
{ /* Llib/midi.scm 421 */
obj_t BgL_fun1866z00_580;
BgL_fun1866z00_580 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 421 */
obj_t BgL_arg1865z00_581;
BgL_arg1865z00_581 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1864z00_579 = 
PROCEDURE_ENTRY(BgL_fun1866z00_580)(BgL_fun1866z00_580, BgL_arg1865z00_581, BEOA); } } 
BgL_vvz00_572 = 
(((long)127) & 
(long)CINT(BgL_arg1864z00_579)); } 
{ /* Llib/midi.scm 421 */

{ /* Llib/midi.scm 422 */
obj_t BgL_fun1859z00_573;
BgL_fun1859z00_573 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 423 */
long BgL_arg1858z00_574;
{ /* Llib/midi.scm 423 */
BGL_LONGLONG_T BgL_arg1860z00_575;
BgL_arg1860z00_575 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 423 */
long BgL_res2677z00_2159;
BgL_res2677z00_2159 = 
LLONG_TO_LONG(BgL_arg1860z00_575); 
BgL_arg1858z00_574 = BgL_res2677z00_2159; } } 
PROCEDURE_ENTRY(BgL_fun1859z00_573)(BgL_fun1859z00_573, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_ppqz00_42), 
BINT(BgL_dtz00_43), 
BINT(BgL_arg1858z00_574), BEOA); } } 
{ /* Llib/midi.scm 424 */
obj_t BgL_fun1863z00_577;
BgL_fun1863z00_577 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_pitchz00); 
{ /* Llib/midi.scm 424 */
long BgL_arg1862z00_578;
BgL_arg1862z00_578 = 
(
(long)CINT(BgL_statusz00_480) & ((long)15)); 
PROCEDURE_ENTRY(BgL_fun1863z00_577)(BgL_fun1863z00_577, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1862z00_578), 
BINT(BgL_ccz00_571), 
BINT(BgL_vvz00_572), BEOA); } } } } }  else 
{ /* Llib/midi.scm 418 */
if(
(
(long)CINT(BgL_statusz00_480)==((long)255)))
{ /* Llib/midi.scm 427 */
obj_t BgL_cz00_586;
{ /* Llib/midi.scm 427 */
obj_t BgL_fun1956z00_683;
BgL_fun1956z00_683 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 427 */
obj_t BgL_arg1955z00_684;
BgL_arg1955z00_684 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_cz00_586 = 
PROCEDURE_ENTRY(BgL_fun1956z00_683)(BgL_fun1956z00_683, BgL_arg1955z00_684, BEOA); } } 
{ /* Llib/midi.scm 427 */
obj_t BgL_lz00_587;
{ /* Llib/midi.scm 428 */
obj_t BgL_fun1954z00_681;
BgL_fun1954z00_681 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 428 */
obj_t BgL_arg1953z00_682;
BgL_arg1953z00_682 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_lz00_587 = 
PROCEDURE_ENTRY(BgL_fun1954z00_681)(BgL_fun1954z00_681, BgL_arg1953z00_682, BEOA); } } 
{ /* Llib/midi.scm 428 */

{ 

if(
INTEGERP(BgL_cz00_586))
{ /* Llib/midi.scm 429 */
switch( 
(long)CINT(BgL_cz00_586)) { case ((long)0) : 

{ /* Llib/midi.scm 432 */
obj_t BgL_fun1873z00_591;
BgL_fun1873z00_591 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqnumzd2); 
{ /* Llib/midi.scm 432 */
int32_t BgL_arg1872z00_592;
BgL_arg1872z00_592 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1873z00_591)(BgL_fun1873z00_591, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BGL_INT32_TO_BINT32(BgL_arg1872z00_592), BEOA); } } break;case ((long)1) : 

{ /* Llib/midi.scm 435 */
obj_t BgL_fun1876z00_594;
BgL_fun1876z00_594 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2textzd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1875z00_595;
{ /* Llib/midi.scm 435 */
obj_t BgL_fun1878z00_596;
BgL_fun1878z00_596 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 435 */
obj_t BgL_arg1877z00_597;
BgL_arg1877z00_597 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1875z00_595 = 
PROCEDURE_ENTRY(BgL_fun1878z00_596)(BgL_fun1878z00_596, BgL_lz00_587, BgL_arg1877z00_597, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1876z00_594)(BgL_fun1876z00_594, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1875z00_595, BEOA); } } break;case ((long)2) : 

{ /* Llib/midi.scm 438 */
obj_t BgL_fun1880z00_598;
BgL_fun1880z00_598 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2copyrightzd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1879z00_599;
{ /* Llib/midi.scm 438 */
obj_t BgL_fun1882z00_600;
BgL_fun1882z00_600 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 438 */
obj_t BgL_arg1881z00_601;
BgL_arg1881z00_601 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1879z00_599 = 
PROCEDURE_ENTRY(BgL_fun1882z00_600)(BgL_fun1882z00_600, BgL_lz00_587, BgL_arg1881z00_601, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1880z00_598)(BgL_fun1880z00_598, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1879z00_599, BEOA); } } break;case ((long)3) : 

{ /* Llib/midi.scm 441 */
obj_t BgL_fun1884z00_602;
BgL_fun1884z00_602 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2trackzd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1883z00_603;
{ /* Llib/midi.scm 441 */
obj_t BgL_fun1886z00_604;
BgL_fun1886z00_604 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 441 */
obj_t BgL_arg1885z00_605;
BgL_arg1885z00_605 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1883z00_603 = 
PROCEDURE_ENTRY(BgL_fun1886z00_604)(BgL_fun1886z00_604, BgL_lz00_587, BgL_arg1885z00_605, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1884z00_602)(BgL_fun1884z00_602, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1883z00_603, BEOA); } } break;case ((long)4) : 

{ /* Llib/midi.scm 444 */
obj_t BgL_fun1888z00_606;
BgL_fun1888z00_606 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2instrumentzd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1887z00_607;
{ /* Llib/midi.scm 444 */
obj_t BgL_fun1890z00_608;
BgL_fun1890z00_608 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 444 */
obj_t BgL_arg1889z00_609;
BgL_arg1889z00_609 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1887z00_607 = 
PROCEDURE_ENTRY(BgL_fun1890z00_608)(BgL_fun1890z00_608, BgL_lz00_587, BgL_arg1889z00_609, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1888z00_606)(BgL_fun1888z00_606, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1887z00_607, BEOA); } } break;case ((long)5) : 

{ /* Llib/midi.scm 447 */
obj_t BgL_fun1892z00_610;
BgL_fun1892z00_610 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2lyriczd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1891z00_611;
{ /* Llib/midi.scm 447 */
obj_t BgL_fun1894z00_612;
BgL_fun1894z00_612 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 447 */
obj_t BgL_arg1893z00_613;
BgL_arg1893z00_613 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1891z00_611 = 
PROCEDURE_ENTRY(BgL_fun1894z00_612)(BgL_fun1894z00_612, BgL_lz00_587, BgL_arg1893z00_613, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1892z00_610)(BgL_fun1892z00_610, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1891z00_611, BEOA); } } break;case ((long)6) : 

{ /* Llib/midi.scm 450 */
obj_t BgL_fun1896z00_614;
BgL_fun1896z00_614 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2markerzd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1895z00_615;
{ /* Llib/midi.scm 450 */
obj_t BgL_fun1898z00_616;
BgL_fun1898z00_616 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 450 */
obj_t BgL_arg1897z00_617;
BgL_arg1897z00_617 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1895z00_615 = 
PROCEDURE_ENTRY(BgL_fun1898z00_616)(BgL_fun1898z00_616, BgL_lz00_587, BgL_arg1897z00_617, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1896z00_614)(BgL_fun1896z00_614, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1895z00_615, BEOA); } } break;case ((long)7) : 

{ /* Llib/midi.scm 453 */
obj_t BgL_fun1900z00_618;
BgL_fun1900z00_618 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2cuezd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1899z00_619;
{ /* Llib/midi.scm 453 */
obj_t BgL_fun1902z00_620;
BgL_fun1902z00_620 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 453 */
obj_t BgL_arg1901z00_621;
BgL_arg1901z00_621 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1899z00_619 = 
PROCEDURE_ENTRY(BgL_fun1902z00_620)(BgL_fun1902z00_620, BgL_lz00_587, BgL_arg1901z00_621, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1900z00_618)(BgL_fun1900z00_618, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1899z00_619, BEOA); } } break;case ((long)8) : 

{ /* Llib/midi.scm 456 */
obj_t BgL_fun1904z00_622;
BgL_fun1904z00_622 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2prgmnamezd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1903z00_623;
{ /* Llib/midi.scm 456 */
obj_t BgL_fun1906z00_624;
BgL_fun1906z00_624 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 456 */
obj_t BgL_arg1905z00_625;
BgL_arg1905z00_625 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1903z00_623 = 
PROCEDURE_ENTRY(BgL_fun1906z00_624)(BgL_fun1906z00_624, BgL_lz00_587, BgL_arg1905z00_625, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1904z00_622)(BgL_fun1904z00_622, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1903z00_623, BEOA); } } break;case ((long)9) : 

{ /* Llib/midi.scm 459 */
obj_t BgL_fun1908z00_626;
BgL_fun1908z00_626 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2devnamezd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1907z00_627;
{ /* Llib/midi.scm 459 */
obj_t BgL_fun1910z00_628;
BgL_fun1910z00_628 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 459 */
obj_t BgL_arg1909z00_629;
BgL_arg1909z00_629 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1907z00_627 = 
PROCEDURE_ENTRY(BgL_fun1910z00_628)(BgL_fun1910z00_628, BgL_lz00_587, BgL_arg1909z00_629, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1908z00_626)(BgL_fun1908z00_626, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1907z00_627, BEOA); } } break;case ((long)32) : 

{ /* Llib/midi.scm 462 */
obj_t BgL_fun1912z00_630;
BgL_fun1912z00_630 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1911z00_631;
{ /* Llib/midi.scm 462 */
obj_t BgL_fun1914z00_632;
BgL_fun1914z00_632 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 462 */
obj_t BgL_arg1913z00_633;
BgL_arg1913z00_633 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1911z00_631 = 
PROCEDURE_ENTRY(BgL_fun1914z00_632)(BgL_fun1914z00_632, BgL_arg1913z00_633, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1912z00_630)(BgL_fun1912z00_630, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1911z00_631, BEOA); } } break;case ((long)33) : 

{ /* Llib/midi.scm 465 */
obj_t BgL_fun1916z00_634;
BgL_fun1916z00_634 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2channprefzd2); 
{ /* Llib/midi.scm 465 */
long BgL_arg1915z00_635;
BgL_arg1915z00_635 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_587), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1916z00_634)(BgL_fun1916z00_634, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1915z00_635), BEOA); } } break;case ((long)47) : 

((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52eotz52)=((bool_t)((bool_t)1)),BUNSPEC); 
{ /* Llib/midi.scm 469 */
obj_t BgL_fun1918z00_637;
BgL_fun1918z00_637 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2eotzd2); 
PROCEDURE_ENTRY(BgL_fun1918z00_637)(BgL_fun1918z00_637, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BUNSPEC, BEOA); } break;case ((long)81) : 

{ 
long BgL_auxz00_5774;
{ /* Llib/midi.scm 472 */
obj_t BgL_arg1919z00_638;
BgL_arg1919z00_638 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_auxz00_5774 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_587), BgL_arg1919z00_638); } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00)=((long)BgL_auxz00_5774),BUNSPEC); } 
{ /* Llib/midi.scm 473 */
obj_t BgL_fun1921z00_639;
BgL_fun1921z00_639 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2tempozd2); 
{ /* Llib/midi.scm 473 */
long BgL_arg1920z00_640;
BgL_arg1920z00_640 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_tempoz00); 
PROCEDURE_ENTRY(BgL_fun1921z00_639)(BgL_fun1921z00_639, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1920z00_640), BEOA); } } break;case ((long)84) : 

{ /* Llib/midi.scm 476 */
obj_t BgL_hrz00_641;
{ /* Llib/midi.scm 476 */
obj_t BgL_fun1932z00_655;
BgL_fun1932z00_655 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 476 */
obj_t BgL_arg1931z00_656;
BgL_arg1931z00_656 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_hrz00_641 = 
PROCEDURE_ENTRY(BgL_fun1932z00_655)(BgL_fun1932z00_655, BgL_arg1931z00_656, BEOA); } } 
{ /* Llib/midi.scm 476 */
obj_t BgL_mmz00_642;
{ /* Llib/midi.scm 477 */
obj_t BgL_fun1930z00_653;
BgL_fun1930z00_653 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 477 */
obj_t BgL_arg1929z00_654;
BgL_arg1929z00_654 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_mmz00_642 = 
PROCEDURE_ENTRY(BgL_fun1930z00_653)(BgL_fun1930z00_653, BgL_arg1929z00_654, BEOA); } } 
{ /* Llib/midi.scm 477 */
obj_t BgL_sez00_643;
{ /* Llib/midi.scm 478 */
obj_t BgL_fun1928z00_651;
BgL_fun1928z00_651 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 478 */
obj_t BgL_arg1927z00_652;
BgL_arg1927z00_652 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_sez00_643 = 
PROCEDURE_ENTRY(BgL_fun1928z00_651)(BgL_fun1928z00_651, BgL_arg1927z00_652, BEOA); } } 
{ /* Llib/midi.scm 478 */
obj_t BgL_frz00_644;
{ /* Llib/midi.scm 479 */
obj_t BgL_fun1926z00_649;
BgL_fun1926z00_649 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 479 */
obj_t BgL_arg1925z00_650;
BgL_arg1925z00_650 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_frz00_644 = 
PROCEDURE_ENTRY(BgL_fun1926z00_649)(BgL_fun1926z00_649, BgL_arg1925z00_650, BEOA); } } 
{ /* Llib/midi.scm 479 */
obj_t BgL_ffz00_645;
{ /* Llib/midi.scm 480 */
obj_t BgL_fun1924z00_647;
BgL_fun1924z00_647 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 480 */
obj_t BgL_arg1923z00_648;
BgL_arg1923z00_648 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ffz00_645 = 
PROCEDURE_ENTRY(BgL_fun1924z00_647)(BgL_fun1924z00_647, BgL_arg1923z00_648, BEOA); } } 
{ /* Llib/midi.scm 480 */

{ /* Llib/midi.scm 481 */
obj_t BgL_fun1922z00_646;
BgL_fun1922z00_646 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2smtpezd2); 
PROCEDURE_ENTRY(BgL_fun1922z00_646)(BgL_fun1922z00_646, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_hrz00_641, BgL_mmz00_642, BgL_sez00_643, BgL_frz00_644, BgL_ffz00_645, BEOA); } } } } } } } break;case ((long)88) : 

{ /* Llib/midi.scm 484 */
obj_t BgL_nnz00_657;
{ /* Llib/midi.scm 484 */
obj_t BgL_fun1941z00_668;
BgL_fun1941z00_668 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 484 */
obj_t BgL_arg1940z00_669;
BgL_arg1940z00_669 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_nnz00_657 = 
PROCEDURE_ENTRY(BgL_fun1941z00_668)(BgL_fun1941z00_668, BgL_arg1940z00_669, BEOA); } } 
{ /* Llib/midi.scm 484 */
obj_t BgL_ddz00_658;
{ /* Llib/midi.scm 485 */
obj_t BgL_fun1939z00_666;
BgL_fun1939z00_666 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 485 */
obj_t BgL_arg1938z00_667;
BgL_arg1938z00_667 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ddz00_658 = 
PROCEDURE_ENTRY(BgL_fun1939z00_666)(BgL_fun1939z00_666, BgL_arg1938z00_667, BEOA); } } 
{ /* Llib/midi.scm 485 */
obj_t BgL_ccz00_659;
{ /* Llib/midi.scm 486 */
obj_t BgL_fun1937z00_664;
BgL_fun1937z00_664 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 486 */
obj_t BgL_arg1936z00_665;
BgL_arg1936z00_665 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_ccz00_659 = 
PROCEDURE_ENTRY(BgL_fun1937z00_664)(BgL_fun1937z00_664, BgL_arg1936z00_665, BEOA); } } 
{ /* Llib/midi.scm 486 */
obj_t BgL_bbz00_660;
{ /* Llib/midi.scm 487 */
obj_t BgL_fun1935z00_662;
BgL_fun1935z00_662 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2bytezd2); 
{ /* Llib/midi.scm 487 */
obj_t BgL_arg1934z00_663;
BgL_arg1934z00_663 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_bbz00_660 = 
PROCEDURE_ENTRY(BgL_fun1935z00_662)(BgL_fun1935z00_662, BgL_arg1934z00_663, BEOA); } } 
{ /* Llib/midi.scm 487 */

{ /* Llib/midi.scm 488 */
obj_t BgL_fun1933z00_661;
BgL_fun1933z00_661 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2timesigzd2); 
PROCEDURE_ENTRY(BgL_fun1933z00_661)(BgL_fun1933z00_661, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_nnz00_657, BgL_ddz00_658, BgL_ccz00_659, BgL_bbz00_660, BEOA); } } } } } } break;case ((long)89) : 

{ /* Llib/midi.scm 491 */
obj_t BgL_fun1943z00_670;
BgL_fun1943z00_670 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2keysigzd2); 
{ /* Llib/midi.scm 491 */
long BgL_arg1942z00_671;
BgL_arg1942z00_671 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(
(long)CINT(BgL_lz00_587), 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52)); 
PROCEDURE_ENTRY(BgL_fun1943z00_670)(BgL_fun1943z00_670, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
BINT(BgL_arg1942z00_671), BEOA); } } break;case ((long)127) : 

{ /* Llib/midi.scm 494 */
obj_t BgL_fun1946z00_673;
BgL_fun1946z00_673 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_metazd2seqspeczd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1945z00_674;
{ /* Llib/midi.scm 494 */
obj_t BgL_fun1948z00_675;
BgL_fun1948z00_675 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 494 */
obj_t BgL_arg1947z00_676;
BgL_arg1947z00_676 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1945z00_674 = 
PROCEDURE_ENTRY(BgL_fun1948z00_675)(BgL_fun1948z00_675, BgL_lz00_587, BgL_arg1947z00_676, BEOA); } } 
PROCEDURE_ENTRY(BgL_fun1946z00_673)(BgL_fun1946z00_673, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_arg1945z00_674, BEOA); } } break;
default: 
BgL_case_else1162z00_588:
{ /* Llib/midi.scm 496 */
obj_t BgL_fun1950z00_677;
BgL_fun1950z00_677 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1949z00_678;
{ /* Llib/midi.scm 497 */
obj_t BgL_list1951z00_679;
{ /* Llib/midi.scm 497 */
obj_t BgL_arg1952z00_680;
BgL_arg1952z00_680 = 
MAKE_YOUNG_PAIR(BgL_cz00_586, BNIL); 
BgL_list1951z00_679 = 
MAKE_YOUNG_PAIR(BgL_statusz00_480, BgL_arg1952z00_680); } 
BgL_arg1949z00_678 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3098z00zz__multimediazd2midizd2, BgL_list1951z00_679); } 
PROCEDURE_ENTRY(BgL_fun1950z00_677)(BgL_fun1950z00_677, BGl_string3099z00zz__multimediazd2midizd2, BGl_string3100z00zz__multimediazd2midizd2, BgL_arg1949z00_678, BEOA); } } } }  else 
{ /* Llib/midi.scm 429 */
goto BgL_case_else1162z00_588;} } } } }  else 
{ /* Llib/midi.scm 498 */
bool_t BgL_test3677z00_5920;
if(
(
(long)CINT(BgL_statusz00_480)==((long)240)))
{ /* Llib/midi.scm 498 */
BgL_test3677z00_5920 = ((bool_t)1)
; }  else 
{ /* Llib/midi.scm 498 */
BgL_test3677z00_5920 = 
(
(long)CINT(BgL_statusz00_480)==((long)247))
; } 
if(BgL_test3677z00_5920)
{ /* Llib/midi.scm 500 */
obj_t BgL_strz00_687;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1966z00_693;
BgL_fun1966z00_693 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2charszd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1964z00_694;obj_t BgL_arg1965z00_695;
{ /* Llib/midi.scm 500 */
obj_t BgL_fun1968z00_696;
BgL_fun1968z00_696 = 
(((BgL_midireaderz00_bglt)COBJECT(BgL_i1160z00_478))->BgL_readzd2vlqzd2); 
{ /* Llib/midi.scm 500 */
obj_t BgL_arg1967z00_697;
BgL_arg1967z00_697 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_arg1964z00_694 = 
PROCEDURE_ENTRY(BgL_fun1968z00_696)(BgL_fun1968z00_696, BgL_arg1967z00_697, BEOA); } } 
BgL_arg1965z00_695 = 
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_38))->BgL_z52streamz52); 
BgL_strz00_687 = 
PROCEDURE_ENTRY(BgL_fun1966z00_693)(BgL_fun1966z00_693, BgL_arg1964z00_694, BgL_arg1965z00_695, BEOA); } } 
{ /* Llib/midi.scm 501 */
obj_t BgL_fun1960z00_688;
BgL_fun1960z00_688 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_cdelayz00); 
{ /* Llib/midi.scm 502 */
long BgL_arg1959z00_689;
{ /* Llib/midi.scm 502 */
BGL_LONGLONG_T BgL_arg1961z00_690;
BgL_arg1961z00_690 = 
(
bgl_current_microseconds()-BgL_t0z00_44); 
{ /* Llib/midi.scm 502 */
long BgL_res2684z00_2173;
BgL_res2684z00_2173 = 
LLONG_TO_LONG(BgL_arg1961z00_690); 
BgL_arg1959z00_689 = BgL_res2684z00_2173; } } 
PROCEDURE_ENTRY(BgL_fun1960z00_688)(BgL_fun1960z00_688, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), 
((obj_t)BgL_trackz00_38), 
BINT(BgL_dtz00_43), 
BINT(BgL_ppqz00_42), 
BINT(BgL_arg1959z00_689), BEOA); } } 
{ /* Llib/midi.scm 503 */
obj_t BgL_fun1963z00_692;
BgL_fun1963z00_692 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_sysexz00); 
PROCEDURE_ENTRY(BgL_fun1963z00_692)(BgL_fun1963z00_692, 
((obj_t)BgL_mplayerz00_39), 
((obj_t)BgL_msinkz00_40), 
BINT(BgL_tickz00_41), BgL_strz00_687, BEOA); } }  else 
{ /* Llib/midi.scm 505 */
obj_t BgL_fun1969z00_698;
BgL_fun1969z00_698 = 
(((BgL_midiplayerz00_bglt)COBJECT(BgL_mplayerz00_39))->BgL_errz00); 
PROCEDURE_ENTRY(BgL_fun1969z00_698)(BgL_fun1969z00_698, BGl_string3099z00zz__multimediazd2midizd2, BGl_string3101z00zz__multimediazd2midizd2, BgL_statusz00_480, BEOA); } } } } } } } } } } 
{ /* Llib/midi.scm 507 */
obj_t BgL_fun1987z00_718;
BgL_fun1987z00_718 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_flushz00); 
{ /* Llib/midi.scm 507 */
obj_t BgL_arg1986z00_719;
BgL_arg1986z00_719 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msinkz00_40))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun1987z00_718)(BgL_fun1987z00_718, BgL_arg1986z00_719, BEOA);} } } } 

}



/* midi-read-mthd */
obj_t BGl_midizd2readzd2mthdz00zz__multimediazd2midizd2(obj_t BgL_ipz00_45)
{
{ /* Llib/midi.scm 512 */
{ /* Llib/midi.scm 513 */
obj_t BgL_tyz00_720;
BgL_tyz00_720 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_45); 
{ /* Llib/midi.scm 514 */
bool_t BgL_test3679z00_5986;
{ /* Llib/midi.scm 514 */
bool_t BgL_res2689z00_2189;
{ /* Llib/midi.scm 514 */
long BgL_l1z00_2176;
BgL_l1z00_2176 = 
STRING_LENGTH(
((obj_t)BgL_tyz00_720)); 
if(
(BgL_l1z00_2176==((long)4)))
{ /* Llib/midi.scm 514 */
int BgL_arg1269z00_2179;
{ /* Llib/midi.scm 514 */
char * BgL_auxz00_5994;char * BgL_tmpz00_5991;
BgL_auxz00_5994 = 
BSTRING_TO_STRING(BGl_string3102z00zz__multimediazd2midizd2); 
BgL_tmpz00_5991 = 
BSTRING_TO_STRING(
((obj_t)BgL_tyz00_720)); 
BgL_arg1269z00_2179 = 
memcmp(BgL_tmpz00_5991, BgL_auxz00_5994, BgL_l1z00_2176); } 
BgL_res2689z00_2189 = 
(
(long)(BgL_arg1269z00_2179)==((long)0)); }  else 
{ /* Llib/midi.scm 514 */
BgL_res2689z00_2189 = ((bool_t)0); } } 
BgL_test3679z00_5986 = BgL_res2689z00_2189; } 
if(BgL_test3679z00_5986)
{ /* Llib/midi.scm 516 */
int32_t BgL_sza7za7_722;
BgL_sza7za7_722 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 516 */
long BgL_fmtz00_723;
{ /* Llib/midi.scm 517 */
int32_t BgL_arg2004z00_768;
BgL_arg2004z00_768 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 517 */
long BgL_res2691z00_2194;
{ /* Llib/midi.scm 517 */
long BgL_arg1426z00_2191;
BgL_arg1426z00_2191 = 
(long)(BgL_arg2004z00_768); 
{ /* Llib/midi.scm 517 */
long BgL_res2690z00_2193;
BgL_res2690z00_2193 = 
(long)(BgL_arg1426z00_2191); 
BgL_res2691z00_2194 = BgL_res2690z00_2193; } } 
BgL_fmtz00_723 = BgL_res2691z00_2194; } } 
{ /* Llib/midi.scm 517 */
long BgL_tckz00_724;
{ /* Llib/midi.scm 518 */
int32_t BgL_arg2003z00_767;
BgL_arg2003z00_767 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 518 */
long BgL_res2693z00_2199;
{ /* Llib/midi.scm 518 */
long BgL_arg1426z00_2196;
BgL_arg1426z00_2196 = 
(long)(BgL_arg2003z00_767); 
{ /* Llib/midi.scm 518 */
long BgL_res2692z00_2198;
BgL_res2692z00_2198 = 
(long)(BgL_arg1426z00_2196); 
BgL_res2693z00_2199 = BgL_res2692z00_2198; } } 
BgL_tckz00_724 = BgL_res2693z00_2199; } } 
{ /* Llib/midi.scm 518 */
long BgL_divz00_725;
{ /* Llib/midi.scm 519 */
int32_t BgL_arg2002z00_766;
BgL_arg2002z00_766 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_45); 
{ /* Llib/midi.scm 519 */
long BgL_res2695z00_2204;
{ /* Llib/midi.scm 519 */
long BgL_arg1426z00_2201;
BgL_arg1426z00_2201 = 
(long)(BgL_arg2002z00_766); 
{ /* Llib/midi.scm 519 */
long BgL_res2694z00_2203;
BgL_res2694z00_2203 = 
(long)(BgL_arg1426z00_2201); 
BgL_res2695z00_2204 = BgL_res2694z00_2203; } } 
BgL_divz00_725 = BgL_res2695z00_2204; } } 
{ /* Llib/midi.scm 519 */

if(
(
(BgL_divz00_725 >> 
(int)(((long)15)))==((long)0)))
{ /* Llib/midi.scm 521 */
long BgL_val4_1198z00_732;
BgL_val4_1198z00_732 = 
(BgL_divz00_725 & ((long)32767)); 
{ /* Llib/midi.scm 521 */
int BgL_res2699z00_2211;
{ /* Llib/midi.scm 521 */
int BgL_tmpz00_6014;
BgL_tmpz00_6014 = 
(int)(((long)5)); 
BgL_res2699z00_2211 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6014); } BgL_res2699z00_2211; } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_6019;int BgL_tmpz00_6017;
BgL_auxz00_6019 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_6017 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6017, BgL_auxz00_6019); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_6024;int BgL_tmpz00_6022;
BgL_auxz00_6024 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_6022 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6022, BgL_auxz00_6024); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_6029;int BgL_tmpz00_6027;
BgL_auxz00_6029 = 
BINT(((long)500000)); 
BgL_tmpz00_6027 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6027, BgL_auxz00_6029); } 
{ /* Llib/midi.scm 521 */
obj_t BgL_auxz00_6034;int BgL_tmpz00_6032;
BgL_auxz00_6034 = 
BINT(BgL_val4_1198z00_732); 
BgL_tmpz00_6032 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6032, BgL_auxz00_6034); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);}  else 
{ 

{ /* Llib/midi.scm 522 */
long BgL_aux1166z00_734;
BgL_aux1166z00_734 = 
(((long)128)-
(
(BgL_divz00_725 >> 
(int)(((long)8))) & ((long)127))); 
switch( BgL_aux1166z00_734) { case ((long)24) : 

{ /* Llib/midi.scm 524 */
long BgL_val4_1203z00_740;
BgL_val4_1203z00_740 = 
(((long)12)*
(BgL_divz00_725 & ((long)255))); 
{ /* Llib/midi.scm 524 */
int BgL_res2708z00_2228;
{ /* Llib/midi.scm 524 */
int BgL_tmpz00_6044;
BgL_tmpz00_6044 = 
(int)(((long)5)); 
BgL_res2708z00_2228 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6044); } BgL_res2708z00_2228; } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6049;int BgL_tmpz00_6047;
BgL_auxz00_6049 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_6047 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6047, BgL_auxz00_6049); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6054;int BgL_tmpz00_6052;
BgL_auxz00_6054 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_6052 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6052, BgL_auxz00_6054); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6059;int BgL_tmpz00_6057;
BgL_auxz00_6059 = 
BINT(((long)500000)); 
BgL_tmpz00_6057 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6057, BgL_auxz00_6059); } 
{ /* Llib/midi.scm 524 */
obj_t BgL_auxz00_6064;int BgL_tmpz00_6062;
BgL_auxz00_6064 = 
BINT(BgL_val4_1203z00_740); 
BgL_tmpz00_6062 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6062, BgL_auxz00_6064); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);} break;case ((long)25) : 

{ /* Llib/midi.scm 526 */
long BgL_val4_1208z00_746;
BgL_val4_1208z00_746 = 
(((long)10)*
(BgL_divz00_725 & ((long)255))); 
{ /* Llib/midi.scm 526 */
int BgL_res2711z00_2233;
{ /* Llib/midi.scm 526 */
int BgL_tmpz00_6070;
BgL_tmpz00_6070 = 
(int)(((long)5)); 
BgL_res2711z00_2233 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6070); } BgL_res2711z00_2233; } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6075;int BgL_tmpz00_6073;
BgL_auxz00_6075 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_6073 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6073, BgL_auxz00_6075); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6080;int BgL_tmpz00_6078;
BgL_auxz00_6080 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_6078 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6078, BgL_auxz00_6080); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6085;int BgL_tmpz00_6083;
BgL_auxz00_6085 = 
BINT(((long)400000)); 
BgL_tmpz00_6083 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6083, BgL_auxz00_6085); } 
{ /* Llib/midi.scm 526 */
obj_t BgL_auxz00_6090;int BgL_tmpz00_6088;
BgL_auxz00_6090 = 
BINT(BgL_val4_1208z00_746); 
BgL_tmpz00_6088 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6088, BgL_auxz00_6090); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);} break;case ((long)29) : 

{ /* Llib/midi.scm 528 */
long BgL_val4_1213z00_752;
BgL_val4_1213z00_752 = 
(((long)2997)*
(BgL_divz00_725 & ((long)255))); 
{ /* Llib/midi.scm 528 */
int BgL_res2714z00_2238;
{ /* Llib/midi.scm 528 */
int BgL_tmpz00_6096;
BgL_tmpz00_6096 = 
(int)(((long)5)); 
BgL_res2714z00_2238 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6096); } BgL_res2714z00_2238; } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6101;int BgL_tmpz00_6099;
BgL_auxz00_6101 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_6099 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6099, BgL_auxz00_6101); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6106;int BgL_tmpz00_6104;
BgL_auxz00_6106 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_6104 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6104, BgL_auxz00_6106); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6111;int BgL_tmpz00_6109;
BgL_auxz00_6111 = 
BINT(((long)100000000)); 
BgL_tmpz00_6109 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6109, BgL_auxz00_6111); } 
{ /* Llib/midi.scm 528 */
obj_t BgL_auxz00_6116;int BgL_tmpz00_6114;
BgL_auxz00_6116 = 
BINT(BgL_val4_1213z00_752); 
BgL_tmpz00_6114 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6114, BgL_auxz00_6116); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);} break;case ((long)30) : 

{ /* Llib/midi.scm 530 */
long BgL_val4_1218z00_758;
BgL_val4_1218z00_758 = 
(((long)15)*
(BgL_divz00_725 & ((long)255))); 
{ /* Llib/midi.scm 530 */
int BgL_res2717z00_2243;
{ /* Llib/midi.scm 530 */
int BgL_tmpz00_6122;
BgL_tmpz00_6122 = 
(int)(((long)5)); 
BgL_res2717z00_2243 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_6122); } BgL_res2717z00_2243; } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6127;int BgL_tmpz00_6125;
BgL_auxz00_6127 = 
BINT(BgL_fmtz00_723); 
BgL_tmpz00_6125 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6125, BgL_auxz00_6127); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6132;int BgL_tmpz00_6130;
BgL_auxz00_6132 = 
BINT(BgL_tckz00_724); 
BgL_tmpz00_6130 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6130, BgL_auxz00_6132); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6137;int BgL_tmpz00_6135;
BgL_auxz00_6137 = 
BINT(((long)500000)); 
BgL_tmpz00_6135 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6135, BgL_auxz00_6137); } 
{ /* Llib/midi.scm 530 */
obj_t BgL_auxz00_6142;int BgL_tmpz00_6140;
BgL_auxz00_6142 = 
BINT(BgL_val4_1218z00_758); 
BgL_tmpz00_6140 = 
(int)(((long)4)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_6140, BgL_auxz00_6142); } 
return 
BGL_INT32_TO_BINT32(BgL_sza7za7_722);} break;
default: 
{ /* Llib/midi.scm 534 */
long BgL_arg1998z00_762;
BgL_arg1998z00_762 = 
(((long)128)-
(
(BgL_divz00_725 >> 
(int)(((long)8))) & ((long)127))); 
return 
BGl_errorz00zz__errorz00(BGl_string3103z00zz__multimediazd2midizd2, BGl_string3104z00zz__multimediazd2midizd2, 
BINT(BgL_arg1998z00_762));} } } } } } } } }  else 
{ /* Llib/midi.scm 514 */
return 
BGl_errorz00zz__errorz00(BGl_string3103z00zz__multimediazd2midizd2, BGl_string3105z00zz__multimediazd2midizd2, BgL_tyz00_720);} } } } 

}



/* midi-read-mtrk */
obj_t BGl_midizd2readzd2mtrkz00zz__multimediazd2midizd2(obj_t BgL_ipz00_46)
{
{ /* Llib/midi.scm 539 */
{ /* Llib/midi.scm 540 */
obj_t BgL_tyz00_769;
BgL_tyz00_769 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)4)), BgL_ipz00_46); 
{ /* Llib/midi.scm 541 */
bool_t BgL_test3682z00_6156;
{ /* Llib/midi.scm 541 */
bool_t BgL_res2722z00_2259;
{ /* Llib/midi.scm 541 */
long BgL_l1z00_2246;
BgL_l1z00_2246 = 
STRING_LENGTH(
((obj_t)BgL_tyz00_769)); 
if(
(BgL_l1z00_2246==((long)4)))
{ /* Llib/midi.scm 541 */
int BgL_arg1269z00_2249;
{ /* Llib/midi.scm 541 */
char * BgL_auxz00_6164;char * BgL_tmpz00_6161;
BgL_auxz00_6164 = 
BSTRING_TO_STRING(BGl_string3106z00zz__multimediazd2midizd2); 
BgL_tmpz00_6161 = 
BSTRING_TO_STRING(
((obj_t)BgL_tyz00_769)); 
BgL_arg1269z00_2249 = 
memcmp(BgL_tmpz00_6161, BgL_auxz00_6164, BgL_l1z00_2246); } 
BgL_res2722z00_2259 = 
(
(long)(BgL_arg1269z00_2249)==((long)0)); }  else 
{ /* Llib/midi.scm 541 */
BgL_res2722z00_2259 = ((bool_t)0); } } 
BgL_test3682z00_6156 = BgL_res2722z00_2259; } 
if(BgL_test3682z00_6156)
{ /* Llib/midi.scm 543 */
int32_t BgL_tmpz00_6169;
BgL_tmpz00_6169 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_46); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6169);}  else 
{ /* Llib/midi.scm 541 */
return 
BGl_errorz00zz__errorz00(BGl_string3107z00zz__multimediazd2midizd2, BGl_string3105z00zz__multimediazd2midizd2, BgL_tyz00_769);} } } } 

}



/* read-int16 */
int32_t BGl_readzd2int16zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_49)
{
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
obj_t BgL_b1z00_772;
BgL_b1z00_772 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 561 */
obj_t BgL_b0z00_773;
BgL_b0z00_773 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_49); 
{ /* Llib/midi.scm 562 */

{ /* Llib/midi.scm 563 */
int32_t BgL_arg2007z00_774;int32_t BgL_arg2008z00_775;
{ /* Llib/midi.scm 563 */
int32_t BgL_arg2009z00_776;
{ /* Llib/midi.scm 555 */
long BgL_arg2006z00_2267;
BgL_arg2006z00_2267 = 
(
CCHAR(BgL_b1z00_772)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2727z00_2271;
BgL_res2727z00_2271 = 
(int32_t)(BgL_arg2006z00_2267); 
BgL_arg2009z00_776 = BgL_res2727z00_2271; } } 
BgL_arg2007z00_774 = 
(BgL_arg2009z00_776 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_arg2006z00_2274;
BgL_arg2006z00_2274 = 
(
CCHAR(BgL_b0z00_773)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2730z00_2278;
BgL_res2730z00_2278 = 
(int32_t)(BgL_arg2006z00_2274); 
BgL_arg2008z00_775 = BgL_res2730z00_2278; } } 
return 
(BgL_arg2007z00_774+BgL_arg2008z00_775);} } } } } 

}



/* &read-int16 */
obj_t BGl_z62readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3131, obj_t BgL_ipz00_3132)
{
{ /* Llib/midi.scm 560 */
{ /* Llib/midi.scm 561 */
int32_t BgL_tmpz00_6184;
BgL_tmpz00_6184 = 
BGl_readzd2int16zd2zz__multimediazd2midizd2(BgL_ipz00_3132); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6184);} } 

}



/* read-int32 */
int32_t BGl_readzd2int32zd2zz__multimediazd2midizd2(obj_t BgL_ipz00_50)
{
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
obj_t BgL_b3z00_777;
BgL_b3z00_777 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 570 */
obj_t BgL_b2z00_778;
BgL_b2z00_778 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 571 */
obj_t BgL_b1z00_779;
BgL_b1z00_779 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 572 */
obj_t BgL_b0z00_780;
BgL_b0z00_780 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_50); 
{ /* Llib/midi.scm 573 */

{ /* Llib/midi.scm 574 */
int32_t BgL_arg2010z00_781;int32_t BgL_arg2011z00_782;
{ /* Llib/midi.scm 574 */
int32_t BgL_arg2012z00_783;
{ /* Llib/midi.scm 555 */
long BgL_arg2006z00_2282;
BgL_arg2006z00_2282 = 
(
CCHAR(BgL_b3z00_777)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2733z00_2286;
BgL_res2733z00_2286 = 
(int32_t)(BgL_arg2006z00_2282); 
BgL_arg2012z00_783 = BgL_res2733z00_2286; } } 
BgL_arg2010z00_781 = 
(BgL_arg2012z00_783 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 575 */
int32_t BgL_arg2013z00_784;int32_t BgL_arg2014z00_785;
{ /* Llib/midi.scm 575 */
int32_t BgL_arg2015z00_786;
{ /* Llib/midi.scm 555 */
long BgL_arg2006z00_2289;
BgL_arg2006z00_2289 = 
(
CCHAR(BgL_b2z00_778)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2736z00_2293;
BgL_res2736z00_2293 = 
(int32_t)(BgL_arg2006z00_2289); 
BgL_arg2015z00_786 = BgL_res2736z00_2293; } } 
BgL_arg2013z00_784 = 
(BgL_arg2015z00_786 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 576 */
int32_t BgL_arg2016z00_787;int32_t BgL_arg2017z00_788;
{ /* Llib/midi.scm 576 */
int32_t BgL_arg2018z00_789;
{ /* Llib/midi.scm 555 */
long BgL_arg2006z00_2296;
BgL_arg2006z00_2296 = 
(
CCHAR(BgL_b1z00_779)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2739z00_2300;
BgL_res2739z00_2300 = 
(int32_t)(BgL_arg2006z00_2296); 
BgL_arg2018z00_789 = BgL_res2739z00_2300; } } 
BgL_arg2016z00_787 = 
(BgL_arg2018z00_789 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 555 */
long BgL_arg2006z00_2303;
BgL_arg2006z00_2303 = 
(
CCHAR(BgL_b0z00_780)); 
{ /* Llib/midi.scm 555 */
int32_t BgL_res2742z00_2307;
BgL_res2742z00_2307 = 
(int32_t)(BgL_arg2006z00_2303); 
BgL_arg2017z00_788 = BgL_res2742z00_2307; } } 
BgL_arg2014z00_785 = 
(BgL_arg2016z00_787+BgL_arg2017z00_788); } 
BgL_arg2011z00_782 = 
(BgL_arg2013z00_784+BgL_arg2014z00_785); } 
return 
(BgL_arg2010z00_781+BgL_arg2011z00_782);} } } } } } } 

}



/* &read-int32 */
obj_t BGl_z62readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3133, obj_t BgL_ipz00_3134)
{
{ /* Llib/midi.scm 569 */
{ /* Llib/midi.scm 570 */
int32_t BgL_tmpz00_6212;
BgL_tmpz00_6212 = 
BGl_readzd2int32zd2zz__multimediazd2midizd2(BgL_ipz00_3134); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6212);} } 

}



/* read-int */
long BGl_readzd2intzd2zz__multimediazd2midizd2(long BgL_lenz00_51, obj_t BgL_ipz00_52)
{
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_g1167z00_790;
{ /* Llib/midi.scm 583 */
obj_t BgL_arg2026z00_802;
BgL_arg2026z00_802 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_g1167z00_790 = 
(
CCHAR(BgL_arg2026z00_802)); } 
{ 
long BgL_valz00_792;long BgL_lenz00_793;
BgL_valz00_792 = BgL_g1167z00_790; 
BgL_lenz00_793 = BgL_lenz00_51; 
BgL_zc3z04anonymousza32019ze3z87_794:
if(
(BgL_lenz00_793==((long)1)))
{ /* Llib/midi.scm 585 */
return BgL_valz00_792;}  else 
{ /* Llib/midi.scm 587 */
long BgL_arg2021z00_796;long BgL_arg2022z00_797;
{ /* Llib/midi.scm 587 */
long BgL_arg2023z00_798;long BgL_arg2024z00_799;
BgL_arg2023z00_798 = 
(BgL_valz00_792 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 587 */
obj_t BgL_arg2025z00_800;
BgL_arg2025z00_800 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_52); 
BgL_arg2024z00_799 = 
(
CCHAR(BgL_arg2025z00_800)); } 
BgL_arg2021z00_796 = 
(BgL_arg2023z00_798+BgL_arg2024z00_799); } 
BgL_arg2022z00_797 = 
(BgL_lenz00_793-((long)1)); 
{ 
long BgL_lenz00_6228;long BgL_valz00_6227;
BgL_valz00_6227 = BgL_arg2021z00_796; 
BgL_lenz00_6228 = BgL_arg2022z00_797; 
BgL_lenz00_793 = BgL_lenz00_6228; 
BgL_valz00_792 = BgL_valz00_6227; 
goto BgL_zc3z04anonymousza32019ze3z87_794;} } } } } 

}



/* &read-int */
obj_t BGl_z62readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3135, obj_t BgL_lenz00_3136, obj_t BgL_ipz00_3137)
{
{ /* Llib/midi.scm 582 */
{ /* Llib/midi.scm 583 */
long BgL_tmpz00_6229;
{ /* Llib/midi.scm 583 */
obj_t BgL_auxz00_6239;long BgL_auxz00_6230;
if(
INPUT_PORTP(BgL_ipz00_3137))
{ /* Llib/midi.scm 583 */
BgL_auxz00_6239 = BgL_ipz00_3137
; }  else 
{ 
obj_t BgL_auxz00_6242;
BgL_auxz00_6242 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3088z00zz__multimediazd2midizd2, BgL_ipz00_3137); 
FAILURE(BgL_auxz00_6242,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 583 */
obj_t BgL_tmpz00_6231;
if(
INTEGERP(BgL_lenz00_3136))
{ /* Llib/midi.scm 583 */
BgL_tmpz00_6231 = BgL_lenz00_3136
; }  else 
{ 
obj_t BgL_auxz00_6234;
BgL_auxz00_6234 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)24391)), BGl_string3108z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_lenz00_3136); 
FAILURE(BgL_auxz00_6234,BFALSE,BFALSE);} 
BgL_auxz00_6230 = 
(long)CINT(BgL_tmpz00_6231); } 
BgL_tmpz00_6229 = 
BGl_readzd2intzd2zz__multimediazd2midizd2(BgL_auxz00_6230, BgL_auxz00_6239); } 
return 
BINT(BgL_tmpz00_6229);} } 

}



/* &read-vlq */
obj_t BGl_z62readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3138, obj_t BgL_ipz00_3139)
{
{ /* Llib/midi.scm 593 */
{ /* Llib/midi.scm 595 */
long BgL_tmpz00_6248;
{ 
long BgL_accz00_4157;
BgL_accz00_4157 = ((long)0); 
BgL_loopz00_4156:
{ /* Llib/midi.scm 595 */
long BgL_cz00_4158;
{ /* Llib/midi.scm 595 */
obj_t BgL_arg2032z00_4159;
BgL_arg2032z00_4159 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_ipz00_3139); 
BgL_cz00_4158 = 
(
CCHAR(BgL_arg2032z00_4159)); } 
if(
(BgL_cz00_4158<=((long)127)))
{ /* Llib/midi.scm 596 */
BgL_tmpz00_6248 = 
(BgL_cz00_4158+BgL_accz00_4157)
; }  else 
{ 
long BgL_accz00_6255;
BgL_accz00_6255 = 
(
(BgL_accz00_4157+
(BgL_cz00_4158 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_4157 = BgL_accz00_6255; 
goto BgL_loopz00_4156;} } } 
return 
BINT(BgL_tmpz00_6248);} } 

}



/* string-stream-peek-byte */
long BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(obj_t BgL_ipz00_54)
{
{ /* Llib/midi.scm 603 */
return 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_54, 
(int)(((long)1))))));} 

}



/* &string-stream-peek-byte */
obj_t BGl_z62stringzd2streamzd2peekzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3143, obj_t BgL_ipz00_3144)
{
{ /* Llib/midi.scm 603 */
{ /* Llib/midi.scm 605 */
long BgL_tmpz00_6268;
{ /* Llib/midi.scm 605 */
obj_t BgL_auxz00_6269;
if(
STRUCTP(BgL_ipz00_3144))
{ /* Llib/midi.scm 605 */
BgL_auxz00_6269 = BgL_ipz00_3144
; }  else 
{ 
obj_t BgL_auxz00_6272;
BgL_auxz00_6272 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)25285)), BGl_string3109z00zz__multimediazd2midizd2, BGl_string3110z00zz__multimediazd2midizd2, BgL_ipz00_3144); 
FAILURE(BgL_auxz00_6272,BFALSE,BFALSE);} 
BgL_tmpz00_6268 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_auxz00_6269); } 
return 
BINT(BgL_tmpz00_6268);} } 

}



/* &string-stream-read-byte */
obj_t BGl_z62stringzd2streamzd2readzd2bytezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3145, obj_t BgL_ipz00_3146)
{
{ /* Llib/midi.scm 610 */
{ /* Llib/midi.scm 611 */
long BgL_tmpz00_6278;
{ /* Llib/midi.scm 611 */
obj_t BgL_ipz00_4160;
if(
STRUCTP(BgL_ipz00_3146))
{ /* Llib/midi.scm 611 */
BgL_ipz00_4160 = BgL_ipz00_3146; }  else 
{ 
obj_t BgL_auxz00_6281;
BgL_auxz00_6281 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)25610)), BGl_string3111z00zz__multimediazd2midizd2, BGl_string3110z00zz__multimediazd2midizd2, BgL_ipz00_3146); 
FAILURE(BgL_auxz00_6281,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 611 */
long BgL_bz00_4161;
BgL_bz00_4161 = 
(
STRING_REF(
STRUCT_REF(BgL_ipz00_4160, 
(int)(((long)0))), 
(long)CINT(
STRUCT_REF(BgL_ipz00_4160, 
(int)(((long)1)))))); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4162;
BgL_arg2036z00_4162 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4160, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6298;int BgL_tmpz00_6296;
BgL_auxz00_6298 = 
BINT(BgL_arg2036z00_4162); 
BgL_tmpz00_6296 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4160, BgL_tmpz00_6296, BgL_auxz00_6298); } } 
BgL_tmpz00_6278 = BgL_bz00_4161; } } 
return 
BINT(BgL_tmpz00_6278);} } 

}



/* &string-stream-read-int16 */
obj_t BGl_z62stringzd2streamzd2readzd2int16zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3147, obj_t BgL_ipz00_3148)
{
{ /* Llib/midi.scm 618 */
{ /* Llib/midi.scm 619 */
int32_t BgL_tmpz00_6302;
{ /* Llib/midi.scm 619 */
obj_t BgL_ipz00_4163;
if(
STRUCTP(BgL_ipz00_3148))
{ /* Llib/midi.scm 619 */
BgL_ipz00_4163 = BgL_ipz00_3148; }  else 
{ 
obj_t BgL_auxz00_6305;
BgL_auxz00_6305 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)26001)), BGl_string3112z00zz__multimediazd2midizd2, BGl_string3110z00zz__multimediazd2midizd2, BgL_ipz00_3148); 
FAILURE(BgL_auxz00_6305,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 619 */
long BgL_b1z00_4164;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4165;
BgL_bz00_4165 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4163); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4166;
BgL_arg2036z00_4166 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4163, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6316;int BgL_tmpz00_6314;
BgL_auxz00_6316 = 
BINT(BgL_arg2036z00_4166); 
BgL_tmpz00_6314 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4163, BgL_tmpz00_6314, BgL_auxz00_6316); } } 
BgL_b1z00_4164 = BgL_bz00_4165; } 
{ /* Llib/midi.scm 619 */
long BgL_b0z00_4167;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4168;
BgL_bz00_4168 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4163); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4169;
BgL_arg2036z00_4169 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4163, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6326;int BgL_tmpz00_6324;
BgL_auxz00_6326 = 
BINT(BgL_arg2036z00_4169); 
BgL_tmpz00_6324 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4163, BgL_tmpz00_6324, BgL_auxz00_6326); } } 
BgL_b0z00_4167 = BgL_bz00_4168; } 
{ /* Llib/midi.scm 620 */

{ /* Llib/midi.scm 621 */
int32_t BgL_arg2038z00_4170;int32_t BgL_arg2039z00_4171;
{ /* Llib/midi.scm 621 */
int32_t BgL_arg2040z00_4172;
{ /* Llib/midi.scm 621 */
int32_t BgL_res2765z00_4173;
BgL_res2765z00_4173 = 
(int32_t)(BgL_b1z00_4164); 
BgL_arg2040z00_4172 = BgL_res2765z00_4173; } 
BgL_arg2038z00_4170 = 
(BgL_arg2040z00_4172 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 621 */
int32_t BgL_res2767z00_4174;
BgL_res2767z00_4174 = 
(int32_t)(BgL_b0z00_4167); 
BgL_arg2039z00_4171 = BgL_res2767z00_4174; } 
BgL_tmpz00_6302 = 
(BgL_arg2038z00_4170+BgL_arg2039z00_4171); } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6302);} } 

}



/* &string-stream-read-int32 */
obj_t BGl_z62stringzd2streamzd2readzd2int32zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3149, obj_t BgL_ipz00_3150)
{
{ /* Llib/midi.scm 626 */
{ /* Llib/midi.scm 627 */
int32_t BgL_tmpz00_6335;
{ /* Llib/midi.scm 627 */
obj_t BgL_ipz00_4175;
if(
STRUCTP(BgL_ipz00_3150))
{ /* Llib/midi.scm 627 */
BgL_ipz00_4175 = BgL_ipz00_3150; }  else 
{ 
obj_t BgL_auxz00_6338;
BgL_auxz00_6338 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)26420)), BGl_string3113z00zz__multimediazd2midizd2, BGl_string3110z00zz__multimediazd2midizd2, BgL_ipz00_3150); 
FAILURE(BgL_auxz00_6338,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 627 */
long BgL_b3z00_4176;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4177;
BgL_bz00_4177 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4175); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4178;
BgL_arg2036z00_4178 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4175, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6349;int BgL_tmpz00_6347;
BgL_auxz00_6349 = 
BINT(BgL_arg2036z00_4178); 
BgL_tmpz00_6347 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4175, BgL_tmpz00_6347, BgL_auxz00_6349); } } 
BgL_b3z00_4176 = BgL_bz00_4177; } 
{ /* Llib/midi.scm 627 */
long BgL_b2z00_4179;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4180;
BgL_bz00_4180 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4175); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4181;
BgL_arg2036z00_4181 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4175, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6359;int BgL_tmpz00_6357;
BgL_auxz00_6359 = 
BINT(BgL_arg2036z00_4181); 
BgL_tmpz00_6357 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4175, BgL_tmpz00_6357, BgL_auxz00_6359); } } 
BgL_b2z00_4179 = BgL_bz00_4180; } 
{ /* Llib/midi.scm 628 */
long BgL_b1z00_4182;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4183;
BgL_bz00_4183 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4175); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4184;
BgL_arg2036z00_4184 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4175, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6369;int BgL_tmpz00_6367;
BgL_auxz00_6369 = 
BINT(BgL_arg2036z00_4184); 
BgL_tmpz00_6367 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4175, BgL_tmpz00_6367, BgL_auxz00_6369); } } 
BgL_b1z00_4182 = BgL_bz00_4183; } 
{ /* Llib/midi.scm 629 */
long BgL_b0z00_4185;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4186;
BgL_bz00_4186 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4175); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4187;
BgL_arg2036z00_4187 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4175, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6379;int BgL_tmpz00_6377;
BgL_auxz00_6379 = 
BINT(BgL_arg2036z00_4187); 
BgL_tmpz00_6377 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4175, BgL_tmpz00_6377, BgL_auxz00_6379); } } 
BgL_b0z00_4185 = BgL_bz00_4186; } 
{ /* Llib/midi.scm 630 */

{ /* Llib/midi.scm 631 */
int32_t BgL_arg2041z00_4188;int32_t BgL_arg2042z00_4189;
{ /* Llib/midi.scm 631 */
int32_t BgL_arg2043z00_4190;
{ /* Llib/midi.scm 631 */
int32_t BgL_res2773z00_4191;
BgL_res2773z00_4191 = 
(int32_t)(BgL_b3z00_4176); 
BgL_arg2043z00_4190 = BgL_res2773z00_4191; } 
BgL_arg2041z00_4188 = 
(BgL_arg2043z00_4190 << 
(int)(((long)24))); } 
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2044z00_4192;int32_t BgL_arg2045z00_4193;
{ /* Llib/midi.scm 632 */
int32_t BgL_arg2046z00_4194;
{ /* Llib/midi.scm 632 */
int32_t BgL_res2775z00_4195;
BgL_res2775z00_4195 = 
(int32_t)(BgL_b2z00_4179); 
BgL_arg2046z00_4194 = BgL_res2775z00_4195; } 
BgL_arg2044z00_4192 = 
(BgL_arg2046z00_4194 << 
(int)(((long)16))); } 
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2047z00_4196;int32_t BgL_arg2048z00_4197;
{ /* Llib/midi.scm 633 */
int32_t BgL_arg2049z00_4198;
{ /* Llib/midi.scm 633 */
int32_t BgL_res2777z00_4199;
BgL_res2777z00_4199 = 
(int32_t)(BgL_b1z00_4182); 
BgL_arg2049z00_4198 = BgL_res2777z00_4199; } 
BgL_arg2047z00_4196 = 
(BgL_arg2049z00_4198 << 
(int)(((long)8))); } 
{ /* Llib/midi.scm 634 */
int32_t BgL_res2779z00_4200;
BgL_res2779z00_4200 = 
(int32_t)(BgL_b0z00_4185); 
BgL_arg2048z00_4197 = BgL_res2779z00_4200; } 
BgL_arg2045z00_4193 = 
(BgL_arg2047z00_4196+BgL_arg2048z00_4197); } 
BgL_arg2042z00_4189 = 
(BgL_arg2044z00_4192+BgL_arg2045z00_4193); } 
BgL_tmpz00_6335 = 
(BgL_arg2041z00_4188+BgL_arg2042z00_4189); } } } } } } } 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_6335);} } 

}



/* &string-stream-read-int */
obj_t BGl_z62stringzd2streamzd2readzd2intzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3151, obj_t BgL_lenz00_3152, obj_t BgL_ipz00_3153)
{
{ /* Llib/midi.scm 639 */
{ /* Llib/midi.scm 640 */
long BgL_tmpz00_6396;
{ /* Llib/midi.scm 640 */
long BgL_lenz00_4201;obj_t BgL_ipz00_4202;
{ /* Llib/midi.scm 640 */
obj_t BgL_tmpz00_6397;
if(
INTEGERP(BgL_lenz00_3152))
{ /* Llib/midi.scm 640 */
BgL_tmpz00_6397 = BgL_lenz00_3152
; }  else 
{ 
obj_t BgL_auxz00_6400;
BgL_auxz00_6400 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string3114z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_lenz00_3152); 
FAILURE(BgL_auxz00_6400,BFALSE,BFALSE);} 
BgL_lenz00_4201 = 
(long)CINT(BgL_tmpz00_6397); } 
if(
STRUCTP(BgL_ipz00_3153))
{ /* Llib/midi.scm 640 */
BgL_ipz00_4202 = BgL_ipz00_3153; }  else 
{ 
obj_t BgL_auxz00_6407;
BgL_auxz00_6407 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)27020)), BGl_string3114z00zz__multimediazd2midizd2, BGl_string3110z00zz__multimediazd2midizd2, BgL_ipz00_3153); 
FAILURE(BgL_auxz00_6407,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 640 */
long BgL_g1168z00_4203;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4204;
BgL_bz00_4204 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4202); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4205;
BgL_arg2036z00_4205 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4202, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6418;int BgL_tmpz00_6416;
BgL_auxz00_6418 = 
BINT(BgL_arg2036z00_4205); 
BgL_tmpz00_6416 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4202, BgL_tmpz00_6416, BgL_auxz00_6418); } } 
BgL_g1168z00_4203 = BgL_bz00_4204; } 
{ 
long BgL_valz00_4207;long BgL_lenz00_4208;
BgL_valz00_4207 = BgL_g1168z00_4203; 
BgL_lenz00_4208 = BgL_lenz00_4201; 
BgL_loopz00_4206:
if(
(BgL_lenz00_4208==((long)1)))
{ /* Llib/midi.scm 642 */
BgL_tmpz00_6396 = BgL_valz00_4207
; }  else 
{ /* Llib/midi.scm 644 */
long BgL_arg2052z00_4209;long BgL_arg2053z00_4210;
{ /* Llib/midi.scm 644 */
long BgL_arg2054z00_4211;long BgL_arg2055z00_4212;
BgL_arg2054z00_4211 = 
(BgL_valz00_4207 << 
(int)(((long)8))); 
{ /* Llib/midi.scm 611 */
long BgL_bz00_4213;
BgL_bz00_4213 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(BgL_ipz00_4202); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4214;
BgL_arg2036z00_4214 = 
(
(long)CINT(
STRUCT_REF(BgL_ipz00_4202, 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6432;int BgL_tmpz00_6430;
BgL_auxz00_6432 = 
BINT(BgL_arg2036z00_4214); 
BgL_tmpz00_6430 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4202, BgL_tmpz00_6430, BgL_auxz00_6432); } } 
BgL_arg2055z00_4212 = BgL_bz00_4213; } 
BgL_arg2052z00_4209 = 
(BgL_arg2054z00_4211+BgL_arg2055z00_4212); } 
BgL_arg2053z00_4210 = 
(BgL_lenz00_4208-((long)1)); 
{ 
long BgL_lenz00_6438;long BgL_valz00_6437;
BgL_valz00_6437 = BgL_arg2052z00_4209; 
BgL_lenz00_6438 = BgL_arg2053z00_4210; 
BgL_lenz00_4208 = BgL_lenz00_6438; 
BgL_valz00_4207 = BgL_valz00_6437; 
goto BgL_loopz00_4206;} } } } } 
return 
BINT(BgL_tmpz00_6396);} } 

}



/* &string-stream-read-vlq */
obj_t BGl_z62stringzd2streamzd2readzd2vlqzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3154, obj_t BgL_ipz00_3155)
{
{ /* Llib/midi.scm 650 */
{ /* Llib/midi.scm 652 */
long BgL_tmpz00_6440;
{ 
long BgL_accz00_4216;
BgL_accz00_4216 = ((long)0); 
BgL_loopz00_4215:
{ /* Llib/midi.scm 652 */
long BgL_cz00_4217;
{ /* Llib/midi.scm 611 */
long BgL_bz00_4218;
BgL_bz00_4218 = 
BGl_stringzd2streamzd2peekzd2bytezd2zz__multimediazd2midizd2(
((obj_t)BgL_ipz00_3155)); 
{ /* Llib/midi.scm 612 */
long BgL_arg2036z00_4219;
BgL_arg2036z00_4219 = 
(
(long)CINT(
STRUCT_REF(
((obj_t)BgL_ipz00_3155), 
(int)(((long)1))))+((long)1)); 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6452;int BgL_auxz00_6450;obj_t BgL_tmpz00_6448;
BgL_auxz00_6452 = 
BINT(BgL_arg2036z00_4219); 
BgL_auxz00_6450 = 
(int)(((long)1)); 
BgL_tmpz00_6448 = 
((obj_t)BgL_ipz00_3155); 
STRUCT_SET(BgL_tmpz00_6448, BgL_auxz00_6450, BgL_auxz00_6452); } } 
BgL_cz00_4217 = BgL_bz00_4218; } 
if(
(BgL_cz00_4217<=((long)127)))
{ /* Llib/midi.scm 653 */
BgL_tmpz00_6440 = 
(BgL_cz00_4217+BgL_accz00_4216)
; }  else 
{ 
long BgL_accz00_6458;
BgL_accz00_6458 = 
(
(BgL_accz00_4216+
(BgL_cz00_4217 & ((long)127))) << 
(int)(((long)7))); 
BgL_accz00_4216 = BgL_accz00_6458; 
goto BgL_loopz00_4215;} } } 
return 
BINT(BgL_tmpz00_6440);} } 

}



/* &string-stream-read-chars */
obj_t BGl_z62stringzd2streamzd2readzd2charszb0zz__multimediazd2midizd2(obj_t BgL_envz00_3156, obj_t BgL_lenz00_3157, obj_t BgL_ipz00_3158)
{
{ /* Llib/midi.scm 660 */
{ /* Llib/midi.scm 661 */
obj_t BgL_ipz00_4220;
if(
STRUCTP(BgL_ipz00_3158))
{ /* Llib/midi.scm 661 */
BgL_ipz00_4220 = BgL_ipz00_3158; }  else 
{ 
obj_t BgL_auxz00_6466;
BgL_auxz00_6466 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)27894)), BGl_string3115z00zz__multimediazd2midizd2, BGl_string3110z00zz__multimediazd2midizd2, BgL_ipz00_3158); 
FAILURE(BgL_auxz00_6466,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 661 */
obj_t BgL_sz00_4221;
{ /* Llib/midi.scm 661 */
obj_t BgL_arg2063z00_4222;obj_t BgL_arg2064z00_4223;obj_t BgL_arg2065z00_4224;
BgL_arg2063z00_4222 = 
STRUCT_REF(BgL_ipz00_4220, 
(int)(((long)0))); 
BgL_arg2064z00_4223 = 
STRUCT_REF(BgL_ipz00_4220, 
(int)(((long)1))); 
BgL_arg2065z00_4224 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_4220, 
(int)(((long)1))), BgL_lenz00_3157); 
{ /* Llib/midi.scm 661 */
obj_t BgL_res2795z00_4225;
{ /* Llib/midi.scm 661 */
long BgL_startz00_4226;long BgL_endz00_4227;
BgL_startz00_4226 = 
(long)CINT(BgL_arg2064z00_4223); 
BgL_endz00_4227 = 
(long)CINT(BgL_arg2065z00_4224); 
BgL_res2795z00_4225 = 
c_substring(
((obj_t)BgL_arg2063z00_4222), BgL_startz00_4226, BgL_endz00_4227); } 
BgL_sz00_4221 = BgL_res2795z00_4225; } } 
{ /* Llib/midi.scm 127 */
obj_t BgL_auxz00_6483;int BgL_tmpz00_6481;
BgL_auxz00_6483 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(
STRUCT_REF(BgL_ipz00_4220, 
(int)(((long)1))), BgL_lenz00_3157); 
BgL_tmpz00_6481 = 
(int)(((long)1)); 
STRUCT_SET(BgL_ipz00_4220, BgL_tmpz00_6481, BgL_auxz00_6483); } 
return BgL_sz00_4221;} } } 

}



/* midiplayer-cdelay */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_68, BgL_midisinkz00_bglt BgL_msz00_69, long BgL_tickz00_70, BgL_miditrackz00_bglt BgL_trackz00_71, long BgL_ppqz00_72, long BgL_dtz00_73, long BgL_usz00_74)
{
{ /* Llib/midi.scm 993 */
if(
(BgL_dtz00_73>((long)0)))
{ /* Llib/midi.scm 998 */
obj_t BgL_fun2069z00_2509;
BgL_fun2069z00_2509 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_69))->BgL_usleepz00); 
{ /* Llib/midi.scm 998 */
long BgL_arg2068z00_2510;
BgL_arg2068z00_2510 = 
(
(
(BgL_dtz00_73*
(((BgL_miditrackz00_bglt)COBJECT(BgL_trackz00_71))->BgL_tempoz00))/BgL_ppqz00_72)-BgL_usz00_74); 
return 
PROCEDURE_ENTRY(BgL_fun2069z00_2509)(BgL_fun2069z00_2509, 
BINT(BgL_arg2068z00_2510), BEOA);} }  else 
{ /* Llib/midi.scm 997 */
return BFALSE;} } 

}



/* &midiplayer-cdelay */
obj_t BGl_z62midiplayerzd2cdelayzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3185, obj_t BgL_mpz00_3186, obj_t BgL_msz00_3187, obj_t BgL_tickz00_3188, obj_t BgL_trackz00_3189, obj_t BgL_ppqz00_3190, obj_t BgL_dtz00_3191, obj_t BgL_usz00_3192)
{
{ /* Llib/midi.scm 993 */
{ /* Llib/midi.scm 995 */
long BgL_auxz00_6551;long BgL_auxz00_6542;long BgL_auxz00_6533;BgL_miditrackz00_bglt BgL_auxz00_6525;long BgL_auxz00_6516;BgL_midisinkz00_bglt BgL_auxz00_6508;BgL_midiplayerz00_bglt BgL_auxz00_6500;
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6552;
if(
INTEGERP(BgL_usz00_3192))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6552 = BgL_usz00_3192
; }  else 
{ 
obj_t BgL_auxz00_6555;
BgL_auxz00_6555 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3116z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_usz00_3192); 
FAILURE(BgL_auxz00_6555,BFALSE,BFALSE);} 
BgL_auxz00_6551 = 
(long)CINT(BgL_tmpz00_6552); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6543;
if(
INTEGERP(BgL_dtz00_3191))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6543 = BgL_dtz00_3191
; }  else 
{ 
obj_t BgL_auxz00_6546;
BgL_auxz00_6546 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3116z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_dtz00_3191); 
FAILURE(BgL_auxz00_6546,BFALSE,BFALSE);} 
BgL_auxz00_6542 = 
(long)CINT(BgL_tmpz00_6543); } 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6534;
if(
INTEGERP(BgL_ppqz00_3190))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6534 = BgL_ppqz00_3190
; }  else 
{ 
obj_t BgL_auxz00_6537;
BgL_auxz00_6537 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3116z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_ppqz00_3190); 
FAILURE(BgL_auxz00_6537,BFALSE,BFALSE);} 
BgL_auxz00_6533 = 
(long)CINT(BgL_tmpz00_6534); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_trackz00_3189, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6525 = 
((BgL_miditrackz00_bglt)BgL_trackz00_3189)
; }  else 
{ 
obj_t BgL_auxz00_6529;
BgL_auxz00_6529 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3116z00zz__multimediazd2midizd2, BGl_string3117z00zz__multimediazd2midizd2, BgL_trackz00_3189); 
FAILURE(BgL_auxz00_6529,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 995 */
obj_t BgL_tmpz00_6517;
if(
INTEGERP(BgL_tickz00_3188))
{ /* Llib/midi.scm 995 */
BgL_tmpz00_6517 = BgL_tickz00_3188
; }  else 
{ 
obj_t BgL_auxz00_6520;
BgL_auxz00_6520 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3116z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3188); 
FAILURE(BgL_auxz00_6520,BFALSE,BFALSE);} 
BgL_auxz00_6516 = 
(long)CINT(BgL_tmpz00_6517); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3187, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6508 = 
((BgL_midisinkz00_bglt)BgL_msz00_3187)
; }  else 
{ 
obj_t BgL_auxz00_6512;
BgL_auxz00_6512 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3116z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3187); 
FAILURE(BgL_auxz00_6512,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3186, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 995 */
BgL_auxz00_6500 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3186)
; }  else 
{ 
obj_t BgL_auxz00_6504;
BgL_auxz00_6504 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37739)), BGl_string3116z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3186); 
FAILURE(BgL_auxz00_6504,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2cdelayzd2zz__multimediazd2midizd2(BgL_auxz00_6500, BgL_auxz00_6508, BgL_auxz00_6516, BgL_auxz00_6525, BgL_auxz00_6533, BgL_auxz00_6542, BgL_auxz00_6551);} } 

}



/* midiplayer-ignore */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ignorezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_75, BgL_midisinkz00_bglt BgL_msz00_76, long BgL_tickz00_77, obj_t BgL_objz00_78)
{
{ /* Llib/midi.scm 1003 */
return BUNSPEC;} 

}



/* &midiplayer-ignore */
obj_t BGl_z62midiplayerzd2ignorezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3193, obj_t BgL_mpz00_3194, obj_t BgL_msz00_3195, obj_t BgL_tickz00_3196, obj_t BgL_objz00_3197)
{
{ /* Llib/midi.scm 1003 */
{ /* Llib/midi.scm 1003 */
BgL_midiplayerz00_bglt BgL_mpz00_4228;BgL_midisinkz00_bglt BgL_msz00_4229;long BgL_tickz00_4230;
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3194, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_mpz00_4228 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3194); }  else 
{ 
obj_t BgL_auxz00_6564;
BgL_auxz00_6564 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3118z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3194); 
FAILURE(BgL_auxz00_6564,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3195, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1003 */
BgL_msz00_4229 = 
((BgL_midisinkz00_bglt)BgL_msz00_3195); }  else 
{ 
obj_t BgL_auxz00_6571;
BgL_auxz00_6571 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3118z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3195); 
FAILURE(BgL_auxz00_6571,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1003 */
obj_t BgL_tmpz00_6575;
if(
INTEGERP(BgL_tickz00_3196))
{ /* Llib/midi.scm 1003 */
BgL_tmpz00_6575 = BgL_tickz00_3196
; }  else 
{ 
obj_t BgL_auxz00_6578;
BgL_auxz00_6578 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)38117)), BGl_string3118z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3196); 
FAILURE(BgL_auxz00_6578,BFALSE,BFALSE);} 
BgL_tickz00_4230 = 
(long)CINT(BgL_tmpz00_6575); } 
return BUNSPEC;} } 

}



/* midiplayer-noteoff */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_88, BgL_midisinkz00_bglt BgL_msz00_89, long BgL_tickz00_90, long BgL_nnz00_91, long BgL_kkz00_92, long BgL_vvz00_93)
{
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2079z00_2550;
BgL_fun2079z00_2550 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2077z00_2551;long BgL_arg2078z00_2552;
BgL_arg2077z00_2551 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
BgL_arg2078z00_2552 = 
(((long)128) | BgL_nnz00_91); 
PROCEDURE_ENTRY(BgL_fun2079z00_2550)(BgL_fun2079z00_2550, BgL_arg2077z00_2551, 
BINT(BgL_arg2078z00_2552), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2081z00_2553;
BgL_fun2081z00_2553 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2080z00_2554;
BgL_arg2080z00_2554 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2081z00_2553)(BgL_fun2081z00_2553, BgL_arg2080z00_2554, 
BINT(BgL_kkz00_92), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2083z00_2555;
BgL_fun2083z00_2555 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2082z00_2556;
BgL_arg2082z00_2556 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_89))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2083z00_2555)(BgL_fun2083z00_2555, BgL_arg2082z00_2556, 
BINT(BgL_vvz00_93), BEOA);} } } 

}



/* &midiplayer-noteoff */
obj_t BGl_z62midiplayerzd2noteoffzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3198, obj_t BgL_mpz00_3199, obj_t BgL_msz00_3200, obj_t BgL_tickz00_3201, obj_t BgL_nnz00_3202, obj_t BgL_kkz00_3203, obj_t BgL_vvz00_3204)
{
{ /* Llib/midi.scm 1026 */
{ /* Llib/midi.scm 1028 */
long BgL_auxz00_6651;long BgL_auxz00_6642;long BgL_auxz00_6633;long BgL_auxz00_6624;BgL_midisinkz00_bglt BgL_auxz00_6616;BgL_midiplayerz00_bglt BgL_auxz00_6608;
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6652;
if(
INTEGERP(BgL_vvz00_3204))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6652 = BgL_vvz00_3204
; }  else 
{ 
obj_t BgL_auxz00_6655;
BgL_auxz00_6655 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3119z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_vvz00_3204); 
FAILURE(BgL_auxz00_6655,BFALSE,BFALSE);} 
BgL_auxz00_6651 = 
(long)CINT(BgL_tmpz00_6652); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6643;
if(
INTEGERP(BgL_kkz00_3203))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6643 = BgL_kkz00_3203
; }  else 
{ 
obj_t BgL_auxz00_6646;
BgL_auxz00_6646 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3119z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_kkz00_3203); 
FAILURE(BgL_auxz00_6646,BFALSE,BFALSE);} 
BgL_auxz00_6642 = 
(long)CINT(BgL_tmpz00_6643); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6634;
if(
INTEGERP(BgL_nnz00_3202))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6634 = BgL_nnz00_3202
; }  else 
{ 
obj_t BgL_auxz00_6637;
BgL_auxz00_6637 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3119z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_nnz00_3202); 
FAILURE(BgL_auxz00_6637,BFALSE,BFALSE);} 
BgL_auxz00_6633 = 
(long)CINT(BgL_tmpz00_6634); } 
{ /* Llib/midi.scm 1028 */
obj_t BgL_tmpz00_6625;
if(
INTEGERP(BgL_tickz00_3201))
{ /* Llib/midi.scm 1028 */
BgL_tmpz00_6625 = BgL_tickz00_3201
; }  else 
{ 
obj_t BgL_auxz00_6628;
BgL_auxz00_6628 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3119z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3201); 
FAILURE(BgL_auxz00_6628,BFALSE,BFALSE);} 
BgL_auxz00_6624 = 
(long)CINT(BgL_tmpz00_6625); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3200, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6616 = 
((BgL_midisinkz00_bglt)BgL_msz00_3200)
; }  else 
{ 
obj_t BgL_auxz00_6620;
BgL_auxz00_6620 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3119z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3200); 
FAILURE(BgL_auxz00_6620,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3199, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1028 */
BgL_auxz00_6608 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3199)
; }  else 
{ 
obj_t BgL_auxz00_6612;
BgL_auxz00_6612 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39392)), BGl_string3119z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3199); 
FAILURE(BgL_auxz00_6612,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteoffzd2zz__multimediazd2midizd2(BgL_auxz00_6608, BgL_auxz00_6616, BgL_auxz00_6624, BgL_auxz00_6633, BgL_auxz00_6642, BgL_auxz00_6651);} } 

}



/* midiplayer-noteon */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_94, BgL_midisinkz00_bglt BgL_msz00_95, long BgL_tickz00_96, long BgL_nnz00_97, long BgL_kkz00_98, long BgL_vvz00_99)
{
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2079z00_2564;
BgL_fun2079z00_2564 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2077z00_2565;long BgL_arg2078z00_2566;
BgL_arg2077z00_2565 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
BgL_arg2078z00_2566 = 
(((long)144) | BgL_nnz00_97); 
PROCEDURE_ENTRY(BgL_fun2079z00_2564)(BgL_fun2079z00_2564, BgL_arg2077z00_2565, 
BINT(BgL_arg2078z00_2566), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2081z00_2567;
BgL_fun2081z00_2567 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2080z00_2568;
BgL_arg2080z00_2568 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2081z00_2567)(BgL_fun2081z00_2567, BgL_arg2080z00_2568, 
BINT(BgL_kkz00_98), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2083z00_2569;
BgL_fun2083z00_2569 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2082z00_2570;
BgL_arg2082z00_2570 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_95))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2083z00_2569)(BgL_fun2083z00_2569, BgL_arg2082z00_2570, 
BINT(BgL_vvz00_99), BEOA);} } } 

}



/* &midiplayer-noteon */
obj_t BGl_z62midiplayerzd2noteonzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3205, obj_t BgL_mpz00_3206, obj_t BgL_msz00_3207, obj_t BgL_tickz00_3208, obj_t BgL_nnz00_3209, obj_t BgL_kkz00_3210, obj_t BgL_vvz00_3211)
{
{ /* Llib/midi.scm 1033 */
{ /* Llib/midi.scm 1035 */
long BgL_auxz00_6729;long BgL_auxz00_6720;long BgL_auxz00_6711;long BgL_auxz00_6702;BgL_midisinkz00_bglt BgL_auxz00_6694;BgL_midiplayerz00_bglt BgL_auxz00_6686;
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6730;
if(
INTEGERP(BgL_vvz00_3211))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6730 = BgL_vvz00_3211
; }  else 
{ 
obj_t BgL_auxz00_6733;
BgL_auxz00_6733 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3120z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_vvz00_3211); 
FAILURE(BgL_auxz00_6733,BFALSE,BFALSE);} 
BgL_auxz00_6729 = 
(long)CINT(BgL_tmpz00_6730); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6721;
if(
INTEGERP(BgL_kkz00_3210))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6721 = BgL_kkz00_3210
; }  else 
{ 
obj_t BgL_auxz00_6724;
BgL_auxz00_6724 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3120z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_kkz00_3210); 
FAILURE(BgL_auxz00_6724,BFALSE,BFALSE);} 
BgL_auxz00_6720 = 
(long)CINT(BgL_tmpz00_6721); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6712;
if(
INTEGERP(BgL_nnz00_3209))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6712 = BgL_nnz00_3209
; }  else 
{ 
obj_t BgL_auxz00_6715;
BgL_auxz00_6715 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3120z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_nnz00_3209); 
FAILURE(BgL_auxz00_6715,BFALSE,BFALSE);} 
BgL_auxz00_6711 = 
(long)CINT(BgL_tmpz00_6712); } 
{ /* Llib/midi.scm 1035 */
obj_t BgL_tmpz00_6703;
if(
INTEGERP(BgL_tickz00_3208))
{ /* Llib/midi.scm 1035 */
BgL_tmpz00_6703 = BgL_tickz00_3208
; }  else 
{ 
obj_t BgL_auxz00_6706;
BgL_auxz00_6706 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3120z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3208); 
FAILURE(BgL_auxz00_6706,BFALSE,BFALSE);} 
BgL_auxz00_6702 = 
(long)CINT(BgL_tmpz00_6703); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3207, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6694 = 
((BgL_midisinkz00_bglt)BgL_msz00_3207)
; }  else 
{ 
obj_t BgL_auxz00_6698;
BgL_auxz00_6698 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3120z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3207); 
FAILURE(BgL_auxz00_6698,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3206, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1035 */
BgL_auxz00_6686 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3206)
; }  else 
{ 
obj_t BgL_auxz00_6690;
BgL_auxz00_6690 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)39752)), BGl_string3120z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3206); 
FAILURE(BgL_auxz00_6690,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2noteonzd2zz__multimediazd2midizd2(BgL_auxz00_6686, BgL_auxz00_6694, BgL_auxz00_6702, BgL_auxz00_6711, BgL_auxz00_6720, BgL_auxz00_6729);} } 

}



/* midiplayer-aftertouch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_100, BgL_midisinkz00_bglt BgL_msz00_101, long BgL_tickz00_102, long BgL_nnz00_103, long BgL_kkz00_104, long BgL_vvz00_105)
{
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2079z00_2578;
BgL_fun2079z00_2578 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2077z00_2579;long BgL_arg2078z00_2580;
BgL_arg2077z00_2579 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
BgL_arg2078z00_2580 = 
(((long)160) | BgL_nnz00_103); 
PROCEDURE_ENTRY(BgL_fun2079z00_2578)(BgL_fun2079z00_2578, BgL_arg2077z00_2579, 
BINT(BgL_arg2078z00_2580), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2081z00_2581;
BgL_fun2081z00_2581 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2080z00_2582;
BgL_arg2080z00_2582 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2081z00_2581)(BgL_fun2081z00_2581, BgL_arg2080z00_2582, 
BINT(BgL_kkz00_104), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2083z00_2583;
BgL_fun2083z00_2583 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2082z00_2584;
BgL_arg2082z00_2584 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_101))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2083z00_2583)(BgL_fun2083z00_2583, BgL_arg2082z00_2584, 
BINT(BgL_vvz00_105), BEOA);} } } 

}



/* &midiplayer-aftertouch */
obj_t BGl_z62midiplayerzd2aftertouchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3212, obj_t BgL_mpz00_3213, obj_t BgL_msz00_3214, obj_t BgL_tickz00_3215, obj_t BgL_nnz00_3216, obj_t BgL_kkz00_3217, obj_t BgL_vvz00_3218)
{
{ /* Llib/midi.scm 1040 */
{ /* Llib/midi.scm 1042 */
long BgL_auxz00_6807;long BgL_auxz00_6798;long BgL_auxz00_6789;long BgL_auxz00_6780;BgL_midisinkz00_bglt BgL_auxz00_6772;BgL_midiplayerz00_bglt BgL_auxz00_6764;
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6808;
if(
INTEGERP(BgL_vvz00_3218))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6808 = BgL_vvz00_3218
; }  else 
{ 
obj_t BgL_auxz00_6811;
BgL_auxz00_6811 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3121z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_vvz00_3218); 
FAILURE(BgL_auxz00_6811,BFALSE,BFALSE);} 
BgL_auxz00_6807 = 
(long)CINT(BgL_tmpz00_6808); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6799;
if(
INTEGERP(BgL_kkz00_3217))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6799 = BgL_kkz00_3217
; }  else 
{ 
obj_t BgL_auxz00_6802;
BgL_auxz00_6802 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3121z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_kkz00_3217); 
FAILURE(BgL_auxz00_6802,BFALSE,BFALSE);} 
BgL_auxz00_6798 = 
(long)CINT(BgL_tmpz00_6799); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6790;
if(
INTEGERP(BgL_nnz00_3216))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6790 = BgL_nnz00_3216
; }  else 
{ 
obj_t BgL_auxz00_6793;
BgL_auxz00_6793 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3121z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_nnz00_3216); 
FAILURE(BgL_auxz00_6793,BFALSE,BFALSE);} 
BgL_auxz00_6789 = 
(long)CINT(BgL_tmpz00_6790); } 
{ /* Llib/midi.scm 1042 */
obj_t BgL_tmpz00_6781;
if(
INTEGERP(BgL_tickz00_3215))
{ /* Llib/midi.scm 1042 */
BgL_tmpz00_6781 = BgL_tickz00_3215
; }  else 
{ 
obj_t BgL_auxz00_6784;
BgL_auxz00_6784 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3121z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3215); 
FAILURE(BgL_auxz00_6784,BFALSE,BFALSE);} 
BgL_auxz00_6780 = 
(long)CINT(BgL_tmpz00_6781); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3214, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6772 = 
((BgL_midisinkz00_bglt)BgL_msz00_3214)
; }  else 
{ 
obj_t BgL_auxz00_6776;
BgL_auxz00_6776 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3121z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3214); 
FAILURE(BgL_auxz00_6776,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3213, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1042 */
BgL_auxz00_6764 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3213)
; }  else 
{ 
obj_t BgL_auxz00_6768;
BgL_auxz00_6768 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40116)), BGl_string3121z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3213); 
FAILURE(BgL_auxz00_6768,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2aftertouchzd2zz__multimediazd2midizd2(BgL_auxz00_6764, BgL_auxz00_6772, BgL_auxz00_6780, BgL_auxz00_6789, BgL_auxz00_6798, BgL_auxz00_6807);} } 

}



/* midiplayer-ctrlchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_106, BgL_midisinkz00_bglt BgL_msz00_107, long BgL_tickz00_108, long BgL_nnz00_109, long BgL_kkz00_110, long BgL_vvz00_111)
{
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2079z00_2592;
BgL_fun2079z00_2592 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2077z00_2593;long BgL_arg2078z00_2594;
BgL_arg2077z00_2593 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
BgL_arg2078z00_2594 = 
(((long)176) | BgL_nnz00_109); 
PROCEDURE_ENTRY(BgL_fun2079z00_2592)(BgL_fun2079z00_2592, BgL_arg2077z00_2593, 
BINT(BgL_arg2078z00_2594), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2081z00_2595;
BgL_fun2081z00_2595 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2080z00_2596;
BgL_arg2080z00_2596 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2081z00_2595)(BgL_fun2081z00_2595, BgL_arg2080z00_2596, 
BINT(BgL_kkz00_110), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2083z00_2597;
BgL_fun2083z00_2597 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2082z00_2598;
BgL_arg2082z00_2598 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_107))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2083z00_2597)(BgL_fun2083z00_2597, BgL_arg2082z00_2598, 
BINT(BgL_vvz00_111), BEOA);} } } 

}



/* &midiplayer-ctrlchange */
obj_t BGl_z62midiplayerzd2ctrlchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3219, obj_t BgL_mpz00_3220, obj_t BgL_msz00_3221, obj_t BgL_tickz00_3222, obj_t BgL_nnz00_3223, obj_t BgL_kkz00_3224, obj_t BgL_vvz00_3225)
{
{ /* Llib/midi.scm 1047 */
{ /* Llib/midi.scm 1049 */
long BgL_auxz00_6885;long BgL_auxz00_6876;long BgL_auxz00_6867;long BgL_auxz00_6858;BgL_midisinkz00_bglt BgL_auxz00_6850;BgL_midiplayerz00_bglt BgL_auxz00_6842;
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6886;
if(
INTEGERP(BgL_vvz00_3225))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6886 = BgL_vvz00_3225
; }  else 
{ 
obj_t BgL_auxz00_6889;
BgL_auxz00_6889 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3122z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_vvz00_3225); 
FAILURE(BgL_auxz00_6889,BFALSE,BFALSE);} 
BgL_auxz00_6885 = 
(long)CINT(BgL_tmpz00_6886); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6877;
if(
INTEGERP(BgL_kkz00_3224))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6877 = BgL_kkz00_3224
; }  else 
{ 
obj_t BgL_auxz00_6880;
BgL_auxz00_6880 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3122z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_kkz00_3224); 
FAILURE(BgL_auxz00_6880,BFALSE,BFALSE);} 
BgL_auxz00_6876 = 
(long)CINT(BgL_tmpz00_6877); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6868;
if(
INTEGERP(BgL_nnz00_3223))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6868 = BgL_nnz00_3223
; }  else 
{ 
obj_t BgL_auxz00_6871;
BgL_auxz00_6871 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3122z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_nnz00_3223); 
FAILURE(BgL_auxz00_6871,BFALSE,BFALSE);} 
BgL_auxz00_6867 = 
(long)CINT(BgL_tmpz00_6868); } 
{ /* Llib/midi.scm 1049 */
obj_t BgL_tmpz00_6859;
if(
INTEGERP(BgL_tickz00_3222))
{ /* Llib/midi.scm 1049 */
BgL_tmpz00_6859 = BgL_tickz00_3222
; }  else 
{ 
obj_t BgL_auxz00_6862;
BgL_auxz00_6862 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3122z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3222); 
FAILURE(BgL_auxz00_6862,BFALSE,BFALSE);} 
BgL_auxz00_6858 = 
(long)CINT(BgL_tmpz00_6859); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3221, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6850 = 
((BgL_midisinkz00_bglt)BgL_msz00_3221)
; }  else 
{ 
obj_t BgL_auxz00_6854;
BgL_auxz00_6854 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3122z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3221); 
FAILURE(BgL_auxz00_6854,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3220, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1049 */
BgL_auxz00_6842 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3220)
; }  else 
{ 
obj_t BgL_auxz00_6846;
BgL_auxz00_6846 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40480)), BGl_string3122z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3220); 
FAILURE(BgL_auxz00_6846,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2ctrlchangezd2zz__multimediazd2midizd2(BgL_auxz00_6842, BgL_auxz00_6850, BgL_auxz00_6858, BgL_auxz00_6867, BgL_auxz00_6876, BgL_auxz00_6885);} } 

}



/* midiplayer-prgmchange */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_112, BgL_midisinkz00_bglt BgL_msz00_113, long BgL_tickz00_114, long BgL_nnz00_115, long BgL_ppz00_116)
{
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2074z00_2605;
BgL_fun2074z00_2605 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2072z00_2606;long BgL_arg2073z00_2607;
BgL_arg2072z00_2606 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
BgL_arg2073z00_2607 = 
(((long)192) | BgL_nnz00_115); 
PROCEDURE_ENTRY(BgL_fun2074z00_2605)(BgL_fun2074z00_2605, BgL_arg2072z00_2606, 
BINT(BgL_arg2073z00_2607), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2076z00_2608;
BgL_fun2076z00_2608 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2075z00_2609;
BgL_arg2075z00_2609 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_113))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2076z00_2608)(BgL_fun2076z00_2608, BgL_arg2075z00_2609, 
BINT(BgL_ppz00_116), BEOA);} } } 

}



/* &midiplayer-prgmchange */
obj_t BGl_z62midiplayerzd2prgmchangezb0zz__multimediazd2midizd2(obj_t BgL_envz00_3226, obj_t BgL_mpz00_3227, obj_t BgL_msz00_3228, obj_t BgL_tickz00_3229, obj_t BgL_nnz00_3230, obj_t BgL_ppz00_3231)
{
{ /* Llib/midi.scm 1054 */
{ /* Llib/midi.scm 1056 */
long BgL_auxz00_6946;long BgL_auxz00_6937;long BgL_auxz00_6928;BgL_midisinkz00_bglt BgL_auxz00_6920;BgL_midiplayerz00_bglt BgL_auxz00_6912;
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6947;
if(
INTEGERP(BgL_ppz00_3231))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6947 = BgL_ppz00_3231
; }  else 
{ 
obj_t BgL_auxz00_6950;
BgL_auxz00_6950 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3123z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_ppz00_3231); 
FAILURE(BgL_auxz00_6950,BFALSE,BFALSE);} 
BgL_auxz00_6946 = 
(long)CINT(BgL_tmpz00_6947); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6938;
if(
INTEGERP(BgL_nnz00_3230))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6938 = BgL_nnz00_3230
; }  else 
{ 
obj_t BgL_auxz00_6941;
BgL_auxz00_6941 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3123z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_nnz00_3230); 
FAILURE(BgL_auxz00_6941,BFALSE,BFALSE);} 
BgL_auxz00_6937 = 
(long)CINT(BgL_tmpz00_6938); } 
{ /* Llib/midi.scm 1056 */
obj_t BgL_tmpz00_6929;
if(
INTEGERP(BgL_tickz00_3229))
{ /* Llib/midi.scm 1056 */
BgL_tmpz00_6929 = BgL_tickz00_3229
; }  else 
{ 
obj_t BgL_auxz00_6932;
BgL_auxz00_6932 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3123z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3229); 
FAILURE(BgL_auxz00_6932,BFALSE,BFALSE);} 
BgL_auxz00_6928 = 
(long)CINT(BgL_tmpz00_6929); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3228, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6920 = 
((BgL_midisinkz00_bglt)BgL_msz00_3228)
; }  else 
{ 
obj_t BgL_auxz00_6924;
BgL_auxz00_6924 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3123z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3228); 
FAILURE(BgL_auxz00_6924,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3227, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1056 */
BgL_auxz00_6912 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3227)
; }  else 
{ 
obj_t BgL_auxz00_6916;
BgL_auxz00_6916 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)40835)), BGl_string3123z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3227); 
FAILURE(BgL_auxz00_6916,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2prgmchangezd2zz__multimediazd2midizd2(BgL_auxz00_6912, BgL_auxz00_6920, BgL_auxz00_6928, BgL_auxz00_6937, BgL_auxz00_6946);} } 

}



/* midiplayer-after-touch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_117, BgL_midisinkz00_bglt BgL_msz00_118, long BgL_tickz00_119, long BgL_nnz00_120, long BgL_ppz00_121)
{
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1011 */
obj_t BgL_fun2074z00_2616;
BgL_fun2074z00_2616 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1011 */
obj_t BgL_arg2072z00_2617;long BgL_arg2073z00_2618;
BgL_arg2072z00_2617 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
BgL_arg2073z00_2618 = 
(((long)208) | BgL_nnz00_120); 
PROCEDURE_ENTRY(BgL_fun2074z00_2616)(BgL_fun2074z00_2616, BgL_arg2072z00_2617, 
BINT(BgL_arg2073z00_2618), BEOA); } } 
{ /* Llib/midi.scm 1012 */
obj_t BgL_fun2076z00_2619;
BgL_fun2076z00_2619 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1012 */
obj_t BgL_arg2075z00_2620;
BgL_arg2075z00_2620 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_118))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2076z00_2619)(BgL_fun2076z00_2619, BgL_arg2075z00_2620, 
BINT(BgL_ppz00_121), BEOA);} } } 

}



/* &midiplayer-after-touch */
obj_t BGl_z62midiplayerzd2afterzd2touchz62zz__multimediazd2midizd2(obj_t BgL_envz00_3232, obj_t BgL_mpz00_3233, obj_t BgL_msz00_3234, obj_t BgL_tickz00_3235, obj_t BgL_nnz00_3236, obj_t BgL_ppz00_3237)
{
{ /* Llib/midi.scm 1061 */
{ /* Llib/midi.scm 1063 */
long BgL_auxz00_7007;long BgL_auxz00_6998;long BgL_auxz00_6989;BgL_midisinkz00_bglt BgL_auxz00_6981;BgL_midiplayerz00_bglt BgL_auxz00_6973;
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_7008;
if(
INTEGERP(BgL_ppz00_3237))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_7008 = BgL_ppz00_3237
; }  else 
{ 
obj_t BgL_auxz00_7011;
BgL_auxz00_7011 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3124z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_ppz00_3237); 
FAILURE(BgL_auxz00_7011,BFALSE,BFALSE);} 
BgL_auxz00_7007 = 
(long)CINT(BgL_tmpz00_7008); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6999;
if(
INTEGERP(BgL_nnz00_3236))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6999 = BgL_nnz00_3236
; }  else 
{ 
obj_t BgL_auxz00_7002;
BgL_auxz00_7002 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3124z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_nnz00_3236); 
FAILURE(BgL_auxz00_7002,BFALSE,BFALSE);} 
BgL_auxz00_6998 = 
(long)CINT(BgL_tmpz00_6999); } 
{ /* Llib/midi.scm 1063 */
obj_t BgL_tmpz00_6990;
if(
INTEGERP(BgL_tickz00_3235))
{ /* Llib/midi.scm 1063 */
BgL_tmpz00_6990 = BgL_tickz00_3235
; }  else 
{ 
obj_t BgL_auxz00_6993;
BgL_auxz00_6993 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3124z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3235); 
FAILURE(BgL_auxz00_6993,BFALSE,BFALSE);} 
BgL_auxz00_6989 = 
(long)CINT(BgL_tmpz00_6990); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3234, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6981 = 
((BgL_midisinkz00_bglt)BgL_msz00_3234)
; }  else 
{ 
obj_t BgL_auxz00_6985;
BgL_auxz00_6985 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3124z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3234); 
FAILURE(BgL_auxz00_6985,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3233, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1063 */
BgL_auxz00_6973 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3233)
; }  else 
{ 
obj_t BgL_auxz00_6977;
BgL_auxz00_6977 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41188)), BGl_string3124z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3233); 
FAILURE(BgL_auxz00_6977,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2afterzd2touchz00zz__multimediazd2midizd2(BgL_auxz00_6973, BgL_auxz00_6981, BgL_auxz00_6989, BgL_auxz00_6998, BgL_auxz00_7007);} } 

}



/* midiplayer-pitch */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_122, BgL_midisinkz00_bglt BgL_msz00_123, long BgL_tickz00_124, long BgL_nnz00_125, long BgL_ccz00_126, long BgL_vvz00_127)
{
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1019 */
obj_t BgL_fun2079z00_2628;
BgL_fun2079z00_2628 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1019 */
obj_t BgL_arg2077z00_2629;long BgL_arg2078z00_2630;
BgL_arg2077z00_2629 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
BgL_arg2078z00_2630 = 
(((long)224) | BgL_nnz00_125); 
PROCEDURE_ENTRY(BgL_fun2079z00_2628)(BgL_fun2079z00_2628, BgL_arg2077z00_2629, 
BINT(BgL_arg2078z00_2630), BEOA); } } 
{ /* Llib/midi.scm 1020 */
obj_t BgL_fun2081z00_2631;
BgL_fun2081z00_2631 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1020 */
obj_t BgL_arg2080z00_2632;
BgL_arg2080z00_2632 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
PROCEDURE_ENTRY(BgL_fun2081z00_2631)(BgL_fun2081z00_2631, BgL_arg2080z00_2632, 
BINT(BgL_ccz00_126), BEOA); } } 
{ /* Llib/midi.scm 1021 */
obj_t BgL_fun2083z00_2633;
BgL_fun2083z00_2633 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_writezd2bytezd2); 
{ /* Llib/midi.scm 1021 */
obj_t BgL_arg2082z00_2634;
BgL_arg2082z00_2634 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_123))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2083z00_2633)(BgL_fun2083z00_2633, BgL_arg2082z00_2634, 
BINT(BgL_vvz00_127), BEOA);} } } 

}



/* &midiplayer-pitch */
obj_t BGl_z62midiplayerzd2pitchzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3238, obj_t BgL_mpz00_3239, obj_t BgL_msz00_3240, obj_t BgL_tickz00_3241, obj_t BgL_nnz00_3242, obj_t BgL_ccz00_3243, obj_t BgL_vvz00_3244)
{
{ /* Llib/midi.scm 1068 */
{ /* Llib/midi.scm 1070 */
long BgL_auxz00_7085;long BgL_auxz00_7076;long BgL_auxz00_7067;long BgL_auxz00_7058;BgL_midisinkz00_bglt BgL_auxz00_7050;BgL_midiplayerz00_bglt BgL_auxz00_7042;
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7086;
if(
INTEGERP(BgL_vvz00_3244))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7086 = BgL_vvz00_3244
; }  else 
{ 
obj_t BgL_auxz00_7089;
BgL_auxz00_7089 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3125z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_vvz00_3244); 
FAILURE(BgL_auxz00_7089,BFALSE,BFALSE);} 
BgL_auxz00_7085 = 
(long)CINT(BgL_tmpz00_7086); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7077;
if(
INTEGERP(BgL_ccz00_3243))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7077 = BgL_ccz00_3243
; }  else 
{ 
obj_t BgL_auxz00_7080;
BgL_auxz00_7080 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3125z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_ccz00_3243); 
FAILURE(BgL_auxz00_7080,BFALSE,BFALSE);} 
BgL_auxz00_7076 = 
(long)CINT(BgL_tmpz00_7077); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7068;
if(
INTEGERP(BgL_nnz00_3242))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7068 = BgL_nnz00_3242
; }  else 
{ 
obj_t BgL_auxz00_7071;
BgL_auxz00_7071 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3125z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_nnz00_3242); 
FAILURE(BgL_auxz00_7071,BFALSE,BFALSE);} 
BgL_auxz00_7067 = 
(long)CINT(BgL_tmpz00_7068); } 
{ /* Llib/midi.scm 1070 */
obj_t BgL_tmpz00_7059;
if(
INTEGERP(BgL_tickz00_3241))
{ /* Llib/midi.scm 1070 */
BgL_tmpz00_7059 = BgL_tickz00_3241
; }  else 
{ 
obj_t BgL_auxz00_7062;
BgL_auxz00_7062 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3125z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3241); 
FAILURE(BgL_auxz00_7062,BFALSE,BFALSE);} 
BgL_auxz00_7058 = 
(long)CINT(BgL_tmpz00_7059); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3240, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_7050 = 
((BgL_midisinkz00_bglt)BgL_msz00_3240)
; }  else 
{ 
obj_t BgL_auxz00_7054;
BgL_auxz00_7054 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3125z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3240); 
FAILURE(BgL_auxz00_7054,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3239, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1070 */
BgL_auxz00_7042 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3239)
; }  else 
{ 
obj_t BgL_auxz00_7046;
BgL_auxz00_7046 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41544)), BGl_string3125z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3239); 
FAILURE(BgL_auxz00_7046,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2pitchzd2zz__multimediazd2midizd2(BgL_auxz00_7042, BgL_auxz00_7050, BgL_auxz00_7058, BgL_auxz00_7067, BgL_auxz00_7076, BgL_auxz00_7085);} } 

}



/* midiplayer-sysex */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mpz00_128, BgL_midisinkz00_bglt BgL_msz00_129, long BgL_tickz00_130, obj_t BgL_dataz00_131)
{
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1077 */
obj_t BgL_fun2085z00_2638;
BgL_fun2085z00_2638 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_writezd2stringzd2); 
{ /* Llib/midi.scm 1077 */
obj_t BgL_arg2084z00_2639;
BgL_arg2084z00_2639 = 
(((BgL_midisinkz00_bglt)COBJECT(BgL_msz00_129))->BgL_streamz00); 
return 
PROCEDURE_ENTRY(BgL_fun2085z00_2638)(BgL_fun2085z00_2638, BgL_arg2084z00_2639, BEOA);} } } 

}



/* &midiplayer-sysex */
obj_t BGl_z62midiplayerzd2sysexzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3245, obj_t BgL_mpz00_3246, obj_t BgL_msz00_3247, obj_t BgL_tickz00_3248, obj_t BgL_dataz00_3249)
{
{ /* Llib/midi.scm 1075 */
{ /* Llib/midi.scm 1076 */
obj_t BgL_auxz00_7126;long BgL_auxz00_7117;BgL_midisinkz00_bglt BgL_auxz00_7109;BgL_midiplayerz00_bglt BgL_auxz00_7101;
if(
STRINGP(BgL_dataz00_3249))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7126 = BgL_dataz00_3249
; }  else 
{ 
obj_t BgL_auxz00_7129;
BgL_auxz00_7129 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3126z00zz__multimediazd2midizd2, BGl_string3086z00zz__multimediazd2midizd2, BgL_dataz00_3249); 
FAILURE(BgL_auxz00_7129,BFALSE,BFALSE);} 
{ /* Llib/midi.scm 1076 */
obj_t BgL_tmpz00_7118;
if(
INTEGERP(BgL_tickz00_3248))
{ /* Llib/midi.scm 1076 */
BgL_tmpz00_7118 = BgL_tickz00_3248
; }  else 
{ 
obj_t BgL_auxz00_7121;
BgL_auxz00_7121 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3126z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_tickz00_3248); 
FAILURE(BgL_auxz00_7121,BFALSE,BFALSE);} 
BgL_auxz00_7117 = 
(long)CINT(BgL_tmpz00_7118); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_msz00_3247, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7109 = 
((BgL_midisinkz00_bglt)BgL_msz00_3247)
; }  else 
{ 
obj_t BgL_auxz00_7113;
BgL_auxz00_7113 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3126z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msz00_3247); 
FAILURE(BgL_auxz00_7113,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_mpz00_3246, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 1076 */
BgL_auxz00_7101 = 
((BgL_midiplayerz00_bglt)BgL_mpz00_3246)
; }  else 
{ 
obj_t BgL_auxz00_7105;
BgL_auxz00_7105 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)41881)), BGl_string3126z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mpz00_3246); 
FAILURE(BgL_auxz00_7105,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2sysexzd2zz__multimediazd2midizd2(BgL_auxz00_7101, BgL_auxz00_7109, BgL_auxz00_7117, BgL_auxz00_7126);} } 

}



/* midi-note-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2notezd2namez00zz__multimediazd2midizd2(long BgL_kkz00_132)
{
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_notez00_888;long BgL_octavez00_889;
{ /* Llib/midi.scm 1083 */
long BgL_arg2089z00_893;
{ /* Llib/midi.scm 1083 */
obj_t BgL_vectorz00_2640;
BgL_vectorz00_2640 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2089z00_893 = 
VECTOR_LENGTH(BgL_vectorz00_2640); } 
{ /* Llib/midi.scm 1083 */
long BgL_res2814z00_2659;
{ /* Llib/midi.scm 1083 */
long BgL_n1z00_2641;long BgL_n2z00_2642;
BgL_n1z00_2641 = BgL_kkz00_132; 
BgL_n2z00_2642 = BgL_arg2089z00_893; 
{ /* Llib/midi.scm 1083 */
bool_t BgL_test3752z00_7136;
{ /* Llib/midi.scm 1083 */
long BgL_arg1327z00_2644;
BgL_arg1327z00_2644 = 
(((BgL_n1z00_2641) | (BgL_n2z00_2642)) & -2147483648); 
BgL_test3752z00_7136 = 
(BgL_arg1327z00_2644==((long)0)); } 
if(BgL_test3752z00_7136)
{ /* Llib/midi.scm 1083 */
int32_t BgL_arg1323z00_2645;
{ /* Llib/midi.scm 1083 */
int32_t BgL_arg1324z00_2646;int32_t BgL_arg1325z00_2647;
{ /* Llib/midi.scm 1083 */
int32_t BgL_res2810z00_2651;
BgL_res2810z00_2651 = 
(int32_t)(BgL_n1z00_2641); 
BgL_arg1324z00_2646 = BgL_res2810z00_2651; } 
{ /* Llib/midi.scm 1083 */
int32_t BgL_res2811z00_2653;
BgL_res2811z00_2653 = 
(int32_t)(BgL_n2z00_2642); 
BgL_arg1325z00_2647 = BgL_res2811z00_2653; } 
BgL_arg1323z00_2645 = 
(BgL_arg1324z00_2646%BgL_arg1325z00_2647); } 
{ /* Llib/midi.scm 1083 */
long BgL_res2813z00_2658;
{ /* Llib/midi.scm 1083 */
long BgL_arg1426z00_2655;
BgL_arg1426z00_2655 = 
(long)(BgL_arg1323z00_2645); 
{ /* Llib/midi.scm 1083 */
long BgL_res2812z00_2657;
BgL_res2812z00_2657 = 
(long)(BgL_arg1426z00_2655); 
BgL_res2813z00_2658 = BgL_res2812z00_2657; } } 
BgL_res2814z00_2659 = BgL_res2813z00_2658; } }  else 
{ /* Llib/midi.scm 1083 */
BgL_res2814z00_2659 = 
(BgL_n1z00_2641%BgL_n2z00_2642); } } } 
BgL_notez00_888 = BgL_res2814z00_2659; } } 
{ /* Llib/midi.scm 1084 */
long BgL_arg2090z00_894;
{ /* Llib/midi.scm 1084 */
obj_t BgL_vectorz00_2660;
BgL_vectorz00_2660 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2090z00_894 = 
VECTOR_LENGTH(BgL_vectorz00_2660); } 
BgL_octavez00_889 = 
(BgL_kkz00_132/BgL_arg2090z00_894); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2086z00_890;
{ /* Llib/midi.scm 1085 */
obj_t BgL_vectorz00_2664;
BgL_vectorz00_2664 = 
CNST_TABLE_REF(((long)3)); 
BgL_arg2086z00_890 = 
VECTOR_REF(BgL_vectorz00_2664,BgL_notez00_888); } 
{ /* Llib/midi.scm 1085 */
obj_t BgL_list2087z00_891;
{ /* Llib/midi.scm 1085 */
obj_t BgL_arg2088z00_892;
BgL_arg2088z00_892 = 
MAKE_YOUNG_PAIR(
BINT(BgL_octavez00_889), BNIL); 
BgL_list2087z00_891 = 
MAKE_YOUNG_PAIR(BgL_arg2086z00_890, BgL_arg2088z00_892); } 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3127z00zz__multimediazd2midizd2, BgL_list2087z00_891);} } } } 

}



/* &midi-note-name */
obj_t BGl_z62midizd2notezd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3250, obj_t BgL_kkz00_3251)
{
{ /* Llib/midi.scm 1082 */
{ /* Llib/midi.scm 1083 */
long BgL_auxz00_7154;
{ /* Llib/midi.scm 1083 */
obj_t BgL_tmpz00_7155;
if(
INTEGERP(BgL_kkz00_3251))
{ /* Llib/midi.scm 1083 */
BgL_tmpz00_7155 = BgL_kkz00_3251
; }  else 
{ 
obj_t BgL_auxz00_7158;
BgL_auxz00_7158 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)42219)), BGl_string3128z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_kkz00_3251); 
FAILURE(BgL_auxz00_7158,BFALSE,BFALSE);} 
BgL_auxz00_7154 = 
(long)CINT(BgL_tmpz00_7155); } 
return 
BGl_midizd2notezd2namez00zz__multimediazd2midizd2(BgL_auxz00_7154);} } 

}



/* midi-controller-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(long BgL_ccz00_133)
{
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
bool_t BgL_test3754z00_7164;
{ /* Llib/midi.scm 1091 */
long BgL_arg2093z00_2667;
{ /* Llib/midi.scm 1091 */
obj_t BgL_vectorz00_2668;
BgL_vectorz00_2668 = 
CNST_TABLE_REF(((long)1)); 
BgL_arg2093z00_2667 = 
VECTOR_LENGTH(BgL_vectorz00_2668); } 
BgL_test3754z00_7164 = 
(BgL_ccz00_133<BgL_arg2093z00_2667); } 
if(BgL_test3754z00_7164)
{ /* Llib/midi.scm 1092 */
obj_t BgL_vectorz00_2672;
BgL_vectorz00_2672 = 
CNST_TABLE_REF(((long)1)); 
return 
VECTOR_REF(BgL_vectorz00_2672,BgL_ccz00_133);}  else 
{ /* Llib/midi.scm 1091 */
return BGl_string3129z00zz__multimediazd2midizd2;} } } 

}



/* &midi-controller-name */
obj_t BGl_z62midizd2controllerzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3252, obj_t BgL_ccz00_3253)
{
{ /* Llib/midi.scm 1090 */
{ /* Llib/midi.scm 1091 */
long BgL_auxz00_7170;
{ /* Llib/midi.scm 1091 */
obj_t BgL_tmpz00_7171;
if(
INTEGERP(BgL_ccz00_3253))
{ /* Llib/midi.scm 1091 */
BgL_tmpz00_7171 = BgL_ccz00_3253
; }  else 
{ 
obj_t BgL_auxz00_7174;
BgL_auxz00_7174 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)42667)), BGl_string3130z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_ccz00_3253); 
FAILURE(BgL_auxz00_7174,BFALSE,BFALSE);} 
BgL_auxz00_7170 = 
(long)CINT(BgL_tmpz00_7171); } 
return 
BGl_midizd2controllerzd2namez00zz__multimediazd2midizd2(BgL_auxz00_7170);} } 

}



/* midi-program-name */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2namez00zz__multimediazd2midizd2(long BgL_ppz00_134)
{
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
bool_t BgL_test3756z00_7180;
{ /* Llib/midi.scm 1099 */
long BgL_arg2096z00_2675;
{ /* Llib/midi.scm 1099 */
obj_t BgL_vectorz00_2676;
BgL_vectorz00_2676 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2096z00_2675 = 
VECTOR_LENGTH(BgL_vectorz00_2676); } 
BgL_test3756z00_7180 = 
(BgL_ppz00_134<BgL_arg2096z00_2675); } 
if(BgL_test3756z00_7180)
{ /* Llib/midi.scm 1100 */
obj_t BgL_vectorz00_2680;
BgL_vectorz00_2680 = 
CNST_TABLE_REF(((long)2)); 
return 
VECTOR_REF(BgL_vectorz00_2680,BgL_ppz00_134);}  else 
{ /* Llib/midi.scm 1099 */
return BGl_string3131z00zz__multimediazd2midizd2;} } } 

}



/* &midi-program-name */
obj_t BGl_z62midizd2programzd2namez62zz__multimediazd2midizd2(obj_t BgL_envz00_3254, obj_t BgL_ppz00_3255)
{
{ /* Llib/midi.scm 1098 */
{ /* Llib/midi.scm 1099 */
long BgL_auxz00_7186;
{ /* Llib/midi.scm 1099 */
obj_t BgL_tmpz00_7187;
if(
INTEGERP(BgL_ppz00_3255))
{ /* Llib/midi.scm 1099 */
BgL_tmpz00_7187 = BgL_ppz00_3255
; }  else 
{ 
obj_t BgL_auxz00_7190;
BgL_auxz00_7190 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)43056)), BGl_string3132z00zz__multimediazd2midizd2, BGl_string3089z00zz__multimediazd2midizd2, BgL_ppz00_3255); 
FAILURE(BgL_auxz00_7190,BFALSE,BFALSE);} 
BgL_auxz00_7186 = 
(long)CINT(BgL_tmpz00_7187); } 
return 
BGl_midizd2programzd2namez00zz__multimediazd2midizd2(BgL_auxz00_7186);} } 

}



/* midi-program-index */
BGL_EXPORTED_DEF obj_t BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(obj_t BgL_prgmz00_135)
{
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
long BgL_g1174z00_901;
{ /* Llib/midi.scm 1107 */
long BgL_arg2103z00_911;
{ /* Llib/midi.scm 1107 */
obj_t BgL_vectorz00_2682;
BgL_vectorz00_2682 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2103z00_911 = 
VECTOR_LENGTH(BgL_vectorz00_2682); } 
BgL_g1174z00_901 = 
(BgL_arg2103z00_911-((long)1)); } 
{ 
long BgL_iz00_903;
BgL_iz00_903 = BgL_g1174z00_901; 
BgL_zc3z04anonymousza32097ze3z87_904:
if(
(BgL_iz00_903>=((long)0)))
{ /* Llib/midi.scm 1109 */
bool_t BgL_test3759z00_7201;
{ /* Llib/midi.scm 1109 */
obj_t BgL_arg2102z00_909;
{ /* Llib/midi.scm 1109 */
obj_t BgL_vectorz00_2687;
BgL_vectorz00_2687 = 
CNST_TABLE_REF(((long)2)); 
BgL_arg2102z00_909 = 
VECTOR_REF(BgL_vectorz00_2687,BgL_iz00_903); } 
BgL_test3759z00_7201 = 
bigloo_strcicmp(BgL_arg2102z00_909, BgL_prgmz00_135); } 
if(BgL_test3759z00_7201)
{ /* Llib/midi.scm 1109 */
return 
BINT(BgL_iz00_903);}  else 
{ 
long BgL_iz00_7206;
BgL_iz00_7206 = 
(BgL_iz00_903-((long)1)); 
BgL_iz00_903 = BgL_iz00_7206; 
goto BgL_zc3z04anonymousza32097ze3z87_904;} }  else 
{ /* Llib/midi.scm 1108 */
return BFALSE;} } } } 

}



/* &midi-program-index */
obj_t BGl_z62midizd2programzd2indexz62zz__multimediazd2midizd2(obj_t BgL_envz00_3256, obj_t BgL_prgmz00_3257)
{
{ /* Llib/midi.scm 1106 */
{ /* Llib/midi.scm 1107 */
obj_t BgL_auxz00_7208;
if(
STRINGP(BgL_prgmz00_3257))
{ /* Llib/midi.scm 1107 */
BgL_auxz00_7208 = BgL_prgmz00_3257
; }  else 
{ 
obj_t BgL_auxz00_7211;
BgL_auxz00_7211 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)43433)), BGl_string3133z00zz__multimediazd2midizd2, BGl_string3086z00zz__multimediazd2midizd2, BgL_prgmz00_3257); 
FAILURE(BgL_auxz00_7211,BFALSE,BFALSE);} 
return 
BGl_midizd2programzd2indexz00zz__multimediazd2midizd2(BgL_auxz00_7208);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2121z00_936;obj_t BgL_arg2122z00_937;
{ /* Llib/midi.scm 17 */
obj_t BgL_v1219z00_952;
BgL_v1219z00_952 = 
create_vector(((long)4)); 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2129z00_953;
BgL_arg2129z00_953 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)5)), BGl_proc3135z00zz__multimediazd2midizd2, BGl_proc3134z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1219z00_952,((long)0),BgL_arg2129z00_953); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2134z00_963;
BgL_arg2134z00_963 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc3138z00zz__multimediazd2midizd2, BGl_proc3137z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3136z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1219z00_952,((long)1),BgL_arg2134z00_963); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2141z00_976;
BgL_arg2141z00_976 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)8)), BGl_proc3141z00zz__multimediazd2midizd2, BGl_proc3140z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3139z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1219z00_952,((long)2),BgL_arg2141z00_976); } 
{ /* Llib/midi.scm 17 */
obj_t BgL_arg2148z00_989;
BgL_arg2148z00_989 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)9)), BGl_proc3144z00zz__multimediazd2midizd2, BGl_proc3143z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3142z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)10))); 
VECTOR_SET(BgL_v1219z00_952,((long)3),BgL_arg2148z00_989); } 
BgL_arg2121z00_936 = BgL_v1219z00_952; } 
{ /* Llib/midi.scm 17 */
obj_t BgL_v1220z00_1002;
BgL_v1220z00_1002 = 
create_vector(((long)0)); 
BgL_arg2122z00_937 = BgL_v1220z00_1002; } 
BGl_midiscorez00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)11)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)5472), BGl_proc3147z00zz__multimediazd2midizd2, BGl_proc3146z00zz__multimediazd2midizd2, BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3145z00zz__multimediazd2midizd2, BFALSE, BgL_arg2121z00_936, BgL_arg2122z00_937); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2158z00_1009;obj_t BgL_arg2159z00_1010;
{ /* Llib/midi.scm 24 */
obj_t BgL_v1221z00_1035;
BgL_v1221z00_1035 = 
create_vector(((long)14)); 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2166z00_1036;
BgL_arg2166z00_1036 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc3150z00zz__multimediazd2midizd2, BGl_proc3149z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3148z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1221z00_1035,((long)0),BgL_arg2166z00_1036); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2173z00_1049;
BgL_arg2173z00_1049 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)15)), BGl_proc3152z00zz__multimediazd2midizd2, BGl_proc3151z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_midireaderz00zz__multimediazd2midizd2); 
VECTOR_SET(BgL_v1221z00_1035,((long)1),BgL_arg2173z00_1049); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2178z00_1059;
BgL_arg2178z00_1059 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)16)), BGl_proc3154z00zz__multimediazd2midizd2, BGl_proc3153z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1221z00_1035,((long)2),BgL_arg2178z00_1059); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2184z00_1069;
BgL_arg2184z00_1069 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)18)), BGl_proc3157z00zz__multimediazd2midizd2, BGl_proc3156z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3155z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1221z00_1035,((long)3),BgL_arg2184z00_1069); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2191z00_1082;
BgL_arg2191z00_1082 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)20)), BGl_proc3160z00zz__multimediazd2midizd2, BGl_proc3159z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3158z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1221z00_1035,((long)4),BgL_arg2191z00_1082); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2198z00_1095;
BgL_arg2198z00_1095 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)22)), BGl_proc3163z00zz__multimediazd2midizd2, BGl_proc3162z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3161z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1035,((long)5),BgL_arg2198z00_1095); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2205z00_1108;
BgL_arg2205z00_1108 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc3166z00zz__multimediazd2midizd2, BGl_proc3165z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3164z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1221z00_1035,((long)6),BgL_arg2205z00_1108); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2212z00_1121;
BgL_arg2212z00_1121 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)7)), BGl_proc3169z00zz__multimediazd2midizd2, BGl_proc3168z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3167z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1035,((long)7),BgL_arg2212z00_1121); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2219z00_1134;
BgL_arg2219z00_1134 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)25)), BGl_proc3172z00zz__multimediazd2midizd2, BGl_proc3171z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3170z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1221z00_1035,((long)8),BgL_arg2219z00_1134); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2226z00_1147;
BgL_arg2226z00_1147 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)26)), BGl_proc3175z00zz__multimediazd2midizd2, BGl_proc3174z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3173z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1035,((long)9),BgL_arg2226z00_1147); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2233z00_1160;
BgL_arg2233z00_1160 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)27)), BGl_proc3178z00zz__multimediazd2midizd2, BGl_proc3177z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3176z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1035,((long)10),BgL_arg2233z00_1160); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2240z00_1173;
BgL_arg2240z00_1173 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc3181z00zz__multimediazd2midizd2, BGl_proc3180z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3179z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)21))); 
VECTOR_SET(BgL_v1221z00_1035,((long)11),BgL_arg2240z00_1173); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2247z00_1186;
BgL_arg2247z00_1186 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc3184z00zz__multimediazd2midizd2, BGl_proc3183z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3182z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)6))); 
VECTOR_SET(BgL_v1221z00_1035,((long)12),BgL_arg2247z00_1186); } 
{ /* Llib/midi.scm 24 */
obj_t BgL_arg2254z00_1199;
BgL_arg2254z00_1199 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)30)), BGl_proc3187z00zz__multimediazd2midizd2, BGl_proc3186z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3185z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)19))); 
VECTOR_SET(BgL_v1221z00_1035,((long)13),BgL_arg2254z00_1199); } 
BgL_arg2158z00_1009 = BgL_v1221z00_1035; } 
{ /* Llib/midi.scm 24 */
obj_t BgL_v1222z00_1212;
BgL_v1222z00_1212 = 
create_vector(((long)0)); 
BgL_arg2159z00_1010 = BgL_v1222z00_1212; } 
BGl_miditrackz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)31)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)27063), BGl_proc3190z00zz__multimediazd2midizd2, BGl_proc3189z00zz__multimediazd2midizd2, BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3188z00zz__multimediazd2midizd2, BFALSE, BgL_arg2158z00_1009, BgL_arg2159z00_1010); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2264z00_1219;obj_t BgL_arg2265z00_1220;
{ /* Llib/midi.scm 42 */
obj_t BgL_v1223z00_1238;
BgL_v1223z00_1238 = 
create_vector(((long)7)); 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2272z00_1239;
BgL_arg2272z00_1239 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)32)), BGl_proc3192z00zz__multimediazd2midizd2, BGl_proc3191z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1238,((long)0),BgL_arg2272z00_1239); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2277z00_1249;
BgL_arg2277z00_1249 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)33)), BGl_proc3194z00zz__multimediazd2midizd2, BGl_proc3193z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1238,((long)1),BgL_arg2277z00_1249); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2282z00_1259;
BgL_arg2282z00_1259 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc3196z00zz__multimediazd2midizd2, BGl_proc3195z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1238,((long)2),BgL_arg2282z00_1259); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2287z00_1269;
BgL_arg2287z00_1269 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)35)), BGl_proc3198z00zz__multimediazd2midizd2, BGl_proc3197z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1238,((long)3),BgL_arg2287z00_1269); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2292z00_1279;
BgL_arg2292z00_1279 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc3200z00zz__multimediazd2midizd2, BGl_proc3199z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1238,((long)4),BgL_arg2292z00_1279); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2297z00_1289;
BgL_arg2297z00_1289 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)37)), BGl_proc3202z00zz__multimediazd2midizd2, BGl_proc3201z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1238,((long)5),BgL_arg2297z00_1289); } 
{ /* Llib/midi.scm 42 */
obj_t BgL_arg2302z00_1299;
BgL_arg2302z00_1299 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)38)), BGl_proc3204z00zz__multimediazd2midizd2, BGl_proc3203z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1223z00_1238,((long)6),BgL_arg2302z00_1299); } 
BgL_arg2264z00_1219 = BgL_v1223z00_1238; } 
{ /* Llib/midi.scm 42 */
obj_t BgL_v1224z00_1309;
BgL_v1224z00_1309 = 
create_vector(((long)0)); 
BgL_arg2265z00_1220 = BgL_v1224z00_1309; } 
BGl_midireaderz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)39)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)54263), BGl_proc3207z00zz__multimediazd2midizd2, BGl_proc3206z00zz__multimediazd2midizd2, BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3205z00zz__multimediazd2midizd2, BFALSE, BgL_arg2264z00_1219, BgL_arg2265z00_1220); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2310z00_1316;obj_t BgL_arg2311z00_1317;
{ /* Llib/midi.scm 52 */
obj_t BgL_v1225z00_1356;
BgL_v1225z00_1356 = 
create_vector(((long)28)); 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2318z00_1357;
BgL_arg2318z00_1357 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)40)), BGl_proc3210z00zz__multimediazd2midizd2, BGl_proc3209z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3208z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)0),BgL_arg2318z00_1357); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2325z00_1370;
BgL_arg2325z00_1370 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)41)), BGl_proc3213z00zz__multimediazd2midizd2, BGl_proc3212z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3211z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)1),BgL_arg2325z00_1370); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2332z00_1383;
BgL_arg2332z00_1383 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)42)), BGl_proc3216z00zz__multimediazd2midizd2, BGl_proc3215z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3214z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)2),BgL_arg2332z00_1383); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2339z00_1396;
BgL_arg2339z00_1396 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)43)), BGl_proc3219z00zz__multimediazd2midizd2, BGl_proc3218z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3217z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)3),BgL_arg2339z00_1396); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2346z00_1409;
BgL_arg2346z00_1409 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)44)), BGl_proc3222z00zz__multimediazd2midizd2, BGl_proc3221z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3220z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)4),BgL_arg2346z00_1409); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2353z00_1422;
BgL_arg2353z00_1422 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)45)), BGl_proc3225z00zz__multimediazd2midizd2, BGl_proc3224z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3223z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)5),BgL_arg2353z00_1422); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2360z00_1435;
BgL_arg2360z00_1435 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)46)), BGl_proc3228z00zz__multimediazd2midizd2, BGl_proc3227z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3226z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)6),BgL_arg2360z00_1435); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2367z00_1448;
BgL_arg2367z00_1448 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)47)), BGl_proc3231z00zz__multimediazd2midizd2, BGl_proc3230z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3229z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)7),BgL_arg2367z00_1448); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2374z00_1461;
BgL_arg2374z00_1461 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)48)), BGl_proc3234z00zz__multimediazd2midizd2, BGl_proc3233z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3232z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)8),BgL_arg2374z00_1461); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2381z00_1474;
BgL_arg2381z00_1474 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)49)), BGl_proc3237z00zz__multimediazd2midizd2, BGl_proc3236z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3235z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)9),BgL_arg2381z00_1474); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2388z00_1487;
BgL_arg2388z00_1487 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)50)), BGl_proc3240z00zz__multimediazd2midizd2, BGl_proc3239z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3238z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)10),BgL_arg2388z00_1487); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2395z00_1500;
BgL_arg2395z00_1500 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)51)), BGl_proc3243z00zz__multimediazd2midizd2, BGl_proc3242z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3241z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)11),BgL_arg2395z00_1500); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2402z00_1513;
BgL_arg2402z00_1513 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)52)), BGl_proc3246z00zz__multimediazd2midizd2, BGl_proc3245z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3244z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)12),BgL_arg2402z00_1513); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2409z00_1526;
BgL_arg2409z00_1526 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)53)), BGl_proc3249z00zz__multimediazd2midizd2, BGl_proc3248z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3247z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)13),BgL_arg2409z00_1526); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2416z00_1539;
BgL_arg2416z00_1539 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)54)), BGl_proc3252z00zz__multimediazd2midizd2, BGl_proc3251z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3250z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)14),BgL_arg2416z00_1539); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2423z00_1552;
BgL_arg2423z00_1552 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)55)), BGl_proc3255z00zz__multimediazd2midizd2, BGl_proc3254z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3253z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)15),BgL_arg2423z00_1552); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2430z00_1565;
BgL_arg2430z00_1565 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)56)), BGl_proc3258z00zz__multimediazd2midizd2, BGl_proc3257z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3256z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)16),BgL_arg2430z00_1565); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2437z00_1578;
BgL_arg2437z00_1578 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)57)), BGl_proc3261z00zz__multimediazd2midizd2, BGl_proc3260z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3259z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)17),BgL_arg2437z00_1578); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2444z00_1591;
BgL_arg2444z00_1591 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)58)), BGl_proc3264z00zz__multimediazd2midizd2, BGl_proc3263z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3262z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)18),BgL_arg2444z00_1591); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2451z00_1604;
BgL_arg2451z00_1604 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)59)), BGl_proc3267z00zz__multimediazd2midizd2, BGl_proc3266z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3265z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)19),BgL_arg2451z00_1604); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2458z00_1617;
BgL_arg2458z00_1617 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)60)), BGl_proc3270z00zz__multimediazd2midizd2, BGl_proc3269z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3268z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)20),BgL_arg2458z00_1617); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2465z00_1630;
BgL_arg2465z00_1630 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)61)), BGl_proc3273z00zz__multimediazd2midizd2, BGl_proc3272z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3271z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)21),BgL_arg2465z00_1630); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2472z00_1643;
BgL_arg2472z00_1643 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)62)), BGl_proc3276z00zz__multimediazd2midizd2, BGl_proc3275z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3274z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)22),BgL_arg2472z00_1643); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2479z00_1656;
BgL_arg2479z00_1656 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)63)), BGl_proc3279z00zz__multimediazd2midizd2, BGl_proc3278z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3277z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)23),BgL_arg2479z00_1656); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2486z00_1669;
BgL_arg2486z00_1669 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)64)), BGl_proc3282z00zz__multimediazd2midizd2, BGl_proc3281z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3280z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)24),BgL_arg2486z00_1669); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2494z00_1691;
BgL_arg2494z00_1691 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)65)), BGl_proc3285z00zz__multimediazd2midizd2, BGl_proc3284z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3283z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)25),BgL_arg2494z00_1691); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2502z00_1712;
BgL_arg2502z00_1712 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)66)), BGl_proc3288z00zz__multimediazd2midizd2, BGl_proc3287z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3286z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)26),BgL_arg2502z00_1712); } 
{ /* Llib/midi.scm 52 */
obj_t BgL_arg2509z00_1725;
BgL_arg2509z00_1725 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)67)), BGl_proc3291z00zz__multimediazd2midizd2, BGl_proc3290z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3289z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1225z00_1356,((long)27),BgL_arg2509z00_1725); } 
BgL_arg2310z00_1316 = BgL_v1225z00_1356; } 
{ /* Llib/midi.scm 52 */
obj_t BgL_v1226z00_1738;
BgL_v1226z00_1738 = 
create_vector(((long)0)); 
BgL_arg2311z00_1317 = BgL_v1226z00_1738; } 
BGl_midiplayerz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)68)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)53193), BGl_proc3294z00zz__multimediazd2midizd2, BGl_proc3293z00zz__multimediazd2midizd2, BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3292z00zz__multimediazd2midizd2, BFALSE, BgL_arg2310z00_1316, BgL_arg2311z00_1317); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2519z00_1745;obj_t BgL_arg2520z00_1746;
{ /* Llib/midi.scm 87 */
obj_t BgL_v1227z00_1762;
BgL_v1227z00_1762 = 
create_vector(((long)5)); 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2527z00_1763;
BgL_arg2527z00_1763 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)69)), BGl_proc3297z00zz__multimediazd2midizd2, BGl_proc3296z00zz__multimediazd2midizd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3295z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)14))); 
VECTOR_SET(BgL_v1227z00_1762,((long)0),BgL_arg2527z00_1763); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2534z00_1776;
BgL_arg2534z00_1776 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)70)), BGl_proc3300z00zz__multimediazd2midizd2, BGl_proc3299z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3298z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1762,((long)1),BgL_arg2534z00_1776); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2541z00_1789;
BgL_arg2541z00_1789 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)71)), BGl_proc3303z00zz__multimediazd2midizd2, BGl_proc3302z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3301z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1762,((long)2),BgL_arg2541z00_1789); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2549z00_1805;
BgL_arg2549z00_1805 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)72)), BGl_proc3306z00zz__multimediazd2midizd2, BGl_proc3305z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3304z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1762,((long)3),BgL_arg2549z00_1805); } 
{ /* Llib/midi.scm 87 */
obj_t BgL_arg2557z00_1821;
BgL_arg2557z00_1821 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)73)), BGl_proc3309z00zz__multimediazd2midizd2, BGl_proc3308z00zz__multimediazd2midizd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3307z00zz__multimediazd2midizd2, 
CNST_TABLE_REF(((long)17))); 
VECTOR_SET(BgL_v1227z00_1762,((long)4),BgL_arg2557z00_1821); } 
BgL_arg2519z00_1745 = BgL_v1227z00_1762; } 
{ /* Llib/midi.scm 87 */
obj_t BgL_v1228z00_1834;
BgL_v1228z00_1834 = 
create_vector(((long)0)); 
BgL_arg2520z00_1746 = BgL_v1228z00_1834; } 
return ( 
BGl_midisinkz00zz__multimediazd2midizd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)74)), 
CNST_TABLE_REF(((long)12)), BGl_objectz00zz__objectz00, ((long)13489), BGl_proc3312z00zz__multimediazd2midizd2, BGl_proc3311z00zz__multimediazd2midizd2, BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3310z00zz__multimediazd2midizd2, BFALSE, BgL_arg2519z00_1745, BgL_arg2520z00_1746), BUNSPEC) ;} } 

}



/* &<@anonymous:2526> */
obj_t BGl_z62zc3z04anonymousza32526ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3452, obj_t BgL_new1118z00_3453)
{
{ /* Llib/midi.scm 87 */
{ 
BgL_midisinkz00_bglt BgL_auxz00_7472;
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3453)))->BgL_streamz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3453)))->BgL_usleepz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3453)))->BgL_writezd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3453)))->BgL_writezd2stringzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_new1118z00_3453)))->BgL_flushz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7472 = 
((BgL_midisinkz00_bglt)BgL_new1118z00_3453); 
return 
((obj_t)BgL_auxz00_7472);} } 

}



/* &lambda2524 */
BgL_midisinkz00_bglt BGl_z62lambda2524z62zz__multimediazd2midizd2(obj_t BgL_envz00_3454)
{
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1117z00_4232;
BgL_new1117z00_4232 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2525z00_4233;
{ /* Llib/midi.scm 87 */
long BgL_res2833z00_4234;
BgL_res2833z00_4234 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg2525z00_4233 = BgL_res2833z00_4234; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1117z00_4232), BgL_arg2525z00_4233); } 
return BgL_new1117z00_4232;} } 

}



/* &lambda2521 */
BgL_midisinkz00_bglt BGl_z62lambda2521z62zz__multimediazd2midizd2(obj_t BgL_envz00_3455, obj_t BgL_stream1112z00_3456, obj_t BgL_usleep1113z00_3457, obj_t BgL_writezd2byte1114zd2_3458, obj_t BgL_writezd2string1115zd2_3459, obj_t BgL_flush1116z00_3460)
{
{ /* Llib/midi.scm 87 */
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1184z00_4239;
{ /* Llib/midi.scm 87 */
BgL_midisinkz00_bglt BgL_new1183z00_4240;
BgL_new1183z00_4240 = 
((BgL_midisinkz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midisinkz00_bgl) ))); 
{ /* Llib/midi.scm 87 */
long BgL_arg2523z00_4241;
{ /* Llib/midi.scm 87 */
long BgL_res2832z00_4242;
BgL_res2832z00_4242 = 
BGL_CLASS_INDEX(BGl_midisinkz00zz__multimediazd2midizd2); 
BgL_arg2523z00_4241 = BgL_res2832z00_4242; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1183z00_4240), BgL_arg2523z00_4241); } 
BgL_new1184z00_4239 = BgL_new1183z00_4240; } 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4239))->BgL_streamz00)=((obj_t)BgL_stream1112z00_3456),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4239))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_usleep1113z00_3457)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4239))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_writezd2byte1114zd2_3458)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4239))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_writezd2string1115zd2_3459)),BUNSPEC); 
((((BgL_midisinkz00_bglt)COBJECT(BgL_new1184z00_4239))->BgL_flushz00)=((obj_t)
((obj_t)BgL_flush1116z00_3460)),BUNSPEC); 
{ /* Llib/midi.scm 87 */
obj_t BgL_fun2522z00_4243;
BgL_fun2522z00_4243 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midisinkz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2522z00_4243)(BgL_fun2522z00_4243, 
((obj_t)BgL_new1184z00_4239), BEOA); } 
return BgL_new1184z00_4239;} } 

}



/* &<@anonymous:2563> */
obj_t BGl_z62zc3z04anonymousza32563ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3461)
{
{ /* Llib/midi.scm 87 */
return BGl_flushzd2outputzd2portzd2envzd2zz__r4_ports_6_10_1z00;} 

}



/* &lambda2562 */
obj_t BGl_z62lambda2562z62zz__multimediazd2midizd2(obj_t BgL_envz00_3462, obj_t BgL_oz00_3463, obj_t BgL_vz00_3464)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3463)))->BgL_flushz00)=((obj_t)
((obj_t)BgL_vz00_3464)),BUNSPEC);} 

}



/* &lambda2561 */
obj_t BGl_z62lambda2561z62zz__multimediazd2midizd2(obj_t BgL_envz00_3465, obj_t BgL_oz00_3466)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3466)))->BgL_flushz00);} 

}



/* &<@anonymous:2555> */
obj_t BGl_z62zc3z04anonymousza32555ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3467)
{
{ /* Llib/midi.scm 87 */
return BGl_proc3313z00zz__multimediazd2midizd2;} 

}



/* &lambda2554 */
obj_t BGl_z62lambda2554z62zz__multimediazd2midizd2(obj_t BgL_envz00_3468, obj_t BgL_oz00_3469, obj_t BgL_vz00_3470)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3469)))->BgL_writezd2stringzd2)=((obj_t)
((obj_t)BgL_vz00_3470)),BUNSPEC);} 

}



/* &lambda2553 */
obj_t BGl_z62lambda2553z62zz__multimediazd2midizd2(obj_t BgL_envz00_3471, obj_t BgL_oz00_3472)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3472)))->BgL_writezd2stringzd2);} 

}



/* &<@anonymous:2556> */
obj_t BGl_z62zc3z04anonymousza32556ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3473, obj_t BgL_opz00_3474, obj_t BgL_sz00_3475)
{
{ /* Llib/midi.scm 92 */
return 
BGl_writezd2stringzd2zz__r4_output_6_10_3z00(BgL_sz00_3475, BgL_opz00_3474);} 

}



/* &<@anonymous:2547> */
obj_t BGl_z62zc3z04anonymousza32547ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3476)
{
{ /* Llib/midi.scm 87 */
return BGl_proc3314z00zz__multimediazd2midizd2;} 

}



/* &lambda2546 */
obj_t BGl_z62lambda2546z62zz__multimediazd2midizd2(obj_t BgL_envz00_3477, obj_t BgL_oz00_3478, obj_t BgL_vz00_3479)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3478)))->BgL_writezd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3479)),BUNSPEC);} 

}



/* &lambda2545 */
obj_t BGl_z62lambda2545z62zz__multimediazd2midizd2(obj_t BgL_envz00_3480, obj_t BgL_oz00_3481)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3481)))->BgL_writezd2bytezd2);} 

}



/* &<@anonymous:2548> */
obj_t BGl_z62zc3z04anonymousza32548ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3482, obj_t BgL_opz00_3483, obj_t BgL_bz00_3484)
{
{ /* Llib/midi.scm 91 */
{ /* Llib/midi.scm 91 */
unsigned char BgL_bytez00_4253;
BgL_bytez00_4253 = 
(unsigned char)CINT(BgL_bz00_3484); 
{ /* Llib/midi.scm 91 */
obj_t BgL_tmpz00_7525;
BgL_tmpz00_7525 = 
((obj_t)BgL_opz00_3483); 
return 
bgl_display_char(BgL_bytez00_4253, BgL_tmpz00_7525);} } } 

}



/* &<@anonymous:2540> */
obj_t BGl_z62zc3z04anonymousza32540ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3485)
{
{ /* Llib/midi.scm 87 */
return BGl_sleepzd2envzd2zz__osz00;} 

}



/* &lambda2539 */
obj_t BGl_z62lambda2539z62zz__multimediazd2midizd2(obj_t BgL_envz00_3486, obj_t BgL_oz00_3487, obj_t BgL_vz00_3488)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3487)))->BgL_usleepz00)=((obj_t)
((obj_t)BgL_vz00_3488)),BUNSPEC);} 

}



/* &lambda2538 */
obj_t BGl_z62lambda2538z62zz__multimediazd2midizd2(obj_t BgL_envz00_3489, obj_t BgL_oz00_3490)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3490)))->BgL_usleepz00);} 

}



/* &<@anonymous:2533> */
obj_t BGl_z62zc3z04anonymousza32533ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3491)
{
{ /* Llib/midi.scm 87 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2532 */
obj_t BGl_z62lambda2532z62zz__multimediazd2midizd2(obj_t BgL_envz00_3492, obj_t BgL_oz00_3493, obj_t BgL_vz00_3494)
{
{ /* Llib/midi.scm 87 */
return 
((((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3493)))->BgL_streamz00)=((obj_t)BgL_vz00_3494),BUNSPEC);} 

}



/* &lambda2531 */
obj_t BGl_z62lambda2531z62zz__multimediazd2midizd2(obj_t BgL_envz00_3495, obj_t BgL_oz00_3496)
{
{ /* Llib/midi.scm 87 */
return 
(((BgL_midisinkz00_bglt)COBJECT(
((BgL_midisinkz00_bglt)BgL_oz00_3496)))->BgL_streamz00);} 

}



/* &<@anonymous:2317> */
obj_t BGl_z62zc3z04anonymousza32317ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3497, obj_t BgL_new1110z00_3498)
{
{ /* Llib/midi.scm 52 */
{ 
BgL_midiplayerz00_bglt BgL_auxz00_7538;
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_errz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_cdelayz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_noteoffz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_noteonz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_aftertouchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_ctrlchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_prgmchangez00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_afterzd2touchzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_pitchz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_sysexz00)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2seqnumzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2textzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2copyrightzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2trackzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2instrumentzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2lyriczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2markerzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2cuezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2prgmnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2devnamezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2channprefzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2midiportzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2eotzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2tempozd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2smtpezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2timesigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2keysigzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498)))->BgL_metazd2seqspeczd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7538 = 
((BgL_midiplayerz00_bglt)BgL_new1110z00_3498); 
return 
((obj_t)BgL_auxz00_7538);} } 

}



/* &lambda2315 */
BgL_midiplayerz00_bglt BGl_z62lambda2315z62zz__multimediazd2midizd2(obj_t BgL_envz00_3499)
{
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1109z00_4260;
BgL_new1109z00_4260 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2316z00_4261;
{ /* Llib/midi.scm 52 */
long BgL_res2831z00_4262;
BgL_res2831z00_4262 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg2316z00_4261 = BgL_res2831z00_4262; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1109z00_4260), BgL_arg2316z00_4261); } 
return BgL_new1109z00_4260;} } 

}



/* &lambda2312 */
BgL_midiplayerz00_bglt BGl_z62lambda2312z62zz__multimediazd2midizd2(obj_t BgL_envz00_3500, obj_t BgL_err1081z00_3501, obj_t BgL_cdelay1082z00_3502, obj_t BgL_noteoff1083z00_3503, obj_t BgL_noteon1084z00_3504, obj_t BgL_aftertouch1085z00_3505, obj_t BgL_ctrlchange1086z00_3506, obj_t BgL_prgmchange1087z00_3507, obj_t BgL_afterzd2touch1088zd2_3508, obj_t BgL_pitch1089z00_3509, obj_t BgL_sysex1090z00_3510, obj_t BgL_metazd2seqnum1091zd2_3511, obj_t BgL_metazd2text1092zd2_3512, obj_t BgL_metazd2copyright1093zd2_3513, obj_t BgL_metazd2track1094zd2_3514, obj_t BgL_metazd2instrument1095zd2_3515, obj_t BgL_metazd2lyric1096zd2_3516, obj_t BgL_metazd2marker1097zd2_3517, obj_t BgL_metazd2cue1098zd2_3518, obj_t BgL_metazd2prgmname1099zd2_3519, obj_t BgL_metazd2devname1100zd2_3520, obj_t BgL_metazd2channpref1101zd2_3521, obj_t BgL_metazd2midiport1102zd2_3522, obj_t BgL_metazd2eot1103zd2_3523, obj_t BgL_metazd2tempo1104zd2_3524, obj_t BgL_metazd2smtpe1105zd2_3525, obj_t BgL_metazd2timesig1106zd2_3526, obj_t BgL_metazd2keysig1107zd2_3527, obj_t BgL_metazd2seqspec1108zd2_3528)
{
{ /* Llib/midi.scm 52 */
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1182z00_4291;
{ /* Llib/midi.scm 52 */
BgL_midiplayerz00_bglt BgL_new1181z00_4292;
BgL_new1181z00_4292 = 
((BgL_midiplayerz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiplayerz00_bgl) ))); 
{ /* Llib/midi.scm 52 */
long BgL_arg2314z00_4293;
{ /* Llib/midi.scm 52 */
long BgL_res2830z00_4294;
BgL_res2830z00_4294 = 
BGL_CLASS_INDEX(BGl_midiplayerz00zz__multimediazd2midizd2); 
BgL_arg2314z00_4293 = BgL_res2830z00_4294; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1181z00_4292), BgL_arg2314z00_4293); } 
BgL_new1182z00_4291 = BgL_new1181z00_4292; } 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_errz00)=((obj_t)
((obj_t)BgL_err1081z00_3501)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_cdelay1082z00_3502)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_noteoff1083z00_3503)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_noteon1084z00_3504)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_aftertouch1085z00_3505)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_ctrlchange1086z00_3506)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_prgmchange1087z00_3507)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_afterzd2touch1088zd2_3508)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_pitch1089z00_3509)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_sysex1090z00_3510)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_metazd2seqnum1091zd2_3511)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_metazd2text1092zd2_3512)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_metazd2copyright1093zd2_3513)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_metazd2track1094zd2_3514)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_metazd2instrument1095zd2_3515)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_metazd2lyric1096zd2_3516)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_metazd2marker1097zd2_3517)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_metazd2cue1098zd2_3518)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_metazd2prgmname1099zd2_3519)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_metazd2devname1100zd2_3520)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_metazd2channpref1101zd2_3521)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_metazd2midiport1102zd2_3522)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_metazd2eot1103zd2_3523)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_metazd2tempo1104zd2_3524)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_metazd2smtpe1105zd2_3525)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_metazd2timesig1106zd2_3526)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_metazd2keysig1107zd2_3527)),BUNSPEC); 
((((BgL_midiplayerz00_bglt)COBJECT(BgL_new1182z00_4291))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_metazd2seqspec1108zd2_3528)),BUNSPEC); 
{ /* Llib/midi.scm 52 */
obj_t BgL_fun2313z00_4295;
BgL_fun2313z00_4295 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiplayerz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2313z00_4295)(BgL_fun2313z00_4295, 
((obj_t)BgL_new1182z00_4291), BEOA); } 
return BgL_new1182z00_4291;} } 

}



/* &<@anonymous:2515> */
obj_t BGl_z62zc3z04anonymousza32515ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3529)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2514 */
obj_t BGl_z62lambda2514z62zz__multimediazd2midizd2(obj_t BgL_envz00_3530, obj_t BgL_oz00_3531, obj_t BgL_vz00_3532)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3531)))->BgL_metazd2seqspeczd2)=((obj_t)
((obj_t)BgL_vz00_3532)),BUNSPEC);} 

}



/* &lambda2513 */
obj_t BGl_z62lambda2513z62zz__multimediazd2midizd2(obj_t BgL_envz00_3533, obj_t BgL_oz00_3534)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3534)))->BgL_metazd2seqspeczd2);} 

}



/* &<@anonymous:2508> */
obj_t BGl_z62zc3z04anonymousza32508ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3535)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2507 */
obj_t BGl_z62lambda2507z62zz__multimediazd2midizd2(obj_t BgL_envz00_3536, obj_t BgL_oz00_3537, obj_t BgL_vz00_3538)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3537)))->BgL_metazd2keysigzd2)=((obj_t)
((obj_t)BgL_vz00_3538)),BUNSPEC);} 

}



/* &lambda2506 */
obj_t BGl_z62lambda2506z62zz__multimediazd2midizd2(obj_t BgL_envz00_3539, obj_t BgL_oz00_3540)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3540)))->BgL_metazd2keysigzd2);} 

}



/* &<@anonymous:2500> */
obj_t BGl_z62zc3z04anonymousza32500ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3541)
{
{ /* Llib/midi.scm 52 */
return BGl_proc3315z00zz__multimediazd2midizd2;} 

}



/* &lambda2499 */
obj_t BGl_z62lambda2499z62zz__multimediazd2midizd2(obj_t BgL_envz00_3542, obj_t BgL_oz00_3543, obj_t BgL_vz00_3544)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3543)))->BgL_metazd2timesigzd2)=((obj_t)
((obj_t)BgL_vz00_3544)),BUNSPEC);} 

}



/* &lambda2498 */
obj_t BGl_z62lambda2498z62zz__multimediazd2midizd2(obj_t BgL_envz00_3545, obj_t BgL_oz00_3546)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3546)))->BgL_metazd2timesigzd2);} 

}



/* &<@anonymous:2501> */
obj_t BGl_z62zc3z04anonymousza32501ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3547, obj_t BgL_mpz00_3548, obj_t BgL_msz00_3549, obj_t BgL_tickz00_3550, obj_t BgL_nnz00_3551, obj_t BgL_ddz00_3552, obj_t BgL_ccz00_3553, obj_t BgL_bbz00_3554)
{
{ /* Llib/midi.scm 83 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:2492> */
obj_t BGl_z62zc3z04anonymousza32492ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3555)
{
{ /* Llib/midi.scm 52 */
return BGl_proc3316z00zz__multimediazd2midizd2;} 

}



/* &lambda2491 */
obj_t BGl_z62lambda2491z62zz__multimediazd2midizd2(obj_t BgL_envz00_3556, obj_t BgL_oz00_3557, obj_t BgL_vz00_3558)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3557)))->BgL_metazd2smtpezd2)=((obj_t)
((obj_t)BgL_vz00_3558)),BUNSPEC);} 

}



/* &lambda2490 */
obj_t BGl_z62lambda2490z62zz__multimediazd2midizd2(obj_t BgL_envz00_3559, obj_t BgL_oz00_3560)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3560)))->BgL_metazd2smtpezd2);} 

}



/* &<@anonymous:2493> */
obj_t BGl_z62zc3z04anonymousza32493ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3561, obj_t BgL_mpz00_3562, obj_t BgL_msz00_3563, obj_t BgL_tickz00_3564, obj_t BgL_hrz00_3565, obj_t BgL_mmz00_3566, obj_t BgL_sez00_3567, obj_t BgL_frz00_3568, obj_t BgL_ffz00_3569)
{
{ /* Llib/midi.scm 82 */
return 
BBOOL(((bool_t)0));} 

}



/* &<@anonymous:2485> */
obj_t BGl_z62zc3z04anonymousza32485ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3570)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2484 */
obj_t BGl_z62lambda2484z62zz__multimediazd2midizd2(obj_t BgL_envz00_3571, obj_t BgL_oz00_3572, obj_t BgL_vz00_3573)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3572)))->BgL_metazd2tempozd2)=((obj_t)
((obj_t)BgL_vz00_3573)),BUNSPEC);} 

}



/* &lambda2483 */
obj_t BGl_z62lambda2483z62zz__multimediazd2midizd2(obj_t BgL_envz00_3574, obj_t BgL_oz00_3575)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3575)))->BgL_metazd2tempozd2);} 

}



/* &<@anonymous:2478> */
obj_t BGl_z62zc3z04anonymousza32478ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3576)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2477 */
obj_t BGl_z62lambda2477z62zz__multimediazd2midizd2(obj_t BgL_envz00_3577, obj_t BgL_oz00_3578, obj_t BgL_vz00_3579)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3578)))->BgL_metazd2eotzd2)=((obj_t)
((obj_t)BgL_vz00_3579)),BUNSPEC);} 

}



/* &lambda2476 */
obj_t BGl_z62lambda2476z62zz__multimediazd2midizd2(obj_t BgL_envz00_3580, obj_t BgL_oz00_3581)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3581)))->BgL_metazd2eotzd2);} 

}



/* &<@anonymous:2471> */
obj_t BGl_z62zc3z04anonymousza32471ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3582)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2470 */
obj_t BGl_z62lambda2470z62zz__multimediazd2midizd2(obj_t BgL_envz00_3583, obj_t BgL_oz00_3584, obj_t BgL_vz00_3585)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3584)))->BgL_metazd2midiportzd2)=((obj_t)
((obj_t)BgL_vz00_3585)),BUNSPEC);} 

}



/* &lambda2469 */
obj_t BGl_z62lambda2469z62zz__multimediazd2midizd2(obj_t BgL_envz00_3586, obj_t BgL_oz00_3587)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3587)))->BgL_metazd2midiportzd2);} 

}



/* &<@anonymous:2464> */
obj_t BGl_z62zc3z04anonymousza32464ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3588)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2463 */
obj_t BGl_z62lambda2463z62zz__multimediazd2midizd2(obj_t BgL_envz00_3589, obj_t BgL_oz00_3590, obj_t BgL_vz00_3591)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3590)))->BgL_metazd2channprefzd2)=((obj_t)
((obj_t)BgL_vz00_3591)),BUNSPEC);} 

}



/* &lambda2462 */
obj_t BGl_z62lambda2462z62zz__multimediazd2midizd2(obj_t BgL_envz00_3592, obj_t BgL_oz00_3593)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3593)))->BgL_metazd2channprefzd2);} 

}



/* &<@anonymous:2457> */
obj_t BGl_z62zc3z04anonymousza32457ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3594)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2456 */
obj_t BGl_z62lambda2456z62zz__multimediazd2midizd2(obj_t BgL_envz00_3595, obj_t BgL_oz00_3596, obj_t BgL_vz00_3597)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3596)))->BgL_metazd2devnamezd2)=((obj_t)
((obj_t)BgL_vz00_3597)),BUNSPEC);} 

}



/* &lambda2455 */
obj_t BGl_z62lambda2455z62zz__multimediazd2midizd2(obj_t BgL_envz00_3598, obj_t BgL_oz00_3599)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3599)))->BgL_metazd2devnamezd2);} 

}



/* &<@anonymous:2450> */
obj_t BGl_z62zc3z04anonymousza32450ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3600)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2449 */
obj_t BGl_z62lambda2449z62zz__multimediazd2midizd2(obj_t BgL_envz00_3601, obj_t BgL_oz00_3602, obj_t BgL_vz00_3603)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3602)))->BgL_metazd2prgmnamezd2)=((obj_t)
((obj_t)BgL_vz00_3603)),BUNSPEC);} 

}



/* &lambda2448 */
obj_t BGl_z62lambda2448z62zz__multimediazd2midizd2(obj_t BgL_envz00_3604, obj_t BgL_oz00_3605)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3605)))->BgL_metazd2prgmnamezd2);} 

}



/* &<@anonymous:2443> */
obj_t BGl_z62zc3z04anonymousza32443ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3606)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2442 */
obj_t BGl_z62lambda2442z62zz__multimediazd2midizd2(obj_t BgL_envz00_3607, obj_t BgL_oz00_3608, obj_t BgL_vz00_3609)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3608)))->BgL_metazd2cuezd2)=((obj_t)
((obj_t)BgL_vz00_3609)),BUNSPEC);} 

}



/* &lambda2441 */
obj_t BGl_z62lambda2441z62zz__multimediazd2midizd2(obj_t BgL_envz00_3610, obj_t BgL_oz00_3611)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3611)))->BgL_metazd2cuezd2);} 

}



/* &<@anonymous:2436> */
obj_t BGl_z62zc3z04anonymousza32436ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3612)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2435 */
obj_t BGl_z62lambda2435z62zz__multimediazd2midizd2(obj_t BgL_envz00_3613, obj_t BgL_oz00_3614, obj_t BgL_vz00_3615)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3614)))->BgL_metazd2markerzd2)=((obj_t)
((obj_t)BgL_vz00_3615)),BUNSPEC);} 

}



/* &lambda2434 */
obj_t BGl_z62lambda2434z62zz__multimediazd2midizd2(obj_t BgL_envz00_3616, obj_t BgL_oz00_3617)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3617)))->BgL_metazd2markerzd2);} 

}



/* &<@anonymous:2429> */
obj_t BGl_z62zc3z04anonymousza32429ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3618)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2428 */
obj_t BGl_z62lambda2428z62zz__multimediazd2midizd2(obj_t BgL_envz00_3619, obj_t BgL_oz00_3620, obj_t BgL_vz00_3621)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3620)))->BgL_metazd2lyriczd2)=((obj_t)
((obj_t)BgL_vz00_3621)),BUNSPEC);} 

}



/* &lambda2427 */
obj_t BGl_z62lambda2427z62zz__multimediazd2midizd2(obj_t BgL_envz00_3622, obj_t BgL_oz00_3623)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3623)))->BgL_metazd2lyriczd2);} 

}



/* &<@anonymous:2422> */
obj_t BGl_z62zc3z04anonymousza32422ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3624)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2421 */
obj_t BGl_z62lambda2421z62zz__multimediazd2midizd2(obj_t BgL_envz00_3625, obj_t BgL_oz00_3626, obj_t BgL_vz00_3627)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3626)))->BgL_metazd2instrumentzd2)=((obj_t)
((obj_t)BgL_vz00_3627)),BUNSPEC);} 

}



/* &lambda2420 */
obj_t BGl_z62lambda2420z62zz__multimediazd2midizd2(obj_t BgL_envz00_3628, obj_t BgL_oz00_3629)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3629)))->BgL_metazd2instrumentzd2);} 

}



/* &<@anonymous:2415> */
obj_t BGl_z62zc3z04anonymousza32415ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3630)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2414 */
obj_t BGl_z62lambda2414z62zz__multimediazd2midizd2(obj_t BgL_envz00_3631, obj_t BgL_oz00_3632, obj_t BgL_vz00_3633)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3632)))->BgL_metazd2trackzd2)=((obj_t)
((obj_t)BgL_vz00_3633)),BUNSPEC);} 

}



/* &lambda2413 */
obj_t BGl_z62lambda2413z62zz__multimediazd2midizd2(obj_t BgL_envz00_3634, obj_t BgL_oz00_3635)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3635)))->BgL_metazd2trackzd2);} 

}



/* &<@anonymous:2408> */
obj_t BGl_z62zc3z04anonymousza32408ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3636)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2407 */
obj_t BGl_z62lambda2407z62zz__multimediazd2midizd2(obj_t BgL_envz00_3637, obj_t BgL_oz00_3638, obj_t BgL_vz00_3639)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3638)))->BgL_metazd2copyrightzd2)=((obj_t)
((obj_t)BgL_vz00_3639)),BUNSPEC);} 

}



/* &lambda2406 */
obj_t BGl_z62lambda2406z62zz__multimediazd2midizd2(obj_t BgL_envz00_3640, obj_t BgL_oz00_3641)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3641)))->BgL_metazd2copyrightzd2);} 

}



/* &<@anonymous:2401> */
obj_t BGl_z62zc3z04anonymousza32401ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3642)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2400 */
obj_t BGl_z62lambda2400z62zz__multimediazd2midizd2(obj_t BgL_envz00_3643, obj_t BgL_oz00_3644, obj_t BgL_vz00_3645)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3644)))->BgL_metazd2textzd2)=((obj_t)
((obj_t)BgL_vz00_3645)),BUNSPEC);} 

}



/* &lambda2399 */
obj_t BGl_z62lambda2399z62zz__multimediazd2midizd2(obj_t BgL_envz00_3646, obj_t BgL_oz00_3647)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3647)))->BgL_metazd2textzd2);} 

}



/* &<@anonymous:2394> */
obj_t BGl_z62zc3z04anonymousza32394ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3648)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ignorezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2393 */
obj_t BGl_z62lambda2393z62zz__multimediazd2midizd2(obj_t BgL_envz00_3649, obj_t BgL_oz00_3650, obj_t BgL_vz00_3651)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3650)))->BgL_metazd2seqnumzd2)=((obj_t)
((obj_t)BgL_vz00_3651)),BUNSPEC);} 

}



/* &lambda2392 */
obj_t BGl_z62lambda2392z62zz__multimediazd2midizd2(obj_t BgL_envz00_3652, obj_t BgL_oz00_3653)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3653)))->BgL_metazd2seqnumzd2);} 

}



/* &<@anonymous:2387> */
obj_t BGl_z62zc3z04anonymousza32387ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3654)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2sysexzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2386 */
obj_t BGl_z62lambda2386z62zz__multimediazd2midizd2(obj_t BgL_envz00_3655, obj_t BgL_oz00_3656, obj_t BgL_vz00_3657)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3656)))->BgL_sysexz00)=((obj_t)
((obj_t)BgL_vz00_3657)),BUNSPEC);} 

}



/* &lambda2385 */
obj_t BGl_z62lambda2385z62zz__multimediazd2midizd2(obj_t BgL_envz00_3658, obj_t BgL_oz00_3659)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3659)))->BgL_sysexz00);} 

}



/* &<@anonymous:2380> */
obj_t BGl_z62zc3z04anonymousza32380ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3660)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2pitchzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2379 */
obj_t BGl_z62lambda2379z62zz__multimediazd2midizd2(obj_t BgL_envz00_3661, obj_t BgL_oz00_3662, obj_t BgL_vz00_3663)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3662)))->BgL_pitchz00)=((obj_t)
((obj_t)BgL_vz00_3663)),BUNSPEC);} 

}



/* &lambda2378 */
obj_t BGl_z62lambda2378z62zz__multimediazd2midizd2(obj_t BgL_envz00_3664, obj_t BgL_oz00_3665)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3665)))->BgL_pitchz00);} 

}



/* &<@anonymous:2373> */
obj_t BGl_z62zc3z04anonymousza32373ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3666)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2afterzd2touchzd2envzd2zz__multimediazd2midizd2;} 

}



/* &lambda2372 */
obj_t BGl_z62lambda2372z62zz__multimediazd2midizd2(obj_t BgL_envz00_3667, obj_t BgL_oz00_3668, obj_t BgL_vz00_3669)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3668)))->BgL_afterzd2touchzd2)=((obj_t)
((obj_t)BgL_vz00_3669)),BUNSPEC);} 

}



/* &lambda2371 */
obj_t BGl_z62lambda2371z62zz__multimediazd2midizd2(obj_t BgL_envz00_3670, obj_t BgL_oz00_3671)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3671)))->BgL_afterzd2touchzd2);} 

}



/* &<@anonymous:2366> */
obj_t BGl_z62zc3z04anonymousza32366ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3672)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2prgmchangezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2365 */
obj_t BGl_z62lambda2365z62zz__multimediazd2midizd2(obj_t BgL_envz00_3673, obj_t BgL_oz00_3674, obj_t BgL_vz00_3675)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3674)))->BgL_prgmchangez00)=((obj_t)
((obj_t)BgL_vz00_3675)),BUNSPEC);} 

}



/* &lambda2364 */
obj_t BGl_z62lambda2364z62zz__multimediazd2midizd2(obj_t BgL_envz00_3676, obj_t BgL_oz00_3677)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3677)))->BgL_prgmchangez00);} 

}



/* &<@anonymous:2359> */
obj_t BGl_z62zc3z04anonymousza32359ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3678)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2ctrlchangezd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2358 */
obj_t BGl_z62lambda2358z62zz__multimediazd2midizd2(obj_t BgL_envz00_3679, obj_t BgL_oz00_3680, obj_t BgL_vz00_3681)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3680)))->BgL_ctrlchangez00)=((obj_t)
((obj_t)BgL_vz00_3681)),BUNSPEC);} 

}



/* &lambda2357 */
obj_t BGl_z62lambda2357z62zz__multimediazd2midizd2(obj_t BgL_envz00_3682, obj_t BgL_oz00_3683)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3683)))->BgL_ctrlchangez00);} 

}



/* &<@anonymous:2352> */
obj_t BGl_z62zc3z04anonymousza32352ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3684)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2aftertouchzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2351 */
obj_t BGl_z62lambda2351z62zz__multimediazd2midizd2(obj_t BgL_envz00_3685, obj_t BgL_oz00_3686, obj_t BgL_vz00_3687)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3686)))->BgL_aftertouchz00)=((obj_t)
((obj_t)BgL_vz00_3687)),BUNSPEC);} 

}



/* &lambda2350 */
obj_t BGl_z62lambda2350z62zz__multimediazd2midizd2(obj_t BgL_envz00_3688, obj_t BgL_oz00_3689)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3689)))->BgL_aftertouchz00);} 

}



/* &<@anonymous:2345> */
obj_t BGl_z62zc3z04anonymousza32345ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3690)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteonzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2344 */
obj_t BGl_z62lambda2344z62zz__multimediazd2midizd2(obj_t BgL_envz00_3691, obj_t BgL_oz00_3692, obj_t BgL_vz00_3693)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3692)))->BgL_noteonz00)=((obj_t)
((obj_t)BgL_vz00_3693)),BUNSPEC);} 

}



/* &lambda2343 */
obj_t BGl_z62lambda2343z62zz__multimediazd2midizd2(obj_t BgL_envz00_3694, obj_t BgL_oz00_3695)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3695)))->BgL_noteonz00);} 

}



/* &<@anonymous:2338> */
obj_t BGl_z62zc3z04anonymousza32338ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3696)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2noteoffzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2337 */
obj_t BGl_z62lambda2337z62zz__multimediazd2midizd2(obj_t BgL_envz00_3697, obj_t BgL_oz00_3698, obj_t BgL_vz00_3699)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3698)))->BgL_noteoffz00)=((obj_t)
((obj_t)BgL_vz00_3699)),BUNSPEC);} 

}



/* &lambda2336 */
obj_t BGl_z62lambda2336z62zz__multimediazd2midizd2(obj_t BgL_envz00_3700, obj_t BgL_oz00_3701)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3701)))->BgL_noteoffz00);} 

}



/* &<@anonymous:2331> */
obj_t BGl_z62zc3z04anonymousza32331ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3702)
{
{ /* Llib/midi.scm 52 */
return BGl_midiplayerzd2cdelayzd2envz00zz__multimediazd2midizd2;} 

}



/* &lambda2330 */
obj_t BGl_z62lambda2330z62zz__multimediazd2midizd2(obj_t BgL_envz00_3703, obj_t BgL_oz00_3704, obj_t BgL_vz00_3705)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3704)))->BgL_cdelayz00)=((obj_t)
((obj_t)BgL_vz00_3705)),BUNSPEC);} 

}



/* &lambda2329 */
obj_t BGl_z62lambda2329z62zz__multimediazd2midizd2(obj_t BgL_envz00_3706, obj_t BgL_oz00_3707)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3707)))->BgL_cdelayz00);} 

}



/* &<@anonymous:2324> */
obj_t BGl_z62zc3z04anonymousza32324ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3708)
{
{ /* Llib/midi.scm 52 */
return BGl_errorzd2envzd2zz__errorz00;} 

}



/* &lambda2323 */
obj_t BGl_z62lambda2323z62zz__multimediazd2midizd2(obj_t BgL_envz00_3709, obj_t BgL_oz00_3710, obj_t BgL_vz00_3711)
{
{ /* Llib/midi.scm 52 */
return 
((((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3710)))->BgL_errz00)=((obj_t)
((obj_t)BgL_vz00_3711)),BUNSPEC);} 

}



/* &lambda2322 */
obj_t BGl_z62lambda2322z62zz__multimediazd2midizd2(obj_t BgL_envz00_3712, obj_t BgL_oz00_3713)
{
{ /* Llib/midi.scm 52 */
return 
(((BgL_midiplayerz00_bglt)COBJECT(
((BgL_midiplayerz00_bglt)BgL_oz00_3713)))->BgL_errz00);} 

}



/* &<@anonymous:2271> */
obj_t BGl_z62zc3z04anonymousza32271ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3714, obj_t BgL_new1079z00_3715)
{
{ /* Llib/midi.scm 42 */
{ 
BgL_midireaderz00_bglt BgL_auxz00_7809;
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3715)))->BgL_peekzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3715)))->BgL_readzd2bytezd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3715)))->BgL_readzd2int16zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3715)))->BgL_readzd2int32zd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3715)))->BgL_readzd2intzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3715)))->BgL_readzd2vlqzd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_new1079z00_3715)))->BgL_readzd2charszd2)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
BgL_auxz00_7809 = 
((BgL_midireaderz00_bglt)BgL_new1079z00_3715); 
return 
((obj_t)BgL_auxz00_7809);} } 

}



/* &lambda2269 */
BgL_midireaderz00_bglt BGl_z62lambda2269z62zz__multimediazd2midizd2(obj_t BgL_envz00_3716)
{
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1078z00_4381;
BgL_new1078z00_4381 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2270z00_4382;
{ /* Llib/midi.scm 42 */
long BgL_res2829z00_4383;
BgL_res2829z00_4383 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg2270z00_4382 = BgL_res2829z00_4383; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1078z00_4381), BgL_arg2270z00_4382); } 
return BgL_new1078z00_4381;} } 

}



/* &lambda2266 */
BgL_midireaderz00_bglt BGl_z62lambda2266z62zz__multimediazd2midizd2(obj_t BgL_envz00_3717, obj_t BgL_peekzd2byte1071zd2_3718, obj_t BgL_readzd2byte1072zd2_3719, obj_t BgL_readzd2int161073zd2_3720, obj_t BgL_readzd2int321074zd2_3721, obj_t BgL_readzd2int1075zd2_3722, obj_t BgL_readzd2vlq1076zd2_3723, obj_t BgL_readzd2chars1077zd2_3724)
{
{ /* Llib/midi.scm 42 */
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1180z00_4391;
{ /* Llib/midi.scm 42 */
BgL_midireaderz00_bglt BgL_new1179z00_4392;
BgL_new1179z00_4392 = 
((BgL_midireaderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midireaderz00_bgl) ))); 
{ /* Llib/midi.scm 42 */
long BgL_arg2268z00_4393;
{ /* Llib/midi.scm 42 */
long BgL_res2828z00_4394;
BgL_res2828z00_4394 = 
BGL_CLASS_INDEX(BGl_midireaderz00zz__multimediazd2midizd2); 
BgL_arg2268z00_4393 = BgL_res2828z00_4394; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1179z00_4392), BgL_arg2268z00_4393); } 
BgL_new1180z00_4391 = BgL_new1179z00_4392; } 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4391))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_peekzd2byte1071zd2_3718)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4391))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_readzd2byte1072zd2_3719)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4391))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_readzd2int161073zd2_3720)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4391))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_readzd2int321074zd2_3721)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4391))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_readzd2int1075zd2_3722)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4391))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_readzd2vlq1076zd2_3723)),BUNSPEC); 
((((BgL_midireaderz00_bglt)COBJECT(BgL_new1180z00_4391))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_readzd2chars1077zd2_3724)),BUNSPEC); 
{ /* Llib/midi.scm 42 */
obj_t BgL_fun2267z00_4395;
BgL_fun2267z00_4395 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midireaderz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2267z00_4395)(BgL_fun2267z00_4395, 
((obj_t)BgL_new1180z00_4391), BEOA); } 
return BgL_new1180z00_4391;} } 

}



/* &lambda2306 */
obj_t BGl_z62lambda2306z62zz__multimediazd2midizd2(obj_t BgL_envz00_3725, obj_t BgL_oz00_3726, obj_t BgL_vz00_3727)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3726)))->BgL_readzd2charszd2)=((obj_t)
((obj_t)BgL_vz00_3727)),BUNSPEC);} 

}



/* &lambda2305 */
obj_t BGl_z62lambda2305z62zz__multimediazd2midizd2(obj_t BgL_envz00_3728, obj_t BgL_oz00_3729)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3729)))->BgL_readzd2charszd2);} 

}



/* &lambda2301 */
obj_t BGl_z62lambda2301z62zz__multimediazd2midizd2(obj_t BgL_envz00_3730, obj_t BgL_oz00_3731, obj_t BgL_vz00_3732)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3731)))->BgL_readzd2vlqzd2)=((obj_t)
((obj_t)BgL_vz00_3732)),BUNSPEC);} 

}



/* &lambda2300 */
obj_t BGl_z62lambda2300z62zz__multimediazd2midizd2(obj_t BgL_envz00_3733, obj_t BgL_oz00_3734)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3734)))->BgL_readzd2vlqzd2);} 

}



/* &lambda2296 */
obj_t BGl_z62lambda2296z62zz__multimediazd2midizd2(obj_t BgL_envz00_3735, obj_t BgL_oz00_3736, obj_t BgL_vz00_3737)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3736)))->BgL_readzd2intzd2)=((obj_t)
((obj_t)BgL_vz00_3737)),BUNSPEC);} 

}



/* &lambda2295 */
obj_t BGl_z62lambda2295z62zz__multimediazd2midizd2(obj_t BgL_envz00_3738, obj_t BgL_oz00_3739)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3739)))->BgL_readzd2intzd2);} 

}



/* &lambda2291 */
obj_t BGl_z62lambda2291z62zz__multimediazd2midizd2(obj_t BgL_envz00_3740, obj_t BgL_oz00_3741, obj_t BgL_vz00_3742)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3741)))->BgL_readzd2int32zd2)=((obj_t)
((obj_t)BgL_vz00_3742)),BUNSPEC);} 

}



/* &lambda2290 */
obj_t BGl_z62lambda2290z62zz__multimediazd2midizd2(obj_t BgL_envz00_3743, obj_t BgL_oz00_3744)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3744)))->BgL_readzd2int32zd2);} 

}



/* &lambda2286 */
obj_t BGl_z62lambda2286z62zz__multimediazd2midizd2(obj_t BgL_envz00_3745, obj_t BgL_oz00_3746, obj_t BgL_vz00_3747)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3746)))->BgL_readzd2int16zd2)=((obj_t)
((obj_t)BgL_vz00_3747)),BUNSPEC);} 

}



/* &lambda2285 */
obj_t BGl_z62lambda2285z62zz__multimediazd2midizd2(obj_t BgL_envz00_3748, obj_t BgL_oz00_3749)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3749)))->BgL_readzd2int16zd2);} 

}



/* &lambda2281 */
obj_t BGl_z62lambda2281z62zz__multimediazd2midizd2(obj_t BgL_envz00_3750, obj_t BgL_oz00_3751, obj_t BgL_vz00_3752)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3751)))->BgL_readzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3752)),BUNSPEC);} 

}



/* &lambda2280 */
obj_t BGl_z62lambda2280z62zz__multimediazd2midizd2(obj_t BgL_envz00_3753, obj_t BgL_oz00_3754)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3754)))->BgL_readzd2bytezd2);} 

}



/* &lambda2276 */
obj_t BGl_z62lambda2276z62zz__multimediazd2midizd2(obj_t BgL_envz00_3755, obj_t BgL_oz00_3756, obj_t BgL_vz00_3757)
{
{ /* Llib/midi.scm 42 */
return 
((((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3756)))->BgL_peekzd2bytezd2)=((obj_t)
((obj_t)BgL_vz00_3757)),BUNSPEC);} 

}



/* &lambda2275 */
obj_t BGl_z62lambda2275z62zz__multimediazd2midizd2(obj_t BgL_envz00_3758, obj_t BgL_oz00_3759)
{
{ /* Llib/midi.scm 42 */
return 
(((BgL_midireaderz00_bglt)COBJECT(
((BgL_midireaderz00_bglt)BgL_oz00_3759)))->BgL_peekzd2bytezd2);} 

}



/* &<@anonymous:2165> */
obj_t BGl_z62zc3z04anonymousza32165ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3760, obj_t BgL_new1069z00_3761)
{
{ /* Llib/midi.scm 24 */
{ 
BgL_miditrackz00_bglt BgL_auxz00_7889;
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_z52streamz52)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_midireaderz00_bglt BgL_auxz00_7892;
{ /* Llib/midi.scm 24 */
obj_t BgL_classz00_4418;
BgL_classz00_4418 = BGl_midireaderz00zz__multimediazd2midizd2; 
{ /* Llib/midi.scm 24 */
obj_t BgL__ortest_1106z00_4419;
BgL__ortest_1106z00_4419 = 
BGL_CLASS_NIL(BgL_classz00_4418); 
if(
CBOOL(BgL__ortest_1106z00_4419))
{ /* Llib/midi.scm 24 */
BgL_auxz00_7892 = 
((BgL_midireaderz00_bglt)BgL__ortest_1106z00_4419)
; }  else 
{ /* Llib/midi.scm 24 */
BgL_auxz00_7892 = 
((BgL_midireaderz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4418))
; } } } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)BgL_auxz00_7892),BUNSPEC); } 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_z52closez52)=((obj_t)BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_z52eotz52)=((bool_t)((bool_t)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_z52wtickz52)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_z52statusz52)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_lenz00)=((int32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_ipz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_startz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_datastartz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_wtickz00)=((uint32_t)
0L),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_statusz00)=((long)((long)0)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_new1069z00_3761)))->BgL_eotz00)=((bool_t)((bool_t)0)),BUNSPEC); 
BgL_auxz00_7889 = 
((BgL_miditrackz00_bglt)BgL_new1069z00_3761); 
return 
((obj_t)BgL_auxz00_7889);} } 

}



/* &lambda2163 */
BgL_miditrackz00_bglt BGl_z62lambda2163z62zz__multimediazd2midizd2(obj_t BgL_envz00_3762)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1068z00_4420;
BgL_new1068z00_4420 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2164z00_4421;
{ /* Llib/midi.scm 24 */
long BgL_res2827z00_4422;
BgL_res2827z00_4422 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg2164z00_4421 = BgL_res2827z00_4422; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1068z00_4420), BgL_arg2164z00_4421); } 
return BgL_new1068z00_4420;} } 

}



/* &lambda2160 */
BgL_miditrackz00_bglt BGl_z62lambda2160z62zz__multimediazd2midizd2(obj_t BgL_envz00_3763, obj_t BgL_z52stream1054z52_3764, obj_t BgL_z52reader1055z52_3765, obj_t BgL_z52close1056z52_3766, obj_t BgL_z52eot1057z52_3767, obj_t BgL_z52wtick1058z52_3768, obj_t BgL_z52status1059z52_3769, obj_t BgL_len1060z00_3770, obj_t BgL_tempo1061z00_3771, obj_t BgL_ip1062z00_3772, obj_t BgL_start1063z00_3773, obj_t BgL_datastart1064z00_3774, obj_t BgL_wtick1065z00_3775, obj_t BgL_status1066z00_3776, obj_t BgL_eot1067z00_3777)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_z52eot1057z52_4425;uint32_t BgL_z52wtick1058z52_4426;long BgL_z52status1059z52_4427;int32_t BgL_len1060z00_4428;long BgL_tempo1061z00_4429;long BgL_start1063z00_4430;long BgL_datastart1064z00_4431;uint32_t BgL_wtick1065z00_4432;long BgL_status1066z00_4433;bool_t BgL_eot1067z00_4434;
BgL_z52eot1057z52_4425 = 
CBOOL(BgL_z52eot1057z52_3767); 
BgL_z52wtick1058z52_4426 = 
BGL_BUINT32_TO_UINT32(BgL_z52wtick1058z52_3768); 
BgL_z52status1059z52_4427 = 
(long)CINT(BgL_z52status1059z52_3769); 
BgL_len1060z00_4428 = 
BGL_BINT32_TO_INT32(BgL_len1060z00_3770); 
BgL_tempo1061z00_4429 = 
(long)CINT(BgL_tempo1061z00_3771); 
BgL_start1063z00_4430 = 
(long)CINT(BgL_start1063z00_3773); 
BgL_datastart1064z00_4431 = 
(long)CINT(BgL_datastart1064z00_3774); 
BgL_wtick1065z00_4432 = 
BGL_BUINT32_TO_UINT32(BgL_wtick1065z00_3775); 
BgL_status1066z00_4433 = 
(long)CINT(BgL_status1066z00_3776); 
BgL_eot1067z00_4434 = 
CBOOL(BgL_eot1067z00_3777); 
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1178z00_4435;
{ /* Llib/midi.scm 24 */
BgL_miditrackz00_bglt BgL_new1177z00_4436;
BgL_new1177z00_4436 = 
((BgL_miditrackz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_miditrackz00_bgl) ))); 
{ /* Llib/midi.scm 24 */
long BgL_arg2162z00_4437;
{ /* Llib/midi.scm 24 */
long BgL_res2826z00_4438;
BgL_res2826z00_4438 = 
BGL_CLASS_INDEX(BGl_miditrackz00zz__multimediazd2midizd2); 
BgL_arg2162z00_4437 = BgL_res2826z00_4438; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1177z00_4436), BgL_arg2162z00_4437); } 
BgL_new1178z00_4435 = BgL_new1177z00_4436; } 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_z52streamz52)=((obj_t)BgL_z52stream1054z52_3764),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_z52reader1055z52_3765)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_z52close1056z52_3766)),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_z52eotz52)=((bool_t)BgL_z52eot1057z52_4425),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_z52wtickz52)=((uint32_t)BgL_z52wtick1058z52_4426),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_z52statusz52)=((long)BgL_z52status1059z52_4427),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_lenz00)=((int32_t)BgL_len1060z00_4428),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_tempoz00)=((long)BgL_tempo1061z00_4429),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_ipz00)=((obj_t)BgL_ip1062z00_3772),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_startz00)=((long)BgL_start1063z00_4430),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_datastartz00)=((long)BgL_datastart1064z00_4431),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_wtickz00)=((uint32_t)BgL_wtick1065z00_4432),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_statusz00)=((long)BgL_status1066z00_4433),BUNSPEC); 
((((BgL_miditrackz00_bglt)COBJECT(BgL_new1178z00_4435))->BgL_eotz00)=((bool_t)BgL_eot1067z00_4434),BUNSPEC); 
{ /* Llib/midi.scm 24 */
obj_t BgL_fun2161z00_4439;
BgL_fun2161z00_4439 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_miditrackz00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2161z00_4439)(BgL_fun2161z00_4439, 
((obj_t)BgL_new1178z00_4435), BEOA); } 
return BgL_new1178z00_4435;} } } 

}



/* &<@anonymous:2260> */
obj_t BGl_z62zc3z04anonymousza32260ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3778)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2259 */
obj_t BGl_z62lambda2259z62zz__multimediazd2midizd2(obj_t BgL_envz00_3779, obj_t BgL_oz00_3780, obj_t BgL_vz00_3781)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4441;
BgL_vz00_4441 = 
CBOOL(BgL_vz00_3781); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3780)))->BgL_eotz00)=((bool_t)BgL_vz00_4441),BUNSPEC);} } 

}



/* &lambda2258 */
obj_t BGl_z62lambda2258z62zz__multimediazd2midizd2(obj_t BgL_envz00_3782, obj_t BgL_oz00_3783)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3783)))->BgL_eotz00));} 

}



/* &<@anonymous:2253> */
obj_t BGl_z62zc3z04anonymousza32253ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3784)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)-1));} 

}



/* &lambda2252 */
obj_t BGl_z62lambda2252z62zz__multimediazd2midizd2(obj_t BgL_envz00_3785, obj_t BgL_oz00_3786, obj_t BgL_vz00_3787)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4444;
BgL_vz00_4444 = 
(long)CINT(BgL_vz00_3787); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3786)))->BgL_statusz00)=((long)BgL_vz00_4444),BUNSPEC);} } 

}



/* &lambda2251 */
obj_t BGl_z62lambda2251z62zz__multimediazd2midizd2(obj_t BgL_envz00_3788, obj_t BgL_oz00_3789)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3789)))->BgL_statusz00));} 

}



/* &<@anonymous:2246> */
obj_t BGl_z62zc3z04anonymousza32246ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3790)
{
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 

}



/* &lambda2245 */
obj_t BGl_z62lambda2245z62zz__multimediazd2midizd2(obj_t BgL_envz00_3791, obj_t BgL_oz00_3792, obj_t BgL_vz00_3793)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4447;
BgL_vz00_4447 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3793); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3792)))->BgL_wtickz00)=((uint32_t)BgL_vz00_4447),BUNSPEC);} } 

}



/* &lambda2244 */
obj_t BGl_z62lambda2244z62zz__multimediazd2midizd2(obj_t BgL_envz00_3794, obj_t BgL_oz00_3795)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_7988;
BgL_tmpz00_7988 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3795)))->BgL_wtickz00); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_7988);} } 

}



/* &<@anonymous:2239> */
obj_t BGl_z62zc3z04anonymousza32239ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3796)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2238 */
obj_t BGl_z62lambda2238z62zz__multimediazd2midizd2(obj_t BgL_envz00_3797, obj_t BgL_oz00_3798, obj_t BgL_vz00_3799)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4450;
BgL_vz00_4450 = 
(long)CINT(BgL_vz00_3799); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3798)))->BgL_datastartz00)=((long)BgL_vz00_4450),BUNSPEC);} } 

}



/* &lambda2237 */
obj_t BGl_z62lambda2237z62zz__multimediazd2midizd2(obj_t BgL_envz00_3800, obj_t BgL_oz00_3801)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3801)))->BgL_datastartz00));} 

}



/* &<@anonymous:2232> */
obj_t BGl_z62zc3z04anonymousza32232ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3802)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2231 */
obj_t BGl_z62lambda2231z62zz__multimediazd2midizd2(obj_t BgL_envz00_3803, obj_t BgL_oz00_3804, obj_t BgL_vz00_3805)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4453;
BgL_vz00_4453 = 
(long)CINT(BgL_vz00_3805); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3804)))->BgL_startz00)=((long)BgL_vz00_4453),BUNSPEC);} } 

}



/* &lambda2230 */
obj_t BGl_z62lambda2230z62zz__multimediazd2midizd2(obj_t BgL_envz00_3806, obj_t BgL_oz00_3807)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3807)))->BgL_startz00));} 

}



/* &<@anonymous:2225> */
obj_t BGl_z62zc3z04anonymousza32225ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3808)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2224 */
obj_t BGl_z62lambda2224z62zz__multimediazd2midizd2(obj_t BgL_envz00_3809, obj_t BgL_oz00_3810, obj_t BgL_vz00_3811)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3810)))->BgL_ipz00)=((obj_t)BgL_vz00_3811),BUNSPEC);} 

}



/* &lambda2223 */
obj_t BGl_z62lambda2223z62zz__multimediazd2midizd2(obj_t BgL_envz00_3812, obj_t BgL_oz00_3813)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3813)))->BgL_ipz00);} 

}



/* &<@anonymous:2218> */
obj_t BGl_z62zc3z04anonymousza32218ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3814)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)500000));} 

}



/* &lambda2217 */
obj_t BGl_z62lambda2217z62zz__multimediazd2midizd2(obj_t BgL_envz00_3815, obj_t BgL_oz00_3816, obj_t BgL_vz00_3817)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4458;
BgL_vz00_4458 = 
(long)CINT(BgL_vz00_3817); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3816)))->BgL_tempoz00)=((long)BgL_vz00_4458),BUNSPEC);} } 

}



/* &lambda2216 */
obj_t BGl_z62lambda2216z62zz__multimediazd2midizd2(obj_t BgL_envz00_3818, obj_t BgL_oz00_3819)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3819)))->BgL_tempoz00));} 

}



/* &<@anonymous:2211> */
obj_t BGl_z62zc3z04anonymousza32211ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3820)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2210 */
obj_t BGl_z62lambda2210z62zz__multimediazd2midizd2(obj_t BgL_envz00_3821, obj_t BgL_oz00_3822, obj_t BgL_vz00_3823)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_vz00_4461;
BgL_vz00_4461 = 
BGL_BINT32_TO_INT32(BgL_vz00_3823); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3822)))->BgL_lenz00)=((int32_t)BgL_vz00_4461),BUNSPEC);} } 

}



/* &lambda2209 */
obj_t BGl_z62lambda2209z62zz__multimediazd2midizd2(obj_t BgL_envz00_3824, obj_t BgL_oz00_3825)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
int32_t BgL_tmpz00_8022;
BgL_tmpz00_8022 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3825)))->BgL_lenz00); 
return 
BGL_INT32_TO_BINT32(BgL_tmpz00_8022);} } 

}



/* &<@anonymous:2204> */
obj_t BGl_z62zc3z04anonymousza32204ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3826)
{
{ /* Llib/midi.scm 24 */
return 
BINT(((long)0));} 

}



/* &lambda2203 */
obj_t BGl_z62lambda2203z62zz__multimediazd2midizd2(obj_t BgL_envz00_3827, obj_t BgL_oz00_3828, obj_t BgL_vz00_3829)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
long BgL_vz00_4464;
BgL_vz00_4464 = 
(long)CINT(BgL_vz00_3829); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3828)))->BgL_z52statusz52)=((long)BgL_vz00_4464),BUNSPEC);} } 

}



/* &lambda2202 */
obj_t BGl_z62lambda2202z62zz__multimediazd2midizd2(obj_t BgL_envz00_3830, obj_t BgL_oz00_3831)
{
{ /* Llib/midi.scm 24 */
return 
BINT(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3831)))->BgL_z52statusz52));} 

}



/* &<@anonymous:2197> */
obj_t BGl_z62zc3z04anonymousza32197ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3832)
{
{ /* Llib/midi.scm 24 */
return 
BGL_UINT32_TO_BUINT32((uint32_t)(0));} 

}



/* &lambda2196 */
obj_t BGl_z62lambda2196z62zz__multimediazd2midizd2(obj_t BgL_envz00_3833, obj_t BgL_oz00_3834, obj_t BgL_vz00_3835)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_vz00_4467;
BgL_vz00_4467 = 
BGL_BUINT32_TO_UINT32(BgL_vz00_3835); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3834)))->BgL_z52wtickz52)=((uint32_t)BgL_vz00_4467),BUNSPEC);} } 

}



/* &lambda2195 */
obj_t BGl_z62lambda2195z62zz__multimediazd2midizd2(obj_t BgL_envz00_3836, obj_t BgL_oz00_3837)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
uint32_t BgL_tmpz00_8037;
BgL_tmpz00_8037 = 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3837)))->BgL_z52wtickz52); 
return 
BGL_UINT32_TO_BUINT32(BgL_tmpz00_8037);} } 

}



/* &<@anonymous:2190> */
obj_t BGl_z62zc3z04anonymousza32190ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3838)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2189 */
obj_t BGl_z62lambda2189z62zz__multimediazd2midizd2(obj_t BgL_envz00_3839, obj_t BgL_oz00_3840, obj_t BgL_vz00_3841)
{
{ /* Llib/midi.scm 24 */
{ /* Llib/midi.scm 24 */
bool_t BgL_vz00_4470;
BgL_vz00_4470 = 
CBOOL(BgL_vz00_3841); 
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3840)))->BgL_z52eotz52)=((bool_t)BgL_vz00_4470),BUNSPEC);} } 

}



/* &lambda2188 */
obj_t BGl_z62lambda2188z62zz__multimediazd2midizd2(obj_t BgL_envz00_3842, obj_t BgL_oz00_3843)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3843)))->BgL_z52eotz52));} 

}



/* &lambda2183 */
obj_t BGl_z62lambda2183z62zz__multimediazd2midizd2(obj_t BgL_envz00_3844, obj_t BgL_oz00_3845, obj_t BgL_vz00_3846)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3845)))->BgL_z52closez52)=((obj_t)
((obj_t)BgL_vz00_3846)),BUNSPEC);} 

}



/* &lambda2182 */
obj_t BGl_z62lambda2182z62zz__multimediazd2midizd2(obj_t BgL_envz00_3847, obj_t BgL_oz00_3848)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3848)))->BgL_z52closez52);} 

}



/* &lambda2177 */
obj_t BGl_z62lambda2177z62zz__multimediazd2midizd2(obj_t BgL_envz00_3849, obj_t BgL_oz00_3850, obj_t BgL_vz00_3851)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3850)))->BgL_z52readerz52)=((BgL_midireaderz00_bglt)
((BgL_midireaderz00_bglt)BgL_vz00_3851)),BUNSPEC);} 

}



/* &lambda2176 */
BgL_midireaderz00_bglt BGl_z62lambda2176z62zz__multimediazd2midizd2(obj_t BgL_envz00_3852, obj_t BgL_oz00_3853)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3853)))->BgL_z52readerz52);} 

}



/* &<@anonymous:2172> */
obj_t BGl_z62zc3z04anonymousza32172ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3854)
{
{ /* Llib/midi.scm 24 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda2171 */
obj_t BGl_z62lambda2171z62zz__multimediazd2midizd2(obj_t BgL_envz00_3855, obj_t BgL_oz00_3856, obj_t BgL_vz00_3857)
{
{ /* Llib/midi.scm 24 */
return 
((((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3856)))->BgL_z52streamz52)=((obj_t)BgL_vz00_3857),BUNSPEC);} 

}



/* &lambda2170 */
obj_t BGl_z62lambda2170z62zz__multimediazd2midizd2(obj_t BgL_envz00_3858, obj_t BgL_oz00_3859)
{
{ /* Llib/midi.scm 24 */
return 
(((BgL_miditrackz00_bglt)COBJECT(
((BgL_miditrackz00_bglt)BgL_oz00_3859)))->BgL_z52streamz52);} 

}



/* &<@anonymous:2128> */
obj_t BGl_z62zc3z04anonymousza32128ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3860, obj_t BgL_new1052z00_3861)
{
{ /* Llib/midi.scm 17 */
{ 
BgL_midiscorez00_bglt BgL_auxz00_8063;
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1052z00_3861)))->BgL_formatz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1052z00_3861)))->BgL_tempoz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1052z00_3861)))->BgL_ppqz00)=((long)((long)0)),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_new1052z00_3861)))->BgL_tracksz00)=((obj_t)
CNST_TABLE_REF(((long)75))),BUNSPEC); 
BgL_auxz00_8063 = 
((BgL_midiscorez00_bglt)BgL_new1052z00_3861); 
return 
((obj_t)BgL_auxz00_8063);} } 

}



/* &lambda2126 */
BgL_midiscorez00_bglt BGl_z62lambda2126z62zz__multimediazd2midizd2(obj_t BgL_envz00_3862)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1051z00_4481;
BgL_new1051z00_4481 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2127z00_4482;
{ /* Llib/midi.scm 17 */
long BgL_res2825z00_4483;
BgL_res2825z00_4483 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg2127z00_4482 = BgL_res2825z00_4483; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1051z00_4481), BgL_arg2127z00_4482); } 
return BgL_new1051z00_4481;} } 

}



/* &lambda2123 */
BgL_midiscorez00_bglt BGl_z62lambda2123z62zz__multimediazd2midizd2(obj_t BgL_envz00_3863, obj_t BgL_format1047z00_3864, obj_t BgL_tempo1048z00_3865, obj_t BgL_ppq1049z00_3866, obj_t BgL_tracks1050z00_3867)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_format1047z00_4484;long BgL_tempo1048z00_4485;long BgL_ppq1049z00_4486;
BgL_format1047z00_4484 = 
(long)CINT(BgL_format1047z00_3864); 
BgL_tempo1048z00_4485 = 
(long)CINT(BgL_tempo1048z00_3865); 
BgL_ppq1049z00_4486 = 
(long)CINT(BgL_ppq1049z00_3866); 
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1176z00_4488;
{ /* Llib/midi.scm 17 */
BgL_midiscorez00_bglt BgL_new1175z00_4489;
BgL_new1175z00_4489 = 
((BgL_midiscorez00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_midiscorez00_bgl) ))); 
{ /* Llib/midi.scm 17 */
long BgL_arg2125z00_4490;
{ /* Llib/midi.scm 17 */
long BgL_res2824z00_4491;
BgL_res2824z00_4491 = 
BGL_CLASS_INDEX(BGl_midiscorez00zz__multimediazd2midizd2); 
BgL_arg2125z00_4490 = BgL_res2824z00_4491; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1175z00_4489), BgL_arg2125z00_4490); } 
BgL_new1176z00_4488 = BgL_new1175z00_4489; } 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1176z00_4488))->BgL_formatz00)=((long)BgL_format1047z00_4484),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1176z00_4488))->BgL_tempoz00)=((long)BgL_tempo1048z00_4485),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1176z00_4488))->BgL_ppqz00)=((long)BgL_ppq1049z00_4486),BUNSPEC); 
((((BgL_midiscorez00_bglt)COBJECT(BgL_new1176z00_4488))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_tracks1050z00_3867)),BUNSPEC); 
{ /* Llib/midi.scm 17 */
obj_t BgL_fun2124z00_4492;
BgL_fun2124z00_4492 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_midiscorez00zz__multimediazd2midizd2); 
PROCEDURE_ENTRY(BgL_fun2124z00_4492)(BgL_fun2124z00_4492, 
((obj_t)BgL_new1176z00_4488), BEOA); } 
return BgL_new1176z00_4488;} } } 

}



/* &<@anonymous:2154> */
obj_t BGl_z62zc3z04anonymousza32154ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3868)
{
{ /* Llib/midi.scm 17 */
return 
CNST_TABLE_REF(((long)75));} 

}



/* &lambda2153 */
obj_t BGl_z62lambda2153z62zz__multimediazd2midizd2(obj_t BgL_envz00_3869, obj_t BgL_oz00_3870, obj_t BgL_vz00_3871)
{
{ /* Llib/midi.scm 17 */
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3870)))->BgL_tracksz00)=((obj_t)
((obj_t)BgL_vz00_3871)),BUNSPEC);} 

}



/* &lambda2152 */
obj_t BGl_z62lambda2152z62zz__multimediazd2midizd2(obj_t BgL_envz00_3872, obj_t BgL_oz00_3873)
{
{ /* Llib/midi.scm 17 */
return 
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3873)))->BgL_tracksz00);} 

}



/* &<@anonymous:2147> */
obj_t BGl_z62zc3z04anonymousza32147ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3874)
{
{ /* Llib/midi.scm 17 */
return 
BINT(((long)96));} 

}



/* &lambda2146 */
obj_t BGl_z62lambda2146z62zz__multimediazd2midizd2(obj_t BgL_envz00_3875, obj_t BgL_oz00_3876, obj_t BgL_vz00_3877)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4497;
BgL_vz00_4497 = 
(long)CINT(BgL_vz00_3877); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3876)))->BgL_ppqz00)=((long)BgL_vz00_4497),BUNSPEC);} } 

}



/* &lambda2145 */
obj_t BGl_z62lambda2145z62zz__multimediazd2midizd2(obj_t BgL_envz00_3878, obj_t BgL_oz00_3879)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3879)))->BgL_ppqz00));} 

}



/* &<@anonymous:2140> */
obj_t BGl_z62zc3z04anonymousza32140ze3ze5zz__multimediazd2midizd2(obj_t BgL_envz00_3880)
{
{ /* Llib/midi.scm 17 */
return 
BINT(((long)500000));} 

}



/* &lambda2139 */
obj_t BGl_z62lambda2139z62zz__multimediazd2midizd2(obj_t BgL_envz00_3881, obj_t BgL_oz00_3882, obj_t BgL_vz00_3883)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4500;
BgL_vz00_4500 = 
(long)CINT(BgL_vz00_3883); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3882)))->BgL_tempoz00)=((long)BgL_vz00_4500),BUNSPEC);} } 

}



/* &lambda2138 */
obj_t BGl_z62lambda2138z62zz__multimediazd2midizd2(obj_t BgL_envz00_3884, obj_t BgL_oz00_3885)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3885)))->BgL_tempoz00));} 

}



/* &lambda2133 */
obj_t BGl_z62lambda2133z62zz__multimediazd2midizd2(obj_t BgL_envz00_3886, obj_t BgL_oz00_3887, obj_t BgL_vz00_3888)
{
{ /* Llib/midi.scm 17 */
{ /* Llib/midi.scm 17 */
long BgL_vz00_4503;
BgL_vz00_4503 = 
(long)CINT(BgL_vz00_3888); 
return 
((((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3887)))->BgL_formatz00)=((long)BgL_vz00_4503),BUNSPEC);} } 

}



/* &lambda2132 */
obj_t BGl_z62lambda2132z62zz__multimediazd2midizd2(obj_t BgL_envz00_3889, obj_t BgL_oz00_3890)
{
{ /* Llib/midi.scm 17 */
return 
BINT(
(((BgL_midiscorez00_bglt)COBJECT(
((BgL_midiscorez00_bglt)BgL_oz00_3890)))->BgL_formatz00));} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3317z00zz__multimediazd2midizd2, BGl_midiscorez00zz__multimediazd2midizd2, BGl_string3318z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3319z00zz__multimediazd2midizd2, BGl_miditrackz00zz__multimediazd2midizd2, BGl_string3320z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3321z00zz__multimediazd2midizd2, BGl_midireaderz00zz__multimediazd2midizd2, BGl_string3322z00zz__multimediazd2midizd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3323z00zz__multimediazd2midizd2, BGl_midiplayerz00zz__multimediazd2midizd2, BGl_string3324z00zz__multimediazd2midizd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, BGl_proc3325z00zz__multimediazd2midizd2, BGl_midisinkz00zz__multimediazd2midizd2, BGl_string3326z00zz__multimediazd2midizd2);} 

}



/* &midisink-init1237 */
obj_t BGl_z62midisinkzd2init1237zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3906, obj_t BgL_msinkz00_3907)
{
{ /* Llib/midi.scm 987 */
return 
((obj_t)
((BgL_midisinkz00_bglt)BgL_msinkz00_3907));} 

}



/* &midiplayer-init1235 */
obj_t BGl_z62midiplayerzd2init1235zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3908, obj_t BgL_mplayerz00_3909)
{
{ /* Llib/midi.scm 981 */
return 
((obj_t)
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3909));} 

}



/* &midireader-init1233 */
obj_t BGl_z62midireaderzd2init1233zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3910, obj_t BgL_mreaderz00_3911)
{
{ /* Llib/midi.scm 975 */
return 
((obj_t)
((BgL_midireaderz00_bglt)BgL_mreaderz00_3911));} 

}



/* &miditrack-init1231 */
obj_t BGl_z62miditrackzd2init1231zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3912, obj_t BgL_mtrackz00_3913)
{
{ /* Llib/midi.scm 969 */
return 
((obj_t)
((BgL_miditrackz00_bglt)BgL_mtrackz00_3913));} 

}



/* &midiscore-init1229 */
obj_t BGl_z62midiscorezd2init1229zb0zz__multimediazd2midizd2(obj_t BgL_envz00_3914, obj_t BgL_mscorez00_3915)
{
{ /* Llib/midi.scm 963 */
return 
((obj_t)
((BgL_midiscorez00_bglt)BgL_mscorez00_3915));} 

}



/* midiscore-init */
BGL_EXPORTED_DEF obj_t BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_midiscorez00_bglt BgL_mscorez00_63)
{
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
obj_t BgL_method1230z00_1858;
{ /* Llib/midi.scm 963 */
obj_t BgL_res2844z00_2876;
{ /* Llib/midi.scm 963 */
long BgL_objzd2classzd2numz00_2841;
{ /* Llib/midi.scm 963 */
long BgL_res2834z00_2844;
BgL_res2834z00_2844 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mscorez00_63)); 
BgL_objzd2classzd2numz00_2841 = BgL_res2834z00_2844; } 
{ /* Llib/midi.scm 963 */
obj_t BgL_arg1759z00_2842;
BgL_arg1759z00_2842 = 
PROCEDURE_REF(BGl_midiscorezd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 963 */
int BgL_offsetz00_2846;
BgL_offsetz00_2846 = 
(int)(BgL_objzd2classzd2numz00_2841); 
{ /* Llib/midi.scm 963 */
long BgL_offsetz00_2847;
BgL_offsetz00_2847 = 
(
(long)(BgL_offsetz00_2846)-OBJECT_TYPE); 
{ /* Llib/midi.scm 963 */
long BgL_modz00_2848;
BgL_modz00_2848 = 
(BgL_offsetz00_2847 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 963 */
long BgL_restz00_2850;
BgL_restz00_2850 = 
(BgL_offsetz00_2847 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 963 */

{ /* Llib/midi.scm 963 */
obj_t BgL_bucketz00_2852;
BgL_bucketz00_2852 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_2842),BgL_modz00_2848); 
BgL_res2844z00_2876 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2852),BgL_restz00_2850); } } } } } } } } 
BgL_method1230z00_1858 = BgL_res2844z00_2876; } 
return 
PROCEDURE_ENTRY(BgL_method1230z00_1858)(BgL_method1230z00_1858, 
((obj_t)BgL_mscorez00_63), BEOA);} } 

}



/* &midiscore-init */
obj_t BGl_z62midiscorezd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3891, obj_t BgL_mscorez00_3892)
{
{ /* Llib/midi.scm 963 */
{ /* Llib/midi.scm 963 */
BgL_midiscorez00_bglt BgL_auxz00_8168;
if(
BGl_isazf3zf3zz__objectz00(BgL_mscorez00_3892, BGl_midiscorez00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 963 */
BgL_auxz00_8168 = 
((BgL_midiscorez00_bglt)BgL_mscorez00_3892)
; }  else 
{ 
obj_t BgL_auxz00_8172;
BgL_auxz00_8172 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)36209)), BGl_string3327z00zz__multimediazd2midizd2, BGl_string3095z00zz__multimediazd2midizd2, BgL_mscorez00_3892); 
FAILURE(BgL_auxz00_8172,BFALSE,BFALSE);} 
return 
BGl_midiscorezd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8168);} } 

}



/* miditrack-init */
BGL_EXPORTED_DEF obj_t BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_miditrackz00_bglt BgL_mtrackz00_64)
{
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
obj_t BgL_method1232z00_1859;
{ /* Llib/midi.scm 969 */
obj_t BgL_res2855z00_2913;
{ /* Llib/midi.scm 969 */
long BgL_objzd2classzd2numz00_2878;
{ /* Llib/midi.scm 969 */
long BgL_res2845z00_2881;
BgL_res2845z00_2881 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mtrackz00_64)); 
BgL_objzd2classzd2numz00_2878 = BgL_res2845z00_2881; } 
{ /* Llib/midi.scm 969 */
obj_t BgL_arg1759z00_2879;
BgL_arg1759z00_2879 = 
PROCEDURE_REF(BGl_miditrackzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 969 */
int BgL_offsetz00_2883;
BgL_offsetz00_2883 = 
(int)(BgL_objzd2classzd2numz00_2878); 
{ /* Llib/midi.scm 969 */
long BgL_offsetz00_2884;
BgL_offsetz00_2884 = 
(
(long)(BgL_offsetz00_2883)-OBJECT_TYPE); 
{ /* Llib/midi.scm 969 */
long BgL_modz00_2885;
BgL_modz00_2885 = 
(BgL_offsetz00_2884 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 969 */
long BgL_restz00_2887;
BgL_restz00_2887 = 
(BgL_offsetz00_2884 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 969 */

{ /* Llib/midi.scm 969 */
obj_t BgL_bucketz00_2889;
BgL_bucketz00_2889 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_2879),BgL_modz00_2885); 
BgL_res2855z00_2913 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2889),BgL_restz00_2887); } } } } } } } } 
BgL_method1232z00_1859 = BgL_res2855z00_2913; } 
return 
PROCEDURE_ENTRY(BgL_method1232z00_1859)(BgL_method1232z00_1859, 
((obj_t)BgL_mtrackz00_64), BEOA);} } 

}



/* &miditrack-init */
obj_t BGl_z62miditrackzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3893, obj_t BgL_mtrackz00_3894)
{
{ /* Llib/midi.scm 969 */
{ /* Llib/midi.scm 969 */
BgL_miditrackz00_bglt BgL_auxz00_8207;
if(
BGl_isazf3zf3zz__objectz00(BgL_mtrackz00_3894, BGl_miditrackz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 969 */
BgL_auxz00_8207 = 
((BgL_miditrackz00_bglt)BgL_mtrackz00_3894)
; }  else 
{ 
obj_t BgL_auxz00_8211;
BgL_auxz00_8211 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)36494)), BGl_string3328z00zz__multimediazd2midizd2, BGl_string3117z00zz__multimediazd2midizd2, BgL_mtrackz00_3894); 
FAILURE(BgL_auxz00_8211,BFALSE,BFALSE);} 
return 
BGl_miditrackzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8207);} } 

}



/* midireader-init */
BGL_EXPORTED_DEF obj_t BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_midireaderz00_bglt BgL_mreaderz00_65)
{
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
obj_t BgL_method1234z00_1860;
{ /* Llib/midi.scm 975 */
obj_t BgL_res2866z00_2950;
{ /* Llib/midi.scm 975 */
long BgL_objzd2classzd2numz00_2915;
{ /* Llib/midi.scm 975 */
long BgL_res2856z00_2918;
BgL_res2856z00_2918 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mreaderz00_65)); 
BgL_objzd2classzd2numz00_2915 = BgL_res2856z00_2918; } 
{ /* Llib/midi.scm 975 */
obj_t BgL_arg1759z00_2916;
BgL_arg1759z00_2916 = 
PROCEDURE_REF(BGl_midireaderzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 975 */
int BgL_offsetz00_2920;
BgL_offsetz00_2920 = 
(int)(BgL_objzd2classzd2numz00_2915); 
{ /* Llib/midi.scm 975 */
long BgL_offsetz00_2921;
BgL_offsetz00_2921 = 
(
(long)(BgL_offsetz00_2920)-OBJECT_TYPE); 
{ /* Llib/midi.scm 975 */
long BgL_modz00_2922;
BgL_modz00_2922 = 
(BgL_offsetz00_2921 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 975 */
long BgL_restz00_2924;
BgL_restz00_2924 = 
(BgL_offsetz00_2921 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 975 */

{ /* Llib/midi.scm 975 */
obj_t BgL_bucketz00_2926;
BgL_bucketz00_2926 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_2916),BgL_modz00_2922); 
BgL_res2866z00_2950 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2926),BgL_restz00_2924); } } } } } } } } 
BgL_method1234z00_1860 = BgL_res2866z00_2950; } 
return 
PROCEDURE_ENTRY(BgL_method1234z00_1860)(BgL_method1234z00_1860, 
((obj_t)BgL_mreaderz00_65), BEOA);} } 

}



/* &midireader-init */
obj_t BGl_z62midireaderzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3895, obj_t BgL_mreaderz00_3896)
{
{ /* Llib/midi.scm 975 */
{ /* Llib/midi.scm 975 */
BgL_midireaderz00_bglt BgL_auxz00_8246;
if(
BGl_isazf3zf3zz__objectz00(BgL_mreaderz00_3896, BGl_midireaderz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 975 */
BgL_auxz00_8246 = 
((BgL_midireaderz00_bglt)BgL_mreaderz00_3896)
; }  else 
{ 
obj_t BgL_auxz00_8250;
BgL_auxz00_8250 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)36779)), BGl_string3329z00zz__multimediazd2midizd2, BGl_string3330z00zz__multimediazd2midizd2, BgL_mreaderz00_3896); 
FAILURE(BgL_auxz00_8250,BFALSE,BFALSE);} 
return 
BGl_midireaderzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8246);} } 

}



/* midiplayer-init */
BGL_EXPORTED_DEF obj_t BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_midiplayerz00_bglt BgL_mplayerz00_66)
{
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
obj_t BgL_method1236z00_1861;
{ /* Llib/midi.scm 981 */
obj_t BgL_res2877z00_2987;
{ /* Llib/midi.scm 981 */
long BgL_objzd2classzd2numz00_2952;
{ /* Llib/midi.scm 981 */
long BgL_res2867z00_2955;
BgL_res2867z00_2955 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_mplayerz00_66)); 
BgL_objzd2classzd2numz00_2952 = BgL_res2867z00_2955; } 
{ /* Llib/midi.scm 981 */
obj_t BgL_arg1759z00_2953;
BgL_arg1759z00_2953 = 
PROCEDURE_REF(BGl_midiplayerzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 981 */
int BgL_offsetz00_2957;
BgL_offsetz00_2957 = 
(int)(BgL_objzd2classzd2numz00_2952); 
{ /* Llib/midi.scm 981 */
long BgL_offsetz00_2958;
BgL_offsetz00_2958 = 
(
(long)(BgL_offsetz00_2957)-OBJECT_TYPE); 
{ /* Llib/midi.scm 981 */
long BgL_modz00_2959;
BgL_modz00_2959 = 
(BgL_offsetz00_2958 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 981 */
long BgL_restz00_2961;
BgL_restz00_2961 = 
(BgL_offsetz00_2958 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 981 */

{ /* Llib/midi.scm 981 */
obj_t BgL_bucketz00_2963;
BgL_bucketz00_2963 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_2953),BgL_modz00_2959); 
BgL_res2877z00_2987 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_2963),BgL_restz00_2961); } } } } } } } } 
BgL_method1236z00_1861 = BgL_res2877z00_2987; } 
return 
PROCEDURE_ENTRY(BgL_method1236z00_1861)(BgL_method1236z00_1861, 
((obj_t)BgL_mplayerz00_66), BEOA);} } 

}



/* &midiplayer-init */
obj_t BGl_z62midiplayerzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3897, obj_t BgL_mplayerz00_3898)
{
{ /* Llib/midi.scm 981 */
{ /* Llib/midi.scm 981 */
BgL_midiplayerz00_bglt BgL_auxz00_8285;
if(
BGl_isazf3zf3zz__objectz00(BgL_mplayerz00_3898, BGl_midiplayerz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 981 */
BgL_auxz00_8285 = 
((BgL_midiplayerz00_bglt)BgL_mplayerz00_3898)
; }  else 
{ 
obj_t BgL_auxz00_8289;
BgL_auxz00_8289 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37068)), BGl_string3331z00zz__multimediazd2midizd2, BGl_string3096z00zz__multimediazd2midizd2, BgL_mplayerz00_3898); 
FAILURE(BgL_auxz00_8289,BFALSE,BFALSE);} 
return 
BGl_midiplayerzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8285);} } 

}



/* midisink-init */
BGL_EXPORTED_DEF obj_t BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_midisinkz00_bglt BgL_msinkz00_67)
{
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
obj_t BgL_method1238z00_1862;
{ /* Llib/midi.scm 987 */
obj_t BgL_res2888z00_3024;
{ /* Llib/midi.scm 987 */
long BgL_objzd2classzd2numz00_2989;
{ /* Llib/midi.scm 987 */
long BgL_res2878z00_2992;
BgL_res2878z00_2992 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_msinkz00_67)); 
BgL_objzd2classzd2numz00_2989 = BgL_res2878z00_2992; } 
{ /* Llib/midi.scm 987 */
obj_t BgL_arg1759z00_2990;
BgL_arg1759z00_2990 = 
PROCEDURE_REF(BGl_midisinkzd2initzd2envz00zz__multimediazd2midizd2, 
(int)(((long)1))); 
{ /* Llib/midi.scm 987 */
int BgL_offsetz00_2994;
BgL_offsetz00_2994 = 
(int)(BgL_objzd2classzd2numz00_2989); 
{ /* Llib/midi.scm 987 */
long BgL_offsetz00_2995;
BgL_offsetz00_2995 = 
(
(long)(BgL_offsetz00_2994)-OBJECT_TYPE); 
{ /* Llib/midi.scm 987 */
long BgL_modz00_2996;
BgL_modz00_2996 = 
(BgL_offsetz00_2995 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/midi.scm 987 */
long BgL_restz00_2998;
BgL_restz00_2998 = 
(BgL_offsetz00_2995 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/midi.scm 987 */

{ /* Llib/midi.scm 987 */
obj_t BgL_bucketz00_3000;
BgL_bucketz00_3000 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_2990),BgL_modz00_2996); 
BgL_res2888z00_3024 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3000),BgL_restz00_2998); } } } } } } } } 
BgL_method1238z00_1862 = BgL_res2888z00_3024; } 
return 
PROCEDURE_ENTRY(BgL_method1238z00_1862)(BgL_method1238z00_1862, 
((obj_t)BgL_msinkz00_67), BEOA);} } 

}



/* &midisink-init */
obj_t BGl_z62midisinkzd2initzb0zz__multimediazd2midizd2(obj_t BgL_envz00_3899, obj_t BgL_msinkz00_3900)
{
{ /* Llib/midi.scm 987 */
{ /* Llib/midi.scm 987 */
BgL_midisinkz00_bglt BgL_auxz00_8324;
if(
BGl_isazf3zf3zz__objectz00(BgL_msinkz00_3900, BGl_midisinkz00zz__multimediazd2midizd2))
{ /* Llib/midi.scm 987 */
BgL_auxz00_8324 = 
((BgL_midisinkz00_bglt)BgL_msinkz00_3900)
; }  else 
{ 
obj_t BgL_auxz00_8328;
BgL_auxz00_8328 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3084z00zz__multimediazd2midizd2, 
BINT(((long)37357)), BGl_string3332z00zz__multimediazd2midizd2, BGl_string3097z00zz__multimediazd2midizd2, BgL_msinkz00_3900); 
FAILURE(BgL_auxz00_8328,BFALSE,BFALSE);} 
return 
BGl_midisinkzd2initzd2zz__multimediazd2midizd2(BgL_auxz00_8324);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2midizd2()
{
{ /* Llib/midi.scm 15 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
