/*===========================================================================*/
/*   (Llib/mpd.scm)                                                          */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -unsafe -safee -copt -fPIC -copt -IUnix Llib/mpd.scm -o objs/mpd.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_musicz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_onstatez00;
   obj_t BgL_onvolumez00;
   obj_t BgL_onerrorz00;
   obj_t BgL_oneventz00;
   obj_t BgL_z52mutexz52;
   struct BgL_musicstatusz00_bgl * BgL_z52statusz52;
} *BgL_musicz00_bglt;

typedef struct BgL_musicstatusz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_statez00;
   obj_t BgL_volumez00;
   bool_t BgL_repeatz00;
   bool_t BgL_randomz00;
   int BgL_playlistidz00;
   int BgL_playlistlengthz00;
   int BgL_xfadez00;
   int BgL_songz00;
   int BgL_songidz00;
   obj_t BgL_songposz00;
   int BgL_songlengthz00;
   int BgL_bitratez00;
   int BgL_khza7za7;
   obj_t BgL_errz00;
   int BgL_bufferingz00;
} *BgL_musicstatusz00_bglt;

typedef struct BgL_musictagz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_titlez00;
   obj_t BgL_artistz00;
   obj_t BgL_interpretz00;
   obj_t BgL_albumz00;
   int BgL_trackz00;
   int BgL_yearz00;
   obj_t BgL_genrez00;
   obj_t BgL_commentz00;
   obj_t BgL_ufidz00;
   obj_t BgL_copyrightz00;
   obj_t BgL_picturez00;
} *BgL_musictagz00_bglt;

typedef struct BgL_musicinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   long BgL_sampleratez00;
   int BgL_channelsz00;
   int BgL_bpsz00;
   long BgL_durationz00;
} *BgL_musicinfoz00_bglt;

typedef struct BgL_mpdzd2databasezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_directoriesz00;
   obj_t BgL_suffixesz00;
   obj_t BgL_z52basez52;
   obj_t BgL_z52artistsz52;
   obj_t BgL_z52albumsz52;
   obj_t BgL_z52genresz52;
   obj_t BgL_z52nartistsz52;
   int BgL_z52nalbumsz52;
   int BgL_z52nsongsz52;
   obj_t BgL_z52uptimez52;
   obj_t BgL_z52dbzd2updatez80;
} *BgL_mpdzd2databasezd2_bglt;


static obj_t BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_directory_to_list(char *);
extern obj_t BGl_musiczd2nextzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_search1341ze70ze7zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
static obj_t BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, int, obj_t, obj_t);
static obj_t BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32649ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT bool_t bigloo_strcicmp(obj_t, obj_t);
static obj_t BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32102ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_assocz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgen1363z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2skipzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_dirnamez00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_stringzd2containszd2zz__r4_strings_6_7z00(obj_t, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_IMPORT obj_t bstring_to_symbol(obj_t);
static obj_t BGl_z62zc3z04anonymousza32051ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_fprintfz00zz__r4_output_6_10_3z00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32303ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32052ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdz00zz__multimediazd2mpdzd2(BgL_musicz00_bglt, obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ti1377zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__multimediazd2mpdzd2();
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2pausezd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32038ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62mpdzd2databasezd2getarti1383z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getarti1387z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32039ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32323ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32129ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenr1381z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenr1385z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ar1371zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
static obj_t BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, BgL_musicz00_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32163ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern BgL_musicstatusz00_bglt BGl_musiczd2statuszd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32092ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_filezd2namezd2ze3listze3zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2hashtablezd2zz__hashz00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2listalb1355z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getinfofilez00zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t fexists(char *);
static obj_t BGl_z62zc3z04anonymousza32344ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_mpdzd2databasezd2_bglt BGl_z62lambda2311z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2linezd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2getzd2alb1393zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static BgL_mpdzd2databasezd2_bglt BGl_z62lambda2314z62zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32168ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
BGL_IMPORT long bgl_list_length(obj_t);
extern obj_t BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2321z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2322z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2();
static obj_t BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2328z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2329z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_zc3z04exitza32048ze3ze70z60zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2335z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2336z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
extern obj_t BGl_filezd2musictagzd2zz__multimediazd2id3zd2(obj_t);
static obj_t BGl_z62lambda2342z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2343z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2volumezd2getz00zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62lambda2349z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32365ze3ze5zz__multimediazd2mpdzd2(obj_t);
extern obj_t BGl_musictagz00zz__multimediazd2id3zd2;
static obj_t BGl_z62lambda2350z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2metazd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2356z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2357z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
static obj_t BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2363z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2364z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd21375zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = BUNSPEC;
static obj_t BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_z62lambda2370z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2371z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2377z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2378z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static bool_t BGl_loopze71ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static bool_t BGl_loopze72ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, bool_t, obj_t);
static bool_t BGl_loopze74ze7zz__multimediazd2mpdzd2(obj_t, BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_loopze75ze7zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
BGL_IMPORT long bgl_date_to_seconds(obj_t);
extern obj_t BGl_musiczd2seekzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t, obj_t);
static obj_t BGl_z62lambda2384z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2385z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(obj_t, long);
static obj_t BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2391z62zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2392z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32386ze3ze5zz__multimediazd2mpdzd2(obj_t);
extern obj_t BGl_musiczd2playzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
static obj_t BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2clearz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32001ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
static obj_t BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_search1333ze70ze7zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2initz121347z70zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t bgl_seconds_to_date(long);
static obj_t BGl_z62zc3z04anonymousza32200ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2();
static obj_t BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2(obj_t, obj_t);
extern obj_t BGl_musiczd2stopzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t BGl_musiczd2closedzf3z21zz__multimediazd2musiczd2(BgL_musicz00_bglt);
BGL_IMPORT obj_t BGl_hashtablezd2mapzd2zz__hashz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(obj_t, long);
static obj_t BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_basenamez00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_makezd2filezd2namez00zz__osz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, bool_t);
static obj_t BGl_zc3z04exitza32035ze3ze70z60zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t);
static obj_t BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2filezd2ze3p1349z53zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32330ze3ze5zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT obj_t BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
static obj_t BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2prevzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_current_seconds();
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, BgL_musicz00_bglt, obj_t, obj_t, obj_t);
extern obj_t BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(BgL_musicz00_bglt, int);
BGL_IMPORT obj_t BGl_callzd2withzd2outputzd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32316ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t);
static obj_t BGl__mpdz00zz__multimediazd2mpdzd2(obj_t, obj_t);
static long BGl_cmdnz00zz__multimediazd2mpdzd2;
static obj_t BGl_z62mpdzd2databasezd2lsinfo1367z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
BGL_IMPORT obj_t BGl_makezd2datezd2zz__datez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_classzd2constructorzd2zz__objectz00(obj_t);
BGL_IMPORT bool_t bigloo_string_lt(obj_t, obj_t);
static obj_t BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_list_ref(obj_t, long);
static obj_t BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32351ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32173ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mpdzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2id3zd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__datez00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__hashz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_musicz00zz__multimediazd2musiczd2;
static long BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2;
static obj_t BGl_z62zc3z04anonymousza32337ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_stringzd2indexzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_prefixz00zz__osz00(obj_t);
extern obj_t BGl_musicinfoz00zz__multimediazd2id3zd2;
static bool_t BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static bool_t BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2al1369zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_z62iozd2errorzb0zz__objectz00;
static obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2();
BGL_IMPORT obj_t BGl_makezd2filezd2pathz00zz__osz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
BGL_IMPORT bool_t bigloo_strcmp_at(obj_t, obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32372ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62mpdzd2databasezd2findzd2ge1379zb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listart1357z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT bool_t bgl_directoryp(char *);
static obj_t BGl_z62mpdzd2databasezd2stats1351z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32358ze3ze5zz__multimediazd2mpdzd2(obj_t);
extern int BGl_musiczd2songzd2zz__multimediazd2musiczd2(BgL_musicz00_bglt);
static obj_t BGl_z62mpdzd2databasezd2listart1365z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_hashtablezd2putz12zc0zz__hashz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2databasezd2listall1353z62zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
BGL_IMPORT long bgl_last_modification_time(char *);
static obj_t BGl_playlistinfoz00zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, int);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32393ze3ze5zz__multimediazd2mpdzd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32572ze3ze5zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt);
static bool_t BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(obj_t, obj_t, BgL_mpdzd2databasezd2_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32379ze3ze5zz__multimediazd2mpdzd2(obj_t);
static obj_t BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(obj_t);
BGL_IMPORT int BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 104 ] ;


DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playza7b03551za7, BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2seekidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2seekidza73552za7, BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2rmzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2rmza7b0za7za73553za7, BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3554z00, BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3555z00, BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3556z00, BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2updatezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2updateza73557za7, BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3400z00zz__multimediazd2mpdzd2, BgL_bgl_string3400za700za7za7_3558za7, "xfade: ", 7 );
DEFINE_STRING( BGl_string3401z00zz__multimediazd2mpdzd2, BgL_bgl_string3401za700za7za7_3559za7, ": ", 2 );
DEFINE_STRING( BGl_string3402z00zz__multimediazd2mpdzd2, BgL_bgl_string3402za700za7za7_3560za7, "wrong number of arguments: [3..6] expected, provided", 52 );
DEFINE_STRING( BGl_string3403z00zz__multimediazd2mpdzd2, BgL_bgl_string3403za700za7za7_3561za7, "http://", 7 );
DEFINE_STRING( BGl_string3404z00zz__multimediazd2mpdzd2, BgL_bgl_string3404za700za7za7_3562za7, "add", 3 );
DEFINE_STRING( BGl_string3405z00zz__multimediazd2mpdzd2, BgL_bgl_string3405za700za7za7_3563za7, "illegal uri \"~a\"", 16 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3564z00, BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3406z00zz__multimediazd2mpdzd2, BgL_bgl_string3406za700za7za7_3565za7, "file: ", 6 );
DEFINE_STRING( BGl_string3407z00zz__multimediazd2mpdzd2, BgL_bgl_string3407za700za7za7_3566za7, "Pos: ", 5 );
DEFINE_STRING( BGl_string3408z00zz__multimediazd2mpdzd2, BgL_bgl_string3408za700za7za7_3567za7, "Id: ", 4 );
DEFINE_STRING( BGl_string3409z00zz__multimediazd2mpdzd2, BgL_bgl_string3409za700za7za7_3568za7, "Artist: ", 8 );
DEFINE_STRING( BGl_string3410z00zz__multimediazd2mpdzd2, BgL_bgl_string3410za700za7za7_3569za7, "Title: ", 7 );
DEFINE_STRING( BGl_string3411z00zz__multimediazd2mpdzd2, BgL_bgl_string3411za700za7za7_3570za7, "Album: ", 7 );
DEFINE_STRING( BGl_string3412z00zz__multimediazd2mpdzd2, BgL_bgl_string3412za700za7za7_3571za7, "50@0", 4 );
DEFINE_STRING( BGl_string3413z00zz__multimediazd2mpdzd2, BgL_bgl_string3413za700za7za7_3572za7, "next", 4 );
DEFINE_STRING( BGl_string3414z00zz__multimediazd2mpdzd2, BgL_bgl_string3414za700za7za7_3573za7, "No more song", 12 );
DEFINE_STRING( BGl_string3415z00zz__multimediazd2mpdzd2, BgL_bgl_string3415za700za7za7_3574za7, "previous", 8 );
DEFINE_STRING( BGl_string3416z00zz__multimediazd2mpdzd2, BgL_bgl_string3416za700za7za7_3575za7, "No previous song", 16 );
DEFINE_STRING( BGl_string3417z00zz__multimediazd2mpdzd2, BgL_bgl_string3417za700za7za7_3576za7, "artist", 6 );
DEFINE_STRING( BGl_string3418z00zz__multimediazd2mpdzd2, BgL_bgl_string3418za700za7za7_3577za7, "genre", 5 );
DEFINE_STRING( BGl_string3419z00zz__multimediazd2mpdzd2, BgL_bgl_string3419za700za7za7_3578za7, "unknown list type \"~a\"", 22 );
DEFINE_STRING( BGl_string3420z00zz__multimediazd2mpdzd2, BgL_bgl_string3420za700za7za7_3579za7, "ACK [2@0] {list} too few arguments for \"list\"", 45 );
DEFINE_STRING( BGl_string3421z00zz__multimediazd2mpdzd2, BgL_bgl_string3421za700za7za7_3580za7, "cpos: ", 6 );
DEFINE_STRING( BGl_string3422z00zz__multimediazd2mpdzd2, BgL_bgl_string3422za700za7za7_3581za7, "unknown find type \"~a\"", 22 );
DEFINE_STRING( BGl_string3423z00zz__multimediazd2mpdzd2, BgL_bgl_string3423za700za7za7_3582za7, "unknown search type \"~a\"", 24 );
DEFINE_STRING( BGl_string3425z00zz__multimediazd2mpdzd2, BgL_bgl_string3425za700za7za7_3583za7, "command: ", 9 );
DEFINE_STRING( BGl_string3428z00zz__multimediazd2mpdzd2, BgL_bgl_string3428za700za7za7_3584za7, "No such file", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3501z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3585z00, BGl_z62mpdzd2databasezd2searchzd21375zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3503z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3586z00, BGl_z62mpdzd2databasezd2findzd2ti1377zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3505z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3587z00, BGl_z62mpdzd2databasezd2findzd2ge1379zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3507z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3588z00, BGl_z62mpdzd2databasezd2getgenr1381z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3509z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3589z00, BGl_z62mpdzd2databasezd2getarti1383z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3433z00zz__multimediazd2mpdzd2, BgL_bgl_string3433za700za7za7_3590za7, "~a-~2,0d-~2,0dT~2,0d:~2,0d:~2,0dZ", 33 );
DEFINE_STRING( BGl_string3434z00zz__multimediazd2mpdzd2, BgL_bgl_string3434za700za7za7_3591za7, "unknown", 7 );
DEFINE_STRING( BGl_string3435z00zz__multimediazd2mpdzd2, BgL_bgl_string3435za700za7za7_3592za7, "Unknown Disc", 12 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3593z00, BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2seekzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2seekza7b03594za7, BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2pingzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2pingza7b03595za7, BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3511z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3596z00, BGl_z62mpdzd2databasezd2getgenr1385z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3513z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3597z00, BGl_z62mpdzd2databasezd2getarti1387z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3515z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3598z00, BGl_z62mpdzd2databasezd2getzd2alb1393zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3517z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3599za7, BGl_z62zc3z04anonymousza32572ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2nextzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2nextza7b03600za7, BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2stopzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2stopza7b03601za7, BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2previouszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2previou3602z00, BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3474z00zz__multimediazd2mpdzd2, BgL_bgl_string3474za700za7za7_3603za7, "mpd-database-init!1347", 22 );
DEFINE_STRING( BGl_string3476z00zz__multimediazd2mpdzd2, BgL_bgl_string3476za700za7za7_3604za7, "mpd-database-file->p1349", 24 );
DEFINE_STRING( BGl_string3478z00zz__multimediazd2mpdzd2, BgL_bgl_string3478za700za7za7_3605za7, "mpd-database-stats1351", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3606z00, BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3607z00, BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3480z00zz__multimediazd2mpdzd2, BgL_bgl_string3480za700za7za7_3608za7, "mpd-database-listall1353", 24 );
DEFINE_STRING( BGl_string3482z00zz__multimediazd2mpdzd2, BgL_bgl_string3482za700za7za7_3609za7, "mpd-database-listalb1355", 24 );
DEFINE_STRING( BGl_string3484z00zz__multimediazd2mpdzd2, BgL_bgl_string3484za700za7za7_3610za7, "mpd-database-listart1357", 24 );
DEFINE_STRING( BGl_string3486z00zz__multimediazd2mpdzd2, BgL_bgl_string3486za700za7za7_3611za7, "mpd-database-listgen1359", 24 );
DEFINE_STRING( BGl_string3488z00zz__multimediazd2mpdzd2, BgL_bgl_string3488za700za7za7_3612za7, "mpd-database-listgen1361", 24 );
DEFINE_STRING( BGl_string3490z00zz__multimediazd2mpdzd2, BgL_bgl_string3490za700za7za7_3613za7, "mpd-database-listgen1363", 24 );
DEFINE_STRING( BGl_string3492z00zz__multimediazd2mpdzd2, BgL_bgl_string3492za700za7za7_3614za7, "mpd-database-listart1365", 24 );
DEFINE_STRING( BGl_string3494z00zz__multimediazd2mpdzd2, BgL_bgl_string3494za700za7za7_3615za7, "mpd-database-lsinfo1367", 23 );
DEFINE_STRING( BGl_string3496z00zz__multimediazd2mpdzd2, BgL_bgl_string3496za700za7za7_3616za7, "mpd-database-find-al1369", 24 );
DEFINE_STRING( BGl_string3498z00zz__multimediazd2mpdzd2, BgL_bgl_string3498za700za7za7_3617za7, "mpd-database-find-ar1371", 24 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3618z00, BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2moveidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2moveidza73619za7, BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2killzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2killza7b03620za7, BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2shufflezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2shuffle3621z00, BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2closezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2closeza7b3622za7, BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2deleteidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2deletei3623z00, BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2volumezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2volumeza73624za7, BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2addzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2addza7b0za73625z00, BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3626z00, BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2urlhandlerszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2urlhand3627z00, BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3628z00, BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playidza73629za7, BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2movezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2moveza7b03630za7, BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2repeatzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2repeatza73631za7, BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3632z00, BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listallinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listall3633z00, BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2lsinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2lsinfoza73634za7, BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2searchzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2searchza73635za7, BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2deletezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2deleteza73636za7, BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listallzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listall3637z00, BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2notcommandszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2notcomm3638z00, BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2clearerrorzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2clearer3639z00, BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3500z00zz__multimediazd2mpdzd2, BgL_bgl_string3500za700za7za7_3640za7, "mpd-database-search-1373", 24 );
DEFINE_STRING( BGl_string3502z00zz__multimediazd2mpdzd2, BgL_bgl_string3502za700za7za7_3641za7, "mpd-database-search-1375", 24 );
DEFINE_STRING( BGl_string3504z00zz__multimediazd2mpdzd2, BgL_bgl_string3504za700za7za7_3642za7, "mpd-database-find-ti1377", 24 );
DEFINE_STRING( BGl_string3506z00zz__multimediazd2mpdzd2, BgL_bgl_string3506za700za7za7_3643za7, "mpd-database-find-ge1379", 24 );
DEFINE_STRING( BGl_string3508z00zz__multimediazd2mpdzd2, BgL_bgl_string3508za700za7za7_3644za7, "mpd-database-getgenr1381", 24 );
BGL_IMPORT obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3424z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3645za7, BGl_z62zc3z04anonymousza32092ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3510z00zz__multimediazd2mpdzd2, BgL_bgl_string3510za700za7za7_3646za7, "mpd-database-getarti1383", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3426z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3647za7, BGl_z62zc3z04anonymousza32102ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3512z00zz__multimediazd2mpdzd2, BgL_bgl_string3512za700za7za7_3648za7, "mpd-database-getgenr1385", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3427z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3649za7, BGl_z62zc3z04anonymousza32129ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3514z00zz__multimediazd2mpdzd2, BgL_bgl_string3514za700za7za7_3650za7, "mpd-database-getarti1387", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3429z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3651za7, BGl_z62zc3z04anonymousza32163ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3516z00zz__multimediazd2mpdzd2, BgL_bgl_string3516za700za7za7_3652za7, "mpd-database-get-alb1393", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2currentsongzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2current3653z00, BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3518z00zz__multimediazd2mpdzd2, BgL_bgl_string3518za700za7za7_3654za7, "directory: ", 11 );
DEFINE_STRING( BGl_string3519z00zz__multimediazd2mpdzd2, BgL_bgl_string3519za700za7za7_3655za7, "lsinfo", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3430z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3656za7, BGl_z62zc3z04anonymousza32168ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2commandszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2command3657z00, BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3431z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3658za7, BGl_z62zc3z04anonymousza32173ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3432z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3659za7, BGl_z62zc3z04anonymousza32200ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3520z00zz__multimediazd2mpdzd2, BgL_bgl_string3520za700za7za7_3660za7, "Genre: ", 7 );
DEFINE_STRING( BGl_string3521z00zz__multimediazd2mpdzd2, BgL_bgl_string3521za700za7za7_3661za7, "artists: ~a\nalbums: ~a\nsongs: ~a\nuptime: ~a\nplaytime: ~a\ndb_playtime: 10000000\ndb_update: ~a\n", 93 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3436z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3662za7, BGl_z62zc3z04anonymousza32303ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3437z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3663za7, BGl_z62zc3z04anonymousza32323ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3523z00zz__multimediazd2mpdzd2, BgL_bgl_string3523za700za7za7_3664za7, "&mpd-database-init!", 19 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3438z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2322za7623665z00, BGl_z62lambda2322z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3524z00zz__multimediazd2mpdzd2, BgL_bgl_string3524za700za7za7_3666za7, "&mpd-database-file->path", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3439z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2321za7623667z00, BGl_z62lambda2321z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3525z00zz__multimediazd2mpdzd2, BgL_bgl_string3525za700za7za7_3668za7, "bstring", 7 );
DEFINE_STRING( BGl_string3363z00zz__multimediazd2mpdzd2, BgL_bgl_string3363za700za7za7_3669za7, "", 0 );
DEFINE_STRING( BGl_string3526z00zz__multimediazd2mpdzd2, BgL_bgl_string3526za700za7za7_3670za7, "&mpd-database-stats", 19 );
DEFINE_STRING( BGl_string3364z00zz__multimediazd2mpdzd2, BgL_bgl_string3364za700za7za7_3671za7, "wrong number of arguments: [4..5] expected, provided", 52 );
DEFINE_STRING( BGl_string3527z00zz__multimediazd2mpdzd2, BgL_bgl_string3527za700za7za7_3672za7, "&mpd-database-listall", 21 );
DEFINE_STRING( BGl_string3365z00zz__multimediazd2mpdzd2, BgL_bgl_string3365za700za7za7_3673za7, "Illegal keyword argument", 24 );
DEFINE_STRING( BGl_string3528z00zz__multimediazd2mpdzd2, BgL_bgl_string3528za700za7za7_3674za7, "&mpd-database-listalbum", 23 );
DEFINE_STRING( BGl_string3366z00zz__multimediazd2mpdzd2, BgL_bgl_string3366za700za7za7_3675za7, "/builddir/build/BUILD/bigloo-4.4a/api/multimedia/src/Llib/mpd.scm", 65 );
DEFINE_STRING( BGl_string3529z00zz__multimediazd2mpdzd2, BgL_bgl_string3529za700za7za7_3676za7, "&mpd-database-listartistalbum", 29 );
DEFINE_STRING( BGl_string3367z00zz__multimediazd2mpdzd2, BgL_bgl_string3367za700za7za7_3677za7, "_mpd", 4 );
DEFINE_STRING( BGl_string3368z00zz__multimediazd2mpdzd2, BgL_bgl_string3368za700za7za7_3678za7, "bint", 4 );
DEFINE_STRING( BGl_string3369z00zz__multimediazd2mpdzd2, BgL_bgl_string3369za700za7za7_3679za7, "music", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3440z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3680za7, BGl_z62zc3z04anonymousza32330ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3441z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2329za7623681z00, BGl_z62lambda2329z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3442z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2328za7623682z00, BGl_z62lambda2328z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3443z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3683za7, BGl_z62zc3z04anonymousza32337ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3444z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2336za7623684z00, BGl_z62lambda2336z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3530z00zz__multimediazd2mpdzd2, BgL_bgl_string3530za700za7za7_3685za7, "&mpd-database-listgenrealbum", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3445z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2335za7623686z00, BGl_z62lambda2335z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3531z00zz__multimediazd2mpdzd2, BgL_bgl_string3531za700za7za7_3687za7, "&mpd-database-listgenreartist", 29 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3446z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3688za7, BGl_z62zc3z04anonymousza32344ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3532z00zz__multimediazd2mpdzd2, BgL_bgl_string3532za700za7za7_3689za7, "&mpd-database-listgenre", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3447z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2343za7623690z00, BGl_z62lambda2343z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3370z00zz__multimediazd2mpdzd2, BgL_bgl_string3370za700za7za7_3691za7, "input-port", 10 );
DEFINE_STRING( BGl_string3533z00zz__multimediazd2mpdzd2, BgL_bgl_string3533za700za7za7_3692za7, "&mpd-database-listartist", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3448z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2342za7623693z00, BGl_z62lambda2342z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3371z00zz__multimediazd2mpdzd2, BgL_bgl_string3371za700za7za7_3694za7, "output-port", 11 );
DEFINE_STRING( BGl_string3534z00zz__multimediazd2mpdzd2, BgL_bgl_string3534za700za7za7_3695za7, "&mpd-database-lsinfo", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3449z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3696za7, BGl_z62zc3z04anonymousza32351ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3372z00zz__multimediazd2mpdzd2, BgL_bgl_string3372za700za7za7_3697za7, "mpd-database", 12 );
DEFINE_STRING( BGl_string3535z00zz__multimediazd2mpdzd2, BgL_bgl_string3535za700za7za7_3698za7, "&mpd-database-find-album", 24 );
DEFINE_STRING( BGl_string3373z00zz__multimediazd2mpdzd2, BgL_bgl_string3373za700za7za7_3699za7, "OK MPD 0.16.0", 13 );
DEFINE_STRING( BGl_string3536z00zz__multimediazd2mpdzd2, BgL_bgl_string3536za700za7za7_3700za7, "&mpd-database-find-artist", 25 );
DEFINE_STRING( BGl_string3374z00zz__multimediazd2mpdzd2, BgL_bgl_string3374za700za7za7_3701za7, "OK\n", 3 );
DEFINE_STRING( BGl_string3537z00zz__multimediazd2mpdzd2, BgL_bgl_string3537za700za7za7_3702za7, "&mpd-database-search-artist-album", 33 );
DEFINE_STRING( BGl_string3375z00zz__multimediazd2mpdzd2, BgL_bgl_string3375za700za7za7_3703za7, "ACK [", 5 );
DEFINE_STRING( BGl_string3538z00zz__multimediazd2mpdzd2, BgL_bgl_string3538za700za7za7_3704za7, "&mpd-database-search-artist-title", 33 );
DEFINE_STRING( BGl_string3376z00zz__multimediazd2mpdzd2, BgL_bgl_string3376za700za7za7_3705za7, "5@0", 3 );
DEFINE_STRING( BGl_string3539z00zz__multimediazd2mpdzd2, BgL_bgl_string3539za700za7za7_3706za7, "&mpd-database-find-title", 24 );
DEFINE_STRING( BGl_string3377z00zz__multimediazd2mpdzd2, BgL_bgl_string3377za700za7za7_3707za7, "] {", 3 );
DEFINE_STRING( BGl_string3378z00zz__multimediazd2mpdzd2, BgL_bgl_string3378za700za7za7_3708za7, "} ", 2 );
DEFINE_STRING( BGl_string3379z00zz__multimediazd2mpdzd2, BgL_bgl_string3379za700za7za7_3709za7, "\n", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3450z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2350za7623710z00, BGl_z62lambda2350z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3451z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2349za7623711z00, BGl_z62lambda2349z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3452z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3712za7, BGl_z62zc3z04anonymousza32358ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3453z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2357za7623713z00, BGl_z62lambda2357z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3454z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2356za7623714z00, BGl_z62lambda2356z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3540z00zz__multimediazd2mpdzd2, BgL_bgl_string3540za700za7za7_3715za7, "&mpd-database-find-genre", 24 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3455z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3716za7, BGl_z62zc3z04anonymousza32365ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3541z00zz__multimediazd2mpdzd2, BgL_bgl_string3541za700za7za7_3717za7, "&mpd-database-getgenre", 22 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3456z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2364za7623718z00, BGl_z62lambda2364z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3542z00zz__multimediazd2mpdzd2, BgL_bgl_string3542za700za7za7_3719za7, "&mpd-database-getartist", 23 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3457z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2363za7623720z00, BGl_z62lambda2363z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3380z00zz__multimediazd2mpdzd2, BgL_bgl_string3380za700za7za7_3721za7, "unknown command \"~a\"", 20 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2crossfadezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2crossfa3722z00, BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STRING( BGl_string3543z00zz__multimediazd2mpdzd2, BgL_bgl_string3543za700za7za7_3723za7, "&mpd-database-getgenreartist", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3458z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3724za7, BGl_z62zc3z04anonymousza32372ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3381z00zz__multimediazd2mpdzd2, BgL_bgl_string3381za700za7za7_3725za7, "list_OK\n", 8 );
DEFINE_STRING( BGl_string3544z00zz__multimediazd2mpdzd2, BgL_bgl_string3544za700za7za7_3726za7, "&mpd-database-getartistalbum", 28 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3459z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2371za7623727z00, BGl_z62lambda2371z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3382z00zz__multimediazd2mpdzd2, BgL_bgl_string3382za700za7za7_3728za7, "wrong number of arguments: [2..4] expected, provided", 52 );
DEFINE_STRING( BGl_string3545z00zz__multimediazd2mpdzd2, BgL_bgl_string3545za700za7za7_3729za7, "&mpd-database-get-album", 23 );
DEFINE_STRING( BGl_string3383z00zz__multimediazd2mpdzd2, BgL_bgl_string3383za700za7za7_3730za7, "handler: ", 9 );
DEFINE_STRING( BGl_string3546z00zz__multimediazd2mpdzd2, BgL_bgl_string3546za700za7za7_3731za7, "__multimedia-mpd", 16 );
DEFINE_STRING( BGl_string3384z00zz__multimediazd2mpdzd2, BgL_bgl_string3384za700za7za7_3732za7, "tagtype: ", 9 );
DEFINE_STRING( BGl_string3547z00zz__multimediazd2mpdzd2, BgL_bgl_string3547za700za7za7_3733za7, "(\"mp3\" \"flac\" \"ogg\" \"wav\") __multimedia-mpd mpd-database %db-update %uptime %nsongs int %nalbums obj %nartists %genres %albums %artists bstring %base suffixes pair-nil directories :Image :Time :Last-Modified :file :Genre :Date :Track :Album :Title :Artist (\"jpg\" \"JPG\" \"png\" \"gif\" \"GIF\") any genre disc album title artist :image :artist :album infofile (:album :artist :image) (\"Artist\" \"Album\" \"Title\" \"Track\" \"Name\" \"Genre\" \"Date\" \"Composer\" \"Performer\" \"Disc\") (\"http://\" \"file://\") :err :command mpd-err (:command :err) command_list_end command_list_ok_begin command_list_begin blank ok :log (:log) mpd outputs update swapid swap shuffle save rm repeat random password moveid move crossfade addid notcommands commands search find kill plconangesposid lsinfo listallinfo list listall stats close clearerror setvol volume previous next pause stop seekid seek playid play currentsong clear deleteid delete add plchanges playlistid playlistinfo playlist status tagtypes urlhandlers "
"ping ", 987 );
DEFINE_STRING( BGl_string3385z00zz__multimediazd2mpdzd2, BgL_bgl_string3385za700za7za7_3734za7, "volume: ", 8 );
DEFINE_STRING( BGl_string3386z00zz__multimediazd2mpdzd2, BgL_bgl_string3386za700za7za7_3735za7, "state: ", 7 );
DEFINE_STRING( BGl_string3387z00zz__multimediazd2mpdzd2, BgL_bgl_string3387za700za7za7_3736za7, "playlist: ", 10 );
DEFINE_STRING( BGl_string3388z00zz__multimediazd2mpdzd2, BgL_bgl_string3388za700za7za7_3737za7, "playlistlength: ", 16 );
DEFINE_STRING( BGl_string3389z00zz__multimediazd2mpdzd2, BgL_bgl_string3389za700za7za7_3738za7, "song: ", 6 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mpdzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl__mpdza700za7za7__multi3739za7, opt_generic_entry, BGl__mpdz00zz__multimediazd2mpdzd2, BFALSE, -1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3740z00, BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3460z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2370za7623741z00, BGl_z62lambda2370z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3461z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3742za7, BGl_z62zc3z04anonymousza32379ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3462z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2378za7623743z00, BGl_z62lambda2378z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3463z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2377za7623744z00, BGl_z62lambda2377z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3464z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3745za7, BGl_z62zc3z04anonymousza32386ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3465z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2385za7623746z00, BGl_z62lambda2385z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3466z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2384za7623747z00, BGl_z62lambda2384z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2setvolzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2setvolza73748za7, BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3467z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3749za7, BGl_z62zc3z04anonymousza32393ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string3390z00zz__multimediazd2mpdzd2, BgL_bgl_string3390za700za7za7_3750za7, "songid: ", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3468z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2392za7623751z00, BGl_z62lambda2392z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string3391z00zz__multimediazd2mpdzd2, BgL_bgl_string3391za700za7za7_3752za7, "bitrate: ", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3469z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2391za7623753z00, BGl_z62lambda2391z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3392z00zz__multimediazd2mpdzd2, BgL_bgl_string3392za700za7za7_3754za7, "audio: ", 7 );
DEFINE_STRING( BGl_string3393z00zz__multimediazd2mpdzd2, BgL_bgl_string3393za700za7za7_3755za7, ":16:2\n", 6 );
DEFINE_STRING( BGl_string3394z00zz__multimediazd2mpdzd2, BgL_bgl_string3394za700za7za7_3756za7, "time: ", 6 );
DEFINE_STRING( BGl_string3395z00zz__multimediazd2mpdzd2, BgL_bgl_string3395za700za7za7_3757za7, ":", 1 );
DEFINE_STRING( BGl_string3396z00zz__multimediazd2mpdzd2, BgL_bgl_string3396za700za7za7_3758za7, "repeat: 1\n", 10 );
DEFINE_STRING( BGl_string3397z00zz__multimediazd2mpdzd2, BgL_bgl_string3397za700za7za7_3759za7, "repeat: 0\n", 10 );
DEFINE_STRING( BGl_string3398z00zz__multimediazd2mpdzd2, BgL_bgl_string3398za700za7za7_3760za7, "random: 1\n", 10 );
DEFINE_STRING( BGl_string3399z00zz__multimediazd2mpdzd2, BgL_bgl_string3399za700za7za7_3761za7, "random: 0\n", 10 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3762z00, BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3470z00zz__multimediazd2mpdzd2, BgL_bgl_za762za7c3za704anonymo3763za7, BGl_z62zc3z04anonymousza32316ze3ze5zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3764z00, BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3471z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2314za7623765z00, BGl_z62lambda2314z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3472z00zz__multimediazd2mpdzd2, BgL_bgl_za762lambda2311za7623766z00, BGl_z62lambda2311z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3473z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3767z00, BGl_z62mpdzd2databasezd2initz121347z70zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3475z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3768z00, BGl_z62mpdzd2databasezd2filezd2ze3p1349z53zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3477z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3769z00, BGl_z62mpdzd2databasezd2stats1351z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3479z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3770z00, BGl_z62mpdzd2databasezd2listall1353z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2statuszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2statusza73771za7, BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2clearzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2clearza7b3772za7, BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2savezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2saveza7b03773za7, BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3481z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3774z00, BGl_z62mpdzd2databasezd2listalb1355z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3483z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3775z00, BGl_z62mpdzd2databasezd2listart1357z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3485z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3776z00, BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3487z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3777z00, BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3778z00, BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3489z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3779z00, BGl_z62mpdzd2databasezd2listgen1363z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3780z00, BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2plconangesposidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2plconan3781z00, BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2addidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2addidza7b3782za7, BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3491z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3783z00, BGl_z62mpdzd2databasezd2listart1365z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3493z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3784z00, BGl_z62mpdzd2databasezd2lsinfo1367z62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2pausezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2pauseza7b3785za7, BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_LLONG( BGl_llong3522z00zz__multimediazd2mpdzd2, BgL_bgl_llong3522za700za7za7__3786za7, ((BGL_LONGLONG_T)0) );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3495z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3787z00, BGl_z62mpdzd2databasezd2findzd2al1369zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3788z00, BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3497z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3789z00, BGl_z62mpdzd2databasezd2findzd2ar1371zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3790z00, BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3499z00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3791z00, BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2randomzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2randomza73792za7, BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2statszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2statsza7b3793za7, BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3794z00, BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2plchangeszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2plchang3795z00, BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2tagtypeszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2tagtype3796z00, BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2swapidzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2swapidza73797za7, BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2swapzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2swapza7b03798za7, BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2findzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2findza7b03799za7, BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2outputszd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2outputs3800z00, BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3801z00, BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3802z00, BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3803z00, BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3804z00, BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2listzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2listza7b03805za7, BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_EXPORT_BGL_GENERIC( BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2databas3806z00, BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2playlistinfozd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2playlis3807z00, BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_mpdzd2passwordzd2envz00zz__multimediazd2mpdzd2, BgL_bgl_za762mpdza7d2passwor3808z00, BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2, 0L, BUNSPEC, 5 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__multimediazd2mpdzd2(long BgL_checksumz00_5998, char * BgL_fromz00_5999)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2))
{ 
BGl_requirezd2initializa7ationz75zz__multimediazd2mpdzd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2(); 
BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2(); 
BGl_cnstzd2initzd2zz__multimediazd2mpdzd2(); 
BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2(); 
BGl_objectzd2initzd2zz__multimediazd2mpdzd2(); 
BGl_genericzd2initzd2zz__multimediazd2mpdzd2(); 
return 
BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__hashz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__datez00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__multimedia-mpd"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__multimedia-mpd"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 15 */
obj_t BgL_cportz00_5497;
{ /* Llib/mpd.scm 15 */
obj_t BgL_stringz00_5505;
BgL_stringz00_5505 = BGl_string3547z00zz__multimediazd2mpdzd2; 
{ /* Llib/mpd.scm 15 */
obj_t BgL_startz00_5506;
BgL_startz00_5506 = 
BINT(((long)0)); 
{ /* Llib/mpd.scm 15 */
obj_t BgL_endz00_5507;
BgL_endz00_5507 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_5505))); 
{ /* Llib/mpd.scm 15 */

BgL_cportz00_5497 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_5505, BgL_startz00_5506, BgL_endz00_5507); } } } } 
{ 
long BgL_iz00_5498;
BgL_iz00_5498 = ((long)103); 
BgL_loopz00_5499:
if(
(BgL_iz00_5498==((long)-1)))
{ /* Llib/mpd.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 15 */
obj_t BgL_arg3549z00_5501;
{ /* Llib/mpd.scm 15 */

{ /* Llib/mpd.scm 15 */
obj_t BgL_locationz00_5503;
BgL_locationz00_5503 = 
BBOOL(((bool_t)0)); 
{ /* Llib/mpd.scm 15 */

BgL_arg3549z00_5501 = 
BGl_readz00zz__readerz00(BgL_cportz00_5497, BgL_locationz00_5503); } } } 
{ /* Llib/mpd.scm 15 */
int BgL_tmpz00_6040;
BgL_tmpz00_6040 = 
(int)(BgL_iz00_5498); 
CNST_TABLE_SET(BgL_tmpz00_6040, BgL_arg3549z00_5501); } } 
{ /* Llib/mpd.scm 15 */
int BgL_auxz00_5504;
BgL_auxz00_5504 = 
(int)(
(BgL_iz00_5498-((long)1))); 
{ 
long BgL_iz00_6045;
BgL_iz00_6045 = 
(long)(BgL_auxz00_5504); 
BgL_iz00_5498 = BgL_iz00_6045; 
goto BgL_loopz00_5499;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = BNIL; 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = BNIL; 
BGl_cmdnz00zz__multimediazd2mpdzd2 = ((long)0); 
{ /* Llib/mpd.scm 338 */
obj_t BgL_arg1434z00_419;
{ /* Llib/mpd.scm 338 */
obj_t BgL_arg1435z00_420;
BgL_arg1435z00_420 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)0)), BGl_mpdzd2pingzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 338 */
obj_t BgL_list1436z00_421;
BgL_list1436z00_421 = 
MAKE_YOUNG_PAIR(BgL_arg1435z00_420, BNIL); 
BgL_arg1434z00_419 = BgL_list1436z00_421; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1434z00_419); } 
{ /* Llib/mpd.scm 344 */
obj_t BgL_arg1516z00_422;
{ /* Llib/mpd.scm 344 */
obj_t BgL_arg1517z00_423;
BgL_arg1517z00_423 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)1)), BGl_mpdzd2urlhandlerszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 344 */
obj_t BgL_list1518z00_424;
BgL_list1518z00_424 = 
MAKE_YOUNG_PAIR(BgL_arg1517z00_423, BNIL); 
BgL_arg1516z00_422 = BgL_list1518z00_424; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1516z00_422); } 
{ /* Llib/mpd.scm 354 */
obj_t BgL_arg1522z00_425;
{ /* Llib/mpd.scm 354 */
obj_t BgL_arg1526z00_426;
BgL_arg1526z00_426 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)2)), BGl_mpdzd2tagtypeszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 354 */
obj_t BgL_list1527z00_427;
BgL_list1527z00_427 = 
MAKE_YOUNG_PAIR(BgL_arg1526z00_426, BNIL); 
BgL_arg1522z00_425 = BgL_list1527z00_427; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1522z00_425); } 
{ /* Llib/mpd.scm 371 */
obj_t BgL_arg1534z00_428;
{ /* Llib/mpd.scm 371 */
obj_t BgL_arg1541z00_429;
BgL_arg1541z00_429 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)3)), BGl_mpdzd2statuszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 371 */
obj_t BgL_list1542z00_430;
BgL_list1542z00_430 = 
MAKE_YOUNG_PAIR(BgL_arg1541z00_429, BNIL); 
BgL_arg1534z00_428 = BgL_list1542z00_430; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1534z00_428); } 
{ /* Llib/mpd.scm 406 */
obj_t BgL_arg1549z00_431;
{ /* Llib/mpd.scm 406 */
obj_t BgL_arg1550z00_432;
BgL_arg1550z00_432 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)4)), BGl_mpdzd2playlistzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 406 */
obj_t BgL_list1551z00_433;
BgL_list1551z00_433 = 
MAKE_YOUNG_PAIR(BgL_arg1550z00_432, BNIL); 
BgL_arg1549z00_431 = BgL_list1551z00_433; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1549z00_431); } 
{ /* Llib/mpd.scm 447 */
obj_t BgL_arg1552z00_434;
{ /* Llib/mpd.scm 447 */
obj_t BgL_arg1553z00_435;
BgL_arg1553z00_435 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)5)), BGl_mpdzd2playlistinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 447 */
obj_t BgL_list1554z00_436;
BgL_list1554z00_436 = 
MAKE_YOUNG_PAIR(BgL_arg1553z00_435, BNIL); 
BgL_arg1552z00_434 = BgL_list1554z00_436; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1552z00_434); } 
{ /* Llib/mpd.scm 453 */
obj_t BgL_arg1567z00_437;
{ /* Llib/mpd.scm 453 */
obj_t BgL_arg1568z00_438;
BgL_arg1568z00_438 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)6)), BGl_mpdzd2playlistidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 453 */
obj_t BgL_list1569z00_439;
BgL_list1569z00_439 = 
MAKE_YOUNG_PAIR(BgL_arg1568z00_438, BNIL); 
BgL_arg1567z00_437 = BgL_list1569z00_439; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1567z00_437); } 
{ /* Llib/mpd.scm 459 */
obj_t BgL_arg1570z00_440;
{ /* Llib/mpd.scm 459 */
obj_t BgL_arg1571z00_441;
BgL_arg1571z00_441 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)7)), BGl_mpdzd2plchangeszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 459 */
obj_t BgL_list1572z00_442;
BgL_list1572z00_442 = 
MAKE_YOUNG_PAIR(BgL_arg1571z00_441, BNIL); 
BgL_arg1570z00_440 = BgL_list1572z00_442; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1570z00_440); } 
{ /* Llib/mpd.scm 477 */
obj_t BgL_arg1584z00_443;
{ /* Llib/mpd.scm 477 */
obj_t BgL_arg1586z00_444;
BgL_arg1586z00_444 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)8)), BGl_mpdzd2addzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 477 */
obj_t BgL_list1587z00_445;
BgL_list1587z00_445 = 
MAKE_YOUNG_PAIR(BgL_arg1586z00_444, BNIL); 
BgL_arg1584z00_443 = BgL_list1587z00_445; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1584z00_443); } 
{ /* Llib/mpd.scm 493 */
obj_t BgL_arg1599z00_446;
{ /* Llib/mpd.scm 493 */
obj_t BgL_arg1600z00_447;
BgL_arg1600z00_447 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)9)), BGl_mpdzd2deletezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 493 */
obj_t BgL_list1602z00_448;
BgL_list1602z00_448 = 
MAKE_YOUNG_PAIR(BgL_arg1600z00_447, BNIL); 
BgL_arg1599z00_446 = BgL_list1602z00_448; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1599z00_446); } 
{ /* Llib/mpd.scm 500 */
obj_t BgL_arg1623z00_449;
{ /* Llib/mpd.scm 500 */
obj_t BgL_arg1624z00_450;
BgL_arg1624z00_450 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)10)), BGl_mpdzd2deleteidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 500 */
obj_t BgL_list1625z00_451;
BgL_list1625z00_451 = 
MAKE_YOUNG_PAIR(BgL_arg1624z00_450, BNIL); 
BgL_arg1623z00_449 = BgL_list1625z00_451; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1623z00_449); } 
{ /* Llib/mpd.scm 507 */
obj_t BgL_arg1627z00_452;
{ /* Llib/mpd.scm 507 */
obj_t BgL_arg1632z00_453;
BgL_arg1632z00_453 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)11)), BGl_mpdzd2clearzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 507 */
obj_t BgL_list1633z00_454;
BgL_list1633z00_454 = 
MAKE_YOUNG_PAIR(BgL_arg1632z00_453, BNIL); 
BgL_arg1627z00_452 = BgL_list1633z00_454; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1627z00_452); } 
BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BFALSE; 
BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2 = ((long)-1); 
BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BGl_string3363z00zz__multimediazd2mpdzd2; 
{ /* Llib/mpd.scm 579 */
obj_t BgL_arg1634z00_455;
{ /* Llib/mpd.scm 579 */
obj_t BgL_arg1635z00_456;
BgL_arg1635z00_456 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)12)), BGl_mpdzd2currentsongzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 579 */
obj_t BgL_list1636z00_457;
BgL_list1636z00_457 = 
MAKE_YOUNG_PAIR(BgL_arg1635z00_456, BNIL); 
BgL_arg1634z00_455 = BgL_list1636z00_457; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1634z00_455); } 
{ /* Llib/mpd.scm 589 */
obj_t BgL_arg1638z00_458;
{ /* Llib/mpd.scm 589 */
obj_t BgL_arg1643z00_459;
BgL_arg1643z00_459 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)13)), BGl_mpdzd2playzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 589 */
obj_t BgL_list1644z00_460;
BgL_list1644z00_460 = 
MAKE_YOUNG_PAIR(BgL_arg1643z00_459, BNIL); 
BgL_arg1638z00_458 = BgL_list1644z00_460; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1638z00_458); } 
{ /* Llib/mpd.scm 598 */
obj_t BgL_arg1650z00_461;
{ /* Llib/mpd.scm 598 */
obj_t BgL_arg1652z00_462;
BgL_arg1652z00_462 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)14)), BGl_mpdzd2playidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 598 */
obj_t BgL_list1653z00_463;
BgL_list1653z00_463 = 
MAKE_YOUNG_PAIR(BgL_arg1652z00_462, BNIL); 
BgL_arg1650z00_461 = BgL_list1653z00_463; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1650z00_461); } 
{ /* Llib/mpd.scm 607 */
obj_t BgL_arg1655z00_464;
{ /* Llib/mpd.scm 607 */
obj_t BgL_arg1658z00_465;
BgL_arg1658z00_465 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)15)), BGl_mpdzd2seekzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 607 */
obj_t BgL_list1659z00_466;
BgL_list1659z00_466 = 
MAKE_YOUNG_PAIR(BgL_arg1658z00_465, BNIL); 
BgL_arg1655z00_464 = BgL_list1659z00_466; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1655z00_464); } 
{ /* Llib/mpd.scm 614 */
obj_t BgL_arg1667z00_467;
{ /* Llib/mpd.scm 614 */
obj_t BgL_arg1668z00_468;
BgL_arg1668z00_468 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)16)), BGl_mpdzd2seekidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 614 */
obj_t BgL_list1669z00_469;
BgL_list1669z00_469 = 
MAKE_YOUNG_PAIR(BgL_arg1668z00_468, BNIL); 
BgL_arg1667z00_467 = BgL_list1669z00_469; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1667z00_467); } 
{ /* Llib/mpd.scm 621 */
obj_t BgL_arg1675z00_470;
{ /* Llib/mpd.scm 621 */
obj_t BgL_arg1677z00_471;
BgL_arg1677z00_471 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)17)), BGl_mpdzd2stopzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 621 */
obj_t BgL_list1678z00_472;
BgL_list1678z00_472 = 
MAKE_YOUNG_PAIR(BgL_arg1677z00_471, BNIL); 
BgL_arg1675z00_470 = BgL_list1678z00_472; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1675z00_470); } 
{ /* Llib/mpd.scm 628 */
obj_t BgL_arg1681z00_473;
{ /* Llib/mpd.scm 628 */
obj_t BgL_arg1682z00_474;
BgL_arg1682z00_474 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)18)), BGl_mpdzd2pausezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 628 */
obj_t BgL_list1683z00_475;
BgL_list1683z00_475 = 
MAKE_YOUNG_PAIR(BgL_arg1682z00_474, BNIL); 
BgL_arg1681z00_473 = BgL_list1683z00_475; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1681z00_473); } 
{ /* Llib/mpd.scm 635 */
obj_t BgL_arg1684z00_476;
{ /* Llib/mpd.scm 635 */
obj_t BgL_arg1687z00_477;
BgL_arg1687z00_477 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)19)), BGl_mpdzd2nextzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 635 */
obj_t BgL_list1688z00_478;
BgL_list1688z00_478 = 
MAKE_YOUNG_PAIR(BgL_arg1687z00_477, BNIL); 
BgL_arg1684z00_476 = BgL_list1688z00_478; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1684z00_476); } 
{ /* Llib/mpd.scm 648 */
obj_t BgL_arg1691z00_479;
{ /* Llib/mpd.scm 648 */
obj_t BgL_arg1692z00_480;
BgL_arg1692z00_480 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)20)), BGl_mpdzd2previouszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 648 */
obj_t BgL_list1693z00_481;
BgL_list1693z00_481 = 
MAKE_YOUNG_PAIR(BgL_arg1692z00_480, BNIL); 
BgL_arg1691z00_479 = BgL_list1693z00_481; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1691z00_479); } 
{ /* Llib/mpd.scm 661 */
obj_t BgL_arg1694z00_482;
{ /* Llib/mpd.scm 661 */
obj_t BgL_arg1697z00_483;
BgL_arg1697z00_483 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)21)), BGl_mpdzd2volumezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 661 */
obj_t BgL_list1698z00_484;
BgL_list1698z00_484 = 
MAKE_YOUNG_PAIR(BgL_arg1697z00_483, BNIL); 
BgL_arg1694z00_482 = BgL_list1698z00_484; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1694z00_482); } 
{ /* Llib/mpd.scm 684 */
obj_t BgL_arg1699z00_485;
{ /* Llib/mpd.scm 684 */
obj_t BgL_arg1700z00_486;
BgL_arg1700z00_486 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)22)), BGl_mpdzd2setvolzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 684 */
obj_t BgL_list1701z00_487;
BgL_list1701z00_487 = 
MAKE_YOUNG_PAIR(BgL_arg1700z00_486, BNIL); 
BgL_arg1699z00_485 = BgL_list1701z00_487; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1699z00_485); } 
{ /* Llib/mpd.scm 690 */
obj_t BgL_arg1706z00_488;
{ /* Llib/mpd.scm 690 */
obj_t BgL_arg1707z00_489;
BgL_arg1707z00_489 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)23)), BGl_mpdzd2clearerrorzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 690 */
obj_t BgL_list1708z00_490;
BgL_list1708z00_490 = 
MAKE_YOUNG_PAIR(BgL_arg1707z00_489, BNIL); 
BgL_arg1706z00_488 = BgL_list1708z00_490; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1706z00_488); } 
{ /* Llib/mpd.scm 696 */
obj_t BgL_arg1709z00_491;
{ /* Llib/mpd.scm 696 */
obj_t BgL_arg1710z00_492;
BgL_arg1710z00_492 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)24)), BGl_mpdzd2closezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 696 */
obj_t BgL_list1711z00_493;
BgL_list1711z00_493 = 
MAKE_YOUNG_PAIR(BgL_arg1710z00_492, BNIL); 
BgL_arg1709z00_491 = BgL_list1711z00_493; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1709z00_491); } 
{ /* Llib/mpd.scm 702 */
obj_t BgL_arg1712z00_494;
{ /* Llib/mpd.scm 702 */
obj_t BgL_arg1713z00_495;
BgL_arg1713z00_495 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)25)), BGl_mpdzd2statszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 702 */
obj_t BgL_list1714z00_496;
BgL_list1714z00_496 = 
MAKE_YOUNG_PAIR(BgL_arg1713z00_495, BNIL); 
BgL_arg1712z00_494 = BgL_list1714z00_496; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1712z00_494); } 
{ /* Llib/mpd.scm 709 */
obj_t BgL_arg1720z00_497;
{ /* Llib/mpd.scm 709 */
obj_t BgL_arg1721z00_498;
BgL_arg1721z00_498 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)26)), BGl_mpdzd2listallzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 709 */
obj_t BgL_list1722z00_499;
BgL_list1722z00_499 = 
MAKE_YOUNG_PAIR(BgL_arg1721z00_498, BNIL); 
BgL_arg1720z00_497 = BgL_list1722z00_499; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1720z00_497); } 
{ /* Llib/mpd.scm 716 */
obj_t BgL_arg1724z00_500;
{ /* Llib/mpd.scm 716 */
obj_t BgL_arg1728z00_501;
BgL_arg1728z00_501 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)27)), BGl_mpdzd2listzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 716 */
obj_t BgL_list1729z00_502;
BgL_list1729z00_502 = 
MAKE_YOUNG_PAIR(BgL_arg1728z00_501, BNIL); 
BgL_arg1724z00_500 = BgL_list1729z00_502; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1724z00_500); } 
{ /* Llib/mpd.scm 745 */
obj_t BgL_arg1731z00_503;
{ /* Llib/mpd.scm 745 */
obj_t BgL_arg1732z00_504;
BgL_arg1732z00_504 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)28)), BGl_mpdzd2listallinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 745 */
obj_t BgL_list1733z00_505;
BgL_list1733z00_505 = 
MAKE_YOUNG_PAIR(BgL_arg1732z00_504, BNIL); 
BgL_arg1731z00_503 = BgL_list1733z00_505; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1731z00_503); } 
{ /* Llib/mpd.scm 752 */
obj_t BgL_arg1735z00_506;
{ /* Llib/mpd.scm 752 */
obj_t BgL_arg1741z00_507;
BgL_arg1741z00_507 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)29)), BGl_mpdzd2lsinfozd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 752 */
obj_t BgL_list1742z00_508;
BgL_list1742z00_508 = 
MAKE_YOUNG_PAIR(BgL_arg1741z00_507, BNIL); 
BgL_arg1735z00_506 = BgL_list1742z00_508; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1735z00_506); } 
{ /* Llib/mpd.scm 759 */
obj_t BgL_arg1754z00_509;
{ /* Llib/mpd.scm 759 */
obj_t BgL_arg1755z00_510;
BgL_arg1755z00_510 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)30)), BGl_mpdzd2plconangesposidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 759 */
obj_t BgL_list1756z00_511;
BgL_list1756z00_511 = 
MAKE_YOUNG_PAIR(BgL_arg1755z00_510, BNIL); 
BgL_arg1754z00_509 = BgL_list1756z00_511; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1754z00_509); } 
{ /* Llib/mpd.scm 771 */
obj_t BgL_arg1757z00_512;
{ /* Llib/mpd.scm 771 */
obj_t BgL_arg1766z00_513;
BgL_arg1766z00_513 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)31)), BGl_mpdzd2killzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 771 */
obj_t BgL_list1767z00_514;
BgL_list1767z00_514 = 
MAKE_YOUNG_PAIR(BgL_arg1766z00_513, BNIL); 
BgL_arg1757z00_512 = BgL_list1767z00_514; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1757z00_512); } 
{ /* Llib/mpd.scm 777 */
obj_t BgL_arg1768z00_515;
{ /* Llib/mpd.scm 777 */
obj_t BgL_arg1769z00_516;
BgL_arg1769z00_516 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)32)), BGl_mpdzd2findzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 777 */
obj_t BgL_list1770z00_517;
BgL_list1770z00_517 = 
MAKE_YOUNG_PAIR(BgL_arg1769z00_516, BNIL); 
BgL_arg1768z00_515 = BgL_list1770z00_517; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1768z00_515); } 
{ /* Llib/mpd.scm 797 */
obj_t BgL_arg1771z00_518;
{ /* Llib/mpd.scm 797 */
obj_t BgL_arg1772z00_519;
BgL_arg1772z00_519 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)33)), BGl_mpdzd2searchzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 797 */
obj_t BgL_list1773z00_520;
BgL_list1773z00_520 = 
MAKE_YOUNG_PAIR(BgL_arg1772z00_519, BNIL); 
BgL_arg1771z00_518 = BgL_list1773z00_520; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1771z00_518); } 
{ /* Llib/mpd.scm 825 */
obj_t BgL_arg1774z00_521;
{ /* Llib/mpd.scm 825 */
obj_t BgL_arg1775z00_522;
BgL_arg1775z00_522 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)34)), BGl_mpdzd2commandszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 825 */
obj_t BgL_list1776z00_523;
BgL_list1776z00_523 = 
MAKE_YOUNG_PAIR(BgL_arg1775z00_522, BNIL); 
BgL_arg1774z00_521 = BgL_list1776z00_523; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1774z00_521); } 
{ /* Llib/mpd.scm 839 */
obj_t BgL_arg1777z00_524;
{ /* Llib/mpd.scm 839 */
obj_t BgL_arg1778z00_525;
BgL_arg1778z00_525 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)35)), BGl_mpdzd2notcommandszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 839 */
obj_t BgL_list1779z00_526;
BgL_list1779z00_526 = 
MAKE_YOUNG_PAIR(BgL_arg1778z00_525, BNIL); 
BgL_arg1777z00_524 = BgL_list1779z00_526; } } 
BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1777z00_524); } 
{ /* Llib/mpd.scm 853 */
obj_t BgL_arg1780z00_527;
{ /* Llib/mpd.scm 853 */
obj_t BgL_arg1781z00_528;
BgL_arg1781z00_528 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)36)), BGl_mpdzd2addidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 853 */
obj_t BgL_list1782z00_529;
BgL_list1782z00_529 = 
MAKE_YOUNG_PAIR(BgL_arg1781z00_528, BNIL); 
BgL_arg1780z00_527 = BgL_list1782z00_529; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1780z00_527); } 
{ /* Llib/mpd.scm 858 */
obj_t BgL_arg1783z00_530;
{ /* Llib/mpd.scm 858 */
obj_t BgL_arg1784z00_531;
BgL_arg1784z00_531 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)37)), BGl_mpdzd2crossfadezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 858 */
obj_t BgL_list1785z00_532;
BgL_list1785z00_532 = 
MAKE_YOUNG_PAIR(BgL_arg1784z00_531, BNIL); 
BgL_arg1783z00_530 = BgL_list1785z00_532; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1783z00_530); } 
{ /* Llib/mpd.scm 863 */
obj_t BgL_arg1786z00_533;
{ /* Llib/mpd.scm 863 */
obj_t BgL_arg1787z00_534;
BgL_arg1787z00_534 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)38)), BGl_mpdzd2movezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 863 */
obj_t BgL_list1788z00_535;
BgL_list1788z00_535 = 
MAKE_YOUNG_PAIR(BgL_arg1787z00_534, BNIL); 
BgL_arg1786z00_533 = BgL_list1788z00_535; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1786z00_533); } 
{ /* Llib/mpd.scm 868 */
obj_t BgL_arg1789z00_536;
{ /* Llib/mpd.scm 868 */
obj_t BgL_arg1790z00_537;
BgL_arg1790z00_537 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)39)), BGl_mpdzd2moveidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 868 */
obj_t BgL_list1791z00_538;
BgL_list1791z00_538 = 
MAKE_YOUNG_PAIR(BgL_arg1790z00_537, BNIL); 
BgL_arg1789z00_536 = BgL_list1791z00_538; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1789z00_536); } 
{ /* Llib/mpd.scm 873 */
obj_t BgL_arg1792z00_539;
{ /* Llib/mpd.scm 873 */
obj_t BgL_arg1793z00_540;
BgL_arg1793z00_540 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)40)), BGl_mpdzd2passwordzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 873 */
obj_t BgL_list1794z00_541;
BgL_list1794z00_541 = 
MAKE_YOUNG_PAIR(BgL_arg1793z00_540, BNIL); 
BgL_arg1792z00_539 = BgL_list1794z00_541; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1792z00_539); } 
{ /* Llib/mpd.scm 878 */
obj_t BgL_arg1795z00_542;
{ /* Llib/mpd.scm 878 */
obj_t BgL_arg1796z00_543;
BgL_arg1796z00_543 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)41)), BGl_mpdzd2randomzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 878 */
obj_t BgL_list1797z00_544;
BgL_list1797z00_544 = 
MAKE_YOUNG_PAIR(BgL_arg1796z00_543, BNIL); 
BgL_arg1795z00_542 = BgL_list1797z00_544; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1795z00_542); } 
{ /* Llib/mpd.scm 883 */
obj_t BgL_arg1798z00_545;
{ /* Llib/mpd.scm 883 */
obj_t BgL_arg1799z00_546;
BgL_arg1799z00_546 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)42)), BGl_mpdzd2repeatzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 883 */
obj_t BgL_list1800z00_547;
BgL_list1800z00_547 = 
MAKE_YOUNG_PAIR(BgL_arg1799z00_546, BNIL); 
BgL_arg1798z00_545 = BgL_list1800z00_547; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1798z00_545); } 
{ /* Llib/mpd.scm 888 */
obj_t BgL_arg1801z00_548;
{ /* Llib/mpd.scm 888 */
obj_t BgL_arg1802z00_549;
BgL_arg1802z00_549 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)43)), BGl_mpdzd2rmzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 888 */
obj_t BgL_list1803z00_550;
BgL_list1803z00_550 = 
MAKE_YOUNG_PAIR(BgL_arg1802z00_549, BNIL); 
BgL_arg1801z00_548 = BgL_list1803z00_550; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1801z00_548); } 
{ /* Llib/mpd.scm 893 */
obj_t BgL_arg1804z00_551;
{ /* Llib/mpd.scm 893 */
obj_t BgL_arg1805z00_552;
BgL_arg1805z00_552 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)44)), BGl_mpdzd2savezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 893 */
obj_t BgL_list1806z00_553;
BgL_list1806z00_553 = 
MAKE_YOUNG_PAIR(BgL_arg1805z00_552, BNIL); 
BgL_arg1804z00_551 = BgL_list1806z00_553; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1804z00_551); } 
{ /* Llib/mpd.scm 898 */
obj_t BgL_arg1807z00_554;
{ /* Llib/mpd.scm 898 */
obj_t BgL_arg1808z00_555;
BgL_arg1808z00_555 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)45)), BGl_mpdzd2shufflezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 898 */
obj_t BgL_list1809z00_556;
BgL_list1809z00_556 = 
MAKE_YOUNG_PAIR(BgL_arg1808z00_555, BNIL); 
BgL_arg1807z00_554 = BgL_list1809z00_556; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1807z00_554); } 
{ /* Llib/mpd.scm 903 */
obj_t BgL_arg1810z00_557;
{ /* Llib/mpd.scm 903 */
obj_t BgL_arg1811z00_558;
BgL_arg1811z00_558 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)46)), BGl_mpdzd2swapzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 903 */
obj_t BgL_list1812z00_559;
BgL_list1812z00_559 = 
MAKE_YOUNG_PAIR(BgL_arg1811z00_558, BNIL); 
BgL_arg1810z00_557 = BgL_list1812z00_559; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1810z00_557); } 
{ /* Llib/mpd.scm 908 */
obj_t BgL_arg1813z00_560;
{ /* Llib/mpd.scm 908 */
obj_t BgL_arg1814z00_561;
BgL_arg1814z00_561 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)47)), BGl_mpdzd2swapidzd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 908 */
obj_t BgL_list1815z00_562;
BgL_list1815z00_562 = 
MAKE_YOUNG_PAIR(BgL_arg1814z00_561, BNIL); 
BgL_arg1813z00_560 = BgL_list1815z00_562; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1813z00_560); } 
{ /* Llib/mpd.scm 913 */
obj_t BgL_arg1816z00_563;
{ /* Llib/mpd.scm 913 */
obj_t BgL_arg1817z00_564;
BgL_arg1817z00_564 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)48)), BGl_mpdzd2updatezd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 913 */
obj_t BgL_list1818z00_565;
BgL_list1818z00_565 = 
MAKE_YOUNG_PAIR(BgL_arg1817z00_564, BNIL); 
BgL_arg1816z00_563 = BgL_list1818z00_565; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1816z00_563); } 
{ /* Llib/mpd.scm 918 */
obj_t BgL_arg1819z00_566;
{ /* Llib/mpd.scm 918 */
obj_t BgL_arg1820z00_567;
BgL_arg1820z00_567 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)49)), BGl_mpdzd2outputszd2envz00zz__multimediazd2mpdzd2); 
{ /* Llib/mpd.scm 918 */
obj_t BgL_list1821z00_568;
BgL_list1821z00_568 = 
MAKE_YOUNG_PAIR(BgL_arg1820z00_567, BNIL); 
BgL_arg1819z00_566 = BgL_list1821z00_568; } } 
BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2 = 
BGl_appendzd22z12zc0zz__r4_pairs_and_lists_6_3z00(BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2, BgL_arg1819z00_566); } 
return BUNSPEC;} 

}



/* get-line-command */
obj_t BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_6)
{
{ /* Llib/mpd.scm 161 */
{ /* Llib/mpd.scm 162 */
obj_t BgL_iz00_579;
BgL_iz00_579 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_6, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_iz00_579))
{ /* Llib/mpd.scm 164 */
obj_t BgL_arg1825z00_580;
{ /* Llib/mpd.scm 164 */
obj_t BgL_res2718z00_2458;
{ /* Llib/mpd.scm 164 */
long BgL_endz00_2457;
BgL_endz00_2457 = 
(long)CINT(BgL_iz00_579); 
BgL_res2718z00_2458 = 
c_substring(
((obj_t)BgL_linez00_6), ((long)0), BgL_endz00_2457); } 
BgL_arg1825z00_580 = BgL_res2718z00_2458; } 
return 
bstring_to_symbol(BgL_arg1825z00_580);}  else 
{ /* Llib/mpd.scm 165 */
obj_t BgL_res2720z00_2462;
BgL_res2720z00_2462 = 
bstring_to_symbol(
((obj_t)BgL_linez00_6)); 
return BgL_res2720z00_2462;} } } 

}



/* get-line-arg-string-nth */
obj_t BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_7, long BgL_numz00_8)
{
{ /* Llib/mpd.scm 170 */
{ 
obj_t BgL_iz00_594;long BgL_lenz00_595;
{ /* Llib/mpd.scm 182 */
obj_t BgL_i0z00_582;long BgL_lenz00_583;
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2494;
BgL_jz00_2494 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_jz00_2494))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1078z00_2495;
BgL__ortest_1078z00_2495 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_jz00_2494); 
if(
CBOOL(BgL__ortest_1078z00_2495))
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BgL__ortest_1078z00_2495; }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BgL_jz00_2494; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_582 = BFALSE; } } 
BgL_lenz00_583 = 
STRING_LENGTH(
((obj_t)BgL_linez00_7)); 
if(
CBOOL(BgL_i0z00_582))
{ /* Llib/mpd.scm 185 */
long BgL_g1084z00_584;
BgL_g1084z00_584 = 
(BgL_numz00_8-((long)1)); 
{ 
long BgL_nz00_586;obj_t BgL_iz00_587;
BgL_nz00_586 = BgL_g1084z00_584; 
BgL_iz00_587 = BgL_i0z00_582; 
BgL_zc3z04anonymousza31826ze3z87_588:
if(
CBOOL(BgL_iz00_587))
{ /* Llib/mpd.scm 188 */
if(
(BgL_nz00_586==((long)0)))
{ /* Llib/mpd.scm 190 */
if(
CBOOL(BgL_iz00_587))
{ /* Llib/mpd.scm 191 */
BgL_iz00_594 = BgL_iz00_587; 
BgL_lenz00_595 = BgL_lenz00_583; 
if(
(
(long)CINT(BgL_iz00_594)<BgL_lenz00_595))
{ /* Llib/mpd.scm 172 */
if(
(((unsigned char)'"')==
STRING_REF(
((obj_t)BgL_linez00_7), 
(long)CINT(BgL_iz00_594))))
{ /* Llib/mpd.scm 174 */
obj_t BgL_jz00_600;
{ /* Llib/mpd.scm 174 */
long BgL_arg1837z00_603;
BgL_arg1837z00_603 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
BgL_jz00_600 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)'"')), 
BINT(BgL_arg1837z00_603)); } 
if(
CBOOL(BgL_jz00_600))
{ /* Llib/mpd.scm 176 */
long BgL_arg1835z00_601;
BgL_arg1835z00_601 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
{ /* Llib/mpd.scm 176 */
obj_t BgL_res2726z00_2479;
{ /* Llib/mpd.scm 176 */
long BgL_endz00_2478;
BgL_endz00_2478 = 
(long)CINT(BgL_jz00_600); 
BgL_res2726z00_2479 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_arg1835z00_601, BgL_endz00_2478); } 
return BgL_res2726z00_2479;} }  else 
{ /* Llib/mpd.scm 177 */
long BgL_arg1836z00_602;
BgL_arg1836z00_602 = 
(
(long)CINT(BgL_iz00_594)+((long)1)); 
{ /* Llib/mpd.scm 177 */
obj_t BgL_res2728z00_2485;
BgL_res2728z00_2485 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_arg1836z00_602, BgL_lenz00_595); 
return BgL_res2728z00_2485;} } }  else 
{ /* Llib/mpd.scm 178 */
obj_t BgL_jz00_604;
BgL_jz00_604 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_iz00_594); 
if(
CBOOL(BgL_jz00_604))
{ /* Llib/mpd.scm 180 */
obj_t BgL_res2729z00_2489;
{ /* Llib/mpd.scm 180 */
long BgL_startz00_2487;long BgL_endz00_2488;
BgL_startz00_2487 = 
(long)CINT(BgL_iz00_594); 
BgL_endz00_2488 = 
(long)CINT(BgL_jz00_604); 
BgL_res2729z00_2489 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_startz00_2487, BgL_endz00_2488); } 
return BgL_res2729z00_2489;}  else 
{ /* Llib/mpd.scm 181 */
obj_t BgL_res2730z00_2493;
{ /* Llib/mpd.scm 181 */
long BgL_startz00_2491;
BgL_startz00_2491 = 
(long)CINT(BgL_iz00_594); 
BgL_res2730z00_2493 = 
c_substring(
((obj_t)BgL_linez00_7), BgL_startz00_2491, BgL_lenz00_595); } 
return BgL_res2730z00_2493;} } }  else 
{ /* Llib/mpd.scm 172 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 191 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 190 */
if(
(
(long)CINT(BgL_iz00_587)<BgL_lenz00_583))
{ /* Llib/mpd.scm 193 */
long BgL_arg1829z00_591;obj_t BgL_arg1830z00_592;
BgL_arg1829z00_591 = 
(BgL_nz00_586-((long)1)); 
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2507;
BgL_jz00_2507 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_iz00_587); 
if(
CBOOL(BgL_jz00_2507))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1078z00_2508;
BgL__ortest_1078z00_2508 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_7, 
BCHAR(((unsigned char)' ')), BgL_jz00_2507); 
if(
CBOOL(BgL__ortest_1078z00_2508))
{ /* Llib/mpd.scm 156 */
BgL_arg1830z00_592 = BgL__ortest_1078z00_2508; }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1830z00_592 = BgL_jz00_2507; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1830z00_592 = BFALSE; } } 
{ 
obj_t BgL_iz00_6327;long BgL_nz00_6326;
BgL_nz00_6326 = BgL_arg1829z00_591; 
BgL_iz00_6327 = BgL_arg1830z00_592; 
BgL_iz00_587 = BgL_iz00_6327; 
BgL_nz00_586 = BgL_nz00_6326; 
goto BgL_zc3z04anonymousza31826ze3z87_588;} }  else 
{ /* Llib/mpd.scm 192 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 188 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 184 */
return BFALSE;} } } } 

}



/* get-line-arg-symbol-nth */
obj_t BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(obj_t BgL_linez00_9, long BgL_numz00_10)
{
{ /* Llib/mpd.scm 198 */
{ 
obj_t BgL_iz00_620;long BgL_lenz00_621;
{ /* Llib/mpd.scm 205 */
obj_t BgL_i0z00_608;long BgL_lenz00_609;
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2524;
BgL_jz00_2524 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), 
BINT(((long)0))); 
if(
CBOOL(BgL_jz00_2524))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1078z00_2525;
BgL__ortest_1078z00_2525 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_jz00_2524); 
if(
CBOOL(BgL__ortest_1078z00_2525))
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BgL__ortest_1078z00_2525; }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BgL_jz00_2524; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_i0z00_608 = BFALSE; } } 
BgL_lenz00_609 = 
STRING_LENGTH(
((obj_t)BgL_linez00_9)); 
if(
CBOOL(BgL_i0z00_608))
{ /* Llib/mpd.scm 208 */
long BgL_g1085z00_610;
BgL_g1085z00_610 = 
(BgL_numz00_10-((long)1)); 
{ 
long BgL_nz00_612;obj_t BgL_iz00_613;
BgL_nz00_612 = BgL_g1085z00_610; 
BgL_iz00_613 = BgL_i0z00_608; 
BgL_zc3z04anonymousza31839ze3z87_614:
if(
CBOOL(BgL_iz00_613))
{ /* Llib/mpd.scm 211 */
if(
(BgL_nz00_612==((long)0)))
{ /* Llib/mpd.scm 213 */
BgL_iz00_620 = BgL_iz00_613; 
BgL_lenz00_621 = BgL_lenz00_609; 
if(
(
(long)CINT(BgL_iz00_620)<BgL_lenz00_621))
{ /* Llib/mpd.scm 201 */
obj_t BgL_jz00_624;
BgL_jz00_624 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_iz00_620); 
if(
CBOOL(BgL_jz00_624))
{ /* Llib/mpd.scm 203 */
obj_t BgL_arg1846z00_625;
{ /* Llib/mpd.scm 203 */
obj_t BgL_arg1847z00_626;
{ /* Llib/mpd.scm 203 */
obj_t BgL_res2737z00_2515;
{ /* Llib/mpd.scm 203 */
long BgL_startz00_2513;long BgL_endz00_2514;
BgL_startz00_2513 = 
(long)CINT(BgL_iz00_620); 
BgL_endz00_2514 = 
(long)CINT(BgL_jz00_624); 
BgL_res2737z00_2515 = 
c_substring(
((obj_t)BgL_linez00_9), BgL_startz00_2513, BgL_endz00_2514); } 
BgL_arg1847z00_626 = BgL_res2737z00_2515; } 
BgL_arg1846z00_625 = 
BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(BgL_arg1847z00_626); } 
return 
bstring_to_symbol(BgL_arg1846z00_625);}  else 
{ /* Llib/mpd.scm 204 */
obj_t BgL_arg1848z00_627;
{ /* Llib/mpd.scm 204 */
obj_t BgL_arg1849z00_628;
{ /* Llib/mpd.scm 204 */
obj_t BgL_res2739z00_2521;
{ /* Llib/mpd.scm 204 */
long BgL_startz00_2519;
BgL_startz00_2519 = 
(long)CINT(BgL_iz00_620); 
BgL_res2739z00_2521 = 
c_substring(
((obj_t)BgL_linez00_9), BgL_startz00_2519, BgL_lenz00_621); } 
BgL_arg1849z00_628 = BgL_res2739z00_2521; } 
BgL_arg1848z00_627 = 
BGl_stringzd2downcasez12zc0zz__r4_strings_6_7z00(BgL_arg1849z00_628); } 
return 
bstring_to_symbol(BgL_arg1848z00_627);} }  else 
{ /* Llib/mpd.scm 200 */
return BFALSE;} }  else 
{ /* Llib/mpd.scm 213 */
if(
(
(long)CINT(BgL_iz00_613)<BgL_lenz00_609))
{ /* Llib/mpd.scm 216 */
long BgL_arg1842z00_617;obj_t BgL_arg1843z00_618;
BgL_arg1842z00_617 = 
(BgL_nz00_612-((long)1)); 
{ /* Llib/mpd.scm 155 */
obj_t BgL_jz00_2537;
BgL_jz00_2537 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_iz00_613); 
if(
CBOOL(BgL_jz00_2537))
{ /* Llib/mpd.scm 156 */
obj_t BgL__ortest_1078z00_2538;
BgL__ortest_1078z00_2538 = 
BGl_stringzd2skipzd2zz__r4_strings_6_7z00(BgL_linez00_9, 
BCHAR(((unsigned char)' ')), BgL_jz00_2537); 
if(
CBOOL(BgL__ortest_1078z00_2538))
{ /* Llib/mpd.scm 156 */
BgL_arg1843z00_618 = BgL__ortest_1078z00_2538; }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1843z00_618 = BgL_jz00_2537; } }  else 
{ /* Llib/mpd.scm 156 */
BgL_arg1843z00_618 = BFALSE; } } 
{ 
obj_t BgL_iz00_6377;long BgL_nz00_6376;
BgL_nz00_6376 = BgL_arg1842z00_617; 
BgL_iz00_6377 = BgL_arg1843z00_618; 
BgL_iz00_613 = BgL_iz00_6377; 
BgL_nz00_612 = BgL_nz00_6376; 
goto BgL_zc3z04anonymousza31839ze3z87_614;} }  else 
{ /* Llib/mpd.scm 215 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 211 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 207 */
return BFALSE;} } } } 

}



/* _mpd */
obj_t BGl__mpdz00zz__multimediazd2mpdzd2(obj_t BgL_env1320z00_19, obj_t BgL_opt1319z00_18)
{
{ /* Llib/mpd.scm 230 */
{ 
obj_t BgL_k1z00_633;long BgL_iz00_634;
{ /* Llib/mpd.scm 230 */
obj_t BgL_g1326z00_636;obj_t BgL_g1327z00_637;obj_t BgL_g1328z00_638;obj_t BgL_g1329z00_639;
BgL_g1326z00_636 = 
VECTOR_REF(BgL_opt1319z00_18,((long)0)); 
BgL_g1327z00_637 = 
VECTOR_REF(BgL_opt1319z00_18,((long)1)); 
BgL_g1328z00_638 = 
VECTOR_REF(BgL_opt1319z00_18,((long)2)); 
BgL_g1329z00_639 = 
VECTOR_REF(BgL_opt1319z00_18,((long)3)); 
{ /* Llib/mpd.scm 230 */
obj_t BgL_logz00_640;
BgL_logz00_640 = BFALSE; 
{ /* Llib/mpd.scm 230 */

{ 
long BgL_iz00_641;
BgL_iz00_641 = ((long)4); 
BgL_check1323z00_642:
if(
(BgL_iz00_641==
VECTOR_LENGTH(BgL_opt1319z00_18)))
{ /* Llib/mpd.scm 230 */BNIL; }  else 
{ /* Llib/mpd.scm 230 */
bool_t BgL_test3836z00_6385;
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1856z00_648;
BgL_arg1856z00_648 = 
VECTOR_REF(BgL_opt1319z00_18,BgL_iz00_641); 
BgL_test3836z00_6385 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1856z00_648, 
CNST_TABLE_REF(((long)51)))); } 
if(BgL_test3836z00_6385)
{ 
long BgL_iz00_6390;
BgL_iz00_6390 = 
(BgL_iz00_641+((long)2)); 
BgL_iz00_641 = BgL_iz00_6390; 
goto BgL_check1323z00_642;}  else 
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1855z00_647;
BgL_arg1855z00_647 = 
VECTOR_REF(BgL_opt1319z00_18,BgL_iz00_641); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)50)), BGl_string3365z00zz__multimediazd2mpdzd2, BgL_arg1855z00_647); } } } 
{ /* Llib/mpd.scm 230 */
obj_t BgL_index1325z00_649;
BgL_k1z00_633 = 
CNST_TABLE_REF(((long)52)); 
BgL_iz00_634 = ((long)4); 
BgL_search1322z00_635:
if(
(BgL_iz00_634==
VECTOR_LENGTH(BgL_opt1319z00_18)))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BINT(((long)-1)); }  else 
{ /* Llib/mpd.scm 230 */
if(
(BgL_iz00_634==
(
VECTOR_LENGTH(BgL_opt1319z00_18)-((long)1))))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)50)), BGl_string3364z00zz__multimediazd2mpdzd2, 
BINT(
VECTOR_LENGTH(BgL_opt1319z00_18))); }  else 
{ /* Llib/mpd.scm 230 */
obj_t BgL_vz00_660;
BgL_vz00_660 = 
VECTOR_REF(BgL_opt1319z00_18,BgL_iz00_634); 
if(
(BgL_vz00_660==BgL_k1z00_633))
{ /* Llib/mpd.scm 230 */
BgL_index1325z00_649 = 
BINT(
(BgL_iz00_634+((long)1))); }  else 
{ 
long BgL_iz00_6412;
BgL_iz00_6412 = 
(BgL_iz00_634+((long)2)); 
BgL_iz00_634 = BgL_iz00_6412; 
goto BgL_search1322z00_635;} } } 
{ /* Llib/mpd.scm 230 */
bool_t BgL_test3840z00_6415;
{ /* Llib/mpd.scm 230 */
long BgL_n1z00_2564;
{ /* Llib/mpd.scm 230 */
obj_t BgL_tmpz00_6416;
if(
INTEGERP(BgL_index1325z00_649))
{ /* Llib/mpd.scm 230 */
BgL_tmpz00_6416 = BgL_index1325z00_649
; }  else 
{ 
obj_t BgL_auxz00_6419;
BgL_auxz00_6419 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3367z00zz__multimediazd2mpdzd2, BGl_string3368z00zz__multimediazd2mpdzd2, BgL_index1325z00_649); 
FAILURE(BgL_auxz00_6419,BFALSE,BFALSE);} 
BgL_n1z00_2564 = 
(long)CINT(BgL_tmpz00_6416); } 
BgL_test3840z00_6415 = 
(BgL_n1z00_2564>=((long)0)); } 
if(BgL_test3840z00_6415)
{ 
long BgL_auxz00_6425;
{ /* Llib/mpd.scm 230 */
obj_t BgL_tmpz00_6426;
if(
INTEGERP(BgL_index1325z00_649))
{ /* Llib/mpd.scm 230 */
BgL_tmpz00_6426 = BgL_index1325z00_649
; }  else 
{ 
obj_t BgL_auxz00_6429;
BgL_auxz00_6429 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3367z00zz__multimediazd2mpdzd2, BGl_string3368z00zz__multimediazd2mpdzd2, BgL_index1325z00_649); 
FAILURE(BgL_auxz00_6429,BFALSE,BFALSE);} 
BgL_auxz00_6425 = 
(long)CINT(BgL_tmpz00_6426); } 
BgL_logz00_640 = 
VECTOR_REF(BgL_opt1319z00_18,BgL_auxz00_6425); }  else 
{ /* Llib/mpd.scm 230 */BFALSE; } } } 
{ /* Llib/mpd.scm 230 */
obj_t BgL_arg1858z00_651;obj_t BgL_arg1859z00_652;obj_t BgL_arg1860z00_653;obj_t BgL_arg1861z00_654;
BgL_arg1858z00_651 = 
VECTOR_REF(BgL_opt1319z00_18,((long)0)); 
BgL_arg1859z00_652 = 
VECTOR_REF(BgL_opt1319z00_18,((long)1)); 
BgL_arg1860z00_653 = 
VECTOR_REF(BgL_opt1319z00_18,((long)2)); 
BgL_arg1861z00_654 = 
VECTOR_REF(BgL_opt1319z00_18,((long)3)); 
{ /* Llib/mpd.scm 230 */
obj_t BgL_logz00_655;
BgL_logz00_655 = BgL_logz00_640; 
{ /* Llib/mpd.scm 230 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_6461;obj_t BgL_auxz00_6454;obj_t BgL_auxz00_6447;BgL_musicz00_bglt BgL_auxz00_6439;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1861z00_654, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6461 = 
((BgL_mpdzd2databasezd2_bglt)BgL_arg1861z00_654)
; }  else 
{ 
obj_t BgL_auxz00_6465;
BgL_auxz00_6465 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3367z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_arg1861z00_654); 
FAILURE(BgL_auxz00_6465,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_arg1860z00_653))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6454 = BgL_arg1860z00_653
; }  else 
{ 
obj_t BgL_auxz00_6457;
BgL_auxz00_6457 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3367z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_arg1860z00_653); 
FAILURE(BgL_auxz00_6457,BFALSE,BFALSE);} 
if(
INPUT_PORTP(BgL_arg1859z00_652))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6447 = BgL_arg1859z00_652
; }  else 
{ 
obj_t BgL_auxz00_6450;
BgL_auxz00_6450 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3367z00zz__multimediazd2mpdzd2, BGl_string3370z00zz__multimediazd2mpdzd2, BgL_arg1859z00_652); 
FAILURE(BgL_auxz00_6450,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1858z00_651, BGl_musicz00zz__multimediazd2musiczd2))
{ /* Llib/mpd.scm 230 */
BgL_auxz00_6439 = 
((BgL_musicz00_bglt)BgL_arg1858z00_651)
; }  else 
{ 
obj_t BgL_auxz00_6443;
BgL_auxz00_6443 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)9602)), BGl_string3367z00zz__multimediazd2mpdzd2, BGl_string3369z00zz__multimediazd2mpdzd2, BgL_arg1858z00_651); 
FAILURE(BgL_auxz00_6443,BFALSE,BFALSE);} 
return 
BGl_mpdz00zz__multimediazd2mpdzd2(BgL_auxz00_6439, BgL_auxz00_6447, BgL_auxz00_6454, BgL_auxz00_6461, BgL_logz00_655);} } } } } } } } 

}



/* mpd */
BGL_EXPORTED_DEF obj_t BGl_mpdz00zz__multimediazd2mpdzd2(BgL_musicz00_bglt BgL_backendz00_13, obj_t BgL_ipz00_14, obj_t BgL_opz00_15, BgL_mpdzd2databasezd2_bglt BgL_dbz00_16, obj_t BgL_logz00_17)
{
{ /* Llib/mpd.scm 230 */
bgl_display_obj(BGl_string3373z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_char(((unsigned char)10), BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
{ 

BgL_zc3z04anonymousza31870ze3z87_666:
if(
BGl_musiczd2closedzf3z21zz__multimediazd2musiczd2(BgL_backendz00_13))
{ /* Llib/mpd.scm 237 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 238 */
obj_t BgL_linez00_668;
BgL_linez00_668 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_ipz00_14); 
BGl_cmdnz00zz__multimediazd2mpdzd2 = 
(((long)1)+BGl_cmdnz00zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_logz00_17))
{ /* Llib/mpd.scm 240 */
PROCEDURE_ENTRY(BgL_logz00_17)(BgL_logz00_17, BgL_linez00_668, BEOA); }  else 
{ /* Llib/mpd.scm 240 */BFALSE; } 
{ /* Llib/mpd.scm 241 */
bool_t BgL_test3849z00_6483;
{ /* Llib/mpd.scm 241 */
bool_t BgL_res2756z00_2570;
BgL_res2756z00_2570 = 
EOF_OBJECTP(BgL_linez00_668); 
BgL_test3849z00_6483 = BgL_res2756z00_2570; } 
if(BgL_test3849z00_6483)
{ /* Llib/mpd.scm 241 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 242 */
obj_t BgL_vz00_670;
BgL_vz00_670 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_16, BgL_backendz00_13, BgL_ipz00_14, BgL_opz00_15, BgL_linez00_668); 
if(
(BgL_vz00_670==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 243 */
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
goto BgL_zc3z04anonymousza31870ze3z87_666;}  else 
{ /* Llib/mpd.scm 243 */
bool_t BgL_test3851z00_6492;
{ /* Llib/mpd.scm 243 */
bool_t BgL__ortest_1087z00_678;
BgL__ortest_1087z00_678 = 
(BgL_vz00_670==
CNST_TABLE_REF(((long)24))); 
if(BgL__ortest_1087z00_678)
{ /* Llib/mpd.scm 243 */
BgL_test3851z00_6492 = BgL__ortest_1087z00_678
; }  else 
{ /* Llib/mpd.scm 243 */
BgL_test3851z00_6492 = 
(BgL_vz00_670==
CNST_TABLE_REF(((long)31)))
; } } 
if(BgL_test3851z00_6492)
{ /* Llib/mpd.scm 243 */
return 
bgl_flush_output_port(BgL_opz00_15);}  else 
{ /* Llib/mpd.scm 243 */
if(
(BgL_vz00_670==
CNST_TABLE_REF(((long)54))))
{ /* Llib/mpd.scm 243 */
goto BgL_zc3z04anonymousza31870ze3z87_666;}  else 
{ /* Llib/mpd.scm 243 */
bgl_display_string(BGl_string3375z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BGl_string3376z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_string(BGl_string3377z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BGl_string3363z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_string(BGl_string3378z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_display_obj(BgL_vz00_670, BgL_opz00_15); 
bgl_display_string(BGl_string3379z00zz__multimediazd2mpdzd2, BgL_opz00_15); 
bgl_flush_output_port(BgL_opz00_15); 
CNST_TABLE_REF(((long)54)); 
goto BgL_zc3z04anonymousza31870ze3z87_666;} } } } } } } } 

}



/* execute-command */
obj_t BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_20, BgL_musicz00_bglt BgL_backendz00_21, obj_t BgL_ipz00_22, obj_t BgL_opz00_23, obj_t BgL_linez00_24)
{
{ /* Llib/mpd.scm 259 */
{ /* Llib/mpd.scm 260 */
obj_t BgL_cmdz00_680;
BgL_cmdz00_680 = 
BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(BgL_linez00_24); 
{ /* Llib/mpd.scm 262 */
bool_t BgL_test3854z00_6512;
if(
(BgL_cmdz00_680==
CNST_TABLE_REF(((long)55))))
{ /* Llib/mpd.scm 262 */
BgL_test3854z00_6512 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 262 */
BgL_test3854z00_6512 = 
(BgL_cmdz00_680==
CNST_TABLE_REF(((long)56)))
; } 
if(BgL_test3854z00_6512)
{ /* Llib/mpd.scm 262 */
return 
BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_dbz00_20, BgL_backendz00_21, BgL_ipz00_22, BgL_opz00_23, BgL_cmdz00_680);}  else 
{ /* Llib/mpd.scm 265 */
obj_t BgL_g1088z00_683;
BgL_g1088z00_683 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_cmdz00_680, BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_g1088z00_683))
{ /* Llib/mpd.scm 267 */
obj_t BgL_fun1878z00_686;
BgL_fun1878z00_686 = 
CDR(
((obj_t)BgL_g1088z00_683)); 
return 
PROCEDURE_ENTRY(BgL_fun1878z00_686)(BgL_fun1878z00_686, 
((obj_t)BgL_dbz00_20), 
((obj_t)BgL_backendz00_21), BgL_linez00_24, BgL_ipz00_22, BgL_opz00_23, BEOA);}  else 
{ /* Llib/mpd.scm 268 */
obj_t BgL_g1091z00_687;
BgL_g1091z00_687 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(BgL_cmdz00_680, BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2); 
if(
CBOOL(BgL_g1091z00_687))
{ /* Llib/mpd.scm 270 */
obj_t BgL_fun1879z00_690;
BgL_fun1879z00_690 = 
CDR(
((obj_t)BgL_g1091z00_687)); 
return 
PROCEDURE_ENTRY(BgL_fun1879z00_690)(BgL_fun1879z00_690, 
((obj_t)BgL_dbz00_20), 
((obj_t)BgL_backendz00_21), BgL_linez00_24, BgL_ipz00_22, BgL_opz00_23, BEOA);}  else 
{ /* Llib/mpd.scm 268 */
if(
(
STRING_LENGTH(BgL_linez00_24)>((long)0)))
{ /* Llib/mpd.scm 273 */
obj_t BgL_list1882z00_693;
BgL_list1882z00_693 = 
MAKE_YOUNG_PAIR(BgL_linez00_24, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3380z00zz__multimediazd2mpdzd2, BgL_list1882z00_693);}  else 
{ /* Llib/mpd.scm 272 */
return 
CNST_TABLE_REF(((long)54));} } } } } } } 

}



/* mpd-list-begin */
obj_t BGl_mpdzd2listzd2beginz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_25, BgL_musicz00_bglt BgL_backendz00_26, obj_t BgL_ipz00_27, obj_t BgL_opz00_28, obj_t BgL_cmdz00_29)
{
{ /* Llib/mpd.scm 279 */
{ 
obj_t BgL_linesz00_698;
BgL_linesz00_698 = BNIL; 
BgL_zc3z04anonymousza31884ze3z87_699:
{ /* Llib/mpd.scm 281 */
obj_t BgL_linez00_700;
BgL_linez00_700 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_ipz00_27); 
{ /* Llib/mpd.scm 282 */
bool_t BgL_test3859z00_6556;
{ /* Llib/mpd.scm 282 */
bool_t BgL_res2761z00_2595;
BgL_res2761z00_2595 = 
EOF_OBJECTP(BgL_linez00_700); 
BgL_test3859z00_6556 = BgL_res2761z00_2595; } 
if(BgL_test3859z00_6556)
{ /* Llib/mpd.scm 282 */
return BFALSE;}  else 
{ /* Llib/mpd.scm 283 */
obj_t BgL_cz00_702;
BgL_cz00_702 = 
BGl_getzd2linezd2commandz00zz__multimediazd2mpdzd2(BgL_linez00_700); 
if(
(BgL_cz00_702==
CNST_TABLE_REF(((long)57))))
{ /* Llib/mpd.scm 284 */
if(
(BgL_cmdz00_29==
CNST_TABLE_REF(((long)55))))
{ /* Llib/mpd.scm 287 */
obj_t BgL_g1094z00_705;
BgL_g1094z00_705 = 
bgl_reverse_bang(BgL_linesz00_698); 
{ 
obj_t BgL_lsz00_707;
BgL_lsz00_707 = BgL_g1094z00_705; 
BgL_zc3z04anonymousza31888ze3z87_708:
if(
NULLP(BgL_lsz00_707))
{ /* Llib/mpd.scm 288 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 290 */
obj_t BgL_lz00_710;
BgL_lz00_710 = 
CAR(
((obj_t)BgL_lsz00_707)); 
{ /* Llib/mpd.scm 290 */
obj_t BgL_vz00_711;
BgL_vz00_711 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_25, BgL_backendz00_26, BgL_ipz00_27, BgL_opz00_28, BgL_lz00_710); 
{ /* Llib/mpd.scm 291 */

if(
(BgL_vz00_711==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 293 */
obj_t BgL_arg1891z00_713;
BgL_arg1891z00_713 = 
CDR(
((obj_t)BgL_lsz00_707)); 
{ 
obj_t BgL_lsz00_6577;
BgL_lsz00_6577 = BgL_arg1891z00_713; 
BgL_lsz00_707 = BgL_lsz00_6577; 
goto BgL_zc3z04anonymousza31888ze3z87_708;} }  else 
{ /* Llib/mpd.scm 292 */
return BgL_vz00_711;} } } } } }  else 
{ /* Llib/mpd.scm 286 */
if(
(BgL_cmdz00_29==
CNST_TABLE_REF(((long)56))))
{ /* Llib/mpd.scm 296 */
obj_t BgL_g1095z00_716;
BgL_g1095z00_716 = 
bgl_reverse_bang(BgL_linesz00_698); 
{ 
obj_t BgL_lsz00_718;
BgL_lsz00_718 = BgL_g1095z00_716; 
BgL_zc3z04anonymousza31893ze3z87_719:
if(
NULLP(BgL_lsz00_718))
{ /* Llib/mpd.scm 297 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 299 */
obj_t BgL_lz00_721;
BgL_lz00_721 = 
CAR(
((obj_t)BgL_lsz00_718)); 
{ /* Llib/mpd.scm 299 */
obj_t BgL_vz00_722;
BgL_vz00_722 = 
BGl_executezd2commandzd2zz__multimediazd2mpdzd2(BgL_dbz00_25, BgL_backendz00_26, BgL_ipz00_27, BgL_opz00_28, BgL_lz00_721); 
{ /* Llib/mpd.scm 300 */

if(
(BgL_vz00_722==
CNST_TABLE_REF(((long)53))))
{ /* Llib/mpd.scm 301 */
bgl_display_string(BGl_string3381z00zz__multimediazd2mpdzd2, BgL_opz00_28); 
{ /* Llib/mpd.scm 304 */
obj_t BgL_arg1896z00_724;
BgL_arg1896z00_724 = 
CDR(
((obj_t)BgL_lsz00_718)); 
{ 
obj_t BgL_lsz00_6594;
BgL_lsz00_6594 = BgL_arg1896z00_724; 
BgL_lsz00_718 = BgL_lsz00_6594; 
goto BgL_zc3z04anonymousza31893ze3z87_719;} } }  else 
{ /* Llib/mpd.scm 301 */
return BgL_vz00_722;} } } } } }  else 
{ /* Llib/mpd.scm 295 */
return BFALSE;} } }  else 
{ /* Llib/mpd.scm 306 */
obj_t BgL_arg1897z00_726;
BgL_arg1897z00_726 = 
MAKE_YOUNG_PAIR(BgL_linez00_700, BgL_linesz00_698); 
{ 
obj_t BgL_linesz00_6596;
BgL_linesz00_6596 = BgL_arg1897z00_726; 
BgL_linesz00_698 = BgL_linesz00_6596; 
goto BgL_zc3z04anonymousza31884ze3z87_699;} } } } } } } 

}



/* search1333~0 */
obj_t BGl_search1333ze70ze7zz__multimediazd2mpdzd2(obj_t BgL_l1332z00_5359, obj_t BgL_opt1330z00_5358, obj_t BgL_k1z00_729, obj_t BgL_iz00_730)
{
{ /* Llib/mpd.scm 324 */
BGl_search1333ze70ze7zz__multimediazd2mpdzd2:
if(
(
(long)CINT(BgL_iz00_730)==
(long)CINT(BgL_l1332z00_5359)))
{ /* Llib/mpd.scm 324 */
return 
BINT(((long)-1));}  else 
{ /* Llib/mpd.scm 324 */
if(
(
(long)CINT(BgL_iz00_730)==
(long)CINT(
SUBFX(BgL_l1332z00_5359, 
BINT(((long)1))))))
{ /* Llib/mpd.scm 324 */
obj_t BgL_arg1911z00_755;
BgL_arg1911z00_755 = 
BINT(
VECTOR_LENGTH(BgL_opt1330z00_5358)); 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)59)), BGl_string3382z00zz__multimediazd2mpdzd2, BgL_arg1911z00_755);}  else 
{ /* Llib/mpd.scm 324 */
obj_t BgL_vz00_756;
BgL_vz00_756 = 
VECTOR_REF(BgL_opt1330z00_5358,
(long)CINT(BgL_iz00_730)); 
if(
(BgL_vz00_756==BgL_k1z00_729))
{ /* Llib/mpd.scm 324 */
return 
ADDFX(BgL_iz00_730, 
BINT(((long)1)));}  else 
{ 
obj_t BgL_iz00_6618;
BgL_iz00_6618 = 
ADDFX(BgL_iz00_730, 
BINT(((long)2))); 
BgL_iz00_730 = BgL_iz00_6618; 
goto BGl_search1333ze70ze7zz__multimediazd2mpdzd2;} } } } 

}



/* &mpd-ping */
obj_t BGl_z62mpdzd2pingzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4650, obj_t BgL_dbz00_4651, obj_t BgL_backendz00_4652, obj_t BgL_linez00_4653, obj_t BgL_ipz00_4654, obj_t BgL_opz00_4655)
{
{ /* Llib/mpd.scm 338 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-urlhandlers */
obj_t BGl_z62mpdzd2urlhandlerszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4656, obj_t BgL_dbz00_4657, obj_t BgL_backendz00_4658, obj_t BgL_linez00_4659, obj_t BgL_ipz00_4660, obj_t BgL_opz00_4661)
{
{ /* Llib/mpd.scm 344 */
{ /* Llib/mpd.scm 345 */
bool_t BgL_tmpz00_6622;
{ /* Llib/mpd.scm 345 */
obj_t BgL_g1179z00_5510;
BgL_g1179z00_5510 = 
CNST_TABLE_REF(((long)62)); 
{ 
obj_t BgL_l1177z00_5512;
BgL_l1177z00_5512 = BgL_g1179z00_5510; 
BgL_zc3z04anonymousza31915ze3z87_5511:
if(
PAIRP(BgL_l1177z00_5512))
{ /* Llib/mpd.scm 349 */
{ /* Llib/mpd.scm 346 */
obj_t BgL_handlerz00_5513;
BgL_handlerz00_5513 = 
CAR(BgL_l1177z00_5512); 
{ /* Llib/mpd.scm 346 */
obj_t BgL_tmpz00_6627;
BgL_tmpz00_6627 = 
((obj_t)BgL_opz00_4661); 
bgl_display_string(BGl_string3383z00zz__multimediazd2mpdzd2, BgL_tmpz00_6627); } 
bgl_display_obj(BgL_handlerz00_5513, BgL_opz00_4661); 
{ /* Llib/mpd.scm 348 */
obj_t BgL_tmpz00_6631;
BgL_tmpz00_6631 = 
((obj_t)BgL_opz00_4661); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6631); } } 
{ 
obj_t BgL_l1177z00_6634;
BgL_l1177z00_6634 = 
CDR(BgL_l1177z00_5512); 
BgL_l1177z00_5512 = BgL_l1177z00_6634; 
goto BgL_zc3z04anonymousza31915ze3z87_5511;} }  else 
{ /* Llib/mpd.scm 349 */
BgL_tmpz00_6622 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_6622);} } 

}



/* &mpd-tagtypes */
obj_t BGl_z62mpdzd2tagtypeszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4662, obj_t BgL_dbz00_4663, obj_t BgL_backendz00_4664, obj_t BgL_linez00_4665, obj_t BgL_ipz00_4666, obj_t BgL_opz00_4667)
{
{ /* Llib/mpd.scm 354 */
{ /* Llib/mpd.scm 355 */
bool_t BgL_tmpz00_6637;
{ /* Llib/mpd.scm 355 */
obj_t BgL_g1182z00_5514;
BgL_g1182z00_5514 = 
CNST_TABLE_REF(((long)63)); 
{ 
obj_t BgL_l1180z00_5516;
BgL_l1180z00_5516 = BgL_g1182z00_5514; 
BgL_zc3z04anonymousza31918ze3z87_5515:
if(
PAIRP(BgL_l1180z00_5516))
{ /* Llib/mpd.scm 359 */
{ /* Llib/mpd.scm 356 */
obj_t BgL_tagz00_5517;
BgL_tagz00_5517 = 
CAR(BgL_l1180z00_5516); 
{ /* Llib/mpd.scm 356 */
obj_t BgL_tmpz00_6642;
BgL_tmpz00_6642 = 
((obj_t)BgL_opz00_4667); 
bgl_display_string(BGl_string3384z00zz__multimediazd2mpdzd2, BgL_tmpz00_6642); } 
bgl_display_obj(BgL_tagz00_5517, BgL_opz00_4667); 
{ /* Llib/mpd.scm 358 */
obj_t BgL_tmpz00_6646;
BgL_tmpz00_6646 = 
((obj_t)BgL_opz00_4667); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6646); } } 
{ 
obj_t BgL_l1180z00_6649;
BgL_l1180z00_6649 = 
CDR(BgL_l1180z00_5516); 
BgL_l1180z00_5516 = BgL_l1180z00_6649; 
goto BgL_zc3z04anonymousza31918ze3z87_5515;} }  else 
{ /* Llib/mpd.scm 359 */
BgL_tmpz00_6637 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_6637);} } 

}



/* &mpd-status */
obj_t BGl_z62mpdzd2statuszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4668, obj_t BgL_dbz00_4669, obj_t BgL_backendz00_4670, obj_t BgL_linez00_4671, obj_t BgL_ipz00_4672, obj_t BgL_opz00_4673)
{
{ /* Llib/mpd.scm 371 */
{ /* Llib/mpd.scm 372 */
BgL_musicstatusz00_bglt BgL_statusz00_5518;
BgL_statusz00_5518 = 
BGl_musiczd2statuszd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4670)); 
{ /* Llib/mpd.scm 376 */
obj_t BgL_volz00_5519;
{ /* Llib/mpd.scm 376 */
bool_t BgL_test3872z00_6654;
{ /* Llib/mpd.scm 376 */
obj_t BgL_tmpz00_6655;
BgL_tmpz00_6655 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_volumez00); 
BgL_test3872z00_6654 = 
VECTORP(BgL_tmpz00_6655); } 
if(BgL_test3872z00_6654)
{ /* Llib/mpd.scm 376 */
obj_t BgL_arg1923z00_5520;
BgL_arg1923z00_5520 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_volumez00); 
BgL_volz00_5519 = 
VECTOR_REF(
((obj_t)BgL_arg1923z00_5520),((long)0)); }  else 
{ /* Llib/mpd.scm 376 */
BgL_volz00_5519 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_volumez00); } } 
{ /* Llib/mpd.scm 377 */
obj_t BgL_tmpz00_6662;
BgL_tmpz00_6662 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3385z00zz__multimediazd2mpdzd2, BgL_tmpz00_6662); } 
bgl_display_obj(BgL_volz00_5519, BgL_opz00_4673); 
{ /* Llib/mpd.scm 377 */
obj_t BgL_tmpz00_6666;
BgL_tmpz00_6666 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6666); } } 
{ /* Llib/mpd.scm 378 */
obj_t BgL_tmpz00_6669;
BgL_tmpz00_6669 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3386z00zz__multimediazd2mpdzd2, BgL_tmpz00_6669); } 
bgl_display_obj(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_statez00), BgL_opz00_4673); 
{ /* Llib/mpd.scm 378 */
obj_t BgL_tmpz00_6674;
BgL_tmpz00_6674 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6674); } 
{ /* Llib/mpd.scm 379 */
obj_t BgL_tmpz00_6677;
BgL_tmpz00_6677 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3387z00zz__multimediazd2mpdzd2, BgL_tmpz00_6677); } 
{ /* Llib/mpd.scm 379 */
int BgL_arg1926z00_5521;
BgL_arg1926z00_5521 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_playlistidz00); 
bgl_display_obj(
BINT(BgL_arg1926z00_5521), BgL_opz00_4673); } 
{ /* Llib/mpd.scm 379 */
obj_t BgL_tmpz00_6683;
BgL_tmpz00_6683 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6683); } 
{ /* Llib/mpd.scm 380 */
obj_t BgL_tmpz00_6686;
BgL_tmpz00_6686 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3388z00zz__multimediazd2mpdzd2, BgL_tmpz00_6686); } 
{ /* Llib/mpd.scm 380 */
int BgL_arg1927z00_5522;
BgL_arg1927z00_5522 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_playlistlengthz00); 
bgl_display_obj(
BINT(BgL_arg1927z00_5522), BgL_opz00_4673); } 
{ /* Llib/mpd.scm 380 */
obj_t BgL_tmpz00_6692;
BgL_tmpz00_6692 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6692); } 
if(
(
(long)(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_songz00))>=((long)0)))
{ /* Llib/mpd.scm 381 */
{ /* Llib/mpd.scm 382 */
obj_t BgL_tmpz00_6699;
BgL_tmpz00_6699 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3389z00zz__multimediazd2mpdzd2, BgL_tmpz00_6699); } 
{ /* Llib/mpd.scm 382 */
int BgL_arg1930z00_5523;
BgL_arg1930z00_5523 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_songz00); 
bgl_display_obj(
BINT(BgL_arg1930z00_5523), BgL_opz00_4673); } 
{ /* Llib/mpd.scm 382 */
obj_t BgL_tmpz00_6705;
BgL_tmpz00_6705 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6705); } 
{ /* Llib/mpd.scm 383 */
obj_t BgL_tmpz00_6708;
BgL_tmpz00_6708 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3390z00zz__multimediazd2mpdzd2, BgL_tmpz00_6708); } 
{ /* Llib/mpd.scm 383 */
int BgL_arg1931z00_5524;
BgL_arg1931z00_5524 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_songidz00); 
bgl_display_obj(
BINT(BgL_arg1931z00_5524), BgL_opz00_4673); } 
{ /* Llib/mpd.scm 383 */
obj_t BgL_tmpz00_6714;
BgL_tmpz00_6714 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6714); } 
{ /* Llib/mpd.scm 384 */
obj_t BgL_tmpz00_6717;
BgL_tmpz00_6717 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3391z00zz__multimediazd2mpdzd2, BgL_tmpz00_6717); } 
{ /* Llib/mpd.scm 384 */
int BgL_arg1932z00_5525;
BgL_arg1932z00_5525 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_bitratez00); 
bgl_display_obj(
BINT(BgL_arg1932z00_5525), BgL_opz00_4673); } 
{ /* Llib/mpd.scm 384 */
obj_t BgL_tmpz00_6723;
BgL_tmpz00_6723 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6723); } 
{ /* Llib/mpd.scm 385 */
obj_t BgL_tmpz00_6726;
BgL_tmpz00_6726 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3392z00zz__multimediazd2mpdzd2, BgL_tmpz00_6726); } 
{ /* Llib/mpd.scm 386 */
int BgL_arg1933z00_5526;
BgL_arg1933z00_5526 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_khza7za7); 
bgl_display_obj(
BINT(BgL_arg1933z00_5526), BgL_opz00_4673); } 
{ /* Llib/mpd.scm 387 */
obj_t BgL_tmpz00_6732;
BgL_tmpz00_6732 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3393z00zz__multimediazd2mpdzd2, BgL_tmpz00_6732); } }  else 
{ /* Llib/mpd.scm 381 */BFALSE; } 
{ /* Llib/mpd.scm 388 */
bool_t BgL_test3874z00_6735;
if(
(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_statez00)==
CNST_TABLE_REF(((long)13))))
{ /* Llib/mpd.scm 388 */
BgL_test3874z00_6735 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 388 */
BgL_test3874z00_6735 = 
(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_statez00)==
CNST_TABLE_REF(((long)18)))
; } 
if(BgL_test3874z00_6735)
{ /* Llib/mpd.scm 388 */
{ /* Llib/mpd.scm 389 */
obj_t BgL_tmpz00_6743;
BgL_tmpz00_6743 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3394z00zz__multimediazd2mpdzd2, BgL_tmpz00_6743); } 
bgl_display_obj(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_songposz00), BgL_opz00_4673); 
{ /* Llib/mpd.scm 391 */
obj_t BgL_tmpz00_6748;
BgL_tmpz00_6748 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3395z00zz__multimediazd2mpdzd2, BgL_tmpz00_6748); } 
{ /* Llib/mpd.scm 392 */
int BgL_arg1941z00_5527;
BgL_arg1941z00_5527 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_songlengthz00); 
bgl_display_obj(
BINT(BgL_arg1941z00_5527), BgL_opz00_4673); } 
{ /* Llib/mpd.scm 393 */
obj_t BgL_tmpz00_6754;
BgL_tmpz00_6754 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6754); } }  else 
{ /* Llib/mpd.scm 388 */BFALSE; } } 
if(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_repeatz00))
{ /* Llib/mpd.scm 395 */
obj_t BgL_tmpz00_6759;
BgL_tmpz00_6759 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3396z00zz__multimediazd2mpdzd2, BgL_tmpz00_6759); }  else 
{ /* Llib/mpd.scm 396 */
obj_t BgL_tmpz00_6762;
BgL_tmpz00_6762 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3397z00zz__multimediazd2mpdzd2, BgL_tmpz00_6762); } 
if(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_randomz00))
{ /* Llib/mpd.scm 398 */
obj_t BgL_tmpz00_6767;
BgL_tmpz00_6767 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3398z00zz__multimediazd2mpdzd2, BgL_tmpz00_6767); }  else 
{ /* Llib/mpd.scm 399 */
obj_t BgL_tmpz00_6770;
BgL_tmpz00_6770 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3399z00zz__multimediazd2mpdzd2, BgL_tmpz00_6770); } 
{ /* Llib/mpd.scm 400 */
obj_t BgL_tmpz00_6773;
BgL_tmpz00_6773 = 
((obj_t)BgL_opz00_4673); 
bgl_display_string(BGl_string3400z00zz__multimediazd2mpdzd2, BgL_tmpz00_6773); } 
{ /* Llib/mpd.scm 400 */
int BgL_arg1946z00_5528;
BgL_arg1946z00_5528 = 
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5518))->BgL_xfadez00); 
bgl_display_obj(
BINT(BgL_arg1946z00_5528), BgL_opz00_4673); } 
{ /* Llib/mpd.scm 400 */
obj_t BgL_tmpz00_6779;
BgL_tmpz00_6779 = 
((obj_t)BgL_opz00_4673); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6779); } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-playlist */
obj_t BGl_z62mpdzd2playlistzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4674, obj_t BgL_dbz00_4675, obj_t BgL_backendz00_4676, obj_t BgL_linez00_4677, obj_t BgL_ipz00_4678, obj_t BgL_opz00_4679)
{
{ /* Llib/mpd.scm 406 */
{ /* Llib/mpd.scm 407 */
obj_t BgL_g1101z00_5529;
BgL_g1101z00_5529 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4676)); 
{ 
obj_t BgL_plistz00_5531;long BgL_numz00_5532;
BgL_plistz00_5531 = BgL_g1101z00_5529; 
BgL_numz00_5532 = ((long)0); 
BgL_loopz00_5530:
if(
PAIRP(BgL_plistz00_5531))
{ /* Llib/mpd.scm 409 */
bgl_display_obj(
BINT(BgL_numz00_5532), BgL_opz00_4679); 
{ /* Llib/mpd.scm 411 */
obj_t BgL_tmpz00_6789;
BgL_tmpz00_6789 = 
((obj_t)BgL_opz00_4679); 
bgl_display_string(BGl_string3395z00zz__multimediazd2mpdzd2, BgL_tmpz00_6789); } 
bgl_display_obj(
CAR(BgL_plistz00_5531), BgL_opz00_4679); 
{ /* Llib/mpd.scm 413 */
obj_t BgL_tmpz00_6794;
BgL_tmpz00_6794 = 
((obj_t)BgL_opz00_4679); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6794); } 
{ 
long BgL_numz00_6799;obj_t BgL_plistz00_6797;
BgL_plistz00_6797 = 
CDR(BgL_plistz00_5531); 
BgL_numz00_6799 = 
(((long)1)+BgL_numz00_5532); 
BgL_numz00_5532 = BgL_numz00_6799; 
BgL_plistz00_5531 = BgL_plistz00_6797; 
goto BgL_loopz00_5530;} }  else 
{ /* Llib/mpd.scm 409 */((bool_t)0); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* search1341~0 */
obj_t BGl_search1341ze70ze7zz__multimediazd2mpdzd2(obj_t BgL_l1340z00_5357, obj_t BgL_opt1338z00_5356, obj_t BgL_k1z00_817, obj_t BgL_iz00_818)
{
{ /* Llib/mpd.scm 420 */
BGl_search1341ze70ze7zz__multimediazd2mpdzd2:
if(
(
(long)CINT(BgL_iz00_818)==
(long)CINT(BgL_l1340z00_5357)))
{ /* Llib/mpd.scm 420 */
return 
BINT(((long)-1));}  else 
{ /* Llib/mpd.scm 420 */
if(
(
(long)CINT(BgL_iz00_818)==
(long)CINT(
SUBFX(BgL_l1340z00_5357, 
BINT(((long)1))))))
{ /* Llib/mpd.scm 420 */
obj_t BgL_arg1967z00_849;
BgL_arg1967z00_849 = 
BINT(
VECTOR_LENGTH(BgL_opt1338z00_5356)); 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)65)), BGl_string3402z00zz__multimediazd2mpdzd2, BgL_arg1967z00_849);}  else 
{ /* Llib/mpd.scm 420 */
obj_t BgL_vz00_850;
BgL_vz00_850 = 
VECTOR_REF(BgL_opt1338z00_5356,
(long)CINT(BgL_iz00_818)); 
if(
(BgL_vz00_850==BgL_k1z00_817))
{ /* Llib/mpd.scm 420 */
return 
ADDFX(BgL_iz00_818, 
BINT(((long)1)));}  else 
{ 
obj_t BgL_iz00_6823;
BgL_iz00_6823 = 
ADDFX(BgL_iz00_818, 
BINT(((long)2))); 
BgL_iz00_818 = BgL_iz00_6823; 
goto BGl_search1341ze70ze7zz__multimediazd2mpdzd2;} } } } 

}



/* playlistinfo */
obj_t BGl_playlistinfoz00zz__multimediazd2mpdzd2(obj_t BgL_dbz00_71, obj_t BgL_backendz00_72, obj_t BgL_linez00_73, obj_t BgL_ipz00_74, obj_t BgL_opz00_75, int BgL_numz00_76)
{
{ /* Llib/mpd.scm 432 */
{ /* Llib/mpd.scm 434 */
obj_t BgL_plistz00_867;
BgL_plistz00_867 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_72)); 
{ /* Llib/mpd.scm 435 */
bool_t BgL_test3882z00_6828;
if(
(
(long)(BgL_numz00_76)>=((long)0)))
{ /* Llib/mpd.scm 435 */
BgL_test3882z00_6828 = 
(
(long)(BgL_numz00_76)<
bgl_list_length(BgL_plistz00_867))
; }  else 
{ /* Llib/mpd.scm 435 */
BgL_test3882z00_6828 = ((bool_t)0)
; } 
if(BgL_test3882z00_6828)
{ /* Llib/mpd.scm 436 */
obj_t BgL_arg1980z00_871;
BgL_arg1980z00_871 = 
bgl_list_ref(BgL_plistz00_867, 
(long)(BgL_numz00_76)); 
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_2813;
BgL_g1186z00_2813 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_71, BgL_arg1980z00_871, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_2815;
BgL_l1184z00_2815 = BgL_g1186z00_2813; 
BgL_zc3z04anonymousza31971ze3z87_2814:
if(
PAIRP(BgL_l1184z00_2815))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_2817;
BgL_kz00_2817 = 
CAR(BgL_l1184z00_2815); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_2818;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_2819;
BgL_arg1974z00_2819 = 
CAR(
((obj_t)BgL_kz00_2817)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2796z00_2826;
BgL_res2796z00_2826 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_2819)); 
BgL_arg1973z00_2818 = BgL_res2796z00_2826; } } 
bgl_display_obj(BgL_arg1973z00_2818, BgL_opz00_75); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6846;
BgL_tmpz00_6846 = 
((obj_t)BgL_opz00_75); 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_tmpz00_6846); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_2820;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_2832;
BgL_pairz00_2832 = 
CDR(
((obj_t)BgL_kz00_2817)); 
BgL_arg1975z00_2820 = 
CAR(BgL_pairz00_2832); } 
bgl_display_obj(BgL_arg1975z00_2820, BgL_opz00_75); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6853;
BgL_tmpz00_6853 = 
((obj_t)BgL_opz00_75); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6853); } } 
{ 
obj_t BgL_l1184z00_6856;
BgL_l1184z00_6856 = 
CDR(BgL_l1184z00_2815); 
BgL_l1184z00_2815 = BgL_l1184z00_6856; 
goto BgL_zc3z04anonymousza31971ze3z87_2814;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } }  else 
{ 
obj_t BgL_plistz00_876;long BgL_numz00_877;
BgL_plistz00_876 = BgL_plistz00_867; 
BgL_numz00_877 = ((long)0); 
BgL_zc3z04anonymousza31981ze3z87_878:
if(
PAIRP(BgL_plistz00_876))
{ /* Llib/mpd.scm 439 */
{ /* Llib/mpd.scm 440 */
obj_t BgL_arg1983z00_880;
BgL_arg1983z00_880 = 
CAR(BgL_plistz00_876); 
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_2837;
BgL_g1186z00_2837 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_71, BgL_arg1983z00_880, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_2839;
BgL_l1184z00_2839 = BgL_g1186z00_2837; 
BgL_zc3z04anonymousza31971ze3z87_2838:
if(
PAIRP(BgL_l1184z00_2839))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_2841;
BgL_kz00_2841 = 
CAR(BgL_l1184z00_2839); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_2842;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_2843;
BgL_arg1974z00_2843 = 
CAR(
((obj_t)BgL_kz00_2841)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2799z00_2850;
BgL_res2799z00_2850 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_2843)); 
BgL_arg1973z00_2842 = BgL_res2799z00_2850; } } 
bgl_display_obj(BgL_arg1973z00_2842, BgL_opz00_75); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_6870;
BgL_tmpz00_6870 = 
((obj_t)BgL_opz00_75); 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_tmpz00_6870); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_2844;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_2856;
BgL_pairz00_2856 = 
CDR(
((obj_t)BgL_kz00_2841)); 
BgL_arg1975z00_2844 = 
CAR(BgL_pairz00_2856); } 
bgl_display_obj(BgL_arg1975z00_2844, BgL_opz00_75); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_6877;
BgL_tmpz00_6877 = 
((obj_t)BgL_opz00_75); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_6877); } } 
{ 
obj_t BgL_l1184z00_6880;
BgL_l1184z00_6880 = 
CDR(BgL_l1184z00_2839); 
BgL_l1184z00_2839 = BgL_l1184z00_6880; 
goto BgL_zc3z04anonymousza31971ze3z87_2838;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } } 
{ 
long BgL_numz00_6884;obj_t BgL_plistz00_6882;
BgL_plistz00_6882 = 
CDR(BgL_plistz00_876); 
BgL_numz00_6884 = 
(((long)1)+BgL_numz00_877); 
BgL_numz00_877 = BgL_numz00_6884; 
BgL_plistz00_876 = BgL_plistz00_6882; 
goto BgL_zc3z04anonymousza31981ze3z87_878;} }  else 
{ /* Llib/mpd.scm 439 */((bool_t)0); } } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-playlistinfo */
obj_t BGl_z62mpdzd2playlistinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4680, obj_t BgL_dbz00_4681, obj_t BgL_backendz00_4682, obj_t BgL_linez00_4683, obj_t BgL_ipz00_4684, obj_t BgL_opz00_4685)
{
{ /* Llib/mpd.scm 447 */
{ /* Llib/mpd.scm 447 */
obj_t BgL_numz00_5533;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5534;
BgL_strz00_5534 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4683, ((long)1)); 
if(
STRINGP(BgL_strz00_5534))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6890;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6891;
BgL_tmpz00_6891 = 
BSTRING_TO_STRING(BgL_strz00_5534); 
BgL_tmpz00_6890 = 
BGL_STRTOL(BgL_tmpz00_6891, ((long)0), ((long)10)); } 
BgL_numz00_5533 = 
BINT(BgL_tmpz00_6890); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5533 = BFALSE; } } 
{ /* Llib/mpd.scm 448 */
obj_t BgL_arg1987z00_5535;
if(
CBOOL(BgL_numz00_5533))
{ /* Llib/mpd.scm 448 */
BgL_arg1987z00_5535 = BgL_numz00_5533; }  else 
{ /* Llib/mpd.scm 448 */
BgL_arg1987z00_5535 = 
BINT(((long)0)); } 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4681, BgL_backendz00_4682, BgL_linez00_4683, BgL_ipz00_4684, BgL_opz00_4685, 
CINT(BgL_arg1987z00_5535));} } } 

}



/* &mpd-playlistid */
obj_t BGl_z62mpdzd2playlistidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4686, obj_t BgL_dbz00_4687, obj_t BgL_backendz00_4688, obj_t BgL_linez00_4689, obj_t BgL_ipz00_4690, obj_t BgL_opz00_4691)
{
{ /* Llib/mpd.scm 453 */
{ /* Llib/mpd.scm 453 */
obj_t BgL_numz00_5536;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5537;
BgL_strz00_5537 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4689, ((long)1)); 
if(
STRINGP(BgL_strz00_5537))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6903;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6904;
BgL_tmpz00_6904 = 
BSTRING_TO_STRING(BgL_strz00_5537); 
BgL_tmpz00_6903 = 
BGL_STRTOL(BgL_tmpz00_6904, ((long)0), ((long)10)); } 
BgL_numz00_5536 = 
BINT(BgL_tmpz00_6903); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5536 = BFALSE; } } 
{ /* Llib/mpd.scm 454 */
obj_t BgL_arg1988z00_5538;
if(
CBOOL(BgL_numz00_5536))
{ /* Llib/mpd.scm 454 */
BgL_arg1988z00_5538 = BgL_numz00_5536; }  else 
{ /* Llib/mpd.scm 454 */
BgL_arg1988z00_5538 = 
BINT(((long)0)); } 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4687, BgL_backendz00_4688, BgL_linez00_4689, BgL_ipz00_4690, BgL_opz00_4691, 
CINT(BgL_arg1988z00_5538));} } } 

}



/* &mpd-plchanges */
obj_t BGl_z62mpdzd2plchangeszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4692, obj_t BgL_dbz00_4693, obj_t BgL_backendz00_4694, obj_t BgL_linez00_4695, obj_t BgL_ipz00_4696, obj_t BgL_opz00_4697)
{
{ /* Llib/mpd.scm 459 */
{ /* Llib/mpd.scm 459 */
obj_t BgL_numz00_5539;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5540;
BgL_strz00_5540 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4695, ((long)1)); 
if(
STRINGP(BgL_strz00_5540))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6916;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6917;
BgL_tmpz00_6917 = 
BSTRING_TO_STRING(BgL_strz00_5540); 
BgL_tmpz00_6916 = 
BGL_STRTOL(BgL_tmpz00_6917, ((long)0), ((long)10)); } 
BgL_numz00_5539 = 
BINT(BgL_tmpz00_6916); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5539 = BFALSE; } } 
{ /* Llib/mpd.scm 460 */
BgL_musicstatusz00_bglt BgL_statusz00_5541;
BgL_statusz00_5541 = 
BGl_musiczd2statuszd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4694)); 
if(
(
(long)CINT(BgL_numz00_5539)<
(long)(
(((BgL_musicstatusz00_bglt)COBJECT(BgL_statusz00_5541))->BgL_playlistidz00))))
{ /* Llib/mpd.scm 462 */
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4693, BgL_backendz00_4694, BgL_linez00_4695, BgL_ipz00_4696, BgL_opz00_4697, 
(int)(((long)0)));}  else 
{ /* Llib/mpd.scm 462 */
return 
CNST_TABLE_REF(((long)53));} } } } 

}



/* &mpd-add */
obj_t BGl_z62mpdzd2addzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4698, obj_t BgL_dbz00_4699, obj_t BgL_backendz00_4700, obj_t BgL_linez00_4701, obj_t BgL_ipz00_4702, obj_t BgL_opz00_4703)
{
{ /* Llib/mpd.scm 477 */
{ /* Llib/mpd.scm 477 */
obj_t BgL_uriz00_5542;
BgL_uriz00_5542 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4701, ((long)1)); 
if(
CBOOL(BgL_uriz00_5542))
{ /* Llib/mpd.scm 479 */
obj_t BgL_pathz00_5543;
if(
bigloo_strcmp_at(BgL_uriz00_5542, BGl_string3403z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 470 */
BgL_pathz00_5543 = BgL_uriz00_5542; }  else 
{ /* Llib/mpd.scm 470 */
BgL_pathz00_5543 = 
BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(BgL_uriz00_5542, BgL_dbz00_4699, BgL_opz00_4703, BGl_string3404z00zz__multimediazd2mpdzd2); } 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_5543)))
{ /* Llib/mpd.scm 481 */
obj_t BgL_g1189z00_5544;
BgL_g1189z00_5544 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_5543); 
{ 
obj_t BgL_l1187z00_5546;
{ /* Llib/mpd.scm 485 */
bool_t BgL_tmpz00_6941;
BgL_l1187z00_5546 = BgL_g1189z00_5544; 
BgL_zc3z04anonymousza31994ze3z87_5545:
if(
PAIRP(BgL_l1187z00_5546))
{ /* Llib/mpd.scm 485 */
{ /* Llib/mpd.scm 482 */
obj_t BgL_fz00_5547;
BgL_fz00_5547 = 
CAR(BgL_l1187z00_5546); 
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_fz00_5547, BgL_dbz00_4699))
{ /* Llib/mpd.scm 484 */
obj_t BgL_arg1997z00_5548;
BgL_arg1997z00_5548 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5543, BgL_fz00_5547); 
BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4700), BgL_arg1997z00_5548); }  else 
{ /* Llib/mpd.scm 482 */BFALSE; } } 
{ 
obj_t BgL_l1187z00_6950;
BgL_l1187z00_6950 = 
CDR(BgL_l1187z00_5546); 
BgL_l1187z00_5546 = BgL_l1187z00_6950; 
goto BgL_zc3z04anonymousza31994ze3z87_5545;} }  else 
{ /* Llib/mpd.scm 485 */
BgL_tmpz00_6941 = ((bool_t)1)
; } 
BBOOL(BgL_tmpz00_6941); } } }  else 
{ /* Llib/mpd.scm 480 */
BGl_musiczd2playlistzd2addz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4700), BgL_pathz00_5543); } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 488 */
obj_t BgL_list1999z00_5549;
BgL_list1999z00_5549 = 
MAKE_YOUNG_PAIR(BgL_uriz00_5542, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3405z00zz__multimediazd2mpdzd2, BgL_list1999z00_5549);} } } 

}



/* &mpd-delete */
obj_t BGl_z62mpdzd2deletezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4704, obj_t BgL_dbz00_4705, obj_t BgL_backendz00_4706, obj_t BgL_linez00_4707, obj_t BgL_ipz00_4708, obj_t BgL_opz00_4709)
{
{ /* Llib/mpd.scm 493 */
{ /* Llib/mpd.scm 493 */
obj_t BgL_numz00_5550;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5551;
BgL_strz00_5551 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4707, ((long)1)); 
if(
STRINGP(BgL_strz00_5551))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6961;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6962;
BgL_tmpz00_6962 = 
BSTRING_TO_STRING(BgL_strz00_5551); 
BgL_tmpz00_6961 = 
BGL_STRTOL(BgL_tmpz00_6962, ((long)0), ((long)10)); } 
BgL_numz00_5550 = 
BINT(BgL_tmpz00_6961); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5550 = BFALSE; } } 
BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4706), 
CINT(BgL_numz00_5550)); 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-deleteid */
obj_t BGl_z62mpdzd2deleteidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4710, obj_t BgL_dbz00_4711, obj_t BgL_backendz00_4712, obj_t BgL_linez00_4713, obj_t BgL_ipz00_4714, obj_t BgL_opz00_4715)
{
{ /* Llib/mpd.scm 500 */
{ /* Llib/mpd.scm 500 */
obj_t BgL_numz00_5552;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5553;
BgL_strz00_5553 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4713, ((long)1)); 
if(
STRINGP(BgL_strz00_5553))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_6973;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_6974;
BgL_tmpz00_6974 = 
BSTRING_TO_STRING(BgL_strz00_5553); 
BgL_tmpz00_6973 = 
BGL_STRTOL(BgL_tmpz00_6974, ((long)0), ((long)10)); } 
BgL_numz00_5552 = 
BINT(BgL_tmpz00_6973); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5552 = BFALSE; } } 
BGl_musiczd2playlistzd2deletez12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4712), 
CINT(BgL_numz00_5552)); 
{ /* Llib/mpd.scm 312 */
obj_t BgL_tmpz00_6981;
BgL_tmpz00_6981 = 
((obj_t)BgL_opz00_4715); 
bgl_display_string(BGl_string3374z00zz__multimediazd2mpdzd2, BgL_tmpz00_6981); } 
{ /* Llib/mpd.scm 313 */
obj_t BgL_tmpz00_6984;
BgL_tmpz00_6984 = 
((obj_t)BgL_opz00_4715); 
return 
bgl_flush_output_port(BgL_tmpz00_6984);} } } 

}



/* &mpd-clear */
obj_t BGl_z62mpdzd2clearzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4716, obj_t BgL_dbz00_4717, obj_t BgL_backendz00_4718, obj_t BgL_linez00_4719, obj_t BgL_ipz00_4720, obj_t BgL_opz00_4721)
{
{ /* Llib/mpd.scm 507 */
BGl_musiczd2playlistzd2clearz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4718)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* currentsong-info */
obj_t BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(obj_t BgL_dbz00_116, obj_t BgL_backendz00_117, obj_t BgL_plistz00_118, int BgL_numz00_119, obj_t BgL_linez00_120, obj_t BgL_ipz00_121)
{
{ /* Llib/mpd.scm 514 */
{ /* Llib/mpd.scm 549 */
obj_t BgL_filez00_919;
BgL_filez00_919 = 
bgl_list_ref(BgL_plistz00_118, 
(long)(BgL_numz00_119)); 
{ /* Llib/mpd.scm 549 */
obj_t BgL_pathz00_920;
if(
bigloo_strcmp_at(BgL_filez00_919, BGl_string3403z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_920 = BgL_filez00_919; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_920 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_919, BgL_dbz00_116); } 
{ /* Llib/mpd.scm 550 */

{ /* Llib/mpd.scm 553 */
obj_t BgL_zc3z04anonymousza32001ze3z87_4950;
BgL_zc3z04anonymousza32001ze3z87_4950 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32001ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32001ze3z87_4950, 
(int)(((long)0)), BgL_backendz00_117); 
PROCEDURE_SET(BgL_zc3z04anonymousza32001ze3z87_4950, 
(int)(((long)1)), BgL_dbz00_116); 
PROCEDURE_SET(BgL_zc3z04anonymousza32001ze3z87_4950, 
(int)(((long)2)), BgL_linez00_120); 
PROCEDURE_SET(BgL_zc3z04anonymousza32001ze3z87_4950, 
(int)(((long)3)), BgL_ipz00_121); 
PROCEDURE_SET(BgL_zc3z04anonymousza32001ze3z87_4950, 
(int)(((long)4)), BgL_filez00_919); 
PROCEDURE_SET(BgL_zc3z04anonymousza32001ze3z87_4950, 
(int)(((long)5)), BgL_pathz00_920); 
return 
BGl_callzd2withzd2outputzd2stringzd2zz__r4_ports_6_10_1z00(BgL_zc3z04anonymousza32001ze3z87_4950);} } } } } 

}



/* &<@anonymous:2001> */
obj_t BGl_z62zc3z04anonymousza32001ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4951, obj_t BgL_opz00_4958)
{
{ /* Llib/mpd.scm 552 */
{ /* Llib/mpd.scm 553 */
obj_t BgL_backendz00_4952;obj_t BgL_dbz00_4953;obj_t BgL_linez00_4954;obj_t BgL_ipz00_4955;obj_t BgL_filez00_4956;obj_t BgL_pathz00_4957;
BgL_backendz00_4952 = 
PROCEDURE_REF(BgL_envz00_4951, 
(int)(((long)0))); 
BgL_dbz00_4953 = 
PROCEDURE_REF(BgL_envz00_4951, 
(int)(((long)1))); 
BgL_linez00_4954 = 
PROCEDURE_REF(BgL_envz00_4951, 
(int)(((long)2))); 
BgL_ipz00_4955 = 
PROCEDURE_REF(BgL_envz00_4951, 
(int)(((long)3))); 
BgL_filez00_4956 = 
PROCEDURE_REF(BgL_envz00_4951, 
(int)(((long)4))); 
BgL_pathz00_4957 = 
PROCEDURE_REF(BgL_envz00_4951, 
(int)(((long)5))); 
{ 
obj_t BgL_opz00_5555;obj_t BgL_filez00_5556;obj_t BgL_pathz00_5557;
if(
fexists(
BSTRING_TO_STRING(BgL_filez00_4956)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_5568;
BgL_g1186z00_5568 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(BgL_dbz00_4953, BgL_filez00_4956, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_5570;
{ /* Llib/mpd.scm 427 */
bool_t BgL_tmpz00_7027;
BgL_l1184z00_5570 = BgL_g1186z00_5568; 
BgL_zc3z04anonymousza31971ze3z87_5569:
if(
PAIRP(BgL_l1184z00_5570))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_5571;
BgL_kz00_5571 = 
CAR(BgL_l1184z00_5570); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_5572;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_5573;
BgL_arg1974z00_5573 = 
CAR(
((obj_t)BgL_kz00_5571)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2815z00_5574;
BgL_res2815z00_5574 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_5573)); 
BgL_arg1973z00_5572 = BgL_res2815z00_5574; } } 
bgl_display_obj(BgL_arg1973z00_5572, BgL_opz00_4958); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_7036;
BgL_tmpz00_7036 = 
((obj_t)BgL_opz00_4958); 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_tmpz00_7036); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_5575;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_5576;
BgL_pairz00_5576 = 
CDR(
((obj_t)BgL_kz00_5571)); 
BgL_arg1975z00_5575 = 
CAR(BgL_pairz00_5576); } 
bgl_display_obj(BgL_arg1975z00_5575, BgL_opz00_4958); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_7043;
BgL_tmpz00_7043 = 
((obj_t)BgL_opz00_4958); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7043); } } 
{ 
obj_t BgL_l1184z00_7046;
BgL_l1184z00_7046 = 
CDR(BgL_l1184z00_5570); 
BgL_l1184z00_5570 = BgL_l1184z00_7046; 
goto BgL_zc3z04anonymousza31971ze3z87_5569;} }  else 
{ /* Llib/mpd.scm 427 */
BgL_tmpz00_7027 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_7027);} } }  else 
{ /* Llib/mpd.scm 553 */
BgL_opz00_5555 = BgL_opz00_4958; 
BgL_filez00_5556 = BgL_filez00_4956; 
BgL_pathz00_5557 = BgL_pathz00_4957; 
{ /* Llib/mpd.scm 518 */
obj_t BgL_metaz00_5558;
BgL_metaz00_5558 = 
BGl_musiczd2metazd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4952)); 
if(
NULLP(BgL_metaz00_5558))
{ /* Llib/mpd.scm 520 */
int BgL_arg2005z00_5559;
BgL_arg2005z00_5559 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4952)); 
return 
BGl_playlistinfoz00zz__multimediazd2mpdzd2(BgL_dbz00_4953, BgL_backendz00_4952, BgL_linez00_4954, BgL_ipz00_4955, BgL_opz00_5555, BgL_arg2005z00_5559);}  else 
{ /* Llib/mpd.scm 521 */
int BgL_numz00_5560;obj_t BgL_dirz00_5561;
BgL_numz00_5560 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4952)); 
BgL_dirz00_5561 = 
BGl_dirnamez00zz__osz00(BgL_filez00_5556); 
{ /* Llib/mpd.scm 523 */
obj_t BgL_tmpz00_7059;
BgL_tmpz00_7059 = 
((obj_t)BgL_opz00_5555); 
bgl_display_string(BGl_string3406z00zz__multimediazd2mpdzd2, BgL_tmpz00_7059); } 
bgl_display_obj(BgL_pathz00_5557, BgL_opz00_5555); 
{ /* Llib/mpd.scm 525 */
obj_t BgL_tmpz00_7063;
BgL_tmpz00_7063 = 
((obj_t)BgL_opz00_5555); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7063); } 
{ /* Llib/mpd.scm 527 */
obj_t BgL_tmpz00_7066;
BgL_tmpz00_7066 = 
((obj_t)BgL_opz00_5555); 
bgl_display_string(BGl_string3407z00zz__multimediazd2mpdzd2, BgL_tmpz00_7066); } 
bgl_display_obj(
BINT(BgL_numz00_5560), BgL_opz00_5555); 
{ /* Llib/mpd.scm 529 */
obj_t BgL_tmpz00_7071;
BgL_tmpz00_7071 = 
((obj_t)BgL_opz00_5555); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7071); } 
{ /* Llib/mpd.scm 530 */
obj_t BgL_tmpz00_7074;
BgL_tmpz00_7074 = 
((obj_t)BgL_opz00_5555); 
bgl_display_string(BGl_string3408z00zz__multimediazd2mpdzd2, BgL_tmpz00_7074); } 
bgl_display_obj(
BINT(BgL_numz00_5560), BgL_opz00_5555); 
{ /* Llib/mpd.scm 532 */
obj_t BgL_tmpz00_7079;
BgL_tmpz00_7079 = 
((obj_t)BgL_opz00_5555); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7079); } 
{ /* Llib/mpd.scm 533 */
obj_t BgL_caz00_5562;
BgL_caz00_5562 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)69)), BgL_metaz00_5558); 
{ /* Llib/mpd.scm 533 */
obj_t BgL_ctz00_5563;
BgL_ctz00_5563 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)70)), BgL_metaz00_5558); 
{ /* Llib/mpd.scm 534 */
obj_t BgL_cbz00_5564;
BgL_cbz00_5564 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)71)), BgL_metaz00_5558); 
{ /* Llib/mpd.scm 535 */
obj_t BgL_az00_5565;
if(
PAIRP(BgL_caz00_5562))
{ /* Llib/mpd.scm 536 */
BgL_az00_5565 = 
CDR(BgL_caz00_5562); }  else 
{ /* Llib/mpd.scm 536 */
BgL_az00_5565 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5561))); } 
{ /* Llib/mpd.scm 536 */
obj_t BgL_tz00_5566;
if(
PAIRP(BgL_ctz00_5563))
{ /* Llib/mpd.scm 539 */
BgL_tz00_5566 = 
CDR(BgL_ctz00_5563); }  else 
{ /* Llib/mpd.scm 539 */
BgL_tz00_5566 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_filez00_5556)); } 
{ /* Llib/mpd.scm 539 */
obj_t BgL_bz00_5567;
if(
PAIRP(BgL_cbz00_5564))
{ /* Llib/mpd.scm 542 */
BgL_bz00_5567 = 
CDR(BgL_cbz00_5564); }  else 
{ /* Llib/mpd.scm 542 */
BgL_bz00_5567 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_5561)); } 
{ /* Llib/mpd.scm 542 */

{ /* Llib/mpd.scm 545 */
obj_t BgL_tmpz00_7104;
BgL_tmpz00_7104 = 
((obj_t)BgL_opz00_5555); 
bgl_display_string(BGl_string3409z00zz__multimediazd2mpdzd2, BgL_tmpz00_7104); } 
bgl_display_obj(BgL_az00_5565, BgL_opz00_5555); 
{ /* Llib/mpd.scm 545 */
obj_t BgL_tmpz00_7108;
BgL_tmpz00_7108 = 
((obj_t)BgL_opz00_5555); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7108); } 
{ /* Llib/mpd.scm 546 */
obj_t BgL_tmpz00_7111;
BgL_tmpz00_7111 = 
((obj_t)BgL_opz00_5555); 
bgl_display_string(BGl_string3410z00zz__multimediazd2mpdzd2, BgL_tmpz00_7111); } 
bgl_display_obj(BgL_tz00_5566, BgL_opz00_5555); 
{ /* Llib/mpd.scm 546 */
obj_t BgL_tmpz00_7115;
BgL_tmpz00_7115 = 
((obj_t)BgL_opz00_5555); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7115); } 
{ /* Llib/mpd.scm 547 */
obj_t BgL_tmpz00_7118;
BgL_tmpz00_7118 = 
((obj_t)BgL_opz00_5555); 
bgl_display_string(BGl_string3411z00zz__multimediazd2mpdzd2, BgL_tmpz00_7118); } 
bgl_display_obj(BgL_bz00_5567, BgL_opz00_5555); 
{ /* Llib/mpd.scm 547 */
obj_t BgL_tmpz00_7122;
BgL_tmpz00_7122 = 
((obj_t)BgL_opz00_5555); 
return 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7122);} } } } } } } } } } } } } } 

}



/* &mpd-currentsong */
obj_t BGl_z62mpdzd2currentsongzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4722, obj_t BgL_dbz00_4723, obj_t BgL_backendz00_4724, obj_t BgL_linez00_4725, obj_t BgL_ipz00_4726, obj_t BgL_opz00_4727)
{
{ /* Llib/mpd.scm 579 */
{ /* Llib/mpd.scm 580 */
obj_t BgL_plistz00_5577;int BgL_numz00_5578;
BgL_plistz00_5577 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4724)); 
BgL_numz00_5578 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4724)); 
{ /* Llib/mpd.scm 582 */
bool_t BgL_test3907z00_7129;
if(
(
(long)(BgL_numz00_5578)>=((long)0)))
{ /* Llib/mpd.scm 582 */
BgL_test3907z00_7129 = 
(
(long)(BgL_numz00_5578)<
bgl_list_length(BgL_plistz00_5577))
; }  else 
{ /* Llib/mpd.scm 582 */
BgL_test3907z00_7129 = ((bool_t)0)
; } 
if(BgL_test3907z00_7129)
{ /* Llib/mpd.scm 568 */
bool_t BgL_test3909z00_7136;
if(
(BgL_plistz00_5577==BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 568 */
BgL_test3909z00_7136 = 
(BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2==
(long)(BgL_numz00_5578))
; }  else 
{ /* Llib/mpd.scm 568 */
BgL_test3909z00_7136 = ((bool_t)0)
; } 
if(BgL_test3909z00_7136)
{ /* Llib/mpd.scm 568 */
bgl_display_obj(BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2, BgL_opz00_4727); }  else 
{ /* Llib/mpd.scm 570 */
obj_t BgL_infoz00_5579;
BgL_infoz00_5579 = 
BGl_currentsongzd2infozd2zz__multimediazd2mpdzd2(BgL_dbz00_4723, BgL_backendz00_4724, BgL_plistz00_5577, BgL_numz00_5578, BgL_linez00_4725, BgL_ipz00_4726); 
BGl_currentsongzd2cachezd2plistz00zz__multimediazd2mpdzd2 = BgL_plistz00_5577; 
BGl_currentsongzd2cachezd2numz00zz__multimediazd2mpdzd2 = 
(long)(BgL_numz00_5578); 
BGl_currentsongzd2cachezd2infoz00zz__multimediazd2mpdzd2 = BgL_infoz00_5579; 
bgl_display_obj(BgL_infoz00_5579, BgL_opz00_4727); } }  else 
{ /* Llib/mpd.scm 582 */BFALSE; } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-play */
obj_t BGl_z62mpdzd2playzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4728, obj_t BgL_dbz00_4729, obj_t BgL_backendz00_4730, obj_t BgL_linez00_4731, obj_t BgL_ipz00_4732, obj_t BgL_opz00_4733)
{
{ /* Llib/mpd.scm 589 */
{ /* Llib/mpd.scm 589 */
obj_t BgL_numz00_5580;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5581;
BgL_strz00_5581 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4731, ((long)1)); 
if(
STRINGP(BgL_strz00_5581))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7149;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7150;
BgL_tmpz00_7150 = 
BSTRING_TO_STRING(BgL_strz00_5581); 
BgL_tmpz00_7149 = 
BGL_STRTOL(BgL_tmpz00_7150, ((long)0), ((long)10)); } 
BgL_numz00_5580 = 
BINT(BgL_tmpz00_7149); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5580 = BFALSE; } } 
{ /* Llib/mpd.scm 590 */
bool_t BgL_test3912z00_7154;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_numz00_5580))
{ /* Llib/mpd.scm 590 */
BgL_test3912z00_7154 = 
(
(long)CINT(BgL_numz00_5580)>=((long)0))
; }  else 
{ /* Llib/mpd.scm 590 */
BgL_test3912z00_7154 = ((bool_t)0)
; } 
if(BgL_test3912z00_7154)
{ /* Llib/mpd.scm 591 */
obj_t BgL_list2021z00_5582;
BgL_list2021z00_5582 = 
MAKE_YOUNG_PAIR(BgL_numz00_5580, BNIL); 
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4730), BgL_list2021z00_5582); }  else 
{ /* Llib/mpd.scm 590 */
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4730), BNIL); } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-playid */
obj_t BGl_z62mpdzd2playidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4734, obj_t BgL_dbz00_4735, obj_t BgL_backendz00_4736, obj_t BgL_linez00_4737, obj_t BgL_ipz00_4738, obj_t BgL_opz00_4739)
{
{ /* Llib/mpd.scm 598 */
{ /* Llib/mpd.scm 598 */
obj_t BgL_numz00_5583;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5584;
BgL_strz00_5584 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4737, ((long)1)); 
if(
STRINGP(BgL_strz00_5584))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7168;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7169;
BgL_tmpz00_7169 = 
BSTRING_TO_STRING(BgL_strz00_5584); 
BgL_tmpz00_7168 = 
BGL_STRTOL(BgL_tmpz00_7169, ((long)0), ((long)10)); } 
BgL_numz00_5583 = 
BINT(BgL_tmpz00_7168); }  else 
{ /* Llib/mpd.scm 223 */
BgL_numz00_5583 = BFALSE; } } 
{ /* Llib/mpd.scm 599 */
bool_t BgL_test3915z00_7173;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_numz00_5583))
{ /* Llib/mpd.scm 599 */
BgL_test3915z00_7173 = 
(
(long)CINT(BgL_numz00_5583)>=((long)0))
; }  else 
{ /* Llib/mpd.scm 599 */
BgL_test3915z00_7173 = ((bool_t)0)
; } 
if(BgL_test3915z00_7173)
{ /* Llib/mpd.scm 600 */
obj_t BgL_list2025z00_5585;
BgL_list2025z00_5585 = 
MAKE_YOUNG_PAIR(BgL_numz00_5583, BNIL); 
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4736), BgL_list2025z00_5585); }  else 
{ /* Llib/mpd.scm 599 */
BGl_musiczd2playzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4736), BNIL); } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-seek */
obj_t BGl_z62mpdzd2seekzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4740, obj_t BgL_dbz00_4741, obj_t BgL_backendz00_4742, obj_t BgL_linez00_4743, obj_t BgL_ipz00_4744, obj_t BgL_opz00_4745)
{
{ /* Llib/mpd.scm 607 */
{ /* Llib/mpd.scm 607 */
obj_t BgL_num1z00_5586;obj_t BgL_num2z00_5587;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5588;
BgL_strz00_5588 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4743, ((long)1)); 
if(
STRINGP(BgL_strz00_5588))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7187;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7188;
BgL_tmpz00_7188 = 
BSTRING_TO_STRING(BgL_strz00_5588); 
BgL_tmpz00_7187 = 
BGL_STRTOL(BgL_tmpz00_7188, ((long)0), ((long)10)); } 
BgL_num1z00_5586 = 
BINT(BgL_tmpz00_7187); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num1z00_5586 = BFALSE; } } 
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5589;
BgL_strz00_5589 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4743, ((long)2)); 
if(
STRINGP(BgL_strz00_5589))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7195;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7196;
BgL_tmpz00_7196 = 
BSTRING_TO_STRING(BgL_strz00_5589); 
BgL_tmpz00_7195 = 
BGL_STRTOL(BgL_tmpz00_7196, ((long)0), ((long)10)); } 
BgL_num2z00_5587 = 
BINT(BgL_tmpz00_7195); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num2z00_5587 = BFALSE; } } 
{ /* Llib/mpd.scm 608 */
obj_t BgL_list2027z00_5590;
BgL_list2027z00_5590 = 
MAKE_YOUNG_PAIR(BgL_num1z00_5586, BNIL); 
BGl_musiczd2seekzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4742), BgL_num2z00_5587, BgL_list2027z00_5590); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-seekid */
obj_t BGl_z62mpdzd2seekidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4746, obj_t BgL_dbz00_4747, obj_t BgL_backendz00_4748, obj_t BgL_linez00_4749, obj_t BgL_ipz00_4750, obj_t BgL_opz00_4751)
{
{ /* Llib/mpd.scm 614 */
{ /* Llib/mpd.scm 614 */
obj_t BgL_num1z00_5591;obj_t BgL_num2z00_5592;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5593;
BgL_strz00_5593 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4749, ((long)1)); 
if(
STRINGP(BgL_strz00_5593))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7207;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7208;
BgL_tmpz00_7208 = 
BSTRING_TO_STRING(BgL_strz00_5593); 
BgL_tmpz00_7207 = 
BGL_STRTOL(BgL_tmpz00_7208, ((long)0), ((long)10)); } 
BgL_num1z00_5591 = 
BINT(BgL_tmpz00_7207); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num1z00_5591 = BFALSE; } } 
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5594;
BgL_strz00_5594 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4749, ((long)2)); 
if(
STRINGP(BgL_strz00_5594))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7215;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7216;
BgL_tmpz00_7216 = 
BSTRING_TO_STRING(BgL_strz00_5594); 
BgL_tmpz00_7215 = 
BGL_STRTOL(BgL_tmpz00_7216, ((long)0), ((long)10)); } 
BgL_num2z00_5592 = 
BINT(BgL_tmpz00_7215); }  else 
{ /* Llib/mpd.scm 223 */
BgL_num2z00_5592 = BFALSE; } } 
{ /* Llib/mpd.scm 615 */
obj_t BgL_list2028z00_5595;
BgL_list2028z00_5595 = 
MAKE_YOUNG_PAIR(BgL_num1z00_5591, BNIL); 
BGl_musiczd2seekzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4748), BgL_num2z00_5592, BgL_list2028z00_5595); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-stop */
obj_t BGl_z62mpdzd2stopzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4752, obj_t BgL_dbz00_4753, obj_t BgL_backendz00_4754, obj_t BgL_linez00_4755, obj_t BgL_ipz00_4756, obj_t BgL_opz00_4757)
{
{ /* Llib/mpd.scm 621 */
BGl_musiczd2stopzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4754)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-pause */
obj_t BGl_z62mpdzd2pausezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4758, obj_t BgL_dbz00_4759, obj_t BgL_backendz00_4760, obj_t BgL_linez00_4761, obj_t BgL_ipz00_4762, obj_t BgL_opz00_4763)
{
{ /* Llib/mpd.scm 628 */
BGl_musiczd2pausezd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4760)); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* <@exit:2035>~0 */
obj_t BGl_zc3z04exitza32035ze3ze70z60zz__multimediazd2mpdzd2(obj_t BgL_backendz00_5355, obj_t BgL_res1111z00_5354)
{
{ /* Llib/mpd.scm 636 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1117z00_1005;
if( SET_EXIT(BgL_an_exit1117z00_1005) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1117z00_1005 = 
(void *)jmpbuf; 
{ /* Llib/mpd.scm 636 */

PUSH_EXIT(BgL_an_exit1117z00_1005, ((long)1)); 
{ /* Llib/mpd.scm 636 */
obj_t BgL_an_exitd1118z00_1006;
BgL_an_exitd1118z00_1006 = 
((obj_t)(&exitd)); 
{ /* Llib/mpd.scm 636 */
bool_t BgL_res1120z00_1009;
{ /* Llib/mpd.scm 636 */
obj_t BgL_ohs1109z00_1010;
BgL_ohs1109z00_1010 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/mpd.scm 636 */
obj_t BgL_exitd1114z00_1011;
BgL_exitd1114z00_1011 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32039ze3z87_4960;
BgL_zc3z04anonymousza32039ze3z87_4960 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32039ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32039ze3z87_4960, 
(int)(((long)0)), BgL_ohs1109z00_1010); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1114z00_1011, BgL_zc3z04anonymousza32039ze3z87_4960); 
{ /* Llib/mpd.scm 636 */
bool_t BgL_tmp1116z00_1013;
{ /* Llib/mpd.scm 636 */
obj_t BgL_arg2036z00_1014;
{ /* Llib/mpd.scm 636 */
obj_t BgL_zc3z04anonymousza32038ze3z87_4959;
BgL_zc3z04anonymousza32038ze3z87_4959 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32038ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32038ze3z87_4959, 
(int)(((long)0)), 
((obj_t)BgL_res1111z00_5354)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32038ze3z87_4959, 
(int)(((long)1)), BgL_an_exitd1118z00_1006); 
BgL_arg2036z00_1014 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza32038ze3z87_4959, BgL_ohs1109z00_1010); } 
BGL_ERROR_HANDLER_SET(BgL_arg2036z00_1014); BUNSPEC; } 
{ /* Llib/mpd.scm 636 */
obj_t BgL_auxz00_4969;
BGl_musiczd2nextzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5355)); 
BgL_auxz00_4969 = 
CNST_TABLE_REF(((long)53)); 
CELL_SET(BgL_res1111z00_5354, BgL_auxz00_4969); } 
BgL_tmp1116z00_1013 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1114z00_1011); 
BGL_ERROR_HANDLER_SET(BgL_ohs1109z00_1010); BUNSPEC; 
BgL_res1120z00_1009 = BgL_tmp1116z00_1013; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1120z00_1009);} } } 
} } 

}



/* &mpd-next */
obj_t BGl_z62mpdzd2nextzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4764, obj_t BgL_dbz00_4765, obj_t BgL_backendz00_4766, obj_t BgL_linez00_4767, obj_t BgL_ipz00_4768, obj_t BgL_opz00_4769)
{
{ /* Llib/mpd.scm 635 */
{ /* Llib/mpd.scm 636 */
obj_t BgL_res1111z00_5596;
BgL_res1111z00_5596 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_5598;
if(
CBOOL(
BGl_zc3z04exitza32035ze3ze70z60zz__multimediazd2mpdzd2(BgL_backendz00_4766, BgL_res1111z00_5596)))
{ /* Llib/mpd.scm 636 */
BgL_ez00_5598 = 
CELL_REF(BgL_res1111z00_5596); 
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_5598, BGl_z62iozd2errorzb0zz__objectz00))
{ /* Llib/mpd.scm 638 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7262;
BgL_tmpz00_7262 = 
((obj_t)BgL_opz00_4769); 
bgl_display_string(BGl_string3375z00zz__multimediazd2mpdzd2, BgL_tmpz00_7262); } 
bgl_display_obj(BGl_string3412z00zz__multimediazd2mpdzd2, BgL_opz00_4769); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7266;
BgL_tmpz00_7266 = 
((obj_t)BgL_opz00_4769); 
bgl_display_string(BGl_string3377z00zz__multimediazd2mpdzd2, BgL_tmpz00_7266); } 
bgl_display_obj(BGl_string3413z00zz__multimediazd2mpdzd2, BgL_opz00_4769); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7270;
BgL_tmpz00_7270 = 
((obj_t)BgL_opz00_4769); 
bgl_display_string(BGl_string3378z00zz__multimediazd2mpdzd2, BgL_tmpz00_7270); } 
bgl_display_obj(BGl_string3414z00zz__multimediazd2mpdzd2, BgL_opz00_4769); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7274;
BgL_tmpz00_7274 = 
((obj_t)BgL_opz00_4769); 
bgl_display_string(BGl_string3379z00zz__multimediazd2mpdzd2, BgL_tmpz00_7274); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7277;
BgL_tmpz00_7277 = 
((obj_t)BgL_opz00_4769); 
bgl_flush_output_port(BgL_tmpz00_7277); } 
return 
CNST_TABLE_REF(((long)54));}  else 
{ /* Llib/mpd.scm 638 */
return 
BGl_raisez00zz__errorz00(BgL_ez00_5598);} }  else 
{ /* Llib/mpd.scm 636 */
return 
CELL_REF(BgL_res1111z00_5596);} } } } 

}



/* &<@anonymous:2038> */
obj_t BGl_z62zc3z04anonymousza32038ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4961, obj_t BgL_ez00_4964)
{
{ /* Llib/mpd.scm 636 */
{ /* Llib/mpd.scm 636 */
obj_t BgL_res1111z00_4962;obj_t BgL_an_exitd1118z00_4963;
BgL_res1111z00_4962 = 
PROCEDURE_REF(BgL_envz00_4961, 
(int)(((long)0))); 
BgL_an_exitd1118z00_4963 = 
PROCEDURE_REF(BgL_envz00_4961, 
(int)(((long)1))); 
CELL_SET(BgL_res1111z00_4962, BgL_ez00_4964); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1118z00_4963, BTRUE);} } 

}



/* &<@anonymous:2039> */
obj_t BGl_z62zc3z04anonymousza32039ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4966)
{
{ /* Llib/mpd.scm 636 */
{ 
obj_t BgL_ohs1109z00_4967;
BgL_ohs1109z00_4967 = 
PROCEDURE_REF(BgL_envz00_4966, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1109z00_4967); 
return BUNSPEC;} } 

}



/* <@exit:2048>~0 */
obj_t BGl_zc3z04exitza32048ze3ze70z60zz__multimediazd2mpdzd2(obj_t BgL_backendz00_5353, obj_t BgL_res1123z00_5352)
{
{ /* Llib/mpd.scm 649 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1129z00_1048;
if( SET_EXIT(BgL_an_exit1129z00_1048) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1129z00_1048 = 
(void *)jmpbuf; 
{ /* Llib/mpd.scm 649 */

PUSH_EXIT(BgL_an_exit1129z00_1048, ((long)1)); 
{ /* Llib/mpd.scm 649 */
obj_t BgL_an_exitd1130z00_1049;
BgL_an_exitd1130z00_1049 = 
((obj_t)(&exitd)); 
{ /* Llib/mpd.scm 649 */
bool_t BgL_res1132z00_1052;
{ /* Llib/mpd.scm 649 */
obj_t BgL_ohs1121z00_1053;
BgL_ohs1121z00_1053 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Llib/mpd.scm 649 */
obj_t BgL_exitd1126z00_1054;
BgL_exitd1126z00_1054 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza32052ze3z87_4972;
BgL_zc3z04anonymousza32052ze3z87_4972 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32052ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32052ze3z87_4972, 
(int)(((long)0)), BgL_ohs1121z00_1053); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1126z00_1054, BgL_zc3z04anonymousza32052ze3z87_4972); 
{ /* Llib/mpd.scm 649 */
bool_t BgL_tmp1128z00_1056;
{ /* Llib/mpd.scm 649 */
obj_t BgL_arg2049z00_1057;
{ /* Llib/mpd.scm 649 */
obj_t BgL_zc3z04anonymousza32051ze3z87_4971;
BgL_zc3z04anonymousza32051ze3z87_4971 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32051ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32051ze3z87_4971, 
(int)(((long)0)), 
((obj_t)BgL_res1123z00_5352)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32051ze3z87_4971, 
(int)(((long)1)), BgL_an_exitd1130z00_1049); 
BgL_arg2049z00_1057 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza32051ze3z87_4971, BgL_ohs1121z00_1053); } 
BGL_ERROR_HANDLER_SET(BgL_arg2049z00_1057); BUNSPEC; } 
{ /* Llib/mpd.scm 649 */
obj_t BgL_auxz00_4981;
BGl_musiczd2prevzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5353)); 
BgL_auxz00_4981 = 
CNST_TABLE_REF(((long)53)); 
CELL_SET(BgL_res1123z00_5352, BgL_auxz00_4981); } 
BgL_tmp1128z00_1056 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1126z00_1054); 
BGL_ERROR_HANDLER_SET(BgL_ohs1121z00_1053); BUNSPEC; 
BgL_res1132z00_1052 = BgL_tmp1128z00_1056; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1132z00_1052);} } } 
} } 

}



/* &mpd-previous */
obj_t BGl_z62mpdzd2previouszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4770, obj_t BgL_dbz00_4771, obj_t BgL_backendz00_4772, obj_t BgL_linez00_4773, obj_t BgL_ipz00_4774, obj_t BgL_opz00_4775)
{
{ /* Llib/mpd.scm 648 */
{ /* Llib/mpd.scm 649 */
obj_t BgL_res1123z00_5599;
BgL_res1123z00_5599 = 
MAKE_CELL(BUNSPEC); 
{ 
obj_t BgL_ez00_5601;
if(
CBOOL(
BGl_zc3z04exitza32048ze3ze70z60zz__multimediazd2mpdzd2(BgL_backendz00_4772, BgL_res1123z00_5599)))
{ /* Llib/mpd.scm 649 */
BgL_ez00_5601 = 
CELL_REF(BgL_res1123z00_5599); 
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_5601, BGl_z62iozd2errorzb0zz__objectz00))
{ /* Llib/mpd.scm 651 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7322;
BgL_tmpz00_7322 = 
((obj_t)BgL_opz00_4775); 
bgl_display_string(BGl_string3375z00zz__multimediazd2mpdzd2, BgL_tmpz00_7322); } 
bgl_display_obj(BGl_string3412z00zz__multimediazd2mpdzd2, BgL_opz00_4775); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7326;
BgL_tmpz00_7326 = 
((obj_t)BgL_opz00_4775); 
bgl_display_string(BGl_string3377z00zz__multimediazd2mpdzd2, BgL_tmpz00_7326); } 
bgl_display_obj(BGl_string3415z00zz__multimediazd2mpdzd2, BgL_opz00_4775); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7330;
BgL_tmpz00_7330 = 
((obj_t)BgL_opz00_4775); 
bgl_display_string(BGl_string3378z00zz__multimediazd2mpdzd2, BgL_tmpz00_7330); } 
bgl_display_obj(BGl_string3416z00zz__multimediazd2mpdzd2, BgL_opz00_4775); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7334;
BgL_tmpz00_7334 = 
((obj_t)BgL_opz00_4775); 
bgl_display_string(BGl_string3379z00zz__multimediazd2mpdzd2, BgL_tmpz00_7334); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7337;
BgL_tmpz00_7337 = 
((obj_t)BgL_opz00_4775); 
bgl_flush_output_port(BgL_tmpz00_7337); } 
return 
CNST_TABLE_REF(((long)54));}  else 
{ /* Llib/mpd.scm 651 */
return 
BGl_raisez00zz__errorz00(BgL_ez00_5601);} }  else 
{ /* Llib/mpd.scm 649 */
return 
CELL_REF(BgL_res1123z00_5599);} } } } 

}



/* &<@anonymous:2051> */
obj_t BGl_z62zc3z04anonymousza32051ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4973, obj_t BgL_ez00_4976)
{
{ /* Llib/mpd.scm 649 */
{ /* Llib/mpd.scm 649 */
obj_t BgL_res1123z00_4974;obj_t BgL_an_exitd1130z00_4975;
BgL_res1123z00_4974 = 
PROCEDURE_REF(BgL_envz00_4973, 
(int)(((long)0))); 
BgL_an_exitd1130z00_4975 = 
PROCEDURE_REF(BgL_envz00_4973, 
(int)(((long)1))); 
CELL_SET(BgL_res1123z00_4974, BgL_ez00_4976); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1130z00_4975, BTRUE);} } 

}



/* &<@anonymous:2052> */
obj_t BGl_z62zc3z04anonymousza32052ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4978)
{
{ /* Llib/mpd.scm 649 */
{ 
obj_t BgL_ohs1121z00_4979;
BgL_ohs1121z00_4979 = 
PROCEDURE_REF(BgL_envz00_4978, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1121z00_4979); 
return BUNSPEC;} } 

}



/* &mpd-volume */
obj_t BGl_z62mpdzd2volumezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4776, obj_t BgL_dbz00_4777, obj_t BgL_backendz00_4778, obj_t BgL_linez00_4779, obj_t BgL_ipz00_4780, obj_t BgL_opz00_4781)
{
{ /* Llib/mpd.scm 661 */
{ /* Llib/mpd.scm 661 */
obj_t BgL_intz00_5602;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5603;
BgL_strz00_5603 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4779, ((long)1)); 
if(
STRINGP(BgL_strz00_5603))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7353;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7354;
BgL_tmpz00_7354 = 
BSTRING_TO_STRING(BgL_strz00_5603); 
BgL_tmpz00_7353 = 
BGL_STRTOL(BgL_tmpz00_7354, ((long)0), ((long)10)); } 
BgL_intz00_5602 = 
BINT(BgL_tmpz00_7353); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5602 = BFALSE; } } 
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_intz00_5602))
{ /* Llib/mpd.scm 662 */
BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4778), BgL_intz00_5602); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 662 */
{ /* Llib/mpd.scm 670 */
obj_t BgL_arg2056z00_5604;
BgL_arg2056z00_5604 = 
BGl_musiczd2volumezd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4778)); 
bgl_display_obj(BgL_arg2056z00_5604, BgL_opz00_4781); } 
{ /* Llib/mpd.scm 671 */
obj_t BgL_tmpz00_7366;
BgL_tmpz00_7366 = 
((obj_t)BgL_opz00_4781); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7366); } 
return 
CNST_TABLE_REF(((long)53));} } } 

}



/* &mpd-setvol */
obj_t BGl_z62mpdzd2setvolzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4782, obj_t BgL_dbz00_4783, obj_t BgL_backendz00_4784, obj_t BgL_linez00_4785, obj_t BgL_ipz00_4786, obj_t BgL_opz00_4787)
{
{ /* Llib/mpd.scm 684 */
{ /* Llib/mpd.scm 684 */
obj_t BgL_intz00_5605;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5606;
BgL_strz00_5606 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4785, ((long)1)); 
if(
STRINGP(BgL_strz00_5606))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7373;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7374;
BgL_tmpz00_7374 = 
BSTRING_TO_STRING(BgL_strz00_5606); 
BgL_tmpz00_7373 = 
BGL_STRTOL(BgL_tmpz00_7374, ((long)0), ((long)10)); } 
BgL_intz00_5605 = 
BINT(BgL_tmpz00_7373); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5605 = BFALSE; } } 
BGl_musiczd2volumezd2setz12z12zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4784), BgL_intz00_5605); 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-clearerror */
obj_t BGl_z62mpdzd2clearerrorzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4788, obj_t BgL_dbz00_4789, obj_t BgL_backendz00_4790, obj_t BgL_linez00_4791, obj_t BgL_ipz00_4792, obj_t BgL_opz00_4793)
{
{ /* Llib/mpd.scm 690 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-close */
obj_t BGl_z62mpdzd2closezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4794, obj_t BgL_dbz00_4795, obj_t BgL_backendz00_4796, obj_t BgL_linez00_4797, obj_t BgL_ipz00_4798, obj_t BgL_opz00_4799)
{
{ /* Llib/mpd.scm 696 */
return 
CNST_TABLE_REF(((long)24));} 

}



/* &mpd-stats */
obj_t BGl_z62mpdzd2statszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4800, obj_t BgL_dbz00_4801, obj_t BgL_backendz00_4802, obj_t BgL_linez00_4803, obj_t BgL_ipz00_4804, obj_t BgL_opz00_4805)
{
{ /* Llib/mpd.scm 702 */
BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4801), BgL_backendz00_4802, BgL_opz00_4805); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-listall */
obj_t BGl_z62mpdzd2listallzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4806, obj_t BgL_dbz00_4807, obj_t BgL_backendz00_4808, obj_t BgL_linez00_4809, obj_t BgL_ipz00_4810, obj_t BgL_opz00_4811)
{
{ /* Llib/mpd.scm 709 */
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4807), BgL_opz00_4811); 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-list */
obj_t BGl_z62mpdzd2listzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4812, obj_t BgL_dbz00_4813, obj_t BgL_backendz00_4814, obj_t BgL_linez00_4815, obj_t BgL_ipz00_4816, obj_t BgL_opz00_4817)
{
{ /* Llib/mpd.scm 716 */
{ /* Llib/mpd.scm 716 */
obj_t BgL_symz00_5607;obj_t BgL_string2z00_5608;obj_t BgL_string3z00_5609;
BgL_symz00_5607 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4815, ((long)1)); 
BgL_string2z00_5608 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4815, ((long)2)); 
BgL_string3z00_5609 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4815, ((long)3)); 
if(
(BgL_symz00_5607==
CNST_TABLE_REF(((long)71))))
{ /* Llib/mpd.scm 717 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5608, BGl_string3417z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 720 */
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4813), BgL_opz00_4817, BgL_string3z00_5609); }  else 
{ /* Llib/mpd.scm 720 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5608, BGl_string3418z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 722 */
BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4813), BgL_opz00_4817, BgL_string3z00_5609); }  else 
{ /* Llib/mpd.scm 722 */
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4813), BgL_opz00_4817, BgL_string2z00_5608); } } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5607==
CNST_TABLE_REF(((long)69))))
{ /* Llib/mpd.scm 717 */
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(BgL_string2z00_5608, BGl_string3418z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 728 */
BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4813), BgL_opz00_4817, BgL_string3z00_5609); }  else 
{ /* Llib/mpd.scm 728 */
BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4813), BgL_opz00_4817); } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5607==
CNST_TABLE_REF(((long)72))))
{ /* Llib/mpd.scm 717 */
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
(BgL_symz00_5607==
CNST_TABLE_REF(((long)73))))
{ /* Llib/mpd.scm 717 */
BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4813), BgL_opz00_4817); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 717 */
if(
CBOOL(BgL_symz00_5607))
{ /* Llib/mpd.scm 740 */
obj_t BgL_list2064z00_5610;
BgL_list2064z00_5610 = 
MAKE_YOUNG_PAIR(BgL_symz00_5607, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3419z00zz__multimediazd2mpdzd2, BgL_list2064z00_5610);}  else 
{ /* Llib/mpd.scm 738 */
return BGl_string3420z00zz__multimediazd2mpdzd2;} } } } } } } 

}



/* &mpd-listallinfo */
obj_t BGl_z62mpdzd2listallinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4818, obj_t BgL_dbz00_4819, obj_t BgL_backendz00_4820, obj_t BgL_linez00_4821, obj_t BgL_ipz00_4822, obj_t BgL_opz00_4823)
{
{ /* Llib/mpd.scm 745 */
{ /* Llib/mpd.scm 745 */
obj_t BgL_dirz00_5611;
BgL_dirz00_5611 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4821, ((long)1)); 
{ /* Llib/mpd.scm 746 */
obj_t BgL_arg2065z00_5612;
if(
CBOOL(BgL_dirz00_5611))
{ /* Llib/mpd.scm 746 */
BgL_arg2065z00_5612 = BgL_dirz00_5611; }  else 
{ /* Llib/mpd.scm 746 */
obj_t BgL_list2067z00_5613;
BgL_list2067z00_5613 = 
MAKE_YOUNG_PAIR(
BCHAR(FILE_SEPARATOR), BNIL); 
BgL_arg2065z00_5612 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list2067z00_5613); } 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4819), BgL_opz00_4823, BgL_arg2065z00_5612, ((bool_t)1)); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-lsinfo */
obj_t BGl_z62mpdzd2lsinfozb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4824, obj_t BgL_dbz00_4825, obj_t BgL_backendz00_4826, obj_t BgL_linez00_4827, obj_t BgL_ipz00_4828, obj_t BgL_opz00_4829)
{
{ /* Llib/mpd.scm 752 */
{ /* Llib/mpd.scm 752 */
obj_t BgL_dirz00_5614;
BgL_dirz00_5614 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4827, ((long)1)); 
{ /* Llib/mpd.scm 753 */
obj_t BgL_arg2068z00_5615;
if(
CBOOL(BgL_dirz00_5614))
{ /* Llib/mpd.scm 753 */
BgL_arg2068z00_5615 = BgL_dirz00_5614; }  else 
{ /* Llib/mpd.scm 753 */
obj_t BgL_list2070z00_5616;
BgL_list2070z00_5616 = 
MAKE_YOUNG_PAIR(
BCHAR(FILE_SEPARATOR), BNIL); 
BgL_arg2068z00_5615 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list2070z00_5616); } 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4825), BgL_opz00_4829, BgL_arg2068z00_5615, ((bool_t)0)); } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-plconangesposid */
obj_t BGl_z62mpdzd2plconangesposidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4830, obj_t BgL_dbz00_4831, obj_t BgL_backendz00_4832, obj_t BgL_linez00_4833, obj_t BgL_ipz00_4834, obj_t BgL_opz00_4835)
{
{ /* Llib/mpd.scm 759 */
{ /* Llib/mpd.scm 759 */
obj_t BgL_intz00_5617;
{ /* Llib/mpd.scm 222 */
obj_t BgL_strz00_5618;
BgL_strz00_5618 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4833, ((long)1)); 
if(
STRINGP(BgL_strz00_5618))
{ /* Llib/mpd.scm 224 */
long BgL_tmpz00_7451;
{ /* Llib/mpd.scm 224 */
char * BgL_tmpz00_7452;
BgL_tmpz00_7452 = 
BSTRING_TO_STRING(BgL_strz00_5618); 
BgL_tmpz00_7451 = 
BGL_STRTOL(BgL_tmpz00_7452, ((long)0), ((long)10)); } 
BgL_intz00_5617 = 
BINT(BgL_tmpz00_7451); }  else 
{ /* Llib/mpd.scm 223 */
BgL_intz00_5617 = BFALSE; } } 
{ /* Llib/mpd.scm 760 */
long BgL_numz00_5619;
BgL_numz00_5619 = ((long)0); 
{ /* Llib/mpd.scm 761 */
obj_t BgL_g1197z00_5620;
BgL_g1197z00_5620 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_4832)); 
{ 
obj_t BgL_l1195z00_5622;
BgL_l1195z00_5622 = BgL_g1197z00_5620; 
BgL_zc3z04anonymousza32071ze3z87_5621:
if(
PAIRP(BgL_l1195z00_5622))
{ /* Llib/mpd.scm 765 */
{ /* Llib/mpd.scm 762 */
obj_t BgL_tmpz00_7460;
BgL_tmpz00_7460 = 
((obj_t)BgL_opz00_4835); 
bgl_display_string(BGl_string3421z00zz__multimediazd2mpdzd2, BgL_tmpz00_7460); } 
bgl_display_obj(
BINT(BgL_numz00_5619), BgL_opz00_4835); 
{ /* Llib/mpd.scm 762 */
obj_t BgL_tmpz00_7465;
BgL_tmpz00_7465 = 
((obj_t)BgL_opz00_4835); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7465); } 
{ /* Llib/mpd.scm 763 */
obj_t BgL_tmpz00_7468;
BgL_tmpz00_7468 = 
((obj_t)BgL_opz00_4835); 
bgl_display_string(BGl_string3408z00zz__multimediazd2mpdzd2, BgL_tmpz00_7468); } 
bgl_display_obj(
BINT(BgL_numz00_5619), BgL_opz00_4835); 
{ /* Llib/mpd.scm 763 */
obj_t BgL_tmpz00_7473;
BgL_tmpz00_7473 = 
((obj_t)BgL_opz00_4835); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7473); } 
BgL_numz00_5619 = 
(BgL_numz00_5619+((long)1)); 
{ 
obj_t BgL_l1195z00_7477;
BgL_l1195z00_7477 = 
CDR(BgL_l1195z00_5622); 
BgL_l1195z00_5622 = BgL_l1195z00_7477; 
goto BgL_zc3z04anonymousza32071ze3z87_5621;} }  else 
{ /* Llib/mpd.scm 765 */((bool_t)1); } } } } 
return 
CNST_TABLE_REF(((long)53));} } 

}



/* &mpd-kill */
obj_t BGl_z62mpdzd2killzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4836, obj_t BgL_dbz00_4837, obj_t BgL_backendz00_4838, obj_t BgL_linez00_4839, obj_t BgL_ipz00_4840, obj_t BgL_opz00_4841)
{
{ /* Llib/mpd.scm 771 */
return 
CNST_TABLE_REF(((long)31));} 

}



/* &mpd-find */
obj_t BGl_z62mpdzd2findzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4842, obj_t BgL_dbz00_4843, obj_t BgL_backendz00_4844, obj_t BgL_linez00_4845, obj_t BgL_ipz00_4846, obj_t BgL_opz00_4847)
{
{ /* Llib/mpd.scm 777 */
{ /* Llib/mpd.scm 777 */
obj_t BgL_symbolz00_5623;obj_t BgL_string2z00_5624;
BgL_symbolz00_5623 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4845, ((long)1)); 
BgL_string2z00_5624 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4845, ((long)2)); 
if(
(BgL_symbolz00_5623==
CNST_TABLE_REF(((long)71))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4843), BgL_opz00_4847, BgL_string2z00_5624); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5623==
CNST_TABLE_REF(((long)69))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4843), BgL_opz00_4847, BgL_string2z00_5624); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5623==
CNST_TABLE_REF(((long)70))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4843), BgL_opz00_4847, BgL_string2z00_5624); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 778 */
if(
(BgL_symbolz00_5623==
CNST_TABLE_REF(((long)73))))
{ /* Llib/mpd.scm 778 */
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4843), BgL_opz00_4847, BgL_string2z00_5624); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 792 */
obj_t BgL_list2078z00_5625;
BgL_list2078z00_5625 = 
MAKE_YOUNG_PAIR(BgL_symbolz00_5623, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3422z00zz__multimediazd2mpdzd2, BgL_list2078z00_5625);} } } } } } 

}



/* &mpd-search */
obj_t BGl_z62mpdzd2searchzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4848, obj_t BgL_dbz00_4849, obj_t BgL_backendz00_4850, obj_t BgL_linez00_4851, obj_t BgL_ipz00_4852, obj_t BgL_opz00_4853)
{
{ /* Llib/mpd.scm 797 */
{ /* Llib/mpd.scm 797 */
obj_t BgL_symbol1z00_5626;obj_t BgL_string2z00_5627;obj_t BgL_symbol3z00_5628;obj_t BgL_string4z00_5629;
BgL_symbol1z00_5626 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4851, ((long)1)); 
BgL_string2z00_5627 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4851, ((long)2)); 
BgL_symbol3z00_5628 = 
BGl_getzd2linezd2argzd2symbolzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4851, ((long)3)); 
BgL_string4z00_5629 = 
BGl_getzd2linezd2argzd2stringzd2nthz00zz__multimediazd2mpdzd2(BgL_linez00_4851, ((long)4)); 
if(
(BgL_symbol1z00_5626==
CNST_TABLE_REF(((long)71))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4849), BgL_opz00_4853, BgL_string2z00_5627); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5626==
CNST_TABLE_REF(((long)69))))
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol3z00_5628==
CNST_TABLE_REF(((long)71))))
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4849), BgL_opz00_4853, BgL_string2z00_5627, BgL_string4z00_5629); }  else 
{ /* Llib/mpd.scm 803 */
if(
(BgL_symbol3z00_5628==
CNST_TABLE_REF(((long)70))))
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4849), BgL_opz00_4853, BgL_string2z00_5627, BgL_string4z00_5629); }  else 
{ /* Llib/mpd.scm 803 */
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4849), BgL_opz00_4853, BgL_string2z00_5627); } } 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5626==
CNST_TABLE_REF(((long)70))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4849), BgL_opz00_4853, BgL_string2z00_5627); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5626==
CNST_TABLE_REF(((long)73))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4849), BgL_opz00_4853, BgL_string2z00_5627); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 798 */
if(
(BgL_symbol1z00_5626==
CNST_TABLE_REF(((long)74))))
{ /* Llib/mpd.scm 798 */
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_4849), BgL_opz00_4853); 
return 
CNST_TABLE_REF(((long)53));}  else 
{ /* Llib/mpd.scm 820 */
obj_t BgL_list2086z00_5630;
BgL_list2086z00_5630 = 
MAKE_YOUNG_PAIR(BgL_symbol1z00_5626, BNIL); 
return 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3423z00zz__multimediazd2mpdzd2, BgL_list2086z00_5630);} } } } } } } 

}



/* &mpd-commands */
obj_t BGl_z62mpdzd2commandszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4854, obj_t BgL_dbz00_4855, obj_t BgL_backendz00_4856, obj_t BgL_linez00_4857, obj_t BgL_ipz00_4858, obj_t BgL_opz00_4859)
{
{ /* Llib/mpd.scm 825 */
{ /* Llib/mpd.scm 826 */
obj_t BgL_g1200z00_5631;
BgL_g1200z00_5631 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3424z00zz__multimediazd2mpdzd2, BGl_za2mpdzd2commandsza2zd2zz__multimediazd2mpdzd2); 
{ 
obj_t BgL_l1198z00_5634;
BgL_l1198z00_5634 = BgL_g1200z00_5631; 
BgL_zc3z04anonymousza32087ze3z87_5633:
if(
PAIRP(BgL_l1198z00_5634))
{ /* Llib/mpd.scm 830 */
{ /* Llib/mpd.scm 827 */
obj_t BgL_cz00_5635;
BgL_cz00_5635 = 
CAR(BgL_l1198z00_5634); 
{ /* Llib/mpd.scm 827 */
obj_t BgL_tmpz00_7559;
BgL_tmpz00_7559 = 
((obj_t)BgL_opz00_4859); 
bgl_display_string(BGl_string3425z00zz__multimediazd2mpdzd2, BgL_tmpz00_7559); } 
{ /* Llib/mpd.scm 828 */
obj_t BgL_arg2089z00_5636;
BgL_arg2089z00_5636 = 
CAR(
((obj_t)BgL_cz00_5635)); 
bgl_display_obj(BgL_arg2089z00_5636, BgL_opz00_4859); } 
{ /* Llib/mpd.scm 829 */
obj_t BgL_tmpz00_7565;
BgL_tmpz00_7565 = 
((obj_t)BgL_opz00_4859); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7565); } } 
{ 
obj_t BgL_l1198z00_7568;
BgL_l1198z00_7568 = 
CDR(BgL_l1198z00_5634); 
BgL_l1198z00_5634 = BgL_l1198z00_7568; 
goto BgL_zc3z04anonymousza32087ze3z87_5633;} }  else 
{ /* Llib/mpd.scm 830 */((bool_t)1); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &<@anonymous:2092> */
obj_t BGl_z62zc3z04anonymousza32092ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4984, obj_t BgL_c1z00_4985, obj_t BgL_c2z00_4986)
{
{ /* Llib/mpd.scm 830 */
{ /* Llib/mpd.scm 831 */
bool_t BgL_tmpz00_7571;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg2093z00_5637;obj_t BgL_arg2094z00_5638;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg2095z00_5639;
BgL_arg2095z00_5639 = 
CAR(
((obj_t)BgL_c1z00_4985)); 
{ /* Llib/mpd.scm 831 */
obj_t BgL_res2850z00_5640;
{ /* Llib/mpd.scm 831 */
obj_t BgL_arg1436z00_5641;
BgL_arg1436z00_5641 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2095z00_5639)); 
BgL_res2850z00_5640 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1436z00_5641); } 
BgL_arg2093z00_5637 = BgL_res2850z00_5640; } } 
{ /* Llib/mpd.scm 832 */
obj_t BgL_arg2096z00_5642;
BgL_arg2096z00_5642 = 
CAR(
((obj_t)BgL_c2z00_4986)); 
{ /* Llib/mpd.scm 832 */
obj_t BgL_res2851z00_5643;
{ /* Llib/mpd.scm 832 */
obj_t BgL_arg1436z00_5644;
BgL_arg1436z00_5644 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2096z00_5642)); 
BgL_res2851z00_5643 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1436z00_5644); } 
BgL_arg2094z00_5638 = BgL_res2851z00_5643; } } 
BgL_tmpz00_7571 = 
bigloo_string_lt(BgL_arg2093z00_5637, BgL_arg2094z00_5638); } 
return 
BBOOL(BgL_tmpz00_7571);} } 

}



/* &mpd-notcommands */
obj_t BGl_z62mpdzd2notcommandszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4860, obj_t BgL_dbz00_4861, obj_t BgL_backendz00_4862, obj_t BgL_linez00_4863, obj_t BgL_ipz00_4864, obj_t BgL_opz00_4865)
{
{ /* Llib/mpd.scm 839 */
{ /* Llib/mpd.scm 840 */
obj_t BgL_g1203z00_5645;
BgL_g1203z00_5645 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3426z00zz__multimediazd2mpdzd2, BGl_za2mpdzd2notcommandsza2zd2zz__multimediazd2mpdzd2); 
{ 
obj_t BgL_l1201z00_5648;
BgL_l1201z00_5648 = BgL_g1203z00_5645; 
BgL_zc3z04anonymousza32097ze3z87_5647:
if(
PAIRP(BgL_l1201z00_5648))
{ /* Llib/mpd.scm 844 */
{ /* Llib/mpd.scm 841 */
obj_t BgL_cz00_5649;
BgL_cz00_5649 = 
CAR(BgL_l1201z00_5648); 
{ /* Llib/mpd.scm 841 */
obj_t BgL_tmpz00_7588;
BgL_tmpz00_7588 = 
((obj_t)BgL_opz00_4865); 
bgl_display_string(BGl_string3425z00zz__multimediazd2mpdzd2, BgL_tmpz00_7588); } 
{ /* Llib/mpd.scm 842 */
obj_t BgL_arg2099z00_5650;
BgL_arg2099z00_5650 = 
CAR(
((obj_t)BgL_cz00_5649)); 
bgl_display_obj(BgL_arg2099z00_5650, BgL_opz00_4865); } 
{ /* Llib/mpd.scm 843 */
obj_t BgL_tmpz00_7594;
BgL_tmpz00_7594 = 
((obj_t)BgL_opz00_4865); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_7594); } } 
{ 
obj_t BgL_l1201z00_7597;
BgL_l1201z00_7597 = 
CDR(BgL_l1201z00_5648); 
BgL_l1201z00_5648 = BgL_l1201z00_7597; 
goto BgL_zc3z04anonymousza32097ze3z87_5647;} }  else 
{ /* Llib/mpd.scm 844 */((bool_t)1); } } } 
return 
CNST_TABLE_REF(((long)53));} 

}



/* &<@anonymous:2102> */
obj_t BGl_z62zc3z04anonymousza32102ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4988, obj_t BgL_c1z00_4989, obj_t BgL_c2z00_4990)
{
{ /* Llib/mpd.scm 844 */
{ /* Llib/mpd.scm 845 */
bool_t BgL_tmpz00_7600;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg2103z00_5651;obj_t BgL_arg2104z00_5652;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg2105z00_5653;
BgL_arg2105z00_5653 = 
CAR(
((obj_t)BgL_c1z00_4989)); 
{ /* Llib/mpd.scm 845 */
obj_t BgL_res2854z00_5654;
{ /* Llib/mpd.scm 845 */
obj_t BgL_arg1436z00_5655;
BgL_arg1436z00_5655 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2105z00_5653)); 
BgL_res2854z00_5654 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1436z00_5655); } 
BgL_arg2103z00_5651 = BgL_res2854z00_5654; } } 
{ /* Llib/mpd.scm 846 */
obj_t BgL_arg2106z00_5656;
BgL_arg2106z00_5656 = 
CAR(
((obj_t)BgL_c2z00_4990)); 
{ /* Llib/mpd.scm 846 */
obj_t BgL_res2855z00_5657;
{ /* Llib/mpd.scm 846 */
obj_t BgL_arg1436z00_5658;
BgL_arg1436z00_5658 = 
SYMBOL_TO_STRING(
((obj_t)BgL_arg2106z00_5656)); 
BgL_res2855z00_5657 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1436z00_5658); } 
BgL_arg2104z00_5652 = BgL_res2855z00_5657; } } 
BgL_tmpz00_7600 = 
bigloo_string_lt(BgL_arg2103z00_5651, BgL_arg2104z00_5652); } 
return 
BBOOL(BgL_tmpz00_7600);} } 

}



/* &mpd-addid */
obj_t BGl_z62mpdzd2addidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4866, obj_t BgL_dbz00_4867, obj_t BgL_backendz00_4868, obj_t BgL_linez00_4869, obj_t BgL_ipz00_4870, obj_t BgL_opz00_4871)
{
{ /* Llib/mpd.scm 853 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-crossfade */
obj_t BGl_z62mpdzd2crossfadezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4872, obj_t BgL_dbz00_4873, obj_t BgL_backendz00_4874, obj_t BgL_linez00_4875, obj_t BgL_ipz00_4876, obj_t BgL_opz00_4877)
{
{ /* Llib/mpd.scm 858 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-move */
obj_t BGl_z62mpdzd2movezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4878, obj_t BgL_dbz00_4879, obj_t BgL_backendz00_4880, obj_t BgL_linez00_4881, obj_t BgL_ipz00_4882, obj_t BgL_opz00_4883)
{
{ /* Llib/mpd.scm 863 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-moveid */
obj_t BGl_z62mpdzd2moveidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4884, obj_t BgL_dbz00_4885, obj_t BgL_backendz00_4886, obj_t BgL_linez00_4887, obj_t BgL_ipz00_4888, obj_t BgL_opz00_4889)
{
{ /* Llib/mpd.scm 868 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-password */
obj_t BGl_z62mpdzd2passwordzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4890, obj_t BgL_dbz00_4891, obj_t BgL_backendz00_4892, obj_t BgL_linez00_4893, obj_t BgL_ipz00_4894, obj_t BgL_opz00_4895)
{
{ /* Llib/mpd.scm 873 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-random */
obj_t BGl_z62mpdzd2randomzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4896, obj_t BgL_dbz00_4897, obj_t BgL_backendz00_4898, obj_t BgL_linez00_4899, obj_t BgL_ipz00_4900, obj_t BgL_opz00_4901)
{
{ /* Llib/mpd.scm 878 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-repeat */
obj_t BGl_z62mpdzd2repeatzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4902, obj_t BgL_dbz00_4903, obj_t BgL_backendz00_4904, obj_t BgL_linez00_4905, obj_t BgL_ipz00_4906, obj_t BgL_opz00_4907)
{
{ /* Llib/mpd.scm 883 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-rm */
obj_t BGl_z62mpdzd2rmzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4908, obj_t BgL_dbz00_4909, obj_t BgL_backendz00_4910, obj_t BgL_linez00_4911, obj_t BgL_ipz00_4912, obj_t BgL_opz00_4913)
{
{ /* Llib/mpd.scm 888 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-save */
obj_t BGl_z62mpdzd2savezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4914, obj_t BgL_dbz00_4915, obj_t BgL_backendz00_4916, obj_t BgL_linez00_4917, obj_t BgL_ipz00_4918, obj_t BgL_opz00_4919)
{
{ /* Llib/mpd.scm 893 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-shuffle */
obj_t BGl_z62mpdzd2shufflezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4920, obj_t BgL_dbz00_4921, obj_t BgL_backendz00_4922, obj_t BgL_linez00_4923, obj_t BgL_ipz00_4924, obj_t BgL_opz00_4925)
{
{ /* Llib/mpd.scm 898 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-swap */
obj_t BGl_z62mpdzd2swapzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4926, obj_t BgL_dbz00_4927, obj_t BgL_backendz00_4928, obj_t BgL_linez00_4929, obj_t BgL_ipz00_4930, obj_t BgL_opz00_4931)
{
{ /* Llib/mpd.scm 903 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-swapid */
obj_t BGl_z62mpdzd2swapidzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4932, obj_t BgL_dbz00_4933, obj_t BgL_backendz00_4934, obj_t BgL_linez00_4935, obj_t BgL_ipz00_4936, obj_t BgL_opz00_4937)
{
{ /* Llib/mpd.scm 908 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-update */
obj_t BGl_z62mpdzd2updatezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4938, obj_t BgL_dbz00_4939, obj_t BgL_backendz00_4940, obj_t BgL_linez00_4941, obj_t BgL_ipz00_4942, obj_t BgL_opz00_4943)
{
{ /* Llib/mpd.scm 913 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* &mpd-outputs */
obj_t BGl_z62mpdzd2outputszb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_4944, obj_t BgL_dbz00_4945, obj_t BgL_backendz00_4946, obj_t BgL_linez00_4947, obj_t BgL_ipz00_4948, obj_t BgL_opz00_4949)
{
{ /* Llib/mpd.scm 918 */
return 
CNST_TABLE_REF(((long)53));} 

}



/* loop~5 */
obj_t BGl_loopze75ze7zz__multimediazd2mpdzd2(obj_t BgL_l1z00_1167, obj_t BgL_l2z00_1168)
{
{ /* Llib/mpd.scm 924 */
{ /* Llib/mpd.scm 927 */
bool_t BgL_test3953z00_7627;
if(
NULLP(BgL_l1z00_1167))
{ /* Llib/mpd.scm 927 */
BgL_test3953z00_7627 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 927 */
BgL_test3953z00_7627 = 
NULLP(BgL_l2z00_1168)
; } 
if(BgL_test3953z00_7627)
{ /* Llib/mpd.scm 927 */
return BNIL;}  else 
{ /* Llib/mpd.scm 929 */
bool_t BgL_test3955z00_7631;
{ /* Llib/mpd.scm 929 */
obj_t BgL_arg2117z00_1179;obj_t BgL_arg2118z00_1180;
BgL_arg2117z00_1179 = 
CAR(
((obj_t)BgL_l1z00_1167)); 
BgL_arg2118z00_1180 = 
CAR(
((obj_t)BgL_l2z00_1168)); 
{ /* Llib/mpd.scm 929 */
bool_t BgL_res2864z00_3163;
{ /* Llib/mpd.scm 929 */
long BgL_l1z00_3150;
BgL_l1z00_3150 = 
STRING_LENGTH(
((obj_t)BgL_arg2117z00_1179)); 
if(
(BgL_l1z00_3150==
STRING_LENGTH(
((obj_t)BgL_arg2118z00_1180))))
{ /* Llib/mpd.scm 929 */
int BgL_arg1269z00_3153;
{ /* Llib/mpd.scm 929 */
char * BgL_auxz00_7645;char * BgL_tmpz00_7642;
BgL_auxz00_7645 = 
BSTRING_TO_STRING(
((obj_t)BgL_arg2118z00_1180)); 
BgL_tmpz00_7642 = 
BSTRING_TO_STRING(
((obj_t)BgL_arg2117z00_1179)); 
BgL_arg1269z00_3153 = 
memcmp(BgL_tmpz00_7642, BgL_auxz00_7645, BgL_l1z00_3150); } 
BgL_res2864z00_3163 = 
(
(long)(BgL_arg1269z00_3153)==((long)0)); }  else 
{ /* Llib/mpd.scm 929 */
BgL_res2864z00_3163 = ((bool_t)0); } } 
BgL_test3955z00_7631 = BgL_res2864z00_3163; } } 
if(BgL_test3955z00_7631)
{ /* Llib/mpd.scm 930 */
obj_t BgL_arg2113z00_1175;obj_t BgL_arg2114z00_1176;
BgL_arg2113z00_1175 = 
CAR(
((obj_t)BgL_l1z00_1167)); 
{ /* Llib/mpd.scm 930 */
obj_t BgL_arg2115z00_1177;obj_t BgL_arg2116z00_1178;
BgL_arg2115z00_1177 = 
CDR(
((obj_t)BgL_l1z00_1167)); 
BgL_arg2116z00_1178 = 
CDR(
((obj_t)BgL_l2z00_1168)); 
BgL_arg2114z00_1176 = 
BGl_loopze75ze7zz__multimediazd2mpdzd2(BgL_arg2115z00_1177, BgL_arg2116z00_1178); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2113z00_1175, BgL_arg2114z00_1176);}  else 
{ /* Llib/mpd.scm 929 */
return BNIL;} } } } 

}



/* file-system-root? */
bool_t BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(obj_t BgL_dirz00_330)
{
{ /* Llib/mpd.scm 949 */
if(
(
STRING_LENGTH(BgL_dirz00_330)==((long)1)))
{ /* Llib/mpd.scm 950 */
return 
(
STRING_REF(BgL_dirz00_330, ((long)0))==
(unsigned char)(FILE_SEPARATOR));}  else 
{ /* Llib/mpd.scm 950 */
return ((bool_t)0);} } 

}



/* directory->sort-list */
obj_t BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(obj_t BgL_dirz00_332)
{
{ /* Llib/mpd.scm 988 */
return 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3427z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_332)));} 

}



/* &<@anonymous:2129> */
obj_t BGl_z62zc3z04anonymousza32129ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4992, obj_t BgL_s1z00_4993, obj_t BgL_s2z00_4994)
{
{ /* Llib/mpd.scm 989 */
{ /* Llib/mpd.scm 990 */
bool_t BgL_tmpz00_7668;
{ /* Llib/mpd.scm 990 */
int BgL_arg2130z00_5659;
{ /* Llib/mpd.scm 990 */

BgL_arg2130z00_5659 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_4993, BgL_s2z00_4994, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7668 = 
(
(long)(BgL_arg2130z00_5659)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7668);} } 

}



/* mpd->file */
obj_t BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(obj_t BgL_filez00_333, obj_t BgL_dbz00_334, obj_t BgL_opz00_335, obj_t BgL_cmdz00_336)
{
{ /* Llib/mpd.scm 996 */
{ /* Llib/mpd.scm 998 */
obj_t BgL_fz00_1220;
{ /* Llib/mpd.scm 998 */
obj_t BgL_g1206z00_1224;
BgL_g1206z00_1224 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_334)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1204z00_1226;
BgL_l1204z00_1226 = BgL_g1206z00_1224; 
BgL_zc3z04anonymousza32132ze3z87_1227:
if(
NULLP(BgL_l1204z00_1226))
{ /* Llib/mpd.scm 998 */
BgL_fz00_1220 = BFALSE; }  else 
{ /* Llib/mpd.scm 999 */
obj_t BgL__ortest_1207z00_1229;
{ /* Llib/mpd.scm 999 */
obj_t BgL_dirz00_1231;
BgL_dirz00_1231 = 
CAR(
((obj_t)BgL_l1204z00_1226)); 
{ /* Llib/mpd.scm 999 */
obj_t BgL_pz00_1232;
BgL_pz00_1232 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1231, BgL_filez00_333); 
if(
fexists(
BSTRING_TO_STRING(BgL_pz00_1232)))
{ /* Llib/mpd.scm 1000 */
BgL__ortest_1207z00_1229 = BgL_pz00_1232; }  else 
{ /* Llib/mpd.scm 1000 */
BgL__ortest_1207z00_1229 = BFALSE; } } } 
if(
CBOOL(BgL__ortest_1207z00_1229))
{ /* Llib/mpd.scm 998 */
BgL_fz00_1220 = BgL__ortest_1207z00_1229; }  else 
{ /* Llib/mpd.scm 998 */
obj_t BgL_arg2134z00_1230;
BgL_arg2134z00_1230 = 
CDR(
((obj_t)BgL_l1204z00_1226)); 
{ 
obj_t BgL_l1204z00_7689;
BgL_l1204z00_7689 = BgL_arg2134z00_1230; 
BgL_l1204z00_1226 = BgL_l1204z00_7689; 
goto BgL_zc3z04anonymousza32132ze3z87_1227;} } } } } 
if(
STRINGP(BgL_fz00_1220))
{ /* Llib/mpd.scm 1003 */
return BgL_fz00_1220;}  else 
{ /* Llib/mpd.scm 1003 */
{ /* Llib/mpd.scm 325 */
obj_t BgL_tmpz00_7692;
BgL_tmpz00_7692 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3375z00zz__multimediazd2mpdzd2, BgL_tmpz00_7692); } 
bgl_display_obj(BGl_string3412z00zz__multimediazd2mpdzd2, BgL_opz00_335); 
{ /* Llib/mpd.scm 327 */
obj_t BgL_tmpz00_7696;
BgL_tmpz00_7696 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3377z00zz__multimediazd2mpdzd2, BgL_tmpz00_7696); } 
bgl_display_obj(BgL_cmdz00_336, BgL_opz00_335); 
{ /* Llib/mpd.scm 329 */
obj_t BgL_tmpz00_7700;
BgL_tmpz00_7700 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3378z00zz__multimediazd2mpdzd2, BgL_tmpz00_7700); } 
bgl_display_obj(BGl_string3428z00zz__multimediazd2mpdzd2, BgL_opz00_335); 
{ /* Llib/mpd.scm 331 */
obj_t BgL_tmpz00_7704;
BgL_tmpz00_7704 = 
((obj_t)BgL_opz00_335); 
bgl_display_string(BGl_string3379z00zz__multimediazd2mpdzd2, BgL_tmpz00_7704); } 
{ /* Llib/mpd.scm 332 */
obj_t BgL_tmpz00_7707;
BgL_tmpz00_7707 = 
((obj_t)BgL_opz00_335); 
bgl_flush_output_port(BgL_tmpz00_7707); } 
return 
CNST_TABLE_REF(((long)54));} } } 

}



/* file->mpd */
obj_t BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(obj_t BgL_filez00_337, obj_t BgL_dbz00_338)
{
{ /* Llib/mpd.scm 1010 */
{ /* Llib/mpd.scm 1012 */
long BgL_blenz00_1236;
BgL_blenz00_1236 = 
STRING_LENGTH(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_338)))->BgL_z52basez52)); 
if(
(
STRING_LENGTH(
((obj_t)BgL_filez00_337))>BgL_blenz00_1236))
{ /* Llib/mpd.scm 1014 */
long BgL_arg2138z00_1239;
BgL_arg2138z00_1239 = 
(BgL_blenz00_1236+((long)1)); 
{ /* Llib/mpd.scm 1014 */
long BgL_endz00_1242;
BgL_endz00_1242 = 
STRING_LENGTH(
((obj_t)BgL_filez00_337)); 
{ /* Llib/mpd.scm 1014 */

return 
BGl_substringz00zz__r4_strings_6_7z00(BgL_filez00_337, BgL_arg2138z00_1239, BgL_endz00_1242);} } }  else 
{ /* Llib/mpd.scm 1013 */
return BGl_string3363z00zz__multimediazd2mpdzd2;} } } 

}



/* image-file? */
bool_t BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(obj_t BgL_fz00_341)
{
{ /* Llib/mpd.scm 1028 */
{ 
obj_t BgL_l1208z00_1248;
BgL_l1208z00_1248 = 
CNST_TABLE_REF(((long)75)); 
BgL_zc3z04anonymousza32142ze3z87_1249:
if(
NULLP(BgL_l1208z00_1248))
{ /* Llib/mpd.scm 1029 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1029 */
bool_t BgL__ortest_1211z00_1251;
{ /* Llib/mpd.scm 1029 */

BgL__ortest_1211z00_1251 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(
CAR(
((obj_t)BgL_l1208z00_1248)), BgL_fz00_341, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL__ortest_1211z00_1251)
{ /* Llib/mpd.scm 1029 */
return BgL__ortest_1211z00_1251;}  else 
{ 
obj_t BgL_l1208z00_7728;
BgL_l1208z00_7728 = 
CDR(
((obj_t)BgL_l1208z00_1248)); 
BgL_l1208z00_1248 = BgL_l1208z00_7728; 
goto BgL_zc3z04anonymousza32142ze3z87_1249;} } } } 

}



/* directory-image */
obj_t BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(obj_t BgL_dirz00_342)
{
{ /* Llib/mpd.scm 1034 */
{ /* Llib/mpd.scm 1035 */
obj_t BgL_fz00_1261;
{ /* Llib/mpd.scm 1035 */
obj_t BgL_g1214z00_1263;
BgL_g1214z00_1263 = 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_342)); 
{ 
obj_t BgL_list1213z00_1265;
BgL_list1213z00_1265 = BgL_g1214z00_1263; 
BgL_zc3z04anonymousza32146ze3z87_1266:
if(
PAIRP(BgL_list1213z00_1265))
{ /* Llib/mpd.scm 1035 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1213z00_1265)))
{ /* Llib/mpd.scm 1035 */
BgL_fz00_1261 = 
CAR(BgL_list1213z00_1265); }  else 
{ 
obj_t BgL_list1213z00_7740;
BgL_list1213z00_7740 = 
CDR(BgL_list1213z00_1265); 
BgL_list1213z00_1265 = BgL_list1213z00_7740; 
goto BgL_zc3z04anonymousza32146ze3z87_1266;} }  else 
{ /* Llib/mpd.scm 1035 */
BgL_fz00_1261 = BFALSE; } } } 
if(
STRINGP(BgL_fz00_1261))
{ /* Llib/mpd.scm 1036 */
return 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_342, BgL_fz00_1261);}  else 
{ /* Llib/mpd.scm 1036 */
return BFALSE;} } } 

}



/* music-file? */
bool_t BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(obj_t BgL_fz00_343, obj_t BgL_dbz00_344)
{
{ /* Llib/mpd.scm 1042 */
{ 
obj_t BgL_l1215z00_1276;
BgL_l1215z00_1276 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_dbz00_344)))->BgL_suffixesz00); 
BgL_zc3z04anonymousza32152ze3z87_1277:
if(
NULLP(BgL_l1215z00_1276))
{ /* Llib/mpd.scm 1044 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1044 */
bool_t BgL__ortest_1218z00_1279;
{ /* Llib/mpd.scm 1044 */

BgL__ortest_1218z00_1279 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(
CAR(
((obj_t)BgL_l1215z00_1276)), BgL_fz00_343, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL__ortest_1218z00_1279)
{ /* Llib/mpd.scm 1044 */
return BgL__ortest_1218z00_1279;}  else 
{ 
obj_t BgL_l1215z00_7751;
BgL_l1215z00_7751 = 
CDR(
((obj_t)BgL_l1215z00_1276)); 
BgL_l1215z00_1276 = BgL_l1215z00_7751; 
goto BgL_zc3z04anonymousza32152ze3z87_1277;} } } } 

}



/* mpd-database-directories-scan */
obj_t BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_347, obj_t BgL_directoriesz00_348)
{
{ /* Llib/mpd.scm 1055 */
{ /* Llib/mpd.scm 1055 */
struct bgl_cell BgL_box3970_5350z00; 
obj_t BgL_nsongsz00_5350;
BgL_nsongsz00_5350 = 
MAKE_CELL_STACK(
BINT(((long)0)),BgL_box3970_5350z00); 
{ /* Llib/mpd.scm 1057 */
obj_t BgL_artistsz00_1295;
BgL_artistsz00_1295 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ /* Llib/mpd.scm 1058 */
obj_t BgL_albumsz00_1296;
BgL_albumsz00_1296 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ /* Llib/mpd.scm 1059 */
obj_t BgL_genresz00_1297;
BgL_genresz00_1297 = 
BGl_makezd2hashtablezd2zz__hashz00(BNIL); 
{ 
obj_t BgL_l1222z00_1300;
BgL_l1222z00_1300 = BgL_directoriesz00_348; 
BgL_zc3z04anonymousza32158ze3z87_1301:
if(
PAIRP(BgL_l1222z00_1300))
{ /* Llib/mpd.scm 1082 */
{ /* Llib/mpd.scm 1082 */
obj_t BgL_dz00_1303;
BgL_dz00_1303 = 
CAR(BgL_l1222z00_1300); 
BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_dbz00_347, BgL_genresz00_1297, BgL_albumsz00_1296, BgL_artistsz00_1295, BgL_nsongsz00_5350, BgL_dz00_1303, BgL_dz00_1303); } 
{ 
obj_t BgL_l1222z00_7764;
BgL_l1222z00_7764 = 
CDR(BgL_l1222z00_1300); 
BgL_l1222z00_1300 = BgL_l1222z00_7764; 
goto BgL_zc3z04anonymousza32158ze3z87_1301;} }  else 
{ /* Llib/mpd.scm 1082 */((bool_t)1); } } 
{ /* Llib/mpd.scm 1084 */
obj_t BgL_val0_1224z00_1306;obj_t BgL_val1_1225z00_1307;obj_t BgL_val2_1226z00_1308;long BgL_val3_1227z00_1309;
BgL_val0_1224z00_1306 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3429z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_artistsz00_1295, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val1_1225z00_1307 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3430z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_albumsz00_1296, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val2_1226z00_1308 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3431z00zz__multimediazd2mpdzd2, 
BGl_hashtablezd2mapzd2zz__hashz00(BgL_genresz00_1297, BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00)); 
BgL_val3_1227z00_1309 = 
(long)CINT(
CELL_REF(BgL_nsongsz00_5350)); 
{ /* Llib/mpd.scm 1084 */
int BgL_res2889z00_3254;
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7773;
BgL_tmpz00_7773 = 
(int)(((long)4)); 
BgL_res2889z00_3254 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7773); } BgL_res2889z00_3254; } 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7776;
BgL_tmpz00_7776 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7776, BgL_val1_1225z00_1307); } 
{ /* Llib/mpd.scm 1084 */
int BgL_tmpz00_7779;
BgL_tmpz00_7779 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7779, BgL_val2_1226z00_1308); } 
{ /* Llib/mpd.scm 1084 */
obj_t BgL_auxz00_7784;int BgL_tmpz00_7782;
BgL_auxz00_7784 = 
BINT(BgL_val3_1227z00_1309); 
BgL_tmpz00_7782 = 
(int)(((long)3)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7782, BgL_auxz00_7784); } 
return BgL_val0_1224z00_1306;} } } } } } 

}



/* directory-scan~0 */
bool_t BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_5348, obj_t BgL_genresz00_5347, obj_t BgL_albumsz00_5346, obj_t BgL_artistsz00_5345, obj_t BgL_nsongsz00_5344, obj_t BgL_dirz00_1334, obj_t BgL_repoz00_1335)
{
{ /* Llib/mpd.scm 1080 */
{ /* Llib/mpd.scm 1063 */
obj_t BgL_albumz00_1337;
BgL_albumz00_1337 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1334); 
{ /* Llib/mpd.scm 1063 */
obj_t BgL_dir2z00_1338;
BgL_dir2z00_1338 = 
BGl_dirnamez00zz__osz00(BgL_dirz00_1334); 
{ /* Llib/mpd.scm 1064 */
obj_t BgL_artistz00_1339;
BgL_artistz00_1339 = 
BGl_basenamez00zz__osz00(BgL_dir2z00_1338); 
{ /* Llib/mpd.scm 1065 */
obj_t BgL_dir3z00_1340;
BgL_dir3z00_1340 = 
BGl_dirnamez00zz__osz00(BgL_dir2z00_1338); 
{ /* Llib/mpd.scm 1066 */
obj_t BgL_genrez00_1341;
BgL_genrez00_1341 = 
BGl_basenamez00zz__osz00(BgL_dir3z00_1340); 
{ /* Llib/mpd.scm 1067 */
bool_t BgL_addz00_1342;
BgL_addz00_1342 = ((bool_t)0); 
{ /* Llib/mpd.scm 1068 */

{ /* Llib/mpd.scm 1069 */
obj_t BgL_g1221z00_1343;
BgL_g1221z00_1343 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_1334); 
{ 
obj_t BgL_l1219z00_1345;
BgL_l1219z00_1345 = BgL_g1221z00_1343; 
BgL_zc3z04anonymousza32177ze3z87_1346:
if(
PAIRP(BgL_l1219z00_1345))
{ /* Llib/mpd.scm 1080 */
{ /* Llib/mpd.scm 1071 */
obj_t BgL_pz00_1348;
BgL_pz00_1348 = 
CAR(BgL_l1219z00_1345); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1348)))
{ /* Llib/mpd.scm 1071 */
BBOOL(
BGl_directoryzd2scanze70z35zz__multimediazd2mpdzd2(BgL_dbz00_5348, BgL_genresz00_5347, BgL_albumsz00_5346, BgL_artistsz00_5345, BgL_nsongsz00_5344, BgL_pz00_1348, BgL_repoz00_1335)); }  else 
{ /* Llib/mpd.scm 1071 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1348, 
((obj_t)BgL_dbz00_5348)))
{ /* Llib/mpd.scm 1073 */
{ /* Llib/mpd.scm 1074 */
obj_t BgL_auxz00_5349;
BgL_auxz00_5349 = 
ADDFX(
CELL_REF(BgL_nsongsz00_5344), 
BINT(((long)1))); 
CELL_SET(BgL_nsongsz00_5344, BgL_auxz00_5349); } 
if(BgL_addz00_1342)
{ /* Llib/mpd.scm 1075 */BFALSE; }  else 
{ /* Llib/mpd.scm 1075 */
BgL_addz00_1342 = ((bool_t)1); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_artistsz00_5345, BgL_artistz00_1339, BgL_dir2z00_1338); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_albumsz00_5346, BgL_albumz00_1337, BgL_dirz00_1334); 
BGl_hashtablezd2putz12zc0zz__hashz00(BgL_genresz00_5347, BgL_genrez00_1341, BgL_dir3z00_1340); } }  else 
{ /* Llib/mpd.scm 1073 */BFALSE; } } } 
{ 
obj_t BgL_l1219z00_7810;
BgL_l1219z00_7810 = 
CDR(BgL_l1219z00_1345); 
BgL_l1219z00_1345 = BgL_l1219z00_7810; 
goto BgL_zc3z04anonymousza32177ze3z87_1346;} }  else 
{ /* Llib/mpd.scm 1080 */
return ((bool_t)1);} } } } } } } } } } } 

}



/* &<@anonymous:2173> */
obj_t BGl_z62zc3z04anonymousza32173ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_4998, obj_t BgL_e1z00_4999, obj_t BgL_e2z00_5000)
{
{ /* Llib/mpd.scm 1088 */
{ /* Llib/mpd.scm 1088 */
bool_t BgL_tmpz00_7812;
{ /* Llib/mpd.scm 1088 */
obj_t BgL_string1z00_5660;obj_t BgL_string2z00_5661;
BgL_string1z00_5660 = 
CAR(
((obj_t)BgL_e1z00_4999)); 
BgL_string2z00_5661 = 
CAR(
((obj_t)BgL_e2z00_5000)); 
BgL_tmpz00_7812 = 
bigloo_string_lt(BgL_string1z00_5660, BgL_string2z00_5661); } 
return 
BBOOL(BgL_tmpz00_7812);} } 

}



/* &<@anonymous:2168> */
obj_t BGl_z62zc3z04anonymousza32168ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5001, obj_t BgL_e1z00_5002, obj_t BgL_e2z00_5003)
{
{ /* Llib/mpd.scm 1086 */
{ /* Llib/mpd.scm 1086 */
bool_t BgL_tmpz00_7819;
{ /* Llib/mpd.scm 1086 */
obj_t BgL_string1z00_5662;obj_t BgL_string2z00_5663;
BgL_string1z00_5662 = 
CAR(
((obj_t)BgL_e1z00_5002)); 
BgL_string2z00_5663 = 
CAR(
((obj_t)BgL_e2z00_5003)); 
BgL_tmpz00_7819 = 
bigloo_string_lt(BgL_string1z00_5662, BgL_string2z00_5663); } 
return 
BBOOL(BgL_tmpz00_7819);} } 

}



/* &<@anonymous:2163> */
obj_t BGl_z62zc3z04anonymousza32163ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5004, obj_t BgL_e1z00_5005, obj_t BgL_e2z00_5006)
{
{ /* Llib/mpd.scm 1084 */
{ /* Llib/mpd.scm 1084 */
bool_t BgL_tmpz00_7826;
{ /* Llib/mpd.scm 1084 */
obj_t BgL_string1z00_5664;obj_t BgL_string2z00_5665;
BgL_string1z00_5664 = 
CAR(
((obj_t)BgL_e1z00_5005)); 
BgL_string2z00_5665 = 
CAR(
((obj_t)BgL_e2z00_5006)); 
BgL_tmpz00_7826 = 
bigloo_string_lt(BgL_string1z00_5664, BgL_string2z00_5665); } 
return 
BBOOL(BgL_tmpz00_7826);} } 

}



/* loop~4 */
bool_t BGl_loopze74ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5343, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5342, obj_t BgL_albumz00_5341, obj_t BgL_artistz00_5340, obj_t BgL_dirz00_1358)
{
{ /* Llib/mpd.scm 1270 */
{ /* Llib/mpd.scm 1271 */
obj_t BgL_artistz00_1360;
if(
CBOOL(BgL_artistz00_5340))
{ /* Llib/mpd.scm 1271 */
BgL_artistz00_1360 = BgL_artistz00_5340; }  else 
{ /* Llib/mpd.scm 1271 */
BgL_artistz00_1360 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1358)); } 
{ /* Llib/mpd.scm 1271 */
obj_t BgL_albumz00_1361;
if(
CBOOL(BgL_albumz00_5341))
{ /* Llib/mpd.scm 1272 */
BgL_albumz00_1361 = BgL_albumz00_5341; }  else 
{ /* Llib/mpd.scm 1272 */
BgL_albumz00_1361 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1358); } 
{ /* Llib/mpd.scm 1272 */
obj_t BgL_filesz00_1362;
BgL_filesz00_1362 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3432z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_1358))); 
{ /* Llib/mpd.scm 1273 */
obj_t BgL_imgz00_1363;
{ /* Llib/mpd.scm 1276 */
obj_t BgL_fz00_1377;
{ 
obj_t BgL_list1270z00_1380;
BgL_list1270z00_1380 = BgL_filesz00_1362; 
BgL_zc3z04anonymousza32192ze3z87_1381:
if(
PAIRP(BgL_list1270z00_1380))
{ /* Llib/mpd.scm 1276 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1270z00_1380)))
{ /* Llib/mpd.scm 1276 */
BgL_fz00_1377 = 
CAR(BgL_list1270z00_1380); }  else 
{ 
obj_t BgL_list1270z00_7849;
BgL_list1270z00_7849 = 
CDR(BgL_list1270z00_1380); 
BgL_list1270z00_1380 = BgL_list1270z00_7849; 
goto BgL_zc3z04anonymousza32192ze3z87_1381;} }  else 
{ /* Llib/mpd.scm 1276 */
BgL_fz00_1377 = BFALSE; } } 
if(
STRINGP(BgL_fz00_1377))
{ /* Llib/mpd.scm 1277 */
BgL_imgz00_1363 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1358, BgL_fz00_1377); }  else 
{ /* Llib/mpd.scm 1277 */
BgL_imgz00_1363 = BFALSE; } } 
{ /* Llib/mpd.scm 1276 */

{ 
obj_t BgL_l1271z00_1365;
BgL_l1271z00_1365 = BgL_filesz00_1362; 
BgL_zc3z04anonymousza32186ze3z87_1366:
if(
PAIRP(BgL_l1271z00_1365))
{ /* Llib/mpd.scm 1279 */
{ /* Llib/mpd.scm 1280 */
obj_t BgL_fz00_1368;
BgL_fz00_1368 = 
CAR(BgL_l1271z00_1365); 
{ /* Llib/mpd.scm 1280 */
obj_t BgL_pz00_1369;
BgL_pz00_1369 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1358, BgL_fz00_1368); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1369)))
{ /* Llib/mpd.scm 1282 */
BGl_loopze74ze7zz__multimediazd2mpdzd2(BgL_opz00_5343, BgL_dbz00_5342, BgL_albumz00_5341, BgL_artistz00_5340, BgL_pz00_1369); }  else 
{ /* Llib/mpd.scm 1282 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1369, 
((obj_t)BgL_dbz00_5342)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3272;
BgL_g1186z00_3272 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5342), BgL_pz00_1369, BgL_artistz00_1360, BgL_albumz00_1361, BgL_imgz00_1363); 
{ 
obj_t BgL_l1184z00_3274;
BgL_l1184z00_3274 = BgL_g1186z00_3272; 
BgL_zc3z04anonymousza31971ze3z87_3273:
if(
PAIRP(BgL_l1184z00_3274))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3276;
BgL_kz00_3276 = 
CAR(BgL_l1184z00_3274); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_3277;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_3278;
BgL_arg1974z00_3278 = 
CAR(
((obj_t)BgL_kz00_3276)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2896z00_3285;
BgL_res2896z00_3285 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_3278)); 
BgL_arg1973z00_3277 = BgL_res2896z00_3285; } } 
bgl_display_obj(BgL_arg1973z00_3277, BgL_opz00_5343); } 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_opz00_5343); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_3279;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3291;
BgL_pairz00_3291 = 
CDR(
((obj_t)BgL_kz00_3276)); 
BgL_arg1975z00_3279 = 
CAR(BgL_pairz00_3291); } 
bgl_display_obj(BgL_arg1975z00_3279, BgL_opz00_5343); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5343); } 
{ 
obj_t BgL_l1184z00_7881;
BgL_l1184z00_7881 = 
CDR(BgL_l1184z00_3274); 
BgL_l1184z00_3274 = BgL_l1184z00_7881; 
goto BgL_zc3z04anonymousza31971ze3z87_3273;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1284 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1271z00_7883;
BgL_l1271z00_7883 = 
CDR(BgL_l1271z00_1365); 
BgL_l1271z00_1365 = BgL_l1271z00_7883; 
goto BgL_zc3z04anonymousza32186ze3z87_1366;} }  else 
{ /* Llib/mpd.scm 1279 */
return ((bool_t)1);} } } } } } } } 

}



/* &<@anonymous:2200> */
obj_t BGl_z62zc3z04anonymousza32200ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5011, obj_t BgL_s1z00_5012, obj_t BgL_s2z00_5013)
{
{ /* Llib/mpd.scm 1273 */
{ /* Llib/mpd.scm 1274 */
bool_t BgL_tmpz00_7885;
{ /* Llib/mpd.scm 1274 */
int BgL_arg2201z00_5666;
{ /* Llib/mpd.scm 1274 */

BgL_arg2201z00_5666 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_5012, BgL_s2z00_5013, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_7885 = 
(
(long)(BgL_arg2201z00_5666)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_7885);} } 

}



/* getinfofile */
obj_t BGl_getinfofilez00zz__multimediazd2mpdzd2(obj_t BgL_dbz00_406, obj_t BgL_filez00_407, obj_t BgL_artistz00_408, obj_t BgL_albumz00_409, obj_t BgL_imagez00_410)
{
{ /* Llib/mpd.scm 1444 */
{ 
obj_t BgL_filez00_1492;BgL_musictagz00_bglt BgL_tagz00_1493;obj_t BgL_filez00_1472;obj_t BgL_dtz00_1458;
{ /* Llib/mpd.scm 1477 */
bool_t BgL_test3985z00_7892;
if(
fexists(
BSTRING_TO_STRING(BgL_filez00_407)))
{ /* Llib/mpd.scm 1477 */
BgL_test3985z00_7892 = 
bgl_directoryp(
BSTRING_TO_STRING(BgL_filez00_407))
; }  else 
{ /* Llib/mpd.scm 1477 */
BgL_test3985z00_7892 = ((bool_t)1)
; } 
if(BgL_test3985z00_7892)
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2206z00_1425;
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2207z00_1426;
{ /* Llib/mpd.scm 1478 */
obj_t BgL_arg2208z00_1427;
if(
bigloo_strcmp_at(BgL_filez00_407, BGl_string3403z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_arg2208z00_1427 = BgL_filez00_407; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_arg2208z00_1427 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_407, BgL_dbz00_406); } 
BgL_arg2207z00_1426 = 
MAKE_YOUNG_PAIR(BgL_arg2208z00_1427, BNIL); } 
BgL_arg2206z00_1425 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)82)), BgL_arg2207z00_1426); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2206z00_1425, BNIL);}  else 
{ /* Llib/mpd.scm 1479 */
obj_t BgL_tagz00_1428;obj_t BgL_infoz00_1429;obj_t BgL_dtz00_1430;obj_t BgL_imgz00_1431;
BgL_tagz00_1428 = 
BGl_filezd2musictagzd2zz__multimediazd2id3zd2(BgL_filez00_407); 
BgL_infoz00_1429 = 
BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(BgL_filez00_407); 
BgL_dtz00_1430 = 
bgl_seconds_to_date(
bgl_last_modification_time(
BSTRING_TO_STRING(BgL_filez00_407))); 
if(
STRINGP(BgL_imagez00_410))
{ /* Llib/mpd.scm 1482 */
BgL_imgz00_1431 = 
BGl_directoryzd2imagezd2zz__multimediazd2mpdzd2(
BGl_dirnamez00zz__osz00(BgL_filez00_407)); }  else 
{ /* Llib/mpd.scm 1482 */
BgL_imgz00_1431 = BFALSE; } 
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2209z00_1432;obj_t BgL_arg2210z00_1433;
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2211z00_1434;
{ /* Llib/mpd.scm 1483 */
obj_t BgL_arg2212z00_1435;
if(
bigloo_strcmp_at(BgL_filez00_407, BGl_string3403z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_arg2212z00_1435 = BgL_filez00_407; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_arg2212z00_1435 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_407, BgL_dbz00_406); } 
BgL_arg2211z00_1434 = 
MAKE_YOUNG_PAIR(BgL_arg2212z00_1435, BNIL); } 
BgL_arg2209z00_1432 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)82)), BgL_arg2211z00_1434); } 
{ /* Llib/mpd.scm 1484 */
obj_t BgL_arg2213z00_1436;obj_t BgL_arg2214z00_1437;
{ /* Llib/mpd.scm 1484 */
obj_t BgL_arg2215z00_1438;
{ /* Llib/mpd.scm 1484 */
obj_t BgL_tmpz00_7920;
BgL_dtz00_1458 = BgL_dtz00_1430; 
{ /* Llib/mpd.scm 1448 */
int BgL_arg2234z00_1460;int BgL_arg2235z00_1461;int BgL_arg2236z00_1462;int BgL_arg2237z00_1463;int BgL_arg2238z00_1464;int BgL_arg2239z00_1465;
{ /* Llib/mpd.scm 1448 */
int BgL_res2897z00_3296;
BgL_res2897z00_3296 = 
BGL_DATE_YEAR(BgL_dtz00_1458); 
BgL_arg2234z00_1460 = BgL_res2897z00_3296; } 
{ /* Llib/mpd.scm 1448 */
int BgL_res2898z00_3298;
BgL_res2898z00_3298 = 
BGL_DATE_MONTH(BgL_dtz00_1458); 
BgL_arg2235z00_1461 = BgL_res2898z00_3298; } 
{ /* Llib/mpd.scm 1448 */
int BgL_res2899z00_3300;
BgL_res2899z00_3300 = 
BGL_DATE_DAY(BgL_dtz00_1458); 
BgL_arg2236z00_1462 = BgL_res2899z00_3300; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2900z00_3302;
BgL_res2900z00_3302 = 
BGL_DATE_HOUR(BgL_dtz00_1458); 
BgL_arg2237z00_1463 = BgL_res2900z00_3302; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2901z00_3304;
BgL_res2901z00_3304 = 
BGL_DATE_MINUTE(BgL_dtz00_1458); 
BgL_arg2238z00_1464 = BgL_res2901z00_3304; } 
{ /* Llib/mpd.scm 1449 */
int BgL_res2902z00_3306;
BgL_res2902z00_3306 = 
BGL_DATE_SECOND(BgL_dtz00_1458); 
BgL_arg2239z00_1465 = BgL_res2902z00_3306; } 
{ /* Llib/mpd.scm 1447 */
obj_t BgL_list2240z00_1466;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2241z00_1467;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2242z00_1468;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2243z00_1469;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2244z00_1470;
{ /* Llib/mpd.scm 1447 */
obj_t BgL_arg2245z00_1471;
BgL_arg2245z00_1471 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2239z00_1465), BNIL); 
BgL_arg2244z00_1470 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2238z00_1464), BgL_arg2245z00_1471); } 
BgL_arg2243z00_1469 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2237z00_1463), BgL_arg2244z00_1470); } 
BgL_arg2242z00_1468 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2236z00_1462), BgL_arg2243z00_1469); } 
BgL_arg2241z00_1467 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2235z00_1461), BgL_arg2242z00_1468); } 
BgL_list2240z00_1466 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2234z00_1460), BgL_arg2241z00_1467); } 
BgL_tmpz00_7920 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3433z00zz__multimediazd2mpdzd2, BgL_list2240z00_1466); } } 
BgL_arg2215z00_1438 = 
MAKE_YOUNG_PAIR(BgL_tmpz00_7920, BNIL); } 
BgL_arg2213z00_1436 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)83)), BgL_arg2215z00_1438); } 
{ /* Llib/mpd.scm 1485 */
obj_t BgL_arg2217z00_1440;obj_t BgL_arg2218z00_1441;
if(
BGl_isazf3zf3zz__objectz00(BgL_infoz00_1429, BGl_musicinfoz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1487 */
obj_t BgL_arg2220z00_1444;
{ /* Llib/mpd.scm 1487 */
obj_t BgL_arg2221z00_1445;
{ /* Llib/mpd.scm 1487 */
long BgL_arg2222z00_1446;
BgL_arg2222z00_1446 = 
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_infoz00_1429)))->BgL_durationz00); 
BgL_arg2221z00_1445 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2222z00_1446), BNIL); } 
BgL_arg2220z00_1444 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)84)), BgL_arg2221z00_1445); } 
BgL_arg2217z00_1440 = 
MAKE_YOUNG_PAIR(BgL_arg2220z00_1444, BNIL); }  else 
{ /* Llib/mpd.scm 1485 */
BgL_arg2217z00_1440 = BNIL; } 
{ /* Llib/mpd.scm 1489 */
obj_t BgL_arg2223z00_1447;obj_t BgL_arg2224z00_1448;
if(
BGl_isazf3zf3zz__objectz00(BgL_tagz00_1428, BGl_musictagz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1489 */
BgL_filez00_1492 = BgL_filez00_407; 
BgL_tagz00_1493 = 
((BgL_musictagz00_bglt)BgL_tagz00_1428); 
{ /* Llib/mpd.scm 1461 */
obj_t BgL_dirz00_1496;
BgL_dirz00_1496 = 
BGl_dirnamez00zz__osz00(BgL_filez00_1492); 
{ /* Llib/mpd.scm 1461 */
obj_t BgL_atz00_1497;
if(
CBOOL(BgL_artistz00_408))
{ /* Llib/mpd.scm 1462 */
BgL_atz00_1497 = BgL_artistz00_408; }  else 
{ /* Llib/mpd.scm 1462 */
if(
bigloo_strcicmp(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_artistz00), BGl_string3434z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1463 */
BgL_atz00_1497 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1496))); }  else 
{ /* Llib/mpd.scm 1463 */
BgL_atz00_1497 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_artistz00); } } 
{ /* Llib/mpd.scm 1462 */
obj_t BgL_alz00_1498;
if(
CBOOL(BgL_albumz00_409))
{ /* Llib/mpd.scm 1466 */
BgL_alz00_1498 = BgL_albumz00_409; }  else 
{ /* Llib/mpd.scm 1466 */
if(
bigloo_strcicmp(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_albumz00), BGl_string3435z00zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1467 */
BgL_alz00_1498 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_1496)); }  else 
{ /* Llib/mpd.scm 1467 */
BgL_alz00_1498 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_albumz00); } } 
{ /* Llib/mpd.scm 1466 */

{ /* Llib/mpd.scm 1470 */
obj_t BgL_arg2263z00_1499;obj_t BgL_arg2264z00_1500;
{ /* Llib/mpd.scm 1470 */
obj_t BgL_arg2265z00_1501;
BgL_arg2265z00_1501 = 
MAKE_YOUNG_PAIR(BgL_atz00_1497, BNIL); 
BgL_arg2263z00_1499 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)76)), BgL_arg2265z00_1501); } 
{ /* Llib/mpd.scm 1471 */
obj_t BgL_arg2266z00_1502;obj_t BgL_arg2267z00_1503;
{ /* Llib/mpd.scm 1471 */
obj_t BgL_arg2268z00_1504;
BgL_arg2268z00_1504 = 
MAKE_YOUNG_PAIR(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_titlez00), BNIL); 
BgL_arg2266z00_1502 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)77)), BgL_arg2268z00_1504); } 
{ /* Llib/mpd.scm 1472 */
obj_t BgL_arg2270z00_1506;obj_t BgL_arg2271z00_1507;
{ /* Llib/mpd.scm 1472 */
obj_t BgL_arg2272z00_1508;
BgL_arg2272z00_1508 = 
MAKE_YOUNG_PAIR(BgL_alz00_1498, BNIL); 
BgL_arg2270z00_1506 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)78)), BgL_arg2272z00_1508); } 
{ /* Llib/mpd.scm 1473 */
obj_t BgL_arg2273z00_1509;obj_t BgL_arg2274z00_1510;
{ /* Llib/mpd.scm 1473 */
obj_t BgL_arg2275z00_1511;
{ /* Llib/mpd.scm 1473 */
int BgL_arg2276z00_1512;
BgL_arg2276z00_1512 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_trackz00); 
BgL_arg2275z00_1511 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2276z00_1512), BNIL); } 
BgL_arg2273z00_1509 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)79)), BgL_arg2275z00_1511); } 
{ /* Llib/mpd.scm 1474 */
obj_t BgL_arg2277z00_1513;obj_t BgL_arg2278z00_1514;
{ /* Llib/mpd.scm 1474 */
obj_t BgL_arg2279z00_1515;
{ /* Llib/mpd.scm 1474 */
int BgL_arg2280z00_1516;
BgL_arg2280z00_1516 = 
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_yearz00); 
BgL_arg2279z00_1515 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2280z00_1516), BNIL); } 
BgL_arg2277z00_1513 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)80)), BgL_arg2279z00_1515); } 
{ /* Llib/mpd.scm 1475 */
obj_t BgL_arg2281z00_1517;
{ /* Llib/mpd.scm 1475 */
obj_t BgL_arg2282z00_1518;
BgL_arg2282z00_1518 = 
MAKE_YOUNG_PAIR(
(((BgL_musictagz00_bglt)COBJECT(BgL_tagz00_1493))->BgL_genrez00), BNIL); 
BgL_arg2281z00_1517 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)81)), BgL_arg2282z00_1518); } 
BgL_arg2278z00_1514 = 
MAKE_YOUNG_PAIR(BgL_arg2281z00_1517, BNIL); } 
BgL_arg2274z00_1510 = 
MAKE_YOUNG_PAIR(BgL_arg2277z00_1513, BgL_arg2278z00_1514); } 
BgL_arg2271z00_1507 = 
MAKE_YOUNG_PAIR(BgL_arg2273z00_1509, BgL_arg2274z00_1510); } 
BgL_arg2267z00_1503 = 
MAKE_YOUNG_PAIR(BgL_arg2270z00_1506, BgL_arg2271z00_1507); } 
BgL_arg2264z00_1500 = 
MAKE_YOUNG_PAIR(BgL_arg2266z00_1502, BgL_arg2267z00_1503); } 
BgL_arg2223z00_1447 = 
MAKE_YOUNG_PAIR(BgL_arg2263z00_1499, BgL_arg2264z00_1500); } } } } } }  else 
{ /* Llib/mpd.scm 1489 */
BgL_filez00_1472 = BgL_filez00_407; 
{ /* Llib/mpd.scm 1452 */
obj_t BgL_dirz00_1474;
BgL_dirz00_1474 = 
BGl_dirnamez00zz__osz00(BgL_filez00_1472); 
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2247z00_1475;obj_t BgL_arg2248z00_1476;
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2249z00_1477;
{ /* Llib/mpd.scm 1453 */
obj_t BgL_arg2250z00_1478;
if(
CBOOL(BgL_artistz00_408))
{ /* Llib/mpd.scm 1453 */
BgL_arg2250z00_1478 = BgL_artistz00_408; }  else 
{ /* Llib/mpd.scm 1453 */
BgL_arg2250z00_1478 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1474))); } 
BgL_arg2249z00_1477 = 
MAKE_YOUNG_PAIR(BgL_arg2250z00_1478, BNIL); } 
BgL_arg2247z00_1475 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)76)), BgL_arg2249z00_1477); } 
{ /* Llib/mpd.scm 1454 */
obj_t BgL_arg2253z00_1482;obj_t BgL_arg2254z00_1483;
{ /* Llib/mpd.scm 1454 */
obj_t BgL_arg2255z00_1484;
BgL_arg2255z00_1484 = 
MAKE_YOUNG_PAIR(
BGl_prefixz00zz__osz00(
BGl_basenamez00zz__osz00(BgL_filez00_1472)), BNIL); 
BgL_arg2253z00_1482 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)77)), BgL_arg2255z00_1484); } 
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2258z00_1487;
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2259z00_1488;
{ /* Llib/mpd.scm 1455 */
obj_t BgL_arg2260z00_1489;
if(
CBOOL(BgL_albumz00_409))
{ /* Llib/mpd.scm 1455 */
BgL_arg2260z00_1489 = BgL_albumz00_409; }  else 
{ /* Llib/mpd.scm 1455 */
BgL_arg2260z00_1489 = 
BGl_stringzd2capitaliza7ez75zz__r4_strings_6_7z00(
BGl_basenamez00zz__osz00(BgL_dirz00_1474)); } 
BgL_arg2259z00_1488 = 
MAKE_YOUNG_PAIR(BgL_arg2260z00_1489, BNIL); } 
BgL_arg2258z00_1487 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)78)), BgL_arg2259z00_1488); } 
BgL_arg2254z00_1483 = 
MAKE_YOUNG_PAIR(BgL_arg2258z00_1487, BNIL); } 
BgL_arg2248z00_1476 = 
MAKE_YOUNG_PAIR(BgL_arg2253z00_1482, BgL_arg2254z00_1483); } 
BgL_arg2223z00_1447 = 
MAKE_YOUNG_PAIR(BgL_arg2247z00_1475, BgL_arg2248z00_1476); } } } 
{ /* Llib/mpd.scm 1492 */
obj_t BgL_arg2226z00_1450;
if(
STRINGP(BgL_imgz00_1431))
{ /* Llib/mpd.scm 1493 */
obj_t BgL_arg2228z00_1452;
{ /* Llib/mpd.scm 1493 */
obj_t BgL_arg2229z00_1453;
BgL_arg2229z00_1453 = 
MAKE_YOUNG_PAIR(BgL_imgz00_1431, BNIL); 
BgL_arg2228z00_1452 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)85)), BgL_arg2229z00_1453); } 
BgL_arg2226z00_1450 = 
MAKE_YOUNG_PAIR(BgL_arg2228z00_1452, BNIL); }  else 
{ /* Llib/mpd.scm 1492 */
BgL_arg2226z00_1450 = BNIL; } 
BgL_arg2224z00_1448 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2226z00_1450, BNIL); } 
BgL_arg2218z00_1441 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2223z00_1447, BgL_arg2224z00_1448); } 
BgL_arg2214z00_1437 = 
BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(BgL_arg2217z00_1440, BgL_arg2218z00_1441); } 
BgL_arg2210z00_1433 = 
MAKE_YOUNG_PAIR(BgL_arg2213z00_1436, BgL_arg2214z00_1437); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2209z00_1432, BgL_arg2210z00_1433);} } } } } 

}



/* loop~3 */
obj_t BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_dbz00_5339, obj_t BgL_albumz00_5338, bool_t BgL_artistz00_5337, obj_t BgL_dirz00_1535)
{
{ /* Llib/mpd.scm 1500 */
{ /* Llib/mpd.scm 1501 */
obj_t BgL_artistz00_1537;obj_t BgL_albumz00_1538;
if(BgL_artistz00_5337)
{ /* Llib/mpd.scm 1501 */
BgL_artistz00_1537 = 
BBOOL(BgL_artistz00_5337); }  else 
{ /* Llib/mpd.scm 1501 */
BgL_artistz00_1537 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_1535)); } 
if(
CBOOL(BgL_albumz00_5338))
{ /* Llib/mpd.scm 1502 */
BgL_albumz00_1538 = BgL_albumz00_5338; }  else 
{ /* Llib/mpd.scm 1502 */
BgL_albumz00_1538 = 
BGl_basenamez00zz__osz00(BgL_dirz00_1535); } 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_l1312z00_1539;
BgL_l1312z00_1539 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3436z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_1535))); 
if(
NULLP(BgL_l1312z00_1539))
{ /* Llib/mpd.scm 1503 */
return BNIL;}  else 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_head1314z00_1541;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_res2913z00_3334;
BgL_res2913z00_3334 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1314z00_1541 = BgL_res2913z00_3334; } 
{ 
obj_t BgL_l1312z00_1543;obj_t BgL_tail1315z00_1544;
BgL_l1312z00_1543 = BgL_l1312z00_1539; 
BgL_tail1315z00_1544 = BgL_head1314z00_1541; 
BgL_zc3z04anonymousza32295ze3z87_1545:
if(
NULLP(BgL_l1312z00_1543))
{ /* Llib/mpd.scm 1503 */
return 
CDR(BgL_head1314z00_1541);}  else 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_newtail1316z00_1547;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_arg2298z00_1549;
{ /* Llib/mpd.scm 1503 */
obj_t BgL_fz00_1550;
BgL_fz00_1550 = 
CAR(
((obj_t)BgL_l1312z00_1543)); 
{ /* Llib/mpd.scm 1504 */
obj_t BgL_pz00_1551;
BgL_pz00_1551 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_1535, BgL_fz00_1550); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_1551)))
{ /* Llib/mpd.scm 1506 */
BgL_arg2298z00_1549 = 
BGl_loopze73ze7zz__multimediazd2mpdzd2(BgL_dbz00_5339, BgL_albumz00_5338, BgL_artistz00_5337, BgL_pz00_1551); }  else 
{ /* Llib/mpd.scm 1506 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_1551, 
((obj_t)BgL_dbz00_5339)))
{ /* Llib/mpd.scm 1509 */

BgL_arg2298z00_1549 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5339), BgL_pz00_1551, BgL_artistz00_1537, BgL_albumz00_1538, BFALSE); }  else 
{ /* Llib/mpd.scm 1508 */
BgL_arg2298z00_1549 = BFALSE; } } } } 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_res2916z00_3340;
BgL_res2916z00_3340 = 
MAKE_YOUNG_PAIR(BgL_arg2298z00_1549, BNIL); 
BgL_newtail1316z00_1547 = BgL_res2916z00_3340; } } 
SET_CDR(BgL_tail1315z00_1544, BgL_newtail1316z00_1547); 
{ /* Llib/mpd.scm 1503 */
obj_t BgL_arg2297z00_1548;
BgL_arg2297z00_1548 = 
CDR(
((obj_t)BgL_l1312z00_1543)); 
{ 
obj_t BgL_tail1315z00_8071;obj_t BgL_l1312z00_8070;
BgL_l1312z00_8070 = BgL_arg2297z00_1548; 
BgL_tail1315z00_8071 = BgL_newtail1316z00_1547; 
BgL_tail1315z00_1544 = BgL_tail1315z00_8071; 
BgL_l1312z00_1543 = BgL_l1312z00_8070; 
goto BgL_zc3z04anonymousza32295ze3z87_1545;} } } } } } } } 

}



/* &<@anonymous:2303> */
obj_t BGl_z62zc3z04anonymousza32303ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5015, obj_t BgL_s1z00_5016, obj_t BgL_s2z00_5017)
{
{ /* Llib/mpd.scm 1510 */
{ /* Llib/mpd.scm 1511 */
bool_t BgL_tmpz00_8072;
{ /* Llib/mpd.scm 1511 */
int BgL_arg2304z00_5667;
{ /* Llib/mpd.scm 1511 */

BgL_arg2304z00_5667 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_5016, BgL_s2z00_5017, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_8072 = 
(
(long)(BgL_arg2304z00_5667)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_8072);} } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2309z00_1578;obj_t BgL_arg2310z00_1579;
{ /* Llib/mpd.scm 20 */
obj_t BgL_v1317z00_1601;
BgL_v1317z00_1601 = 
create_vector(((long)11)); 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2317z00_1602;
BgL_arg2317z00_1602 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)86)), BGl_proc3439z00zz__multimediazd2mpdzd2, BGl_proc3438z00zz__multimediazd2mpdzd2, ((bool_t)1), ((bool_t)0), BFALSE, BGl_proc3437z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1317z00_1601,((long)0),BgL_arg2317z00_1602); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2324z00_1615;
BgL_arg2324z00_1615 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)88)), BGl_proc3442z00zz__multimediazd2mpdzd2, BGl_proc3441z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3440z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1317z00_1601,((long)1),BgL_arg2324z00_1615); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2331z00_1628;
BgL_arg2331z00_1628 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)89)), BGl_proc3445z00zz__multimediazd2mpdzd2, BGl_proc3444z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3443z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)90))); 
VECTOR_SET(BgL_v1317z00_1601,((long)2),BgL_arg2331z00_1628); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2338z00_1641;
BgL_arg2338z00_1641 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)91)), BGl_proc3448z00zz__multimediazd2mpdzd2, BGl_proc3447z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3446z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1317z00_1601,((long)3),BgL_arg2338z00_1641); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2345z00_1654;
BgL_arg2345z00_1654 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)92)), BGl_proc3451z00zz__multimediazd2mpdzd2, BGl_proc3450z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3449z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1317z00_1601,((long)4),BgL_arg2345z00_1654); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2352z00_1667;
BgL_arg2352z00_1667 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)93)), BGl_proc3454z00zz__multimediazd2mpdzd2, BGl_proc3453z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3452z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)87))); 
VECTOR_SET(BgL_v1317z00_1601,((long)5),BgL_arg2352z00_1667); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2359z00_1680;
BgL_arg2359z00_1680 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)94)), BGl_proc3457z00zz__multimediazd2mpdzd2, BGl_proc3456z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3455z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)95))); 
VECTOR_SET(BgL_v1317z00_1601,((long)6),BgL_arg2359z00_1680); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2366z00_1693;
BgL_arg2366z00_1693 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)96)), BGl_proc3460z00zz__multimediazd2mpdzd2, BGl_proc3459z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3458z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)97))); 
VECTOR_SET(BgL_v1317z00_1601,((long)7),BgL_arg2366z00_1693); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2373z00_1706;
BgL_arg2373z00_1706 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)98)), BGl_proc3463z00zz__multimediazd2mpdzd2, BGl_proc3462z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3461z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)97))); 
VECTOR_SET(BgL_v1317z00_1601,((long)8),BgL_arg2373z00_1706); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2380z00_1719;
BgL_arg2380z00_1719 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)99)), BGl_proc3466z00zz__multimediazd2mpdzd2, BGl_proc3465z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3464z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)95))); 
VECTOR_SET(BgL_v1317z00_1601,((long)9),BgL_arg2380z00_1719); } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_arg2387z00_1732;
BgL_arg2387z00_1732 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)100)), BGl_proc3469z00zz__multimediazd2mpdzd2, BGl_proc3468z00zz__multimediazd2mpdzd2, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc3467z00zz__multimediazd2mpdzd2, 
CNST_TABLE_REF(((long)95))); 
VECTOR_SET(BgL_v1317z00_1601,((long)10),BgL_arg2387z00_1732); } 
BgL_arg2309z00_1578 = BgL_v1317z00_1601; } 
{ /* Llib/mpd.scm 20 */
obj_t BgL_v1318z00_1745;
BgL_v1318z00_1745 = 
create_vector(((long)0)); 
BgL_arg2310z00_1579 = BgL_v1318z00_1745; } 
return ( 
BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)101)), 
CNST_TABLE_REF(((long)102)), BGl_objectz00zz__objectz00, ((long)35683), BGl_proc3472z00zz__multimediazd2mpdzd2, BGl_proc3471z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BGl_proc3470z00zz__multimediazd2mpdzd2, BFALSE, BgL_arg2309z00_1578, BgL_arg2310z00_1579), BUNSPEC) ;} } 

}



/* &<@anonymous:2316> */
obj_t BGl_z62zc3z04anonymousza32316ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5054, obj_t BgL_new1065z00_5055)
{
{ /* Llib/mpd.scm 20 */
{ 
BgL_mpdzd2databasezd2_bglt BgL_auxz00_8128;
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_directoriesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_suffixesz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52basez52)=((obj_t)BGl_string3363z00zz__multimediazd2mpdzd2),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52artistsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52albumsz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52genresz52)=((obj_t)BNIL),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52nartistsz52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52nalbumsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52nsongsz52)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52uptimez52)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055)))->BgL_z52dbzd2updatez80)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_8128 = 
((BgL_mpdzd2databasezd2_bglt)BgL_new1065z00_5055); 
return 
((obj_t)BgL_auxz00_8128);} } 

}



/* &lambda2314 */
BgL_mpdzd2databasezd2_bglt BGl_z62lambda2314z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5056)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1064z00_5669;
BgL_new1064z00_5669 = 
((BgL_mpdzd2databasezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpdzd2databasezd2_bgl) ))); 
{ /* Llib/mpd.scm 20 */
long BgL_arg2315z00_5670;
{ /* Llib/mpd.scm 20 */
long BgL_res2918z00_5671;
BgL_res2918z00_5671 = 
BGL_CLASS_INDEX(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
BgL_arg2315z00_5670 = BgL_res2918z00_5671; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1064z00_5669), BgL_arg2315z00_5670); } 
return BgL_new1064z00_5669;} } 

}



/* &lambda2311 */
BgL_mpdzd2databasezd2_bglt BGl_z62lambda2311z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5057, obj_t BgL_directories1053z00_5058, obj_t BgL_suffixes1054z00_5059, obj_t BgL_z52base1055z52_5060, obj_t BgL_z52artists1056z52_5061, obj_t BgL_z52albums1057z52_5062, obj_t BgL_z52genres1058z52_5063, obj_t BgL_z52nartists1059z52_5064, obj_t BgL_z52nalbums1060z52_5065, obj_t BgL_z52nsongs1061z52_5066, obj_t BgL_z52uptime1062z52_5067, obj_t BgL_z52dbzd2update1063z80_5068)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_z52nalbums1060z52_5678;int BgL_z52nsongs1061z52_5679;
BgL_z52nalbums1060z52_5678 = 
CINT(BgL_z52nalbums1060z52_5065); 
BgL_z52nsongs1061z52_5679 = 
CINT(BgL_z52nsongs1061z52_5066); 
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1174z00_5680;
{ /* Llib/mpd.scm 20 */
BgL_mpdzd2databasezd2_bglt BgL_new1173z00_5681;
BgL_new1173z00_5681 = 
((BgL_mpdzd2databasezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_mpdzd2databasezd2_bgl) ))); 
{ /* Llib/mpd.scm 20 */
long BgL_arg2313z00_5682;
{ /* Llib/mpd.scm 20 */
long BgL_res2917z00_5683;
BgL_res2917z00_5683 = 
BGL_CLASS_INDEX(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
BgL_arg2313z00_5682 = BgL_res2917z00_5683; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1173z00_5681), BgL_arg2313z00_5682); } 
BgL_new1174z00_5680 = BgL_new1173z00_5681; } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_directoriesz00)=((obj_t)
((obj_t)BgL_directories1053z00_5058)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_suffixesz00)=((obj_t)
((obj_t)BgL_suffixes1054z00_5059)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52basez52)=((obj_t)
((obj_t)BgL_z52base1055z52_5060)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52artistsz52)=((obj_t)
((obj_t)BgL_z52artists1056z52_5061)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52albumsz52)=((obj_t)
((obj_t)BgL_z52albums1057z52_5062)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52genresz52)=((obj_t)
((obj_t)BgL_z52genres1058z52_5063)),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52nartistsz52)=((obj_t)BgL_z52nartists1059z52_5064),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52nalbumsz52)=((int)BgL_z52nalbums1060z52_5678),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52nsongsz52)=((int)BgL_z52nsongs1061z52_5679),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52uptimez52)=((obj_t)BgL_z52uptime1062z52_5067),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(BgL_new1174z00_5680))->BgL_z52dbzd2updatez80)=((obj_t)BgL_z52dbzd2update1063z80_5068),BUNSPEC); 
{ /* Llib/mpd.scm 20 */
obj_t BgL_fun2312z00_5684;
BgL_fun2312z00_5684 = 
BGl_classzd2constructorzd2zz__objectz00(BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2); 
PROCEDURE_ENTRY(BgL_fun2312z00_5684)(BgL_fun2312z00_5684, 
((obj_t)BgL_new1174z00_5680), BEOA); } 
return BgL_new1174z00_5680;} } } 

}



/* &<@anonymous:2393> */
obj_t BGl_z62zc3z04anonymousza32393ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5069)
{
{ /* Llib/mpd.scm 20 */
return BUNSPEC;} 

}



/* &lambda2392 */
obj_t BGl_z62lambda2392z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5070, obj_t BgL_oz00_5071, obj_t BgL_vz00_5072)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5071)))->BgL_z52dbzd2updatez80)=((obj_t)BgL_vz00_5072),BUNSPEC);} 

}



/* &lambda2391 */
obj_t BGl_z62lambda2391z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5073, obj_t BgL_oz00_5074)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5074)))->BgL_z52dbzd2updatez80);} 

}



/* &<@anonymous:2386> */
obj_t BGl_z62zc3z04anonymousza32386ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5075)
{
{ /* Llib/mpd.scm 20 */
return BUNSPEC;} 

}



/* &lambda2385 */
obj_t BGl_z62lambda2385z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5076, obj_t BgL_oz00_5077, obj_t BgL_vz00_5078)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5077)))->BgL_z52uptimez52)=((obj_t)BgL_vz00_5078),BUNSPEC);} 

}



/* &lambda2384 */
obj_t BGl_z62lambda2384z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5079, obj_t BgL_oz00_5080)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5080)))->BgL_z52uptimez52);} 

}



/* &<@anonymous:2379> */
obj_t BGl_z62zc3z04anonymousza32379ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5081)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2378 */
obj_t BGl_z62lambda2378z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5082, obj_t BgL_oz00_5083, obj_t BgL_vz00_5084)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_vz00_5690;
BgL_vz00_5690 = 
CINT(BgL_vz00_5084); 
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5083)))->BgL_z52nsongsz52)=((int)BgL_vz00_5690),BUNSPEC);} } 

}



/* &lambda2377 */
obj_t BGl_z62lambda2377z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5085, obj_t BgL_oz00_5086)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5086)))->BgL_z52nsongsz52));} 

}



/* &<@anonymous:2372> */
obj_t BGl_z62zc3z04anonymousza32372ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5087)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2371 */
obj_t BGl_z62lambda2371z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5088, obj_t BgL_oz00_5089, obj_t BgL_vz00_5090)
{
{ /* Llib/mpd.scm 20 */
{ /* Llib/mpd.scm 20 */
int BgL_vz00_5693;
BgL_vz00_5693 = 
CINT(BgL_vz00_5090); 
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5089)))->BgL_z52nalbumsz52)=((int)BgL_vz00_5693),BUNSPEC);} } 

}



/* &lambda2370 */
obj_t BGl_z62lambda2370z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5091, obj_t BgL_oz00_5092)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5092)))->BgL_z52nalbumsz52));} 

}



/* &<@anonymous:2365> */
obj_t BGl_z62zc3z04anonymousza32365ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5093)
{
{ /* Llib/mpd.scm 20 */
return 
BINT(((long)0));} 

}



/* &lambda2364 */
obj_t BGl_z62lambda2364z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5094, obj_t BgL_oz00_5095, obj_t BgL_vz00_5096)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5095)))->BgL_z52nartistsz52)=((obj_t)BgL_vz00_5096),BUNSPEC);} 

}



/* &lambda2363 */
obj_t BGl_z62lambda2363z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5097, obj_t BgL_oz00_5098)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5098)))->BgL_z52nartistsz52);} 

}



/* &<@anonymous:2358> */
obj_t BGl_z62zc3z04anonymousza32358ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5099)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2357 */
obj_t BGl_z62lambda2357z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5100, obj_t BgL_oz00_5101, obj_t BgL_vz00_5102)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5101)))->BgL_z52genresz52)=((obj_t)
((obj_t)BgL_vz00_5102)),BUNSPEC);} 

}



/* &lambda2356 */
obj_t BGl_z62lambda2356z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5103, obj_t BgL_oz00_5104)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5104)))->BgL_z52genresz52);} 

}



/* &<@anonymous:2351> */
obj_t BGl_z62zc3z04anonymousza32351ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5105)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2350 */
obj_t BGl_z62lambda2350z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5106, obj_t BgL_oz00_5107, obj_t BgL_vz00_5108)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5107)))->BgL_z52albumsz52)=((obj_t)
((obj_t)BgL_vz00_5108)),BUNSPEC);} 

}



/* &lambda2349 */
obj_t BGl_z62lambda2349z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5109, obj_t BgL_oz00_5110)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5110)))->BgL_z52albumsz52);} 

}



/* &<@anonymous:2344> */
obj_t BGl_z62zc3z04anonymousza32344ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5111)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2343 */
obj_t BGl_z62lambda2343z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5112, obj_t BgL_oz00_5113, obj_t BgL_vz00_5114)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5113)))->BgL_z52artistsz52)=((obj_t)
((obj_t)BgL_vz00_5114)),BUNSPEC);} 

}



/* &lambda2342 */
obj_t BGl_z62lambda2342z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5115, obj_t BgL_oz00_5116)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5116)))->BgL_z52artistsz52);} 

}



/* &<@anonymous:2337> */
obj_t BGl_z62zc3z04anonymousza32337ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5117)
{
{ /* Llib/mpd.scm 20 */
return BGl_string3369z00zz__multimediazd2mpdzd2;} 

}



/* &lambda2336 */
obj_t BGl_z62lambda2336z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5118, obj_t BgL_oz00_5119, obj_t BgL_vz00_5120)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5119)))->BgL_z52basez52)=((obj_t)
((obj_t)BgL_vz00_5120)),BUNSPEC);} 

}



/* &lambda2335 */
obj_t BGl_z62lambda2335z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5121, obj_t BgL_oz00_5122)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5122)))->BgL_z52basez52);} 

}



/* &<@anonymous:2330> */
obj_t BGl_z62zc3z04anonymousza32330ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5123)
{
{ /* Llib/mpd.scm 20 */
return 
CNST_TABLE_REF(((long)103));} 

}



/* &lambda2329 */
obj_t BGl_z62lambda2329z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5124, obj_t BgL_oz00_5125, obj_t BgL_vz00_5126)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5125)))->BgL_suffixesz00)=((obj_t)
((obj_t)BgL_vz00_5126)),BUNSPEC);} 

}



/* &lambda2328 */
obj_t BGl_z62lambda2328z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5127, obj_t BgL_oz00_5128)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5128)))->BgL_suffixesz00);} 

}



/* &<@anonymous:2323> */
obj_t BGl_z62zc3z04anonymousza32323ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5129)
{
{ /* Llib/mpd.scm 20 */
return BNIL;} 

}



/* &lambda2322 */
obj_t BGl_z62lambda2322z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5130, obj_t BgL_oz00_5131, obj_t BgL_vz00_5132)
{
{ /* Llib/mpd.scm 20 */
return 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5131)))->BgL_directoriesz00)=((obj_t)
((obj_t)BgL_vz00_5132)),BUNSPEC);} 

}



/* &lambda2321 */
obj_t BGl_z62lambda2321z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5133, obj_t BgL_oz00_5134)
{
{ /* Llib/mpd.scm 20 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5134)))->BgL_directoriesz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, BGl_proc3473z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3474z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, BGl_proc3475z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3476z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, BGl_proc3477z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3478z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3479z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3480z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3481z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3482z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3483z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3484z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3485z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3486z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3487z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3488z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3489z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3490z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3491z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3492z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, BGl_proc3493z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3494z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, BGl_proc3495z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3496z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, BGl_proc3497z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3498z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3499z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3500z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3501z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3502z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, BGl_proc3503z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3504z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, BGl_proc3505z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3506z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, BGl_proc3507z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3508z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3509z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3510z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3511z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3512z00zz__multimediazd2mpdzd2); 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, BGl_proc3513z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3514z00zz__multimediazd2mpdzd2); 
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, BGl_proc3515z00zz__multimediazd2mpdzd2, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2, BGl_string3516z00zz__multimediazd2mpdzd2);} 

}



/* &mpd-database-get-alb1393 */
obj_t BGl_z62mpdzd2databasezd2getzd2alb1393zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5161, obj_t BgL_oz00_5162, obj_t BgL_albumz00_5163)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1519 */
obj_t BgL_cz00_5719;
BgL_cz00_5719 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_albumz00_5163, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5162)))->BgL_z52albumsz52)); 
if(
PAIRP(BgL_cz00_5719))
{ /* Llib/mpd.scm 1521 */
obj_t BgL_dirz00_5721;
BgL_dirz00_5721 = 
CDR(BgL_cz00_5719); 
return 
BGl_loopze73ze7zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5162), BgL_albumz00_5163, ((bool_t)0), BgL_dirz00_5721);}  else 
{ /* Llib/mpd.scm 1520 */
return BFALSE;} } } 

}



/* &mpd-database-getarti1387 */
obj_t BGl_z62mpdzd2databasezd2getarti1387z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5164, obj_t BgL_oz00_5165, obj_t BgL_artistz00_5166)
{
{ /* Llib/mpd.scm 1431 */
if(
STRINGP(BgL_artistz00_5166))
{ /* Llib/mpd.scm 1434 */
obj_t BgL_arg2647z00_5724;
BgL_arg2647z00_5724 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5165)))->BgL_z52albumsz52); 
{ /* Llib/mpd.scm 1435 */
obj_t BgL_zc3z04anonymousza32649ze3z87_5725;
BgL_zc3z04anonymousza32649ze3z87_5725 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32649ze3ze5zz__multimediazd2mpdzd2, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32649ze3z87_5725, 
(int)(((long)0)), BgL_artistz00_5166); 
{ /* Llib/mpd.scm 1434 */
obj_t BgL_list2648z00_5726;
BgL_list2648z00_5726 = 
MAKE_YOUNG_PAIR(BgL_arg2647z00_5724, BNIL); 
return 
BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(BgL_zc3z04anonymousza32649ze3z87_5725, BgL_list2648z00_5726);} } }  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_l1306z00_5727;
BgL_l1306z00_5727 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5165)))->BgL_z52albumsz52); 
if(
NULLP(BgL_l1306z00_5727))
{ /* Llib/mpd.scm 1439 */
return BNIL;}  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_head1308z00_5728;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_res3029z00_5729;
BgL_res3029z00_5729 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1308z00_5728 = BgL_res3029z00_5729; } 
{ 
obj_t BgL_l1306z00_5731;obj_t BgL_tail1309z00_5732;
BgL_l1306z00_5731 = BgL_l1306z00_5727; 
BgL_tail1309z00_5732 = BgL_head1308z00_5728; 
BgL_zc3z04anonymousza32658ze3z87_5730:
if(
NULLP(BgL_l1306z00_5731))
{ /* Llib/mpd.scm 1439 */
return 
CDR(BgL_head1308z00_5728);}  else 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_newtail1310z00_5733;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2661z00_5734;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_az00_5735;
BgL_az00_5735 = 
CAR(
((obj_t)BgL_l1306z00_5731)); 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2662z00_5736;
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2663z00_5737;
BgL_arg2663z00_5737 = 
CAR(
((obj_t)BgL_az00_5735)); 
BgL_arg2662z00_5736 = 
MAKE_YOUNG_PAIR(BgL_arg2663z00_5737, BNIL); } 
BgL_arg2661z00_5734 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)66)), BgL_arg2662z00_5736); } } 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_res3031z00_5738;
BgL_res3031z00_5738 = 
MAKE_YOUNG_PAIR(BgL_arg2661z00_5734, BNIL); 
BgL_newtail1310z00_5733 = BgL_res3031z00_5738; } } 
SET_CDR(BgL_tail1309z00_5732, BgL_newtail1310z00_5733); 
{ /* Llib/mpd.scm 1439 */
obj_t BgL_arg2660z00_5739;
BgL_arg2660z00_5739 = 
CDR(
((obj_t)BgL_l1306z00_5731)); 
{ 
obj_t BgL_tail1309z00_8307;obj_t BgL_l1306z00_8306;
BgL_l1306z00_8306 = BgL_arg2660z00_5739; 
BgL_tail1309z00_8307 = BgL_newtail1310z00_5733; 
BgL_tail1309z00_5732 = BgL_tail1309z00_8307; 
BgL_l1306z00_5731 = BgL_l1306z00_8306; 
goto BgL_zc3z04anonymousza32658ze3z87_5730;} } } } } } } 

}



/* &<@anonymous:2649> */
obj_t BGl_z62zc3z04anonymousza32649ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5167, obj_t BgL_cz00_5169)
{
{ /* Llib/mpd.scm 1434 */
{ /* Llib/mpd.scm 1435 */
obj_t BgL_artistz00_5168;
BgL_artistz00_5168 = 
PROCEDURE_REF(BgL_envz00_5167, 
(int)(((long)0))); 
{ /* Llib/mpd.scm 1435 */
obj_t BgL_dirz00_5740;
BgL_dirz00_5740 = 
CDR(
((obj_t)BgL_cz00_5169)); 
{ /* Llib/mpd.scm 1436 */
bool_t BgL_test4009z00_8312;
{ /* Llib/mpd.scm 1436 */
obj_t BgL_arg2655z00_5741;
BgL_arg2655z00_5741 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5740)); 
{ /* Llib/mpd.scm 1436 */
bool_t BgL_res3027z00_5742;
{ /* Llib/mpd.scm 1436 */
long BgL_l1z00_5743;
BgL_l1z00_5743 = 
STRING_LENGTH(BgL_arg2655z00_5741); 
if(
(BgL_l1z00_5743==
STRING_LENGTH(
((obj_t)BgL_artistz00_5168))))
{ /* Llib/mpd.scm 1436 */
int BgL_arg1269z00_5744;
{ /* Llib/mpd.scm 1436 */
char * BgL_auxz00_8322;char * BgL_tmpz00_8320;
BgL_auxz00_8322 = 
BSTRING_TO_STRING(
((obj_t)BgL_artistz00_5168)); 
BgL_tmpz00_8320 = 
BSTRING_TO_STRING(BgL_arg2655z00_5741); 
BgL_arg1269z00_5744 = 
memcmp(BgL_tmpz00_8320, BgL_auxz00_8322, BgL_l1z00_5743); } 
BgL_res3027z00_5742 = 
(
(long)(BgL_arg1269z00_5744)==((long)0)); }  else 
{ /* Llib/mpd.scm 1436 */
BgL_res3027z00_5742 = ((bool_t)0); } } 
BgL_test4009z00_8312 = BgL_res3027z00_5742; } } 
if(BgL_test4009z00_8312)
{ /* Llib/mpd.scm 1437 */
obj_t BgL_arg2653z00_5745;
{ /* Llib/mpd.scm 1437 */
obj_t BgL_arg2654z00_5746;
BgL_arg2654z00_5746 = 
CAR(
((obj_t)BgL_cz00_5169)); 
BgL_arg2653z00_5745 = 
MAKE_YOUNG_PAIR(BgL_arg2654z00_5746, BNIL); } 
return 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)66)), BgL_arg2653z00_5745);}  else 
{ /* Llib/mpd.scm 1436 */
return BFALSE;} } } } } 

}



/* &mpd-database-getgenr1385 */
obj_t BGl_z62mpdzd2databasezd2getgenr1385z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5170, obj_t BgL_oz00_5171, obj_t BgL_genrez00_5172)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1423 */
obj_t BgL_hook1304z00_5748;
BgL_hook1304z00_5748 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_g1305z00_5749;
BgL_g1305z00_5749 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5171)))->BgL_z52artistsz52); 
{ 
obj_t BgL_l1301z00_5751;obj_t BgL_h1302z00_5752;
BgL_l1301z00_5751 = BgL_g1305z00_5749; 
BgL_h1302z00_5752 = BgL_hook1304z00_5748; 
BgL_zc3z04anonymousza32634ze3z87_5750:
if(
NULLP(BgL_l1301z00_5751))
{ /* Llib/mpd.scm 1423 */
return 
CDR(BgL_hook1304z00_5748);}  else 
{ /* Llib/mpd.scm 1423 */
bool_t BgL_test4012z00_8339;
{ /* Llib/mpd.scm 1424 */
obj_t BgL_cz00_5753;
BgL_cz00_5753 = 
CAR(
((obj_t)BgL_l1301z00_5751)); 
{ /* Llib/mpd.scm 1424 */
obj_t BgL_dirz00_5754;
BgL_dirz00_5754 = 
CDR(
((obj_t)BgL_cz00_5753)); 
{ /* Llib/mpd.scm 1425 */
obj_t BgL_arg2642z00_5755;
BgL_arg2642z00_5755 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5754)); 
{ /* Llib/mpd.scm 1425 */
bool_t BgL_res3020z00_5756;
{ /* Llib/mpd.scm 1425 */
long BgL_l1z00_5757;
BgL_l1z00_5757 = 
STRING_LENGTH(BgL_arg2642z00_5755); 
if(
(BgL_l1z00_5757==
STRING_LENGTH(
((obj_t)BgL_genrez00_5172))))
{ /* Llib/mpd.scm 1425 */
int BgL_arg1269z00_5758;
{ /* Llib/mpd.scm 1425 */
char * BgL_auxz00_8353;char * BgL_tmpz00_8351;
BgL_auxz00_8353 = 
BSTRING_TO_STRING(
((obj_t)BgL_genrez00_5172)); 
BgL_tmpz00_8351 = 
BSTRING_TO_STRING(BgL_arg2642z00_5755); 
BgL_arg1269z00_5758 = 
memcmp(BgL_tmpz00_8351, BgL_auxz00_8353, BgL_l1z00_5757); } 
BgL_res3020z00_5756 = 
(
(long)(BgL_arg1269z00_5758)==((long)0)); }  else 
{ /* Llib/mpd.scm 1425 */
BgL_res3020z00_5756 = ((bool_t)0); } } 
BgL_test4012z00_8339 = BgL_res3020z00_5756; } } } } 
if(BgL_test4012z00_8339)
{ /* Llib/mpd.scm 1423 */
obj_t BgL_nh1303z00_5759;
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2640z00_5760;
BgL_arg2640z00_5760 = 
CAR(
((obj_t)BgL_l1301z00_5751)); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_res3021z00_5761;
BgL_res3021z00_5761 = 
MAKE_YOUNG_PAIR(BgL_arg2640z00_5760, BNIL); 
BgL_nh1303z00_5759 = BgL_res3021z00_5761; } } 
SET_CDR(BgL_h1302z00_5752, BgL_nh1303z00_5759); 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2639z00_5762;
BgL_arg2639z00_5762 = 
CDR(
((obj_t)BgL_l1301z00_5751)); 
{ 
obj_t BgL_h1302z00_8366;obj_t BgL_l1301z00_8365;
BgL_l1301z00_8365 = BgL_arg2639z00_5762; 
BgL_h1302z00_8366 = BgL_nh1303z00_5759; 
BgL_h1302z00_5752 = BgL_h1302z00_8366; 
BgL_l1301z00_5751 = BgL_l1301z00_8365; 
goto BgL_zc3z04anonymousza32634ze3z87_5750;} } }  else 
{ /* Llib/mpd.scm 1423 */
obj_t BgL_arg2641z00_5763;
BgL_arg2641z00_5763 = 
CDR(
((obj_t)BgL_l1301z00_5751)); 
{ 
obj_t BgL_l1301z00_8369;
BgL_l1301z00_8369 = BgL_arg2641z00_5763; 
BgL_l1301z00_5751 = BgL_l1301z00_8369; 
goto BgL_zc3z04anonymousza32634ze3z87_5750;} } } } } } } 

}



/* &mpd-database-getarti1383 */
obj_t BGl_z62mpdzd2databasezd2getarti1383z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5173, obj_t BgL_oz00_5174)
{
{ /* Llib/mpd.scm 1414 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5174)))->BgL_z52artistsz52);} 

}



/* &mpd-database-getgenr1381 */
obj_t BGl_z62mpdzd2databasezd2getgenr1381z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5175, obj_t BgL_oz00_5176)
{
{ /* Llib/mpd.scm 1407 */
return 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5176)))->BgL_z52genresz52);} 

}



/* &mpd-database-find-ge1379 */
obj_t BGl_z62mpdzd2databasezd2findzd2ge1379zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5177, obj_t BgL_oz00_5178, obj_t BgL_opz00_5179, obj_t BgL_genrez00_5180)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1393 */
bool_t BgL_tmpz00_8374;
{ /* Llib/mpd.scm 1402 */
obj_t BgL_g1298z00_5768;
BgL_g1298z00_5768 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5178)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1296z00_5770;
BgL_l1296z00_5770 = BgL_g1298z00_5768; 
BgL_zc3z04anonymousza32616ze3z87_5769:
if(
NULLP(BgL_l1296z00_5770))
{ /* Llib/mpd.scm 1402 */
BgL_tmpz00_8374 = ((bool_t)0)
; }  else 
{ /* Llib/mpd.scm 1402 */
bool_t BgL__ortest_1299z00_5771;
{ /* Llib/mpd.scm 1402 */
obj_t BgL_arg2619z00_5772;
BgL_arg2619z00_5772 = 
CAR(
((obj_t)BgL_l1296z00_5770)); 
BgL__ortest_1299z00_5771 = 
BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(BgL_genrez00_5180, 
((obj_t)BgL_opz00_5179), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5178), BgL_arg2619z00_5772); } 
if(BgL__ortest_1299z00_5771)
{ /* Llib/mpd.scm 1402 */
BgL_tmpz00_8374 = BgL__ortest_1299z00_5771
; }  else 
{ /* Llib/mpd.scm 1402 */
obj_t BgL_arg2618z00_5773;
BgL_arg2618z00_5773 = 
CDR(
((obj_t)BgL_l1296z00_5770)); 
{ 
obj_t BgL_l1296z00_8387;
BgL_l1296z00_8387 = BgL_arg2618z00_5773; 
BgL_l1296z00_5770 = BgL_l1296z00_8387; 
goto BgL_zc3z04anonymousza32616ze3z87_5769;} } } } } 
return 
BBOOL(BgL_tmpz00_8374);} } 

}



/* find-genre~0 */
bool_t BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(obj_t BgL_genrez00_5336, obj_t BgL_opz00_5335, BgL_mpdzd2databasezd2_bglt BgL_oz00_5334, obj_t BgL_dirz00_2277)
{
{ /* Llib/mpd.scm 1399 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_dirz00_2277)))
{ /* Llib/mpd.scm 1394 */
obj_t BgL_g1294z00_2280;
BgL_g1294z00_2280 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2277); 
{ 
obj_t BgL_l1292z00_2282;
BgL_l1292z00_2282 = BgL_g1294z00_2280; 
BgL_zc3z04anonymousza32622ze3z87_2283:
if(
NULLP(BgL_l1292z00_2282))
{ /* Llib/mpd.scm 1394 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1394 */
bool_t BgL__ortest_1295z00_2285;
{ /* Llib/mpd.scm 1394 */
obj_t BgL_arg2625z00_2287;
BgL_arg2625z00_2287 = 
CAR(
((obj_t)BgL_l1292z00_2282)); 
BgL__ortest_1295z00_2285 = 
BGl_findzd2genreze70z35zz__multimediazd2mpdzd2(BgL_genrez00_5336, BgL_opz00_5335, BgL_oz00_5334, BgL_arg2625z00_2287); } 
if(BgL__ortest_1295z00_2285)
{ /* Llib/mpd.scm 1394 */
return BgL__ortest_1295z00_2285;}  else 
{ /* Llib/mpd.scm 1394 */
obj_t BgL_arg2624z00_2286;
BgL_arg2624z00_2286 = 
CDR(
((obj_t)BgL_l1292z00_2282)); 
{ 
obj_t BgL_l1292z00_8401;
BgL_l1292z00_8401 = BgL_arg2624z00_2286; 
BgL_l1292z00_2282 = BgL_l1292z00_8401; 
goto BgL_zc3z04anonymousza32622ze3z87_2283;} } } } }  else 
{ /* Llib/mpd.scm 1395 */
bool_t BgL_test4019z00_8402;
{ /* Llib/mpd.scm 1395 */
obj_t BgL_arg2629z00_2295;
BgL_arg2629z00_2295 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_2277)); 
{ /* Llib/mpd.scm 1395 */
bool_t BgL_res3011z00_3753;
{ /* Llib/mpd.scm 1395 */
long BgL_l1z00_3740;
BgL_l1z00_3740 = 
STRING_LENGTH(BgL_arg2629z00_2295); 
if(
(BgL_l1z00_3740==
STRING_LENGTH(
((obj_t)BgL_genrez00_5336))))
{ /* Llib/mpd.scm 1395 */
int BgL_arg1269z00_3743;
{ /* Llib/mpd.scm 1395 */
char * BgL_auxz00_8412;char * BgL_tmpz00_8410;
BgL_auxz00_8412 = 
BSTRING_TO_STRING(
((obj_t)BgL_genrez00_5336)); 
BgL_tmpz00_8410 = 
BSTRING_TO_STRING(BgL_arg2629z00_2295); 
BgL_arg1269z00_3743 = 
memcmp(BgL_tmpz00_8410, BgL_auxz00_8412, BgL_l1z00_3740); } 
BgL_res3011z00_3753 = 
(
(long)(BgL_arg1269z00_3743)==((long)0)); }  else 
{ /* Llib/mpd.scm 1395 */
BgL_res3011z00_3753 = ((bool_t)0); } } 
BgL_test4019z00_8402 = BgL_res3011z00_3753; } } 
if(BgL_test4019z00_8402)
{ /* Llib/mpd.scm 1395 */
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3754;
BgL_g1186z00_3754 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_oz00_5334), BgL_dirz00_2277, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_3756;
BgL_l1184z00_3756 = BgL_g1186z00_3754; 
BgL_zc3z04anonymousza31971ze3z87_3755:
if(
PAIRP(BgL_l1184z00_3756))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3758;
BgL_kz00_3758 = 
CAR(BgL_l1184z00_3756); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_3759;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_3760;
BgL_arg1974z00_3760 = 
CAR(
((obj_t)BgL_kz00_3758)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res3013z00_3767;
BgL_res3013z00_3767 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_3760)); 
BgL_arg1973z00_3759 = BgL_res3013z00_3767; } } 
bgl_display_obj(BgL_arg1973z00_3759, BgL_opz00_5335); } 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_opz00_5335); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_3761;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3773;
BgL_pairz00_3773 = 
CDR(
((obj_t)BgL_kz00_3758)); 
BgL_arg1975z00_3761 = 
CAR(BgL_pairz00_3773); } 
bgl_display_obj(BgL_arg1975z00_3761, BgL_opz00_5335); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5335); } 
{ 
obj_t BgL_l1184z00_8434;
BgL_l1184z00_8434 = 
CDR(BgL_l1184z00_3756); 
BgL_l1184z00_3756 = BgL_l1184z00_8434; 
goto BgL_zc3z04anonymousza31971ze3z87_3755;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } 
return ((bool_t)1);}  else 
{ /* Llib/mpd.scm 1395 */
return ((bool_t)0);} } } 

}



/* &mpd-database-find-ti1377 */
obj_t BGl_z62mpdzd2databasezd2findzd2ti1377zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5181, obj_t BgL_oz00_5182, obj_t BgL_opz00_5183, obj_t BgL_titlez00_5184)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1375 */
bool_t BgL_tmpz00_8436;
{ /* Llib/mpd.scm 1384 */
obj_t BgL_g1290z00_5776;
BgL_g1290z00_5776 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5182)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1288z00_5778;
BgL_l1288z00_5778 = BgL_g1290z00_5776; 
BgL_zc3z04anonymousza32600ze3z87_5777:
if(
NULLP(BgL_l1288z00_5778))
{ /* Llib/mpd.scm 1384 */
BgL_tmpz00_8436 = ((bool_t)0)
; }  else 
{ /* Llib/mpd.scm 1384 */
bool_t BgL__ortest_1291z00_5779;
{ /* Llib/mpd.scm 1384 */
obj_t BgL_arg2603z00_5780;
BgL_arg2603z00_5780 = 
CAR(
((obj_t)BgL_l1288z00_5778)); 
BgL__ortest_1291z00_5779 = 
BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(BgL_titlez00_5184, 
((obj_t)BgL_opz00_5183), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5182), BgL_arg2603z00_5780); } 
if(BgL__ortest_1291z00_5779)
{ /* Llib/mpd.scm 1384 */
BgL_tmpz00_8436 = BgL__ortest_1291z00_5779
; }  else 
{ /* Llib/mpd.scm 1384 */
obj_t BgL_arg2602z00_5781;
BgL_arg2602z00_5781 = 
CDR(
((obj_t)BgL_l1288z00_5778)); 
{ 
obj_t BgL_l1288z00_8449;
BgL_l1288z00_8449 = BgL_arg2602z00_5781; 
BgL_l1288z00_5778 = BgL_l1288z00_8449; 
goto BgL_zc3z04anonymousza32600ze3z87_5777;} } } } } 
return 
BBOOL(BgL_tmpz00_8436);} } 

}



/* find-title~0 */
bool_t BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(obj_t BgL_titlez00_5333, obj_t BgL_opz00_5332, BgL_mpdzd2databasezd2_bglt BgL_oz00_5331, obj_t BgL_dirz00_2239)
{
{ /* Llib/mpd.scm 1381 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_dirz00_2239)))
{ /* Llib/mpd.scm 1376 */
obj_t BgL_g1286z00_2242;
BgL_g1286z00_2242 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2239); 
{ 
obj_t BgL_l1284z00_2244;
BgL_l1284z00_2244 = BgL_g1286z00_2242; 
BgL_zc3z04anonymousza32606ze3z87_2245:
if(
NULLP(BgL_l1284z00_2244))
{ /* Llib/mpd.scm 1376 */
return ((bool_t)0);}  else 
{ /* Llib/mpd.scm 1376 */
bool_t BgL__ortest_1287z00_2247;
{ /* Llib/mpd.scm 1376 */
obj_t BgL_arg2609z00_2249;
BgL_arg2609z00_2249 = 
CAR(
((obj_t)BgL_l1284z00_2244)); 
BgL__ortest_1287z00_2247 = 
BGl_findzd2titleze70z35zz__multimediazd2mpdzd2(BgL_titlez00_5333, BgL_opz00_5332, BgL_oz00_5331, BgL_arg2609z00_2249); } 
if(BgL__ortest_1287z00_2247)
{ /* Llib/mpd.scm 1376 */
return BgL__ortest_1287z00_2247;}  else 
{ /* Llib/mpd.scm 1376 */
obj_t BgL_arg2608z00_2248;
BgL_arg2608z00_2248 = 
CDR(
((obj_t)BgL_l1284z00_2244)); 
{ 
obj_t BgL_l1284z00_8463;
BgL_l1284z00_8463 = BgL_arg2608z00_2248; 
BgL_l1284z00_2244 = BgL_l1284z00_8463; 
goto BgL_zc3z04anonymousza32606ze3z87_2245;} } } } }  else 
{ /* Llib/mpd.scm 1377 */
bool_t BgL_test4027z00_8464;
{ /* Llib/mpd.scm 1377 */
obj_t BgL_arg2613z00_2257;
BgL_arg2613z00_2257 = 
BGl_prefixz00zz__osz00(
BGl_basenamez00zz__osz00(BgL_dirz00_2239)); 
{ /* Llib/mpd.scm 1377 */
bool_t BgL_res3001z00_3707;
{ /* Llib/mpd.scm 1377 */
long BgL_l1z00_3694;
BgL_l1z00_3694 = 
STRING_LENGTH(BgL_arg2613z00_2257); 
if(
(BgL_l1z00_3694==
STRING_LENGTH(
((obj_t)BgL_titlez00_5333))))
{ /* Llib/mpd.scm 1377 */
int BgL_arg1269z00_3697;
{ /* Llib/mpd.scm 1377 */
char * BgL_auxz00_8474;char * BgL_tmpz00_8472;
BgL_auxz00_8474 = 
BSTRING_TO_STRING(
((obj_t)BgL_titlez00_5333)); 
BgL_tmpz00_8472 = 
BSTRING_TO_STRING(BgL_arg2613z00_2257); 
BgL_arg1269z00_3697 = 
memcmp(BgL_tmpz00_8472, BgL_auxz00_8474, BgL_l1z00_3694); } 
BgL_res3001z00_3707 = 
(
(long)(BgL_arg1269z00_3697)==((long)0)); }  else 
{ /* Llib/mpd.scm 1377 */
BgL_res3001z00_3707 = ((bool_t)0); } } 
BgL_test4027z00_8464 = BgL_res3001z00_3707; } } 
if(BgL_test4027z00_8464)
{ /* Llib/mpd.scm 1377 */
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3708;
BgL_g1186z00_3708 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_oz00_5331), BgL_dirz00_2239, BFALSE, BFALSE, BFALSE); 
{ 
obj_t BgL_l1184z00_3710;
BgL_l1184z00_3710 = BgL_g1186z00_3708; 
BgL_zc3z04anonymousza31971ze3z87_3709:
if(
PAIRP(BgL_l1184z00_3710))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3712;
BgL_kz00_3712 = 
CAR(BgL_l1184z00_3710); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_3713;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_3714;
BgL_arg1974z00_3714 = 
CAR(
((obj_t)BgL_kz00_3712)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res3003z00_3721;
BgL_res3003z00_3721 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_3714)); 
BgL_arg1973z00_3713 = BgL_res3003z00_3721; } } 
bgl_display_obj(BgL_arg1973z00_3713, BgL_opz00_5332); } 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_opz00_5332); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_3715;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3727;
BgL_pairz00_3727 = 
CDR(
((obj_t)BgL_kz00_3712)); 
BgL_arg1975z00_3715 = 
CAR(BgL_pairz00_3727); } 
bgl_display_obj(BgL_arg1975z00_3715, BgL_opz00_5332); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5332); } 
{ 
obj_t BgL_l1184z00_8496;
BgL_l1184z00_8496 = 
CDR(BgL_l1184z00_3710); 
BgL_l1184z00_3710 = BgL_l1184z00_8496; 
goto BgL_zc3z04anonymousza31971ze3z87_3709;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } } 
return ((bool_t)1);}  else 
{ /* Llib/mpd.scm 1377 */
return ((bool_t)0);} } } 

}



/* &mpd-database-search-1375 */
obj_t BGl_z62mpdzd2databasezd2searchzd21375zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5185, obj_t BgL_oz00_5186, obj_t BgL_opz00_5187, obj_t BgL_artistz00_5188, obj_t BgL_titlez00_5189)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1349 */
bool_t BgL_tmpz00_8498;
{ 
BgL_mpdzd2databasezd2_bglt BgL_dbz00_5785;obj_t BgL_dirz00_5786;obj_t BgL_opz00_5787;
{ /* Llib/mpd.scm 1364 */
obj_t BgL_cz00_5788;
BgL_cz00_5788 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5188, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5186)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5788))
{ /* Llib/mpd.scm 1365 */
BgL_dbz00_5785 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5186); 
BgL_dirz00_5786 = 
CDR(BgL_cz00_5788); 
BgL_opz00_5787 = 
((obj_t)BgL_opz00_5187); 
BgL_tmpz00_8498 = 
BGl_loopze72ze7zz__multimediazd2mpdzd2(BgL_opz00_5787, BgL_dbz00_5785, BgL_artistz00_5188, BgL_titlez00_5189, BgL_dirz00_5786); }  else 
{ /* Llib/mpd.scm 1365 */
BgL_tmpz00_8498 = ((bool_t)0)
; } } } 
return 
BBOOL(BgL_tmpz00_8498);} } 

}



/* loop~2 */
bool_t BGl_loopze72ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5330, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5329, obj_t BgL_artistz00_5328, obj_t BgL_titlez00_5327, obj_t BgL_dirz00_2190)
{
{ /* Llib/mpd.scm 1348 */
{ /* Llib/mpd.scm 1349 */
obj_t BgL_filesz00_2192;
BgL_filesz00_2192 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2190); 
{ /* Llib/mpd.scm 1349 */
obj_t BgL_imgz00_2193;
{ 
obj_t BgL_list1281z00_2212;
BgL_list1281z00_2212 = BgL_filesz00_2192; 
BgL_zc3z04anonymousza32593ze3z87_2213:
if(
PAIRP(BgL_list1281z00_2212))
{ /* Llib/mpd.scm 1350 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1281z00_2212)))
{ /* Llib/mpd.scm 1350 */
BgL_imgz00_2193 = 
CAR(BgL_list1281z00_2212); }  else 
{ 
obj_t BgL_list1281z00_8516;
BgL_list1281z00_8516 = 
CDR(BgL_list1281z00_2212); 
BgL_list1281z00_2212 = BgL_list1281z00_8516; 
goto BgL_zc3z04anonymousza32593ze3z87_2213;} }  else 
{ /* Llib/mpd.scm 1350 */
BgL_imgz00_2193 = BFALSE; } } 
{ /* Llib/mpd.scm 1350 */

{ 
obj_t BgL_l1282z00_2195;
BgL_l1282z00_2195 = BgL_filesz00_2192; 
BgL_zc3z04anonymousza32585ze3z87_2196:
if(
PAIRP(BgL_l1282z00_2195))
{ /* Llib/mpd.scm 1351 */
{ /* Llib/mpd.scm 1352 */
obj_t BgL_fz00_2198;
BgL_fz00_2198 = 
CAR(BgL_l1282z00_2195); 
{ /* Llib/mpd.scm 1352 */
obj_t BgL_pz00_2199;
BgL_pz00_2199 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2190, BgL_fz00_2198); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2199)))
{ /* Llib/mpd.scm 1354 */
BGl_loopze72ze7zz__multimediazd2mpdzd2(BgL_opz00_5330, BgL_dbz00_5329, BgL_artistz00_5328, BgL_titlez00_5327, BgL_pz00_2199); }  else 
{ /* Llib/mpd.scm 1356 */
bool_t BgL_test4035z00_8526;
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_2199, 
((obj_t)BgL_dbz00_5329)))
{ /* Llib/mpd.scm 1356 */
obj_t BgL_arg2591z00_2208;
BgL_arg2591z00_2208 = 
BGl_prefixz00zz__osz00(BgL_fz00_2198); 
{ /* Llib/mpd.scm 1356 */
bool_t BgL_res2991z00_3661;
{ /* Llib/mpd.scm 1356 */
long BgL_l1z00_3648;
BgL_l1z00_3648 = 
STRING_LENGTH(
((obj_t)BgL_titlez00_5327)); 
if(
(BgL_l1z00_3648==
STRING_LENGTH(BgL_arg2591z00_2208)))
{ /* Llib/mpd.scm 1356 */
int BgL_arg1269z00_3651;
{ /* Llib/mpd.scm 1356 */
char * BgL_auxz00_8539;char * BgL_tmpz00_8536;
BgL_auxz00_8539 = 
BSTRING_TO_STRING(BgL_arg2591z00_2208); 
BgL_tmpz00_8536 = 
BSTRING_TO_STRING(
((obj_t)BgL_titlez00_5327)); 
BgL_arg1269z00_3651 = 
memcmp(BgL_tmpz00_8536, BgL_auxz00_8539, BgL_l1z00_3648); } 
BgL_res2991z00_3661 = 
(
(long)(BgL_arg1269z00_3651)==((long)0)); }  else 
{ /* Llib/mpd.scm 1356 */
BgL_res2991z00_3661 = ((bool_t)0); } } 
BgL_test4035z00_8526 = BgL_res2991z00_3661; } }  else 
{ /* Llib/mpd.scm 1356 */
BgL_test4035z00_8526 = ((bool_t)0)
; } 
if(BgL_test4035z00_8526)
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3662;
BgL_g1186z00_3662 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5329), BgL_pz00_2199, BgL_artistz00_5328, BgL_titlez00_5327, BgL_imgz00_2193); 
{ 
obj_t BgL_l1184z00_3664;
BgL_l1184z00_3664 = BgL_g1186z00_3662; 
BgL_zc3z04anonymousza31971ze3z87_3663:
if(
PAIRP(BgL_l1184z00_3664))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3666;
BgL_kz00_3666 = 
CAR(BgL_l1184z00_3664); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_3667;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_3668;
BgL_arg1974z00_3668 = 
CAR(
((obj_t)BgL_kz00_3666)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2993z00_3675;
BgL_res2993z00_3675 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_3668)); 
BgL_arg1973z00_3667 = BgL_res2993z00_3675; } } 
bgl_display_obj(BgL_arg1973z00_3667, BgL_opz00_5330); } 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_opz00_5330); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_3669;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3681;
BgL_pairz00_3681 = 
CDR(
((obj_t)BgL_kz00_3666)); 
BgL_arg1975z00_3669 = 
CAR(BgL_pairz00_3681); } 
bgl_display_obj(BgL_arg1975z00_3669, BgL_opz00_5330); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5330); } 
{ 
obj_t BgL_l1184z00_8560;
BgL_l1184z00_8560 = 
CDR(BgL_l1184z00_3664); 
BgL_l1184z00_3664 = BgL_l1184z00_8560; 
goto BgL_zc3z04anonymousza31971ze3z87_3663;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1356 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1282z00_8562;
BgL_l1282z00_8562 = 
CDR(BgL_l1282z00_2195); 
BgL_l1282z00_2195 = BgL_l1282z00_8562; 
goto BgL_zc3z04anonymousza32585ze3z87_2196;} }  else 
{ /* Llib/mpd.scm 1351 */
return ((bool_t)1);} } } } } } 

}



/* &mpd-database-search-1373 */
obj_t BGl_z62mpdzd2databasezd2searchzd21373zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5190, obj_t BgL_oz00_5191, obj_t BgL_opz00_5192, obj_t BgL_artistz00_5193, obj_t BgL_albumz00_5194)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1315 */
bool_t BgL_tmpz00_8564;
{ 
BgL_mpdzd2databasezd2_bglt BgL_dbz00_5792;obj_t BgL_dirz00_5793;obj_t BgL_opz00_5794;
{ /* Llib/mpd.scm 1338 */
obj_t BgL_cz00_5795;
BgL_cz00_5795 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5193, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5191)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5795))
{ /* Llib/mpd.scm 1339 */
BgL_dbz00_5792 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5191); 
BgL_dirz00_5793 = 
CDR(BgL_cz00_5795); 
BgL_opz00_5794 = 
((obj_t)BgL_opz00_5192); 
BgL_tmpz00_8564 = 
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5794, BgL_dbz00_5792, BgL_artistz00_5193, BgL_albumz00_5194, BgL_dirz00_5793); }  else 
{ /* Llib/mpd.scm 1339 */
BgL_tmpz00_8564 = ((bool_t)0)
; } } } 
return 
BBOOL(BgL_tmpz00_8564);} } 

}



/* loop~1 */
bool_t BGl_loopze71ze7zz__multimediazd2mpdzd2(obj_t BgL_opz00_5326, BgL_mpdzd2databasezd2_bglt BgL_dbz00_5325, obj_t BgL_artistz00_5324, obj_t BgL_albumz00_5323, obj_t BgL_dirz00_2119)
{
{ /* Llib/mpd.scm 1314 */
{ /* Llib/mpd.scm 1315 */
bool_t BgL_test4040z00_8575;
{ /* Llib/mpd.scm 1315 */
obj_t BgL_arg2578z00_2169;
BgL_arg2578z00_2169 = 
BGl_basenamez00zz__osz00(BgL_dirz00_2119); 
{ /* Llib/mpd.scm 1315 */
bool_t BgL_res2973z00_3590;
{ /* Llib/mpd.scm 1315 */
long BgL_l1z00_3577;
BgL_l1z00_3577 = 
STRING_LENGTH(BgL_arg2578z00_2169); 
if(
(BgL_l1z00_3577==
STRING_LENGTH(
((obj_t)BgL_albumz00_5323))))
{ /* Llib/mpd.scm 1315 */
int BgL_arg1269z00_3580;
{ /* Llib/mpd.scm 1315 */
char * BgL_auxz00_8584;char * BgL_tmpz00_8582;
BgL_auxz00_8584 = 
BSTRING_TO_STRING(
((obj_t)BgL_albumz00_5323)); 
BgL_tmpz00_8582 = 
BSTRING_TO_STRING(BgL_arg2578z00_2169); 
BgL_arg1269z00_3580 = 
memcmp(BgL_tmpz00_8582, BgL_auxz00_8584, BgL_l1z00_3577); } 
BgL_res2973z00_3590 = 
(
(long)(BgL_arg1269z00_3580)==((long)0)); }  else 
{ /* Llib/mpd.scm 1315 */
BgL_res2973z00_3590 = ((bool_t)0); } } 
BgL_test4040z00_8575 = BgL_res2973z00_3590; } } 
if(BgL_test4040z00_8575)
{ /* Llib/mpd.scm 1316 */
obj_t BgL_filesz00_2123;
BgL_filesz00_2123 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_proc3517z00zz__multimediazd2mpdzd2, 
bgl_directory_to_list(
BSTRING_TO_STRING(BgL_dirz00_2119))); 
{ /* Llib/mpd.scm 1316 */
obj_t BgL_imgz00_2124;
{ /* Llib/mpd.scm 1319 */
obj_t BgL_fz00_2138;
{ 
obj_t BgL_list1274z00_2141;
BgL_list1274z00_2141 = BgL_filesz00_2123; 
BgL_zc3z04anonymousza32564ze3z87_2142:
if(
PAIRP(BgL_list1274z00_2141))
{ /* Llib/mpd.scm 1319 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1274z00_2141)))
{ /* Llib/mpd.scm 1319 */
BgL_fz00_2138 = 
CAR(BgL_list1274z00_2141); }  else 
{ 
obj_t BgL_list1274z00_8599;
BgL_list1274z00_8599 = 
CDR(BgL_list1274z00_2141); 
BgL_list1274z00_2141 = BgL_list1274z00_8599; 
goto BgL_zc3z04anonymousza32564ze3z87_2142;} }  else 
{ /* Llib/mpd.scm 1319 */
BgL_fz00_2138 = BFALSE; } } 
if(
STRINGP(BgL_fz00_2138))
{ /* Llib/mpd.scm 1320 */
BgL_imgz00_2124 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2119, BgL_fz00_2138); }  else 
{ /* Llib/mpd.scm 1320 */
BgL_imgz00_2124 = BFALSE; } } 
{ /* Llib/mpd.scm 1319 */

{ 
obj_t BgL_l1275z00_2126;
BgL_l1275z00_2126 = BgL_filesz00_2123; 
BgL_zc3z04anonymousza32558ze3z87_2127:
if(
PAIRP(BgL_l1275z00_2126))
{ /* Llib/mpd.scm 1322 */
{ /* Llib/mpd.scm 1323 */
obj_t BgL_fz00_2129;
BgL_fz00_2129 = 
CAR(BgL_l1275z00_2126); 
{ /* Llib/mpd.scm 1323 */
obj_t BgL_pz00_2130;
BgL_pz00_2130 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_dirz00_2119, BgL_fz00_2129); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2130)))
{ /* Llib/mpd.scm 1325 */
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5326, BgL_dbz00_5325, BgL_artistz00_5324, BgL_albumz00_5323, BgL_pz00_2130); }  else 
{ /* Llib/mpd.scm 1325 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_pz00_2130, 
((obj_t)BgL_dbz00_5325)))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_3608;
BgL_g1186z00_3608 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)BgL_dbz00_5325), BgL_pz00_2130, BgL_artistz00_5324, BgL_albumz00_5323, BgL_imgz00_2124); 
{ 
obj_t BgL_l1184z00_3610;
BgL_l1184z00_3610 = BgL_g1186z00_3608; 
BgL_zc3z04anonymousza31971ze3z87_3609:
if(
PAIRP(BgL_l1184z00_3610))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_3612;
BgL_kz00_3612 = 
CAR(BgL_l1184z00_3610); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_3613;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_3614;
BgL_arg1974z00_3614 = 
CAR(
((obj_t)BgL_kz00_3612)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2980z00_3621;
BgL_res2980z00_3621 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_3614)); 
BgL_arg1973z00_3613 = BgL_res2980z00_3621; } } 
bgl_display_obj(BgL_arg1973z00_3613, BgL_opz00_5326); } 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_opz00_5326); 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_3615;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_3627;
BgL_pairz00_3627 = 
CDR(
((obj_t)BgL_kz00_3612)); 
BgL_arg1975z00_3615 = 
CAR(BgL_pairz00_3627); } 
bgl_display_obj(BgL_arg1975z00_3615, BgL_opz00_5326); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5326); } 
{ 
obj_t BgL_l1184z00_8631;
BgL_l1184z00_8631 = 
CDR(BgL_l1184z00_3610); 
BgL_l1184z00_3610 = BgL_l1184z00_8631; 
goto BgL_zc3z04anonymousza31971ze3z87_3609;} }  else 
{ /* Llib/mpd.scm 427 */((bool_t)1); } } }  else 
{ /* Llib/mpd.scm 1327 */((bool_t)0); } } } } 
{ 
obj_t BgL_l1275z00_8633;
BgL_l1275z00_8633 = 
CDR(BgL_l1275z00_2126); 
BgL_l1275z00_2126 = BgL_l1275z00_8633; 
goto BgL_zc3z04anonymousza32558ze3z87_2127;} }  else 
{ /* Llib/mpd.scm 1322 */
return ((bool_t)1);} } } } }  else 
{ /* Llib/mpd.scm 1333 */
obj_t BgL_g1279z00_2160;
BgL_g1279z00_2160 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_2119); 
{ 
obj_t BgL_l1277z00_2162;
BgL_l1277z00_2162 = BgL_g1279z00_2160; 
BgL_zc3z04anonymousza32574ze3z87_2163:
if(
PAIRP(BgL_l1277z00_2162))
{ /* Llib/mpd.scm 1336 */
{ /* Llib/mpd.scm 1334 */
obj_t BgL_pz00_2165;
BgL_pz00_2165 = 
CAR(BgL_l1277z00_2162); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_2165)))
{ /* Llib/mpd.scm 1334 */
BGl_loopze71ze7zz__multimediazd2mpdzd2(BgL_opz00_5326, BgL_dbz00_5325, BgL_artistz00_5324, BgL_albumz00_5323, BgL_pz00_2165); }  else 
{ /* Llib/mpd.scm 1334 */((bool_t)0); } } 
{ 
obj_t BgL_l1277z00_8643;
BgL_l1277z00_8643 = 
CDR(BgL_l1277z00_2162); 
BgL_l1277z00_2162 = BgL_l1277z00_8643; 
goto BgL_zc3z04anonymousza32574ze3z87_2163;} }  else 
{ /* Llib/mpd.scm 1336 */
return ((bool_t)1);} } } } } 

}



/* &<@anonymous:2572> */
obj_t BGl_z62zc3z04anonymousza32572ze3ze5zz__multimediazd2mpdzd2(obj_t BgL_envz00_5195, obj_t BgL_s1z00_5196, obj_t BgL_s2z00_5197)
{
{ /* Llib/mpd.scm 1316 */
{ /* Llib/mpd.scm 1317 */
bool_t BgL_tmpz00_8645;
{ /* Llib/mpd.scm 1317 */
int BgL_arg2573z00_5796;
{ /* Llib/mpd.scm 1317 */

BgL_arg2573z00_5796 = 
BGl_stringzd2naturalzd2compare3z00zz__r4_strings_6_7z00(BgL_s1z00_5196, BgL_s2z00_5197, 
BINT(((long)0)), 
BINT(((long)0))); } 
BgL_tmpz00_8645 = 
(
(long)(BgL_arg2573z00_5796)<((long)0)); } 
return 
BBOOL(BgL_tmpz00_8645);} } 

}



/* &mpd-database-find-ar1371 */
obj_t BGl_z62mpdzd2databasezd2findzd2ar1371zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5198, obj_t BgL_oz00_5199, obj_t BgL_opz00_5200, obj_t BgL_artistz00_5201)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1304 */
bool_t BgL_tmpz00_8652;
{ /* Llib/mpd.scm 1305 */
obj_t BgL_cz00_5802;
BgL_cz00_5802 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_artistz00_5201, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5199)))->BgL_z52artistsz52)); 
if(
PAIRP(BgL_cz00_5802))
{ /* Llib/mpd.scm 1307 */
obj_t BgL_dirz00_5804;
BgL_dirz00_5804 = 
CDR(BgL_cz00_5802); 
BgL_tmpz00_8652 = 
BGl_loopze74ze7zz__multimediazd2mpdzd2(
((obj_t)BgL_opz00_5200), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5199), BFALSE, BgL_artistz00_5201, BgL_dirz00_5804); }  else 
{ /* Llib/mpd.scm 1306 */
BgL_tmpz00_8652 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_tmpz00_8652);} } 

}



/* &mpd-database-find-al1369 */
obj_t BGl_z62mpdzd2databasezd2findzd2al1369zb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5202, obj_t BgL_oz00_5203, obj_t BgL_opz00_5204, obj_t BgL_albumz00_5205)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1295 */
bool_t BgL_tmpz00_8663;
{ /* Llib/mpd.scm 1296 */
obj_t BgL_cz00_5811;
BgL_cz00_5811 = 
BGl_assocz00zz__r4_pairs_and_lists_6_3z00(BgL_albumz00_5205, 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5203)))->BgL_z52albumsz52)); 
if(
PAIRP(BgL_cz00_5811))
{ /* Llib/mpd.scm 1298 */
obj_t BgL_dirz00_5813;
BgL_dirz00_5813 = 
CDR(BgL_cz00_5811); 
BgL_tmpz00_8663 = 
BGl_loopze74ze7zz__multimediazd2mpdzd2(
((obj_t)BgL_opz00_5204), 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5203), BgL_albumz00_5205, BFALSE, BgL_dirz00_5813); }  else 
{ /* Llib/mpd.scm 1297 */
BgL_tmpz00_8663 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_tmpz00_8663);} } 

}



/* &mpd-database-lsinfo1367 */
obj_t BGl_z62mpdzd2databasezd2lsinfo1367z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5206, obj_t BgL_oz00_5207, obj_t BgL_opz00_5208, obj_t BgL_dirz00_5209, obj_t BgL_recz00_5210)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1234 */
bool_t BgL_tmpz00_8674;
{ /* Llib/mpd.scm 1234 */
bool_t BgL_recz00_5818;
BgL_recz00_5818 = 
CBOOL(BgL_recz00_5210); 
{ /* Llib/mpd.scm 1235 */
bool_t BgL_test4053z00_8676;
if(
BGl_filezd2systemzd2rootzf3zf3zz__multimediazd2mpdzd2(
((obj_t)BgL_dirz00_5209)))
{ /* Llib/mpd.scm 1235 */
BgL_test4053z00_8676 = ((bool_t)1)
; }  else 
{ /* Llib/mpd.scm 1235 */
obj_t BgL_arg2541z00_5819;
BgL_arg2541z00_5819 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207)))->BgL_z52basez52); 
{ /* Llib/mpd.scm 1235 */
bool_t BgL_res2957z00_5820;
{ /* Llib/mpd.scm 1235 */
long BgL_l1z00_5821;
BgL_l1z00_5821 = 
STRING_LENGTH(
((obj_t)BgL_dirz00_5209)); 
if(
(BgL_l1z00_5821==
STRING_LENGTH(BgL_arg2541z00_5819)))
{ /* Llib/mpd.scm 1235 */
int BgL_arg1269z00_5822;
{ /* Llib/mpd.scm 1235 */
char * BgL_auxz00_8690;char * BgL_tmpz00_8687;
BgL_auxz00_8690 = 
BSTRING_TO_STRING(BgL_arg2541z00_5819); 
BgL_tmpz00_8687 = 
BSTRING_TO_STRING(
((obj_t)BgL_dirz00_5209)); 
BgL_arg1269z00_5822 = 
memcmp(BgL_tmpz00_8687, BgL_auxz00_8690, BgL_l1z00_5821); } 
BgL_res2957z00_5820 = 
(
(long)(BgL_arg1269z00_5822)==((long)0)); }  else 
{ /* Llib/mpd.scm 1235 */
BgL_res2957z00_5820 = ((bool_t)0); } } 
BgL_test4053z00_8676 = BgL_res2957z00_5820; } } 
if(BgL_test4053z00_8676)
{ /* Llib/mpd.scm 1236 */
obj_t BgL_g1264z00_5823;
BgL_g1264z00_5823 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1262z00_5825;
BgL_l1262z00_5825 = BgL_g1264z00_5823; 
BgL_zc3z04anonymousza32522ze3z87_5824:
if(
PAIRP(BgL_l1262z00_5825))
{ /* Llib/mpd.scm 1236 */
{ /* Llib/mpd.scm 1237 */
obj_t BgL_dirz00_5826;
BgL_dirz00_5826 = 
CAR(BgL_l1262z00_5825); 
{ /* Llib/mpd.scm 1237 */
obj_t BgL_g1261z00_5827;
BgL_g1261z00_5827 = 
BGl_directoryzd2ze3pathzd2listze3zz__r4_ports_6_10_1z00(BgL_dirz00_5826); 
{ 
obj_t BgL_l1258z00_5829;
BgL_l1258z00_5829 = BgL_g1261z00_5827; 
BgL_zc3z04anonymousza32524ze3z87_5828:
if(
PAIRP(BgL_l1258z00_5829))
{ /* Llib/mpd.scm 1244 */
{ /* Llib/mpd.scm 1238 */
obj_t BgL_dirz00_5830;
BgL_dirz00_5830 = 
CAR(BgL_l1258z00_5829); 
{ /* Llib/mpd.scm 1238 */
obj_t BgL_mdz00_5831;
BgL_mdz00_5831 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_dirz00_5830, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207))); 
{ /* Llib/mpd.scm 1239 */
obj_t BgL_tmpz00_8707;
BgL_tmpz00_8707 = 
((obj_t)BgL_opz00_5208); 
bgl_display_string(BGl_string3518z00zz__multimediazd2mpdzd2, BgL_tmpz00_8707); } 
bgl_display_obj(BgL_mdz00_5831, 
((obj_t)BgL_opz00_5208)); 
{ /* Llib/mpd.scm 1241 */
obj_t BgL_tmpz00_8712;
BgL_tmpz00_8712 = 
((obj_t)BgL_opz00_5208); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8712); } 
if(BgL_recz00_5818)
{ /* Llib/mpd.scm 1242 */
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207), 
((obj_t)BgL_opz00_5208), BgL_mdz00_5831, BgL_recz00_5818); }  else 
{ /* Llib/mpd.scm 1242 */BFALSE; } } } 
{ 
obj_t BgL_l1258z00_8719;
BgL_l1258z00_8719 = 
CDR(BgL_l1258z00_5829); 
BgL_l1258z00_5829 = BgL_l1258z00_8719; 
goto BgL_zc3z04anonymousza32524ze3z87_5828;} }  else 
{ /* Llib/mpd.scm 1244 */((bool_t)1); } } } } 
{ 
obj_t BgL_l1262z00_8721;
BgL_l1262z00_8721 = 
CDR(BgL_l1262z00_5825); 
BgL_l1262z00_5825 = BgL_l1262z00_8721; 
goto BgL_zc3z04anonymousza32522ze3z87_5824;} }  else 
{ /* Llib/mpd.scm 1236 */
BgL_tmpz00_8674 = ((bool_t)1)
; } } }  else 
{ /* Llib/mpd.scm 1246 */
obj_t BgL_pathz00_5832;
BgL_pathz00_5832 = 
BGl_mpdzd2ze3filez31zz__multimediazd2mpdzd2(
((obj_t)BgL_dirz00_5209), 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207)), 
((obj_t)BgL_opz00_5208), BGl_string3519z00zz__multimediazd2mpdzd2); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_5832)))
{ /* Llib/mpd.scm 1248 */
obj_t BgL_filesz00_5833;
BgL_filesz00_5833 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_5832); 
{ /* Llib/mpd.scm 1248 */
obj_t BgL_imgz00_5834;
{ /* Llib/mpd.scm 1249 */
obj_t BgL_fz00_5835;
{ 
obj_t BgL_list1266z00_5837;
BgL_list1266z00_5837 = BgL_filesz00_5833; 
BgL_zc3z04anonymousza32535ze3z87_5836:
if(
PAIRP(BgL_list1266z00_5837))
{ /* Llib/mpd.scm 1249 */
if(
BGl_imagezd2filezf3z21zz__multimediazd2mpdzd2(
CAR(BgL_list1266z00_5837)))
{ /* Llib/mpd.scm 1249 */
BgL_fz00_5835 = 
CAR(BgL_list1266z00_5837); }  else 
{ 
obj_t BgL_list1266z00_8738;
BgL_list1266z00_8738 = 
CDR(BgL_list1266z00_5837); 
BgL_list1266z00_5837 = BgL_list1266z00_8738; 
goto BgL_zc3z04anonymousza32535ze3z87_5836;} }  else 
{ /* Llib/mpd.scm 1249 */
BgL_fz00_5835 = BFALSE; } } 
if(
STRINGP(BgL_fz00_5835))
{ /* Llib/mpd.scm 1250 */
BgL_imgz00_5834 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5832, BgL_fz00_5835); }  else 
{ /* Llib/mpd.scm 1250 */
BgL_imgz00_5834 = BFALSE; } } 
{ /* Llib/mpd.scm 1249 */

{ 
obj_t BgL_l1267z00_5839;
BgL_l1267z00_5839 = BgL_filesz00_5833; 
BgL_zc3z04anonymousza32529ze3z87_5838:
if(
PAIRP(BgL_l1267z00_5839))
{ /* Llib/mpd.scm 1252 */
{ /* Llib/mpd.scm 1253 */
obj_t BgL_fz00_5840;
BgL_fz00_5840 = 
CAR(BgL_l1267z00_5839); 
{ /* Llib/mpd.scm 1253 */
obj_t BgL_pz00_5841;
BgL_pz00_5841 = 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_5832, BgL_fz00_5840); 
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pz00_5841)))
{ /* Llib/mpd.scm 1256 */
obj_t BgL_mdz00_5842;
BgL_mdz00_5842 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pz00_5841, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207))); 
{ /* Llib/mpd.scm 1257 */
obj_t BgL_tmpz00_8753;
BgL_tmpz00_8753 = 
((obj_t)BgL_opz00_5208); 
bgl_display_string(BGl_string3518z00zz__multimediazd2mpdzd2, BgL_tmpz00_8753); } 
bgl_display_obj(BgL_mdz00_5842, 
((obj_t)BgL_opz00_5208)); 
{ /* Llib/mpd.scm 1259 */
obj_t BgL_tmpz00_8758;
BgL_tmpz00_8758 = 
((obj_t)BgL_opz00_5208); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8758); } 
if(BgL_recz00_5818)
{ /* Llib/mpd.scm 1260 */
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207), 
((obj_t)BgL_opz00_5208), BgL_mdz00_5842, BgL_recz00_5818); }  else 
{ /* Llib/mpd.scm 1260 */BFALSE; } }  else 
{ /* Llib/mpd.scm 1255 */
if(
BGl_musiczd2filezf3z21zz__multimediazd2mpdzd2(BgL_fz00_5840, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207))))
{ /* Llib/mpd.scm 422 */
obj_t BgL_g1186z00_5843;
BgL_g1186z00_5843 = 
BGl_getinfofilez00zz__multimediazd2mpdzd2(
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5207)), BgL_pz00_5841, BFALSE, BFALSE, BgL_imgz00_5834); 
{ 
obj_t BgL_l1184z00_5845;
{ /* Llib/mpd.scm 427 */
bool_t BgL_tmpz00_8772;
BgL_l1184z00_5845 = BgL_g1186z00_5843; 
BgL_zc3z04anonymousza31971ze3z87_5844:
if(
PAIRP(BgL_l1184z00_5845))
{ /* Llib/mpd.scm 427 */
{ /* Llib/mpd.scm 423 */
obj_t BgL_kz00_5846;
BgL_kz00_5846 = 
CAR(BgL_l1184z00_5845); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1973z00_5847;
{ /* Llib/mpd.scm 423 */
obj_t BgL_arg1974z00_5848;
BgL_arg1974z00_5848 = 
CAR(
((obj_t)BgL_kz00_5846)); 
{ /* Llib/mpd.scm 423 */
obj_t BgL_res2966z00_5849;
BgL_res2966z00_5849 = 
KEYWORD_TO_STRING(
((obj_t)BgL_arg1974z00_5848)); 
BgL_arg1973z00_5847 = BgL_res2966z00_5849; } } 
bgl_display_obj(BgL_arg1973z00_5847, 
((obj_t)BgL_opz00_5208)); } 
{ /* Llib/mpd.scm 424 */
obj_t BgL_tmpz00_8782;
BgL_tmpz00_8782 = 
((obj_t)BgL_opz00_5208); 
bgl_display_string(BGl_string3401z00zz__multimediazd2mpdzd2, BgL_tmpz00_8782); } 
{ /* Llib/mpd.scm 425 */
obj_t BgL_arg1975z00_5850;
{ /* Llib/mpd.scm 425 */
obj_t BgL_pairz00_5851;
BgL_pairz00_5851 = 
CDR(
((obj_t)BgL_kz00_5846)); 
BgL_arg1975z00_5850 = 
CAR(BgL_pairz00_5851); } 
bgl_display_obj(BgL_arg1975z00_5850, 
((obj_t)BgL_opz00_5208)); } 
{ /* Llib/mpd.scm 426 */
obj_t BgL_tmpz00_8790;
BgL_tmpz00_8790 = 
((obj_t)BgL_opz00_5208); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8790); } } 
{ 
obj_t BgL_l1184z00_8793;
BgL_l1184z00_8793 = 
CDR(BgL_l1184z00_5845); 
BgL_l1184z00_5845 = BgL_l1184z00_8793; 
goto BgL_zc3z04anonymousza31971ze3z87_5844;} }  else 
{ /* Llib/mpd.scm 427 */
BgL_tmpz00_8772 = ((bool_t)1)
; } 
BBOOL(BgL_tmpz00_8772); } } }  else 
{ /* Llib/mpd.scm 1262 */BFALSE; } } } } 
{ 
obj_t BgL_l1267z00_8796;
BgL_l1267z00_8796 = 
CDR(BgL_l1267z00_5839); 
BgL_l1267z00_5839 = BgL_l1267z00_8796; 
goto BgL_zc3z04anonymousza32529ze3z87_5838;} }  else 
{ /* Llib/mpd.scm 1252 */
BgL_tmpz00_8674 = ((bool_t)1)
; } } } } }  else 
{ /* Llib/mpd.scm 1247 */
BgL_tmpz00_8674 = ((bool_t)0)
; } } } } 
return 
BBOOL(BgL_tmpz00_8674);} } 

}



/* &mpd-database-listart1365 */
obj_t BGl_z62mpdzd2databasezd2listart1365z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5211, obj_t BgL_oz00_5212, obj_t BgL_opz00_5213)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1224 */
bool_t BgL_tmpz00_8799;
{ /* Llib/mpd.scm 1224 */
obj_t BgL_g1257z00_5854;
BgL_g1257z00_5854 = 
BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5212)); 
{ 
obj_t BgL_l1255z00_5856;
BgL_l1255z00_5856 = BgL_g1257z00_5854; 
BgL_zc3z04anonymousza32514ze3z87_5855:
if(
PAIRP(BgL_l1255z00_5856))
{ /* Llib/mpd.scm 1228 */
{ /* Llib/mpd.scm 1225 */
obj_t BgL_az00_5857;
BgL_az00_5857 = 
CAR(BgL_l1255z00_5856); 
{ /* Llib/mpd.scm 1225 */
obj_t BgL_tmpz00_8805;
BgL_tmpz00_8805 = 
((obj_t)BgL_opz00_5213); 
bgl_display_string(BGl_string3409z00zz__multimediazd2mpdzd2, BgL_tmpz00_8805); } 
{ /* Llib/mpd.scm 1226 */
obj_t BgL_arg2516z00_5858;
BgL_arg2516z00_5858 = 
CAR(
((obj_t)BgL_az00_5857)); 
bgl_display_obj(BgL_arg2516z00_5858, 
((obj_t)BgL_opz00_5213)); } 
{ /* Llib/mpd.scm 1227 */
obj_t BgL_tmpz00_8812;
BgL_tmpz00_8812 = 
((obj_t)BgL_opz00_5213); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8812); } } 
{ 
obj_t BgL_l1255z00_8815;
BgL_l1255z00_8815 = 
CDR(BgL_l1255z00_5856); 
BgL_l1255z00_5856 = BgL_l1255z00_8815; 
goto BgL_zc3z04anonymousza32514ze3z87_5855;} }  else 
{ /* Llib/mpd.scm 1228 */
BgL_tmpz00_8799 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8799);} } 

}



/* &mpd-database-listgen1363 */
obj_t BGl_z62mpdzd2databasezd2listgen1363z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5214, obj_t BgL_oz00_5215, obj_t BgL_opz00_5216)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1214 */
bool_t BgL_tmpz00_8818;
{ /* Llib/mpd.scm 1214 */
obj_t BgL_g1254z00_5861;
BgL_g1254z00_5861 = 
BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5215)); 
{ 
obj_t BgL_l1252z00_5863;
BgL_l1252z00_5863 = BgL_g1254z00_5861; 
BgL_zc3z04anonymousza32509ze3z87_5862:
if(
PAIRP(BgL_l1252z00_5863))
{ /* Llib/mpd.scm 1218 */
{ /* Llib/mpd.scm 1215 */
obj_t BgL_az00_5864;
BgL_az00_5864 = 
CAR(BgL_l1252z00_5863); 
{ /* Llib/mpd.scm 1215 */
obj_t BgL_tmpz00_8824;
BgL_tmpz00_8824 = 
((obj_t)BgL_opz00_5216); 
bgl_display_string(BGl_string3520z00zz__multimediazd2mpdzd2, BgL_tmpz00_8824); } 
{ /* Llib/mpd.scm 1216 */
obj_t BgL_arg2511z00_5865;
BgL_arg2511z00_5865 = 
CAR(
((obj_t)BgL_az00_5864)); 
bgl_display_obj(BgL_arg2511z00_5865, 
((obj_t)BgL_opz00_5216)); } 
{ /* Llib/mpd.scm 1217 */
obj_t BgL_tmpz00_8831;
BgL_tmpz00_8831 = 
((obj_t)BgL_opz00_5216); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8831); } } 
{ 
obj_t BgL_l1252z00_8834;
BgL_l1252z00_8834 = 
CDR(BgL_l1252z00_5863); 
BgL_l1252z00_5863 = BgL_l1252z00_8834; 
goto BgL_zc3z04anonymousza32509ze3z87_5862;} }  else 
{ /* Llib/mpd.scm 1218 */
BgL_tmpz00_8818 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8818);} } 

}



/* &mpd-database-listgen1361 */
obj_t BGl_z62mpdzd2databasezd2listgen1361z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5217, obj_t BgL_oz00_5218, obj_t BgL_opz00_5219, obj_t BgL_genrez00_5220)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1204 */
bool_t BgL_tmpz00_8837;
{ /* Llib/mpd.scm 1204 */
obj_t BgL_g1251z00_5868;
BgL_g1251z00_5868 = 
BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5218), BgL_genrez00_5220); 
{ 
obj_t BgL_l1249z00_5870;
BgL_l1249z00_5870 = BgL_g1251z00_5868; 
BgL_zc3z04anonymousza32504ze3z87_5869:
if(
PAIRP(BgL_l1249z00_5870))
{ /* Llib/mpd.scm 1208 */
{ /* Llib/mpd.scm 1205 */
obj_t BgL_az00_5871;
BgL_az00_5871 = 
CAR(BgL_l1249z00_5870); 
{ /* Llib/mpd.scm 1205 */
obj_t BgL_tmpz00_8843;
BgL_tmpz00_8843 = 
((obj_t)BgL_opz00_5219); 
bgl_display_string(BGl_string3409z00zz__multimediazd2mpdzd2, BgL_tmpz00_8843); } 
{ /* Llib/mpd.scm 1206 */
obj_t BgL_arg2506z00_5872;
BgL_arg2506z00_5872 = 
CAR(
((obj_t)BgL_az00_5871)); 
bgl_display_obj(BgL_arg2506z00_5872, 
((obj_t)BgL_opz00_5219)); } 
{ /* Llib/mpd.scm 1207 */
obj_t BgL_tmpz00_8850;
BgL_tmpz00_8850 = 
((obj_t)BgL_opz00_5219); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8850); } } 
{ 
obj_t BgL_l1249z00_8853;
BgL_l1249z00_8853 = 
CDR(BgL_l1249z00_5870); 
BgL_l1249z00_5870 = BgL_l1249z00_8853; 
goto BgL_zc3z04anonymousza32504ze3z87_5869;} }  else 
{ /* Llib/mpd.scm 1208 */
BgL_tmpz00_8837 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8837);} } 

}



/* &mpd-database-listgen1359 */
obj_t BGl_z62mpdzd2databasezd2listgen1359z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5221, obj_t BgL_oz00_5222, obj_t BgL_opz00_5223, obj_t BgL_genrez00_5224)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1190 */
bool_t BgL_tmpz00_8856;
{ /* Llib/mpd.scm 1190 */
obj_t BgL_g1248z00_5875;
{ /* Llib/mpd.scm 1194 */
obj_t BgL_hook1244z00_5876;
BgL_hook1244z00_5876 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_g1245z00_5877;
BgL_g1245z00_5877 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5222)))->BgL_z52albumsz52); 
{ 
obj_t BgL_l1241z00_5879;obj_t BgL_h1242z00_5880;
BgL_l1241z00_5879 = BgL_g1245z00_5877; 
BgL_h1242z00_5880 = BgL_hook1244z00_5876; 
BgL_zc3z04anonymousza32491ze3z87_5878:
if(
NULLP(BgL_l1241z00_5879))
{ /* Llib/mpd.scm 1197 */
BgL_g1248z00_5875 = 
CDR(BgL_hook1244z00_5876); }  else 
{ /* Llib/mpd.scm 1197 */
bool_t BgL_test4072z00_8863;
{ /* Llib/mpd.scm 1195 */
obj_t BgL_cz00_5881;
BgL_cz00_5881 = 
CAR(
((obj_t)BgL_l1241z00_5879)); 
{ /* Llib/mpd.scm 1195 */
obj_t BgL_dirz00_5882;
BgL_dirz00_5882 = 
CDR(
((obj_t)BgL_cz00_5881)); 
{ /* Llib/mpd.scm 1196 */
obj_t BgL_arg2500z00_5883;
BgL_arg2500z00_5883 = 
BGl_basenamez00zz__osz00(
BGl_dirnamez00zz__osz00(
BGl_dirnamez00zz__osz00(BgL_dirz00_5882))); 
{ /* Llib/mpd.scm 1196 */
bool_t BgL_res2947z00_5884;
{ /* Llib/mpd.scm 1196 */
long BgL_l1z00_5885;
BgL_l1z00_5885 = 
STRING_LENGTH(BgL_arg2500z00_5883); 
if(
(BgL_l1z00_5885==
STRING_LENGTH(
((obj_t)BgL_genrez00_5224))))
{ /* Llib/mpd.scm 1196 */
int BgL_arg1269z00_5886;
{ /* Llib/mpd.scm 1196 */
char * BgL_auxz00_8878;char * BgL_tmpz00_8876;
BgL_auxz00_8878 = 
BSTRING_TO_STRING(
((obj_t)BgL_genrez00_5224)); 
BgL_tmpz00_8876 = 
BSTRING_TO_STRING(BgL_arg2500z00_5883); 
BgL_arg1269z00_5886 = 
memcmp(BgL_tmpz00_8876, BgL_auxz00_8878, BgL_l1z00_5885); } 
BgL_res2947z00_5884 = 
(
(long)(BgL_arg1269z00_5886)==((long)0)); }  else 
{ /* Llib/mpd.scm 1196 */
BgL_res2947z00_5884 = ((bool_t)0); } } 
BgL_test4072z00_8863 = BgL_res2947z00_5884; } } } } 
if(BgL_test4072z00_8863)
{ /* Llib/mpd.scm 1197 */
obj_t BgL_nh1243z00_5887;
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2498z00_5888;
BgL_arg2498z00_5888 = 
CAR(
((obj_t)BgL_l1241z00_5879)); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_res2948z00_5889;
BgL_res2948z00_5889 = 
MAKE_YOUNG_PAIR(BgL_arg2498z00_5888, BNIL); 
BgL_nh1243z00_5887 = BgL_res2948z00_5889; } } 
SET_CDR(BgL_h1242z00_5880, BgL_nh1243z00_5887); 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2497z00_5890;
BgL_arg2497z00_5890 = 
CDR(
((obj_t)BgL_l1241z00_5879)); 
{ 
obj_t BgL_h1242z00_8891;obj_t BgL_l1241z00_8890;
BgL_l1241z00_8890 = BgL_arg2497z00_5890; 
BgL_h1242z00_8891 = BgL_nh1243z00_5887; 
BgL_h1242z00_5880 = BgL_h1242z00_8891; 
BgL_l1241z00_5879 = BgL_l1241z00_8890; 
goto BgL_zc3z04anonymousza32491ze3z87_5878;} } }  else 
{ /* Llib/mpd.scm 1197 */
obj_t BgL_arg2499z00_5891;
BgL_arg2499z00_5891 = 
CDR(
((obj_t)BgL_l1241z00_5879)); 
{ 
obj_t BgL_l1241z00_8894;
BgL_l1241z00_8894 = BgL_arg2499z00_5891; 
BgL_l1241z00_5879 = BgL_l1241z00_8894; 
goto BgL_zc3z04anonymousza32491ze3z87_5878;} } } } } } 
{ 
obj_t BgL_l1246z00_5893;
BgL_l1246z00_5893 = BgL_g1248z00_5875; 
BgL_zc3z04anonymousza32487ze3z87_5892:
if(
PAIRP(BgL_l1246z00_5893))
{ /* Llib/mpd.scm 1194 */
{ /* Llib/mpd.scm 1191 */
obj_t BgL_az00_5894;
BgL_az00_5894 = 
CAR(BgL_l1246z00_5893); 
{ /* Llib/mpd.scm 1191 */
obj_t BgL_tmpz00_8898;
BgL_tmpz00_8898 = 
((obj_t)BgL_opz00_5223); 
bgl_display_string(BGl_string3411z00zz__multimediazd2mpdzd2, BgL_tmpz00_8898); } 
{ /* Llib/mpd.scm 1192 */
obj_t BgL_arg2489z00_5895;
BgL_arg2489z00_5895 = 
CAR(
((obj_t)BgL_az00_5894)); 
bgl_display_obj(BgL_arg2489z00_5895, 
((obj_t)BgL_opz00_5223)); } 
{ /* Llib/mpd.scm 1193 */
obj_t BgL_tmpz00_8905;
BgL_tmpz00_8905 = 
((obj_t)BgL_opz00_5223); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8905); } } 
{ 
obj_t BgL_l1246z00_8908;
BgL_l1246z00_8908 = 
CDR(BgL_l1246z00_5893); 
BgL_l1246z00_5893 = BgL_l1246z00_8908; 
goto BgL_zc3z04anonymousza32487ze3z87_5892;} }  else 
{ /* Llib/mpd.scm 1194 */
BgL_tmpz00_8856 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8856);} } 

}



/* &mpd-database-listart1357 */
obj_t BGl_z62mpdzd2databasezd2listart1357z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5225, obj_t BgL_oz00_5226, obj_t BgL_opz00_5227, obj_t BgL_artistz00_5228)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1180 */
bool_t BgL_tmpz00_8911;
{ /* Llib/mpd.scm 1180 */
obj_t BgL_g1239z00_5898;
BgL_g1239z00_5898 = 
BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5226), BgL_artistz00_5228); 
{ 
obj_t BgL_l1237z00_5900;
BgL_l1237z00_5900 = BgL_g1239z00_5898; 
BgL_zc3z04anonymousza32482ze3z87_5899:
if(
PAIRP(BgL_l1237z00_5900))
{ /* Llib/mpd.scm 1184 */
{ /* Llib/mpd.scm 1181 */
obj_t BgL_az00_5901;
BgL_az00_5901 = 
CAR(BgL_l1237z00_5900); 
{ /* Llib/mpd.scm 1181 */
obj_t BgL_tmpz00_8917;
BgL_tmpz00_8917 = 
((obj_t)BgL_opz00_5227); 
bgl_display_string(BGl_string3411z00zz__multimediazd2mpdzd2, BgL_tmpz00_8917); } 
{ /* Llib/mpd.scm 1182 */
obj_t BgL_arg2484z00_5902;
{ /* Llib/mpd.scm 1182 */
obj_t BgL_pairz00_5903;
BgL_pairz00_5903 = 
CDR(
((obj_t)BgL_az00_5901)); 
BgL_arg2484z00_5902 = 
CAR(BgL_pairz00_5903); } 
bgl_display_obj(BgL_arg2484z00_5902, 
((obj_t)BgL_opz00_5227)); } 
{ /* Llib/mpd.scm 1183 */
obj_t BgL_tmpz00_8925;
BgL_tmpz00_8925 = 
((obj_t)BgL_opz00_5227); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8925); } } 
{ 
obj_t BgL_l1237z00_8928;
BgL_l1237z00_8928 = 
CDR(BgL_l1237z00_5900); 
BgL_l1237z00_5900 = BgL_l1237z00_8928; 
goto BgL_zc3z04anonymousza32482ze3z87_5899;} }  else 
{ /* Llib/mpd.scm 1184 */
BgL_tmpz00_8911 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8911);} } 

}



/* &mpd-database-listalb1355 */
obj_t BGl_z62mpdzd2databasezd2listalb1355z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5229, obj_t BgL_oz00_5230, obj_t BgL_opz00_5231)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1169 */
bool_t BgL_tmpz00_8931;
{ /* Llib/mpd.scm 1169 */
obj_t BgL_g1236z00_5906;
BgL_g1236z00_5906 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5230)))->BgL_z52albumsz52); 
{ 
obj_t BgL_l1234z00_5908;
BgL_l1234z00_5908 = BgL_g1236z00_5906; 
BgL_zc3z04anonymousza32477ze3z87_5907:
if(
PAIRP(BgL_l1234z00_5908))
{ /* Llib/mpd.scm 1173 */
{ /* Llib/mpd.scm 1170 */
obj_t BgL_az00_5909;
BgL_az00_5909 = 
CAR(BgL_l1234z00_5908); 
{ /* Llib/mpd.scm 1170 */
obj_t BgL_tmpz00_8937;
BgL_tmpz00_8937 = 
((obj_t)BgL_opz00_5231); 
bgl_display_string(BGl_string3411z00zz__multimediazd2mpdzd2, BgL_tmpz00_8937); } 
{ /* Llib/mpd.scm 1171 */
obj_t BgL_arg2479z00_5910;
BgL_arg2479z00_5910 = 
CAR(
((obj_t)BgL_az00_5909)); 
bgl_display_obj(BgL_arg2479z00_5910, 
((obj_t)BgL_opz00_5231)); } 
{ /* Llib/mpd.scm 1172 */
obj_t BgL_tmpz00_8944;
BgL_tmpz00_8944 = 
((obj_t)BgL_opz00_5231); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8944); } } 
{ 
obj_t BgL_l1234z00_8947;
BgL_l1234z00_8947 = 
CDR(BgL_l1234z00_5908); 
BgL_l1234z00_5908 = BgL_l1234z00_8947; 
goto BgL_zc3z04anonymousza32477ze3z87_5907;} }  else 
{ /* Llib/mpd.scm 1173 */
BgL_tmpz00_8931 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8931);} } 

}



/* &mpd-database-listall1353 */
obj_t BGl_z62mpdzd2databasezd2listall1353z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5232, obj_t BgL_oz00_5233, obj_t BgL_opz00_5234)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1146 */
bool_t BgL_tmpz00_8950;
{ /* Llib/mpd.scm 1160 */
obj_t BgL_tmpz00_8951;
BgL_tmpz00_8951 = 
((obj_t)BgL_opz00_5234); 
bgl_display_string(BGl_string3518z00zz__multimediazd2mpdzd2, BgL_tmpz00_8951); } 
bgl_display_obj(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5233)))->BgL_z52basez52), 
((obj_t)BgL_opz00_5234)); 
{ /* Llib/mpd.scm 1162 */
obj_t BgL_tmpz00_8958;
BgL_tmpz00_8958 = 
((obj_t)BgL_opz00_5234); 
bgl_display_char(((unsigned char)10), BgL_tmpz00_8958); } 
{ /* Llib/mpd.scm 1163 */
obj_t BgL_g1233z00_5916;
BgL_g1233z00_5916 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5233)))->BgL_directoriesz00); 
{ 
obj_t BgL_l1231z00_5918;
BgL_l1231z00_5918 = BgL_g1233z00_5916; 
BgL_zc3z04anonymousza32463ze3z87_5917:
if(
PAIRP(BgL_l1231z00_5918))
{ /* Llib/mpd.scm 1163 */
{ /* Llib/mpd.scm 1163 */
obj_t BgL_pathz00_5921;
BgL_pathz00_5921 = 
CAR(BgL_l1231z00_5918); 
BGl_loopze70ze7zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5233), 
((obj_t)BgL_opz00_5234), BgL_pathz00_5921); } 
{ 
obj_t BgL_l1231z00_8969;
BgL_l1231z00_8969 = 
CDR(BgL_l1231z00_5918); 
BgL_l1231z00_5918 = BgL_l1231z00_8969; 
goto BgL_zc3z04anonymousza32463ze3z87_5917;} }  else 
{ /* Llib/mpd.scm 1163 */
BgL_tmpz00_8950 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_8950);} } 

}



/* loop~0 */
obj_t BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_5320, obj_t BgL_opz00_5319, obj_t BgL_pathz00_1892)
{
{ /* Llib/mpd.scm 1145 */
if(
bgl_directoryp(
BSTRING_TO_STRING(BgL_pathz00_1892)))
{ /* Llib/mpd.scm 1146 */
bgl_display_string(BGl_string3518z00zz__multimediazd2mpdzd2, BgL_opz00_5319); 
{ /* Llib/mpd.scm 1149 */
obj_t BgL_arg2470z00_1895;
BgL_arg2470z00_1895 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pathz00_1892, 
((obj_t)BgL_oz00_5320)); 
bgl_display_obj(BgL_arg2470z00_1895, BgL_opz00_5319); } 
bgl_display_char(((unsigned char)10), BgL_opz00_5319); 
{ /* Llib/mpd.scm 1151 */
obj_t BgL_g1230z00_1896;
BgL_g1230z00_1896 = 
BGl_directoryzd2ze3sortzd2listze3zz__multimediazd2mpdzd2(BgL_pathz00_1892); 
{ 
obj_t BgL_l1228z00_1898;
{ /* Llib/mpd.scm 1153 */
bool_t BgL_tmpz00_8981;
BgL_l1228z00_1898 = BgL_g1230z00_1896; 
BgL_zc3z04anonymousza32471ze3z87_1899:
if(
PAIRP(BgL_l1228z00_1898))
{ /* Llib/mpd.scm 1153 */
{ /* Llib/mpd.scm 1152 */
obj_t BgL_fz00_1901;
BgL_fz00_1901 = 
CAR(BgL_l1228z00_1898); 
BGl_loopze70ze7zz__multimediazd2mpdzd2(BgL_oz00_5320, BgL_opz00_5319, 
BGl_makezd2filezd2namez00zz__osz00(BgL_pathz00_1892, BgL_fz00_1901)); } 
{ 
obj_t BgL_l1228z00_8987;
BgL_l1228z00_8987 = 
CDR(BgL_l1228z00_1898); 
BgL_l1228z00_1898 = BgL_l1228z00_8987; 
goto BgL_zc3z04anonymousza32471ze3z87_1899;} }  else 
{ /* Llib/mpd.scm 1153 */
BgL_tmpz00_8981 = ((bool_t)1)
; } 
return 
BBOOL(BgL_tmpz00_8981);} } } }  else 
{ /* Llib/mpd.scm 1146 */
bgl_display_string(BGl_string3406z00zz__multimediazd2mpdzd2, BgL_opz00_5319); 
{ /* Llib/mpd.scm 1156 */
obj_t BgL_arg2475z00_1905;
BgL_arg2475z00_1905 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_pathz00_1892, 
((obj_t)BgL_oz00_5320)); 
bgl_display_obj(BgL_arg2475z00_1905, BgL_opz00_5319); } 
return 
bgl_display_char(((unsigned char)10), BgL_opz00_5319);} } 

}



/* &mpd-database-stats1351 */
obj_t BGl_z62mpdzd2databasezd2stats1351z62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5235, obj_t BgL_oz00_5236, obj_t BgL_backendz00_5237, obj_t BgL_opz00_5238)
{
{ /* Llib/mpd.scm 1108 */
{ 

{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2436z00_5929;int BgL_arg2437z00_5930;int BgL_arg2438z00_5931;long BgL_arg2439z00_5932;obj_t BgL_arg2440z00_5933;long BgL_arg2441z00_5934;
BgL_arg2436z00_5929 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5236)))->BgL_z52nartistsz52); 
BgL_arg2437z00_5930 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5236)))->BgL_z52nalbumsz52); 
BgL_arg2438z00_5931 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5236)))->BgL_z52nsongsz52); 
{ /* Llib/mpd.scm 1135 */
long BgL_arg2448z00_5935;
{ /* Llib/mpd.scm 1135 */
long BgL_arg2449z00_5936;obj_t BgL_arg2450z00_5937;
BgL_arg2449z00_5936 = 
bgl_current_seconds(); 
BgL_arg2450z00_5937 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5236)))->BgL_z52uptimez52); 
{ /* Llib/mpd.scm 1135 */
long BgL_res2932z00_5938;
{ /* Llib/mpd.scm 1135 */
long BgL_za72za7_5939;
BgL_za72za7_5939 = 
BELONG_TO_LONG(BgL_arg2450z00_5937); 
{ /* Llib/mpd.scm 1135 */
long BgL_tmpz00_9005;
BgL_tmpz00_9005 = 
(BgL_arg2449z00_5936-BgL_za72za7_5939); 
BgL_res2932z00_5938 = 
(long)(BgL_tmpz00_9005); } } 
BgL_arg2448z00_5935 = BgL_res2932z00_5938; } } 
{ /* Llib/mpd.scm 1135 */
long BgL_res2933z00_5940;
BgL_res2933z00_5940 = 
(long)(BgL_arg2448z00_5935); 
BgL_arg2439z00_5932 = BgL_res2933z00_5940; } } 
{ /* Llib/mpd.scm 1111 */
obj_t BgL_plistz00_5924;int BgL_numz00_5925;
BgL_plistz00_5924 = 
BGl_musiczd2playlistzd2getz00zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5237)); 
BgL_numz00_5925 = 
BGl_musiczd2songzd2zz__multimediazd2musiczd2(
((BgL_musicz00_bglt)BgL_backendz00_5237)); 
{ /* Llib/mpd.scm 1113 */
bool_t BgL_test4080z00_9013;
if(
(
(long)(BgL_numz00_5925)>=((long)0)))
{ /* Llib/mpd.scm 1113 */
BgL_test4080z00_9013 = 
(
(long)(BgL_numz00_5925)<
bgl_list_length(BgL_plistz00_5924))
; }  else 
{ /* Llib/mpd.scm 1113 */
BgL_test4080z00_9013 = ((bool_t)0)
; } 
if(BgL_test4080z00_9013)
{ /* Llib/mpd.scm 1114 */
obj_t BgL_filez00_5926;
BgL_filez00_5926 = 
bgl_list_ref(BgL_plistz00_5924, 
(long)(BgL_numz00_5925)); 
{ /* Llib/mpd.scm 1114 */
obj_t BgL_pathz00_5927;
if(
bigloo_strcmp_at(BgL_filez00_5926, BGl_string3403z00zz__multimediazd2mpdzd2, ((long)0)))
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_5927 = BgL_filez00_5926; }  else 
{ /* Llib/mpd.scm 1021 */
BgL_pathz00_5927 = 
BGl_filezd2ze3mpdz31zz__multimediazd2mpdzd2(BgL_filez00_5926, 
((obj_t)
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5236))); } 
{ /* Llib/mpd.scm 1115 */

if(
fexists(
BSTRING_TO_STRING(BgL_filez00_5926)))
{ /* Llib/mpd.scm 1117 */
obj_t BgL_infoz00_5928;
BgL_infoz00_5928 = 
BGl_filezd2musicinfozd2zz__multimediazd2id3zd2(BgL_filez00_5926); 
if(
BGl_isazf3zf3zz__objectz00(BgL_infoz00_5928, BGl_musicinfoz00zz__multimediazd2id3zd2))
{ /* Llib/mpd.scm 1118 */
BgL_arg2440z00_5933 = 
BINT(
(((BgL_musicinfoz00_bglt)COBJECT(
((BgL_musicinfoz00_bglt)BgL_infoz00_5928)))->BgL_durationz00)); }  else 
{ /* Llib/mpd.scm 1118 */
BgL_arg2440z00_5933 = 
BINT(((long)1000000)); } }  else 
{ /* Llib/mpd.scm 1116 */
BgL_arg2440z00_5933 = 
BINT(((long)1000000)); } } } }  else 
{ /* Llib/mpd.scm 1113 */
BgL_arg2440z00_5933 = BFALSE; } } } 
{ /* Llib/mpd.scm 1137 */
long BgL_arg2451z00_5941;
{ /* Llib/mpd.scm 1137 */
long BgL_arg2452z00_5942;obj_t BgL_arg2453z00_5943;
BgL_arg2452z00_5942 = 
bgl_current_seconds(); 
BgL_arg2453z00_5943 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5236)))->BgL_z52dbzd2updatez80); 
{ /* Llib/mpd.scm 1137 */
long BgL_res2935z00_5944;
{ /* Llib/mpd.scm 1137 */
long BgL_za72za7_5945;
BgL_za72za7_5945 = 
BELONG_TO_LONG(BgL_arg2453z00_5943); 
{ /* Llib/mpd.scm 1137 */
long BgL_tmpz00_9042;
BgL_tmpz00_9042 = 
(BgL_arg2452z00_5942-BgL_za72za7_5945); 
BgL_res2935z00_5944 = 
(long)(BgL_tmpz00_9042); } } 
BgL_arg2451z00_5941 = BgL_res2935z00_5944; } } 
{ /* Llib/mpd.scm 1137 */
long BgL_res2936z00_5946;
BgL_res2936z00_5946 = 
(long)(BgL_arg2451z00_5941); 
BgL_arg2441z00_5934 = BgL_res2936z00_5946; } } 
{ /* Llib/mpd.scm 1125 */
obj_t BgL_list2442z00_5947;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2443z00_5948;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2444z00_5949;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2445z00_5950;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2446z00_5951;
{ /* Llib/mpd.scm 1125 */
obj_t BgL_arg2447z00_5952;
BgL_arg2447z00_5952 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2441z00_5934), BNIL); 
BgL_arg2446z00_5951 = 
MAKE_YOUNG_PAIR(BgL_arg2440z00_5933, BgL_arg2447z00_5952); } 
BgL_arg2445z00_5950 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2439z00_5932), BgL_arg2446z00_5951); } 
BgL_arg2444z00_5949 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2438z00_5931), BgL_arg2445z00_5950); } 
BgL_arg2443z00_5948 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2437z00_5930), BgL_arg2444z00_5949); } 
BgL_list2442z00_5947 = 
MAKE_YOUNG_PAIR(BgL_arg2436z00_5929, BgL_arg2443z00_5948); } 
return 
BGl_fprintfz00zz__r4_output_6_10_3z00(BgL_opz00_5238, BGl_string3521z00zz__multimediazd2mpdzd2, BgL_list2442z00_5947);} } } } 

}



/* &mpd-database-file->p1349 */
obj_t BGl_z62mpdzd2databasezd2filezd2ze3p1349z53zz__multimediazd2mpdzd2(obj_t BgL_envz00_5239, obj_t BgL_oz00_5240, obj_t BgL_filez00_5241)
{
{ /* Llib/mpd.scm 1095 */
if(
NULLP(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5240)))->BgL_directoriesz00)))
{ /* Llib/mpd.scm 1097 */
return 
((obj_t)BgL_filez00_5241);}  else 
{ /* Llib/mpd.scm 1099 */
obj_t BgL_dirz00_5955;
{ /* Llib/mpd.scm 1099 */
obj_t BgL_arg2433z00_5956;
BgL_arg2433z00_5956 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
((obj_t)BgL_filez00_5241)); 
BgL_dirz00_5955 = 
CAR(
((obj_t)BgL_arg2433z00_5956)); } 
{ /* Llib/mpd.scm 1099 */
obj_t BgL_nz00_5957;
{ /* Llib/mpd.scm 1100 */
obj_t BgL_arg2431z00_5958;
BgL_arg2431z00_5958 = 
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5240)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 1100 */

BgL_nz00_5957 = 
BGl_stringzd2containszd2zz__r4_strings_6_7z00(BgL_arg2431z00_5958, BgL_dirz00_5955, 
(int)(((long)0))); } } 
{ /* Llib/mpd.scm 1100 */

if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_nz00_5957))
{ /* Llib/mpd.scm 1102 */
obj_t BgL_arg2428z00_5959;
{ /* Llib/mpd.scm 1102 */
obj_t BgL_arg2429z00_5960;
BgL_arg2429z00_5960 = 
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5240)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 1102 */
obj_t BgL_res2927z00_5961;
{ /* Llib/mpd.scm 1102 */
long BgL_endz00_5962;
BgL_endz00_5962 = 
(long)CINT(BgL_nz00_5957); 
BgL_res2927z00_5961 = 
c_substring(
((obj_t)BgL_arg2429z00_5960), ((long)0), BgL_endz00_5962); } 
BgL_arg2428z00_5959 = BgL_res2927z00_5961; } } 
return 
string_append(BgL_arg2428z00_5959, 
((obj_t)BgL_filez00_5241));}  else 
{ /* Llib/mpd.scm 1101 */
return 
((obj_t)BgL_filez00_5241);} } } } } 

}



/* &mpd-database-init!1347 */
obj_t BGl_z62mpdzd2databasezd2initz121347z70zz__multimediazd2mpdzd2(obj_t BgL_envz00_5242, obj_t BgL_oz00_5243)
{
{ /* Llib/mpd.scm 956 */
{ 
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9082;
if(
NULLP(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_directoriesz00)))
{ /* Llib/mpd.scm 962 */BFALSE; }  else 
{ /* Llib/mpd.scm 962 */
if(
NULLP(
CDR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_directoriesz00))))
{ 
obj_t BgL_auxz00_9092;
{ /* Llib/mpd.scm 964 */
obj_t BgL_pairz00_5966;
BgL_pairz00_5966 = 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_directoriesz00); 
BgL_auxz00_9092 = 
CAR(BgL_pairz00_5966); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52basez52)=((obj_t)BgL_auxz00_9092),BUNSPEC); }  else 
{ /* Llib/mpd.scm 965 */
obj_t BgL_g1139z00_5967;obj_t BgL_g1140z00_5968;
BgL_g1139z00_5967 = 
CDR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_directoriesz00)); 
BgL_g1140z00_5968 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_directoriesz00))); 
{ 
obj_t BgL_dirsz00_5970;obj_t BgL_lz00_5971;
BgL_dirsz00_5970 = BgL_g1139z00_5967; 
BgL_lz00_5971 = BgL_g1140z00_5968; 
BgL_loopz00_5969:
if(
NULLP(BgL_dirsz00_5970))
{ 
obj_t BgL_auxz00_9107;
{ /* Llib/mpd.scm 968 */
obj_t BgL_runner2405z00_5972;
BgL_runner2405z00_5972 = BgL_lz00_5971; 
{ /* Llib/mpd.scm 968 */
obj_t BgL_aux2403z00_5973;
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5974;
BgL_pairz00_5974 = BgL_runner2405z00_5972; 
BgL_aux2403z00_5973 = 
CAR(BgL_pairz00_5974); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5975;
BgL_pairz00_5975 = BgL_runner2405z00_5972; 
BgL_runner2405z00_5972 = 
CDR(BgL_pairz00_5975); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_aux2404z00_5976;
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5977;
BgL_pairz00_5977 = BgL_runner2405z00_5972; 
BgL_aux2404z00_5976 = 
CAR(BgL_pairz00_5977); } 
{ /* Llib/mpd.scm 968 */
obj_t BgL_pairz00_5978;
BgL_pairz00_5978 = BgL_runner2405z00_5972; 
BgL_runner2405z00_5972 = 
CDR(BgL_pairz00_5978); } 
BgL_auxz00_9107 = 
BGl_makezd2filezd2pathz00zz__osz00(BgL_aux2403z00_5973, BgL_aux2404z00_5976, BgL_runner2405z00_5972); } } } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52basez52)=((obj_t)BgL_auxz00_9107),BUNSPEC); }  else 
{ /* Llib/mpd.scm 969 */
obj_t BgL_nlz00_5979;
BgL_nlz00_5979 = 
BGl_filezd2namezd2ze3listze3zz__osz00(
BGl_dirnamez00zz__osz00(
CAR(
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_directoriesz00)))); 
{ /* Llib/mpd.scm 970 */
obj_t BgL_arg2406z00_5980;obj_t BgL_arg2407z00_5981;
BgL_arg2406z00_5980 = 
CDR(
((obj_t)BgL_dirsz00_5970)); 
BgL_arg2407z00_5981 = 
BGl_loopze75ze7zz__multimediazd2mpdzd2(BgL_lz00_5971, BgL_nlz00_5979); 
{ 
obj_t BgL_lz00_9124;obj_t BgL_dirsz00_9123;
BgL_dirsz00_9123 = BgL_arg2406z00_5980; 
BgL_lz00_9124 = BgL_arg2407z00_5981; 
BgL_lz00_5971 = BgL_lz00_9124; 
BgL_dirsz00_5970 = BgL_dirsz00_9123; 
goto BgL_loopz00_5969;} } } } } } 
{ 
obj_t BgL_auxz00_9125;
{ /* Llib/mpd.scm 972 */
long BgL_arg2417z00_5984;long BgL_arg2418z00_5985;
{ /* Llib/mpd.scm 972 */
long BgL_res2922z00_5986;
BgL_res2922z00_5986 = 
bgl_current_seconds(); 
BgL_arg2417z00_5984 = BgL_res2922z00_5986; } 
{ /* Llib/mpd.scm 972 */
obj_t BgL_arg2419z00_5987;
BgL_arg2419z00_5987 = 
BGl_makezd2datezd2zz__datez00(
BINT(((long)1)), 
BINT(((long)-1)), 
BINT(((long)0)), 
BINT(((long)0)), 
BINT(((long)1)), BGl_llong3522z00zz__multimediazd2mpdzd2, 
BINT(((long)0)), BFALSE, 
BINT(((long)1970))); 
{ /* Llib/mpd.scm 972 */
long BgL_res2923z00_5988;
BgL_res2923z00_5988 = 
bgl_date_to_seconds(
((obj_t)BgL_arg2419z00_5987)); 
BgL_arg2418z00_5985 = BgL_res2923z00_5988; } } 
BgL_auxz00_9125 = 
BGl_2zd2zd2zz__r4_numbers_6_5z00(
make_belong(BgL_arg2417z00_5984), 
make_belong(BgL_arg2418z00_5985)); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52dbzd2updatez80)=((obj_t)BgL_auxz00_9125),BUNSPEC); } 
{ 
obj_t BgL_auxz00_9142;
{ /* Llib/mpd.scm 973 */
long BgL_arg2420z00_5989;long BgL_arg2421z00_5990;
{ /* Llib/mpd.scm 973 */
long BgL_res2924z00_5991;
BgL_res2924z00_5991 = 
bgl_current_seconds(); 
BgL_arg2420z00_5989 = BgL_res2924z00_5991; } 
{ /* Llib/mpd.scm 973 */
obj_t BgL_arg2422z00_5992;
BgL_arg2422z00_5992 = 
BGl_makezd2datezd2zz__datez00(
BINT(((long)1)), 
BINT(((long)-1)), 
BINT(((long)0)), 
BINT(((long)0)), 
BINT(((long)1)), BGl_llong3522z00zz__multimediazd2mpdzd2, 
BINT(((long)0)), BFALSE, 
BINT(((long)1970))); 
{ /* Llib/mpd.scm 973 */
long BgL_res2925z00_5993;
BgL_res2925z00_5993 = 
bgl_date_to_seconds(
((obj_t)BgL_arg2422z00_5992)); 
BgL_arg2421z00_5990 = BgL_res2925z00_5993; } } 
BgL_auxz00_9142 = 
BGl_2zd2zd2zz__r4_numbers_6_5z00(
make_belong(BgL_arg2420z00_5989), 
make_belong(BgL_arg2421z00_5990)); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52uptimez52)=((obj_t)BgL_auxz00_9142),BUNSPEC); } 
{ /* Llib/mpd.scm 975 */
obj_t BgL_artistsz00_5994;
BgL_artistsz00_5994 = 
BGl_mpdzd2databasezd2directorieszd2scanzd2zz__multimediazd2mpdzd2(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243), 
(((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_directoriesz00)); 
{ /* Llib/mpd.scm 976 */
obj_t BgL_albumsz00_5995;obj_t BgL_genresz00_5996;obj_t BgL_nsongz00_5997;
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_9163;
BgL_tmpz00_9163 = 
(int)(((long)1)); 
BgL_albumsz00_5995 = 
BGL_MVALUES_VAL(BgL_tmpz00_9163); } 
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_9166;
BgL_tmpz00_9166 = 
(int)(((long)2)); 
BgL_genresz00_5996 = 
BGL_MVALUES_VAL(BgL_tmpz00_9166); } 
{ /* Llib/mpd.scm 977 */
int BgL_tmpz00_9169;
BgL_tmpz00_9169 = 
(int)(((long)3)); 
BgL_nsongz00_5997 = 
BGL_MVALUES_VAL(BgL_tmpz00_9169); } 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52artistsz52)=((obj_t)BgL_artistsz00_5994),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52nartistsz52)=((obj_t)
BINT(
bgl_list_length(BgL_artistsz00_5994))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52albumsz52)=((obj_t)BgL_albumsz00_5995),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52genresz52)=((obj_t)BgL_genresz00_5996),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52nalbumsz52)=((int)
(int)(
bgl_list_length(BgL_albumsz00_5995))),BUNSPEC); 
((((BgL_mpdzd2databasezd2_bglt)COBJECT(
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243)))->BgL_z52nsongsz52)=((int)
CINT(BgL_nsongz00_5997)),BUNSPEC); } } 
BgL_auxz00_9082 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5243); 
return 
((obj_t)BgL_auxz00_9082);} } 

}



/* mpd-database-init! */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_331)
{
{ /* Llib/mpd.scm 956 */
{ /* Llib/mpd.scm 956 */
obj_t BgL_method1348z00_2382;
{ /* Llib/mpd.scm 956 */
obj_t BgL_res3043z00_3872;
{ /* Llib/mpd.scm 956 */
long BgL_objzd2classzd2numz00_3837;
{ /* Llib/mpd.scm 956 */
long BgL_res3033z00_3840;
BgL_res3033z00_3840 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_331)); 
BgL_objzd2classzd2numz00_3837 = BgL_res3033z00_3840; } 
{ /* Llib/mpd.scm 956 */
obj_t BgL_arg1759z00_3838;
BgL_arg1759z00_3838 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2initz12zd2envzc0zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 956 */
int BgL_offsetz00_3842;
BgL_offsetz00_3842 = 
(int)(BgL_objzd2classzd2numz00_3837); 
{ /* Llib/mpd.scm 956 */
long BgL_offsetz00_3843;
BgL_offsetz00_3843 = 
(
(long)(BgL_offsetz00_3842)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 956 */
long BgL_modz00_3844;
BgL_modz00_3844 = 
(BgL_offsetz00_3843 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 956 */
long BgL_restz00_3846;
BgL_restz00_3846 = 
(BgL_offsetz00_3843 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 956 */

{ /* Llib/mpd.scm 956 */
obj_t BgL_bucketz00_3848;
BgL_bucketz00_3848 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_3838),BgL_modz00_3844); 
BgL_res3043z00_3872 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3848),BgL_restz00_3846); } } } } } } } } 
BgL_method1348z00_2382 = BgL_res3043z00_3872; } 
return 
PROCEDURE_ENTRY(BgL_method1348z00_2382)(BgL_method1348z00_2382, 
((obj_t)BgL_oz00_331), BEOA);} } 

}



/* &mpd-database-init! */
obj_t BGl_z62mpdzd2databasezd2initz12z70zz__multimediazd2mpdzd2(obj_t BgL_envz00_5135, obj_t BgL_oz00_5136)
{
{ /* Llib/mpd.scm 956 */
{ /* Llib/mpd.scm 956 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9221;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5136, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 956 */
BgL_auxz00_9221 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5136)
; }  else 
{ 
obj_t BgL_auxz00_9225;
BgL_auxz00_9225 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)37998)), BGl_string3523z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5136); 
FAILURE(BgL_auxz00_9225,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2initz12z12zz__multimediazd2mpdzd2(BgL_auxz00_9221);} } 

}



/* mpd-database-file->path */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_349, obj_t BgL_filez00_350)
{
{ /* Llib/mpd.scm 1095 */
{ /* Llib/mpd.scm 1095 */
obj_t BgL_method1350z00_2383;
{ /* Llib/mpd.scm 1095 */
obj_t BgL_res3054z00_3909;
{ /* Llib/mpd.scm 1095 */
long BgL_objzd2classzd2numz00_3874;
{ /* Llib/mpd.scm 1095 */
long BgL_res3044z00_3877;
BgL_res3044z00_3877 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_349)); 
BgL_objzd2classzd2numz00_3874 = BgL_res3044z00_3877; } 
{ /* Llib/mpd.scm 1095 */
obj_t BgL_arg1759z00_3875;
BgL_arg1759z00_3875 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2filezd2ze3pathzd2envze3zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1095 */
int BgL_offsetz00_3879;
BgL_offsetz00_3879 = 
(int)(BgL_objzd2classzd2numz00_3874); 
{ /* Llib/mpd.scm 1095 */
long BgL_offsetz00_3880;
BgL_offsetz00_3880 = 
(
(long)(BgL_offsetz00_3879)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1095 */
long BgL_modz00_3881;
BgL_modz00_3881 = 
(BgL_offsetz00_3880 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1095 */
long BgL_restz00_3883;
BgL_restz00_3883 = 
(BgL_offsetz00_3880 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1095 */

{ /* Llib/mpd.scm 1095 */
obj_t BgL_bucketz00_3885;
BgL_bucketz00_3885 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_3875),BgL_modz00_3881); 
BgL_res3054z00_3909 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3885),BgL_restz00_3883); } } } } } } } } 
BgL_method1350z00_2383 = BgL_res3054z00_3909; } 
return 
PROCEDURE_ENTRY(BgL_method1350z00_2383)(BgL_method1350z00_2383, 
((obj_t)BgL_oz00_349), BgL_filez00_350, BEOA);} } 

}



/* &mpd-database-file->path */
obj_t BGl_z62mpdzd2databasezd2filezd2ze3pathz53zz__multimediazd2mpdzd2(obj_t BgL_envz00_5244, obj_t BgL_oz00_5245, obj_t BgL_filez00_5246)
{
{ /* Llib/mpd.scm 1095 */
{ /* Llib/mpd.scm 1095 */
obj_t BgL_auxz00_9269;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9261;
if(
STRINGP(BgL_filez00_5246))
{ /* Llib/mpd.scm 1095 */
BgL_auxz00_9269 = BgL_filez00_5246
; }  else 
{ 
obj_t BgL_auxz00_9272;
BgL_auxz00_9272 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)43641)), BGl_string3524z00zz__multimediazd2mpdzd2, BGl_string3525z00zz__multimediazd2mpdzd2, BgL_filez00_5246); 
FAILURE(BgL_auxz00_9272,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5245, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1095 */
BgL_auxz00_9261 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5245)
; }  else 
{ 
obj_t BgL_auxz00_9265;
BgL_auxz00_9265 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)43641)), BGl_string3524z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5245); 
FAILURE(BgL_auxz00_9265,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2filezd2ze3pathz31zz__multimediazd2mpdzd2(BgL_auxz00_9261, BgL_auxz00_9269);} } 

}



/* mpd-database-stats */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_351, obj_t BgL_backendz00_352, obj_t BgL_opz00_353)
{
{ /* Llib/mpd.scm 1108 */
{ /* Llib/mpd.scm 1108 */
obj_t BgL_method1352z00_2384;
{ /* Llib/mpd.scm 1108 */
obj_t BgL_res3065z00_3946;
{ /* Llib/mpd.scm 1108 */
long BgL_objzd2classzd2numz00_3911;
{ /* Llib/mpd.scm 1108 */
long BgL_res3055z00_3914;
BgL_res3055z00_3914 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_351)); 
BgL_objzd2classzd2numz00_3911 = BgL_res3055z00_3914; } 
{ /* Llib/mpd.scm 1108 */
obj_t BgL_arg1759z00_3912;
BgL_arg1759z00_3912 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2statszd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1108 */
int BgL_offsetz00_3916;
BgL_offsetz00_3916 = 
(int)(BgL_objzd2classzd2numz00_3911); 
{ /* Llib/mpd.scm 1108 */
long BgL_offsetz00_3917;
BgL_offsetz00_3917 = 
(
(long)(BgL_offsetz00_3916)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1108 */
long BgL_modz00_3918;
BgL_modz00_3918 = 
(BgL_offsetz00_3917 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1108 */
long BgL_restz00_3920;
BgL_restz00_3920 = 
(BgL_offsetz00_3917 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1108 */

{ /* Llib/mpd.scm 1108 */
obj_t BgL_bucketz00_3922;
BgL_bucketz00_3922 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_3912),BgL_modz00_3918); 
BgL_res3065z00_3946 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3922),BgL_restz00_3920); } } } } } } } } 
BgL_method1352z00_2384 = BgL_res3065z00_3946; } 
return 
PROCEDURE_ENTRY(BgL_method1352z00_2384)(BgL_method1352z00_2384, 
((obj_t)BgL_oz00_351), BgL_backendz00_352, BgL_opz00_353, BEOA);} } 

}



/* &mpd-database-stats */
obj_t BGl_z62mpdzd2databasezd2statsz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5247, obj_t BgL_oz00_5248, obj_t BgL_backendz00_5249, obj_t BgL_opz00_5250)
{
{ /* Llib/mpd.scm 1108 */
{ /* Llib/mpd.scm 1108 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_9309;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5248, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1108 */
BgL_auxz00_9309 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5248)
; }  else 
{ 
obj_t BgL_auxz00_9313;
BgL_auxz00_9313 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)44204)), BGl_string3526z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5248); 
FAILURE(BgL_auxz00_9313,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2statsz00zz__multimediazd2mpdzd2(BgL_auxz00_9309, BgL_backendz00_5249, BgL_opz00_5250);} } 

}



/* mpd-database-listall */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_354, obj_t BgL_opz00_355)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1142 */
obj_t BgL_method1354z00_2385;
{ /* Llib/mpd.scm 1142 */
obj_t BgL_res3076z00_3983;
{ /* Llib/mpd.scm 1142 */
long BgL_objzd2classzd2numz00_3948;
{ /* Llib/mpd.scm 1142 */
long BgL_res3066z00_3951;
BgL_res3066z00_3951 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_354)); 
BgL_objzd2classzd2numz00_3948 = BgL_res3066z00_3951; } 
{ /* Llib/mpd.scm 1142 */
obj_t BgL_arg1759z00_3949;
BgL_arg1759z00_3949 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listallzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1142 */
int BgL_offsetz00_3953;
BgL_offsetz00_3953 = 
(int)(BgL_objzd2classzd2numz00_3948); 
{ /* Llib/mpd.scm 1142 */
long BgL_offsetz00_3954;
BgL_offsetz00_3954 = 
(
(long)(BgL_offsetz00_3953)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1142 */
long BgL_modz00_3955;
BgL_modz00_3955 = 
(BgL_offsetz00_3954 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1142 */
long BgL_restz00_3957;
BgL_restz00_3957 = 
(BgL_offsetz00_3954 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1142 */

{ /* Llib/mpd.scm 1142 */
obj_t BgL_bucketz00_3959;
BgL_bucketz00_3959 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_3949),BgL_modz00_3955); 
BgL_res3076z00_3983 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3959),BgL_restz00_3957); } } } } } } } } 
BgL_method1354z00_2385 = BgL_res3076z00_3983; } 
return 
PROCEDURE_ENTRY(BgL_method1354z00_2385)(BgL_method1354z00_2385, 
((obj_t)BgL_oz00_354), BgL_opz00_355, BEOA);} } 

}



/* &mpd-database-listall */
obj_t BGl_z62mpdzd2databasezd2listallz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5251, obj_t BgL_oz00_5252, obj_t BgL_opz00_5253)
{
{ /* Llib/mpd.scm 1142 */
{ /* Llib/mpd.scm 1142 */
obj_t BgL_auxz00_9357;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9349;
if(
OUTPUT_PORTP(BgL_opz00_5253))
{ /* Llib/mpd.scm 1142 */
BgL_auxz00_9357 = BgL_opz00_5253
; }  else 
{ 
obj_t BgL_auxz00_9360;
BgL_auxz00_9360 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)45279)), BGl_string3527z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5253); 
FAILURE(BgL_auxz00_9360,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5252, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1142 */
BgL_auxz00_9349 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5252)
; }  else 
{ 
obj_t BgL_auxz00_9353;
BgL_auxz00_9353 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)45279)), BGl_string3527z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5252); 
FAILURE(BgL_auxz00_9353,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listallz00zz__multimediazd2mpdzd2(BgL_auxz00_9349, BgL_auxz00_9357);} } 

}



/* mpd-database-listalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_356, obj_t BgL_opz00_357)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1168 */
obj_t BgL_method1356z00_2386;
{ /* Llib/mpd.scm 1168 */
obj_t BgL_res3087z00_4020;
{ /* Llib/mpd.scm 1168 */
long BgL_objzd2classzd2numz00_3985;
{ /* Llib/mpd.scm 1168 */
long BgL_res3077z00_3988;
BgL_res3077z00_3988 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_356)); 
BgL_objzd2classzd2numz00_3985 = BgL_res3077z00_3988; } 
{ /* Llib/mpd.scm 1168 */
obj_t BgL_arg1759z00_3986;
BgL_arg1759z00_3986 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1168 */
int BgL_offsetz00_3990;
BgL_offsetz00_3990 = 
(int)(BgL_objzd2classzd2numz00_3985); 
{ /* Llib/mpd.scm 1168 */
long BgL_offsetz00_3991;
BgL_offsetz00_3991 = 
(
(long)(BgL_offsetz00_3990)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1168 */
long BgL_modz00_3992;
BgL_modz00_3992 = 
(BgL_offsetz00_3991 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1168 */
long BgL_restz00_3994;
BgL_restz00_3994 = 
(BgL_offsetz00_3991 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1168 */

{ /* Llib/mpd.scm 1168 */
obj_t BgL_bucketz00_3996;
BgL_bucketz00_3996 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_3986),BgL_modz00_3992); 
BgL_res3087z00_4020 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_3996),BgL_restz00_3994); } } } } } } } } 
BgL_method1356z00_2386 = BgL_res3087z00_4020; } 
return 
PROCEDURE_ENTRY(BgL_method1356z00_2386)(BgL_method1356z00_2386, 
((obj_t)BgL_oz00_356), BgL_opz00_357, BEOA);} } 

}



/* &mpd-database-listalbum */
obj_t BGl_z62mpdzd2databasezd2listalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5254, obj_t BgL_oz00_5255, obj_t BgL_opz00_5256)
{
{ /* Llib/mpd.scm 1168 */
{ /* Llib/mpd.scm 1168 */
obj_t BgL_auxz00_9404;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9396;
if(
OUTPUT_PORTP(BgL_opz00_5256))
{ /* Llib/mpd.scm 1168 */
BgL_auxz00_9404 = BgL_opz00_5256
; }  else 
{ 
obj_t BgL_auxz00_9407;
BgL_auxz00_9407 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)46110)), BGl_string3528z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5256); 
FAILURE(BgL_auxz00_9407,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5255, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1168 */
BgL_auxz00_9396 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5255)
; }  else 
{ 
obj_t BgL_auxz00_9400;
BgL_auxz00_9400 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)46110)), BGl_string3528z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5255); 
FAILURE(BgL_auxz00_9400,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9396, BgL_auxz00_9404);} } 

}



/* mpd-database-listartistalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_358, obj_t BgL_opz00_359, obj_t BgL_artistz00_360)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1179 */
obj_t BgL_method1358z00_2387;
{ /* Llib/mpd.scm 1179 */
obj_t BgL_res3098z00_4057;
{ /* Llib/mpd.scm 1179 */
long BgL_objzd2classzd2numz00_4022;
{ /* Llib/mpd.scm 1179 */
long BgL_res3088z00_4025;
BgL_res3088z00_4025 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_358)); 
BgL_objzd2classzd2numz00_4022 = BgL_res3088z00_4025; } 
{ /* Llib/mpd.scm 1179 */
obj_t BgL_arg1759z00_4023;
BgL_arg1759z00_4023 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listartistalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1179 */
int BgL_offsetz00_4027;
BgL_offsetz00_4027 = 
(int)(BgL_objzd2classzd2numz00_4022); 
{ /* Llib/mpd.scm 1179 */
long BgL_offsetz00_4028;
BgL_offsetz00_4028 = 
(
(long)(BgL_offsetz00_4027)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1179 */
long BgL_modz00_4029;
BgL_modz00_4029 = 
(BgL_offsetz00_4028 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1179 */
long BgL_restz00_4031;
BgL_restz00_4031 = 
(BgL_offsetz00_4028 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1179 */

{ /* Llib/mpd.scm 1179 */
obj_t BgL_bucketz00_4033;
BgL_bucketz00_4033 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4023),BgL_modz00_4029); 
BgL_res3098z00_4057 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4033),BgL_restz00_4031); } } } } } } } } 
BgL_method1358z00_2387 = BgL_res3098z00_4057; } 
return 
PROCEDURE_ENTRY(BgL_method1358z00_2387)(BgL_method1358z00_2387, 
((obj_t)BgL_oz00_358), BgL_opz00_359, BgL_artistz00_360, BEOA);} } 

}



/* &mpd-database-listartistalbum */
obj_t BGl_z62mpdzd2databasezd2listartistalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5257, obj_t BgL_oz00_5258, obj_t BgL_opz00_5259, obj_t BgL_artistz00_5260)
{
{ /* Llib/mpd.scm 1179 */
{ /* Llib/mpd.scm 1179 */
obj_t BgL_auxz00_9452;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9444;
if(
OUTPUT_PORTP(BgL_opz00_5259))
{ /* Llib/mpd.scm 1179 */
BgL_auxz00_9452 = BgL_opz00_5259
; }  else 
{ 
obj_t BgL_auxz00_9455;
BgL_auxz00_9455 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)46540)), BGl_string3529z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5259); 
FAILURE(BgL_auxz00_9455,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5258, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1179 */
BgL_auxz00_9444 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5258)
; }  else 
{ 
obj_t BgL_auxz00_9448;
BgL_auxz00_9448 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)46540)), BGl_string3529z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5258); 
FAILURE(BgL_auxz00_9448,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listartistalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9444, BgL_auxz00_9452, BgL_artistz00_5260);} } 

}



/* mpd-database-listgenrealbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_361, obj_t BgL_opz00_362, obj_t BgL_genrez00_363)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1189 */
obj_t BgL_method1360z00_2388;
{ /* Llib/mpd.scm 1189 */
obj_t BgL_res3109z00_4094;
{ /* Llib/mpd.scm 1189 */
long BgL_objzd2classzd2numz00_4059;
{ /* Llib/mpd.scm 1189 */
long BgL_res3099z00_4062;
BgL_res3099z00_4062 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_361)); 
BgL_objzd2classzd2numz00_4059 = BgL_res3099z00_4062; } 
{ /* Llib/mpd.scm 1189 */
obj_t BgL_arg1759z00_4060;
BgL_arg1759z00_4060 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenrealbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1189 */
int BgL_offsetz00_4064;
BgL_offsetz00_4064 = 
(int)(BgL_objzd2classzd2numz00_4059); 
{ /* Llib/mpd.scm 1189 */
long BgL_offsetz00_4065;
BgL_offsetz00_4065 = 
(
(long)(BgL_offsetz00_4064)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1189 */
long BgL_modz00_4066;
BgL_modz00_4066 = 
(BgL_offsetz00_4065 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1189 */
long BgL_restz00_4068;
BgL_restz00_4068 = 
(BgL_offsetz00_4065 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1189 */

{ /* Llib/mpd.scm 1189 */
obj_t BgL_bucketz00_4070;
BgL_bucketz00_4070 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4060),BgL_modz00_4066); 
BgL_res3109z00_4094 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4070),BgL_restz00_4068); } } } } } } } } 
BgL_method1360z00_2388 = BgL_res3109z00_4094; } 
return 
PROCEDURE_ENTRY(BgL_method1360z00_2388)(BgL_method1360z00_2388, 
((obj_t)BgL_oz00_361), BgL_opz00_362, BgL_genrez00_363, BEOA);} } 

}



/* &mpd-database-listgenrealbum */
obj_t BGl_z62mpdzd2databasezd2listgenrealbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5261, obj_t BgL_oz00_5262, obj_t BgL_opz00_5263, obj_t BgL_genrez00_5264)
{
{ /* Llib/mpd.scm 1189 */
{ /* Llib/mpd.scm 1189 */
obj_t BgL_auxz00_9500;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9492;
if(
OUTPUT_PORTP(BgL_opz00_5263))
{ /* Llib/mpd.scm 1189 */
BgL_auxz00_9500 = BgL_opz00_5263
; }  else 
{ 
obj_t BgL_auxz00_9503;
BgL_auxz00_9503 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)46973)), BGl_string3530z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5263); 
FAILURE(BgL_auxz00_9503,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5262, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1189 */
BgL_auxz00_9492 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5262)
; }  else 
{ 
obj_t BgL_auxz00_9496;
BgL_auxz00_9496 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)46973)), BGl_string3530z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5262); 
FAILURE(BgL_auxz00_9496,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenrealbumz00zz__multimediazd2mpdzd2(BgL_auxz00_9492, BgL_auxz00_9500, BgL_genrez00_5264);} } 

}



/* mpd-database-listgenreartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_364, obj_t BgL_opz00_365, obj_t BgL_genrez00_366)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1203 */
obj_t BgL_method1362z00_2389;
{ /* Llib/mpd.scm 1203 */
obj_t BgL_res3120z00_4131;
{ /* Llib/mpd.scm 1203 */
long BgL_objzd2classzd2numz00_4096;
{ /* Llib/mpd.scm 1203 */
long BgL_res3110z00_4099;
BgL_res3110z00_4099 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_364)); 
BgL_objzd2classzd2numz00_4096 = BgL_res3110z00_4099; } 
{ /* Llib/mpd.scm 1203 */
obj_t BgL_arg1759z00_4097;
BgL_arg1759z00_4097 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenreartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1203 */
int BgL_offsetz00_4101;
BgL_offsetz00_4101 = 
(int)(BgL_objzd2classzd2numz00_4096); 
{ /* Llib/mpd.scm 1203 */
long BgL_offsetz00_4102;
BgL_offsetz00_4102 = 
(
(long)(BgL_offsetz00_4101)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1203 */
long BgL_modz00_4103;
BgL_modz00_4103 = 
(BgL_offsetz00_4102 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1203 */
long BgL_restz00_4105;
BgL_restz00_4105 = 
(BgL_offsetz00_4102 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1203 */

{ /* Llib/mpd.scm 1203 */
obj_t BgL_bucketz00_4107;
BgL_bucketz00_4107 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4097),BgL_modz00_4103); 
BgL_res3120z00_4131 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4107),BgL_restz00_4105); } } } } } } } } 
BgL_method1362z00_2389 = BgL_res3120z00_4131; } 
return 
PROCEDURE_ENTRY(BgL_method1362z00_2389)(BgL_method1362z00_2389, 
((obj_t)BgL_oz00_364), BgL_opz00_365, BgL_genrez00_366, BEOA);} } 

}



/* &mpd-database-listgenreartist */
obj_t BGl_z62mpdzd2databasezd2listgenreartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5265, obj_t BgL_oz00_5266, obj_t BgL_opz00_5267, obj_t BgL_genrez00_5268)
{
{ /* Llib/mpd.scm 1203 */
{ /* Llib/mpd.scm 1203 */
obj_t BgL_auxz00_9548;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9540;
if(
OUTPUT_PORTP(BgL_opz00_5267))
{ /* Llib/mpd.scm 1203 */
BgL_auxz00_9548 = BgL_opz00_5267
; }  else 
{ 
obj_t BgL_auxz00_9551;
BgL_auxz00_9551 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)47524)), BGl_string3531z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5267); 
FAILURE(BgL_auxz00_9551,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5266, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1203 */
BgL_auxz00_9540 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5266)
; }  else 
{ 
obj_t BgL_auxz00_9544;
BgL_auxz00_9544 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)47524)), BGl_string3531z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5266); 
FAILURE(BgL_auxz00_9544,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenreartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9540, BgL_auxz00_9548, BgL_genrez00_5268);} } 

}



/* mpd-database-listgenre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_367, obj_t BgL_opz00_368)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1213 */
obj_t BgL_method1364z00_2390;
{ /* Llib/mpd.scm 1213 */
obj_t BgL_res3131z00_4168;
{ /* Llib/mpd.scm 1213 */
long BgL_objzd2classzd2numz00_4133;
{ /* Llib/mpd.scm 1213 */
long BgL_res3121z00_4136;
BgL_res3121z00_4136 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_367)); 
BgL_objzd2classzd2numz00_4133 = BgL_res3121z00_4136; } 
{ /* Llib/mpd.scm 1213 */
obj_t BgL_arg1759z00_4134;
BgL_arg1759z00_4134 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listgenrezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1213 */
int BgL_offsetz00_4138;
BgL_offsetz00_4138 = 
(int)(BgL_objzd2classzd2numz00_4133); 
{ /* Llib/mpd.scm 1213 */
long BgL_offsetz00_4139;
BgL_offsetz00_4139 = 
(
(long)(BgL_offsetz00_4138)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1213 */
long BgL_modz00_4140;
BgL_modz00_4140 = 
(BgL_offsetz00_4139 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1213 */
long BgL_restz00_4142;
BgL_restz00_4142 = 
(BgL_offsetz00_4139 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1213 */

{ /* Llib/mpd.scm 1213 */
obj_t BgL_bucketz00_4144;
BgL_bucketz00_4144 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4134),BgL_modz00_4140); 
BgL_res3131z00_4168 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4144),BgL_restz00_4142); } } } } } } } } 
BgL_method1364z00_2390 = BgL_res3131z00_4168; } 
return 
PROCEDURE_ENTRY(BgL_method1364z00_2390)(BgL_method1364z00_2390, 
((obj_t)BgL_oz00_367), BgL_opz00_368, BEOA);} } 

}



/* &mpd-database-listgenre */
obj_t BGl_z62mpdzd2databasezd2listgenrez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5269, obj_t BgL_oz00_5270, obj_t BgL_opz00_5271)
{
{ /* Llib/mpd.scm 1213 */
{ /* Llib/mpd.scm 1213 */
obj_t BgL_auxz00_9595;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9587;
if(
OUTPUT_PORTP(BgL_opz00_5271))
{ /* Llib/mpd.scm 1213 */
BgL_auxz00_9595 = BgL_opz00_5271
; }  else 
{ 
obj_t BgL_auxz00_9598;
BgL_auxz00_9598 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)47955)), BGl_string3532z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5271); 
FAILURE(BgL_auxz00_9598,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5270, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1213 */
BgL_auxz00_9587 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5270)
; }  else 
{ 
obj_t BgL_auxz00_9591;
BgL_auxz00_9591 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)47955)), BGl_string3532z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5270); 
FAILURE(BgL_auxz00_9591,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listgenrez00zz__multimediazd2mpdzd2(BgL_auxz00_9587, BgL_auxz00_9595);} } 

}



/* mpd-database-listartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_369, obj_t BgL_opz00_370)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1223 */
obj_t BgL_method1366z00_2391;
{ /* Llib/mpd.scm 1223 */
obj_t BgL_res3142z00_4205;
{ /* Llib/mpd.scm 1223 */
long BgL_objzd2classzd2numz00_4170;
{ /* Llib/mpd.scm 1223 */
long BgL_res3132z00_4173;
BgL_res3132z00_4173 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_369)); 
BgL_objzd2classzd2numz00_4170 = BgL_res3132z00_4173; } 
{ /* Llib/mpd.scm 1223 */
obj_t BgL_arg1759z00_4171;
BgL_arg1759z00_4171 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2listartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1223 */
int BgL_offsetz00_4175;
BgL_offsetz00_4175 = 
(int)(BgL_objzd2classzd2numz00_4170); 
{ /* Llib/mpd.scm 1223 */
long BgL_offsetz00_4176;
BgL_offsetz00_4176 = 
(
(long)(BgL_offsetz00_4175)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1223 */
long BgL_modz00_4177;
BgL_modz00_4177 = 
(BgL_offsetz00_4176 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1223 */
long BgL_restz00_4179;
BgL_restz00_4179 = 
(BgL_offsetz00_4176 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1223 */

{ /* Llib/mpd.scm 1223 */
obj_t BgL_bucketz00_4181;
BgL_bucketz00_4181 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4171),BgL_modz00_4177); 
BgL_res3142z00_4205 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4181),BgL_restz00_4179); } } } } } } } } 
BgL_method1366z00_2391 = BgL_res3142z00_4205; } 
return 
PROCEDURE_ENTRY(BgL_method1366z00_2391)(BgL_method1366z00_2391, 
((obj_t)BgL_oz00_369), BgL_opz00_370, BEOA);} } 

}



/* &mpd-database-listartist */
obj_t BGl_z62mpdzd2databasezd2listartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5272, obj_t BgL_oz00_5273, obj_t BgL_opz00_5274)
{
{ /* Llib/mpd.scm 1223 */
{ /* Llib/mpd.scm 1223 */
obj_t BgL_auxz00_9642;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9634;
if(
OUTPUT_PORTP(BgL_opz00_5274))
{ /* Llib/mpd.scm 1223 */
BgL_auxz00_9642 = BgL_opz00_5274
; }  else 
{ 
obj_t BgL_auxz00_9645;
BgL_auxz00_9645 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)48361)), BGl_string3533z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5274); 
FAILURE(BgL_auxz00_9645,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5273, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1223 */
BgL_auxz00_9634 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5273)
; }  else 
{ 
obj_t BgL_auxz00_9638;
BgL_auxz00_9638 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)48361)), BGl_string3533z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5273); 
FAILURE(BgL_auxz00_9638,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2listartistz00zz__multimediazd2mpdzd2(BgL_auxz00_9634, BgL_auxz00_9642);} } 

}



/* mpd-database-lsinfo */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_371, obj_t BgL_opz00_372, obj_t BgL_dirz00_373, bool_t BgL_recz00_374)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1233 */
obj_t BgL_method1368z00_2392;
{ /* Llib/mpd.scm 1233 */
obj_t BgL_res3153z00_4242;
{ /* Llib/mpd.scm 1233 */
long BgL_objzd2classzd2numz00_4207;
{ /* Llib/mpd.scm 1233 */
long BgL_res3143z00_4210;
BgL_res3143z00_4210 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_371)); 
BgL_objzd2classzd2numz00_4207 = BgL_res3143z00_4210; } 
{ /* Llib/mpd.scm 1233 */
obj_t BgL_arg1759z00_4208;
BgL_arg1759z00_4208 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2lsinfozd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1233 */
int BgL_offsetz00_4212;
BgL_offsetz00_4212 = 
(int)(BgL_objzd2classzd2numz00_4207); 
{ /* Llib/mpd.scm 1233 */
long BgL_offsetz00_4213;
BgL_offsetz00_4213 = 
(
(long)(BgL_offsetz00_4212)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1233 */
long BgL_modz00_4214;
BgL_modz00_4214 = 
(BgL_offsetz00_4213 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1233 */
long BgL_restz00_4216;
BgL_restz00_4216 = 
(BgL_offsetz00_4213 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1233 */

{ /* Llib/mpd.scm 1233 */
obj_t BgL_bucketz00_4218;
BgL_bucketz00_4218 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4208),BgL_modz00_4214); 
BgL_res3153z00_4242 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4218),BgL_restz00_4216); } } } } } } } } 
BgL_method1368z00_2392 = BgL_res3153z00_4242; } 
return 
PROCEDURE_ENTRY(BgL_method1368z00_2392)(BgL_method1368z00_2392, 
((obj_t)BgL_oz00_371), BgL_opz00_372, BgL_dirz00_373, 
BBOOL(BgL_recz00_374), BEOA);} } 

}



/* &mpd-database-lsinfo */
obj_t BGl_z62mpdzd2databasezd2lsinfoz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5275, obj_t BgL_oz00_5276, obj_t BgL_opz00_5277, obj_t BgL_dirz00_5278, obj_t BgL_recz00_5279)
{
{ /* Llib/mpd.scm 1233 */
{ /* Llib/mpd.scm 1233 */
obj_t BgL_auxz00_9699;obj_t BgL_auxz00_9692;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9684;
if(
STRINGP(BgL_dirz00_5278))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9699 = BgL_dirz00_5278
; }  else 
{ 
obj_t BgL_auxz00_9702;
BgL_auxz00_9702 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3534z00zz__multimediazd2mpdzd2, BGl_string3525z00zz__multimediazd2mpdzd2, BgL_dirz00_5278); 
FAILURE(BgL_auxz00_9702,BFALSE,BFALSE);} 
if(
OUTPUT_PORTP(BgL_opz00_5277))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9692 = BgL_opz00_5277
; }  else 
{ 
obj_t BgL_auxz00_9695;
BgL_auxz00_9695 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3534z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5277); 
FAILURE(BgL_auxz00_9695,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5276, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1233 */
BgL_auxz00_9684 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5276)
; }  else 
{ 
obj_t BgL_auxz00_9688;
BgL_auxz00_9688 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)48770)), BGl_string3534z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5276); 
FAILURE(BgL_auxz00_9688,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2lsinfoz00zz__multimediazd2mpdzd2(BgL_auxz00_9684, BgL_auxz00_9692, BgL_auxz00_9699, 
CBOOL(BgL_recz00_5279));} } 

}



/* mpd-database-find-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_380, obj_t BgL_opz00_381, obj_t BgL_albumz00_382)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1294 */
obj_t BgL_method1370z00_2393;
{ /* Llib/mpd.scm 1294 */
obj_t BgL_res3164z00_4279;
{ /* Llib/mpd.scm 1294 */
long BgL_objzd2classzd2numz00_4244;
{ /* Llib/mpd.scm 1294 */
long BgL_res3154z00_4247;
BgL_res3154z00_4247 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_380)); 
BgL_objzd2classzd2numz00_4244 = BgL_res3154z00_4247; } 
{ /* Llib/mpd.scm 1294 */
obj_t BgL_arg1759z00_4245;
BgL_arg1759z00_4245 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2albumzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1294 */
int BgL_offsetz00_4249;
BgL_offsetz00_4249 = 
(int)(BgL_objzd2classzd2numz00_4244); 
{ /* Llib/mpd.scm 1294 */
long BgL_offsetz00_4250;
BgL_offsetz00_4250 = 
(
(long)(BgL_offsetz00_4249)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1294 */
long BgL_modz00_4251;
BgL_modz00_4251 = 
(BgL_offsetz00_4250 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1294 */
long BgL_restz00_4253;
BgL_restz00_4253 = 
(BgL_offsetz00_4250 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1294 */

{ /* Llib/mpd.scm 1294 */
obj_t BgL_bucketz00_4255;
BgL_bucketz00_4255 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4245),BgL_modz00_4251); 
BgL_res3164z00_4279 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4255),BgL_restz00_4253); } } } } } } } } 
BgL_method1370z00_2393 = BgL_res3164z00_4279; } 
return 
PROCEDURE_ENTRY(BgL_method1370z00_2393)(BgL_method1370z00_2393, 
((obj_t)BgL_oz00_380), BgL_opz00_381, BgL_albumz00_382, BEOA);} } 

}



/* &mpd-database-find-album */
obj_t BGl_z62mpdzd2databasezd2findzd2albumzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5280, obj_t BgL_oz00_5281, obj_t BgL_opz00_5282, obj_t BgL_albumz00_5283)
{
{ /* Llib/mpd.scm 1294 */
{ /* Llib/mpd.scm 1294 */
obj_t BgL_auxz00_9748;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9740;
if(
OUTPUT_PORTP(BgL_opz00_5282))
{ /* Llib/mpd.scm 1294 */
BgL_auxz00_9748 = BgL_opz00_5282
; }  else 
{ 
obj_t BgL_auxz00_9751;
BgL_auxz00_9751 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)50979)), BGl_string3535z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5282); 
FAILURE(BgL_auxz00_9751,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5281, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1294 */
BgL_auxz00_9740 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5281)
; }  else 
{ 
obj_t BgL_auxz00_9744;
BgL_auxz00_9744 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)50979)), BGl_string3535z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5281); 
FAILURE(BgL_auxz00_9744,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2albumzd2zz__multimediazd2mpdzd2(BgL_auxz00_9740, BgL_auxz00_9748, BgL_albumz00_5283);} } 

}



/* mpd-database-find-artist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_383, obj_t BgL_opz00_384, obj_t BgL_artistz00_385)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1303 */
obj_t BgL_method1372z00_2394;
{ /* Llib/mpd.scm 1303 */
obj_t BgL_res3175z00_4316;
{ /* Llib/mpd.scm 1303 */
long BgL_objzd2classzd2numz00_4281;
{ /* Llib/mpd.scm 1303 */
long BgL_res3165z00_4284;
BgL_res3165z00_4284 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_383)); 
BgL_objzd2classzd2numz00_4281 = BgL_res3165z00_4284; } 
{ /* Llib/mpd.scm 1303 */
obj_t BgL_arg1759z00_4282;
BgL_arg1759z00_4282 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2artistzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1303 */
int BgL_offsetz00_4286;
BgL_offsetz00_4286 = 
(int)(BgL_objzd2classzd2numz00_4281); 
{ /* Llib/mpd.scm 1303 */
long BgL_offsetz00_4287;
BgL_offsetz00_4287 = 
(
(long)(BgL_offsetz00_4286)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1303 */
long BgL_modz00_4288;
BgL_modz00_4288 = 
(BgL_offsetz00_4287 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1303 */
long BgL_restz00_4290;
BgL_restz00_4290 = 
(BgL_offsetz00_4287 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1303 */

{ /* Llib/mpd.scm 1303 */
obj_t BgL_bucketz00_4292;
BgL_bucketz00_4292 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4282),BgL_modz00_4288); 
BgL_res3175z00_4316 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4292),BgL_restz00_4290); } } } } } } } } 
BgL_method1372z00_2394 = BgL_res3175z00_4316; } 
return 
PROCEDURE_ENTRY(BgL_method1372z00_2394)(BgL_method1372z00_2394, 
((obj_t)BgL_oz00_383), BgL_opz00_384, BgL_artistz00_385, BEOA);} } 

}



/* &mpd-database-find-artist */
obj_t BGl_z62mpdzd2databasezd2findzd2artistzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5284, obj_t BgL_oz00_5285, obj_t BgL_opz00_5286, obj_t BgL_artistz00_5287)
{
{ /* Llib/mpd.scm 1303 */
{ /* Llib/mpd.scm 1303 */
obj_t BgL_auxz00_9796;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9788;
if(
OUTPUT_PORTP(BgL_opz00_5286))
{ /* Llib/mpd.scm 1303 */
BgL_auxz00_9796 = BgL_opz00_5286
; }  else 
{ 
obj_t BgL_auxz00_9799;
BgL_auxz00_9799 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)51417)), BGl_string3536z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5286); 
FAILURE(BgL_auxz00_9799,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5285, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1303 */
BgL_auxz00_9788 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5285)
; }  else 
{ 
obj_t BgL_auxz00_9792;
BgL_auxz00_9792 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)51417)), BGl_string3536z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5285); 
FAILURE(BgL_auxz00_9792,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2artistzd2zz__multimediazd2mpdzd2(BgL_auxz00_9788, BgL_auxz00_9796, BgL_artistz00_5287);} } 

}



/* mpd-database-search-artist-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_386, obj_t BgL_opz00_387, obj_t BgL_artistz00_388, obj_t BgL_albumz00_389)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1312 */
obj_t BgL_method1374z00_2395;
{ /* Llib/mpd.scm 1312 */
obj_t BgL_res3186z00_4353;
{ /* Llib/mpd.scm 1312 */
long BgL_objzd2classzd2numz00_4318;
{ /* Llib/mpd.scm 1312 */
long BgL_res3176z00_4321;
BgL_res3176z00_4321 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_386)); 
BgL_objzd2classzd2numz00_4318 = BgL_res3176z00_4321; } 
{ /* Llib/mpd.scm 1312 */
obj_t BgL_arg1759z00_4319;
BgL_arg1759z00_4319 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2searchzd2artistzd2albumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1312 */
int BgL_offsetz00_4323;
BgL_offsetz00_4323 = 
(int)(BgL_objzd2classzd2numz00_4318); 
{ /* Llib/mpd.scm 1312 */
long BgL_offsetz00_4324;
BgL_offsetz00_4324 = 
(
(long)(BgL_offsetz00_4323)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1312 */
long BgL_modz00_4325;
BgL_modz00_4325 = 
(BgL_offsetz00_4324 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1312 */
long BgL_restz00_4327;
BgL_restz00_4327 = 
(BgL_offsetz00_4324 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1312 */

{ /* Llib/mpd.scm 1312 */
obj_t BgL_bucketz00_4329;
BgL_bucketz00_4329 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4319),BgL_modz00_4325); 
BgL_res3186z00_4353 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4329),BgL_restz00_4327); } } } } } } } } 
BgL_method1374z00_2395 = BgL_res3186z00_4353; } 
return 
PROCEDURE_ENTRY(BgL_method1374z00_2395)(BgL_method1374z00_2395, 
((obj_t)BgL_oz00_386), BgL_opz00_387, BgL_artistz00_388, BgL_albumz00_389, BEOA);} } 

}



/* &mpd-database-search-artist-album */
obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2albumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5288, obj_t BgL_oz00_5289, obj_t BgL_opz00_5290, obj_t BgL_artistz00_5291, obj_t BgL_albumz00_5292)
{
{ /* Llib/mpd.scm 1312 */
{ /* Llib/mpd.scm 1312 */
obj_t BgL_auxz00_9845;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9837;
if(
OUTPUT_PORTP(BgL_opz00_5290))
{ /* Llib/mpd.scm 1312 */
BgL_auxz00_9845 = BgL_opz00_5290
; }  else 
{ 
obj_t BgL_auxz00_9848;
BgL_auxz00_9848 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)51861)), BGl_string3537z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5290); 
FAILURE(BgL_auxz00_9848,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5289, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1312 */
BgL_auxz00_9837 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5289)
; }  else 
{ 
obj_t BgL_auxz00_9841;
BgL_auxz00_9841 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)51861)), BGl_string3537z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5289); 
FAILURE(BgL_auxz00_9841,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2searchzd2artistzd2albumz00zz__multimediazd2mpdzd2(BgL_auxz00_9837, BgL_auxz00_9845, BgL_artistz00_5291, BgL_albumz00_5292);} } 

}



/* mpd-database-search-artist-title */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_390, obj_t BgL_opz00_391, obj_t BgL_artistz00_392, obj_t BgL_titlez00_393)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1345 */
obj_t BgL_method1376z00_2396;
{ /* Llib/mpd.scm 1345 */
obj_t BgL_res3197z00_4390;
{ /* Llib/mpd.scm 1345 */
long BgL_objzd2classzd2numz00_4355;
{ /* Llib/mpd.scm 1345 */
long BgL_res3187z00_4358;
BgL_res3187z00_4358 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_390)); 
BgL_objzd2classzd2numz00_4355 = BgL_res3187z00_4358; } 
{ /* Llib/mpd.scm 1345 */
obj_t BgL_arg1759z00_4356;
BgL_arg1759z00_4356 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2searchzd2artistzd2titlezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1345 */
int BgL_offsetz00_4360;
BgL_offsetz00_4360 = 
(int)(BgL_objzd2classzd2numz00_4355); 
{ /* Llib/mpd.scm 1345 */
long BgL_offsetz00_4361;
BgL_offsetz00_4361 = 
(
(long)(BgL_offsetz00_4360)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1345 */
long BgL_modz00_4362;
BgL_modz00_4362 = 
(BgL_offsetz00_4361 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1345 */
long BgL_restz00_4364;
BgL_restz00_4364 = 
(BgL_offsetz00_4361 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1345 */

{ /* Llib/mpd.scm 1345 */
obj_t BgL_bucketz00_4366;
BgL_bucketz00_4366 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4356),BgL_modz00_4362); 
BgL_res3197z00_4390 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4366),BgL_restz00_4364); } } } } } } } } 
BgL_method1376z00_2396 = BgL_res3197z00_4390; } 
return 
PROCEDURE_ENTRY(BgL_method1376z00_2396)(BgL_method1376z00_2396, 
((obj_t)BgL_oz00_390), BgL_opz00_391, BgL_artistz00_392, BgL_titlez00_393, BEOA);} } 

}



/* &mpd-database-search-artist-title */
obj_t BGl_z62mpdzd2databasezd2searchzd2artistzd2titlez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5293, obj_t BgL_oz00_5294, obj_t BgL_opz00_5295, obj_t BgL_artistz00_5296, obj_t BgL_titlez00_5297)
{
{ /* Llib/mpd.scm 1345 */
{ /* Llib/mpd.scm 1345 */
obj_t BgL_auxz00_9894;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9886;
if(
OUTPUT_PORTP(BgL_opz00_5295))
{ /* Llib/mpd.scm 1345 */
BgL_auxz00_9894 = BgL_opz00_5295
; }  else 
{ 
obj_t BgL_auxz00_9897;
BgL_auxz00_9897 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)53036)), BGl_string3538z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5295); 
FAILURE(BgL_auxz00_9897,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5294, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1345 */
BgL_auxz00_9886 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5294)
; }  else 
{ 
obj_t BgL_auxz00_9890;
BgL_auxz00_9890 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)53036)), BGl_string3538z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5294); 
FAILURE(BgL_auxz00_9890,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2searchzd2artistzd2titlez00zz__multimediazd2mpdzd2(BgL_auxz00_9886, BgL_auxz00_9894, BgL_artistz00_5296, BgL_titlez00_5297);} } 

}



/* mpd-database-find-title */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_394, obj_t BgL_opz00_395, obj_t BgL_titlez00_396)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1371 */
obj_t BgL_method1378z00_2397;
{ /* Llib/mpd.scm 1371 */
obj_t BgL_res3208z00_4427;
{ /* Llib/mpd.scm 1371 */
long BgL_objzd2classzd2numz00_4392;
{ /* Llib/mpd.scm 1371 */
long BgL_res3198z00_4395;
BgL_res3198z00_4395 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_394)); 
BgL_objzd2classzd2numz00_4392 = BgL_res3198z00_4395; } 
{ /* Llib/mpd.scm 1371 */
obj_t BgL_arg1759z00_4393;
BgL_arg1759z00_4393 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2titlezd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1371 */
int BgL_offsetz00_4397;
BgL_offsetz00_4397 = 
(int)(BgL_objzd2classzd2numz00_4392); 
{ /* Llib/mpd.scm 1371 */
long BgL_offsetz00_4398;
BgL_offsetz00_4398 = 
(
(long)(BgL_offsetz00_4397)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1371 */
long BgL_modz00_4399;
BgL_modz00_4399 = 
(BgL_offsetz00_4398 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1371 */
long BgL_restz00_4401;
BgL_restz00_4401 = 
(BgL_offsetz00_4398 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1371 */

{ /* Llib/mpd.scm 1371 */
obj_t BgL_bucketz00_4403;
BgL_bucketz00_4403 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4393),BgL_modz00_4399); 
BgL_res3208z00_4427 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4403),BgL_restz00_4401); } } } } } } } } 
BgL_method1378z00_2397 = BgL_res3208z00_4427; } 
return 
PROCEDURE_ENTRY(BgL_method1378z00_2397)(BgL_method1378z00_2397, 
((obj_t)BgL_oz00_394), BgL_opz00_395, BgL_titlez00_396, BEOA);} } 

}



/* &mpd-database-find-title */
obj_t BGl_z62mpdzd2databasezd2findzd2titlezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5298, obj_t BgL_oz00_5299, obj_t BgL_opz00_5300, obj_t BgL_titlez00_5301)
{
{ /* Llib/mpd.scm 1371 */
{ /* Llib/mpd.scm 1371 */
obj_t BgL_auxz00_9942;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9934;
if(
OUTPUT_PORTP(BgL_opz00_5300))
{ /* Llib/mpd.scm 1371 */
BgL_auxz00_9942 = BgL_opz00_5300
; }  else 
{ 
obj_t BgL_auxz00_9945;
BgL_auxz00_9945 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)53940)), BGl_string3539z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5300); 
FAILURE(BgL_auxz00_9945,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5299, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1371 */
BgL_auxz00_9934 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5299)
; }  else 
{ 
obj_t BgL_auxz00_9938;
BgL_auxz00_9938 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)53940)), BGl_string3539z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5299); 
FAILURE(BgL_auxz00_9938,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2titlezd2zz__multimediazd2mpdzd2(BgL_auxz00_9934, BgL_auxz00_9942, BgL_titlez00_5301);} } 

}



/* mpd-database-find-genre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_397, obj_t BgL_opz00_398, obj_t BgL_genrez00_399)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1389 */
obj_t BgL_method1380z00_2398;
{ /* Llib/mpd.scm 1389 */
obj_t BgL_res3219z00_4464;
{ /* Llib/mpd.scm 1389 */
long BgL_objzd2classzd2numz00_4429;
{ /* Llib/mpd.scm 1389 */
long BgL_res3209z00_4432;
BgL_res3209z00_4432 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_397)); 
BgL_objzd2classzd2numz00_4429 = BgL_res3209z00_4432; } 
{ /* Llib/mpd.scm 1389 */
obj_t BgL_arg1759z00_4430;
BgL_arg1759z00_4430 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2findzd2genrezd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1389 */
int BgL_offsetz00_4434;
BgL_offsetz00_4434 = 
(int)(BgL_objzd2classzd2numz00_4429); 
{ /* Llib/mpd.scm 1389 */
long BgL_offsetz00_4435;
BgL_offsetz00_4435 = 
(
(long)(BgL_offsetz00_4434)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1389 */
long BgL_modz00_4436;
BgL_modz00_4436 = 
(BgL_offsetz00_4435 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1389 */
long BgL_restz00_4438;
BgL_restz00_4438 = 
(BgL_offsetz00_4435 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1389 */

{ /* Llib/mpd.scm 1389 */
obj_t BgL_bucketz00_4440;
BgL_bucketz00_4440 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4430),BgL_modz00_4436); 
BgL_res3219z00_4464 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4440),BgL_restz00_4438); } } } } } } } } 
BgL_method1380z00_2398 = BgL_res3219z00_4464; } 
return 
PROCEDURE_ENTRY(BgL_method1380z00_2398)(BgL_method1380z00_2398, 
((obj_t)BgL_oz00_397), BgL_opz00_398, BgL_genrez00_399, BEOA);} } 

}



/* &mpd-database-find-genre */
obj_t BGl_z62mpdzd2databasezd2findzd2genrezb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5302, obj_t BgL_oz00_5303, obj_t BgL_opz00_5304, obj_t BgL_genrez00_5305)
{
{ /* Llib/mpd.scm 1389 */
{ /* Llib/mpd.scm 1389 */
obj_t BgL_auxz00_9990;BgL_mpdzd2databasezd2_bglt BgL_auxz00_9982;
if(
OUTPUT_PORTP(BgL_opz00_5304))
{ /* Llib/mpd.scm 1389 */
BgL_auxz00_9990 = BgL_opz00_5304
; }  else 
{ 
obj_t BgL_auxz00_9993;
BgL_auxz00_9993 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)54520)), BGl_string3540z00zz__multimediazd2mpdzd2, BGl_string3371z00zz__multimediazd2mpdzd2, BgL_opz00_5304); 
FAILURE(BgL_auxz00_9993,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5303, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1389 */
BgL_auxz00_9982 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5303)
; }  else 
{ 
obj_t BgL_auxz00_9986;
BgL_auxz00_9986 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)54520)), BGl_string3540z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5303); 
FAILURE(BgL_auxz00_9986,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2findzd2genrezd2zz__multimediazd2mpdzd2(BgL_auxz00_9982, BgL_auxz00_9990, BgL_genrez00_5305);} } 

}



/* mpd-database-getgenre */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_400)
{
{ /* Llib/mpd.scm 1407 */
{ /* Llib/mpd.scm 1407 */
obj_t BgL_method1382z00_2399;
{ /* Llib/mpd.scm 1407 */
obj_t BgL_res3230z00_4501;
{ /* Llib/mpd.scm 1407 */
long BgL_objzd2classzd2numz00_4466;
{ /* Llib/mpd.scm 1407 */
long BgL_res3220z00_4469;
BgL_res3220z00_4469 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_400)); 
BgL_objzd2classzd2numz00_4466 = BgL_res3220z00_4469; } 
{ /* Llib/mpd.scm 1407 */
obj_t BgL_arg1759z00_4467;
BgL_arg1759z00_4467 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getgenrezd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1407 */
int BgL_offsetz00_4471;
BgL_offsetz00_4471 = 
(int)(BgL_objzd2classzd2numz00_4466); 
{ /* Llib/mpd.scm 1407 */
long BgL_offsetz00_4472;
BgL_offsetz00_4472 = 
(
(long)(BgL_offsetz00_4471)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1407 */
long BgL_modz00_4473;
BgL_modz00_4473 = 
(BgL_offsetz00_4472 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1407 */
long BgL_restz00_4475;
BgL_restz00_4475 = 
(BgL_offsetz00_4472 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1407 */

{ /* Llib/mpd.scm 1407 */
obj_t BgL_bucketz00_4477;
BgL_bucketz00_4477 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4467),BgL_modz00_4473); 
BgL_res3230z00_4501 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4477),BgL_restz00_4475); } } } } } } } } 
BgL_method1382z00_2399 = BgL_res3230z00_4501; } 
return 
PROCEDURE_ENTRY(BgL_method1382z00_2399)(BgL_method1382z00_2399, 
((obj_t)BgL_oz00_400), BEOA);} } 

}



/* &mpd-database-getgenre */
obj_t BGl_z62mpdzd2databasezd2getgenrez62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5306, obj_t BgL_oz00_5307)
{
{ /* Llib/mpd.scm 1407 */
{ /* Llib/mpd.scm 1407 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_10028;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5307, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1407 */
BgL_auxz00_10028 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5307)
; }  else 
{ 
obj_t BgL_auxz00_10032;
BgL_auxz00_10032 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)55101)), BGl_string3541z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5307); 
FAILURE(BgL_auxz00_10032,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getgenrez00zz__multimediazd2mpdzd2(BgL_auxz00_10028);} } 

}



/* mpd-database-getartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_401)
{
{ /* Llib/mpd.scm 1414 */
{ /* Llib/mpd.scm 1414 */
obj_t BgL_method1384z00_2400;
{ /* Llib/mpd.scm 1414 */
obj_t BgL_res3241z00_4538;
{ /* Llib/mpd.scm 1414 */
long BgL_objzd2classzd2numz00_4503;
{ /* Llib/mpd.scm 1414 */
long BgL_res3231z00_4506;
BgL_res3231z00_4506 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_401)); 
BgL_objzd2classzd2numz00_4503 = BgL_res3231z00_4506; } 
{ /* Llib/mpd.scm 1414 */
obj_t BgL_arg1759z00_4504;
BgL_arg1759z00_4504 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1414 */
int BgL_offsetz00_4508;
BgL_offsetz00_4508 = 
(int)(BgL_objzd2classzd2numz00_4503); 
{ /* Llib/mpd.scm 1414 */
long BgL_offsetz00_4509;
BgL_offsetz00_4509 = 
(
(long)(BgL_offsetz00_4508)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1414 */
long BgL_modz00_4510;
BgL_modz00_4510 = 
(BgL_offsetz00_4509 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1414 */
long BgL_restz00_4512;
BgL_restz00_4512 = 
(BgL_offsetz00_4509 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1414 */

{ /* Llib/mpd.scm 1414 */
obj_t BgL_bucketz00_4514;
BgL_bucketz00_4514 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4504),BgL_modz00_4510); 
BgL_res3241z00_4538 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4514),BgL_restz00_4512); } } } } } } } } 
BgL_method1384z00_2400 = BgL_res3241z00_4538; } 
return 
PROCEDURE_ENTRY(BgL_method1384z00_2400)(BgL_method1384z00_2400, 
((obj_t)BgL_oz00_401), BEOA);} } 

}



/* &mpd-database-getartist */
obj_t BGl_z62mpdzd2databasezd2getartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5308, obj_t BgL_oz00_5309)
{
{ /* Llib/mpd.scm 1414 */
{ /* Llib/mpd.scm 1414 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_10067;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5309, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1414 */
BgL_auxz00_10067 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5309)
; }  else 
{ 
obj_t BgL_auxz00_10071;
BgL_auxz00_10071 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)55438)), BGl_string3542z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5309); 
FAILURE(BgL_auxz00_10071,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getartistz00zz__multimediazd2mpdzd2(BgL_auxz00_10067);} } 

}



/* mpd-database-getgenreartist */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_402, obj_t BgL_genrez00_403)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1421 */
obj_t BgL_method1386z00_2401;
{ /* Llib/mpd.scm 1421 */
obj_t BgL_res3252z00_4575;
{ /* Llib/mpd.scm 1421 */
long BgL_objzd2classzd2numz00_4540;
{ /* Llib/mpd.scm 1421 */
long BgL_res3242z00_4543;
BgL_res3242z00_4543 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_402)); 
BgL_objzd2classzd2numz00_4540 = BgL_res3242z00_4543; } 
{ /* Llib/mpd.scm 1421 */
obj_t BgL_arg1759z00_4541;
BgL_arg1759z00_4541 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getgenreartistzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1421 */
int BgL_offsetz00_4545;
BgL_offsetz00_4545 = 
(int)(BgL_objzd2classzd2numz00_4540); 
{ /* Llib/mpd.scm 1421 */
long BgL_offsetz00_4546;
BgL_offsetz00_4546 = 
(
(long)(BgL_offsetz00_4545)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1421 */
long BgL_modz00_4547;
BgL_modz00_4547 = 
(BgL_offsetz00_4546 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1421 */
long BgL_restz00_4549;
BgL_restz00_4549 = 
(BgL_offsetz00_4546 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1421 */

{ /* Llib/mpd.scm 1421 */
obj_t BgL_bucketz00_4551;
BgL_bucketz00_4551 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4541),BgL_modz00_4547); 
BgL_res3252z00_4575 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4551),BgL_restz00_4549); } } } } } } } } 
BgL_method1386z00_2401 = BgL_res3252z00_4575; } 
return 
PROCEDURE_ENTRY(BgL_method1386z00_2401)(BgL_method1386z00_2401, 
((obj_t)BgL_oz00_402), BgL_genrez00_403, BEOA);} } 

}



/* &mpd-database-getgenreartist */
obj_t BGl_z62mpdzd2databasezd2getgenreartistz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5310, obj_t BgL_oz00_5311, obj_t BgL_genrez00_5312)
{
{ /* Llib/mpd.scm 1421 */
{ /* Llib/mpd.scm 1421 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_10107;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5311, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1421 */
BgL_auxz00_10107 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5311)
; }  else 
{ 
obj_t BgL_auxz00_10111;
BgL_auxz00_10111 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)55778)), BGl_string3543z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5311); 
FAILURE(BgL_auxz00_10111,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getgenreartistz00zz__multimediazd2mpdzd2(BgL_auxz00_10107, BgL_genrez00_5312);} } 

}



/* mpd-database-getartistalbum */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_404, obj_t BgL_artistz00_405)
{
{ /* Llib/mpd.scm 1431 */
{ /* Llib/mpd.scm 1431 */
obj_t BgL_method1388z00_2402;
{ /* Llib/mpd.scm 1431 */
obj_t BgL_res3263z00_4612;
{ /* Llib/mpd.scm 1431 */
long BgL_objzd2classzd2numz00_4577;
{ /* Llib/mpd.scm 1431 */
long BgL_res3253z00_4580;
BgL_res3253z00_4580 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_404)); 
BgL_objzd2classzd2numz00_4577 = BgL_res3253z00_4580; } 
{ /* Llib/mpd.scm 1431 */
obj_t BgL_arg1759z00_4578;
BgL_arg1759z00_4578 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getartistalbumzd2envzd2zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1431 */
int BgL_offsetz00_4582;
BgL_offsetz00_4582 = 
(int)(BgL_objzd2classzd2numz00_4577); 
{ /* Llib/mpd.scm 1431 */
long BgL_offsetz00_4583;
BgL_offsetz00_4583 = 
(
(long)(BgL_offsetz00_4582)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1431 */
long BgL_modz00_4584;
BgL_modz00_4584 = 
(BgL_offsetz00_4583 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1431 */
long BgL_restz00_4586;
BgL_restz00_4586 = 
(BgL_offsetz00_4583 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1431 */

{ /* Llib/mpd.scm 1431 */
obj_t BgL_bucketz00_4588;
BgL_bucketz00_4588 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4578),BgL_modz00_4584); 
BgL_res3263z00_4612 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4588),BgL_restz00_4586); } } } } } } } } 
BgL_method1388z00_2402 = BgL_res3263z00_4612; } 
return 
PROCEDURE_ENTRY(BgL_method1388z00_2402)(BgL_method1388z00_2402, 
((obj_t)BgL_oz00_404), BgL_artistz00_405, BEOA);} } 

}



/* &mpd-database-getartistalbum */
obj_t BGl_z62mpdzd2databasezd2getartistalbumz62zz__multimediazd2mpdzd2(obj_t BgL_envz00_5313, obj_t BgL_oz00_5314, obj_t BgL_artistz00_5315)
{
{ /* Llib/mpd.scm 1431 */
{ /* Llib/mpd.scm 1431 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_10147;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5314, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1431 */
BgL_auxz00_10147 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5314)
; }  else 
{ 
obj_t BgL_auxz00_10151;
BgL_auxz00_10151 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)56226)), BGl_string3544z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5314); 
FAILURE(BgL_auxz00_10151,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getartistalbumz00zz__multimediazd2mpdzd2(BgL_auxz00_10147, BgL_artistz00_5315);} } 

}



/* mpd-database-get-album */
BGL_EXPORTED_DEF obj_t BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_mpdzd2databasezd2_bglt BgL_oz00_417, obj_t BgL_albumz00_418)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1517 */
obj_t BgL_method1394z00_2403;
{ /* Llib/mpd.scm 1517 */
obj_t BgL_res3274z00_4649;
{ /* Llib/mpd.scm 1517 */
long BgL_objzd2classzd2numz00_4614;
{ /* Llib/mpd.scm 1517 */
long BgL_res3264z00_4617;
BgL_res3264z00_4617 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_oz00_417)); 
BgL_objzd2classzd2numz00_4614 = BgL_res3264z00_4617; } 
{ /* Llib/mpd.scm 1517 */
obj_t BgL_arg1759z00_4615;
BgL_arg1759z00_4615 = 
PROCEDURE_REF(BGl_mpdzd2databasezd2getzd2albumzd2envz00zz__multimediazd2mpdzd2, 
(int)(((long)1))); 
{ /* Llib/mpd.scm 1517 */
int BgL_offsetz00_4619;
BgL_offsetz00_4619 = 
(int)(BgL_objzd2classzd2numz00_4614); 
{ /* Llib/mpd.scm 1517 */
long BgL_offsetz00_4620;
BgL_offsetz00_4620 = 
(
(long)(BgL_offsetz00_4619)-OBJECT_TYPE); 
{ /* Llib/mpd.scm 1517 */
long BgL_modz00_4621;
BgL_modz00_4621 = 
(BgL_offsetz00_4620 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/mpd.scm 1517 */
long BgL_restz00_4623;
BgL_restz00_4623 = 
(BgL_offsetz00_4620 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/mpd.scm 1517 */

{ /* Llib/mpd.scm 1517 */
obj_t BgL_bucketz00_4625;
BgL_bucketz00_4625 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_4615),BgL_modz00_4621); 
BgL_res3274z00_4649 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_4625),BgL_restz00_4623); } } } } } } } } 
BgL_method1394z00_2403 = BgL_res3274z00_4649; } 
return 
PROCEDURE_ENTRY(BgL_method1394z00_2403)(BgL_method1394z00_2403, 
((obj_t)BgL_oz00_417), BgL_albumz00_418, BEOA);} } 

}



/* &mpd-database-get-album */
obj_t BGl_z62mpdzd2databasezd2getzd2albumzb0zz__multimediazd2mpdzd2(obj_t BgL_envz00_5316, obj_t BgL_oz00_5317, obj_t BgL_albumz00_5318)
{
{ /* Llib/mpd.scm 1517 */
{ /* Llib/mpd.scm 1517 */
BgL_mpdzd2databasezd2_bglt BgL_auxz00_10187;
if(
BGl_isazf3zf3zz__objectz00(BgL_oz00_5317, BGl_mpdzd2databasezd2zz__multimediazd2mpdzd2))
{ /* Llib/mpd.scm 1517 */
BgL_auxz00_10187 = 
((BgL_mpdzd2databasezd2_bglt)BgL_oz00_5317)
; }  else 
{ 
obj_t BgL_auxz00_10191;
BgL_auxz00_10191 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string3366z00zz__multimediazd2mpdzd2, 
BINT(((long)59323)), BGl_string3545z00zz__multimediazd2mpdzd2, BGl_string3372z00zz__multimediazd2mpdzd2, BgL_oz00_5317); 
FAILURE(BgL_auxz00_10191,BFALSE,BFALSE);} 
return 
BGl_mpdzd2databasezd2getzd2albumzd2zz__multimediazd2mpdzd2(BgL_auxz00_10187, BgL_albumz00_5318);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__multimediazd2mpdzd2()
{
{ /* Llib/mpd.scm 15 */
BGl_modulezd2initializa7ationz75zz__multimediazd2musiczd2(((long)95358746), 
BSTRING_TO_STRING(BGl_string3546z00zz__multimediazd2mpdzd2)); 
return 
BGl_modulezd2initializa7ationz75zz__multimediazd2id3zd2(((long)299259981), 
BSTRING_TO_STRING(BGl_string3546z00zz__multimediazd2mpdzd2));} 

}

#ifdef __cplusplus
}
#endif
