/*===========================================================================*/
/*   (Llib/pgp_composition.scm)                                              */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -fno-reflection -unsafe -safee -copt -fPIC -copt -IPosix Llib/pgp_composition.scm -o objs/pgp_composition.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_pgpzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2packetzd2_bglt;

typedef struct BgL_pgpzd2sigzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
} *BgL_pgpzd2sigzd2packetz00_bglt;

typedef struct BgL_pgpzd2signaturezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_signaturez00;
   obj_t BgL_signedzd2packetzd2prefixz00;
   obj_t BgL_hashzd2trailerzd2;
   obj_t BgL_leftzd2hashzd2;
} *BgL_pgpzd2signaturezd2packetz00_bglt;

typedef struct BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_versionz00;
   obj_t BgL_signaturezd2typezd2;
   obj_t BgL_issuerz00;
   obj_t BgL_publiczd2keyzd2algoz00;
   obj_t BgL_hashzd2algozd2;
   bool_t BgL_containszd2nestedzd2sigzf3zf3;
} *BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt;

typedef struct BgL_pgpzd2keyzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   long BgL_versionz00;
   bool_t BgL_subkeyzf3zf3;
   obj_t BgL_algoz00;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_validzd2dayszd2;
   obj_t BgL_keyz00;
} *BgL_pgpzd2keyzd2packetz00_bglt;

typedef struct BgL_pgpzd2compressedzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_packetsz00;
} *BgL_pgpzd2compressedzd2packetz00_bglt;

typedef struct BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt;

typedef struct BgL_pgpzd2literalzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_formatz00;
   bool_t BgL_forzd2yourzd2eyeszd2onlyzf3z21;
   obj_t BgL_filezd2namezd2;
   obj_t BgL_creationzd2datezd2;
   obj_t BgL_dataz00;
} *BgL_pgpzd2literalzd2packetz00_bglt;

typedef struct BgL_pgpzd2idzd2packetz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_dataz00;
} *BgL_pgpzd2idzd2packetz00_bglt;

typedef struct BgL_signedzd2idzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_pgpzd2idzd2packetz00_bgl * BgL_idz00;
   obj_t BgL_sigsz00;
} *BgL_signedzd2idzd2_bglt;

typedef struct BgL_pgpzd2subkeyzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_pgpzd2keyzd2packetz00_bgl * BgL_keyzd2packetzd2;
   obj_t BgL_sigsz00;
   obj_t BgL_revocationzd2sigszd2;
   struct BgL_pgpzd2keyzd2_bgl * BgL_pgpzd2keyzd2;
} *BgL_pgpzd2subkeyzd2_bglt;

typedef struct BgL_pgpzd2compositionzd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2compositionzd2_bglt;

typedef struct BgL_pgpzd2keyzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_subkeysz00;
   obj_t BgL_userzd2idszd2;
} *BgL_pgpzd2keyzd2_bglt;

typedef struct BgL_pgpzd2messagezd2_bgl {
   header_t header;
   obj_t widening;
} *BgL_pgpzd2messagezd2_bglt;

typedef struct BgL_pgpzd2encryptedzd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_sessionzd2keyszd2;
   struct BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bgl * BgL_encryptedzd2datazd2;
} *BgL_pgpzd2encryptedzd2_bglt;

typedef struct BgL_pgpzd2signaturezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_msgz00;
   obj_t BgL_sigsz00;
} *BgL_pgpzd2signaturezd2_bglt;

typedef struct BgL_pgpzd2onezd2passzd2signaturezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_msgz00;
   obj_t BgL_sigsz00;
   obj_t BgL_onezd2passzd2sigsz00;
} *BgL_pgpzd2onezd2passzd2signaturezd2_bglt;

typedef struct BgL_pgpzd2literalzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_pgpzd2literalzd2packetz00_bgl * BgL_literalz00;
} *BgL_pgpzd2literalzd2_bglt;


static BgL_signedzd2idzd2_bglt BGl_z62lambda1922z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_signedzd2idzd2_bglt BGl_z62lambda1924z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32010ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
static BgL_pgpzd2idzd2packetz00_bglt BGl_z62lambda1930z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1931z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1935z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1936z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62encodezd2pgp1313zb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2subkeyzd2_bglt BGl_z62lambda1942z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2subkeyzd2_bglt BGl_z62lambda1944z62zz__openpgpzd2compositionzd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static obj_t BGl_armoredzd2pipezd2portz00zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT obj_t BGl_base64zd2encodezd2zz__base64z00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static BgL_pgpzd2keyzd2packetz00_bglt BGl_z62lambda1950z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1951z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1955z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1956z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
static obj_t BGl_z62lambda1960z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1961z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2keyzd2_bglt BGl_z62lambda1965z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62parsezd2packetszb0zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1966z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2_bglt BGl_parsezd2signaturezd2zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32030ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
static BgL_pgpzd2compositionzd2_bglt BGl_z62lambda1971z62zz__openpgpzd2compositionzd2(obj_t);
static BgL_pgpzd2keyzd2_bglt BGl_z62lambda1979z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2pgpzd2PGPzd2Key1316zb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2keyzd2_bglt BGl_z62lambda1981z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62lambda1987z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1988z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
extern obj_t BGl_base64zd2decodezd2pipezd2portzd2zz__openpgpzd2portzd2utilz00(obj_t);
static obj_t BGl_objectzd2initzd2zz__openpgpzd2compositionzd2();
static obj_t BGl_z62lambda1992z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda1993z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31973ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
static BgL_pgpzd2messagezd2_bglt BGl_z62lambda1998z62zz__openpgpzd2compositionzd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_decodezd2pgpzd2zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_appendzd221009zd2zz__openpgpzd2compositionzd2(obj_t, obj_t);
extern obj_t BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_methodzd2initzd2zz__openpgpzd2compositionzd2();
static bool_t BGl_subkeyzd2sigzf3ze70zc6zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62decodezd2pgpzb0zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_encodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt, obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2nativezd2pgpz62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_safezd2readzd2lineze70ze7zz__openpgpzd2compositionzd2(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2 = BUNSPEC;
extern obj_t BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t BGl_readzd2linezd2zz__r4_input_6_10_2z00(obj_t);
BGL_IMPORT long bgl_list_length(obj_t);
BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__openpgpzd2compositionzd2();
static BgL_pgpzd2literalzd2_bglt BGl_parsezd2literalzd2zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT obj_t BGl_readzd2stringzd2zz__r4_input_6_10_2z00(obj_t);
BGL_IMPORT obj_t c_substring(obj_t, long, long);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
static obj_t BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt, obj_t);
BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
BGL_IMPORT bool_t BGl_stringzd2prefixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31907ze3ze5zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62encodezd2pgpzb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31909ze3ze5zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza31926ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT bool_t BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_encodezd2nativezd2pgpz00zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31946ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62encodezd2pgpzd2PGPzd2Encry1322zb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__openpgpzd2compositionzd2();
BGL_IMPORT obj_t bgl_reverse(obj_t);
static obj_t BGl_genericzd2initzd2zz__openpgpzd2compositionzd2();
BGL_IMPORT obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62zc3z04anonymousza31983ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
extern obj_t BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2;
BGL_IMPORT obj_t BGl_unreadzd2stringz12zc0zz__r4_input_6_10_2z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readzd2charzd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_decodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT obj_t BGl_crczd2stringzd2zz__crcz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_close_input_port(obj_t);
BGL_IMPORT obj_t BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(obj_t);
static BgL_pgpzd2encryptedzd2_bglt BGl_z62lambda2006z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2encryptedzd2_bglt BGl_z62lambda2008z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_createzd2chksum64zd2zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62lambda2014z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2015z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_close_output_port(obj_t);
static BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BGl_z62lambda2019z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62zc3z04anonymousza32065ze3ze5zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT bool_t BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
static obj_t BGl_z62lambda2020z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2_bglt BGl_z62lambda2026z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2signaturezd2_bglt BGl_z62lambda2028z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62lambda2034z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2035z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2039z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2040z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2onezd2passzd2signaturezd2_bglt BGl_z62lambda2046z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t, obj_t);
static BgL_pgpzd2onezd2passzd2signaturezd2_bglt BGl_z62lambda2048z62zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_parsezd2keyszd2zz__openpgpzd2compositionzd2(obj_t);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2compositionzd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2portzd2utilz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2encodezd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2decodezd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2packetszd2(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2utilzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__crcz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__base64z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
static obj_t BGl_z62lambda2054z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2055z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_parsezd2onezd2passzd2signaturezd2zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_z62encodezd2pgpzd2PGPzd2Signa1320zb0zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static BgL_pgpzd2literalzd2_bglt BGl_z62lambda2061z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static BgL_pgpzd2literalzd2_bglt BGl_z62lambda2063z62zz__openpgpzd2compositionzd2(obj_t);
static BgL_pgpzd2literalzd2packetz00_bglt BGl_z62lambda2069z62zz__openpgpzd2compositionzd2(obj_t, obj_t);
static obj_t BGl_z62lambda2070z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static bool_t BGl_revocationzd2signaturezf3ze70zc6zz__openpgpzd2compositionzd2(obj_t);
extern obj_t BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(BgL_pgpzd2packetzd2_bglt, obj_t);
static obj_t BGl_cnstzd2initzd2zz__openpgpzd2compositionzd2();
BGL_IMPORT obj_t BGl_stringzd2indexzd2zz__r4_strings_6_7z00(obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__openpgpzd2compositionzd2();
extern obj_t BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_importedzd2moduleszd2initz00zz__openpgpzd2compositionzd2();
BGL_EXPORTED_DEF obj_t BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2 = BUNSPEC;
BGL_IMPORT obj_t BGl_objectz00zz__objectz00;
extern obj_t BGl_decodezd2packetszd2zz__openpgpzd2decodezd2(obj_t);
extern obj_t BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2;
static obj_t BGl_parsezd2encryptedzd2messagez00zz__openpgpzd2compositionzd2(obj_t);
static obj_t BGl_parsezd2keyzd2zz__openpgpzd2compositionzd2(obj_t, obj_t);
extern obj_t BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2;
extern obj_t BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2;
static obj_t BGl_z62encodezd2pgpzd2PGPzd2Onezd2P1318z62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62encodezd2armoredzd2pgpz62zz__openpgpzd2compositionzd2(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 39 ] ;


DEFINE_STRING( BGl_string2300z00zz__openpgpzd2compositionzd2, BgL_bgl_string2300za700za7za7_2382za7, "-----BEGIN", 10 );
DEFINE_STATIC_BGL_GENERIC( BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72383za7, BGl_z62encodezd2pgpzb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2301z00zz__openpgpzd2compositionzd2, BgL_bgl_string2301za700za7za7_2384za7, "-----", 5 );
DEFINE_STRING( BGl_string2302z00zz__openpgpzd2compositionzd2, BgL_bgl_string2302za700za7za7_2385za7, "not an armored file", 19 );
DEFINE_STRING( BGl_string2303z00zz__openpgpzd2compositionzd2, BgL_bgl_string2303za700za7za7_2386za7, "unexpected end of file", 22 );
DEFINE_STRING( BGl_string2304z00zz__openpgpzd2compositionzd2, BgL_bgl_string2304za700za7za7_2387za7, "&decode-pgp", 11 );
DEFINE_STRING( BGl_string2305z00zz__openpgpzd2compositionzd2, BgL_bgl_string2305za700za7za7_2388za7, "input-port", 10 );
DEFINE_STRING( BGl_string2306z00zz__openpgpzd2compositionzd2, BgL_bgl_string2306za700za7za7_2389za7, "&encode-native-pgp", 18 );
DEFINE_STRING( BGl_string2307z00zz__openpgpzd2compositionzd2, BgL_bgl_string2307za700za7za7_2390za7, "PGP-Composition", 15 );
DEFINE_STRING( BGl_string2308z00zz__openpgpzd2compositionzd2, BgL_bgl_string2308za700za7za7_2391za7, "output-port", 11 );
DEFINE_STRING( BGl_string2309z00zz__openpgpzd2compositionzd2, BgL_bgl_string2309za700za7za7_2392za7, "&encode-armored-pgp", 19 );
DEFINE_STRING( BGl_string2310z00zz__openpgpzd2compositionzd2, BgL_bgl_string2310za700za7za7_2393za7, "bstring", 7 );
DEFINE_STRING( BGl_string2311z00zz__openpgpzd2compositionzd2, BgL_bgl_string2311za700za7za7_2394za7, "-----BEGIN ", 11 );
DEFINE_STRING( BGl_string2312z00zz__openpgpzd2compositionzd2, BgL_bgl_string2312za700za7za7_2395za7, ": ", 2 );
DEFINE_STRING( BGl_string2313z00zz__openpgpzd2compositionzd2, BgL_bgl_string2313za700za7za7_2396za7, "=", 1 );
DEFINE_STRING( BGl_string2314z00zz__openpgpzd2compositionzd2, BgL_bgl_string2314za700za7za7_2397za7, "-----END ", 9 );
DEFINE_STRING( BGl_string2369z00zz__openpgpzd2compositionzd2, BgL_bgl_string2369za700za7za7_2398za7, "encode-pgp1313", 14 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_decodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BgL_bgl_za762decodeza7d2pgpza72399za7, BGl_z62decodezd2pgpzb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2370z00zz__openpgpzd2compositionzd2, BgL_bgl_string2370za700za7za7_2400za7, "Not yet implemented", 19 );
DEFINE_STRING( BGl_string2371z00zz__openpgpzd2compositionzd2, BgL_bgl_string2371za700za7za7_2401za7, "&encode-pgp", 11 );
DEFINE_STRING( BGl_string2373z00zz__openpgpzd2compositionzd2, BgL_bgl_string2373za700za7za7_2402za7, "encode-pgp", 10 );
DEFINE_STRING( BGl_string2377z00zz__openpgpzd2compositionzd2, BgL_bgl_string2377za700za7za7_2403za7, "__openpgp-composition", 21 );
DEFINE_STRING( BGl_string2378z00zz__openpgpzd2compositionzd2, BgL_bgl_string2378za700za7za7_2404za7, "encode-pgp PGP-Literal literal PGP-One-Pass-Signature one-pass-sigs PGP-Signature obj msg PGP-Encrypted encrypted-data session-keys PGP-Message PGP-Key user-ids pair subkeys PGP-Composition PGP-Subkey pgp-key revocation-sigs key-packet __openpgp-composition Signed-ID pair-nil sigs id radix-64-24 parse-literal parse-signature parse-encrypted-message subkey-binding key-revocation parse-key positive-certif casual-certif persona-certif generic-certif parse-subkey parse-packets ", 478 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encodezd2armoredzd2pgpzd2envzd2zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2armo2405z00, BGl_z62encodezd2armoredzd2pgpz62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 4 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_encodezd2nativezd2pgpzd2envzd2zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2nati2406z00, BGl_z62encodezd2nativezd2pgpz62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_parsezd2packetszd2envz00zz__openpgpzd2compositionzd2, BgL_bgl_za762parseza7d2packe2407z00, BGl_z62parsezd2packetszb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2315z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1931za7622408z00, BGl_z62lambda1931z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2316z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1930za7622409z00, BGl_z62lambda1930z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2317z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1936za7622410z00, BGl_z62lambda1936z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2318z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1935za7622411z00, BGl_z62lambda1935z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2319z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2412za7, BGl_z62zc3z04anonymousza31926ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2320z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1924za7622413z00, BGl_z62lambda1924z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2321z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1922za7622414z00, BGl_z62lambda1922z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2322z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1951za7622415z00, BGl_z62lambda1951z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2323z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1950za7622416z00, BGl_z62lambda1950z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2324z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1956za7622417z00, BGl_z62lambda1956z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2325z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1955za7622418z00, BGl_z62lambda1955z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2326z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1961za7622419z00, BGl_z62lambda1961z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2327z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1960za7622420z00, BGl_z62lambda1960z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2328z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1966za7622421z00, BGl_z62lambda1966z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2329z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1965za7622422z00, BGl_z62lambda1965z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2330z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2423za7, BGl_z62zc3z04anonymousza31946ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2331z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1944za7622424z00, BGl_z62lambda1944z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2332z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1942za7622425z00, BGl_z62lambda1942z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2333z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2426za7, BGl_z62zc3z04anonymousza31973ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2334z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1971za7622427z00, BGl_z62lambda1971z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2335z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1988za7622428z00, BGl_z62lambda1988z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2336z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1987za7622429z00, BGl_z62lambda1987z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2337z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1993za7622430z00, BGl_z62lambda1993z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2338z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1992za7622431z00, BGl_z62lambda1992z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2339z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2432za7, BGl_z62zc3z04anonymousza31983ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2340z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1981za7622433z00, BGl_z62lambda1981z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2341z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1979za7622434z00, BGl_z62lambda1979z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2342z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2435za7, BGl_z62zc3z04anonymousza32000ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2343z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda1998za7622436z00, BGl_z62lambda1998z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2344z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2015za7622437z00, BGl_z62lambda2015z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2345z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2014za7622438z00, BGl_z62lambda2014z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2346z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2020za7622439z00, BGl_z62lambda2020z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2347z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2019za7622440z00, BGl_z62lambda2019z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2348z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2441za7, BGl_z62zc3z04anonymousza32010ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2349z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2008za7622442z00, BGl_z62lambda2008z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2350z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2006za7622443z00, BGl_z62lambda2006z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2351z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2035za7622444z00, BGl_z62lambda2035z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2352z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2034za7622445z00, BGl_z62lambda2034z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2353z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2040za7622446z00, BGl_z62lambda2040z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2354z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2039za7622447z00, BGl_z62lambda2039z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2355z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2448za7, BGl_z62zc3z04anonymousza32030ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2356z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2028za7622449z00, BGl_z62lambda2028z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2357z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2026za7622450z00, BGl_z62lambda2026z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2358z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2055za7622451z00, BGl_z62lambda2055z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2359z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2054za7622452z00, BGl_z62lambda2054z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2283z00zz__openpgpzd2compositionzd2, BgL_bgl_string2283za700za7za7_2453za7, "no packet decoded", 17 );
DEFINE_STRING( BGl_string2284z00zz__openpgpzd2compositionzd2, BgL_bgl_string2284za700za7za7_2454za7, "discarding packets", 18 );
DEFINE_STRING( BGl_string2285z00zz__openpgpzd2compositionzd2, BgL_bgl_string2285za700za7za7_2455za7, "could not parse pgp-message", 27 );
DEFINE_STRING( BGl_string2286z00zz__openpgpzd2compositionzd2, BgL_bgl_string2286za700za7za7_2456za7, "/builddir/build/BUILD/bigloo-4.4a/api/openpgp/src/Llib/pgp_composition.scm", 74 );
DEFINE_STRING( BGl_string2287z00zz__openpgpzd2compositionzd2, BgL_bgl_string2287za700za7za7_2457za7, "&parse-packets", 14 );
DEFINE_STRING( BGl_string2288z00zz__openpgpzd2compositionzd2, BgL_bgl_string2288za700za7za7_2458za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string2289z00zz__openpgpzd2compositionzd2, BgL_bgl_string2289za700za7za7_2459za7, "Subkey not followed by subkey-binding Signature", 47 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2360z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2460za7, BGl_z62zc3z04anonymousza32050ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2361z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2048za7622461z00, BGl_z62lambda2048z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2362z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2046za7622462z00, BGl_z62lambda2046z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2363z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2070za7622463z00, BGl_z62lambda2070z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2364z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2069za7622464z00, BGl_z62lambda2069z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2365z00zz__openpgpzd2compositionzd2, BgL_bgl_za762za7c3za704anonymo2465za7, BGl_z62zc3z04anonymousza32065ze3ze5zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2366z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2063za7622466z00, BGl_z62lambda2063z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2367z00zz__openpgpzd2compositionzd2, BgL_bgl_za762lambda2061za7622467z00, BGl_z62lambda2061z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2290z00zz__openpgpzd2compositionzd2, BgL_bgl_string2290za700za7za7_2468za7, "At least one user ID is required", 32 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2368z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgp12469z00, BGl_z62encodezd2pgp1313zb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2291z00zz__openpgpzd2compositionzd2, BgL_bgl_string2291za700za7za7_2470za7, "missing encrypted data packet", 29 );
DEFINE_STRING( BGl_string2292z00zz__openpgpzd2compositionzd2, BgL_bgl_string2292za700za7za7_2471za7, "Packet after encrypted data discarded", 37 );
DEFINE_STRING( BGl_string2293z00zz__openpgpzd2compositionzd2, BgL_bgl_string2293za700za7za7_2472za7, "unexpected packet encountered and discarded", 43 );
DEFINE_STRING( BGl_string2294z00zz__openpgpzd2compositionzd2, BgL_bgl_string2294za700za7za7_2473za7, "discarding packets after signature message", 42 );
DEFINE_STRING( BGl_string2295z00zz__openpgpzd2compositionzd2, BgL_bgl_string2295za700za7za7_2474za7, "bad one-pass signature", 22 );
DEFINE_STRING( BGl_string2296z00zz__openpgpzd2compositionzd2, BgL_bgl_string2296za700za7za7_2475za7, "bad one-pass-signature", 22 );
DEFINE_STRING( BGl_string2297z00zz__openpgpzd2compositionzd2, BgL_bgl_string2297za700za7za7_2476za7, "bad Literal", 11 );
DEFINE_STRING( BGl_string2298z00zz__openpgpzd2compositionzd2, BgL_bgl_string2298za700za7za7_2477za7, "read-armored", 12 );
DEFINE_STRING( BGl_string2299z00zz__openpgpzd2compositionzd2, BgL_bgl_string2299za700za7za7_2478za7, "bad checksum", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2372z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72479za7, BGl_z62encodezd2pgpzd2PGPzd2Key1316zb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2374z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72480za7, BGl_z62encodezd2pgpzd2PGPzd2Onezd2P1318z62zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2375z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72481za7, BGl_z62encodezd2pgpzd2PGPzd2Signa1320zb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2376z00zz__openpgpzd2compositionzd2, BgL_bgl_za762encodeza7d2pgpza72482za7, BGl_z62encodezd2pgpzd2PGPzd2Encry1322zb0zz__openpgpzd2compositionzd2, 0L, BUNSPEC, 2 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2) );
ADD_ROOT( (void *)(&BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__openpgpzd2compositionzd2(long BgL_checksumz00_2065, char * BgL_fromz00_2066)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__openpgpzd2compositionzd2))
{ 
BGl_requirezd2initializa7ationz75zz__openpgpzd2compositionzd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__openpgpzd2compositionzd2(); 
BGl_libraryzd2moduleszd2initz00zz__openpgpzd2compositionzd2(); 
BGl_cnstzd2initzd2zz__openpgpzd2compositionzd2(); 
BGl_importedzd2moduleszd2initz00zz__openpgpzd2compositionzd2(); 
BGl_objectzd2initzd2zz__openpgpzd2compositionzd2(); 
BGl_genericzd2initzd2zz__openpgpzd2compositionzd2(); 
BGl_methodzd2initzd2zz__openpgpzd2compositionzd2(); 
return 
BGl_toplevelzd2initzd2zz__openpgpzd2compositionzd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__base64z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__crcz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__openpgp-composition"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "__openpgp-composition"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_cportz00_1846;
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_stringz00_1854;
BgL_stringz00_1854 = BGl_string2378z00zz__openpgpzd2compositionzd2; 
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_startz00_1855;
BgL_startz00_1855 = 
BINT(((long)0)); 
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_endz00_1856;
BgL_endz00_1856 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_1854))); 
{ /* Llib/pgp_composition.scm 15 */

BgL_cportz00_1846 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_1854, BgL_startz00_1855, BgL_endz00_1856); } } } } 
{ 
long BgL_iz00_1847;
BgL_iz00_1847 = ((long)38); 
BgL_loopz00_1848:
if(
(BgL_iz00_1847==((long)-1)))
{ /* Llib/pgp_composition.scm 15 */
return BUNSPEC;}  else 
{ /* Llib/pgp_composition.scm 15 */
{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_arg2380z00_1850;
{ /* Llib/pgp_composition.scm 15 */

{ /* Llib/pgp_composition.scm 15 */
obj_t BgL_locationz00_1852;
BgL_locationz00_1852 = 
BBOOL(((bool_t)0)); 
{ /* Llib/pgp_composition.scm 15 */

BgL_arg2380z00_1850 = 
BGl_readz00zz__readerz00(BgL_cportz00_1846, BgL_locationz00_1852); } } } 
{ /* Llib/pgp_composition.scm 15 */
int BgL_tmpz00_2104;
BgL_tmpz00_2104 = 
(int)(BgL_iz00_1847); 
CNST_TABLE_SET(BgL_tmpz00_2104, BgL_arg2380z00_1850); } } 
{ /* Llib/pgp_composition.scm 15 */
int BgL_auxz00_1853;
BgL_auxz00_1853 = 
(int)(
(BgL_iz00_1847-((long)1))); 
{ 
long BgL_iz00_2109;
BgL_iz00_2109 = 
(long)(BgL_auxz00_1853); 
BgL_iz00_1847 = BgL_iz00_2109; 
goto BgL_loopz00_1848;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
return BUNSPEC;} 

}



/* append-21009 */
obj_t BGl_appendzd221009zd2zz__openpgpzd2compositionzd2(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_56;
BgL_headz00_56 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_57;obj_t BgL_tailz00_58;
BgL_prevz00_57 = BgL_headz00_56; 
BgL_tailz00_58 = BgL_l1z00_1; 
BgL_loopz00_59:
if(
PAIRP(BgL_tailz00_58))
{ 
obj_t BgL_newzd2prevzd2_61;
BgL_newzd2prevzd2_61 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_58), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_57, BgL_newzd2prevzd2_61); 
{ 
obj_t BgL_tailz00_2119;obj_t BgL_prevz00_2118;
BgL_prevz00_2118 = BgL_newzd2prevzd2_61; 
BgL_tailz00_2119 = 
CDR(BgL_tailz00_58); 
BgL_tailz00_58 = BgL_tailz00_2119; 
BgL_prevz00_57 = BgL_prevz00_2118; 
goto BgL_loopz00_59;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_56);} } } 

}



/* parse-packets */
BGL_EXPORTED_DEF obj_t BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_4)
{
{ /* Llib/pgp_composition.scm 71 */
BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2:
if(
NULLP(BgL_packetsz00_4))
{ /* Llib/pgp_composition.scm 74 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2283z00zz__openpgpzd2compositionzd2, BFALSE);}  else 
{ /* Llib/pgp_composition.scm 78 */
bool_t BgL_test2487z00_2126;
{ /* Llib/pgp_composition.scm 78 */
bool_t BgL_test2488z00_2127;
{ /* Llib/pgp_composition.scm 78 */
obj_t BgL_arg1553z00_101;
BgL_arg1553z00_101 = 
CAR(BgL_packetsz00_4); 
BgL_test2488z00_2127 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1553z00_101, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2488z00_2127)
{ /* Llib/pgp_composition.scm 78 */
if(
(((BgL_pgpzd2keyzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2keyzd2packetz00_bglt)
CAR(BgL_packetsz00_4))))->BgL_subkeyzf3zf3))
{ /* Llib/pgp_composition.scm 80 */
BgL_test2487z00_2126 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 80 */
BgL_test2487z00_2126 = ((bool_t)1)
; } }  else 
{ /* Llib/pgp_composition.scm 78 */
BgL_test2487z00_2126 = ((bool_t)0)
; } } 
if(BgL_test2487z00_2126)
{ /* Llib/pgp_composition.scm 78 */
return 
BGl_parsezd2keyszd2zz__openpgpzd2compositionzd2(BgL_packetsz00_4);}  else 
{ /* Llib/pgp_composition.scm 82 */
bool_t BgL_test2490z00_2135;
{ /* Llib/pgp_composition.scm 82 */
bool_t BgL_test2491z00_2136;
{ /* Llib/pgp_composition.scm 82 */
obj_t BgL_arg1552z00_97;
BgL_arg1552z00_97 = 
CAR(BgL_packetsz00_4); 
BgL_test2491z00_2136 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1552z00_97, BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2); } 
if(BgL_test2491z00_2136)
{ /* Llib/pgp_composition.scm 82 */
BgL_test2490z00_2135 = ((bool_t)1)
; }  else 
{ /* Llib/pgp_composition.scm 83 */
obj_t BgL_arg1550z00_96;
BgL_arg1550z00_96 = 
CAR(BgL_packetsz00_4); 
BgL_test2490z00_2135 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1550z00_96, BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); } } 
if(BgL_test2490z00_2135)
{ /* Llib/pgp_composition.scm 82 */
return 
BGl_parsezd2encryptedzd2messagez00zz__openpgpzd2compositionzd2(BgL_packetsz00_4);}  else 
{ /* Llib/pgp_composition.scm 85 */
bool_t BgL_test2492z00_2142;
{ /* Llib/pgp_composition.scm 85 */
obj_t BgL_arg1549z00_94;
BgL_arg1549z00_94 = 
CAR(BgL_packetsz00_4); 
BgL_test2492z00_2142 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1549z00_94, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2492z00_2142)
{ /* Llib/pgp_composition.scm 85 */
return 
((obj_t)
BGl_parsezd2signaturezd2zz__openpgpzd2compositionzd2(BgL_packetsz00_4));}  else 
{ /* Llib/pgp_composition.scm 87 */
bool_t BgL_test2493z00_2147;
{ /* Llib/pgp_composition.scm 87 */
obj_t BgL_arg1542z00_93;
BgL_arg1542z00_93 = 
CAR(BgL_packetsz00_4); 
BgL_test2493z00_2147 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1542z00_93, BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2493z00_2147)
{ /* Llib/pgp_composition.scm 87 */
return 
BGl_parsezd2onezd2passzd2signaturezd2zz__openpgpzd2compositionzd2(BgL_packetsz00_4);}  else 
{ /* Llib/pgp_composition.scm 89 */
bool_t BgL_test2494z00_2151;
{ /* Llib/pgp_composition.scm 89 */
obj_t BgL_arg1541z00_92;
BgL_arg1541z00_92 = 
CAR(BgL_packetsz00_4); 
BgL_test2494z00_2151 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1541z00_92, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2494z00_2151)
{ /* Llib/pgp_composition.scm 89 */
return 
((obj_t)
BGl_parsezd2literalzd2zz__openpgpzd2compositionzd2(BgL_packetsz00_4));}  else 
{ /* Llib/pgp_composition.scm 91 */
bool_t BgL_test2495z00_2156;
{ /* Llib/pgp_composition.scm 91 */
obj_t BgL_arg1534z00_91;
BgL_arg1534z00_91 = 
CAR(BgL_packetsz00_4); 
BgL_test2495z00_2156 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1534z00_91, BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2495z00_2156)
{ /* Llib/pgp_composition.scm 91 */
if(
NULLP(
CDR(BgL_packetsz00_4)))
{ /* Llib/pgp_composition.scm 93 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 94 */
obj_t BgL_list1524z00_87;
BgL_list1524z00_87 = 
MAKE_YOUNG_PAIR(BGl_string2284z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1524z00_87); } 
{ /* Llib/pgp_composition.scm 95 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_i1138z00_89;
BgL_i1138z00_89 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)
CAR(BgL_packetsz00_4)); 
{ 
obj_t BgL_packetsz00_2166;
BgL_packetsz00_2166 = 
(((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(BgL_i1138z00_89))->BgL_packetsz00); 
BgL_packetsz00_4 = BgL_packetsz00_2166; 
goto BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2;} } }  else 
{ /* Llib/pgp_composition.scm 91 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2285z00zz__openpgpzd2compositionzd2, BgL_packetsz00_4);} } } } } } } } 

}



/* &parse-packets */
obj_t BGl_z62parsezd2packetszb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1603, obj_t BgL_packetsz00_1604)
{
{ /* Llib/pgp_composition.scm 71 */
{ /* Llib/pgp_composition.scm 74 */
obj_t BgL_auxz00_2170;
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_packetsz00_1604))
{ /* Llib/pgp_composition.scm 74 */
BgL_auxz00_2170 = BgL_packetsz00_1604
; }  else 
{ 
obj_t BgL_auxz00_2173;
BgL_auxz00_2173 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)3527)), BGl_string2287z00zz__openpgpzd2compositionzd2, BGl_string2288z00zz__openpgpzd2compositionzd2, BgL_packetsz00_1604); 
FAILURE(BgL_auxz00_2173,BFALSE,BFALSE);} 
return 
BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(BgL_auxz00_2170);} } 

}



/* parse-keys */
obj_t BGl_parsezd2keyszd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_5)
{
{ /* Llib/pgp_composition.scm 107 */
{ 
obj_t BgL_packetsz00_1125;obj_t BgL_keysz00_1126;obj_t BgL_userzd2idszd2_1127;
BgL_packetsz00_1125 = BgL_packetsz00_5; 
BgL_keysz00_1126 = BNIL; 
BgL_userzd2idszd2_1127 = BNIL; 
BgL_loopz00_1124:
if(
NULLP(BgL_packetsz00_1125))
{ /* Llib/pgp_composition.scm 112 */
return BgL_keysz00_1126;}  else 
{ /* Llib/pgp_composition.scm 114 */
obj_t BgL_keyz00_1135;
BgL_keyz00_1135 = 
BGl_parsezd2keyzd2zz__openpgpzd2compositionzd2(BgL_packetsz00_1125, BgL_userzd2idszd2_1127); 
{ /* Llib/pgp_composition.scm 116 */
obj_t BgL_remainingzd2packetszd2_1136;obj_t BgL_nuserzd2idszd2_1137;
{ /* Llib/pgp_composition.scm 116 */
int BgL_tmpz00_2181;
BgL_tmpz00_2181 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_1136 = 
BGL_MVALUES_VAL(BgL_tmpz00_2181); } 
{ /* Llib/pgp_composition.scm 116 */
int BgL_tmpz00_2184;
BgL_tmpz00_2184 = 
(int)(((long)2)); 
BgL_nuserzd2idszd2_1137 = 
BGL_MVALUES_VAL(BgL_tmpz00_2184); } 
{ 
obj_t BgL_userzd2idszd2_2190;obj_t BgL_keysz00_2188;obj_t BgL_packetsz00_2187;
BgL_packetsz00_2187 = BgL_remainingzd2packetszd2_1136; 
BgL_keysz00_2188 = 
BGl_appendzd221009zd2zz__openpgpzd2compositionzd2(BgL_keyz00_1135, BgL_keysz00_1126); 
BgL_userzd2idszd2_2190 = 
BGl_appendzd221009zd2zz__openpgpzd2compositionzd2(BgL_nuserzd2idszd2_1137, BgL_userzd2idszd2_1127); 
BgL_userzd2idszd2_1127 = BgL_userzd2idszd2_2190; 
BgL_keysz00_1126 = BgL_keysz00_2188; 
BgL_packetsz00_1125 = BgL_packetsz00_2187; 
goto BgL_loopz00_1124;} } } } } 

}



/* parse-key */
obj_t BGl_parsezd2keyzd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_6, obj_t BgL_userzd2idszd2_7)
{
{ /* Llib/pgp_composition.scm 123 */
{ 
obj_t BgL_packetsz00_162;obj_t BgL_packetsz00_181;obj_t BgL_packetsz00_214;obj_t BgL_packetsz00_238;
{ /* Llib/pgp_composition.scm 220 */
obj_t BgL_mainzd2keyzd2packetz00_121;
BgL_mainzd2keyzd2packetz00_121 = 
CAR(
((obj_t)BgL_packetsz00_6)); 
{ /* Llib/pgp_composition.scm 221 */
obj_t BgL_revocationzd2sigszd2_122;
{ /* Llib/pgp_composition.scm 222 */
obj_t BgL_arg1599z00_156;
BgL_arg1599z00_156 = 
CDR(
((obj_t)BgL_packetsz00_6)); 
BgL_packetsz00_162 = BgL_arg1599z00_156; 
{ 
obj_t BgL_packetsz00_166;obj_t BgL_revocationsz00_167;
BgL_packetsz00_166 = BgL_packetsz00_162; 
BgL_revocationsz00_167 = BNIL; 
BgL_zc3z04anonymousza31603ze3z87_168:
if(
NULLP(BgL_packetsz00_166))
{ /* Llib/pgp_composition.scm 135 */
obj_t BgL_val0_1225z00_170;
BgL_val0_1225z00_170 = 
bgl_reverse_bang(BgL_revocationsz00_167); 
{ /* Llib/pgp_composition.scm 135 */
int BgL_res2141z00_1142;
{ /* Llib/pgp_composition.scm 135 */
int BgL_tmpz00_2199;
BgL_tmpz00_2199 = 
(int)(((long)2)); 
BgL_res2141z00_1142 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2199); } BgL_res2141z00_1142; } 
{ /* Llib/pgp_composition.scm 135 */
int BgL_tmpz00_2202;
BgL_tmpz00_2202 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2202, BNIL); } 
BgL_revocationzd2sigszd2_122 = BgL_val0_1225z00_170; }  else 
{ /* Llib/pgp_composition.scm 134 */
if(
BGl_revocationzd2signaturezf3ze70zc6zz__openpgpzd2compositionzd2(
CAR(
((obj_t)BgL_packetsz00_166))))
{ /* Llib/pgp_composition.scm 137 */
obj_t BgL_arg1627z00_174;obj_t BgL_arg1632z00_175;
BgL_arg1627z00_174 = 
CDR(
((obj_t)BgL_packetsz00_166)); 
{ /* Llib/pgp_composition.scm 138 */
obj_t BgL_arg1634z00_176;
BgL_arg1634z00_176 = 
CAR(
((obj_t)BgL_packetsz00_166)); 
BgL_arg1632z00_175 = 
MAKE_YOUNG_PAIR(BgL_arg1634z00_176, BgL_revocationsz00_167); } 
{ 
obj_t BgL_revocationsz00_2215;obj_t BgL_packetsz00_2214;
BgL_packetsz00_2214 = BgL_arg1627z00_174; 
BgL_revocationsz00_2215 = BgL_arg1632z00_175; 
BgL_revocationsz00_167 = BgL_revocationsz00_2215; 
BgL_packetsz00_166 = BgL_packetsz00_2214; 
goto BgL_zc3z04anonymousza31603ze3z87_168;} }  else 
{ /* Llib/pgp_composition.scm 140 */
obj_t BgL_val0_1227z00_177;
BgL_val0_1227z00_177 = 
bgl_reverse_bang(BgL_revocationsz00_167); 
{ /* Llib/pgp_composition.scm 140 */
int BgL_res2142z00_1146;
{ /* Llib/pgp_composition.scm 140 */
int BgL_tmpz00_2217;
BgL_tmpz00_2217 = 
(int)(((long)2)); 
BgL_res2142z00_1146 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2217); } BgL_res2142z00_1146; } 
{ /* Llib/pgp_composition.scm 140 */
int BgL_tmpz00_2220;
BgL_tmpz00_2220 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2220, BgL_packetsz00_166); } 
BgL_revocationzd2sigszd2_122 = BgL_val0_1227z00_177; } } } } 
{ /* Llib/pgp_composition.scm 223 */
obj_t BgL_remainingzd2packetszd2_123;
{ /* Llib/pgp_composition.scm 223 */
int BgL_tmpz00_2223;
BgL_tmpz00_2223 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_123 = 
BGL_MVALUES_VAL(BgL_tmpz00_2223); } 
{ /* Llib/pgp_composition.scm 223 */
obj_t BgL_nuserzd2idszd2_124;
BgL_packetsz00_214 = BgL_remainingzd2packetszd2_123; 
{ 
obj_t BgL_packetsz00_218;obj_t BgL_userzd2idszd2_219;
BgL_packetsz00_218 = BgL_packetsz00_214; 
BgL_userzd2idszd2_219 = BNIL; 
BgL_zc3z04anonymousza31662ze3z87_220:
if(
NULLP(BgL_packetsz00_218))
{ /* Llib/pgp_composition.scm 167 */
obj_t BgL_val0_1233z00_222;
BgL_val0_1233z00_222 = 
bgl_reverse_bang(BgL_userzd2idszd2_219); 
{ /* Llib/pgp_composition.scm 167 */
int BgL_res2147z00_1154;
{ /* Llib/pgp_composition.scm 167 */
int BgL_tmpz00_2229;
BgL_tmpz00_2229 = 
(int)(((long)2)); 
BgL_res2147z00_1154 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2229); } BgL_res2147z00_1154; } 
{ /* Llib/pgp_composition.scm 167 */
int BgL_tmpz00_2232;
BgL_tmpz00_2232 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2232, BNIL); } 
BgL_nuserzd2idszd2_124 = BgL_val0_1233z00_222; }  else 
{ /* Llib/pgp_composition.scm 168 */
bool_t BgL_test2502z00_2235;
{ /* Llib/pgp_composition.scm 168 */
obj_t BgL_arg1682z00_236;
BgL_arg1682z00_236 = 
CAR(
((obj_t)BgL_packetsz00_218)); 
BgL_test2502z00_2235 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1682z00_236, BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2502z00_2235)
{ /* Llib/pgp_composition.scm 170 */
obj_t BgL_sigsz00_226;
{ /* Llib/pgp_composition.scm 171 */
obj_t BgL_arg1681z00_233;
BgL_arg1681z00_233 = 
CDR(
((obj_t)BgL_packetsz00_218)); 
BgL_packetsz00_181 = BgL_arg1681z00_233; 
{ 
obj_t BgL_pktz00_201;
{ 
obj_t BgL_packetsz00_186;obj_t BgL_sigsz00_187;
BgL_packetsz00_186 = BgL_packetsz00_181; 
BgL_sigsz00_187 = BNIL; 
BgL_zc3z04anonymousza31637ze3z87_188:
if(
NULLP(BgL_packetsz00_186))
{ /* Llib/pgp_composition.scm 154 */
obj_t BgL_val0_1229z00_190;
BgL_val0_1229z00_190 = 
bgl_reverse_bang(BgL_sigsz00_187); 
{ /* Llib/pgp_composition.scm 154 */
int BgL_res2144z00_1148;
{ /* Llib/pgp_composition.scm 154 */
int BgL_tmpz00_2244;
BgL_tmpz00_2244 = 
(int)(((long)2)); 
BgL_res2144z00_1148 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2244); } BgL_res2144z00_1148; } 
{ /* Llib/pgp_composition.scm 154 */
int BgL_tmpz00_2247;
BgL_tmpz00_2247 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2247, BNIL); } 
BgL_sigsz00_226 = BgL_val0_1229z00_190; }  else 
{ /* Llib/pgp_composition.scm 155 */
bool_t BgL_test2504z00_2250;
BgL_pktz00_201 = 
CAR(
((obj_t)BgL_packetsz00_186)); 
if(
BGl_isazf3zf3zz__objectz00(BgL_pktz00_201, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_composition.scm 146 */
obj_t BgL_casezd2valuezd2_205;
BgL_casezd2valuezd2_205 = 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_201))))->BgL_signaturezd2typezd2); 
{ /* Llib/pgp_composition.scm 146 */
bool_t BgL__ortest_1149z00_210;
BgL__ortest_1149z00_210 = 
(BgL_casezd2valuezd2_205==
CNST_TABLE_REF(((long)2))); 
if(BgL__ortest_1149z00_210)
{ /* Llib/pgp_composition.scm 146 */
BgL_test2504z00_2250 = BgL__ortest_1149z00_210
; }  else 
{ /* Llib/pgp_composition.scm 146 */
bool_t BgL__ortest_1150z00_211;
BgL__ortest_1150z00_211 = 
(BgL_casezd2valuezd2_205==
CNST_TABLE_REF(((long)3))); 
if(BgL__ortest_1150z00_211)
{ /* Llib/pgp_composition.scm 146 */
BgL_test2504z00_2250 = BgL__ortest_1150z00_211
; }  else 
{ /* Llib/pgp_composition.scm 146 */
bool_t BgL__ortest_1151z00_212;
BgL__ortest_1151z00_212 = 
(BgL_casezd2valuezd2_205==
CNST_TABLE_REF(((long)4))); 
if(BgL__ortest_1151z00_212)
{ /* Llib/pgp_composition.scm 146 */
BgL_test2504z00_2250 = BgL__ortest_1151z00_212
; }  else 
{ /* Llib/pgp_composition.scm 146 */
BgL_test2504z00_2250 = 
(BgL_casezd2valuezd2_205==
CNST_TABLE_REF(((long)5)))
; } } } } }  else 
{ /* Llib/pgp_composition.scm 144 */
BgL_test2504z00_2250 = ((bool_t)0)
; } 
if(BgL_test2504z00_2250)
{ /* Llib/pgp_composition.scm 156 */
obj_t BgL_arg1650z00_194;obj_t BgL_arg1652z00_195;
BgL_arg1650z00_194 = 
CDR(
((obj_t)BgL_packetsz00_186)); 
{ /* Llib/pgp_composition.scm 157 */
obj_t BgL_arg1655z00_196;
BgL_arg1655z00_196 = 
CAR(
((obj_t)BgL_packetsz00_186)); 
BgL_arg1652z00_195 = 
MAKE_YOUNG_PAIR(BgL_arg1655z00_196, BgL_sigsz00_187); } 
{ 
obj_t BgL_sigsz00_2275;obj_t BgL_packetsz00_2274;
BgL_packetsz00_2274 = BgL_arg1650z00_194; 
BgL_sigsz00_2275 = BgL_arg1652z00_195; 
BgL_sigsz00_187 = BgL_sigsz00_2275; 
BgL_packetsz00_186 = BgL_packetsz00_2274; 
goto BgL_zc3z04anonymousza31637ze3z87_188;} }  else 
{ /* Llib/pgp_composition.scm 159 */
obj_t BgL_val0_1231z00_197;
BgL_val0_1231z00_197 = 
bgl_reverse_bang(BgL_sigsz00_187); 
{ /* Llib/pgp_composition.scm 159 */
int BgL_res2145z00_1152;
{ /* Llib/pgp_composition.scm 159 */
int BgL_tmpz00_2277;
BgL_tmpz00_2277 = 
(int)(((long)2)); 
BgL_res2145z00_1152 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2277); } BgL_res2145z00_1152; } 
{ /* Llib/pgp_composition.scm 159 */
int BgL_tmpz00_2280;
BgL_tmpz00_2280 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2280, BgL_packetsz00_186); } 
BgL_sigsz00_226 = BgL_val0_1231z00_197; } } } } } 
{ /* Llib/pgp_composition.scm 172 */
obj_t BgL_remainingzd2packetszd2_227;
{ /* Llib/pgp_composition.scm 172 */
int BgL_tmpz00_2283;
BgL_tmpz00_2283 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_227 = 
BGL_MVALUES_VAL(BgL_tmpz00_2283); } 
{ /* Llib/pgp_composition.scm 173 */
obj_t BgL_arg1675z00_228;
{ /* Llib/pgp_composition.scm 173 */
BgL_signedzd2idzd2_bglt BgL_arg1677z00_229;
{ /* Llib/pgp_composition.scm 173 */
BgL_signedzd2idzd2_bglt BgL_new1156z00_230;
{ /* Llib/pgp_composition.scm 175 */
BgL_signedzd2idzd2_bglt BgL_new1155z00_231;
BgL_new1155z00_231 = 
((BgL_signedzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_signedzd2idzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 175 */
long BgL_arg1678z00_232;
{ /* Llib/pgp_composition.scm 175 */
long BgL_res2148z00_1158;
BgL_res2148z00_1158 = 
BGL_CLASS_INDEX(BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2); 
BgL_arg1678z00_232 = BgL_res2148z00_1158; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1155z00_231), BgL_arg1678z00_232); } 
{ /* Llib/pgp_composition.scm 175 */
BgL_objectz00_bglt BgL_tmpz00_2290;
BgL_tmpz00_2290 = 
((BgL_objectz00_bglt)BgL_new1155z00_231); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2290, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1155z00_231); 
BgL_new1156z00_230 = BgL_new1155z00_231; } 
((((BgL_signedzd2idzd2_bglt)COBJECT(BgL_new1156z00_230))->BgL_idz00)=((BgL_pgpzd2idzd2packetz00_bglt)
((BgL_pgpzd2idzd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_218)))),BUNSPEC); 
((((BgL_signedzd2idzd2_bglt)COBJECT(BgL_new1156z00_230))->BgL_sigsz00)=((obj_t)BgL_sigsz00_226),BUNSPEC); 
BgL_arg1677z00_229 = BgL_new1156z00_230; } 
BgL_arg1675z00_228 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1677z00_229), BgL_userzd2idszd2_219); } 
{ 
obj_t BgL_userzd2idszd2_2302;obj_t BgL_packetsz00_2301;
BgL_packetsz00_2301 = BgL_remainingzd2packetszd2_227; 
BgL_userzd2idszd2_2302 = BgL_arg1675z00_228; 
BgL_userzd2idszd2_219 = BgL_userzd2idszd2_2302; 
BgL_packetsz00_218 = BgL_packetsz00_2301; 
goto BgL_zc3z04anonymousza31662ze3z87_220;} } } }  else 
{ /* Llib/pgp_composition.scm 178 */
obj_t BgL_val0_1235z00_234;
BgL_val0_1235z00_234 = 
bgl_reverse_bang(BgL_userzd2idszd2_219); 
{ /* Llib/pgp_composition.scm 178 */
int BgL_res2149z00_1163;
{ /* Llib/pgp_composition.scm 178 */
int BgL_tmpz00_2304;
BgL_tmpz00_2304 = 
(int)(((long)2)); 
BgL_res2149z00_1163 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2304); } BgL_res2149z00_1163; } 
{ /* Llib/pgp_composition.scm 178 */
int BgL_tmpz00_2307;
BgL_tmpz00_2307 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2307, BgL_packetsz00_218); } 
BgL_nuserzd2idszd2_124 = BgL_val0_1235z00_234; } } } 
{ /* Llib/pgp_composition.scm 228 */
obj_t BgL_remainingzd2packetszd2_125;
{ /* Llib/pgp_composition.scm 228 */
int BgL_tmpz00_2310;
BgL_tmpz00_2310 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_125 = 
BGL_MVALUES_VAL(BgL_tmpz00_2310); } 
{ /* Llib/pgp_composition.scm 225 */
bool_t BgL_test2509z00_2313;
if(
NULLP(BgL_nuserzd2idszd2_124))
{ /* Llib/pgp_composition.scm 225 */
BgL_test2509z00_2313 = 
NULLP(BgL_userzd2idszd2_7)
; }  else 
{ /* Llib/pgp_composition.scm 225 */
BgL_test2509z00_2313 = ((bool_t)0)
; } 
if(BgL_test2509z00_2313)
{ /* Llib/pgp_composition.scm 225 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2290z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 225 */BFALSE; } } 
{ /* Llib/pgp_composition.scm 229 */
obj_t BgL_subkeysz00_129;
BgL_packetsz00_238 = BgL_remainingzd2packetszd2_125; 
{ 
obj_t BgL_packetsz00_243;obj_t BgL_subkeysz00_244;
BgL_packetsz00_243 = BgL_packetsz00_238; 
BgL_subkeysz00_244 = BNIL; 
BgL_zc3z04anonymousza31684ze3z87_245:
{ /* Llib/pgp_composition.scm 188 */
bool_t BgL_test2511z00_2319;
if(
NULLP(BgL_packetsz00_243))
{ /* Llib/pgp_composition.scm 188 */
BgL_test2511z00_2319 = ((bool_t)1)
; }  else 
{ /* Llib/pgp_composition.scm 188 */
BgL_test2511z00_2319 = 
NULLP(
CDR(
((obj_t)BgL_packetsz00_243)))
; } 
if(BgL_test2511z00_2319)
{ /* Llib/pgp_composition.scm 190 */
obj_t BgL_val0_1237z00_249;
BgL_val0_1237z00_249 = 
bgl_reverse_bang(BgL_subkeysz00_244); 
{ /* Llib/pgp_composition.scm 190 */
int BgL_res2152z00_1167;
{ /* Llib/pgp_composition.scm 190 */
int BgL_tmpz00_2326;
BgL_tmpz00_2326 = 
(int)(((long)2)); 
BgL_res2152z00_1167 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2326); } BgL_res2152z00_1167; } 
{ /* Llib/pgp_composition.scm 190 */
int BgL_tmpz00_2329;
BgL_tmpz00_2329 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2329, BNIL); } 
BgL_subkeysz00_129 = BgL_val0_1237z00_249; }  else 
{ /* Llib/pgp_composition.scm 191 */
bool_t BgL_test2513z00_2332;
{ /* Llib/pgp_composition.scm 191 */
obj_t BgL_arg1735z00_291;
BgL_arg1735z00_291 = 
CAR(
((obj_t)BgL_packetsz00_243)); 
BgL_test2513z00_2332 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1735z00_291, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2513z00_2332)
{ /* Llib/pgp_composition.scm 192 */
obj_t BgL_g1160z00_253;
BgL_g1160z00_253 = 
CDR(
((obj_t)BgL_packetsz00_243)); 
{ 
obj_t BgL_pktsz00_257;obj_t BgL_subkeyzd2sigszd2_258;obj_t BgL_revoczd2sigszd2_259;
BgL_pktsz00_257 = BgL_g1160z00_253; 
BgL_subkeyzd2sigszd2_258 = BNIL; 
BgL_revoczd2sigszd2_259 = BNIL; 
BgL_zc3z04anonymousza31694ze3z87_260:
{ /* Llib/pgp_composition.scm 196 */
bool_t BgL_test2514z00_2338;
if(
NULLP(BgL_pktsz00_257))
{ /* Llib/pgp_composition.scm 196 */
BgL_test2514z00_2338 = ((bool_t)1)
; }  else 
{ /* Llib/pgp_composition.scm 196 */
if(
BGl_subkeyzd2sigzf3ze70zc6zz__openpgpzd2compositionzd2(
CAR(
((obj_t)BgL_pktsz00_257))))
{ /* Llib/pgp_composition.scm 197 */
BgL_test2514z00_2338 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 197 */
if(
BGl_revocationzd2signaturezf3ze70zc6zz__openpgpzd2compositionzd2(
CAR(
((obj_t)BgL_pktsz00_257))))
{ /* Llib/pgp_composition.scm 198 */
BgL_test2514z00_2338 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 198 */
BgL_test2514z00_2338 = ((bool_t)1)
; } } } 
if(BgL_test2514z00_2338)
{ /* Llib/pgp_composition.scm 196 */
if(
NULLP(BgL_subkeyzd2sigszd2_258))
{ /* Llib/pgp_composition.scm 199 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)1)), BGl_string2289z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 199 */BFALSE; } 
{ /* Llib/pgp_composition.scm 204 */
obj_t BgL_arg1706z00_269;
{ /* Llib/pgp_composition.scm 204 */
BgL_pgpzd2subkeyzd2_bglt BgL_arg1707z00_270;
{ /* Llib/pgp_composition.scm 204 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1167z00_271;
{ /* Llib/pgp_composition.scm 208 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1166z00_272;
BgL_new1166z00_272 = 
((BgL_pgpzd2subkeyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2subkeyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 208 */
long BgL_arg1708z00_273;
{ /* Llib/pgp_composition.scm 208 */
long BgL_res2155z00_1175;
BgL_res2155z00_1175 = 
BGL_CLASS_INDEX(BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2); 
BgL_arg1708z00_273 = BgL_res2155z00_1175; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1166z00_272), BgL_arg1708z00_273); } 
{ /* Llib/pgp_composition.scm 208 */
BgL_objectz00_bglt BgL_tmpz00_2357;
BgL_tmpz00_2357 = 
((BgL_objectz00_bglt)BgL_new1166z00_272); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2357, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1166z00_272); 
BgL_new1167z00_271 = BgL_new1166z00_272; } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1167z00_271))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2keyzd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_243)))),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1167z00_271))->BgL_sigsz00)=((obj_t)BgL_subkeyzd2sigszd2_258),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1167z00_271))->BgL_revocationzd2sigszd2)=((obj_t)BgL_revoczd2sigszd2_259),BUNSPEC); 
{ 
BgL_pgpzd2keyzd2_bglt BgL_auxz00_2367;
{ /* Llib/pgp_composition.scm 208 */
obj_t BgL_classz00_1180;
BgL_classz00_1180 = BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2; 
{ /* Llib/pgp_composition.scm 208 */
obj_t BgL__ortest_1106z00_1181;
BgL__ortest_1106z00_1181 = 
BGL_CLASS_NIL(BgL_classz00_1180); 
if(
CBOOL(BgL__ortest_1106z00_1181))
{ /* Llib/pgp_composition.scm 208 */
BgL_auxz00_2367 = 
((BgL_pgpzd2keyzd2_bglt)BgL__ortest_1106z00_1181)
; }  else 
{ /* Llib/pgp_composition.scm 208 */
BgL_auxz00_2367 = 
((BgL_pgpzd2keyzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1180))
; } } } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1167z00_271))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)BgL_auxz00_2367),BUNSPEC); } 
BgL_arg1707z00_270 = BgL_new1167z00_271; } 
BgL_arg1706z00_269 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1707z00_270), BgL_subkeysz00_244); } 
{ 
obj_t BgL_subkeysz00_2378;obj_t BgL_packetsz00_2377;
BgL_packetsz00_2377 = BgL_pktsz00_257; 
BgL_subkeysz00_2378 = BgL_arg1706z00_269; 
BgL_subkeysz00_244 = BgL_subkeysz00_2378; 
BgL_packetsz00_243 = BgL_packetsz00_2377; 
goto BgL_zc3z04anonymousza31684ze3z87_245;} } }  else 
{ /* Llib/pgp_composition.scm 196 */
if(
BGl_subkeyzd2sigzf3ze70zc6zz__openpgpzd2compositionzd2(
CAR(
((obj_t)BgL_pktsz00_257))))
{ /* Llib/pgp_composition.scm 211 */
obj_t BgL_arg1712z00_276;obj_t BgL_arg1713z00_277;
BgL_arg1712z00_276 = 
CDR(
((obj_t)BgL_pktsz00_257)); 
{ /* Llib/pgp_composition.scm 211 */
obj_t BgL_arg1714z00_278;
BgL_arg1714z00_278 = 
CAR(
((obj_t)BgL_pktsz00_257)); 
BgL_arg1713z00_277 = 
MAKE_YOUNG_PAIR(BgL_arg1714z00_278, BgL_subkeyzd2sigszd2_258); } 
{ 
obj_t BgL_subkeyzd2sigszd2_2389;obj_t BgL_pktsz00_2388;
BgL_pktsz00_2388 = BgL_arg1712z00_276; 
BgL_subkeyzd2sigszd2_2389 = BgL_arg1713z00_277; 
BgL_subkeyzd2sigszd2_258 = BgL_subkeyzd2sigszd2_2389; 
BgL_pktsz00_257 = BgL_pktsz00_2388; 
goto BgL_zc3z04anonymousza31694ze3z87_260;} }  else 
{ /* Llib/pgp_composition.scm 213 */
obj_t BgL_arg1720z00_279;obj_t BgL_arg1721z00_280;
BgL_arg1720z00_279 = 
CDR(
((obj_t)BgL_pktsz00_257)); 
{ /* Llib/pgp_composition.scm 214 */
obj_t BgL_arg1724z00_281;
BgL_arg1724z00_281 = 
CAR(
((obj_t)BgL_pktsz00_257)); 
BgL_arg1721z00_280 = 
MAKE_YOUNG_PAIR(BgL_arg1724z00_281, BgL_revoczd2sigszd2_259); } 
{ 
obj_t BgL_revoczd2sigszd2_2396;obj_t BgL_pktsz00_2395;
BgL_pktsz00_2395 = BgL_arg1720z00_279; 
BgL_revoczd2sigszd2_2396 = BgL_arg1721z00_280; 
BgL_revoczd2sigszd2_259 = BgL_revoczd2sigszd2_2396; 
BgL_pktsz00_257 = BgL_pktsz00_2395; 
goto BgL_zc3z04anonymousza31694ze3z87_260;} } } } } }  else 
{ /* Llib/pgp_composition.scm 216 */
obj_t BgL_val0_1239z00_289;
BgL_val0_1239z00_289 = 
bgl_reverse_bang(BgL_subkeysz00_244); 
{ /* Llib/pgp_composition.scm 216 */
int BgL_res2156z00_1187;
{ /* Llib/pgp_composition.scm 216 */
int BgL_tmpz00_2398;
BgL_tmpz00_2398 = 
(int)(((long)2)); 
BgL_res2156z00_1187 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2398); } BgL_res2156z00_1187; } 
{ /* Llib/pgp_composition.scm 216 */
int BgL_tmpz00_2401;
BgL_tmpz00_2401 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2401, BgL_packetsz00_243); } 
BgL_subkeysz00_129 = BgL_val0_1239z00_289; } } } } 
{ /* Llib/pgp_composition.scm 231 */
obj_t BgL_remainingzd2packetszd2_130;
{ /* Llib/pgp_composition.scm 231 */
int BgL_tmpz00_2404;
BgL_tmpz00_2404 = 
(int)(((long)1)); 
BgL_remainingzd2packetszd2_130 = 
BGL_MVALUES_VAL(BgL_tmpz00_2404); } 
if(
BGl_isazf3zf3zz__objectz00(BgL_mainzd2keyzd2packetz00_121, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_composition.scm 232 */
BgL_pgpzd2subkeyzd2_bglt BgL_mainzd2keyzd2_132;
{ /* Llib/pgp_composition.scm 232 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1169z00_150;
{ /* Llib/pgp_composition.scm 233 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1168z00_151;
BgL_new1168z00_151 = 
((BgL_pgpzd2subkeyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2subkeyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 233 */
long BgL_arg1587z00_152;
{ /* Llib/pgp_composition.scm 233 */
long BgL_res2159z00_1193;
BgL_res2159z00_1193 = 
BGL_CLASS_INDEX(BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2); 
BgL_arg1587z00_152 = BgL_res2159z00_1193; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1168z00_151), BgL_arg1587z00_152); } 
{ /* Llib/pgp_composition.scm 233 */
BgL_objectz00_bglt BgL_tmpz00_2413;
BgL_tmpz00_2413 = 
((BgL_objectz00_bglt)BgL_new1168z00_151); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2413, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1168z00_151); 
BgL_new1169z00_150 = BgL_new1168z00_151; } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1169z00_150))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_mainzd2keyzd2packetz00_121)),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1169z00_150))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1169z00_150))->BgL_revocationzd2sigszd2)=((obj_t)BgL_revocationzd2sigszd2_122),BUNSPEC); 
{ 
BgL_pgpzd2keyzd2_bglt BgL_auxz00_2421;
{ /* Llib/pgp_composition.scm 236 */
obj_t BgL_classz00_1197;
BgL_classz00_1197 = BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2; 
{ /* Llib/pgp_composition.scm 236 */
obj_t BgL__ortest_1106z00_1198;
BgL__ortest_1106z00_1198 = 
BGL_CLASS_NIL(BgL_classz00_1197); 
if(
CBOOL(BgL__ortest_1106z00_1198))
{ /* Llib/pgp_composition.scm 236 */
BgL_auxz00_2421 = 
((BgL_pgpzd2keyzd2_bglt)BgL__ortest_1106z00_1198)
; }  else 
{ /* Llib/pgp_composition.scm 236 */
BgL_auxz00_2421 = 
((BgL_pgpzd2keyzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1197))
; } } } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1169z00_150))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)BgL_auxz00_2421),BUNSPEC); } 
BgL_mainzd2keyzd2_132 = BgL_new1169z00_150; } 
{ /* Llib/pgp_composition.scm 232 */
obj_t BgL_allzd2subkeyszd2_133;
BgL_allzd2subkeyszd2_133 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_mainzd2keyzd2_132), BgL_subkeysz00_129); 
{ /* Llib/pgp_composition.scm 237 */
BgL_pgpzd2keyzd2_bglt BgL_reszd2keyzd2_134;
{ /* Llib/pgp_composition.scm 238 */
BgL_pgpzd2keyzd2_bglt BgL_new1171z00_147;
{ /* Llib/pgp_composition.scm 240 */
BgL_pgpzd2keyzd2_bglt BgL_new1170z00_148;
BgL_new1170z00_148 = 
((BgL_pgpzd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2keyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 240 */
long BgL_arg1586z00_149;
{ /* Llib/pgp_composition.scm 240 */
long BgL_res2160z00_1200;
BgL_res2160z00_1200 = 
BGL_CLASS_INDEX(BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2); 
BgL_arg1586z00_149 = BgL_res2160z00_1200; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1170z00_148), BgL_arg1586z00_149); } 
{ /* Llib/pgp_composition.scm 240 */
BgL_objectz00_bglt BgL_tmpz00_2435;
BgL_tmpz00_2435 = 
((BgL_objectz00_bglt)BgL_new1170z00_148); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2435, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1170z00_148); 
BgL_new1171z00_147 = BgL_new1170z00_148; } 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(BgL_new1171z00_147))->BgL_subkeysz00)=((obj_t)BgL_allzd2subkeyszd2_133),BUNSPEC); 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(BgL_new1171z00_147))->BgL_userzd2idszd2)=((obj_t)
BGl_appendzd221009zd2zz__openpgpzd2compositionzd2(BgL_nuserzd2idszd2_124, BgL_userzd2idszd2_7)),BUNSPEC); 
BgL_reszd2keyzd2_134 = BgL_new1171z00_147; } 
{ /* Llib/pgp_composition.scm 238 */

{ 
obj_t BgL_l1241z00_136;
BgL_l1241z00_136 = BgL_allzd2subkeyszd2_133; 
BgL_zc3z04anonymousza31574ze3z87_137:
if(
PAIRP(BgL_l1241z00_136))
{ /* Llib/pgp_composition.scm 241 */
{ /* Llib/pgp_composition.scm 242 */
obj_t BgL_skeyz00_139;
BgL_skeyz00_139 = 
CAR(BgL_l1241z00_136); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_skeyz00_139)))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)BgL_reszd2keyzd2_134),BUNSPEC); } 
{ 
obj_t BgL_l1241z00_2447;
BgL_l1241z00_2447 = 
CDR(BgL_l1241z00_136); 
BgL_l1241z00_136 = BgL_l1241z00_2447; 
goto BgL_zc3z04anonymousza31574ze3z87_137;} }  else 
{ /* Llib/pgp_composition.scm 241 */((bool_t)1); } } 
{ /* Llib/pgp_composition.scm 245 */
obj_t BgL_val0_1243z00_143;
{ /* Llib/pgp_composition.scm 245 */
obj_t BgL_list1585z00_146;
BgL_list1585z00_146 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_reszd2keyzd2_134), BNIL); 
BgL_val0_1243z00_143 = BgL_list1585z00_146; } 
{ /* Llib/pgp_composition.scm 245 */
int BgL_res2163z00_1208;
{ /* Llib/pgp_composition.scm 245 */
int BgL_tmpz00_2451;
BgL_tmpz00_2451 = 
(int)(((long)3)); 
BgL_res2163z00_1208 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2451); } BgL_res2163z00_1208; } 
{ /* Llib/pgp_composition.scm 245 */
int BgL_tmpz00_2454;
BgL_tmpz00_2454 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2454, BgL_remainingzd2packetszd2_130); } 
{ /* Llib/pgp_composition.scm 245 */
int BgL_tmpz00_2457;
BgL_tmpz00_2457 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2457, BgL_nuserzd2idszd2_124); } 
return BgL_val0_1243z00_143;} } } } }  else 
{ /* Llib/pgp_composition.scm 231 */
{ /* Llib/pgp_composition.scm 246 */
int BgL_res2164z00_1209;
{ /* Llib/pgp_composition.scm 246 */
int BgL_tmpz00_2460;
BgL_tmpz00_2460 = 
(int)(((long)3)); 
BgL_res2164z00_1209 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2460); } BgL_res2164z00_1209; } 
{ /* Llib/pgp_composition.scm 246 */
int BgL_tmpz00_2463;
BgL_tmpz00_2463 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2463, BgL_remainingzd2packetszd2_130); } 
{ /* Llib/pgp_composition.scm 246 */
int BgL_tmpz00_2466;
BgL_tmpz00_2466 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2466, BgL_userzd2idszd2_7); } 
return BNIL;} } } } } } } } } } 

}



/* revocation-signature?~0 */
bool_t BGl_revocationzd2signaturezf3ze70zc6zz__openpgpzd2compositionzd2(obj_t BgL_pktz00_157)
{
{ /* Llib/pgp_composition.scm 128 */
if(
BGl_isazf3zf3zz__objectz00(BgL_pktz00_157, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_composition.scm 126 */
return 
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_157))))->BgL_signaturezd2typezd2)==
CNST_TABLE_REF(((long)7)));}  else 
{ /* Llib/pgp_composition.scm 126 */
return ((bool_t)0);} } 

}



/* subkey-sig?~0 */
bool_t BGl_subkeyzd2sigzf3ze70zc6zz__openpgpzd2compositionzd2(obj_t BgL_pktz00_295)
{
{ /* Llib/pgp_composition.scm 184 */
if(
BGl_isazf3zf3zz__objectz00(BgL_pktz00_295, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2))
{ /* Llib/pgp_composition.scm 182 */
return 
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_295))))->BgL_signaturezd2typezd2)==
CNST_TABLE_REF(((long)8)));}  else 
{ /* Llib/pgp_composition.scm 182 */
return ((bool_t)0);} } 

}



/* parse-encrypted-message */
obj_t BGl_parsezd2encryptedzd2messagez00zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_8)
{
{ /* Llib/pgp_composition.scm 251 */
{ 
obj_t BgL_packetsz00_308;obj_t BgL_sessionzd2keyszd2_309;
BgL_packetsz00_308 = BgL_packetsz00_8; 
BgL_sessionzd2keyszd2_309 = BNIL; 
BgL_zc3z04anonymousza31755ze3z87_310:
if(
NULLP(BgL_packetsz00_308))
{ /* Llib/pgp_composition.scm 256 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2291z00zz__openpgpzd2compositionzd2, BFALSE);}  else 
{ /* Llib/pgp_composition.scm 260 */
bool_t BgL_test2527z00_2487;
{ /* Llib/pgp_composition.scm 260 */
obj_t BgL_arg1791z00_341;
BgL_arg1791z00_341 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
BgL_test2527z00_2487 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1791z00_341, BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2); } 
if(BgL_test2527z00_2487)
{ /* Llib/pgp_composition.scm 260 */
if(
NULLP(
CDR(
((obj_t)BgL_packetsz00_308))))
{ /* Llib/pgp_composition.scm 261 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 262 */
obj_t BgL_list1770z00_316;
BgL_list1770z00_316 = 
MAKE_YOUNG_PAIR(BGl_string2292z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1770z00_316); } 
{ /* Llib/pgp_composition.scm 263 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1175z00_318;
{ /* Llib/pgp_composition.scm 264 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1174z00_319;
BgL_new1174z00_319 = 
((BgL_pgpzd2encryptedzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2encryptedzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 264 */
long BgL_arg1772z00_320;
{ /* Llib/pgp_composition.scm 264 */
long BgL_res2167z00_1215;
BgL_res2167z00_1215 = 
BGL_CLASS_INDEX(BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2); 
BgL_arg1772z00_320 = BgL_res2167z00_1215; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1174z00_319), BgL_arg1772z00_320); } 
{ /* Llib/pgp_composition.scm 264 */
BgL_objectz00_bglt BgL_tmpz00_2501;
BgL_tmpz00_2501 = 
((BgL_objectz00_bglt)BgL_new1174z00_319); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2501, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1174z00_319); 
BgL_new1175z00_318 = BgL_new1174z00_319; } 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1175z00_318))->BgL_sessionzd2keyszd2)=((obj_t)
bgl_reverse_bang(BgL_sessionzd2keyszd2_309)),BUNSPEC); 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1175z00_318))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
CAR(
((obj_t)BgL_packetsz00_308)))),BUNSPEC); 
return 
((obj_t)BgL_new1175z00_318);} }  else 
{ /* Llib/pgp_composition.scm 266 */
bool_t BgL_test2529z00_2512;
{ /* Llib/pgp_composition.scm 266 */
obj_t BgL_arg1790z00_340;
BgL_arg1790z00_340 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
BgL_test2529z00_2512 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1790z00_340, BGl_PGPzd2MDCzd2Symmetricallyzd2Encryptedzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2529z00_2512)
{ /* Llib/pgp_composition.scm 266 */
if(
NULLP(
CDR(
((obj_t)BgL_packetsz00_308))))
{ /* Llib/pgp_composition.scm 267 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 268 */
obj_t BgL_list1777z00_325;
BgL_list1777z00_325 = 
MAKE_YOUNG_PAIR(BGl_string2292z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1777z00_325); } 
{ /* Llib/pgp_composition.scm 269 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1177z00_327;
{ /* Llib/pgp_composition.scm 270 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1176z00_328;
BgL_new1176z00_328 = 
((BgL_pgpzd2encryptedzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2encryptedzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 270 */
long BgL_arg1779z00_329;
{ /* Llib/pgp_composition.scm 270 */
long BgL_res2169z00_1224;
BgL_res2169z00_1224 = 
BGL_CLASS_INDEX(BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2); 
BgL_arg1779z00_329 = BgL_res2169z00_1224; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1176z00_328), BgL_arg1779z00_329); } 
{ /* Llib/pgp_composition.scm 270 */
BgL_objectz00_bglt BgL_tmpz00_2526;
BgL_tmpz00_2526 = 
((BgL_objectz00_bglt)BgL_new1176z00_328); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2526, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1176z00_328); 
BgL_new1177z00_327 = BgL_new1176z00_328; } 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1177z00_327))->BgL_sessionzd2keyszd2)=((obj_t)
bgl_reverse_bang(BgL_sessionzd2keyszd2_309)),BUNSPEC); 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1177z00_327))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
CAR(
((obj_t)BgL_packetsz00_308)))),BUNSPEC); 
return 
((obj_t)BgL_new1177z00_327);} }  else 
{ /* Llib/pgp_composition.scm 272 */
bool_t BgL_test2531z00_2537;
{ /* Llib/pgp_composition.scm 272 */
obj_t BgL_arg1789z00_339;
BgL_arg1789z00_339 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
BgL_test2531z00_2537 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1789z00_339, BGl_PGPzd2Sessionzd2Keyzd2Packetzd2zz__openpgpzd2packetszd2); } 
if(BgL_test2531z00_2537)
{ /* Llib/pgp_composition.scm 273 */
obj_t BgL_arg1782z00_332;obj_t BgL_arg1783z00_333;
BgL_arg1782z00_332 = 
CDR(
((obj_t)BgL_packetsz00_308)); 
{ /* Llib/pgp_composition.scm 274 */
obj_t BgL_arg1784z00_334;
BgL_arg1784z00_334 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
BgL_arg1783z00_333 = 
MAKE_YOUNG_PAIR(BgL_arg1784z00_334, BgL_sessionzd2keyszd2_309); } 
{ 
obj_t BgL_sessionzd2keyszd2_2547;obj_t BgL_packetsz00_2546;
BgL_packetsz00_2546 = BgL_arg1782z00_332; 
BgL_sessionzd2keyszd2_2547 = BgL_arg1783z00_333; 
BgL_sessionzd2keyszd2_309 = BgL_sessionzd2keyszd2_2547; 
BgL_packetsz00_308 = BgL_packetsz00_2546; 
goto BgL_zc3z04anonymousza31755ze3z87_310;} }  else 
{ /* Llib/pgp_composition.scm 272 */
{ /* Llib/pgp_composition.scm 277 */
obj_t BgL_arg1785z00_335;
BgL_arg1785z00_335 = 
CAR(
((obj_t)BgL_packetsz00_308)); 
{ /* Llib/pgp_composition.scm 276 */
obj_t BgL_list1786z00_336;
{ /* Llib/pgp_composition.scm 276 */
obj_t BgL_arg1787z00_337;
BgL_arg1787z00_337 = 
MAKE_YOUNG_PAIR(BgL_arg1785z00_335, BNIL); 
BgL_list1786z00_336 = 
MAKE_YOUNG_PAIR(BGl_string2293z00zz__openpgpzd2compositionzd2, BgL_arg1787z00_337); } 
BGl_warningz00zz__errorz00(BgL_list1786z00_336); } } 
{ /* Llib/pgp_composition.scm 278 */
obj_t BgL_arg1788z00_338;
BgL_arg1788z00_338 = 
CDR(
((obj_t)BgL_packetsz00_308)); 
{ 
obj_t BgL_packetsz00_2555;
BgL_packetsz00_2555 = BgL_arg1788z00_338; 
BgL_packetsz00_308 = BgL_packetsz00_2555; 
goto BgL_zc3z04anonymousza31755ze3z87_310;} } } } } } } } 

}



/* parse-signature */
BgL_pgpzd2signaturezd2_bglt BGl_parsezd2signaturezd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_9)
{
{ /* Llib/pgp_composition.scm 283 */
{ 
obj_t BgL_packetsz00_345;obj_t BgL_sigsz00_346;
BgL_packetsz00_345 = BgL_packetsz00_9; 
BgL_sigsz00_346 = BNIL; 
BgL_zc3z04anonymousza31792ze3z87_347:
if(
NULLP(BgL_packetsz00_345))
{ /* Llib/pgp_composition.scm 290 */
BgL_pgpzd2signaturezd2_bglt BgL_new1180z00_349;
{ /* Llib/pgp_composition.scm 291 */
BgL_pgpzd2signaturezd2_bglt BgL_new1179z00_350;
BgL_new1179z00_350 = 
((BgL_pgpzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 291 */
long BgL_arg1794z00_351;
{ /* Llib/pgp_composition.scm 291 */
long BgL_res2171z00_1236;
BgL_res2171z00_1236 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BgL_arg1794z00_351 = BgL_res2171z00_1236; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1179z00_350), BgL_arg1794z00_351); } 
BgL_new1180z00_349 = BgL_new1179z00_350; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1180z00_349))->BgL_msgz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1180z00_349))->BgL_sigsz00)=((obj_t)
bgl_reverse_bang(BgL_sigsz00_346)),BUNSPEC); 
return BgL_new1180z00_349;}  else 
{ /* Llib/pgp_composition.scm 293 */
bool_t BgL_test2533z00_2565;
{ /* Llib/pgp_composition.scm 293 */
obj_t BgL_arg1817z00_377;
BgL_arg1817z00_377 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
BgL_test2533z00_2565 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1817z00_377, BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2533z00_2565)
{ /* Llib/pgp_composition.scm 294 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_i1181z00_354;
BgL_i1181z00_354 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_345))); 
{ 
obj_t BgL_packetsz00_2572;
BgL_packetsz00_2572 = 
BGl_appendzd221009zd2zz__openpgpzd2compositionzd2(
(((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(BgL_i1181z00_354))->BgL_packetsz00), BgL_packetsz00_345); 
BgL_packetsz00_345 = BgL_packetsz00_2572; 
goto BgL_zc3z04anonymousza31792ze3z87_347;} }  else 
{ /* Llib/pgp_composition.scm 296 */
bool_t BgL_test2534z00_2575;
{ /* Llib/pgp_composition.scm 296 */
obj_t BgL_arg1816z00_376;
BgL_arg1816z00_376 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
BgL_test2534z00_2575 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1816z00_376, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2534z00_2575)
{ /* Llib/pgp_composition.scm 297 */
obj_t BgL_arg1801z00_359;obj_t BgL_arg1802z00_360;
BgL_arg1801z00_359 = 
CDR(
((obj_t)BgL_packetsz00_345)); 
{ /* Llib/pgp_composition.scm 297 */
obj_t BgL_arg1803z00_361;
BgL_arg1803z00_361 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
BgL_arg1802z00_360 = 
MAKE_YOUNG_PAIR(BgL_arg1803z00_361, BgL_sigsz00_346); } 
{ 
obj_t BgL_sigsz00_2585;obj_t BgL_packetsz00_2584;
BgL_packetsz00_2584 = BgL_arg1801z00_359; 
BgL_sigsz00_2585 = BgL_arg1802z00_360; 
BgL_sigsz00_346 = BgL_sigsz00_2585; 
BgL_packetsz00_345 = BgL_packetsz00_2584; 
goto BgL_zc3z04anonymousza31792ze3z87_347;} }  else 
{ /* Llib/pgp_composition.scm 298 */
bool_t BgL_test2535z00_2586;
{ /* Llib/pgp_composition.scm 298 */
obj_t BgL_arg1815z00_375;
BgL_arg1815z00_375 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
BgL_test2535z00_2586 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1815z00_375, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2535z00_2586)
{ /* Llib/pgp_composition.scm 298 */
if(
NULLP(
CDR(
((obj_t)BgL_packetsz00_345))))
{ /* Llib/pgp_composition.scm 299 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 300 */
obj_t BgL_list1808z00_366;
BgL_list1808z00_366 = 
MAKE_YOUNG_PAIR(BGl_string2294z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1808z00_366); } 
{ /* Llib/pgp_composition.scm 301 */
BgL_pgpzd2signaturezd2_bglt BgL_new1183z00_368;
{ /* Llib/pgp_composition.scm 302 */
BgL_pgpzd2signaturezd2_bglt BgL_new1182z00_369;
BgL_new1182z00_369 = 
((BgL_pgpzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 302 */
long BgL_arg1810z00_370;
{ /* Llib/pgp_composition.scm 302 */
long BgL_res2173z00_1248;
BgL_res2173z00_1248 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BgL_arg1810z00_370 = BgL_res2173z00_1248; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1182z00_369), BgL_arg1810z00_370); } 
BgL_new1183z00_368 = BgL_new1182z00_369; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1183z00_368))->BgL_msgz00)=((obj_t)
CAR(
((obj_t)BgL_packetsz00_345))),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1183z00_368))->BgL_sigsz00)=((obj_t)
bgl_reverse_bang(BgL_sigsz00_346)),BUNSPEC); 
return BgL_new1183z00_368;} }  else 
{ /* Llib/pgp_composition.scm 298 */
{ /* Llib/pgp_composition.scm 306 */
obj_t BgL_arg1811z00_371;
BgL_arg1811z00_371 = 
CAR(
((obj_t)BgL_packetsz00_345)); 
{ /* Llib/pgp_composition.scm 305 */
obj_t BgL_list1812z00_372;
{ /* Llib/pgp_composition.scm 305 */
obj_t BgL_arg1813z00_373;
BgL_arg1813z00_373 = 
MAKE_YOUNG_PAIR(BgL_arg1811z00_371, BNIL); 
BgL_list1812z00_372 = 
MAKE_YOUNG_PAIR(BGl_string2293z00zz__openpgpzd2compositionzd2, BgL_arg1813z00_373); } 
BGl_warningz00zz__errorz00(BgL_list1812z00_372); } } 
{ /* Llib/pgp_composition.scm 307 */
obj_t BgL_arg1814z00_374;
BgL_arg1814z00_374 = 
CDR(
((obj_t)BgL_packetsz00_345)); 
{ 
obj_t BgL_packetsz00_2612;
BgL_packetsz00_2612 = BgL_arg1814z00_374; 
BgL_packetsz00_345 = BgL_packetsz00_2612; 
goto BgL_zc3z04anonymousza31792ze3z87_347;} } } } } } } } 

}



/* parse-one-pass-signature */
obj_t BGl_parsezd2onezd2passzd2signaturezd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_10)
{
{ /* Llib/pgp_composition.scm 312 */
{ 
obj_t BgL_opzd2pktzd2_436;obj_t BgL_pktz00_437;
{ 
obj_t BgL_packetsz00_383;bool_t BgL_expectzd2onezd2passzf3zf3_384;obj_t BgL_onezd2passzd2sigsz00_385;obj_t BgL_msgz00_386;obj_t BgL_sigsz00_387;
BgL_packetsz00_383 = BgL_packetsz00_10; 
BgL_expectzd2onezd2passzf3zf3_384 = ((bool_t)1); 
BgL_onezd2passzd2sigsz00_385 = BNIL; 
BgL_msgz00_386 = BFALSE; 
BgL_sigsz00_387 = BNIL; 
BgL_zc3z04anonymousza31818ze3z87_388:
if(
NULLP(BgL_packetsz00_383))
{ /* Llib/pgp_composition.scm 336 */
obj_t BgL_onezd2passzd2sigsz00_390;
BgL_onezd2passzd2sigsz00_390 = 
bgl_reverse_bang(BgL_onezd2passzd2sigsz00_385); 
if(
(
bgl_list_length(BgL_onezd2passzd2sigsz00_390)==
bgl_list_length(BgL_sigsz00_387)))
{ /* Llib/pgp_composition.scm 337 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 337 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2295z00zz__openpgpzd2compositionzd2, BFALSE); } 
{ 
obj_t BgL_ll1249z00_397;obj_t BgL_ll1250z00_398;
BgL_ll1249z00_397 = BgL_onezd2passzd2sigsz00_390; 
BgL_ll1250z00_398 = BgL_sigsz00_387; 
BgL_zc3z04anonymousza31825ze3z87_399:
if(
NULLP(BgL_ll1249z00_397))
{ /* Llib/pgp_composition.scm 342 */((bool_t)1); }  else 
{ /* Llib/pgp_composition.scm 342 */
{ /* Llib/pgp_composition.scm 343 */
obj_t BgL_opzd2pktzd2_401;obj_t BgL_sigzd2pktzd2_402;
BgL_opzd2pktzd2_401 = 
CAR(
((obj_t)BgL_ll1249z00_397)); 
BgL_sigzd2pktzd2_402 = 
CAR(
((obj_t)BgL_ll1250z00_398)); 
{ /* Llib/pgp_composition.scm 343 */
bool_t BgL_test2540z00_2628;
BgL_opzd2pktzd2_436 = BgL_opzd2pktzd2_401; 
BgL_pktz00_437 = BgL_sigzd2pktzd2_402; 
if(
BGl_equalzf3zf3zz__r4_equivalence_6_2z00(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_opzd2pktzd2_436))))->BgL_issuerz00), 
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_437))))->BgL_issuerz00)))
{ /* Llib/pgp_composition.scm 323 */
if(
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_opzd2pktzd2_436))))->BgL_publiczd2keyzd2algoz00)==
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_437))))->BgL_publiczd2keyzd2algoz00)))
{ /* Llib/pgp_composition.scm 324 */
if(
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_opzd2pktzd2_436))))->BgL_hashzd2algozd2)==
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_437))))->BgL_hashzd2algozd2)))
{ /* Llib/pgp_composition.scm 325 */
BgL_test2540z00_2628 = 
(
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)BgL_opzd2pktzd2_436))))->BgL_signaturezd2typezd2)==
(((BgL_pgpzd2sigzd2packetz00_bglt)COBJECT(
((BgL_pgpzd2sigzd2packetz00_bglt)
((BgL_pgpzd2signaturezd2packetz00_bglt)BgL_pktz00_437))))->BgL_signaturezd2typezd2))
; }  else 
{ /* Llib/pgp_composition.scm 325 */
BgL_test2540z00_2628 = ((bool_t)0)
; } }  else 
{ /* Llib/pgp_composition.scm 324 */
BgL_test2540z00_2628 = ((bool_t)0)
; } }  else 
{ /* Llib/pgp_composition.scm 323 */
BgL_test2540z00_2628 = ((bool_t)0)
; } 
if(BgL_test2540z00_2628)
{ /* Llib/pgp_composition.scm 343 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 343 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2296z00zz__openpgpzd2compositionzd2, BFALSE); } } } 
{ /* Llib/pgp_composition.scm 342 */
obj_t BgL_arg1828z00_404;obj_t BgL_arg1829z00_405;
BgL_arg1828z00_404 = 
CDR(
((obj_t)BgL_ll1249z00_397)); 
BgL_arg1829z00_405 = 
CDR(
((obj_t)BgL_ll1250z00_398)); 
{ 
obj_t BgL_ll1250z00_2667;obj_t BgL_ll1249z00_2666;
BgL_ll1249z00_2666 = BgL_arg1828z00_404; 
BgL_ll1250z00_2667 = BgL_arg1829z00_405; 
BgL_ll1250z00_398 = BgL_ll1250z00_2667; 
BgL_ll1249z00_397 = BgL_ll1249z00_2666; 
goto BgL_zc3z04anonymousza31825ze3z87_399;} } } } 
{ /* Llib/pgp_composition.scm 349 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1194z00_407;
{ /* Llib/pgp_composition.scm 351 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1193z00_408;
BgL_new1193z00_408 = 
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2onezd2passzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 351 */
long BgL_arg1830z00_409;
{ /* Llib/pgp_composition.scm 351 */
long BgL_res2177z00_1264;
BgL_res2177z00_1264 = 
BGL_CLASS_INDEX(BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BgL_arg1830z00_409 = BgL_res2177z00_1264; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1193z00_408), BgL_arg1830z00_409); } 
{ /* Llib/pgp_composition.scm 351 */
BgL_objectz00_bglt BgL_tmpz00_2672;
BgL_tmpz00_2672 = 
((BgL_objectz00_bglt)BgL_new1193z00_408); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2672, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1193z00_408); 
BgL_new1194z00_407 = BgL_new1193z00_408; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1194z00_407)))->BgL_msgz00)=((obj_t)BgL_msgz00_386),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1194z00_407)))->BgL_sigsz00)=((obj_t)BgL_sigsz00_387),BUNSPEC); 
((((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(BgL_new1194z00_407))->BgL_onezd2passzd2sigsz00)=((obj_t)BgL_onezd2passzd2sigsz00_390),BUNSPEC); 
return 
((obj_t)BgL_new1194z00_407);} }  else 
{ /* Llib/pgp_composition.scm 353 */
bool_t BgL_test2544z00_2682;
{ /* Llib/pgp_composition.scm 353 */
obj_t BgL_arg1853z00_434;
BgL_arg1853z00_434 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_test2544z00_2682 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1853z00_434, BGl_PGPzd2Compressedzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2544z00_2682)
{ /* Llib/pgp_composition.scm 354 */
BgL_pgpzd2compressedzd2packetz00_bglt BgL_i1195z00_412;
BgL_i1195z00_412 = 
((BgL_pgpzd2compressedzd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_383))); 
{ 
obj_t BgL_packetsz00_2689;
BgL_packetsz00_2689 = 
BGl_appendzd221009zd2zz__openpgpzd2compositionzd2(
(((BgL_pgpzd2compressedzd2packetz00_bglt)COBJECT(BgL_i1195z00_412))->BgL_packetsz00), BgL_packetsz00_383); 
BgL_packetsz00_383 = BgL_packetsz00_2689; 
goto BgL_zc3z04anonymousza31818ze3z87_388;} }  else 
{ /* Llib/pgp_composition.scm 357 */
bool_t BgL_test2545z00_2692;
if(BgL_expectzd2onezd2passzf3zf3_384)
{ /* Llib/pgp_composition.scm 358 */
obj_t BgL_arg1852z00_433;
BgL_arg1852z00_433 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_test2545z00_2692 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1852z00_433, BGl_PGPzd2Onezd2Passzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); }  else 
{ /* Llib/pgp_composition.scm 357 */
BgL_test2545z00_2692 = ((bool_t)0)
; } 
if(BgL_test2545z00_2692)
{ /* Llib/pgp_composition.scm 359 */
BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt BgL_i1196z00_417;
BgL_i1196z00_417 = 
((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)
CAR(
((obj_t)BgL_packetsz00_383))); 
{ /* Llib/pgp_composition.scm 361 */
obj_t BgL_arg1837z00_418;bool_t BgL_arg1838z00_419;obj_t BgL_arg1839z00_420;
BgL_arg1837z00_418 = 
CDR(
((obj_t)BgL_packetsz00_383)); 
BgL_arg1838z00_419 = 
(((BgL_pgpzd2onezd2passzd2signaturezd2packetz00_bglt)COBJECT(BgL_i1196z00_417))->BgL_containszd2nestedzd2sigzf3zf3); 
{ /* Llib/pgp_composition.scm 363 */
obj_t BgL_arg1840z00_421;
BgL_arg1840z00_421 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_arg1839z00_420 = 
MAKE_YOUNG_PAIR(BgL_arg1840z00_421, BgL_onezd2passzd2sigsz00_385); } 
{ 
obj_t BgL_onezd2passzd2sigsz00_2708;bool_t BgL_expectzd2onezd2passzf3zf3_2707;obj_t BgL_packetsz00_2706;
BgL_packetsz00_2706 = BgL_arg1837z00_418; 
BgL_expectzd2onezd2passzf3zf3_2707 = BgL_arg1838z00_419; 
BgL_onezd2passzd2sigsz00_2708 = BgL_arg1839z00_420; 
BgL_onezd2passzd2sigsz00_385 = BgL_onezd2passzd2sigsz00_2708; 
BgL_expectzd2onezd2passzf3zf3_384 = BgL_expectzd2onezd2passzf3zf3_2707; 
BgL_packetsz00_383 = BgL_packetsz00_2706; 
goto BgL_zc3z04anonymousza31818ze3z87_388;} } }  else 
{ /* Llib/pgp_composition.scm 357 */
if(BgL_expectzd2onezd2passzf3zf3_384)
{ /* Llib/pgp_composition.scm 366 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2295z00zz__openpgpzd2compositionzd2, BFALSE);}  else 
{ /* Llib/pgp_composition.scm 370 */
bool_t BgL_test2548z00_2712;
if(
CBOOL(BgL_msgz00_386))
{ /* Llib/pgp_composition.scm 370 */
BgL_test2548z00_2712 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 370 */
obj_t BgL_arg1851z00_432;
BgL_arg1851z00_432 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_test2548z00_2712 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1851z00_432, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2548z00_2712)
{ /* Llib/pgp_composition.scm 371 */
obj_t BgL_arg1843z00_424;obj_t BgL_arg1844z00_425;
BgL_arg1843z00_424 = 
CDR(
((obj_t)BgL_packetsz00_383)); 
BgL_arg1844z00_425 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
{ 
obj_t BgL_msgz00_2724;bool_t BgL_expectzd2onezd2passzf3zf3_2723;obj_t BgL_packetsz00_2722;
BgL_packetsz00_2722 = BgL_arg1843z00_424; 
BgL_expectzd2onezd2passzf3zf3_2723 = ((bool_t)0); 
BgL_msgz00_2724 = BgL_arg1844z00_425; 
BgL_msgz00_386 = BgL_msgz00_2724; 
BgL_expectzd2onezd2passzf3zf3_384 = BgL_expectzd2onezd2passzf3zf3_2723; 
BgL_packetsz00_383 = BgL_packetsz00_2722; 
goto BgL_zc3z04anonymousza31818ze3z87_388;} }  else 
{ /* Llib/pgp_composition.scm 370 */
if(
CBOOL(BgL_msgz00_386))
{ /* Llib/pgp_composition.scm 376 */
bool_t BgL_test2551z00_2727;
{ /* Llib/pgp_composition.scm 376 */
obj_t BgL_arg1850z00_431;
BgL_arg1850z00_431 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_test2551z00_2727 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1850z00_431, BGl_PGPzd2Signaturezd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2551z00_2727)
{ /* Llib/pgp_composition.scm 377 */
obj_t BgL_arg1847z00_428;obj_t BgL_arg1848z00_429;
BgL_arg1847z00_428 = 
CDR(
((obj_t)BgL_packetsz00_383)); 
{ /* Llib/pgp_composition.scm 378 */
obj_t BgL_arg1849z00_430;
BgL_arg1849z00_430 = 
CAR(
((obj_t)BgL_packetsz00_383)); 
BgL_arg1848z00_429 = 
MAKE_YOUNG_PAIR(BgL_arg1849z00_430, BgL_sigsz00_387); } 
{ 
obj_t BgL_sigsz00_2738;bool_t BgL_expectzd2onezd2passzf3zf3_2737;obj_t BgL_packetsz00_2736;
BgL_packetsz00_2736 = BgL_arg1847z00_428; 
BgL_expectzd2onezd2passzf3zf3_2737 = ((bool_t)0); 
BgL_sigsz00_2738 = BgL_arg1848z00_429; 
BgL_sigsz00_387 = BgL_sigsz00_2738; 
BgL_expectzd2onezd2passzf3zf3_384 = BgL_expectzd2onezd2passzf3zf3_2737; 
BgL_packetsz00_383 = BgL_packetsz00_2736; 
goto BgL_zc3z04anonymousza31818ze3z87_388;} }  else 
{ /* Llib/pgp_composition.scm 376 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2295z00zz__openpgpzd2compositionzd2, BFALSE);} }  else 
{ /* Llib/pgp_composition.scm 372 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2295z00zz__openpgpzd2compositionzd2, BFALSE);} } } } } } } } } 

}



/* parse-literal */
BgL_pgpzd2literalzd2_bglt BGl_parsezd2literalzd2zz__openpgpzd2compositionzd2(obj_t BgL_packetsz00_11)
{
{ /* Llib/pgp_composition.scm 387 */
if(
NULLP(
CDR(BgL_packetsz00_11)))
{ /* Llib/pgp_composition.scm 388 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 389 */
obj_t BgL_list1865z00_455;
BgL_list1865z00_455 = 
MAKE_YOUNG_PAIR(BGl_string2284z00zz__openpgpzd2compositionzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1865z00_455); } 
{ /* Llib/pgp_composition.scm 390 */
bool_t BgL_test2553z00_2748;
{ /* Llib/pgp_composition.scm 391 */
bool_t BgL_test2554z00_2749;
{ /* Llib/pgp_composition.scm 391 */
obj_t BgL_arg1872z00_464;
BgL_arg1872z00_464 = 
CAR(BgL_packetsz00_11); 
BgL_test2554z00_2749 = 
BGl_isazf3zf3zz__objectz00(BgL_arg1872z00_464, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); } 
if(BgL_test2554z00_2749)
{ /* Llib/pgp_composition.scm 391 */
BgL_test2553z00_2748 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 391 */
BgL_test2553z00_2748 = ((bool_t)1)
; } } 
if(BgL_test2553z00_2748)
{ /* Llib/pgp_composition.scm 390 */
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2297z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 390 */BFALSE; } } 
{ /* Llib/pgp_composition.scm 395 */
BgL_pgpzd2literalzd2_bglt BgL_new1198z00_465;
{ /* Llib/pgp_composition.scm 396 */
BgL_pgpzd2literalzd2_bglt BgL_new1197z00_466;
BgL_new1197z00_466 = 
((BgL_pgpzd2literalzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2literalzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 396 */
long BgL_arg1873z00_467;
{ /* Llib/pgp_composition.scm 396 */
long BgL_res2180z00_1285;
BgL_res2180z00_1285 = 
BGL_CLASS_INDEX(BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2); 
BgL_arg1873z00_467 = BgL_res2180z00_1285; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1197z00_466), BgL_arg1873z00_467); } 
{ /* Llib/pgp_composition.scm 396 */
BgL_objectz00_bglt BgL_tmpz00_2758;
BgL_tmpz00_2758 = 
((BgL_objectz00_bglt)BgL_new1197z00_466); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_2758, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1197z00_466); 
BgL_new1198z00_465 = BgL_new1197z00_466; } 
((((BgL_pgpzd2literalzd2_bglt)COBJECT(BgL_new1198z00_465))->BgL_literalz00)=((BgL_pgpzd2literalzd2packetz00_bglt)
((BgL_pgpzd2literalzd2packetz00_bglt)
CAR(BgL_packetsz00_11))),BUNSPEC); 
return BgL_new1198z00_465;} } 

}



/* create-chksum64 */
obj_t BGl_createzd2chksum64zd2zz__openpgpzd2compositionzd2(obj_t BgL_dataz00_12)
{
{ /* Llib/pgp_composition.scm 401 */
{ /* Llib/pgp_composition.scm 402 */
obj_t BgL_computedzd2chksumzd2_468;
BgL_computedzd2chksumzd2_468 = 
BGl_crczd2stringzd2zz__crcz00(
CNST_TABLE_REF(((long)12)), BgL_dataz00_12, BTRUE, 
BINT(((long)0)), 
BINT(((long)11994318))); 
{ /* Llib/pgp_composition.scm 402 */
long BgL_b1z00_469;
BgL_b1z00_469 = 
(
(
(long)CINT(BgL_computedzd2chksumzd2_468) & ((long)16711680)) >> 
(int)(((long)16))); 
{ /* Llib/pgp_composition.scm 404 */
long BgL_b2z00_470;
BgL_b2z00_470 = 
(
(
(long)CINT(BgL_computedzd2chksumzd2_468) & ((long)65280)) >> 
(int)(((long)8))); 
{ /* Llib/pgp_composition.scm 405 */
long BgL_b3z00_471;
BgL_b3z00_471 = 
(
(long)CINT(BgL_computedzd2chksumzd2_468) & ((long)255)); 
{ /* Llib/pgp_composition.scm 406 */

{ /* Llib/pgp_composition.scm 407 */
obj_t BgL_arg1874z00_472;
{ /* Llib/pgp_composition.scm 407 */
unsigned char BgL_arg1875z00_475;unsigned char BgL_arg1876z00_476;unsigned char BgL_arg1877z00_477;
BgL_arg1875z00_475 = 
(BgL_b1z00_469); 
BgL_arg1876z00_476 = 
(BgL_b2z00_470); 
BgL_arg1877z00_477 = 
(BgL_b3z00_471); 
{ /* Llib/pgp_composition.scm 407 */
obj_t BgL_list1878z00_478;
{ /* Llib/pgp_composition.scm 407 */
obj_t BgL_arg1879z00_479;
{ /* Llib/pgp_composition.scm 407 */
obj_t BgL_arg1880z00_480;
BgL_arg1880z00_480 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_arg1877z00_477), BNIL); 
BgL_arg1879z00_479 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_arg1876z00_476), BgL_arg1880z00_480); } 
BgL_list1878z00_478 = 
MAKE_YOUNG_PAIR(
BCHAR(BgL_arg1875z00_475), BgL_arg1879z00_479); } 
BgL_arg1874z00_472 = 
BGl_listzd2ze3stringz31zz__r4_strings_6_7z00(BgL_list1878z00_478); } } 
{ /* Llib/pgp_composition.scm 407 */

return 
BGl_base64zd2encodezd2zz__base64z00(BgL_arg1874z00_472, 
BINT(((long)76)));} } } } } } } } 

}



/* armored-pipe-port */
obj_t BGl_armoredzd2pipezd2portz00zz__openpgpzd2compositionzd2(obj_t BgL_pz00_13)
{
{ /* Llib/pgp_composition.scm 414 */
{ 
obj_t BgL_lz00_547;obj_t BgL_dataz00_560;obj_t BgL_pz00_561;
{ /* Llib/pgp_composition.scm 460 */
obj_t BgL_lz00_489;
BgL_lz00_489 = 
BGl_safezd2readzd2lineze70ze7zz__openpgpzd2compositionzd2(BgL_pz00_13); 
{ /* Llib/pgp_composition.scm 461 */
bool_t BgL_test2555z00_2792;
{ /* Llib/pgp_composition.scm 461 */
bool_t BgL_test2556z00_2793;
{ /* Llib/pgp_composition.scm 461 */

BgL_test2556z00_2793 = 
BGl_stringzd2prefixzf3z21zz__r4_strings_6_7z00(BGl_string2300z00zz__openpgpzd2compositionzd2, BgL_lz00_489, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL_test2556z00_2793)
{ /* Llib/pgp_composition.scm 462 */

BgL_test2555z00_2792 = 
BGl_stringzd2suffixzf3z21zz__r4_strings_6_7z00(BGl_string2301z00zz__openpgpzd2compositionzd2, BgL_lz00_489, BFALSE, BFALSE, BFALSE, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 461 */
BgL_test2555z00_2792 = ((bool_t)0)
; } } 
if(BgL_test2555z00_2792)
{ /* Llib/pgp_composition.scm 461 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 461 */
BGl_errorz00zz__errorz00(BGl_string2298z00zz__openpgpzd2compositionzd2, BGl_string2302z00zz__openpgpzd2compositionzd2, BgL_lz00_489); } } 
{ /* Llib/pgp_composition.scm 465 */
obj_t BgL_mainzd2headerzd2infoz00_523;
{ /* Llib/pgp_composition.scm 465 */
long BgL_arg1888z00_541;
BgL_arg1888z00_541 = 
(
STRING_LENGTH(
((obj_t)BgL_lz00_489))-((long)5)); 
{ /* Llib/pgp_composition.scm 465 */
obj_t BgL_res2206z00_1347;
BgL_res2206z00_1347 = 
c_substring(
((obj_t)BgL_lz00_489), ((long)11), BgL_arg1888z00_541); 
BgL_mainzd2headerzd2infoz00_523 = BgL_res2206z00_1347; } } 
{ 
obj_t BgL_headersz00_526;
BgL_headersz00_526 = BNIL; 
BgL_zc3z04anonymousza31885ze3z87_527:
{ /* Llib/pgp_composition.scm 467 */
obj_t BgL_lz00_528;
BgL_lz00_528 = 
BGl_safezd2readzd2lineze70ze7zz__openpgpzd2compositionzd2(BgL_pz00_13); 
if(
(
STRING_LENGTH(
((obj_t)BgL_lz00_528))==((long)0)))
{ /* Llib/pgp_composition.scm 469 */
obj_t BgL_val2_1254z00_532;
{ /* Llib/pgp_composition.scm 470 */
obj_t BgL_p64z00_533;
BgL_p64z00_533 = 
BGl_base64zd2decodezd2pipezd2portzd2zz__openpgpzd2portzd2utilz00(BgL_pz00_13); 
{ /* Llib/pgp_composition.scm 470 */
obj_t BgL_dataz00_534;
BgL_dataz00_534 = 
BGl_readzd2stringzd2zz__r4_input_6_10_2z00(BgL_p64z00_533); 
{ /* Llib/pgp_composition.scm 471 */

BgL_dataz00_560 = BgL_dataz00_534; 
BgL_pz00_561 = BgL_pz00_13; 
{ /* Llib/pgp_composition.scm 447 */
obj_t BgL_cz00_564;
BgL_cz00_564 = 
BGl_readzd2charzd2zz__r4_input_6_10_2z00(BgL_pz00_561); 
{ /* Llib/pgp_composition.scm 448 */
bool_t BgL_test2558z00_2810;
if(
CHARP(BgL_cz00_564))
{ /* Llib/pgp_composition.scm 448 */
if(
(
CCHAR(BgL_cz00_564)==((unsigned char)'=')))
{ /* Llib/pgp_composition.scm 449 */
BgL_test2558z00_2810 = ((bool_t)0)
; }  else 
{ /* Llib/pgp_composition.scm 449 */
BgL_test2558z00_2810 = ((bool_t)1)
; } }  else 
{ /* Llib/pgp_composition.scm 448 */
BgL_test2558z00_2810 = ((bool_t)1)
; } 
if(BgL_test2558z00_2810)
{ /* Llib/pgp_composition.scm 448 */
BGl_errorz00zz__errorz00(BGl_string2298z00zz__openpgpzd2compositionzd2, BGl_string2299z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 448 */BFALSE; } } 
{ /* Llib/pgp_composition.scm 451 */
obj_t BgL_linez00_570;obj_t BgL_expectedz00_571;
BgL_linez00_570 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_pz00_561); 
BgL_expectedz00_571 = 
BGl_createzd2chksum64zd2zz__openpgpzd2compositionzd2(BgL_dataz00_560); 
{ /* Llib/pgp_composition.scm 455 */
bool_t BgL_test2561z00_2819;
{ /* Llib/pgp_composition.scm 455 */
bool_t BgL_res2198z00_1324;
BgL_res2198z00_1324 = 
EOF_OBJECTP(BgL_linez00_570); 
BgL_test2561z00_2819 = BgL_res2198z00_1324; } 
if(BgL_test2561z00_2819)
{ /* Llib/pgp_composition.scm 455 */
BGl_errorz00zz__errorz00(BGl_string2298z00zz__openpgpzd2compositionzd2, BGl_string2299z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 455 */BFALSE; } } 
{ /* Llib/pgp_composition.scm 456 */
bool_t BgL_test2562z00_2822;
{ /* Llib/pgp_composition.scm 456 */
bool_t BgL_res2203z00_1340;
{ /* Llib/pgp_composition.scm 456 */
long BgL_l1z00_1327;
BgL_l1z00_1327 = 
STRING_LENGTH(
((obj_t)BgL_linez00_570)); 
if(
(BgL_l1z00_1327==
STRING_LENGTH(BgL_expectedz00_571)))
{ /* Llib/pgp_composition.scm 456 */
int BgL_arg1269z00_1330;
{ /* Llib/pgp_composition.scm 456 */
char * BgL_auxz00_2831;char * BgL_tmpz00_2828;
BgL_auxz00_2831 = 
BSTRING_TO_STRING(BgL_expectedz00_571); 
BgL_tmpz00_2828 = 
BSTRING_TO_STRING(
((obj_t)BgL_linez00_570)); 
BgL_arg1269z00_1330 = 
memcmp(BgL_tmpz00_2828, BgL_auxz00_2831, BgL_l1z00_1327); } 
BgL_res2203z00_1340 = 
(
(long)(BgL_arg1269z00_1330)==((long)0)); }  else 
{ /* Llib/pgp_composition.scm 456 */
BgL_res2203z00_1340 = ((bool_t)0); } } 
BgL_test2562z00_2822 = BgL_res2203z00_1340; } 
if(BgL_test2562z00_2822)
{ /* Llib/pgp_composition.scm 456 */BFALSE; }  else 
{ /* Llib/pgp_composition.scm 456 */
BGl_errorz00zz__errorz00(BGl_string2298z00zz__openpgpzd2compositionzd2, BGl_string2299z00zz__openpgpzd2compositionzd2, BFALSE); } } } } 
{ /* Llib/pgp_composition.scm 474 */
long BgL_endz00_537;
BgL_endz00_537 = 
STRING_LENGTH(BgL_dataz00_534); 
{ /* Llib/pgp_composition.scm 474 */

BgL_val2_1254z00_532 = 
BGl_openzd2inputzd2stringz00zz__r4_ports_6_10_1z00(BgL_dataz00_534, 
BINT(((long)0)), 
BINT(BgL_endz00_537)); } } } } } 
{ /* Llib/pgp_composition.scm 469 */
int BgL_res2211z00_1357;
{ /* Llib/pgp_composition.scm 469 */
int BgL_tmpz00_2841;
BgL_tmpz00_2841 = 
(int)(((long)3)); 
BgL_res2211z00_1357 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2841); } BgL_res2211z00_1357; } 
{ /* Llib/pgp_composition.scm 469 */
int BgL_tmpz00_2844;
BgL_tmpz00_2844 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2844, BgL_headersz00_526); } 
{ /* Llib/pgp_composition.scm 469 */
int BgL_tmpz00_2847;
BgL_tmpz00_2847 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2847, BgL_val2_1254z00_532); } 
return BgL_mainzd2headerzd2infoz00_523;}  else 
{ /* Llib/pgp_composition.scm 475 */
obj_t BgL_headerz00_538;
BgL_lz00_547 = BgL_lz00_528; 
{ /* Llib/pgp_composition.scm 439 */
obj_t BgL_posz00_549;
{ /* Llib/pgp_composition.scm 439 */

BgL_posz00_549 = 
BGl_stringzd2indexzd2zz__r4_strings_6_7z00(BgL_lz00_547, 
BCHAR(((unsigned char)':')), 
BINT(((long)0))); } 
if(
CBOOL(BgL_posz00_549))
{ /* Llib/pgp_composition.scm 441 */
obj_t BgL_arg1893z00_551;obj_t BgL_arg1894z00_552;
{ /* Llib/pgp_composition.scm 441 */
obj_t BgL_res2191z00_1310;
{ /* Llib/pgp_composition.scm 441 */
long BgL_endz00_1309;
BgL_endz00_1309 = 
(long)CINT(BgL_posz00_549); 
BgL_res2191z00_1310 = 
c_substring(
((obj_t)BgL_lz00_547), ((long)0), BgL_endz00_1309); } 
BgL_arg1893z00_551 = BgL_res2191z00_1310; } 
{ /* Llib/pgp_composition.scm 442 */
long BgL_arg1897z00_555;long BgL_arg1898z00_556;
BgL_arg1897z00_555 = 
(
(long)CINT(BgL_posz00_549)+((long)1)); 
BgL_arg1898z00_556 = 
STRING_LENGTH(
((obj_t)BgL_lz00_547)); 
{ /* Llib/pgp_composition.scm 442 */
obj_t BgL_res2194z00_1318;
BgL_res2194z00_1318 = 
c_substring(
((obj_t)BgL_lz00_547), BgL_arg1897z00_555, BgL_arg1898z00_556); 
BgL_arg1894z00_552 = BgL_res2194z00_1318; } } 
{ /* Llib/pgp_composition.scm 441 */
obj_t BgL_list1895z00_553;
{ /* Llib/pgp_composition.scm 441 */
obj_t BgL_arg1896z00_554;
BgL_arg1896z00_554 = 
MAKE_YOUNG_PAIR(BgL_arg1894z00_552, BNIL); 
BgL_list1895z00_553 = 
MAKE_YOUNG_PAIR(BgL_arg1893z00_551, BgL_arg1896z00_554); } 
BgL_headerz00_538 = BgL_list1895z00_553; } }  else 
{ /* Llib/pgp_composition.scm 440 */
BgL_headerz00_538 = BFALSE; } } 
if(
CBOOL(BgL_headerz00_538))
{ /* Llib/pgp_composition.scm 477 */
obj_t BgL_arg1887z00_539;
BgL_arg1887z00_539 = 
MAKE_YOUNG_PAIR(BgL_headerz00_538, BgL_headersz00_526); 
{ 
obj_t BgL_headersz00_2869;
BgL_headersz00_2869 = BgL_arg1887z00_539; 
BgL_headersz00_526 = BgL_headersz00_2869; 
goto BgL_zc3z04anonymousza31885ze3z87_527;} }  else 
{ 

goto BgL_zc3z04anonymousza31885ze3z87_527;} } } } } } } } 

}



/* safe-read-line~0 */
obj_t BGl_safezd2readzd2lineze70ze7zz__openpgpzd2compositionzd2(obj_t BgL_pz00_543)
{
{ /* Llib/pgp_composition.scm 436 */
{ /* Llib/pgp_composition.scm 433 */
obj_t BgL_lz00_545;
BgL_lz00_545 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_pz00_543); 
{ /* Llib/pgp_composition.scm 434 */
bool_t BgL_test2566z00_2871;
{ /* Llib/pgp_composition.scm 434 */
bool_t BgL_res2190z00_1307;
BgL_res2190z00_1307 = 
EOF_OBJECTP(BgL_lz00_545); 
BgL_test2566z00_2871 = BgL_res2190z00_1307; } 
if(BgL_test2566z00_2871)
{ /* Llib/pgp_composition.scm 434 */
BGl_errorz00zz__errorz00(BGl_string2298z00zz__openpgpzd2compositionzd2, BGl_string2303z00zz__openpgpzd2compositionzd2, BFALSE); }  else 
{ /* Llib/pgp_composition.scm 434 */BFALSE; } } 
return BgL_lz00_545;} } 

}



/* decode-pgp */
BGL_EXPORTED_DEF obj_t BGl_decodezd2pgpzd2zz__openpgpzd2compositionzd2(obj_t BgL_pz00_14)
{
{ /* Llib/pgp_composition.scm 483 */
{ /* Llib/pgp_composition.scm 486 */
obj_t BgL_firstzd2charszd2_579;
BgL_firstzd2charszd2_579 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(((long)10)), BgL_pz00_14); 
BGl_unreadzd2stringz12zc0zz__r4_input_6_10_2z00(BgL_firstzd2charszd2_579, BgL_pz00_14); 
{ /* Llib/pgp_composition.scm 490 */
bool_t BgL_test2567z00_2877;
{ /* Llib/pgp_composition.scm 490 */
bool_t BgL_res2216z00_1373;
if(
(((long)10)==
STRING_LENGTH(
((obj_t)BgL_firstzd2charszd2_579))))
{ /* Llib/pgp_composition.scm 490 */
int BgL_arg1269z00_1363;
{ /* Llib/pgp_composition.scm 490 */
char * BgL_auxz00_2884;char * BgL_tmpz00_2882;
BgL_auxz00_2884 = 
BSTRING_TO_STRING(
((obj_t)BgL_firstzd2charszd2_579)); 
BgL_tmpz00_2882 = 
BSTRING_TO_STRING(BGl_string2300z00zz__openpgpzd2compositionzd2); 
BgL_arg1269z00_1363 = 
memcmp(BgL_tmpz00_2882, BgL_auxz00_2884, ((long)10)); } 
BgL_res2216z00_1373 = 
(
(long)(BgL_arg1269z00_1363)==((long)0)); }  else 
{ /* Llib/pgp_composition.scm 490 */
BgL_res2216z00_1373 = ((bool_t)0); } 
BgL_test2567z00_2877 = BgL_res2216z00_1373; } 
if(BgL_test2567z00_2877)
{ /* Llib/pgp_composition.scm 491 */
obj_t BgL_mainzd2headerzd2infoz00_581;
BgL_mainzd2headerzd2infoz00_581 = 
BGl_decodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(BgL_pz00_14); 
{ /* Llib/pgp_composition.scm 491 */
obj_t BgL_headersz00_582;obj_t BgL_compositionz00_583;
{ /* Llib/pgp_composition.scm 491 */
int BgL_tmpz00_2891;
BgL_tmpz00_2891 = 
(int)(((long)1)); 
BgL_headersz00_582 = 
BGL_MVALUES_VAL(BgL_tmpz00_2891); } 
{ /* Llib/pgp_composition.scm 491 */
int BgL_tmpz00_2894;
BgL_tmpz00_2894 = 
(int)(((long)2)); 
BgL_compositionz00_583 = 
BGL_MVALUES_VAL(BgL_tmpz00_2894); } 
return BgL_compositionz00_583;} }  else 
{ /* Llib/pgp_composition.scm 490 */
return 
BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(
BGl_decodezd2packetszd2zz__openpgpzd2decodezd2(BgL_pz00_14));} } } } 

}



/* &decode-pgp */
obj_t BGl_z62decodezd2pgpzb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1605, obj_t BgL_pz00_1606)
{
{ /* Llib/pgp_composition.scm 483 */
{ /* Llib/pgp_composition.scm 486 */
obj_t BgL_auxz00_2899;
if(
INPUT_PORTP(BgL_pz00_1606))
{ /* Llib/pgp_composition.scm 486 */
BgL_auxz00_2899 = BgL_pz00_1606
; }  else 
{ 
obj_t BgL_auxz00_2902;
BgL_auxz00_2902 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)18018)), BGl_string2304z00zz__openpgpzd2compositionzd2, BGl_string2305z00zz__openpgpzd2compositionzd2, BgL_pz00_1606); 
FAILURE(BgL_auxz00_2902,BFALSE,BFALSE);} 
return 
BGl_decodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_auxz00_2899);} } 

}



/* decode-armored-pgp */
obj_t BGl_decodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(obj_t BgL_pz00_15)
{
{ /* Llib/pgp_composition.scm 501 */
{ /* Llib/pgp_composition.scm 503 */
obj_t BgL_mainzd2headerzd2infoz00_584;
BgL_mainzd2headerzd2infoz00_584 = 
BGl_armoredzd2pipezd2portz00zz__openpgpzd2compositionzd2(BgL_pz00_15); 
{ /* Llib/pgp_composition.scm 505 */
obj_t BgL_headersz00_585;obj_t BgL_ppz00_586;
{ /* Llib/pgp_composition.scm 505 */
int BgL_tmpz00_2908;
BgL_tmpz00_2908 = 
(int)(((long)1)); 
BgL_headersz00_585 = 
BGL_MVALUES_VAL(BgL_tmpz00_2908); } 
{ /* Llib/pgp_composition.scm 505 */
int BgL_tmpz00_2911;
BgL_tmpz00_2911 = 
(int)(((long)2)); 
BgL_ppz00_586 = 
BGL_MVALUES_VAL(BgL_tmpz00_2911); } 
{ /* Llib/pgp_composition.scm 505 */
obj_t BgL_exitd1201z00_587;
BgL_exitd1201z00_587 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/pgp_composition.scm 507 */
obj_t BgL_zc3z04anonymousza31907ze3z87_1607;
BgL_zc3z04anonymousza31907ze3z87_1607 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31907ze3ze5zz__openpgpzd2compositionzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31907ze3z87_1607, 
(int)(((long)0)), BgL_ppz00_586); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1201z00_587, BgL_zc3z04anonymousza31907ze3z87_1607); 
{ /* Llib/pgp_composition.scm 506 */
obj_t BgL_tmp1203z00_589;
{ /* Llib/pgp_composition.scm 506 */
obj_t BgL_val2_1257z00_592;
{ /* Llib/pgp_composition.scm 65 */
obj_t BgL_packetsz00_1379;
BgL_packetsz00_1379 = 
BGl_decodezd2packetszd2zz__openpgpzd2decodezd2(
((obj_t)BgL_ppz00_586)); 
BgL_val2_1257z00_592 = 
BGl_parsezd2packetszd2zz__openpgpzd2compositionzd2(BgL_packetsz00_1379); } 
{ /* Llib/pgp_composition.scm 506 */
int BgL_res2217z00_1380;
{ /* Llib/pgp_composition.scm 506 */
int BgL_tmpz00_2924;
BgL_tmpz00_2924 = 
(int)(((long)3)); 
BgL_res2217z00_1380 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_2924); } BgL_res2217z00_1380; } 
{ /* Llib/pgp_composition.scm 506 */
int BgL_tmpz00_2927;
BgL_tmpz00_2927 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2927, BgL_headersz00_585); } 
{ /* Llib/pgp_composition.scm 506 */
int BgL_tmpz00_2930;
BgL_tmpz00_2930 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_2930, BgL_val2_1257z00_592); } 
BgL_tmp1203z00_589 = BgL_mainzd2headerzd2infoz00_584; } 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1201z00_587); 
bgl_close_input_port(
((obj_t)BgL_ppz00_586)); 
return BgL_tmp1203z00_589;} } } } } } 

}



/* &<@anonymous:1907> */
obj_t BGl_z62zc3z04anonymousza31907ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1608)
{
{ /* Llib/pgp_composition.scm 505 */
{ /* Llib/pgp_composition.scm 507 */
obj_t BgL_ppz00_1609;
BgL_ppz00_1609 = 
PROCEDURE_REF(BgL_envz00_1608, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_ppz00_1609));} } 

}



/* encode-native-pgp */
BGL_EXPORTED_DEF obj_t BGl_encodezd2nativezd2pgpz00zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt BgL_pgpzd2compositionzd2_27, obj_t BgL_pz00_28)
{
{ /* Llib/pgp_composition.scm 590 */
return 
BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_27, BgL_pz00_28);} 

}



/* &encode-native-pgp */
obj_t BGl_z62encodezd2nativezd2pgpz62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1610, obj_t BgL_pgpzd2compositionzd2_1611, obj_t BgL_pz00_1612)
{
{ /* Llib/pgp_composition.scm 590 */
{ /* Llib/pgp_composition.scm 591 */
obj_t BgL_auxz00_2949;BgL_pgpzd2compositionzd2_bglt BgL_auxz00_2941;
if(
OUTPUT_PORTP(BgL_pz00_1612))
{ /* Llib/pgp_composition.scm 591 */
BgL_auxz00_2949 = BgL_pz00_1612
; }  else 
{ 
obj_t BgL_auxz00_2952;
BgL_auxz00_2952 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)22474)), BGl_string2306z00zz__openpgpzd2compositionzd2, BGl_string2308z00zz__openpgpzd2compositionzd2, BgL_pz00_1612); 
FAILURE(BgL_auxz00_2952,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_pgpzd2compositionzd2_1611, BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2))
{ /* Llib/pgp_composition.scm 591 */
BgL_auxz00_2941 = 
((BgL_pgpzd2compositionzd2_bglt)BgL_pgpzd2compositionzd2_1611)
; }  else 
{ 
obj_t BgL_auxz00_2945;
BgL_auxz00_2945 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)22474)), BGl_string2306z00zz__openpgpzd2compositionzd2, BGl_string2307z00zz__openpgpzd2compositionzd2, BgL_pgpzd2compositionzd2_1611); 
FAILURE(BgL_auxz00_2945,BFALSE,BFALSE);} 
return 
BGl_encodezd2nativezd2pgpz00zz__openpgpzd2compositionzd2(BgL_auxz00_2941, BgL_auxz00_2949);} } 

}



/* encode-armored-pgp */
BGL_EXPORTED_DEF obj_t BGl_encodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt BgL_pgpzd2compositionzd2_29, obj_t BgL_mainzd2headerzd2infoz00_30, obj_t BgL_headersz00_31, obj_t BgL_pz00_32)
{
{ /* Llib/pgp_composition.scm 598 */
{ /* Llib/pgp_composition.scm 602 */
obj_t BgL_pstrz00_595;
{ /* Llib/pgp_composition.scm 602 */

{ /* Llib/pgp_composition.scm 602 */

BgL_pstrz00_595 = 
BGl_openzd2outputzd2stringz00zz__r4_ports_6_10_1z00(BTRUE); } } 
BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_29, BgL_pstrz00_595); 
{ /* Llib/pgp_composition.scm 604 */
obj_t BgL_strz00_596;
BgL_strz00_596 = 
bgl_close_output_port(BgL_pstrz00_595); 
{ /* Llib/pgp_composition.scm 604 */
obj_t BgL_b64zd2encodedzd2_597;
{ /* Llib/pgp_composition.scm 605 */

BgL_b64zd2encodedzd2_597 = 
BGl_base64zd2encodezd2zz__base64z00(BgL_strz00_596, 
BINT(((long)76))); } 
{ /* Llib/pgp_composition.scm 605 */
obj_t BgL_crczd2b64zd2_598;
BgL_crczd2b64zd2_598 = 
BGl_createzd2chksum64zd2zz__openpgpzd2compositionzd2(BgL_strz00_596); 
{ /* Llib/pgp_composition.scm 606 */

{ /* Llib/pgp_composition.scm 609 */
obj_t BgL_zc3z04anonymousza31909ze3z87_1613;
BgL_zc3z04anonymousza31909ze3z87_1613 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31909ze3ze5zz__openpgpzd2compositionzd2, 
(int)(((long)0)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31909ze3z87_1613, 
(int)(((long)0)), BgL_mainzd2headerzd2infoz00_30); 
PROCEDURE_SET(BgL_zc3z04anonymousza31909ze3z87_1613, 
(int)(((long)1)), BgL_headersz00_31); 
PROCEDURE_SET(BgL_zc3z04anonymousza31909ze3z87_1613, 
(int)(((long)2)), BgL_b64zd2encodedzd2_597); 
PROCEDURE_SET(BgL_zc3z04anonymousza31909ze3z87_1613, 
(int)(((long)3)), BgL_crczd2b64zd2_598); 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_pz00_32, BgL_zc3z04anonymousza31909ze3z87_1613);} } } } } } } 

}



/* &encode-armored-pgp */
obj_t BGl_z62encodezd2armoredzd2pgpz62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1614, obj_t BgL_pgpzd2compositionzd2_1615, obj_t BgL_mainzd2headerzd2infoz00_1616, obj_t BgL_headersz00_1617, obj_t BgL_pz00_1618)
{
{ /* Llib/pgp_composition.scm 598 */
{ /* Llib/pgp_composition.scm 602 */
obj_t BgL_auxz00_2997;obj_t BgL_auxz00_2990;obj_t BgL_auxz00_2983;BgL_pgpzd2compositionzd2_bglt BgL_auxz00_2975;
if(
OUTPUT_PORTP(BgL_pz00_1618))
{ /* Llib/pgp_composition.scm 602 */
BgL_auxz00_2997 = BgL_pz00_1618
; }  else 
{ 
obj_t BgL_auxz00_3000;
BgL_auxz00_3000 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)23022)), BGl_string2309z00zz__openpgpzd2compositionzd2, BGl_string2308z00zz__openpgpzd2compositionzd2, BgL_pz00_1618); 
FAILURE(BgL_auxz00_3000,BFALSE,BFALSE);} 
if(
BGl_pairzd2orzd2nullzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_headersz00_1617))
{ /* Llib/pgp_composition.scm 602 */
BgL_auxz00_2990 = BgL_headersz00_1617
; }  else 
{ 
obj_t BgL_auxz00_2993;
BgL_auxz00_2993 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)23022)), BGl_string2309z00zz__openpgpzd2compositionzd2, BGl_string2288z00zz__openpgpzd2compositionzd2, BgL_headersz00_1617); 
FAILURE(BgL_auxz00_2993,BFALSE,BFALSE);} 
if(
STRINGP(BgL_mainzd2headerzd2infoz00_1616))
{ /* Llib/pgp_composition.scm 602 */
BgL_auxz00_2983 = BgL_mainzd2headerzd2infoz00_1616
; }  else 
{ 
obj_t BgL_auxz00_2986;
BgL_auxz00_2986 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)23022)), BGl_string2309z00zz__openpgpzd2compositionzd2, BGl_string2310z00zz__openpgpzd2compositionzd2, BgL_mainzd2headerzd2infoz00_1616); 
FAILURE(BgL_auxz00_2986,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_pgpzd2compositionzd2_1615, BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2))
{ /* Llib/pgp_composition.scm 602 */
BgL_auxz00_2975 = 
((BgL_pgpzd2compositionzd2_bglt)BgL_pgpzd2compositionzd2_1615)
; }  else 
{ 
obj_t BgL_auxz00_2979;
BgL_auxz00_2979 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)23022)), BGl_string2309z00zz__openpgpzd2compositionzd2, BGl_string2307z00zz__openpgpzd2compositionzd2, BgL_pgpzd2compositionzd2_1615); 
FAILURE(BgL_auxz00_2979,BFALSE,BFALSE);} 
return 
BGl_encodezd2armoredzd2pgpz00zz__openpgpzd2compositionzd2(BgL_auxz00_2975, BgL_auxz00_2983, BgL_auxz00_2990, BgL_auxz00_2997);} } 

}



/* &<@anonymous:1909> */
obj_t BGl_z62zc3z04anonymousza31909ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1619)
{
{ /* Llib/pgp_composition.scm 608 */
{ /* Llib/pgp_composition.scm 609 */
obj_t BgL_mainzd2headerzd2infoz00_1620;obj_t BgL_headersz00_1621;obj_t BgL_b64zd2encodedzd2_1622;obj_t BgL_crczd2b64zd2_1623;
BgL_mainzd2headerzd2infoz00_1620 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1619, 
(int)(((long)0)))); 
BgL_headersz00_1621 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1619, 
(int)(((long)1)))); 
BgL_b64zd2encodedzd2_1622 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1619, 
(int)(((long)2)))); 
BgL_crczd2b64zd2_1623 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_1619, 
(int)(((long)3)))); 
{ /* Llib/pgp_composition.scm 609 */
obj_t BgL_port1288z00_1859;
{ /* Llib/pgp_composition.scm 609 */
obj_t BgL_res2218z00_1860;
{ /* Llib/pgp_composition.scm 609 */
obj_t BgL_tmpz00_3017;
BgL_tmpz00_3017 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2218z00_1860 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3017); } 
BgL_port1288z00_1859 = BgL_res2218z00_1860; } 
bgl_display_string(BGl_string2311z00zz__openpgpzd2compositionzd2, BgL_port1288z00_1859); 
bgl_display_obj(BgL_mainzd2headerzd2infoz00_1620, BgL_port1288z00_1859); 
bgl_display_string(BGl_string2301z00zz__openpgpzd2compositionzd2, BgL_port1288z00_1859); 
bgl_display_char(((unsigned char)10), BgL_port1288z00_1859); } 
{ 
obj_t BgL_l1290z00_1862;
BgL_l1290z00_1862 = BgL_headersz00_1621; 
BgL_zc3z04anonymousza31910ze3z87_1861:
if(
PAIRP(BgL_l1290z00_1862))
{ /* Llib/pgp_composition.scm 610 */
{ /* Llib/pgp_composition.scm 611 */
obj_t BgL_headerz00_1863;
BgL_headerz00_1863 = 
CAR(BgL_l1290z00_1862); 
{ /* Llib/pgp_composition.scm 611 */
obj_t BgL_port1289z00_1864;
{ /* Llib/pgp_composition.scm 611 */
obj_t BgL_res2220z00_1865;
{ /* Llib/pgp_composition.scm 611 */
obj_t BgL_tmpz00_3027;
BgL_tmpz00_3027 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2220z00_1865 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3027); } 
BgL_port1289z00_1864 = BgL_res2220z00_1865; } 
{ /* Llib/pgp_composition.scm 611 */
obj_t BgL_arg1912z00_1866;
BgL_arg1912z00_1866 = 
CAR(
((obj_t)BgL_headerz00_1863)); 
bgl_display_obj(BgL_arg1912z00_1866, BgL_port1289z00_1864); } 
bgl_display_string(BGl_string2312z00zz__openpgpzd2compositionzd2, BgL_port1289z00_1864); 
{ /* Llib/pgp_composition.scm 611 */
obj_t BgL_arg1913z00_1867;
{ /* Llib/pgp_composition.scm 611 */
obj_t BgL_pairz00_1868;
BgL_pairz00_1868 = 
CDR(
((obj_t)BgL_headerz00_1863)); 
BgL_arg1913z00_1867 = 
CAR(BgL_pairz00_1868); } 
bgl_display_obj(BgL_arg1913z00_1867, BgL_port1289z00_1864); } 
bgl_display_char(((unsigned char)10), BgL_port1289z00_1864); } } 
{ 
obj_t BgL_l1290z00_3039;
BgL_l1290z00_3039 = 
CDR(BgL_l1290z00_1862); 
BgL_l1290z00_1862 = BgL_l1290z00_3039; 
goto BgL_zc3z04anonymousza31910ze3z87_1861;} }  else 
{ /* Llib/pgp_composition.scm 610 */((bool_t)1); } } 
{ /* Llib/pgp_composition.scm 613 */
obj_t BgL_arg1915z00_1869;
{ /* Llib/pgp_composition.scm 613 */
obj_t BgL_res2221z00_1870;
{ /* Llib/pgp_composition.scm 613 */
obj_t BgL_tmpz00_3041;
BgL_tmpz00_3041 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2221z00_1870 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3041); } 
BgL_arg1915z00_1869 = BgL_res2221z00_1870; } 
bgl_display_char(((unsigned char)10), BgL_arg1915z00_1869); } 
{ /* Llib/pgp_composition.scm 614 */
obj_t BgL_port1292z00_1871;
{ /* Llib/pgp_composition.scm 614 */
obj_t BgL_res2222z00_1872;
{ /* Llib/pgp_composition.scm 614 */
obj_t BgL_tmpz00_3045;
BgL_tmpz00_3045 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2222z00_1872 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3045); } 
BgL_port1292z00_1871 = BgL_res2222z00_1872; } 
bgl_display_obj(BgL_b64zd2encodedzd2_1622, BgL_port1292z00_1871); 
bgl_display_char(((unsigned char)10), BgL_port1292z00_1871); } 
{ /* Llib/pgp_composition.scm 615 */
obj_t BgL_arg1916z00_1873;
{ /* Llib/pgp_composition.scm 615 */
obj_t BgL_res2223z00_1874;
{ /* Llib/pgp_composition.scm 615 */
obj_t BgL_tmpz00_3050;
BgL_tmpz00_3050 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2223z00_1874 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3050); } 
BgL_arg1916z00_1873 = BgL_res2223z00_1874; } 
bgl_display_string(BGl_string2313z00zz__openpgpzd2compositionzd2, BgL_arg1916z00_1873); } 
{ /* Llib/pgp_composition.scm 616 */
obj_t BgL_port1293z00_1875;
{ /* Llib/pgp_composition.scm 616 */
obj_t BgL_res2224z00_1876;
{ /* Llib/pgp_composition.scm 616 */
obj_t BgL_tmpz00_3054;
BgL_tmpz00_3054 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2224z00_1876 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3054); } 
BgL_port1293z00_1875 = BgL_res2224z00_1876; } 
bgl_display_obj(BgL_crczd2b64zd2_1623, BgL_port1293z00_1875); 
bgl_display_char(((unsigned char)10), BgL_port1293z00_1875); } 
{ /* Llib/pgp_composition.scm 617 */
obj_t BgL_port1294z00_1877;
{ /* Llib/pgp_composition.scm 617 */
obj_t BgL_res2225z00_1878;
{ /* Llib/pgp_composition.scm 617 */
obj_t BgL_tmpz00_3059;
BgL_tmpz00_3059 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2225z00_1878 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_3059); } 
BgL_port1294z00_1877 = BgL_res2225z00_1878; } 
bgl_display_string(BGl_string2314z00zz__openpgpzd2compositionzd2, BgL_port1294z00_1877); 
bgl_display_obj(BgL_mainzd2headerzd2infoz00_1620, BgL_port1294z00_1877); 
bgl_display_string(BGl_string2301z00zz__openpgpzd2compositionzd2, BgL_port1294z00_1877); 
return 
bgl_display_char(((unsigned char)10), BgL_port1294z00_1877);} } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_arg1920z00_624;obj_t BgL_arg1921z00_625;
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_v1295z00_637;
BgL_v1295z00_637 = 
create_vector(((long)2)); 
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_arg1927z00_638;
BgL_arg1927z00_638 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)13)), BGl_proc2316z00zz__openpgpzd2compositionzd2, BGl_proc2315z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2); 
VECTOR_SET(BgL_v1295z00_637,((long)0),BgL_arg1927z00_638); } 
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_arg1932z00_648;
BgL_arg1932z00_648 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)14)), BGl_proc2318z00zz__openpgpzd2compositionzd2, BGl_proc2317z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1295z00_637,((long)1),BgL_arg1932z00_648); } 
BgL_arg1920z00_624 = BgL_v1295z00_637; } 
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_v1296z00_658;
BgL_v1296z00_658 = 
create_vector(((long)0)); 
BgL_arg1921z00_625 = BgL_v1296z00_658; } 
BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)16)), 
CNST_TABLE_REF(((long)17)), BGl_objectz00zz__objectz00, ((long)38640), BGl_proc2321z00zz__openpgpzd2compositionzd2, BGl_proc2320z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2319z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1920z00_624, BgL_arg1921z00_625); } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1940z00_665;obj_t BgL_arg1941z00_666;
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_v1297z00_680;
BgL_v1297z00_680 = 
create_vector(((long)4)); 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1947z00_681;
BgL_arg1947z00_681 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)18)), BGl_proc2323z00zz__openpgpzd2compositionzd2, BGl_proc2322z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2); 
VECTOR_SET(BgL_v1297z00_680,((long)0),BgL_arg1947z00_681); } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1952z00_691;
BgL_arg1952z00_691 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)14)), BGl_proc2325z00zz__openpgpzd2compositionzd2, BGl_proc2324z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1297z00_680,((long)1),BgL_arg1952z00_691); } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1957z00_701;
BgL_arg1957z00_701 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)19)), BGl_proc2327z00zz__openpgpzd2compositionzd2, BGl_proc2326z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1297z00_680,((long)2),BgL_arg1957z00_701); } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_arg1962z00_711;
BgL_arg1962z00_711 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)20)), BGl_proc2329z00zz__openpgpzd2compositionzd2, BGl_proc2328z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2); 
VECTOR_SET(BgL_v1297z00_680,((long)3),BgL_arg1962z00_711); } 
BgL_arg1940z00_665 = BgL_v1297z00_680; } 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_v1298z00_721;
BgL_v1298z00_721 = 
create_vector(((long)0)); 
BgL_arg1941z00_666 = BgL_v1298z00_721; } 
BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)21)), 
CNST_TABLE_REF(((long)17)), BGl_objectz00zz__objectz00, ((long)25366), BGl_proc2332z00zz__openpgpzd2compositionzd2, BGl_proc2331z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2330z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1940z00_665, BgL_arg1941z00_666); } 
{ /* Llib/pgp_composition.scm 38 */
obj_t BgL_arg1969z00_727;obj_t BgL_arg1970z00_728;
{ /* Llib/pgp_composition.scm 38 */
obj_t BgL_v1299z00_734;
BgL_v1299z00_734 = 
create_vector(((long)0)); 
BgL_arg1969z00_727 = BgL_v1299z00_734; } 
{ /* Llib/pgp_composition.scm 38 */
obj_t BgL_v1300z00_735;
BgL_v1300z00_735 = 
create_vector(((long)0)); 
BgL_arg1970z00_728 = BgL_v1300z00_735; } 
BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)22)), 
CNST_TABLE_REF(((long)17)), BGl_objectz00zz__objectz00, ((long)55391), BFALSE, BGl_proc2334z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2333z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1969z00_727, BgL_arg1970z00_728); } 
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_arg1977z00_741;obj_t BgL_arg1978z00_742;
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_v1301z00_754;
BgL_v1301z00_754 = 
create_vector(((long)2)); 
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_arg1984z00_755;
BgL_arg1984z00_755 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)23)), BGl_proc2336z00zz__openpgpzd2compositionzd2, BGl_proc2335z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)24))); 
VECTOR_SET(BgL_v1301z00_754,((long)0),BgL_arg1984z00_755); } 
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_arg1989z00_765;
BgL_arg1989z00_765 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)25)), BGl_proc2338z00zz__openpgpzd2compositionzd2, BGl_proc2337z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1301z00_754,((long)1),BgL_arg1989z00_765); } 
BgL_arg1977z00_741 = BgL_v1301z00_754; } 
{ /* Llib/pgp_composition.scm 39 */
obj_t BgL_v1302z00_775;
BgL_v1302z00_775 = 
create_vector(((long)0)); 
BgL_arg1978z00_742 = BgL_v1302z00_775; } 
BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)26)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2, ((long)57229), BGl_proc2341z00zz__openpgpzd2compositionzd2, BGl_proc2340z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2339z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1977z00_741, BgL_arg1978z00_742); } 
{ /* Llib/pgp_composition.scm 42 */
obj_t BgL_arg1996z00_781;obj_t BgL_arg1997z00_782;
{ /* Llib/pgp_composition.scm 42 */
obj_t BgL_v1303z00_788;
BgL_v1303z00_788 = 
create_vector(((long)0)); 
BgL_arg1996z00_781 = BgL_v1303z00_788; } 
{ /* Llib/pgp_composition.scm 42 */
obj_t BgL_v1304z00_789;
BgL_v1304z00_789 = 
create_vector(((long)0)); 
BgL_arg1997z00_782 = BgL_v1304z00_789; } 
BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)27)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2, ((long)36885), BFALSE, BGl_proc2343z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2342z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg1996z00_781, BgL_arg1997z00_782); } 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_arg2004z00_795;obj_t BgL_arg2005z00_796;
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_v1305z00_808;
BgL_v1305z00_808 = 
create_vector(((long)2)); 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_arg2011z00_809;
BgL_arg2011z00_809 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)28)), BGl_proc2345z00zz__openpgpzd2compositionzd2, BGl_proc2344z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1305z00_808,((long)0),BgL_arg2011z00_809); } 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_arg2016z00_819;
BgL_arg2016z00_819 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)29)), BGl_proc2347z00zz__openpgpzd2compositionzd2, BGl_proc2346z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2); 
VECTOR_SET(BgL_v1305z00_808,((long)1),BgL_arg2016z00_819); } 
BgL_arg2004z00_795 = BgL_v1305z00_808; } 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_v1306z00_829;
BgL_v1306z00_829 = 
create_vector(((long)0)); 
BgL_arg2005z00_796 = BgL_v1306z00_829; } 
BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)30)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2, ((long)34853), BGl_proc2350z00zz__openpgpzd2compositionzd2, BGl_proc2349z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2348z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2004z00_795, BgL_arg2005z00_796); } 
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_arg2024z00_836;obj_t BgL_arg2025z00_837;
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_v1307z00_849;
BgL_v1307z00_849 = 
create_vector(((long)2)); 
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_arg2031z00_850;
BgL_arg2031z00_850 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)31)), BGl_proc2352z00zz__openpgpzd2compositionzd2, BGl_proc2351z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)32))); 
VECTOR_SET(BgL_v1307z00_849,((long)0),BgL_arg2031z00_850); } 
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_arg2036z00_860;
BgL_arg2036z00_860 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)14)), BGl_proc2354z00zz__openpgpzd2compositionzd2, BGl_proc2353z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1307z00_849,((long)1),BgL_arg2036z00_860); } 
BgL_arg2024z00_836 = BgL_v1307z00_849; } 
{ /* Llib/pgp_composition.scm 47 */
obj_t BgL_v1308z00_870;
BgL_v1308z00_870 = 
create_vector(((long)0)); 
BgL_arg2025z00_837 = BgL_v1308z00_870; } 
BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)33)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2, ((long)53777), BGl_proc2357z00zz__openpgpzd2compositionzd2, BGl_proc2356z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2355z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2024z00_836, BgL_arg2025z00_837); } 
{ /* Llib/pgp_composition.scm 50 */
obj_t BgL_arg2044z00_877;obj_t BgL_arg2045z00_878;
{ /* Llib/pgp_composition.scm 50 */
obj_t BgL_v1309z00_891;
BgL_v1309z00_891 = 
create_vector(((long)1)); 
{ /* Llib/pgp_composition.scm 50 */
obj_t BgL_arg2051z00_892;
BgL_arg2051z00_892 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)34)), BGl_proc2359z00zz__openpgpzd2compositionzd2, BGl_proc2358z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, 
CNST_TABLE_REF(((long)15))); 
VECTOR_SET(BgL_v1309z00_891,((long)0),BgL_arg2051z00_892); } 
BgL_arg2044z00_877 = BgL_v1309z00_891; } 
{ /* Llib/pgp_composition.scm 50 */
obj_t BgL_v1310z00_902;
BgL_v1310z00_902 = 
create_vector(((long)0)); 
BgL_arg2045z00_878 = BgL_v1310z00_902; } 
BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)35)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2, ((long)43793), BGl_proc2362z00zz__openpgpzd2compositionzd2, BGl_proc2361z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2360z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2044z00_877, BgL_arg2045z00_878); } 
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_arg2059z00_909;obj_t BgL_arg2060z00_910;
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_v1311z00_921;
BgL_v1311z00_921 = 
create_vector(((long)1)); 
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_arg2066z00_922;
BgL_arg2066z00_922 = 
BGl_makezd2classzd2fieldz00zz__objectz00(
CNST_TABLE_REF(((long)36)), BGl_proc2364z00zz__openpgpzd2compositionzd2, BGl_proc2363z00zz__openpgpzd2compositionzd2, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2); 
VECTOR_SET(BgL_v1311z00_921,((long)0),BgL_arg2066z00_922); } 
BgL_arg2059z00_909 = BgL_v1311z00_921; } 
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_v1312z00_932;
BgL_v1312z00_932 = 
create_vector(((long)0)); 
BgL_arg2060z00_910 = BgL_v1312z00_932; } 
return ( 
BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2 = 
BGl_registerzd2classz12zc0zz__objectz00(
CNST_TABLE_REF(((long)37)), 
CNST_TABLE_REF(((long)17)), BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2, ((long)54333), BGl_proc2367z00zz__openpgpzd2compositionzd2, BGl_proc2366z00zz__openpgpzd2compositionzd2, BFALSE, BGl_proc2365z00zz__openpgpzd2compositionzd2, BFALSE, BgL_arg2059z00_909, BgL_arg2060z00_910), BUNSPEC) ;} } 

}



/* &<@anonymous:2065> */
obj_t BGl_z62zc3z04anonymousza32065ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1677, obj_t BgL_new1130z00_1678)
{
{ /* Llib/pgp_composition.scm 52 */
{ 
BgL_pgpzd2literalzd2_bglt BgL_auxz00_3162;
{ 
BgL_pgpzd2literalzd2packetz00_bglt BgL_auxz00_3163;
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL_classz00_1880;
BgL_classz00_1880 = BGl_PGPzd2Literalzd2Packetz00zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_composition.scm 52 */
obj_t BgL__ortest_1106z00_1881;
BgL__ortest_1106z00_1881 = 
BGL_CLASS_NIL(BgL_classz00_1880); 
if(
CBOOL(BgL__ortest_1106z00_1881))
{ /* Llib/pgp_composition.scm 52 */
BgL_auxz00_3163 = 
((BgL_pgpzd2literalzd2packetz00_bglt)BgL__ortest_1106z00_1881)
; }  else 
{ /* Llib/pgp_composition.scm 52 */
BgL_auxz00_3163 = 
((BgL_pgpzd2literalzd2packetz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1880))
; } } } 
((((BgL_pgpzd2literalzd2_bglt)COBJECT(
((BgL_pgpzd2literalzd2_bglt)BgL_new1130z00_1678)))->BgL_literalz00)=((BgL_pgpzd2literalzd2packetz00_bglt)BgL_auxz00_3163),BUNSPEC); } 
BgL_auxz00_3162 = 
((BgL_pgpzd2literalzd2_bglt)BgL_new1130z00_1678); 
return 
((obj_t)BgL_auxz00_3162);} } 

}



/* &lambda2063 */
BgL_pgpzd2literalzd2_bglt BGl_z62lambda2063z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1679)
{
{ /* Llib/pgp_composition.scm 52 */
{ /* Llib/pgp_composition.scm 52 */
BgL_pgpzd2literalzd2_bglt BgL_new1129z00_1882;
BgL_new1129z00_1882 = 
((BgL_pgpzd2literalzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2literalzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 52 */
long BgL_arg2064z00_1883;
{ /* Llib/pgp_composition.scm 52 */
long BgL_res2241z00_1884;
BgL_res2241z00_1884 = 
BGL_CLASS_INDEX(BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2); 
BgL_arg2064z00_1883 = BgL_res2241z00_1884; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1129z00_1882), BgL_arg2064z00_1883); } 
{ /* Llib/pgp_composition.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_3178;
BgL_tmpz00_3178 = 
((BgL_objectz00_bglt)BgL_new1129z00_1882); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3178, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1129z00_1882); 
return BgL_new1129z00_1882;} } 

}



/* &lambda2061 */
BgL_pgpzd2literalzd2_bglt BGl_z62lambda2061z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1680, obj_t BgL_literal1128z00_1681)
{
{ /* Llib/pgp_composition.scm 52 */
{ /* Llib/pgp_composition.scm 52 */
BgL_pgpzd2literalzd2_bglt BgL_new1224z00_1886;
{ /* Llib/pgp_composition.scm 52 */
BgL_pgpzd2literalzd2_bglt BgL_new1223z00_1887;
BgL_new1223z00_1887 = 
((BgL_pgpzd2literalzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2literalzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 52 */
long BgL_arg2062z00_1888;
{ /* Llib/pgp_composition.scm 52 */
long BgL_res2240z00_1889;
BgL_res2240z00_1889 = 
BGL_CLASS_INDEX(BGl_PGPzd2Literalzd2zz__openpgpzd2compositionzd2); 
BgL_arg2062z00_1888 = BgL_res2240z00_1889; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1223z00_1887), BgL_arg2062z00_1888); } 
{ /* Llib/pgp_composition.scm 52 */
BgL_objectz00_bglt BgL_tmpz00_3186;
BgL_tmpz00_3186 = 
((BgL_objectz00_bglt)BgL_new1223z00_1887); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3186, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1223z00_1887); 
BgL_new1224z00_1886 = BgL_new1223z00_1887; } 
((((BgL_pgpzd2literalzd2_bglt)COBJECT(BgL_new1224z00_1886))->BgL_literalz00)=((BgL_pgpzd2literalzd2packetz00_bglt)
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_literal1128z00_1681)),BUNSPEC); 
return BgL_new1224z00_1886;} } 

}



/* &lambda2070 */
obj_t BGl_z62lambda2070z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1682, obj_t BgL_oz00_1683, obj_t BgL_vz00_1684)
{
{ /* Llib/pgp_composition.scm 52 */
return 
((((BgL_pgpzd2literalzd2_bglt)COBJECT(
((BgL_pgpzd2literalzd2_bglt)BgL_oz00_1683)))->BgL_literalz00)=((BgL_pgpzd2literalzd2packetz00_bglt)
((BgL_pgpzd2literalzd2packetz00_bglt)BgL_vz00_1684)),BUNSPEC);} 

}



/* &lambda2069 */
BgL_pgpzd2literalzd2packetz00_bglt BGl_z62lambda2069z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1685, obj_t BgL_oz00_1686)
{
{ /* Llib/pgp_composition.scm 52 */
return 
(((BgL_pgpzd2literalzd2_bglt)COBJECT(
((BgL_pgpzd2literalzd2_bglt)BgL_oz00_1686)))->BgL_literalz00);} 

}



/* &<@anonymous:2050> */
obj_t BGl_z62zc3z04anonymousza32050ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1687, obj_t BgL_new1126z00_1688)
{
{ /* Llib/pgp_composition.scm 50 */
{ 
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_auxz00_3197;
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_new1126z00_1688))))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_new1126z00_1688))))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_new1126z00_1688)))->BgL_onezd2passzd2sigsz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_3197 = 
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_new1126z00_1688); 
return 
((obj_t)BgL_auxz00_3197);} } 

}



/* &lambda2048 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BGl_z62lambda2048z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1689)
{
{ /* Llib/pgp_composition.scm 50 */
{ /* Llib/pgp_composition.scm 50 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1125z00_1894;
BgL_new1125z00_1894 = 
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2onezd2passzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 50 */
long BgL_arg2049z00_1895;
{ /* Llib/pgp_composition.scm 50 */
long BgL_res2239z00_1896;
BgL_res2239z00_1896 = 
BGL_CLASS_INDEX(BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BgL_arg2049z00_1895 = BgL_res2239z00_1896; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_1894), BgL_arg2049z00_1895); } 
{ /* Llib/pgp_composition.scm 50 */
BgL_objectz00_bglt BgL_tmpz00_3212;
BgL_tmpz00_3212 = 
((BgL_objectz00_bglt)BgL_new1125z00_1894); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3212, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1125z00_1894); 
return BgL_new1125z00_1894;} } 

}



/* &lambda2046 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BGl_z62lambda2046z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1690, obj_t BgL_msg1122z00_1691, obj_t BgL_sigs1123z00_1692, obj_t BgL_onezd2passzd2sigs1124z00_1693)
{
{ /* Llib/pgp_composition.scm 50 */
{ /* Llib/pgp_composition.scm 50 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1222z00_1899;
{ /* Llib/pgp_composition.scm 50 */
BgL_pgpzd2onezd2passzd2signaturezd2_bglt BgL_new1221z00_1900;
BgL_new1221z00_1900 = 
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2onezd2passzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 50 */
long BgL_arg2047z00_1901;
{ /* Llib/pgp_composition.scm 50 */
long BgL_res2238z00_1902;
BgL_res2238z00_1902 = 
BGL_CLASS_INDEX(BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BgL_arg2047z00_1901 = BgL_res2238z00_1902; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1221z00_1900), BgL_arg2047z00_1901); } 
{ /* Llib/pgp_composition.scm 50 */
BgL_objectz00_bglt BgL_tmpz00_3220;
BgL_tmpz00_3220 = 
((BgL_objectz00_bglt)BgL_new1221z00_1900); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3220, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1221z00_1900); 
BgL_new1222z00_1899 = BgL_new1221z00_1900; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1222z00_1899)))->BgL_msgz00)=((obj_t)BgL_msg1122z00_1691),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1222z00_1899)))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_sigs1123z00_1692)),BUNSPEC); 
((((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(BgL_new1222z00_1899))->BgL_onezd2passzd2sigsz00)=((obj_t)
((obj_t)BgL_onezd2passzd2sigs1124z00_1693)),BUNSPEC); 
return BgL_new1222z00_1899;} } 

}



/* &lambda2055 */
obj_t BGl_z62lambda2055z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1694, obj_t BgL_oz00_1695, obj_t BgL_vz00_1696)
{
{ /* Llib/pgp_composition.scm 50 */
return 
((((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_oz00_1695)))->BgL_onezd2passzd2sigsz00)=((obj_t)
((obj_t)BgL_vz00_1696)),BUNSPEC);} 

}



/* &lambda2054 */
obj_t BGl_z62lambda2054z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1697, obj_t BgL_oz00_1698)
{
{ /* Llib/pgp_composition.scm 50 */
return 
(((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_oz00_1698)))->BgL_onezd2passzd2sigsz00);} 

}



/* &<@anonymous:2030> */
obj_t BGl_z62zc3z04anonymousza32030ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1699, obj_t BgL_new1120z00_1700)
{
{ /* Llib/pgp_composition.scm 47 */
{ 
BgL_pgpzd2signaturezd2_bglt BgL_auxz00_3236;
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1120z00_1700)))->BgL_msgz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_new1120z00_1700)))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_3236 = 
((BgL_pgpzd2signaturezd2_bglt)BgL_new1120z00_1700); 
return 
((obj_t)BgL_auxz00_3236);} } 

}



/* &lambda2028 */
BgL_pgpzd2signaturezd2_bglt BGl_z62lambda2028z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1701)
{
{ /* Llib/pgp_composition.scm 47 */
{ /* Llib/pgp_composition.scm 47 */
BgL_pgpzd2signaturezd2_bglt BgL_new1119z00_1907;
BgL_new1119z00_1907 = 
((BgL_pgpzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 47 */
long BgL_arg2029z00_1908;
{ /* Llib/pgp_composition.scm 47 */
long BgL_res2237z00_1909;
BgL_res2237z00_1909 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BgL_arg2029z00_1908 = BgL_res2237z00_1909; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_1907), BgL_arg2029z00_1908); } 
return BgL_new1119z00_1907;} } 

}



/* &lambda2026 */
BgL_pgpzd2signaturezd2_bglt BGl_z62lambda2026z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1702, obj_t BgL_msg1117z00_1703, obj_t BgL_sigs1118z00_1704)
{
{ /* Llib/pgp_composition.scm 47 */
{ /* Llib/pgp_composition.scm 47 */
BgL_pgpzd2signaturezd2_bglt BgL_new1220z00_1911;
{ /* Llib/pgp_composition.scm 47 */
BgL_pgpzd2signaturezd2_bglt BgL_new1219z00_1912;
BgL_new1219z00_1912 = 
((BgL_pgpzd2signaturezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2signaturezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 47 */
long BgL_arg2027z00_1913;
{ /* Llib/pgp_composition.scm 47 */
long BgL_res2236z00_1914;
BgL_res2236z00_1914 = 
BGL_CLASS_INDEX(BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2); 
BgL_arg2027z00_1913 = BgL_res2236z00_1914; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1219z00_1912), BgL_arg2027z00_1913); } 
BgL_new1220z00_1911 = BgL_new1219z00_1912; } 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1220z00_1911))->BgL_msgz00)=((obj_t)BgL_msg1117z00_1703),BUNSPEC); 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(BgL_new1220z00_1911))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_sigs1118z00_1704)),BUNSPEC); 
return BgL_new1220z00_1911;} } 

}



/* &lambda2040 */
obj_t BGl_z62lambda2040z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1705, obj_t BgL_oz00_1706, obj_t BgL_vz00_1707)
{
{ /* Llib/pgp_composition.scm 47 */
return 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_oz00_1706)))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_vz00_1707)),BUNSPEC);} 

}



/* &lambda2039 */
obj_t BGl_z62lambda2039z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1708, obj_t BgL_oz00_1709)
{
{ /* Llib/pgp_composition.scm 47 */
return 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_oz00_1709)))->BgL_sigsz00);} 

}



/* &lambda2035 */
obj_t BGl_z62lambda2035z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1710, obj_t BgL_oz00_1711, obj_t BgL_vz00_1712)
{
{ /* Llib/pgp_composition.scm 47 */
return 
((((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_oz00_1711)))->BgL_msgz00)=((obj_t)BgL_vz00_1712),BUNSPEC);} 

}



/* &lambda2034 */
obj_t BGl_z62lambda2034z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1713, obj_t BgL_oz00_1714)
{
{ /* Llib/pgp_composition.scm 47 */
return 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_oz00_1714)))->BgL_msgz00);} 

}



/* &<@anonymous:2010> */
obj_t BGl_z62zc3z04anonymousza32010ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1715, obj_t BgL_new1115z00_1716)
{
{ /* Llib/pgp_composition.scm 43 */
{ 
BgL_pgpzd2encryptedzd2_bglt BgL_auxz00_3263;
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_new1115z00_1716)))->BgL_sessionzd2keyszd2)=((obj_t)BNIL),BUNSPEC); 
{ 
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BgL_auxz00_3266;
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL_classz00_1921;
BgL_classz00_1921 = BGl_PGPzd2Symmetricallyzd2Encryptedzd2Packetzd2zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_composition.scm 43 */
obj_t BgL__ortest_1106z00_1922;
BgL__ortest_1106z00_1922 = 
BGL_CLASS_NIL(BgL_classz00_1921); 
if(
CBOOL(BgL__ortest_1106z00_1922))
{ /* Llib/pgp_composition.scm 43 */
BgL_auxz00_3266 = 
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL__ortest_1106z00_1922)
; }  else 
{ /* Llib/pgp_composition.scm 43 */
BgL_auxz00_3266 = 
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1921))
; } } } 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_new1115z00_1716)))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_auxz00_3266),BUNSPEC); } 
BgL_auxz00_3263 = 
((BgL_pgpzd2encryptedzd2_bglt)BgL_new1115z00_1716); 
return 
((obj_t)BgL_auxz00_3263);} } 

}



/* &lambda2008 */
BgL_pgpzd2encryptedzd2_bglt BGl_z62lambda2008z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1717)
{
{ /* Llib/pgp_composition.scm 43 */
{ /* Llib/pgp_composition.scm 43 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1114z00_1923;
BgL_new1114z00_1923 = 
((BgL_pgpzd2encryptedzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2encryptedzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 43 */
long BgL_arg2009z00_1924;
{ /* Llib/pgp_composition.scm 43 */
long BgL_res2235z00_1925;
BgL_res2235z00_1925 = 
BGL_CLASS_INDEX(BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2); 
BgL_arg2009z00_1924 = BgL_res2235z00_1925; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1114z00_1923), BgL_arg2009z00_1924); } 
{ /* Llib/pgp_composition.scm 43 */
BgL_objectz00_bglt BgL_tmpz00_3281;
BgL_tmpz00_3281 = 
((BgL_objectz00_bglt)BgL_new1114z00_1923); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3281, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1114z00_1923); 
return BgL_new1114z00_1923;} } 

}



/* &lambda2006 */
BgL_pgpzd2encryptedzd2_bglt BGl_z62lambda2006z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1718, obj_t BgL_sessionzd2keys1112zd2_1719, obj_t BgL_encryptedzd2data1113zd2_1720)
{
{ /* Llib/pgp_composition.scm 43 */
{ /* Llib/pgp_composition.scm 43 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1218z00_1928;
{ /* Llib/pgp_composition.scm 43 */
BgL_pgpzd2encryptedzd2_bglt BgL_new1217z00_1929;
BgL_new1217z00_1929 = 
((BgL_pgpzd2encryptedzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2encryptedzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 43 */
long BgL_arg2007z00_1930;
{ /* Llib/pgp_composition.scm 43 */
long BgL_res2234z00_1931;
BgL_res2234z00_1931 = 
BGL_CLASS_INDEX(BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2); 
BgL_arg2007z00_1930 = BgL_res2234z00_1931; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1217z00_1929), BgL_arg2007z00_1930); } 
{ /* Llib/pgp_composition.scm 43 */
BgL_objectz00_bglt BgL_tmpz00_3289;
BgL_tmpz00_3289 = 
((BgL_objectz00_bglt)BgL_new1217z00_1929); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3289, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1217z00_1929); 
BgL_new1218z00_1928 = BgL_new1217z00_1929; } 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1218z00_1928))->BgL_sessionzd2keyszd2)=((obj_t)
((obj_t)BgL_sessionzd2keys1112zd2_1719)),BUNSPEC); 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(BgL_new1218z00_1928))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_encryptedzd2data1113zd2_1720)),BUNSPEC); 
return BgL_new1218z00_1928;} } 

}



/* &lambda2020 */
obj_t BGl_z62lambda2020z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1721, obj_t BgL_oz00_1722, obj_t BgL_vz00_1723)
{
{ /* Llib/pgp_composition.scm 43 */
return 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_oz00_1722)))->BgL_encryptedzd2datazd2)=((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)
((BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt)BgL_vz00_1723)),BUNSPEC);} 

}



/* &lambda2019 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BGl_z62lambda2019z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1724, obj_t BgL_oz00_1725)
{
{ /* Llib/pgp_composition.scm 43 */
return 
(((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_oz00_1725)))->BgL_encryptedzd2datazd2);} 

}



/* &lambda2015 */
obj_t BGl_z62lambda2015z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1726, obj_t BgL_oz00_1727, obj_t BgL_vz00_1728)
{
{ /* Llib/pgp_composition.scm 43 */
return 
((((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_oz00_1727)))->BgL_sessionzd2keyszd2)=((obj_t)
((obj_t)BgL_vz00_1728)),BUNSPEC);} 

}



/* &lambda2014 */
obj_t BGl_z62lambda2014z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1729, obj_t BgL_oz00_1730)
{
{ /* Llib/pgp_composition.scm 43 */
return 
(((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_oz00_1730)))->BgL_sessionzd2keyszd2);} 

}



/* &<@anonymous:2000> */
obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1731, obj_t BgL_new1110z00_1732)
{
{ /* Llib/pgp_composition.scm 42 */
return 
((obj_t)
((BgL_pgpzd2messagezd2_bglt)BgL_new1110z00_1732));} 

}



/* &lambda1998 */
BgL_pgpzd2messagezd2_bglt BGl_z62lambda1998z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1733)
{
{ /* Llib/pgp_composition.scm 42 */
{ /* Llib/pgp_composition.scm 42 */
BgL_pgpzd2messagezd2_bglt BgL_new1109z00_1939;
BgL_new1109z00_1939 = 
((BgL_pgpzd2messagezd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2messagezd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 42 */
long BgL_arg1999z00_1940;
{ /* Llib/pgp_composition.scm 42 */
long BgL_res2233z00_1941;
BgL_res2233z00_1941 = 
BGL_CLASS_INDEX(BGl_PGPzd2Messagezd2zz__openpgpzd2compositionzd2); 
BgL_arg1999z00_1940 = BgL_res2233z00_1941; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1109z00_1939), BgL_arg1999z00_1940); } 
return BgL_new1109z00_1939;} } 

}



/* &<@anonymous:1983> */
obj_t BGl_z62zc3z04anonymousza31983ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1734, obj_t BgL_new1107z00_1735)
{
{ /* Llib/pgp_composition.scm 39 */
{ 
BgL_pgpzd2keyzd2_bglt BgL_auxz00_3313;
((((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_new1107z00_1735)))->BgL_subkeysz00)=((obj_t)
MAKE_YOUNG_PAIR(BFALSE, BFALSE)),BUNSPEC); 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_new1107z00_1735)))->BgL_userzd2idszd2)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_3313 = 
((BgL_pgpzd2keyzd2_bglt)BgL_new1107z00_1735); 
return 
((obj_t)BgL_auxz00_3313);} } 

}



/* &lambda1981 */
BgL_pgpzd2keyzd2_bglt BGl_z62lambda1981z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1736)
{
{ /* Llib/pgp_composition.scm 39 */
{ /* Llib/pgp_composition.scm 39 */
BgL_pgpzd2keyzd2_bglt BgL_new1106z00_1943;
BgL_new1106z00_1943 = 
((BgL_pgpzd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2keyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 39 */
long BgL_arg1982z00_1944;
{ /* Llib/pgp_composition.scm 39 */
long BgL_res2232z00_1945;
BgL_res2232z00_1945 = 
BGL_CLASS_INDEX(BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2); 
BgL_arg1982z00_1944 = BgL_res2232z00_1945; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1106z00_1943), BgL_arg1982z00_1944); } 
{ /* Llib/pgp_composition.scm 39 */
BgL_objectz00_bglt BgL_tmpz00_3325;
BgL_tmpz00_3325 = 
((BgL_objectz00_bglt)BgL_new1106z00_1943); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3325, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1106z00_1943); 
return BgL_new1106z00_1943;} } 

}



/* &lambda1979 */
BgL_pgpzd2keyzd2_bglt BGl_z62lambda1979z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1737, obj_t BgL_subkeys1103z00_1738, obj_t BgL_userzd2ids1104zd2_1739)
{
{ /* Llib/pgp_composition.scm 39 */
{ /* Llib/pgp_composition.scm 39 */
BgL_pgpzd2keyzd2_bglt BgL_new1216z00_1948;
{ /* Llib/pgp_composition.scm 39 */
BgL_pgpzd2keyzd2_bglt BgL_new1215z00_1949;
BgL_new1215z00_1949 = 
((BgL_pgpzd2keyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2keyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 39 */
long BgL_arg1980z00_1950;
{ /* Llib/pgp_composition.scm 39 */
long BgL_res2231z00_1951;
BgL_res2231z00_1951 = 
BGL_CLASS_INDEX(BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2); 
BgL_arg1980z00_1950 = BgL_res2231z00_1951; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1215z00_1949), BgL_arg1980z00_1950); } 
{ /* Llib/pgp_composition.scm 39 */
BgL_objectz00_bglt BgL_tmpz00_3333;
BgL_tmpz00_3333 = 
((BgL_objectz00_bglt)BgL_new1215z00_1949); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3333, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1215z00_1949); 
BgL_new1216z00_1948 = BgL_new1215z00_1949; } 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(BgL_new1216z00_1948))->BgL_subkeysz00)=((obj_t)
((obj_t)BgL_subkeys1103z00_1738)),BUNSPEC); 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(BgL_new1216z00_1948))->BgL_userzd2idszd2)=((obj_t)
((obj_t)BgL_userzd2ids1104zd2_1739)),BUNSPEC); 
return BgL_new1216z00_1948;} } 

}



/* &lambda1993 */
obj_t BGl_z62lambda1993z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1740, obj_t BgL_oz00_1741, obj_t BgL_vz00_1742)
{
{ /* Llib/pgp_composition.scm 39 */
return 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_oz00_1741)))->BgL_userzd2idszd2)=((obj_t)
((obj_t)BgL_vz00_1742)),BUNSPEC);} 

}



/* &lambda1992 */
obj_t BGl_z62lambda1992z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1743, obj_t BgL_oz00_1744)
{
{ /* Llib/pgp_composition.scm 39 */
return 
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_oz00_1744)))->BgL_userzd2idszd2);} 

}



/* &lambda1988 */
obj_t BGl_z62lambda1988z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1745, obj_t BgL_oz00_1746, obj_t BgL_vz00_1747)
{
{ /* Llib/pgp_composition.scm 39 */
return 
((((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_oz00_1746)))->BgL_subkeysz00)=((obj_t)
((obj_t)BgL_vz00_1747)),BUNSPEC);} 

}



/* &lambda1987 */
obj_t BGl_z62lambda1987z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1748, obj_t BgL_oz00_1749)
{
{ /* Llib/pgp_composition.scm 39 */
return 
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_oz00_1749)))->BgL_subkeysz00);} 

}



/* &<@anonymous:1973> */
obj_t BGl_z62zc3z04anonymousza31973ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1750, obj_t BgL_new1101z00_1751)
{
{ /* Llib/pgp_composition.scm 38 */
return 
((obj_t)
((BgL_pgpzd2compositionzd2_bglt)BgL_new1101z00_1751));} 

}



/* &lambda1971 */
BgL_pgpzd2compositionzd2_bglt BGl_z62lambda1971z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1752)
{
{ /* Llib/pgp_composition.scm 38 */
{ /* Llib/pgp_composition.scm 38 */
BgL_pgpzd2compositionzd2_bglt BgL_new1100z00_1959;
BgL_new1100z00_1959 = 
((BgL_pgpzd2compositionzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2compositionzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 38 */
long BgL_arg1972z00_1960;
{ /* Llib/pgp_composition.scm 38 */
long BgL_res2230z00_1961;
BgL_res2230z00_1961 = 
BGL_CLASS_INDEX(BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2); 
BgL_arg1972z00_1960 = BgL_res2230z00_1961; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1100z00_1959), BgL_arg1972z00_1960); } 
return BgL_new1100z00_1959;} } 

}



/* &<@anonymous:1946> */
obj_t BGl_z62zc3z04anonymousza31946ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1753, obj_t BgL_new1098z00_1754)
{
{ /* Llib/pgp_composition.scm 33 */
{ 
BgL_pgpzd2subkeyzd2_bglt BgL_auxz00_3357;
{ 
BgL_pgpzd2keyzd2packetz00_bglt BgL_auxz00_3358;
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_classz00_1963;
BgL_classz00_1963 = BGl_PGPzd2Keyzd2Packetz00zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL__ortest_1106z00_1964;
BgL__ortest_1106z00_1964 = 
BGL_CLASS_NIL(BgL_classz00_1963); 
if(
CBOOL(BgL__ortest_1106z00_1964))
{ /* Llib/pgp_composition.scm 33 */
BgL_auxz00_3358 = 
((BgL_pgpzd2keyzd2packetz00_bglt)BgL__ortest_1106z00_1964)
; }  else 
{ /* Llib/pgp_composition.scm 33 */
BgL_auxz00_3358 = 
((BgL_pgpzd2keyzd2packetz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1963))
; } } } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1098z00_1754)))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)BgL_auxz00_3358),BUNSPEC); } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1098z00_1754)))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1098z00_1754)))->BgL_revocationzd2sigszd2)=((obj_t)BNIL),BUNSPEC); 
{ 
BgL_pgpzd2keyzd2_bglt BgL_auxz00_3371;
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL_classz00_1965;
BgL_classz00_1965 = BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2; 
{ /* Llib/pgp_composition.scm 33 */
obj_t BgL__ortest_1106z00_1966;
BgL__ortest_1106z00_1966 = 
BGL_CLASS_NIL(BgL_classz00_1965); 
if(
CBOOL(BgL__ortest_1106z00_1966))
{ /* Llib/pgp_composition.scm 33 */
BgL_auxz00_3371 = 
((BgL_pgpzd2keyzd2_bglt)BgL__ortest_1106z00_1966)
; }  else 
{ /* Llib/pgp_composition.scm 33 */
BgL_auxz00_3371 = 
((BgL_pgpzd2keyzd2_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1965))
; } } } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1098z00_1754)))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)BgL_auxz00_3371),BUNSPEC); } 
BgL_auxz00_3357 = 
((BgL_pgpzd2subkeyzd2_bglt)BgL_new1098z00_1754); 
return 
((obj_t)BgL_auxz00_3357);} } 

}



/* &lambda1944 */
BgL_pgpzd2subkeyzd2_bglt BGl_z62lambda1944z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1755)
{
{ /* Llib/pgp_composition.scm 33 */
{ /* Llib/pgp_composition.scm 33 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1097z00_1967;
BgL_new1097z00_1967 = 
((BgL_pgpzd2subkeyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2subkeyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 33 */
long BgL_arg1945z00_1968;
{ /* Llib/pgp_composition.scm 33 */
long BgL_res2229z00_1969;
BgL_res2229z00_1969 = 
BGL_CLASS_INDEX(BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2); 
BgL_arg1945z00_1968 = BgL_res2229z00_1969; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1097z00_1967), BgL_arg1945z00_1968); } 
{ /* Llib/pgp_composition.scm 33 */
BgL_objectz00_bglt BgL_tmpz00_3386;
BgL_tmpz00_3386 = 
((BgL_objectz00_bglt)BgL_new1097z00_1967); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3386, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1097z00_1967); 
return BgL_new1097z00_1967;} } 

}



/* &lambda1942 */
BgL_pgpzd2subkeyzd2_bglt BGl_z62lambda1942z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1756, obj_t BgL_keyzd2packet1093zd2_1757, obj_t BgL_sigs1094z00_1758, obj_t BgL_revocationzd2sigs1095zd2_1759, obj_t BgL_pgpzd2key1096zd2_1760)
{
{ /* Llib/pgp_composition.scm 33 */
{ /* Llib/pgp_composition.scm 33 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1214z00_1974;
{ /* Llib/pgp_composition.scm 33 */
BgL_pgpzd2subkeyzd2_bglt BgL_new1213z00_1975;
BgL_new1213z00_1975 = 
((BgL_pgpzd2subkeyzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_pgpzd2subkeyzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 33 */
long BgL_arg1943z00_1976;
{ /* Llib/pgp_composition.scm 33 */
long BgL_res2228z00_1977;
BgL_res2228z00_1977 = 
BGL_CLASS_INDEX(BGl_PGPzd2Subkeyzd2zz__openpgpzd2compositionzd2); 
BgL_arg1943z00_1976 = BgL_res2228z00_1977; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1213z00_1975), BgL_arg1943z00_1976); } 
{ /* Llib/pgp_composition.scm 33 */
BgL_objectz00_bglt BgL_tmpz00_3394;
BgL_tmpz00_3394 = 
((BgL_objectz00_bglt)BgL_new1213z00_1975); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3394, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1213z00_1975); 
BgL_new1214z00_1974 = BgL_new1213z00_1975; } 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1214z00_1974))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_keyzd2packet1093zd2_1757)),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1214z00_1974))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_sigs1094z00_1758)),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1214z00_1974))->BgL_revocationzd2sigszd2)=((obj_t)
((obj_t)BgL_revocationzd2sigs1095zd2_1759)),BUNSPEC); 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(BgL_new1214z00_1974))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)
((BgL_pgpzd2keyzd2_bglt)BgL_pgpzd2key1096zd2_1760)),BUNSPEC); 
return BgL_new1214z00_1974;} } 

}



/* &lambda1966 */
obj_t BGl_z62lambda1966z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1761, obj_t BgL_oz00_1762, obj_t BgL_vz00_1763)
{
{ /* Llib/pgp_composition.scm 33 */
return 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1762)))->BgL_pgpzd2keyzd2)=((BgL_pgpzd2keyzd2_bglt)
((BgL_pgpzd2keyzd2_bglt)BgL_vz00_1763)),BUNSPEC);} 

}



/* &lambda1965 */
BgL_pgpzd2keyzd2_bglt BGl_z62lambda1965z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1764, obj_t BgL_oz00_1765)
{
{ /* Llib/pgp_composition.scm 33 */
return 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1765)))->BgL_pgpzd2keyzd2);} 

}



/* &lambda1961 */
obj_t BGl_z62lambda1961z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1766, obj_t BgL_oz00_1767, obj_t BgL_vz00_1768)
{
{ /* Llib/pgp_composition.scm 33 */
return 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1767)))->BgL_revocationzd2sigszd2)=((obj_t)
((obj_t)BgL_vz00_1768)),BUNSPEC);} 

}



/* &lambda1960 */
obj_t BGl_z62lambda1960z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1769, obj_t BgL_oz00_1770)
{
{ /* Llib/pgp_composition.scm 33 */
return 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1770)))->BgL_revocationzd2sigszd2);} 

}



/* &lambda1956 */
obj_t BGl_z62lambda1956z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1771, obj_t BgL_oz00_1772, obj_t BgL_vz00_1773)
{
{ /* Llib/pgp_composition.scm 33 */
return 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1772)))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_vz00_1773)),BUNSPEC);} 

}



/* &lambda1955 */
obj_t BGl_z62lambda1955z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1774, obj_t BgL_oz00_1775)
{
{ /* Llib/pgp_composition.scm 33 */
return 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1775)))->BgL_sigsz00);} 

}



/* &lambda1951 */
obj_t BGl_z62lambda1951z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1776, obj_t BgL_oz00_1777, obj_t BgL_vz00_1778)
{
{ /* Llib/pgp_composition.scm 33 */
return 
((((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1777)))->BgL_keyzd2packetzd2)=((BgL_pgpzd2keyzd2packetz00_bglt)
((BgL_pgpzd2keyzd2packetz00_bglt)BgL_vz00_1778)),BUNSPEC);} 

}



/* &lambda1950 */
BgL_pgpzd2keyzd2packetz00_bglt BGl_z62lambda1950z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1779, obj_t BgL_oz00_1780)
{
{ /* Llib/pgp_composition.scm 33 */
return 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_oz00_1780)))->BgL_keyzd2packetzd2);} 

}



/* &<@anonymous:1926> */
obj_t BGl_z62zc3z04anonymousza31926ze3ze5zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1781, obj_t BgL_new1091z00_1782)
{
{ /* Llib/pgp_composition.scm 30 */
{ 
BgL_signedzd2idzd2_bglt BgL_auxz00_3426;
{ 
BgL_pgpzd2idzd2packetz00_bglt BgL_auxz00_3427;
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL_classz00_1991;
BgL_classz00_1991 = BGl_PGPzd2IDzd2Packetz00zz__openpgpzd2packetszd2; 
{ /* Llib/pgp_composition.scm 30 */
obj_t BgL__ortest_1106z00_1992;
BgL__ortest_1106z00_1992 = 
BGL_CLASS_NIL(BgL_classz00_1991); 
if(
CBOOL(BgL__ortest_1106z00_1992))
{ /* Llib/pgp_composition.scm 30 */
BgL_auxz00_3427 = 
((BgL_pgpzd2idzd2packetz00_bglt)BgL__ortest_1106z00_1992)
; }  else 
{ /* Llib/pgp_composition.scm 30 */
BgL_auxz00_3427 = 
((BgL_pgpzd2idzd2packetz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_1991))
; } } } 
((((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_new1091z00_1782)))->BgL_idz00)=((BgL_pgpzd2idzd2packetz00_bglt)BgL_auxz00_3427),BUNSPEC); } 
((((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_new1091z00_1782)))->BgL_sigsz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_3426 = 
((BgL_signedzd2idzd2_bglt)BgL_new1091z00_1782); 
return 
((obj_t)BgL_auxz00_3426);} } 

}



/* &lambda1924 */
BgL_signedzd2idzd2_bglt BGl_z62lambda1924z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1783)
{
{ /* Llib/pgp_composition.scm 30 */
{ /* Llib/pgp_composition.scm 30 */
BgL_signedzd2idzd2_bglt BgL_new1090z00_1993;
BgL_new1090z00_1993 = 
((BgL_signedzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_signedzd2idzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 30 */
long BgL_arg1925z00_1994;
{ /* Llib/pgp_composition.scm 30 */
long BgL_res2227z00_1995;
BgL_res2227z00_1995 = 
BGL_CLASS_INDEX(BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2); 
BgL_arg1925z00_1994 = BgL_res2227z00_1995; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1090z00_1993), BgL_arg1925z00_1994); } 
{ /* Llib/pgp_composition.scm 30 */
BgL_objectz00_bglt BgL_tmpz00_3444;
BgL_tmpz00_3444 = 
((BgL_objectz00_bglt)BgL_new1090z00_1993); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3444, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1090z00_1993); 
return BgL_new1090z00_1993;} } 

}



/* &lambda1922 */
BgL_signedzd2idzd2_bglt BGl_z62lambda1922z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1784, obj_t BgL_id1088z00_1785, obj_t BgL_sigs1089z00_1786)
{
{ /* Llib/pgp_composition.scm 30 */
{ /* Llib/pgp_composition.scm 30 */
BgL_signedzd2idzd2_bglt BgL_new1212z00_1998;
{ /* Llib/pgp_composition.scm 30 */
BgL_signedzd2idzd2_bglt BgL_new1211z00_1999;
BgL_new1211z00_1999 = 
((BgL_signedzd2idzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_signedzd2idzd2_bgl) ))); 
{ /* Llib/pgp_composition.scm 30 */
long BgL_arg1923z00_2000;
{ /* Llib/pgp_composition.scm 30 */
long BgL_res2226z00_2001;
BgL_res2226z00_2001 = 
BGL_CLASS_INDEX(BGl_Signedzd2IDzd2zz__openpgpzd2compositionzd2); 
BgL_arg1923z00_2000 = BgL_res2226z00_2001; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1211z00_1999), BgL_arg1923z00_2000); } 
{ /* Llib/pgp_composition.scm 30 */
BgL_objectz00_bglt BgL_tmpz00_3452;
BgL_tmpz00_3452 = 
((BgL_objectz00_bglt)BgL_new1211z00_1999); 
BGL_OBJECT_WIDENING_SET(BgL_tmpz00_3452, BFALSE); } 
((BgL_objectz00_bglt)BgL_new1211z00_1999); 
BgL_new1212z00_1998 = BgL_new1211z00_1999; } 
((((BgL_signedzd2idzd2_bglt)COBJECT(BgL_new1212z00_1998))->BgL_idz00)=((BgL_pgpzd2idzd2packetz00_bglt)
((BgL_pgpzd2idzd2packetz00_bglt)BgL_id1088z00_1785)),BUNSPEC); 
((((BgL_signedzd2idzd2_bglt)COBJECT(BgL_new1212z00_1998))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_sigs1089z00_1786)),BUNSPEC); 
return BgL_new1212z00_1998;} } 

}



/* &lambda1936 */
obj_t BGl_z62lambda1936z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1787, obj_t BgL_oz00_1788, obj_t BgL_vz00_1789)
{
{ /* Llib/pgp_composition.scm 30 */
return 
((((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_oz00_1788)))->BgL_sigsz00)=((obj_t)
((obj_t)BgL_vz00_1789)),BUNSPEC);} 

}



/* &lambda1935 */
obj_t BGl_z62lambda1935z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1790, obj_t BgL_oz00_1791)
{
{ /* Llib/pgp_composition.scm 30 */
return 
(((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_oz00_1791)))->BgL_sigsz00);} 

}



/* &lambda1931 */
obj_t BGl_z62lambda1931z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1792, obj_t BgL_oz00_1793, obj_t BgL_vz00_1794)
{
{ /* Llib/pgp_composition.scm 30 */
return 
((((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_oz00_1793)))->BgL_idz00)=((BgL_pgpzd2idzd2packetz00_bglt)
((BgL_pgpzd2idzd2packetz00_bglt)BgL_vz00_1794)),BUNSPEC);} 

}



/* &lambda1930 */
BgL_pgpzd2idzd2packetz00_bglt BGl_z62lambda1930z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1795, obj_t BgL_oz00_1796)
{
{ /* Llib/pgp_composition.scm 30 */
return 
(((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_oz00_1796)))->BgL_idz00);} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_proc2368z00zz__openpgpzd2compositionzd2, BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2, BGl_string2369z00zz__openpgpzd2compositionzd2);} 

}



/* &encode-pgp1313 */
obj_t BGl_z62encodezd2pgp1313zb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1798, obj_t BgL_thisz00_1799, obj_t BgL_pz00_1800)
{
{ /* Llib/pgp_composition.scm 519 */
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)38)), BGl_string2370z00zz__openpgpzd2compositionzd2, 
((obj_t)
((BgL_pgpzd2compositionzd2_bglt)BgL_thisz00_1799)));} 

}



/* encode-pgp */
obj_t BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_pgpzd2compositionzd2_bglt BgL_thisz00_17, obj_t BgL_pz00_18)
{
{ /* Llib/pgp_composition.scm 519 */
{ /* Llib/pgp_composition.scm 519 */
obj_t BgL_method1314z00_941;
{ /* Llib/pgp_composition.scm 519 */
obj_t BgL_res2252z00_1570;
{ /* Llib/pgp_composition.scm 519 */
long BgL_objzd2classzd2numz00_1535;
{ /* Llib/pgp_composition.scm 519 */
long BgL_res2242z00_1538;
BgL_res2242z00_1538 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_thisz00_17)); 
BgL_objzd2classzd2numz00_1535 = BgL_res2242z00_1538; } 
{ /* Llib/pgp_composition.scm 519 */
obj_t BgL_arg1759z00_1536;
BgL_arg1759z00_1536 = 
PROCEDURE_REF(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, 
(int)(((long)1))); 
{ /* Llib/pgp_composition.scm 519 */
int BgL_offsetz00_1540;
BgL_offsetz00_1540 = 
(int)(BgL_objzd2classzd2numz00_1535); 
{ /* Llib/pgp_composition.scm 519 */
long BgL_offsetz00_1541;
BgL_offsetz00_1541 = 
(
(long)(BgL_offsetz00_1540)-OBJECT_TYPE); 
{ /* Llib/pgp_composition.scm 519 */
long BgL_modz00_1542;
BgL_modz00_1542 = 
(BgL_offsetz00_1541 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Llib/pgp_composition.scm 519 */
long BgL_restz00_1544;
BgL_restz00_1544 = 
(BgL_offsetz00_1541 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Llib/pgp_composition.scm 519 */

{ /* Llib/pgp_composition.scm 519 */
obj_t BgL_bucketz00_1546;
BgL_bucketz00_1546 = 
VECTOR_REF(
((obj_t)BgL_arg1759z00_1536),BgL_modz00_1542); 
BgL_res2252z00_1570 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_1546),BgL_restz00_1544); } } } } } } } } 
BgL_method1314z00_941 = BgL_res2252z00_1570; } 
return 
PROCEDURE_ENTRY(BgL_method1314z00_941)(BgL_method1314z00_941, 
((obj_t)BgL_thisz00_17), BgL_pz00_18, BEOA);} } 

}



/* &encode-pgp */
obj_t BGl_z62encodezd2pgpzb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1801, obj_t BgL_thisz00_1802, obj_t BgL_pz00_1803)
{
{ /* Llib/pgp_composition.scm 519 */
{ /* Llib/pgp_composition.scm 519 */
obj_t BgL_auxz00_3514;BgL_pgpzd2compositionzd2_bglt BgL_auxz00_3506;
if(
OUTPUT_PORTP(BgL_pz00_1803))
{ /* Llib/pgp_composition.scm 519 */
BgL_auxz00_3514 = BgL_pz00_1803
; }  else 
{ 
obj_t BgL_auxz00_3517;
BgL_auxz00_3517 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)19433)), BGl_string2371z00zz__openpgpzd2compositionzd2, BGl_string2308z00zz__openpgpzd2compositionzd2, BgL_pz00_1803); 
FAILURE(BgL_auxz00_3517,BFALSE,BFALSE);} 
if(
BGl_isazf3zf3zz__objectz00(BgL_thisz00_1802, BGl_PGPzd2Compositionzd2zz__openpgpzd2compositionzd2))
{ /* Llib/pgp_composition.scm 519 */
BgL_auxz00_3506 = 
((BgL_pgpzd2compositionzd2_bglt)BgL_thisz00_1802)
; }  else 
{ 
obj_t BgL_auxz00_3510;
BgL_auxz00_3510 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2286z00zz__openpgpzd2compositionzd2, 
BINT(((long)19433)), BGl_string2371z00zz__openpgpzd2compositionzd2, BGl_string2307z00zz__openpgpzd2compositionzd2, BgL_thisz00_1802); 
FAILURE(BgL_auxz00_3510,BFALSE,BFALSE);} 
return 
BGl_encodezd2pgpzd2zz__openpgpzd2compositionzd2(BgL_auxz00_3506, BgL_auxz00_3514);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_PGPzd2Keyzd2zz__openpgpzd2compositionzd2, BGl_proc2372z00zz__openpgpzd2compositionzd2, BGl_string2373z00zz__openpgpzd2compositionzd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_PGPzd2Onezd2Passzd2Signaturezd2zz__openpgpzd2compositionzd2, BGl_proc2374z00zz__openpgpzd2compositionzd2, BGl_string2373z00zz__openpgpzd2compositionzd2); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_PGPzd2Signaturezd2zz__openpgpzd2compositionzd2, BGl_proc2375z00zz__openpgpzd2compositionzd2, BGl_string2373z00zz__openpgpzd2compositionzd2); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_encodezd2pgpzd2envz00zz__openpgpzd2compositionzd2, BGl_PGPzd2Encryptedzd2zz__openpgpzd2compositionzd2, BGl_proc2376z00zz__openpgpzd2compositionzd2, BGl_string2373z00zz__openpgpzd2compositionzd2);} 

}



/* &encode-pgp-PGP-Encry1322 */
obj_t BGl_z62encodezd2pgpzd2PGPzd2Encry1322zb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1808, obj_t BgL_thisz00_1809, obj_t BgL_pz00_1810)
{
{ /* Llib/pgp_composition.scm 580 */
{ /* Llib/pgp_composition.scm 582 */
obj_t BgL_g1287z00_2012;
BgL_g1287z00_2012 = 
(((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_thisz00_1809)))->BgL_sessionzd2keyszd2); 
{ 
obj_t BgL_l1285z00_2014;
BgL_l1285z00_2014 = BgL_g1287z00_2012; 
BgL_zc3z04anonymousza32108ze3z87_2013:
if(
PAIRP(BgL_l1285z00_2014))
{ /* Llib/pgp_composition.scm 582 */
{ /* Llib/pgp_composition.scm 583 */
obj_t BgL_sessionzd2keyzd2_2015;
BgL_sessionzd2keyzd2_2015 = 
CAR(BgL_l1285z00_2014); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sessionzd2keyzd2_2015), 
((obj_t)BgL_pz00_1810)); } 
{ 
obj_t BgL_l1285z00_3534;
BgL_l1285z00_3534 = 
CDR(BgL_l1285z00_2014); 
BgL_l1285z00_2014 = BgL_l1285z00_3534; 
goto BgL_zc3z04anonymousza32108ze3z87_2013;} }  else 
{ /* Llib/pgp_composition.scm 582 */((bool_t)1); } } } 
{ /* Llib/pgp_composition.scm 585 */
BgL_pgpzd2symmetricallyzd2encryptedzd2packetzd2_bglt BgL_arg2111z00_2016;
BgL_arg2111z00_2016 = 
(((BgL_pgpzd2encryptedzd2_bglt)COBJECT(
((BgL_pgpzd2encryptedzd2_bglt)BgL_thisz00_1809)))->BgL_encryptedzd2datazd2); 
return 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2111z00_2016), 
((obj_t)BgL_pz00_1810));} } 

}



/* &encode-pgp-PGP-Signa1320 */
obj_t BGl_z62encodezd2pgpzd2PGPzd2Signa1320zb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1811, obj_t BgL_thisz00_1812, obj_t BgL_pz00_1813)
{
{ /* Llib/pgp_composition.scm 570 */
{ /* Llib/pgp_composition.scm 572 */
obj_t BgL_g1284z00_2019;
BgL_g1284z00_2019 = 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_thisz00_1812)))->BgL_sigsz00); 
{ 
obj_t BgL_l1282z00_2021;
BgL_l1282z00_2021 = BgL_g1284z00_2019; 
BgL_zc3z04anonymousza32103ze3z87_2020:
if(
PAIRP(BgL_l1282z00_2021))
{ /* Llib/pgp_composition.scm 572 */
{ /* Llib/pgp_composition.scm 573 */
obj_t BgL_sigz00_2022;
BgL_sigz00_2022 = 
CAR(BgL_l1282z00_2021); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sigz00_2022), 
((obj_t)BgL_pz00_1813)); } 
{ 
obj_t BgL_l1282z00_3549;
BgL_l1282z00_3549 = 
CDR(BgL_l1282z00_2021); 
BgL_l1282z00_2021 = BgL_l1282z00_3549; 
goto BgL_zc3z04anonymousza32103ze3z87_2020;} }  else 
{ /* Llib/pgp_composition.scm 572 */((bool_t)1); } } } 
if(
CBOOL(
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_thisz00_1812)))->BgL_msgz00)))
{ /* Llib/pgp_composition.scm 575 */
obj_t BgL_arg2107z00_2023;
BgL_arg2107z00_2023 = 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)BgL_thisz00_1812)))->BgL_msgz00); 
return 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2107z00_2023), 
((obj_t)BgL_pz00_1813));}  else 
{ /* Llib/pgp_composition.scm 575 */
return BFALSE;} } 

}



/* &encode-pgp-PGP-One-P1318 */
obj_t BGl_z62encodezd2pgpzd2PGPzd2Onezd2P1318z62zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1814, obj_t BgL_thisz00_1815, obj_t BgL_pz00_1816)
{
{ /* Llib/pgp_composition.scm 557 */
{ /* Llib/pgp_composition.scm 558 */
bool_t BgL_tmpz00_3560;
{ /* Llib/pgp_composition.scm 559 */
obj_t BgL_g1278z00_2026;
BgL_g1278z00_2026 = 
bgl_reverse(
(((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_thisz00_1815)))->BgL_onezd2passzd2sigsz00)); 
{ 
obj_t BgL_l1276z00_2028;
BgL_l1276z00_2028 = BgL_g1278z00_2026; 
BgL_zc3z04anonymousza32095ze3z87_2027:
if(
PAIRP(BgL_l1276z00_2028))
{ /* Llib/pgp_composition.scm 561 */
{ /* Llib/pgp_composition.scm 560 */
obj_t BgL_opsz00_2029;
BgL_opsz00_2029 = 
CAR(BgL_l1276z00_2028); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_opsz00_2029), 
((obj_t)BgL_pz00_1816)); } 
{ 
obj_t BgL_l1276z00_3570;
BgL_l1276z00_3570 = 
CDR(BgL_l1276z00_2028); 
BgL_l1276z00_2028 = BgL_l1276z00_3570; 
goto BgL_zc3z04anonymousza32095ze3z87_2027;} }  else 
{ /* Llib/pgp_composition.scm 561 */((bool_t)1); } } } 
{ /* Llib/pgp_composition.scm 562 */
obj_t BgL_arg2099z00_2030;
BgL_arg2099z00_2030 = 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_thisz00_1815))))->BgL_msgz00); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2099z00_2030), 
((obj_t)BgL_pz00_1816)); } 
{ /* Llib/pgp_composition.scm 563 */
obj_t BgL_g1281z00_2031;
BgL_g1281z00_2031 = 
(((BgL_pgpzd2signaturezd2_bglt)COBJECT(
((BgL_pgpzd2signaturezd2_bglt)
((BgL_pgpzd2onezd2passzd2signaturezd2_bglt)BgL_thisz00_1815))))->BgL_sigsz00); 
{ 
obj_t BgL_l1279z00_2033;
BgL_l1279z00_2033 = BgL_g1281z00_2031; 
BgL_zc3z04anonymousza32100ze3z87_2032:
if(
PAIRP(BgL_l1279z00_2033))
{ /* Llib/pgp_composition.scm 563 */
{ /* Llib/pgp_composition.scm 564 */
obj_t BgL_sigz00_2034;
BgL_sigz00_2034 = 
CAR(BgL_l1279z00_2033); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sigz00_2034), 
((obj_t)BgL_pz00_1816)); } 
{ 
obj_t BgL_l1279z00_3587;
BgL_l1279z00_3587 = 
CDR(BgL_l1279z00_2033); 
BgL_l1279z00_2033 = BgL_l1279z00_3587; 
goto BgL_zc3z04anonymousza32100ze3z87_2032;} }  else 
{ /* Llib/pgp_composition.scm 563 */
BgL_tmpz00_3560 = ((bool_t)1)
; } } } 
return 
BBOOL(BgL_tmpz00_3560);} } 

}



/* &encode-pgp-PGP-Key1316 */
obj_t BGl_z62encodezd2pgpzd2PGPzd2Key1316zb0zz__openpgpzd2compositionzd2(obj_t BgL_envz00_1817, obj_t BgL_thisz00_1818, obj_t BgL_pz00_1819)
{
{ /* Llib/pgp_composition.scm 527 */
{ /* Llib/pgp_composition.scm 528 */
bool_t BgL_tmpz00_3590;
{ /* Llib/pgp_composition.scm 529 */
obj_t BgL_mainzd2keyzd2_2037;
BgL_mainzd2keyzd2_2037 = 
CAR(
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_thisz00_1818)))->BgL_subkeysz00)); 
{ /* Llib/pgp_composition.scm 529 */
obj_t BgL_otherzd2subkeyszd2_2038;
BgL_otherzd2subkeyszd2_2038 = 
CDR(
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_thisz00_1818)))->BgL_subkeysz00)); 
{ /* Llib/pgp_composition.scm 530 */

{ /* Llib/pgp_composition.scm 532 */
BgL_pgpzd2keyzd2packetz00_bglt BgL_arg2072z00_2039;
BgL_arg2072z00_2039 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_mainzd2keyzd2_2037)))->BgL_keyzd2packetzd2); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2072z00_2039), 
((obj_t)BgL_pz00_1819)); } 
{ /* Llib/pgp_composition.scm 533 */
obj_t BgL_g1261z00_2040;
BgL_g1261z00_2040 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_mainzd2keyzd2_2037)))->BgL_revocationzd2sigszd2); 
{ 
obj_t BgL_l1258z00_2042;
BgL_l1258z00_2042 = BgL_g1261z00_2040; 
BgL_zc3z04anonymousza32073ze3z87_2041:
if(
PAIRP(BgL_l1258z00_2042))
{ /* Llib/pgp_composition.scm 533 */
{ /* Llib/pgp_composition.scm 533 */
obj_t BgL_revoczd2sigzd2_2043;
BgL_revoczd2sigzd2_2043 = 
CAR(BgL_l1258z00_2042); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_revoczd2sigzd2_2043), 
((obj_t)BgL_pz00_1819)); } 
{ 
obj_t BgL_l1258z00_3610;
BgL_l1258z00_3610 = 
CDR(BgL_l1258z00_2042); 
BgL_l1258z00_2042 = BgL_l1258z00_3610; 
goto BgL_zc3z04anonymousza32073ze3z87_2041;} }  else 
{ /* Llib/pgp_composition.scm 533 */((bool_t)1); } } } 
{ /* Llib/pgp_composition.scm 535 */
obj_t BgL_g1267z00_2044;
BgL_g1267z00_2044 = 
(((BgL_pgpzd2keyzd2_bglt)COBJECT(
((BgL_pgpzd2keyzd2_bglt)BgL_thisz00_1818)))->BgL_userzd2idszd2); 
{ 
obj_t BgL_l1265z00_2046;
BgL_l1265z00_2046 = BgL_g1267z00_2044; 
BgL_zc3z04anonymousza32076ze3z87_2045:
if(
PAIRP(BgL_l1265z00_2046))
{ /* Llib/pgp_composition.scm 535 */
{ /* Llib/pgp_composition.scm 536 */
obj_t BgL_userzd2idzd2_2047;
BgL_userzd2idzd2_2047 = 
CAR(BgL_l1265z00_2046); 
{ /* Llib/pgp_composition.scm 537 */
BgL_pgpzd2idzd2packetz00_bglt BgL_arg2078z00_2048;
BgL_arg2078z00_2048 = 
(((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_userzd2idzd2_2047)))->BgL_idz00); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2078z00_2048), 
((obj_t)BgL_pz00_1819)); } 
{ /* Llib/pgp_composition.scm 538 */
obj_t BgL_g1264z00_2049;
BgL_g1264z00_2049 = 
(((BgL_signedzd2idzd2_bglt)COBJECT(
((BgL_signedzd2idzd2_bglt)BgL_userzd2idzd2_2047)))->BgL_sigsz00); 
{ 
obj_t BgL_l1262z00_2051;
BgL_l1262z00_2051 = BgL_g1264z00_2049; 
BgL_zc3z04anonymousza32079ze3z87_2050:
if(
PAIRP(BgL_l1262z00_2051))
{ /* Llib/pgp_composition.scm 538 */
{ /* Llib/pgp_composition.scm 539 */
obj_t BgL_sigz00_2052;
BgL_sigz00_2052 = 
CAR(BgL_l1262z00_2051); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sigz00_2052), 
((obj_t)BgL_pz00_1819)); } 
{ 
obj_t BgL_l1262z00_3630;
BgL_l1262z00_3630 = 
CDR(BgL_l1262z00_2051); 
BgL_l1262z00_2051 = BgL_l1262z00_3630; 
goto BgL_zc3z04anonymousza32079ze3z87_2050;} }  else 
{ /* Llib/pgp_composition.scm 538 */((bool_t)1); } } } } 
{ 
obj_t BgL_l1265z00_3632;
BgL_l1265z00_3632 = 
CDR(BgL_l1265z00_2046); 
BgL_l1265z00_2046 = BgL_l1265z00_3632; 
goto BgL_zc3z04anonymousza32076ze3z87_2045;} }  else 
{ /* Llib/pgp_composition.scm 535 */((bool_t)1); } } } 
{ 
obj_t BgL_l1274z00_2054;
BgL_l1274z00_2054 = BgL_otherzd2subkeyszd2_2038; 
BgL_zc3z04anonymousza32083ze3z87_2053:
if(
PAIRP(BgL_l1274z00_2054))
{ /* Llib/pgp_composition.scm 542 */
{ /* Llib/pgp_composition.scm 543 */
obj_t BgL_subkeyz00_2055;
BgL_subkeyz00_2055 = 
CAR(BgL_l1274z00_2054); 
{ /* Llib/pgp_composition.scm 545 */
BgL_pgpzd2keyzd2packetz00_bglt BgL_arg2085z00_2056;
BgL_arg2085z00_2056 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_subkeyz00_2055)))->BgL_keyzd2packetzd2); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_arg2085z00_2056), 
((obj_t)BgL_pz00_1819)); } 
{ /* Llib/pgp_composition.scm 546 */
obj_t BgL_g1270z00_2057;
BgL_g1270z00_2057 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_subkeyz00_2055)))->BgL_sigsz00); 
{ 
obj_t BgL_l1268z00_2059;
BgL_l1268z00_2059 = BgL_g1270z00_2057; 
BgL_zc3z04anonymousza32086ze3z87_2058:
if(
PAIRP(BgL_l1268z00_2059))
{ /* Llib/pgp_composition.scm 546 */
{ /* Llib/pgp_composition.scm 547 */
obj_t BgL_sigz00_2060;
BgL_sigz00_2060 = 
CAR(BgL_l1268z00_2059); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_sigz00_2060), 
((obj_t)BgL_pz00_1819)); } 
{ 
obj_t BgL_l1268z00_3650;
BgL_l1268z00_3650 = 
CDR(BgL_l1268z00_2059); 
BgL_l1268z00_2059 = BgL_l1268z00_3650; 
goto BgL_zc3z04anonymousza32086ze3z87_2058;} }  else 
{ /* Llib/pgp_composition.scm 546 */((bool_t)1); } } } 
{ /* Llib/pgp_composition.scm 549 */
obj_t BgL_g1273z00_2061;
BgL_g1273z00_2061 = 
(((BgL_pgpzd2subkeyzd2_bglt)COBJECT(
((BgL_pgpzd2subkeyzd2_bglt)BgL_subkeyz00_2055)))->BgL_revocationzd2sigszd2); 
{ 
obj_t BgL_l1271z00_2063;
BgL_l1271z00_2063 = BgL_g1273z00_2061; 
BgL_zc3z04anonymousza32089ze3z87_2062:
if(
PAIRP(BgL_l1271z00_2063))
{ /* Llib/pgp_composition.scm 549 */
{ /* Llib/pgp_composition.scm 550 */
obj_t BgL_revoczd2sigzd2_2064;
BgL_revoczd2sigzd2_2064 = 
CAR(BgL_l1271z00_2063); 
BGl_encodezd2packetzd2zz__openpgpzd2encodezd2(
((BgL_pgpzd2packetzd2_bglt)BgL_revoczd2sigzd2_2064), 
((obj_t)BgL_pz00_1819)); } 
{ 
obj_t BgL_l1271z00_3660;
BgL_l1271z00_3660 = 
CDR(BgL_l1271z00_2063); 
BgL_l1271z00_2063 = BgL_l1271z00_3660; 
goto BgL_zc3z04anonymousza32089ze3z87_2062;} }  else 
{ /* Llib/pgp_composition.scm 549 */((bool_t)1); } } } } 
{ 
obj_t BgL_l1274z00_3662;
BgL_l1274z00_3662 = 
CDR(BgL_l1274z00_2054); 
BgL_l1274z00_2054 = BgL_l1274z00_3662; 
goto BgL_zc3z04anonymousza32083ze3z87_2053;} }  else 
{ /* Llib/pgp_composition.scm 542 */
BgL_tmpz00_3590 = ((bool_t)1)
; } } } } } 
return 
BBOOL(BgL_tmpz00_3590);} } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__openpgpzd2compositionzd2()
{
{ /* Llib/pgp_composition.scm 15 */
BGl_modulezd2initializa7ationz75zz__openpgpzd2utilzd2(((long)211416722), 
BSTRING_TO_STRING(BGl_string2377z00zz__openpgpzd2compositionzd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2packetszd2(((long)485669712), 
BSTRING_TO_STRING(BGl_string2377z00zz__openpgpzd2compositionzd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2decodezd2(((long)216390720), 
BSTRING_TO_STRING(BGl_string2377z00zz__openpgpzd2compositionzd2)); 
BGl_modulezd2initializa7ationz75zz__openpgpzd2encodezd2(((long)466864874), 
BSTRING_TO_STRING(BGl_string2377z00zz__openpgpzd2compositionzd2)); 
return 
BGl_modulezd2initializa7ationz75zz__openpgpzd2portzd2utilz00(((long)98035620), 
BSTRING_TO_STRING(BGl_string2377z00zz__openpgpzd2compositionzd2));} 

}

#ifdef __cplusplus
}
#endif
