/*===========================================================================*/
/*   (bmem/bmem.scm)                                                         */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -ld-relative -g -I bmem bmem/bmem.scm -o bmem/bmem.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_z62errorz62_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_fnamez00;
   obj_t BgL_locationz00;
   obj_t BgL_stackz00;
   obj_t BgL_procz00;
   obj_t BgL_msgz00;
   obj_t BgL_objz00;
} *BgL_z62errorz62_bglt;

typedef struct BgL_z52htmlzd2elementz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
} *BgL_z52htmlzd2elementz80_bglt;

typedef struct BgL_z52htmlzd2documentz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_attrza2za2;
   obj_t BgL_dtdz00;
   obj_t BgL_bodyz00;
   obj_t BgL_cssz00;
} *BgL_z52htmlzd2documentz80_bglt;

typedef struct BgL_z52htmlzd2brz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
} *BgL_z52htmlzd2brz80_bglt;

typedef struct BgL_z52htmlzd2boxz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_kindz00;
   obj_t BgL_inlineza2za2;
   obj_t BgL_alignz00;
} *BgL_z52htmlzd2boxz80_bglt;

typedef struct BgL_z52htmlzd2headingz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   int BgL_levelz00;
   obj_t BgL_alignmentz00;
   obj_t BgL_inlineza2za2;
} *BgL_z52htmlzd2headingz80_bglt;

typedef struct BgL_z52htmlzd2tablez80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_captionz00;
   obj_t BgL_colgroupzf3zf3;
   obj_t BgL_tfootzf3zf3;
   obj_t BgL_theadzf3zf3;
   obj_t BgL_widthz00;
   obj_t BgL_borderz00;
   obj_t BgL_framez00;
   obj_t BgL_rulesz00;
   obj_t BgL_cellspacingz00;
   obj_t BgL_cellpaddingz00;
   obj_t BgL_tbodyzb2zb2;
} *BgL_z52htmlzd2tablez80_bglt;

typedef struct BgL_z52htmlzd2trz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_tcellzb2zb2;
} *BgL_z52htmlzd2trz80_bglt;

typedef struct BgL_z52htmlzd2colgroupz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_widthz00;
   obj_t BgL_spanz00;
   obj_t BgL_alignz00;
   obj_t BgL_valignz00;
   obj_t BgL_charz00;
   obj_t BgL_colza2za2;
} *BgL_z52htmlzd2colgroupz80_bglt;

typedef struct BgL_z52htmlzd2tcellz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_kindz00;
   int BgL_colspanz00;
   int BgL_rowspanz00;
   obj_t BgL_alignz00;
   obj_t BgL_valignz00;
   obj_t BgL_charz00;
   obj_t BgL_widthz00;
   obj_t BgL_flowza2za2;
} *BgL_z52htmlzd2tcellz80_bglt;

typedef struct BgL_z52htmlzd2az80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_classz00;
   obj_t BgL_titlez00;
   obj_t BgL_stylez00;
   obj_t BgL_typez00;
   obj_t BgL_hrefz00;
   obj_t BgL_namez00;
   obj_t BgL_inlineza2za2;
} *BgL_z52htmlzd2az80_bglt;

typedef struct BgL_z52cssz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_typez00;
} *BgL_z52cssz52_bglt;

typedef struct BgL_funinfoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_identz00;
   bool_t BgL_usez00;
   int BgL_numz00;
   BGL_LONGLONG_T BgL_dsiza7eza7;
   BGL_LONGLONG_T BgL_isiza7eza7;
   obj_t BgL_gcza2za2;
   obj_t BgL_dtypez00;
   obj_t BgL_itypez00;
} *BgL_funinfoz00_bglt;


extern obj_t BGl_makezd2threadzd2tablez00zzbmem_threadz00(obj_t);
extern obj_t BGl_z52htmlzd2az80zzhtmlz00;
extern obj_t BGl_z52htmlzd2tablez80zzhtmlz00;
BGL_IMPORT obj_t BGl_raisez00zz__errorz00(obj_t);
extern obj_t BGl_csszd2colorzd2zzbmem_toolsz00(int, int, int, int);
static obj_t BGl_z62zc3z04anonymousza31644za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2uriza2z00zzbmem_paramz00;
extern obj_t BGl_addzd2functionz12zc0zzbmem_functionz00(obj_t);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
static obj_t BGl_findzd2monitorzd2zzbmemz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31797za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00(obj_t, obj_t);
extern obj_t BGl_za2siza7eofzd2wordza2z75zzbmem_paramz00;
extern obj_t BGl_z52htmlzd2documentz80zzhtmlz00;
extern obj_t BGl_funinfoz00zzbmem_functionz00;
BGL_IMPORT obj_t BGl_getenvz00zz__osz00(obj_t);
BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_appendz00zz__r4_pairs_and_lists_6_3z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31651za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zzbmemz00();
BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_dynamiczd2csszd2zzbmemz00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
extern obj_t BGl_htmlzd2pluginzd2versionz00zzhtmlz00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zzbmemz00();
extern obj_t BGl_za2foutza2z00zzbmem_paramz00;
static obj_t BGl_z62zc3z04anonymousza32033za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_errorzf2czd2locationz20zz__errorz00(obj_t, obj_t, obj_t, char *, long);
extern obj_t BGl_bmemzd2typezd2zzbmem_typez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_za2bmemza2z00zzbmem_paramz00;
extern obj_t BGl_za2portza2z00zzbmem_paramz00;
static obj_t BGl_z62dynamiczd2csszb0zzbmemz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z52htmlzd2brz80zzhtmlz00;
extern obj_t BGl_z52htmlzd2boxz80zzhtmlz00;
BGL_IMPORT obj_t BGl_errorzd2notifyzd2zz__errorz00(obj_t);
extern obj_t BGl_makezd2gczd2tablesz00zzbmem_gcz00(obj_t, obj_t, obj_t);
extern obj_t BGl_htmlzd2pluginzd2usagez00zzhtmlz00(obj_t, obj_t, obj_t, BgL_z52htmlzd2elementz80_bglt);
extern obj_t BGl_za2bmemzd2versionza2zd2zzbmem_paramz00;
extern obj_t BGl_z52htmlzd2headingz80zzhtmlz00;
BGL_IMPORT obj_t BGl_bigloozd2initializa7edz12z67zz__paramz00();
BGL_IMPORT obj_t bgl_debug_set(int);
BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
extern obj_t BGl_htmlzd2stringzd2zzhtmlz00(obj_t);
BGL_IMPORT long bgl_list_length(obj_t);
static obj_t BGl_gczd2rootszd2initz00zzbmemz00();
extern obj_t BGl_getzd2functionszd2zzbmem_functionz00();
static obj_t BGl_z62mainz62zzbmemz00(obj_t, obj_t);
extern obj_t BGl_makezd2typezd2tablesz00zzbmem_typez00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_findzd2filezf2pathz20zz__osz00(obj_t, obj_t);
extern obj_t BGl_z52htmlzd2colgroupz80zzhtmlz00;
BGL_IMPORT obj_t BGl_pregexpzd2matchzd2zz__regexpz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_withzd2inputzd2fromzd2filezd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(long, long);
extern obj_t BGl_bmemzd2functionzd2zzbmem_functionz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT long BGl_bitzd2andzd2zz__bitz00(long, long);
static obj_t BGl_pregexp1551z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1552z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1556z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1557z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1558z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1559z00zzbmemz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31692za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_pregexp1560z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1561z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1562z00zzbmemz00 = BUNSPEC;
static obj_t BGl_pregexp1563z00zzbmemz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31725za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zzbmemz00 = BUNSPEC;
static obj_t BGl_z62functionzd2identzd2ppz62zzbmemz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z52htmlzd2trz80zzhtmlz00;
static obj_t BGl_toplevelzd2initzd2zzbmemz00();
static obj_t BGl_z62zc3z04anonymousza31790za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zzbmemz00();
BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
static BgL_z52htmlzd2documentz80_bglt BGl_bmemzd2allzd2zzbmemz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t bigloo_main(obj_t);
static obj_t BGl_z62zc3z04anonymousza31804za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00(obj_t);
static obj_t BGl_usagez00zzbmemz00(obj_t);
BGL_IMPORT obj_t BGl_pregexpz00zz__regexpz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
extern obj_t BGl_za2typeza2z00zzbmem_paramz00;
BGL_IMPORT obj_t BGl_errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_functionzd2refzd2zzbmemz00(obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32055za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3343z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2hostnameza2z00zzbmem_paramz00;
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_modulezd2initzd2errorz00zz__errorz00(char *, char *);
extern BgL_z52cssz52_bglt BGl_listzd2ze3cssz31zzhtmlz00(obj_t);
extern obj_t BGl_htmlzd2legendzd2zzbmem_toolsz00(int, obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_z52htmlzd2tcellz80zzhtmlz00;
BGL_IMPORT obj_t string_append(obj_t, obj_t);
extern obj_t BGl_za2functionza2z00zzbmem_paramz00;
static obj_t BGl_z62zc3z04anonymousza31807za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3139z04ze3z33zzbmemz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31636za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z33zzbmemz00(obj_t);
static obj_t BGl_parsezd2cmdlinez12zc0zzbmemz00(obj_t);
extern obj_t BGl_htmlzd2vboxzd2zzhtmlz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
BGL_IMPORT bool_t bigloo_string_lt(obj_t, obj_t);
BGL_IMPORT obj_t bgl_list_ref(obj_t, long);
extern obj_t BGl_printzd2htmlzd2zzhtmlz00(BgL_z52htmlzd2documentz80_bglt);
extern obj_t BGl_za2csszd2pathza2zd2zzbmem_paramz00;
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzbmemz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_typez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_gcz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_functionz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_toolsz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzbmem_paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zzhtmlz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__expander_argsz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__regexpz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
BGL_IMPORT obj_t BGl_z62errorz62zz__objectz00;
BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31679za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62typezd2refzb0zzbmemz00(obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zzbmemz00();
BGL_EXPORTED_DECL obj_t BGl_functionzd2identzd2ppz00zzbmemz00(obj_t);
BGL_IMPORT obj_t BGl_argszd2parsezd2usagez00zz__expander_argsz00(obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zzbmemz00();
static obj_t BGl_importedzd2moduleszd2initz00zzbmemz00();
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31659za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
extern obj_t BGl_za2fileza2z00zzbmem_paramz00;
static obj_t BGl_z62functionzd2refzb0zzbmemz00(obj_t, obj_t);
static obj_t BGl_bmemzd2requestzd2zzbmemz00();
static obj_t BGl_parsezd2uriz12zc0zzbmemz00(obj_t);
BGL_IMPORT obj_t BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31824za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z33zzbmemz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_mainz00zzbmemz00(obj_t);
extern obj_t BGl_htmlzd2pluginzd2errorz00zzhtmlz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_makezd2functionzd2tablesz00zzbmem_functionz00(obj_t, obj_t, obj_t);
static bool_t BGl_httpzd2requestzf3z21zzbmemz00();
static obj_t BGl_z62zc3z04anonymousza31775za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
extern obj_t BGl_makezd2gczd2summaryz00zzbmem_gcz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31708za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31755za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_typezd2refzd2zzbmemz00(obj_t);
static obj_t __cnst[ 82 ] ;


DEFINE_STRING( BGl_string3010z00zzbmemz00, BgL_bgl_string3010za700za7za7b3191za7, "bmem-request", 12 );
DEFINE_STRING( BGl_string3011z00zzbmemz00, BgL_bgl_string3011za700za7za7b3192za7, "Illegal monitor file (empty gc section)", 39 );
DEFINE_STRING( BGl_string3012z00zzbmemz00, BgL_bgl_string3012za700za7za7b3193za7, "pair-nil", 8 );
DEFINE_STRING( BGl_string3013z00zzbmemz00, BgL_bgl_string3013za700za7za7b3194za7, "bint", 4 );
DEFINE_STRING( BGl_string3014z00zzbmemz00, BgL_bgl_string3014za700za7za7b3195za7, "<@anonymous:1817:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:175@>", 79 );
DEFINE_STRING( BGl_string3015z00zzbmemz00, BgL_bgl_string3015za700za7za7b3196za7, "for-each", 8 );
DEFINE_STRING( BGl_string3016z00zzbmemz00, BgL_bgl_string3016za700za7za7b3197za7, "list", 4 );
DEFINE_STRING( BGl_string3017z00zzbmemz00, BgL_bgl_string3017za700za7za7b3198za7, "Can't find function", 19 );
DEFINE_STRING( BGl_string3018z00zzbmemz00, BgL_bgl_string3018za700za7za7b3199za7, "Can't find type", 15 );
DEFINE_STRING( BGl_string3019z00zzbmemz00, BgL_bgl_string3019za700za7za7b3200za7, "<@anonymous:1824:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:194@>", 79 );
DEFINE_STRING( BGl_string3020z00zzbmemz00, BgL_bgl_string3020za700za7za7b3201za7, "function-ident-pp", 17 );
DEFINE_STRING( BGl_string3021z00zzbmemz00, BgL_bgl_string3021za700za7za7b3202za7, ")", 1 );
DEFINE_STRING( BGl_string3022z00zzbmemz00, BgL_bgl_string3022za700za7za7b3203za7, ":", 1 );
DEFINE_STRING( BGl_string3023z00zzbmemz00, BgL_bgl_string3023za700za7za7b3204za7, "&#955; (", 8 );
DEFINE_STRING( BGl_string3024z00zzbmemz00, BgL_bgl_string3024za700za7za7b3205za7, "&#923; (", 8 );
DEFINE_STRING( BGl_string3025z00zzbmemz00, BgL_bgl_string3025za700za7za7b3206za7, "function-ref", 12 );
DEFINE_STRING( BGl_string3026z00zzbmemz00, BgL_bgl_string3026za700za7za7b3207za7, "function-index", 14 );
DEFINE_STRING( BGl_string3027z00zzbmemz00, BgL_bgl_string3027za700za7za7b3208za7, "&#955;", 6 );
DEFINE_STRING( BGl_string3028z00zzbmemz00, BgL_bgl_string3028za700za7za7b3209za7, "&#923;", 6 );
DEFINE_STRING( BGl_string3029z00zzbmemz00, BgL_bgl_string3029za700za7za7b3210za7, "function-ident", 14 );
DEFINE_STRING( BGl_string3030z00zzbmemz00, BgL_bgl_string3030za700za7za7b3211za7, "http://~a:~a/~a?fun=~a", 22 );
DEFINE_STRING( BGl_string3031z00zzbmemz00, BgL_bgl_string3031za700za7za7b3212za7, "type-ref", 8 );
DEFINE_STRING( BGl_string3032z00zzbmemz00, BgL_bgl_string3032za700za7za7b3213za7, "type-ident", 10 );
DEFINE_STRING( BGl_string3033z00zzbmemz00, BgL_bgl_string3033za700za7za7b3214za7, "http://~a:~a/~a?type=~a", 23 );
DEFINE_STRING( BGl_string3034z00zzbmemz00, BgL_bgl_string3034za700za7za7b3215za7, "bmem-all", 8 );
DEFINE_STRING( BGl_string3035z00zzbmemz00, BgL_bgl_string3035za700za7za7b3216za7, "Can't find gc monitor", 21 );
DEFINE_STRING( BGl_string3036z00zzbmemz00, BgL_bgl_string3036za700za7za7b3217za7, "Can't find function monitor", 27 );
DEFINE_STRING( BGl_string3037z00zzbmemz00, BgL_bgl_string3037za700za7za7b3218za7, "Can't find type monitor", 23 );
DEFINE_STRING( BGl_string3038z00zzbmemz00, BgL_bgl_string3038za700za7za7b3219za7, "", 0 );
DEFINE_STRING( BGl_string3039z00zzbmemz00, BgL_bgl_string3039za700za7za7b3220za7, "Bglmem", 6 );
DEFINE_STRING( BGl_string3040z00zzbmemz00, BgL_bgl_string3040za700za7za7b3221za7, "Contents", 8 );
DEFINE_STRING( BGl_string3041z00zzbmemz00, BgL_bgl_string3041za700za7za7b3222za7, "contents", 8 );
DEFINE_STRING( BGl_string3042z00zzbmemz00, BgL_bgl_string3042za700za7za7b3223za7, "#functions", 10 );
DEFINE_STRING( BGl_string3043z00zzbmemz00, BgL_bgl_string3043za700za7za7b3224za7, "Functions", 9 );
DEFINE_STRING( BGl_string3044z00zzbmemz00, BgL_bgl_string3044za700za7za7b3225za7, "#types", 6 );
DEFINE_STRING( BGl_string3045z00zzbmemz00, BgL_bgl_string3045za700za7za7b3226za7, "Types", 5 );
DEFINE_STRING( BGl_string3046z00zzbmemz00, BgL_bgl_string3046za700za7za7b3227za7, "#threads", 8 );
DEFINE_STRING( BGl_string3047z00zzbmemz00, BgL_bgl_string3047za700za7za7b3228za7, "Threads", 7 );
DEFINE_STRING( BGl_string3048z00zzbmemz00, BgL_bgl_string3048za700za7za7b3229za7, "#gcs", 4 );
DEFINE_STRING( BGl_string3049z00zzbmemz00, BgL_bgl_string3049za700za7za7b3230za7, "Garbage Collections", 19 );
DEFINE_STRING( BGl_string3050z00zzbmemz00, BgL_bgl_string3050za700za7za7b3231za7, "Legends", 7 );
DEFINE_STRING( BGl_string3051z00zzbmemz00, BgL_bgl_string3051za700za7za7b3232za7, "<@anonymous:2027:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:326@>", 79 );
DEFINE_STRING( BGl_string3052z00zzbmemz00, BgL_bgl_string3052za700za7za7b3233za7, "funinfo", 7 );
DEFINE_STRING( BGl_string3054z00zzbmemz00, BgL_bgl_string3054za700za7za7b3234za7, "<@anonymous:2013:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:322@>", 79 );
DEFINE_STRING( BGl_string3055z00zzbmemz00, BgL_bgl_string3055za700za7za7b3235za7, "function~a", 10 );
DEFINE_STRING( BGl_string3056z00zzbmemz00, BgL_bgl_string3056za700za7za7b3236za7, "map", 3 );
DEFINE_STRING( BGl_string3057z00zzbmemz00, BgL_bgl_string3057za700za7za7b3237za7, "90%", 3 );
DEFINE_STRING( BGl_string3058z00zzbmemz00, BgL_bgl_string3058za700za7za7b3238za7, "function-legend", 15 );
DEFINE_STRING( BGl_string3060z00zzbmemz00, BgL_bgl_string3060za700za7za7b3239za7, "<@anonymous:2041:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:340@>", 79 );
DEFINE_STRING( BGl_string3061z00zzbmemz00, BgL_bgl_string3061za700za7za7b3240za7, "type~a", 6 );
DEFINE_STRING( BGl_string3062z00zzbmemz00, BgL_bgl_string3062za700za7za7b3241za7, "type-legend", 11 );
DEFINE_STRING( BGl_string3063z00zzbmemz00, BgL_bgl_string3063za700za7za7b3242za7, "<@anonymous:2061:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:350@>", 79 );
DEFINE_STRING( BGl_string3064z00zzbmemz00, BgL_bgl_string3064za700za7za7b3243za7, "gc~a", 4 );
DEFINE_STRING( BGl_string3065z00zzbmemz00, BgL_bgl_string3065za700za7za7b3244za7, "gc #~a", 6 );
DEFINE_STRING( BGl_string3066z00zzbmemz00, BgL_bgl_string3066za700za7za7b3245za7, "Gcs", 3 );
DEFINE_STRING( BGl_string3067z00zzbmemz00, BgL_bgl_string3067za700za7za7b3246za7, "gc-legend", 9 );
DEFINE_STRING( BGl_string3068z00zzbmemz00, BgL_bgl_string3068za700za7za7b3247za7, "functions", 9 );
DEFINE_STRING( BGl_string3069z00zzbmemz00, BgL_bgl_string3069za700za7za7b3248za7, "types", 5 );
DEFINE_STRING( BGl_string3070z00zzbmemz00, BgL_bgl_string3070za700za7za7b3249za7, "threads", 7 );
DEFINE_STRING( BGl_string3071z00zzbmemz00, BgL_bgl_string3071za700za7za7b3250za7, "gcs", 3 );
DEFINE_STRING( BGl_string3072z00zzbmemz00, BgL_bgl_string3072za700za7za7b3251za7, "main", 4 );
DEFINE_STRING( BGl_string3073z00zzbmemz00, BgL_bgl_string3073za700za7za7b3252za7, "hop", 3 );
DEFINE_STRING( BGl_string3074z00zzbmemz00, BgL_bgl_string3074za700za7za7b3253za7, "bglmem: ", 8 );
DEFINE_STRING( BGl_string3075z00zzbmemz00, BgL_bgl_string3075za700za7za7b3254za7, "class-field", 11 );
DEFINE_STRING( BGl_string3076z00zzbmemz00, BgL_bgl_string3076za700za7za7b3255za7, "20%", 3 );
DEFINE_STRING( BGl_string3077z00zzbmemz00, BgL_bgl_string3077za700za7za7b3256za7, "80%", 3 );
DEFINE_STRING( BGl_string3078z00zzbmemz00, BgL_bgl_string3078za700za7za7b3257za7, "100%", 4 );
DEFINE_STRING( BGl_string3079z00zzbmemz00, BgL_bgl_string3079za700za7za7b3258za7, "1px solid black", 15 );
DEFINE_STRING( BGl_string3080z00zzbmemz00, BgL_bgl_string3080za700za7za7b3259za7, "left", 4 );
DEFINE_STRING( BGl_string3081z00zzbmemz00, BgL_bgl_string3081za700za7za7b3260za7, "top", 3 );
DEFINE_STRING( BGl_string3082z00zzbmemz00, BgL_bgl_string3082za700za7za7b3261za7, "hop-margin", 10 );
DEFINE_STRING( BGl_string3083z00zzbmemz00, BgL_bgl_string3083za700za7za7b3262za7, "hop-title", 9 );
DEFINE_STRING( BGl_string3084z00zzbmemz00, BgL_bgl_string3084za700za7za7b3263za7, "hop-page", 8 );
DEFINE_STRING( BGl_string3085z00zzbmemz00, BgL_bgl_string3085za700za7za7b3264za7, "<@anonymous:2055:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:343@>", 79 );
DEFINE_STRING( BGl_string3086z00zzbmemz00, BgL_bgl_string3086za700za7za7b3265za7, "<@anonymous:2033:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:326@>", 79 );
DEFINE_STRING( BGl_string3087z00zzbmemz00, BgL_bgl_string3087za700za7za7b3266za7, "gc-css", 6 );
DEFINE_STRING( BGl_string3088z00zzbmemz00, BgL_bgl_string3088za700za7za7b3267za7, "div.profile .gc~a", 17 );
DEFINE_STRING( BGl_string3089z00zzbmemz00, BgL_bgl_string3089za700za7za7b3268za7, "#ccc", 4 );
DEFINE_STRING( BGl_string3090z00zzbmemz00, BgL_bgl_string3090za700za7za7b3269za7, "#ddf", 4 );
DEFINE_STRING( BGl_string3091z00zzbmemz00, BgL_bgl_string3091za700za7za7b3270za7, "div.profile .function-1", 23 );
DEFINE_STRING( BGl_string3092z00zzbmemz00, BgL_bgl_string3092za700za7za7b3271za7, "<@anonymous:2108:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:403@>", 79 );
DEFINE_STRING( BGl_string3093z00zzbmemz00, BgL_bgl_string3093za700za7za7b3272za7, "div.profile .function~a", 23 );
DEFINE_STRING( BGl_string3094z00zzbmemz00, BgL_bgl_string3094za700za7za7b3273za7, "div.profile .type-1", 19 );
DEFINE_STRING( BGl_string3095z00zzbmemz00, BgL_bgl_string3095za700za7za7b3274za7, "<@anonymous:2128:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:411@>", 79 );
DEFINE_STRING( BGl_string3096z00zzbmemz00, BgL_bgl_string3096za700za7za7b3275za7, "div.profile .type~a", 19 );
DEFINE_STRING( BGl_string3097z00zzbmemz00, BgL_bgl_string3097za700za7za7b3276za7, "byte", 4 );
DEFINE_STRING( BGl_string3098z00zzbmemz00, BgL_bgl_string3098za700za7za7b3277za7, "rgb( 60, 60, 60 )", 17 );
DEFINE_STRING( BGl_string3099z00zzbmemz00, BgL_bgl_string3099za700za7za7b3278za7, "dynamic-css", 11 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_functionzd2refzd2envz00zzbmemz00, BgL_bgl_za762functionza7d2re3279z00, BGl_z62functionzd2refzb0zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_typezd2refzd2envz00zzbmemz00, BgL_bgl_za762typeza7d2refza7b03280za7, BGl_z62typezd2refzb0zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2945z00zzbmemz00, BgL_bgl_string2945za700za7za7b3281za7, "<exit:([^>]+)>", 14 );
DEFINE_STRING( BGl_string2946z00zzbmemz00, BgL_bgl_string2946za700za7za7b3282za7, "<exit:[^:]+:([^:]+):([0-9]+)>", 29 );
DEFINE_STRING( BGl_string2947z00zzbmemz00, BgL_bgl_string2947za700za7za7b3283za7, "<anonymous:([^>]+)>", 19 );
DEFINE_STRING( BGl_string2948z00zzbmemz00, BgL_bgl_string2948za700za7za7b3284za7, "<anonymous:[^:]+:([^:]+):([0-9]+)>", 34 );
DEFINE_STRING( BGl_string2949z00zzbmemz00, BgL_bgl_string2949za700za7za7b3285za7, "([^?]+)[?]type=(.+)", 19 );
DEFINE_STRING( BGl_string2950z00zzbmemz00, BgL_bgl_string2950za700za7za7b3286za7, "([^?]+)[?]fun=(.+)", 18 );
DEFINE_STRING( BGl_string2951z00zzbmemz00, BgL_bgl_string2951za700za7za7b3287za7, "hop-usage", 9 );
DEFINE_STRING( BGl_string2952z00zzbmemz00, BgL_bgl_string2952za700za7za7b3288za7, "bglmem", 6 );
DEFINE_STRING( BGl_string2953z00zzbmemz00, BgL_bgl_string2953za700za7za7b3289za7, "bglmem [options]", 16 );
DEFINE_STRING( BGl_string2954z00zzbmemz00, BgL_bgl_string2954za700za7za7b3290za7, "/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm", 56 );
DEFINE_STRING( BGl_string2955z00zzbmemz00, BgL_bgl_string2955za700za7za7b3291za7, "usage", 5 );
DEFINE_STRING( BGl_string2956z00zzbmemz00, BgL_bgl_string2956za700za7za7b3292za7, "%html-document", 14 );
DEFINE_STRING( BGl_string2957z00zzbmemz00, BgL_bgl_string2957za700za7za7b3293za7, "usage: bglmem [options] name.bmem", 33 );
DEFINE_STRING( BGl_string2958z00zzbmemz00, BgL_bgl_string2958za700za7za7b3294za7, "procedure", 9 );
DEFINE_STRING( BGl_string2959z00zzbmemz00, BgL_bgl_string2959za700za7za7b3295za7, "usage:Wrong number of arguments", 31 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_dynamiczd2csszd2envz00zzbmemz00, BgL_bgl_za762dynamicza7d2css3296z00, BGl_z62dynamiczd2csszb0zzbmemz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2960z00zzbmemz00, BgL_bgl_string2960za700za7za7b3297za7, "<@anonymous:1636:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:60@>", 78 );
DEFINE_STRING( BGl_string2961z00zzbmemz00, BgL_bgl_string2961za700za7za7b3298za7, "<@anonymous:1636:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:60@>:Wrong number of arguments", 104 );
DEFINE_STRING( BGl_string2962z00zzbmemz00, BgL_bgl_string2962za700za7za7b3299za7, "QUERY_STRING", 12 );
DEFINE_STRING( BGl_string2963z00zzbmemz00, BgL_bgl_string2963za700za7za7b3300za7, "SERVER_NAME", 11 );
DEFINE_STRING( BGl_string2964z00zzbmemz00, BgL_bgl_string2964za700za7za7b3301za7, "SERVER_PORT", 11 );
DEFINE_STRING( BGl_string2973z00zzbmemz00, BgL_bgl_string2973za700za7za7b3302za7, "liip", 4 );
DEFINE_STRING( BGl_string2974z00zzbmemz00, BgL_bgl_string2974za700za7za7b3303za7, "pair", 4 );
DEFINE_STRING( BGl_string2975z00zzbmemz00, BgL_bgl_string2975za700za7za7b3304za7, "liip:Wrong number of arguments", 30 );
DEFINE_STRING( BGl_string2976z00zzbmemz00, BgL_bgl_string2976za700za7za7b3305za7, "Illegal argument list", 21 );
DEFINE_STRING( BGl_string2977z00zzbmemz00, BgL_bgl_string2977za700za7za7b3306za7, "<@anonymous:1775:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2978z00zzbmemz00, BgL_bgl_string2978za700za7za7b3307za7, "bstring", 7 );
DEFINE_STRING( BGl_string2979z00zzbmemz00, BgL_bgl_string2979za700za7za7b3308za7, "--help", 6 );
DEFINE_STRING( BGl_string2980z00zzbmemz00, BgL_bgl_string2980za700za7za7b3309za7, "<@anonymous:1755:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2981z00zzbmemz00, BgL_bgl_string2981za700za7za7b3310za7, "-v", 2 );
DEFINE_STRING( BGl_string2982z00zzbmemz00, BgL_bgl_string2982za700za7za7b3311za7, "--version", 9 );
DEFINE_STRING( BGl_string2983z00zzbmemz00, BgL_bgl_string2983za700za7za7b3312za7, ": ", 2 );
DEFINE_STRING( BGl_string2984z00zzbmemz00, BgL_bgl_string2984za700za7za7b3313za7, "<@anonymous:1725:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2985z00zzbmemz00, BgL_bgl_string2985za700za7za7b3314za7, "-o", 2 );
DEFINE_STRING( BGl_string2986z00zzbmemz00, BgL_bgl_string2986za700za7za7b3315za7, "--output", 8 );
DEFINE_STRING( BGl_string2987z00zzbmemz00, BgL_bgl_string2987za700za7za7b3316za7, "missing argument", 16 );
DEFINE_STRING( BGl_string2988z00zzbmemz00, BgL_bgl_string2988za700za7za7b3317za7, "<@anonymous:1708:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2989z00zzbmemz00, BgL_bgl_string2989za700za7za7b3318za7, "-f", 2 );
DEFINE_STRING( BGl_string2990z00zzbmemz00, BgL_bgl_string2990za700za7za7b3319za7, "--function", 10 );
DEFINE_STRING( BGl_string2991z00zzbmemz00, BgL_bgl_string2991za700za7za7b3320za7, "<@anonymous:1692:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2992z00zzbmemz00, BgL_bgl_string2992za700za7za7b3321za7, "-t", 2 );
DEFINE_STRING( BGl_string2993z00zzbmemz00, BgL_bgl_string2993za700za7za7b3322za7, "--type", 6 );
DEFINE_STRING( BGl_string2994z00zzbmemz00, BgL_bgl_string2994za700za7za7b3323za7, "<@anonymous:1679:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2995z00zzbmemz00, BgL_bgl_string2995za700za7za7b3324za7, "-h", 2 );
DEFINE_STRING( BGl_string2996z00zzbmemz00, BgL_bgl_string2996za700za7za7b3325za7, "--hostname", 10 );
DEFINE_STRING( BGl_string2997z00zzbmemz00, BgL_bgl_string2997za700za7za7b3326za7, "<@anonymous:1659:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string2998z00zzbmemz00, BgL_bgl_string2998za700za7za7b3327za7, "-p", 2 );
DEFINE_STRING( BGl_string2999z00zzbmemz00, BgL_bgl_string2999za700za7za7b3328za7, "--port", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3004z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3329za7, BGl_z62zc3z04anonymousza31797za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3006z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3330za7, BGl_z62zc3z04anonymousza31807za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3139z04ze3z33zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3100z00zzbmemz00, BgL_bgl_string3100za700za7za7b3331za7, "loop", 4 );
DEFINE_STRING( BGl_string3101z00zzbmemz00, BgL_bgl_string3101za700za7za7b3332za7, "bmem", 4 );
DEFINE_STRING( BGl_string3102z00zzbmemz00, BgL_bgl_string3102za700za7za7b3333za7, "%import@bmem method-init@bmem generic-init@bmem object-init@bmem (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 15280) find-monitor@bmem :background :cursor help (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 13848) dynamic-css@bmem td (\"Garbage collections\") (\"Threads information\") (\"Types\") (\"Functions\") (\"Statistics\") exec bmem (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 10764) bmem-all@bmem (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 10203) type-ref@bmem span (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 9077) function-ref@bmem (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 8360) function-ident-pp@bmem sizeof-word bglmem (\".\") thread type function gc info (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 5677) bmem-request@bmem (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 5069) main@bmem (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem."
"scm\" 4460) parse-uri!@bmem (((\"-p\" \"--port\") ?p (help \"Port number of the request\")) (set! *port* p)) ?p (((\"-h\" \"--hostname\") ?h (help \"Hostname of the request\")) (set! *hostname* h)) ?h (((\"-t\" \"--type\") ?type (help \"Show the type information\")) (set! *type* type)) ?type (((\"-f\" \"--function\") ?function (help \"Show the function information\")) (set! *function* function)) ?function (((\"-o\" \"--output\") ?fout (help \"Output file\")) (set! *fout* fout)) ?fout (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 1902) plugin-exit@bmem args-parse end fail next (funcall fun1787 fun1787 a* v) ((\"--help\" . \"This help message\") (\"-v,--version\" . \"Version number\") (\"-o,--output FOUT\" . \"Output file\") (\"-f,--function FUNCTION\" . \"Show the function information\") (\"-t,--type TYPE\" . \"Show the type information\") (\"-h,--hostname H\" . \"Hostname of the request\") (\"-p,--port P\" . \"Port number of the request\")) (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/b"
"mem/bmem.scm\" 3070) parse-cmdline!@bmem _ (funcall proc proc #f) div (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 2455) usage@bmem (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 2168) http-request?@bmem pregexp1551@bmem pregexp1552@bmem pregexp1556@bmem pregexp1557@bmem pregexp1558@bmem pregexp1559@bmem pregexp1560@bmem pregexp1561@bmem pregexp1562@bmem pregexp1563@bmem %toplevel@bmem (at \"/builddir/build/BUILD/bigloo-4.4a/bde/bmem/bmem/bmem.scm\" 1037) gc-roots-init@bmem ", 2467 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_functionzd2identzd2ppzd2envzd2zzbmemz00, BgL_bgl_za762functionza7d2id3334z00, BGl_z62functionzd2identzd2ppz62zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3053z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3335za7, BGl_z62zc3z04anonymousza32033za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc3059z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3336za7, BGl_z62zc3z04anonymousza32055za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3343z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_mainzd2envzd2zzbmemz00, BgL_bgl_za762mainza762za7za7bmem3337z00, BGl_z62mainz62zzbmemz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2965z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3338za7, BGl_z62zc3z04anonymousza31790za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2966z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3339za7, BGl_z62zc3z04anonymousza31644za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2967z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3340za7, BGl_z62zc3z04anonymousza31659za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2968z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3341za7, BGl_z62zc3z04anonymousza31679za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2969z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3342za7, BGl_z62zc3z04anonymousza31692za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2970z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3343za7, BGl_z62zc3z04anonymousza31708za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2971z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3344za7, BGl_z62zc3z04anonymousza31725za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2972z00zzbmemz00, BgL_bgl_za762za7c3za704anonymo3345za7, BGl_z62zc3z04anonymousza31755za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 0L, BUNSPEC, 2 );
BGL_IMPORT obj_t BGl_readzd2envzd2zz__readerz00;
DEFINE_STRING( BGl_string3000z00zzbmemz00, BgL_bgl_string3000za700za7za7b3346za7, "<@anonymous:1790:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@>", 78 );
DEFINE_STRING( BGl_string3001z00zzbmemz00, BgL_bgl_string3001za700za7za7b3347za7, "Illegal option", 14 );
DEFINE_STRING( BGl_string3002z00zzbmemz00, BgL_bgl_string3002za700za7za7b3348za7, "see -help", 9 );
DEFINE_STRING( BGl_string3003z00zzbmemz00, BgL_bgl_string3003za700za7za7b3349za7, "parse-uri!", 10 );
DEFINE_STRING( BGl_string3005z00zzbmemz00, BgL_bgl_string3005za700za7za7b3350za7, "&main", 5 );
DEFINE_STRING( BGl_string3007z00zzbmemz00, BgL_bgl_string3007za700za7za7b3351za7, "<@anonymous:1797:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:125@>", 79 );
DEFINE_STRING( BGl_string3008z00zzbmemz00, BgL_bgl_string3008za700za7za7b3352za7, "/usr/lib64/bigloo/4.4a/bmem", 27 );
DEFINE_STRING( BGl_string3009z00zzbmemz00, BgL_bgl_string3009za700za7za7b3353za7, "bmem.css", 8 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_pregexp1551z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1552z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1556z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1557z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1558z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1559z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1560z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1561z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1562z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_pregexp1563z00zzbmemz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zzbmemz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}


/* Libraries setup */
static int bigloo_libinit( int argc, char *argv[], char *env[] ) {
return 0; }


long bigloo_abort(long n) { return n; }

int BIGLOO_MAIN(int argc, char *argv[], char *env[]) { 
return _bigloo_main(argc, argv, env, &bigloo_main, &bigloo_libinit, 0);}


/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzbmemz00(long BgL_checksumz00_2781, char * BgL_fromz00_2782)
{
{ 
if(
BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(
(long)CINT(
BINT(
BGl_bitzd2andzd2zz__bitz00(BgL_checksumz00_2781, ((long)78678018)))), BgL_checksumz00_2781))
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zzbmemz00))
{ 
BGl_requirezd2initializa7ationz75zzbmemz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zzbmemz00(); 
BGl_libraryzd2moduleszd2initz00zzbmemz00(); 
BGl_cnstzd2initzd2zzbmemz00(); 
BGl_importedzd2moduleszd2initz00zzbmemz00(); 
BGl_objectzd2initzd2zzbmemz00(); 
BGl_genericzd2initzd2zzbmemz00(); 
BGl_methodzd2initzd2zzbmemz00(); 
return 
BGl_toplevelzd2initzd2zzbmemz00();}  else 
{ 
return BUNSPEC;} }  else 
{ 
char * BgL_sz00_2785;
BgL_sz00_2785 = 
"bmem"; 
return 
BGl_modulezd2initzd2errorz00zz__errorz00(BgL_sz00_2785, BgL_fromz00_2782);} } 

}



/* bigloo_main */
BGL_EXPORTED_DEF obj_t bigloo_main(obj_t BgL_argvz00_2787)
{
{ 
BGl_modulezd2initializa7ationz75zzbmemz00(((long)0), "bmem"); 
BGl_bigloozd2initializa7edz12z67zz__paramz00(); 
{ 
obj_t BgL_tmpz00_2809;
BgL_tmpz00_2809 = 
BGl_mainz00zzbmemz00(BgL_argvz00_2787); 
return 
BIGLOO_EXIT(BgL_tmpz00_2809);} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__regexpz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__expander_argsz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)0), "bmem"); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)0), "bmem"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_cportz00_2464;
{ /* bmem/bmem.scm 16 */
obj_t BgL_stringz00_2472;
BgL_stringz00_2472 = BGl_string3102z00zzbmemz00; 
{ /* bmem/bmem.scm 16 */
obj_t BgL_startz00_2473;
BgL_startz00_2473 = 
BINT(((long)0)); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_endz00_2474;
BgL_endz00_2474 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_2472))); 
{ /* bmem/bmem.scm 16 */

BgL_cportz00_2464 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_2472, BgL_startz00_2473, BgL_endz00_2474); } } } } 
{ 
long BgL_iz00_2465;
BgL_iz00_2465 = ((long)81); 
BgL_loopz00_2466:
if(
(BgL_iz00_2465==((long)-1)))
{ /* bmem/bmem.scm 16 */
return BUNSPEC;}  else 
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_arg3104z00_2468;
{ /* bmem/bmem.scm 16 */

{ /* bmem/bmem.scm 16 */
obj_t BgL_locationz00_2470;
BgL_locationz00_2470 = 
BBOOL(((bool_t)0)); 
{ /* bmem/bmem.scm 16 */

BgL_arg3104z00_2468 = 
BGl_readz00zz__readerz00(BgL_cportz00_2464, BgL_locationz00_2470); } } } 
{ /* bmem/bmem.scm 16 */
int BgL_tmpz00_2838;
BgL_tmpz00_2838 = 
(int)(BgL_iz00_2465); 
CNST_TABLE_SET(BgL_tmpz00_2838, BgL_arg3104z00_2468); } } 
{ /* bmem/bmem.scm 16 */
int BgL_auxz00_2471;
BgL_auxz00_2471 = 
(int)(
(BgL_iz00_2465-((long)1))); 
{ 
long BgL_iz00_2843;
BgL_iz00_2843 = 
(long)(BgL_auxz00_2471); 
BgL_iz00_2465 = BgL_iz00_2843; 
goto BgL_loopz00_2466;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2194z00_1041;obj_t BgL_loc2195z00_1042;obj_t BgL_env2196z00_1043;
BgL_name2194z00_1041 = 
CNST_TABLE_REF(((long)0)); 
BgL_loc2195z00_1042 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2196z00_1043 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2196z00_1043, BgL_name2194z00_1041, BgL_loc2195z00_1042); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2193z00_1044;
BgL_aux2193z00_1044 = 
bgl_gc_roots_register(); 
BGL_ENV_POP_TRACE(BgL_env2196z00_1043); 
return BgL_aux2193z00_1044;} } } } 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2198z00_1045;obj_t BgL_loc2199z00_1046;obj_t BgL_env2200z00_1047;
BgL_name2198z00_1045 = 
CNST_TABLE_REF(((long)2)); 
BgL_loc2199z00_1046 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2200z00_1047 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2200z00_1047, BgL_name2198z00_1045, BgL_loc2199z00_1046); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2197z00_1048;
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2154z00_1001;obj_t BgL_loc2155z00_1002;obj_t BgL_env2156z00_1003;
BgL_name2154z00_1001 = 
CNST_TABLE_REF(((long)3)); 
BgL_loc2155z00_1002 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2156z00_1003 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2156z00_1003, BgL_name2154z00_1001, BgL_loc2155z00_1002); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2153z00_1004;
BgL_aux2153z00_1004 = 
BGl_pregexpz00zz__regexpz00(BGl_string2945z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2156z00_1003); 
BGl_pregexp1563z00zzbmemz00 = BgL_aux2153z00_1004; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2158z00_1005;obj_t BgL_loc2159z00_1006;obj_t BgL_env2160z00_1007;
BgL_name2158z00_1005 = 
CNST_TABLE_REF(((long)4)); 
BgL_loc2159z00_1006 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2160z00_1007 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2160z00_1007, BgL_name2158z00_1005, BgL_loc2159z00_1006); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2157z00_1008;
BgL_aux2157z00_1008 = 
BGl_pregexpz00zz__regexpz00(BGl_string2946z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2160z00_1007); 
BGl_pregexp1562z00zzbmemz00 = BgL_aux2157z00_1008; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2162z00_1009;obj_t BgL_loc2163z00_1010;obj_t BgL_env2164z00_1011;
BgL_name2162z00_1009 = 
CNST_TABLE_REF(((long)5)); 
BgL_loc2163z00_1010 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2164z00_1011 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2164z00_1011, BgL_name2162z00_1009, BgL_loc2163z00_1010); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2161z00_1012;
BgL_aux2161z00_1012 = 
BGl_pregexpz00zz__regexpz00(BGl_string2947z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2164z00_1011); 
BGl_pregexp1561z00zzbmemz00 = BgL_aux2161z00_1012; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2166z00_1013;obj_t BgL_loc2167z00_1014;obj_t BgL_env2168z00_1015;
BgL_name2166z00_1013 = 
CNST_TABLE_REF(((long)6)); 
BgL_loc2167z00_1014 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2168z00_1015 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2168z00_1015, BgL_name2166z00_1013, BgL_loc2167z00_1014); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2165z00_1016;
BgL_aux2165z00_1016 = 
BGl_pregexpz00zz__regexpz00(BGl_string2948z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2168z00_1015); 
BGl_pregexp1560z00zzbmemz00 = BgL_aux2165z00_1016; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2170z00_1017;obj_t BgL_loc2171z00_1018;obj_t BgL_env2172z00_1019;
BgL_name2170z00_1017 = 
CNST_TABLE_REF(((long)7)); 
BgL_loc2171z00_1018 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2172z00_1019 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2172z00_1019, BgL_name2170z00_1017, BgL_loc2171z00_1018); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2169z00_1020;
BgL_aux2169z00_1020 = 
BGl_pregexpz00zz__regexpz00(BGl_string2945z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2172z00_1019); 
BGl_pregexp1559z00zzbmemz00 = BgL_aux2169z00_1020; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2174z00_1021;obj_t BgL_loc2175z00_1022;obj_t BgL_env2176z00_1023;
BgL_name2174z00_1021 = 
CNST_TABLE_REF(((long)8)); 
BgL_loc2175z00_1022 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2176z00_1023 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2176z00_1023, BgL_name2174z00_1021, BgL_loc2175z00_1022); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2173z00_1024;
BgL_aux2173z00_1024 = 
BGl_pregexpz00zz__regexpz00(BGl_string2946z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2176z00_1023); 
BGl_pregexp1558z00zzbmemz00 = BgL_aux2173z00_1024; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2178z00_1025;obj_t BgL_loc2179z00_1026;obj_t BgL_env2180z00_1027;
BgL_name2178z00_1025 = 
CNST_TABLE_REF(((long)9)); 
BgL_loc2179z00_1026 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2180z00_1027 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2180z00_1027, BgL_name2178z00_1025, BgL_loc2179z00_1026); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2177z00_1028;
BgL_aux2177z00_1028 = 
BGl_pregexpz00zz__regexpz00(BGl_string2947z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2180z00_1027); 
BGl_pregexp1557z00zzbmemz00 = BgL_aux2177z00_1028; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2182z00_1029;obj_t BgL_loc2183z00_1030;obj_t BgL_env2184z00_1031;
BgL_name2182z00_1029 = 
CNST_TABLE_REF(((long)10)); 
BgL_loc2183z00_1030 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2184z00_1031 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2184z00_1031, BgL_name2182z00_1029, BgL_loc2183z00_1030); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2181z00_1032;
BgL_aux2181z00_1032 = 
BGl_pregexpz00zz__regexpz00(BGl_string2948z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2184z00_1031); 
BGl_pregexp1556z00zzbmemz00 = BgL_aux2181z00_1032; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2186z00_1033;obj_t BgL_loc2187z00_1034;obj_t BgL_env2188z00_1035;
BgL_name2186z00_1033 = 
CNST_TABLE_REF(((long)11)); 
BgL_loc2187z00_1034 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2188z00_1035 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2188z00_1035, BgL_name2186z00_1033, BgL_loc2187z00_1034); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2185z00_1036;
BgL_aux2185z00_1036 = 
BGl_pregexpz00zz__regexpz00(BGl_string2949z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2188z00_1035); 
BGl_pregexp1552z00zzbmemz00 = BgL_aux2185z00_1036; } } } 
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2190z00_1037;obj_t BgL_loc2191z00_1038;obj_t BgL_env2192z00_1039;
BgL_name2190z00_1037 = 
CNST_TABLE_REF(((long)12)); 
BgL_loc2191z00_1038 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2192z00_1039 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2192z00_1039, BgL_name2190z00_1037, BgL_loc2191z00_1038); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2189z00_1040;
BgL_aux2189z00_1040 = 
BGl_pregexpz00zz__regexpz00(BGl_string2950z00zzbmemz00, BNIL); 
BGL_ENV_POP_TRACE(BgL_env2192z00_1039); 
BGl_pregexp1551z00zzbmemz00 = BgL_aux2189z00_1040; } } } 
BgL_aux2197z00_1048 = 
bgl_debug_set(
(int)(((long)1))); 
BGL_ENV_POP_TRACE(BgL_env2200z00_1047); 
return BgL_aux2197z00_1048;} } } } 

}



/* http-request? */
bool_t BGl_httpzd2requestzf3z21zzbmemz00()
{
{ /* bmem/bmem.scm 46 */
{ /* bmem/bmem.scm 47 */
obj_t BgL_name2206z00_1053;obj_t BgL_loc2207z00_1054;obj_t BgL_env2208z00_1055;
BgL_name2206z00_1053 = 
CNST_TABLE_REF(((long)13)); 
BgL_loc2207z00_1054 = 
CNST_TABLE_REF(((long)14)); 
BgL_env2208z00_1055 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 47 */

BGL_ENV_PUSH_TRACE(BgL_env2208z00_1055, BgL_name2206z00_1053, BgL_loc2207z00_1054); 
{ /* bmem/bmem.scm 47 */
bool_t BgL_aux2205z00_1056;
if(
STRINGP(BGl_za2hostnameza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 47 */
BgL_aux2205z00_1056 = 
STRINGP(BGl_za2portza2z00zzbmem_paramz00); }  else 
{ /* bmem/bmem.scm 47 */
BgL_aux2205z00_1056 = ((bool_t)0); } 
BGL_ENV_POP_TRACE(BgL_env2208z00_1055); 
return BgL_aux2205z00_1056;} } } } 

}



/* usage */
obj_t BGl_usagez00zzbmemz00(obj_t BgL_procz00_4)
{
{ /* bmem/bmem.scm 52 */
{ /* bmem/bmem.scm 53 */
obj_t BgL_name2210z00_1057;obj_t BgL_loc2211z00_1058;obj_t BgL_env2212z00_1059;
BgL_name2210z00_1057 = 
CNST_TABLE_REF(((long)15)); 
BgL_loc2211z00_1058 = 
CNST_TABLE_REF(((long)16)); 
BgL_env2212z00_1059 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 53 */

BGL_ENV_PUSH_TRACE(BgL_env2212z00_1059, BgL_name2210z00_1057, BgL_loc2211z00_1058); 
{ /* bmem/bmem.scm 53 */
obj_t BgL_aux2209z00_1060;
if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 58 */
obj_t BgL_arg1627z00_43;
{ /* bmem/bmem.scm 58 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1632z00_44;
{ /* bmem/bmem.scm 58 */
BgL_z52htmlzd2boxz80_bglt BgL_new1281z00_45;
{ /* bmem/bmem.scm 58 */
obj_t BgL_env1279z00_50;
BgL_env1279z00_50 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 58 */

{ 
long BgL_auxz00_2933;
{ /* bmem/bmem.scm 58 */
long BgL_res2287z00_1138;
{ /* bmem/bmem.scm 58 */
obj_t BgL_classz00_1137;
BgL_classz00_1137 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2287z00_1138 = 
BGL_CLASS_INDEX(BgL_classz00_1137); } 
BgL_auxz00_2933 = BgL_res2287z00_1138; } 
bmem_set_allocation_type( BgL_auxz00_2933, 0 ); } 
{ /* bmem/bmem.scm 58 */
BgL_z52htmlzd2boxz80_bglt BgL_new1278z00_52;
BgL_new1278z00_52 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 58 */
long BgL_arg1638z00_53;
{ /* bmem/bmem.scm 58 */
long BgL_res2288z00_1140;
BgL_res2288z00_1140 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BgL_arg1638z00_53 = BgL_res2288z00_1140; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1278z00_52), BgL_arg1638z00_53); } 
BgL_new1281z00_45 = BgL_new1278z00_52; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1281z00_45)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1281z00_45)))->BgL_classz00)=((obj_t)BGl_string2951z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1281z00_45)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1281z00_45)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1281z00_45))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
{ 
obj_t BgL_auxz00_2950;
{ /* bmem/bmem.scm 62 */
obj_t BgL_arg1634z00_46;
{ /* bmem/bmem.scm 62 */
obj_t BgL_zc3z04anonymousza31636za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z51_2067;
BgL_zc3z04anonymousza31636za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z51_2067 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31636za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z33zzbmemz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31636za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z51_2067, 
(int)(((long)0)), BgL_procz00_4); 
BgL_arg1634z00_46 = 
BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00(BgL_zc3z04anonymousza31636za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z51_2067); } 
BgL_auxz00_2950 = 
BGl_htmlzd2stringzd2zzhtmlz00(BgL_arg1634z00_46); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1281z00_45))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_2950),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1281z00_45))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1632z00_44 = BgL_new1281z00_45; } 
BgL_arg1627z00_43 = 
BGl_htmlzd2pluginzd2usagez00zzhtmlz00(BFALSE, BGl_string2952z00zzbmemz00, BGl_string2953z00zzbmemz00, 
((BgL_z52htmlzd2elementz80_bglt)BgL_arg1632z00_44)); } 
{ /* bmem/bmem.scm 54 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_2962;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1627z00_43, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 62 */
BgL_auxz00_2962 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_arg1627z00_43)
; }  else 
{ 
obj_t BgL_auxz00_2966;
BgL_auxz00_2966 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)2679)), BGl_string2955z00zzbmemz00, BGl_string2956z00zzbmemz00, BgL_arg1627z00_43); 
FAILURE(BgL_auxz00_2966,BFALSE,BFALSE);} 
BgL_aux2209z00_1060 = 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_2962); } }  else 
{ /* bmem/bmem.scm 53 */
{ /* bmem/bmem.scm 64 */
obj_t BgL_port1492z00_54;
{ /* bmem/bmem.scm 64 */
obj_t BgL_res2289z00_1144;
{ /* bmem/bmem.scm 64 */
obj_t BgL_tmpz00_2971;
BgL_tmpz00_2971 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2289z00_1144 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2971); } 
BgL_port1492z00_54 = BgL_res2289z00_1144; } 
bgl_display_string(BGl_string2957z00zzbmemz00, BgL_port1492z00_54); 
bgl_display_char(((unsigned char)10), BgL_port1492z00_54); } 
{ /* bmem/bmem.scm 65 */
obj_t BgL_funz00_2153;
if(
PROCEDUREP(BgL_procz00_4))
{ /* bmem/bmem.scm 65 */
BgL_funz00_2153 = BgL_procz00_4; }  else 
{ 
obj_t BgL_auxz00_2978;
BgL_auxz00_2978 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)2746)), BGl_string2955z00zzbmemz00, BGl_string2958z00zzbmemz00, BgL_procz00_4); 
FAILURE(BgL_auxz00_2978,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_2153, ((long)1)))
{ /* bmem/bmem.scm 65 */
BgL_aux2209z00_1060 = 
PROCEDURE_ENTRY(BgL_funz00_2153)(BgL_procz00_4, BFALSE, BEOA); }  else 
{ /* bmem/bmem.scm 65 */
BGl_errorzf2locationzf2zz__errorz00(BGl_string2959z00zzbmemz00, 
CNST_TABLE_REF(((long)18)), BgL_funz00_2153, BGl_string2954z00zzbmemz00, 
BINT(((long)2746))); 
{ 
obj_t BgL_auxz00_2995;obj_t BgL_auxz00_2993;obj_t BgL_auxz00_2991;
BgL_auxz00_2995 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2993 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_2991 = 
CNST_TABLE_REF(((long)19)); 
FAILURE(BgL_auxz00_2991,BgL_auxz00_2993,BgL_auxz00_2995);} } } } 
BGL_ENV_POP_TRACE(BgL_env2212z00_1059); 
return BgL_aux2209z00_1060;} } } } 

}



/* &<@anonymous:1636:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:60@> */
obj_t BGl_z62zc3z04anonymousza31636za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza360z04ze3z33zzbmemz00(obj_t BgL_envz00_2068)
{
{ /* bmem/bmem.scm 61 */
{ /* bmem/bmem.scm 62 */
obj_t BgL_procz00_2069;
BgL_procz00_2069 = 
PROCEDURE_REF(BgL_envz00_2068, 
(int)(((long)0))); 
{ /* bmem/bmem.scm 62 */
obj_t BgL_funz00_2477;
if(
PROCEDUREP(BgL_procz00_2069))
{ /* bmem/bmem.scm 62 */
BgL_funz00_2477 = BgL_procz00_2069; }  else 
{ 
obj_t BgL_auxz00_3003;
BgL_auxz00_3003 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)2666)), BGl_string2960z00zzbmemz00, BGl_string2958z00zzbmemz00, BgL_procz00_2069); 
FAILURE(BgL_auxz00_3003,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_2477, ((long)1)))
{ /* bmem/bmem.scm 62 */
return 
PROCEDURE_ENTRY(BgL_funz00_2477)(BgL_procz00_2069, BFALSE, BEOA);}  else 
{ /* bmem/bmem.scm 62 */
BGl_errorzf2locationzf2zz__errorz00(BGl_string2961z00zzbmemz00, 
CNST_TABLE_REF(((long)18)), BgL_funz00_2477, BGl_string2954z00zzbmemz00, 
BINT(((long)2666))); 
{ 
obj_t BgL_auxz00_3020;obj_t BgL_auxz00_3018;obj_t BgL_auxz00_3016;
BgL_auxz00_3020 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_3018 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_3016 = 
CNST_TABLE_REF(((long)19)); 
FAILURE(BgL_auxz00_3016,BgL_auxz00_3018,BgL_auxz00_3020);} } } } } 

}



/* parse-cmdline! */
obj_t BGl_parsezd2cmdlinez12zc0zzbmemz00(obj_t BgL_argvz00_5)
{
{ /* bmem/bmem.scm 70 */
{ /* bmem/bmem.scm 72 */
obj_t BgL_name2214z00_1061;obj_t BgL_loc2215z00_1062;obj_t BgL_env2216z00_1063;
BgL_name2214z00_1061 = 
CNST_TABLE_REF(((long)20)); 
BgL_loc2215z00_1062 = 
CNST_TABLE_REF(((long)21)); 
BgL_env2216z00_1063 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 72 */

BGL_ENV_PUSH_TRACE(BgL_env2216z00_1063, BgL_name2214z00_1061, BgL_loc2215z00_1062); 
{ /* bmem/bmem.scm 72 */
obj_t BgL_aux2213z00_1064;
BGl_za2uriza2z00zzbmem_paramz00 = 
BGl_getenvz00zz__osz00(BGl_string2962z00zzbmemz00); 
BGl_za2hostnameza2z00zzbmem_paramz00 = 
BGl_getenvz00zz__osz00(BGl_string2963z00zzbmemz00); 
BGl_za2portza2z00zzbmem_paramz00 = 
BGl_getenvz00zz__osz00(BGl_string2964z00zzbmemz00); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_argszd2parsezd2usagez00_55;
BgL_argszd2parsezd2usagez00_55 = 
BGl_argszd2parsezd2usagez00zz__expander_argsz00(
CNST_TABLE_REF(((long)22))); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_pza2za2_56;
{ /* bmem/bmem.scm 76 */
obj_t BgL_list1789z00_277;
BgL_list1789z00_277 = 
MAKE_YOUNG_PAIR(BGl_proc2965z00zzbmemz00, BNIL); 
BgL_pza2za2_56 = BgL_list1789z00_277; } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_aza2za2_57;
BgL_aza2za2_57 = 
CDR(BgL_argvz00_5); 
{ /* bmem/bmem.scm 76 */

BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2966z00zzbmemz00, BgL_pza2za2_56); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_zc3z04anonymousza31651za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_2077;
BgL_zc3z04anonymousza31651za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_2077 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31651za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 
(int)(((long)2)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31651za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_2077, 
(int)(((long)0)), BgL_argszd2parsezd2usagez00_55); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza31651za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_2077, BgL_pza2za2_56); } 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2967z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2968z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2969z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2970z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2971z00zzbmemz00, BgL_pza2za2_56); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BGl_proc2972z00zzbmemz00, BgL_pza2za2_56); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_zc3z04anonymousza31775za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_2070;
BgL_zc3z04anonymousza31775za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_2070 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31775za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00, 
(int)(((long)2)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31775za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_2070, 
(int)(((long)0)), BgL_argszd2parsezd2usagez00_55); 
BgL_pza2za2_56 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza31775za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_2070, BgL_pza2za2_56); } 
if(
BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_aza2za2_57))
{ 
obj_t BgL_aza2za2_259;obj_t BgL_vz00_260;
BgL_aza2za2_259 = BgL_aza2za2_57; 
BgL_vz00_260 = BFALSE; 
BgL_zc3z04anonymousza31781za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_261:
{ 
obj_t BgL_pza2za2_263;
BgL_pza2za2_263 = BgL_pza2za2_56; 
BgL_zc3z04anonymousza31782za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_264:
{ /* bmem/bmem.scm 76 */
obj_t BgL_actionz00_265;
{ /* bmem/bmem.scm 76 */
obj_t BgL_fun1787z00_273;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_1455;
if(
PAIRP(BgL_pza2za2_263))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_1455 = BgL_pza2za2_263; }  else 
{ 
obj_t BgL_auxz00_3057;
BgL_auxz00_3057 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2973z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_pza2za2_263); 
FAILURE(BgL_auxz00_3057,BFALSE,BFALSE);} 
BgL_fun1787z00_273 = 
CAR(BgL_pairz00_1455); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_funz00_2165;
if(
PROCEDUREP(BgL_fun1787z00_273))
{ /* bmem/bmem.scm 76 */
BgL_funz00_2165 = BgL_fun1787z00_273; }  else 
{ 
obj_t BgL_auxz00_3064;
BgL_auxz00_3064 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2973z00zzbmemz00, BGl_string2958z00zzbmemz00, BgL_fun1787z00_273); 
FAILURE(BgL_auxz00_3064,BFALSE,BFALSE);} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_2165, ((long)2)))
{ /* bmem/bmem.scm 76 */
BgL_actionz00_265 = 
PROCEDURE_ENTRY(BgL_funz00_2165)(BgL_fun1787z00_273, BgL_aza2za2_259, BgL_vz00_260, BEOA); }  else 
{ /* bmem/bmem.scm 76 */
BGl_errorzf2locationzf2zz__errorz00(BGl_string2975z00zzbmemz00, 
CNST_TABLE_REF(((long)23)), BgL_funz00_2165, BGl_string2954z00zzbmemz00, 
BINT(((long)3182))); 
{ 
obj_t BgL_auxz00_3082;obj_t BgL_auxz00_3080;obj_t BgL_auxz00_3078;
BgL_auxz00_3082 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_3080 = 
CNST_TABLE_REF(((long)19)); 
BgL_auxz00_3078 = 
CNST_TABLE_REF(((long)19)); 
FAILURE(BgL_auxz00_3078,BgL_auxz00_3080,BgL_auxz00_3082);} } } } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_naza2za2_266;obj_t BgL_nvz00_267;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3085;
BgL_tmpz00_3085 = 
(int)(((long)1)); 
BgL_naza2za2_266 = 
BGL_MVALUES_VAL(BgL_tmpz00_3085); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3088;
BgL_tmpz00_3088 = 
(int)(((long)2)); 
BgL_nvz00_267 = 
BGL_MVALUES_VAL(BgL_tmpz00_3088); } 
if(
(BgL_actionz00_265==
CNST_TABLE_REF(((long)24))))
{ 
obj_t BgL_vz00_3095;obj_t BgL_aza2za2_3094;
BgL_aza2za2_3094 = BgL_naza2za2_266; 
BgL_vz00_3095 = BgL_nvz00_267; 
BgL_vz00_260 = BgL_vz00_3095; 
BgL_aza2za2_259 = BgL_aza2za2_3094; 
goto BgL_zc3z04anonymousza31781za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_261;}  else 
{ /* bmem/bmem.scm 76 */
if(
(BgL_actionz00_265==
CNST_TABLE_REF(((long)25))))
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1785z00_271;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_1460;
if(
PAIRP(BgL_pza2za2_263))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_1460 = BgL_pza2za2_263; }  else 
{ 
obj_t BgL_auxz00_3101;
BgL_auxz00_3101 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2973z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_pza2za2_263); 
FAILURE(BgL_auxz00_3101,BFALSE,BFALSE);} 
BgL_arg1785z00_271 = 
CDR(BgL_pairz00_1460); } 
{ 
obj_t BgL_pza2za2_3106;
BgL_pza2za2_3106 = BgL_arg1785z00_271; 
BgL_pza2za2_263 = BgL_pza2za2_3106; 
goto BgL_zc3z04anonymousza31782za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z51_264;} }  else 
{ /* bmem/bmem.scm 76 */
if(
(BgL_actionz00_265==
CNST_TABLE_REF(((long)26))))
{ /* bmem/bmem.scm 76 */
BgL_aux2213z00_1064 = BgL_nvz00_267; }  else 
{ /* bmem/bmem.scm 76 */
BgL_aux2213z00_1064 = BUNSPEC; } } } } } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_aux2213z00_1064 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)27)), BGl_string2976z00zzbmemz00, BgL_aza2za2_57, BGl_string2954z00zzbmemz00, 
BINT(((long)3182))); } } } } } 
BGL_ENV_POP_TRACE(BgL_env2216z00_1063); 
return BgL_aux2213z00_1064;} } } } 

}



/* &<@anonymous:1775:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31775za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2080, obj_t BgL_g1304z00_2082, obj_t BgL_g1305z00_2083)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
obj_t BgL_argszd2parsezd2usagez00_2081;
BgL_argszd2parsezd2usagez00_2081 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_2080, 
(int)(((long)0)))); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_test3372z00_3117;
if(
PAIRP(BgL_g1304z00_2082))
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1779z00_2478;
BgL_arg1779z00_2478 = 
CAR(BgL_g1304z00_2082); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2392z00_2479;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2480;
if(
STRINGP(BgL_arg1779z00_2478))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2480 = BgL_arg1779z00_2478; }  else 
{ 
obj_t BgL_auxz00_3123;
BgL_auxz00_3123 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2977z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1779z00_2478); 
FAILURE(BgL_auxz00_3123,BFALSE,BFALSE);} 
if(
(((long)6)==
STRING_LENGTH(BgL_string2z00_2480)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2482;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3132;char * BgL_tmpz00_3130;
BgL_auxz00_3132 = 
BSTRING_TO_STRING(BgL_string2z00_2480); 
BgL_tmpz00_3130 = 
BSTRING_TO_STRING(BGl_string2979z00zzbmemz00); 
BgL_arg1269z00_2482 = 
memcmp(BgL_tmpz00_3130, BgL_auxz00_3132, ((long)6)); } 
BgL_res2392z00_2479 = 
(
(long)(BgL_arg1269z00_2482)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2392z00_2479 = ((bool_t)0); } } 
BgL_test3372z00_3117 = BgL_res2392z00_2479; } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test3372z00_3117 = ((bool_t)0)
; } 
if(BgL_test3372z00_3117)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2483;
BgL_thezd2remainingzd2argsz00_2483 = 
CDR(BgL_g1304z00_2082); 
{ /* bmem/bmem.scm 78 */
obj_t BgL_nvz00_2484;
BGl_usagez00zzbmemz00(BgL_argszd2parsezd2usagez00_2081); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2202z00_2485;obj_t BgL_loc2203z00_2486;obj_t BgL_env2204z00_2487;
BgL_name2202z00_2485 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2203z00_2486 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2204z00_2487 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2204z00_2487, BgL_name2202z00_2485, BgL_loc2203z00_2486); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2201z00_2488;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1625z00_2489;
BgL_list1625z00_2489 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2201z00_2488 = 
BGl_exitz00zz__errorz00(BgL_list1625z00_2489); } 
BGL_ENV_POP_TRACE(BgL_env2204z00_2487); 
BgL_nvz00_2484 = BgL_aux2201z00_2488; } } } 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1545z00_2490;
BgL_val0_1545z00_2490 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2393z00_2491;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3148;
BgL_tmpz00_3148 = 
(int)(((long)3)); 
BgL_res2393z00_2491 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3148); } BgL_res2393z00_2491; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3151;
BgL_tmpz00_3151 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3151, BgL_thezd2remainingzd2argsz00_2483); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3154;
BgL_tmpz00_3154 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3154, BgL_nvz00_2484); } 
return BgL_val0_1545z00_2490;} } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1548z00_2492;
BgL_val0_1548z00_2492 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2394z00_2493;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3158;
BgL_tmpz00_3158 = 
(int)(((long)3)); 
BgL_res2394z00_2493 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3158); } BgL_res2394z00_2493; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3161;
BgL_tmpz00_3161 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3161, BgL_g1304z00_2082); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3164;
BgL_tmpz00_3164 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3164, BgL_g1305z00_2083); } 
return BgL_val0_1548z00_2492;} } } } 

}



/* &<@anonymous:1755:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31755za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2084, obj_t BgL_g1301z00_2085, obj_t BgL_g1302z00_2086)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test3376z00_3167;
if(
PAIRP(BgL_g1301z00_2085))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1303z00_2494;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1773z00_2495;
BgL_arg1773z00_2495 = 
CAR(BgL_g1301z00_2085); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2378z00_2496;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2497;
if(
STRINGP(BgL_arg1773z00_2495))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2497 = BgL_arg1773z00_2495; }  else 
{ 
obj_t BgL_auxz00_3173;
BgL_auxz00_3173 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2980z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1773z00_2495); 
FAILURE(BgL_auxz00_3173,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2497)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2499;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3182;char * BgL_tmpz00_3180;
BgL_auxz00_3182 = 
BSTRING_TO_STRING(BgL_string2z00_2497); 
BgL_tmpz00_3180 = 
BSTRING_TO_STRING(BGl_string2981z00zzbmemz00); 
BgL_arg1269z00_2499 = 
memcmp(BgL_tmpz00_3180, BgL_auxz00_3182, ((long)2)); } 
BgL_res2378z00_2496 = 
(
(long)(BgL_arg1269z00_2499)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2378z00_2496 = ((bool_t)0); } } 
BgL__ortest_1303z00_2494 = BgL_res2378z00_2496; } } 
if(BgL__ortest_1303z00_2494)
{ /* bmem/bmem.scm 76 */
BgL_test3376z00_3167 = BgL__ortest_1303z00_2494
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1772z00_2500;
BgL_arg1772z00_2500 = 
CAR(BgL_g1301z00_2085); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2383z00_2501;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2502;
if(
STRINGP(BgL_arg1772z00_2500))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2502 = BgL_arg1772z00_2500; }  else 
{ 
obj_t BgL_auxz00_3191;
BgL_auxz00_3191 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2980z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1772z00_2500); 
FAILURE(BgL_auxz00_3191,BFALSE,BFALSE);} 
if(
(((long)9)==
STRING_LENGTH(BgL_string2z00_2502)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2504;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3200;char * BgL_tmpz00_3198;
BgL_auxz00_3200 = 
BSTRING_TO_STRING(BgL_string2z00_2502); 
BgL_tmpz00_3198 = 
BSTRING_TO_STRING(BGl_string2982z00zzbmemz00); 
BgL_arg1269z00_2504 = 
memcmp(BgL_tmpz00_3198, BgL_auxz00_3200, ((long)9)); } 
BgL_res2383z00_2501 = 
(
(long)(BgL_arg1269z00_2504)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2383z00_2501 = ((bool_t)0); } } 
BgL_test3376z00_3167 = BgL_res2383z00_2501; } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test3376z00_3167 = ((bool_t)0)
; } 
if(BgL_test3376z00_3167)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2505;
BgL_thezd2remainingzd2argsz00_2505 = 
CDR(BgL_g1301z00_2085); 
{ /* bmem/bmem.scm 83 */
obj_t BgL_nvz00_2506;
if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 82 */
obj_t BgL_arg1771z00_2507;
{ /* bmem/bmem.scm 82 */
obj_t BgL_auxz00_3215;obj_t BgL_auxz00_3208;
{ /* bmem/bmem.scm 82 */
obj_t BgL_aux2679z00_2509;
BgL_aux2679z00_2509 = BGl_za2bmemzd2versionza2zd2zzbmem_paramz00; 
if(
STRINGP(BgL_aux2679z00_2509))
{ /* bmem/bmem.scm 82 */
BgL_auxz00_3215 = BgL_aux2679z00_2509
; }  else 
{ 
obj_t BgL_auxz00_3218;
BgL_auxz00_3218 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3434)), BGl_string2980z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_aux2679z00_2509); 
FAILURE(BgL_auxz00_3218,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 82 */
obj_t BgL_aux2677z00_2508;
BgL_aux2677z00_2508 = BGl_za2bmemza2z00zzbmem_paramz00; 
if(
STRINGP(BgL_aux2677z00_2508))
{ /* bmem/bmem.scm 82 */
BgL_auxz00_3208 = BgL_aux2677z00_2508
; }  else 
{ 
obj_t BgL_auxz00_3211;
BgL_auxz00_3211 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3427)), BGl_string2980z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_aux2677z00_2508); 
FAILURE(BgL_auxz00_3211,BFALSE,BFALSE);} } 
BgL_arg1771z00_2507 = 
BGl_htmlzd2pluginzd2versionz00zzhtmlz00(BFALSE, BgL_auxz00_3208, BgL_auxz00_3215); } 
{ /* bmem/bmem.scm 82 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_3223;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1771z00_2507, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 82 */
BgL_auxz00_3223 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_arg1771z00_2507)
; }  else 
{ 
obj_t BgL_auxz00_3227;
BgL_auxz00_3227 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3448)), BGl_string2980z00zzbmemz00, BGl_string2956z00zzbmemz00, BgL_arg1771z00_2507); 
FAILURE(BgL_auxz00_3227,BFALSE,BFALSE);} 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_3223); } }  else 
{ /* bmem/bmem.scm 83 */
obj_t BgL_port1538z00_2510;
{ /* bmem/bmem.scm 83 */
obj_t BgL_res2384z00_2511;
{ /* bmem/bmem.scm 83 */
obj_t BgL_tmpz00_3232;
BgL_tmpz00_3232 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2384z00_2511 = 
BGL_ENV_CURRENT_ERROR_PORT(BgL_tmpz00_3232); } 
BgL_port1538z00_2510 = BgL_res2384z00_2511; } 
bgl_display_obj(BGl_za2bmemza2z00zzbmem_paramz00, BgL_port1538z00_2510); 
bgl_display_string(BGl_string2983z00zzbmemz00, BgL_port1538z00_2510); 
bgl_display_obj(BGl_za2bmemzd2versionza2zd2zzbmem_paramz00, BgL_port1538z00_2510); 
bgl_display_char(((unsigned char)10), BgL_port1538z00_2510); } 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2202z00_2512;obj_t BgL_loc2203z00_2513;obj_t BgL_env2204z00_2514;
BgL_name2202z00_2512 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2203z00_2513 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2204z00_2514 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2204z00_2514, BgL_name2202z00_2512, BgL_loc2203z00_2513); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2201z00_2515;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1625z00_2516;
BgL_list1625z00_2516 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2201z00_2515 = 
BGl_exitz00zz__errorz00(BgL_list1625z00_2516); } 
BGL_ENV_POP_TRACE(BgL_env2204z00_2514); 
BgL_nvz00_2506 = BgL_aux2201z00_2515; } } } 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1539z00_2517;
BgL_val0_1539z00_2517 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2385z00_2518;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3248;
BgL_tmpz00_3248 = 
(int)(((long)3)); 
BgL_res2385z00_2518 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3248); } BgL_res2385z00_2518; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3251;
BgL_tmpz00_3251 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3251, BgL_thezd2remainingzd2argsz00_2505); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3254;
BgL_tmpz00_3254 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3254, BgL_nvz00_2506); } 
return BgL_val0_1539z00_2517;} } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1542z00_2519;
BgL_val0_1542z00_2519 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2386z00_2520;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3258;
BgL_tmpz00_3258 = 
(int)(((long)3)); 
BgL_res2386z00_2520 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3258); } BgL_res2386z00_2520; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3261;
BgL_tmpz00_3261 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3261, BgL_g1301z00_2085); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3264;
BgL_tmpz00_3264 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3264, BgL_g1302z00_2086); } 
return BgL_val0_1542z00_2519;} } } 

}



/* &<@anonymous:1725:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31725za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2087, obj_t BgL_g1298z00_2088, obj_t BgL_g1299z00_2089)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test3387z00_3267;
if(
PAIRP(BgL_g1298z00_2088))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1300z00_2521;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1741z00_2522;
BgL_arg1741z00_2522 = 
CAR(BgL_g1298z00_2088); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2364z00_2523;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2524;
if(
STRINGP(BgL_arg1741z00_2522))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2524 = BgL_arg1741z00_2522; }  else 
{ 
obj_t BgL_auxz00_3273;
BgL_auxz00_3273 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2984z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1741z00_2522); 
FAILURE(BgL_auxz00_3273,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2524)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2526;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3282;char * BgL_tmpz00_3280;
BgL_auxz00_3282 = 
BSTRING_TO_STRING(BgL_string2z00_2524); 
BgL_tmpz00_3280 = 
BSTRING_TO_STRING(BGl_string2985z00zzbmemz00); 
BgL_arg1269z00_2526 = 
memcmp(BgL_tmpz00_3280, BgL_auxz00_3282, ((long)2)); } 
BgL_res2364z00_2523 = 
(
(long)(BgL_arg1269z00_2526)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2364z00_2523 = ((bool_t)0); } } 
BgL__ortest_1300z00_2521 = BgL_res2364z00_2523; } } 
if(BgL__ortest_1300z00_2521)
{ /* bmem/bmem.scm 76 */
BgL_test3387z00_3267 = BgL__ortest_1300z00_2521
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1735z00_2527;
BgL_arg1735z00_2527 = 
CAR(BgL_g1298z00_2088); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2369z00_2528;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2529;
if(
STRINGP(BgL_arg1735z00_2527))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2529 = BgL_arg1735z00_2527; }  else 
{ 
obj_t BgL_auxz00_3291;
BgL_auxz00_3291 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2984z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1735z00_2527); 
FAILURE(BgL_auxz00_3291,BFALSE,BFALSE);} 
if(
(((long)8)==
STRING_LENGTH(BgL_string2z00_2529)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2531;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3300;char * BgL_tmpz00_3298;
BgL_auxz00_3300 = 
BSTRING_TO_STRING(BgL_string2z00_2529); 
BgL_tmpz00_3298 = 
BSTRING_TO_STRING(BGl_string2986z00zzbmemz00); 
BgL_arg1269z00_2531 = 
memcmp(BgL_tmpz00_3298, BgL_auxz00_3300, ((long)8)); } 
BgL_res2369z00_2528 = 
(
(long)(BgL_arg1269z00_2531)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2369z00_2528 = ((bool_t)0); } } 
BgL_test3387z00_3267 = BgL_res2369z00_2528; } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test3387z00_3267 = ((bool_t)0)
; } 
if(BgL_test3387z00_3267)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2532;
BgL_thezd2remainingzd2argsz00_2532 = 
CDR(BgL_g1298z00_2088); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_foutz00_2533;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2532))
{ /* bmem/bmem.scm 76 */
BgL_foutz00_2533 = 
CAR(BgL_thezd2remainingzd2argsz00_2532); }  else 
{ /* bmem/bmem.scm 76 */
BgL_foutz00_2533 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)30)), BGl_string2987z00zzbmemz00, 
CNST_TABLE_REF(((long)31)), BGl_string2954z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2534;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2535;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2532))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2535 = BgL_thezd2remainingzd2argsz00_2532; }  else 
{ 
obj_t BgL_auxz00_3315;
BgL_auxz00_3315 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2984z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2532); 
FAILURE(BgL_auxz00_3315,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2534 = 
CDR(BgL_pairz00_2535); } 
{ /* bmem/bmem.scm 86 */
obj_t BgL_nvz00_2536;
BgL_nvz00_2536 = ( 
BGl_za2foutza2z00zzbmem_paramz00 = BgL_foutz00_2533, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1532z00_2537;
BgL_val0_1532z00_2537 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2371z00_2538;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3321;
BgL_tmpz00_3321 = 
(int)(((long)3)); 
BgL_res2371z00_2538 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3321); } BgL_res2371z00_2538; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3324;
BgL_tmpz00_3324 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3324, BgL_thezd2remainingzd2argsz00_2534); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3327;
BgL_tmpz00_3327 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3327, BgL_nvz00_2536); } 
return BgL_val0_1532z00_2537;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1535z00_2539;
BgL_val0_1535z00_2539 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2372z00_2540;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3331;
BgL_tmpz00_3331 = 
(int)(((long)3)); 
BgL_res2372z00_2540 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3331); } BgL_res2372z00_2540; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3334;
BgL_tmpz00_3334 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3334, BgL_g1298z00_2088); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3337;
BgL_tmpz00_3337 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3337, BgL_g1299z00_2089); } 
return BgL_val0_1535z00_2539;} } } 

}



/* &<@anonymous:1708:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31708za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2090, obj_t BgL_g1295z00_2091, obj_t BgL_g1296z00_2092)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test3396z00_3340;
if(
PAIRP(BgL_g1295z00_2091))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1297z00_2541;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1721z00_2542;
BgL_arg1721z00_2542 = 
CAR(BgL_g1295z00_2091); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2350z00_2543;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2544;
if(
STRINGP(BgL_arg1721z00_2542))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2544 = BgL_arg1721z00_2542; }  else 
{ 
obj_t BgL_auxz00_3346;
BgL_auxz00_3346 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2988z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1721z00_2542); 
FAILURE(BgL_auxz00_3346,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2544)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2546;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3355;char * BgL_tmpz00_3353;
BgL_auxz00_3355 = 
BSTRING_TO_STRING(BgL_string2z00_2544); 
BgL_tmpz00_3353 = 
BSTRING_TO_STRING(BGl_string2989z00zzbmemz00); 
BgL_arg1269z00_2546 = 
memcmp(BgL_tmpz00_3353, BgL_auxz00_3355, ((long)2)); } 
BgL_res2350z00_2543 = 
(
(long)(BgL_arg1269z00_2546)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2350z00_2543 = ((bool_t)0); } } 
BgL__ortest_1297z00_2541 = BgL_res2350z00_2543; } } 
if(BgL__ortest_1297z00_2541)
{ /* bmem/bmem.scm 76 */
BgL_test3396z00_3340 = BgL__ortest_1297z00_2541
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1720z00_2547;
BgL_arg1720z00_2547 = 
CAR(BgL_g1295z00_2091); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2355z00_2548;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2549;
if(
STRINGP(BgL_arg1720z00_2547))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2549 = BgL_arg1720z00_2547; }  else 
{ 
obj_t BgL_auxz00_3364;
BgL_auxz00_3364 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2988z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1720z00_2547); 
FAILURE(BgL_auxz00_3364,BFALSE,BFALSE);} 
if(
(((long)10)==
STRING_LENGTH(BgL_string2z00_2549)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2551;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3373;char * BgL_tmpz00_3371;
BgL_auxz00_3373 = 
BSTRING_TO_STRING(BgL_string2z00_2549); 
BgL_tmpz00_3371 = 
BSTRING_TO_STRING(BGl_string2990z00zzbmemz00); 
BgL_arg1269z00_2551 = 
memcmp(BgL_tmpz00_3371, BgL_auxz00_3373, ((long)10)); } 
BgL_res2355z00_2548 = 
(
(long)(BgL_arg1269z00_2551)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2355z00_2548 = ((bool_t)0); } } 
BgL_test3396z00_3340 = BgL_res2355z00_2548; } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test3396z00_3340 = ((bool_t)0)
; } 
if(BgL_test3396z00_3340)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2552;
BgL_thezd2remainingzd2argsz00_2552 = 
CDR(BgL_g1295z00_2091); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_functionz00_2553;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2552))
{ /* bmem/bmem.scm 76 */
BgL_functionz00_2553 = 
CAR(BgL_thezd2remainingzd2argsz00_2552); }  else 
{ /* bmem/bmem.scm 76 */
BgL_functionz00_2553 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)32)), BGl_string2987z00zzbmemz00, 
CNST_TABLE_REF(((long)33)), BGl_string2954z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2554;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2555;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2552))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2555 = BgL_thezd2remainingzd2argsz00_2552; }  else 
{ 
obj_t BgL_auxz00_3388;
BgL_auxz00_3388 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2988z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2552); 
FAILURE(BgL_auxz00_3388,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2554 = 
CDR(BgL_pairz00_2555); } 
{ /* bmem/bmem.scm 88 */
obj_t BgL_nvz00_2556;
BgL_nvz00_2556 = ( 
BGl_za2functionza2z00zzbmem_paramz00 = BgL_functionz00_2553, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1526z00_2557;
BgL_val0_1526z00_2557 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2357z00_2558;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3394;
BgL_tmpz00_3394 = 
(int)(((long)3)); 
BgL_res2357z00_2558 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3394); } BgL_res2357z00_2558; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3397;
BgL_tmpz00_3397 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3397, BgL_thezd2remainingzd2argsz00_2554); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3400;
BgL_tmpz00_3400 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3400, BgL_nvz00_2556); } 
return BgL_val0_1526z00_2557;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1529z00_2559;
BgL_val0_1529z00_2559 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2358z00_2560;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3404;
BgL_tmpz00_3404 = 
(int)(((long)3)); 
BgL_res2358z00_2560 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3404); } BgL_res2358z00_2560; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3407;
BgL_tmpz00_3407 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3407, BgL_g1295z00_2091); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3410;
BgL_tmpz00_3410 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3410, BgL_g1296z00_2092); } 
return BgL_val0_1529z00_2559;} } } 

}



/* &<@anonymous:1692:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31692za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2093, obj_t BgL_g1292z00_2094, obj_t BgL_g1293z00_2095)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test3405z00_3413;
if(
PAIRP(BgL_g1292z00_2094))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1294z00_2561;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1706z00_2562;
BgL_arg1706z00_2562 = 
CAR(BgL_g1292z00_2094); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2336z00_2563;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2564;
if(
STRINGP(BgL_arg1706z00_2562))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2564 = BgL_arg1706z00_2562; }  else 
{ 
obj_t BgL_auxz00_3419;
BgL_auxz00_3419 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2991z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1706z00_2562); 
FAILURE(BgL_auxz00_3419,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2564)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2566;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3428;char * BgL_tmpz00_3426;
BgL_auxz00_3428 = 
BSTRING_TO_STRING(BgL_string2z00_2564); 
BgL_tmpz00_3426 = 
BSTRING_TO_STRING(BGl_string2992z00zzbmemz00); 
BgL_arg1269z00_2566 = 
memcmp(BgL_tmpz00_3426, BgL_auxz00_3428, ((long)2)); } 
BgL_res2336z00_2563 = 
(
(long)(BgL_arg1269z00_2566)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2336z00_2563 = ((bool_t)0); } } 
BgL__ortest_1294z00_2561 = BgL_res2336z00_2563; } } 
if(BgL__ortest_1294z00_2561)
{ /* bmem/bmem.scm 76 */
BgL_test3405z00_3413 = BgL__ortest_1294z00_2561
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1700z00_2567;
BgL_arg1700z00_2567 = 
CAR(BgL_g1292z00_2094); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2341z00_2568;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2569;
if(
STRINGP(BgL_arg1700z00_2567))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2569 = BgL_arg1700z00_2567; }  else 
{ 
obj_t BgL_auxz00_3437;
BgL_auxz00_3437 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2991z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1700z00_2567); 
FAILURE(BgL_auxz00_3437,BFALSE,BFALSE);} 
if(
(((long)6)==
STRING_LENGTH(BgL_string2z00_2569)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2571;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3446;char * BgL_tmpz00_3444;
BgL_auxz00_3446 = 
BSTRING_TO_STRING(BgL_string2z00_2569); 
BgL_tmpz00_3444 = 
BSTRING_TO_STRING(BGl_string2993z00zzbmemz00); 
BgL_arg1269z00_2571 = 
memcmp(BgL_tmpz00_3444, BgL_auxz00_3446, ((long)6)); } 
BgL_res2341z00_2568 = 
(
(long)(BgL_arg1269z00_2571)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2341z00_2568 = ((bool_t)0); } } 
BgL_test3405z00_3413 = BgL_res2341z00_2568; } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test3405z00_3413 = ((bool_t)0)
; } 
if(BgL_test3405z00_3413)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2572;
BgL_thezd2remainingzd2argsz00_2572 = 
CDR(BgL_g1292z00_2094); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_typez00_2573;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2572))
{ /* bmem/bmem.scm 76 */
BgL_typez00_2573 = 
CAR(BgL_thezd2remainingzd2argsz00_2572); }  else 
{ /* bmem/bmem.scm 76 */
BgL_typez00_2573 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)34)), BGl_string2987z00zzbmemz00, 
CNST_TABLE_REF(((long)35)), BGl_string2954z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2574;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2575;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2572))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2575 = BgL_thezd2remainingzd2argsz00_2572; }  else 
{ 
obj_t BgL_auxz00_3461;
BgL_auxz00_3461 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2991z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2572); 
FAILURE(BgL_auxz00_3461,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2574 = 
CDR(BgL_pairz00_2575); } 
{ /* bmem/bmem.scm 90 */
obj_t BgL_nvz00_2576;
BgL_nvz00_2576 = ( 
BGl_za2typeza2z00zzbmem_paramz00 = BgL_typez00_2573, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1520z00_2577;
BgL_val0_1520z00_2577 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2343z00_2578;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3467;
BgL_tmpz00_3467 = 
(int)(((long)3)); 
BgL_res2343z00_2578 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3467); } BgL_res2343z00_2578; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3470;
BgL_tmpz00_3470 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3470, BgL_thezd2remainingzd2argsz00_2574); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3473;
BgL_tmpz00_3473 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3473, BgL_nvz00_2576); } 
return BgL_val0_1520z00_2577;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1523z00_2579;
BgL_val0_1523z00_2579 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2344z00_2580;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3477;
BgL_tmpz00_3477 = 
(int)(((long)3)); 
BgL_res2344z00_2580 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3477); } BgL_res2344z00_2580; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3480;
BgL_tmpz00_3480 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3480, BgL_g1292z00_2094); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3483;
BgL_tmpz00_3483 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3483, BgL_g1293z00_2095); } 
return BgL_val0_1523z00_2579;} } } 

}



/* &<@anonymous:1679:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31679za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2096, obj_t BgL_g1289z00_2097, obj_t BgL_g1290z00_2098)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test3414z00_3486;
if(
PAIRP(BgL_g1289z00_2097))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1291z00_2581;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1688z00_2582;
BgL_arg1688z00_2582 = 
CAR(BgL_g1289z00_2097); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2322z00_2583;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2584;
if(
STRINGP(BgL_arg1688z00_2582))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2584 = BgL_arg1688z00_2582; }  else 
{ 
obj_t BgL_auxz00_3492;
BgL_auxz00_3492 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2994z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1688z00_2582); 
FAILURE(BgL_auxz00_3492,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2584)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2586;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3501;char * BgL_tmpz00_3499;
BgL_auxz00_3501 = 
BSTRING_TO_STRING(BgL_string2z00_2584); 
BgL_tmpz00_3499 = 
BSTRING_TO_STRING(BGl_string2995z00zzbmemz00); 
BgL_arg1269z00_2586 = 
memcmp(BgL_tmpz00_3499, BgL_auxz00_3501, ((long)2)); } 
BgL_res2322z00_2583 = 
(
(long)(BgL_arg1269z00_2586)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2322z00_2583 = ((bool_t)0); } } 
BgL__ortest_1291z00_2581 = BgL_res2322z00_2583; } } 
if(BgL__ortest_1291z00_2581)
{ /* bmem/bmem.scm 76 */
BgL_test3414z00_3486 = BgL__ortest_1291z00_2581
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1687z00_2587;
BgL_arg1687z00_2587 = 
CAR(BgL_g1289z00_2097); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2327z00_2588;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2589;
if(
STRINGP(BgL_arg1687z00_2587))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2589 = BgL_arg1687z00_2587; }  else 
{ 
obj_t BgL_auxz00_3510;
BgL_auxz00_3510 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2994z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1687z00_2587); 
FAILURE(BgL_auxz00_3510,BFALSE,BFALSE);} 
if(
(((long)10)==
STRING_LENGTH(BgL_string2z00_2589)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2591;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3519;char * BgL_tmpz00_3517;
BgL_auxz00_3519 = 
BSTRING_TO_STRING(BgL_string2z00_2589); 
BgL_tmpz00_3517 = 
BSTRING_TO_STRING(BGl_string2996z00zzbmemz00); 
BgL_arg1269z00_2591 = 
memcmp(BgL_tmpz00_3517, BgL_auxz00_3519, ((long)10)); } 
BgL_res2327z00_2588 = 
(
(long)(BgL_arg1269z00_2591)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2327z00_2588 = ((bool_t)0); } } 
BgL_test3414z00_3486 = BgL_res2327z00_2588; } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test3414z00_3486 = ((bool_t)0)
; } 
if(BgL_test3414z00_3486)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2592;
BgL_thezd2remainingzd2argsz00_2592 = 
CDR(BgL_g1289z00_2097); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_hz00_2593;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2592))
{ /* bmem/bmem.scm 76 */
BgL_hz00_2593 = 
CAR(BgL_thezd2remainingzd2argsz00_2592); }  else 
{ /* bmem/bmem.scm 76 */
BgL_hz00_2593 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)36)), BGl_string2987z00zzbmemz00, 
CNST_TABLE_REF(((long)37)), BGl_string2954z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2594;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2595;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2592))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2595 = BgL_thezd2remainingzd2argsz00_2592; }  else 
{ 
obj_t BgL_auxz00_3534;
BgL_auxz00_3534 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2994z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2592); 
FAILURE(BgL_auxz00_3534,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2594 = 
CDR(BgL_pairz00_2595); } 
{ /* bmem/bmem.scm 92 */
obj_t BgL_nvz00_2596;
BgL_nvz00_2596 = ( 
BGl_za2hostnameza2z00zzbmem_paramz00 = BgL_hz00_2593, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1514z00_2597;
BgL_val0_1514z00_2597 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2329z00_2598;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3540;
BgL_tmpz00_3540 = 
(int)(((long)3)); 
BgL_res2329z00_2598 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3540); } BgL_res2329z00_2598; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3543;
BgL_tmpz00_3543 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3543, BgL_thezd2remainingzd2argsz00_2594); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3546;
BgL_tmpz00_3546 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3546, BgL_nvz00_2596); } 
return BgL_val0_1514z00_2597;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1517z00_2599;
BgL_val0_1517z00_2599 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2330z00_2600;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3550;
BgL_tmpz00_3550 = 
(int)(((long)3)); 
BgL_res2330z00_2600 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3550); } BgL_res2330z00_2600; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3553;
BgL_tmpz00_3553 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3553, BgL_g1289z00_2097); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3556;
BgL_tmpz00_3556 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3556, BgL_g1290z00_2098); } 
return BgL_val0_1517z00_2599;} } } 

}



/* &<@anonymous:1659:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31659za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2099, obj_t BgL_g1286z00_2100, obj_t BgL_g1287z00_2101)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
bool_t BgL_test3423z00_3559;
if(
PAIRP(BgL_g1286z00_2100))
{ /* bmem/bmem.scm 76 */
bool_t BgL__ortest_1288z00_2601;
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1677z00_2602;
BgL_arg1677z00_2602 = 
CAR(BgL_g1286z00_2100); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2308z00_2603;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2604;
if(
STRINGP(BgL_arg1677z00_2602))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2604 = BgL_arg1677z00_2602; }  else 
{ 
obj_t BgL_auxz00_3565;
BgL_auxz00_3565 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2997z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1677z00_2602); 
FAILURE(BgL_auxz00_3565,BFALSE,BFALSE);} 
if(
(((long)2)==
STRING_LENGTH(BgL_string2z00_2604)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2606;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3574;char * BgL_tmpz00_3572;
BgL_auxz00_3574 = 
BSTRING_TO_STRING(BgL_string2z00_2604); 
BgL_tmpz00_3572 = 
BSTRING_TO_STRING(BGl_string2998z00zzbmemz00); 
BgL_arg1269z00_2606 = 
memcmp(BgL_tmpz00_3572, BgL_auxz00_3574, ((long)2)); } 
BgL_res2308z00_2603 = 
(
(long)(BgL_arg1269z00_2606)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2308z00_2603 = ((bool_t)0); } } 
BgL__ortest_1288z00_2601 = BgL_res2308z00_2603; } } 
if(BgL__ortest_1288z00_2601)
{ /* bmem/bmem.scm 76 */
BgL_test3423z00_3559 = BgL__ortest_1288z00_2601
; }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1675z00_2607;
BgL_arg1675z00_2607 = 
CAR(BgL_g1286z00_2100); 
{ /* bmem/bmem.scm 76 */
bool_t BgL_res2313z00_2608;
{ /* bmem/bmem.scm 76 */
obj_t BgL_string2z00_2609;
if(
STRINGP(BgL_arg1675z00_2607))
{ /* bmem/bmem.scm 76 */
BgL_string2z00_2609 = BgL_arg1675z00_2607; }  else 
{ 
obj_t BgL_auxz00_3583;
BgL_auxz00_3583 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2997z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1675z00_2607); 
FAILURE(BgL_auxz00_3583,BFALSE,BFALSE);} 
if(
(((long)6)==
STRING_LENGTH(BgL_string2z00_2609)))
{ /* bmem/bmem.scm 76 */
int BgL_arg1269z00_2611;
{ /* bmem/bmem.scm 76 */
char * BgL_auxz00_3592;char * BgL_tmpz00_3590;
BgL_auxz00_3592 = 
BSTRING_TO_STRING(BgL_string2z00_2609); 
BgL_tmpz00_3590 = 
BSTRING_TO_STRING(BGl_string2999z00zzbmemz00); 
BgL_arg1269z00_2611 = 
memcmp(BgL_tmpz00_3590, BgL_auxz00_3592, ((long)6)); } 
BgL_res2313z00_2608 = 
(
(long)(BgL_arg1269z00_2611)==((long)0)); }  else 
{ /* bmem/bmem.scm 76 */
BgL_res2313z00_2608 = ((bool_t)0); } } 
BgL_test3423z00_3559 = BgL_res2313z00_2608; } } }  else 
{ /* bmem/bmem.scm 76 */
BgL_test3423z00_3559 = ((bool_t)0)
; } 
if(BgL_test3423z00_3559)
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2612;
BgL_thezd2remainingzd2argsz00_2612 = 
CDR(BgL_g1286z00_2100); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_pz00_2613;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2612))
{ /* bmem/bmem.scm 76 */
BgL_pz00_2613 = 
CAR(BgL_thezd2remainingzd2argsz00_2612); }  else 
{ /* bmem/bmem.scm 76 */
BgL_pz00_2613 = 
BGl_errorzf2locationzf2zz__errorz00(
CNST_TABLE_REF(((long)38)), BGl_string2987z00zzbmemz00, 
CNST_TABLE_REF(((long)39)), BGl_string2954z00zzbmemz00, 
BINT(((long)3182))); } 
{ /* bmem/bmem.scm 76 */
obj_t BgL_thezd2remainingzd2argsz00_2614;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2615;
if(
PAIRP(BgL_thezd2remainingzd2argsz00_2612))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2615 = BgL_thezd2remainingzd2argsz00_2612; }  else 
{ 
obj_t BgL_auxz00_3607;
BgL_auxz00_3607 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string2997z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_thezd2remainingzd2argsz00_2612); 
FAILURE(BgL_auxz00_3607,BFALSE,BFALSE);} 
BgL_thezd2remainingzd2argsz00_2614 = 
CDR(BgL_pairz00_2615); } 
{ /* bmem/bmem.scm 94 */
obj_t BgL_nvz00_2616;
BgL_nvz00_2616 = ( 
BGl_za2portza2z00zzbmem_paramz00 = BgL_pz00_2613, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */

{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1508z00_2617;
BgL_val0_1508z00_2617 = 
CNST_TABLE_REF(((long)24)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2315z00_2618;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3613;
BgL_tmpz00_3613 = 
(int)(((long)3)); 
BgL_res2315z00_2618 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3613); } BgL_res2315z00_2618; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3616;
BgL_tmpz00_3616 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3616, BgL_thezd2remainingzd2argsz00_2614); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3619;
BgL_tmpz00_3619 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3619, BgL_nvz00_2616); } 
return BgL_val0_1508z00_2617;} } } } } }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1511z00_2619;
BgL_val0_1511z00_2619 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2316z00_2620;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3623;
BgL_tmpz00_3623 = 
(int)(((long)3)); 
BgL_res2316z00_2620 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3623); } BgL_res2316z00_2620; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3626;
BgL_tmpz00_3626 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3626, BgL_g1286z00_2100); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3629;
BgL_tmpz00_3629 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3629, BgL_g1287z00_2101); } 
return BgL_val0_1511z00_2619;} } } 

}



/* &<@anonymous:1651:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31651za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2102, obj_t BgL_g1284z00_2104, obj_t BgL_g1285z00_2105)
{
{ /* bmem/bmem.scm 76 */
{ /* bmem/bmem.scm 76 */
obj_t BgL_argszd2parsezd2usagez00_2103;
BgL_argszd2parsezd2usagez00_2103 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_2102, 
(int)(((long)0)))); 
if(
NULLP(BgL_g1284z00_2104))
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1502z00_2621;obj_t BgL_val2_1504z00_2622;
BgL_val0_1502z00_2621 = 
CNST_TABLE_REF(((long)26)); 
{ /* bmem/bmem.scm 96 */
bool_t BgL_test3433z00_3638;
if(
STRINGP(BGl_za2uriza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 96 */
BgL_test3433z00_3638 = ((bool_t)0)
; }  else 
{ /* bmem/bmem.scm 96 */
if(
STRINGP(BGl_za2hostnameza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 97 */
BgL_test3433z00_3638 = 
STRINGP(BGl_za2portza2z00zzbmem_paramz00)
; }  else 
{ /* bmem/bmem.scm 97 */
BgL_test3433z00_3638 = ((bool_t)0)
; } } 
if(BgL_test3433z00_3638)
{ /* bmem/bmem.scm 96 */
BGl_usagez00zzbmemz00(BgL_argszd2parsezd2usagez00_2103); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2202z00_2623;obj_t BgL_loc2203z00_2624;obj_t BgL_env2204z00_2625;
BgL_name2202z00_2623 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2203z00_2624 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2204z00_2625 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2204z00_2625, BgL_name2202z00_2623, BgL_loc2203z00_2624); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2201z00_2626;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1625z00_2627;
BgL_list1625z00_2627 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2201z00_2626 = 
BGl_exitz00zz__errorz00(BgL_list1625z00_2627); } 
BGL_ENV_POP_TRACE(BgL_env2204z00_2625); 
BgL_val2_1504z00_2622 = BgL_aux2201z00_2626; } } } }  else 
{ /* bmem/bmem.scm 96 */
BgL_val2_1504z00_2622 = BFALSE; } } 
{ /* bmem/bmem.scm 76 */
int BgL_res2301z00_2628;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3653;
BgL_tmpz00_3653 = 
(int)(((long)3)); 
BgL_res2301z00_2628 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3653); } BgL_res2301z00_2628; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3656;
BgL_tmpz00_3656 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3656, BgL_g1284z00_2104); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3659;
BgL_tmpz00_3659 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3659, BgL_val2_1504z00_2622); } 
return BgL_val0_1502z00_2621;}  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1505z00_2629;
BgL_val0_1505z00_2629 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2302z00_2630;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3663;
BgL_tmpz00_3663 = 
(int)(((long)3)); 
BgL_res2302z00_2630 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3663); } BgL_res2302z00_2630; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3666;
BgL_tmpz00_3666 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3666, BgL_g1284z00_2104); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3669;
BgL_tmpz00_3669 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3669, BgL_g1285z00_2105); } 
return BgL_val0_1505z00_2629;} } } 

}



/* &<@anonymous:1644:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31644za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2106, obj_t BgL_g1282z00_2107, obj_t BgL_g1283z00_2108)
{
{ /* bmem/bmem.scm 76 */
if(
PAIRP(BgL_g1282z00_2107))
{ /* bmem/bmem.scm 76 */
obj_t BgL_elsez00_2631;
BgL_elsez00_2631 = 
CAR(BgL_g1282z00_2107); 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1496z00_2632;obj_t BgL_val1_1497z00_2633;obj_t BgL_val2_1498z00_2634;
BgL_val0_1496z00_2632 = 
CNST_TABLE_REF(((long)24)); 
BgL_val1_1497z00_2633 = 
CDR(BgL_g1282z00_2107); 
BgL_val2_1498z00_2634 = ( 
BGl_za2uriza2z00zzbmem_paramz00 = BgL_elsez00_2631, BUNSPEC) ; 
{ /* bmem/bmem.scm 76 */
int BgL_res2295z00_2635;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3677;
BgL_tmpz00_3677 = 
(int)(((long)3)); 
BgL_res2295z00_2635 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3677); } BgL_res2295z00_2635; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3680;
BgL_tmpz00_3680 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3680, BgL_val1_1497z00_2633); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3683;
BgL_tmpz00_3683 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3683, BgL_val2_1498z00_2634); } 
return BgL_val0_1496z00_2632;} }  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1499z00_2636;
BgL_val0_1499z00_2636 = 
CNST_TABLE_REF(((long)25)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2296z00_2637;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3687;
BgL_tmpz00_3687 = 
(int)(((long)3)); 
BgL_res2296z00_2637 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3687); } BgL_res2296z00_2637; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3690;
BgL_tmpz00_3690 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3690, BgL_g1282z00_2107); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3693;
BgL_tmpz00_3693 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3693, BgL_g1283z00_2108); } 
return BgL_val0_1499z00_2636;} } 

}



/* &<@anonymous:1790:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:76@> */
obj_t BGl_z62zc3z04anonymousza31790za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza376z04ze3z33zzbmemz00(obj_t BgL_envz00_2109, obj_t BgL_az00_2110, obj_t BgL_vz00_2111)
{
{ /* bmem/bmem.scm 76 */
if(
NULLP(BgL_az00_2110))
{ /* bmem/bmem.scm 76 */
obj_t BgL_val0_1493z00_2638;
BgL_val0_1493z00_2638 = 
CNST_TABLE_REF(((long)26)); 
{ /* bmem/bmem.scm 76 */
int BgL_res2292z00_2639;
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3699;
BgL_tmpz00_3699 = 
(int)(((long)3)); 
BgL_res2292z00_2639 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_3699); } BgL_res2292z00_2639; } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3702;
BgL_tmpz00_3702 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3702, BgL_az00_2110); } 
{ /* bmem/bmem.scm 76 */
int BgL_tmpz00_3705;
BgL_tmpz00_3705 = 
(int)(((long)2)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_3705, BgL_vz00_2111); } 
return BgL_val0_1493z00_2638;}  else 
{ /* bmem/bmem.scm 76 */
obj_t BgL_arg1792z00_2640;
{ /* bmem/bmem.scm 76 */
obj_t BgL_pairz00_2641;
if(
PAIRP(BgL_az00_2110))
{ /* bmem/bmem.scm 76 */
BgL_pairz00_2641 = BgL_az00_2110; }  else 
{ 
obj_t BgL_auxz00_3710;
BgL_auxz00_3710 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)3182)), BGl_string3000z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_az00_2110); 
FAILURE(BgL_auxz00_3710,BFALSE,BFALSE);} 
BgL_arg1792z00_2640 = 
CAR(BgL_pairz00_2641); } 
return 
BGl_errorzf2locationzf2zz__errorz00(BgL_arg1792z00_2640, BGl_string3001z00zzbmemz00, BGl_string3002z00zzbmemz00, BGl_string2954z00zzbmemz00, 
BINT(((long)3182)));} } 

}



/* parse-uri! */
obj_t BGl_parsezd2uriz12zc0zzbmemz00(obj_t BgL_uriz00_6)
{
{ /* bmem/bmem.scm 108 */
{ /* bmem/bmem.scm 109 */
obj_t BgL_name2218z00_1065;obj_t BgL_loc2219z00_1066;obj_t BgL_env2220z00_1067;
BgL_name2218z00_1065 = 
CNST_TABLE_REF(((long)40)); 
BgL_loc2219z00_1066 = 
CNST_TABLE_REF(((long)41)); 
BgL_env2220z00_1067 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 109 */

BGL_ENV_PUSH_TRACE(BgL_env2220z00_1067, BgL_name2218z00_1065, BgL_loc2219z00_1066); 
{ /* bmem/bmem.scm 109 */
obj_t BgL_aux2217z00_1068;
{ /* bmem/bmem.scm 109 */
obj_t BgL_pz00_287;
{ /* bmem/bmem.scm 109 */
obj_t BgL_patz00_295;
BgL_patz00_295 = BGl_pregexp1551z00zzbmemz00; 
{ /* bmem/bmem.scm 109 */
long BgL_endz00_298;
{ /* bmem/bmem.scm 109 */
obj_t BgL_stringz00_1464;
if(
STRINGP(BgL_uriz00_6))
{ /* bmem/bmem.scm 109 */
BgL_stringz00_1464 = BgL_uriz00_6; }  else 
{ 
obj_t BgL_auxz00_3723;
BgL_auxz00_3723 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4469)), BGl_string3003z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_uriz00_6); 
FAILURE(BgL_auxz00_3723,BFALSE,BFALSE);} 
BgL_endz00_298 = 
STRING_LENGTH(BgL_stringz00_1464); } 
{ /* bmem/bmem.scm 109 */

{ /* bmem/bmem.scm 109 */
obj_t BgL_auxz00_3728;
if(
STRINGP(BgL_uriz00_6))
{ /* bmem/bmem.scm 109 */
BgL_auxz00_3728 = BgL_uriz00_6
; }  else 
{ 
obj_t BgL_auxz00_3731;
BgL_auxz00_3731 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4469)), BGl_string3003z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_uriz00_6); 
FAILURE(BgL_auxz00_3731,BFALSE,BFALSE);} 
BgL_pz00_287 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_295, BgL_auxz00_3728, 
BINT(((long)0)), 
BINT(BgL_endz00_298)); } } } } 
if(
PAIRP(BgL_pz00_287))
{ /* bmem/bmem.scm 110 */
{ /* bmem/bmem.scm 112 */
obj_t BgL_pairz00_1470;
{ /* bmem/bmem.scm 112 */
obj_t BgL_aux2719z00_2220;
BgL_aux2719z00_2220 = 
CDR(BgL_pz00_287); 
if(
PAIRP(BgL_aux2719z00_2220))
{ /* bmem/bmem.scm 112 */
BgL_pairz00_1470 = BgL_aux2719z00_2220; }  else 
{ 
obj_t BgL_auxz00_3743;
BgL_auxz00_3743 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4562)), BGl_string3003z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2719z00_2220); 
FAILURE(BgL_auxz00_3743,BFALSE,BFALSE);} } 
BGl_za2fileza2z00zzbmem_paramz00 = 
CAR(BgL_pairz00_1470); } 
{ /* bmem/bmem.scm 113 */
obj_t BgL_pairz00_1476;
{ /* bmem/bmem.scm 113 */
obj_t BgL_pairz00_1475;
{ /* bmem/bmem.scm 113 */
obj_t BgL_aux2721z00_2222;
BgL_aux2721z00_2222 = 
CDR(BgL_pz00_287); 
if(
PAIRP(BgL_aux2721z00_2222))
{ /* bmem/bmem.scm 113 */
BgL_pairz00_1475 = BgL_aux2721z00_2222; }  else 
{ 
obj_t BgL_auxz00_3751;
BgL_auxz00_3751 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4595)), BGl_string3003z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2721z00_2222); 
FAILURE(BgL_auxz00_3751,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 113 */
obj_t BgL_aux2723z00_2224;
BgL_aux2723z00_2224 = 
CDR(BgL_pairz00_1475); 
if(
PAIRP(BgL_aux2723z00_2224))
{ /* bmem/bmem.scm 113 */
BgL_pairz00_1476 = BgL_aux2723z00_2224; }  else 
{ 
obj_t BgL_auxz00_3758;
BgL_auxz00_3758 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4595)), BGl_string3003z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2723z00_2224); 
FAILURE(BgL_auxz00_3758,BFALSE,BFALSE);} } } 
BgL_aux2217z00_1068 = ( 
BGl_za2functionza2z00zzbmem_paramz00 = 
CAR(BgL_pairz00_1476), BUNSPEC) ; } }  else 
{ /* bmem/bmem.scm 114 */
obj_t BgL_pz00_289;
{ /* bmem/bmem.scm 114 */
obj_t BgL_patz00_291;
BgL_patz00_291 = BGl_pregexp1552z00zzbmemz00; 
{ /* bmem/bmem.scm 114 */
long BgL_endz00_294;
{ /* bmem/bmem.scm 114 */
obj_t BgL_stringz00_1477;
if(
STRINGP(BgL_uriz00_6))
{ /* bmem/bmem.scm 114 */
BgL_stringz00_1477 = BgL_uriz00_6; }  else 
{ 
obj_t BgL_auxz00_3765;
BgL_auxz00_3765 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4619)), BGl_string3003z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_uriz00_6); 
FAILURE(BgL_auxz00_3765,BFALSE,BFALSE);} 
BgL_endz00_294 = 
STRING_LENGTH(BgL_stringz00_1477); } 
{ /* bmem/bmem.scm 114 */

{ /* bmem/bmem.scm 114 */
obj_t BgL_auxz00_3770;
if(
STRINGP(BgL_uriz00_6))
{ /* bmem/bmem.scm 114 */
BgL_auxz00_3770 = BgL_uriz00_6
; }  else 
{ 
obj_t BgL_auxz00_3773;
BgL_auxz00_3773 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4619)), BGl_string3003z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_uriz00_6); 
FAILURE(BgL_auxz00_3773,BFALSE,BFALSE);} 
BgL_pz00_289 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_291, BgL_auxz00_3770, 
BINT(((long)0)), 
BINT(BgL_endz00_294)); } } } } 
if(
PAIRP(BgL_pz00_289))
{ /* bmem/bmem.scm 115 */
{ /* bmem/bmem.scm 117 */
obj_t BgL_pairz00_1483;
{ /* bmem/bmem.scm 117 */
obj_t BgL_aux2729z00_2230;
BgL_aux2729z00_2230 = 
CDR(BgL_pz00_289); 
if(
PAIRP(BgL_aux2729z00_2230))
{ /* bmem/bmem.scm 117 */
BgL_pairz00_1483 = BgL_aux2729z00_2230; }  else 
{ 
obj_t BgL_auxz00_3785;
BgL_auxz00_3785 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4712)), BGl_string3003z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2729z00_2230); 
FAILURE(BgL_auxz00_3785,BFALSE,BFALSE);} } 
BGl_za2fileza2z00zzbmem_paramz00 = 
CAR(BgL_pairz00_1483); } 
{ /* bmem/bmem.scm 118 */
obj_t BgL_pairz00_1489;
{ /* bmem/bmem.scm 118 */
obj_t BgL_pairz00_1488;
{ /* bmem/bmem.scm 118 */
obj_t BgL_aux2731z00_2232;
BgL_aux2731z00_2232 = 
CDR(BgL_pz00_289); 
if(
PAIRP(BgL_aux2731z00_2232))
{ /* bmem/bmem.scm 118 */
BgL_pairz00_1488 = BgL_aux2731z00_2232; }  else 
{ 
obj_t BgL_auxz00_3793;
BgL_auxz00_3793 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4741)), BGl_string3003z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2731z00_2232); 
FAILURE(BgL_auxz00_3793,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 118 */
obj_t BgL_aux2733z00_2234;
BgL_aux2733z00_2234 = 
CDR(BgL_pairz00_1488); 
if(
PAIRP(BgL_aux2733z00_2234))
{ /* bmem/bmem.scm 118 */
BgL_pairz00_1489 = BgL_aux2733z00_2234; }  else 
{ 
obj_t BgL_auxz00_3800;
BgL_auxz00_3800 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)4741)), BGl_string3003z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2733z00_2234); 
FAILURE(BgL_auxz00_3800,BFALSE,BFALSE);} } } 
BgL_aux2217z00_1068 = ( 
BGl_za2typeza2z00zzbmem_paramz00 = 
CAR(BgL_pairz00_1489), BUNSPEC) ; } }  else 
{ /* bmem/bmem.scm 115 */
BgL_aux2217z00_1068 = ( 
BGl_za2fileza2z00zzbmem_paramz00 = BgL_uriz00_6, BUNSPEC) ; } } } 
BGL_ENV_POP_TRACE(BgL_env2220z00_1067); 
return BgL_aux2217z00_1068;} } } } 

}



/* main */
BGL_EXPORTED_DEF obj_t BGl_mainz00zzbmemz00(obj_t BgL_argvz00_7)
{
{ /* bmem/bmem.scm 124 */
{ /* bmem/bmem.scm 127 */
obj_t BgL_name2222z00_1069;obj_t BgL_loc2223z00_1070;obj_t BgL_env2224z00_1071;
BgL_name2222z00_1069 = 
CNST_TABLE_REF(((long)42)); 
BgL_loc2223z00_1070 = 
CNST_TABLE_REF(((long)43)); 
BgL_env2224z00_1071 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 127 */

BGL_ENV_PUSH_TRACE(BgL_env2224z00_1071, BgL_name2222z00_1069, BgL_loc2223z00_1070); 
{ /* bmem/bmem.scm 127 */
obj_t BgL_aux2221z00_1072;
{ /* bmem/bmem.scm 127 */
obj_t BgL_zc3z04anonymousza31804za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z51_2113;
BgL_zc3z04anonymousza31804za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z51_2113 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31804za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31804za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z51_2113, 
(int)(((long)0)), BgL_argvz00_7); 
BgL_aux2221z00_1072 = 
BGl_withzd2exceptionzd2handlerz00zz__errorz00(BGl_proc3004z00zzbmemz00, BgL_zc3z04anonymousza31804za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z51_2113); } 
BGL_ENV_POP_TRACE(BgL_env2224z00_1071); 
return BgL_aux2221z00_1072;} } } } 

}



/* &main */
obj_t BGl_z62mainz62zzbmemz00(obj_t BgL_envz00_2115, obj_t BgL_argvz00_2116)
{
{ /* bmem/bmem.scm 124 */
{ /* bmem/bmem.scm 127 */
obj_t BgL_auxz00_3817;
if(
PAIRP(BgL_argvz00_2116))
{ /* bmem/bmem.scm 127 */
BgL_auxz00_3817 = BgL_argvz00_2116
; }  else 
{ 
obj_t BgL_auxz00_3820;
BgL_auxz00_3820 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)5069)), BGl_string3005z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_argvz00_2116); 
FAILURE(BgL_auxz00_3820,BFALSE,BFALSE);} 
return 
BGl_mainz00zzbmemz00(BgL_auxz00_3817);} } 

}



/* &<@anonymous:1804:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:125@> */
obj_t BGl_z62zc3z04anonymousza31804za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00(obj_t BgL_envz00_2117)
{
{ /* bmem/bmem.scm 136 */
{ /* bmem/bmem.scm 137 */
obj_t BgL_argvz00_2118;
BgL_argvz00_2118 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_2117, 
(int)(((long)0)))); 
BGl_parsezd2cmdlinez12zc0zzbmemz00(BgL_argvz00_2118); 
if(
STRINGP(BGl_za2uriza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 138 */BFALSE; }  else 
{ /* bmem/bmem.scm 138 */
BGl_usagez00zzbmemz00(BGl_proc3006z00zzbmemz00); } 
BGl_parsezd2uriz12zc0zzbmemz00(BGl_za2uriza2z00zzbmem_paramz00); 
return 
BGl_bmemzd2requestzd2zzbmemz00();} } 

}



/* &<@anonymous:1797:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:125@> */
obj_t BGl_z62zc3z04anonymousza31797za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3125z04ze3z33zzbmemz00(obj_t BgL_envz00_2119, obj_t BgL_ez00_2120)
{
{ /* bmem/bmem.scm 126 */
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_2120, BGl_z62errorz62zz__objectz00))
{ /* bmem/bmem.scm 127 */
BGl_errorzd2notifyzd2zz__errorz00(BgL_ez00_2120); 
if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 132 */
obj_t BgL_arg1800z00_2642;
{ /* bmem/bmem.scm 132 */
obj_t BgL_arg1801z00_2643;obj_t BgL_arg1802z00_2644;obj_t BgL_arg1803z00_2645;
BgL_arg1801z00_2643 = 
(((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_ez00_2120)))->BgL_objz00); 
BgL_arg1802z00_2644 = 
(((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_ez00_2120)))->BgL_procz00); 
BgL_arg1803z00_2645 = 
(((BgL_z62errorz62_bglt)COBJECT(
((BgL_z62errorz62_bglt)BgL_ez00_2120)))->BgL_msgz00); 
{ /* bmem/bmem.scm 132 */
obj_t BgL_auxz00_3845;
{ /* bmem/bmem.scm 132 */
obj_t BgL_aux2737z00_2646;
BgL_aux2737z00_2646 = BGl_za2bmemza2z00zzbmem_paramz00; 
if(
STRINGP(BgL_aux2737z00_2646))
{ /* bmem/bmem.scm 132 */
BgL_auxz00_3845 = BgL_aux2737z00_2646
; }  else 
{ 
obj_t BgL_auxz00_3848;
BgL_auxz00_3848 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)5221)), BGl_string3007z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_aux2737z00_2646); 
FAILURE(BgL_auxz00_3848,BFALSE,BFALSE);} } 
BgL_arg1800z00_2642 = 
BGl_htmlzd2pluginzd2errorz00zzhtmlz00(BFALSE, BgL_auxz00_3845, BgL_arg1801z00_2643, BgL_arg1802z00_2644, BgL_arg1803z00_2645); } } 
{ /* bmem/bmem.scm 131 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_3853;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1800z00_2642, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 132 */
BgL_auxz00_3853 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_arg1800z00_2642)
; }  else 
{ 
obj_t BgL_auxz00_3857;
BgL_auxz00_3857 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)5240)), BGl_string3007z00zzbmemz00, BGl_string2956z00zzbmemz00, BgL_arg1800z00_2642); 
FAILURE(BgL_auxz00_3857,BFALSE,BFALSE);} 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_3853); } }  else 
{ /* bmem/bmem.scm 130 */BFALSE; } 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2202z00_2647;obj_t BgL_loc2203z00_2648;obj_t BgL_env2204z00_2649;
BgL_name2202z00_2647 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2203z00_2648 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2204z00_2649 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2204z00_2649, BgL_name2202z00_2647, BgL_loc2203z00_2648); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2201z00_2650;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1625z00_2651;
BgL_list1625z00_2651 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2201z00_2650 = 
BGl_exitz00zz__errorz00(BgL_list1625z00_2651); } 
BGL_ENV_POP_TRACE(BgL_env2204z00_2649); BgL_aux2201z00_2650; } } } ((bool_t)0); }  else 
{ /* bmem/bmem.scm 127 */((bool_t)0); } 
return 
BGl_raisez00zz__errorz00(BgL_ez00_2120);} 

}



/* &<@anonymous:1807:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:139@> */
obj_t BGl_z62zc3z04anonymousza31807za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3139z04ze3z33zzbmemz00(obj_t BgL_envz00_2121, obj_t BgL__z00_2122)
{
{ /* bmem/bmem.scm 139 */
{ /* bmem/bmem.scm 139 */
obj_t BgL_list1808z00_2652;
BgL_list1808z00_2652 = 
MAKE_YOUNG_PAIR(
BINT(((long)0)), BNIL); 
return 
BGl_exitz00zz__errorz00(BgL_list1808z00_2652);} } 

}



/* bmem-request */
obj_t BGl_bmemzd2requestzd2zzbmemz00()
{
{ /* bmem/bmem.scm 146 */
{ /* bmem/bmem.scm 147 */
obj_t BgL_name2226z00_1073;obj_t BgL_loc2227z00_1074;obj_t BgL_env2228z00_1075;
BgL_name2226z00_1073 = 
CNST_TABLE_REF(((long)44)); 
BgL_loc2227z00_1074 = 
CNST_TABLE_REF(((long)45)); 
BgL_env2228z00_1075 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 147 */

BGL_ENV_PUSH_TRACE(BgL_env2228z00_1075, BgL_name2226z00_1073, BgL_loc2227z00_1074); 
{ /* bmem/bmem.scm 147 */
obj_t BgL_aux2225z00_1076;
{ /* bmem/bmem.scm 147 */
obj_t BgL_monz00_319;
if(
STRINGP(BGl_za2fileza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 147 */
BgL_monz00_319 = 
BGl_withzd2inputzd2fromzd2filezd2zz__r4_ports_6_10_1z00(BGl_za2fileza2z00zzbmem_paramz00, BGl_readzd2envzd2zz__readerz00); }  else 
{ /* bmem/bmem.scm 149 */
obj_t BgL_arg1831z00_360;
{ /* bmem/bmem.scm 149 */
obj_t BgL_res2407z00_1504;
{ /* bmem/bmem.scm 149 */
obj_t BgL_tmpz00_3881;
BgL_tmpz00_3881 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_res2407z00_1504 = 
BGL_ENV_CURRENT_INPUT_PORT(BgL_tmpz00_3881); } 
BgL_arg1831z00_360 = BgL_res2407z00_1504; } 
{ /* bmem/bmem.scm 149 */

{ /* bmem/bmem.scm 149 */

BgL_monz00_319 = 
BGl_readz00zz__readerz00(BgL_arg1831z00_360, BFALSE); } } } 
{ /* bmem/bmem.scm 147 */
obj_t BgL_infoz00_320;
BgL_infoz00_320 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)46))); 
{ /* bmem/bmem.scm 150 */
obj_t BgL_gcmonz00_321;
BgL_gcmonz00_321 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)47))); 
{ /* bmem/bmem.scm 151 */
obj_t BgL_funmonz00_322;
BgL_funmonz00_322 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)48))); 
{ /* bmem/bmem.scm 152 */
obj_t BgL_typesz00_323;
BgL_typesz00_323 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)49))); 
{ /* bmem/bmem.scm 153 */
obj_t BgL_threadz00_324;
BgL_threadz00_324 = 
BGl_findzd2monitorzd2zzbmemz00(BgL_monz00_319, 
CNST_TABLE_REF(((long)50))); 
{ /* bmem/bmem.scm 154 */
obj_t BgL_cssz00_325;
{ /* bmem/bmem.scm 155 */
obj_t BgL_pz00_352;
{ /* bmem/bmem.scm 155 */
obj_t BgL_arg1826z00_355;
BgL_arg1826z00_355 = 
MAKE_YOUNG_PAIR(BGl_string3008z00zzbmemz00, BNIL); 
{ /* bmem/bmem.scm 155 */
obj_t BgL_list1827z00_356;
{ /* bmem/bmem.scm 155 */
obj_t BgL_arg1828z00_357;
{ /* bmem/bmem.scm 155 */
obj_t BgL_arg1829z00_358;
BgL_arg1829z00_358 = 
MAKE_YOUNG_PAIR(BgL_arg1826z00_355, BNIL); 
BgL_arg1828z00_357 = 
MAKE_YOUNG_PAIR(BGl_za2csszd2pathza2zd2zzbmem_paramz00, BgL_arg1829z00_358); } 
BgL_list1827z00_356 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)51)), BgL_arg1828z00_357); } 
BgL_pz00_352 = 
BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list1827z00_356); } } 
{ /* bmem/bmem.scm 156 */
obj_t BgL_fz00_353;
BgL_fz00_353 = 
BGl_findzd2filezf2pathz20zz__osz00(BGl_string3009z00zzbmemz00, BgL_pz00_352); 
if(
STRINGP(BgL_fz00_353))
{ /* bmem/bmem.scm 157 */
BgL_cssz00_325 = BgL_fz00_353; }  else 
{ /* bmem/bmem.scm 157 */
BgL_cssz00_325 = BFALSE; } } } 
{ /* bmem/bmem.scm 155 */

{ /* bmem/bmem.scm 161 */
bool_t BgL_test3459z00_3904;
if(
NULLP(BgL_gcmonz00_321))
{ /* bmem/bmem.scm 161 */
BgL_test3459z00_3904 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 161 */
obj_t BgL_tmpz00_3907;
{ /* bmem/bmem.scm 161 */
obj_t BgL_pairz00_1507;
if(
PAIRP(BgL_gcmonz00_321))
{ /* bmem/bmem.scm 161 */
BgL_pairz00_1507 = BgL_gcmonz00_321; }  else 
{ 
obj_t BgL_auxz00_3910;
BgL_auxz00_3910 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6164)), BGl_string3010z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_gcmonz00_321); 
FAILURE(BgL_auxz00_3910,BFALSE,BFALSE);} 
BgL_tmpz00_3907 = 
CDR(BgL_pairz00_1507); } 
BgL_test3459z00_3904 = 
NULLP(BgL_tmpz00_3907); } 
if(BgL_test3459z00_3904)
{ /* bmem/bmem.scm 161 */
{ /* bmem/bmem.scm 164 */
obj_t BgL_arg1812z00_329;
BgL_arg1812z00_329 = 
BGl_htmlzd2pluginzd2errorz00zzhtmlz00(BFALSE, BGl_string2952z00zzbmemz00, 
CNST_TABLE_REF(((long)52)), BGl_string3011z00zzbmemz00, BNIL); 
{ /* bmem/bmem.scm 163 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_3918;
if(
BGl_isazf3zf3zz__objectz00(BgL_arg1812z00_329, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 168 */
BgL_auxz00_3918 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_arg1812z00_329)
; }  else 
{ 
obj_t BgL_auxz00_3922;
BgL_auxz00_3922 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6312)), BGl_string3010z00zzbmemz00, BGl_string2956z00zzbmemz00, BgL_arg1812z00_329); 
FAILURE(BgL_auxz00_3922,BFALSE,BFALSE);} 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_3918); } } 
{ /* bmem/bmem.scm 41 */
obj_t BgL_name2202z00_1509;obj_t BgL_loc2203z00_1510;obj_t BgL_env2204z00_1511;
BgL_name2202z00_1509 = 
CNST_TABLE_REF(((long)28)); 
BgL_loc2203z00_1510 = 
CNST_TABLE_REF(((long)29)); 
BgL_env2204z00_1511 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 41 */

BGL_ENV_PUSH_TRACE(BgL_env2204z00_1511, BgL_name2202z00_1509, BgL_loc2203z00_1510); 
{ /* bmem/bmem.scm 41 */
obj_t BgL_aux2201z00_1513;
{ /* bmem/bmem.scm 41 */
obj_t BgL_list1625z00_1514;
BgL_list1625z00_1514 = 
MAKE_YOUNG_PAIR(
BINT(((long)-1)), BNIL); 
BgL_aux2201z00_1513 = 
BGl_exitz00zz__errorz00(BgL_list1625z00_1514); } 
BGL_ENV_POP_TRACE(BgL_env2204z00_1511); BgL_aux2201z00_1513; } } } }  else 
{ /* bmem/bmem.scm 161 */((bool_t)0); } } 
{ /* bmem/bmem.scm 171 */
obj_t BgL_cz00_332;
{ /* bmem/bmem.scm 171 */
obj_t BgL_auxz00_3935;
{ /* bmem/bmem.scm 171 */
obj_t BgL_pairz00_1515;
if(
PAIRP(BgL_infoz00_320))
{ /* bmem/bmem.scm 171 */
BgL_pairz00_1515 = BgL_infoz00_320; }  else 
{ 
obj_t BgL_auxz00_3939;
BgL_auxz00_3939 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6409)), BGl_string3010z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_infoz00_320); 
FAILURE(BgL_auxz00_3939,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 171 */
obj_t BgL_aux2747z00_2252;
BgL_aux2747z00_2252 = 
CDR(BgL_pairz00_1515); 
{ /* bmem/bmem.scm 171 */
bool_t BgL_test3464z00_3944;
if(
PAIRP(BgL_aux2747z00_2252))
{ /* bmem/bmem.scm 171 */
BgL_test3464z00_3944 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 171 */
BgL_test3464z00_3944 = 
NULLP(BgL_aux2747z00_2252)
; } 
if(BgL_test3464z00_3944)
{ /* bmem/bmem.scm 171 */
BgL_auxz00_3935 = BgL_aux2747z00_2252
; }  else 
{ 
obj_t BgL_auxz00_3948;
BgL_auxz00_3948 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6404)), BGl_string3010z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2747z00_2252); 
FAILURE(BgL_auxz00_3948,BFALSE,BFALSE);} } } } 
BgL_cz00_332 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)53)), BgL_auxz00_3935); } 
if(
PAIRP(BgL_cz00_332))
{ /* bmem/bmem.scm 173 */
obj_t BgL_arg1815z00_334;
{ /* bmem/bmem.scm 173 */
obj_t BgL_pairz00_1520;
{ /* bmem/bmem.scm 173 */
obj_t BgL_aux2749z00_2254;
BgL_aux2749z00_2254 = 
CDR(BgL_cz00_332); 
if(
PAIRP(BgL_aux2749z00_2254))
{ /* bmem/bmem.scm 173 */
BgL_pairz00_1520 = BgL_aux2749z00_2254; }  else 
{ 
obj_t BgL_auxz00_3958;
BgL_auxz00_3958 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6475)), BGl_string3010z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2749z00_2254); 
FAILURE(BgL_auxz00_3958,BFALSE,BFALSE);} } 
BgL_arg1815z00_334 = 
CAR(BgL_pairz00_1520); } 
{ /* bmem/bmem.scm 173 */
BGL_LONGLONG_T BgL_res2412z00_1522;
{ /* bmem/bmem.scm 173 */
long BgL_xz00_1521;
{ /* bmem/bmem.scm 173 */
obj_t BgL_tmpz00_3963;
if(
INTEGERP(BgL_arg1815z00_334))
{ /* bmem/bmem.scm 173 */
BgL_tmpz00_3963 = BgL_arg1815z00_334
; }  else 
{ 
obj_t BgL_auxz00_3966;
BgL_auxz00_3966 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6482)), BGl_string3010z00zzbmemz00, BGl_string3013z00zzbmemz00, BgL_arg1815z00_334); 
FAILURE(BgL_auxz00_3966,BFALSE,BFALSE);} 
BgL_xz00_1521 = 
(long)CINT(BgL_tmpz00_3963); } 
BgL_res2412z00_1522 = 
LONG_TO_LLONG(BgL_xz00_1521); } 
BGl_za2siza7eofzd2wordza2z75zzbmem_paramz00 = 
make_bllong(BgL_res2412z00_1522); } }  else 
{ /* bmem/bmem.scm 172 */BFALSE; } } 
{ /* bmem/bmem.scm 175 */
obj_t BgL_g1555z00_336;
{ /* bmem/bmem.scm 175 */
obj_t BgL_pairz00_1523;
if(
PAIRP(BgL_funmonz00_322))
{ /* bmem/bmem.scm 175 */
BgL_pairz00_1523 = BgL_funmonz00_322; }  else 
{ 
obj_t BgL_auxz00_3975;
BgL_auxz00_3975 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6556)), BGl_string3010z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_funmonz00_322); 
FAILURE(BgL_auxz00_3975,BFALSE,BFALSE);} 
BgL_g1555z00_336 = 
CDR(BgL_pairz00_1523); } 
{ 
obj_t BgL_l1553z00_338;
BgL_l1553z00_338 = BgL_g1555z00_336; 
BgL_zc3z04anonymousza31817za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3175z04ze3z51_339:
if(
PAIRP(BgL_l1553z00_338))
{ /* bmem/bmem.scm 175 */
{ /* bmem/bmem.scm 175 */
obj_t BgL_arg1819z00_341;
BgL_arg1819z00_341 = 
CAR(BgL_l1553z00_338); 
{ /* bmem/bmem.scm 175 */
obj_t BgL_auxz00_3983;
if(
PAIRP(BgL_arg1819z00_341))
{ /* bmem/bmem.scm 175 */
BgL_auxz00_3983 = BgL_arg1819z00_341
; }  else 
{ 
obj_t BgL_auxz00_3986;
BgL_auxz00_3986 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6551)), BGl_string3014z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_arg1819z00_341); 
FAILURE(BgL_auxz00_3986,BFALSE,BFALSE);} 
BGl_addzd2functionz12zc0zzbmem_functionz00(BgL_auxz00_3983); } } 
{ 
obj_t BgL_l1553z00_3991;
BgL_l1553z00_3991 = 
CDR(BgL_l1553z00_338); 
BgL_l1553z00_338 = BgL_l1553z00_3991; 
goto BgL_zc3z04anonymousza31817za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3175z04ze3z51_339;} }  else 
{ /* bmem/bmem.scm 175 */
if(
NULLP(BgL_l1553z00_338))
{ /* bmem/bmem.scm 175 */BTRUE; }  else 
{ /* bmem/bmem.scm 175 */
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string3015z00zzbmemz00, BGl_string3016z00zzbmemz00, BgL_l1553z00_338, BGl_string2954z00zzbmemz00, 
BINT(((long)6527))); } } } } 
{ /* bmem/bmem.scm 176 */
obj_t BgL_docz00_345;
if(
CBOOL(BGl_za2functionza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 178 */
obj_t BgL__ortest_1307z00_350;
{ /* bmem/bmem.scm 178 */
obj_t BgL_auxz00_4024;obj_t BgL_auxz00_4015;obj_t BgL_auxz00_4006;obj_t BgL_auxz00_3999;
{ /* bmem/bmem.scm 178 */
bool_t BgL_test3479z00_4025;
if(
PAIRP(BgL_typesz00_323))
{ /* bmem/bmem.scm 178 */
BgL_test3479z00_4025 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 178 */
BgL_test3479z00_4025 = 
NULLP(BgL_typesz00_323)
; } 
if(BgL_test3479z00_4025)
{ /* bmem/bmem.scm 178 */
BgL_auxz00_4024 = BgL_typesz00_323
; }  else 
{ 
obj_t BgL_auxz00_4029;
BgL_auxz00_4029 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6665)), BGl_string3010z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_typesz00_323); 
FAILURE(BgL_auxz00_4029,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 178 */
bool_t BgL_test3477z00_4016;
if(
PAIRP(BgL_funmonz00_322))
{ /* bmem/bmem.scm 178 */
BgL_test3477z00_4016 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 178 */
BgL_test3477z00_4016 = 
NULLP(BgL_funmonz00_322)
; } 
if(BgL_test3477z00_4016)
{ /* bmem/bmem.scm 178 */
BgL_auxz00_4015 = BgL_funmonz00_322
; }  else 
{ 
obj_t BgL_auxz00_4020;
BgL_auxz00_4020 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6658)), BGl_string3010z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_funmonz00_322); 
FAILURE(BgL_auxz00_4020,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 178 */
bool_t BgL_test3475z00_4007;
if(
PAIRP(BgL_gcmonz00_321))
{ /* bmem/bmem.scm 178 */
BgL_test3475z00_4007 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 178 */
BgL_test3475z00_4007 = 
NULLP(BgL_gcmonz00_321)
; } 
if(BgL_test3475z00_4007)
{ /* bmem/bmem.scm 178 */
BgL_auxz00_4006 = BgL_gcmonz00_321
; }  else 
{ 
obj_t BgL_auxz00_4011;
BgL_auxz00_4011 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6652)), BGl_string3010z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_gcmonz00_321); 
FAILURE(BgL_auxz00_4011,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 178 */
obj_t BgL_aux2757z00_2262;
BgL_aux2757z00_2262 = BGl_za2functionza2z00zzbmem_paramz00; 
if(
STRINGP(BgL_aux2757z00_2262))
{ /* bmem/bmem.scm 178 */
BgL_auxz00_3999 = BgL_aux2757z00_2262
; }  else 
{ 
obj_t BgL_auxz00_4002;
BgL_auxz00_4002 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6632)), BGl_string3010z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_aux2757z00_2262); 
FAILURE(BgL_auxz00_4002,BFALSE,BFALSE);} } 
BgL__ortest_1307z00_350 = 
BGl_bmemzd2functionzd2zzbmem_functionz00(BgL_auxz00_3999, BgL_cssz00_325, BgL_infoz00_320, BgL_auxz00_4006, BgL_auxz00_4015, BgL_auxz00_4024); } 
if(
CBOOL(BgL__ortest_1307z00_350))
{ /* bmem/bmem.scm 178 */
BgL_docz00_345 = BgL__ortest_1307z00_350; }  else 
{ /* bmem/bmem.scm 178 */
BgL_docz00_345 = 
BGl_htmlzd2pluginzd2errorz00zzhtmlz00(BFALSE, BGl_string2952z00zzbmemz00, 
CNST_TABLE_REF(((long)52)), BGl_string3017z00zzbmemz00, BGl_za2functionza2z00zzbmem_paramz00); } }  else 
{ /* bmem/bmem.scm 177 */
if(
CBOOL(BGl_za2typeza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 185 */
obj_t BgL__ortest_1308z00_351;
{ /* bmem/bmem.scm 185 */
obj_t BgL_auxz00_4065;obj_t BgL_auxz00_4056;obj_t BgL_auxz00_4047;obj_t BgL_auxz00_4040;
{ /* bmem/bmem.scm 185 */
bool_t BgL_test3488z00_4066;
if(
PAIRP(BgL_typesz00_323))
{ /* bmem/bmem.scm 185 */
BgL_test3488z00_4066 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 185 */
BgL_test3488z00_4066 = 
NULLP(BgL_typesz00_323)
; } 
if(BgL_test3488z00_4066)
{ /* bmem/bmem.scm 185 */
BgL_auxz00_4065 = BgL_typesz00_323
; }  else 
{ 
obj_t BgL_auxz00_4070;
BgL_auxz00_4070 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6852)), BGl_string3010z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_typesz00_323); 
FAILURE(BgL_auxz00_4070,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 185 */
bool_t BgL_test3486z00_4057;
if(
PAIRP(BgL_funmonz00_322))
{ /* bmem/bmem.scm 185 */
BgL_test3486z00_4057 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 185 */
BgL_test3486z00_4057 = 
NULLP(BgL_funmonz00_322)
; } 
if(BgL_test3486z00_4057)
{ /* bmem/bmem.scm 185 */
BgL_auxz00_4056 = BgL_funmonz00_322
; }  else 
{ 
obj_t BgL_auxz00_4061;
BgL_auxz00_4061 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6845)), BGl_string3010z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_funmonz00_322); 
FAILURE(BgL_auxz00_4061,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 185 */
bool_t BgL_test3484z00_4048;
if(
PAIRP(BgL_gcmonz00_321))
{ /* bmem/bmem.scm 185 */
BgL_test3484z00_4048 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 185 */
BgL_test3484z00_4048 = 
NULLP(BgL_gcmonz00_321)
; } 
if(BgL_test3484z00_4048)
{ /* bmem/bmem.scm 185 */
BgL_auxz00_4047 = BgL_gcmonz00_321
; }  else 
{ 
obj_t BgL_auxz00_4052;
BgL_auxz00_4052 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6839)), BGl_string3010z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_gcmonz00_321); 
FAILURE(BgL_auxz00_4052,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 185 */
obj_t BgL_aux2765z00_2270;
BgL_aux2765z00_2270 = BGl_za2typeza2z00zzbmem_paramz00; 
if(
STRINGP(BgL_aux2765z00_2270))
{ /* bmem/bmem.scm 185 */
BgL_auxz00_4040 = BgL_aux2765z00_2270
; }  else 
{ 
obj_t BgL_auxz00_4043;
BgL_auxz00_4043 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)6823)), BGl_string3010z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_aux2765z00_2270); 
FAILURE(BgL_auxz00_4043,BFALSE,BFALSE);} } 
BgL__ortest_1308z00_351 = 
BGl_bmemzd2typezd2zzbmem_typez00(BgL_auxz00_4040, BgL_cssz00_325, BgL_infoz00_320, BgL_auxz00_4047, BgL_auxz00_4056, BgL_auxz00_4065); } 
if(
CBOOL(BgL__ortest_1308z00_351))
{ /* bmem/bmem.scm 185 */
BgL_docz00_345 = BgL__ortest_1308z00_351; }  else 
{ /* bmem/bmem.scm 185 */
BgL_docz00_345 = 
BGl_htmlzd2pluginzd2errorz00zzhtmlz00(BFALSE, BGl_string2952z00zzbmemz00, 
CNST_TABLE_REF(((long)52)), BGl_string3018z00zzbmemz00, BGl_za2typeza2z00zzbmem_paramz00); } }  else 
{ /* bmem/bmem.scm 184 */
BgL_docz00_345 = 
((obj_t)
BGl_bmemzd2allzd2zzbmemz00(BgL_cssz00_325, BgL_infoz00_320, BgL_gcmonz00_321, BgL_funmonz00_322, BgL_typesz00_323, BgL_threadz00_324)); } } 
if(
STRINGP(BGl_za2foutza2z00zzbmem_paramz00))
{ /* bmem/bmem.scm 194 */
obj_t BgL_zc3z04anonymousza31824za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z51_2123;
BgL_zc3z04anonymousza31824za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z51_2123 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31824za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z33zzbmemz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31824za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z51_2123, 
(int)(((long)0)), BgL_docz00_345); 
BgL_aux2225z00_1076 = 
BGl_withzd2outputzd2tozd2filezd2zz__r4_ports_6_10_1z00(BGl_za2foutza2z00zzbmem_paramz00, BgL_zc3z04anonymousza31824za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z51_2123); }  else 
{ /* bmem/bmem.scm 195 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_4089;
if(
BGl_isazf3zf3zz__objectz00(BgL_docz00_345, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 195 */
BgL_auxz00_4089 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_docz00_345)
; }  else 
{ 
obj_t BgL_auxz00_4093;
BgL_auxz00_4093 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)7140)), BGl_string3010z00zzbmemz00, BGl_string2956z00zzbmemz00, BgL_docz00_345); 
FAILURE(BgL_auxz00_4093,BFALSE,BFALSE);} 
BgL_aux2225z00_1076 = 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_4089); } } } } } } } } } } 
BGL_ENV_POP_TRACE(BgL_env2228z00_1075); 
return BgL_aux2225z00_1076;} } } } 

}



/* &<@anonymous:1824:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:194@> */
obj_t BGl_z62zc3z04anonymousza31824za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3194z04ze3z33zzbmemz00(obj_t BgL_envz00_2124)
{
{ /* bmem/bmem.scm 194 */
{ /* bmem/bmem.scm 194 */
obj_t BgL_docz00_2125;
BgL_docz00_2125 = 
PROCEDURE_REF(BgL_envz00_2124, 
(int)(((long)0))); 
{ /* bmem/bmem.scm 194 */
BgL_z52htmlzd2documentz80_bglt BgL_auxz00_4101;
if(
BGl_isazf3zf3zz__objectz00(BgL_docz00_2125, BGl_z52htmlzd2documentz80zzhtmlz00))
{ /* bmem/bmem.scm 194 */
BgL_auxz00_4101 = 
((BgL_z52htmlzd2documentz80_bglt)BgL_docz00_2125)
; }  else 
{ 
obj_t BgL_auxz00_4105;
BgL_auxz00_4105 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)7115)), BGl_string3019z00zzbmemz00, BGl_string2956z00zzbmemz00, BgL_docz00_2125); 
FAILURE(BgL_auxz00_4105,BFALSE,BFALSE);} 
return 
BGl_printzd2htmlzd2zzhtmlz00(BgL_auxz00_4101);} } } 

}



/* function-ident-pp */
BGL_EXPORTED_DEF obj_t BGl_functionzd2identzd2ppz00zzbmemz00(obj_t BgL_identz00_8)
{
{ /* bmem/bmem.scm 223 */
{ /* bmem/bmem.scm 224 */
obj_t BgL_name2230z00_1077;obj_t BgL_loc2231z00_1078;obj_t BgL_env2232z00_1079;
BgL_name2230z00_1077 = 
CNST_TABLE_REF(((long)54)); 
BgL_loc2231z00_1078 = 
CNST_TABLE_REF(((long)55)); 
BgL_env2232z00_1079 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 224 */

BGL_ENV_PUSH_TRACE(BgL_env2232z00_1079, BgL_name2230z00_1077, BgL_loc2231z00_1078); 
{ /* bmem/bmem.scm 224 */
obj_t BgL_aux2229z00_1080;
{ /* bmem/bmem.scm 224 */
obj_t BgL_iz00_363;
if(
SYMBOLP(BgL_identz00_8))
{ /* bmem/bmem.scm 224 */
obj_t BgL_res2418z00_1534;
{ /* bmem/bmem.scm 224 */
obj_t BgL_arg1436z00_1533;
BgL_arg1436z00_1533 = 
SYMBOL_TO_STRING(BgL_identz00_8); 
BgL_res2418z00_1534 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1436z00_1533); } 
BgL_iz00_363 = BgL_res2418z00_1534; }  else 
{ /* bmem/bmem.scm 224 */
BgL_iz00_363 = BgL_identz00_8; } 
{ /* bmem/bmem.scm 224 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_pregexpzd2tmp1312zd2_365;
BgL_pregexpzd2tmp1312zd2_365 = BNIL; 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_patz00_367;
BgL_patz00_367 = BGl_pregexp1556z00zzbmemz00; 
{ /* bmem/bmem.scm 225 */
long BgL_endz00_370;
{ /* bmem/bmem.scm 225 */
obj_t BgL_stringz00_1538;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_stringz00_1538 = BgL_iz00_363; }  else 
{ 
obj_t BgL_auxz00_4120;
BgL_auxz00_4120 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4120,BFALSE,BFALSE);} 
BgL_endz00_370 = 
STRING_LENGTH(BgL_stringz00_1538); } 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4125;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4125 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_4128;
BgL_auxz00_4128 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4128,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1312zd2_365 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_367, BgL_auxz00_4125, 
BINT(((long)0)), 
BINT(BgL_endz00_370)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1312zd2_365))
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1832z00_371;obj_t BgL_arg1833z00_372;
{ /* bmem/bmem.scm 225 */
long BgL_arg1849z00_1540;
BgL_arg1849z00_1540 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4138;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2781z00_2290;
BgL_aux2781z00_2290 = BgL_pregexpzd2tmp1312zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3498z00_4139;
if(
PAIRP(BgL_aux2781z00_2290))
{ /* bmem/bmem.scm 225 */
BgL_test3498z00_4139 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3498z00_4139 = 
NULLP(BgL_aux2781z00_2290)
; } 
if(BgL_test3498z00_4139)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4138 = BgL_aux2781z00_2290
; }  else 
{ 
obj_t BgL_auxz00_4143;
BgL_auxz00_4143 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2781z00_2290); 
FAILURE(BgL_auxz00_4143,BFALSE,BFALSE);} } } 
BgL_arg1832z00_371 = 
bgl_list_ref(BgL_auxz00_4138, BgL_arg1849z00_1540); } } 
{ /* bmem/bmem.scm 225 */
long BgL_arg1849z00_1542;
BgL_arg1849z00_1542 = 
(((long)1)+((long)1)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4149;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2783z00_2292;
BgL_aux2783z00_2292 = BgL_pregexpzd2tmp1312zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3500z00_4150;
if(
PAIRP(BgL_aux2783z00_2292))
{ /* bmem/bmem.scm 225 */
BgL_test3500z00_4150 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3500z00_4150 = 
NULLP(BgL_aux2783z00_2292)
; } 
if(BgL_test3500z00_4150)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4149 = BgL_aux2783z00_2292
; }  else 
{ 
obj_t BgL_auxz00_4154;
BgL_auxz00_4154 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2783z00_2292); 
FAILURE(BgL_auxz00_4154,BFALSE,BFALSE);} } } 
BgL_arg1833z00_372 = 
bgl_list_ref(BgL_auxz00_4149, BgL_arg1849z00_1542); } } 
{ /* bmem/bmem.scm 228 */
obj_t BgL_list1834z00_373;
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1835z00_374;
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1836z00_375;
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1837z00_376;
{ /* bmem/bmem.scm 228 */
obj_t BgL_arg1838z00_377;
BgL_arg1838z00_377 = 
MAKE_YOUNG_PAIR(BGl_string3021z00zzbmemz00, BNIL); 
BgL_arg1837z00_376 = 
MAKE_YOUNG_PAIR(BgL_arg1833z00_372, BgL_arg1838z00_377); } 
BgL_arg1836z00_375 = 
MAKE_YOUNG_PAIR(BGl_string3022z00zzbmemz00, BgL_arg1837z00_376); } 
BgL_arg1835z00_374 = 
MAKE_YOUNG_PAIR(BgL_arg1832z00_371, BgL_arg1836z00_375); } 
BgL_list1834z00_373 = 
MAKE_YOUNG_PAIR(BGl_string3023z00zzbmemz00, BgL_arg1835z00_374); } 
BgL_aux2229z00_1080 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list1834z00_373); } }  else 
{ /* bmem/bmem.scm 225 */
{ /* bmem/bmem.scm 225 */
obj_t BgL_patz00_378;
BgL_patz00_378 = BGl_pregexp1557z00zzbmemz00; 
{ /* bmem/bmem.scm 225 */
long BgL_endz00_381;
{ /* bmem/bmem.scm 225 */
obj_t BgL_stringz00_1544;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_stringz00_1544 = BgL_iz00_363; }  else 
{ 
obj_t BgL_auxz00_4167;
BgL_auxz00_4167 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4167,BFALSE,BFALSE);} 
BgL_endz00_381 = 
STRING_LENGTH(BgL_stringz00_1544); } 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4172;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4172 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_4175;
BgL_auxz00_4175 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4175,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1312zd2_365 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_378, BgL_auxz00_4172, 
BINT(((long)0)), 
BINT(BgL_endz00_381)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1312zd2_365))
{ /* bmem/bmem.scm 230 */
obj_t BgL_arg1839z00_382;
{ /* bmem/bmem.scm 225 */
long BgL_arg1849z00_1546;
BgL_arg1849z00_1546 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4185;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2789z00_2298;
BgL_aux2789z00_2298 = BgL_pregexpzd2tmp1312zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3505z00_4186;
if(
PAIRP(BgL_aux2789z00_2298))
{ /* bmem/bmem.scm 225 */
BgL_test3505z00_4186 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3505z00_4186 = 
NULLP(BgL_aux2789z00_2298)
; } 
if(BgL_test3505z00_4186)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4185 = BgL_aux2789z00_2298
; }  else 
{ 
obj_t BgL_auxz00_4190;
BgL_auxz00_4190 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2789z00_2298); 
FAILURE(BgL_auxz00_4190,BFALSE,BFALSE);} } } 
BgL_arg1839z00_382 = 
bgl_list_ref(BgL_auxz00_4185, BgL_arg1849z00_1546); } } 
{ /* bmem/bmem.scm 230 */
obj_t BgL_tmpz00_4195;
if(
STRINGP(BgL_arg1839z00_382))
{ /* bmem/bmem.scm 230 */
BgL_tmpz00_4195 = BgL_arg1839z00_382
; }  else 
{ 
obj_t BgL_auxz00_4198;
BgL_auxz00_4198 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8590)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1839z00_382); 
FAILURE(BgL_auxz00_4198,BFALSE,BFALSE);} 
BgL_aux2229z00_1080 = 
string_append_3(BGl_string3023z00zzbmemz00, BgL_tmpz00_4195, BGl_string3021z00zzbmemz00); } }  else 
{ /* bmem/bmem.scm 225 */
{ /* bmem/bmem.scm 225 */
obj_t BgL_patz00_383;
BgL_patz00_383 = BGl_pregexp1558z00zzbmemz00; 
{ /* bmem/bmem.scm 225 */
long BgL_endz00_386;
{ /* bmem/bmem.scm 225 */
obj_t BgL_stringz00_1548;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_stringz00_1548 = BgL_iz00_363; }  else 
{ 
obj_t BgL_auxz00_4205;
BgL_auxz00_4205 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4205,BFALSE,BFALSE);} 
BgL_endz00_386 = 
STRING_LENGTH(BgL_stringz00_1548); } 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4210;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4210 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_4213;
BgL_auxz00_4213 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4213,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1312zd2_365 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_383, BgL_auxz00_4210, 
BINT(((long)0)), 
BINT(BgL_endz00_386)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1312zd2_365))
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1840z00_387;obj_t BgL_arg1841z00_388;
{ /* bmem/bmem.scm 225 */
long BgL_arg1849z00_1550;
BgL_arg1849z00_1550 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4223;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2797z00_2306;
BgL_aux2797z00_2306 = BgL_pregexpzd2tmp1312zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3511z00_4224;
if(
PAIRP(BgL_aux2797z00_2306))
{ /* bmem/bmem.scm 225 */
BgL_test3511z00_4224 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3511z00_4224 = 
NULLP(BgL_aux2797z00_2306)
; } 
if(BgL_test3511z00_4224)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4223 = BgL_aux2797z00_2306
; }  else 
{ 
obj_t BgL_auxz00_4228;
BgL_auxz00_4228 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2797z00_2306); 
FAILURE(BgL_auxz00_4228,BFALSE,BFALSE);} } } 
BgL_arg1840z00_387 = 
bgl_list_ref(BgL_auxz00_4223, BgL_arg1849z00_1550); } } 
{ /* bmem/bmem.scm 225 */
long BgL_arg1849z00_1552;
BgL_arg1849z00_1552 = 
(((long)1)+((long)1)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4234;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2799z00_2308;
BgL_aux2799z00_2308 = BgL_pregexpzd2tmp1312zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3513z00_4235;
if(
PAIRP(BgL_aux2799z00_2308))
{ /* bmem/bmem.scm 225 */
BgL_test3513z00_4235 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3513z00_4235 = 
NULLP(BgL_aux2799z00_2308)
; } 
if(BgL_test3513z00_4235)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4234 = BgL_aux2799z00_2308
; }  else 
{ 
obj_t BgL_auxz00_4239;
BgL_auxz00_4239 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2799z00_2308); 
FAILURE(BgL_auxz00_4239,BFALSE,BFALSE);} } } 
BgL_arg1841z00_388 = 
bgl_list_ref(BgL_auxz00_4234, BgL_arg1849z00_1552); } } 
{ /* bmem/bmem.scm 232 */
obj_t BgL_list1842z00_389;
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1843z00_390;
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1844z00_391;
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1845z00_392;
{ /* bmem/bmem.scm 232 */
obj_t BgL_arg1846z00_393;
BgL_arg1846z00_393 = 
MAKE_YOUNG_PAIR(BGl_string3021z00zzbmemz00, BNIL); 
BgL_arg1845z00_392 = 
MAKE_YOUNG_PAIR(BgL_arg1841z00_388, BgL_arg1846z00_393); } 
BgL_arg1844z00_391 = 
MAKE_YOUNG_PAIR(BGl_string3022z00zzbmemz00, BgL_arg1845z00_392); } 
BgL_arg1843z00_390 = 
MAKE_YOUNG_PAIR(BgL_arg1840z00_387, BgL_arg1844z00_391); } 
BgL_list1842z00_389 = 
MAKE_YOUNG_PAIR(BGl_string3024z00zzbmemz00, BgL_arg1843z00_390); } 
BgL_aux2229z00_1080 = 
BGl_stringzd2appendzd2zz__r4_strings_6_7z00(BgL_list1842z00_389); } }  else 
{ /* bmem/bmem.scm 225 */
{ /* bmem/bmem.scm 225 */
obj_t BgL_patz00_394;
BgL_patz00_394 = BGl_pregexp1559z00zzbmemz00; 
{ /* bmem/bmem.scm 225 */
long BgL_endz00_397;
{ /* bmem/bmem.scm 225 */
obj_t BgL_stringz00_1554;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_stringz00_1554 = BgL_iz00_363; }  else 
{ 
obj_t BgL_auxz00_4252;
BgL_auxz00_4252 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4252,BFALSE,BFALSE);} 
BgL_endz00_397 = 
STRING_LENGTH(BgL_stringz00_1554); } 
{ /* bmem/bmem.scm 225 */

{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4257;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4257 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_4260;
BgL_auxz00_4260 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4260,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1312zd2_365 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_394, BgL_auxz00_4257, 
BINT(((long)0)), 
BINT(BgL_endz00_397)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1312zd2_365))
{ /* bmem/bmem.scm 234 */
obj_t BgL_arg1847z00_398;
{ /* bmem/bmem.scm 225 */
long BgL_arg1849z00_1556;
BgL_arg1849z00_1556 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 225 */
obj_t BgL_auxz00_4270;
{ /* bmem/bmem.scm 225 */
obj_t BgL_aux2805z00_2314;
BgL_aux2805z00_2314 = BgL_pregexpzd2tmp1312zd2_365; 
{ /* bmem/bmem.scm 225 */
bool_t BgL_test3518z00_4271;
if(
PAIRP(BgL_aux2805z00_2314))
{ /* bmem/bmem.scm 225 */
BgL_test3518z00_4271 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 225 */
BgL_test3518z00_4271 = 
NULLP(BgL_aux2805z00_2314)
; } 
if(BgL_test3518z00_4271)
{ /* bmem/bmem.scm 225 */
BgL_auxz00_4270 = BgL_aux2805z00_2314
; }  else 
{ 
obj_t BgL_auxz00_4275;
BgL_auxz00_4275 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8428)), BGl_string3020z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2805z00_2314); 
FAILURE(BgL_auxz00_4275,BFALSE,BFALSE);} } } 
BgL_arg1847z00_398 = 
bgl_list_ref(BgL_auxz00_4270, BgL_arg1849z00_1556); } } 
{ /* bmem/bmem.scm 234 */
obj_t BgL_tmpz00_4280;
if(
STRINGP(BgL_arg1847z00_398))
{ /* bmem/bmem.scm 234 */
BgL_tmpz00_4280 = BgL_arg1847z00_398
; }  else 
{ 
obj_t BgL_auxz00_4283;
BgL_auxz00_4283 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8749)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg1847z00_398); 
FAILURE(BgL_auxz00_4283,BFALSE,BFALSE);} 
BgL_aux2229z00_1080 = 
string_append_3(BGl_string3024z00zzbmemz00, BgL_tmpz00_4280, BGl_string3021z00zzbmemz00); } }  else 
{ /* bmem/bmem.scm 236 */
obj_t BgL_auxz00_4288;
if(
STRINGP(BgL_iz00_363))
{ /* bmem/bmem.scm 236 */
BgL_auxz00_4288 = BgL_iz00_363
; }  else 
{ 
obj_t BgL_auxz00_4291;
BgL_auxz00_4291 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)8815)), BGl_string3020z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_363); 
FAILURE(BgL_auxz00_4291,BFALSE,BFALSE);} 
BgL_aux2229z00_1080 = 
BGl_htmlzd2stringzd2zzhtmlz00(BgL_auxz00_4288); } } } } } } } } 
BGL_ENV_POP_TRACE(BgL_env2232z00_1079); 
return BgL_aux2229z00_1080;} } } } 

}



/* &function-ident-pp */
obj_t BGl_z62functionzd2identzd2ppz62zzbmemz00(obj_t BgL_envz00_2129, obj_t BgL_identz00_2130)
{
{ /* bmem/bmem.scm 223 */
return 
BGl_functionzd2identzd2ppz00zzbmemz00(BgL_identz00_2130);} 

}



/* function-ref */
BGL_EXPORTED_DEF obj_t BGl_functionzd2refzd2zzbmemz00(obj_t BgL_identz00_9)
{
{ /* bmem/bmem.scm 241 */
{ /* bmem/bmem.scm 242 */
obj_t BgL_name2234z00_1081;obj_t BgL_loc2235z00_1082;obj_t BgL_env2236z00_1083;
BgL_name2234z00_1081 = 
CNST_TABLE_REF(((long)56)); 
BgL_loc2235z00_1082 = 
CNST_TABLE_REF(((long)57)); 
BgL_env2236z00_1083 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 242 */

BGL_ENV_PUSH_TRACE(BgL_env2236z00_1083, BgL_name2234z00_1081, BgL_loc2235z00_1082); 
{ /* bmem/bmem.scm 242 */
BgL_z52htmlzd2elementz80_bglt BgL_aux2233z00_1084;
{ /* bmem/bmem.scm 242 */
obj_t BgL_iz00_404;
if(
SYMBOLP(BgL_identz00_9))
{ /* bmem/bmem.scm 242 */
obj_t BgL_res2432z00_1562;
{ /* bmem/bmem.scm 242 */
obj_t BgL_arg1436z00_1561;
BgL_arg1436z00_1561 = 
SYMBOL_TO_STRING(BgL_identz00_9); 
BgL_res2432z00_1562 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1436z00_1561); } 
BgL_iz00_404 = BgL_res2432z00_1562; }  else 
{ /* bmem/bmem.scm 242 */
BgL_iz00_404 = BgL_identz00_9; } 
{ /* bmem/bmem.scm 242 */
obj_t BgL_idz00_405;
{ /* bmem/bmem.scm 243 */
obj_t BgL_pregexpzd2tmp1314zd2_424;
BgL_pregexpzd2tmp1314zd2_424 = BNIL; 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_patz00_426;
BgL_patz00_426 = BGl_pregexp1560z00zzbmemz00; 
{ /* bmem/bmem.scm 243 */
long BgL_endz00_429;
{ /* bmem/bmem.scm 243 */
obj_t BgL_stringz00_1566;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_stringz00_1566 = BgL_iz00_404; }  else 
{ 
obj_t BgL_auxz00_4308;
BgL_auxz00_4308 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4308,BFALSE,BFALSE);} 
BgL_endz00_429 = 
STRING_LENGTH(BgL_stringz00_1566); } 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4313;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4313 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_4316;
BgL_auxz00_4316 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4316,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1314zd2_424 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_426, BgL_auxz00_4313, 
BINT(((long)0)), 
BINT(BgL_endz00_429)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1314zd2_424))
{ /* bmem/bmem.scm 247 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1858z00_430;
{ /* bmem/bmem.scm 247 */
BgL_z52htmlzd2boxz80_bglt BgL_new1318z00_433;
{ /* bmem/bmem.scm 247 */
obj_t BgL_env1316z00_439;
BgL_env1316z00_439 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 247 */

{ 
long BgL_auxz00_4326;
{ /* bmem/bmem.scm 247 */
long BgL_res2436z00_1570;
{ /* bmem/bmem.scm 247 */
obj_t BgL_classz00_1569;
BgL_classz00_1569 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2436z00_1570 = 
BGL_CLASS_INDEX(BgL_classz00_1569); } 
BgL_auxz00_4326 = BgL_res2436z00_1570; } 
bmem_set_allocation_type( BgL_auxz00_4326, 0 ); } 
{ /* bmem/bmem.scm 247 */
BgL_z52htmlzd2boxz80_bglt BgL_new1315z00_441;
BgL_new1315z00_441 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 247 */
long BgL_arg1866z00_442;
{ /* bmem/bmem.scm 247 */
long BgL_res2437z00_1572;
BgL_res2437z00_1572 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BgL_arg1866z00_442 = BgL_res2437z00_1572; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1315z00_441), BgL_arg1866z00_442); } 
BgL_new1318z00_433 = BgL_new1315z00_441; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1318z00_433)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1318z00_433)))->BgL_classz00)=((obj_t)BGl_string3026z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1318z00_433)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1318z00_433)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1318z00_433))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)58))),BUNSPEC); 
{ 
obj_t BgL_auxz00_4343;
{ /* bmem/bmem.scm 248 */
obj_t BgL_arg1861z00_434;obj_t BgL_arg1862z00_435;
{ /* bmem/bmem.scm 243 */
long BgL_arg1885z00_1575;
BgL_arg1885z00_1575 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4345;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2815z00_2324;
BgL_aux2815z00_2324 = BgL_pregexpzd2tmp1314zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3526z00_4346;
if(
PAIRP(BgL_aux2815z00_2324))
{ /* bmem/bmem.scm 243 */
BgL_test3526z00_4346 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3526z00_4346 = 
NULLP(BgL_aux2815z00_2324)
; } 
if(BgL_test3526z00_4346)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4345 = BgL_aux2815z00_2324
; }  else 
{ 
obj_t BgL_auxz00_4350;
BgL_auxz00_4350 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2815z00_2324); 
FAILURE(BgL_auxz00_4350,BFALSE,BFALSE);} } } 
BgL_arg1861z00_434 = 
bgl_list_ref(BgL_auxz00_4345, BgL_arg1885z00_1575); } } 
{ /* bmem/bmem.scm 243 */
long BgL_arg1885z00_1577;
BgL_arg1885z00_1577 = 
(((long)1)+((long)1)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4356;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2817z00_2326;
BgL_aux2817z00_2326 = BgL_pregexpzd2tmp1314zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3528z00_4357;
if(
PAIRP(BgL_aux2817z00_2326))
{ /* bmem/bmem.scm 243 */
BgL_test3528z00_4357 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3528z00_4357 = 
NULLP(BgL_aux2817z00_2326)
; } 
if(BgL_test3528z00_4357)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4356 = BgL_aux2817z00_2326
; }  else 
{ 
obj_t BgL_auxz00_4361;
BgL_auxz00_4361 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2817z00_2326); 
FAILURE(BgL_auxz00_4361,BFALSE,BFALSE);} } } 
BgL_arg1862z00_435 = 
bgl_list_ref(BgL_auxz00_4356, BgL_arg1885z00_1577); } } 
{ /* bmem/bmem.scm 248 */
obj_t BgL_list1863z00_436;
{ /* bmem/bmem.scm 248 */
obj_t BgL_arg1864z00_437;
{ /* bmem/bmem.scm 248 */
obj_t BgL_arg1865z00_438;
BgL_arg1865z00_438 = 
MAKE_YOUNG_PAIR(BgL_arg1862z00_435, BNIL); 
BgL_arg1864z00_437 = 
MAKE_YOUNG_PAIR(BGl_string3022z00zzbmemz00, BgL_arg1865z00_438); } 
BgL_list1863z00_436 = 
MAKE_YOUNG_PAIR(BgL_arg1861z00_434, BgL_arg1864z00_437); } 
BgL_auxz00_4343 = BgL_list1863z00_436; } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1318z00_433))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4343),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1318z00_433))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1858z00_430 = BgL_new1318z00_433; } 
{ /* bmem/bmem.scm 246 */
obj_t BgL_list1859z00_431;
{ /* bmem/bmem.scm 246 */
obj_t BgL_arg1860z00_432;
BgL_arg1860z00_432 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1858z00_430), BNIL); 
BgL_list1859z00_431 = 
MAKE_YOUNG_PAIR(BGl_string3027z00zzbmemz00, BgL_arg1860z00_432); } 
BgL_idz00_405 = BgL_list1859z00_431; } }  else 
{ /* bmem/bmem.scm 243 */
{ /* bmem/bmem.scm 243 */
obj_t BgL_patz00_443;
BgL_patz00_443 = BGl_pregexp1561z00zzbmemz00; 
{ /* bmem/bmem.scm 243 */
long BgL_endz00_446;
{ /* bmem/bmem.scm 243 */
obj_t BgL_stringz00_1581;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_stringz00_1581 = BgL_iz00_404; }  else 
{ 
obj_t BgL_auxz00_4376;
BgL_auxz00_4376 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4376,BFALSE,BFALSE);} 
BgL_endz00_446 = 
STRING_LENGTH(BgL_stringz00_1581); } 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4381;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4381 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_4384;
BgL_auxz00_4384 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4384,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1314zd2_424 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_443, BgL_auxz00_4381, 
BINT(((long)0)), 
BINT(BgL_endz00_446)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1314zd2_424))
{ /* bmem/bmem.scm 251 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1867z00_447;
{ /* bmem/bmem.scm 251 */
BgL_z52htmlzd2boxz80_bglt BgL_new1322z00_450;
{ /* bmem/bmem.scm 251 */
obj_t BgL_env1320z00_451;
BgL_env1320z00_451 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 251 */

{ 
long BgL_auxz00_4394;
{ /* bmem/bmem.scm 251 */
long BgL_res2444z00_1585;
{ /* bmem/bmem.scm 251 */
obj_t BgL_classz00_1584;
BgL_classz00_1584 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2444z00_1585 = 
BGL_CLASS_INDEX(BgL_classz00_1584); } 
BgL_auxz00_4394 = BgL_res2444z00_1585; } 
bmem_set_allocation_type( BgL_auxz00_4394, 0 ); } 
{ /* bmem/bmem.scm 251 */
BgL_z52htmlzd2boxz80_bglt BgL_new1319z00_453;
BgL_new1319z00_453 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 251 */
long BgL_arg1870z00_454;
{ /* bmem/bmem.scm 251 */
long BgL_res2445z00_1587;
BgL_res2445z00_1587 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BgL_arg1870z00_454 = BgL_res2445z00_1587; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1319z00_453), BgL_arg1870z00_454); } 
BgL_new1322z00_450 = BgL_new1319z00_453; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1322z00_450)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1322z00_450)))->BgL_classz00)=((obj_t)BGl_string3026z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1322z00_450)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1322z00_450)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1322z00_450))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)58))),BUNSPEC); 
{ 
obj_t BgL_auxz00_4411;
{ /* bmem/bmem.scm 243 */
long BgL_arg1885z00_1590;
BgL_arg1885z00_1590 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4413;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2823z00_2332;
BgL_aux2823z00_2332 = BgL_pregexpzd2tmp1314zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3533z00_4414;
if(
PAIRP(BgL_aux2823z00_2332))
{ /* bmem/bmem.scm 243 */
BgL_test3533z00_4414 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3533z00_4414 = 
NULLP(BgL_aux2823z00_2332)
; } 
if(BgL_test3533z00_4414)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4413 = BgL_aux2823z00_2332
; }  else 
{ 
obj_t BgL_auxz00_4418;
BgL_auxz00_4418 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2823z00_2332); 
FAILURE(BgL_auxz00_4418,BFALSE,BFALSE);} } } 
BgL_auxz00_4411 = 
bgl_list_ref(BgL_auxz00_4413, BgL_arg1885z00_1590); } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1322z00_450))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4411),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1322z00_450))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1867z00_447 = BgL_new1322z00_450; } 
{ /* bmem/bmem.scm 250 */
obj_t BgL_list1868z00_448;
{ /* bmem/bmem.scm 250 */
obj_t BgL_arg1869z00_449;
BgL_arg1869z00_449 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1867z00_447), BNIL); 
BgL_list1868z00_448 = 
MAKE_YOUNG_PAIR(BGl_string3027z00zzbmemz00, BgL_arg1869z00_449); } 
BgL_idz00_405 = BgL_list1868z00_448; } }  else 
{ /* bmem/bmem.scm 243 */
{ /* bmem/bmem.scm 243 */
obj_t BgL_patz00_455;
BgL_patz00_455 = BGl_pregexp1562z00zzbmemz00; 
{ /* bmem/bmem.scm 243 */
long BgL_endz00_458;
{ /* bmem/bmem.scm 243 */
obj_t BgL_stringz00_1593;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_stringz00_1593 = BgL_iz00_404; }  else 
{ 
obj_t BgL_auxz00_4430;
BgL_auxz00_4430 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4430,BFALSE,BFALSE);} 
BgL_endz00_458 = 
STRING_LENGTH(BgL_stringz00_1593); } 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4435;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4435 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_4438;
BgL_auxz00_4438 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4438,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1314zd2_424 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_455, BgL_auxz00_4435, 
BINT(((long)0)), 
BINT(BgL_endz00_458)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1314zd2_424))
{ /* bmem/bmem.scm 254 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1871z00_459;
{ /* bmem/bmem.scm 254 */
BgL_z52htmlzd2boxz80_bglt BgL_new1326z00_462;
{ /* bmem/bmem.scm 254 */
obj_t BgL_env1324z00_468;
BgL_env1324z00_468 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 254 */

{ 
long BgL_auxz00_4448;
{ /* bmem/bmem.scm 254 */
long BgL_res2450z00_1597;
{ /* bmem/bmem.scm 254 */
obj_t BgL_classz00_1596;
BgL_classz00_1596 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2450z00_1597 = 
BGL_CLASS_INDEX(BgL_classz00_1596); } 
BgL_auxz00_4448 = BgL_res2450z00_1597; } 
bmem_set_allocation_type( BgL_auxz00_4448, 0 ); } 
{ /* bmem/bmem.scm 254 */
BgL_z52htmlzd2boxz80_bglt BgL_new1323z00_470;
BgL_new1323z00_470 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 254 */
long BgL_arg1879z00_471;
{ /* bmem/bmem.scm 254 */
long BgL_res2451z00_1599;
BgL_res2451z00_1599 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BgL_arg1879z00_471 = BgL_res2451z00_1599; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1323z00_470), BgL_arg1879z00_471); } 
BgL_new1326z00_462 = BgL_new1323z00_470; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1326z00_462)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1326z00_462)))->BgL_classz00)=((obj_t)BGl_string3026z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1326z00_462)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1326z00_462)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1326z00_462))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)58))),BUNSPEC); 
{ 
obj_t BgL_auxz00_4465;
{ /* bmem/bmem.scm 255 */
obj_t BgL_arg1874z00_463;obj_t BgL_arg1875z00_464;
{ /* bmem/bmem.scm 243 */
long BgL_arg1885z00_1602;
BgL_arg1885z00_1602 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4467;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2829z00_2338;
BgL_aux2829z00_2338 = BgL_pregexpzd2tmp1314zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3538z00_4468;
if(
PAIRP(BgL_aux2829z00_2338))
{ /* bmem/bmem.scm 243 */
BgL_test3538z00_4468 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3538z00_4468 = 
NULLP(BgL_aux2829z00_2338)
; } 
if(BgL_test3538z00_4468)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4467 = BgL_aux2829z00_2338
; }  else 
{ 
obj_t BgL_auxz00_4472;
BgL_auxz00_4472 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2829z00_2338); 
FAILURE(BgL_auxz00_4472,BFALSE,BFALSE);} } } 
BgL_arg1874z00_463 = 
bgl_list_ref(BgL_auxz00_4467, BgL_arg1885z00_1602); } } 
{ /* bmem/bmem.scm 243 */
long BgL_arg1885z00_1604;
BgL_arg1885z00_1604 = 
(((long)1)+((long)1)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4478;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2831z00_2340;
BgL_aux2831z00_2340 = BgL_pregexpzd2tmp1314zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3540z00_4479;
if(
PAIRP(BgL_aux2831z00_2340))
{ /* bmem/bmem.scm 243 */
BgL_test3540z00_4479 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3540z00_4479 = 
NULLP(BgL_aux2831z00_2340)
; } 
if(BgL_test3540z00_4479)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4478 = BgL_aux2831z00_2340
; }  else 
{ 
obj_t BgL_auxz00_4483;
BgL_auxz00_4483 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2831z00_2340); 
FAILURE(BgL_auxz00_4483,BFALSE,BFALSE);} } } 
BgL_arg1875z00_464 = 
bgl_list_ref(BgL_auxz00_4478, BgL_arg1885z00_1604); } } 
{ /* bmem/bmem.scm 255 */
obj_t BgL_list1876z00_465;
{ /* bmem/bmem.scm 255 */
obj_t BgL_arg1877z00_466;
{ /* bmem/bmem.scm 255 */
obj_t BgL_arg1878z00_467;
BgL_arg1878z00_467 = 
MAKE_YOUNG_PAIR(BgL_arg1875z00_464, BNIL); 
BgL_arg1877z00_466 = 
MAKE_YOUNG_PAIR(BGl_string3022z00zzbmemz00, BgL_arg1878z00_467); } 
BgL_list1876z00_465 = 
MAKE_YOUNG_PAIR(BgL_arg1874z00_463, BgL_arg1877z00_466); } 
BgL_auxz00_4465 = BgL_list1876z00_465; } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1326z00_462))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4465),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1326z00_462))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1871z00_459 = BgL_new1326z00_462; } 
{ /* bmem/bmem.scm 253 */
obj_t BgL_list1872z00_460;
{ /* bmem/bmem.scm 253 */
obj_t BgL_arg1873z00_461;
BgL_arg1873z00_461 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1871z00_459), BNIL); 
BgL_list1872z00_460 = 
MAKE_YOUNG_PAIR(BGl_string3028z00zzbmemz00, BgL_arg1873z00_461); } 
BgL_idz00_405 = BgL_list1872z00_460; } }  else 
{ /* bmem/bmem.scm 243 */
{ /* bmem/bmem.scm 243 */
obj_t BgL_patz00_472;
BgL_patz00_472 = BGl_pregexp1563z00zzbmemz00; 
{ /* bmem/bmem.scm 243 */
long BgL_endz00_475;
{ /* bmem/bmem.scm 243 */
obj_t BgL_stringz00_1608;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_stringz00_1608 = BgL_iz00_404; }  else 
{ 
obj_t BgL_auxz00_4498;
BgL_auxz00_4498 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4498,BFALSE,BFALSE);} 
BgL_endz00_475 = 
STRING_LENGTH(BgL_stringz00_1608); } 
{ /* bmem/bmem.scm 243 */

{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4503;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4503 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_4506;
BgL_auxz00_4506 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4506,BFALSE,BFALSE);} 
BgL_pregexpzd2tmp1314zd2_424 = 
BGl_pregexpzd2matchzd2zz__regexpz00(BgL_patz00_472, BgL_auxz00_4503, 
BINT(((long)0)), 
BINT(BgL_endz00_475)); } } } } 
if(
CBOOL(BgL_pregexpzd2tmp1314zd2_424))
{ /* bmem/bmem.scm 258 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1880z00_476;
{ /* bmem/bmem.scm 258 */
BgL_z52htmlzd2boxz80_bglt BgL_new1330z00_479;
{ /* bmem/bmem.scm 258 */
obj_t BgL_env1328z00_480;
BgL_env1328z00_480 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 258 */

{ 
long BgL_auxz00_4516;
{ /* bmem/bmem.scm 258 */
long BgL_res2458z00_1612;
{ /* bmem/bmem.scm 258 */
obj_t BgL_classz00_1611;
BgL_classz00_1611 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2458z00_1612 = 
BGL_CLASS_INDEX(BgL_classz00_1611); } 
BgL_auxz00_4516 = BgL_res2458z00_1612; } 
bmem_set_allocation_type( BgL_auxz00_4516, 0 ); } 
{ /* bmem/bmem.scm 258 */
BgL_z52htmlzd2boxz80_bglt BgL_new1327z00_482;
BgL_new1327z00_482 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 258 */
long BgL_arg1883z00_483;
{ /* bmem/bmem.scm 258 */
long BgL_res2459z00_1614;
BgL_res2459z00_1614 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BgL_arg1883z00_483 = BgL_res2459z00_1614; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1327z00_482), BgL_arg1883z00_483); } 
BgL_new1330z00_479 = BgL_new1327z00_482; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1330z00_479)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1330z00_479)))->BgL_classz00)=((obj_t)BGl_string3026z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1330z00_479)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1330z00_479)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1330z00_479))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)58))),BUNSPEC); 
{ 
obj_t BgL_auxz00_4533;
{ /* bmem/bmem.scm 243 */
long BgL_arg1885z00_1617;
BgL_arg1885z00_1617 = 
(((long)1)+((long)0)); 
{ /* bmem/bmem.scm 243 */
obj_t BgL_auxz00_4535;
{ /* bmem/bmem.scm 243 */
obj_t BgL_aux2837z00_2346;
BgL_aux2837z00_2346 = BgL_pregexpzd2tmp1314zd2_424; 
{ /* bmem/bmem.scm 243 */
bool_t BgL_test3545z00_4536;
if(
PAIRP(BgL_aux2837z00_2346))
{ /* bmem/bmem.scm 243 */
BgL_test3545z00_4536 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 243 */
BgL_test3545z00_4536 = 
NULLP(BgL_aux2837z00_2346)
; } 
if(BgL_test3545z00_4536)
{ /* bmem/bmem.scm 243 */
BgL_auxz00_4535 = BgL_aux2837z00_2346
; }  else 
{ 
obj_t BgL_auxz00_4540;
BgL_auxz00_4540 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9145)), BGl_string3025z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2837z00_2346); 
FAILURE(BgL_auxz00_4540,BFALSE,BFALSE);} } } 
BgL_auxz00_4533 = 
bgl_list_ref(BgL_auxz00_4535, BgL_arg1885z00_1617); } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1330z00_479))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4533),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1330z00_479))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1880z00_476 = BgL_new1330z00_479; } 
{ /* bmem/bmem.scm 257 */
obj_t BgL_list1881z00_477;
{ /* bmem/bmem.scm 257 */
obj_t BgL_arg1882z00_478;
BgL_arg1882z00_478 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1880z00_476), BNIL); 
BgL_list1881z00_477 = 
MAKE_YOUNG_PAIR(BGl_string3028z00zzbmemz00, BgL_arg1882z00_478); } 
BgL_idz00_405 = BgL_list1881z00_477; } }  else 
{ /* bmem/bmem.scm 260 */
obj_t BgL_auxz00_4550;
if(
STRINGP(BgL_iz00_404))
{ /* bmem/bmem.scm 260 */
BgL_auxz00_4550 = BgL_iz00_404
; }  else 
{ 
obj_t BgL_auxz00_4553;
BgL_auxz00_4553 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)9702)), BGl_string3025z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_iz00_404); 
FAILURE(BgL_auxz00_4553,BFALSE,BFALSE);} 
BgL_idz00_405 = 
BGl_htmlzd2stringzd2zzhtmlz00(BgL_auxz00_4550); } } } } } } 
{ /* bmem/bmem.scm 243 */
BgL_z52htmlzd2boxz80_bglt BgL_hidz00_406;
{ /* bmem/bmem.scm 261 */
BgL_z52htmlzd2boxz80_bglt BgL_new1334z00_418;
{ /* bmem/bmem.scm 261 */
obj_t BgL_env1332z00_419;
BgL_env1332z00_419 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 261 */

{ 
long BgL_auxz00_4559;
{ /* bmem/bmem.scm 261 */
long BgL_res2463z00_1622;
{ /* bmem/bmem.scm 261 */
obj_t BgL_classz00_1621;
BgL_classz00_1621 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2463z00_1622 = 
BGL_CLASS_INDEX(BgL_classz00_1621); } 
BgL_auxz00_4559 = BgL_res2463z00_1622; } 
bmem_set_allocation_type( BgL_auxz00_4559, 0 ); } 
{ /* bmem/bmem.scm 261 */
BgL_z52htmlzd2boxz80_bglt BgL_new1331z00_421;
BgL_new1331z00_421 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 261 */
long BgL_arg1857z00_422;
{ /* bmem/bmem.scm 261 */
long BgL_res2464z00_1624;
BgL_res2464z00_1624 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BgL_arg1857z00_422 = BgL_res2464z00_1624; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1331z00_421), BgL_arg1857z00_422); } 
BgL_new1334z00_418 = BgL_new1331z00_421; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1334z00_418)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1334z00_418)))->BgL_classz00)=((obj_t)BGl_string3029z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1334z00_418)))->BgL_titlez00)=((obj_t)BgL_iz00_404),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1334z00_418)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1334z00_418))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1334z00_418))->BgL_inlineza2za2)=((obj_t)BgL_idz00_405),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1334z00_418))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_hidz00_406 = BgL_new1334z00_418; } 
{ /* bmem/bmem.scm 261 */

if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 264 */
obj_t BgL_urlz00_408;
{ /* bmem/bmem.scm 264 */
obj_t BgL_list1853z00_414;
{ /* bmem/bmem.scm 264 */
obj_t BgL_arg1854z00_415;
{ /* bmem/bmem.scm 264 */
obj_t BgL_arg1855z00_416;
{ /* bmem/bmem.scm 264 */
obj_t BgL_arg1856z00_417;
BgL_arg1856z00_417 = 
MAKE_YOUNG_PAIR(BgL_identz00_9, BNIL); 
BgL_arg1855z00_416 = 
MAKE_YOUNG_PAIR(BGl_za2fileza2z00zzbmem_paramz00, BgL_arg1856z00_417); } 
BgL_arg1854z00_415 = 
MAKE_YOUNG_PAIR(BGl_za2portza2z00zzbmem_paramz00, BgL_arg1855z00_416); } 
BgL_list1853z00_414 = 
MAKE_YOUNG_PAIR(BGl_za2hostnameza2z00zzbmem_paramz00, BgL_arg1854z00_415); } 
BgL_urlz00_408 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3030z00zzbmemz00, BgL_list1853z00_414); } 
{ /* bmem/bmem.scm 269 */
BgL_z52htmlzd2az80_bglt BgL_new1338z00_409;
{ /* bmem/bmem.scm 269 */
obj_t BgL_env1336z00_410;
BgL_env1336z00_410 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 269 */

{ 
long BgL_auxz00_4586;
{ /* bmem/bmem.scm 269 */
long BgL_res2466z00_1629;
{ /* bmem/bmem.scm 269 */
obj_t BgL_classz00_1628;
BgL_classz00_1628 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2466z00_1629 = 
BGL_CLASS_INDEX(BgL_classz00_1628); } 
BgL_auxz00_4586 = BgL_res2466z00_1629; } 
bmem_set_allocation_type( BgL_auxz00_4586, 0 ); } 
{ /* bmem/bmem.scm 269 */
BgL_z52htmlzd2az80_bglt BgL_new1335z00_412;
BgL_new1335z00_412 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 269 */
long BgL_arg1852z00_413;
{ /* bmem/bmem.scm 269 */
long BgL_res2467z00_1631;
BgL_res2467z00_1631 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BgL_arg1852z00_413 = BgL_res2467z00_1631; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1335z00_412), BgL_arg1852z00_413); } 
BgL_new1338z00_409 = BgL_new1335z00_412; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1338z00_409)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1338z00_409)))->BgL_classz00)=((obj_t)BGl_string3025z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1338z00_409)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1338z00_409)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1338z00_409))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1338z00_409))->BgL_hrefz00)=((obj_t)BgL_urlz00_408),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1338z00_409))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1338z00_409))->BgL_inlineza2za2)=((obj_t)
((obj_t)BgL_hidz00_406)),BUNSPEC); 
BgL_aux2233z00_1084 = 
((BgL_z52htmlzd2elementz80_bglt)BgL_new1338z00_409); } }  else 
{ /* bmem/bmem.scm 262 */
BgL_aux2233z00_1084 = 
((BgL_z52htmlzd2elementz80_bglt)BgL_hidz00_406); } } } } } 
BGL_ENV_POP_TRACE(BgL_env2236z00_1083); 
return 
((obj_t)BgL_aux2233z00_1084);} } } } 

}



/* &function-ref */
obj_t BGl_z62functionzd2refzb0zzbmemz00(obj_t BgL_envz00_2131, obj_t BgL_identz00_2132)
{
{ /* bmem/bmem.scm 241 */
return 
BGl_functionzd2refzd2zzbmemz00(BgL_identz00_2132);} 

}



/* type-ref */
BGL_EXPORTED_DEF obj_t BGl_typezd2refzd2zzbmemz00(obj_t BgL_identz00_10)
{
{ /* bmem/bmem.scm 274 */
{ /* bmem/bmem.scm 275 */
obj_t BgL_name2238z00_1085;obj_t BgL_loc2239z00_1086;obj_t BgL_env2240z00_1087;
BgL_name2238z00_1085 = 
CNST_TABLE_REF(((long)59)); 
BgL_loc2239z00_1086 = 
CNST_TABLE_REF(((long)60)); 
BgL_env2240z00_1087 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 275 */

BGL_ENV_PUSH_TRACE(BgL_env2240z00_1087, BgL_name2238z00_1085, BgL_loc2239z00_1086); 
{ /* bmem/bmem.scm 275 */
BgL_z52htmlzd2elementz80_bglt BgL_aux2237z00_1088;
{ /* bmem/bmem.scm 275 */
obj_t BgL_identz00_489;
{ /* bmem/bmem.scm 275 */
obj_t BgL_auxz00_4615;
if(
STRINGP(BgL_identz00_10))
{ /* bmem/bmem.scm 275 */
BgL_auxz00_4615 = BgL_identz00_10
; }  else 
{ 
obj_t BgL_auxz00_4618;
BgL_auxz00_4618 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)10230)), BGl_string3031z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_identz00_10); 
FAILURE(BgL_auxz00_4618,BFALSE,BFALSE);} 
BgL_identz00_489 = 
BGl_htmlzd2stringzd2zzhtmlz00(BgL_auxz00_4615); } 
{ /* bmem/bmem.scm 275 */
BgL_z52htmlzd2boxz80_bglt BgL_hidz00_490;
{ /* bmem/bmem.scm 276 */
BgL_z52htmlzd2boxz80_bglt BgL_new1342z00_502;
{ /* bmem/bmem.scm 276 */
obj_t BgL_env1340z00_503;
BgL_env1340z00_503 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 276 */

{ 
long BgL_auxz00_4624;
{ /* bmem/bmem.scm 276 */
long BgL_res2470z00_1637;
{ /* bmem/bmem.scm 276 */
obj_t BgL_classz00_1636;
BgL_classz00_1636 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2470z00_1637 = 
BGL_CLASS_INDEX(BgL_classz00_1636); } 
BgL_auxz00_4624 = BgL_res2470z00_1637; } 
bmem_set_allocation_type( BgL_auxz00_4624, 0 ); } 
{ /* bmem/bmem.scm 276 */
BgL_z52htmlzd2boxz80_bglt BgL_new1339z00_505;
BgL_new1339z00_505 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 276 */
long BgL_arg1893z00_506;
{ /* bmem/bmem.scm 276 */
long BgL_res2471z00_1639;
BgL_res2471z00_1639 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BgL_arg1893z00_506 = BgL_res2471z00_1639; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1339z00_505), BgL_arg1893z00_506); } 
BgL_new1342z00_502 = BgL_new1339z00_505; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1342z00_502)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1342z00_502)))->BgL_classz00)=((obj_t)BGl_string3032z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1342z00_502)))->BgL_titlez00)=((obj_t)BgL_identz00_489),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1342z00_502)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1342z00_502))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1342z00_502))->BgL_inlineza2za2)=((obj_t)BgL_identz00_489),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1342z00_502))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_hidz00_490 = BgL_new1342z00_502; } 
{ /* bmem/bmem.scm 276 */

if(
BGl_httpzd2requestzf3z21zzbmemz00())
{ /* bmem/bmem.scm 279 */
obj_t BgL_urlz00_492;
{ /* bmem/bmem.scm 279 */
obj_t BgL_list1889z00_498;
{ /* bmem/bmem.scm 279 */
obj_t BgL_arg1890z00_499;
{ /* bmem/bmem.scm 279 */
obj_t BgL_arg1891z00_500;
{ /* bmem/bmem.scm 279 */
obj_t BgL_arg1892z00_501;
BgL_arg1892z00_501 = 
MAKE_YOUNG_PAIR(BgL_identz00_489, BNIL); 
BgL_arg1891z00_500 = 
MAKE_YOUNG_PAIR(BGl_za2fileza2z00zzbmem_paramz00, BgL_arg1892z00_501); } 
BgL_arg1890z00_499 = 
MAKE_YOUNG_PAIR(BGl_za2portza2z00zzbmem_paramz00, BgL_arg1891z00_500); } 
BgL_list1889z00_498 = 
MAKE_YOUNG_PAIR(BGl_za2hostnameza2z00zzbmem_paramz00, BgL_arg1890z00_499); } 
BgL_urlz00_492 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3033z00zzbmemz00, BgL_list1889z00_498); } 
{ /* bmem/bmem.scm 284 */
BgL_z52htmlzd2az80_bglt BgL_new1346z00_493;
{ /* bmem/bmem.scm 284 */
obj_t BgL_env1344z00_494;
BgL_env1344z00_494 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 284 */

{ 
long BgL_auxz00_4651;
{ /* bmem/bmem.scm 284 */
long BgL_res2473z00_1644;
{ /* bmem/bmem.scm 284 */
obj_t BgL_classz00_1643;
BgL_classz00_1643 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2473z00_1644 = 
BGL_CLASS_INDEX(BgL_classz00_1643); } 
BgL_auxz00_4651 = BgL_res2473z00_1644; } 
bmem_set_allocation_type( BgL_auxz00_4651, 0 ); } 
{ /* bmem/bmem.scm 284 */
BgL_z52htmlzd2az80_bglt BgL_new1343z00_496;
BgL_new1343z00_496 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 284 */
long BgL_arg1888z00_497;
{ /* bmem/bmem.scm 284 */
long BgL_res2474z00_1646;
BgL_res2474z00_1646 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BgL_arg1888z00_497 = BgL_res2474z00_1646; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1343z00_496), BgL_arg1888z00_497); } 
BgL_new1346z00_493 = BgL_new1343z00_496; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1346z00_493)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1346z00_493)))->BgL_classz00)=((obj_t)BGl_string3031z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1346z00_493)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1346z00_493)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1346z00_493))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1346z00_493))->BgL_hrefz00)=((obj_t)BgL_urlz00_492),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1346z00_493))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1346z00_493))->BgL_inlineza2za2)=((obj_t)
((obj_t)BgL_hidz00_490)),BUNSPEC); 
BgL_aux2237z00_1088 = 
((BgL_z52htmlzd2elementz80_bglt)BgL_new1346z00_493); } }  else 
{ /* bmem/bmem.scm 277 */
BgL_aux2237z00_1088 = 
((BgL_z52htmlzd2elementz80_bglt)BgL_hidz00_490); } } } } 
BGL_ENV_POP_TRACE(BgL_env2240z00_1087); 
return 
((obj_t)BgL_aux2237z00_1088);} } } } 

}



/* &type-ref */
obj_t BGl_z62typezd2refzb0zzbmemz00(obj_t BgL_envz00_2133, obj_t BgL_identz00_2134)
{
{ /* bmem/bmem.scm 274 */
return 
BGl_typezd2refzd2zzbmemz00(BgL_identz00_2134);} 

}



/* bmem-all */
BgL_z52htmlzd2documentz80_bglt BGl_bmemzd2allzd2zzbmemz00(obj_t BgL_cssz00_11, obj_t BgL_infoz00_12, obj_t BgL_gcmonz00_13, obj_t BgL_funmonz00_14, obj_t BgL_typesz00_15, obj_t BgL_threadz00_16)
{
{ /* bmem/bmem.scm 290 */
{ /* bmem/bmem.scm 291 */
obj_t BgL_name2242z00_1089;obj_t BgL_loc2243z00_1090;obj_t BgL_env2244z00_1091;
BgL_name2242z00_1089 = 
CNST_TABLE_REF(((long)61)); 
BgL_loc2243z00_1090 = 
CNST_TABLE_REF(((long)62)); 
BgL_env2244z00_1091 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 291 */

BGL_ENV_PUSH_TRACE(BgL_env2244z00_1091, BgL_name2242z00_1089, BgL_loc2243z00_1090); 
{ /* bmem/bmem.scm 291 */
BgL_z52htmlzd2documentz80_bglt BgL_aux2241z00_1092;
{ /* bmem/bmem.scm 291 */
obj_t BgL_functionsz00_507;
BgL_functionsz00_507 = 
BGl_getzd2functionszd2zzbmem_functionz00(); 
{ /* bmem/bmem.scm 291 */
obj_t BgL_gctablez00_508;
if(
PAIRP(BgL_gcmonz00_13))
{ /* bmem/bmem.scm 293 */
obj_t BgL_auxz00_4683;
{ /* bmem/bmem.scm 293 */
bool_t BgL_test3552z00_4684;
if(
PAIRP(BgL_typesz00_15))
{ /* bmem/bmem.scm 293 */
BgL_test3552z00_4684 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 293 */
BgL_test3552z00_4684 = 
NULLP(BgL_typesz00_15)
; } 
if(BgL_test3552z00_4684)
{ /* bmem/bmem.scm 293 */
BgL_auxz00_4683 = BgL_typesz00_15
; }  else 
{ 
obj_t BgL_auxz00_4688;
BgL_auxz00_4688 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)10870)), BGl_string3034z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_typesz00_15); 
FAILURE(BgL_auxz00_4688,BFALSE,BFALSE);} } 
BgL_gctablez00_508 = 
BGl_makezd2gczd2tablesz00zzbmem_gcz00(BgL_gcmonz00_13, BgL_functionsz00_507, BgL_auxz00_4683); }  else 
{ /* bmem/bmem.scm 292 */
BGl_errorzf2czd2locationz20zz__errorz00(
CNST_TABLE_REF(((long)63)), BGl_string3035z00zzbmemz00, BFALSE, 
BSTRING_TO_STRING(BGl_string2954z00zzbmemz00), ((long)10886)); 
BgL_gctablez00_508 = 
BGl_errorzf2locationzf2zz__errorz00(BFALSE, BFALSE, BFALSE, BGl_string2954z00zzbmemz00, 
BINT(((long)10886))); } 
{ /* bmem/bmem.scm 292 */
obj_t BgL_funtablez00_509;
if(
PAIRP(BgL_funmonz00_14))
{ /* bmem/bmem.scm 297 */
BgL_funtablez00_509 = 
BGl_makezd2functionzd2tablesz00zzbmem_functionz00(BgL_gcmonz00_13, BgL_functionsz00_507, BgL_typesz00_15); }  else 
{ /* bmem/bmem.scm 297 */
BGl_errorzf2czd2locationz20zz__errorz00(
CNST_TABLE_REF(((long)63)), BGl_string3036z00zzbmemz00, BFALSE, 
BSTRING_TO_STRING(BGl_string2954z00zzbmemz00), ((long)11030)); 
BgL_funtablez00_509 = 
BGl_errorzf2locationzf2zz__errorz00(BFALSE, BFALSE, BFALSE, BGl_string2954z00zzbmemz00, 
BINT(((long)11030))); } 
{ /* bmem/bmem.scm 297 */
obj_t BgL_typetablez00_510;
if(
PAIRP(BgL_typesz00_15))
{ /* bmem/bmem.scm 303 */
obj_t BgL_auxz00_4708;
{ /* bmem/bmem.scm 303 */
bool_t BgL_test3556z00_4709;
if(
PAIRP(BgL_gcmonz00_13))
{ /* bmem/bmem.scm 303 */
BgL_test3556z00_4709 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 303 */
BgL_test3556z00_4709 = 
NULLP(BgL_gcmonz00_13)
; } 
if(BgL_test3556z00_4709)
{ /* bmem/bmem.scm 303 */
BgL_auxz00_4708 = BgL_gcmonz00_13
; }  else 
{ 
obj_t BgL_auxz00_4713;
BgL_auxz00_4713 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)11153)), BGl_string3034z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_gcmonz00_13); 
FAILURE(BgL_auxz00_4713,BFALSE,BFALSE);} } 
BgL_typetablez00_510 = 
BGl_makezd2typezd2tablesz00zzbmem_typez00(BgL_auxz00_4708, BgL_functionsz00_507, BgL_typesz00_15); }  else 
{ /* bmem/bmem.scm 302 */
BGl_errorzf2czd2locationz20zz__errorz00(
CNST_TABLE_REF(((long)63)), BGl_string3037z00zzbmemz00, BFALSE, 
BSTRING_TO_STRING(BGl_string2954z00zzbmemz00), ((long)11180)); 
BgL_typetablez00_510 = 
BGl_errorzf2locationzf2zz__errorz00(BFALSE, BFALSE, BFALSE, BGl_string2954z00zzbmemz00, 
BINT(((long)11180))); } 
{ /* bmem/bmem.scm 302 */
obj_t BgL_threadtablez00_511;
if(
PAIRP(BgL_threadz00_16))
{ /* bmem/bmem.scm 307 */
BgL_threadtablez00_511 = 
BGl_makezd2threadzd2tablez00zzbmem_threadz00(BgL_threadz00_16); }  else 
{ /* bmem/bmem.scm 307 */
BgL_threadtablez00_511 = BGl_string3038z00zzbmemz00; } 
{ /* bmem/bmem.scm 307 */
obj_t BgL_dcssz00_512;
BgL_dcssz00_512 = 
BGl_dynamiczd2csszd2zzbmemz00(BgL_gcmonz00_13, BgL_functionsz00_507, BgL_typesz00_15); 
{ /* bmem/bmem.scm 310 */
obj_t BgL_marginz00_513;
{ /* bmem/bmem.scm 311 */
BgL_z52htmlzd2headingz80_bglt BgL_arg1978z00_697;BgL_z52htmlzd2headingz80_bglt BgL_arg1979z00_698;BgL_z52htmlzd2boxz80_bglt BgL_arg1980z00_699;BgL_z52htmlzd2headingz80_bglt BgL_arg1981z00_700;obj_t BgL_arg1982z00_701;BgL_z52htmlzd2brz80_bglt BgL_arg1983z00_702;obj_t BgL_arg1984z00_703;BgL_z52htmlzd2brz80_bglt BgL_arg1985z00_704;obj_t BgL_arg1986z00_705;
{ /* bmem/bmem.scm 311 */
BgL_z52htmlzd2headingz80_bglt BgL_new1350z00_715;
{ /* bmem/bmem.scm 311 */
obj_t BgL_env1348z00_716;
BgL_env1348z00_716 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 311 */

{ 
long BgL_auxz00_4728;
{ /* bmem/bmem.scm 311 */
long BgL_res2481z00_1656;
{ /* bmem/bmem.scm 311 */
obj_t BgL_classz00_1655;
BgL_classz00_1655 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_res2481z00_1656 = 
BGL_CLASS_INDEX(BgL_classz00_1655); } 
BgL_auxz00_4728 = BgL_res2481z00_1656; } 
bmem_set_allocation_type( BgL_auxz00_4728, 0 ); } 
{ /* bmem/bmem.scm 311 */
BgL_z52htmlzd2headingz80_bglt BgL_new1347z00_718;
BgL_new1347z00_718 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 311 */
long BgL_arg1996z00_719;
{ /* bmem/bmem.scm 311 */
long BgL_res2482z00_1658;
BgL_res2482z00_1658 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BgL_arg1996z00_719 = BgL_res2482z00_1658; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1347z00_718), BgL_arg1996z00_719); } 
BgL_new1350z00_715 = BgL_new1347z00_718; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1350z00_715)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1350z00_715)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1350z00_715)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1350z00_715)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1350z00_715))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1350z00_715))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_4746;
{ /* bmem/bmem.scm 311 */
obj_t BgL_tmpz00_4747;
{ /* bmem/bmem.scm 311 */
obj_t BgL_aux2847z00_2356;
BgL_aux2847z00_2356 = BGl_za2bmemzd2versionza2zd2zzbmem_paramz00; 
if(
STRINGP(BgL_aux2847z00_2356))
{ /* bmem/bmem.scm 311 */
BgL_tmpz00_4747 = BgL_aux2847z00_2356
; }  else 
{ 
obj_t BgL_auxz00_4750;
BgL_auxz00_4750 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)11380)), BGl_string3034z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_aux2847z00_2356); 
FAILURE(BgL_auxz00_4750,BFALSE,BFALSE);} } 
BgL_auxz00_4746 = 
string_append(BGl_string3039z00zzbmemz00, BgL_tmpz00_4747); } 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1350z00_715))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4746),BUNSPEC); } 
BgL_arg1978z00_697 = BgL_new1350z00_715; } 
{ /* bmem/bmem.scm 312 */
BgL_z52htmlzd2headingz80_bglt BgL_new1354z00_720;
{ /* bmem/bmem.scm 312 */
obj_t BgL_env1352z00_721;
BgL_env1352z00_721 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 312 */

{ 
long BgL_auxz00_4757;
{ /* bmem/bmem.scm 312 */
long BgL_res2484z00_1663;
{ /* bmem/bmem.scm 312 */
obj_t BgL_classz00_1662;
BgL_classz00_1662 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_res2484z00_1663 = 
BGL_CLASS_INDEX(BgL_classz00_1662); } 
BgL_auxz00_4757 = BgL_res2484z00_1663; } 
bmem_set_allocation_type( BgL_auxz00_4757, 0 ); } 
{ /* bmem/bmem.scm 312 */
BgL_z52htmlzd2headingz80_bglt BgL_new1351z00_723;
BgL_new1351z00_723 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 312 */
long BgL_arg1997z00_724;
{ /* bmem/bmem.scm 312 */
long BgL_res2485z00_1665;
BgL_res2485z00_1665 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BgL_arg1997z00_724 = BgL_res2485z00_1665; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1351z00_723), BgL_arg1997z00_724); } 
BgL_new1354z00_720 = BgL_new1351z00_723; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1354z00_720)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1354z00_720)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1354z00_720)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1354z00_720)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1354z00_720))->BgL_levelz00)=((int)
(int)(((long)2))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1354z00_720))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1354z00_720))->BgL_inlineza2za2)=((obj_t)BGl_string3040z00zzbmemz00),BUNSPEC); 
BgL_arg1979z00_698 = BgL_new1354z00_720; } 
{ /* bmem/bmem.scm 313 */
BgL_z52htmlzd2boxz80_bglt BgL_new1358z00_725;
{ /* bmem/bmem.scm 313 */
obj_t BgL_env1356z00_753;
BgL_env1356z00_753 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 313 */

{ 
long BgL_auxz00_4777;
{ /* bmem/bmem.scm 313 */
long BgL_res2487z00_1670;
{ /* bmem/bmem.scm 313 */
obj_t BgL_classz00_1669;
BgL_classz00_1669 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2487z00_1670 = 
BGL_CLASS_INDEX(BgL_classz00_1669); } 
BgL_auxz00_4777 = BgL_res2487z00_1670; } 
bmem_set_allocation_type( BgL_auxz00_4777, 0 ); } 
{ /* bmem/bmem.scm 313 */
BgL_z52htmlzd2boxz80_bglt BgL_new1355z00_755;
BgL_new1355z00_755 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 313 */
long BgL_arg2009z00_756;
{ /* bmem/bmem.scm 313 */
long BgL_res2488z00_1672;
BgL_res2488z00_1672 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2boxz80zzhtmlz00); 
BgL_arg2009z00_756 = BgL_res2488z00_1672; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1355z00_755), BgL_arg2009z00_756); } 
BgL_new1358z00_725 = BgL_new1355z00_755; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1358z00_725)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1358z00_725)))->BgL_classz00)=((obj_t)BGl_string3041z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1358z00_725)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1358z00_725)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1358z00_725))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
{ 
obj_t BgL_auxz00_4794;
{ /* bmem/bmem.scm 315 */
BgL_z52htmlzd2az80_bglt BgL_arg1998z00_726;BgL_z52htmlzd2az80_bglt BgL_arg1999z00_727;BgL_z52htmlzd2az80_bglt BgL_arg2000z00_728;BgL_z52htmlzd2az80_bglt BgL_arg2001z00_729;
{ /* bmem/bmem.scm 315 */
BgL_z52htmlzd2az80_bglt BgL_new1362z00_733;
{ /* bmem/bmem.scm 315 */
obj_t BgL_env1360z00_734;
{ /* bmem/bmem.scm 315 */
obj_t BgL_res2489z00_1675;
BgL_res2489z00_1675 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1360z00_734 = BgL_res2489z00_1675; } 
{ /* bmem/bmem.scm 315 */

{ 
long BgL_auxz00_4796;
{ /* bmem/bmem.scm 315 */
long BgL_res2490z00_1677;
{ /* bmem/bmem.scm 315 */
obj_t BgL_classz00_1676;
BgL_classz00_1676 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2490z00_1677 = 
BGL_CLASS_INDEX(BgL_classz00_1676); } 
BgL_auxz00_4796 = BgL_res2490z00_1677; } 
bmem_set_allocation_type( BgL_auxz00_4796, 0 ); } 
{ /* bmem/bmem.scm 315 */
BgL_z52htmlzd2az80_bglt BgL_new1359z00_736;
BgL_new1359z00_736 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 315 */
long BgL_arg2005z00_737;
{ /* bmem/bmem.scm 315 */
long BgL_res2491z00_1679;
{ /* bmem/bmem.scm 315 */
obj_t BgL_classz00_1678;
BgL_classz00_1678 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2491z00_1679 = 
BGL_CLASS_INDEX(BgL_classz00_1678); } 
BgL_arg2005z00_737 = BgL_res2491z00_1679; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1359z00_736), BgL_arg2005z00_737); } 
BgL_new1362z00_733 = BgL_new1359z00_736; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1362z00_733)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1362z00_733)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1362z00_733)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1362z00_733)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1362z00_733))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1362z00_733))->BgL_hrefz00)=((obj_t)BGl_string3042z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1362z00_733))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1362z00_733))->BgL_inlineza2za2)=((obj_t)BGl_string3043z00zzbmemz00),BUNSPEC); 
BgL_arg1998z00_726 = BgL_new1362z00_733; } 
{ /* bmem/bmem.scm 316 */
BgL_z52htmlzd2az80_bglt BgL_new1366z00_738;
{ /* bmem/bmem.scm 316 */
obj_t BgL_env1364z00_739;
{ /* bmem/bmem.scm 316 */
obj_t BgL_res2492z00_1682;
BgL_res2492z00_1682 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1364z00_739 = BgL_res2492z00_1682; } 
{ /* bmem/bmem.scm 316 */

{ 
long BgL_auxz00_4816;
{ /* bmem/bmem.scm 316 */
long BgL_res2493z00_1684;
{ /* bmem/bmem.scm 316 */
obj_t BgL_classz00_1683;
BgL_classz00_1683 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2493z00_1684 = 
BGL_CLASS_INDEX(BgL_classz00_1683); } 
BgL_auxz00_4816 = BgL_res2493z00_1684; } 
bmem_set_allocation_type( BgL_auxz00_4816, 0 ); } 
{ /* bmem/bmem.scm 316 */
BgL_z52htmlzd2az80_bglt BgL_new1363z00_741;
BgL_new1363z00_741 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 316 */
long BgL_arg2006z00_742;
{ /* bmem/bmem.scm 316 */
long BgL_res2494z00_1686;
{ /* bmem/bmem.scm 316 */
obj_t BgL_classz00_1685;
BgL_classz00_1685 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2494z00_1686 = 
BGL_CLASS_INDEX(BgL_classz00_1685); } 
BgL_arg2006z00_742 = BgL_res2494z00_1686; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1363z00_741), BgL_arg2006z00_742); } 
BgL_new1366z00_738 = BgL_new1363z00_741; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1366z00_738)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1366z00_738)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1366z00_738)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1366z00_738)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1366z00_738))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1366z00_738))->BgL_hrefz00)=((obj_t)BGl_string3044z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1366z00_738))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1366z00_738))->BgL_inlineza2za2)=((obj_t)BGl_string3045z00zzbmemz00),BUNSPEC); 
BgL_arg1999z00_727 = BgL_new1366z00_738; } 
{ /* bmem/bmem.scm 317 */
BgL_z52htmlzd2az80_bglt BgL_new1370z00_743;
{ /* bmem/bmem.scm 317 */
obj_t BgL_env1368z00_744;
{ /* bmem/bmem.scm 317 */
obj_t BgL_res2495z00_1689;
BgL_res2495z00_1689 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1368z00_744 = BgL_res2495z00_1689; } 
{ /* bmem/bmem.scm 317 */

{ 
long BgL_auxz00_4836;
{ /* bmem/bmem.scm 317 */
long BgL_res2496z00_1691;
{ /* bmem/bmem.scm 317 */
obj_t BgL_classz00_1690;
BgL_classz00_1690 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2496z00_1691 = 
BGL_CLASS_INDEX(BgL_classz00_1690); } 
BgL_auxz00_4836 = BgL_res2496z00_1691; } 
bmem_set_allocation_type( BgL_auxz00_4836, 0 ); } 
{ /* bmem/bmem.scm 317 */
BgL_z52htmlzd2az80_bglt BgL_new1367z00_746;
BgL_new1367z00_746 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 317 */
long BgL_arg2007z00_747;
{ /* bmem/bmem.scm 317 */
long BgL_res2497z00_1693;
{ /* bmem/bmem.scm 317 */
obj_t BgL_classz00_1692;
BgL_classz00_1692 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2497z00_1693 = 
BGL_CLASS_INDEX(BgL_classz00_1692); } 
BgL_arg2007z00_747 = BgL_res2497z00_1693; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1367z00_746), BgL_arg2007z00_747); } 
BgL_new1370z00_743 = BgL_new1367z00_746; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1370z00_743)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1370z00_743)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1370z00_743)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1370z00_743)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1370z00_743))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1370z00_743))->BgL_hrefz00)=((obj_t)BGl_string3046z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1370z00_743))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1370z00_743))->BgL_inlineza2za2)=((obj_t)BGl_string3047z00zzbmemz00),BUNSPEC); 
BgL_arg2000z00_728 = BgL_new1370z00_743; } 
{ /* bmem/bmem.scm 318 */
BgL_z52htmlzd2az80_bglt BgL_new1374z00_748;
{ /* bmem/bmem.scm 318 */
obj_t BgL_env1372z00_749;
{ /* bmem/bmem.scm 318 */
obj_t BgL_res2498z00_1696;
BgL_res2498z00_1696 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1372z00_749 = BgL_res2498z00_1696; } 
{ /* bmem/bmem.scm 318 */

{ 
long BgL_auxz00_4856;
{ /* bmem/bmem.scm 318 */
long BgL_res2499z00_1698;
{ /* bmem/bmem.scm 318 */
obj_t BgL_classz00_1697;
BgL_classz00_1697 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2499z00_1698 = 
BGL_CLASS_INDEX(BgL_classz00_1697); } 
BgL_auxz00_4856 = BgL_res2499z00_1698; } 
bmem_set_allocation_type( BgL_auxz00_4856, 0 ); } 
{ /* bmem/bmem.scm 318 */
BgL_z52htmlzd2az80_bglt BgL_new1371z00_751;
BgL_new1371z00_751 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 318 */
long BgL_arg2008z00_752;
{ /* bmem/bmem.scm 318 */
long BgL_res2500z00_1700;
{ /* bmem/bmem.scm 318 */
obj_t BgL_classz00_1699;
BgL_classz00_1699 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2500z00_1700 = 
BGL_CLASS_INDEX(BgL_classz00_1699); } 
BgL_arg2008z00_752 = BgL_res2500z00_1700; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1371z00_751), BgL_arg2008z00_752); } 
BgL_new1374z00_748 = BgL_new1371z00_751; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1374z00_748)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1374z00_748)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1374z00_748)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1374z00_748)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1374z00_748))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1374z00_748))->BgL_hrefz00)=((obj_t)BGl_string3048z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1374z00_748))->BgL_namez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1374z00_748))->BgL_inlineza2za2)=((obj_t)BGl_string3049z00zzbmemz00),BUNSPEC); 
BgL_arg2001z00_729 = BgL_new1374z00_748; } 
{ /* bmem/bmem.scm 314 */
obj_t BgL_list2002z00_730;
{ /* bmem/bmem.scm 314 */
obj_t BgL_arg2003z00_731;
{ /* bmem/bmem.scm 314 */
obj_t BgL_arg2004z00_732;
BgL_arg2004z00_732 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2001z00_729), BNIL); 
BgL_arg2003z00_731 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2000z00_728), BgL_arg2004z00_732); } 
BgL_list2002z00_730 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1999z00_727), BgL_arg2003z00_731); } 
BgL_auxz00_4794 = 
BGl_htmlzd2vboxzd2zzhtmlz00(
((obj_t)BgL_arg1998z00_726), BgL_list2002z00_730); } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1358z00_725))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_4794),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1358z00_725))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1980z00_699 = BgL_new1358z00_725; } 
{ /* bmem/bmem.scm 319 */
BgL_z52htmlzd2headingz80_bglt BgL_new1378z00_757;
{ /* bmem/bmem.scm 319 */
obj_t BgL_env1376z00_758;
BgL_env1376z00_758 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 319 */

{ 
long BgL_auxz00_4886;
{ /* bmem/bmem.scm 319 */
long BgL_res2502z00_1705;
{ /* bmem/bmem.scm 319 */
obj_t BgL_classz00_1704;
BgL_classz00_1704 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_res2502z00_1705 = 
BGL_CLASS_INDEX(BgL_classz00_1704); } 
BgL_auxz00_4886 = BgL_res2502z00_1705; } 
bmem_set_allocation_type( BgL_auxz00_4886, 0 ); } 
{ /* bmem/bmem.scm 319 */
BgL_z52htmlzd2headingz80_bglt BgL_new1375z00_760;
BgL_new1375z00_760 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 319 */
long BgL_arg2010z00_761;
{ /* bmem/bmem.scm 319 */
long BgL_res2503z00_1707;
BgL_res2503z00_1707 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BgL_arg2010z00_761 = BgL_res2503z00_1707; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1375z00_760), BgL_arg2010z00_761); } 
BgL_new1378z00_757 = BgL_new1375z00_760; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1378z00_757)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1378z00_757)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1378z00_757)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1378z00_757)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1378z00_757))->BgL_levelz00)=((int)
(int)(((long)2))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1378z00_757))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1378z00_757))->BgL_inlineza2za2)=((obj_t)BGl_string3050z00zzbmemz00),BUNSPEC); 
BgL_arg1981z00_700 = BgL_new1378z00_757; } 
{ /* bmem/bmem.scm 322 */
obj_t BgL_arg2011z00_762;
{ /* bmem/bmem.scm 322 */
obj_t BgL_l1569z00_763;
{ /* bmem/bmem.scm 326 */
obj_t BgL_arg2025z00_785;
{ /* bmem/bmem.scm 326 */
obj_t BgL_hook1568z00_787;
BgL_hook1568z00_787 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
{ 
obj_t BgL_l1565z00_789;obj_t BgL_h1566z00_790;
BgL_l1565z00_789 = BgL_functionsz00_507; 
BgL_h1566z00_790 = BgL_hook1568z00_787; 
BgL_zc3z04anonymousza32027za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z51_791:
if(
NULLP(BgL_l1565z00_789))
{ /* bmem/bmem.scm 326 */
BgL_arg2025z00_785 = 
CDR(BgL_hook1568z00_787); }  else 
{ /* bmem/bmem.scm 326 */
bool_t BgL_test3561z00_4909;
{ /* bmem/bmem.scm 327 */
BgL_funinfoz00_bglt BgL_i1380z00_801;
{ /* bmem/bmem.scm 327 */
obj_t BgL_pairz00_1712;
if(
PAIRP(BgL_l1565z00_789))
{ /* bmem/bmem.scm 327 */
BgL_pairz00_1712 = BgL_l1565z00_789; }  else 
{ 
obj_t BgL_auxz00_4912;
BgL_auxz00_4912 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)11906)), BGl_string3051z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_l1565z00_789); 
FAILURE(BgL_auxz00_4912,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 327 */
obj_t BgL_aux2851z00_2360;
BgL_aux2851z00_2360 = 
CAR(BgL_pairz00_1712); 
if(
BGl_isazf3zf3zz__objectz00(BgL_aux2851z00_2360, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 327 */
BgL_i1380z00_801 = 
((BgL_funinfoz00_bglt)BgL_aux2851z00_2360); }  else 
{ 
obj_t BgL_auxz00_4920;
BgL_auxz00_4920 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)11906)), BGl_string3051z00zzbmemz00, BGl_string3052z00zzbmemz00, BgL_aux2851z00_2360); 
FAILURE(BgL_auxz00_4920,BFALSE,BFALSE);} } } 
BgL_test3561z00_4909 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1380z00_801))->BgL_usez00); } 
if(BgL_test3561z00_4909)
{ /* bmem/bmem.scm 326 */
obj_t BgL_nh1567z00_796;
{ /* bmem/bmem.scm 326 */
obj_t BgL_arg2031z00_798;
{ /* bmem/bmem.scm 326 */
obj_t BgL_pairz00_1713;
if(
PAIRP(BgL_l1565z00_789))
{ /* bmem/bmem.scm 326 */
BgL_pairz00_1713 = BgL_l1565z00_789; }  else 
{ 
obj_t BgL_auxz00_4927;
BgL_auxz00_4927 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)11874)), BGl_string3051z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_l1565z00_789); 
FAILURE(BgL_auxz00_4927,BFALSE,BFALSE);} 
BgL_arg2031z00_798 = 
CAR(BgL_pairz00_1713); } 
{ /* bmem/bmem.scm 326 */
obj_t BgL_res2505z00_1714;
BgL_res2505z00_1714 = 
MAKE_YOUNG_PAIR(BgL_arg2031z00_798, BNIL); 
BgL_nh1567z00_796 = BgL_res2505z00_1714; } } 
SET_CDR(BgL_h1566z00_790, BgL_nh1567z00_796); 
{ /* bmem/bmem.scm 326 */
obj_t BgL_arg2030z00_797;
{ /* bmem/bmem.scm 326 */
obj_t BgL_pairz00_1716;
if(
PAIRP(BgL_l1565z00_789))
{ /* bmem/bmem.scm 326 */
BgL_pairz00_1716 = BgL_l1565z00_789; }  else 
{ 
obj_t BgL_auxz00_4936;
BgL_auxz00_4936 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)11874)), BGl_string3051z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_l1565z00_789); 
FAILURE(BgL_auxz00_4936,BFALSE,BFALSE);} 
BgL_arg2030z00_797 = 
CDR(BgL_pairz00_1716); } 
{ 
obj_t BgL_h1566z00_4942;obj_t BgL_l1565z00_4941;
BgL_l1565z00_4941 = BgL_arg2030z00_797; 
BgL_h1566z00_4942 = BgL_nh1567z00_796; 
BgL_h1566z00_790 = BgL_h1566z00_4942; 
BgL_l1565z00_789 = BgL_l1565z00_4941; 
goto BgL_zc3z04anonymousza32027za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z51_791;} } }  else 
{ /* bmem/bmem.scm 326 */
obj_t BgL_arg2032z00_799;
{ /* bmem/bmem.scm 326 */
obj_t BgL_pairz00_1717;
if(
PAIRP(BgL_l1565z00_789))
{ /* bmem/bmem.scm 326 */
BgL_pairz00_1717 = BgL_l1565z00_789; }  else 
{ 
obj_t BgL_auxz00_4945;
BgL_auxz00_4945 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)11874)), BGl_string3051z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_l1565z00_789); 
FAILURE(BgL_auxz00_4945,BFALSE,BFALSE);} 
BgL_arg2032z00_799 = 
CDR(BgL_pairz00_1717); } 
{ 
obj_t BgL_l1565z00_4950;
BgL_l1565z00_4950 = BgL_arg2032z00_799; 
BgL_l1565z00_789 = BgL_l1565z00_4950; 
goto BgL_zc3z04anonymousza32027za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z51_791;} } } } } 
BgL_l1569z00_763 = 
BGl_sortz00zz__r4_vectors_6_8z00(BgL_arg2025z00_785, BGl_proc3053z00zzbmemz00); } 
if(
NULLP(BgL_l1569z00_763))
{ /* bmem/bmem.scm 322 */
BgL_arg2011z00_762 = BNIL; }  else 
{ /* bmem/bmem.scm 322 */
obj_t BgL_head1571z00_765;
{ /* bmem/bmem.scm 322 */
obj_t BgL_res2510z00_1734;
BgL_res2510z00_1734 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1571z00_765 = BgL_res2510z00_1734; } 
{ 
obj_t BgL_l1569z00_767;obj_t BgL_tail1572z00_768;
BgL_l1569z00_767 = BgL_l1569z00_763; 
BgL_tail1572z00_768 = BgL_head1571z00_765; 
BgL_zc3z04anonymousza32013za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3322z04ze3z51_769:
if(
PAIRP(BgL_l1569z00_767))
{ /* bmem/bmem.scm 322 */
obj_t BgL_newtail1573z00_771;
{ /* bmem/bmem.scm 322 */
obj_t BgL_arg2016z00_773;
{ /* bmem/bmem.scm 322 */
obj_t BgL_fz00_774;
BgL_fz00_774 = 
CAR(BgL_l1569z00_767); 
{ /* bmem/bmem.scm 323 */
BgL_funinfoz00_bglt BgL_i1379z00_775;
if(
BGl_isazf3zf3zz__objectz00(BgL_fz00_774, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 324 */
BgL_i1379z00_775 = 
((BgL_funinfoz00_bglt)BgL_fz00_774); }  else 
{ 
obj_t BgL_auxz00_4961;
BgL_auxz00_4961 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)11796)), BGl_string3054z00zzbmemz00, BGl_string3052z00zzbmemz00, BgL_fz00_774); 
FAILURE(BgL_auxz00_4961,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 324 */
obj_t BgL_arg2017z00_776;obj_t BgL_arg2018z00_777;
{ /* bmem/bmem.scm 324 */
int BgL_arg2021z00_780;
BgL_arg2021z00_780 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1379z00_775))->BgL_numz00); 
{ /* bmem/bmem.scm 324 */
obj_t BgL_list2022z00_781;
BgL_list2022z00_781 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2021z00_780), BNIL); 
BgL_arg2017z00_776 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3055z00zzbmemz00, BgL_list2022z00_781); } } 
BgL_arg2018z00_777 = 
BGl_functionzd2refzd2zzbmemz00(
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1379z00_775))->BgL_identz00)); 
{ /* bmem/bmem.scm 324 */
obj_t BgL_list2019z00_778;
{ /* bmem/bmem.scm 324 */
obj_t BgL_arg2020z00_779;
BgL_arg2020z00_779 = 
MAKE_YOUNG_PAIR(BgL_arg2018z00_777, BNIL); 
BgL_list2019z00_778 = 
MAKE_YOUNG_PAIR(BgL_arg2017z00_776, BgL_arg2020z00_779); } 
BgL_arg2016z00_773 = BgL_list2019z00_778; } } } } 
{ /* bmem/bmem.scm 322 */
obj_t BgL_res2513z00_1738;
BgL_res2513z00_1738 = 
MAKE_YOUNG_PAIR(BgL_arg2016z00_773, BNIL); 
BgL_newtail1573z00_771 = BgL_res2513z00_1738; } } 
SET_CDR(BgL_tail1572z00_768, BgL_newtail1573z00_771); 
{ 
obj_t BgL_tail1572z00_4977;obj_t BgL_l1569z00_4975;
BgL_l1569z00_4975 = 
CDR(BgL_l1569z00_767); 
BgL_tail1572z00_4977 = BgL_newtail1573z00_771; 
BgL_tail1572z00_768 = BgL_tail1572z00_4977; 
BgL_l1569z00_767 = BgL_l1569z00_4975; 
goto BgL_zc3z04anonymousza32013za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3322z04ze3z51_769;} }  else 
{ /* bmem/bmem.scm 322 */
if(
NULLP(BgL_l1569z00_767))
{ /* bmem/bmem.scm 322 */
BgL_arg2011z00_762 = 
CDR(BgL_head1571z00_765); }  else 
{ /* bmem/bmem.scm 322 */
BgL_arg2011z00_762 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string3056z00zzbmemz00, BGl_string3016z00zzbmemz00, BgL_l1569z00_767, BGl_string2954z00zzbmemz00, 
BINT(((long)11730))); } } } } } 
{ /* bmem/bmem.scm 320 */
obj_t BgL_auxz00_4983;
{ /* bmem/bmem.scm 335 */
bool_t BgL_test3571z00_4985;
if(
PAIRP(BgL_arg2011z00_762))
{ /* bmem/bmem.scm 335 */
BgL_test3571z00_4985 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 335 */
BgL_test3571z00_4985 = 
NULLP(BgL_arg2011z00_762)
; } 
if(BgL_test3571z00_4985)
{ /* bmem/bmem.scm 335 */
BgL_auxz00_4983 = BgL_arg2011z00_762
; }  else 
{ 
obj_t BgL_auxz00_4989;
BgL_auxz00_4989 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12170)), BGl_string3034z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_arg2011z00_762); 
FAILURE(BgL_auxz00_4989,BFALSE,BFALSE);} } 
BgL_arg1982z00_701 = 
BGl_htmlzd2legendzd2zzbmem_toolsz00(
(int)(((long)1)), BGl_string3057z00zzbmemz00, BgL_auxz00_4983, BGl_string3043z00zzbmemz00, BGl_string3058z00zzbmemz00); } } 
{ /* bmem/bmem.scm 337 */
BgL_z52htmlzd2brz80_bglt BgL_new1386z00_813;
{ /* bmem/bmem.scm 337 */
obj_t BgL_env1384z00_814;
BgL_env1384z00_814 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 337 */

{ 
long BgL_auxz00_4995;
{ /* bmem/bmem.scm 337 */
long BgL_res2516z00_1745;
{ /* bmem/bmem.scm 337 */
obj_t BgL_classz00_1744;
BgL_classz00_1744 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_res2516z00_1745 = 
BGL_CLASS_INDEX(BgL_classz00_1744); } 
BgL_auxz00_4995 = BgL_res2516z00_1745; } 
bmem_set_allocation_type( BgL_auxz00_4995, 0 ); } 
{ /* bmem/bmem.scm 337 */
BgL_z52htmlzd2brz80_bglt BgL_new1383z00_816;
BgL_new1383z00_816 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 337 */
long BgL_arg2038z00_817;
{ /* bmem/bmem.scm 337 */
long BgL_res2517z00_1747;
BgL_res2517z00_1747 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BgL_arg2038z00_817 = BgL_res2517z00_1747; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1383z00_816), BgL_arg2038z00_817); } 
BgL_new1386z00_813 = BgL_new1383z00_816; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1386z00_813)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1386z00_813)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1386z00_813)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1386z00_813)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1983z00_702 = BgL_new1386z00_813; } 
{ /* bmem/bmem.scm 340 */
obj_t BgL_arg2039z00_818;
{ /* bmem/bmem.scm 340 */
obj_t BgL_l1574z00_819;
{ /* bmem/bmem.scm 343 */
obj_t BgL_arg2053z00_840;
{ /* bmem/bmem.scm 343 */
obj_t BgL_pairz00_1750;
if(
PAIRP(BgL_typesz00_15))
{ /* bmem/bmem.scm 343 */
BgL_pairz00_1750 = BgL_typesz00_15; }  else 
{ 
obj_t BgL_auxz00_5012;
BgL_auxz00_5012 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12359)), BGl_string3034z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_typesz00_15); 
FAILURE(BgL_auxz00_5012,BFALSE,BFALSE);} 
BgL_arg2053z00_840 = 
CDR(BgL_pairz00_1750); } 
BgL_l1574z00_819 = 
BGl_sortz00zz__r4_vectors_6_8z00(BgL_arg2053z00_840, BGl_proc3059z00zzbmemz00); } 
if(
NULLP(BgL_l1574z00_819))
{ /* bmem/bmem.scm 340 */
BgL_arg2039z00_818 = BNIL; }  else 
{ /* bmem/bmem.scm 340 */
obj_t BgL_head1576z00_821;
{ /* bmem/bmem.scm 340 */
obj_t BgL_res2520z00_1765;
BgL_res2520z00_1765 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1576z00_821 = BgL_res2520z00_1765; } 
{ 
obj_t BgL_l1574z00_823;obj_t BgL_tail1577z00_824;
BgL_l1574z00_823 = BgL_l1574z00_819; 
BgL_tail1577z00_824 = BgL_head1576z00_821; 
BgL_zc3z04anonymousza32041za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3340z04ze3z51_825:
if(
PAIRP(BgL_l1574z00_823))
{ /* bmem/bmem.scm 340 */
obj_t BgL_newtail1578z00_827;
{ /* bmem/bmem.scm 340 */
obj_t BgL_arg2044z00_829;
{ /* bmem/bmem.scm 340 */
obj_t BgL_tz00_830;
BgL_tz00_830 = 
CAR(BgL_l1574z00_823); 
{ /* bmem/bmem.scm 341 */
obj_t BgL_arg2045z00_831;obj_t BgL_arg2046z00_832;
{ /* bmem/bmem.scm 341 */
obj_t BgL_arg2049z00_835;
{ /* bmem/bmem.scm 341 */
obj_t BgL_pairz00_1768;
if(
PAIRP(BgL_tz00_830))
{ /* bmem/bmem.scm 341 */
BgL_pairz00_1768 = BgL_tz00_830; }  else 
{ 
obj_t BgL_auxz00_5026;
BgL_auxz00_5026 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12302)), BGl_string3060z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_tz00_830); 
FAILURE(BgL_auxz00_5026,BFALSE,BFALSE);} 
BgL_arg2049z00_835 = 
CAR(BgL_pairz00_1768); } 
{ /* bmem/bmem.scm 341 */
obj_t BgL_list2050z00_836;
BgL_list2050z00_836 = 
MAKE_YOUNG_PAIR(BgL_arg2049z00_835, BNIL); 
BgL_arg2045z00_831 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3061z00zzbmemz00, BgL_list2050z00_836); } } 
{ /* bmem/bmem.scm 342 */
obj_t BgL_arg2051z00_837;
{ /* bmem/bmem.scm 342 */
obj_t BgL_pairz00_1769;
if(
PAIRP(BgL_tz00_830))
{ /* bmem/bmem.scm 342 */
BgL_pairz00_1769 = BgL_tz00_830; }  else 
{ 
obj_t BgL_auxz00_5035;
BgL_auxz00_5035 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12333)), BGl_string3060z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_tz00_830); 
FAILURE(BgL_auxz00_5035,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 342 */
obj_t BgL_pairz00_1772;
{ /* bmem/bmem.scm 342 */
obj_t BgL_aux2869z00_2382;
BgL_aux2869z00_2382 = 
CDR(BgL_pairz00_1769); 
if(
PAIRP(BgL_aux2869z00_2382))
{ /* bmem/bmem.scm 342 */
BgL_pairz00_1772 = BgL_aux2869z00_2382; }  else 
{ 
obj_t BgL_auxz00_5042;
BgL_auxz00_5042 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12327)), BGl_string3060z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2869z00_2382); 
FAILURE(BgL_auxz00_5042,BFALSE,BFALSE);} } 
BgL_arg2051z00_837 = 
CAR(BgL_pairz00_1772); } } 
BgL_arg2046z00_832 = 
BGl_typezd2refzd2zzbmemz00(BgL_arg2051z00_837); } 
{ /* bmem/bmem.scm 341 */
obj_t BgL_list2047z00_833;
{ /* bmem/bmem.scm 341 */
obj_t BgL_arg2048z00_834;
BgL_arg2048z00_834 = 
MAKE_YOUNG_PAIR(BgL_arg2046z00_832, BNIL); 
BgL_list2047z00_833 = 
MAKE_YOUNG_PAIR(BgL_arg2045z00_831, BgL_arg2048z00_834); } 
BgL_arg2044z00_829 = BgL_list2047z00_833; } } } 
{ /* bmem/bmem.scm 340 */
obj_t BgL_res2523z00_1774;
BgL_res2523z00_1774 = 
MAKE_YOUNG_PAIR(BgL_arg2044z00_829, BNIL); 
BgL_newtail1578z00_827 = BgL_res2523z00_1774; } } 
SET_CDR(BgL_tail1577z00_824, BgL_newtail1578z00_827); 
{ 
obj_t BgL_tail1577z00_5054;obj_t BgL_l1574z00_5052;
BgL_l1574z00_5052 = 
CDR(BgL_l1574z00_823); 
BgL_tail1577z00_5054 = BgL_newtail1578z00_827; 
BgL_tail1577z00_824 = BgL_tail1577z00_5054; 
BgL_l1574z00_823 = BgL_l1574z00_5052; 
goto BgL_zc3z04anonymousza32041za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3340z04ze3z51_825;} }  else 
{ /* bmem/bmem.scm 340 */
if(
NULLP(BgL_l1574z00_823))
{ /* bmem/bmem.scm 340 */
BgL_arg2039z00_818 = 
CDR(BgL_head1576z00_821); }  else 
{ /* bmem/bmem.scm 340 */
BgL_arg2039z00_818 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string3056z00zzbmemz00, BGl_string3016z00zzbmemz00, BgL_l1574z00_823, BGl_string2954z00zzbmemz00, 
BINT(((long)12252))); } } } } } 
{ /* bmem/bmem.scm 338 */
obj_t BgL_auxz00_5060;
{ /* bmem/bmem.scm 345 */
bool_t BgL_test3580z00_5062;
if(
PAIRP(BgL_arg2039z00_818))
{ /* bmem/bmem.scm 345 */
BgL_test3580z00_5062 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 345 */
BgL_test3580z00_5062 = 
NULLP(BgL_arg2039z00_818)
; } 
if(BgL_test3580z00_5062)
{ /* bmem/bmem.scm 345 */
BgL_auxz00_5060 = BgL_arg2039z00_818
; }  else 
{ 
obj_t BgL_auxz00_5066;
BgL_auxz00_5066 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12433)), BGl_string3034z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_arg2039z00_818); 
FAILURE(BgL_auxz00_5066,BFALSE,BFALSE);} } 
BgL_arg1984z00_703 = 
BGl_htmlzd2legendzd2zzbmem_toolsz00(
(int)(((long)1)), BGl_string3057z00zzbmemz00, BgL_auxz00_5060, BGl_string3045z00zzbmemz00, BGl_string3062z00zzbmemz00); } } 
{ /* bmem/bmem.scm 347 */
BgL_z52htmlzd2brz80_bglt BgL_new1390z00_848;
{ /* bmem/bmem.scm 347 */
obj_t BgL_env1388z00_849;
BgL_env1388z00_849 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 347 */

{ 
long BgL_auxz00_5072;
{ /* bmem/bmem.scm 347 */
long BgL_res2526z00_1781;
{ /* bmem/bmem.scm 347 */
obj_t BgL_classz00_1780;
BgL_classz00_1780 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_res2526z00_1781 = 
BGL_CLASS_INDEX(BgL_classz00_1780); } 
BgL_auxz00_5072 = BgL_res2526z00_1781; } 
bmem_set_allocation_type( BgL_auxz00_5072, 0 ); } 
{ /* bmem/bmem.scm 347 */
BgL_z52htmlzd2brz80_bglt BgL_new1387z00_851;
BgL_new1387z00_851 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 347 */
long BgL_arg2058z00_852;
{ /* bmem/bmem.scm 347 */
long BgL_res2527z00_1783;
BgL_res2527z00_1783 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BgL_arg2058z00_852 = BgL_res2527z00_1783; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1387z00_851), BgL_arg2058z00_852); } 
BgL_new1390z00_848 = BgL_new1387z00_851; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1390z00_848)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1390z00_848)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1390z00_848)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1390z00_848)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1985z00_704 = BgL_new1390z00_848; } 
{ /* bmem/bmem.scm 350 */
obj_t BgL_arg2059z00_853;
{ /* bmem/bmem.scm 350 */
obj_t BgL_l1579z00_854;
{ /* bmem/bmem.scm 353 */
obj_t BgL_pairz00_1786;
if(
PAIRP(BgL_gcmonz00_13))
{ /* bmem/bmem.scm 353 */
BgL_pairz00_1786 = BgL_gcmonz00_13; }  else 
{ 
obj_t BgL_auxz00_5089;
BgL_auxz00_5089 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12628)), BGl_string3034z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_gcmonz00_13); 
FAILURE(BgL_auxz00_5089,BFALSE,BFALSE);} 
BgL_l1579z00_854 = 
CDR(BgL_pairz00_1786); } 
if(
NULLP(BgL_l1579z00_854))
{ /* bmem/bmem.scm 350 */
BgL_arg2059z00_853 = BNIL; }  else 
{ /* bmem/bmem.scm 350 */
obj_t BgL_head1581z00_856;
{ /* bmem/bmem.scm 350 */
obj_t BgL_res2529z00_1788;
BgL_res2529z00_1788 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1581z00_856 = BgL_res2529z00_1788; } 
{ 
obj_t BgL_l1579z00_858;obj_t BgL_tail1582z00_859;
BgL_l1579z00_858 = BgL_l1579z00_854; 
BgL_tail1582z00_859 = BgL_head1581z00_856; 
BgL_zc3z04anonymousza32061za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3350z04ze3z51_860:
if(
PAIRP(BgL_l1579z00_858))
{ /* bmem/bmem.scm 350 */
obj_t BgL_newtail1583z00_862;
{ /* bmem/bmem.scm 350 */
obj_t BgL_arg2064z00_864;
{ /* bmem/bmem.scm 350 */
obj_t BgL_tz00_865;
BgL_tz00_865 = 
CAR(BgL_l1579z00_858); 
{ /* bmem/bmem.scm 351 */
obj_t BgL_arg2065z00_866;obj_t BgL_arg2066z00_867;
{ /* bmem/bmem.scm 351 */
long BgL_arg2069z00_870;
{ /* bmem/bmem.scm 351 */
long BgL_za72za7_1792;
{ /* bmem/bmem.scm 351 */
obj_t BgL_pairz00_1791;
if(
PAIRP(BgL_tz00_865))
{ /* bmem/bmem.scm 351 */
BgL_pairz00_1791 = BgL_tz00_865; }  else 
{ 
obj_t BgL_auxz00_5102;
BgL_auxz00_5102 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12562)), BGl_string3063z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_tz00_865); 
FAILURE(BgL_auxz00_5102,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 351 */
obj_t BgL_tmpz00_5106;
{ /* bmem/bmem.scm 351 */
obj_t BgL_aux2877z00_2390;
BgL_aux2877z00_2390 = 
CAR(BgL_pairz00_1791); 
if(
INTEGERP(BgL_aux2877z00_2390))
{ /* bmem/bmem.scm 351 */
BgL_tmpz00_5106 = BgL_aux2877z00_2390
; }  else 
{ 
obj_t BgL_auxz00_5110;
BgL_auxz00_5110 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12557)), BGl_string3063z00zzbmemz00, BGl_string3013z00zzbmemz00, BgL_aux2877z00_2390); 
FAILURE(BgL_auxz00_5110,BFALSE,BFALSE);} } 
BgL_za72za7_1792 = 
(long)CINT(BgL_tmpz00_5106); } } 
BgL_arg2069z00_870 = 
(((long)1)+BgL_za72za7_1792); } 
{ /* bmem/bmem.scm 351 */
obj_t BgL_list2070z00_871;
BgL_list2070z00_871 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2069z00_870), BNIL); 
BgL_arg2065z00_866 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3064z00zzbmemz00, BgL_list2070z00_871); } } 
{ /* bmem/bmem.scm 352 */
long BgL_arg2072z00_873;
{ /* bmem/bmem.scm 352 */
long BgL_za72za7_1795;
{ /* bmem/bmem.scm 352 */
obj_t BgL_pairz00_1794;
if(
PAIRP(BgL_tz00_865))
{ /* bmem/bmem.scm 352 */
BgL_pairz00_1794 = BgL_tz00_865; }  else 
{ 
obj_t BgL_auxz00_5121;
BgL_auxz00_5121 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12607)), BGl_string3063z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_tz00_865); 
FAILURE(BgL_auxz00_5121,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 352 */
obj_t BgL_tmpz00_5125;
{ /* bmem/bmem.scm 352 */
obj_t BgL_aux2881z00_2394;
BgL_aux2881z00_2394 = 
CAR(BgL_pairz00_1794); 
if(
INTEGERP(BgL_aux2881z00_2394))
{ /* bmem/bmem.scm 352 */
BgL_tmpz00_5125 = BgL_aux2881z00_2394
; }  else 
{ 
obj_t BgL_auxz00_5129;
BgL_auxz00_5129 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12602)), BGl_string3063z00zzbmemz00, BGl_string3013z00zzbmemz00, BgL_aux2881z00_2394); 
FAILURE(BgL_auxz00_5129,BFALSE,BFALSE);} } 
BgL_za72za7_1795 = 
(long)CINT(BgL_tmpz00_5125); } } 
BgL_arg2072z00_873 = 
(((long)1)+BgL_za72za7_1795); } 
{ /* bmem/bmem.scm 352 */
obj_t BgL_list2073z00_874;
BgL_list2073z00_874 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2072z00_873), BNIL); 
BgL_arg2066z00_867 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3065z00zzbmemz00, BgL_list2073z00_874); } } 
{ /* bmem/bmem.scm 351 */
obj_t BgL_list2067z00_868;
{ /* bmem/bmem.scm 351 */
obj_t BgL_arg2068z00_869;
BgL_arg2068z00_869 = 
MAKE_YOUNG_PAIR(BgL_arg2066z00_867, BNIL); 
BgL_list2067z00_868 = 
MAKE_YOUNG_PAIR(BgL_arg2065z00_866, BgL_arg2068z00_869); } 
BgL_arg2064z00_864 = BgL_list2067z00_868; } } } 
{ /* bmem/bmem.scm 350 */
obj_t BgL_res2534z00_1798;
BgL_res2534z00_1798 = 
MAKE_YOUNG_PAIR(BgL_arg2064z00_864, BNIL); 
BgL_newtail1583z00_862 = BgL_res2534z00_1798; } } 
SET_CDR(BgL_tail1582z00_859, BgL_newtail1583z00_862); 
{ 
obj_t BgL_tail1582z00_5144;obj_t BgL_l1579z00_5142;
BgL_l1579z00_5142 = 
CDR(BgL_l1579z00_858); 
BgL_tail1582z00_5144 = BgL_newtail1583z00_862; 
BgL_tail1582z00_859 = BgL_tail1582z00_5144; 
BgL_l1579z00_858 = BgL_l1579z00_5142; 
goto BgL_zc3z04anonymousza32061za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3350z04ze3z51_860;} }  else 
{ /* bmem/bmem.scm 350 */
if(
NULLP(BgL_l1579z00_858))
{ /* bmem/bmem.scm 350 */
BgL_arg2059z00_853 = 
CDR(BgL_head1581z00_856); }  else 
{ /* bmem/bmem.scm 350 */
BgL_arg2059z00_853 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string3056z00zzbmemz00, BGl_string3016z00zzbmemz00, BgL_l1579z00_858, BGl_string2954z00zzbmemz00, 
BINT(((long)12507))); } } } } } 
{ /* bmem/bmem.scm 348 */
obj_t BgL_auxz00_5150;
{ /* bmem/bmem.scm 353 */
bool_t BgL_test3590z00_5152;
if(
PAIRP(BgL_arg2059z00_853))
{ /* bmem/bmem.scm 353 */
BgL_test3590z00_5152 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 353 */
BgL_test3590z00_5152 = 
NULLP(BgL_arg2059z00_853)
; } 
if(BgL_test3590z00_5152)
{ /* bmem/bmem.scm 353 */
BgL_auxz00_5150 = BgL_arg2059z00_853
; }  else 
{ 
obj_t BgL_auxz00_5156;
BgL_auxz00_5156 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12634)), BGl_string3034z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_arg2059z00_853); 
FAILURE(BgL_auxz00_5156,BFALSE,BFALSE);} } 
BgL_arg1986z00_705 = 
BGl_htmlzd2legendzd2zzbmem_toolsz00(
(int)(((long)1)), BGl_string3057z00zzbmemz00, BgL_auxz00_5150, BGl_string3066z00zzbmemz00, BGl_string3067z00zzbmemz00); } } 
{ /* bmem/bmem.scm 311 */
obj_t BgL_list1987z00_706;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1988z00_707;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1989z00_708;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1990z00_709;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1991z00_710;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1992z00_711;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1993z00_712;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1994z00_713;
{ /* bmem/bmem.scm 311 */
obj_t BgL_arg1995z00_714;
BgL_arg1995z00_714 = 
MAKE_YOUNG_PAIR(BgL_arg1986z00_705, BNIL); 
BgL_arg1994z00_713 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1985z00_704), BgL_arg1995z00_714); } 
BgL_arg1993z00_712 = 
MAKE_YOUNG_PAIR(BgL_arg1984z00_703, BgL_arg1994z00_713); } 
BgL_arg1992z00_711 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1983z00_702), BgL_arg1993z00_712); } 
BgL_arg1991z00_710 = 
MAKE_YOUNG_PAIR(BgL_arg1982z00_701, BgL_arg1992z00_711); } 
BgL_arg1990z00_709 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1981z00_700), BgL_arg1991z00_710); } 
BgL_arg1989z00_708 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1980z00_699), BgL_arg1990z00_709); } 
BgL_arg1988z00_707 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1979z00_698), BgL_arg1989z00_708); } 
BgL_list1987z00_706 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1978z00_697), BgL_arg1988z00_707); } 
BgL_marginz00_513 = BgL_list1987z00_706; } } 
{ /* bmem/bmem.scm 311 */
obj_t BgL_titlez00_514;
if(
PAIRP(BgL_infoz00_12))
{ /* bmem/bmem.scm 356 */
obj_t BgL_cz00_694;
{ /* bmem/bmem.scm 356 */
obj_t BgL_auxz00_5178;
{ /* bmem/bmem.scm 356 */
obj_t BgL_aux2885z00_2398;
BgL_aux2885z00_2398 = 
CDR(BgL_infoz00_12); 
{ /* bmem/bmem.scm 356 */
bool_t BgL_test3593z00_5181;
if(
PAIRP(BgL_aux2885z00_2398))
{ /* bmem/bmem.scm 356 */
BgL_test3593z00_5181 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 356 */
BgL_test3593z00_5181 = 
NULLP(BgL_aux2885z00_2398)
; } 
if(BgL_test3593z00_5181)
{ /* bmem/bmem.scm 356 */
BgL_auxz00_5178 = BgL_aux2885z00_2398
; }  else 
{ 
obj_t BgL_auxz00_5185;
BgL_auxz00_5185 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12716)), BGl_string3034z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_aux2885z00_2398); 
FAILURE(BgL_auxz00_5185,BFALSE,BFALSE);} } } 
BgL_cz00_694 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
CNST_TABLE_REF(((long)64)), BgL_auxz00_5178); } 
if(
PAIRP(BgL_cz00_694))
{ /* bmem/bmem.scm 358 */
obj_t BgL_pairz00_1810;
{ /* bmem/bmem.scm 358 */
obj_t BgL_aux2887z00_2400;
BgL_aux2887z00_2400 = 
CDR(BgL_cz00_694); 
if(
PAIRP(BgL_aux2887z00_2400))
{ /* bmem/bmem.scm 358 */
BgL_pairz00_1810 = BgL_aux2887z00_2400; }  else 
{ 
obj_t BgL_auxz00_5195;
BgL_auxz00_5195 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12754)), BGl_string3034z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2887z00_2400); 
FAILURE(BgL_auxz00_5195,BFALSE,BFALSE);} } 
BgL_titlez00_514 = 
CAR(BgL_pairz00_1810); }  else 
{ /* bmem/bmem.scm 357 */
BgL_titlez00_514 = BGl_string2952z00zzbmemz00; } }  else 
{ /* bmem/bmem.scm 355 */
BgL_titlez00_514 = BGl_string2952z00zzbmemz00; } 
{ /* bmem/bmem.scm 355 */
obj_t BgL_pagez00_515;
{ /* bmem/bmem.scm 361 */
BgL_z52htmlzd2headingz80_bglt BgL_arg1930z00_596;obj_t BgL_arg1931z00_597;BgL_z52htmlzd2brz80_bglt BgL_arg1932z00_598;BgL_z52htmlzd2headingz80_bglt BgL_arg1933z00_599;BgL_z52htmlzd2az80_bglt BgL_arg1934z00_600;BgL_z52htmlzd2brz80_bglt BgL_arg1935z00_601;BgL_z52htmlzd2headingz80_bglt BgL_arg1936z00_602;BgL_z52htmlzd2az80_bglt BgL_arg1937z00_603;BgL_z52htmlzd2brz80_bglt BgL_arg1938z00_604;BgL_z52htmlzd2headingz80_bglt BgL_arg1939z00_605;BgL_z52htmlzd2az80_bglt BgL_arg1940z00_606;BgL_z52htmlzd2brz80_bglt BgL_arg1941z00_607;BgL_z52htmlzd2headingz80_bglt BgL_arg1942z00_608;BgL_z52htmlzd2az80_bglt BgL_arg1943z00_609;
{ /* bmem/bmem.scm 361 */
BgL_z52htmlzd2headingz80_bglt BgL_new1394z00_628;
{ /* bmem/bmem.scm 361 */
obj_t BgL_env1392z00_629;
BgL_env1392z00_629 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 361 */

{ 
long BgL_auxz00_5201;
{ /* bmem/bmem.scm 361 */
long BgL_res2540z00_1813;
{ /* bmem/bmem.scm 361 */
obj_t BgL_classz00_1812;
BgL_classz00_1812 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_res2540z00_1813 = 
BGL_CLASS_INDEX(BgL_classz00_1812); } 
BgL_auxz00_5201 = BgL_res2540z00_1813; } 
bmem_set_allocation_type( BgL_auxz00_5201, 0 ); } 
{ /* bmem/bmem.scm 361 */
BgL_z52htmlzd2headingz80_bglt BgL_new1391z00_631;
BgL_new1391z00_631 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 361 */
long BgL_arg1962z00_632;
{ /* bmem/bmem.scm 361 */
long BgL_res2541z00_1815;
BgL_res2541z00_1815 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BgL_arg1962z00_632 = BgL_res2541z00_1815; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1391z00_631), BgL_arg1962z00_632); } 
BgL_new1394z00_628 = BgL_new1391z00_631; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1394z00_628)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1394z00_628)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1394z00_628)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1394z00_628)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1394z00_628))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1394z00_628))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1394z00_628))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)65))),BUNSPEC); 
BgL_arg1930z00_596 = BgL_new1394z00_628; } 
{ /* bmem/bmem.scm 362 */
obj_t BgL_auxz00_5221;
{ /* bmem/bmem.scm 362 */
bool_t BgL_test3597z00_5222;
if(
PAIRP(BgL_gcmonz00_13))
{ /* bmem/bmem.scm 362 */
BgL_test3597z00_5222 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 362 */
BgL_test3597z00_5222 = 
NULLP(BgL_gcmonz00_13)
; } 
if(BgL_test3597z00_5222)
{ /* bmem/bmem.scm 362 */
BgL_auxz00_5221 = BgL_gcmonz00_13
; }  else 
{ 
obj_t BgL_auxz00_5226;
BgL_auxz00_5226 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12862)), BGl_string3034z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_gcmonz00_13); 
FAILURE(BgL_auxz00_5226,BFALSE,BFALSE);} } 
BgL_arg1931z00_597 = 
BGl_makezd2gczd2summaryz00zzbmem_gcz00(BgL_auxz00_5221); } 
{ /* bmem/bmem.scm 363 */
BgL_z52htmlzd2brz80_bglt BgL_new1398z00_633;
{ /* bmem/bmem.scm 363 */
obj_t BgL_env1396z00_634;
BgL_env1396z00_634 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 363 */

{ 
long BgL_auxz00_5232;
{ /* bmem/bmem.scm 363 */
long BgL_res2543z00_1820;
{ /* bmem/bmem.scm 363 */
obj_t BgL_classz00_1819;
BgL_classz00_1819 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_res2543z00_1820 = 
BGL_CLASS_INDEX(BgL_classz00_1819); } 
BgL_auxz00_5232 = BgL_res2543z00_1820; } 
bmem_set_allocation_type( BgL_auxz00_5232, 0 ); } 
{ /* bmem/bmem.scm 363 */
BgL_z52htmlzd2brz80_bglt BgL_new1395z00_636;
BgL_new1395z00_636 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 363 */
long BgL_arg1963z00_637;
{ /* bmem/bmem.scm 363 */
long BgL_res2544z00_1822;
BgL_res2544z00_1822 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BgL_arg1963z00_637 = BgL_res2544z00_1822; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1395z00_636), BgL_arg1963z00_637); } 
BgL_new1398z00_633 = BgL_new1395z00_636; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1398z00_633)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1398z00_633)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1398z00_633)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1398z00_633)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1932z00_598 = BgL_new1398z00_633; } 
{ /* bmem/bmem.scm 364 */
BgL_z52htmlzd2headingz80_bglt BgL_new1402z00_638;
{ /* bmem/bmem.scm 364 */
obj_t BgL_env1400z00_639;
BgL_env1400z00_639 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 364 */

{ 
long BgL_auxz00_5248;
{ /* bmem/bmem.scm 364 */
long BgL_res2546z00_1827;
{ /* bmem/bmem.scm 364 */
obj_t BgL_classz00_1826;
BgL_classz00_1826 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_res2546z00_1827 = 
BGL_CLASS_INDEX(BgL_classz00_1826); } 
BgL_auxz00_5248 = BgL_res2546z00_1827; } 
bmem_set_allocation_type( BgL_auxz00_5248, 0 ); } 
{ /* bmem/bmem.scm 364 */
BgL_z52htmlzd2headingz80_bglt BgL_new1399z00_641;
BgL_new1399z00_641 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 364 */
long BgL_arg1964z00_642;
{ /* bmem/bmem.scm 364 */
long BgL_res2547z00_1829;
BgL_res2547z00_1829 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BgL_arg1964z00_642 = BgL_res2547z00_1829; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1399z00_641), BgL_arg1964z00_642); } 
BgL_new1402z00_638 = BgL_new1399z00_641; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1402z00_638)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1402z00_638)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1402z00_638)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1402z00_638)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1402z00_638))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1402z00_638))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1402z00_638))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)66))),BUNSPEC); 
BgL_arg1933z00_599 = BgL_new1402z00_638; } 
{ /* bmem/bmem.scm 364 */
BgL_z52htmlzd2az80_bglt BgL_new1406z00_643;
{ /* bmem/bmem.scm 364 */
obj_t BgL_env1404z00_644;
BgL_env1404z00_644 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 364 */

{ 
long BgL_auxz00_5269;
{ /* bmem/bmem.scm 364 */
long BgL_res2549z00_1834;
{ /* bmem/bmem.scm 364 */
obj_t BgL_classz00_1833;
BgL_classz00_1833 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2549z00_1834 = 
BGL_CLASS_INDEX(BgL_classz00_1833); } 
BgL_auxz00_5269 = BgL_res2549z00_1834; } 
bmem_set_allocation_type( BgL_auxz00_5269, 0 ); } 
{ /* bmem/bmem.scm 364 */
BgL_z52htmlzd2az80_bglt BgL_new1403z00_646;
BgL_new1403z00_646 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 364 */
long BgL_arg1965z00_647;
{ /* bmem/bmem.scm 364 */
long BgL_res2550z00_1836;
BgL_res2550z00_1836 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BgL_arg1965z00_647 = BgL_res2550z00_1836; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1403z00_646), BgL_arg1965z00_647); } 
BgL_new1406z00_643 = BgL_new1403z00_646; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1406z00_643)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1406z00_643)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1406z00_643)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1406z00_643)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1406z00_643))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1406z00_643))->BgL_hrefz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1406z00_643))->BgL_namez00)=((obj_t)BGl_string3068z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1406z00_643))->BgL_inlineza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1934z00_600 = BgL_new1406z00_643; } 
{ /* bmem/bmem.scm 365 */
BgL_z52htmlzd2brz80_bglt BgL_new1410z00_648;
{ /* bmem/bmem.scm 365 */
obj_t BgL_env1408z00_649;
BgL_env1408z00_649 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 365 */

{ 
long BgL_auxz00_5289;
{ /* bmem/bmem.scm 365 */
long BgL_res2552z00_1841;
{ /* bmem/bmem.scm 365 */
obj_t BgL_classz00_1840;
BgL_classz00_1840 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_res2552z00_1841 = 
BGL_CLASS_INDEX(BgL_classz00_1840); } 
BgL_auxz00_5289 = BgL_res2552z00_1841; } 
bmem_set_allocation_type( BgL_auxz00_5289, 0 ); } 
{ /* bmem/bmem.scm 365 */
BgL_z52htmlzd2brz80_bglt BgL_new1407z00_651;
BgL_new1407z00_651 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 365 */
long BgL_arg1966z00_652;
{ /* bmem/bmem.scm 365 */
long BgL_res2553z00_1843;
BgL_res2553z00_1843 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BgL_arg1966z00_652 = BgL_res2553z00_1843; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1407z00_651), BgL_arg1966z00_652); } 
BgL_new1410z00_648 = BgL_new1407z00_651; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1410z00_648)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1410z00_648)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1410z00_648)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1410z00_648)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1935z00_601 = BgL_new1410z00_648; } 
{ /* bmem/bmem.scm 366 */
BgL_z52htmlzd2headingz80_bglt BgL_new1414z00_653;
{ /* bmem/bmem.scm 366 */
obj_t BgL_env1412z00_654;
BgL_env1412z00_654 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 366 */

{ 
long BgL_auxz00_5305;
{ /* bmem/bmem.scm 366 */
long BgL_res2555z00_1848;
{ /* bmem/bmem.scm 366 */
obj_t BgL_classz00_1847;
BgL_classz00_1847 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_res2555z00_1848 = 
BGL_CLASS_INDEX(BgL_classz00_1847); } 
BgL_auxz00_5305 = BgL_res2555z00_1848; } 
bmem_set_allocation_type( BgL_auxz00_5305, 0 ); } 
{ /* bmem/bmem.scm 366 */
BgL_z52htmlzd2headingz80_bglt BgL_new1411z00_656;
BgL_new1411z00_656 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 366 */
long BgL_arg1967z00_657;
{ /* bmem/bmem.scm 366 */
long BgL_res2556z00_1850;
BgL_res2556z00_1850 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BgL_arg1967z00_657 = BgL_res2556z00_1850; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1411z00_656), BgL_arg1967z00_657); } 
BgL_new1414z00_653 = BgL_new1411z00_656; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1414z00_653)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1414z00_653)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1414z00_653)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1414z00_653)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1414z00_653))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1414z00_653))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1414z00_653))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)67))),BUNSPEC); 
BgL_arg1936z00_602 = BgL_new1414z00_653; } 
{ /* bmem/bmem.scm 366 */
BgL_z52htmlzd2az80_bglt BgL_new1418z00_658;
{ /* bmem/bmem.scm 366 */
obj_t BgL_env1416z00_659;
BgL_env1416z00_659 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 366 */

{ 
long BgL_auxz00_5326;
{ /* bmem/bmem.scm 366 */
long BgL_res2558z00_1855;
{ /* bmem/bmem.scm 366 */
obj_t BgL_classz00_1854;
BgL_classz00_1854 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2558z00_1855 = 
BGL_CLASS_INDEX(BgL_classz00_1854); } 
BgL_auxz00_5326 = BgL_res2558z00_1855; } 
bmem_set_allocation_type( BgL_auxz00_5326, 0 ); } 
{ /* bmem/bmem.scm 366 */
BgL_z52htmlzd2az80_bglt BgL_new1415z00_661;
BgL_new1415z00_661 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 366 */
long BgL_arg1968z00_662;
{ /* bmem/bmem.scm 366 */
long BgL_res2559z00_1857;
BgL_res2559z00_1857 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BgL_arg1968z00_662 = BgL_res2559z00_1857; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1415z00_661), BgL_arg1968z00_662); } 
BgL_new1418z00_658 = BgL_new1415z00_661; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1418z00_658)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1418z00_658)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1418z00_658)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1418z00_658)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1418z00_658))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1418z00_658))->BgL_hrefz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1418z00_658))->BgL_namez00)=((obj_t)BGl_string3069z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1418z00_658))->BgL_inlineza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1937z00_603 = BgL_new1418z00_658; } 
{ /* bmem/bmem.scm 367 */
BgL_z52htmlzd2brz80_bglt BgL_new1422z00_663;
{ /* bmem/bmem.scm 367 */
obj_t BgL_env1420z00_664;
BgL_env1420z00_664 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 367 */

{ 
long BgL_auxz00_5346;
{ /* bmem/bmem.scm 367 */
long BgL_res2561z00_1862;
{ /* bmem/bmem.scm 367 */
obj_t BgL_classz00_1861;
BgL_classz00_1861 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_res2561z00_1862 = 
BGL_CLASS_INDEX(BgL_classz00_1861); } 
BgL_auxz00_5346 = BgL_res2561z00_1862; } 
bmem_set_allocation_type( BgL_auxz00_5346, 0 ); } 
{ /* bmem/bmem.scm 367 */
BgL_z52htmlzd2brz80_bglt BgL_new1419z00_666;
BgL_new1419z00_666 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 367 */
long BgL_arg1969z00_667;
{ /* bmem/bmem.scm 367 */
long BgL_res2562z00_1864;
BgL_res2562z00_1864 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BgL_arg1969z00_667 = BgL_res2562z00_1864; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1419z00_666), BgL_arg1969z00_667); } 
BgL_new1422z00_663 = BgL_new1419z00_666; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1422z00_663)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1422z00_663)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1422z00_663)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1422z00_663)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1938z00_604 = BgL_new1422z00_663; } 
{ /* bmem/bmem.scm 368 */
BgL_z52htmlzd2headingz80_bglt BgL_new1426z00_668;
{ /* bmem/bmem.scm 368 */
obj_t BgL_env1424z00_669;
BgL_env1424z00_669 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 368 */

{ 
long BgL_auxz00_5362;
{ /* bmem/bmem.scm 368 */
long BgL_res2564z00_1869;
{ /* bmem/bmem.scm 368 */
obj_t BgL_classz00_1868;
BgL_classz00_1868 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_res2564z00_1869 = 
BGL_CLASS_INDEX(BgL_classz00_1868); } 
BgL_auxz00_5362 = BgL_res2564z00_1869; } 
bmem_set_allocation_type( BgL_auxz00_5362, 0 ); } 
{ /* bmem/bmem.scm 368 */
BgL_z52htmlzd2headingz80_bglt BgL_new1423z00_671;
BgL_new1423z00_671 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 368 */
long BgL_arg1970z00_672;
{ /* bmem/bmem.scm 368 */
long BgL_res2565z00_1871;
BgL_res2565z00_1871 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BgL_arg1970z00_672 = BgL_res2565z00_1871; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1423z00_671), BgL_arg1970z00_672); } 
BgL_new1426z00_668 = BgL_new1423z00_671; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1426z00_668)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1426z00_668)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1426z00_668)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1426z00_668)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1426z00_668))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1426z00_668))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1426z00_668))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)68))),BUNSPEC); 
BgL_arg1939z00_605 = BgL_new1426z00_668; } 
{ /* bmem/bmem.scm 368 */
BgL_z52htmlzd2az80_bglt BgL_new1430z00_673;
{ /* bmem/bmem.scm 368 */
obj_t BgL_env1428z00_674;
BgL_env1428z00_674 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 368 */

{ 
long BgL_auxz00_5383;
{ /* bmem/bmem.scm 368 */
long BgL_res2567z00_1876;
{ /* bmem/bmem.scm 368 */
obj_t BgL_classz00_1875;
BgL_classz00_1875 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2567z00_1876 = 
BGL_CLASS_INDEX(BgL_classz00_1875); } 
BgL_auxz00_5383 = BgL_res2567z00_1876; } 
bmem_set_allocation_type( BgL_auxz00_5383, 0 ); } 
{ /* bmem/bmem.scm 368 */
BgL_z52htmlzd2az80_bglt BgL_new1427z00_676;
BgL_new1427z00_676 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 368 */
long BgL_arg1971z00_677;
{ /* bmem/bmem.scm 368 */
long BgL_res2568z00_1878;
BgL_res2568z00_1878 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BgL_arg1971z00_677 = BgL_res2568z00_1878; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1427z00_676), BgL_arg1971z00_677); } 
BgL_new1430z00_673 = BgL_new1427z00_676; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1430z00_673)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1430z00_673)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1430z00_673)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1430z00_673)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1430z00_673))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1430z00_673))->BgL_hrefz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1430z00_673))->BgL_namez00)=((obj_t)BGl_string3070z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1430z00_673))->BgL_inlineza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1940z00_606 = BgL_new1430z00_673; } 
{ /* bmem/bmem.scm 369 */
BgL_z52htmlzd2brz80_bglt BgL_new1434z00_678;
{ /* bmem/bmem.scm 369 */
obj_t BgL_env1432z00_679;
BgL_env1432z00_679 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 369 */

{ 
long BgL_auxz00_5403;
{ /* bmem/bmem.scm 369 */
long BgL_res2570z00_1883;
{ /* bmem/bmem.scm 369 */
obj_t BgL_classz00_1882;
BgL_classz00_1882 = BGl_z52htmlzd2brz80zzhtmlz00; 
BgL_res2570z00_1883 = 
BGL_CLASS_INDEX(BgL_classz00_1882); } 
BgL_auxz00_5403 = BgL_res2570z00_1883; } 
bmem_set_allocation_type( BgL_auxz00_5403, 0 ); } 
{ /* bmem/bmem.scm 369 */
BgL_z52htmlzd2brz80_bglt BgL_new1431z00_681;
BgL_new1431z00_681 = 
((BgL_z52htmlzd2brz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2brz80_bgl) ))); 
{ /* bmem/bmem.scm 369 */
long BgL_arg1972z00_682;
{ /* bmem/bmem.scm 369 */
long BgL_res2571z00_1885;
BgL_res2571z00_1885 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2brz80zzhtmlz00); 
BgL_arg1972z00_682 = BgL_res2571z00_1885; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1431z00_681), BgL_arg1972z00_682); } 
BgL_new1434z00_678 = BgL_new1431z00_681; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1434z00_678)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1434z00_678)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1434z00_678)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1434z00_678)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1941z00_607 = BgL_new1434z00_678; } 
{ /* bmem/bmem.scm 370 */
BgL_z52htmlzd2headingz80_bglt BgL_new1438z00_683;
{ /* bmem/bmem.scm 370 */
obj_t BgL_env1436z00_684;
BgL_env1436z00_684 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 370 */

{ 
long BgL_auxz00_5419;
{ /* bmem/bmem.scm 370 */
long BgL_res2573z00_1890;
{ /* bmem/bmem.scm 370 */
obj_t BgL_classz00_1889;
BgL_classz00_1889 = BGl_z52htmlzd2headingz80zzhtmlz00; 
BgL_res2573z00_1890 = 
BGL_CLASS_INDEX(BgL_classz00_1889); } 
BgL_auxz00_5419 = BgL_res2573z00_1890; } 
bmem_set_allocation_type( BgL_auxz00_5419, 0 ); } 
{ /* bmem/bmem.scm 370 */
BgL_z52htmlzd2headingz80_bglt BgL_new1435z00_686;
BgL_new1435z00_686 = 
((BgL_z52htmlzd2headingz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2headingz80_bgl) ))); 
{ /* bmem/bmem.scm 370 */
long BgL_arg1973z00_687;
{ /* bmem/bmem.scm 370 */
long BgL_res2574z00_1892;
BgL_res2574z00_1892 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2headingz80zzhtmlz00); 
BgL_arg1973z00_687 = BgL_res2574z00_1892; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1435z00_686), BgL_arg1973z00_687); } 
BgL_new1438z00_683 = BgL_new1435z00_686; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1438z00_683)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1438z00_683)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1438z00_683)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1438z00_683)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1438z00_683))->BgL_levelz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1438z00_683))->BgL_alignmentz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2headingz80_bglt)COBJECT(BgL_new1438z00_683))->BgL_inlineza2za2)=((obj_t)
CNST_TABLE_REF(((long)69))),BUNSPEC); 
BgL_arg1942z00_608 = BgL_new1438z00_683; } 
{ /* bmem/bmem.scm 370 */
BgL_z52htmlzd2az80_bglt BgL_new1442z00_688;
{ /* bmem/bmem.scm 370 */
obj_t BgL_env1440z00_689;
BgL_env1440z00_689 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 370 */

{ 
long BgL_auxz00_5440;
{ /* bmem/bmem.scm 370 */
long BgL_res2576z00_1897;
{ /* bmem/bmem.scm 370 */
obj_t BgL_classz00_1896;
BgL_classz00_1896 = BGl_z52htmlzd2az80zzhtmlz00; 
BgL_res2576z00_1897 = 
BGL_CLASS_INDEX(BgL_classz00_1896); } 
BgL_auxz00_5440 = BgL_res2576z00_1897; } 
bmem_set_allocation_type( BgL_auxz00_5440, 0 ); } 
{ /* bmem/bmem.scm 370 */
BgL_z52htmlzd2az80_bglt BgL_new1439z00_691;
BgL_new1439z00_691 = 
((BgL_z52htmlzd2az80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2az80_bgl) ))); 
{ /* bmem/bmem.scm 370 */
long BgL_arg1974z00_692;
{ /* bmem/bmem.scm 370 */
long BgL_res2577z00_1899;
BgL_res2577z00_1899 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2az80zzhtmlz00); 
BgL_arg1974z00_692 = BgL_res2577z00_1899; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1439z00_691), BgL_arg1974z00_692); } 
BgL_new1442z00_688 = BgL_new1439z00_691; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1442z00_688)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1442z00_688)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1442z00_688)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1442z00_688)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1442z00_688))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1442z00_688))->BgL_hrefz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1442z00_688))->BgL_namez00)=((obj_t)BGl_string3071z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2az80_bglt)COBJECT(BgL_new1442z00_688))->BgL_inlineza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1943z00_609 = BgL_new1442z00_688; } 
{ /* bmem/bmem.scm 361 */
obj_t BgL_list1944z00_610;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1945z00_611;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1946z00_612;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1947z00_613;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1948z00_614;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1949z00_615;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1950z00_616;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1951z00_617;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1952z00_618;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1953z00_619;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1954z00_620;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1955z00_621;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1956z00_622;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1957z00_623;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1958z00_624;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1959z00_625;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1960z00_626;
{ /* bmem/bmem.scm 361 */
obj_t BgL_arg1961z00_627;
BgL_arg1961z00_627 = 
MAKE_YOUNG_PAIR(BgL_gctablez00_508, BNIL); 
BgL_arg1960z00_626 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1943z00_609), BgL_arg1961z00_627); } 
BgL_arg1959z00_625 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1942z00_608), BgL_arg1960z00_626); } 
BgL_arg1958z00_624 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1941z00_607), BgL_arg1959z00_625); } 
BgL_arg1957z00_623 = 
MAKE_YOUNG_PAIR(BgL_threadtablez00_511, BgL_arg1958z00_624); } 
BgL_arg1956z00_622 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1940z00_606), BgL_arg1957z00_623); } 
BgL_arg1955z00_621 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1939z00_605), BgL_arg1956z00_622); } 
BgL_arg1954z00_620 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1938z00_604), BgL_arg1955z00_621); } 
BgL_arg1953z00_619 = 
MAKE_YOUNG_PAIR(BgL_typetablez00_510, BgL_arg1954z00_620); } 
BgL_arg1952z00_618 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1937z00_603), BgL_arg1953z00_619); } 
BgL_arg1951z00_617 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1936z00_602), BgL_arg1952z00_618); } 
BgL_arg1950z00_616 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1935z00_601), BgL_arg1951z00_617); } 
BgL_arg1949z00_615 = 
MAKE_YOUNG_PAIR(BgL_funtablez00_509, BgL_arg1950z00_616); } 
BgL_arg1948z00_614 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1934z00_600), BgL_arg1949z00_615); } 
BgL_arg1947z00_613 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1933z00_599), BgL_arg1948z00_614); } 
BgL_arg1946z00_612 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1932z00_598), BgL_arg1947z00_613); } 
BgL_arg1945z00_611 = 
MAKE_YOUNG_PAIR(BgL_arg1931z00_597, BgL_arg1946z00_612); } 
BgL_list1944z00_610 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1930z00_596), BgL_arg1945z00_611); } 
BgL_pagez00_515 = BgL_list1944z00_610; } } 
{ /* bmem/bmem.scm 361 */

{ /* bmem/bmem.scm 372 */
BgL_z52htmlzd2documentz80_bglt BgL_new1446z00_516;
{ /* bmem/bmem.scm 372 */
obj_t BgL_env1444z00_592;
BgL_env1444z00_592 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 372 */

{ 
long BgL_auxz00_5491;
{ /* bmem/bmem.scm 372 */
long BgL_res2580z00_1905;
{ /* bmem/bmem.scm 372 */
obj_t BgL_classz00_1904;
BgL_classz00_1904 = BGl_z52htmlzd2documentz80zzhtmlz00; 
BgL_res2580z00_1905 = 
BGL_CLASS_INDEX(BgL_classz00_1904); } 
BgL_auxz00_5491 = BgL_res2580z00_1905; } 
bmem_set_allocation_type( BgL_auxz00_5491, 0 ); } 
{ /* bmem/bmem.scm 372 */
BgL_z52htmlzd2documentz80_bglt BgL_new1443z00_594;
BgL_new1443z00_594 = 
((BgL_z52htmlzd2documentz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2documentz80_bgl) ))); 
{ /* bmem/bmem.scm 372 */
long BgL_arg1929z00_595;
{ /* bmem/bmem.scm 372 */
long BgL_res2581z00_1907;
BgL_res2581z00_1907 = 
BGL_CLASS_INDEX(BGl_z52htmlzd2documentz80zzhtmlz00); 
BgL_arg1929z00_595 = BgL_res2581z00_1907; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1443z00_594), BgL_arg1929z00_595); } 
BgL_new1446z00_516 = BgL_new1443z00_594; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1446z00_516)))->BgL_idz00)=((obj_t)BGl_string3072z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1446z00_516)))->BgL_classz00)=((obj_t)BGl_string3073z00zzbmemz00),BUNSPEC); 
{ 
obj_t BgL_auxz00_5502;
{ /* bmem/bmem.scm 372 */
bool_t BgL_test3599z00_5504;
{ /* bmem/bmem.scm 372 */
bool_t BgL_res2586z00_1925;
{ /* bmem/bmem.scm 372 */
obj_t BgL_string1z00_1910;
if(
STRINGP(BgL_titlez00_514))
{ /* bmem/bmem.scm 372 */
BgL_string1z00_1910 = BgL_titlez00_514; }  else 
{ 
obj_t BgL_auxz00_5507;
BgL_auxz00_5507 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)13250)), BGl_string3034z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_titlez00_514); 
FAILURE(BgL_auxz00_5507,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 372 */
long BgL_l1z00_1912;
BgL_l1z00_1912 = 
STRING_LENGTH(BgL_string1z00_1910); 
if(
(BgL_l1z00_1912==
STRING_LENGTH(BGl_string2952z00zzbmemz00)))
{ /* bmem/bmem.scm 372 */
int BgL_arg1269z00_1915;
{ /* bmem/bmem.scm 372 */
char * BgL_auxz00_5517;char * BgL_tmpz00_5515;
BgL_auxz00_5517 = 
BSTRING_TO_STRING(BGl_string2952z00zzbmemz00); 
BgL_tmpz00_5515 = 
BSTRING_TO_STRING(BgL_string1z00_1910); 
BgL_arg1269z00_1915 = 
memcmp(BgL_tmpz00_5515, BgL_auxz00_5517, BgL_l1z00_1912); } 
BgL_res2586z00_1925 = 
(
(long)(BgL_arg1269z00_1915)==((long)0)); }  else 
{ /* bmem/bmem.scm 372 */
BgL_res2586z00_1925 = ((bool_t)0); } } } 
BgL_test3599z00_5504 = BgL_res2586z00_1925; } 
if(BgL_test3599z00_5504)
{ /* bmem/bmem.scm 372 */
BgL_auxz00_5502 = BGl_string2952z00zzbmemz00
; }  else 
{ /* bmem/bmem.scm 374 */
obj_t BgL_tmpz00_5522;
if(
STRINGP(BgL_titlez00_514))
{ /* bmem/bmem.scm 374 */
BgL_tmpz00_5522 = BgL_titlez00_514
; }  else 
{ 
obj_t BgL_auxz00_5525;
BgL_auxz00_5525 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)13283)), BGl_string3034z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_titlez00_514); 
FAILURE(BgL_auxz00_5525,BFALSE,BFALSE);} 
BgL_auxz00_5502 = 
string_append(BGl_string3074z00zzbmemz00, BgL_tmpz00_5522); } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1446z00_516)))->BgL_titlez00)=((obj_t)BgL_auxz00_5502),BUNSPEC); } 
{ 
obj_t BgL_auxz00_5531;
{ /* bmem/bmem.scm 375 */
obj_t BgL_list1895z00_518;
{ /* bmem/bmem.scm 375 */
obj_t BgL_arg1896z00_519;
BgL_arg1896z00_519 = 
MAKE_YOUNG_PAIR(BgL_dcssz00_512, BNIL); 
BgL_list1895z00_518 = 
MAKE_YOUNG_PAIR(BgL_cssz00_11, BgL_arg1896z00_519); } 
BgL_auxz00_5531 = BgL_list1895z00_518; } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1446z00_516)))->BgL_stylez00)=((obj_t)BgL_auxz00_5531),BUNSPEC); } 
((((BgL_z52htmlzd2documentz80_bglt)COBJECT(BgL_new1446z00_516))->BgL_attrza2za2)=((obj_t)BNIL),BUNSPEC); 
{ 
obj_t BgL_auxz00_5537;
{ /* bmem/bmem.scm 372 */
obj_t BgL_arg1897z00_520;
{ /* bmem/bmem.scm 372 */
obj_t BgL_arg1898z00_521;
{ /* bmem/bmem.scm 372 */
obj_t BgL_res2588z00_1928;
{ /* bmem/bmem.scm 372 */
obj_t BgL_classz00_1927;
BgL_classz00_1927 = BGl_z52htmlzd2documentz80zzhtmlz00; 
BgL_res2588z00_1928 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_1927); } 
BgL_arg1898z00_521 = BgL_res2588z00_1928; } 
BgL_arg1897z00_520 = 
VECTOR_REF(BgL_arg1898z00_521,((long)5)); } 
{ /* bmem/bmem.scm 372 */
obj_t BgL_auxz00_5540;
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_arg1897z00_520))
{ /* bmem/bmem.scm 372 */
BgL_auxz00_5540 = BgL_arg1897z00_520
; }  else 
{ 
obj_t BgL_auxz00_5543;
BgL_auxz00_5543 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)13214)), BGl_string3034z00zzbmemz00, BGl_string3075z00zzbmemz00, BgL_arg1897z00_520); 
FAILURE(BgL_auxz00_5543,BFALSE,BFALSE);} 
BgL_auxz00_5537 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_auxz00_5540); } } 
((((BgL_z52htmlzd2documentz80_bglt)COBJECT(BgL_new1446z00_516))->BgL_dtdz00)=((obj_t)BgL_auxz00_5537),BUNSPEC); } 
{ 
obj_t BgL_auxz00_5549;
{ /* bmem/bmem.scm 377 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1899z00_522;
{ /* bmem/bmem.scm 377 */
BgL_z52htmlzd2boxz80_bglt BgL_new1450z00_524;
{ /* bmem/bmem.scm 377 */
obj_t BgL_env1448z00_586;
{ /* bmem/bmem.scm 377 */
obj_t BgL_res2589z00_1930;
BgL_res2589z00_1930 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1448z00_586 = BgL_res2589z00_1930; } 
{ /* bmem/bmem.scm 377 */

{ 
long BgL_auxz00_5551;
{ /* bmem/bmem.scm 377 */
long BgL_res2590z00_1932;
{ /* bmem/bmem.scm 377 */
obj_t BgL_classz00_1931;
BgL_classz00_1931 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2590z00_1932 = 
BGL_CLASS_INDEX(BgL_classz00_1931); } 
BgL_auxz00_5551 = BgL_res2590z00_1932; } 
bmem_set_allocation_type( BgL_auxz00_5551, 0 ); } 
{ /* bmem/bmem.scm 377 */
BgL_z52htmlzd2boxz80_bglt BgL_new1447z00_588;
BgL_new1447z00_588 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/bmem.scm 377 */
long BgL_arg1926z00_589;
{ /* bmem/bmem.scm 377 */
long BgL_res2591z00_1934;
{ /* bmem/bmem.scm 377 */
obj_t BgL_classz00_1933;
BgL_classz00_1933 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2591z00_1934 = 
BGL_CLASS_INDEX(BgL_classz00_1933); } 
BgL_arg1926z00_589 = BgL_res2591z00_1934; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1447z00_588), BgL_arg1926z00_589); } 
BgL_new1450z00_524 = BgL_new1447z00_588; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1450z00_524)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1450z00_524)))->BgL_classz00)=((obj_t)BGl_string2952z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1450z00_524)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1450z00_524)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1450z00_524))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
{ 
obj_t BgL_auxz00_5568;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tablez80_bglt BgL_arg1901z00_525;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tablez80_bglt BgL_new1454z00_527;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1452z00_582;
{ /* bmem/bmem.scm 378 */
obj_t BgL_res2592z00_1937;
BgL_res2592z00_1937 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1452z00_582 = BgL_res2592z00_1937; } 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5570;
{ /* bmem/bmem.scm 378 */
long BgL_res2593z00_1939;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1938;
BgL_classz00_1938 = BGl_z52htmlzd2tablez80zzhtmlz00; 
BgL_res2593z00_1939 = 
BGL_CLASS_INDEX(BgL_classz00_1938); } 
BgL_auxz00_5570 = BgL_res2593z00_1939; } 
bmem_set_allocation_type( BgL_auxz00_5570, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tablez80_bglt BgL_new1451z00_584;
BgL_new1451z00_584 = 
((BgL_z52htmlzd2tablez80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2tablez80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1925z00_585;
{ /* bmem/bmem.scm 378 */
long BgL_res2594z00_1941;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1940;
BgL_classz00_1940 = BGl_z52htmlzd2tablez80zzhtmlz00; 
BgL_res2594z00_1941 = 
BGL_CLASS_INDEX(BgL_classz00_1940); } 
BgL_arg1925z00_585 = BgL_res2594z00_1941; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1451z00_584), BgL_arg1925z00_585); } 
BgL_new1454z00_527 = BgL_new1451z00_584; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1454z00_527)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1454z00_527)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1454z00_527)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1454z00_527)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_captionz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5586;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_arg1903z00_528;BgL_z52htmlzd2colgroupz80_bglt BgL_arg1904z00_529;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_new1458z00_532;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1456z00_533;
{ /* bmem/bmem.scm 378 */
obj_t BgL_res2595z00_1944;
BgL_res2595z00_1944 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1456z00_533 = BgL_res2595z00_1944; } 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5588;
{ /* bmem/bmem.scm 378 */
long BgL_res2596z00_1946;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1945;
BgL_classz00_1945 = BGl_z52htmlzd2colgroupz80zzhtmlz00; 
BgL_res2596z00_1946 = 
BGL_CLASS_INDEX(BgL_classz00_1945); } 
BgL_auxz00_5588 = BgL_res2596z00_1946; } 
bmem_set_allocation_type( BgL_auxz00_5588, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_new1455z00_535;
BgL_new1455z00_535 = 
((BgL_z52htmlzd2colgroupz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2colgroupz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1907z00_536;
{ /* bmem/bmem.scm 378 */
long BgL_res2597z00_1948;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1947;
BgL_classz00_1947 = BGl_z52htmlzd2colgroupz80zzhtmlz00; 
BgL_res2597z00_1948 = 
BGL_CLASS_INDEX(BgL_classz00_1947); } 
BgL_arg1907z00_536 = BgL_res2597z00_1948; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1455z00_535), BgL_arg1907z00_536); } 
BgL_new1458z00_532 = BgL_new1455z00_535; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1458z00_532)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1458z00_532)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1458z00_532)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1458z00_532)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1458z00_532))->BgL_widthz00)=((obj_t)BGl_string3076z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1458z00_532))->BgL_spanz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1458z00_532))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1458z00_532))->BgL_valignz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1458z00_532))->BgL_charz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1458z00_532))->BgL_colza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1903z00_528 = BgL_new1458z00_532; } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_new1462z00_537;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1460z00_538;
{ /* bmem/bmem.scm 378 */
obj_t BgL_res2598z00_1951;
BgL_res2598z00_1951 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1460z00_538 = BgL_res2598z00_1951; } 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5610;
{ /* bmem/bmem.scm 378 */
long BgL_res2599z00_1953;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1952;
BgL_classz00_1952 = BGl_z52htmlzd2colgroupz80zzhtmlz00; 
BgL_res2599z00_1953 = 
BGL_CLASS_INDEX(BgL_classz00_1952); } 
BgL_auxz00_5610 = BgL_res2599z00_1953; } 
bmem_set_allocation_type( BgL_auxz00_5610, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2colgroupz80_bglt BgL_new1459z00_540;
BgL_new1459z00_540 = 
((BgL_z52htmlzd2colgroupz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2colgroupz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1908z00_541;
{ /* bmem/bmem.scm 378 */
long BgL_res2600z00_1955;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1954;
BgL_classz00_1954 = BGl_z52htmlzd2colgroupz80zzhtmlz00; 
BgL_res2600z00_1955 = 
BGL_CLASS_INDEX(BgL_classz00_1954); } 
BgL_arg1908z00_541 = BgL_res2600z00_1955; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1459z00_540), BgL_arg1908z00_541); } 
BgL_new1462z00_537 = BgL_new1459z00_540; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1462z00_537)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1462z00_537)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1462z00_537)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1462z00_537)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1462z00_537))->BgL_widthz00)=((obj_t)BGl_string3077z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1462z00_537))->BgL_spanz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1462z00_537))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1462z00_537))->BgL_valignz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1462z00_537))->BgL_charz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2colgroupz80_bglt)COBJECT(BgL_new1462z00_537))->BgL_colza2za2)=((obj_t)BNIL),BUNSPEC); 
BgL_arg1904z00_529 = BgL_new1462z00_537; } 
{ /* bmem/bmem.scm 378 */
obj_t BgL_list1905z00_530;
{ /* bmem/bmem.scm 378 */
obj_t BgL_arg1906z00_531;
BgL_arg1906z00_531 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1904z00_529), BNIL); 
BgL_list1905z00_530 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1903z00_528), BgL_arg1906z00_531); } 
BgL_auxz00_5586 = BgL_list1905z00_530; } } 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_colgroupzf3zf3)=((obj_t)BgL_auxz00_5586),BUNSPEC); } 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_tfootzf3zf3)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_theadzf3zf3)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_widthz00)=((obj_t)BGl_string3078z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_borderz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_framez00)=((obj_t)BGl_string3079z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_rulesz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_cellspacingz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_cellpaddingz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5644;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2trz80_bglt BgL_arg1909z00_542;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2trz80_bglt BgL_new1466z00_544;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1464z00_578;
{ /* bmem/bmem.scm 378 */
obj_t BgL_res2602z00_1959;
BgL_res2602z00_1959 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1464z00_578 = BgL_res2602z00_1959; } 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5646;
{ /* bmem/bmem.scm 378 */
long BgL_res2603z00_1961;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1960;
BgL_classz00_1960 = BGl_z52htmlzd2trz80zzhtmlz00; 
BgL_res2603z00_1961 = 
BGL_CLASS_INDEX(BgL_classz00_1960); } 
BgL_auxz00_5646 = BgL_res2603z00_1961; } 
bmem_set_allocation_type( BgL_auxz00_5646, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2trz80_bglt BgL_new1463z00_580;
BgL_new1463z00_580 = 
((BgL_z52htmlzd2trz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2trz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1924z00_581;
{ /* bmem/bmem.scm 378 */
long BgL_res2604z00_1963;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1962;
BgL_classz00_1962 = BGl_z52htmlzd2trz80zzhtmlz00; 
BgL_res2604z00_1963 = 
BGL_CLASS_INDEX(BgL_classz00_1962); } 
BgL_arg1924z00_581 = BgL_res2604z00_1963; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1463z00_580), BgL_arg1924z00_581); } 
BgL_new1466z00_544 = BgL_new1463z00_580; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1466z00_544)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1466z00_544)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1466z00_544)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1466z00_544)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5661;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_arg1911z00_545;BgL_z52htmlzd2tcellz80_bglt BgL_arg1912z00_546;
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_new1470z00_549;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1468z00_555;
{ /* bmem/bmem.scm 378 */
obj_t BgL_res2605z00_1966;
BgL_res2605z00_1966 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1468z00_555 = BgL_res2605z00_1966; } 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5663;
{ /* bmem/bmem.scm 378 */
long BgL_res2606z00_1968;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1967;
BgL_classz00_1967 = BGl_z52htmlzd2tcellz80zzhtmlz00; 
BgL_res2606z00_1968 = 
BGL_CLASS_INDEX(BgL_classz00_1967); } 
BgL_auxz00_5663 = BgL_res2606z00_1968; } 
bmem_set_allocation_type( BgL_auxz00_5663, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_new1467z00_557;
BgL_new1467z00_557 = 
((BgL_z52htmlzd2tcellz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2tcellz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1916z00_558;
{ /* bmem/bmem.scm 378 */
long BgL_res2607z00_1970;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1969;
BgL_classz00_1969 = BGl_z52htmlzd2tcellz80zzhtmlz00; 
BgL_res2607z00_1970 = 
BGL_CLASS_INDEX(BgL_classz00_1969); } 
BgL_arg1916z00_558 = BgL_res2607z00_1970; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1467z00_557), BgL_arg1916z00_558); } 
BgL_new1470z00_549 = BgL_new1467z00_557; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1470z00_549)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1470z00_549)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1470z00_549)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1470z00_549)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1470z00_549))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)70))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1470z00_549))->BgL_colspanz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1470z00_549))->BgL_rowspanz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1470z00_549))->BgL_alignz00)=((obj_t)BGl_string3080z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1470z00_549))->BgL_valignz00)=((obj_t)BGl_string3081z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1470z00_549))->BgL_charz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1470z00_549))->BgL_widthz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5688;
{ /* bmem/html.sch 105 */
BgL_z52htmlzd2boxz80_bglt BgL_new1474z00_550;
{ /* bmem/html.sch 105 */
obj_t BgL_env1472z00_551;
{ /* bmem/html.sch 105 */
obj_t BgL_res2608z00_1973;
BgL_res2608z00_1973 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1472z00_551 = BgL_res2608z00_1973; } 
{ /* bmem/html.sch 105 */

{ 
long BgL_auxz00_5690;
{ /* bmem/html.sch 105 */
long BgL_res2609z00_1975;
{ /* bmem/html.sch 105 */
obj_t BgL_classz00_1974;
BgL_classz00_1974 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2609z00_1975 = 
BGL_CLASS_INDEX(BgL_classz00_1974); } 
BgL_auxz00_5690 = BgL_res2609z00_1975; } 
bmem_set_allocation_type( BgL_auxz00_5690, 0 ); } 
{ /* bmem/html.sch 105 */
BgL_z52htmlzd2boxz80_bglt BgL_new1471z00_553;
BgL_new1471z00_553 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/html.sch 105 */
long BgL_arg1915z00_554;
{ /* bmem/html.sch 105 */
long BgL_res2610z00_1977;
{ /* bmem/html.sch 105 */
obj_t BgL_classz00_1976;
BgL_classz00_1976 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2610z00_1977 = 
BGL_CLASS_INDEX(BgL_classz00_1976); } 
BgL_arg1915z00_554 = BgL_res2610z00_1977; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1471z00_553), BgL_arg1915z00_554); } 
BgL_new1474z00_550 = BgL_new1471z00_553; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1474z00_550)))->BgL_idz00)=((obj_t)BGl_string3080z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1474z00_550)))->BgL_classz00)=((obj_t)BGl_string3082z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1474z00_550)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1474z00_550)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1474z00_550))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1474z00_550))->BgL_inlineza2za2)=((obj_t)BgL_marginz00_513),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1474z00_550))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_auxz00_5688 = 
((obj_t)BgL_new1474z00_550); } 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1470z00_549))->BgL_flowza2za2)=((obj_t)BgL_auxz00_5688),BUNSPEC); } 
BgL_arg1911z00_545 = BgL_new1470z00_549; } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_new1478z00_559;
{ /* bmem/bmem.scm 378 */
obj_t BgL_env1476z00_574;
{ /* bmem/bmem.scm 378 */
obj_t BgL_res2611z00_1980;
BgL_res2611z00_1980 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1476z00_574 = BgL_res2611z00_1980; } 
{ /* bmem/bmem.scm 378 */

{ 
long BgL_auxz00_5712;
{ /* bmem/bmem.scm 378 */
long BgL_res2612z00_1982;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1981;
BgL_classz00_1981 = BGl_z52htmlzd2tcellz80zzhtmlz00; 
BgL_res2612z00_1982 = 
BGL_CLASS_INDEX(BgL_classz00_1981); } 
BgL_auxz00_5712 = BgL_res2612z00_1982; } 
bmem_set_allocation_type( BgL_auxz00_5712, 0 ); } 
{ /* bmem/bmem.scm 378 */
BgL_z52htmlzd2tcellz80_bglt BgL_new1475z00_576;
BgL_new1475z00_576 = 
((BgL_z52htmlzd2tcellz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2tcellz80_bgl) ))); 
{ /* bmem/bmem.scm 378 */
long BgL_arg1923z00_577;
{ /* bmem/bmem.scm 378 */
long BgL_res2613z00_1984;
{ /* bmem/bmem.scm 378 */
obj_t BgL_classz00_1983;
BgL_classz00_1983 = BGl_z52htmlzd2tcellz80zzhtmlz00; 
BgL_res2613z00_1984 = 
BGL_CLASS_INDEX(BgL_classz00_1983); } 
BgL_arg1923z00_577 = BgL_res2613z00_1984; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1475z00_576), BgL_arg1923z00_577); } 
BgL_new1478z00_559 = BgL_new1475z00_576; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1478z00_559)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1478z00_559)))->BgL_classz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1478z00_559)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1478z00_559)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1478z00_559))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)70))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1478z00_559))->BgL_colspanz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1478z00_559))->BgL_rowspanz00)=((int)
(int)(((long)1))),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1478z00_559))->BgL_alignz00)=((obj_t)BGl_string3080z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1478z00_559))->BgL_valignz00)=((obj_t)BGl_string3081z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1478z00_559))->BgL_charz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1478z00_559))->BgL_widthz00)=((obj_t)BFALSE),BUNSPEC); 
{ 
obj_t BgL_auxz00_5737;
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_arg1917z00_560;BgL_z52htmlzd2boxz80_bglt BgL_arg1918z00_561;
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_new1482z00_564;
{ /* bmem/html.sch 133 */
obj_t BgL_env1480z00_565;
{ /* bmem/html.sch 133 */
obj_t BgL_res2614z00_1987;
BgL_res2614z00_1987 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1480z00_565 = BgL_res2614z00_1987; } 
{ /* bmem/html.sch 133 */

{ 
long BgL_auxz00_5739;
{ /* bmem/html.sch 133 */
long BgL_res2615z00_1989;
{ /* bmem/html.sch 133 */
obj_t BgL_classz00_1988;
BgL_classz00_1988 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2615z00_1989 = 
BGL_CLASS_INDEX(BgL_classz00_1988); } 
BgL_auxz00_5739 = BgL_res2615z00_1989; } 
bmem_set_allocation_type( BgL_auxz00_5739, 0 ); } 
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_new1479z00_567;
BgL_new1479z00_567 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/html.sch 133 */
long BgL_arg1921z00_568;
{ /* bmem/html.sch 133 */
long BgL_res2616z00_1991;
{ /* bmem/html.sch 133 */
obj_t BgL_classz00_1990;
BgL_classz00_1990 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2616z00_1991 = 
BGL_CLASS_INDEX(BgL_classz00_1990); } 
BgL_arg1921z00_568 = BgL_res2616z00_1991; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1479z00_567), BgL_arg1921z00_568); } 
BgL_new1482z00_564 = BgL_new1479z00_567; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1482z00_564)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1482z00_564)))->BgL_classz00)=((obj_t)BGl_string3083z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1482z00_564)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1482z00_564)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1482z00_564))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1482z00_564))->BgL_inlineza2za2)=((obj_t)BgL_titlez00_514),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1482z00_564))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1917z00_560 = BgL_new1482z00_564; } 
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_new1486z00_569;
{ /* bmem/html.sch 133 */
obj_t BgL_env1484z00_570;
{ /* bmem/html.sch 133 */
obj_t BgL_res2617z00_1994;
BgL_res2617z00_1994 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_env1484z00_570 = BgL_res2617z00_1994; } 
{ /* bmem/html.sch 133 */

{ 
long BgL_auxz00_5759;
{ /* bmem/html.sch 133 */
long BgL_res2618z00_1996;
{ /* bmem/html.sch 133 */
obj_t BgL_classz00_1995;
BgL_classz00_1995 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2618z00_1996 = 
BGL_CLASS_INDEX(BgL_classz00_1995); } 
BgL_auxz00_5759 = BgL_res2618z00_1996; } 
bmem_set_allocation_type( BgL_auxz00_5759, 0 ); } 
{ /* bmem/html.sch 133 */
BgL_z52htmlzd2boxz80_bglt BgL_new1483z00_572;
BgL_new1483z00_572 = 
((BgL_z52htmlzd2boxz80_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_z52htmlzd2boxz80_bgl) ))); 
{ /* bmem/html.sch 133 */
long BgL_arg1922z00_573;
{ /* bmem/html.sch 133 */
long BgL_res2619z00_1998;
{ /* bmem/html.sch 133 */
obj_t BgL_classz00_1997;
BgL_classz00_1997 = BGl_z52htmlzd2boxz80zzhtmlz00; 
BgL_res2619z00_1998 = 
BGL_CLASS_INDEX(BgL_classz00_1997); } 
BgL_arg1922z00_573 = BgL_res2619z00_1998; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1483z00_572), BgL_arg1922z00_573); } 
BgL_new1486z00_569 = BgL_new1483z00_572; } } } 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1486z00_569)))->BgL_idz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1486z00_569)))->BgL_classz00)=((obj_t)BGl_string3084z00zzbmemz00),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1486z00_569)))->BgL_titlez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2elementz80_bglt)COBJECT(
((BgL_z52htmlzd2elementz80_bglt)BgL_new1486z00_569)))->BgL_stylez00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1486z00_569))->BgL_kindz00)=((obj_t)
CNST_TABLE_REF(((long)17))),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1486z00_569))->BgL_inlineza2za2)=((obj_t)BgL_pagez00_515),BUNSPEC); 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1486z00_569))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1918z00_561 = BgL_new1486z00_569; } 
{ /* bmem/html.sch 133 */
obj_t BgL_list1919z00_562;
{ /* bmem/html.sch 133 */
obj_t BgL_arg1920z00_563;
BgL_arg1920z00_563 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1918z00_561), BNIL); 
BgL_list1919z00_562 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1917z00_560), BgL_arg1920z00_563); } 
BgL_auxz00_5737 = BgL_list1919z00_562; } } 
((((BgL_z52htmlzd2tcellz80_bglt)COBJECT(BgL_new1478z00_559))->BgL_flowza2za2)=((obj_t)BgL_auxz00_5737),BUNSPEC); } 
BgL_arg1912z00_546 = BgL_new1478z00_559; } 
{ /* bmem/bmem.scm 378 */
obj_t BgL_list1913z00_547;
{ /* bmem/bmem.scm 378 */
obj_t BgL_arg1914z00_548;
BgL_arg1914z00_548 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1912z00_546), BNIL); 
BgL_list1913z00_547 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1911z00_545), BgL_arg1914z00_548); } 
BgL_auxz00_5661 = BgL_list1913z00_547; } } 
((((BgL_z52htmlzd2trz80_bglt)COBJECT(BgL_new1466z00_544))->BgL_tcellzb2zb2)=((obj_t)BgL_auxz00_5661),BUNSPEC); } 
BgL_arg1909z00_542 = BgL_new1466z00_544; } 
{ /* bmem/bmem.scm 378 */
obj_t BgL_list1910z00_543;
BgL_list1910z00_543 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1909z00_542), BNIL); 
BgL_auxz00_5644 = BgL_list1910z00_543; } } 
((((BgL_z52htmlzd2tablez80_bglt)COBJECT(BgL_new1454z00_527))->BgL_tbodyzb2zb2)=((obj_t)BgL_auxz00_5644),BUNSPEC); } 
BgL_arg1901z00_525 = BgL_new1454z00_527; } 
{ /* bmem/bmem.scm 378 */
obj_t BgL_list1902z00_526;
BgL_list1902z00_526 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1901z00_525), BNIL); 
BgL_auxz00_5568 = BgL_list1902z00_526; } } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1450z00_524))->BgL_inlineza2za2)=((obj_t)BgL_auxz00_5568),BUNSPEC); } 
((((BgL_z52htmlzd2boxz80_bglt)COBJECT(BgL_new1450z00_524))->BgL_alignz00)=((obj_t)BFALSE),BUNSPEC); 
BgL_arg1899z00_522 = BgL_new1450z00_524; } 
{ /* bmem/bmem.scm 377 */
obj_t BgL_list1900z00_523;
BgL_list1900z00_523 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg1899z00_522), BNIL); 
BgL_auxz00_5549 = BgL_list1900z00_523; } } 
((((BgL_z52htmlzd2documentz80_bglt)COBJECT(BgL_new1446z00_516))->BgL_bodyz00)=((obj_t)BgL_auxz00_5549),BUNSPEC); } 
{ 
obj_t BgL_auxz00_5798;
{ /* bmem/bmem.scm 372 */
obj_t BgL_arg1927z00_590;
{ /* bmem/bmem.scm 372 */
obj_t BgL_arg1928z00_591;
{ /* bmem/bmem.scm 372 */
obj_t BgL_res2625z00_2007;
{ /* bmem/bmem.scm 372 */
obj_t BgL_classz00_2006;
BgL_classz00_2006 = BGl_z52htmlzd2documentz80zzhtmlz00; 
BgL_res2625z00_2007 = 
BGL_CLASS_ALL_FIELDS(BgL_classz00_2006); } 
BgL_arg1928z00_591 = BgL_res2625z00_2007; } 
BgL_arg1927z00_590 = 
VECTOR_REF(BgL_arg1928z00_591,((long)7)); } 
{ /* bmem/bmem.scm 372 */
obj_t BgL_auxz00_5801;
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_arg1927z00_590))
{ /* bmem/bmem.scm 372 */
BgL_auxz00_5801 = BgL_arg1927z00_590
; }  else 
{ 
obj_t BgL_auxz00_5804;
BgL_auxz00_5804 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)13214)), BGl_string3034z00zzbmemz00, BGl_string3075z00zzbmemz00, BgL_arg1927z00_590); 
FAILURE(BgL_auxz00_5804,BFALSE,BFALSE);} 
BgL_auxz00_5798 = 
BGl_classzd2fieldzd2defaultzd2valuezd2zz__objectz00(BgL_auxz00_5801); } } 
((((BgL_z52htmlzd2documentz80_bglt)COBJECT(BgL_new1446z00_516))->BgL_cssz00)=((obj_t)BgL_auxz00_5798),BUNSPEC); } 
BgL_aux2241z00_1092 = BgL_new1446z00_516; } } } } } } } } } } } 
BGL_ENV_POP_TRACE(BgL_env2244z00_1091); 
return BgL_aux2241z00_1092;} } } } 

}



/* &<@anonymous:2055:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:343@> */
obj_t BGl_z62zc3z04anonymousza32055za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3343z04ze3z33zzbmemz00(obj_t BgL_envz00_2137, obj_t BgL_t1z00_2138, obj_t BgL_t2z00_2139)
{
{ /* bmem/bmem.scm 344 */
{ /* bmem/bmem.scm 345 */
bool_t BgL_tmpz00_5811;
{ /* bmem/bmem.scm 345 */
obj_t BgL_string1z00_2757;obj_t BgL_string2z00_2758;
{ /* bmem/bmem.scm 345 */
obj_t BgL_pairz00_2759;
if(
PAIRP(BgL_t1z00_2138))
{ /* bmem/bmem.scm 345 */
BgL_pairz00_2759 = BgL_t1z00_2138; }  else 
{ 
obj_t BgL_auxz00_5814;
BgL_auxz00_5814 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12417)), BGl_string3085z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_t1z00_2138); 
FAILURE(BgL_auxz00_5814,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 345 */
obj_t BgL_pairz00_2760;
{ /* bmem/bmem.scm 345 */
obj_t BgL_aux2901z00_2761;
BgL_aux2901z00_2761 = 
CDR(BgL_pairz00_2759); 
if(
PAIRP(BgL_aux2901z00_2761))
{ /* bmem/bmem.scm 345 */
BgL_pairz00_2760 = BgL_aux2901z00_2761; }  else 
{ 
obj_t BgL_auxz00_5821;
BgL_auxz00_5821 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12411)), BGl_string3085z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2901z00_2761); 
FAILURE(BgL_auxz00_5821,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 345 */
obj_t BgL_aux2903z00_2762;
BgL_aux2903z00_2762 = 
CAR(BgL_pairz00_2760); 
if(
STRINGP(BgL_aux2903z00_2762))
{ /* bmem/bmem.scm 345 */
BgL_string1z00_2757 = BgL_aux2903z00_2762; }  else 
{ 
obj_t BgL_auxz00_5828;
BgL_auxz00_5828 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12411)), BGl_string3085z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_aux2903z00_2762); 
FAILURE(BgL_auxz00_5828,BFALSE,BFALSE);} } } } 
{ /* bmem/bmem.scm 345 */
obj_t BgL_pairz00_2763;
if(
PAIRP(BgL_t2z00_2139))
{ /* bmem/bmem.scm 345 */
BgL_pairz00_2763 = BgL_t2z00_2139; }  else 
{ 
obj_t BgL_auxz00_5834;
BgL_auxz00_5834 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12427)), BGl_string3085z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_t2z00_2139); 
FAILURE(BgL_auxz00_5834,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 345 */
obj_t BgL_pairz00_2764;
{ /* bmem/bmem.scm 345 */
obj_t BgL_aux2907z00_2765;
BgL_aux2907z00_2765 = 
CDR(BgL_pairz00_2763); 
if(
PAIRP(BgL_aux2907z00_2765))
{ /* bmem/bmem.scm 345 */
BgL_pairz00_2764 = BgL_aux2907z00_2765; }  else 
{ 
obj_t BgL_auxz00_5841;
BgL_auxz00_5841 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12421)), BGl_string3085z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2907z00_2765); 
FAILURE(BgL_auxz00_5841,BFALSE,BFALSE);} } 
{ /* bmem/bmem.scm 345 */
obj_t BgL_aux2909z00_2766;
BgL_aux2909z00_2766 = 
CAR(BgL_pairz00_2764); 
if(
STRINGP(BgL_aux2909z00_2766))
{ /* bmem/bmem.scm 345 */
BgL_string2z00_2758 = BgL_aux2909z00_2766; }  else 
{ 
obj_t BgL_auxz00_5848;
BgL_auxz00_5848 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12421)), BGl_string3085z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_aux2909z00_2766); 
FAILURE(BgL_auxz00_5848,BFALSE,BFALSE);} } } } 
BgL_tmpz00_5811 = 
bigloo_string_lt(BgL_string1z00_2757, BgL_string2z00_2758); } 
return 
BBOOL(BgL_tmpz00_5811);} } 

}



/* &<@anonymous:2033:/builddir/build/BUILD/bigloo-4,4a/bde/bmem/bmem/bmem,scm:326@> */
obj_t BGl_z62zc3z04anonymousza32033za3zf2builddirzf2buildzf2BUILDzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3326z04ze3z33zzbmemz00(obj_t BgL_envz00_2140, obj_t BgL_f1z00_2141, obj_t BgL_f2z00_2142)
{
{ /* bmem/bmem.scm 330 */
{ /* bmem/bmem.scm 331 */
bool_t BgL_tmpz00_5854;
{ /* bmem/bmem.scm 331 */
BgL_funinfoz00_bglt BgL_i1381z00_2767;
if(
BGl_isazf3zf3zz__objectz00(BgL_f1z00_2141, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 332 */
BgL_i1381z00_2767 = 
((BgL_funinfoz00_bglt)BgL_f1z00_2141); }  else 
{ 
obj_t BgL_auxz00_5858;
BgL_auxz00_5858 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12053)), BGl_string3086z00zzbmemz00, BGl_string3052z00zzbmemz00, BgL_f1z00_2141); 
FAILURE(BgL_auxz00_5858,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 332 */
BgL_funinfoz00_bglt BgL_i1382z00_2768;
if(
BGl_isazf3zf3zz__objectz00(BgL_f1z00_2141, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 333 */
BgL_i1382z00_2768 = 
((BgL_funinfoz00_bglt)BgL_f1z00_2141); }  else 
{ 
obj_t BgL_auxz00_5865;
BgL_auxz00_5865 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)12102)), BGl_string3086z00zzbmemz00, BGl_string3052z00zzbmemz00, BgL_f1z00_2141); 
FAILURE(BgL_auxz00_5865,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 334 */
obj_t BgL_arg2034z00_2769;obj_t BgL_arg2035z00_2770;
{ /* bmem/bmem.scm 334 */
obj_t BgL_arg2036z00_2771;
BgL_arg2036z00_2771 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1381z00_2767))->BgL_identz00); 
{ /* bmem/bmem.scm 334 */
obj_t BgL_res2506z00_2772;
{ /* bmem/bmem.scm 334 */
obj_t BgL_arg1436z00_2773;
BgL_arg1436z00_2773 = 
SYMBOL_TO_STRING(BgL_arg2036z00_2771); 
BgL_res2506z00_2772 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1436z00_2773); } 
BgL_arg2034z00_2769 = BgL_res2506z00_2772; } } 
{ /* bmem/bmem.scm 335 */
obj_t BgL_arg2037z00_2774;
BgL_arg2037z00_2774 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1382z00_2768))->BgL_identz00); 
{ /* bmem/bmem.scm 335 */
obj_t BgL_res2507z00_2775;
{ /* bmem/bmem.scm 335 */
obj_t BgL_arg1436z00_2776;
BgL_arg1436z00_2776 = 
SYMBOL_TO_STRING(BgL_arg2037z00_2774); 
BgL_res2507z00_2775 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg1436z00_2776); } 
BgL_arg2035z00_2770 = BgL_res2507z00_2775; } } 
BgL_tmpz00_5854 = 
bigloo_string_lt(BgL_arg2034z00_2769, BgL_arg2035z00_2770); } } } 
return 
BBOOL(BgL_tmpz00_5854);} } 

}



/* dynamic-css */
BGL_EXPORTED_DEF obj_t BGl_dynamiczd2csszd2zzbmemz00(obj_t BgL_gcmonz00_17, obj_t BgL_functionz00_18, obj_t BgL_typesz00_19)
{
{ /* bmem/bmem.scm 388 */
{ /* bmem/bmem.scm 390 */
obj_t BgL_name2246z00_1093;obj_t BgL_loc2247z00_1094;obj_t BgL_env2248z00_1095;
BgL_name2246z00_1093 = 
CNST_TABLE_REF(((long)71)); 
BgL_loc2247z00_1094 = 
CNST_TABLE_REF(((long)72)); 
BgL_env2248z00_1095 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 390 */

BGL_ENV_PUSH_TRACE(BgL_env2248z00_1095, BgL_name2246z00_1093, BgL_loc2247z00_1094); 
{ /* bmem/bmem.scm 390 */
BgL_z52cssz52_bglt BgL_aux2245z00_1096;
{ 
obj_t BgL_typesz00_949;obj_t BgL_funz00_917;obj_t BgL_gcmonz00_894;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2080z00_885;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2081z00_886;obj_t BgL_arg2082z00_887;obj_t BgL_arg2083z00_888;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2087z00_892;
{ /* bmem/bmem.scm 420 */
obj_t BgL_pairz00_2053;
if(
PAIRP(BgL_gcmonz00_17))
{ /* bmem/bmem.scm 420 */
BgL_pairz00_2053 = BgL_gcmonz00_17; }  else 
{ 
obj_t BgL_auxz00_5883;
BgL_auxz00_5883 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14919)), BGl_string3099z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_gcmonz00_17); 
FAILURE(BgL_auxz00_5883,BFALSE,BFALSE);} 
BgL_arg2087z00_892 = 
CDR(BgL_pairz00_2053); } 
BgL_gcmonz00_894 = BgL_arg2087z00_892; 
{ /* bmem/bmem.scm 390 */
long BgL_g1487z00_896;
{ /* bmem/bmem.scm 390 */
obj_t BgL_auxz00_5888;
{ /* bmem/bmem.scm 390 */
bool_t BgL_test3614z00_5889;
if(
PAIRP(BgL_gcmonz00_894))
{ /* bmem/bmem.scm 390 */
BgL_test3614z00_5889 = ((bool_t)1)
; }  else 
{ /* bmem/bmem.scm 390 */
BgL_test3614z00_5889 = 
NULLP(BgL_gcmonz00_894)
; } 
if(BgL_test3614z00_5889)
{ /* bmem/bmem.scm 390 */
BgL_auxz00_5888 = BgL_gcmonz00_894
; }  else 
{ 
obj_t BgL_auxz00_5893;
BgL_auxz00_5893 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)13870)), BGl_string3087z00zzbmemz00, BGl_string3012z00zzbmemz00, BgL_gcmonz00_894); 
FAILURE(BgL_auxz00_5893,BFALSE,BFALSE);} } 
BgL_g1487z00_896 = 
bgl_list_length(BgL_auxz00_5888); } 
{ 
long BgL_iz00_899;obj_t BgL_resz00_900;
BgL_iz00_899 = BgL_g1487z00_896; 
BgL_resz00_900 = BNIL; 
BgL_zc3z04anonymousza32090za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3390z04ze3z51_901:
if(
(BgL_iz00_899>=((long)-1)))
{ /* bmem/bmem.scm 393 */
obj_t BgL_selectorz00_903;
{ /* bmem/bmem.scm 393 */
obj_t BgL_list2099z00_915;
BgL_list2099z00_915 = 
MAKE_YOUNG_PAIR(
BINT(BgL_iz00_899), BNIL); 
BgL_selectorz00_903 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3088z00zzbmemz00, BgL_list2099z00_915); } 
{ /* bmem/bmem.scm 393 */
obj_t BgL_colorz00_904;
switch( BgL_iz00_899) { case ((long)-1) : 

BgL_colorz00_904 = BGl_string3089z00zzbmemz00; break;case ((long)0) : 

BgL_colorz00_904 = BGl_string3090z00zzbmemz00; break;
default: 
BgL_colorz00_904 = 
BGl_csszd2colorzd2zzbmem_toolsz00(
(int)(BgL_iz00_899), 
(int)(((long)117)), 
(int)(((long)128)), 
(int)(((long)162))); } 
{ /* bmem/bmem.scm 394 */
obj_t BgL_entryz00_905;
{ /* bmem/bmem.scm 398 */
obj_t BgL_arg2094z00_908;
{ /* bmem/bmem.scm 398 */
obj_t BgL_arg2095z00_909;
{ /* bmem/bmem.scm 398 */
obj_t BgL_arg2096z00_910;
{ /* bmem/bmem.scm 398 */
obj_t BgL_arg2097z00_911;
BgL_arg2097z00_911 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2096z00_910 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2097z00_911); } 
BgL_arg2095z00_909 = 
MAKE_YOUNG_PAIR(BgL_colorz00_904, BgL_arg2096z00_910); } 
BgL_arg2094z00_908 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2095z00_909); } 
BgL_entryz00_905 = 
MAKE_YOUNG_PAIR(BgL_selectorz00_903, BgL_arg2094z00_908); } 
{ /* bmem/bmem.scm 398 */

{ /* bmem/bmem.scm 399 */
long BgL_arg2092z00_906;obj_t BgL_arg2093z00_907;
BgL_arg2092z00_906 = 
(BgL_iz00_899-((long)1)); 
BgL_arg2093z00_907 = 
MAKE_YOUNG_PAIR(BgL_entryz00_905, BgL_resz00_900); 
{ 
obj_t BgL_resz00_5920;long BgL_iz00_5919;
BgL_iz00_5919 = BgL_arg2092z00_906; 
BgL_resz00_5920 = BgL_arg2093z00_907; 
BgL_resz00_900 = BgL_resz00_5920; 
BgL_iz00_899 = BgL_iz00_5919; 
goto BgL_zc3z04anonymousza32090za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3390z04ze3z51_901;} } } } } }  else 
{ /* bmem/bmem.scm 392 */
BgL_arg2081z00_886 = 
bgl_reverse_bang(BgL_resz00_900); } } } } 
BgL_funz00_917 = BgL_functionz00_18; 
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2101z00_919;obj_t BgL_arg2102z00_920;
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2103z00_921;
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2104z00_922;
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2105z00_923;
{ /* bmem/bmem.scm 402 */
obj_t BgL_arg2106z00_924;
BgL_arg2106z00_924 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2105z00_923 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2106z00_924); } 
BgL_arg2104z00_922 = 
MAKE_YOUNG_PAIR(BGl_string3089z00zzbmemz00, BgL_arg2105z00_923); } 
BgL_arg2103z00_921 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2104z00_922); } 
BgL_arg2101z00_919 = 
MAKE_YOUNG_PAIR(BGl_string3091z00zzbmemz00, BgL_arg2103z00_921); } 
if(
NULLP(BgL_funz00_917))
{ /* bmem/bmem.scm 403 */
BgL_arg2102z00_920 = BNIL; }  else 
{ /* bmem/bmem.scm 403 */
obj_t BgL_head1586z00_927;
{ /* bmem/bmem.scm 403 */
obj_t BgL_res2630z00_2015;
BgL_res2630z00_2015 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1586z00_927 = BgL_res2630z00_2015; } 
{ 
obj_t BgL_l1584z00_929;obj_t BgL_tail1587z00_930;
BgL_l1584z00_929 = BgL_funz00_917; 
BgL_tail1587z00_930 = BgL_head1586z00_927; 
BgL_zc3z04anonymousza32108za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3403z04ze3z51_931:
if(
PAIRP(BgL_l1584z00_929))
{ /* bmem/bmem.scm 403 */
obj_t BgL_newtail1588z00_933;
{ /* bmem/bmem.scm 403 */
obj_t BgL_arg2111z00_935;
{ /* bmem/bmem.scm 403 */
obj_t BgL_fz00_936;
BgL_fz00_936 = 
CAR(BgL_l1584z00_929); 
{ /* bmem/bmem.scm 404 */
BgL_funinfoz00_bglt BgL_i1491z00_937;
if(
BGl_isazf3zf3zz__objectz00(BgL_fz00_936, BGl_funinfoz00zzbmem_functionz00))
{ /* bmem/bmem.scm 405 */
BgL_i1491z00_937 = 
((BgL_funinfoz00_bglt)BgL_fz00_936); }  else 
{ 
obj_t BgL_auxz00_5939;
BgL_auxz00_5939 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14357)), BGl_string3092z00zzbmemz00, BGl_string3052z00zzbmemz00, BgL_fz00_936); 
FAILURE(BgL_auxz00_5939,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 405 */
obj_t BgL_selectorz00_938;
{ /* bmem/bmem.scm 405 */
int BgL_arg2117z00_945;
BgL_arg2117z00_945 = 
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1491z00_937))->BgL_numz00); 
{ /* bmem/bmem.scm 405 */
obj_t BgL_list2118z00_946;
BgL_list2118z00_946 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg2117z00_945), BNIL); 
BgL_selectorz00_938 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3093z00zzbmemz00, BgL_list2118z00_946); } } 
{ /* bmem/bmem.scm 405 */
obj_t BgL_colorz00_939;
BgL_colorz00_939 = 
BGl_csszd2colorzd2zzbmem_toolsz00(
(((BgL_funinfoz00_bglt)COBJECT(BgL_i1491z00_937))->BgL_numz00), 
(int)(((long)143)), 
(int)(((long)255)), 
(int)(((long)128))); 
{ /* bmem/bmem.scm 406 */

{ /* bmem/bmem.scm 407 */
obj_t BgL_arg2112z00_940;
{ /* bmem/bmem.scm 407 */
obj_t BgL_arg2113z00_941;
{ /* bmem/bmem.scm 407 */
obj_t BgL_arg2114z00_942;
{ /* bmem/bmem.scm 407 */
obj_t BgL_arg2115z00_943;
BgL_arg2115z00_943 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2114z00_942 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2115z00_943); } 
BgL_arg2113z00_941 = 
MAKE_YOUNG_PAIR(BgL_colorz00_939, BgL_arg2114z00_942); } 
BgL_arg2112z00_940 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2113z00_941); } 
BgL_arg2111z00_935 = 
MAKE_YOUNG_PAIR(BgL_selectorz00_938, BgL_arg2112z00_940); } } } } } } 
{ /* bmem/bmem.scm 403 */
obj_t BgL_res2632z00_2018;
BgL_res2632z00_2018 = 
MAKE_YOUNG_PAIR(BgL_arg2111z00_935, BNIL); 
BgL_newtail1588z00_933 = BgL_res2632z00_2018; } } 
SET_CDR(BgL_tail1587z00_930, BgL_newtail1588z00_933); 
{ 
obj_t BgL_tail1587z00_5964;obj_t BgL_l1584z00_5962;
BgL_l1584z00_5962 = 
CDR(BgL_l1584z00_929); 
BgL_tail1587z00_5964 = BgL_newtail1588z00_933; 
BgL_tail1587z00_930 = BgL_tail1587z00_5964; 
BgL_l1584z00_929 = BgL_l1584z00_5962; 
goto BgL_zc3z04anonymousza32108za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3403z04ze3z51_931;} }  else 
{ /* bmem/bmem.scm 403 */
if(
NULLP(BgL_l1584z00_929))
{ /* bmem/bmem.scm 403 */
BgL_arg2102z00_920 = 
CDR(BgL_head1586z00_927); }  else 
{ /* bmem/bmem.scm 403 */
BgL_arg2102z00_920 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string3056z00zzbmemz00, BGl_string3016z00zzbmemz00, BgL_l1584z00_929, BGl_string2954z00zzbmemz00, 
BINT(((long)14301))); } } } } 
BgL_arg2082z00_887 = 
MAKE_YOUNG_PAIR(BgL_arg2101z00_919, BgL_arg2102z00_920); } 
{ /* bmem/bmem.scm 422 */
obj_t BgL_arg2088z00_893;
{ /* bmem/bmem.scm 422 */
obj_t BgL_pairz00_2054;
if(
PAIRP(BgL_typesz00_19))
{ /* bmem/bmem.scm 422 */
BgL_pairz00_2054 = BgL_typesz00_19; }  else 
{ 
obj_t BgL_auxz00_5973;
BgL_auxz00_5973 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14976)), BGl_string3099z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_typesz00_19); 
FAILURE(BgL_auxz00_5973,BFALSE,BFALSE);} 
BgL_arg2088z00_893 = 
CDR(BgL_pairz00_2054); } 
BgL_typesz00_949 = BgL_arg2088z00_893; 
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2121z00_951;obj_t BgL_arg2122z00_952;
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2123z00_953;
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2124z00_954;
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2125z00_955;
{ /* bmem/bmem.scm 410 */
obj_t BgL_arg2126z00_956;
BgL_arg2126z00_956 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2125z00_955 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2126z00_956); } 
BgL_arg2124z00_954 = 
MAKE_YOUNG_PAIR(BGl_string3089z00zzbmemz00, BgL_arg2125z00_955); } 
BgL_arg2123z00_953 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2124z00_954); } 
BgL_arg2121z00_951 = 
MAKE_YOUNG_PAIR(BGl_string3094z00zzbmemz00, BgL_arg2123z00_953); } 
if(
NULLP(BgL_typesz00_949))
{ /* bmem/bmem.scm 411 */
BgL_arg2122z00_952 = BNIL; }  else 
{ /* bmem/bmem.scm 411 */
obj_t BgL_head1591z00_959;
{ /* bmem/bmem.scm 411 */
obj_t BgL_res2635z00_2024;
BgL_res2635z00_2024 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1591z00_959 = BgL_res2635z00_2024; } 
{ 
obj_t BgL_l1589z00_961;obj_t BgL_tail1592z00_962;
BgL_l1589z00_961 = BgL_typesz00_949; 
BgL_tail1592z00_962 = BgL_head1591z00_959; 
BgL_zc3z04anonymousza32128za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3411z04ze3z51_963:
if(
PAIRP(BgL_l1589z00_961))
{ /* bmem/bmem.scm 411 */
obj_t BgL_newtail1593z00_965;
{ /* bmem/bmem.scm 411 */
obj_t BgL_arg2131z00_967;
{ /* bmem/bmem.scm 411 */
obj_t BgL_tz00_968;
BgL_tz00_968 = 
CAR(BgL_l1589z00_961); 
{ /* bmem/bmem.scm 412 */
obj_t BgL_iz00_969;
{ /* bmem/bmem.scm 412 */
obj_t BgL_pairz00_2027;
if(
PAIRP(BgL_tz00_968))
{ /* bmem/bmem.scm 412 */
BgL_pairz00_2027 = BgL_tz00_968; }  else 
{ 
obj_t BgL_auxz00_5994;
BgL_auxz00_5994 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14660)), BGl_string3095z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_tz00_968); 
FAILURE(BgL_auxz00_5994,BFALSE,BFALSE);} 
BgL_iz00_969 = 
CAR(BgL_pairz00_2027); } 
{ /* bmem/bmem.scm 412 */
obj_t BgL_selectorz00_970;
{ /* bmem/bmem.scm 413 */
obj_t BgL_list2139z00_979;
BgL_list2139z00_979 = 
MAKE_YOUNG_PAIR(BgL_iz00_969, BNIL); 
BgL_selectorz00_970 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3096z00zzbmemz00, BgL_list2139z00_979); } 
{ /* bmem/bmem.scm 413 */
obj_t BgL_colorz00_971;
{ /* bmem/bmem.scm 414 */
bool_t BgL_test3625z00_6001;
{ /* bmem/bmem.scm 414 */
obj_t BgL_arg2138z00_978;
{ /* bmem/bmem.scm 414 */
obj_t BgL_pairz00_2028;
if(
PAIRP(BgL_tz00_968))
{ /* bmem/bmem.scm 414 */
BgL_pairz00_2028 = BgL_tz00_968; }  else 
{ 
obj_t BgL_auxz00_6004;
BgL_auxz00_6004 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14741)), BGl_string3095z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_tz00_968); 
FAILURE(BgL_auxz00_6004,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 414 */
obj_t BgL_pairz00_2031;
{ /* bmem/bmem.scm 414 */
obj_t BgL_aux2923z00_2442;
BgL_aux2923z00_2442 = 
CDR(BgL_pairz00_2028); 
if(
PAIRP(BgL_aux2923z00_2442))
{ /* bmem/bmem.scm 414 */
BgL_pairz00_2031 = BgL_aux2923z00_2442; }  else 
{ 
obj_t BgL_auxz00_6011;
BgL_auxz00_6011 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14735)), BGl_string3095z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2923z00_2442); 
FAILURE(BgL_auxz00_6011,BFALSE,BFALSE);} } 
BgL_arg2138z00_978 = 
CAR(BgL_pairz00_2031); } } 
{ /* bmem/bmem.scm 414 */
bool_t BgL_res2641z00_2047;
{ /* bmem/bmem.scm 414 */
obj_t BgL_string1z00_2032;
if(
STRINGP(BgL_arg2138z00_978))
{ /* bmem/bmem.scm 414 */
BgL_string1z00_2032 = BgL_arg2138z00_978; }  else 
{ 
obj_t BgL_auxz00_6018;
BgL_auxz00_6018 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14742)), BGl_string3095z00zzbmemz00, BGl_string2978z00zzbmemz00, BgL_arg2138z00_978); 
FAILURE(BgL_auxz00_6018,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 414 */
long BgL_l1z00_2034;
BgL_l1z00_2034 = 
STRING_LENGTH(BgL_string1z00_2032); 
if(
(BgL_l1z00_2034==((long)4)))
{ /* bmem/bmem.scm 414 */
int BgL_arg1269z00_2037;
{ /* bmem/bmem.scm 414 */
char * BgL_auxz00_6027;char * BgL_tmpz00_6025;
BgL_auxz00_6027 = 
BSTRING_TO_STRING(BGl_string3097z00zzbmemz00); 
BgL_tmpz00_6025 = 
BSTRING_TO_STRING(BgL_string1z00_2032); 
BgL_arg1269z00_2037 = 
memcmp(BgL_tmpz00_6025, BgL_auxz00_6027, BgL_l1z00_2034); } 
BgL_res2641z00_2047 = 
(
(long)(BgL_arg1269z00_2037)==((long)0)); }  else 
{ /* bmem/bmem.scm 414 */
BgL_res2641z00_2047 = ((bool_t)0); } } } 
BgL_test3625z00_6001 = BgL_res2641z00_2047; } } 
if(BgL_test3625z00_6001)
{ /* bmem/bmem.scm 414 */
BgL_colorz00_971 = BGl_string3098z00zzbmemz00; }  else 
{ /* bmem/bmem.scm 416 */
int BgL_auxz00_6032;
{ /* bmem/bmem.scm 416 */
obj_t BgL_tmpz00_6033;
if(
INTEGERP(BgL_iz00_969))
{ /* bmem/bmem.scm 416 */
BgL_tmpz00_6033 = BgL_iz00_969
; }  else 
{ 
obj_t BgL_auxz00_6036;
BgL_auxz00_6036 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14797)), BGl_string3095z00zzbmemz00, BGl_string3013z00zzbmemz00, BgL_iz00_969); 
FAILURE(BgL_auxz00_6036,BFALSE,BFALSE);} 
BgL_auxz00_6032 = 
CINT(BgL_tmpz00_6033); } 
BgL_colorz00_971 = 
BGl_csszd2colorzd2zzbmem_toolsz00(BgL_auxz00_6032, 
(int)(((long)200)), 
(int)(((long)40)), 
(int)(((long)80))); } } 
{ /* bmem/bmem.scm 414 */

{ /* bmem/bmem.scm 417 */
obj_t BgL_arg2132z00_972;
{ /* bmem/bmem.scm 417 */
obj_t BgL_arg2133z00_973;
{ /* bmem/bmem.scm 417 */
obj_t BgL_arg2134z00_974;
{ /* bmem/bmem.scm 417 */
obj_t BgL_arg2135z00_975;
BgL_arg2135z00_975 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)73)), BNIL); 
BgL_arg2134z00_974 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)74)), BgL_arg2135z00_975); } 
BgL_arg2133z00_973 = 
MAKE_YOUNG_PAIR(BgL_colorz00_971, BgL_arg2134z00_974); } 
BgL_arg2132z00_972 = 
MAKE_YOUNG_PAIR(
CNST_TABLE_REF(((long)75)), BgL_arg2133z00_973); } 
BgL_arg2131z00_967 = 
MAKE_YOUNG_PAIR(BgL_selectorz00_970, BgL_arg2132z00_972); } } } } } } 
{ /* bmem/bmem.scm 411 */
obj_t BgL_res2642z00_2048;
BgL_res2642z00_2048 = 
MAKE_YOUNG_PAIR(BgL_arg2131z00_967, BNIL); 
BgL_newtail1593z00_965 = BgL_res2642z00_2048; } } 
SET_CDR(BgL_tail1592z00_962, BgL_newtail1593z00_965); 
{ 
obj_t BgL_tail1592z00_6057;obj_t BgL_l1589z00_6055;
BgL_l1589z00_6055 = 
CDR(BgL_l1589z00_961); 
BgL_tail1592z00_6057 = BgL_newtail1593z00_965; 
BgL_tail1592z00_962 = BgL_tail1592z00_6057; 
BgL_l1589z00_961 = BgL_l1589z00_6055; 
goto BgL_zc3z04anonymousza32128za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3411z04ze3z51_963;} }  else 
{ /* bmem/bmem.scm 411 */
if(
NULLP(BgL_l1589z00_961))
{ /* bmem/bmem.scm 411 */
BgL_arg2122z00_952 = 
CDR(BgL_head1591z00_959); }  else 
{ /* bmem/bmem.scm 411 */
BgL_arg2122z00_952 = 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BGl_string3056z00zzbmemz00, BGl_string3016z00zzbmemz00, BgL_l1589z00_961, BGl_string2954z00zzbmemz00, 
BINT(((long)14625))); } } } } 
BgL_arg2083z00_888 = 
MAKE_YOUNG_PAIR(BgL_arg2121z00_951, BgL_arg2122z00_952); } } 
{ /* bmem/bmem.scm 420 */
obj_t BgL_list2084z00_889;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2085z00_890;
{ /* bmem/bmem.scm 420 */
obj_t BgL_arg2086z00_891;
BgL_arg2086z00_891 = 
MAKE_YOUNG_PAIR(BgL_arg2083z00_888, BNIL); 
BgL_arg2085z00_890 = 
MAKE_YOUNG_PAIR(BgL_arg2082z00_887, BgL_arg2086z00_891); } 
BgL_list2084z00_889 = 
MAKE_YOUNG_PAIR(BgL_arg2081z00_886, BgL_arg2085z00_890); } 
BgL_arg2080z00_885 = 
BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2084z00_889); } } 
{ /* bmem/bmem.scm 419 */
obj_t BgL_auxz00_6068;
if(
PAIRP(BgL_arg2080z00_885))
{ /* bmem/bmem.scm 422 */
BgL_auxz00_6068 = BgL_arg2080z00_885
; }  else 
{ 
obj_t BgL_auxz00_6071;
BgL_auxz00_6071 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)14983)), BGl_string3099z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_arg2080z00_885); 
FAILURE(BgL_auxz00_6071,BFALSE,BFALSE);} 
BgL_aux2245z00_1096 = 
BGl_listzd2ze3cssz31zzhtmlz00(BgL_auxz00_6068); } } } 
BGL_ENV_POP_TRACE(BgL_env2248z00_1095); 
return 
((obj_t)BgL_aux2245z00_1096);} } } } 

}



/* &dynamic-css */
obj_t BGl_z62dynamiczd2csszb0zzbmemz00(obj_t BgL_envz00_2143, obj_t BgL_gcmonz00_2144, obj_t BgL_functionz00_2145, obj_t BgL_typesz00_2146)
{
{ /* bmem/bmem.scm 388 */
return 
BGl_dynamiczd2csszd2zzbmemz00(BgL_gcmonz00_2144, BgL_functionz00_2145, BgL_typesz00_2146);} 

}



/* find-monitor */
obj_t BGl_findzd2monitorzd2zzbmemz00(obj_t BgL_monz00_20, obj_t BgL_keyz00_21)
{
{ /* bmem/bmem.scm 427 */
{ /* bmem/bmem.scm 430 */
obj_t BgL_name2250z00_1097;obj_t BgL_loc2251z00_1098;obj_t BgL_env2252z00_1099;
BgL_name2250z00_1097 = 
CNST_TABLE_REF(((long)76)); 
BgL_loc2251z00_1098 = 
CNST_TABLE_REF(((long)77)); 
BgL_env2252z00_1099 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 430 */

BGL_ENV_PUSH_TRACE(BgL_env2252z00_1099, BgL_name2250z00_1097, BgL_loc2251z00_1098); 
{ /* bmem/bmem.scm 430 */
obj_t BgL_aux2249z00_1100;
{ 
obj_t BgL_monz00_986;
BgL_monz00_986 = BgL_monz00_20; 
BgL_zc3z04anonymousza32141za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3428z04ze3z51_987:
if(
NULLP(BgL_monz00_986))
{ /* bmem/bmem.scm 430 */
BgL_aux2249z00_1100 = BFALSE; }  else 
{ /* bmem/bmem.scm 432 */
bool_t BgL_test3634z00_6085;
{ /* bmem/bmem.scm 432 */
bool_t BgL_test3635z00_6086;
{ /* bmem/bmem.scm 432 */
obj_t BgL_tmpz00_6087;
{ /* bmem/bmem.scm 432 */
obj_t BgL_pairz00_2057;
if(
PAIRP(BgL_monz00_986))
{ /* bmem/bmem.scm 432 */
BgL_pairz00_2057 = BgL_monz00_986; }  else 
{ 
obj_t BgL_auxz00_6090;
BgL_auxz00_6090 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)15320)), BGl_string3100z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_monz00_986); 
FAILURE(BgL_auxz00_6090,BFALSE,BFALSE);} 
BgL_tmpz00_6087 = 
CAR(BgL_pairz00_2057); } 
BgL_test3635z00_6086 = 
PAIRP(BgL_tmpz00_6087); } 
if(BgL_test3635z00_6086)
{ /* bmem/bmem.scm 432 */
obj_t BgL_tmpz00_6096;
{ /* bmem/bmem.scm 432 */
obj_t BgL_pairz00_2060;
{ /* bmem/bmem.scm 432 */
obj_t BgL_pairz00_2059;
if(
PAIRP(BgL_monz00_986))
{ /* bmem/bmem.scm 432 */
BgL_pairz00_2059 = BgL_monz00_986; }  else 
{ 
obj_t BgL_auxz00_6099;
BgL_auxz00_6099 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)15341)), BGl_string3100z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_monz00_986); 
FAILURE(BgL_auxz00_6099,BFALSE,BFALSE);} 
{ /* bmem/bmem.scm 432 */
obj_t BgL_aux2939z00_2458;
BgL_aux2939z00_2458 = 
CAR(BgL_pairz00_2059); 
if(
PAIRP(BgL_aux2939z00_2458))
{ /* bmem/bmem.scm 432 */
BgL_pairz00_2060 = BgL_aux2939z00_2458; }  else 
{ 
obj_t BgL_auxz00_6106;
BgL_auxz00_6106 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)15336)), BGl_string3100z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_aux2939z00_2458); 
FAILURE(BgL_auxz00_6106,BFALSE,BFALSE);} } } 
BgL_tmpz00_6096 = 
CAR(BgL_pairz00_2060); } 
BgL_test3634z00_6085 = 
(BgL_tmpz00_6096==BgL_keyz00_21); }  else 
{ /* bmem/bmem.scm 432 */
BgL_test3634z00_6085 = ((bool_t)0)
; } } 
if(BgL_test3634z00_6085)
{ /* bmem/bmem.scm 433 */
obj_t BgL_pairz00_2061;
if(
PAIRP(BgL_monz00_986))
{ /* bmem/bmem.scm 433 */
BgL_pairz00_2061 = BgL_monz00_986; }  else 
{ 
obj_t BgL_auxz00_6114;
BgL_auxz00_6114 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)15361)), BGl_string3100z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_monz00_986); 
FAILURE(BgL_auxz00_6114,BFALSE,BFALSE);} 
BgL_aux2249z00_1100 = 
CAR(BgL_pairz00_2061); }  else 
{ 
obj_t BgL_monz00_6119;
{ /* bmem/bmem.scm 435 */
obj_t BgL_pairz00_2062;
if(
PAIRP(BgL_monz00_986))
{ /* bmem/bmem.scm 435 */
BgL_pairz00_2062 = BgL_monz00_986; }  else 
{ 
obj_t BgL_auxz00_6122;
BgL_auxz00_6122 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2954z00zzbmemz00, 
BINT(((long)15389)), BGl_string3100z00zzbmemz00, BGl_string2974z00zzbmemz00, BgL_monz00_986); 
FAILURE(BgL_auxz00_6122,BFALSE,BFALSE);} 
BgL_monz00_6119 = 
CDR(BgL_pairz00_2062); } 
BgL_monz00_986 = BgL_monz00_6119; 
goto BgL_zc3z04anonymousza32141za3zf2builddirzf2buildzf2buildzf2bigloozd24zc24azf2bdezf2bmemzf2bmemzf2bmemzc2scmza3428z04ze3z51_987;} } } 
BGL_ENV_POP_TRACE(BgL_env2252z00_1099); 
return BgL_aux2249z00_1100;} } } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2254z00_1101;obj_t BgL_loc2255z00_1102;obj_t BgL_env2256z00_1103;
BgL_name2254z00_1101 = 
CNST_TABLE_REF(((long)78)); 
BgL_loc2255z00_1102 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2256z00_1103 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2256z00_1103, BgL_name2254z00_1101, BgL_loc2255z00_1102); 
BGL_ENV_POP_TRACE(BgL_env2256z00_1103); 
return BUNSPEC;} } } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2258z00_1105;obj_t BgL_loc2259z00_1106;obj_t BgL_env2260z00_1107;
BgL_name2258z00_1105 = 
CNST_TABLE_REF(((long)79)); 
BgL_loc2259z00_1106 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2260z00_1107 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2260z00_1107, BgL_name2258z00_1105, BgL_loc2259z00_1106); 
BGL_ENV_POP_TRACE(BgL_env2260z00_1107); 
return BUNSPEC;} } } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2262z00_1109;obj_t BgL_loc2263z00_1110;obj_t BgL_env2264z00_1111;
BgL_name2262z00_1109 = 
CNST_TABLE_REF(((long)80)); 
BgL_loc2263z00_1110 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2264z00_1111 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2264z00_1111, BgL_name2262z00_1109, BgL_loc2263z00_1110); 
BGL_ENV_POP_TRACE(BgL_env2264z00_1111); 
return BUNSPEC;} } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zzbmemz00()
{
{ /* bmem/bmem.scm 16 */
{ /* bmem/bmem.scm 16 */
obj_t BgL_name2266z00_1113;obj_t BgL_loc2267z00_1114;obj_t BgL_env2268z00_1115;
BgL_name2266z00_1113 = 
CNST_TABLE_REF(((long)81)); 
BgL_loc2267z00_1114 = 
CNST_TABLE_REF(((long)1)); 
BgL_env2268z00_1115 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* bmem/bmem.scm 16 */

BGL_ENV_PUSH_TRACE(BgL_env2268z00_1115, BgL_name2266z00_1113, BgL_loc2267z00_1114); 
{ /* bmem/bmem.scm 16 */
obj_t BgL_aux2265z00_1116;
BGl_modulezd2initializa7ationz75zzhtmlz00(((long)75073879), 
BSTRING_TO_STRING(BGl_string3101z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_paramz00(((long)145760934), 
BSTRING_TO_STRING(BGl_string3101z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_toolsz00(((long)330722915), 
BSTRING_TO_STRING(BGl_string3101z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_functionz00(((long)88630167), 
BSTRING_TO_STRING(BGl_string3101z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_gcz00(((long)471623306), 
BSTRING_TO_STRING(BGl_string3101z00zzbmemz00)); 
BGl_modulezd2initializa7ationz75zzbmem_typez00(((long)176367239), 
BSTRING_TO_STRING(BGl_string3101z00zzbmemz00)); 
BgL_aux2265z00_1116 = 
BGl_modulezd2initializa7ationz75zzbmem_threadz00(((long)222586213), 
BSTRING_TO_STRING(BGl_string3101z00zzbmemz00)); 
BGL_ENV_POP_TRACE(BgL_env2268z00_1115); 
return BgL_aux2265z00_1116;} } } } 

}

#ifdef __cplusplus
}
#endif
