/*===========================================================================*/
/*   (Ast/sexp.scm)                                                          */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Sun 01 Nov 2020 07:23:42 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4a -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/sexp.scm) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_feffectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_readz00;
		obj_t BgL_writez00;
	}                 *BgL_feffectz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_nodezf2effectzf2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
	}                       *BgL_nodezf2effectzf2_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_literalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}                 *BgL_literalz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_closurez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}                 *BgL_closurez00_bglt;

	typedef struct BgL_kwotez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}               *BgL_kwotez00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
		obj_t BgL_metaz00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_stackablez00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_switchz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_switchz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	extern obj_t BGl_normaliza7ezd2prognz75zztools_prognz00(obj_t);
	BGL_IMPORT obj_t BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_stringzd2replacezd2zz__r4_strings_6_7z00(obj_t,
		unsigned char, unsigned char);
	extern obj_t BGl_closurez00zzast_nodez00;
	BGL_IMPORT bool_t BGl_equalzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_findzd2locationzf2locz20zztools_locationz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_applicationzd2ze3nodez31zzast_appz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_ifzd2symzd2zzast_sexpz00();
	extern BgL_nodez00_bglt BGl_applycationzd2ze3nodez31zzast_applyz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	extern obj_t BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00(BgL_nodez00_bglt);
	static obj_t BGl_objectzd2initzd2zzast_sexpz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_privatezd2nodezd2zzast_privatez00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t string_append_3(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2containszd2zz__r4_strings_6_7z00(obj_t, obj_t,
		int);
	extern obj_t BGl_castzd2sexpzd2typez00zzast_privatez00(obj_t);
	extern obj_t BGl_za2magicza2z00zztype_cachez00;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	extern obj_t BGl_letzd2symzf3z21zzast_letz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_sexpz00();
	extern obj_t BGl_externz00zzast_nodez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00
		(BgL_globalz00_bglt, BgL_nodez00_bglt, obj_t);
	extern obj_t BGl_za2bdbzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2compilerzd2debugza2zd2zzengine_paramz00;
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	BGL_IMPORT obj_t BGl_exceptionzd2notifyzd2zz__objectz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza36916ze3ze5zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt);
	static BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(bool_t,
		obj_t, BgL_typez00_bglt, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	extern BgL_jumpzd2exzd2itz00_bglt
		BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT bool_t BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t, obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zzast_sexpz00();
	extern obj_t BGl_parsezd2idzd2zzast_identz00(obj_t, obj_t);
	static obj_t BGl_za2sitesza2z00zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t);
	extern obj_t BGl_currentzd2functionzd2zztools_errorz00();
	static obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_epairifyzd2reczd2zztools_miscz00(obj_t, obj_t);
	static obj_t BGl_zc3z04exitza31525ze3ze70z60zzast_sexpz00(obj_t, obj_t);
	BGL_IMPORT obj_t c_substring(obj_t, long, long);
	extern obj_t BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2ifza2z00zzast_sexpz00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	extern BgL_typez00_bglt BGl_usezd2typez12zc0zztype_envz00(obj_t, obj_t);
	static obj_t BGl_loopze70ze7zzast_sexpz00(obj_t, obj_t, obj_t, obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	static bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_letrecza2zd2ze3nodez93zzast_letz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(obj_t);
	BGL_IMPORT obj_t BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern BgL_nodez00_bglt BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_lambdazd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_sexpz00 = BUNSPEC;
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_userzd2errorzf2locationz20zztools_errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t);
	static obj_t BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_sexpz00();
	extern obj_t BGl_epairifyz00zztools_miscz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_sexpz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_privatezd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	extern obj_t BGl_labelszd2symzd2zzast_labelsz00();
	extern obj_t BGl_labelszd2symzf3z21zzast_labelsz00(obj_t);
	BGL_IMPORT obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_za2cachezd2resza2zd2zzast_sexpz00 = BUNSPEC;
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t,
		obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t);
	static obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	BGL_IMPORT bool_t bigloo_strncmp(obj_t, obj_t, long);
	static obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t, obj_t, obj_t,
		obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2atomz00zztype_typeofz00(obj_t);
	extern BgL_nodez00_bglt BGl_letzd2ze3nodez31zzast_letz00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t,
		obj_t);
	static obj_t BGl_liipze70ze7zzast_sexpz00(obj_t);
	extern obj_t BGl_replacez12z12zztools_miscz00(obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_dumpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_privatez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_applyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_appz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_exitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_labelsz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_pragmaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_buildz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern bool_t BGl_globalzd2readzd2onlyzf3zf3zzast_varz00(BgL_globalz00_bglt);
	static BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_stringzd2appendzd2zz__r4_strings_6_7z00(obj_t);
	extern bool_t BGl_castzd2sexpzf3z21zzast_privatez00(obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_cnstzd2initzd2zzast_sexpz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00();
	static obj_t BGl_z62zc3z04anonymousza31537ze3ze5zzast_sexpz00(obj_t, obj_t);
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	static obj_t BGl_z62zc3z04anonymousza31538ze3ze5zzast_sexpz00(obj_t);
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_letzd2symzd2zzast_letz00();
	BGL_EXPORTED_DECL BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt,
		BgL_nodez00_bglt);
	extern obj_t BGl_za2unspecza2z00zztype_cachez00;
	static BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_letzd2funzd2_bglt BGl_labelszd2ze3nodez31zzast_labelsz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_literalz00zzast_nodez00;
	extern obj_t BGl_switchz00zzast_nodez00;
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t,
		obj_t, obj_t, obj_t);
	extern BgL_typez00_bglt BGl_getzd2typezd2kwotez00zztype_typeofz00(obj_t);
	BGL_IMPORT obj_t BGl_withzd2exceptionzd2handlerz00zz__errorz00(obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	extern BgL_feffectz00_bglt BGl_parsezd2effectzd2zzeffect_feffectz00(obj_t);
	static obj_t BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BUNSPEC;
	static obj_t __cnst[49];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8084z00,
		BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8085z00,
		BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_errorzd2sexpzd2ze3nodezd2envz31zzast_sexpz00,
		BgL_bgl_za762errorza7d2sexpza78086za7,
		BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00, 0L, BUNSPEC, 3);
	BGL_IMPORT obj_t BGl_expzd2envzd2zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_makezd2anonymouszd2namezd2envzd2zzast_sexpz00,
		BgL_bgl_za762makeza7d2anonym8087z00, va_generic_entry,
		BGl_z62makezd2anonymouszd2namez62zzast_sexpz00, BUNSPEC, -2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2localzd2envz00zzast_sexpz00,
		BgL_bgl_za762findza7d2localza78088za7, BGl_z62findzd2localzb0zzast_sexpz00,
		0L, BUNSPEC, 2);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_locationzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762locationza7d2za7e8089za7,
		BGl_z62locationzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762sexpza7d2za7e3nod8090za7,
		BGl_z62sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_topzd2levelzd2sexpzd2ze3nodezd2envze3zzast_sexpz00,
		BgL_bgl_za762topza7d2levelza7d8091za7,
		BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_sexpza2zd2ze3nodezd2envz41zzast_sexpz00,
		BgL_bgl_za762sexpza7a2za7d2za7e38092z00,
		BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00, 0L, BUNSPEC, 4);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_definezd2primopzd2refzf2srczd2ze3nodezd2envz11zzast_sexpz00,
		BgL_bgl_za762defineza7d2prim8093z00,
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00, 0L, BUNSPEC,
		3);
	      DEFINE_STRING(BGl_string8046z00zzast_sexpz00,
		BgL_bgl_string8046za700za7za7a8094za7, "Illegal `application' form", 26);
	      DEFINE_STRING(BGl_string8047z00zzast_sexpz00,
		BgL_bgl_string8047za700za7za7a8095za7, "Illegal `case' form", 19);
	      DEFINE_STRING(BGl_string8048z00zzast_sexpz00,
		BgL_bgl_string8048za700za7za7a8096za7, "Illegal `failure' form", 22);
	      DEFINE_STRING(BGl_string8049z00zzast_sexpz00,
		BgL_bgl_string8049za700za7za7a8097za7, "Illegal `static-pragma' expression",
		34);
	      DEFINE_STRING(BGl_string8050z00zzast_sexpz00,
		BgL_bgl_string8050za700za7za7a8098za7, "anonymous", 9);
	      DEFINE_STRING(BGl_string8051z00zzast_sexpz00,
		BgL_bgl_string8051za700za7za7a8099za7, "Illegal `define' form", 21);
	      DEFINE_STRING(BGl_string8052z00zzast_sexpz00,
		BgL_bgl_string8052za700za7za7a8100za7, "illegal `define' expression", 27);
	      DEFINE_STRING(BGl_string8053z00zzast_sexpz00,
		BgL_bgl_string8053za700za7za7a8101za7, "Illegal `set!' form", 19);
	      DEFINE_STRING(BGl_string8054z00zzast_sexpz00,
		BgL_bgl_string8054za700za7za7a8102za7, "Read-only variable", 18);
	      DEFINE_STRING(BGl_string8055z00zzast_sexpz00,
		BgL_bgl_string8055za700za7za7a8103za7, "illegal `set!' expression", 25);
	      DEFINE_STRING(BGl_string8056z00zzast_sexpz00,
		BgL_bgl_string8056za700za7za7a8104za7, "Illegal ->", 10);
	      DEFINE_STRING(BGl_string8057z00zzast_sexpz00,
		BgL_bgl_string8057za700za7za7a8105za7, "Illegal `if' form", 17);
	      DEFINE_STRING(BGl_string8058z00zzast_sexpz00,
		BgL_bgl_string8058za700za7za7a8106za7, "Illegal `quote' expression", 26);
	      DEFINE_STRING(BGl_string8059z00zzast_sexpz00,
		BgL_bgl_string8059za700za7za7a8107za7, "Illegal `@' expression", 22);
	      DEFINE_STRING(BGl_string8060z00zzast_sexpz00,
		BgL_bgl_string8060za700za7za7a8108za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string8061z00zzast_sexpz00,
		BgL_bgl_string8061za700za7za7a8109za7, "Illegal atom in s-expression", 28);
	      DEFINE_STRING(BGl_string8062z00zzast_sexpz00,
		BgL_bgl_string8062za700za7za7a8110za7, "Illegal `()' expression", 23);
	      DEFINE_STRING(BGl_string8063z00zzast_sexpz00,
		BgL_bgl_string8063za700za7za7a8111za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string8064z00zzast_sexpz00,
		BgL_bgl_string8064za700za7za7a8112za7, "Illegal formal argument", 23);
	      DEFINE_STRING(BGl_string8065z00zzast_sexpz00,
		BgL_bgl_string8065za700za7za7a8113za7, "Illegal `lambda' form", 21);
	      DEFINE_STRING(BGl_string8066z00zzast_sexpz00,
		BgL_bgl_string8066za700za7za7a8114za7,
		"Backend (~a) does not support external first class function", 59);
	      DEFINE_STRING(BGl_string8067z00zzast_sexpz00,
		BgL_bgl_string8067za700za7za7a8115za7, "Illegal pragma/effect", 21);
	      DEFINE_STRING(BGl_string8068z00zzast_sexpz00,
		BgL_bgl_string8068za700za7za7a8116za7, "Illegal free-pragma/effect", 26);
	      DEFINE_STRING(BGl_string8069z00zzast_sexpz00,
		BgL_bgl_string8069za700za7za7a8117za7, "Illegal lambda", 14);
	      DEFINE_STRING(BGl_string8070z00zzast_sexpz00,
		BgL_bgl_string8070za700za7za7a8118za7, "Illegal empty sequence", 22);
	      DEFINE_STRING(BGl_string8071z00zzast_sexpz00,
		BgL_bgl_string8071za700za7za7a8119za7, "Illegal mutation", 16);
	      DEFINE_STRING(BGl_string8072z00zzast_sexpz00,
		BgL_bgl_string8072za700za7za7a8120za7, "($1)", 4);
	      DEFINE_STRING(BGl_string8073z00zzast_sexpz00,
		BgL_bgl_string8073za700za7za7a8121za7, "<@", 2);
	      DEFINE_STRING(BGl_string8074z00zzast_sexpz00,
		BgL_bgl_string8074za700za7za7a8122za7, ":", 1);
	      DEFINE_STRING(BGl_string8075z00zzast_sexpz00,
		BgL_bgl_string8075za700za7za7a8123za7, "./", 2);
	      DEFINE_STRING(BGl_string8076z00zzast_sexpz00,
		BgL_bgl_string8076za700za7za7a8124za7, "@>", 2);
	      DEFINE_STRING(BGl_string8077z00zzast_sexpz00,
		BgL_bgl_string8077za700za7za7a8125za7, ">", 1);
	      DEFINE_STRING(BGl_string8078z00zzast_sexpz00,
		BgL_bgl_string8078za700za7za7a8126za7, "-", 1);
	      DEFINE_STRING(BGl_string8079z00zzast_sexpz00,
		BgL_bgl_string8079za700za7za7a8127za7, "ast_sexp", 8);
	      DEFINE_STRING(BGl_string8080z00zzast_sexpz00,
		BgL_bgl_string8080za700za7za7a8128za7,
		"not mutex @> bdb anonymous location pragma::obj (@ __evmeaning_address foreign) (@ define-primop! __evenv) at (@ define-primop-ref/loc! __evenv) (@ define-primop-ref! __evenv) write car exp app cons :prelock apply synchronize jump-exit set-exit case failure free-pragma/effect static-pragma free-pragma pragma/effect letrec* labels letrec let define begin -> __r4_control_features_6_9 quote @ eval bool test set! pragma else (quote ()) lambda value if (value apply app set! test) ",
		480);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_ifzd2symzd2envz00zzast_sexpz00,
		BgL_bgl_za762ifza7d2symza7b0za7za78129za7, BGl_z62ifzd2symzb0zzast_sexpz00,
		0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_usezd2variablez12zd2envz12zzast_sexpz00,
		BgL_bgl_za762useza7d2variabl8130z00,
		BGl_z62usezd2variablez12za2zzast_sexpz00, 0L, BUNSPEC, 3);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		     ADD_ROOT((void *) (&BGl_za2sitesza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2ifza2z00zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_requirezd2initializa7ationz75zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2nameza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2resza2zd2zzast_sexpz00));
		     ADD_ROOT((void *) (&BGl_za2cachezd2stackza2zd2zzast_sexpz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long
		BgL_checksumz00_13904, char *BgL_fromz00_13905)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_sexpz00))
				{
					BGl_requirezd2initializa7ationz75zzast_sexpz00 = BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zzast_sexpz00();
					BGl_libraryzd2moduleszd2initz00zzast_sexpz00();
					BGl_cnstzd2initzd2zzast_sexpz00();
					BGl_importedzd2moduleszd2initz00zzast_sexpz00();
					return BGl_toplevelzd2initzd2zzast_sexpz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_sexp");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0), "ast_sexp");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "ast_sexp");
			return BUNSPEC;
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			{	/* Ast/sexp.scm 14 */
				obj_t BgL_cportz00_13891;

				{	/* Ast/sexp.scm 14 */
					obj_t BgL_stringz00_13899;

					BgL_stringz00_13899 = BGl_string8080z00zzast_sexpz00;
					{	/* Ast/sexp.scm 14 */
						obj_t BgL_startz00_13900;

						BgL_startz00_13900 = BINT(((long) 0));
						{	/* Ast/sexp.scm 14 */
							obj_t BgL_endz00_13901;

							BgL_endz00_13901 =
								BINT(STRING_LENGTH(((obj_t) BgL_stringz00_13899)));
							{	/* Ast/sexp.scm 14 */

								BgL_cportz00_13891 =
									BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
									(BgL_stringz00_13899, BgL_startz00_13900, BgL_endz00_13901);
				}}}}
				{
					long BgL_iz00_13892;

					BgL_iz00_13892 = ((long) 48);
				BgL_loopz00_13893:
					if ((BgL_iz00_13892 == ((long) -1)))
						{	/* Ast/sexp.scm 14 */
							return BUNSPEC;
						}
					else
						{	/* Ast/sexp.scm 14 */
							{	/* Ast/sexp.scm 14 */
								obj_t BgL_arg8082z00_13895;

								{	/* Ast/sexp.scm 14 */

									{	/* Ast/sexp.scm 14 */
										obj_t BgL_locationz00_13897;

										BgL_locationz00_13897 = BBOOL(((bool_t) 0));
										{	/* Ast/sexp.scm 14 */

											BgL_arg8082z00_13895 =
												BGl_readz00zz__readerz00(BgL_cportz00_13891,
												BgL_locationz00_13897);
										}
									}
								}
								{	/* Ast/sexp.scm 14 */
									int BgL_tmpz00_13943;

									BgL_tmpz00_13943 = (int) (BgL_iz00_13892);
									CNST_TABLE_SET(BgL_tmpz00_13943, BgL_arg8082z00_13895);
							}}
							{	/* Ast/sexp.scm 14 */
								int BgL_auxz00_13898;

								BgL_auxz00_13898 = (int) ((BgL_iz00_13892 - ((long) 1)));
								{
									long BgL_iz00_13948;

									BgL_iz00_13948 = (long) (BgL_auxz00_13898);
									BgL_iz00_13892 = BgL_iz00_13948;
									goto BgL_loopz00_13893;
								}
							}
						}
				}
			}
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_za2sitesza2z00zzast_sexpz00 = CNST_TABLE_REF(((long) 0));
			BGl_za2ifza2z00zzast_sexpz00 =
				BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 1)));
			BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BFALSE;
			BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BFALSE;
			return (BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE, BUNSPEC);
		}

	}



/* top-level-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_17,
		obj_t BgL_locz00_18)
	{
		{	/* Ast/sexp.scm 66 */
			return
				((BgL_nodez00_bglt)
				BGl_zc3z04exitza31525ze3ze70z60zzast_sexpz00(BgL_locz00_18,
					BgL_expz00_17));
		}

	}



/* <@exit:1525>~0 */
	obj_t BGl_zc3z04exitza31525ze3ze70z60zzast_sexpz00(obj_t BgL_locz00_13889,
		obj_t BgL_expz00_13888)
	{
		{	/* Ast/sexp.scm 67 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1109z00_1715;

			if (SET_EXIT(BgL_an_exit1109z00_1715))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1109z00_1715 = (void *) jmpbuf;
					{	/* Ast/sexp.scm 67 */

						PUSH_EXIT(BgL_an_exit1109z00_1715, ((long) 1));
						{	/* Ast/sexp.scm 67 */
							obj_t BgL_an_exitd1110z00_1716;

							BgL_an_exitd1110z00_1716 = ((obj_t) (&exitd));
							{	/* Ast/sexp.scm 67 */
								obj_t BgL_res1112z00_1719;

								{	/* Ast/sexp.scm 70 */
									obj_t BgL_zc3z04anonymousza31538ze3z87_13831;
									obj_t BgL_zc3z04anonymousza31537ze3z87_13832;

									BgL_zc3z04anonymousza31538ze3z87_13831 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31538ze3ze5zzast_sexpz00,
										(int) (((long) 0)), (int) (((long) 2)));
									BgL_zc3z04anonymousza31537ze3z87_13832 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31537ze3ze5zzast_sexpz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31538ze3z87_13831,
										(int) (((long) 0)), BgL_expz00_13888);
									PROCEDURE_SET(BgL_zc3z04anonymousza31538ze3z87_13831,
										(int) (((long) 1)), BgL_locz00_13889);
									PROCEDURE_SET(BgL_zc3z04anonymousza31537ze3z87_13832,
										(int) (((long) 0)), BgL_an_exitd1110z00_1716);
									BgL_res1112z00_1719 =
										BGl_withzd2exceptionzd2handlerz00zz__errorz00
										(BgL_zc3z04anonymousza31537ze3z87_13832,
										BgL_zc3z04anonymousza31538ze3z87_13831);
								}
								POP_EXIT();
								return BgL_res1112z00_1719;
							}
						}
					}
				}
		}

	}



/* &top-level-sexp->node */
	BgL_nodez00_bglt BGl_z62topzd2levelzd2sexpzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13833, obj_t BgL_expz00_13834, obj_t BgL_locz00_13835)
	{
		{	/* Ast/sexp.scm 66 */
			return
				BGl_topzd2levelzd2sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13834,
				BgL_locz00_13835);
		}

	}



/* &<@anonymous:1538> */
	obj_t BGl_z62zc3z04anonymousza31538ze3ze5zzast_sexpz00(obj_t BgL_envz00_13836)
	{
		{	/* Ast/sexp.scm 72 */
			{	/* Ast/sexp.scm 73 */
				obj_t BgL_expz00_13837;
				obj_t BgL_locz00_13838;

				BgL_expz00_13837 = PROCEDURE_REF(BgL_envz00_13836, (int) (((long) 0)));
				BgL_locz00_13838 = PROCEDURE_REF(BgL_envz00_13836, (int) (((long) 1)));
				return
					((obj_t)
					BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13837, BNIL,
						BgL_locz00_13838, CNST_TABLE_REF(((long) 2))));
		}}

	}



/* &<@anonymous:1537> */
	obj_t BGl_z62zc3z04anonymousza31537ze3ze5zzast_sexpz00(obj_t BgL_envz00_13839,
		obj_t BgL_ez00_13841)
	{
		{	/* Ast/sexp.scm 69 */
			{	/* Ast/sexp.scm 70 */
				obj_t BgL_an_exitd1110z00_13840;

				BgL_an_exitd1110z00_13840 =
					PROCEDURE_REF(BgL_envz00_13839, (int) (((long) 0)));
				BGl_exceptionzd2notifyzd2zz__objectz00(BgL_ez00_13841);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1110z00_13840,
					BUNSPEC);
			}
		}

	}



/* if-sym */
	BGL_EXPORTED_DEF obj_t BGl_ifzd2symzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 88 */
			return BGl_za2ifza2z00zzast_sexpz00;
		}

	}



/* &if-sym */
	obj_t BGl_z62ifzd2symzb0zzast_sexpz00(obj_t BgL_envz00_13842)
	{
		{	/* Ast/sexp.scm 88 */
			return BGl_ifzd2symzd2zzast_sexpz00();
		}

	}



/* proc-or-lambda? */
	bool_t BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(obj_t BgL_ez00_20)
	{
		{	/* Ast/sexp.scm 100 */
			if (SYMBOLP(BgL_ez00_20))
				{	/* Ast/sexp.scm 101 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 101 */
					if (PAIRP(BgL_ez00_20))
						{	/* Ast/sexp.scm 101 */
							if ((CAR(BgL_ez00_20) == CNST_TABLE_REF(((long) 3))))
								{	/* Ast/sexp.scm 101 */
									obj_t BgL_tmpz00_13994;

									BgL_tmpz00_13994 = CDR(BgL_ez00_20);
									return PAIRP(BgL_tmpz00_13994);
								}
							else
								{	/* Ast/sexp.scm 101 */
									return ((bool_t) 0);
								}
						}
					else
						{	/* Ast/sexp.scm 101 */
							return ((bool_t) 0);
						}
				}
		}

	}



/* sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t
		BgL_expz00_21, obj_t BgL_stackz00_22, obj_t BgL_locz00_23,
		obj_t BgL_sitez00_24)
	{
		{	/* Ast/sexp.scm 114 */
		BGl_sexpzd2ze3nodez31zzast_sexpz00:
			{
				obj_t BgL_atomz00_1741;
				obj_t BgL_lz00_1746;
				obj_t BgL_bodyz00_1750;
				obj_t BgL_lz00_1755;
				obj_t BgL_valz00_1756;
				obj_t BgL_bodyz00_1760;
				obj_t BgL_argsz00_1761;
				obj_t BgL_bindingsz00_1763;
				obj_t BgL_exprz00_1764;
				obj_t BgL_varz00_1768;
				obj_t BgL_bodyz00_1769;
				obj_t BgL_argz00_1770;
				obj_t BgL_varsz00_1772;
				obj_t BgL_bodyz00_1773;
				obj_t BgL_argsz00_1774;
				obj_t BgL_testz00_1776;
				obj_t BgL_proc1z00_1777;
				obj_t BgL_proc2z00_1778;
				obj_t BgL_argsz00_1779;
				obj_t BgL_testz00_1781;
				obj_t BgL_proc1z00_1782;
				obj_t BgL_proc2z00_1783;
				obj_t BgL_argsz00_1784;
				obj_t BgL_effectz00_1788;
				obj_t BgL_restz00_1789;
				obj_t BgL_effectz00_1793;
				obj_t BgL_restz00_1794;

				if (NULLP(BgL_expz00_21))
					{	/* Ast/sexp.scm 119 */
						{	/* Ast/sexp.scm 122 */
							BgL_nodez00_bglt BgL_res7354z00_9655;

							{	/* Ast/sexp.scm 726 */
								obj_t BgL_arg7130z00_9651;
								BgL_nodez00_bglt BgL_arg7131z00_9652;

								BgL_arg7130z00_9651 =
									BGl_shapez00zztools_shapez00
									(BGl_currentzd2functionzd2zztools_errorz00());
								BgL_arg7131z00_9652 =
									BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
									BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
								{	/* Ast/sexp.scm 725 */
									obj_t BgL_list7132z00_9654;

									BgL_list7132z00_9654 =
										MAKE_YOUNG_PAIR(((obj_t) BgL_arg7131z00_9652), BNIL);
									BgL_res7354z00_9655 =
										((BgL_nodez00_bglt)
										BGl_userzd2errorzf2locationz20zztools_errorz00
										(BgL_locz00_23, BgL_arg7130z00_9651,
											BGl_string8062z00zzast_sexpz00, BgL_expz00_21,
											BgL_list7132z00_9654));
							}}
							return BgL_res7354z00_9655;
						}
					}
				else
					{	/* Ast/sexp.scm 119 */
						if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
								BGl_nodez00zzast_nodez00))
							{
								obj_t BgL_auxz00_14010;

								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_externz00zzast_nodez00))
									{	/* Ast/sexp.scm 127 */
										obj_t BgL_l01342z00_8370;

										BgL_l01342z00_8370 =
											(((BgL_externz00_bglt) COBJECT(
													((BgL_externz00_bglt) BgL_expz00_21)))->
											BgL_exprza2za2);
										{
											obj_t BgL_l1341z00_8372;

											BgL_l1341z00_8372 = BgL_l01342z00_8370;
										BgL_zc3z04anonymousza36635ze3z87_8373:
											if (NULLP(BgL_l1341z00_8372))
												{	/* Ast/sexp.scm 127 */
													BgL_l01342z00_8370;
												}
											else
												{	/* Ast/sexp.scm 127 */
													{	/* Ast/sexp.scm 127 */
														BgL_nodez00_bglt BgL_arg6637z00_8375;

														{	/* Ast/sexp.scm 127 */
															obj_t BgL_ez00_8376;

															BgL_ez00_8376 = CAR(((obj_t) BgL_l1341z00_8372));
															{	/* Ast/sexp.scm 127 */
																obj_t BgL_arg6638z00_8377;

																BgL_arg6638z00_8377 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_externz00_bglt)
																					BgL_expz00_21))))->BgL_locz00);
																BgL_arg6637z00_8375 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8376, BgL_stackz00_22,
																	BgL_arg6638z00_8377,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 127 */
															obj_t BgL_auxz00_14026;
															obj_t BgL_tmpz00_14024;

															BgL_auxz00_14026 = ((obj_t) BgL_arg6637z00_8375);
															BgL_tmpz00_14024 = ((obj_t) BgL_l1341z00_8372);
															SET_CAR(BgL_tmpz00_14024, BgL_auxz00_14026);
													}}
													{	/* Ast/sexp.scm 127 */
														obj_t BgL_arg6639z00_8378;

														BgL_arg6639z00_8378 =
															CDR(((obj_t) BgL_l1341z00_8372));
														{
															obj_t BgL_l1341z00_14031;

															BgL_l1341z00_14031 = BgL_arg6639z00_8378;
															BgL_l1341z00_8372 = BgL_l1341z00_14031;
															goto BgL_zc3z04anonymousza36635ze3z87_8373;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 125 */
										BFALSE;
									}
								if (BGl_isazf3zf3zz__objectz00(BgL_expz00_21,
										BGl_appz00zzast_nodez00))
									{	/* Ast/sexp.scm 130 */
										obj_t BgL_l01345z00_8382;

										BgL_l01345z00_8382 =
											(((BgL_appz00_bglt) COBJECT(
													((BgL_appz00_bglt) BgL_expz00_21)))->BgL_argsz00);
										{
											obj_t BgL_l1344z00_8384;

											BgL_l1344z00_8384 = BgL_l01345z00_8382;
										BgL_zc3z04anonymousza36641ze3z87_8385:
											if (NULLP(BgL_l1344z00_8384))
												{	/* Ast/sexp.scm 130 */
													BgL_l01345z00_8382;
												}
											else
												{	/* Ast/sexp.scm 130 */
													{	/* Ast/sexp.scm 130 */
														BgL_nodez00_bglt BgL_arg6643z00_8387;

														{	/* Ast/sexp.scm 130 */
															obj_t BgL_ez00_8388;

															BgL_ez00_8388 = CAR(((obj_t) BgL_l1344z00_8384));
															{	/* Ast/sexp.scm 130 */
																obj_t BgL_arg6644z00_8389;

																BgL_arg6644z00_8389 =
																	(((BgL_nodez00_bglt) COBJECT(
																			((BgL_nodez00_bglt)
																				((BgL_appz00_bglt) BgL_expz00_21))))->
																	BgL_locz00);
																BgL_arg6643z00_8387 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(BgL_ez00_8388, BgL_stackz00_22,
																	BgL_arg6644z00_8389,
																	CNST_TABLE_REF(((long) 2)));
														}}
														{	/* Ast/sexp.scm 130 */
															obj_t BgL_auxz00_14047;
															obj_t BgL_tmpz00_14045;

															BgL_auxz00_14047 = ((obj_t) BgL_arg6643z00_8387);
															BgL_tmpz00_14045 = ((obj_t) BgL_l1344z00_8384);
															SET_CAR(BgL_tmpz00_14045, BgL_auxz00_14047);
													}}
													{	/* Ast/sexp.scm 130 */
														obj_t BgL_arg6645z00_8390;

														BgL_arg6645z00_8390 =
															CDR(((obj_t) BgL_l1344z00_8384));
														{
															obj_t BgL_l1344z00_14052;

															BgL_l1344z00_14052 = BgL_arg6645z00_8390;
															BgL_l1344z00_8384 = BgL_l1344z00_14052;
															goto BgL_zc3z04anonymousza36641ze3z87_8385;
														}
													}
												}
										}
									}
								else
									{	/* Ast/sexp.scm 128 */
										BFALSE;
									}
								BgL_auxz00_14010 = BgL_expz00_21;
								return ((BgL_nodez00_bglt) BgL_auxz00_14010);
							}
						else
							{	/* Ast/sexp.scm 119 */
								if (PAIRP(BgL_expz00_21))
									{	/* Ast/sexp.scm 119 */
										obj_t BgL_carzd2478zd2_1815;

										BgL_carzd2478zd2_1815 = CAR(BgL_expz00_21);
										if (SYMBOLP(BgL_carzd2478zd2_1815))
											{	/* Ast/sexp.scm 119 */
												bool_t BgL_test8144z00_14059;

												{	/* Ast/sexp.scm 119 */
													obj_t BgL__ortest_1144z00_5095;

													BgL__ortest_1144z00_5095 =
														BGl_findzd2localzd2zzast_sexpz00
														(BgL_carzd2478zd2_1815, BgL_stackz00_22);
													if (CBOOL(BgL__ortest_1144z00_5095))
														{	/* Ast/sexp.scm 119 */
															BgL_test8144z00_14059 =
																CBOOL(BgL__ortest_1144z00_5095);
														}
													else
														{	/* Ast/sexp.scm 119 */
															obj_t BgL_gz00_5096;

															BgL_gz00_5096 =
																BGl_findzd2globalzd2zzast_envz00
																(BgL_carzd2478zd2_1815, BNIL);
															if (CBOOL(BgL_gz00_5096))
																{	/* Ast/sexp.scm 119 */
																	if (
																		((((BgL_globalz00_bglt) COBJECT(
																						((BgL_globalz00_bglt)
																							BgL_gz00_5096)))->
																				BgL_modulez00) ==
																			CNST_TABLE_REF(((long) 13))))
																		{	/* Ast/sexp.scm 119 */
																			BgL_test8144z00_14059 = ((bool_t) 0);
																		}
																	else
																		{	/* Ast/sexp.scm 119 */
																			BgL_test8144z00_14059 = ((bool_t) 1);
																		}
																}
															else
																{	/* Ast/sexp.scm 119 */
																	BgL_test8144z00_14059 = ((bool_t) 0);
																}
														}
												}
												if (BgL_test8144z00_14059)
													{	/* Ast/sexp.scm 119 */
														return
															BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21,
															BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
													}
												else
													{	/* Ast/sexp.scm 119 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 11))))
															{	/* Ast/sexp.scm 119 */
															BgL_tagzd2371zd2_1745:
																{	/* Ast/sexp.scm 174 */
																	obj_t BgL_locz00_8422;

																	BgL_locz00_8422 =
																		BGl_findzd2locationzf2locz20zztools_locationz00
																		(BgL_expz00_21, BgL_locz00_23);
																	{
																		obj_t BgL_namez00_8423;
																		obj_t BgL_modulez00_8424;

																		if (PAIRP(BgL_expz00_21))
																			{	/* Ast/sexp.scm 175 */
																				obj_t BgL_cdrzd262164zd2_8429;

																				BgL_cdrzd262164zd2_8429 =
																					CDR(BgL_expz00_21);
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 11))))
																					{	/* Ast/sexp.scm 175 */
																						if (PAIRP(BgL_cdrzd262164zd2_8429))
																							{	/* Ast/sexp.scm 175 */
																								obj_t BgL_carzd262167zd2_8433;
																								obj_t BgL_cdrzd262168zd2_8434;

																								BgL_carzd262167zd2_8433 =
																									CAR(BgL_cdrzd262164zd2_8429);
																								BgL_cdrzd262168zd2_8434 =
																									CDR(BgL_cdrzd262164zd2_8429);
																								if (SYMBOLP
																									(BgL_carzd262167zd2_8433))
																									{	/* Ast/sexp.scm 175 */
																										if (PAIRP
																											(BgL_cdrzd262168zd2_8434))
																											{	/* Ast/sexp.scm 175 */
																												obj_t
																													BgL_carzd262173zd2_8437;
																												BgL_carzd262173zd2_8437
																													=
																													CAR
																													(BgL_cdrzd262168zd2_8434);
																												if (SYMBOLP
																													(BgL_carzd262173zd2_8437))
																													{	/* Ast/sexp.scm 175 */
																														if (NULLP(CDR
																																(BgL_cdrzd262168zd2_8434)))
																															{	/* Ast/sexp.scm 175 */
																																BgL_namez00_8423
																																	=
																																	BgL_carzd262167zd2_8433;
																																BgL_modulez00_8424
																																	=
																																	BgL_carzd262173zd2_8437;
																																{	/* Ast/sexp.scm 177 */
																																	obj_t
																																		BgL_globalz00_8443;
																																	obj_t
																																		BgL_locz00_8444;
																																	BgL_globalz00_8443
																																		=
																																		BGl_findzd2globalzf2modulez20zzast_envz00
																																		(BgL_namez00_8423,
																																		BgL_modulez00_8424);
																																	BgL_locz00_8444
																																		=
																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																		(BgL_namez00_8423,
																																		BgL_locz00_8422);
																																	if (BGl_isazf3zf3zz__objectz00(BgL_globalz00_8443, BGl_globalz00zzast_varz00))
																																		{	/* Ast/sexp.scm 180 */
																																			if (
																																				((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_globalz00_8443)))->BgL_importz00) == CNST_TABLE_REF(((long) 10))))
																																				{	/* Ast/sexp.scm 183 */
																																					obj_t
																																						BgL_arg6678z00_8448;
																																					{	/* Ast/sexp.scm 183 */
																																						obj_t
																																							BgL_arg6679z00_8449;
																																						BgL_arg6679z00_8449
																																							=
																																							MAKE_YOUNG_PAIR
																																							(BGl_atomz00zzast_nodez00,
																																							BNIL);
																																						BgL_arg6678z00_8448
																																							=
																																							MAKE_YOUNG_PAIR
																																							(CNST_TABLE_REF
																																							(((long) 10)), BgL_arg6679z00_8449);
																																					}
																																					{
																																						obj_t
																																							BgL_locz00_14112;
																																						obj_t
																																							BgL_expz00_14111;
																																						BgL_expz00_14111
																																							=
																																							BgL_arg6678z00_8448;
																																						BgL_locz00_14112
																																							=
																																							BgL_locz00_8444;
																																						BgL_locz00_23
																																							=
																																							BgL_locz00_14112;
																																						BgL_expz00_21
																																							=
																																							BgL_expz00_14111;
																																						goto
																																							BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 182 */
																																					return
																																						BGl_variablezd2ze3nodez31zzast_sexpz00
																																						(BgL_globalz00_8443,
																																						BgL_locz00_8444,
																																						BgL_sitez00_24);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 181 */
																																			BgL_nodez00_bglt
																																				BgL_res7371z00_9699;
																																			{	/* Ast/sexp.scm 726 */
																																				obj_t
																																					BgL_arg7130z00_9695;
																																				BgL_nodez00_bglt
																																					BgL_arg7131z00_9696;
																																				BgL_arg7130z00_9695
																																					=
																																					BGl_shapez00zztools_shapez00
																																					(BGl_currentzd2functionzd2zztools_errorz00
																																					());
																																				BgL_arg7131z00_9696
																																					=
																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																					(CNST_TABLE_REF
																																					(((long) 4)), BNIL, BgL_locz00_8444, CNST_TABLE_REF(((long) 2)));
																																				{	/* Ast/sexp.scm 725 */
																																					obj_t
																																						BgL_list7132z00_9698;
																																					BgL_list7132z00_9698
																																						=
																																						MAKE_YOUNG_PAIR
																																						(((obj_t) BgL_arg7131z00_9696), BNIL);
																																					BgL_res7371z00_9699
																																						=
																																						(
																																						(BgL_nodez00_bglt)
																																						BGl_userzd2errorzf2locationz20zztools_errorz00
																																						(BgL_locz00_8444,
																																							BgL_arg7130z00_9695,
																																							BGl_string8060z00zzast_sexpz00,
																																							BgL_expz00_21,
																																							BgL_list7132z00_9698));
																																			}}
																																			return
																																				BgL_res7371z00_9699;
																																		}
																																}
																															}
																														else
																															{	/* Ast/sexp.scm 175 */
																															BgL_tagzd262157zd2_8426:
																																{	/* Ast/sexp.scm 187 */
																																	BgL_nodez00_bglt
																																		BgL_res7372z00_9705;
																																	{	/* Ast/sexp.scm 726 */
																																		obj_t
																																			BgL_arg7130z00_9701;
																																		BgL_nodez00_bglt
																																			BgL_arg7131z00_9702;
																																		BgL_arg7130z00_9701
																																			=
																																			BGl_shapez00zztools_shapez00
																																			(BGl_currentzd2functionzd2zztools_errorz00
																																			());
																																		BgL_arg7131z00_9702
																																			=
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																			(CNST_TABLE_REF
																																			(((long)
																																					4)),
																																			BNIL,
																																			BgL_locz00_8422,
																																			CNST_TABLE_REF
																																			(((long)
																																					2)));
																																		{	/* Ast/sexp.scm 725 */
																																			obj_t
																																				BgL_list7132z00_9704;
																																			BgL_list7132z00_9704
																																				=
																																				MAKE_YOUNG_PAIR
																																				(((obj_t) BgL_arg7131z00_9702), BNIL);
																																			BgL_res7372z00_9705
																																				=
																																				(
																																				(BgL_nodez00_bglt)
																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																				(BgL_locz00_8422,
																																					BgL_arg7130z00_9701,
																																					BGl_string8059z00zzast_sexpz00,
																																					BgL_expz00_21,
																																					BgL_list7132z00_9704));
																																	}}
																																	return
																																		BgL_res7372z00_9705;
																																}
																															}
																													}
																												else
																													{	/* Ast/sexp.scm 175 */
																														goto
																															BgL_tagzd262157zd2_8426;
																													}
																											}
																										else
																											{	/* Ast/sexp.scm 175 */
																												goto
																													BgL_tagzd262157zd2_8426;
																											}
																									}
																								else
																									{	/* Ast/sexp.scm 175 */
																										goto
																											BgL_tagzd262157zd2_8426;
																									}
																							}
																						else
																							{	/* Ast/sexp.scm 175 */
																								goto BgL_tagzd262157zd2_8426;
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 175 */
																						goto BgL_tagzd262157zd2_8426;
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 175 */
																				goto BgL_tagzd262157zd2_8426;
																			}
																	}
																}
															}
														else
															{	/* Ast/sexp.scm 119 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 14))))
																	{	/* Ast/sexp.scm 119 */
																		BgL_lz00_1746 = CDR(BgL_expz00_21);
																	BgL_tagzd2372zd2_1747:
																		{	/* Ast/sexp.scm 190 */
																			bool_t BgL_test8159z00_14136;

																			if (PAIRP(BgL_lz00_1746))
																				{	/* Ast/sexp.scm 190 */
																					bool_t BgL_test8161z00_14139;

																					{	/* Ast/sexp.scm 190 */
																						obj_t BgL_tmpz00_14140;

																						BgL_tmpz00_14140 =
																							CDR(BgL_lz00_1746);
																						BgL_test8161z00_14139 =
																							PAIRP(BgL_tmpz00_14140);
																					}
																					if (BgL_test8161z00_14139)
																						{
																							obj_t BgL_l1346z00_8468;

																							BgL_l1346z00_8468 = BgL_lz00_1746;
																						BgL_zc3z04anonymousza36690ze3z87_8469:
																							if (NULLP
																								(BgL_l1346z00_8468))
																								{	/* Ast/sexp.scm 190 */
																									BgL_test8159z00_14136 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Ast/sexp.scm 190 */
																									bool_t BgL_test8163z00_14145;

																									{	/* Ast/sexp.scm 190 */
																										obj_t BgL_tmpz00_14146;

																										BgL_tmpz00_14146 =
																											CAR(
																											((obj_t)
																												BgL_l1346z00_8468));
																										BgL_test8163z00_14145 =
																											SYMBOLP(BgL_tmpz00_14146);
																									}
																									if (BgL_test8163z00_14145)
																										{
																											obj_t BgL_l1346z00_14150;

																											BgL_l1346z00_14150 =
																												CDR(
																												((obj_t)
																													BgL_l1346z00_8468));
																											BgL_l1346z00_8468 =
																												BgL_l1346z00_14150;
																											goto
																												BgL_zc3z04anonymousza36690ze3z87_8469;
																										}
																									else
																										{	/* Ast/sexp.scm 190 */
																											BgL_test8159z00_14136 =
																												((bool_t) 0);
																										}
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 190 */
																							BgL_test8159z00_14136 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 190 */
																					BgL_test8159z00_14136 = ((bool_t) 0);
																				}
																			if (BgL_test8159z00_14136)
																				{	/* Ast/sexp.scm 190 */
																					return
																						BGl_fieldzd2refzd2ze3nodeze3zzast_objectz00
																						(BgL_lz00_1746, BgL_expz00_21,
																						BgL_stackz00_22, BgL_locz00_23,
																						BgL_sitez00_24);
																				}
																			else
																				{	/* Ast/sexp.scm 192 */
																					BgL_nodez00_bglt BgL_res7383z00_9730;

																					{	/* Ast/sexp.scm 726 */
																						obj_t BgL_arg7130z00_9726;
																						BgL_nodez00_bglt
																							BgL_arg7131z00_9727;
																						BgL_arg7130z00_9726 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7131z00_9727 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_23,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 725 */
																							obj_t BgL_list7132z00_9729;

																							BgL_list7132z00_9729 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7131z00_9727),
																								BNIL);
																							BgL_res7383z00_9730 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_23,
																									BgL_arg7130z00_9726,
																									BGl_string8056z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7132z00_9729));
																					}}
																					return BgL_res7383z00_9730;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 119 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 12))))
																			{	/* Ast/sexp.scm 119 */
																			BgL_tagzd2373zd2_1748:
																				{
																					obj_t BgL_valuez00_8477;

																					if (PAIRP(BgL_expz00_21))
																						{	/* Ast/sexp.scm 119 */
																							obj_t BgL_cdrzd262184zd2_8482;

																							BgL_cdrzd262184zd2_8482 =
																								CDR(BgL_expz00_21);
																							if (PAIRP
																								(BgL_cdrzd262184zd2_8482))
																								{	/* Ast/sexp.scm 119 */
																									if (NULLP(CDR
																											(BgL_cdrzd262184zd2_8482)))
																										{	/* Ast/sexp.scm 119 */
																											BgL_valuez00_8477 =
																												CAR
																												(BgL_cdrzd262184zd2_8482);
																											{	/* Ast/sexp.scm 197 */
																												obj_t BgL_locz00_8488;

																												BgL_locz00_8488 =
																													BGl_findzd2locationzf2locz20zztools_locationz00
																													(BgL_expz00_21,
																													BgL_locz00_23);
																												if (NULLP
																													(BgL_valuez00_8477))
																													{	/* Ast/sexp.scm 200 */
																														BgL_literalz00_bglt
																															BgL_new1120z00_8490;
																														{	/* Ast/sexp.scm 201 */
																															BgL_literalz00_bglt
																																BgL_new1119z00_8492;
																															BgL_new1119z00_8492
																																=
																																(
																																(BgL_literalz00_bglt)
																																BOBJECT
																																(GC_MALLOC
																																	(sizeof(struct
																																			BgL_literalz00_bgl))));
																															{	/* Ast/sexp.scm 201 */
																																long
																																	BgL_arg6702z00_8493;
																																{	/* Ast/sexp.scm 201 */
																																	long
																																		BgL_res7385z00_9733;
																																	BgL_res7385z00_9733
																																		=
																																		BGL_CLASS_INDEX
																																		(BGl_literalz00zzast_nodez00);
																																	BgL_arg6702z00_8493
																																		=
																																		BgL_res7385z00_9733;
																																}
																																BGL_OBJECT_CLASS_NUM_SET
																																	(((BgL_objectz00_bglt) BgL_new1119z00_8492), BgL_arg6702z00_8493);
																															}
																															{	/* Ast/sexp.scm 201 */
																																BgL_objectz00_bglt
																																	BgL_tmpz00_14183;
																																BgL_tmpz00_14183
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	BgL_new1119z00_8492);
																																BGL_OBJECT_WIDENING_SET
																																	(BgL_tmpz00_14183,
																																	BFALSE);
																															}
																															((BgL_objectz00_bglt) BgL_new1119z00_8492);
																															BgL_new1120z00_8490
																																=
																																BgL_new1119z00_8492;
																														}
																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1120z00_8490)))->BgL_locz00) = ((obj_t) BgL_locz00_8488), BUNSPEC);
																														{
																															BgL_typez00_bglt
																																BgL_auxz00_14189;
																															{	/* Ast/sexp.scm 202 */
																																BgL_typez00_bglt
																																	BgL_arg6701z00_8491;
																																BgL_arg6701z00_8491
																																	=
																																	BGl_getzd2typezd2kwotez00zztype_typeofz00
																																	(BgL_valuez00_8477);
																																BgL_auxz00_14189
																																	=
																																	BGl_strictzd2nodezd2typez00zzast_nodez00
																																	(BgL_arg6701z00_8491,
																																	((BgL_typez00_bglt) BGl_za2bnilza2z00zztype_cachez00));
																															}
																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1120z00_8490)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_14189), BUNSPEC);
																														}
																														((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_new1120z00_8490)))->BgL_valuez00) = ((obj_t) BNIL), BUNSPEC);
																														return
																															(
																															(BgL_nodez00_bglt)
																															BgL_new1120z00_8490);
																													}
																												else
																													{	/* Ast/sexp.scm 204 */
																														bool_t
																															BgL_test8169z00_14198;
																														if (PAIRP
																															(BgL_valuez00_8477))
																															{	/* Ast/sexp.scm 204 */
																																BgL_test8169z00_14198
																																	=
																																	((bool_t) 1);
																															}
																														else
																															{	/* Ast/sexp.scm 204 */
																																if (VECTORP
																																	(BgL_valuez00_8477))
																																	{	/* Ast/sexp.scm 205 */
																																		BgL_test8169z00_14198
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 205 */
																																		if (BGL_HVECTORP(BgL_valuez00_8477))
																																			{	/* Ast/sexp.scm 206 */
																																				BgL_test8169z00_14198
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 206 */
																																				if (STRUCTP(BgL_valuez00_8477))
																																					{	/* Ast/sexp.scm 207 */
																																						BgL_test8169z00_14198
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 207 */
																																						if (SYMBOLP(BgL_valuez00_8477))
																																							{	/* Ast/sexp.scm 208 */
																																								BgL_test8169z00_14198
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 208 */
																																								BgL_test8169z00_14198
																																									=
																																									KEYWORDP
																																									(BgL_valuez00_8477);
																																							}
																																					}
																																			}
																																	}
																															}
																														if (BgL_test8169z00_14198)
																															{	/* Ast/sexp.scm 210 */
																																BgL_kwotez00_bglt
																																	BgL_new1122z00_8500;
																																{	/* Ast/sexp.scm 211 */
																																	BgL_kwotez00_bglt
																																		BgL_new1121z00_8502;
																																	BgL_new1121z00_8502
																																		=
																																		(
																																		(BgL_kwotez00_bglt)
																																		BOBJECT
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_kwotez00_bgl))));
																																	{	/* Ast/sexp.scm 211 */
																																		long
																																			BgL_arg6710z00_8503;
																																		{	/* Ast/sexp.scm 211 */
																																			long
																																				BgL_res7391z00_9743;
																																			BgL_res7391z00_9743
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_kwotez00zzast_nodez00);
																																			BgL_arg6710z00_8503
																																				=
																																				BgL_res7391z00_9743;
																																		}
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1121z00_8502), BgL_arg6710z00_8503);
																																	}
																																	{	/* Ast/sexp.scm 211 */
																																		BgL_objectz00_bglt
																																			BgL_tmpz00_14214;
																																		BgL_tmpz00_14214
																																			=
																																			(
																																			(BgL_objectz00_bglt)
																																			BgL_new1121z00_8502);
																																		BGL_OBJECT_WIDENING_SET
																																			(BgL_tmpz00_14214,
																																			BFALSE);
																																	}
																																	((BgL_objectz00_bglt) BgL_new1121z00_8502);
																																	BgL_new1122z00_8500
																																		=
																																		BgL_new1121z00_8502;
																																}
																																((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1122z00_8500)))->BgL_locz00) = ((obj_t) BgL_locz00_8488), BUNSPEC);
																																{
																																	BgL_typez00_bglt
																																		BgL_auxz00_14220;
																																	{	/* Ast/sexp.scm 212 */
																																		BgL_typez00_bglt
																																			BgL_arg6709z00_8501;
																																		BgL_arg6709z00_8501
																																			=
																																			BGl_getzd2typezd2kwotez00zztype_typeofz00
																																			(BgL_valuez00_8477);
																																		BgL_auxz00_14220
																																			=
																																			BGl_strictzd2nodezd2typez00zzast_nodez00
																																			(BgL_arg6709z00_8501,
																																			((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00));
																																	}
																																	((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1122z00_8500)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_14220), BUNSPEC);
																																}
																																((((BgL_kwotez00_bglt) COBJECT(BgL_new1122z00_8500))->BgL_valuez00) = ((obj_t) BgL_valuez00_8477), BUNSPEC);
																																return
																																	(
																																	(BgL_nodez00_bglt)
																																	BgL_new1122z00_8500);
																															}
																														else
																															{	/* Ast/sexp.scm 214 */
																																bool_t
																																	BgL_test8175z00_14228;
																																if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_valuez00_8477))
																																	{	/* Ast/sexp.scm 214 */
																																		BgL_test8175z00_14228
																																			=
																																			((bool_t)
																																			1);
																																	}
																																else
																																	{	/* Ast/sexp.scm 214 */
																																		if (STRINGP
																																			(BgL_valuez00_8477))
																																			{	/* Ast/sexp.scm 215 */
																																				BgL_test8175z00_14228
																																					=
																																					(
																																					(bool_t)
																																					1);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 215 */
																																				if (CNSTP(BgL_valuez00_8477))
																																					{	/* Ast/sexp.scm 216 */
																																						BgL_test8175z00_14228
																																							=
																																							(
																																							(bool_t)
																																							1);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 216 */
																																						if (CHARP(BgL_valuez00_8477))
																																							{	/* Ast/sexp.scm 220 */
																																								BgL_test8175z00_14228
																																									=
																																									(
																																									(bool_t)
																																									1);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 220 */
																																								BgL_test8175z00_14228
																																									=
																																									BOOLEANP
																																									(BgL_valuez00_8477);
																																							}
																																					}
																																			}
																																	}
																																if (BgL_test8175z00_14228)
																																	{
																																		obj_t
																																			BgL_locz00_14239;
																																		obj_t
																																			BgL_expz00_14238;
																																		BgL_expz00_14238
																																			=
																																			BgL_valuez00_8477;
																																		BgL_locz00_14239
																																			=
																																			BgL_locz00_8488;
																																		BgL_locz00_23
																																			=
																																			BgL_locz00_14239;
																																		BgL_expz00_21
																																			=
																																			BgL_expz00_14238;
																																		goto
																																			BGl_sexpzd2ze3nodez31zzast_sexpz00;
																																	}
																																else
																																	{	/* Ast/sexp.scm 224 */
																																		BgL_nodez00_bglt
																																			BgL_res7396z00_9756;
																																		{	/* Ast/sexp.scm 726 */
																																			obj_t
																																				BgL_arg7130z00_9752;
																																			BgL_nodez00_bglt
																																				BgL_arg7131z00_9753;
																																			BgL_arg7130z00_9752
																																				=
																																				BGl_shapez00zztools_shapez00
																																				(BGl_currentzd2functionzd2zztools_errorz00
																																				());
																																			BgL_arg7131z00_9753
																																				=
																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																				(CNST_TABLE_REF
																																				(((long)
																																						4)),
																																				BNIL,
																																				BgL_locz00_8488,
																																				CNST_TABLE_REF
																																				(((long)
																																						2)));
																																			{	/* Ast/sexp.scm 725 */
																																				obj_t
																																					BgL_list7132z00_9755;
																																				BgL_list7132z00_9755
																																					=
																																					MAKE_YOUNG_PAIR
																																					(((obj_t) BgL_arg7131z00_9753), BNIL);
																																				BgL_res7396z00_9756
																																					=
																																					(
																																					(BgL_nodez00_bglt)
																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																					(BgL_locz00_8488,
																																						BgL_arg7130z00_9752,
																																						BGl_string8058z00zzast_sexpz00,
																																						BgL_expz00_21,
																																						BgL_list7132z00_9755));
																																		}}
																																		return
																																			BgL_res7396z00_9756;
																																	}
																															}
																													}
																											}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																										BgL_tagzd262179zd2_8479:
																											{	/* Ast/sexp.scm 226 */
																												BgL_nodez00_bglt
																													BgL_res7397z00_9762;
																												{	/* Ast/sexp.scm 726 */
																													obj_t
																														BgL_arg7130z00_9758;
																													BgL_nodez00_bglt
																														BgL_arg7131z00_9759;
																													BgL_arg7130z00_9758 =
																														BGl_shapez00zztools_shapez00
																														(BGl_currentzd2functionzd2zztools_errorz00
																														());
																													BgL_arg7131z00_9759 =
																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																														(CNST_TABLE_REF((
																																(long) 4)),
																														BNIL, BgL_locz00_23,
																														CNST_TABLE_REF((
																																(long) 2)));
																													{	/* Ast/sexp.scm 725 */
																														obj_t
																															BgL_list7132z00_9761;
																														BgL_list7132z00_9761
																															=
																															MAKE_YOUNG_PAIR((
																																(obj_t)
																																BgL_arg7131z00_9759),
																															BNIL);
																														BgL_res7397z00_9762
																															=
																															(
																															(BgL_nodez00_bglt)
																															BGl_userzd2errorzf2locationz20zztools_errorz00
																															(BgL_locz00_23,
																																BgL_arg7130z00_9758,
																																BGl_string8058z00zzast_sexpz00,
																																BgL_expz00_21,
																																BgL_list7132z00_9761));
																												}}
																												return
																													BgL_res7397z00_9762;
																											}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									goto BgL_tagzd262179zd2_8479;
																								}
																						}
																					else
																						{	/* Ast/sexp.scm 119 */
																							goto BgL_tagzd262179zd2_8479;
																						}
																				}
																			}
																		else
																			{	/* Ast/sexp.scm 119 */
																				if (
																					(CAR(BgL_expz00_21) ==
																						CNST_TABLE_REF(((long) 15))))
																					{	/* Ast/sexp.scm 119 */
																						if (NULLP(CDR(BgL_expz00_21)))
																							{	/* Ast/sexp.scm 119 */
																							BgL_tagzd2374zd2_1749:
																								{
																									obj_t BgL_locz00_14267;
																									obj_t BgL_expz00_14266;

																									BgL_expz00_14266 = BUNSPEC;
																									BgL_locz00_14267 =
																										BGl_findzd2locationzf2locz20zztools_locationz00
																										(BgL_expz00_21,
																										BgL_locz00_23);
																									BgL_locz00_23 =
																										BgL_locz00_14267;
																									BgL_expz00_21 =
																										BgL_expz00_14266;
																									goto
																										BGl_sexpzd2ze3nodez31zzast_sexpz00;
																								}
																							}
																						else
																							{	/* Ast/sexp.scm 119 */
																								obj_t BgL_arg1610z00_1837;

																								BgL_arg1610z00_1837 =
																									CDR(BgL_expz00_21);
																								{
																									BgL_sequencez00_bglt
																										BgL_auxz00_14270;
																									BgL_bodyz00_1750 =
																										BgL_arg1610z00_1837;
																								BgL_tagzd2375zd2_1751:
																									{	/* Ast/sexp.scm 231 */
																										obj_t BgL_locz00_8519;

																										BgL_locz00_8519 =
																											BGl_findzd2locationzf2locz20zztools_locationz00
																											(BgL_expz00_21,
																											BgL_locz00_23);
																										{	/* Ast/sexp.scm 231 */
																											obj_t BgL_nodesz00_8520;

																											BgL_nodesz00_8520 =
																												BGl_sexpza2zd2ze3nodez93zzast_sexpz00
																												(BgL_bodyz00_1750,
																												BgL_stackz00_22,
																												BgL_locz00_8519,
																												BgL_sitez00_24);
																											{	/* Ast/sexp.scm 232 */

																												{	/* Ast/sexp.scm 233 */
																													BgL_sequencez00_bglt
																														BgL_new1125z00_8521;
																													{	/* Ast/sexp.scm 234 */
																														BgL_sequencez00_bglt
																															BgL_new1124z00_8522;
																														BgL_new1124z00_8522
																															=
																															(
																															(BgL_sequencez00_bglt)
																															BOBJECT(GC_MALLOC
																																(sizeof(struct
																																		BgL_sequencez00_bgl))));
																														{	/* Ast/sexp.scm 234 */
																															long
																																BgL_arg6717z00_8523;
																															{	/* Ast/sexp.scm 234 */
																																long
																																	BgL_res7401z00_9770;
																																BgL_res7401z00_9770
																																	=
																																	BGL_CLASS_INDEX
																																	(BGl_sequencez00zzast_nodez00);
																																BgL_arg6717z00_8523
																																	=
																																	BgL_res7401z00_9770;
																															}
																															BGL_OBJECT_CLASS_NUM_SET
																																(((BgL_objectz00_bglt) BgL_new1124z00_8522), BgL_arg6717z00_8523);
																														}
																														{	/* Ast/sexp.scm 234 */
																															BgL_objectz00_bglt
																																BgL_tmpz00_14277;
																															BgL_tmpz00_14277 =
																																(
																																(BgL_objectz00_bglt)
																																BgL_new1124z00_8522);
																															BGL_OBJECT_WIDENING_SET
																																(BgL_tmpz00_14277,
																																BFALSE);
																														}
																														((BgL_objectz00_bglt) BgL_new1124z00_8522);
																														BgL_new1125z00_8521
																															=
																															BgL_new1124z00_8522;
																													}
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1125z00_8521)))->
																															BgL_locz00) =
																														((obj_t)
																															BgL_locz00_8519),
																														BUNSPEC);
																													((((BgL_nodez00_bglt)
																																COBJECT((
																																		(BgL_nodez00_bglt)
																																		BgL_new1125z00_8521)))->
																															BgL_typez00) =
																														((BgL_typez00_bglt)
																															((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1125z00_8521)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																													((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1125z00_8521)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8521))->BgL_nodesz00) = ((obj_t) BgL_nodesz00_8520), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8521))->BgL_unsafez00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													((((BgL_sequencez00_bglt) COBJECT(BgL_new1125z00_8521))->BgL_metaz00) = ((obj_t) BNIL), BUNSPEC);
																													BgL_auxz00_14270 =
																														BgL_new1125z00_8521;
																									}}}}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_14270);
																								}
																							}
																					}
																				else
																					{	/* Ast/sexp.scm 119 */
																						obj_t BgL_carzd2610zd2_1839;
																						obj_t BgL_cdrzd2611zd2_1840;

																						BgL_carzd2610zd2_1839 =
																							CAR(BgL_expz00_21);
																						BgL_cdrzd2611zd2_1840 =
																							CDR(BgL_expz00_21);
																						{

																							if (
																								(BgL_carzd2610zd2_1839 ==
																									CNST_TABLE_REF(((long) 1))))
																								{
																									obj_t BgL_auxz00_14300;

																								BgL_kapzd2612zd2_1841:
																									if (PAIRP
																										(BgL_cdrzd2611zd2_1840))
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd2615zd2_2588;
																											BgL_cdrzd2615zd2_2588 =
																												CDR
																												(BgL_cdrzd2611zd2_1840);
																											if (PAIRP
																												(BgL_cdrzd2615zd2_2588))
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_cdrzd2618zd2_2590;
																													BgL_cdrzd2618zd2_2590
																														=
																														CDR
																														(BgL_cdrzd2615zd2_2588);
																													if ((CAR
																															(BgL_cdrzd2615zd2_2588)
																															== BTRUE))
																														{	/* Ast/sexp.scm 119 */
																															if (PAIRP
																																(BgL_cdrzd2618zd2_2590))
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR
																																			(BgL_cdrzd2618zd2_2590)
																																			==
																																			BFALSE))
																																		{	/* Ast/sexp.scm 119 */
																																			if (NULLP
																																				(CDR
																																					(BgL_cdrzd2618zd2_2590)))
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_sitez00_24
																																							==
																																							CNST_TABLE_REF
																																							(((long) 8))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg2271z00_2600;
																																							BgL_arg2271z00_2600
																																								=
																																								CAR
																																								(BgL_cdrzd2611zd2_1840);
																																							BgL_auxz00_14300
																																								=
																																								(
																																								(obj_t)
																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																								(BgL_arg2271z00_2600,
																																									BgL_stackz00_22,
																																									BgL_locz00_23,
																																									BgL_sitez00_24));
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd2637zd2_2601;
																																							BgL_carzd2637zd2_2601
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd2637zd2_2601 == CNST_TABLE_REF(((long) 1))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_14329;
																																								BgL_tagzd2377zd2_1754:
																																									{
																																										obj_t
																																											BgL_siz00_8524;
																																										obj_t
																																											BgL_alorsz00_8525;
																																										obj_t
																																											BgL_sinonz00_8526;
																																										obj_t
																																											BgL_siz00_8528;
																																										obj_t
																																											BgL_alorsz00_8529;
																																										if (PAIRP(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd262200zd2_8534;
																																												BgL_cdrzd262200zd2_8534
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												if (PAIRP(BgL_cdrzd262200zd2_8534))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd262205zd2_8536;
																																														BgL_cdrzd262205zd2_8536
																																															=
																																															CDR
																																															(BgL_cdrzd262200zd2_8534);
																																														if (PAIRP(BgL_cdrzd262205zd2_8536))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd262210zd2_8538;
																																																BgL_cdrzd262210zd2_8538
																																																	=
																																																	CDR
																																																	(BgL_cdrzd262205zd2_8536);
																																																if (PAIRP(BgL_cdrzd262210zd2_8538))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd262210zd2_8538)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				BgL_siz00_8524
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262200zd2_8534);
																																																				BgL_alorsz00_8525
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262205zd2_8536);
																																																				BgL_sinonz00_8526
																																																					=
																																																					CAR
																																																					(BgL_cdrzd262210zd2_8538);
																																																				{	/* Ast/sexp.scm 244 */
																																																					obj_t
																																																						BgL_ntz00_8553;
																																																					BgL_ntz00_8553
																																																						=
																																																						BGl_notzd2testzd2zzast_sexpz00
																																																						(BgL_siz00_8524);
																																																					if (CBOOL(BgL_ntz00_8553))
																																																						{	/* Ast/sexp.scm 245 */
																																																							{	/* Ast/sexp.scm 247 */
																																																								obj_t
																																																									BgL_arg6733z00_8554;
																																																								BgL_arg6733z00_8554
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 247 */
																																																									obj_t
																																																										BgL_tmpz00_14349;
																																																									BgL_tmpz00_14349
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6733z00_8554);
																																																									SET_CAR
																																																										(BgL_tmpz00_14349,
																																																										BgL_ntz00_8553);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 248 */
																																																								obj_t
																																																									BgL_arg6734z00_8555;
																																																								{	/* Ast/sexp.scm 248 */
																																																									obj_t
																																																										BgL_pairz00_9779;
																																																									BgL_pairz00_9779
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_arg6734z00_8555
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9779);
																																																								}
																																																								{	/* Ast/sexp.scm 248 */
																																																									obj_t
																																																										BgL_tmpz00_14355;
																																																									BgL_tmpz00_14355
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6734z00_8555);
																																																									SET_CAR
																																																										(BgL_tmpz00_14355,
																																																										BgL_sinonz00_8526);
																																																								}
																																																							}
																																																							{	/* Ast/sexp.scm 249 */
																																																								obj_t
																																																									BgL_arg6735z00_8556;
																																																								{	/* Ast/sexp.scm 249 */
																																																									obj_t
																																																										BgL_pairz00_9786;
																																																									{	/* Ast/sexp.scm 249 */
																																																										obj_t
																																																											BgL_pairz00_9785;
																																																										BgL_pairz00_9785
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_pairz00_9786
																																																											=
																																																											CDR
																																																											(BgL_pairz00_9785);
																																																									}
																																																									BgL_arg6735z00_8556
																																																										=
																																																										CDR
																																																										(BgL_pairz00_9786);
																																																								}
																																																								{	/* Ast/sexp.scm 249 */
																																																									obj_t
																																																										BgL_tmpz00_14362;
																																																									BgL_tmpz00_14362
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_arg6735z00_8556);
																																																									SET_CAR
																																																										(BgL_tmpz00_14362,
																																																										BgL_alorsz00_8525);
																																																								}
																																																							}
																																																							BgL_auxz00_14329
																																																								=
																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																								(BgL_expz00_21,
																																																								BgL_stackz00_22,
																																																								BgL_locz00_23,
																																																								BgL_sitez00_24);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 251 */
																																																							obj_t
																																																								BgL_locz00_8557;
																																																							BgL_locz00_8557
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 251 */
																																																								obj_t
																																																									BgL_cdlocz00_8558;
																																																								{	/* Ast/sexp.scm 252 */
																																																									obj_t
																																																										BgL_arg6755z00_8592;
																																																									BgL_arg6755z00_8592
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8558
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6755z00_8592,
																																																										BgL_locz00_8557);
																																																								}
																																																								{	/* Ast/sexp.scm 252 */
																																																									obj_t
																																																										BgL_cddlocz00_8559;
																																																									{	/* Ast/sexp.scm 253 */
																																																										obj_t
																																																											BgL_arg6754z00_8591;
																																																										{	/* Ast/sexp.scm 253 */
																																																											obj_t
																																																												BgL_pairz00_9792;
																																																											BgL_pairz00_9792
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6754z00_8591
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9792);
																																																										}
																																																										BgL_cddlocz00_8559
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6754z00_8591,
																																																											BgL_locz00_8557);
																																																									}
																																																									{	/* Ast/sexp.scm 253 */
																																																										obj_t
																																																											BgL_cdddlocz00_8560;
																																																										{	/* Ast/sexp.scm 254 */
																																																											obj_t
																																																												BgL_arg6753z00_8590;
																																																											{	/* Ast/sexp.scm 254 */
																																																												obj_t
																																																													BgL_pairz00_9798;
																																																												{	/* Ast/sexp.scm 254 */
																																																													obj_t
																																																														BgL_pairz00_9797;
																																																													BgL_pairz00_9797
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_pairz00_9798
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9797);
																																																												}
																																																												BgL_arg6753z00_8590
																																																													=
																																																													CDR
																																																													(BgL_pairz00_9798);
																																																											}
																																																											BgL_cdddlocz00_8560
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6753z00_8590,
																																																												BgL_locz00_8557);
																																																										}
																																																										{	/* Ast/sexp.scm 254 */
																																																											obj_t
																																																												BgL_lzd2sizd2_8561;
																																																											BgL_lzd2sizd2_8561
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_siz00_8524,
																																																												BgL_cdlocz00_8558);
																																																											{	/* Ast/sexp.scm 255 */
																																																												obj_t
																																																													BgL_lzd2alorszd2_8562;
																																																												BgL_lzd2alorszd2_8562
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_alorsz00_8525,
																																																													BgL_cddlocz00_8559);
																																																												{	/* Ast/sexp.scm 256 */
																																																													obj_t
																																																														BgL_lzd2sinonzd2_8563;
																																																													BgL_lzd2sinonzd2_8563
																																																														=
																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																														(BgL_sinonz00_8526,
																																																														BgL_cdddlocz00_8560);
																																																													{	/* Ast/sexp.scm 257 */
																																																														BgL_nodez00_bglt
																																																															BgL_testz00_8564;
																																																														BgL_testz00_8564
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_siz00_8524,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_8557,
																																																															CNST_TABLE_REF
																																																															(((long) 8)));
																																																														{	/* Ast/sexp.scm 258 */

																																																															{	/* Ast/sexp.scm 260 */
																																																																bool_t
																																																																	BgL_test8197z00_14384;
																																																																{	/* Ast/sexp.scm 260 */
																																																																	bool_t
																																																																		BgL_res7402z00_9799;
																																																																	BgL_res7402z00_9799
																																																																		=
																																																																		BGl_isazf3zf3zz__objectz00
																																																																		(
																																																																		((obj_t) BgL_testz00_8564), BGl_atomz00zzast_nodez00);
																																																																	BgL_test8197z00_14384
																																																																		=
																																																																		BgL_res7402z00_9799;
																																																																}
																																																																if (BgL_test8197z00_14384)
																																																																	{	/* Ast/sexp.scm 260 */
																																																																		if (CBOOL((((BgL_atomz00_bglt) COBJECT(((BgL_atomz00_bglt) BgL_testz00_8564)))->BgL_valuez00)))
																																																																			{	/* Ast/sexp.scm 262 */
																																																																				BgL_auxz00_14329
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_alorsz00_8525,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2alorszd2_8562,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 262 */
																																																																				BgL_auxz00_14329
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_sinonz00_8526,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2sinonzd2_8563,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 265 */
																																																																		bool_t
																																																																			BgL_test8199z00_14395;
																																																																		{	/* Ast/sexp.scm 265 */
																																																																			bool_t
																																																																				BgL_res7403z00_9800;
																																																																			BgL_res7403z00_9800
																																																																				=
																																																																				BGl_isazf3zf3zz__objectz00
																																																																				(
																																																																				((obj_t) BgL_testz00_8564), BGl_kwotez00zzast_nodez00);
																																																																			BgL_test8199z00_14395
																																																																				=
																																																																				BgL_res7403z00_9800;
																																																																		}
																																																																		if (BgL_test8199z00_14395)
																																																																			{	/* Ast/sexp.scm 265 */
																																																																				BgL_auxz00_14329
																																																																					=
																																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																					(BgL_alorsz00_8525,
																																																																					BgL_stackz00_22,
																																																																					BgL_lzd2alorszd2_8562,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 267 */
																																																																				bool_t
																																																																					BgL_test8200z00_14400;
																																																																				{	/* Ast/sexp.scm 267 */
																																																																					bool_t
																																																																						BgL_res7404z00_9801;
																																																																					BgL_res7404z00_9801
																																																																						=
																																																																						BGl_isazf3zf3zz__objectz00
																																																																						(
																																																																						((obj_t) BgL_testz00_8564), BGl_varz00zzast_nodez00);
																																																																					BgL_test8200z00_14400
																																																																						=
																																																																						BgL_res7404z00_9801;
																																																																				}
																																																																				if (BgL_test8200z00_14400)
																																																																					{	/* Ast/sexp.scm 268 */
																																																																						BgL_nodez00_bglt
																																																																							BgL_alorsz00_8570;
																																																																						BgL_nodez00_bglt
																																																																							BgL_sinonz00_8571;
																																																																						BgL_alorsz00_8570
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_alorsz00_8525,
																																																																							BgL_stackz00_22,
																																																																							BgL_lzd2alorszd2_8562,
																																																																							CNST_TABLE_REF
																																																																							(((long) 2)));
																																																																						BgL_sinonz00_8571
																																																																							=
																																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																							(BgL_sinonz00_8526,
																																																																							BgL_stackz00_22,
																																																																							BgL_lzd2sinonzd2_8563,
																																																																							CNST_TABLE_REF
																																																																							(((long) 2)));
																																																																						{	/* Ast/sexp.scm 270 */
																																																																							BgL_conditionalz00_bglt
																																																																								BgL_new1129z00_8572;
																																																																							{	/* Ast/sexp.scm 271 */
																																																																								BgL_conditionalz00_bglt
																																																																									BgL_new1127z00_8573;
																																																																								BgL_new1127z00_8573
																																																																									=
																																																																									(
																																																																									(BgL_conditionalz00_bglt)
																																																																									BOBJECT
																																																																									(GC_MALLOC
																																																																										(sizeof
																																																																											(struct
																																																																												BgL_conditionalz00_bgl))));
																																																																								{	/* Ast/sexp.scm 271 */
																																																																									long
																																																																										BgL_arg6740z00_8574;
																																																																									{	/* Ast/sexp.scm 271 */
																																																																										long
																																																																											BgL_res7405z00_9803;
																																																																										BgL_res7405z00_9803
																																																																											=
																																																																											BGL_CLASS_INDEX
																																																																											(BGl_conditionalz00zzast_nodez00);
																																																																										BgL_arg6740z00_8574
																																																																											=
																																																																											BgL_res7405z00_9803;
																																																																									}
																																																																									BGL_OBJECT_CLASS_NUM_SET
																																																																										(
																																																																										((BgL_objectz00_bglt) BgL_new1127z00_8573), BgL_arg6740z00_8574);
																																																																								}
																																																																								{	/* Ast/sexp.scm 271 */
																																																																									BgL_objectz00_bglt
																																																																										BgL_tmpz00_14411;
																																																																									BgL_tmpz00_14411
																																																																										=
																																																																										(
																																																																										(BgL_objectz00_bglt)
																																																																										BgL_new1127z00_8573);
																																																																									BGL_OBJECT_WIDENING_SET
																																																																										(BgL_tmpz00_14411,
																																																																										BFALSE);
																																																																								}
																																																																								((BgL_objectz00_bglt) BgL_new1127z00_8573);
																																																																								BgL_new1129z00_8572
																																																																									=
																																																																									BgL_new1127z00_8573;
																																																																							}
																																																																							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1129z00_8572)))->BgL_locz00) = ((obj_t) BgL_locz00_8557), BUNSPEC);
																																																																							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1129z00_8572)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1129z00_8572)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																							((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1129z00_8572)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1129z00_8572))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8564), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1129z00_8572))->BgL_truez00) = ((BgL_nodez00_bglt) BgL_alorsz00_8570), BUNSPEC);
																																																																							((((BgL_conditionalz00_bglt) COBJECT(BgL_new1129z00_8572))->BgL_falsez00) = ((BgL_nodez00_bglt) BgL_sinonz00_8571), BUNSPEC);
																																																																							BgL_auxz00_14329
																																																																								=
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_new1129z00_8572);
																																																																					}}
																																																																				else
																																																																					{	/* Ast/sexp.scm 277 */
																																																																						obj_t
																																																																							BgL_vz00_8575;
																																																																						BgL_vz00_8575
																																																																							=
																																																																							BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																																																																							(BGl_gensymz00zz__r4_symbols_6_4z00
																																																																							(CNST_TABLE_REF
																																																																								(((long) 8))));
																																																																						{	/* Ast/sexp.scm 277 */
																																																																							obj_t
																																																																								BgL_varz00_8576;
																																																																							BgL_varz00_8576
																																																																								=
																																																																								BGl_makezd2typedzd2identz00zzast_identz00
																																																																								(BgL_vz00_8575,
																																																																								CNST_TABLE_REF
																																																																								(((long) 9)));
																																																																							{	/* Ast/sexp.scm 278 */
																																																																								obj_t
																																																																									BgL_nexpz00_8577;
																																																																								{	/* Ast/sexp.scm 279 */
																																																																									obj_t
																																																																										BgL_arg6748z00_8585;
																																																																									{	/* Ast/sexp.scm 279 */
																																																																										obj_t
																																																																											BgL_arg6749z00_8586;
																																																																										{	/* Ast/sexp.scm 279 */
																																																																											obj_t
																																																																												BgL_arg6750z00_8587;
																																																																											{	/* Ast/sexp.scm 279 */
																																																																												obj_t
																																																																													BgL_arg6751z00_8588;
																																																																												BgL_arg6751z00_8588
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_sinonz00_8526,
																																																																													BNIL);
																																																																												BgL_arg6750z00_8587
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_alorsz00_8525,
																																																																													BgL_arg6751z00_8588);
																																																																											}
																																																																											BgL_arg6749z00_8586
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_vz00_8575,
																																																																												BgL_arg6750z00_8587);
																																																																										}
																																																																										BgL_arg6748z00_8585
																																																																											=
																																																																											MAKE_YOUNG_PAIR
																																																																											(CNST_TABLE_REF
																																																																											(((long) 1)), BgL_arg6749z00_8586);
																																																																									}
																																																																									BgL_nexpz00_8577
																																																																										=
																																																																										BGl_epairifyzd2reczd2zztools_miscz00
																																																																										(BgL_arg6748z00_8585,
																																																																										BgL_expz00_21);
																																																																								}
																																																																								{	/* Ast/sexp.scm 279 */

																																																																									{	/* Ast/sexp.scm 280 */
																																																																										obj_t
																																																																											BgL_arg6741z00_8578;
																																																																										{	/* Ast/sexp.scm 280 */
																																																																											obj_t
																																																																												BgL_arg6742z00_8579;
																																																																											obj_t
																																																																												BgL_arg6743z00_8580;
																																																																											BgL_arg6742z00_8579
																																																																												=
																																																																												BGl_letzd2symzd2zzast_letz00
																																																																												();
																																																																											{	/* Ast/sexp.scm 280 */
																																																																												obj_t
																																																																													BgL_arg6744z00_8581;
																																																																												obj_t
																																																																													BgL_arg6745z00_8582;
																																																																												{	/* Ast/sexp.scm 280 */
																																																																													obj_t
																																																																														BgL_arg6746z00_8583;
																																																																													{	/* Ast/sexp.scm 280 */
																																																																														obj_t
																																																																															BgL_arg6747z00_8584;
																																																																														BgL_arg6747z00_8584
																																																																															=
																																																																															MAKE_YOUNG_PAIR
																																																																															(BgL_siz00_8524,
																																																																															BNIL);
																																																																														BgL_arg6746z00_8583
																																																																															=
																																																																															MAKE_YOUNG_PAIR
																																																																															(BgL_varz00_8576,
																																																																															BgL_arg6747z00_8584);
																																																																													}
																																																																													BgL_arg6744z00_8581
																																																																														=
																																																																														MAKE_YOUNG_PAIR
																																																																														(BgL_arg6746z00_8583,
																																																																														BNIL);
																																																																												}
																																																																												BgL_arg6745z00_8582
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_nexpz00_8577,
																																																																													BNIL);
																																																																												BgL_arg6743z00_8580
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(BgL_arg6744z00_8581,
																																																																													BgL_arg6745z00_8582);
																																																																											}
																																																																											BgL_arg6741z00_8578
																																																																												=
																																																																												MAKE_YOUNG_PAIR
																																																																												(BgL_arg6742z00_8579,
																																																																												BgL_arg6743z00_8580);
																																																																										}
																																																																										BGl_replacez12z12zztools_miscz00
																																																																											(BgL_expz00_21,
																																																																											BgL_arg6741z00_8578);
																																																																									}
																																																																									BgL_auxz00_14329
																																																																										=
																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																										(BgL_expz00_21,
																																																																										BgL_stackz00_22,
																																																																										BgL_locz00_8557,
																																																																										BgL_sitez00_24);
																																																			}}}}}}}}}}}}}}}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																			BgL_tagzd262191zd2_8531:
																																																				{	/* Ast/sexp.scm 286 */
																																																					BgL_nodez00_bglt
																																																						BgL_res7407z00_9818;
																																																					{	/* Ast/sexp.scm 726 */
																																																						obj_t
																																																							BgL_arg7130z00_9814;
																																																						BgL_nodez00_bglt
																																																							BgL_arg7131z00_9815;
																																																						BgL_arg7130z00_9814
																																																							=
																																																							BGl_shapez00zztools_shapez00
																																																							(BGl_currentzd2functionzd2zztools_errorz00
																																																							());
																																																						BgL_arg7131z00_9815
																																																							=
																																																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																							(CNST_TABLE_REF
																																																							(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																						{	/* Ast/sexp.scm 725 */
																																																							obj_t
																																																								BgL_list7132z00_9817;
																																																							BgL_list7132z00_9817
																																																								=
																																																								MAKE_YOUNG_PAIR
																																																								(
																																																								((obj_t) BgL_arg7131z00_9815), BNIL);
																																																							BgL_res7407z00_9818
																																																								=
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BGl_userzd2errorzf2locationz20zztools_errorz00
																																																								(BgL_locz00_23,
																																																									BgL_arg7130z00_9814,
																																																									BGl_string8057z00zzast_sexpz00,
																																																									BgL_expz00_21,
																																																									BgL_list7132z00_9817));
																																																					}}
																																																					BgL_auxz00_14329
																																																						=
																																																						BgL_res7407z00_9818;
																																																	}}}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262235zd2_8547;
																																																		BgL_cdrzd262235zd2_8547
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_cdrzd262200zd2_8534));
																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd262235zd2_8547))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6730z00_8550;
																																																				obj_t
																																																					BgL_arg6731z00_8551;
																																																				BgL_arg6730z00_8550
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262200zd2_8534));
																																																				BgL_arg6731z00_8551
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd262235zd2_8547));
																																																				BgL_siz00_8528
																																																					=
																																																					BgL_arg6730z00_8550;
																																																				BgL_alorsz00_8529
																																																					=
																																																					BgL_arg6731z00_8551;
																																																				{	/* Ast/sexp.scm 283 */
																																																					obj_t
																																																						BgL_arg6756z00_8593;
																																																					obj_t
																																																						BgL_arg6757z00_8594;
																																																					{	/* Ast/sexp.scm 283 */
																																																						obj_t
																																																							BgL_pairz00_9810;
																																																						BgL_pairz00_9810
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_arg6756z00_8593
																																																							=
																																																							CDR
																																																							(BgL_pairz00_9810);
																																																					}
																																																					{	/* Ast/sexp.scm 283 */
																																																						obj_t
																																																							BgL_list6758z00_8595;
																																																						BgL_list6758z00_8595
																																																							=
																																																							MAKE_YOUNG_PAIR
																																																							(BUNSPEC,
																																																							BNIL);
																																																						BgL_arg6757z00_8594
																																																							=
																																																							BgL_list6758z00_8595;
																																																					}
																																																					{	/* Ast/sexp.scm 283 */
																																																						obj_t
																																																							BgL_tmpz00_14475;
																																																						BgL_tmpz00_14475
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_arg6756z00_8593);
																																																						SET_CDR
																																																							(BgL_tmpz00_14475,
																																																							BgL_arg6757z00_8594);
																																																					}
																																																				}
																																																				BgL_auxz00_14329
																																																					=
																																																					BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																					(BgL_expz00_21,
																																																					BgL_stackz00_22,
																																																					BgL_locz00_23,
																																																					BgL_sitez00_24);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262191zd2_8531;
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd262191zd2_8531;
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd262191zd2_8531;
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_tagzd262191zd2_8531;
																																											}
																																									}
																																									BgL_auxz00_14300
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_14329);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd2637zd2_2601 == BGl_za2ifza2z00zzast_sexpz00))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_14482;
																																											goto
																																												BgL_tagzd2377zd2_1754;
																																											BgL_auxz00_14300
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_14482);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_14489;
																																												BgL_tagzd2379zd2_1758:
																																													{
																																														obj_t
																																															BgL_varz00_8622;
																																														obj_t
																																															BgL_valz00_8623;
																																														if (PAIRP(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd262265zd2_8628;
																																																BgL_cdrzd262265zd2_8628
																																																	=
																																																	CDR
																																																	(BgL_expz00_21);
																																																if (PAIRP(BgL_cdrzd262265zd2_8628))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262269zd2_8630;
																																																		BgL_cdrzd262269zd2_8630
																																																			=
																																																			CDR
																																																			(BgL_cdrzd262265zd2_8628);
																																																		if (PAIRP(BgL_cdrzd262269zd2_8630))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd262269zd2_8630)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						BgL_varz00_8622
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262265zd2_8628);
																																																						BgL_valz00_8623
																																																							=
																																																							CAR
																																																							(BgL_cdrzd262269zd2_8630);
																																																						{	/* Ast/sexp.scm 295 */
																																																							obj_t
																																																								BgL_locz00_8637;
																																																							BgL_locz00_8637
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 295 */
																																																								obj_t
																																																									BgL_cdlocz00_8638;
																																																								{	/* Ast/sexp.scm 296 */
																																																									obj_t
																																																										BgL_arg6795z00_8665;
																																																									BgL_arg6795z00_8665
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdlocz00_8638
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_arg6795z00_8665,
																																																										BgL_locz00_8637);
																																																								}
																																																								{	/* Ast/sexp.scm 296 */
																																																									obj_t
																																																										BgL_cddlocz00_8639;
																																																									{	/* Ast/sexp.scm 297 */
																																																										obj_t
																																																											BgL_arg6794z00_8664;
																																																										{	/* Ast/sexp.scm 297 */
																																																											obj_t
																																																												BgL_pairz00_9854;
																																																											BgL_pairz00_9854
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_arg6794z00_8664
																																																												=
																																																												CDR
																																																												(BgL_pairz00_9854);
																																																										}
																																																										BgL_cddlocz00_8639
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_arg6794z00_8664,
																																																											BgL_locz00_8637);
																																																									}
																																																									{	/* Ast/sexp.scm 297 */
																																																										obj_t
																																																											BgL_valzd2loczd2_8640;
																																																										BgL_valzd2loczd2_8640
																																																											=
																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																											(BgL_valz00_8623,
																																																											BgL_cddlocz00_8639);
																																																										{	/* Ast/sexp.scm 298 */
																																																											BgL_nodez00_bglt
																																																												BgL_valz00_8641;
																																																											{

																																																												if (PAIRP(BgL_valz00_8623))
																																																													{	/* Ast/sexp.scm 299 */
																																																														if ((CAR(BgL_valz00_8623) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 299 */
																																																																{	/* Ast/sexp.scm 302 */
																																																																	obj_t
																																																																		BgL_arg6793z00_8663;
																																																																	{	/* Ast/sexp.scm 302 */
																																																																		obj_t
																																																																			BgL_res7419z00_9857;
																																																																		{	/* Ast/sexp.scm 302 */
																																																																			obj_t
																																																																				BgL_arg1454z00_9856;
																																																																			BgL_arg1454z00_9856
																																																																				=
																																																																				SYMBOL_TO_STRING
																																																																				(
																																																																				((obj_t) BgL_varz00_8622));
																																																																			BgL_res7419z00_9857
																																																																				=
																																																																				BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																																				(BgL_arg1454z00_9856);
																																																																		}
																																																																		BgL_arg6793z00_8663
																																																																			=
																																																																			BgL_res7419z00_9857;
																																																																	}
																																																																	BgL_valz00_8641
																																																																		=
																																																																		BGl_lambdazd2ze3nodez31zzast_sexpz00
																																																																		(BgL_valz00_8623,
																																																																		BgL_stackz00_22,
																																																																		BgL_valzd2loczd2_8640,
																																																																		CNST_TABLE_REF
																																																																		(((long) 2)), BgL_arg6793z00_8663);
																																																															}}
																																																														else
																																																															{	/* Ast/sexp.scm 299 */
																																																															BgL_tagzd262276zd2_8657:
																																																																BgL_valz00_8641 = BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_valz00_8623, BgL_stackz00_22, BgL_valzd2loczd2_8640, CNST_TABLE_REF(((long) 2)));
																																																													}}
																																																												else
																																																													{	/* Ast/sexp.scm 299 */
																																																														goto
																																																															BgL_tagzd262276zd2_8657;
																																																													}
																																																											}
																																																											{	/* Ast/sexp.scm 299 */

																																																												{	/* Ast/sexp.scm 305 */
																																																													BgL_nodez00_bglt
																																																														BgL_astz00_8642;
																																																													BgL_astz00_8642
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_varz00_8622,
																																																														BgL_stackz00_22,
																																																														BgL_cdlocz00_8638,
																																																														CNST_TABLE_REF
																																																														(((long) 7)));
																																																													{	/* Ast/sexp.scm 306 */
																																																														bool_t
																																																															BgL_test8210z00_14525;
																																																														{	/* Ast/sexp.scm 306 */
																																																															bool_t
																																																																BgL_res7421z00_9860;
																																																															BgL_res7421z00_9860
																																																																=
																																																																BGl_isazf3zf3zz__objectz00
																																																																(
																																																																((obj_t) BgL_astz00_8642), BGl_varz00zzast_nodez00);
																																																															BgL_test8210z00_14525
																																																																=
																																																																BgL_res7421z00_9860;
																																																														}
																																																														if (BgL_test8210z00_14525)
																																																															{	/* Ast/sexp.scm 308 */
																																																																bool_t
																																																																	BgL_test8211z00_14528;
																																																																{	/* Ast/sexp.scm 308 */
																																																																	bool_t
																																																																		BgL_test8212z00_14529;
																																																																	{	/* Ast/sexp.scm 308 */
																																																																		BgL_variablez00_bglt
																																																																			BgL_arg6788z00_8655;
																																																																		BgL_arg6788z00_8655
																																																																			=
																																																																			(
																																																																			((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8642)))->BgL_variablez00);
																																																																		{	/* Ast/sexp.scm 308 */
																																																																			bool_t
																																																																				BgL_res7422z00_9861;
																																																																			BgL_res7422z00_9861
																																																																				=
																																																																				BGl_isazf3zf3zz__objectz00
																																																																				(
																																																																				((obj_t) BgL_arg6788z00_8655), BGl_globalz00zzast_varz00);
																																																																			BgL_test8212z00_14529
																																																																				=
																																																																				BgL_res7422z00_9861;
																																																																		}
																																																																	}
																																																																	if (BgL_test8212z00_14529)
																																																																		{	/* Ast/sexp.scm 309 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6787z00_8654;
																																																																			BgL_arg6787z00_8654
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8642)))->BgL_variablez00);
																																																																			BgL_test8211z00_14528
																																																																				=
																																																																				BGl_globalzd2readzd2onlyzf3zf3zzast_varz00
																																																																				(
																																																																				((BgL_globalz00_bglt) BgL_arg6787z00_8654));
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 308 */
																																																																			BgL_test8211z00_14528
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																																if (BgL_test8211z00_14528)
																																																																	{	/* Ast/sexp.scm 310 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7423z00_9867;
																																																																		{	/* Ast/sexp.scm 726 */
																																																																			obj_t
																																																																				BgL_arg7130z00_9863;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7131z00_9864;
																																																																			BgL_arg7130z00_9863
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7131z00_9864
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_cdlocz00_8638, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 725 */
																																																																				obj_t
																																																																					BgL_list7132z00_9866;
																																																																				BgL_list7132z00_9866
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7131z00_9864), BNIL);
																																																																				BgL_res7423z00_9867
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_cdlocz00_8638,
																																																																						BgL_arg7130z00_9863,
																																																																						BGl_string8054z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7132z00_9866));
																																																																		}}
																																																																		BgL_auxz00_14489
																																																																			=
																																																																			BgL_res7423z00_9867;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 312 */
																																																																		BgL_setqz00_bglt
																																																																			BgL_new1132z00_8650;
																																																																		{	/* Ast/sexp.scm 313 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1131z00_8651;
																																																																			BgL_new1131z00_8651
																																																																				=
																																																																				(
																																																																				(BgL_setqz00_bglt)
																																																																				BOBJECT
																																																																				(GC_MALLOC
																																																																					(sizeof
																																																																						(struct
																																																																							BgL_setqz00_bgl))));
																																																																			{	/* Ast/sexp.scm 313 */
																																																																				long
																																																																					BgL_arg6786z00_8652;
																																																																				{	/* Ast/sexp.scm 313 */
																																																																					long
																																																																						BgL_res7424z00_9869;
																																																																					BgL_res7424z00_9869
																																																																						=
																																																																						BGL_CLASS_INDEX
																																																																						(BGl_setqz00zzast_nodez00);
																																																																					BgL_arg6786z00_8652
																																																																						=
																																																																						BgL_res7424z00_9869;
																																																																				}
																																																																				BGL_OBJECT_CLASS_NUM_SET
																																																																					(
																																																																					((BgL_objectz00_bglt) BgL_new1131z00_8651), BgL_arg6786z00_8652);
																																																																			}
																																																																			{	/* Ast/sexp.scm 313 */
																																																																				BgL_objectz00_bglt
																																																																					BgL_tmpz00_14551;
																																																																				BgL_tmpz00_14551
																																																																					=
																																																																					(
																																																																					(BgL_objectz00_bglt)
																																																																					BgL_new1131z00_8651);
																																																																				BGL_OBJECT_WIDENING_SET
																																																																					(BgL_tmpz00_14551,
																																																																					BFALSE);
																																																																			}
																																																																			((BgL_objectz00_bglt) BgL_new1131z00_8651);
																																																																			BgL_new1132z00_8650
																																																																				=
																																																																				BgL_new1131z00_8651;
																																																																		}
																																																																		((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1132z00_8650)))->BgL_locz00) = ((obj_t) BgL_locz00_8637), BUNSPEC);
																																																																		((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1132z00_8650)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																		((((BgL_setqz00_bglt) COBJECT(BgL_new1132z00_8650))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8642)), BUNSPEC);
																																																																		((((BgL_setqz00_bglt) COBJECT(BgL_new1132z00_8650))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8641), BUNSPEC);
																																																																		BgL_auxz00_14489
																																																																			=
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BgL_new1132z00_8650);
																																																															}}
																																																														else
																																																															{	/* Ast/sexp.scm 317 */
																																																																BgL_nodez00_bglt
																																																																	BgL_res7425z00_9878;
																																																																{	/* Ast/sexp.scm 726 */
																																																																	obj_t
																																																																		BgL_arg7130z00_9874;
																																																																	BgL_nodez00_bglt
																																																																		BgL_arg7131z00_9875;
																																																																	BgL_arg7130z00_9874
																																																																		=
																																																																		BGl_shapez00zztools_shapez00
																																																																		(BGl_currentzd2functionzd2zztools_errorz00
																																																																		());
																																																																	BgL_arg7131z00_9875
																																																																		=
																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																		(CNST_TABLE_REF
																																																																		(((long) 4)), BNIL, BgL_locz00_8637, CNST_TABLE_REF(((long) 2)));
																																																																	{	/* Ast/sexp.scm 725 */
																																																																		obj_t
																																																																			BgL_list7132z00_9877;
																																																																		BgL_list7132z00_9877
																																																																			=
																																																																			MAKE_YOUNG_PAIR
																																																																			(
																																																																			((obj_t) BgL_arg7131z00_9875), BNIL);
																																																																		BgL_res7425z00_9878
																																																																			=
																																																																			(
																																																																			(BgL_nodez00_bglt)
																																																																			BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																			(BgL_locz00_8637,
																																																																				BgL_arg7130z00_9874,
																																																																				BGl_string8055z00zzast_sexpz00,
																																																																				BgL_expz00_21,
																																																																				BgL_list7132z00_9877));
																																																																}}
																																																																BgL_auxz00_14489
																																																																	=
																																																																	BgL_res7425z00_9878;
																																																					}}}}}}}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																					BgL_tagzd262258zd2_8625:
																																																						{	/* Ast/sexp.scm 321 */
																																																							obj_t
																																																								BgL_arg6796z00_8666;
																																																							BgL_arg6796z00_8666
																																																								=
																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																								(BgL_expz00_21,
																																																								BgL_locz00_23);
																																																							{	/* Ast/sexp.scm 320 */
																																																								BgL_nodez00_bglt
																																																									BgL_res7426z00_9884;
																																																								{	/* Ast/sexp.scm 726 */
																																																									obj_t
																																																										BgL_arg7130z00_9880;
																																																									BgL_nodez00_bglt
																																																										BgL_arg7131z00_9881;
																																																									BgL_arg7130z00_9880
																																																										=
																																																										BGl_shapez00zztools_shapez00
																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																										());
																																																									BgL_arg7131z00_9881
																																																										=
																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																										(CNST_TABLE_REF
																																																										(((long) 4)), BNIL, BgL_arg6796z00_8666, CNST_TABLE_REF(((long) 2)));
																																																									{	/* Ast/sexp.scm 725 */
																																																										obj_t
																																																											BgL_list7132z00_9883;
																																																										BgL_list7132z00_9883
																																																											=
																																																											MAKE_YOUNG_PAIR
																																																											(
																																																											((obj_t) BgL_arg7131z00_9881), BNIL);
																																																										BgL_res7426z00_9884
																																																											=
																																																											(
																																																											(BgL_nodez00_bglt)
																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																											(BgL_arg6796z00_8666,
																																																												BgL_arg7130z00_9880,
																																																												BGl_string8053z00zzast_sexpz00,
																																																												BgL_expz00_21,
																																																												BgL_list7132z00_9883));
																																																								}}
																																																								BgL_auxz00_14489
																																																									=
																																																									BgL_res7426z00_9884;
																																																			}}}}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262258zd2_8625;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd262258zd2_8625;
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd262258zd2_8625;
																																															}
																																													}
																																													BgL_auxz00_14300
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_14489);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_14591;
																																														BgL_tagzd2380zd2_1759:
																																															{
																																																obj_t
																																																	BgL_varz00_8667;
																																																obj_t
																																																	BgL_valz00_8668;
																																																if (PAIRP(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd262288zd2_8673;
																																																		BgL_cdrzd262288zd2_8673
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		if (PAIRP(BgL_cdrzd262288zd2_8673))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd262292zd2_8675;
																																																				BgL_cdrzd262292zd2_8675
																																																					=
																																																					CDR
																																																					(BgL_cdrzd262288zd2_8673);
																																																				if (PAIRP(BgL_cdrzd262292zd2_8675))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd262292zd2_8675)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								BgL_varz00_8667
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262288zd2_8673);
																																																								BgL_valz00_8668
																																																									=
																																																									CAR
																																																									(BgL_cdrzd262292zd2_8675);
																																																								{	/* Ast/sexp.scm 328 */
																																																									obj_t
																																																										BgL_locz00_8682;
																																																									BgL_locz00_8682
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 328 */
																																																										obj_t
																																																											BgL_cdlocz00_8683;
																																																										{	/* Ast/sexp.scm 329 */
																																																											obj_t
																																																												BgL_arg6812z00_8698;
																																																											BgL_arg6812z00_8698
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdlocz00_8683
																																																												=
																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																												(BgL_arg6812z00_8698,
																																																												BgL_locz00_8682);
																																																										}
																																																										{	/* Ast/sexp.scm 329 */
																																																											obj_t
																																																												BgL_cddlocz00_8684;
																																																											{	/* Ast/sexp.scm 330 */
																																																												obj_t
																																																													BgL_arg6811z00_8697;
																																																												{	/* Ast/sexp.scm 330 */
																																																													obj_t
																																																														BgL_pairz00_9898;
																																																													BgL_pairz00_9898
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_arg6811z00_8697
																																																														=
																																																														CDR
																																																														(BgL_pairz00_9898);
																																																												}
																																																												BgL_cddlocz00_8684
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_arg6811z00_8697,
																																																													BgL_locz00_8682);
																																																											}
																																																											{	/* Ast/sexp.scm 330 */
																																																												obj_t
																																																													BgL_valzd2loczd2_8685;
																																																												BgL_valzd2loczd2_8685
																																																													=
																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																													(BgL_valz00_8668,
																																																													BgL_cddlocz00_8684);
																																																												{	/* Ast/sexp.scm 331 */
																																																													BgL_nodez00_bglt
																																																														BgL_valz00_8686;
																																																													BgL_valz00_8686
																																																														=
																																																														BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																														(BgL_valz00_8668,
																																																														BgL_stackz00_22,
																																																														BgL_valzd2loczd2_8685,
																																																														CNST_TABLE_REF
																																																														(((long) 2)));
																																																													{	/* Ast/sexp.scm 332 */

																																																														{	/* Ast/sexp.scm 333 */
																																																															BgL_nodez00_bglt
																																																																BgL_astz00_8687;
																																																															BgL_astz00_8687
																																																																=
																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																(BgL_varz00_8667,
																																																																BgL_stackz00_22,
																																																																BgL_cdlocz00_8683,
																																																																CNST_TABLE_REF
																																																																(((long) 2)));
																																																															{	/* Ast/sexp.scm 334 */
																																																																bool_t
																																																																	BgL_test8218z00_14616;
																																																																{	/* Ast/sexp.scm 334 */
																																																																	bool_t
																																																																		BgL_test8219z00_14617;
																																																																	{	/* Ast/sexp.scm 334 */
																																																																		bool_t
																																																																			BgL_res7431z00_9899;
																																																																		BgL_res7431z00_9899
																																																																			=
																																																																			BGl_isazf3zf3zz__objectz00
																																																																			(
																																																																			((obj_t) BgL_astz00_8687), BGl_varz00zzast_nodez00);
																																																																		BgL_test8219z00_14617
																																																																			=
																																																																			BgL_res7431z00_9899;
																																																																	}
																																																																	if (BgL_test8219z00_14617)
																																																																		{	/* Ast/sexp.scm 334 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6810z00_8696;
																																																																			BgL_arg6810z00_8696
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8687)))->BgL_variablez00);
																																																																			{	/* Ast/sexp.scm 334 */
																																																																				bool_t
																																																																					BgL_res7432z00_9901;
																																																																				BgL_res7432z00_9901
																																																																					=
																																																																					BGl_isazf3zf3zz__objectz00
																																																																					(
																																																																					((obj_t) BgL_arg6810z00_8696), BGl_globalz00zzast_varz00);
																																																																				BgL_test8218z00_14616
																																																																					=
																																																																					BgL_res7432z00_9901;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 334 */
																																																																			BgL_test8218z00_14616
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																																if (BgL_test8218z00_14616)
																																																																	{	/* Ast/sexp.scm 334 */
																																																																		{	/* Ast/sexp.scm 336 */
																																																																			BgL_variablez00_bglt
																																																																				BgL_arg6808z00_8691;
																																																																			BgL_arg6808z00_8691
																																																																				=
																																																																				(
																																																																				((BgL_varz00_bglt) COBJECT(((BgL_varz00_bglt) BgL_astz00_8687)))->BgL_variablez00);
																																																																			((((BgL_globalz00_bglt) COBJECT(((BgL_globalz00_bglt) BgL_arg6808z00_8691)))->BgL_srcz00) = ((obj_t) ((obj_t) BgL_valz00_8686)), BUNSPEC);
																																																																		}
																																																																		{	/* Ast/sexp.scm 337 */
																																																																			BgL_setqz00_bglt
																																																																				BgL_new1135z00_8692;
																																																																			{	/* Ast/sexp.scm 338 */
																																																																				BgL_setqz00_bglt
																																																																					BgL_new1134z00_8693;
																																																																				BgL_new1134z00_8693
																																																																					=
																																																																					(
																																																																					(BgL_setqz00_bglt)
																																																																					BOBJECT
																																																																					(GC_MALLOC
																																																																						(sizeof
																																																																							(struct
																																																																								BgL_setqz00_bgl))));
																																																																				{	/* Ast/sexp.scm 338 */
																																																																					long
																																																																						BgL_arg6809z00_8694;
																																																																					{	/* Ast/sexp.scm 338 */
																																																																						long
																																																																							BgL_res7433z00_9905;
																																																																						BgL_res7433z00_9905
																																																																							=
																																																																							BGL_CLASS_INDEX
																																																																							(BGl_setqz00zzast_nodez00);
																																																																						BgL_arg6809z00_8694
																																																																							=
																																																																							BgL_res7433z00_9905;
																																																																					}
																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																						(
																																																																						((BgL_objectz00_bglt) BgL_new1134z00_8693), BgL_arg6809z00_8694);
																																																																				}
																																																																				{	/* Ast/sexp.scm 338 */
																																																																					BgL_objectz00_bglt
																																																																						BgL_tmpz00_14633;
																																																																					BgL_tmpz00_14633
																																																																						=
																																																																						(
																																																																						(BgL_objectz00_bglt)
																																																																						BgL_new1134z00_8693);
																																																																					BGL_OBJECT_WIDENING_SET
																																																																						(BgL_tmpz00_14633,
																																																																						BFALSE);
																																																																				}
																																																																				((BgL_objectz00_bglt) BgL_new1134z00_8693);
																																																																				BgL_new1135z00_8692
																																																																					=
																																																																					BgL_new1134z00_8693;
																																																																			}
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1135z00_8692)))->BgL_locz00) = ((obj_t) BgL_locz00_8682), BUNSPEC);
																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1135z00_8692)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1135z00_8692))->BgL_varz00) = ((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_astz00_8687)), BUNSPEC);
																																																																			((((BgL_setqz00_bglt) COBJECT(BgL_new1135z00_8692))->BgL_valuez00) = ((BgL_nodez00_bglt) BgL_valz00_8686), BUNSPEC);
																																																																			BgL_auxz00_14591
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_new1135z00_8692);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 342 */
																																																																		BgL_nodez00_bglt
																																																																			BgL_res7434z00_9914;
																																																																		{	/* Ast/sexp.scm 726 */
																																																																			obj_t
																																																																				BgL_arg7130z00_9910;
																																																																			BgL_nodez00_bglt
																																																																				BgL_arg7131z00_9911;
																																																																			BgL_arg7130z00_9910
																																																																				=
																																																																				BGl_shapez00zztools_shapez00
																																																																				(BGl_currentzd2functionzd2zztools_errorz00
																																																																				());
																																																																			BgL_arg7131z00_9911
																																																																				=
																																																																				BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																				(CNST_TABLE_REF
																																																																				(((long) 4)), BNIL, BgL_locz00_8682, CNST_TABLE_REF(((long) 2)));
																																																																			{	/* Ast/sexp.scm 725 */
																																																																				obj_t
																																																																					BgL_list7132z00_9913;
																																																																				BgL_list7132z00_9913
																																																																					=
																																																																					MAKE_YOUNG_PAIR
																																																																					(
																																																																					((obj_t) BgL_arg7131z00_9911), BNIL);
																																																																				BgL_res7434z00_9914
																																																																					=
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																					(BgL_locz00_8682,
																																																																						BgL_arg7130z00_9910,
																																																																						BGl_string8052z00zzast_sexpz00,
																																																																						BgL_expz00_21,
																																																																						BgL_list7132z00_9913));
																																																																		}}
																																																																		BgL_auxz00_14591
																																																																			=
																																																																			BgL_res7434z00_9914;
																																																							}}}}}}}}}}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																							BgL_tagzd262281zd2_8670:
																																																								{	/* Ast/sexp.scm 346 */
																																																									obj_t
																																																										BgL_arg6813z00_8699;
																																																									BgL_arg6813z00_8699
																																																										=
																																																										BGl_findzd2locationzf2locz20zztools_locationz00
																																																										(BgL_expz00_21,
																																																										BgL_locz00_23);
																																																									{	/* Ast/sexp.scm 345 */
																																																										BgL_nodez00_bglt
																																																											BgL_res7435z00_9920;
																																																										{	/* Ast/sexp.scm 726 */
																																																											obj_t
																																																												BgL_arg7130z00_9916;
																																																											BgL_nodez00_bglt
																																																												BgL_arg7131z00_9917;
																																																											BgL_arg7130z00_9916
																																																												=
																																																												BGl_shapez00zztools_shapez00
																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																												());
																																																											BgL_arg7131z00_9917
																																																												=
																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																												(CNST_TABLE_REF
																																																												(((long) 4)), BNIL, BgL_arg6813z00_8699, CNST_TABLE_REF(((long) 2)));
																																																											{	/* Ast/sexp.scm 725 */
																																																												obj_t
																																																													BgL_list7132z00_9919;
																																																												BgL_list7132z00_9919
																																																													=
																																																													MAKE_YOUNG_PAIR
																																																													(
																																																													((obj_t) BgL_arg7131z00_9917), BNIL);
																																																												BgL_res7435z00_9920
																																																													=
																																																													(
																																																													(BgL_nodez00_bglt)
																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																													(BgL_arg6813z00_8699,
																																																														BgL_arg7130z00_9916,
																																																														BGl_string8051z00zzast_sexpz00,
																																																														BgL_expz00_21,
																																																														BgL_list7132z00_9919));
																																																										}}
																																																										BgL_auxz00_14591
																																																											=
																																																											BgL_res7435z00_9920;
																																																					}}}}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd262281zd2_8670;
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_tagzd262281zd2_8670;
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd262281zd2_8670;
																																																	}
																																															}
																																															BgL_auxz00_14300
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_14591);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd2706zd2_2608;
																																															BgL_carzd2706zd2_2608
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if (PAIRP(BgL_carzd2706zd2_2608))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd2709zd2_2610;
																																																	obj_t
																																																		BgL_cdrzd2710zd2_2611;
																																																	BgL_carzd2709zd2_2610
																																																		=
																																																		CAR
																																																		(BgL_carzd2706zd2_2608);
																																																	BgL_cdrzd2710zd2_2611
																																																		=
																																																		CDR
																																																		(BgL_carzd2706zd2_2608);
																																																	{

																																																		if ((BgL_carzd2709zd2_2610 == CNST_TABLE_REF(((long) 17))))
																																																			{	/* Ast/sexp.scm 119 */
																																																			BgL_kapzd2711zd2_2612:
																																																				if (PAIRP(BgL_cdrzd2710zd2_2611))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd2714zd2_2737;
																																																						BgL_cdrzd2714zd2_2737
																																																							=
																																																							CDR
																																																							(BgL_cdrzd2710zd2_2611);
																																																						if (PAIRP(BgL_cdrzd2714zd2_2737))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (NULLP(CDR(BgL_cdrzd2714zd2_2737)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2365z00_2741;
																																																										obj_t
																																																											BgL_arg2366z00_2742;
																																																										BgL_arg2365z00_2741
																																																											=
																																																											CAR
																																																											(BgL_cdrzd2714zd2_2737);
																																																										BgL_arg2366z00_2742
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_14688;
																																																											BgL_bodyz00_1760
																																																												=
																																																												BgL_arg2365z00_2741;
																																																											BgL_argsz00_1761
																																																												=
																																																												BgL_arg2366z00_2742;
																																																										BgL_tagzd2381zd2_1762:
																																																											{	/* Ast/sexp.scm 349 */
																																																												obj_t
																																																													BgL_letzd2partzd2_8700;
																																																												BgL_letzd2partzd2_8700
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 349 */
																																																													obj_t
																																																														BgL_nexpz00_8701;
																																																													{	/* Ast/sexp.scm 350 */
																																																														obj_t
																																																															BgL_arg6814z00_8702;
																																																														obj_t
																																																															BgL_arg6815z00_8703;
																																																														BgL_arg6814z00_8702
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_letzd2partzd2_8700));
																																																														{	/* Ast/sexp.scm 350 */
																																																															obj_t
																																																																BgL_arg6816z00_8704;
																																																															obj_t
																																																																BgL_arg6817z00_8705;
																																																															{	/* Ast/sexp.scm 350 */
																																																																obj_t
																																																																	BgL_pairz00_9935;
																																																																BgL_pairz00_9935
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_letzd2partzd2_8700));
																																																																BgL_arg6816z00_8704
																																																																	=
																																																																	CAR
																																																																	(BgL_pairz00_9935);
																																																															}
																																																															{	/* Ast/sexp.scm 350 */
																																																																obj_t
																																																																	BgL_arg6818z00_8706;
																																																																BgL_arg6818z00_8706
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_bodyz00_1760,
																																																																	BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																	(BgL_argsz00_1761,
																																																																		BNIL));
																																																																BgL_arg6817z00_8705
																																																																	=
																																																																	MAKE_YOUNG_PAIR
																																																																	(BgL_arg6818z00_8706,
																																																																	BNIL);
																																																															}
																																																															BgL_arg6815z00_8703
																																																																=
																																																																MAKE_YOUNG_PAIR
																																																																(BgL_arg6816z00_8704,
																																																																BgL_arg6817z00_8705);
																																																														}
																																																														BgL_nexpz00_8701
																																																															=
																																																															MAKE_YOUNG_PAIR
																																																															(BgL_arg6814z00_8702,
																																																															BgL_arg6815z00_8703);
																																																													}
																																																													{	/* Ast/sexp.scm 350 */

																																																														BgL_auxz00_14688
																																																															=
																																																															BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																															(BgL_nexpz00_8701,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															BgL_sitez00_24);
																																																													}
																																																												}
																																																											}
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_14688);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd2738zd2_2743;
																																																										BgL_cdrzd2738zd2_2743
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8225z00_14705;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2440z00_2854;
																																																												BgL_arg2440z00_2854
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8225z00_14705
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2440z00_2854));
																																																											}
																																																											if (BgL_test8225z00_14705)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg2369z00_2746;
																																																													obj_t
																																																														BgL_arg2370z00_2747;
																																																													BgL_arg2369z00_2746
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2743));
																																																													BgL_arg2370z00_2747
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd2738zd2_2743));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_14714;
																																																														BgL_bindingsz00_1763
																																																															=
																																																															BgL_arg2369z00_2746;
																																																														BgL_exprz00_1764
																																																															=
																																																															BgL_arg2370z00_2747;
																																																													BgL_tagzd2382zd2_1765:
																																																														{	/* Ast/sexp.scm 354 */
																																																															bool_t
																																																																BgL_test8226z00_14715;
																																																															if (PAIRP(BgL_bindingsz00_1763))
																																																																{	/* Ast/sexp.scm 354 */
																																																																	if (NULLP(CDR(BgL_bindingsz00_1763)))
																																																																		{	/* Ast/sexp.scm 354 */
																																																																			if (PAIRP(BgL_exprz00_1764))
																																																																				{	/* Ast/sexp.scm 355 */
																																																																					BgL_test8226z00_14715
																																																																						=
																																																																						NULLP
																																																																						(CDR
																																																																						(BgL_exprz00_1764));
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 355 */
																																																																					BgL_test8226z00_14715
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 354 */
																																																																			BgL_test8226z00_14715
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 354 */
																																																																	BgL_test8226z00_14715
																																																																		=
																																																																		(
																																																																		(bool_t)
																																																																		0);
																																																																}
																																																															if (BgL_test8226z00_14715)
																																																																{
																																																																	obj_t
																																																																		BgL_varz00_8715;
																																																																	obj_t
																																																																		BgL_exprz00_8716;
																																																																	obj_t
																																																																		BgL_idz00_8717;
																																																																	obj_t
																																																																		BgL_thenz00_8718;
																																																																	obj_t
																																																																		BgL_otherwisez00_8719;
																																																																	if (PAIRP(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 356 */
																																																																			obj_t
																																																																				BgL_cdrzd262311zd2_8723;
																																																																			BgL_cdrzd262311zd2_8723
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if (PAIRP(BgL_cdrzd262311zd2_8723))
																																																																				{	/* Ast/sexp.scm 356 */
																																																																					obj_t
																																																																						BgL_carzd262317zd2_8725;
																																																																					obj_t
																																																																						BgL_cdrzd262318zd2_8726;
																																																																					BgL_carzd262317zd2_8725
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd262311zd2_8723);
																																																																					BgL_cdrzd262318zd2_8726
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262311zd2_8723);
																																																																					if (PAIRP(BgL_carzd262317zd2_8725))
																																																																						{	/* Ast/sexp.scm 356 */
																																																																							obj_t
																																																																								BgL_carzd262321zd2_8728;
																																																																							BgL_carzd262321zd2_8728
																																																																								=
																																																																								CAR
																																																																								(BgL_carzd262317zd2_8725);
																																																																							if (PAIRP(BgL_carzd262321zd2_8728))
																																																																								{	/* Ast/sexp.scm 356 */
																																																																									obj_t
																																																																										BgL_cdrzd262326zd2_8730;
																																																																									BgL_cdrzd262326zd2_8730
																																																																										=
																																																																										CDR
																																																																										(BgL_carzd262321zd2_8728);
																																																																									if (PAIRP(BgL_cdrzd262326zd2_8730))
																																																																										{	/* Ast/sexp.scm 356 */
																																																																											if (NULLP(CDR(BgL_cdrzd262326zd2_8730)))
																																																																												{	/* Ast/sexp.scm 356 */
																																																																													if (NULLP(CDR(BgL_carzd262317zd2_8725)))
																																																																														{	/* Ast/sexp.scm 356 */
																																																																															if (PAIRP(BgL_cdrzd262318zd2_8726))
																																																																																{	/* Ast/sexp.scm 356 */
																																																																																	obj_t
																																																																																		BgL_carzd262335zd2_8737;
																																																																																	BgL_carzd262335zd2_8737
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd262318zd2_8726);
																																																																																	if (PAIRP(BgL_carzd262335zd2_8737))
																																																																																		{	/* Ast/sexp.scm 356 */
																																																																																			obj_t
																																																																																				BgL_cdrzd262341zd2_8739;
																																																																																			BgL_cdrzd262341zd2_8739
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_carzd262335zd2_8737);
																																																																																			if ((CAR(BgL_carzd262335zd2_8737) == CNST_TABLE_REF(((long) 1))))
																																																																																				{	/* Ast/sexp.scm 356 */
																																																																																					if (PAIRP(BgL_cdrzd262341zd2_8739))
																																																																																						{	/* Ast/sexp.scm 356 */
																																																																																							obj_t
																																																																																								BgL_carzd262345zd2_8743;
																																																																																							obj_t
																																																																																								BgL_cdrzd262346zd2_8744;
																																																																																							BgL_carzd262345zd2_8743
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_cdrzd262341zd2_8739);
																																																																																							BgL_cdrzd262346zd2_8744
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_cdrzd262341zd2_8739);
																																																																																							if (SYMBOLP(BgL_carzd262345zd2_8743))
																																																																																								{	/* Ast/sexp.scm 356 */
																																																																																									if (PAIRP(BgL_cdrzd262346zd2_8744))
																																																																																										{	/* Ast/sexp.scm 356 */
																																																																																											obj_t
																																																																																												BgL_cdrzd262353zd2_8747;
																																																																																											BgL_cdrzd262353zd2_8747
																																																																																												=
																																																																																												CDR
																																																																																												(BgL_cdrzd262346zd2_8744);
																																																																																											if (PAIRP(BgL_cdrzd262353zd2_8747))
																																																																																												{	/* Ast/sexp.scm 356 */
																																																																																													if (NULLP(CDR(BgL_cdrzd262353zd2_8747)))
																																																																																														{	/* Ast/sexp.scm 356 */
																																																																																															if (NULLP(CDR(BgL_cdrzd262318zd2_8726)))
																																																																																																{	/* Ast/sexp.scm 356 */
																																																																																																	BgL_varz00_8715
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_carzd262321zd2_8728);
																																																																																																	BgL_exprz00_8716
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262326zd2_8730);
																																																																																																	BgL_idz00_8717
																																																																																																		=
																																																																																																		BgL_carzd262345zd2_8743;
																																																																																																	BgL_thenz00_8718
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262346zd2_8744);
																																																																																																	BgL_otherwisez00_8719
																																																																																																		=
																																																																																																		CAR
																																																																																																		(BgL_cdrzd262353zd2_8747);
																																																																																																	{	/* Ast/sexp.scm 361 */
																																																																																																		obj_t
																																																																																																			BgL_ntz00_8762;
																																																																																																		BgL_ntz00_8762
																																																																																																			=
																																																																																																			BGl_notzd2testzd2zzast_sexpz00
																																																																																																			(BgL_exprz00_8716);
																																																																																																		{	/* Ast/sexp.scm 362 */
																																																																																																			bool_t
																																																																																																				BgL_test8246z00_14774;
																																																																																																			if (CBOOL(BgL_ntz00_8762))
																																																																																																				{	/* Ast/sexp.scm 362 */
																																																																																																					if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8717, BgL_otherwisez00_8719))
																																																																																																						{	/* Ast/sexp.scm 363 */
																																																																																																							BgL_test8246z00_14774
																																																																																																								=
																																																																																																								(
																																																																																																								(bool_t)
																																																																																																								0);
																																																																																																						}
																																																																																																					else
																																																																																																						{	/* Ast/sexp.scm 363 */
																																																																																																							if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_8717, BgL_thenz00_8718))
																																																																																																								{	/* Ast/sexp.scm 364 */
																																																																																																									BgL_test8246z00_14774
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										0);
																																																																																																								}
																																																																																																							else
																																																																																																								{	/* Ast/sexp.scm 364 */
																																																																																																									BgL_test8246z00_14774
																																																																																																										=
																																																																																																										(
																																																																																																										(bool_t)
																																																																																																										1);
																																																																																																								}
																																																																																																						}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 362 */
																																																																																																					BgL_test8246z00_14774
																																																																																																						=
																																																																																																						(
																																																																																																						(bool_t)
																																																																																																						0);
																																																																																																				}
																																																																																																			if (BgL_test8246z00_14774)
																																																																																																				{	/* Ast/sexp.scm 365 */
																																																																																																					obj_t
																																																																																																						BgL_bindingz00_8766;
																																																																																																					obj_t
																																																																																																						BgL_bodyz00_8767;
																																																																																																					BgL_bindingz00_8766
																																																																																																						=
																																																																																																						CAR
																																																																																																						(
																																																																																																						((obj_t) BgL_bindingsz00_1763));
																																																																																																					{	/* Ast/sexp.scm 366 */
																																																																																																						obj_t
																																																																																																							BgL_pairz00_9948;
																																																																																																						{	/* Ast/sexp.scm 366 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9947;
																																																																																																							BgL_pairz00_9947
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_expz00_21));
																																																																																																							BgL_pairz00_9948
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9947);
																																																																																																						}
																																																																																																						BgL_bodyz00_8767
																																																																																																							=
																																																																																																							CAR
																																																																																																							(BgL_pairz00_9948);
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 367 */
																																																																																																						obj_t
																																																																																																							BgL_arg6859z00_8768;
																																																																																																						BgL_arg6859z00_8768
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_bindingz00_8766));
																																																																																																						{	/* Ast/sexp.scm 367 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14789;
																																																																																																							BgL_tmpz00_14789
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6859z00_8768);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14789,
																																																																																																								BgL_ntz00_8762);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 368 */
																																																																																																						obj_t
																																																																																																							BgL_arg6860z00_8769;
																																																																																																						{	/* Ast/sexp.scm 368 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9954;
																																																																																																							BgL_pairz00_9954
																																																																																																								=
																																																																																																								CDR
																																																																																																								(
																																																																																																								((obj_t) BgL_bodyz00_8767));
																																																																																																							BgL_arg6860z00_8769
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9954);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 368 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14795;
																																																																																																							BgL_tmpz00_14795
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6860z00_8769);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14795,
																																																																																																								BgL_otherwisez00_8719);
																																																																																																						}
																																																																																																					}
																																																																																																					{	/* Ast/sexp.scm 369 */
																																																																																																						obj_t
																																																																																																							BgL_arg6861z00_8770;
																																																																																																						{	/* Ast/sexp.scm 369 */
																																																																																																							obj_t
																																																																																																								BgL_pairz00_9961;
																																																																																																							{	/* Ast/sexp.scm 369 */
																																																																																																								obj_t
																																																																																																									BgL_pairz00_9960;
																																																																																																								BgL_pairz00_9960
																																																																																																									=
																																																																																																									CDR
																																																																																																									(
																																																																																																									((obj_t) BgL_bodyz00_8767));
																																																																																																								BgL_pairz00_9961
																																																																																																									=
																																																																																																									CDR
																																																																																																									(BgL_pairz00_9960);
																																																																																																							}
																																																																																																							BgL_arg6861z00_8770
																																																																																																								=
																																																																																																								CDR
																																																																																																								(BgL_pairz00_9961);
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 369 */
																																																																																																							obj_t
																																																																																																								BgL_tmpz00_14802;
																																																																																																							BgL_tmpz00_14802
																																																																																																								=
																																																																																																								(
																																																																																																								(obj_t)
																																																																																																								BgL_arg6861z00_8770);
																																																																																																							SET_CAR
																																																																																																								(BgL_tmpz00_14802,
																																																																																																								BgL_thenz00_8718);
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 362 */
																																																																																																					BFALSE;
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 356 */
																																																																																																	BFALSE;
																																																																																																}
																																																																																														}
																																																																																													else
																																																																																														{	/* Ast/sexp.scm 356 */
																																																																																															BFALSE;
																																																																																														}
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 356 */
																																																																																													BFALSE;
																																																																																												}
																																																																																										}
																																																																																									else
																																																																																										{	/* Ast/sexp.scm 356 */
																																																																																											BFALSE;
																																																																																										}
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 356 */
																																																																																									BFALSE;
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 356 */
																																																																																							BFALSE;
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 356 */
																																																																																					BFALSE;
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 356 */
																																																																																			BFALSE;
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 356 */
																																																																																	BFALSE;
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 356 */
																																																																															BFALSE;
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 356 */
																																																																													BFALSE;
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 356 */
																																																																											BFALSE;
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 356 */
																																																																									BFALSE;
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 356 */
																																																																							BFALSE;
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 356 */
																																																																					BFALSE;
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 356 */
																																																																			BFALSE;
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 354 */
																																																																	BFALSE;
																																																																}
																																																														}
																																																														BgL_auxz00_14714
																																																															=
																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																															(BgL_expz00_21,
																																																															BgL_stackz00_22,
																																																															BgL_locz00_23,
																																																															CNST_TABLE_REF
																																																															(((long) 2)));
																																																														BgL_auxz00_14300
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_14714);
																																																												}}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test8250z00_14812;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2439z00_2853;
																																																														BgL_arg2439z00_2853
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8250z00_14812
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2439z00_2853));
																																																													}
																																																													if (BgL_test8250z00_14812)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_14817;
																																																														BgL_tagzd2384zd2_1767:
																																																															BgL_auxz00_14817 = BGl_labelszd2ze3nodez31zzast_labelsz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_14817);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd2805zd2_2750;
																																																															BgL_carzd2805zd2_2750
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd2810zd2_2751;
																																																																BgL_cdrzd2810zd2_2751
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd2805zd2_2750));
																																																																if ((CAR(((obj_t) BgL_carzd2805zd2_2750)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg2375z00_2754;
																																																																		obj_t
																																																																			BgL_arg2376z00_2755;
																																																																		obj_t
																																																																			BgL_arg2377z00_2756;
																																																																		BgL_arg2375z00_2754
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2751));
																																																																		BgL_arg2376z00_2755
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd2810zd2_2751));
																																																																		BgL_arg2377z00_2756
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_14836;
																																																																			BgL_varsz00_1772
																																																																				=
																																																																				BgL_arg2375z00_2754;
																																																																			BgL_bodyz00_1773
																																																																				=
																																																																				BgL_arg2376z00_2755;
																																																																			BgL_argsz00_1774
																																																																				=
																																																																				BgL_arg2377z00_2756;
																																																																		BgL_tagzd2386zd2_1775:
																																																																			{	/* Ast/sexp.scm 383 */
																																																																				obj_t
																																																																					BgL_locz00_8782;
																																																																				obj_t
																																																																					BgL_nexpz00_8783;
																																																																				BgL_locz00_8782
																																																																					=
																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																					(BgL_expz00_21,
																																																																					BgL_locz00_23);
																																																																				{	/* Ast/sexp.scm 384 */
																																																																					obj_t
																																																																						BgL_arg6866z00_8784;
																																																																					obj_t
																																																																						BgL_arg6867z00_8785;
																																																																					BgL_arg6866z00_8784
																																																																						=
																																																																						BGl_letzd2symzd2zzast_letz00
																																																																						();
																																																																					{	/* Ast/sexp.scm 387 */
																																																																						obj_t
																																																																							BgL_arg6868z00_8786;
																																																																						obj_t
																																																																							BgL_arg6869z00_8787;
																																																																						BgL_arg6868z00_8786
																																																																							=
																																																																							BGl_loopze70ze7zzast_sexpz00
																																																																							(BgL_expz00_21,
																																																																							BgL_locz00_23,
																																																																							BgL_varsz00_1772,
																																																																							BgL_argsz00_1774);
																																																																						{	/* Ast/sexp.scm 426 */
																																																																							obj_t
																																																																								BgL_arg6911z00_8837;
																																																																							{	/* Ast/sexp.scm 426 */
																																																																								obj_t
																																																																									BgL_arg6912z00_8838;
																																																																								obj_t
																																																																									BgL_arg6913z00_8839;
																																																																								BgL_arg6912z00_8838
																																																																									=
																																																																									BGl_shapez00zztools_shapez00
																																																																									(BGl_currentzd2functionzd2zztools_errorz00
																																																																									());
																																																																								BgL_arg6913z00_8839
																																																																									=
																																																																									BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																									(BgL_bodyz00_1773);
																																																																								{	/* Ast/sexp.scm 430 */
																																																																									obj_t
																																																																										BgL_zc3z04anonymousza36916ze3z87_13843;
																																																																									BgL_zc3z04anonymousza36916ze3z87_13843
																																																																										=
																																																																										MAKE_FX_PROCEDURE
																																																																										(BGl_z62zc3z04anonymousza36916ze3ze5zzast_sexpz00,
																																																																										(int)
																																																																										(((long) 3)), (int) (((long) 1)));
																																																																									PROCEDURE_SET
																																																																										(BgL_zc3z04anonymousza36916ze3z87_13843,
																																																																										(int)
																																																																										(((long) 0)), BgL_locz00_23);
																																																																									BgL_arg6911z00_8837
																																																																										=
																																																																										BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
																																																																										(BgL_arg6912z00_8838,
																																																																										BgL_varsz00_1772,
																																																																										BgL_arg6913z00_8839,
																																																																										BgL_zc3z04anonymousza36916ze3z87_13843);
																																																																							}}
																																																																							BgL_arg6869z00_8787
																																																																								=
																																																																								MAKE_YOUNG_PAIR
																																																																								(BgL_arg6911z00_8837,
																																																																								BNIL);
																																																																						}
																																																																						BgL_arg6867z00_8785
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(BgL_arg6868z00_8786,
																																																																							BgL_arg6869z00_8787);
																																																																					}
																																																																					BgL_nexpz00_8783
																																																																						=
																																																																						MAKE_YOUNG_PAIR
																																																																						(BgL_arg6866z00_8784,
																																																																						BgL_arg6867z00_8785);
																																																																				}
																																																																				BgL_auxz00_14836
																																																																					=
																																																																					BGl_letzd2ze3nodez31zzast_letz00
																																																																					(BgL_nexpz00_8783,
																																																																					BgL_stackz00_22,
																																																																					BgL_locz00_8782,
																																																																					CNST_TABLE_REF
																																																																					(((long) 2)));
																																																																			}
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_14836);
																																																																	}}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd2833zd2_2758;
																																																																		BgL_cdrzd2833zd2_2758
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd2839zd2_2759;
																																																																			BgL_cdrzd2839zd2_2759
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd2805zd2_2750));
																																																																			if ((CAR(((obj_t) BgL_carzd2805zd2_2750)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd2845zd2_2762;
																																																																					BgL_cdrzd2845zd2_2762
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd2839zd2_2759));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd2850zd2_2763;
																																																																						obj_t
																																																																							BgL_cdrzd2851zd2_2764;
																																																																						BgL_carzd2850zd2_2763
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2762));
																																																																						BgL_cdrzd2851zd2_2764
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd2845zd2_2762));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2850zd2_2763))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (PAIRP(BgL_cdrzd2851zd2_2764))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd2858zd2_2767;
																																																																										BgL_carzd2858zd2_2767
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd2851zd2_2764);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2858zd2_2767))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (NULLP(CDR(BgL_cdrzd2851zd2_2764)))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test8257z00_14880;
																																																																														{
																																																																															obj_t
																																																																																BgL_l1365z00_2800;
																																																																															BgL_l1365z00_2800
																																																																																=
																																																																																BgL_cdrzd2833zd2_2758;
																																																																														BgL_zc3z04anonymousza32401ze3z87_2801:
																																																																															if (NULLP(BgL_l1365z00_2800))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8257z00_14880
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test8259z00_14883;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test8260z00_14884;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_tmpz00_14885;
																																																																																			BgL_tmpz00_14885
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_l1365z00_2800));
																																																																																			BgL_test8260z00_14884
																																																																																				=
																																																																																				PAIRP
																																																																																				(BgL_tmpz00_14885);
																																																																																		}
																																																																																		if (BgL_test8260z00_14884)
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8259z00_14883
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8259z00_14883
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test8259z00_14883)
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_l1365z00_14889;
																																																																																			BgL_l1365z00_14889
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_l1365z00_2800));
																																																																																			BgL_l1365z00_2800
																																																																																				=
																																																																																				BgL_l1365z00_14889;
																																																																																			goto
																																																																																				BgL_zc3z04anonymousza32401ze3z87_2801;
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test8257z00_14880
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																}
																																																																														}
																																																																														if (BgL_test8257z00_14880)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg2391z00_2783;
																																																																																BgL_arg2391z00_2783
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd2839zd2_2759));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_14894;
																																																																																	BgL_testz00_1776
																																																																																		=
																																																																																		BgL_arg2391z00_2783;
																																																																																	BgL_proc1z00_1777
																																																																																		=
																																																																																		BgL_carzd2850zd2_2763;
																																																																																	BgL_proc2z00_1778
																																																																																		=
																																																																																		BgL_carzd2858zd2_2767;
																																																																																	BgL_argsz00_1779
																																																																																		=
																																																																																		BgL_cdrzd2833zd2_2758;
																																																																																BgL_tagzd2387zd2_1780:
																																																																																	{	/* Ast/sexp.scm 437 */
																																																																																		obj_t
																																																																																			BgL_nexpz00_8848;
																																																																																		{	/* Ast/sexp.scm 437 */
																																																																																			obj_t
																																																																																				BgL_arg6919z00_8850;
																																																																																			{	/* Ast/sexp.scm 437 */
																																																																																				obj_t
																																																																																					BgL_arg6920z00_8851;
																																																																																				{	/* Ast/sexp.scm 437 */
																																																																																					obj_t
																																																																																						BgL_arg6921z00_8852;
																																																																																					obj_t
																																																																																						BgL_arg6922z00_8853;
																																																																																					BgL_arg6921z00_8852
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_proc1z00_1777,
																																																																																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																						(BgL_argsz00_1779,
																																																																																							BNIL));
																																																																																					{	/* Ast/sexp.scm 437 */
																																																																																						obj_t
																																																																																							BgL_arg6924z00_8855;
																																																																																						BgL_arg6924z00_8855
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_proc2z00_1778,
																																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																							(BgL_argsz00_1779,
																																																																																								BNIL));
																																																																																						BgL_arg6922z00_8853
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(BgL_arg6924z00_8855,
																																																																																							BNIL);
																																																																																					}
																																																																																					BgL_arg6920z00_8851
																																																																																						=
																																																																																						MAKE_YOUNG_PAIR
																																																																																						(BgL_arg6921z00_8852,
																																																																																						BgL_arg6922z00_8853);
																																																																																				}
																																																																																				BgL_arg6919z00_8850
																																																																																					=
																																																																																					MAKE_YOUNG_PAIR
																																																																																					(BgL_testz00_1776,
																																																																																					BgL_arg6920z00_8851);
																																																																																			}
																																																																																			BgL_nexpz00_8848
																																																																																				=
																																																																																				MAKE_YOUNG_PAIR
																																																																																				(CNST_TABLE_REF
																																																																																				(((long) 1)), BgL_arg6919z00_8850);
																																																																																		}
																																																																																		BgL_auxz00_14894
																																																																																			=
																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																			(BgL_nexpz00_8848,
																																																																																			BgL_stackz00_22,
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_locz00_23),
																																																																																			BgL_sitez00_24);
																																																																																	}
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_14894);
																																																																															}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd2882zd2_2784;
																																																																																BgL_cdrzd2882zd2_2784
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd2889zd2_2785;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10198;
																																																																																		BgL_pairz00_10198
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_expz00_21));
																																																																																		BgL_cdrzd2889zd2_2785
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_pairz00_10198);
																																																																																	}
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd2896zd2_2786;
																																																																																		BgL_cdrzd2896zd2_2786
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd2889zd2_2785));
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd2902zd2_2787;
																																																																																			BgL_carzd2902zd2_2787
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd2896zd2_2786));
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2902zd2_2787))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_carzd2909zd2_2789;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_pairz00_10202;
																																																																																						BgL_pairz00_10202
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd2896zd2_2786));
																																																																																						BgL_carzd2909zd2_2789
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_pairz00_10202);
																																																																																					}
																																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd2909zd2_2789))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd2882zd2_2784))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_arg2395z00_2792;
																																																																																									BgL_arg2395z00_2792
																																																																																										=
																																																																																										CAR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd2889zd2_2785));
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_14927;
																																																																																										BgL_testz00_1781
																																																																																											=
																																																																																											BgL_arg2395z00_2792;
																																																																																										BgL_proc1z00_1782
																																																																																											=
																																																																																											BgL_carzd2902zd2_2787;
																																																																																										BgL_proc2z00_1783
																																																																																											=
																																																																																											BgL_carzd2909zd2_2789;
																																																																																										BgL_argsz00_1784
																																																																																											=
																																																																																											BgL_cdrzd2882zd2_2784;
																																																																																									BgL_tagzd2388zd2_1785:
																																																																																										{	/* Ast/sexp.scm 443 */
																																																																																											obj_t
																																																																																												BgL_tmpsz00_8857;
																																																																																											if (NULLP(BgL_argsz00_1784))
																																																																																												{	/* Ast/sexp.scm 443 */
																																																																																													BgL_tmpsz00_8857
																																																																																														=
																																																																																														BNIL;
																																																																																												}
																																																																																											else
																																																																																												{	/* Ast/sexp.scm 443 */
																																																																																													obj_t
																																																																																														BgL_head1354z00_8901;
																																																																																													{	/* Ast/sexp.scm 443 */
																																																																																														obj_t
																																																																																															BgL_res7470z00_10022;
																																																																																														BgL_res7470z00_10022
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BNIL,
																																																																																															BNIL);
																																																																																														BgL_head1354z00_8901
																																																																																															=
																																																																																															BgL_res7470z00_10022;
																																																																																													}
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_l1352z00_8903;
																																																																																														obj_t
																																																																																															BgL_tail1355z00_8904;
																																																																																														BgL_l1352z00_8903
																																																																																															=
																																																																																															BgL_argsz00_1784;
																																																																																														BgL_tail1355z00_8904
																																																																																															=
																																																																																															BgL_head1354z00_8901;
																																																																																													BgL_zc3z04anonymousza36955ze3z87_8905:
																																																																																														if (NULLP(BgL_l1352z00_8903))
																																																																																															{	/* Ast/sexp.scm 443 */
																																																																																																BgL_tmpsz00_8857
																																																																																																	=
																																																																																																	CDR
																																																																																																	(BgL_head1354z00_8901);
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 443 */
																																																																																																obj_t
																																																																																																	BgL_newtail1356z00_8907;
																																																																																																{	/* Ast/sexp.scm 443 */
																																																																																																	obj_t
																																																																																																		BgL_arg6958z00_8909;
																																																																																																	{	/* Ast/sexp.scm 443 */

																																																																																																		{	/* Ast/sexp.scm 443 */

																																																																																																			BgL_arg6958z00_8909
																																																																																																				=
																																																																																																				BGl_gensymz00zz__r4_symbols_6_4z00
																																																																																																				(BFALSE);
																																																																																																		}
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 443 */
																																																																																																		obj_t
																																																																																																			BgL_res7472z00_10026;
																																																																																																		BgL_res7472z00_10026
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_arg6958z00_8909,
																																																																																																			BNIL);
																																																																																																		BgL_newtail1356z00_8907
																																																																																																			=
																																																																																																			BgL_res7472z00_10026;
																																																																																																	}
																																																																																																}
																																																																																																SET_CDR
																																																																																																	(BgL_tail1355z00_8904,
																																																																																																	BgL_newtail1356z00_8907);
																																																																																																{	/* Ast/sexp.scm 443 */
																																																																																																	obj_t
																																																																																																		BgL_arg6957z00_8908;
																																																																																																	BgL_arg6957z00_8908
																																																																																																		=
																																																																																																		CDR
																																																																																																		(
																																																																																																		((obj_t) BgL_l1352z00_8903));
																																																																																																	{
																																																																																																		obj_t
																																																																																																			BgL_tail1355z00_14940;
																																																																																																		obj_t
																																																																																																			BgL_l1352z00_14939;
																																																																																																		BgL_l1352z00_14939
																																																																																																			=
																																																																																																			BgL_arg6957z00_8908;
																																																																																																		BgL_tail1355z00_14940
																																																																																																			=
																																																																																																			BgL_newtail1356z00_8907;
																																																																																																		BgL_tail1355z00_8904
																																																																																																			=
																																																																																																			BgL_tail1355z00_14940;
																																																																																																		BgL_l1352z00_8903
																																																																																																			=
																																																																																																			BgL_l1352z00_14939;
																																																																																																		goto
																																																																																																			BgL_zc3z04anonymousza36955ze3z87_8905;
																																																																																																	}
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											{	/* Ast/sexp.scm 443 */
																																																																																												obj_t
																																																																																													BgL_locz00_8858;
																																																																																												BgL_locz00_8858
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_expz00_21,
																																																																																													BgL_locz00_23);
																																																																																												{	/* Ast/sexp.scm 444 */
																																																																																													obj_t
																																																																																														BgL_nexpz00_8859;
																																																																																													{	/* Ast/sexp.scm 445 */
																																																																																														obj_t
																																																																																															BgL_arg6927z00_8861;
																																																																																														obj_t
																																																																																															BgL_arg6928z00_8862;
																																																																																														BgL_arg6927z00_8861
																																																																																															=
																																																																																															BGl_letzd2symzd2zzast_letz00
																																																																																															();
																																																																																														{	/* Ast/sexp.scm 445 */
																																																																																															obj_t
																																																																																																BgL_arg6929z00_8863;
																																																																																															obj_t
																																																																																																BgL_arg6930z00_8864;
																																																																																															if (NULLP(BgL_tmpsz00_8857))
																																																																																																{	/* Ast/sexp.scm 445 */
																																																																																																	BgL_arg6929z00_8863
																																																																																																		=
																																																																																																		BNIL;
																																																																																																}
																																																																																															else
																																																																																																{	/* Ast/sexp.scm 445 */
																																																																																																	obj_t
																																																																																																		BgL_head1359z00_8868;
																																																																																																	{	/* Ast/sexp.scm 445 */
																																																																																																		obj_t
																																																																																																			BgL_arg6941z00_8886;
																																																																																																		{	/* Ast/sexp.scm 445 */
																																																																																																			obj_t
																																																																																																				BgL_arg6942z00_8887;
																																																																																																			obj_t
																																																																																																				BgL_arg6943z00_8888;
																																																																																																			BgL_arg6942z00_8887
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_tmpsz00_8857));
																																																																																																			BgL_arg6943z00_8888
																																																																																																				=
																																																																																																				CAR
																																																																																																				(
																																																																																																				((obj_t) BgL_argsz00_1784));
																																																																																																			{	/* Ast/sexp.scm 445 */
																																																																																																				obj_t
																																																																																																					BgL_list6944z00_8889;
																																																																																																				{	/* Ast/sexp.scm 445 */
																																																																																																					obj_t
																																																																																																						BgL_arg6945z00_8890;
																																																																																																					BgL_arg6945z00_8890
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6943z00_8888,
																																																																																																						BNIL);
																																																																																																					BgL_list6944z00_8889
																																																																																																						=
																																																																																																						MAKE_YOUNG_PAIR
																																																																																																						(BgL_arg6942z00_8887,
																																																																																																						BgL_arg6945z00_8890);
																																																																																																				}
																																																																																																				BgL_arg6941z00_8886
																																																																																																					=
																																																																																																					BgL_list6944z00_8889;
																																																																																																			}
																																																																																																		}
																																																																																																		{	/* Ast/sexp.scm 445 */
																																																																																																			obj_t
																																																																																																				BgL_res7475z00_10033;
																																																																																																			BgL_res7475z00_10033
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6941z00_8886,
																																																																																																				BNIL);
																																																																																																			BgL_head1359z00_8868
																																																																																																				=
																																																																																																				BgL_res7475z00_10033;
																																																																																																		}
																																																																																																	}
																																																																																																	{	/* Ast/sexp.scm 445 */
																																																																																																		obj_t
																																																																																																			BgL_g1363z00_8869;
																																																																																																		obj_t
																																																																																																			BgL_g1364z00_8870;
																																																																																																		BgL_g1363z00_8869
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_tmpsz00_8857));
																																																																																																		BgL_g1364z00_8870
																																																																																																			=
																																																																																																			CDR
																																																																																																			(
																																																																																																			((obj_t) BgL_argsz00_1784));
																																																																																																		{
																																																																																																			obj_t
																																																																																																				BgL_ll1357z00_8872;
																																																																																																			obj_t
																																																																																																				BgL_ll1358z00_8873;
																																																																																																			obj_t
																																																																																																				BgL_tail1360z00_8874;
																																																																																																			BgL_ll1357z00_8872
																																																																																																				=
																																																																																																				BgL_g1363z00_8869;
																																																																																																			BgL_ll1358z00_8873
																																																																																																				=
																																																																																																				BgL_g1364z00_8870;
																																																																																																			BgL_tail1360z00_8874
																																																																																																				=
																																																																																																				BgL_head1359z00_8868;
																																																																																																		BgL_zc3z04anonymousza36932ze3z87_8875:
																																																																																																			if (NULLP(BgL_ll1357z00_8872))
																																																																																																				{	/* Ast/sexp.scm 445 */
																																																																																																					BgL_arg6929z00_8863
																																																																																																						=
																																																																																																						BgL_head1359z00_8868;
																																																																																																				}
																																																																																																			else
																																																																																																				{	/* Ast/sexp.scm 445 */
																																																																																																					obj_t
																																																																																																						BgL_newtail1361z00_8877;
																																																																																																					{	/* Ast/sexp.scm 445 */
																																																																																																						obj_t
																																																																																																							BgL_arg6936z00_8880;
																																																																																																						{	/* Ast/sexp.scm 445 */
																																																																																																							obj_t
																																																																																																								BgL_arg6937z00_8881;
																																																																																																							obj_t
																																																																																																								BgL_arg6938z00_8882;
																																																																																																							BgL_arg6937z00_8881
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1357z00_8872));
																																																																																																							BgL_arg6938z00_8882
																																																																																																								=
																																																																																																								CAR
																																																																																																								(
																																																																																																								((obj_t) BgL_ll1358z00_8873));
																																																																																																							{	/* Ast/sexp.scm 445 */
																																																																																																								obj_t
																																																																																																									BgL_list6939z00_8883;
																																																																																																								{	/* Ast/sexp.scm 445 */
																																																																																																									obj_t
																																																																																																										BgL_arg6940z00_8884;
																																																																																																									BgL_arg6940z00_8884
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6938z00_8882,
																																																																																																										BNIL);
																																																																																																									BgL_list6939z00_8883
																																																																																																										=
																																																																																																										MAKE_YOUNG_PAIR
																																																																																																										(BgL_arg6937z00_8881,
																																																																																																										BgL_arg6940z00_8884);
																																																																																																								}
																																																																																																								BgL_arg6936z00_8880
																																																																																																									=
																																																																																																									BgL_list6939z00_8883;
																																																																																																							}
																																																																																																						}
																																																																																																						{	/* Ast/sexp.scm 445 */
																																																																																																							obj_t
																																																																																																								BgL_res7478z00_10040;
																																																																																																							BgL_res7478z00_10040
																																																																																																								=
																																																																																																								MAKE_YOUNG_PAIR
																																																																																																								(BgL_arg6936z00_8880,
																																																																																																								BNIL);
																																																																																																							BgL_newtail1361z00_8877
																																																																																																								=
																																																																																																								BgL_res7478z00_10040;
																																																																																																						}
																																																																																																					}
																																																																																																					SET_CDR
																																																																																																						(BgL_tail1360z00_8874,
																																																																																																						BgL_newtail1361z00_8877);
																																																																																																					{	/* Ast/sexp.scm 445 */
																																																																																																						obj_t
																																																																																																							BgL_arg6934z00_8878;
																																																																																																						obj_t
																																																																																																							BgL_arg6935z00_8879;
																																																																																																						BgL_arg6934z00_8878
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1357z00_8872));
																																																																																																						BgL_arg6935z00_8879
																																																																																																							=
																																																																																																							CDR
																																																																																																							(
																																																																																																							((obj_t) BgL_ll1358z00_8873));
																																																																																																						{
																																																																																																							obj_t
																																																																																																								BgL_tail1360z00_14972;
																																																																																																							obj_t
																																																																																																								BgL_ll1358z00_14971;
																																																																																																							obj_t
																																																																																																								BgL_ll1357z00_14970;
																																																																																																							BgL_ll1357z00_14970
																																																																																																								=
																																																																																																								BgL_arg6934z00_8878;
																																																																																																							BgL_ll1358z00_14971
																																																																																																								=
																																																																																																								BgL_arg6935z00_8879;
																																																																																																							BgL_tail1360z00_14972
																																																																																																								=
																																																																																																								BgL_newtail1361z00_8877;
																																																																																																							BgL_tail1360z00_8874
																																																																																																								=
																																																																																																								BgL_tail1360z00_14972;
																																																																																																							BgL_ll1358z00_8873
																																																																																																								=
																																																																																																								BgL_ll1358z00_14971;
																																																																																																							BgL_ll1357z00_8872
																																																																																																								=
																																																																																																								BgL_ll1357z00_14970;
																																																																																																							goto
																																																																																																								BgL_zc3z04anonymousza36932ze3z87_8875;
																																																																																																						}
																																																																																																					}
																																																																																																				}
																																																																																																		}
																																																																																																	}
																																																																																																}
																																																																																															{	/* Ast/sexp.scm 446 */
																																																																																																obj_t
																																																																																																	BgL_arg6946z00_8891;
																																																																																																{	/* Ast/sexp.scm 446 */
																																																																																																	obj_t
																																																																																																		BgL_arg6947z00_8892;
																																																																																																	{	/* Ast/sexp.scm 446 */
																																																																																																		obj_t
																																																																																																			BgL_arg6948z00_8893;
																																																																																																		{	/* Ast/sexp.scm 446 */
																																																																																																			obj_t
																																																																																																				BgL_arg6949z00_8894;
																																																																																																			obj_t
																																																																																																				BgL_arg6950z00_8895;
																																																																																																			BgL_arg6949z00_8894
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_proc1z00_1782,
																																																																																																				BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																				(BgL_tmpsz00_8857,
																																																																																																					BNIL));
																																																																																																			{	/* Ast/sexp.scm 446 */
																																																																																																				obj_t
																																																																																																					BgL_arg6952z00_8897;
																																																																																																				BgL_arg6952z00_8897
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_proc2z00_1783,
																																																																																																					BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																																																					(BgL_tmpsz00_8857,
																																																																																																						BNIL));
																																																																																																				BgL_arg6950z00_8895
																																																																																																					=
																																																																																																					MAKE_YOUNG_PAIR
																																																																																																					(BgL_arg6952z00_8897,
																																																																																																					BNIL);
																																																																																																			}
																																																																																																			BgL_arg6948z00_8893
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(BgL_arg6949z00_8894,
																																																																																																				BgL_arg6950z00_8895);
																																																																																																		}
																																																																																																		BgL_arg6947z00_8892
																																																																																																			=
																																																																																																			MAKE_YOUNG_PAIR
																																																																																																			(BgL_testz00_1781,
																																																																																																			BgL_arg6948z00_8893);
																																																																																																	}
																																																																																																	BgL_arg6946z00_8891
																																																																																																		=
																																																																																																		MAKE_YOUNG_PAIR
																																																																																																		(CNST_TABLE_REF
																																																																																																		(((long) 1)), BgL_arg6947z00_8892);
																																																																																																}
																																																																																																BgL_arg6930z00_8864
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BgL_arg6946z00_8891,
																																																																																																	BNIL);
																																																																																															}
																																																																																															BgL_arg6928z00_8862
																																																																																																=
																																																																																																MAKE_YOUNG_PAIR
																																																																																																(BgL_arg6929z00_8863,
																																																																																																BgL_arg6930z00_8864);
																																																																																														}
																																																																																														BgL_nexpz00_8859
																																																																																															=
																																																																																															MAKE_YOUNG_PAIR
																																																																																															(BgL_arg6927z00_8861,
																																																																																															BgL_arg6928z00_8862);
																																																																																													}
																																																																																													{	/* Ast/sexp.scm 445 */

																																																																																														BgL_auxz00_14927
																																																																																															=
																																																																																															BGl_letzd2ze3nodez31zzast_letz00
																																																																																															(BgL_nexpz00_8859,
																																																																																															BgL_stackz00_22,
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_expz00_21,
																																																																																																BgL_locz00_8858),
																																																																																															BgL_sitez00_24);
																																																																																										}}}}
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_14927);
																																																																																								}}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																										{	/* Ast/sexp.scm 119 */
																																																																																										BgL_tagzd2403zd2_1809:
																																																																																											BgL_auxz00_14300 = BGl_privatezd2nodezd2zzast_privatez00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																										}
																																																																																									else
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_14991;
																																																																																										BgL_tagzd2404zd2_1810:
																																																																																											BgL_auxz00_14991 = BGl_callzd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																											BgL_auxz00_14300
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_14991);
																																																																																										}
																																																																																								}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1809;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_14996;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1810;
																																																																																									BgL_auxz00_14300
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_14996);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15000;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15000);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	}
																																																																																}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_15004;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_15004);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd21185zd2_2811;
																																																																												BgL_cdrzd21185zd2_2811
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd21191zd2_2812;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10206;
																																																																														BgL_pairz00_10206
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd21191zd2_2812
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10206);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd21197zd2_2813;
																																																																														BgL_cdrzd21197zd2_2813
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd21191zd2_2812));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd21202zd2_2814;
																																																																															obj_t
																																																																																BgL_cdrzd21203zd2_2815;
																																																																															BgL_carzd21202zd2_2814
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2813));
																																																																															BgL_cdrzd21203zd2_2815
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd21197zd2_2813));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21202zd2_2814))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd21208zd2_2817;
																																																																																	BgL_carzd21208zd2_2817
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd21203zd2_2815));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21208zd2_2817))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (NULLP(CDR(((obj_t) BgL_cdrzd21203zd2_2815))))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21185zd2_2811))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg2412z00_2822;
																																																																																							BgL_arg2412z00_2822
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd21191zd2_2812));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15031;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_15035;
																																																																																									obj_t
																																																																																										BgL_proc2z00_15034;
																																																																																									obj_t
																																																																																										BgL_proc1z00_15033;
																																																																																									obj_t
																																																																																										BgL_testz00_15032;
																																																																																									BgL_testz00_15032
																																																																																										=
																																																																																										BgL_arg2412z00_2822;
																																																																																									BgL_proc1z00_15033
																																																																																										=
																																																																																										BgL_carzd21202zd2_2814;
																																																																																									BgL_proc2z00_15034
																																																																																										=
																																																																																										BgL_carzd21208zd2_2817;
																																																																																									BgL_argsz00_15035
																																																																																										=
																																																																																										BgL_cdrzd21185zd2_2811;
																																																																																									BgL_argsz00_1784
																																																																																										=
																																																																																										BgL_argsz00_15035;
																																																																																									BgL_proc2z00_1783
																																																																																										=
																																																																																										BgL_proc2z00_15034;
																																																																																									BgL_proc1z00_1782
																																																																																										=
																																																																																										BgL_proc1z00_15033;
																																																																																									BgL_testz00_1781
																																																																																										=
																																																																																										BgL_testz00_15032;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1785;
																																																																																								}
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15031);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1809;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_15039;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1810;
																																																																																									BgL_auxz00_14300
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_15039);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15043;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15043);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15047;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15047);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15051;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15051);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_15055;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_14300
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_15055);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd21541zd2_2830;
																																																																								BgL_cdrzd21541zd2_2830
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd21548zd2_2831;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10216;
																																																																										BgL_pairz00_10216
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd21548zd2_2831
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10216);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd21555zd2_2832;
																																																																										BgL_cdrzd21555zd2_2832
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd21548zd2_2831));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd21561zd2_2833;
																																																																											obj_t
																																																																												BgL_cdrzd21562zd2_2834;
																																																																											BgL_carzd21561zd2_2833
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2832));
																																																																											BgL_cdrzd21562zd2_2834
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd21555zd2_2832));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21561zd2_2833))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd21562zd2_2834))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd21569zd2_2837;
																																																																															BgL_carzd21569zd2_2837
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd21562zd2_2834);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd21569zd2_2837))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(BgL_cdrzd21562zd2_2834)))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd21541zd2_2830))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2426z00_2842;
																																																																																					BgL_arg2426z00_2842
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd21548zd2_2831));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15082;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15086;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15085;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15084;
																																																																																							obj_t
																																																																																								BgL_testz00_15083;
																																																																																							BgL_testz00_15083
																																																																																								=
																																																																																								BgL_arg2426z00_2842;
																																																																																							BgL_proc1z00_15084
																																																																																								=
																																																																																								BgL_carzd21561zd2_2833;
																																																																																							BgL_proc2z00_15085
																																																																																								=
																																																																																								BgL_carzd21569zd2_2837;
																																																																																							BgL_argsz00_15086
																																																																																								=
																																																																																								BgL_cdrzd21541zd2_2830;
																																																																																							BgL_argsz00_1784
																																																																																								=
																																																																																								BgL_argsz00_15086;
																																																																																							BgL_proc2z00_1783
																																																																																								=
																																																																																								BgL_proc2z00_15085;
																																																																																							BgL_proc1z00_1782
																																																																																								=
																																																																																								BgL_proc1z00_15084;
																																																																																							BgL_testz00_1781
																																																																																								=
																																																																																								BgL_testz00_15083;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1785;
																																																																																						}
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15082);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15090;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15090);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15094;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15094);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_15098;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_15098);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15102;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15102);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15106;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15106);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15110;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15110);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd21962zd2_2856;
																																																								BgL_cdrzd21962zd2_2856
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8292z00_15114;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2457z00_2873;
																																																										BgL_arg2457z00_2873
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8292z00_15114
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2457z00_2873));
																																																									}
																																																									if (BgL_test8292z00_15114)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2444z00_2859;
																																																											obj_t
																																																												BgL_arg2445z00_2860;
																																																											BgL_arg2444z00_2859
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2856));
																																																											BgL_arg2445z00_2860
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd21962zd2_2856));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_15123;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_15125;
																																																													obj_t
																																																														BgL_bindingsz00_15124;
																																																													BgL_bindingsz00_15124
																																																														=
																																																														BgL_arg2444z00_2859;
																																																													BgL_exprz00_15125
																																																														=
																																																														BgL_arg2445z00_2860;
																																																													BgL_exprz00_1764
																																																														=
																																																														BgL_exprz00_15125;
																																																													BgL_bindingsz00_1763
																																																														=
																																																														BgL_bindingsz00_15124;
																																																													goto
																																																														BgL_tagzd2382zd2_1765;
																																																												}
																																																												BgL_auxz00_14300
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_15123);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8293z00_15127;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2456z00_2872;
																																																												BgL_arg2456z00_2872
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8293z00_15127
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2456z00_2872));
																																																											}
																																																											if (BgL_test8293z00_15127)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15132;
																																																													goto
																																																														BgL_tagzd2384zd2_1767;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15132);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd22028zd2_2863;
																																																													BgL_carzd22028zd2_2863
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd22033zd2_2864;
																																																														BgL_cdrzd22033zd2_2864
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd22028zd2_2863));
																																																														if ((CAR(((obj_t) BgL_carzd22028zd2_2863)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2450z00_2867;
																																																																obj_t
																																																																	BgL_arg2451z00_2868;
																																																																obj_t
																																																																	BgL_arg2453z00_2869;
																																																																BgL_arg2450z00_2867
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2864));
																																																																BgL_arg2451z00_2868
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd22033zd2_2864));
																																																																BgL_arg2453z00_2869
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15149;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_15152;
																																																																		obj_t
																																																																			BgL_bodyz00_15151;
																																																																		obj_t
																																																																			BgL_varsz00_15150;
																																																																		BgL_varsz00_15150
																																																																			=
																																																																			BgL_arg2450z00_2867;
																																																																		BgL_bodyz00_15151
																																																																			=
																																																																			BgL_arg2451z00_2868;
																																																																		BgL_argsz00_15152
																																																																			=
																																																																			BgL_arg2453z00_2869;
																																																																		BgL_argsz00_1774
																																																																			=
																																																																			BgL_argsz00_15152;
																																																																		BgL_bodyz00_1773
																																																																			=
																																																																			BgL_bodyz00_15151;
																																																																		BgL_varsz00_1772
																																																																			=
																																																																			BgL_varsz00_15150;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1775;
																																																																	}
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15149);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_15156;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_15156);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd22144zd2_2874;
																																																						BgL_cdrzd22144zd2_2874
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8296z00_15160;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2470z00_2883;
																																																								BgL_arg2470z00_2883
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8296z00_15160
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2470z00_2883));
																																																							}
																																																							if (BgL_test8296z00_15160)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2460z00_2877;
																																																									obj_t
																																																										BgL_arg2461z00_2878;
																																																									BgL_arg2460z00_2877
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2874));
																																																									BgL_arg2461z00_2878
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd22144zd2_2874));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_15169;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_15171;
																																																											obj_t
																																																												BgL_bindingsz00_15170;
																																																											BgL_bindingsz00_15170
																																																												=
																																																												BgL_arg2460z00_2877;
																																																											BgL_exprz00_15171
																																																												=
																																																												BgL_arg2461z00_2878;
																																																											BgL_exprz00_1764
																																																												=
																																																												BgL_exprz00_15171;
																																																											BgL_bindingsz00_1763
																																																												=
																																																												BgL_bindingsz00_15170;
																																																											goto
																																																												BgL_tagzd2382zd2_1765;
																																																										}
																																																										BgL_auxz00_14300
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_15169);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8297z00_15173;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2467z00_2882;
																																																										BgL_arg2467z00_2882
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8297z00_15173
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2467z00_2882));
																																																									}
																																																									if (BgL_test8297z00_15173)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15178;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15178);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_15182;
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15182);
																																																												}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2709zd2_2610)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd2711zd2_2612;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd2709zd2_2610 == CNST_TABLE_REF(((long) 18))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd2711zd2_2612;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if ((BgL_carzd2709zd2_2610 == CNST_TABLE_REF(((long) 19))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd2711zd2_2612;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd2709zd2_2610)))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_kapzd2711zd2_2612;
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd22316zd2_2618;
																																																												BgL_cdrzd22316zd2_2618
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test8303z00_15198;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2360z00_2735;
																																																														BgL_arg2360z00_2735
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8303z00_15198
																																																															=
																																																															CBOOL
																																																															(BGl_letzd2symzf3z21zzast_letz00
																																																															(BgL_arg2360z00_2735));
																																																													}
																																																													if (BgL_test8303z00_15198)
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg2288z00_2621;
																																																															obj_t
																																																																BgL_arg2289z00_2622;
																																																															BgL_arg2288z00_2621
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2618));
																																																															BgL_arg2289z00_2622
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd22316zd2_2618));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_15207;
																																																																{
																																																																	obj_t
																																																																		BgL_exprz00_15209;
																																																																	obj_t
																																																																		BgL_bindingsz00_15208;
																																																																	BgL_bindingsz00_15208
																																																																		=
																																																																		BgL_arg2288z00_2621;
																																																																	BgL_exprz00_15209
																																																																		=
																																																																		BgL_arg2289z00_2622;
																																																																	BgL_exprz00_1764
																																																																		=
																																																																		BgL_exprz00_15209;
																																																																	BgL_bindingsz00_1763
																																																																		=
																																																																		BgL_bindingsz00_15208;
																																																																	goto
																																																																		BgL_tagzd2382zd2_1765;
																																																																}
																																																																BgL_auxz00_14300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_15207);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test8304z00_15211;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2359z00_2734;
																																																																BgL_arg2359z00_2734
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_test8304z00_15211
																																																																	=
																																																																	CBOOL
																																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																																	(BgL_arg2359z00_2734));
																																																															}
																																																															if (BgL_test8304z00_15211)
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_15216;
																																																																	goto
																																																																		BgL_tagzd2384zd2_1767;
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15216);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd22382zd2_2625;
																																																																	BgL_carzd22382zd2_2625
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd22387zd2_2626;
																																																																		BgL_cdrzd22387zd2_2626
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd22382zd2_2625));
																																																																		if ((CAR(((obj_t) BgL_carzd22382zd2_2625)) == CNST_TABLE_REF(((long) 3))))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd22387zd2_2626))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg2295z00_2630;
																																																																						obj_t
																																																																							BgL_arg2296z00_2631;
																																																																						obj_t
																																																																							BgL_arg2297z00_2632;
																																																																						BgL_arg2295z00_2630
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd22387zd2_2626);
																																																																						BgL_arg2296z00_2631
																																																																							=
																																																																							CDR
																																																																							(BgL_cdrzd22387zd2_2626);
																																																																						BgL_arg2297z00_2632
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15233;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_15236;
																																																																								obj_t
																																																																									BgL_bodyz00_15235;
																																																																								obj_t
																																																																									BgL_varsz00_15234;
																																																																								BgL_varsz00_15234
																																																																									=
																																																																									BgL_arg2295z00_2630;
																																																																								BgL_bodyz00_15235
																																																																									=
																																																																									BgL_arg2296z00_2631;
																																																																								BgL_argsz00_15236
																																																																									=
																																																																									BgL_arg2297z00_2632;
																																																																								BgL_argsz00_1774
																																																																									=
																																																																									BgL_argsz00_15236;
																																																																								BgL_bodyz00_1773
																																																																									=
																																																																									BgL_bodyz00_15235;
																																																																								BgL_varsz00_1772
																																																																									=
																																																																									BgL_varsz00_15234;
																																																																								goto
																																																																									BgL_tagzd2386zd2_1775;
																																																																							}
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15233);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_15240;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_14300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_15240);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd22494zd2_2635;
																																																																				BgL_cdrzd22494zd2_2635
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd22499zd2_2636;
																																																																					BgL_cdrzd22499zd2_2636
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_carzd22382zd2_2625));
																																																																					if ((CAR(((obj_t) BgL_carzd22382zd2_2625)) == CNST_TABLE_REF(((long) 1))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd22499zd2_2636))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd22504zd2_2640;
																																																																									BgL_cdrzd22504zd2_2640
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd22499zd2_2636);
																																																																									if (PAIRP(BgL_cdrzd22504zd2_2640))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd22508zd2_2642;
																																																																											obj_t
																																																																												BgL_cdrzd22509zd2_2643;
																																																																											BgL_carzd22508zd2_2642
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd22504zd2_2640);
																																																																											BgL_cdrzd22509zd2_2643
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd22504zd2_2640);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22508zd2_2642))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd22509zd2_2643))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd22514zd2_2646;
																																																																															BgL_carzd22514zd2_2646
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd22509zd2_2643);
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22514zd2_2646))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(BgL_cdrzd22509zd2_2643)))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test8315z00_15268;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1368z00_2679;
																																																																																				BgL_l1368z00_2679
																																																																																					=
																																																																																					BgL_cdrzd22494zd2_2635;
																																																																																			BgL_zc3z04anonymousza32323ze3z87_2680:
																																																																																				if (NULLP(BgL_l1368z00_2679))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test8315z00_15268
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							1);
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						bool_t
																																																																																							BgL_test8317z00_15271;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							bool_t
																																																																																								BgL_test8318z00_15272;
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_tmpz00_15273;
																																																																																								BgL_tmpz00_15273
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_l1368z00_2679));
																																																																																								BgL_test8318z00_15272
																																																																																									=
																																																																																									PAIRP
																																																																																									(BgL_tmpz00_15273);
																																																																																							}
																																																																																							if (BgL_test8318z00_15272)
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									BgL_test8317z00_15271
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										0);
																																																																																								}
																																																																																							else
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									BgL_test8317z00_15271
																																																																																										=
																																																																																										(
																																																																																										(bool_t)
																																																																																										1);
																																																																																								}
																																																																																						}
																																																																																						if (BgL_test8317z00_15271)
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_l1368z00_15277;
																																																																																								BgL_l1368z00_15277
																																																																																									=
																																																																																									CDR
																																																																																									(
																																																																																									((obj_t) BgL_l1368z00_2679));
																																																																																								BgL_l1368z00_2679
																																																																																									=
																																																																																									BgL_l1368z00_15277;
																																																																																								goto
																																																																																									BgL_zc3z04anonymousza32323ze3z87_2680;
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								BgL_test8315z00_15268
																																																																																									=
																																																																																									(
																																																																																									(bool_t)
																																																																																									0);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																			if (BgL_test8315z00_15268)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2313z00_2662;
																																																																																					BgL_arg2313z00_2662
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_cdrzd22499zd2_2636);
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15281;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_15285;
																																																																																							obj_t
																																																																																								BgL_proc2z00_15284;
																																																																																							obj_t
																																																																																								BgL_proc1z00_15283;
																																																																																							obj_t
																																																																																								BgL_testz00_15282;
																																																																																							BgL_testz00_15282
																																																																																								=
																																																																																								BgL_arg2313z00_2662;
																																																																																							BgL_proc1z00_15283
																																																																																								=
																																																																																								BgL_carzd22508zd2_2642;
																																																																																							BgL_proc2z00_15284
																																																																																								=
																																																																																								BgL_carzd22514zd2_2646;
																																																																																							BgL_argsz00_15285
																																																																																								=
																																																																																								BgL_cdrzd22494zd2_2635;
																																																																																							BgL_argsz00_1779
																																																																																								=
																																																																																								BgL_argsz00_15285;
																																																																																							BgL_proc2z00_1778
																																																																																								=
																																																																																								BgL_proc2z00_15284;
																																																																																							BgL_proc1z00_1777
																																																																																								=
																																																																																								BgL_proc1z00_15283;
																																																																																							BgL_testz00_1776
																																																																																								=
																																																																																								BgL_testz00_15282;
																																																																																							goto
																																																																																								BgL_tagzd2387zd2_1780;
																																																																																						}
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15281);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd22539zd2_2663;
																																																																																					BgL_cdrzd22539zd2_2663
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_cdrzd22547zd2_2664;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10273;
																																																																																							BgL_pairz00_10273
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_expz00_21));
																																																																																							BgL_cdrzd22547zd2_2664
																																																																																								=
																																																																																								CDR
																																																																																								(BgL_pairz00_10273);
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_cdrzd22555zd2_2665;
																																																																																							BgL_cdrzd22555zd2_2665
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd22547zd2_2664));
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd22562zd2_2666;
																																																																																								BgL_carzd22562zd2_2666
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd22555zd2_2665));
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22562zd2_2666))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_carzd22571zd2_2668;
																																																																																										{	/* Ast/sexp.scm 119 */
																																																																																											obj_t
																																																																																												BgL_pairz00_10277;
																																																																																											BgL_pairz00_10277
																																																																																												=
																																																																																												CDR
																																																																																												(
																																																																																												((obj_t) BgL_cdrzd22555zd2_2665));
																																																																																											BgL_carzd22571zd2_2668
																																																																																												=
																																																																																												CAR
																																																																																												(BgL_pairz00_10277);
																																																																																										}
																																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22571zd2_2668))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22539zd2_2663))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														obj_t
																																																																																															BgL_arg2317z00_2671;
																																																																																														BgL_arg2317z00_2671
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_cdrzd22547zd2_2664));
																																																																																														{
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_auxz00_15307;
																																																																																															{
																																																																																																obj_t
																																																																																																	BgL_argsz00_15311;
																																																																																																obj_t
																																																																																																	BgL_proc2z00_15310;
																																																																																																obj_t
																																																																																																	BgL_proc1z00_15309;
																																																																																																obj_t
																																																																																																	BgL_testz00_15308;
																																																																																																BgL_testz00_15308
																																																																																																	=
																																																																																																	BgL_arg2317z00_2671;
																																																																																																BgL_proc1z00_15309
																																																																																																	=
																																																																																																	BgL_carzd22562zd2_2666;
																																																																																																BgL_proc2z00_15310
																																																																																																	=
																																																																																																	BgL_carzd22571zd2_2668;
																																																																																																BgL_argsz00_15311
																																																																																																	=
																																																																																																	BgL_cdrzd22539zd2_2663;
																																																																																																BgL_argsz00_1784
																																																																																																	=
																																																																																																	BgL_argsz00_15311;
																																																																																																BgL_proc2z00_1783
																																																																																																	=
																																																																																																	BgL_proc2z00_15310;
																																																																																																BgL_proc1z00_1782
																																																																																																	=
																																																																																																	BgL_proc1z00_15309;
																																																																																																BgL_testz00_1781
																																																																																																	=
																																																																																																	BgL_testz00_15308;
																																																																																																goto
																																																																																																	BgL_tagzd2388zd2_1785;
																																																																																															}
																																																																																															BgL_auxz00_14300
																																																																																																=
																																																																																																(
																																																																																																(obj_t)
																																																																																																BgL_auxz00_15307);
																																																																																														}
																																																																																													}
																																																																																												else
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																															{	/* Ast/sexp.scm 119 */
																																																																																																goto
																																																																																																	BgL_tagzd2403zd2_1809;
																																																																																															}
																																																																																														else
																																																																																															{
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_auxz00_15315;
																																																																																																goto
																																																																																																	BgL_tagzd2404zd2_1810;
																																																																																																BgL_auxz00_14300
																																																																																																	=
																																																																																																	(
																																																																																																	(obj_t)
																																																																																																	BgL_auxz00_15315);
																																																																																															}
																																																																																													}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1809;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15319;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1810;
																																																																																														BgL_auxz00_14300
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15319);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15323;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_14300
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15323);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15327;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15327);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd22849zd2_2690;
																																																																																	BgL_cdrzd22849zd2_2690
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd22856zd2_2691;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10281;
																																																																																			BgL_pairz00_10281
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd22856zd2_2691
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10281);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd22863zd2_2692;
																																																																																			BgL_cdrzd22863zd2_2692
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd22856zd2_2691));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd22869zd2_2693;
																																																																																				obj_t
																																																																																					BgL_cdrzd22870zd2_2694;
																																																																																				BgL_carzd22869zd2_2693
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2692));
																																																																																				BgL_cdrzd22870zd2_2694
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd22863zd2_2692));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22869zd2_2693))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd22877zd2_2696;
																																																																																						BgL_carzd22877zd2_2696
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd22870zd2_2694));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd22877zd2_2696))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd22870zd2_2694))))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd22849zd2_2690))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg2332z00_2701;
																																																																																												BgL_arg2332z00_2701
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd22856zd2_2691));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_15354;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_15358;
																																																																																														obj_t
																																																																																															BgL_proc2z00_15357;
																																																																																														obj_t
																																																																																															BgL_proc1z00_15356;
																																																																																														obj_t
																																																																																															BgL_testz00_15355;
																																																																																														BgL_testz00_15355
																																																																																															=
																																																																																															BgL_arg2332z00_2701;
																																																																																														BgL_proc1z00_15356
																																																																																															=
																																																																																															BgL_carzd22869zd2_2693;
																																																																																														BgL_proc2z00_15357
																																																																																															=
																																																																																															BgL_carzd22877zd2_2696;
																																																																																														BgL_argsz00_15358
																																																																																															=
																																																																																															BgL_cdrzd22849zd2_2690;
																																																																																														BgL_argsz00_1784
																																																																																															=
																																																																																															BgL_argsz00_15358;
																																																																																														BgL_proc2z00_1783
																																																																																															=
																																																																																															BgL_proc2z00_15357;
																																																																																														BgL_proc1z00_1782
																																																																																															=
																																																																																															BgL_proc1z00_15356;
																																																																																														BgL_testz00_1781
																																																																																															=
																																																																																															BgL_testz00_15355;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1785;
																																																																																													}
																																																																																													BgL_auxz00_14300
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_15354);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1809;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_15362;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1810;
																																																																																														BgL_auxz00_14300
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_15362);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15366;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_14300
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15366);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15370;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15370);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15374;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15374);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_15378;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15378);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd23210zd2_2709;
																																																																													BgL_cdrzd23210zd2_2709
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd23216zd2_2710;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10291;
																																																																															BgL_pairz00_10291
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd23216zd2_2710
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10291);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd23222zd2_2711;
																																																																															BgL_cdrzd23222zd2_2711
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd23216zd2_2710));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd23227zd2_2712;
																																																																																obj_t
																																																																																	BgL_cdrzd23228zd2_2713;
																																																																																BgL_carzd23227zd2_2712
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2711));
																																																																																BgL_cdrzd23228zd2_2713
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd23222zd2_2711));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23227zd2_2712))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (PAIRP(BgL_cdrzd23228zd2_2713))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd23233zd2_2716;
																																																																																				BgL_carzd23233zd2_2716
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_cdrzd23228zd2_2713);
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd23233zd2_2716))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(BgL_cdrzd23228zd2_2713)))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd23210zd2_2709))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2346z00_2721;
																																																																																										BgL_arg2346z00_2721
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd23216zd2_2710));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_15405;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_15409;
																																																																																												obj_t
																																																																																													BgL_proc2z00_15408;
																																																																																												obj_t
																																																																																													BgL_proc1z00_15407;
																																																																																												obj_t
																																																																																													BgL_testz00_15406;
																																																																																												BgL_testz00_15406
																																																																																													=
																																																																																													BgL_arg2346z00_2721;
																																																																																												BgL_proc1z00_15407
																																																																																													=
																																																																																													BgL_carzd23227zd2_2712;
																																																																																												BgL_proc2z00_15408
																																																																																													=
																																																																																													BgL_carzd23233zd2_2716;
																																																																																												BgL_argsz00_15409
																																																																																													=
																																																																																													BgL_cdrzd23210zd2_2709;
																																																																																												BgL_argsz00_1784
																																																																																													=
																																																																																													BgL_argsz00_15409;
																																																																																												BgL_proc2z00_1783
																																																																																													=
																																																																																													BgL_proc2z00_15408;
																																																																																												BgL_proc1z00_1782
																																																																																													=
																																																																																													BgL_proc1z00_15407;
																																																																																												BgL_testz00_1781
																																																																																													=
																																																																																													BgL_testz00_15406;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1785;
																																																																																											}
																																																																																											BgL_auxz00_14300
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_15405);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_15413;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_14300
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_15413);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_15417;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_15417);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15421;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15421);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_15425;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_15425);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_15429;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_15429);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15433;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15433);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15437;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15437);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_15441;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_15441);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd23771zd2_2885;
																																																	BgL_cdrzd23771zd2_2885
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd2706zd2_2608 == CNST_TABLE_REF(((long) 17))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2473z00_2887;
																																																			obj_t
																																																				BgL_arg2475z00_2888;
																																																			BgL_arg2473z00_2887
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2885));
																																																			BgL_arg2475z00_2888
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd23771zd2_2885));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_15452;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_15454;
																																																					obj_t
																																																						BgL_bindingsz00_15453;
																																																					BgL_bindingsz00_15453
																																																						=
																																																						BgL_arg2473z00_2887;
																																																					BgL_exprz00_15454
																																																						=
																																																						BgL_arg2475z00_2888;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_15454;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_15453;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_14300
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_15452);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd2706zd2_2608)))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2478z00_2890;
																																																					obj_t
																																																						BgL_arg2479z00_2891;
																																																					BgL_arg2478z00_2890
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2885));
																																																					BgL_arg2479z00_2891
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd23771zd2_2885));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_15463;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_15465;
																																																							obj_t
																																																								BgL_bindingsz00_15464;
																																																							BgL_bindingsz00_15464
																																																								=
																																																								BgL_arg2478z00_2890;
																																																							BgL_exprz00_15465
																																																								=
																																																								BgL_arg2479z00_2891;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_15465;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_15464;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_14300
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_15463);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((BgL_carzd2706zd2_2608 == CNST_TABLE_REF(((long) 18))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg2481z00_2893;
																																																							obj_t
																																																								BgL_arg2482z00_2894;
																																																							BgL_arg2481z00_2893
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2885));
																																																							BgL_arg2482z00_2894
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd23771zd2_2885));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_15474;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_15476;
																																																									obj_t
																																																										BgL_bindingsz00_15475;
																																																									BgL_bindingsz00_15475
																																																										=
																																																										BgL_arg2481z00_2893;
																																																									BgL_exprz00_15476
																																																										=
																																																										BgL_arg2482z00_2894;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_15476;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_15475;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_14300
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_15474);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15483;
																																																								BgL_tagzd2383zd2_1766:
																																																									BgL_auxz00_15483 = BGl_letrecza2zd2ze3nodez93zzast_letz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15483);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd23808zd2_2897;
																																																									BgL_carzd23808zd2_2897
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((BgL_carzd23808zd2_2897 == CNST_TABLE_REF(((long) 19))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_15492;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_15492);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd23808zd2_2897)))
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15497;
																																																													goto
																																																														BgL_tagzd2384zd2_1767;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15497);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_15504;
																																																														BgL_tagzd2389zd2_1786:
																																																															BgL_auxz00_15504 = BGl_lambdazd2ze3nodez31zzast_sexpz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24, BGl_string8050z00zzast_sexpz00);
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_15504);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15512;
																																																																BgL_tagzd2390zd2_1787:
																																																																	BgL_auxz00_15512 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 0), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15512);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd23888zd2_2904;
																																																																	BgL_cdrzd23888zd2_2904
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg2494z00_2907;
																																																																			obj_t
																																																																				BgL_arg2496z00_2908;
																																																																			BgL_arg2494z00_2907
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2904));
																																																																			BgL_arg2496z00_2908
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd23888zd2_2904));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_15527;
																																																																				BgL_effectz00_1788
																																																																					=
																																																																					BgL_arg2494z00_2907;
																																																																				BgL_restz00_1789
																																																																					=
																																																																					BgL_arg2496z00_2908;
																																																																			BgL_tagzd2391zd2_1790:
																																																																				{	/* Ast/sexp.scm 458 */
																																																																					BgL_feffectz00_bglt
																																																																						BgL_arg6959z00_8913;
																																																																					obj_t
																																																																						BgL_arg6960z00_8914;
																																																																					BgL_arg6959z00_8913
																																																																						=
																																																																						BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																						(BgL_effectz00_1788);
																																																																					{	/* Ast/sexp.scm 459 */
																																																																						obj_t
																																																																							BgL_arg6961z00_8915;
																																																																						BgL_arg6961z00_8915
																																																																							=
																																																																							BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																							(BgL_restz00_1789,
																																																																							BNIL);
																																																																						BgL_arg6960z00_8914
																																																																							=
																																																																							MAKE_YOUNG_PAIR
																																																																							(CNST_TABLE_REF
																																																																							(((long) 6)), BgL_arg6961z00_8915);
																																																																					}
																																																																					BgL_auxz00_15527
																																																																						=
																																																																						BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																						(
																																																																						((bool_t) 0), ((obj_t) BgL_arg6959z00_8913), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6960z00_8914, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																				}
																																																																				BgL_auxz00_14300
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_15527);
																																																																		}}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_15541;
																																																																				BgL_tagzd2392zd2_1791:
																																																																					BgL_auxz00_15541 = BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_15541);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_15550;
																																																																						BgL_tagzd2393zd2_1792:
																																																																							{	/* Ast/sexp.scm 465 */
																																																																								bool_t
																																																																									BgL_test8359z00_15551;
																																																																								if (NULLP(BgL_stackz00_22))
																																																																									{	/* Ast/sexp.scm 465 */
																																																																										BgL_test8359z00_15551
																																																																											=
																																																																											(BgL_sitez00_24
																																																																											==
																																																																											CNST_TABLE_REF
																																																																											(((long) 2)));
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 465 */
																																																																										BgL_test8359z00_15551
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								if (BgL_test8359z00_15551)
																																																																									{	/* Ast/sexp.scm 465 */
																																																																										{	/* Ast/sexp.scm 469 */
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg6964z00_8918;
																																																																											BgL_arg6964z00_8918
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), BFALSE, ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																											BGl_addzd2staticzd2pragmaz12z12zzast_pragmaz00
																																																																												(BgL_arg6964z00_8918);
																																																																										}
																																																																										BgL_auxz00_15550
																																																																											=
																																																																											BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																											(BUNSPEC,
																																																																											BgL_stackz00_22,
																																																																											BgL_locz00_23,
																																																																											BgL_sitez00_24);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 466 */
																																																																										BgL_nodez00_bglt
																																																																											BgL_res7480z00_10050;
																																																																										{	/* Ast/sexp.scm 726 */
																																																																											obj_t
																																																																												BgL_arg7130z00_10046;
																																																																											BgL_nodez00_bglt
																																																																												BgL_arg7131z00_10047;
																																																																											BgL_arg7130z00_10046
																																																																												=
																																																																												BGl_shapez00zztools_shapez00
																																																																												(BGl_currentzd2functionzd2zztools_errorz00
																																																																												());
																																																																											BgL_arg7131z00_10047
																																																																												=
																																																																												BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																												(CNST_TABLE_REF
																																																																												(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																																											{	/* Ast/sexp.scm 725 */
																																																																												obj_t
																																																																													BgL_list7132z00_10049;
																																																																												BgL_list7132z00_10049
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(
																																																																													((obj_t) BgL_arg7131z00_10047), BNIL);
																																																																												BgL_res7480z00_10050
																																																																													=
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																													(BgL_locz00_23,
																																																																														BgL_arg7130z00_10046,
																																																																														BGl_string8049z00zzast_sexpz00,
																																																																														BgL_expz00_21,
																																																																														BgL_list7132z00_10049));
																																																																										}}
																																																																										BgL_auxz00_15550
																																																																											=
																																																																											BgL_res7480z00_10050;
																																																																							}}
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_15550);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg2506z00_2916;
																																																																									obj_t
																																																																										BgL_arg2507z00_2917;
																																																																									BgL_arg2506z00_2916
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2904));
																																																																									BgL_arg2507z00_2917
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd23888zd2_2904));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_15579;
																																																																										BgL_effectz00_1793
																																																																											=
																																																																											BgL_arg2506z00_2916;
																																																																										BgL_restz00_1794
																																																																											=
																																																																											BgL_arg2507z00_2917;
																																																																									BgL_tagzd2394zd2_1795:
																																																																										{	/* Ast/sexp.scm 474 */
																																																																											BgL_feffectz00_bglt
																																																																												BgL_arg6965z00_8920;
																																																																											obj_t
																																																																												BgL_arg6966z00_8921;
																																																																											BgL_arg6965z00_8920
																																																																												=
																																																																												BGl_parsezd2effectzd2zzeffect_feffectz00
																																																																												(BgL_effectz00_1793);
																																																																											{	/* Ast/sexp.scm 475 */
																																																																												obj_t
																																																																													BgL_arg6967z00_8922;
																																																																												BgL_arg6967z00_8922
																																																																													=
																																																																													BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																																																																													(BgL_restz00_1794,
																																																																													BNIL);
																																																																												BgL_arg6966z00_8921
																																																																													=
																																																																													MAKE_YOUNG_PAIR
																																																																													(CNST_TABLE_REF
																																																																													(((long) 6)), BgL_arg6967z00_8922);
																																																																											}
																																																																											BgL_auxz00_15579
																																																																												=
																																																																												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																																																																												(
																																																																												((bool_t) 1), ((obj_t) BgL_arg6965z00_8920), ((BgL_typez00_bglt) BGl_za2unspecza2z00zztype_cachez00), BgL_arg6966z00_8921, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																										}
																																																																										BgL_auxz00_14300
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_15579);
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_15593;
																																																																										BgL_tagzd2395zd2_1796:
																																																																											{
																																																																												obj_t
																																																																													BgL_procz00_8923;
																																																																												obj_t
																																																																													BgL_msgz00_8924;
																																																																												obj_t
																																																																													BgL_objz00_8925;
																																																																												if (PAIRP(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd262369zd2_8930;
																																																																														BgL_cdrzd262369zd2_8930
																																																																															=
																																																																															CDR
																																																																															(BgL_expz00_21);
																																																																														if (PAIRP(BgL_cdrzd262369zd2_8930))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd262374zd2_8932;
																																																																																BgL_cdrzd262374zd2_8932
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd262369zd2_8930);
																																																																																if (PAIRP(BgL_cdrzd262374zd2_8932))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd262379zd2_8934;
																																																																																		BgL_cdrzd262379zd2_8934
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262374zd2_8932);
																																																																																		if (PAIRP(BgL_cdrzd262379zd2_8934))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd262379zd2_8934)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg6974z00_8938;
																																																																																						obj_t
																																																																																							BgL_arg6975z00_8939;
																																																																																						obj_t
																																																																																							BgL_arg6976z00_8940;
																																																																																						BgL_arg6974z00_8938
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262369zd2_8930);
																																																																																						BgL_arg6975z00_8939
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262374zd2_8932);
																																																																																						BgL_arg6976z00_8940
																																																																																							=
																																																																																							CAR
																																																																																							(BgL_cdrzd262379zd2_8934);
																																																																																						{
																																																																																							BgL_failz00_bglt
																																																																																								BgL_auxz00_15611;
																																																																																							BgL_procz00_8923
																																																																																								=
																																																																																								BgL_arg6974z00_8938;
																																																																																							BgL_msgz00_8924
																																																																																								=
																																																																																								BgL_arg6975z00_8939;
																																																																																							BgL_objz00_8925
																																																																																								=
																																																																																								BgL_arg6976z00_8940;
																																																																																							{	/* Ast/sexp.scm 480 */
																																																																																								obj_t
																																																																																									BgL_locz00_8942;
																																																																																								BgL_locz00_8942
																																																																																									=
																																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																									(BgL_expz00_21,
																																																																																									BgL_locz00_23);
																																																																																								{	/* Ast/sexp.scm 480 */
																																																																																									obj_t
																																																																																										BgL_cdlocz00_8943;
																																																																																									{	/* Ast/sexp.scm 481 */
																																																																																										obj_t
																																																																																											BgL_arg6981z00_8957;
																																																																																										BgL_arg6981z00_8957
																																																																																											=
																																																																																											CDR
																																																																																											(
																																																																																											((obj_t) BgL_expz00_21));
																																																																																										BgL_cdlocz00_8943
																																																																																											=
																																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																											(BgL_arg6981z00_8957,
																																																																																											BgL_locz00_8942);
																																																																																									}
																																																																																									{	/* Ast/sexp.scm 481 */
																																																																																										obj_t
																																																																																											BgL_cddlocz00_8944;
																																																																																										{	/* Ast/sexp.scm 482 */
																																																																																											obj_t
																																																																																												BgL_arg6980z00_8956;
																																																																																											{	/* Ast/sexp.scm 482 */
																																																																																												obj_t
																																																																																													BgL_pairz00_10055;
																																																																																												BgL_pairz00_10055
																																																																																													=
																																																																																													CDR
																																																																																													(
																																																																																													((obj_t) BgL_expz00_21));
																																																																																												BgL_arg6980z00_8956
																																																																																													=
																																																																																													CDR
																																																																																													(BgL_pairz00_10055);
																																																																																											}
																																																																																											BgL_cddlocz00_8944
																																																																																												=
																																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																												(BgL_arg6980z00_8956,
																																																																																												BgL_locz00_8942);
																																																																																										}
																																																																																										{	/* Ast/sexp.scm 482 */
																																																																																											obj_t
																																																																																												BgL_cdddlocz00_8945;
																																																																																											{	/* Ast/sexp.scm 483 */
																																																																																												obj_t
																																																																																													BgL_arg6979z00_8955;
																																																																																												{	/* Ast/sexp.scm 483 */
																																																																																													obj_t
																																																																																														BgL_pairz00_10061;
																																																																																													{	/* Ast/sexp.scm 483 */
																																																																																														obj_t
																																																																																															BgL_pairz00_10060;
																																																																																														BgL_pairz00_10060
																																																																																															=
																																																																																															CDR
																																																																																															(
																																																																																															((obj_t) BgL_expz00_21));
																																																																																														BgL_pairz00_10061
																																																																																															=
																																																																																															CDR
																																																																																															(BgL_pairz00_10060);
																																																																																													}
																																																																																													BgL_arg6979z00_8955
																																																																																														=
																																																																																														CDR
																																																																																														(BgL_pairz00_10061);
																																																																																												}
																																																																																												BgL_cdddlocz00_8945
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_arg6979z00_8955,
																																																																																													BgL_locz00_8942);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 483 */
																																																																																												obj_t
																																																																																													BgL_loczd2proczd2_8946;
																																																																																												BgL_loczd2proczd2_8946
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_procz00_8923,
																																																																																													BgL_cdlocz00_8943);
																																																																																												{	/* Ast/sexp.scm 484 */
																																																																																													obj_t
																																																																																														BgL_loczd2msgzd2_8947;
																																																																																													BgL_loczd2msgzd2_8947
																																																																																														=
																																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																														(BgL_msgz00_8924,
																																																																																														BgL_cddlocz00_8944);
																																																																																													{	/* Ast/sexp.scm 485 */
																																																																																														obj_t
																																																																																															BgL_loczd2objzd2_8948;
																																																																																														BgL_loczd2objzd2_8948
																																																																																															=
																																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																															(BgL_objz00_8925,
																																																																																															BgL_cdddlocz00_8945);
																																																																																														{	/* Ast/sexp.scm 486 */
																																																																																															BgL_nodez00_bglt
																																																																																																BgL_procz00_8949;
																																																																																															BgL_procz00_8949
																																																																																																=
																																																																																																BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																(BgL_procz00_8923,
																																																																																																BgL_stackz00_22,
																																																																																																BgL_loczd2proczd2_8946,
																																																																																																CNST_TABLE_REF
																																																																																																(((long) 2)));
																																																																																															{	/* Ast/sexp.scm 487 */
																																																																																																BgL_nodez00_bglt
																																																																																																	BgL_msgz00_8950;
																																																																																																BgL_msgz00_8950
																																																																																																	=
																																																																																																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																	(BgL_msgz00_8924,
																																																																																																	BgL_stackz00_22,
																																																																																																	BgL_loczd2msgzd2_8947,
																																																																																																	CNST_TABLE_REF
																																																																																																	(((long) 2)));
																																																																																																{	/* Ast/sexp.scm 488 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_objz00_8951;
																																																																																																	BgL_objz00_8951
																																																																																																		=
																																																																																																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																		(BgL_objz00_8925,
																																																																																																		BgL_stackz00_22,
																																																																																																		BgL_loczd2objzd2_8948,
																																																																																																		CNST_TABLE_REF
																																																																																																		(((long) 2)));
																																																																																																	{	/* Ast/sexp.scm 489 */

																																																																																																		{	/* Ast/sexp.scm 490 */
																																																																																																			BgL_failz00_bglt
																																																																																																				BgL_new1140z00_8952;
																																																																																																			{	/* Ast/sexp.scm 491 */
																																																																																																				BgL_failz00_bglt
																																																																																																					BgL_new1139z00_8953;
																																																																																																				BgL_new1139z00_8953
																																																																																																					=
																																																																																																					(
																																																																																																					(BgL_failz00_bglt)
																																																																																																					BOBJECT
																																																																																																					(GC_MALLOC
																																																																																																						(sizeof
																																																																																																							(struct
																																																																																																								BgL_failz00_bgl))));
																																																																																																				{	/* Ast/sexp.scm 491 */
																																																																																																					long
																																																																																																						BgL_arg6978z00_8954;
																																																																																																					{	/* Ast/sexp.scm 491 */
																																																																																																						long
																																																																																																							BgL_res7481z00_10063;
																																																																																																						BgL_res7481z00_10063
																																																																																																							=
																																																																																																							BGL_CLASS_INDEX
																																																																																																							(BGl_failz00zzast_nodez00);
																																																																																																						BgL_arg6978z00_8954
																																																																																																							=
																																																																																																							BgL_res7481z00_10063;
																																																																																																					}
																																																																																																					BGL_OBJECT_CLASS_NUM_SET
																																																																																																						(
																																																																																																						((BgL_objectz00_bglt) BgL_new1139z00_8953), BgL_arg6978z00_8954);
																																																																																																				}
																																																																																																				{	/* Ast/sexp.scm 491 */
																																																																																																					BgL_objectz00_bglt
																																																																																																						BgL_tmpz00_15638;
																																																																																																					BgL_tmpz00_15638
																																																																																																						=
																																																																																																						(
																																																																																																						(BgL_objectz00_bglt)
																																																																																																						BgL_new1139z00_8953);
																																																																																																					BGL_OBJECT_WIDENING_SET
																																																																																																						(BgL_tmpz00_15638,
																																																																																																						BFALSE);
																																																																																																				}
																																																																																																				((BgL_objectz00_bglt) BgL_new1139z00_8953);
																																																																																																				BgL_new1140z00_8952
																																																																																																					=
																																																																																																					BgL_new1139z00_8953;
																																																																																																			}
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1140z00_8952)))->BgL_locz00) = ((obj_t) BgL_locz00_8942), BUNSPEC);
																																																																																																			((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1140z00_8952)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2magicza2z00zztype_cachez00)), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8952))->BgL_procz00) = ((BgL_nodez00_bglt) BgL_procz00_8949), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8952))->BgL_msgz00) = ((BgL_nodez00_bglt) BgL_msgz00_8950), BUNSPEC);
																																																																																																			((((BgL_failz00_bglt) COBJECT(BgL_new1140z00_8952))->BgL_objz00) = ((BgL_nodez00_bglt) BgL_objz00_8951), BUNSPEC);
																																																																																																			BgL_auxz00_15611
																																																																																																				=
																																																																																																				BgL_new1140z00_8952;
																																																																																							}}}}}}}}}}}}
																																																																																							BgL_auxz00_15593
																																																																																								=
																																																																																								(
																																																																																								(BgL_nodez00_bglt)
																																																																																								BgL_auxz00_15611);
																																																																																					}}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																					BgL_tagzd262360zd2_8927:
																																																																																						{	/* Ast/sexp.scm 498 */
																																																																																							obj_t
																																																																																								BgL_arg6982z00_8958;
																																																																																							BgL_arg6982z00_8958
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_expz00_21,
																																																																																								BgL_locz00_23);
																																																																																							{	/* Ast/sexp.scm 497 */
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_res7482z00_10072;
																																																																																								{	/* Ast/sexp.scm 726 */
																																																																																									obj_t
																																																																																										BgL_arg7130z00_10068;
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_arg7131z00_10069;
																																																																																									BgL_arg7130z00_10068
																																																																																										=
																																																																																										BGl_shapez00zztools_shapez00
																																																																																										(BGl_currentzd2functionzd2zztools_errorz00
																																																																																										());
																																																																																									BgL_arg7131z00_10069
																																																																																										=
																																																																																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																										(CNST_TABLE_REF
																																																																																										(((long) 4)), BNIL, BgL_arg6982z00_8958, CNST_TABLE_REF(((long) 2)));
																																																																																									{	/* Ast/sexp.scm 725 */
																																																																																										obj_t
																																																																																											BgL_list7132z00_10071;
																																																																																										BgL_list7132z00_10071
																																																																																											=
																																																																																											MAKE_YOUNG_PAIR
																																																																																											(
																																																																																											((obj_t) BgL_arg7131z00_10069), BNIL);
																																																																																										BgL_res7482z00_10072
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																											(BgL_arg6982z00_8958,
																																																																																												BgL_arg7130z00_10068,
																																																																																												BGl_string8048z00zzast_sexpz00,
																																																																																												BgL_expz00_21,
																																																																																												BgL_list7132z00_10071));
																																																																																								}}
																																																																																								BgL_auxz00_15593
																																																																																									=
																																																																																									BgL_res7482z00_10072;
																																																																																			}}}}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd262360zd2_8927;
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd262360zd2_8927;
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd262360zd2_8927;
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd262360zd2_8927;
																																																																													}
																																																																											}
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_15593);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_15667;
																																																																												BgL_tagzd2396zd2_1797:
																																																																													{
																																																																														obj_t
																																																																															BgL_testz00_8959;
																																																																														obj_t
																																																																															BgL_clausesz00_8960;
																																																																														if (PAIRP(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd262393zd2_8965;
																																																																																BgL_cdrzd262393zd2_8965
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_expz00_21);
																																																																																if (PAIRP(BgL_cdrzd262393zd2_8965))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_testz00_8959
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd262393zd2_8965);
																																																																																		BgL_clausesz00_8960
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd262393zd2_8965);
																																																																																		{	/* Ast/sexp.scm 509 */
																																																																																			obj_t
																																																																																				BgL_locz00_8969;
																																																																																			BgL_locz00_8969
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 509 */
																																																																																				obj_t
																																																																																					BgL_cdlocz00_8970;
																																																																																				{	/* Ast/sexp.scm 510 */
																																																																																					obj_t
																																																																																						BgL_arg7012z00_9010;
																																																																																					BgL_arg7012z00_9010
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdlocz00_8970
																																																																																						=
																																																																																						BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																						(BgL_arg7012z00_9010,
																																																																																						BgL_locz00_8969);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 510 */
																																																																																					obj_t
																																																																																						BgL_cddlocz00_8971;
																																																																																					{	/* Ast/sexp.scm 511 */
																																																																																						obj_t
																																																																																							BgL_arg7011z00_9009;
																																																																																						BgL_arg7011z00_9009
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_expz00_21));
																																																																																						BgL_cddlocz00_8971
																																																																																							=
																																																																																							BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																							(BgL_arg7011z00_9009,
																																																																																							BgL_locz00_8969);
																																																																																					}
																																																																																					{	/* Ast/sexp.scm 511 */
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_testz00_8972;
																																																																																						{	/* Ast/sexp.scm 514 */
																																																																																							obj_t
																																																																																								BgL_arg7010z00_9008;
																																																																																							BgL_arg7010z00_9008
																																																																																								=
																																																																																								BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																								(BgL_testz00_8959,
																																																																																								BgL_cdlocz00_8970);
																																																																																							BgL_testz00_8972
																																																																																								=
																																																																																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																								(BgL_testz00_8959,
																																																																																								BgL_stackz00_22,
																																																																																								BgL_arg7010z00_9008,
																																																																																								CNST_TABLE_REF
																																																																																								(((long) 2)));
																																																																																						}
																																																																																						{	/* Ast/sexp.scm 512 */

																																																																																							{
																																																																																								obj_t
																																																																																									BgL_clsz00_8975;
																																																																																								obj_t
																																																																																									BgL_nclausesz00_8976;
																																																																																								BgL_clsz00_8975
																																																																																									=
																																																																																									BgL_clausesz00_8960;
																																																																																								BgL_nclausesz00_8976
																																																																																									=
																																																																																									BNIL;
																																																																																							BgL_zc3z04anonymousza36987ze3z87_8977:
																																																																																								if (NULLP(BgL_clsz00_8975))
																																																																																									{	/* Ast/sexp.scm 519 */
																																																																																										BgL_switchz00_bglt
																																																																																											BgL_new1143z00_8979;
																																																																																										{	/* Ast/sexp.scm 520 */
																																																																																											BgL_switchz00_bglt
																																																																																												BgL_new1142z00_8983;
																																																																																											BgL_new1142z00_8983
																																																																																												=
																																																																																												(
																																																																																												(BgL_switchz00_bglt)
																																																																																												BOBJECT
																																																																																												(GC_MALLOC
																																																																																													(sizeof
																																																																																														(struct
																																																																																															BgL_switchz00_bgl))));
																																																																																											{	/* Ast/sexp.scm 520 */
																																																																																												long
																																																																																													BgL_arg6992z00_8984;
																																																																																												{	/* Ast/sexp.scm 520 */
																																																																																													long
																																																																																														BgL_res7489z00_10089;
																																																																																													BgL_res7489z00_10089
																																																																																														=
																																																																																														BGL_CLASS_INDEX
																																																																																														(BGl_switchz00zzast_nodez00);
																																																																																													BgL_arg6992z00_8984
																																																																																														=
																																																																																														BgL_res7489z00_10089;
																																																																																												}
																																																																																												BGL_OBJECT_CLASS_NUM_SET
																																																																																													(
																																																																																													((BgL_objectz00_bglt) BgL_new1142z00_8983), BgL_arg6992z00_8984);
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 520 */
																																																																																												BgL_objectz00_bglt
																																																																																													BgL_tmpz00_15689;
																																																																																												BgL_tmpz00_15689
																																																																																													=
																																																																																													(
																																																																																													(BgL_objectz00_bglt)
																																																																																													BgL_new1142z00_8983);
																																																																																												BGL_OBJECT_WIDENING_SET
																																																																																													(BgL_tmpz00_15689,
																																																																																													BFALSE);
																																																																																											}
																																																																																											((BgL_objectz00_bglt) BgL_new1142z00_8983);
																																																																																											BgL_new1143z00_8979
																																																																																												=
																																																																																												BgL_new1142z00_8983;
																																																																																										}
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1143z00_8979)))->BgL_locz00) = ((obj_t) BgL_locz00_8969), BUNSPEC);
																																																																																										((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1143z00_8979)))->BgL_typez00) = ((BgL_typez00_bglt) ((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1143z00_8979)))->BgL_sidezd2effectzd2) = ((obj_t) BUNSPEC), BUNSPEC);
																																																																																										((((BgL_nodezf2effectzf2_bglt) COBJECT(((BgL_nodezf2effectzf2_bglt) BgL_new1143z00_8979)))->BgL_keyz00) = ((obj_t) BINT(((long) -1))), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8979))->BgL_testz00) = ((BgL_nodez00_bglt) BgL_testz00_8972), BUNSPEC);
																																																																																										((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8979))->BgL_clausesz00) = ((obj_t) bgl_reverse_bang(BgL_nclausesz00_8976)), BUNSPEC);
																																																																																										{
																																																																																											BgL_typez00_bglt
																																																																																												BgL_auxz00_15706;
																																																																																											{	/* Ast/sexp.scm 523 */
																																																																																												obj_t
																																																																																													BgL_arg6989z00_8980;
																																																																																												{	/* Ast/sexp.scm 523 */
																																																																																													obj_t
																																																																																														BgL_pairz00_10095;
																																																																																													{	/* Ast/sexp.scm 523 */
																																																																																														obj_t
																																																																																															BgL_pairz00_10094;
																																																																																														BgL_pairz00_10094
																																																																																															=
																																																																																															CAR
																																																																																															(
																																																																																															((obj_t) BgL_clausesz00_8960));
																																																																																														BgL_pairz00_10095
																																																																																															=
																																																																																															CAR
																																																																																															(BgL_pairz00_10094);
																																																																																													}
																																																																																													BgL_arg6989z00_8980
																																																																																														=
																																																																																														CAR
																																																																																														(BgL_pairz00_10095);
																																																																																												}
																																																																																												BgL_auxz00_15706
																																																																																													=
																																																																																													BGl_getzd2typezd2atomz00zztype_typeofz00
																																																																																													(BgL_arg6989z00_8980);
																																																																																											}
																																																																																											((((BgL_switchz00_bglt) COBJECT(BgL_new1143z00_8979))->BgL_itemzd2typezd2) = ((BgL_typez00_bglt) BgL_auxz00_15706), BUNSPEC);
																																																																																										}
																																																																																										BgL_auxz00_15667
																																																																																											=
																																																																																											(
																																																																																											(BgL_nodez00_bglt)
																																																																																											BgL_new1143z00_8979);
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 525 */
																																																																																										obj_t
																																																																																											BgL_clausez00_8985;
																																																																																										BgL_clausez00_8985
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_clsz00_8975));
																																																																																										{	/* Ast/sexp.scm 525 */
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_bodyz00_8986;
																																																																																											{	/* Ast/sexp.scm 526 */
																																																																																												obj_t
																																																																																													BgL_arg7007z00_9004;
																																																																																												obj_t
																																																																																													BgL_arg7008z00_9005;
																																																																																												{	/* Ast/sexp.scm 526 */
																																																																																													obj_t
																																																																																														BgL_arg7009z00_9006;
																																																																																													BgL_arg7009z00_9006
																																																																																														=
																																																																																														CDR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_8985));
																																																																																													BgL_arg7007z00_9004
																																																																																														=
																																																																																														BGl_normaliza7ezd2prognz75zztools_prognz00
																																																																																														(BgL_arg7009z00_9006);
																																																																																												}
																																																																																												BgL_arg7008z00_9005
																																																																																													=
																																																																																													BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																													(BgL_clausez00_8985,
																																																																																													BgL_cddlocz00_8971);
																																																																																												BgL_bodyz00_8986
																																																																																													=
																																																																																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																													(BgL_arg7007z00_9004,
																																																																																													BgL_stackz00_22,
																																																																																													BgL_arg7008z00_9005,
																																																																																													CNST_TABLE_REF
																																																																																													(((long) 2)));
																																																																																											}
																																																																																											{	/* Ast/sexp.scm 526 */
																																																																																												obj_t
																																																																																													BgL_nclausez00_8987;
																																																																																												{	/* Ast/sexp.scm 530 */
																																																																																													obj_t
																																																																																														BgL_arg7006z00_9003;
																																																																																													BgL_arg7006z00_9003
																																																																																														=
																																																																																														CAR
																																																																																														(
																																																																																														((obj_t) BgL_clausez00_8985));
																																																																																													BgL_nclausez00_8987
																																																																																														=
																																																																																														MAKE_YOUNG_PAIR
																																																																																														(BgL_arg7006z00_9003,
																																																																																														((obj_t) BgL_bodyz00_8986));
																																																																																												}
																																																																																												{	/* Ast/sexp.scm 530 */

																																																																																													{	/* Ast/sexp.scm 532 */
																																																																																														bool_t
																																																																																															BgL_test8372z00_15726;
																																																																																														if ((CAR(((obj_t) BgL_clausez00_8985)) == CNST_TABLE_REF(((long) 5))))
																																																																																															{	/* Ast/sexp.scm 532 */
																																																																																																if (NULLP(CDR(((obj_t) BgL_clsz00_8975))))
																																																																																																	{	/* Ast/sexp.scm 533 */
																																																																																																		BgL_test8372z00_15726
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			0);
																																																																																																	}
																																																																																																else
																																																																																																	{	/* Ast/sexp.scm 533 */
																																																																																																		BgL_test8372z00_15726
																																																																																																			=
																																																																																																			(
																																																																																																			(bool_t)
																																																																																																			1);
																																																																																																	}
																																																																																															}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 532 */
																																																																																																BgL_test8372z00_15726
																																																																																																	=
																																																																																																	(
																																																																																																	(bool_t)
																																																																																																	0);
																																																																																															}
																																																																																														if (BgL_test8372z00_15726)
																																																																																															{	/* Ast/sexp.scm 535 */
																																																																																																obj_t
																																																																																																	BgL_arg7000z00_8995;
																																																																																																BgL_arg7000z00_8995
																																																																																																	=
																																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																																	(BgL_expz00_21,
																																																																																																	BgL_locz00_8969);
																																																																																																{	/* Ast/sexp.scm 534 */
																																																																																																	BgL_nodez00_bglt
																																																																																																		BgL_res7491z00_10107;
																																																																																																	{	/* Ast/sexp.scm 726 */
																																																																																																		obj_t
																																																																																																			BgL_arg7130z00_10103;
																																																																																																		BgL_nodez00_bglt
																																																																																																			BgL_arg7131z00_10104;
																																																																																																		BgL_arg7130z00_10103
																																																																																																			=
																																																																																																			BGl_shapez00zztools_shapez00
																																																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																																																			());
																																																																																																		BgL_arg7131z00_10104
																																																																																																			=
																																																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																																			(CNST_TABLE_REF
																																																																																																			(((long) 4)), BNIL, BgL_arg7000z00_8995, CNST_TABLE_REF(((long) 2)));
																																																																																																		{	/* Ast/sexp.scm 725 */
																																																																																																			obj_t
																																																																																																				BgL_list7132z00_10106;
																																																																																																			BgL_list7132z00_10106
																																																																																																				=
																																																																																																				MAKE_YOUNG_PAIR
																																																																																																				(
																																																																																																				((obj_t) BgL_arg7131z00_10104), BNIL);
																																																																																																			BgL_res7491z00_10107
																																																																																																				=
																																																																																																				(
																																																																																																				(BgL_nodez00_bglt)
																																																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																																				(BgL_arg7000z00_8995,
																																																																																																					BgL_arg7130z00_10103,
																																																																																																					BGl_string8047z00zzast_sexpz00,
																																																																																																					BgL_expz00_21,
																																																																																																					BgL_list7132z00_10106));
																																																																																																	}}
																																																																																																	BgL_auxz00_15667
																																																																																																		=
																																																																																																		BgL_res7491z00_10107;
																																																																																															}}
																																																																																														else
																																																																																															{	/* Ast/sexp.scm 536 */
																																																																																																obj_t
																																																																																																	BgL_arg7001z00_8996;
																																																																																																obj_t
																																																																																																	BgL_arg7002z00_8997;
																																																																																																BgL_arg7001z00_8996
																																																																																																	=
																																																																																																	CDR
																																																																																																	(
																																																																																																	((obj_t) BgL_clsz00_8975));
																																																																																																BgL_arg7002z00_8997
																																																																																																	=
																																																																																																	MAKE_YOUNG_PAIR
																																																																																																	(BGl_epairifyz00zztools_miscz00
																																																																																																	(BgL_nclausez00_8987,
																																																																																																		BgL_clausez00_8985),
																																																																																																	BgL_nclausesz00_8976);
																																																																																																{
																																																																																																	obj_t
																																																																																																		BgL_nclausesz00_15751;
																																																																																																	obj_t
																																																																																																		BgL_clsz00_15750;
																																																																																																	BgL_clsz00_15750
																																																																																																		=
																																																																																																		BgL_arg7001z00_8996;
																																																																																																	BgL_nclausesz00_15751
																																																																																																		=
																																																																																																		BgL_arg7002z00_8997;
																																																																																																	BgL_nclausesz00_8976
																																																																																																		=
																																																																																																		BgL_nclausesz00_15751;
																																																																																																	BgL_clsz00_8975
																																																																																																		=
																																																																																																		BgL_clsz00_15750;
																																																																																																	goto
																																																																																																		BgL_zc3z04anonymousza36987ze3z87_8977;
																																																																																																}
																																																																																															}
																																																																																													}
																																																																																												}
																																																																																											}
																																																																																										}
																																																																																									}
																																																																																							}
																																																																																						}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																	BgL_tagzd262386zd2_8962:
																																																																																		{	/* Ast/sexp.scm 541 */
																																																																																			obj_t
																																																																																				BgL_arg7013z00_9011;
																																																																																			BgL_arg7013z00_9011
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			{	/* Ast/sexp.scm 540 */
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_res7492z00_10114;
																																																																																				{	/* Ast/sexp.scm 726 */
																																																																																					obj_t
																																																																																						BgL_arg7130z00_10110;
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_arg7131z00_10111;
																																																																																					BgL_arg7130z00_10110
																																																																																						=
																																																																																						BGl_shapez00zztools_shapez00
																																																																																						(BGl_currentzd2functionzd2zztools_errorz00
																																																																																						());
																																																																																					BgL_arg7131z00_10111
																																																																																						=
																																																																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																																						(CNST_TABLE_REF
																																																																																						(((long) 4)), BNIL, BgL_arg7013z00_9011, CNST_TABLE_REF(((long) 2)));
																																																																																					{	/* Ast/sexp.scm 725 */
																																																																																						obj_t
																																																																																							BgL_list7132z00_10113;
																																																																																						BgL_list7132z00_10113
																																																																																							=
																																																																																							MAKE_YOUNG_PAIR
																																																																																							(
																																																																																							((obj_t) BgL_arg7131z00_10111), BNIL);
																																																																																						BgL_res7492z00_10114
																																																																																							=
																																																																																							(
																																																																																							(BgL_nodez00_bglt)
																																																																																							BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																																							(BgL_arg7013z00_9011,
																																																																																								BgL_arg7130z00_10110,
																																																																																								BGl_string8047z00zzast_sexpz00,
																																																																																								BgL_expz00_21,
																																																																																								BgL_list7132z00_10113));
																																																																																				}}
																																																																																				BgL_auxz00_15667
																																																																																					=
																																																																																					BgL_res7492z00_10114;
																																																																															}}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd262386zd2_8962;
																																																																															}
																																																																													}
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_15667);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																														{
																																																																															BgL_letzd2funzd2_bglt
																																																																																BgL_auxz00_15770;
																																																																														BgL_tagzd2397zd2_1798:
																																																																															BgL_auxz00_15770 = BGl_setzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15770);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																																{
																																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																																		BgL_auxz00_15778;
																																																																																BgL_tagzd2398zd2_1799:
																																																																																	BgL_auxz00_15778 = BGl_jumpzd2exitzd2ze3nodeze3zzast_exitz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_15778);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd23965zd2_2926;
																																																																																	BgL_cdrzd23965zd2_2926
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2522z00_2929;
																																																																																			obj_t
																																																																																				BgL_arg2523z00_2930;
																																																																																			BgL_arg2522z00_2929
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2926));
																																																																																			BgL_arg2523z00_2930
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd23965zd2_2926));
																																																																																			{	/* Ast/sexp.scm 555 */
																																																																																				obj_t
																																																																																					BgL_arg7015z00_10330;
																																																																																				BgL_arg7015z00_10330
																																																																																					=
																																																																																					BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																					(BgL_expz00_21,
																																																																																					BgL_locz00_23);
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																					(BgL_expz00_21,
																																																																																						BgL_arg2522z00_2929,
																																																																																						CNST_TABLE_REF
																																																																																						(((long) 4)), BgL_arg2523z00_2930, BgL_stackz00_22, BgL_arg7015z00_10330, BgL_sitez00_24));
																																																																																		}}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15798;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15798);
																																																																																				}
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd23990zd2_2947;
																																					BgL_carzd23990zd2_2947
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd23990zd2_2947
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_15805;
																																							goto
																																								BgL_tagzd2377zd2_1754;
																																							BgL_auxz00_14300
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_15805);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd23990zd2_2947 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_15809;
																																									goto
																																										BgL_tagzd2377zd2_1754;
																																									BgL_auxz00_14300
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_15809);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_15816;
																																											goto
																																												BgL_tagzd2379zd2_1758;
																																											BgL_auxz00_14300
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_15816);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_15823;
																																													goto
																																														BgL_tagzd2380zd2_1759;
																																													BgL_auxz00_14300
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_15823);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd24059zd2_2954;
																																													BgL_carzd24059zd2_2954
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd24059zd2_2954))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd24062zd2_2956;
																																															obj_t
																																																BgL_cdrzd24063zd2_2957;
																																															BgL_carzd24062zd2_2956
																																																=
																																																CAR
																																																(BgL_carzd24059zd2_2954);
																																															BgL_cdrzd24063zd2_2957
																																																=
																																																CDR
																																																(BgL_carzd24059zd2_2954);
																																															{

																																																if ((BgL_carzd24062zd2_2956 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 119 */
																																																	BgL_kapzd24064zd2_2958:
																																																		if (PAIRP(BgL_cdrzd24063zd2_2957))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd24067zd2_3083;
																																																				BgL_cdrzd24067zd2_3083
																																																					=
																																																					CDR
																																																					(BgL_cdrzd24063zd2_2957);
																																																				if (PAIRP(BgL_cdrzd24067zd2_3083))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd24067zd2_3083)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2644z00_3087;
																																																								obj_t
																																																									BgL_arg2645z00_3088;
																																																								BgL_arg2644z00_3087
																																																									=
																																																									CAR
																																																									(BgL_cdrzd24067zd2_3083);
																																																								BgL_arg2645z00_3088
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_15845;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_15847;
																																																										obj_t
																																																											BgL_bodyz00_15846;
																																																										BgL_bodyz00_15846
																																																											=
																																																											BgL_arg2644z00_3087;
																																																										BgL_argsz00_15847
																																																											=
																																																											BgL_arg2645z00_3088;
																																																										BgL_argsz00_1761
																																																											=
																																																											BgL_argsz00_15847;
																																																										BgL_bodyz00_1760
																																																											=
																																																											BgL_bodyz00_15846;
																																																										goto
																																																											BgL_tagzd2381zd2_1762;
																																																									}
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_15845);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd24091zd2_3089;
																																																								BgL_cdrzd24091zd2_3089
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8388z00_15851;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2719z00_3200;
																																																										BgL_arg2719z00_3200
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8388z00_15851
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2719z00_3200));
																																																									}
																																																									if (BgL_test8388z00_15851)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2648z00_3092;
																																																											obj_t
																																																												BgL_arg2649z00_3093;
																																																											BgL_arg2648z00_3092
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3089));
																																																											BgL_arg2649z00_3093
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd24091zd2_3089));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_15860;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_15862;
																																																													obj_t
																																																														BgL_bindingsz00_15861;
																																																													BgL_bindingsz00_15861
																																																														=
																																																														BgL_arg2648z00_3092;
																																																													BgL_exprz00_15862
																																																														=
																																																														BgL_arg2649z00_3093;
																																																													BgL_exprz00_1764
																																																														=
																																																														BgL_exprz00_15862;
																																																													BgL_bindingsz00_1763
																																																														=
																																																														BgL_bindingsz00_15861;
																																																													goto
																																																														BgL_tagzd2382zd2_1765;
																																																												}
																																																												BgL_auxz00_14300
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_15860);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8389z00_15864;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2717z00_3199;
																																																												BgL_arg2717z00_3199
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8389z00_15864
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2717z00_3199));
																																																											}
																																																											if (BgL_test8389z00_15864)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_15869;
																																																													goto
																																																														BgL_tagzd2384zd2_1767;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_15869);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd24158zd2_3096;
																																																													BgL_carzd24158zd2_3096
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd24163zd2_3097;
																																																														BgL_cdrzd24163zd2_3097
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd24158zd2_3096));
																																																														if ((CAR(((obj_t) BgL_carzd24158zd2_3096)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg2654z00_3100;
																																																																obj_t
																																																																	BgL_arg2656z00_3101;
																																																																obj_t
																																																																	BgL_arg2657z00_3102;
																																																																BgL_arg2654z00_3100
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3097));
																																																																BgL_arg2656z00_3101
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd24163zd2_3097));
																																																																BgL_arg2657z00_3102
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_15886;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_15889;
																																																																		obj_t
																																																																			BgL_bodyz00_15888;
																																																																		obj_t
																																																																			BgL_varsz00_15887;
																																																																		BgL_varsz00_15887
																																																																			=
																																																																			BgL_arg2654z00_3100;
																																																																		BgL_bodyz00_15888
																																																																			=
																																																																			BgL_arg2656z00_3101;
																																																																		BgL_argsz00_15889
																																																																			=
																																																																			BgL_arg2657z00_3102;
																																																																		BgL_argsz00_1774
																																																																			=
																																																																			BgL_argsz00_15889;
																																																																		BgL_bodyz00_1773
																																																																			=
																																																																			BgL_bodyz00_15888;
																																																																		BgL_varsz00_1772
																																																																			=
																																																																			BgL_varsz00_15887;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1775;
																																																																	}
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_15886);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd24186zd2_3104;
																																																																BgL_cdrzd24186zd2_3104
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd24192zd2_3105;
																																																																	BgL_cdrzd24192zd2_3105
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd24158zd2_3096));
																																																																	if ((CAR(((obj_t) BgL_carzd24158zd2_3096)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd24198zd2_3108;
																																																																			BgL_cdrzd24198zd2_3108
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd24192zd2_3105));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd24203zd2_3109;
																																																																				obj_t
																																																																					BgL_cdrzd24204zd2_3110;
																																																																				BgL_carzd24203zd2_3109
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3108));
																																																																				BgL_cdrzd24204zd2_3110
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd24198zd2_3108));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24203zd2_3109))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (PAIRP(BgL_cdrzd24204zd2_3110))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd24211zd2_3113;
																																																																								BgL_carzd24211zd2_3113
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd24204zd2_3110);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24211zd2_3113))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(BgL_cdrzd24204zd2_3110)))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8396z00_15916;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1371z00_3146;
																																																																													BgL_l1371z00_3146
																																																																														=
																																																																														BgL_cdrzd24186zd2_3104;
																																																																												BgL_zc3z04anonymousza32681ze3z87_3147:
																																																																													if (NULLP(BgL_l1371z00_3146))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test8396z00_15916
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8398z00_15919;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test8399z00_15920;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_15921;
																																																																																	BgL_tmpz00_15921
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1371z00_3146));
																																																																																	BgL_test8399z00_15920
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_15921);
																																																																																}
																																																																																if (BgL_test8399z00_15920)
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8398z00_15919
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8398z00_15919
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_test8398z00_15919)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1371z00_15925;
																																																																																	BgL_l1371z00_15925
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1371z00_3146));
																																																																																	BgL_l1371z00_3146
																																																																																		=
																																																																																		BgL_l1371z00_15925;
																																																																																	goto
																																																																																		BgL_zc3z04anonymousza32681ze3z87_3147;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8396z00_15916
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_test8396z00_15916)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2670z00_3129;
																																																																														BgL_arg2670z00_3129
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd24192zd2_3105));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_15930;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_15934;
																																																																																obj_t
																																																																																	BgL_proc2z00_15933;
																																																																																obj_t
																																																																																	BgL_proc1z00_15932;
																																																																																obj_t
																																																																																	BgL_testz00_15931;
																																																																																BgL_testz00_15931
																																																																																	=
																																																																																	BgL_arg2670z00_3129;
																																																																																BgL_proc1z00_15932
																																																																																	=
																																																																																	BgL_carzd24203zd2_3109;
																																																																																BgL_proc2z00_15933
																																																																																	=
																																																																																	BgL_carzd24211zd2_3113;
																																																																																BgL_argsz00_15934
																																																																																	=
																																																																																	BgL_cdrzd24186zd2_3104;
																																																																																BgL_argsz00_1779
																																																																																	=
																																																																																	BgL_argsz00_15934;
																																																																																BgL_proc2z00_1778
																																																																																	=
																																																																																	BgL_proc2z00_15933;
																																																																																BgL_proc1z00_1777
																																																																																	=
																																																																																	BgL_proc1z00_15932;
																																																																																BgL_testz00_1776
																																																																																	=
																																																																																	BgL_testz00_15931;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1780;
																																																																															}
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_15930);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd24235zd2_3130;
																																																																														BgL_cdrzd24235zd2_3130
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd24242zd2_3131;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10374;
																																																																																BgL_pairz00_10374
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd24242zd2_3131
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10374);
																																																																															}
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd24249zd2_3132;
																																																																																BgL_cdrzd24249zd2_3132
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd24242zd2_3131));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd24255zd2_3133;
																																																																																	BgL_carzd24255zd2_3133
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd24249zd2_3132));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24255zd2_3133))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd24262zd2_3135;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_pairz00_10378;
																																																																																				BgL_pairz00_10378
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd24249zd2_3132));
																																																																																				BgL_carzd24262zd2_3135
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_10378);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24262zd2_3135))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24235zd2_3130))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg2675z00_3138;
																																																																																							BgL_arg2675z00_3138
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd24242zd2_3131));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_15956;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_15960;
																																																																																									obj_t
																																																																																										BgL_proc2z00_15959;
																																																																																									obj_t
																																																																																										BgL_proc1z00_15958;
																																																																																									obj_t
																																																																																										BgL_testz00_15957;
																																																																																									BgL_testz00_15957
																																																																																										=
																																																																																										BgL_arg2675z00_3138;
																																																																																									BgL_proc1z00_15958
																																																																																										=
																																																																																										BgL_carzd24255zd2_3133;
																																																																																									BgL_proc2z00_15959
																																																																																										=
																																																																																										BgL_carzd24262zd2_3135;
																																																																																									BgL_argsz00_15960
																																																																																										=
																																																																																										BgL_cdrzd24235zd2_3130;
																																																																																									BgL_argsz00_1784
																																																																																										=
																																																																																										BgL_argsz00_15960;
																																																																																									BgL_proc2z00_1783
																																																																																										=
																																																																																										BgL_proc2z00_15959;
																																																																																									BgL_proc1z00_1782
																																																																																										=
																																																																																										BgL_proc1z00_15958;
																																																																																									BgL_testz00_1781
																																																																																										=
																																																																																										BgL_testz00_15957;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1785;
																																																																																								}
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_15956);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1809;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_15964;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1810;
																																																																																									BgL_auxz00_14300
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_15964);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_15968;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_15968);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_15972;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_15972);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_15976;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_14300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_15976);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd24538zd2_3157;
																																																																										BgL_cdrzd24538zd2_3157
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd24544zd2_3158;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_10382;
																																																																												BgL_pairz00_10382
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd24544zd2_3158
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10382);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd24550zd2_3159;
																																																																												BgL_cdrzd24550zd2_3159
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd24544zd2_3158));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd24555zd2_3160;
																																																																													obj_t
																																																																														BgL_cdrzd24556zd2_3161;
																																																																													BgL_carzd24555zd2_3160
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3159));
																																																																													BgL_cdrzd24556zd2_3161
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd24550zd2_3159));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24555zd2_3160))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd24561zd2_3163;
																																																																															BgL_carzd24561zd2_3163
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd24556zd2_3161));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24561zd2_3163))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd24556zd2_3161))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24538zd2_3157))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg2691z00_3168;
																																																																																					BgL_arg2691z00_3168
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd24544zd2_3158));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16003;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_16007;
																																																																																							obj_t
																																																																																								BgL_proc2z00_16006;
																																																																																							obj_t
																																																																																								BgL_proc1z00_16005;
																																																																																							obj_t
																																																																																								BgL_testz00_16004;
																																																																																							BgL_testz00_16004
																																																																																								=
																																																																																								BgL_arg2691z00_3168;
																																																																																							BgL_proc1z00_16005
																																																																																								=
																																																																																								BgL_carzd24555zd2_3160;
																																																																																							BgL_proc2z00_16006
																																																																																								=
																																																																																								BgL_carzd24561zd2_3163;
																																																																																							BgL_argsz00_16007
																																																																																								=
																																																																																								BgL_cdrzd24538zd2_3157;
																																																																																							BgL_argsz00_1784
																																																																																								=
																																																																																								BgL_argsz00_16007;
																																																																																							BgL_proc2z00_1783
																																																																																								=
																																																																																								BgL_proc2z00_16006;
																																																																																							BgL_proc1z00_1782
																																																																																								=
																																																																																								BgL_proc1z00_16005;
																																																																																							BgL_testz00_1781
																																																																																								=
																																																																																								BgL_testz00_16004;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1785;
																																																																																						}
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16003);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_16011;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_16011);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16015;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16015);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16019;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16019);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16023;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16023);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_16027;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_14300
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_16027);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd24894zd2_3176;
																																																																						BgL_cdrzd24894zd2_3176
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd24901zd2_3177;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_10392;
																																																																								BgL_pairz00_10392
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd24901zd2_3177
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10392);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd24908zd2_3178;
																																																																								BgL_cdrzd24908zd2_3178
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd24901zd2_3177));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd24914zd2_3179;
																																																																									obj_t
																																																																										BgL_cdrzd24915zd2_3180;
																																																																									BgL_carzd24914zd2_3179
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3178));
																																																																									BgL_cdrzd24915zd2_3180
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd24908zd2_3178));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24914zd2_3179))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd24915zd2_3180))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd24922zd2_3183;
																																																																													BgL_carzd24922zd2_3183
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd24915zd2_3180);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd24922zd2_3183))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd24915zd2_3180)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd24894zd2_3176))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2705z00_3188;
																																																																																			BgL_arg2705z00_3188
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd24901zd2_3177));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16054;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16058;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16057;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16056;
																																																																																					obj_t
																																																																																						BgL_testz00_16055;
																																																																																					BgL_testz00_16055
																																																																																						=
																																																																																						BgL_arg2705z00_3188;
																																																																																					BgL_proc1z00_16056
																																																																																						=
																																																																																						BgL_carzd24914zd2_3179;
																																																																																					BgL_proc2z00_16057
																																																																																						=
																																																																																						BgL_carzd24922zd2_3183;
																																																																																					BgL_argsz00_16058
																																																																																						=
																																																																																						BgL_cdrzd24894zd2_3176;
																																																																																					BgL_argsz00_1784
																																																																																						=
																																																																																						BgL_argsz00_16058;
																																																																																					BgL_proc2z00_1783
																																																																																						=
																																																																																						BgL_proc2z00_16057;
																																																																																					BgL_proc1z00_1782
																																																																																						=
																																																																																						BgL_proc1z00_16056;
																																																																																					BgL_testz00_1781
																																																																																						=
																																																																																						BgL_testz00_16055;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1785;
																																																																																				}
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16054);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16062;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16062);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16066;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16066);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16070;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16070);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16074;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16074);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16078;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16078);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16082;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16082);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd25315zd2_3202;
																																																						BgL_cdrzd25315zd2_3202
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8427z00_16086;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2743z00_3219;
																																																								BgL_arg2743z00_3219
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8427z00_16086
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg2743z00_3219));
																																																							}
																																																							if (BgL_test8427z00_16086)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2725z00_3205;
																																																									obj_t
																																																										BgL_arg2726z00_3206;
																																																									BgL_arg2725z00_3205
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3202));
																																																									BgL_arg2726z00_3206
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd25315zd2_3202));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_16095;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_16097;
																																																											obj_t
																																																												BgL_bindingsz00_16096;
																																																											BgL_bindingsz00_16096
																																																												=
																																																												BgL_arg2725z00_3205;
																																																											BgL_exprz00_16097
																																																												=
																																																												BgL_arg2726z00_3206;
																																																											BgL_exprz00_1764
																																																												=
																																																												BgL_exprz00_16097;
																																																											BgL_bindingsz00_1763
																																																												=
																																																												BgL_bindingsz00_16096;
																																																											goto
																																																												BgL_tagzd2382zd2_1765;
																																																										}
																																																										BgL_auxz00_14300
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_16095);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8428z00_16099;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2742z00_3218;
																																																										BgL_arg2742z00_3218
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8428z00_16099
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg2742z00_3218));
																																																									}
																																																									if (BgL_test8428z00_16099)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16104;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16104);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd25381zd2_3209;
																																																											BgL_carzd25381zd2_3209
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd25386zd2_3210;
																																																												BgL_cdrzd25386zd2_3210
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd25381zd2_3209));
																																																												if ((CAR(((obj_t) BgL_carzd25381zd2_3209)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2732z00_3213;
																																																														obj_t
																																																															BgL_arg2736z00_3214;
																																																														obj_t
																																																															BgL_arg2738z00_3215;
																																																														BgL_arg2732z00_3213
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3210));
																																																														BgL_arg2736z00_3214
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd25386zd2_3210));
																																																														BgL_arg2738z00_3215
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16121;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_16124;
																																																																obj_t
																																																																	BgL_bodyz00_16123;
																																																																obj_t
																																																																	BgL_varsz00_16122;
																																																																BgL_varsz00_16122
																																																																	=
																																																																	BgL_arg2732z00_3213;
																																																																BgL_bodyz00_16123
																																																																	=
																																																																	BgL_arg2736z00_3214;
																																																																BgL_argsz00_16124
																																																																	=
																																																																	BgL_arg2738z00_3215;
																																																																BgL_argsz00_1774
																																																																	=
																																																																	BgL_argsz00_16124;
																																																																BgL_bodyz00_1773
																																																																	=
																																																																	BgL_bodyz00_16123;
																																																																BgL_varsz00_1772
																																																																	=
																																																																	BgL_varsz00_16122;
																																																																goto
																																																																	BgL_tagzd2386zd2_1775;
																																																															}
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16121);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_16128;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_14300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_16128);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd25497zd2_3220;
																																																				BgL_cdrzd25497zd2_3220
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8431z00_16132;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg2762z00_3229;
																																																						BgL_arg2762z00_3229
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8431z00_16132
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg2762z00_3229));
																																																					}
																																																					if (BgL_test8431z00_16132)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg2747z00_3223;
																																																							obj_t
																																																								BgL_arg2749z00_3224;
																																																							BgL_arg2747z00_3223
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3220));
																																																							BgL_arg2749z00_3224
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd25497zd2_3220));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16141;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16143;
																																																									obj_t
																																																										BgL_bindingsz00_16142;
																																																									BgL_bindingsz00_16142
																																																										=
																																																										BgL_arg2747z00_3223;
																																																									BgL_exprz00_16143
																																																										=
																																																										BgL_arg2749z00_3224;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_16143;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_16142;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_14300
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16141);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8432z00_16145;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg2756z00_3228;
																																																								BgL_arg2756z00_3228
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8432z00_16145
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg2756z00_3228));
																																																							}
																																																							if (BgL_test8432z00_16145)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16150;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16150);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1809;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_16154;
																																																											goto
																																																												BgL_tagzd2404zd2_1810;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16154);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24062zd2_2956)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd24064zd2_2958;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd24062zd2_2956 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd24064zd2_2958;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd24062zd2_2956 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd24064zd2_2958;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd24062zd2_2956)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd24064zd2_2958;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd25669zd2_2964;
																																																										BgL_cdrzd25669zd2_2964
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8438z00_16170;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2639z00_3081;
																																																												BgL_arg2639z00_3081
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8438z00_16170
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg2639z00_3081));
																																																											}
																																																											if (BgL_test8438z00_16170)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg2560z00_2967;
																																																													obj_t
																																																														BgL_arg2561z00_2968;
																																																													BgL_arg2560z00_2967
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2964));
																																																													BgL_arg2561z00_2968
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd25669zd2_2964));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16179;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_16181;
																																																															obj_t
																																																																BgL_bindingsz00_16180;
																																																															BgL_bindingsz00_16180
																																																																=
																																																																BgL_arg2560z00_2967;
																																																															BgL_exprz00_16181
																																																																=
																																																																BgL_arg2561z00_2968;
																																																															BgL_exprz00_1764
																																																																=
																																																																BgL_exprz00_16181;
																																																															BgL_bindingsz00_1763
																																																																=
																																																																BgL_bindingsz00_16180;
																																																															goto
																																																																BgL_tagzd2382zd2_1765;
																																																														}
																																																														BgL_auxz00_14300
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16179);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test8439z00_16183;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2637z00_3080;
																																																														BgL_arg2637z00_3080
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test8439z00_16183
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg2637z00_3080));
																																																													}
																																																													if (BgL_test8439z00_16183)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_16188;
																																																															goto
																																																																BgL_tagzd2384zd2_1767;
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16188);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd25735zd2_2971;
																																																															BgL_carzd25735zd2_2971
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd25740zd2_2972;
																																																																BgL_cdrzd25740zd2_2972
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd25735zd2_2971));
																																																																if ((CAR(((obj_t) BgL_carzd25735zd2_2971)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd25740zd2_2972))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg2567z00_2976;
																																																																				obj_t
																																																																					BgL_arg2568z00_2977;
																																																																				obj_t
																																																																					BgL_arg2569z00_2978;
																																																																				BgL_arg2567z00_2976
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd25740zd2_2972);
																																																																				BgL_arg2568z00_2977
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd25740zd2_2972);
																																																																				BgL_arg2569z00_2978
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16205;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_16208;
																																																																						obj_t
																																																																							BgL_bodyz00_16207;
																																																																						obj_t
																																																																							BgL_varsz00_16206;
																																																																						BgL_varsz00_16206
																																																																							=
																																																																							BgL_arg2567z00_2976;
																																																																						BgL_bodyz00_16207
																																																																							=
																																																																							BgL_arg2568z00_2977;
																																																																						BgL_argsz00_16208
																																																																							=
																																																																							BgL_arg2569z00_2978;
																																																																						BgL_argsz00_1774
																																																																							=
																																																																							BgL_argsz00_16208;
																																																																						BgL_bodyz00_1773
																																																																							=
																																																																							BgL_bodyz00_16207;
																																																																						BgL_varsz00_1772
																																																																							=
																																																																							BgL_varsz00_16206;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1775;
																																																																					}
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16205);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_16212;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_16212);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd25847zd2_2981;
																																																																		BgL_cdrzd25847zd2_2981
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd25852zd2_2982;
																																																																			BgL_cdrzd25852zd2_2982
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd25735zd2_2971));
																																																																			if ((CAR(((obj_t) BgL_carzd25735zd2_2971)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd25852zd2_2982))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd25857zd2_2986;
																																																																							BgL_cdrzd25857zd2_2986
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd25852zd2_2982);
																																																																							if (PAIRP(BgL_cdrzd25857zd2_2986))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd25861zd2_2988;
																																																																									obj_t
																																																																										BgL_cdrzd25862zd2_2989;
																																																																									BgL_carzd25861zd2_2988
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd25857zd2_2986);
																																																																									BgL_cdrzd25862zd2_2989
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd25857zd2_2986);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25861zd2_2988))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd25862zd2_2989))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd25867zd2_2992;
																																																																													BgL_carzd25867zd2_2992
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd25862zd2_2989);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25867zd2_2992))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd25862zd2_2989)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test8450z00_16240;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1374z00_3025;
																																																																																		BgL_l1374z00_3025
																																																																																			=
																																																																																			BgL_cdrzd25847zd2_2981;
																																																																																	BgL_zc3z04anonymousza32597ze3z87_3026:
																																																																																		if (NULLP(BgL_l1374z00_3025))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8450z00_16240
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				bool_t
																																																																																					BgL_test8452z00_16243;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					bool_t
																																																																																						BgL_test8453z00_16244;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_16245;
																																																																																						BgL_tmpz00_16245
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1374z00_3025));
																																																																																						BgL_test8453z00_16244
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_16245);
																																																																																					}
																																																																																					if (BgL_test8453z00_16244)
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test8452z00_16243
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test8452z00_16243
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_test8452z00_16243)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1374z00_16249;
																																																																																						BgL_l1374z00_16249
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1374z00_3025));
																																																																																						BgL_l1374z00_3025
																																																																																							=
																																																																																							BgL_l1374z00_16249;
																																																																																						goto
																																																																																							BgL_zc3z04anonymousza32597ze3z87_3026;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test8450z00_16240
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test8450z00_16240)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg2586z00_3008;
																																																																																			BgL_arg2586z00_3008
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd25852zd2_2982);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16253;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16257;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16256;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16255;
																																																																																					obj_t
																																																																																						BgL_testz00_16254;
																																																																																					BgL_testz00_16254
																																																																																						=
																																																																																						BgL_arg2586z00_3008;
																																																																																					BgL_proc1z00_16255
																																																																																						=
																																																																																						BgL_carzd25861zd2_2988;
																																																																																					BgL_proc2z00_16256
																																																																																						=
																																																																																						BgL_carzd25867zd2_2992;
																																																																																					BgL_argsz00_16257
																																																																																						=
																																																																																						BgL_cdrzd25847zd2_2981;
																																																																																					BgL_argsz00_1779
																																																																																						=
																																																																																						BgL_argsz00_16257;
																																																																																					BgL_proc2z00_1778
																																																																																						=
																																																																																						BgL_proc2z00_16256;
																																																																																					BgL_proc1z00_1777
																																																																																						=
																																																																																						BgL_proc1z00_16255;
																																																																																					BgL_testz00_1776
																																																																																						=
																																																																																						BgL_testz00_16254;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1780;
																																																																																				}
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16253);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd25892zd2_3009;
																																																																																			BgL_cdrzd25892zd2_3009
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_cdrzd25900zd2_3010;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10449;
																																																																																					BgL_pairz00_10449
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd25900zd2_3010
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_10449);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd25908zd2_3011;
																																																																																					BgL_cdrzd25908zd2_3011
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd25900zd2_3010));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd25915zd2_3012;
																																																																																						BgL_carzd25915zd2_3012
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd25908zd2_3011));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25915zd2_3012))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd25924zd2_3014;
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_pairz00_10453;
																																																																																									BgL_pairz00_10453
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd25908zd2_3011));
																																																																																									BgL_carzd25924zd2_3014
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_10453);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd25924zd2_3014))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd25892zd2_3009))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg2591z00_3017;
																																																																																												BgL_arg2591z00_3017
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd25900zd2_3010));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_16279;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_16283;
																																																																																														obj_t
																																																																																															BgL_proc2z00_16282;
																																																																																														obj_t
																																																																																															BgL_proc1z00_16281;
																																																																																														obj_t
																																																																																															BgL_testz00_16280;
																																																																																														BgL_testz00_16280
																																																																																															=
																																																																																															BgL_arg2591z00_3017;
																																																																																														BgL_proc1z00_16281
																																																																																															=
																																																																																															BgL_carzd25915zd2_3012;
																																																																																														BgL_proc2z00_16282
																																																																																															=
																																																																																															BgL_carzd25924zd2_3014;
																																																																																														BgL_argsz00_16283
																																																																																															=
																																																																																															BgL_cdrzd25892zd2_3009;
																																																																																														BgL_argsz00_1784
																																																																																															=
																																																																																															BgL_argsz00_16283;
																																																																																														BgL_proc2z00_1783
																																																																																															=
																																																																																															BgL_proc2z00_16282;
																																																																																														BgL_proc1z00_1782
																																																																																															=
																																																																																															BgL_proc1z00_16281;
																																																																																														BgL_testz00_1781
																																																																																															=
																																																																																															BgL_testz00_16280;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1785;
																																																																																													}
																																																																																													BgL_auxz00_14300
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_16279);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1809;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_16287;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1810;
																																																																																														BgL_auxz00_14300
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_16287);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16291;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_14300
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16291);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16295;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16295);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16299;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16299);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd26202zd2_3036;
																																																																															BgL_cdrzd26202zd2_3036
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd26209zd2_3037;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10457;
																																																																																	BgL_pairz00_10457
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd26209zd2_3037
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10457);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd26216zd2_3038;
																																																																																	BgL_cdrzd26216zd2_3038
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd26209zd2_3037));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd26222zd2_3039;
																																																																																		obj_t
																																																																																			BgL_cdrzd26223zd2_3040;
																																																																																		BgL_carzd26222zd2_3039
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_3038));
																																																																																		BgL_cdrzd26223zd2_3040
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd26216zd2_3038));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26222zd2_3039))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd26230zd2_3042;
																																																																																				BgL_carzd26230zd2_3042
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd26223zd2_3040));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26230zd2_3042))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd26223zd2_3040))))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26202zd2_3036))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2608z00_3047;
																																																																																										BgL_arg2608z00_3047
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd26209zd2_3037));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_16326;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_16330;
																																																																																												obj_t
																																																																																													BgL_proc2z00_16329;
																																																																																												obj_t
																																																																																													BgL_proc1z00_16328;
																																																																																												obj_t
																																																																																													BgL_testz00_16327;
																																																																																												BgL_testz00_16327
																																																																																													=
																																																																																													BgL_arg2608z00_3047;
																																																																																												BgL_proc1z00_16328
																																																																																													=
																																																																																													BgL_carzd26222zd2_3039;
																																																																																												BgL_proc2z00_16329
																																																																																													=
																																																																																													BgL_carzd26230zd2_3042;
																																																																																												BgL_argsz00_16330
																																																																																													=
																																																																																													BgL_cdrzd26202zd2_3036;
																																																																																												BgL_argsz00_1784
																																																																																													=
																																																																																													BgL_argsz00_16330;
																																																																																												BgL_proc2z00_1783
																																																																																													=
																																																																																													BgL_proc2z00_16329;
																																																																																												BgL_proc1z00_1782
																																																																																													=
																																																																																													BgL_proc1z00_16328;
																																																																																												BgL_testz00_1781
																																																																																													=
																																																																																													BgL_testz00_16327;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1785;
																																																																																											}
																																																																																											BgL_auxz00_14300
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_16326);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_16334;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_14300
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_16334);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16338;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16338);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16342;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16342);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16346;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16346);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16350;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16350);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd26563zd2_3055;
																																																																											BgL_cdrzd26563zd2_3055
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd26569zd2_3056;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_10467;
																																																																													BgL_pairz00_10467
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd26569zd2_3056
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10467);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd26575zd2_3057;
																																																																													BgL_cdrzd26575zd2_3057
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd26569zd2_3056));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd26580zd2_3058;
																																																																														obj_t
																																																																															BgL_cdrzd26581zd2_3059;
																																																																														BgL_carzd26580zd2_3058
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3057));
																																																																														BgL_cdrzd26581zd2_3059
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd26575zd2_3057));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26580zd2_3058))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd26581zd2_3059))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd26586zd2_3062;
																																																																																		BgL_carzd26586zd2_3062
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd26581zd2_3059);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd26586zd2_3062))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd26581zd2_3059)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd26563zd2_3055))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg2623z00_3067;
																																																																																								BgL_arg2623z00_3067
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd26569zd2_3056));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_16377;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_16381;
																																																																																										obj_t
																																																																																											BgL_proc2z00_16380;
																																																																																										obj_t
																																																																																											BgL_proc1z00_16379;
																																																																																										obj_t
																																																																																											BgL_testz00_16378;
																																																																																										BgL_testz00_16378
																																																																																											=
																																																																																											BgL_arg2623z00_3067;
																																																																																										BgL_proc1z00_16379
																																																																																											=
																																																																																											BgL_carzd26580zd2_3058;
																																																																																										BgL_proc2z00_16380
																																																																																											=
																																																																																											BgL_carzd26586zd2_3062;
																																																																																										BgL_argsz00_16381
																																																																																											=
																																																																																											BgL_cdrzd26563zd2_3055;
																																																																																										BgL_argsz00_1784
																																																																																											=
																																																																																											BgL_argsz00_16381;
																																																																																										BgL_proc2z00_1783
																																																																																											=
																																																																																											BgL_proc2z00_16380;
																																																																																										BgL_proc1z00_1782
																																																																																											=
																																																																																											BgL_proc1z00_16379;
																																																																																										BgL_testz00_1781
																																																																																											=
																																																																																											BgL_testz00_16378;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1785;
																																																																																									}
																																																																																									BgL_auxz00_14300
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_16377);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_16385;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_16385);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_16389;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_16389);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16393;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16393);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16397;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16397);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16401;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16401);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16405;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16405);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16409;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16409);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_16413;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_16413);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd27124zd2_3231;
																																															BgL_cdrzd27124zd2_3231
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd24059zd2_2954 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg2765z00_3233;
																																																	obj_t
																																																		BgL_arg2768z00_3234;
																																																	BgL_arg2765z00_3233
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3231));
																																																	BgL_arg2768z00_3234
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd27124zd2_3231));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_16424;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_16426;
																																																			obj_t
																																																				BgL_bindingsz00_16425;
																																																			BgL_bindingsz00_16425
																																																				=
																																																				BgL_arg2765z00_3233;
																																																			BgL_exprz00_16426
																																																				=
																																																				BgL_arg2768z00_3234;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_16426;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_16425;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_14300
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_16424);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd24059zd2_2954)))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2770z00_3236;
																																																			obj_t
																																																				BgL_arg2771z00_3237;
																																																			BgL_arg2770z00_3236
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3231));
																																																			BgL_arg2771z00_3237
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd27124zd2_3231));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_16435;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_16437;
																																																					obj_t
																																																						BgL_bindingsz00_16436;
																																																					BgL_bindingsz00_16436
																																																						=
																																																						BgL_arg2770z00_3236;
																																																					BgL_exprz00_16437
																																																						=
																																																						BgL_arg2771z00_3237;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_16437;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_16436;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_14300
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_16435);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((BgL_carzd24059zd2_2954 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2773z00_3239;
																																																					obj_t
																																																						BgL_arg2774z00_3240;
																																																					BgL_arg2773z00_3239
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3231));
																																																					BgL_arg2774z00_3240
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd27124zd2_3231));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16446;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16448;
																																																							obj_t
																																																								BgL_bindingsz00_16447;
																																																							BgL_bindingsz00_16447
																																																								=
																																																								BgL_arg2773z00_3239;
																																																							BgL_exprz00_16448
																																																								=
																																																								BgL_arg2774z00_3240;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_16448;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_16447;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_14300
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16446);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_16455;
																																																							goto
																																																								BgL_tagzd2383zd2_1766;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16455);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd27161zd2_3243;
																																																							BgL_carzd27161zd2_3243
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd27161zd2_3243 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16462;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16462);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27161zd2_3243)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16467;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16467);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16474;
																																																													goto
																																																														BgL_tagzd2389zd2_1786;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16474);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16481;
																																																															goto
																																																																BgL_tagzd2390zd2_1787;
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16481);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd27241zd2_3250;
																																																															BgL_cdrzd27241zd2_3250
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg2788z00_3253;
																																																																	obj_t
																																																																		BgL_arg2792z00_3254;
																																																																	BgL_arg2788z00_3253
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3250));
																																																																	BgL_arg2792z00_3254
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27241zd2_3250));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_16494;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_16496;
																																																																			obj_t
																																																																				BgL_effectz00_16495;
																																																																			BgL_effectz00_16495
																																																																				=
																																																																				BgL_arg2788z00_3253;
																																																																			BgL_restz00_16496
																																																																				=
																																																																				BgL_arg2792z00_3254;
																																																																			BgL_restz00_1789
																																																																				=
																																																																				BgL_restz00_16496;
																																																																			BgL_effectz00_1788
																																																																				=
																																																																				BgL_effectz00_16495;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1790;
																																																																		}
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_16494);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16503;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1791;
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16503);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_16510;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1792;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_16510);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg2810z00_3262;
																																																																							obj_t
																																																																								BgL_arg2811z00_3263;
																																																																							BgL_arg2810z00_3262
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3250));
																																																																							BgL_arg2811z00_3263
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd27241zd2_3250));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16521;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_16523;
																																																																									obj_t
																																																																										BgL_effectz00_16522;
																																																																									BgL_effectz00_16522
																																																																										=
																																																																										BgL_arg2810z00_3262;
																																																																									BgL_restz00_16523
																																																																										=
																																																																										BgL_arg2811z00_3263;
																																																																									BgL_restz00_1794
																																																																										=
																																																																										BgL_restz00_16523;
																																																																									BgL_effectz00_1793
																																																																										=
																																																																										BgL_effectz00_16522;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1795;
																																																																								}
																																																																								BgL_auxz00_14300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16521);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_16530;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1796;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_16530);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16537;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1797;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16537);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_16544;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1798;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16544);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_16551;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1799;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16551);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd27318zd2_3272;
																																																																															BgL_cdrzd27318zd2_3272
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg2831z00_3275;
																																																																																	obj_t
																																																																																		BgL_arg2832z00_3276;
																																																																																	BgL_arg2831z00_3275
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3272));
																																																																																	BgL_arg2832z00_3276
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd27318zd2_3272));
																																																																																	{	/* Ast/sexp.scm 555 */
																																																																																		obj_t
																																																																																			BgL_arg7015z00_10506;
																																																																																		BgL_arg7015z00_10506
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg2831z00_3275,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg2832z00_3276, BgL_stackz00_22, BgL_arg7015z00_10506, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16570;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16570);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd27343zd2_3293;
																																			BgL_carzd27343zd2_3293
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd27343zd2_3293
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_16577;
																																					goto
																																						BgL_tagzd2377zd2_1754;
																																					BgL_auxz00_14300
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_16577);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd27343zd2_3293
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_16581;
																																							goto
																																								BgL_tagzd2377zd2_1754;
																																							BgL_auxz00_14300
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_16581);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_16588;
																																									goto
																																										BgL_tagzd2379zd2_1758;
																																									BgL_auxz00_14300
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_16588);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_16595;
																																											goto
																																												BgL_tagzd2380zd2_1759;
																																											BgL_auxz00_14300
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_16595);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd27412zd2_3300;
																																											BgL_carzd27412zd2_3300
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd27412zd2_3300))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd27415zd2_3302;
																																													obj_t
																																														BgL_cdrzd27416zd2_3303;
																																													BgL_carzd27415zd2_3302
																																														=
																																														CAR
																																														(BgL_carzd27412zd2_3300);
																																													BgL_cdrzd27416zd2_3303
																																														=
																																														CDR
																																														(BgL_carzd27412zd2_3300);
																																													{

																																														if ((BgL_carzd27415zd2_3302 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 119 */
																																															BgL_kapzd27417zd2_3304:
																																																if (PAIRP(BgL_cdrzd27416zd2_3303))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd27420zd2_3429;
																																																		BgL_cdrzd27420zd2_3429
																																																			=
																																																			CDR
																																																			(BgL_cdrzd27416zd2_3303);
																																																		if (PAIRP(BgL_cdrzd27420zd2_3429))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd27420zd2_3429)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg2969z00_3433;
																																																						obj_t
																																																							BgL_arg2973z00_3434;
																																																						BgL_arg2969z00_3433
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27420zd2_3429);
																																																						BgL_arg2973z00_3434
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_16617;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_16619;
																																																								obj_t
																																																									BgL_bodyz00_16618;
																																																								BgL_bodyz00_16618
																																																									=
																																																									BgL_arg2969z00_3433;
																																																								BgL_argsz00_16619
																																																									=
																																																									BgL_arg2973z00_3434;
																																																								BgL_argsz00_1761
																																																									=
																																																									BgL_argsz00_16619;
																																																								BgL_bodyz00_1760
																																																									=
																																																									BgL_bodyz00_16618;
																																																								goto
																																																									BgL_tagzd2381zd2_1762;
																																																							}
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16617);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd27444zd2_3435;
																																																						BgL_cdrzd27444zd2_3435
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8510z00_16623;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3071z00_3546;
																																																								BgL_arg3071z00_3546
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8510z00_16623
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3071z00_3546));
																																																							}
																																																							if (BgL_test8510z00_16623)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg2976z00_3438;
																																																									obj_t
																																																										BgL_arg2977z00_3439;
																																																									BgL_arg2976z00_3438
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3435));
																																																									BgL_arg2977z00_3439
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd27444zd2_3435));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_16632;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_16634;
																																																											obj_t
																																																												BgL_bindingsz00_16633;
																																																											BgL_bindingsz00_16633
																																																												=
																																																												BgL_arg2976z00_3438;
																																																											BgL_exprz00_16634
																																																												=
																																																												BgL_arg2977z00_3439;
																																																											BgL_exprz00_1764
																																																												=
																																																												BgL_exprz00_16634;
																																																											BgL_bindingsz00_1763
																																																												=
																																																												BgL_bindingsz00_16633;
																																																											goto
																																																												BgL_tagzd2382zd2_1765;
																																																										}
																																																										BgL_auxz00_14300
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_16632);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8511z00_16636;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3070z00_3545;
																																																										BgL_arg3070z00_3545
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8511z00_16636
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3070z00_3545));
																																																									}
																																																									if (BgL_test8511z00_16636)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_16641;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_16641);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd27511zd2_3442;
																																																											BgL_carzd27511zd2_3442
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd27516zd2_3443;
																																																												BgL_cdrzd27516zd2_3443
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd27511zd2_3442));
																																																												if ((CAR(((obj_t) BgL_carzd27511zd2_3442)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg2991z00_3446;
																																																														obj_t
																																																															BgL_arg2996z00_3447;
																																																														obj_t
																																																															BgL_arg2997z00_3448;
																																																														BgL_arg2991z00_3446
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3443));
																																																														BgL_arg2996z00_3447
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd27516zd2_3443));
																																																														BgL_arg2997z00_3448
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_16658;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_16661;
																																																																obj_t
																																																																	BgL_bodyz00_16660;
																																																																obj_t
																																																																	BgL_varsz00_16659;
																																																																BgL_varsz00_16659
																																																																	=
																																																																	BgL_arg2991z00_3446;
																																																																BgL_bodyz00_16660
																																																																	=
																																																																	BgL_arg2996z00_3447;
																																																																BgL_argsz00_16661
																																																																	=
																																																																	BgL_arg2997z00_3448;
																																																																BgL_argsz00_1774
																																																																	=
																																																																	BgL_argsz00_16661;
																																																																BgL_bodyz00_1773
																																																																	=
																																																																	BgL_bodyz00_16660;
																																																																BgL_varsz00_1772
																																																																	=
																																																																	BgL_varsz00_16659;
																																																																goto
																																																																	BgL_tagzd2386zd2_1775;
																																																															}
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_16658);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd27539zd2_3450;
																																																														BgL_cdrzd27539zd2_3450
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd27545zd2_3451;
																																																															BgL_cdrzd27545zd2_3451
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd27511zd2_3442));
																																																															if ((CAR(((obj_t) BgL_carzd27511zd2_3442)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd27551zd2_3454;
																																																																	BgL_cdrzd27551zd2_3454
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd27545zd2_3451));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd27556zd2_3455;
																																																																		obj_t
																																																																			BgL_cdrzd27557zd2_3456;
																																																																		BgL_carzd27556zd2_3455
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3454));
																																																																		BgL_cdrzd27557zd2_3456
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd27551zd2_3454));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27556zd2_3455))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd27557zd2_3456))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd27564zd2_3459;
																																																																						BgL_carzd27564zd2_3459
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd27557zd2_3456);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27564zd2_3459))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd27557zd2_3456)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test8518z00_16688;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1377z00_3492;
																																																																											BgL_l1377z00_3492
																																																																												=
																																																																												BgL_cdrzd27539zd2_3450;
																																																																										BgL_zc3z04anonymousza33029ze3z87_3493:
																																																																											if (NULLP(BgL_l1377z00_3492))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8518z00_16688
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8520z00_16691;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test8521z00_16692;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_tmpz00_16693;
																																																																															BgL_tmpz00_16693
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1377z00_3492));
																																																																															BgL_test8521z00_16692
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_16693);
																																																																														}
																																																																														if (BgL_test8521z00_16692)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8520z00_16691
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8520z00_16691
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_test8520z00_16691)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1377z00_16697;
																																																																															BgL_l1377z00_16697
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1377z00_3492));
																																																																															BgL_l1377z00_3492
																																																																																=
																																																																																BgL_l1377z00_16697;
																																																																															goto
																																																																																BgL_zc3z04anonymousza33029ze3z87_3493;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test8518z00_16688
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_test8518z00_16688)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg3017z00_3475;
																																																																												BgL_arg3017z00_3475
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd27545zd2_3451));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16702;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_16706;
																																																																														obj_t
																																																																															BgL_proc2z00_16705;
																																																																														obj_t
																																																																															BgL_proc1z00_16704;
																																																																														obj_t
																																																																															BgL_testz00_16703;
																																																																														BgL_testz00_16703
																																																																															=
																																																																															BgL_arg3017z00_3475;
																																																																														BgL_proc1z00_16704
																																																																															=
																																																																															BgL_carzd27556zd2_3455;
																																																																														BgL_proc2z00_16705
																																																																															=
																																																																															BgL_carzd27564zd2_3459;
																																																																														BgL_argsz00_16706
																																																																															=
																																																																															BgL_cdrzd27539zd2_3450;
																																																																														BgL_argsz00_1779
																																																																															=
																																																																															BgL_argsz00_16706;
																																																																														BgL_proc2z00_1778
																																																																															=
																																																																															BgL_proc2z00_16705;
																																																																														BgL_proc1z00_1777
																																																																															=
																																																																															BgL_proc1z00_16704;
																																																																														BgL_testz00_1776
																																																																															=
																																																																															BgL_testz00_16703;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1780;
																																																																													}
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16702);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd27588zd2_3476;
																																																																												BgL_cdrzd27588zd2_3476
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd27595zd2_3477;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10550;
																																																																														BgL_pairz00_10550
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd27595zd2_3477
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_10550);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd27602zd2_3478;
																																																																														BgL_cdrzd27602zd2_3478
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd27595zd2_3477));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd27608zd2_3479;
																																																																															BgL_carzd27608zd2_3479
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd27602zd2_3478));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27608zd2_3479))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd27615zd2_3481;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_10554;
																																																																																		BgL_pairz00_10554
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd27602zd2_3478));
																																																																																		BgL_carzd27615zd2_3481
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_10554);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27615zd2_3481))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27588zd2_3476))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg3021z00_3484;
																																																																																					BgL_arg3021z00_3484
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd27595zd2_3477));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_16728;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_16732;
																																																																																							obj_t
																																																																																								BgL_proc2z00_16731;
																																																																																							obj_t
																																																																																								BgL_proc1z00_16730;
																																																																																							obj_t
																																																																																								BgL_testz00_16729;
																																																																																							BgL_testz00_16729
																																																																																								=
																																																																																								BgL_arg3021z00_3484;
																																																																																							BgL_proc1z00_16730
																																																																																								=
																																																																																								BgL_carzd27608zd2_3479;
																																																																																							BgL_proc2z00_16731
																																																																																								=
																																																																																								BgL_carzd27615zd2_3481;
																																																																																							BgL_argsz00_16732
																																																																																								=
																																																																																								BgL_cdrzd27588zd2_3476;
																																																																																							BgL_argsz00_1784
																																																																																								=
																																																																																								BgL_argsz00_16732;
																																																																																							BgL_proc2z00_1783
																																																																																								=
																																																																																								BgL_proc2z00_16731;
																																																																																							BgL_proc1z00_1782
																																																																																								=
																																																																																								BgL_proc1z00_16730;
																																																																																							BgL_testz00_1781
																																																																																								=
																																																																																								BgL_testz00_16729;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1785;
																																																																																						}
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_16728);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_16736;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_16736);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16740;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16740);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16744;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16744);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_16748;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_14300
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_16748);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd27891zd2_3503;
																																																																								BgL_cdrzd27891zd2_3503
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd27897zd2_3504;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10558;
																																																																										BgL_pairz00_10558
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd27897zd2_3504
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10558);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd27903zd2_3505;
																																																																										BgL_cdrzd27903zd2_3505
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd27897zd2_3504));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd27908zd2_3506;
																																																																											obj_t
																																																																												BgL_cdrzd27909zd2_3507;
																																																																											BgL_carzd27908zd2_3506
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3505));
																																																																											BgL_cdrzd27909zd2_3507
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd27903zd2_3505));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27908zd2_3506))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd27914zd2_3509;
																																																																													BgL_carzd27914zd2_3509
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd27909zd2_3507));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd27914zd2_3509))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd27909zd2_3507))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd27891zd2_3503))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg3039z00_3514;
																																																																																			BgL_arg3039z00_3514
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd27897zd2_3504));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_16775;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_16779;
																																																																																					obj_t
																																																																																						BgL_proc2z00_16778;
																																																																																					obj_t
																																																																																						BgL_proc1z00_16777;
																																																																																					obj_t
																																																																																						BgL_testz00_16776;
																																																																																					BgL_testz00_16776
																																																																																						=
																																																																																						BgL_arg3039z00_3514;
																																																																																					BgL_proc1z00_16777
																																																																																						=
																																																																																						BgL_carzd27908zd2_3506;
																																																																																					BgL_proc2z00_16778
																																																																																						=
																																																																																						BgL_carzd27914zd2_3509;
																																																																																					BgL_argsz00_16779
																																																																																						=
																																																																																						BgL_cdrzd27891zd2_3503;
																																																																																					BgL_argsz00_1784
																																																																																						=
																																																																																						BgL_argsz00_16779;
																																																																																					BgL_proc2z00_1783
																																																																																						=
																																																																																						BgL_proc2z00_16778;
																																																																																					BgL_proc1z00_1782
																																																																																						=
																																																																																						BgL_proc1z00_16777;
																																																																																					BgL_testz00_1781
																																																																																						=
																																																																																						BgL_testz00_16776;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1785;
																																																																																				}
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_16775);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_16783;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_16783);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16787;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16787);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16791;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16791);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16795;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16795);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_16799;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_14300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_16799);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd28247zd2_3522;
																																																																				BgL_cdrzd28247zd2_3522
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd28254zd2_3523;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_10568;
																																																																						BgL_pairz00_10568
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd28254zd2_3523
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10568);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd28261zd2_3524;
																																																																						BgL_cdrzd28261zd2_3524
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd28254zd2_3523));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd28267zd2_3525;
																																																																							obj_t
																																																																								BgL_cdrzd28268zd2_3526;
																																																																							BgL_carzd28267zd2_3525
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3524));
																																																																							BgL_cdrzd28268zd2_3526
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd28261zd2_3524));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28267zd2_3525))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd28268zd2_3526))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd28275zd2_3529;
																																																																											BgL_carzd28275zd2_3529
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd28268zd2_3526);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd28275zd2_3529))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd28268zd2_3526)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd28247zd2_3522))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3057z00_3534;
																																																																																	BgL_arg3057z00_3534
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd28254zd2_3523));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_16826;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_16830;
																																																																																			obj_t
																																																																																				BgL_proc2z00_16829;
																																																																																			obj_t
																																																																																				BgL_proc1z00_16828;
																																																																																			obj_t
																																																																																				BgL_testz00_16827;
																																																																																			BgL_testz00_16827
																																																																																				=
																																																																																				BgL_arg3057z00_3534;
																																																																																			BgL_proc1z00_16828
																																																																																				=
																																																																																				BgL_carzd28267zd2_3525;
																																																																																			BgL_proc2z00_16829
																																																																																				=
																																																																																				BgL_carzd28275zd2_3529;
																																																																																			BgL_argsz00_16830
																																																																																				=
																																																																																				BgL_cdrzd28247zd2_3522;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_16830;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_16829;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_16828;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_16827;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_16826);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_16834;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_16834);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_16838;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_16838);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_16842;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_16842);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_16846;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_16846);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_16850;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_16850);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16854;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16854);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd28668zd2_3548;
																																																				BgL_cdrzd28668zd2_3548
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8549z00_16858;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3102z00_3565;
																																																						BgL_arg3102z00_3565
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8549z00_16858
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3102z00_3565));
																																																					}
																																																					if (BgL_test8549z00_16858)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3079z00_3551;
																																																							obj_t
																																																								BgL_arg3080z00_3552;
																																																							BgL_arg3079z00_3551
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3548));
																																																							BgL_arg3080z00_3552
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd28668zd2_3548));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_16867;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_16869;
																																																									obj_t
																																																										BgL_bindingsz00_16868;
																																																									BgL_bindingsz00_16868
																																																										=
																																																										BgL_arg3079z00_3551;
																																																									BgL_exprz00_16869
																																																										=
																																																										BgL_arg3080z00_3552;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_16869;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_16868;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_14300
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_16867);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8550z00_16871;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3101z00_3564;
																																																								BgL_arg3101z00_3564
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8550z00_16871
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3101z00_3564));
																																																							}
																																																							if (BgL_test8550z00_16871)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_16876;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16876);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd28734zd2_3555;
																																																									BgL_carzd28734zd2_3555
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd28739zd2_3556;
																																																										BgL_cdrzd28739zd2_3556
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd28734zd2_3555));
																																																										if ((CAR(((obj_t) BgL_carzd28734zd2_3555)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg3095z00_3559;
																																																												obj_t
																																																													BgL_arg3097z00_3560;
																																																												obj_t
																																																													BgL_arg3098z00_3561;
																																																												BgL_arg3095z00_3559
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3556));
																																																												BgL_arg3097z00_3560
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd28739zd2_3556));
																																																												BgL_arg3098z00_3561
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_16893;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_16896;
																																																														obj_t
																																																															BgL_bodyz00_16895;
																																																														obj_t
																																																															BgL_varsz00_16894;
																																																														BgL_varsz00_16894
																																																															=
																																																															BgL_arg3095z00_3559;
																																																														BgL_bodyz00_16895
																																																															=
																																																															BgL_arg3097z00_3560;
																																																														BgL_argsz00_16896
																																																															=
																																																															BgL_arg3098z00_3561;
																																																														BgL_argsz00_1774
																																																															=
																																																															BgL_argsz00_16896;
																																																														BgL_bodyz00_1773
																																																															=
																																																															BgL_bodyz00_16895;
																																																														BgL_varsz00_1772
																																																															=
																																																															BgL_varsz00_16894;
																																																														goto
																																																															BgL_tagzd2386zd2_1775;
																																																													}
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16893);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_16900;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_14300
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_16900);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd28850zd2_3566;
																																																		BgL_cdrzd28850zd2_3566
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8553z00_16904;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3113z00_3575;
																																																				BgL_arg3113z00_3575
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8553z00_16904
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3113z00_3575));
																																																			}
																																																			if (BgL_test8553z00_16904)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3106z00_3569;
																																																					obj_t
																																																						BgL_arg3107z00_3570;
																																																					BgL_arg3106z00_3569
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3566));
																																																					BgL_arg3107z00_3570
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd28850zd2_3566));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_16913;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_16915;
																																																							obj_t
																																																								BgL_bindingsz00_16914;
																																																							BgL_bindingsz00_16914
																																																								=
																																																								BgL_arg3106z00_3569;
																																																							BgL_exprz00_16915
																																																								=
																																																								BgL_arg3107z00_3570;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_16915;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_16914;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_14300
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_16913);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8554z00_16917;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3111z00_3574;
																																																						BgL_arg3111z00_3574
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8554z00_16917
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3111z00_3574));
																																																					}
																																																					if (BgL_test8554z00_16917)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_16922;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_16922);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1809;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_16926;
																																																									goto
																																																										BgL_tagzd2404zd2_1810;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_16926);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27415zd2_3302)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd27417zd2_3304;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd27415zd2_3302 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd27417zd2_3304;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd27415zd2_3302 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd27417zd2_3304;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd27415zd2_3302)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd27417zd2_3304;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd29022zd2_3310;
																																																								BgL_cdrzd29022zd2_3310
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8560z00_16942;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg2964z00_3427;
																																																										BgL_arg2964z00_3427
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8560z00_16942
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg2964z00_3427));
																																																									}
																																																									if (BgL_test8560z00_16942)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg2867z00_3313;
																																																											obj_t
																																																												BgL_arg2868z00_3314;
																																																											BgL_arg2867z00_3313
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3310));
																																																											BgL_arg2868z00_3314
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd29022zd2_3310));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_16951;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_16953;
																																																													obj_t
																																																														BgL_bindingsz00_16952;
																																																													BgL_bindingsz00_16952
																																																														=
																																																														BgL_arg2867z00_3313;
																																																													BgL_exprz00_16953
																																																														=
																																																														BgL_arg2868z00_3314;
																																																													BgL_exprz00_1764
																																																														=
																																																														BgL_exprz00_16953;
																																																													BgL_bindingsz00_1763
																																																														=
																																																														BgL_bindingsz00_16952;
																																																													goto
																																																														BgL_tagzd2382zd2_1765;
																																																												}
																																																												BgL_auxz00_14300
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_16951);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test8561z00_16955;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg2963z00_3426;
																																																												BgL_arg2963z00_3426
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test8561z00_16955
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg2963z00_3426));
																																																											}
																																																											if (BgL_test8561z00_16955)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_16960;
																																																													goto
																																																														BgL_tagzd2384zd2_1767;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_16960);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd29088zd2_3317;
																																																													BgL_carzd29088zd2_3317
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd29093zd2_3318;
																																																														BgL_cdrzd29093zd2_3318
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd29088zd2_3317));
																																																														if ((CAR(((obj_t) BgL_carzd29088zd2_3317)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd29093zd2_3318))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg2876z00_3322;
																																																																		obj_t
																																																																			BgL_arg2877z00_3323;
																																																																		obj_t
																																																																			BgL_arg2878z00_3324;
																																																																		BgL_arg2876z00_3322
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd29093zd2_3318);
																																																																		BgL_arg2877z00_3323
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd29093zd2_3318);
																																																																		BgL_arg2878z00_3324
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_16977;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_16980;
																																																																				obj_t
																																																																					BgL_bodyz00_16979;
																																																																				obj_t
																																																																					BgL_varsz00_16978;
																																																																				BgL_varsz00_16978
																																																																					=
																																																																					BgL_arg2876z00_3322;
																																																																				BgL_bodyz00_16979
																																																																					=
																																																																					BgL_arg2877z00_3323;
																																																																				BgL_argsz00_16980
																																																																					=
																																																																					BgL_arg2878z00_3324;
																																																																				BgL_argsz00_1774
																																																																					=
																																																																					BgL_argsz00_16980;
																																																																				BgL_bodyz00_1773
																																																																					=
																																																																					BgL_bodyz00_16979;
																																																																				BgL_varsz00_1772
																																																																					=
																																																																					BgL_varsz00_16978;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1775;
																																																																			}
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_16977);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_16984;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_14300
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_16984);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd29200zd2_3327;
																																																																BgL_cdrzd29200zd2_3327
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd29205zd2_3328;
																																																																	BgL_cdrzd29205zd2_3328
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd29088zd2_3317));
																																																																	if ((CAR(((obj_t) BgL_carzd29088zd2_3317)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd29205zd2_3328))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd29210zd2_3332;
																																																																					BgL_cdrzd29210zd2_3332
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd29205zd2_3328);
																																																																					if (PAIRP(BgL_cdrzd29210zd2_3332))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd29214zd2_3334;
																																																																							obj_t
																																																																								BgL_cdrzd29215zd2_3335;
																																																																							BgL_carzd29214zd2_3334
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd29210zd2_3332);
																																																																							BgL_cdrzd29215zd2_3335
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd29210zd2_3332);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29214zd2_3334))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd29215zd2_3335))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd29220zd2_3338;
																																																																											BgL_carzd29220zd2_3338
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd29215zd2_3335);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29220zd2_3338))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd29215zd2_3335)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8572z00_17012;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1380z00_3371;
																																																																																BgL_l1380z00_3371
																																																																																	=
																																																																																	BgL_cdrzd29200zd2_3327;
																																																																															BgL_zc3z04anonymousza32923ze3z87_3372:
																																																																																if (NULLP(BgL_l1380z00_3371))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8572z00_17012
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test8574z00_17015;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test8575z00_17016;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_17017;
																																																																																				BgL_tmpz00_17017
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1380z00_3371));
																																																																																				BgL_test8575z00_17016
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_17017);
																																																																																			}
																																																																																			if (BgL_test8575z00_17016)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test8574z00_17015
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test8574z00_17015
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_test8574z00_17015)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1380z00_17021;
																																																																																				BgL_l1380z00_17021
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1380z00_3371));
																																																																																				BgL_l1380z00_3371
																																																																																					=
																																																																																					BgL_l1380z00_17021;
																																																																																				goto
																																																																																					BgL_zc3z04anonymousza32923ze3z87_3372;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test8572z00_17012
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_test8572z00_17012)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg2911z00_3354;
																																																																																	BgL_arg2911z00_3354
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd29205zd2_3328);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17025;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_17029;
																																																																																			obj_t
																																																																																				BgL_proc2z00_17028;
																																																																																			obj_t
																																																																																				BgL_proc1z00_17027;
																																																																																			obj_t
																																																																																				BgL_testz00_17026;
																																																																																			BgL_testz00_17026
																																																																																				=
																																																																																				BgL_arg2911z00_3354;
																																																																																			BgL_proc1z00_17027
																																																																																				=
																																																																																				BgL_carzd29214zd2_3334;
																																																																																			BgL_proc2z00_17028
																																																																																				=
																																																																																				BgL_carzd29220zd2_3338;
																																																																																			BgL_argsz00_17029
																																																																																				=
																																																																																				BgL_cdrzd29200zd2_3327;
																																																																																			BgL_argsz00_1779
																																																																																				=
																																																																																				BgL_argsz00_17029;
																																																																																			BgL_proc2z00_1778
																																																																																				=
																																																																																				BgL_proc2z00_17028;
																																																																																			BgL_proc1z00_1777
																																																																																				=
																																																																																				BgL_proc1z00_17027;
																																																																																			BgL_testz00_1776
																																																																																				=
																																																																																				BgL_testz00_17026;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1780;
																																																																																		}
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17025);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd29245zd2_3355;
																																																																																	BgL_cdrzd29245zd2_3355
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd29253zd2_3356;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_10625;
																																																																																			BgL_pairz00_10625
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd29253zd2_3356
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_10625);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd29261zd2_3357;
																																																																																			BgL_cdrzd29261zd2_3357
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd29253zd2_3356));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd29268zd2_3358;
																																																																																				BgL_carzd29268zd2_3358
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd29261zd2_3357));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29268zd2_3358))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd29277zd2_3360;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_10629;
																																																																																							BgL_pairz00_10629
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd29261zd2_3357));
																																																																																							BgL_carzd29277zd2_3360
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_10629);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29277zd2_3360))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29245zd2_3355))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg2917z00_3363;
																																																																																										BgL_arg2917z00_3363
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd29253zd2_3356));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_17051;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_17055;
																																																																																												obj_t
																																																																																													BgL_proc2z00_17054;
																																																																																												obj_t
																																																																																													BgL_proc1z00_17053;
																																																																																												obj_t
																																																																																													BgL_testz00_17052;
																																																																																												BgL_testz00_17052
																																																																																													=
																																																																																													BgL_arg2917z00_3363;
																																																																																												BgL_proc1z00_17053
																																																																																													=
																																																																																													BgL_carzd29268zd2_3358;
																																																																																												BgL_proc2z00_17054
																																																																																													=
																																																																																													BgL_carzd29277zd2_3360;
																																																																																												BgL_argsz00_17055
																																																																																													=
																																																																																													BgL_cdrzd29245zd2_3355;
																																																																																												BgL_argsz00_1784
																																																																																													=
																																																																																													BgL_argsz00_17055;
																																																																																												BgL_proc2z00_1783
																																																																																													=
																																																																																													BgL_proc2z00_17054;
																																																																																												BgL_proc1z00_1782
																																																																																													=
																																																																																													BgL_proc1z00_17053;
																																																																																												BgL_testz00_1781
																																																																																													=
																																																																																													BgL_testz00_17052;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1785;
																																																																																											}
																																																																																											BgL_auxz00_14300
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_17051);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_17059;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_14300
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_17059);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17063;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17063);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17067;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17067);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17071;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17071);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd29555zd2_3382;
																																																																													BgL_cdrzd29555zd2_3382
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd29562zd2_3383;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10633;
																																																																															BgL_pairz00_10633
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd29562zd2_3383
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10633);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd29569zd2_3384;
																																																																															BgL_cdrzd29569zd2_3384
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd29562zd2_3383));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd29575zd2_3385;
																																																																																obj_t
																																																																																	BgL_cdrzd29576zd2_3386;
																																																																																BgL_carzd29575zd2_3385
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3384));
																																																																																BgL_cdrzd29576zd2_3386
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd29569zd2_3384));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29575zd2_3385))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd29583zd2_3388;
																																																																																		BgL_carzd29583zd2_3388
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd29576zd2_3386));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29583zd2_3388))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd29576zd2_3386))))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29555zd2_3382))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg2933z00_3393;
																																																																																								BgL_arg2933z00_3393
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd29562zd2_3383));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_17098;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_17102;
																																																																																										obj_t
																																																																																											BgL_proc2z00_17101;
																																																																																										obj_t
																																																																																											BgL_proc1z00_17100;
																																																																																										obj_t
																																																																																											BgL_testz00_17099;
																																																																																										BgL_testz00_17099
																																																																																											=
																																																																																											BgL_arg2933z00_3393;
																																																																																										BgL_proc1z00_17100
																																																																																											=
																																																																																											BgL_carzd29575zd2_3385;
																																																																																										BgL_proc2z00_17101
																																																																																											=
																																																																																											BgL_carzd29583zd2_3388;
																																																																																										BgL_argsz00_17102
																																																																																											=
																																																																																											BgL_cdrzd29555zd2_3382;
																																																																																										BgL_argsz00_1784
																																																																																											=
																																																																																											BgL_argsz00_17102;
																																																																																										BgL_proc2z00_1783
																																																																																											=
																																																																																											BgL_proc2z00_17101;
																																																																																										BgL_proc1z00_1782
																																																																																											=
																																																																																											BgL_proc1z00_17100;
																																																																																										BgL_testz00_1781
																																																																																											=
																																																																																											BgL_testz00_17099;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1785;
																																																																																									}
																																																																																									BgL_auxz00_14300
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_17098);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17106;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17106);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17110;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17110);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17114;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17114);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17118;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17118);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17122;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17122);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd29916zd2_3401;
																																																																									BgL_cdrzd29916zd2_3401
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd29922zd2_3402;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_10643;
																																																																											BgL_pairz00_10643
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd29922zd2_3402
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_10643);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd29928zd2_3403;
																																																																											BgL_cdrzd29928zd2_3403
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd29922zd2_3402));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd29933zd2_3404;
																																																																												obj_t
																																																																													BgL_cdrzd29934zd2_3405;
																																																																												BgL_carzd29933zd2_3404
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3403));
																																																																												BgL_cdrzd29934zd2_3405
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd29928zd2_3403));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29933zd2_3404))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd29934zd2_3405))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd29939zd2_3408;
																																																																																BgL_carzd29939zd2_3408
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd29934zd2_3405);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd29939zd2_3408))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(BgL_cdrzd29934zd2_3405)))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd29916zd2_3401))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg2948z00_3413;
																																																																																						BgL_arg2948z00_3413
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd29922zd2_3402));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17149;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17153;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17152;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17151;
																																																																																								obj_t
																																																																																									BgL_testz00_17150;
																																																																																								BgL_testz00_17150
																																																																																									=
																																																																																									BgL_arg2948z00_3413;
																																																																																								BgL_proc1z00_17151
																																																																																									=
																																																																																									BgL_carzd29933zd2_3404;
																																																																																								BgL_proc2z00_17152
																																																																																									=
																																																																																									BgL_carzd29939zd2_3408;
																																																																																								BgL_argsz00_17153
																																																																																									=
																																																																																									BgL_cdrzd29916zd2_3401;
																																																																																								BgL_argsz00_1784
																																																																																									=
																																																																																									BgL_argsz00_17153;
																																																																																								BgL_proc2z00_1783
																																																																																									=
																																																																																									BgL_proc2z00_17152;
																																																																																								BgL_proc1z00_1782
																																																																																									=
																																																																																									BgL_proc1z00_17151;
																																																																																								BgL_testz00_1781
																																																																																									=
																																																																																									BgL_testz00_17150;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1785;
																																																																																							}
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17149);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17157;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17157);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17161;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17161);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17165;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17165);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17169;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17169);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17173;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17173);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17177;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17177);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17181;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17181);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_17185;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_17185);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd210477zd2_3577;
																																													BgL_cdrzd210477zd2_3577
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd27412zd2_3300 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3116z00_3579;
																																															obj_t
																																																BgL_arg3117z00_3580;
																																															BgL_arg3116z00_3579
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3577));
																																															BgL_arg3117z00_3580
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210477zd2_3577));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_17196;
																																																{
																																																	obj_t
																																																		BgL_exprz00_17198;
																																																	obj_t
																																																		BgL_bindingsz00_17197;
																																																	BgL_bindingsz00_17197
																																																		=
																																																		BgL_arg3116z00_3579;
																																																	BgL_exprz00_17198
																																																		=
																																																		BgL_arg3117z00_3580;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_17198;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_17197;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_14300
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_17196);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd27412zd2_3300)))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3119z00_3582;
																																																	obj_t
																																																		BgL_arg3120z00_3583;
																																																	BgL_arg3119z00_3582
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3577));
																																																	BgL_arg3120z00_3583
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210477zd2_3577));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_17207;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_17209;
																																																			obj_t
																																																				BgL_bindingsz00_17208;
																																																			BgL_bindingsz00_17208
																																																				=
																																																				BgL_arg3119z00_3582;
																																																			BgL_exprz00_17209
																																																				=
																																																				BgL_arg3120z00_3583;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_17209;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_17208;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_14300
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_17207);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((BgL_carzd27412zd2_3300 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3123z00_3585;
																																																			obj_t
																																																				BgL_arg3127z00_3586;
																																																			BgL_arg3123z00_3585
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3577));
																																																			BgL_arg3127z00_3586
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd210477zd2_3577));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17218;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17220;
																																																					obj_t
																																																						BgL_bindingsz00_17219;
																																																					BgL_bindingsz00_17219
																																																						=
																																																						BgL_arg3123z00_3585;
																																																					BgL_exprz00_17220
																																																						=
																																																						BgL_arg3127z00_3586;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_17220;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_17219;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_14300
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17218);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17227;
																																																					goto
																																																						BgL_tagzd2383zd2_1766;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17227);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd210514zd2_3589;
																																																					BgL_carzd210514zd2_3589
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd210514zd2_3589 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17234;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17234);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210514zd2_3589)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17239;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17239);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17246;
																																																											goto
																																																												BgL_tagzd2389zd2_1786;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17246);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_17253;
																																																													goto
																																																														BgL_tagzd2390zd2_1787;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_17253);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd210594zd2_3596;
																																																													BgL_cdrzd210594zd2_3596
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg3139z00_3599;
																																																															obj_t
																																																																BgL_arg3140z00_3600;
																																																															BgL_arg3139z00_3599
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3596));
																																																															BgL_arg3140z00_3600
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210594zd2_3596));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_17266;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_17268;
																																																																	obj_t
																																																																		BgL_effectz00_17267;
																																																																	BgL_effectz00_17267
																																																																		=
																																																																		BgL_arg3139z00_3599;
																																																																	BgL_restz00_17268
																																																																		=
																																																																		BgL_arg3140z00_3600;
																																																																	BgL_restz00_1789
																																																																		=
																																																																		BgL_restz00_17268;
																																																																	BgL_effectz00_1788
																																																																		=
																																																																		BgL_effectz00_17267;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1790;
																																																																}
																																																																BgL_auxz00_14300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_17266);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17275;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1791;
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17275);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_17282;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1792;
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_17282);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg3154z00_3608;
																																																																					obj_t
																																																																						BgL_arg3157z00_3609;
																																																																					BgL_arg3154z00_3608
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3596));
																																																																					BgL_arg3157z00_3609
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd210594zd2_3596));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_17293;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_17295;
																																																																							obj_t
																																																																								BgL_effectz00_17294;
																																																																							BgL_effectz00_17294
																																																																								=
																																																																								BgL_arg3154z00_3608;
																																																																							BgL_restz00_17295
																																																																								=
																																																																								BgL_arg3157z00_3609;
																																																																							BgL_restz00_1794
																																																																								=
																																																																								BgL_restz00_17295;
																																																																							BgL_effectz00_1793
																																																																								=
																																																																								BgL_effectz00_17294;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1795;
																																																																						}
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_17293);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_17302;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1796;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_17302);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17309;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1797;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17309);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_17316;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1798;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17316);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_17323;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1799;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17323);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd210671zd2_3618;
																																																																													BgL_cdrzd210671zd2_3618
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3171z00_3621;
																																																																															obj_t
																																																																																BgL_arg3172z00_3622;
																																																																															BgL_arg3171z00_3621
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3618));
																																																																															BgL_arg3172z00_3622
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd210671zd2_3618));
																																																																															{	/* Ast/sexp.scm 555 */
																																																																																obj_t
																																																																																	BgL_arg7015z00_10682;
																																																																																BgL_arg7015z00_10682
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3171z00_3621,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3172z00_3622, BgL_stackz00_22, BgL_arg7015z00_10682, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17342;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17342);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd210696zd2_3639;
																																	BgL_carzd210696zd2_3639
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd210696zd2_3639
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_17349;
																																			goto
																																				BgL_tagzd2377zd2_1754;
																																			BgL_auxz00_14300
																																				=
																																				((obj_t)
																																				BgL_auxz00_17349);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd210696zd2_3639
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_17353;
																																					goto
																																						BgL_tagzd2377zd2_1754;
																																					BgL_auxz00_14300
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_17353);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_cdrzd210718zd2_3642;
																																					BgL_cdrzd210718zd2_3642
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd210721zd2_3645;
																																							obj_t
																																								BgL_cdrzd210722zd2_3646;
																																							BgL_carzd210721zd2_3645
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3642));
																																							BgL_cdrzd210722zd2_3646
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd210718zd2_3642));
																																							if (PAIRP(BgL_carzd210721zd2_3645))
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(BgL_carzd210721zd2_3645) == CNST_TABLE_REF(((long) 14))))
																																										{	/* Ast/sexp.scm 119 */
																																											if (NULLP(CDR(((obj_t) BgL_cdrzd210722zd2_3646))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3211z00_3652;
																																													obj_t
																																														BgL_arg3212z00_3653;
																																													BgL_arg3211z00_3652
																																														=
																																														CDR
																																														(BgL_carzd210721zd2_3645);
																																													BgL_arg3212z00_3653
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210722zd2_3646));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_17379;
																																														BgL_lz00_1755
																																															=
																																															BgL_arg3211z00_3652;
																																														BgL_valz00_1756
																																															=
																																															BgL_arg3212z00_3653;
																																													BgL_tagzd2378zd2_1757:
																																														{	/* Ast/sexp.scm 289 */
																																															bool_t
																																																BgL_test8629z00_17380;
																																															if (PAIRP(BgL_lz00_1755))
																																																{	/* Ast/sexp.scm 289 */
																																																	bool_t
																																																		BgL_test8631z00_17383;
																																																	{	/* Ast/sexp.scm 289 */
																																																		obj_t
																																																			BgL_tmpz00_17384;
																																																		BgL_tmpz00_17384
																																																			=
																																																			CDR
																																																			(BgL_lz00_1755);
																																																		BgL_test8631z00_17383
																																																			=
																																																			PAIRP
																																																			(BgL_tmpz00_17384);
																																																	}
																																																	if (BgL_test8631z00_17383)
																																																		{
																																																			obj_t
																																																				BgL_l1349z00_8613;
																																																			BgL_l1349z00_8613
																																																				=
																																																				BgL_lz00_1755;
																																																		BgL_zc3z04anonymousza36768ze3z87_8614:
																																																			if (NULLP(BgL_l1349z00_8613))
																																																				{	/* Ast/sexp.scm 289 */
																																																					BgL_test8629z00_17380
																																																						=
																																																						(
																																																						(bool_t)
																																																						1);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 289 */
																																																					bool_t
																																																						BgL_test8633z00_17389;
																																																					{	/* Ast/sexp.scm 289 */
																																																						obj_t
																																																							BgL_tmpz00_17390;
																																																						BgL_tmpz00_17390
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_l1349z00_8613));
																																																						BgL_test8633z00_17389
																																																							=
																																																							SYMBOLP
																																																							(BgL_tmpz00_17390);
																																																					}
																																																					if (BgL_test8633z00_17389)
																																																						{
																																																							obj_t
																																																								BgL_l1349z00_17394;
																																																							BgL_l1349z00_17394
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_l1349z00_8613));
																																																							BgL_l1349z00_8613
																																																								=
																																																								BgL_l1349z00_17394;
																																																							goto
																																																								BgL_zc3z04anonymousza36768ze3z87_8614;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 289 */
																																																							BgL_test8629z00_17380
																																																								=
																																																								(
																																																								(bool_t)
																																																								0);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 289 */
																																																			BgL_test8629z00_17380
																																																				=
																																																				(
																																																				(bool_t)
																																																				0);
																																																		}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 289 */
																																																	BgL_test8629z00_17380
																																																		=
																																																		(
																																																		(bool_t)
																																																		0);
																																																}
																																															if (BgL_test8629z00_17380)
																																																{	/* Ast/sexp.scm 289 */
																																																	BgL_auxz00_17379
																																																		=
																																																		BGl_fieldzd2setzd2ze3nodeze3zzast_objectz00
																																																		(BgL_lz00_1755,
																																																		BgL_valz00_1756,
																																																		BgL_expz00_21,
																																																		BgL_stackz00_22,
																																																		BgL_locz00_23,
																																																		BgL_sitez00_24);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 291 */
																																																	BgL_nodez00_bglt
																																																		BgL_res7418z00_9849;
																																																	{	/* Ast/sexp.scm 726 */
																																																		obj_t
																																																			BgL_arg7130z00_9845;
																																																		BgL_nodez00_bglt
																																																			BgL_arg7131z00_9846;
																																																		BgL_arg7130z00_9845
																																																			=
																																																			BGl_shapez00zztools_shapez00
																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																			());
																																																		BgL_arg7131z00_9846
																																																			=
																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																			(CNST_TABLE_REF
																																																			(((long) 4)), BNIL, BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																																																		{	/* Ast/sexp.scm 725 */
																																																			obj_t
																																																				BgL_list7132z00_9848;
																																																			BgL_list7132z00_9848
																																																				=
																																																				MAKE_YOUNG_PAIR
																																																				(
																																																				((obj_t) BgL_arg7131z00_9846), BNIL);
																																																			BgL_res7418z00_9849
																																																				=
																																																				(
																																																				(BgL_nodez00_bglt)
																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																				(BgL_locz00_23,
																																																					BgL_arg7130z00_9845,
																																																					BGl_string8056z00zzast_sexpz00,
																																																					BgL_expz00_21,
																																																					BgL_list7132z00_9848));
																																																	}}
																																																	BgL_auxz00_17379
																																																		=
																																																		BgL_res7418z00_9849;
																																														}}
																																														BgL_auxz00_14300
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_17379);
																																												}}
																																											else
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_17408;
																																													goto
																																														BgL_tagzd2379zd2_1758;
																																													BgL_auxz00_14300
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_17408);
																																												}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_17410;
																																											goto
																																												BgL_tagzd2379zd2_1758;
																																											BgL_auxz00_14300
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_17410);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17412;
																																									goto
																																										BgL_tagzd2379zd2_1758;
																																									BgL_auxz00_14300
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17412);
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_17419;
																																									goto
																																										BgL_tagzd2380zd2_1759;
																																									BgL_auxz00_14300
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_17419);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd210819zd2_3658;
																																									BgL_carzd210819zd2_3658
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd210819zd2_3658))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd210822zd2_3660;
																																											obj_t
																																												BgL_cdrzd210823zd2_3661;
																																											BgL_carzd210822zd2_3660
																																												=
																																												CAR
																																												(BgL_carzd210819zd2_3658);
																																											BgL_cdrzd210823zd2_3661
																																												=
																																												CDR
																																												(BgL_carzd210819zd2_3658);
																																											{

																																												if ((BgL_carzd210822zd2_3660 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 119 */
																																													BgL_kapzd210824zd2_3662:
																																														if (PAIRP(BgL_cdrzd210823zd2_3661))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd210827zd2_3787;
																																																BgL_cdrzd210827zd2_3787
																																																	=
																																																	CDR
																																																	(BgL_cdrzd210823zd2_3661);
																																																if (PAIRP(BgL_cdrzd210827zd2_3787))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd210827zd2_3787)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3331z00_3791;
																																																				obj_t
																																																					BgL_arg3332z00_3792;
																																																				BgL_arg3331z00_3791
																																																					=
																																																					CAR
																																																					(BgL_cdrzd210827zd2_3787);
																																																				BgL_arg3332z00_3792
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_17441;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_17443;
																																																						obj_t
																																																							BgL_bodyz00_17442;
																																																						BgL_bodyz00_17442
																																																							=
																																																							BgL_arg3331z00_3791;
																																																						BgL_argsz00_17443
																																																							=
																																																							BgL_arg3332z00_3792;
																																																						BgL_argsz00_1761
																																																							=
																																																							BgL_argsz00_17443;
																																																						BgL_bodyz00_1760
																																																							=
																																																							BgL_bodyz00_17442;
																																																						goto
																																																							BgL_tagzd2381zd2_1762;
																																																					}
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17441);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd210851zd2_3793;
																																																				BgL_cdrzd210851zd2_3793
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8640z00_17447;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3417z00_3904;
																																																						BgL_arg3417z00_3904
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8640z00_17447
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3417z00_3904));
																																																					}
																																																					if (BgL_test8640z00_17447)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3335z00_3796;
																																																							obj_t
																																																								BgL_arg3336z00_3797;
																																																							BgL_arg3335z00_3796
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3793));
																																																							BgL_arg3336z00_3797
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd210851zd2_3793));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_17456;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_17458;
																																																									obj_t
																																																										BgL_bindingsz00_17457;
																																																									BgL_bindingsz00_17457
																																																										=
																																																										BgL_arg3335z00_3796;
																																																									BgL_exprz00_17458
																																																										=
																																																										BgL_arg3336z00_3797;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_17458;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_17457;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_14300
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_17456);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8641z00_17460;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3416z00_3903;
																																																								BgL_arg3416z00_3903
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8641z00_17460
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3416z00_3903));
																																																							}
																																																							if (BgL_test8641z00_17460)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_17465;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_17465);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd210918zd2_3800;
																																																									BgL_carzd210918zd2_3800
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd210923zd2_3801;
																																																										BgL_cdrzd210923zd2_3801
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd210918zd2_3800));
																																																										if ((CAR(((obj_t) BgL_carzd210918zd2_3800)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg3348z00_3804;
																																																												obj_t
																																																													BgL_arg3349z00_3805;
																																																												obj_t
																																																													BgL_arg3350z00_3806;
																																																												BgL_arg3348z00_3804
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3801));
																																																												BgL_arg3349z00_3805
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd210923zd2_3801));
																																																												BgL_arg3350z00_3806
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_17482;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_17485;
																																																														obj_t
																																																															BgL_bodyz00_17484;
																																																														obj_t
																																																															BgL_varsz00_17483;
																																																														BgL_varsz00_17483
																																																															=
																																																															BgL_arg3348z00_3804;
																																																														BgL_bodyz00_17484
																																																															=
																																																															BgL_arg3349z00_3805;
																																																														BgL_argsz00_17485
																																																															=
																																																															BgL_arg3350z00_3806;
																																																														BgL_argsz00_1774
																																																															=
																																																															BgL_argsz00_17485;
																																																														BgL_bodyz00_1773
																																																															=
																																																															BgL_bodyz00_17484;
																																																														BgL_varsz00_1772
																																																															=
																																																															BgL_varsz00_17483;
																																																														goto
																																																															BgL_tagzd2386zd2_1775;
																																																													}
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_17482);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd210946zd2_3808;
																																																												BgL_cdrzd210946zd2_3808
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd210952zd2_3809;
																																																													BgL_cdrzd210952zd2_3809
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd210918zd2_3800));
																																																													if ((CAR(((obj_t) BgL_carzd210918zd2_3800)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd210958zd2_3812;
																																																															BgL_cdrzd210958zd2_3812
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd210952zd2_3809));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd210963zd2_3813;
																																																																obj_t
																																																																	BgL_cdrzd210964zd2_3814;
																																																																BgL_carzd210963zd2_3813
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3812));
																																																																BgL_cdrzd210964zd2_3814
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd210958zd2_3812));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210963zd2_3813))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd210964zd2_3814))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd210971zd2_3817;
																																																																				BgL_carzd210971zd2_3817
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd210964zd2_3814);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd210971zd2_3817))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd210964zd2_3814)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8648z00_17512;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1383z00_3850;
																																																																									BgL_l1383z00_3850
																																																																										=
																																																																										BgL_cdrzd210946zd2_3808;
																																																																								BgL_zc3z04anonymousza33381ze3z87_3851:
																																																																									if (NULLP(BgL_l1383z00_3850))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8648z00_17512
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8650z00_17515;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8651z00_17516;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_17517;
																																																																													BgL_tmpz00_17517
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1383z00_3850));
																																																																													BgL_test8651z00_17516
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_17517);
																																																																												}
																																																																												if (BgL_test8651z00_17516)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8650z00_17515
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8650z00_17515
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test8650z00_17515)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1383z00_17521;
																																																																													BgL_l1383z00_17521
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1383z00_3850));
																																																																													BgL_l1383z00_3850
																																																																														=
																																																																														BgL_l1383z00_17521;
																																																																													goto
																																																																														BgL_zc3z04anonymousza33381ze3z87_3851;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8648z00_17512
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test8648z00_17512)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg3370z00_3833;
																																																																										BgL_arg3370z00_3833
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd210952zd2_3809));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17526;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_17530;
																																																																												obj_t
																																																																													BgL_proc2z00_17529;
																																																																												obj_t
																																																																													BgL_proc1z00_17528;
																																																																												obj_t
																																																																													BgL_testz00_17527;
																																																																												BgL_testz00_17527
																																																																													=
																																																																													BgL_arg3370z00_3833;
																																																																												BgL_proc1z00_17528
																																																																													=
																																																																													BgL_carzd210963zd2_3813;
																																																																												BgL_proc2z00_17529
																																																																													=
																																																																													BgL_carzd210971zd2_3817;
																																																																												BgL_argsz00_17530
																																																																													=
																																																																													BgL_cdrzd210946zd2_3808;
																																																																												BgL_argsz00_1779
																																																																													=
																																																																													BgL_argsz00_17530;
																																																																												BgL_proc2z00_1778
																																																																													=
																																																																													BgL_proc2z00_17529;
																																																																												BgL_proc1z00_1777
																																																																													=
																																																																													BgL_proc1z00_17528;
																																																																												BgL_testz00_1776
																																																																													=
																																																																													BgL_testz00_17527;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1780;
																																																																											}
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17526);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd210995zd2_3834;
																																																																										BgL_cdrzd210995zd2_3834
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd211002zd2_3835;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_10735;
																																																																												BgL_pairz00_10735
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd211002zd2_3835
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_10735);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd211009zd2_3836;
																																																																												BgL_cdrzd211009zd2_3836
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd211002zd2_3835));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd211015zd2_3837;
																																																																													BgL_carzd211015zd2_3837
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd211009zd2_3836));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211015zd2_3837))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd211022zd2_3839;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10739;
																																																																																BgL_pairz00_10739
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd211009zd2_3836));
																																																																																BgL_carzd211022zd2_3839
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_10739);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211022zd2_3839))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd210995zd2_3834))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg3374z00_3842;
																																																																																			BgL_arg3374z00_3842
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd211002zd2_3835));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17552;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_17556;
																																																																																					obj_t
																																																																																						BgL_proc2z00_17555;
																																																																																					obj_t
																																																																																						BgL_proc1z00_17554;
																																																																																					obj_t
																																																																																						BgL_testz00_17553;
																																																																																					BgL_testz00_17553
																																																																																						=
																																																																																						BgL_arg3374z00_3842;
																																																																																					BgL_proc1z00_17554
																																																																																						=
																																																																																						BgL_carzd211015zd2_3837;
																																																																																					BgL_proc2z00_17555
																																																																																						=
																																																																																						BgL_carzd211022zd2_3839;
																																																																																					BgL_argsz00_17556
																																																																																						=
																																																																																						BgL_cdrzd210995zd2_3834;
																																																																																					BgL_argsz00_1784
																																																																																						=
																																																																																						BgL_argsz00_17556;
																																																																																					BgL_proc2z00_1783
																																																																																						=
																																																																																						BgL_proc2z00_17555;
																																																																																					BgL_proc1z00_1782
																																																																																						=
																																																																																						BgL_proc1z00_17554;
																																																																																					BgL_testz00_1781
																																																																																						=
																																																																																						BgL_testz00_17553;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1785;
																																																																																				}
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17552);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17560;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17560);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17564;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17564);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17568;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17568);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_17572;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_14300
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_17572);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd211298zd2_3861;
																																																																						BgL_cdrzd211298zd2_3861
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd211304zd2_3862;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_10743;
																																																																								BgL_pairz00_10743
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd211304zd2_3862
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_10743);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd211310zd2_3863;
																																																																								BgL_cdrzd211310zd2_3863
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd211304zd2_3862));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd211315zd2_3864;
																																																																									obj_t
																																																																										BgL_cdrzd211316zd2_3865;
																																																																									BgL_carzd211315zd2_3864
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3863));
																																																																									BgL_cdrzd211316zd2_3865
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd211310zd2_3863));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211315zd2_3864))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd211321zd2_3867;
																																																																											BgL_carzd211321zd2_3867
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd211316zd2_3865));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211321zd2_3867))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd211316zd2_3865))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211298zd2_3861))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3390z00_3872;
																																																																																	BgL_arg3390z00_3872
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd211304zd2_3862));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17599;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_17603;
																																																																																			obj_t
																																																																																				BgL_proc2z00_17602;
																																																																																			obj_t
																																																																																				BgL_proc1z00_17601;
																																																																																			obj_t
																																																																																				BgL_testz00_17600;
																																																																																			BgL_testz00_17600
																																																																																				=
																																																																																				BgL_arg3390z00_3872;
																																																																																			BgL_proc1z00_17601
																																																																																				=
																																																																																				BgL_carzd211315zd2_3864;
																																																																																			BgL_proc2z00_17602
																																																																																				=
																																																																																				BgL_carzd211321zd2_3867;
																																																																																			BgL_argsz00_17603
																																																																																				=
																																																																																				BgL_cdrzd211298zd2_3861;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_17603;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_17602;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_17601;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_17600;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17599);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_17607;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_17607);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17611;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17611);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17615;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17615);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17619;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17619);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_17623;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_17623);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd211654zd2_3880;
																																																																		BgL_cdrzd211654zd2_3880
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd211661zd2_3881;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_10753;
																																																																				BgL_pairz00_10753
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd211661zd2_3881
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_10753);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd211668zd2_3882;
																																																																				BgL_cdrzd211668zd2_3882
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd211661zd2_3881));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd211674zd2_3883;
																																																																					obj_t
																																																																						BgL_cdrzd211675zd2_3884;
																																																																					BgL_carzd211674zd2_3883
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3882));
																																																																					BgL_cdrzd211675zd2_3884
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd211668zd2_3882));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211674zd2_3883))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd211675zd2_3884))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd211682zd2_3887;
																																																																									BgL_carzd211682zd2_3887
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd211675zd2_3884);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd211682zd2_3887))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd211675zd2_3884)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd211654zd2_3880))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3404z00_3892;
																																																																															BgL_arg3404z00_3892
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd211661zd2_3881));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17650;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17654;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17653;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17652;
																																																																																	obj_t
																																																																																		BgL_testz00_17651;
																																																																																	BgL_testz00_17651
																																																																																		=
																																																																																		BgL_arg3404z00_3892;
																																																																																	BgL_proc1z00_17652
																																																																																		=
																																																																																		BgL_carzd211674zd2_3883;
																																																																																	BgL_proc2z00_17653
																																																																																		=
																																																																																		BgL_carzd211682zd2_3887;
																																																																																	BgL_argsz00_17654
																																																																																		=
																																																																																		BgL_cdrzd211654zd2_3880;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_17654;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_17653;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_17652;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_17651;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17650);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_17658;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_17658);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17662;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17662);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_17666;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_17666);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17670;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17670);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_17674;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_17674);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17678;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17678);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd212075zd2_3906;
																																																		BgL_cdrzd212075zd2_3906
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8679z00_17682;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3434z00_3923;
																																																				BgL_arg3434z00_3923
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8679z00_17682
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3434z00_3923));
																																																			}
																																																			if (BgL_test8679z00_17682)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3421z00_3909;
																																																					obj_t
																																																						BgL_arg3422z00_3910;
																																																					BgL_arg3421z00_3909
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3906));
																																																					BgL_arg3422z00_3910
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd212075zd2_3906));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_17691;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_17693;
																																																							obj_t
																																																								BgL_bindingsz00_17692;
																																																							BgL_bindingsz00_17692
																																																								=
																																																								BgL_arg3421z00_3909;
																																																							BgL_exprz00_17693
																																																								=
																																																								BgL_arg3422z00_3910;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_17693;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_17692;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_14300
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_17691);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8680z00_17695;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3433z00_3922;
																																																						BgL_arg3433z00_3922
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8680z00_17695
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3433z00_3922));
																																																					}
																																																					if (BgL_test8680z00_17695)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_17700;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17700);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd212141zd2_3913;
																																																							BgL_carzd212141zd2_3913
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd212146zd2_3914;
																																																								BgL_cdrzd212146zd2_3914
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd212141zd2_3913));
																																																								if ((CAR(((obj_t) BgL_carzd212141zd2_3913)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3427z00_3917;
																																																										obj_t
																																																											BgL_arg3428z00_3918;
																																																										obj_t
																																																											BgL_arg3429z00_3919;
																																																										BgL_arg3427z00_3917
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3914));
																																																										BgL_arg3428z00_3918
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd212146zd2_3914));
																																																										BgL_arg3429z00_3919
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_17717;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_17720;
																																																												obj_t
																																																													BgL_bodyz00_17719;
																																																												obj_t
																																																													BgL_varsz00_17718;
																																																												BgL_varsz00_17718
																																																													=
																																																													BgL_arg3427z00_3917;
																																																												BgL_bodyz00_17719
																																																													=
																																																													BgL_arg3428z00_3918;
																																																												BgL_argsz00_17720
																																																													=
																																																													BgL_arg3429z00_3919;
																																																												BgL_argsz00_1774
																																																													=
																																																													BgL_argsz00_17720;
																																																												BgL_bodyz00_1773
																																																													=
																																																													BgL_bodyz00_17719;
																																																												BgL_varsz00_1772
																																																													=
																																																													BgL_varsz00_17718;
																																																												goto
																																																													BgL_tagzd2386zd2_1775;
																																																											}
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17717);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1809;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_17724;
																																																												goto
																																																													BgL_tagzd2404zd2_1810;
																																																												BgL_auxz00_14300
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_17724);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd212257zd2_3924;
																																																BgL_cdrzd212257zd2_3924
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8683z00_17728;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3445z00_3933;
																																																		BgL_arg3445z00_3933
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8683z00_17728
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3445z00_3933));
																																																	}
																																																	if (BgL_test8683z00_17728)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3439z00_3927;
																																																			obj_t
																																																				BgL_arg3440z00_3928;
																																																			BgL_arg3439z00_3927
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3924));
																																																			BgL_arg3440z00_3928
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd212257zd2_3924));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_17737;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_17739;
																																																					obj_t
																																																						BgL_bindingsz00_17738;
																																																					BgL_bindingsz00_17738
																																																						=
																																																						BgL_arg3439z00_3927;
																																																					BgL_exprz00_17739
																																																						=
																																																						BgL_arg3440z00_3928;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_17739;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_17738;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_14300
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_17737);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8684z00_17741;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3444z00_3932;
																																																				BgL_arg3444z00_3932
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8684z00_17741
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3444z00_3932));
																																																			}
																																																			if (BgL_test8684z00_17741)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_17746;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_17746);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1809;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_17750;
																																																							goto
																																																								BgL_tagzd2404zd2_1810;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_17750);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210822zd2_3660)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd210824zd2_3662;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd210822zd2_3660 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd210824zd2_3662;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd210822zd2_3660 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd210824zd2_3662;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd210822zd2_3660)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd210824zd2_3662;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd212429zd2_3668;
																																																						BgL_cdrzd212429zd2_3668
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8690z00_17766;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3324z00_3785;
																																																								BgL_arg3324z00_3785
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8690z00_17766
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg3324z00_3785));
																																																							}
																																																							if (BgL_test8690z00_17766)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg3234z00_3671;
																																																									obj_t
																																																										BgL_arg3235z00_3672;
																																																									BgL_arg3234z00_3671
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3668));
																																																									BgL_arg3235z00_3672
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd212429zd2_3668));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_17775;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_17777;
																																																											obj_t
																																																												BgL_bindingsz00_17776;
																																																											BgL_bindingsz00_17776
																																																												=
																																																												BgL_arg3234z00_3671;
																																																											BgL_exprz00_17777
																																																												=
																																																												BgL_arg3235z00_3672;
																																																											BgL_exprz00_1764
																																																												=
																																																												BgL_exprz00_17777;
																																																											BgL_bindingsz00_1763
																																																												=
																																																												BgL_bindingsz00_17776;
																																																											goto
																																																												BgL_tagzd2382zd2_1765;
																																																										}
																																																										BgL_auxz00_14300
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_17775);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test8691z00_17779;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3323z00_3784;
																																																										BgL_arg3323z00_3784
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test8691z00_17779
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg3323z00_3784));
																																																									}
																																																									if (BgL_test8691z00_17779)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_17784;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_17784);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd212495zd2_3675;
																																																											BgL_carzd212495zd2_3675
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd212500zd2_3676;
																																																												BgL_cdrzd212500zd2_3676
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd212495zd2_3675));
																																																												if ((CAR(((obj_t) BgL_carzd212495zd2_3675)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd212500zd2_3676))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg3242z00_3680;
																																																																obj_t
																																																																	BgL_arg3243z00_3681;
																																																																obj_t
																																																																	BgL_arg3244z00_3682;
																																																																BgL_arg3242z00_3680
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd212500zd2_3676);
																																																																BgL_arg3243z00_3681
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd212500zd2_3676);
																																																																BgL_arg3244z00_3682
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_17801;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_17804;
																																																																		obj_t
																																																																			BgL_bodyz00_17803;
																																																																		obj_t
																																																																			BgL_varsz00_17802;
																																																																		BgL_varsz00_17802
																																																																			=
																																																																			BgL_arg3242z00_3680;
																																																																		BgL_bodyz00_17803
																																																																			=
																																																																			BgL_arg3243z00_3681;
																																																																		BgL_argsz00_17804
																																																																			=
																																																																			BgL_arg3244z00_3682;
																																																																		BgL_argsz00_1774
																																																																			=
																																																																			BgL_argsz00_17804;
																																																																		BgL_bodyz00_1773
																																																																			=
																																																																			BgL_bodyz00_17803;
																																																																		BgL_varsz00_1772
																																																																			=
																																																																			BgL_varsz00_17802;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1775;
																																																																	}
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_17801);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_17808;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_17808);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd212607zd2_3685;
																																																														BgL_cdrzd212607zd2_3685
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd212612zd2_3686;
																																																															BgL_cdrzd212612zd2_3686
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd212495zd2_3675));
																																																															if ((CAR(((obj_t) BgL_carzd212495zd2_3675)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd212612zd2_3686))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd212617zd2_3690;
																																																																			BgL_cdrzd212617zd2_3690
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd212612zd2_3686);
																																																																			if (PAIRP(BgL_cdrzd212617zd2_3690))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd212621zd2_3692;
																																																																					obj_t
																																																																						BgL_cdrzd212622zd2_3693;
																																																																					BgL_carzd212621zd2_3692
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd212617zd2_3690);
																																																																					BgL_cdrzd212622zd2_3693
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd212617zd2_3690);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212621zd2_3692))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd212622zd2_3693))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd212627zd2_3696;
																																																																									BgL_carzd212627zd2_3696
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd212622zd2_3693);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212627zd2_3696))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd212622zd2_3693)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8702z00_17836;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1386z00_3729;
																																																																														BgL_l1386z00_3729
																																																																															=
																																																																															BgL_cdrzd212607zd2_3685;
																																																																													BgL_zc3z04anonymousza33280ze3z87_3730:
																																																																														if (NULLP(BgL_l1386z00_3729))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8702z00_17836
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test8704z00_17839;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test8705z00_17840;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_17841;
																																																																																		BgL_tmpz00_17841
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1386z00_3729));
																																																																																		BgL_test8705z00_17840
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_17841);
																																																																																	}
																																																																																	if (BgL_test8705z00_17840)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test8704z00_17839
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test8704z00_17839
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_test8704z00_17839)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1386z00_17845;
																																																																																		BgL_l1386z00_17845
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1386z00_3729));
																																																																																		BgL_l1386z00_3729
																																																																																			=
																																																																																			BgL_l1386z00_17845;
																																																																																		goto
																																																																																			BgL_zc3z04anonymousza33280ze3z87_3730;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test8702z00_17836
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_test8702z00_17836)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3268z00_3712;
																																																																															BgL_arg3268z00_3712
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd212612zd2_3686);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17849;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_17853;
																																																																																	obj_t
																																																																																		BgL_proc2z00_17852;
																																																																																	obj_t
																																																																																		BgL_proc1z00_17851;
																																																																																	obj_t
																																																																																		BgL_testz00_17850;
																																																																																	BgL_testz00_17850
																																																																																		=
																																																																																		BgL_arg3268z00_3712;
																																																																																	BgL_proc1z00_17851
																																																																																		=
																																																																																		BgL_carzd212621zd2_3692;
																																																																																	BgL_proc2z00_17852
																																																																																		=
																																																																																		BgL_carzd212627zd2_3696;
																																																																																	BgL_argsz00_17853
																																																																																		=
																																																																																		BgL_cdrzd212607zd2_3685;
																																																																																	BgL_argsz00_1779
																																																																																		=
																																																																																		BgL_argsz00_17853;
																																																																																	BgL_proc2z00_1778
																																																																																		=
																																																																																		BgL_proc2z00_17852;
																																																																																	BgL_proc1z00_1777
																																																																																		=
																																																																																		BgL_proc1z00_17851;
																																																																																	BgL_testz00_1776
																																																																																		=
																																																																																		BgL_testz00_17850;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1780;
																																																																																}
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17849);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd212652zd2_3713;
																																																																															BgL_cdrzd212652zd2_3713
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd212660zd2_3714;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_10810;
																																																																																	BgL_pairz00_10810
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd212660zd2_3714
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_10810);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd212668zd2_3715;
																																																																																	BgL_cdrzd212668zd2_3715
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd212660zd2_3714));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd212675zd2_3716;
																																																																																		BgL_carzd212675zd2_3716
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd212668zd2_3715));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212675zd2_3716))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd212684zd2_3718;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_10814;
																																																																																					BgL_pairz00_10814
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd212668zd2_3715));
																																																																																					BgL_carzd212684zd2_3718
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_10814);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212684zd2_3718))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212652zd2_3713))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg3273z00_3721;
																																																																																								BgL_arg3273z00_3721
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd212660zd2_3714));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_17875;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_17879;
																																																																																										obj_t
																																																																																											BgL_proc2z00_17878;
																																																																																										obj_t
																																																																																											BgL_proc1z00_17877;
																																																																																										obj_t
																																																																																											BgL_testz00_17876;
																																																																																										BgL_testz00_17876
																																																																																											=
																																																																																											BgL_arg3273z00_3721;
																																																																																										BgL_proc1z00_17877
																																																																																											=
																																																																																											BgL_carzd212675zd2_3716;
																																																																																										BgL_proc2z00_17878
																																																																																											=
																																																																																											BgL_carzd212684zd2_3718;
																																																																																										BgL_argsz00_17879
																																																																																											=
																																																																																											BgL_cdrzd212652zd2_3713;
																																																																																										BgL_argsz00_1784
																																																																																											=
																																																																																											BgL_argsz00_17879;
																																																																																										BgL_proc2z00_1783
																																																																																											=
																																																																																											BgL_proc2z00_17878;
																																																																																										BgL_proc1z00_1782
																																																																																											=
																																																																																											BgL_proc1z00_17877;
																																																																																										BgL_testz00_1781
																																																																																											=
																																																																																											BgL_testz00_17876;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1785;
																																																																																									}
																																																																																									BgL_auxz00_14300
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_17875);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_17883;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_14300
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_17883);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17887;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17887);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17891;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17891);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_17895;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_17895);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd212962zd2_3740;
																																																																											BgL_cdrzd212962zd2_3740
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd212969zd2_3741;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_10818;
																																																																													BgL_pairz00_10818
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd212969zd2_3741
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_10818);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd212976zd2_3742;
																																																																													BgL_cdrzd212976zd2_3742
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd212969zd2_3741));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd212982zd2_3743;
																																																																														obj_t
																																																																															BgL_cdrzd212983zd2_3744;
																																																																														BgL_carzd212982zd2_3743
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3742));
																																																																														BgL_cdrzd212983zd2_3744
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd212976zd2_3742));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212982zd2_3743))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd212990zd2_3746;
																																																																																BgL_carzd212990zd2_3746
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd212983zd2_3744));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd212990zd2_3746))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd212983zd2_3744))))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd212962zd2_3740))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg3295z00_3751;
																																																																																						BgL_arg3295z00_3751
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd212969zd2_3741));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_17922;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_17926;
																																																																																								obj_t
																																																																																									BgL_proc2z00_17925;
																																																																																								obj_t
																																																																																									BgL_proc1z00_17924;
																																																																																								obj_t
																																																																																									BgL_testz00_17923;
																																																																																								BgL_testz00_17923
																																																																																									=
																																																																																									BgL_arg3295z00_3751;
																																																																																								BgL_proc1z00_17924
																																																																																									=
																																																																																									BgL_carzd212982zd2_3743;
																																																																																								BgL_proc2z00_17925
																																																																																									=
																																																																																									BgL_carzd212990zd2_3746;
																																																																																								BgL_argsz00_17926
																																																																																									=
																																																																																									BgL_cdrzd212962zd2_3740;
																																																																																								BgL_argsz00_1784
																																																																																									=
																																																																																									BgL_argsz00_17926;
																																																																																								BgL_proc2z00_1783
																																																																																									=
																																																																																									BgL_proc2z00_17925;
																																																																																								BgL_proc1z00_1782
																																																																																									=
																																																																																									BgL_proc1z00_17924;
																																																																																								BgL_testz00_1781
																																																																																									=
																																																																																									BgL_testz00_17923;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1785;
																																																																																							}
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_17922);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_17930;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_17930);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17934;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17934);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17938;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17938);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17942;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17942);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_17946;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_17946);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd213323zd2_3759;
																																																																							BgL_cdrzd213323zd2_3759
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd213329zd2_3760;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_10828;
																																																																									BgL_pairz00_10828
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd213329zd2_3760
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_10828);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd213335zd2_3761;
																																																																									BgL_cdrzd213335zd2_3761
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd213329zd2_3760));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd213340zd2_3762;
																																																																										obj_t
																																																																											BgL_cdrzd213341zd2_3763;
																																																																										BgL_carzd213340zd2_3762
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3761));
																																																																										BgL_cdrzd213341zd2_3763
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd213335zd2_3761));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213340zd2_3762))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (PAIRP(BgL_cdrzd213341zd2_3763))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd213346zd2_3766;
																																																																														BgL_carzd213346zd2_3766
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd213341zd2_3763);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd213346zd2_3766))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(BgL_cdrzd213341zd2_3763)))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd213323zd2_3759))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg3309z00_3771;
																																																																																				BgL_arg3309z00_3771
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd213329zd2_3760));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_17973;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_17977;
																																																																																						obj_t
																																																																																							BgL_proc2z00_17976;
																																																																																						obj_t
																																																																																							BgL_proc1z00_17975;
																																																																																						obj_t
																																																																																							BgL_testz00_17974;
																																																																																						BgL_testz00_17974
																																																																																							=
																																																																																							BgL_arg3309z00_3771;
																																																																																						BgL_proc1z00_17975
																																																																																							=
																																																																																							BgL_carzd213340zd2_3762;
																																																																																						BgL_proc2z00_17976
																																																																																							=
																																																																																							BgL_carzd213346zd2_3766;
																																																																																						BgL_argsz00_17977
																																																																																							=
																																																																																							BgL_cdrzd213323zd2_3759;
																																																																																						BgL_argsz00_1784
																																																																																							=
																																																																																							BgL_argsz00_17977;
																																																																																						BgL_proc2z00_1783
																																																																																							=
																																																																																							BgL_proc2z00_17976;
																																																																																						BgL_proc1z00_1782
																																																																																							=
																																																																																							BgL_proc1z00_17975;
																																																																																						BgL_testz00_1781
																																																																																							=
																																																																																							BgL_testz00_17974;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1785;
																																																																																					}
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_17973);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_17981;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_17981);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_17985;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_17985);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_17989;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_17989);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_17993;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_17993);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_17997;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_14300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_17997);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18001;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18001);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18005;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18005);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18009;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18009);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd210819zd2_3658 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3447z00_3937;
																																													obj_t
																																														BgL_arg3448z00_3938;
																																													BgL_arg3447z00_3937
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3642));
																																													BgL_arg3448z00_3938
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd210718zd2_3642));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_18018;
																																														{
																																															obj_t
																																																BgL_exprz00_18020;
																																															obj_t
																																																BgL_bindingsz00_18019;
																																															BgL_bindingsz00_18019
																																																=
																																																BgL_arg3447z00_3937;
																																															BgL_exprz00_18020
																																																=
																																																BgL_arg3448z00_3938;
																																															BgL_exprz00_1764
																																																=
																																																BgL_exprz00_18020;
																																															BgL_bindingsz00_1763
																																																=
																																																BgL_bindingsz00_18019;
																																															goto
																																																BgL_tagzd2382zd2_1765;
																																														}
																																														BgL_auxz00_14300
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_18018);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd210819zd2_3658)))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3450z00_3940;
																																															obj_t
																																																BgL_arg3452z00_3941;
																																															BgL_arg3450z00_3940
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3642));
																																															BgL_arg3452z00_3941
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd210718zd2_3642));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_18029;
																																																{
																																																	obj_t
																																																		BgL_exprz00_18031;
																																																	obj_t
																																																		BgL_bindingsz00_18030;
																																																	BgL_bindingsz00_18030
																																																		=
																																																		BgL_arg3450z00_3940;
																																																	BgL_exprz00_18031
																																																		=
																																																		BgL_arg3452z00_3941;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_18031;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_18030;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_14300
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_18029);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((BgL_carzd210819zd2_3658 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3454z00_3943;
																																																	obj_t
																																																		BgL_arg3455z00_3944;
																																																	BgL_arg3454z00_3943
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3642));
																																																	BgL_arg3455z00_3944
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd210718zd2_3642));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_18040;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_18042;
																																																			obj_t
																																																				BgL_bindingsz00_18041;
																																																			BgL_bindingsz00_18041
																																																				=
																																																				BgL_arg3454z00_3943;
																																																			BgL_exprz00_18042
																																																				=
																																																				BgL_arg3455z00_3944;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_18042;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_18041;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_14300
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_18040);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_18049;
																																																			goto
																																																				BgL_tagzd2383zd2_1766;
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18049);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd213921zd2_3947;
																																																			BgL_carzd213921zd2_3947
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd213921zd2_3947 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18056;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18056);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd213921zd2_3947)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_18061;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18061);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18068;
																																																									goto
																																																										BgL_tagzd2389zd2_1786;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18068);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_18075;
																																																											goto
																																																												BgL_tagzd2390zd2_1787;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_18075);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd214001zd2_3954;
																																																											BgL_cdrzd214001zd2_3954
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg3467z00_3957;
																																																													obj_t
																																																														BgL_arg3469z00_3958;
																																																													BgL_arg3467z00_3957
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3954));
																																																													BgL_arg3469z00_3958
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214001zd2_3954));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_18088;
																																																														{
																																																															obj_t
																																																																BgL_restz00_18090;
																																																															obj_t
																																																																BgL_effectz00_18089;
																																																															BgL_effectz00_18089
																																																																=
																																																																BgL_arg3467z00_3957;
																																																															BgL_restz00_18090
																																																																=
																																																																BgL_arg3469z00_3958;
																																																															BgL_restz00_1789
																																																																=
																																																																BgL_restz00_18090;
																																																															BgL_effectz00_1788
																																																																=
																																																																BgL_effectz00_18089;
																																																															goto
																																																																BgL_tagzd2391zd2_1790;
																																																														}
																																																														BgL_auxz00_14300
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_18088);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18097;
																																																															goto
																																																																BgL_tagzd2392zd2_1791;
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18097);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_18104;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1792;
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_18104);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg3477z00_3966;
																																																																			obj_t
																																																																				BgL_arg3479z00_3967;
																																																																			BgL_arg3477z00_3966
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3954));
																																																																			BgL_arg3479z00_3967
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd214001zd2_3954));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_18115;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_18117;
																																																																					obj_t
																																																																						BgL_effectz00_18116;
																																																																					BgL_effectz00_18116
																																																																						=
																																																																						BgL_arg3477z00_3966;
																																																																					BgL_restz00_18117
																																																																						=
																																																																						BgL_arg3479z00_3967;
																																																																					BgL_restz00_1794
																																																																						=
																																																																						BgL_restz00_18117;
																																																																					BgL_effectz00_1793
																																																																						=
																																																																						BgL_effectz00_18116;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1795;
																																																																				}
																																																																				BgL_auxz00_14300
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_18115);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18124;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1796;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18124);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18131;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1797;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18131);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_18138;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1798;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18138);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_18145;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1799;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18145);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test8752z00_18152;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_tmpz00_18153;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_10866;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_10865;
																																																																																BgL_pairz00_10865
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_pairz00_10866
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_10865);
																																																																															}
																																																																															BgL_tmpz00_18153
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_10866);
																																																																														}
																																																																														BgL_test8752z00_18152
																																																																															=
																																																																															NULLP
																																																																															(BgL_tmpz00_18153);
																																																																													}
																																																																													if (BgL_test8752z00_18152)
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18159;
																																																																														BgL_tagzd2399zd2_1800:
																																																																															BgL_auxz00_18159 = BGl_applycationzd2ze3nodez31zzast_applyz00(BgL_expz00_21, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24);
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18159);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18164;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18164);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd214094zd2_3986;
																																																																													BgL_cdrzd214094zd2_3986
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3503z00_3989;
																																																																															obj_t
																																																																																BgL_arg3504z00_3990;
																																																																															BgL_arg3503z00_3989
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_3986));
																																																																															BgL_arg3504z00_3990
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214094zd2_3986));
																																																																															{	/* Ast/sexp.scm 555 */
																																																																																obj_t
																																																																																	BgL_arg7015z00_10872;
																																																																																BgL_arg7015z00_10872
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg3503z00_3989,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg3504z00_3990, BgL_stackz00_22, BgL_arg7015z00_10872, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18183;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18183);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd214119zd2_4007;
																															BgL_carzd214119zd2_4007
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd214119zd2_4007
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_18190;
																																	goto
																																		BgL_tagzd2377zd2_1754;
																																	BgL_auxz00_14300
																																		=
																																		((obj_t)
																																		BgL_auxz00_18190);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(BgL_carzd214119zd2_4007
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_18194;
																																			goto
																																				BgL_tagzd2377zd2_1754;
																																			BgL_auxz00_14300
																																				=
																																				((obj_t)
																																				BgL_auxz00_18194);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_cdrzd214141zd2_4010;
																																			BgL_cdrzd214141zd2_4010
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd214144zd2_4013;
																																					obj_t
																																						BgL_cdrzd214145zd2_4014;
																																					BgL_carzd214144zd2_4013
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd214141zd2_4010));
																																					BgL_cdrzd214145zd2_4014
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd214141zd2_4010));
																																					if (PAIRP(BgL_carzd214144zd2_4013))
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_carzd214144zd2_4013) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 119 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd214145zd2_4014))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg3536z00_4020;
																																											obj_t
																																												BgL_arg3537z00_4021;
																																											BgL_arg3536z00_4020
																																												=
																																												CDR
																																												(BgL_carzd214144zd2_4013);
																																											BgL_arg3537z00_4021
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214145zd2_4014));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18220;
																																												{
																																													obj_t
																																														BgL_valz00_18222;
																																													obj_t
																																														BgL_lz00_18221;
																																													BgL_lz00_18221
																																														=
																																														BgL_arg3536z00_4020;
																																													BgL_valz00_18222
																																														=
																																														BgL_arg3537z00_4021;
																																													BgL_valz00_1756
																																														=
																																														BgL_valz00_18222;
																																													BgL_lz00_1755
																																														=
																																														BgL_lz00_18221;
																																													goto
																																														BgL_tagzd2378zd2_1757;
																																												}
																																												BgL_auxz00_14300
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18220);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_18224;
																																											goto
																																												BgL_tagzd2379zd2_1758;
																																											BgL_auxz00_14300
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_18224);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_18226;
																																									goto
																																										BgL_tagzd2379zd2_1758;
																																									BgL_auxz00_14300
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_18226);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_18228;
																																							goto
																																								BgL_tagzd2379zd2_1758;
																																							BgL_auxz00_14300
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_18228);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_18235;
																																							goto
																																								BgL_tagzd2380zd2_1759;
																																							BgL_auxz00_14300
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_18235);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd214242zd2_4026;
																																							BgL_carzd214242zd2_4026
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd214242zd2_4026))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd214245zd2_4028;
																																									obj_t
																																										BgL_cdrzd214246zd2_4029;
																																									BgL_carzd214245zd2_4028
																																										=
																																										CAR
																																										(BgL_carzd214242zd2_4026);
																																									BgL_cdrzd214246zd2_4029
																																										=
																																										CDR
																																										(BgL_carzd214242zd2_4026);
																																									{

																																										if ((BgL_carzd214245zd2_4028 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 119 */
																																											BgL_kapzd214247zd2_4030:
																																												if (PAIRP(BgL_cdrzd214246zd2_4029))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd214250zd2_4155;
																																														BgL_cdrzd214250zd2_4155
																																															=
																																															CDR
																																															(BgL_cdrzd214246zd2_4029);
																																														if (PAIRP(BgL_cdrzd214250zd2_4155))
																																															{	/* Ast/sexp.scm 119 */
																																																if (NULLP(CDR(BgL_cdrzd214250zd2_4155)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3634z00_4159;
																																																		obj_t
																																																			BgL_arg3635z00_4160;
																																																		BgL_arg3634z00_4159
																																																			=
																																																			CAR
																																																			(BgL_cdrzd214250zd2_4155);
																																																		BgL_arg3635z00_4160
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_18257;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_18259;
																																																				obj_t
																																																					BgL_bodyz00_18258;
																																																				BgL_bodyz00_18258
																																																					=
																																																					BgL_arg3634z00_4159;
																																																				BgL_argsz00_18259
																																																					=
																																																					BgL_arg3635z00_4160;
																																																				BgL_argsz00_1761
																																																					=
																																																					BgL_argsz00_18259;
																																																				BgL_bodyz00_1760
																																																					=
																																																					BgL_bodyz00_18258;
																																																				goto
																																																					BgL_tagzd2381zd2_1762;
																																																			}
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18257);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd214274zd2_4161;
																																																		BgL_cdrzd214274zd2_4161
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8768z00_18263;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3712z00_4272;
																																																				BgL_arg3712z00_4272
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8768z00_18263
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3712z00_4272));
																																																			}
																																																			if (BgL_test8768z00_18263)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3639z00_4164;
																																																					obj_t
																																																						BgL_arg3640z00_4165;
																																																					BgL_arg3639z00_4164
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4161));
																																																					BgL_arg3640z00_4165
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd214274zd2_4161));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_18272;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_18274;
																																																							obj_t
																																																								BgL_bindingsz00_18273;
																																																							BgL_bindingsz00_18273
																																																								=
																																																								BgL_arg3639z00_4164;
																																																							BgL_exprz00_18274
																																																								=
																																																								BgL_arg3640z00_4165;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_18274;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_18273;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_14300
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_18272);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8769z00_18276;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3711z00_4271;
																																																						BgL_arg3711z00_4271
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8769z00_18276
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3711z00_4271));
																																																					}
																																																					if (BgL_test8769z00_18276)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_18281;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18281);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd214341zd2_4168;
																																																							BgL_carzd214341zd2_4168
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd214346zd2_4169;
																																																								BgL_cdrzd214346zd2_4169
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd214341zd2_4168));
																																																								if ((CAR(((obj_t) BgL_carzd214341zd2_4168)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg3646z00_4172;
																																																										obj_t
																																																											BgL_arg3647z00_4173;
																																																										obj_t
																																																											BgL_arg3649z00_4174;
																																																										BgL_arg3646z00_4172
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4169));
																																																										BgL_arg3647z00_4173
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd214346zd2_4169));
																																																										BgL_arg3649z00_4174
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_18298;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_18301;
																																																												obj_t
																																																													BgL_bodyz00_18300;
																																																												obj_t
																																																													BgL_varsz00_18299;
																																																												BgL_varsz00_18299
																																																													=
																																																													BgL_arg3646z00_4172;
																																																												BgL_bodyz00_18300
																																																													=
																																																													BgL_arg3647z00_4173;
																																																												BgL_argsz00_18301
																																																													=
																																																													BgL_arg3649z00_4174;
																																																												BgL_argsz00_1774
																																																													=
																																																													BgL_argsz00_18301;
																																																												BgL_bodyz00_1773
																																																													=
																																																													BgL_bodyz00_18300;
																																																												BgL_varsz00_1772
																																																													=
																																																													BgL_varsz00_18299;
																																																												goto
																																																													BgL_tagzd2386zd2_1775;
																																																											}
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_18298);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd214369zd2_4176;
																																																										BgL_cdrzd214369zd2_4176
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd214375zd2_4177;
																																																											BgL_cdrzd214375zd2_4177
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd214341zd2_4168));
																																																											if ((CAR(((obj_t) BgL_carzd214341zd2_4168)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd214381zd2_4180;
																																																													BgL_cdrzd214381zd2_4180
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd214375zd2_4177));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd214386zd2_4181;
																																																														obj_t
																																																															BgL_cdrzd214387zd2_4182;
																																																														BgL_carzd214386zd2_4181
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4180));
																																																														BgL_cdrzd214387zd2_4182
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd214381zd2_4180));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214386zd2_4181))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd214387zd2_4182))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd214394zd2_4185;
																																																																		BgL_carzd214394zd2_4185
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd214387zd2_4182);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214394zd2_4185))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd214387zd2_4182)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test8776z00_18328;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1389z00_4218;
																																																																							BgL_l1389z00_4218
																																																																								=
																																																																								BgL_cdrzd214369zd2_4176;
																																																																						BgL_zc3z04anonymousza33673ze3z87_4219:
																																																																							if (NULLP(BgL_l1389z00_4218))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8776z00_18328
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test8778z00_18331;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test8779z00_18332;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_18333;
																																																																											BgL_tmpz00_18333
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1389z00_4218));
																																																																											BgL_test8779z00_18332
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_18333);
																																																																										}
																																																																										if (BgL_test8779z00_18332)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test8778z00_18331
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test8778z00_18331
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test8778z00_18331)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1389z00_18337;
																																																																											BgL_l1389z00_18337
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1389z00_4218));
																																																																											BgL_l1389z00_4218
																																																																												=
																																																																												BgL_l1389z00_18337;
																																																																											goto
																																																																												BgL_zc3z04anonymousza33673ze3z87_4219;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8776z00_18328
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test8776z00_18328)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg3662z00_4201;
																																																																								BgL_arg3662z00_4201
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd214375zd2_4177));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18342;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_18346;
																																																																										obj_t
																																																																											BgL_proc2z00_18345;
																																																																										obj_t
																																																																											BgL_proc1z00_18344;
																																																																										obj_t
																																																																											BgL_testz00_18343;
																																																																										BgL_testz00_18343
																																																																											=
																																																																											BgL_arg3662z00_4201;
																																																																										BgL_proc1z00_18344
																																																																											=
																																																																											BgL_carzd214386zd2_4181;
																																																																										BgL_proc2z00_18345
																																																																											=
																																																																											BgL_carzd214394zd2_4185;
																																																																										BgL_argsz00_18346
																																																																											=
																																																																											BgL_cdrzd214369zd2_4176;
																																																																										BgL_argsz00_1779
																																																																											=
																																																																											BgL_argsz00_18346;
																																																																										BgL_proc2z00_1778
																																																																											=
																																																																											BgL_proc2z00_18345;
																																																																										BgL_proc1z00_1777
																																																																											=
																																																																											BgL_proc1z00_18344;
																																																																										BgL_testz00_1776
																																																																											=
																																																																											BgL_testz00_18343;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1780;
																																																																									}
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18342);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd214418zd2_4202;
																																																																								BgL_cdrzd214418zd2_4202
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd214425zd2_4203;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_10925;
																																																																										BgL_pairz00_10925
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd214425zd2_4203
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_10925);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd214432zd2_4204;
																																																																										BgL_cdrzd214432zd2_4204
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd214425zd2_4203));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd214438zd2_4205;
																																																																											BgL_carzd214438zd2_4205
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd214432zd2_4204));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214438zd2_4205))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd214445zd2_4207;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_10929;
																																																																														BgL_pairz00_10929
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd214432zd2_4204));
																																																																														BgL_carzd214445zd2_4207
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_10929);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214445zd2_4207))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214418zd2_4202))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3666z00_4210;
																																																																																	BgL_arg3666z00_4210
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd214425zd2_4203));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18368;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_18372;
																																																																																			obj_t
																																																																																				BgL_proc2z00_18371;
																																																																																			obj_t
																																																																																				BgL_proc1z00_18370;
																																																																																			obj_t
																																																																																				BgL_testz00_18369;
																																																																																			BgL_testz00_18369
																																																																																				=
																																																																																				BgL_arg3666z00_4210;
																																																																																			BgL_proc1z00_18370
																																																																																				=
																																																																																				BgL_carzd214438zd2_4205;
																																																																																			BgL_proc2z00_18371
																																																																																				=
																																																																																				BgL_carzd214445zd2_4207;
																																																																																			BgL_argsz00_18372
																																																																																				=
																																																																																				BgL_cdrzd214418zd2_4202;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_18372;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_18371;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_18370;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_18369;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18368);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18376;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18376);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18380;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18380);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18384;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18384);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_18388;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_14300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_18388);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd214721zd2_4229;
																																																																				BgL_cdrzd214721zd2_4229
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd214727zd2_4230;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_10933;
																																																																						BgL_pairz00_10933
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd214727zd2_4230
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_10933);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd214733zd2_4231;
																																																																						BgL_cdrzd214733zd2_4231
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd214727zd2_4230));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd214738zd2_4232;
																																																																							obj_t
																																																																								BgL_cdrzd214739zd2_4233;
																																																																							BgL_carzd214738zd2_4232
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4231));
																																																																							BgL_cdrzd214739zd2_4233
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd214733zd2_4231));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214738zd2_4232))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd214744zd2_4235;
																																																																									BgL_carzd214744zd2_4235
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd214739zd2_4233));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd214744zd2_4235))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd214739zd2_4233))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd214721zd2_4229))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3683z00_4240;
																																																																															BgL_arg3683z00_4240
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd214727zd2_4230));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18415;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_18419;
																																																																																	obj_t
																																																																																		BgL_proc2z00_18418;
																																																																																	obj_t
																																																																																		BgL_proc1z00_18417;
																																																																																	obj_t
																																																																																		BgL_testz00_18416;
																																																																																	BgL_testz00_18416
																																																																																		=
																																																																																		BgL_arg3683z00_4240;
																																																																																	BgL_proc1z00_18417
																																																																																		=
																																																																																		BgL_carzd214738zd2_4232;
																																																																																	BgL_proc2z00_18418
																																																																																		=
																																																																																		BgL_carzd214744zd2_4235;
																																																																																	BgL_argsz00_18419
																																																																																		=
																																																																																		BgL_cdrzd214721zd2_4229;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_18419;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_18418;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_18417;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_18416;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18415);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_18423;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_18423);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18427;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18427);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18431;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18431);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18435;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18435);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_18439;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_14300
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_18439);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd215077zd2_4248;
																																																																BgL_cdrzd215077zd2_4248
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd215084zd2_4249;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_10943;
																																																																		BgL_pairz00_10943
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd215084zd2_4249
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_10943);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd215091zd2_4250;
																																																																		BgL_cdrzd215091zd2_4250
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd215084zd2_4249));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd215097zd2_4251;
																																																																			obj_t
																																																																				BgL_cdrzd215098zd2_4252;
																																																																			BgL_carzd215097zd2_4251
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4250));
																																																																			BgL_cdrzd215098zd2_4252
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd215091zd2_4250));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215097zd2_4251))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd215098zd2_4252))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd215105zd2_4255;
																																																																							BgL_carzd215105zd2_4255
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd215098zd2_4252);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd215105zd2_4255))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd215098zd2_4252)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd215077zd2_4248))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3698z00_4260;
																																																																													BgL_arg3698z00_4260
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd215084zd2_4249));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18466;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18470;
																																																																															obj_t
																																																																																BgL_proc2z00_18469;
																																																																															obj_t
																																																																																BgL_proc1z00_18468;
																																																																															obj_t
																																																																																BgL_testz00_18467;
																																																																															BgL_testz00_18467
																																																																																=
																																																																																BgL_arg3698z00_4260;
																																																																															BgL_proc1z00_18468
																																																																																=
																																																																																BgL_carzd215097zd2_4251;
																																																																															BgL_proc2z00_18469
																																																																																=
																																																																																BgL_carzd215105zd2_4255;
																																																																															BgL_argsz00_18470
																																																																																=
																																																																																BgL_cdrzd215077zd2_4248;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_18470;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_18469;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_18468;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_18467;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_14300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18466);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18474;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18474);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18478;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18478);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_18482;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_18482);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18486;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18486);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_18490;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18490);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18494;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18494);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd215498zd2_4274;
																																																BgL_cdrzd215498zd2_4274
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8807z00_18498;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3728z00_4291;
																																																		BgL_arg3728z00_4291
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8807z00_18498
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg3728z00_4291));
																																																	}
																																																	if (BgL_test8807z00_18498)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3716z00_4277;
																																																			obj_t
																																																				BgL_arg3717z00_4278;
																																																			BgL_arg3716z00_4277
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4274));
																																																			BgL_arg3717z00_4278
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd215498zd2_4274));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_18507;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_18509;
																																																					obj_t
																																																						BgL_bindingsz00_18508;
																																																					BgL_bindingsz00_18508
																																																						=
																																																						BgL_arg3716z00_4277;
																																																					BgL_exprz00_18509
																																																						=
																																																						BgL_arg3717z00_4278;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_18509;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_18508;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_14300
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_18507);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8808z00_18511;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3727z00_4290;
																																																				BgL_arg3727z00_4290
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8808z00_18511
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg3727z00_4290));
																																																			}
																																																			if (BgL_test8808z00_18511)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18516;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18516);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd215564zd2_4281;
																																																					BgL_carzd215564zd2_4281
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd215569zd2_4282;
																																																						BgL_cdrzd215569zd2_4282
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd215564zd2_4281));
																																																						if ((CAR(((obj_t) BgL_carzd215564zd2_4281)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3722z00_4285;
																																																								obj_t
																																																									BgL_arg3723z00_4286;
																																																								obj_t
																																																									BgL_arg3724z00_4287;
																																																								BgL_arg3722z00_4285
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4282));
																																																								BgL_arg3723z00_4286
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd215569zd2_4282));
																																																								BgL_arg3724z00_4287
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18533;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_18536;
																																																										obj_t
																																																											BgL_bodyz00_18535;
																																																										obj_t
																																																											BgL_varsz00_18534;
																																																										BgL_varsz00_18534
																																																											=
																																																											BgL_arg3722z00_4285;
																																																										BgL_bodyz00_18535
																																																											=
																																																											BgL_arg3723z00_4286;
																																																										BgL_argsz00_18536
																																																											=
																																																											BgL_arg3724z00_4287;
																																																										BgL_argsz00_1774
																																																											=
																																																											BgL_argsz00_18536;
																																																										BgL_bodyz00_1773
																																																											=
																																																											BgL_bodyz00_18535;
																																																										BgL_varsz00_1772
																																																											=
																																																											BgL_varsz00_18534;
																																																										goto
																																																											BgL_tagzd2386zd2_1775;
																																																									}
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18533);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1809;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_18540;
																																																										goto
																																																											BgL_tagzd2404zd2_1810;
																																																										BgL_auxz00_14300
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_18540);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd215680zd2_4292;
																																														BgL_cdrzd215680zd2_4292
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8811z00_18544;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg3737z00_4301;
																																																BgL_arg3737z00_4301
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8811z00_18544
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg3737z00_4301));
																																															}
																																															if (BgL_test8811z00_18544)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg3731z00_4295;
																																																	obj_t
																																																		BgL_arg3732z00_4296;
																																																	BgL_arg3731z00_4295
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4292));
																																																	BgL_arg3732z00_4296
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd215680zd2_4292));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_18553;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_18555;
																																																			obj_t
																																																				BgL_bindingsz00_18554;
																																																			BgL_bindingsz00_18554
																																																				=
																																																				BgL_arg3731z00_4295;
																																																			BgL_exprz00_18555
																																																				=
																																																				BgL_arg3732z00_4296;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_18555;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_18554;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_14300
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_18553);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8812z00_18557;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg3736z00_4300;
																																																		BgL_arg3736z00_4300
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8812z00_18557
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg3736z00_4300));
																																																	}
																																																	if (BgL_test8812z00_18557)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18562;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18562);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1809;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_18566;
																																																					goto
																																																						BgL_tagzd2404zd2_1810;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18566);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214245zd2_4028)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd214247zd2_4030;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd214245zd2_4028 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd214247zd2_4030;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd214245zd2_4028 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd214247zd2_4030;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd214245zd2_4028)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd214247zd2_4030;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd215852zd2_4036;
																																																				BgL_cdrzd215852zd2_4036
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8818z00_18582;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3629z00_4153;
																																																						BgL_arg3629z00_4153
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8818z00_18582
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg3629z00_4153));
																																																					}
																																																					if (BgL_test8818z00_18582)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg3550z00_4039;
																																																							obj_t
																																																								BgL_arg3551z00_4040;
																																																							BgL_arg3550z00_4039
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_4036));
																																																							BgL_arg3551z00_4040
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd215852zd2_4036));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_18591;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_18593;
																																																									obj_t
																																																										BgL_bindingsz00_18592;
																																																									BgL_bindingsz00_18592
																																																										=
																																																										BgL_arg3550z00_4039;
																																																									BgL_exprz00_18593
																																																										=
																																																										BgL_arg3551z00_4040;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_18593;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_18592;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_14300
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_18591);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test8819z00_18595;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3628z00_4152;
																																																								BgL_arg3628z00_4152
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test8819z00_18595
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg3628z00_4152));
																																																							}
																																																							if (BgL_test8819z00_18595)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_18600;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18600);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd215918zd2_4043;
																																																									BgL_carzd215918zd2_4043
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd215923zd2_4044;
																																																										BgL_cdrzd215923zd2_4044
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd215918zd2_4043));
																																																										if ((CAR(((obj_t) BgL_carzd215918zd2_4043)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd215923zd2_4044))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg3558z00_4048;
																																																														obj_t
																																																															BgL_arg3559z00_4049;
																																																														obj_t
																																																															BgL_arg3560z00_4050;
																																																														BgL_arg3558z00_4048
																																																															=
																																																															CAR
																																																															(BgL_cdrzd215923zd2_4044);
																																																														BgL_arg3559z00_4049
																																																															=
																																																															CDR
																																																															(BgL_cdrzd215923zd2_4044);
																																																														BgL_arg3560z00_4050
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18617;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_18620;
																																																																obj_t
																																																																	BgL_bodyz00_18619;
																																																																obj_t
																																																																	BgL_varsz00_18618;
																																																																BgL_varsz00_18618
																																																																	=
																																																																	BgL_arg3558z00_4048;
																																																																BgL_bodyz00_18619
																																																																	=
																																																																	BgL_arg3559z00_4049;
																																																																BgL_argsz00_18620
																																																																	=
																																																																	BgL_arg3560z00_4050;
																																																																BgL_argsz00_1774
																																																																	=
																																																																	BgL_argsz00_18620;
																																																																BgL_bodyz00_1773
																																																																	=
																																																																	BgL_bodyz00_18619;
																																																																BgL_varsz00_1772
																																																																	=
																																																																	BgL_varsz00_18618;
																																																																goto
																																																																	BgL_tagzd2386zd2_1775;
																																																															}
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18617);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_18624;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_14300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_18624);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd216030zd2_4053;
																																																												BgL_cdrzd216030zd2_4053
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd216035zd2_4054;
																																																													BgL_cdrzd216035zd2_4054
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd215918zd2_4043));
																																																													if ((CAR(((obj_t) BgL_carzd215918zd2_4043)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd216035zd2_4054))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd216040zd2_4058;
																																																																	BgL_cdrzd216040zd2_4058
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd216035zd2_4054);
																																																																	if (PAIRP(BgL_cdrzd216040zd2_4058))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd216044zd2_4060;
																																																																			obj_t
																																																																				BgL_cdrzd216045zd2_4061;
																																																																			BgL_carzd216044zd2_4060
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd216040zd2_4058);
																																																																			BgL_cdrzd216045zd2_4061
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd216040zd2_4058);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216044zd2_4060))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd216045zd2_4061))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd216050zd2_4064;
																																																																							BgL_carzd216050zd2_4064
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd216045zd2_4061);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216050zd2_4064))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd216045zd2_4061)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8830z00_18652;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1392z00_4097;
																																																																												BgL_l1392z00_4097
																																																																													=
																																																																													BgL_cdrzd216030zd2_4053;
																																																																											BgL_zc3z04anonymousza33589ze3z87_4098:
																																																																												if (NULLP(BgL_l1392z00_4097))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8830z00_18652
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test8832z00_18655;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test8833z00_18656;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_tmpz00_18657;
																																																																																BgL_tmpz00_18657
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1392z00_4097));
																																																																																BgL_test8833z00_18656
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_18657);
																																																																															}
																																																																															if (BgL_test8833z00_18656)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8832z00_18655
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test8832z00_18655
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_test8832z00_18655)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1392z00_18661;
																																																																																BgL_l1392z00_18661
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1392z00_4097));
																																																																																BgL_l1392z00_4097
																																																																																	=
																																																																																	BgL_l1392z00_18661;
																																																																																goto
																																																																																	BgL_zc3z04anonymousza33589ze3z87_4098;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test8830z00_18652
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_test8830z00_18652)
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3577z00_4080;
																																																																													BgL_arg3577z00_4080
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd216035zd2_4054);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18665;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_18669;
																																																																															obj_t
																																																																																BgL_proc2z00_18668;
																																																																															obj_t
																																																																																BgL_proc1z00_18667;
																																																																															obj_t
																																																																																BgL_testz00_18666;
																																																																															BgL_testz00_18666
																																																																																=
																																																																																BgL_arg3577z00_4080;
																																																																															BgL_proc1z00_18667
																																																																																=
																																																																																BgL_carzd216044zd2_4060;
																																																																															BgL_proc2z00_18668
																																																																																=
																																																																																BgL_carzd216050zd2_4064;
																																																																															BgL_argsz00_18669
																																																																																=
																																																																																BgL_cdrzd216030zd2_4053;
																																																																															BgL_argsz00_1779
																																																																																=
																																																																																BgL_argsz00_18669;
																																																																															BgL_proc2z00_1778
																																																																																=
																																																																																BgL_proc2z00_18668;
																																																																															BgL_proc1z00_1777
																																																																																=
																																																																																BgL_proc1z00_18667;
																																																																															BgL_testz00_1776
																																																																																=
																																																																																BgL_testz00_18666;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1780;
																																																																														}
																																																																														BgL_auxz00_14300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18665);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd216075zd2_4081;
																																																																													BgL_cdrzd216075zd2_4081
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd216083zd2_4082;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_11000;
																																																																															BgL_pairz00_11000
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd216083zd2_4082
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_11000);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd216091zd2_4083;
																																																																															BgL_cdrzd216091zd2_4083
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd216083zd2_4082));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd216098zd2_4084;
																																																																																BgL_carzd216098zd2_4084
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd216091zd2_4083));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216098zd2_4084))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd216107zd2_4086;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_11004;
																																																																																			BgL_pairz00_11004
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd216091zd2_4083));
																																																																																			BgL_carzd216107zd2_4086
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_11004);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216107zd2_4086))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216075zd2_4081))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg3582z00_4089;
																																																																																						BgL_arg3582z00_4089
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd216083zd2_4082));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_18691;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_18695;
																																																																																								obj_t
																																																																																									BgL_proc2z00_18694;
																																																																																								obj_t
																																																																																									BgL_proc1z00_18693;
																																																																																								obj_t
																																																																																									BgL_testz00_18692;
																																																																																								BgL_testz00_18692
																																																																																									=
																																																																																									BgL_arg3582z00_4089;
																																																																																								BgL_proc1z00_18693
																																																																																									=
																																																																																									BgL_carzd216098zd2_4084;
																																																																																								BgL_proc2z00_18694
																																																																																									=
																																																																																									BgL_carzd216107zd2_4086;
																																																																																								BgL_argsz00_18695
																																																																																									=
																																																																																									BgL_cdrzd216075zd2_4081;
																																																																																								BgL_argsz00_1784
																																																																																									=
																																																																																									BgL_argsz00_18695;
																																																																																								BgL_proc2z00_1783
																																																																																									=
																																																																																									BgL_proc2z00_18694;
																																																																																								BgL_proc1z00_1782
																																																																																									=
																																																																																									BgL_proc1z00_18693;
																																																																																								BgL_testz00_1781
																																																																																									=
																																																																																									BgL_testz00_18692;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1785;
																																																																																							}
																																																																																							BgL_auxz00_14300
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_18691);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_18699;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_14300
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_18699);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18703;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18703);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18707;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18707);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18711;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18711);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd216385zd2_4108;
																																																																									BgL_cdrzd216385zd2_4108
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd216392zd2_4109;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_11008;
																																																																											BgL_pairz00_11008
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd216392zd2_4109
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_11008);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd216399zd2_4110;
																																																																											BgL_cdrzd216399zd2_4110
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd216392zd2_4109));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd216405zd2_4111;
																																																																												obj_t
																																																																													BgL_cdrzd216406zd2_4112;
																																																																												BgL_carzd216405zd2_4111
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4110));
																																																																												BgL_cdrzd216406zd2_4112
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd216399zd2_4110));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216405zd2_4111))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd216413zd2_4114;
																																																																														BgL_carzd216413zd2_4114
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd216406zd2_4112));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216413zd2_4114))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd216406zd2_4112))))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216385zd2_4108))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg3600z00_4119;
																																																																																				BgL_arg3600z00_4119
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd216392zd2_4109));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_18738;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_18742;
																																																																																						obj_t
																																																																																							BgL_proc2z00_18741;
																																																																																						obj_t
																																																																																							BgL_proc1z00_18740;
																																																																																						obj_t
																																																																																							BgL_testz00_18739;
																																																																																						BgL_testz00_18739
																																																																																							=
																																																																																							BgL_arg3600z00_4119;
																																																																																						BgL_proc1z00_18740
																																																																																							=
																																																																																							BgL_carzd216405zd2_4111;
																																																																																						BgL_proc2z00_18741
																																																																																							=
																																																																																							BgL_carzd216413zd2_4114;
																																																																																						BgL_argsz00_18742
																																																																																							=
																																																																																							BgL_cdrzd216385zd2_4108;
																																																																																						BgL_argsz00_1784
																																																																																							=
																																																																																							BgL_argsz00_18742;
																																																																																						BgL_proc2z00_1783
																																																																																							=
																																																																																							BgL_proc2z00_18741;
																																																																																						BgL_proc1z00_1782
																																																																																							=
																																																																																							BgL_proc1z00_18740;
																																																																																						BgL_testz00_1781
																																																																																							=
																																																																																							BgL_testz00_18739;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1785;
																																																																																					}
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_18738);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_18746;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_14300
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_18746);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18750;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18750);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18754;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18754);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18758;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18758);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_18762;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18762);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd216746zd2_4127;
																																																																					BgL_cdrzd216746zd2_4127
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd216752zd2_4128;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11018;
																																																																							BgL_pairz00_11018
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd216752zd2_4128
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11018);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd216758zd2_4129;
																																																																							BgL_cdrzd216758zd2_4129
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd216752zd2_4128));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd216763zd2_4130;
																																																																								obj_t
																																																																									BgL_cdrzd216764zd2_4131;
																																																																								BgL_carzd216763zd2_4130
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4129));
																																																																								BgL_cdrzd216764zd2_4131
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd216758zd2_4129));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216763zd2_4130))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (PAIRP(BgL_cdrzd216764zd2_4131))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd216769zd2_4134;
																																																																												BgL_carzd216769zd2_4134
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd216764zd2_4131);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd216769zd2_4134))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(BgL_cdrzd216764zd2_4131)))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd216746zd2_4127))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3615z00_4139;
																																																																																		BgL_arg3615z00_4139
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd216752zd2_4128));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_18789;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_18793;
																																																																																				obj_t
																																																																																					BgL_proc2z00_18792;
																																																																																				obj_t
																																																																																					BgL_proc1z00_18791;
																																																																																				obj_t
																																																																																					BgL_testz00_18790;
																																																																																				BgL_testz00_18790
																																																																																					=
																																																																																					BgL_arg3615z00_4139;
																																																																																				BgL_proc1z00_18791
																																																																																					=
																																																																																					BgL_carzd216763zd2_4130;
																																																																																				BgL_proc2z00_18792
																																																																																					=
																																																																																					BgL_carzd216769zd2_4134;
																																																																																				BgL_argsz00_18793
																																																																																					=
																																																																																					BgL_cdrzd216746zd2_4127;
																																																																																				BgL_argsz00_1784
																																																																																					=
																																																																																					BgL_argsz00_18793;
																																																																																				BgL_proc2z00_1783
																																																																																					=
																																																																																					BgL_proc2z00_18792;
																																																																																				BgL_proc1z00_1782
																																																																																					=
																																																																																					BgL_proc1z00_18791;
																																																																																				BgL_testz00_1781
																																																																																					=
																																																																																					BgL_testz00_18790;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1785;
																																																																																			}
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_18789);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_18797;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_18797);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_18801;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_18801);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_18805;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_18805);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_18809;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_14300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_18809);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_18813;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_14300
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_18813);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18817;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18817);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18821;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18821);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_18825;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_18825);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd214242zd2_4026 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg3739z00_4305;
																																											obj_t
																																												BgL_arg3740z00_4306;
																																											BgL_arg3739z00_4305
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_4010));
																																											BgL_arg3740z00_4306
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd214141zd2_4010));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_18834;
																																												{
																																													obj_t
																																														BgL_exprz00_18836;
																																													obj_t
																																														BgL_bindingsz00_18835;
																																													BgL_bindingsz00_18835
																																														=
																																														BgL_arg3739z00_4305;
																																													BgL_exprz00_18836
																																														=
																																														BgL_arg3740z00_4306;
																																													BgL_exprz00_1764
																																														=
																																														BgL_exprz00_18836;
																																													BgL_bindingsz00_1763
																																														=
																																														BgL_bindingsz00_18835;
																																													goto
																																														BgL_tagzd2382zd2_1765;
																																												}
																																												BgL_auxz00_14300
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_18834);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd214242zd2_4026)))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg3742z00_4308;
																																													obj_t
																																														BgL_arg3743z00_4309;
																																													BgL_arg3742z00_4308
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_4010));
																																													BgL_arg3743z00_4309
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd214141zd2_4010));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_18845;
																																														{
																																															obj_t
																																																BgL_exprz00_18847;
																																															obj_t
																																																BgL_bindingsz00_18846;
																																															BgL_bindingsz00_18846
																																																=
																																																BgL_arg3742z00_4308;
																																															BgL_exprz00_18847
																																																=
																																																BgL_arg3743z00_4309;
																																															BgL_exprz00_1764
																																																=
																																																BgL_exprz00_18847;
																																															BgL_bindingsz00_1763
																																																=
																																																BgL_bindingsz00_18846;
																																															goto
																																																BgL_tagzd2382zd2_1765;
																																														}
																																														BgL_auxz00_14300
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_18845);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((BgL_carzd214242zd2_4026 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg3745z00_4311;
																																															obj_t
																																																BgL_arg3746z00_4312;
																																															BgL_arg3745z00_4311
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_4010));
																																															BgL_arg3746z00_4312
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd214141zd2_4010));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_18856;
																																																{
																																																	obj_t
																																																		BgL_exprz00_18858;
																																																	obj_t
																																																		BgL_bindingsz00_18857;
																																																	BgL_bindingsz00_18857
																																																		=
																																																		BgL_arg3745z00_4311;
																																																	BgL_exprz00_18858
																																																		=
																																																		BgL_arg3746z00_4312;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_18858;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_18857;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_14300
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_18856);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_18865;
																																																	goto
																																																		BgL_tagzd2383zd2_1766;
																																																	BgL_auxz00_14300
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_18865);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd217344zd2_4315;
																																																	BgL_carzd217344zd2_4315
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd217344zd2_4315 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_18872;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_18872);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217344zd2_4315)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_18877;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_18877);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_18884;
																																																							goto
																																																								BgL_tagzd2389zd2_1786;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_18884);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_18891;
																																																									goto
																																																										BgL_tagzd2390zd2_1787;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_18891);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd217424zd2_4322;
																																																									BgL_cdrzd217424zd2_4322
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg3757z00_4325;
																																																											obj_t
																																																												BgL_arg3758z00_4326;
																																																											BgL_arg3757z00_4325
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4322));
																																																											BgL_arg3758z00_4326
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217424zd2_4322));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_18904;
																																																												{
																																																													obj_t
																																																														BgL_restz00_18906;
																																																													obj_t
																																																														BgL_effectz00_18905;
																																																													BgL_effectz00_18905
																																																														=
																																																														BgL_arg3757z00_4325;
																																																													BgL_restz00_18906
																																																														=
																																																														BgL_arg3758z00_4326;
																																																													BgL_restz00_1789
																																																														=
																																																														BgL_restz00_18906;
																																																													BgL_effectz00_1788
																																																														=
																																																														BgL_effectz00_18905;
																																																													goto
																																																														BgL_tagzd2391zd2_1790;
																																																												}
																																																												BgL_auxz00_14300
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_18904);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_18913;
																																																													goto
																																																														BgL_tagzd2392zd2_1791;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_18913);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_18920;
																																																															goto
																																																																BgL_tagzd2393zd2_1792;
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_18920);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg3765z00_4334;
																																																																	obj_t
																																																																		BgL_arg3766z00_4335;
																																																																	BgL_arg3765z00_4334
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4322));
																																																																	BgL_arg3766z00_4335
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd217424zd2_4322));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_18931;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_18933;
																																																																			obj_t
																																																																				BgL_effectz00_18932;
																																																																			BgL_effectz00_18932
																																																																				=
																																																																				BgL_arg3765z00_4334;
																																																																			BgL_restz00_18933
																																																																				=
																																																																				BgL_arg3766z00_4335;
																																																																			BgL_restz00_1794
																																																																				=
																																																																				BgL_restz00_18933;
																																																																			BgL_effectz00_1793
																																																																				=
																																																																				BgL_effectz00_18932;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1795;
																																																																		}
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_18931);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_18940;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1796;
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_18940);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_18947;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1797;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_18947);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_18954;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1798;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_18954);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_18961;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1799;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_18961);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8880z00_18968;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_tmpz00_18969;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11056;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_11055;
																																																																														BgL_pairz00_11055
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_11056
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_11055);
																																																																													}
																																																																													BgL_tmpz00_18969
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11056);
																																																																												}
																																																																												BgL_test8880z00_18968
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_18969);
																																																																											}
																																																																											if (BgL_test8880z00_18968)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_18975;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1800;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_18975);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_18979;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_18979);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd217512zd2_4354;
																																																																											BgL_cdrzd217512zd2_4354
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd217518zd2_4357;
																																																																													BgL_cdrzd217518zd2_4357
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd217512zd2_4354));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd217524zd2_4358;
																																																																														BgL_cdrzd217524zd2_4358
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd217518zd2_4357));
																																																																														if ((CAR(((obj_t) BgL_cdrzd217518zd2_4357)) == CNST_TABLE_REF(((long) 31))))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd217524zd2_4358))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3790z00_4362;
																																																																																		obj_t
																																																																																			BgL_arg3791z00_4363;
																																																																																		obj_t
																																																																																			BgL_arg3792z00_4364;
																																																																																		BgL_arg3790z00_4362
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4354));
																																																																																		BgL_arg3791z00_4363
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd217524zd2_4358);
																																																																																		BgL_arg3792z00_4364
																																																																																			=
																																																																																			CDR
																																																																																			(BgL_cdrzd217524zd2_4358);
																																																																																		{	/* Ast/sexp.scm 553 */
																																																																																			obj_t
																																																																																				BgL_arg7014z00_11067;
																																																																																			BgL_arg7014z00_11067
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3790z00_4362,
																																																																																					BgL_arg3791z00_4363,
																																																																																					BgL_arg3792z00_4364,
																																																																																					BgL_stackz00_22,
																																																																																					BgL_arg7014z00_11067,
																																																																																					BgL_sitez00_24));
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg3793z00_4366;
																																																																																		obj_t
																																																																																			BgL_arg3794z00_4367;
																																																																																		BgL_arg3793z00_4366
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4354));
																																																																																		BgL_arg3794z00_4367
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd217512zd2_4354));
																																																																																		{	/* Ast/sexp.scm 555 */
																																																																																			obj_t
																																																																																				BgL_arg7015z00_11071;
																																																																																			BgL_arg7015z00_11071
																																																																																				=
																																																																																				BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																				(BgL_expz00_21,
																																																																																				BgL_locz00_23);
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																				(BgL_expz00_21,
																																																																																					BgL_arg3793z00_4366,
																																																																																					CNST_TABLE_REF
																																																																																					(((long) 4)), BgL_arg3794z00_4367, BgL_stackz00_22, BgL_arg7015z00_11071, BgL_sitez00_24));
																																																																															}}}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg3795z00_4369;
																																																																																obj_t
																																																																																	BgL_arg3796z00_4370;
																																																																																BgL_arg3795z00_4369
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4354));
																																																																																BgL_arg3796z00_4370
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd217512zd2_4354));
																																																																																{	/* Ast/sexp.scm 555 */
																																																																																	obj_t
																																																																																		BgL_arg7015z00_11075;
																																																																																	BgL_arg7015z00_11075
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg3795z00_4369,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg3796z00_4370, BgL_stackz00_22, BgL_arg7015z00_11075, BgL_sitez00_24));
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19024;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19024);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_carzd217575zd2_4389;
																													BgL_carzd217575zd2_4389
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd217575zd2_4389
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_19031;
																															goto
																																BgL_tagzd2377zd2_1754;
																															BgL_auxz00_14300 =
																																((obj_t)
																																BgL_auxz00_19031);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(BgL_carzd217575zd2_4389
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_19035;
																																	goto
																																		BgL_tagzd2377zd2_1754;
																																	BgL_auxz00_14300
																																		=
																																		((obj_t)
																																		BgL_auxz00_19035);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_19042;
																																			goto
																																				BgL_tagzd2379zd2_1758;
																																			BgL_auxz00_14300
																																				=
																																				((obj_t)
																																				BgL_auxz00_19042);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_19049;
																																					goto
																																						BgL_tagzd2380zd2_1759;
																																					BgL_auxz00_14300
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_19049);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd217644zd2_4396;
																																					BgL_carzd217644zd2_4396
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd217644zd2_4396))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd217647zd2_4398;
																																							obj_t
																																								BgL_cdrzd217648zd2_4399;
																																							BgL_carzd217647zd2_4398
																																								=
																																								CAR
																																								(BgL_carzd217644zd2_4396);
																																							BgL_cdrzd217648zd2_4399
																																								=
																																								CDR
																																								(BgL_carzd217644zd2_4396);
																																							{

																																								if ((BgL_carzd217647zd2_4398 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 119 */
																																									BgL_kapzd217649zd2_4400:
																																										if (PAIRP(BgL_cdrzd217648zd2_4399))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd217652zd2_4582;
																																												BgL_cdrzd217652zd2_4582
																																													=
																																													CDR
																																													(BgL_cdrzd217648zd2_4399);
																																												if (PAIRP(BgL_cdrzd217652zd2_4582))
																																													{	/* Ast/sexp.scm 119 */
																																														if (NULLP(CDR(BgL_cdrzd217652zd2_4582)))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg3950z00_4586;
																																																obj_t
																																																	BgL_arg3951z00_4587;
																																																BgL_arg3950z00_4586
																																																	=
																																																	CAR
																																																	(BgL_cdrzd217652zd2_4582);
																																																BgL_arg3951z00_4587
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_19071;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_19073;
																																																		obj_t
																																																			BgL_bodyz00_19072;
																																																		BgL_bodyz00_19072
																																																			=
																																																			BgL_arg3950z00_4586;
																																																		BgL_argsz00_19073
																																																			=
																																																			BgL_arg3951z00_4587;
																																																		BgL_argsz00_1761
																																																			=
																																																			BgL_argsz00_19073;
																																																		BgL_bodyz00_1760
																																																			=
																																																			BgL_bodyz00_19072;
																																																		goto
																																																			BgL_tagzd2381zd2_1762;
																																																	}
																																																	BgL_auxz00_14300
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19071);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd217676zd2_4588;
																																																BgL_cdrzd217676zd2_4588
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8895z00_19077;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg4021z00_4699;
																																																		BgL_arg4021z00_4699
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8895z00_19077
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg4021z00_4699));
																																																	}
																																																	if (BgL_test8895z00_19077)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg3954z00_4591;
																																																			obj_t
																																																				BgL_arg3955z00_4592;
																																																			BgL_arg3954z00_4591
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4588));
																																																			BgL_arg3955z00_4592
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd217676zd2_4588));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_19086;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_19088;
																																																					obj_t
																																																						BgL_bindingsz00_19087;
																																																					BgL_bindingsz00_19087
																																																						=
																																																						BgL_arg3954z00_4591;
																																																					BgL_exprz00_19088
																																																						=
																																																						BgL_arg3955z00_4592;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_19088;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_19087;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_14300
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_19086);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8896z00_19090;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg4020z00_4698;
																																																				BgL_arg4020z00_4698
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8896z00_19090
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg4020z00_4698));
																																																			}
																																																			if (BgL_test8896z00_19090)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_19095;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19095);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd217743zd2_4595;
																																																					BgL_carzd217743zd2_4595
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd217748zd2_4596;
																																																						BgL_cdrzd217748zd2_4596
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd217743zd2_4595));
																																																						if ((CAR(((obj_t) BgL_carzd217743zd2_4595)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg3960z00_4599;
																																																								obj_t
																																																									BgL_arg3961z00_4600;
																																																								obj_t
																																																									BgL_arg3962z00_4601;
																																																								BgL_arg3960z00_4599
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4596));
																																																								BgL_arg3961z00_4600
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd217748zd2_4596));
																																																								BgL_arg3962z00_4601
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_19112;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_19115;
																																																										obj_t
																																																											BgL_bodyz00_19114;
																																																										obj_t
																																																											BgL_varsz00_19113;
																																																										BgL_varsz00_19113
																																																											=
																																																											BgL_arg3960z00_4599;
																																																										BgL_bodyz00_19114
																																																											=
																																																											BgL_arg3961z00_4600;
																																																										BgL_argsz00_19115
																																																											=
																																																											BgL_arg3962z00_4601;
																																																										BgL_argsz00_1774
																																																											=
																																																											BgL_argsz00_19115;
																																																										BgL_bodyz00_1773
																																																											=
																																																											BgL_bodyz00_19114;
																																																										BgL_varsz00_1772
																																																											=
																																																											BgL_varsz00_19113;
																																																										goto
																																																											BgL_tagzd2386zd2_1775;
																																																									}
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_19112);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd217771zd2_4603;
																																																								BgL_cdrzd217771zd2_4603
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd217777zd2_4604;
																																																									BgL_cdrzd217777zd2_4604
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd217743zd2_4595));
																																																									if ((CAR(((obj_t) BgL_carzd217743zd2_4595)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd217783zd2_4607;
																																																											BgL_cdrzd217783zd2_4607
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd217777zd2_4604));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd217788zd2_4608;
																																																												obj_t
																																																													BgL_cdrzd217789zd2_4609;
																																																												BgL_carzd217788zd2_4608
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4607));
																																																												BgL_cdrzd217789zd2_4609
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd217783zd2_4607));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217788zd2_4608))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd217789zd2_4609))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd217796zd2_4612;
																																																																BgL_carzd217796zd2_4612
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd217789zd2_4609);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217796zd2_4612))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd217789zd2_4609)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test8903z00_19142;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1395z00_4645;
																																																																					BgL_l1395z00_4645
																																																																						=
																																																																						BgL_cdrzd217771zd2_4603;
																																																																				BgL_zc3z04anonymousza33985ze3z87_4646:
																																																																					if (NULLP(BgL_l1395z00_4645))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test8903z00_19142
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test8905z00_19145;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8906z00_19146;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_19147;
																																																																									BgL_tmpz00_19147
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1395z00_4645));
																																																																									BgL_test8906z00_19146
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_19147);
																																																																								}
																																																																								if (BgL_test8906z00_19146)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8905z00_19145
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test8905z00_19145
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test8905z00_19145)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1395z00_19151;
																																																																									BgL_l1395z00_19151
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1395z00_4645));
																																																																									BgL_l1395z00_4645
																																																																										=
																																																																										BgL_l1395z00_19151;
																																																																									goto
																																																																										BgL_zc3z04anonymousza33985ze3z87_4646;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test8903z00_19142
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test8903z00_19142)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg3975z00_4628;
																																																																						BgL_arg3975z00_4628
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd217777zd2_4604));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19156;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_19160;
																																																																								obj_t
																																																																									BgL_proc2z00_19159;
																																																																								obj_t
																																																																									BgL_proc1z00_19158;
																																																																								obj_t
																																																																									BgL_testz00_19157;
																																																																								BgL_testz00_19157
																																																																									=
																																																																									BgL_arg3975z00_4628;
																																																																								BgL_proc1z00_19158
																																																																									=
																																																																									BgL_carzd217788zd2_4608;
																																																																								BgL_proc2z00_19159
																																																																									=
																																																																									BgL_carzd217796zd2_4612;
																																																																								BgL_argsz00_19160
																																																																									=
																																																																									BgL_cdrzd217771zd2_4603;
																																																																								BgL_argsz00_1779
																																																																									=
																																																																									BgL_argsz00_19160;
																																																																								BgL_proc2z00_1778
																																																																									=
																																																																									BgL_proc2z00_19159;
																																																																								BgL_proc1z00_1777
																																																																									=
																																																																									BgL_proc1z00_19158;
																																																																								BgL_testz00_1776
																																																																									=
																																																																									BgL_testz00_19157;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1780;
																																																																							}
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19156);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd217820zd2_4629;
																																																																						BgL_cdrzd217820zd2_4629
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd217827zd2_4630;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11119;
																																																																								BgL_pairz00_11119
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd217827zd2_4630
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11119);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd217834zd2_4631;
																																																																								BgL_cdrzd217834zd2_4631
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd217827zd2_4630));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd217840zd2_4632;
																																																																									BgL_carzd217840zd2_4632
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd217834zd2_4631));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217840zd2_4632))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd217847zd2_4634;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11123;
																																																																												BgL_pairz00_11123
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd217834zd2_4631));
																																																																												BgL_carzd217847zd2_4634
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11123);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd217847zd2_4634))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd217820zd2_4629))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3979z00_4637;
																																																																															BgL_arg3979z00_4637
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd217827zd2_4630));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19182;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19186;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19185;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19184;
																																																																																	obj_t
																																																																																		BgL_testz00_19183;
																																																																																	BgL_testz00_19183
																																																																																		=
																																																																																		BgL_arg3979z00_4637;
																																																																																	BgL_proc1z00_19184
																																																																																		=
																																																																																		BgL_carzd217840zd2_4632;
																																																																																	BgL_proc2z00_19185
																																																																																		=
																																																																																		BgL_carzd217847zd2_4634;
																																																																																	BgL_argsz00_19186
																																																																																		=
																																																																																		BgL_cdrzd217820zd2_4629;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_19186;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_19185;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_19184;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_19183;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19182);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19190;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19190);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19194;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19194);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19198;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19198);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19202;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19202);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd218123zd2_4656;
																																																																		BgL_cdrzd218123zd2_4656
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd218129zd2_4657;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11127;
																																																																				BgL_pairz00_11127
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd218129zd2_4657
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11127);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd218135zd2_4658;
																																																																				BgL_cdrzd218135zd2_4658
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd218129zd2_4657));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd218140zd2_4659;
																																																																					obj_t
																																																																						BgL_cdrzd218141zd2_4660;
																																																																					BgL_carzd218140zd2_4659
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4658));
																																																																					BgL_cdrzd218141zd2_4660
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd218135zd2_4658));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218140zd2_4659))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd218146zd2_4662;
																																																																							BgL_carzd218146zd2_4662
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd218141zd2_4660));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218146zd2_4662))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd218141zd2_4660))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218123zd2_4656))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3995z00_4667;
																																																																													BgL_arg3995z00_4667
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd218129zd2_4657));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19229;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19233;
																																																																															obj_t
																																																																																BgL_proc2z00_19232;
																																																																															obj_t
																																																																																BgL_proc1z00_19231;
																																																																															obj_t
																																																																																BgL_testz00_19230;
																																																																															BgL_testz00_19230
																																																																																=
																																																																																BgL_arg3995z00_4667;
																																																																															BgL_proc1z00_19231
																																																																																=
																																																																																BgL_carzd218140zd2_4659;
																																																																															BgL_proc2z00_19232
																																																																																=
																																																																																BgL_carzd218146zd2_4662;
																																																																															BgL_argsz00_19233
																																																																																=
																																																																																BgL_cdrzd218123zd2_4656;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_19233;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_19232;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_19231;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_19230;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_14300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19229);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19237;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19237);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19241;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19241);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19245;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19245);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19249;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19249);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19253;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19253);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd218479zd2_4675;
																																																														BgL_cdrzd218479zd2_4675
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd218486zd2_4676;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_11137;
																																																																BgL_pairz00_11137
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd218486zd2_4676
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11137);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd218493zd2_4677;
																																																																BgL_cdrzd218493zd2_4677
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd218486zd2_4676));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd218499zd2_4678;
																																																																	obj_t
																																																																		BgL_cdrzd218500zd2_4679;
																																																																	BgL_carzd218499zd2_4678
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4677));
																																																																	BgL_cdrzd218500zd2_4679
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd218493zd2_4677));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218499zd2_4678))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd218500zd2_4679))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd218507zd2_4682;
																																																																					BgL_carzd218507zd2_4682
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd218500zd2_4679);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd218507zd2_4682))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd218500zd2_4679)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd218479zd2_4675))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg4009z00_4687;
																																																																											BgL_arg4009z00_4687
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd218486zd2_4676));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19280;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19284;
																																																																													obj_t
																																																																														BgL_proc2z00_19283;
																																																																													obj_t
																																																																														BgL_proc1z00_19282;
																																																																													obj_t
																																																																														BgL_testz00_19281;
																																																																													BgL_testz00_19281
																																																																														=
																																																																														BgL_arg4009z00_4687;
																																																																													BgL_proc1z00_19282
																																																																														=
																																																																														BgL_carzd218499zd2_4678;
																																																																													BgL_proc2z00_19283
																																																																														=
																																																																														BgL_carzd218507zd2_4682;
																																																																													BgL_argsz00_19284
																																																																														=
																																																																														BgL_cdrzd218479zd2_4675;
																																																																													BgL_argsz00_1784
																																																																														=
																																																																														BgL_argsz00_19284;
																																																																													BgL_proc2z00_1783
																																																																														=
																																																																														BgL_proc2z00_19283;
																																																																													BgL_proc1z00_1782
																																																																														=
																																																																														BgL_proc1z00_19282;
																																																																													BgL_testz00_1781
																																																																														=
																																																																														BgL_testz00_19281;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1785;
																																																																												}
																																																																												BgL_auxz00_14300
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19280);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19288;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19288);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19292;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19292);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19296;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19296);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_19300;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19300);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_19304;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19304);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19308;
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19308);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd218900zd2_4701;
																																														BgL_cdrzd218900zd2_4701
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8934z00_19312;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg4037z00_4718;
																																																BgL_arg4037z00_4718
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8934z00_19312
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg4037z00_4718));
																																															}
																																															if (BgL_test8934z00_19312)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4025z00_4704;
																																																	obj_t
																																																		BgL_arg4026z00_4705;
																																																	BgL_arg4025z00_4704
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4701));
																																																	BgL_arg4026z00_4705
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd218900zd2_4701));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_19321;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_19323;
																																																			obj_t
																																																				BgL_bindingsz00_19322;
																																																			BgL_bindingsz00_19322
																																																				=
																																																				BgL_arg4025z00_4704;
																																																			BgL_exprz00_19323
																																																				=
																																																				BgL_arg4026z00_4705;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_19323;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_19322;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_14300
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_19321);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test8935z00_19325;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg4036z00_4717;
																																																		BgL_arg4036z00_4717
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test8935z00_19325
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg4036z00_4717));
																																																	}
																																																	if (BgL_test8935z00_19325)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19330;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19330);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd218966zd2_4708;
																																																			BgL_carzd218966zd2_4708
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd218971zd2_4709;
																																																				BgL_cdrzd218971zd2_4709
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd218966zd2_4708));
																																																				if ((CAR(((obj_t) BgL_carzd218966zd2_4708)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg4031z00_4712;
																																																						obj_t
																																																							BgL_arg4032z00_4713;
																																																						obj_t
																																																							BgL_arg4033z00_4714;
																																																						BgL_arg4031z00_4712
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4709));
																																																						BgL_arg4032z00_4713
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd218971zd2_4709));
																																																						BgL_arg4033z00_4714
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19347;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_19350;
																																																								obj_t
																																																									BgL_bodyz00_19349;
																																																								obj_t
																																																									BgL_varsz00_19348;
																																																								BgL_varsz00_19348
																																																									=
																																																									BgL_arg4031z00_4712;
																																																								BgL_bodyz00_19349
																																																									=
																																																									BgL_arg4032z00_4713;
																																																								BgL_argsz00_19350
																																																									=
																																																									BgL_arg4033z00_4714;
																																																								BgL_argsz00_1774
																																																									=
																																																									BgL_argsz00_19350;
																																																								BgL_bodyz00_1773
																																																									=
																																																									BgL_bodyz00_19349;
																																																								BgL_varsz00_1772
																																																									=
																																																									BgL_varsz00_19348;
																																																								goto
																																																									BgL_tagzd2386zd2_1775;
																																																							}
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19347);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1809;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_19354;
																																																								goto
																																																									BgL_tagzd2404zd2_1810;
																																																								BgL_auxz00_14300
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_19354);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd219082zd2_4719;
																																												BgL_cdrzd219082zd2_4719
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test8938z00_19358;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg4046z00_4728;
																																														BgL_arg4046z00_4728
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test8938z00_19358
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg4046z00_4728));
																																													}
																																													if (BgL_test8938z00_19358)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4040z00_4722;
																																															obj_t
																																																BgL_arg4041z00_4723;
																																															BgL_arg4040z00_4722
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4719));
																																															BgL_arg4041z00_4723
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd219082zd2_4719));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_19367;
																																																{
																																																	obj_t
																																																		BgL_exprz00_19369;
																																																	obj_t
																																																		BgL_bindingsz00_19368;
																																																	BgL_bindingsz00_19368
																																																		=
																																																		BgL_arg4040z00_4722;
																																																	BgL_exprz00_19369
																																																		=
																																																		BgL_arg4041z00_4723;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_19369;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_19368;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_14300
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19367);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test8939z00_19371;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg4045z00_4727;
																																																BgL_arg4045z00_4727
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test8939z00_19371
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg4045z00_4727));
																																															}
																																															if (BgL_test8939z00_19371)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19376;
																																																	goto
																																																		BgL_tagzd2384zd2_1767;
																																																	BgL_auxz00_14300
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19376);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1809;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_19380;
																																																			goto
																																																				BgL_tagzd2404zd2_1810;
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19380);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217647zd2_4398)))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd217649zd2_4400;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd217647zd2_4398 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd217649zd2_4400;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd217647zd2_4398 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd217649zd2_4400;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd217647zd2_4398)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd217649zd2_4400;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd219254zd2_4406;
																																																		BgL_cdrzd219254zd2_4406
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test8945z00_19396;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg3945z00_4580;
																																																				BgL_arg3945z00_4580
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test8945z00_19396
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg3945z00_4580));
																																																			}
																																																			if (BgL_test8945z00_19396)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg3829z00_4409;
																																																					obj_t
																																																						BgL_arg3830z00_4410;
																																																					BgL_arg3829z00_4409
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4406));
																																																					BgL_arg3830z00_4410
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd219254zd2_4406));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_19405;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_19407;
																																																							obj_t
																																																								BgL_bindingsz00_19406;
																																																							BgL_bindingsz00_19406
																																																								=
																																																								BgL_arg3829z00_4409;
																																																							BgL_exprz00_19407
																																																								=
																																																								BgL_arg3830z00_4410;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_19407;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_19406;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_14300
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_19405);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test8946z00_19409;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg3944z00_4579;
																																																						BgL_arg3944z00_4579
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test8946z00_19409
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg3944z00_4579));
																																																					}
																																																					if (BgL_test8946z00_19409)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_19414;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19414);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd219307zd2_4413;
																																																							obj_t
																																																								BgL_cdrzd219308zd2_4414;
																																																							BgL_carzd219307zd2_4413
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							BgL_cdrzd219308zd2_4414
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd219312zd2_4415;
																																																								BgL_cdrzd219312zd2_4415
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd219307zd2_4413));
																																																								if ((CAR(((obj_t) BgL_carzd219307zd2_4413)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd219312zd2_4415))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd219315zd2_4419;
																																																												obj_t
																																																													BgL_cdrzd219316zd2_4420;
																																																												BgL_carzd219315zd2_4419
																																																													=
																																																													CAR
																																																													(BgL_cdrzd219312zd2_4415);
																																																												BgL_cdrzd219316zd2_4420
																																																													=
																																																													CDR
																																																													(BgL_cdrzd219312zd2_4415);
																																																												if (PAIRP(BgL_carzd219315zd2_4419))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (NULLP(CDR(BgL_carzd219315zd2_4419)))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd219316zd2_4420))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd219322zd2_4425;
																																																																		BgL_carzd219322zd2_4425
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd219316zd2_4420);
																																																																		if (PAIRP(BgL_carzd219322zd2_4425))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd219322zd2_4425))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd219316zd2_4420)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd219329zd2_4430;
																																																																								BgL_carzd219329zd2_4430
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd219308zd2_4414));
																																																																								if (PAIRP(BgL_carzd219329zd2_4430))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd219354zd2_4432;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_11185;
																																																																											BgL_pairz00_11185
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd219354zd2_4432
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_11185);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg3845z00_4433;
																																																																											obj_t
																																																																												BgL_arg3846z00_4434;
																																																																											obj_t
																																																																												BgL_arg3847z00_4435;
																																																																											BgL_arg3845z00_4433
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4432));
																																																																											BgL_arg3846z00_4434
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd219354zd2_4432));
																																																																											BgL_arg3847z00_4435
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_19459;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_19462;
																																																																													obj_t
																																																																														BgL_bodyz00_19461;
																																																																													obj_t
																																																																														BgL_varsz00_19460;
																																																																													BgL_varsz00_19460
																																																																														=
																																																																														BgL_arg3845z00_4433;
																																																																													BgL_bodyz00_19461
																																																																														=
																																																																														BgL_arg3846z00_4434;
																																																																													BgL_argsz00_19462
																																																																														=
																																																																														BgL_arg3847z00_4435;
																																																																													BgL_argsz00_1774
																																																																														=
																																																																														BgL_argsz00_19462;
																																																																													BgL_bodyz00_1773
																																																																														=
																																																																														BgL_bodyz00_19461;
																																																																													BgL_varsz00_1772
																																																																														=
																																																																														BgL_varsz00_19460;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1775;
																																																																												}
																																																																												BgL_auxz00_14300
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_19459);
																																																																											}
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd219308zd2_4414))))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg3851z00_4439;
																																																																												BgL_arg3851z00_4439
																																																																													=
																																																																													CAR
																																																																													(BgL_carzd219315zd2_4419);
																																																																												{
																																																																													BgL_castz00_bglt
																																																																														BgL_auxz00_19469;
																																																																													BgL_varz00_1768
																																																																														=
																																																																														BgL_arg3851z00_4439;
																																																																													BgL_bodyz00_1769
																																																																														=
																																																																														BgL_carzd219322zd2_4425;
																																																																													BgL_argz00_1770
																																																																														=
																																																																														BgL_carzd219329zd2_4430;
																																																																												BgL_tagzd2385zd2_1771:
																																																																													{	/* Ast/sexp.scm 378 */
																																																																														BgL_castz00_bglt
																																																																															BgL_new1138z00_8778;
																																																																														{	/* Ast/sexp.scm 379 */
																																																																															BgL_castz00_bglt
																																																																																BgL_new1137z00_8780;
																																																																															BgL_new1137z00_8780
																																																																																=
																																																																																(
																																																																																(BgL_castz00_bglt)
																																																																																BOBJECT
																																																																																(GC_MALLOC
																																																																																	(sizeof
																																																																																		(struct
																																																																																			BgL_castz00_bgl))));
																																																																															{	/* Ast/sexp.scm 379 */
																																																																																long
																																																																																	BgL_arg6865z00_8781;
																																																																																{	/* Ast/sexp.scm 379 */
																																																																																	long
																																																																																		BgL_res7459z00_9998;
																																																																																	BgL_res7459z00_9998
																																																																																		=
																																																																																		BGL_CLASS_INDEX
																																																																																		(BGl_castz00zzast_nodez00);
																																																																																	BgL_arg6865z00_8781
																																																																																		=
																																																																																		BgL_res7459z00_9998;
																																																																																}
																																																																																BGL_OBJECT_CLASS_NUM_SET
																																																																																	(
																																																																																	((BgL_objectz00_bglt) BgL_new1137z00_8780), BgL_arg6865z00_8781);
																																																																															}
																																																																															{	/* Ast/sexp.scm 379 */
																																																																																BgL_objectz00_bglt
																																																																																	BgL_tmpz00_19474;
																																																																																BgL_tmpz00_19474
																																																																																	=
																																																																																	(
																																																																																	(BgL_objectz00_bglt)
																																																																																	BgL_new1137z00_8780);
																																																																																BGL_OBJECT_WIDENING_SET
																																																																																	(BgL_tmpz00_19474,
																																																																																	BFALSE);
																																																																															}
																																																																															((BgL_objectz00_bglt) BgL_new1137z00_8780);
																																																																															BgL_new1138z00_8778
																																																																																=
																																																																																BgL_new1137z00_8780;
																																																																														}
																																																																														((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1138z00_8778)))->BgL_locz00) = ((obj_t) BgL_locz00_23), BUNSPEC);
																																																																														{
																																																																															BgL_typez00_bglt
																																																																																BgL_auxz00_19480;
																																																																															{	/* Ast/sexp.scm 380 */
																																																																																obj_t
																																																																																	BgL_arg6864z00_8779;
																																																																																BgL_arg6864z00_8779
																																																																																	=
																																																																																	BGl_castzd2sexpzd2typez00zzast_privatez00
																																																																																	(BgL_bodyz00_1769);
																																																																																BgL_auxz00_19480
																																																																																	=
																																																																																	BGl_usezd2typez12zc0zztype_envz00
																																																																																	(BgL_arg6864z00_8779,
																																																																																	BgL_locz00_23);
																																																																															}
																																																																															((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt) BgL_new1138z00_8778)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_auxz00_19480), BUNSPEC);
																																																																														}
																																																																														((((BgL_castz00_bglt) COBJECT(BgL_new1138z00_8778))->BgL_argz00) = ((BgL_nodez00_bglt) BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_argz00_1770, BgL_stackz00_22, BgL_locz00_23, BgL_sitez00_24)), BUNSPEC);
																																																																														BgL_auxz00_19469
																																																																															=
																																																																															BgL_new1138z00_8778;
																																																																													}
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19469);
																																																																											}}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd219382zd2_4440;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11193;
																																																																													BgL_pairz00_11193
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd219382zd2_4440
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_11193);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg3852z00_4441;
																																																																													obj_t
																																																																														BgL_arg3853z00_4442;
																																																																													obj_t
																																																																														BgL_arg3854z00_4443;
																																																																													BgL_arg3852z00_4441
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4440));
																																																																													BgL_arg3853z00_4442
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219382zd2_4440));
																																																																													BgL_arg3854z00_4443
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_19497;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_19500;
																																																																															obj_t
																																																																																BgL_bodyz00_19499;
																																																																															obj_t
																																																																																BgL_varsz00_19498;
																																																																															BgL_varsz00_19498
																																																																																=
																																																																																BgL_arg3852z00_4441;
																																																																															BgL_bodyz00_19499
																																																																																=
																																																																																BgL_arg3853z00_4442;
																																																																															BgL_argsz00_19500
																																																																																=
																																																																																BgL_arg3854z00_4443;
																																																																															BgL_argsz00_1774
																																																																																=
																																																																																BgL_argsz00_19500;
																																																																															BgL_bodyz00_1773
																																																																																=
																																																																																BgL_bodyz00_19499;
																																																																															BgL_varsz00_1772
																																																																																=
																																																																																BgL_varsz00_19498;
																																																																															goto
																																																																																BgL_tagzd2386zd2_1775;
																																																																														}
																																																																														BgL_auxz00_14300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_19497);
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd219408zd2_4446;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_11198;
																																																																									BgL_pairz00_11198
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd219408zd2_4446
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_11198);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg3857z00_4447;
																																																																									obj_t
																																																																										BgL_arg3858z00_4448;
																																																																									obj_t
																																																																										BgL_arg3859z00_4449;
																																																																									BgL_arg3857z00_4447
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4446));
																																																																									BgL_arg3858z00_4448
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd219408zd2_4446));
																																																																									BgL_arg3859z00_4449
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19511;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_19514;
																																																																											obj_t
																																																																												BgL_bodyz00_19513;
																																																																											obj_t
																																																																												BgL_varsz00_19512;
																																																																											BgL_varsz00_19512
																																																																												=
																																																																												BgL_arg3857z00_4447;
																																																																											BgL_bodyz00_19513
																																																																												=
																																																																												BgL_arg3858z00_4448;
																																																																											BgL_argsz00_19514
																																																																												=
																																																																												BgL_arg3859z00_4449;
																																																																											BgL_argsz00_1774
																																																																												=
																																																																												BgL_argsz00_19514;
																																																																											BgL_bodyz00_1773
																																																																												=
																																																																												BgL_bodyz00_19513;
																																																																											BgL_varsz00_1772
																																																																												=
																																																																												BgL_varsz00_19512;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1775;
																																																																										}
																																																																										BgL_auxz00_14300
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19511);
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd219434zd2_4452;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11203;
																																																																							BgL_pairz00_11203
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd219434zd2_4452
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11203);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg3862z00_4453;
																																																																							obj_t
																																																																								BgL_arg3863z00_4454;
																																																																							obj_t
																																																																								BgL_arg3864z00_4455;
																																																																							BgL_arg3862z00_4453
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4452));
																																																																							BgL_arg3863z00_4454
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd219434zd2_4452));
																																																																							BgL_arg3864z00_4455
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_19525;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_19528;
																																																																									obj_t
																																																																										BgL_bodyz00_19527;
																																																																									obj_t
																																																																										BgL_varsz00_19526;
																																																																									BgL_varsz00_19526
																																																																										=
																																																																										BgL_arg3862z00_4453;
																																																																									BgL_bodyz00_19527
																																																																										=
																																																																										BgL_arg3863z00_4454;
																																																																									BgL_argsz00_19528
																																																																										=
																																																																										BgL_arg3864z00_4455;
																																																																									BgL_argsz00_1774
																																																																										=
																																																																										BgL_argsz00_19528;
																																																																									BgL_bodyz00_1773
																																																																										=
																																																																										BgL_bodyz00_19527;
																																																																									BgL_varsz00_1772
																																																																										=
																																																																										BgL_varsz00_19526;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1775;
																																																																								}
																																																																								BgL_auxz00_14300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_19525);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd219460zd2_4457;
																																																																				BgL_cdrzd219460zd2_4457
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_carzd219307zd2_4413));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg3866z00_4458;
																																																																					obj_t
																																																																						BgL_arg3867z00_4459;
																																																																					obj_t
																																																																						BgL_arg3868z00_4460;
																																																																					BgL_arg3866z00_4458
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4457));
																																																																					BgL_arg3867z00_4459
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd219460zd2_4457));
																																																																					BgL_arg3868z00_4460
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19538;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_19541;
																																																																							obj_t
																																																																								BgL_bodyz00_19540;
																																																																							obj_t
																																																																								BgL_varsz00_19539;
																																																																							BgL_varsz00_19539
																																																																								=
																																																																								BgL_arg3866z00_4458;
																																																																							BgL_bodyz00_19540
																																																																								=
																																																																								BgL_arg3867z00_4459;
																																																																							BgL_argsz00_19541
																																																																								=
																																																																								BgL_arg3868z00_4460;
																																																																							BgL_argsz00_1774
																																																																								=
																																																																								BgL_argsz00_19541;
																																																																							BgL_bodyz00_1773
																																																																								=
																																																																								BgL_bodyz00_19540;
																																																																							BgL_varsz00_1772
																																																																								=
																																																																								BgL_varsz00_19539;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1775;
																																																																						}
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19538);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd219486zd2_4462;
																																																																		BgL_cdrzd219486zd2_4462
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd219307zd2_4413));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg3870z00_4463;
																																																																			obj_t
																																																																				BgL_arg3871z00_4464;
																																																																			obj_t
																																																																				BgL_arg3872z00_4465;
																																																																			BgL_arg3870z00_4463
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4462));
																																																																			BgL_arg3871z00_4464
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd219486zd2_4462));
																																																																			BgL_arg3872z00_4465
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_19551;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_19554;
																																																																					obj_t
																																																																						BgL_bodyz00_19553;
																																																																					obj_t
																																																																						BgL_varsz00_19552;
																																																																					BgL_varsz00_19552
																																																																						=
																																																																						BgL_arg3870z00_4463;
																																																																					BgL_bodyz00_19553
																																																																						=
																																																																						BgL_arg3871z00_4464;
																																																																					BgL_argsz00_19554
																																																																						=
																																																																						BgL_arg3872z00_4465;
																																																																					BgL_argsz00_1774
																																																																						=
																																																																						BgL_argsz00_19554;
																																																																					BgL_bodyz00_1773
																																																																						=
																																																																						BgL_bodyz00_19553;
																																																																					BgL_varsz00_1772
																																																																						=
																																																																						BgL_varsz00_19552;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1775;
																																																																				}
																																																																				BgL_auxz00_14300
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_19551);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd219512zd2_4467;
																																																																BgL_cdrzd219512zd2_4467
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd219307zd2_4413));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg3874z00_4468;
																																																																	obj_t
																																																																		BgL_arg3875z00_4469;
																																																																	obj_t
																																																																		BgL_arg3876z00_4470;
																																																																	BgL_arg3874z00_4468
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4467));
																																																																	BgL_arg3875z00_4469
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd219512zd2_4467));
																																																																	BgL_arg3876z00_4470
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19564;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_19567;
																																																																			obj_t
																																																																				BgL_bodyz00_19566;
																																																																			obj_t
																																																																				BgL_varsz00_19565;
																																																																			BgL_varsz00_19565
																																																																				=
																																																																				BgL_arg3874z00_4468;
																																																																			BgL_bodyz00_19566
																																																																				=
																																																																				BgL_arg3875z00_4469;
																																																																			BgL_argsz00_19567
																																																																				=
																																																																				BgL_arg3876z00_4470;
																																																																			BgL_argsz00_1774
																																																																				=
																																																																				BgL_argsz00_19567;
																																																																			BgL_bodyz00_1773
																																																																				=
																																																																				BgL_bodyz00_19566;
																																																																			BgL_varsz00_1772
																																																																				=
																																																																				BgL_varsz00_19565;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1775;
																																																																		}
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19564);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd219538zd2_4473;
																																																														BgL_cdrzd219538zd2_4473
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd219307zd2_4413));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg3879z00_4474;
																																																															obj_t
																																																																BgL_arg3880z00_4475;
																																																															obj_t
																																																																BgL_arg3881z00_4476;
																																																															BgL_arg3879z00_4474
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4473));
																																																															BgL_arg3880z00_4475
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd219538zd2_4473));
																																																															BgL_arg3881z00_4476
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19577;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_19580;
																																																																	obj_t
																																																																		BgL_bodyz00_19579;
																																																																	obj_t
																																																																		BgL_varsz00_19578;
																																																																	BgL_varsz00_19578
																																																																		=
																																																																		BgL_arg3879z00_4474;
																																																																	BgL_bodyz00_19579
																																																																		=
																																																																		BgL_arg3880z00_4475;
																																																																	BgL_argsz00_19580
																																																																		=
																																																																		BgL_arg3881z00_4476;
																																																																	BgL_argsz00_1774
																																																																		=
																																																																		BgL_argsz00_19580;
																																																																	BgL_bodyz00_1773
																																																																		=
																																																																		BgL_bodyz00_19579;
																																																																	BgL_varsz00_1772
																																																																		=
																																																																		BgL_varsz00_19578;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1775;
																																																																}
																																																																BgL_auxz00_14300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19577);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19584;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_14300
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19584);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd219676zd2_4481;
																																																										BgL_cdrzd219676zd2_4481
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd219307zd2_4413));
																																																										if ((CAR(((obj_t) BgL_carzd219307zd2_4413)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd219676zd2_4481))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd219681zd2_4485;
																																																														BgL_cdrzd219681zd2_4485
																																																															=
																																																															CDR
																																																															(BgL_cdrzd219676zd2_4481);
																																																														if (PAIRP(BgL_cdrzd219681zd2_4485))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd219685zd2_4487;
																																																																obj_t
																																																																	BgL_cdrzd219686zd2_4488;
																																																																BgL_carzd219685zd2_4487
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd219681zd2_4485);
																																																																BgL_cdrzd219686zd2_4488
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd219681zd2_4485);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219685zd2_4487))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd219686zd2_4488))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd219691zd2_4491;
																																																																				BgL_carzd219691zd2_4491
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd219686zd2_4488);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219691zd2_4491))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd219686zd2_4488)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test8965z00_19610;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1398z00_4524;
																																																																									BgL_l1398z00_4524
																																																																										=
																																																																										BgL_cdrzd219308zd2_4414;
																																																																								BgL_zc3z04anonymousza33908ze3z87_4525:
																																																																									if (NULLP(BgL_l1398z00_4524))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test8965z00_19610
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test8967z00_19613;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test8968z00_19614;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_19615;
																																																																													BgL_tmpz00_19615
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1398z00_4524));
																																																																													BgL_test8968z00_19614
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_19615);
																																																																												}
																																																																												if (BgL_test8968z00_19614)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8967z00_19613
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test8967z00_19613
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test8967z00_19613)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1398z00_19619;
																																																																													BgL_l1398z00_19619
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1398z00_4524));
																																																																													BgL_l1398z00_4524
																																																																														=
																																																																														BgL_l1398z00_19619;
																																																																													goto
																																																																														BgL_zc3z04anonymousza33908ze3z87_4525;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test8965z00_19610
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test8965z00_19610)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg3898z00_4507;
																																																																										BgL_arg3898z00_4507
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd219676zd2_4481);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19623;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_19627;
																																																																												obj_t
																																																																													BgL_proc2z00_19626;
																																																																												obj_t
																																																																													BgL_proc1z00_19625;
																																																																												obj_t
																																																																													BgL_testz00_19624;
																																																																												BgL_testz00_19624
																																																																													=
																																																																													BgL_arg3898z00_4507;
																																																																												BgL_proc1z00_19625
																																																																													=
																																																																													BgL_carzd219685zd2_4487;
																																																																												BgL_proc2z00_19626
																																																																													=
																																																																													BgL_carzd219691zd2_4491;
																																																																												BgL_argsz00_19627
																																																																													=
																																																																													BgL_cdrzd219308zd2_4414;
																																																																												BgL_argsz00_1779
																																																																													=
																																																																													BgL_argsz00_19627;
																																																																												BgL_proc2z00_1778
																																																																													=
																																																																													BgL_proc2z00_19626;
																																																																												BgL_proc1z00_1777
																																																																													=
																																																																													BgL_proc1z00_19625;
																																																																												BgL_testz00_1776
																																																																													=
																																																																													BgL_testz00_19624;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1780;
																																																																											}
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19623);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd219716zd2_4508;
																																																																										BgL_cdrzd219716zd2_4508
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd219724zd2_4509;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11247;
																																																																												BgL_pairz00_11247
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd219724zd2_4509
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11247);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd219732zd2_4510;
																																																																												BgL_cdrzd219732zd2_4510
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd219724zd2_4509));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd219739zd2_4511;
																																																																													BgL_carzd219739zd2_4511
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd219732zd2_4510));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219739zd2_4511))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd219748zd2_4513;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11251;
																																																																																BgL_pairz00_11251
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd219732zd2_4510));
																																																																																BgL_carzd219748zd2_4513
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11251);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd219748zd2_4513))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd219716zd2_4508))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg3902z00_4516;
																																																																																			BgL_arg3902z00_4516
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd219724zd2_4509));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_19649;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_19653;
																																																																																					obj_t
																																																																																						BgL_proc2z00_19652;
																																																																																					obj_t
																																																																																						BgL_proc1z00_19651;
																																																																																					obj_t
																																																																																						BgL_testz00_19650;
																																																																																					BgL_testz00_19650
																																																																																						=
																																																																																						BgL_arg3902z00_4516;
																																																																																					BgL_proc1z00_19651
																																																																																						=
																																																																																						BgL_carzd219739zd2_4511;
																																																																																					BgL_proc2z00_19652
																																																																																						=
																																																																																						BgL_carzd219748zd2_4513;
																																																																																					BgL_argsz00_19653
																																																																																						=
																																																																																						BgL_cdrzd219716zd2_4508;
																																																																																					BgL_argsz00_1784
																																																																																						=
																																																																																						BgL_argsz00_19653;
																																																																																					BgL_proc2z00_1783
																																																																																						=
																																																																																						BgL_proc2z00_19652;
																																																																																					BgL_proc1z00_1782
																																																																																						=
																																																																																						BgL_proc1z00_19651;
																																																																																					BgL_testz00_1781
																																																																																						=
																																																																																						BgL_testz00_19650;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1785;
																																																																																				}
																																																																																				BgL_auxz00_14300
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_19649);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_19657;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_14300
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_19657);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19661;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19661);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19665;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19665);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_19669;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_14300
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_19669);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd220026zd2_4535;
																																																																						BgL_cdrzd220026zd2_4535
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd220033zd2_4536;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11255;
																																																																								BgL_pairz00_11255
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd220033zd2_4536
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11255);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd220040zd2_4537;
																																																																								BgL_cdrzd220040zd2_4537
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd220033zd2_4536));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd220046zd2_4538;
																																																																									obj_t
																																																																										BgL_cdrzd220047zd2_4539;
																																																																									BgL_carzd220046zd2_4538
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4537));
																																																																									BgL_cdrzd220047zd2_4539
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd220040zd2_4537));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220046zd2_4538))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd220054zd2_4541;
																																																																											BgL_carzd220054zd2_4541
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd220047zd2_4539));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220054zd2_4541))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd220047zd2_4539))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220026zd2_4535))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg3917z00_4546;
																																																																																	BgL_arg3917z00_4546
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd220033zd2_4536));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_19696;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_19700;
																																																																																			obj_t
																																																																																				BgL_proc2z00_19699;
																																																																																			obj_t
																																																																																				BgL_proc1z00_19698;
																																																																																			obj_t
																																																																																				BgL_testz00_19697;
																																																																																			BgL_testz00_19697
																																																																																				=
																																																																																				BgL_arg3917z00_4546;
																																																																																			BgL_proc1z00_19698
																																																																																				=
																																																																																				BgL_carzd220046zd2_4538;
																																																																																			BgL_proc2z00_19699
																																																																																				=
																																																																																				BgL_carzd220054zd2_4541;
																																																																																			BgL_argsz00_19700
																																																																																				=
																																																																																				BgL_cdrzd220026zd2_4535;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_19700;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_19699;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_19698;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_19697;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_14300
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_19696);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_19704;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_14300
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_19704);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19708;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19708);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19712;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19712);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19716;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19716);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_19720;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_19720);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd220387zd2_4554;
																																																																		BgL_cdrzd220387zd2_4554
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd220393zd2_4555;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11265;
																																																																				BgL_pairz00_11265
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd220393zd2_4555
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11265);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd220399zd2_4556;
																																																																				BgL_cdrzd220399zd2_4556
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd220393zd2_4555));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd220404zd2_4557;
																																																																					obj_t
																																																																						BgL_cdrzd220405zd2_4558;
																																																																					BgL_carzd220404zd2_4557
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4556));
																																																																					BgL_cdrzd220405zd2_4558
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd220399zd2_4556));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220404zd2_4557))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd220405zd2_4558))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd220410zd2_4561;
																																																																									BgL_carzd220410zd2_4561
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd220405zd2_4558);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd220410zd2_4561))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd220405zd2_4558)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd220387zd2_4554))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg3931z00_4566;
																																																																															BgL_arg3931z00_4566
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd220393zd2_4555));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_19747;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_19751;
																																																																																	obj_t
																																																																																		BgL_proc2z00_19750;
																																																																																	obj_t
																																																																																		BgL_proc1z00_19749;
																																																																																	obj_t
																																																																																		BgL_testz00_19748;
																																																																																	BgL_testz00_19748
																																																																																		=
																																																																																		BgL_arg3931z00_4566;
																																																																																	BgL_proc1z00_19749
																																																																																		=
																																																																																		BgL_carzd220404zd2_4557;
																																																																																	BgL_proc2z00_19750
																																																																																		=
																																																																																		BgL_carzd220410zd2_4561;
																																																																																	BgL_argsz00_19751
																																																																																		=
																																																																																		BgL_cdrzd220387zd2_4554;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_19751;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_19750;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_19749;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_19748;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_19747);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_19755;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_19755);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_19759;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_19759);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_19763;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_19763);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19767;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19767);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_19771;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_19771);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_19775;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_19775);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19779;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_14300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19779);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_19783;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_14300
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_19783);
																																																													}
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_cdrzd220948zd2_4730;
																																							BgL_cdrzd220948zd2_4730
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd217644zd2_4396 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg4048z00_4732;
																																									obj_t
																																										BgL_arg4049z00_4733;
																																									BgL_arg4048z00_4732
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4730));
																																									BgL_arg4049z00_4733
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd220948zd2_4730));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_19794;
																																										{
																																											obj_t
																																												BgL_exprz00_19796;
																																											obj_t
																																												BgL_bindingsz00_19795;
																																											BgL_bindingsz00_19795
																																												=
																																												BgL_arg4048z00_4732;
																																											BgL_exprz00_19796
																																												=
																																												BgL_arg4049z00_4733;
																																											BgL_exprz00_1764
																																												=
																																												BgL_exprz00_19796;
																																											BgL_bindingsz00_1763
																																												=
																																												BgL_bindingsz00_19795;
																																											goto
																																												BgL_tagzd2382zd2_1765;
																																										}
																																										BgL_auxz00_14300
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_19794);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd217644zd2_4396)))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4051z00_4735;
																																											obj_t
																																												BgL_arg4052z00_4736;
																																											BgL_arg4051z00_4735
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4730));
																																											BgL_arg4052z00_4736
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd220948zd2_4730));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_19805;
																																												{
																																													obj_t
																																														BgL_exprz00_19807;
																																													obj_t
																																														BgL_bindingsz00_19806;
																																													BgL_bindingsz00_19806
																																														=
																																														BgL_arg4051z00_4735;
																																													BgL_exprz00_19807
																																														=
																																														BgL_arg4052z00_4736;
																																													BgL_exprz00_1764
																																														=
																																														BgL_exprz00_19807;
																																													BgL_bindingsz00_1763
																																														=
																																														BgL_bindingsz00_19806;
																																													goto
																																														BgL_tagzd2382zd2_1765;
																																												}
																																												BgL_auxz00_14300
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_19805);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd217644zd2_4396 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4054z00_4738;
																																													obj_t
																																														BgL_arg4055z00_4739;
																																													BgL_arg4054z00_4738
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4730));
																																													BgL_arg4055z00_4739
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd220948zd2_4730));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_19816;
																																														{
																																															obj_t
																																																BgL_exprz00_19818;
																																															obj_t
																																																BgL_bindingsz00_19817;
																																															BgL_bindingsz00_19817
																																																=
																																																BgL_arg4054z00_4738;
																																															BgL_exprz00_19818
																																																=
																																																BgL_arg4055z00_4739;
																																															BgL_exprz00_1764
																																																=
																																																BgL_exprz00_19818;
																																															BgL_bindingsz00_1763
																																																=
																																																BgL_bindingsz00_19817;
																																															goto
																																																BgL_tagzd2382zd2_1765;
																																														}
																																														BgL_auxz00_14300
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_19816);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19825;
																																															goto
																																																BgL_tagzd2383zd2_1766;
																																															BgL_auxz00_14300
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19825);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd220985zd2_4742;
																																															BgL_carzd220985zd2_4742
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd220985zd2_4742 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_19832;
																																																	goto
																																																		BgL_tagzd2384zd2_1767;
																																																	BgL_auxz00_14300
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_19832);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd220985zd2_4742)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_19837;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_19837);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_19844;
																																																					goto
																																																						BgL_tagzd2389zd2_1786;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_19844);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_19851;
																																																							goto
																																																								BgL_tagzd2390zd2_1787;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_19851);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd221065zd2_4749;
																																																							BgL_cdrzd221065zd2_4749
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg4066z00_4752;
																																																									obj_t
																																																										BgL_arg4067z00_4753;
																																																									BgL_arg4066z00_4752
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4749));
																																																									BgL_arg4067z00_4753
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd221065zd2_4749));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_19864;
																																																										{
																																																											obj_t
																																																												BgL_restz00_19866;
																																																											obj_t
																																																												BgL_effectz00_19865;
																																																											BgL_effectz00_19865
																																																												=
																																																												BgL_arg4066z00_4752;
																																																											BgL_restz00_19866
																																																												=
																																																												BgL_arg4067z00_4753;
																																																											BgL_restz00_1789
																																																												=
																																																												BgL_restz00_19866;
																																																											BgL_effectz00_1788
																																																												=
																																																												BgL_effectz00_19865;
																																																											goto
																																																												BgL_tagzd2391zd2_1790;
																																																										}
																																																										BgL_auxz00_14300
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_19864);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_19873;
																																																											goto
																																																												BgL_tagzd2392zd2_1791;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_19873);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_19880;
																																																													goto
																																																														BgL_tagzd2393zd2_1792;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_19880);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg4074z00_4761;
																																																															obj_t
																																																																BgL_arg4075z00_4762;
																																																															BgL_arg4074z00_4761
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4749));
																																																															BgL_arg4075z00_4762
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221065zd2_4749));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_19891;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_19893;
																																																																	obj_t
																																																																		BgL_effectz00_19892;
																																																																	BgL_effectz00_19892
																																																																		=
																																																																		BgL_arg4074z00_4761;
																																																																	BgL_restz00_19893
																																																																		=
																																																																		BgL_arg4075z00_4762;
																																																																	BgL_restz00_1794
																																																																		=
																																																																		BgL_restz00_19893;
																																																																	BgL_effectz00_1793
																																																																		=
																																																																		BgL_effectz00_19892;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1795;
																																																																}
																																																																BgL_auxz00_14300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_19891);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_19900;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1796;
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_19900);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_19907;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1797;
																																																																			BgL_auxz00_14300
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_19907);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_19914;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1798;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_19914);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_19921;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1799;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_19921);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd221142zd2_4771;
																																																																							BgL_cdrzd221142zd2_4771
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg4086z00_4774;
																																																																									obj_t
																																																																										BgL_arg4087z00_4775;
																																																																									BgL_arg4086z00_4774
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4771));
																																																																									BgL_arg4087z00_4775
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd221142zd2_4771));
																																																																									{	/* Ast/sexp.scm 555 */
																																																																										obj_t
																																																																											BgL_arg7015z00_11304;
																																																																										BgL_arg7015z00_11304
																																																																											=
																																																																											BGl_findzd2locationzf2locz20zztools_locationz00
																																																																											(BgL_expz00_21,
																																																																											BgL_locz00_23);
																																																																										BgL_auxz00_14300
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																											(BgL_expz00_21,
																																																																												BgL_arg4086z00_4774,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4087z00_4775, BgL_stackz00_22, BgL_arg7015z00_11304, BgL_sitez00_24));
																																																																								}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_19940;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_19940);
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_carzd221167zd2_4791;
																											BgL_carzd221167zd2_4791 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd221167zd2_4791
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_19947;
																													goto
																														BgL_tagzd2377zd2_1754;
																													BgL_auxz00_14300 =
																														((obj_t)
																														BgL_auxz00_19947);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(BgL_carzd221167zd2_4791
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_19951;
																															goto
																																BgL_tagzd2377zd2_1754;
																															BgL_auxz00_14300 =
																																((obj_t)
																																BgL_auxz00_19951);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_19958;
																																	goto
																																		BgL_tagzd2379zd2_1758;
																																	BgL_auxz00_14300
																																		=
																																		((obj_t)
																																		BgL_auxz00_19958);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_19965;
																																			goto
																																				BgL_tagzd2380zd2_1759;
																																			BgL_auxz00_14300
																																				=
																																				((obj_t)
																																				BgL_auxz00_19965);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd221236zd2_4798;
																																			BgL_carzd221236zd2_4798
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd221236zd2_4798))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd221239zd2_4800;
																																					obj_t
																																						BgL_cdrzd221240zd2_4801;
																																					BgL_carzd221239zd2_4800
																																						=
																																						CAR
																																						(BgL_carzd221236zd2_4798);
																																					BgL_cdrzd221240zd2_4801
																																						=
																																						CDR
																																						(BgL_carzd221236zd2_4798);
																																					{

																																						if (
																																							(BgL_carzd221239zd2_4800
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 119 */
																																							BgL_kapzd221241zd2_4802:
																																								if (PAIRP(BgL_cdrzd221240zd2_4801))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd221244zd2_4921;
																																										BgL_cdrzd221244zd2_4921
																																											=
																																											CDR
																																											(BgL_cdrzd221240zd2_4801);
																																										if (PAIRP(BgL_cdrzd221244zd2_4921))
																																											{	/* Ast/sexp.scm 119 */
																																												if (NULLP(CDR(BgL_cdrzd221244zd2_4921)))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg4189z00_4925;
																																														obj_t
																																															BgL_arg4190z00_4926;
																																														BgL_arg4189z00_4925
																																															=
																																															CAR
																																															(BgL_cdrzd221244zd2_4921);
																																														BgL_arg4190z00_4926
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_19987;
																																															{
																																																obj_t
																																																	BgL_argsz00_19989;
																																																obj_t
																																																	BgL_bodyz00_19988;
																																																BgL_bodyz00_19988
																																																	=
																																																	BgL_arg4189z00_4925;
																																																BgL_argsz00_19989
																																																	=
																																																	BgL_arg4190z00_4926;
																																																BgL_argsz00_1761
																																																	=
																																																	BgL_argsz00_19989;
																																																BgL_bodyz00_1760
																																																	=
																																																	BgL_bodyz00_19988;
																																																goto
																																																	BgL_tagzd2381zd2_1762;
																																															}
																																															BgL_auxz00_14300
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_19987);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9025z00_19991;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4254z00_5032;
																																															BgL_arg4254z00_5032
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9025z00_19991
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4254z00_5032));
																																														}
																																														if (BgL_test9025z00_19991)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_19996;
																																																goto
																																																	BgL_tagzd2384zd2_1767;
																																																BgL_auxz00_14300
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_19996);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd221322zd2_4929;
																																																BgL_carzd221322zd2_4929
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd221327zd2_4930;
																																																	BgL_cdrzd221327zd2_4930
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd221322zd2_4929));
																																																	if ((CAR(((obj_t) BgL_carzd221322zd2_4929)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4195z00_4933;
																																																			obj_t
																																																				BgL_arg4196z00_4934;
																																																			obj_t
																																																				BgL_arg4197z00_4935;
																																																			BgL_arg4195z00_4933
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4930));
																																																			BgL_arg4196z00_4934
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd221327zd2_4930));
																																																			BgL_arg4197z00_4935
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_20013;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_20016;
																																																					obj_t
																																																						BgL_bodyz00_20015;
																																																					obj_t
																																																						BgL_varsz00_20014;
																																																					BgL_varsz00_20014
																																																						=
																																																						BgL_arg4195z00_4933;
																																																					BgL_bodyz00_20015
																																																						=
																																																						BgL_arg4196z00_4934;
																																																					BgL_argsz00_20016
																																																						=
																																																						BgL_arg4197z00_4935;
																																																					BgL_argsz00_1774
																																																						=
																																																						BgL_argsz00_20016;
																																																					BgL_bodyz00_1773
																																																						=
																																																						BgL_bodyz00_20015;
																																																					BgL_varsz00_1772
																																																						=
																																																						BgL_varsz00_20014;
																																																					goto
																																																						BgL_tagzd2386zd2_1775;
																																																				}
																																																				BgL_auxz00_14300
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_20013);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd221350zd2_4937;
																																																			BgL_cdrzd221350zd2_4937
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd221356zd2_4938;
																																																				BgL_cdrzd221356zd2_4938
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd221322zd2_4929));
																																																				if ((CAR(((obj_t) BgL_carzd221322zd2_4929)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd221362zd2_4941;
																																																						BgL_cdrzd221362zd2_4941
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd221356zd2_4938));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd221367zd2_4942;
																																																							obj_t
																																																								BgL_cdrzd221368zd2_4943;
																																																							BgL_carzd221367zd2_4942
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4941));
																																																							BgL_cdrzd221368zd2_4943
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd221362zd2_4941));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221367zd2_4942))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd221368zd2_4943))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd221375zd2_4946;
																																																											BgL_carzd221375zd2_4946
																																																												=
																																																												CAR
																																																												(BgL_cdrzd221368zd2_4943);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221375zd2_4946))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(BgL_cdrzd221368zd2_4943)))
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test9032z00_20043;
																																																															{
																																																																obj_t
																																																																	BgL_l1401z00_4979;
																																																																BgL_l1401z00_4979
																																																																	=
																																																																	BgL_cdrzd221350zd2_4937;
																																																															BgL_zc3z04anonymousza34220ze3z87_4980:
																																																																if (NULLP(BgL_l1401z00_4979))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test9032z00_20043
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test9034z00_20046;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test9035z00_20047;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_tmpz00_20048;
																																																																				BgL_tmpz00_20048
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1401z00_4979));
																																																																				BgL_test9035z00_20047
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_20048);
																																																																			}
																																																																			if (BgL_test9035z00_20047)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test9034z00_20046
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test9034z00_20046
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_test9034z00_20046)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1401z00_20052;
																																																																				BgL_l1401z00_20052
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1401z00_4979));
																																																																				BgL_l1401z00_4979
																																																																					=
																																																																					BgL_l1401z00_20052;
																																																																				goto
																																																																					BgL_zc3z04anonymousza34220ze3z87_4980;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test9032z00_20043
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_test9032z00_20043)
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg4210z00_4962;
																																																																	BgL_arg4210z00_4962
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd221356zd2_4938));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20057;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_20061;
																																																																			obj_t
																																																																				BgL_proc2z00_20060;
																																																																			obj_t
																																																																				BgL_proc1z00_20059;
																																																																			obj_t
																																																																				BgL_testz00_20058;
																																																																			BgL_testz00_20058
																																																																				=
																																																																				BgL_arg4210z00_4962;
																																																																			BgL_proc1z00_20059
																																																																				=
																																																																				BgL_carzd221367zd2_4942;
																																																																			BgL_proc2z00_20060
																																																																				=
																																																																				BgL_carzd221375zd2_4946;
																																																																			BgL_argsz00_20061
																																																																				=
																																																																				BgL_cdrzd221350zd2_4937;
																																																																			BgL_argsz00_1779
																																																																				=
																																																																				BgL_argsz00_20061;
																																																																			BgL_proc2z00_1778
																																																																				=
																																																																				BgL_proc2z00_20060;
																																																																			BgL_proc1z00_1777
																																																																				=
																																																																				BgL_proc1z00_20059;
																																																																			BgL_testz00_1776
																																																																				=
																																																																				BgL_testz00_20058;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1780;
																																																																		}
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20057);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd221399zd2_4963;
																																																																	BgL_cdrzd221399zd2_4963
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd221406zd2_4964;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_11344;
																																																																			BgL_pairz00_11344
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd221406zd2_4964
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11344);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd221413zd2_4965;
																																																																			BgL_cdrzd221413zd2_4965
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd221406zd2_4964));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd221419zd2_4966;
																																																																				BgL_carzd221419zd2_4966
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd221413zd2_4965));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221419zd2_4966))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd221426zd2_4968;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11348;
																																																																							BgL_pairz00_11348
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd221413zd2_4965));
																																																																							BgL_carzd221426zd2_4968
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_11348);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221426zd2_4968))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221399zd2_4963))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4214z00_4971;
																																																																										BgL_arg4214z00_4971
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd221406zd2_4964));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20083;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20087;
																																																																												obj_t
																																																																													BgL_proc2z00_20086;
																																																																												obj_t
																																																																													BgL_proc1z00_20085;
																																																																												obj_t
																																																																													BgL_testz00_20084;
																																																																												BgL_testz00_20084
																																																																													=
																																																																													BgL_arg4214z00_4971;
																																																																												BgL_proc1z00_20085
																																																																													=
																																																																													BgL_carzd221419zd2_4966;
																																																																												BgL_proc2z00_20086
																																																																													=
																																																																													BgL_carzd221426zd2_4968;
																																																																												BgL_argsz00_20087
																																																																													=
																																																																													BgL_cdrzd221399zd2_4963;
																																																																												BgL_argsz00_1784
																																																																													=
																																																																													BgL_argsz00_20087;
																																																																												BgL_proc2z00_1783
																																																																													=
																																																																													BgL_proc2z00_20086;
																																																																												BgL_proc1z00_1782
																																																																													=
																																																																													BgL_proc1z00_20085;
																																																																												BgL_testz00_1781
																																																																													=
																																																																													BgL_testz00_20084;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1785;
																																																																											}
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20083);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20091;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_14300
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20091);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20095;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_14300
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20095);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20099;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_14300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20099);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20103;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20103);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd221702zd2_4990;
																																																													BgL_cdrzd221702zd2_4990
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd221708zd2_4991;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_11352;
																																																															BgL_pairz00_11352
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd221708zd2_4991
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11352);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd221714zd2_4992;
																																																															BgL_cdrzd221714zd2_4992
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd221708zd2_4991));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd221719zd2_4993;
																																																																obj_t
																																																																	BgL_cdrzd221720zd2_4994;
																																																																BgL_carzd221719zd2_4993
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_4992));
																																																																BgL_cdrzd221720zd2_4994
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd221714zd2_4992));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221719zd2_4993))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd221725zd2_4996;
																																																																		BgL_carzd221725zd2_4996
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd221720zd2_4994));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd221725zd2_4996))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd221720zd2_4994))))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd221702zd2_4990))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4229z00_5001;
																																																																								BgL_arg4229z00_5001
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd221708zd2_4991));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20130;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_20134;
																																																																										obj_t
																																																																											BgL_proc2z00_20133;
																																																																										obj_t
																																																																											BgL_proc1z00_20132;
																																																																										obj_t
																																																																											BgL_testz00_20131;
																																																																										BgL_testz00_20131
																																																																											=
																																																																											BgL_arg4229z00_5001;
																																																																										BgL_proc1z00_20132
																																																																											=
																																																																											BgL_carzd221719zd2_4993;
																																																																										BgL_proc2z00_20133
																																																																											=
																																																																											BgL_carzd221725zd2_4996;
																																																																										BgL_argsz00_20134
																																																																											=
																																																																											BgL_cdrzd221702zd2_4990;
																																																																										BgL_argsz00_1784
																																																																											=
																																																																											BgL_argsz00_20134;
																																																																										BgL_proc2z00_1783
																																																																											=
																																																																											BgL_proc2z00_20133;
																																																																										BgL_proc1z00_1782
																																																																											=
																																																																											BgL_proc1z00_20132;
																																																																										BgL_testz00_1781
																																																																											=
																																																																											BgL_testz00_20131;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1785;
																																																																									}
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20130);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20138;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_14300
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20138);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20142;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_14300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20142);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20146;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20146);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20150;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_14300
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20150);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_20154;
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																													BgL_auxz00_14300
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_20154);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd222058zd2_5009;
																																																									BgL_cdrzd222058zd2_5009
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd222065zd2_5010;
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_pairz00_11362;
																																																											BgL_pairz00_11362
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd222065zd2_5010
																																																												=
																																																												CDR
																																																												(BgL_pairz00_11362);
																																																										}
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd222072zd2_5011;
																																																											BgL_cdrzd222072zd2_5011
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd222065zd2_5010));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd222078zd2_5012;
																																																												obj_t
																																																													BgL_cdrzd222079zd2_5013;
																																																												BgL_carzd222078zd2_5012
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_5011));
																																																												BgL_cdrzd222079zd2_5013
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd222072zd2_5011));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222078zd2_5012))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd222079zd2_5013))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd222086zd2_5016;
																																																																BgL_carzd222086zd2_5016
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222079zd2_5013);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222086zd2_5016))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd222079zd2_5013)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd222058zd2_5009))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4243z00_5021;
																																																																						BgL_arg4243z00_5021
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd222065zd2_5010));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20181;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_20185;
																																																																								obj_t
																																																																									BgL_proc2z00_20184;
																																																																								obj_t
																																																																									BgL_proc1z00_20183;
																																																																								obj_t
																																																																									BgL_testz00_20182;
																																																																								BgL_testz00_20182
																																																																									=
																																																																									BgL_arg4243z00_5021;
																																																																								BgL_proc1z00_20183
																																																																									=
																																																																									BgL_carzd222078zd2_5012;
																																																																								BgL_proc2z00_20184
																																																																									=
																																																																									BgL_carzd222086zd2_5016;
																																																																								BgL_argsz00_20185
																																																																									=
																																																																									BgL_cdrzd222058zd2_5009;
																																																																								BgL_argsz00_1784
																																																																									=
																																																																									BgL_argsz00_20185;
																																																																								BgL_proc2z00_1783
																																																																									=
																																																																									BgL_proc2z00_20184;
																																																																								BgL_proc1z00_1782
																																																																									=
																																																																									BgL_proc1z00_20183;
																																																																								BgL_testz00_1781
																																																																									=
																																																																									BgL_testz00_20182;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1785;
																																																																							}
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20181);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20189;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_14300
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20189);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20193;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20193);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20197;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_14300
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20197);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20201;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20201);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_20205;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_14300
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_20205);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1809;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20209;
																																																								goto
																																																									BgL_tagzd2404zd2_1810;
																																																								BgL_auxz00_14300
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20209);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9063z00_20211;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4265z00_5045;
																																													BgL_arg4265z00_5045
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9063z00_20211
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4265z00_5045));
																																												}
																																												if (BgL_test9063z00_20211)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_20216;
																																														goto
																																															BgL_tagzd2384zd2_1767;
																																														BgL_auxz00_14300
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20216);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd222532zd2_5036;
																																														BgL_carzd222532zd2_5036
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd222537zd2_5037;
																																															BgL_cdrzd222537zd2_5037
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd222532zd2_5036));
																																															if ((CAR(((obj_t) BgL_carzd222532zd2_5036)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4260z00_5040;
																																																	obj_t
																																																		BgL_arg4261z00_5041;
																																																	obj_t
																																																		BgL_arg4262z00_5042;
																																																	BgL_arg4260z00_5040
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_5037));
																																																	BgL_arg4261z00_5041
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd222537zd2_5037));
																																																	BgL_arg4262z00_5042
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_20233;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_20236;
																																																			obj_t
																																																				BgL_bodyz00_20235;
																																																			obj_t
																																																				BgL_varsz00_20234;
																																																			BgL_varsz00_20234
																																																				=
																																																				BgL_arg4260z00_5040;
																																																			BgL_bodyz00_20235
																																																				=
																																																				BgL_arg4261z00_5041;
																																																			BgL_argsz00_20236
																																																				=
																																																				BgL_arg4262z00_5042;
																																																			BgL_argsz00_1774
																																																				=
																																																				BgL_argsz00_20236;
																																																			BgL_bodyz00_1773
																																																				=
																																																				BgL_bodyz00_20235;
																																																			BgL_varsz00_1772
																																																				=
																																																				BgL_varsz00_20234;
																																																			goto
																																																				BgL_tagzd2386zd2_1775;
																																																		}
																																																		BgL_auxz00_14300
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20233);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1809;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20240;
																																																			goto
																																																				BgL_tagzd2404zd2_1810;
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20240);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test9066z00_20242;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4269z00_5049;
																																											BgL_arg4269z00_5049
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9066z00_20242
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4269z00_5049));
																																										}
																																										if (BgL_test9066z00_20242)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_20247;
																																												goto
																																													BgL_tagzd2384zd2_1767;
																																												BgL_auxz00_14300
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_20247);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd2403zd2_1809;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_20251;
																																														goto
																																															BgL_tagzd2404zd2_1810;
																																														BgL_auxz00_14300
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_20251);
																																													}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd221239zd2_4800)))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd221241zd2_4802;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd221239zd2_4800 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd221241zd2_4802;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd221239zd2_4800 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd221241zd2_4802;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd221239zd2_4800)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd221241zd2_4802;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9072z00_20265;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4184z00_4919;
																																																	BgL_arg4184z00_4919
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9072z00_20265
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4184z00_4919));
																																																}
																																																if (BgL_test9072z00_20265)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20270;
																																																		goto
																																																			BgL_tagzd2384zd2_1767;
																																																		BgL_auxz00_14300
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20270);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd222860zd2_4810;
																																																		BgL_carzd222860zd2_4810
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd222865zd2_4811;
																																																			BgL_cdrzd222865zd2_4811
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd222860zd2_4810));
																																																			if ((CAR(((obj_t) BgL_carzd222860zd2_4810)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd222865zd2_4811))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg4120z00_4815;
																																																							obj_t
																																																								BgL_arg4121z00_4816;
																																																							obj_t
																																																								BgL_arg4122z00_4817;
																																																							BgL_arg4120z00_4815
																																																								=
																																																								CAR
																																																								(BgL_cdrzd222865zd2_4811);
																																																							BgL_arg4121z00_4816
																																																								=
																																																								CDR
																																																								(BgL_cdrzd222865zd2_4811);
																																																							BgL_arg4122z00_4817
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20287;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20290;
																																																									obj_t
																																																										BgL_bodyz00_20289;
																																																									obj_t
																																																										BgL_varsz00_20288;
																																																									BgL_varsz00_20288
																																																										=
																																																										BgL_arg4120z00_4815;
																																																									BgL_bodyz00_20289
																																																										=
																																																										BgL_arg4121z00_4816;
																																																									BgL_argsz00_20290
																																																										=
																																																										BgL_arg4122z00_4817;
																																																									BgL_argsz00_1774
																																																										=
																																																										BgL_argsz00_20290;
																																																									BgL_bodyz00_1773
																																																										=
																																																										BgL_bodyz00_20289;
																																																									BgL_varsz00_1772
																																																										=
																																																										BgL_varsz00_20288;
																																																									goto
																																																										BgL_tagzd2386zd2_1775;
																																																								}
																																																								BgL_auxz00_14300
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20287);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1809;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_20294;
																																																									goto
																																																										BgL_tagzd2404zd2_1810;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_20294);
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd222972zd2_4820;
																																																					BgL_cdrzd222972zd2_4820
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd222977zd2_4821;
																																																						BgL_cdrzd222977zd2_4821
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd222860zd2_4810));
																																																						if ((CAR(((obj_t) BgL_carzd222860zd2_4810)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (PAIRP(BgL_cdrzd222977zd2_4821))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd222982zd2_4825;
																																																										BgL_cdrzd222982zd2_4825
																																																											=
																																																											CDR
																																																											(BgL_cdrzd222977zd2_4821);
																																																										if (PAIRP(BgL_cdrzd222982zd2_4825))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd222986zd2_4827;
																																																												obj_t
																																																													BgL_cdrzd222987zd2_4828;
																																																												BgL_carzd222986zd2_4827
																																																													=
																																																													CAR
																																																													(BgL_cdrzd222982zd2_4825);
																																																												BgL_cdrzd222987zd2_4828
																																																													=
																																																													CDR
																																																													(BgL_cdrzd222982zd2_4825);
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222986zd2_4827))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd222987zd2_4828))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd222992zd2_4831;
																																																																BgL_carzd222992zd2_4831
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd222987zd2_4828);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd222992zd2_4831))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd222987zd2_4828)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test9083z00_20322;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1404z00_4864;
																																																																					BgL_l1404z00_4864
																																																																						=
																																																																						BgL_cdrzd222972zd2_4820;
																																																																				BgL_zc3z04anonymousza34148ze3z87_4865:
																																																																					if (NULLP(BgL_l1404z00_4864))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9083z00_20322
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test9085z00_20325;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9086z00_20326;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_20327;
																																																																									BgL_tmpz00_20327
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1404z00_4864));
																																																																									BgL_test9086z00_20326
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_20327);
																																																																								}
																																																																								if (BgL_test9086z00_20326)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9085z00_20325
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9085z00_20325
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test9085z00_20325)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1404z00_20331;
																																																																									BgL_l1404z00_20331
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1404z00_4864));
																																																																									BgL_l1404z00_4864
																																																																										=
																																																																										BgL_l1404z00_20331;
																																																																									goto
																																																																										BgL_zc3z04anonymousza34148ze3z87_4865;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9083z00_20322
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test9083z00_20322)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4138z00_4847;
																																																																						BgL_arg4138z00_4847
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd222977zd2_4821);
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20335;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_20339;
																																																																								obj_t
																																																																									BgL_proc2z00_20338;
																																																																								obj_t
																																																																									BgL_proc1z00_20337;
																																																																								obj_t
																																																																									BgL_testz00_20336;
																																																																								BgL_testz00_20336
																																																																									=
																																																																									BgL_arg4138z00_4847;
																																																																								BgL_proc1z00_20337
																																																																									=
																																																																									BgL_carzd222986zd2_4827;
																																																																								BgL_proc2z00_20338
																																																																									=
																																																																									BgL_carzd222992zd2_4831;
																																																																								BgL_argsz00_20339
																																																																									=
																																																																									BgL_cdrzd222972zd2_4820;
																																																																								BgL_argsz00_1779
																																																																									=
																																																																									BgL_argsz00_20339;
																																																																								BgL_proc2z00_1778
																																																																									=
																																																																									BgL_proc2z00_20338;
																																																																								BgL_proc1z00_1777
																																																																									=
																																																																									BgL_proc1z00_20337;
																																																																								BgL_testz00_1776
																																																																									=
																																																																									BgL_testz00_20336;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1780;
																																																																							}
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20335);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd223017zd2_4848;
																																																																						BgL_cdrzd223017zd2_4848
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd223025zd2_4849;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11407;
																																																																								BgL_pairz00_11407
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd223025zd2_4849
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11407);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd223033zd2_4850;
																																																																								BgL_cdrzd223033zd2_4850
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd223025zd2_4849));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd223040zd2_4851;
																																																																									BgL_carzd223040zd2_4851
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd223033zd2_4850));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223040zd2_4851))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd223049zd2_4853;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11411;
																																																																												BgL_pairz00_11411
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd223033zd2_4850));
																																																																												BgL_carzd223049zd2_4853
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_11411);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223049zd2_4853))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223017zd2_4848))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg4142z00_4856;
																																																																															BgL_arg4142z00_4856
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd223025zd2_4849));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20361;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_20365;
																																																																																	obj_t
																																																																																		BgL_proc2z00_20364;
																																																																																	obj_t
																																																																																		BgL_proc1z00_20363;
																																																																																	obj_t
																																																																																		BgL_testz00_20362;
																																																																																	BgL_testz00_20362
																																																																																		=
																																																																																		BgL_arg4142z00_4856;
																																																																																	BgL_proc1z00_20363
																																																																																		=
																																																																																		BgL_carzd223040zd2_4851;
																																																																																	BgL_proc2z00_20364
																																																																																		=
																																																																																		BgL_carzd223049zd2_4853;
																																																																																	BgL_argsz00_20365
																																																																																		=
																																																																																		BgL_cdrzd223017zd2_4848;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_20365;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_20364;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_20363;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_20362;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_14300
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20361);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_20369;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_14300
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_20369);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20373;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20373);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20377;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20377);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20381;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_14300
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20381);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd223327zd2_4875;
																																																																		BgL_cdrzd223327zd2_4875
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd223334zd2_4876;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11415;
																																																																				BgL_pairz00_11415
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd223334zd2_4876
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11415);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd223341zd2_4877;
																																																																				BgL_cdrzd223341zd2_4877
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd223334zd2_4876));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd223347zd2_4878;
																																																																					obj_t
																																																																						BgL_cdrzd223348zd2_4879;
																																																																					BgL_carzd223347zd2_4878
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4877));
																																																																					BgL_cdrzd223348zd2_4879
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd223341zd2_4877));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223347zd2_4878))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd223355zd2_4881;
																																																																							BgL_carzd223355zd2_4881
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd223348zd2_4879));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223355zd2_4881))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd223348zd2_4879))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223327zd2_4875))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4157z00_4886;
																																																																													BgL_arg4157z00_4886
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd223334zd2_4876));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20408;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_20412;
																																																																															obj_t
																																																																																BgL_proc2z00_20411;
																																																																															obj_t
																																																																																BgL_proc1z00_20410;
																																																																															obj_t
																																																																																BgL_testz00_20409;
																																																																															BgL_testz00_20409
																																																																																=
																																																																																BgL_arg4157z00_4886;
																																																																															BgL_proc1z00_20410
																																																																																=
																																																																																BgL_carzd223347zd2_4878;
																																																																															BgL_proc2z00_20411
																																																																																=
																																																																																BgL_carzd223355zd2_4881;
																																																																															BgL_argsz00_20412
																																																																																=
																																																																																BgL_cdrzd223327zd2_4875;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_20412;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_20411;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_20410;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_20409;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_14300
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20408);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20416;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_14300
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20416);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20420;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20420);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20424;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20424);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20428;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20428);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_20432;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_14300
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_20432);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd223688zd2_4894;
																																																														BgL_cdrzd223688zd2_4894
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd223694zd2_4895;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_11425;
																																																																BgL_pairz00_11425
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd223694zd2_4895
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_11425);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd223700zd2_4896;
																																																																BgL_cdrzd223700zd2_4896
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd223694zd2_4895));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd223705zd2_4897;
																																																																	obj_t
																																																																		BgL_cdrzd223706zd2_4898;
																																																																	BgL_carzd223705zd2_4897
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4896));
																																																																	BgL_cdrzd223706zd2_4898
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd223700zd2_4896));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223705zd2_4897))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd223706zd2_4898))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd223711zd2_4901;
																																																																					BgL_carzd223711zd2_4901
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd223706zd2_4898);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd223711zd2_4901))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd223706zd2_4898)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd223688zd2_4894))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg4171z00_4906;
																																																																											BgL_arg4171z00_4906
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd223694zd2_4895));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20459;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_20463;
																																																																													obj_t
																																																																														BgL_proc2z00_20462;
																																																																													obj_t
																																																																														BgL_proc1z00_20461;
																																																																													obj_t
																																																																														BgL_testz00_20460;
																																																																													BgL_testz00_20460
																																																																														=
																																																																														BgL_arg4171z00_4906;
																																																																													BgL_proc1z00_20461
																																																																														=
																																																																														BgL_carzd223705zd2_4897;
																																																																													BgL_proc2z00_20462
																																																																														=
																																																																														BgL_carzd223711zd2_4901;
																																																																													BgL_argsz00_20463
																																																																														=
																																																																														BgL_cdrzd223688zd2_4894;
																																																																													BgL_argsz00_1784
																																																																														=
																																																																														BgL_argsz00_20463;
																																																																													BgL_proc2z00_1783
																																																																														=
																																																																														BgL_proc2z00_20462;
																																																																													BgL_proc1z00_1782
																																																																														=
																																																																														BgL_proc1z00_20461;
																																																																													BgL_testz00_1781
																																																																														=
																																																																														BgL_testz00_20460;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1785;
																																																																												}
																																																																												BgL_auxz00_14300
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20459);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20467;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_14300
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20467);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20471;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_14300
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20471);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_20475;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_14300
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_20475);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_20479;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_14300
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_20479);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20483;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_14300
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20483);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_20487;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_14300
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_20487);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1809;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20491;
																																																												goto
																																																													BgL_tagzd2404zd2_1810;
																																																												BgL_auxz00_14300
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20491);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1809;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_20495;
																																																										goto
																																																											BgL_tagzd2404zd2_1810;
																																																										BgL_auxz00_14300
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_20495);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd221236zd2_4798
																																							==
																																							CNST_TABLE_REF
																																							(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_20500;
																																							goto
																																								BgL_tagzd2383zd2_1766;
																																							BgL_auxz00_14300
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_20500);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd224273zd2_5052;
																																							BgL_carzd224273zd2_5052
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd224273zd2_5052 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_20507;
																																									goto
																																										BgL_tagzd2384zd2_1767;
																																									BgL_auxz00_14300
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_20507);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224273zd2_5052)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_20512;
																																											goto
																																												BgL_tagzd2384zd2_1767;
																																											BgL_auxz00_14300
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_20512);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20519;
																																													goto
																																														BgL_tagzd2389zd2_1786;
																																													BgL_auxz00_14300
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20519);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_20526;
																																															goto
																																																BgL_tagzd2390zd2_1787;
																																															BgL_auxz00_14300
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_20526);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_20533;
																																																	goto
																																																		BgL_tagzd2392zd2_1791;
																																																	BgL_auxz00_14300
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_20533);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20540;
																																																			goto
																																																				BgL_tagzd2393zd2_1792;
																																																			BgL_auxz00_14300
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20540);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_20547;
																																																					goto
																																																						BgL_tagzd2395zd2_1796;
																																																					BgL_auxz00_14300
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_20547);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_20554;
																																																							goto
																																																								BgL_tagzd2396zd2_1797;
																																																							BgL_auxz00_14300
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_20554);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_20561;
																																																									goto
																																																										BgL_tagzd2397zd2_1798;
																																																									BgL_auxz00_14300
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_20561);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_20568;
																																																											goto
																																																												BgL_tagzd2398zd2_1799;
																																																											BgL_auxz00_14300
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_20568);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20578;
																																																														BgL_tagzd2402zd2_1808:
																																																															{	/* Ast/sexp.scm 559 */
																																																																obj_t
																																																																	BgL_arg7016z00_9014;
																																																																BgL_arg7016z00_9014
																																																																	=
																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																	(BgL_expz00_21,
																																																																	BgL_locz00_23);
																																																																{	/* Ast/sexp.scm 558 */
																																																																	BgL_nodez00_bglt
																																																																		BgL_res7495z00_10127;
																																																																	{	/* Ast/sexp.scm 726 */
																																																																		obj_t
																																																																			BgL_arg7130z00_10123;
																																																																		BgL_nodez00_bglt
																																																																			BgL_arg7131z00_10124;
																																																																		BgL_arg7130z00_10123
																																																																			=
																																																																			BGl_shapez00zztools_shapez00
																																																																			(BGl_currentzd2functionzd2zztools_errorz00
																																																																			());
																																																																		BgL_arg7131z00_10124
																																																																			=
																																																																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																																																																			(CNST_TABLE_REF
																																																																			(((long) 4)), BNIL, BgL_arg7016z00_9014, CNST_TABLE_REF(((long) 2)));
																																																																		{	/* Ast/sexp.scm 725 */
																																																																			obj_t
																																																																				BgL_list7132z00_10126;
																																																																			BgL_list7132z00_10126
																																																																				=
																																																																				MAKE_YOUNG_PAIR
																																																																				(
																																																																				((obj_t) BgL_arg7131z00_10124), BNIL);
																																																																			BgL_res7495z00_10127
																																																																				=
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BGl_userzd2errorzf2locationz20zztools_errorz00
																																																																				(BgL_arg7016z00_9014,
																																																																					BgL_arg7130z00_10123,
																																																																					BGl_string8046z00zzast_sexpz00,
																																																																					BgL_expz00_21,
																																																																					BgL_list7132z00_10126));
																																																																	}}
																																																																	BgL_auxz00_20578
																																																																		=
																																																																		BgL_res7495z00_10127;
																																																															}}
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20578);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20592;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_14300
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20592);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_20596;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_14300
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_20596);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_14300);
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									if (
																										(BgL_carzd2610zd2_1839 ==
																											BGl_za2ifza2z00zzast_sexpz00))
																										{
																											obj_t BgL_auxz00_20601;

																											goto
																												BgL_kapzd2612zd2_1841;
																											return ((BgL_nodez00_bglt)
																												BgL_auxz00_20601);
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											bool_t
																												BgL_test9132z00_20603;
																											{	/* Ast/sexp.scm 119 */
																												obj_t
																													BgL_arg2259z00_2586;
																												BgL_arg2259z00_2586 =
																													CAR(BgL_expz00_21);
																												BgL_test9132z00_20603 =
																													(BgL_arg2259z00_2586
																													==
																													BGl_za2ifza2z00zzast_sexpz00);
																											}
																											if (BgL_test9132z00_20603)
																												{	/* Ast/sexp.scm 119 */
																													goto
																														BgL_tagzd2377zd2_1754;
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_cdrzd224445zd2_1846;
																													BgL_cdrzd224445zd2_1846
																														=
																														CDR(BgL_expz00_21);
																													if ((CAR
																															(BgL_expz00_21) ==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{	/* Ast/sexp.scm 119 */
																															if (PAIRP
																																(BgL_cdrzd224445zd2_1846))
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd224448zd2_1850;
																																	obj_t
																																		BgL_cdrzd224449zd2_1851;
																																	BgL_carzd224448zd2_1850
																																		=
																																		CAR
																																		(BgL_cdrzd224445zd2_1846);
																																	BgL_cdrzd224449zd2_1851
																																		=
																																		CDR
																																		(BgL_cdrzd224445zd2_1846);
																																	if (PAIRP
																																		(BgL_carzd224448zd2_1850))
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR
																																					(BgL_carzd224448zd2_1850)
																																					==
																																					CNST_TABLE_REF
																																					(((long) 14))))
																																				{	/* Ast/sexp.scm 119 */
																																					if (PAIRP(BgL_cdrzd224449zd2_1851))
																																						{	/* Ast/sexp.scm 119 */
																																							if (NULLP(CDR(BgL_cdrzd224449zd2_1851)))
																																								{
																																									obj_t
																																										BgL_valz00_20628;
																																									obj_t
																																										BgL_lz00_20626;
																																									BgL_lz00_20626
																																										=
																																										CDR
																																										(BgL_carzd224448zd2_1850);
																																									BgL_valz00_20628
																																										=
																																										CAR
																																										(BgL_cdrzd224449zd2_1851);
																																									BgL_valz00_1756
																																										=
																																										BgL_valz00_20628;
																																									BgL_lz00_1755
																																										=
																																										BgL_lz00_20626;
																																									goto
																																										BgL_tagzd2378zd2_1757;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									goto
																																										BgL_tagzd2379zd2_1758;
																																								}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							goto
																																								BgL_tagzd2379zd2_1758;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					goto
																																						BgL_tagzd2379zd2_1758;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			goto
																																				BgL_tagzd2379zd2_1758;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2379zd2_1758;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR
																																	(BgL_expz00_21)
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2380zd2_1759;
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd224574zd2_1864;
																																	BgL_carzd224574zd2_1864
																																		=
																																		CAR
																																		(BgL_expz00_21);
																																	if (PAIRP
																																		(BgL_carzd224574zd2_1864))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd224577zd2_1866;
																																			obj_t
																																				BgL_cdrzd224578zd2_1867;
																																			BgL_carzd224577zd2_1866
																																				=
																																				CAR
																																				(BgL_carzd224574zd2_1864);
																																			BgL_cdrzd224578zd2_1867
																																				=
																																				CDR
																																				(BgL_carzd224574zd2_1864);
																																			{

																																				if (
																																					(BgL_carzd224577zd2_1866
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{
																																						obj_t
																																							BgL_auxz00_20642;
																																					BgL_kapzd224579zd2_1868:
																																						if (PAIRP(BgL_cdrzd224578zd2_1867))
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd224582zd2_2170;
																																								BgL_cdrzd224582zd2_2170
																																									=
																																									CDR
																																									(BgL_cdrzd224578zd2_1867);
																																								if (PAIRP(BgL_cdrzd224582zd2_2170))
																																									{	/* Ast/sexp.scm 119 */
																																										if (NULLP(CDR(BgL_cdrzd224582zd2_2170)))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg1944z00_2174;
																																												obj_t
																																													BgL_arg1945z00_2175;
																																												BgL_arg1944z00_2174
																																													=
																																													CAR
																																													(BgL_cdrzd224582zd2_2170);
																																												BgL_arg1945z00_2175
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_20654;
																																													{
																																														obj_t
																																															BgL_argsz00_20656;
																																														obj_t
																																															BgL_bodyz00_20655;
																																														BgL_bodyz00_20655
																																															=
																																															BgL_arg1944z00_2174;
																																														BgL_argsz00_20656
																																															=
																																															BgL_arg1945z00_2175;
																																														BgL_argsz00_1761
																																															=
																																															BgL_argsz00_20656;
																																														BgL_bodyz00_1760
																																															=
																																															BgL_bodyz00_20655;
																																														goto
																																															BgL_tagzd2381zd2_1762;
																																													}
																																													BgL_auxz00_20642
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_20654);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd224605zd2_2176;
																																												BgL_cdrzd224605zd2_2176
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{

																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9145z00_20660;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg2016z00_2286;
																																															BgL_arg2016z00_2286
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9145z00_20660
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg2016z00_2286));
																																														}
																																														if (BgL_test9145z00_20660)
																																															{	/* Ast/sexp.scm 119 */
																																																if (PAIRP(BgL_cdrzd224605zd2_2176))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg2020z00_2288;
																																																		obj_t
																																																			BgL_arg2021z00_2289;
																																																		BgL_arg2020z00_2288
																																																			=
																																																			CAR
																																																			(BgL_cdrzd224605zd2_2176);
																																																		BgL_arg2021z00_2289
																																																			=
																																																			CDR
																																																			(BgL_cdrzd224605zd2_2176);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_20669;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_20671;
																																																				obj_t
																																																					BgL_bindingsz00_20670;
																																																				BgL_bindingsz00_20670
																																																					=
																																																					BgL_arg2020z00_2288;
																																																				BgL_exprz00_20671
																																																					=
																																																					BgL_arg2021z00_2289;
																																																				BgL_exprz00_1764
																																																					=
																																																					BgL_exprz00_20671;
																																																				BgL_bindingsz00_1763
																																																					=
																																																					BgL_bindingsz00_20670;
																																																				goto
																																																					BgL_tagzd2382zd2_1765;
																																																			}
																																																			BgL_auxz00_20642
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_20669);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test9147z00_20673;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2087z00_2395;
																																																			BgL_arg2087z00_2395
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_test9147z00_20673
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg2087z00_2395));
																																																		}
																																																		if (BgL_test9147z00_20673)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_20678;
																																																				goto
																																																					BgL_tagzd2384zd2_1767;
																																																				BgL_auxz00_20642
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_20678);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd224669zd2_2292;
																																																				BgL_carzd224669zd2_2292
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd224674zd2_2293;
																																																					BgL_cdrzd224674zd2_2293
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd224669zd2_2292));
																																																					if ((CAR(((obj_t) BgL_carzd224669zd2_2292)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg2027z00_2296;
																																																							obj_t
																																																								BgL_arg2028z00_2297;
																																																							obj_t
																																																								BgL_arg2029z00_2298;
																																																							BgL_arg2027z00_2296
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2293));
																																																							BgL_arg2028z00_2297
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd224674zd2_2293));
																																																							BgL_arg2029z00_2298
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_20695;
																																																								{
																																																									obj_t
																																																										BgL_argsz00_20698;
																																																									obj_t
																																																										BgL_bodyz00_20697;
																																																									obj_t
																																																										BgL_varsz00_20696;
																																																									BgL_varsz00_20696
																																																										=
																																																										BgL_arg2027z00_2296;
																																																									BgL_bodyz00_20697
																																																										=
																																																										BgL_arg2028z00_2297;
																																																									BgL_argsz00_20698
																																																										=
																																																										BgL_arg2029z00_2298;
																																																									BgL_argsz00_1774
																																																										=
																																																										BgL_argsz00_20698;
																																																									BgL_bodyz00_1773
																																																										=
																																																										BgL_bodyz00_20697;
																																																									BgL_varsz00_1772
																																																										=
																																																										BgL_varsz00_20696;
																																																									goto
																																																										BgL_tagzd2386zd2_1775;
																																																								}
																																																								BgL_auxz00_20642
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_20695);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd224697zd2_2300;
																																																							BgL_cdrzd224697zd2_2300
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd224703zd2_2301;
																																																								BgL_cdrzd224703zd2_2301
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd224669zd2_2292));
																																																								if ((CAR(((obj_t) BgL_carzd224669zd2_2292)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd224709zd2_2304;
																																																										BgL_cdrzd224709zd2_2304
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd224703zd2_2301));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd224714zd2_2305;
																																																											obj_t
																																																												BgL_cdrzd224715zd2_2306;
																																																											BgL_carzd224714zd2_2305
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2304));
																																																											BgL_cdrzd224715zd2_2306
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd224709zd2_2304));
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224714zd2_2305))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd224715zd2_2306))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd224722zd2_2309;
																																																															BgL_carzd224722zd2_2309
																																																																=
																																																																CAR
																																																																(BgL_cdrzd224715zd2_2306);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224722zd2_2309))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd224715zd2_2306)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test9154z00_20725;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1407z00_2342;
																																																																				BgL_l1407z00_2342
																																																																					=
																																																																					BgL_cdrzd224697zd2_2300;
																																																																			BgL_zc3z04anonymousza32052ze3z87_2343:
																																																																				if (NULLP(BgL_l1407z00_2342))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test9154z00_20725
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9156z00_20728;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test9157z00_20729;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_tmpz00_20730;
																																																																								BgL_tmpz00_20730
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1407z00_2342));
																																																																								BgL_test9157z00_20729
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_20730);
																																																																							}
																																																																							if (BgL_test9157z00_20729)
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9156z00_20728
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9156z00_20728
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_test9156z00_20728)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1407z00_20734;
																																																																								BgL_l1407z00_20734
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1407z00_2342));
																																																																								BgL_l1407z00_2342
																																																																									=
																																																																									BgL_l1407z00_20734;
																																																																								goto
																																																																									BgL_zc3z04anonymousza32052ze3z87_2343;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9154z00_20725
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_test9154z00_20725)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg2042z00_2325;
																																																																					BgL_arg2042z00_2325
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd224703zd2_2301));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20739;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_20743;
																																																																							obj_t
																																																																								BgL_proc2z00_20742;
																																																																							obj_t
																																																																								BgL_proc1z00_20741;
																																																																							obj_t
																																																																								BgL_testz00_20740;
																																																																							BgL_testz00_20740
																																																																								=
																																																																								BgL_arg2042z00_2325;
																																																																							BgL_proc1z00_20741
																																																																								=
																																																																								BgL_carzd224714zd2_2305;
																																																																							BgL_proc2z00_20742
																																																																								=
																																																																								BgL_carzd224722zd2_2309;
																																																																							BgL_argsz00_20743
																																																																								=
																																																																								BgL_cdrzd224697zd2_2300;
																																																																							BgL_argsz00_1779
																																																																								=
																																																																								BgL_argsz00_20743;
																																																																							BgL_proc2z00_1778
																																																																								=
																																																																								BgL_proc2z00_20742;
																																																																							BgL_proc1z00_1777
																																																																								=
																																																																								BgL_proc1z00_20741;
																																																																							BgL_testz00_1776
																																																																								=
																																																																								BgL_testz00_20740;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1780;
																																																																						}
																																																																						BgL_auxz00_20642
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20739);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd224746zd2_2326;
																																																																					BgL_cdrzd224746zd2_2326
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd224753zd2_2327;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_11501;
																																																																							BgL_pairz00_11501
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd224753zd2_2327
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_11501);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd224760zd2_2328;
																																																																							BgL_cdrzd224760zd2_2328
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd224753zd2_2327));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd224766zd2_2329;
																																																																								BgL_carzd224766zd2_2329
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd224760zd2_2328));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224766zd2_2329))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd224773zd2_2331;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_11505;
																																																																											BgL_pairz00_11505
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd224760zd2_2328));
																																																																											BgL_carzd224773zd2_2331
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_11505);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd224773zd2_2331))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd224746zd2_2326))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2046z00_2334;
																																																																														BgL_arg2046z00_2334
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd224753zd2_2327));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_20765;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_20769;
																																																																																obj_t
																																																																																	BgL_proc2z00_20768;
																																																																																obj_t
																																																																																	BgL_proc1z00_20767;
																																																																																obj_t
																																																																																	BgL_testz00_20766;
																																																																																BgL_testz00_20766
																																																																																	=
																																																																																	BgL_arg2046z00_2334;
																																																																																BgL_proc1z00_20767
																																																																																	=
																																																																																	BgL_carzd224766zd2_2329;
																																																																																BgL_proc2z00_20768
																																																																																	=
																																																																																	BgL_carzd224773zd2_2331;
																																																																																BgL_argsz00_20769
																																																																																	=
																																																																																	BgL_cdrzd224746zd2_2326;
																																																																																BgL_argsz00_1784
																																																																																	=
																																																																																	BgL_argsz00_20769;
																																																																																BgL_proc2z00_1783
																																																																																	=
																																																																																	BgL_proc2z00_20768;
																																																																																BgL_proc1z00_1782
																																																																																	=
																																																																																	BgL_proc1z00_20767;
																																																																																BgL_testz00_1781
																																																																																	=
																																																																																	BgL_testz00_20766;
																																																																																goto
																																																																																	BgL_tagzd2388zd2_1785;
																																																																															}
																																																																															BgL_auxz00_20642
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_20765);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_20773;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_20642
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_20773);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20777;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_20642
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20777);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20781;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_20642
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20781);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_20785;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_20642
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_20785);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd225049zd2_2353;
																																																																	BgL_cdrzd225049zd2_2353
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd225055zd2_2354;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_11509;
																																																																			BgL_pairz00_11509
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd225055zd2_2354
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_11509);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd225061zd2_2355;
																																																																			BgL_cdrzd225061zd2_2355
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225055zd2_2354));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd225066zd2_2356;
																																																																				obj_t
																																																																					BgL_cdrzd225067zd2_2357;
																																																																				BgL_carzd225066zd2_2356
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2355));
																																																																				BgL_cdrzd225067zd2_2357
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd225061zd2_2355));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225066zd2_2356))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd225072zd2_2359;
																																																																						BgL_carzd225072zd2_2359
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225067zd2_2357));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225072zd2_2359))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd225067zd2_2357))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225049zd2_2353))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg2062z00_2364;
																																																																												BgL_arg2062z00_2364
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225055zd2_2354));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20812;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20816;
																																																																														obj_t
																																																																															BgL_proc2z00_20815;
																																																																														obj_t
																																																																															BgL_proc1z00_20814;
																																																																														obj_t
																																																																															BgL_testz00_20813;
																																																																														BgL_testz00_20813
																																																																															=
																																																																															BgL_arg2062z00_2364;
																																																																														BgL_proc1z00_20814
																																																																															=
																																																																															BgL_carzd225066zd2_2356;
																																																																														BgL_proc2z00_20815
																																																																															=
																																																																															BgL_carzd225072zd2_2359;
																																																																														BgL_argsz00_20816
																																																																															=
																																																																															BgL_cdrzd225049zd2_2353;
																																																																														BgL_argsz00_1784
																																																																															=
																																																																															BgL_argsz00_20816;
																																																																														BgL_proc2z00_1783
																																																																															=
																																																																															BgL_proc2z00_20815;
																																																																														BgL_proc1z00_1782
																																																																															=
																																																																															BgL_proc1z00_20814;
																																																																														BgL_testz00_1781
																																																																															=
																																																																															BgL_testz00_20813;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1785;
																																																																													}
																																																																													BgL_auxz00_20642
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20812);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20820;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_20642
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20820);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20824;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_20642
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20824);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20828;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_20642
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20828);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20832;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_20642
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20832);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_20836;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_20642
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_20836);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd225405zd2_2372;
																																																													BgL_cdrzd225405zd2_2372
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd225412zd2_2373;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_11519;
																																																															BgL_pairz00_11519
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd225412zd2_2373
																																																																=
																																																																CDR
																																																																(BgL_pairz00_11519);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd225419zd2_2374;
																																																															BgL_cdrzd225419zd2_2374
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd225412zd2_2373));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd225425zd2_2375;
																																																																obj_t
																																																																	BgL_cdrzd225426zd2_2376;
																																																																BgL_carzd225425zd2_2375
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2374));
																																																																BgL_cdrzd225426zd2_2376
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd225419zd2_2374));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225425zd2_2375))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd225426zd2_2376))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd225433zd2_2379;
																																																																				BgL_carzd225433zd2_2379
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd225426zd2_2376);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225433zd2_2379))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd225426zd2_2376)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225405zd2_2372))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg2076z00_2384;
																																																																										BgL_arg2076z00_2384
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd225412zd2_2373));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_20863;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_20867;
																																																																												obj_t
																																																																													BgL_proc2z00_20866;
																																																																												obj_t
																																																																													BgL_proc1z00_20865;
																																																																												obj_t
																																																																													BgL_testz00_20864;
																																																																												BgL_testz00_20864
																																																																													=
																																																																													BgL_arg2076z00_2384;
																																																																												BgL_proc1z00_20865
																																																																													=
																																																																													BgL_carzd225425zd2_2375;
																																																																												BgL_proc2z00_20866
																																																																													=
																																																																													BgL_carzd225433zd2_2379;
																																																																												BgL_argsz00_20867
																																																																													=
																																																																													BgL_cdrzd225405zd2_2372;
																																																																												BgL_argsz00_1784
																																																																													=
																																																																													BgL_argsz00_20867;
																																																																												BgL_proc2z00_1783
																																																																													=
																																																																													BgL_proc2z00_20866;
																																																																												BgL_proc1z00_1782
																																																																													=
																																																																													BgL_proc1z00_20865;
																																																																												BgL_testz00_1781
																																																																													=
																																																																													BgL_testz00_20864;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1785;
																																																																											}
																																																																											BgL_auxz00_20642
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_20863);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20871;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_20642
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20871);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_20875;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_20642
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_20875);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_20879;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_20642
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_20879);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_20883;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_20642
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_20883);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20887;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_20642
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20887);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1809;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_20891;
																																																												goto
																																																													BgL_tagzd2404zd2_1810;
																																																												BgL_auxz00_20642
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_20891);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9185z00_20893;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg2015z00_2285;
																																																	BgL_arg2015z00_2285
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9185z00_20893
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg2015z00_2285));
																																																}
																																																if (BgL_test9185z00_20893)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_20898;
																																																		goto
																																																			BgL_tagzd2384zd2_1767;
																																																		BgL_auxz00_20642
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_20898);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd225865zd2_2182;
																																																		BgL_carzd225865zd2_2182
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd225870zd2_2183;
																																																			BgL_cdrzd225870zd2_2183
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd225865zd2_2182));
																																																			if ((CAR(((obj_t) BgL_carzd225865zd2_2182)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg1952z00_2186;
																																																					obj_t
																																																						BgL_arg1953z00_2187;
																																																					obj_t
																																																						BgL_arg1954z00_2188;
																																																					BgL_arg1952z00_2186
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2183));
																																																					BgL_arg1953z00_2187
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd225870zd2_2183));
																																																					BgL_arg1954z00_2188
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_20915;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_20918;
																																																							obj_t
																																																								BgL_bodyz00_20917;
																																																							obj_t
																																																								BgL_varsz00_20916;
																																																							BgL_varsz00_20916
																																																								=
																																																								BgL_arg1952z00_2186;
																																																							BgL_bodyz00_20917
																																																								=
																																																								BgL_arg1953z00_2187;
																																																							BgL_argsz00_20918
																																																								=
																																																								BgL_arg1954z00_2188;
																																																							BgL_argsz00_1774
																																																								=
																																																								BgL_argsz00_20918;
																																																							BgL_bodyz00_1773
																																																								=
																																																								BgL_bodyz00_20917;
																																																							BgL_varsz00_1772
																																																								=
																																																								BgL_varsz00_20916;
																																																							goto
																																																								BgL_tagzd2386zd2_1775;
																																																						}
																																																						BgL_auxz00_20642
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_20915);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd225893zd2_2190;
																																																					BgL_cdrzd225893zd2_2190
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd225899zd2_2191;
																																																						BgL_cdrzd225899zd2_2191
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd225865zd2_2182));
																																																						if ((CAR(((obj_t) BgL_carzd225865zd2_2182)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd225905zd2_2194;
																																																								BgL_cdrzd225905zd2_2194
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd225899zd2_2191));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd225910zd2_2195;
																																																									obj_t
																																																										BgL_cdrzd225911zd2_2196;
																																																									BgL_carzd225910zd2_2195
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2194));
																																																									BgL_cdrzd225911zd2_2196
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd225905zd2_2194));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225910zd2_2195))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd225911zd2_2196))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd225918zd2_2199;
																																																													BgL_carzd225918zd2_2199
																																																														=
																																																														CAR
																																																														(BgL_cdrzd225911zd2_2196);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225918zd2_2199))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(BgL_cdrzd225911zd2_2196)))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test9192z00_20945;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1410z00_2232;
																																																																		BgL_l1410z00_2232
																																																																			=
																																																																			BgL_cdrzd225893zd2_2190;
																																																																	BgL_zc3z04anonymousza31977ze3z87_2233:
																																																																		if (NULLP(BgL_l1410z00_2232))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test9192z00_20945
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test9194z00_20948;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test9195z00_20949;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_tmpz00_20950;
																																																																						BgL_tmpz00_20950
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1410z00_2232));
																																																																						BgL_test9195z00_20949
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_20950);
																																																																					}
																																																																					if (BgL_test9195z00_20949)
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9194z00_20948
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9194z00_20948
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_test9194z00_20948)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1410z00_20954;
																																																																						BgL_l1410z00_20954
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1410z00_2232));
																																																																						BgL_l1410z00_2232
																																																																							=
																																																																							BgL_l1410z00_20954;
																																																																						goto
																																																																							BgL_zc3z04anonymousza31977ze3z87_2233;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test9192z00_20945
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_test9192z00_20945)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg1967z00_2215;
																																																																			BgL_arg1967z00_2215
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd225899zd2_2191));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_20959;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_20963;
																																																																					obj_t
																																																																						BgL_proc2z00_20962;
																																																																					obj_t
																																																																						BgL_proc1z00_20961;
																																																																					obj_t
																																																																						BgL_testz00_20960;
																																																																					BgL_testz00_20960
																																																																						=
																																																																						BgL_arg1967z00_2215;
																																																																					BgL_proc1z00_20961
																																																																						=
																																																																						BgL_carzd225910zd2_2195;
																																																																					BgL_proc2z00_20962
																																																																						=
																																																																						BgL_carzd225918zd2_2199;
																																																																					BgL_argsz00_20963
																																																																						=
																																																																						BgL_cdrzd225893zd2_2190;
																																																																					BgL_argsz00_1779
																																																																						=
																																																																						BgL_argsz00_20963;
																																																																					BgL_proc2z00_1778
																																																																						=
																																																																						BgL_proc2z00_20962;
																																																																					BgL_proc1z00_1777
																																																																						=
																																																																						BgL_proc1z00_20961;
																																																																					BgL_testz00_1776
																																																																						=
																																																																						BgL_testz00_20960;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1780;
																																																																				}
																																																																				BgL_auxz00_20642
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_20959);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd225942zd2_2216;
																																																																			BgL_cdrzd225942zd2_2216
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd225949zd2_2217;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_11554;
																																																																					BgL_pairz00_11554
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd225949zd2_2217
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_11554);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd225956zd2_2218;
																																																																					BgL_cdrzd225956zd2_2218
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd225949zd2_2217));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd225962zd2_2219;
																																																																						BgL_carzd225962zd2_2219
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd225956zd2_2218));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225962zd2_2219))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd225969zd2_2221;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_11558;
																																																																									BgL_pairz00_11558
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd225956zd2_2218));
																																																																									BgL_carzd225969zd2_2221
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_11558);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd225969zd2_2221))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd225942zd2_2216))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1971z00_2224;
																																																																												BgL_arg1971z00_2224
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd225949zd2_2217));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_20985;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_20989;
																																																																														obj_t
																																																																															BgL_proc2z00_20988;
																																																																														obj_t
																																																																															BgL_proc1z00_20987;
																																																																														obj_t
																																																																															BgL_testz00_20986;
																																																																														BgL_testz00_20986
																																																																															=
																																																																															BgL_arg1971z00_2224;
																																																																														BgL_proc1z00_20987
																																																																															=
																																																																															BgL_carzd225962zd2_2219;
																																																																														BgL_proc2z00_20988
																																																																															=
																																																																															BgL_carzd225969zd2_2221;
																																																																														BgL_argsz00_20989
																																																																															=
																																																																															BgL_cdrzd225942zd2_2216;
																																																																														BgL_argsz00_1784
																																																																															=
																																																																															BgL_argsz00_20989;
																																																																														BgL_proc2z00_1783
																																																																															=
																																																																															BgL_proc2z00_20988;
																																																																														BgL_proc1z00_1782
																																																																															=
																																																																															BgL_proc1z00_20987;
																																																																														BgL_testz00_1781
																																																																															=
																																																																															BgL_testz00_20986;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1785;
																																																																													}
																																																																													BgL_auxz00_20642
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_20985);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_20993;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_20642
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_20993);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_20997;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_20642
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_20997);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21001;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_20642
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21001);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_21005;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_20642
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_21005);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd226245zd2_2243;
																																																															BgL_cdrzd226245zd2_2243
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd226251zd2_2244;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_11562;
																																																																	BgL_pairz00_11562
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd226251zd2_2244
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_11562);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd226257zd2_2245;
																																																																	BgL_cdrzd226257zd2_2245
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd226251zd2_2244));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd226262zd2_2246;
																																																																		obj_t
																																																																			BgL_cdrzd226263zd2_2247;
																																																																		BgL_carzd226262zd2_2246
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2245));
																																																																		BgL_cdrzd226263zd2_2247
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd226257zd2_2245));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226262zd2_2246))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd226268zd2_2249;
																																																																				BgL_carzd226268zd2_2249
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd226263zd2_2247));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226268zd2_2249))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd226263zd2_2247))))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226245zd2_2243))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1986z00_2254;
																																																																										BgL_arg1986z00_2254
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd226251zd2_2244));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21032;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_21036;
																																																																												obj_t
																																																																													BgL_proc2z00_21035;
																																																																												obj_t
																																																																													BgL_proc1z00_21034;
																																																																												obj_t
																																																																													BgL_testz00_21033;
																																																																												BgL_testz00_21033
																																																																													=
																																																																													BgL_arg1986z00_2254;
																																																																												BgL_proc1z00_21034
																																																																													=
																																																																													BgL_carzd226262zd2_2246;
																																																																												BgL_proc2z00_21035
																																																																													=
																																																																													BgL_carzd226268zd2_2249;
																																																																												BgL_argsz00_21036
																																																																													=
																																																																													BgL_cdrzd226245zd2_2243;
																																																																												BgL_argsz00_1784
																																																																													=
																																																																													BgL_argsz00_21036;
																																																																												BgL_proc2z00_1783
																																																																													=
																																																																													BgL_proc2z00_21035;
																																																																												BgL_proc1z00_1782
																																																																													=
																																																																													BgL_proc1z00_21034;
																																																																												BgL_testz00_1781
																																																																													=
																																																																													BgL_testz00_21033;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1785;
																																																																											}
																																																																											BgL_auxz00_20642
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21032);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_21040;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_20642
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_21040);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21044;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_20642
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21044);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_21048;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_20642
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_21048);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21052;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_20642
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21052);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_21056;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_20642
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_21056);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd226601zd2_2262;
																																																											BgL_cdrzd226601zd2_2262
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd226608zd2_2263;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_11572;
																																																													BgL_pairz00_11572
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd226608zd2_2263
																																																														=
																																																														CDR
																																																														(BgL_pairz00_11572);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd226615zd2_2264;
																																																													BgL_cdrzd226615zd2_2264
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd226608zd2_2263));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd226621zd2_2265;
																																																														obj_t
																																																															BgL_cdrzd226622zd2_2266;
																																																														BgL_carzd226621zd2_2265
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2264));
																																																														BgL_cdrzd226622zd2_2266
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd226615zd2_2264));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226621zd2_2265))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd226622zd2_2266))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd226629zd2_2269;
																																																																		BgL_carzd226629zd2_2269
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd226622zd2_2266);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd226629zd2_2269))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd226622zd2_2266)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd226601zd2_2262))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg2001z00_2274;
																																																																								BgL_arg2001z00_2274
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd226608zd2_2263));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_21083;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_21087;
																																																																										obj_t
																																																																											BgL_proc2z00_21086;
																																																																										obj_t
																																																																											BgL_proc1z00_21085;
																																																																										obj_t
																																																																											BgL_testz00_21084;
																																																																										BgL_testz00_21084
																																																																											=
																																																																											BgL_arg2001z00_2274;
																																																																										BgL_proc1z00_21085
																																																																											=
																																																																											BgL_carzd226621zd2_2265;
																																																																										BgL_proc2z00_21086
																																																																											=
																																																																											BgL_carzd226629zd2_2269;
																																																																										BgL_argsz00_21087
																																																																											=
																																																																											BgL_cdrzd226601zd2_2262;
																																																																										BgL_argsz00_1784
																																																																											=
																																																																											BgL_argsz00_21087;
																																																																										BgL_proc2z00_1783
																																																																											=
																																																																											BgL_proc2z00_21086;
																																																																										BgL_proc1z00_1782
																																																																											=
																																																																											BgL_proc1z00_21085;
																																																																										BgL_testz00_1781
																																																																											=
																																																																											BgL_testz00_21084;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1785;
																																																																									}
																																																																									BgL_auxz00_20642
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_21083);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21091;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_20642
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21091);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_21095;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_20642
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_21095);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21099;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_20642
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21099);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_21103;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_20642
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_21103);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_21107;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_20642
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_21107);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1809;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_21111;
																																																										goto
																																																											BgL_tagzd2404zd2_1810;
																																																										BgL_auxz00_20642
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_21111);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd227021zd2_2397;
																																										BgL_cdrzd227021zd2_2397
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9223z00_21115;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg2102z00_2413;
																																													BgL_arg2102z00_2413
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9223z00_21115
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg2102z00_2413));
																																												}
																																												if (BgL_test9223z00_21115)
																																													{	/* Ast/sexp.scm 119 */
																																														if (PAIRP(BgL_cdrzd227021zd2_2397))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg2104z00_2415;
																																																obj_t
																																																	BgL_arg2105z00_2416;
																																																BgL_arg2104z00_2415
																																																	=
																																																	CAR
																																																	(BgL_cdrzd227021zd2_2397);
																																																BgL_arg2105z00_2416
																																																	=
																																																	CDR
																																																	(BgL_cdrzd227021zd2_2397);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_21124;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_21126;
																																																		obj_t
																																																			BgL_bindingsz00_21125;
																																																		BgL_bindingsz00_21125
																																																			=
																																																			BgL_arg2104z00_2415;
																																																		BgL_exprz00_21126
																																																			=
																																																			BgL_arg2105z00_2416;
																																																		BgL_exprz00_1764
																																																			=
																																																			BgL_exprz00_21126;
																																																		BgL_bindingsz00_1763
																																																			=
																																																			BgL_bindingsz00_21125;
																																																		goto
																																																			BgL_tagzd2382zd2_1765;
																																																	}
																																																	BgL_auxz00_20642
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_21124);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9225z00_21128;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg2115z00_2428;
																																																	BgL_arg2115z00_2428
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test9225z00_21128
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg2115z00_2428));
																																																}
																																																if (BgL_test9225z00_21128)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_21133;
																																																		goto
																																																			BgL_tagzd2384zd2_1767;
																																																		BgL_auxz00_20642
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_21133);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd227084zd2_2419;
																																																		BgL_carzd227084zd2_2419
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd227089zd2_2420;
																																																			BgL_cdrzd227089zd2_2420
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd227084zd2_2419));
																																																			if ((CAR(((obj_t) BgL_carzd227084zd2_2419)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg2110z00_2423;
																																																					obj_t
																																																						BgL_arg2111z00_2424;
																																																					obj_t
																																																						BgL_arg2112z00_2425;
																																																					BgL_arg2110z00_2423
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2420));
																																																					BgL_arg2111z00_2424
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd227089zd2_2420));
																																																					BgL_arg2112z00_2425
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_21150;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_21153;
																																																							obj_t
																																																								BgL_bodyz00_21152;
																																																							obj_t
																																																								BgL_varsz00_21151;
																																																							BgL_varsz00_21151
																																																								=
																																																								BgL_arg2110z00_2423;
																																																							BgL_bodyz00_21152
																																																								=
																																																								BgL_arg2111z00_2424;
																																																							BgL_argsz00_21153
																																																								=
																																																								BgL_arg2112z00_2425;
																																																							BgL_argsz00_1774
																																																								=
																																																								BgL_argsz00_21153;
																																																							BgL_bodyz00_1773
																																																								=
																																																								BgL_bodyz00_21152;
																																																							BgL_varsz00_1772
																																																								=
																																																								BgL_varsz00_21151;
																																																							goto
																																																								BgL_tagzd2386zd2_1775;
																																																						}
																																																						BgL_auxz00_20642
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_21150);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1809;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21157;
																																																							goto
																																																								BgL_tagzd2404zd2_1810;
																																																							BgL_auxz00_20642
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21157);
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9228z00_21159;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg2101z00_2412;
																																															BgL_arg2101z00_2412
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9228z00_21159
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2101z00_2412));
																																														}
																																														if (BgL_test9228z00_21159)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_21164;
																																																goto
																																																	BgL_tagzd2384zd2_1767;
																																																BgL_auxz00_20642
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21164);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd227238zd2_2403;
																																																BgL_carzd227238zd2_2403
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd227243zd2_2404;
																																																	BgL_cdrzd227243zd2_2404
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd227238zd2_2403));
																																																	if ((CAR(((obj_t) BgL_carzd227238zd2_2403)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg2095z00_2407;
																																																			obj_t
																																																				BgL_arg2096z00_2408;
																																																			obj_t
																																																				BgL_arg2098z00_2409;
																																																			BgL_arg2095z00_2407
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2404));
																																																			BgL_arg2096z00_2408
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd227243zd2_2404));
																																																			BgL_arg2098z00_2409
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_21181;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_21184;
																																																					obj_t
																																																						BgL_bodyz00_21183;
																																																					obj_t
																																																						BgL_varsz00_21182;
																																																					BgL_varsz00_21182
																																																						=
																																																						BgL_arg2095z00_2407;
																																																					BgL_bodyz00_21183
																																																						=
																																																						BgL_arg2096z00_2408;
																																																					BgL_argsz00_21184
																																																						=
																																																						BgL_arg2098z00_2409;
																																																					BgL_argsz00_1774
																																																						=
																																																						BgL_argsz00_21184;
																																																					BgL_bodyz00_1773
																																																						=
																																																						BgL_bodyz00_21183;
																																																					BgL_varsz00_1772
																																																						=
																																																						BgL_varsz00_21182;
																																																					goto
																																																						BgL_tagzd2386zd2_1775;
																																																				}
																																																				BgL_auxz00_20642
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_21181);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1809;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21188;
																																																					goto
																																																						BgL_tagzd2404zd2_1810;
																																																					BgL_auxz00_20642
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21188);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd227353zd2_2429;
																																								BgL_cdrzd227353zd2_2429
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test9231z00_21192;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg2123z00_2437;
																																											BgL_arg2123z00_2437
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test9231z00_21192
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg2123z00_2437));
																																										}
																																										if (BgL_test9231z00_21192)
																																											{	/* Ast/sexp.scm 119 */
																																												if (PAIRP(BgL_cdrzd227353zd2_2429))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg2125z00_2439;
																																														obj_t
																																															BgL_arg2126z00_2440;
																																														BgL_arg2125z00_2439
																																															=
																																															CAR
																																															(BgL_cdrzd227353zd2_2429);
																																														BgL_arg2126z00_2440
																																															=
																																															CDR
																																															(BgL_cdrzd227353zd2_2429);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21201;
																																															{
																																																obj_t
																																																	BgL_exprz00_21203;
																																																obj_t
																																																	BgL_bindingsz00_21202;
																																																BgL_bindingsz00_21202
																																																	=
																																																	BgL_arg2125z00_2439;
																																																BgL_exprz00_21203
																																																	=
																																																	BgL_arg2126z00_2440;
																																																BgL_exprz00_1764
																																																	=
																																																	BgL_exprz00_21203;
																																																BgL_bindingsz00_1763
																																																	=
																																																	BgL_bindingsz00_21202;
																																																goto
																																																	BgL_tagzd2382zd2_1765;
																																															}
																																															BgL_auxz00_20642
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21201);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test9233z00_21205;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg2130z00_2444;
																																															BgL_arg2130z00_2444
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test9233z00_21205
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg2130z00_2444));
																																														}
																																														if (BgL_test9233z00_21205)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_21210;
																																																goto
																																																	BgL_tagzd2384zd2_1767;
																																																BgL_auxz00_20642
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21210);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_tagzd2403zd2_1809;
																																																	}
																																																else
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_21214;
																																																		goto
																																																			BgL_tagzd2404zd2_1810;
																																																		BgL_auxz00_20642
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_21214);
																																																	}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test9235z00_21216;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg2121z00_2436;
																																													BgL_arg2121z00_2436
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test9235z00_21216
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg2121z00_2436));
																																												}
																																												if (BgL_test9235z00_21216)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_21221;
																																														goto
																																															BgL_tagzd2384zd2_1767;
																																														BgL_auxz00_20642
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_21221);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd2403zd2_1809;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_21225;
																																																goto
																																																	BgL_tagzd2404zd2_1810;
																																																BgL_auxz00_20642
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_21225);
																																															}
																																													}
																																											}
																																									}
																																								}
																																							}
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_20642);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224577zd2_1866)))
																																							{
																																								obj_t
																																									BgL_auxz00_21231;
																																								goto
																																									BgL_kapzd224579zd2_1868;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_21231);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd224577zd2_1866 == CNST_TABLE_REF(((long) 18))))
																																									{
																																										obj_t
																																											BgL_auxz00_21236;
																																										goto
																																											BgL_kapzd224579zd2_1868;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_21236);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd224577zd2_1866 == CNST_TABLE_REF(((long) 19))))
																																											{
																																												obj_t
																																													BgL_auxz00_21241;
																																												goto
																																													BgL_kapzd224579zd2_1868;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_21241);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd224577zd2_1866)))
																																													{
																																														obj_t
																																															BgL_auxz00_21246;
																																														goto
																																															BgL_kapzd224579zd2_1868;
																																														return
																																															(
																																															(BgL_nodez00_bglt)
																																															BgL_auxz00_21246);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd227662zd2_1874;
																																														BgL_cdrzd227662zd2_1874
																																															=
																																															CDR
																																															(BgL_expz00_21);
																																														{

																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test9241z00_21249;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg1866z00_2053;
																																																	BgL_arg1866z00_2053
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_test9241z00_21249
																																																		=
																																																		CBOOL
																																																		(BGl_letzd2symzf3z21zzast_letz00
																																																		(BgL_arg1866z00_2053));
																																																}
																																																if (BgL_test9241z00_21249)
																																																	{
																																																		obj_t
																																																			BgL_auxz00_21253;
																																																		if (PAIRP(BgL_cdrzd227662zd2_1874))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg1868z00_2055;
																																																				obj_t
																																																					BgL_arg1869z00_2056;
																																																				BgL_arg1868z00_2055
																																																					=
																																																					CAR
																																																					(BgL_cdrzd227662zd2_1874);
																																																				BgL_arg1869z00_2056
																																																					=
																																																					CDR
																																																					(BgL_cdrzd227662zd2_1874);
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21258;
																																																					{
																																																						obj_t
																																																							BgL_exprz00_21260;
																																																						obj_t
																																																							BgL_bindingsz00_21259;
																																																						BgL_bindingsz00_21259
																																																							=
																																																							BgL_arg1868z00_2055;
																																																						BgL_exprz00_21260
																																																							=
																																																							BgL_arg1869z00_2056;
																																																						BgL_exprz00_1764
																																																							=
																																																							BgL_exprz00_21260;
																																																						BgL_bindingsz00_1763
																																																							=
																																																							BgL_bindingsz00_21259;
																																																						goto
																																																							BgL_tagzd2382zd2_1765;
																																																					}
																																																					BgL_auxz00_21253
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21258);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				bool_t
																																																					BgL_test9243z00_21262;
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg1939z00_2168;
																																																					BgL_arg1939z00_2168
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_test9243z00_21262
																																																						=
																																																						CBOOL
																																																						(BGl_labelszd2symzf3z21zzast_labelsz00
																																																						(BgL_arg1939z00_2168));
																																																				}
																																																				if (BgL_test9243z00_21262)
																																																					{
																																																						BgL_letzd2funzd2_bglt
																																																							BgL_auxz00_21267;
																																																						goto
																																																							BgL_tagzd2384zd2_1767;
																																																						BgL_auxz00_21253
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_21267);
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_carzd227725zd2_2059;
																																																						BgL_carzd227725zd2_2059
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd227730zd2_2060;
																																																							BgL_cdrzd227730zd2_2060
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd227725zd2_2059));
																																																							if ((CAR(((obj_t) BgL_carzd227725zd2_2059)) == CNST_TABLE_REF(((long) 3))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd227730zd2_2060))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg1875z00_2064;
																																																											obj_t
																																																												BgL_arg1876z00_2065;
																																																											obj_t
																																																												BgL_arg1877z00_2066;
																																																											BgL_arg1875z00_2064
																																																												=
																																																												CAR
																																																												(BgL_cdrzd227730zd2_2060);
																																																											BgL_arg1876z00_2065
																																																												=
																																																												CDR
																																																												(BgL_cdrzd227730zd2_2060);
																																																											BgL_arg1877z00_2066
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_21284;
																																																												{
																																																													obj_t
																																																														BgL_argsz00_21287;
																																																													obj_t
																																																														BgL_bodyz00_21286;
																																																													obj_t
																																																														BgL_varsz00_21285;
																																																													BgL_varsz00_21285
																																																														=
																																																														BgL_arg1875z00_2064;
																																																													BgL_bodyz00_21286
																																																														=
																																																														BgL_arg1876z00_2065;
																																																													BgL_argsz00_21287
																																																														=
																																																														BgL_arg1877z00_2066;
																																																													BgL_argsz00_1774
																																																														=
																																																														BgL_argsz00_21287;
																																																													BgL_bodyz00_1773
																																																														=
																																																														BgL_bodyz00_21286;
																																																													BgL_varsz00_1772
																																																														=
																																																														BgL_varsz00_21285;
																																																													goto
																																																														BgL_tagzd2386zd2_1775;
																																																												}
																																																												BgL_auxz00_21253
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_21284);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_21291;
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																													BgL_auxz00_21253
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21291);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd227837zd2_2069;
																																																									BgL_cdrzd227837zd2_2069
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd227842zd2_2070;
																																																										BgL_cdrzd227842zd2_2070
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd227725zd2_2059));
																																																										if ((CAR(((obj_t) BgL_carzd227725zd2_2059)) == CNST_TABLE_REF(((long) 1))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd227842zd2_2070))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd227847zd2_2074;
																																																														BgL_cdrzd227847zd2_2074
																																																															=
																																																															CDR
																																																															(BgL_cdrzd227842zd2_2070);
																																																														if (PAIRP(BgL_cdrzd227847zd2_2074))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd227851zd2_2076;
																																																																obj_t
																																																																	BgL_cdrzd227852zd2_2077;
																																																																BgL_carzd227851zd2_2076
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd227847zd2_2074);
																																																																BgL_cdrzd227852zd2_2077
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd227847zd2_2074);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227851zd2_2076))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd227852zd2_2077))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd227857zd2_2080;
																																																																				BgL_carzd227857zd2_2080
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd227852zd2_2077);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227857zd2_2080))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd227852zd2_2077)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9254z00_21319;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1413z00_2113;
																																																																									BgL_l1413z00_2113
																																																																										=
																																																																										BgL_cdrzd227837zd2_2069;
																																																																								BgL_zc3z04anonymousza31903ze3z87_2114:
																																																																									if (NULLP(BgL_l1413z00_2113))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9254z00_21319
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9256z00_21322;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9257z00_21323;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_21324;
																																																																													BgL_tmpz00_21324
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1413z00_2113));
																																																																													BgL_test9257z00_21323
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_21324);
																																																																												}
																																																																												if (BgL_test9257z00_21323)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9256z00_21322
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9256z00_21322
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test9256z00_21322)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1413z00_21328;
																																																																													BgL_l1413z00_21328
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1413z00_2113));
																																																																													BgL_l1413z00_2113
																																																																														=
																																																																														BgL_l1413z00_21328;
																																																																													goto
																																																																														BgL_zc3z04anonymousza31903ze3z87_2114;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test9254z00_21319
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test9254z00_21319)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1893z00_2096;
																																																																										BgL_arg1893z00_2096
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd227842zd2_2070);
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21332;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_21336;
																																																																												obj_t
																																																																													BgL_proc2z00_21335;
																																																																												obj_t
																																																																													BgL_proc1z00_21334;
																																																																												obj_t
																																																																													BgL_testz00_21333;
																																																																												BgL_testz00_21333
																																																																													=
																																																																													BgL_arg1893z00_2096;
																																																																												BgL_proc1z00_21334
																																																																													=
																																																																													BgL_carzd227851zd2_2076;
																																																																												BgL_proc2z00_21335
																																																																													=
																																																																													BgL_carzd227857zd2_2080;
																																																																												BgL_argsz00_21336
																																																																													=
																																																																													BgL_cdrzd227837zd2_2069;
																																																																												BgL_argsz00_1779
																																																																													=
																																																																													BgL_argsz00_21336;
																																																																												BgL_proc2z00_1778
																																																																													=
																																																																													BgL_proc2z00_21335;
																																																																												BgL_proc1z00_1777
																																																																													=
																																																																													BgL_proc1z00_21334;
																																																																												BgL_testz00_1776
																																																																													=
																																																																													BgL_testz00_21333;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1780;
																																																																											}
																																																																											BgL_auxz00_21253
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21332);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd227882zd2_2097;
																																																																										BgL_cdrzd227882zd2_2097
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd227890zd2_2098;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11639;
																																																																												BgL_pairz00_11639
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd227890zd2_2098
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11639);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd227898zd2_2099;
																																																																												BgL_cdrzd227898zd2_2099
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd227890zd2_2098));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd227905zd2_2100;
																																																																													BgL_carzd227905zd2_2100
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd227898zd2_2099));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227905zd2_2100))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd227914zd2_2102;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11643;
																																																																																BgL_pairz00_11643
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd227898zd2_2099));
																																																																																BgL_carzd227914zd2_2102
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_11643);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd227914zd2_2102))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd227882zd2_2097))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg1897z00_2105;
																																																																																			BgL_arg1897z00_2105
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd227890zd2_2098));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_21358;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_21362;
																																																																																					obj_t
																																																																																						BgL_proc2z00_21361;
																																																																																					obj_t
																																																																																						BgL_proc1z00_21360;
																																																																																					obj_t
																																																																																						BgL_testz00_21359;
																																																																																					BgL_testz00_21359
																																																																																						=
																																																																																						BgL_arg1897z00_2105;
																																																																																					BgL_proc1z00_21360
																																																																																						=
																																																																																						BgL_carzd227905zd2_2100;
																																																																																					BgL_proc2z00_21361
																																																																																						=
																																																																																						BgL_carzd227914zd2_2102;
																																																																																					BgL_argsz00_21362
																																																																																						=
																																																																																						BgL_cdrzd227882zd2_2097;
																																																																																					BgL_argsz00_1784
																																																																																						=
																																																																																						BgL_argsz00_21362;
																																																																																					BgL_proc2z00_1783
																																																																																						=
																																																																																						BgL_proc2z00_21361;
																																																																																					BgL_proc1z00_1782
																																																																																						=
																																																																																						BgL_proc1z00_21360;
																																																																																					BgL_testz00_1781
																																																																																						=
																																																																																						BgL_testz00_21359;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1785;
																																																																																				}
																																																																																				BgL_auxz00_21253
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_21358);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_21366;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_21253
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_21366);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21370;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_21253
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21370);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21374;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_21253
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21374);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_21378;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_21253
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_21378);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd228192zd2_2124;
																																																																						BgL_cdrzd228192zd2_2124
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd228199zd2_2125;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11647;
																																																																								BgL_pairz00_11647
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd228199zd2_2125
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11647);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd228206zd2_2126;
																																																																								BgL_cdrzd228206zd2_2126
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd228199zd2_2125));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd228212zd2_2127;
																																																																									obj_t
																																																																										BgL_cdrzd228213zd2_2128;
																																																																									BgL_carzd228212zd2_2127
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2126));
																																																																									BgL_cdrzd228213zd2_2128
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd228206zd2_2126));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228212zd2_2127))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd228220zd2_2130;
																																																																											BgL_carzd228220zd2_2130
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd228213zd2_2128));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228220zd2_2130))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd228213zd2_2128))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228192zd2_2124))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg1912z00_2135;
																																																																																	BgL_arg1912z00_2135
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd228199zd2_2125));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_21405;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_21409;
																																																																																			obj_t
																																																																																				BgL_proc2z00_21408;
																																																																																			obj_t
																																																																																				BgL_proc1z00_21407;
																																																																																			obj_t
																																																																																				BgL_testz00_21406;
																																																																																			BgL_testz00_21406
																																																																																				=
																																																																																				BgL_arg1912z00_2135;
																																																																																			BgL_proc1z00_21407
																																																																																				=
																																																																																				BgL_carzd228212zd2_2127;
																																																																																			BgL_proc2z00_21408
																																																																																				=
																																																																																				BgL_carzd228220zd2_2130;
																																																																																			BgL_argsz00_21409
																																																																																				=
																																																																																				BgL_cdrzd228192zd2_2124;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_21409;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_21408;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_21407;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_21406;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_21253
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_21405);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_21413;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_21253
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_21413);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21417;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_21253
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21417);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21421;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_21253
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21421);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21425;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_21253
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21425);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_21429;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_21253
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_21429);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd228553zd2_2143;
																																																																		BgL_cdrzd228553zd2_2143
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd228559zd2_2144;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_11657;
																																																																				BgL_pairz00_11657
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd228559zd2_2144
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_11657);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd228565zd2_2145;
																																																																				BgL_cdrzd228565zd2_2145
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd228559zd2_2144));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd228570zd2_2146;
																																																																					obj_t
																																																																						BgL_cdrzd228571zd2_2147;
																																																																					BgL_carzd228570zd2_2146
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2145));
																																																																					BgL_cdrzd228571zd2_2147
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd228565zd2_2145));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228570zd2_2146))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd228571zd2_2147))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd228576zd2_2150;
																																																																									BgL_carzd228576zd2_2150
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd228571zd2_2147);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd228576zd2_2150))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd228571zd2_2147)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd228553zd2_2143))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg1926z00_2155;
																																																																															BgL_arg1926z00_2155
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd228559zd2_2144));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_21456;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21460;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21459;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21458;
																																																																																	obj_t
																																																																																		BgL_testz00_21457;
																																																																																	BgL_testz00_21457
																																																																																		=
																																																																																		BgL_arg1926z00_2155;
																																																																																	BgL_proc1z00_21458
																																																																																		=
																																																																																		BgL_carzd228570zd2_2146;
																																																																																	BgL_proc2z00_21459
																																																																																		=
																																																																																		BgL_carzd228576zd2_2150;
																																																																																	BgL_argsz00_21460
																																																																																		=
																																																																																		BgL_cdrzd228553zd2_2143;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_21460;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_21459;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_21458;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_21457;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_21253
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_21456);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_21464;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_21253
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_21464);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_21468;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_21253
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_21468);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_21472;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_21253
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_21472);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_21476;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_21253
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_21476);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_21480;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_21253
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_21480);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_21484;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_21253
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_21484);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_21488;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_21253
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_21488);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_21492;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_21253
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_21492);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_21253);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test9287z00_21495;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg1865z00_2052;
																																																			BgL_arg1865z00_2052
																																																				=
																																																				CAR
																																																				(BgL_expz00_21);
																																																			BgL_test9287z00_21495
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg1865z00_2052));
																																																		}
																																																		if (BgL_test9287z00_21495)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_21499;
																																																				goto
																																																					BgL_tagzd2384zd2_1767;
																																																				return
																																																					(
																																																					(BgL_nodez00_bglt)
																																																					BgL_auxz00_21499);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd229139zd2_1880;
																																																				obj_t
																																																					BgL_cdrzd229140zd2_1881;
																																																				BgL_carzd229139zd2_1880
																																																					=
																																																					CAR
																																																					(BgL_expz00_21);
																																																				BgL_cdrzd229140zd2_1881
																																																					=
																																																					CDR
																																																					(BgL_expz00_21);
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd229144zd2_1882;
																																																					BgL_cdrzd229144zd2_1882
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd229139zd2_1880));
																																																					if ((CAR(((obj_t) BgL_carzd229139zd2_1880)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd229144zd2_1882))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd229147zd2_1886;
																																																									obj_t
																																																										BgL_cdrzd229148zd2_1887;
																																																									BgL_carzd229147zd2_1886
																																																										=
																																																										CAR
																																																										(BgL_cdrzd229144zd2_1882);
																																																									BgL_cdrzd229148zd2_1887
																																																										=
																																																										CDR
																																																										(BgL_cdrzd229144zd2_1882);
																																																									if (PAIRP(BgL_carzd229147zd2_1886))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(BgL_carzd229147zd2_1886)))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd229148zd2_1887))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd229154zd2_1892;
																																																															BgL_carzd229154zd2_1892
																																																																=
																																																																CAR
																																																																(BgL_cdrzd229148zd2_1887);
																																																															if (PAIRP(BgL_carzd229154zd2_1892))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd229154zd2_1892))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (NULLP(CDR(BgL_cdrzd229148zd2_1887)))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd229140zd2_1881))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd229161zd2_1898;
																																																																							BgL_carzd229161zd2_1898
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229140zd2_1881);
																																																																							if (PAIRP(BgL_carzd229161zd2_1898))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd229185zd2_1900;
																																																																									BgL_cdrzd229185zd2_1900
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg1690z00_1901;
																																																																										obj_t
																																																																											BgL_arg1695z00_1902;
																																																																										obj_t
																																																																											BgL_arg1696z00_1903;
																																																																										BgL_arg1690z00_1901
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1900));
																																																																										BgL_arg1695z00_1902
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229185zd2_1900));
																																																																										BgL_arg1696z00_1903
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_21543;
																																																																											obj_t
																																																																												BgL_bodyz00_21542;
																																																																											obj_t
																																																																												BgL_varsz00_21541;
																																																																											BgL_varsz00_21541
																																																																												=
																																																																												BgL_arg1690z00_1901;
																																																																											BgL_bodyz00_21542
																																																																												=
																																																																												BgL_arg1695z00_1902;
																																																																											BgL_argsz00_21543
																																																																												=
																																																																												BgL_arg1696z00_1903;
																																																																											BgL_argsz00_1774
																																																																												=
																																																																												BgL_argsz00_21543;
																																																																											BgL_bodyz00_1773
																																																																												=
																																																																												BgL_bodyz00_21542;
																																																																											BgL_varsz00_1772
																																																																												=
																																																																												BgL_varsz00_21541;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1775;
																																																																										}
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd229140zd2_1881)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg1705z00_1907;
																																																																											BgL_arg1705z00_1907
																																																																												=
																																																																												CAR
																																																																												(BgL_carzd229147zd2_1886);
																																																																											{
																																																																												BgL_castz00_bglt
																																																																													BgL_auxz00_21548;
																																																																												{
																																																																													obj_t
																																																																														BgL_argz00_21551;
																																																																													obj_t
																																																																														BgL_bodyz00_21550;
																																																																													obj_t
																																																																														BgL_varz00_21549;
																																																																													BgL_varz00_21549
																																																																														=
																																																																														BgL_arg1705z00_1907;
																																																																													BgL_bodyz00_21550
																																																																														=
																																																																														BgL_carzd229154zd2_1892;
																																																																													BgL_argz00_21551
																																																																														=
																																																																														BgL_carzd229161zd2_1898;
																																																																													BgL_argz00_1770
																																																																														=
																																																																														BgL_argz00_21551;
																																																																													BgL_bodyz00_1769
																																																																														=
																																																																														BgL_bodyz00_21550;
																																																																													BgL_varz00_1768
																																																																														=
																																																																														BgL_varz00_21549;
																																																																													goto
																																																																														BgL_tagzd2385zd2_1771;
																																																																												}
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21548);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd229212zd2_1908;
																																																																											BgL_cdrzd229212zd2_1908
																																																																												=
																																																																												CDR
																																																																												(CAR
																																																																												(BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1706z00_1909;
																																																																												obj_t
																																																																													BgL_arg1708z00_1910;
																																																																												obj_t
																																																																													BgL_arg1709z00_1911;
																																																																												BgL_arg1706z00_1909
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1908));
																																																																												BgL_arg1708z00_1910
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd229212zd2_1908));
																																																																												BgL_arg1709z00_1911
																																																																													=
																																																																													CDR
																																																																													(BgL_expz00_21);
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21562;
																																																																													obj_t
																																																																														BgL_bodyz00_21561;
																																																																													obj_t
																																																																														BgL_varsz00_21560;
																																																																													BgL_varsz00_21560
																																																																														=
																																																																														BgL_arg1706z00_1909;
																																																																													BgL_bodyz00_21561
																																																																														=
																																																																														BgL_arg1708z00_1910;
																																																																													BgL_argsz00_21562
																																																																														=
																																																																														BgL_arg1709z00_1911;
																																																																													BgL_argsz00_1774
																																																																														=
																																																																														BgL_argsz00_21562;
																																																																													BgL_bodyz00_1773
																																																																														=
																																																																														BgL_bodyz00_21561;
																																																																													BgL_varsz00_1772
																																																																														=
																																																																														BgL_varsz00_21560;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1775;
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd229238zd2_1914;
																																																																							BgL_cdrzd229238zd2_1914
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg1713z00_1915;
																																																																								obj_t
																																																																									BgL_arg1714z00_1916;
																																																																								obj_t
																																																																									BgL_arg1716z00_1917;
																																																																								BgL_arg1713z00_1915
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1914));
																																																																								BgL_arg1714z00_1916
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229238zd2_1914));
																																																																								BgL_arg1716z00_1917
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_21572;
																																																																									obj_t
																																																																										BgL_bodyz00_21571;
																																																																									obj_t
																																																																										BgL_varsz00_21570;
																																																																									BgL_varsz00_21570
																																																																										=
																																																																										BgL_arg1713z00_1915;
																																																																									BgL_bodyz00_21571
																																																																										=
																																																																										BgL_arg1714z00_1916;
																																																																									BgL_argsz00_21572
																																																																										=
																																																																										BgL_arg1716z00_1917;
																																																																									BgL_argsz00_1774
																																																																										=
																																																																										BgL_argsz00_21572;
																																																																									BgL_bodyz00_1773
																																																																										=
																																																																										BgL_bodyz00_21571;
																																																																									BgL_varsz00_1772
																																																																										=
																																																																										BgL_varsz00_21570;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1775;
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd229264zd2_1919;
																																																																					BgL_cdrzd229264zd2_1919
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg1720z00_1920;
																																																																						obj_t
																																																																							BgL_arg1721z00_1921;
																																																																						obj_t
																																																																							BgL_arg1723z00_1922;
																																																																						BgL_arg1720z00_1920
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1919));
																																																																						BgL_arg1721z00_1921
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229264zd2_1919));
																																																																						BgL_arg1723z00_1922
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21582;
																																																																							obj_t
																																																																								BgL_bodyz00_21581;
																																																																							obj_t
																																																																								BgL_varsz00_21580;
																																																																							BgL_varsz00_21580
																																																																								=
																																																																								BgL_arg1720z00_1920;
																																																																							BgL_bodyz00_21581
																																																																								=
																																																																								BgL_arg1721z00_1921;
																																																																							BgL_argsz00_21582
																																																																								=
																																																																								BgL_arg1723z00_1922;
																																																																							BgL_argsz00_1774
																																																																								=
																																																																								BgL_argsz00_21582;
																																																																							BgL_bodyz00_1773
																																																																								=
																																																																								BgL_bodyz00_21581;
																																																																							BgL_varsz00_1772
																																																																								=
																																																																								BgL_varsz00_21580;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1775;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd229290zd2_1925;
																																																																			BgL_cdrzd229290zd2_1925
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg1726z00_1926;
																																																																				obj_t
																																																																					BgL_arg1727z00_1927;
																																																																				obj_t
																																																																					BgL_arg1728z00_1928;
																																																																				BgL_arg1726z00_1926
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1925));
																																																																				BgL_arg1727z00_1927
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd229290zd2_1925));
																																																																				BgL_arg1728z00_1928
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_21592;
																																																																					obj_t
																																																																						BgL_bodyz00_21591;
																																																																					obj_t
																																																																						BgL_varsz00_21590;
																																																																					BgL_varsz00_21590
																																																																						=
																																																																						BgL_arg1726z00_1926;
																																																																					BgL_bodyz00_21591
																																																																						=
																																																																						BgL_arg1727z00_1927;
																																																																					BgL_argsz00_21592
																																																																						=
																																																																						BgL_arg1728z00_1928;
																																																																					BgL_argsz00_1774
																																																																						=
																																																																						BgL_argsz00_21592;
																																																																					BgL_bodyz00_1773
																																																																						=
																																																																						BgL_bodyz00_21591;
																																																																					BgL_varsz00_1772
																																																																						=
																																																																						BgL_varsz00_21590;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1775;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd229316zd2_1930;
																																																																	BgL_cdrzd229316zd2_1930
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd229139zd2_1880));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg1736z00_1931;
																																																																		obj_t
																																																																			BgL_arg1737z00_1932;
																																																																		obj_t
																																																																			BgL_arg1738z00_1933;
																																																																		BgL_arg1736z00_1931
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1930));
																																																																		BgL_arg1737z00_1932
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd229316zd2_1930));
																																																																		BgL_arg1738z00_1933
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_21602;
																																																																			obj_t
																																																																				BgL_bodyz00_21601;
																																																																			obj_t
																																																																				BgL_varsz00_21600;
																																																																			BgL_varsz00_21600
																																																																				=
																																																																				BgL_arg1736z00_1931;
																																																																			BgL_bodyz00_21601
																																																																				=
																																																																				BgL_arg1737z00_1932;
																																																																			BgL_argsz00_21602
																																																																				=
																																																																				BgL_arg1738z00_1933;
																																																																			BgL_argsz00_1774
																																																																				=
																																																																				BgL_argsz00_21602;
																																																																			BgL_bodyz00_1773
																																																																				=
																																																																				BgL_bodyz00_21601;
																																																																			BgL_varsz00_1772
																																																																				=
																																																																				BgL_varsz00_21600;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1775;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd229342zd2_1935;
																																																															BgL_cdrzd229342zd2_1935
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd229139zd2_1880));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg1740z00_1936;
																																																																obj_t
																																																																	BgL_arg1741z00_1937;
																																																																obj_t
																																																																	BgL_arg1742z00_1938;
																																																																BgL_arg1740z00_1936
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1935));
																																																																BgL_arg1741z00_1937
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd229342zd2_1935));
																																																																BgL_arg1742z00_1938
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_21612;
																																																																	obj_t
																																																																		BgL_bodyz00_21611;
																																																																	obj_t
																																																																		BgL_varsz00_21610;
																																																																	BgL_varsz00_21610
																																																																		=
																																																																		BgL_arg1740z00_1936;
																																																																	BgL_bodyz00_21611
																																																																		=
																																																																		BgL_arg1741z00_1937;
																																																																	BgL_argsz00_21612
																																																																		=
																																																																		BgL_arg1742z00_1938;
																																																																	BgL_argsz00_1774
																																																																		=
																																																																		BgL_argsz00_21612;
																																																																	BgL_bodyz00_1773
																																																																		=
																																																																		BgL_bodyz00_21611;
																																																																	BgL_varsz00_1772
																																																																		=
																																																																		BgL_varsz00_21610;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1775;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd229368zd2_1940;
																																																													BgL_cdrzd229368zd2_1940
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd229139zd2_1880));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg1744z00_1941;
																																																														obj_t
																																																															BgL_arg1749z00_1942;
																																																														obj_t
																																																															BgL_arg1751z00_1943;
																																																														BgL_arg1744z00_1941
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1940));
																																																														BgL_arg1749z00_1942
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd229368zd2_1940));
																																																														BgL_arg1751z00_1943
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_21622;
																																																															obj_t
																																																																BgL_bodyz00_21621;
																																																															obj_t
																																																																BgL_varsz00_21620;
																																																															BgL_varsz00_21620
																																																																=
																																																																BgL_arg1744z00_1941;
																																																															BgL_bodyz00_21621
																																																																=
																																																																BgL_arg1749z00_1942;
																																																															BgL_argsz00_21622
																																																																=
																																																																BgL_arg1751z00_1943;
																																																															BgL_argsz00_1774
																																																																=
																																																																BgL_argsz00_21622;
																																																															BgL_bodyz00_1773
																																																																=
																																																																BgL_bodyz00_21621;
																																																															BgL_varsz00_1772
																																																																=
																																																																BgL_varsz00_21620;
																																																															goto
																																																																BgL_tagzd2386zd2_1775;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd229394zd2_1946;
																																																											BgL_cdrzd229394zd2_1946
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd229139zd2_1880));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg1772z00_1947;
																																																												obj_t
																																																													BgL_arg1783z00_1948;
																																																												obj_t
																																																													BgL_arg1785z00_1949;
																																																												BgL_arg1772z00_1947
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1946));
																																																												BgL_arg1783z00_1948
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd229394zd2_1946));
																																																												BgL_arg1785z00_1949
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_21632;
																																																													obj_t
																																																														BgL_bodyz00_21631;
																																																													obj_t
																																																														BgL_varsz00_21630;
																																																													BgL_varsz00_21630
																																																														=
																																																														BgL_arg1772z00_1947;
																																																													BgL_bodyz00_21631
																																																														=
																																																														BgL_arg1783z00_1948;
																																																													BgL_argsz00_21632
																																																														=
																																																														BgL_arg1785z00_1949;
																																																													BgL_argsz00_1774
																																																														=
																																																														BgL_argsz00_21632;
																																																													BgL_bodyz00_1773
																																																														=
																																																														BgL_bodyz00_21631;
																																																													BgL_varsz00_1772
																																																														=
																																																														BgL_varsz00_21630;
																																																													goto
																																																														BgL_tagzd2386zd2_1775;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21635;
																																																											goto
																																																												BgL_tagzd2403zd2_1809;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21635);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1810;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd229532zd2_1954;
																																																							BgL_cdrzd229532zd2_1954
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd229139zd2_1880));
																																																							if ((CAR(((obj_t) BgL_carzd229139zd2_1880)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd229532zd2_1954))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd229537zd2_1958;
																																																											BgL_cdrzd229537zd2_1958
																																																												=
																																																												CDR
																																																												(BgL_cdrzd229532zd2_1954);
																																																											if (PAIRP(BgL_cdrzd229537zd2_1958))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd229541zd2_1960;
																																																													obj_t
																																																														BgL_cdrzd229542zd2_1961;
																																																													BgL_carzd229541zd2_1960
																																																														=
																																																														CAR
																																																														(BgL_cdrzd229537zd2_1958);
																																																													BgL_cdrzd229542zd2_1961
																																																														=
																																																														CDR
																																																														(BgL_cdrzd229537zd2_1958);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229541zd2_1960))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd229542zd2_1961))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd229547zd2_1964;
																																																																	BgL_carzd229547zd2_1964
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd229542zd2_1961);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229547zd2_1964))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (NULLP(CDR(BgL_cdrzd229542zd2_1961)))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test9307z00_21661;
																																																																					{
																																																																						obj_t
																																																																							BgL_l1416z00_1997;
																																																																						BgL_l1416z00_1997
																																																																							=
																																																																							BgL_cdrzd229140zd2_1881;
																																																																					BgL_zc3z04anonymousza31818ze3z87_1998:
																																																																						if (NULLP(BgL_l1416z00_1997))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test9307z00_21661
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9309z00_21664;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9310z00_21665;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_tmpz00_21666;
																																																																										BgL_tmpz00_21666
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_l1416z00_1997));
																																																																										BgL_test9310z00_21665
																																																																											=
																																																																											PAIRP
																																																																											(BgL_tmpz00_21666);
																																																																									}
																																																																									if (BgL_test9310z00_21665)
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9309z00_21664
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9309z00_21664
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																								}
																																																																								if (BgL_test9309z00_21664)
																																																																									{
																																																																										obj_t
																																																																											BgL_l1416z00_21670;
																																																																										BgL_l1416z00_21670
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_l1416z00_1997));
																																																																										BgL_l1416z00_1997
																																																																											=
																																																																											BgL_l1416z00_21670;
																																																																										goto
																																																																											BgL_zc3z04anonymousza31818ze3z87_1998;
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9307z00_21661
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																							}
																																																																					}
																																																																					if (BgL_test9307z00_21661)
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_21677;
																																																																							obj_t
																																																																								BgL_proc2z00_21676;
																																																																							obj_t
																																																																								BgL_proc1z00_21675;
																																																																							obj_t
																																																																								BgL_testz00_21673;
																																																																							BgL_testz00_21673
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd229532zd2_1954);
																																																																							BgL_proc1z00_21675
																																																																								=
																																																																								BgL_carzd229541zd2_1960;
																																																																							BgL_proc2z00_21676
																																																																								=
																																																																								BgL_carzd229547zd2_1964;
																																																																							BgL_argsz00_21677
																																																																								=
																																																																								BgL_cdrzd229140zd2_1881;
																																																																							BgL_argsz00_1779
																																																																								=
																																																																								BgL_argsz00_21677;
																																																																							BgL_proc2z00_1778
																																																																								=
																																																																								BgL_proc2z00_21676;
																																																																							BgL_proc1z00_1777
																																																																								=
																																																																								BgL_proc1z00_21675;
																																																																							BgL_testz00_1776
																																																																								=
																																																																								BgL_testz00_21673;
																																																																							goto
																																																																								BgL_tagzd2387zd2_1780;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd229572zd2_1981;
																																																																							BgL_cdrzd229572zd2_1981
																																																																								=
																																																																								CDR
																																																																								(BgL_expz00_21);
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd229580zd2_1982;
																																																																								BgL_cdrzd229580zd2_1982
																																																																									=
																																																																									CDR
																																																																									(CAR
																																																																									(BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd229588zd2_1983;
																																																																									BgL_cdrzd229588zd2_1983
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd229580zd2_1982));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd229595zd2_1984;
																																																																										BgL_carzd229595zd2_1984
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd229588zd2_1983));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229595zd2_1984))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd229604zd2_1986;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_11758;
																																																																													BgL_pairz00_11758
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd229588zd2_1983));
																																																																													BgL_carzd229604zd2_1986
																																																																														=
																																																																														CAR
																																																																														(BgL_pairz00_11758);
																																																																												}
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229604zd2_1986))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229572zd2_1981))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg1812z00_1989;
																																																																																BgL_arg1812z00_1989
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd229580zd2_1982));
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_21699;
																																																																																	obj_t
																																																																																		BgL_proc2z00_21698;
																																																																																	obj_t
																																																																																		BgL_proc1z00_21697;
																																																																																	obj_t
																																																																																		BgL_testz00_21696;
																																																																																	BgL_testz00_21696
																																																																																		=
																																																																																		BgL_arg1812z00_1989;
																																																																																	BgL_proc1z00_21697
																																																																																		=
																																																																																		BgL_carzd229595zd2_1984;
																																																																																	BgL_proc2z00_21698
																																																																																		=
																																																																																		BgL_carzd229604zd2_1986;
																																																																																	BgL_argsz00_21699
																																																																																		=
																																																																																		BgL_cdrzd229572zd2_1981;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_21699;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_21698;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_21697;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_21696;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_auxz00_21702;
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																		return
																																																																																			(
																																																																																			(BgL_nodez00_bglt)
																																																																																			BgL_auxz00_21702);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21706;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21706);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21710;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21710);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_21714;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_21714);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd229882zd2_2008;
																																																																			BgL_cdrzd229882zd2_2008
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd229889zd2_2009;
																																																																				BgL_cdrzd229889zd2_2009
																																																																					=
																																																																					CDR
																																																																					(CAR
																																																																					(BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd229896zd2_2010;
																																																																					BgL_cdrzd229896zd2_2010
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd229889zd2_2009));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd229902zd2_2011;
																																																																						obj_t
																																																																							BgL_cdrzd229903zd2_2012;
																																																																						BgL_carzd229902zd2_2011
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_2010));
																																																																						BgL_cdrzd229903zd2_2012
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd229896zd2_2010));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229902zd2_2011))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd229910zd2_2014;
																																																																								BgL_carzd229910zd2_2014
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd229903zd2_2012));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd229910zd2_2014))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(((obj_t) BgL_cdrzd229903zd2_2012))))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd229882zd2_2008))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg1830z00_2019;
																																																																														BgL_arg1830z00_2019
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd229889zd2_2009));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_21742;
																																																																															obj_t
																																																																																BgL_proc2z00_21741;
																																																																															obj_t
																																																																																BgL_proc1z00_21740;
																																																																															obj_t
																																																																																BgL_testz00_21739;
																																																																															BgL_testz00_21739
																																																																																=
																																																																																BgL_arg1830z00_2019;
																																																																															BgL_proc1z00_21740
																																																																																=
																																																																																BgL_carzd229902zd2_2011;
																																																																															BgL_proc2z00_21741
																																																																																=
																																																																																BgL_carzd229910zd2_2014;
																																																																															BgL_argsz00_21742
																																																																																=
																																																																																BgL_cdrzd229882zd2_2008;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_21742;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_21741;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_21740;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_21739;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_21745;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_21745);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21749;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21749);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21753;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21753);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21757;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21757);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{
																																																																			obj_t
																																																																				BgL_auxz00_21761;
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_21761);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd230243zd2_2027;
																																																															BgL_cdrzd230243zd2_2027
																																																																=
																																																																CDR
																																																																(BgL_expz00_21);
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd230249zd2_2028;
																																																																BgL_cdrzd230249zd2_2028
																																																																	=
																																																																	CDR
																																																																	(CAR
																																																																	(BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd230255zd2_2029;
																																																																	BgL_cdrzd230255zd2_2029
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd230249zd2_2028));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd230260zd2_2030;
																																																																		obj_t
																																																																			BgL_cdrzd230261zd2_2031;
																																																																		BgL_carzd230260zd2_2030
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_2029));
																																																																		BgL_cdrzd230261zd2_2031
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd230255zd2_2029));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230260zd2_2030))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd230261zd2_2031))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd230266zd2_2034;
																																																																						BgL_carzd230266zd2_2034
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd230261zd2_2031);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd230266zd2_2034))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd230261zd2_2031)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd230243zd2_2027))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg1845z00_2039;
																																																																												BgL_arg1845z00_2039
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd230249zd2_2028));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_21789;
																																																																													obj_t
																																																																														BgL_proc2z00_21788;
																																																																													obj_t
																																																																														BgL_proc1z00_21787;
																																																																													obj_t
																																																																														BgL_testz00_21786;
																																																																													BgL_testz00_21786
																																																																														=
																																																																														BgL_arg1845z00_2039;
																																																																													BgL_proc1z00_21787
																																																																														=
																																																																														BgL_carzd230260zd2_2030;
																																																																													BgL_proc2z00_21788
																																																																														=
																																																																														BgL_carzd230266zd2_2034;
																																																																													BgL_argsz00_21789
																																																																														=
																																																																														BgL_cdrzd230243zd2_2027;
																																																																													BgL_argsz00_1784
																																																																														=
																																																																														BgL_argsz00_21789;
																																																																													BgL_proc2z00_1783
																																																																														=
																																																																														BgL_proc2z00_21788;
																																																																													BgL_proc1z00_1782
																																																																														=
																																																																														BgL_proc1z00_21787;
																																																																													BgL_testz00_1781
																																																																														=
																																																																														BgL_testz00_21786;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1785;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_21792;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_21792);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_21796;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_21796);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_21800;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_21800);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_21804;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_21804);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_21808;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_21808);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21812;
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21812);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_21816;
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_21816);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_21820;
																																																											goto
																																																												BgL_tagzd2403zd2_1809;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_21820);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1810;
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{

																																			if (
																																				(BgL_carzd224574zd2_1864
																																					==
																																					CNST_TABLE_REF
																																					(((long) 17))))
																																				{
																																					obj_t
																																						BgL_auxz00_21825;
																																				BgL_kapzd230804zd2_2447:
																																					if (PAIRP(BgL_cdrzd224445zd2_1846))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg2216z00_2544;
																																							obj_t
																																								BgL_arg2217z00_2545;
																																							BgL_arg2216z00_2544
																																								=
																																								CAR
																																								(BgL_cdrzd224445zd2_1846);
																																							BgL_arg2217z00_2545
																																								=
																																								CDR
																																								(BgL_cdrzd224445zd2_1846);
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_21830;
																																								{
																																									obj_t
																																										BgL_exprz00_21832;
																																									obj_t
																																										BgL_bindingsz00_21831;
																																									BgL_bindingsz00_21831
																																										=
																																										BgL_arg2216z00_2544;
																																									BgL_exprz00_21832
																																										=
																																										BgL_arg2217z00_2545;
																																									BgL_exprz00_1764
																																										=
																																										BgL_exprz00_21832;
																																									BgL_bindingsz00_1763
																																										=
																																										BgL_bindingsz00_21831;
																																									goto
																																										BgL_tagzd2382zd2_1765;
																																								}
																																								BgL_auxz00_21825
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_21830);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_21839;
																																									goto
																																										BgL_tagzd2383zd2_1766;
																																									BgL_auxz00_21825
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_21839);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd230837zd2_2548;
																																									BgL_carzd230837zd2_2548
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if ((BgL_carzd230837zd2_2548 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_21846;
																																											goto
																																												BgL_tagzd2384zd2_1767;
																																											BgL_auxz00_21825
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_21846);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230837zd2_2548)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21851;
																																													goto
																																														BgL_tagzd2384zd2_1767;
																																													BgL_auxz00_21825
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_21851);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_21858;
																																															goto
																																																BgL_tagzd2389zd2_1786;
																																															BgL_auxz00_21825
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_21858);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_21865;
																																																	goto
																																																		BgL_tagzd2390zd2_1787;
																																																	BgL_auxz00_21825
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_21865);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_21872;
																																																			goto
																																																				BgL_tagzd2392zd2_1791;
																																																			BgL_auxz00_21825
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_21872);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_21879;
																																																					goto
																																																						BgL_tagzd2393zd2_1792;
																																																					BgL_auxz00_21825
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_21879);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_21886;
																																																							goto
																																																								BgL_tagzd2395zd2_1796;
																																																							BgL_auxz00_21825
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_21886);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_21893;
																																																									goto
																																																										BgL_tagzd2396zd2_1797;
																																																									BgL_auxz00_21825
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_21893);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_21900;
																																																											goto
																																																												BgL_tagzd2397zd2_1798;
																																																											BgL_auxz00_21825
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_21900);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																												{
																																																													BgL_jumpzd2exzd2itz00_bglt
																																																														BgL_auxz00_21907;
																																																													goto
																																																														BgL_tagzd2398zd2_1799;
																																																													BgL_auxz00_21825
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_21907);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21917;
																																																																	goto
																																																																		BgL_tagzd2402zd2_1808;
																																																																	BgL_auxz00_21825
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21917);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_21921;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_21825
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_21921);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_21925;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_21825
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_21925);
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_21825);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd224574zd2_1864)))
																																						{
																																							obj_t
																																								BgL_auxz00_21931;
																																							goto
																																								BgL_kapzd230804zd2_2447;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_21931);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd224574zd2_1864 == CNST_TABLE_REF(((long) 18))))
																																								{
																																									obj_t
																																										BgL_auxz00_21936;
																																									goto
																																										BgL_kapzd230804zd2_2447;
																																									return
																																										(
																																										(BgL_nodez00_bglt)
																																										BgL_auxz00_21936);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																										{	/* Ast/sexp.scm 119 */
																																											goto
																																												BgL_tagzd2383zd2_1766;
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd230998zd2_2453;
																																											BgL_carzd230998zd2_2453
																																												=
																																												CAR
																																												(BgL_expz00_21);
																																											if ((BgL_carzd230998zd2_2453 == CNST_TABLE_REF(((long) 19))))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_21946;
																																													goto
																																														BgL_tagzd2384zd2_1767;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_21946);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd230998zd2_2453)))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_21951;
																																															goto
																																																BgL_tagzd2384zd2_1767;
																																															return
																																																(
																																																(BgL_nodez00_bglt)
																																																BgL_auxz00_21951);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2389zd2_1786;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2390zd2_1787;
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd231077zd2_2460;
																																																			BgL_cdrzd231077zd2_2460
																																																				=
																																																				CDR
																																																				(BgL_expz00_21);
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd231077zd2_2460))
																																																						{
																																																							obj_t
																																																								BgL_restz00_21970;
																																																							obj_t
																																																								BgL_effectz00_21968;
																																																							BgL_effectz00_21968
																																																								=
																																																								CAR
																																																								(BgL_cdrzd231077zd2_2460);
																																																							BgL_restz00_21970
																																																								=
																																																								CDR
																																																								(BgL_cdrzd231077zd2_2460);
																																																							BgL_restz00_1789
																																																								=
																																																								BgL_restz00_21970;
																																																							BgL_effectz00_1788
																																																								=
																																																								BgL_effectz00_21968;
																																																							goto
																																																								BgL_tagzd2391zd2_1790;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_21974;
																																																									goto
																																																										BgL_tagzd2403zd2_1809;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_21974);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1810;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2392zd2_1791;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2393zd2_1792;
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd231077zd2_2460))
																																																												{
																																																													obj_t
																																																														BgL_restz00_21992;
																																																													obj_t
																																																														BgL_effectz00_21990;
																																																													BgL_effectz00_21990
																																																														=
																																																														CAR
																																																														(BgL_cdrzd231077zd2_2460);
																																																													BgL_restz00_21992
																																																														=
																																																														CDR
																																																														(BgL_cdrzd231077zd2_2460);
																																																													BgL_restz00_1794
																																																														=
																																																														BgL_restz00_21992;
																																																													BgL_effectz00_1793
																																																														=
																																																														BgL_effectz00_21990;
																																																													goto
																																																														BgL_tagzd2394zd2_1795;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{
																																																															obj_t
																																																																BgL_auxz00_21996;
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_21996);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2395zd2_1796;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2396zd2_1797;
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																																{
																																																																	BgL_letzd2funzd2_bglt
																																																																		BgL_auxz00_22010;
																																																																	goto
																																																																		BgL_tagzd2397zd2_1798;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_22010);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																		{
																																																																			BgL_jumpzd2exzd2itz00_bglt
																																																																				BgL_auxz00_22016;
																																																																			goto
																																																																				BgL_tagzd2398zd2_1799;
																																																																			return
																																																																				(
																																																																				(BgL_nodez00_bglt)
																																																																				BgL_auxz00_22016);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd231204zd2_2486;
																																																																			BgL_cdrzd231204zd2_2486
																																																																				=
																																																																				CDR
																																																																				(BgL_expz00_21);
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd231204zd2_2486))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd231206zd2_2490;
																																																																							BgL_cdrzd231206zd2_2490
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd231204zd2_2486);
																																																																							if (PAIRP(BgL_cdrzd231206zd2_2490))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd231206zd2_2490)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2399zd2_1800;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_22033;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_22033);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_22037;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_22037);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_22041;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_22041);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd231204zd2_2486))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd231251zd2_2502;
																																																																									BgL_cdrzd231251zd2_2502
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd231204zd2_2486);
																																																																									if (PAIRP(BgL_cdrzd231251zd2_2502))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd231256zd2_2504;
																																																																											BgL_cdrzd231256zd2_2504
																																																																												=
																																																																												CDR
																																																																												(BgL_cdrzd231251zd2_2502);
																																																																											if ((CAR(BgL_cdrzd231251zd2_2502) == CNST_TABLE_REF(((long) 31))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (PAIRP(BgL_cdrzd231256zd2_2504))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg2183z00_2508;
																																																																															obj_t
																																																																																BgL_arg2184z00_2509;
																																																																															obj_t
																																																																																BgL_arg2185z00_2510;
																																																																															BgL_arg2183z00_2508
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231204zd2_2486);
																																																																															BgL_arg2184z00_2509
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd231256zd2_2504);
																																																																															BgL_arg2185z00_2510
																																																																																=
																																																																																CDR
																																																																																(BgL_cdrzd231256zd2_2504);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2183z00_2508,
																																																																																BgL_arg2184z00_2509,
																																																																																BgL_arg2185z00_2510,
																																																																																BgL_stackz00_22,
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_locz00_23),
																																																																																BgL_sitez00_24);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd231269zd2_2511;
																																																																															BgL_cdrzd231269zd2_2511
																																																																																=
																																																																																CDR
																																																																																(BgL_expz00_21);
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg2186z00_2512;
																																																																																obj_t
																																																																																	BgL_arg2187z00_2513;
																																																																																BgL_arg2186z00_2512
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2511));
																																																																																BgL_arg2187z00_2513
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231269zd2_2511));
																																																																																{	/* Ast/sexp.scm 555 */
																																																																																	obj_t
																																																																																		BgL_arg7015z00_11841;
																																																																																	BgL_arg7015z00_11841
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	return
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_arg2186z00_2512,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg2187z00_2513, BgL_stackz00_22, BgL_arg7015z00_11841, BgL_sitez00_24);
																																																																												}}}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd231284zd2_2514;
																																																																													BgL_cdrzd231284zd2_2514
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg2188z00_2515;
																																																																														obj_t
																																																																															BgL_arg2189z00_2516;
																																																																														BgL_arg2188z00_2515
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2514));
																																																																														BgL_arg2189z00_2516
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231284zd2_2514));
																																																																														{	/* Ast/sexp.scm 555 */
																																																																															obj_t
																																																																																BgL_arg7015z00_11845;
																																																																															BgL_arg7015z00_11845
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg2188z00_2515,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg2189z00_2516, BgL_stackz00_22, BgL_arg7015z00_11845, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd231299zd2_2518;
																																																																											BgL_cdrzd231299zd2_2518
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg2191z00_2519;
																																																																												obj_t
																																																																													BgL_arg2192z00_2520;
																																																																												BgL_arg2191z00_2519
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2518));
																																																																												BgL_arg2192z00_2520
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd231299zd2_2518));
																																																																												{	/* Ast/sexp.scm 555 */
																																																																													obj_t
																																																																														BgL_arg7015z00_11849;
																																																																													BgL_arg7015z00_11849
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg2191z00_2519,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg2192z00_2520, BgL_stackz00_22, BgL_arg7015z00_11849, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_22090;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_22090);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_expz00_21)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2402zd2_1808;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{
																																																																													obj_t
																																																																														BgL_auxz00_22100;
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																													return
																																																																														(
																																																																														(BgL_nodez00_bglt)
																																																																														BgL_auxz00_22100);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_22104;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_22104);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																					}
																			}
																	}
															}
													}
											}
										else
											{	/* Ast/sexp.scm 119 */
												if (
													(BgL_carzd2478zd2_1815 ==
														CNST_TABLE_REF(((long) 11))))
													{	/* Ast/sexp.scm 119 */
														goto BgL_tagzd2371zd2_1745;
													}
												else
													{	/* Ast/sexp.scm 119 */
														if (
															(CAR(BgL_expz00_21) ==
																CNST_TABLE_REF(((long) 14))))
															{
																obj_t BgL_lz00_22113;

																BgL_lz00_22113 = CDR(BgL_expz00_21);
																BgL_lz00_1746 = BgL_lz00_22113;
																goto BgL_tagzd2372zd2_1747;
															}
														else
															{	/* Ast/sexp.scm 119 */
																if (
																	(CAR(BgL_expz00_21) ==
																		CNST_TABLE_REF(((long) 12))))
																	{	/* Ast/sexp.scm 119 */
																		goto BgL_tagzd2373zd2_1748;
																	}
																else
																	{	/* Ast/sexp.scm 119 */
																		if (
																			(CAR(BgL_expz00_21) ==
																				CNST_TABLE_REF(((long) 15))))
																			{	/* Ast/sexp.scm 119 */
																				if (NULLP(CDR(BgL_expz00_21)))
																					{	/* Ast/sexp.scm 119 */
																						goto BgL_tagzd2374zd2_1749;
																					}
																				else
																					{	/* Ast/sexp.scm 119 */
																						obj_t BgL_arg4326z00_5111;

																						BgL_arg4326z00_5111 =
																							CDR(BgL_expz00_21);
																						{
																							BgL_sequencez00_bglt
																								BgL_auxz00_22127;
																							{
																								obj_t BgL_bodyz00_22128;

																								BgL_bodyz00_22128 =
																									BgL_arg4326z00_5111;
																								BgL_bodyz00_1750 =
																									BgL_bodyz00_22128;
																								goto BgL_tagzd2375zd2_1751;
																							}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_22127);
																						}
																					}
																			}
																		else
																			{	/* Ast/sexp.scm 119 */
																				obj_t BgL_carzd231447zd2_5113;
																				obj_t BgL_cdrzd231448zd2_5114;

																				BgL_carzd231447zd2_5113 =
																					CAR(BgL_expz00_21);
																				BgL_cdrzd231448zd2_5114 =
																					CDR(BgL_expz00_21);
																				{

																					if (
																						(BgL_carzd231447zd2_5113 ==
																							CNST_TABLE_REF(((long) 1))))
																						{
																							obj_t BgL_auxz00_22135;

																						BgL_kapzd231449zd2_5115:
																							if (PAIRP
																								(BgL_cdrzd231448zd2_5114))
																								{	/* Ast/sexp.scm 119 */
																									obj_t BgL_cdrzd231452zd2_5862;

																									BgL_cdrzd231452zd2_5862 =
																										CDR
																										(BgL_cdrzd231448zd2_5114);
																									if (PAIRP
																										(BgL_cdrzd231452zd2_5862))
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd231455zd2_5864;
																											BgL_cdrzd231455zd2_5864 =
																												CDR
																												(BgL_cdrzd231452zd2_5862);
																											if ((CAR
																													(BgL_cdrzd231452zd2_5862)
																													== BTRUE))
																												{	/* Ast/sexp.scm 119 */
																													if (PAIRP
																														(BgL_cdrzd231455zd2_5864))
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR
																																	(BgL_cdrzd231455zd2_5864)
																																	== BFALSE))
																																{	/* Ast/sexp.scm 119 */
																																	if (NULLP(CDR
																																			(BgL_cdrzd231455zd2_5864)))
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_sitez00_24
																																					==
																																					CNST_TABLE_REF
																																					(((long) 8))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_arg4868z00_5874;
																																					BgL_arg4868z00_5874
																																						=
																																						CAR
																																						(BgL_cdrzd231448zd2_5114);
																																					BgL_auxz00_22135
																																						=
																																						(
																																						(obj_t)
																																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																																						(BgL_arg4868z00_5874,
																																							BgL_stackz00_22,
																																							BgL_locz00_23,
																																							BgL_sitez00_24));
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd231474zd2_5875;
																																					BgL_carzd231474zd2_5875
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd231474zd2_5875
																																							==
																																							CNST_TABLE_REF
																																							(((long) 1))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22164;
																																							goto
																																								BgL_tagzd2377zd2_1754;
																																							BgL_auxz00_22135
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22164);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd231474zd2_5875 == BGl_za2ifza2z00zzast_sexpz00))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22168;
																																									goto
																																										BgL_tagzd2377zd2_1754;
																																									BgL_auxz00_22135
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22168);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22175;
																																											goto
																																												BgL_tagzd2379zd2_1758;
																																											BgL_auxz00_22135
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22175);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_22182;
																																													goto
																																														BgL_tagzd2380zd2_1759;
																																													BgL_auxz00_22135
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_22182);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd231543zd2_5882;
																																													BgL_carzd231543zd2_5882
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if (PAIRP(BgL_carzd231543zd2_5882))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd231546zd2_5884;
																																															obj_t
																																																BgL_cdrzd231547zd2_5885;
																																															BgL_carzd231546zd2_5884
																																																=
																																																CAR
																																																(BgL_carzd231543zd2_5882);
																																															BgL_cdrzd231547zd2_5885
																																																=
																																																CDR
																																																(BgL_carzd231543zd2_5882);
																																															{

																																																if ((BgL_carzd231546zd2_5884 == CNST_TABLE_REF(((long) 17))))
																																																	{	/* Ast/sexp.scm 119 */
																																																	BgL_kapzd231548zd2_5886:
																																																		if (PAIRP(BgL_cdrzd231547zd2_5885))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd231551zd2_6011;
																																																				BgL_cdrzd231551zd2_6011
																																																					=
																																																					CDR
																																																					(BgL_cdrzd231547zd2_5885);
																																																				if (PAIRP(BgL_cdrzd231551zd2_6011))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (NULLP(CDR(BgL_cdrzd231551zd2_6011)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg4960z00_6015;
																																																								obj_t
																																																									BgL_arg4961z00_6016;
																																																								BgL_arg4960z00_6015
																																																									=
																																																									CAR
																																																									(BgL_cdrzd231551zd2_6011);
																																																								BgL_arg4961z00_6016
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_22204;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_22206;
																																																										obj_t
																																																											BgL_bodyz00_22205;
																																																										BgL_bodyz00_22205
																																																											=
																																																											BgL_arg4960z00_6015;
																																																										BgL_argsz00_22206
																																																											=
																																																											BgL_arg4961z00_6016;
																																																										BgL_argsz00_1761
																																																											=
																																																											BgL_argsz00_22206;
																																																										BgL_bodyz00_1760
																																																											=
																																																											BgL_bodyz00_22205;
																																																										goto
																																																											BgL_tagzd2381zd2_1762;
																																																									}
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22204);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd231575zd2_6017;
																																																								BgL_cdrzd231575zd2_6017
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9415z00_22210;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5030z00_6128;
																																																										BgL_arg5030z00_6128
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9415z00_22210
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5030z00_6128));
																																																									}
																																																									if (BgL_test9415z00_22210)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg4964z00_6020;
																																																											obj_t
																																																												BgL_arg4965z00_6021;
																																																											BgL_arg4964z00_6020
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_6017));
																																																											BgL_arg4965z00_6021
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd231575zd2_6017));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_22219;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_22221;
																																																													obj_t
																																																														BgL_bindingsz00_22220;
																																																													BgL_bindingsz00_22220
																																																														=
																																																														BgL_arg4964z00_6020;
																																																													BgL_exprz00_22221
																																																														=
																																																														BgL_arg4965z00_6021;
																																																													BgL_exprz00_1764
																																																														=
																																																														BgL_exprz00_22221;
																																																													BgL_bindingsz00_1763
																																																														=
																																																														BgL_bindingsz00_22220;
																																																													goto
																																																														BgL_tagzd2382zd2_1765;
																																																												}
																																																												BgL_auxz00_22135
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_22219);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test9416z00_22223;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5029z00_6127;
																																																												BgL_arg5029z00_6127
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9416z00_22223
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5029z00_6127));
																																																											}
																																																											if (BgL_test9416z00_22223)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_22228;
																																																													goto
																																																														BgL_tagzd2384zd2_1767;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22228);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd231642zd2_6024;
																																																													BgL_carzd231642zd2_6024
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd231647zd2_6025;
																																																														BgL_cdrzd231647zd2_6025
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd231642zd2_6024));
																																																														if ((CAR(((obj_t) BgL_carzd231642zd2_6024)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg4970z00_6028;
																																																																obj_t
																																																																	BgL_arg4971z00_6029;
																																																																obj_t
																																																																	BgL_arg4972z00_6030;
																																																																BgL_arg4970z00_6028
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_6025));
																																																																BgL_arg4971z00_6029
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd231647zd2_6025));
																																																																BgL_arg4972z00_6030
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_22245;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_22248;
																																																																		obj_t
																																																																			BgL_bodyz00_22247;
																																																																		obj_t
																																																																			BgL_varsz00_22246;
																																																																		BgL_varsz00_22246
																																																																			=
																																																																			BgL_arg4970z00_6028;
																																																																		BgL_bodyz00_22247
																																																																			=
																																																																			BgL_arg4971z00_6029;
																																																																		BgL_argsz00_22248
																																																																			=
																																																																			BgL_arg4972z00_6030;
																																																																		BgL_argsz00_1774
																																																																			=
																																																																			BgL_argsz00_22248;
																																																																		BgL_bodyz00_1773
																																																																			=
																																																																			BgL_bodyz00_22247;
																																																																		BgL_varsz00_1772
																																																																			=
																																																																			BgL_varsz00_22246;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1775;
																																																																	}
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_22245);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd231670zd2_6032;
																																																																BgL_cdrzd231670zd2_6032
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd231676zd2_6033;
																																																																	BgL_cdrzd231676zd2_6033
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd231642zd2_6024));
																																																																	if ((CAR(((obj_t) BgL_carzd231642zd2_6024)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd231682zd2_6036;
																																																																			BgL_cdrzd231682zd2_6036
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd231676zd2_6033));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd231687zd2_6037;
																																																																				obj_t
																																																																					BgL_cdrzd231688zd2_6038;
																																																																				BgL_carzd231687zd2_6037
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_6036));
																																																																				BgL_cdrzd231688zd2_6038
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd231682zd2_6036));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231687zd2_6037))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (PAIRP(BgL_cdrzd231688zd2_6038))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd231695zd2_6041;
																																																																								BgL_carzd231695zd2_6041
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd231688zd2_6038);
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231695zd2_6041))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (NULLP(CDR(BgL_cdrzd231688zd2_6038)))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9423z00_22275;
																																																																												{
																																																																													obj_t
																																																																														BgL_l1419z00_6074;
																																																																													BgL_l1419z00_6074
																																																																														=
																																																																														BgL_cdrzd231670zd2_6032;
																																																																												BgL_zc3z04anonymousza34995ze3z87_6075:
																																																																													if (NULLP(BgL_l1419z00_6074))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9423z00_22275
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test9425z00_22278;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test9426z00_22279;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_tmpz00_22280;
																																																																																	BgL_tmpz00_22280
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_l1419z00_6074));
																																																																																	BgL_test9426z00_22279
																																																																																		=
																																																																																		PAIRP
																																																																																		(BgL_tmpz00_22280);
																																																																																}
																																																																																if (BgL_test9426z00_22279)
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9425z00_22278
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9425z00_22278
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																															}
																																																																															if (BgL_test9425z00_22278)
																																																																																{
																																																																																	obj_t
																																																																																		BgL_l1419z00_22284;
																																																																																	BgL_l1419z00_22284
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_l1419z00_6074));
																																																																																	BgL_l1419z00_6074
																																																																																		=
																																																																																		BgL_l1419z00_22284;
																																																																																	goto
																																																																																		BgL_zc3z04anonymousza34995ze3z87_6075;
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test9423z00_22275
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																														}
																																																																												}
																																																																												if (BgL_test9423z00_22275)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4985z00_6057;
																																																																														BgL_arg4985z00_6057
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd231676zd2_6033));
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22289;
																																																																															{
																																																																																obj_t
																																																																																	BgL_argsz00_22293;
																																																																																obj_t
																																																																																	BgL_proc2z00_22292;
																																																																																obj_t
																																																																																	BgL_proc1z00_22291;
																																																																																obj_t
																																																																																	BgL_testz00_22290;
																																																																																BgL_testz00_22290
																																																																																	=
																																																																																	BgL_arg4985z00_6057;
																																																																																BgL_proc1z00_22291
																																																																																	=
																																																																																	BgL_carzd231687zd2_6037;
																																																																																BgL_proc2z00_22292
																																																																																	=
																																																																																	BgL_carzd231695zd2_6041;
																																																																																BgL_argsz00_22293
																																																																																	=
																																																																																	BgL_cdrzd231670zd2_6032;
																																																																																BgL_argsz00_1779
																																																																																	=
																																																																																	BgL_argsz00_22293;
																																																																																BgL_proc2z00_1778
																																																																																	=
																																																																																	BgL_proc2z00_22292;
																																																																																BgL_proc1z00_1777
																																																																																	=
																																																																																	BgL_proc1z00_22291;
																																																																																BgL_testz00_1776
																																																																																	=
																																																																																	BgL_testz00_22290;
																																																																																goto
																																																																																	BgL_tagzd2387zd2_1780;
																																																																															}
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22289);
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd231719zd2_6058;
																																																																														BgL_cdrzd231719zd2_6058
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd231726zd2_6059;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_11916;
																																																																																BgL_pairz00_11916
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_expz00_21));
																																																																																BgL_cdrzd231726zd2_6059
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_pairz00_11916);
																																																																															}
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd231733zd2_6060;
																																																																																BgL_cdrzd231733zd2_6060
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd231726zd2_6059));
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd231739zd2_6061;
																																																																																	BgL_carzd231739zd2_6061
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd231733zd2_6060));
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231739zd2_6061))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_carzd231746zd2_6063;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_pairz00_11920;
																																																																																				BgL_pairz00_11920
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd231733zd2_6060));
																																																																																				BgL_carzd231746zd2_6063
																																																																																					=
																																																																																					CAR
																																																																																					(BgL_pairz00_11920);
																																																																																			}
																																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd231746zd2_6063))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd231719zd2_6058))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_arg4989z00_6066;
																																																																																							BgL_arg4989z00_6066
																																																																																								=
																																																																																								CAR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd231726zd2_6059));
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22315;
																																																																																								{
																																																																																									obj_t
																																																																																										BgL_argsz00_22319;
																																																																																									obj_t
																																																																																										BgL_proc2z00_22318;
																																																																																									obj_t
																																																																																										BgL_proc1z00_22317;
																																																																																									obj_t
																																																																																										BgL_testz00_22316;
																																																																																									BgL_testz00_22316
																																																																																										=
																																																																																										BgL_arg4989z00_6066;
																																																																																									BgL_proc1z00_22317
																																																																																										=
																																																																																										BgL_carzd231739zd2_6061;
																																																																																									BgL_proc2z00_22318
																																																																																										=
																																																																																										BgL_carzd231746zd2_6063;
																																																																																									BgL_argsz00_22319
																																																																																										=
																																																																																										BgL_cdrzd231719zd2_6058;
																																																																																									BgL_argsz00_1784
																																																																																										=
																																																																																										BgL_argsz00_22319;
																																																																																									BgL_proc2z00_1783
																																																																																										=
																																																																																										BgL_proc2z00_22318;
																																																																																									BgL_proc1z00_1782
																																																																																										=
																																																																																										BgL_proc1z00_22317;
																																																																																									BgL_testz00_1781
																																																																																										=
																																																																																										BgL_testz00_22316;
																																																																																									goto
																																																																																										BgL_tagzd2388zd2_1785;
																																																																																								}
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22315);
																																																																																							}
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									goto
																																																																																										BgL_tagzd2403zd2_1809;
																																																																																								}
																																																																																							else
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22323;
																																																																																									goto
																																																																																										BgL_tagzd2404zd2_1810;
																																																																																									BgL_auxz00_22135
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22323);
																																																																																								}
																																																																																						}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22327;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_22135
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22327);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22331;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22331);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															}
																																																																														}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_22335;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_22335);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd232022zd2_6085;
																																																																										BgL_cdrzd232022zd2_6085
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd232028zd2_6086;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_11924;
																																																																												BgL_pairz00_11924
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd232028zd2_6086
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_11924);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd232034zd2_6087;
																																																																												BgL_cdrzd232034zd2_6087
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd232028zd2_6086));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd232039zd2_6088;
																																																																													obj_t
																																																																														BgL_cdrzd232040zd2_6089;
																																																																													BgL_carzd232039zd2_6088
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6087));
																																																																													BgL_cdrzd232040zd2_6089
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd232034zd2_6087));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232039zd2_6088))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd232045zd2_6091;
																																																																															BgL_carzd232045zd2_6091
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd232040zd2_6089));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232045zd2_6091))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (NULLP(CDR(((obj_t) BgL_cdrzd232040zd2_6089))))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232022zd2_6085))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg5004z00_6096;
																																																																																					BgL_arg5004z00_6096
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd232028zd2_6086));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22362;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_22366;
																																																																																							obj_t
																																																																																								BgL_proc2z00_22365;
																																																																																							obj_t
																																																																																								BgL_proc1z00_22364;
																																																																																							obj_t
																																																																																								BgL_testz00_22363;
																																																																																							BgL_testz00_22363
																																																																																								=
																																																																																								BgL_arg5004z00_6096;
																																																																																							BgL_proc1z00_22364
																																																																																								=
																																																																																								BgL_carzd232039zd2_6088;
																																																																																							BgL_proc2z00_22365
																																																																																								=
																																																																																								BgL_carzd232045zd2_6091;
																																																																																							BgL_argsz00_22366
																																																																																								=
																																																																																								BgL_cdrzd232022zd2_6085;
																																																																																							BgL_argsz00_1784
																																																																																								=
																																																																																								BgL_argsz00_22366;
																																																																																							BgL_proc2z00_1783
																																																																																								=
																																																																																								BgL_proc2z00_22365;
																																																																																							BgL_proc1z00_1782
																																																																																								=
																																																																																								BgL_proc1z00_22364;
																																																																																							BgL_testz00_1781
																																																																																								=
																																																																																								BgL_testz00_22363;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1785;
																																																																																						}
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22362);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_22370;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_22135
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_22370);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22374;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22374);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22378;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22378);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22382;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22382);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_22386;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_22135
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_22386);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd232378zd2_6104;
																																																																						BgL_cdrzd232378zd2_6104
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd232385zd2_6105;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_11934;
																																																																								BgL_pairz00_11934
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd232385zd2_6105
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_11934);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd232392zd2_6106;
																																																																								BgL_cdrzd232392zd2_6106
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd232385zd2_6105));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd232398zd2_6107;
																																																																									obj_t
																																																																										BgL_cdrzd232399zd2_6108;
																																																																									BgL_carzd232398zd2_6107
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6106));
																																																																									BgL_cdrzd232399zd2_6108
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd232392zd2_6106));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232398zd2_6107))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd232399zd2_6108))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd232406zd2_6111;
																																																																													BgL_carzd232406zd2_6111
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd232399zd2_6108);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd232406zd2_6111))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd232399zd2_6108)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd232378zd2_6104))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg5018z00_6116;
																																																																																			BgL_arg5018z00_6116
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd232385zd2_6105));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22413;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22417;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22416;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22415;
																																																																																					obj_t
																																																																																						BgL_testz00_22414;
																																																																																					BgL_testz00_22414
																																																																																						=
																																																																																						BgL_arg5018z00_6116;
																																																																																					BgL_proc1z00_22415
																																																																																						=
																																																																																						BgL_carzd232398zd2_6107;
																																																																																					BgL_proc2z00_22416
																																																																																						=
																																																																																						BgL_carzd232406zd2_6111;
																																																																																					BgL_argsz00_22417
																																																																																						=
																																																																																						BgL_cdrzd232378zd2_6104;
																																																																																					BgL_argsz00_1784
																																																																																						=
																																																																																						BgL_argsz00_22417;
																																																																																					BgL_proc2z00_1783
																																																																																						=
																																																																																						BgL_proc2z00_22416;
																																																																																					BgL_proc1z00_1782
																																																																																						=
																																																																																						BgL_proc1z00_22415;
																																																																																					BgL_testz00_1781
																																																																																						=
																																																																																						BgL_testz00_22414;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1785;
																																																																																				}
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22413);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_22421;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_22421);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22425;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22425);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_22429;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_22429);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22433;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22433);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_22437;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22437);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22441;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22441);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd232799zd2_6130;
																																																						BgL_cdrzd232799zd2_6130
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9454z00_22445;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5046z00_6147;
																																																								BgL_arg5046z00_6147
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9454z00_22445
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5046z00_6147));
																																																							}
																																																							if (BgL_test9454z00_22445)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg5034z00_6133;
																																																									obj_t
																																																										BgL_arg5035z00_6134;
																																																									BgL_arg5034z00_6133
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6130));
																																																									BgL_arg5035z00_6134
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd232799zd2_6130));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22454;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22456;
																																																											obj_t
																																																												BgL_bindingsz00_22455;
																																																											BgL_bindingsz00_22455
																																																												=
																																																												BgL_arg5034z00_6133;
																																																											BgL_exprz00_22456
																																																												=
																																																												BgL_arg5035z00_6134;
																																																											BgL_exprz00_1764
																																																												=
																																																												BgL_exprz00_22456;
																																																											BgL_bindingsz00_1763
																																																												=
																																																												BgL_bindingsz00_22455;
																																																											goto
																																																												BgL_tagzd2382zd2_1765;
																																																										}
																																																										BgL_auxz00_22135
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22454);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9455z00_22458;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5045z00_6146;
																																																										BgL_arg5045z00_6146
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9455z00_22458
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5045z00_6146));
																																																									}
																																																									if (BgL_test9455z00_22458)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22463;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22463);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd232865zd2_6137;
																																																											BgL_carzd232865zd2_6137
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd232870zd2_6138;
																																																												BgL_cdrzd232870zd2_6138
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd232865zd2_6137));
																																																												if ((CAR(((obj_t) BgL_carzd232865zd2_6137)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg5040z00_6141;
																																																														obj_t
																																																															BgL_arg5041z00_6142;
																																																														obj_t
																																																															BgL_arg5042z00_6143;
																																																														BgL_arg5040z00_6141
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6138));
																																																														BgL_arg5041z00_6142
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd232870zd2_6138));
																																																														BgL_arg5042z00_6143
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22480;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_22483;
																																																																obj_t
																																																																	BgL_bodyz00_22482;
																																																																obj_t
																																																																	BgL_varsz00_22481;
																																																																BgL_varsz00_22481
																																																																	=
																																																																	BgL_arg5040z00_6141;
																																																																BgL_bodyz00_22482
																																																																	=
																																																																	BgL_arg5041z00_6142;
																																																																BgL_argsz00_22483
																																																																	=
																																																																	BgL_arg5042z00_6143;
																																																																BgL_argsz00_1774
																																																																	=
																																																																	BgL_argsz00_22483;
																																																																BgL_bodyz00_1773
																																																																	=
																																																																	BgL_bodyz00_22482;
																																																																BgL_varsz00_1772
																																																																	=
																																																																	BgL_varsz00_22481;
																																																																goto
																																																																	BgL_tagzd2386zd2_1775;
																																																															}
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22480);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_22487;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_22487);
																																																															}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd232981zd2_6148;
																																																				BgL_cdrzd232981zd2_6148
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9458z00_22491;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5055z00_6157;
																																																						BgL_arg5055z00_6157
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9458z00_22491
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5055z00_6157));
																																																					}
																																																					if (BgL_test9458z00_22491)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5049z00_6151;
																																																							obj_t
																																																								BgL_arg5050z00_6152;
																																																							BgL_arg5049z00_6151
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6148));
																																																							BgL_arg5050z00_6152
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd232981zd2_6148));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_22500;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_22502;
																																																									obj_t
																																																										BgL_bindingsz00_22501;
																																																									BgL_bindingsz00_22501
																																																										=
																																																										BgL_arg5049z00_6151;
																																																									BgL_exprz00_22502
																																																										=
																																																										BgL_arg5050z00_6152;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_22502;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_22501;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_22135
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_22500);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9459z00_22504;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5054z00_6156;
																																																								BgL_arg5054z00_6156
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9459z00_22504
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5054z00_6156));
																																																							}
																																																							if (BgL_test9459z00_22504)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22509;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22509);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1809;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_22513;
																																																											goto
																																																												BgL_tagzd2404zd2_1810;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22513);
																																																										}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231546zd2_5884)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd231548zd2_5886;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd231546zd2_5884 == CNST_TABLE_REF(((long) 18))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd231548zd2_5886;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if ((BgL_carzd231546zd2_5884 == CNST_TABLE_REF(((long) 19))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd231548zd2_5886;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd231546zd2_5884)))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_kapzd231548zd2_5886;
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd233153zd2_5892;
																																																										BgL_cdrzd233153zd2_5892
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test9465z00_22529;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg4955z00_6009;
																																																												BgL_arg4955z00_6009
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9465z00_22529
																																																													=
																																																													CBOOL
																																																													(BGl_letzd2symzf3z21zzast_letz00
																																																													(BgL_arg4955z00_6009));
																																																											}
																																																											if (BgL_test9465z00_22529)
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg4883z00_5895;
																																																													obj_t
																																																														BgL_arg4884z00_5896;
																																																													BgL_arg4883z00_5895
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5892));
																																																													BgL_arg4884z00_5896
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd233153zd2_5892));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_22538;
																																																														{
																																																															obj_t
																																																																BgL_exprz00_22540;
																																																															obj_t
																																																																BgL_bindingsz00_22539;
																																																															BgL_bindingsz00_22539
																																																																=
																																																																BgL_arg4883z00_5895;
																																																															BgL_exprz00_22540
																																																																=
																																																																BgL_arg4884z00_5896;
																																																															BgL_exprz00_1764
																																																																=
																																																																BgL_exprz00_22540;
																																																															BgL_bindingsz00_1763
																																																																=
																																																																BgL_bindingsz00_22539;
																																																															goto
																																																																BgL_tagzd2382zd2_1765;
																																																														}
																																																														BgL_auxz00_22135
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_22538);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test9466z00_22542;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg4954z00_6008;
																																																														BgL_arg4954z00_6008
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_test9466z00_22542
																																																															=
																																																															CBOOL
																																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																																															(BgL_arg4954z00_6008));
																																																													}
																																																													if (BgL_test9466z00_22542)
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_22547;
																																																															goto
																																																																BgL_tagzd2384zd2_1767;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22547);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd233219zd2_5899;
																																																															BgL_carzd233219zd2_5899
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd233224zd2_5900;
																																																																BgL_cdrzd233224zd2_5900
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd233219zd2_5899));
																																																																if ((CAR(((obj_t) BgL_carzd233219zd2_5899)) == CNST_TABLE_REF(((long) 3))))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd233224zd2_5900))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg4890z00_5904;
																																																																				obj_t
																																																																					BgL_arg4891z00_5905;
																																																																				obj_t
																																																																					BgL_arg4892z00_5906;
																																																																				BgL_arg4890z00_5904
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd233224zd2_5900);
																																																																				BgL_arg4891z00_5905
																																																																					=
																																																																					CDR
																																																																					(BgL_cdrzd233224zd2_5900);
																																																																				BgL_arg4892z00_5906
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22564;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_22567;
																																																																						obj_t
																																																																							BgL_bodyz00_22566;
																																																																						obj_t
																																																																							BgL_varsz00_22565;
																																																																						BgL_varsz00_22565
																																																																							=
																																																																							BgL_arg4890z00_5904;
																																																																						BgL_bodyz00_22566
																																																																							=
																																																																							BgL_arg4891z00_5905;
																																																																						BgL_argsz00_22567
																																																																							=
																																																																							BgL_arg4892z00_5906;
																																																																						BgL_argsz00_1774
																																																																							=
																																																																							BgL_argsz00_22567;
																																																																						BgL_bodyz00_1773
																																																																							=
																																																																							BgL_bodyz00_22566;
																																																																						BgL_varsz00_1772
																																																																							=
																																																																							BgL_varsz00_22565;
																																																																						goto
																																																																							BgL_tagzd2386zd2_1775;
																																																																					}
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22564);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_22571;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_22135
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_22571);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd233331zd2_5909;
																																																																		BgL_cdrzd233331zd2_5909
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd233336zd2_5910;
																																																																			BgL_cdrzd233336zd2_5910
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_carzd233219zd2_5899));
																																																																			if ((CAR(((obj_t) BgL_carzd233219zd2_5899)) == CNST_TABLE_REF(((long) 1))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd233336zd2_5910))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd233341zd2_5914;
																																																																							BgL_cdrzd233341zd2_5914
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd233336zd2_5910);
																																																																							if (PAIRP(BgL_cdrzd233341zd2_5914))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd233345zd2_5916;
																																																																									obj_t
																																																																										BgL_cdrzd233346zd2_5917;
																																																																									BgL_carzd233345zd2_5916
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd233341zd2_5914);
																																																																									BgL_cdrzd233346zd2_5917
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd233341zd2_5914);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233345zd2_5916))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd233346zd2_5917))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd233351zd2_5920;
																																																																													BgL_carzd233351zd2_5920
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd233346zd2_5917);
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233351zd2_5920))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(BgL_cdrzd233346zd2_5917)))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test9477z00_22599;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1422z00_5953;
																																																																																		BgL_l1422z00_5953
																																																																																			=
																																																																																			BgL_cdrzd233331zd2_5909;
																																																																																	BgL_zc3z04anonymousza34918ze3z87_5954:
																																																																																		if (NULLP(BgL_l1422z00_5953))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test9477z00_22599
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					1);
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				bool_t
																																																																																					BgL_test9479z00_22602;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					bool_t
																																																																																						BgL_test9480z00_22603;
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_tmpz00_22604;
																																																																																						BgL_tmpz00_22604
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_l1422z00_5953));
																																																																																						BgL_test9480z00_22603
																																																																																							=
																																																																																							PAIRP
																																																																																							(BgL_tmpz00_22604);
																																																																																					}
																																																																																					if (BgL_test9480z00_22603)
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test9479z00_22602
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								0);
																																																																																						}
																																																																																					else
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							BgL_test9479z00_22602
																																																																																								=
																																																																																								(
																																																																																								(bool_t)
																																																																																								1);
																																																																																						}
																																																																																				}
																																																																																				if (BgL_test9479z00_22602)
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_l1422z00_22608;
																																																																																						BgL_l1422z00_22608
																																																																																							=
																																																																																							CDR
																																																																																							(
																																																																																							((obj_t) BgL_l1422z00_5953));
																																																																																						BgL_l1422z00_5953
																																																																																							=
																																																																																							BgL_l1422z00_22608;
																																																																																						goto
																																																																																							BgL_zc3z04anonymousza34918ze3z87_5954;
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						BgL_test9477z00_22599
																																																																																							=
																																																																																							(
																																																																																							(bool_t)
																																																																																							0);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																	if (BgL_test9477z00_22599)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg4908z00_5936;
																																																																																			BgL_arg4908z00_5936
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_cdrzd233336zd2_5910);
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22612;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_22616;
																																																																																					obj_t
																																																																																						BgL_proc2z00_22615;
																																																																																					obj_t
																																																																																						BgL_proc1z00_22614;
																																																																																					obj_t
																																																																																						BgL_testz00_22613;
																																																																																					BgL_testz00_22613
																																																																																						=
																																																																																						BgL_arg4908z00_5936;
																																																																																					BgL_proc1z00_22614
																																																																																						=
																																																																																						BgL_carzd233345zd2_5916;
																																																																																					BgL_proc2z00_22615
																																																																																						=
																																																																																						BgL_carzd233351zd2_5920;
																																																																																					BgL_argsz00_22616
																																																																																						=
																																																																																						BgL_cdrzd233331zd2_5909;
																																																																																					BgL_argsz00_1779
																																																																																						=
																																																																																						BgL_argsz00_22616;
																																																																																					BgL_proc2z00_1778
																																																																																						=
																																																																																						BgL_proc2z00_22615;
																																																																																					BgL_proc1z00_1777
																																																																																						=
																																																																																						BgL_proc1z00_22614;
																																																																																					BgL_testz00_1776
																																																																																						=
																																																																																						BgL_testz00_22613;
																																																																																					goto
																																																																																						BgL_tagzd2387zd2_1780;
																																																																																				}
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22612);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd233376zd2_5937;
																																																																																			BgL_cdrzd233376zd2_5937
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_cdrzd233384zd2_5938;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_11991;
																																																																																					BgL_pairz00_11991
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_expz00_21));
																																																																																					BgL_cdrzd233384zd2_5938
																																																																																						=
																																																																																						CDR
																																																																																						(BgL_pairz00_11991);
																																																																																				}
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_cdrzd233392zd2_5939;
																																																																																					BgL_cdrzd233392zd2_5939
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd233384zd2_5938));
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd233399zd2_5940;
																																																																																						BgL_carzd233399zd2_5940
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd233392zd2_5939));
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233399zd2_5940))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_carzd233408zd2_5942;
																																																																																								{	/* Ast/sexp.scm 119 */
																																																																																									obj_t
																																																																																										BgL_pairz00_11995;
																																																																																									BgL_pairz00_11995
																																																																																										=
																																																																																										CDR
																																																																																										(
																																																																																										((obj_t) BgL_cdrzd233392zd2_5939));
																																																																																									BgL_carzd233408zd2_5942
																																																																																										=
																																																																																										CAR
																																																																																										(BgL_pairz00_11995);
																																																																																								}
																																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233408zd2_5942))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233376zd2_5937))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												obj_t
																																																																																													BgL_arg4912z00_5945;
																																																																																												BgL_arg4912z00_5945
																																																																																													=
																																																																																													CAR
																																																																																													(
																																																																																													((obj_t) BgL_cdrzd233384zd2_5938));
																																																																																												{
																																																																																													BgL_nodez00_bglt
																																																																																														BgL_auxz00_22638;
																																																																																													{
																																																																																														obj_t
																																																																																															BgL_argsz00_22642;
																																																																																														obj_t
																																																																																															BgL_proc2z00_22641;
																																																																																														obj_t
																																																																																															BgL_proc1z00_22640;
																																																																																														obj_t
																																																																																															BgL_testz00_22639;
																																																																																														BgL_testz00_22639
																																																																																															=
																																																																																															BgL_arg4912z00_5945;
																																																																																														BgL_proc1z00_22640
																																																																																															=
																																																																																															BgL_carzd233399zd2_5940;
																																																																																														BgL_proc2z00_22641
																																																																																															=
																																																																																															BgL_carzd233408zd2_5942;
																																																																																														BgL_argsz00_22642
																																																																																															=
																																																																																															BgL_cdrzd233376zd2_5937;
																																																																																														BgL_argsz00_1784
																																																																																															=
																																																																																															BgL_argsz00_22642;
																																																																																														BgL_proc2z00_1783
																																																																																															=
																																																																																															BgL_proc2z00_22641;
																																																																																														BgL_proc1z00_1782
																																																																																															=
																																																																																															BgL_proc1z00_22640;
																																																																																														BgL_testz00_1781
																																																																																															=
																																																																																															BgL_testz00_22639;
																																																																																														goto
																																																																																															BgL_tagzd2388zd2_1785;
																																																																																													}
																																																																																													BgL_auxz00_22135
																																																																																														=
																																																																																														(
																																																																																														(obj_t)
																																																																																														BgL_auxz00_22638);
																																																																																												}
																																																																																											}
																																																																																										else
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																													{	/* Ast/sexp.scm 119 */
																																																																																														goto
																																																																																															BgL_tagzd2403zd2_1809;
																																																																																													}
																																																																																												else
																																																																																													{
																																																																																														BgL_nodez00_bglt
																																																																																															BgL_auxz00_22646;
																																																																																														goto
																																																																																															BgL_tagzd2404zd2_1810;
																																																																																														BgL_auxz00_22135
																																																																																															=
																																																																																															(
																																																																																															(obj_t)
																																																																																															BgL_auxz00_22646);
																																																																																													}
																																																																																											}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22650;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_22135
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22650);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22654;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_22135
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22654);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				}
																																																																																			}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22658;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22658);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd233686zd2_5964;
																																																																															BgL_cdrzd233686zd2_5964
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd233693zd2_5965;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_11999;
																																																																																	BgL_pairz00_11999
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd233693zd2_5965
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_11999);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd233700zd2_5966;
																																																																																	BgL_cdrzd233700zd2_5966
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd233693zd2_5965));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd233706zd2_5967;
																																																																																		obj_t
																																																																																			BgL_cdrzd233707zd2_5968;
																																																																																		BgL_carzd233706zd2_5967
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5966));
																																																																																		BgL_cdrzd233707zd2_5968
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd233700zd2_5966));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233706zd2_5967))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd233714zd2_5970;
																																																																																				BgL_carzd233714zd2_5970
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd233707zd2_5968));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd233714zd2_5970))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd233707zd2_5968))))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd233686zd2_5964))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg4927z00_5975;
																																																																																										BgL_arg4927z00_5975
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd233693zd2_5965));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_22685;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_22689;
																																																																																												obj_t
																																																																																													BgL_proc2z00_22688;
																																																																																												obj_t
																																																																																													BgL_proc1z00_22687;
																																																																																												obj_t
																																																																																													BgL_testz00_22686;
																																																																																												BgL_testz00_22686
																																																																																													=
																																																																																													BgL_arg4927z00_5975;
																																																																																												BgL_proc1z00_22687
																																																																																													=
																																																																																													BgL_carzd233706zd2_5967;
																																																																																												BgL_proc2z00_22688
																																																																																													=
																																																																																													BgL_carzd233714zd2_5970;
																																																																																												BgL_argsz00_22689
																																																																																													=
																																																																																													BgL_cdrzd233686zd2_5964;
																																																																																												BgL_argsz00_1784
																																																																																													=
																																																																																													BgL_argsz00_22689;
																																																																																												BgL_proc2z00_1783
																																																																																													=
																																																																																													BgL_proc2z00_22688;
																																																																																												BgL_proc1z00_1782
																																																																																													=
																																																																																													BgL_proc1z00_22687;
																																																																																												BgL_testz00_1781
																																																																																													=
																																																																																													BgL_testz00_22686;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1785;
																																																																																											}
																																																																																											BgL_auxz00_22135
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_22685);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_22693;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_22135
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_22693);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22697;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_22135
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22697);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22701;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22701);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22705;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22705);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_22709;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22709);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd234047zd2_5983;
																																																																											BgL_cdrzd234047zd2_5983
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd234053zd2_5984;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12009;
																																																																													BgL_pairz00_12009
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd234053zd2_5984
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12009);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd234059zd2_5985;
																																																																													BgL_cdrzd234059zd2_5985
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd234053zd2_5984));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd234064zd2_5986;
																																																																														obj_t
																																																																															BgL_cdrzd234065zd2_5987;
																																																																														BgL_carzd234064zd2_5986
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_5985));
																																																																														BgL_cdrzd234065zd2_5987
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd234059zd2_5985));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234064zd2_5986))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (PAIRP(BgL_cdrzd234065zd2_5987))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd234070zd2_5990;
																																																																																		BgL_carzd234070zd2_5990
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_cdrzd234065zd2_5987);
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd234070zd2_5990))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(BgL_cdrzd234065zd2_5987)))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd234047zd2_5983))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg4941z00_5995;
																																																																																								BgL_arg4941z00_5995
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd234053zd2_5984));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_22736;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_22740;
																																																																																										obj_t
																																																																																											BgL_proc2z00_22739;
																																																																																										obj_t
																																																																																											BgL_proc1z00_22738;
																																																																																										obj_t
																																																																																											BgL_testz00_22737;
																																																																																										BgL_testz00_22737
																																																																																											=
																																																																																											BgL_arg4941z00_5995;
																																																																																										BgL_proc1z00_22738
																																																																																											=
																																																																																											BgL_carzd234064zd2_5986;
																																																																																										BgL_proc2z00_22739
																																																																																											=
																																																																																											BgL_carzd234070zd2_5990;
																																																																																										BgL_argsz00_22740
																																																																																											=
																																																																																											BgL_cdrzd234047zd2_5983;
																																																																																										BgL_argsz00_1784
																																																																																											=
																																																																																											BgL_argsz00_22740;
																																																																																										BgL_proc2z00_1783
																																																																																											=
																																																																																											BgL_proc2z00_22739;
																																																																																										BgL_proc1z00_1782
																																																																																											=
																																																																																											BgL_proc1z00_22738;
																																																																																										BgL_testz00_1781
																																																																																											=
																																																																																											BgL_testz00_22737;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1785;
																																																																																									}
																																																																																									BgL_auxz00_22135
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_22736);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_22744;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_22135
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_22744);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_22748;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_22748);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_22752;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_22752);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_22756;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_22756);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_22760;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_22760);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22764;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22764);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22768;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22768);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_22772;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_22772);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd234608zd2_6159;
																																															BgL_cdrzd234608zd2_6159
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd231543zd2_5882 == CNST_TABLE_REF(((long) 17))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5057z00_6161;
																																																	obj_t
																																																		BgL_arg5058z00_6162;
																																																	BgL_arg5057z00_6161
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6159));
																																																	BgL_arg5058z00_6162
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd234608zd2_6159));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_22783;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_22785;
																																																			obj_t
																																																				BgL_bindingsz00_22784;
																																																			BgL_bindingsz00_22784
																																																				=
																																																				BgL_arg5057z00_6161;
																																																			BgL_exprz00_22785
																																																				=
																																																				BgL_arg5058z00_6162;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_22785;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_22784;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_22135
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_22783);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd231543zd2_5882)))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5060z00_6164;
																																																			obj_t
																																																				BgL_arg5061z00_6165;
																																																			BgL_arg5060z00_6164
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6159));
																																																			BgL_arg5061z00_6165
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd234608zd2_6159));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_22794;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_22796;
																																																					obj_t
																																																						BgL_bindingsz00_22795;
																																																					BgL_bindingsz00_22795
																																																						=
																																																						BgL_arg5060z00_6164;
																																																					BgL_exprz00_22796
																																																						=
																																																						BgL_arg5061z00_6165;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_22796;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_22795;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_22135
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_22794);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((BgL_carzd231543zd2_5882 == CNST_TABLE_REF(((long) 18))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5063z00_6167;
																																																					obj_t
																																																						BgL_arg5064z00_6168;
																																																					BgL_arg5063z00_6167
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6159));
																																																					BgL_arg5064z00_6168
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd234608zd2_6159));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_22805;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_22807;
																																																							obj_t
																																																								BgL_bindingsz00_22806;
																																																							BgL_bindingsz00_22806
																																																								=
																																																								BgL_arg5063z00_6167;
																																																							BgL_exprz00_22807
																																																								=
																																																								BgL_arg5064z00_6168;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_22807;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_22806;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_22135
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_22805);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22814;
																																																							goto
																																																								BgL_tagzd2383zd2_1766;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22814);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd234645zd2_6171;
																																																							BgL_carzd234645zd2_6171
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((BgL_carzd234645zd2_6171 == CNST_TABLE_REF(((long) 19))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_22821;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_22821);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234645zd2_6171)))
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_22826;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_22826);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_22833;
																																																													goto
																																																														BgL_tagzd2389zd2_1786;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_22833);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_22840;
																																																															goto
																																																																BgL_tagzd2390zd2_1787;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_22840);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd234725zd2_6178;
																																																															BgL_cdrzd234725zd2_6178
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg5075z00_6181;
																																																																	obj_t
																																																																		BgL_arg5076z00_6182;
																																																																	BgL_arg5075z00_6181
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6178));
																																																																	BgL_arg5076z00_6182
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd234725zd2_6178));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_22853;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_22855;
																																																																			obj_t
																																																																				BgL_effectz00_22854;
																																																																			BgL_effectz00_22854
																																																																				=
																																																																				BgL_arg5075z00_6181;
																																																																			BgL_restz00_22855
																																																																				=
																																																																				BgL_arg5076z00_6182;
																																																																			BgL_restz00_1789
																																																																				=
																																																																				BgL_restz00_22855;
																																																																			BgL_effectz00_1788
																																																																				=
																																																																				BgL_effectz00_22854;
																																																																			goto
																																																																				BgL_tagzd2391zd2_1790;
																																																																		}
																																																																		BgL_auxz00_22135
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_22853);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_22862;
																																																																			goto
																																																																				BgL_tagzd2392zd2_1791;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_22862);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_22869;
																																																																					goto
																																																																						BgL_tagzd2393zd2_1792;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_22869);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg5083z00_6190;
																																																																							obj_t
																																																																								BgL_arg5084z00_6191;
																																																																							BgL_arg5083z00_6190
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6178));
																																																																							BgL_arg5084z00_6191
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd234725zd2_6178));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_22880;
																																																																								{
																																																																									obj_t
																																																																										BgL_restz00_22882;
																																																																									obj_t
																																																																										BgL_effectz00_22881;
																																																																									BgL_effectz00_22881
																																																																										=
																																																																										BgL_arg5083z00_6190;
																																																																									BgL_restz00_22882
																																																																										=
																																																																										BgL_arg5084z00_6191;
																																																																									BgL_restz00_1794
																																																																										=
																																																																										BgL_restz00_22882;
																																																																									BgL_effectz00_1793
																																																																										=
																																																																										BgL_effectz00_22881;
																																																																									goto
																																																																										BgL_tagzd2394zd2_1795;
																																																																								}
																																																																								BgL_auxz00_22135
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_22880);
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_22889;
																																																																									goto
																																																																										BgL_tagzd2395zd2_1796;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_22889);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_22896;
																																																																											goto
																																																																												BgL_tagzd2396zd2_1797;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_22896);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																												{
																																																																													BgL_letzd2funzd2_bglt
																																																																														BgL_auxz00_22903;
																																																																													goto
																																																																														BgL_tagzd2397zd2_1798;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_22903);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																														{
																																																																															BgL_jumpzd2exzd2itz00_bglt
																																																																																BgL_auxz00_22910;
																																																																															goto
																																																																																BgL_tagzd2398zd2_1799;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_22910);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd234802zd2_6200;
																																																																															BgL_cdrzd234802zd2_6200
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5095z00_6203;
																																																																																	obj_t
																																																																																		BgL_arg5096z00_6204;
																																																																																	BgL_arg5095z00_6203
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6200));
																																																																																	BgL_arg5096z00_6204
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd234802zd2_6200));
																																																																																	{	/* Ast/sexp.scm 555 */
																																																																																		obj_t
																																																																																			BgL_arg7015z00_12048;
																																																																																		BgL_arg7015z00_12048
																																																																																			=
																																																																																			BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																			(BgL_expz00_21,
																																																																																			BgL_locz00_23);
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																			(BgL_expz00_21,
																																																																																				BgL_arg5095z00_6203,
																																																																																				CNST_TABLE_REF
																																																																																				(((long) 4)), BgL_arg5096z00_6204, BgL_stackz00_22, BgL_arg7015z00_12048, BgL_sitez00_24));
																																																																																}}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_22929;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_22929);
																																																																																		}
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd234827zd2_6221;
																																			BgL_carzd234827zd2_6221
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (
																																				(BgL_carzd234827zd2_6221
																																					==
																																					CNST_TABLE_REF
																																					(((long) 1))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_22936;
																																					goto
																																						BgL_tagzd2377zd2_1754;
																																					BgL_auxz00_22135
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_22936);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd234827zd2_6221
																																							==
																																							BGl_za2ifza2z00zzast_sexpz00))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_22940;
																																							goto
																																								BgL_tagzd2377zd2_1754;
																																							BgL_auxz00_22135
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_22940);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_22947;
																																									goto
																																										BgL_tagzd2379zd2_1758;
																																									BgL_auxz00_22135
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_22947);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_22954;
																																											goto
																																												BgL_tagzd2380zd2_1759;
																																											BgL_auxz00_22135
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_22954);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd234896zd2_6228;
																																											BgL_carzd234896zd2_6228
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if (PAIRP(BgL_carzd234896zd2_6228))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd234899zd2_6230;
																																													obj_t
																																														BgL_cdrzd234900zd2_6231;
																																													BgL_carzd234899zd2_6230
																																														=
																																														CAR
																																														(BgL_carzd234896zd2_6228);
																																													BgL_cdrzd234900zd2_6231
																																														=
																																														CDR
																																														(BgL_carzd234896zd2_6228);
																																													{

																																														if ((BgL_carzd234899zd2_6230 == CNST_TABLE_REF(((long) 17))))
																																															{	/* Ast/sexp.scm 119 */
																																															BgL_kapzd234901zd2_6232:
																																																if (PAIRP(BgL_cdrzd234900zd2_6231))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd234904zd2_6357;
																																																		BgL_cdrzd234904zd2_6357
																																																			=
																																																			CDR
																																																			(BgL_cdrzd234900zd2_6231);
																																																		if (PAIRP(BgL_cdrzd234904zd2_6357))
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (NULLP(CDR(BgL_cdrzd234904zd2_6357)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5203z00_6361;
																																																						obj_t
																																																							BgL_arg5204z00_6362;
																																																						BgL_arg5203z00_6361
																																																							=
																																																							CAR
																																																							(BgL_cdrzd234904zd2_6357);
																																																						BgL_arg5204z00_6362
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_22976;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_22978;
																																																								obj_t
																																																									BgL_bodyz00_22977;
																																																								BgL_bodyz00_22977
																																																									=
																																																									BgL_arg5203z00_6361;
																																																								BgL_argsz00_22978
																																																									=
																																																									BgL_arg5204z00_6362;
																																																								BgL_argsz00_1761
																																																									=
																																																									BgL_argsz00_22978;
																																																								BgL_bodyz00_1760
																																																									=
																																																									BgL_bodyz00_22977;
																																																								goto
																																																									BgL_tagzd2381zd2_1762;
																																																							}
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_22976);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd234928zd2_6363;
																																																						BgL_cdrzd234928zd2_6363
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9537z00_22982;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5273z00_6474;
																																																								BgL_arg5273z00_6474
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9537z00_22982
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5273z00_6474));
																																																							}
																																																							if (BgL_test9537z00_22982)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg5207z00_6366;
																																																									obj_t
																																																										BgL_arg5208z00_6367;
																																																									BgL_arg5207z00_6366
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6363));
																																																									BgL_arg5208z00_6367
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd234928zd2_6363));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_22991;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_22993;
																																																											obj_t
																																																												BgL_bindingsz00_22992;
																																																											BgL_bindingsz00_22992
																																																												=
																																																												BgL_arg5207z00_6366;
																																																											BgL_exprz00_22993
																																																												=
																																																												BgL_arg5208z00_6367;
																																																											BgL_exprz00_1764
																																																												=
																																																												BgL_exprz00_22993;
																																																											BgL_bindingsz00_1763
																																																												=
																																																												BgL_bindingsz00_22992;
																																																											goto
																																																												BgL_tagzd2382zd2_1765;
																																																										}
																																																										BgL_auxz00_22135
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_22991);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9538z00_22995;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5272z00_6473;
																																																										BgL_arg5272z00_6473
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9538z00_22995
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5272z00_6473));
																																																									}
																																																									if (BgL_test9538z00_22995)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_23000;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23000);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd234995zd2_6370;
																																																											BgL_carzd234995zd2_6370
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd235000zd2_6371;
																																																												BgL_cdrzd235000zd2_6371
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd234995zd2_6370));
																																																												if ((CAR(((obj_t) BgL_carzd234995zd2_6370)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg5213z00_6374;
																																																														obj_t
																																																															BgL_arg5214z00_6375;
																																																														obj_t
																																																															BgL_arg5215z00_6376;
																																																														BgL_arg5213z00_6374
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6371));
																																																														BgL_arg5214z00_6375
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd235000zd2_6371));
																																																														BgL_arg5215z00_6376
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_23017;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_23020;
																																																																obj_t
																																																																	BgL_bodyz00_23019;
																																																																obj_t
																																																																	BgL_varsz00_23018;
																																																																BgL_varsz00_23018
																																																																	=
																																																																	BgL_arg5213z00_6374;
																																																																BgL_bodyz00_23019
																																																																	=
																																																																	BgL_arg5214z00_6375;
																																																																BgL_argsz00_23020
																																																																	=
																																																																	BgL_arg5215z00_6376;
																																																																BgL_argsz00_1774
																																																																	=
																																																																	BgL_argsz00_23020;
																																																																BgL_bodyz00_1773
																																																																	=
																																																																	BgL_bodyz00_23019;
																																																																BgL_varsz00_1772
																																																																	=
																																																																	BgL_varsz00_23018;
																																																																goto
																																																																	BgL_tagzd2386zd2_1775;
																																																															}
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_23017);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd235023zd2_6378;
																																																														BgL_cdrzd235023zd2_6378
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd235029zd2_6379;
																																																															BgL_cdrzd235029zd2_6379
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd234995zd2_6370));
																																																															if ((CAR(((obj_t) BgL_carzd234995zd2_6370)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd235035zd2_6382;
																																																																	BgL_cdrzd235035zd2_6382
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd235029zd2_6379));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd235040zd2_6383;
																																																																		obj_t
																																																																			BgL_cdrzd235041zd2_6384;
																																																																		BgL_carzd235040zd2_6383
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6382));
																																																																		BgL_cdrzd235041zd2_6384
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd235035zd2_6382));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235040zd2_6383))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (PAIRP(BgL_cdrzd235041zd2_6384))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd235048zd2_6387;
																																																																						BgL_carzd235048zd2_6387
																																																																							=
																																																																							CAR
																																																																							(BgL_cdrzd235041zd2_6384);
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235048zd2_6387))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(BgL_cdrzd235041zd2_6384)))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test9545z00_23047;
																																																																										{
																																																																											obj_t
																																																																												BgL_l1425z00_6420;
																																																																											BgL_l1425z00_6420
																																																																												=
																																																																												BgL_cdrzd235023zd2_6378;
																																																																										BgL_zc3z04anonymousza35238ze3z87_6421:
																																																																											if (NULLP(BgL_l1425z00_6420))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test9545z00_23047
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														1);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test9547z00_23050;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test9548z00_23051;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_tmpz00_23052;
																																																																															BgL_tmpz00_23052
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_l1425z00_6420));
																																																																															BgL_test9548z00_23051
																																																																																=
																																																																																PAIRP
																																																																																(BgL_tmpz00_23052);
																																																																														}
																																																																														if (BgL_test9548z00_23051)
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9547z00_23050
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9547z00_23050
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																													}
																																																																													if (BgL_test9547z00_23050)
																																																																														{
																																																																															obj_t
																																																																																BgL_l1425z00_23056;
																																																																															BgL_l1425z00_23056
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_l1425z00_6420));
																																																																															BgL_l1425z00_6420
																																																																																=
																																																																																BgL_l1425z00_23056;
																																																																															goto
																																																																																BgL_zc3z04anonymousza35238ze3z87_6421;
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9545z00_23047
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																												}
																																																																										}
																																																																										if (BgL_test9545z00_23047)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg5228z00_6403;
																																																																												BgL_arg5228z00_6403
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd235029zd2_6379));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23061;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_23065;
																																																																														obj_t
																																																																															BgL_proc2z00_23064;
																																																																														obj_t
																																																																															BgL_proc1z00_23063;
																																																																														obj_t
																																																																															BgL_testz00_23062;
																																																																														BgL_testz00_23062
																																																																															=
																																																																															BgL_arg5228z00_6403;
																																																																														BgL_proc1z00_23063
																																																																															=
																																																																															BgL_carzd235040zd2_6383;
																																																																														BgL_proc2z00_23064
																																																																															=
																																																																															BgL_carzd235048zd2_6387;
																																																																														BgL_argsz00_23065
																																																																															=
																																																																															BgL_cdrzd235023zd2_6378;
																																																																														BgL_argsz00_1779
																																																																															=
																																																																															BgL_argsz00_23065;
																																																																														BgL_proc2z00_1778
																																																																															=
																																																																															BgL_proc2z00_23064;
																																																																														BgL_proc1z00_1777
																																																																															=
																																																																															BgL_proc1z00_23063;
																																																																														BgL_testz00_1776
																																																																															=
																																																																															BgL_testz00_23062;
																																																																														goto
																																																																															BgL_tagzd2387zd2_1780;
																																																																													}
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23061);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd235072zd2_6404;
																																																																												BgL_cdrzd235072zd2_6404
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd235079zd2_6405;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12092;
																																																																														BgL_pairz00_12092
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_cdrzd235079zd2_6405
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_12092);
																																																																													}
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd235086zd2_6406;
																																																																														BgL_cdrzd235086zd2_6406
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd235079zd2_6405));
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd235092zd2_6407;
																																																																															BgL_carzd235092zd2_6407
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd235086zd2_6406));
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235092zd2_6407))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_carzd235099zd2_6409;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_pairz00_12096;
																																																																																		BgL_pairz00_12096
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd235086zd2_6406));
																																																																																		BgL_carzd235099zd2_6409
																																																																																			=
																																																																																			CAR
																																																																																			(BgL_pairz00_12096);
																																																																																	}
																																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235099zd2_6409))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235072zd2_6404))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_arg5232z00_6412;
																																																																																					BgL_arg5232z00_6412
																																																																																						=
																																																																																						CAR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd235079zd2_6405));
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23087;
																																																																																						{
																																																																																							obj_t
																																																																																								BgL_argsz00_23091;
																																																																																							obj_t
																																																																																								BgL_proc2z00_23090;
																																																																																							obj_t
																																																																																								BgL_proc1z00_23089;
																																																																																							obj_t
																																																																																								BgL_testz00_23088;
																																																																																							BgL_testz00_23088
																																																																																								=
																																																																																								BgL_arg5232z00_6412;
																																																																																							BgL_proc1z00_23089
																																																																																								=
																																																																																								BgL_carzd235092zd2_6407;
																																																																																							BgL_proc2z00_23090
																																																																																								=
																																																																																								BgL_carzd235099zd2_6409;
																																																																																							BgL_argsz00_23091
																																																																																								=
																																																																																								BgL_cdrzd235072zd2_6404;
																																																																																							BgL_argsz00_1784
																																																																																								=
																																																																																								BgL_argsz00_23091;
																																																																																							BgL_proc2z00_1783
																																																																																								=
																																																																																								BgL_proc2z00_23090;
																																																																																							BgL_proc1z00_1782
																																																																																								=
																																																																																								BgL_proc1z00_23089;
																																																																																							BgL_testz00_1781
																																																																																								=
																																																																																								BgL_testz00_23088;
																																																																																							goto
																																																																																								BgL_tagzd2388zd2_1785;
																																																																																						}
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23087);
																																																																																					}
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							goto
																																																																																								BgL_tagzd2403zd2_1809;
																																																																																						}
																																																																																					else
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_23095;
																																																																																							goto
																																																																																								BgL_tagzd2404zd2_1810;
																																																																																							BgL_auxz00_22135
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_23095);
																																																																																						}
																																																																																				}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23099;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23099);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23103;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23103);
																																																																																		}
																																																																																}
																																																																														}
																																																																													}
																																																																												}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_23107;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_22135
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_23107);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd235375zd2_6431;
																																																																								BgL_cdrzd235375zd2_6431
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd235381zd2_6432;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12100;
																																																																										BgL_pairz00_12100
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd235381zd2_6432
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12100);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd235387zd2_6433;
																																																																										BgL_cdrzd235387zd2_6433
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd235381zd2_6432));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd235392zd2_6434;
																																																																											obj_t
																																																																												BgL_cdrzd235393zd2_6435;
																																																																											BgL_carzd235392zd2_6434
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6433));
																																																																											BgL_cdrzd235393zd2_6435
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd235387zd2_6433));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235392zd2_6434))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd235398zd2_6437;
																																																																													BgL_carzd235398zd2_6437
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd235393zd2_6435));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235398zd2_6437))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (NULLP(CDR(((obj_t) BgL_cdrzd235393zd2_6435))))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235375zd2_6431))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg5247z00_6442;
																																																																																			BgL_arg5247z00_6442
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd235381zd2_6432));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23134;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_23138;
																																																																																					obj_t
																																																																																						BgL_proc2z00_23137;
																																																																																					obj_t
																																																																																						BgL_proc1z00_23136;
																																																																																					obj_t
																																																																																						BgL_testz00_23135;
																																																																																					BgL_testz00_23135
																																																																																						=
																																																																																						BgL_arg5247z00_6442;
																																																																																					BgL_proc1z00_23136
																																																																																						=
																																																																																						BgL_carzd235392zd2_6434;
																																																																																					BgL_proc2z00_23137
																																																																																						=
																																																																																						BgL_carzd235398zd2_6437;
																																																																																					BgL_argsz00_23138
																																																																																						=
																																																																																						BgL_cdrzd235375zd2_6431;
																																																																																					BgL_argsz00_1784
																																																																																						=
																																																																																						BgL_argsz00_23138;
																																																																																					BgL_proc2z00_1783
																																																																																						=
																																																																																						BgL_proc2z00_23137;
																																																																																					BgL_proc1z00_1782
																																																																																						=
																																																																																						BgL_proc1z00_23136;
																																																																																					BgL_testz00_1781
																																																																																						=
																																																																																						BgL_testz00_23135;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1785;
																																																																																				}
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23134);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23142;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23142);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23146;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23146);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23150;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23150);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23154;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23154);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_23158;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_22135
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_23158);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd235731zd2_6450;
																																																																				BgL_cdrzd235731zd2_6450
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd235738zd2_6451;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12110;
																																																																						BgL_pairz00_12110
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd235738zd2_6451
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12110);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd235745zd2_6452;
																																																																						BgL_cdrzd235745zd2_6452
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd235738zd2_6451));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd235751zd2_6453;
																																																																							obj_t
																																																																								BgL_cdrzd235752zd2_6454;
																																																																							BgL_carzd235751zd2_6453
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6452));
																																																																							BgL_cdrzd235752zd2_6454
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd235745zd2_6452));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235751zd2_6453))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd235752zd2_6454))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd235759zd2_6457;
																																																																											BgL_carzd235759zd2_6457
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd235752zd2_6454);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd235759zd2_6457))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd235752zd2_6454)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd235731zd2_6450))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5261z00_6462;
																																																																																	BgL_arg5261z00_6462
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd235738zd2_6451));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23185;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23189;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23188;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23187;
																																																																																			obj_t
																																																																																				BgL_testz00_23186;
																																																																																			BgL_testz00_23186
																																																																																				=
																																																																																				BgL_arg5261z00_6462;
																																																																																			BgL_proc1z00_23187
																																																																																				=
																																																																																				BgL_carzd235751zd2_6453;
																																																																																			BgL_proc2z00_23188
																																																																																				=
																																																																																				BgL_carzd235759zd2_6457;
																																																																																			BgL_argsz00_23189
																																																																																				=
																																																																																				BgL_cdrzd235731zd2_6450;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_23189;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_23188;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_23187;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_23186;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23185);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23193;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23193);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23197;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23197);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23201;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23201);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23205;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23205);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23209;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23209);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23213;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23213);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd236152zd2_6476;
																																																				BgL_cdrzd236152zd2_6476
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9576z00_23217;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5289z00_6493;
																																																						BgL_arg5289z00_6493
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9576z00_23217
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5289z00_6493));
																																																					}
																																																					if (BgL_test9576z00_23217)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5277z00_6479;
																																																							obj_t
																																																								BgL_arg5278z00_6480;
																																																							BgL_arg5277z00_6479
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6476));
																																																							BgL_arg5278z00_6480
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd236152zd2_6476));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23226;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23228;
																																																									obj_t
																																																										BgL_bindingsz00_23227;
																																																									BgL_bindingsz00_23227
																																																										=
																																																										BgL_arg5277z00_6479;
																																																									BgL_exprz00_23228
																																																										=
																																																										BgL_arg5278z00_6480;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_23228;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_23227;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_22135
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23226);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9577z00_23230;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5288z00_6492;
																																																								BgL_arg5288z00_6492
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9577z00_23230
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5288z00_6492));
																																																							}
																																																							if (BgL_test9577z00_23230)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23235;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23235);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd236218zd2_6483;
																																																									BgL_carzd236218zd2_6483
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd236223zd2_6484;
																																																										BgL_cdrzd236223zd2_6484
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd236218zd2_6483));
																																																										if ((CAR(((obj_t) BgL_carzd236218zd2_6483)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5283z00_6487;
																																																												obj_t
																																																													BgL_arg5284z00_6488;
																																																												obj_t
																																																													BgL_arg5285z00_6489;
																																																												BgL_arg5283z00_6487
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6484));
																																																												BgL_arg5284z00_6488
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd236223zd2_6484));
																																																												BgL_arg5285z00_6489
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23252;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23255;
																																																														obj_t
																																																															BgL_bodyz00_23254;
																																																														obj_t
																																																															BgL_varsz00_23253;
																																																														BgL_varsz00_23253
																																																															=
																																																															BgL_arg5283z00_6487;
																																																														BgL_bodyz00_23254
																																																															=
																																																															BgL_arg5284z00_6488;
																																																														BgL_argsz00_23255
																																																															=
																																																															BgL_arg5285z00_6489;
																																																														BgL_argsz00_1774
																																																															=
																																																															BgL_argsz00_23255;
																																																														BgL_bodyz00_1773
																																																															=
																																																															BgL_bodyz00_23254;
																																																														BgL_varsz00_1772
																																																															=
																																																															BgL_varsz00_23253;
																																																														goto
																																																															BgL_tagzd2386zd2_1775;
																																																													}
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23252);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_23259;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_22135
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_23259);
																																																													}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd236334zd2_6494;
																																																		BgL_cdrzd236334zd2_6494
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9580z00_23263;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5298z00_6503;
																																																				BgL_arg5298z00_6503
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9580z00_23263
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5298z00_6503));
																																																			}
																																																			if (BgL_test9580z00_23263)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5292z00_6497;
																																																					obj_t
																																																						BgL_arg5293z00_6498;
																																																					BgL_arg5292z00_6497
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6494));
																																																					BgL_arg5293z00_6498
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd236334zd2_6494));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23272;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_23274;
																																																							obj_t
																																																								BgL_bindingsz00_23273;
																																																							BgL_bindingsz00_23273
																																																								=
																																																								BgL_arg5292z00_6497;
																																																							BgL_exprz00_23274
																																																								=
																																																								BgL_arg5293z00_6498;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_23274;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_23273;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_22135
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23272);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9581z00_23276;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5297z00_6502;
																																																						BgL_arg5297z00_6502
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9581z00_23276
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5297z00_6502));
																																																					}
																																																					if (BgL_test9581z00_23276)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23281;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23281);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2403zd2_1809;
																																																								}
																																																							else
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_23285;
																																																									goto
																																																										BgL_tagzd2404zd2_1810;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23285);
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234899zd2_6230)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd234901zd2_6232;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd234899zd2_6230 == CNST_TABLE_REF(((long) 18))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd234901zd2_6232;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if ((BgL_carzd234899zd2_6230 == CNST_TABLE_REF(((long) 19))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd234901zd2_6232;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd234899zd2_6230)))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_kapzd234901zd2_6232;
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd236506zd2_6238;
																																																								BgL_cdrzd236506zd2_6238
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9587z00_23301;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5198z00_6355;
																																																										BgL_arg5198z00_6355
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9587z00_23301
																																																											=
																																																											CBOOL
																																																											(BGl_letzd2symzf3z21zzast_letz00
																																																											(BgL_arg5198z00_6355));
																																																									}
																																																									if (BgL_test9587z00_23301)
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg5126z00_6241;
																																																											obj_t
																																																												BgL_arg5127z00_6242;
																																																											BgL_arg5126z00_6241
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6238));
																																																											BgL_arg5127z00_6242
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd236506zd2_6238));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_23310;
																																																												{
																																																													obj_t
																																																														BgL_exprz00_23312;
																																																													obj_t
																																																														BgL_bindingsz00_23311;
																																																													BgL_bindingsz00_23311
																																																														=
																																																														BgL_arg5126z00_6241;
																																																													BgL_exprz00_23312
																																																														=
																																																														BgL_arg5127z00_6242;
																																																													BgL_exprz00_1764
																																																														=
																																																														BgL_exprz00_23312;
																																																													BgL_bindingsz00_1763
																																																														=
																																																														BgL_bindingsz00_23311;
																																																													goto
																																																														BgL_tagzd2382zd2_1765;
																																																												}
																																																												BgL_auxz00_22135
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_23310);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											bool_t
																																																												BgL_test9588z00_23314;
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5197z00_6354;
																																																												BgL_arg5197z00_6354
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												BgL_test9588z00_23314
																																																													=
																																																													CBOOL
																																																													(BGl_labelszd2symzf3z21zzast_labelsz00
																																																													(BgL_arg5197z00_6354));
																																																											}
																																																											if (BgL_test9588z00_23314)
																																																												{
																																																													BgL_letzd2funzd2_bglt
																																																														BgL_auxz00_23319;
																																																													goto
																																																														BgL_tagzd2384zd2_1767;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23319);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd236572zd2_6245;
																																																													BgL_carzd236572zd2_6245
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd236577zd2_6246;
																																																														BgL_cdrzd236577zd2_6246
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd236572zd2_6245));
																																																														if ((CAR(((obj_t) BgL_carzd236572zd2_6245)) == CNST_TABLE_REF(((long) 3))))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd236577zd2_6246))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg5133z00_6250;
																																																																		obj_t
																																																																			BgL_arg5134z00_6251;
																																																																		obj_t
																																																																			BgL_arg5135z00_6252;
																																																																		BgL_arg5133z00_6250
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd236577zd2_6246);
																																																																		BgL_arg5134z00_6251
																																																																			=
																																																																			CDR
																																																																			(BgL_cdrzd236577zd2_6246);
																																																																		BgL_arg5135z00_6252
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23336;
																																																																			{
																																																																				obj_t
																																																																					BgL_argsz00_23339;
																																																																				obj_t
																																																																					BgL_bodyz00_23338;
																																																																				obj_t
																																																																					BgL_varsz00_23337;
																																																																				BgL_varsz00_23337
																																																																					=
																																																																					BgL_arg5133z00_6250;
																																																																				BgL_bodyz00_23338
																																																																					=
																																																																					BgL_arg5134z00_6251;
																																																																				BgL_argsz00_23339
																																																																					=
																																																																					BgL_arg5135z00_6252;
																																																																				BgL_argsz00_1774
																																																																					=
																																																																					BgL_argsz00_23339;
																																																																				BgL_bodyz00_1773
																																																																					=
																																																																					BgL_bodyz00_23338;
																																																																				BgL_varsz00_1772
																																																																					=
																																																																					BgL_varsz00_23337;
																																																																				goto
																																																																					BgL_tagzd2386zd2_1775;
																																																																			}
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23336);
																																																																		}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_23343;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_23343);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd236684zd2_6255;
																																																																BgL_cdrzd236684zd2_6255
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd236689zd2_6256;
																																																																	BgL_cdrzd236689zd2_6256
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_carzd236572zd2_6245));
																																																																	if ((CAR(((obj_t) BgL_carzd236572zd2_6245)) == CNST_TABLE_REF(((long) 1))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd236689zd2_6256))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd236694zd2_6260;
																																																																					BgL_cdrzd236694zd2_6260
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd236689zd2_6256);
																																																																					if (PAIRP(BgL_cdrzd236694zd2_6260))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd236698zd2_6262;
																																																																							obj_t
																																																																								BgL_cdrzd236699zd2_6263;
																																																																							BgL_carzd236698zd2_6262
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd236694zd2_6260);
																																																																							BgL_cdrzd236699zd2_6263
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd236694zd2_6260);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236698zd2_6262))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (PAIRP(BgL_cdrzd236699zd2_6263))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd236704zd2_6266;
																																																																											BgL_carzd236704zd2_6266
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd236699zd2_6263);
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236704zd2_6266))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(BgL_cdrzd236699zd2_6263)))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test9599z00_23371;
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1428z00_6299;
																																																																																BgL_l1428z00_6299
																																																																																	=
																																																																																	BgL_cdrzd236684zd2_6255;
																																																																															BgL_zc3z04anonymousza35161ze3z87_6300:
																																																																																if (NULLP(BgL_l1428z00_6299))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9599z00_23371
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			1);
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		bool_t
																																																																																			BgL_test9601z00_23374;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			bool_t
																																																																																				BgL_test9602z00_23375;
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_tmpz00_23376;
																																																																																				BgL_tmpz00_23376
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_l1428z00_6299));
																																																																																				BgL_test9602z00_23375
																																																																																					=
																																																																																					PAIRP
																																																																																					(BgL_tmpz00_23376);
																																																																																			}
																																																																																			if (BgL_test9602z00_23375)
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test9601z00_23374
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						0);
																																																																																				}
																																																																																			else
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					BgL_test9601z00_23374
																																																																																						=
																																																																																						(
																																																																																						(bool_t)
																																																																																						1);
																																																																																				}
																																																																																		}
																																																																																		if (BgL_test9601z00_23374)
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_l1428z00_23380;
																																																																																				BgL_l1428z00_23380
																																																																																					=
																																																																																					CDR
																																																																																					(
																																																																																					((obj_t) BgL_l1428z00_6299));
																																																																																				BgL_l1428z00_6299
																																																																																					=
																																																																																					BgL_l1428z00_23380;
																																																																																				goto
																																																																																					BgL_zc3z04anonymousza35161ze3z87_6300;
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				BgL_test9599z00_23371
																																																																																					=
																																																																																					(
																																																																																					(bool_t)
																																																																																					0);
																																																																																			}
																																																																																	}
																																																																															}
																																																																															if (BgL_test9599z00_23371)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5151z00_6282;
																																																																																	BgL_arg5151z00_6282
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_cdrzd236689zd2_6256);
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23384;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23388;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23387;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23386;
																																																																																			obj_t
																																																																																				BgL_testz00_23385;
																																																																																			BgL_testz00_23385
																																																																																				=
																																																																																				BgL_arg5151z00_6282;
																																																																																			BgL_proc1z00_23386
																																																																																				=
																																																																																				BgL_carzd236698zd2_6262;
																																																																																			BgL_proc2z00_23387
																																																																																				=
																																																																																				BgL_carzd236704zd2_6266;
																																																																																			BgL_argsz00_23388
																																																																																				=
																																																																																				BgL_cdrzd236684zd2_6255;
																																																																																			BgL_argsz00_1779
																																																																																				=
																																																																																				BgL_argsz00_23388;
																																																																																			BgL_proc2z00_1778
																																																																																				=
																																																																																				BgL_proc2z00_23387;
																																																																																			BgL_proc1z00_1777
																																																																																				=
																																																																																				BgL_proc1z00_23386;
																																																																																			BgL_testz00_1776
																																																																																				=
																																																																																				BgL_testz00_23385;
																																																																																			goto
																																																																																				BgL_tagzd2387zd2_1780;
																																																																																		}
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23384);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd236729zd2_6283;
																																																																																	BgL_cdrzd236729zd2_6283
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_cdrzd236737zd2_6284;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12167;
																																																																																			BgL_pairz00_12167
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_expz00_21));
																																																																																			BgL_cdrzd236737zd2_6284
																																																																																				=
																																																																																				CDR
																																																																																				(BgL_pairz00_12167);
																																																																																		}
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_cdrzd236745zd2_6285;
																																																																																			BgL_cdrzd236745zd2_6285
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd236737zd2_6284));
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd236752zd2_6286;
																																																																																				BgL_carzd236752zd2_6286
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd236745zd2_6285));
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236752zd2_6286))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_carzd236761zd2_6288;
																																																																																						{	/* Ast/sexp.scm 119 */
																																																																																							obj_t
																																																																																								BgL_pairz00_12171;
																																																																																							BgL_pairz00_12171
																																																																																								=
																																																																																								CDR
																																																																																								(
																																																																																								((obj_t) BgL_cdrzd236745zd2_6285));
																																																																																							BgL_carzd236761zd2_6288
																																																																																								=
																																																																																								CAR
																																																																																								(BgL_pairz00_12171);
																																																																																						}
																																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd236761zd2_6288))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd236729zd2_6283))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										obj_t
																																																																																											BgL_arg5155z00_6291;
																																																																																										BgL_arg5155z00_6291
																																																																																											=
																																																																																											CAR
																																																																																											(
																																																																																											((obj_t) BgL_cdrzd236737zd2_6284));
																																																																																										{
																																																																																											BgL_nodez00_bglt
																																																																																												BgL_auxz00_23410;
																																																																																											{
																																																																																												obj_t
																																																																																													BgL_argsz00_23414;
																																																																																												obj_t
																																																																																													BgL_proc2z00_23413;
																																																																																												obj_t
																																																																																													BgL_proc1z00_23412;
																																																																																												obj_t
																																																																																													BgL_testz00_23411;
																																																																																												BgL_testz00_23411
																																																																																													=
																																																																																													BgL_arg5155z00_6291;
																																																																																												BgL_proc1z00_23412
																																																																																													=
																																																																																													BgL_carzd236752zd2_6286;
																																																																																												BgL_proc2z00_23413
																																																																																													=
																																																																																													BgL_carzd236761zd2_6288;
																																																																																												BgL_argsz00_23414
																																																																																													=
																																																																																													BgL_cdrzd236729zd2_6283;
																																																																																												BgL_argsz00_1784
																																																																																													=
																																																																																													BgL_argsz00_23414;
																																																																																												BgL_proc2z00_1783
																																																																																													=
																																																																																													BgL_proc2z00_23413;
																																																																																												BgL_proc1z00_1782
																																																																																													=
																																																																																													BgL_proc1z00_23412;
																																																																																												BgL_testz00_1781
																																																																																													=
																																																																																													BgL_testz00_23411;
																																																																																												goto
																																																																																													BgL_tagzd2388zd2_1785;
																																																																																											}
																																																																																											BgL_auxz00_22135
																																																																																												=
																																																																																												(
																																																																																												(obj_t)
																																																																																												BgL_auxz00_23410);
																																																																																										}
																																																																																									}
																																																																																								else
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																											{	/* Ast/sexp.scm 119 */
																																																																																												goto
																																																																																													BgL_tagzd2403zd2_1809;
																																																																																											}
																																																																																										else
																																																																																											{
																																																																																												BgL_nodez00_bglt
																																																																																													BgL_auxz00_23418;
																																																																																												goto
																																																																																													BgL_tagzd2404zd2_1810;
																																																																																												BgL_auxz00_22135
																																																																																													=
																																																																																													(
																																																																																													(obj_t)
																																																																																													BgL_auxz00_23418);
																																																																																											}
																																																																																									}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23422;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_22135
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23422);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23426;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23426);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		}
																																																																																	}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23430;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23430);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd237039zd2_6310;
																																																																													BgL_cdrzd237039zd2_6310
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd237046zd2_6311;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_12175;
																																																																															BgL_pairz00_12175
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd237046zd2_6311
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12175);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd237053zd2_6312;
																																																																															BgL_cdrzd237053zd2_6312
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd237046zd2_6311));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd237059zd2_6313;
																																																																																obj_t
																																																																																	BgL_cdrzd237060zd2_6314;
																																																																																BgL_carzd237059zd2_6313
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6312));
																																																																																BgL_cdrzd237060zd2_6314
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd237053zd2_6312));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237059zd2_6313))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd237067zd2_6316;
																																																																																		BgL_carzd237067zd2_6316
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd237060zd2_6314));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237067zd2_6316))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd237060zd2_6314))))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237039zd2_6310))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg5170z00_6321;
																																																																																								BgL_arg5170z00_6321
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd237046zd2_6311));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_23457;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_23461;
																																																																																										obj_t
																																																																																											BgL_proc2z00_23460;
																																																																																										obj_t
																																																																																											BgL_proc1z00_23459;
																																																																																										obj_t
																																																																																											BgL_testz00_23458;
																																																																																										BgL_testz00_23458
																																																																																											=
																																																																																											BgL_arg5170z00_6321;
																																																																																										BgL_proc1z00_23459
																																																																																											=
																																																																																											BgL_carzd237059zd2_6313;
																																																																																										BgL_proc2z00_23460
																																																																																											=
																																																																																											BgL_carzd237067zd2_6316;
																																																																																										BgL_argsz00_23461
																																																																																											=
																																																																																											BgL_cdrzd237039zd2_6310;
																																																																																										BgL_argsz00_1784
																																																																																											=
																																																																																											BgL_argsz00_23461;
																																																																																										BgL_proc2z00_1783
																																																																																											=
																																																																																											BgL_proc2z00_23460;
																																																																																										BgL_proc1z00_1782
																																																																																											=
																																																																																											BgL_proc1z00_23459;
																																																																																										BgL_testz00_1781
																																																																																											=
																																																																																											BgL_testz00_23458;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1785;
																																																																																									}
																																																																																									BgL_auxz00_22135
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_23457);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_23465;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_22135
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_23465);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23469;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23469);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23473;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23473);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23477;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23477);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23481;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23481);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd237400zd2_6329;
																																																																									BgL_cdrzd237400zd2_6329
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd237406zd2_6330;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12185;
																																																																											BgL_pairz00_12185
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd237406zd2_6330
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12185);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd237412zd2_6331;
																																																																											BgL_cdrzd237412zd2_6331
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd237406zd2_6330));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd237417zd2_6332;
																																																																												obj_t
																																																																													BgL_cdrzd237418zd2_6333;
																																																																												BgL_carzd237417zd2_6332
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6331));
																																																																												BgL_cdrzd237418zd2_6333
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd237412zd2_6331));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237417zd2_6332))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd237418zd2_6333))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd237423zd2_6336;
																																																																																BgL_carzd237423zd2_6336
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd237418zd2_6333);
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd237423zd2_6336))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(BgL_cdrzd237418zd2_6333)))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd237400zd2_6329))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5184z00_6341;
																																																																																						BgL_arg5184z00_6341
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd237406zd2_6330));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_23508;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_23512;
																																																																																								obj_t
																																																																																									BgL_proc2z00_23511;
																																																																																								obj_t
																																																																																									BgL_proc1z00_23510;
																																																																																								obj_t
																																																																																									BgL_testz00_23509;
																																																																																								BgL_testz00_23509
																																																																																									=
																																																																																									BgL_arg5184z00_6341;
																																																																																								BgL_proc1z00_23510
																																																																																									=
																																																																																									BgL_carzd237417zd2_6332;
																																																																																								BgL_proc2z00_23511
																																																																																									=
																																																																																									BgL_carzd237423zd2_6336;
																																																																																								BgL_argsz00_23512
																																																																																									=
																																																																																									BgL_cdrzd237400zd2_6329;
																																																																																								BgL_argsz00_1784
																																																																																									=
																																																																																									BgL_argsz00_23512;
																																																																																								BgL_proc2z00_1783
																																																																																									=
																																																																																									BgL_proc2z00_23511;
																																																																																								BgL_proc1z00_1782
																																																																																									=
																																																																																									BgL_proc1z00_23510;
																																																																																								BgL_testz00_1781
																																																																																									=
																																																																																									BgL_testz00_23509;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1785;
																																																																																							}
																																																																																							BgL_auxz00_22135
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_23508);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_23516;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_23516);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_23520;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_23520);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23524;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23524);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23528;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23528);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23532;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23532);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23536;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23536);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23540;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23540);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_23544;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_23544);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																													}
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd237961zd2_6505;
																																													BgL_cdrzd237961zd2_6505
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd234896zd2_6228 == CNST_TABLE_REF(((long) 17))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5300z00_6507;
																																															obj_t
																																																BgL_arg5301z00_6508;
																																															BgL_arg5300z00_6507
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6505));
																																															BgL_arg5301z00_6508
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd237961zd2_6505));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_23555;
																																																{
																																																	obj_t
																																																		BgL_exprz00_23557;
																																																	obj_t
																																																		BgL_bindingsz00_23556;
																																																	BgL_bindingsz00_23556
																																																		=
																																																		BgL_arg5300z00_6507;
																																																	BgL_exprz00_23557
																																																		=
																																																		BgL_arg5301z00_6508;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_23557;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_23556;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_22135
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_23555);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd234896zd2_6228)))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5303z00_6510;
																																																	obj_t
																																																		BgL_arg5304z00_6511;
																																																	BgL_arg5303z00_6510
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6505));
																																																	BgL_arg5304z00_6511
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd237961zd2_6505));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_23566;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_23568;
																																																			obj_t
																																																				BgL_bindingsz00_23567;
																																																			BgL_bindingsz00_23567
																																																				=
																																																				BgL_arg5303z00_6510;
																																																			BgL_exprz00_23568
																																																				=
																																																				BgL_arg5304z00_6511;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_23568;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_23567;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_22135
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_23566);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((BgL_carzd234896zd2_6228 == CNST_TABLE_REF(((long) 18))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5306z00_6513;
																																																			obj_t
																																																				BgL_arg5307z00_6514;
																																																			BgL_arg5306z00_6513
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6505));
																																																			BgL_arg5307z00_6514
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd237961zd2_6505));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_23577;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_23579;
																																																					obj_t
																																																						BgL_bindingsz00_23578;
																																																					BgL_bindingsz00_23578
																																																						=
																																																						BgL_arg5306z00_6513;
																																																					BgL_exprz00_23579
																																																						=
																																																						BgL_arg5307z00_6514;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_23579;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_23578;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_22135
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_23577);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23586;
																																																					goto
																																																						BgL_tagzd2383zd2_1766;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23586);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd237998zd2_6517;
																																																					BgL_carzd237998zd2_6517
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((BgL_carzd237998zd2_6517 == CNST_TABLE_REF(((long) 19))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_23593;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_23593);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd237998zd2_6517)))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23598;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23598);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_23605;
																																																											goto
																																																												BgL_tagzd2389zd2_1786;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_23605);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23612;
																																																													goto
																																																														BgL_tagzd2390zd2_1787;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23612);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd238078zd2_6524;
																																																													BgL_cdrzd238078zd2_6524
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg5318z00_6527;
																																																															obj_t
																																																																BgL_arg5319z00_6528;
																																																															BgL_arg5318z00_6527
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6524));
																																																															BgL_arg5319z00_6528
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238078zd2_6524));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_23625;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_23627;
																																																																	obj_t
																																																																		BgL_effectz00_23626;
																																																																	BgL_effectz00_23626
																																																																		=
																																																																		BgL_arg5318z00_6527;
																																																																	BgL_restz00_23627
																																																																		=
																																																																		BgL_arg5319z00_6528;
																																																																	BgL_restz00_1789
																																																																		=
																																																																		BgL_restz00_23627;
																																																																	BgL_effectz00_1788
																																																																		=
																																																																		BgL_effectz00_23626;
																																																																	goto
																																																																		BgL_tagzd2391zd2_1790;
																																																																}
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_23625);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23634;
																																																																	goto
																																																																		BgL_tagzd2392zd2_1791;
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23634);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_23641;
																																																																			goto
																																																																				BgL_tagzd2393zd2_1792;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_23641);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg5326z00_6536;
																																																																					obj_t
																																																																						BgL_arg5327z00_6537;
																																																																					BgL_arg5326z00_6536
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6524));
																																																																					BgL_arg5327z00_6537
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd238078zd2_6524));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23652;
																																																																						{
																																																																							obj_t
																																																																								BgL_restz00_23654;
																																																																							obj_t
																																																																								BgL_effectz00_23653;
																																																																							BgL_effectz00_23653
																																																																								=
																																																																								BgL_arg5326z00_6536;
																																																																							BgL_restz00_23654
																																																																								=
																																																																								BgL_arg5327z00_6537;
																																																																							BgL_restz00_1794
																																																																								=
																																																																								BgL_restz00_23654;
																																																																							BgL_effectz00_1793
																																																																								=
																																																																								BgL_effectz00_23653;
																																																																							goto
																																																																								BgL_tagzd2394zd2_1795;
																																																																						}
																																																																						BgL_auxz00_22135
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23652);
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_23661;
																																																																							goto
																																																																								BgL_tagzd2395zd2_1796;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_23661);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23668;
																																																																									goto
																																																																										BgL_tagzd2396zd2_1797;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23668);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																										{
																																																																											BgL_letzd2funzd2_bglt
																																																																												BgL_auxz00_23675;
																																																																											goto
																																																																												BgL_tagzd2397zd2_1798;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23675);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																												{
																																																																													BgL_jumpzd2exzd2itz00_bglt
																																																																														BgL_auxz00_23682;
																																																																													goto
																																																																														BgL_tagzd2398zd2_1799;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23682);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd238155zd2_6546;
																																																																													BgL_cdrzd238155zd2_6546
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5338z00_6549;
																																																																															obj_t
																																																																																BgL_arg5339z00_6550;
																																																																															BgL_arg5338z00_6549
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6546));
																																																																															BgL_arg5339z00_6550
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd238155zd2_6546));
																																																																															{	/* Ast/sexp.scm 555 */
																																																																																obj_t
																																																																																	BgL_arg7015z00_12224;
																																																																																BgL_arg7015z00_12224
																																																																																	=
																																																																																	BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																	(BgL_expz00_21,
																																																																																	BgL_locz00_23);
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																	(BgL_expz00_21,
																																																																																		BgL_arg5338z00_6549,
																																																																																		CNST_TABLE_REF
																																																																																		(((long) 4)), BgL_arg5339z00_6550, BgL_stackz00_22, BgL_arg7015z00_12224, BgL_sitez00_24));
																																																																														}}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23701;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23701);
																																																																																}
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd238180zd2_6567;
																																	BgL_carzd238180zd2_6567
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (
																																		(BgL_carzd238180zd2_6567
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					1))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_23708;
																																			goto
																																				BgL_tagzd2377zd2_1754;
																																			BgL_auxz00_22135
																																				=
																																				((obj_t)
																																				BgL_auxz00_23708);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd238180zd2_6567
																																					==
																																					BGl_za2ifza2z00zzast_sexpz00))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_23712;
																																					goto
																																						BgL_tagzd2377zd2_1754;
																																					BgL_auxz00_22135
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_23712);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 7))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_23719;
																																							goto
																																								BgL_tagzd2379zd2_1758;
																																							BgL_auxz00_22135
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_23719);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_23726;
																																									goto
																																										BgL_tagzd2380zd2_1759;
																																									BgL_auxz00_22135
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_23726);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd238249zd2_6574;
																																									BgL_carzd238249zd2_6574
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									if (PAIRP(BgL_carzd238249zd2_6574))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_carzd238252zd2_6576;
																																											obj_t
																																												BgL_cdrzd238253zd2_6577;
																																											BgL_carzd238252zd2_6576
																																												=
																																												CAR
																																												(BgL_carzd238249zd2_6574);
																																											BgL_cdrzd238253zd2_6577
																																												=
																																												CDR
																																												(BgL_carzd238249zd2_6574);
																																											{

																																												if ((BgL_carzd238252zd2_6576 == CNST_TABLE_REF(((long) 17))))
																																													{	/* Ast/sexp.scm 119 */
																																													BgL_kapzd238254zd2_6578:
																																														if (PAIRP(BgL_cdrzd238253zd2_6577))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd238257zd2_6703;
																																																BgL_cdrzd238257zd2_6703
																																																	=
																																																	CDR
																																																	(BgL_cdrzd238253zd2_6577);
																																																if (PAIRP(BgL_cdrzd238257zd2_6703))
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (NULLP(CDR(BgL_cdrzd238257zd2_6703)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5447z00_6707;
																																																				obj_t
																																																					BgL_arg5448z00_6708;
																																																				BgL_arg5447z00_6707
																																																					=
																																																					CAR
																																																					(BgL_cdrzd238257zd2_6703);
																																																				BgL_arg5448z00_6708
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_23748;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_23750;
																																																						obj_t
																																																							BgL_bodyz00_23749;
																																																						BgL_bodyz00_23749
																																																							=
																																																							BgL_arg5447z00_6707;
																																																						BgL_argsz00_23750
																																																							=
																																																							BgL_arg5448z00_6708;
																																																						BgL_argsz00_1761
																																																							=
																																																							BgL_argsz00_23750;
																																																						BgL_bodyz00_1760
																																																							=
																																																							BgL_bodyz00_23749;
																																																						goto
																																																							BgL_tagzd2381zd2_1762;
																																																					}
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_23748);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd238281zd2_6709;
																																																				BgL_cdrzd238281zd2_6709
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9659z00_23754;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5518z00_6820;
																																																						BgL_arg5518z00_6820
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9659z00_23754
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5518z00_6820));
																																																					}
																																																					if (BgL_test9659z00_23754)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5451z00_6712;
																																																							obj_t
																																																								BgL_arg5452z00_6713;
																																																							BgL_arg5451z00_6712
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6709));
																																																							BgL_arg5452z00_6713
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd238281zd2_6709));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_23763;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_23765;
																																																									obj_t
																																																										BgL_bindingsz00_23764;
																																																									BgL_bindingsz00_23764
																																																										=
																																																										BgL_arg5451z00_6712;
																																																									BgL_exprz00_23765
																																																										=
																																																										BgL_arg5452z00_6713;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_23765;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_23764;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_22135
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_23763);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9660z00_23767;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5517z00_6819;
																																																								BgL_arg5517z00_6819
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9660z00_23767
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5517z00_6819));
																																																							}
																																																							if (BgL_test9660z00_23767)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_23772;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_23772);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd238348zd2_6716;
																																																									BgL_carzd238348zd2_6716
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd238353zd2_6717;
																																																										BgL_cdrzd238353zd2_6717
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd238348zd2_6716));
																																																										if ((CAR(((obj_t) BgL_carzd238348zd2_6716)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5457z00_6720;
																																																												obj_t
																																																													BgL_arg5458z00_6721;
																																																												obj_t
																																																													BgL_arg5459z00_6722;
																																																												BgL_arg5457z00_6720
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6717));
																																																												BgL_arg5458z00_6721
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd238353zd2_6717));
																																																												BgL_arg5459z00_6722
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_23789;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_23792;
																																																														obj_t
																																																															BgL_bodyz00_23791;
																																																														obj_t
																																																															BgL_varsz00_23790;
																																																														BgL_varsz00_23790
																																																															=
																																																															BgL_arg5457z00_6720;
																																																														BgL_bodyz00_23791
																																																															=
																																																															BgL_arg5458z00_6721;
																																																														BgL_argsz00_23792
																																																															=
																																																															BgL_arg5459z00_6722;
																																																														BgL_argsz00_1774
																																																															=
																																																															BgL_argsz00_23792;
																																																														BgL_bodyz00_1773
																																																															=
																																																															BgL_bodyz00_23791;
																																																														BgL_varsz00_1772
																																																															=
																																																															BgL_varsz00_23790;
																																																														goto
																																																															BgL_tagzd2386zd2_1775;
																																																													}
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_23789);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd238376zd2_6724;
																																																												BgL_cdrzd238376zd2_6724
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd238382zd2_6725;
																																																													BgL_cdrzd238382zd2_6725
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd238348zd2_6716));
																																																													if ((CAR(((obj_t) BgL_carzd238348zd2_6716)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd238388zd2_6728;
																																																															BgL_cdrzd238388zd2_6728
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd238382zd2_6725));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd238393zd2_6729;
																																																																obj_t
																																																																	BgL_cdrzd238394zd2_6730;
																																																																BgL_carzd238393zd2_6729
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6728));
																																																																BgL_cdrzd238394zd2_6730
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd238388zd2_6728));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238393zd2_6729))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd238394zd2_6730))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd238401zd2_6733;
																																																																				BgL_carzd238401zd2_6733
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd238394zd2_6730);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238401zd2_6733))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd238394zd2_6730)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9667z00_23819;
																																																																								{
																																																																									obj_t
																																																																										BgL_l1431z00_6766;
																																																																									BgL_l1431z00_6766
																																																																										=
																																																																										BgL_cdrzd238376zd2_6724;
																																																																								BgL_zc3z04anonymousza35482ze3z87_6767:
																																																																									if (NULLP(BgL_l1431z00_6766))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9667z00_23819
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												1);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9669z00_23822;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9670z00_23823;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_tmpz00_23824;
																																																																													BgL_tmpz00_23824
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_l1431z00_6766));
																																																																													BgL_test9670z00_23823
																																																																														=
																																																																														PAIRP
																																																																														(BgL_tmpz00_23824);
																																																																												}
																																																																												if (BgL_test9670z00_23823)
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9669z00_23822
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9669z00_23822
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																											}
																																																																											if (BgL_test9669z00_23822)
																																																																												{
																																																																													obj_t
																																																																														BgL_l1431z00_23828;
																																																																													BgL_l1431z00_23828
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_l1431z00_6766));
																																																																													BgL_l1431z00_6766
																																																																														=
																																																																														BgL_l1431z00_23828;
																																																																													goto
																																																																														BgL_zc3z04anonymousza35482ze3z87_6767;
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													BgL_test9667z00_23819
																																																																														=
																																																																														(
																																																																														(bool_t)
																																																																														0);
																																																																												}
																																																																										}
																																																																								}
																																																																								if (BgL_test9667z00_23819)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg5472z00_6749;
																																																																										BgL_arg5472z00_6749
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd238382zd2_6725));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23833;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_23837;
																																																																												obj_t
																																																																													BgL_proc2z00_23836;
																																																																												obj_t
																																																																													BgL_proc1z00_23835;
																																																																												obj_t
																																																																													BgL_testz00_23834;
																																																																												BgL_testz00_23834
																																																																													=
																																																																													BgL_arg5472z00_6749;
																																																																												BgL_proc1z00_23835
																																																																													=
																																																																													BgL_carzd238393zd2_6729;
																																																																												BgL_proc2z00_23836
																																																																													=
																																																																													BgL_carzd238401zd2_6733;
																																																																												BgL_argsz00_23837
																																																																													=
																																																																													BgL_cdrzd238376zd2_6724;
																																																																												BgL_argsz00_1779
																																																																													=
																																																																													BgL_argsz00_23837;
																																																																												BgL_proc2z00_1778
																																																																													=
																																																																													BgL_proc2z00_23836;
																																																																												BgL_proc1z00_1777
																																																																													=
																																																																													BgL_proc1z00_23835;
																																																																												BgL_testz00_1776
																																																																													=
																																																																													BgL_testz00_23834;
																																																																												goto
																																																																													BgL_tagzd2387zd2_1780;
																																																																											}
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23833);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd238425zd2_6750;
																																																																										BgL_cdrzd238425zd2_6750
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd238432zd2_6751;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_12268;
																																																																												BgL_pairz00_12268
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_cdrzd238432zd2_6751
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12268);
																																																																											}
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd238439zd2_6752;
																																																																												BgL_cdrzd238439zd2_6752
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd238432zd2_6751));
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd238445zd2_6753;
																																																																													BgL_carzd238445zd2_6753
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd238439zd2_6752));
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238445zd2_6753))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_carzd238452zd2_6755;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_pairz00_12272;
																																																																																BgL_pairz00_12272
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd238439zd2_6752));
																																																																																BgL_carzd238452zd2_6755
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_pairz00_12272);
																																																																															}
																																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238452zd2_6755))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238425zd2_6750))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_arg5476z00_6758;
																																																																																			BgL_arg5476z00_6758
																																																																																				=
																																																																																				CAR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd238432zd2_6751));
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_23859;
																																																																																				{
																																																																																					obj_t
																																																																																						BgL_argsz00_23863;
																																																																																					obj_t
																																																																																						BgL_proc2z00_23862;
																																																																																					obj_t
																																																																																						BgL_proc1z00_23861;
																																																																																					obj_t
																																																																																						BgL_testz00_23860;
																																																																																					BgL_testz00_23860
																																																																																						=
																																																																																						BgL_arg5476z00_6758;
																																																																																					BgL_proc1z00_23861
																																																																																						=
																																																																																						BgL_carzd238445zd2_6753;
																																																																																					BgL_proc2z00_23862
																																																																																						=
																																																																																						BgL_carzd238452zd2_6755;
																																																																																					BgL_argsz00_23863
																																																																																						=
																																																																																						BgL_cdrzd238425zd2_6750;
																																																																																					BgL_argsz00_1784
																																																																																						=
																																																																																						BgL_argsz00_23863;
																																																																																					BgL_proc2z00_1783
																																																																																						=
																																																																																						BgL_proc2z00_23862;
																																																																																					BgL_proc1z00_1782
																																																																																						=
																																																																																						BgL_proc1z00_23861;
																																																																																					BgL_testz00_1781
																																																																																						=
																																																																																						BgL_testz00_23860;
																																																																																					goto
																																																																																						BgL_tagzd2388zd2_1785;
																																																																																				}
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_23859);
																																																																																			}
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					goto
																																																																																						BgL_tagzd2403zd2_1809;
																																																																																				}
																																																																																			else
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_23867;
																																																																																					goto
																																																																																						BgL_tagzd2404zd2_1810;
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_23867);
																																																																																				}
																																																																																		}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23871;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23871);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23875;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23875);
																																																																																}
																																																																														}
																																																																												}
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_23879;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_22135
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_23879);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd238728zd2_6777;
																																																																						BgL_cdrzd238728zd2_6777
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd238734zd2_6778;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_12276;
																																																																								BgL_pairz00_12276
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd238734zd2_6778
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12276);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd238740zd2_6779;
																																																																								BgL_cdrzd238740zd2_6779
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd238734zd2_6778));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd238745zd2_6780;
																																																																									obj_t
																																																																										BgL_cdrzd238746zd2_6781;
																																																																									BgL_carzd238745zd2_6780
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6779));
																																																																									BgL_cdrzd238746zd2_6781
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd238740zd2_6779));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238745zd2_6780))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd238751zd2_6783;
																																																																											BgL_carzd238751zd2_6783
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd238746zd2_6781));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd238751zd2_6783))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (NULLP(CDR(((obj_t) BgL_cdrzd238746zd2_6781))))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd238728zd2_6777))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5491z00_6788;
																																																																																	BgL_arg5491z00_6788
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd238734zd2_6778));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_23906;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_23910;
																																																																																			obj_t
																																																																																				BgL_proc2z00_23909;
																																																																																			obj_t
																																																																																				BgL_proc1z00_23908;
																																																																																			obj_t
																																																																																				BgL_testz00_23907;
																																																																																			BgL_testz00_23907
																																																																																				=
																																																																																				BgL_arg5491z00_6788;
																																																																																			BgL_proc1z00_23908
																																																																																				=
																																																																																				BgL_carzd238745zd2_6780;
																																																																																			BgL_proc2z00_23909
																																																																																				=
																																																																																				BgL_carzd238751zd2_6783;
																																																																																			BgL_argsz00_23910
																																																																																				=
																																																																																				BgL_cdrzd238728zd2_6777;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_23910;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_23909;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_23908;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_23907;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_23906);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_23914;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_23914);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23918;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23918);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23922;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23922);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23926;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23926);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_23930;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_22135
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_23930);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd239084zd2_6796;
																																																																		BgL_cdrzd239084zd2_6796
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd239091zd2_6797;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_12286;
																																																																				BgL_pairz00_12286
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd239091zd2_6797
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12286);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd239098zd2_6798;
																																																																				BgL_cdrzd239098zd2_6798
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd239091zd2_6797));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd239104zd2_6799;
																																																																					obj_t
																																																																						BgL_cdrzd239105zd2_6800;
																																																																					BgL_carzd239104zd2_6799
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6798));
																																																																					BgL_cdrzd239105zd2_6800
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd239098zd2_6798));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239104zd2_6799))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd239105zd2_6800))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd239112zd2_6803;
																																																																									BgL_carzd239112zd2_6803
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd239105zd2_6800);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd239112zd2_6803))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd239105zd2_6800)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd239084zd2_6796))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5506z00_6808;
																																																																															BgL_arg5506z00_6808
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd239091zd2_6797));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_23957;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_23961;
																																																																																	obj_t
																																																																																		BgL_proc2z00_23960;
																																																																																	obj_t
																																																																																		BgL_proc1z00_23959;
																																																																																	obj_t
																																																																																		BgL_testz00_23958;
																																																																																	BgL_testz00_23958
																																																																																		=
																																																																																		BgL_arg5506z00_6808;
																																																																																	BgL_proc1z00_23959
																																																																																		=
																																																																																		BgL_carzd239104zd2_6799;
																																																																																	BgL_proc2z00_23960
																																																																																		=
																																																																																		BgL_carzd239112zd2_6803;
																																																																																	BgL_argsz00_23961
																																																																																		=
																																																																																		BgL_cdrzd239084zd2_6796;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_23961;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_23960;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_23959;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_23958;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_23957);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_23965;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_23965);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_23969;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_23969);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_23973;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_23973);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_23977;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_23977);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_23981;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_23981);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_23985;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_23985);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd239505zd2_6822;
																																																		BgL_cdrzd239505zd2_6822
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9698z00_23989;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5534z00_6839;
																																																				BgL_arg5534z00_6839
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9698z00_23989
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5534z00_6839));
																																																			}
																																																			if (BgL_test9698z00_23989)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5522z00_6825;
																																																					obj_t
																																																						BgL_arg5523z00_6826;
																																																					BgL_arg5522z00_6825
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6822));
																																																					BgL_arg5523z00_6826
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd239505zd2_6822));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_23998;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_24000;
																																																							obj_t
																																																								BgL_bindingsz00_23999;
																																																							BgL_bindingsz00_23999
																																																								=
																																																								BgL_arg5522z00_6825;
																																																							BgL_exprz00_24000
																																																								=
																																																								BgL_arg5523z00_6826;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_24000;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_23999;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_22135
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_23998);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9699z00_24002;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5533z00_6838;
																																																						BgL_arg5533z00_6838
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9699z00_24002
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5533z00_6838));
																																																					}
																																																					if (BgL_test9699z00_24002)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24007;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24007);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd239571zd2_6829;
																																																							BgL_carzd239571zd2_6829
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd239576zd2_6830;
																																																								BgL_cdrzd239576zd2_6830
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd239571zd2_6829));
																																																								if ((CAR(((obj_t) BgL_carzd239571zd2_6829)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5528z00_6833;
																																																										obj_t
																																																											BgL_arg5529z00_6834;
																																																										obj_t
																																																											BgL_arg5530z00_6835;
																																																										BgL_arg5528z00_6833
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6830));
																																																										BgL_arg5529z00_6834
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd239576zd2_6830));
																																																										BgL_arg5530z00_6835
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24024;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_24027;
																																																												obj_t
																																																													BgL_bodyz00_24026;
																																																												obj_t
																																																													BgL_varsz00_24025;
																																																												BgL_varsz00_24025
																																																													=
																																																													BgL_arg5528z00_6833;
																																																												BgL_bodyz00_24026
																																																													=
																																																													BgL_arg5529z00_6834;
																																																												BgL_argsz00_24027
																																																													=
																																																													BgL_arg5530z00_6835;
																																																												BgL_argsz00_1774
																																																													=
																																																													BgL_argsz00_24027;
																																																												BgL_bodyz00_1773
																																																													=
																																																													BgL_bodyz00_24026;
																																																												BgL_varsz00_1772
																																																													=
																																																													BgL_varsz00_24025;
																																																												goto
																																																													BgL_tagzd2386zd2_1775;
																																																											}
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24024);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1809;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_24031;
																																																												goto
																																																													BgL_tagzd2404zd2_1810;
																																																												BgL_auxz00_22135
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_24031);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd239687zd2_6840;
																																																BgL_cdrzd239687zd2_6840
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9702z00_24035;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5543z00_6849;
																																																		BgL_arg5543z00_6849
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9702z00_24035
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5543z00_6849));
																																																	}
																																																	if (BgL_test9702z00_24035)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5537z00_6843;
																																																			obj_t
																																																				BgL_arg5538z00_6844;
																																																			BgL_arg5537z00_6843
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6840));
																																																			BgL_arg5538z00_6844
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd239687zd2_6840));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_24044;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_24046;
																																																					obj_t
																																																						BgL_bindingsz00_24045;
																																																					BgL_bindingsz00_24045
																																																						=
																																																						BgL_arg5537z00_6843;
																																																					BgL_exprz00_24046
																																																						=
																																																						BgL_arg5538z00_6844;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_24046;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_24045;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_22135
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_24044);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9703z00_24048;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5542z00_6848;
																																																				BgL_arg5542z00_6848
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9703z00_24048
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5542z00_6848));
																																																			}
																																																			if (BgL_test9703z00_24048)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24053;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24053);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1809;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_24057;
																																																							goto
																																																								BgL_tagzd2404zd2_1810;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24057);
																																																						}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238252zd2_6576)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd238254zd2_6578;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd238252zd2_6576 == CNST_TABLE_REF(((long) 18))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd238254zd2_6578;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if ((BgL_carzd238252zd2_6576 == CNST_TABLE_REF(((long) 19))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd238254zd2_6578;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd238252zd2_6576)))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_kapzd238254zd2_6578;
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd239859zd2_6584;
																																																						BgL_cdrzd239859zd2_6584
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9709z00_24073;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5442z00_6701;
																																																								BgL_arg5442z00_6701
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9709z00_24073
																																																									=
																																																									CBOOL
																																																									(BGl_letzd2symzf3z21zzast_letz00
																																																									(BgL_arg5442z00_6701));
																																																							}
																																																							if (BgL_test9709z00_24073)
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg5370z00_6587;
																																																									obj_t
																																																										BgL_arg5371z00_6588;
																																																									BgL_arg5370z00_6587
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6584));
																																																									BgL_arg5371z00_6588
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd239859zd2_6584));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_24082;
																																																										{
																																																											obj_t
																																																												BgL_exprz00_24084;
																																																											obj_t
																																																												BgL_bindingsz00_24083;
																																																											BgL_bindingsz00_24083
																																																												=
																																																												BgL_arg5370z00_6587;
																																																											BgL_exprz00_24084
																																																												=
																																																												BgL_arg5371z00_6588;
																																																											BgL_exprz00_1764
																																																												=
																																																												BgL_exprz00_24084;
																																																											BgL_bindingsz00_1763
																																																												=
																																																												BgL_bindingsz00_24083;
																																																											goto
																																																												BgL_tagzd2382zd2_1765;
																																																										}
																																																										BgL_auxz00_22135
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_24082);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									bool_t
																																																										BgL_test9710z00_24086;
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5441z00_6700;
																																																										BgL_arg5441z00_6700
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										BgL_test9710z00_24086
																																																											=
																																																											CBOOL
																																																											(BGl_labelszd2symzf3z21zzast_labelsz00
																																																											(BgL_arg5441z00_6700));
																																																									}
																																																									if (BgL_test9710z00_24086)
																																																										{
																																																											BgL_letzd2funzd2_bglt
																																																												BgL_auxz00_24091;
																																																											goto
																																																												BgL_tagzd2384zd2_1767;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24091);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd239925zd2_6591;
																																																											BgL_carzd239925zd2_6591
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd239930zd2_6592;
																																																												BgL_cdrzd239930zd2_6592
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd239925zd2_6591));
																																																												if ((CAR(((obj_t) BgL_carzd239925zd2_6591)) == CNST_TABLE_REF(((long) 3))))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd239930zd2_6592))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg5377z00_6596;
																																																																obj_t
																																																																	BgL_arg5378z00_6597;
																																																																obj_t
																																																																	BgL_arg5379z00_6598;
																																																																BgL_arg5377z00_6596
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd239930zd2_6592);
																																																																BgL_arg5378z00_6597
																																																																	=
																																																																	CDR
																																																																	(BgL_cdrzd239930zd2_6592);
																																																																BgL_arg5379z00_6598
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24108;
																																																																	{
																																																																		obj_t
																																																																			BgL_argsz00_24111;
																																																																		obj_t
																																																																			BgL_bodyz00_24110;
																																																																		obj_t
																																																																			BgL_varsz00_24109;
																																																																		BgL_varsz00_24109
																																																																			=
																																																																			BgL_arg5377z00_6596;
																																																																		BgL_bodyz00_24110
																																																																			=
																																																																			BgL_arg5378z00_6597;
																																																																		BgL_argsz00_24111
																																																																			=
																																																																			BgL_arg5379z00_6598;
																																																																		BgL_argsz00_1774
																																																																			=
																																																																			BgL_argsz00_24111;
																																																																		BgL_bodyz00_1773
																																																																			=
																																																																			BgL_bodyz00_24110;
																																																																		BgL_varsz00_1772
																																																																			=
																																																																			BgL_varsz00_24109;
																																																																		goto
																																																																			BgL_tagzd2386zd2_1775;
																																																																	}
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24108);
																																																																}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_24115;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_22135
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_24115);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd240037zd2_6601;
																																																														BgL_cdrzd240037zd2_6601
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd240042zd2_6602;
																																																															BgL_cdrzd240042zd2_6602
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd239925zd2_6591));
																																																															if ((CAR(((obj_t) BgL_carzd239925zd2_6591)) == CNST_TABLE_REF(((long) 1))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd240042zd2_6602))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd240047zd2_6606;
																																																																			BgL_cdrzd240047zd2_6606
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd240042zd2_6602);
																																																																			if (PAIRP(BgL_cdrzd240047zd2_6606))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd240051zd2_6608;
																																																																					obj_t
																																																																						BgL_cdrzd240052zd2_6609;
																																																																					BgL_carzd240051zd2_6608
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd240047zd2_6606);
																																																																					BgL_cdrzd240052zd2_6609
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd240047zd2_6606);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240051zd2_6608))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (PAIRP(BgL_cdrzd240052zd2_6609))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd240057zd2_6612;
																																																																									BgL_carzd240057zd2_6612
																																																																										=
																																																																										CAR
																																																																										(BgL_cdrzd240052zd2_6609);
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240057zd2_6612))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(BgL_cdrzd240052zd2_6609)))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test9721z00_24143;
																																																																													{
																																																																														obj_t
																																																																															BgL_l1434z00_6645;
																																																																														BgL_l1434z00_6645
																																																																															=
																																																																															BgL_cdrzd240037zd2_6601;
																																																																													BgL_zc3z04anonymousza35405ze3z87_6646:
																																																																														if (NULLP(BgL_l1434z00_6645))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9721z00_24143
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	1);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																bool_t
																																																																																	BgL_test9723z00_24146;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	bool_t
																																																																																		BgL_test9724z00_24147;
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_tmpz00_24148;
																																																																																		BgL_tmpz00_24148
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_l1434z00_6645));
																																																																																		BgL_test9724z00_24147
																																																																																			=
																																																																																			PAIRP
																																																																																			(BgL_tmpz00_24148);
																																																																																	}
																																																																																	if (BgL_test9724z00_24147)
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test9723z00_24146
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				0);
																																																																																		}
																																																																																	else
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			BgL_test9723z00_24146
																																																																																				=
																																																																																				(
																																																																																				(bool_t)
																																																																																				1);
																																																																																		}
																																																																																}
																																																																																if (BgL_test9723z00_24146)
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_l1434z00_24152;
																																																																																		BgL_l1434z00_24152
																																																																																			=
																																																																																			CDR
																																																																																			(
																																																																																			((obj_t) BgL_l1434z00_6645));
																																																																																		BgL_l1434z00_6645
																																																																																			=
																																																																																			BgL_l1434z00_24152;
																																																																																		goto
																																																																																			BgL_zc3z04anonymousza35405ze3z87_6646;
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		BgL_test9721z00_24143
																																																																																			=
																																																																																			(
																																																																																			(bool_t)
																																																																																			0);
																																																																																	}
																																																																															}
																																																																													}
																																																																													if (BgL_test9721z00_24143)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5395z00_6628;
																																																																															BgL_arg5395z00_6628
																																																																																=
																																																																																CAR
																																																																																(BgL_cdrzd240042zd2_6602);
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24156;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24160;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24159;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24158;
																																																																																	obj_t
																																																																																		BgL_testz00_24157;
																																																																																	BgL_testz00_24157
																																																																																		=
																																																																																		BgL_arg5395z00_6628;
																																																																																	BgL_proc1z00_24158
																																																																																		=
																																																																																		BgL_carzd240051zd2_6608;
																																																																																	BgL_proc2z00_24159
																																																																																		=
																																																																																		BgL_carzd240057zd2_6612;
																																																																																	BgL_argsz00_24160
																																																																																		=
																																																																																		BgL_cdrzd240037zd2_6601;
																																																																																	BgL_argsz00_1779
																																																																																		=
																																																																																		BgL_argsz00_24160;
																																																																																	BgL_proc2z00_1778
																																																																																		=
																																																																																		BgL_proc2z00_24159;
																																																																																	BgL_proc1z00_1777
																																																																																		=
																																																																																		BgL_proc1z00_24158;
																																																																																	BgL_testz00_1776
																																																																																		=
																																																																																		BgL_testz00_24157;
																																																																																	goto
																																																																																		BgL_tagzd2387zd2_1780;
																																																																																}
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24156);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd240082zd2_6629;
																																																																															BgL_cdrzd240082zd2_6629
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_cdrzd240090zd2_6630;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12343;
																																																																																	BgL_pairz00_12343
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_expz00_21));
																																																																																	BgL_cdrzd240090zd2_6630
																																																																																		=
																																																																																		CDR
																																																																																		(BgL_pairz00_12343);
																																																																																}
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_cdrzd240098zd2_6631;
																																																																																	BgL_cdrzd240098zd2_6631
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd240090zd2_6630));
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd240105zd2_6632;
																																																																																		BgL_carzd240105zd2_6632
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd240098zd2_6631));
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240105zd2_6632))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_carzd240114zd2_6634;
																																																																																				{	/* Ast/sexp.scm 119 */
																																																																																					obj_t
																																																																																						BgL_pairz00_12347;
																																																																																					BgL_pairz00_12347
																																																																																						=
																																																																																						CDR
																																																																																						(
																																																																																						((obj_t) BgL_cdrzd240098zd2_6631));
																																																																																					BgL_carzd240114zd2_6634
																																																																																						=
																																																																																						CAR
																																																																																						(BgL_pairz00_12347);
																																																																																				}
																																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240114zd2_6634))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240082zd2_6629))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								obj_t
																																																																																									BgL_arg5399z00_6637;
																																																																																								BgL_arg5399z00_6637
																																																																																									=
																																																																																									CAR
																																																																																									(
																																																																																									((obj_t) BgL_cdrzd240090zd2_6630));
																																																																																								{
																																																																																									BgL_nodez00_bglt
																																																																																										BgL_auxz00_24182;
																																																																																									{
																																																																																										obj_t
																																																																																											BgL_argsz00_24186;
																																																																																										obj_t
																																																																																											BgL_proc2z00_24185;
																																																																																										obj_t
																																																																																											BgL_proc1z00_24184;
																																																																																										obj_t
																																																																																											BgL_testz00_24183;
																																																																																										BgL_testz00_24183
																																																																																											=
																																																																																											BgL_arg5399z00_6637;
																																																																																										BgL_proc1z00_24184
																																																																																											=
																																																																																											BgL_carzd240105zd2_6632;
																																																																																										BgL_proc2z00_24185
																																																																																											=
																																																																																											BgL_carzd240114zd2_6634;
																																																																																										BgL_argsz00_24186
																																																																																											=
																																																																																											BgL_cdrzd240082zd2_6629;
																																																																																										BgL_argsz00_1784
																																																																																											=
																																																																																											BgL_argsz00_24186;
																																																																																										BgL_proc2z00_1783
																																																																																											=
																																																																																											BgL_proc2z00_24185;
																																																																																										BgL_proc1z00_1782
																																																																																											=
																																																																																											BgL_proc1z00_24184;
																																																																																										BgL_testz00_1781
																																																																																											=
																																																																																											BgL_testz00_24183;
																																																																																										goto
																																																																																											BgL_tagzd2388zd2_1785;
																																																																																									}
																																																																																									BgL_auxz00_22135
																																																																																										=
																																																																																										(
																																																																																										(obj_t)
																																																																																										BgL_auxz00_24182);
																																																																																								}
																																																																																							}
																																																																																						else
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																									{	/* Ast/sexp.scm 119 */
																																																																																										goto
																																																																																											BgL_tagzd2403zd2_1809;
																																																																																									}
																																																																																								else
																																																																																									{
																																																																																										BgL_nodez00_bglt
																																																																																											BgL_auxz00_24190;
																																																																																										goto
																																																																																											BgL_tagzd2404zd2_1810;
																																																																																										BgL_auxz00_22135
																																																																																											=
																																																																																											(
																																																																																											(obj_t)
																																																																																											BgL_auxz00_24190);
																																																																																									}
																																																																																							}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24194;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24194);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24198;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24198);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																}
																																																																															}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24202;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24202);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd240392zd2_6656;
																																																																											BgL_cdrzd240392zd2_6656
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd240399zd2_6657;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12351;
																																																																													BgL_pairz00_12351
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd240399zd2_6657
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12351);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd240406zd2_6658;
																																																																													BgL_cdrzd240406zd2_6658
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd240399zd2_6657));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd240412zd2_6659;
																																																																														obj_t
																																																																															BgL_cdrzd240413zd2_6660;
																																																																														BgL_carzd240412zd2_6659
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6658));
																																																																														BgL_cdrzd240413zd2_6660
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd240406zd2_6658));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240412zd2_6659))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd240420zd2_6662;
																																																																																BgL_carzd240420zd2_6662
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd240413zd2_6660));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240420zd2_6662))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd240413zd2_6660))))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240392zd2_6656))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5414z00_6667;
																																																																																						BgL_arg5414z00_6667
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd240399zd2_6657));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24229;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24233;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24232;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24231;
																																																																																								obj_t
																																																																																									BgL_testz00_24230;
																																																																																								BgL_testz00_24230
																																																																																									=
																																																																																									BgL_arg5414z00_6667;
																																																																																								BgL_proc1z00_24231
																																																																																									=
																																																																																									BgL_carzd240412zd2_6659;
																																																																																								BgL_proc2z00_24232
																																																																																									=
																																																																																									BgL_carzd240420zd2_6662;
																																																																																								BgL_argsz00_24233
																																																																																									=
																																																																																									BgL_cdrzd240392zd2_6656;
																																																																																								BgL_argsz00_1784
																																																																																									=
																																																																																									BgL_argsz00_24233;
																																																																																								BgL_proc2z00_1783
																																																																																									=
																																																																																									BgL_proc2z00_24232;
																																																																																								BgL_proc1z00_1782
																																																																																									=
																																																																																									BgL_proc1z00_24231;
																																																																																								BgL_testz00_1781
																																																																																									=
																																																																																									BgL_testz00_24230;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1785;
																																																																																							}
																																																																																							BgL_auxz00_22135
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24229);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24237;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24237);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24241;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24241);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24245;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24245);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24249;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24249);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24253;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24253);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd240753zd2_6675;
																																																																							BgL_cdrzd240753zd2_6675
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd240759zd2_6676;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12361;
																																																																									BgL_pairz00_12361
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd240759zd2_6676
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12361);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd240765zd2_6677;
																																																																									BgL_cdrzd240765zd2_6677
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd240759zd2_6676));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd240770zd2_6678;
																																																																										obj_t
																																																																											BgL_cdrzd240771zd2_6679;
																																																																										BgL_carzd240770zd2_6678
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6677));
																																																																										BgL_cdrzd240771zd2_6679
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd240765zd2_6677));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240770zd2_6678))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (PAIRP(BgL_cdrzd240771zd2_6679))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd240776zd2_6682;
																																																																														BgL_carzd240776zd2_6682
																																																																															=
																																																																															CAR
																																																																															(BgL_cdrzd240771zd2_6679);
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd240776zd2_6682))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(BgL_cdrzd240771zd2_6679)))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd240753zd2_6675))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5428z00_6687;
																																																																																				BgL_arg5428z00_6687
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd240759zd2_6676));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_24280;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_24284;
																																																																																						obj_t
																																																																																							BgL_proc2z00_24283;
																																																																																						obj_t
																																																																																							BgL_proc1z00_24282;
																																																																																						obj_t
																																																																																							BgL_testz00_24281;
																																																																																						BgL_testz00_24281
																																																																																							=
																																																																																							BgL_arg5428z00_6687;
																																																																																						BgL_proc1z00_24282
																																																																																							=
																																																																																							BgL_carzd240770zd2_6678;
																																																																																						BgL_proc2z00_24283
																																																																																							=
																																																																																							BgL_carzd240776zd2_6682;
																																																																																						BgL_argsz00_24284
																																																																																							=
																																																																																							BgL_cdrzd240753zd2_6675;
																																																																																						BgL_argsz00_1784
																																																																																							=
																																																																																							BgL_argsz00_24284;
																																																																																						BgL_proc2z00_1783
																																																																																							=
																																																																																							BgL_proc2z00_24283;
																																																																																						BgL_proc1z00_1782
																																																																																							=
																																																																																							BgL_proc1z00_24282;
																																																																																						BgL_testz00_1781
																																																																																							=
																																																																																							BgL_testz00_24281;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1785;
																																																																																					}
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_24280);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24288;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24288);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24292;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24292);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24296;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24296);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24300;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24300);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24304;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24304);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24308;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24308);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24312;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24312);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_24316;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_24316);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																											}
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_cdrzd241314zd2_6851;
																																											BgL_cdrzd241314zd2_6851
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											if ((BgL_carzd238249zd2_6574 == CNST_TABLE_REF(((long) 17))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg5545z00_6853;
																																													obj_t
																																														BgL_arg5546z00_6854;
																																													BgL_arg5545z00_6853
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6851));
																																													BgL_arg5546z00_6854
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241314zd2_6851));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_24327;
																																														{
																																															obj_t
																																																BgL_exprz00_24329;
																																															obj_t
																																																BgL_bindingsz00_24328;
																																															BgL_bindingsz00_24328
																																																=
																																																BgL_arg5545z00_6853;
																																															BgL_exprz00_24329
																																																=
																																																BgL_arg5546z00_6854;
																																															BgL_exprz00_1764
																																																=
																																																BgL_exprz00_24329;
																																															BgL_bindingsz00_1763
																																																=
																																																BgL_bindingsz00_24328;
																																															goto
																																																BgL_tagzd2382zd2_1765;
																																														}
																																														BgL_auxz00_22135
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_24327);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd238249zd2_6574)))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5548z00_6856;
																																															obj_t
																																																BgL_arg5549z00_6857;
																																															BgL_arg5548z00_6856
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6851));
																																															BgL_arg5549z00_6857
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241314zd2_6851));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_24338;
																																																{
																																																	obj_t
																																																		BgL_exprz00_24340;
																																																	obj_t
																																																		BgL_bindingsz00_24339;
																																																	BgL_bindingsz00_24339
																																																		=
																																																		BgL_arg5548z00_6856;
																																																	BgL_exprz00_24340
																																																		=
																																																		BgL_arg5549z00_6857;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_24340;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_24339;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_22135
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_24338);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((BgL_carzd238249zd2_6574 == CNST_TABLE_REF(((long) 18))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5551z00_6859;
																																																	obj_t
																																																		BgL_arg5552z00_6860;
																																																	BgL_arg5551z00_6859
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6851));
																																																	BgL_arg5552z00_6860
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd241314zd2_6851));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24349;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24351;
																																																			obj_t
																																																				BgL_bindingsz00_24350;
																																																			BgL_bindingsz00_24350
																																																				=
																																																				BgL_arg5551z00_6859;
																																																			BgL_exprz00_24351
																																																				=
																																																				BgL_arg5552z00_6860;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_24351;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_24350;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_22135
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24349);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_24358;
																																																			goto
																																																				BgL_tagzd2383zd2_1766;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24358);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd241351zd2_6863;
																																																			BgL_carzd241351zd2_6863
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			if ((BgL_carzd241351zd2_6863 == CNST_TABLE_REF(((long) 19))))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24365;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24365);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241351zd2_6863)))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24370;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24370);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24377;
																																																									goto
																																																										BgL_tagzd2389zd2_1786;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24377);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24384;
																																																											goto
																																																												BgL_tagzd2390zd2_1787;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24384);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd241431zd2_6870;
																																																											BgL_cdrzd241431zd2_6870
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg5563z00_6873;
																																																													obj_t
																																																														BgL_arg5564z00_6874;
																																																													BgL_arg5563z00_6873
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6870));
																																																													BgL_arg5564z00_6874
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241431zd2_6870));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_24397;
																																																														{
																																																															obj_t
																																																																BgL_restz00_24399;
																																																															obj_t
																																																																BgL_effectz00_24398;
																																																															BgL_effectz00_24398
																																																																=
																																																																BgL_arg5563z00_6873;
																																																															BgL_restz00_24399
																																																																=
																																																																BgL_arg5564z00_6874;
																																																															BgL_restz00_1789
																																																																=
																																																																BgL_restz00_24399;
																																																															BgL_effectz00_1788
																																																																=
																																																																BgL_effectz00_24398;
																																																															goto
																																																																BgL_tagzd2391zd2_1790;
																																																														}
																																																														BgL_auxz00_22135
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_24397);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24406;
																																																															goto
																																																																BgL_tagzd2392zd2_1791;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24406);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_24413;
																																																																	goto
																																																																		BgL_tagzd2393zd2_1792;
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_24413);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg5571z00_6882;
																																																																			obj_t
																																																																				BgL_arg5572z00_6883;
																																																																			BgL_arg5571z00_6882
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6870));
																																																																			BgL_arg5572z00_6883
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd241431zd2_6870));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24424;
																																																																				{
																																																																					obj_t
																																																																						BgL_restz00_24426;
																																																																					obj_t
																																																																						BgL_effectz00_24425;
																																																																					BgL_effectz00_24425
																																																																						=
																																																																						BgL_arg5571z00_6882;
																																																																					BgL_restz00_24426
																																																																						=
																																																																						BgL_arg5572z00_6883;
																																																																					BgL_restz00_1794
																																																																						=
																																																																						BgL_restz00_24426;
																																																																					BgL_effectz00_1793
																																																																						=
																																																																						BgL_effectz00_24425;
																																																																					goto
																																																																						BgL_tagzd2394zd2_1795;
																																																																				}
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24424);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_24433;
																																																																					goto
																																																																						BgL_tagzd2395zd2_1796;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_24433);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24440;
																																																																							goto
																																																																								BgL_tagzd2396zd2_1797;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24440);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																								{
																																																																									BgL_letzd2funzd2_bglt
																																																																										BgL_auxz00_24447;
																																																																									goto
																																																																										BgL_tagzd2397zd2_1798;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24447);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																										{
																																																																											BgL_jumpzd2exzd2itz00_bglt
																																																																												BgL_auxz00_24454;
																																																																											goto
																																																																												BgL_tagzd2398zd2_1799;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24454);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd241508zd2_6892;
																																																																											BgL_cdrzd241508zd2_6892
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5583z00_6895;
																																																																													obj_t
																																																																														BgL_arg5584z00_6896;
																																																																													BgL_arg5583z00_6895
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6892));
																																																																													BgL_arg5584z00_6896
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd241508zd2_6892));
																																																																													{	/* Ast/sexp.scm 555 */
																																																																														obj_t
																																																																															BgL_arg7015z00_12400;
																																																																														BgL_arg7015z00_12400
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5583z00_6895,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5584z00_6896, BgL_stackz00_22, BgL_arg7015z00_12400, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24473;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24473);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd241533zd2_6913;
																															BgL_carzd241533zd2_6913
																																=
																																CAR(((obj_t)
																																	BgL_expz00_21));
																															if (
																																(BgL_carzd241533zd2_6913
																																	==
																																	CNST_TABLE_REF
																																	(((long) 1))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_24480;
																																	goto
																																		BgL_tagzd2377zd2_1754;
																																	BgL_auxz00_22135
																																		=
																																		((obj_t)
																																		BgL_auxz00_24480);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(BgL_carzd241533zd2_6913
																																			==
																																			BGl_za2ifza2z00zzast_sexpz00))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_24484;
																																			goto
																																				BgL_tagzd2377zd2_1754;
																																			BgL_auxz00_22135
																																				=
																																				((obj_t)
																																				BgL_auxz00_24484);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_cdrzd241555zd2_6916;
																																			BgL_cdrzd241555zd2_6916
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if ((CAR((
																																							(obj_t)
																																							BgL_expz00_21))
																																					==
																																					CNST_TABLE_REF
																																					(((long) 7))))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd241558zd2_6919;
																																					obj_t
																																						BgL_cdrzd241559zd2_6920;
																																					BgL_carzd241558zd2_6919
																																						=
																																						CAR(
																																						((obj_t) BgL_cdrzd241555zd2_6916));
																																					BgL_cdrzd241559zd2_6920
																																						=
																																						CDR(
																																						((obj_t) BgL_cdrzd241555zd2_6916));
																																					if (PAIRP(BgL_carzd241558zd2_6919))
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_carzd241558zd2_6919) == CNST_TABLE_REF(((long) 14))))
																																								{	/* Ast/sexp.scm 119 */
																																									if (NULLP(CDR(((obj_t) BgL_cdrzd241559zd2_6920))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg5610z00_6926;
																																											obj_t
																																												BgL_arg5611z00_6927;
																																											BgL_arg5610z00_6926
																																												=
																																												CDR
																																												(BgL_carzd241558zd2_6919);
																																											BgL_arg5611z00_6927
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241559zd2_6920));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_24510;
																																												{
																																													obj_t
																																														BgL_valz00_24512;
																																													obj_t
																																														BgL_lz00_24511;
																																													BgL_lz00_24511
																																														=
																																														BgL_arg5610z00_6926;
																																													BgL_valz00_24512
																																														=
																																														BgL_arg5611z00_6927;
																																													BgL_valz00_1756
																																														=
																																														BgL_valz00_24512;
																																													BgL_lz00_1755
																																														=
																																														BgL_lz00_24511;
																																													goto
																																														BgL_tagzd2378zd2_1757;
																																												}
																																												BgL_auxz00_22135
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_24510);
																																											}
																																										}
																																									else
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_24514;
																																											goto
																																												BgL_tagzd2379zd2_1758;
																																											BgL_auxz00_22135
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_24514);
																																										}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_24516;
																																									goto
																																										BgL_tagzd2379zd2_1758;
																																									BgL_auxz00_22135
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_24516);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24518;
																																							goto
																																								BgL_tagzd2379zd2_1758;
																																							BgL_auxz00_22135
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24518);
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_24525;
																																							goto
																																								BgL_tagzd2380zd2_1759;
																																							BgL_auxz00_22135
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_24525);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd241656zd2_6932;
																																							BgL_carzd241656zd2_6932
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if (PAIRP(BgL_carzd241656zd2_6932))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd241659zd2_6934;
																																									obj_t
																																										BgL_cdrzd241660zd2_6935;
																																									BgL_carzd241659zd2_6934
																																										=
																																										CAR
																																										(BgL_carzd241656zd2_6932);
																																									BgL_cdrzd241660zd2_6935
																																										=
																																										CDR
																																										(BgL_carzd241656zd2_6932);
																																									{

																																										if ((BgL_carzd241659zd2_6934 == CNST_TABLE_REF(((long) 17))))
																																											{	/* Ast/sexp.scm 119 */
																																											BgL_kapzd241661zd2_6936:
																																												if (PAIRP(BgL_cdrzd241660zd2_6935))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd241664zd2_7061;
																																														BgL_cdrzd241664zd2_7061
																																															=
																																															CDR
																																															(BgL_cdrzd241660zd2_6935);
																																														if (PAIRP(BgL_cdrzd241664zd2_7061))
																																															{	/* Ast/sexp.scm 119 */
																																																if (NULLP(CDR(BgL_cdrzd241664zd2_7061)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5701z00_7065;
																																																		obj_t
																																																			BgL_arg5702z00_7066;
																																																		BgL_arg5701z00_7065
																																																			=
																																																			CAR
																																																			(BgL_cdrzd241664zd2_7061);
																																																		BgL_arg5702z00_7066
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_24547;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_24549;
																																																				obj_t
																																																					BgL_bodyz00_24548;
																																																				BgL_bodyz00_24548
																																																					=
																																																					BgL_arg5701z00_7065;
																																																				BgL_argsz00_24549
																																																					=
																																																					BgL_arg5702z00_7066;
																																																				BgL_argsz00_1761
																																																					=
																																																					BgL_argsz00_24549;
																																																				BgL_bodyz00_1760
																																																					=
																																																					BgL_bodyz00_24548;
																																																				goto
																																																					BgL_tagzd2381zd2_1762;
																																																			}
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24547);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd241688zd2_7067;
																																																		BgL_cdrzd241688zd2_7067
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9784z00_24553;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5771z00_7178;
																																																				BgL_arg5771z00_7178
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9784z00_24553
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5771z00_7178));
																																																			}
																																																			if (BgL_test9784z00_24553)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5705z00_7070;
																																																					obj_t
																																																						BgL_arg5706z00_7071;
																																																					BgL_arg5705z00_7070
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7067));
																																																					BgL_arg5706z00_7071
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd241688zd2_7067));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_24562;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_24564;
																																																							obj_t
																																																								BgL_bindingsz00_24563;
																																																							BgL_bindingsz00_24563
																																																								=
																																																								BgL_arg5705z00_7070;
																																																							BgL_exprz00_24564
																																																								=
																																																								BgL_arg5706z00_7071;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_24564;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_24563;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_22135
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_24562);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9785z00_24566;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5770z00_7177;
																																																						BgL_arg5770z00_7177
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9785z00_24566
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5770z00_7177));
																																																					}
																																																					if (BgL_test9785z00_24566)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_24571;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_24571);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd241755zd2_7074;
																																																							BgL_carzd241755zd2_7074
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd241760zd2_7075;
																																																								BgL_cdrzd241760zd2_7075
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd241755zd2_7074));
																																																								if ((CAR(((obj_t) BgL_carzd241755zd2_7074)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg5711z00_7078;
																																																										obj_t
																																																											BgL_arg5712z00_7079;
																																																										obj_t
																																																											BgL_arg5713z00_7080;
																																																										BgL_arg5711z00_7078
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7075));
																																																										BgL_arg5712z00_7079
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd241760zd2_7075));
																																																										BgL_arg5713z00_7080
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_24588;
																																																											{
																																																												obj_t
																																																													BgL_argsz00_24591;
																																																												obj_t
																																																													BgL_bodyz00_24590;
																																																												obj_t
																																																													BgL_varsz00_24589;
																																																												BgL_varsz00_24589
																																																													=
																																																													BgL_arg5711z00_7078;
																																																												BgL_bodyz00_24590
																																																													=
																																																													BgL_arg5712z00_7079;
																																																												BgL_argsz00_24591
																																																													=
																																																													BgL_arg5713z00_7080;
																																																												BgL_argsz00_1774
																																																													=
																																																													BgL_argsz00_24591;
																																																												BgL_bodyz00_1773
																																																													=
																																																													BgL_bodyz00_24590;
																																																												BgL_varsz00_1772
																																																													=
																																																													BgL_varsz00_24589;
																																																												goto
																																																													BgL_tagzd2386zd2_1775;
																																																											}
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_24588);
																																																										}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd241783zd2_7082;
																																																										BgL_cdrzd241783zd2_7082
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd241789zd2_7083;
																																																											BgL_cdrzd241789zd2_7083
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd241755zd2_7074));
																																																											if ((CAR(((obj_t) BgL_carzd241755zd2_7074)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd241795zd2_7086;
																																																													BgL_cdrzd241795zd2_7086
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd241789zd2_7083));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd241800zd2_7087;
																																																														obj_t
																																																															BgL_cdrzd241801zd2_7088;
																																																														BgL_carzd241800zd2_7087
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7086));
																																																														BgL_cdrzd241801zd2_7088
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd241795zd2_7086));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241800zd2_7087))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd241801zd2_7088))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd241808zd2_7091;
																																																																		BgL_carzd241808zd2_7091
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd241801zd2_7088);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241808zd2_7091))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd241801zd2_7088)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test9792z00_24618;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1437z00_7124;
																																																																							BgL_l1437z00_7124
																																																																								=
																																																																								BgL_cdrzd241783zd2_7082;
																																																																						BgL_zc3z04anonymousza35736ze3z87_7125:
																																																																							if (NULLP(BgL_l1437z00_7124))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9792z00_24618
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9794z00_24621;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test9795z00_24622;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_24623;
																																																																											BgL_tmpz00_24623
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1437z00_7124));
																																																																											BgL_test9795z00_24622
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_24623);
																																																																										}
																																																																										if (BgL_test9795z00_24622)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9794z00_24621
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9794z00_24621
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test9794z00_24621)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1437z00_24627;
																																																																											BgL_l1437z00_24627
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1437z00_7124));
																																																																											BgL_l1437z00_7124
																																																																												=
																																																																												BgL_l1437z00_24627;
																																																																											goto
																																																																												BgL_zc3z04anonymousza35736ze3z87_7125;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test9792z00_24618
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test9792z00_24618)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg5726z00_7107;
																																																																								BgL_arg5726z00_7107
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd241789zd2_7083));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24632;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_24636;
																																																																										obj_t
																																																																											BgL_proc2z00_24635;
																																																																										obj_t
																																																																											BgL_proc1z00_24634;
																																																																										obj_t
																																																																											BgL_testz00_24633;
																																																																										BgL_testz00_24633
																																																																											=
																																																																											BgL_arg5726z00_7107;
																																																																										BgL_proc1z00_24634
																																																																											=
																																																																											BgL_carzd241800zd2_7087;
																																																																										BgL_proc2z00_24635
																																																																											=
																																																																											BgL_carzd241808zd2_7091;
																																																																										BgL_argsz00_24636
																																																																											=
																																																																											BgL_cdrzd241783zd2_7082;
																																																																										BgL_argsz00_1779
																																																																											=
																																																																											BgL_argsz00_24636;
																																																																										BgL_proc2z00_1778
																																																																											=
																																																																											BgL_proc2z00_24635;
																																																																										BgL_proc1z00_1777
																																																																											=
																																																																											BgL_proc1z00_24634;
																																																																										BgL_testz00_1776
																																																																											=
																																																																											BgL_testz00_24633;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1780;
																																																																									}
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24632);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd241832zd2_7108;
																																																																								BgL_cdrzd241832zd2_7108
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd241839zd2_7109;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12453;
																																																																										BgL_pairz00_12453
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd241839zd2_7109
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12453);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd241846zd2_7110;
																																																																										BgL_cdrzd241846zd2_7110
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd241839zd2_7109));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd241852zd2_7111;
																																																																											BgL_carzd241852zd2_7111
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd241846zd2_7110));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241852zd2_7111))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd241859zd2_7113;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12457;
																																																																														BgL_pairz00_12457
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd241846zd2_7110));
																																																																														BgL_carzd241859zd2_7113
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12457);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd241859zd2_7113))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd241832zd2_7108))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg5730z00_7116;
																																																																																	BgL_arg5730z00_7116
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd241839zd2_7109));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_24658;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_24662;
																																																																																			obj_t
																																																																																				BgL_proc2z00_24661;
																																																																																			obj_t
																																																																																				BgL_proc1z00_24660;
																																																																																			obj_t
																																																																																				BgL_testz00_24659;
																																																																																			BgL_testz00_24659
																																																																																				=
																																																																																				BgL_arg5730z00_7116;
																																																																																			BgL_proc1z00_24660
																																																																																				=
																																																																																				BgL_carzd241852zd2_7111;
																																																																																			BgL_proc2z00_24661
																																																																																				=
																																																																																				BgL_carzd241859zd2_7113;
																																																																																			BgL_argsz00_24662
																																																																																				=
																																																																																				BgL_cdrzd241832zd2_7108;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_24662;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_24661;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_24660;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_24659;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_24658);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_24666;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_24666);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24670;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24670);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24674;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24674);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_24678;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_22135
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_24678);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd242135zd2_7135;
																																																																				BgL_cdrzd242135zd2_7135
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd242141zd2_7136;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12461;
																																																																						BgL_pairz00_12461
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd242141zd2_7136
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12461);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd242147zd2_7137;
																																																																						BgL_cdrzd242147zd2_7137
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd242141zd2_7136));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd242152zd2_7138;
																																																																							obj_t
																																																																								BgL_cdrzd242153zd2_7139;
																																																																							BgL_carzd242152zd2_7138
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7137));
																																																																							BgL_cdrzd242153zd2_7139
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd242147zd2_7137));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242152zd2_7138))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd242158zd2_7141;
																																																																									BgL_carzd242158zd2_7141
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd242153zd2_7139));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242158zd2_7141))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd242153zd2_7139))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242135zd2_7135))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5745z00_7146;
																																																																															BgL_arg5745z00_7146
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd242141zd2_7136));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_24705;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_24709;
																																																																																	obj_t
																																																																																		BgL_proc2z00_24708;
																																																																																	obj_t
																																																																																		BgL_proc1z00_24707;
																																																																																	obj_t
																																																																																		BgL_testz00_24706;
																																																																																	BgL_testz00_24706
																																																																																		=
																																																																																		BgL_arg5745z00_7146;
																																																																																	BgL_proc1z00_24707
																																																																																		=
																																																																																		BgL_carzd242152zd2_7138;
																																																																																	BgL_proc2z00_24708
																																																																																		=
																																																																																		BgL_carzd242158zd2_7141;
																																																																																	BgL_argsz00_24709
																																																																																		=
																																																																																		BgL_cdrzd242135zd2_7135;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_24709;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_24708;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_24707;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_24706;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_24705);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_24713;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_24713);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24717;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24717);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24721;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24721);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24725;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24725);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_24729;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_24729);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd242491zd2_7154;
																																																																BgL_cdrzd242491zd2_7154
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd242498zd2_7155;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12471;
																																																																		BgL_pairz00_12471
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd242498zd2_7155
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12471);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd242505zd2_7156;
																																																																		BgL_cdrzd242505zd2_7156
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd242498zd2_7155));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd242511zd2_7157;
																																																																			obj_t
																																																																				BgL_cdrzd242512zd2_7158;
																																																																			BgL_carzd242511zd2_7157
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7156));
																																																																			BgL_cdrzd242512zd2_7158
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd242505zd2_7156));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242511zd2_7157))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd242512zd2_7158))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd242519zd2_7161;
																																																																							BgL_carzd242519zd2_7161
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd242512zd2_7158);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd242519zd2_7161))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd242512zd2_7158)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd242491zd2_7154))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5759z00_7166;
																																																																													BgL_arg5759z00_7166
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd242498zd2_7155));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24756;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24760;
																																																																															obj_t
																																																																																BgL_proc2z00_24759;
																																																																															obj_t
																																																																																BgL_proc1z00_24758;
																																																																															obj_t
																																																																																BgL_testz00_24757;
																																																																															BgL_testz00_24757
																																																																																=
																																																																																BgL_arg5759z00_7166;
																																																																															BgL_proc1z00_24758
																																																																																=
																																																																																BgL_carzd242511zd2_7157;
																																																																															BgL_proc2z00_24759
																																																																																=
																																																																																BgL_carzd242519zd2_7161;
																																																																															BgL_argsz00_24760
																																																																																=
																																																																																BgL_cdrzd242491zd2_7154;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_24760;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_24759;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_24758;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_24757;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24756);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_24764;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_24764);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_24768;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_24768);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_24772;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_24772);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_24776;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_24776);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_24780;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_24780);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24784;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24784);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd242912zd2_7180;
																																																BgL_cdrzd242912zd2_7180
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9823z00_24788;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5787z00_7197;
																																																		BgL_arg5787z00_7197
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9823z00_24788
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg5787z00_7197));
																																																	}
																																																	if (BgL_test9823z00_24788)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5775z00_7183;
																																																			obj_t
																																																				BgL_arg5776z00_7184;
																																																			BgL_arg5775z00_7183
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7180));
																																																			BgL_arg5776z00_7184
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd242912zd2_7180));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_24797;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_24799;
																																																					obj_t
																																																						BgL_bindingsz00_24798;
																																																					BgL_bindingsz00_24798
																																																						=
																																																						BgL_arg5775z00_7183;
																																																					BgL_exprz00_24799
																																																						=
																																																						BgL_arg5776z00_7184;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_24799;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_24798;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_22135
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_24797);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9824z00_24801;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5786z00_7196;
																																																				BgL_arg5786z00_7196
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9824z00_24801
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg5786z00_7196));
																																																			}
																																																			if (BgL_test9824z00_24801)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_24806;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24806);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd242978zd2_7187;
																																																					BgL_carzd242978zd2_7187
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd242983zd2_7188;
																																																						BgL_cdrzd242983zd2_7188
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd242978zd2_7187));
																																																						if ((CAR(((obj_t) BgL_carzd242978zd2_7187)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5781z00_7191;
																																																								obj_t
																																																									BgL_arg5782z00_7192;
																																																								obj_t
																																																									BgL_arg5783z00_7193;
																																																								BgL_arg5781z00_7191
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7188));
																																																								BgL_arg5782z00_7192
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd242983zd2_7188));
																																																								BgL_arg5783z00_7193
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_24823;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_24826;
																																																										obj_t
																																																											BgL_bodyz00_24825;
																																																										obj_t
																																																											BgL_varsz00_24824;
																																																										BgL_varsz00_24824
																																																											=
																																																											BgL_arg5781z00_7191;
																																																										BgL_bodyz00_24825
																																																											=
																																																											BgL_arg5782z00_7192;
																																																										BgL_argsz00_24826
																																																											=
																																																											BgL_arg5783z00_7193;
																																																										BgL_argsz00_1774
																																																											=
																																																											BgL_argsz00_24826;
																																																										BgL_bodyz00_1773
																																																											=
																																																											BgL_bodyz00_24825;
																																																										BgL_varsz00_1772
																																																											=
																																																											BgL_varsz00_24824;
																																																										goto
																																																											BgL_tagzd2386zd2_1775;
																																																									}
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24823);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1809;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_24830;
																																																										goto
																																																											BgL_tagzd2404zd2_1810;
																																																										BgL_auxz00_22135
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_24830);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd243094zd2_7198;
																																														BgL_cdrzd243094zd2_7198
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9827z00_24834;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg5796z00_7207;
																																																BgL_arg5796z00_7207
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9827z00_24834
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg5796z00_7207));
																																															}
																																															if (BgL_test9827z00_24834)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg5790z00_7201;
																																																	obj_t
																																																		BgL_arg5791z00_7202;
																																																	BgL_arg5790z00_7201
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7198));
																																																	BgL_arg5791z00_7202
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd243094zd2_7198));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_24843;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_24845;
																																																			obj_t
																																																				BgL_bindingsz00_24844;
																																																			BgL_bindingsz00_24844
																																																				=
																																																				BgL_arg5790z00_7201;
																																																			BgL_exprz00_24845
																																																				=
																																																				BgL_arg5791z00_7202;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_24845;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_24844;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_22135
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_24843);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9828z00_24847;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg5795z00_7206;
																																																		BgL_arg5795z00_7206
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9828z00_24847
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg5795z00_7206));
																																																	}
																																																	if (BgL_test9828z00_24847)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_24852;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_24852);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1809;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_24856;
																																																					goto
																																																						BgL_tagzd2404zd2_1810;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_24856);
																																																				}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241659zd2_6934)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd241661zd2_6936;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd241659zd2_6934 == CNST_TABLE_REF(((long) 18))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd241661zd2_6936;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if ((BgL_carzd241659zd2_6934 == CNST_TABLE_REF(((long) 19))))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd241661zd2_6936;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd241659zd2_6934)))
																																																			{	/* Ast/sexp.scm 119 */
																																																				goto
																																																					BgL_kapzd241661zd2_6936;
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd243266zd2_6942;
																																																				BgL_cdrzd243266zd2_6942
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9834z00_24872;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5696z00_7059;
																																																						BgL_arg5696z00_7059
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9834z00_24872
																																																							=
																																																							CBOOL
																																																							(BGl_letzd2symzf3z21zzast_letz00
																																																							(BgL_arg5696z00_7059));
																																																					}
																																																					if (BgL_test9834z00_24872)
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg5624z00_6945;
																																																							obj_t
																																																								BgL_arg5625z00_6946;
																																																							BgL_arg5624z00_6945
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6942));
																																																							BgL_arg5625z00_6946
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd243266zd2_6942));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_24881;
																																																								{
																																																									obj_t
																																																										BgL_exprz00_24883;
																																																									obj_t
																																																										BgL_bindingsz00_24882;
																																																									BgL_bindingsz00_24882
																																																										=
																																																										BgL_arg5624z00_6945;
																																																									BgL_exprz00_24883
																																																										=
																																																										BgL_arg5625z00_6946;
																																																									BgL_exprz00_1764
																																																										=
																																																										BgL_exprz00_24883;
																																																									BgL_bindingsz00_1763
																																																										=
																																																										BgL_bindingsz00_24882;
																																																									goto
																																																										BgL_tagzd2382zd2_1765;
																																																								}
																																																								BgL_auxz00_22135
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_24881);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							bool_t
																																																								BgL_test9835z00_24885;
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5695z00_7058;
																																																								BgL_arg5695z00_7058
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								BgL_test9835z00_24885
																																																									=
																																																									CBOOL
																																																									(BGl_labelszd2symzf3z21zzast_labelsz00
																																																									(BgL_arg5695z00_7058));
																																																							}
																																																							if (BgL_test9835z00_24885)
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_24890;
																																																									goto
																																																										BgL_tagzd2384zd2_1767;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_24890);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd243332zd2_6949;
																																																									BgL_carzd243332zd2_6949
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd243337zd2_6950;
																																																										BgL_cdrzd243337zd2_6950
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_carzd243332zd2_6949));
																																																										if ((CAR(((obj_t) BgL_carzd243332zd2_6949)) == CNST_TABLE_REF(((long) 3))))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd243337zd2_6950))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg5631z00_6954;
																																																														obj_t
																																																															BgL_arg5632z00_6955;
																																																														obj_t
																																																															BgL_arg5633z00_6956;
																																																														BgL_arg5631z00_6954
																																																															=
																																																															CAR
																																																															(BgL_cdrzd243337zd2_6950);
																																																														BgL_arg5632z00_6955
																																																															=
																																																															CDR
																																																															(BgL_cdrzd243337zd2_6950);
																																																														BgL_arg5633z00_6956
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_24907;
																																																															{
																																																																obj_t
																																																																	BgL_argsz00_24910;
																																																																obj_t
																																																																	BgL_bodyz00_24909;
																																																																obj_t
																																																																	BgL_varsz00_24908;
																																																																BgL_varsz00_24908
																																																																	=
																																																																	BgL_arg5631z00_6954;
																																																																BgL_bodyz00_24909
																																																																	=
																																																																	BgL_arg5632z00_6955;
																																																																BgL_argsz00_24910
																																																																	=
																																																																	BgL_arg5633z00_6956;
																																																																BgL_argsz00_1774
																																																																	=
																																																																	BgL_argsz00_24910;
																																																																BgL_bodyz00_1773
																																																																	=
																																																																	BgL_bodyz00_24909;
																																																																BgL_varsz00_1772
																																																																	=
																																																																	BgL_varsz00_24908;
																																																																goto
																																																																	BgL_tagzd2386zd2_1775;
																																																															}
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_24907);
																																																														}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_24914;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_24914);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd243444zd2_6959;
																																																												BgL_cdrzd243444zd2_6959
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd243449zd2_6960;
																																																													BgL_cdrzd243449zd2_6960
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd243332zd2_6949));
																																																													if ((CAR(((obj_t) BgL_carzd243332zd2_6949)) == CNST_TABLE_REF(((long) 1))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (PAIRP(BgL_cdrzd243449zd2_6960))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd243454zd2_6964;
																																																																	BgL_cdrzd243454zd2_6964
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd243449zd2_6960);
																																																																	if (PAIRP(BgL_cdrzd243454zd2_6964))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd243458zd2_6966;
																																																																			obj_t
																																																																				BgL_cdrzd243459zd2_6967;
																																																																			BgL_carzd243458zd2_6966
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd243454zd2_6964);
																																																																			BgL_cdrzd243459zd2_6967
																																																																				=
																																																																				CDR
																																																																				(BgL_cdrzd243454zd2_6964);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243458zd2_6966))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd243459zd2_6967))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd243464zd2_6970;
																																																																							BgL_carzd243464zd2_6970
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd243459zd2_6967);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243464zd2_6970))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd243459zd2_6967)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9846z00_24942;
																																																																											{
																																																																												obj_t
																																																																													BgL_l1440z00_7003;
																																																																												BgL_l1440z00_7003
																																																																													=
																																																																													BgL_cdrzd243444zd2_6959;
																																																																											BgL_zc3z04anonymousza35659ze3z87_7004:
																																																																												if (NULLP(BgL_l1440z00_7003))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9846z00_24942
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															1);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														bool_t
																																																																															BgL_test9848z00_24945;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															bool_t
																																																																																BgL_test9849z00_24946;
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_tmpz00_24947;
																																																																																BgL_tmpz00_24947
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_l1440z00_7003));
																																																																																BgL_test9849z00_24946
																																																																																	=
																																																																																	PAIRP
																																																																																	(BgL_tmpz00_24947);
																																																																															}
																																																																															if (BgL_test9849z00_24946)
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test9848z00_24945
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		0);
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	BgL_test9848z00_24945
																																																																																		=
																																																																																		(
																																																																																		(bool_t)
																																																																																		1);
																																																																																}
																																																																														}
																																																																														if (BgL_test9848z00_24945)
																																																																															{
																																																																																obj_t
																																																																																	BgL_l1440z00_24951;
																																																																																BgL_l1440z00_24951
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_l1440z00_7003));
																																																																																BgL_l1440z00_7003
																																																																																	=
																																																																																	BgL_l1440z00_24951;
																																																																																goto
																																																																																	BgL_zc3z04anonymousza35659ze3z87_7004;
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																BgL_test9846z00_24942
																																																																																	=
																																																																																	(
																																																																																	(bool_t)
																																																																																	0);
																																																																															}
																																																																													}
																																																																											}
																																																																											if (BgL_test9846z00_24942)
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5649z00_6986;
																																																																													BgL_arg5649z00_6986
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd243449zd2_6960);
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_24955;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_24959;
																																																																															obj_t
																																																																																BgL_proc2z00_24958;
																																																																															obj_t
																																																																																BgL_proc1z00_24957;
																																																																															obj_t
																																																																																BgL_testz00_24956;
																																																																															BgL_testz00_24956
																																																																																=
																																																																																BgL_arg5649z00_6986;
																																																																															BgL_proc1z00_24957
																																																																																=
																																																																																BgL_carzd243458zd2_6966;
																																																																															BgL_proc2z00_24958
																																																																																=
																																																																																BgL_carzd243464zd2_6970;
																																																																															BgL_argsz00_24959
																																																																																=
																																																																																BgL_cdrzd243444zd2_6959;
																																																																															BgL_argsz00_1779
																																																																																=
																																																																																BgL_argsz00_24959;
																																																																															BgL_proc2z00_1778
																																																																																=
																																																																																BgL_proc2z00_24958;
																																																																															BgL_proc1z00_1777
																																																																																=
																																																																																BgL_proc1z00_24957;
																																																																															BgL_testz00_1776
																																																																																=
																																																																																BgL_testz00_24956;
																																																																															goto
																																																																																BgL_tagzd2387zd2_1780;
																																																																														}
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_24955);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd243489zd2_6987;
																																																																													BgL_cdrzd243489zd2_6987
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_cdrzd243497zd2_6988;
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_pairz00_12528;
																																																																															BgL_pairz00_12528
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_expz00_21));
																																																																															BgL_cdrzd243497zd2_6988
																																																																																=
																																																																																CDR
																																																																																(BgL_pairz00_12528);
																																																																														}
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_cdrzd243505zd2_6989;
																																																																															BgL_cdrzd243505zd2_6989
																																																																																=
																																																																																CDR
																																																																																(
																																																																																((obj_t) BgL_cdrzd243497zd2_6988));
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd243512zd2_6990;
																																																																																BgL_carzd243512zd2_6990
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd243505zd2_6989));
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243512zd2_6990))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_carzd243521zd2_6992;
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			obj_t
																																																																																				BgL_pairz00_12532;
																																																																																			BgL_pairz00_12532
																																																																																				=
																																																																																				CDR
																																																																																				(
																																																																																				((obj_t) BgL_cdrzd243505zd2_6989));
																																																																																			BgL_carzd243521zd2_6992
																																																																																				=
																																																																																				CAR
																																																																																				(BgL_pairz00_12532);
																																																																																		}
																																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243521zd2_6992))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243489zd2_6987))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						obj_t
																																																																																							BgL_arg5653z00_6995;
																																																																																						BgL_arg5653z00_6995
																																																																																							=
																																																																																							CAR
																																																																																							(
																																																																																							((obj_t) BgL_cdrzd243497zd2_6988));
																																																																																						{
																																																																																							BgL_nodez00_bglt
																																																																																								BgL_auxz00_24981;
																																																																																							{
																																																																																								obj_t
																																																																																									BgL_argsz00_24985;
																																																																																								obj_t
																																																																																									BgL_proc2z00_24984;
																																																																																								obj_t
																																																																																									BgL_proc1z00_24983;
																																																																																								obj_t
																																																																																									BgL_testz00_24982;
																																																																																								BgL_testz00_24982
																																																																																									=
																																																																																									BgL_arg5653z00_6995;
																																																																																								BgL_proc1z00_24983
																																																																																									=
																																																																																									BgL_carzd243512zd2_6990;
																																																																																								BgL_proc2z00_24984
																																																																																									=
																																																																																									BgL_carzd243521zd2_6992;
																																																																																								BgL_argsz00_24985
																																																																																									=
																																																																																									BgL_cdrzd243489zd2_6987;
																																																																																								BgL_argsz00_1784
																																																																																									=
																																																																																									BgL_argsz00_24985;
																																																																																								BgL_proc2z00_1783
																																																																																									=
																																																																																									BgL_proc2z00_24984;
																																																																																								BgL_proc1z00_1782
																																																																																									=
																																																																																									BgL_proc1z00_24983;
																																																																																								BgL_testz00_1781
																																																																																									=
																																																																																									BgL_testz00_24982;
																																																																																								goto
																																																																																									BgL_tagzd2388zd2_1785;
																																																																																							}
																																																																																							BgL_auxz00_22135
																																																																																								=
																																																																																								(
																																																																																								(obj_t)
																																																																																								BgL_auxz00_24981);
																																																																																						}
																																																																																					}
																																																																																				else
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																							{	/* Ast/sexp.scm 119 */
																																																																																								goto
																																																																																									BgL_tagzd2403zd2_1809;
																																																																																							}
																																																																																						else
																																																																																							{
																																																																																								BgL_nodez00_bglt
																																																																																									BgL_auxz00_24989;
																																																																																								goto
																																																																																									BgL_tagzd2404zd2_1810;
																																																																																								BgL_auxz00_22135
																																																																																									=
																																																																																									(
																																																																																									(obj_t)
																																																																																									BgL_auxz00_24989);
																																																																																							}
																																																																																					}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_24993;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_24993);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_24997;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_24997);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														}
																																																																													}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25001;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25001);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd243799zd2_7014;
																																																																									BgL_cdrzd243799zd2_7014
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd243806zd2_7015;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12536;
																																																																											BgL_pairz00_12536
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd243806zd2_7015
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12536);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd243813zd2_7016;
																																																																											BgL_cdrzd243813zd2_7016
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd243806zd2_7015));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd243819zd2_7017;
																																																																												obj_t
																																																																													BgL_cdrzd243820zd2_7018;
																																																																												BgL_carzd243819zd2_7017
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_7016));
																																																																												BgL_cdrzd243820zd2_7018
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd243813zd2_7016));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243819zd2_7017))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd243827zd2_7020;
																																																																														BgL_carzd243827zd2_7020
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd243820zd2_7018));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd243827zd2_7020))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (NULLP(CDR(((obj_t) BgL_cdrzd243820zd2_7018))))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd243799zd2_7014))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5668z00_7025;
																																																																																				BgL_arg5668z00_7025
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd243806zd2_7015));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_25028;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_25032;
																																																																																						obj_t
																																																																																							BgL_proc2z00_25031;
																																																																																						obj_t
																																																																																							BgL_proc1z00_25030;
																																																																																						obj_t
																																																																																							BgL_testz00_25029;
																																																																																						BgL_testz00_25029
																																																																																							=
																																																																																							BgL_arg5668z00_7025;
																																																																																						BgL_proc1z00_25030
																																																																																							=
																																																																																							BgL_carzd243819zd2_7017;
																																																																																						BgL_proc2z00_25031
																																																																																							=
																																																																																							BgL_carzd243827zd2_7020;
																																																																																						BgL_argsz00_25032
																																																																																							=
																																																																																							BgL_cdrzd243799zd2_7014;
																																																																																						BgL_argsz00_1784
																																																																																							=
																																																																																							BgL_argsz00_25032;
																																																																																						BgL_proc2z00_1783
																																																																																							=
																																																																																							BgL_proc2z00_25031;
																																																																																						BgL_proc1z00_1782
																																																																																							=
																																																																																							BgL_proc1z00_25030;
																																																																																						BgL_testz00_1781
																																																																																							=
																																																																																							BgL_testz00_25029;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1785;
																																																																																					}
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_25028);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_25036;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_25036);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25040;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25040);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25044;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25044);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25048;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25048);
																																																																															}
																																																																													}
																																																																											}
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25052;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25052);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd244160zd2_7033;
																																																																					BgL_cdrzd244160zd2_7033
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd244166zd2_7034;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_12546;
																																																																							BgL_pairz00_12546
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd244166zd2_7034
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12546);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd244172zd2_7035;
																																																																							BgL_cdrzd244172zd2_7035
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd244166zd2_7034));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd244177zd2_7036;
																																																																								obj_t
																																																																									BgL_cdrzd244178zd2_7037;
																																																																								BgL_carzd244177zd2_7036
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_7035));
																																																																								BgL_cdrzd244178zd2_7037
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd244172zd2_7035));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244177zd2_7036))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (PAIRP(BgL_cdrzd244178zd2_7037))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd244183zd2_7040;
																																																																												BgL_carzd244183zd2_7040
																																																																													=
																																																																													CAR
																																																																													(BgL_cdrzd244178zd2_7037);
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd244183zd2_7040))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(BgL_cdrzd244178zd2_7037)))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd244160zd2_7033))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg5682z00_7045;
																																																																																		BgL_arg5682z00_7045
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd244166zd2_7034));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_25079;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_25083;
																																																																																				obj_t
																																																																																					BgL_proc2z00_25082;
																																																																																				obj_t
																																																																																					BgL_proc1z00_25081;
																																																																																				obj_t
																																																																																					BgL_testz00_25080;
																																																																																				BgL_testz00_25080
																																																																																					=
																																																																																					BgL_arg5682z00_7045;
																																																																																				BgL_proc1z00_25081
																																																																																					=
																																																																																					BgL_carzd244177zd2_7036;
																																																																																				BgL_proc2z00_25082
																																																																																					=
																																																																																					BgL_carzd244183zd2_7040;
																																																																																				BgL_argsz00_25083
																																																																																					=
																																																																																					BgL_cdrzd244160zd2_7033;
																																																																																				BgL_argsz00_1784
																																																																																					=
																																																																																					BgL_argsz00_25083;
																																																																																				BgL_proc2z00_1783
																																																																																					=
																																																																																					BgL_proc2z00_25082;
																																																																																				BgL_proc1z00_1782
																																																																																					=
																																																																																					BgL_proc1z00_25081;
																																																																																				BgL_testz00_1781
																																																																																					=
																																																																																					BgL_testz00_25080;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1785;
																																																																																			}
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_25079);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25087;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25087);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25091;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25091);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25095;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25095);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25099;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25099);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25103;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_22135
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25103);
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25107;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25107);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25111;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25111);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25115;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25115);
																																																																}
																																																														}
																																																												}
																																																											}
																																																									}
																																																								}
																																																						}
																																																				}
																																																			}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd241656zd2_6932 == CNST_TABLE_REF(((long) 17))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg5798z00_7211;
																																											obj_t
																																												BgL_arg5799z00_7212;
																																											BgL_arg5798z00_7211
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6916));
																																											BgL_arg5799z00_7212
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd241555zd2_6916));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_25124;
																																												{
																																													obj_t
																																														BgL_exprz00_25126;
																																													obj_t
																																														BgL_bindingsz00_25125;
																																													BgL_bindingsz00_25125
																																														=
																																														BgL_arg5798z00_7211;
																																													BgL_exprz00_25126
																																														=
																																														BgL_arg5799z00_7212;
																																													BgL_exprz00_1764
																																														=
																																														BgL_exprz00_25126;
																																													BgL_bindingsz00_1763
																																														=
																																														BgL_bindingsz00_25125;
																																													goto
																																														BgL_tagzd2382zd2_1765;
																																												}
																																												BgL_auxz00_22135
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_25124);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd241656zd2_6932)))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg5801z00_7214;
																																													obj_t
																																														BgL_arg5802z00_7215;
																																													BgL_arg5801z00_7214
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6916));
																																													BgL_arg5802z00_7215
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd241555zd2_6916));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25135;
																																														{
																																															obj_t
																																																BgL_exprz00_25137;
																																															obj_t
																																																BgL_bindingsz00_25136;
																																															BgL_bindingsz00_25136
																																																=
																																																BgL_arg5801z00_7214;
																																															BgL_exprz00_25137
																																																=
																																																BgL_arg5802z00_7215;
																																															BgL_exprz00_1764
																																																=
																																																BgL_exprz00_25137;
																																															BgL_bindingsz00_1763
																																																=
																																																BgL_bindingsz00_25136;
																																															goto
																																																BgL_tagzd2382zd2_1765;
																																														}
																																														BgL_auxz00_22135
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25135);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((BgL_carzd241656zd2_6932 == CNST_TABLE_REF(((long) 18))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg5804z00_7217;
																																															obj_t
																																																BgL_arg5805z00_7218;
																																															BgL_arg5804z00_7217
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6916));
																																															BgL_arg5805z00_7218
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd241555zd2_6916));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25146;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25148;
																																																	obj_t
																																																		BgL_bindingsz00_25147;
																																																	BgL_bindingsz00_25147
																																																		=
																																																		BgL_arg5804z00_7217;
																																																	BgL_exprz00_25148
																																																		=
																																																		BgL_arg5805z00_7218;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_25148;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_25147;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_22135
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25146);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25155;
																																																	goto
																																																		BgL_tagzd2383zd2_1766;
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25155);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd244758zd2_7221;
																																																	BgL_carzd244758zd2_7221
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	if ((BgL_carzd244758zd2_7221 == CNST_TABLE_REF(((long) 19))))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25162;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25162);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd244758zd2_7221)))
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25167;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25167);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25174;
																																																							goto
																																																								BgL_tagzd2389zd2_1786;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25174);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_25181;
																																																									goto
																																																										BgL_tagzd2390zd2_1787;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_25181);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd244838zd2_7228;
																																																									BgL_cdrzd244838zd2_7228
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_arg5816z00_7231;
																																																											obj_t
																																																												BgL_arg5817z00_7232;
																																																											BgL_arg5816z00_7231
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7228));
																																																											BgL_arg5817z00_7232
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd244838zd2_7228));
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_25194;
																																																												{
																																																													obj_t
																																																														BgL_restz00_25196;
																																																													obj_t
																																																														BgL_effectz00_25195;
																																																													BgL_effectz00_25195
																																																														=
																																																														BgL_arg5816z00_7231;
																																																													BgL_restz00_25196
																																																														=
																																																														BgL_arg5817z00_7232;
																																																													BgL_restz00_1789
																																																														=
																																																														BgL_restz00_25196;
																																																													BgL_effectz00_1788
																																																														=
																																																														BgL_effectz00_25195;
																																																													goto
																																																														BgL_tagzd2391zd2_1790;
																																																												}
																																																												BgL_auxz00_22135
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_25194);
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25203;
																																																													goto
																																																														BgL_tagzd2392zd2_1791;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25203);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25210;
																																																															goto
																																																																BgL_tagzd2393zd2_1792;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25210);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg5824z00_7240;
																																																																	obj_t
																																																																		BgL_arg5825z00_7241;
																																																																	BgL_arg5824z00_7240
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7228));
																																																																	BgL_arg5825z00_7241
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd244838zd2_7228));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25221;
																																																																		{
																																																																			obj_t
																																																																				BgL_restz00_25223;
																																																																			obj_t
																																																																				BgL_effectz00_25222;
																																																																			BgL_effectz00_25222
																																																																				=
																																																																				BgL_arg5824z00_7240;
																																																																			BgL_restz00_25223
																																																																				=
																																																																				BgL_arg5825z00_7241;
																																																																			BgL_restz00_1794
																																																																				=
																																																																				BgL_restz00_25223;
																																																																			BgL_effectz00_1793
																																																																				=
																																																																				BgL_effectz00_25222;
																																																																			goto
																																																																				BgL_tagzd2394zd2_1795;
																																																																		}
																																																																		BgL_auxz00_22135
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25221);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25230;
																																																																			goto
																																																																				BgL_tagzd2395zd2_1796;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25230);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25237;
																																																																					goto
																																																																						BgL_tagzd2396zd2_1797;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25237);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																						{
																																																																							BgL_letzd2funzd2_bglt
																																																																								BgL_auxz00_25244;
																																																																							goto
																																																																								BgL_tagzd2397zd2_1798;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25244);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																								{
																																																																									BgL_jumpzd2exzd2itz00_bglt
																																																																										BgL_auxz00_25251;
																																																																									goto
																																																																										BgL_tagzd2398zd2_1799;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25251);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											bool_t
																																																																												BgL_test9896z00_25258;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_tmpz00_25259;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12584;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12583;
																																																																														BgL_pairz00_12583
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_expz00_21));
																																																																														BgL_pairz00_12584
																																																																															=
																																																																															CDR
																																																																															(BgL_pairz00_12583);
																																																																													}
																																																																													BgL_tmpz00_25259
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12584);
																																																																												}
																																																																												BgL_test9896z00_25258
																																																																													=
																																																																													NULLP
																																																																													(BgL_tmpz00_25259);
																																																																											}
																																																																											if (BgL_test9896z00_25258)
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25265;
																																																																													goto
																																																																														BgL_tagzd2399zd2_1800;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25265);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25269;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25269);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd244931zd2_7260;
																																																																											BgL_cdrzd244931zd2_7260
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg5846z00_7263;
																																																																													obj_t
																																																																														BgL_arg5847z00_7264;
																																																																													BgL_arg5846z00_7263
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7260));
																																																																													BgL_arg5847z00_7264
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd244931zd2_7260));
																																																																													{	/* Ast/sexp.scm 555 */
																																																																														obj_t
																																																																															BgL_arg7015z00_12590;
																																																																														BgL_arg7015z00_12590
																																																																															=
																																																																															BGl_findzd2locationzf2locz20zztools_locationz00
																																																																															(BgL_expz00_21,
																																																																															BgL_locz00_23);
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																															(BgL_expz00_21,
																																																																																BgL_arg5846z00_7263,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg5847z00_7264, BgL_stackz00_22, BgL_arg7015z00_12590, BgL_sitez00_24));
																																																																												}}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25288;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25288);
																																																																														}
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													obj_t
																														BgL_carzd244956zd2_7281;
																													BgL_carzd244956zd2_7281
																														=
																														CAR(((obj_t)
																															BgL_expz00_21));
																													if (
																														(BgL_carzd244956zd2_7281
																															==
																															CNST_TABLE_REF((
																																	(long) 1))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_25295;
																															goto
																																BgL_tagzd2377zd2_1754;
																															BgL_auxz00_22135 =
																																((obj_t)
																																BgL_auxz00_25295);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(BgL_carzd244956zd2_7281
																																	==
																																	BGl_za2ifza2z00zzast_sexpz00))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_25299;
																																	goto
																																		BgL_tagzd2377zd2_1754;
																																	BgL_auxz00_22135
																																		=
																																		((obj_t)
																																		BgL_auxz00_25299);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_cdrzd244978zd2_7284;
																																	BgL_cdrzd244978zd2_7284
																																		=
																																		CDR(((obj_t)
																																			BgL_expz00_21));
																																	if ((CAR((
																																					(obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					7))))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd244981zd2_7287;
																																			obj_t
																																				BgL_cdrzd244982zd2_7288;
																																			BgL_carzd244981zd2_7287
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7284));
																																			BgL_cdrzd244982zd2_7288
																																				=
																																				CDR((
																																					(obj_t)
																																					BgL_cdrzd244978zd2_7284));
																																			if (PAIRP
																																				(BgL_carzd244981zd2_7287))
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(BgL_carzd244981zd2_7287)
																																							==
																																							CNST_TABLE_REF
																																							(((long) 14))))
																																						{	/* Ast/sexp.scm 119 */
																																							if (NULLP(CDR(((obj_t) BgL_cdrzd244982zd2_7288))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg5873z00_7294;
																																									obj_t
																																										BgL_arg5874z00_7295;
																																									BgL_arg5873z00_7294
																																										=
																																										CDR
																																										(BgL_carzd244981zd2_7287);
																																									BgL_arg5874z00_7295
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244982zd2_7288));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25325;
																																										{
																																											obj_t
																																												BgL_valz00_25327;
																																											obj_t
																																												BgL_lz00_25326;
																																											BgL_lz00_25326
																																												=
																																												BgL_arg5873z00_7294;
																																											BgL_valz00_25327
																																												=
																																												BgL_arg5874z00_7295;
																																											BgL_valz00_1756
																																												=
																																												BgL_valz00_25327;
																																											BgL_lz00_1755
																																												=
																																												BgL_lz00_25326;
																																											goto
																																												BgL_tagzd2378zd2_1757;
																																										}
																																										BgL_auxz00_22135
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25325);
																																									}
																																								}
																																							else
																																								{
																																									BgL_nodez00_bglt
																																										BgL_auxz00_25329;
																																									goto
																																										BgL_tagzd2379zd2_1758;
																																									BgL_auxz00_22135
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_25329);
																																								}
																																						}
																																					else
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_25331;
																																							goto
																																								BgL_tagzd2379zd2_1758;
																																							BgL_auxz00_22135
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_25331);
																																						}
																																				}
																																			else
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_25333;
																																					goto
																																						BgL_tagzd2379zd2_1758;
																																					BgL_auxz00_22135
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_25333);
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(CAR(
																																						((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 16))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_25340;
																																					goto
																																						BgL_tagzd2380zd2_1759;
																																					BgL_auxz00_22135
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_25340);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd245079zd2_7300;
																																					BgL_carzd245079zd2_7300
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (PAIRP(BgL_carzd245079zd2_7300))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd245082zd2_7302;
																																							obj_t
																																								BgL_cdrzd245083zd2_7303;
																																							BgL_carzd245082zd2_7302
																																								=
																																								CAR
																																								(BgL_carzd245079zd2_7300);
																																							BgL_cdrzd245083zd2_7303
																																								=
																																								CDR
																																								(BgL_carzd245079zd2_7300);
																																							{

																																								if ((BgL_carzd245082zd2_7302 == CNST_TABLE_REF(((long) 17))))
																																									{	/* Ast/sexp.scm 119 */
																																									BgL_kapzd245084zd2_7304:
																																										if (PAIRP(BgL_cdrzd245083zd2_7303))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd245087zd2_7429;
																																												BgL_cdrzd245087zd2_7429
																																													=
																																													CDR
																																													(BgL_cdrzd245083zd2_7303);
																																												if (PAIRP(BgL_cdrzd245087zd2_7429))
																																													{	/* Ast/sexp.scm 119 */
																																														if (NULLP(CDR(BgL_cdrzd245087zd2_7429)))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg5964z00_7433;
																																																obj_t
																																																	BgL_arg5965z00_7434;
																																																BgL_arg5964z00_7433
																																																	=
																																																	CAR
																																																	(BgL_cdrzd245087zd2_7429);
																																																BgL_arg5965z00_7434
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_25362;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_25364;
																																																		obj_t
																																																			BgL_bodyz00_25363;
																																																		BgL_bodyz00_25363
																																																			=
																																																			BgL_arg5964z00_7433;
																																																		BgL_argsz00_25364
																																																			=
																																																			BgL_arg5965z00_7434;
																																																		BgL_argsz00_1761
																																																			=
																																																			BgL_argsz00_25364;
																																																		BgL_bodyz00_1760
																																																			=
																																																			BgL_bodyz00_25363;
																																																		goto
																																																			BgL_tagzd2381zd2_1762;
																																																	}
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25362);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd245111zd2_7435;
																																																BgL_cdrzd245111zd2_7435
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9912z00_25368;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6034z00_7546;
																																																		BgL_arg6034z00_7546
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9912z00_25368
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6034z00_7546));
																																																	}
																																																	if (BgL_test9912z00_25368)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg5968z00_7438;
																																																			obj_t
																																																				BgL_arg5969z00_7439;
																																																			BgL_arg5968z00_7438
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7435));
																																																			BgL_arg5969z00_7439
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd245111zd2_7435));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_25377;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_25379;
																																																					obj_t
																																																						BgL_bindingsz00_25378;
																																																					BgL_bindingsz00_25378
																																																						=
																																																						BgL_arg5968z00_7438;
																																																					BgL_exprz00_25379
																																																						=
																																																						BgL_arg5969z00_7439;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_25379;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_25378;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_22135
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_25377);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9913z00_25381;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6033z00_7545;
																																																				BgL_arg6033z00_7545
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9913z00_25381
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6033z00_7545));
																																																			}
																																																			if (BgL_test9913z00_25381)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_25386;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25386);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd245178zd2_7442;
																																																					BgL_carzd245178zd2_7442
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd245183zd2_7443;
																																																						BgL_cdrzd245183zd2_7443
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd245178zd2_7442));
																																																						if ((CAR(((obj_t) BgL_carzd245178zd2_7442)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_arg5974z00_7446;
																																																								obj_t
																																																									BgL_arg5975z00_7447;
																																																								obj_t
																																																									BgL_arg5976z00_7448;
																																																								BgL_arg5974z00_7446
																																																									=
																																																									CAR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7443));
																																																								BgL_arg5975z00_7447
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd245183zd2_7443));
																																																								BgL_arg5976z00_7448
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_25403;
																																																									{
																																																										obj_t
																																																											BgL_argsz00_25406;
																																																										obj_t
																																																											BgL_bodyz00_25405;
																																																										obj_t
																																																											BgL_varsz00_25404;
																																																										BgL_varsz00_25404
																																																											=
																																																											BgL_arg5974z00_7446;
																																																										BgL_bodyz00_25405
																																																											=
																																																											BgL_arg5975z00_7447;
																																																										BgL_argsz00_25406
																																																											=
																																																											BgL_arg5976z00_7448;
																																																										BgL_argsz00_1774
																																																											=
																																																											BgL_argsz00_25406;
																																																										BgL_bodyz00_1773
																																																											=
																																																											BgL_bodyz00_25405;
																																																										BgL_varsz00_1772
																																																											=
																																																											BgL_varsz00_25404;
																																																										goto
																																																											BgL_tagzd2386zd2_1775;
																																																									}
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_25403);
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd245206zd2_7450;
																																																								BgL_cdrzd245206zd2_7450
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_expz00_21));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd245212zd2_7451;
																																																									BgL_cdrzd245212zd2_7451
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd245178zd2_7442));
																																																									if ((CAR(((obj_t) BgL_carzd245178zd2_7442)) == CNST_TABLE_REF(((long) 1))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd245218zd2_7454;
																																																											BgL_cdrzd245218zd2_7454
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd245212zd2_7451));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd245223zd2_7455;
																																																												obj_t
																																																													BgL_cdrzd245224zd2_7456;
																																																												BgL_carzd245223zd2_7455
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7454));
																																																												BgL_cdrzd245224zd2_7456
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd245218zd2_7454));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245223zd2_7455))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd245224zd2_7456))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd245231zd2_7459;
																																																																BgL_carzd245231zd2_7459
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd245224zd2_7456);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245231zd2_7459))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd245224zd2_7456)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test9920z00_25433;
																																																																				{
																																																																					obj_t
																																																																						BgL_l1443z00_7492;
																																																																					BgL_l1443z00_7492
																																																																						=
																																																																						BgL_cdrzd245206zd2_7450;
																																																																				BgL_zc3z04anonymousza35999ze3z87_7493:
																																																																					if (NULLP(BgL_l1443z00_7492))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test9920z00_25433
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test9922z00_25436;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								bool_t
																																																																									BgL_test9923z00_25437;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_tmpz00_25438;
																																																																									BgL_tmpz00_25438
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_l1443z00_7492));
																																																																									BgL_test9923z00_25437
																																																																										=
																																																																										PAIRP
																																																																										(BgL_tmpz00_25438);
																																																																								}
																																																																								if (BgL_test9923z00_25437)
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9922z00_25436
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											0);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										BgL_test9922z00_25436
																																																																											=
																																																																											(
																																																																											(bool_t)
																																																																											1);
																																																																									}
																																																																							}
																																																																							if (BgL_test9922z00_25436)
																																																																								{
																																																																									obj_t
																																																																										BgL_l1443z00_25442;
																																																																									BgL_l1443z00_25442
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_l1443z00_7492));
																																																																									BgL_l1443z00_7492
																																																																										=
																																																																										BgL_l1443z00_25442;
																																																																									goto
																																																																										BgL_zc3z04anonymousza35999ze3z87_7493;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test9920z00_25433
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																						}
																																																																				}
																																																																				if (BgL_test9920z00_25433)
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg5989z00_7475;
																																																																						BgL_arg5989z00_7475
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd245212zd2_7451));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25447;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_25451;
																																																																								obj_t
																																																																									BgL_proc2z00_25450;
																																																																								obj_t
																																																																									BgL_proc1z00_25449;
																																																																								obj_t
																																																																									BgL_testz00_25448;
																																																																								BgL_testz00_25448
																																																																									=
																																																																									BgL_arg5989z00_7475;
																																																																								BgL_proc1z00_25449
																																																																									=
																																																																									BgL_carzd245223zd2_7455;
																																																																								BgL_proc2z00_25450
																																																																									=
																																																																									BgL_carzd245231zd2_7459;
																																																																								BgL_argsz00_25451
																																																																									=
																																																																									BgL_cdrzd245206zd2_7450;
																																																																								BgL_argsz00_1779
																																																																									=
																																																																									BgL_argsz00_25451;
																																																																								BgL_proc2z00_1778
																																																																									=
																																																																									BgL_proc2z00_25450;
																																																																								BgL_proc1z00_1777
																																																																									=
																																																																									BgL_proc1z00_25449;
																																																																								BgL_testz00_1776
																																																																									=
																																																																									BgL_testz00_25448;
																																																																								goto
																																																																									BgL_tagzd2387zd2_1780;
																																																																							}
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25447);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd245255zd2_7476;
																																																																						BgL_cdrzd245255zd2_7476
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd245262zd2_7477;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_pairz00_12643;
																																																																								BgL_pairz00_12643
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								BgL_cdrzd245262zd2_7477
																																																																									=
																																																																									CDR
																																																																									(BgL_pairz00_12643);
																																																																							}
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd245269zd2_7478;
																																																																								BgL_cdrzd245269zd2_7478
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd245262zd2_7477));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd245275zd2_7479;
																																																																									BgL_carzd245275zd2_7479
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd245269zd2_7478));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245275zd2_7479))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd245282zd2_7481;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_12647;
																																																																												BgL_pairz00_12647
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd245269zd2_7478));
																																																																												BgL_carzd245282zd2_7481
																																																																													=
																																																																													CAR
																																																																													(BgL_pairz00_12647);
																																																																											}
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245282zd2_7481))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245255zd2_7476))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg5993z00_7484;
																																																																															BgL_arg5993z00_7484
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd245262zd2_7477));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25473;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_25477;
																																																																																	obj_t
																																																																																		BgL_proc2z00_25476;
																																																																																	obj_t
																																																																																		BgL_proc1z00_25475;
																																																																																	obj_t
																																																																																		BgL_testz00_25474;
																																																																																	BgL_testz00_25474
																																																																																		=
																																																																																		BgL_arg5993z00_7484;
																																																																																	BgL_proc1z00_25475
																																																																																		=
																																																																																		BgL_carzd245275zd2_7479;
																																																																																	BgL_proc2z00_25476
																																																																																		=
																																																																																		BgL_carzd245282zd2_7481;
																																																																																	BgL_argsz00_25477
																																																																																		=
																																																																																		BgL_cdrzd245255zd2_7476;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_25477;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_25476;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_25475;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_25474;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25473);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25481;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25481);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25485;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25485);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25489;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25489);
																																																																												}
																																																																										}
																																																																								}
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_25493;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_22135
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_25493);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd245558zd2_7503;
																																																																		BgL_cdrzd245558zd2_7503
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd245564zd2_7504;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_pairz00_12651;
																																																																				BgL_pairz00_12651
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				BgL_cdrzd245564zd2_7504
																																																																					=
																																																																					CDR
																																																																					(BgL_pairz00_12651);
																																																																			}
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd245570zd2_7505;
																																																																				BgL_cdrzd245570zd2_7505
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd245564zd2_7504));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd245575zd2_7506;
																																																																					obj_t
																																																																						BgL_cdrzd245576zd2_7507;
																																																																					BgL_carzd245575zd2_7506
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7505));
																																																																					BgL_cdrzd245576zd2_7507
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd245570zd2_7505));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245575zd2_7506))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd245581zd2_7509;
																																																																							BgL_carzd245581zd2_7509
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd245576zd2_7507));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245581zd2_7509))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(((obj_t) BgL_cdrzd245576zd2_7507))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245558zd2_7503))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6008z00_7514;
																																																																													BgL_arg6008z00_7514
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd245564zd2_7504));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25520;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_25524;
																																																																															obj_t
																																																																																BgL_proc2z00_25523;
																																																																															obj_t
																																																																																BgL_proc1z00_25522;
																																																																															obj_t
																																																																																BgL_testz00_25521;
																																																																															BgL_testz00_25521
																																																																																=
																																																																																BgL_arg6008z00_7514;
																																																																															BgL_proc1z00_25522
																																																																																=
																																																																																BgL_carzd245575zd2_7506;
																																																																															BgL_proc2z00_25523
																																																																																=
																																																																																BgL_carzd245581zd2_7509;
																																																																															BgL_argsz00_25524
																																																																																=
																																																																																BgL_cdrzd245558zd2_7503;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_25524;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_25523;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_25522;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_25521;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25520);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_25528;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_25528);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25532;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25532);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25536;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25536);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25540;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25540);
																																																																								}
																																																																						}
																																																																				}
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_25544;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_22135
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_25544);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd245914zd2_7522;
																																																														BgL_cdrzd245914zd2_7522
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd245921zd2_7523;
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_pairz00_12661;
																																																																BgL_pairz00_12661
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																BgL_cdrzd245921zd2_7523
																																																																	=
																																																																	CDR
																																																																	(BgL_pairz00_12661);
																																																															}
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd245928zd2_7524;
																																																																BgL_cdrzd245928zd2_7524
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd245921zd2_7523));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd245934zd2_7525;
																																																																	obj_t
																																																																		BgL_cdrzd245935zd2_7526;
																																																																	BgL_carzd245934zd2_7525
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7524));
																																																																	BgL_cdrzd245935zd2_7526
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd245928zd2_7524));
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245934zd2_7525))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd245935zd2_7526))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd245942zd2_7529;
																																																																					BgL_carzd245942zd2_7529
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd245935zd2_7526);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd245942zd2_7529))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd245935zd2_7526)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd245914zd2_7522))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6022z00_7534;
																																																																											BgL_arg6022z00_7534
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd245921zd2_7523));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25571;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25575;
																																																																													obj_t
																																																																														BgL_proc2z00_25574;
																																																																													obj_t
																																																																														BgL_proc1z00_25573;
																																																																													obj_t
																																																																														BgL_testz00_25572;
																																																																													BgL_testz00_25572
																																																																														=
																																																																														BgL_arg6022z00_7534;
																																																																													BgL_proc1z00_25573
																																																																														=
																																																																														BgL_carzd245934zd2_7525;
																																																																													BgL_proc2z00_25574
																																																																														=
																																																																														BgL_carzd245942zd2_7529;
																																																																													BgL_argsz00_25575
																																																																														=
																																																																														BgL_cdrzd245914zd2_7522;
																																																																													BgL_argsz00_1784
																																																																														=
																																																																														BgL_argsz00_25575;
																																																																													BgL_proc2z00_1783
																																																																														=
																																																																														BgL_proc2z00_25574;
																																																																													BgL_proc1z00_1782
																																																																														=
																																																																														BgL_proc1z00_25573;
																																																																													BgL_testz00_1781
																																																																														=
																																																																														BgL_testz00_25572;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1785;
																																																																												}
																																																																												BgL_auxz00_22135
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25571);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_25579;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_25579);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25583;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25583);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_25587;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_25587);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25591;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25591);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_25595;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_25595);
																																																																				}
																																																																		}
																																																																}
																																																															}
																																																														}
																																																													}
																																																											}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25599;
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25599);
																																																												}
																																																										}
																																																								}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd246335zd2_7548;
																																														BgL_cdrzd246335zd2_7548
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9951z00_25603;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6050z00_7565;
																																																BgL_arg6050z00_7565
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9951z00_25603
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6050z00_7565));
																																															}
																																															if (BgL_test9951z00_25603)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg6038z00_7551;
																																																	obj_t
																																																		BgL_arg6039z00_7552;
																																																	BgL_arg6038z00_7551
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7548));
																																																	BgL_arg6039z00_7552
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd246335zd2_7548));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_25612;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_25614;
																																																			obj_t
																																																				BgL_bindingsz00_25613;
																																																			BgL_bindingsz00_25613
																																																				=
																																																				BgL_arg6038z00_7551;
																																																			BgL_exprz00_25614
																																																				=
																																																				BgL_arg6039z00_7552;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_25614;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_25613;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_22135
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_25612);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test9952z00_25616;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6049z00_7564;
																																																		BgL_arg6049z00_7564
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test9952z00_25616
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6049z00_7564));
																																																	}
																																																	if (BgL_test9952z00_25616)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25621;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25621);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd246401zd2_7555;
																																																			BgL_carzd246401zd2_7555
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd246406zd2_7556;
																																																				BgL_cdrzd246406zd2_7556
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd246401zd2_7555));
																																																				if ((CAR(((obj_t) BgL_carzd246401zd2_7555)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg6044z00_7559;
																																																						obj_t
																																																							BgL_arg6045z00_7560;
																																																						obj_t
																																																							BgL_arg6046z00_7561;
																																																						BgL_arg6044z00_7559
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7556));
																																																						BgL_arg6045z00_7560
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd246406zd2_7556));
																																																						BgL_arg6046z00_7561
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25638;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_25641;
																																																								obj_t
																																																									BgL_bodyz00_25640;
																																																								obj_t
																																																									BgL_varsz00_25639;
																																																								BgL_varsz00_25639
																																																									=
																																																									BgL_arg6044z00_7559;
																																																								BgL_bodyz00_25640
																																																									=
																																																									BgL_arg6045z00_7560;
																																																								BgL_argsz00_25641
																																																									=
																																																									BgL_arg6046z00_7561;
																																																								BgL_argsz00_1774
																																																									=
																																																									BgL_argsz00_25641;
																																																								BgL_bodyz00_1773
																																																									=
																																																									BgL_bodyz00_25640;
																																																								BgL_varsz00_1772
																																																									=
																																																									BgL_varsz00_25639;
																																																								goto
																																																									BgL_tagzd2386zd2_1775;
																																																							}
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25638);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1809;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_25645;
																																																								goto
																																																									BgL_tagzd2404zd2_1810;
																																																								BgL_auxz00_22135
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_25645);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd246517zd2_7566;
																																												BgL_cdrzd246517zd2_7566
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test9955z00_25649;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6059z00_7575;
																																														BgL_arg6059z00_7575
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test9955z00_25649
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6059z00_7575));
																																													}
																																													if (BgL_test9955z00_25649)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6053z00_7569;
																																															obj_t
																																																BgL_arg6054z00_7570;
																																															BgL_arg6053z00_7569
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7566));
																																															BgL_arg6054z00_7570
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd246517zd2_7566));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_25658;
																																																{
																																																	obj_t
																																																		BgL_exprz00_25660;
																																																	obj_t
																																																		BgL_bindingsz00_25659;
																																																	BgL_bindingsz00_25659
																																																		=
																																																		BgL_arg6053z00_7569;
																																																	BgL_exprz00_25660
																																																		=
																																																		BgL_arg6054z00_7570;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_25660;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_25659;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_22135
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_25658);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test9956z00_25662;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6058z00_7574;
																																																BgL_arg6058z00_7574
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test9956z00_25662
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6058z00_7574));
																																															}
																																															if (BgL_test9956z00_25662)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25667;
																																																	goto
																																																		BgL_tagzd2384zd2_1767;
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25667);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1809;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_25671;
																																																			goto
																																																				BgL_tagzd2404zd2_1810;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25671);
																																																		}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245082zd2_7302)))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd245084zd2_7304;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd245082zd2_7302 == CNST_TABLE_REF(((long) 18))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd245084zd2_7304;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if ((BgL_carzd245082zd2_7302 == CNST_TABLE_REF(((long) 19))))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd245084zd2_7304;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd245082zd2_7302)))
																																																	{	/* Ast/sexp.scm 119 */
																																																		goto
																																																			BgL_kapzd245084zd2_7304;
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd246689zd2_7310;
																																																		BgL_cdrzd246689zd2_7310
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test9962z00_25687;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg5959z00_7427;
																																																				BgL_arg5959z00_7427
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test9962z00_25687
																																																					=
																																																					CBOOL
																																																					(BGl_letzd2symzf3z21zzast_letz00
																																																					(BgL_arg5959z00_7427));
																																																			}
																																																			if (BgL_test9962z00_25687)
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg5887z00_7313;
																																																					obj_t
																																																						BgL_arg5888z00_7314;
																																																					BgL_arg5887z00_7313
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7310));
																																																					BgL_arg5888z00_7314
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd246689zd2_7310));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_25696;
																																																						{
																																																							obj_t
																																																								BgL_exprz00_25698;
																																																							obj_t
																																																								BgL_bindingsz00_25697;
																																																							BgL_bindingsz00_25697
																																																								=
																																																								BgL_arg5887z00_7313;
																																																							BgL_exprz00_25698
																																																								=
																																																								BgL_arg5888z00_7314;
																																																							BgL_exprz00_1764
																																																								=
																																																								BgL_exprz00_25698;
																																																							BgL_bindingsz00_1763
																																																								=
																																																								BgL_bindingsz00_25697;
																																																							goto
																																																								BgL_tagzd2382zd2_1765;
																																																						}
																																																						BgL_auxz00_22135
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_25696);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					bool_t
																																																						BgL_test9963z00_25700;
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg5958z00_7426;
																																																						BgL_arg5958z00_7426
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						BgL_test9963z00_25700
																																																							=
																																																							CBOOL
																																																							(BGl_labelszd2symzf3z21zzast_labelsz00
																																																							(BgL_arg5958z00_7426));
																																																					}
																																																					if (BgL_test9963z00_25700)
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_25705;
																																																							goto
																																																								BgL_tagzd2384zd2_1767;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25705);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd246755zd2_7317;
																																																							BgL_carzd246755zd2_7317
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd246760zd2_7318;
																																																								BgL_cdrzd246760zd2_7318
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd246755zd2_7317));
																																																								if ((CAR(((obj_t) BgL_carzd246755zd2_7317)) == CNST_TABLE_REF(((long) 3))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd246760zd2_7318))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg5894z00_7322;
																																																												obj_t
																																																													BgL_arg5895z00_7323;
																																																												obj_t
																																																													BgL_arg5896z00_7324;
																																																												BgL_arg5894z00_7322
																																																													=
																																																													CAR
																																																													(BgL_cdrzd246760zd2_7318);
																																																												BgL_arg5895z00_7323
																																																													=
																																																													CDR
																																																													(BgL_cdrzd246760zd2_7318);
																																																												BgL_arg5896z00_7324
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_25722;
																																																													{
																																																														obj_t
																																																															BgL_argsz00_25725;
																																																														obj_t
																																																															BgL_bodyz00_25724;
																																																														obj_t
																																																															BgL_varsz00_25723;
																																																														BgL_varsz00_25723
																																																															=
																																																															BgL_arg5894z00_7322;
																																																														BgL_bodyz00_25724
																																																															=
																																																															BgL_arg5895z00_7323;
																																																														BgL_argsz00_25725
																																																															=
																																																															BgL_arg5896z00_7324;
																																																														BgL_argsz00_1774
																																																															=
																																																															BgL_argsz00_25725;
																																																														BgL_bodyz00_1773
																																																															=
																																																															BgL_bodyz00_25724;
																																																														BgL_varsz00_1772
																																																															=
																																																															BgL_varsz00_25723;
																																																														goto
																																																															BgL_tagzd2386zd2_1775;
																																																													}
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_25722);
																																																												}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_25729;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_22135
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_25729);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd246867zd2_7327;
																																																										BgL_cdrzd246867zd2_7327
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_expz00_21));
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd246872zd2_7328;
																																																											BgL_cdrzd246872zd2_7328
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd246755zd2_7317));
																																																											if ((CAR(((obj_t) BgL_carzd246755zd2_7317)) == CNST_TABLE_REF(((long) 1))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd246872zd2_7328))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd246877zd2_7332;
																																																															BgL_cdrzd246877zd2_7332
																																																																=
																																																																CDR
																																																																(BgL_cdrzd246872zd2_7328);
																																																															if (PAIRP(BgL_cdrzd246877zd2_7332))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_carzd246881zd2_7334;
																																																																	obj_t
																																																																		BgL_cdrzd246882zd2_7335;
																																																																	BgL_carzd246881zd2_7334
																																																																		=
																																																																		CAR
																																																																		(BgL_cdrzd246877zd2_7332);
																																																																	BgL_cdrzd246882zd2_7335
																																																																		=
																																																																		CDR
																																																																		(BgL_cdrzd246877zd2_7332);
																																																																	if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246881zd2_7334))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd246882zd2_7335))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd246887zd2_7338;
																																																																					BgL_carzd246887zd2_7338
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd246882zd2_7335);
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246887zd2_7338))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd246882zd2_7335)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test9974z00_25757;
																																																																									{
																																																																										obj_t
																																																																											BgL_l1446z00_7371;
																																																																										BgL_l1446z00_7371
																																																																											=
																																																																											BgL_cdrzd246867zd2_7327;
																																																																									BgL_zc3z04anonymousza35922ze3z87_7372:
																																																																										if (NULLP(BgL_l1446z00_7371))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test9974z00_25757
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												bool_t
																																																																													BgL_test9976z00_25760;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													bool_t
																																																																														BgL_test9977z00_25761;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_tmpz00_25762;
																																																																														BgL_tmpz00_25762
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_l1446z00_7371));
																																																																														BgL_test9977z00_25761
																																																																															=
																																																																															PAIRP
																																																																															(BgL_tmpz00_25762);
																																																																													}
																																																																													if (BgL_test9977z00_25761)
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9976z00_25760
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																0);
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															BgL_test9976z00_25760
																																																																																=
																																																																																(
																																																																																(bool_t)
																																																																																1);
																																																																														}
																																																																												}
																																																																												if (BgL_test9976z00_25760)
																																																																													{
																																																																														obj_t
																																																																															BgL_l1446z00_25766;
																																																																														BgL_l1446z00_25766
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_l1446z00_7371));
																																																																														BgL_l1446z00_7371
																																																																															=
																																																																															BgL_l1446z00_25766;
																																																																														goto
																																																																															BgL_zc3z04anonymousza35922ze3z87_7372;
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														BgL_test9974z00_25757
																																																																															=
																																																																															(
																																																																															(bool_t)
																																																																															0);
																																																																													}
																																																																											}
																																																																									}
																																																																									if (BgL_test9974z00_25757)
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg5912z00_7354;
																																																																											BgL_arg5912z00_7354
																																																																												=
																																																																												CAR
																																																																												(BgL_cdrzd246872zd2_7328);
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25770;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_25774;
																																																																													obj_t
																																																																														BgL_proc2z00_25773;
																																																																													obj_t
																																																																														BgL_proc1z00_25772;
																																																																													obj_t
																																																																														BgL_testz00_25771;
																																																																													BgL_testz00_25771
																																																																														=
																																																																														BgL_arg5912z00_7354;
																																																																													BgL_proc1z00_25772
																																																																														=
																																																																														BgL_carzd246881zd2_7334;
																																																																													BgL_proc2z00_25773
																																																																														=
																																																																														BgL_carzd246887zd2_7338;
																																																																													BgL_argsz00_25774
																																																																														=
																																																																														BgL_cdrzd246867zd2_7327;
																																																																													BgL_argsz00_1779
																																																																														=
																																																																														BgL_argsz00_25774;
																																																																													BgL_proc2z00_1778
																																																																														=
																																																																														BgL_proc2z00_25773;
																																																																													BgL_proc1z00_1777
																																																																														=
																																																																														BgL_proc1z00_25772;
																																																																													BgL_testz00_1776
																																																																														=
																																																																														BgL_testz00_25771;
																																																																													goto
																																																																														BgL_tagzd2387zd2_1780;
																																																																												}
																																																																												BgL_auxz00_22135
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25770);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd246912zd2_7355;
																																																																											BgL_cdrzd246912zd2_7355
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd246920zd2_7356;
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_pairz00_12718;
																																																																													BgL_pairz00_12718
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_expz00_21));
																																																																													BgL_cdrzd246920zd2_7356
																																																																														=
																																																																														CDR
																																																																														(BgL_pairz00_12718);
																																																																												}
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd246928zd2_7357;
																																																																													BgL_cdrzd246928zd2_7357
																																																																														=
																																																																														CDR
																																																																														(
																																																																														((obj_t) BgL_cdrzd246920zd2_7356));
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_carzd246935zd2_7358;
																																																																														BgL_carzd246935zd2_7358
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd246928zd2_7357));
																																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246935zd2_7358))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_carzd246944zd2_7360;
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_pairz00_12722;
																																																																																	BgL_pairz00_12722
																																																																																		=
																																																																																		CDR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd246928zd2_7357));
																																																																																	BgL_carzd246944zd2_7360
																																																																																		=
																																																																																		CAR
																																																																																		(BgL_pairz00_12722);
																																																																																}
																																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd246944zd2_7360))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd246912zd2_7355))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				obj_t
																																																																																					BgL_arg5916z00_7363;
																																																																																				BgL_arg5916z00_7363
																																																																																					=
																																																																																					CAR
																																																																																					(
																																																																																					((obj_t) BgL_cdrzd246920zd2_7356));
																																																																																				{
																																																																																					BgL_nodez00_bglt
																																																																																						BgL_auxz00_25796;
																																																																																					{
																																																																																						obj_t
																																																																																							BgL_argsz00_25800;
																																																																																						obj_t
																																																																																							BgL_proc2z00_25799;
																																																																																						obj_t
																																																																																							BgL_proc1z00_25798;
																																																																																						obj_t
																																																																																							BgL_testz00_25797;
																																																																																						BgL_testz00_25797
																																																																																							=
																																																																																							BgL_arg5916z00_7363;
																																																																																						BgL_proc1z00_25798
																																																																																							=
																																																																																							BgL_carzd246935zd2_7358;
																																																																																						BgL_proc2z00_25799
																																																																																							=
																																																																																							BgL_carzd246944zd2_7360;
																																																																																						BgL_argsz00_25800
																																																																																							=
																																																																																							BgL_cdrzd246912zd2_7355;
																																																																																						BgL_argsz00_1784
																																																																																							=
																																																																																							BgL_argsz00_25800;
																																																																																						BgL_proc2z00_1783
																																																																																							=
																																																																																							BgL_proc2z00_25799;
																																																																																						BgL_proc1z00_1782
																																																																																							=
																																																																																							BgL_proc1z00_25798;
																																																																																						BgL_testz00_1781
																																																																																							=
																																																																																							BgL_testz00_25797;
																																																																																						goto
																																																																																							BgL_tagzd2388zd2_1785;
																																																																																					}
																																																																																					BgL_auxz00_22135
																																																																																						=
																																																																																						(
																																																																																						(obj_t)
																																																																																						BgL_auxz00_25796);
																																																																																				}
																																																																																			}
																																																																																		else
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																					{	/* Ast/sexp.scm 119 */
																																																																																						goto
																																																																																							BgL_tagzd2403zd2_1809;
																																																																																					}
																																																																																				else
																																																																																					{
																																																																																						BgL_nodez00_bglt
																																																																																							BgL_auxz00_25804;
																																																																																						goto
																																																																																							BgL_tagzd2404zd2_1810;
																																																																																						BgL_auxz00_22135
																																																																																							=
																																																																																							(
																																																																																							(obj_t)
																																																																																							BgL_auxz00_25804);
																																																																																					}
																																																																																			}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25808;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25808);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25812;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25812);
																																																																																	}
																																																																															}
																																																																													}
																																																																												}
																																																																											}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_25816;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_25816);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd247222zd2_7382;
																																																																							BgL_cdrzd247222zd2_7382
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd247229zd2_7383;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12726;
																																																																									BgL_pairz00_12726
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd247229zd2_7383
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12726);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd247236zd2_7384;
																																																																									BgL_cdrzd247236zd2_7384
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd247229zd2_7383));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd247242zd2_7385;
																																																																										obj_t
																																																																											BgL_cdrzd247243zd2_7386;
																																																																										BgL_carzd247242zd2_7385
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7384));
																																																																										BgL_cdrzd247243zd2_7386
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd247236zd2_7384));
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247242zd2_7385))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_carzd247250zd2_7388;
																																																																												BgL_carzd247250zd2_7388
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd247243zd2_7386));
																																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247250zd2_7388))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (NULLP(CDR(((obj_t) BgL_cdrzd247243zd2_7386))))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247222zd2_7382))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		obj_t
																																																																																			BgL_arg5931z00_7393;
																																																																																		BgL_arg5931z00_7393
																																																																																			=
																																																																																			CAR
																																																																																			(
																																																																																			((obj_t) BgL_cdrzd247229zd2_7383));
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_25843;
																																																																																			{
																																																																																				obj_t
																																																																																					BgL_argsz00_25847;
																																																																																				obj_t
																																																																																					BgL_proc2z00_25846;
																																																																																				obj_t
																																																																																					BgL_proc1z00_25845;
																																																																																				obj_t
																																																																																					BgL_testz00_25844;
																																																																																				BgL_testz00_25844
																																																																																					=
																																																																																					BgL_arg5931z00_7393;
																																																																																				BgL_proc1z00_25845
																																																																																					=
																																																																																					BgL_carzd247242zd2_7385;
																																																																																				BgL_proc2z00_25846
																																																																																					=
																																																																																					BgL_carzd247250zd2_7388;
																																																																																				BgL_argsz00_25847
																																																																																					=
																																																																																					BgL_cdrzd247222zd2_7382;
																																																																																				BgL_argsz00_1784
																																																																																					=
																																																																																					BgL_argsz00_25847;
																																																																																				BgL_proc2z00_1783
																																																																																					=
																																																																																					BgL_proc2z00_25846;
																																																																																				BgL_proc1z00_1782
																																																																																					=
																																																																																					BgL_proc1z00_25845;
																																																																																				BgL_testz00_1781
																																																																																					=
																																																																																					BgL_testz00_25844;
																																																																																				goto
																																																																																					BgL_tagzd2388zd2_1785;
																																																																																			}
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_25843);
																																																																																		}
																																																																																	}
																																																																																else
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																			{	/* Ast/sexp.scm 119 */
																																																																																				goto
																																																																																					BgL_tagzd2403zd2_1809;
																																																																																			}
																																																																																		else
																																																																																			{
																																																																																				BgL_nodez00_bglt
																																																																																					BgL_auxz00_25851;
																																																																																				goto
																																																																																					BgL_tagzd2404zd2_1810;
																																																																																				BgL_auxz00_22135
																																																																																					=
																																																																																					(
																																																																																					(obj_t)
																																																																																					BgL_auxz00_25851);
																																																																																			}
																																																																																	}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25855;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25855);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25859;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25859);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25863;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25863);
																																																																													}
																																																																											}
																																																																									}
																																																																								}
																																																																							}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_25867;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_25867);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd247583zd2_7401;
																																																																			BgL_cdrzd247583zd2_7401
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd247589zd2_7402;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_12736;
																																																																					BgL_pairz00_12736
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd247589zd2_7402
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12736);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd247595zd2_7403;
																																																																					BgL_cdrzd247595zd2_7403
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd247589zd2_7402));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd247600zd2_7404;
																																																																						obj_t
																																																																							BgL_cdrzd247601zd2_7405;
																																																																						BgL_carzd247600zd2_7404
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7403));
																																																																						BgL_cdrzd247601zd2_7405
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd247595zd2_7403));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247600zd2_7404))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (PAIRP(BgL_cdrzd247601zd2_7405))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd247606zd2_7408;
																																																																										BgL_carzd247606zd2_7408
																																																																											=
																																																																											CAR
																																																																											(BgL_cdrzd247601zd2_7405);
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd247606zd2_7408))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (NULLP(CDR(BgL_cdrzd247601zd2_7405)))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd247583zd2_7401))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg5945z00_7413;
																																																																																BgL_arg5945z00_7413
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd247589zd2_7402));
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_25894;
																																																																																	{
																																																																																		obj_t
																																																																																			BgL_argsz00_25898;
																																																																																		obj_t
																																																																																			BgL_proc2z00_25897;
																																																																																		obj_t
																																																																																			BgL_proc1z00_25896;
																																																																																		obj_t
																																																																																			BgL_testz00_25895;
																																																																																		BgL_testz00_25895
																																																																																			=
																																																																																			BgL_arg5945z00_7413;
																																																																																		BgL_proc1z00_25896
																																																																																			=
																																																																																			BgL_carzd247600zd2_7404;
																																																																																		BgL_proc2z00_25897
																																																																																			=
																																																																																			BgL_carzd247606zd2_7408;
																																																																																		BgL_argsz00_25898
																																																																																			=
																																																																																			BgL_cdrzd247583zd2_7401;
																																																																																		BgL_argsz00_1784
																																																																																			=
																																																																																			BgL_argsz00_25898;
																																																																																		BgL_proc2z00_1783
																																																																																			=
																																																																																			BgL_proc2z00_25897;
																																																																																		BgL_proc1z00_1782
																																																																																			=
																																																																																			BgL_proc1z00_25896;
																																																																																		BgL_testz00_1781
																																																																																			=
																																																																																			BgL_testz00_25895;
																																																																																		goto
																																																																																			BgL_tagzd2388zd2_1785;
																																																																																	}
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_25894);
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																	{	/* Ast/sexp.scm 119 */
																																																																																		goto
																																																																																			BgL_tagzd2403zd2_1809;
																																																																																	}
																																																																																else
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_25902;
																																																																																		goto
																																																																																			BgL_tagzd2404zd2_1810;
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_25902);
																																																																																	}
																																																																															}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																															}
																																																																														else
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_25906;
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_25906);
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_25910;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_25910);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_25914;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_22135
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_25914);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_25918;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_22135
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_25918);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_25922;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_25922);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_25926;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_25926);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_25930;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_25930);
																																																														}
																																																												}
																																																										}
																																																									}
																																																							}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																											}
																																									}
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((BgL_carzd245079zd2_7300 == CNST_TABLE_REF(((long) 17))))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6061z00_7579;
																																									obj_t
																																										BgL_arg6062z00_7580;
																																									BgL_arg6061z00_7579
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7284));
																																									BgL_arg6062z00_7580
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd244978zd2_7284));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_25939;
																																										{
																																											obj_t
																																												BgL_exprz00_25941;
																																											obj_t
																																												BgL_bindingsz00_25940;
																																											BgL_bindingsz00_25940
																																												=
																																												BgL_arg6061z00_7579;
																																											BgL_exprz00_25941
																																												=
																																												BgL_arg6062z00_7580;
																																											BgL_exprz00_1764
																																												=
																																												BgL_exprz00_25941;
																																											BgL_bindingsz00_1763
																																												=
																																												BgL_bindingsz00_25940;
																																											goto
																																												BgL_tagzd2382zd2_1765;
																																										}
																																										BgL_auxz00_22135
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_25939);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd245079zd2_7300)))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6064z00_7582;
																																											obj_t
																																												BgL_arg6065z00_7583;
																																											BgL_arg6064z00_7582
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7284));
																																											BgL_arg6065z00_7583
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd244978zd2_7284));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_25950;
																																												{
																																													obj_t
																																														BgL_exprz00_25952;
																																													obj_t
																																														BgL_bindingsz00_25951;
																																													BgL_bindingsz00_25951
																																														=
																																														BgL_arg6064z00_7582;
																																													BgL_exprz00_25952
																																														=
																																														BgL_arg6065z00_7583;
																																													BgL_exprz00_1764
																																														=
																																														BgL_exprz00_25952;
																																													BgL_bindingsz00_1763
																																														=
																																														BgL_bindingsz00_25951;
																																													goto
																																														BgL_tagzd2382zd2_1765;
																																												}
																																												BgL_auxz00_22135
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_25950);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((BgL_carzd245079zd2_7300 == CNST_TABLE_REF(((long) 18))))
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6067z00_7585;
																																													obj_t
																																														BgL_arg6068z00_7586;
																																													BgL_arg6067z00_7585
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7284));
																																													BgL_arg6068z00_7586
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd244978zd2_7284));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_25961;
																																														{
																																															obj_t
																																																BgL_exprz00_25963;
																																															obj_t
																																																BgL_bindingsz00_25962;
																																															BgL_bindingsz00_25962
																																																=
																																																BgL_arg6067z00_7585;
																																															BgL_exprz00_25963
																																																=
																																																BgL_arg6068z00_7586;
																																															BgL_exprz00_1764
																																																=
																																																BgL_exprz00_25963;
																																															BgL_bindingsz00_1763
																																																=
																																																BgL_bindingsz00_25962;
																																															goto
																																																BgL_tagzd2382zd2_1765;
																																														}
																																														BgL_auxz00_22135
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_25961);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_25970;
																																															goto
																																																BgL_tagzd2383zd2_1766;
																																															BgL_auxz00_22135
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_25970);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_carzd248181zd2_7589;
																																															BgL_carzd248181zd2_7589
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															if ((BgL_carzd248181zd2_7589 == CNST_TABLE_REF(((long) 19))))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_25977;
																																																	goto
																																																		BgL_tagzd2384zd2_1767;
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_25977);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248181zd2_7589)))
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_25982;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_25982);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_25989;
																																																					goto
																																																						BgL_tagzd2389zd2_1786;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_25989);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_25996;
																																																							goto
																																																								BgL_tagzd2390zd2_1787;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_25996);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd248261zd2_7596;
																																																							BgL_cdrzd248261zd2_7596
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg6079z00_7599;
																																																									obj_t
																																																										BgL_arg6080z00_7600;
																																																									BgL_arg6079z00_7599
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7596));
																																																									BgL_arg6080z00_7600
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248261zd2_7596));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_26009;
																																																										{
																																																											obj_t
																																																												BgL_restz00_26011;
																																																											obj_t
																																																												BgL_effectz00_26010;
																																																											BgL_effectz00_26010
																																																												=
																																																												BgL_arg6079z00_7599;
																																																											BgL_restz00_26011
																																																												=
																																																												BgL_arg6080z00_7600;
																																																											BgL_restz00_1789
																																																												=
																																																												BgL_restz00_26011;
																																																											BgL_effectz00_1788
																																																												=
																																																												BgL_effectz00_26010;
																																																											goto
																																																												BgL_tagzd2391zd2_1790;
																																																										}
																																																										BgL_auxz00_22135
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_26009);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26018;
																																																											goto
																																																												BgL_tagzd2392zd2_1791;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26018);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_26025;
																																																													goto
																																																														BgL_tagzd2393zd2_1792;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_26025);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6087z00_7608;
																																																															obj_t
																																																																BgL_arg6088z00_7609;
																																																															BgL_arg6087z00_7608
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7596));
																																																															BgL_arg6088z00_7609
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd248261zd2_7596));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26036;
																																																																{
																																																																	obj_t
																																																																		BgL_restz00_26038;
																																																																	obj_t
																																																																		BgL_effectz00_26037;
																																																																	BgL_effectz00_26037
																																																																		=
																																																																		BgL_arg6087z00_7608;
																																																																	BgL_restz00_26038
																																																																		=
																																																																		BgL_arg6088z00_7609;
																																																																	BgL_restz00_1794
																																																																		=
																																																																		BgL_restz00_26038;
																																																																	BgL_effectz00_1793
																																																																		=
																																																																		BgL_effectz00_26037;
																																																																	goto
																																																																		BgL_tagzd2394zd2_1795;
																																																																}
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26036);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_26045;
																																																																	goto
																																																																		BgL_tagzd2395zd2_1796;
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_26045);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_26052;
																																																																			goto
																																																																				BgL_tagzd2396zd2_1797;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26052);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																				{
																																																																					BgL_letzd2funzd2_bglt
																																																																						BgL_auxz00_26059;
																																																																					goto
																																																																						BgL_tagzd2397zd2_1798;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26059);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																						{
																																																																							BgL_jumpzd2exzd2itz00_bglt
																																																																								BgL_auxz00_26066;
																																																																							goto
																																																																								BgL_tagzd2398zd2_1799;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26066);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 30))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test10024z00_26073;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_tmpz00_26074;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12774;
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_pairz00_12773;
																																																																												BgL_pairz00_12773
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_expz00_21));
																																																																												BgL_pairz00_12774
																																																																													=
																																																																													CDR
																																																																													(BgL_pairz00_12773);
																																																																											}
																																																																											BgL_tmpz00_26074
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12774);
																																																																										}
																																																																										BgL_test10024z00_26073
																																																																											=
																																																																											NULLP
																																																																											(BgL_tmpz00_26074);
																																																																									}
																																																																									if (BgL_test10024z00_26073)
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26080;
																																																																											goto
																																																																												BgL_tagzd2399zd2_1800;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26080);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26084;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26084);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd248349zd2_7628;
																																																																									BgL_cdrzd248349zd2_7628
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd248355zd2_7631;
																																																																											BgL_cdrzd248355zd2_7631
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248349zd2_7628));
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_cdrzd248361zd2_7632;
																																																																												BgL_cdrzd248361zd2_7632
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd248355zd2_7631));
																																																																												if ((CAR(((obj_t) BgL_cdrzd248355zd2_7631)) == CNST_TABLE_REF(((long) 31))))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (PAIRP(BgL_cdrzd248361zd2_7632))
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg6112z00_7636;
																																																																																obj_t
																																																																																	BgL_arg6113z00_7637;
																																																																																obj_t
																																																																																	BgL_arg6114z00_7638;
																																																																																BgL_arg6112z00_7636
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7628));
																																																																																BgL_arg6113z00_7637
																																																																																	=
																																																																																	CAR
																																																																																	(BgL_cdrzd248361zd2_7632);
																																																																																BgL_arg6114z00_7638
																																																																																	=
																																																																																	CDR
																																																																																	(BgL_cdrzd248361zd2_7632);
																																																																																{	/* Ast/sexp.scm 553 */
																																																																																	obj_t
																																																																																		BgL_arg7014z00_12785;
																																																																																	BgL_arg7014z00_12785
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6112z00_7636,
																																																																																			BgL_arg6113z00_7637,
																																																																																			BgL_arg6114z00_7638,
																																																																																			BgL_stackz00_22,
																																																																																			BgL_arg7014z00_12785,
																																																																																			BgL_sitez00_24));
																																																																																}
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																obj_t
																																																																																	BgL_arg6115z00_7640;
																																																																																obj_t
																																																																																	BgL_arg6116z00_7641;
																																																																																BgL_arg6115z00_7640
																																																																																	=
																																																																																	CAR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7628));
																																																																																BgL_arg6116z00_7641
																																																																																	=
																																																																																	CDR
																																																																																	(
																																																																																	((obj_t) BgL_cdrzd248349zd2_7628));
																																																																																{	/* Ast/sexp.scm 555 */
																																																																																	obj_t
																																																																																		BgL_arg7015z00_12789;
																																																																																	BgL_arg7015z00_12789
																																																																																		=
																																																																																		BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																		(BgL_expz00_21,
																																																																																		BgL_locz00_23);
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																		(BgL_expz00_21,
																																																																																			BgL_arg6115z00_7640,
																																																																																			CNST_TABLE_REF
																																																																																			(((long) 4)), BgL_arg6116z00_7641, BgL_stackz00_22, BgL_arg7015z00_12789, BgL_sitez00_24));
																																																																													}}}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg6117z00_7643;
																																																																														obj_t
																																																																															BgL_arg6118z00_7644;
																																																																														BgL_arg6117z00_7643
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7628));
																																																																														BgL_arg6118z00_7644
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd248349zd2_7628));
																																																																														{	/* Ast/sexp.scm 555 */
																																																																															obj_t
																																																																																BgL_arg7015z00_12793;
																																																																															BgL_arg7015z00_12793
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																	BgL_arg6117z00_7643,
																																																																																	CNST_TABLE_REF
																																																																																	(((long) 4)), BgL_arg6118z00_7644, BgL_stackz00_22, BgL_arg7015z00_12793, BgL_sitez00_24));
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26129;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26129);
																																																																												}
																																																																										}
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_carzd248412zd2_7663;
																											BgL_carzd248412zd2_7663 =
																												CAR(((obj_t)
																													BgL_expz00_21));
																											if (
																												(BgL_carzd248412zd2_7663
																													==
																													CNST_TABLE_REF(((long)
																															1))))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_26136;
																													goto
																														BgL_tagzd2377zd2_1754;
																													BgL_auxz00_22135 =
																														((obj_t)
																														BgL_auxz00_26136);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(BgL_carzd248412zd2_7663
																															==
																															BGl_za2ifza2z00zzast_sexpz00))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_26140;
																															goto
																																BgL_tagzd2377zd2_1754;
																															BgL_auxz00_22135 =
																																((obj_t)
																																BgL_auxz00_26140);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long) 7))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_26147;
																																	goto
																																		BgL_tagzd2379zd2_1758;
																																	BgL_auxz00_22135
																																		=
																																		((obj_t)
																																		BgL_auxz00_26147);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR(
																																				((obj_t)
																																					BgL_expz00_21))
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					16))))
																																		{
																																			BgL_nodez00_bglt
																																				BgL_auxz00_26154;
																																			goto
																																				BgL_tagzd2380zd2_1759;
																																			BgL_auxz00_22135
																																				=
																																				((obj_t)
																																				BgL_auxz00_26154);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd248481zd2_7670;
																																			BgL_carzd248481zd2_7670
																																				=
																																				CAR((
																																					(obj_t)
																																					BgL_expz00_21));
																																			if (PAIRP
																																				(BgL_carzd248481zd2_7670))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd248484zd2_7672;
																																					obj_t
																																						BgL_cdrzd248485zd2_7673;
																																					BgL_carzd248484zd2_7672
																																						=
																																						CAR
																																						(BgL_carzd248481zd2_7670);
																																					BgL_cdrzd248485zd2_7673
																																						=
																																						CDR
																																						(BgL_carzd248481zd2_7670);
																																					{

																																						if (
																																							(BgL_carzd248484zd2_7672
																																								==
																																								CNST_TABLE_REF
																																								(((long) 17))))
																																							{	/* Ast/sexp.scm 119 */
																																							BgL_kapzd248486zd2_7674:
																																								if (PAIRP(BgL_cdrzd248485zd2_7673))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd248489zd2_7856;
																																										BgL_cdrzd248489zd2_7856
																																											=
																																											CDR
																																											(BgL_cdrzd248485zd2_7673);
																																										if (PAIRP(BgL_cdrzd248489zd2_7856))
																																											{	/* Ast/sexp.scm 119 */
																																												if (NULLP(CDR(BgL_cdrzd248489zd2_7856)))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6272z00_7860;
																																														obj_t
																																															BgL_arg6273z00_7861;
																																														BgL_arg6272z00_7860
																																															=
																																															CAR
																																															(BgL_cdrzd248489zd2_7856);
																																														BgL_arg6273z00_7861
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_26176;
																																															{
																																																obj_t
																																																	BgL_argsz00_26178;
																																																obj_t
																																																	BgL_bodyz00_26177;
																																																BgL_bodyz00_26177
																																																	=
																																																	BgL_arg6272z00_7860;
																																																BgL_argsz00_26178
																																																	=
																																																	BgL_arg6273z00_7861;
																																																BgL_argsz00_1761
																																																	=
																																																	BgL_argsz00_26178;
																																																BgL_bodyz00_1760
																																																	=
																																																	BgL_bodyz00_26177;
																																																goto
																																																	BgL_tagzd2381zd2_1762;
																																															}
																																															BgL_auxz00_22135
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26176);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_cdrzd248513zd2_7862;
																																														BgL_cdrzd248513zd2_7862
																																															=
																																															CDR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test10039z00_26182;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6342z00_7973;
																																																BgL_arg6342z00_7973
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test10039z00_26182
																																																	=
																																																	CBOOL
																																																	(BGl_letzd2symzf3z21zzast_letz00
																																																	(BgL_arg6342z00_7973));
																																															}
																																															if (BgL_test10039z00_26182)
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg6276z00_7865;
																																																	obj_t
																																																		BgL_arg6277z00_7866;
																																																	BgL_arg6276z00_7865
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7862));
																																																	BgL_arg6277z00_7866
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd248513zd2_7862));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_26191;
																																																		{
																																																			obj_t
																																																				BgL_exprz00_26193;
																																																			obj_t
																																																				BgL_bindingsz00_26192;
																																																			BgL_bindingsz00_26192
																																																				=
																																																				BgL_arg6276z00_7865;
																																																			BgL_exprz00_26193
																																																				=
																																																				BgL_arg6277z00_7866;
																																																			BgL_exprz00_1764
																																																				=
																																																				BgL_exprz00_26193;
																																																			BgL_bindingsz00_1763
																																																				=
																																																				BgL_bindingsz00_26192;
																																																			goto
																																																				BgL_tagzd2382zd2_1765;
																																																		}
																																																		BgL_auxz00_22135
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_26191);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test10040z00_26195;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6341z00_7972;
																																																		BgL_arg6341z00_7972
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test10040z00_26195
																																																			=
																																																			CBOOL
																																																			(BGl_labelszd2symzf3z21zzast_labelsz00
																																																			(BgL_arg6341z00_7972));
																																																	}
																																																	if (BgL_test10040z00_26195)
																																																		{
																																																			BgL_letzd2funzd2_bglt
																																																				BgL_auxz00_26200;
																																																			goto
																																																				BgL_tagzd2384zd2_1767;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26200);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_carzd248580zd2_7869;
																																																			BgL_carzd248580zd2_7869
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd248585zd2_7870;
																																																				BgL_cdrzd248585zd2_7870
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd248580zd2_7869));
																																																				if ((CAR(((obj_t) BgL_carzd248580zd2_7869)) == CNST_TABLE_REF(((long) 3))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_arg6282z00_7873;
																																																						obj_t
																																																							BgL_arg6283z00_7874;
																																																						obj_t
																																																							BgL_arg6284z00_7875;
																																																						BgL_arg6282z00_7873
																																																							=
																																																							CAR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7870));
																																																						BgL_arg6283z00_7874
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd248585zd2_7870));
																																																						BgL_arg6284z00_7875
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_26217;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_26220;
																																																								obj_t
																																																									BgL_bodyz00_26219;
																																																								obj_t
																																																									BgL_varsz00_26218;
																																																								BgL_varsz00_26218
																																																									=
																																																									BgL_arg6282z00_7873;
																																																								BgL_bodyz00_26219
																																																									=
																																																									BgL_arg6283z00_7874;
																																																								BgL_argsz00_26220
																																																									=
																																																									BgL_arg6284z00_7875;
																																																								BgL_argsz00_1774
																																																									=
																																																									BgL_argsz00_26220;
																																																								BgL_bodyz00_1773
																																																									=
																																																									BgL_bodyz00_26219;
																																																								BgL_varsz00_1772
																																																									=
																																																									BgL_varsz00_26218;
																																																								goto
																																																									BgL_tagzd2386zd2_1775;
																																																							}
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_26217);
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd248608zd2_7877;
																																																						BgL_cdrzd248608zd2_7877
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_expz00_21));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd248614zd2_7878;
																																																							BgL_cdrzd248614zd2_7878
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_carzd248580zd2_7869));
																																																							if ((CAR(((obj_t) BgL_carzd248580zd2_7869)) == CNST_TABLE_REF(((long) 1))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd248620zd2_7881;
																																																									BgL_cdrzd248620zd2_7881
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd248614zd2_7878));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd248625zd2_7882;
																																																										obj_t
																																																											BgL_cdrzd248626zd2_7883;
																																																										BgL_carzd248625zd2_7882
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7881));
																																																										BgL_cdrzd248626zd2_7883
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd248620zd2_7881));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248625zd2_7882))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd248626zd2_7883))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd248633zd2_7886;
																																																														BgL_carzd248633zd2_7886
																																																															=
																																																															CAR
																																																															(BgL_cdrzd248626zd2_7883);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248633zd2_7886))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd248626zd2_7883)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test10047z00_26247;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1449z00_7919;
																																																																			BgL_l1449z00_7919
																																																																				=
																																																																				BgL_cdrzd248608zd2_7877;
																																																																		BgL_zc3z04anonymousza36307ze3z87_7920:
																																																																			if (NULLP(BgL_l1449z00_7919))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test10047z00_26247
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test10049z00_26250;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10050z00_26251;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_tmpz00_26252;
																																																																							BgL_tmpz00_26252
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1449z00_7919));
																																																																							BgL_test10050z00_26251
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_26252);
																																																																						}
																																																																						if (BgL_test10050z00_26251)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test10049z00_26250
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test10049z00_26250
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_test10049z00_26250)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1449z00_26256;
																																																																							BgL_l1449z00_26256
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1449z00_7919));
																																																																							BgL_l1449z00_7919
																																																																								=
																																																																								BgL_l1449z00_26256;
																																																																							goto
																																																																								BgL_zc3z04anonymousza36307ze3z87_7920;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test10047z00_26247
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_test10047z00_26247)
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6297z00_7902;
																																																																				BgL_arg6297z00_7902
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd248614zd2_7878));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26261;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_26265;
																																																																						obj_t
																																																																							BgL_proc2z00_26264;
																																																																						obj_t
																																																																							BgL_proc1z00_26263;
																																																																						obj_t
																																																																							BgL_testz00_26262;
																																																																						BgL_testz00_26262
																																																																							=
																																																																							BgL_arg6297z00_7902;
																																																																						BgL_proc1z00_26263
																																																																							=
																																																																							BgL_carzd248625zd2_7882;
																																																																						BgL_proc2z00_26264
																																																																							=
																																																																							BgL_carzd248633zd2_7886;
																																																																						BgL_argsz00_26265
																																																																							=
																																																																							BgL_cdrzd248608zd2_7877;
																																																																						BgL_argsz00_1779
																																																																							=
																																																																							BgL_argsz00_26265;
																																																																						BgL_proc2z00_1778
																																																																							=
																																																																							BgL_proc2z00_26264;
																																																																						BgL_proc1z00_1777
																																																																							=
																																																																							BgL_proc1z00_26263;
																																																																						BgL_testz00_1776
																																																																							=
																																																																							BgL_testz00_26262;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1780;
																																																																					}
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26261);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd248657zd2_7903;
																																																																				BgL_cdrzd248657zd2_7903
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd248664zd2_7904;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12837;
																																																																						BgL_pairz00_12837
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd248664zd2_7904
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12837);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd248671zd2_7905;
																																																																						BgL_cdrzd248671zd2_7905
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd248664zd2_7904));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd248677zd2_7906;
																																																																							BgL_carzd248677zd2_7906
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd248671zd2_7905));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248677zd2_7906))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd248684zd2_7908;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12841;
																																																																										BgL_pairz00_12841
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd248671zd2_7905));
																																																																										BgL_carzd248684zd2_7908
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_12841);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248684zd2_7908))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248657zd2_7903))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6301z00_7911;
																																																																													BgL_arg6301z00_7911
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd248664zd2_7904));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26287;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26291;
																																																																															obj_t
																																																																																BgL_proc2z00_26290;
																																																																															obj_t
																																																																																BgL_proc1z00_26289;
																																																																															obj_t
																																																																																BgL_testz00_26288;
																																																																															BgL_testz00_26288
																																																																																=
																																																																																BgL_arg6301z00_7911;
																																																																															BgL_proc1z00_26289
																																																																																=
																																																																																BgL_carzd248677zd2_7906;
																																																																															BgL_proc2z00_26290
																																																																																=
																																																																																BgL_carzd248684zd2_7908;
																																																																															BgL_argsz00_26291
																																																																																=
																																																																																BgL_cdrzd248657zd2_7903;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_26291;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_26290;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_26289;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_26288;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26287);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26295;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26295);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26299;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26299);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26303;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26303);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26307;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26307);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd248960zd2_7930;
																																																																BgL_cdrzd248960zd2_7930
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd248966zd2_7931;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12845;
																																																																		BgL_pairz00_12845
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd248966zd2_7931
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12845);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd248972zd2_7932;
																																																																		BgL_cdrzd248972zd2_7932
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd248966zd2_7931));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd248977zd2_7933;
																																																																			obj_t
																																																																				BgL_cdrzd248978zd2_7934;
																																																																			BgL_carzd248977zd2_7933
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7932));
																																																																			BgL_cdrzd248978zd2_7934
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd248972zd2_7932));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248977zd2_7933))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd248983zd2_7936;
																																																																					BgL_carzd248983zd2_7936
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd248978zd2_7934));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd248983zd2_7936))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd248978zd2_7934))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd248960zd2_7930))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6316z00_7941;
																																																																											BgL_arg6316z00_7941
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd248966zd2_7931));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26334;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26338;
																																																																													obj_t
																																																																														BgL_proc2z00_26337;
																																																																													obj_t
																																																																														BgL_proc1z00_26336;
																																																																													obj_t
																																																																														BgL_testz00_26335;
																																																																													BgL_testz00_26335
																																																																														=
																																																																														BgL_arg6316z00_7941;
																																																																													BgL_proc1z00_26336
																																																																														=
																																																																														BgL_carzd248977zd2_7933;
																																																																													BgL_proc2z00_26337
																																																																														=
																																																																														BgL_carzd248983zd2_7936;
																																																																													BgL_argsz00_26338
																																																																														=
																																																																														BgL_cdrzd248960zd2_7930;
																																																																													BgL_argsz00_1784
																																																																														=
																																																																														BgL_argsz00_26338;
																																																																													BgL_proc2z00_1783
																																																																														=
																																																																														BgL_proc2z00_26337;
																																																																													BgL_proc1z00_1782
																																																																														=
																																																																														BgL_proc1z00_26336;
																																																																													BgL_testz00_1781
																																																																														=
																																																																														BgL_testz00_26335;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1785;
																																																																												}
																																																																												BgL_auxz00_22135
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26334);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26342;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26342);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26346;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26346);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26350;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26350);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26354;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26354);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26358;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26358);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd249316zd2_7949;
																																																												BgL_cdrzd249316zd2_7949
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd249323zd2_7950;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_pairz00_12855;
																																																														BgL_pairz00_12855
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd249323zd2_7950
																																																															=
																																																															CDR
																																																															(BgL_pairz00_12855);
																																																													}
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd249330zd2_7951;
																																																														BgL_cdrzd249330zd2_7951
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd249323zd2_7950));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd249336zd2_7952;
																																																															obj_t
																																																																BgL_cdrzd249337zd2_7953;
																																																															BgL_carzd249336zd2_7952
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7951));
																																																															BgL_cdrzd249337zd2_7953
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd249330zd2_7951));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249336zd2_7952))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd249337zd2_7953))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd249344zd2_7956;
																																																																			BgL_carzd249344zd2_7956
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd249337zd2_7953);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd249344zd2_7956))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (NULLP(CDR(BgL_cdrzd249337zd2_7953)))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd249316zd2_7949))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6330z00_7961;
																																																																									BgL_arg6330z00_7961
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd249323zd2_7950));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26385;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26389;
																																																																											obj_t
																																																																												BgL_proc2z00_26388;
																																																																											obj_t
																																																																												BgL_proc1z00_26387;
																																																																											obj_t
																																																																												BgL_testz00_26386;
																																																																											BgL_testz00_26386
																																																																												=
																																																																												BgL_arg6330z00_7961;
																																																																											BgL_proc1z00_26387
																																																																												=
																																																																												BgL_carzd249336zd2_7952;
																																																																											BgL_proc2z00_26388
																																																																												=
																																																																												BgL_carzd249344zd2_7956;
																																																																											BgL_argsz00_26389
																																																																												=
																																																																												BgL_cdrzd249316zd2_7949;
																																																																											BgL_argsz00_1784
																																																																												=
																																																																												BgL_argsz00_26389;
																																																																											BgL_proc2z00_1783
																																																																												=
																																																																												BgL_proc2z00_26388;
																																																																											BgL_proc1z00_1782
																																																																												=
																																																																												BgL_proc1z00_26387;
																																																																											BgL_testz00_1781
																																																																												=
																																																																												BgL_testz00_26386;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1785;
																																																																										}
																																																																										BgL_auxz00_22135
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26385);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26393;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26393);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26397;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26397);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26401;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26401);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_26405;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_26405);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_26409;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_26409);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1809;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26413;
																																																											goto
																																																												BgL_tagzd2404zd2_1810;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26413);
																																																										}
																																																								}
																																																						}
																																																					}
																																																			}
																																																		}
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd249737zd2_7975;
																																												BgL_cdrzd249737zd2_7975
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test10078z00_26417;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6358z00_7992;
																																														BgL_arg6358z00_7992
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test10078z00_26417
																																															=
																																															CBOOL
																																															(BGl_letzd2symzf3z21zzast_letz00
																																															(BgL_arg6358z00_7992));
																																													}
																																													if (BgL_test10078z00_26417)
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6346z00_7978;
																																															obj_t
																																																BgL_arg6347z00_7979;
																																															BgL_arg6346z00_7978
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7975));
																																															BgL_arg6347z00_7979
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd249737zd2_7975));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_26426;
																																																{
																																																	obj_t
																																																		BgL_exprz00_26428;
																																																	obj_t
																																																		BgL_bindingsz00_26427;
																																																	BgL_bindingsz00_26427
																																																		=
																																																		BgL_arg6346z00_7978;
																																																	BgL_exprz00_26428
																																																		=
																																																		BgL_arg6347z00_7979;
																																																	BgL_exprz00_1764
																																																		=
																																																		BgL_exprz00_26428;
																																																	BgL_bindingsz00_1763
																																																		=
																																																		BgL_bindingsz00_26427;
																																																	goto
																																																		BgL_tagzd2382zd2_1765;
																																																}
																																																BgL_auxz00_22135
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_26426);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															bool_t
																																																BgL_test10079z00_26430;
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg6357z00_7991;
																																																BgL_arg6357z00_7991
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																BgL_test10079z00_26430
																																																	=
																																																	CBOOL
																																																	(BGl_labelszd2symzf3z21zzast_labelsz00
																																																	(BgL_arg6357z00_7991));
																																															}
																																															if (BgL_test10079z00_26430)
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26435;
																																																	goto
																																																		BgL_tagzd2384zd2_1767;
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26435);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_carzd249803zd2_7982;
																																																	BgL_carzd249803zd2_7982
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd249808zd2_7983;
																																																		BgL_cdrzd249808zd2_7983
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd249803zd2_7982));
																																																		if ((CAR(((obj_t) BgL_carzd249803zd2_7982)) == CNST_TABLE_REF(((long) 3))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6352z00_7986;
																																																				obj_t
																																																					BgL_arg6353z00_7987;
																																																				obj_t
																																																					BgL_arg6354z00_7988;
																																																				BgL_arg6352z00_7986
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7983));
																																																				BgL_arg6353z00_7987
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd249808zd2_7983));
																																																				BgL_arg6354z00_7988
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26452;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_26455;
																																																						obj_t
																																																							BgL_bodyz00_26454;
																																																						obj_t
																																																							BgL_varsz00_26453;
																																																						BgL_varsz00_26453
																																																							=
																																																							BgL_arg6352z00_7986;
																																																						BgL_bodyz00_26454
																																																							=
																																																							BgL_arg6353z00_7987;
																																																						BgL_argsz00_26455
																																																							=
																																																							BgL_arg6354z00_7988;
																																																						BgL_argsz00_1774
																																																							=
																																																							BgL_argsz00_26455;
																																																						BgL_bodyz00_1773
																																																							=
																																																							BgL_bodyz00_26454;
																																																						BgL_varsz00_1772
																																																							=
																																																							BgL_varsz00_26453;
																																																						goto
																																																							BgL_tagzd2386zd2_1775;
																																																					}
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26452);
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd2403zd2_1809;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_26459;
																																																						goto
																																																							BgL_tagzd2404zd2_1810;
																																																						BgL_auxz00_22135
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_26459);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd249919zd2_7993;
																																										BgL_cdrzd249919zd2_7993
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{	/* Ast/sexp.scm 119 */
																																											bool_t
																																												BgL_test10082z00_26463;
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg6367z00_8002;
																																												BgL_arg6367z00_8002
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												BgL_test10082z00_26463
																																													=
																																													CBOOL
																																													(BGl_letzd2symzf3z21zzast_letz00
																																													(BgL_arg6367z00_8002));
																																											}
																																											if (BgL_test10082z00_26463)
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6361z00_7996;
																																													obj_t
																																														BgL_arg6362z00_7997;
																																													BgL_arg6361z00_7996
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_7993));
																																													BgL_arg6362z00_7997
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_cdrzd249919zd2_7993));
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_26472;
																																														{
																																															obj_t
																																																BgL_exprz00_26474;
																																															obj_t
																																																BgL_bindingsz00_26473;
																																															BgL_bindingsz00_26473
																																																=
																																																BgL_arg6361z00_7996;
																																															BgL_exprz00_26474
																																																=
																																																BgL_arg6362z00_7997;
																																															BgL_exprz00_1764
																																																=
																																																BgL_exprz00_26474;
																																															BgL_bindingsz00_1763
																																																=
																																																BgL_bindingsz00_26473;
																																															goto
																																																BgL_tagzd2382zd2_1765;
																																														}
																																														BgL_auxz00_22135
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_26472);
																																													}
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													bool_t
																																														BgL_test10083z00_26476;
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg6366z00_8001;
																																														BgL_arg6366z00_8001
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														BgL_test10083z00_26476
																																															=
																																															CBOOL
																																															(BGl_labelszd2symzf3z21zzast_labelsz00
																																															(BgL_arg6366z00_8001));
																																													}
																																													if (BgL_test10083z00_26476)
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26481;
																																															goto
																																																BgL_tagzd2384zd2_1767;
																																															BgL_auxz00_22135
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26481);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2403zd2_1809;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_26485;
																																																	goto
																																																		BgL_tagzd2404zd2_1810;
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26485);
																																																}
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248484zd2_7672)))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd248486zd2_7674;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd248484zd2_7672 == CNST_TABLE_REF(((long) 18))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd248486zd2_7674;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if ((BgL_carzd248484zd2_7672 == CNST_TABLE_REF(((long) 19))))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd248486zd2_7674;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd248484zd2_7672)))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_kapzd248486zd2_7674;
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_cdrzd250091zd2_7680;
																																																BgL_cdrzd250091zd2_7680
																																																	=
																																																	CDR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	bool_t
																																																		BgL_test10089z00_26501;
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg6267z00_7854;
																																																		BgL_arg6267z00_7854
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		BgL_test10089z00_26501
																																																			=
																																																			CBOOL
																																																			(BGl_letzd2symzf3z21zzast_letz00
																																																			(BgL_arg6267z00_7854));
																																																	}
																																																	if (BgL_test10089z00_26501)
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg6151z00_7683;
																																																			obj_t
																																																				BgL_arg6152z00_7684;
																																																			BgL_arg6151z00_7683
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7680));
																																																			BgL_arg6152z00_7684
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd250091zd2_7680));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_26510;
																																																				{
																																																					obj_t
																																																						BgL_exprz00_26512;
																																																					obj_t
																																																						BgL_bindingsz00_26511;
																																																					BgL_bindingsz00_26511
																																																						=
																																																						BgL_arg6151z00_7683;
																																																					BgL_exprz00_26512
																																																						=
																																																						BgL_arg6152z00_7684;
																																																					BgL_exprz00_1764
																																																						=
																																																						BgL_exprz00_26512;
																																																					BgL_bindingsz00_1763
																																																						=
																																																						BgL_bindingsz00_26511;
																																																					goto
																																																						BgL_tagzd2382zd2_1765;
																																																				}
																																																				BgL_auxz00_22135
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_26510);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			bool_t
																																																				BgL_test10090z00_26514;
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_arg6266z00_7853;
																																																				BgL_arg6266z00_7853
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				BgL_test10090z00_26514
																																																					=
																																																					CBOOL
																																																					(BGl_labelszd2symzf3z21zzast_labelsz00
																																																					(BgL_arg6266z00_7853));
																																																			}
																																																			if (BgL_test10090z00_26514)
																																																				{
																																																					BgL_letzd2funzd2_bglt
																																																						BgL_auxz00_26519;
																																																					goto
																																																						BgL_tagzd2384zd2_1767;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26519);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd250144zd2_7687;
																																																					obj_t
																																																						BgL_cdrzd250145zd2_7688;
																																																					BgL_carzd250144zd2_7687
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					BgL_cdrzd250145zd2_7688
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd250149zd2_7689;
																																																						BgL_cdrzd250149zd2_7689
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd250144zd2_7687));
																																																						if ((CAR(((obj_t) BgL_carzd250144zd2_7687)) == CNST_TABLE_REF(((long) 3))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (PAIRP(BgL_cdrzd250149zd2_7689))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd250152zd2_7693;
																																																										obj_t
																																																											BgL_cdrzd250153zd2_7694;
																																																										BgL_carzd250152zd2_7693
																																																											=
																																																											CAR
																																																											(BgL_cdrzd250149zd2_7689);
																																																										BgL_cdrzd250153zd2_7694
																																																											=
																																																											CDR
																																																											(BgL_cdrzd250149zd2_7689);
																																																										if (PAIRP(BgL_carzd250152zd2_7693))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (NULLP(CDR(BgL_carzd250152zd2_7693)))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd250153zd2_7694))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd250159zd2_7699;
																																																																BgL_carzd250159zd2_7699
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd250153zd2_7694);
																																																																if (PAIRP(BgL_carzd250159zd2_7699))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd250159zd2_7699))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd250153zd2_7694)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd250166zd2_7704;
																																																																						BgL_carzd250166zd2_7704
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250145zd2_7688));
																																																																						if (PAIRP(BgL_carzd250166zd2_7704))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd250191zd2_7706;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_12903;
																																																																									BgL_pairz00_12903
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									BgL_cdrzd250191zd2_7706
																																																																										=
																																																																										CDR
																																																																										(BgL_pairz00_12903);
																																																																								}
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6167z00_7707;
																																																																									obj_t
																																																																										BgL_arg6168z00_7708;
																																																																									obj_t
																																																																										BgL_arg6169z00_7709;
																																																																									BgL_arg6167z00_7707
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7706));
																																																																									BgL_arg6168z00_7708
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250191zd2_7706));
																																																																									BgL_arg6169z00_7709
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_expz00_21));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_26564;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_26567;
																																																																											obj_t
																																																																												BgL_bodyz00_26566;
																																																																											obj_t
																																																																												BgL_varsz00_26565;
																																																																											BgL_varsz00_26565
																																																																												=
																																																																												BgL_arg6167z00_7707;
																																																																											BgL_bodyz00_26566
																																																																												=
																																																																												BgL_arg6168z00_7708;
																																																																											BgL_argsz00_26567
																																																																												=
																																																																												BgL_arg6169z00_7709;
																																																																											BgL_argsz00_1774
																																																																												=
																																																																												BgL_argsz00_26567;
																																																																											BgL_bodyz00_1773
																																																																												=
																																																																												BgL_bodyz00_26566;
																																																																											BgL_varsz00_1772
																																																																												=
																																																																												BgL_varsz00_26565;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1775;
																																																																										}
																																																																										BgL_auxz00_22135
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_26564);
																																																																									}
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd250145zd2_7688))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg6173z00_7713;
																																																																										BgL_arg6173z00_7713
																																																																											=
																																																																											CAR
																																																																											(BgL_carzd250152zd2_7693);
																																																																										{
																																																																											BgL_castz00_bglt
																																																																												BgL_auxz00_26574;
																																																																											{
																																																																												obj_t
																																																																													BgL_argz00_26577;
																																																																												obj_t
																																																																													BgL_bodyz00_26576;
																																																																												obj_t
																																																																													BgL_varz00_26575;
																																																																												BgL_varz00_26575
																																																																													=
																																																																													BgL_arg6173z00_7713;
																																																																												BgL_bodyz00_26576
																																																																													=
																																																																													BgL_carzd250159zd2_7699;
																																																																												BgL_argz00_26577
																																																																													=
																																																																													BgL_carzd250166zd2_7704;
																																																																												BgL_argz00_1770
																																																																													=
																																																																													BgL_argz00_26577;
																																																																												BgL_bodyz00_1769
																																																																													=
																																																																													BgL_bodyz00_26576;
																																																																												BgL_varz00_1768
																																																																													=
																																																																													BgL_varz00_26575;
																																																																												goto
																																																																													BgL_tagzd2385zd2_1771;
																																																																											}
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26574);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd250219zd2_7714;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_12911;
																																																																											BgL_pairz00_12911
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											BgL_cdrzd250219zd2_7714
																																																																												=
																																																																												CDR
																																																																												(BgL_pairz00_12911);
																																																																										}
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6174z00_7715;
																																																																											obj_t
																																																																												BgL_arg6175z00_7716;
																																																																											obj_t
																																																																												BgL_arg6176z00_7717;
																																																																											BgL_arg6174z00_7715
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7714));
																																																																											BgL_arg6175z00_7716
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250219zd2_7714));
																																																																											BgL_arg6176z00_7717
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_expz00_21));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_26588;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_26591;
																																																																													obj_t
																																																																														BgL_bodyz00_26590;
																																																																													obj_t
																																																																														BgL_varsz00_26589;
																																																																													BgL_varsz00_26589
																																																																														=
																																																																														BgL_arg6174z00_7715;
																																																																													BgL_bodyz00_26590
																																																																														=
																																																																														BgL_arg6175z00_7716;
																																																																													BgL_argsz00_26591
																																																																														=
																																																																														BgL_arg6176z00_7717;
																																																																													BgL_argsz00_1774
																																																																														=
																																																																														BgL_argsz00_26591;
																																																																													BgL_bodyz00_1773
																																																																														=
																																																																														BgL_bodyz00_26590;
																																																																													BgL_varsz00_1772
																																																																														=
																																																																														BgL_varsz00_26589;
																																																																													goto
																																																																														BgL_tagzd2386zd2_1775;
																																																																												}
																																																																												BgL_auxz00_22135
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_26588);
																																																																											}
																																																																										}
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd250245zd2_7720;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_12916;
																																																																							BgL_pairz00_12916
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							BgL_cdrzd250245zd2_7720
																																																																								=
																																																																								CDR
																																																																								(BgL_pairz00_12916);
																																																																						}
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg6179z00_7721;
																																																																							obj_t
																																																																								BgL_arg6180z00_7722;
																																																																							obj_t
																																																																								BgL_arg6181z00_7723;
																																																																							BgL_arg6179z00_7721
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7720));
																																																																							BgL_arg6180z00_7722
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250245zd2_7720));
																																																																							BgL_arg6181z00_7723
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_expz00_21));
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26602;
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_26605;
																																																																									obj_t
																																																																										BgL_bodyz00_26604;
																																																																									obj_t
																																																																										BgL_varsz00_26603;
																																																																									BgL_varsz00_26603
																																																																										=
																																																																										BgL_arg6179z00_7721;
																																																																									BgL_bodyz00_26604
																																																																										=
																																																																										BgL_arg6180z00_7722;
																																																																									BgL_argsz00_26605
																																																																										=
																																																																										BgL_arg6181z00_7723;
																																																																									BgL_argsz00_1774
																																																																										=
																																																																										BgL_argsz00_26605;
																																																																									BgL_bodyz00_1773
																																																																										=
																																																																										BgL_bodyz00_26604;
																																																																									BgL_varsz00_1772
																																																																										=
																																																																										BgL_varsz00_26603;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1775;
																																																																								}
																																																																								BgL_auxz00_22135
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26602);
																																																																							}
																																																																						}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd250271zd2_7726;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_12921;
																																																																					BgL_pairz00_12921
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd250271zd2_7726
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_12921);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_arg6184z00_7727;
																																																																					obj_t
																																																																						BgL_arg6185z00_7728;
																																																																					obj_t
																																																																						BgL_arg6186z00_7729;
																																																																					BgL_arg6184z00_7727
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7726));
																																																																					BgL_arg6185z00_7728
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd250271zd2_7726));
																																																																					BgL_arg6186z00_7729
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_26616;
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_26619;
																																																																							obj_t
																																																																								BgL_bodyz00_26618;
																																																																							obj_t
																																																																								BgL_varsz00_26617;
																																																																							BgL_varsz00_26617
																																																																								=
																																																																								BgL_arg6184z00_7727;
																																																																							BgL_bodyz00_26618
																																																																								=
																																																																								BgL_arg6185z00_7728;
																																																																							BgL_argsz00_26619
																																																																								=
																																																																								BgL_arg6186z00_7729;
																																																																							BgL_argsz00_1774
																																																																								=
																																																																								BgL_argsz00_26619;
																																																																							BgL_bodyz00_1773
																																																																								=
																																																																								BgL_bodyz00_26618;
																																																																							BgL_varsz00_1772
																																																																								=
																																																																								BgL_varsz00_26617;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1775;
																																																																						}
																																																																						BgL_auxz00_22135
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_26616);
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd250297zd2_7731;
																																																																		BgL_cdrzd250297zd2_7731
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_carzd250144zd2_7687));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg6188z00_7732;
																																																																			obj_t
																																																																				BgL_arg6189z00_7733;
																																																																			obj_t
																																																																				BgL_arg6190z00_7734;
																																																																			BgL_arg6188z00_7732
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7731));
																																																																			BgL_arg6189z00_7733
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd250297zd2_7731));
																																																																			BgL_arg6190z00_7734
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26629;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_26632;
																																																																					obj_t
																																																																						BgL_bodyz00_26631;
																																																																					obj_t
																																																																						BgL_varsz00_26630;
																																																																					BgL_varsz00_26630
																																																																						=
																																																																						BgL_arg6188z00_7732;
																																																																					BgL_bodyz00_26631
																																																																						=
																																																																						BgL_arg6189z00_7733;
																																																																					BgL_argsz00_26632
																																																																						=
																																																																						BgL_arg6190z00_7734;
																																																																					BgL_argsz00_1774
																																																																						=
																																																																						BgL_argsz00_26632;
																																																																					BgL_bodyz00_1773
																																																																						=
																																																																						BgL_bodyz00_26631;
																																																																					BgL_varsz00_1772
																																																																						=
																																																																						BgL_varsz00_26630;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1775;
																																																																				}
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26629);
																																																																			}
																																																																		}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd250323zd2_7736;
																																																																BgL_cdrzd250323zd2_7736
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_carzd250144zd2_7687));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg6192z00_7737;
																																																																	obj_t
																																																																		BgL_arg6193z00_7738;
																																																																	obj_t
																																																																		BgL_arg6194z00_7739;
																																																																	BgL_arg6192z00_7737
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7736));
																																																																	BgL_arg6193z00_7738
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd250323zd2_7736));
																																																																	BgL_arg6194z00_7739
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_26642;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_26645;
																																																																			obj_t
																																																																				BgL_bodyz00_26644;
																																																																			obj_t
																																																																				BgL_varsz00_26643;
																																																																			BgL_varsz00_26643
																																																																				=
																																																																				BgL_arg6192z00_7737;
																																																																			BgL_bodyz00_26644
																																																																				=
																																																																				BgL_arg6193z00_7738;
																																																																			BgL_argsz00_26645
																																																																				=
																																																																				BgL_arg6194z00_7739;
																																																																			BgL_argsz00_1774
																																																																				=
																																																																				BgL_argsz00_26645;
																																																																			BgL_bodyz00_1773
																																																																				=
																																																																				BgL_bodyz00_26644;
																																																																			BgL_varsz00_1772
																																																																				=
																																																																				BgL_varsz00_26643;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1775;
																																																																		}
																																																																		BgL_auxz00_22135
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_26642);
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd250349zd2_7741;
																																																														BgL_cdrzd250349zd2_7741
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_carzd250144zd2_7687));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6196z00_7742;
																																																															obj_t
																																																																BgL_arg6197z00_7743;
																																																															obj_t
																																																																BgL_arg6198z00_7744;
																																																															BgL_arg6196z00_7742
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7741));
																																																															BgL_arg6197z00_7743
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd250349zd2_7741));
																																																															BgL_arg6198z00_7744
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26655;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_26658;
																																																																	obj_t
																																																																		BgL_bodyz00_26657;
																																																																	obj_t
																																																																		BgL_varsz00_26656;
																																																																	BgL_varsz00_26656
																																																																		=
																																																																		BgL_arg6196z00_7742;
																																																																	BgL_bodyz00_26657
																																																																		=
																																																																		BgL_arg6197z00_7743;
																																																																	BgL_argsz00_26658
																																																																		=
																																																																		BgL_arg6198z00_7744;
																																																																	BgL_argsz00_1774
																																																																		=
																																																																		BgL_argsz00_26658;
																																																																	BgL_bodyz00_1773
																																																																		=
																																																																		BgL_bodyz00_26657;
																																																																	BgL_varsz00_1772
																																																																		=
																																																																		BgL_varsz00_26656;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1775;
																																																																}
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26655);
																																																															}
																																																														}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd250375zd2_7747;
																																																												BgL_cdrzd250375zd2_7747
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_carzd250144zd2_7687));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg6201z00_7748;
																																																													obj_t
																																																														BgL_arg6202z00_7749;
																																																													obj_t
																																																														BgL_arg6203z00_7750;
																																																													BgL_arg6201z00_7748
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7747));
																																																													BgL_arg6202z00_7749
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd250375zd2_7747));
																																																													BgL_arg6203z00_7750
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26668;
																																																														{
																																																															obj_t
																																																																BgL_argsz00_26671;
																																																															obj_t
																																																																BgL_bodyz00_26670;
																																																															obj_t
																																																																BgL_varsz00_26669;
																																																															BgL_varsz00_26669
																																																																=
																																																																BgL_arg6201z00_7748;
																																																															BgL_bodyz00_26670
																																																																=
																																																																BgL_arg6202z00_7749;
																																																															BgL_argsz00_26671
																																																																=
																																																																BgL_arg6203z00_7750;
																																																															BgL_argsz00_1774
																																																																=
																																																																BgL_argsz00_26671;
																																																															BgL_bodyz00_1773
																																																																=
																																																																BgL_bodyz00_26670;
																																																															BgL_varsz00_1772
																																																																=
																																																																BgL_varsz00_26669;
																																																															goto
																																																																BgL_tagzd2386zd2_1775;
																																																														}
																																																														BgL_auxz00_22135
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26668);
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1809;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26675;
																																																												goto
																																																													BgL_tagzd2404zd2_1810;
																																																												BgL_auxz00_22135
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26675);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd250513zd2_7755;
																																																								BgL_cdrzd250513zd2_7755
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd250144zd2_7687));
																																																								if ((CAR(((obj_t) BgL_carzd250144zd2_7687)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd250513zd2_7755))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd250518zd2_7759;
																																																												BgL_cdrzd250518zd2_7759
																																																													=
																																																													CDR
																																																													(BgL_cdrzd250513zd2_7755);
																																																												if (PAIRP(BgL_cdrzd250518zd2_7759))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd250522zd2_7761;
																																																														obj_t
																																																															BgL_cdrzd250523zd2_7762;
																																																														BgL_carzd250522zd2_7761
																																																															=
																																																															CAR
																																																															(BgL_cdrzd250518zd2_7759);
																																																														BgL_cdrzd250523zd2_7762
																																																															=
																																																															CDR
																																																															(BgL_cdrzd250518zd2_7759);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250522zd2_7761))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd250523zd2_7762))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd250528zd2_7765;
																																																																		BgL_carzd250528zd2_7765
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd250523zd2_7762);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250528zd2_7765))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd250523zd2_7762)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10109z00_26701;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1452z00_7798;
																																																																							BgL_l1452z00_7798
																																																																								=
																																																																								BgL_cdrzd250145zd2_7688;
																																																																						BgL_zc3z04anonymousza36230ze3z87_7799:
																																																																							if (NULLP(BgL_l1452z00_7798))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test10109z00_26701
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test10111z00_26704;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test10112z00_26705;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_26706;
																																																																											BgL_tmpz00_26706
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1452z00_7798));
																																																																											BgL_test10112z00_26705
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_26706);
																																																																										}
																																																																										if (BgL_test10112z00_26705)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test10111z00_26704
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test10111z00_26704
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test10111z00_26704)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1452z00_26710;
																																																																											BgL_l1452z00_26710
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1452z00_7798));
																																																																											BgL_l1452z00_7798
																																																																												=
																																																																												BgL_l1452z00_26710;
																																																																											goto
																																																																												BgL_zc3z04anonymousza36230ze3z87_7799;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test10109z00_26701
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test10109z00_26701)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg6220z00_7781;
																																																																								BgL_arg6220z00_7781
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd250513zd2_7755);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26714;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_26718;
																																																																										obj_t
																																																																											BgL_proc2z00_26717;
																																																																										obj_t
																																																																											BgL_proc1z00_26716;
																																																																										obj_t
																																																																											BgL_testz00_26715;
																																																																										BgL_testz00_26715
																																																																											=
																																																																											BgL_arg6220z00_7781;
																																																																										BgL_proc1z00_26716
																																																																											=
																																																																											BgL_carzd250522zd2_7761;
																																																																										BgL_proc2z00_26717
																																																																											=
																																																																											BgL_carzd250528zd2_7765;
																																																																										BgL_argsz00_26718
																																																																											=
																																																																											BgL_cdrzd250145zd2_7688;
																																																																										BgL_argsz00_1779
																																																																											=
																																																																											BgL_argsz00_26718;
																																																																										BgL_proc2z00_1778
																																																																											=
																																																																											BgL_proc2z00_26717;
																																																																										BgL_proc1z00_1777
																																																																											=
																																																																											BgL_proc1z00_26716;
																																																																										BgL_testz00_1776
																																																																											=
																																																																											BgL_testz00_26715;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1780;
																																																																									}
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26714);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd250553zd2_7782;
																																																																								BgL_cdrzd250553zd2_7782
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd250561zd2_7783;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_12965;
																																																																										BgL_pairz00_12965
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd250561zd2_7783
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_12965);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd250569zd2_7784;
																																																																										BgL_cdrzd250569zd2_7784
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd250561zd2_7783));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd250576zd2_7785;
																																																																											BgL_carzd250576zd2_7785
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd250569zd2_7784));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250576zd2_7785))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd250585zd2_7787;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_12969;
																																																																														BgL_pairz00_12969
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd250569zd2_7784));
																																																																														BgL_carzd250585zd2_7787
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_12969);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250585zd2_7787))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250553zd2_7782))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg6224z00_7790;
																																																																																	BgL_arg6224z00_7790
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd250561zd2_7783));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_26740;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_26744;
																																																																																			obj_t
																																																																																				BgL_proc2z00_26743;
																																																																																			obj_t
																																																																																				BgL_proc1z00_26742;
																																																																																			obj_t
																																																																																				BgL_testz00_26741;
																																																																																			BgL_testz00_26741
																																																																																				=
																																																																																				BgL_arg6224z00_7790;
																																																																																			BgL_proc1z00_26742
																																																																																				=
																																																																																				BgL_carzd250576zd2_7785;
																																																																																			BgL_proc2z00_26743
																																																																																				=
																																																																																				BgL_carzd250585zd2_7787;
																																																																																			BgL_argsz00_26744
																																																																																				=
																																																																																				BgL_cdrzd250553zd2_7782;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_26744;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_26743;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_26742;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_26741;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_22135
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_26740);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_26748;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_22135
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_26748);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26752;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26752);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26756;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26756);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_26760;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_22135
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_26760);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd250863zd2_7809;
																																																																				BgL_cdrzd250863zd2_7809
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd250870zd2_7810;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_12973;
																																																																						BgL_pairz00_12973
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd250870zd2_7810
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_12973);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd250877zd2_7811;
																																																																						BgL_cdrzd250877zd2_7811
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd250870zd2_7810));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd250883zd2_7812;
																																																																							obj_t
																																																																								BgL_cdrzd250884zd2_7813;
																																																																							BgL_carzd250883zd2_7812
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7811));
																																																																							BgL_cdrzd250884zd2_7813
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd250877zd2_7811));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250883zd2_7812))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd250891zd2_7815;
																																																																									BgL_carzd250891zd2_7815
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd250884zd2_7813));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd250891zd2_7815))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd250884zd2_7813))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd250863zd2_7809))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg6239z00_7820;
																																																																															BgL_arg6239z00_7820
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd250870zd2_7810));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_26787;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_26791;
																																																																																	obj_t
																																																																																		BgL_proc2z00_26790;
																																																																																	obj_t
																																																																																		BgL_proc1z00_26789;
																																																																																	obj_t
																																																																																		BgL_testz00_26788;
																																																																																	BgL_testz00_26788
																																																																																		=
																																																																																		BgL_arg6239z00_7820;
																																																																																	BgL_proc1z00_26789
																																																																																		=
																																																																																		BgL_carzd250883zd2_7812;
																																																																																	BgL_proc2z00_26790
																																																																																		=
																																																																																		BgL_carzd250891zd2_7815;
																																																																																	BgL_argsz00_26791
																																																																																		=
																																																																																		BgL_cdrzd250863zd2_7809;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_26791;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_26790;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_26789;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_26788;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_22135
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_26787);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_26795;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_22135
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_26795);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26799;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26799);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26803;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26803);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26807;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26807);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_26811;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_26811);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd251224zd2_7828;
																																																																BgL_cdrzd251224zd2_7828
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd251230zd2_7829;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_12983;
																																																																		BgL_pairz00_12983
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd251230zd2_7829
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_12983);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd251236zd2_7830;
																																																																		BgL_cdrzd251236zd2_7830
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd251230zd2_7829));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd251241zd2_7831;
																																																																			obj_t
																																																																				BgL_cdrzd251242zd2_7832;
																																																																			BgL_carzd251241zd2_7831
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7830));
																																																																			BgL_cdrzd251242zd2_7832
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd251236zd2_7830));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251241zd2_7831))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd251242zd2_7832))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd251247zd2_7835;
																																																																							BgL_carzd251247zd2_7835
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd251242zd2_7832);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd251247zd2_7835))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd251242zd2_7832)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd251224zd2_7828))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6253z00_7840;
																																																																													BgL_arg6253z00_7840
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd251230zd2_7829));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_26838;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_26842;
																																																																															obj_t
																																																																																BgL_proc2z00_26841;
																																																																															obj_t
																																																																																BgL_proc1z00_26840;
																																																																															obj_t
																																																																																BgL_testz00_26839;
																																																																															BgL_testz00_26839
																																																																																=
																																																																																BgL_arg6253z00_7840;
																																																																															BgL_proc1z00_26840
																																																																																=
																																																																																BgL_carzd251241zd2_7831;
																																																																															BgL_proc2z00_26841
																																																																																=
																																																																																BgL_carzd251247zd2_7835;
																																																																															BgL_argsz00_26842
																																																																																=
																																																																																BgL_cdrzd251224zd2_7828;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_26842;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_26841;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_26840;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_26839;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_26838);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_26846;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_26846);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_26850;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_26850);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_26854;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_26854);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_26858;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_26858);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_26862;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_26862);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_26866;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_26866);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26870;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_22135
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26870);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1809;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_26874;
																																																												goto
																																																													BgL_tagzd2404zd2_1810;
																																																												BgL_auxz00_22135
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_26874);
																																																											}
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_cdrzd251785zd2_8004;
																																					BgL_cdrzd251785zd2_8004
																																						=
																																						CDR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd248481zd2_7670
																																							==
																																							CNST_TABLE_REF
																																							(((long) 17))))
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_arg6369z00_8006;
																																							obj_t
																																								BgL_arg6370z00_8007;
																																							BgL_arg6369z00_8006
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_8004));
																																							BgL_arg6370z00_8007
																																								=
																																								CDR
																																								(
																																								((obj_t) BgL_cdrzd251785zd2_8004));
																																							{
																																								BgL_nodez00_bglt
																																									BgL_auxz00_26885;
																																								{
																																									obj_t
																																										BgL_exprz00_26887;
																																									obj_t
																																										BgL_bindingsz00_26886;
																																									BgL_bindingsz00_26886
																																										=
																																										BgL_arg6369z00_8006;
																																									BgL_exprz00_26887
																																										=
																																										BgL_arg6370z00_8007;
																																									BgL_exprz00_1764
																																										=
																																										BgL_exprz00_26887;
																																									BgL_bindingsz00_1763
																																										=
																																										BgL_bindingsz00_26886;
																																									goto
																																										BgL_tagzd2382zd2_1765;
																																								}
																																								BgL_auxz00_22135
																																									=
																																									(
																																									(obj_t)
																																									BgL_auxz00_26885);
																																							}
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd248481zd2_7670)))
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6372z00_8009;
																																									obj_t
																																										BgL_arg6373z00_8010;
																																									BgL_arg6372z00_8009
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_8004));
																																									BgL_arg6373z00_8010
																																										=
																																										CDR
																																										(
																																										((obj_t) BgL_cdrzd251785zd2_8004));
																																									{
																																										BgL_nodez00_bglt
																																											BgL_auxz00_26896;
																																										{
																																											obj_t
																																												BgL_exprz00_26898;
																																											obj_t
																																												BgL_bindingsz00_26897;
																																											BgL_bindingsz00_26897
																																												=
																																												BgL_arg6372z00_8009;
																																											BgL_exprz00_26898
																																												=
																																												BgL_arg6373z00_8010;
																																											BgL_exprz00_1764
																																												=
																																												BgL_exprz00_26898;
																																											BgL_bindingsz00_1763
																																												=
																																												BgL_bindingsz00_26897;
																																											goto
																																												BgL_tagzd2382zd2_1765;
																																										}
																																										BgL_auxz00_22135
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_26896);
																																									}
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((BgL_carzd248481zd2_7670 == CNST_TABLE_REF(((long) 18))))
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6375z00_8012;
																																											obj_t
																																												BgL_arg6376z00_8013;
																																											BgL_arg6375z00_8012
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_8004));
																																											BgL_arg6376z00_8013
																																												=
																																												CDR
																																												(
																																												((obj_t) BgL_cdrzd251785zd2_8004));
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_26907;
																																												{
																																													obj_t
																																														BgL_exprz00_26909;
																																													obj_t
																																														BgL_bindingsz00_26908;
																																													BgL_bindingsz00_26908
																																														=
																																														BgL_arg6375z00_8012;
																																													BgL_exprz00_26909
																																														=
																																														BgL_arg6376z00_8013;
																																													BgL_exprz00_1764
																																														=
																																														BgL_exprz00_26909;
																																													BgL_bindingsz00_1763
																																														=
																																														BgL_bindingsz00_26908;
																																													goto
																																														BgL_tagzd2382zd2_1765;
																																												}
																																												BgL_auxz00_22135
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_26907);
																																											}
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_26916;
																																													goto
																																														BgL_tagzd2383zd2_1766;
																																													BgL_auxz00_22135
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_26916);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_carzd251822zd2_8016;
																																													BgL_carzd251822zd2_8016
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													if ((BgL_carzd251822zd2_8016 == CNST_TABLE_REF(((long) 19))))
																																														{
																																															BgL_letzd2funzd2_bglt
																																																BgL_auxz00_26923;
																																															goto
																																																BgL_tagzd2384zd2_1767;
																																															BgL_auxz00_22135
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_26923);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd251822zd2_8016)))
																																																{
																																																	BgL_letzd2funzd2_bglt
																																																		BgL_auxz00_26928;
																																																	goto
																																																		BgL_tagzd2384zd2_1767;
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_26928);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_26935;
																																																			goto
																																																				BgL_tagzd2389zd2_1786;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_26935);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_26942;
																																																					goto
																																																						BgL_tagzd2390zd2_1787;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_26942);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd251902zd2_8023;
																																																					BgL_cdrzd251902zd2_8023
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 21))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_arg6387z00_8026;
																																																							obj_t
																																																								BgL_arg6388z00_8027;
																																																							BgL_arg6387z00_8026
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_8023));
																																																							BgL_arg6388z00_8027
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd251902zd2_8023));
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_26955;
																																																								{
																																																									obj_t
																																																										BgL_restz00_26957;
																																																									obj_t
																																																										BgL_effectz00_26956;
																																																									BgL_effectz00_26956
																																																										=
																																																										BgL_arg6387z00_8026;
																																																									BgL_restz00_26957
																																																										=
																																																										BgL_arg6388z00_8027;
																																																									BgL_restz00_1789
																																																										=
																																																										BgL_restz00_26957;
																																																									BgL_effectz00_1788
																																																										=
																																																										BgL_effectz00_26956;
																																																									goto
																																																										BgL_tagzd2391zd2_1790;
																																																								}
																																																								BgL_auxz00_22135
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_26955);
																																																							}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																								{
																																																									BgL_nodez00_bglt
																																																										BgL_auxz00_26964;
																																																									goto
																																																										BgL_tagzd2392zd2_1791;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_26964);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_26971;
																																																											goto
																																																												BgL_tagzd2393zd2_1792;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_26971);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 24))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_arg6395z00_8035;
																																																													obj_t
																																																														BgL_arg6396z00_8036;
																																																													BgL_arg6395z00_8035
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_8023));
																																																													BgL_arg6396z00_8036
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd251902zd2_8023));
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_26982;
																																																														{
																																																															obj_t
																																																																BgL_restz00_26984;
																																																															obj_t
																																																																BgL_effectz00_26983;
																																																															BgL_effectz00_26983
																																																																=
																																																																BgL_arg6395z00_8035;
																																																															BgL_restz00_26984
																																																																=
																																																																BgL_arg6396z00_8036;
																																																															BgL_restz00_1794
																																																																=
																																																																BgL_restz00_26984;
																																																															BgL_effectz00_1793
																																																																=
																																																																BgL_effectz00_26983;
																																																															goto
																																																																BgL_tagzd2394zd2_1795;
																																																														}
																																																														BgL_auxz00_22135
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_26982);
																																																													}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_26991;
																																																															goto
																																																																BgL_tagzd2395zd2_1796;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_26991);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_26998;
																																																																	goto
																																																																		BgL_tagzd2396zd2_1797;
																																																																	BgL_auxz00_22135
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_26998);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																																		{
																																																																			BgL_letzd2funzd2_bglt
																																																																				BgL_auxz00_27005;
																																																																			goto
																																																																				BgL_tagzd2397zd2_1798;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27005);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																																				{
																																																																					BgL_jumpzd2exzd2itz00_bglt
																																																																						BgL_auxz00_27012;
																																																																					goto
																																																																						BgL_tagzd2398zd2_1799;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27012);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd251979zd2_8045;
																																																																					BgL_cdrzd251979zd2_8045
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 29))))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_arg6407z00_8048;
																																																																							obj_t
																																																																								BgL_arg6408z00_8049;
																																																																							BgL_arg6407z00_8048
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8045));
																																																																							BgL_arg6408z00_8049
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd251979zd2_8045));
																																																																							{	/* Ast/sexp.scm 555 */
																																																																								obj_t
																																																																									BgL_arg7015z00_13022;
																																																																								BgL_arg7015z00_13022
																																																																									=
																																																																									BGl_findzd2locationzf2locz20zztools_locationz00
																																																																									(BgL_expz00_21,
																																																																									BgL_locz00_23);
																																																																								BgL_auxz00_22135
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																									(BgL_expz00_21,
																																																																										BgL_arg6407z00_8048,
																																																																										CNST_TABLE_REF
																																																																										(((long) 4)), BgL_arg6408z00_8049, BgL_stackz00_22, BgL_arg7015z00_13022, BgL_sitez00_24));
																																																																						}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27031;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27031);
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									obj_t BgL_carzd252004zd2_8065;

																									BgL_carzd252004zd2_8065 =
																										CAR(
																										((obj_t) BgL_expz00_21));
																									if (
																										(BgL_carzd252004zd2_8065 ==
																											CNST_TABLE_REF(((long)
																													1))))
																										{
																											BgL_nodez00_bglt
																												BgL_auxz00_27038;
																											goto
																												BgL_tagzd2377zd2_1754;
																											BgL_auxz00_22135 =
																												((obj_t)
																												BgL_auxz00_27038);
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											if (
																												(BgL_carzd252004zd2_8065
																													==
																													BGl_za2ifza2z00zzast_sexpz00))
																												{
																													BgL_nodez00_bglt
																														BgL_auxz00_27042;
																													goto
																														BgL_tagzd2377zd2_1754;
																													BgL_auxz00_22135 =
																														((obj_t)
																														BgL_auxz00_27042);
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(CAR(
																																((obj_t)
																																	BgL_expz00_21))
																															==
																															CNST_TABLE_REF((
																																	(long) 7))))
																														{
																															BgL_nodez00_bglt
																																BgL_auxz00_27049;
																															goto
																																BgL_tagzd2379zd2_1758;
																															BgL_auxz00_22135 =
																																((obj_t)
																																BgL_auxz00_27049);
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															if (
																																(CAR(
																																		((obj_t)
																																			BgL_expz00_21))
																																	==
																																	CNST_TABLE_REF
																																	(((long)
																																			16))))
																																{
																																	BgL_nodez00_bglt
																																		BgL_auxz00_27056;
																																	goto
																																		BgL_tagzd2380zd2_1759;
																																	BgL_auxz00_22135
																																		=
																																		((obj_t)
																																		BgL_auxz00_27056);
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd252073zd2_8072;
																																	BgL_carzd252073zd2_8072
																																		=
																																		CAR(((obj_t)
																																			BgL_expz00_21));
																																	if (PAIRP
																																		(BgL_carzd252073zd2_8072))
																																		{	/* Ast/sexp.scm 119 */
																																			obj_t
																																				BgL_carzd252076zd2_8074;
																																			obj_t
																																				BgL_cdrzd252077zd2_8075;
																																			BgL_carzd252076zd2_8074
																																				=
																																				CAR
																																				(BgL_carzd252073zd2_8072);
																																			BgL_cdrzd252077zd2_8075
																																				=
																																				CDR
																																				(BgL_carzd252073zd2_8072);
																																			{

																																				if (
																																					(BgL_carzd252076zd2_8074
																																						==
																																						CNST_TABLE_REF
																																						(((long) 17))))
																																					{	/* Ast/sexp.scm 119 */
																																					BgL_kapzd252078zd2_8076:
																																						if (PAIRP(BgL_cdrzd252077zd2_8075))
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd252081zd2_8195;
																																								BgL_cdrzd252081zd2_8195
																																									=
																																									CDR
																																									(BgL_cdrzd252077zd2_8075);
																																								if (PAIRP(BgL_cdrzd252081zd2_8195))
																																									{	/* Ast/sexp.scm 119 */
																																										if (NULLP(CDR(BgL_cdrzd252081zd2_8195)))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg6510z00_8199;
																																												obj_t
																																													BgL_arg6511z00_8200;
																																												BgL_arg6510z00_8199
																																													=
																																													CAR
																																													(BgL_cdrzd252081zd2_8195);
																																												BgL_arg6511z00_8200
																																													=
																																													CDR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_27078;
																																													{
																																														obj_t
																																															BgL_argsz00_27080;
																																														obj_t
																																															BgL_bodyz00_27079;
																																														BgL_bodyz00_27079
																																															=
																																															BgL_arg6510z00_8199;
																																														BgL_argsz00_27080
																																															=
																																															BgL_arg6511z00_8200;
																																														BgL_argsz00_1761
																																															=
																																															BgL_argsz00_27080;
																																														BgL_bodyz00_1760
																																															=
																																															BgL_bodyz00_27079;
																																														goto
																																															BgL_tagzd2381zd2_1762;
																																													}
																																													BgL_auxz00_22135
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_27078);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test10169z00_27082;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg6575z00_8306;
																																													BgL_arg6575z00_8306
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10169z00_27082
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg6575z00_8306));
																																												}
																																												if (BgL_test10169z00_27082)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_27087;
																																														goto
																																															BgL_tagzd2384zd2_1767;
																																														BgL_auxz00_22135
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_27087);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd252159zd2_8203;
																																														BgL_carzd252159zd2_8203
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd252164zd2_8204;
																																															BgL_cdrzd252164zd2_8204
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd252159zd2_8203));
																																															if ((CAR(((obj_t) BgL_carzd252159zd2_8203)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg6516z00_8207;
																																																	obj_t
																																																		BgL_arg6517z00_8208;
																																																	obj_t
																																																		BgL_arg6518z00_8209;
																																																	BgL_arg6516z00_8207
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8204));
																																																	BgL_arg6517z00_8208
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd252164zd2_8204));
																																																	BgL_arg6518z00_8209
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_27104;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_27107;
																																																			obj_t
																																																				BgL_bodyz00_27106;
																																																			obj_t
																																																				BgL_varsz00_27105;
																																																			BgL_varsz00_27105
																																																				=
																																																				BgL_arg6516z00_8207;
																																																			BgL_bodyz00_27106
																																																				=
																																																				BgL_arg6517z00_8208;
																																																			BgL_argsz00_27107
																																																				=
																																																				BgL_arg6518z00_8209;
																																																			BgL_argsz00_1774
																																																				=
																																																				BgL_argsz00_27107;
																																																			BgL_bodyz00_1773
																																																				=
																																																				BgL_bodyz00_27106;
																																																			BgL_varsz00_1772
																																																				=
																																																				BgL_varsz00_27105;
																																																			goto
																																																				BgL_tagzd2386zd2_1775;
																																																		}
																																																		BgL_auxz00_22135
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27104);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd252187zd2_8211;
																																																	BgL_cdrzd252187zd2_8211
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_cdrzd252193zd2_8212;
																																																		BgL_cdrzd252193zd2_8212
																																																			=
																																																			CDR
																																																			(
																																																			((obj_t) BgL_carzd252159zd2_8203));
																																																		if ((CAR(((obj_t) BgL_carzd252159zd2_8203)) == CNST_TABLE_REF(((long) 1))))
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd252199zd2_8215;
																																																				BgL_cdrzd252199zd2_8215
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_cdrzd252193zd2_8212));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_carzd252204zd2_8216;
																																																					obj_t
																																																						BgL_cdrzd252205zd2_8217;
																																																					BgL_carzd252204zd2_8216
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8215));
																																																					BgL_cdrzd252205zd2_8217
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd252199zd2_8215));
																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252204zd2_8216))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd252205zd2_8217))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd252212zd2_8220;
																																																									BgL_carzd252212zd2_8220
																																																										=
																																																										CAR
																																																										(BgL_cdrzd252205zd2_8217);
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252212zd2_8220))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(BgL_cdrzd252205zd2_8217)))
																																																												{	/* Ast/sexp.scm 119 */
																																																													bool_t
																																																														BgL_test10176z00_27134;
																																																													{
																																																														obj_t
																																																															BgL_l1455z00_8253;
																																																														BgL_l1455z00_8253
																																																															=
																																																															BgL_cdrzd252187zd2_8211;
																																																													BgL_zc3z04anonymousza36541ze3z87_8254:
																																																														if (NULLP(BgL_l1455z00_8253))
																																																															{	/* Ast/sexp.scm 119 */
																																																																BgL_test10176z00_27134
																																																																	=
																																																																	(
																																																																	(bool_t)
																																																																	1);
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																bool_t
																																																																	BgL_test10178z00_27137;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test10179z00_27138;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_tmpz00_27139;
																																																																		BgL_tmpz00_27139
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_l1455z00_8253));
																																																																		BgL_test10179z00_27138
																																																																			=
																																																																			PAIRP
																																																																			(BgL_tmpz00_27139);
																																																																	}
																																																																	if (BgL_test10179z00_27138)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			BgL_test10178z00_27137
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				0);
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			BgL_test10178z00_27137
																																																																				=
																																																																				(
																																																																				(bool_t)
																																																																				1);
																																																																		}
																																																																}
																																																																if (BgL_test10178z00_27137)
																																																																	{
																																																																		obj_t
																																																																			BgL_l1455z00_27143;
																																																																		BgL_l1455z00_27143
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_l1455z00_8253));
																																																																		BgL_l1455z00_8253
																																																																			=
																																																																			BgL_l1455z00_27143;
																																																																		goto
																																																																			BgL_zc3z04anonymousza36541ze3z87_8254;
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test10176z00_27134
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			0);
																																																																	}
																																																															}
																																																													}
																																																													if (BgL_test10176z00_27134)
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_arg6531z00_8236;
																																																															BgL_arg6531z00_8236
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd252193zd2_8212));
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27148;
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_27152;
																																																																	obj_t
																																																																		BgL_proc2z00_27151;
																																																																	obj_t
																																																																		BgL_proc1z00_27150;
																																																																	obj_t
																																																																		BgL_testz00_27149;
																																																																	BgL_testz00_27149
																																																																		=
																																																																		BgL_arg6531z00_8236;
																																																																	BgL_proc1z00_27150
																																																																		=
																																																																		BgL_carzd252204zd2_8216;
																																																																	BgL_proc2z00_27151
																																																																		=
																																																																		BgL_carzd252212zd2_8220;
																																																																	BgL_argsz00_27152
																																																																		=
																																																																		BgL_cdrzd252187zd2_8211;
																																																																	BgL_argsz00_1779
																																																																		=
																																																																		BgL_argsz00_27152;
																																																																	BgL_proc2z00_1778
																																																																		=
																																																																		BgL_proc2z00_27151;
																																																																	BgL_proc1z00_1777
																																																																		=
																																																																		BgL_proc1z00_27150;
																																																																	BgL_testz00_1776
																																																																		=
																																																																		BgL_testz00_27149;
																																																																	goto
																																																																		BgL_tagzd2387zd2_1780;
																																																																}
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27148);
																																																															}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd252236zd2_8237;
																																																															BgL_cdrzd252236zd2_8237
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd252243zd2_8238;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_13062;
																																																																	BgL_pairz00_13062
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd252243zd2_8238
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_13062);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd252250zd2_8239;
																																																																	BgL_cdrzd252250zd2_8239
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd252243zd2_8238));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd252256zd2_8240;
																																																																		BgL_carzd252256zd2_8240
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd252250zd2_8239));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252256zd2_8240))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd252263zd2_8242;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_13066;
																																																																					BgL_pairz00_13066
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd252250zd2_8239));
																																																																					BgL_carzd252263zd2_8242
																																																																						=
																																																																						CAR
																																																																						(BgL_pairz00_13066);
																																																																				}
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252263zd2_8242))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252236zd2_8237))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg6535z00_8245;
																																																																								BgL_arg6535z00_8245
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd252243zd2_8238));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27174;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27178;
																																																																										obj_t
																																																																											BgL_proc2z00_27177;
																																																																										obj_t
																																																																											BgL_proc1z00_27176;
																																																																										obj_t
																																																																											BgL_testz00_27175;
																																																																										BgL_testz00_27175
																																																																											=
																																																																											BgL_arg6535z00_8245;
																																																																										BgL_proc1z00_27176
																																																																											=
																																																																											BgL_carzd252256zd2_8240;
																																																																										BgL_proc2z00_27177
																																																																											=
																																																																											BgL_carzd252263zd2_8242;
																																																																										BgL_argsz00_27178
																																																																											=
																																																																											BgL_cdrzd252236zd2_8237;
																																																																										BgL_argsz00_1784
																																																																											=
																																																																											BgL_argsz00_27178;
																																																																										BgL_proc2z00_1783
																																																																											=
																																																																											BgL_proc2z00_27177;
																																																																										BgL_proc1z00_1782
																																																																											=
																																																																											BgL_proc1z00_27176;
																																																																										BgL_testz00_1781
																																																																											=
																																																																											BgL_testz00_27175;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1785;
																																																																									}
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27174);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27182;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_22135
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27182);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27186;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_22135
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27186);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27190;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_22135
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27190);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27194;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27194);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd252539zd2_8264;
																																																											BgL_cdrzd252539zd2_8264
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd252545zd2_8265;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_13070;
																																																													BgL_pairz00_13070
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd252545zd2_8265
																																																														=
																																																														CDR
																																																														(BgL_pairz00_13070);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd252551zd2_8266;
																																																													BgL_cdrzd252551zd2_8266
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd252545zd2_8265));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd252556zd2_8267;
																																																														obj_t
																																																															BgL_cdrzd252557zd2_8268;
																																																														BgL_carzd252556zd2_8267
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8266));
																																																														BgL_cdrzd252557zd2_8268
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd252551zd2_8266));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252556zd2_8267))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd252562zd2_8270;
																																																																BgL_carzd252562zd2_8270
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd252557zd2_8268));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252562zd2_8270))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(((obj_t) BgL_cdrzd252557zd2_8268))))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252539zd2_8264))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg6550z00_8275;
																																																																						BgL_arg6550z00_8275
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd252545zd2_8265));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27221;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_27225;
																																																																								obj_t
																																																																									BgL_proc2z00_27224;
																																																																								obj_t
																																																																									BgL_proc1z00_27223;
																																																																								obj_t
																																																																									BgL_testz00_27222;
																																																																								BgL_testz00_27222
																																																																									=
																																																																									BgL_arg6550z00_8275;
																																																																								BgL_proc1z00_27223
																																																																									=
																																																																									BgL_carzd252556zd2_8267;
																																																																								BgL_proc2z00_27224
																																																																									=
																																																																									BgL_carzd252562zd2_8270;
																																																																								BgL_argsz00_27225
																																																																									=
																																																																									BgL_cdrzd252539zd2_8264;
																																																																								BgL_argsz00_1784
																																																																									=
																																																																									BgL_argsz00_27225;
																																																																								BgL_proc2z00_1783
																																																																									=
																																																																									BgL_proc2z00_27224;
																																																																								BgL_proc1z00_1782
																																																																									=
																																																																									BgL_proc1z00_27223;
																																																																								BgL_testz00_1781
																																																																									=
																																																																									BgL_testz00_27222;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1785;
																																																																							}
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27221);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27229;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_22135
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27229);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27233;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_22135
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27233);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27237;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27237);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27241;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_22135
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27241);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1809;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_27245;
																																																											goto
																																																												BgL_tagzd2404zd2_1810;
																																																											BgL_auxz00_22135
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_27245);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd252895zd2_8283;
																																																							BgL_cdrzd252895zd2_8283
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd252902zd2_8284;
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_pairz00_13080;
																																																									BgL_pairz00_13080
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									BgL_cdrzd252902zd2_8284
																																																										=
																																																										CDR
																																																										(BgL_pairz00_13080);
																																																								}
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd252909zd2_8285;
																																																									BgL_cdrzd252909zd2_8285
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd252902zd2_8284));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd252915zd2_8286;
																																																										obj_t
																																																											BgL_cdrzd252916zd2_8287;
																																																										BgL_carzd252915zd2_8286
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8285));
																																																										BgL_cdrzd252916zd2_8287
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd252909zd2_8285));
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252915zd2_8286))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd252916zd2_8287))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd252923zd2_8290;
																																																														BgL_carzd252923zd2_8290
																																																															=
																																																															CAR
																																																															(BgL_cdrzd252916zd2_8287);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd252923zd2_8290))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd252916zd2_8287)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd252895zd2_8283))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6564z00_8295;
																																																																				BgL_arg6564z00_8295
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd252902zd2_8284));
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27272;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_27276;
																																																																						obj_t
																																																																							BgL_proc2z00_27275;
																																																																						obj_t
																																																																							BgL_proc1z00_27274;
																																																																						obj_t
																																																																							BgL_testz00_27273;
																																																																						BgL_testz00_27273
																																																																							=
																																																																							BgL_arg6564z00_8295;
																																																																						BgL_proc1z00_27274
																																																																							=
																																																																							BgL_carzd252915zd2_8286;
																																																																						BgL_proc2z00_27275
																																																																							=
																																																																							BgL_carzd252923zd2_8290;
																																																																						BgL_argsz00_27276
																																																																							=
																																																																							BgL_cdrzd252895zd2_8283;
																																																																						BgL_argsz00_1784
																																																																							=
																																																																							BgL_argsz00_27276;
																																																																						BgL_proc2z00_1783
																																																																							=
																																																																							BgL_proc2z00_27275;
																																																																						BgL_proc1z00_1782
																																																																							=
																																																																							BgL_proc1z00_27274;
																																																																						BgL_testz00_1781
																																																																							=
																																																																							BgL_testz00_27273;
																																																																						goto
																																																																							BgL_tagzd2388zd2_1785;
																																																																					}
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27272);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27280;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_22135
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27280);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27284;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27284);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27288;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_22135
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27288);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27292;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27292);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_27296;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_22135
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_27296);
																																																													}
																																																											}
																																																									}
																																																								}
																																																							}
																																																						}
																																																				}
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																					{	/* Ast/sexp.scm 119 */
																																																						goto
																																																							BgL_tagzd2403zd2_1809;
																																																					}
																																																				else
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27300;
																																																						goto
																																																							BgL_tagzd2404zd2_1810;
																																																						BgL_auxz00_22135
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27300);
																																																					}
																																																			}
																																																	}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test10207z00_27302;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg6586z00_8319;
																																											BgL_arg6586z00_8319
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10207z00_27302
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg6586z00_8319));
																																										}
																																										if (BgL_test10207z00_27302)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_27307;
																																												goto
																																													BgL_tagzd2384zd2_1767;
																																												BgL_auxz00_22135
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27307);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_carzd253369zd2_8310;
																																												BgL_carzd253369zd2_8310
																																													=
																																													CAR
																																													(
																																													((obj_t) BgL_expz00_21));
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_cdrzd253374zd2_8311;
																																													BgL_cdrzd253374zd2_8311
																																														=
																																														CDR
																																														(
																																														((obj_t) BgL_carzd253369zd2_8310));
																																													if ((CAR(((obj_t) BgL_carzd253369zd2_8310)) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6581z00_8314;
																																															obj_t
																																																BgL_arg6582z00_8315;
																																															obj_t
																																																BgL_arg6583z00_8316;
																																															BgL_arg6581z00_8314
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8311));
																																															BgL_arg6582z00_8315
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_cdrzd253374zd2_8311));
																																															BgL_arg6583z00_8316
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_27324;
																																																{
																																																	obj_t
																																																		BgL_argsz00_27327;
																																																	obj_t
																																																		BgL_bodyz00_27326;
																																																	obj_t
																																																		BgL_varsz00_27325;
																																																	BgL_varsz00_27325
																																																		=
																																																		BgL_arg6581z00_8314;
																																																	BgL_bodyz00_27326
																																																		=
																																																		BgL_arg6582z00_8315;
																																																	BgL_argsz00_27327
																																																		=
																																																		BgL_arg6583z00_8316;
																																																	BgL_argsz00_1774
																																																		=
																																																		BgL_argsz00_27327;
																																																	BgL_bodyz00_1773
																																																		=
																																																		BgL_bodyz00_27326;
																																																	BgL_varsz00_1772
																																																		=
																																																		BgL_varsz00_27325;
																																																	goto
																																																		BgL_tagzd2386zd2_1775;
																																																}
																																																BgL_auxz00_22135
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27324);
																																															}
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2403zd2_1809;
																																																}
																																															else
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27331;
																																																	goto
																																																		BgL_tagzd2404zd2_1810;
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27331);
																																																}
																																														}
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								bool_t
																																									BgL_test10210z00_27333;
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg6590z00_8323;
																																									BgL_arg6590z00_8323
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_test10210z00_27333
																																										=
																																										CBOOL
																																										(BGl_labelszd2symzf3z21zzast_labelsz00
																																										(BgL_arg6590z00_8323));
																																								}
																																								if (BgL_test10210z00_27333)
																																									{
																																										BgL_letzd2funzd2_bglt
																																											BgL_auxz00_27338;
																																										goto
																																											BgL_tagzd2384zd2_1767;
																																										BgL_auxz00_22135
																																											=
																																											(
																																											(obj_t)
																																											BgL_auxz00_27338);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_tagzd2403zd2_1809;
																																											}
																																										else
																																											{
																																												BgL_nodez00_bglt
																																													BgL_auxz00_27342;
																																												goto
																																													BgL_tagzd2404zd2_1810;
																																												BgL_auxz00_22135
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_27342);
																																											}
																																									}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd252076zd2_8074)))
																																							{	/* Ast/sexp.scm 119 */
																																								goto
																																									BgL_kapzd252078zd2_8076;
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd252076zd2_8074 == CNST_TABLE_REF(((long) 18))))
																																									{	/* Ast/sexp.scm 119 */
																																										goto
																																											BgL_kapzd252078zd2_8076;
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if ((BgL_carzd252076zd2_8074 == CNST_TABLE_REF(((long) 19))))
																																											{	/* Ast/sexp.scm 119 */
																																												goto
																																													BgL_kapzd252078zd2_8076;
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd252076zd2_8074)))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_kapzd252078zd2_8076;
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test10216z00_27356;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg6505z00_8193;
																																															BgL_arg6505z00_8193
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10216z00_27356
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg6505z00_8193));
																																														}
																																														if (BgL_test10216z00_27356)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27361;
																																																goto
																																																	BgL_tagzd2384zd2_1767;
																																																BgL_auxz00_22135
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27361);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd253697zd2_8084;
																																																BgL_carzd253697zd2_8084
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd253702zd2_8085;
																																																	BgL_cdrzd253702zd2_8085
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd253697zd2_8084));
																																																	if ((CAR(((obj_t) BgL_carzd253697zd2_8084)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (PAIRP(BgL_cdrzd253702zd2_8085))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg6441z00_8089;
																																																					obj_t
																																																						BgL_arg6442z00_8090;
																																																					obj_t
																																																						BgL_arg6443z00_8091;
																																																					BgL_arg6441z00_8089
																																																						=
																																																						CAR
																																																						(BgL_cdrzd253702zd2_8085);
																																																					BgL_arg6442z00_8090
																																																						=
																																																						CDR
																																																						(BgL_cdrzd253702zd2_8085);
																																																					BgL_arg6443z00_8091
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27378;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27381;
																																																							obj_t
																																																								BgL_bodyz00_27380;
																																																							obj_t
																																																								BgL_varsz00_27379;
																																																							BgL_varsz00_27379
																																																								=
																																																								BgL_arg6441z00_8089;
																																																							BgL_bodyz00_27380
																																																								=
																																																								BgL_arg6442z00_8090;
																																																							BgL_argsz00_27381
																																																								=
																																																								BgL_arg6443z00_8091;
																																																							BgL_argsz00_1774
																																																								=
																																																								BgL_argsz00_27381;
																																																							BgL_bodyz00_1773
																																																								=
																																																								BgL_bodyz00_27380;
																																																							BgL_varsz00_1772
																																																								=
																																																								BgL_varsz00_27379;
																																																							goto
																																																								BgL_tagzd2386zd2_1775;
																																																						}
																																																						BgL_auxz00_22135
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27378);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2403zd2_1809;
																																																						}
																																																					else
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_27385;
																																																							goto
																																																								BgL_tagzd2404zd2_1810;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27385);
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd253809zd2_8094;
																																																			BgL_cdrzd253809zd2_8094
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd253814zd2_8095;
																																																				BgL_cdrzd253814zd2_8095
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd253697zd2_8084));
																																																				if ((CAR(((obj_t) BgL_carzd253697zd2_8084)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (PAIRP(BgL_cdrzd253814zd2_8095))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd253819zd2_8099;
																																																								BgL_cdrzd253819zd2_8099
																																																									=
																																																									CDR
																																																									(BgL_cdrzd253814zd2_8095);
																																																								if (PAIRP(BgL_cdrzd253819zd2_8099))
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_carzd253823zd2_8101;
																																																										obj_t
																																																											BgL_cdrzd253824zd2_8102;
																																																										BgL_carzd253823zd2_8101
																																																											=
																																																											CAR
																																																											(BgL_cdrzd253819zd2_8099);
																																																										BgL_cdrzd253824zd2_8102
																																																											=
																																																											CDR
																																																											(BgL_cdrzd253819zd2_8099);
																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253823zd2_8101))
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (PAIRP(BgL_cdrzd253824zd2_8102))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd253829zd2_8105;
																																																														BgL_carzd253829zd2_8105
																																																															=
																																																															CAR
																																																															(BgL_cdrzd253824zd2_8102);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253829zd2_8105))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (NULLP(CDR(BgL_cdrzd253824zd2_8102)))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test10227z00_27413;
																																																																		{
																																																																			obj_t
																																																																				BgL_l1458z00_8138;
																																																																			BgL_l1458z00_8138
																																																																				=
																																																																				BgL_cdrzd253809zd2_8094;
																																																																		BgL_zc3z04anonymousza36469ze3z87_8139:
																																																																			if (NULLP(BgL_l1458z00_8138))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test10227z00_27413
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test10229z00_27416;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10230z00_27417;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_tmpz00_27418;
																																																																							BgL_tmpz00_27418
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_l1458z00_8138));
																																																																							BgL_test10230z00_27417
																																																																								=
																																																																								PAIRP
																																																																								(BgL_tmpz00_27418);
																																																																						}
																																																																						if (BgL_test10230z00_27417)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test10229z00_27416
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test10229z00_27416
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									1);
																																																																							}
																																																																					}
																																																																					if (BgL_test10229z00_27416)
																																																																						{
																																																																							obj_t
																																																																								BgL_l1458z00_27422;
																																																																							BgL_l1458z00_27422
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_l1458z00_8138));
																																																																							BgL_l1458z00_8138
																																																																								=
																																																																								BgL_l1458z00_27422;
																																																																							goto
																																																																								BgL_zc3z04anonymousza36469ze3z87_8139;
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test10227z00_27413
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																				}
																																																																		}
																																																																		if (BgL_test10227z00_27413)
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg6459z00_8121;
																																																																				BgL_arg6459z00_8121
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd253814zd2_8095);
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27426;
																																																																					{
																																																																						obj_t
																																																																							BgL_argsz00_27430;
																																																																						obj_t
																																																																							BgL_proc2z00_27429;
																																																																						obj_t
																																																																							BgL_proc1z00_27428;
																																																																						obj_t
																																																																							BgL_testz00_27427;
																																																																						BgL_testz00_27427
																																																																							=
																																																																							BgL_arg6459z00_8121;
																																																																						BgL_proc1z00_27428
																																																																							=
																																																																							BgL_carzd253823zd2_8101;
																																																																						BgL_proc2z00_27429
																																																																							=
																																																																							BgL_carzd253829zd2_8105;
																																																																						BgL_argsz00_27430
																																																																							=
																																																																							BgL_cdrzd253809zd2_8094;
																																																																						BgL_argsz00_1779
																																																																							=
																																																																							BgL_argsz00_27430;
																																																																						BgL_proc2z00_1778
																																																																							=
																																																																							BgL_proc2z00_27429;
																																																																						BgL_proc1z00_1777
																																																																							=
																																																																							BgL_proc1z00_27428;
																																																																						BgL_testz00_1776
																																																																							=
																																																																							BgL_testz00_27427;
																																																																						goto
																																																																							BgL_tagzd2387zd2_1780;
																																																																					}
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27426);
																																																																				}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd253854zd2_8122;
																																																																				BgL_cdrzd253854zd2_8122
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd253862zd2_8123;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_13125;
																																																																						BgL_pairz00_13125
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd253862zd2_8123
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_13125);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd253870zd2_8124;
																																																																						BgL_cdrzd253870zd2_8124
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd253862zd2_8123));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd253877zd2_8125;
																																																																							BgL_carzd253877zd2_8125
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd253870zd2_8124));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253877zd2_8125))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd253886zd2_8127;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_13129;
																																																																										BgL_pairz00_13129
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd253870zd2_8124));
																																																																										BgL_carzd253886zd2_8127
																																																																											=
																																																																											CAR
																																																																											(BgL_pairz00_13129);
																																																																									}
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd253886zd2_8127))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd253854zd2_8122))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg6463z00_8130;
																																																																													BgL_arg6463z00_8130
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd253862zd2_8123));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27452;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_27456;
																																																																															obj_t
																																																																																BgL_proc2z00_27455;
																																																																															obj_t
																																																																																BgL_proc1z00_27454;
																																																																															obj_t
																																																																																BgL_testz00_27453;
																																																																															BgL_testz00_27453
																																																																																=
																																																																																BgL_arg6463z00_8130;
																																																																															BgL_proc1z00_27454
																																																																																=
																																																																																BgL_carzd253877zd2_8125;
																																																																															BgL_proc2z00_27455
																																																																																=
																																																																																BgL_carzd253886zd2_8127;
																																																																															BgL_argsz00_27456
																																																																																=
																																																																																BgL_cdrzd253854zd2_8122;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_27456;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_27455;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_27454;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_27453;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_22135
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27452);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_27460;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_22135
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_27460);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27464;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27464);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27468;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27468);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27472;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_22135
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27472);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd254164zd2_8149;
																																																																BgL_cdrzd254164zd2_8149
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd254171zd2_8150;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_13133;
																																																																		BgL_pairz00_13133
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd254171zd2_8150
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_13133);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd254178zd2_8151;
																																																																		BgL_cdrzd254178zd2_8151
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd254171zd2_8150));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd254184zd2_8152;
																																																																			obj_t
																																																																				BgL_cdrzd254185zd2_8153;
																																																																			BgL_carzd254184zd2_8152
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8151));
																																																																			BgL_cdrzd254185zd2_8153
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd254178zd2_8151));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254184zd2_8152))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd254192zd2_8155;
																																																																					BgL_carzd254192zd2_8155
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_cdrzd254185zd2_8153));
																																																																					if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254192zd2_8155))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(((obj_t) BgL_cdrzd254185zd2_8153))))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254164zd2_8149))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_arg6478z00_8160;
																																																																											BgL_arg6478z00_8160
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd254171zd2_8150));
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27499;
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_27503;
																																																																													obj_t
																																																																														BgL_proc2z00_27502;
																																																																													obj_t
																																																																														BgL_proc1z00_27501;
																																																																													obj_t
																																																																														BgL_testz00_27500;
																																																																													BgL_testz00_27500
																																																																														=
																																																																														BgL_arg6478z00_8160;
																																																																													BgL_proc1z00_27501
																																																																														=
																																																																														BgL_carzd254184zd2_8152;
																																																																													BgL_proc2z00_27502
																																																																														=
																																																																														BgL_carzd254192zd2_8155;
																																																																													BgL_argsz00_27503
																																																																														=
																																																																														BgL_cdrzd254164zd2_8149;
																																																																													BgL_argsz00_1784
																																																																														=
																																																																														BgL_argsz00_27503;
																																																																													BgL_proc2z00_1783
																																																																														=
																																																																														BgL_proc2z00_27502;
																																																																													BgL_proc1z00_1782
																																																																														=
																																																																														BgL_proc1z00_27501;
																																																																													BgL_testz00_1781
																																																																														=
																																																																														BgL_testz00_27500;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1785;
																																																																												}
																																																																												BgL_auxz00_22135
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27499);
																																																																											}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27507;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_22135
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27507);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27511;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27511);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27515;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27515);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27519;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27519);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_27523;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_22135
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_27523);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd254525zd2_8168;
																																																												BgL_cdrzd254525zd2_8168
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_expz00_21));
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd254531zd2_8169;
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_pairz00_13143;
																																																														BgL_pairz00_13143
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_expz00_21));
																																																														BgL_cdrzd254531zd2_8169
																																																															=
																																																															CDR
																																																															(BgL_pairz00_13143);
																																																													}
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd254537zd2_8170;
																																																														BgL_cdrzd254537zd2_8170
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd254531zd2_8169));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd254542zd2_8171;
																																																															obj_t
																																																																BgL_cdrzd254543zd2_8172;
																																																															BgL_carzd254542zd2_8171
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8170));
																																																															BgL_cdrzd254543zd2_8172
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd254537zd2_8170));
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254542zd2_8171))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (PAIRP(BgL_cdrzd254543zd2_8172))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd254548zd2_8175;
																																																																			BgL_carzd254548zd2_8175
																																																																				=
																																																																				CAR
																																																																				(BgL_cdrzd254543zd2_8172);
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd254548zd2_8175))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (NULLP(CDR(BgL_cdrzd254543zd2_8172)))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd254525zd2_8168))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg6492z00_8180;
																																																																									BgL_arg6492z00_8180
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd254531zd2_8169));
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27550;
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_27554;
																																																																											obj_t
																																																																												BgL_proc2z00_27553;
																																																																											obj_t
																																																																												BgL_proc1z00_27552;
																																																																											obj_t
																																																																												BgL_testz00_27551;
																																																																											BgL_testz00_27551
																																																																												=
																																																																												BgL_arg6492z00_8180;
																																																																											BgL_proc1z00_27552
																																																																												=
																																																																												BgL_carzd254542zd2_8171;
																																																																											BgL_proc2z00_27553
																																																																												=
																																																																												BgL_carzd254548zd2_8175;
																																																																											BgL_argsz00_27554
																																																																												=
																																																																												BgL_cdrzd254525zd2_8168;
																																																																											BgL_argsz00_1784
																																																																												=
																																																																												BgL_argsz00_27554;
																																																																											BgL_proc2z00_1783
																																																																												=
																																																																												BgL_proc2z00_27553;
																																																																											BgL_proc1z00_1782
																																																																												=
																																																																												BgL_proc1z00_27552;
																																																																											BgL_testz00_1781
																																																																												=
																																																																												BgL_testz00_27551;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1785;
																																																																										}
																																																																										BgL_auxz00_22135
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27550);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27558;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_22135
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27558);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27562;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_22135
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27562);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_27566;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_22135
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_27566);
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																				}
																																																																			else
																																																																				{
																																																																					BgL_nodez00_bglt
																																																																						BgL_auxz00_27570;
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																					BgL_auxz00_22135
																																																																						=
																																																																						(
																																																																						(obj_t)
																																																																						BgL_auxz00_27570);
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27574;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_22135
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27574);
																																																																		}
																																																																}
																																																														}
																																																													}
																																																												}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1809;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_27578;
																																																												goto
																																																													BgL_tagzd2404zd2_1810;
																																																												BgL_auxz00_22135
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_27578);
																																																											}
																																																									}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1809;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27582;
																																																										goto
																																																											BgL_tagzd2404zd2_1810;
																																																										BgL_auxz00_22135
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27582);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1809;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_27586;
																																																								goto
																																																									BgL_tagzd2404zd2_1810;
																																																								BgL_auxz00_22135
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_27586);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (
																																				(BgL_carzd252073zd2_8072
																																					==
																																					CNST_TABLE_REF
																																					(((long) 20))))
																																				{
																																					BgL_nodez00_bglt
																																						BgL_auxz00_27591;
																																					goto
																																						BgL_tagzd2383zd2_1766;
																																					BgL_auxz00_22135
																																						=
																																						(
																																						(obj_t)
																																						BgL_auxz00_27591);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_carzd255110zd2_8326;
																																					BgL_carzd255110zd2_8326
																																						=
																																						CAR(
																																						((obj_t) BgL_expz00_21));
																																					if (
																																						(BgL_carzd255110zd2_8326
																																							==
																																							CNST_TABLE_REF
																																							(((long) 19))))
																																						{
																																							BgL_letzd2funzd2_bglt
																																								BgL_auxz00_27598;
																																							goto
																																								BgL_tagzd2384zd2_1767;
																																							BgL_auxz00_22135
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_27598);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255110zd2_8326)))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_27603;
																																									goto
																																										BgL_tagzd2384zd2_1767;
																																									BgL_auxz00_22135
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_27603);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27610;
																																											goto
																																												BgL_tagzd2389zd2_1786;
																																											BgL_auxz00_22135
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27610);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_27617;
																																													goto
																																														BgL_tagzd2390zd2_1787;
																																													BgL_auxz00_22135
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_27617);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_27624;
																																															goto
																																																BgL_tagzd2392zd2_1791;
																																															BgL_auxz00_22135
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_27624);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27631;
																																																	goto
																																																		BgL_tagzd2393zd2_1792;
																																																	BgL_auxz00_22135
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27631);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_27638;
																																																			goto
																																																				BgL_tagzd2395zd2_1796;
																																																			BgL_auxz00_22135
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_27638);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_27645;
																																																					goto
																																																						BgL_tagzd2396zd2_1797;
																																																					BgL_auxz00_22135
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_27645);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																						{
																																																							BgL_letzd2funzd2_bglt
																																																								BgL_auxz00_27652;
																																																							goto
																																																								BgL_tagzd2397zd2_1798;
																																																							BgL_auxz00_22135
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_27652);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																								{
																																																									BgL_jumpzd2exzd2itz00_bglt
																																																										BgL_auxz00_27659;
																																																									goto
																																																										BgL_tagzd2398zd2_1799;
																																																									BgL_auxz00_22135
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_27659);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27669;
																																																													goto
																																																														BgL_tagzd2402zd2_1808;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27669);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27673;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_22135
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27673);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_27677;
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																													BgL_auxz00_22135
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_27677);
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																							return
																								((BgL_nodez00_bglt)
																								BgL_auxz00_22135);
																						}
																					else
																						{	/* Ast/sexp.scm 119 */
																							if (
																								(BgL_carzd231447zd2_5113 ==
																									BGl_za2ifza2z00zzast_sexpz00))
																								{
																									obj_t BgL_auxz00_27682;

																									goto BgL_kapzd231449zd2_5115;
																									return
																										((BgL_nodez00_bglt)
																										BgL_auxz00_27682);
																								}
																							else
																								{	/* Ast/sexp.scm 119 */
																									bool_t BgL_test10276z00_27684;

																									{	/* Ast/sexp.scm 119 */
																										obj_t BgL_arg4857z00_5860;

																										BgL_arg4857z00_5860 =
																											CAR(BgL_expz00_21);
																										BgL_test10276z00_27684 =
																											(BgL_arg4857z00_5860 ==
																											BGl_za2ifza2z00zzast_sexpz00);
																									}
																									if (BgL_test10276z00_27684)
																										{	/* Ast/sexp.scm 119 */
																											goto
																												BgL_tagzd2377zd2_1754;
																										}
																									else
																										{	/* Ast/sexp.scm 119 */
																											obj_t
																												BgL_cdrzd255282zd2_5120;
																											BgL_cdrzd255282zd2_5120 =
																												CDR(BgL_expz00_21);
																											if ((CAR(BgL_expz00_21) ==
																													CNST_TABLE_REF(((long)
																															7))))
																												{	/* Ast/sexp.scm 119 */
																													if (PAIRP
																														(BgL_cdrzd255282zd2_5120))
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd255285zd2_5124;
																															obj_t
																																BgL_cdrzd255286zd2_5125;
																															BgL_carzd255285zd2_5124
																																=
																																CAR
																																(BgL_cdrzd255282zd2_5120);
																															BgL_cdrzd255286zd2_5125
																																=
																																CDR
																																(BgL_cdrzd255282zd2_5120);
																															if (PAIRP
																																(BgL_carzd255285zd2_5124))
																																{	/* Ast/sexp.scm 119 */
																																	if (
																																		(CAR
																																			(BgL_carzd255285zd2_5124)
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					14))))
																																		{	/* Ast/sexp.scm 119 */
																																			if (PAIRP
																																				(BgL_cdrzd255286zd2_5125))
																																				{	/* Ast/sexp.scm 119 */
																																					if (NULLP(CDR(BgL_cdrzd255286zd2_5125)))
																																						{
																																							obj_t
																																								BgL_valz00_27709;
																																							obj_t
																																								BgL_lz00_27707;
																																							BgL_lz00_27707
																																								=
																																								CDR
																																								(BgL_carzd255285zd2_5124);
																																							BgL_valz00_27709
																																								=
																																								CAR
																																								(BgL_cdrzd255286zd2_5125);
																																							BgL_valz00_1756
																																								=
																																								BgL_valz00_27709;
																																							BgL_lz00_1755
																																								=
																																								BgL_lz00_27707;
																																							goto
																																								BgL_tagzd2378zd2_1757;
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							goto
																																								BgL_tagzd2379zd2_1758;
																																						}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					goto
																																						BgL_tagzd2379zd2_1758;
																																				}
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			goto
																																				BgL_tagzd2379zd2_1758;
																																		}
																																}
																															else
																																{	/* Ast/sexp.scm 119 */
																																	goto
																																		BgL_tagzd2379zd2_1758;
																																}
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															goto
																																BgL_tagzd2379zd2_1758;
																														}
																												}
																											else
																												{	/* Ast/sexp.scm 119 */
																													if (
																														(CAR(BgL_expz00_21)
																															==
																															CNST_TABLE_REF((
																																	(long) 16))))
																														{	/* Ast/sexp.scm 119 */
																															goto
																																BgL_tagzd2380zd2_1759;
																														}
																													else
																														{	/* Ast/sexp.scm 119 */
																															obj_t
																																BgL_carzd255411zd2_5138;
																															BgL_carzd255411zd2_5138
																																=
																																CAR
																																(BgL_expz00_21);
																															if (PAIRP
																																(BgL_carzd255411zd2_5138))
																																{	/* Ast/sexp.scm 119 */
																																	obj_t
																																		BgL_carzd255414zd2_5140;
																																	obj_t
																																		BgL_cdrzd255415zd2_5141;
																																	BgL_carzd255414zd2_5140
																																		=
																																		CAR
																																		(BgL_carzd255411zd2_5138);
																																	BgL_cdrzd255415zd2_5141
																																		=
																																		CDR
																																		(BgL_carzd255411zd2_5138);
																																	{

																																		if (
																																			(BgL_carzd255414zd2_5140
																																				==
																																				CNST_TABLE_REF
																																				(((long)
																																						17))))
																																			{
																																				obj_t
																																					BgL_auxz00_27723;
																																			BgL_kapzd255416zd2_5142:
																																				if (PAIRP(BgL_cdrzd255415zd2_5141))
																																					{	/* Ast/sexp.scm 119 */
																																						obj_t
																																							BgL_cdrzd255419zd2_5444;
																																						BgL_cdrzd255419zd2_5444
																																							=
																																							CDR
																																							(BgL_cdrzd255415zd2_5141);
																																						if (PAIRP(BgL_cdrzd255419zd2_5444))
																																							{	/* Ast/sexp.scm 119 */
																																								if (NULLP(CDR(BgL_cdrzd255419zd2_5444)))
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_arg4554z00_5448;
																																										obj_t
																																											BgL_arg4555z00_5449;
																																										BgL_arg4554z00_5448
																																											=
																																											CAR
																																											(BgL_cdrzd255419zd2_5444);
																																										BgL_arg4555z00_5449
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{
																																											BgL_nodez00_bglt
																																												BgL_auxz00_27735;
																																											{
																																												obj_t
																																													BgL_argsz00_27737;
																																												obj_t
																																													BgL_bodyz00_27736;
																																												BgL_bodyz00_27736
																																													=
																																													BgL_arg4554z00_5448;
																																												BgL_argsz00_27737
																																													=
																																													BgL_arg4555z00_5449;
																																												BgL_argsz00_1761
																																													=
																																													BgL_argsz00_27737;
																																												BgL_bodyz00_1760
																																													=
																																													BgL_bodyz00_27736;
																																												goto
																																													BgL_tagzd2381zd2_1762;
																																											}
																																											BgL_auxz00_27723
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_27735);
																																										}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										obj_t
																																											BgL_cdrzd255442zd2_5450;
																																										BgL_cdrzd255442zd2_5450
																																											=
																																											CDR
																																											(
																																											((obj_t) BgL_expz00_21));
																																										{

																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test10289z00_27741;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4622z00_5560;
																																													BgL_arg4622z00_5560
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10289z00_27741
																																														=
																																														CBOOL
																																														(BGl_letzd2symzf3z21zzast_letz00
																																														(BgL_arg4622z00_5560));
																																												}
																																												if (BgL_test10289z00_27741)
																																													{	/* Ast/sexp.scm 119 */
																																														if (PAIRP(BgL_cdrzd255442zd2_5450))
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_arg4624z00_5562;
																																																obj_t
																																																	BgL_arg4625z00_5563;
																																																BgL_arg4624z00_5562
																																																	=
																																																	CAR
																																																	(BgL_cdrzd255442zd2_5450);
																																																BgL_arg4625z00_5563
																																																	=
																																																	CDR
																																																	(BgL_cdrzd255442zd2_5450);
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_27750;
																																																	{
																																																		obj_t
																																																			BgL_exprz00_27752;
																																																		obj_t
																																																			BgL_bindingsz00_27751;
																																																		BgL_bindingsz00_27751
																																																			=
																																																			BgL_arg4624z00_5562;
																																																		BgL_exprz00_27752
																																																			=
																																																			BgL_arg4625z00_5563;
																																																		BgL_exprz00_1764
																																																			=
																																																			BgL_exprz00_27752;
																																																		BgL_bindingsz00_1763
																																																			=
																																																			BgL_bindingsz00_27751;
																																																		goto
																																																			BgL_tagzd2382zd2_1765;
																																																	}
																																																	BgL_auxz00_27723
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_27750);
																																																}
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test10291z00_27754;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4689z00_5669;
																																																	BgL_arg4689z00_5669
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	BgL_test10291z00_27754
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4689z00_5669));
																																																}
																																																if (BgL_test10291z00_27754)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_27759;
																																																		goto
																																																			BgL_tagzd2384zd2_1767;
																																																		BgL_auxz00_27723
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_27759);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd255506zd2_5566;
																																																		BgL_carzd255506zd2_5566
																																																			=
																																																			CAR
																																																			(
																																																			((obj_t) BgL_expz00_21));
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd255511zd2_5567;
																																																			BgL_cdrzd255511zd2_5567
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd255506zd2_5566));
																																																			if ((CAR(((obj_t) BgL_carzd255506zd2_5566)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_arg4630z00_5570;
																																																					obj_t
																																																						BgL_arg4631z00_5571;
																																																					obj_t
																																																						BgL_arg4632z00_5572;
																																																					BgL_arg4630z00_5570
																																																						=
																																																						CAR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5567));
																																																					BgL_arg4631z00_5571
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_cdrzd255511zd2_5567));
																																																					BgL_arg4632z00_5572
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{
																																																						BgL_nodez00_bglt
																																																							BgL_auxz00_27776;
																																																						{
																																																							obj_t
																																																								BgL_argsz00_27779;
																																																							obj_t
																																																								BgL_bodyz00_27778;
																																																							obj_t
																																																								BgL_varsz00_27777;
																																																							BgL_varsz00_27777
																																																								=
																																																								BgL_arg4630z00_5570;
																																																							BgL_bodyz00_27778
																																																								=
																																																								BgL_arg4631z00_5571;
																																																							BgL_argsz00_27779
																																																								=
																																																								BgL_arg4632z00_5572;
																																																							BgL_argsz00_1774
																																																								=
																																																								BgL_argsz00_27779;
																																																							BgL_bodyz00_1773
																																																								=
																																																								BgL_bodyz00_27778;
																																																							BgL_varsz00_1772
																																																								=
																																																								BgL_varsz00_27777;
																																																							goto
																																																								BgL_tagzd2386zd2_1775;
																																																						}
																																																						BgL_auxz00_27723
																																																							=
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_27776);
																																																					}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd255534zd2_5574;
																																																					BgL_cdrzd255534zd2_5574
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_expz00_21));
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd255540zd2_5575;
																																																						BgL_cdrzd255540zd2_5575
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_carzd255506zd2_5566));
																																																						if ((CAR(((obj_t) BgL_carzd255506zd2_5566)) == CNST_TABLE_REF(((long) 1))))
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd255546zd2_5578;
																																																								BgL_cdrzd255546zd2_5578
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_cdrzd255540zd2_5575));
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_carzd255551zd2_5579;
																																																									obj_t
																																																										BgL_cdrzd255552zd2_5580;
																																																									BgL_carzd255551zd2_5579
																																																										=
																																																										CAR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5578));
																																																									BgL_cdrzd255552zd2_5580
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_cdrzd255546zd2_5578));
																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255551zd2_5579))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd255552zd2_5580))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd255559zd2_5583;
																																																													BgL_carzd255559zd2_5583
																																																														=
																																																														CAR
																																																														(BgL_cdrzd255552zd2_5580);
																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255559zd2_5583))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (NULLP(CDR(BgL_cdrzd255552zd2_5580)))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	bool_t
																																																																		BgL_test10298z00_27806;
																																																																	{
																																																																		obj_t
																																																																			BgL_l1461z00_5616;
																																																																		BgL_l1461z00_5616
																																																																			=
																																																																			BgL_cdrzd255534zd2_5574;
																																																																	BgL_zc3z04anonymousza34655ze3z87_5617:
																																																																		if (NULLP(BgL_l1461z00_5616))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test10298z00_27806
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					1);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				bool_t
																																																																					BgL_test10300z00_27809;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					bool_t
																																																																						BgL_test10301z00_27810;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_tmpz00_27811;
																																																																						BgL_tmpz00_27811
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_l1461z00_5616));
																																																																						BgL_test10301z00_27810
																																																																							=
																																																																							PAIRP
																																																																							(BgL_tmpz00_27811);
																																																																					}
																																																																					if (BgL_test10301z00_27810)
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test10300z00_27809
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								0);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							BgL_test10300z00_27809
																																																																								=
																																																																								(
																																																																								(bool_t)
																																																																								1);
																																																																						}
																																																																				}
																																																																				if (BgL_test10300z00_27809)
																																																																					{
																																																																						obj_t
																																																																							BgL_l1461z00_27815;
																																																																						BgL_l1461z00_27815
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_l1461z00_5616));
																																																																						BgL_l1461z00_5616
																																																																							=
																																																																							BgL_l1461z00_27815;
																																																																						goto
																																																																							BgL_zc3z04anonymousza34655ze3z87_5617;
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test10298z00_27806
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							0);
																																																																					}
																																																																			}
																																																																	}
																																																																	if (BgL_test10298z00_27806)
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_arg4645z00_5599;
																																																																			BgL_arg4645z00_5599
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd255540zd2_5575));
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27820;
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_27824;
																																																																					obj_t
																																																																						BgL_proc2z00_27823;
																																																																					obj_t
																																																																						BgL_proc1z00_27822;
																																																																					obj_t
																																																																						BgL_testz00_27821;
																																																																					BgL_testz00_27821
																																																																						=
																																																																						BgL_arg4645z00_5599;
																																																																					BgL_proc1z00_27822
																																																																						=
																																																																						BgL_carzd255551zd2_5579;
																																																																					BgL_proc2z00_27823
																																																																						=
																																																																						BgL_carzd255559zd2_5583;
																																																																					BgL_argsz00_27824
																																																																						=
																																																																						BgL_cdrzd255534zd2_5574;
																																																																					BgL_argsz00_1779
																																																																						=
																																																																						BgL_argsz00_27824;
																																																																					BgL_proc2z00_1778
																																																																						=
																																																																						BgL_proc2z00_27823;
																																																																					BgL_proc1z00_1777
																																																																						=
																																																																						BgL_proc1z00_27822;
																																																																					BgL_testz00_1776
																																																																						=
																																																																						BgL_testz00_27821;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1780;
																																																																				}
																																																																				BgL_auxz00_27723
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27820);
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd255583zd2_5600;
																																																																			BgL_cdrzd255583zd2_5600
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd255590zd2_5601;
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_pairz00_13219;
																																																																					BgL_pairz00_13219
																																																																						=
																																																																						CAR
																																																																						(
																																																																						((obj_t) BgL_expz00_21));
																																																																					BgL_cdrzd255590zd2_5601
																																																																						=
																																																																						CDR
																																																																						(BgL_pairz00_13219);
																																																																				}
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd255597zd2_5602;
																																																																					BgL_cdrzd255597zd2_5602
																																																																						=
																																																																						CDR
																																																																						(
																																																																						((obj_t) BgL_cdrzd255590zd2_5601));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd255603zd2_5603;
																																																																						BgL_carzd255603zd2_5603
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd255597zd2_5602));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255603zd2_5603))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd255610zd2_5605;
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_pairz00_13223;
																																																																									BgL_pairz00_13223
																																																																										=
																																																																										CDR
																																																																										(
																																																																										((obj_t) BgL_cdrzd255597zd2_5602));
																																																																									BgL_carzd255610zd2_5605
																																																																										=
																																																																										CAR
																																																																										(BgL_pairz00_13223);
																																																																								}
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255610zd2_5605))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255583zd2_5600))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4649z00_5608;
																																																																												BgL_arg4649z00_5608
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd255590zd2_5601));
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_27846;
																																																																													{
																																																																														obj_t
																																																																															BgL_argsz00_27850;
																																																																														obj_t
																																																																															BgL_proc2z00_27849;
																																																																														obj_t
																																																																															BgL_proc1z00_27848;
																																																																														obj_t
																																																																															BgL_testz00_27847;
																																																																														BgL_testz00_27847
																																																																															=
																																																																															BgL_arg4649z00_5608;
																																																																														BgL_proc1z00_27848
																																																																															=
																																																																															BgL_carzd255603zd2_5603;
																																																																														BgL_proc2z00_27849
																																																																															=
																																																																															BgL_carzd255610zd2_5605;
																																																																														BgL_argsz00_27850
																																																																															=
																																																																															BgL_cdrzd255583zd2_5600;
																																																																														BgL_argsz00_1784
																																																																															=
																																																																															BgL_argsz00_27850;
																																																																														BgL_proc2z00_1783
																																																																															=
																																																																															BgL_proc2z00_27849;
																																																																														BgL_proc1z00_1782
																																																																															=
																																																																															BgL_proc1z00_27848;
																																																																														BgL_testz00_1781
																																																																															=
																																																																															BgL_testz00_27847;
																																																																														goto
																																																																															BgL_tagzd2388zd2_1785;
																																																																													}
																																																																													BgL_auxz00_27723
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_27846);
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																													}
																																																																												else
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_27854;
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																														BgL_auxz00_27723
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_27854);
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27858;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_27723
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27858);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27862;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_27723
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27862);
																																																																									}
																																																																							}
																																																																					}
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			goto
																																																																				BgL_tagzd2403zd2_1809;
																																																																		}
																																																																	else
																																																																		{
																																																																			BgL_nodez00_bglt
																																																																				BgL_auxz00_27866;
																																																																			goto
																																																																				BgL_tagzd2404zd2_1810;
																																																																			BgL_auxz00_27723
																																																																				=
																																																																				(
																																																																				(obj_t)
																																																																				BgL_auxz00_27866);
																																																																		}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd255886zd2_5627;
																																																															BgL_cdrzd255886zd2_5627
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd255892zd2_5628;
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_pairz00_13227;
																																																																	BgL_pairz00_13227
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	BgL_cdrzd255892zd2_5628
																																																																		=
																																																																		CDR
																																																																		(BgL_pairz00_13227);
																																																																}
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd255898zd2_5629;
																																																																	BgL_cdrzd255898zd2_5629
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_cdrzd255892zd2_5628));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd255903zd2_5630;
																																																																		obj_t
																																																																			BgL_cdrzd255904zd2_5631;
																																																																		BgL_carzd255903zd2_5630
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5629));
																																																																		BgL_cdrzd255904zd2_5631
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd255898zd2_5629));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255903zd2_5630))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd255909zd2_5633;
																																																																				BgL_carzd255909zd2_5633
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd255904zd2_5631));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd255909zd2_5633))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(((obj_t) BgL_cdrzd255904zd2_5631))))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd255886zd2_5627))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4664z00_5638;
																																																																										BgL_arg4664z00_5638
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd255892zd2_5628));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_27893;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_27897;
																																																																												obj_t
																																																																													BgL_proc2z00_27896;
																																																																												obj_t
																																																																													BgL_proc1z00_27895;
																																																																												obj_t
																																																																													BgL_testz00_27894;
																																																																												BgL_testz00_27894
																																																																													=
																																																																													BgL_arg4664z00_5638;
																																																																												BgL_proc1z00_27895
																																																																													=
																																																																													BgL_carzd255903zd2_5630;
																																																																												BgL_proc2z00_27896
																																																																													=
																																																																													BgL_carzd255909zd2_5633;
																																																																												BgL_argsz00_27897
																																																																													=
																																																																													BgL_cdrzd255886zd2_5627;
																																																																												BgL_argsz00_1784
																																																																													=
																																																																													BgL_argsz00_27897;
																																																																												BgL_proc2z00_1783
																																																																													=
																																																																													BgL_proc2z00_27896;
																																																																												BgL_proc1z00_1782
																																																																													=
																																																																													BgL_proc1z00_27895;
																																																																												BgL_testz00_1781
																																																																													=
																																																																													BgL_testz00_27894;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1785;
																																																																											}
																																																																											BgL_auxz00_27723
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_27893);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_27901;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_27723
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_27901);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27905;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_27723
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27905);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27909;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_27723
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27909);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27913;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_27723
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27913);
																																																																					}
																																																																			}
																																																																	}
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_27917;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_27723
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_27917);
																																																														}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd256242zd2_5646;
																																																											BgL_cdrzd256242zd2_5646
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd256249zd2_5647;
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_pairz00_13237;
																																																													BgL_pairz00_13237
																																																														=
																																																														CAR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													BgL_cdrzd256249zd2_5647
																																																														=
																																																														CDR
																																																														(BgL_pairz00_13237);
																																																												}
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd256256zd2_5648;
																																																													BgL_cdrzd256256zd2_5648
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_cdrzd256249zd2_5647));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd256262zd2_5649;
																																																														obj_t
																																																															BgL_cdrzd256263zd2_5650;
																																																														BgL_carzd256262zd2_5649
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5648));
																																																														BgL_cdrzd256263zd2_5650
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd256256zd2_5648));
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256262zd2_5649))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd256263zd2_5650))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd256270zd2_5653;
																																																																		BgL_carzd256270zd2_5653
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd256263zd2_5650);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256270zd2_5653))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd256263zd2_5650)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256242zd2_5646))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4678z00_5658;
																																																																								BgL_arg4678z00_5658
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd256249zd2_5647));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_27944;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_27948;
																																																																										obj_t
																																																																											BgL_proc2z00_27947;
																																																																										obj_t
																																																																											BgL_proc1z00_27946;
																																																																										obj_t
																																																																											BgL_testz00_27945;
																																																																										BgL_testz00_27945
																																																																											=
																																																																											BgL_arg4678z00_5658;
																																																																										BgL_proc1z00_27946
																																																																											=
																																																																											BgL_carzd256262zd2_5649;
																																																																										BgL_proc2z00_27947
																																																																											=
																																																																											BgL_carzd256270zd2_5653;
																																																																										BgL_argsz00_27948
																																																																											=
																																																																											BgL_cdrzd256242zd2_5646;
																																																																										BgL_argsz00_1784
																																																																											=
																																																																											BgL_argsz00_27948;
																																																																										BgL_proc2z00_1783
																																																																											=
																																																																											BgL_proc2z00_27947;
																																																																										BgL_proc1z00_1782
																																																																											=
																																																																											BgL_proc1z00_27946;
																																																																										BgL_testz00_1781
																																																																											=
																																																																											BgL_testz00_27945;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1785;
																																																																									}
																																																																									BgL_auxz00_27723
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_27944);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_27952;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_27723
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_27952);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_27956;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_27723
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_27956);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_27960;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_27723
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_27960);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_27964;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_27723
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_27964);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_27968;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_27723
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_27968);
																																																																	}
																																																															}
																																																													}
																																																												}
																																																											}
																																																										}
																																																								}
																																																							}
																																																						else
																																																							{	/* Ast/sexp.scm 119 */
																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																									{	/* Ast/sexp.scm 119 */
																																																										goto
																																																											BgL_tagzd2403zd2_1809;
																																																									}
																																																								else
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_27972;
																																																										goto
																																																											BgL_tagzd2404zd2_1810;
																																																										BgL_auxz00_27723
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_27972);
																																																									}
																																																							}
																																																					}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test10329z00_27974;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4621z00_5559;
																																															BgL_arg4621z00_5559
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10329z00_27974
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4621z00_5559));
																																														}
																																														if (BgL_test10329z00_27974)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_27979;
																																																goto
																																																	BgL_tagzd2384zd2_1767;
																																																BgL_auxz00_27723
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_27979);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd256702zd2_5456;
																																																BgL_carzd256702zd2_5456
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd256707zd2_5457;
																																																	BgL_cdrzd256707zd2_5457
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd256702zd2_5456));
																																																	if ((CAR(((obj_t) BgL_carzd256702zd2_5456)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4562z00_5460;
																																																			obj_t
																																																				BgL_arg4563z00_5461;
																																																			obj_t
																																																				BgL_arg4564z00_5462;
																																																			BgL_arg4562z00_5460
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5457));
																																																			BgL_arg4563z00_5461
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd256707zd2_5457));
																																																			BgL_arg4564z00_5462
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_27996;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_27999;
																																																					obj_t
																																																						BgL_bodyz00_27998;
																																																					obj_t
																																																						BgL_varsz00_27997;
																																																					BgL_varsz00_27997
																																																						=
																																																						BgL_arg4562z00_5460;
																																																					BgL_bodyz00_27998
																																																						=
																																																						BgL_arg4563z00_5461;
																																																					BgL_argsz00_27999
																																																						=
																																																						BgL_arg4564z00_5462;
																																																					BgL_argsz00_1774
																																																						=
																																																						BgL_argsz00_27999;
																																																					BgL_bodyz00_1773
																																																						=
																																																						BgL_bodyz00_27998;
																																																					BgL_varsz00_1772
																																																						=
																																																						BgL_varsz00_27997;
																																																					goto
																																																						BgL_tagzd2386zd2_1775;
																																																				}
																																																				BgL_auxz00_27723
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_27996);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd256730zd2_5464;
																																																			BgL_cdrzd256730zd2_5464
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_cdrzd256736zd2_5465;
																																																				BgL_cdrzd256736zd2_5465
																																																					=
																																																					CDR
																																																					(
																																																					((obj_t) BgL_carzd256702zd2_5456));
																																																				if ((CAR(((obj_t) BgL_carzd256702zd2_5456)) == CNST_TABLE_REF(((long) 1))))
																																																					{	/* Ast/sexp.scm 119 */
																																																						obj_t
																																																							BgL_cdrzd256742zd2_5468;
																																																						BgL_cdrzd256742zd2_5468
																																																							=
																																																							CDR
																																																							(
																																																							((obj_t) BgL_cdrzd256736zd2_5465));
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd256747zd2_5469;
																																																							obj_t
																																																								BgL_cdrzd256748zd2_5470;
																																																							BgL_carzd256747zd2_5469
																																																								=
																																																								CAR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5468));
																																																							BgL_cdrzd256748zd2_5470
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_cdrzd256742zd2_5468));
																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256747zd2_5469))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd256748zd2_5470))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd256755zd2_5473;
																																																											BgL_carzd256755zd2_5473
																																																												=
																																																												CAR
																																																												(BgL_cdrzd256748zd2_5470);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256755zd2_5473))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(BgL_cdrzd256748zd2_5470)))
																																																														{	/* Ast/sexp.scm 119 */
																																																															bool_t
																																																																BgL_test10336z00_28026;
																																																															{
																																																																obj_t
																																																																	BgL_l1464z00_5506;
																																																																BgL_l1464z00_5506
																																																																	=
																																																																	BgL_cdrzd256730zd2_5464;
																																																															BgL_zc3z04anonymousza34587ze3z87_5507:
																																																																if (NULLP(BgL_l1464z00_5506))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		BgL_test10336z00_28026
																																																																			=
																																																																			(
																																																																			(bool_t)
																																																																			1);
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		bool_t
																																																																			BgL_test10338z00_28029;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test10339z00_28030;
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_tmpz00_28031;
																																																																				BgL_tmpz00_28031
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_l1464z00_5506));
																																																																				BgL_test10339z00_28030
																																																																					=
																																																																					PAIRP
																																																																					(BgL_tmpz00_28031);
																																																																			}
																																																																			if (BgL_test10339z00_28030)
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test10338z00_28029
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						0);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					BgL_test10338z00_28029
																																																																						=
																																																																						(
																																																																						(bool_t)
																																																																						1);
																																																																				}
																																																																		}
																																																																		if (BgL_test10338z00_28029)
																																																																			{
																																																																				obj_t
																																																																					BgL_l1464z00_28035;
																																																																				BgL_l1464z00_28035
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_l1464z00_5506));
																																																																				BgL_l1464z00_5506
																																																																					=
																																																																					BgL_l1464z00_28035;
																																																																				goto
																																																																					BgL_zc3z04anonymousza34587ze3z87_5507;
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				BgL_test10336z00_28026
																																																																					=
																																																																					(
																																																																					(bool_t)
																																																																					0);
																																																																			}
																																																																	}
																																																															}
																																																															if (BgL_test10336z00_28026)
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_arg4577z00_5489;
																																																																	BgL_arg4577z00_5489
																																																																		=
																																																																		CAR
																																																																		(
																																																																		((obj_t) BgL_cdrzd256736zd2_5465));
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_28040;
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_28044;
																																																																			obj_t
																																																																				BgL_proc2z00_28043;
																																																																			obj_t
																																																																				BgL_proc1z00_28042;
																																																																			obj_t
																																																																				BgL_testz00_28041;
																																																																			BgL_testz00_28041
																																																																				=
																																																																				BgL_arg4577z00_5489;
																																																																			BgL_proc1z00_28042
																																																																				=
																																																																				BgL_carzd256747zd2_5469;
																																																																			BgL_proc2z00_28043
																																																																				=
																																																																				BgL_carzd256755zd2_5473;
																																																																			BgL_argsz00_28044
																																																																				=
																																																																				BgL_cdrzd256730zd2_5464;
																																																																			BgL_argsz00_1779
																																																																				=
																																																																				BgL_argsz00_28044;
																																																																			BgL_proc2z00_1778
																																																																				=
																																																																				BgL_proc2z00_28043;
																																																																			BgL_proc1z00_1777
																																																																				=
																																																																				BgL_proc1z00_28042;
																																																																			BgL_testz00_1776
																																																																				=
																																																																				BgL_testz00_28041;
																																																																			goto
																																																																				BgL_tagzd2387zd2_1780;
																																																																		}
																																																																		BgL_auxz00_27723
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_28040);
																																																																	}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd256779zd2_5490;
																																																																	BgL_cdrzd256779zd2_5490
																																																																		=
																																																																		CDR
																																																																		(
																																																																		((obj_t) BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd256786zd2_5491;
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_pairz00_13272;
																																																																			BgL_pairz00_13272
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_expz00_21));
																																																																			BgL_cdrzd256786zd2_5491
																																																																				=
																																																																				CDR
																																																																				(BgL_pairz00_13272);
																																																																		}
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd256793zd2_5492;
																																																																			BgL_cdrzd256793zd2_5492
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd256786zd2_5491));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd256799zd2_5493;
																																																																				BgL_carzd256799zd2_5493
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd256793zd2_5492));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256799zd2_5493))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd256806zd2_5495;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_pairz00_13276;
																																																																							BgL_pairz00_13276
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd256793zd2_5492));
																																																																							BgL_carzd256806zd2_5495
																																																																								=
																																																																								CAR
																																																																								(BgL_pairz00_13276);
																																																																						}
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd256806zd2_5495))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd256779zd2_5490))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4581z00_5498;
																																																																										BgL_arg4581z00_5498
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd256786zd2_5491));
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28066;
																																																																											{
																																																																												obj_t
																																																																													BgL_argsz00_28070;
																																																																												obj_t
																																																																													BgL_proc2z00_28069;
																																																																												obj_t
																																																																													BgL_proc1z00_28068;
																																																																												obj_t
																																																																													BgL_testz00_28067;
																																																																												BgL_testz00_28067
																																																																													=
																																																																													BgL_arg4581z00_5498;
																																																																												BgL_proc1z00_28068
																																																																													=
																																																																													BgL_carzd256799zd2_5493;
																																																																												BgL_proc2z00_28069
																																																																													=
																																																																													BgL_carzd256806zd2_5495;
																																																																												BgL_argsz00_28070
																																																																													=
																																																																													BgL_cdrzd256779zd2_5490;
																																																																												BgL_argsz00_1784
																																																																													=
																																																																													BgL_argsz00_28070;
																																																																												BgL_proc2z00_1783
																																																																													=
																																																																													BgL_proc2z00_28069;
																																																																												BgL_proc1z00_1782
																																																																													=
																																																																													BgL_proc1z00_28068;
																																																																												BgL_testz00_1781
																																																																													=
																																																																													BgL_testz00_28067;
																																																																												goto
																																																																													BgL_tagzd2388zd2_1785;
																																																																											}
																																																																											BgL_auxz00_27723
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28066);
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																											}
																																																																										else
																																																																											{
																																																																												BgL_nodez00_bglt
																																																																													BgL_auxz00_28074;
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																												BgL_auxz00_27723
																																																																													=
																																																																													(
																																																																													(obj_t)
																																																																													BgL_auxz00_28074);
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_28078;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_27723
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_28078);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28082;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_27723
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28082);
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_28086;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_27723
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_28086);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd257082zd2_5517;
																																																													BgL_cdrzd257082zd2_5517
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_expz00_21));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd257088zd2_5518;
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_pairz00_13280;
																																																															BgL_pairz00_13280
																																																																=
																																																																CAR
																																																																(
																																																																((obj_t) BgL_expz00_21));
																																																															BgL_cdrzd257088zd2_5518
																																																																=
																																																																CDR
																																																																(BgL_pairz00_13280);
																																																														}
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd257094zd2_5519;
																																																															BgL_cdrzd257094zd2_5519
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd257088zd2_5518));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd257099zd2_5520;
																																																																obj_t
																																																																	BgL_cdrzd257100zd2_5521;
																																																																BgL_carzd257099zd2_5520
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5519));
																																																																BgL_cdrzd257100zd2_5521
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd257094zd2_5519));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257099zd2_5520))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd257105zd2_5523;
																																																																		BgL_carzd257105zd2_5523
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd257100zd2_5521));
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257105zd2_5523))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(((obj_t) BgL_cdrzd257100zd2_5521))))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257082zd2_5517))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4596z00_5528;
																																																																								BgL_arg4596z00_5528
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd257088zd2_5518));
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28113;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_28117;
																																																																										obj_t
																																																																											BgL_proc2z00_28116;
																																																																										obj_t
																																																																											BgL_proc1z00_28115;
																																																																										obj_t
																																																																											BgL_testz00_28114;
																																																																										BgL_testz00_28114
																																																																											=
																																																																											BgL_arg4596z00_5528;
																																																																										BgL_proc1z00_28115
																																																																											=
																																																																											BgL_carzd257099zd2_5520;
																																																																										BgL_proc2z00_28116
																																																																											=
																																																																											BgL_carzd257105zd2_5523;
																																																																										BgL_argsz00_28117
																																																																											=
																																																																											BgL_cdrzd257082zd2_5517;
																																																																										BgL_argsz00_1784
																																																																											=
																																																																											BgL_argsz00_28117;
																																																																										BgL_proc2z00_1783
																																																																											=
																																																																											BgL_proc2z00_28116;
																																																																										BgL_proc1z00_1782
																																																																											=
																																																																											BgL_proc1z00_28115;
																																																																										BgL_testz00_1781
																																																																											=
																																																																											BgL_testz00_28114;
																																																																										goto
																																																																											BgL_tagzd2388zd2_1785;
																																																																									}
																																																																									BgL_auxz00_27723
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28113);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																									}
																																																																								else
																																																																									{
																																																																										BgL_nodez00_bglt
																																																																											BgL_auxz00_28121;
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																										BgL_auxz00_27723
																																																																											=
																																																																											(
																																																																											(obj_t)
																																																																											BgL_auxz00_28121);
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28125;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_27723
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28125);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_28129;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_27723
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_28129);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28133;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_27723
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28133);
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																												}
																																																											else
																																																												{
																																																													BgL_nodez00_bglt
																																																														BgL_auxz00_28137;
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																													BgL_auxz00_27723
																																																														=
																																																														(
																																																														(obj_t)
																																																														BgL_auxz00_28137);
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd257438zd2_5536;
																																																									BgL_cdrzd257438zd2_5536
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_cdrzd257445zd2_5537;
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_pairz00_13290;
																																																											BgL_pairz00_13290
																																																												=
																																																												CAR
																																																												(
																																																												((obj_t) BgL_expz00_21));
																																																											BgL_cdrzd257445zd2_5537
																																																												=
																																																												CDR
																																																												(BgL_pairz00_13290);
																																																										}
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd257452zd2_5538;
																																																											BgL_cdrzd257452zd2_5538
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_cdrzd257445zd2_5537));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_carzd257458zd2_5539;
																																																												obj_t
																																																													BgL_cdrzd257459zd2_5540;
																																																												BgL_carzd257458zd2_5539
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5538));
																																																												BgL_cdrzd257459zd2_5540
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd257452zd2_5538));
																																																												if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257458zd2_5539))
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (PAIRP(BgL_cdrzd257459zd2_5540))
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd257466zd2_5543;
																																																																BgL_carzd257466zd2_5543
																																																																	=
																																																																	CAR
																																																																	(BgL_cdrzd257459zd2_5540);
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd257466zd2_5543))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (NULLP(CDR(BgL_cdrzd257459zd2_5540)))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd257438zd2_5536))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4610z00_5548;
																																																																						BgL_arg4610z00_5548
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd257445zd2_5537));
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_28164;
																																																																							{
																																																																								obj_t
																																																																									BgL_argsz00_28168;
																																																																								obj_t
																																																																									BgL_proc2z00_28167;
																																																																								obj_t
																																																																									BgL_proc1z00_28166;
																																																																								obj_t
																																																																									BgL_testz00_28165;
																																																																								BgL_testz00_28165
																																																																									=
																																																																									BgL_arg4610z00_5548;
																																																																								BgL_proc1z00_28166
																																																																									=
																																																																									BgL_carzd257458zd2_5539;
																																																																								BgL_proc2z00_28167
																																																																									=
																																																																									BgL_carzd257466zd2_5543;
																																																																								BgL_argsz00_28168
																																																																									=
																																																																									BgL_cdrzd257438zd2_5536;
																																																																								BgL_argsz00_1784
																																																																									=
																																																																									BgL_argsz00_28168;
																																																																								BgL_proc2z00_1783
																																																																									=
																																																																									BgL_proc2z00_28167;
																																																																								BgL_proc1z00_1782
																																																																									=
																																																																									BgL_proc1z00_28166;
																																																																								BgL_testz00_1781
																																																																									=
																																																																									BgL_testz00_28165;
																																																																								goto
																																																																									BgL_tagzd2388zd2_1785;
																																																																							}
																																																																							BgL_auxz00_27723
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_28164);
																																																																						}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28172;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_27723
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28172);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																					}
																																																																				else
																																																																					{
																																																																						BgL_nodez00_bglt
																																																																							BgL_auxz00_28176;
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																						BgL_auxz00_27723
																																																																							=
																																																																							(
																																																																							(obj_t)
																																																																							BgL_auxz00_28176);
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28180;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_27723
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28180);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		goto
																																																																			BgL_tagzd2403zd2_1809;
																																																																	}
																																																																else
																																																																	{
																																																																		BgL_nodez00_bglt
																																																																			BgL_auxz00_28184;
																																																																		goto
																																																																			BgL_tagzd2404zd2_1810;
																																																																		BgL_auxz00_27723
																																																																			=
																																																																			(
																																																																			(obj_t)
																																																																			BgL_auxz00_28184);
																																																																	}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_28188;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_27723
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_28188);
																																																															}
																																																													}
																																																											}
																																																										}
																																																									}
																																																								}
																																																						}
																																																					}
																																																				else
																																																					{	/* Ast/sexp.scm 119 */
																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																							{	/* Ast/sexp.scm 119 */
																																																								goto
																																																									BgL_tagzd2403zd2_1809;
																																																							}
																																																						else
																																																							{
																																																								BgL_nodez00_bglt
																																																									BgL_auxz00_28192;
																																																								goto
																																																									BgL_tagzd2404zd2_1810;
																																																								BgL_auxz00_27723
																																																									=
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_28192);
																																																							}
																																																					}
																																																			}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								obj_t
																																									BgL_cdrzd257858zd2_5671;
																																								BgL_cdrzd257858zd2_5671
																																									=
																																									CDR
																																									(
																																									((obj_t) BgL_expz00_21));
																																								{

																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test10367z00_28196;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4703z00_5687;
																																											BgL_arg4703z00_5687
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10367z00_28196
																																												=
																																												CBOOL
																																												(BGl_letzd2symzf3z21zzast_letz00
																																												(BgL_arg4703z00_5687));
																																										}
																																										if (BgL_test10367z00_28196)
																																											{	/* Ast/sexp.scm 119 */
																																												if (PAIRP(BgL_cdrzd257858zd2_5671))
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_arg4705z00_5689;
																																														obj_t
																																															BgL_arg4706z00_5690;
																																														BgL_arg4705z00_5689
																																															=
																																															CAR
																																															(BgL_cdrzd257858zd2_5671);
																																														BgL_arg4706z00_5690
																																															=
																																															CDR
																																															(BgL_cdrzd257858zd2_5671);
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28205;
																																															{
																																																obj_t
																																																	BgL_exprz00_28207;
																																																obj_t
																																																	BgL_bindingsz00_28206;
																																																BgL_bindingsz00_28206
																																																	=
																																																	BgL_arg4705z00_5689;
																																																BgL_exprz00_28207
																																																	=
																																																	BgL_arg4706z00_5690;
																																																BgL_exprz00_1764
																																																	=
																																																	BgL_exprz00_28207;
																																																BgL_bindingsz00_1763
																																																	=
																																																	BgL_bindingsz00_28206;
																																																goto
																																																	BgL_tagzd2382zd2_1765;
																																															}
																																															BgL_auxz00_27723
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28205);
																																														}
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test10369z00_28209;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4716z00_5702;
																																															BgL_arg4716z00_5702
																																																=
																																																CAR
																																																(
																																																((obj_t) BgL_expz00_21));
																																															BgL_test10369z00_28209
																																																=
																																																CBOOL
																																																(BGl_labelszd2symzf3z21zzast_labelsz00
																																																(BgL_arg4716z00_5702));
																																														}
																																														if (BgL_test10369z00_28209)
																																															{
																																																BgL_letzd2funzd2_bglt
																																																	BgL_auxz00_28214;
																																																goto
																																																	BgL_tagzd2384zd2_1767;
																																																BgL_auxz00_27723
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_28214);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																obj_t
																																																	BgL_carzd257921zd2_5693;
																																																BgL_carzd257921zd2_5693
																																																	=
																																																	CAR
																																																	(
																																																	((obj_t) BgL_expz00_21));
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd257926zd2_5694;
																																																	BgL_cdrzd257926zd2_5694
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_carzd257921zd2_5693));
																																																	if ((CAR(((obj_t) BgL_carzd257921zd2_5693)) == CNST_TABLE_REF(((long) 3))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4711z00_5697;
																																																			obj_t
																																																				BgL_arg4712z00_5698;
																																																			obj_t
																																																				BgL_arg4713z00_5699;
																																																			BgL_arg4711z00_5697
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5694));
																																																			BgL_arg4712z00_5698
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_cdrzd257926zd2_5694));
																																																			BgL_arg4713z00_5699
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			{
																																																				BgL_nodez00_bglt
																																																					BgL_auxz00_28231;
																																																				{
																																																					obj_t
																																																						BgL_argsz00_28234;
																																																					obj_t
																																																						BgL_bodyz00_28233;
																																																					obj_t
																																																						BgL_varsz00_28232;
																																																					BgL_varsz00_28232
																																																						=
																																																						BgL_arg4711z00_5697;
																																																					BgL_bodyz00_28233
																																																						=
																																																						BgL_arg4712z00_5698;
																																																					BgL_argsz00_28234
																																																						=
																																																						BgL_arg4713z00_5699;
																																																					BgL_argsz00_1774
																																																						=
																																																						BgL_argsz00_28234;
																																																					BgL_bodyz00_1773
																																																						=
																																																						BgL_bodyz00_28233;
																																																					BgL_varsz00_1772
																																																						=
																																																						BgL_varsz00_28232;
																																																					goto
																																																						BgL_tagzd2386zd2_1775;
																																																				}
																																																				BgL_auxz00_27723
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_28231);
																																																			}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2403zd2_1809;
																																																				}
																																																			else
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28238;
																																																					goto
																																																						BgL_tagzd2404zd2_1810;
																																																					BgL_auxz00_27723
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28238);
																																																				}
																																																		}
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test10372z00_28240;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4702z00_5686;
																																													BgL_arg4702z00_5686
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10372z00_28240
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4702z00_5686));
																																												}
																																												if (BgL_test10372z00_28240)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_28245;
																																														goto
																																															BgL_tagzd2384zd2_1767;
																																														BgL_auxz00_27723
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28245);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														obj_t
																																															BgL_carzd258075zd2_5677;
																																														BgL_carzd258075zd2_5677
																																															=
																																															CAR
																																															(
																																															((obj_t) BgL_expz00_21));
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_cdrzd258080zd2_5678;
																																															BgL_cdrzd258080zd2_5678
																																																=
																																																CDR
																																																(
																																																((obj_t) BgL_carzd258075zd2_5677));
																																															if ((CAR(((obj_t) BgL_carzd258075zd2_5677)) == CNST_TABLE_REF(((long) 3))))
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4697z00_5681;
																																																	obj_t
																																																		BgL_arg4698z00_5682;
																																																	obj_t
																																																		BgL_arg4699z00_5683;
																																																	BgL_arg4697z00_5681
																																																		=
																																																		CAR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5678));
																																																	BgL_arg4698z00_5682
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_cdrzd258080zd2_5678));
																																																	BgL_arg4699z00_5683
																																																		=
																																																		CDR
																																																		(
																																																		((obj_t) BgL_expz00_21));
																																																	{
																																																		BgL_nodez00_bglt
																																																			BgL_auxz00_28262;
																																																		{
																																																			obj_t
																																																				BgL_argsz00_28265;
																																																			obj_t
																																																				BgL_bodyz00_28264;
																																																			obj_t
																																																				BgL_varsz00_28263;
																																																			BgL_varsz00_28263
																																																				=
																																																				BgL_arg4697z00_5681;
																																																			BgL_bodyz00_28264
																																																				=
																																																				BgL_arg4698z00_5682;
																																																			BgL_argsz00_28265
																																																				=
																																																				BgL_arg4699z00_5683;
																																																			BgL_argsz00_1774
																																																				=
																																																				BgL_argsz00_28265;
																																																			BgL_bodyz00_1773
																																																				=
																																																				BgL_bodyz00_28264;
																																																			BgL_varsz00_1772
																																																				=
																																																				BgL_varsz00_28263;
																																																			goto
																																																				BgL_tagzd2386zd2_1775;
																																																		}
																																																		BgL_auxz00_27723
																																																			=
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_28262);
																																																	}
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																		{	/* Ast/sexp.scm 119 */
																																																			goto
																																																				BgL_tagzd2403zd2_1809;
																																																		}
																																																	else
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28269;
																																																			goto
																																																				BgL_tagzd2404zd2_1810;
																																																			BgL_auxz00_27723
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28269);
																																																		}
																																																}
																																														}
																																													}
																																											}
																																									}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						obj_t
																																							BgL_cdrzd258190zd2_5703;
																																						BgL_cdrzd258190zd2_5703
																																							=
																																							CDR
																																							(((obj_t) BgL_expz00_21));
																																						{

																																							{	/* Ast/sexp.scm 119 */
																																								bool_t
																																									BgL_test10375z00_28273;
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_arg4723z00_5711;
																																									BgL_arg4723z00_5711
																																										=
																																										CAR
																																										(
																																										((obj_t) BgL_expz00_21));
																																									BgL_test10375z00_28273
																																										=
																																										CBOOL
																																										(BGl_letzd2symzf3z21zzast_letz00
																																										(BgL_arg4723z00_5711));
																																								}
																																								if (BgL_test10375z00_28273)
																																									{	/* Ast/sexp.scm 119 */
																																										if (PAIRP(BgL_cdrzd258190zd2_5703))
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_arg4725z00_5713;
																																												obj_t
																																													BgL_arg4726z00_5714;
																																												BgL_arg4725z00_5713
																																													=
																																													CAR
																																													(BgL_cdrzd258190zd2_5703);
																																												BgL_arg4726z00_5714
																																													=
																																													CDR
																																													(BgL_cdrzd258190zd2_5703);
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28282;
																																													{
																																														obj_t
																																															BgL_exprz00_28284;
																																														obj_t
																																															BgL_bindingsz00_28283;
																																														BgL_bindingsz00_28283
																																															=
																																															BgL_arg4725z00_5713;
																																														BgL_exprz00_28284
																																															=
																																															BgL_arg4726z00_5714;
																																														BgL_exprz00_1764
																																															=
																																															BgL_exprz00_28284;
																																														BgL_bindingsz00_1763
																																															=
																																															BgL_bindingsz00_28283;
																																														goto
																																															BgL_tagzd2382zd2_1765;
																																													}
																																													BgL_auxz00_27723
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28282);
																																												}
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												bool_t
																																													BgL_test10377z00_28286;
																																												{	/* Ast/sexp.scm 119 */
																																													obj_t
																																														BgL_arg4730z00_5718;
																																													BgL_arg4730z00_5718
																																														=
																																														CAR
																																														(
																																														((obj_t) BgL_expz00_21));
																																													BgL_test10377z00_28286
																																														=
																																														CBOOL
																																														(BGl_labelszd2symzf3z21zzast_labelsz00
																																														(BgL_arg4730z00_5718));
																																												}
																																												if (BgL_test10377z00_28286)
																																													{
																																														BgL_letzd2funzd2_bglt
																																															BgL_auxz00_28291;
																																														goto
																																															BgL_tagzd2384zd2_1767;
																																														BgL_auxz00_27723
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28291);
																																													}
																																												else
																																													{	/* Ast/sexp.scm 119 */
																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																															{	/* Ast/sexp.scm 119 */
																																																goto
																																																	BgL_tagzd2403zd2_1809;
																																															}
																																														else
																																															{
																																																BgL_nodez00_bglt
																																																	BgL_auxz00_28295;
																																																goto
																																																	BgL_tagzd2404zd2_1810;
																																																BgL_auxz00_27723
																																																	=
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_28295);
																																															}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										bool_t
																																											BgL_test10379z00_28297;
																																										{	/* Ast/sexp.scm 119 */
																																											obj_t
																																												BgL_arg4722z00_5710;
																																											BgL_arg4722z00_5710
																																												=
																																												CAR
																																												(
																																												((obj_t) BgL_expz00_21));
																																											BgL_test10379z00_28297
																																												=
																																												CBOOL
																																												(BGl_labelszd2symzf3z21zzast_labelsz00
																																												(BgL_arg4722z00_5710));
																																										}
																																										if (BgL_test10379z00_28297)
																																											{
																																												BgL_letzd2funzd2_bglt
																																													BgL_auxz00_28302;
																																												goto
																																													BgL_tagzd2384zd2_1767;
																																												BgL_auxz00_27723
																																													=
																																													(
																																													(obj_t)
																																													BgL_auxz00_28302);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																													{	/* Ast/sexp.scm 119 */
																																														goto
																																															BgL_tagzd2403zd2_1809;
																																													}
																																												else
																																													{
																																														BgL_nodez00_bglt
																																															BgL_auxz00_28306;
																																														goto
																																															BgL_tagzd2404zd2_1810;
																																														BgL_auxz00_27723
																																															=
																																															(
																																															(obj_t)
																																															BgL_auxz00_28306);
																																													}
																																											}
																																									}
																																							}
																																						}
																																					}
																																				return
																																					(
																																					(BgL_nodez00_bglt)
																																					BgL_auxz00_27723);
																																			}
																																		else
																																			{	/* Ast/sexp.scm 119 */
																																				if (CBOOL(BGl_letzd2symzf3z21zzast_letz00(BgL_carzd255414zd2_5140)))
																																					{
																																						obj_t
																																							BgL_auxz00_28312;
																																						goto
																																							BgL_kapzd255416zd2_5142;
																																						return
																																							(
																																							(BgL_nodez00_bglt)
																																							BgL_auxz00_28312);
																																					}
																																				else
																																					{	/* Ast/sexp.scm 119 */
																																						if (
																																							(BgL_carzd255414zd2_5140
																																								==
																																								CNST_TABLE_REF
																																								(((long) 18))))
																																							{
																																								obj_t
																																									BgL_auxz00_28317;
																																								goto
																																									BgL_kapzd255416zd2_5142;
																																								return
																																									(
																																									(BgL_nodez00_bglt)
																																									BgL_auxz00_28317);
																																							}
																																						else
																																							{	/* Ast/sexp.scm 119 */
																																								if ((BgL_carzd255414zd2_5140 == CNST_TABLE_REF(((long) 19))))
																																									{
																																										obj_t
																																											BgL_auxz00_28322;
																																										goto
																																											BgL_kapzd255416zd2_5142;
																																										return
																																											(
																																											(BgL_nodez00_bglt)
																																											BgL_auxz00_28322);
																																									}
																																								else
																																									{	/* Ast/sexp.scm 119 */
																																										if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd255414zd2_5140)))
																																											{
																																												obj_t
																																													BgL_auxz00_28327;
																																												goto
																																													BgL_kapzd255416zd2_5142;
																																												return
																																													(
																																													(BgL_nodez00_bglt)
																																													BgL_auxz00_28327);
																																											}
																																										else
																																											{	/* Ast/sexp.scm 119 */
																																												obj_t
																																													BgL_cdrzd258499zd2_5148;
																																												BgL_cdrzd258499zd2_5148
																																													=
																																													CDR
																																													(BgL_expz00_21);
																																												{

																																													{	/* Ast/sexp.scm 119 */
																																														bool_t
																																															BgL_test10385z00_28330;
																																														{	/* Ast/sexp.scm 119 */
																																															obj_t
																																																BgL_arg4474z00_5327;
																																															BgL_arg4474z00_5327
																																																=
																																																CAR
																																																(BgL_expz00_21);
																																															BgL_test10385z00_28330
																																																=
																																																CBOOL
																																																(BGl_letzd2symzf3z21zzast_letz00
																																																(BgL_arg4474z00_5327));
																																														}
																																														if (BgL_test10385z00_28330)
																																															{
																																																obj_t
																																																	BgL_auxz00_28334;
																																																if (PAIRP(BgL_cdrzd258499zd2_5148))
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_arg4476z00_5329;
																																																		obj_t
																																																			BgL_arg4477z00_5330;
																																																		BgL_arg4476z00_5329
																																																			=
																																																			CAR
																																																			(BgL_cdrzd258499zd2_5148);
																																																		BgL_arg4477z00_5330
																																																			=
																																																			CDR
																																																			(BgL_cdrzd258499zd2_5148);
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28339;
																																																			{
																																																				obj_t
																																																					BgL_exprz00_28341;
																																																				obj_t
																																																					BgL_bindingsz00_28340;
																																																				BgL_bindingsz00_28340
																																																					=
																																																					BgL_arg4476z00_5329;
																																																				BgL_exprz00_28341
																																																					=
																																																					BgL_arg4477z00_5330;
																																																				BgL_exprz00_1764
																																																					=
																																																					BgL_exprz00_28341;
																																																				BgL_bindingsz00_1763
																																																					=
																																																					BgL_bindingsz00_28340;
																																																				goto
																																																					BgL_tagzd2382zd2_1765;
																																																			}
																																																			BgL_auxz00_28334
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28339);
																																																		}
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		bool_t
																																																			BgL_test10387z00_28343;
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_arg4549z00_5442;
																																																			BgL_arg4549z00_5442
																																																				=
																																																				CAR
																																																				(
																																																				((obj_t) BgL_expz00_21));
																																																			BgL_test10387z00_28343
																																																				=
																																																				CBOOL
																																																				(BGl_labelszd2symzf3z21zzast_labelsz00
																																																				(BgL_arg4549z00_5442));
																																																		}
																																																		if (BgL_test10387z00_28343)
																																																			{
																																																				BgL_letzd2funzd2_bglt
																																																					BgL_auxz00_28348;
																																																				goto
																																																					BgL_tagzd2384zd2_1767;
																																																				BgL_auxz00_28334
																																																					=
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_28348);
																																																			}
																																																		else
																																																			{	/* Ast/sexp.scm 119 */
																																																				obj_t
																																																					BgL_carzd258562zd2_5333;
																																																				BgL_carzd258562zd2_5333
																																																					=
																																																					CAR
																																																					(
																																																					((obj_t) BgL_expz00_21));
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd258567zd2_5334;
																																																					BgL_cdrzd258567zd2_5334
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd258562zd2_5333));
																																																					if ((CAR(((obj_t) BgL_carzd258562zd2_5333)) == CNST_TABLE_REF(((long) 3))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd258567zd2_5334))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_arg4483z00_5338;
																																																									obj_t
																																																										BgL_arg4484z00_5339;
																																																									obj_t
																																																										BgL_arg4485z00_5340;
																																																									BgL_arg4483z00_5338
																																																										=
																																																										CAR
																																																										(BgL_cdrzd258567zd2_5334);
																																																									BgL_arg4484z00_5339
																																																										=
																																																										CDR
																																																										(BgL_cdrzd258567zd2_5334);
																																																									BgL_arg4485z00_5340
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_expz00_21));
																																																									{
																																																										BgL_nodez00_bglt
																																																											BgL_auxz00_28365;
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28368;
																																																											obj_t
																																																												BgL_bodyz00_28367;
																																																											obj_t
																																																												BgL_varsz00_28366;
																																																											BgL_varsz00_28366
																																																												=
																																																												BgL_arg4483z00_5338;
																																																											BgL_bodyz00_28367
																																																												=
																																																												BgL_arg4484z00_5339;
																																																											BgL_argsz00_28368
																																																												=
																																																												BgL_arg4485z00_5340;
																																																											BgL_argsz00_1774
																																																												=
																																																												BgL_argsz00_28368;
																																																											BgL_bodyz00_1773
																																																												=
																																																												BgL_bodyz00_28367;
																																																											BgL_varsz00_1772
																																																												=
																																																												BgL_varsz00_28366;
																																																											goto
																																																												BgL_tagzd2386zd2_1775;
																																																										}
																																																										BgL_auxz00_28334
																																																											=
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_28365);
																																																									}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2403zd2_1809;
																																																										}
																																																									else
																																																										{
																																																											BgL_nodez00_bglt
																																																												BgL_auxz00_28372;
																																																											goto
																																																												BgL_tagzd2404zd2_1810;
																																																											BgL_auxz00_28334
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28372);
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_cdrzd258674zd2_5343;
																																																							BgL_cdrzd258674zd2_5343
																																																								=
																																																								CDR
																																																								(
																																																								((obj_t) BgL_expz00_21));
																																																							{	/* Ast/sexp.scm 119 */
																																																								obj_t
																																																									BgL_cdrzd258679zd2_5344;
																																																								BgL_cdrzd258679zd2_5344
																																																									=
																																																									CDR
																																																									(
																																																									((obj_t) BgL_carzd258562zd2_5333));
																																																								if ((CAR(((obj_t) BgL_carzd258562zd2_5333)) == CNST_TABLE_REF(((long) 1))))
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (PAIRP(BgL_cdrzd258679zd2_5344))
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_cdrzd258684zd2_5348;
																																																												BgL_cdrzd258684zd2_5348
																																																													=
																																																													CDR
																																																													(BgL_cdrzd258679zd2_5344);
																																																												if (PAIRP(BgL_cdrzd258684zd2_5348))
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_carzd258688zd2_5350;
																																																														obj_t
																																																															BgL_cdrzd258689zd2_5351;
																																																														BgL_carzd258688zd2_5350
																																																															=
																																																															CAR
																																																															(BgL_cdrzd258684zd2_5348);
																																																														BgL_cdrzd258689zd2_5351
																																																															=
																																																															CDR
																																																															(BgL_cdrzd258684zd2_5348);
																																																														if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258688zd2_5350))
																																																															{	/* Ast/sexp.scm 119 */
																																																																if (PAIRP(BgL_cdrzd258689zd2_5351))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_carzd258694zd2_5354;
																																																																		BgL_carzd258694zd2_5354
																																																																			=
																																																																			CAR
																																																																			(BgL_cdrzd258689zd2_5351);
																																																																		if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258694zd2_5354))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (NULLP(CDR(BgL_cdrzd258689zd2_5351)))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10398z00_28400;
																																																																						{
																																																																							obj_t
																																																																								BgL_l1467z00_5387;
																																																																							BgL_l1467z00_5387
																																																																								=
																																																																								BgL_cdrzd258674zd2_5343;
																																																																						BgL_zc3z04anonymousza34511ze3z87_5388:
																																																																							if (NULLP(BgL_l1467z00_5387))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test10398z00_28400
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									bool_t
																																																																										BgL_test10400z00_28403;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										bool_t
																																																																											BgL_test10401z00_28404;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_tmpz00_28405;
																																																																											BgL_tmpz00_28405
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_l1467z00_5387));
																																																																											BgL_test10401z00_28404
																																																																												=
																																																																												PAIRP
																																																																												(BgL_tmpz00_28405);
																																																																										}
																																																																										if (BgL_test10401z00_28404)
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test10400z00_28403
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													0);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												BgL_test10400z00_28403
																																																																													=
																																																																													(
																																																																													(bool_t)
																																																																													1);
																																																																											}
																																																																									}
																																																																									if (BgL_test10400z00_28403)
																																																																										{
																																																																											obj_t
																																																																												BgL_l1467z00_28409;
																																																																											BgL_l1467z00_28409
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_l1467z00_5387));
																																																																											BgL_l1467z00_5387
																																																																												=
																																																																												BgL_l1467z00_28409;
																																																																											goto
																																																																												BgL_zc3z04anonymousza34511ze3z87_5388;
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											BgL_test10398z00_28400
																																																																												=
																																																																												(
																																																																												(bool_t)
																																																																												0);
																																																																										}
																																																																								}
																																																																						}
																																																																						if (BgL_test10398z00_28400)
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4501z00_5370;
																																																																								BgL_arg4501z00_5370
																																																																									=
																																																																									CAR
																																																																									(BgL_cdrzd258679zd2_5344);
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28413;
																																																																									{
																																																																										obj_t
																																																																											BgL_argsz00_28417;
																																																																										obj_t
																																																																											BgL_proc2z00_28416;
																																																																										obj_t
																																																																											BgL_proc1z00_28415;
																																																																										obj_t
																																																																											BgL_testz00_28414;
																																																																										BgL_testz00_28414
																																																																											=
																																																																											BgL_arg4501z00_5370;
																																																																										BgL_proc1z00_28415
																																																																											=
																																																																											BgL_carzd258688zd2_5350;
																																																																										BgL_proc2z00_28416
																																																																											=
																																																																											BgL_carzd258694zd2_5354;
																																																																										BgL_argsz00_28417
																																																																											=
																																																																											BgL_cdrzd258674zd2_5343;
																																																																										BgL_argsz00_1779
																																																																											=
																																																																											BgL_argsz00_28417;
																																																																										BgL_proc2z00_1778
																																																																											=
																																																																											BgL_proc2z00_28416;
																																																																										BgL_proc1z00_1777
																																																																											=
																																																																											BgL_proc1z00_28415;
																																																																										BgL_testz00_1776
																																																																											=
																																																																											BgL_testz00_28414;
																																																																										goto
																																																																											BgL_tagzd2387zd2_1780;
																																																																									}
																																																																									BgL_auxz00_28334
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28413);
																																																																								}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_cdrzd258719zd2_5371;
																																																																								BgL_cdrzd258719zd2_5371
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_expz00_21));
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd258727zd2_5372;
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_pairz00_13357;
																																																																										BgL_pairz00_13357
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_expz00_21));
																																																																										BgL_cdrzd258727zd2_5372
																																																																											=
																																																																											CDR
																																																																											(BgL_pairz00_13357);
																																																																									}
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_cdrzd258735zd2_5373;
																																																																										BgL_cdrzd258735zd2_5373
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd258727zd2_5372));
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_carzd258742zd2_5374;
																																																																											BgL_carzd258742zd2_5374
																																																																												=
																																																																												CAR
																																																																												(
																																																																												((obj_t) BgL_cdrzd258735zd2_5373));
																																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258742zd2_5374))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_carzd258751zd2_5376;
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_pairz00_13361;
																																																																														BgL_pairz00_13361
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd258735zd2_5373));
																																																																														BgL_carzd258751zd2_5376
																																																																															=
																																																																															CAR
																																																																															(BgL_pairz00_13361);
																																																																													}
																																																																													if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd258751zd2_5376))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd258719zd2_5371))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	obj_t
																																																																																		BgL_arg4505z00_5379;
																																																																																	BgL_arg4505z00_5379
																																																																																		=
																																																																																		CAR
																																																																																		(
																																																																																		((obj_t) BgL_cdrzd258727zd2_5372));
																																																																																	{
																																																																																		BgL_nodez00_bglt
																																																																																			BgL_auxz00_28439;
																																																																																		{
																																																																																			obj_t
																																																																																				BgL_argsz00_28443;
																																																																																			obj_t
																																																																																				BgL_proc2z00_28442;
																																																																																			obj_t
																																																																																				BgL_proc1z00_28441;
																																																																																			obj_t
																																																																																				BgL_testz00_28440;
																																																																																			BgL_testz00_28440
																																																																																				=
																																																																																				BgL_arg4505z00_5379;
																																																																																			BgL_proc1z00_28441
																																																																																				=
																																																																																				BgL_carzd258742zd2_5374;
																																																																																			BgL_proc2z00_28442
																																																																																				=
																																																																																				BgL_carzd258751zd2_5376;
																																																																																			BgL_argsz00_28443
																																																																																				=
																																																																																				BgL_cdrzd258719zd2_5371;
																																																																																			BgL_argsz00_1784
																																																																																				=
																																																																																				BgL_argsz00_28443;
																																																																																			BgL_proc2z00_1783
																																																																																				=
																																																																																				BgL_proc2z00_28442;
																																																																																			BgL_proc1z00_1782
																																																																																				=
																																																																																				BgL_proc1z00_28441;
																																																																																			BgL_testz00_1781
																																																																																				=
																																																																																				BgL_testz00_28440;
																																																																																			goto
																																																																																				BgL_tagzd2388zd2_1785;
																																																																																		}
																																																																																		BgL_auxz00_28334
																																																																																			=
																																																																																			(
																																																																																			(obj_t)
																																																																																			BgL_auxz00_28439);
																																																																																	}
																																																																																}
																																																																															else
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																		{	/* Ast/sexp.scm 119 */
																																																																																			goto
																																																																																				BgL_tagzd2403zd2_1809;
																																																																																		}
																																																																																	else
																																																																																		{
																																																																																			BgL_nodez00_bglt
																																																																																				BgL_auxz00_28447;
																																																																																			goto
																																																																																				BgL_tagzd2404zd2_1810;
																																																																																			BgL_auxz00_28334
																																																																																				=
																																																																																				(
																																																																																				(obj_t)
																																																																																				BgL_auxz00_28447);
																																																																																		}
																																																																																}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_28451;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_28334
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_28451);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28455;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_28334
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28455);
																																																																														}
																																																																												}
																																																																										}
																																																																									}
																																																																								}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																							}
																																																																						else
																																																																							{
																																																																								BgL_nodez00_bglt
																																																																									BgL_auxz00_28459;
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																								BgL_auxz00_28334
																																																																									=
																																																																									(
																																																																									(obj_t)
																																																																									BgL_auxz00_28459);
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_cdrzd259029zd2_5398;
																																																																				BgL_cdrzd259029zd2_5398
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_expz00_21));
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd259036zd2_5399;
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_pairz00_13365;
																																																																						BgL_pairz00_13365
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_expz00_21));
																																																																						BgL_cdrzd259036zd2_5399
																																																																							=
																																																																							CDR
																																																																							(BgL_pairz00_13365);
																																																																					}
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd259043zd2_5400;
																																																																						BgL_cdrzd259043zd2_5400
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd259036zd2_5399));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd259049zd2_5401;
																																																																							obj_t
																																																																								BgL_cdrzd259050zd2_5402;
																																																																							BgL_carzd259049zd2_5401
																																																																								=
																																																																								CAR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5400));
																																																																							BgL_cdrzd259050zd2_5402
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd259043zd2_5400));
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259049zd2_5401))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_carzd259057zd2_5404;
																																																																									BgL_carzd259057zd2_5404
																																																																										=
																																																																										CAR
																																																																										(
																																																																										((obj_t) BgL_cdrzd259050zd2_5402));
																																																																									if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259057zd2_5404))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (NULLP(CDR(((obj_t) BgL_cdrzd259050zd2_5402))))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259029zd2_5398))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															obj_t
																																																																																BgL_arg4520z00_5409;
																																																																															BgL_arg4520z00_5409
																																																																																=
																																																																																CAR
																																																																																(
																																																																																((obj_t) BgL_cdrzd259036zd2_5399));
																																																																															{
																																																																																BgL_nodez00_bglt
																																																																																	BgL_auxz00_28486;
																																																																																{
																																																																																	obj_t
																																																																																		BgL_argsz00_28490;
																																																																																	obj_t
																																																																																		BgL_proc2z00_28489;
																																																																																	obj_t
																																																																																		BgL_proc1z00_28488;
																																																																																	obj_t
																																																																																		BgL_testz00_28487;
																																																																																	BgL_testz00_28487
																																																																																		=
																																																																																		BgL_arg4520z00_5409;
																																																																																	BgL_proc1z00_28488
																																																																																		=
																																																																																		BgL_carzd259049zd2_5401;
																																																																																	BgL_proc2z00_28489
																																																																																		=
																																																																																		BgL_carzd259057zd2_5404;
																																																																																	BgL_argsz00_28490
																																																																																		=
																																																																																		BgL_cdrzd259029zd2_5398;
																																																																																	BgL_argsz00_1784
																																																																																		=
																																																																																		BgL_argsz00_28490;
																																																																																	BgL_proc2z00_1783
																																																																																		=
																																																																																		BgL_proc2z00_28489;
																																																																																	BgL_proc1z00_1782
																																																																																		=
																																																																																		BgL_proc1z00_28488;
																																																																																	BgL_testz00_1781
																																																																																		=
																																																																																		BgL_testz00_28487;
																																																																																	goto
																																																																																		BgL_tagzd2388zd2_1785;
																																																																																}
																																																																																BgL_auxz00_28334
																																																																																	=
																																																																																	(
																																																																																	(obj_t)
																																																																																	BgL_auxz00_28486);
																																																																															}
																																																																														}
																																																																													else
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																																{	/* Ast/sexp.scm 119 */
																																																																																	goto
																																																																																		BgL_tagzd2403zd2_1809;
																																																																																}
																																																																															else
																																																																																{
																																																																																	BgL_nodez00_bglt
																																																																																		BgL_auxz00_28494;
																																																																																	goto
																																																																																		BgL_tagzd2404zd2_1810;
																																																																																	BgL_auxz00_28334
																																																																																		=
																																																																																		(
																																																																																		(obj_t)
																																																																																		BgL_auxz00_28494);
																																																																																}
																																																																														}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28498;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_28334
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28498);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_28502;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_28334
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_28502);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28506;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_28334
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28506);
																																																																										}
																																																																								}
																																																																						}
																																																																					}
																																																																				}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																			}
																																																																		else
																																																																			{
																																																																				BgL_nodez00_bglt
																																																																					BgL_auxz00_28510;
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																				BgL_auxz00_28334
																																																																					=
																																																																					(
																																																																					(obj_t)
																																																																					BgL_auxz00_28510);
																																																																			}
																																																																	}
																																																															}
																																																														else
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_cdrzd259390zd2_5417;
																																																																BgL_cdrzd259390zd2_5417
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_expz00_21));
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd259396zd2_5418;
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_pairz00_13375;
																																																																		BgL_pairz00_13375
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_expz00_21));
																																																																		BgL_cdrzd259396zd2_5418
																																																																			=
																																																																			CDR
																																																																			(BgL_pairz00_13375);
																																																																	}
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd259402zd2_5419;
																																																																		BgL_cdrzd259402zd2_5419
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd259396zd2_5418));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_carzd259407zd2_5420;
																																																																			obj_t
																																																																				BgL_cdrzd259408zd2_5421;
																																																																			BgL_carzd259407zd2_5420
																																																																				=
																																																																				CAR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5419));
																																																																			BgL_cdrzd259408zd2_5421
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd259402zd2_5419));
																																																																			if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259407zd2_5420))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd259408zd2_5421))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_carzd259413zd2_5424;
																																																																							BgL_carzd259413zd2_5424
																																																																								=
																																																																								CAR
																																																																								(BgL_cdrzd259408zd2_5421);
																																																																							if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd259413zd2_5424))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (NULLP(CDR(BgL_cdrzd259408zd2_5421)))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd259390zd2_5417))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4536z00_5429;
																																																																													BgL_arg4536z00_5429
																																																																														=
																																																																														CAR
																																																																														(
																																																																														((obj_t) BgL_cdrzd259396zd2_5418));
																																																																													{
																																																																														BgL_nodez00_bglt
																																																																															BgL_auxz00_28537;
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28541;
																																																																															obj_t
																																																																																BgL_proc2z00_28540;
																																																																															obj_t
																																																																																BgL_proc1z00_28539;
																																																																															obj_t
																																																																																BgL_testz00_28538;
																																																																															BgL_testz00_28538
																																																																																=
																																																																																BgL_arg4536z00_5429;
																																																																															BgL_proc1z00_28539
																																																																																=
																																																																																BgL_carzd259407zd2_5420;
																																																																															BgL_proc2z00_28540
																																																																																=
																																																																																BgL_carzd259413zd2_5424;
																																																																															BgL_argsz00_28541
																																																																																=
																																																																																BgL_cdrzd259390zd2_5417;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_28541;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_28540;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_28539;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_28538;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																														BgL_auxz00_28334
																																																																															=
																																																																															(
																																																																															(obj_t)
																																																																															BgL_auxz00_28537);
																																																																													}
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																														{	/* Ast/sexp.scm 119 */
																																																																															goto
																																																																																BgL_tagzd2403zd2_1809;
																																																																														}
																																																																													else
																																																																														{
																																																																															BgL_nodez00_bglt
																																																																																BgL_auxz00_28545;
																																																																															goto
																																																																																BgL_tagzd2404zd2_1810;
																																																																															BgL_auxz00_28334
																																																																																=
																																																																																(
																																																																																(obj_t)
																																																																																BgL_auxz00_28545);
																																																																														}
																																																																												}
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													goto
																																																																														BgL_tagzd2403zd2_1809;
																																																																												}
																																																																											else
																																																																												{
																																																																													BgL_nodez00_bglt
																																																																														BgL_auxz00_28549;
																																																																													goto
																																																																														BgL_tagzd2404zd2_1810;
																																																																													BgL_auxz00_28334
																																																																														=
																																																																														(
																																																																														(obj_t)
																																																																														BgL_auxz00_28549);
																																																																												}
																																																																										}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																										}
																																																																									else
																																																																										{
																																																																											BgL_nodez00_bglt
																																																																												BgL_auxz00_28553;
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																											BgL_auxz00_28334
																																																																												=
																																																																												(
																																																																												(obj_t)
																																																																												BgL_auxz00_28553);
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																								}
																																																																							else
																																																																								{
																																																																									BgL_nodez00_bglt
																																																																										BgL_auxz00_28557;
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																									BgL_auxz00_28334
																																																																										=
																																																																										(
																																																																										(obj_t)
																																																																										BgL_auxz00_28557);
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																						}
																																																																					else
																																																																						{
																																																																							BgL_nodez00_bglt
																																																																								BgL_auxz00_28561;
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																							BgL_auxz00_28334
																																																																								=
																																																																								(
																																																																								(obj_t)
																																																																								BgL_auxz00_28561);
																																																																						}
																																																																				}
																																																																		}
																																																																	}
																																																																}
																																																															}
																																																													}
																																																												else
																																																													{	/* Ast/sexp.scm 119 */
																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																															{	/* Ast/sexp.scm 119 */
																																																																goto
																																																																	BgL_tagzd2403zd2_1809;
																																																															}
																																																														else
																																																															{
																																																																BgL_nodez00_bglt
																																																																	BgL_auxz00_28565;
																																																																goto
																																																																	BgL_tagzd2404zd2_1810;
																																																																BgL_auxz00_28334
																																																																	=
																																																																	(
																																																																	(obj_t)
																																																																	BgL_auxz00_28565);
																																																															}
																																																													}
																																																											}
																																																										else
																																																											{	/* Ast/sexp.scm 119 */
																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																													{	/* Ast/sexp.scm 119 */
																																																														goto
																																																															BgL_tagzd2403zd2_1809;
																																																													}
																																																												else
																																																													{
																																																														BgL_nodez00_bglt
																																																															BgL_auxz00_28569;
																																																														goto
																																																															BgL_tagzd2404zd2_1810;
																																																														BgL_auxz00_28334
																																																															=
																																																															(
																																																															(obj_t)
																																																															BgL_auxz00_28569);
																																																													}
																																																											}
																																																									}
																																																								else
																																																									{	/* Ast/sexp.scm 119 */
																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																											{	/* Ast/sexp.scm 119 */
																																																												goto
																																																													BgL_tagzd2403zd2_1809;
																																																											}
																																																										else
																																																											{
																																																												BgL_nodez00_bglt
																																																													BgL_auxz00_28573;
																																																												goto
																																																													BgL_tagzd2404zd2_1810;
																																																												BgL_auxz00_28334
																																																													=
																																																													(
																																																													(obj_t)
																																																													BgL_auxz00_28573);
																																																											}
																																																									}
																																																							}
																																																						}
																																																				}
																																																			}
																																																	}
																																																return
																																																	(
																																																	(BgL_nodez00_bglt)
																																																	BgL_auxz00_28334);
																																															}
																																														else
																																															{	/* Ast/sexp.scm 119 */
																																																bool_t
																																																	BgL_test10431z00_28576;
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_arg4473z00_5326;
																																																	BgL_arg4473z00_5326
																																																		=
																																																		CAR
																																																		(BgL_expz00_21);
																																																	BgL_test10431z00_28576
																																																		=
																																																		CBOOL
																																																		(BGl_labelszd2symzf3z21zzast_labelsz00
																																																		(BgL_arg4473z00_5326));
																																																}
																																																if (BgL_test10431z00_28576)
																																																	{
																																																		BgL_letzd2funzd2_bglt
																																																			BgL_auxz00_28580;
																																																		goto
																																																			BgL_tagzd2384zd2_1767;
																																																		return
																																																			(
																																																			(BgL_nodez00_bglt)
																																																			BgL_auxz00_28580);
																																																	}
																																																else
																																																	{	/* Ast/sexp.scm 119 */
																																																		obj_t
																																																			BgL_carzd259976zd2_5154;
																																																		obj_t
																																																			BgL_cdrzd259977zd2_5155;
																																																		BgL_carzd259976zd2_5154
																																																			=
																																																			CAR
																																																			(BgL_expz00_21);
																																																		BgL_cdrzd259977zd2_5155
																																																			=
																																																			CDR
																																																			(BgL_expz00_21);
																																																		{	/* Ast/sexp.scm 119 */
																																																			obj_t
																																																				BgL_cdrzd259981zd2_5156;
																																																			BgL_cdrzd259981zd2_5156
																																																				=
																																																				CDR
																																																				(
																																																				((obj_t) BgL_carzd259976zd2_5154));
																																																			if ((CAR(((obj_t) BgL_carzd259976zd2_5154)) == CNST_TABLE_REF(((long) 3))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (PAIRP(BgL_cdrzd259981zd2_5156))
																																																						{	/* Ast/sexp.scm 119 */
																																																							obj_t
																																																								BgL_carzd259984zd2_5160;
																																																							obj_t
																																																								BgL_cdrzd259985zd2_5161;
																																																							BgL_carzd259984zd2_5160
																																																								=
																																																								CAR
																																																								(BgL_cdrzd259981zd2_5156);
																																																							BgL_cdrzd259985zd2_5161
																																																								=
																																																								CDR
																																																								(BgL_cdrzd259981zd2_5156);
																																																							if (PAIRP(BgL_carzd259984zd2_5160))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (NULLP(CDR(BgL_carzd259984zd2_5160)))
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (PAIRP(BgL_cdrzd259985zd2_5161))
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_carzd259991zd2_5166;
																																																													BgL_carzd259991zd2_5166
																																																														=
																																																														CAR
																																																														(BgL_cdrzd259985zd2_5161);
																																																													if (PAIRP(BgL_carzd259991zd2_5166))
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_castzd2sexpzf3z21zzast_privatez00(BgL_carzd259991zd2_5166))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd259985zd2_5161)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd259977zd2_5155))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_carzd259998zd2_5172;
																																																																					BgL_carzd259998zd2_5172
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd259977zd2_5155);
																																																																					if (PAIRP(BgL_carzd259998zd2_5172))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd260022zd2_5174;
																																																																							BgL_cdrzd260022zd2_5174
																																																																								=
																																																																								CDR
																																																																								(CAR
																																																																								(BgL_expz00_21));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_arg4370z00_5175;
																																																																								obj_t
																																																																									BgL_arg4371z00_5176;
																																																																								obj_t
																																																																									BgL_arg4372z00_5177;
																																																																								BgL_arg4370z00_5175
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5174));
																																																																								BgL_arg4371z00_5176
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260022zd2_5174));
																																																																								BgL_arg4372z00_5177
																																																																									=
																																																																									CDR
																																																																									(BgL_expz00_21);
																																																																								{
																																																																									obj_t
																																																																										BgL_argsz00_28624;
																																																																									obj_t
																																																																										BgL_bodyz00_28623;
																																																																									obj_t
																																																																										BgL_varsz00_28622;
																																																																									BgL_varsz00_28622
																																																																										=
																																																																										BgL_arg4370z00_5175;
																																																																									BgL_bodyz00_28623
																																																																										=
																																																																										BgL_arg4371z00_5176;
																																																																									BgL_argsz00_28624
																																																																										=
																																																																										BgL_arg4372z00_5177;
																																																																									BgL_argsz00_1774
																																																																										=
																																																																										BgL_argsz00_28624;
																																																																									BgL_bodyz00_1773
																																																																										=
																																																																										BgL_bodyz00_28623;
																																																																									BgL_varsz00_1772
																																																																										=
																																																																										BgL_varsz00_28622;
																																																																									goto
																																																																										BgL_tagzd2386zd2_1775;
																																																																								}
																																																																							}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd259977zd2_5155)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_arg4376z00_5181;
																																																																									BgL_arg4376z00_5181
																																																																										=
																																																																										CAR
																																																																										(BgL_carzd259984zd2_5160);
																																																																									{
																																																																										BgL_castz00_bglt
																																																																											BgL_auxz00_28629;
																																																																										{
																																																																											obj_t
																																																																												BgL_argz00_28632;
																																																																											obj_t
																																																																												BgL_bodyz00_28631;
																																																																											obj_t
																																																																												BgL_varz00_28630;
																																																																											BgL_varz00_28630
																																																																												=
																																																																												BgL_arg4376z00_5181;
																																																																											BgL_bodyz00_28631
																																																																												=
																																																																												BgL_carzd259991zd2_5166;
																																																																											BgL_argz00_28632
																																																																												=
																																																																												BgL_carzd259998zd2_5172;
																																																																											BgL_argz00_1770
																																																																												=
																																																																												BgL_argz00_28632;
																																																																											BgL_bodyz00_1769
																																																																												=
																																																																												BgL_bodyz00_28631;
																																																																											BgL_varz00_1768
																																																																												=
																																																																												BgL_varz00_28630;
																																																																											goto
																																																																												BgL_tagzd2385zd2_1771;
																																																																										}
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28629);
																																																																									}
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd260049zd2_5182;
																																																																									BgL_cdrzd260049zd2_5182
																																																																										=
																																																																										CDR
																																																																										(CAR
																																																																										(BgL_expz00_21));
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4377z00_5183;
																																																																										obj_t
																																																																											BgL_arg4378z00_5184;
																																																																										obj_t
																																																																											BgL_arg4379z00_5185;
																																																																										BgL_arg4377z00_5183
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5182));
																																																																										BgL_arg4378z00_5184
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd260049zd2_5182));
																																																																										BgL_arg4379z00_5185
																																																																											=
																																																																											CDR
																																																																											(BgL_expz00_21);
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28643;
																																																																											obj_t
																																																																												BgL_bodyz00_28642;
																																																																											obj_t
																																																																												BgL_varsz00_28641;
																																																																											BgL_varsz00_28641
																																																																												=
																																																																												BgL_arg4377z00_5183;
																																																																											BgL_bodyz00_28642
																																																																												=
																																																																												BgL_arg4378z00_5184;
																																																																											BgL_argsz00_28643
																																																																												=
																																																																												BgL_arg4379z00_5185;
																																																																											BgL_argsz00_1774
																																																																												=
																																																																												BgL_argsz00_28643;
																																																																											BgL_bodyz00_1773
																																																																												=
																																																																												BgL_bodyz00_28642;
																																																																											BgL_varsz00_1772
																																																																												=
																																																																												BgL_varsz00_28641;
																																																																											goto
																																																																												BgL_tagzd2386zd2_1775;
																																																																										}
																																																																									}
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd260075zd2_5188;
																																																																					BgL_cdrzd260075zd2_5188
																																																																						=
																																																																						CDR
																																																																						(CAR
																																																																						(BgL_expz00_21));
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_arg4382z00_5189;
																																																																						obj_t
																																																																							BgL_arg4383z00_5190;
																																																																						obj_t
																																																																							BgL_arg4384z00_5191;
																																																																						BgL_arg4382z00_5189
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5188));
																																																																						BgL_arg4383z00_5190
																																																																							=
																																																																							CDR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260075zd2_5188));
																																																																						BgL_arg4384z00_5191
																																																																							=
																																																																							CDR
																																																																							(BgL_expz00_21);
																																																																						{
																																																																							obj_t
																																																																								BgL_argsz00_28653;
																																																																							obj_t
																																																																								BgL_bodyz00_28652;
																																																																							obj_t
																																																																								BgL_varsz00_28651;
																																																																							BgL_varsz00_28651
																																																																								=
																																																																								BgL_arg4382z00_5189;
																																																																							BgL_bodyz00_28652
																																																																								=
																																																																								BgL_arg4383z00_5190;
																																																																							BgL_argsz00_28653
																																																																								=
																																																																								BgL_arg4384z00_5191;
																																																																							BgL_argsz00_1774
																																																																								=
																																																																								BgL_argsz00_28653;
																																																																							BgL_bodyz00_1773
																																																																								=
																																																																								BgL_bodyz00_28652;
																																																																							BgL_varsz00_1772
																																																																								=
																																																																								BgL_varsz00_28651;
																																																																							goto
																																																																								BgL_tagzd2386zd2_1775;
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd260101zd2_5193;
																																																																			BgL_cdrzd260101zd2_5193
																																																																				=
																																																																				CDR
																																																																				(CAR
																																																																				(BgL_expz00_21));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_arg4386z00_5194;
																																																																				obj_t
																																																																					BgL_arg4387z00_5195;
																																																																				obj_t
																																																																					BgL_arg4388z00_5196;
																																																																				BgL_arg4386z00_5194
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5193));
																																																																				BgL_arg4387z00_5195
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260101zd2_5193));
																																																																				BgL_arg4388z00_5196
																																																																					=
																																																																					CDR
																																																																					(BgL_expz00_21);
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28663;
																																																																					obj_t
																																																																						BgL_bodyz00_28662;
																																																																					obj_t
																																																																						BgL_varsz00_28661;
																																																																					BgL_varsz00_28661
																																																																						=
																																																																						BgL_arg4386z00_5194;
																																																																					BgL_bodyz00_28662
																																																																						=
																																																																						BgL_arg4387z00_5195;
																																																																					BgL_argsz00_28663
																																																																						=
																																																																						BgL_arg4388z00_5196;
																																																																					BgL_argsz00_1774
																																																																						=
																																																																						BgL_argsz00_28663;
																																																																					BgL_bodyz00_1773
																																																																						=
																																																																						BgL_bodyz00_28662;
																																																																					BgL_varsz00_1772
																																																																						=
																																																																						BgL_varsz00_28661;
																																																																					goto
																																																																						BgL_tagzd2386zd2_1775;
																																																																				}
																																																																			}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd260127zd2_5199;
																																																																	BgL_cdrzd260127zd2_5199
																																																																		=
																																																																		CDR
																																																																		(CAR
																																																																		(BgL_expz00_21));
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_arg4391z00_5200;
																																																																		obj_t
																																																																			BgL_arg4392z00_5201;
																																																																		obj_t
																																																																			BgL_arg4393z00_5202;
																																																																		BgL_arg4391z00_5200
																																																																			=
																																																																			CAR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5199));
																																																																		BgL_arg4392z00_5201
																																																																			=
																																																																			CDR
																																																																			(
																																																																			((obj_t) BgL_cdrzd260127zd2_5199));
																																																																		BgL_arg4393z00_5202
																																																																			=
																																																																			CDR
																																																																			(BgL_expz00_21);
																																																																		{
																																																																			obj_t
																																																																				BgL_argsz00_28673;
																																																																			obj_t
																																																																				BgL_bodyz00_28672;
																																																																			obj_t
																																																																				BgL_varsz00_28671;
																																																																			BgL_varsz00_28671
																																																																				=
																																																																				BgL_arg4391z00_5200;
																																																																			BgL_bodyz00_28672
																																																																				=
																																																																				BgL_arg4392z00_5201;
																																																																			BgL_argsz00_28673
																																																																				=
																																																																				BgL_arg4393z00_5202;
																																																																			BgL_argsz00_1774
																																																																				=
																																																																				BgL_argsz00_28673;
																																																																			BgL_bodyz00_1773
																																																																				=
																																																																				BgL_bodyz00_28672;
																																																																			BgL_varsz00_1772
																																																																				=
																																																																				BgL_varsz00_28671;
																																																																			goto
																																																																				BgL_tagzd2386zd2_1775;
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd260153zd2_5204;
																																																															BgL_cdrzd260153zd2_5204
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_carzd259976zd2_5154));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_arg4395z00_5205;
																																																																obj_t
																																																																	BgL_arg4396z00_5206;
																																																																obj_t
																																																																	BgL_arg4397z00_5207;
																																																																BgL_arg4395z00_5205
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5204));
																																																																BgL_arg4396z00_5206
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd260153zd2_5204));
																																																																BgL_arg4397z00_5207
																																																																	=
																																																																	CDR
																																																																	(BgL_expz00_21);
																																																																{
																																																																	obj_t
																																																																		BgL_argsz00_28683;
																																																																	obj_t
																																																																		BgL_bodyz00_28682;
																																																																	obj_t
																																																																		BgL_varsz00_28681;
																																																																	BgL_varsz00_28681
																																																																		=
																																																																		BgL_arg4395z00_5205;
																																																																	BgL_bodyz00_28682
																																																																		=
																																																																		BgL_arg4396z00_5206;
																																																																	BgL_argsz00_28683
																																																																		=
																																																																		BgL_arg4397z00_5207;
																																																																	BgL_argsz00_1774
																																																																		=
																																																																		BgL_argsz00_28683;
																																																																	BgL_bodyz00_1773
																																																																		=
																																																																		BgL_bodyz00_28682;
																																																																	BgL_varsz00_1772
																																																																		=
																																																																		BgL_varsz00_28681;
																																																																	goto
																																																																		BgL_tagzd2386zd2_1775;
																																																																}
																																																															}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd260179zd2_5209;
																																																													BgL_cdrzd260179zd2_5209
																																																														=
																																																														CDR
																																																														(
																																																														((obj_t) BgL_carzd259976zd2_5154));
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_arg4399z00_5210;
																																																														obj_t
																																																															BgL_arg4400z00_5211;
																																																														obj_t
																																																															BgL_arg4401z00_5212;
																																																														BgL_arg4399z00_5210
																																																															=
																																																															CAR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5209));
																																																														BgL_arg4400z00_5211
																																																															=
																																																															CDR
																																																															(
																																																															((obj_t) BgL_cdrzd260179zd2_5209));
																																																														BgL_arg4401z00_5212
																																																															=
																																																															CDR
																																																															(BgL_expz00_21);
																																																														{
																																																															obj_t
																																																																BgL_argsz00_28693;
																																																															obj_t
																																																																BgL_bodyz00_28692;
																																																															obj_t
																																																																BgL_varsz00_28691;
																																																															BgL_varsz00_28691
																																																																=
																																																																BgL_arg4399z00_5210;
																																																															BgL_bodyz00_28692
																																																																=
																																																																BgL_arg4400z00_5211;
																																																															BgL_argsz00_28693
																																																																=
																																																																BgL_arg4401z00_5212;
																																																															BgL_argsz00_1774
																																																																=
																																																																BgL_argsz00_28693;
																																																															BgL_bodyz00_1773
																																																																=
																																																																BgL_bodyz00_28692;
																																																															BgL_varsz00_1772
																																																																=
																																																																BgL_varsz00_28691;
																																																															goto
																																																																BgL_tagzd2386zd2_1775;
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_cdrzd260205zd2_5214;
																																																											BgL_cdrzd260205zd2_5214
																																																												=
																																																												CDR
																																																												(
																																																												((obj_t) BgL_carzd259976zd2_5154));
																																																											{	/* Ast/sexp.scm 119 */
																																																												obj_t
																																																													BgL_arg4403z00_5215;
																																																												obj_t
																																																													BgL_arg4404z00_5216;
																																																												obj_t
																																																													BgL_arg4405z00_5217;
																																																												BgL_arg4403z00_5215
																																																													=
																																																													CAR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5214));
																																																												BgL_arg4404z00_5216
																																																													=
																																																													CDR
																																																													(
																																																													((obj_t) BgL_cdrzd260205zd2_5214));
																																																												BgL_arg4405z00_5217
																																																													=
																																																													CDR
																																																													(BgL_expz00_21);
																																																												{
																																																													obj_t
																																																														BgL_argsz00_28703;
																																																													obj_t
																																																														BgL_bodyz00_28702;
																																																													obj_t
																																																														BgL_varsz00_28701;
																																																													BgL_varsz00_28701
																																																														=
																																																														BgL_arg4403z00_5215;
																																																													BgL_bodyz00_28702
																																																														=
																																																														BgL_arg4404z00_5216;
																																																													BgL_argsz00_28703
																																																														=
																																																														BgL_arg4405z00_5217;
																																																													BgL_argsz00_1774
																																																														=
																																																														BgL_argsz00_28703;
																																																													BgL_bodyz00_1773
																																																														=
																																																														BgL_bodyz00_28702;
																																																													BgL_varsz00_1772
																																																														=
																																																														BgL_varsz00_28701;
																																																													goto
																																																														BgL_tagzd2386zd2_1775;
																																																												}
																																																											}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd260231zd2_5220;
																																																									BgL_cdrzd260231zd2_5220
																																																										=
																																																										CDR
																																																										(
																																																										((obj_t) BgL_carzd259976zd2_5154));
																																																									{	/* Ast/sexp.scm 119 */
																																																										obj_t
																																																											BgL_arg4408z00_5221;
																																																										obj_t
																																																											BgL_arg4409z00_5222;
																																																										obj_t
																																																											BgL_arg4410z00_5223;
																																																										BgL_arg4408z00_5221
																																																											=
																																																											CAR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5220));
																																																										BgL_arg4409z00_5222
																																																											=
																																																											CDR
																																																											(
																																																											((obj_t) BgL_cdrzd260231zd2_5220));
																																																										BgL_arg4410z00_5223
																																																											=
																																																											CDR
																																																											(BgL_expz00_21);
																																																										{
																																																											obj_t
																																																												BgL_argsz00_28713;
																																																											obj_t
																																																												BgL_bodyz00_28712;
																																																											obj_t
																																																												BgL_varsz00_28711;
																																																											BgL_varsz00_28711
																																																												=
																																																												BgL_arg4408z00_5221;
																																																											BgL_bodyz00_28712
																																																												=
																																																												BgL_arg4409z00_5222;
																																																											BgL_argsz00_28713
																																																												=
																																																												BgL_arg4410z00_5223;
																																																											BgL_argsz00_1774
																																																												=
																																																												BgL_argsz00_28713;
																																																											BgL_bodyz00_1773
																																																												=
																																																												BgL_bodyz00_28712;
																																																											BgL_varsz00_1772
																																																												=
																																																												BgL_varsz00_28711;
																																																											goto
																																																												BgL_tagzd2386zd2_1775;
																																																										}
																																																									}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28716;
																																																									goto
																																																										BgL_tagzd2403zd2_1809;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28716);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1810;
																																																								}
																																																						}
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					obj_t
																																																						BgL_cdrzd260369zd2_5228;
																																																					BgL_cdrzd260369zd2_5228
																																																						=
																																																						CDR
																																																						(
																																																						((obj_t) BgL_carzd259976zd2_5154));
																																																					if ((CAR(((obj_t) BgL_carzd259976zd2_5154)) == CNST_TABLE_REF(((long) 1))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (PAIRP(BgL_cdrzd260369zd2_5228))
																																																								{	/* Ast/sexp.scm 119 */
																																																									obj_t
																																																										BgL_cdrzd260374zd2_5232;
																																																									BgL_cdrzd260374zd2_5232
																																																										=
																																																										CDR
																																																										(BgL_cdrzd260369zd2_5228);
																																																									if (PAIRP(BgL_cdrzd260374zd2_5232))
																																																										{	/* Ast/sexp.scm 119 */
																																																											obj_t
																																																												BgL_carzd260378zd2_5234;
																																																											obj_t
																																																												BgL_cdrzd260379zd2_5235;
																																																											BgL_carzd260378zd2_5234
																																																												=
																																																												CAR
																																																												(BgL_cdrzd260374zd2_5232);
																																																											BgL_cdrzd260379zd2_5235
																																																												=
																																																												CDR
																																																												(BgL_cdrzd260374zd2_5232);
																																																											if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260378zd2_5234))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (PAIRP(BgL_cdrzd260379zd2_5235))
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_carzd260384zd2_5238;
																																																															BgL_carzd260384zd2_5238
																																																																=
																																																																CAR
																																																																(BgL_cdrzd260379zd2_5235);
																																																															if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260384zd2_5238))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	if (NULLP(CDR(BgL_cdrzd260379zd2_5235)))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			bool_t
																																																																				BgL_test10451z00_28742;
																																																																			{
																																																																				obj_t
																																																																					BgL_l1470z00_5271;
																																																																				BgL_l1470z00_5271
																																																																					=
																																																																					BgL_cdrzd259977zd2_5155;
																																																																			BgL_zc3z04anonymousza34437ze3z87_5272:
																																																																				if (NULLP(BgL_l1470z00_5271))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						BgL_test10451z00_28742
																																																																							=
																																																																							(
																																																																							(bool_t)
																																																																							1);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						bool_t
																																																																							BgL_test10453z00_28745;
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							bool_t
																																																																								BgL_test10454z00_28746;
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_tmpz00_28747;
																																																																								BgL_tmpz00_28747
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_l1470z00_5271));
																																																																								BgL_test10454z00_28746
																																																																									=
																																																																									PAIRP
																																																																									(BgL_tmpz00_28747);
																																																																							}
																																																																							if (BgL_test10454z00_28746)
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test10453z00_28745
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										0);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									BgL_test10453z00_28745
																																																																										=
																																																																										(
																																																																										(bool_t)
																																																																										1);
																																																																								}
																																																																						}
																																																																						if (BgL_test10453z00_28745)
																																																																							{
																																																																								obj_t
																																																																									BgL_l1470z00_28751;
																																																																								BgL_l1470z00_28751
																																																																									=
																																																																									CDR
																																																																									(
																																																																									((obj_t) BgL_l1470z00_5271));
																																																																								BgL_l1470z00_5271
																																																																									=
																																																																									BgL_l1470z00_28751;
																																																																								goto
																																																																									BgL_zc3z04anonymousza34437ze3z87_5272;
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								BgL_test10451z00_28742
																																																																									=
																																																																									(
																																																																									(bool_t)
																																																																									0);
																																																																							}
																																																																					}
																																																																			}
																																																																			if (BgL_test10451z00_28742)
																																																																				{
																																																																					obj_t
																																																																						BgL_argsz00_28758;
																																																																					obj_t
																																																																						BgL_proc2z00_28757;
																																																																					obj_t
																																																																						BgL_proc1z00_28756;
																																																																					obj_t
																																																																						BgL_testz00_28754;
																																																																					BgL_testz00_28754
																																																																						=
																																																																						CAR
																																																																						(BgL_cdrzd260369zd2_5228);
																																																																					BgL_proc1z00_28756
																																																																						=
																																																																						BgL_carzd260378zd2_5234;
																																																																					BgL_proc2z00_28757
																																																																						=
																																																																						BgL_carzd260384zd2_5238;
																																																																					BgL_argsz00_28758
																																																																						=
																																																																						BgL_cdrzd259977zd2_5155;
																																																																					BgL_argsz00_1779
																																																																						=
																																																																						BgL_argsz00_28758;
																																																																					BgL_proc2z00_1778
																																																																						=
																																																																						BgL_proc2z00_28757;
																																																																					BgL_proc1z00_1777
																																																																						=
																																																																						BgL_proc1z00_28756;
																																																																					BgL_testz00_1776
																																																																						=
																																																																						BgL_testz00_28754;
																																																																					goto
																																																																						BgL_tagzd2387zd2_1780;
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd260409zd2_5255;
																																																																					BgL_cdrzd260409zd2_5255
																																																																						=
																																																																						CDR
																																																																						(BgL_expz00_21);
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_cdrzd260417zd2_5256;
																																																																						BgL_cdrzd260417zd2_5256
																																																																							=
																																																																							CDR
																																																																							(CAR
																																																																							(BgL_expz00_21));
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd260425zd2_5257;
																																																																							BgL_cdrzd260425zd2_5257
																																																																								=
																																																																								CDR
																																																																								(
																																																																								((obj_t) BgL_cdrzd260417zd2_5256));
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								obj_t
																																																																									BgL_carzd260432zd2_5258;
																																																																								BgL_carzd260432zd2_5258
																																																																									=
																																																																									CAR
																																																																									(
																																																																									((obj_t) BgL_cdrzd260425zd2_5257));
																																																																								if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260432zd2_5258))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_carzd260441zd2_5260;
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_pairz00_13476;
																																																																											BgL_pairz00_13476
																																																																												=
																																																																												CDR
																																																																												(
																																																																												((obj_t) BgL_cdrzd260425zd2_5257));
																																																																											BgL_carzd260441zd2_5260
																																																																												=
																																																																												CAR
																																																																												(BgL_pairz00_13476);
																																																																										}
																																																																										if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260441zd2_5260))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260409zd2_5255))
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4431z00_5263;
																																																																														BgL_arg4431z00_5263
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd260417zd2_5256));
																																																																														{
																																																																															obj_t
																																																																																BgL_argsz00_28780;
																																																																															obj_t
																																																																																BgL_proc2z00_28779;
																																																																															obj_t
																																																																																BgL_proc1z00_28778;
																																																																															obj_t
																																																																																BgL_testz00_28777;
																																																																															BgL_testz00_28777
																																																																																=
																																																																																BgL_arg4431z00_5263;
																																																																															BgL_proc1z00_28778
																																																																																=
																																																																																BgL_carzd260432zd2_5258;
																																																																															BgL_proc2z00_28779
																																																																																=
																																																																																BgL_carzd260441zd2_5260;
																																																																															BgL_argsz00_28780
																																																																																=
																																																																																BgL_cdrzd260409zd2_5255;
																																																																															BgL_argsz00_1784
																																																																																=
																																																																																BgL_argsz00_28780;
																																																																															BgL_proc2z00_1783
																																																																																=
																																																																																BgL_proc2z00_28779;
																																																																															BgL_proc1z00_1782
																																																																																=
																																																																																BgL_proc1z00_28778;
																																																																															BgL_testz00_1781
																																																																																=
																																																																																BgL_testz00_28777;
																																																																															goto
																																																																																BgL_tagzd2388zd2_1785;
																																																																														}
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																															{
																																																																																obj_t
																																																																																	BgL_auxz00_28783;
																																																																																goto
																																																																																	BgL_tagzd2403zd2_1809;
																																																																																return
																																																																																	(
																																																																																	(BgL_nodez00_bglt)
																																																																																	BgL_auxz00_28783);
																																																																															}
																																																																														else
																																																																															{	/* Ast/sexp.scm 119 */
																																																																																goto
																																																																																	BgL_tagzd2404zd2_1810;
																																																																															}
																																																																													}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28787;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28787);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28791;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28791);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																											}
																																																																									}
																																																																							}
																																																																						}
																																																																					}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																				{
																																																																					obj_t
																																																																						BgL_auxz00_28795;
																																																																					goto
																																																																						BgL_tagzd2403zd2_1809;
																																																																					return
																																																																						(
																																																																						(BgL_nodez00_bglt)
																																																																						BgL_auxz00_28795);
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					goto
																																																																						BgL_tagzd2404zd2_1810;
																																																																				}
																																																																		}
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd260719zd2_5282;
																																																																	BgL_cdrzd260719zd2_5282
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		obj_t
																																																																			BgL_cdrzd260726zd2_5283;
																																																																		BgL_cdrzd260726zd2_5283
																																																																			=
																																																																			CDR
																																																																			(CAR
																																																																			(BgL_expz00_21));
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			obj_t
																																																																				BgL_cdrzd260733zd2_5284;
																																																																			BgL_cdrzd260733zd2_5284
																																																																				=
																																																																				CDR
																																																																				(
																																																																				((obj_t) BgL_cdrzd260726zd2_5283));
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd260739zd2_5285;
																																																																				obj_t
																																																																					BgL_cdrzd260740zd2_5286;
																																																																				BgL_carzd260739zd2_5285
																																																																					=
																																																																					CAR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5284));
																																																																				BgL_cdrzd260740zd2_5286
																																																																					=
																																																																					CDR
																																																																					(
																																																																					((obj_t) BgL_cdrzd260733zd2_5284));
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260739zd2_5285))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						obj_t
																																																																							BgL_carzd260747zd2_5288;
																																																																						BgL_carzd260747zd2_5288
																																																																							=
																																																																							CAR
																																																																							(
																																																																							((obj_t) BgL_cdrzd260740zd2_5286));
																																																																						if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd260747zd2_5288))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (NULLP(CDR(((obj_t) BgL_cdrzd260740zd2_5286))))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd260719zd2_5282))
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4446z00_5293;
																																																																												BgL_arg4446z00_5293
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd260726zd2_5283));
																																																																												{
																																																																													obj_t
																																																																														BgL_argsz00_28823;
																																																																													obj_t
																																																																														BgL_proc2z00_28822;
																																																																													obj_t
																																																																														BgL_proc1z00_28821;
																																																																													obj_t
																																																																														BgL_testz00_28820;
																																																																													BgL_testz00_28820
																																																																														=
																																																																														BgL_arg4446z00_5293;
																																																																													BgL_proc1z00_28821
																																																																														=
																																																																														BgL_carzd260739zd2_5285;
																																																																													BgL_proc2z00_28822
																																																																														=
																																																																														BgL_carzd260747zd2_5288;
																																																																													BgL_argsz00_28823
																																																																														=
																																																																														BgL_cdrzd260719zd2_5282;
																																																																													BgL_argsz00_1784
																																																																														=
																																																																														BgL_argsz00_28823;
																																																																													BgL_proc2z00_1783
																																																																														=
																																																																														BgL_proc2z00_28822;
																																																																													BgL_proc1z00_1782
																																																																														=
																																																																														BgL_proc1z00_28821;
																																																																													BgL_testz00_1781
																																																																														=
																																																																														BgL_testz00_28820;
																																																																													goto
																																																																														BgL_tagzd2388zd2_1785;
																																																																												}
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																													{
																																																																														obj_t
																																																																															BgL_auxz00_28826;
																																																																														goto
																																																																															BgL_tagzd2403zd2_1809;
																																																																														return
																																																																															(
																																																																															(BgL_nodez00_bglt)
																																																																															BgL_auxz00_28826);
																																																																													}
																																																																												else
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														goto
																																																																															BgL_tagzd2404zd2_1810;
																																																																													}
																																																																											}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28830;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28830);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28834;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28834);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28838;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28838);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																							}
																																																																					}
																																																																			}
																																																																		}
																																																																	}
																																																																}
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{
																																																																	obj_t
																																																																		BgL_auxz00_28842;
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_28842);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													obj_t
																																																														BgL_cdrzd261080zd2_5301;
																																																													BgL_cdrzd261080zd2_5301
																																																														=
																																																														CDR
																																																														(BgL_expz00_21);
																																																													{	/* Ast/sexp.scm 119 */
																																																														obj_t
																																																															BgL_cdrzd261086zd2_5302;
																																																														BgL_cdrzd261086zd2_5302
																																																															=
																																																															CDR
																																																															(CAR
																																																															(BgL_expz00_21));
																																																														{	/* Ast/sexp.scm 119 */
																																																															obj_t
																																																																BgL_cdrzd261092zd2_5303;
																																																															BgL_cdrzd261092zd2_5303
																																																																=
																																																																CDR
																																																																(
																																																																((obj_t) BgL_cdrzd261086zd2_5302));
																																																															{	/* Ast/sexp.scm 119 */
																																																																obj_t
																																																																	BgL_carzd261097zd2_5304;
																																																																obj_t
																																																																	BgL_cdrzd261098zd2_5305;
																																																																BgL_carzd261097zd2_5304
																																																																	=
																																																																	CAR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5303));
																																																																BgL_cdrzd261098zd2_5305
																																																																	=
																																																																	CDR
																																																																	(
																																																																	((obj_t) BgL_cdrzd261092zd2_5303));
																																																																if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261097zd2_5304))
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (PAIRP(BgL_cdrzd261098zd2_5305))
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				obj_t
																																																																					BgL_carzd261103zd2_5308;
																																																																				BgL_carzd261103zd2_5308
																																																																					=
																																																																					CAR
																																																																					(BgL_cdrzd261098zd2_5305);
																																																																				if (BGl_proczd2orzd2lambdazf3zf3zzast_sexpz00(BgL_carzd261103zd2_5308))
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (NULLP(CDR(BgL_cdrzd261098zd2_5305)))
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00(BgL_cdrzd261080zd2_5301))
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4460z00_5313;
																																																																										BgL_arg4460z00_5313
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd261086zd2_5302));
																																																																										{
																																																																											obj_t
																																																																												BgL_argsz00_28870;
																																																																											obj_t
																																																																												BgL_proc2z00_28869;
																																																																											obj_t
																																																																												BgL_proc1z00_28868;
																																																																											obj_t
																																																																												BgL_testz00_28867;
																																																																											BgL_testz00_28867
																																																																												=
																																																																												BgL_arg4460z00_5313;
																																																																											BgL_proc1z00_28868
																																																																												=
																																																																												BgL_carzd261097zd2_5304;
																																																																											BgL_proc2z00_28869
																																																																												=
																																																																												BgL_carzd261103zd2_5308;
																																																																											BgL_argsz00_28870
																																																																												=
																																																																												BgL_cdrzd261080zd2_5301;
																																																																											BgL_argsz00_1784
																																																																												=
																																																																												BgL_argsz00_28870;
																																																																											BgL_proc2z00_1783
																																																																												=
																																																																												BgL_proc2z00_28869;
																																																																											BgL_proc1z00_1782
																																																																												=
																																																																												BgL_proc1z00_28868;
																																																																											BgL_testz00_1781
																																																																												=
																																																																												BgL_testz00_28867;
																																																																											goto
																																																																												BgL_tagzd2388zd2_1785;
																																																																										}
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																											{
																																																																												obj_t
																																																																													BgL_auxz00_28873;
																																																																												goto
																																																																													BgL_tagzd2403zd2_1809;
																																																																												return
																																																																													(
																																																																													(BgL_nodez00_bglt)
																																																																													BgL_auxz00_28873);
																																																																											}
																																																																										else
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												goto
																																																																													BgL_tagzd2404zd2_1810;
																																																																											}
																																																																									}
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																									{
																																																																										obj_t
																																																																											BgL_auxz00_28877;
																																																																										goto
																																																																											BgL_tagzd2403zd2_1809;
																																																																										return
																																																																											(
																																																																											(BgL_nodez00_bglt)
																																																																											BgL_auxz00_28877);
																																																																									}
																																																																								else
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										goto
																																																																											BgL_tagzd2404zd2_1810;
																																																																									}
																																																																							}
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																							{
																																																																								obj_t
																																																																									BgL_auxz00_28881;
																																																																								goto
																																																																									BgL_tagzd2403zd2_1809;
																																																																								return
																																																																									(
																																																																									(BgL_nodez00_bglt)
																																																																									BgL_auxz00_28881);
																																																																							}
																																																																						else
																																																																							{	/* Ast/sexp.scm 119 */
																																																																								goto
																																																																									BgL_tagzd2404zd2_1810;
																																																																							}
																																																																					}
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																					{
																																																																						obj_t
																																																																							BgL_auxz00_28885;
																																																																						goto
																																																																							BgL_tagzd2403zd2_1809;
																																																																						return
																																																																							(
																																																																							(BgL_nodez00_bglt)
																																																																							BgL_auxz00_28885);
																																																																					}
																																																																				else
																																																																					{	/* Ast/sexp.scm 119 */
																																																																						goto
																																																																							BgL_tagzd2404zd2_1810;
																																																																					}
																																																																			}
																																																																	}
																																																																else
																																																																	{	/* Ast/sexp.scm 119 */
																																																																		if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																			{
																																																																				obj_t
																																																																					BgL_auxz00_28889;
																																																																				goto
																																																																					BgL_tagzd2403zd2_1809;
																																																																				return
																																																																					(
																																																																					(BgL_nodez00_bglt)
																																																																					BgL_auxz00_28889);
																																																																			}
																																																																		else
																																																																			{	/* Ast/sexp.scm 119 */
																																																																				goto
																																																																					BgL_tagzd2404zd2_1810;
																																																																			}
																																																																	}
																																																															}
																																																														}
																																																													}
																																																												}
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_28893;
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_28893);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																										{
																																																											obj_t
																																																												BgL_auxz00_28897;
																																																											goto
																																																												BgL_tagzd2403zd2_1809;
																																																											return
																																																												(
																																																												(BgL_nodez00_bglt)
																																																												BgL_auxz00_28897);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2404zd2_1810;
																																																										}
																																																								}
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																								{
																																																									obj_t
																																																										BgL_auxz00_28901;
																																																									goto
																																																										BgL_tagzd2403zd2_1809;
																																																									return
																																																										(
																																																										(BgL_nodez00_bglt)
																																																										BgL_auxz00_28901);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									goto
																																																										BgL_tagzd2404zd2_1810;
																																																								}
																																																						}
																																																				}
																																																		}
																																																	}
																																															}
																																													}
																																												}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																																}
																															else
																																{

																																	if (
																																		(BgL_carzd255411zd2_5138
																																			==
																																			CNST_TABLE_REF
																																			(((long)
																																					17))))
																																		{
																																			obj_t
																																				BgL_auxz00_28906;
																																		BgL_kapzd261641zd2_5721:
																																			if (PAIRP
																																				(BgL_cdrzd255282zd2_5120))
																																				{	/* Ast/sexp.scm 119 */
																																					obj_t
																																						BgL_arg4816z00_5818;
																																					obj_t
																																						BgL_arg4817z00_5819;
																																					BgL_arg4816z00_5818
																																						=
																																						CAR
																																						(BgL_cdrzd255282zd2_5120);
																																					BgL_arg4817z00_5819
																																						=
																																						CDR
																																						(BgL_cdrzd255282zd2_5120);
																																					{
																																						BgL_nodez00_bglt
																																							BgL_auxz00_28911;
																																						{
																																							obj_t
																																								BgL_exprz00_28913;
																																							obj_t
																																								BgL_bindingsz00_28912;
																																							BgL_bindingsz00_28912
																																								=
																																								BgL_arg4816z00_5818;
																																							BgL_exprz00_28913
																																								=
																																								BgL_arg4817z00_5819;
																																							BgL_exprz00_1764
																																								=
																																								BgL_exprz00_28913;
																																							BgL_bindingsz00_1763
																																								=
																																								BgL_bindingsz00_28912;
																																							goto
																																								BgL_tagzd2382zd2_1765;
																																						}
																																						BgL_auxz00_28906
																																							=
																																							(
																																							(obj_t)
																																							BgL_auxz00_28911);
																																					}
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(CAR
																																							(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 20))))
																																						{
																																							BgL_nodez00_bglt
																																								BgL_auxz00_28920;
																																							goto
																																								BgL_tagzd2383zd2_1766;
																																							BgL_auxz00_28906
																																								=
																																								(
																																								(obj_t)
																																								BgL_auxz00_28920);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							obj_t
																																								BgL_carzd261674zd2_5822;
																																							BgL_carzd261674zd2_5822
																																								=
																																								CAR
																																								(
																																								((obj_t) BgL_expz00_21));
																																							if ((BgL_carzd261674zd2_5822 == CNST_TABLE_REF(((long) 19))))
																																								{
																																									BgL_letzd2funzd2_bglt
																																										BgL_auxz00_28927;
																																									goto
																																										BgL_tagzd2384zd2_1767;
																																									BgL_auxz00_28906
																																										=
																																										(
																																										(obj_t)
																																										BgL_auxz00_28927);
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261674zd2_5822)))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_28932;
																																											goto
																																												BgL_tagzd2384zd2_1767;
																																											BgL_auxz00_28906
																																												=
																																												(
																																												(obj_t)
																																												BgL_auxz00_28932);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 3))))
																																												{
																																													BgL_nodez00_bglt
																																														BgL_auxz00_28939;
																																													goto
																																														BgL_tagzd2389zd2_1786;
																																													BgL_auxz00_28906
																																														=
																																														(
																																														(obj_t)
																																														BgL_auxz00_28939);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 6))))
																																														{
																																															BgL_nodez00_bglt
																																																BgL_auxz00_28946;
																																															goto
																																																BgL_tagzd2390zd2_1787;
																																															BgL_auxz00_28906
																																																=
																																																(
																																																(obj_t)
																																																BgL_auxz00_28946);
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 22))))
																																																{
																																																	BgL_nodez00_bglt
																																																		BgL_auxz00_28953;
																																																	goto
																																																		BgL_tagzd2392zd2_1791;
																																																	BgL_auxz00_28906
																																																		=
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_28953);
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 23))))
																																																		{
																																																			BgL_nodez00_bglt
																																																				BgL_auxz00_28960;
																																																			goto
																																																				BgL_tagzd2393zd2_1792;
																																																			BgL_auxz00_28906
																																																				=
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_28960);
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 25))))
																																																				{
																																																					BgL_nodez00_bglt
																																																						BgL_auxz00_28967;
																																																					goto
																																																						BgL_tagzd2395zd2_1796;
																																																					BgL_auxz00_28906
																																																						=
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_28967);
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 26))))
																																																						{
																																																							BgL_nodez00_bglt
																																																								BgL_auxz00_28974;
																																																							goto
																																																								BgL_tagzd2396zd2_1797;
																																																							BgL_auxz00_28906
																																																								=
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_28974);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 27))))
																																																								{
																																																									BgL_letzd2funzd2_bglt
																																																										BgL_auxz00_28981;
																																																									goto
																																																										BgL_tagzd2397zd2_1798;
																																																									BgL_auxz00_28906
																																																										=
																																																										(
																																																										(obj_t)
																																																										BgL_auxz00_28981);
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(((obj_t) BgL_expz00_21)) == CNST_TABLE_REF(((long) 28))))
																																																										{
																																																											BgL_jumpzd2exzd2itz00_bglt
																																																												BgL_auxz00_28988;
																																																											goto
																																																												BgL_tagzd2398zd2_1799;
																																																											BgL_auxz00_28906
																																																												=
																																																												(
																																																												(obj_t)
																																																												BgL_auxz00_28988);
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(((obj_t) BgL_expz00_21)), BUNSPEC))
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (NULLP(CDR(((obj_t) BgL_expz00_21))))
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_28998;
																																																															goto
																																																																BgL_tagzd2402zd2_1808;
																																																															BgL_auxz00_28906
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_28998);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																{	/* Ast/sexp.scm 119 */
																																																																	goto
																																																																		BgL_tagzd2403zd2_1809;
																																																																}
																																																															else
																																																																{
																																																																	BgL_nodez00_bglt
																																																																		BgL_auxz00_29002;
																																																																	goto
																																																																		BgL_tagzd2404zd2_1810;
																																																																	BgL_auxz00_28906
																																																																		=
																																																																		(
																																																																		(obj_t)
																																																																		BgL_auxz00_29002);
																																																																}
																																																														}
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																														{	/* Ast/sexp.scm 119 */
																																																															goto
																																																																BgL_tagzd2403zd2_1809;
																																																														}
																																																													else
																																																														{
																																																															BgL_nodez00_bglt
																																																																BgL_auxz00_29006;
																																																															goto
																																																																BgL_tagzd2404zd2_1810;
																																																															BgL_auxz00_28906
																																																																=
																																																																(
																																																																(obj_t)
																																																																BgL_auxz00_29006);
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																			return
																																				(
																																				(BgL_nodez00_bglt)
																																				BgL_auxz00_28906);
																																		}
																																	else
																																		{	/* Ast/sexp.scm 119 */
																																			if (CBOOL
																																				(BGl_letzd2symzf3z21zzast_letz00
																																					(BgL_carzd255411zd2_5138)))
																																				{
																																					obj_t
																																						BgL_auxz00_29012;
																																					goto
																																						BgL_kapzd261641zd2_5721;
																																					return
																																						(
																																						(BgL_nodez00_bglt)
																																						BgL_auxz00_29012);
																																				}
																																			else
																																				{	/* Ast/sexp.scm 119 */
																																					if (
																																						(BgL_carzd255411zd2_5138
																																							==
																																							CNST_TABLE_REF
																																							(((long) 18))))
																																						{
																																							obj_t
																																								BgL_auxz00_29017;
																																							goto
																																								BgL_kapzd261641zd2_5721;
																																							return
																																								(
																																								(BgL_nodez00_bglt)
																																								BgL_auxz00_29017);
																																						}
																																					else
																																						{	/* Ast/sexp.scm 119 */
																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 20))))
																																								{	/* Ast/sexp.scm 119 */
																																									goto
																																										BgL_tagzd2383zd2_1766;
																																								}
																																							else
																																								{	/* Ast/sexp.scm 119 */
																																									obj_t
																																										BgL_carzd261835zd2_5727;
																																									BgL_carzd261835zd2_5727
																																										=
																																										CAR
																																										(BgL_expz00_21);
																																									if ((BgL_carzd261835zd2_5727 == CNST_TABLE_REF(((long) 19))))
																																										{
																																											BgL_letzd2funzd2_bglt
																																												BgL_auxz00_29027;
																																											goto
																																												BgL_tagzd2384zd2_1767;
																																											return
																																												(
																																												(BgL_nodez00_bglt)
																																												BgL_auxz00_29027);
																																										}
																																									else
																																										{	/* Ast/sexp.scm 119 */
																																											if (CBOOL(BGl_labelszd2symzf3z21zzast_labelsz00(BgL_carzd261835zd2_5727)))
																																												{
																																													BgL_letzd2funzd2_bglt
																																														BgL_auxz00_29032;
																																													goto
																																														BgL_tagzd2384zd2_1767;
																																													return
																																														(
																																														(BgL_nodez00_bglt)
																																														BgL_auxz00_29032);
																																												}
																																											else
																																												{	/* Ast/sexp.scm 119 */
																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 3))))
																																														{	/* Ast/sexp.scm 119 */
																																															goto
																																																BgL_tagzd2389zd2_1786;
																																														}
																																													else
																																														{	/* Ast/sexp.scm 119 */
																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 6))))
																																																{	/* Ast/sexp.scm 119 */
																																																	goto
																																																		BgL_tagzd2390zd2_1787;
																																																}
																																															else
																																																{	/* Ast/sexp.scm 119 */
																																																	obj_t
																																																		BgL_cdrzd261914zd2_5734;
																																																	BgL_cdrzd261914zd2_5734
																																																		=
																																																		CDR
																																																		(BgL_expz00_21);
																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 21))))
																																																		{	/* Ast/sexp.scm 119 */
																																																			if (PAIRP(BgL_cdrzd261914zd2_5734))
																																																				{
																																																					obj_t
																																																						BgL_restz00_29051;
																																																					obj_t
																																																						BgL_effectz00_29049;
																																																					BgL_effectz00_29049
																																																						=
																																																						CAR
																																																						(BgL_cdrzd261914zd2_5734);
																																																					BgL_restz00_29051
																																																						=
																																																						CDR
																																																						(BgL_cdrzd261914zd2_5734);
																																																					BgL_restz00_1789
																																																						=
																																																						BgL_restz00_29051;
																																																					BgL_effectz00_1788
																																																						=
																																																						BgL_effectz00_29049;
																																																					goto
																																																						BgL_tagzd2391zd2_1790;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																						{
																																																							obj_t
																																																								BgL_auxz00_29055;
																																																							goto
																																																								BgL_tagzd2403zd2_1809;
																																																							return
																																																								(
																																																								(BgL_nodez00_bglt)
																																																								BgL_auxz00_29055);
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2404zd2_1810;
																																																						}
																																																				}
																																																		}
																																																	else
																																																		{	/* Ast/sexp.scm 119 */
																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 22))))
																																																				{	/* Ast/sexp.scm 119 */
																																																					goto
																																																						BgL_tagzd2392zd2_1791;
																																																				}
																																																			else
																																																				{	/* Ast/sexp.scm 119 */
																																																					if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 23))))
																																																						{	/* Ast/sexp.scm 119 */
																																																							goto
																																																								BgL_tagzd2393zd2_1792;
																																																						}
																																																					else
																																																						{	/* Ast/sexp.scm 119 */
																																																							if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 24))))
																																																								{	/* Ast/sexp.scm 119 */
																																																									if (PAIRP(BgL_cdrzd261914zd2_5734))
																																																										{
																																																											obj_t
																																																												BgL_restz00_29073;
																																																											obj_t
																																																												BgL_effectz00_29071;
																																																											BgL_effectz00_29071
																																																												=
																																																												CAR
																																																												(BgL_cdrzd261914zd2_5734);
																																																											BgL_restz00_29073
																																																												=
																																																												CDR
																																																												(BgL_cdrzd261914zd2_5734);
																																																											BgL_restz00_1794
																																																												=
																																																												BgL_restz00_29073;
																																																											BgL_effectz00_1793
																																																												=
																																																												BgL_effectz00_29071;
																																																											goto
																																																												BgL_tagzd2394zd2_1795;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																												{
																																																													obj_t
																																																														BgL_auxz00_29077;
																																																													goto
																																																														BgL_tagzd2403zd2_1809;
																																																													return
																																																														(
																																																														(BgL_nodez00_bglt)
																																																														BgL_auxz00_29077);
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2404zd2_1810;
																																																												}
																																																										}
																																																								}
																																																							else
																																																								{	/* Ast/sexp.scm 119 */
																																																									if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 25))))
																																																										{	/* Ast/sexp.scm 119 */
																																																											goto
																																																												BgL_tagzd2395zd2_1796;
																																																										}
																																																									else
																																																										{	/* Ast/sexp.scm 119 */
																																																											if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 26))))
																																																												{	/* Ast/sexp.scm 119 */
																																																													goto
																																																														BgL_tagzd2396zd2_1797;
																																																												}
																																																											else
																																																												{	/* Ast/sexp.scm 119 */
																																																													if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 27))))
																																																														{
																																																															BgL_letzd2funzd2_bglt
																																																																BgL_auxz00_29091;
																																																															goto
																																																																BgL_tagzd2397zd2_1798;
																																																															return
																																																																(
																																																																(BgL_nodez00_bglt)
																																																																BgL_auxz00_29091);
																																																														}
																																																													else
																																																														{	/* Ast/sexp.scm 119 */
																																																															if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 28))))
																																																																{
																																																																	BgL_jumpzd2exzd2itz00_bglt
																																																																		BgL_auxz00_29097;
																																																																	goto
																																																																		BgL_tagzd2398zd2_1799;
																																																																	return
																																																																		(
																																																																		(BgL_nodez00_bglt)
																																																																		BgL_auxz00_29097);
																																																																}
																																																															else
																																																																{	/* Ast/sexp.scm 119 */
																																																																	obj_t
																																																																		BgL_cdrzd262041zd2_5760;
																																																																	BgL_cdrzd262041zd2_5760
																																																																		=
																																																																		CDR
																																																																		(BgL_expz00_21);
																																																																	if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 30))))
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if (PAIRP(BgL_cdrzd262041zd2_5760))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					obj_t
																																																																						BgL_cdrzd262043zd2_5764;
																																																																					BgL_cdrzd262043zd2_5764
																																																																						=
																																																																						CDR
																																																																						(BgL_cdrzd262041zd2_5760);
																																																																					if (PAIRP(BgL_cdrzd262043zd2_5764))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_cdrzd262043zd2_5764)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2399zd2_1800;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_29114;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_29114);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29118;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29118);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																						{
																																																																							obj_t
																																																																								BgL_auxz00_29122;
																																																																							goto
																																																																								BgL_tagzd2403zd2_1809;
																																																																							return
																																																																								(
																																																																								(BgL_nodez00_bglt)
																																																																								BgL_auxz00_29122);
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							goto
																																																																								BgL_tagzd2404zd2_1810;
																																																																						}
																																																																				}
																																																																		}
																																																																	else
																																																																		{	/* Ast/sexp.scm 119 */
																																																																			if ((CAR(BgL_expz00_21) == CNST_TABLE_REF(((long) 29))))
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (PAIRP(BgL_cdrzd262041zd2_5760))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							obj_t
																																																																								BgL_cdrzd262088zd2_5776;
																																																																							BgL_cdrzd262088zd2_5776
																																																																								=
																																																																								CDR
																																																																								(BgL_cdrzd262041zd2_5760);
																																																																							if (PAIRP(BgL_cdrzd262088zd2_5776))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd262093zd2_5778;
																																																																									BgL_cdrzd262093zd2_5778
																																																																										=
																																																																										CDR
																																																																										(BgL_cdrzd262088zd2_5776);
																																																																									if ((CAR(BgL_cdrzd262088zd2_5776) == CNST_TABLE_REF(((long) 31))))
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											if (PAIRP(BgL_cdrzd262093zd2_5778))
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_arg4783z00_5782;
																																																																													obj_t
																																																																														BgL_arg4784z00_5783;
																																																																													obj_t
																																																																														BgL_arg4785z00_5784;
																																																																													BgL_arg4783z00_5782
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262041zd2_5760);
																																																																													BgL_arg4784z00_5783
																																																																														=
																																																																														CAR
																																																																														(BgL_cdrzd262093zd2_5778);
																																																																													BgL_arg4785z00_5784
																																																																														=
																																																																														CDR
																																																																														(BgL_cdrzd262093zd2_5778);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4783z00_5782,
																																																																														BgL_arg4784z00_5783,
																																																																														BgL_arg4785z00_5784,
																																																																														BgL_stackz00_22,
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																															BgL_locz00_23),
																																																																														BgL_sitez00_24);
																																																																												}
																																																																											else
																																																																												{	/* Ast/sexp.scm 119 */
																																																																													obj_t
																																																																														BgL_cdrzd262106zd2_5785;
																																																																													BgL_cdrzd262106zd2_5785
																																																																														=
																																																																														CDR
																																																																														(BgL_expz00_21);
																																																																													{	/* Ast/sexp.scm 119 */
																																																																														obj_t
																																																																															BgL_arg4786z00_5786;
																																																																														obj_t
																																																																															BgL_arg4787z00_5787;
																																																																														BgL_arg4786z00_5786
																																																																															=
																																																																															CAR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5785));
																																																																														BgL_arg4787z00_5787
																																																																															=
																																																																															CDR
																																																																															(
																																																																															((obj_t) BgL_cdrzd262106zd2_5785));
																																																																														{	/* Ast/sexp.scm 555 */
																																																																															obj_t
																																																																																BgL_arg7015z00_13559;
																																																																															BgL_arg7015z00_13559
																																																																																=
																																																																																BGl_findzd2locationzf2locz20zztools_locationz00
																																																																																(BgL_expz00_21,
																																																																																BgL_locz00_23);
																																																																															return
																																																																																BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																																(BgL_expz00_21,
																																																																																BgL_arg4786z00_5786,
																																																																																CNST_TABLE_REF
																																																																																(((long) 4)), BgL_arg4787z00_5787, BgL_stackz00_22, BgL_arg7015z00_13559, BgL_sitez00_24);
																																																																										}}}}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											obj_t
																																																																												BgL_cdrzd262121zd2_5788;
																																																																											BgL_cdrzd262121zd2_5788
																																																																												=
																																																																												CDR
																																																																												(BgL_expz00_21);
																																																																											{	/* Ast/sexp.scm 119 */
																																																																												obj_t
																																																																													BgL_arg4788z00_5789;
																																																																												obj_t
																																																																													BgL_arg4789z00_5790;
																																																																												BgL_arg4788z00_5789
																																																																													=
																																																																													CAR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5788));
																																																																												BgL_arg4789z00_5790
																																																																													=
																																																																													CDR
																																																																													(
																																																																													((obj_t) BgL_cdrzd262121zd2_5788));
																																																																												{	/* Ast/sexp.scm 555 */
																																																																													obj_t
																																																																														BgL_arg7015z00_13563;
																																																																													BgL_arg7015z00_13563
																																																																														=
																																																																														BGl_findzd2locationzf2locz20zztools_locationz00
																																																																														(BgL_expz00_21,
																																																																														BgL_locz00_23);
																																																																													return
																																																																														BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																														(BgL_expz00_21,
																																																																														BgL_arg4788z00_5789,
																																																																														CNST_TABLE_REF
																																																																														(((long) 4)), BgL_arg4789z00_5790, BgL_stackz00_22, BgL_arg7015z00_13563, BgL_sitez00_24);
																																																																								}}}}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									obj_t
																																																																										BgL_cdrzd262136zd2_5792;
																																																																									BgL_cdrzd262136zd2_5792
																																																																										=
																																																																										CDR
																																																																										(BgL_expz00_21);
																																																																									{	/* Ast/sexp.scm 119 */
																																																																										obj_t
																																																																											BgL_arg4791z00_5793;
																																																																										obj_t
																																																																											BgL_arg4792z00_5794;
																																																																										BgL_arg4791z00_5793
																																																																											=
																																																																											CAR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5792));
																																																																										BgL_arg4792z00_5794
																																																																											=
																																																																											CDR
																																																																											(
																																																																											((obj_t) BgL_cdrzd262136zd2_5792));
																																																																										{	/* Ast/sexp.scm 555 */
																																																																											obj_t
																																																																												BgL_arg7015z00_13567;
																																																																											BgL_arg7015z00_13567
																																																																												=
																																																																												BGl_findzd2locationzf2locz20zztools_locationz00
																																																																												(BgL_expz00_21,
																																																																												BgL_locz00_23);
																																																																											return
																																																																												BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00
																																																																												(BgL_expz00_21,
																																																																												BgL_arg4791z00_5793,
																																																																												CNST_TABLE_REF
																																																																												(((long) 4)), BgL_arg4792z00_5794, BgL_stackz00_22, BgL_arg7015z00_13567, BgL_sitez00_24);
																																																																						}}}}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29171;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29171);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																								}
																																																																						}
																																																																				}
																																																																			else
																																																																				{	/* Ast/sexp.scm 119 */
																																																																					if (BGl_equalzf3zf3zz__r4_equivalence_6_2z00(CAR(BgL_expz00_21), BUNSPEC))
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (NULLP(CDR(BgL_expz00_21)))
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2402zd2_1808;
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																										{
																																																																											obj_t
																																																																												BgL_auxz00_29181;
																																																																											goto
																																																																												BgL_tagzd2403zd2_1809;
																																																																											return
																																																																												(
																																																																												(BgL_nodez00_bglt)
																																																																												BgL_auxz00_29181);
																																																																										}
																																																																									else
																																																																										{	/* Ast/sexp.scm 119 */
																																																																											goto
																																																																												BgL_tagzd2404zd2_1810;
																																																																										}
																																																																								}
																																																																						}
																																																																					else
																																																																						{	/* Ast/sexp.scm 119 */
																																																																							if (BGl_privatezd2sexpzf3z21zzast_privatez00(BgL_expz00_21))
																																																																								{
																																																																									obj_t
																																																																										BgL_auxz00_29185;
																																																																									goto
																																																																										BgL_tagzd2403zd2_1809;
																																																																									return
																																																																										(
																																																																										(BgL_nodez00_bglt)
																																																																										BgL_auxz00_29185);
																																																																								}
																																																																							else
																																																																								{	/* Ast/sexp.scm 119 */
																																																																									goto
																																																																										BgL_tagzd2404zd2_1810;
																																																																								}
																																																																						}
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																			}
																	}
															}
													}
											}
									}
								else
									{	/* Ast/sexp.scm 119 */
										BgL_atomz00_1741 = BgL_expz00_21;
										{	/* Ast/sexp.scm 135 */
											bool_t BgL_test10537z00_29187;

											if (BGl_isazf3zf3zz__objectz00(BgL_atomz00_1741,
													BGl_localz00zzast_varz00))
												{	/* Ast/sexp.scm 135 */
													BgL_test10537z00_29187 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 135 */
													BgL_test10537z00_29187 =
														BGl_isazf3zf3zz__objectz00(BgL_atomz00_1741,
														BGl_globalz00zzast_varz00);
												}
											if (BgL_test10537z00_29187)
												{	/* Ast/sexp.scm 135 */
													return
														BGl_variablezd2ze3nodez31zzast_sexpz00
														(BgL_atomz00_1741, BgL_locz00_23, BgL_sitez00_24);
												}
											else
												{	/* Ast/sexp.scm 137 */
													bool_t BgL_test10539z00_29192;

													if (STRUCTP(BgL_atomz00_1741))
														{	/* Ast/sexp.scm 137 */
															BgL_test10539z00_29192 = ((bool_t) 1);
														}
													else
														{	/* Ast/sexp.scm 137 */
															if (VECTORP(BgL_atomz00_1741))
																{	/* Ast/sexp.scm 138 */
																	BgL_test10539z00_29192 = ((bool_t) 1);
																}
															else
																{	/* Ast/sexp.scm 138 */
																	if (BGL_HVECTORP(BgL_atomz00_1741))
																		{	/* Ast/sexp.scm 138 */
																			BgL_test10539z00_29192 = ((bool_t) 1);
																		}
																	else
																		{	/* Ast/sexp.scm 138 */
																			if (BGL_OBJECTP(BgL_atomz00_1741))
																				{	/* Ast/sexp.scm 139 */
																					BgL_test10539z00_29192 = ((bool_t) 1);
																				}
																			else
																				{	/* Ast/sexp.scm 139 */
																					BgL_test10539z00_29192 =
																						PROCEDUREP(BgL_atomz00_1741);
																				}
																		}
																}
														}
													if (BgL_test10539z00_29192)
														{	/* Ast/sexp.scm 141 */
															BgL_nodez00_bglt BgL_res7365z00_9677;

															{	/* Ast/sexp.scm 726 */
																obj_t BgL_arg7130z00_9673;
																BgL_nodez00_bglt BgL_arg7131z00_9674;

																BgL_arg7130z00_9673 =
																	BGl_shapez00zztools_shapez00
																	(BGl_currentzd2functionzd2zztools_errorz00());
																BgL_arg7131z00_9674 =
																	BGl_sexpzd2ze3nodez31zzast_sexpz00
																	(CNST_TABLE_REF(((long) 4)), BNIL,
																	BgL_locz00_23, CNST_TABLE_REF(((long) 2)));
																{	/* Ast/sexp.scm 725 */
																	obj_t BgL_list7132z00_9676;

																	BgL_list7132z00_9676 =
																		MAKE_YOUNG_PAIR(
																		((obj_t) BgL_arg7131z00_9674), BNIL);
																	BgL_res7365z00_9677 =
																		((BgL_nodez00_bglt)
																		BGl_userzd2errorzf2locationz20zztools_errorz00
																		(BgL_locz00_23, BgL_arg7130z00_9673,
																			BGl_string8061z00zzast_sexpz00,
																			BgL_expz00_21, BgL_list7132z00_9676));
															}}
															return BgL_res7365z00_9677;
														}
													else
														{	/* Ast/sexp.scm 137 */
															if (SYMBOLP(BgL_atomz00_1741))
																{	/* Ast/sexp.scm 147 */
																	obj_t BgL_g1117z00_8400;

																	BgL_g1117z00_8400 =
																		BGl_findzd2localzd2zzast_sexpz00
																		(BgL_atomz00_1741, BgL_stackz00_22);
																	if (CBOOL(BgL_g1117z00_8400))
																		{	/* Ast/sexp.scm 147 */
																			return
																				BGl_variablezd2ze3nodez31zzast_sexpz00
																				(BgL_g1117z00_8400, BgL_locz00_23,
																				BgL_sitez00_24);
																		}
																	else
																		{	/* Ast/sexp.scm 151 */
																			obj_t BgL_globalz00_8403;
																			obj_t BgL_locz00_8404;

																			BgL_globalz00_8403 =
																				BGl_findzd2globalzd2zzast_envz00
																				(BgL_atomz00_1741, BNIL);
																			BgL_locz00_8404 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_atomz00_1741, BgL_locz00_23);
																			if (BGl_isazf3zf3zz__objectz00
																				(BgL_globalz00_8403,
																					BGl_globalz00zzast_varz00))
																				{	/* Ast/sexp.scm 154 */
																					if (
																						((((BgL_globalz00_bglt) COBJECT(
																										((BgL_globalz00_bglt)
																											BgL_globalz00_8403)))->
																								BgL_importz00) ==
																							CNST_TABLE_REF(((long) 10))))
																						{	/* Ast/sexp.scm 157 */
																							obj_t BgL_arg6657z00_8408;

																							{	/* Ast/sexp.scm 157 */
																								obj_t BgL_arg6658z00_8409;

																								{	/* Ast/sexp.scm 157 */
																									obj_t BgL_arg6659z00_8410;

																									{	/* Ast/sexp.scm 157 */
																										obj_t BgL_arg6660z00_8411;

																										BgL_arg6660z00_8411 =
																											MAKE_YOUNG_PAIR
																											(BgL_atomz00_1741, BNIL);
																										BgL_arg6659z00_8410 =
																											MAKE_YOUNG_PAIR
																											(CNST_TABLE_REF(((long)
																													12)),
																											BgL_arg6660z00_8411);
																									}
																									BgL_arg6658z00_8409 =
																										MAKE_YOUNG_PAIR
																										(BgL_arg6659z00_8410, BNIL);
																								}
																								BgL_arg6657z00_8408 =
																									MAKE_YOUNG_PAIR(CNST_TABLE_REF
																									(((long) 10)),
																									BgL_arg6658z00_8409);
																							}
																							{
																								obj_t BgL_locz00_29233;
																								obj_t BgL_expz00_29232;

																								BgL_expz00_29232 =
																									BgL_arg6657z00_8408;
																								BgL_locz00_29233 =
																									BgL_locz00_8404;
																								BgL_locz00_23 =
																									BgL_locz00_29233;
																								BgL_expz00_21 =
																									BgL_expz00_29232;
																								goto
																									BGl_sexpzd2ze3nodez31zzast_sexpz00;
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 156 */
																							return
																								BGl_variablezd2ze3nodez31zzast_sexpz00
																								(BgL_globalz00_8403,
																								BgL_locz00_8404,
																								BgL_sitez00_24);
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 155 */
																					BgL_nodez00_bglt BgL_res7368z00_9686;

																					{	/* Ast/sexp.scm 726 */
																						obj_t BgL_arg7130z00_9682;
																						BgL_nodez00_bglt
																							BgL_arg7131z00_9683;
																						BgL_arg7130z00_9682 =
																							BGl_shapez00zztools_shapez00
																							(BGl_currentzd2functionzd2zztools_errorz00
																							());
																						BgL_arg7131z00_9683 =
																							BGl_sexpzd2ze3nodez31zzast_sexpz00
																							(CNST_TABLE_REF(((long) 4)), BNIL,
																							BgL_locz00_8404,
																							CNST_TABLE_REF(((long) 2)));
																						{	/* Ast/sexp.scm 725 */
																							obj_t BgL_list7132z00_9685;

																							BgL_list7132z00_9685 =
																								MAKE_YOUNG_PAIR(
																								((obj_t) BgL_arg7131z00_9683),
																								BNIL);
																							BgL_res7368z00_9686 =
																								((BgL_nodez00_bglt)
																								BGl_userzd2errorzf2locationz20zztools_errorz00
																								(BgL_locz00_8404,
																									BgL_arg7130z00_9682,
																									BGl_string8060z00zzast_sexpz00,
																									BgL_expz00_21,
																									BgL_list7132z00_9685));
																					}}
																					return BgL_res7368z00_9686;
																				}
																		}
																}
															else
																{	/* Ast/sexp.scm 143 */
																	BgL_literalz00_bglt BgL_new1116z00_8414;

																	{	/* Ast/sexp.scm 144 */
																		BgL_literalz00_bglt BgL_new1115z00_8415;

																		BgL_new1115z00_8415 =
																			((BgL_literalz00_bglt)
																			BOBJECT(GC_MALLOC(sizeof(struct
																						BgL_literalz00_bgl))));
																		{	/* Ast/sexp.scm 144 */
																			long BgL_arg6663z00_8416;

																			{	/* Ast/sexp.scm 144 */
																				long BgL_res7369z00_9688;

																				BgL_res7369z00_9688 =
																					BGL_CLASS_INDEX
																					(BGl_literalz00zzast_nodez00);
																				BgL_arg6663z00_8416 =
																					BgL_res7369z00_9688;
																			}
																			BGL_OBJECT_CLASS_NUM_SET(
																				((BgL_objectz00_bglt)
																					BgL_new1115z00_8415),
																				BgL_arg6663z00_8416);
																		}
																		{	/* Ast/sexp.scm 144 */
																			BgL_objectz00_bglt BgL_tmpz00_29248;

																			BgL_tmpz00_29248 =
																				((BgL_objectz00_bglt)
																				BgL_new1115z00_8415);
																			BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29248,
																				BFALSE);
																		}
																		((BgL_objectz00_bglt) BgL_new1115z00_8415);
																		BgL_new1116z00_8414 = BgL_new1115z00_8415;
																	}
																	((((BgL_nodez00_bglt) COBJECT(
																					((BgL_nodez00_bglt)
																						BgL_new1116z00_8414)))->
																			BgL_locz00) =
																		((obj_t) BgL_locz00_23), BUNSPEC);
																	((((BgL_nodez00_bglt)
																				COBJECT(((BgL_nodez00_bglt)
																						BgL_new1116z00_8414)))->
																			BgL_typez00) =
																		((BgL_typez00_bglt)
																			BGl_getzd2typezd2atomz00zztype_typeofz00
																			(BgL_atomz00_1741)), BUNSPEC);
																	((((BgL_atomz00_bglt)
																				COBJECT(((BgL_atomz00_bglt)
																						BgL_new1116z00_8414)))->
																			BgL_valuez00) =
																		((obj_t) BgL_atomz00_1741), BUNSPEC);
																	return ((BgL_nodez00_bglt)
																		BgL_new1116z00_8414);
																}
														}
												}
										}
									}
							}
					}
			}
		}

	}



/* liip~0 */
	obj_t BGl_liipze70ze7zzast_sexpz00(obj_t BgL_argsz00_8827)
	{
		{	/* Ast/sexp.scm 399 */
			if (NULLP(BgL_argsz00_8827))
				{	/* Ast/sexp.scm 400 */
					return CNST_TABLE_REF(((long) 4));
				}
			else
				{	/* Ast/sexp.scm 402 */
					obj_t BgL_arg6906z00_8830;

					{	/* Ast/sexp.scm 402 */
						obj_t BgL_arg6907z00_8831;
						obj_t BgL_arg6908z00_8832;

						BgL_arg6907z00_8831 = CAR(((obj_t) BgL_argsz00_8827));
						{	/* Ast/sexp.scm 403 */
							obj_t BgL_arg6909z00_8833;

							{	/* Ast/sexp.scm 403 */
								obj_t BgL_arg6910z00_8834;

								BgL_arg6910z00_8834 = CDR(((obj_t) BgL_argsz00_8827));
								BgL_arg6909z00_8833 =
									BGl_liipze70ze7zzast_sexpz00(BgL_arg6910z00_8834);
							}
							BgL_arg6908z00_8832 = MAKE_YOUNG_PAIR(BgL_arg6909z00_8833, BNIL);
						}
						BgL_arg6906z00_8830 =
							MAKE_YOUNG_PAIR(BgL_arg6907z00_8831, BgL_arg6908z00_8832);
					}
					return
						MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 32)), BgL_arg6906z00_8830);
		}}

	}



/* loop~0 */
	obj_t BGl_loopze70ze7zzast_sexpz00(obj_t BgL_expz00_13887,
		obj_t BgL_locz00_13886, obj_t BgL_varsz00_8789, obj_t BgL_argsz00_8790)
	{
		{	/* Ast/sexp.scm 384 */
		BGl_loopze70ze7zzast_sexpz00:
			if (NULLP(BgL_varsz00_8789))
				{	/* Ast/sexp.scm 387 */
					if (NULLP(BgL_argsz00_8790))
						{	/* Ast/sexp.scm 388 */
							return BNIL;
						}
					else
						{	/* Ast/sexp.scm 388 */
							return
								BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_13886,
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00()),
								BGl_string8063z00zzast_sexpz00, BgL_expz00_13887, BNIL);
						}
				}
			else
				{	/* Ast/sexp.scm 387 */
					if (PAIRP(BgL_varsz00_8789))
						{	/* Ast/sexp.scm 395 */
							if (BGl_dssslzd2namedzd2constantzf3zf3zz__dssslz00(CAR
									(BgL_varsz00_8789)))
								{	/* Ast/sexp.scm 405 */
									obj_t BgL_argz00_8800;

									BgL_argz00_8800 =
										BGl_dssslzd2findzd2firstzd2formalzd2zztools_dssslz00(CDR
										(BgL_varsz00_8789));
									if (CBOOL(BgL_argz00_8800))
										{
											obj_t BgL_varsz00_29288;

											BgL_varsz00_29288 = BgL_argz00_8800;
											BgL_varsz00_8789 = BgL_varsz00_29288;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
									else
										{
											obj_t BgL_varsz00_29289;

											BgL_varsz00_29289 = BNIL;
											BgL_varsz00_8789 = BgL_varsz00_29289;
											goto BGl_loopze70ze7zzast_sexpz00;
										}
								}
							else
								{	/* Ast/sexp.scm 410 */
									bool_t BgL_test10554z00_29290;

									{	/* Ast/sexp.scm 410 */
										obj_t BgL_tmpz00_29291;

										BgL_tmpz00_29291 = CAR(BgL_varsz00_8789);
										BgL_test10554z00_29290 = SYMBOLP(BgL_tmpz00_29291);
									}
									if (BgL_test10554z00_29290)
										{	/* Ast/sexp.scm 410 */
											if (NULLP(BgL_argsz00_8790))
												{	/* Ast/sexp.scm 416 */
													return
														BGl_userzd2errorzf2locationz20zztools_errorz00
														(BgL_locz00_13886,
														BGl_shapez00zztools_shapez00
														(BGl_currentzd2functionzd2zztools_errorz00()),
														BGl_string8063z00zzast_sexpz00, BgL_expz00_13887,
														BNIL);
												}
											else
												{	/* Ast/sexp.scm 423 */
													obj_t BgL_arg6886z00_8808;
													obj_t BgL_arg6887z00_8809;

													{	/* Ast/sexp.scm 423 */
														obj_t BgL_arg6888z00_8810;
														obj_t BgL_arg6889z00_8811;

														BgL_arg6888z00_8810 = CAR(BgL_varsz00_8789);
														BgL_arg6889z00_8811 =
															CAR(((obj_t) BgL_argsz00_8790));
														{	/* Ast/sexp.scm 423 */
															obj_t BgL_list6890z00_8812;

															{	/* Ast/sexp.scm 423 */
																obj_t BgL_arg6891z00_8813;

																BgL_arg6891z00_8813 =
																	MAKE_YOUNG_PAIR(BgL_arg6889z00_8811, BNIL);
																BgL_list6890z00_8812 =
																	MAKE_YOUNG_PAIR(BgL_arg6888z00_8810,
																	BgL_arg6891z00_8813);
															}
															BgL_arg6886z00_8808 = BgL_list6890z00_8812;
														}
													}
													{	/* Ast/sexp.scm 424 */
														obj_t BgL_arg6892z00_8814;
														obj_t BgL_arg6893z00_8815;

														BgL_arg6892z00_8814 = CDR(BgL_varsz00_8789);
														BgL_arg6893z00_8815 =
															CDR(((obj_t) BgL_argsz00_8790));
														BgL_arg6887z00_8809 =
															BGl_loopze70ze7zzast_sexpz00(BgL_expz00_13887,
															BgL_locz00_13886, BgL_arg6892z00_8814,
															BgL_arg6893z00_8815);
													}
													return
														MAKE_YOUNG_PAIR(BgL_arg6886z00_8808,
														BgL_arg6887z00_8809);
												}
										}
									else
										{	/* Ast/sexp.scm 410 */
											return
												BGl_userzd2errorzf2locationz20zztools_errorz00
												(BgL_locz00_13886,
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00()),
												BGl_string8064z00zzast_sexpz00, BgL_expz00_13887, BNIL);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 400 */
							obj_t BgL_arg6899z00_8821;

							{	/* Ast/sexp.scm 400 */
								obj_t BgL_arg6901z00_8823;

								BgL_arg6901z00_8823 =
									BGl_liipze70ze7zzast_sexpz00(BgL_argsz00_8790);
								{	/* Ast/sexp.scm 397 */
									obj_t BgL_list6902z00_8824;

									{	/* Ast/sexp.scm 397 */
										obj_t BgL_arg6903z00_8825;

										BgL_arg6903z00_8825 =
											MAKE_YOUNG_PAIR(BgL_arg6901z00_8823, BNIL);
										BgL_list6902z00_8824 =
											MAKE_YOUNG_PAIR(BgL_varsz00_8789, BgL_arg6903z00_8825);
									}
									BgL_arg6899z00_8821 = BgL_list6902z00_8824;
								}
							}
							{	/* Ast/sexp.scm 396 */
								obj_t BgL_list6900z00_8822;

								BgL_list6900z00_8822 =
									MAKE_YOUNG_PAIR(BgL_arg6899z00_8821, BNIL);
								return BgL_list6900z00_8822;
							}
						}
				}
		}

	}



/* &sexp->node */
	BgL_nodez00_bglt BGl_z62sexpzd2ze3nodez53zzast_sexpz00(obj_t BgL_envz00_13844,
		obj_t BgL_expz00_13845, obj_t BgL_stackz00_13846, obj_t BgL_locz00_13847,
		obj_t BgL_sitez00_13848)
	{
		{	/* Ast/sexp.scm 114 */
			return
				BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_13845, BgL_stackz00_13846,
				BgL_locz00_13847, BgL_sitez00_13848);
		}

	}



/* &<@anonymous:6916> */
	obj_t BGl_z62zc3z04anonymousza36916ze3ze5zzast_sexpz00(obj_t BgL_envz00_13849,
		obj_t BgL_objz00_13851, obj_t BgL_procz00_13852, obj_t BgL_msgz00_13853)
	{
		{	/* Ast/sexp.scm 429 */
			return
				BGl_userzd2errorzf2locationz20zztools_errorz00(PROCEDURE_REF
				(BgL_envz00_13849, (int) (((long) 0))), BgL_objz00_13851,
				BgL_procz00_13852, BgL_msgz00_13853, BNIL);
		}

	}



/* lambda->node */
	BgL_nodez00_bglt BGl_lambdazd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_25,
		obj_t BgL_stackz00_26, obj_t BgL_locz00_27, obj_t BgL_sitez00_28,
		obj_t BgL_prefnamez00_29)
	{
		{	/* Ast/sexp.scm 574 */
			{
				obj_t BgL_argsz00_9015;
				obj_t BgL_bodyz00_9016;

				if (PAIRP(BgL_expz00_25))
					{	/* Ast/sexp.scm 575 */
						obj_t BgL_cdrzd262408zd2_9021;

						BgL_cdrzd262408zd2_9021 = CDR(BgL_expz00_25);
						if (PAIRP(BgL_cdrzd262408zd2_9021))
							{	/* Ast/sexp.scm 575 */
								BgL_argsz00_9015 = CAR(BgL_cdrzd262408zd2_9021);
								BgL_bodyz00_9016 = CDR(BgL_cdrzd262408zd2_9021);
								{	/* Ast/sexp.scm 577 */
									obj_t BgL_locz00_9025;
									obj_t BgL_funz00_9026;

									BgL_locz00_9025 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expz00_25, BgL_locz00_27);
									{	/* Ast/sexp.scm 578 */
										obj_t BgL_list7030z00_9036;

										BgL_list7030z00_9036 =
											MAKE_YOUNG_PAIR(BgL_prefnamez00_29, BNIL);
										BgL_funz00_9026 =
											BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_27,
											BgL_list7030z00_9036);
									}
									{	/* Ast/sexp.scm 579 */
										obj_t BgL_arg7021z00_9027;

										{	/* Ast/sexp.scm 579 */
											obj_t BgL_arg7022z00_9028;
											obj_t BgL_arg7023z00_9029;

											BgL_arg7022z00_9028 =
												BGl_labelszd2symzd2zzast_labelsz00();
											{	/* Ast/sexp.scm 579 */
												obj_t BgL_arg7024z00_9030;
												obj_t BgL_arg7025z00_9031;

												{	/* Ast/sexp.scm 579 */
													obj_t BgL_arg7026z00_9032;

													{	/* Ast/sexp.scm 579 */
														obj_t BgL_arg7027z00_9033;

														{	/* Ast/sexp.scm 579 */
															obj_t BgL_arg7028z00_9034;

															BgL_arg7028z00_9034 =
																MAKE_YOUNG_PAIR
																(BGl_normaliza7ezd2prognz75zztools_prognz00
																(BgL_bodyz00_9016), BNIL);
															BgL_arg7027z00_9033 =
																MAKE_YOUNG_PAIR(BgL_argsz00_9015,
																BgL_arg7028z00_9034);
														}
														BgL_arg7026z00_9032 =
															MAKE_YOUNG_PAIR(BgL_funz00_9026,
															BgL_arg7027z00_9033);
													}
													BgL_arg7024z00_9030 =
														MAKE_YOUNG_PAIR(BgL_arg7026z00_9032, BNIL);
												}
												BgL_arg7025z00_9031 =
													MAKE_YOUNG_PAIR(BgL_funz00_9026, BNIL);
												BgL_arg7023z00_9029 =
													MAKE_YOUNG_PAIR(BgL_arg7024z00_9030,
													BgL_arg7025z00_9031);
											}
											BgL_arg7021z00_9027 =
												MAKE_YOUNG_PAIR(BgL_arg7022z00_9028,
												BgL_arg7023z00_9029);
										}
										return
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7021z00_9027,
											BgL_stackz00_26, BgL_locz00_9025, BgL_sitez00_28);
									}
								}
							}
						else
							{	/* Ast/sexp.scm 575 */
							BgL_tagzd262401zd2_9018:
								{	/* Ast/sexp.scm 586 */
									obj_t BgL_arg7031z00_9037;

									BgL_arg7031z00_9037 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expz00_25, BgL_locz00_27);
									{	/* Ast/sexp.scm 584 */
										BgL_nodez00_bglt BgL_res7964z00_13576;

										{	/* Ast/sexp.scm 726 */
											obj_t BgL_arg7130z00_13572;
											BgL_nodez00_bglt BgL_arg7131z00_13573;

											BgL_arg7130z00_13572 =
												BGl_shapez00zztools_shapez00
												(BGl_currentzd2functionzd2zztools_errorz00());
											BgL_arg7131z00_13573 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF((
														(long) 4)), BNIL, BgL_arg7031z00_9037,
												CNST_TABLE_REF(((long) 2)));
											{	/* Ast/sexp.scm 725 */
												obj_t BgL_list7132z00_13575;

												BgL_list7132z00_13575 =
													MAKE_YOUNG_PAIR(((obj_t) BgL_arg7131z00_13573), BNIL);
												BgL_res7964z00_13576 =
													((BgL_nodez00_bglt)
													BGl_userzd2errorzf2locationz20zztools_errorz00
													(BgL_arg7031z00_9037, BgL_arg7130z00_13572,
														BGl_string8065z00zzast_sexpz00, BgL_expz00_25,
														BgL_list7132z00_13575));
										}}
										return BgL_res7964z00_13576;
									}
								}
							}
					}
				else
					{	/* Ast/sexp.scm 575 */
						goto BgL_tagzd262401zd2_9018;
					}
			}
		}

	}



/* variable->node */
	BgL_nodez00_bglt BGl_variablezd2ze3nodez31zzast_sexpz00(obj_t BgL_vz00_30,
		obj_t BgL_locz00_31, obj_t BgL_sitez00_32)
	{
		{	/* Ast/sexp.scm 591 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_vz00_30), BgL_locz00_31, BgL_sitez00_32);
			{	/* Ast/sexp.scm 593 */
				bool_t BgL_test10558z00_29352;

				if ((BgL_sitez00_32 == CNST_TABLE_REF(((long) 33))))
					{	/* Ast/sexp.scm 593 */
						BgL_test10558z00_29352 = ((bool_t) 0);
					}
				else
					{	/* Ast/sexp.scm 593 */
						BgL_valuez00_bglt BgL_arg7054z00_9069;

						BgL_arg7054z00_9069 =
							(((BgL_variablez00_bglt) COBJECT(
									((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_valuez00);
						{	/* Ast/sexp.scm 593 */
							bool_t BgL_res7967z00_13583;

							BgL_res7967z00_13583 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg7054z00_9069), BGl_funz00zzast_varz00);
							BgL_test10558z00_29352 = BgL_res7967z00_13583;
						}
					}
				if (BgL_test10558z00_29352)
					{	/* Ast/sexp.scm 594 */
						bool_t BgL_test10560z00_29360;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_30,
								BGl_globalz00zzast_varz00))
							{	/* Ast/sexp.scm 595 */
								bool_t BgL_test10562z00_29363;

								{	/* Ast/sexp.scm 595 */
									BgL_valuez00_bglt BgL_arg7051z00_9063;

									BgL_arg7051z00_9063 =
										(((BgL_variablez00_bglt) COBJECT(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_30))))->BgL_valuez00);
									{	/* Ast/sexp.scm 595 */
										bool_t BgL_res7969z00_13586;

										BgL_res7969z00_13586 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_arg7051z00_9063), BGl_cfunz00zzast_varz00);
										BgL_test10562z00_29363 = BgL_res7969z00_13586;
									}
								}
								if (BgL_test10562z00_29363)
									{	/* Ast/sexp.scm 596 */
										bool_t BgL_test10563z00_29369;

										{	/* Ast/sexp.scm 596 */
											obj_t BgL_arg7050z00_9062;

											BgL_arg7050z00_9062 =
												BGl_thezd2backendzd2zzbackend_backendz00();
											BgL_test10563z00_29369 =
												(((BgL_backendz00_bglt) COBJECT(
														((BgL_backendz00_bglt) BgL_arg7050z00_9062)))->
												BgL_foreignzd2closurezd2);
										}
										if (BgL_test10563z00_29369)
											{	/* Ast/sexp.scm 596 */
												BgL_test10560z00_29360 = ((bool_t) 0);
											}
										else
											{	/* Ast/sexp.scm 596 */
												if ((BgL_sitez00_32 == CNST_TABLE_REF(((long) 30))))
													{	/* Ast/sexp.scm 597 */
														BgL_test10560z00_29360 = ((bool_t) 0);
													}
												else
													{	/* Ast/sexp.scm 597 */
														BgL_test10560z00_29360 = ((bool_t) 1);
													}
											}
									}
								else
									{	/* Ast/sexp.scm 595 */
										BgL_test10560z00_29360 = ((bool_t) 0);
									}
							}
						else
							{	/* Ast/sexp.scm 594 */
								BgL_test10560z00_29360 = ((bool_t) 0);
							}
						if (BgL_test10560z00_29360)
							{	/* Ast/sexp.scm 599 */
								obj_t BgL_arg7044z00_9050;

								{	/* Ast/sexp.scm 599 */
									obj_t BgL_arg7045z00_9051;

									{	/* Ast/sexp.scm 599 */
										obj_t BgL_arg7047z00_9053;

										BgL_arg7047z00_9053 =
											BGl_thezd2backendzd2zzbackend_backendz00();
										BgL_arg7045z00_9051 =
											(((BgL_backendz00_bglt) COBJECT(
													((BgL_backendz00_bglt) BgL_arg7047z00_9053)))->
											BgL_namez00);
									}
									{	/* Ast/sexp.scm 599 */
										obj_t BgL_list7046z00_9052;

										BgL_list7046z00_9052 =
											MAKE_YOUNG_PAIR(BgL_arg7045z00_9051, BNIL);
										BgL_arg7044z00_9050 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string8066z00zzast_sexpz00, BgL_list7046z00_9052);
									}
								}
								return
									BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00
									(BgL_arg7044z00_9050, BGl_expzd2envzd2zz__r4_numbers_6_5z00,
									BgL_locz00_31);
							}
						else
							{	/* Ast/sexp.scm 600 */
								BgL_closurez00_bglt BgL_new1146z00_9054;

								{	/* Ast/sexp.scm 601 */
									BgL_closurez00_bglt BgL_new1145z00_9056;

									BgL_new1145z00_9056 =
										((BgL_closurez00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_closurez00_bgl))));
									{	/* Ast/sexp.scm 601 */
										long BgL_arg7049z00_9057;

										{	/* Ast/sexp.scm 601 */
											long BgL_res7972z00_13594;

											BgL_res7972z00_13594 =
												BGL_CLASS_INDEX(BGl_closurez00zzast_nodez00);
											BgL_arg7049z00_9057 = BgL_res7972z00_13594;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1145z00_9056),
											BgL_arg7049z00_9057);
									}
									BgL_new1146z00_9054 = BgL_new1145z00_9056;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1146z00_9054)))->
										BgL_locz00) = ((obj_t) BgL_locz00_31), BUNSPEC);
								{
									BgL_typez00_bglt BgL_auxz00_29388;

									{	/* Ast/sexp.scm 602 */
										BgL_typez00_bglt BgL_arg7048z00_9055;

										BgL_arg7048z00_9055 =
											(((BgL_variablez00_bglt) COBJECT(
													((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_typez00);
										BgL_auxz00_29388 =
											BGl_strictzd2nodezd2typez00zzast_nodez00(
											((BgL_typez00_bglt)
												BGl_za2procedureza2z00zztype_cachez00),
											BgL_arg7048z00_9055);
									}
									((((BgL_nodez00_bglt) COBJECT(
													((BgL_nodez00_bglt) BgL_new1146z00_9054)))->
											BgL_typez00) =
										((BgL_typez00_bglt) BgL_auxz00_29388), BUNSPEC);
								}
								((((BgL_varz00_bglt) COBJECT(
												((BgL_varz00_bglt) BgL_new1146z00_9054)))->
										BgL_variablez00) =
									((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_30)),
									BUNSPEC);
								return ((BgL_nodez00_bglt) BgL_new1146z00_9054);
							}
					}
				else
					{	/* Ast/sexp.scm 604 */
						BgL_varz00_bglt BgL_new1148z00_9064;

						{	/* Ast/sexp.scm 605 */
							BgL_varz00_bglt BgL_new1147z00_9066;

							BgL_new1147z00_9066 =
								((BgL_varz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
											BgL_varz00_bgl))));
							{	/* Ast/sexp.scm 605 */
								long BgL_arg7053z00_9067;

								{	/* Ast/sexp.scm 605 */
									long BgL_res7973z00_13599;

									BgL_res7973z00_13599 =
										BGL_CLASS_INDEX(BGl_varz00zzast_nodez00);
									BgL_arg7053z00_9067 = BgL_res7973z00_13599;
								}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_new1147z00_9066),
									BgL_arg7053z00_9067);
							}
							BgL_new1148z00_9064 = BgL_new1147z00_9066;
						}
						((((BgL_nodez00_bglt) COBJECT(
										((BgL_nodez00_bglt) BgL_new1148z00_9064)))->BgL_locz00) =
							((obj_t) BgL_locz00_31), BUNSPEC);
						{
							BgL_typez00_bglt BgL_auxz00_29405;

							{	/* Ast/sexp.scm 606 */
								BgL_typez00_bglt BgL_arg7052z00_9065;

								BgL_arg7052z00_9065 =
									(((BgL_variablez00_bglt) COBJECT(
											((BgL_variablez00_bglt) BgL_vz00_30)))->BgL_typez00);
								BgL_auxz00_29405 =
									BGl_strictzd2nodezd2typez00zzast_nodez00(
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00),
									BgL_arg7052z00_9065);
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1148z00_9064)))->BgL_typez00) =
								((BgL_typez00_bglt) BgL_auxz00_29405), BUNSPEC);
						}
						((((BgL_varz00_bglt) COBJECT(BgL_new1148z00_9064))->
								BgL_variablez00) =
							((BgL_variablez00_bglt) ((BgL_variablez00_bglt) BgL_vz00_30)),
							BUNSPEC);
						return ((BgL_nodez00_bglt) BgL_new1148z00_9064);
					}
			}
		}

	}



/* call->node */
	BgL_nodez00_bglt BGl_callzd2ze3nodez31zzast_sexpz00(obj_t BgL_expz00_33,
		obj_t BgL_stackz00_34, obj_t BgL_locz00_35, obj_t BgL_sitez00_36)
	{
		{	/* Ast/sexp.scm 612 */
			{	/* Ast/sexp.scm 613 */
				obj_t BgL_callerz00_9070;
				obj_t BgL_locz00_9071;

				BgL_callerz00_9070 = CAR(((obj_t) BgL_expz00_33));
				BgL_locz00_9071 =
					BGl_findzd2locationzf2locz20zztools_locationz00(BgL_expz00_33,
					BgL_locz00_35);
				if (SYMBOLP(BgL_callerz00_9070))
					{	/* Ast/sexp.scm 617 */
						obj_t BgL_pidz00_9073;

						BgL_pidz00_9073 =
							BGl_parsezd2idzd2zzast_identz00(BgL_callerz00_9070,
							BgL_locz00_9071);
						{	/* Ast/sexp.scm 617 */
							obj_t BgL_idz00_9074;

							BgL_idz00_9074 = CAR(BgL_pidz00_9073);
							{	/* Ast/sexp.scm 618 */
								obj_t BgL_typez00_9075;

								BgL_typez00_9075 = CDR(BgL_pidz00_9073);
								{	/* Ast/sexp.scm 619 */

									if ((BgL_idz00_9074 == CNST_TABLE_REF(((long) 6))))
										{	/* Ast/sexp.scm 620 */
											return
												BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00(((bool_t)
													0), BFALSE, ((BgL_typez00_bglt) BgL_typez00_9075),
												BgL_expz00_33, BgL_stackz00_34, BgL_locz00_9071,
												BgL_sitez00_36);
										}
									else
										{	/* Ast/sexp.scm 620 */
											if ((BgL_idz00_9074 == CNST_TABLE_REF(((long) 21))))
												{	/* Ast/sexp.scm 624 */
													bool_t BgL_test10568z00_29431;

													{	/* Ast/sexp.scm 624 */
														obj_t BgL_tmpz00_29432;

														BgL_tmpz00_29432 = CDR(((obj_t) BgL_expz00_33));
														BgL_test10568z00_29431 = PAIRP(BgL_tmpz00_29432);
													}
													if (BgL_test10568z00_29431)
														{	/* Ast/sexp.scm 628 */
															BgL_feffectz00_bglt BgL_arg7060z00_9081;
															obj_t BgL_arg7061z00_9082;

															{	/* Ast/sexp.scm 628 */
																obj_t BgL_arg7062z00_9083;

																{	/* Ast/sexp.scm 628 */
																	obj_t BgL_pairz00_13616;

																	BgL_pairz00_13616 =
																		CDR(((obj_t) BgL_expz00_33));
																	BgL_arg7062z00_9083 = CAR(BgL_pairz00_13616);
																}
																BgL_arg7060z00_9081 =
																	BGl_parsezd2effectzd2zzeffect_feffectz00
																	(BgL_arg7062z00_9083);
															}
															{	/* Ast/sexp.scm 629 */
																obj_t BgL_arg7063z00_9084;
																obj_t BgL_arg7064z00_9085;

																{	/* Ast/sexp.scm 629 */
																	obj_t BgL_arg7065z00_9086;

																	BgL_arg7065z00_9086 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 34)),
																		BNIL);
																	BgL_arg7063z00_9084 =
																		MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 35)),
																		BgL_arg7065z00_9086);
																}
																{	/* Ast/sexp.scm 629 */
																	obj_t BgL_auxz00_29444;

																	{	/* Ast/sexp.scm 629 */
																		obj_t BgL_pairz00_13620;

																		BgL_pairz00_13620 =
																			CDR(((obj_t) BgL_expz00_33));
																		BgL_auxz00_29444 = CDR(BgL_pairz00_13620);
																	}
																	BgL_arg7064z00_9085 =
																		BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																		(BgL_auxz00_29444, BNIL);
																}
																BgL_arg7061z00_9082 =
																	MAKE_YOUNG_PAIR(BgL_arg7063z00_9084,
																	BgL_arg7064z00_9085);
															}
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 0), ((obj_t) BgL_arg7060z00_9081),
																((BgL_typez00_bglt) BgL_typez00_9075),
																BgL_arg7061z00_9082, BgL_stackz00_34,
																BgL_locz00_9071, BgL_sitez00_36);
														}
													else
														{	/* Ast/sexp.scm 627 */
															obj_t BgL_arg7067z00_9088;

															BgL_arg7067z00_9088 =
																BGl_findzd2locationzf2locz20zztools_locationz00
																(BgL_expz00_33, BgL_locz00_9071);
															{	/* Ast/sexp.scm 625 */
																BgL_nodez00_bglt BgL_res7978z00_13626;

																{	/* Ast/sexp.scm 726 */
																	obj_t BgL_arg7130z00_13622;
																	BgL_nodez00_bglt BgL_arg7131z00_13623;

																	BgL_arg7130z00_13622 =
																		BGl_shapez00zztools_shapez00
																		(BGl_currentzd2functionzd2zztools_errorz00
																		());
																	BgL_arg7131z00_13623 =
																		BGl_sexpzd2ze3nodez31zzast_sexpz00
																		(CNST_TABLE_REF(((long) 4)), BNIL,
																		BgL_arg7067z00_9088,
																		CNST_TABLE_REF(((long) 2)));
																	{	/* Ast/sexp.scm 725 */
																		obj_t BgL_list7132z00_13625;

																		BgL_list7132z00_13625 =
																			MAKE_YOUNG_PAIR(
																			((obj_t) BgL_arg7131z00_13623), BNIL);
																		BgL_res7978z00_13626 =
																			((BgL_nodez00_bglt)
																			BGl_userzd2errorzf2locationz20zztools_errorz00
																			(BgL_arg7067z00_9088,
																				BgL_arg7130z00_13622,
																				BGl_string8067z00zzast_sexpz00,
																				BgL_expz00_33, BgL_list7132z00_13625));
																}}
																return BgL_res7978z00_13626;
															}
														}
												}
											else
												{	/* Ast/sexp.scm 620 */
													if ((BgL_idz00_9074 == CNST_TABLE_REF(((long) 22))))
														{	/* Ast/sexp.scm 620 */
															return
																BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00((
																	(bool_t) 1), BFALSE,
																((BgL_typez00_bglt) BgL_typez00_9075),
																BgL_expz00_33, BgL_stackz00_34, BgL_locz00_9071,
																BgL_sitez00_36);
														}
													else
														{	/* Ast/sexp.scm 620 */
															if (
																(BgL_idz00_9074 == CNST_TABLE_REF(((long) 24))))
																{	/* Ast/sexp.scm 634 */
																	bool_t BgL_test10571z00_29471;

																	{	/* Ast/sexp.scm 634 */
																		obj_t BgL_tmpz00_29472;

																		BgL_tmpz00_29472 =
																			CDR(((obj_t) BgL_expz00_33));
																		BgL_test10571z00_29471 =
																			PAIRP(BgL_tmpz00_29472);
																	}
																	if (BgL_test10571z00_29471)
																		{	/* Ast/sexp.scm 638 */
																			BgL_feffectz00_bglt BgL_arg7073z00_9094;
																			obj_t BgL_arg7074z00_9095;

																			{	/* Ast/sexp.scm 638 */
																				obj_t BgL_arg7075z00_9096;

																				{	/* Ast/sexp.scm 638 */
																					obj_t BgL_pairz00_13636;

																					BgL_pairz00_13636 =
																						CDR(((obj_t) BgL_expz00_33));
																					BgL_arg7075z00_9096 =
																						CAR(BgL_pairz00_13636);
																				}
																				BgL_arg7073z00_9094 =
																					BGl_parsezd2effectzd2zzeffect_feffectz00
																					(BgL_arg7075z00_9096);
																			}
																			{	/* Ast/sexp.scm 639 */
																				obj_t BgL_arg7076z00_9097;
																				obj_t BgL_arg7077z00_9098;

																				{	/* Ast/sexp.scm 639 */
																					obj_t BgL_arg7078z00_9099;

																					BgL_arg7078z00_9099 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 34)), BNIL);
																					BgL_arg7076z00_9097 =
																						MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																								(long) 35)),
																						BgL_arg7078z00_9099);
																				}
																				{	/* Ast/sexp.scm 639 */
																					obj_t BgL_auxz00_29484;

																					{	/* Ast/sexp.scm 639 */
																						obj_t BgL_pairz00_13640;

																						BgL_pairz00_13640 =
																							CDR(((obj_t) BgL_expz00_33));
																						BgL_auxz00_29484 =
																							CDR(BgL_pairz00_13640);
																					}
																					BgL_arg7077z00_9098 =
																						BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
																						(BgL_auxz00_29484, BNIL);
																				}
																				BgL_arg7074z00_9095 =
																					MAKE_YOUNG_PAIR(BgL_arg7076z00_9097,
																					BgL_arg7077z00_9098);
																			}
																			return
																				BGl_pragmazf2typezd2ze3nodezc3zzast_pragmaz00
																				(((bool_t) 1),
																				((obj_t) BgL_arg7073z00_9094),
																				((BgL_typez00_bglt) BgL_typez00_9075),
																				BgL_arg7074z00_9095, BgL_stackz00_34,
																				BgL_locz00_9071, BgL_sitez00_36);
																		}
																	else
																		{	/* Ast/sexp.scm 637 */
																			obj_t BgL_arg7080z00_9101;

																			BgL_arg7080z00_9101 =
																				BGl_findzd2locationzf2locz20zztools_locationz00
																				(BgL_expz00_33, BgL_locz00_9071);
																			{	/* Ast/sexp.scm 635 */
																				BgL_nodez00_bglt BgL_res7982z00_13646;

																				{	/* Ast/sexp.scm 726 */
																					obj_t BgL_arg7130z00_13642;
																					BgL_nodez00_bglt BgL_arg7131z00_13643;

																					BgL_arg7130z00_13642 =
																						BGl_shapez00zztools_shapez00
																						(BGl_currentzd2functionzd2zztools_errorz00
																						());
																					BgL_arg7131z00_13643 =
																						BGl_sexpzd2ze3nodez31zzast_sexpz00
																						(CNST_TABLE_REF(((long) 4)), BNIL,
																						BgL_arg7080z00_9101,
																						CNST_TABLE_REF(((long) 2)));
																					{	/* Ast/sexp.scm 725 */
																						obj_t BgL_list7132z00_13645;

																						BgL_list7132z00_13645 =
																							MAKE_YOUNG_PAIR(
																							((obj_t) BgL_arg7131z00_13643),
																							BNIL);
																						BgL_res7982z00_13646 =
																							((BgL_nodez00_bglt)
																							BGl_userzd2errorzf2locationz20zztools_errorz00
																							(BgL_arg7080z00_9101,
																								BgL_arg7130z00_13642,
																								BGl_string8068z00zzast_sexpz00,
																								BgL_expz00_33,
																								BgL_list7132z00_13645));
																				}}
																				return BgL_res7982z00_13646;
																			}
																		}
																}
															else
																{	/* Ast/sexp.scm 620 */
																	if (
																		(BgL_idz00_9074 ==
																			CNST_TABLE_REF(((long) 3))))
																		{
																			obj_t BgL_argsz00_9104;
																			obj_t BgL_bodyz00_9105;

																			if (PAIRP(BgL_expz00_33))
																				{	/* Ast/sexp.scm 642 */
																					obj_t BgL_cdrzd262423zd2_9110;

																					BgL_cdrzd262423zd2_9110 =
																						CDR(BgL_expz00_33);
																					if (PAIRP(BgL_cdrzd262423zd2_9110))
																						{	/* Ast/sexp.scm 642 */
																							BgL_argsz00_9104 =
																								CAR(BgL_cdrzd262423zd2_9110);
																							BgL_bodyz00_9105 =
																								CDR(BgL_cdrzd262423zd2_9110);
																							{	/* Ast/sexp.scm 644 */
																								obj_t BgL_locz00_9114;

																								BgL_locz00_9114 =
																									BGl_findzd2locationzf2locz20zztools_locationz00
																									(BgL_expz00_33,
																									BgL_locz00_9071);
																								{	/* Ast/sexp.scm 644 */
																									obj_t BgL_funz00_9115;

																									BgL_funz00_9115 =
																										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
																										(BGl_gensymz00zz__r4_symbols_6_4z00
																										(CNST_TABLE_REF(((long)
																													3))));
																									{	/* Ast/sexp.scm 645 */
																										obj_t BgL_tfunz00_9116;

																										if (BGl_bigloozd2typezf3z21zztype_typez00(((BgL_typez00_bglt) BgL_typez00_9075)))
																											{	/* Ast/sexp.scm 647 */
																												obj_t
																													BgL_arg7097z00_9127;
																												BgL_arg7097z00_9127 =
																													(((BgL_typez00_bglt)
																														COBJECT((
																																(BgL_typez00_bglt)
																																BgL_typez00_9075)))->
																													BgL_idz00);
																												BgL_tfunz00_9116 =
																													BGl_makezd2typedzd2identz00zzast_identz00
																													(BgL_funz00_9115,
																													BgL_arg7097z00_9127);
																											}
																										else
																											{	/* Ast/sexp.scm 646 */
																												BgL_tfunz00_9116 =
																													BgL_funz00_9115;
																											}
																										{	/* Ast/sexp.scm 646 */

																											{	/* Ast/sexp.scm 650 */
																												obj_t
																													BgL_arg7087z00_9117;
																												{	/* Ast/sexp.scm 650 */
																													obj_t
																														BgL_arg7088z00_9118;
																													obj_t
																														BgL_arg7089z00_9119;
																													BgL_arg7088z00_9118 =
																														BGl_labelszd2symzd2zzast_labelsz00
																														();
																													{	/* Ast/sexp.scm 650 */
																														obj_t
																															BgL_arg7090z00_9120;
																														obj_t
																															BgL_arg7091z00_9121;
																														{	/* Ast/sexp.scm 650 */
																															obj_t
																																BgL_arg7092z00_9122;
																															{	/* Ast/sexp.scm 650 */
																																obj_t
																																	BgL_arg7093z00_9123;
																																{	/* Ast/sexp.scm 650 */
																																	obj_t
																																		BgL_arg7094z00_9124;
																																	BgL_arg7094z00_9124
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BGl_normaliza7ezd2prognz75zztools_prognz00
																																		(BgL_bodyz00_9105),
																																		BNIL);
																																	BgL_arg7093z00_9123
																																		=
																																		MAKE_YOUNG_PAIR
																																		(BgL_argsz00_9104,
																																		BgL_arg7094z00_9124);
																																}
																																BgL_arg7092z00_9122
																																	=
																																	MAKE_YOUNG_PAIR
																																	(BgL_tfunz00_9116,
																																	BgL_arg7093z00_9123);
																															}
																															BgL_arg7090z00_9120
																																=
																																MAKE_YOUNG_PAIR
																																(BgL_arg7092z00_9122,
																																BNIL);
																														}
																														BgL_arg7091z00_9121
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_funz00_9115,
																															BNIL);
																														BgL_arg7089z00_9119
																															=
																															MAKE_YOUNG_PAIR
																															(BgL_arg7090z00_9120,
																															BgL_arg7091z00_9121);
																													}
																													BgL_arg7087z00_9117 =
																														MAKE_YOUNG_PAIR
																														(BgL_arg7088z00_9118,
																														BgL_arg7089z00_9119);
																												}
																												return
																													BGl_sexpzd2ze3nodez31zzast_sexpz00
																													(BgL_arg7087z00_9117,
																													BgL_stackz00_34,
																													BgL_locz00_9114,
																													BgL_sitez00_36);
																											}
																										}
																									}
																								}
																							}
																						}
																					else
																						{	/* Ast/sexp.scm 642 */
																						BgL_tagzd262416zd2_9107:
																							{	/* Ast/sexp.scm 656 */
																								BgL_nodez00_bglt
																									BgL_res7984z00_13655;
																								{	/* Ast/sexp.scm 726 */
																									obj_t BgL_arg7130z00_13651;
																									BgL_nodez00_bglt
																										BgL_arg7131z00_13652;
																									BgL_arg7130z00_13651 =
																										BGl_shapez00zztools_shapez00
																										(BGl_currentzd2functionzd2zztools_errorz00
																										());
																									BgL_arg7131z00_13652 =
																										BGl_sexpzd2ze3nodez31zzast_sexpz00
																										(CNST_TABLE_REF(((long) 4)),
																										BNIL, BgL_locz00_9071,
																										CNST_TABLE_REF(((long) 2)));
																									{	/* Ast/sexp.scm 725 */
																										obj_t BgL_list7132z00_13654;

																										BgL_list7132z00_13654 =
																											MAKE_YOUNG_PAIR(
																											((obj_t)
																												BgL_arg7131z00_13652),
																											BNIL);
																										BgL_res7984z00_13655 =
																											((BgL_nodez00_bglt)
																											BGl_userzd2errorzf2locationz20zztools_errorz00
																											(BgL_locz00_9071,
																												BgL_arg7130z00_13651,
																												BGl_string8069z00zzast_sexpz00,
																												BgL_expz00_33,
																												BgL_list7132z00_13654));
																								}}
																								return BgL_res7984z00_13655;
																							}
																						}
																				}
																			else
																				{	/* Ast/sexp.scm 642 */
																					goto BgL_tagzd262416zd2_9107;
																				}
																		}
																	else
																		{	/* Ast/sexp.scm 620 */
																			return
																				BGl_applicationzd2ze3nodez31zzast_appz00
																				(BgL_expz00_33, BgL_stackz00_34,
																				BgL_locz00_9071, BgL_sitez00_36);
																		}
																}
														}
												}
										}
								}
							}
						}
					}
				else
					{	/* Ast/sexp.scm 615 */
						return
							BGl_applicationzd2ze3nodez31zzast_appz00(BgL_expz00_33,
							BgL_stackz00_34, BgL_locz00_9071, BgL_sitez00_36);
					}
			}
		}

	}



/* sexp*->node */
	BGL_EXPORTED_DEF obj_t BGl_sexpza2zd2ze3nodez93zzast_sexpz00(obj_t
		BgL_expza2za2_37, obj_t BgL_stackz00_38, obj_t BgL_locz00_39,
		obj_t BgL_sitez00_40)
	{
		{	/* Ast/sexp.scm 664 */
			{
				obj_t BgL_expsz00_9131;
				obj_t BgL_resz00_9132;
				obj_t BgL_locz00_9133;

				BgL_expsz00_9131 = BgL_expza2za2_37;
				BgL_resz00_9132 = BNIL;
				BgL_locz00_9133 = BgL_locz00_39;
			BgL_zc3z04anonymousza37099ze3z87_9134:
				if (NULLP(BgL_expsz00_9131))
					{	/* Ast/sexp.scm 670 */
						BgL_nodez00_bglt BgL_res7988z00_13667;

						{	/* Ast/sexp.scm 726 */
							obj_t BgL_arg7130z00_13663;
							BgL_nodez00_bglt BgL_arg7131z00_13664;

							BgL_arg7130z00_13663 =
								BGl_shapez00zztools_shapez00
								(BGl_currentzd2functionzd2zztools_errorz00());
							BgL_arg7131z00_13664 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)),
								BNIL, BgL_locz00_9133, CNST_TABLE_REF(((long) 2)));
							{	/* Ast/sexp.scm 725 */
								obj_t BgL_list7132z00_13666;

								BgL_list7132z00_13666 =
									MAKE_YOUNG_PAIR(((obj_t) BgL_arg7131z00_13664), BNIL);
								BgL_res7988z00_13667 =
									((BgL_nodez00_bglt)
									BGl_userzd2errorzf2locationz20zztools_errorz00
									(BgL_locz00_9133, BgL_arg7130z00_13663,
										BGl_string8070z00zzast_sexpz00, BgL_expsz00_9131,
										BgL_list7132z00_13666));
						}}
						return ((obj_t) BgL_res7988z00_13667);
					}
				else
					{	/* Ast/sexp.scm 669 */
						if (NULLP(CDR(((obj_t) BgL_expsz00_9131))))
							{	/* Ast/sexp.scm 672 */
								obj_t BgL_locz00_9138;
								obj_t BgL_nsitez00_9139;

								{	/* Ast/sexp.scm 672 */
									obj_t BgL_arg7106z00_9143;
									obj_t BgL_arg7107z00_9144;

									BgL_arg7106z00_9143 = CAR(((obj_t) BgL_expsz00_9131));
									BgL_arg7107z00_9144 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9131, BgL_locz00_9133);
									BgL_locz00_9138 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7106z00_9143, BgL_arg7107z00_9144);
								}
								if ((BgL_sitez00_40 == CNST_TABLE_REF(((long) 33))))
									{	/* Ast/sexp.scm 674 */
										BgL_nsitez00_9139 = CNST_TABLE_REF(((long) 2));
									}
								else
									{	/* Ast/sexp.scm 674 */
										BgL_nsitez00_9139 = BgL_sitez00_40;
									}
								{	/* Ast/sexp.scm 675 */
									obj_t BgL_arg7103z00_9140;

									{	/* Ast/sexp.scm 675 */
										BgL_nodez00_bglt BgL_arg7104z00_9141;

										{	/* Ast/sexp.scm 675 */
											obj_t BgL_arg7105z00_9142;

											BgL_arg7105z00_9142 = CAR(((obj_t) BgL_expsz00_9131));
											BgL_arg7104z00_9141 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7105z00_9142,
												BgL_stackz00_38, BgL_locz00_9138, BgL_nsitez00_9139);
										}
										BgL_arg7103z00_9140 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7104z00_9141), BgL_resz00_9132);
									}
									return bgl_reverse_bang(BgL_arg7103z00_9140);
								}
							}
						else
							{	/* Ast/sexp.scm 677 */
								obj_t BgL_locz00_9146;

								{	/* Ast/sexp.scm 677 */
									obj_t BgL_arg7113z00_9151;
									obj_t BgL_arg7114z00_9152;

									BgL_arg7113z00_9151 = CAR(((obj_t) BgL_expsz00_9131));
									BgL_arg7114z00_9152 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_expsz00_9131, BgL_locz00_9133);
									BgL_locz00_9146 =
										BGl_findzd2locationzf2locz20zztools_locationz00
										(BgL_arg7113z00_9151, BgL_arg7114z00_9152);
								}
								{	/* Ast/sexp.scm 679 */
									obj_t BgL_arg7109z00_9147;
									obj_t BgL_arg7110z00_9148;

									BgL_arg7109z00_9147 = CDR(((obj_t) BgL_expsz00_9131));
									{	/* Ast/sexp.scm 680 */
										BgL_nodez00_bglt BgL_arg7111z00_9149;

										{	/* Ast/sexp.scm 680 */
											obj_t BgL_arg7112z00_9150;

											BgL_arg7112z00_9150 = CAR(((obj_t) BgL_expsz00_9131));
											BgL_arg7111z00_9149 =
												BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7112z00_9150,
												BgL_stackz00_38, BgL_locz00_9146,
												CNST_TABLE_REF(((long) 2)));
										}
										BgL_arg7110z00_9148 =
											MAKE_YOUNG_PAIR(
											((obj_t) BgL_arg7111z00_9149), BgL_resz00_9132);
									}
									{
										obj_t BgL_locz00_29588;
										obj_t BgL_resz00_29587;
										obj_t BgL_expsz00_29586;

										BgL_expsz00_29586 = BgL_arg7109z00_9147;
										BgL_resz00_29587 = BgL_arg7110z00_9148;
										BgL_locz00_29588 = BgL_locz00_9146;
										BgL_locz00_9133 = BgL_locz00_29588;
										BgL_resz00_9132 = BgL_resz00_29587;
										BgL_expsz00_9131 = BgL_expsz00_29586;
										goto BgL_zc3z04anonymousza37099ze3z87_9134;
									}
								}
							}
					}
			}
		}

	}



/* &sexp*->node */
	obj_t BGl_z62sexpza2zd2ze3nodezf1zzast_sexpz00(obj_t BgL_envz00_13856,
		obj_t BgL_expza2za2_13857, obj_t BgL_stackz00_13858, obj_t BgL_locz00_13859,
		obj_t BgL_sitez00_13860)
	{
		{	/* Ast/sexp.scm 664 */
			return
				BGl_sexpza2zd2ze3nodez93zzast_sexpz00(BgL_expza2za2_13857,
				BgL_stackz00_13858, BgL_locz00_13859, BgL_sitez00_13860);
		}

	}



/* find-local */
	BGL_EXPORTED_DEF obj_t BGl_findzd2localzd2zzast_sexpz00(obj_t BgL_namez00_41,
		obj_t BgL_stackz00_42)
	{
		{	/* Ast/sexp.scm 693 */
			{	/* Ast/sexp.scm 694 */
				bool_t BgL_test10579z00_29590;

				if ((BgL_namez00_41 == BGl_za2cachezd2nameza2zd2zzast_sexpz00))
					{	/* Ast/sexp.scm 694 */
						BgL_test10579z00_29590 =
							(BgL_stackz00_42 == BGl_za2cachezd2stackza2zd2zzast_sexpz00);
					}
				else
					{	/* Ast/sexp.scm 694 */
						BgL_test10579z00_29590 = ((bool_t) 0);
					}
				if (BgL_test10579z00_29590)
					{	/* Ast/sexp.scm 694 */
						return BGl_za2cachezd2resza2zd2zzast_sexpz00;
					}
				else
					{	/* Ast/sexp.scm 694 */
						BGl_za2cachezd2nameza2zd2zzast_sexpz00 = BgL_namez00_41;
						BGl_za2cachezd2stackza2zd2zzast_sexpz00 = BgL_stackz00_42;
						{
							obj_t BgL_stackz00_9158;

							BgL_stackz00_9158 = BgL_stackz00_42;
						BgL_zc3z04anonymousza37118ze3z87_9159:
							if (NULLP(BgL_stackz00_9158))
								{	/* Ast/sexp.scm 701 */
									BGl_za2cachezd2resza2zd2zzast_sexpz00 = BFALSE;
									return BFALSE;
								}
							else
								{	/* Ast/sexp.scm 701 */
									if (
										((((BgL_variablez00_bglt) COBJECT(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt)
																CAR(
																	((obj_t) BgL_stackz00_9158))))))->
												BgL_idz00) == BgL_namez00_41))
										{	/* Ast/sexp.scm 704 */
											BGl_za2cachezd2resza2zd2zzast_sexpz00 =
												CAR(((obj_t) BgL_stackz00_9158));
											return CAR(((obj_t) BgL_stackz00_9158));
										}
									else
										{	/* Ast/sexp.scm 708 */
											obj_t BgL_arg7123z00_9164;

											BgL_arg7123z00_9164 = CDR(((obj_t) BgL_stackz00_9158));
											{
												obj_t BgL_stackz00_29609;

												BgL_stackz00_29609 = BgL_arg7123z00_9164;
												BgL_stackz00_9158 = BgL_stackz00_29609;
												goto BgL_zc3z04anonymousza37118ze3z87_9159;
											}
										}
								}
						}
					}
			}
		}

	}



/* &find-local */
	obj_t BGl_z62findzd2localzb0zzast_sexpz00(obj_t BgL_envz00_13861,
		obj_t BgL_namez00_13862, obj_t BgL_stackz00_13863)
	{
		{	/* Ast/sexp.scm 693 */
			return
				BGl_findzd2localzd2zzast_sexpz00(BgL_namez00_13862, BgL_stackz00_13863);
		}

	}



/* use-variable! */
	BGL_EXPORTED_DEF obj_t
		BGl_usezd2variablez12zc0zzast_sexpz00(BgL_variablez00_bglt BgL_varz00_43,
		obj_t BgL_locz00_44, obj_t BgL_sitez00_45)
	{
		{	/* Ast/sexp.scm 713 */
			if ((BgL_sitez00_45 == CNST_TABLE_REF(((long) 7))))
				{	/* Ast/sexp.scm 716 */
					obj_t BgL_vz00_13682;

					BgL_vz00_13682 = CNST_TABLE_REF(((long) 36));
					((((BgL_variablez00_bglt) COBJECT(BgL_varz00_43))->BgL_accessz00) =
						((obj_t) BgL_vz00_13682), BUNSPEC);
				}
			else
				{	/* Ast/sexp.scm 715 */
					BFALSE;
				}
			{	/* Ast/sexp.scm 717 */
				BgL_valuez00_bglt BgL_valz00_9170;

				BgL_valz00_9170 =
					(((BgL_variablez00_bglt) COBJECT(BgL_varz00_43))->BgL_valuez00);
				{	/* Ast/sexp.scm 718 */
					bool_t BgL_test10584z00_29617;

					if ((BgL_sitez00_45 == CNST_TABLE_REF(((long) 7))))
						{	/* Ast/sexp.scm 718 */
							bool_t BgL_res7991z00_13684;

							BgL_res7991z00_13684 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_valz00_9170), BGl_funz00zzast_varz00);
							BgL_test10584z00_29617 = BgL_res7991z00_13684;
						}
					else
						{	/* Ast/sexp.scm 718 */
							BgL_test10584z00_29617 = ((bool_t) 0);
						}
					if (BgL_test10584z00_29617)
						{	/* Ast/sexp.scm 719 */
							obj_t BgL_arg7129z00_9173;

							BgL_arg7129z00_9173 =
								BGl_shapez00zztools_shapez00(((obj_t) BgL_varz00_43));
							{	/* Ast/sexp.scm 719 */
								BgL_nodez00_bglt BgL_res7992z00_13690;

								{	/* Ast/sexp.scm 726 */
									obj_t BgL_arg7130z00_13686;
									BgL_nodez00_bglt BgL_arg7131z00_13687;

									BgL_arg7130z00_13686 =
										BGl_shapez00zztools_shapez00
										(BGl_currentzd2functionzd2zztools_errorz00());
									BgL_arg7131z00_13687 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long)
												4)), BNIL, BgL_locz00_44, CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 725 */
										obj_t BgL_list7132z00_13689;

										BgL_list7132z00_13689 =
											MAKE_YOUNG_PAIR(((obj_t) BgL_arg7131z00_13687), BNIL);
										BgL_res7992z00_13690 =
											((BgL_nodez00_bglt)
											BGl_userzd2errorzf2locationz20zztools_errorz00
											(BgL_locz00_44, BgL_arg7130z00_13686,
												BGl_string8071z00zzast_sexpz00, BgL_arg7129z00_9173,
												BgL_list7132z00_13689));
								}}
								return ((obj_t) BgL_res7992z00_13690);
							}
						}
					else
						{	/* Ast/sexp.scm 718 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &use-variable! */
	obj_t BGl_z62usezd2variablez12za2zzast_sexpz00(obj_t BgL_envz00_13864,
		obj_t BgL_varz00_13865, obj_t BgL_locz00_13866, obj_t BgL_sitez00_13867)
	{
		{	/* Ast/sexp.scm 713 */
			return
				BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_varz00_13865), BgL_locz00_13866,
				BgL_sitez00_13867);
		}

	}



/* error-sexp->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(obj_t BgL_msgz00_46,
		obj_t BgL_expz00_47, obj_t BgL_locz00_48)
	{
		{	/* Ast/sexp.scm 724 */
			{	/* Ast/sexp.scm 726 */
				obj_t BgL_arg7130z00_9175;
				BgL_nodez00_bglt BgL_arg7131z00_9176;

				BgL_arg7130z00_9175 =
					BGl_shapez00zztools_shapez00(BGl_currentzd2functionzd2zztools_errorz00
					());
				BgL_arg7131z00_9176 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 4)), BNIL,
					BgL_locz00_48, CNST_TABLE_REF(((long) 2)));
				{	/* Ast/sexp.scm 725 */
					obj_t BgL_list7132z00_9177;

					BgL_list7132z00_9177 =
						MAKE_YOUNG_PAIR(((obj_t) BgL_arg7131z00_9176), BNIL);
					return
						((BgL_nodez00_bglt)
						BGl_userzd2errorzf2locationz20zztools_errorz00(BgL_locz00_48,
							BgL_arg7130z00_9175, BgL_msgz00_46, BgL_expz00_47,
							BgL_list7132z00_9177));
				}
			}
		}

	}



/* &error-sexp->node */
	BgL_nodez00_bglt BGl_z62errorzd2sexpzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13868, obj_t BgL_msgz00_13869, obj_t BgL_expz00_13870,
		obj_t BgL_locz00_13871)
	{
		{	/* Ast/sexp.scm 724 */
			return
				BGl_errorzd2sexpzd2ze3nodeze3zzast_sexpz00(BgL_msgz00_13869,
				BgL_expz00_13870, BgL_locz00_13871);
		}

	}



/* define-primop-ref->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_49, BgL_nodez00_bglt BgL_refz00_50)
	{
		{	/* Ast/sexp.scm 734 */
			{	/* Ast/sexp.scm 735 */
				BgL_nodez00_bglt BgL_funz00_9179;

				BgL_funz00_9179 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 37)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 736 */
					bool_t BgL_test10586z00_29650;

					{	/* Ast/sexp.scm 736 */
						bool_t BgL_res7993z00_13691;

						BgL_res7993z00_13691 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9179), BGl_varz00zzast_nodez00);
						BgL_test10586z00_29650 = BgL_res7993z00_13691;
					}
					if (BgL_test10586z00_29650)
						{	/* Ast/sexp.scm 737 */
							BgL_appz00_bglt BgL_new1151z00_9181;

							{	/* Ast/sexp.scm 737 */
								BgL_appz00_bglt BgL_new1150z00_9188;

								BgL_new1150z00_9188 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 737 */
									long BgL_arg7141z00_9189;

									{	/* Ast/sexp.scm 737 */
										long BgL_res7994z00_13693;

										BgL_res7994z00_13693 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg7141z00_9189 = BgL_res7994z00_13693;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1150z00_9188),
										BgL_arg7141z00_9189);
								}
								{	/* Ast/sexp.scm 737 */
									BgL_objectz00_bglt BgL_tmpz00_29657;

									BgL_tmpz00_29657 = ((BgL_objectz00_bglt) BgL_new1150z00_9188);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29657, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1150z00_9188);
								BgL_new1151z00_9181 = BgL_new1150z00_9188;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1151z00_9181)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1151z00_9181)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1151z00_9181)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1151z00_9181)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1151z00_9181))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9179)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29673;

								{	/* Ast/sexp.scm 740 */
									BgL_nodez00_bglt BgL_arg7135z00_9182;

									{	/* Ast/sexp.scm 740 */
										obj_t BgL_arg7138z00_9185;

										{	/* Ast/sexp.scm 740 */
											obj_t BgL_arg7139z00_9186;

											{	/* Ast/sexp.scm 740 */
												obj_t BgL_arg7140z00_9187;

												BgL_arg7140z00_9187 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_globalz00_49)))->
													BgL_idz00);
												BgL_arg7139z00_9186 =
													MAKE_YOUNG_PAIR(BgL_arg7140z00_9187, BNIL);
											}
											BgL_arg7138z00_9185 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
												BgL_arg7139z00_9186);
										}
										BgL_arg7135z00_9182 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7138z00_9185,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									{	/* Ast/sexp.scm 740 */
										obj_t BgL_list7136z00_9183;

										{	/* Ast/sexp.scm 740 */
											obj_t BgL_arg7137z00_9184;

											BgL_arg7137z00_9184 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_refz00_50), BNIL);
											BgL_list7136z00_9183 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg7135z00_9182), BgL_arg7137z00_9184);
										}
										BgL_auxz00_29673 = BgL_list7136z00_9183;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1151z00_9181))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29673), BUNSPEC);
							}
							((((BgL_appz00_bglt) COBJECT(BgL_new1151z00_9181))->
									BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
							return ((BgL_nodez00_bglt) BgL_new1151z00_9181);
						}
					else
						{	/* Ast/sexp.scm 736 */
							return BgL_funz00_9179;
						}
				}
			}
		}

	}



/* &define-primop-ref->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2refzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13872, obj_t BgL_globalz00_13873, obj_t BgL_refz00_13874)
	{
		{	/* Ast/sexp.scm 734 */
			return
				BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13873),
				((BgL_nodez00_bglt) BgL_refz00_13874));
		}

	}



/* define-primop-ref/src->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_51, BgL_nodez00_bglt BgL_refz00_52, obj_t BgL_srcz00_53)
	{
		{	/* Ast/sexp.scm 746 */
			{	/* Ast/sexp.scm 747 */
				bool_t BgL_test10587z00_29691;

				{	/* Ast/sexp.scm 747 */
					bool_t BgL_res7996z00_13699;

					BgL_res7996z00_13699 = EPAIRP(BgL_srcz00_53);
					BgL_test10587z00_29691 = BgL_res7996z00_13699;
				}
				if (BgL_test10587z00_29691)
					{
						obj_t BgL_fnamez00_9191;
						obj_t BgL_locz00_9192;

						{	/* Ast/sexp.scm 749 */
							obj_t BgL_ezd262432zd2_9195;

							BgL_ezd262432zd2_9195 = CER(((obj_t) BgL_srcz00_53));
							if (PAIRP(BgL_ezd262432zd2_9195))
								{	/* Ast/sexp.scm 749 */
									obj_t BgL_cdrzd262438zd2_9197;

									BgL_cdrzd262438zd2_9197 = CDR(BgL_ezd262432zd2_9195);
									if (
										(CAR(BgL_ezd262432zd2_9195) == CNST_TABLE_REF(((long) 39))))
										{	/* Ast/sexp.scm 749 */
											if (PAIRP(BgL_cdrzd262438zd2_9197))
												{	/* Ast/sexp.scm 749 */
													obj_t BgL_cdrzd262442zd2_9201;

													BgL_cdrzd262442zd2_9201 =
														CDR(BgL_cdrzd262438zd2_9197);
													if (PAIRP(BgL_cdrzd262442zd2_9201))
														{	/* Ast/sexp.scm 749 */
															if (NULLP(CDR(BgL_cdrzd262442zd2_9201)))
																{	/* Ast/sexp.scm 749 */
																	BgL_fnamez00_9191 =
																		CAR(BgL_cdrzd262438zd2_9197);
																	BgL_locz00_9192 =
																		CAR(BgL_cdrzd262442zd2_9201);
																	{	/* Ast/sexp.scm 751 */
																		BgL_nodez00_bglt BgL_funz00_9209;

																		BgL_funz00_9209 =
																			BGl_sexpzd2ze3nodez31zzast_sexpz00
																			(CNST_TABLE_REF(((long) 38)), BNIL,
																			BFALSE, CNST_TABLE_REF(((long) 33)));
																		{	/* Ast/sexp.scm 752 */
																			bool_t BgL_test10593z00_29713;

																			{	/* Ast/sexp.scm 752 */
																				bool_t BgL_res7997z00_13700;

																				BgL_res7997z00_13700 =
																					BGl_isazf3zf3zz__objectz00(
																					((obj_t) BgL_funz00_9209),
																					BGl_varz00zzast_nodez00);
																				BgL_test10593z00_29713 =
																					BgL_res7997z00_13700;
																			}
																			if (BgL_test10593z00_29713)
																				{	/* Ast/sexp.scm 753 */
																					BgL_appz00_bglt BgL_new1153z00_9211;

																					{	/* Ast/sexp.scm 753 */
																						BgL_appz00_bglt BgL_new1152z00_9222;

																						BgL_new1152z00_9222 =
																							((BgL_appz00_bglt)
																							BOBJECT(GC_MALLOC(sizeof(struct
																										BgL_appz00_bgl))));
																						{	/* Ast/sexp.scm 753 */
																							long BgL_arg7165z00_9223;

																							{	/* Ast/sexp.scm 753 */
																								long BgL_res7998z00_13702;

																								BgL_res7998z00_13702 =
																									BGL_CLASS_INDEX
																									(BGl_appz00zzast_nodez00);
																								BgL_arg7165z00_9223 =
																									BgL_res7998z00_13702;
																							}
																							BGL_OBJECT_CLASS_NUM_SET(
																								((BgL_objectz00_bglt)
																									BgL_new1152z00_9222),
																								BgL_arg7165z00_9223);
																						}
																						{	/* Ast/sexp.scm 753 */
																							BgL_objectz00_bglt
																								BgL_tmpz00_29720;
																							BgL_tmpz00_29720 =
																								((BgL_objectz00_bglt)
																								BgL_new1152z00_9222);
																							BGL_OBJECT_WIDENING_SET
																								(BgL_tmpz00_29720, BFALSE);
																						}
																						((BgL_objectz00_bglt)
																							BgL_new1152z00_9222);
																						BgL_new1153z00_9211 =
																							BgL_new1152z00_9222;
																					}
																					((((BgL_nodez00_bglt) COBJECT(
																									((BgL_nodez00_bglt)
																										BgL_new1153z00_9211)))->
																							BgL_locz00) =
																						((obj_t) BFALSE), BUNSPEC);
																					((((BgL_nodez00_bglt)
																								COBJECT(((BgL_nodez00_bglt)
																										BgL_new1153z00_9211)))->
																							BgL_typez00) =
																						((BgL_typez00_bglt) (
																								(BgL_typez00_bglt)
																								BGl_za2_za2z00zztype_cachez00)),
																						BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								COBJECT((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1153z00_9211)))->
																							BgL_sidezd2effectzd2) =
																						((obj_t) BUNSPEC), BUNSPEC);
																					((((BgL_nodezf2effectzf2_bglt)
																								COBJECT((
																										(BgL_nodezf2effectzf2_bglt)
																										BgL_new1153z00_9211)))->
																							BgL_keyz00) =
																						((obj_t) BINT(((long) -1))),
																						BUNSPEC);
																					((((BgL_appz00_bglt)
																								COBJECT(BgL_new1153z00_9211))->
																							BgL_funz00) =
																						((BgL_varz00_bglt) (
																								(BgL_varz00_bglt)
																								BgL_funz00_9209)), BUNSPEC);
																					{
																						obj_t BgL_auxz00_29736;

																						{	/* Ast/sexp.scm 757 */
																							BgL_nodez00_bglt
																								BgL_arg7155z00_9212;
																							BgL_nodez00_bglt
																								BgL_arg7156z00_9213;
																							BgL_nodez00_bglt
																								BgL_arg7157z00_9214;
																							{	/* Ast/sexp.scm 757 */
																								obj_t BgL_arg7162z00_9219;

																								{	/* Ast/sexp.scm 757 */
																									obj_t BgL_arg7163z00_9220;

																									{	/* Ast/sexp.scm 757 */
																										obj_t BgL_arg7164z00_9221;

																										BgL_arg7164z00_9221 =
																											(((BgL_variablez00_bglt)
																												COBJECT((
																														(BgL_variablez00_bglt)
																														BgL_globalz00_51)))->
																											BgL_idz00);
																										BgL_arg7163z00_9220 =
																											MAKE_YOUNG_PAIR
																											(BgL_arg7164z00_9221,
																											BNIL);
																									}
																									BgL_arg7162z00_9219 =
																										MAKE_YOUNG_PAIR
																										(CNST_TABLE_REF(((long)
																												12)),
																										BgL_arg7163z00_9220);
																								}
																								BgL_arg7155z00_9212 =
																									BGl_sexpzd2ze3nodez31zzast_sexpz00
																									(BgL_arg7162z00_9219, BNIL,
																									BFALSE,
																									CNST_TABLE_REF(((long) 2)));
																							}
																							BgL_arg7156z00_9213 =
																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																								(BgL_fnamez00_9191, BNIL,
																								BFALSE,
																								CNST_TABLE_REF(((long) 2)));
																							BgL_arg7157z00_9214 =
																								BGl_sexpzd2ze3nodez31zzast_sexpz00
																								(BgL_locz00_9192, BNIL, BFALSE,
																								CNST_TABLE_REF(((long) 2)));
																							{	/* Ast/sexp.scm 756 */
																								obj_t BgL_list7158z00_9215;

																								{	/* Ast/sexp.scm 756 */
																									obj_t BgL_arg7159z00_9216;

																									{	/* Ast/sexp.scm 756 */
																										obj_t BgL_arg7160z00_9217;

																										{	/* Ast/sexp.scm 756 */
																											obj_t BgL_arg7161z00_9218;

																											BgL_arg7161z00_9218 =
																												MAKE_YOUNG_PAIR(
																												((obj_t)
																													BgL_arg7157z00_9214),
																												BNIL);
																											BgL_arg7160z00_9217 =
																												MAKE_YOUNG_PAIR(((obj_t)
																													BgL_arg7156z00_9213),
																												BgL_arg7161z00_9218);
																										}
																										BgL_arg7159z00_9216 =
																											MAKE_YOUNG_PAIR(
																											((obj_t) BgL_refz00_52),
																											BgL_arg7160z00_9217);
																									}
																									BgL_list7158z00_9215 =
																										MAKE_YOUNG_PAIR(
																										((obj_t)
																											BgL_arg7155z00_9212),
																										BgL_arg7159z00_9216);
																								}
																								BgL_auxz00_29736 =
																									BgL_list7158z00_9215;
																						}}
																						((((BgL_appz00_bglt)
																									COBJECT
																									(BgL_new1153z00_9211))->
																								BgL_argsz00) =
																							((obj_t) BgL_auxz00_29736),
																							BUNSPEC);
																					}
																					((((BgL_appz00_bglt)
																								COBJECT(BgL_new1153z00_9211))->
																							BgL_stackablez00) =
																						((obj_t) BFALSE), BUNSPEC);
																					return ((BgL_nodez00_bglt)
																						BgL_new1153z00_9211);
																				}
																			else
																				{	/* Ast/sexp.scm 752 */
																					return BgL_funz00_9209;
																				}
																		}
																	}
																}
															else
																{	/* Ast/sexp.scm 749 */
																	return
																		BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
																		(BgL_globalz00_51, BgL_refz00_52);
																}
														}
													else
														{	/* Ast/sexp.scm 749 */
															return
																BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
																(BgL_globalz00_51, BgL_refz00_52);
														}
												}
											else
												{	/* Ast/sexp.scm 749 */
													return
														BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
														(BgL_globalz00_51, BgL_refz00_52);
												}
										}
									else
										{	/* Ast/sexp.scm 749 */
											return
												BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
												(BgL_globalz00_51, BgL_refz00_52);
										}
								}
							else
								{	/* Ast/sexp.scm 749 */
									return
										BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
										(BgL_globalz00_51, BgL_refz00_52);
								}
						}
					}
				else
					{	/* Ast/sexp.scm 747 */
						return
							BGl_definezd2primopzd2refzd2ze3nodez31zzast_sexpz00
							(BgL_globalz00_51, BgL_refz00_52);
					}
			}
		}

	}



/* &define-primop-ref/src->node */
	BgL_nodez00_bglt
		BGl_z62definezd2primopzd2refzf2srczd2ze3nodeza1zzast_sexpz00(obj_t
		BgL_envz00_13875, obj_t BgL_globalz00_13876, obj_t BgL_refz00_13877,
		obj_t BgL_srcz00_13878)
	{
		{	/* Ast/sexp.scm 746 */
			return
				BGl_definezd2primopzd2refzf2srczd2ze3nodezc3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13876),
				((BgL_nodez00_bglt) BgL_refz00_13877), BgL_srcz00_13878);
		}

	}



/* define-primop->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(BgL_globalz00_bglt
		BgL_globalz00_54)
	{
		{	/* Ast/sexp.scm 768 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_54), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 770 */
				BgL_nodez00_bglt BgL_funz00_9224;

				BgL_funz00_9224 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 40)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 771 */
					bool_t BgL_test10594z00_29776;

					{	/* Ast/sexp.scm 771 */
						bool_t BgL_res8004z00_13719;

						BgL_res8004z00_13719 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9224), BGl_varz00zzast_nodez00);
						BgL_test10594z00_29776 = BgL_res8004z00_13719;
					}
					if (BgL_test10594z00_29776)
						{	/* Ast/sexp.scm 772 */
							BgL_appz00_bglt BgL_new1155z00_9226;

							{	/* Ast/sexp.scm 772 */
								BgL_appz00_bglt BgL_new1154z00_9234;

								BgL_new1154z00_9234 =
									((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
												BgL_appz00_bgl))));
								{	/* Ast/sexp.scm 772 */
									long BgL_arg7174z00_9235;

									{	/* Ast/sexp.scm 772 */
										long BgL_res8005z00_13721;

										BgL_res8005z00_13721 =
											BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
										BgL_arg7174z00_9235 = BgL_res8005z00_13721;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1154z00_9234),
										BgL_arg7174z00_9235);
								}
								{	/* Ast/sexp.scm 772 */
									BgL_objectz00_bglt BgL_tmpz00_29783;

									BgL_tmpz00_29783 = ((BgL_objectz00_bglt) BgL_new1154z00_9234);
									BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29783, BFALSE);
								}
								((BgL_objectz00_bglt) BgL_new1154z00_9234);
								BgL_new1155z00_9226 = BgL_new1154z00_9234;
							}
							((((BgL_nodez00_bglt) COBJECT(
											((BgL_nodez00_bglt) BgL_new1155z00_9226)))->BgL_locz00) =
								((obj_t) BFALSE), BUNSPEC);
							((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
												BgL_new1155z00_9226)))->BgL_typez00) =
								((BgL_typez00_bglt) ((BgL_typez00_bglt)
										BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1155z00_9226)))->BgL_sidezd2effectzd2) =
								((obj_t) BUNSPEC), BUNSPEC);
							((((BgL_nodezf2effectzf2_bglt)
										COBJECT(((BgL_nodezf2effectzf2_bglt)
												BgL_new1155z00_9226)))->BgL_keyz00) =
								((obj_t) BINT(((long) -1))), BUNSPEC);
							((((BgL_appz00_bglt) COBJECT(BgL_new1155z00_9226))->BgL_funz00) =
								((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9224)),
								BUNSPEC);
							{
								obj_t BgL_auxz00_29799;

								{	/* Ast/sexp.scm 775 */
									BgL_nodez00_bglt BgL_arg7167z00_9227;
									BgL_nodez00_bglt BgL_arg7168z00_9228;

									{	/* Ast/sexp.scm 775 */
										obj_t BgL_arg7171z00_9231;

										{	/* Ast/sexp.scm 775 */
											obj_t BgL_arg7172z00_9232;

											{	/* Ast/sexp.scm 775 */
												obj_t BgL_arg7173z00_9233;

												BgL_arg7173z00_9233 =
													(((BgL_variablez00_bglt) COBJECT(
															((BgL_variablez00_bglt) BgL_globalz00_54)))->
													BgL_idz00);
												BgL_arg7172z00_9232 =
													MAKE_YOUNG_PAIR(BgL_arg7173z00_9233, BNIL);
											}
											BgL_arg7171z00_9231 =
												MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 12)),
												BgL_arg7172z00_9232);
										}
										BgL_arg7167z00_9227 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7171z00_9231,
											BNIL, BFALSE, CNST_TABLE_REF(((long) 2)));
									}
									BgL_arg7168z00_9228 =
										BGl_sexpzd2ze3nodez31zzast_sexpz00(
										((obj_t) BgL_globalz00_54), BNIL, BFALSE,
										CNST_TABLE_REF(((long) 2)));
									{	/* Ast/sexp.scm 775 */
										obj_t BgL_list7169z00_9229;

										{	/* Ast/sexp.scm 775 */
											obj_t BgL_arg7170z00_9230;

											BgL_arg7170z00_9230 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_arg7168z00_9228), BNIL);
											BgL_list7169z00_9229 =
												MAKE_YOUNG_PAIR(
												((obj_t) BgL_arg7167z00_9227), BgL_arg7170z00_9230);
										}
										BgL_auxz00_29799 = BgL_list7169z00_9229;
								}}
								((((BgL_appz00_bglt) COBJECT(BgL_new1155z00_9226))->
										BgL_argsz00) = ((obj_t) BgL_auxz00_29799), BUNSPEC);
							}
							((((BgL_appz00_bglt) COBJECT(BgL_new1155z00_9226))->
									BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
							return ((BgL_nodez00_bglt) BgL_new1155z00_9226);
						}
					else
						{	/* Ast/sexp.scm 771 */
							return BgL_funz00_9224;
						}
				}
			}
		}

	}



/* &define-primop->node */
	BgL_nodez00_bglt BGl_z62definezd2primopzd2ze3nodez81zzast_sexpz00(obj_t
		BgL_envz00_13879, obj_t BgL_globalz00_13880)
	{
		{	/* Ast/sexp.scm 768 */
			return
				BGl_definezd2primopzd2ze3nodeze3zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13880));
		}

	}



/* location->node */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_locationzd2ze3nodez31zzast_sexpz00(BgL_globalz00_bglt BgL_globalz00_55)
	{
		{	/* Ast/sexp.scm 782 */
			BGl_usezd2variablez12zc0zzast_sexpz00(
				((BgL_variablez00_bglt) BgL_globalz00_55), BFALSE,
				CNST_TABLE_REF(((long) 2)));
			{	/* Ast/sexp.scm 784 */
				BgL_nodez00_bglt BgL_funz00_9236;

				BgL_funz00_9236 =
					BGl_sexpzd2ze3nodez31zzast_sexpz00(CNST_TABLE_REF(((long) 41)), BNIL,
					BFALSE, CNST_TABLE_REF(((long) 33)));
				{	/* Ast/sexp.scm 785 */
					bool_t BgL_test10595z00_29825;

					{	/* Ast/sexp.scm 785 */
						bool_t BgL_res8007z00_13727;

						BgL_res8007z00_13727 =
							BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_9236), BGl_varz00zzast_nodez00);
						BgL_test10595z00_29825 = BgL_res8007z00_13727;
					}
					if (BgL_test10595z00_29825)
						{	/* Ast/sexp.scm 786 */
							obj_t BgL_exprz00_9238;

							{	/* Ast/sexp.scm 786 */
								bool_t BgL_test10596z00_29828;

								{	/* Ast/sexp.scm 786 */
									obj_t BgL_arg7183z00_9248;

									BgL_arg7183z00_9248 =
										BGl_thezd2backendzd2zzbackend_backendz00();
									BgL_test10596z00_29828 =
										(((BgL_backendz00_bglt) COBJECT(
												((BgL_backendz00_bglt) BgL_arg7183z00_9248)))->
										BgL_pragmazd2supportzd2);
								}
								if (BgL_test10596z00_29828)
									{	/* Ast/sexp.scm 787 */
										obj_t BgL_arg7181z00_9246;

										{	/* Ast/sexp.scm 787 */
											obj_t BgL_arg7182z00_9247;

											BgL_arg7182z00_9247 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_globalz00_55), BNIL);
											BgL_arg7181z00_9246 =
												MAKE_YOUNG_PAIR(BGl_string8072z00zzast_sexpz00,
												BgL_arg7182z00_9247);
										}
										BgL_exprz00_9238 =
											MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 42)),
											BgL_arg7181z00_9246);
									}
								else
									{	/* Ast/sexp.scm 786 */
										BgL_exprz00_9238 = ((obj_t) BgL_globalz00_55);
									}
							}
							{	/* Ast/sexp.scm 789 */
								BgL_appz00_bglt BgL_new1158z00_9239;

								{	/* Ast/sexp.scm 789 */
									BgL_appz00_bglt BgL_new1157z00_9242;

									BgL_new1157z00_9242 =
										((BgL_appz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
													BgL_appz00_bgl))));
									{	/* Ast/sexp.scm 789 */
										long BgL_arg7178z00_9243;

										{	/* Ast/sexp.scm 789 */
											long BgL_res8009z00_13732;

											BgL_res8009z00_13732 =
												BGL_CLASS_INDEX(BGl_appz00zzast_nodez00);
											BgL_arg7178z00_9243 = BgL_res8009z00_13732;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1157z00_9242),
											BgL_arg7178z00_9243);
									}
									{	/* Ast/sexp.scm 789 */
										BgL_objectz00_bglt BgL_tmpz00_29842;

										BgL_tmpz00_29842 =
											((BgL_objectz00_bglt) BgL_new1157z00_9242);
										BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29842, BFALSE);
									}
									((BgL_objectz00_bglt) BgL_new1157z00_9242);
									BgL_new1158z00_9239 = BgL_new1157z00_9242;
								}
								((((BgL_nodez00_bglt) COBJECT(
												((BgL_nodez00_bglt) BgL_new1158z00_9239)))->
										BgL_locz00) = ((obj_t) BFALSE), BUNSPEC);
								((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
													BgL_new1158z00_9239)))->BgL_typez00) =
									((BgL_typez00_bglt)
										BGl_strictzd2nodezd2typez00zzast_nodez00(((BgL_typez00_bglt)
												BGl_za2_za2z00zztype_cachez00),
											((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00))),
									BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt)
													BgL_new1158z00_9239)))->BgL_sidezd2effectzd2) =
									((obj_t) BUNSPEC), BUNSPEC);
								((((BgL_nodezf2effectzf2_bglt)
											COBJECT(((BgL_nodezf2effectzf2_bglt)
													BgL_new1158z00_9239)))->BgL_keyz00) =
									((obj_t) BINT(((long) -1))), BUNSPEC);
								((((BgL_appz00_bglt) COBJECT(BgL_new1158z00_9239))->
										BgL_funz00) =
									((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_funz00_9236)),
									BUNSPEC);
								{
									obj_t BgL_auxz00_29860;

									{	/* Ast/sexp.scm 792 */
										BgL_nodez00_bglt BgL_arg7176z00_9240;

										BgL_arg7176z00_9240 =
											BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_exprz00_9238, BNIL,
											BFALSE, CNST_TABLE_REF(((long) 2)));
										{	/* Ast/sexp.scm 792 */
											obj_t BgL_list7177z00_9241;

											BgL_list7177z00_9241 =
												MAKE_YOUNG_PAIR(((obj_t) BgL_arg7176z00_9240), BNIL);
											BgL_auxz00_29860 = BgL_list7177z00_9241;
									}}
									((((BgL_appz00_bglt) COBJECT(BgL_new1158z00_9239))->
											BgL_argsz00) = ((obj_t) BgL_auxz00_29860), BUNSPEC);
								}
								((((BgL_appz00_bglt) COBJECT(BgL_new1158z00_9239))->
										BgL_stackablez00) = ((obj_t) BFALSE), BUNSPEC);
								return ((BgL_nodez00_bglt) BgL_new1158z00_9239);
							}
						}
					else
						{	/* Ast/sexp.scm 785 */
							return BgL_funz00_9236;
						}
				}
			}
		}

	}



/* &location->node */
	BgL_nodez00_bglt BGl_z62locationzd2ze3nodez53zzast_sexpz00(obj_t
		BgL_envz00_13881, obj_t BgL_globalz00_13882)
	{
		{	/* Ast/sexp.scm 782 */
			return
				BGl_locationzd2ze3nodez31zzast_sexpz00(
				((BgL_globalz00_bglt) BgL_globalz00_13882));
		}

	}



/* make-anonymous-name */
	BGL_EXPORTED_DEF obj_t BGl_makezd2anonymouszd2namez00zzast_sexpz00(obj_t
		BgL_locz00_56, obj_t BgL_prefz00_57)
	{
		{	/* Ast/sexp.scm 798 */
			{	/* Ast/sexp.scm 799 */
				obj_t BgL_prefz00_9249;

				{	/* Ast/sexp.scm 799 */
					bool_t BgL_test10597z00_29870;

					if (PAIRP(BgL_prefz00_57))
						{	/* Ast/sexp.scm 799 */
							obj_t BgL_tmpz00_29873;

							BgL_tmpz00_29873 = CAR(BgL_prefz00_57);
							BgL_test10597z00_29870 = STRINGP(BgL_tmpz00_29873);
						}
					else
						{	/* Ast/sexp.scm 799 */
							BgL_test10597z00_29870 = ((bool_t) 0);
						}
					if (BgL_test10597z00_29870)
						{	/* Ast/sexp.scm 799 */
							BgL_prefz00_9249 = CAR(BgL_prefz00_57);
						}
					else
						{	/* Ast/sexp.scm 799 */
							BgL_prefz00_9249 = BGl_string8050z00zzast_sexpz00;
						}
				}
				{	/* Ast/sexp.scm 802 */
					bool_t BgL_test10599z00_29877;

					if (STRUCTP(BgL_locz00_56))
						{	/* Ast/sexp.scm 802 */
							BgL_test10599z00_29877 =
								(STRUCT_KEY(BgL_locz00_56) == CNST_TABLE_REF(((long) 43)));
						}
					else
						{	/* Ast/sexp.scm 802 */
							BgL_test10599z00_29877 = ((bool_t) 0);
						}
					if (BgL_test10599z00_29877)
						{	/* Ast/sexp.scm 803 */
							obj_t BgL_filez00_9251;
							obj_t BgL_linez00_9252;
							obj_t BgL_basez00_9253;

							BgL_filez00_9251 =
								BGl_locationzd2fullzd2fnamez00zztools_locationz00
								(BgL_locz00_56);
							BgL_linez00_9252 = STRUCT_REF(BgL_locz00_56, (int) (((long) 2)));
							{	/* Ast/sexp.scm 805 */
								obj_t BgL_arg7213z00_9294;

								BgL_arg7213z00_9294 =
									BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
									(BGl_string8073z00zzast_sexpz00, BgL_prefz00_9249,
										BGl_string8074z00zzast_sexpz00));
								{	/* Ast/sexp.scm 805 */
									obj_t BgL_res8015z00_13749;

									{	/* Ast/sexp.scm 805 */
										obj_t BgL_arg1454z00_13748;

										BgL_arg1454z00_13748 =
											SYMBOL_TO_STRING(BgL_arg7213z00_9294);
										BgL_res8015z00_13749 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1454z00_13748);
									}
									BgL_basez00_9253 = BgL_res8015z00_13749;
							}}
							{	/* Ast/sexp.scm 807 */
								bool_t BgL_test10601z00_29890;

								{	/* Ast/sexp.scm 807 */

									BgL_test10601z00_29890 =
										CBOOL(BGl_stringzd2containszd2zz__r4_strings_6_7z00
										(BgL_prefz00_9249, BGl_string8073z00zzast_sexpz00,
											(int) (((long) 0))));
								}
								if (BgL_test10601z00_29890)
									{	/* Ast/sexp.scm 808 */
										obj_t BgL_arg7186z00_9258;

										{	/* Ast/sexp.scm 808 */
											obj_t BgL_arg7187z00_9259;
											obj_t BgL_arg7188z00_9260;

											{	/* Ast/sexp.scm 808 */
												obj_t BgL_arg7189z00_9261;

												{	/* Ast/sexp.scm 808 */
													obj_t BgL_res8016z00_13751;

													BgL_res8016z00_13751 =
														bstring_to_symbol(((obj_t) BgL_prefz00_9249));
													BgL_arg7189z00_9261 = BgL_res8016z00_13751;
												}
												{	/* Ast/sexp.scm 808 */
													obj_t BgL_res8017z00_13754;

													{	/* Ast/sexp.scm 808 */
														obj_t BgL_arg1454z00_13753;

														BgL_arg1454z00_13753 =
															SYMBOL_TO_STRING(BgL_arg7189z00_9261);
														BgL_res8017z00_13754 =
															BGl_stringzd2copyzd2zz__r4_strings_6_7z00
															(BgL_arg1454z00_13753);
													}
													BgL_arg7187z00_9259 = BgL_res8017z00_13754;
												}
											}
											{	/* Ast/sexp.scm 808 */
												obj_t BgL_arg7190z00_9262;

												BgL_arg7190z00_9262 =
													BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF((
															(long) 44)));
												{	/* Ast/sexp.scm 808 */
													obj_t BgL_res8018z00_13757;

													{	/* Ast/sexp.scm 808 */
														obj_t BgL_arg1454z00_13756;

														BgL_arg1454z00_13756 =
															SYMBOL_TO_STRING(BgL_arg7190z00_9262);
														BgL_res8018z00_13757 =
															BGl_stringzd2copyzd2zz__r4_strings_6_7z00
															(BgL_arg1454z00_13756);
													}
													BgL_arg7188z00_9260 = BgL_res8018z00_13757;
											}}
											BgL_arg7186z00_9258 =
												string_append(BgL_arg7187z00_9259, BgL_arg7188z00_9260);
										}
										return bstring_to_symbol(BgL_arg7186z00_9258);
									}
								else
									{	/* Ast/sexp.scm 809 */
										bool_t BgL_test10602z00_29904;

										{	/* Ast/sexp.scm 809 */
											bool_t BgL_test10603z00_29905;

											if (
												((long) CINT(BGl_za2bdbzd2debugza2zd2zzengine_paramz00)
													>= ((long) 1)))
												{	/* Ast/sexp.scm 810 */
													obj_t BgL_arg7211z00_9289;

													{	/* Ast/sexp.scm 810 */
														obj_t BgL_arg7212z00_9290;

														BgL_arg7212z00_9290 =
															BGl_thezd2backendzd2zzbackend_backendz00();
														BgL_arg7211z00_9289 =
															(((BgL_backendz00_bglt) COBJECT(
																	((BgL_backendz00_bglt)
																		BgL_arg7212z00_9290)))->
															BgL_debugzd2supportzd2);
													}
													BgL_test10603z00_29905 =
														CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
														(CNST_TABLE_REF(((long) 45)), BgL_arg7211z00_9289));
												}
											else
												{	/* Ast/sexp.scm 809 */
													BgL_test10603z00_29905 = ((bool_t) 0);
												}
											if (BgL_test10603z00_29905)
												{	/* Ast/sexp.scm 809 */
													BgL_test10602z00_29904 = ((bool_t) 1);
												}
											else
												{	/* Ast/sexp.scm 809 */
													BgL_test10602z00_29904 =
														(
														(long)
														CINT(BGl_za2compilerzd2debugza2zd2zzengine_paramz00)
														>= ((long) 1));
										}}
										if (BgL_test10602z00_29904)
											{	/* Ast/sexp.scm 812 */
												obj_t BgL_filez00_9271;

												if (bigloo_strncmp(BgL_filez00_9251,
														BGl_string8075z00zzast_sexpz00, ((long) 2)))
													{	/* Ast/sexp.scm 812 */
														BgL_filez00_9271 =
															c_substring(BgL_filez00_9251, ((long) 2),
															STRING_LENGTH(BgL_filez00_9251));
													}
												else
													{	/* Ast/sexp.scm 812 */
														BgL_filez00_9271 = BgL_filez00_9251;
													}
												{	/* Ast/sexp.scm 817 */
													obj_t BgL_arg7198z00_9272;

													{	/* Ast/sexp.scm 817 */
														obj_t BgL_arg7199z00_9273;
														obj_t BgL_arg7200z00_9274;

														BgL_arg7199z00_9273 =
															BGl_stringzd2replacezd2zz__r4_strings_6_7z00
															(BgL_filez00_9271, (char) (((unsigned char) '.')),
															(char) (((unsigned char) ',')));
														{	/* Ast/sexp.scm 818 */

															BgL_arg7200z00_9274 =
																BGl_numberzd2ze3stringz31zz__r4_numbers_6_5z00
																(BgL_linez00_9252, BINT(((long) 10)));
														}
														{	/* Ast/sexp.scm 816 */
															obj_t BgL_list7201z00_9275;

															{	/* Ast/sexp.scm 816 */
																obj_t BgL_arg7202z00_9276;

																{	/* Ast/sexp.scm 816 */
																	obj_t BgL_arg7203z00_9277;

																	{	/* Ast/sexp.scm 816 */
																		obj_t BgL_arg7204z00_9278;

																		{	/* Ast/sexp.scm 816 */
																			obj_t BgL_arg7205z00_9279;

																			{	/* Ast/sexp.scm 816 */
																				obj_t BgL_arg7206z00_9280;

																				BgL_arg7206z00_9280 =
																					MAKE_YOUNG_PAIR
																					(BGl_string8076z00zzast_sexpz00,
																					BNIL);
																				BgL_arg7205z00_9279 =
																					MAKE_YOUNG_PAIR(BgL_arg7200z00_9274,
																					BgL_arg7206z00_9280);
																			}
																			BgL_arg7204z00_9278 =
																				MAKE_YOUNG_PAIR
																				(BGl_string8074z00zzast_sexpz00,
																				BgL_arg7205z00_9279);
																		}
																		BgL_arg7203z00_9277 =
																			MAKE_YOUNG_PAIR(BgL_arg7199z00_9273,
																			BgL_arg7204z00_9278);
																	}
																	BgL_arg7202z00_9276 =
																		MAKE_YOUNG_PAIR
																		(BGl_string8074z00zzast_sexpz00,
																		BgL_arg7203z00_9277);
																}
																BgL_list7201z00_9275 =
																	MAKE_YOUNG_PAIR(BgL_basez00_9253,
																	BgL_arg7202z00_9276);
															}
															BgL_arg7198z00_9272 =
																BGl_stringzd2appendzd2zz__r4_strings_6_7z00
																(BgL_list7201z00_9275);
													}}
													return bstring_to_symbol(BgL_arg7198z00_9272);
												}
											}
										else
											{	/* Ast/sexp.scm 821 */
												obj_t BgL_arg7209z00_9285;

												BgL_arg7209z00_9285 =
													BGl_stringzd2replacezd2zz__r4_strings_6_7z00
													(string_append(BgL_basez00_9253,
														BGl_string8077z00zzast_sexpz00),
													(char) (((unsigned char) '.')),
													(char) (((unsigned char) ',')));
												{	/* Ast/sexp.scm 821 */
													obj_t BgL_res8027z00_13778;

													BgL_res8027z00_13778 =
														bstring_to_symbol(((obj_t) BgL_arg7209z00_9285));
													return BgL_res8027z00_13778;
												}
											}
									}
							}
						}
					else
						{	/* Ast/sexp.scm 822 */
							obj_t BgL_arg7215z00_9296;

							{	/* Ast/sexp.scm 822 */
								obj_t BgL_arg7216z00_9297;
								obj_t BgL_arg7217z00_9298;

								{	/* Ast/sexp.scm 822 */
									obj_t BgL_arg7218z00_9299;

									BgL_arg7218z00_9299 =
										BGl_gensymz00zz__r4_symbols_6_4z00(string_append_3
										(BGl_string8073z00zzast_sexpz00, BgL_prefz00_9249,
											BGl_string8078z00zzast_sexpz00));
									{	/* Ast/sexp.scm 822 */
										obj_t BgL_res8028z00_13781;

										{	/* Ast/sexp.scm 822 */
											obj_t BgL_arg1454z00_13780;

											BgL_arg1454z00_13780 =
												SYMBOL_TO_STRING(BgL_arg7218z00_9299);
											BgL_res8028z00_13781 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1454z00_13780);
										}
										BgL_arg7216z00_9297 = BgL_res8028z00_13781;
									}
								}
								{	/* Ast/sexp.scm 822 */
									obj_t BgL_res8029z00_13784;

									{	/* Ast/sexp.scm 822 */
										obj_t BgL_symbolz00_13782;

										BgL_symbolz00_13782 = CNST_TABLE_REF(((long) 46));
										{	/* Ast/sexp.scm 822 */
											obj_t BgL_arg1454z00_13783;

											BgL_arg1454z00_13783 =
												SYMBOL_TO_STRING(BgL_symbolz00_13782);
											BgL_res8029z00_13784 =
												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
												(BgL_arg1454z00_13783);
									}}
									BgL_arg7217z00_9298 = BgL_res8029z00_13784;
								}
								BgL_arg7215z00_9296 =
									string_append(BgL_arg7216z00_9297, BgL_arg7217z00_9298);
							}
							return bstring_to_symbol(BgL_arg7215z00_9296);
						}
				}
			}
		}

	}



/* &make-anonymous-name */
	obj_t BGl_z62makezd2anonymouszd2namez62zzast_sexpz00(obj_t BgL_envz00_13883,
		obj_t BgL_locz00_13884, obj_t BgL_prefz00_13885)
	{
		{	/* Ast/sexp.scm 798 */
			return
				BGl_makezd2anonymouszd2namez00zzast_sexpz00(BgL_locz00_13884,
				BgL_prefz00_13885);
		}

	}



/* synchronize->node */
	BgL_nodez00_bglt BGl_synchroniza7ezd2ze3nodez96zzast_sexpz00(obj_t
		BgL_expz00_58, obj_t BgL_mutexz00_59, obj_t BgL_prelockz00_60,
		obj_t BgL_bodyz00_61, obj_t BgL_stackz00_62, obj_t BgL_locz00_63,
		obj_t BgL_sitez00_64)
	{
		{	/* Ast/sexp.scm 827 */
			if (SYMBOLP(BgL_mutexz00_59))
				{	/* Ast/sexp.scm 829 */
					BgL_syncz00_bglt BgL_new1160z00_9307;

					{	/* Ast/sexp.scm 830 */
						BgL_syncz00_bglt BgL_new1159z00_9309;

						BgL_new1159z00_9309 =
							((BgL_syncz00_bglt) BOBJECT(GC_MALLOC(sizeof(struct
										BgL_syncz00_bgl))));
						{	/* Ast/sexp.scm 830 */
							long BgL_arg7226z00_9310;

							{	/* Ast/sexp.scm 830 */
								long BgL_res8032z00_13789;

								BgL_res8032z00_13789 =
									BGL_CLASS_INDEX(BGl_syncz00zzast_nodez00);
								BgL_arg7226z00_9310 = BgL_res8032z00_13789;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1159z00_9309),
								BgL_arg7226z00_9310);
						}
						{	/* Ast/sexp.scm 830 */
							BgL_objectz00_bglt BgL_tmpz00_29956;

							BgL_tmpz00_29956 = ((BgL_objectz00_bglt) BgL_new1159z00_9309);
							BGL_OBJECT_WIDENING_SET(BgL_tmpz00_29956, BFALSE);
						}
						((BgL_objectz00_bglt) BgL_new1159z00_9309);
						BgL_new1160z00_9307 = BgL_new1159z00_9309;
					}
					((((BgL_nodez00_bglt) COBJECT(
									((BgL_nodez00_bglt) BgL_new1160z00_9307)))->BgL_locz00) =
						((obj_t) BgL_locz00_63), BUNSPEC);
					((((BgL_nodez00_bglt) COBJECT(((BgL_nodez00_bglt)
										BgL_new1160z00_9307)))->BgL_typez00) =
						((BgL_typez00_bglt) ((BgL_typez00_bglt)
								BGl_za2_za2z00zztype_cachez00)), BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1160z00_9307))->BgL_mutexz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_mutexz00_59,
								BgL_stackz00_62, BgL_locz00_63, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					((((BgL_syncz00_bglt) COBJECT(BgL_new1160z00_9307))->BgL_prelockz00) =
						((BgL_nodez00_bglt)
							BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_prelockz00_60,
								BgL_stackz00_62, BgL_locz00_63, CNST_TABLE_REF(((long) 2)))),
						BUNSPEC);
					{
						BgL_nodez00_bglt BgL_auxz00_29971;

						{	/* Ast/sexp.scm 834 */
							obj_t BgL_arg7225z00_9308;

							BgL_arg7225z00_9308 =
								BGl_normaliza7ezd2prognz75zztools_prognz00(BgL_bodyz00_61);
							BgL_auxz00_29971 =
								BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_arg7225z00_9308,
								BgL_stackz00_62, BgL_locz00_63, BgL_sitez00_64);
						}
						((((BgL_syncz00_bglt) COBJECT(BgL_new1160z00_9307))->BgL_bodyz00) =
							((BgL_nodez00_bglt) BgL_auxz00_29971), BUNSPEC);
					}
					return ((BgL_nodez00_bglt) BgL_new1160z00_9307);
				}
			else
				{	/* Ast/sexp.scm 835 */
					obj_t BgL_vz00_9311;

					BgL_vz00_9311 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 47))));
					{	/* Ast/sexp.scm 835 */
						obj_t BgL_varz00_9312;

						BgL_varz00_9312 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_vz00_9311,
							CNST_TABLE_REF(((long) 47)));
						{	/* Ast/sexp.scm 836 */
							obj_t BgL_nexpz00_9313;

							{	/* Ast/sexp.scm 837 */
								obj_t BgL_arg7234z00_9321;

								{	/* Ast/sexp.scm 837 */
									obj_t BgL_arg7235z00_9322;

									BgL_arg7235z00_9322 =
										MAKE_YOUNG_PAIR(BgL_vz00_9311,
										BGl_eappendzd22zd2zz__r4_pairs_and_lists_6_3z00
										(BgL_bodyz00_61, BNIL));
									BgL_arg7234z00_9321 =
										MAKE_YOUNG_PAIR(CNST_TABLE_REF(((long) 29)),
										BgL_arg7235z00_9322);
								}
								BgL_nexpz00_9313 =
									BGl_epairifyzd2reczd2zztools_miscz00(BgL_arg7234z00_9321,
									BgL_expz00_58);
							}
							{	/* Ast/sexp.scm 837 */

								{	/* Ast/sexp.scm 838 */
									obj_t BgL_arg7227z00_9314;

									{	/* Ast/sexp.scm 838 */
										obj_t BgL_arg7228z00_9315;
										obj_t BgL_arg7229z00_9316;

										BgL_arg7228z00_9315 = BGl_letzd2symzd2zzast_letz00();
										{	/* Ast/sexp.scm 838 */
											obj_t BgL_arg7230z00_9317;
											obj_t BgL_arg7231z00_9318;

											{	/* Ast/sexp.scm 838 */
												obj_t BgL_arg7232z00_9319;

												{	/* Ast/sexp.scm 838 */
													obj_t BgL_arg7233z00_9320;

													BgL_arg7233z00_9320 =
														MAKE_YOUNG_PAIR(BgL_mutexz00_59, BNIL);
													BgL_arg7232z00_9319 =
														MAKE_YOUNG_PAIR(BgL_varz00_9312,
														BgL_arg7233z00_9320);
												}
												BgL_arg7230z00_9317 =
													MAKE_YOUNG_PAIR(BgL_arg7232z00_9319, BNIL);
											}
											BgL_arg7231z00_9318 =
												MAKE_YOUNG_PAIR(BgL_nexpz00_9313, BNIL);
											BgL_arg7229z00_9316 =
												MAKE_YOUNG_PAIR(BgL_arg7230z00_9317,
												BgL_arg7231z00_9318);
										}
										BgL_arg7227z00_9314 =
											MAKE_YOUNG_PAIR(BgL_arg7228z00_9315, BgL_arg7229z00_9316);
									}
									BGl_replacez12z12zztools_miscz00(BgL_expz00_58,
										BgL_arg7227z00_9314);
								}
								return
									BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_58,
									BgL_stackz00_62, BgL_locz00_63, BgL_sitez00_64);
							}
						}
					}
				}
		}

	}



/* not-test */
	obj_t BGl_notzd2testzd2zzast_sexpz00(obj_t BgL_testz00_65)
	{
		{	/* Ast/sexp.scm 847 */
			{
				obj_t BgL_bindingsz00_9329;
				obj_t BgL_exprz00_9330;

				if (PAIRP(BgL_testz00_65))
					{	/* Ast/sexp.scm 848 */
						obj_t BgL_cdrzd262458zd2_9335;

						BgL_cdrzd262458zd2_9335 = CDR(BgL_testz00_65);
						if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 1))))
							{	/* Ast/sexp.scm 848 */
								if (PAIRP(BgL_cdrzd262458zd2_9335))
									{	/* Ast/sexp.scm 848 */
										obj_t BgL_cdrzd262461zd2_9339;

										BgL_cdrzd262461zd2_9339 = CDR(BgL_cdrzd262458zd2_9335);
										if (PAIRP(BgL_cdrzd262461zd2_9339))
											{	/* Ast/sexp.scm 848 */
												obj_t BgL_cdrzd262464zd2_9341;

												BgL_cdrzd262464zd2_9341 = CDR(BgL_cdrzd262461zd2_9339);
												if ((CAR(BgL_cdrzd262461zd2_9339) == BFALSE))
													{	/* Ast/sexp.scm 848 */
														if (PAIRP(BgL_cdrzd262464zd2_9341))
															{	/* Ast/sexp.scm 848 */
																if ((CAR(BgL_cdrzd262464zd2_9341) == BTRUE))
																	{	/* Ast/sexp.scm 848 */
																		if (NULLP(CDR(BgL_cdrzd262464zd2_9341)))
																			{	/* Ast/sexp.scm 848 */
																				return CAR(BgL_cdrzd262458zd2_9335);
																			}
																		else
																			{	/* Ast/sexp.scm 848 */
																				return BFALSE;
																			}
																	}
																else
																	{	/* Ast/sexp.scm 848 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 848 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 848 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 848 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 848 */
										return BFALSE;
									}
							}
						else
							{	/* Ast/sexp.scm 848 */
								if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 48))))
									{	/* Ast/sexp.scm 848 */
										if (PAIRP(BgL_cdrzd262458zd2_9335))
											{	/* Ast/sexp.scm 848 */
												if (NULLP(CDR(BgL_cdrzd262458zd2_9335)))
													{	/* Ast/sexp.scm 848 */
														return CAR(BgL_cdrzd262458zd2_9335);
													}
												else
													{	/* Ast/sexp.scm 848 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 848 */
												return BFALSE;
											}
									}
								else
									{	/* Ast/sexp.scm 848 */
										obj_t BgL_cdrzd262538zd2_9361;

										BgL_cdrzd262538zd2_9361 = CDR(BgL_testz00_65);
										if ((CAR(BgL_testz00_65) == CNST_TABLE_REF(((long) 17))))
											{	/* Ast/sexp.scm 848 */
												if (PAIRP(BgL_cdrzd262538zd2_9361))
													{	/* Ast/sexp.scm 848 */
														obj_t BgL_cdrzd262542zd2_9365;

														BgL_cdrzd262542zd2_9365 =
															CDR(BgL_cdrzd262538zd2_9361);
														if (PAIRP(BgL_cdrzd262542zd2_9365))
															{	/* Ast/sexp.scm 848 */
																if (NULLP(CDR(BgL_cdrzd262542zd2_9365)))
																	{	/* Ast/sexp.scm 848 */
																		BgL_bindingsz00_9329 =
																			CAR(BgL_cdrzd262538zd2_9361);
																		BgL_exprz00_9330 =
																			CAR(BgL_cdrzd262542zd2_9365);
																		{	/* Ast/sexp.scm 854 */
																			obj_t BgL_ntz00_9375;

																			BgL_ntz00_9375 =
																				BGl_notzd2testzd2zzast_sexpz00
																				(BgL_exprz00_9330);
																			if (CBOOL(BgL_ntz00_9375))
																				{	/* Ast/sexp.scm 856 */
																					obj_t BgL_arg7273z00_9376;

																					{	/* Ast/sexp.scm 856 */
																						obj_t BgL_arg7274z00_9377;

																						{	/* Ast/sexp.scm 856 */
																							obj_t BgL_arg7275z00_9378;

																							BgL_arg7275z00_9378 =
																								MAKE_YOUNG_PAIR(BgL_ntz00_9375,
																								BNIL);
																							BgL_arg7274z00_9377 =
																								MAKE_YOUNG_PAIR
																								(BgL_bindingsz00_9329,
																								BgL_arg7275z00_9378);
																						}
																						BgL_arg7273z00_9376 =
																							MAKE_YOUNG_PAIR(CNST_TABLE_REF((
																									(long) 17)),
																							BgL_arg7274z00_9377);
																					}
																					return
																						BGl_epairifyzd2reczd2zztools_miscz00
																						(BgL_arg7273z00_9376,
																						BgL_testz00_65);
																				}
																			else
																				{	/* Ast/sexp.scm 855 */
																					return BFALSE;
																				}
																		}
																	}
																else
																	{	/* Ast/sexp.scm 848 */
																		return BFALSE;
																	}
															}
														else
															{	/* Ast/sexp.scm 848 */
																return BFALSE;
															}
													}
												else
													{	/* Ast/sexp.scm 848 */
														return BFALSE;
													}
											}
										else
											{	/* Ast/sexp.scm 848 */
												return BFALSE;
											}
									}
							}
					}
				else
					{	/* Ast/sexp.scm 848 */
						return BFALSE;
					}
			}
		}

	}



/* used-in? */
	bool_t BGl_usedzd2inzf3z21zzast_sexpz00(obj_t BgL_idz00_66,
		obj_t BgL_exprz00_67)
	{
		{	/* Ast/sexp.scm 865 */
			if ((BgL_idz00_66 == BgL_exprz00_67))
				{	/* Ast/sexp.scm 867 */
					return ((bool_t) 1);
				}
			else
				{	/* Ast/sexp.scm 867 */
					if (PAIRP(BgL_exprz00_67))
						{	/* Ast/sexp.scm 868 */
							if ((CAR(BgL_exprz00_67) == CNST_TABLE_REF(((long) 12))))
								{	/* Ast/sexp.scm 869 */
									return ((bool_t) 0);
								}
							else
								{	/* Ast/sexp.scm 869 */
									if (BGl_listzf3zf3zz__r4_pairs_and_lists_6_3z00
										(BgL_exprz00_67))
										{
											obj_t BgL_list1474z00_9395;

											{	/* Ast/sexp.scm 871 */
												obj_t BgL_tmpz00_30063;

												BgL_list1474z00_9395 = BgL_exprz00_67;
											BgL_zc3z04anonymousza37286ze3z87_9396:
												if (PAIRP(BgL_list1474z00_9395))
													{	/* Ast/sexp.scm 871 */
														if (BGl_usedzd2inzf3z21zzast_sexpz00(BgL_idz00_66,
																CAR(BgL_list1474z00_9395)))
															{	/* Ast/sexp.scm 871 */
																BgL_tmpz00_30063 = CAR(BgL_list1474z00_9395);
															}
														else
															{
																obj_t BgL_list1474z00_30070;

																BgL_list1474z00_30070 =
																	CDR(BgL_list1474z00_9395);
																BgL_list1474z00_9395 = BgL_list1474z00_30070;
																goto BgL_zc3z04anonymousza37286ze3z87_9396;
															}
													}
												else
													{	/* Ast/sexp.scm 871 */
														BgL_tmpz00_30063 = BFALSE;
													}
												return CBOOL(BgL_tmpz00_30063);
											}
										}
									else
										{	/* Ast/sexp.scm 870 */
											return ((bool_t) 0);
										}
								}
						}
					else
						{	/* Ast/sexp.scm 868 */
							return ((bool_t) 0);
						}
				}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			return BUNSPEC;
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_sexpz00()
	{
		{	/* Ast/sexp.scm 14 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713251),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504034),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925560),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_prognz00(((long) 302006061),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333171),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470340),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztools_dssslz00(((long) 275867862),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343422),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457413),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49974950),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 346490117),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 502006413),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 398780361),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 378368389),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206763),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885627),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730597),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90833999),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 469732619),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_buildz00(((long) 428035839),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_pragmaz00(((long) 156774029),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_labelsz00(((long) 129879054),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204214),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_exitz00(((long) 419066123),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_appz00(((long) 449859289),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_applyz00(((long) 277780822),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_privatez00(((long) 135263818),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_objectz00(((long) 520121765),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			BGl_modulezd2initializa7ationz75zzast_dumpz00(((long) 271707736),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
			return
				BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374373),
				BSTRING_TO_STRING(BGl_string8079z00zzast_sexpz00));
		}

	}

#ifdef __cplusplus
}
#endif
