/*===========================================================================*/
/*   (Eval/evaluate.scm)                                                     */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate.scm -o objs/obj_p/Eval/evaluate.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
extern obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
static obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
static obj_t BGl_requirezd2initializa7ationz75zz__evaluatez00 = BUNSPEC;
extern bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
static BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern BgL_ev_exprz00_bglt BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t);
static BgL_ev_globalz00_bglt BGl_convzd2globalzd2zz__evaluatez00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
extern obj_t bgl_reverse(obj_t);
static obj_t BGl_genericzd2initzd2zz__evaluatez00();
extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
extern obj_t BGl_classzd2existszd2zz__objectz00(obj_t);
extern int BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
static obj_t BGl_objectzd2initzd2zz__evaluatez00();
extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
extern bool_t BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(obj_t);
static obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
extern obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t);
extern obj_t BGl_findzd2classzd2fieldz00zz__objectz00(obj_t, obj_t);
extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
extern obj_t bstring_to_symbol(obj_t);
extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_appendzd221009zd2zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
extern obj_t make_vector(long, obj_t);
extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
extern obj_t BGl_classzd2fieldzd2mutatorz00zz__objectz00(obj_t);
static obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__evaluatez00();
extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
extern obj_t string_append(obj_t, obj_t);
extern obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
extern obj_t BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_ev_exprz00_bglt);
extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_getzd2location3zd2zz__evaluatez00(obj_t, obj_t, obj_t);
extern obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
extern obj_t BGl_findzd2statezd2zz__evaluate_compz00();
extern obj_t BGl_evmodulez00zz__evmodulez00(obj_t, obj_t);
static obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t);
static obj_t BGl_keyword3116z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_classzd2fieldzd2typez00zz__objectz00(obj_t);
static obj_t BGl_evepairifyz00zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31363ze3ze5zz__evaluatez00(obj_t);
static obj_t BGl_symbol3001z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_expandz00zz__expandz00(obj_t);
static obj_t BGl_symbol3009z00zz__evaluatez00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
extern bool_t BGl_classzf3zf3zz__objectz00(obj_t);
static obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t, obj_t);
static obj_t BGl_symbol3011z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3013z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3014z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3016z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3018z00zz__evaluatez00 = BUNSPEC;
extern int bgl_debug();
extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
BGL_EXPORTED_DECL obj_t BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t);
static obj_t BGl_symbol3100z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3020z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3102z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3022z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3104z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3024z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
static obj_t BGl_symbol3106z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3026z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3108z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3027z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3029z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluatez00();
static obj_t BGl_symbol3110z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3112z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3031z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_convertz00zz__evaluatez00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol3114z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3033z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3035z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3118z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3037z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3039z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_gczd2rootszd2initz00zz__evaluatez00();
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00();
static obj_t BGl_symbol3041z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3043z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3045z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3047z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3049z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
static obj_t BGl_symbol3051z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3053z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3055z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3057z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3059z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
static obj_t BGl_symbol3061z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3063z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3065z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3067z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3069z00zz__evaluatez00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_evaluate2z00zz__evaluatez00(obj_t, obj_t, obj_t);
extern obj_t BGl_getzd2sourcezd2locationz00zz__readerz00(obj_t);
extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
static obj_t BGl_symbol3071z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3073z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_rconvzf2locze70z15zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol3075z00zz__evaluatez00 = BUNSPEC;
extern obj_t c_substring(obj_t, long, long);
static obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t, obj_t, obj_t);
extern obj_t BGl_evalzd2findzd2modulez00zz__evmodulez00(obj_t);
extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
extern obj_t BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(obj_t, obj_t, bool_t);
extern obj_t BGl_evcompilezd2errorzd2zz__evcompilez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol3080z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3083z00zz__evaluatez00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int);
static obj_t BGl_symbol3085z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3088z00zz__evaluatez00 = BUNSPEC;
extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_profzd2initzd2zz__evaluatez00();
extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
static obj_t BGl_symbol3090z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3092z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_loopze70ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_loopze71ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol3094z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3096z00zz__evaluatez00 = BUNSPEC;
static obj_t BGl_symbol3098z00zz__evaluatez00 = BUNSPEC;
extern obj_t bstring_to_keyword(obj_t);
BGL_EXPORTED_DECL obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
static BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t);
static obj_t BGl_convz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
static obj_t BGl_uconvze70ze7zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t, obj_t);
static obj_t *__cnst;


DEFINE_STRING( BGl_string3010z00zz__evaluatez00, BgL_bgl_string3010za700za7za7_3121za7, "pair", 4 );
DEFINE_STRING( BGl_string3012z00zz__evaluatez00, BgL_bgl_string3012za700za7za7_3122za7, "pair?", 5 );
DEFINE_STRING( BGl_string3015z00zz__evaluatez00, BgL_bgl_string3015za700za7za7_3123za7, "vector?", 7 );
DEFINE_STRING( BGl_string3017z00zz__evaluatez00, BgL_bgl_string3017za700za7za7_3124za7, "symbol", 6 );
DEFINE_STRING( BGl_string3019z00zz__evaluatez00, BgL_bgl_string3019za700za7za7_3125za7, "symbol?", 7 );
DEFINE_STRING( BGl_string3101z00zz__evaluatez00, BgL_bgl_string3101za700za7za7_3126za7, "let*", 4 );
DEFINE_STRING( BGl_string3021z00zz__evaluatez00, BgL_bgl_string3021za700za7za7_3127za7, "char", 4 );
DEFINE_STRING( BGl_string3103z00zz__evaluatez00, BgL_bgl_string3103za700za7za7_3128za7, "letrec", 6 );
DEFINE_STRING( BGl_string3023z00zz__evaluatez00, BgL_bgl_string3023za700za7za7_3129za7, "char?", 5 );
DEFINE_STRING( BGl_string3105z00zz__evaluatez00, BgL_bgl_string3105za700za7za7_3130za7, "set!", 4 );
DEFINE_STRING( BGl_string3025z00zz__evaluatez00, BgL_bgl_string3025za700za7za7_3131za7, "int", 3 );
DEFINE_STRING( BGl_string3107z00zz__evaluatez00, BgL_bgl_string3107za700za7za7_3132za7, "define", 6 );
DEFINE_STRING( BGl_string3109z00zz__evaluatez00, BgL_bgl_string3109za700za7za7_3133za7, "bind-exit", 9 );
DEFINE_STRING( BGl_string3028z00zz__evaluatez00, BgL_bgl_string3028za700za7za7_3134za7, "integer?", 8 );
DEFINE_STRING( BGl_string3111z00zz__evaluatez00, BgL_bgl_string3111za700za7za7_3135za7, "unwind-protect", 14 );
DEFINE_STRING( BGl_string3030z00zz__evaluatez00, BgL_bgl_string3030za700za7za7_3136za7, "real", 4 );
DEFINE_STRING( BGl_string3113z00zz__evaluatez00, BgL_bgl_string3113za700za7za7_3137za7, "with-handler", 12 );
DEFINE_STRING( BGl_string3032z00zz__evaluatez00, BgL_bgl_string3032za700za7za7_3138za7, "breal", 5 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evaluate2zd2restorezd2bpz12zd2envzc0zz__evaluatez00, BgL_bgl_za762evaluate2za7d2r3139z00, BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string3115z00zz__evaluatez00, BgL_bgl_string3115za700za7za7_3140za7, "synchronize", 11 );
DEFINE_STRING( BGl_string3034z00zz__evaluatez00, BgL_bgl_string3034za700za7za7_3141za7, "real?", 5 );
DEFINE_STRING( BGl_string3117z00zz__evaluatez00, BgL_bgl_string3117za700za7za7_3142za7, "prelock", 7 );
DEFINE_STRING( BGl_string3036z00zz__evaluatez00, BgL_bgl_string3036za700za7za7_3143za7, "bool", 4 );
DEFINE_STRING( BGl_string3119z00zz__evaluatez00, BgL_bgl_string3119za700za7za7_3144za7, "free-pragma::obj", 16 );
DEFINE_STRING( BGl_string3038z00zz__evaluatez00, BgL_bgl_string3038za700za7za7_3145za7, "boolean?", 8 );
DEFINE_STRING( BGl_string3120z00zz__evaluatez00, BgL_bgl_string3120za700za7za7_3146za7, "__evaluate", 10 );
DEFINE_STRING( BGl_string3040z00zz__evaluatez00, BgL_bgl_string3040za700za7za7_3147za7, "struct", 6 );
DEFINE_STRING( BGl_string3042z00zz__evaluatez00, BgL_bgl_string3042za700za7za7_3148za7, "struct?", 7 );
DEFINE_STRING( BGl_string3044z00zz__evaluatez00, BgL_bgl_string3044za700za7za7_3149za7, "class", 5 );
DEFINE_STRING( BGl_string3046z00zz__evaluatez00, BgL_bgl_string3046za700za7za7_3150za7, "class?", 6 );
DEFINE_STRING( BGl_string3048z00zz__evaluatez00, BgL_bgl_string3048za700za7za7_3151za7, "string", 6 );
DEFINE_STRING( BGl_string3050z00zz__evaluatez00, BgL_bgl_string3050za700za7za7_3152za7, "bstring", 7 );
DEFINE_STRING( BGl_string3052z00zz__evaluatez00, BgL_bgl_string3052za700za7za7_3153za7, "string?", 7 );
DEFINE_STRING( BGl_string3054z00zz__evaluatez00, BgL_bgl_string3054za700za7za7_3154za7, "o", 1 );
DEFINE_STRING( BGl_string3056z00zz__evaluatez00, BgL_bgl_string3056za700za7za7_3155za7, "quote", 5 );
DEFINE_STRING( BGl_string3058z00zz__evaluatez00, BgL_bgl_string3058za700za7za7_3156za7, "class-exists", 12 );
DEFINE_STRING( BGl_string3060z00zz__evaluatez00, BgL_bgl_string3060za700za7za7_3157za7, "c", 1 );
DEFINE_STRING( BGl_string3062z00zz__evaluatez00, BgL_bgl_string3062za700za7za7_3158za7, "isa?", 4 );
DEFINE_STRING( BGl_string3064z00zz__evaluatez00, BgL_bgl_string3064za700za7za7_3159za7, "if", 2 );
DEFINE_STRING( BGl_string3066z00zz__evaluatez00, BgL_bgl_string3066za700za7za7_3160za7, "let", 3 );
DEFINE_STRING( BGl_string3068z00zz__evaluatez00, BgL_bgl_string3068za700za7za7_3161za7, "lambda", 6 );
DEFINE_STRING( BGl_string3070z00zz__evaluatez00, BgL_bgl_string3070za700za7za7_3162za7, "bigloo-type-error/location", 26 );
DEFINE_STRING( BGl_string3072z00zz__evaluatez00, BgL_bgl_string3072za700za7za7_3163za7, "bigloo-type-error", 17 );
DEFINE_STRING( BGl_string3074z00zz__evaluatez00, BgL_bgl_string3074za700za7za7_3164za7, "at", 2 );
DEFINE_STRING( BGl_string3076z00zz__evaluatez00, BgL_bgl_string3076za700za7za7_3165za7, "tmp", 3 );
DEFINE_STRING( BGl_string3077z00zz__evaluatez00, BgL_bgl_string3077za700za7za7_3166za7, "~a::~a", 6 );
DEFINE_STRING( BGl_string3078z00zz__evaluatez00, BgL_bgl_string3078za700za7za7_3167za7, "free-pragma", 11 );
DEFINE_STRING( BGl_string3079z00zz__evaluatez00, BgL_bgl_string3079za700za7za7_3168za7, "not supported in eval", 21 );
DEFINE_STRING( BGl_string3081z00zz__evaluatez00, BgL_bgl_string3081za700za7za7_3169za7, "\\@", 2 );
DEFINE_STRING( BGl_string3082z00zz__evaluatez00, BgL_bgl_string3082za700za7za7_3170za7, "Illegal form", 12 );
DEFINE_STRING( BGl_string3084z00zz__evaluatez00, BgL_bgl_string3084za700za7za7_3171za7, "begin", 5 );
DEFINE_STRING( BGl_string3086z00zz__evaluatez00, BgL_bgl_string3086za700za7za7_3172za7, " ", 1 );
DEFINE_STRING( BGl_string3087z00zz__evaluatez00, BgL_bgl_string3087za700za7za7_3173za7, "Illegal non toplevel module declaration", 39 );
DEFINE_STRING( BGl_string3089z00zz__evaluatez00, BgL_bgl_string3089za700za7za7_3174za7, "module", 6 );
DEFINE_STRING( BGl_string3091z00zz__evaluatez00, BgL_bgl_string3091za700za7za7_3175za7, "@", 1 );
DEFINE_STRING( BGl_string3093z00zz__evaluatez00, BgL_bgl_string3093za700za7za7_3176za7, "->", 2 );
DEFINE_STRING( BGl_string3095z00zz__evaluatez00, BgL_bgl_string3095za700za7za7_3177za7, "trap", 4 );
DEFINE_STRING( BGl_string3097z00zz__evaluatez00, BgL_bgl_string3097za700za7za7_3178za7, "or", 2 );
DEFINE_STRING( BGl_string3099z00zz__evaluatez00, BgL_bgl_string3099za700za7za7_3179za7, "and", 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_setzd2evaluationzd2contextz12zd2envzc0zz__evaluatez00, BgL_bgl_za762setza7d2evaluat3180z00, BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00, 0L, BUNSPEC, 1 );
extern obj_t BGl_errorzd2envzd2zz__errorz00;
DEFINE_STRING( BGl_string2995z00zz__evaluatez00, BgL_bgl_string2995za700za7za7_3181za7, "", 0 );
DEFINE_STRING( BGl_string2996z00zz__evaluatez00, BgL_bgl_string2996za700za7za7_3182za7, "/builddir/build/BUILD/bigloo-4.4a/runtime/Eval/evaluate.scm", 59 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evaluate2zd2restorezd2statez12zd2envzc0zz__evaluatez00, BgL_bgl_za762evaluate2za7d2r3183z00, BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2997z00zz__evaluatez00, BgL_bgl_string2997za700za7za7_3184za7, "&evaluate2-restore-bp!", 22 );
DEFINE_STRING( BGl_string2998z00zz__evaluatez00, BgL_bgl_string2998za700za7za7_3185za7, "bint", 4 );
DEFINE_STRING( BGl_string2999z00zz__evaluatez00, BgL_bgl_string2999za700za7za7_3186za7, "&evaluate2-restore-state!", 25 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_getzd2evaluationzd2contextzd2envzd2zz__evaluatez00, BgL_bgl_za762getza7d2evaluat3187z00, BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00, 0L, BUNSPEC, 0 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_evaluate2zd2envzd2zz__evaluatez00, BgL_bgl_za762evaluate2za762za73188za7, BGl_z62evaluate2z62zz__evaluatez00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string3000z00zz__evaluatez00, BgL_bgl_string3000za700za7za7_3189za7, "vector", 6 );
DEFINE_STRING( BGl_string3002z00zz__evaluatez00, BgL_bgl_string3002za700za7za7_3190za7, "toplevel", 8 );
DEFINE_STRING( BGl_string3003z00zz__evaluatez00, BgL_bgl_string3003za700za7za7_3191za7, "eval", 4 );
DEFINE_STRING( BGl_string3004z00zz__evaluatez00, BgL_bgl_string3004za700za7za7_3192za7, "Bad syntax", 10 );
DEFINE_STRING( BGl_string3005z00zz__evaluatez00, BgL_bgl_string3005za700za7za7_3193za7, "Class \"~a\" has no field \"~a\"", 28 );
DEFINE_STRING( BGl_string3006z00zz__evaluatez00, BgL_bgl_string3006za700za7za7_3194za7, "Static type not a class", 23 );
DEFINE_STRING( BGl_string3007z00zz__evaluatez00, BgL_bgl_string3007za700za7za7_3195za7, "Variable unbound", 16 );
DEFINE_STRING( BGl_string3008z00zz__evaluatez00, BgL_bgl_string3008za700za7za7_3196za7, "Field read-only", 15 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_keyword3116z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3001z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3009z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3011z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3013z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3014z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3016z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3018z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3100z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3020z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3102z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3022z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3104z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3024z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3106z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3026z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3108z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3027z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3029z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3110z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3112z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3031z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3114z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3033z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3035z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3118z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3037z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3039z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3041z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3043z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3045z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3047z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3049z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3051z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3053z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3055z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3057z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3059z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3061z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3063z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3065z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3067z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3069z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3071z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3073z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3075z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3080z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3083z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3085z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3088z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3090z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3092z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3094z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3096z00zz__evaluatez00) );
ADD_ROOT( (void *)(&BGl_symbol3098z00zz__evaluatez00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "(\"append-21009\" \"BGl_appendzd221009zd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"untype-ident\" \"Eval/evaluate.scm\" 2232) \"BGl_untypezd2identzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"get-evaluation-context\" \"Eval/evaluate.scm\" 2931) \"BGl_getzd2evaluationzd2contextz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&get-evaluation-context\" \"Eval/evaluate.scm\" 2931) \"BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"set-evaluation-context!\" \"Eval/evaluate.scm\" 3411) \"BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&set-evaluation-context!\" \"Eval/evaluate.scm\" 3411) \"BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"evaluate2-restore-bp!\" \"Eval/evaluate.scm\" 3852) \"BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&evaluate2-restore-bp!\" \"Eval/evaluate.scm\" 3852) \"BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"evaluate2-restore-state!\" \"Eval/evaluate.scm\" 4196) \"BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&evaluate2-restore-state!\" \"Eval/evaluate.scm\" 4196) \"BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"evaluate2\" \"Eval/evaluate.scm\" 4542) \"BGl_evaluate2z00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&evaluate2\" \"Eval/evaluate.scm\" 4542) \"BGl_z62evaluate2z62zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1363>\" \"Eval/evaluate.scm\" 4796) \"BGl_z62zc3z04anonymousza31363ze3ze5zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"get-location\" \"Eval/evaluate.scm\" 5084) \"BGl_getzd2locationzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"get-location3\" \"Eval/evaluate.scm\" 5377) \"BGl_getzd2location3zd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"convert\" \"Eval/evaluate.scm\" 5715) \"BGl_convertz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-var\" \"Eval/evaluate.scm\" 6016) \"BGl_convzd2varzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-begin\" \"Eval/evaluate.scm\" 6437) \"BGl_convzd2beginzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-global\" \"Eval/evaluate.scm\" 7149) \"BGl_convzd2globalzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-field-ref\" \"Eval/evaluate.scm\" 7530) \"BGl_convzd2fieldzd2refz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-field-set\" \"Eval/evaluate.scm\" 8597) \"BGl_convzd2fieldzd2setz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-class-field-ref\" \"Eval/evaluate.scm\" 9944) \"BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-class-field-set\" \"Eval/evaluate.scm\" 10386) \"BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"evepairify\" \"Eval/evaluate.scm\" 10822) \"BGl_evepairifyz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"type-check\" \"Eval/evaluate.scm\" 11104) \"BGl_typezd2checkzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"type-checks\" \"Eval/evaluate.scm\" 12230) \"BGl_typezd2checkszd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"loop~1\" \"Eval/evaluate.scm\" 12330) \"BGl_loopze71ze7zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"type-result\" \"Eval/evaluate.scm\" 12883) \"BGl_typezd2resultzd2zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv\" \"Eval/evaluate.scm\" 13355) \"BGl_convz00zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"loop~0\" \"Eval/evaluate.scm\" 13921) \"BGl_loopze70ze7zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"rconv/loc~0\" \"Eval/evaluate.scm\" 13488) \"BGl_rconvzf2locze70z15zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"uconv/loc~0\" \"Eval/evaluate.scm\" 13727) \"BGl_uconvzf2locze70z15zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-vals~0\" \"Eval/evaluate.scm\" 17675) \"BGl_convzd2valsze70z35zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"conv-lambda~0\" \"Eval/evaluate.scm\" 14468) \"BGl_convzd2lambdaze70z35zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "((\"uconv~0\" \"Eval/evaluate.scm\" 13794) \"BGl_uconvze70ze7zz__evaluatez00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long BgL_checksumz00_4497, char * BgL_fromz00_4498)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluatez00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluatez00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluatez00(); 
BGl_cnstzd2initzd2zz__evaluatez00(); 
BGl_importedzd2moduleszd2initz00zz__evaluatez00(); 
return 
BGl_profzd2initzd2zz__evaluatez00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
BGl_symbol3001z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3002z00zz__evaluatez00); 
BGl_symbol3009z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3010z00zz__evaluatez00); 
BGl_symbol3011z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3012z00zz__evaluatez00); 
BGl_symbol3013z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3000z00zz__evaluatez00); 
BGl_symbol3014z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3015z00zz__evaluatez00); 
BGl_symbol3016z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3017z00zz__evaluatez00); 
BGl_symbol3018z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3019z00zz__evaluatez00); 
BGl_symbol3020z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3021z00zz__evaluatez00); 
BGl_symbol3022z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3023z00zz__evaluatez00); 
BGl_symbol3024z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3025z00zz__evaluatez00); 
BGl_symbol3026z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string2998z00zz__evaluatez00); 
BGl_symbol3027z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3028z00zz__evaluatez00); 
BGl_symbol3029z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3030z00zz__evaluatez00); 
BGl_symbol3031z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3032z00zz__evaluatez00); 
BGl_symbol3033z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3034z00zz__evaluatez00); 
BGl_symbol3035z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3036z00zz__evaluatez00); 
BGl_symbol3037z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3038z00zz__evaluatez00); 
BGl_symbol3039z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3040z00zz__evaluatez00); 
BGl_symbol3041z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3042z00zz__evaluatez00); 
BGl_symbol3043z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3044z00zz__evaluatez00); 
BGl_symbol3045z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3046z00zz__evaluatez00); 
BGl_symbol3047z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3048z00zz__evaluatez00); 
BGl_symbol3049z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3050z00zz__evaluatez00); 
BGl_symbol3051z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3052z00zz__evaluatez00); 
BGl_symbol3053z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3054z00zz__evaluatez00); 
BGl_symbol3055z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3056z00zz__evaluatez00); 
BGl_symbol3057z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3058z00zz__evaluatez00); 
BGl_symbol3059z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3060z00zz__evaluatez00); 
BGl_symbol3061z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3062z00zz__evaluatez00); 
BGl_symbol3063z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3064z00zz__evaluatez00); 
BGl_symbol3065z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3066z00zz__evaluatez00); 
BGl_symbol3067z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3068z00zz__evaluatez00); 
BGl_symbol3069z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3070z00zz__evaluatez00); 
BGl_symbol3071z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3072z00zz__evaluatez00); 
BGl_symbol3073z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3074z00zz__evaluatez00); 
BGl_symbol3075z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3076z00zz__evaluatez00); 
BGl_symbol3080z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3081z00zz__evaluatez00); 
BGl_symbol3083z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3084z00zz__evaluatez00); 
BGl_symbol3085z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3086z00zz__evaluatez00); 
BGl_symbol3088z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3089z00zz__evaluatez00); 
BGl_symbol3090z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3091z00zz__evaluatez00); 
BGl_symbol3092z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3093z00zz__evaluatez00); 
BGl_symbol3094z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3095z00zz__evaluatez00); 
BGl_symbol3096z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3097z00zz__evaluatez00); 
BGl_symbol3098z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3099z00zz__evaluatez00); 
BGl_symbol3100z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3101z00zz__evaluatez00); 
BGl_symbol3102z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3103z00zz__evaluatez00); 
BGl_symbol3104z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3105z00zz__evaluatez00); 
BGl_symbol3106z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3107z00zz__evaluatez00); 
BGl_symbol3108z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3109z00zz__evaluatez00); 
BGl_symbol3110z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3111z00zz__evaluatez00); 
BGl_symbol3112z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3113z00zz__evaluatez00); 
BGl_symbol3114z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3115z00zz__evaluatez00); 
BGl_keyword3116z00zz__evaluatez00 = 
bstring_to_keyword(BGl_string3117z00zz__evaluatez00); 
return ( 
BGl_symbol3118z00zz__evaluatez00 = 
bstring_to_symbol(BGl_string3119z00zz__evaluatez00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return 
write_bprof_table();} 

}



/* append-21009 */
obj_t BGl_appendzd221009zd2zz__evaluatez00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_1137;
BgL_headz00_1137 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_1138;obj_t BgL_tailz00_1139;
BgL_prevz00_1138 = BgL_headz00_1137; 
BgL_tailz00_1139 = BgL_l1z00_1; 
BgL_loopz00_1140:
if(
PAIRP(BgL_tailz00_1139))
{ 
obj_t BgL_newzd2prevzd2_1142;
BgL_newzd2prevzd2_1142 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_1139), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_1138, BgL_newzd2prevzd2_1142); 
{ 
obj_t BgL_tailz00_4570;obj_t BgL_prevz00_4569;
BgL_prevz00_4569 = BgL_newzd2prevzd2_1142; 
BgL_tailz00_4570 = 
CDR(BgL_tailz00_1139); 
BgL_tailz00_1139 = BgL_tailz00_4570; 
BgL_prevz00_1138 = BgL_prevz00_4569; 
goto BgL_loopz00_1140;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_1137);} } } 

}



/* untype-ident */
obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t BgL_idz00_3)
{
{ /* Eval/evaluate.scm 73 */
{ /* Eval/evaluate.scm 74 */
obj_t BgL_stringz00_1145;
{ /* Eval/evaluate.scm 74 */
obj_t BgL_res2659z00_3131;
{ /* Eval/evaluate.scm 74 */
obj_t BgL_arg2505z00_3130;
BgL_arg2505z00_3130 = 
SYMBOL_TO_STRING(BgL_idz00_3); 
BgL_res2659z00_3131 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2505z00_3130); } 
BgL_stringz00_1145 = BgL_res2659z00_3131; } 
{ /* Eval/evaluate.scm 74 */
long BgL_lenz00_1146;
BgL_lenz00_1146 = 
STRING_LENGTH(BgL_stringz00_1145); 
{ /* Eval/evaluate.scm 75 */

{ 
long BgL_walkerz00_1148;
BgL_walkerz00_1148 = ((long)0); 
BgL_zc3z04anonymousza31331ze3z87_1149:
if(
(BgL_walkerz00_1148==BgL_lenz00_1146))
{ /* Eval/evaluate.scm 78 */
return 
MAKE_YOUNG_PAIR(BgL_idz00_3, BFALSE);}  else 
{ /* Eval/evaluate.scm 80 */
bool_t BgL_test3200z00_4579;
if(
(
STRING_REF(BgL_stringz00_1145, BgL_walkerz00_1148)==((unsigned char)':')))
{ /* Eval/evaluate.scm 80 */
if(
(BgL_walkerz00_1148<
(BgL_lenz00_1146-((long)1))))
{ /* Eval/evaluate.scm 81 */
BgL_test3200z00_4579 = 
(
STRING_REF(BgL_stringz00_1145, 
(BgL_walkerz00_1148+((long)1)))==((unsigned char)':'))
; }  else 
{ /* Eval/evaluate.scm 81 */
BgL_test3200z00_4579 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate.scm 80 */
BgL_test3200z00_4579 = ((bool_t)0)
; } 
if(BgL_test3200z00_4579)
{ /* Eval/evaluate.scm 83 */
obj_t BgL_arg1342z00_1160;obj_t BgL_arg1343z00_1161;
BgL_arg1342z00_1160 = 
bstring_to_symbol(
c_substring(BgL_stringz00_1145, ((long)0), BgL_walkerz00_1148)); 
{ /* Eval/evaluate.scm 84 */
obj_t BgL_arg1346z00_1163;
{ /* Eval/evaluate.scm 84 */
long BgL_arg1347z00_1164;
BgL_arg1347z00_1164 = 
(BgL_walkerz00_1148+((long)2)); 
{ /* Ieee/string.scm 190 */
long BgL_endz00_1167;
BgL_endz00_1167 = 
STRING_LENGTH(BgL_stringz00_1145); 
{ /* Ieee/string.scm 190 */

BgL_arg1346z00_1163 = 
BGl_substringz00zz__r4_strings_6_7z00(BgL_stringz00_1145, BgL_arg1347z00_1164, BgL_endz00_1167); } } } 
BgL_arg1343z00_1161 = 
bstring_to_symbol(BgL_arg1346z00_1163); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1342z00_1160, BgL_arg1343z00_1161);}  else 
{ 
long BgL_walkerz00_4596;
BgL_walkerz00_4596 = 
(BgL_walkerz00_1148+((long)1)); 
BgL_walkerz00_1148 = BgL_walkerz00_4596; 
goto BgL_zc3z04anonymousza31331ze3z87_1149;} } } } } } } 

}



/* get-evaluation-context */
BGL_EXPORTED_DEF obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00()
{
{ /* Eval/evaluate.scm 91 */
{ /* Eval/evaluate.scm 92 */
obj_t BgL_sz00_1176;
BgL_sz00_1176 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate.scm 93 */
obj_t BgL_bpz00_1177;
BgL_bpz00_1177 = 
VECTOR_REF(
((obj_t)BgL_sz00_1176),((long)0)); 
{ /* Eval/evaluate.scm 94 */
obj_t BgL_rz00_1178;
BgL_rz00_1178 = 
make_vector(
(long)CINT(BgL_bpz00_1177), BGl_string2995z00zz__evaluatez00); 
{ 
long BgL_iz00_1180;
BgL_iz00_1180 = ((long)0); 
BgL_zc3z04anonymousza31354ze3z87_1181:
if(
(BgL_iz00_1180<
(long)CINT(BgL_bpz00_1177)))
{ /* Eval/evaluate.scm 96 */
{ /* Eval/evaluate.scm 97 */
obj_t BgL_arg1356z00_1183;
BgL_arg1356z00_1183 = 
VECTOR_REF(
((obj_t)BgL_sz00_1176),BgL_iz00_1180); 
VECTOR_SET(BgL_rz00_1178,BgL_iz00_1180,BgL_arg1356z00_1183); } 
{ 
long BgL_iz00_4609;
BgL_iz00_4609 = 
(BgL_iz00_1180+((long)1)); 
BgL_iz00_1180 = BgL_iz00_4609; 
goto BgL_zc3z04anonymousza31354ze3z87_1181;} }  else 
{ /* Eval/evaluate.scm 96 */((bool_t)0); } } 
return BgL_rz00_1178;} } } } 

}



/* &get-evaluation-context */
obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t BgL_envz00_4446)
{
{ /* Eval/evaluate.scm 91 */
return 
BGl_getzd2evaluationzd2contextz00zz__evaluatez00();} 

}



/* set-evaluation-context! */
BGL_EXPORTED_DEF obj_t BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t BgL_vz00_4)
{
{ /* Eval/evaluate.scm 104 */
{ /* Eval/evaluate.scm 105 */
obj_t BgL_sz00_1186;
BgL_sz00_1186 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate.scm 106 */
obj_t BgL_bpz00_1187;
BgL_bpz00_1187 = 
VECTOR_REF(
((obj_t)BgL_vz00_4),((long)0)); 
{ 
long BgL_iz00_1189;
{ /* Eval/evaluate.scm 107 */
bool_t BgL_tmpz00_4615;
BgL_iz00_1189 = ((long)0); 
BgL_zc3z04anonymousza31358ze3z87_1190:
if(
(BgL_iz00_1189<
(long)CINT(BgL_bpz00_1187)))
{ /* Eval/evaluate.scm 108 */
{ /* Eval/evaluate.scm 109 */
obj_t BgL_arg1360z00_1192;
BgL_arg1360z00_1192 = 
VECTOR_REF(
((obj_t)BgL_vz00_4),BgL_iz00_1189); 
VECTOR_SET(
((obj_t)BgL_sz00_1186),BgL_iz00_1189,BgL_arg1360z00_1192); } 
{ 
long BgL_iz00_4623;
BgL_iz00_4623 = 
(BgL_iz00_1189+((long)1)); 
BgL_iz00_1189 = BgL_iz00_4623; 
goto BgL_zc3z04anonymousza31358ze3z87_1190;} }  else 
{ /* Eval/evaluate.scm 108 */
BgL_tmpz00_4615 = ((bool_t)0)
; } 
return 
BBOOL(BgL_tmpz00_4615);} } } } } 

}



/* &set-evaluation-context! */
obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t BgL_envz00_4447, obj_t BgL_vz00_4448)
{
{ /* Eval/evaluate.scm 104 */
return 
BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(BgL_vz00_4448);} 

}



/* evaluate2-restore-bp! */
BGL_EXPORTED_DEF obj_t BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int BgL_bpz00_5)
{
{ /* Eval/evaluate.scm 115 */
{ /* Eval/evaluate.scm 116 */
obj_t BgL_sz00_1195;
{ /* Eval/evaluate.scm 116 */
obj_t BgL_tmpz00_4627;
BgL_tmpz00_4627 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_sz00_1195 = 
BGL_ENV_EVSTATE(BgL_tmpz00_4627); } 
return 
VECTOR_SET(
((obj_t)BgL_sz00_1195),((long)0),
BINT(BgL_bpz00_5));} } 

}



/* &evaluate2-restore-bp! */
obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t BgL_envz00_4449, obj_t BgL_bpz00_4450)
{
{ /* Eval/evaluate.scm 115 */
{ /* Eval/evaluate.scm 116 */
int BgL_auxz00_4633;
{ /* Eval/evaluate.scm 116 */
obj_t BgL_tmpz00_4634;
if(
INTEGERP(BgL_bpz00_4450))
{ /* Eval/evaluate.scm 116 */
BgL_tmpz00_4634 = BgL_bpz00_4450
; }  else 
{ 
obj_t BgL_auxz00_4637;
BgL_auxz00_4637 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2996z00zz__evaluatez00, 
BINT(((long)3890)), BGl_string2997z00zz__evaluatez00, BGl_string2998z00zz__evaluatez00, BgL_bpz00_4450); 
FAILURE(BgL_auxz00_4637,BFALSE,BFALSE);} 
BgL_auxz00_4633 = 
CINT(BgL_tmpz00_4634); } 
return 
BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(BgL_auxz00_4633);} } 

}



/* evaluate2-restore-state! */
BGL_EXPORTED_DEF obj_t BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t BgL_statez00_6)
{
{ /* Eval/evaluate.scm 122 */
{ /* Eval/evaluate.scm 124 */
obj_t BgL_tmpz00_4643;
BgL_tmpz00_4643 = 
BGL_CURRENT_DYNAMIC_ENV(); 
return 
BGL_ENV_EVSTATE_SET(BgL_tmpz00_4643, BgL_statez00_6);} } 

}



/* &evaluate2-restore-state! */
obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t BgL_envz00_4451, obj_t BgL_statez00_4452)
{
{ /* Eval/evaluate.scm 122 */
{ /* Eval/evaluate.scm 123 */
obj_t BgL_auxz00_4646;
if(
VECTORP(BgL_statez00_4452))
{ /* Eval/evaluate.scm 123 */
BgL_auxz00_4646 = BgL_statez00_4452
; }  else 
{ 
obj_t BgL_auxz00_4649;
BgL_auxz00_4649 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string2996z00zz__evaluatez00, 
BINT(((long)4240)), BGl_string2999z00zz__evaluatez00, BGl_string3000z00zz__evaluatez00, BgL_statez00_4452); 
FAILURE(BgL_auxz00_4649,BFALSE,BFALSE);} 
return 
BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(BgL_auxz00_4646);} } 

}



/* evaluate2 */
BGL_EXPORTED_DEF obj_t BGl_evaluate2z00zz__evaluatez00(obj_t BgL_sexpz00_7, obj_t BgL_envz00_8, obj_t BgL_locz00_9)
{
{ /* Eval/evaluate.scm 129 */
{ /* Eval/evaluate.scm 130 */
BgL_ev_exprz00_bglt BgL_astz00_1198;
{ /* Eval/evaluate.scm 130 */
obj_t BgL_arg1364z00_1208;
BgL_arg1364z00_1208 = 
BGl_convertz00zz__evaluatez00(BgL_sexpz00_7, BgL_envz00_8, BgL_locz00_9); 
BgL_astz00_1198 = 
BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(
((BgL_ev_exprz00_bglt)BgL_arg1364z00_1208)); } 
BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_astz00_1198); 
{ /* Eval/evaluate.scm 132 */
int BgL_nz00_1199;
BgL_nz00_1199 = 
BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_astz00_1198); 
{ /* Eval/evaluate.scm 133 */
obj_t BgL_fz00_1200;
BgL_fz00_1200 = 
BGl_compilez00zz__evaluate_compz00(BgL_astz00_1198); 
{ /* Eval/evaluate.scm 134 */
obj_t BgL_sz00_1201;
BgL_sz00_1201 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate.scm 135 */
obj_t BgL_bpz00_1202;
BgL_bpz00_1202 = 
VECTOR_REF(
((obj_t)BgL_sz00_1201),((long)0)); 
{ /* Eval/evaluate.scm 136 */
obj_t BgL_exitd1063z00_1203;
BgL_exitd1063z00_1203 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Eval/evaluate.scm 138 */
obj_t BgL_zc3z04anonymousza31363ze3z87_4453;
BgL_zc3z04anonymousza31363ze3z87_4453 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31363ze3ze5zz__evaluatez00, 
(int)(((long)0)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31363ze3z87_4453, 
(int)(((long)0)), BgL_sz00_1201); 
PROCEDURE_SET(BgL_zc3z04anonymousza31363ze3z87_4453, 
(int)(((long)1)), BgL_bpz00_1202); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1063z00_1203, BgL_zc3z04anonymousza31363ze3z87_4453); 
{ /* Eval/evaluate.scm 137 */
obj_t BgL_tmp1065z00_1205;
BgL_tmp1065z00_1205 = 
PROCEDURE_ENTRY(BgL_fz00_1200)(BgL_fz00_1200, BgL_sz00_1201, BEOA); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1063z00_1203); 
BGl_z62zc3z04anonymousza31363ze3ze5zz__evaluatez00(BgL_zc3z04anonymousza31363ze3z87_4453); 
return BgL_tmp1065z00_1205;} } } } } } } } } 

}



/* &evaluate2 */
obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t BgL_envz00_4454, obj_t BgL_sexpz00_4455, obj_t BgL_envz00_4456, obj_t BgL_locz00_4457)
{
{ /* Eval/evaluate.scm 129 */
return 
BGl_evaluate2z00zz__evaluatez00(BgL_sexpz00_4455, BgL_envz00_4456, BgL_locz00_4457);} 

}



/* &<@anonymous:1363> */
obj_t BGl_z62zc3z04anonymousza31363ze3ze5zz__evaluatez00(obj_t BgL_envz00_4458)
{
{ /* Eval/evaluate.scm 136 */
{ /* Eval/evaluate.scm 138 */
obj_t BgL_sz00_4459;obj_t BgL_bpz00_4460;
BgL_sz00_4459 = 
PROCEDURE_REF(BgL_envz00_4458, 
(int)(((long)0))); 
BgL_bpz00_4460 = 
PROCEDURE_REF(BgL_envz00_4458, 
(int)(((long)1))); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_4459),((long)0),BgL_bpz00_4460);} } 

}



/* get-location */
obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t BgL_expz00_10, obj_t BgL_locz00_11)
{
{ /* Eval/evaluate.scm 143 */
{ /* Eval/evaluate.scm 144 */
obj_t BgL__ortest_1066z00_1209;
BgL__ortest_1066z00_1209 = 
BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_10); 
if(
CBOOL(BgL__ortest_1066z00_1209))
{ /* Eval/evaluate.scm 144 */
return BgL__ortest_1066z00_1209;}  else 
{ /* Eval/evaluate.scm 144 */
return BgL_locz00_11;} } } 

}



/* get-location3 */
obj_t BGl_getzd2location3zd2zz__evaluatez00(obj_t BgL_expz00_12, obj_t BgL_lstz00_13, obj_t BgL_locz00_14)
{
{ /* Eval/evaluate.scm 149 */
{ /* Eval/evaluate.scm 150 */
obj_t BgL__ortest_1067z00_1210;
BgL__ortest_1067z00_1210 = 
BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_12); 
if(
CBOOL(BgL__ortest_1067z00_1210))
{ /* Eval/evaluate.scm 150 */
return BgL__ortest_1067z00_1210;}  else 
{ /* Eval/evaluate.scm 151 */
obj_t BgL__ortest_1068z00_1211;
BgL__ortest_1068z00_1211 = 
BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_lstz00_13); 
if(
CBOOL(BgL__ortest_1068z00_1211))
{ /* Eval/evaluate.scm 151 */
return BgL__ortest_1068z00_1211;}  else 
{ /* Eval/evaluate.scm 151 */
return BgL_locz00_14;} } } } 

}



/* convert */
obj_t BGl_convertz00zz__evaluatez00(obj_t BgL_ez00_15, obj_t BgL_globalsz00_16, obj_t BgL_locz00_17)
{
{ /* Eval/evaluate.scm 157 */
return 
BGl_convz00zz__evaluatez00(BgL_ez00_15, BNIL, BgL_globalsz00_16, BFALSE, BGl_symbol3001z00zz__evaluatez00, BgL_locz00_17, ((bool_t)1));} 

}



/* conv-var */
obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t BgL_vz00_18, obj_t BgL_localsz00_19)
{
{ /* Eval/evaluate.scm 163 */
{ 
obj_t BgL_lz00_1213;
BgL_lz00_1213 = BgL_localsz00_19; 
BgL_zc3z04anonymousza31365ze3z87_1214:
if(
NULLP(BgL_lz00_1213))
{ /* Eval/evaluate.scm 165 */
return BFALSE;}  else 
{ /* Eval/evaluate.scm 167 */
obj_t BgL_rvz00_1216;
BgL_rvz00_1216 = 
CAR(
((obj_t)BgL_lz00_1213)); 
if(
(BgL_vz00_18==
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_rvz00_1216)))->BgL_namez00)))
{ /* Eval/evaluate.scm 169 */
return BgL_rvz00_1216;}  else 
{ 
obj_t BgL_lz00_4703;
BgL_lz00_4703 = 
CDR(
((obj_t)BgL_lz00_1213)); 
BgL_lz00_1213 = BgL_lz00_4703; 
goto BgL_zc3z04anonymousza31365ze3z87_1214;} } } } 

}



/* conv-begin */
obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t BgL_lz00_20, obj_t BgL_localsz00_21, obj_t BgL_globalsz00_22, obj_t BgL_tailzf3zf3_23, obj_t BgL_wherez00_24, obj_t BgL_locz00_25, bool_t BgL_topzf3zf3_26)
{
{ /* Eval/evaluate.scm 176 */
{ /* Eval/evaluate.scm 177 */
obj_t BgL_locz00_1223;
BgL_locz00_1223 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_lz00_20, BgL_locz00_25); 
{ 
obj_t BgL_e1z00_1227;obj_t BgL_rz00_1228;obj_t BgL_ez00_1225;
if(
NULLP(BgL_lz00_20))
{ 
BgL_ev_littz00_bglt BgL_auxz00_4709;
{ /* Eval/evaluate.scm 180 */
BgL_ev_littz00_bglt BgL_new1071z00_1240;
{ /* Eval/evaluate.scm 181 */
BgL_ev_littz00_bglt BgL_new1070z00_1241;
BgL_new1070z00_1241 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 181 */
long BgL_arg1380z00_1242;
{ /* Eval/evaluate.scm 181 */
long BgL_res2682z00_3198;
BgL_res2682z00_3198 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg1380z00_1242 = BgL_res2682z00_3198; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1070z00_1241), BgL_arg1380z00_1242); } 
BgL_new1071z00_1240 = BgL_new1070z00_1241; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1071z00_1240))->BgL_valuez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4709 = BgL_new1071z00_1240; } 
return 
((obj_t)BgL_auxz00_4709);}  else 
{ /* Eval/evaluate.scm 178 */
if(
PAIRP(BgL_lz00_20))
{ /* Eval/evaluate.scm 178 */
if(
NULLP(
CDR(BgL_lz00_20)))
{ /* Eval/evaluate.scm 178 */
BgL_ez00_1225 = 
CAR(BgL_lz00_20); 
return 
BGl_convz00zz__evaluatez00(BgL_ez00_1225, BgL_localsz00_21, BgL_globalsz00_22, BgL_tailzf3zf3_23, BgL_wherez00_24, 
BGl_getzd2locationzd2zz__evaluatez00(BgL_ez00_1225, BgL_locz00_1223), BgL_topzf3zf3_26);}  else 
{ /* Eval/evaluate.scm 178 */
obj_t BgL_arg1376z00_1237;obj_t BgL_arg1377z00_1238;
BgL_arg1376z00_1237 = 
CAR(BgL_lz00_20); 
BgL_arg1377z00_1238 = 
CDR(BgL_lz00_20); 
{ 
BgL_ev_prog2z00_bglt BgL_auxz00_4726;
BgL_e1z00_1227 = BgL_arg1376z00_1237; 
BgL_rz00_1228 = BgL_arg1377z00_1238; 
{ /* Eval/evaluate.scm 185 */
BgL_ev_prog2z00_bglt BgL_new1073z00_1244;
{ /* Eval/evaluate.scm 186 */
BgL_ev_prog2z00_bglt BgL_new1072z00_1246;
BgL_new1072z00_1246 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate.scm 186 */
long BgL_arg1383z00_1247;
{ /* Eval/evaluate.scm 186 */
long BgL_res2683z00_3202;
BgL_res2683z00_3202 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BgL_arg1383z00_1247 = BgL_res2683z00_3202; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1072z00_1246), BgL_arg1383z00_1247); } 
BgL_new1073z00_1244 = BgL_new1072z00_1246; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4731;
{ /* Eval/evaluate.scm 186 */
obj_t BgL_arg1382z00_1245;
BgL_arg1382z00_1245 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_e1z00_1227, BgL_locz00_1223); 
BgL_auxz00_4731 = 
((BgL_ev_exprz00_bglt)
BGl_convz00zz__evaluatez00(BgL_e1z00_1227, BgL_localsz00_21, BgL_globalsz00_22, BFALSE, BgL_wherez00_24, BgL_arg1382z00_1245, BgL_topzf3zf3_26)); } 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1073z00_1244))->BgL_e1z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4731),BUNSPEC); } 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1073z00_1244))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_rz00_1228, BgL_localsz00_21, BgL_globalsz00_22, BgL_tailzf3zf3_23, BgL_wherez00_24, BgL_locz00_1223, BgL_topzf3zf3_26))),BUNSPEC); 
BgL_auxz00_4726 = BgL_new1073z00_1244; } 
return 
((obj_t)BgL_auxz00_4726);} } }  else 
{ /* Eval/evaluate.scm 178 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_1223, BGl_string3003z00zz__evaluatez00, BGl_string3004z00zz__evaluatez00, BgL_lz00_20);} } } } } 

}



/* conv-global */
BgL_ev_globalz00_bglt BGl_convzd2globalzd2zz__evaluatez00(obj_t BgL_locz00_27, obj_t BgL_idz00_28, obj_t BgL_globalsz00_29)
{
{ /* Eval/evaluate.scm 194 */
{ /* Eval/evaluate.scm 195 */
BgL_ev_globalz00_bglt BgL_new1075z00_1248;
{ /* Eval/evaluate.scm 196 */
BgL_ev_globalz00_bglt BgL_new1074z00_1250;
BgL_new1074z00_1250 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate.scm 196 */
long BgL_arg1385z00_1251;
{ /* Eval/evaluate.scm 196 */
long BgL_res2687z00_3213;
BgL_res2687z00_3213 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg1385z00_1251 = BgL_res2687z00_3213; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1074z00_1250), BgL_arg1385z00_1251); } 
BgL_new1075z00_1248 = BgL_new1074z00_1250; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1075z00_1248))->BgL_locz00)=((obj_t)BgL_locz00_27),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1075z00_1248))->BgL_namez00)=((obj_t)BgL_idz00_28),BUNSPEC); 
{ 
obj_t BgL_auxz00_4747;
if(
BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_29))
{ /* Eval/evaluate.scm 198 */
BgL_auxz00_4747 = BgL_globalsz00_29
; }  else 
{ /* Eval/evaluate.scm 198 */
BgL_auxz00_4747 = 
BGL_MODULE()
; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1075z00_1248))->BgL_modz00)=((obj_t)BgL_auxz00_4747),BUNSPEC); } 
return BgL_new1075z00_1248;} } 

}



/* conv-field-ref */
obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t BgL_ez00_30, obj_t BgL_localsz00_31, obj_t BgL_globalsz00_32, obj_t BgL_tailzf3zf3_33, obj_t BgL_wherez00_34, obj_t BgL_locz00_35, bool_t BgL_topzf3zf3_36)
{
{ /* Eval/evaluate.scm 203 */
{ /* Eval/evaluate.scm 204 */
obj_t BgL_lz00_1252;
BgL_lz00_1252 = 
CDR(
((obj_t)BgL_ez00_30)); 
{ /* Eval/evaluate.scm 204 */
obj_t BgL_vz00_1253;
BgL_vz00_1253 = 
BGl_convzd2varzd2zz__evaluatez00(
CAR(
((obj_t)BgL_lz00_1252)), BgL_localsz00_31); 
{ /* Eval/evaluate.scm 205 */

if(
BGl_isazf3zf3zz__objectz00(BgL_vz00_1253, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate.scm 208 */
obj_t BgL_g1078z00_1256;obj_t BgL_g1079z00_1257;
{ /* Eval/evaluate.scm 209 */
obj_t BgL_arg1401z00_1280;
BgL_arg1401z00_1280 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_typez00); 
BgL_g1078z00_1256 = 
BGl_classzd2existszd2zz__objectz00(BgL_arg1401z00_1280); } 
BgL_g1079z00_1257 = 
CDR(
((obj_t)BgL_lz00_1252)); 
{ 
BgL_ev_exprz00_bglt BgL_nodez00_1259;obj_t BgL_klassz00_1260;obj_t BgL_fieldsz00_1261;
BgL_nodez00_1259 = 
((BgL_ev_exprz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_1253)); 
BgL_klassz00_1260 = BgL_g1078z00_1256; 
BgL_fieldsz00_1261 = BgL_g1079z00_1257; 
BgL_zc3z04anonymousza31387ze3z87_1262:
if(
NULLP(BgL_fieldsz00_1261))
{ /* Eval/evaluate.scm 212 */
return 
((obj_t)BgL_nodez00_1259);}  else 
{ /* Eval/evaluate.scm 212 */
if(
BGl_classzf3zf3zz__objectz00(BgL_klassz00_1260))
{ /* Eval/evaluate.scm 215 */
obj_t BgL_fieldz00_1265;
{ /* Eval/evaluate.scm 215 */
obj_t BgL_arg1399z00_1276;
BgL_arg1399z00_1276 = 
CAR(
((obj_t)BgL_fieldsz00_1261)); 
BgL_fieldz00_1265 = 
BGl_findzd2classzd2fieldz00zz__objectz00(BgL_klassz00_1260, BgL_arg1399z00_1276); } 
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_fieldz00_1265))
{ /* Eval/evaluate.scm 217 */
BgL_ev_appz00_bglt BgL_nodez00_1267;
BgL_nodez00_1267 = 
BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(BgL_fieldz00_1265, BgL_nodez00_1259, BgL_locz00_35, BgL_tailzf3zf3_33); 
{ /* Eval/evaluate.scm 220 */
obj_t BgL_arg1391z00_1268;obj_t BgL_arg1392z00_1269;
BgL_arg1391z00_1268 = 
BGl_classzd2fieldzd2typez00zz__objectz00(BgL_fieldz00_1265); 
BgL_arg1392z00_1269 = 
CDR(
((obj_t)BgL_fieldsz00_1261)); 
{ 
obj_t BgL_fieldsz00_4781;obj_t BgL_klassz00_4780;BgL_ev_exprz00_bglt BgL_nodez00_4778;
BgL_nodez00_4778 = 
((BgL_ev_exprz00_bglt)BgL_nodez00_1267); 
BgL_klassz00_4780 = BgL_arg1391z00_1268; 
BgL_fieldsz00_4781 = BgL_arg1392z00_1269; 
BgL_fieldsz00_1261 = BgL_fieldsz00_4781; 
BgL_klassz00_1260 = BgL_klassz00_4780; 
BgL_nodez00_1259 = BgL_nodez00_4778; 
goto BgL_zc3z04anonymousza31387ze3z87_1262;} } }  else 
{ /* Eval/evaluate.scm 222 */
obj_t BgL_arg1393z00_1270;obj_t BgL_arg1394z00_1271;
BgL_arg1393z00_1270 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_typez00); 
{ /* Eval/evaluate.scm 223 */
obj_t BgL_arg1395z00_1272;obj_t BgL_arg1396z00_1273;
BgL_arg1395z00_1272 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_typez00); 
BgL_arg1396z00_1273 = 
CAR(
((obj_t)BgL_fieldsz00_1261)); 
{ /* Eval/evaluate.scm 223 */
obj_t BgL_list1397z00_1274;
{ /* Eval/evaluate.scm 223 */
obj_t BgL_arg1398z00_1275;
BgL_arg1398z00_1275 = 
MAKE_YOUNG_PAIR(BgL_arg1396z00_1273, BNIL); 
BgL_list1397z00_1274 = 
MAKE_YOUNG_PAIR(BgL_arg1395z00_1272, BgL_arg1398z00_1275); } 
BgL_arg1394z00_1271 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3005z00zz__evaluatez00, BgL_list1397z00_1274); } } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35, BgL_arg1393z00_1270, BgL_arg1394z00_1271, BgL_ez00_30);} }  else 
{ /* Eval/evaluate.scm 226 */
obj_t BgL_arg1400z00_1277;
{ /* Eval/evaluate.scm 226 */
obj_t BgL__ortest_1080z00_1278;
BgL__ortest_1080z00_1278 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_typez00); 
if(
CBOOL(BgL__ortest_1080z00_1278))
{ /* Eval/evaluate.scm 226 */
BgL_arg1400z00_1277 = BgL__ortest_1080z00_1278; }  else 
{ /* Eval/evaluate.scm 226 */
BgL_arg1400z00_1277 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1253)))->BgL_namez00); } } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35, BgL_arg1400z00_1277, BGl_string3006z00zz__evaluatez00, BgL_ez00_30);} } } }  else 
{ /* Eval/evaluate.scm 228 */
obj_t BgL_arg1402z00_1281;
{ /* Eval/evaluate.scm 228 */
obj_t BgL_pairz00_3226;
BgL_pairz00_3226 = 
CDR(
((obj_t)BgL_ez00_30)); 
BgL_arg1402z00_1281 = 
CAR(BgL_pairz00_3226); } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35, BgL_arg1402z00_1281, BGl_string3007z00zz__evaluatez00, BgL_ez00_30);} } } } } 

}



/* conv-field-set */
obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t BgL_lz00_37, obj_t BgL_e2z00_38, obj_t BgL_ez00_39, obj_t BgL_localsz00_40, obj_t BgL_globalsz00_41, obj_t BgL_tailzf3zf3_42, obj_t BgL_wherez00_43, obj_t BgL_locz00_44, bool_t BgL_topzf3zf3_45)
{
{ /* Eval/evaluate.scm 233 */
{ /* Eval/evaluate.scm 234 */
obj_t BgL_vz00_1283;
BgL_vz00_1283 = 
BGl_convzd2varzd2zz__evaluatez00(
CAR(BgL_lz00_37), BgL_localsz00_40); 
{ /* Eval/evaluate.scm 234 */
obj_t BgL_e2z00_1284;
BgL_e2z00_1284 = 
BGl_convz00zz__evaluatez00(BgL_e2z00_38, BgL_localsz00_40, BgL_globalsz00_41, BFALSE, BgL_wherez00_43, BgL_locz00_44, ((bool_t)0)); 
{ /* Eval/evaluate.scm 235 */

if(
BGl_isazf3zf3zz__objectz00(BgL_vz00_1283, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate.scm 238 */
obj_t BgL_g1082z00_1287;obj_t BgL_g1083z00_1288;
{ /* Eval/evaluate.scm 239 */
obj_t BgL_arg1431z00_1319;
BgL_arg1431z00_1319 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_typez00); 
BgL_g1082z00_1287 = 
BGl_classzd2existszd2zz__objectz00(BgL_arg1431z00_1319); } 
BgL_g1083z00_1288 = 
CDR(BgL_lz00_37); 
{ 
BgL_ev_exprz00_bglt BgL_nodez00_1290;obj_t BgL_klassz00_1291;obj_t BgL_fieldsz00_1292;
BgL_nodez00_1290 = 
((BgL_ev_exprz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_1283)); 
BgL_klassz00_1291 = BgL_g1082z00_1287; 
BgL_fieldsz00_1292 = BgL_g1083z00_1288; 
BgL_zc3z04anonymousza31406ze3z87_1293:
if(
NULLP(BgL_fieldsz00_1292))
{ /* Eval/evaluate.scm 242 */
return 
((obj_t)BgL_nodez00_1290);}  else 
{ /* Eval/evaluate.scm 242 */
if(
BGl_classzf3zf3zz__objectz00(BgL_klassz00_1291))
{ /* Eval/evaluate.scm 245 */
obj_t BgL_fieldz00_1296;
{ /* Eval/evaluate.scm 245 */
obj_t BgL_arg1429z00_1315;
BgL_arg1429z00_1315 = 
CAR(
((obj_t)BgL_fieldsz00_1292)); 
BgL_fieldz00_1296 = 
BGl_findzd2classzd2fieldz00zz__objectz00(BgL_klassz00_1291, BgL_arg1429z00_1315); } 
if(
BGl_classzd2fieldzf3z21zz__objectz00(BgL_fieldz00_1296))
{ /* Eval/evaluate.scm 246 */
if(
NULLP(
CDR(
((obj_t)BgL_fieldsz00_1292))))
{ /* Eval/evaluate.scm 247 */
if(
BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(BgL_fieldz00_1296))
{ /* Eval/evaluate.scm 250 */
obj_t BgL_arg1413z00_1301;
{ /* Eval/evaluate.scm 250 */
obj_t BgL_list1414z00_1302;
{ /* Eval/evaluate.scm 250 */
obj_t BgL_arg1415z00_1303;
BgL_arg1415z00_1303 = 
MAKE_YOUNG_PAIR(BgL_e2z00_1284, BNIL); 
BgL_list1414z00_1302 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_nodez00_1290), BgL_arg1415z00_1303); } 
BgL_arg1413z00_1301 = BgL_list1414z00_1302; } 
return 
((obj_t)
BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(BgL_fieldz00_1296, BgL_arg1413z00_1301, BgL_locz00_44, BgL_tailzf3zf3_42));}  else 
{ /* Eval/evaluate.scm 251 */
obj_t BgL_arg1417z00_1304;
BgL_arg1417z00_1304 = 
CAR(
((obj_t)BgL_fieldsz00_1292)); 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44, BgL_arg1417z00_1304, BGl_string3008z00zz__evaluatez00, BgL_ez00_39);} }  else 
{ /* Eval/evaluate.scm 254 */
BgL_ev_appz00_bglt BgL_nodez00_1305;
BgL_nodez00_1305 = 
BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(BgL_fieldz00_1296, BgL_nodez00_1290, BgL_locz00_44, BgL_tailzf3zf3_42); 
{ /* Eval/evaluate.scm 257 */
obj_t BgL_arg1418z00_1306;obj_t BgL_arg1419z00_1307;
BgL_arg1418z00_1306 = 
BGl_classzd2fieldzd2typez00zz__objectz00(BgL_fieldz00_1296); 
BgL_arg1419z00_1307 = 
CDR(
((obj_t)BgL_fieldsz00_1292)); 
{ 
obj_t BgL_fieldsz00_4845;obj_t BgL_klassz00_4844;BgL_ev_exprz00_bglt BgL_nodez00_4842;
BgL_nodez00_4842 = 
((BgL_ev_exprz00_bglt)BgL_nodez00_1305); 
BgL_klassz00_4844 = BgL_arg1418z00_1306; 
BgL_fieldsz00_4845 = BgL_arg1419z00_1307; 
BgL_fieldsz00_1292 = BgL_fieldsz00_4845; 
BgL_klassz00_1291 = BgL_klassz00_4844; 
BgL_nodez00_1290 = BgL_nodez00_4842; 
goto BgL_zc3z04anonymousza31406ze3z87_1293;} } } }  else 
{ /* Eval/evaluate.scm 259 */
obj_t BgL_arg1421z00_1309;obj_t BgL_arg1422z00_1310;
BgL_arg1421z00_1309 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_typez00); 
{ /* Eval/evaluate.scm 260 */
obj_t BgL_arg1423z00_1311;obj_t BgL_arg1424z00_1312;
BgL_arg1423z00_1311 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_typez00); 
BgL_arg1424z00_1312 = 
CAR(
((obj_t)BgL_fieldsz00_1292)); 
{ /* Eval/evaluate.scm 260 */
obj_t BgL_list1425z00_1313;
{ /* Eval/evaluate.scm 260 */
obj_t BgL_arg1426z00_1314;
BgL_arg1426z00_1314 = 
MAKE_YOUNG_PAIR(BgL_arg1424z00_1312, BNIL); 
BgL_list1425z00_1313 = 
MAKE_YOUNG_PAIR(BgL_arg1423z00_1311, BgL_arg1426z00_1314); } 
BgL_arg1422z00_1310 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3005z00zz__evaluatez00, BgL_list1425z00_1313); } } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44, BgL_arg1421z00_1309, BgL_arg1422z00_1310, BgL_ez00_39);} }  else 
{ /* Eval/evaluate.scm 264 */
obj_t BgL_arg1430z00_1316;
{ /* Eval/evaluate.scm 264 */
obj_t BgL__ortest_1084z00_1317;
BgL__ortest_1084z00_1317 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_typez00); 
if(
CBOOL(BgL__ortest_1084z00_1317))
{ /* Eval/evaluate.scm 264 */
BgL_arg1430z00_1316 = BgL__ortest_1084z00_1317; }  else 
{ /* Eval/evaluate.scm 264 */
BgL_arg1430z00_1316 = 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_1283)))->BgL_namez00); } } 
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44, BgL_arg1430z00_1316, BGl_string3006z00zz__evaluatez00, BgL_ez00_39);} } } }  else 
{ /* Eval/evaluate.scm 236 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44, 
CAR(BgL_lz00_37), BGl_string3007z00zz__evaluatez00, BgL_ez00_39);} } } } } 

}



/* make-class-field-ref */
BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(obj_t BgL_fieldz00_46, BgL_ev_exprz00_bglt BgL_argz00_47, obj_t BgL_locz00_48, obj_t BgL_tailzf3zf3_49)
{
{ /* Eval/evaluate.scm 270 */
{ /* Eval/evaluate.scm 271 */
obj_t BgL_getz00_1322;
BgL_getz00_1322 = 
BGl_classzd2fieldzd2accessorz00zz__objectz00(BgL_fieldz00_46); 
{ /* Eval/evaluate.scm 272 */
BgL_ev_appz00_bglt BgL_new1086z00_1323;
{ /* Eval/evaluate.scm 273 */
BgL_ev_appz00_bglt BgL_new1085z00_1328;
BgL_new1085z00_1328 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate.scm 273 */
long BgL_arg1436z00_1329;
{ /* Eval/evaluate.scm 273 */
long BgL_res2692z00_3239;
BgL_res2692z00_3239 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1436z00_1329 = BgL_res2692z00_3239; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1085z00_1328), BgL_arg1436z00_1329); } 
BgL_new1086z00_1323 = BgL_new1085z00_1328; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1086z00_1323))->BgL_locz00)=((obj_t)BgL_locz00_48),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4873;
{ /* Eval/evaluate.scm 274 */
BgL_ev_littz00_bglt BgL_new1088z00_1324;
{ /* Eval/evaluate.scm 274 */
BgL_ev_littz00_bglt BgL_new1087z00_1325;
BgL_new1087z00_1325 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 274 */
long BgL_arg1434z00_1326;
{ /* Eval/evaluate.scm 274 */
long BgL_res2693z00_3243;
{ /* Eval/evaluate.scm 274 */
obj_t BgL_classz00_3242;
BgL_classz00_3242 = BGl_ev_littz00zz__evaluate_typesz00; 
BgL_res2693z00_3243 = 
BGL_CLASS_INDEX(BgL_classz00_3242); } 
BgL_arg1434z00_1326 = BgL_res2693z00_3243; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1087z00_1325), BgL_arg1434z00_1326); } 
BgL_new1088z00_1324 = BgL_new1087z00_1325; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1088z00_1324))->BgL_valuez00)=((obj_t)BgL_getz00_1322),BUNSPEC); 
BgL_auxz00_4873 = 
((BgL_ev_exprz00_bglt)BgL_new1088z00_1324); } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1086z00_1323))->BgL_funz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4873),BUNSPEC); } 
{ 
obj_t BgL_auxz00_4881;
{ /* Eval/evaluate.scm 275 */
obj_t BgL_list1435z00_1327;
BgL_list1435z00_1327 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_argz00_47), BNIL); 
BgL_auxz00_4881 = BgL_list1435z00_1327; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1086z00_1323))->BgL_argsz00)=((obj_t)BgL_auxz00_4881),BUNSPEC); } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1086z00_1323))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf3zf3_49),BUNSPEC); 
return BgL_new1086z00_1323;} } } 

}



/* make-class-field-set */
BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(obj_t BgL_fieldz00_50, obj_t BgL_argsz00_51, obj_t BgL_locz00_52, obj_t BgL_tailzf3zf3_53)
{
{ /* Eval/evaluate.scm 281 */
{ /* Eval/evaluate.scm 282 */
obj_t BgL_setz00_1330;
BgL_setz00_1330 = 
BGl_classzd2fieldzd2mutatorz00zz__objectz00(BgL_fieldz00_50); 
{ /* Eval/evaluate.scm 283 */
BgL_ev_appz00_bglt BgL_new1090z00_1331;
{ /* Eval/evaluate.scm 284 */
BgL_ev_appz00_bglt BgL_new1089z00_1335;
BgL_new1089z00_1335 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate.scm 284 */
long BgL_arg1438z00_1336;
{ /* Eval/evaluate.scm 284 */
long BgL_res2695z00_3248;
BgL_res2695z00_3248 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1438z00_1336 = BgL_res2695z00_3248; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1089z00_1335), BgL_arg1438z00_1336); } 
BgL_new1090z00_1331 = BgL_new1089z00_1335; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1090z00_1331))->BgL_locz00)=((obj_t)BgL_locz00_52),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4892;
{ /* Eval/evaluate.scm 285 */
BgL_ev_littz00_bglt BgL_new1092z00_1332;
{ /* Eval/evaluate.scm 285 */
BgL_ev_littz00_bglt BgL_new1091z00_1333;
BgL_new1091z00_1333 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 285 */
long BgL_arg1437z00_1334;
{ /* Eval/evaluate.scm 285 */
long BgL_res2696z00_3252;
{ /* Eval/evaluate.scm 285 */
obj_t BgL_classz00_3251;
BgL_classz00_3251 = BGl_ev_littz00zz__evaluate_typesz00; 
BgL_res2696z00_3252 = 
BGL_CLASS_INDEX(BgL_classz00_3251); } 
BgL_arg1437z00_1334 = BgL_res2696z00_3252; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1091z00_1333), BgL_arg1437z00_1334); } 
BgL_new1092z00_1332 = BgL_new1091z00_1333; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1092z00_1332))->BgL_valuez00)=((obj_t)BgL_setz00_1330),BUNSPEC); 
BgL_auxz00_4892 = 
((BgL_ev_exprz00_bglt)BgL_new1092z00_1332); } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1090z00_1331))->BgL_funz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4892),BUNSPEC); } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1090z00_1331))->BgL_argsz00)=((obj_t)BgL_argsz00_51),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1090z00_1331))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf3zf3_53),BUNSPEC); 
return BgL_new1090z00_1331;} } } 

}



/* evepairify */
obj_t BGl_evepairifyz00zz__evaluatez00(obj_t BgL_pz00_54, obj_t BgL_locz00_55)
{
{ /* Eval/evaluate.scm 292 */
{ /* Eval/evaluate.scm 293 */
obj_t BgL_arg1439z00_1337;obj_t BgL_arg1440z00_1338;
BgL_arg1439z00_1337 = 
CAR(BgL_pz00_54); 
BgL_arg1440z00_1338 = 
CDR(BgL_pz00_54); 
{ /* Eval/evaluate.scm 293 */
obj_t BgL_res2697z00_3257;
BgL_res2697z00_3257 = 
MAKE_YOUNG_EPAIR(BgL_arg1439z00_1337, BgL_arg1440z00_1338, BgL_locz00_55); 
return BgL_res2697z00_3257;} } } 

}



/* type-check */
obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t BgL_varz00_56, obj_t BgL_tnamez00_57, obj_t BgL_locz00_58, obj_t BgL_procnamez00_59, obj_t BgL_bodyz00_60)
{
{ /* Eval/evaluate.scm 298 */
if(
SYMBOLP(BgL_tnamez00_57))
{ /* Eval/evaluate.scm 301 */
obj_t BgL_predz00_1340;
if(
(BgL_tnamez00_57==BGl_symbol3009z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3011z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3013z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3014z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3016z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3018z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3020z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3022z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
bool_t BgL_test3233z00_4915;
{ /* Eval/evaluate.scm 301 */
bool_t BgL__ortest_1093z00_1416;
BgL__ortest_1093z00_1416 = 
(BgL_tnamez00_57==BGl_symbol3024z00zz__evaluatez00); 
if(BgL__ortest_1093z00_1416)
{ /* Eval/evaluate.scm 301 */
BgL_test3233z00_4915 = BgL__ortest_1093z00_1416
; }  else 
{ /* Eval/evaluate.scm 301 */
BgL_test3233z00_4915 = 
(BgL_tnamez00_57==BGl_symbol3026z00zz__evaluatez00)
; } } 
if(BgL_test3233z00_4915)
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3027z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
bool_t BgL_test3235z00_4919;
{ /* Eval/evaluate.scm 301 */
bool_t BgL__ortest_1094z00_1415;
BgL__ortest_1094z00_1415 = 
(BgL_tnamez00_57==BGl_symbol3029z00zz__evaluatez00); 
if(BgL__ortest_1094z00_1415)
{ /* Eval/evaluate.scm 301 */
BgL_test3235z00_4919 = BgL__ortest_1094z00_1415
; }  else 
{ /* Eval/evaluate.scm 301 */
BgL_test3235z00_4919 = 
(BgL_tnamez00_57==BGl_symbol3031z00zz__evaluatez00)
; } } 
if(BgL_test3235z00_4919)
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3033z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3035z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3037z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3039z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3041z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
if(
(BgL_tnamez00_57==BGl_symbol3043z00zz__evaluatez00))
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3045z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 301 */
bool_t BgL_test3240z00_4929;
{ /* Eval/evaluate.scm 301 */
bool_t BgL__ortest_1095z00_1414;
BgL__ortest_1095z00_1414 = 
(BgL_tnamez00_57==BGl_symbol3047z00zz__evaluatez00); 
if(BgL__ortest_1095z00_1414)
{ /* Eval/evaluate.scm 301 */
BgL_test3240z00_4929 = BgL__ortest_1095z00_1414
; }  else 
{ /* Eval/evaluate.scm 301 */
BgL_test3240z00_4929 = 
(BgL_tnamez00_57==BGl_symbol3049z00zz__evaluatez00)
; } } 
if(BgL_test3240z00_4929)
{ /* Eval/evaluate.scm 301 */
BgL_predz00_1340 = BGl_symbol3051z00zz__evaluatez00; }  else 
{ /* Eval/evaluate.scm 312 */
obj_t BgL_arg1488z00_1394;
{ /* Eval/evaluate.scm 312 */
obj_t BgL_arg1489z00_1395;obj_t BgL_arg1491z00_1396;
BgL_arg1489z00_1395 = 
MAKE_YOUNG_PAIR(BGl_symbol3053z00zz__evaluatez00, BNIL); 
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1492z00_1397;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1493z00_1398;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1494z00_1399;obj_t BgL_arg1495z00_1400;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1496z00_1401;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1497z00_1402;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1498z00_1403;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1500z00_1404;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1501z00_1405;
{ /* Eval/evaluate.scm 313 */
obj_t BgL_arg1502z00_1406;
BgL_arg1502z00_1406 = 
MAKE_YOUNG_PAIR(BgL_tnamez00_57, BNIL); 
BgL_arg1501z00_1405 = 
MAKE_YOUNG_PAIR(BGl_symbol3055z00zz__evaluatez00, BgL_arg1502z00_1406); } 
BgL_arg1500z00_1404 = 
MAKE_YOUNG_PAIR(BgL_arg1501z00_1405, BNIL); } 
BgL_arg1498z00_1403 = 
MAKE_YOUNG_PAIR(BGl_symbol3057z00zz__evaluatez00, BgL_arg1500z00_1404); } 
BgL_arg1497z00_1402 = 
MAKE_YOUNG_PAIR(BgL_arg1498z00_1403, BNIL); } 
BgL_arg1496z00_1401 = 
MAKE_YOUNG_PAIR(BGl_symbol3059z00zz__evaluatez00, BgL_arg1497z00_1402); } 
BgL_arg1494z00_1399 = 
MAKE_YOUNG_PAIR(BgL_arg1496z00_1401, BNIL); } 
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1504z00_1407;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1505z00_1408;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1507z00_1409;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1508z00_1410;obj_t BgL_arg1509z00_1411;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1510z00_1412;
{ /* Eval/evaluate.scm 314 */
obj_t BgL_arg1511z00_1413;
BgL_arg1511z00_1413 = 
MAKE_YOUNG_PAIR(BGl_symbol3059z00zz__evaluatez00, BNIL); 
BgL_arg1510z00_1412 = 
MAKE_YOUNG_PAIR(BGl_symbol3053z00zz__evaluatez00, BgL_arg1511z00_1413); } 
BgL_arg1508z00_1410 = 
MAKE_YOUNG_PAIR(BGl_symbol3061z00zz__evaluatez00, BgL_arg1510z00_1412); } 
BgL_arg1509z00_1411 = 
MAKE_YOUNG_PAIR(BTRUE, BNIL); 
BgL_arg1507z00_1409 = 
MAKE_YOUNG_PAIR(BgL_arg1508z00_1410, BgL_arg1509z00_1411); } 
BgL_arg1505z00_1408 = 
MAKE_YOUNG_PAIR(BGl_symbol3059z00zz__evaluatez00, BgL_arg1507z00_1409); } 
BgL_arg1504z00_1407 = 
MAKE_YOUNG_PAIR(BGl_symbol3063z00zz__evaluatez00, BgL_arg1505z00_1408); } 
BgL_arg1495z00_1400 = 
MAKE_YOUNG_PAIR(BgL_arg1504z00_1407, BNIL); } 
BgL_arg1493z00_1398 = 
MAKE_YOUNG_PAIR(BgL_arg1494z00_1399, BgL_arg1495z00_1400); } 
BgL_arg1492z00_1397 = 
MAKE_YOUNG_PAIR(BGl_symbol3065z00zz__evaluatez00, BgL_arg1493z00_1398); } 
BgL_arg1491z00_1396 = 
MAKE_YOUNG_PAIR(BgL_arg1492z00_1397, BNIL); } 
BgL_arg1488z00_1394 = 
MAKE_YOUNG_PAIR(BgL_arg1489z00_1395, BgL_arg1491z00_1396); } 
BgL_predz00_1340 = 
MAKE_YOUNG_PAIR(BGl_symbol3067z00zz__evaluatez00, BgL_arg1488z00_1394); } } } } } } } } } } 
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1442z00_1341;
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1443z00_1342;
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1444z00_1343;obj_t BgL_arg1445z00_1344;
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1446z00_1345;
BgL_arg1446z00_1345 = 
MAKE_YOUNG_PAIR(BgL_varz00_56, BNIL); 
BgL_arg1444z00_1343 = 
MAKE_YOUNG_PAIR(BgL_predz00_1340, BgL_arg1446z00_1345); } 
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1447z00_1346;
{ /* Eval/evaluate.scm 316 */
obj_t BgL_arg1448z00_1347;
{ 
obj_t BgL_fnamez00_1348;obj_t BgL_posz00_1349;
if(
PAIRP(BgL_locz00_58))
{ /* Eval/evaluate.scm 316 */
obj_t BgL_cdrzd2138zd2_1354;
BgL_cdrzd2138zd2_1354 = 
CDR(BgL_locz00_58); 
if(
(
CAR(BgL_locz00_58)==BGl_symbol3073z00zz__evaluatez00))
{ /* Eval/evaluate.scm 316 */
if(
PAIRP(BgL_cdrzd2138zd2_1354))
{ /* Eval/evaluate.scm 316 */
obj_t BgL_cdrzd2142zd2_1358;
BgL_cdrzd2142zd2_1358 = 
CDR(BgL_cdrzd2138zd2_1354); 
if(
PAIRP(BgL_cdrzd2142zd2_1358))
{ /* Eval/evaluate.scm 316 */
if(
NULLP(
CDR(BgL_cdrzd2142zd2_1358)))
{ /* Eval/evaluate.scm 316 */
BgL_fnamez00_1348 = 
CAR(BgL_cdrzd2138zd2_1354); 
BgL_posz00_1349 = 
CAR(BgL_cdrzd2142zd2_1358); 
{ /* Eval/evaluate.scm 321 */
obj_t BgL_arg1462z00_1366;
{ /* Eval/evaluate.scm 321 */
obj_t BgL_arg1463z00_1367;obj_t BgL_arg1464z00_1368;
if(
SYMBOLP(BgL_procnamez00_59))
{ /* Eval/evaluate.scm 321 */
obj_t BgL_res2707z00_3276;
{ /* Eval/evaluate.scm 321 */
obj_t BgL_arg2505z00_3275;
BgL_arg2505z00_3275 = 
SYMBOL_TO_STRING(BgL_procnamez00_59); 
BgL_res2707z00_3276 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2505z00_3275); } 
BgL_arg1463z00_1367 = BgL_res2707z00_3276; }  else 
{ /* Eval/evaluate.scm 321 */
BgL_arg1463z00_1367 = BFALSE; } 
{ /* Eval/evaluate.scm 322 */
obj_t BgL_arg1466z00_1370;obj_t BgL_arg1467z00_1371;
{ /* Eval/evaluate.scm 322 */
obj_t BgL_res2708z00_3279;
{ /* Eval/evaluate.scm 322 */
obj_t BgL_arg2505z00_3278;
BgL_arg2505z00_3278 = 
SYMBOL_TO_STRING(
((obj_t)BgL_tnamez00_57)); 
BgL_res2708z00_3279 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2505z00_3278); } 
BgL_arg1466z00_1370 = BgL_res2708z00_3279; } 
{ /* Eval/evaluate.scm 320 */
obj_t BgL_arg1468z00_1372;
{ /* Eval/evaluate.scm 320 */
obj_t BgL_arg1469z00_1373;
BgL_arg1469z00_1373 = 
MAKE_YOUNG_PAIR(BgL_posz00_1349, BNIL); 
BgL_arg1468z00_1372 = 
MAKE_YOUNG_PAIR(BgL_fnamez00_1348, BgL_arg1469z00_1373); } 
BgL_arg1467z00_1371 = 
MAKE_YOUNG_PAIR(BgL_varz00_56, BgL_arg1468z00_1372); } 
BgL_arg1464z00_1368 = 
MAKE_YOUNG_PAIR(BgL_arg1466z00_1370, BgL_arg1467z00_1371); } 
BgL_arg1462z00_1366 = 
MAKE_YOUNG_PAIR(BgL_arg1463z00_1367, BgL_arg1464z00_1368); } 
BgL_arg1448z00_1347 = 
MAKE_YOUNG_PAIR(BGl_symbol3069z00zz__evaluatez00, BgL_arg1462z00_1366); } }  else 
{ /* Eval/evaluate.scm 316 */
BgL_tagzd2131zd2_1351:
{ /* Eval/evaluate.scm 326 */
obj_t BgL_arg1470z00_1374;
{ /* Eval/evaluate.scm 326 */
obj_t BgL_arg1471z00_1375;obj_t BgL_arg1472z00_1376;
if(
SYMBOLP(BgL_procnamez00_59))
{ /* Eval/evaluate.scm 326 */
obj_t BgL_res2710z00_3283;
{ /* Eval/evaluate.scm 326 */
obj_t BgL_arg2505z00_3282;
BgL_arg2505z00_3282 = 
SYMBOL_TO_STRING(BgL_procnamez00_59); 
BgL_res2710z00_3283 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2505z00_3282); } 
BgL_arg1471z00_1375 = BgL_res2710z00_3283; }  else 
{ /* Eval/evaluate.scm 326 */
BgL_arg1471z00_1375 = BFALSE; } 
{ /* Eval/evaluate.scm 327 */
obj_t BgL_arg1476z00_1378;obj_t BgL_arg1477z00_1379;
{ /* Eval/evaluate.scm 327 */
obj_t BgL_res2711z00_3286;
{ /* Eval/evaluate.scm 327 */
obj_t BgL_arg2505z00_3285;
BgL_arg2505z00_3285 = 
SYMBOL_TO_STRING(
((obj_t)BgL_tnamez00_57)); 
BgL_res2711z00_3286 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2505z00_3285); } 
BgL_arg1476z00_1378 = BgL_res2711z00_3286; } 
BgL_arg1477z00_1379 = 
MAKE_YOUNG_PAIR(BgL_varz00_56, BNIL); 
BgL_arg1472z00_1376 = 
MAKE_YOUNG_PAIR(BgL_arg1476z00_1378, BgL_arg1477z00_1379); } 
BgL_arg1470z00_1374 = 
MAKE_YOUNG_PAIR(BgL_arg1471z00_1375, BgL_arg1472z00_1376); } 
BgL_arg1448z00_1347 = 
MAKE_YOUNG_PAIR(BGl_symbol3071z00zz__evaluatez00, BgL_arg1470z00_1374); } } }  else 
{ /* Eval/evaluate.scm 316 */
goto BgL_tagzd2131zd2_1351;} }  else 
{ /* Eval/evaluate.scm 316 */
goto BgL_tagzd2131zd2_1351;} }  else 
{ /* Eval/evaluate.scm 316 */
goto BgL_tagzd2131zd2_1351;} }  else 
{ /* Eval/evaluate.scm 316 */
goto BgL_tagzd2131zd2_1351;} } 
BgL_arg1447z00_1346 = 
MAKE_YOUNG_PAIR(BgL_arg1448z00_1347, BNIL); } 
BgL_arg1445z00_1344 = 
MAKE_YOUNG_PAIR(BgL_bodyz00_60, BgL_arg1447z00_1346); } 
BgL_arg1443z00_1342 = 
MAKE_YOUNG_PAIR(BgL_arg1444z00_1343, BgL_arg1445z00_1344); } 
BgL_arg1442z00_1341 = 
MAKE_YOUNG_PAIR(BGl_symbol3063z00zz__evaluatez00, BgL_arg1443z00_1342); } 
return 
BGl_evepairifyz00zz__evaluatez00(BgL_arg1442z00_1341, BgL_locz00_58);} }  else 
{ /* Eval/evaluate.scm 300 */
return BgL_bodyz00_60;} } 

}



/* type-checks */
obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t BgL_varsz00_61, obj_t BgL_srcsz00_62, obj_t BgL_bodyz00_63, obj_t BgL_locz00_64, obj_t BgL_procnamez00_65)
{
{ /* Eval/evaluate.scm 334 */
{ /* Eval/evaluate.scm 335 */
bool_t BgL_test3249z00_5001;
{ /* Eval/evaluate.scm 335 */
int BgL_arg1522z00_1435;
BgL_arg1522z00_1435 = 
bgl_debug(); 
BgL_test3249z00_5001 = 
(
(long)(BgL_arg1522z00_1435)<=((long)0)); } 
if(BgL_test3249z00_5001)
{ /* Eval/evaluate.scm 335 */
return BgL_bodyz00_63;}  else 
{ /* Eval/evaluate.scm 335 */
return 
BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_63, BgL_procnamez00_65, BgL_locz00_64, BgL_varsz00_61, BgL_srcsz00_62);} } } 

}



/* loop~1 */
obj_t BGl_loopze71ze7zz__evaluatez00(obj_t BgL_bodyz00_4492, obj_t BgL_procnamez00_4491, obj_t BgL_locz00_4490, obj_t BgL_varsz00_1420, obj_t BgL_srcsz00_1421)
{
{ /* Eval/evaluate.scm 337 */
BGl_loopze71ze7zz__evaluatez00:
if(
NULLP(BgL_varsz00_1420))
{ /* Eval/evaluate.scm 339 */
return BgL_bodyz00_4492;}  else 
{ /* Eval/evaluate.scm 341 */
obj_t BgL_vz00_1424;
BgL_vz00_1424 = 
CAR(
((obj_t)BgL_varsz00_1420)); 
{ /* Eval/evaluate.scm 341 */
obj_t BgL_idz00_1425;
BgL_idz00_1425 = 
CAR(
((obj_t)BgL_vz00_1424)); 
{ /* Eval/evaluate.scm 342 */
obj_t BgL_tnamez00_1426;
BgL_tnamez00_1426 = 
CDR(
((obj_t)BgL_vz00_1424)); 
{ /* Eval/evaluate.scm 343 */

if(
CBOOL(BgL_tnamez00_1426))
{ /* Eval/evaluate.scm 345 */
obj_t BgL_locz00_1427;
{ /* Eval/evaluate.scm 345 */
obj_t BgL_arg1519z00_1431;
BgL_arg1519z00_1431 = 
CAR(
((obj_t)BgL_srcsz00_1421)); 
BgL_locz00_1427 = 
BGl_getzd2location3zd2zz__evaluatez00(BgL_arg1519z00_1431, BgL_srcsz00_1421, BgL_locz00_4490); } 
{ /* Eval/evaluate.scm 347 */
obj_t BgL_arg1516z00_1428;
{ /* Eval/evaluate.scm 347 */
obj_t BgL_arg1517z00_1429;obj_t BgL_arg1518z00_1430;
BgL_arg1517z00_1429 = 
CDR(
((obj_t)BgL_varsz00_1420)); 
BgL_arg1518z00_1430 = 
CDR(
((obj_t)BgL_srcsz00_1421)); 
BgL_arg1516z00_1428 = 
BGl_loopze71ze7zz__evaluatez00(BgL_bodyz00_4492, BgL_procnamez00_4491, BgL_locz00_4490, BgL_arg1517z00_1429, BgL_arg1518z00_1430); } 
return 
BGl_typezd2checkzd2zz__evaluatez00(BgL_idz00_1425, BgL_tnamez00_1426, BgL_locz00_1427, BgL_procnamez00_4491, BgL_arg1516z00_1428);} }  else 
{ /* Eval/evaluate.scm 348 */
obj_t BgL_arg1520z00_1432;obj_t BgL_arg1521z00_1433;
BgL_arg1520z00_1432 = 
CDR(
((obj_t)BgL_varsz00_1420)); 
BgL_arg1521z00_1433 = 
CDR(
((obj_t)BgL_srcsz00_1421)); 
{ 
obj_t BgL_srcsz00_5030;obj_t BgL_varsz00_5029;
BgL_varsz00_5029 = BgL_arg1520z00_1432; 
BgL_srcsz00_5030 = BgL_arg1521z00_1433; 
BgL_srcsz00_1421 = BgL_srcsz00_5030; 
BgL_varsz00_1420 = BgL_varsz00_5029; 
goto BGl_loopze71ze7zz__evaluatez00;} } } } } } } 

}



/* type-result */
obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t BgL_typez00_66, obj_t BgL_bodyz00_67, obj_t BgL_locz00_68)
{
{ /* Eval/evaluate.scm 353 */
{ /* Eval/evaluate.scm 354 */
bool_t BgL_test3252z00_5031;
if(
CBOOL(BgL_typez00_66))
{ /* Eval/evaluate.scm 354 */
int BgL_arg1537z00_1450;
BgL_arg1537z00_1450 = 
bgl_debug(); 
BgL_test3252z00_5031 = 
(
(long)(BgL_arg1537z00_1450)>=((long)1)); }  else 
{ /* Eval/evaluate.scm 354 */
BgL_test3252z00_5031 = ((bool_t)0)
; } 
if(BgL_test3252z00_5031)
{ /* Eval/evaluate.scm 355 */
obj_t BgL_tmpz00_1438;
BgL_tmpz00_1438 = 
BGl_gensymz00zz__r4_symbols_6_4z00(BGl_symbol3075z00zz__evaluatez00); 
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1525z00_1439;obj_t BgL_arg1526z00_1440;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1527z00_1441;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1529z00_1442;obj_t BgL_arg1530z00_1443;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1531z00_1444;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1532z00_1445;obj_t BgL_arg1533z00_1446;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1534z00_1447;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_list1535z00_1448;
{ /* Eval/evaluate.scm 357 */
obj_t BgL_arg1536z00_1449;
BgL_arg1536z00_1449 = 
MAKE_YOUNG_PAIR(BgL_typez00_66, BNIL); 
BgL_list1535z00_1448 = 
MAKE_YOUNG_PAIR(BgL_tmpz00_1438, BgL_arg1536z00_1449); } 
BgL_arg1534z00_1447 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string3077z00zz__evaluatez00, BgL_list1535z00_1448); } 
BgL_arg1532z00_1445 = 
bstring_to_symbol(BgL_arg1534z00_1447); } 
BgL_arg1533z00_1446 = 
MAKE_YOUNG_PAIR(BgL_bodyz00_67, BNIL); 
BgL_arg1531z00_1444 = 
MAKE_YOUNG_PAIR(BgL_arg1532z00_1445, BgL_arg1533z00_1446); } 
BgL_arg1529z00_1442 = 
MAKE_YOUNG_PAIR(BgL_arg1531z00_1444, BNIL); } 
BgL_arg1530z00_1443 = 
MAKE_YOUNG_PAIR(BgL_tmpz00_1438, BNIL); 
BgL_arg1527z00_1441 = 
MAKE_YOUNG_PAIR(BgL_arg1529z00_1442, BgL_arg1530z00_1443); } 
BgL_arg1525z00_1439 = 
MAKE_YOUNG_PAIR(BGl_symbol3065z00zz__evaluatez00, BgL_arg1527z00_1441); } 
BgL_arg1526z00_1440 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bodyz00_67, BgL_locz00_68); 
return 
BGl_evepairifyz00zz__evaluatez00(BgL_arg1525z00_1439, BgL_arg1526z00_1440);} }  else 
{ /* Eval/evaluate.scm 354 */
return BgL_bodyz00_67;} } } 

}



/* conv */
obj_t BGl_convz00zz__evaluatez00(obj_t BgL_ez00_69, obj_t BgL_localsz00_70, obj_t BgL_globalsz00_71, obj_t BgL_tailzf3zf3_72, obj_t BgL_wherez00_73, obj_t BgL_locz00_74, bool_t BgL_topzf3zf3_75)
{
{ /* Eval/evaluate.scm 365 */
BGl_convz00zz__evaluatez00:
{ 
obj_t BgL_ez00_2636;obj_t BgL_locz00_2637;obj_t BgL_wherez00_2638;obj_t BgL_ez00_2646;obj_t BgL_wherez00_2647;
{ 
obj_t BgL_xz00_1459;obj_t BgL_bahz00_1461;obj_t BgL_idz00_1463;obj_t BgL_modnamez00_1464;obj_t BgL_lz00_1466;obj_t BgL_funz00_1468;obj_t BgL_argsz00_1469;obj_t BgL_ez00_1471;obj_t BgL_vz00_1473;obj_t BgL_pz00_1475;obj_t BgL_tz00_1476;obj_t BgL_oz00_1477;obj_t BgL_pz00_1479;obj_t BgL_tz00_1480;obj_t BgL_argsz00_1482;obj_t BgL_argsz00_1484;obj_t BgL_lz00_1486;obj_t BgL_bindsz00_1488;obj_t BgL_bodyz00_1489;obj_t BgL_bindsz00_1491;obj_t BgL_bodyz00_1492;obj_t BgL_bindsz00_1494;obj_t BgL_bodyz00_1495;obj_t BgL_idz00_1497;obj_t BgL_modnamez00_1498;obj_t BgL_ez00_1499;obj_t BgL_lz00_1501;obj_t BgL_e2z00_1502;obj_t BgL_vz00_1504;obj_t BgL_ez00_1505;obj_t BgL_gvz00_1508;obj_t BgL_formalsz00_1509;obj_t BgL_bodyz00_1510;obj_t BgL_gvz00_1512;obj_t BgL_gez00_1513;obj_t BgL_vz00_1515;obj_t BgL_bodyz00_1516;obj_t BgL_ez00_1518;obj_t BgL_bodyz00_1519;obj_t BgL_hz00_1521;obj_t BgL_bodyz00_1522;obj_t BgL_mz00_1524;obj_t BgL_pz00_1525;obj_t BgL_bodyz00_1526;obj_t BgL_mz00_1528;obj_t BgL_bodyz00_1529;obj_t BgL_formalsz00_1531;obj_t BgL_bodyz00_1532;obj_t BgL_fz00_1535;obj_t BgL_argsz00_1536;
if(
PAIRP(BgL_ez00_69))
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3088z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
BgL_bahz00_1461 = 
CDR(BgL_ez00_69); 
if(BgL_topzf3zf3_75)
{ /* Eval/evaluate.scm 432 */
obj_t BgL_formsz00_2326;
BgL_formsz00_2326 = 
BGl_evmodulez00zz__evmodulez00(BgL_ez00_69, 
BGl_getzd2locationzd2zz__evaluatez00(BgL_ez00_69, BgL_locz00_74)); 
{ /* Eval/evaluate.scm 433 */
obj_t BgL_arg2198z00_2327;obj_t BgL_arg2199z00_2328;
BgL_arg2198z00_2327 = 
BGl_expandz00zz__expandz00(BgL_formsz00_2326); 
BgL_arg2199z00_2328 = 
BGL_MODULE(); 
{ 
bool_t BgL_topzf3zf3_5064;obj_t BgL_wherez00_5063;obj_t BgL_tailzf3zf3_5062;obj_t BgL_globalsz00_5061;obj_t BgL_ez00_5060;
BgL_ez00_5060 = BgL_arg2198z00_2327; 
BgL_globalsz00_5061 = BgL_arg2199z00_2328; 
BgL_tailzf3zf3_5062 = BgL_wherez00_73; 
BgL_wherez00_5063 = BFALSE; 
BgL_topzf3zf3_5064 = ((bool_t)1); 
BgL_topzf3zf3_75 = BgL_topzf3zf3_5064; 
BgL_wherez00_73 = BgL_wherez00_5063; 
BgL_tailzf3zf3_72 = BgL_tailzf3zf3_5062; 
BgL_globalsz00_71 = BgL_globalsz00_5061; 
BgL_ez00_69 = BgL_ez00_5060; 
goto BGl_convz00zz__evaluatez00;} } }  else 
{ /* Eval/evaluate.scm 431 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74, BGl_string3003z00zz__evaluatez00, BGl_string3087z00zz__evaluatez00, BgL_ez00_69);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd2250zd2_1544;
BgL_cdrzd2250zd2_1544 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3090z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd2250zd2_1544))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd2253zd2_1548;obj_t BgL_cdrzd2254zd2_1549;
BgL_carzd2253zd2_1548 = 
CAR(BgL_cdrzd2250zd2_1544); 
BgL_cdrzd2254zd2_1549 = 
CDR(BgL_cdrzd2250zd2_1544); 
if(
SYMBOLP(BgL_carzd2253zd2_1548))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd2254zd2_1549))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd2258zd2_1552;
BgL_carzd2258zd2_1552 = 
CAR(BgL_cdrzd2254zd2_1549); 
if(
SYMBOLP(BgL_carzd2258zd2_1552))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd2254zd2_1549)))
{ 
BgL_ev_globalz00_bglt BgL_auxz00_5085;
BgL_idz00_1463 = BgL_carzd2253zd2_1548; 
BgL_modnamez00_1464 = BgL_carzd2258zd2_1552; 
{ /* Eval/evaluate.scm 437 */
BgL_ev_globalz00_bglt BgL_new1106z00_2330;
{ /* Eval/evaluate.scm 438 */
BgL_ev_globalz00_bglt BgL_new1104z00_2331;
BgL_new1104z00_2331 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate.scm 438 */
long BgL_arg2201z00_2332;
{ /* Eval/evaluate.scm 438 */
long BgL_res2735z00_3349;
BgL_res2735z00_3349 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg2201z00_2332 = BgL_res2735z00_3349; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1104z00_2331), BgL_arg2201z00_2332); } 
BgL_new1106z00_2330 = BgL_new1104z00_2331; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1106z00_2330))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1106z00_2330))->BgL_namez00)=((obj_t)BgL_idz00_1463),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1106z00_2330))->BgL_modz00)=((obj_t)
BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_modnamez00_1464)),BUNSPEC); 
BgL_auxz00_5085 = BgL_new1106z00_2330; } 
return 
((obj_t)BgL_auxz00_5085);}  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd2303zd2_1556;
BgL_carzd2303zd2_1556 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd2303zd2_1556))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd2303zd2_1556, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5101;
BgL_funz00_1468 = BgL_carzd2303zd2_1556; 
BgL_argsz00_1469 = BgL_cdrzd2250zd2_1544; 
BgL_tagzd2152zd2_1470:
{ /* Eval/evaluate.scm 449 */
obj_t BgL_funz00_2359;obj_t BgL_argsz00_2360;
BgL_funz00_2359 = 
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_funz00_1468); 
BgL_argsz00_2360 = 
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_locz00_74, BgL_argsz00_1469); 
{ /* Eval/evaluate.scm 450 */
BgL_ev_appz00_bglt BgL_new1108z00_2361;
{ /* Eval/evaluate.scm 451 */
BgL_ev_appz00_bglt BgL_new1107z00_2362;
BgL_new1107z00_2362 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate.scm 451 */
long BgL_arg2215z00_2363;
{ /* Eval/evaluate.scm 451 */
long BgL_res2740z00_3360;
BgL_res2740z00_3360 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg2215z00_2363 = BgL_res2740z00_3360; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1107z00_2362), BgL_arg2215z00_2363); } 
BgL_new1108z00_2361 = BgL_new1107z00_2362; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1108z00_2361))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1108z00_2361))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_funz00_2359)),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1108z00_2361))->BgL_argsz00)=((obj_t)BgL_argsz00_2360),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1108z00_2361))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf3zf3_72),BUNSPEC); 
BgL_auxz00_5101 = BgL_new1108z00_2361; } } 
return 
((obj_t)BgL_auxz00_5101);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5114;
BgL_fz00_1535 = BgL_carzd2303zd2_1556; 
BgL_argsz00_1536 = BgL_cdrzd2250zd2_1544; 
BgL_tagzd2176zd2_1537:
{ /* Eval/evaluate.scm 599 */
obj_t BgL_funz00_2625;obj_t BgL_argsz00_2626;
BgL_funz00_2625 = 
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_fz00_1535); 
BgL_argsz00_2626 = 
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_locz00_74, BgL_argsz00_1536); 
{ /* Eval/evaluate.scm 600 */
BgL_ev_appz00_bglt BgL_new1156z00_2627;
{ /* Eval/evaluate.scm 601 */
BgL_ev_appz00_bglt BgL_new1155z00_2628;
BgL_new1155z00_2628 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate.scm 601 */
long BgL_arg2335z00_2629;
{ /* Eval/evaluate.scm 601 */
long BgL_res2804z00_3570;
BgL_res2804z00_3570 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg2335z00_2629 = BgL_res2804z00_3570; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1155z00_2628), BgL_arg2335z00_2629); } 
BgL_new1156z00_2627 = BgL_new1155z00_2628; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1156z00_2627))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1156z00_2627))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_funz00_2625)),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1156z00_2627))->BgL_argsz00)=((obj_t)BgL_argsz00_2626),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1156z00_2627))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf3zf3_72),BUNSPEC); 
BgL_auxz00_5114 = BgL_new1156z00_2627; } } 
return 
((obj_t)BgL_auxz00_5114);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5127;
{ 
obj_t BgL_argsz00_5129;obj_t BgL_fz00_5128;
BgL_fz00_5128 = BgL_carzd2303zd2_1556; 
BgL_argsz00_5129 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5129; 
BgL_fz00_1535 = BgL_fz00_5128; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5127);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd21010zd2_1567;
BgL_carzd21010zd2_1567 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd21010zd2_1567))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd21010zd2_1567, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5137;
{ 
obj_t BgL_argsz00_5139;obj_t BgL_funz00_5138;
BgL_funz00_5138 = BgL_carzd21010zd2_1567; 
BgL_argsz00_5139 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1469 = BgL_argsz00_5139; 
BgL_funz00_1468 = BgL_funz00_5138; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5137);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5141;
{ 
obj_t BgL_argsz00_5143;obj_t BgL_fz00_5142;
BgL_fz00_5142 = BgL_carzd21010zd2_1567; 
BgL_argsz00_5143 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5143; 
BgL_fz00_1535 = BgL_fz00_5142; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5141);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5145;
{ 
obj_t BgL_argsz00_5147;obj_t BgL_fz00_5146;
BgL_fz00_5146 = BgL_carzd21010zd2_1567; 
BgL_argsz00_5147 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5147; 
BgL_fz00_1535 = BgL_fz00_5146; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5145);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd21717zd2_1577;
BgL_carzd21717zd2_1577 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd21717zd2_1577))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd21717zd2_1577, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5155;
{ 
obj_t BgL_argsz00_5157;obj_t BgL_funz00_5156;
BgL_funz00_5156 = BgL_carzd21717zd2_1577; 
BgL_argsz00_5157 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1469 = BgL_argsz00_5157; 
BgL_funz00_1468 = BgL_funz00_5156; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5155);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5159;
{ 
obj_t BgL_argsz00_5161;obj_t BgL_fz00_5160;
BgL_fz00_5160 = BgL_carzd21717zd2_1577; 
BgL_argsz00_5161 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5161; 
BgL_fz00_1535 = BgL_fz00_5160; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5159);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5163;
{ 
obj_t BgL_argsz00_5165;obj_t BgL_fz00_5164;
BgL_fz00_5164 = BgL_carzd21717zd2_1577; 
BgL_argsz00_5165 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5165; 
BgL_fz00_1535 = BgL_fz00_5164; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5163);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd22424zd2_1587;
BgL_carzd22424zd2_1587 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd22424zd2_1587))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd22424zd2_1587, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5173;
{ 
obj_t BgL_argsz00_5175;obj_t BgL_funz00_5174;
BgL_funz00_5174 = BgL_carzd22424zd2_1587; 
BgL_argsz00_5175 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1469 = BgL_argsz00_5175; 
BgL_funz00_1468 = BgL_funz00_5174; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5173);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5177;
{ 
obj_t BgL_argsz00_5179;obj_t BgL_fz00_5178;
BgL_fz00_5178 = BgL_carzd22424zd2_1587; 
BgL_argsz00_5179 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5179; 
BgL_fz00_1535 = BgL_fz00_5178; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5177);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5181;
{ 
obj_t BgL_argsz00_5183;obj_t BgL_fz00_5182;
BgL_fz00_5182 = BgL_carzd22424zd2_1587; 
BgL_argsz00_5183 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5183; 
BgL_fz00_1535 = BgL_fz00_5182; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5181);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd23131zd2_1597;
BgL_carzd23131zd2_1597 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd23131zd2_1597))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd23131zd2_1597, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5191;
{ 
obj_t BgL_argsz00_5193;obj_t BgL_funz00_5192;
BgL_funz00_5192 = BgL_carzd23131zd2_1597; 
BgL_argsz00_5193 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1469 = BgL_argsz00_5193; 
BgL_funz00_1468 = BgL_funz00_5192; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5191);}  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5195;
{ 
obj_t BgL_argsz00_5197;obj_t BgL_fz00_5196;
BgL_fz00_5196 = BgL_carzd23131zd2_1597; 
BgL_argsz00_5197 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5197; 
BgL_fz00_1535 = BgL_fz00_5196; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5195);} }  else 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5199;
{ 
obj_t BgL_argsz00_5201;obj_t BgL_fz00_5200;
BgL_fz00_5200 = BgL_carzd23131zd2_1597; 
BgL_argsz00_5201 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1536 = BgL_argsz00_5201; 
BgL_fz00_1535 = BgL_fz00_5200; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5199);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3092z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
BgL_lz00_1466 = BgL_cdrzd2250zd2_1544; 
{ /* Eval/evaluate.scm 442 */
bool_t BgL_test3274z00_5206;
if(
PAIRP(BgL_lz00_1466))
{ /* Eval/evaluate.scm 442 */
bool_t BgL_test3276z00_5209;
{ /* Eval/evaluate.scm 442 */
obj_t BgL_tmpz00_5210;
BgL_tmpz00_5210 = 
CDR(BgL_lz00_1466); 
BgL_test3276z00_5209 = 
PAIRP(BgL_tmpz00_5210); } 
if(BgL_test3276z00_5209)
{ 
obj_t BgL_l1205z00_2350;
BgL_l1205z00_2350 = BgL_lz00_1466; 
BgL_zc3z04anonymousza32211ze3z87_2351:
if(
NULLP(BgL_l1205z00_2350))
{ /* Eval/evaluate.scm 442 */
BgL_test3274z00_5206 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate.scm 442 */
bool_t BgL_test3278z00_5215;
{ /* Eval/evaluate.scm 442 */
obj_t BgL_tmpz00_5216;
BgL_tmpz00_5216 = 
CAR(
((obj_t)BgL_l1205z00_2350)); 
BgL_test3278z00_5215 = 
SYMBOLP(BgL_tmpz00_5216); } 
if(BgL_test3278z00_5215)
{ 
obj_t BgL_l1205z00_5220;
BgL_l1205z00_5220 = 
CDR(
((obj_t)BgL_l1205z00_2350)); 
BgL_l1205z00_2350 = BgL_l1205z00_5220; 
goto BgL_zc3z04anonymousza32211ze3z87_2351;}  else 
{ /* Eval/evaluate.scm 442 */
BgL_test3274z00_5206 = ((bool_t)0)
; } } }  else 
{ /* Eval/evaluate.scm 442 */
BgL_test3274z00_5206 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate.scm 442 */
BgL_test3274z00_5206 = ((bool_t)0)
; } 
if(BgL_test3274z00_5206)
{ /* Eval/evaluate.scm 442 */
return 
BGl_convzd2fieldzd2refz00zz__evaluatez00(BgL_ez00_69, BgL_localsz00_70, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, BgL_topzf3zf3_75);}  else 
{ /* Eval/evaluate.scm 442 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74, BGl_string3003z00zz__evaluatez00, BGl_string3082z00zz__evaluatez00, BgL_ez00_69);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd23841zd2_1610;
BgL_carzd23841zd2_1610 = 
CAR(BgL_ez00_69); 
if(
SYMBOLP(BgL_carzd23841zd2_1610))
{ /* Eval/evaluate.scm 424 */
if(
CBOOL(
BGl_convzd2varzd2zz__evaluatez00(BgL_carzd23841zd2_1610, BgL_localsz00_70)))
{ 
BgL_ev_appz00_bglt BgL_auxz00_5231;
{ 
obj_t BgL_argsz00_5233;obj_t BgL_funz00_5232;
BgL_funz00_5232 = BgL_carzd23841zd2_1610; 
BgL_argsz00_5233 = BgL_cdrzd2250zd2_1544; 
BgL_argsz00_1469 = BgL_argsz00_5233; 
BgL_funz00_1468 = BgL_funz00_5232; 
goto BgL_tagzd2152zd2_1470;} 
return 
((obj_t)BgL_auxz00_5231);}  else 
{ /* Eval/evaluate.scm 424 */
if(
(BgL_carzd23841zd2_1610==BGl_symbol3094z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd2250zd2_1544))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd2250zd2_1544)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1603z00_1621;
BgL_arg1603z00_1621 = 
CAR(BgL_cdrzd2250zd2_1544); 
{ 
BgL_ev_trapz00_bglt BgL_auxz00_5243;
BgL_ez00_1471 = BgL_arg1603z00_1621; 
BgL_tagzd2153zd2_1472:
{ /* Eval/evaluate.scm 456 */
BgL_ev_trapz00_bglt BgL_new1110z00_2364;
{ /* Eval/evaluate.scm 457 */
BgL_ev_trapz00_bglt BgL_new1109z00_2365;
BgL_new1109z00_2365 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate.scm 457 */
long BgL_arg2216z00_2366;
{ /* Eval/evaluate.scm 457 */
long BgL_res2741z00_3364;
BgL_res2741z00_3364 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BgL_arg2216z00_2366 = BgL_res2741z00_3364; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1109z00_2365), BgL_arg2216z00_2366); } 
BgL_new1110z00_2364 = BgL_new1109z00_2365; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1110z00_2364)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_1471))),BUNSPEC); 
BgL_auxz00_5243 = BgL_new1110z00_2364; } 
return 
((obj_t)BgL_auxz00_5243);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1604z00_1622;obj_t BgL_arg1606z00_1623;
BgL_arg1604z00_1622 = 
CAR(BgL_ez00_69); 
BgL_arg1606z00_1623 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5255;
{ 
obj_t BgL_argsz00_5257;obj_t BgL_fz00_5256;
BgL_fz00_5256 = BgL_arg1604z00_1622; 
BgL_argsz00_5257 = BgL_arg1606z00_1623; 
BgL_argsz00_1536 = BgL_argsz00_5257; 
BgL_fz00_1535 = BgL_fz00_5256; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5255);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1608z00_1625;obj_t BgL_arg1609z00_1626;
BgL_arg1608z00_1625 = 
CAR(BgL_ez00_69); 
BgL_arg1609z00_1626 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5261;
{ 
obj_t BgL_argsz00_5263;obj_t BgL_fz00_5262;
BgL_fz00_5262 = BgL_arg1608z00_1625; 
BgL_argsz00_5263 = BgL_arg1609z00_1626; 
BgL_argsz00_1536 = BgL_argsz00_5263; 
BgL_fz00_1535 = BgL_fz00_5262; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5261);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd24514zd2_1627;
BgL_cdrzd24514zd2_1627 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3055z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd24514zd2_1627))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd24514zd2_1627)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1617z00_1633;
BgL_arg1617z00_1633 = 
CAR(BgL_cdrzd24514zd2_1627); 
{ 
BgL_ev_littz00_bglt BgL_auxz00_5275;
BgL_vz00_1473 = BgL_arg1617z00_1633; 
BgL_tagzd2154zd2_1474:
{ /* Eval/evaluate.scm 459 */
BgL_ev_littz00_bglt BgL_new1112z00_2367;
{ /* Eval/evaluate.scm 460 */
BgL_ev_littz00_bglt BgL_new1111z00_2368;
BgL_new1111z00_2368 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 460 */
long BgL_arg2217z00_2369;
{ /* Eval/evaluate.scm 460 */
long BgL_res2742z00_3368;
BgL_res2742z00_3368 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg2217z00_2369 = BgL_res2742z00_3368; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1111z00_2368), BgL_arg2217z00_2369); } 
BgL_new1112z00_2367 = BgL_new1111z00_2368; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1112z00_2367))->BgL_valuez00)=((obj_t)BgL_vz00_1473),BUNSPEC); 
BgL_auxz00_5275 = BgL_new1112z00_2367; } 
return 
((obj_t)BgL_auxz00_5275);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1619z00_1634;
BgL_arg1619z00_1634 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5283;
{ 
obj_t BgL_argsz00_5285;obj_t BgL_fz00_5284;
BgL_fz00_5284 = BgL_arg1619z00_1634; 
BgL_argsz00_5285 = BgL_cdrzd24514zd2_1627; 
BgL_argsz00_1536 = BgL_argsz00_5285; 
BgL_fz00_1535 = BgL_fz00_5284; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5283);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1622z00_1637;
BgL_arg1622z00_1637 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5288;
{ 
obj_t BgL_argsz00_5290;obj_t BgL_fz00_5289;
BgL_fz00_5289 = BgL_arg1622z00_1637; 
BgL_argsz00_5290 = BgL_cdrzd24514zd2_1627; 
BgL_argsz00_1536 = BgL_argsz00_5290; 
BgL_fz00_1535 = BgL_fz00_5289; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5288);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3063z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd24514zd2_1627))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd25128zd2_1643;
BgL_cdrzd25128zd2_1643 = 
CDR(BgL_cdrzd24514zd2_1627); 
if(
PAIRP(BgL_cdrzd25128zd2_1643))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd25133zd2_1645;
BgL_cdrzd25133zd2_1645 = 
CDR(BgL_cdrzd25128zd2_1643); 
if(
PAIRP(BgL_cdrzd25133zd2_1645))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd25133zd2_1645)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1631z00_1649;obj_t BgL_arg1632z00_1650;obj_t BgL_arg1633z00_1651;
BgL_arg1631z00_1649 = 
CAR(BgL_cdrzd24514zd2_1627); 
BgL_arg1632z00_1650 = 
CAR(BgL_cdrzd25128zd2_1643); 
BgL_arg1633z00_1651 = 
CAR(BgL_cdrzd25133zd2_1645); 
{ 
BgL_ev_ifz00_bglt BgL_auxz00_5309;
BgL_pz00_1475 = BgL_arg1631z00_1649; 
BgL_tz00_1476 = BgL_arg1632z00_1650; 
BgL_oz00_1477 = BgL_arg1633z00_1651; 
BgL_tagzd2155zd2_1478:
{ /* Eval/evaluate.scm 462 */
BgL_ev_ifz00_bglt BgL_new1114z00_2370;
{ /* Eval/evaluate.scm 463 */
BgL_ev_ifz00_bglt BgL_new1113z00_2374;
BgL_new1113z00_2374 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate.scm 463 */
long BgL_arg2221z00_2375;
{ /* Eval/evaluate.scm 463 */
long BgL_res2743z00_3372;
BgL_res2743z00_3372 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg2221z00_2375 = BgL_res2743z00_3372; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1113z00_2374), BgL_arg2221z00_2375); } 
BgL_new1114z00_2370 = BgL_new1113z00_2374; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5314;
{ /* Eval/evaluate.scm 463 */
obj_t BgL_arg2218z00_2371;
BgL_arg2218z00_2371 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_pz00_1475, BgL_locz00_74); 
BgL_auxz00_5314 = 
((BgL_ev_exprz00_bglt)
BGl_uconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_pz00_1475, BgL_arg2218z00_2371)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1114z00_2370))->BgL_pz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5314),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5319;
{ /* Eval/evaluate.scm 464 */
obj_t BgL_arg2219z00_2372;
BgL_arg2219z00_2372 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_tz00_1476, BgL_locz00_74); 
BgL_auxz00_5319 = 
((BgL_ev_exprz00_bglt)
BGl_rconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_tailzf3zf3_72, BgL_globalsz00_71, BgL_localsz00_70, BgL_tz00_1476, BgL_arg2219z00_2372)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1114z00_2370))->BgL_tz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5319),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5324;
{ /* Eval/evaluate.scm 465 */
obj_t BgL_arg2220z00_2373;
BgL_arg2220z00_2373 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_oz00_1477, BgL_locz00_74); 
BgL_auxz00_5324 = 
((BgL_ev_exprz00_bglt)
BGl_rconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_tailzf3zf3_72, BgL_globalsz00_71, BgL_localsz00_70, BgL_oz00_1477, BgL_arg2220z00_2373)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1114z00_2370))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5324),BUNSPEC); } 
BgL_auxz00_5309 = BgL_new1114z00_2370; } 
return 
((obj_t)BgL_auxz00_5309);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1634z00_1652;obj_t BgL_arg1635z00_1653;
BgL_arg1634z00_1652 = 
CAR(BgL_ez00_69); 
BgL_arg1635z00_1653 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5332;
{ 
obj_t BgL_argsz00_5334;obj_t BgL_fz00_5333;
BgL_fz00_5333 = BgL_arg1634z00_1652; 
BgL_argsz00_5334 = BgL_arg1635z00_1653; 
BgL_argsz00_1536 = BgL_argsz00_5334; 
BgL_fz00_1535 = BgL_fz00_5333; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5332);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd25433zd2_1655;
BgL_cdrzd25433zd2_1655 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd25439zd2_1656;
BgL_cdrzd25439zd2_1656 = 
CDR(
((obj_t)BgL_cdrzd25433zd2_1655)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd25439zd2_1656))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1639z00_1659;obj_t BgL_arg1640z00_1660;
BgL_arg1639z00_1659 = 
CAR(
((obj_t)BgL_cdrzd25433zd2_1655)); 
BgL_arg1640z00_1660 = 
CAR(
((obj_t)BgL_cdrzd25439zd2_1656)); 
{ 
BgL_ev_ifz00_bglt BgL_auxz00_5347;
BgL_pz00_1479 = BgL_arg1639z00_1659; 
BgL_tz00_1480 = BgL_arg1640z00_1660; 
BgL_tagzd2156zd2_1481:
{ /* Eval/evaluate.scm 467 */
BgL_ev_ifz00_bglt BgL_new1116z00_2376;
{ /* Eval/evaluate.scm 468 */
BgL_ev_ifz00_bglt BgL_new1115z00_2380;
BgL_new1115z00_2380 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate.scm 468 */
long BgL_arg2225z00_2381;
{ /* Eval/evaluate.scm 468 */
long BgL_res2744z00_3376;
BgL_res2744z00_3376 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg2225z00_2381 = BgL_res2744z00_3376; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1115z00_2380), BgL_arg2225z00_2381); } 
BgL_new1116z00_2376 = BgL_new1115z00_2380; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5352;
{ /* Eval/evaluate.scm 468 */
obj_t BgL_arg2222z00_2377;
BgL_arg2222z00_2377 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_pz00_1479, BgL_locz00_74); 
BgL_auxz00_5352 = 
((BgL_ev_exprz00_bglt)
BGl_uconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_pz00_1479, BgL_arg2222z00_2377)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1116z00_2376))->BgL_pz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5352),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5357;
{ /* Eval/evaluate.scm 469 */
obj_t BgL_arg2223z00_2378;
BgL_arg2223z00_2378 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_tz00_1480, BgL_locz00_74); 
BgL_auxz00_5357 = 
((BgL_ev_exprz00_bglt)
BGl_rconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_tailzf3zf3_72, BgL_globalsz00_71, BgL_localsz00_70, BgL_tz00_1480, BgL_arg2223z00_2378)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1116z00_2376))->BgL_tz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5357),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5362;
{ /* Eval/evaluate.scm 470 */
obj_t BgL_arg2224z00_2379;
BgL_arg2224z00_2379 = 
BGl_getzd2locationzd2zz__evaluatez00(BFALSE, BgL_locz00_74); 
BgL_auxz00_5362 = 
((BgL_ev_exprz00_bglt)
BGl_rconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_tailzf3zf3_72, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_69, BgL_arg2224z00_2379)); } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1116z00_2376))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5362),BUNSPEC); } 
BgL_auxz00_5347 = BgL_new1116z00_2376; } 
return 
((obj_t)BgL_auxz00_5347);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1641z00_1661;
BgL_arg1641z00_1661 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5369;
{ 
obj_t BgL_argsz00_5371;obj_t BgL_fz00_5370;
BgL_fz00_5370 = BgL_arg1641z00_1661; 
BgL_argsz00_5371 = BgL_cdrzd25433zd2_1655; 
BgL_argsz00_1536 = BgL_argsz00_5371; 
BgL_fz00_1535 = BgL_fz00_5370; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5369);} } } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1644z00_1664;obj_t BgL_arg1645z00_1665;
BgL_arg1644z00_1664 = 
CAR(BgL_ez00_69); 
BgL_arg1645z00_1665 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5375;
{ 
obj_t BgL_argsz00_5377;obj_t BgL_fz00_5376;
BgL_fz00_5376 = BgL_arg1644z00_1664; 
BgL_argsz00_5377 = BgL_arg1645z00_1665; 
BgL_argsz00_1536 = BgL_argsz00_5377; 
BgL_fz00_1535 = BgL_fz00_5376; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5375);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1647z00_1666;obj_t BgL_arg1648z00_1667;
BgL_arg1647z00_1666 = 
CAR(BgL_ez00_69); 
BgL_arg1648z00_1667 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5381;
{ 
obj_t BgL_argsz00_5383;obj_t BgL_fz00_5382;
BgL_fz00_5382 = BgL_arg1647z00_1666; 
BgL_argsz00_5383 = BgL_arg1648z00_1667; 
BgL_argsz00_1536 = BgL_argsz00_5383; 
BgL_fz00_1535 = BgL_fz00_5382; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5381);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3096z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1652z00_1670;
BgL_arg1652z00_1670 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_orz00_bglt BgL_auxz00_5389;
BgL_argsz00_1482 = BgL_arg1652z00_1670; 
BgL_tagzd2157zd2_1483:
{ /* Eval/evaluate.scm 472 */
BgL_ev_orz00_bglt BgL_new1118z00_2382;
{ /* Eval/evaluate.scm 473 */
BgL_ev_orz00_bglt BgL_new1117z00_2383;
BgL_new1117z00_2383 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate.scm 473 */
long BgL_arg2226z00_2384;
{ /* Eval/evaluate.scm 473 */
long BgL_res2745z00_3380;
BgL_res2745z00_3380 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BgL_arg2226z00_2384 = BgL_res2745z00_3380; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1117z00_2383), BgL_arg2226z00_2384); } 
BgL_new1118z00_2382 = BgL_new1117z00_2383; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1118z00_2382)))->BgL_argsz00)=((obj_t)
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_locz00_74, BgL_argsz00_1482)),BUNSPEC); 
BgL_auxz00_5389 = BgL_new1118z00_2382; } 
return 
((obj_t)BgL_auxz00_5389);} }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3098z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1655z00_1673;
BgL_arg1655z00_1673 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_andz00_bglt BgL_auxz00_5402;
BgL_argsz00_1484 = BgL_arg1655z00_1673; 
BgL_tagzd2158zd2_1485:
{ /* Eval/evaluate.scm 475 */
BgL_ev_andz00_bglt BgL_new1120z00_2385;
{ /* Eval/evaluate.scm 476 */
BgL_ev_andz00_bglt BgL_new1119z00_2386;
BgL_new1119z00_2386 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate.scm 476 */
long BgL_arg2227z00_2387;
{ /* Eval/evaluate.scm 476 */
long BgL_res2746z00_3384;
BgL_res2746z00_3384 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BgL_arg2227z00_2387 = BgL_res2746z00_3384; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1119z00_2386), BgL_arg2227z00_2387); } 
BgL_new1120z00_2385 = BgL_new1119z00_2386; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1120z00_2385)))->BgL_argsz00)=((obj_t)
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_locz00_74, BgL_argsz00_1484)),BUNSPEC); 
BgL_auxz00_5402 = BgL_new1120z00_2385; } 
return 
((obj_t)BgL_auxz00_5402);} }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3083z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
BgL_lz00_1486 = 
CDR(BgL_ez00_69); 
BgL_tagzd2159zd2_1487:
return 
BGl_convzd2beginzd2zz__evaluatez00(BgL_lz00_1486, BgL_localsz00_70, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, BgL_topzf3zf3_75);}  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd26338zd2_1677;
BgL_cdrzd26338zd2_1677 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3065z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26338zd2_1677))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1663z00_1681;obj_t BgL_arg1664z00_1682;
BgL_arg1663z00_1681 = 
CAR(BgL_cdrzd26338zd2_1677); 
BgL_arg1664z00_1682 = 
CDR(BgL_cdrzd26338zd2_1677); 
{ 
BgL_ev_letz00_bglt BgL_auxz00_5424;
BgL_bindsz00_1488 = BgL_arg1663z00_1681; 
BgL_bodyz00_1489 = BgL_arg1664z00_1682; 
BgL_tagzd2160zd2_1490:
{ /* Eval/evaluate.scm 480 */
obj_t BgL_ubindsz00_2388;
if(
NULLP(BgL_bindsz00_1488))
{ /* Eval/evaluate.scm 480 */
BgL_ubindsz00_2388 = BNIL; }  else 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_head1210z00_2433;
{ /* Eval/evaluate.scm 480 */
obj_t BgL_res2748z00_3388;
BgL_res2748z00_3388 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1210z00_2433 = BgL_res2748z00_3388; } 
{ 
obj_t BgL_l1208z00_2435;obj_t BgL_tail1211z00_2436;
BgL_l1208z00_2435 = BgL_bindsz00_1488; 
BgL_tail1211z00_2436 = BgL_head1210z00_2433; 
BgL_zc3z04anonymousza32246ze3z87_2437:
if(
NULLP(BgL_l1208z00_2435))
{ /* Eval/evaluate.scm 480 */
BgL_ubindsz00_2388 = 
CDR(BgL_head1210z00_2433); }  else 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_newtail1212z00_2439;
{ /* Eval/evaluate.scm 480 */
obj_t BgL_arg2249z00_2441;
{ /* Eval/evaluate.scm 480 */
obj_t BgL_bz00_2442;
BgL_bz00_2442 = 
CAR(
((obj_t)BgL_l1208z00_2435)); 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_arg2250z00_2443;
BgL_arg2250z00_2443 = 
CAR(
((obj_t)BgL_bz00_2442)); 
BgL_arg2249z00_2441 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_arg2250z00_2443); } } 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_res2750z00_3393;
BgL_res2750z00_3393 = 
MAKE_YOUNG_PAIR(BgL_arg2249z00_2441, BNIL); 
BgL_newtail1212z00_2439 = BgL_res2750z00_3393; } } 
SET_CDR(BgL_tail1211z00_2436, BgL_newtail1212z00_2439); 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_arg2248z00_2440;
BgL_arg2248z00_2440 = 
CDR(
((obj_t)BgL_l1208z00_2435)); 
{ 
obj_t BgL_tail1211z00_5441;obj_t BgL_l1208z00_5440;
BgL_l1208z00_5440 = BgL_arg2248z00_2440; 
BgL_tail1211z00_5441 = BgL_newtail1212z00_2439; 
BgL_tail1211z00_2436 = BgL_tail1211z00_5441; 
BgL_l1208z00_2435 = BgL_l1208z00_5440; 
goto BgL_zc3z04anonymousza32246ze3z87_2437;} } } } } 
{ /* Eval/evaluate.scm 480 */
obj_t BgL_varsz00_2389;
if(
NULLP(BgL_ubindsz00_2388))
{ /* Eval/evaluate.scm 481 */
BgL_varsz00_2389 = BNIL; }  else 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_head1215z00_2417;
{ /* Eval/evaluate.scm 481 */
obj_t BgL_res2752z00_3397;
BgL_res2752z00_3397 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1215z00_2417 = BgL_res2752z00_3397; } 
{ 
obj_t BgL_l1213z00_2419;obj_t BgL_tail1216z00_2420;
BgL_l1213z00_2419 = BgL_ubindsz00_2388; 
BgL_tail1216z00_2420 = BgL_head1215z00_2417; 
BgL_zc3z04anonymousza32240ze3z87_2421:
if(
NULLP(BgL_l1213z00_2419))
{ /* Eval/evaluate.scm 481 */
BgL_varsz00_2389 = 
CDR(BgL_head1215z00_2417); }  else 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_newtail1217z00_2423;
{ /* Eval/evaluate.scm 481 */
BgL_ev_varz00_bglt BgL_arg2243z00_2425;
{ /* Eval/evaluate.scm 481 */
obj_t BgL_iz00_2426;
BgL_iz00_2426 = 
CAR(
((obj_t)BgL_l1213z00_2419)); 
{ /* Eval/evaluate.scm 482 */
BgL_ev_varz00_bglt BgL_new1122z00_2427;
{ /* Eval/evaluate.scm 484 */
BgL_ev_varz00_bglt BgL_new1121z00_2428;
BgL_new1121z00_2428 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 484 */
long BgL_arg2244z00_2429;
{ /* Eval/evaluate.scm 484 */
long BgL_res2754z00_3402;
BgL_res2754z00_3402 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2244z00_2429 = BgL_res2754z00_3402; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1121z00_2428), BgL_arg2244z00_2429); } 
BgL_new1122z00_2427 = BgL_new1121z00_2428; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1122z00_2427))->BgL_namez00)=((obj_t)
CAR(
((obj_t)BgL_iz00_2426))),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1122z00_2427))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1122z00_2427))->BgL_typez00)=((obj_t)
CDR(
((obj_t)BgL_iz00_2426))),BUNSPEC); 
BgL_arg2243z00_2425 = BgL_new1122z00_2427; } } 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_res2755z00_3407;
BgL_res2755z00_3407 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2243z00_2425), BNIL); 
BgL_newtail1217z00_2423 = BgL_res2755z00_3407; } } 
SET_CDR(BgL_tail1216z00_2420, BgL_newtail1217z00_2423); 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_arg2242z00_2424;
BgL_arg2242z00_2424 = 
CDR(
((obj_t)BgL_l1213z00_2419)); 
{ 
obj_t BgL_tail1216z00_5467;obj_t BgL_l1213z00_5466;
BgL_l1213z00_5466 = BgL_arg2242z00_2424; 
BgL_tail1216z00_5467 = BgL_newtail1217z00_2423; 
BgL_tail1216z00_2420 = BgL_tail1216z00_5467; 
BgL_l1213z00_2419 = BgL_l1213z00_5466; 
goto BgL_zc3z04anonymousza32240ze3z87_2421;} } } } } 
{ /* Eval/evaluate.scm 481 */
obj_t BgL_bodyz00_2390;
{ /* Eval/evaluate.scm 486 */
bool_t BgL_test3302z00_5468;
{ /* Eval/evaluate.scm 486 */
obj_t BgL_tmpz00_5469;
BgL_tmpz00_5469 = 
CDR(
((obj_t)BgL_bodyz00_1489)); 
BgL_test3302z00_5468 = 
PAIRP(BgL_tmpz00_5469); } 
if(BgL_test3302z00_5468)
{ /* Eval/evaluate.scm 486 */
obj_t BgL_res2757z00_3413;
BgL_res2757z00_3413 = 
MAKE_YOUNG_EPAIR(BGl_symbol3083z00zz__evaluatez00, BgL_bodyz00_1489, BgL_locz00_74); 
BgL_bodyz00_2390 = BgL_res2757z00_3413; }  else 
{ /* Eval/evaluate.scm 486 */
BgL_bodyz00_2390 = 
CAR(
((obj_t)BgL_bodyz00_1489)); } } 
{ /* Eval/evaluate.scm 486 */
obj_t BgL_tbodyz00_2391;
BgL_tbodyz00_2391 = 
BGl_typezd2checkszd2zz__evaluatez00(BgL_ubindsz00_2388, BgL_bindsz00_1488, BgL_bodyz00_2390, BgL_locz00_74, BgL_wherez00_73); 
{ /* Eval/evaluate.scm 487 */

{ /* Eval/evaluate.scm 488 */
obj_t BgL_blocz00_2392;
BgL_blocz00_2392 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bindsz00_1488, BgL_locz00_74); 
{ /* Eval/evaluate.scm 489 */
BgL_ev_letz00_bglt BgL_new1124z00_2393;
{ /* Eval/evaluate.scm 490 */
BgL_ev_letz00_bglt BgL_new1123z00_2410;
BgL_new1123z00_2410 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate.scm 490 */
long BgL_arg2235z00_2411;
{ /* Eval/evaluate.scm 490 */
long BgL_res2758z00_3416;
BgL_res2758z00_3416 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BgL_arg2235z00_2411 = BgL_res2758z00_3416; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1123z00_2410), BgL_arg2235z00_2411); } 
BgL_new1124z00_2393 = BgL_new1123z00_2410; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1124z00_2393)))->BgL_varsz00)=((obj_t)BgL_varsz00_2389),BUNSPEC); 
{ 
obj_t BgL_auxz00_5484;
if(
NULLP(BgL_bindsz00_1488))
{ /* Eval/evaluate.scm 491 */
BgL_auxz00_5484 = BNIL
; }  else 
{ /* Eval/evaluate.scm 491 */
obj_t BgL_head1220z00_2396;
{ /* Eval/evaluate.scm 491 */
obj_t BgL_res2760z00_3420;
BgL_res2760z00_3420 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1220z00_2396 = BgL_res2760z00_3420; } 
{ 
obj_t BgL_l1218z00_2398;obj_t BgL_tail1221z00_2399;
BgL_l1218z00_2398 = BgL_bindsz00_1488; 
BgL_tail1221z00_2399 = BgL_head1220z00_2396; 
BgL_zc3z04anonymousza32229ze3z87_2400:
if(
NULLP(BgL_l1218z00_2398))
{ /* Eval/evaluate.scm 491 */
BgL_auxz00_5484 = 
CDR(BgL_head1220z00_2396)
; }  else 
{ /* Eval/evaluate.scm 491 */
obj_t BgL_newtail1222z00_2402;
{ /* Eval/evaluate.scm 491 */
obj_t BgL_arg2232z00_2404;
{ /* Eval/evaluate.scm 491 */
obj_t BgL_bz00_2405;
BgL_bz00_2405 = 
CAR(
((obj_t)BgL_l1218z00_2398)); 
{ /* Eval/evaluate.scm 492 */
obj_t BgL_locz00_2406;
BgL_locz00_2406 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bz00_2405, BgL_blocz00_2392); 
{ /* Eval/evaluate.scm 493 */
obj_t BgL_arg2233z00_2407;
{ /* Eval/evaluate.scm 493 */
obj_t BgL_pairz00_3427;
BgL_pairz00_3427 = 
CDR(
((obj_t)BgL_bz00_2405)); 
BgL_arg2233z00_2407 = 
CAR(BgL_pairz00_3427); } 
BgL_arg2232z00_2404 = 
BGl_uconvzf2locze70z15zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_arg2233z00_2407, BgL_locz00_2406); } } } 
{ /* Eval/evaluate.scm 491 */
obj_t BgL_res2762z00_3428;
BgL_res2762z00_3428 = 
MAKE_YOUNG_PAIR(BgL_arg2232z00_2404, BNIL); 
BgL_newtail1222z00_2402 = BgL_res2762z00_3428; } } 
SET_CDR(BgL_tail1221z00_2399, BgL_newtail1222z00_2402); 
{ /* Eval/evaluate.scm 491 */
obj_t BgL_arg2231z00_2403;
BgL_arg2231z00_2403 = 
CDR(
((obj_t)BgL_l1218z00_2398)); 
{ 
obj_t BgL_tail1221z00_5504;obj_t BgL_l1218z00_5503;
BgL_l1218z00_5503 = BgL_arg2231z00_2403; 
BgL_tail1221z00_5504 = BgL_newtail1222z00_2402; 
BgL_tail1221z00_2399 = BgL_tail1221z00_5504; 
BgL_l1218z00_2398 = BgL_l1218z00_5503; 
goto BgL_zc3z04anonymousza32229ze3z87_2400;} } } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1124z00_2393)))->BgL_valsz00)=((obj_t)BgL_auxz00_5484),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5506;
{ /* Eval/evaluate.scm 495 */
obj_t BgL_arg2234z00_2409;
BgL_arg2234z00_2409 = 
BGl_appendzd221009zd2zz__evaluatez00(BgL_varsz00_2389, BgL_localsz00_70); 
BgL_auxz00_5506 = 
((BgL_ev_exprz00_bglt)
BGl_convz00zz__evaluatez00(BgL_tbodyz00_2391, BgL_arg2234z00_2409, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0))); } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1124z00_2393)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5506),BUNSPEC); } 
((((BgL_ev_letz00_bglt)COBJECT(BgL_new1124z00_2393))->BgL_boxesz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_5424 = BgL_new1124z00_2393; } } } } } } } 
return 
((obj_t)BgL_auxz00_5424);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1667z00_1683;
BgL_arg1667z00_1683 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5515;
{ 
obj_t BgL_argsz00_5517;obj_t BgL_fz00_5516;
BgL_fz00_5516 = BgL_arg1667z00_1683; 
BgL_argsz00_5517 = BgL_cdrzd26338zd2_1677; 
BgL_argsz00_1536 = BgL_argsz00_5517; 
BgL_fz00_1535 = BgL_fz00_5516; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5515);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3100z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26338zd2_1677))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1672z00_1689;obj_t BgL_arg1675z00_1690;
BgL_arg1672z00_1689 = 
CAR(BgL_cdrzd26338zd2_1677); 
BgL_arg1675z00_1690 = 
CDR(BgL_cdrzd26338zd2_1677); 
{ 
BgL_ev_letza2za2_bglt BgL_auxz00_5526;
BgL_bindsz00_1491 = BgL_arg1672z00_1689; 
BgL_bodyz00_1492 = BgL_arg1675z00_1690; 
BgL_tagzd2161zd2_1493:
{ /* Eval/evaluate.scm 503 */
obj_t BgL_varsz00_2446;obj_t BgL_blocz00_2447;
if(
NULLP(BgL_bindsz00_1491))
{ /* Eval/evaluate.scm 503 */
BgL_varsz00_2446 = BNIL; }  else 
{ /* Eval/evaluate.scm 503 */
obj_t BgL_head1225z00_2455;
{ /* Eval/evaluate.scm 503 */
obj_t BgL_res2765z00_3443;
BgL_res2765z00_3443 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1225z00_2455 = BgL_res2765z00_3443; } 
{ 
obj_t BgL_l1223z00_2457;obj_t BgL_tail1226z00_2458;
BgL_l1223z00_2457 = BgL_bindsz00_1491; 
BgL_tail1226z00_2458 = BgL_head1225z00_2455; 
BgL_zc3z04anonymousza32255ze3z87_2459:
if(
NULLP(BgL_l1223z00_2457))
{ /* Eval/evaluate.scm 503 */
BgL_varsz00_2446 = 
CDR(BgL_head1225z00_2455); }  else 
{ /* Eval/evaluate.scm 503 */
obj_t BgL_newtail1227z00_2461;
{ /* Eval/evaluate.scm 503 */
BgL_ev_varz00_bglt BgL_arg2258z00_2463;
{ /* Eval/evaluate.scm 503 */
obj_t BgL_bz00_2464;
BgL_bz00_2464 = 
CAR(
((obj_t)BgL_l1223z00_2457)); 
{ /* Eval/evaluate.scm 504 */
obj_t BgL_iz00_2465;
{ /* Eval/evaluate.scm 504 */
obj_t BgL_arg2260z00_2469;
BgL_arg2260z00_2469 = 
CAR(
((obj_t)BgL_bz00_2464)); 
BgL_iz00_2465 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_arg2260z00_2469); } 
{ /* Eval/evaluate.scm 505 */
BgL_ev_varz00_bglt BgL_new1126z00_2466;
{ /* Eval/evaluate.scm 507 */
BgL_ev_varz00_bglt BgL_new1125z00_2467;
BgL_new1125z00_2467 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 507 */
long BgL_arg2259z00_2468;
{ /* Eval/evaluate.scm 507 */
long BgL_res2767z00_3449;
BgL_res2767z00_3449 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2259z00_2468 = BgL_res2767z00_3449; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1125z00_2467), BgL_arg2259z00_2468); } 
BgL_new1126z00_2466 = BgL_new1125z00_2467; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1126z00_2466))->BgL_namez00)=((obj_t)
CAR(BgL_iz00_2465)),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1126z00_2466))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1126z00_2466))->BgL_typez00)=((obj_t)
CDR(BgL_iz00_2465)),BUNSPEC); 
BgL_arg2258z00_2463 = BgL_new1126z00_2466; } } } 
{ /* Eval/evaluate.scm 503 */
obj_t BgL_res2768z00_3454;
BgL_res2768z00_3454 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2258z00_2463), BNIL); 
BgL_newtail1227z00_2461 = BgL_res2768z00_3454; } } 
SET_CDR(BgL_tail1226z00_2458, BgL_newtail1227z00_2461); 
{ /* Eval/evaluate.scm 503 */
obj_t BgL_arg2257z00_2462;
BgL_arg2257z00_2462 = 
CDR(
((obj_t)BgL_l1223z00_2457)); 
{ 
obj_t BgL_tail1226z00_5553;obj_t BgL_l1223z00_5552;
BgL_l1223z00_5552 = BgL_arg2257z00_2462; 
BgL_tail1226z00_5553 = BgL_newtail1227z00_2461; 
BgL_tail1226z00_2458 = BgL_tail1226z00_5553; 
BgL_l1223z00_2457 = BgL_l1223z00_5552; 
goto BgL_zc3z04anonymousza32255ze3z87_2459;} } } } } 
BgL_blocz00_2447 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bindsz00_1491, BgL_locz00_74); 
{ /* Eval/evaluate.scm 510 */
BgL_ev_letza2za2_bglt BgL_new1128z00_2448;
{ /* Eval/evaluate.scm 511 */
BgL_ev_letza2za2_bglt BgL_new1127z00_2451;
BgL_new1127z00_2451 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate.scm 511 */
long BgL_arg2253z00_2452;
{ /* Eval/evaluate.scm 511 */
long BgL_res2769z00_3458;
BgL_res2769z00_3458 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BgL_arg2253z00_2452 = BgL_res2769z00_3458; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1127z00_2451), BgL_arg2253z00_2452); } 
BgL_new1128z00_2448 = BgL_new1127z00_2451; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1128z00_2448)))->BgL_varsz00)=((obj_t)BgL_varsz00_2446),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1128z00_2448)))->BgL_valsz00)=((obj_t)
BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_bindsz00_1491, BgL_varsz00_2446, BgL_localsz00_70, BgL_blocz00_2447)),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5564;
{ /* Eval/evaluate.scm 513 */
obj_t BgL_arg2251z00_2449;
{ /* Eval/evaluate.scm 513 */
obj_t BgL_arg2252z00_2450;
BgL_arg2252z00_2450 = 
bgl_reverse(BgL_varsz00_2446); 
BgL_arg2251z00_2449 = 
BGl_appendzd221009zd2zz__evaluatez00(BgL_arg2252z00_2450, BgL_localsz00_70); } 
BgL_auxz00_5564 = 
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1492, BgL_arg2251z00_2449, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0))); } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1128z00_2448)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5564),BUNSPEC); } 
((((BgL_ev_letza2za2_bglt)COBJECT(BgL_new1128z00_2448))->BgL_boxesz00)=((obj_t)BNIL),BUNSPEC); 
BgL_auxz00_5526 = BgL_new1128z00_2448; } } 
return 
((obj_t)BgL_auxz00_5526);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1677z00_1691;obj_t BgL_arg1678z00_1692;
BgL_arg1677z00_1691 = 
CAR(BgL_ez00_69); 
BgL_arg1678z00_1692 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5575;
{ 
obj_t BgL_argsz00_5577;obj_t BgL_fz00_5576;
BgL_fz00_5576 = BgL_arg1677z00_1691; 
BgL_argsz00_5577 = BgL_arg1678z00_1692; 
BgL_argsz00_1536 = BgL_argsz00_5577; 
BgL_fz00_1535 = BgL_fz00_5576; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5575);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd26736zd2_1693;
BgL_cdrzd26736zd2_1693 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3102z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26736zd2_1693))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1683z00_1697;obj_t BgL_arg1684z00_1698;
BgL_arg1683z00_1697 = 
CAR(BgL_cdrzd26736zd2_1693); 
BgL_arg1684z00_1698 = 
CDR(BgL_cdrzd26736zd2_1693); 
{ 
BgL_ev_letrecz00_bglt BgL_auxz00_5587;
BgL_bindsz00_1494 = BgL_arg1683z00_1697; 
BgL_bodyz00_1495 = BgL_arg1684z00_1698; 
BgL_tagzd2162zd2_1496:
{ /* Eval/evaluate.scm 515 */
obj_t BgL_ubindsz00_2487;
if(
NULLP(BgL_bindsz00_1494))
{ /* Eval/evaluate.scm 515 */
BgL_ubindsz00_2487 = BNIL; }  else 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_head1230z00_2537;
{ /* Eval/evaluate.scm 515 */
obj_t BgL_res2771z00_3462;
BgL_res2771z00_3462 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1230z00_2537 = BgL_res2771z00_3462; } 
{ 
obj_t BgL_l1228z00_2539;obj_t BgL_tail1231z00_2540;
BgL_l1228z00_2539 = BgL_bindsz00_1494; 
BgL_tail1231z00_2540 = BgL_head1230z00_2537; 
BgL_zc3z04anonymousza32294ze3z87_2541:
if(
NULLP(BgL_l1228z00_2539))
{ /* Eval/evaluate.scm 515 */
BgL_ubindsz00_2487 = 
CDR(BgL_head1230z00_2537); }  else 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_newtail1232z00_2543;
{ /* Eval/evaluate.scm 515 */
obj_t BgL_arg2297z00_2545;
{ /* Eval/evaluate.scm 515 */
obj_t BgL_bz00_2546;
BgL_bz00_2546 = 
CAR(
((obj_t)BgL_l1228z00_2539)); 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_arg2298z00_2547;
BgL_arg2298z00_2547 = 
CAR(
((obj_t)BgL_bz00_2546)); 
BgL_arg2297z00_2545 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_arg2298z00_2547); } } 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_res2773z00_3467;
BgL_res2773z00_3467 = 
MAKE_YOUNG_PAIR(BgL_arg2297z00_2545, BNIL); 
BgL_newtail1232z00_2543 = BgL_res2773z00_3467; } } 
SET_CDR(BgL_tail1231z00_2540, BgL_newtail1232z00_2543); 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_arg2296z00_2544;
BgL_arg2296z00_2544 = 
CDR(
((obj_t)BgL_l1228z00_2539)); 
{ 
obj_t BgL_tail1231z00_5604;obj_t BgL_l1228z00_5603;
BgL_l1228z00_5603 = BgL_arg2296z00_2544; 
BgL_tail1231z00_5604 = BgL_newtail1232z00_2543; 
BgL_tail1231z00_2540 = BgL_tail1231z00_5604; 
BgL_l1228z00_2539 = BgL_l1228z00_5603; 
goto BgL_zc3z04anonymousza32294ze3z87_2541;} } } } } 
{ /* Eval/evaluate.scm 515 */
obj_t BgL_varsz00_2488;
if(
NULLP(BgL_ubindsz00_2487))
{ /* Eval/evaluate.scm 516 */
BgL_varsz00_2488 = BNIL; }  else 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_head1235z00_2521;
{ /* Eval/evaluate.scm 516 */
obj_t BgL_res2775z00_3471;
BgL_res2775z00_3471 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1235z00_2521 = BgL_res2775z00_3471; } 
{ 
obj_t BgL_l1233z00_2523;obj_t BgL_tail1236z00_2524;
BgL_l1233z00_2523 = BgL_ubindsz00_2487; 
BgL_tail1236z00_2524 = BgL_head1235z00_2521; 
BgL_zc3z04anonymousza32288ze3z87_2525:
if(
NULLP(BgL_l1233z00_2523))
{ /* Eval/evaluate.scm 516 */
BgL_varsz00_2488 = 
CDR(BgL_head1235z00_2521); }  else 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_newtail1237z00_2527;
{ /* Eval/evaluate.scm 516 */
BgL_ev_varz00_bglt BgL_arg2291z00_2529;
{ /* Eval/evaluate.scm 516 */
obj_t BgL_iz00_2530;
BgL_iz00_2530 = 
CAR(
((obj_t)BgL_l1233z00_2523)); 
{ /* Eval/evaluate.scm 517 */
BgL_ev_varz00_bglt BgL_new1130z00_2531;
{ /* Eval/evaluate.scm 519 */
BgL_ev_varz00_bglt BgL_new1129z00_2532;
BgL_new1129z00_2532 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 519 */
long BgL_arg2292z00_2533;
{ /* Eval/evaluate.scm 519 */
long BgL_res2777z00_3476;
BgL_res2777z00_3476 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2292z00_2533 = BgL_res2777z00_3476; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1129z00_2532), BgL_arg2292z00_2533); } 
BgL_new1130z00_2531 = BgL_new1129z00_2532; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1130z00_2531))->BgL_namez00)=((obj_t)
CAR(
((obj_t)BgL_iz00_2530))),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1130z00_2531))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1130z00_2531))->BgL_typez00)=((obj_t)
CDR(
((obj_t)BgL_iz00_2530))),BUNSPEC); 
BgL_arg2291z00_2529 = BgL_new1130z00_2531; } } 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_res2778z00_3481;
BgL_res2778z00_3481 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2291z00_2529), BNIL); 
BgL_newtail1237z00_2527 = BgL_res2778z00_3481; } } 
SET_CDR(BgL_tail1236z00_2524, BgL_newtail1237z00_2527); 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_arg2290z00_2528;
BgL_arg2290z00_2528 = 
CDR(
((obj_t)BgL_l1233z00_2523)); 
{ 
obj_t BgL_tail1236z00_5630;obj_t BgL_l1233z00_5629;
BgL_l1233z00_5629 = BgL_arg2290z00_2528; 
BgL_tail1236z00_5630 = BgL_newtail1237z00_2527; 
BgL_tail1236z00_2524 = BgL_tail1236z00_5630; 
BgL_l1233z00_2523 = BgL_l1233z00_5629; 
goto BgL_zc3z04anonymousza32288ze3z87_2525;} } } } } 
{ /* Eval/evaluate.scm 516 */
obj_t BgL_localsz00_2489;
BgL_localsz00_2489 = 
BGl_appendzd221009zd2zz__evaluatez00(BgL_varsz00_2488, BgL_localsz00_70); 
{ /* Eval/evaluate.scm 521 */
obj_t BgL_bodyz00_2490;
{ /* Eval/evaluate.scm 522 */
bool_t BgL_test3315z00_5632;
{ /* Eval/evaluate.scm 522 */
obj_t BgL_tmpz00_5633;
BgL_tmpz00_5633 = 
CDR(
((obj_t)BgL_bodyz00_1495)); 
BgL_test3315z00_5632 = 
PAIRP(BgL_tmpz00_5633); } 
if(BgL_test3315z00_5632)
{ /* Eval/evaluate.scm 522 */
obj_t BgL_res2780z00_3487;
BgL_res2780z00_3487 = 
MAKE_YOUNG_EPAIR(BGl_symbol3083z00zz__evaluatez00, BgL_bodyz00_1495, BgL_locz00_74); 
BgL_bodyz00_2490 = BgL_res2780z00_3487; }  else 
{ /* Eval/evaluate.scm 522 */
BgL_bodyz00_2490 = 
CAR(
((obj_t)BgL_bodyz00_1495)); } } 
{ /* Eval/evaluate.scm 522 */
obj_t BgL_tbodyz00_2491;
BgL_tbodyz00_2491 = 
BGl_typezd2checkszd2zz__evaluatez00(BgL_ubindsz00_2487, BgL_bindsz00_1494, BgL_bodyz00_2490, BgL_locz00_74, BgL_wherez00_73); 
{ /* Eval/evaluate.scm 523 */
obj_t BgL_blocz00_2492;
BgL_blocz00_2492 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bindsz00_1494, BgL_locz00_74); 
{ /* Eval/evaluate.scm 524 */

{ /* Eval/evaluate.scm 525 */
BgL_ev_letrecz00_bglt BgL_new1132z00_2493;
{ /* Eval/evaluate.scm 526 */
BgL_ev_letrecz00_bglt BgL_new1131z00_2514;
BgL_new1131z00_2514 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate.scm 526 */
long BgL_arg2283z00_2515;
{ /* Eval/evaluate.scm 526 */
long BgL_res2781z00_3490;
BgL_res2781z00_3490 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BgL_arg2283z00_2515 = BgL_res2781z00_3490; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1131z00_2514), BgL_arg2283z00_2515); } 
BgL_new1132z00_2493 = BgL_new1131z00_2514; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1132z00_2493)))->BgL_varsz00)=((obj_t)BgL_varsz00_2488),BUNSPEC); 
{ 
obj_t BgL_auxz00_5648;
if(
NULLP(BgL_bindsz00_1494))
{ /* Eval/evaluate.scm 527 */
BgL_auxz00_5648 = BNIL
; }  else 
{ /* Eval/evaluate.scm 527 */
obj_t BgL_head1240z00_2496;
{ /* Eval/evaluate.scm 527 */
obj_t BgL_res2783z00_3494;
BgL_res2783z00_3494 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1240z00_2496 = BgL_res2783z00_3494; } 
{ 
obj_t BgL_l1238z00_2498;obj_t BgL_tail1241z00_2499;
BgL_l1238z00_2498 = BgL_bindsz00_1494; 
BgL_tail1241z00_2499 = BgL_head1240z00_2496; 
BgL_zc3z04anonymousza32272ze3z87_2500:
if(
NULLP(BgL_l1238z00_2498))
{ /* Eval/evaluate.scm 527 */
BgL_auxz00_5648 = 
CDR(BgL_head1240z00_2496)
; }  else 
{ /* Eval/evaluate.scm 527 */
obj_t BgL_newtail1242z00_2502;
{ /* Eval/evaluate.scm 527 */
obj_t BgL_arg2275z00_2504;
{ /* Eval/evaluate.scm 527 */
obj_t BgL_bz00_2505;
BgL_bz00_2505 = 
CAR(
((obj_t)BgL_l1238z00_2498)); 
{ /* Eval/evaluate.scm 528 */
obj_t BgL_arg2276z00_2506;obj_t BgL_arg2277z00_2507;obj_t BgL_arg2278z00_2508;
{ /* Eval/evaluate.scm 528 */
obj_t BgL_pairz00_3501;
BgL_pairz00_3501 = 
CDR(
((obj_t)BgL_bz00_2505)); 
BgL_arg2276z00_2506 = 
CAR(BgL_pairz00_3501); } 
{ /* Eval/evaluate.scm 528 */
obj_t BgL_arg2279z00_2509;
BgL_arg2279z00_2509 = 
CAR(
((obj_t)BgL_bz00_2505)); 
{ /* Eval/evaluate.scm 528 */
obj_t BgL_list2280z00_2510;
{ /* Eval/evaluate.scm 528 */
obj_t BgL_arg2281z00_2511;
{ /* Eval/evaluate.scm 528 */
obj_t BgL_arg2282z00_2512;
BgL_arg2282z00_2512 = 
MAKE_YOUNG_PAIR(BgL_wherez00_73, BNIL); 
BgL_arg2281z00_2511 = 
MAKE_YOUNG_PAIR(BGl_symbol3085z00zz__evaluatez00, BgL_arg2282z00_2512); } 
BgL_list2280z00_2510 = 
MAKE_YOUNG_PAIR(BgL_arg2279z00_2509, BgL_arg2281z00_2511); } 
BgL_arg2277z00_2507 = 
BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(BgL_list2280z00_2510); } } 
BgL_arg2278z00_2508 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bz00_2505, BgL_blocz00_2492); 
BgL_arg2275z00_2504 = 
BGl_convz00zz__evaluatez00(BgL_arg2276z00_2506, BgL_localsz00_2489, BgL_globalsz00_71, BFALSE, BgL_arg2277z00_2507, BgL_arg2278z00_2508, ((bool_t)0)); } } 
{ /* Eval/evaluate.scm 527 */
obj_t BgL_res2785z00_3503;
BgL_res2785z00_3503 = 
MAKE_YOUNG_PAIR(BgL_arg2275z00_2504, BNIL); 
BgL_newtail1242z00_2502 = BgL_res2785z00_3503; } } 
SET_CDR(BgL_tail1241z00_2499, BgL_newtail1242z00_2502); 
{ /* Eval/evaluate.scm 527 */
obj_t BgL_arg2274z00_2503;
BgL_arg2274z00_2503 = 
CDR(
((obj_t)BgL_l1238z00_2498)); 
{ 
obj_t BgL_tail1241z00_5674;obj_t BgL_l1238z00_5673;
BgL_l1238z00_5673 = BgL_arg2274z00_2503; 
BgL_tail1241z00_5674 = BgL_newtail1242z00_2502; 
BgL_tail1241z00_2499 = BgL_tail1241z00_5674; 
BgL_l1238z00_2498 = BgL_l1238z00_5673; 
goto BgL_zc3z04anonymousza32272ze3z87_2500;} } } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1132z00_2493)))->BgL_valsz00)=((obj_t)BgL_auxz00_5648),BUNSPEC); } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1132z00_2493)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convz00zz__evaluatez00(BgL_tbodyz00_2491, BgL_localsz00_2489, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_5587 = BgL_new1132z00_2493; } } } } } } } } 
return 
((obj_t)BgL_auxz00_5587);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1685z00_1699;
BgL_arg1685z00_1699 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5682;
{ 
obj_t BgL_argsz00_5684;obj_t BgL_fz00_5683;
BgL_fz00_5683 = BgL_arg1685z00_1699; 
BgL_argsz00_5684 = BgL_cdrzd26736zd2_1693; 
BgL_argsz00_1536 = BgL_argsz00_5684; 
BgL_fz00_1535 = BgL_fz00_5683; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5682);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3104z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26736zd2_1693))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd26912zd2_1705;obj_t BgL_cdrzd26913zd2_1706;
BgL_carzd26912zd2_1705 = 
CAR(BgL_cdrzd26736zd2_1693); 
BgL_cdrzd26913zd2_1706 = 
CDR(BgL_cdrzd26736zd2_1693); 
if(
PAIRP(BgL_carzd26912zd2_1705))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd26917zd2_1708;
BgL_cdrzd26917zd2_1708 = 
CDR(BgL_carzd26912zd2_1705); 
if(
(
CAR(BgL_carzd26912zd2_1705)==BGl_symbol3090z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26917zd2_1708))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd26920zd2_1712;obj_t BgL_cdrzd26921zd2_1713;
BgL_carzd26920zd2_1712 = 
CAR(BgL_cdrzd26917zd2_1708); 
BgL_cdrzd26921zd2_1713 = 
CDR(BgL_cdrzd26917zd2_1708); 
if(
SYMBOLP(BgL_carzd26920zd2_1712))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26921zd2_1713))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd26925zd2_1716;
BgL_carzd26925zd2_1716 = 
CAR(BgL_cdrzd26921zd2_1713); 
if(
SYMBOLP(BgL_carzd26925zd2_1716))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd26921zd2_1713)))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd26913zd2_1706))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd26913zd2_1706)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1702z00_1723;
BgL_arg1702z00_1723 = 
CAR(BgL_cdrzd26913zd2_1706); 
{ 
BgL_ev_setglobalz00_bglt BgL_auxz00_5719;
BgL_idz00_1497 = BgL_carzd26920zd2_1712; 
BgL_modnamez00_1498 = BgL_carzd26925zd2_1716; 
BgL_ez00_1499 = BgL_arg1702z00_1723; 
BgL_tagzd2163zd2_1500:
{ /* Eval/evaluate.scm 531 */
BgL_ev_setglobalz00_bglt BgL_new1134z00_2549;
{ /* Eval/evaluate.scm 535 */
BgL_ev_setglobalz00_bglt BgL_new1133z00_2550;
BgL_new1133z00_2550 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate.scm 535 */
long BgL_arg2299z00_2551;
{ /* Eval/evaluate.scm 535 */
long BgL_res2786z00_3507;
BgL_res2786z00_3507 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg2299z00_2551 = BgL_res2786z00_3507; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1133z00_2550), BgL_arg2299z00_2551); } 
BgL_new1134z00_2549 = BgL_new1133z00_2550; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1134z00_2549)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_1499))),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1134z00_2549))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1134z00_2549))->BgL_namez00)=((obj_t)BgL_idz00_1497),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1134z00_2549))->BgL_modz00)=((obj_t)
BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_modnamez00_1498)),BUNSPEC); 
BgL_auxz00_5719 = BgL_new1134z00_2549; } 
return 
((obj_t)BgL_auxz00_5719);} }  else 
{ /* Eval/evaluate.scm 424 */
BgL_tagzd2166zd2_1507:
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74, BGl_string3003z00zz__evaluatez00, BGl_string3082z00zz__evaluatez00, BgL_ez00_69);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27041zd2_1725;
BgL_cdrzd27041zd2_1725 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27045zd2_1726;
BgL_cdrzd27045zd2_1726 = 
CDR(
((obj_t)BgL_cdrzd27041zd2_1725)); 
if(
PAIRP(BgL_cdrzd27045zd2_1726))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27045zd2_1726)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1707z00_1730;obj_t BgL_arg1708z00_1731;
BgL_arg1707z00_1730 = 
CAR(
((obj_t)BgL_cdrzd27041zd2_1725)); 
BgL_arg1708z00_1731 = 
CAR(BgL_cdrzd27045zd2_1726); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5745;
BgL_vz00_1504 = BgL_arg1707z00_1730; 
BgL_ez00_1505 = BgL_arg1708z00_1731; 
BgL_tagzd2165zd2_1506:
{ /* Eval/evaluate.scm 541 */
obj_t BgL_cvz00_2578;obj_t BgL_ez00_2579;
BgL_cvz00_2578 = 
BGl_convzd2varzd2zz__evaluatez00(BgL_vz00_1504, BgL_localsz00_70); 
BgL_ez00_2579 = 
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_1505); 
if(
CBOOL(BgL_cvz00_2578))
{ /* Eval/evaluate.scm 543 */
BgL_ev_setlocalz00_bglt BgL_new1136z00_2580;
{ /* Eval/evaluate.scm 545 */
BgL_ev_setlocalz00_bglt BgL_new1135z00_2581;
BgL_new1135z00_2581 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate.scm 545 */
long BgL_arg2313z00_2582;
{ /* Eval/evaluate.scm 545 */
long BgL_res2791z00_3518;
BgL_res2791z00_3518 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BgL_arg2313z00_2582 = BgL_res2791z00_3518; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1135z00_2581), BgL_arg2313z00_2582); } 
BgL_new1136z00_2580 = BgL_new1135z00_2581; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1136z00_2580)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_ez00_2579)),BUNSPEC); 
((((BgL_ev_setlocalz00_bglt)COBJECT(BgL_new1136z00_2580))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_cvz00_2578)),BUNSPEC); 
BgL_auxz00_5745 = 
((BgL_ev_hookz00_bglt)BgL_new1136z00_2580); }  else 
{ /* Eval/evaluate.scm 546 */
BgL_ev_setglobalz00_bglt BgL_new1138z00_2583;
{ /* Eval/evaluate.scm 550 */
BgL_ev_setglobalz00_bglt BgL_new1137z00_2585;
BgL_new1137z00_2585 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate.scm 550 */
long BgL_arg2315z00_2586;
{ /* Eval/evaluate.scm 550 */
long BgL_res2792z00_3522;
BgL_res2792z00_3522 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg2315z00_2586 = BgL_res2792z00_3522; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1137z00_2585), BgL_arg2315z00_2586); } 
BgL_new1138z00_2583 = BgL_new1137z00_2585; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1138z00_2583)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_ez00_2579)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1138z00_2583))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1138z00_2583))->BgL_namez00)=((obj_t)BgL_vz00_1504),BUNSPEC); 
{ 
obj_t BgL_auxz00_5769;
if(
BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
{ /* Eval/evaluate.scm 549 */
BgL_auxz00_5769 = BgL_globalsz00_71
; }  else 
{ /* Eval/evaluate.scm 549 */
BgL_auxz00_5769 = 
BGL_MODULE()
; } 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1138z00_2583))->BgL_modz00)=((obj_t)BgL_auxz00_5769),BUNSPEC); } 
BgL_auxz00_5745 = 
((BgL_ev_hookz00_bglt)BgL_new1138z00_2583); } } 
return 
((obj_t)BgL_auxz00_5745);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27102zd2_1734;
BgL_cdrzd27102zd2_1734 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27106zd2_1735;
BgL_cdrzd27106zd2_1735 = 
CDR(
((obj_t)BgL_cdrzd27102zd2_1734)); 
if(
PAIRP(BgL_cdrzd27106zd2_1735))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27106zd2_1735)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1714z00_1739;obj_t BgL_arg1715z00_1740;
BgL_arg1714z00_1739 = 
CAR(
((obj_t)BgL_cdrzd27102zd2_1734)); 
BgL_arg1715z00_1740 = 
CAR(BgL_cdrzd27106zd2_1735); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5787;
{ 
obj_t BgL_ez00_5789;obj_t BgL_vz00_5788;
BgL_vz00_5788 = BgL_arg1714z00_1739; 
BgL_ez00_5789 = BgL_arg1715z00_1740; 
BgL_ez00_1505 = BgL_ez00_5789; 
BgL_vz00_1504 = BgL_vz00_5788; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5787);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27163zd2_1742;
BgL_cdrzd27163zd2_1742 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27167zd2_1743;
BgL_cdrzd27167zd2_1743 = 
CDR(
((obj_t)BgL_cdrzd27163zd2_1742)); 
if(
PAIRP(BgL_cdrzd27167zd2_1743))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27167zd2_1743)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1720z00_1747;obj_t BgL_arg1721z00_1748;
BgL_arg1720z00_1747 = 
CAR(
((obj_t)BgL_cdrzd27163zd2_1742)); 
BgL_arg1721z00_1748 = 
CAR(BgL_cdrzd27167zd2_1743); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5802;
{ 
obj_t BgL_ez00_5804;obj_t BgL_vz00_5803;
BgL_vz00_5803 = BgL_arg1720z00_1747; 
BgL_ez00_5804 = BgL_arg1721z00_1748; 
BgL_ez00_1505 = BgL_ez00_5804; 
BgL_vz00_1504 = BgL_vz00_5803; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5802);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27224zd2_1750;
BgL_cdrzd27224zd2_1750 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27228zd2_1751;
BgL_cdrzd27228zd2_1751 = 
CDR(
((obj_t)BgL_cdrzd27224zd2_1750)); 
if(
PAIRP(BgL_cdrzd27228zd2_1751))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27228zd2_1751)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1726z00_1755;obj_t BgL_arg1727z00_1756;
BgL_arg1726z00_1755 = 
CAR(
((obj_t)BgL_cdrzd27224zd2_1750)); 
BgL_arg1727z00_1756 = 
CAR(BgL_cdrzd27228zd2_1751); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5817;
{ 
obj_t BgL_ez00_5819;obj_t BgL_vz00_5818;
BgL_vz00_5818 = BgL_arg1726z00_1755; 
BgL_ez00_5819 = BgL_arg1727z00_1756; 
BgL_ez00_1505 = BgL_ez00_5819; 
BgL_vz00_1504 = BgL_vz00_5818; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5817);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27285zd2_1758;
BgL_cdrzd27285zd2_1758 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27289zd2_1759;
BgL_cdrzd27289zd2_1759 = 
CDR(
((obj_t)BgL_cdrzd27285zd2_1758)); 
if(
PAIRP(BgL_cdrzd27289zd2_1759))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27289zd2_1759)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1732z00_1763;obj_t BgL_arg1733z00_1764;
BgL_arg1732z00_1763 = 
CAR(
((obj_t)BgL_cdrzd27285zd2_1758)); 
BgL_arg1733z00_1764 = 
CAR(BgL_cdrzd27289zd2_1759); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5832;
{ 
obj_t BgL_ez00_5834;obj_t BgL_vz00_5833;
BgL_vz00_5833 = BgL_arg1732z00_1763; 
BgL_ez00_5834 = BgL_arg1733z00_1764; 
BgL_ez00_1505 = BgL_ez00_5834; 
BgL_vz00_1504 = BgL_vz00_5833; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5832);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27333zd2_1766;
BgL_cdrzd27333zd2_1766 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd27336zd2_1767;obj_t BgL_cdrzd27337zd2_1768;
BgL_carzd27336zd2_1767 = 
CAR(
((obj_t)BgL_cdrzd27333zd2_1766)); 
BgL_cdrzd27337zd2_1768 = 
CDR(
((obj_t)BgL_cdrzd27333zd2_1766)); 
if(
(
CAR(
((obj_t)BgL_carzd27336zd2_1767))==BGl_symbol3092z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd27337zd2_1768))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27337zd2_1768)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1740z00_1774;obj_t BgL_arg1741z00_1775;
BgL_arg1740z00_1774 = 
CDR(
((obj_t)BgL_carzd27336zd2_1767)); 
BgL_arg1741z00_1775 = 
CAR(BgL_cdrzd27337zd2_1768); 
BgL_lz00_1501 = BgL_arg1740z00_1774; 
BgL_e2z00_1502 = BgL_arg1741z00_1775; 
BgL_tagzd2164zd2_1503:
{ /* Eval/evaluate.scm 537 */
bool_t BgL_test3344z00_5853;
if(
PAIRP(BgL_lz00_1501))
{ /* Eval/evaluate.scm 537 */
bool_t BgL_test3346z00_5856;
{ /* Eval/evaluate.scm 537 */
obj_t BgL_tmpz00_5857;
BgL_tmpz00_5857 = 
CDR(BgL_lz00_1501); 
BgL_test3346z00_5856 = 
PAIRP(BgL_tmpz00_5857); } 
if(BgL_test3346z00_5856)
{ 
obj_t BgL_l1243z00_2569;
BgL_l1243z00_2569 = BgL_lz00_1501; 
BgL_zc3z04anonymousza32309ze3z87_2570:
if(
NULLP(BgL_l1243z00_2569))
{ /* Eval/evaluate.scm 537 */
BgL_test3344z00_5853 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate.scm 537 */
bool_t BgL_test3348z00_5862;
{ /* Eval/evaluate.scm 537 */
obj_t BgL_tmpz00_5863;
BgL_tmpz00_5863 = 
CAR(
((obj_t)BgL_l1243z00_2569)); 
BgL_test3348z00_5862 = 
SYMBOLP(BgL_tmpz00_5863); } 
if(BgL_test3348z00_5862)
{ 
obj_t BgL_l1243z00_5867;
BgL_l1243z00_5867 = 
CDR(
((obj_t)BgL_l1243z00_2569)); 
BgL_l1243z00_2569 = BgL_l1243z00_5867; 
goto BgL_zc3z04anonymousza32309ze3z87_2570;}  else 
{ /* Eval/evaluate.scm 537 */
BgL_test3344z00_5853 = ((bool_t)0)
; } } }  else 
{ /* Eval/evaluate.scm 537 */
BgL_test3344z00_5853 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate.scm 537 */
BgL_test3344z00_5853 = ((bool_t)0)
; } 
if(BgL_test3344z00_5853)
{ /* Eval/evaluate.scm 537 */
return 
BGl_convzd2fieldzd2setz00zz__evaluatez00(BgL_lz00_1501, BgL_e2z00_1502, BgL_ez00_69, BgL_localsz00_70, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, BgL_topzf3zf3_75);}  else 
{ /* Eval/evaluate.scm 537 */
return 
BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74, BGl_string3003z00zz__evaluatez00, BGl_string3082z00zz__evaluatez00, BgL_ez00_69);} } }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27413zd2_1778;
BgL_cdrzd27413zd2_1778 = 
CDR(
((obj_t)BgL_cdrzd27333zd2_1766)); 
if(
PAIRP(BgL_cdrzd27413zd2_1778))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27413zd2_1778)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1746z00_1782;obj_t BgL_arg1747z00_1783;
BgL_arg1746z00_1782 = 
CAR(
((obj_t)BgL_cdrzd27333zd2_1766)); 
BgL_arg1747z00_1783 = 
CAR(BgL_cdrzd27413zd2_1778); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5882;
{ 
obj_t BgL_ez00_5884;obj_t BgL_vz00_5883;
BgL_vz00_5883 = BgL_arg1746z00_1782; 
BgL_ez00_5884 = BgL_arg1747z00_1783; 
BgL_ez00_1505 = BgL_ez00_5884; 
BgL_vz00_1504 = BgL_vz00_5883; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5882);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27470zd2_1787;
BgL_cdrzd27470zd2_1787 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27474zd2_1788;
BgL_cdrzd27474zd2_1788 = 
CDR(
((obj_t)BgL_cdrzd27470zd2_1787)); 
if(
PAIRP(BgL_cdrzd27474zd2_1788))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27474zd2_1788)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1755z00_1792;obj_t BgL_arg1756z00_1793;
BgL_arg1755z00_1792 = 
CAR(
((obj_t)BgL_cdrzd27470zd2_1787)); 
BgL_arg1756z00_1793 = 
CAR(BgL_cdrzd27474zd2_1788); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5897;
{ 
obj_t BgL_ez00_5899;obj_t BgL_vz00_5898;
BgL_vz00_5898 = BgL_arg1755z00_1792; 
BgL_ez00_5899 = BgL_arg1756z00_1793; 
BgL_ez00_1505 = BgL_ez00_5899; 
BgL_vz00_1504 = BgL_vz00_5898; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_5897);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27595zd2_1795;
BgL_cdrzd27595zd2_1795 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3106z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd27595zd2_1795))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27600zd2_1799;
BgL_cdrzd27600zd2_1799 = 
CDR(BgL_cdrzd27595zd2_1795); 
if(
PAIRP(BgL_cdrzd27600zd2_1799))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd27604zd2_1801;
BgL_carzd27604zd2_1801 = 
CAR(BgL_cdrzd27600zd2_1799); 
if(
PAIRP(BgL_carzd27604zd2_1801))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27609zd2_1803;
BgL_cdrzd27609zd2_1803 = 
CDR(BgL_carzd27604zd2_1801); 
if(
(
CAR(BgL_carzd27604zd2_1801)==BGl_symbol3067z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd27609zd2_1803))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27613zd2_1807;
BgL_cdrzd27613zd2_1807 = 
CDR(BgL_cdrzd27609zd2_1803); 
if(
PAIRP(BgL_cdrzd27613zd2_1807))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27613zd2_1807)))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd27600zd2_1799)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1771z00_1813;obj_t BgL_arg1772z00_1814;obj_t BgL_arg1773z00_1815;
BgL_arg1771z00_1813 = 
CAR(BgL_cdrzd27595zd2_1795); 
BgL_arg1772z00_1814 = 
CAR(BgL_cdrzd27609zd2_1803); 
BgL_arg1773z00_1815 = 
CAR(BgL_cdrzd27613zd2_1807); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5931;
BgL_gvz00_1508 = BgL_arg1771z00_1813; 
BgL_formalsz00_1509 = BgL_arg1772z00_1814; 
BgL_bodyz00_1510 = BgL_arg1773z00_1815; 
BgL_tagzd2167zd2_1511:
{ /* Eval/evaluate.scm 554 */
obj_t BgL_tidz00_2587;
BgL_tidz00_2587 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_gvz00_1508); 
{ /* Eval/evaluate.scm 555 */
BgL_ev_defglobalz00_bglt BgL_new1140z00_2588;
{ /* Eval/evaluate.scm 559 */
BgL_ev_defglobalz00_bglt BgL_new1139z00_2591;
BgL_new1139z00_2591 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate.scm 559 */
long BgL_arg2318z00_2592;
{ /* Eval/evaluate.scm 559 */
long BgL_res2793z00_3526;
BgL_res2793z00_3526 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg2318z00_2592 = BgL_res2793z00_3526; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1139z00_2591), BgL_arg2318z00_2592); } 
BgL_new1140z00_2588 = BgL_new1139z00_2591; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5937;
{ /* Eval/evaluate.scm 559 */
obj_t BgL_arg2316z00_2589;
BgL_arg2316z00_2589 = 
CDR(BgL_tidz00_2587); 
BgL_auxz00_5937 = 
((BgL_ev_exprz00_bglt)
BGl_convzd2lambdaze70z35zz__evaluatez00(BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_69, BgL_locz00_74, BgL_formalsz00_1509, BgL_bodyz00_1510, BgL_gvz00_1508, BgL_arg2316z00_2589)); } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1140z00_2588)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5937),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1140z00_2588)))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1140z00_2588)))->BgL_namez00)=((obj_t)
CAR(BgL_tidz00_2587)),BUNSPEC); 
{ 
obj_t BgL_auxz00_5948;
if(
BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
{ /* Eval/evaluate.scm 558 */
BgL_auxz00_5948 = BgL_globalsz00_71
; }  else 
{ /* Eval/evaluate.scm 558 */
BgL_auxz00_5948 = 
BGL_MODULE()
; } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1140z00_2588)))->BgL_modz00)=((obj_t)BgL_auxz00_5948),BUNSPEC); } 
BgL_auxz00_5931 = BgL_new1140z00_2588; } } 
return 
((obj_t)BgL_auxz00_5931);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1774z00_1816;
BgL_arg1774z00_1816 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_5956;
{ 
obj_t BgL_argsz00_5958;obj_t BgL_fz00_5957;
BgL_fz00_5957 = BgL_arg1774z00_1816; 
BgL_argsz00_5958 = BgL_cdrzd27595zd2_1795; 
BgL_argsz00_1536 = BgL_argsz00_5958; 
BgL_fz00_1535 = BgL_fz00_5957; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_5956);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27715zd2_1820;
BgL_cdrzd27715zd2_1820 = 
CDR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd27715zd2_1820))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1779z00_1823;obj_t BgL_arg1780z00_1824;
BgL_arg1779z00_1823 = 
CAR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
BgL_arg1780z00_1824 = 
CAR(
((obj_t)BgL_cdrzd27715zd2_1820)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5970;
BgL_gvz00_1512 = BgL_arg1779z00_1823; 
BgL_gez00_1513 = BgL_arg1780z00_1824; 
BgL_tagzd2168zd2_1514:
{ /* Eval/evaluate.scm 561 */
obj_t BgL_tidz00_2593;
BgL_tidz00_2593 = 
BGl_untypezd2identzd2zz__evaluatez00(BgL_gvz00_1512); 
{ /* Eval/evaluate.scm 562 */
BgL_ev_defglobalz00_bglt BgL_new1142z00_2594;
{ /* Eval/evaluate.scm 566 */
BgL_ev_defglobalz00_bglt BgL_new1141z00_2599;
BgL_new1141z00_2599 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate.scm 566 */
long BgL_arg2323z00_2600;
{ /* Eval/evaluate.scm 566 */
long BgL_res2794z00_3532;
BgL_res2794z00_3532 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg2323z00_2600 = BgL_res2794z00_3532; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_2599), BgL_arg2323z00_2600); } 
BgL_new1142z00_2594 = BgL_new1141z00_2599; } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5976;
{ /* Eval/evaluate.scm 567 */
obj_t BgL_arg2319z00_2595;
{ /* Eval/evaluate.scm 567 */
obj_t BgL_arg2321z00_2597;
BgL_arg2321z00_2597 = 
CDR(BgL_tidz00_2593); 
BgL_arg2319z00_2595 = 
BGl_typezd2resultzd2zz__evaluatez00(BgL_arg2321z00_2597, BgL_gez00_1513, BgL_locz00_74); } 
{ 
obj_t BgL_auxz00_5980;
BgL_ez00_2646 = BgL_arg2319z00_2595; 
if(BgL_topzf3zf3_75)
{ /* Eval/evaluate.scm 568 */
BgL_wherez00_2647 = BgL_gvz00_1512; }  else 
{ /* Eval/evaluate.scm 568 */
BgL_wherez00_2647 = BgL_wherez00_73; } 
BgL_ez00_2636 = BgL_ez00_2646; 
BgL_locz00_2637 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_ez00_2646, BgL_locz00_74); 
BgL_wherez00_2638 = BgL_wherez00_2647; 
BgL_auxz00_5980 = 
BGl_convz00zz__evaluatez00(BgL_ez00_2636, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_2638, BgL_locz00_2637, ((bool_t)0)); 
BgL_auxz00_5976 = 
((BgL_ev_exprz00_bglt)BgL_auxz00_5980); } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1142z00_2594)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5976),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1142z00_2594)))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1142z00_2594)))->BgL_namez00)=((obj_t)
CAR(BgL_tidz00_2593)),BUNSPEC); 
{ 
obj_t BgL_auxz00_5991;
if(
BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
{ /* Eval/evaluate.scm 565 */
BgL_auxz00_5991 = BgL_globalsz00_71
; }  else 
{ /* Eval/evaluate.scm 565 */
BgL_auxz00_5991 = 
BGL_MODULE()
; } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1142z00_2594)))->BgL_modz00)=((obj_t)BgL_auxz00_5991),BUNSPEC); } 
BgL_auxz00_5970 = BgL_new1142z00_2594; } } 
return 
((obj_t)BgL_auxz00_5970);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1781z00_1825;obj_t BgL_arg1782z00_1826;
BgL_arg1781z00_1825 = 
CAR(BgL_ez00_69); 
BgL_arg1782z00_1826 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6000;
{ 
obj_t BgL_argsz00_6002;obj_t BgL_fz00_6001;
BgL_fz00_6001 = BgL_arg1781z00_1825; 
BgL_argsz00_6002 = BgL_arg1782z00_1826; 
BgL_argsz00_1536 = BgL_argsz00_6002; 
BgL_fz00_1535 = BgL_fz00_6001; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6000);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27804zd2_1830;
BgL_cdrzd27804zd2_1830 = 
CDR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd27804zd2_1830))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1787z00_1833;obj_t BgL_arg1788z00_1834;
BgL_arg1787z00_1833 = 
CAR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
BgL_arg1788z00_1834 = 
CAR(
((obj_t)BgL_cdrzd27804zd2_1830)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6014;
{ 
obj_t BgL_gez00_6016;obj_t BgL_gvz00_6015;
BgL_gvz00_6015 = BgL_arg1787z00_1833; 
BgL_gez00_6016 = BgL_arg1788z00_1834; 
BgL_gez00_1513 = BgL_gez00_6016; 
BgL_gvz00_1512 = BgL_gvz00_6015; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6014);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1789z00_1835;obj_t BgL_arg1790z00_1836;
BgL_arg1789z00_1835 = 
CAR(BgL_ez00_69); 
BgL_arg1790z00_1836 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6020;
{ 
obj_t BgL_argsz00_6022;obj_t BgL_fz00_6021;
BgL_fz00_6021 = BgL_arg1789z00_1835; 
BgL_argsz00_6022 = BgL_arg1790z00_1836; 
BgL_argsz00_1536 = BgL_argsz00_6022; 
BgL_fz00_1535 = BgL_fz00_6021; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6020);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27893zd2_1839;
BgL_cdrzd27893zd2_1839 = 
CDR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd27893zd2_1839))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1794z00_1842;obj_t BgL_arg1795z00_1843;
BgL_arg1794z00_1842 = 
CAR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
BgL_arg1795z00_1843 = 
CAR(
((obj_t)BgL_cdrzd27893zd2_1839)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6034;
{ 
obj_t BgL_gez00_6036;obj_t BgL_gvz00_6035;
BgL_gvz00_6035 = BgL_arg1794z00_1842; 
BgL_gez00_6036 = BgL_arg1795z00_1843; 
BgL_gez00_1513 = BgL_gez00_6036; 
BgL_gvz00_1512 = BgL_gvz00_6035; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6034);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1796z00_1844;obj_t BgL_arg1797z00_1845;
BgL_arg1796z00_1844 = 
CAR(BgL_ez00_69); 
BgL_arg1797z00_1845 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6040;
{ 
obj_t BgL_argsz00_6042;obj_t BgL_fz00_6041;
BgL_fz00_6041 = BgL_arg1796z00_1844; 
BgL_argsz00_6042 = BgL_arg1797z00_1845; 
BgL_argsz00_1536 = BgL_argsz00_6042; 
BgL_fz00_1535 = BgL_fz00_6041; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6040);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd27982zd2_1848;
BgL_cdrzd27982zd2_1848 = 
CDR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd27982zd2_1848))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1801z00_1851;obj_t BgL_arg1802z00_1852;
BgL_arg1801z00_1851 = 
CAR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
BgL_arg1802z00_1852 = 
CAR(
((obj_t)BgL_cdrzd27982zd2_1848)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6054;
{ 
obj_t BgL_gez00_6056;obj_t BgL_gvz00_6055;
BgL_gvz00_6055 = BgL_arg1801z00_1851; 
BgL_gez00_6056 = BgL_arg1802z00_1852; 
BgL_gez00_1513 = BgL_gez00_6056; 
BgL_gvz00_1512 = BgL_gvz00_6055; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6054);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1803z00_1853;obj_t BgL_arg1804z00_1854;
BgL_arg1803z00_1853 = 
CAR(BgL_ez00_69); 
BgL_arg1804z00_1854 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6060;
{ 
obj_t BgL_argsz00_6062;obj_t BgL_fz00_6061;
BgL_fz00_6061 = BgL_arg1803z00_1853; 
BgL_argsz00_6062 = BgL_arg1804z00_1854; 
BgL_argsz00_1536 = BgL_argsz00_6062; 
BgL_fz00_1535 = BgL_fz00_6061; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6060);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28071zd2_1858;
BgL_cdrzd28071zd2_1858 = 
CDR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd28071zd2_1858))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1809z00_1861;obj_t BgL_arg1810z00_1862;
BgL_arg1809z00_1861 = 
CAR(
((obj_t)BgL_cdrzd27595zd2_1795)); 
BgL_arg1810z00_1862 = 
CAR(
((obj_t)BgL_cdrzd28071zd2_1858)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6074;
{ 
obj_t BgL_gez00_6076;obj_t BgL_gvz00_6075;
BgL_gvz00_6075 = BgL_arg1809z00_1861; 
BgL_gez00_6076 = BgL_arg1810z00_1862; 
BgL_gez00_1513 = BgL_gez00_6076; 
BgL_gvz00_1512 = BgL_gvz00_6075; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6074);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1811z00_1863;obj_t BgL_arg1812z00_1864;
BgL_arg1811z00_1863 = 
CAR(BgL_ez00_69); 
BgL_arg1812z00_1864 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6080;
{ 
obj_t BgL_argsz00_6082;obj_t BgL_fz00_6081;
BgL_fz00_6081 = BgL_arg1811z00_1863; 
BgL_argsz00_6082 = BgL_arg1812z00_1864; 
BgL_argsz00_1536 = BgL_argsz00_6082; 
BgL_fz00_1535 = BgL_fz00_6081; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6080);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1814z00_1866;
BgL_arg1814z00_1866 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6085;
{ 
obj_t BgL_argsz00_6087;obj_t BgL_fz00_6086;
BgL_fz00_6086 = BgL_arg1814z00_1866; 
BgL_argsz00_6087 = BgL_cdrzd27595zd2_1795; 
BgL_argsz00_1536 = BgL_argsz00_6087; 
BgL_fz00_1535 = BgL_fz00_6086; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6085);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1816z00_1868;
BgL_arg1816z00_1868 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6090;
{ 
obj_t BgL_argsz00_6092;obj_t BgL_fz00_6091;
BgL_fz00_6091 = BgL_arg1816z00_1868; 
BgL_argsz00_6092 = BgL_cdrzd27595zd2_1795; 
BgL_argsz00_1536 = BgL_argsz00_6092; 
BgL_fz00_1535 = BgL_fz00_6091; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6090);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3108z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd27595zd2_1795))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd28319zd2_1874;
BgL_carzd28319zd2_1874 = 
CAR(BgL_cdrzd27595zd2_1795); 
if(
PAIRP(BgL_carzd28319zd2_1874))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_carzd28319zd2_1874)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1824z00_1878;obj_t BgL_arg1825z00_1879;
BgL_arg1824z00_1878 = 
CAR(BgL_carzd28319zd2_1874); 
BgL_arg1825z00_1879 = 
CDR(BgL_cdrzd27595zd2_1795); 
{ 
BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_6107;
BgL_vz00_1515 = BgL_arg1824z00_1878; 
BgL_bodyz00_1516 = BgL_arg1825z00_1879; 
BgL_tagzd2169zd2_1517:
{ /* Eval/evaluate.scm 570 */
BgL_ev_varz00_bglt BgL_varz00_2601;
{ /* Eval/evaluate.scm 570 */
BgL_ev_varz00_bglt BgL_new1144z00_2606;
{ /* Eval/evaluate.scm 570 */
BgL_ev_varz00_bglt BgL_new1143z00_2607;
BgL_new1143z00_2607 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 570 */
long BgL_arg2326z00_2608;
{ /* Eval/evaluate.scm 570 */
long BgL_res2795z00_3538;
BgL_res2795z00_3538 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2326z00_2608 = BgL_res2795z00_3538; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1143z00_2607), BgL_arg2326z00_2608); } 
BgL_new1144z00_2606 = BgL_new1143z00_2607; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1144z00_2606))->BgL_namez00)=((obj_t)BgL_vz00_1515),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1144z00_2606))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1144z00_2606))->BgL_typez00)=((obj_t)BFALSE),BUNSPEC); 
BgL_varz00_2601 = BgL_new1144z00_2606; } 
{ /* Eval/evaluate.scm 571 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1146z00_2602;
{ /* Eval/evaluate.scm 572 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1145z00_2604;
BgL_new1145z00_2604 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate.scm 572 */
long BgL_arg2325z00_2605;
{ /* Eval/evaluate.scm 572 */
long BgL_res2796z00_3542;
BgL_res2796z00_3542 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BgL_arg2325z00_2605 = BgL_res2796z00_3542; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1145z00_2604), BgL_arg2325z00_2605); } 
BgL_new1146z00_2602 = BgL_new1145z00_2604; } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1146z00_2602))->BgL_varz00)=((BgL_ev_varz00_bglt)BgL_varz00_2601),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_6120;
{ /* Eval/evaluate.scm 573 */
obj_t BgL_arg2324z00_2603;
BgL_arg2324z00_2603 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_varz00_2601), BgL_localsz00_70); 
BgL_auxz00_6120 = 
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1516, BgL_arg2324z00_2603, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0))); } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1146z00_2602))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_6120),BUNSPEC); } 
BgL_auxz00_6107 = BgL_new1146z00_2602; } } 
return 
((obj_t)BgL_auxz00_6107);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1826z00_1880;obj_t BgL_arg1827z00_1881;
BgL_arg1826z00_1880 = 
CAR(BgL_ez00_69); 
BgL_arg1827z00_1881 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6129;
{ 
obj_t BgL_argsz00_6131;obj_t BgL_fz00_6130;
BgL_fz00_6130 = BgL_arg1826z00_1880; 
BgL_argsz00_6131 = BgL_arg1827z00_1881; 
BgL_argsz00_1536 = BgL_argsz00_6131; 
BgL_fz00_1535 = BgL_fz00_6130; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6129);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1829z00_1883;obj_t BgL_arg1830z00_1884;
BgL_arg1829z00_1883 = 
CAR(BgL_ez00_69); 
BgL_arg1830z00_1884 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6135;
{ 
obj_t BgL_argsz00_6137;obj_t BgL_fz00_6136;
BgL_fz00_6136 = BgL_arg1829z00_1883; 
BgL_argsz00_6137 = BgL_arg1830z00_1884; 
BgL_argsz00_1536 = BgL_argsz00_6137; 
BgL_fz00_1535 = BgL_fz00_6136; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6135);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1831z00_1885;obj_t BgL_arg1832z00_1886;
BgL_arg1831z00_1885 = 
CAR(BgL_ez00_69); 
BgL_arg1832z00_1886 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6141;
{ 
obj_t BgL_argsz00_6143;obj_t BgL_fz00_6142;
BgL_fz00_6142 = BgL_arg1831z00_1885; 
BgL_argsz00_6143 = BgL_arg1832z00_1886; 
BgL_argsz00_1536 = BgL_argsz00_6143; 
BgL_fz00_1535 = BgL_fz00_6142; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6141);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28490zd2_1887;
BgL_cdrzd28490zd2_1887 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3110z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28490zd2_1887))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1836z00_1891;obj_t BgL_arg1837z00_1892;
BgL_arg1836z00_1891 = 
CAR(BgL_cdrzd28490zd2_1887); 
BgL_arg1837z00_1892 = 
CDR(BgL_cdrzd28490zd2_1887); 
{ 
BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_6153;
BgL_ez00_1518 = BgL_arg1836z00_1891; 
BgL_bodyz00_1519 = BgL_arg1837z00_1892; 
BgL_tagzd2170zd2_1520:
{ /* Eval/evaluate.scm 575 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1148z00_2609;
{ /* Eval/evaluate.scm 576 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1147z00_2610;
BgL_new1147z00_2610 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate.scm 576 */
long BgL_arg2327z00_2611;
{ /* Eval/evaluate.scm 576 */
long BgL_res2797z00_3546;
BgL_res2797z00_3546 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BgL_arg2327z00_2611 = BgL_res2797z00_3546; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1147z00_2610), BgL_arg2327z00_2611); } 
BgL_new1148z00_2609 = BgL_new1147z00_2610; } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1148z00_2609))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_1518))),BUNSPEC); 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1148z00_2609))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1519, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_6153 = BgL_new1148z00_2609; } 
return 
((obj_t)BgL_auxz00_6153);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1838z00_1893;
BgL_arg1838z00_1893 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6166;
{ 
obj_t BgL_argsz00_6168;obj_t BgL_fz00_6167;
BgL_fz00_6167 = BgL_arg1838z00_1893; 
BgL_argsz00_6168 = BgL_cdrzd28490zd2_1887; 
BgL_argsz00_1536 = BgL_argsz00_6168; 
BgL_fz00_1535 = BgL_fz00_6167; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6166);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3112z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28490zd2_1887))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1843z00_1899;obj_t BgL_arg1844z00_1900;
BgL_arg1843z00_1899 = 
CAR(BgL_cdrzd28490zd2_1887); 
BgL_arg1844z00_1900 = 
CDR(BgL_cdrzd28490zd2_1887); 
{ 
BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_6177;
BgL_hz00_1521 = BgL_arg1843z00_1899; 
BgL_bodyz00_1522 = BgL_arg1844z00_1900; 
BgL_tagzd2171zd2_1523:
{ /* Eval/evaluate.scm 579 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1150z00_2612;
{ /* Eval/evaluate.scm 580 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1149z00_2613;
BgL_new1149z00_2613 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate.scm 580 */
long BgL_arg2328z00_2614;
{ /* Eval/evaluate.scm 580 */
long BgL_res2798z00_3550;
BgL_res2798z00_3550 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BgL_arg2328z00_2614 = BgL_res2798z00_3550; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1149z00_2613), BgL_arg2328z00_2614); } 
BgL_new1150z00_2612 = BgL_new1149z00_2613; } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1150z00_2612))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_hz00_1521))),BUNSPEC); 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1150z00_2612))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1522, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_6177 = BgL_new1150z00_2612; } 
return 
((obj_t)BgL_auxz00_6177);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1845z00_1901;obj_t BgL_arg1846z00_1902;
BgL_arg1845z00_1901 = 
CAR(BgL_ez00_69); 
BgL_arg1846z00_1902 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6191;
{ 
obj_t BgL_argsz00_6193;obj_t BgL_fz00_6192;
BgL_fz00_6192 = BgL_arg1845z00_1901; 
BgL_argsz00_6193 = BgL_arg1846z00_1902; 
BgL_argsz00_1536 = BgL_argsz00_6193; 
BgL_fz00_1535 = BgL_fz00_6192; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6191);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28597zd2_1903;
BgL_cdrzd28597zd2_1903 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3114z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28597zd2_1903))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28602zd2_1907;
BgL_cdrzd28602zd2_1907 = 
CDR(BgL_cdrzd28597zd2_1903); 
if(
PAIRP(BgL_cdrzd28602zd2_1907))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28607zd2_1909;
BgL_cdrzd28607zd2_1909 = 
CDR(BgL_cdrzd28602zd2_1907); 
if(
(
CAR(BgL_cdrzd28602zd2_1907)==BGl_keyword3116z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28607zd2_1909))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1854z00_1913;obj_t BgL_arg1855z00_1914;obj_t BgL_arg1856z00_1915;
BgL_arg1854z00_1913 = 
CAR(BgL_cdrzd28597zd2_1903); 
BgL_arg1855z00_1914 = 
CAR(BgL_cdrzd28607zd2_1909); 
BgL_arg1856z00_1915 = 
CDR(BgL_cdrzd28607zd2_1909); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6213;
BgL_mz00_1524 = BgL_arg1854z00_1913; 
BgL_pz00_1525 = BgL_arg1855z00_1914; 
BgL_bodyz00_1526 = BgL_arg1856z00_1915; 
BgL_tagzd2172zd2_1527:
{ /* Eval/evaluate.scm 583 */
BgL_ev_synchroniza7eza7_bglt BgL_new1152z00_2615;
{ /* Eval/evaluate.scm 584 */
BgL_ev_synchroniza7eza7_bglt BgL_new1151z00_2616;
BgL_new1151z00_2616 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate.scm 584 */
long BgL_arg2329z00_2617;
{ /* Eval/evaluate.scm 584 */
long BgL_res2799z00_3554;
BgL_res2799z00_3554 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg2329z00_2617 = BgL_res2799z00_3554; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1151z00_2616), BgL_arg2329z00_2617); } 
BgL_new1152z00_2615 = BgL_new1151z00_2616; } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1152z00_2615))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1152z00_2615))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_mz00_1524))),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1152z00_2615))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_pz00_1525))),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1152z00_2615))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1526, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_6213 = BgL_new1152z00_2615; } 
return 
((obj_t)BgL_auxz00_6213);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1857z00_1917;obj_t BgL_arg1858z00_1918;
BgL_arg1857z00_1917 = 
CAR(
((obj_t)BgL_cdrzd28597zd2_1903)); 
BgL_arg1858z00_1918 = 
CDR(
((obj_t)BgL_cdrzd28597zd2_1903)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6233;
BgL_mz00_1528 = BgL_arg1857z00_1917; 
BgL_bodyz00_1529 = BgL_arg1858z00_1918; 
BgL_tagzd2173zd2_1530:
{ /* Eval/evaluate.scm 589 */
BgL_ev_synchroniza7eza7_bglt BgL_new1154z00_2618;
{ /* Eval/evaluate.scm 590 */
BgL_ev_synchroniza7eza7_bglt BgL_new1153z00_2619;
BgL_new1153z00_2619 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate.scm 590 */
long BgL_arg2330z00_2620;
{ /* Eval/evaluate.scm 590 */
long BgL_res2800z00_3558;
BgL_res2800z00_3558 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg2330z00_2620 = BgL_res2800z00_3558; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1153z00_2619), BgL_arg2330z00_2620); } 
BgL_new1154z00_2618 = BgL_new1153z00_2619; } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1154z00_2618))->BgL_locz00)=((obj_t)BgL_locz00_74),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1154z00_2618))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BgL_mz00_1528))),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1154z00_2618))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_uconvze70ze7zz__evaluatez00(BgL_locz00_74, BgL_wherez00_73, BgL_globalsz00_71, BgL_localsz00_70, BNIL))),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1154z00_2618))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)
BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1529, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t)0)))),BUNSPEC); 
BgL_auxz00_6233 = BgL_new1154z00_2618; } 
return 
((obj_t)BgL_auxz00_6233);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1859z00_1920;obj_t BgL_arg1860z00_1921;
BgL_arg1859z00_1920 = 
CAR(
((obj_t)BgL_cdrzd28597zd2_1903)); 
BgL_arg1860z00_1921 = 
CDR(
((obj_t)BgL_cdrzd28597zd2_1903)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6253;
{ 
obj_t BgL_bodyz00_6255;obj_t BgL_mz00_6254;
BgL_mz00_6254 = BgL_arg1859z00_1920; 
BgL_bodyz00_6255 = BgL_arg1860z00_1921; 
BgL_bodyz00_1529 = BgL_bodyz00_6255; 
BgL_mz00_1528 = BgL_mz00_6254; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6253);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1862z00_1924;obj_t BgL_arg1863z00_1925;
BgL_arg1862z00_1924 = 
CAR(
((obj_t)BgL_cdrzd28597zd2_1903)); 
BgL_arg1863z00_1925 = 
CDR(
((obj_t)BgL_cdrzd28597zd2_1903)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6261;
{ 
obj_t BgL_bodyz00_6263;obj_t BgL_mz00_6262;
BgL_mz00_6262 = BgL_arg1862z00_1924; 
BgL_bodyz00_6263 = BgL_arg1863z00_1925; 
BgL_bodyz00_1529 = BgL_bodyz00_6263; 
BgL_mz00_1528 = BgL_mz00_6262; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6261);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1864z00_1926;
BgL_arg1864z00_1926 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6266;
{ 
obj_t BgL_argsz00_6268;obj_t BgL_fz00_6267;
BgL_fz00_6267 = BgL_arg1864z00_1926; 
BgL_argsz00_6268 = BgL_cdrzd28597zd2_1903; 
BgL_argsz00_1536 = BgL_argsz00_6268; 
BgL_fz00_1535 = BgL_fz00_6267; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6266);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3067z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd28597zd2_1903))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd28709zd2_1932;
BgL_cdrzd28709zd2_1932 = 
CDR(BgL_cdrzd28597zd2_1903); 
if(
PAIRP(BgL_cdrzd28709zd2_1932))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd28709zd2_1932)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1872z00_1936;obj_t BgL_arg1873z00_1937;
BgL_arg1872z00_1936 = 
CAR(BgL_cdrzd28597zd2_1903); 
BgL_arg1873z00_1937 = 
CAR(BgL_cdrzd28709zd2_1932); 
{ 
BgL_ev_absz00_bglt BgL_auxz00_6283;
BgL_formalsz00_1531 = BgL_arg1872z00_1936; 
BgL_bodyz00_1532 = BgL_arg1873z00_1937; 
BgL_tagzd2174zd2_1533:
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2331z00_2621;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2332z00_2622;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2333z00_2623;obj_t BgL_arg2334z00_2624;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_res2801z00_3563;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_symbolz00_3561;
BgL_symbolz00_3561 = BGl_symbol3080z00zz__evaluatez00; 
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2505z00_3562;
BgL_arg2505z00_3562 = 
SYMBOL_TO_STRING(BgL_symbolz00_3561); 
BgL_res2801z00_3563 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2505z00_3562); } } 
BgL_arg2333z00_2623 = BgL_res2801z00_3563; } 
{ /* Eval/evaluate.scm 595 */
obj_t BgL_res2802z00_3566;
{ /* Eval/evaluate.scm 595 */
obj_t BgL_arg2505z00_3565;
BgL_arg2505z00_3565 = 
SYMBOL_TO_STRING(
((obj_t)BgL_wherez00_73)); 
BgL_res2802z00_3566 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2505z00_3565); } 
BgL_arg2334z00_2624 = BgL_res2802z00_3566; } 
BgL_arg2332z00_2622 = 
string_append(BgL_arg2333z00_2623, BgL_arg2334z00_2624); } 
BgL_arg2331z00_2621 = 
bstring_to_symbol(BgL_arg2332z00_2622); } 
BgL_auxz00_6283 = 
BGl_convzd2lambdaze70z35zz__evaluatez00(BgL_globalsz00_71, BgL_localsz00_70, BgL_ez00_69, BgL_locz00_74, BgL_formalsz00_1531, BgL_bodyz00_1532, BgL_arg2331z00_2621, BFALSE); } 
return 
((obj_t)BgL_auxz00_6283);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1874z00_1938;obj_t BgL_arg1875z00_1939;
BgL_arg1874z00_1938 = 
CAR(BgL_ez00_69); 
BgL_arg1875z00_1939 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6295;
{ 
obj_t BgL_argsz00_6297;obj_t BgL_fz00_6296;
BgL_fz00_6296 = BgL_arg1874z00_1938; 
BgL_argsz00_6297 = BgL_arg1875z00_1939; 
BgL_argsz00_1536 = BgL_argsz00_6297; 
BgL_fz00_1535 = BgL_fz00_6296; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6295);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1877z00_1941;obj_t BgL_arg1878z00_1942;
BgL_arg1877z00_1941 = 
CAR(BgL_ez00_69); 
BgL_arg1878z00_1942 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6301;
{ 
obj_t BgL_argsz00_6303;obj_t BgL_fz00_6302;
BgL_fz00_6302 = BgL_arg1877z00_1941; 
BgL_argsz00_6303 = BgL_arg1878z00_1942; 
BgL_argsz00_1536 = BgL_argsz00_6303; 
BgL_fz00_1535 = BgL_fz00_6302; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6301);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1879z00_1943;obj_t BgL_arg1880z00_1944;
BgL_arg1879z00_1943 = 
CAR(BgL_ez00_69); 
BgL_arg1880z00_1944 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6307;
{ 
obj_t BgL_argsz00_6309;obj_t BgL_fz00_6308;
BgL_fz00_6308 = BgL_arg1879z00_1943; 
BgL_argsz00_6309 = BgL_arg1880z00_1944; 
BgL_argsz00_1536 = BgL_argsz00_6309; 
BgL_fz00_1535 = BgL_fz00_6308; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6307);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3118z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
BgL_tagzd2175zd2_1534:
return 
BGl_errorz00zz__errorz00(BGl_string3078z00zz__evaluatez00, BGl_string3079z00zz__evaluatez00, BgL_ez00_69);}  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1883z00_1947;obj_t BgL_arg1884z00_1948;
BgL_arg1883z00_1947 = 
CAR(BgL_ez00_69); 
BgL_arg1884z00_1948 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6317;
{ 
obj_t BgL_argsz00_6319;obj_t BgL_fz00_6318;
BgL_fz00_6318 = BgL_arg1883z00_1947; 
BgL_argsz00_6319 = BgL_arg1884z00_1948; 
BgL_argsz00_1536 = BgL_argsz00_6319; 
BgL_fz00_1535 = BgL_fz00_6318; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6317);} } } } } } } } } } } } } } } } } } } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(BgL_carzd23841zd2_1610==BGl_symbol3094z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd2250zd2_1544))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd2250zd2_1544)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1907z00_1973;
BgL_arg1907z00_1973 = 
CAR(BgL_cdrzd2250zd2_1544); 
{ 
BgL_ev_trapz00_bglt BgL_auxz00_6329;
{ 
obj_t BgL_ez00_6330;
BgL_ez00_6330 = BgL_arg1907z00_1973; 
BgL_ez00_1471 = BgL_ez00_6330; 
goto BgL_tagzd2153zd2_1472;} 
return 
((obj_t)BgL_auxz00_6329);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1908z00_1974;obj_t BgL_arg1909z00_1975;
BgL_arg1908z00_1974 = 
CAR(BgL_ez00_69); 
BgL_arg1909z00_1975 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6334;
{ 
obj_t BgL_argsz00_6336;obj_t BgL_fz00_6335;
BgL_fz00_6335 = BgL_arg1908z00_1974; 
BgL_argsz00_6336 = BgL_arg1909z00_1975; 
BgL_argsz00_1536 = BgL_argsz00_6336; 
BgL_fz00_1535 = BgL_fz00_6335; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6334);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1911z00_1977;obj_t BgL_arg1912z00_1978;
BgL_arg1911z00_1977 = 
CAR(BgL_ez00_69); 
BgL_arg1912z00_1978 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6340;
{ 
obj_t BgL_argsz00_6342;obj_t BgL_fz00_6341;
BgL_fz00_6341 = BgL_arg1911z00_1977; 
BgL_argsz00_6342 = BgL_arg1912z00_1978; 
BgL_argsz00_1536 = BgL_argsz00_6342; 
BgL_fz00_1535 = BgL_fz00_6341; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6340);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd29422zd2_1979;
BgL_cdrzd29422zd2_1979 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3055z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd29422zd2_1979))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd29422zd2_1979)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1918z00_1985;
BgL_arg1918z00_1985 = 
CAR(BgL_cdrzd29422zd2_1979); 
{ 
BgL_ev_littz00_bglt BgL_auxz00_6354;
{ 
obj_t BgL_vz00_6355;
BgL_vz00_6355 = BgL_arg1918z00_1985; 
BgL_vz00_1473 = BgL_vz00_6355; 
goto BgL_tagzd2154zd2_1474;} 
return 
((obj_t)BgL_auxz00_6354);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1919z00_1986;
BgL_arg1919z00_1986 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6358;
{ 
obj_t BgL_argsz00_6360;obj_t BgL_fz00_6359;
BgL_fz00_6359 = BgL_arg1919z00_1986; 
BgL_argsz00_6360 = BgL_cdrzd29422zd2_1979; 
BgL_argsz00_1536 = BgL_argsz00_6360; 
BgL_fz00_1535 = BgL_fz00_6359; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6358);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1922z00_1989;
BgL_arg1922z00_1989 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6363;
{ 
obj_t BgL_argsz00_6365;obj_t BgL_fz00_6364;
BgL_fz00_6364 = BgL_arg1922z00_1989; 
BgL_argsz00_6365 = BgL_cdrzd29422zd2_1979; 
BgL_argsz00_1536 = BgL_argsz00_6365; 
BgL_fz00_1535 = BgL_fz00_6364; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6363);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3063z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd29422zd2_1979))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd210036zd2_1995;
BgL_cdrzd210036zd2_1995 = 
CDR(BgL_cdrzd29422zd2_1979); 
if(
PAIRP(BgL_cdrzd210036zd2_1995))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd210041zd2_1997;
BgL_cdrzd210041zd2_1997 = 
CDR(BgL_cdrzd210036zd2_1995); 
if(
PAIRP(BgL_cdrzd210041zd2_1997))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd210041zd2_1997)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1931z00_2001;obj_t BgL_arg1932z00_2002;obj_t BgL_arg1933z00_2003;
BgL_arg1931z00_2001 = 
CAR(BgL_cdrzd29422zd2_1979); 
BgL_arg1932z00_2002 = 
CAR(BgL_cdrzd210036zd2_1995); 
BgL_arg1933z00_2003 = 
CAR(BgL_cdrzd210041zd2_1997); 
{ 
BgL_ev_ifz00_bglt BgL_auxz00_6384;
{ 
obj_t BgL_oz00_6387;obj_t BgL_tz00_6386;obj_t BgL_pz00_6385;
BgL_pz00_6385 = BgL_arg1931z00_2001; 
BgL_tz00_6386 = BgL_arg1932z00_2002; 
BgL_oz00_6387 = BgL_arg1933z00_2003; 
BgL_oz00_1477 = BgL_oz00_6387; 
BgL_tz00_1476 = BgL_tz00_6386; 
BgL_pz00_1475 = BgL_pz00_6385; 
goto BgL_tagzd2155zd2_1478;} 
return 
((obj_t)BgL_auxz00_6384);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1934z00_2004;obj_t BgL_arg1935z00_2005;
BgL_arg1934z00_2004 = 
CAR(BgL_ez00_69); 
BgL_arg1935z00_2005 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6391;
{ 
obj_t BgL_argsz00_6393;obj_t BgL_fz00_6392;
BgL_fz00_6392 = BgL_arg1934z00_2004; 
BgL_argsz00_6393 = BgL_arg1935z00_2005; 
BgL_argsz00_1536 = BgL_argsz00_6393; 
BgL_fz00_1535 = BgL_fz00_6392; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6391);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd210341zd2_2007;
BgL_cdrzd210341zd2_2007 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd210347zd2_2008;
BgL_cdrzd210347zd2_2008 = 
CDR(
((obj_t)BgL_cdrzd210341zd2_2007)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd210347zd2_2008))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1939z00_2011;obj_t BgL_arg1940z00_2012;
BgL_arg1939z00_2011 = 
CAR(
((obj_t)BgL_cdrzd210341zd2_2007)); 
BgL_arg1940z00_2012 = 
CAR(
((obj_t)BgL_cdrzd210347zd2_2008)); 
{ 
BgL_ev_ifz00_bglt BgL_auxz00_6406;
{ 
obj_t BgL_tz00_6408;obj_t BgL_pz00_6407;
BgL_pz00_6407 = BgL_arg1939z00_2011; 
BgL_tz00_6408 = BgL_arg1940z00_2012; 
BgL_tz00_1480 = BgL_tz00_6408; 
BgL_pz00_1479 = BgL_pz00_6407; 
goto BgL_tagzd2156zd2_1481;} 
return 
((obj_t)BgL_auxz00_6406);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1941z00_2013;
BgL_arg1941z00_2013 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6411;
{ 
obj_t BgL_argsz00_6413;obj_t BgL_fz00_6412;
BgL_fz00_6412 = BgL_arg1941z00_2013; 
BgL_argsz00_6413 = BgL_cdrzd210341zd2_2007; 
BgL_argsz00_1536 = BgL_argsz00_6413; 
BgL_fz00_1535 = BgL_fz00_6412; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6411);} } } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1944z00_2016;obj_t BgL_arg1945z00_2017;
BgL_arg1944z00_2016 = 
CAR(BgL_ez00_69); 
BgL_arg1945z00_2017 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6417;
{ 
obj_t BgL_argsz00_6419;obj_t BgL_fz00_6418;
BgL_fz00_6418 = BgL_arg1944z00_2016; 
BgL_argsz00_6419 = BgL_arg1945z00_2017; 
BgL_argsz00_1536 = BgL_argsz00_6419; 
BgL_fz00_1535 = BgL_fz00_6418; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6417);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1946z00_2018;obj_t BgL_arg1947z00_2019;
BgL_arg1946z00_2018 = 
CAR(BgL_ez00_69); 
BgL_arg1947z00_2019 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6423;
{ 
obj_t BgL_argsz00_6425;obj_t BgL_fz00_6424;
BgL_fz00_6424 = BgL_arg1946z00_2018; 
BgL_argsz00_6425 = BgL_arg1947z00_2019; 
BgL_argsz00_1536 = BgL_argsz00_6425; 
BgL_fz00_1535 = BgL_fz00_6424; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6423);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3096z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1950z00_2022;
BgL_arg1950z00_2022 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_orz00_bglt BgL_auxz00_6431;
{ 
obj_t BgL_argsz00_6432;
BgL_argsz00_6432 = BgL_arg1950z00_2022; 
BgL_argsz00_1482 = BgL_argsz00_6432; 
goto BgL_tagzd2157zd2_1483;} 
return 
((obj_t)BgL_auxz00_6431);} }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3098z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1953z00_2025;
BgL_arg1953z00_2025 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_andz00_bglt BgL_auxz00_6438;
{ 
obj_t BgL_argsz00_6439;
BgL_argsz00_6439 = BgL_arg1953z00_2025; 
BgL_argsz00_1484 = BgL_argsz00_6439; 
goto BgL_tagzd2158zd2_1485;} 
return 
((obj_t)BgL_auxz00_6438);} }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3083z00zz__evaluatez00))
{ 
obj_t BgL_lz00_6444;
BgL_lz00_6444 = 
CDR(BgL_ez00_69); 
BgL_lz00_1486 = BgL_lz00_6444; 
goto BgL_tagzd2159zd2_1487;}  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211246zd2_2029;
BgL_cdrzd211246zd2_2029 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3065z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211246zd2_2029))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1960z00_2033;obj_t BgL_arg1961z00_2034;
BgL_arg1960z00_2033 = 
CAR(BgL_cdrzd211246zd2_2029); 
BgL_arg1961z00_2034 = 
CDR(BgL_cdrzd211246zd2_2029); 
{ 
BgL_ev_letz00_bglt BgL_auxz00_6454;
{ 
obj_t BgL_bodyz00_6456;obj_t BgL_bindsz00_6455;
BgL_bindsz00_6455 = BgL_arg1960z00_2033; 
BgL_bodyz00_6456 = BgL_arg1961z00_2034; 
BgL_bodyz00_1489 = BgL_bodyz00_6456; 
BgL_bindsz00_1488 = BgL_bindsz00_6455; 
goto BgL_tagzd2160zd2_1490;} 
return 
((obj_t)BgL_auxz00_6454);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1962z00_2035;
BgL_arg1962z00_2035 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6459;
{ 
obj_t BgL_argsz00_6461;obj_t BgL_fz00_6460;
BgL_fz00_6460 = BgL_arg1962z00_2035; 
BgL_argsz00_6461 = BgL_cdrzd211246zd2_2029; 
BgL_argsz00_1536 = BgL_argsz00_6461; 
BgL_fz00_1535 = BgL_fz00_6460; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6459);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3100z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211246zd2_2029))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1967z00_2041;obj_t BgL_arg1968z00_2042;
BgL_arg1967z00_2041 = 
CAR(BgL_cdrzd211246zd2_2029); 
BgL_arg1968z00_2042 = 
CDR(BgL_cdrzd211246zd2_2029); 
{ 
BgL_ev_letza2za2_bglt BgL_auxz00_6470;
{ 
obj_t BgL_bodyz00_6472;obj_t BgL_bindsz00_6471;
BgL_bindsz00_6471 = BgL_arg1967z00_2041; 
BgL_bodyz00_6472 = BgL_arg1968z00_2042; 
BgL_bodyz00_1492 = BgL_bodyz00_6472; 
BgL_bindsz00_1491 = BgL_bindsz00_6471; 
goto BgL_tagzd2161zd2_1493;} 
return 
((obj_t)BgL_auxz00_6470);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1969z00_2043;obj_t BgL_arg1970z00_2044;
BgL_arg1969z00_2043 = 
CAR(BgL_ez00_69); 
BgL_arg1970z00_2044 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6476;
{ 
obj_t BgL_argsz00_6478;obj_t BgL_fz00_6477;
BgL_fz00_6477 = BgL_arg1969z00_2043; 
BgL_argsz00_6478 = BgL_arg1970z00_2044; 
BgL_argsz00_1536 = BgL_argsz00_6478; 
BgL_fz00_1535 = BgL_fz00_6477; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6476);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211644zd2_2045;
BgL_cdrzd211644zd2_2045 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3102z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211644zd2_2045))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1974z00_2049;obj_t BgL_arg1975z00_2050;
BgL_arg1974z00_2049 = 
CAR(BgL_cdrzd211644zd2_2045); 
BgL_arg1975z00_2050 = 
CDR(BgL_cdrzd211644zd2_2045); 
{ 
BgL_ev_letrecz00_bglt BgL_auxz00_6488;
{ 
obj_t BgL_bodyz00_6490;obj_t BgL_bindsz00_6489;
BgL_bindsz00_6489 = BgL_arg1974z00_2049; 
BgL_bodyz00_6490 = BgL_arg1975z00_2050; 
BgL_bodyz00_1495 = BgL_bodyz00_6490; 
BgL_bindsz00_1494 = BgL_bindsz00_6489; 
goto BgL_tagzd2162zd2_1496;} 
return 
((obj_t)BgL_auxz00_6488);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1976z00_2051;
BgL_arg1976z00_2051 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6493;
{ 
obj_t BgL_argsz00_6495;obj_t BgL_fz00_6494;
BgL_fz00_6494 = BgL_arg1976z00_2051; 
BgL_argsz00_6495 = BgL_cdrzd211644zd2_2045; 
BgL_argsz00_1536 = BgL_argsz00_6495; 
BgL_fz00_1535 = BgL_fz00_6494; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6493);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3104z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211644zd2_2045))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd211820zd2_2057;obj_t BgL_cdrzd211821zd2_2058;
BgL_carzd211820zd2_2057 = 
CAR(BgL_cdrzd211644zd2_2045); 
BgL_cdrzd211821zd2_2058 = 
CDR(BgL_cdrzd211644zd2_2045); 
if(
PAIRP(BgL_carzd211820zd2_2057))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211825zd2_2060;
BgL_cdrzd211825zd2_2060 = 
CDR(BgL_carzd211820zd2_2057); 
if(
(
CAR(BgL_carzd211820zd2_2057)==BGl_symbol3090z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211825zd2_2060))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd211828zd2_2064;obj_t BgL_cdrzd211829zd2_2065;
BgL_carzd211828zd2_2064 = 
CAR(BgL_cdrzd211825zd2_2060); 
BgL_cdrzd211829zd2_2065 = 
CDR(BgL_cdrzd211825zd2_2060); 
if(
SYMBOLP(BgL_carzd211828zd2_2064))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211829zd2_2065))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd211833zd2_2068;
BgL_carzd211833zd2_2068 = 
CAR(BgL_cdrzd211829zd2_2065); 
if(
SYMBOLP(BgL_carzd211833zd2_2068))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd211829zd2_2065)))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd211821zd2_2058))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd211821zd2_2058)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1993z00_2075;
BgL_arg1993z00_2075 = 
CAR(BgL_cdrzd211821zd2_2058); 
{ 
BgL_ev_setglobalz00_bglt BgL_auxz00_6530;
{ 
obj_t BgL_ez00_6533;obj_t BgL_modnamez00_6532;obj_t BgL_idz00_6531;
BgL_idz00_6531 = BgL_carzd211828zd2_2064; 
BgL_modnamez00_6532 = BgL_carzd211833zd2_2068; 
BgL_ez00_6533 = BgL_arg1993z00_2075; 
BgL_ez00_1499 = BgL_ez00_6533; 
BgL_modnamez00_1498 = BgL_modnamez00_6532; 
BgL_idz00_1497 = BgL_idz00_6531; 
goto BgL_tagzd2163zd2_1500;} 
return 
((obj_t)BgL_auxz00_6530);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211949zd2_2077;
BgL_cdrzd211949zd2_2077 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd211953zd2_2078;
BgL_cdrzd211953zd2_2078 = 
CDR(
((obj_t)BgL_cdrzd211949zd2_2077)); 
if(
PAIRP(BgL_cdrzd211953zd2_2078))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd211953zd2_2078)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg1998z00_2082;obj_t BgL_arg1999z00_2083;
BgL_arg1998z00_2082 = 
CAR(
((obj_t)BgL_cdrzd211949zd2_2077)); 
BgL_arg1999z00_2083 = 
CAR(BgL_cdrzd211953zd2_2078); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6546;
{ 
obj_t BgL_ez00_6548;obj_t BgL_vz00_6547;
BgL_vz00_6547 = BgL_arg1998z00_2082; 
BgL_ez00_6548 = BgL_arg1999z00_2083; 
BgL_ez00_1505 = BgL_ez00_6548; 
BgL_vz00_1504 = BgL_vz00_6547; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6546);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212010zd2_2086;
BgL_cdrzd212010zd2_2086 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212014zd2_2087;
BgL_cdrzd212014zd2_2087 = 
CDR(
((obj_t)BgL_cdrzd212010zd2_2086)); 
if(
PAIRP(BgL_cdrzd212014zd2_2087))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212014zd2_2087)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2005z00_2091;obj_t BgL_arg2006z00_2092;
BgL_arg2005z00_2091 = 
CAR(
((obj_t)BgL_cdrzd212010zd2_2086)); 
BgL_arg2006z00_2092 = 
CAR(BgL_cdrzd212014zd2_2087); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6561;
{ 
obj_t BgL_ez00_6563;obj_t BgL_vz00_6562;
BgL_vz00_6562 = BgL_arg2005z00_2091; 
BgL_ez00_6563 = BgL_arg2006z00_2092; 
BgL_ez00_1505 = BgL_ez00_6563; 
BgL_vz00_1504 = BgL_vz00_6562; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6561);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212071zd2_2094;
BgL_cdrzd212071zd2_2094 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212075zd2_2095;
BgL_cdrzd212075zd2_2095 = 
CDR(
((obj_t)BgL_cdrzd212071zd2_2094)); 
if(
PAIRP(BgL_cdrzd212075zd2_2095))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212075zd2_2095)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2011z00_2099;obj_t BgL_arg2012z00_2100;
BgL_arg2011z00_2099 = 
CAR(
((obj_t)BgL_cdrzd212071zd2_2094)); 
BgL_arg2012z00_2100 = 
CAR(BgL_cdrzd212075zd2_2095); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6576;
{ 
obj_t BgL_ez00_6578;obj_t BgL_vz00_6577;
BgL_vz00_6577 = BgL_arg2011z00_2099; 
BgL_ez00_6578 = BgL_arg2012z00_2100; 
BgL_ez00_1505 = BgL_ez00_6578; 
BgL_vz00_1504 = BgL_vz00_6577; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6576);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212132zd2_2102;
BgL_cdrzd212132zd2_2102 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212136zd2_2103;
BgL_cdrzd212136zd2_2103 = 
CDR(
((obj_t)BgL_cdrzd212132zd2_2102)); 
if(
PAIRP(BgL_cdrzd212136zd2_2103))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212136zd2_2103)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2017z00_2107;obj_t BgL_arg2018z00_2108;
BgL_arg2017z00_2107 = 
CAR(
((obj_t)BgL_cdrzd212132zd2_2102)); 
BgL_arg2018z00_2108 = 
CAR(BgL_cdrzd212136zd2_2103); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6591;
{ 
obj_t BgL_ez00_6593;obj_t BgL_vz00_6592;
BgL_vz00_6592 = BgL_arg2017z00_2107; 
BgL_ez00_6593 = BgL_arg2018z00_2108; 
BgL_ez00_1505 = BgL_ez00_6593; 
BgL_vz00_1504 = BgL_vz00_6592; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6591);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212193zd2_2110;
BgL_cdrzd212193zd2_2110 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212197zd2_2111;
BgL_cdrzd212197zd2_2111 = 
CDR(
((obj_t)BgL_cdrzd212193zd2_2110)); 
if(
PAIRP(BgL_cdrzd212197zd2_2111))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212197zd2_2111)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2023z00_2115;obj_t BgL_arg2024z00_2116;
BgL_arg2023z00_2115 = 
CAR(
((obj_t)BgL_cdrzd212193zd2_2110)); 
BgL_arg2024z00_2116 = 
CAR(BgL_cdrzd212197zd2_2111); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6606;
{ 
obj_t BgL_ez00_6608;obj_t BgL_vz00_6607;
BgL_vz00_6607 = BgL_arg2023z00_2115; 
BgL_ez00_6608 = BgL_arg2024z00_2116; 
BgL_ez00_1505 = BgL_ez00_6608; 
BgL_vz00_1504 = BgL_vz00_6607; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6606);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212241zd2_2118;
BgL_cdrzd212241zd2_2118 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd212244zd2_2119;obj_t BgL_cdrzd212245zd2_2120;
BgL_carzd212244zd2_2119 = 
CAR(
((obj_t)BgL_cdrzd212241zd2_2118)); 
BgL_cdrzd212245zd2_2120 = 
CDR(
((obj_t)BgL_cdrzd212241zd2_2118)); 
if(
(
CAR(
((obj_t)BgL_carzd212244zd2_2119))==BGl_symbol3092z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd212245zd2_2120))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212245zd2_2120)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2031z00_2126;obj_t BgL_arg2032z00_2127;
BgL_arg2031z00_2126 = 
CDR(
((obj_t)BgL_carzd212244zd2_2119)); 
BgL_arg2032z00_2127 = 
CAR(BgL_cdrzd212245zd2_2120); 
{ 
obj_t BgL_e2z00_6628;obj_t BgL_lz00_6627;
BgL_lz00_6627 = BgL_arg2031z00_2126; 
BgL_e2z00_6628 = BgL_arg2032z00_2127; 
BgL_e2z00_1502 = BgL_e2z00_6628; 
BgL_lz00_1501 = BgL_lz00_6627; 
goto BgL_tagzd2164zd2_1503;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212321zd2_2130;
BgL_cdrzd212321zd2_2130 = 
CDR(
((obj_t)BgL_cdrzd212241zd2_2118)); 
if(
PAIRP(BgL_cdrzd212321zd2_2130))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212321zd2_2130)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2037z00_2134;obj_t BgL_arg2038z00_2135;
BgL_arg2037z00_2134 = 
CAR(
((obj_t)BgL_cdrzd212241zd2_2118)); 
BgL_arg2038z00_2135 = 
CAR(BgL_cdrzd212321zd2_2130); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6639;
{ 
obj_t BgL_ez00_6641;obj_t BgL_vz00_6640;
BgL_vz00_6640 = BgL_arg2037z00_2134; 
BgL_ez00_6641 = BgL_arg2038z00_2135; 
BgL_ez00_1505 = BgL_ez00_6641; 
BgL_vz00_1504 = BgL_vz00_6640; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6639);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212378zd2_2139;
BgL_cdrzd212378zd2_2139 = 
CDR(BgL_ez00_69); 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212382zd2_2140;
BgL_cdrzd212382zd2_2140 = 
CDR(
((obj_t)BgL_cdrzd212378zd2_2139)); 
if(
PAIRP(BgL_cdrzd212382zd2_2140))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212382zd2_2140)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2045z00_2144;obj_t BgL_arg2046z00_2145;
BgL_arg2045z00_2144 = 
CAR(
((obj_t)BgL_cdrzd212378zd2_2139)); 
BgL_arg2046z00_2145 = 
CAR(BgL_cdrzd212382zd2_2140); 
{ 
BgL_ev_hookz00_bglt BgL_auxz00_6654;
{ 
obj_t BgL_ez00_6656;obj_t BgL_vz00_6655;
BgL_vz00_6655 = BgL_arg2045z00_2144; 
BgL_ez00_6656 = BgL_arg2046z00_2145; 
BgL_ez00_1505 = BgL_ez00_6656; 
BgL_vz00_1504 = BgL_vz00_6655; 
goto BgL_tagzd2165zd2_1506;} 
return 
((obj_t)BgL_auxz00_6654);} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} } } }  else 
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2166zd2_1507;} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212503zd2_2147;
BgL_cdrzd212503zd2_2147 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3106z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd212503zd2_2147))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212508zd2_2151;
BgL_cdrzd212508zd2_2151 = 
CDR(BgL_cdrzd212503zd2_2147); 
if(
PAIRP(BgL_cdrzd212508zd2_2151))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd212512zd2_2153;
BgL_carzd212512zd2_2153 = 
CAR(BgL_cdrzd212508zd2_2151); 
if(
PAIRP(BgL_carzd212512zd2_2153))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212517zd2_2155;
BgL_cdrzd212517zd2_2155 = 
CDR(BgL_carzd212512zd2_2153); 
if(
(
CAR(BgL_carzd212512zd2_2153)==BGl_symbol3067z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd212517zd2_2155))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212521zd2_2159;
BgL_cdrzd212521zd2_2159 = 
CDR(BgL_cdrzd212517zd2_2155); 
if(
PAIRP(BgL_cdrzd212521zd2_2159))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212521zd2_2159)))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd212508zd2_2151)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2061z00_2165;obj_t BgL_arg2062z00_2166;obj_t BgL_arg2063z00_2167;
BgL_arg2061z00_2165 = 
CAR(BgL_cdrzd212503zd2_2147); 
BgL_arg2062z00_2166 = 
CAR(BgL_cdrzd212517zd2_2155); 
BgL_arg2063z00_2167 = 
CAR(BgL_cdrzd212521zd2_2159); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6688;
{ 
obj_t BgL_bodyz00_6691;obj_t BgL_formalsz00_6690;obj_t BgL_gvz00_6689;
BgL_gvz00_6689 = BgL_arg2061z00_2165; 
BgL_formalsz00_6690 = BgL_arg2062z00_2166; 
BgL_bodyz00_6691 = BgL_arg2063z00_2167; 
BgL_bodyz00_1510 = BgL_bodyz00_6691; 
BgL_formalsz00_1509 = BgL_formalsz00_6690; 
BgL_gvz00_1508 = BgL_gvz00_6689; 
goto BgL_tagzd2167zd2_1511;} 
return 
((obj_t)BgL_auxz00_6688);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2064z00_2168;
BgL_arg2064z00_2168 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6694;
{ 
obj_t BgL_argsz00_6696;obj_t BgL_fz00_6695;
BgL_fz00_6695 = BgL_arg2064z00_2168; 
BgL_argsz00_6696 = BgL_cdrzd212503zd2_2147; 
BgL_argsz00_1536 = BgL_argsz00_6696; 
BgL_fz00_1535 = BgL_fz00_6695; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6694);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212623zd2_2172;
BgL_cdrzd212623zd2_2172 = 
CDR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212623zd2_2172))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2069z00_2175;obj_t BgL_arg2070z00_2176;
BgL_arg2069z00_2175 = 
CAR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
BgL_arg2070z00_2176 = 
CAR(
((obj_t)BgL_cdrzd212623zd2_2172)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6708;
{ 
obj_t BgL_gez00_6710;obj_t BgL_gvz00_6709;
BgL_gvz00_6709 = BgL_arg2069z00_2175; 
BgL_gez00_6710 = BgL_arg2070z00_2176; 
BgL_gez00_1513 = BgL_gez00_6710; 
BgL_gvz00_1512 = BgL_gvz00_6709; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6708);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2071z00_2177;obj_t BgL_arg2072z00_2178;
BgL_arg2071z00_2177 = 
CAR(BgL_ez00_69); 
BgL_arg2072z00_2178 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6714;
{ 
obj_t BgL_argsz00_6716;obj_t BgL_fz00_6715;
BgL_fz00_6715 = BgL_arg2071z00_2177; 
BgL_argsz00_6716 = BgL_arg2072z00_2178; 
BgL_argsz00_1536 = BgL_argsz00_6716; 
BgL_fz00_1535 = BgL_fz00_6715; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6714);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212712zd2_2182;
BgL_cdrzd212712zd2_2182 = 
CDR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212712zd2_2182))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2077z00_2185;obj_t BgL_arg2078z00_2186;
BgL_arg2077z00_2185 = 
CAR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
BgL_arg2078z00_2186 = 
CAR(
((obj_t)BgL_cdrzd212712zd2_2182)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6728;
{ 
obj_t BgL_gez00_6730;obj_t BgL_gvz00_6729;
BgL_gvz00_6729 = BgL_arg2077z00_2185; 
BgL_gez00_6730 = BgL_arg2078z00_2186; 
BgL_gez00_1513 = BgL_gez00_6730; 
BgL_gvz00_1512 = BgL_gvz00_6729; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6728);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2079z00_2187;obj_t BgL_arg2080z00_2188;
BgL_arg2079z00_2187 = 
CAR(BgL_ez00_69); 
BgL_arg2080z00_2188 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6734;
{ 
obj_t BgL_argsz00_6736;obj_t BgL_fz00_6735;
BgL_fz00_6735 = BgL_arg2079z00_2187; 
BgL_argsz00_6736 = BgL_arg2080z00_2188; 
BgL_argsz00_1536 = BgL_argsz00_6736; 
BgL_fz00_1535 = BgL_fz00_6735; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6734);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212801zd2_2191;
BgL_cdrzd212801zd2_2191 = 
CDR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212801zd2_2191))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2084z00_2194;obj_t BgL_arg2085z00_2195;
BgL_arg2084z00_2194 = 
CAR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
BgL_arg2085z00_2195 = 
CAR(
((obj_t)BgL_cdrzd212801zd2_2191)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6748;
{ 
obj_t BgL_gez00_6750;obj_t BgL_gvz00_6749;
BgL_gvz00_6749 = BgL_arg2084z00_2194; 
BgL_gez00_6750 = BgL_arg2085z00_2195; 
BgL_gez00_1513 = BgL_gez00_6750; 
BgL_gvz00_1512 = BgL_gvz00_6749; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6748);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2086z00_2196;obj_t BgL_arg2087z00_2197;
BgL_arg2086z00_2196 = 
CAR(BgL_ez00_69); 
BgL_arg2087z00_2197 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6754;
{ 
obj_t BgL_argsz00_6756;obj_t BgL_fz00_6755;
BgL_fz00_6755 = BgL_arg2086z00_2196; 
BgL_argsz00_6756 = BgL_arg2087z00_2197; 
BgL_argsz00_1536 = BgL_argsz00_6756; 
BgL_fz00_1535 = BgL_fz00_6755; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6754);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212890zd2_2200;
BgL_cdrzd212890zd2_2200 = 
CDR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212890zd2_2200))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2091z00_2203;obj_t BgL_arg2092z00_2204;
BgL_arg2091z00_2203 = 
CAR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
BgL_arg2092z00_2204 = 
CAR(
((obj_t)BgL_cdrzd212890zd2_2200)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6768;
{ 
obj_t BgL_gez00_6770;obj_t BgL_gvz00_6769;
BgL_gvz00_6769 = BgL_arg2091z00_2203; 
BgL_gez00_6770 = BgL_arg2092z00_2204; 
BgL_gez00_1513 = BgL_gez00_6770; 
BgL_gvz00_1512 = BgL_gvz00_6769; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6768);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2093z00_2205;obj_t BgL_arg2094z00_2206;
BgL_arg2093z00_2205 = 
CAR(BgL_ez00_69); 
BgL_arg2094z00_2206 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6774;
{ 
obj_t BgL_argsz00_6776;obj_t BgL_fz00_6775;
BgL_fz00_6775 = BgL_arg2093z00_2205; 
BgL_argsz00_6776 = BgL_arg2094z00_2206; 
BgL_argsz00_1536 = BgL_argsz00_6776; 
BgL_fz00_1535 = BgL_fz00_6775; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6774);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd212979zd2_2210;
BgL_cdrzd212979zd2_2210 = 
CDR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
if(
NULLP(
CDR(
((obj_t)BgL_cdrzd212979zd2_2210))))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2099z00_2213;obj_t BgL_arg2100z00_2214;
BgL_arg2099z00_2213 = 
CAR(
((obj_t)BgL_cdrzd212503zd2_2147)); 
BgL_arg2100z00_2214 = 
CAR(
((obj_t)BgL_cdrzd212979zd2_2210)); 
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_6788;
{ 
obj_t BgL_gez00_6790;obj_t BgL_gvz00_6789;
BgL_gvz00_6789 = BgL_arg2099z00_2213; 
BgL_gez00_6790 = BgL_arg2100z00_2214; 
BgL_gez00_1513 = BgL_gez00_6790; 
BgL_gvz00_1512 = BgL_gvz00_6789; 
goto BgL_tagzd2168zd2_1514;} 
return 
((obj_t)BgL_auxz00_6788);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2101z00_2215;obj_t BgL_arg2102z00_2216;
BgL_arg2101z00_2215 = 
CAR(BgL_ez00_69); 
BgL_arg2102z00_2216 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6794;
{ 
obj_t BgL_argsz00_6796;obj_t BgL_fz00_6795;
BgL_fz00_6795 = BgL_arg2101z00_2215; 
BgL_argsz00_6796 = BgL_arg2102z00_2216; 
BgL_argsz00_1536 = BgL_argsz00_6796; 
BgL_fz00_1535 = BgL_fz00_6795; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6794);} } } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2104z00_2218;
BgL_arg2104z00_2218 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6799;
{ 
obj_t BgL_argsz00_6801;obj_t BgL_fz00_6800;
BgL_fz00_6800 = BgL_arg2104z00_2218; 
BgL_argsz00_6801 = BgL_cdrzd212503zd2_2147; 
BgL_argsz00_1536 = BgL_argsz00_6801; 
BgL_fz00_1535 = BgL_fz00_6800; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6799);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2106z00_2220;
BgL_arg2106z00_2220 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6804;
{ 
obj_t BgL_argsz00_6806;obj_t BgL_fz00_6805;
BgL_fz00_6805 = BgL_arg2106z00_2220; 
BgL_argsz00_6806 = BgL_cdrzd212503zd2_2147; 
BgL_argsz00_1536 = BgL_argsz00_6806; 
BgL_fz00_1535 = BgL_fz00_6805; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6804);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3108z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd212503zd2_2147))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_carzd213227zd2_2226;
BgL_carzd213227zd2_2226 = 
CAR(BgL_cdrzd212503zd2_2147); 
if(
PAIRP(BgL_carzd213227zd2_2226))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_carzd213227zd2_2226)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2114z00_2230;obj_t BgL_arg2115z00_2231;
BgL_arg2114z00_2230 = 
CAR(BgL_carzd213227zd2_2226); 
BgL_arg2115z00_2231 = 
CDR(BgL_cdrzd212503zd2_2147); 
{ 
BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_6821;
{ 
obj_t BgL_bodyz00_6823;obj_t BgL_vz00_6822;
BgL_vz00_6822 = BgL_arg2114z00_2230; 
BgL_bodyz00_6823 = BgL_arg2115z00_2231; 
BgL_bodyz00_1516 = BgL_bodyz00_6823; 
BgL_vz00_1515 = BgL_vz00_6822; 
goto BgL_tagzd2169zd2_1517;} 
return 
((obj_t)BgL_auxz00_6821);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2116z00_2232;obj_t BgL_arg2117z00_2233;
BgL_arg2116z00_2232 = 
CAR(BgL_ez00_69); 
BgL_arg2117z00_2233 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6827;
{ 
obj_t BgL_argsz00_6829;obj_t BgL_fz00_6828;
BgL_fz00_6828 = BgL_arg2116z00_2232; 
BgL_argsz00_6829 = BgL_arg2117z00_2233; 
BgL_argsz00_1536 = BgL_argsz00_6829; 
BgL_fz00_1535 = BgL_fz00_6828; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6827);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2119z00_2235;obj_t BgL_arg2120z00_2236;
BgL_arg2119z00_2235 = 
CAR(BgL_ez00_69); 
BgL_arg2120z00_2236 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6833;
{ 
obj_t BgL_argsz00_6835;obj_t BgL_fz00_6834;
BgL_fz00_6834 = BgL_arg2119z00_2235; 
BgL_argsz00_6835 = BgL_arg2120z00_2236; 
BgL_argsz00_1536 = BgL_argsz00_6835; 
BgL_fz00_1535 = BgL_fz00_6834; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6833);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2121z00_2237;obj_t BgL_arg2122z00_2238;
BgL_arg2121z00_2237 = 
CAR(BgL_ez00_69); 
BgL_arg2122z00_2238 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6839;
{ 
obj_t BgL_argsz00_6841;obj_t BgL_fz00_6840;
BgL_fz00_6840 = BgL_arg2121z00_2237; 
BgL_argsz00_6841 = BgL_arg2122z00_2238; 
BgL_argsz00_1536 = BgL_argsz00_6841; 
BgL_fz00_1535 = BgL_fz00_6840; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6839);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213398zd2_2239;
BgL_cdrzd213398zd2_2239 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3110z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213398zd2_2239))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2126z00_2243;obj_t BgL_arg2127z00_2244;
BgL_arg2126z00_2243 = 
CAR(BgL_cdrzd213398zd2_2239); 
BgL_arg2127z00_2244 = 
CDR(BgL_cdrzd213398zd2_2239); 
{ 
BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_6851;
{ 
obj_t BgL_bodyz00_6853;obj_t BgL_ez00_6852;
BgL_ez00_6852 = BgL_arg2126z00_2243; 
BgL_bodyz00_6853 = BgL_arg2127z00_2244; 
BgL_bodyz00_1519 = BgL_bodyz00_6853; 
BgL_ez00_1518 = BgL_ez00_6852; 
goto BgL_tagzd2170zd2_1520;} 
return 
((obj_t)BgL_auxz00_6851);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2128z00_2245;
BgL_arg2128z00_2245 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6856;
{ 
obj_t BgL_argsz00_6858;obj_t BgL_fz00_6857;
BgL_fz00_6857 = BgL_arg2128z00_2245; 
BgL_argsz00_6858 = BgL_cdrzd213398zd2_2239; 
BgL_argsz00_1536 = BgL_argsz00_6858; 
BgL_fz00_1535 = BgL_fz00_6857; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6856);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3112z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213398zd2_2239))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2133z00_2251;obj_t BgL_arg2134z00_2252;
BgL_arg2133z00_2251 = 
CAR(BgL_cdrzd213398zd2_2239); 
BgL_arg2134z00_2252 = 
CDR(BgL_cdrzd213398zd2_2239); 
{ 
BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_6867;
{ 
obj_t BgL_bodyz00_6869;obj_t BgL_hz00_6868;
BgL_hz00_6868 = BgL_arg2133z00_2251; 
BgL_bodyz00_6869 = BgL_arg2134z00_2252; 
BgL_bodyz00_1522 = BgL_bodyz00_6869; 
BgL_hz00_1521 = BgL_hz00_6868; 
goto BgL_tagzd2171zd2_1523;} 
return 
((obj_t)BgL_auxz00_6867);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2135z00_2253;obj_t BgL_arg2136z00_2254;
BgL_arg2135z00_2253 = 
CAR(BgL_ez00_69); 
BgL_arg2136z00_2254 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6873;
{ 
obj_t BgL_argsz00_6875;obj_t BgL_fz00_6874;
BgL_fz00_6874 = BgL_arg2135z00_2253; 
BgL_argsz00_6875 = BgL_arg2136z00_2254; 
BgL_argsz00_1536 = BgL_argsz00_6875; 
BgL_fz00_1535 = BgL_fz00_6874; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6873);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213505zd2_2255;
BgL_cdrzd213505zd2_2255 = 
CDR(BgL_ez00_69); 
if(
(
CAR(BgL_ez00_69)==BGl_symbol3114z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213505zd2_2255))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213510zd2_2259;
BgL_cdrzd213510zd2_2259 = 
CDR(BgL_cdrzd213505zd2_2255); 
if(
PAIRP(BgL_cdrzd213510zd2_2259))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213515zd2_2261;
BgL_cdrzd213515zd2_2261 = 
CDR(BgL_cdrzd213510zd2_2259); 
if(
(
CAR(BgL_cdrzd213510zd2_2259)==BGl_keyword3116z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213515zd2_2261))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2144z00_2265;obj_t BgL_arg2145z00_2266;obj_t BgL_arg2146z00_2267;
BgL_arg2144z00_2265 = 
CAR(BgL_cdrzd213505zd2_2255); 
BgL_arg2145z00_2266 = 
CAR(BgL_cdrzd213515zd2_2261); 
BgL_arg2146z00_2267 = 
CDR(BgL_cdrzd213515zd2_2261); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6895;
{ 
obj_t BgL_bodyz00_6898;obj_t BgL_pz00_6897;obj_t BgL_mz00_6896;
BgL_mz00_6896 = BgL_arg2144z00_2265; 
BgL_pz00_6897 = BgL_arg2145z00_2266; 
BgL_bodyz00_6898 = BgL_arg2146z00_2267; 
BgL_bodyz00_1526 = BgL_bodyz00_6898; 
BgL_pz00_1525 = BgL_pz00_6897; 
BgL_mz00_1524 = BgL_mz00_6896; 
goto BgL_tagzd2172zd2_1527;} 
return 
((obj_t)BgL_auxz00_6895);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2147z00_2269;obj_t BgL_arg2148z00_2270;
BgL_arg2147z00_2269 = 
CAR(
((obj_t)BgL_cdrzd213505zd2_2255)); 
BgL_arg2148z00_2270 = 
CDR(
((obj_t)BgL_cdrzd213505zd2_2255)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6904;
{ 
obj_t BgL_bodyz00_6906;obj_t BgL_mz00_6905;
BgL_mz00_6905 = BgL_arg2147z00_2269; 
BgL_bodyz00_6906 = BgL_arg2148z00_2270; 
BgL_bodyz00_1529 = BgL_bodyz00_6906; 
BgL_mz00_1528 = BgL_mz00_6905; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6904);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2149z00_2272;obj_t BgL_arg2150z00_2273;
BgL_arg2149z00_2272 = 
CAR(
((obj_t)BgL_cdrzd213505zd2_2255)); 
BgL_arg2150z00_2273 = 
CDR(
((obj_t)BgL_cdrzd213505zd2_2255)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6912;
{ 
obj_t BgL_bodyz00_6914;obj_t BgL_mz00_6913;
BgL_mz00_6913 = BgL_arg2149z00_2272; 
BgL_bodyz00_6914 = BgL_arg2150z00_2273; 
BgL_bodyz00_1529 = BgL_bodyz00_6914; 
BgL_mz00_1528 = BgL_mz00_6913; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6912);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2152z00_2276;obj_t BgL_arg2153z00_2277;
BgL_arg2152z00_2276 = 
CAR(
((obj_t)BgL_cdrzd213505zd2_2255)); 
BgL_arg2153z00_2277 = 
CDR(
((obj_t)BgL_cdrzd213505zd2_2255)); 
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_6920;
{ 
obj_t BgL_bodyz00_6922;obj_t BgL_mz00_6921;
BgL_mz00_6921 = BgL_arg2152z00_2276; 
BgL_bodyz00_6922 = BgL_arg2153z00_2277; 
BgL_bodyz00_1529 = BgL_bodyz00_6922; 
BgL_mz00_1528 = BgL_mz00_6921; 
goto BgL_tagzd2173zd2_1530;} 
return 
((obj_t)BgL_auxz00_6920);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2154z00_2278;
BgL_arg2154z00_2278 = 
CAR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6925;
{ 
obj_t BgL_argsz00_6927;obj_t BgL_fz00_6926;
BgL_fz00_6926 = BgL_arg2154z00_2278; 
BgL_argsz00_6927 = BgL_cdrzd213505zd2_2255; 
BgL_argsz00_1536 = BgL_argsz00_6927; 
BgL_fz00_1535 = BgL_fz00_6926; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6925);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3067z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
if(
PAIRP(BgL_cdrzd213505zd2_2255))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_cdrzd213617zd2_2284;
BgL_cdrzd213617zd2_2284 = 
CDR(BgL_cdrzd213505zd2_2255); 
if(
PAIRP(BgL_cdrzd213617zd2_2284))
{ /* Eval/evaluate.scm 424 */
if(
NULLP(
CDR(BgL_cdrzd213617zd2_2284)))
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2162z00_2288;obj_t BgL_arg2163z00_2289;
BgL_arg2162z00_2288 = 
CAR(BgL_cdrzd213505zd2_2255); 
BgL_arg2163z00_2289 = 
CAR(BgL_cdrzd213617zd2_2284); 
{ 
BgL_ev_absz00_bglt BgL_auxz00_6942;
{ 
obj_t BgL_bodyz00_6944;obj_t BgL_formalsz00_6943;
BgL_formalsz00_6943 = BgL_arg2162z00_2288; 
BgL_bodyz00_6944 = BgL_arg2163z00_2289; 
BgL_bodyz00_1532 = BgL_bodyz00_6944; 
BgL_formalsz00_1531 = BgL_formalsz00_6943; 
goto BgL_tagzd2174zd2_1533;} 
return 
((obj_t)BgL_auxz00_6942);} }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2164z00_2290;obj_t BgL_arg2165z00_2291;
BgL_arg2164z00_2290 = 
CAR(BgL_ez00_69); 
BgL_arg2165z00_2291 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6948;
{ 
obj_t BgL_argsz00_6950;obj_t BgL_fz00_6949;
BgL_fz00_6949 = BgL_arg2164z00_2290; 
BgL_argsz00_6950 = BgL_arg2165z00_2291; 
BgL_argsz00_1536 = BgL_argsz00_6950; 
BgL_fz00_1535 = BgL_fz00_6949; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6948);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2167z00_2293;obj_t BgL_arg2168z00_2294;
BgL_arg2167z00_2293 = 
CAR(BgL_ez00_69); 
BgL_arg2168z00_2294 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6954;
{ 
obj_t BgL_argsz00_6956;obj_t BgL_fz00_6955;
BgL_fz00_6955 = BgL_arg2167z00_2293; 
BgL_argsz00_6956 = BgL_arg2168z00_2294; 
BgL_argsz00_1536 = BgL_argsz00_6956; 
BgL_fz00_1535 = BgL_fz00_6955; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6954);} } }  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2169z00_2295;obj_t BgL_arg2170z00_2296;
BgL_arg2169z00_2295 = 
CAR(BgL_ez00_69); 
BgL_arg2170z00_2296 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6960;
{ 
obj_t BgL_argsz00_6962;obj_t BgL_fz00_6961;
BgL_fz00_6961 = BgL_arg2169z00_2295; 
BgL_argsz00_6962 = BgL_arg2170z00_2296; 
BgL_argsz00_1536 = BgL_argsz00_6962; 
BgL_fz00_1535 = BgL_fz00_6961; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6960);} } }  else 
{ /* Eval/evaluate.scm 424 */
if(
(
CAR(BgL_ez00_69)==BGl_symbol3118z00zz__evaluatez00))
{ /* Eval/evaluate.scm 424 */
goto BgL_tagzd2175zd2_1534;}  else 
{ /* Eval/evaluate.scm 424 */
obj_t BgL_arg2173z00_2299;obj_t BgL_arg2174z00_2300;
BgL_arg2173z00_2299 = 
CAR(BgL_ez00_69); 
BgL_arg2174z00_2300 = 
CDR(BgL_ez00_69); 
{ 
BgL_ev_appz00_bglt BgL_auxz00_6969;
{ 
obj_t BgL_argsz00_6971;obj_t BgL_fz00_6970;
BgL_fz00_6970 = BgL_arg2173z00_2299; 
BgL_argsz00_6971 = BgL_arg2174z00_2300; 
BgL_argsz00_1536 = BgL_argsz00_6971; 
BgL_fz00_1535 = BgL_fz00_6970; 
goto BgL_tagzd2176zd2_1537;} 
return 
((obj_t)BgL_auxz00_6969);} } } } } } } } } } } } } } } } } } } } } } }  else 
{ /* Eval/evaluate.scm 424 */
BgL_xz00_1459 = BgL_ez00_69; 
if(
SYMBOLP(BgL_xz00_1459))
{ /* Eval/evaluate.scm 427 */
obj_t BgL__ortest_1101z00_2322;
BgL__ortest_1101z00_2322 = 
BGl_convzd2varzd2zz__evaluatez00(BgL_xz00_1459, BgL_localsz00_70); 
if(
CBOOL(BgL__ortest_1101z00_2322))
{ /* Eval/evaluate.scm 427 */
return BgL__ortest_1101z00_2322;}  else 
{ /* Eval/evaluate.scm 427 */
return 
((obj_t)
BGl_convzd2globalzd2zz__evaluatez00(BgL_locz00_74, BgL_xz00_1459, BgL_globalsz00_71));} }  else 
{ /* Eval/evaluate.scm 428 */
BgL_ev_littz00_bglt BgL_new1103z00_2323;
{ /* Eval/evaluate.scm 429 */
BgL_ev_littz00_bglt BgL_new1102z00_2324;
BgL_new1102z00_2324 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate.scm 429 */
long BgL_arg2197z00_2325;
{ /* Eval/evaluate.scm 429 */
long BgL_res2734z00_3345;
BgL_res2734z00_3345 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg2197z00_2325 = BgL_res2734z00_3345; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1102z00_2324), BgL_arg2197z00_2325); } 
BgL_new1103z00_2323 = BgL_new1102z00_2324; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1103z00_2323))->BgL_valuez00)=((obj_t)BgL_xz00_1459),BUNSPEC); 
return 
((obj_t)BgL_new1103z00_2323);} } } } } 

}



/* loop~0 */
obj_t BGl_loopze70ze7zz__evaluatez00(obj_t BgL_wherez00_4468, obj_t BgL_globalsz00_4467, obj_t BgL_localsz00_4466, obj_t BgL_locz00_4465, obj_t BgL_esz00_2653)
{
{ /* Eval/evaluate.scm 386 */
if(
NULLP(BgL_esz00_2653))
{ /* Eval/evaluate.scm 387 */
return BNIL;}  else 
{ /* Eval/evaluate.scm 389 */
obj_t BgL_ez00_2656;
BgL_ez00_2656 = 
CAR(
((obj_t)BgL_esz00_2653)); 
{ /* Eval/evaluate.scm 390 */
obj_t BgL_arg2348z00_2657;obj_t BgL_arg2349z00_2658;
BgL_arg2348z00_2657 = 
BGl_convz00zz__evaluatez00(BgL_ez00_2656, BgL_localsz00_4466, BgL_globalsz00_4467, BFALSE, BgL_wherez00_4468, 
BGl_getzd2location3zd2zz__evaluatez00(BgL_ez00_2656, BgL_esz00_2653, BgL_locz00_4465), ((bool_t)0)); 
{ /* Eval/evaluate.scm 391 */
obj_t BgL_arg2351z00_2660;
BgL_arg2351z00_2660 = 
CDR(
((obj_t)BgL_esz00_2653)); 
BgL_arg2349z00_2658 = 
BGl_loopze70ze7zz__evaluatez00(BgL_wherez00_4468, BgL_globalsz00_4467, BgL_localsz00_4466, BgL_locz00_4465, BgL_arg2351z00_2660); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2348z00_2657, BgL_arg2349z00_2658);} } } 

}



/* rconv/loc~0 */
obj_t BGl_rconvzf2locze70z15zz__evaluatez00(obj_t BgL_wherez00_4472, obj_t BgL_tailzf3zf3_4471, obj_t BgL_globalsz00_4470, obj_t BgL_localsz00_4469, obj_t BgL_ez00_2630, obj_t BgL_locz00_2631)
{
{ /* Eval/evaluate.scm 368 */
return 
BGl_convz00zz__evaluatez00(BgL_ez00_2630, BgL_localsz00_4469, BgL_globalsz00_4470, BgL_tailzf3zf3_4471, BgL_wherez00_4472, BgL_locz00_2631, ((bool_t)0));} 

}



/* uconv/loc~0 */
obj_t BGl_uconvzf2locze70z15zz__evaluatez00(obj_t BgL_wherez00_4475, obj_t BgL_globalsz00_4474, obj_t BgL_localsz00_4473, obj_t BgL_ez00_2640, obj_t BgL_locz00_2641)
{
{ /* Eval/evaluate.scm 377 */
return 
BGl_convz00zz__evaluatez00(BgL_ez00_2640, BgL_localsz00_4473, BgL_globalsz00_4474, BFALSE, BgL_wherez00_4475, BgL_locz00_2641, ((bool_t)0));} 

}



/* conv-vals~0 */
obj_t BGl_convzd2valsze70z35zz__evaluatez00(obj_t BgL_wherez00_4477, obj_t BgL_globalsz00_4476, obj_t BgL_lz00_2471, obj_t BgL_varsz00_2472, obj_t BgL_localsz00_2473, obj_t BgL_locz00_2474)
{
{ /* Eval/evaluate.scm 502 */
if(
NULLP(BgL_lz00_2471))
{ /* Eval/evaluate.scm 498 */
return BNIL;}  else 
{ /* Eval/evaluate.scm 500 */
obj_t BgL_locz00_2477;
{ /* Eval/evaluate.scm 500 */
obj_t BgL_arg2270z00_2485;
BgL_arg2270z00_2485 = 
CAR(
((obj_t)BgL_lz00_2471)); 
BgL_locz00_2477 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_arg2270z00_2485, BgL_locz00_2474); } 
{ /* Eval/evaluate.scm 501 */
obj_t BgL_arg2263z00_2478;obj_t BgL_arg2264z00_2479;
{ /* Eval/evaluate.scm 501 */
obj_t BgL_arg2265z00_2480;
{ /* Eval/evaluate.scm 501 */
obj_t BgL_pairz00_3438;
{ /* Eval/evaluate.scm 501 */
obj_t BgL_pairz00_3437;
BgL_pairz00_3437 = 
CAR(
((obj_t)BgL_lz00_2471)); 
BgL_pairz00_3438 = 
CDR(BgL_pairz00_3437); } 
BgL_arg2265z00_2480 = 
CAR(BgL_pairz00_3438); } 
BgL_arg2263z00_2478 = 
BGl_convz00zz__evaluatez00(BgL_arg2265z00_2480, BgL_localsz00_2473, BgL_globalsz00_4476, BFALSE, BgL_wherez00_4477, BgL_locz00_2477, ((bool_t)0)); } 
{ /* Eval/evaluate.scm 502 */
obj_t BgL_arg2266z00_2481;obj_t BgL_arg2267z00_2482;obj_t BgL_arg2268z00_2483;
BgL_arg2266z00_2481 = 
CDR(
((obj_t)BgL_lz00_2471)); 
BgL_arg2267z00_2482 = 
CDR(
((obj_t)BgL_varsz00_2472)); 
{ /* Eval/evaluate.scm 502 */
obj_t BgL_arg2269z00_2484;
BgL_arg2269z00_2484 = 
CAR(
((obj_t)BgL_varsz00_2472)); 
BgL_arg2268z00_2483 = 
MAKE_YOUNG_PAIR(BgL_arg2269z00_2484, BgL_localsz00_2473); } 
BgL_arg2264z00_2479 = 
BGl_convzd2valsze70z35zz__evaluatez00(BgL_wherez00_4477, BgL_globalsz00_4476, BgL_arg2266z00_2481, BgL_arg2267z00_2482, BgL_arg2268z00_2483, BgL_locz00_2477); } 
return 
MAKE_YOUNG_PAIR(BgL_arg2263z00_2478, BgL_arg2264z00_2479);} } } 

}



/* conv-lambda~0 */
BgL_ev_absz00_bglt BGl_convzd2lambdaze70z35zz__evaluatez00(obj_t BgL_globalsz00_4481, obj_t BgL_localsz00_4480, obj_t BgL_ez00_4479, obj_t BgL_locz00_4478, obj_t BgL_formalsz00_2662, obj_t BgL_bodyz00_2663, obj_t BgL_wherez00_2664, obj_t BgL_typez00_2665)
{
{ /* Eval/evaluate.scm 404 */
{ 
obj_t BgL_lz00_2696;
{ /* Eval/evaluate.scm 406 */
obj_t BgL_argsz00_2668;
BgL_lz00_2696 = 
BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(BgL_formalsz00_2662, BGl_errorzd2envzd2zz__errorz00, ((bool_t)1)); 
{ 
obj_t BgL_rz00_2700;obj_t BgL_flatz00_2701;long BgL_arityz00_2702;
BgL_rz00_2700 = BgL_lz00_2696; 
BgL_flatz00_2701 = BNIL; 
BgL_arityz00_2702 = ((long)0); 
BgL_zc3z04anonymousza32365ze3z87_2703:
if(
NULLP(BgL_rz00_2700))
{ /* Eval/evaluate.scm 399 */
obj_t BgL_val0_1196z00_2705;
BgL_val0_1196z00_2705 = 
bgl_reverse_bang(BgL_flatz00_2701); 
{ /* Eval/evaluate.scm 399 */
int BgL_res2722z00_3316;
{ /* Eval/evaluate.scm 399 */
int BgL_tmpz00_7020;
BgL_tmpz00_7020 = 
(int)(((long)2)); 
BgL_res2722z00_3316 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7020); } BgL_res2722z00_3316; } 
{ /* Eval/evaluate.scm 399 */
obj_t BgL_auxz00_7025;int BgL_tmpz00_7023;
BgL_auxz00_7025 = 
BINT(BgL_arityz00_2702); 
BgL_tmpz00_7023 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7023, BgL_auxz00_7025); } 
BgL_argsz00_2668 = BgL_val0_1196z00_2705; }  else 
{ /* Eval/evaluate.scm 398 */
if(
PAIRP(BgL_rz00_2700))
{ /* Eval/evaluate.scm 403 */
obj_t BgL_arg2368z00_2708;obj_t BgL_arg2369z00_2709;long BgL_arg2370z00_2710;
BgL_arg2368z00_2708 = 
CDR(BgL_rz00_2700); 
BgL_arg2369z00_2709 = 
MAKE_YOUNG_PAIR(
BGl_untypezd2identzd2zz__evaluatez00(
CAR(BgL_rz00_2700)), BgL_flatz00_2701); 
BgL_arg2370z00_2710 = 
(BgL_arityz00_2702+((long)1)); 
{ 
long BgL_arityz00_7037;obj_t BgL_flatz00_7036;obj_t BgL_rz00_7035;
BgL_rz00_7035 = BgL_arg2368z00_2708; 
BgL_flatz00_7036 = BgL_arg2369z00_2709; 
BgL_arityz00_7037 = BgL_arg2370z00_2710; 
BgL_arityz00_2702 = BgL_arityz00_7037; 
BgL_flatz00_2701 = BgL_flatz00_7036; 
BgL_rz00_2700 = BgL_rz00_7035; 
goto BgL_zc3z04anonymousza32365ze3z87_2703;} }  else 
{ /* Eval/evaluate.scm 401 */
obj_t BgL_val0_1198z00_2713;long BgL_val1_1199z00_2714;
{ /* Eval/evaluate.scm 401 */
obj_t BgL_arg2373z00_2715;
BgL_arg2373z00_2715 = 
MAKE_YOUNG_PAIR(
BGl_untypezd2identzd2zz__evaluatez00(BgL_rz00_2700), BgL_flatz00_2701); 
BgL_val0_1198z00_2713 = 
bgl_reverse_bang(BgL_arg2373z00_2715); } 
BgL_val1_1199z00_2714 = 
(((long)-1)-BgL_arityz00_2702); 
{ /* Eval/evaluate.scm 401 */
int BgL_res2726z00_3324;
{ /* Eval/evaluate.scm 401 */
int BgL_tmpz00_7042;
BgL_tmpz00_7042 = 
(int)(((long)2)); 
BgL_res2726z00_3324 = 
BGL_MVALUES_NUMBER_SET(BgL_tmpz00_7042); } BgL_res2726z00_3324; } 
{ /* Eval/evaluate.scm 401 */
obj_t BgL_auxz00_7047;int BgL_tmpz00_7045;
BgL_auxz00_7047 = 
BINT(BgL_val1_1199z00_2714); 
BgL_tmpz00_7045 = 
(int)(((long)1)); 
BGL_MVALUES_VAL_SET(BgL_tmpz00_7045, BgL_auxz00_7047); } 
BgL_argsz00_2668 = BgL_val0_1198z00_2713; } } } 
{ /* Eval/evaluate.scm 407 */
obj_t BgL_arityz00_2669;
{ /* Eval/evaluate.scm 408 */
int BgL_tmpz00_7051;
BgL_tmpz00_7051 = 
(int)(((long)1)); 
BgL_arityz00_2669 = 
BGL_MVALUES_VAL(BgL_tmpz00_7051); } 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_varsz00_2670;obj_t BgL_bodyz00_2671;obj_t BgL_nlocz00_2672;
if(
NULLP(BgL_argsz00_2668))
{ /* Eval/evaluate.scm 408 */
BgL_varsz00_2670 = BNIL; }  else 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_head1202z00_2679;
{ /* Eval/evaluate.scm 408 */
obj_t BgL_res2728z00_3326;
BgL_res2728z00_3326 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1202z00_2679 = BgL_res2728z00_3326; } 
{ 
obj_t BgL_l1200z00_2681;obj_t BgL_tail1203z00_2682;
BgL_l1200z00_2681 = BgL_argsz00_2668; 
BgL_tail1203z00_2682 = BgL_head1202z00_2679; 
BgL_zc3z04anonymousza32356ze3z87_2683:
if(
NULLP(BgL_l1200z00_2681))
{ /* Eval/evaluate.scm 408 */
BgL_varsz00_2670 = 
CDR(BgL_head1202z00_2679); }  else 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_newtail1204z00_2685;
{ /* Eval/evaluate.scm 408 */
BgL_ev_varz00_bglt BgL_arg2359z00_2687;
{ /* Eval/evaluate.scm 408 */
obj_t BgL_vz00_2688;
BgL_vz00_2688 = 
CAR(
((obj_t)BgL_l1200z00_2681)); 
{ /* Eval/evaluate.scm 409 */
BgL_ev_varz00_bglt BgL_new1098z00_2689;
{ /* Eval/evaluate.scm 411 */
BgL_ev_varz00_bglt BgL_new1097z00_2690;
BgL_new1097z00_2690 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate.scm 411 */
long BgL_arg2360z00_2691;
{ /* Eval/evaluate.scm 411 */
long BgL_res2730z00_3331;
BgL_res2730z00_3331 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg2360z00_2691 = BgL_res2730z00_3331; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1097z00_2690), BgL_arg2360z00_2691); } 
BgL_new1098z00_2689 = BgL_new1097z00_2690; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1098z00_2689))->BgL_namez00)=((obj_t)
CAR(
((obj_t)BgL_vz00_2688))),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1098z00_2689))->BgL_effz00)=((obj_t)BFALSE),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1098z00_2689))->BgL_typez00)=((obj_t)
CDR(
((obj_t)BgL_vz00_2688))),BUNSPEC); 
BgL_arg2359z00_2687 = BgL_new1098z00_2689; } } 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_res2731z00_3336;
BgL_res2731z00_3336 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg2359z00_2687), BNIL); 
BgL_newtail1204z00_2685 = BgL_res2731z00_3336; } } 
SET_CDR(BgL_tail1203z00_2682, BgL_newtail1204z00_2685); 
{ /* Eval/evaluate.scm 408 */
obj_t BgL_arg2358z00_2686;
BgL_arg2358z00_2686 = 
CDR(
((obj_t)BgL_l1200z00_2681)); 
{ 
obj_t BgL_tail1203z00_7079;obj_t BgL_l1200z00_7078;
BgL_l1200z00_7078 = BgL_arg2358z00_2686; 
BgL_tail1203z00_7079 = BgL_newtail1204z00_2685; 
BgL_tail1203z00_2682 = BgL_tail1203z00_7079; 
BgL_l1200z00_2681 = BgL_l1200z00_7078; 
goto BgL_zc3z04anonymousza32356ze3z87_2683;} } } } } 
BgL_bodyz00_2671 = 
BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(BgL_ez00_4479, BgL_formalsz00_2662, 
BGl_typezd2checkszd2zz__evaluatez00(BgL_argsz00_2668, BgL_argsz00_2668, 
BGl_typezd2resultzd2zz__evaluatez00(BgL_typez00_2665, BgL_bodyz00_2663, BgL_locz00_4478), BgL_locz00_4478, BgL_wherez00_2664), BGl_errorzd2envzd2zz__errorz00); 
BgL_nlocz00_2672 = 
BGl_getzd2locationzd2zz__evaluatez00(BgL_bodyz00_2663, BgL_locz00_4478); 
{ /* Eval/evaluate.scm 417 */
BgL_ev_absz00_bglt BgL_new1100z00_2673;
{ /* Eval/evaluate.scm 418 */
BgL_ev_absz00_bglt BgL_new1099z00_2675;
BgL_new1099z00_2675 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate.scm 418 */
long BgL_arg2354z00_2676;
{ /* Eval/evaluate.scm 418 */
long BgL_res2732z00_3340;
BgL_res2732z00_3340 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BgL_arg2354z00_2676 = BgL_res2732z00_3340; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1099z00_2675), BgL_arg2354z00_2676); } 
BgL_new1100z00_2673 = BgL_new1099z00_2675; } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_locz00)=((obj_t)BgL_locz00_4478),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_wherez00)=((obj_t)BgL_wherez00_2664),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_arityz00)=((obj_t)BgL_arityz00_2669),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_varsz00)=((obj_t)BgL_varsz00_2670),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_7092;
{ /* Eval/evaluate.scm 422 */
obj_t BgL_arg2353z00_2674;
BgL_arg2353z00_2674 = 
BGl_appendzd221009zd2zz__evaluatez00(BgL_varsz00_2670, BgL_localsz00_4480); 
BgL_auxz00_7092 = 
((BgL_ev_exprz00_bglt)
BGl_convz00zz__evaluatez00(BgL_bodyz00_2671, BgL_arg2353z00_2674, BgL_globalsz00_4481, BTRUE, BgL_wherez00_2664, BgL_nlocz00_2672, ((bool_t)0))); } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_7092),BUNSPEC); } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_siza7eza7)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_bindz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_freez00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_innerz00)=((obj_t)BNIL),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1100z00_2673))->BgL_boxesz00)=((obj_t)BNIL),BUNSPEC); 
return BgL_new1100z00_2673;} } } } } } 

}



/* uconv~0 */
obj_t BGl_uconvze70ze7zz__evaluatez00(obj_t BgL_locz00_4485, obj_t BgL_wherez00_4484, obj_t BgL_globalsz00_4483, obj_t BgL_localsz00_4482, obj_t BgL_ez00_2643)
{
{ /* Eval/evaluate.scm 380 */
return 
BGl_uconvzf2locze70z15zz__evaluatez00(BgL_wherez00_4484, BgL_globalsz00_4483, BgL_localsz00_4482, BgL_ez00_2643, 
BGl_getzd2locationzd2zz__evaluatez00(BgL_ez00_2643, BgL_locz00_4485));} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00()
{
{ /* Eval/evaluate.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046386), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)37115357), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)70989162), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135277364), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218115), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267996), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519875), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251315035), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936798), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439352636), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453938973), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)193422032), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967910), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68572481), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)420334581), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057945), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155874), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198621048), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309694), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519474), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460263341), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-44274296), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614573), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927845), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)190906089), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540733), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988972), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151379), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)233942106), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)220647683), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__prognz00(((long)177147628), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__expandz00(((long)414007030), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evenvz00(((long)528345319), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evcompilez00(((long)492753248), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__everrorz00(((long)375872251), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evmodulez00(((long)505900559), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long)0), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(((long)483789088), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(((long)121298808), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long)193509655), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00)); 
return 
BGl_modulezd2initializa7ationz75zz__evaluate_compz00(((long)444000681), 
BSTRING_TO_STRING(BGl_string3120z00zz__evaluatez00));} 

}

#ifdef __cplusplus
}
#endif
