/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_comp.scm -o objs/obj_p/Eval/evaluate_comp.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static obj_t BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5238z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32931ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32753ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32737ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5240z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5242z00zz__evaluate_compz00 = BUNSPEC;
BGL_EXPORTED_DECL obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
static obj_t BGl_symbol5248z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32681ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32665ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33378ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32649ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5256z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5258z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32828ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5260z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5263z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt, obj_t);
static obj_t BGl_symbol5266z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5268z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32102ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32772ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33574ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31954ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5270z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5272z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5274z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5276z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5278z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32030ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32846ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32757ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5280z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5282z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5284z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5286z00zz__evaluate_compz00 = BUNSPEC;
extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
static obj_t BGl_symbol5288z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_zc3z04exitza33068ze3ze70z60zz__evaluate_compz00(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32685ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33649ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32669ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5290z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5292z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5294z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5296z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5298z00zz__evaluate_compz00 = BUNSPEC;
extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_cadrerrvz00zz__evaluate_compz00(obj_t);
extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza33399ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_or1404zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31990ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32866ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t bstring_to_symbol(obj_t);
extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
static obj_t BGl_appendzd221009zd2zz__evaluate_compz00(obj_t, obj_t);
extern obj_t make_vector(long, obj_t);
static obj_t BGl_z62zc3z04anonymousza32689ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
static long BGl_correctz00zz__evaluate_compz00(obj_t, long);
static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32957ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32868ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33300ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32958ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33599ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33124ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_reset_profilez00zz__evaluate_compz00();
static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
static obj_t BGl_z62run5149z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32072ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_labels1425zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5151z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5153z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5155z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5157z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5159z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32340ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t, obj_t, obj_t);
static obj_t BGl_z62run5161z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5163z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5165z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5167z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5169z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5171z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5173z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5175z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5177z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5179z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62run5181z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5183z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5185z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5187z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5189z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32076ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5191z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5193z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5195z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5197z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5199z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
extern int bgl_debug();
static obj_t BGl_z62zc3z04anonymousza32701ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32434ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_bindzd2exit1417z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33074ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5148z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_global1394zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t, obj_t, obj_t, long, obj_t);
extern obj_t create_struct(obj_t, int);
static obj_t BGl_get_profilez00zz__evaluate_compz00();
static obj_t BGl_z62main5150z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31811ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5152z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5154z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33075ze3ze5zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32184ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5156z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5158z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
extern long bgl_list_length(obj_t);
extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
static obj_t BGl_z62main5160z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5162z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33343ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33092ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5164z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5166z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5168z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33611ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5170z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
static obj_t BGl_z62main5172z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_withzd2handler1421z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5174z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33239ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5176z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5178z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static bool_t BGl_cadrzf3zf3zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32721ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5180z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33434ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32705ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5182z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5184z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33078ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5186z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5188z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza31920ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5190z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_letza21413z12zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5192z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5194z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5196z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5198z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza33363ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33185ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_litt1400zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
static obj_t BGl_profzd2initzd2zz__evaluate_compz00();
extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
static obj_t BGl_z62zc3z04anonymousza32741ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33292ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32725ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32709ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31924ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32653ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32386ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32297ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32816ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33456ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5300z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza33278ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5302z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5304z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5306z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5308z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
static bool_t BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32922ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32906ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33546ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5310z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5312z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5314z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5316z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5318z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
static obj_t BGl_z62compzd2ev_trap1388zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32761ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32834ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32745ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32729ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5320z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5322z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5324z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5326z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5328z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32673ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32657ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_symbol5330z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5332z00zz__evaluate_compz00 = BUNSPEC;
extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32852ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_prog21409zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
static obj_t BGl_zc3z04exitza33085ze3ze70z60zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_defglobal1398zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32749ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
static obj_t BGl_symbol5363z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62compzd2ev_setglobal1396zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32693ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32766ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza31875ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32677ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
static obj_t BGl_symbol5371z00zz__evaluate_compz00 = BUNSPEC;
extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33585ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
static obj_t BGl_symbol5382z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5384z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5386z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_symbol5388z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32130ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32009ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t bgl_reverse_bang(obj_t);
static obj_t BGl_z62zc3z04anonymousza31788ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
static obj_t BGl_z62zc3z04anonymousza32963ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32769ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33007ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33693ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31984ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31895ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31968ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32697ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_goto1427zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_let1411zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_evmodulezd2namezd2zz__evmodulez00(obj_t);
static obj_t BGl_z62zc3z04anonymousza33113ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5201z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5203z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31986ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5205z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5207z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5209z62zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32983ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5211z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5213z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5215z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5217z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5219z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33221ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
static obj_t BGl_z62zc3z04anonymousza32225ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
static obj_t BGl_z62run5221z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32879ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5223z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5225z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5227z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5229z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_synchroniza7e1423z17zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33311ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33028ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5231z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62run5233z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32049ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32986ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
static obj_t BGl_z62compzd2ev_app1429zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_var1390zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32334ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern bool_t bigloo_string_lt(obj_t, obj_t);
static obj_t BGl_z62main5200z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5202z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5204z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5206z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32262ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5208z62zz__evaluate_compz00(obj_t, obj_t);
extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
static obj_t BGl_z62main5210z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5212z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5214z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32190ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5216z62zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5218z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62compzd2ev_and1406zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static bool_t BGl_checkzd2stackzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62main5220z62zz__evaluate_compz00(obj_t);
extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
static obj_t BGl_z62main5222z62zz__evaluate_compz00(obj_t);
extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long, long);
static obj_t BGl_z62zc3z04anonymousza33260ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62main5224z62zz__evaluate_compz00(obj_t);
static obj_t BGl_z62main5226z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5228z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5230z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62main5232z62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza33067ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
static obj_t BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_abs1431zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
static obj_t BGl_z62compzd2ev_letrec1415zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33425ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33409ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_if1402zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32713ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t, BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza33354ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33533ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32480ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62comp1385z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33194ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00(obj_t);
extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
static obj_t BGl_z62compzd2ev_setlocal1392zb0zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32911ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32733ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33446ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza32717ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62compzd2ev_unwindzd2prote1419z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
static obj_t BGl_z62zc3z04anonymousza32661ze3ze5zz__evaluate_compz00(obj_t, obj_t);
extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
static obj_t BGl_z62zc3z04anonymousza32840ze3ze5zz__evaluate_compz00(obj_t, obj_t);
static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt, obj_t);
static obj_t *__cnst;


DEFINE_STATIC_BGL_PROCEDURE( BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_bgl_za762za7c3lexintza7a1za75392z00, BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_compilezd2envzd2zz__evaluate_compz00, BgL_bgl_za762compileza762za7za7_5393z00, BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
DEFINE_EXPORT_BGL_PROCEDURE( BGl_findzd2statezd2envz00zz__evaluate_compz00, BgL_bgl_za762findza7d2stateza75394za7, BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string5239z00zz__evaluate_compz00, BgL_bgl_string5239za700za7za7_5395za7, "all", 3 );
DEFINE_STRING( BGl_string5241z00zz__evaluate_compz00, BgL_bgl_string5241za700za7za7_5396za7, "label-tag", 9 );
DEFINE_STRING( BGl_string5243z00zz__evaluate_compz00, BgL_bgl_string5243za700za7za7_5397za7, "bounce", 6 );
DEFINE_STRING( BGl_string5244z00zz__evaluate_compz00, BgL_bgl_string5244za700za7za7_5398za7, "non non non", 11 );
DEFINE_STRING( BGl_string5245z00zz__evaluate_compz00, BgL_bgl_string5245za700za7za7_5399za7, " in ", 4 );
DEFINE_STRING( BGl_string5246z00zz__evaluate_compz00, BgL_bgl_string5246za700za7za7_5400za7, "eval", 4 );
DEFINE_STRING( BGl_string5247z00zz__evaluate_compz00, BgL_bgl_string5247za700za7za7_5401za7, "internal error: not found", 25 );
DEFINE_STRING( BGl_string5249z00zz__evaluate_compz00, BgL_bgl_string5249za700za7za7_5402za7, "at", 2 );
extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
DEFINE_STRING( BGl_string5250z00zz__evaluate_compz00, BgL_bgl_string5250za700za7za7_5403za7, "", 0 );
DEFINE_STRING( BGl_string5251z00zz__evaluate_compz00, BgL_bgl_string5251za700za7za7_5404za7, "/builddir/build/BUILD/bigloo-4.4a/runtime/Eval/evaluate_comp.scm", 64 );
DEFINE_STRING( BGl_string5252z00zz__evaluate_compz00, BgL_bgl_string5252za700za7za7_5405za7, "&compile", 8 );
DEFINE_STRING( BGl_string5253z00zz__evaluate_compz00, BgL_bgl_string5253za700za7za7_5406za7, "ev_expr", 7 );
DEFINE_STRING( BGl_string5254z00zz__evaluate_compz00, BgL_bgl_string5254za700za7za7_5407za7, "expecting ~a, got ~a", 20 );
DEFINE_STRING( BGl_string5255z00zz__evaluate_compz00, BgL_bgl_string5255za700za7za7_5408za7, "wrong number of argument", 24 );
DEFINE_STRING( BGl_string5257z00zz__evaluate_compz00, BgL_bgl_string5257za700za7za7_5409za7, "mcell", 5 );
DEFINE_STRING( BGl_string5259z00zz__evaluate_compz00, BgL_bgl_string5259za700za7za7_5410za7, "internal", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5334z00zz__evaluate_compz00, BgL_bgl_za762comp1385za762za7za75411z00, BGl_z62comp1385z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5338z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_tra5412z00, BGl_z62compzd2ev_trap1388zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5261z00zz__evaluate_compz00, BgL_bgl_string5261za700za7za7_5413za7, "impossible", 10 );
DEFINE_STRING( BGl_string5262z00zz__evaluate_compz00, BgL_bgl_string5262za700za7za7_5414za7, "procedure", 9 );
DEFINE_STRING( BGl_string5264z00zz__evaluate_compz00, BgL_bgl_string5264za700za7za7_5415za7, "user", 4 );
DEFINE_STRING( BGl_string5265z00zz__evaluate_compz00, BgL_bgl_string5265za700za7za7_5416za7, "invalid byte code", 17 );
DEFINE_STRING( BGl_string5267z00zz__evaluate_compz00, BgL_bgl_string5267za700za7za7_5417za7, "+", 1 );
DEFINE_STRING( BGl_string5269z00zz__evaluate_compz00, BgL_bgl_string5269za700za7za7_5418za7, "number", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5340z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_var5419z00, BGl_z62compzd2ev_var1390zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5341z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_set5420z00, BGl_z62compzd2ev_setlocal1392zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5342z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_glo5421z00, BGl_z62compzd2ev_global1394zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5343z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_set5422z00, BGl_z62compzd2ev_setglobal1396zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5344z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_def5423z00, BGl_z62compzd2ev_defglobal1398zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5345z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_lit5424z00, BGl_z62compzd2ev_litt1400zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5346z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_if15425z00, BGl_z62compzd2ev_if1402zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5347z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_or15426z00, BGl_z62compzd2ev_or1404zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5348z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_and5427z00, BGl_z62compzd2ev_and1406zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5271z00zz__evaluate_compz00, BgL_bgl_string5271za700za7za7_5428za7, "-", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5349z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_pro5429z00, BGl_z62compzd2ev_prog21409zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5273z00zz__evaluate_compz00, BgL_bgl_string5273za700za7za7_5430za7, "*", 1 );
DEFINE_STRING( BGl_string5275z00zz__evaluate_compz00, BgL_bgl_string5275za700za7za7_5431za7, "/", 1 );
DEFINE_STRING( BGl_string5277z00zz__evaluate_compz00, BgL_bgl_string5277za700za7za7_5432za7, "<", 1 );
DEFINE_STRING( BGl_string5279z00zz__evaluate_compz00, BgL_bgl_string5279za700za7za7_5433za7, ">", 1 );
extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5350z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5434z00, BGl_z62compzd2ev_let1411zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5351z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5435z00, BGl_z62compzd2ev_letza21413z12zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5352z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_let5436z00, BGl_z62compzd2ev_letrec1415zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5353z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_bin5437z00, BGl_z62compzd2ev_bindzd2exit1417z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5354z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_unw5438z00, BGl_z62compzd2ev_unwindzd2prote1419z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5355z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_wit5439z00, BGl_z62compzd2ev_withzd2handler1421z62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5356z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_syn5440z00, BGl_z62compzd2ev_synchroniza7e1423z17zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5357z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_lab5441z00, BGl_z62compzd2ev_labels1425zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5358z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_got5442z00, BGl_z62compzd2ev_goto1427zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5281z00zz__evaluate_compz00, BgL_bgl_string5281za700za7za7_5443za7, "<=", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5359z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_app5444z00, BGl_z62compzd2ev_app1429zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5283z00zz__evaluate_compz00, BgL_bgl_string5283za700za7za7_5445za7, ">=", 2 );
DEFINE_STRING( BGl_string5285z00zz__evaluate_compz00, BgL_bgl_string5285za700za7za7_5446za7, "=", 1 );
DEFINE_STRING( BGl_string5287z00zz__evaluate_compz00, BgL_bgl_string5287za700za7za7_5447za7, "+fx", 3 );
DEFINE_STRING( BGl_string5289z00zz__evaluate_compz00, BgL_bgl_string5289za700za7za7_5448za7, "fixnum", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5360z00zz__evaluate_compz00, BgL_bgl_za762compza7d2ev_abs5449z00, BGl_z62compzd2ev_abs1431zb0zz__evaluate_compz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string5291z00zz__evaluate_compz00, BgL_bgl_string5291za700za7za7_5450za7, "-fx", 3 );
DEFINE_STRING( BGl_string5293z00zz__evaluate_compz00, BgL_bgl_string5293za700za7za7_5451za7, "*fx", 3 );
DEFINE_STRING( BGl_string5295z00zz__evaluate_compz00, BgL_bgl_string5295za700za7za7_5452za7, "/fx", 3 );
DEFINE_STRING( BGl_string5297z00zz__evaluate_compz00, BgL_bgl_string5297za700za7za7_5453za7, "<fx", 3 );
DEFINE_STRING( BGl_string5299z00zz__evaluate_compz00, BgL_bgl_string5299za700za7za7_5454za7, ">fx", 3 );
extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5374z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5455za7, BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5375z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5456za7, BGl_z62zc3z04anonymousza32828ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5376z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5457za7, BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5377z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5458za7, BGl_z62zc3z04anonymousza32834ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5378z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5459za7, BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5379z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5460za7, BGl_z62zc3z04anonymousza32840ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5380z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5461za7, BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc5381z00zz__evaluate_compz00, BgL_bgl_za762za7c3za704anonymo5462za7, BGl_z62zc3z04anonymousza32846ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1 );
extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
DEFINE_STATIC_BGL_GENERIC( BGl_compzd2envzd2zz__evaluate_compz00, BgL_bgl_za762compza762za7za7__ev5463z00, BGl_z62compz62zz__evaluate_compz00, 0L, BUNSPEC, 2 );
extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
DEFINE_STRING( BGl_string5301z00zz__evaluate_compz00, BgL_bgl_string5301za700za7za7_5464za7, "<=fx", 4 );
DEFINE_STRING( BGl_string5303z00zz__evaluate_compz00, BgL_bgl_string5303za700za7za7_5465za7, ">=fx", 4 );
DEFINE_STRING( BGl_string5305z00zz__evaluate_compz00, BgL_bgl_string5305za700za7za7_5466za7, "=fx", 3 );
DEFINE_STRING( BGl_string5307z00zz__evaluate_compz00, BgL_bgl_string5307za700za7za7_5467za7, "+fl", 3 );
DEFINE_STRING( BGl_string5309z00zz__evaluate_compz00, BgL_bgl_string5309za700za7za7_5468za7, "flonum", 6 );
DEFINE_STRING( BGl_string5311z00zz__evaluate_compz00, BgL_bgl_string5311za700za7za7_5469za7, "-fl", 3 );
DEFINE_STRING( BGl_string5313z00zz__evaluate_compz00, BgL_bgl_string5313za700za7za7_5470za7, "*fl", 3 );
DEFINE_STRING( BGl_string5315z00zz__evaluate_compz00, BgL_bgl_string5315za700za7za7_5471za7, "/fl", 3 );
DEFINE_STRING( BGl_string5317z00zz__evaluate_compz00, BgL_bgl_string5317za700za7za7_5472za7, "<fl", 3 );
DEFINE_STRING( BGl_string5319z00zz__evaluate_compz00, BgL_bgl_string5319za700za7za7_5473za7, ">fl", 3 );
DEFINE_STRING( BGl_string5321z00zz__evaluate_compz00, BgL_bgl_string5321za700za7za7_5474za7, "<=fl", 4 );
DEFINE_STRING( BGl_string5323z00zz__evaluate_compz00, BgL_bgl_string5323za700za7za7_5475za7, ">=fl", 4 );
DEFINE_STRING( BGl_string5325z00zz__evaluate_compz00, BgL_bgl_string5325za700za7za7_5476za7, "=fl", 3 );
DEFINE_STRING( BGl_string5327z00zz__evaluate_compz00, BgL_bgl_string5327za700za7za7_5477za7, "car", 3 );
extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
DEFINE_STRING( BGl_string5329z00zz__evaluate_compz00, BgL_bgl_string5329za700za7za7_5478za7, "pair", 4 );
extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_STRING( BGl_string5331z00zz__evaluate_compz00, BgL_bgl_string5331za700za7za7_5479za7, "cdr", 3 );
DEFINE_STRING( BGl_string5333z00zz__evaluate_compz00, BgL_bgl_string5333za700za7za7_5480za7, "cadr", 4 );
DEFINE_STRING( BGl_string5335z00zz__evaluate_compz00, BgL_bgl_string5335za700za7za7_5481za7, "comp1385", 8 );
DEFINE_STRING( BGl_string5336z00zz__evaluate_compz00, BgL_bgl_string5336za700za7za7_5482za7, "internal error: not defined for", 31 );
DEFINE_STRING( BGl_string5337z00zz__evaluate_compz00, BgL_bgl_string5337za700za7za7_5483za7, "&comp", 5 );
DEFINE_STRING( BGl_string5339z00zz__evaluate_compz00, BgL_bgl_string5339za700za7za7_5484za7, "comp", 4 );
DEFINE_STRING( BGl_string5361z00zz__evaluate_compz00, BgL_bgl_string5361za700za7za7_5485za7, "internal error", 14 );
DEFINE_STRING( BGl_string5362z00zz__evaluate_compz00, BgL_bgl_string5362za700za7za7_5486za7, "must be dead code", 17 );
DEFINE_STRING( BGl_string5364z00zz__evaluate_compz00, BgL_bgl_string5364za700za7za7_5487za7, "notyet", 6 );
DEFINE_STRING( BGl_string5365z00zz__evaluate_compz00, BgL_bgl_string5365za700za7za7_5488za7, "synchronize", 11 );
DEFINE_STRING( BGl_string5366z00zz__evaluate_compz00, BgL_bgl_string5366za700za7za7_5489za7, "mutex", 5 );
DEFINE_STRING( BGl_string5367z00zz__evaluate_compz00, BgL_bgl_string5367za700za7za7_5490za7, "set!", 4 );
DEFINE_STRING( BGl_string5368z00zz__evaluate_compz00, BgL_bgl_string5368za700za7za7_5491za7, "read-only variable", 18 );
DEFINE_STRING( BGl_string5369z00zz__evaluate_compz00, BgL_bgl_string5369za700za7za7_5492za7, "\nRedefinition of compiled variable -- ", 38 );
DEFINE_STRING( BGl_string5370z00zz__evaluate_compz00, BgL_bgl_string5370za700za7za7_5493za7, "Unbound variable", 16 );
DEFINE_STRING( BGl_string5372z00zz__evaluate_compz00, BgL_bgl_string5372za700za7za7_5494za7, "@", 1 );
DEFINE_STRING( BGl_string5373z00zz__evaluate_compz00, BgL_bgl_string5373za700za7za7_5495za7, "Uninitialized variable", 22 );
DEFINE_STRING( BGl_string5383z00zz__evaluate_compz00, BgL_bgl_string5383za700za7za7_5496za7, "get_sp", 6 );
DEFINE_STRING( BGl_string5385z00zz__evaluate_compz00, BgL_bgl_string5385za700za7za7_5497za7, "reset_profile", 13 );
DEFINE_STRING( BGl_string5387z00zz__evaluate_compz00, BgL_bgl_string5387za700za7za7_5498za7, "get_profile", 11 );
DEFINE_STRING( BGl_string5389z00zz__evaluate_compz00, BgL_bgl_string5389za700za7za7_5499za7, "reset_stack", 11 );
extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
DEFINE_STRING( BGl_string5390z00zz__evaluate_compz00, BgL_bgl_string5390za700za7za7_5500za7, "internal error: unknown command", 31 );
DEFINE_STRING( BGl_string5391z00zz__evaluate_compz00, BgL_bgl_string5391za700za7za7_5501za7, "__evaluate_comp", 15 );
extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol5238z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5240z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5242z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5248z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5256z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5258z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5260z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5263z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5266z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5268z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5270z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5272z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5274z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5276z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5278z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5280z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5282z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5284z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5286z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5288z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5290z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5292z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5294z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5296z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5298z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5300z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5302z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5304z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5306z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5308z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5310z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5312z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5314z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5316z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5318z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5320z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5322z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5324z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5326z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5328z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5330z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5332z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5363z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5371z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5382z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5384z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5386z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_symbol5388z00zz__evaluate_compz00) );
ADD_ROOT( (void *)(&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_comp.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "(\"append-21009\" \"BGl_appendzd221009zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"reset_profile\" \"Eval/evaluate_comp.scm\" 3738) \"BGl_reset_profilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"o->s~0\" \"Eval/evaluate_comp.scm\" 3991) \"BGl_ozd2ze3sze70zd6zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<lexint\" \"Eval/evaluate_comp.scm\" 3822) \"BGl_z62zc3lexintza1zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"get_profile\" \"Eval/evaluate_comp.scm\" 4130) \"BGl_get_profilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~1\" \"Eval/evaluate_comp.scm\" 4155) \"BGl_recze71ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"index\" \"Eval/evaluate_comp.scm\" 4323) \"BGl_indexz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"_index\" \"Eval/evaluate_comp.scm\" 4474) \"BGl__indexz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"lname\" \"Eval/evaluate_comp.scm\" 5060) \"BGl_lnamez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"loc-type-error\" \"Eval/evaluate_comp.scm\" 5157) \"BGl_loczd2typezd2errorz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-state\" \"Eval/evaluate_comp.scm\" 5415) \"BGl_makezd2statezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"find-state\" \"Eval/evaluate_comp.scm\" 5531) \"BGl_findzd2statezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&find-state\" \"Eval/evaluate_comp.scm\" 5531) \"BGl_z62findzd2statezb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"compile\" \"Eval/evaluate_comp.scm\" 6974) \"BGl_compilez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&compile\" \"Eval/evaluate_comp.scm\" 6974) \"BGl_z62compilez62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"global-fun-value\" \"Eval/evaluate_comp.scm\" 8623) \"BGl_globalzd2funzd2valuez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"catch-goto-trampoline\" \"Eval/evaluate_comp.scm\" 17544) \"BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-boxes-args-on-sp\" \"Eval/evaluate_comp.scm\" 18918) \"BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"sub-stk\" \"Eval/evaluate_comp.scm\" 19526) \"BGl_subzd2stkzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"catch-trampoline\" \"Eval/evaluate_comp.scm\" 20027) \"BGl_catchzd2trampolinezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"check-stack\" \"Eval/evaluate_comp.scm\" 20362) \"BGl_checkzd2stackzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-with-push\" \"Eval/evaluate_comp.scm\" 20432) \"BGl_compzd2withzd2pushz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"rec~0\" \"Eval/evaluate_comp.scm\" 20677) \"BGl_recze70ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"subr-call-with-push\" \"Eval/evaluate_comp.scm\" 20840) \"BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-args-on-sp\" \"Eval/evaluate_comp.scm\" 21077) \"BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"push-nargs-on-sp\" \"Eval/evaluate_comp.scm\" 21237) \"BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"need-shift\" \"Eval/evaluate_comp.scm\" 23383) \"BGl_needzd2shiftzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-old-call\" \"Eval/evaluate_comp.scm\" 23648) \"BGl_compzd2oldzd2callz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1788>\" \"Eval/evaluate_comp.scm\" 24088) \"BGl_z62zc3z04anonymousza31788ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1811>\" \"Eval/evaluate_comp.scm\" 24088) \"BGl_z62zc3z04anonymousza31811ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1834>\" \"Eval/evaluate_comp.scm\" 24429) \"BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1854>\" \"Eval/evaluate_comp.scm\" 24429) \"BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1875>\" \"Eval/evaluate_comp.scm\" 23861) \"BGl_z62zc3z04anonymousza31875ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1895>\" \"Eval/evaluate_comp.scm\" 23861) \"BGl_z62zc3z04anonymousza31895ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call0\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call0zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1918>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1920>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31920ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1924>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31924ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1938>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1954>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31954ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1968>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31968ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call1\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call1zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1984>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31984ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1986>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31986ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1990>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza31990ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2009>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32009ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2030>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32030ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2049>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32049ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call2\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call2zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2070>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32070ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2072>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32072ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2076>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32076ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2102>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32102ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2130>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32130ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2156>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32156ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call3\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call3zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2184>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32184ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2186>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2190>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32190ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2225>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32225ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2262>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32262ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2297>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32297ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp-call4\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_compzd2call4zd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2334>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32334ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2336>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32336ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2340>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32340ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2386>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32386ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2434>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32434ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2480>\" \"Eval/evaluate_comp.scm\" 28541) \"BGl_z62zc3z04anonymousza32480ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"is-constant-fun?\" \"Eval/evaluate_comp.scm\" 28599) \"BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"compile-float-arith\" \"Eval/evaluate_comp.scm\" 29243) \"BGl_compilezd2floatzd2arithz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"eval-float-arith\" \"Eval/evaluate_comp.scm\" 30631) \"BGl_evalzd2floatzd2arithz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"E~0\" \"Eval/evaluate_comp.scm\" 31463) \"BGl_Eze70ze7zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"arith-expression\" \"Eval/evaluate_comp.scm\" 31480) \"BGl_arithzd2expressionzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2649>\" \"Eval/evaluate_comp.scm\" 31744) \"BGl_z62zc3z04anonymousza32649ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"inline-call\" \"Eval/evaluate_comp.scm\" 32671) \"BGl_inlinezd2callzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2653>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32653ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2657>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32657ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2661>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32661ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2665>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32665ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2669>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32669ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2673>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32673ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2677>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32677ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2681>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32681ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2685>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32685ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2689>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32689ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2693>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32693ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2697>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32697ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2701>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32701ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2705>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32705ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2709>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32709ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2713>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32713ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2717>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32717ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2721>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32721ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2725>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32725ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2729>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32729ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2733>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32733ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2737>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32737ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2741>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32741ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2745>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32745ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2749>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32749ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2753>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32753ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2757>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32757ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2761>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32761ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2763>\" \"Eval/evaluate_comp.scm\" 33014) \"BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2766>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32766ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2769>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32769ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2772>\" \"Eval/evaluate_comp.scm\" 32860) \"BGl_z62zc3z04anonymousza32772ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"cadr?\" \"Eval/evaluate_comp.scm\" 33248) \"BGl_cadrzf3zf3zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"cadrerrv\" \"Eval/evaluate_comp.scm\" 33304) \"BGl_cadrerrvz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"correct\" \"Eval/evaluate_comp.scm\" 34318) \"BGl_correctz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"bind-frame\" \"Eval/evaluate_comp.scm\" 34404) \"BGl_bindzd2framezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"make-boxes\" \"Eval/evaluate_comp.scm\" 38731) \"BGl_makezd2boxeszd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"free-collect\" \"Eval/evaluate_comp.scm\" 38987) \"BGl_freezd2collectzd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"free-restore\" \"Eval/evaluate_comp.scm\" 39257) \"BGl_freezd2restorezd2zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp1385\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_z62comp1385z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"comp\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_compz00zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp\" \"Eval/evaluate_comp.scm\" 7022) \"BGl_z62compz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_abs1431\" \"Eval/evaluate_comp.scm\" 38257) \"BGl_z62compzd2ev_abs1431zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3574>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33574ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62mainz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62runz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3585>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33585ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5148\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5148z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5149\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5149z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3599>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33599ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5150\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5150z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5151\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5151z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3611>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33611ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5152\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5152z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5153\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5153z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3523>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5154\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5154z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5155\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5155z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3533>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33533ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5156\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5156z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5157\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5157z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3546>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33546ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5158\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5158z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5159\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5159z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3557>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5160\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5160z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5161\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5161z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3472>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5162\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5162z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5163\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5163z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3482>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5164\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5164z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5165\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5165z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3495>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5166\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5166z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5167\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5167z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3506>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5168\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5168z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5169\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5169z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3425>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33425ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5170\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5170z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5171\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5171z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3434>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33434ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5172\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5172z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5173\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5173z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3446>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33446ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5174\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5174z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5175\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5175z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3456>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33456ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5176\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5176z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5177\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5177z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3378>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33378ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5178\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5178z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5179\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5179z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3387>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5180\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5180z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5181\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5181z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3399>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33399ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5182\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5182z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5183\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5183z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3409>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33409ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5184\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5184z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5185\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5185z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3335>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5186\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5186z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5187\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5187z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3343>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33343ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5188\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5188z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5189\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5189z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3354>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33354ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5190\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5190z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5191\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5191z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3363>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33363ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5192\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5192z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5193\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5193z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3292>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33292ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5194\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5194z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5195\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5195z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3300>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33300ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5196\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5196z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5197\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5197z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3311>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33311ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5198\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5198z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5199\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5199z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3320>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5200\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5200z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5201\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5201z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3253>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5202\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5202z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5203\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5203z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3260>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33260ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5204\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5204z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5205\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5205z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3270>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5206\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5206z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5207\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5207z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3278>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33278ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5208\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5208z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5209\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5209z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3214>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5210\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5210z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5211\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5211z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3221>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33221ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5212\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5212z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5213\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5213z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3231>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5214\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5214z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5215\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5215z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3239>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33239ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5216\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5216z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5217\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5217z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3179>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5218\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5218z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5219\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5219z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3185>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33185ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5220\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5220z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5221\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5221z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3194>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33194ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5222\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5222z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5223\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5223z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3201>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5224\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5224z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5225\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5225z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3629>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5226\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5226z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5227\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5227z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3649>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33649ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5228\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5228z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5229\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5229z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3672>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5230\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5230z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5231\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5231z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3693>\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62zc3z04anonymousza33693ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&main5232\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62main5232z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&run5233\" \"Eval/evaluate_comp.scm\" 38688) \"BGl_z62run5233z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_app1429\" \"Eval/evaluate_comp.scm\" 33872) \"BGl_z62compzd2ev_app1429zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_goto1427\" \"Eval/evaluate_comp.scm\" 17884) \"BGl_z62compzd2ev_goto1427zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3118>\" \"Eval/evaluate_comp.scm\" 18509) \"BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3124>\" \"Eval/evaluate_comp.scm\" 18790) \"BGl_z62zc3z04anonymousza33124ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_labels1425\" \"Eval/evaluate_comp.scm\" 16809) \"BGl_z62compzd2ev_labels1425zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3113>\" \"Eval/evaluate_comp.scm\" 17482) \"BGl_z62zc3z04anonymousza33113ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_synchronize1423\" \"Eval/evaluate_comp.scm\" 16182) \"BGl_z62compzd2ev_synchroniza7e1423z17zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3092>\" \"Eval/evaluate_comp.scm\" 16392) \"BGl_z62zc3z04anonymousza33092ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_with-handler1421\" \"Eval/evaluate_comp.scm\" 15840) \"BGl_z62compzd2ev_withzd2handler1421z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3078>\" \"Eval/evaluate_comp.scm\" 16005) \"BGl_z62zc3z04anonymousza33078ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"<@exit:3085>~0\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_zc3z04exitza33085ze3ze70z60zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3088>\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3089>\" \"Eval/evaluate_comp.scm\" 16112) \"BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_unwind-prote1419\" \"Eval/evaluate_comp.scm\" 15532) \"BGl_z62compzd2ev_unwindzd2prote1419z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3074>\" \"Eval/evaluate_comp.scm\" 15683) \"BGl_z62zc3z04anonymousza33074ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3075>\" \"Eval/evaluate_comp.scm\" 15752) \"BGl_z62zc3z04anonymousza33075ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_bind-exit1417\" \"Eval/evaluate_comp.scm\" 15077) \"BGl_z62compzd2ev_bindzd2exit1417z62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3067>\" \"Eval/evaluate_comp.scm\" 15316) \"BGl_z62zc3z04anonymousza33067ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"<@exit:3068>~0\" \"Eval/evaluate_comp.scm\" 15383) \"BGl_zc3z04exitza33068ze3ze70z60zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&exit\" \"Eval/evaluate_comp.scm\" 15383) \"BGl_z62exitz62zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_letrec1415\" \"Eval/evaluate_comp.scm\" 14024) \"BGl_z62compzd2ev_letrec1415zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3028>\" \"Eval/evaluate_comp.scm\" 14306) \"BGl_z62zc3z04anonymousza33028ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3041>\" \"Eval/evaluate_comp.scm\" 14662) \"BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_let*1413\" \"Eval/evaluate_comp.scm\" 13529) \"BGl_z62compzd2ev_letza21413z12zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:3007>\" \"Eval/evaluate_comp.scm\" 13764) \"BGl_z62zc3z04anonymousza33007ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_let1411\" \"Eval/evaluate_comp.scm\" 12849) \"BGl_z62compzd2ev_let1411zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2986>\" \"Eval/evaluate_comp.scm\" 13176) \"BGl_z62zc3z04anonymousza32986ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_prog21409\" \"Eval/evaluate_comp.scm\" 12655) \"BGl_z62compzd2ev_prog21409zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2983>\" \"Eval/evaluate_comp.scm\" 12785) \"BGl_z62zc3z04anonymousza32983ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_and1406\" \"Eval/evaluate_comp.scm\" 12369) \"BGl_z62compzd2ev_and1406zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2973>\" \"Eval/evaluate_comp.scm\" 12500) \"BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_or1404\" \"Eval/evaluate_comp.scm\" 12111) \"BGl_z62compzd2ev_or1404zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2963>\" \"Eval/evaluate_comp.scm\" 12240) \"BGl_z62zc3z04anonymousza32963ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_if1402\" \"Eval/evaluate_comp.scm\" 11907) \"BGl_z62compzd2ev_if1402zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2958>\" \"Eval/evaluate_comp.scm\" 12044) \"BGl_z62zc3z04anonymousza32958ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_litt1400\" \"Eval/evaluate_comp.scm\" 11788) \"BGl_z62compzd2ev_litt1400zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2957>\" \"Eval/evaluate_comp.scm\" 11867) \"BGl_z62zc3z04anonymousza32957ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_defglobal1398\" \"Eval/evaluate_comp.scm\" 10831) \"BGl_z62compzd2ev_defglobal1398zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2931>\" \"Eval/evaluate_comp.scm\" 10957) \"BGl_z62zc3z04anonymousza32931ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_setglobal1396\" \"Eval/evaluate_comp.scm\" 9970) \"BGl_z62compzd2ev_setglobal1396zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2906>\" \"Eval/evaluate_comp.scm\" 10180) \"BGl_z62zc3z04anonymousza32906ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2911>\" \"Eval/evaluate_comp.scm\" 10353) \"BGl_z62zc3z04anonymousza32911ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2922>\" \"Eval/evaluate_comp.scm\" 10613) \"BGl_z62zc3z04anonymousza32922ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_global1394\" \"Eval/evaluate_comp.scm\" 8830) \"BGl_z62compzd2ev_global1394zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2866>\" \"Eval/evaluate_comp.scm\" 9018) \"BGl_z62zc3z04anonymousza32866ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2868>\" \"Eval/evaluate_comp.scm\" 9111) \"BGl_z62zc3z04anonymousza32868ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2879>\" \"Eval/evaluate_comp.scm\" 9364) \"BGl_z62zc3z04anonymousza32879ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_setlocal1392\" \"Eval/evaluate_comp.scm\" 8242) \"BGl_z62compzd2ev_setlocal1392zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2855>\" \"Eval/evaluate_comp.scm\" 8418) \"BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2859>\" \"Eval/evaluate_comp.scm\" 8525) \"BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_var1390\" \"Eval/evaluate_comp.scm\" 8097) \"BGl_z62compzd2ev_var1390zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2843>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2846>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32846ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2837>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2840>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32840ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2831>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2834>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32834ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2825>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2828>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32828ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2849>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2852>\" \"Eval/evaluate_comp.scm\" 8208) \"BGl_z62zc3z04anonymousza32852ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&comp-ev_trap1388\" \"Eval/evaluate_comp.scm\" 7340) \"BGl_z62compzd2ev_trap1388zb0zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2816>\" \"Eval/evaluate_comp.scm\" 7442) \"BGl_z62zc3z04anonymousza32816ze3ze5zz__evaluate_compz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long BgL_checksumz00_15075, char * BgL_fromz00_15076)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_compz00(); 
BGl_cnstzd2initzd2zz__evaluate_compz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_compz00(); 
BGl_genericzd2initzd2zz__evaluate_compz00(); 
BGl_methodzd2initzd2zz__evaluate_compz00(); 
BGl_toplevelzd2initzd2zz__evaluate_compz00(); 
return 
BGl_profzd2initzd2zz__evaluate_compz00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_symbol5238z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5239z00zz__evaluate_compz00); 
BGl_symbol5240z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5241z00zz__evaluate_compz00); 
BGl_symbol5242z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5243z00zz__evaluate_compz00); 
BGl_symbol5248z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5249z00zz__evaluate_compz00); 
BGl_symbol5256z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5257z00zz__evaluate_compz00); 
BGl_symbol5258z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5259z00zz__evaluate_compz00); 
BGl_symbol5260z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5261z00zz__evaluate_compz00); 
BGl_symbol5263z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5264z00zz__evaluate_compz00); 
BGl_symbol5266z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5267z00zz__evaluate_compz00); 
BGl_symbol5268z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5269z00zz__evaluate_compz00); 
BGl_symbol5270z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5271z00zz__evaluate_compz00); 
BGl_symbol5272z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5273z00zz__evaluate_compz00); 
BGl_symbol5274z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5275z00zz__evaluate_compz00); 
BGl_symbol5276z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5277z00zz__evaluate_compz00); 
BGl_symbol5278z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5279z00zz__evaluate_compz00); 
BGl_symbol5280z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5281z00zz__evaluate_compz00); 
BGl_symbol5282z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5283z00zz__evaluate_compz00); 
BGl_symbol5284z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5285z00zz__evaluate_compz00); 
BGl_symbol5286z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5287z00zz__evaluate_compz00); 
BGl_symbol5288z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5289z00zz__evaluate_compz00); 
BGl_symbol5290z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5291z00zz__evaluate_compz00); 
BGl_symbol5292z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5293z00zz__evaluate_compz00); 
BGl_symbol5294z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5295z00zz__evaluate_compz00); 
BGl_symbol5296z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5297z00zz__evaluate_compz00); 
BGl_symbol5298z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5299z00zz__evaluate_compz00); 
BGl_symbol5300z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5301z00zz__evaluate_compz00); 
BGl_symbol5302z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5303z00zz__evaluate_compz00); 
BGl_symbol5304z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5305z00zz__evaluate_compz00); 
BGl_symbol5306z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5307z00zz__evaluate_compz00); 
BGl_symbol5308z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5309z00zz__evaluate_compz00); 
BGl_symbol5310z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5311z00zz__evaluate_compz00); 
BGl_symbol5312z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5313z00zz__evaluate_compz00); 
BGl_symbol5314z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5315z00zz__evaluate_compz00); 
BGl_symbol5316z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5317z00zz__evaluate_compz00); 
BGl_symbol5318z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5319z00zz__evaluate_compz00); 
BGl_symbol5320z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5321z00zz__evaluate_compz00); 
BGl_symbol5322z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5323z00zz__evaluate_compz00); 
BGl_symbol5324z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5325z00zz__evaluate_compz00); 
BGl_symbol5326z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5327z00zz__evaluate_compz00); 
BGl_symbol5328z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5329z00zz__evaluate_compz00); 
BGl_symbol5330z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5331z00zz__evaluate_compz00); 
BGl_symbol5332z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5333z00zz__evaluate_compz00); 
BGl_symbol5363z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5364z00zz__evaluate_compz00); 
BGl_symbol5371z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5372z00zz__evaluate_compz00); 
BGl_symbol5382z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5383z00zz__evaluate_compz00); 
BGl_symbol5384z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5385z00zz__evaluate_compz00); 
BGl_symbol5386z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5387z00zz__evaluate_compz00); 
return ( 
BGl_symbol5388z00zz__evaluate_compz00 = 
bstring_to_symbol(BGl_string5389z00zz__evaluate_compz00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
write_bprof_table();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
{ /* Eval/evaluate_comp.scm 114 */
BGL_LONGLONG_T BgL_arg1498z00_1352;
{ /* Eval/evaluate_comp.scm 114 */
BGL_LONGLONG_T BgL_res4020z00_6424;
BgL_res4020z00_6424 = 
LONG_TO_LLONG(((long)0)); 
BgL_arg1498z00_1352 = BgL_res4020z00_6424; } 
{ /* Eval/evaluate_comp.scm 114 */
obj_t BgL_list1499z00_1353;
{ /* Eval/evaluate_comp.scm 114 */
obj_t BgL_arg1500z00_1354;
BgL_arg1500z00_1354 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1498z00_1352), BNIL); 
BgL_list1499z00_1353 = 
MAKE_YOUNG_PAIR(BGl_symbol5238z00zz__evaluate_compz00, BgL_arg1500z00_1354); } 
BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BgL_list1499z00_1353; } } 
BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long)8192); 
BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = 
create_struct(BGl_symbol5240z00zz__evaluate_compz00, 
(int)(((long)0))); 
BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = 
create_struct(BGl_symbol5242z00zz__evaluate_compz00, 
(int)(((long)0))); 
return BUNSPEC;} 

}



/* append-21009 */
obj_t BGl_appendzd221009zd2zz__evaluate_compz00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
{
{ 
{ 
obj_t BgL_headz00_1355;
BgL_headz00_1355 = 
MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2); 
{ 
obj_t BgL_prevz00_1356;obj_t BgL_tailz00_1357;
BgL_prevz00_1356 = BgL_headz00_1355; 
BgL_tailz00_1357 = BgL_l1z00_1; 
BgL_loopz00_1358:
if(
PAIRP(BgL_tailz00_1357))
{ 
obj_t BgL_newzd2prevzd2_1360;
BgL_newzd2prevzd2_1360 = 
MAKE_YOUNG_PAIR(
CAR(BgL_tailz00_1357), BgL_l2z00_2); 
SET_CDR(BgL_prevz00_1356, BgL_newzd2prevzd2_1360); 
{ 
obj_t BgL_tailz00_15152;obj_t BgL_prevz00_15151;
BgL_prevz00_15151 = BgL_newzd2prevzd2_1360; 
BgL_tailz00_15152 = 
CDR(BgL_tailz00_1357); 
BgL_tailz00_1357 = BgL_tailz00_15152; 
BgL_prevz00_1356 = BgL_prevz00_15151; 
goto BgL_loopz00_1358;} }  else 
{ BNIL; } 
return 
CDR(BgL_headz00_1355);} } } 

}



/* reset_profile */
obj_t BGl_reset_profilez00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 132 */
{ /* Eval/evaluate_comp.scm 133 */
BGL_LONGLONG_T BgL_arg1521z00_1383;
{ /* Eval/evaluate_comp.scm 133 */
BGL_LONGLONG_T BgL_res4027z00_6437;
BgL_res4027z00_6437 = 
LONG_TO_LLONG(((long)0)); 
BgL_arg1521z00_1383 = BgL_res4027z00_6437; } 
{ /* Eval/evaluate_comp.scm 133 */
obj_t BgL_list1522z00_1384;
{ /* Eval/evaluate_comp.scm 133 */
obj_t BgL_arg1523z00_1385;
BgL_arg1523z00_1385 = 
MAKE_YOUNG_PAIR(
make_bllong(BgL_arg1521z00_1383), BNIL); 
BgL_list1522z00_1384 = 
MAKE_YOUNG_PAIR(BGl_symbol5238z00zz__evaluate_compz00, BgL_arg1523z00_1385); } 
return ( 
BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BgL_list1522z00_1384, BUNSPEC) ;} } } 

}



/* o->s~0 */
obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1394)
{
{ /* Eval/evaluate_comp.scm 141 */
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1394))
{ /* Ieee/fixnum.scm 979 */

return 
BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
(long)CINT(BgL_vz00_1394), ((long)10));}  else 
{ /* Eval/evaluate_comp.scm 138 */
if(
SYMBOLP(BgL_vz00_1394))
{ /* Eval/evaluate_comp.scm 139 */
obj_t BgL_res4030z00_6442;
{ /* Eval/evaluate_comp.scm 139 */
obj_t BgL_arg3867z00_6441;
BgL_arg3867z00_6441 = 
SYMBOL_TO_STRING(BgL_vz00_1394); 
BgL_res4030z00_6442 = 
BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg3867z00_6441); } 
return BgL_res4030z00_6442;}  else 
{ /* Eval/evaluate_comp.scm 139 */
if(
STRINGP(BgL_vz00_1394))
{ /* Eval/evaluate_comp.scm 140 */
return BgL_vz00_1394;}  else 
{ /* Eval/evaluate_comp.scm 140 */
return BGl_string5244z00zz__evaluate_compz00;} } } } 

}



/* &<lexint */
obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_10644, obj_t BgL_t1z00_10645, obj_t BgL_t2z00_10646)
{
{ /* Eval/evaluate_comp.scm 135 */
{ /* Eval/evaluate_comp.scm 138 */
bool_t BgL_tmpz00_15169;
{ /* Eval/evaluate_comp.scm 142 */
obj_t BgL_v1z00_12636;obj_t BgL_v2z00_12637;
BgL_v1z00_12636 = 
CAR(
((obj_t)BgL_t1z00_10645)); 
BgL_v2z00_12637 = 
CAR(
((obj_t)BgL_t2z00_10646)); 
{ /* Eval/evaluate_comp.scm 143 */
bool_t BgL_test5507z00_15174;
if(
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_12636))
{ /* Eval/evaluate_comp.scm 143 */
BgL_test5507z00_15174 = 
BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v2z00_12637)
; }  else 
{ /* Eval/evaluate_comp.scm 143 */
BgL_test5507z00_15174 = ((bool_t)0)
; } 
if(BgL_test5507z00_15174)
{ /* Eval/evaluate_comp.scm 143 */
BgL_tmpz00_15169 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_12636, BgL_v2z00_12637)
; }  else 
{ /* Eval/evaluate_comp.scm 143 */
BgL_tmpz00_15169 = 
bigloo_string_lt(
BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v1z00_12636), 
BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_12637))
; } } } 
return 
BBOOL(BgL_tmpz00_15169);} } 

}



/* get_profile */
obj_t BGl_get_profilez00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 147 */
BGl_recze71ze7zz__evaluate_compz00(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00); 
return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;} 

}



/* rec~1 */
bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1403)
{
{ /* Eval/evaluate_comp.scm 148 */
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_arg1534z00_1405;obj_t BgL_arg1536z00_1406;
BgL_arg1534z00_1405 = 
CDR(
((obj_t)BgL_tz00_1403)); 
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_arg1537z00_1407;
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_pairz00_6453;
BgL_pairz00_6453 = 
CDR(
((obj_t)BgL_tz00_1403)); 
BgL_arg1537z00_1407 = 
CDR(BgL_pairz00_6453); } 
BgL_arg1536z00_1406 = 
BGl_sortz00zz__r4_vectors_6_8z00(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1537z00_1407); } 
{ /* Eval/evaluate_comp.scm 149 */
obj_t BgL_tmpz00_15190;
BgL_tmpz00_15190 = 
((obj_t)BgL_arg1534z00_1405); 
SET_CDR(BgL_tmpz00_15190, BgL_arg1536z00_1406); } } 
{ /* Eval/evaluate_comp.scm 150 */
obj_t BgL_g1287z00_1408;
{ /* Eval/evaluate_comp.scm 150 */
obj_t BgL_pairz00_6458;
BgL_pairz00_6458 = 
CDR(
((obj_t)BgL_tz00_1403)); 
BgL_g1287z00_1408 = 
CDR(BgL_pairz00_6458); } 
{ 
obj_t BgL_l1285z00_1410;
BgL_l1285z00_1410 = BgL_g1287z00_1408; 
BgL_zc3z04anonymousza31538ze3z87_1411:
if(
PAIRP(BgL_l1285z00_1410))
{ /* Eval/evaluate_comp.scm 150 */
BGl_recze71ze7zz__evaluate_compz00(
CAR(BgL_l1285z00_1410)); 
{ 
obj_t BgL_l1285z00_15200;
BgL_l1285z00_15200 = 
CDR(BgL_l1285z00_1410); 
BgL_l1285z00_1410 = BgL_l1285z00_15200; 
goto BgL_zc3z04anonymousza31538ze3z87_1411;} }  else 
{ /* Eval/evaluate_comp.scm 150 */
return ((bool_t)1);} } } } 

}



/* index */
obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
{
{ /* Eval/evaluate_comp.scm 156 */
{ 
obj_t BgL_lz00_1418;long BgL_nz00_1419;
BgL_lz00_1418 = BgL_lz00_7; 
BgL_nz00_1419 = ((long)0); 
BgL_zc3z04anonymousza31541ze3z87_1420:
if(
NULLP(BgL_lz00_1418))
{ /* Eval/evaluate_comp.scm 158 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 158 */
if(
(BgL_xz00_6==
CAR(
((obj_t)BgL_lz00_1418))))
{ /* Eval/evaluate_comp.scm 159 */
return 
BINT(BgL_nz00_1419);}  else 
{ 
long BgL_nz00_15212;obj_t BgL_lz00_15209;
BgL_lz00_15209 = 
CDR(
((obj_t)BgL_lz00_1418)); 
BgL_nz00_15212 = 
(BgL_nz00_1419+((long)1)); 
BgL_nz00_1419 = BgL_nz00_15212; 
BgL_lz00_1418 = BgL_lz00_15209; 
goto BgL_zc3z04anonymousza31541ze3z87_1420;} } } } 

}



/* _index */
obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
{
{ /* Eval/evaluate_comp.scm 163 */
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL__ortest_1076z00_1428;
BgL__ortest_1076z00_1428 = 
BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9); 
if(
CBOOL(BgL__ortest_1076z00_1428))
{ /* Eval/evaluate_comp.scm 164 */
return BgL__ortest_1076z00_1428;}  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1550z00_1429;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1552z00_1430;
if(
NULLP(BgL_lz00_9))
{ /* Eval/evaluate_comp.scm 164 */
BgL_arg1552z00_1430 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_head1290z00_1436;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1564z00_1448;
BgL_arg1564z00_1448 = 
BGl_lnamez00zz__evaluate_compz00(
CAR(
((obj_t)BgL_lz00_9))); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_res4037z00_6469;
BgL_res4037z00_6469 = 
MAKE_YOUNG_PAIR(BgL_arg1564z00_1448, BNIL); 
BgL_head1290z00_1436 = BgL_res4037z00_6469; } } 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_g1293z00_1437;
BgL_g1293z00_1437 = 
CDR(
((obj_t)BgL_lz00_9)); 
{ 
obj_t BgL_l1288z00_1439;obj_t BgL_tail1291z00_1440;
BgL_l1288z00_1439 = BgL_g1293z00_1437; 
BgL_tail1291z00_1440 = BgL_head1290z00_1436; 
BgL_zc3z04anonymousza31557ze3z87_1441:
if(
NULLP(BgL_l1288z00_1439))
{ /* Eval/evaluate_comp.scm 164 */
BgL_arg1552z00_1430 = BgL_head1290z00_1436; }  else 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_newtail1292z00_1443;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1562z00_1445;
BgL_arg1562z00_1445 = 
BGl_lnamez00zz__evaluate_compz00(
CAR(
((obj_t)BgL_l1288z00_1439))); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_res4039z00_6473;
BgL_res4039z00_6473 = 
MAKE_YOUNG_PAIR(BgL_arg1562z00_1445, BNIL); 
BgL_newtail1292z00_1443 = BgL_res4039z00_6473; } } 
SET_CDR(BgL_tail1291z00_1440, BgL_newtail1292z00_1443); 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1561z00_1444;
BgL_arg1561z00_1444 = 
CDR(
((obj_t)BgL_l1288z00_1439)); 
{ 
obj_t BgL_tail1291z00_15235;obj_t BgL_l1288z00_15234;
BgL_l1288z00_15234 = BgL_arg1561z00_1444; 
BgL_tail1291z00_15235 = BgL_newtail1292z00_1443; 
BgL_tail1291z00_1440 = BgL_tail1291z00_15235; 
BgL_l1288z00_1439 = BgL_l1288z00_15234; 
goto BgL_zc3z04anonymousza31557ze3z87_1441;} } } } } } 
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_list1553z00_1431;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1554z00_1432;
{ /* Eval/evaluate_comp.scm 164 */
obj_t BgL_arg1555z00_1433;
BgL_arg1555z00_1433 = 
MAKE_YOUNG_PAIR(BgL_arg1552z00_1430, BNIL); 
BgL_arg1554z00_1432 = 
MAKE_YOUNG_PAIR(BGl_string5245z00zz__evaluate_compz00, BgL_arg1555z00_1433); } 
BgL_list1553z00_1431 = 
MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1554z00_1432); } 
BgL_arg1550z00_1429 = BgL_list1553z00_1431; } } 
return 
BGl_errorz00zz__errorz00(BGl_string5246z00zz__evaluate_compz00, BGl_string5247z00zz__evaluate_compz00, BgL_arg1550z00_1429);} } } 

}



/* lname */
obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
{
{ /* Eval/evaluate_comp.scm 188 */
if(
BGl_isazf3zf3zz__objectz00(BgL_vz00_16, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 189 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_vz00_16)))->BgL_namez00);}  else 
{ /* Eval/evaluate_comp.scm 189 */
return BgL_vz00_16;} } 

}



/* loc-type-error */
obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17, obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
{
{ /* Eval/evaluate_comp.scm 193 */
{ 
obj_t BgL_fnamez00_1469;obj_t BgL_locz00_1470;
if(
PAIRP(BgL_locz00_20))
{ /* Eval/evaluate_comp.scm 194 */
obj_t BgL_cdrzd2194zd2_1475;
BgL_cdrzd2194zd2_1475 = 
CDR(BgL_locz00_20); 
if(
(
CAR(BgL_locz00_20)==BGl_symbol5248z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 194 */
if(
PAIRP(BgL_cdrzd2194zd2_1475))
{ /* Eval/evaluate_comp.scm 194 */
obj_t BgL_cdrzd2198zd2_1479;
BgL_cdrzd2198zd2_1479 = 
CDR(BgL_cdrzd2194zd2_1475); 
if(
PAIRP(BgL_cdrzd2198zd2_1479))
{ /* Eval/evaluate_comp.scm 194 */
if(
NULLP(
CDR(BgL_cdrzd2198zd2_1479)))
{ /* Eval/evaluate_comp.scm 194 */
BgL_fnamez00_1469 = 
CAR(BgL_cdrzd2194zd2_1475); 
BgL_locz00_1470 = 
CAR(BgL_cdrzd2198zd2_1479); 
return 
BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19, BgL_fnamez00_1469, BgL_locz00_1470);}  else 
{ /* Eval/evaluate_comp.scm 194 */
BgL_tagzd2187zd2_1472:
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1472;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1472;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1472;} }  else 
{ /* Eval/evaluate_comp.scm 194 */
goto BgL_tagzd2187zd2_1472;} } } 

}



/* make-state */
obj_t BGl_makezd2statezd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 206 */
{ /* Eval/evaluate_comp.scm 207 */
obj_t BgL_stkz00_1497;
BgL_stkz00_1497 = 
make_vector(((long)8192), BGl_string5250z00zz__evaluate_compz00); 
VECTOR_SET(BgL_stkz00_1497,((long)0),
BINT(((long)2))); 
return BgL_stkz00_1497;} } 

}



/* find-state */
BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 211 */
{ /* Eval/evaluate_comp.scm 212 */
obj_t BgL_sz00_1498;
{ /* Eval/evaluate_comp.scm 212 */
obj_t BgL_tmpz00_15265;
BgL_tmpz00_15265 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_sz00_1498 = 
BGL_ENV_EVSTATE(BgL_tmpz00_15265); } 
if(
VECTORP(BgL_sz00_1498))
{ /* Eval/evaluate_comp.scm 213 */
return BgL_sz00_1498;}  else 
{ /* Eval/evaluate_comp.scm 214 */
obj_t BgL_statez00_1500;
BgL_statez00_1500 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 215 */
obj_t BgL_tmpz00_15271;
BgL_tmpz00_15271 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_tmpz00_15271, BgL_statez00_1500); } 
return BgL_statez00_1500;} } } 

}



/* &find-state */
obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_10647)
{
{ /* Eval/evaluate_comp.scm 211 */
return 
BGl_findzd2statezd2zz__evaluate_compz00();} 

}



/* compile */
BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_34)
{
{ /* Eval/evaluate_comp.scm 273 */
return 
BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);} 

}



/* &compile */
obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_10648, obj_t BgL_ez00_10649)
{
{ /* Eval/evaluate_comp.scm 273 */
{ /* Eval/evaluate_comp.scm 274 */
BgL_ev_exprz00_bglt BgL_auxz00_15276;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_10649, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 274 */
BgL_auxz00_15276 = 
((BgL_ev_exprz00_bglt)BgL_ez00_10649)
; }  else 
{ 
obj_t BgL_auxz00_15280;
BgL_auxz00_15280 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string5251z00zz__evaluate_compz00, 
BINT(((long)7006)), BGl_string5252z00zz__evaluate_compz00, BGl_string5253z00zz__evaluate_compz00, BgL_ez00_10649); 
FAILURE(BgL_auxz00_15280,BFALSE,BFALSE);} 
return 
BGl_compilez00zz__evaluate_compz00(BgL_auxz00_15276);} } 

}



/* global-fun-value */
obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_43)
{
{ /* Eval/evaluate_comp.scm 332 */
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 335 */
obj_t BgL_gz00_1556;
{ /* Eval/evaluate_comp.scm 335 */
obj_t BgL_arg1649z00_1557;obj_t BgL_arg1650z00_1558;
BgL_arg1649z00_1557 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_ez00_43)))->BgL_modz00); 
BgL_arg1650z00_1558 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_ez00_43)))->BgL_namez00); 
BgL_gz00_1556 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg1649z00_1557, BgL_arg1650z00_1558); } 
if(
CBOOL(BgL_gz00_1556))
{ /* Eval/evaluate_comp.scm 336 */
return 
VECTOR_REF(
((obj_t)BgL_gz00_1556),((long)2));}  else 
{ /* Eval/evaluate_comp.scm 336 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 333 */
return BFALSE;} } 

}



/* catch-goto-trampoline */
obj_t BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(obj_t BgL_fz00_78, obj_t BgL_sz00_79)
{
{ /* Eval/evaluate_comp.scm 593 */
{ 
obj_t BgL_fz00_1568;
BgL_fz00_1568 = BgL_fz00_78; 
BgL_zc3z04anonymousza31659ze3z87_1569:
{ /* Eval/evaluate_comp.scm 597 */
obj_t BgL_rz00_1570;
BgL_rz00_1570 = 
PROCEDURE_ENTRY(BgL_fz00_1568)(BgL_fz00_1568, BgL_sz00_79, BEOA); 
{ /* Eval/evaluate_comp.scm 599 */
bool_t BgL_test5525z00_15301;
if(
PROCEDUREP(BgL_rz00_1570))
{ /* Eval/evaluate_comp.scm 599 */
obj_t BgL_arg1663z00_1575;
BgL_arg1663z00_1575 = 
PROCEDURE_ATTR(BgL_rz00_1570); 
if(
STRUCTP(BgL_arg1663z00_1575))
{ /* Eval/evaluate_comp.scm 569 */
BgL_test5525z00_15301 = 
(
STRUCT_KEY(BgL_arg1663z00_1575)==BGl_symbol5240z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 569 */
BgL_test5525z00_15301 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate_comp.scm 599 */
BgL_test5525z00_15301 = ((bool_t)0)
; } 
if(BgL_test5525z00_15301)
{ 
obj_t BgL_fz00_15309;
BgL_fz00_15309 = BgL_rz00_1570; 
BgL_fz00_1568 = BgL_fz00_15309; 
goto BgL_zc3z04anonymousza31659ze3z87_1569;}  else 
{ /* Eval/evaluate_comp.scm 599 */
return BgL_rz00_1570;} } } } } 

}



/* push-boxes-args-on-sp */
obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85, obj_t BgL_locz00_86)
{
{ /* Eval/evaluate_comp.scm 623 */
{ 
obj_t BgL_lz00_1578;obj_t BgL_bsz00_1579;long BgL_spz00_1580;
BgL_lz00_1578 = BgL_argsz00_83; 
BgL_bsz00_1579 = BgL_boxesz00_84; 
BgL_spz00_1580 = BgL_spz00_85; 
BgL_zc3z04anonymousza31664ze3z87_1581:
if(
NULLP(BgL_lz00_1578))
{ /* Eval/evaluate_comp.scm 625 */
if(
NULLP(BgL_bsz00_1579))
{ /* Eval/evaluate_comp.scm 626 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 629 */
obj_t BgL_arg1667z00_1584;
{ /* Eval/evaluate_comp.scm 629 */
long BgL_arg1668z00_1585;long BgL_arg1669z00_1586;
BgL_arg1668z00_1585 = 
bgl_list_length(BgL_boxesz00_84); 
BgL_arg1669z00_1586 = 
bgl_list_length(BgL_argsz00_83); 
{ /* Eval/evaluate_comp.scm 628 */
obj_t BgL_list1670z00_1587;
{ /* Eval/evaluate_comp.scm 628 */
obj_t BgL_arg1671z00_1588;
BgL_arg1671z00_1588 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1669z00_1586), BNIL); 
BgL_list1670z00_1587 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1668z00_1585), BgL_arg1671z00_1588); } 
BgL_arg1667z00_1584 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string5254z00zz__evaluate_compz00, BgL_list1670z00_1587); } } 
return 
BGl_everrorz00zz__everrorz00(BgL_locz00_86, BGl_string5246z00zz__evaluate_compz00, BGl_string5255z00zz__evaluate_compz00, BgL_arg1667z00_1584);} }  else 
{ /* Eval/evaluate_comp.scm 625 */
if(
NULLP(BgL_bsz00_1579))
{ /* Eval/evaluate_comp.scm 633 */
obj_t BgL_arg1675z00_1590;
{ /* Eval/evaluate_comp.scm 633 */
long BgL_arg1677z00_1591;long BgL_arg1678z00_1592;
BgL_arg1677z00_1591 = 
bgl_list_length(BgL_boxesz00_84); 
BgL_arg1678z00_1592 = 
bgl_list_length(BgL_argsz00_83); 
{ /* Eval/evaluate_comp.scm 632 */
obj_t BgL_list1679z00_1593;
{ /* Eval/evaluate_comp.scm 632 */
obj_t BgL_arg1680z00_1594;
BgL_arg1680z00_1594 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1678z00_1592), BNIL); 
BgL_list1679z00_1593 = 
MAKE_YOUNG_PAIR(
BINT(BgL_arg1677z00_1591), BgL_arg1680z00_1594); } 
BgL_arg1675z00_1590 = 
BGl_formatz00zz__r4_output_6_10_3z00(BGl_string5254z00zz__evaluate_compz00, BgL_list1679z00_1593); } } 
return 
BGl_everrorz00zz__everrorz00(BgL_locz00_86, BGl_string5246z00zz__evaluate_compz00, BGl_string5255z00zz__evaluate_compz00, BgL_arg1675z00_1590);}  else 
{ /* Eval/evaluate_comp.scm 630 */
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_arg1681z00_1595;
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_vz00_1596;
{ /* Eval/evaluate_comp.scm 636 */
obj_t BgL_fun1683z00_1598;
BgL_fun1683z00_1598 = 
CAR(
((obj_t)BgL_lz00_1578)); 
BgL_vz00_1596 = 
PROCEDURE_ENTRY(BgL_fun1683z00_1598)(BgL_fun1683z00_1598, BgL_sz00_82, BEOA); } 
if(
CBOOL(
CAR(
((obj_t)BgL_bsz00_1579))))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_6515;
BgL_newz00_6515 = 
create_struct(BGl_symbol5256z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_15344;
BgL_tmpz00_15344 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_6515, BgL_tmpz00_15344, BgL_vz00_1596); } 
BgL_arg1681z00_1595 = BgL_newz00_6515; }  else 
{ /* Eval/evaluate_comp.scm 637 */
BgL_arg1681z00_1595 = BgL_vz00_1596; } } 
VECTOR_SET(
((obj_t)BgL_sz00_82),BgL_spz00_1580,BgL_arg1681z00_1595); } 
{ /* Eval/evaluate_comp.scm 640 */
obj_t BgL_arg1684z00_1599;obj_t BgL_arg1685z00_1600;long BgL_arg1686z00_1601;
BgL_arg1684z00_1599 = 
CDR(
((obj_t)BgL_lz00_1578)); 
BgL_arg1685z00_1600 = 
CDR(
((obj_t)BgL_bsz00_1579)); 
BgL_arg1686z00_1601 = 
(BgL_spz00_1580+((long)1)); 
{ 
long BgL_spz00_15356;obj_t BgL_bsz00_15355;obj_t BgL_lz00_15354;
BgL_lz00_15354 = BgL_arg1684z00_1599; 
BgL_bsz00_15355 = BgL_arg1685z00_1600; 
BgL_spz00_15356 = BgL_arg1686z00_1601; 
BgL_spz00_1580 = BgL_spz00_15356; 
BgL_bsz00_1579 = BgL_bsz00_15355; 
BgL_lz00_1578 = BgL_lz00_15354; 
goto BgL_zc3z04anonymousza31664ze3z87_1581;} } } } } } 

}



/* sub-stk */
obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88, obj_t BgL_l2z00_89)
{
{ /* Eval/evaluate_comp.scm 645 */
BGl_subzd2stkzd2zz__evaluate_compz00:
if(
NULLP(BgL_l1z00_88))
{ /* Eval/evaluate_comp.scm 646 */
return BgL_l2z00_89;}  else 
{ /* Eval/evaluate_comp.scm 646 */
if(
(
CAR(
((obj_t)BgL_l1z00_88))==
CAR(
((obj_t)BgL_l2z00_89))))
{ /* Eval/evaluate_comp.scm 649 */
obj_t BgL_arg1693z00_1607;obj_t BgL_arg1694z00_1608;
BgL_arg1693z00_1607 = 
CDR(
((obj_t)BgL_l1z00_88)); 
BgL_arg1694z00_1608 = 
CDR(
((obj_t)BgL_l2z00_89)); 
{ 
obj_t BgL_l2z00_15370;obj_t BgL_l1z00_15369;
BgL_l1z00_15369 = BgL_arg1693z00_1607; 
BgL_l2z00_15370 = BgL_arg1694z00_1608; 
BgL_l2z00_89 = BgL_l2z00_15370; 
BgL_l1z00_88 = BgL_l1z00_15369; 
goto BGl_subzd2stkzd2zz__evaluate_compz00;} }  else 
{ /* Eval/evaluate_comp.scm 647 */
return 
BGl_errorz00zz__errorz00(BGl_string5246z00zz__evaluate_compz00, BGl_symbol5258z00zz__evaluate_compz00, BGl_symbol5260z00zz__evaluate_compz00);} } } 

}



/* catch-trampoline */
obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93, obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
{
{ /* Eval/evaluate_comp.scm 669 */
{ /* Eval/evaluate_comp.scm 670 */
obj_t BgL_savedzd2bpzd2_1619;
BgL_savedzd2bpzd2_1619 = 
VECTOR_REF(
((obj_t)BgL_sz00_94),((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_94),((long)0),BgL_bpz00_95); 
{ 
obj_t BgL_fz00_1621;
BgL_fz00_1621 = BgL_fz00_93; 
BgL_zc3z04anonymousza31707ze3z87_1622:
{ /* Eval/evaluate_comp.scm 673 */
obj_t BgL_rz00_1623;
BgL_rz00_1623 = 
PROCEDURE_ENTRY(BgL_fz00_1621)(BgL_fz00_1621, BgL_sz00_94, BEOA); 
{ /* Eval/evaluate_comp.scm 674 */
bool_t BgL_test5535z00_15380;
if(
PROCEDUREP(BgL_rz00_1623))
{ /* Eval/evaluate_comp.scm 674 */
obj_t BgL_arg1712z00_1628;
BgL_arg1712z00_1628 = 
PROCEDURE_ATTR(BgL_rz00_1623); 
if(
STRUCTP(BgL_arg1712z00_1628))
{ /* Eval/evaluate_comp.scm 654 */
BgL_test5535z00_15380 = 
(
STRUCT_KEY(BgL_arg1712z00_1628)==BGl_symbol5242z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 654 */
BgL_test5535z00_15380 = ((bool_t)0)
; } }  else 
{ /* Eval/evaluate_comp.scm 674 */
BgL_test5535z00_15380 = ((bool_t)0)
; } 
if(BgL_test5535z00_15380)
{ 
obj_t BgL_fz00_15388;
BgL_fz00_15388 = BgL_rz00_1623; 
BgL_fz00_1621 = BgL_fz00_15388; 
goto BgL_zc3z04anonymousza31707ze3z87_1622;}  else 
{ /* Eval/evaluate_comp.scm 674 */
VECTOR_SET(
((obj_t)BgL_sz00_94),((long)0),BgL_savedzd2bpzd2_1619); 
return BgL_rz00_1623;} } } } } } 

}



/* check-stack */
bool_t BGl_checkzd2stackzd2zz__evaluate_compz00(obj_t BgL_sz00_114, obj_t BgL_bpz00_115, obj_t BgL_nz00_116)
{
{ /* Eval/evaluate_comp.scm 685 */
return 
(
(
(long)CINT(BgL_bpz00_115)+
(long)CINT(BgL_nz00_116))<
VECTOR_LENGTH(
((obj_t)BgL_sz00_114)));} 

}



/* comp-with-push */
obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117, obj_t BgL_stkz00_118)
{
{ /* Eval/evaluate_comp.scm 688 */
if(
NULLP(BgL_eza2za2_117))
{ /* Eval/evaluate_comp.scm 690 */
return BNIL;}  else 
{ /* Eval/evaluate_comp.scm 692 */
obj_t BgL_arg1728z00_1646;obj_t BgL_arg1729z00_1647;
{ /* Eval/evaluate_comp.scm 692 */
obj_t BgL_arg1730z00_1648;
BgL_arg1730z00_1648 = 
CAR(
((obj_t)BgL_eza2za2_117)); 
BgL_arg1728z00_1646 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg1730z00_1648), BgL_stkz00_118); } 
{ /* Eval/evaluate_comp.scm 693 */
obj_t BgL_arg1731z00_1649;obj_t BgL_arg1732z00_1650;
BgL_arg1731z00_1649 = 
CDR(
((obj_t)BgL_eza2za2_117)); 
{ /* Eval/evaluate_comp.scm 693 */
obj_t BgL_arg1733z00_1651;
BgL_arg1733z00_1651 = 
MAKE_YOUNG_PAIR(BFALSE, BNIL); 
BgL_arg1732z00_1650 = 
BGl_appendzd221009zd2zz__evaluate_compz00(BgL_stkz00_118, BgL_arg1733z00_1651); } 
BgL_arg1729z00_1647 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1731z00_1649, BgL_arg1732z00_1650); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1728z00_1646, BgL_arg1729z00_1647);} } 

}



/* rec~0 */
obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_12621, obj_t BgL_lz00_1653, long BgL_iz00_1654)
{
{ /* Eval/evaluate_comp.scm 696 */
if(
NULLP(BgL_lz00_1653))
{ /* Eval/evaluate_comp.scm 697 */
return BNIL;}  else 
{ /* Eval/evaluate_comp.scm 697 */
if(
(BgL_iz00_1654==((long)0)))
{ /* Eval/evaluate_comp.scm 698 */
return 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1653, BgL_stkz00_12621);}  else 
{ /* Eval/evaluate_comp.scm 699 */
obj_t BgL_arg1737z00_1658;obj_t BgL_arg1738z00_1659;
{ /* Eval/evaluate_comp.scm 699 */
obj_t BgL_arg1739z00_1660;
BgL_arg1739z00_1660 = 
CAR(
((obj_t)BgL_lz00_1653)); 
BgL_arg1737z00_1658 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg1739z00_1660), BgL_stkz00_12621); } 
{ /* Eval/evaluate_comp.scm 700 */
obj_t BgL_arg1740z00_1661;long BgL_arg1741z00_1662;
BgL_arg1740z00_1661 = 
CDR(
((obj_t)BgL_lz00_1653)); 
BgL_arg1741z00_1662 = 
(BgL_iz00_1654-((long)1)); 
BgL_arg1738z00_1659 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_12621, BgL_arg1740z00_1661, BgL_arg1741z00_1662); } 
return 
MAKE_YOUNG_PAIR(BgL_arg1737z00_1658, BgL_arg1738z00_1659);} } } 

}



/* subr-call-with-push */
obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122, obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125, obj_t BgL_siza7eza7_126)
{
{ /* Eval/evaluate_comp.scm 702 */
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_argsz00_1664;
if(
NULLP(BgL_argsz00_124))
{ /* Eval/evaluate_comp.scm 704 */
BgL_argsz00_1664 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_head1339z00_1669;
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_res4072z00_6580;
BgL_res4072z00_6580 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1339z00_1669 = BgL_res4072z00_6580; } 
{ 
obj_t BgL_l1337z00_1671;obj_t BgL_tail1340z00_1672;
BgL_l1337z00_1671 = BgL_argsz00_124; 
BgL_tail1340z00_1672 = BgL_head1339z00_1669; 
BgL_zc3z04anonymousza31744ze3z87_1673:
if(
NULLP(BgL_l1337z00_1671))
{ /* Eval/evaluate_comp.scm 704 */
BgL_argsz00_1664 = 
CDR(BgL_head1339z00_1669); }  else 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_newtail1341z00_1675;
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_arg1747z00_1677;
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_az00_1678;
BgL_az00_1678 = 
CAR(
((obj_t)BgL_l1337z00_1671)); 
BgL_arg1747z00_1677 = 
PROCEDURE_ENTRY(BgL_az00_1678)(BgL_az00_1678, BgL_sz00_122, BEOA); } 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_res4074z00_6584;
BgL_res4074z00_6584 = 
MAKE_YOUNG_PAIR(BgL_arg1747z00_1677, BNIL); 
BgL_newtail1341z00_1675 = BgL_res4074z00_6584; } } 
SET_CDR(BgL_tail1340z00_1672, BgL_newtail1341z00_1675); 
{ /* Eval/evaluate_comp.scm 704 */
obj_t BgL_arg1746z00_1676;
BgL_arg1746z00_1676 = 
CDR(
((obj_t)BgL_l1337z00_1671)); 
{ 
obj_t BgL_tail1340z00_15440;obj_t BgL_l1337z00_15439;
BgL_l1337z00_15439 = BgL_arg1746z00_1676; 
BgL_tail1340z00_15440 = BgL_newtail1341z00_1675; 
BgL_tail1340z00_1672 = BgL_tail1340z00_15440; 
BgL_l1337z00_1671 = BgL_l1337z00_15439; 
goto BgL_zc3z04anonymousza31744ze3z87_1673;} } } } } 
{ /* Eval/evaluate_comp.scm 705 */
long BgL_arg1742z00_1665;
BgL_arg1742z00_1665 = 
(
(long)CINT(BgL_bpz00_125)+
(long)CINT(BgL_siza7eza7_126)); 
VECTOR_SET(
((obj_t)BgL_sz00_122),((long)0),
BINT(BgL_arg1742z00_1665)); } 
{ /* Eval/evaluate_comp.scm 706 */
obj_t BgL_za2za2resza2za2z00_1666;
BgL_za2za2resza2za2z00_1666 = 
apply(BgL_fz00_123, BgL_argsz00_1664); 
VECTOR_SET(
((obj_t)BgL_sz00_122),((long)0),BgL_bpz00_125); 
return BgL_za2za2resza2za2z00_1666;} } } 

}



/* push-args-on-sp */
bool_t BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(obj_t BgL_sz00_127, obj_t BgL_argsz00_128, obj_t BgL_spz00_129)
{
{ /* Eval/evaluate_comp.scm 709 */
{ 
obj_t BgL_lz00_1681;obj_t BgL_spz00_1682;
BgL_lz00_1681 = BgL_argsz00_128; 
BgL_spz00_1682 = BgL_spz00_129; 
BgL_zc3z04anonymousza31748ze3z87_1683:
if(
NULLP(BgL_lz00_1681))
{ /* Eval/evaluate_comp.scm 711 */
return ((bool_t)0);}  else 
{ /* Eval/evaluate_comp.scm 711 */
{ /* Eval/evaluate_comp.scm 712 */
obj_t BgL_arg1750z00_1685;
{ /* Eval/evaluate_comp.scm 712 */
obj_t BgL_fun1751z00_1686;
BgL_fun1751z00_1686 = 
CAR(
((obj_t)BgL_lz00_1681)); 
BgL_arg1750z00_1685 = 
PROCEDURE_ENTRY(BgL_fun1751z00_1686)(BgL_fun1751z00_1686, BgL_sz00_127, BEOA); } 
{ /* Eval/evaluate_comp.scm 712 */
long BgL_kz00_6595;
BgL_kz00_6595 = 
(long)CINT(BgL_spz00_1682); 
VECTOR_SET(
((obj_t)BgL_sz00_127),BgL_kz00_6595,BgL_arg1750z00_1685); } } 
{ /* Eval/evaluate_comp.scm 713 */
obj_t BgL_arg1752z00_1687;long BgL_arg1753z00_1688;
BgL_arg1752z00_1687 = 
CDR(
((obj_t)BgL_lz00_1681)); 
BgL_arg1753z00_1688 = 
(
(long)CINT(BgL_spz00_1682)+((long)1)); 
{ 
obj_t BgL_spz00_15467;obj_t BgL_lz00_15466;
BgL_lz00_15466 = BgL_arg1752z00_1687; 
BgL_spz00_15467 = 
BINT(BgL_arg1753z00_1688); 
BgL_spz00_1682 = BgL_spz00_15467; 
BgL_lz00_1681 = BgL_lz00_15466; 
goto BgL_zc3z04anonymousza31748ze3z87_1683;} } } } } 

}



/* push-nargs-on-sp */
obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132, obj_t BgL_spz00_133)
{
{ /* Eval/evaluate_comp.scm 715 */
{ /* Eval/evaluate_comp.scm 716 */
long BgL_g1145z00_1690;
BgL_g1145z00_1690 = 
(((long)-1)-
(long)CINT(BgL_arityz00_130)); 
{ 
obj_t BgL_lz00_1692;obj_t BgL_spz00_1693;long BgL_nz00_1694;
BgL_lz00_1692 = BgL_argsz00_132; 
BgL_spz00_1693 = BgL_spz00_133; 
BgL_nz00_1694 = BgL_g1145z00_1690; 
BgL_zc3z04anonymousza31754ze3z87_1695:
if(
(BgL_nz00_1694==((long)0)))
{ 
obj_t BgL_lz00_1699;obj_t BgL_rz00_1700;
BgL_lz00_1699 = BgL_lz00_1692; 
BgL_rz00_1700 = BNIL; 
BgL_zc3z04anonymousza31756ze3z87_1701:
if(
NULLP(BgL_lz00_1699))
{ /* Eval/evaluate_comp.scm 720 */
obj_t BgL_arg1758z00_1703;
BgL_arg1758z00_1703 = 
bgl_reverse_bang(BgL_rz00_1700); 
{ /* Eval/evaluate_comp.scm 720 */
long BgL_kz00_6605;
BgL_kz00_6605 = 
(long)CINT(BgL_spz00_1693); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_131),BgL_kz00_6605,BgL_arg1758z00_1703);} }  else 
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_arg1759z00_1704;obj_t BgL_arg1760z00_1705;
BgL_arg1759z00_1704 = 
CDR(
((obj_t)BgL_lz00_1699)); 
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_arg1761z00_1706;
{ /* Eval/evaluate_comp.scm 721 */
obj_t BgL_fun1762z00_1707;
BgL_fun1762z00_1707 = 
CAR(
((obj_t)BgL_lz00_1699)); 
BgL_arg1761z00_1706 = 
PROCEDURE_ENTRY(BgL_fun1762z00_1707)(BgL_fun1762z00_1707, BgL_sz00_131, BEOA); } 
BgL_arg1760z00_1705 = 
MAKE_YOUNG_PAIR(BgL_arg1761z00_1706, BgL_rz00_1700); } 
{ 
obj_t BgL_rz00_15489;obj_t BgL_lz00_15488;
BgL_lz00_15488 = BgL_arg1759z00_1704; 
BgL_rz00_15489 = BgL_arg1760z00_1705; 
BgL_rz00_1700 = BgL_rz00_15489; 
BgL_lz00_1699 = BgL_lz00_15488; 
goto BgL_zc3z04anonymousza31756ze3z87_1701;} } }  else 
{ /* Eval/evaluate_comp.scm 717 */
{ /* Eval/evaluate_comp.scm 722 */
obj_t BgL_arg1763z00_1709;
{ /* Eval/evaluate_comp.scm 722 */
obj_t BgL_fun1764z00_1710;
BgL_fun1764z00_1710 = 
CAR(
((obj_t)BgL_lz00_1692)); 
BgL_arg1763z00_1709 = 
PROCEDURE_ENTRY(BgL_fun1764z00_1710)(BgL_fun1764z00_1710, BgL_sz00_131, BEOA); } 
{ /* Eval/evaluate_comp.scm 722 */
long BgL_kz00_6610;
BgL_kz00_6610 = 
(long)CINT(BgL_spz00_1693); 
VECTOR_SET(
((obj_t)BgL_sz00_131),BgL_kz00_6610,BgL_arg1763z00_1709); } } 
{ /* Eval/evaluate_comp.scm 723 */
obj_t BgL_arg1765z00_1711;long BgL_arg1766z00_1712;long BgL_arg1767z00_1713;
BgL_arg1765z00_1711 = 
CDR(
((obj_t)BgL_lz00_1692)); 
BgL_arg1766z00_1712 = 
(
(long)CINT(BgL_spz00_1693)+((long)1)); 
BgL_arg1767z00_1713 = 
(BgL_nz00_1694-((long)1)); 
{ 
long BgL_nz00_15507;obj_t BgL_spz00_15505;obj_t BgL_lz00_15504;
BgL_lz00_15504 = BgL_arg1765z00_1711; 
BgL_spz00_15505 = 
BINT(BgL_arg1766z00_1712); 
BgL_nz00_15507 = BgL_arg1767z00_1713; 
BgL_nz00_1694 = BgL_nz00_15507; 
BgL_spz00_1693 = BgL_spz00_15505; 
BgL_lz00_1692 = BgL_lz00_15504; 
goto BgL_zc3z04anonymousza31754ze3z87_1695;} } } } } } 

}



/* need-shift */
bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134, obj_t BgL_stkz00_135)
{
{ /* Eval/evaluate_comp.scm 766 */
{ 
obj_t BgL_lz00_1716;obj_t BgL_stkz00_1717;
BgL_lz00_1716 = BgL_argsz00_134; 
BgL_stkz00_1717 = BgL_stkz00_135; 
BgL_zc3z04anonymousza31768ze3z87_1718:
{ /* Eval/evaluate_comp.scm 770 */
bool_t BgL_test5546z00_15508;
if(
NULLP(BgL_lz00_1716))
{ /* Eval/evaluate_comp.scm 770 */
BgL_test5546z00_15508 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 770 */
BgL_test5546z00_15508 = 
NULLP(BgL_stkz00_1717)
; } 
if(BgL_test5546z00_15508)
{ /* Eval/evaluate_comp.scm 770 */
return ((bool_t)0);}  else 
{ /* Eval/evaluate_comp.scm 772 */
bool_t BgL_test5548z00_15512;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_g1344z00_1735;
BgL_g1344z00_1735 = 
CDR(
((obj_t)BgL_lz00_1716)); 
{ 
obj_t BgL_l1342z00_1737;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_tmpz00_15515;
BgL_l1342z00_1737 = BgL_g1344z00_1735; 
BgL_zc3z04anonymousza31779ze3z87_1738:
if(
NULLP(BgL_l1342z00_1737))
{ /* Eval/evaluate_comp.scm 772 */
BgL_tmpz00_15515 = BFALSE
; }  else 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL__ortest_1345z00_1740;
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_ez00_1742;
BgL_ez00_1742 = 
CAR(
((obj_t)BgL_l1342z00_1737)); 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_arg1781z00_1743;obj_t BgL_arg1782z00_1744;
BgL_arg1781z00_1743 = 
CAR(
((obj_t)BgL_stkz00_1717)); 
BgL_arg1782z00_1744 = 
BGl_usez00zz__evaluate_usez00(
((BgL_ev_exprz00_bglt)BgL_ez00_1742), BNIL); 
BgL__ortest_1345z00_1740 = 
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1781z00_1743, BgL_arg1782z00_1744); } } 
if(
CBOOL(BgL__ortest_1345z00_1740))
{ /* Eval/evaluate_comp.scm 772 */
BgL_tmpz00_15515 = BgL__ortest_1345z00_1740
; }  else 
{ /* Eval/evaluate_comp.scm 772 */
obj_t BgL_arg1780z00_1741;
BgL_arg1780z00_1741 = 
CDR(
((obj_t)BgL_l1342z00_1737)); 
{ 
obj_t BgL_l1342z00_15529;
BgL_l1342z00_15529 = BgL_arg1780z00_1741; 
BgL_l1342z00_1737 = BgL_l1342z00_15529; 
goto BgL_zc3z04anonymousza31779ze3z87_1738;} } } 
BgL_test5548z00_15512 = 
CBOOL(BgL_tmpz00_15515); } } } 
if(BgL_test5548z00_15512)
{ /* Eval/evaluate_comp.scm 772 */
return ((bool_t)1);}  else 
{ /* Eval/evaluate_comp.scm 774 */
obj_t BgL_arg1777z00_1733;obj_t BgL_arg1778z00_1734;
BgL_arg1777z00_1733 = 
CDR(
((obj_t)BgL_lz00_1716)); 
BgL_arg1778z00_1734 = 
CDR(
((obj_t)BgL_stkz00_1717)); 
{ 
obj_t BgL_stkz00_15536;obj_t BgL_lz00_15535;
BgL_lz00_15535 = BgL_arg1777z00_1733; 
BgL_stkz00_15536 = BgL_arg1778z00_1734; 
BgL_stkz00_1717 = BgL_stkz00_15536; 
BgL_lz00_1716 = BgL_lz00_15535; 
goto BgL_zc3z04anonymousza31768ze3z87_1718;} } } } } } 

}



/* comp-old-call */
obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt BgL_ez00_136, obj_t BgL_stkz00_137)
{
{ /* Eval/evaluate_comp.scm 776 */
{ /* Eval/evaluate_comp.scm 778 */
long BgL_siza7eza7_1749;long BgL_nbargsz00_1750;obj_t BgL_fz00_1751;obj_t BgL_symbzd2funzd2_1752;
BgL_siza7eza7_1749 = 
bgl_list_length(BgL_stkz00_137); 
BgL_nbargsz00_1750 = 
bgl_list_length(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00)); 
BgL_fz00_1751 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_funz00), BgL_stkz00_137); 
BgL_symbzd2funzd2_1752 = 
BGl_uncompilez00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_funz00)); 
if(
CBOOL(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_tailzf3zf3)))
{ /* Eval/evaluate_comp.scm 780 */
if(
BGl_needzd2shiftzd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137))
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5553z00_15550;
{ /* Eval/evaluate_comp.scm 787 */
int BgL_arg1831z00_1831;
BgL_arg1831z00_1831 = 
bgl_debug(); 
BgL_test5553z00_15550 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1831z00_1831), 
BINT(((long)0))); } 
if(BgL_test5553z00_15550)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_argsz00_1758;
BgL_argsz00_1758 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_zc3z04anonymousza31788ze3z87_10650;
BgL_zc3z04anonymousza31788ze3z87_10650 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31788ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31788ze3z87_10650, 
(int)(((long)0)), BgL_fz00_1751); 
PROCEDURE_SET(BgL_zc3z04anonymousza31788ze3z87_10650, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31788ze3z87_10650, 
(int)(((long)2)), BgL_symbzd2funzd2_1752); 
PROCEDURE_SET(BgL_zc3z04anonymousza31788ze3z87_10650, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1750)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31788ze3z87_10650, 
(int)(((long)4)), BgL_argsz00_1758); 
PROCEDURE_SET(BgL_zc3z04anonymousza31788ze3z87_10650, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1749)); 
return BgL_zc3z04anonymousza31788ze3z87_10650;} }  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_argsz00_1796;
BgL_argsz00_1796 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_zc3z04anonymousza31811ze3z87_10651;
BgL_zc3z04anonymousza31811ze3z87_10651 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31811ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_10651, 
(int)(((long)0)), BgL_fz00_1751); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_10651, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_10651, 
(int)(((long)2)), BgL_symbzd2funzd2_1752); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_10651, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1750)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_10651, 
(int)(((long)4)), BgL_argsz00_1796); 
PROCEDURE_SET(BgL_zc3z04anonymousza31811ze3z87_10651, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1749)); 
return BgL_zc3z04anonymousza31811ze3z87_10651;} } }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5554z00_15595;
{ /* Eval/evaluate_comp.scm 795 */
int BgL_arg1871z00_1901;
BgL_arg1871z00_1901 = 
bgl_debug(); 
BgL_test5554z00_15595 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1871z00_1901), 
BINT(((long)0))); } 
if(BgL_test5554z00_15595)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_argsz00_1834;
BgL_argsz00_1834 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137, 
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_siza7eza7_1749); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_zc3z04anonymousza31834ze3z87_10652;
BgL_zc3z04anonymousza31834ze3z87_10652 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_10652, 
(int)(((long)0)), BgL_fz00_1751); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_10652, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_10652, 
(int)(((long)2)), BgL_symbzd2funzd2_1752); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_10652, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1750)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31834ze3z87_10652, 
(int)(((long)4)), BgL_argsz00_1834); 
return BgL_zc3z04anonymousza31834ze3z87_10652;} }  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_argsz00_1869;
BgL_argsz00_1869 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137, 
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_siza7eza7_1749); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_zc3z04anonymousza31854ze3z87_10653;
BgL_zc3z04anonymousza31854ze3z87_10653 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_10653, 
(int)(((long)0)), BgL_fz00_1751); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_10653, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_10653, 
(int)(((long)2)), BgL_symbzd2funzd2_1752); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_10653, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1750)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31854ze3z87_10653, 
(int)(((long)4)), BgL_argsz00_1869); 
return BgL_zc3z04anonymousza31854ze3z87_10653;} } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5555z00_15634;
{ /* Eval/evaluate_comp.scm 781 */
int BgL_arg1912z00_1972;
BgL_arg1912z00_1972 = 
bgl_debug(); 
BgL_test5555z00_15634 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1912z00_1972), 
BINT(((long)0))); } 
if(BgL_test5555z00_15634)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_argsz00_1905;
BgL_argsz00_1905 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_zc3z04anonymousza31875ze3z87_10654;
BgL_zc3z04anonymousza31875ze3z87_10654 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31875ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31875ze3z87_10654, 
(int)(((long)0)), BgL_fz00_1751); 
PROCEDURE_SET(BgL_zc3z04anonymousza31875ze3z87_10654, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31875ze3z87_10654, 
(int)(((long)2)), BgL_symbzd2funzd2_1752); 
PROCEDURE_SET(BgL_zc3z04anonymousza31875ze3z87_10654, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1750)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31875ze3z87_10654, 
(int)(((long)4)), BgL_argsz00_1905); 
PROCEDURE_SET(BgL_zc3z04anonymousza31875ze3z87_10654, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1749)); 
return BgL_zc3z04anonymousza31875ze3z87_10654;} }  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_argsz00_1940;
BgL_argsz00_1940 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_ez00_136))->BgL_argsz00), BgL_stkz00_137); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_zc3z04anonymousza31895ze3z87_10655;
BgL_zc3z04anonymousza31895ze3z87_10655 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31895ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_10655, 
(int)(((long)0)), BgL_fz00_1751); 
PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_10655, 
(int)(((long)1)), 
((obj_t)BgL_ez00_136)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_10655, 
(int)(((long)2)), BgL_symbzd2funzd2_1752); 
PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_10655, 
(int)(((long)3)), 
BINT(BgL_nbargsz00_1750)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_10655, 
(int)(((long)4)), BgL_argsz00_1940); 
PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_10655, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_1749)); 
return BgL_zc3z04anonymousza31895ze3z87_10655;} } } } } 

}



/* &<@anonymous:1788> */
obj_t BGl_z62zc3z04anonymousza31788ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10656, obj_t BgL_sz00_10663)
{
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_10657;BgL_ev_appz00_bglt BgL_i1153z00_10658;obj_t BgL_symbzd2funzd2_10659;long BgL_nbargsz00_10660;obj_t BgL_argsz00_10661;long BgL_siza7eza7_10662;
BgL_fz00_10657 = 
PROCEDURE_REF(BgL_envz00_10656, 
(int)(((long)0))); 
BgL_i1153z00_10658 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10656, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10659 = 
PROCEDURE_REF(BgL_envz00_10656, 
(int)(((long)2))); 
BgL_nbargsz00_10660 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10656, 
(int)(((long)3)))); 
BgL_argsz00_10661 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10656, 
(int)(((long)4)))); 
BgL_siza7eza7_10662 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10656, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_bpz00_12642;
BgL_bpz00_12642 = 
VECTOR_REF(
((obj_t)BgL_sz00_10663),((long)0)); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_12643;
BgL_fz00_12643 = 
PROCEDURE_ENTRY(BgL_fz00_10657)(BgL_fz00_10657, BgL_sz00_10663, BEOA); 
if(
PROCEDUREP(BgL_fz00_12643))
{ /* Eval/evaluate_comp.scm 787 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10658))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12643); } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ufz00_12644;
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_15705;
BgL_tmpz00_15705 = 
((obj_t)BgL_fz00_12643); 
BgL_ufz00_12644 = 
PROCEDURE_ATTR(BgL_tmpz00_15705); } 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5557z00_15708;
if(
STRUCTP(BgL_ufz00_12644))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5557z00_15708 = 
(
STRUCT_KEY(BgL_ufz00_12644)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5557z00_15708 = ((bool_t)0)
; } 
if(BgL_test5557z00_15708)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_arityz00_12645;obj_t BgL_runz00_12646;obj_t BgL_sfz00_12647;
BgL_arityz00_12645 = 
STRUCT_REF(BgL_ufz00_12644, 
(int)(((long)0))); 
BgL_runz00_12646 = 
STRUCT_REF(BgL_ufz00_12644, 
(int)(((long)1))); 
BgL_sfz00_12647 = 
STRUCT_REF(BgL_ufz00_12644, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_spz00_12648;
BgL_spz00_12648 = 
(
(long)CINT(BgL_bpz00_12642)+BgL_siza7eza7_10662); 
if(
(
(long)CINT(BgL_arityz00_12645)==BgL_nbargsz00_10660))
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10663, BgL_argsz00_10661, 
BINT(BgL_spz00_12648)); 
{ /* Eval/evaluate_comp.scm 791 */
long BgL_arg1793z00_12649;
BgL_arg1793z00_12649 = 
(BgL_spz00_12648+BgL_nbargsz00_10660); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10663, 
(long)CINT(BgL_bpz00_12642), BgL_sz00_10663, 
BINT(BgL_spz00_12648), 
BINT(BgL_arg1793z00_12649)); } }  else 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5560z00_15731;
if(
(
(long)CINT(BgL_arityz00_12645)>=((long)0)))
{ /* Eval/evaluate_comp.scm 787 */
BgL_test5560z00_15731 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BgL_test5560z00_15731 = 
(
(long)CINT(BgL_arityz00_12645)<
(((long)-1)-BgL_nbargsz00_10660))
; } 
if(BgL_test5560z00_15731)
{ /* Eval/evaluate_comp.scm 787 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10658))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12644, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10660), 
CINT(BgL_arityz00_12645)); }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12645, BgL_sz00_10663, BgL_argsz00_10661, 
BINT(BgL_spz00_12648)); 
{ /* Eval/evaluate_comp.scm 793 */
long BgL_arg1799z00_12650;
BgL_arg1799z00_12650 = 
(BgL_spz00_12648+
(((long)0)-
(long)CINT(BgL_arityz00_12645))); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10663, 
(long)CINT(BgL_bpz00_12642), BgL_sz00_10663, 
BINT(BgL_spz00_12648), 
BINT(BgL_arg1799z00_12650)); } } } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_z12denvz12_12651;
BgL_z12denvz12_12651 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_15754;
BgL_tmpz00_15754 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10658))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12651, BgL_tmpz00_15754); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10663, BgL_bpz00_12642, BgL_sfz00_12647))
{ /* Eval/evaluate_comp.scm 787 */
return BgL_runz00_12646;}  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_nsz00_12652;
BgL_nsz00_12652 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_arg1804z00_12653;
BgL_arg1804z00_12653 = 
(
(long)CINT(BgL_bpz00_12642)+BgL_nbargsz00_10660); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12652, ((long)2), BgL_sz00_10663, BgL_bpz00_12642, 
BINT(BgL_arg1804z00_12653)); } 
VECTOR_SET(BgL_nsz00_12652,((long)1),BgL_sz00_10663); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12651, BgL_nsz00_12652); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ez00_12654;
BgL_ez00_12654 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12654, BgL_sz00_10663); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_____rz00_12655;
BgL_____rz00_12655 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12646, BgL_nsz00_12652, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12654); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12651, BgL_sz00_10663); 
return BgL_____rz00_12655;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 787 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12643, 
(int)(BgL_nbargsz00_10660)))
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_auxz00_15777;obj_t BgL_tmpz00_15775;
BgL_auxz00_15777 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10658))->BgL_locz00); 
BgL_tmpz00_15775 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15775, BgL_auxz00_15777); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10663, BgL_fz00_12643, BgL_argsz00_10661, BgL_bpz00_12642, 
BINT(BgL_siza7eza7_10662));}  else 
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10658))->BgL_locz00), BgL_symbzd2funzd2_10659, 
(int)(BgL_nbargsz00_10660), 
PROCEDURE_ARITY(BgL_fz00_12643));} } } } } } } } 

}



/* &<@anonymous:1811> */
obj_t BGl_z62zc3z04anonymousza31811ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10664, obj_t BgL_sz00_10671)
{
{ /* Eval/evaluate_comp.scm 787 */
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_10665;BgL_ev_appz00_bglt BgL_i1153z00_10666;obj_t BgL_symbzd2funzd2_10667;long BgL_nbargsz00_10668;obj_t BgL_argsz00_10669;long BgL_siza7eza7_10670;
BgL_fz00_10665 = 
PROCEDURE_REF(BgL_envz00_10664, 
(int)(((long)0))); 
BgL_i1153z00_10666 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10664, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10667 = 
PROCEDURE_REF(BgL_envz00_10664, 
(int)(((long)2))); 
BgL_nbargsz00_10668 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10664, 
(int)(((long)3)))); 
BgL_argsz00_10669 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10664, 
(int)(((long)4)))); 
BgL_siza7eza7_10670 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10664, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_bpz00_12656;
BgL_bpz00_12656 = 
VECTOR_REF(
((obj_t)BgL_sz00_10671),((long)0)); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_fz00_12657;
BgL_fz00_12657 = 
PROCEDURE_ENTRY(BgL_fz00_10665)(BgL_fz00_10665, BgL_sz00_10671, BEOA); 
if(
PROCEDUREP(BgL_fz00_12657))
{ /* Eval/evaluate_comp.scm 787 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10666))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12657); } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ufz00_12658;
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_tmpz00_15812;
BgL_tmpz00_15812 = 
((obj_t)BgL_fz00_12657); 
BgL_ufz00_12658 = 
PROCEDURE_ATTR(BgL_tmpz00_15812); } 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5565z00_15815;
if(
STRUCTP(BgL_ufz00_12658))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5565z00_15815 = 
(
STRUCT_KEY(BgL_ufz00_12658)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5565z00_15815 = ((bool_t)0)
; } 
if(BgL_test5565z00_15815)
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_arityz00_12659;obj_t BgL_runz00_12660;obj_t BgL_sfz00_12661;
BgL_arityz00_12659 = 
STRUCT_REF(BgL_ufz00_12658, 
(int)(((long)0))); 
BgL_runz00_12660 = 
STRUCT_REF(BgL_ufz00_12658, 
(int)(((long)1))); 
BgL_sfz00_12661 = 
STRUCT_REF(BgL_ufz00_12658, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_spz00_12662;
BgL_spz00_12662 = 
(
(long)CINT(BgL_bpz00_12656)+BgL_siza7eza7_10670); 
if(
(
(long)CINT(BgL_arityz00_12659)==BgL_nbargsz00_10668))
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10671, BgL_argsz00_10669, 
BINT(BgL_spz00_12662)); 
{ /* Eval/evaluate_comp.scm 791 */
long BgL_arg1816z00_12663;
BgL_arg1816z00_12663 = 
(BgL_spz00_12662+BgL_nbargsz00_10668); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10671, 
(long)CINT(BgL_bpz00_12656), BgL_sz00_10671, 
BINT(BgL_spz00_12662), 
BINT(BgL_arg1816z00_12663)); } }  else 
{ /* Eval/evaluate_comp.scm 787 */
bool_t BgL_test5568z00_15838;
if(
(
(long)CINT(BgL_arityz00_12659)>=((long)0)))
{ /* Eval/evaluate_comp.scm 787 */
BgL_test5568z00_15838 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 787 */
BgL_test5568z00_15838 = 
(
(long)CINT(BgL_arityz00_12659)<
(((long)-1)-BgL_nbargsz00_10668))
; } 
if(BgL_test5568z00_15838)
{ /* Eval/evaluate_comp.scm 787 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10666))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12658, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10668), 
CINT(BgL_arityz00_12659)); }  else 
{ /* Eval/evaluate_comp.scm 787 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12659, BgL_sz00_10671, BgL_argsz00_10669, 
BINT(BgL_spz00_12662)); 
{ /* Eval/evaluate_comp.scm 793 */
long BgL_arg1822z00_12664;
BgL_arg1822z00_12664 = 
(BgL_spz00_12662+
(((long)0)-
(long)CINT(BgL_arityz00_12659))); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_10671, 
(long)CINT(BgL_bpz00_12656), BgL_sz00_10671, 
BINT(BgL_spz00_12662), 
BINT(BgL_arg1822z00_12664)); } } } 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_z12denvz12_12665;
BgL_z12denvz12_12665 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10671, BgL_bpz00_12656, BgL_sfz00_12661))
{ /* Eval/evaluate_comp.scm 787 */
return BgL_runz00_12660;}  else 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_nsz00_12666;
BgL_nsz00_12666 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 787 */
long BgL_arg1826z00_12667;
BgL_arg1826z00_12667 = 
(
(long)CINT(BgL_bpz00_12656)+BgL_nbargsz00_10668); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12666, ((long)2), BgL_sz00_10671, BgL_bpz00_12656, 
BINT(BgL_arg1826z00_12667)); } 
VECTOR_SET(BgL_nsz00_12666,((long)1),BgL_sz00_10671); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12665, BgL_nsz00_12666); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_ez00_12668;
BgL_ez00_12668 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12668, BgL_sz00_10671); 
{ /* Eval/evaluate_comp.scm 787 */
obj_t BgL_____rz00_12669;
BgL_____rz00_12669 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12660, BgL_nsz00_12666, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12668); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12665, BgL_sz00_10671); 
return BgL_____rz00_12669;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 787 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12657, 
(int)(BgL_nbargsz00_10668)))
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10671, BgL_fz00_12657, BgL_argsz00_10669, BgL_bpz00_12656, 
BINT(BgL_siza7eza7_10670));}  else 
{ /* Eval/evaluate_comp.scm 787 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10666))->BgL_locz00), BgL_symbzd2funzd2_10667, 
(int)(BgL_nbargsz00_10668), 
PROCEDURE_ARITY(BgL_fz00_12657));} } } } } } } } 

}



/* &<@anonymous:1834> */
obj_t BGl_z62zc3z04anonymousza31834ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10672, obj_t BgL_sz00_10678)
{
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_10673;BgL_ev_appz00_bglt BgL_i1153z00_10674;obj_t BgL_symbzd2funzd2_10675;long BgL_nbargsz00_10676;obj_t BgL_argsz00_10677;
BgL_fz00_10673 = 
PROCEDURE_REF(BgL_envz00_10672, 
(int)(((long)0))); 
BgL_i1153z00_10674 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10672, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10675 = 
PROCEDURE_REF(BgL_envz00_10672, 
(int)(((long)2))); 
BgL_nbargsz00_10676 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10672, 
(int)(((long)3)))); 
BgL_argsz00_10677 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10672, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_bpz00_12670;
BgL_bpz00_12670 = 
VECTOR_REF(
((obj_t)BgL_sz00_10678),((long)0)); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_12671;
BgL_fz00_12671 = 
PROCEDURE_ENTRY(BgL_fz00_10673)(BgL_fz00_10673, BgL_sz00_10678, BEOA); 
if(
PROCEDUREP(BgL_fz00_12671))
{ /* Eval/evaluate_comp.scm 795 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10674))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12671); } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ufz00_12672;
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_15908;
BgL_tmpz00_15908 = 
((obj_t)BgL_fz00_12671); 
BgL_ufz00_12672 = 
PROCEDURE_ATTR(BgL_tmpz00_15908); } 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5573z00_15911;
if(
STRUCTP(BgL_ufz00_12672))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5573z00_15911 = 
(
STRUCT_KEY(BgL_ufz00_12672)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5573z00_15911 = ((bool_t)0)
; } 
if(BgL_test5573z00_15911)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_arityz00_12673;obj_t BgL_runz00_12674;obj_t BgL_sfz00_12675;
BgL_arityz00_12673 = 
STRUCT_REF(BgL_ufz00_12672, 
(int)(((long)0))); 
BgL_runz00_12674 = 
STRUCT_REF(BgL_ufz00_12672, 
(int)(((long)1))); 
BgL_sfz00_12675 = 
STRUCT_REF(BgL_ufz00_12672, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12673)==BgL_nbargsz00_10676))
{ /* Eval/evaluate_comp.scm 795 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10678, BgL_argsz00_10677, BgL_bpz00_12670)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5576z00_15927;
if(
(
(long)CINT(BgL_arityz00_12673)>=((long)0)))
{ /* Eval/evaluate_comp.scm 795 */
BgL_test5576z00_15927 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BgL_test5576z00_15927 = 
(
(long)CINT(BgL_arityz00_12673)<
(((long)-1)-BgL_nbargsz00_10676))
; } 
if(BgL_test5576z00_15927)
{ /* Eval/evaluate_comp.scm 795 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10674))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12672, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10676), 
CINT(BgL_arityz00_12673)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12673, BgL_sz00_10678, BgL_argsz00_10677, BgL_bpz00_12670); } } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_z12denvz12_12676;
BgL_z12denvz12_12676 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_15942;
BgL_tmpz00_15942 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10674))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12676, BgL_tmpz00_15942); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10678, BgL_bpz00_12670, BgL_sfz00_12675))
{ /* Eval/evaluate_comp.scm 795 */
return BgL_runz00_12674;}  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_nsz00_12677;
BgL_nsz00_12677 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 795 */
long BgL_arg1847z00_12678;
BgL_arg1847z00_12678 = 
(
(long)CINT(BgL_bpz00_12670)+BgL_nbargsz00_10676); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12677, ((long)2), BgL_sz00_10678, BgL_bpz00_12670, 
BINT(BgL_arg1847z00_12678)); } 
VECTOR_SET(BgL_nsz00_12677,((long)1),BgL_sz00_10678); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12676, BgL_nsz00_12677); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ez00_12679;
BgL_ez00_12679 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12679, BgL_sz00_10678); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_____rz00_12680;
BgL_____rz00_12680 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12674, BgL_nsz00_12677, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12679); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12676, BgL_sz00_10678); 
return BgL_____rz00_12680;} } } } }  else 
{ /* Eval/evaluate_comp.scm 795 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12671, 
(int)(BgL_nbargsz00_10676)))
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_auxz00_15965;obj_t BgL_tmpz00_15963;
BgL_auxz00_15965 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10674))->BgL_locz00); 
BgL_tmpz00_15963 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_15963, BgL_auxz00_15965); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10678, BgL_fz00_12671, BgL_argsz00_10677, BgL_bpz00_12670, 
BINT(BgL_nbargsz00_10676));}  else 
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10674))->BgL_locz00), BgL_symbzd2funzd2_10675, 
(int)(BgL_nbargsz00_10676), 
PROCEDURE_ARITY(BgL_fz00_12671));} } } } } } } } 

}



/* &<@anonymous:1854> */
obj_t BGl_z62zc3z04anonymousza31854ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10679, obj_t BgL_sz00_10685)
{
{ /* Eval/evaluate_comp.scm 795 */
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_10680;BgL_ev_appz00_bglt BgL_i1153z00_10681;obj_t BgL_symbzd2funzd2_10682;long BgL_nbargsz00_10683;obj_t BgL_argsz00_10684;
BgL_fz00_10680 = 
PROCEDURE_REF(BgL_envz00_10679, 
(int)(((long)0))); 
BgL_i1153z00_10681 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10679, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10682 = 
PROCEDURE_REF(BgL_envz00_10679, 
(int)(((long)2))); 
BgL_nbargsz00_10683 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10679, 
(int)(((long)3)))); 
BgL_argsz00_10684 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10679, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_bpz00_12681;
BgL_bpz00_12681 = 
VECTOR_REF(
((obj_t)BgL_sz00_10685),((long)0)); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_fz00_12682;
BgL_fz00_12682 = 
PROCEDURE_ENTRY(BgL_fz00_10680)(BgL_fz00_10680, BgL_sz00_10685, BEOA); 
if(
PROCEDUREP(BgL_fz00_12682))
{ /* Eval/evaluate_comp.scm 795 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10681))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12682); } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ufz00_12683;
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_tmpz00_15997;
BgL_tmpz00_15997 = 
((obj_t)BgL_fz00_12682); 
BgL_ufz00_12683 = 
PROCEDURE_ATTR(BgL_tmpz00_15997); } 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5581z00_16000;
if(
STRUCTP(BgL_ufz00_12683))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5581z00_16000 = 
(
STRUCT_KEY(BgL_ufz00_12683)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5581z00_16000 = ((bool_t)0)
; } 
if(BgL_test5581z00_16000)
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_arityz00_12684;obj_t BgL_runz00_12685;obj_t BgL_sfz00_12686;
BgL_arityz00_12684 = 
STRUCT_REF(BgL_ufz00_12683, 
(int)(((long)0))); 
BgL_runz00_12685 = 
STRUCT_REF(BgL_ufz00_12683, 
(int)(((long)1))); 
BgL_sfz00_12686 = 
STRUCT_REF(BgL_ufz00_12683, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12684)==BgL_nbargsz00_10683))
{ /* Eval/evaluate_comp.scm 795 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10685, BgL_argsz00_10684, BgL_bpz00_12681)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
bool_t BgL_test5584z00_16016;
if(
(
(long)CINT(BgL_arityz00_12684)>=((long)0)))
{ /* Eval/evaluate_comp.scm 795 */
BgL_test5584z00_16016 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 795 */
BgL_test5584z00_16016 = 
(
(long)CINT(BgL_arityz00_12684)<
(((long)-1)-BgL_nbargsz00_10683))
; } 
if(BgL_test5584z00_16016)
{ /* Eval/evaluate_comp.scm 795 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10681))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12683, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10683), 
CINT(BgL_arityz00_12684)); }  else 
{ /* Eval/evaluate_comp.scm 795 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12684, BgL_sz00_10685, BgL_argsz00_10684, BgL_bpz00_12681); } } 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_z12denvz12_12687;
BgL_z12denvz12_12687 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10685, BgL_bpz00_12681, BgL_sfz00_12686))
{ /* Eval/evaluate_comp.scm 795 */
return BgL_runz00_12685;}  else 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_nsz00_12688;
BgL_nsz00_12688 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 795 */
long BgL_arg1866z00_12689;
BgL_arg1866z00_12689 = 
(
(long)CINT(BgL_bpz00_12681)+BgL_nbargsz00_10683); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12688, ((long)2), BgL_sz00_10685, BgL_bpz00_12681, 
BINT(BgL_arg1866z00_12689)); } 
VECTOR_SET(BgL_nsz00_12688,((long)1),BgL_sz00_10685); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12687, BgL_nsz00_12688); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_ez00_12690;
BgL_ez00_12690 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12690, BgL_sz00_10685); 
{ /* Eval/evaluate_comp.scm 795 */
obj_t BgL_____rz00_12691;
BgL_____rz00_12691 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12685, BgL_nsz00_12688, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12690); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12687, BgL_sz00_10685); 
return BgL_____rz00_12691;} } } } }  else 
{ /* Eval/evaluate_comp.scm 795 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12682, 
(int)(BgL_nbargsz00_10683)))
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10685, BgL_fz00_12682, BgL_argsz00_10684, BgL_bpz00_12681, 
BINT(BgL_nbargsz00_10683));}  else 
{ /* Eval/evaluate_comp.scm 795 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10681))->BgL_locz00), BgL_symbzd2funzd2_10682, 
(int)(BgL_nbargsz00_10683), 
PROCEDURE_ARITY(BgL_fz00_12682));} } } } } } } } 

}



/* &<@anonymous:1875> */
obj_t BGl_z62zc3z04anonymousza31875ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10686, obj_t BgL_sz00_10693)
{
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_10687;BgL_ev_appz00_bglt BgL_i1153z00_10688;obj_t BgL_symbzd2funzd2_10689;long BgL_nbargsz00_10690;obj_t BgL_argsz00_10691;long BgL_siza7eza7_10692;
BgL_fz00_10687 = 
PROCEDURE_REF(BgL_envz00_10686, 
(int)(((long)0))); 
BgL_i1153z00_10688 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10686, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10689 = 
PROCEDURE_REF(BgL_envz00_10686, 
(int)(((long)2))); 
BgL_nbargsz00_10690 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10686, 
(int)(((long)3)))); 
BgL_argsz00_10691 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10686, 
(int)(((long)4)))); 
BgL_siza7eza7_10692 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10686, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_bpz00_12692;
BgL_bpz00_12692 = 
VECTOR_REF(
((obj_t)BgL_sz00_10693),((long)0)); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_12693;
BgL_fz00_12693 = 
PROCEDURE_ENTRY(BgL_fz00_10687)(BgL_fz00_10687, BgL_sz00_10693, BEOA); 
if(
PROCEDUREP(BgL_fz00_12693))
{ /* Eval/evaluate_comp.scm 781 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10688))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12693); } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ufz00_12694;
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_16081;
BgL_tmpz00_16081 = 
((obj_t)BgL_fz00_12693); 
BgL_ufz00_12694 = 
PROCEDURE_ATTR(BgL_tmpz00_16081); } 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5589z00_16084;
if(
STRUCTP(BgL_ufz00_12694))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5589z00_16084 = 
(
STRUCT_KEY(BgL_ufz00_12694)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5589z00_16084 = ((bool_t)0)
; } 
if(BgL_test5589z00_16084)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_arityz00_12695;obj_t BgL_runz00_12696;obj_t BgL_sfz00_12697;
BgL_arityz00_12695 = 
STRUCT_REF(BgL_ufz00_12694, 
(int)(((long)0))); 
BgL_runz00_12696 = 
STRUCT_REF(BgL_ufz00_12694, 
(int)(((long)1))); 
BgL_sfz00_12697 = 
STRUCT_REF(BgL_ufz00_12694, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_spz00_12698;
BgL_spz00_12698 = 
(
(long)CINT(BgL_bpz00_12692)+BgL_siza7eza7_10692); 
if(
(
(long)CINT(BgL_arityz00_12695)==BgL_nbargsz00_10690))
{ /* Eval/evaluate_comp.scm 781 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10693, BgL_argsz00_10691, 
BINT(BgL_spz00_12698))); }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5592z00_16103;
if(
(
(long)CINT(BgL_arityz00_12695)>=((long)0)))
{ /* Eval/evaluate_comp.scm 781 */
BgL_test5592z00_16103 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BgL_test5592z00_16103 = 
(
(long)CINT(BgL_arityz00_12695)<
(((long)-1)-BgL_nbargsz00_10690))
; } 
if(BgL_test5592z00_16103)
{ /* Eval/evaluate_comp.scm 781 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10688))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12694, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10690), 
CINT(BgL_arityz00_12695)); }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12695, BgL_sz00_10693, BgL_argsz00_10691, 
BINT(BgL_spz00_12698)); } } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_z12denvz12_12699;
BgL_z12denvz12_12699 = 
BGL_CURRENT_DYNAMIC_ENV(); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_16119;
BgL_tmpz00_16119 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10688))->BgL_locz00); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12699, BgL_tmpz00_16119); } 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10693, 
BINT(BgL_spz00_12698), BgL_sfz00_12697))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12696, BgL_sz00_10693, 
BINT(BgL_spz00_12698));}  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_nsz00_12700;
BgL_nsz00_12700 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_arg1888z00_12701;
BgL_arg1888z00_12701 = 
(BgL_spz00_12698+BgL_nbargsz00_10690); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12700, ((long)2), BgL_sz00_10693, 
BINT(BgL_spz00_12698), 
BINT(BgL_arg1888z00_12701)); } 
VECTOR_SET(BgL_nsz00_12700,((long)1),BgL_sz00_10693); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12699, BgL_nsz00_12700); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ez00_12702;
BgL_ez00_12702 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12702, BgL_sz00_10693); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_____rz00_12703;
BgL_____rz00_12703 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12696, BgL_nsz00_12700, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12702); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12699, BgL_sz00_10693); 
return BgL_____rz00_12703;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12693, 
(int)(BgL_nbargsz00_10690)))
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_auxz00_16145;obj_t BgL_tmpz00_16143;
BgL_auxz00_16145 = 
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10688))->BgL_locz00); 
BgL_tmpz00_16143 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16143, BgL_auxz00_16145); } 
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10693, BgL_fz00_12693, BgL_argsz00_10691, BgL_bpz00_12692, 
BINT(BgL_siza7eza7_10692));}  else 
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10688))->BgL_locz00), BgL_symbzd2funzd2_10689, 
(int)(BgL_nbargsz00_10690), 
PROCEDURE_ARITY(BgL_fz00_12693));} } } } } } } } 

}



/* &<@anonymous:1895> */
obj_t BGl_z62zc3z04anonymousza31895ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10694, obj_t BgL_sz00_10701)
{
{ /* Eval/evaluate_comp.scm 781 */
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_10695;BgL_ev_appz00_bglt BgL_i1153z00_10696;obj_t BgL_symbzd2funzd2_10697;long BgL_nbargsz00_10698;obj_t BgL_argsz00_10699;long BgL_siza7eza7_10700;
BgL_fz00_10695 = 
PROCEDURE_REF(BgL_envz00_10694, 
(int)(((long)0))); 
BgL_i1153z00_10696 = 
((BgL_ev_appz00_bglt)
PROCEDURE_REF(BgL_envz00_10694, 
(int)(((long)1)))); 
BgL_symbzd2funzd2_10697 = 
PROCEDURE_REF(BgL_envz00_10694, 
(int)(((long)2))); 
BgL_nbargsz00_10698 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10694, 
(int)(((long)3)))); 
BgL_argsz00_10699 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10694, 
(int)(((long)4)))); 
BgL_siza7eza7_10700 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10694, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_bpz00_12704;
BgL_bpz00_12704 = 
VECTOR_REF(
((obj_t)BgL_sz00_10701),((long)0)); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_fz00_12705;
BgL_fz00_12705 = 
PROCEDURE_ENTRY(BgL_fz00_10695)(BgL_fz00_10695, BgL_sz00_10701, BEOA); 
if(
PROCEDUREP(BgL_fz00_12705))
{ /* Eval/evaluate_comp.scm 781 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_evtypezd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10696))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12705); } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ufz00_12706;
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_tmpz00_16180;
BgL_tmpz00_16180 = 
((obj_t)BgL_fz00_12705); 
BgL_ufz00_12706 = 
PROCEDURE_ATTR(BgL_tmpz00_16180); } 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5597z00_16183;
if(
STRUCTP(BgL_ufz00_12706))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5597z00_16183 = 
(
STRUCT_KEY(BgL_ufz00_12706)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5597z00_16183 = ((bool_t)0)
; } 
if(BgL_test5597z00_16183)
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_arityz00_12707;obj_t BgL_runz00_12708;obj_t BgL_sfz00_12709;
BgL_arityz00_12707 = 
STRUCT_REF(BgL_ufz00_12706, 
(int)(((long)0))); 
BgL_runz00_12708 = 
STRUCT_REF(BgL_ufz00_12706, 
(int)(((long)1))); 
BgL_sfz00_12709 = 
STRUCT_REF(BgL_ufz00_12706, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_spz00_12710;
BgL_spz00_12710 = 
(
(long)CINT(BgL_bpz00_12704)+BgL_siza7eza7_10700); 
if(
(
(long)CINT(BgL_arityz00_12707)==BgL_nbargsz00_10698))
{ /* Eval/evaluate_comp.scm 781 */
BBOOL(
BGl_pushzd2argszd2onzd2spzd2zz__evaluate_compz00(BgL_sz00_10701, BgL_argsz00_10699, 
BINT(BgL_spz00_12710))); }  else 
{ /* Eval/evaluate_comp.scm 781 */
bool_t BgL_test5600z00_16202;
if(
(
(long)CINT(BgL_arityz00_12707)>=((long)0)))
{ /* Eval/evaluate_comp.scm 781 */
BgL_test5600z00_16202 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 781 */
BgL_test5600z00_16202 = 
(
(long)CINT(BgL_arityz00_12707)<
(((long)-1)-BgL_nbargsz00_10698))
; } 
if(BgL_test5600z00_16202)
{ /* Eval/evaluate_comp.scm 781 */
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10696))->BgL_locz00), 
STRUCT_REF(BgL_ufz00_12706, 
(int)(((long)3))), 
(int)(BgL_nbargsz00_10698), 
CINT(BgL_arityz00_12707)); }  else 
{ /* Eval/evaluate_comp.scm 781 */
BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(BgL_arityz00_12707, BgL_sz00_10701, BgL_argsz00_10699, 
BINT(BgL_spz00_12710)); } } 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_z12denvz12_12711;
BgL_z12denvz12_12711 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10701, 
BINT(BgL_spz00_12710), BgL_sfz00_12709))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12708, BgL_sz00_10701, 
BINT(BgL_spz00_12710));}  else 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_nsz00_12712;
BgL_nsz00_12712 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 781 */
long BgL_arg1907z00_12713;
BgL_arg1907z00_12713 = 
(BgL_spz00_12710+BgL_nbargsz00_10698); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12712, ((long)2), BgL_sz00_10701, 
BINT(BgL_spz00_12710), 
BINT(BgL_arg1907z00_12713)); } 
VECTOR_SET(BgL_nsz00_12712,((long)1),BgL_sz00_10701); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12711, BgL_nsz00_12712); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_ez00_12714;
BgL_ez00_12714 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12714, BgL_sz00_10701); 
{ /* Eval/evaluate_comp.scm 781 */
obj_t BgL_____rz00_12715;
BgL_____rz00_12715 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12708, BgL_nsz00_12712, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12714); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12711, BgL_sz00_10701); 
return BgL_____rz00_12715;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 781 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12705, 
(int)(BgL_nbargsz00_10698)))
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(BgL_sz00_10701, BgL_fz00_12705, BgL_argsz00_10699, BgL_bpz00_12704, 
BINT(BgL_siza7eza7_10700));}  else 
{ /* Eval/evaluate_comp.scm 781 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_i1153z00_10696))->BgL_locz00), BgL_symbzd2funzd2_10697, 
(int)(BgL_nbargsz00_10698), 
PROCEDURE_ARITY(BgL_fz00_12705));} } } } } } } } 

}



/* comp-call0 */
obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138, BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140, obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143, long BgL_siza7eza7_144)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_1976;
BgL_cfunz00_1976 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139, ((long)0), BgL_locz00_138, BgL_symbzd2funzd2_140); 
if(
CBOOL(BgL_cfunz00_1976))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5605z00_16248;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1921z00_1990;
BgL_arg1921z00_1990 = 
bgl_debug(); 
BgL_test5605z00_16248 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1921z00_1990), 
BINT(((long)0))); } 
if(BgL_test5605z00_16248)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31918ze3z87_10702;
BgL_zc3z04anonymousza31918ze3z87_10702 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31918ze3z87_10702, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_144)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31918ze3z87_10702, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31918ze3z87_10702, 
(int)(((long)2)), BgL_cfunz00_1976); 
return BgL_zc3z04anonymousza31918ze3z87_10702;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31920ze3z87_10703;
BgL_zc3z04anonymousza31920ze3z87_10703 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31920ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31920ze3z87_10703, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_144)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31920ze3z87_10703, 
(int)(((long)1)), BgL_cfunz00_1976); 
return BgL_zc3z04anonymousza31920ze3z87_10703;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_142))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5607z00_16273;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1951z00_2054;
BgL_arg1951z00_2054 = 
bgl_debug(); 
BgL_test5607z00_16273 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1951z00_2054), 
BINT(((long)0))); } 
if(BgL_test5607z00_16273)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31924ze3z87_10704;
BgL_zc3z04anonymousza31924ze3z87_10704 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31924ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31924ze3z87_10704, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31924ze3z87_10704, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31924ze3z87_10704, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31924ze3z87_10704, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31924ze3z87_10704;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31938ze3z87_10705;
BgL_zc3z04anonymousza31938ze3z87_10705 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_10705, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_10705, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_10705, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_10705, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31938ze3z87_10705;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5608z00_16302;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1981z00_2118;
BgL_arg1981z00_2118 = 
bgl_debug(); 
BgL_test5608z00_16302 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1981z00_2118), 
BINT(((long)0))); } 
if(BgL_test5608z00_16302)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31954ze3z87_10706;
BgL_zc3z04anonymousza31954ze3z87_10706 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31954ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10706, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10706, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10706, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31954ze3z87_10706, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31954ze3z87_10706;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31968ze3z87_10707;
BgL_zc3z04anonymousza31968ze3z87_10707 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31968ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31968ze3z87_10707, 
(int)(((long)0)), BgL_funz00_141); 
PROCEDURE_SET(BgL_zc3z04anonymousza31968ze3z87_10707, 
(int)(((long)1)), BgL_locz00_138); 
PROCEDURE_SET(BgL_zc3z04anonymousza31968ze3z87_10707, 
(int)(((long)2)), BgL_symbzd2funzd2_140); 
PROCEDURE_SET(BgL_zc3z04anonymousza31968ze3z87_10707, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_144)); 
return BgL_zc3z04anonymousza31968ze3z87_10707;} } } } } 

}



/* &<@anonymous:1918> */
obj_t BGl_z62zc3z04anonymousza31918ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10708, obj_t BgL_sz00_10712)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_siza7eza7_10709;obj_t BgL_locz00_10710;obj_t BgL_cfunz00_10711;
BgL_siza7eza7_10709 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10708, 
(int)(((long)0)))); 
BgL_locz00_10710 = 
PROCEDURE_REF(BgL_envz00_10708, 
(int)(((long)1))); 
BgL_cfunz00_10711 = 
PROCEDURE_REF(BgL_envz00_10708, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12716;
BgL_bpz00_12716 = 
VECTOR_REF(
((obj_t)BgL_sz00_10712),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */

{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12717;
BgL_nbpz00_12717 = 
(
(long)CINT(BgL_bpz00_12716)+BgL_siza7eza7_10709); 
VECTOR_SET(
((obj_t)BgL_sz00_10712),((long)0),
BINT(BgL_nbpz00_12717)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16345;
BgL_tmpz00_16345 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16345, BgL_locz00_10710); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12718;
BgL_rz00_12718 = 
PROCEDURE_ENTRY(BgL_cfunz00_10711)(BgL_cfunz00_10711, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10712),((long)0),BgL_bpz00_12716); 
return BgL_rz00_12718;} } } } } } 

}



/* &<@anonymous:1920> */
obj_t BGl_z62zc3z04anonymousza31920ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10713, obj_t BgL_sz00_10716)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_siza7eza7_10714;obj_t BgL_cfunz00_10715;
BgL_siza7eza7_10714 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10713, 
(int)(((long)0)))); 
BgL_cfunz00_10715 = 
PROCEDURE_REF(BgL_envz00_10713, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12719;
BgL_bpz00_12719 = 
VECTOR_REF(
((obj_t)BgL_sz00_10716),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */

{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12720;
BgL_nbpz00_12720 = 
(
(long)CINT(BgL_bpz00_12719)+BgL_siza7eza7_10714); 
VECTOR_SET(
((obj_t)BgL_sz00_10716),((long)0),
BINT(BgL_nbpz00_12720)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12721;
BgL_rz00_12721 = 
PROCEDURE_ENTRY(BgL_cfunz00_10715)(BgL_cfunz00_10715, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10716),((long)0),BgL_bpz00_12719); 
return BgL_rz00_12721;} } } } } } 

}



/* &<@anonymous:1924> */
obj_t BGl_z62zc3z04anonymousza31924ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10717, obj_t BgL_sz00_10722)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10718;obj_t BgL_locz00_10719;obj_t BgL_symbzd2funzd2_10720;long BgL_siza7eza7_10721;
BgL_funz00_10718 = 
PROCEDURE_REF(BgL_envz00_10717, 
(int)(((long)0))); 
BgL_locz00_10719 = 
PROCEDURE_REF(BgL_envz00_10717, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10720 = 
PROCEDURE_REF(BgL_envz00_10717, 
(int)(((long)2))); 
BgL_siza7eza7_10721 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10717, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12722;
BgL_bpz00_12722 = 
VECTOR_REF(
((obj_t)BgL_sz00_10722),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12723;
BgL_fz00_12723 = 
PROCEDURE_ENTRY(BgL_funz00_10718)(BgL_funz00_10718, BgL_sz00_10722, BEOA); 
if(
PROCEDUREP(BgL_fz00_12723))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10719, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12723); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12724;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16388;
BgL_tmpz00_16388 = 
((obj_t)BgL_fz00_12723); 
BgL_ufz00_12724 = 
PROCEDURE_ATTR(BgL_tmpz00_16388); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5610z00_16391;
if(
STRUCTP(BgL_ufz00_12724))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5610z00_16391 = 
(
STRUCT_KEY(BgL_ufz00_12724)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5610z00_16391 = ((bool_t)0)
; } 
if(BgL_test5610z00_16391)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12725;obj_t BgL_runz00_12726;obj_t BgL_sfz00_12727;
BgL_arityz00_12725 = 
STRUCT_REF(BgL_ufz00_12724, 
(int)(((long)0))); 
BgL_runz00_12726 = 
STRUCT_REF(BgL_ufz00_12724, 
(int)(((long)1))); 
BgL_sfz00_12727 = 
STRUCT_REF(BgL_ufz00_12724, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12725)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12725))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12725)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1929z00_12730;obj_t BgL_arg1930z00_12731;
BgL_arg1929z00_12730 = 
(
(long)CINT(BgL_bpz00_12722)+((long)0)); 
BgL_arg1930z00_12731 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10722),BgL_arg1929z00_12730,BgL_arg1930z00_12731); } break;
default: 
BgL_case_else1169z00_12728:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1932z00_12729;
BgL_arg1932z00_12729 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12724), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10719, BgL_arg1932z00_12729, 
(int)(((long)0)), 
CINT(BgL_arityz00_12725)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1169z00_12728;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12732;
BgL_z12denvz12_12732 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12732, BgL_locz00_10719); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10722, BgL_bpz00_12722, BgL_sfz00_12727))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12726;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12733;
BgL_nsz00_12733 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1934z00_12734;
BgL_arg1934z00_12734 = 
(
(long)CINT(BgL_bpz00_12722)+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12733, ((long)2), BgL_sz00_10722, BgL_bpz00_12722, 
BINT(BgL_arg1934z00_12734)); } 
VECTOR_SET(BgL_nsz00_12733,((long)1),BgL_sz00_10722); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12732, BgL_nsz00_12733); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12735;
BgL_ez00_12735 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12735, BgL_sz00_10722); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12736;
BgL_____rz00_12736 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12726, BgL_nsz00_12733, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12735); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12732, BgL_sz00_10722); 
return BgL_____rz00_12736;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12723, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12737;
BgL_nbpz00_12737 = 
(
(long)CINT(BgL_bpz00_12722)+BgL_siza7eza7_10721); 
VECTOR_SET(
((obj_t)BgL_sz00_10722),((long)0),
BINT(BgL_nbpz00_12737)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16444;
BgL_tmpz00_16444 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16444, BgL_locz00_10719); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12738;
BgL_rz00_12738 = 
PROCEDURE_ENTRY(BgL_fz00_12723)(BgL_fz00_12723, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10722),((long)0),BgL_bpz00_12722); 
return BgL_rz00_12738;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10719, BgL_symbzd2funzd2_10720, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12723));} } } } } } } } 

}



/* &<@anonymous:1938> */
obj_t BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10723, obj_t BgL_sz00_10728)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10724;obj_t BgL_locz00_10725;obj_t BgL_symbzd2funzd2_10726;long BgL_siza7eza7_10727;
BgL_funz00_10724 = 
PROCEDURE_REF(BgL_envz00_10723, 
(int)(((long)0))); 
BgL_locz00_10725 = 
PROCEDURE_REF(BgL_envz00_10723, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10726 = 
PROCEDURE_REF(BgL_envz00_10723, 
(int)(((long)2))); 
BgL_siza7eza7_10727 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10723, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12739;
BgL_bpz00_12739 = 
VECTOR_REF(
((obj_t)BgL_sz00_10728),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12740;
BgL_fz00_12740 = 
PROCEDURE_ENTRY(BgL_funz00_10724)(BgL_funz00_10724, BgL_sz00_10728, BEOA); 
if(
PROCEDUREP(BgL_fz00_12740))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10725, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12740); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12741;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16473;
BgL_tmpz00_16473 = 
((obj_t)BgL_fz00_12740); 
BgL_ufz00_12741 = 
PROCEDURE_ATTR(BgL_tmpz00_16473); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5617z00_16476;
if(
STRUCTP(BgL_ufz00_12741))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5617z00_16476 = 
(
STRUCT_KEY(BgL_ufz00_12741)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5617z00_16476 = ((bool_t)0)
; } 
if(BgL_test5617z00_16476)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12742;obj_t BgL_runz00_12743;obj_t BgL_sfz00_12744;
BgL_arityz00_12742 = 
STRUCT_REF(BgL_ufz00_12741, 
(int)(((long)0))); 
BgL_runz00_12743 = 
STRUCT_REF(BgL_ufz00_12741, 
(int)(((long)1))); 
BgL_sfz00_12744 = 
STRUCT_REF(BgL_ufz00_12741, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12742)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12742))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12742)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1943z00_12747;obj_t BgL_arg1944z00_12748;
BgL_arg1943z00_12747 = 
(
(long)CINT(BgL_bpz00_12739)+((long)0)); 
BgL_arg1944z00_12748 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10728),BgL_arg1943z00_12747,BgL_arg1944z00_12748); } break;
default: 
BgL_case_else1171z00_12745:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1946z00_12746;
BgL_arg1946z00_12746 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12741), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10725, BgL_arg1946z00_12746, 
(int)(((long)0)), 
CINT(BgL_arityz00_12742)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1171z00_12745;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12749;
BgL_z12denvz12_12749 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10728, BgL_bpz00_12739, BgL_sfz00_12744))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12743;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12750;
BgL_nsz00_12750 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1948z00_12751;
BgL_arg1948z00_12751 = 
(
(long)CINT(BgL_bpz00_12739)+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12750, ((long)2), BgL_sz00_10728, BgL_bpz00_12739, 
BINT(BgL_arg1948z00_12751)); } 
VECTOR_SET(BgL_nsz00_12750,((long)1),BgL_sz00_10728); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12749, BgL_nsz00_12750); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12752;
BgL_ez00_12752 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12752, BgL_sz00_10728); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12753;
BgL_____rz00_12753 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12743, BgL_nsz00_12750, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12752); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12749, BgL_sz00_10728); 
return BgL_____rz00_12753;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12740, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12754;
BgL_nbpz00_12754 = 
(
(long)CINT(BgL_bpz00_12739)+BgL_siza7eza7_10727); 
VECTOR_SET(
((obj_t)BgL_sz00_10728),((long)0),
BINT(BgL_nbpz00_12754)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12755;
BgL_rz00_12755 = 
PROCEDURE_ENTRY(BgL_fz00_12740)(BgL_fz00_12740, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10728),((long)0),BgL_bpz00_12739); 
return BgL_rz00_12755;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10725, BgL_symbzd2funzd2_10726, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12740));} } } } } } } } 

}



/* &<@anonymous:1954> */
obj_t BGl_z62zc3z04anonymousza31954ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10729, obj_t BgL_sz00_10734)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10730;obj_t BgL_locz00_10731;obj_t BgL_symbzd2funzd2_10732;long BgL_siza7eza7_10733;
BgL_funz00_10730 = 
PROCEDURE_REF(BgL_envz00_10729, 
(int)(((long)0))); 
BgL_locz00_10731 = 
PROCEDURE_REF(BgL_envz00_10729, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10732 = 
PROCEDURE_REF(BgL_envz00_10729, 
(int)(((long)2))); 
BgL_siza7eza7_10733 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10729, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12756;
BgL_bpz00_12756 = 
VECTOR_REF(
((obj_t)BgL_sz00_10734),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12757;
BgL_fz00_12757 = 
PROCEDURE_ENTRY(BgL_funz00_10730)(BgL_funz00_10730, BgL_sz00_10734, BEOA); 
if(
PROCEDUREP(BgL_fz00_12757))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10731, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12757); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12758;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16554;
BgL_tmpz00_16554 = 
((obj_t)BgL_fz00_12757); 
BgL_ufz00_12758 = 
PROCEDURE_ATTR(BgL_tmpz00_16554); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5624z00_16557;
if(
STRUCTP(BgL_ufz00_12758))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5624z00_16557 = 
(
STRUCT_KEY(BgL_ufz00_12758)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5624z00_16557 = ((bool_t)0)
; } 
if(BgL_test5624z00_16557)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12759;obj_t BgL_runz00_12760;obj_t BgL_sfz00_12761;
BgL_arityz00_12759 = 
STRUCT_REF(BgL_ufz00_12758, 
(int)(((long)0))); 
BgL_runz00_12760 = 
STRUCT_REF(BgL_ufz00_12758, 
(int)(((long)1))); 
BgL_sfz00_12761 = 
STRUCT_REF(BgL_ufz00_12758, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12762;
BgL_spz00_12762 = 
(
(long)CINT(BgL_bpz00_12756)+BgL_siza7eza7_10733); 
if(
(
(long)CINT(BgL_arityz00_12759)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12759))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12759)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1959z00_12765;obj_t BgL_arg1960z00_12766;
BgL_arg1959z00_12765 = 
(BgL_spz00_12762+((long)0)); 
BgL_arg1960z00_12766 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10734),BgL_arg1959z00_12765,BgL_arg1960z00_12766); } break;
default: 
BgL_case_else1173z00_12763:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1962z00_12764;
BgL_arg1962z00_12764 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12758), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10731, BgL_arg1962z00_12764, 
(int)(((long)0)), 
CINT(BgL_arityz00_12759)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1173z00_12763;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12767;
BgL_z12denvz12_12767 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12767, BgL_locz00_10731); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10734, 
BINT(BgL_spz00_12762), BgL_sfz00_12761))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12760, BgL_sz00_10734, 
BINT(BgL_spz00_12762));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12768;
BgL_nsz00_12768 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1964z00_12769;
BgL_arg1964z00_12769 = 
(BgL_spz00_12762+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12768, ((long)2), BgL_sz00_10734, 
BINT(BgL_spz00_12762), 
BINT(BgL_arg1964z00_12769)); } 
VECTOR_SET(BgL_nsz00_12768,((long)1),BgL_sz00_10734); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12767, BgL_nsz00_12768); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12770;
BgL_ez00_12770 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12770, BgL_sz00_10734); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12771;
BgL_____rz00_12771 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12760, BgL_nsz00_12768, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12770); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12767, BgL_sz00_10734); 
return BgL_____rz00_12771;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12757, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12772;
BgL_nbpz00_12772 = 
(
(long)CINT(BgL_bpz00_12756)+BgL_siza7eza7_10733); 
VECTOR_SET(
((obj_t)BgL_sz00_10734),((long)0),
BINT(BgL_nbpz00_12772)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16614;
BgL_tmpz00_16614 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16614, BgL_locz00_10731); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12773;
BgL_rz00_12773 = 
PROCEDURE_ENTRY(BgL_fz00_12757)(BgL_fz00_12757, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10734),((long)0),BgL_bpz00_12756); 
return BgL_rz00_12773;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10731, BgL_symbzd2funzd2_10732, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12757));} } } } } } } } 

}



/* &<@anonymous:1968> */
obj_t BGl_z62zc3z04anonymousza31968ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10735, obj_t BgL_sz00_10740)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10736;obj_t BgL_locz00_10737;obj_t BgL_symbzd2funzd2_10738;long BgL_siza7eza7_10739;
BgL_funz00_10736 = 
PROCEDURE_REF(BgL_envz00_10735, 
(int)(((long)0))); 
BgL_locz00_10737 = 
PROCEDURE_REF(BgL_envz00_10735, 
(int)(((long)1))); 
BgL_symbzd2funzd2_10738 = 
PROCEDURE_REF(BgL_envz00_10735, 
(int)(((long)2))); 
BgL_siza7eza7_10739 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10735, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12774;
BgL_bpz00_12774 = 
VECTOR_REF(
((obj_t)BgL_sz00_10740),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12775;
BgL_fz00_12775 = 
PROCEDURE_ENTRY(BgL_funz00_10736)(BgL_funz00_10736, BgL_sz00_10740, BEOA); 
if(
PROCEDUREP(BgL_fz00_12775))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10737, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12775); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12776;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16643;
BgL_tmpz00_16643 = 
((obj_t)BgL_fz00_12775); 
BgL_ufz00_12776 = 
PROCEDURE_ATTR(BgL_tmpz00_16643); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5631z00_16646;
if(
STRUCTP(BgL_ufz00_12776))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5631z00_16646 = 
(
STRUCT_KEY(BgL_ufz00_12776)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5631z00_16646 = ((bool_t)0)
; } 
if(BgL_test5631z00_16646)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12777;obj_t BgL_runz00_12778;obj_t BgL_sfz00_12779;
BgL_arityz00_12777 = 
STRUCT_REF(BgL_ufz00_12776, 
(int)(((long)0))); 
BgL_runz00_12778 = 
STRUCT_REF(BgL_ufz00_12776, 
(int)(((long)1))); 
BgL_sfz00_12779 = 
STRUCT_REF(BgL_ufz00_12776, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12780;
BgL_spz00_12780 = 
(
(long)CINT(BgL_bpz00_12774)+BgL_siza7eza7_10739); 
if(
(
(long)CINT(BgL_arityz00_12777)==((long)0)))
{ /* Eval/evaluate_comp.scm 896 */BUNSPEC; }  else 
{ 

if(
INTEGERP(BgL_arityz00_12777))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12777)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1973z00_12783;obj_t BgL_arg1974z00_12784;
BgL_arg1973z00_12783 = 
(BgL_spz00_12780+((long)0)); 
BgL_arg1974z00_12784 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10740),BgL_arg1973z00_12783,BgL_arg1974z00_12784); } break;
default: 
BgL_case_else1175z00_12781:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg1976z00_12782;
BgL_arg1976z00_12782 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12776), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10737, BgL_arg1976z00_12782, 
(int)(((long)0)), 
CINT(BgL_arityz00_12777)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1175z00_12781;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12785;
BgL_z12denvz12_12785 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10740, 
BINT(BgL_spz00_12780), BgL_sfz00_12779))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12778, BgL_sz00_10740, 
BINT(BgL_spz00_12780));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12786;
BgL_nsz00_12786 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1978z00_12787;
BgL_arg1978z00_12787 = 
(BgL_spz00_12780+((long)0)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12786, ((long)2), BgL_sz00_10740, 
BINT(BgL_spz00_12780), 
BINT(BgL_arg1978z00_12787)); } 
VECTOR_SET(BgL_nsz00_12786,((long)1),BgL_sz00_10740); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12785, BgL_nsz00_12786); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12788;
BgL_ez00_12788 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12788, BgL_sz00_10740); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12789;
BgL_____rz00_12789 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12778, BgL_nsz00_12786, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12788); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12785, BgL_sz00_10740); 
return BgL_____rz00_12789;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12775, 
(int)(((long)0))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12790;
BgL_nbpz00_12790 = 
(
(long)CINT(BgL_bpz00_12774)+BgL_siza7eza7_10739); 
VECTOR_SET(
((obj_t)BgL_sz00_10740),((long)0),
BINT(BgL_nbpz00_12790)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12791;
BgL_rz00_12791 = 
PROCEDURE_ENTRY(BgL_fz00_12775)(BgL_fz00_12775, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10740),((long)0),BgL_bpz00_12774); 
return BgL_rz00_12791;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10737, BgL_symbzd2funzd2_10738, 
(int)(((long)0)), 
PROCEDURE_ARITY(BgL_fz00_12775));} } } } } } } } 

}



/* comp-call1 */
obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145, BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147, obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150, long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2119;
BgL_cfunz00_2119 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146, ((long)1), BgL_locz00_145, BgL_symbzd2funzd2_147); 
if(
CBOOL(BgL_cfunz00_2119))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5638z00_16713;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg1987z00_2135;
BgL_arg1987z00_2135 = 
bgl_debug(); 
BgL_test5638z00_16713 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg1987z00_2135), 
BINT(((long)0))); } 
if(BgL_test5638z00_16713)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31984ze3z87_10741;
BgL_zc3z04anonymousza31984ze3z87_10741 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31984ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31984ze3z87_10741, 
(int)(((long)0)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31984ze3z87_10741, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_151)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31984ze3z87_10741, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza31984ze3z87_10741, 
(int)(((long)3)), BgL_cfunz00_2119); 
return BgL_zc3z04anonymousza31984ze3z87_10741;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31986ze3z87_10742;
BgL_zc3z04anonymousza31986ze3z87_10742 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31986ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31986ze3z87_10742, 
(int)(((long)0)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31986ze3z87_10742, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_151)); 
PROCEDURE_SET(BgL_zc3z04anonymousza31986ze3z87_10742, 
(int)(((long)2)), BgL_cfunz00_2119); 
return BgL_zc3z04anonymousza31986ze3z87_10742;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_149))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5640z00_16742;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2027z00_2211;
BgL_arg2027z00_2211 = 
bgl_debug(); 
BgL_test5640z00_16742 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2027z00_2211), 
BINT(((long)0))); } 
if(BgL_test5640z00_16742)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza31990ze3z87_10743;
BgL_zc3z04anonymousza31990ze3z87_10743 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31990ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31990ze3z87_10743, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza31990ze3z87_10743, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza31990ze3z87_10743, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza31990ze3z87_10743, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza31990ze3z87_10743, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza31990ze3z87_10743;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32009ze3z87_10744;
BgL_zc3z04anonymousza32009ze3z87_10744 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32009ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32009ze3z87_10744, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza32009ze3z87_10744, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza32009ze3z87_10744, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza32009ze3z87_10744, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza32009ze3z87_10744, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza32009ze3z87_10744;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5641z00_16775;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2067z00_2287;
BgL_arg2067z00_2287 = 
bgl_debug(); 
BgL_test5641z00_16775 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2067z00_2287), 
BINT(((long)0))); } 
if(BgL_test5641z00_16775)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32030ze3z87_10745;
BgL_zc3z04anonymousza32030ze3z87_10745 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32030ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32030ze3z87_10745, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza32030ze3z87_10745, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza32030ze3z87_10745, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza32030ze3z87_10745, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza32030ze3z87_10745, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza32030ze3z87_10745;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32049ze3z87_10746;
BgL_zc3z04anonymousza32049ze3z87_10746 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32049ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32049ze3z87_10746, 
(int)(((long)0)), BgL_funz00_148); 
PROCEDURE_SET(BgL_zc3z04anonymousza32049ze3z87_10746, 
(int)(((long)1)), BgL_a1z00_152); 
PROCEDURE_SET(BgL_zc3z04anonymousza32049ze3z87_10746, 
(int)(((long)2)), BgL_locz00_145); 
PROCEDURE_SET(BgL_zc3z04anonymousza32049ze3z87_10746, 
(int)(((long)3)), BgL_symbzd2funzd2_147); 
PROCEDURE_SET(BgL_zc3z04anonymousza32049ze3z87_10746, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_151)); 
return BgL_zc3z04anonymousza32049ze3z87_10746;} } } } } 

}



/* &<@anonymous:1984> */
obj_t BGl_z62zc3z04anonymousza31984ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10747, obj_t BgL_sz00_10752)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10748;long BgL_siza7eza7_10749;obj_t BgL_locz00_10750;obj_t BgL_cfunz00_10751;
BgL_a1z00_10748 = 
PROCEDURE_REF(BgL_envz00_10747, 
(int)(((long)0))); 
BgL_siza7eza7_10749 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10747, 
(int)(((long)1)))); 
BgL_locz00_10750 = 
PROCEDURE_REF(BgL_envz00_10747, 
(int)(((long)2))); 
BgL_cfunz00_10751 = 
PROCEDURE_REF(BgL_envz00_10747, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12792;
BgL_bpz00_12792 = 
VECTOR_REF(
((obj_t)BgL_sz00_10752),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12793;
BgL_a1z00_12793 = 
PROCEDURE_ENTRY(BgL_a1z00_10748)(BgL_a1z00_10748, BgL_sz00_10752, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12794;
BgL_nbpz00_12794 = 
(
(long)CINT(BgL_bpz00_12792)+BgL_siza7eza7_10749); 
VECTOR_SET(
((obj_t)BgL_sz00_10752),((long)0),
BINT(BgL_nbpz00_12794)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16828;
BgL_tmpz00_16828 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16828, BgL_locz00_10750); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12795;
BgL_rz00_12795 = 
PROCEDURE_ENTRY(BgL_cfunz00_10751)(BgL_cfunz00_10751, BgL_a1z00_12793, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10752),((long)0),BgL_bpz00_12792); 
return BgL_rz00_12795;} } } } } } 

}



/* &<@anonymous:1986> */
obj_t BGl_z62zc3z04anonymousza31986ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10753, obj_t BgL_sz00_10757)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10754;long BgL_siza7eza7_10755;obj_t BgL_cfunz00_10756;
BgL_a1z00_10754 = 
PROCEDURE_REF(BgL_envz00_10753, 
(int)(((long)0))); 
BgL_siza7eza7_10755 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10753, 
(int)(((long)1)))); 
BgL_cfunz00_10756 = 
PROCEDURE_REF(BgL_envz00_10753, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12796;
BgL_bpz00_12796 = 
VECTOR_REF(
((obj_t)BgL_sz00_10757),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12797;
BgL_a1z00_12797 = 
PROCEDURE_ENTRY(BgL_a1z00_10754)(BgL_a1z00_10754, BgL_sz00_10757, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12798;
BgL_nbpz00_12798 = 
(
(long)CINT(BgL_bpz00_12796)+BgL_siza7eza7_10755); 
VECTOR_SET(
((obj_t)BgL_sz00_10757),((long)0),
BINT(BgL_nbpz00_12798)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12799;
BgL_rz00_12799 = 
PROCEDURE_ENTRY(BgL_cfunz00_10756)(BgL_cfunz00_10756, BgL_a1z00_12797, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10757),((long)0),BgL_bpz00_12796); 
return BgL_rz00_12799;} } } } } } 

}



/* &<@anonymous:1990> */
obj_t BGl_z62zc3z04anonymousza31990ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10758, obj_t BgL_sz00_10764)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10759;obj_t BgL_a1z00_10760;obj_t BgL_locz00_10761;obj_t BgL_symbzd2funzd2_10762;long BgL_siza7eza7_10763;
BgL_funz00_10759 = 
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)0))); 
BgL_a1z00_10760 = 
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)1))); 
BgL_locz00_10761 = 
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10762 = 
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)3))); 
BgL_siza7eza7_10763 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10758, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12800;
BgL_bpz00_12800 = 
VECTOR_REF(
((obj_t)BgL_sz00_10764),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12801;obj_t BgL_a1z00_12802;
BgL_fz00_12801 = 
PROCEDURE_ENTRY(BgL_funz00_10759)(BgL_funz00_10759, BgL_sz00_10764, BEOA); 
BgL_a1z00_12802 = 
PROCEDURE_ENTRY(BgL_a1z00_10760)(BgL_a1z00_10760, BgL_sz00_10764, BEOA); 
if(
PROCEDUREP(BgL_fz00_12801))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10761, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12801); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12803;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16885;
BgL_tmpz00_16885 = 
((obj_t)BgL_fz00_12801); 
BgL_ufz00_12803 = 
PROCEDURE_ATTR(BgL_tmpz00_16885); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5643z00_16888;
if(
STRUCTP(BgL_ufz00_12803))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5643z00_16888 = 
(
STRUCT_KEY(BgL_ufz00_12803)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5643z00_16888 = ((bool_t)0)
; } 
if(BgL_test5643z00_16888)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12804;obj_t BgL_runz00_12805;obj_t BgL_sfz00_12806;
BgL_arityz00_12804 = 
STRUCT_REF(BgL_ufz00_12803, 
(int)(((long)0))); 
BgL_runz00_12805 = 
STRUCT_REF(BgL_ufz00_12803, 
(int)(((long)1))); 
BgL_sfz00_12806 = 
STRUCT_REF(BgL_ufz00_12803, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12804)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1994z00_12807;
BgL_arg1994z00_12807 = 
(
(long)CINT(BgL_bpz00_12800)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10764),BgL_arg1994z00_12807,BgL_a1z00_12802); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12804))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12804)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1996z00_12810;obj_t BgL_arg1997z00_12811;
BgL_arg1996z00_12810 = 
(
(long)CINT(BgL_bpz00_12800)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list1998z00_12812;
BgL_list1998z00_12812 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12802, BNIL); 
BgL_arg1997z00_12811 = BgL_list1998z00_12812; } 
VECTOR_SET(
((obj_t)BgL_sz00_10764),BgL_arg1996z00_12810,BgL_arg1997z00_12811); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg1999z00_12813;
BgL_arg1999z00_12813 = 
(
(long)CINT(BgL_bpz00_12800)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10764),BgL_arg1999z00_12813,BgL_a1z00_12802); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2000z00_12814;obj_t BgL_arg2001z00_12815;
BgL_arg2000z00_12814 = 
(
(long)CINT(BgL_bpz00_12800)+((long)1)); 
BgL_arg2001z00_12815 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10764),BgL_arg2000z00_12814,BgL_arg2001z00_12815); } break;
default: 
BgL_case_else1177z00_12808:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2003z00_12809;
BgL_arg2003z00_12809 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12803), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10761, BgL_arg2003z00_12809, 
(int)(((long)1)), 
CINT(BgL_arityz00_12804)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1177z00_12808;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12816;
BgL_z12denvz12_12816 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12816, BgL_locz00_10761); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10764, BgL_bpz00_12800, BgL_sfz00_12806))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12805;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12817;
BgL_nsz00_12817 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2005z00_12818;
BgL_arg2005z00_12818 = 
(
(long)CINT(BgL_bpz00_12800)+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12817, ((long)2), BgL_sz00_10764, BgL_bpz00_12800, 
BINT(BgL_arg2005z00_12818)); } 
VECTOR_SET(BgL_nsz00_12817,((long)1),BgL_sz00_10764); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12816, BgL_nsz00_12817); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12819;
BgL_ez00_12819 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12819, BgL_sz00_10764); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12820;
BgL_____rz00_12820 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12805, BgL_nsz00_12817, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12819); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12816, BgL_sz00_10764); 
return BgL_____rz00_12820;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12801, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12821;
BgL_nbpz00_12821 = 
(
(long)CINT(BgL_bpz00_12800)+BgL_siza7eza7_10763); 
VECTOR_SET(
((obj_t)BgL_sz00_10764),((long)0),
BINT(BgL_nbpz00_12821)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16954;
BgL_tmpz00_16954 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_16954, BgL_locz00_10761); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12822;
BgL_rz00_12822 = 
PROCEDURE_ENTRY(BgL_fz00_12801)(BgL_fz00_12801, BgL_a1z00_12802, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10764),((long)0),BgL_bpz00_12800); 
return BgL_rz00_12822;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10761, BgL_symbzd2funzd2_10762, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12801));} } } } } } } } 

}



/* &<@anonymous:2009> */
obj_t BGl_z62zc3z04anonymousza32009ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10765, obj_t BgL_sz00_10771)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10766;obj_t BgL_a1z00_10767;obj_t BgL_locz00_10768;obj_t BgL_symbzd2funzd2_10769;long BgL_siza7eza7_10770;
BgL_funz00_10766 = 
PROCEDURE_REF(BgL_envz00_10765, 
(int)(((long)0))); 
BgL_a1z00_10767 = 
PROCEDURE_REF(BgL_envz00_10765, 
(int)(((long)1))); 
BgL_locz00_10768 = 
PROCEDURE_REF(BgL_envz00_10765, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10769 = 
PROCEDURE_REF(BgL_envz00_10765, 
(int)(((long)3))); 
BgL_siza7eza7_10770 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10765, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12823;
BgL_bpz00_12823 = 
VECTOR_REF(
((obj_t)BgL_sz00_10771),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12824;obj_t BgL_a1z00_12825;
BgL_fz00_12824 = 
PROCEDURE_ENTRY(BgL_funz00_10766)(BgL_funz00_10766, BgL_sz00_10771, BEOA); 
BgL_a1z00_12825 = 
PROCEDURE_ENTRY(BgL_a1z00_10767)(BgL_a1z00_10767, BgL_sz00_10771, BEOA); 
if(
PROCEDUREP(BgL_fz00_12824))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10768, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12824); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12826;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_16990;
BgL_tmpz00_16990 = 
((obj_t)BgL_fz00_12824); 
BgL_ufz00_12826 = 
PROCEDURE_ATTR(BgL_tmpz00_16990); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5650z00_16993;
if(
STRUCTP(BgL_ufz00_12826))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5650z00_16993 = 
(
STRUCT_KEY(BgL_ufz00_12826)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5650z00_16993 = ((bool_t)0)
; } 
if(BgL_test5650z00_16993)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12827;obj_t BgL_runz00_12828;obj_t BgL_sfz00_12829;
BgL_arityz00_12827 = 
STRUCT_REF(BgL_ufz00_12826, 
(int)(((long)0))); 
BgL_runz00_12828 = 
STRUCT_REF(BgL_ufz00_12826, 
(int)(((long)1))); 
BgL_sfz00_12829 = 
STRUCT_REF(BgL_ufz00_12826, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12827)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2013z00_12830;
BgL_arg2013z00_12830 = 
(
(long)CINT(BgL_bpz00_12823)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10771),BgL_arg2013z00_12830,BgL_a1z00_12825); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12827))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12827)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2015z00_12833;obj_t BgL_arg2016z00_12834;
BgL_arg2015z00_12833 = 
(
(long)CINT(BgL_bpz00_12823)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2017z00_12835;
BgL_list2017z00_12835 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12825, BNIL); 
BgL_arg2016z00_12834 = BgL_list2017z00_12835; } 
VECTOR_SET(
((obj_t)BgL_sz00_10771),BgL_arg2015z00_12833,BgL_arg2016z00_12834); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2018z00_12836;
BgL_arg2018z00_12836 = 
(
(long)CINT(BgL_bpz00_12823)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10771),BgL_arg2018z00_12836,BgL_a1z00_12825); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2019z00_12837;obj_t BgL_arg2020z00_12838;
BgL_arg2019z00_12837 = 
(
(long)CINT(BgL_bpz00_12823)+((long)1)); 
BgL_arg2020z00_12838 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10771),BgL_arg2019z00_12837,BgL_arg2020z00_12838); } break;
default: 
BgL_case_else1179z00_12831:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2022z00_12832;
BgL_arg2022z00_12832 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12826), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10768, BgL_arg2022z00_12832, 
(int)(((long)1)), 
CINT(BgL_arityz00_12827)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1179z00_12831;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12839;
BgL_z12denvz12_12839 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10771, BgL_bpz00_12823, BgL_sfz00_12829))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12828;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12840;
BgL_nsz00_12840 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2024z00_12841;
BgL_arg2024z00_12841 = 
(
(long)CINT(BgL_bpz00_12823)+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12840, ((long)2), BgL_sz00_10771, BgL_bpz00_12823, 
BINT(BgL_arg2024z00_12841)); } 
VECTOR_SET(BgL_nsz00_12840,((long)1),BgL_sz00_10771); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12839, BgL_nsz00_12840); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12842;
BgL_ez00_12842 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12842, BgL_sz00_10771); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12843;
BgL_____rz00_12843 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12828, BgL_nsz00_12840, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12842); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12839, BgL_sz00_10771); 
return BgL_____rz00_12843;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12824, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12844;
BgL_nbpz00_12844 = 
(
(long)CINT(BgL_bpz00_12823)+BgL_siza7eza7_10770); 
VECTOR_SET(
((obj_t)BgL_sz00_10771),((long)0),
BINT(BgL_nbpz00_12844)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12845;
BgL_rz00_12845 = 
PROCEDURE_ENTRY(BgL_fz00_12824)(BgL_fz00_12824, BgL_a1z00_12825, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10771),((long)0),BgL_bpz00_12823); 
return BgL_rz00_12845;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10768, BgL_symbzd2funzd2_10769, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12824));} } } } } } } } 

}



/* &<@anonymous:2030> */
obj_t BGl_z62zc3z04anonymousza32030ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10772, obj_t BgL_sz00_10778)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10773;obj_t BgL_a1z00_10774;obj_t BgL_locz00_10775;obj_t BgL_symbzd2funzd2_10776;long BgL_siza7eza7_10777;
BgL_funz00_10773 = 
PROCEDURE_REF(BgL_envz00_10772, 
(int)(((long)0))); 
BgL_a1z00_10774 = 
PROCEDURE_REF(BgL_envz00_10772, 
(int)(((long)1))); 
BgL_locz00_10775 = 
PROCEDURE_REF(BgL_envz00_10772, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10776 = 
PROCEDURE_REF(BgL_envz00_10772, 
(int)(((long)3))); 
BgL_siza7eza7_10777 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10772, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12846;
BgL_bpz00_12846 = 
VECTOR_REF(
((obj_t)BgL_sz00_10778),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12847;obj_t BgL_a1z00_12848;
BgL_fz00_12847 = 
PROCEDURE_ENTRY(BgL_funz00_10773)(BgL_funz00_10773, BgL_sz00_10778, BEOA); 
BgL_a1z00_12848 = 
PROCEDURE_ENTRY(BgL_a1z00_10774)(BgL_a1z00_10774, BgL_sz00_10778, BEOA); 
if(
PROCEDUREP(BgL_fz00_12847))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10775, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12847); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12849;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17091;
BgL_tmpz00_17091 = 
((obj_t)BgL_fz00_12847); 
BgL_ufz00_12849 = 
PROCEDURE_ATTR(BgL_tmpz00_17091); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5657z00_17094;
if(
STRUCTP(BgL_ufz00_12849))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5657z00_17094 = 
(
STRUCT_KEY(BgL_ufz00_12849)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5657z00_17094 = ((bool_t)0)
; } 
if(BgL_test5657z00_17094)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12850;obj_t BgL_runz00_12851;obj_t BgL_sfz00_12852;
BgL_arityz00_12850 = 
STRUCT_REF(BgL_ufz00_12849, 
(int)(((long)0))); 
BgL_runz00_12851 = 
STRUCT_REF(BgL_ufz00_12849, 
(int)(((long)1))); 
BgL_sfz00_12852 = 
STRUCT_REF(BgL_ufz00_12849, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12853;
BgL_spz00_12853 = 
(
(long)CINT(BgL_bpz00_12846)+BgL_siza7eza7_10777); 
if(
(
(long)CINT(BgL_arityz00_12850)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2034z00_12854;
BgL_arg2034z00_12854 = 
(BgL_spz00_12853+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10778),BgL_arg2034z00_12854,BgL_a1z00_12848); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12850))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12850)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2036z00_12857;obj_t BgL_arg2037z00_12858;
BgL_arg2036z00_12857 = 
(BgL_spz00_12853+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2038z00_12859;
BgL_list2038z00_12859 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12848, BNIL); 
BgL_arg2037z00_12858 = BgL_list2038z00_12859; } 
VECTOR_SET(
((obj_t)BgL_sz00_10778),BgL_arg2036z00_12857,BgL_arg2037z00_12858); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2039z00_12860;
BgL_arg2039z00_12860 = 
(BgL_spz00_12853+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10778),BgL_arg2039z00_12860,BgL_a1z00_12848); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2040z00_12861;obj_t BgL_arg2041z00_12862;
BgL_arg2040z00_12861 = 
(BgL_spz00_12853+((long)1)); 
BgL_arg2041z00_12862 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10778),BgL_arg2040z00_12861,BgL_arg2041z00_12862); } break;
default: 
BgL_case_else1181z00_12855:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2043z00_12856;
BgL_arg2043z00_12856 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12849), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10775, BgL_arg2043z00_12856, 
(int)(((long)1)), 
CINT(BgL_arityz00_12850)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1181z00_12855;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12863;
BgL_z12denvz12_12863 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12863, BgL_locz00_10775); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10778, 
BINT(BgL_spz00_12853), BgL_sfz00_12852))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12851, BgL_sz00_10778, 
BINT(BgL_spz00_12853));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12864;
BgL_nsz00_12864 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2045z00_12865;
BgL_arg2045z00_12865 = 
(BgL_spz00_12853+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12864, ((long)2), BgL_sz00_10778, 
BINT(BgL_spz00_12853), 
BINT(BgL_arg2045z00_12865)); } 
VECTOR_SET(BgL_nsz00_12864,((long)1),BgL_sz00_10778); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12863, BgL_nsz00_12864); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12866;
BgL_ez00_12866 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12866, BgL_sz00_10778); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12867;
BgL_____rz00_12867 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12851, BgL_nsz00_12864, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12866); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12863, BgL_sz00_10778); 
return BgL_____rz00_12867;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12847, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12868;
BgL_nbpz00_12868 = 
(
(long)CINT(BgL_bpz00_12846)+BgL_siza7eza7_10777); 
VECTOR_SET(
((obj_t)BgL_sz00_10778),((long)0),
BINT(BgL_nbpz00_12868)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17161;
BgL_tmpz00_17161 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17161, BgL_locz00_10775); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12869;
BgL_rz00_12869 = 
PROCEDURE_ENTRY(BgL_fz00_12847)(BgL_fz00_12847, BgL_a1z00_12848, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10778),((long)0),BgL_bpz00_12846); 
return BgL_rz00_12869;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10775, BgL_symbzd2funzd2_10776, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12847));} } } } } } } } 

}



/* &<@anonymous:2049> */
obj_t BGl_z62zc3z04anonymousza32049ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10779, obj_t BgL_sz00_10785)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10780;obj_t BgL_a1z00_10781;obj_t BgL_locz00_10782;obj_t BgL_symbzd2funzd2_10783;long BgL_siza7eza7_10784;
BgL_funz00_10780 = 
PROCEDURE_REF(BgL_envz00_10779, 
(int)(((long)0))); 
BgL_a1z00_10781 = 
PROCEDURE_REF(BgL_envz00_10779, 
(int)(((long)1))); 
BgL_locz00_10782 = 
PROCEDURE_REF(BgL_envz00_10779, 
(int)(((long)2))); 
BgL_symbzd2funzd2_10783 = 
PROCEDURE_REF(BgL_envz00_10779, 
(int)(((long)3))); 
BgL_siza7eza7_10784 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10779, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12870;
BgL_bpz00_12870 = 
VECTOR_REF(
((obj_t)BgL_sz00_10785),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12871;obj_t BgL_a1z00_12872;
BgL_fz00_12871 = 
PROCEDURE_ENTRY(BgL_funz00_10780)(BgL_funz00_10780, BgL_sz00_10785, BEOA); 
BgL_a1z00_12872 = 
PROCEDURE_ENTRY(BgL_a1z00_10781)(BgL_a1z00_10781, BgL_sz00_10785, BEOA); 
if(
PROCEDUREP(BgL_fz00_12871))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10782, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12871); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12873;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17197;
BgL_tmpz00_17197 = 
((obj_t)BgL_fz00_12871); 
BgL_ufz00_12873 = 
PROCEDURE_ATTR(BgL_tmpz00_17197); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5664z00_17200;
if(
STRUCTP(BgL_ufz00_12873))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5664z00_17200 = 
(
STRUCT_KEY(BgL_ufz00_12873)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5664z00_17200 = ((bool_t)0)
; } 
if(BgL_test5664z00_17200)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12874;obj_t BgL_runz00_12875;obj_t BgL_sfz00_12876;
BgL_arityz00_12874 = 
STRUCT_REF(BgL_ufz00_12873, 
(int)(((long)0))); 
BgL_runz00_12875 = 
STRUCT_REF(BgL_ufz00_12873, 
(int)(((long)1))); 
BgL_sfz00_12876 = 
STRUCT_REF(BgL_ufz00_12873, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12877;
BgL_spz00_12877 = 
(
(long)CINT(BgL_bpz00_12870)+BgL_siza7eza7_10784); 
if(
(
(long)CINT(BgL_arityz00_12874)==((long)1)))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2053z00_12878;
BgL_arg2053z00_12878 = 
(BgL_spz00_12877+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10785),BgL_arg2053z00_12878,BgL_a1z00_12872); }  else 
{ 

if(
INTEGERP(BgL_arityz00_12874))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12874)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2055z00_12881;obj_t BgL_arg2056z00_12882;
BgL_arg2055z00_12881 = 
(BgL_spz00_12877+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2057z00_12883;
BgL_list2057z00_12883 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12872, BNIL); 
BgL_arg2056z00_12882 = BgL_list2057z00_12883; } 
VECTOR_SET(
((obj_t)BgL_sz00_10785),BgL_arg2055z00_12881,BgL_arg2056z00_12882); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2058z00_12884;
BgL_arg2058z00_12884 = 
(BgL_spz00_12877+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10785),BgL_arg2058z00_12884,BgL_a1z00_12872); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2059z00_12885;obj_t BgL_arg2060z00_12886;
BgL_arg2059z00_12885 = 
(BgL_spz00_12877+((long)1)); 
BgL_arg2060z00_12886 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10785),BgL_arg2059z00_12885,BgL_arg2060z00_12886); } break;
default: 
BgL_case_else1183z00_12879:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2062z00_12880;
BgL_arg2062z00_12880 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12873), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10782, BgL_arg2062z00_12880, 
(int)(((long)1)), 
CINT(BgL_arityz00_12874)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1183z00_12879;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12887;
BgL_z12denvz12_12887 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10785, 
BINT(BgL_spz00_12877), BgL_sfz00_12876))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12875, BgL_sz00_10785, 
BINT(BgL_spz00_12877));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12888;
BgL_nsz00_12888 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2064z00_12889;
BgL_arg2064z00_12889 = 
(BgL_spz00_12877+((long)1)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12888, ((long)2), BgL_sz00_10785, 
BINT(BgL_spz00_12877), 
BINT(BgL_arg2064z00_12889)); } 
VECTOR_SET(BgL_nsz00_12888,((long)1),BgL_sz00_10785); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12887, BgL_nsz00_12888); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12890;
BgL_ez00_12890 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12890, BgL_sz00_10785); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12891;
BgL_____rz00_12891 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12875, BgL_nsz00_12888, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12890); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12887, BgL_sz00_10785); 
return BgL_____rz00_12891;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12871, 
(int)(((long)1))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12892;
BgL_nbpz00_12892 = 
(
(long)CINT(BgL_bpz00_12870)+BgL_siza7eza7_10784); 
VECTOR_SET(
((obj_t)BgL_sz00_10785),((long)0),
BINT(BgL_nbpz00_12892)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12893;
BgL_rz00_12893 = 
PROCEDURE_ENTRY(BgL_fz00_12871)(BgL_fz00_12871, BgL_a1z00_12872, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10785),((long)0),BgL_bpz00_12870); 
return BgL_rz00_12893;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10782, BgL_symbzd2funzd2_10783, 
(int)(((long)1)), 
PROCEDURE_ARITY(BgL_fz00_12871));} } } } } } } } 

}



/* comp-call2 */
obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153, BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155, obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158, long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2288;
BgL_cfunz00_2288 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154, ((long)2), BgL_locz00_153, BgL_symbzd2funzd2_155); 
if(
CBOOL(BgL_cfunz00_2288))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5671z00_17278;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2073z00_2306;
BgL_arg2073z00_2306 = 
bgl_debug(); 
BgL_test5671z00_17278 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2073z00_2306), 
BINT(((long)0))); } 
if(BgL_test5671z00_17278)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32070ze3z87_10786;
BgL_zc3z04anonymousza32070ze3z87_10786 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32070ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32070ze3z87_10786, 
(int)(((long)0)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32070ze3z87_10786, 
(int)(((long)1)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32070ze3z87_10786, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_159)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32070ze3z87_10786, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32070ze3z87_10786, 
(int)(((long)4)), BgL_cfunz00_2288); 
return BgL_zc3z04anonymousza32070ze3z87_10786;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32072ze3z87_10787;
BgL_zc3z04anonymousza32072ze3z87_10787 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32072ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32072ze3z87_10787, 
(int)(((long)0)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32072ze3z87_10787, 
(int)(((long)1)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32072ze3z87_10787, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_159)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32072ze3z87_10787, 
(int)(((long)3)), BgL_cfunz00_2288); 
return BgL_zc3z04anonymousza32072ze3z87_10787;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_157))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5673z00_17311;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2127z00_2398;
BgL_arg2127z00_2398 = 
bgl_debug(); 
BgL_test5673z00_17311 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2127z00_2398), 
BINT(((long)0))); } 
if(BgL_test5673z00_17311)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32076ze3z87_10788;
BgL_zc3z04anonymousza32076ze3z87_10788 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32076ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32076ze3z87_10788, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32076ze3z87_10788, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32076ze3z87_10788, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32076ze3z87_10788, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32076ze3z87_10788, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32076ze3z87_10788, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32076ze3z87_10788;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32102ze3z87_10789;
BgL_zc3z04anonymousza32102ze3z87_10789 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32102ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32102ze3z87_10789, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32102ze3z87_10789, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32102ze3z87_10789, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32102ze3z87_10789, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32102ze3z87_10789, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32102ze3z87_10789, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32102ze3z87_10789;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5674z00_17348;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2181z00_2490;
BgL_arg2181z00_2490 = 
bgl_debug(); 
BgL_test5674z00_17348 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2181z00_2490), 
BINT(((long)0))); } 
if(BgL_test5674z00_17348)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32130ze3z87_10790;
BgL_zc3z04anonymousza32130ze3z87_10790 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32130ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32130ze3z87_10790, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32130ze3z87_10790, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32130ze3z87_10790, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32130ze3z87_10790, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32130ze3z87_10790, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32130ze3z87_10790, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32130ze3z87_10790;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32156ze3z87_10791;
BgL_zc3z04anonymousza32156ze3z87_10791 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32156ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_10791, 
(int)(((long)0)), BgL_funz00_156); 
PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_10791, 
(int)(((long)1)), BgL_a1z00_160); 
PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_10791, 
(int)(((long)2)), BgL_a2z00_161); 
PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_10791, 
(int)(((long)3)), BgL_locz00_153); 
PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_10791, 
(int)(((long)4)), BgL_symbzd2funzd2_155); 
PROCEDURE_SET(BgL_zc3z04anonymousza32156ze3z87_10791, 
(int)(((long)5)), 
BINT(BgL_siza7eza7_159)); 
return BgL_zc3z04anonymousza32156ze3z87_10791;} } } } } 

}



/* &<@anonymous:2070> */
obj_t BGl_z62zc3z04anonymousza32070ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10792, obj_t BgL_sz00_10798)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10793;obj_t BgL_a2z00_10794;long BgL_siza7eza7_10795;obj_t BgL_locz00_10796;obj_t BgL_cfunz00_10797;
BgL_a1z00_10793 = 
PROCEDURE_REF(BgL_envz00_10792, 
(int)(((long)0))); 
BgL_a2z00_10794 = 
PROCEDURE_REF(BgL_envz00_10792, 
(int)(((long)1))); 
BgL_siza7eza7_10795 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10792, 
(int)(((long)2)))); 
BgL_locz00_10796 = 
PROCEDURE_REF(BgL_envz00_10792, 
(int)(((long)3))); 
BgL_cfunz00_10797 = 
PROCEDURE_REF(BgL_envz00_10792, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12894;
BgL_bpz00_12894 = 
VECTOR_REF(
((obj_t)BgL_sz00_10798),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12895;obj_t BgL_a2z00_12896;
BgL_a1z00_12895 = 
PROCEDURE_ENTRY(BgL_a1z00_10793)(BgL_a1z00_10793, BgL_sz00_10798, BEOA); 
BgL_a2z00_12896 = 
PROCEDURE_ENTRY(BgL_a2z00_10794)(BgL_a2z00_10794, BgL_sz00_10798, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12897;
BgL_nbpz00_12897 = 
(
(long)CINT(BgL_bpz00_12894)+BgL_siza7eza7_10795); 
VECTOR_SET(
((obj_t)BgL_sz00_10798),((long)0),
BINT(BgL_nbpz00_12897)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17411;
BgL_tmpz00_17411 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17411, BgL_locz00_10796); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12898;
BgL_rz00_12898 = 
PROCEDURE_ENTRY(BgL_cfunz00_10797)(BgL_cfunz00_10797, BgL_a1z00_12895, BgL_a2z00_12896, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10798),((long)0),BgL_bpz00_12894); 
return BgL_rz00_12898;} } } } } } 

}



/* &<@anonymous:2072> */
obj_t BGl_z62zc3z04anonymousza32072ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10799, obj_t BgL_sz00_10804)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10800;obj_t BgL_a2z00_10801;long BgL_siza7eza7_10802;obj_t BgL_cfunz00_10803;
BgL_a1z00_10800 = 
PROCEDURE_REF(BgL_envz00_10799, 
(int)(((long)0))); 
BgL_a2z00_10801 = 
PROCEDURE_REF(BgL_envz00_10799, 
(int)(((long)1))); 
BgL_siza7eza7_10802 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10799, 
(int)(((long)2)))); 
BgL_cfunz00_10803 = 
PROCEDURE_REF(BgL_envz00_10799, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12899;
BgL_bpz00_12899 = 
VECTOR_REF(
((obj_t)BgL_sz00_10804),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_12900;obj_t BgL_a2z00_12901;
BgL_a1z00_12900 = 
PROCEDURE_ENTRY(BgL_a1z00_10800)(BgL_a1z00_10800, BgL_sz00_10804, BEOA); 
BgL_a2z00_12901 = 
PROCEDURE_ENTRY(BgL_a2z00_10801)(BgL_a2z00_10801, BgL_sz00_10804, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12902;
BgL_nbpz00_12902 = 
(
(long)CINT(BgL_bpz00_12899)+BgL_siza7eza7_10802); 
VECTOR_SET(
((obj_t)BgL_sz00_10804),((long)0),
BINT(BgL_nbpz00_12902)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12903;
BgL_rz00_12903 = 
PROCEDURE_ENTRY(BgL_cfunz00_10803)(BgL_cfunz00_10803, BgL_a1z00_12900, BgL_a2z00_12901, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10804),((long)0),BgL_bpz00_12899); 
return BgL_rz00_12903;} } } } } } 

}



/* &<@anonymous:2076> */
obj_t BGl_z62zc3z04anonymousza32076ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10805, obj_t BgL_sz00_10812)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10806;obj_t BgL_a1z00_10807;obj_t BgL_a2z00_10808;obj_t BgL_locz00_10809;obj_t BgL_symbzd2funzd2_10810;long BgL_siza7eza7_10811;
BgL_funz00_10806 = 
PROCEDURE_REF(BgL_envz00_10805, 
(int)(((long)0))); 
BgL_a1z00_10807 = 
PROCEDURE_REF(BgL_envz00_10805, 
(int)(((long)1))); 
BgL_a2z00_10808 = 
PROCEDURE_REF(BgL_envz00_10805, 
(int)(((long)2))); 
BgL_locz00_10809 = 
PROCEDURE_REF(BgL_envz00_10805, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10810 = 
PROCEDURE_REF(BgL_envz00_10805, 
(int)(((long)4))); 
BgL_siza7eza7_10811 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10805, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12904;
BgL_bpz00_12904 = 
VECTOR_REF(
((obj_t)BgL_sz00_10812),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12905;obj_t BgL_a1z00_12906;obj_t BgL_a2z00_12907;
BgL_fz00_12905 = 
PROCEDURE_ENTRY(BgL_funz00_10806)(BgL_funz00_10806, BgL_sz00_10812, BEOA); 
BgL_a1z00_12906 = 
PROCEDURE_ENTRY(BgL_a1z00_10807)(BgL_a1z00_10807, BgL_sz00_10812, BEOA); 
BgL_a2z00_12907 = 
PROCEDURE_ENTRY(BgL_a2z00_10808)(BgL_a2z00_10808, BgL_sz00_10812, BEOA); 
if(
PROCEDUREP(BgL_fz00_12905))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10809, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12905); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12908;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17482;
BgL_tmpz00_17482 = 
((obj_t)BgL_fz00_12905); 
BgL_ufz00_12908 = 
PROCEDURE_ATTR(BgL_tmpz00_17482); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5676z00_17485;
if(
STRUCTP(BgL_ufz00_12908))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5676z00_17485 = 
(
STRUCT_KEY(BgL_ufz00_12908)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5676z00_17485 = ((bool_t)0)
; } 
if(BgL_test5676z00_17485)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12909;obj_t BgL_runz00_12910;obj_t BgL_sfz00_12911;
BgL_arityz00_12909 = 
STRUCT_REF(BgL_ufz00_12908, 
(int)(((long)0))); 
BgL_runz00_12910 = 
STRUCT_REF(BgL_ufz00_12908, 
(int)(((long)1))); 
BgL_sfz00_12911 = 
STRUCT_REF(BgL_ufz00_12908, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12909)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2080z00_12912;
BgL_arg2080z00_12912 = 
(
(long)CINT(BgL_bpz00_12904)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10812),BgL_arg2080z00_12912,BgL_a1z00_12906); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2081z00_12913;
BgL_arg2081z00_12913 = 
(
(long)CINT(BgL_bpz00_12904)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10812),BgL_arg2081z00_12913,BgL_a2z00_12907); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12909))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12909)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2083z00_12916;obj_t BgL_arg2084z00_12917;
BgL_arg2083z00_12916 = 
(
(long)CINT(BgL_bpz00_12904)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2085z00_12918;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2086z00_12919;
BgL_arg2086z00_12919 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12907, BNIL); 
BgL_list2085z00_12918 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12906, BgL_arg2086z00_12919); } 
BgL_arg2084z00_12917 = BgL_list2085z00_12918; } 
VECTOR_SET(
((obj_t)BgL_sz00_10812),BgL_arg2083z00_12916,BgL_arg2084z00_12917); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2087z00_12920;
BgL_arg2087z00_12920 = 
(
(long)CINT(BgL_bpz00_12904)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10812),BgL_arg2087z00_12920,BgL_a1z00_12906); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2088z00_12921;obj_t BgL_arg2089z00_12922;
BgL_arg2088z00_12921 = 
(
(long)CINT(BgL_bpz00_12904)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2090z00_12923;
BgL_list2090z00_12923 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12907, BNIL); 
BgL_arg2089z00_12922 = BgL_list2090z00_12923; } 
VECTOR_SET(
((obj_t)BgL_sz00_10812),BgL_arg2088z00_12921,BgL_arg2089z00_12922); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2091z00_12924;
BgL_arg2091z00_12924 = 
(
(long)CINT(BgL_bpz00_12904)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10812),BgL_arg2091z00_12924,BgL_a1z00_12906); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2092z00_12925;
BgL_arg2092z00_12925 = 
(
(long)CINT(BgL_bpz00_12904)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10812),BgL_arg2092z00_12925,BgL_a2z00_12907); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2093z00_12926;obj_t BgL_arg2094z00_12927;
BgL_arg2093z00_12926 = 
(
(long)CINT(BgL_bpz00_12904)+((long)2)); 
BgL_arg2094z00_12927 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10812),BgL_arg2093z00_12926,BgL_arg2094z00_12927); } break;
default: 
BgL_case_else1185z00_12914:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2096z00_12915;
BgL_arg2096z00_12915 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12908), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10809, BgL_arg2096z00_12915, 
(int)(((long)2)), 
CINT(BgL_arityz00_12909)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1185z00_12914;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12928;
BgL_z12denvz12_12928 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12928, BgL_locz00_10809); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10812, BgL_bpz00_12904, BgL_sfz00_12911))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12910;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12929;
BgL_nsz00_12929 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2098z00_12930;
BgL_arg2098z00_12930 = 
(
(long)CINT(BgL_bpz00_12904)+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12929, ((long)2), BgL_sz00_10812, BgL_bpz00_12904, 
BINT(BgL_arg2098z00_12930)); } 
VECTOR_SET(BgL_nsz00_12929,((long)1),BgL_sz00_10812); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12928, BgL_nsz00_12929); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12931;
BgL_ez00_12931 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12931, BgL_sz00_10812); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12932;
BgL_____rz00_12932 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12910, BgL_nsz00_12929, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12931); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12928, BgL_sz00_10812); 
return BgL_____rz00_12932;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12905, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12933;
BgL_nbpz00_12933 = 
(
(long)CINT(BgL_bpz00_12904)+BgL_siza7eza7_10811); 
VECTOR_SET(
((obj_t)BgL_sz00_10812),((long)0),
BINT(BgL_nbpz00_12933)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17569;
BgL_tmpz00_17569 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17569, BgL_locz00_10809); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12934;
BgL_rz00_12934 = 
PROCEDURE_ENTRY(BgL_fz00_12905)(BgL_fz00_12905, BgL_a1z00_12906, BgL_a2z00_12907, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10812),((long)0),BgL_bpz00_12904); 
return BgL_rz00_12934;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10809, BgL_symbzd2funzd2_10810, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12905));} } } } } } } } 

}



/* &<@anonymous:2102> */
obj_t BGl_z62zc3z04anonymousza32102ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10813, obj_t BgL_sz00_10820)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10814;obj_t BgL_a1z00_10815;obj_t BgL_a2z00_10816;obj_t BgL_locz00_10817;obj_t BgL_symbzd2funzd2_10818;long BgL_siza7eza7_10819;
BgL_funz00_10814 = 
PROCEDURE_REF(BgL_envz00_10813, 
(int)(((long)0))); 
BgL_a1z00_10815 = 
PROCEDURE_REF(BgL_envz00_10813, 
(int)(((long)1))); 
BgL_a2z00_10816 = 
PROCEDURE_REF(BgL_envz00_10813, 
(int)(((long)2))); 
BgL_locz00_10817 = 
PROCEDURE_REF(BgL_envz00_10813, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10818 = 
PROCEDURE_REF(BgL_envz00_10813, 
(int)(((long)4))); 
BgL_siza7eza7_10819 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10813, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12935;
BgL_bpz00_12935 = 
VECTOR_REF(
((obj_t)BgL_sz00_10820),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12936;obj_t BgL_a1z00_12937;obj_t BgL_a2z00_12938;
BgL_fz00_12936 = 
PROCEDURE_ENTRY(BgL_funz00_10814)(BgL_funz00_10814, BgL_sz00_10820, BEOA); 
BgL_a1z00_12937 = 
PROCEDURE_ENTRY(BgL_a1z00_10815)(BgL_a1z00_10815, BgL_sz00_10820, BEOA); 
BgL_a2z00_12938 = 
PROCEDURE_ENTRY(BgL_a2z00_10816)(BgL_a2z00_10816, BgL_sz00_10820, BEOA); 
if(
PROCEDUREP(BgL_fz00_12936))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10817, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12936); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12939;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17612;
BgL_tmpz00_17612 = 
((obj_t)BgL_fz00_12936); 
BgL_ufz00_12939 = 
PROCEDURE_ATTR(BgL_tmpz00_17612); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5683z00_17615;
if(
STRUCTP(BgL_ufz00_12939))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5683z00_17615 = 
(
STRUCT_KEY(BgL_ufz00_12939)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5683z00_17615 = ((bool_t)0)
; } 
if(BgL_test5683z00_17615)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12940;obj_t BgL_runz00_12941;obj_t BgL_sfz00_12942;
BgL_arityz00_12940 = 
STRUCT_REF(BgL_ufz00_12939, 
(int)(((long)0))); 
BgL_runz00_12941 = 
STRUCT_REF(BgL_ufz00_12939, 
(int)(((long)1))); 
BgL_sfz00_12942 = 
STRUCT_REF(BgL_ufz00_12939, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_12940)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2106z00_12943;
BgL_arg2106z00_12943 = 
(
(long)CINT(BgL_bpz00_12935)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10820),BgL_arg2106z00_12943,BgL_a1z00_12937); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2107z00_12944;
BgL_arg2107z00_12944 = 
(
(long)CINT(BgL_bpz00_12935)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10820),BgL_arg2107z00_12944,BgL_a2z00_12938); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12940))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12940)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2109z00_12947;obj_t BgL_arg2110z00_12948;
BgL_arg2109z00_12947 = 
(
(long)CINT(BgL_bpz00_12935)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2111z00_12949;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2112z00_12950;
BgL_arg2112z00_12950 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12938, BNIL); 
BgL_list2111z00_12949 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12937, BgL_arg2112z00_12950); } 
BgL_arg2110z00_12948 = BgL_list2111z00_12949; } 
VECTOR_SET(
((obj_t)BgL_sz00_10820),BgL_arg2109z00_12947,BgL_arg2110z00_12948); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2113z00_12951;
BgL_arg2113z00_12951 = 
(
(long)CINT(BgL_bpz00_12935)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10820),BgL_arg2113z00_12951,BgL_a1z00_12937); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2114z00_12952;obj_t BgL_arg2115z00_12953;
BgL_arg2114z00_12952 = 
(
(long)CINT(BgL_bpz00_12935)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2116z00_12954;
BgL_list2116z00_12954 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12938, BNIL); 
BgL_arg2115z00_12953 = BgL_list2116z00_12954; } 
VECTOR_SET(
((obj_t)BgL_sz00_10820),BgL_arg2114z00_12952,BgL_arg2115z00_12953); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2117z00_12955;
BgL_arg2117z00_12955 = 
(
(long)CINT(BgL_bpz00_12935)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10820),BgL_arg2117z00_12955,BgL_a1z00_12937); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2118z00_12956;
BgL_arg2118z00_12956 = 
(
(long)CINT(BgL_bpz00_12935)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10820),BgL_arg2118z00_12956,BgL_a2z00_12938); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2119z00_12957;obj_t BgL_arg2120z00_12958;
BgL_arg2119z00_12957 = 
(
(long)CINT(BgL_bpz00_12935)+((long)2)); 
BgL_arg2120z00_12958 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10820),BgL_arg2119z00_12957,BgL_arg2120z00_12958); } break;
default: 
BgL_case_else1187z00_12945:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2122z00_12946;
BgL_arg2122z00_12946 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12939), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10817, BgL_arg2122z00_12946, 
(int)(((long)2)), 
CINT(BgL_arityz00_12940)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1187z00_12945;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12959;
BgL_z12denvz12_12959 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10820, BgL_bpz00_12935, BgL_sfz00_12942))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_12941;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12960;
BgL_nsz00_12960 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2124z00_12961;
BgL_arg2124z00_12961 = 
(
(long)CINT(BgL_bpz00_12935)+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12960, ((long)2), BgL_sz00_10820, BgL_bpz00_12935, 
BINT(BgL_arg2124z00_12961)); } 
VECTOR_SET(BgL_nsz00_12960,((long)1),BgL_sz00_10820); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12959, BgL_nsz00_12960); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12962;
BgL_ez00_12962 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12962, BgL_sz00_10820); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12963;
BgL_____rz00_12963 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12941, BgL_nsz00_12960, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12962); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12959, BgL_sz00_10820); 
return BgL_____rz00_12963;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12936, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12964;
BgL_nbpz00_12964 = 
(
(long)CINT(BgL_bpz00_12935)+BgL_siza7eza7_10819); 
VECTOR_SET(
((obj_t)BgL_sz00_10820),((long)0),
BINT(BgL_nbpz00_12964)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12965;
BgL_rz00_12965 = 
PROCEDURE_ENTRY(BgL_fz00_12936)(BgL_fz00_12936, BgL_a1z00_12937, BgL_a2z00_12938, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10820),((long)0),BgL_bpz00_12935); 
return BgL_rz00_12965;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10817, BgL_symbzd2funzd2_10818, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12936));} } } } } } } } 

}



/* &<@anonymous:2130> */
obj_t BGl_z62zc3z04anonymousza32130ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10821, obj_t BgL_sz00_10828)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10822;obj_t BgL_a1z00_10823;obj_t BgL_a2z00_10824;obj_t BgL_locz00_10825;obj_t BgL_symbzd2funzd2_10826;long BgL_siza7eza7_10827;
BgL_funz00_10822 = 
PROCEDURE_REF(BgL_envz00_10821, 
(int)(((long)0))); 
BgL_a1z00_10823 = 
PROCEDURE_REF(BgL_envz00_10821, 
(int)(((long)1))); 
BgL_a2z00_10824 = 
PROCEDURE_REF(BgL_envz00_10821, 
(int)(((long)2))); 
BgL_locz00_10825 = 
PROCEDURE_REF(BgL_envz00_10821, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10826 = 
PROCEDURE_REF(BgL_envz00_10821, 
(int)(((long)4))); 
BgL_siza7eza7_10827 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10821, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12966;
BgL_bpz00_12966 = 
VECTOR_REF(
((obj_t)BgL_sz00_10828),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12967;obj_t BgL_a1z00_12968;obj_t BgL_a2z00_12969;
BgL_fz00_12967 = 
PROCEDURE_ENTRY(BgL_funz00_10822)(BgL_funz00_10822, BgL_sz00_10828, BEOA); 
BgL_a1z00_12968 = 
PROCEDURE_ENTRY(BgL_a1z00_10823)(BgL_a1z00_10823, BgL_sz00_10828, BEOA); 
BgL_a2z00_12969 = 
PROCEDURE_ENTRY(BgL_a2z00_10824)(BgL_a2z00_10824, BgL_sz00_10828, BEOA); 
if(
PROCEDUREP(BgL_fz00_12967))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10825, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12967); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_12970;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17738;
BgL_tmpz00_17738 = 
((obj_t)BgL_fz00_12967); 
BgL_ufz00_12970 = 
PROCEDURE_ATTR(BgL_tmpz00_17738); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5690z00_17741;
if(
STRUCTP(BgL_ufz00_12970))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5690z00_17741 = 
(
STRUCT_KEY(BgL_ufz00_12970)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5690z00_17741 = ((bool_t)0)
; } 
if(BgL_test5690z00_17741)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_12971;obj_t BgL_runz00_12972;obj_t BgL_sfz00_12973;
BgL_arityz00_12971 = 
STRUCT_REF(BgL_ufz00_12970, 
(int)(((long)0))); 
BgL_runz00_12972 = 
STRUCT_REF(BgL_ufz00_12970, 
(int)(((long)1))); 
BgL_sfz00_12973 = 
STRUCT_REF(BgL_ufz00_12970, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_12974;
BgL_spz00_12974 = 
(
(long)CINT(BgL_bpz00_12966)+BgL_siza7eza7_10827); 
if(
(
(long)CINT(BgL_arityz00_12971)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2134z00_12975;
BgL_arg2134z00_12975 = 
(BgL_spz00_12974+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10828),BgL_arg2134z00_12975,BgL_a1z00_12968); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2135z00_12976;
BgL_arg2135z00_12976 = 
(BgL_spz00_12974+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10828),BgL_arg2135z00_12976,BgL_a2z00_12969); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_12971))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_12971)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2137z00_12979;obj_t BgL_arg2138z00_12980;
BgL_arg2137z00_12979 = 
(BgL_spz00_12974+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2139z00_12981;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2140z00_12982;
BgL_arg2140z00_12982 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12969, BNIL); 
BgL_list2139z00_12981 = 
MAKE_YOUNG_PAIR(BgL_a1z00_12968, BgL_arg2140z00_12982); } 
BgL_arg2138z00_12980 = BgL_list2139z00_12981; } 
VECTOR_SET(
((obj_t)BgL_sz00_10828),BgL_arg2137z00_12979,BgL_arg2138z00_12980); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2141z00_12983;
BgL_arg2141z00_12983 = 
(BgL_spz00_12974+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10828),BgL_arg2141z00_12983,BgL_a1z00_12968); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2142z00_12984;obj_t BgL_arg2143z00_12985;
BgL_arg2142z00_12984 = 
(BgL_spz00_12974+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2144z00_12986;
BgL_list2144z00_12986 = 
MAKE_YOUNG_PAIR(BgL_a2z00_12969, BNIL); 
BgL_arg2143z00_12985 = BgL_list2144z00_12986; } 
VECTOR_SET(
((obj_t)BgL_sz00_10828),BgL_arg2142z00_12984,BgL_arg2143z00_12985); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2145z00_12987;
BgL_arg2145z00_12987 = 
(BgL_spz00_12974+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10828),BgL_arg2145z00_12987,BgL_a1z00_12968); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2146z00_12988;
BgL_arg2146z00_12988 = 
(BgL_spz00_12974+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10828),BgL_arg2146z00_12988,BgL_a2z00_12969); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2147z00_12989;obj_t BgL_arg2148z00_12990;
BgL_arg2147z00_12989 = 
(BgL_spz00_12974+((long)2)); 
BgL_arg2148z00_12990 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10828),BgL_arg2147z00_12989,BgL_arg2148z00_12990); } break;
default: 
BgL_case_else1189z00_12977:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2150z00_12978;
BgL_arg2150z00_12978 = 
STRUCT_REF(
((obj_t)BgL_ufz00_12970), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10825, BgL_arg2150z00_12978, 
(int)(((long)2)), 
CINT(BgL_arityz00_12971)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1189z00_12977;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_12991;
BgL_z12denvz12_12991 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_12991, BgL_locz00_10825); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10828, 
BINT(BgL_spz00_12974), BgL_sfz00_12973))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12972, BgL_sz00_10828, 
BINT(BgL_spz00_12974));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_12992;
BgL_nsz00_12992 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2152z00_12993;
BgL_arg2152z00_12993 = 
(BgL_spz00_12974+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_12992, ((long)2), BgL_sz00_10828, 
BINT(BgL_spz00_12974), 
BINT(BgL_arg2152z00_12993)); } 
VECTOR_SET(BgL_nsz00_12992,((long)1),BgL_sz00_10828); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12991, BgL_nsz00_12992); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_12994;
BgL_ez00_12994 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_12994, BgL_sz00_10828); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_12995;
BgL_____rz00_12995 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12972, BgL_nsz00_12992, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_12994); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_12991, BgL_sz00_10828); 
return BgL_____rz00_12995;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12967, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_12996;
BgL_nbpz00_12996 = 
(
(long)CINT(BgL_bpz00_12966)+BgL_siza7eza7_10827); 
VECTOR_SET(
((obj_t)BgL_sz00_10828),((long)0),
BINT(BgL_nbpz00_12996)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17822;
BgL_tmpz00_17822 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_17822, BgL_locz00_10825); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_12997;
BgL_rz00_12997 = 
PROCEDURE_ENTRY(BgL_fz00_12967)(BgL_fz00_12967, BgL_a1z00_12968, BgL_a2z00_12969, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10828),((long)0),BgL_bpz00_12966); 
return BgL_rz00_12997;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10825, BgL_symbzd2funzd2_10826, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12967));} } } } } } } } 

}



/* &<@anonymous:2156> */
obj_t BGl_z62zc3z04anonymousza32156ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10829, obj_t BgL_sz00_10836)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10830;obj_t BgL_a1z00_10831;obj_t BgL_a2z00_10832;obj_t BgL_locz00_10833;obj_t BgL_symbzd2funzd2_10834;long BgL_siza7eza7_10835;
BgL_funz00_10830 = 
PROCEDURE_REF(BgL_envz00_10829, 
(int)(((long)0))); 
BgL_a1z00_10831 = 
PROCEDURE_REF(BgL_envz00_10829, 
(int)(((long)1))); 
BgL_a2z00_10832 = 
PROCEDURE_REF(BgL_envz00_10829, 
(int)(((long)2))); 
BgL_locz00_10833 = 
PROCEDURE_REF(BgL_envz00_10829, 
(int)(((long)3))); 
BgL_symbzd2funzd2_10834 = 
PROCEDURE_REF(BgL_envz00_10829, 
(int)(((long)4))); 
BgL_siza7eza7_10835 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10829, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_12998;
BgL_bpz00_12998 = 
VECTOR_REF(
((obj_t)BgL_sz00_10836),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_12999;obj_t BgL_a1z00_13000;obj_t BgL_a2z00_13001;
BgL_fz00_12999 = 
PROCEDURE_ENTRY(BgL_funz00_10830)(BgL_funz00_10830, BgL_sz00_10836, BEOA); 
BgL_a1z00_13000 = 
PROCEDURE_ENTRY(BgL_a1z00_10831)(BgL_a1z00_10831, BgL_sz00_10836, BEOA); 
BgL_a2z00_13001 = 
PROCEDURE_ENTRY(BgL_a2z00_10832)(BgL_a2z00_10832, BgL_sz00_10836, BEOA); 
if(
PROCEDUREP(BgL_fz00_12999))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10833, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_12999); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13002;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_17865;
BgL_tmpz00_17865 = 
((obj_t)BgL_fz00_12999); 
BgL_ufz00_13002 = 
PROCEDURE_ATTR(BgL_tmpz00_17865); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5697z00_17868;
if(
STRUCTP(BgL_ufz00_13002))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5697z00_17868 = 
(
STRUCT_KEY(BgL_ufz00_13002)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5697z00_17868 = ((bool_t)0)
; } 
if(BgL_test5697z00_17868)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13003;obj_t BgL_runz00_13004;obj_t BgL_sfz00_13005;
BgL_arityz00_13003 = 
STRUCT_REF(BgL_ufz00_13002, 
(int)(((long)0))); 
BgL_runz00_13004 = 
STRUCT_REF(BgL_ufz00_13002, 
(int)(((long)1))); 
BgL_sfz00_13005 = 
STRUCT_REF(BgL_ufz00_13002, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13006;
BgL_spz00_13006 = 
(
(long)CINT(BgL_bpz00_12998)+BgL_siza7eza7_10835); 
if(
(
(long)CINT(BgL_arityz00_13003)==((long)2)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2160z00_13007;
BgL_arg2160z00_13007 = 
(BgL_spz00_13006+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10836),BgL_arg2160z00_13007,BgL_a1z00_13000); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2161z00_13008;
BgL_arg2161z00_13008 = 
(BgL_spz00_13006+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10836),BgL_arg2161z00_13008,BgL_a2z00_13001); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13003))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13003)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2163z00_13011;obj_t BgL_arg2164z00_13012;
BgL_arg2163z00_13011 = 
(BgL_spz00_13006+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2165z00_13013;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2166z00_13014;
BgL_arg2166z00_13014 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13001, BNIL); 
BgL_list2165z00_13013 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13000, BgL_arg2166z00_13014); } 
BgL_arg2164z00_13012 = BgL_list2165z00_13013; } 
VECTOR_SET(
((obj_t)BgL_sz00_10836),BgL_arg2163z00_13011,BgL_arg2164z00_13012); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2167z00_13015;
BgL_arg2167z00_13015 = 
(BgL_spz00_13006+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10836),BgL_arg2167z00_13015,BgL_a1z00_13000); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2168z00_13016;obj_t BgL_arg2169z00_13017;
BgL_arg2168z00_13016 = 
(BgL_spz00_13006+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2170z00_13018;
BgL_list2170z00_13018 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13001, BNIL); 
BgL_arg2169z00_13017 = BgL_list2170z00_13018; } 
VECTOR_SET(
((obj_t)BgL_sz00_10836),BgL_arg2168z00_13016,BgL_arg2169z00_13017); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2171z00_13019;
BgL_arg2171z00_13019 = 
(BgL_spz00_13006+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10836),BgL_arg2171z00_13019,BgL_a1z00_13000); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2172z00_13020;
BgL_arg2172z00_13020 = 
(BgL_spz00_13006+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10836),BgL_arg2172z00_13020,BgL_a2z00_13001); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2173z00_13021;obj_t BgL_arg2174z00_13022;
BgL_arg2173z00_13021 = 
(BgL_spz00_13006+((long)2)); 
BgL_arg2174z00_13022 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10836),BgL_arg2173z00_13021,BgL_arg2174z00_13022); } break;
default: 
BgL_case_else1191z00_13009:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2176z00_13010;
BgL_arg2176z00_13010 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13002), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10833, BgL_arg2176z00_13010, 
(int)(((long)2)), 
CINT(BgL_arityz00_13003)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1191z00_13009;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13023;
BgL_z12denvz12_13023 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10836, 
BINT(BgL_spz00_13006), BgL_sfz00_13005))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13004, BgL_sz00_10836, 
BINT(BgL_spz00_13006));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13024;
BgL_nsz00_13024 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2178z00_13025;
BgL_arg2178z00_13025 = 
(BgL_spz00_13006+((long)2)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13024, ((long)2), BgL_sz00_10836, 
BINT(BgL_spz00_13006), 
BINT(BgL_arg2178z00_13025)); } 
VECTOR_SET(BgL_nsz00_13024,((long)1),BgL_sz00_10836); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13023, BgL_nsz00_13024); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13026;
BgL_ez00_13026 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13026, BgL_sz00_10836); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13027;
BgL_____rz00_13027 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13004, BgL_nsz00_13024, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13026); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13023, BgL_sz00_10836); 
return BgL_____rz00_13027;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_12999, 
(int)(((long)2))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13028;
BgL_nbpz00_13028 = 
(
(long)CINT(BgL_bpz00_12998)+BgL_siza7eza7_10835); 
VECTOR_SET(
((obj_t)BgL_sz00_10836),((long)0),
BINT(BgL_nbpz00_13028)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13029;
BgL_rz00_13029 = 
PROCEDURE_ENTRY(BgL_fz00_12999)(BgL_fz00_12999, BgL_a1z00_13000, BgL_a2z00_13001, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10836),((long)0),BgL_bpz00_12998); 
return BgL_rz00_13029;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10833, BgL_symbzd2funzd2_10834, 
(int)(((long)2)), 
PROCEDURE_ARITY(BgL_fz00_12999));} } } } } } } } 

}



/* comp-call3 */
obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162, BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164, obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167, long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170, obj_t BgL_a3z00_171)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2491;
BgL_cfunz00_2491 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163, ((long)3), BgL_locz00_162, BgL_symbzd2funzd2_164); 
if(
CBOOL(BgL_cfunz00_2491))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5704z00_17961;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2187z00_2511;
BgL_arg2187z00_2511 = 
bgl_debug(); 
BgL_test5704z00_17961 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2187z00_2511), 
BINT(((long)0))); } 
if(BgL_test5704z00_17961)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32184ze3z87_10837;
BgL_zc3z04anonymousza32184ze3z87_10837 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32184ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_10837, 
(int)(((long)0)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_10837, 
(int)(((long)1)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_10837, 
(int)(((long)2)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_10837, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_168)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_10837, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32184ze3z87_10837, 
(int)(((long)5)), BgL_cfunz00_2491); 
return BgL_zc3z04anonymousza32184ze3z87_10837;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32186ze3z87_10838;
BgL_zc3z04anonymousza32186ze3z87_10838 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_10838, 
(int)(((long)0)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_10838, 
(int)(((long)1)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_10838, 
(int)(((long)2)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_10838, 
(int)(((long)3)), 
BINT(BgL_siza7eza7_168)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32186ze3z87_10838, 
(int)(((long)4)), BgL_cfunz00_2491); 
return BgL_zc3z04anonymousza32186ze3z87_10838;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_166))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5706z00_17998;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2259z00_2623;
BgL_arg2259z00_2623 = 
bgl_debug(); 
BgL_test5706z00_17998 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2259z00_2623), 
BINT(((long)0))); } 
if(BgL_test5706z00_17998)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32190ze3z87_10839;
BgL_zc3z04anonymousza32190ze3z87_10839 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32190ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32190ze3z87_10839, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32190ze3z87_10839, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32190ze3z87_10839, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32190ze3z87_10839, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32190ze3z87_10839, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32190ze3z87_10839, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32190ze3z87_10839, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32190ze3z87_10839;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32225ze3z87_10840;
BgL_zc3z04anonymousza32225ze3z87_10840 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32225ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32225ze3z87_10840, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32225ze3z87_10840, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32225ze3z87_10840, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32225ze3z87_10840, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32225ze3z87_10840, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32225ze3z87_10840, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32225ze3z87_10840, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32225ze3z87_10840;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5707z00_18039;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2331z00_2735;
BgL_arg2331z00_2735 = 
bgl_debug(); 
BgL_test5707z00_18039 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2331z00_2735), 
BINT(((long)0))); } 
if(BgL_test5707z00_18039)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32262ze3z87_10841;
BgL_zc3z04anonymousza32262ze3z87_10841 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32262ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32262ze3z87_10841, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32262ze3z87_10841, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32262ze3z87_10841, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32262ze3z87_10841, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32262ze3z87_10841, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32262ze3z87_10841, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32262ze3z87_10841, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32262ze3z87_10841;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32297ze3z87_10842;
BgL_zc3z04anonymousza32297ze3z87_10842 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32297ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32297ze3z87_10842, 
(int)(((long)0)), BgL_funz00_165); 
PROCEDURE_SET(BgL_zc3z04anonymousza32297ze3z87_10842, 
(int)(((long)1)), BgL_a1z00_169); 
PROCEDURE_SET(BgL_zc3z04anonymousza32297ze3z87_10842, 
(int)(((long)2)), BgL_a2z00_170); 
PROCEDURE_SET(BgL_zc3z04anonymousza32297ze3z87_10842, 
(int)(((long)3)), BgL_a3z00_171); 
PROCEDURE_SET(BgL_zc3z04anonymousza32297ze3z87_10842, 
(int)(((long)4)), BgL_locz00_162); 
PROCEDURE_SET(BgL_zc3z04anonymousza32297ze3z87_10842, 
(int)(((long)5)), BgL_symbzd2funzd2_164); 
PROCEDURE_SET(BgL_zc3z04anonymousza32297ze3z87_10842, 
(int)(((long)6)), 
BINT(BgL_siza7eza7_168)); 
return BgL_zc3z04anonymousza32297ze3z87_10842;} } } } } 

}



/* &<@anonymous:2184> */
obj_t BGl_z62zc3z04anonymousza32184ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10843, obj_t BgL_sz00_10850)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10844;obj_t BgL_a2z00_10845;obj_t BgL_a3z00_10846;long BgL_siza7eza7_10847;obj_t BgL_locz00_10848;obj_t BgL_cfunz00_10849;
BgL_a1z00_10844 = 
PROCEDURE_REF(BgL_envz00_10843, 
(int)(((long)0))); 
BgL_a2z00_10845 = 
PROCEDURE_REF(BgL_envz00_10843, 
(int)(((long)1))); 
BgL_a3z00_10846 = 
PROCEDURE_REF(BgL_envz00_10843, 
(int)(((long)2))); 
BgL_siza7eza7_10847 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10843, 
(int)(((long)3)))); 
BgL_locz00_10848 = 
PROCEDURE_REF(BgL_envz00_10843, 
(int)(((long)4))); 
BgL_cfunz00_10849 = 
PROCEDURE_REF(BgL_envz00_10843, 
(int)(((long)5))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13030;
BgL_bpz00_13030 = 
VECTOR_REF(
((obj_t)BgL_sz00_10850),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_13031;obj_t BgL_a2z00_13032;obj_t BgL_a3z00_13033;
BgL_a1z00_13031 = 
PROCEDURE_ENTRY(BgL_a1z00_10844)(BgL_a1z00_10844, BgL_sz00_10850, BEOA); 
BgL_a2z00_13032 = 
PROCEDURE_ENTRY(BgL_a2z00_10845)(BgL_a2z00_10845, BgL_sz00_10850, BEOA); 
BgL_a3z00_13033 = 
PROCEDURE_ENTRY(BgL_a3z00_10846)(BgL_a3z00_10846, BgL_sz00_10850, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13034;
BgL_nbpz00_13034 = 
(
(long)CINT(BgL_bpz00_13030)+BgL_siza7eza7_10847); 
VECTOR_SET(
((obj_t)BgL_sz00_10850),((long)0),
BINT(BgL_nbpz00_13034)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18112;
BgL_tmpz00_18112 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18112, BgL_locz00_10848); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13035;
BgL_rz00_13035 = 
PROCEDURE_ENTRY(BgL_cfunz00_10849)(BgL_cfunz00_10849, BgL_a1z00_13031, BgL_a2z00_13032, BgL_a3z00_13033, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10850),((long)0),BgL_bpz00_13030); 
return BgL_rz00_13035;} } } } } } 

}



/* &<@anonymous:2186> */
obj_t BGl_z62zc3z04anonymousza32186ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10851, obj_t BgL_sz00_10857)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10852;obj_t BgL_a2z00_10853;obj_t BgL_a3z00_10854;long BgL_siza7eza7_10855;obj_t BgL_cfunz00_10856;
BgL_a1z00_10852 = 
PROCEDURE_REF(BgL_envz00_10851, 
(int)(((long)0))); 
BgL_a2z00_10853 = 
PROCEDURE_REF(BgL_envz00_10851, 
(int)(((long)1))); 
BgL_a3z00_10854 = 
PROCEDURE_REF(BgL_envz00_10851, 
(int)(((long)2))); 
BgL_siza7eza7_10855 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10851, 
(int)(((long)3)))); 
BgL_cfunz00_10856 = 
PROCEDURE_REF(BgL_envz00_10851, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13036;
BgL_bpz00_13036 = 
VECTOR_REF(
((obj_t)BgL_sz00_10857),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_13037;obj_t BgL_a2z00_13038;obj_t BgL_a3z00_13039;
BgL_a1z00_13037 = 
PROCEDURE_ENTRY(BgL_a1z00_10852)(BgL_a1z00_10852, BgL_sz00_10857, BEOA); 
BgL_a2z00_13038 = 
PROCEDURE_ENTRY(BgL_a2z00_10853)(BgL_a2z00_10853, BgL_sz00_10857, BEOA); 
BgL_a3z00_13039 = 
PROCEDURE_ENTRY(BgL_a3z00_10854)(BgL_a3z00_10854, BgL_sz00_10857, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13040;
BgL_nbpz00_13040 = 
(
(long)CINT(BgL_bpz00_13036)+BgL_siza7eza7_10855); 
VECTOR_SET(
((obj_t)BgL_sz00_10857),((long)0),
BINT(BgL_nbpz00_13040)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13041;
BgL_rz00_13041 = 
PROCEDURE_ENTRY(BgL_cfunz00_10856)(BgL_cfunz00_10856, BgL_a1z00_13037, BgL_a2z00_13038, BgL_a3z00_13039, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10857),((long)0),BgL_bpz00_13036); 
return BgL_rz00_13041;} } } } } } 

}



/* &<@anonymous:2190> */
obj_t BGl_z62zc3z04anonymousza32190ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10858, obj_t BgL_sz00_10866)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10859;obj_t BgL_a1z00_10860;obj_t BgL_a2z00_10861;obj_t BgL_a3z00_10862;obj_t BgL_locz00_10863;obj_t BgL_symbzd2funzd2_10864;long BgL_siza7eza7_10865;
BgL_funz00_10859 = 
PROCEDURE_REF(BgL_envz00_10858, 
(int)(((long)0))); 
BgL_a1z00_10860 = 
PROCEDURE_REF(BgL_envz00_10858, 
(int)(((long)1))); 
BgL_a2z00_10861 = 
PROCEDURE_REF(BgL_envz00_10858, 
(int)(((long)2))); 
BgL_a3z00_10862 = 
PROCEDURE_REF(BgL_envz00_10858, 
(int)(((long)3))); 
BgL_locz00_10863 = 
PROCEDURE_REF(BgL_envz00_10858, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10864 = 
PROCEDURE_REF(BgL_envz00_10858, 
(int)(((long)5))); 
BgL_siza7eza7_10865 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10858, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13042;
BgL_bpz00_13042 = 
VECTOR_REF(
((obj_t)BgL_sz00_10866),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13043;obj_t BgL_a1z00_13044;obj_t BgL_a2z00_13045;obj_t BgL_a3z00_13046;
BgL_fz00_13043 = 
PROCEDURE_ENTRY(BgL_funz00_10859)(BgL_funz00_10859, BgL_sz00_10866, BEOA); 
BgL_a1z00_13044 = 
PROCEDURE_ENTRY(BgL_a1z00_10860)(BgL_a1z00_10860, BgL_sz00_10866, BEOA); 
BgL_a2z00_13045 = 
PROCEDURE_ENTRY(BgL_a2z00_10861)(BgL_a2z00_10861, BgL_sz00_10866, BEOA); 
BgL_a3z00_13046 = 
PROCEDURE_ENTRY(BgL_a3z00_10862)(BgL_a3z00_10862, BgL_sz00_10866, BEOA); 
if(
PROCEDUREP(BgL_fz00_13043))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10863, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_13043); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13047;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18197;
BgL_tmpz00_18197 = 
((obj_t)BgL_fz00_13043); 
BgL_ufz00_13047 = 
PROCEDURE_ATTR(BgL_tmpz00_18197); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5709z00_18200;
if(
STRUCTP(BgL_ufz00_13047))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5709z00_18200 = 
(
STRUCT_KEY(BgL_ufz00_13047)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5709z00_18200 = ((bool_t)0)
; } 
if(BgL_test5709z00_18200)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13048;obj_t BgL_runz00_13049;obj_t BgL_sfz00_13050;
BgL_arityz00_13048 = 
STRUCT_REF(BgL_ufz00_13047, 
(int)(((long)0))); 
BgL_runz00_13049 = 
STRUCT_REF(BgL_ufz00_13047, 
(int)(((long)1))); 
BgL_sfz00_13050 = 
STRUCT_REF(BgL_ufz00_13047, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13048)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2194z00_13051;
BgL_arg2194z00_13051 = 
(
(long)CINT(BgL_bpz00_13042)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2194z00_13051,BgL_a1z00_13044); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2195z00_13052;
BgL_arg2195z00_13052 = 
(
(long)CINT(BgL_bpz00_13042)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2195z00_13052,BgL_a2z00_13045); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2196z00_13053;
BgL_arg2196z00_13053 = 
(
(long)CINT(BgL_bpz00_13042)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2196z00_13053,BgL_a3z00_13046); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13048))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13048)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2198z00_13056;obj_t BgL_arg2199z00_13057;
BgL_arg2198z00_13056 = 
(
(long)CINT(BgL_bpz00_13042)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2200z00_13058;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2201z00_13059;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2202z00_13060;
BgL_arg2202z00_13060 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13046, BNIL); 
BgL_arg2201z00_13059 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13045, BgL_arg2202z00_13060); } 
BgL_list2200z00_13058 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13044, BgL_arg2201z00_13059); } 
BgL_arg2199z00_13057 = BgL_list2200z00_13058; } 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2198z00_13056,BgL_arg2199z00_13057); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2203z00_13061;
BgL_arg2203z00_13061 = 
(
(long)CINT(BgL_bpz00_13042)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2203z00_13061,BgL_a1z00_13044); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2204z00_13062;obj_t BgL_arg2205z00_13063;
BgL_arg2204z00_13062 = 
(
(long)CINT(BgL_bpz00_13042)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2206z00_13064;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2207z00_13065;
BgL_arg2207z00_13065 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13046, BNIL); 
BgL_list2206z00_13064 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13045, BgL_arg2207z00_13065); } 
BgL_arg2205z00_13063 = BgL_list2206z00_13064; } 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2204z00_13062,BgL_arg2205z00_13063); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2208z00_13066;
BgL_arg2208z00_13066 = 
(
(long)CINT(BgL_bpz00_13042)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2208z00_13066,BgL_a1z00_13044); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2209z00_13067;
BgL_arg2209z00_13067 = 
(
(long)CINT(BgL_bpz00_13042)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2209z00_13067,BgL_a2z00_13045); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2210z00_13068;obj_t BgL_arg2211z00_13069;
BgL_arg2210z00_13068 = 
(
(long)CINT(BgL_bpz00_13042)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2212z00_13070;
BgL_list2212z00_13070 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13046, BNIL); 
BgL_arg2211z00_13069 = BgL_list2212z00_13070; } 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2210z00_13068,BgL_arg2211z00_13069); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2213z00_13071;
BgL_arg2213z00_13071 = 
(
(long)CINT(BgL_bpz00_13042)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2213z00_13071,BgL_a1z00_13044); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2214z00_13072;
BgL_arg2214z00_13072 = 
(
(long)CINT(BgL_bpz00_13042)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2214z00_13072,BgL_a2z00_13045); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2215z00_13073;
BgL_arg2215z00_13073 = 
(
(long)CINT(BgL_bpz00_13042)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2215z00_13073,BgL_a3z00_13046); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2216z00_13074;obj_t BgL_arg2217z00_13075;
BgL_arg2216z00_13074 = 
(
(long)CINT(BgL_bpz00_13042)+((long)3)); 
BgL_arg2217z00_13075 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10866),BgL_arg2216z00_13074,BgL_arg2217z00_13075); } break;
default: 
BgL_case_else1193z00_13054:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2219z00_13055;
BgL_arg2219z00_13055 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13047), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10863, BgL_arg2219z00_13055, 
(int)(((long)3)), 
CINT(BgL_arityz00_13048)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1193z00_13054;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13076;
BgL_z12denvz12_13076 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13076, BgL_locz00_10863); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10866, BgL_bpz00_13042, BgL_sfz00_13050))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_13049;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13077;
BgL_nsz00_13077 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2221z00_13078;
BgL_arg2221z00_13078 = 
(
(long)CINT(BgL_bpz00_13042)+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13077, ((long)2), BgL_sz00_10866, BgL_bpz00_13042, 
BINT(BgL_arg2221z00_13078)); } 
VECTOR_SET(BgL_nsz00_13077,((long)1),BgL_sz00_10866); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13076, BgL_nsz00_13077); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13079;
BgL_ez00_13079 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13079, BgL_sz00_10866); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13080;
BgL_____rz00_13080 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13049, BgL_nsz00_13077, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13079); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13076, BgL_sz00_10866); 
return BgL_____rz00_13080;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13043, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13081;
BgL_nbpz00_13081 = 
(
(long)CINT(BgL_bpz00_13042)+BgL_siza7eza7_10865); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),((long)0),
BINT(BgL_nbpz00_13081)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18307;
BgL_tmpz00_18307 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18307, BgL_locz00_10863); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13082;
BgL_rz00_13082 = 
PROCEDURE_ENTRY(BgL_fz00_13043)(BgL_fz00_13043, BgL_a1z00_13044, BgL_a2z00_13045, BgL_a3z00_13046, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10866),((long)0),BgL_bpz00_13042); 
return BgL_rz00_13082;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10863, BgL_symbzd2funzd2_10864, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13043));} } } } } } } } 

}



/* &<@anonymous:2225> */
obj_t BGl_z62zc3z04anonymousza32225ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10867, obj_t BgL_sz00_10875)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10868;obj_t BgL_a1z00_10869;obj_t BgL_a2z00_10870;obj_t BgL_a3z00_10871;obj_t BgL_locz00_10872;obj_t BgL_symbzd2funzd2_10873;long BgL_siza7eza7_10874;
BgL_funz00_10868 = 
PROCEDURE_REF(BgL_envz00_10867, 
(int)(((long)0))); 
BgL_a1z00_10869 = 
PROCEDURE_REF(BgL_envz00_10867, 
(int)(((long)1))); 
BgL_a2z00_10870 = 
PROCEDURE_REF(BgL_envz00_10867, 
(int)(((long)2))); 
BgL_a3z00_10871 = 
PROCEDURE_REF(BgL_envz00_10867, 
(int)(((long)3))); 
BgL_locz00_10872 = 
PROCEDURE_REF(BgL_envz00_10867, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10873 = 
PROCEDURE_REF(BgL_envz00_10867, 
(int)(((long)5))); 
BgL_siza7eza7_10874 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10867, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13083;
BgL_bpz00_13083 = 
VECTOR_REF(
((obj_t)BgL_sz00_10875),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13084;obj_t BgL_a1z00_13085;obj_t BgL_a2z00_13086;obj_t BgL_a3z00_13087;
BgL_fz00_13084 = 
PROCEDURE_ENTRY(BgL_funz00_10868)(BgL_funz00_10868, BgL_sz00_10875, BEOA); 
BgL_a1z00_13085 = 
PROCEDURE_ENTRY(BgL_a1z00_10869)(BgL_a1z00_10869, BgL_sz00_10875, BEOA); 
BgL_a2z00_13086 = 
PROCEDURE_ENTRY(BgL_a2z00_10870)(BgL_a2z00_10870, BgL_sz00_10875, BEOA); 
BgL_a3z00_13087 = 
PROCEDURE_ENTRY(BgL_a3z00_10871)(BgL_a3z00_10871, BgL_sz00_10875, BEOA); 
if(
PROCEDUREP(BgL_fz00_13084))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10872, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_13084); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13088;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18357;
BgL_tmpz00_18357 = 
((obj_t)BgL_fz00_13084); 
BgL_ufz00_13088 = 
PROCEDURE_ATTR(BgL_tmpz00_18357); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5716z00_18360;
if(
STRUCTP(BgL_ufz00_13088))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5716z00_18360 = 
(
STRUCT_KEY(BgL_ufz00_13088)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5716z00_18360 = ((bool_t)0)
; } 
if(BgL_test5716z00_18360)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13089;obj_t BgL_runz00_13090;obj_t BgL_sfz00_13091;
BgL_arityz00_13089 = 
STRUCT_REF(BgL_ufz00_13088, 
(int)(((long)0))); 
BgL_runz00_13090 = 
STRUCT_REF(BgL_ufz00_13088, 
(int)(((long)1))); 
BgL_sfz00_13091 = 
STRUCT_REF(BgL_ufz00_13088, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13089)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2229z00_13092;
BgL_arg2229z00_13092 = 
(
(long)CINT(BgL_bpz00_13083)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2229z00_13092,BgL_a1z00_13085); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2230z00_13093;
BgL_arg2230z00_13093 = 
(
(long)CINT(BgL_bpz00_13083)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2230z00_13093,BgL_a2z00_13086); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2231z00_13094;
BgL_arg2231z00_13094 = 
(
(long)CINT(BgL_bpz00_13083)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2231z00_13094,BgL_a3z00_13087); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13089))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13089)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2233z00_13097;obj_t BgL_arg2234z00_13098;
BgL_arg2233z00_13097 = 
(
(long)CINT(BgL_bpz00_13083)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2235z00_13099;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2236z00_13100;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2237z00_13101;
BgL_arg2237z00_13101 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13087, BNIL); 
BgL_arg2236z00_13100 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13086, BgL_arg2237z00_13101); } 
BgL_list2235z00_13099 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13085, BgL_arg2236z00_13100); } 
BgL_arg2234z00_13098 = BgL_list2235z00_13099; } 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2233z00_13097,BgL_arg2234z00_13098); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2238z00_13102;
BgL_arg2238z00_13102 = 
(
(long)CINT(BgL_bpz00_13083)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2238z00_13102,BgL_a1z00_13085); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2239z00_13103;obj_t BgL_arg2240z00_13104;
BgL_arg2239z00_13103 = 
(
(long)CINT(BgL_bpz00_13083)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2241z00_13105;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2242z00_13106;
BgL_arg2242z00_13106 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13087, BNIL); 
BgL_list2241z00_13105 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13086, BgL_arg2242z00_13106); } 
BgL_arg2240z00_13104 = BgL_list2241z00_13105; } 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2239z00_13103,BgL_arg2240z00_13104); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2243z00_13107;
BgL_arg2243z00_13107 = 
(
(long)CINT(BgL_bpz00_13083)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2243z00_13107,BgL_a1z00_13085); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2244z00_13108;
BgL_arg2244z00_13108 = 
(
(long)CINT(BgL_bpz00_13083)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2244z00_13108,BgL_a2z00_13086); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2245z00_13109;obj_t BgL_arg2246z00_13110;
BgL_arg2245z00_13109 = 
(
(long)CINT(BgL_bpz00_13083)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2247z00_13111;
BgL_list2247z00_13111 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13087, BNIL); 
BgL_arg2246z00_13110 = BgL_list2247z00_13111; } 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2245z00_13109,BgL_arg2246z00_13110); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2248z00_13112;
BgL_arg2248z00_13112 = 
(
(long)CINT(BgL_bpz00_13083)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2248z00_13112,BgL_a1z00_13085); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2249z00_13113;
BgL_arg2249z00_13113 = 
(
(long)CINT(BgL_bpz00_13083)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2249z00_13113,BgL_a2z00_13086); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2250z00_13114;
BgL_arg2250z00_13114 = 
(
(long)CINT(BgL_bpz00_13083)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2250z00_13114,BgL_a3z00_13087); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2251z00_13115;obj_t BgL_arg2252z00_13116;
BgL_arg2251z00_13115 = 
(
(long)CINT(BgL_bpz00_13083)+((long)3)); 
BgL_arg2252z00_13116 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10875),BgL_arg2251z00_13115,BgL_arg2252z00_13116); } break;
default: 
BgL_case_else1195z00_13095:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2254z00_13096;
BgL_arg2254z00_13096 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13088), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10872, BgL_arg2254z00_13096, 
(int)(((long)3)), 
CINT(BgL_arityz00_13089)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1195z00_13095;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13117;
BgL_z12denvz12_13117 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10875, BgL_bpz00_13083, BgL_sfz00_13091))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_13090;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13118;
BgL_nsz00_13118 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2256z00_13119;
BgL_arg2256z00_13119 = 
(
(long)CINT(BgL_bpz00_13083)+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13118, ((long)2), BgL_sz00_10875, BgL_bpz00_13083, 
BINT(BgL_arg2256z00_13119)); } 
VECTOR_SET(BgL_nsz00_13118,((long)1),BgL_sz00_10875); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13117, BgL_nsz00_13118); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13120;
BgL_ez00_13120 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13120, BgL_sz00_10875); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13121;
BgL_____rz00_13121 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13090, BgL_nsz00_13118, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13120); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13117, BgL_sz00_10875); 
return BgL_____rz00_13121;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13084, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13122;
BgL_nbpz00_13122 = 
(
(long)CINT(BgL_bpz00_13083)+BgL_siza7eza7_10874); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),((long)0),
BINT(BgL_nbpz00_13122)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13123;
BgL_rz00_13123 = 
PROCEDURE_ENTRY(BgL_fz00_13084)(BgL_fz00_13084, BgL_a1z00_13085, BgL_a2z00_13086, BgL_a3z00_13087, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10875),((long)0),BgL_bpz00_13083); 
return BgL_rz00_13123;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10872, BgL_symbzd2funzd2_10873, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13084));} } } } } } } } 

}



/* &<@anonymous:2262> */
obj_t BGl_z62zc3z04anonymousza32262ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10876, obj_t BgL_sz00_10884)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10877;obj_t BgL_a1z00_10878;obj_t BgL_a2z00_10879;obj_t BgL_a3z00_10880;obj_t BgL_locz00_10881;obj_t BgL_symbzd2funzd2_10882;long BgL_siza7eza7_10883;
BgL_funz00_10877 = 
PROCEDURE_REF(BgL_envz00_10876, 
(int)(((long)0))); 
BgL_a1z00_10878 = 
PROCEDURE_REF(BgL_envz00_10876, 
(int)(((long)1))); 
BgL_a2z00_10879 = 
PROCEDURE_REF(BgL_envz00_10876, 
(int)(((long)2))); 
BgL_a3z00_10880 = 
PROCEDURE_REF(BgL_envz00_10876, 
(int)(((long)3))); 
BgL_locz00_10881 = 
PROCEDURE_REF(BgL_envz00_10876, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10882 = 
PROCEDURE_REF(BgL_envz00_10876, 
(int)(((long)5))); 
BgL_siza7eza7_10883 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10876, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13124;
BgL_bpz00_13124 = 
VECTOR_REF(
((obj_t)BgL_sz00_10884),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13125;obj_t BgL_a1z00_13126;obj_t BgL_a2z00_13127;obj_t BgL_a3z00_13128;
BgL_fz00_13125 = 
PROCEDURE_ENTRY(BgL_funz00_10877)(BgL_funz00_10877, BgL_sz00_10884, BEOA); 
BgL_a1z00_13126 = 
PROCEDURE_ENTRY(BgL_a1z00_10878)(BgL_a1z00_10878, BgL_sz00_10884, BEOA); 
BgL_a2z00_13127 = 
PROCEDURE_ENTRY(BgL_a2z00_10879)(BgL_a2z00_10879, BgL_sz00_10884, BEOA); 
BgL_a3z00_13128 = 
PROCEDURE_ENTRY(BgL_a3z00_10880)(BgL_a3z00_10880, BgL_sz00_10884, BEOA); 
if(
PROCEDUREP(BgL_fz00_13125))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10881, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_13125); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13129;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18513;
BgL_tmpz00_18513 = 
((obj_t)BgL_fz00_13125); 
BgL_ufz00_13129 = 
PROCEDURE_ATTR(BgL_tmpz00_18513); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5723z00_18516;
if(
STRUCTP(BgL_ufz00_13129))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5723z00_18516 = 
(
STRUCT_KEY(BgL_ufz00_13129)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5723z00_18516 = ((bool_t)0)
; } 
if(BgL_test5723z00_18516)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13130;obj_t BgL_runz00_13131;obj_t BgL_sfz00_13132;
BgL_arityz00_13130 = 
STRUCT_REF(BgL_ufz00_13129, 
(int)(((long)0))); 
BgL_runz00_13131 = 
STRUCT_REF(BgL_ufz00_13129, 
(int)(((long)1))); 
BgL_sfz00_13132 = 
STRUCT_REF(BgL_ufz00_13129, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13133;
BgL_spz00_13133 = 
(
(long)CINT(BgL_bpz00_13124)+BgL_siza7eza7_10883); 
if(
(
(long)CINT(BgL_arityz00_13130)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2266z00_13134;
BgL_arg2266z00_13134 = 
(BgL_spz00_13133+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2266z00_13134,BgL_a1z00_13126); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2267z00_13135;
BgL_arg2267z00_13135 = 
(BgL_spz00_13133+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2267z00_13135,BgL_a2z00_13127); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2268z00_13136;
BgL_arg2268z00_13136 = 
(BgL_spz00_13133+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2268z00_13136,BgL_a3z00_13128); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13130))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13130)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2270z00_13139;obj_t BgL_arg2271z00_13140;
BgL_arg2270z00_13139 = 
(BgL_spz00_13133+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2272z00_13141;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2273z00_13142;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2274z00_13143;
BgL_arg2274z00_13143 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13128, BNIL); 
BgL_arg2273z00_13142 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13127, BgL_arg2274z00_13143); } 
BgL_list2272z00_13141 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13126, BgL_arg2273z00_13142); } 
BgL_arg2271z00_13140 = BgL_list2272z00_13141; } 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2270z00_13139,BgL_arg2271z00_13140); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2275z00_13144;
BgL_arg2275z00_13144 = 
(BgL_spz00_13133+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2275z00_13144,BgL_a1z00_13126); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2276z00_13145;obj_t BgL_arg2277z00_13146;
BgL_arg2276z00_13145 = 
(BgL_spz00_13133+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2278z00_13147;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2279z00_13148;
BgL_arg2279z00_13148 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13128, BNIL); 
BgL_list2278z00_13147 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13127, BgL_arg2279z00_13148); } 
BgL_arg2277z00_13146 = BgL_list2278z00_13147; } 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2276z00_13145,BgL_arg2277z00_13146); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2280z00_13149;
BgL_arg2280z00_13149 = 
(BgL_spz00_13133+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2280z00_13149,BgL_a1z00_13126); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2281z00_13150;
BgL_arg2281z00_13150 = 
(BgL_spz00_13133+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2281z00_13150,BgL_a2z00_13127); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2282z00_13151;obj_t BgL_arg2283z00_13152;
BgL_arg2282z00_13151 = 
(BgL_spz00_13133+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2284z00_13153;
BgL_list2284z00_13153 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13128, BNIL); 
BgL_arg2283z00_13152 = BgL_list2284z00_13153; } 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2282z00_13151,BgL_arg2283z00_13152); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2285z00_13154;
BgL_arg2285z00_13154 = 
(BgL_spz00_13133+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2285z00_13154,BgL_a1z00_13126); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2286z00_13155;
BgL_arg2286z00_13155 = 
(BgL_spz00_13133+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2286z00_13155,BgL_a2z00_13127); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2287z00_13156;
BgL_arg2287z00_13156 = 
(BgL_spz00_13133+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2287z00_13156,BgL_a3z00_13128); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2288z00_13157;obj_t BgL_arg2289z00_13158;
BgL_arg2288z00_13157 = 
(BgL_spz00_13133+((long)3)); 
BgL_arg2289z00_13158 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10884),BgL_arg2288z00_13157,BgL_arg2289z00_13158); } break;
default: 
BgL_case_else1197z00_13137:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2291z00_13138;
BgL_arg2291z00_13138 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13129), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10881, BgL_arg2291z00_13138, 
(int)(((long)3)), 
CINT(BgL_arityz00_13130)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1197z00_13137;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13159;
BgL_z12denvz12_13159 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13159, BgL_locz00_10881); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10884, 
BINT(BgL_spz00_13133), BgL_sfz00_13132))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13131, BgL_sz00_10884, 
BINT(BgL_spz00_13133));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13160;
BgL_nsz00_13160 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2293z00_13161;
BgL_arg2293z00_13161 = 
(BgL_spz00_13133+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13160, ((long)2), BgL_sz00_10884, 
BINT(BgL_spz00_13133), 
BINT(BgL_arg2293z00_13161)); } 
VECTOR_SET(BgL_nsz00_13160,((long)1),BgL_sz00_10884); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13159, BgL_nsz00_13160); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13162;
BgL_ez00_13162 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13162, BgL_sz00_10884); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13163;
BgL_____rz00_13163 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13131, BgL_nsz00_13160, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13162); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13159, BgL_sz00_10884); 
return BgL_____rz00_13163;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13125, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13164;
BgL_nbpz00_13164 = 
(
(long)CINT(BgL_bpz00_13124)+BgL_siza7eza7_10883); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),((long)0),
BINT(BgL_nbpz00_13164)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18615;
BgL_tmpz00_18615 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18615, BgL_locz00_10881); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13165;
BgL_rz00_13165 = 
PROCEDURE_ENTRY(BgL_fz00_13125)(BgL_fz00_13125, BgL_a1z00_13126, BgL_a2z00_13127, BgL_a3z00_13128, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10884),((long)0),BgL_bpz00_13124); 
return BgL_rz00_13165;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10881, BgL_symbzd2funzd2_10882, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13125));} } } } } } } } 

}



/* &<@anonymous:2297> */
obj_t BGl_z62zc3z04anonymousza32297ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10885, obj_t BgL_sz00_10893)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10886;obj_t BgL_a1z00_10887;obj_t BgL_a2z00_10888;obj_t BgL_a3z00_10889;obj_t BgL_locz00_10890;obj_t BgL_symbzd2funzd2_10891;long BgL_siza7eza7_10892;
BgL_funz00_10886 = 
PROCEDURE_REF(BgL_envz00_10885, 
(int)(((long)0))); 
BgL_a1z00_10887 = 
PROCEDURE_REF(BgL_envz00_10885, 
(int)(((long)1))); 
BgL_a2z00_10888 = 
PROCEDURE_REF(BgL_envz00_10885, 
(int)(((long)2))); 
BgL_a3z00_10889 = 
PROCEDURE_REF(BgL_envz00_10885, 
(int)(((long)3))); 
BgL_locz00_10890 = 
PROCEDURE_REF(BgL_envz00_10885, 
(int)(((long)4))); 
BgL_symbzd2funzd2_10891 = 
PROCEDURE_REF(BgL_envz00_10885, 
(int)(((long)5))); 
BgL_siza7eza7_10892 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10885, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13166;
BgL_bpz00_13166 = 
VECTOR_REF(
((obj_t)BgL_sz00_10893),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13167;obj_t BgL_a1z00_13168;obj_t BgL_a2z00_13169;obj_t BgL_a3z00_13170;
BgL_fz00_13167 = 
PROCEDURE_ENTRY(BgL_funz00_10886)(BgL_funz00_10886, BgL_sz00_10893, BEOA); 
BgL_a1z00_13168 = 
PROCEDURE_ENTRY(BgL_a1z00_10887)(BgL_a1z00_10887, BgL_sz00_10893, BEOA); 
BgL_a2z00_13169 = 
PROCEDURE_ENTRY(BgL_a2z00_10888)(BgL_a2z00_10888, BgL_sz00_10893, BEOA); 
BgL_a3z00_13170 = 
PROCEDURE_ENTRY(BgL_a3z00_10889)(BgL_a3z00_10889, BgL_sz00_10893, BEOA); 
if(
PROCEDUREP(BgL_fz00_13167))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10890, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_13167); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13171;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18665;
BgL_tmpz00_18665 = 
((obj_t)BgL_fz00_13167); 
BgL_ufz00_13171 = 
PROCEDURE_ATTR(BgL_tmpz00_18665); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5730z00_18668;
if(
STRUCTP(BgL_ufz00_13171))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5730z00_18668 = 
(
STRUCT_KEY(BgL_ufz00_13171)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5730z00_18668 = ((bool_t)0)
; } 
if(BgL_test5730z00_18668)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13172;obj_t BgL_runz00_13173;obj_t BgL_sfz00_13174;
BgL_arityz00_13172 = 
STRUCT_REF(BgL_ufz00_13171, 
(int)(((long)0))); 
BgL_runz00_13173 = 
STRUCT_REF(BgL_ufz00_13171, 
(int)(((long)1))); 
BgL_sfz00_13174 = 
STRUCT_REF(BgL_ufz00_13171, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13175;
BgL_spz00_13175 = 
(
(long)CINT(BgL_bpz00_13166)+BgL_siza7eza7_10892); 
if(
(
(long)CINT(BgL_arityz00_13172)==((long)3)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2301z00_13176;
BgL_arg2301z00_13176 = 
(BgL_spz00_13175+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2301z00_13176,BgL_a1z00_13168); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2302z00_13177;
BgL_arg2302z00_13177 = 
(BgL_spz00_13175+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2302z00_13177,BgL_a2z00_13169); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2303z00_13178;
BgL_arg2303z00_13178 = 
(BgL_spz00_13175+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2303z00_13178,BgL_a3z00_13170); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13172))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13172)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2305z00_13181;obj_t BgL_arg2306z00_13182;
BgL_arg2305z00_13181 = 
(BgL_spz00_13175+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2307z00_13183;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2308z00_13184;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2309z00_13185;
BgL_arg2309z00_13185 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13170, BNIL); 
BgL_arg2308z00_13184 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13169, BgL_arg2309z00_13185); } 
BgL_list2307z00_13183 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13168, BgL_arg2308z00_13184); } 
BgL_arg2306z00_13182 = BgL_list2307z00_13183; } 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2305z00_13181,BgL_arg2306z00_13182); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2310z00_13186;
BgL_arg2310z00_13186 = 
(BgL_spz00_13175+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2310z00_13186,BgL_a1z00_13168); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2311z00_13187;obj_t BgL_arg2312z00_13188;
BgL_arg2311z00_13187 = 
(BgL_spz00_13175+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2313z00_13189;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2314z00_13190;
BgL_arg2314z00_13190 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13170, BNIL); 
BgL_list2313z00_13189 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13169, BgL_arg2314z00_13190); } 
BgL_arg2312z00_13188 = BgL_list2313z00_13189; } 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2311z00_13187,BgL_arg2312z00_13188); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2315z00_13191;
BgL_arg2315z00_13191 = 
(BgL_spz00_13175+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2315z00_13191,BgL_a1z00_13168); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2316z00_13192;
BgL_arg2316z00_13192 = 
(BgL_spz00_13175+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2316z00_13192,BgL_a2z00_13169); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2317z00_13193;obj_t BgL_arg2318z00_13194;
BgL_arg2317z00_13193 = 
(BgL_spz00_13175+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2319z00_13195;
BgL_list2319z00_13195 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13170, BNIL); 
BgL_arg2318z00_13194 = BgL_list2319z00_13195; } 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2317z00_13193,BgL_arg2318z00_13194); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2320z00_13196;
BgL_arg2320z00_13196 = 
(BgL_spz00_13175+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2320z00_13196,BgL_a1z00_13168); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2321z00_13197;
BgL_arg2321z00_13197 = 
(BgL_spz00_13175+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2321z00_13197,BgL_a2z00_13169); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2322z00_13198;
BgL_arg2322z00_13198 = 
(BgL_spz00_13175+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2322z00_13198,BgL_a3z00_13170); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2323z00_13199;obj_t BgL_arg2324z00_13200;
BgL_arg2323z00_13199 = 
(BgL_spz00_13175+((long)3)); 
BgL_arg2324z00_13200 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10893),BgL_arg2323z00_13199,BgL_arg2324z00_13200); } break;
default: 
BgL_case_else1199z00_13179:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2326z00_13180;
BgL_arg2326z00_13180 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13171), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10890, BgL_arg2326z00_13180, 
(int)(((long)3)), 
CINT(BgL_arityz00_13172)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1199z00_13179;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13201;
BgL_z12denvz12_13201 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10893, 
BINT(BgL_spz00_13175), BgL_sfz00_13174))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13173, BgL_sz00_10893, 
BINT(BgL_spz00_13175));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13202;
BgL_nsz00_13202 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2328z00_13203;
BgL_arg2328z00_13203 = 
(BgL_spz00_13175+((long)3)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13202, ((long)2), BgL_sz00_10893, 
BINT(BgL_spz00_13175), 
BINT(BgL_arg2328z00_13203)); } 
VECTOR_SET(BgL_nsz00_13202,((long)1),BgL_sz00_10893); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13201, BgL_nsz00_13202); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13204;
BgL_ez00_13204 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13204, BgL_sz00_10893); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13205;
BgL_____rz00_13205 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13173, BgL_nsz00_13202, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13204); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13201, BgL_sz00_10893); 
return BgL_____rz00_13205;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13167, 
(int)(((long)3))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13206;
BgL_nbpz00_13206 = 
(
(long)CINT(BgL_bpz00_13166)+BgL_siza7eza7_10892); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),((long)0),
BINT(BgL_nbpz00_13206)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13207;
BgL_rz00_13207 = 
PROCEDURE_ENTRY(BgL_fz00_13167)(BgL_fz00_13167, BgL_a1z00_13168, BgL_a2z00_13169, BgL_a3z00_13170, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10893),((long)0),BgL_bpz00_13166); 
return BgL_rz00_13207;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10890, BgL_symbzd2funzd2_10891, 
(int)(((long)3)), 
PROCEDURE_ARITY(BgL_fz00_13167));} } } } } } } } 

}



/* comp-call4 */
obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172, BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174, obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177, long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180, obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_cfunz00_2736;
BgL_cfunz00_2736 = 
BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173, ((long)4), BgL_locz00_172, BgL_symbzd2funzd2_174); 
if(
CBOOL(BgL_cfunz00_2736))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5737z00_18780;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2337z00_2758;
BgL_arg2337z00_2758 = 
bgl_debug(); 
BgL_test5737z00_18780 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2337z00_2758), 
BINT(((long)0))); } 
if(BgL_test5737z00_18780)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32334ze3z87_10894;
BgL_zc3z04anonymousza32334ze3z87_10894 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32334ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32334ze3z87_10894, 
(int)(((long)0)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32334ze3z87_10894, 
(int)(((long)1)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32334ze3z87_10894, 
(int)(((long)2)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32334ze3z87_10894, 
(int)(((long)3)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32334ze3z87_10894, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_178)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32334ze3z87_10894, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32334ze3z87_10894, 
(int)(((long)6)), BgL_cfunz00_2736); 
return BgL_zc3z04anonymousza32334ze3z87_10894;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32336ze3z87_10895;
BgL_zc3z04anonymousza32336ze3z87_10895 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32336ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_10895, 
(int)(((long)0)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_10895, 
(int)(((long)1)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_10895, 
(int)(((long)2)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_10895, 
(int)(((long)3)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_10895, 
(int)(((long)4)), 
BINT(BgL_siza7eza7_178)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32336ze3z87_10895, 
(int)(((long)5)), BgL_cfunz00_2736); 
return BgL_zc3z04anonymousza32336ze3z87_10895;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
CBOOL(BgL_tailzf3zf3_176))
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5739z00_18821;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2431z00_2894;
BgL_arg2431z00_2894 = 
bgl_debug(); 
BgL_test5739z00_18821 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2431z00_2894), 
BINT(((long)0))); } 
if(BgL_test5739z00_18821)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32340ze3z87_10896;
BgL_zc3z04anonymousza32340ze3z87_10896 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32340ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32340ze3z87_10896, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32340ze3z87_10896, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32340ze3z87_10896, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32340ze3z87_10896, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32340ze3z87_10896, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32340ze3z87_10896, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32340ze3z87_10896, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32340ze3z87_10896, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32340ze3z87_10896;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32386ze3z87_10897;
BgL_zc3z04anonymousza32386ze3z87_10897 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32386ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32386ze3z87_10897, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32386ze3z87_10897, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32386ze3z87_10897, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32386ze3z87_10897, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32386ze3z87_10897, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32386ze3z87_10897, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32386ze3z87_10897, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32386ze3z87_10897, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32386ze3z87_10897;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5740z00_18866;
{ /* Eval/evaluate_comp.scm 896 */
int BgL_arg2525z00_3030;
BgL_arg2525z00_3030 = 
bgl_debug(); 
BgL_test5740z00_18866 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(
BINT(BgL_arg2525z00_3030), 
BINT(((long)0))); } 
if(BgL_test5740z00_18866)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32434ze3z87_10898;
BgL_zc3z04anonymousza32434ze3z87_10898 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32434ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32434ze3z87_10898, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32434ze3z87_10898, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32434ze3z87_10898, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32434ze3z87_10898, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32434ze3z87_10898, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32434ze3z87_10898, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32434ze3z87_10898, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32434ze3z87_10898, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32434ze3z87_10898;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_zc3z04anonymousza32480ze3z87_10899;
BgL_zc3z04anonymousza32480ze3z87_10899 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32480ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)8))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32480ze3z87_10899, 
(int)(((long)0)), BgL_funz00_175); 
PROCEDURE_SET(BgL_zc3z04anonymousza32480ze3z87_10899, 
(int)(((long)1)), BgL_a1z00_179); 
PROCEDURE_SET(BgL_zc3z04anonymousza32480ze3z87_10899, 
(int)(((long)2)), BgL_a2z00_180); 
PROCEDURE_SET(BgL_zc3z04anonymousza32480ze3z87_10899, 
(int)(((long)3)), BgL_a3z00_181); 
PROCEDURE_SET(BgL_zc3z04anonymousza32480ze3z87_10899, 
(int)(((long)4)), BgL_a4z00_182); 
PROCEDURE_SET(BgL_zc3z04anonymousza32480ze3z87_10899, 
(int)(((long)5)), BgL_locz00_172); 
PROCEDURE_SET(BgL_zc3z04anonymousza32480ze3z87_10899, 
(int)(((long)6)), BgL_symbzd2funzd2_174); 
PROCEDURE_SET(BgL_zc3z04anonymousza32480ze3z87_10899, 
(int)(((long)7)), 
BINT(BgL_siza7eza7_178)); 
return BgL_zc3z04anonymousza32480ze3z87_10899;} } } } } 

}



/* &<@anonymous:2334> */
obj_t BGl_z62zc3z04anonymousza32334ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10900, obj_t BgL_sz00_10908)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10901;obj_t BgL_a2z00_10902;obj_t BgL_a3z00_10903;obj_t BgL_a4z00_10904;long BgL_siza7eza7_10905;obj_t BgL_locz00_10906;obj_t BgL_cfunz00_10907;
BgL_a1z00_10901 = 
PROCEDURE_REF(BgL_envz00_10900, 
(int)(((long)0))); 
BgL_a2z00_10902 = 
PROCEDURE_REF(BgL_envz00_10900, 
(int)(((long)1))); 
BgL_a3z00_10903 = 
PROCEDURE_REF(BgL_envz00_10900, 
(int)(((long)2))); 
BgL_a4z00_10904 = 
PROCEDURE_REF(BgL_envz00_10900, 
(int)(((long)3))); 
BgL_siza7eza7_10905 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10900, 
(int)(((long)4)))); 
BgL_locz00_10906 = 
PROCEDURE_REF(BgL_envz00_10900, 
(int)(((long)5))); 
BgL_cfunz00_10907 = 
PROCEDURE_REF(BgL_envz00_10900, 
(int)(((long)6))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13208;
BgL_bpz00_13208 = 
VECTOR_REF(
((obj_t)BgL_sz00_10908),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_13209;obj_t BgL_a2z00_13210;obj_t BgL_a3z00_13211;obj_t BgL_a4z00_13212;
BgL_a1z00_13209 = 
PROCEDURE_ENTRY(BgL_a1z00_10901)(BgL_a1z00_10901, BgL_sz00_10908, BEOA); 
BgL_a2z00_13210 = 
PROCEDURE_ENTRY(BgL_a2z00_10902)(BgL_a2z00_10902, BgL_sz00_10908, BEOA); 
BgL_a3z00_13211 = 
PROCEDURE_ENTRY(BgL_a3z00_10903)(BgL_a3z00_10903, BgL_sz00_10908, BEOA); 
BgL_a4z00_13212 = 
PROCEDURE_ENTRY(BgL_a4z00_10904)(BgL_a4z00_10904, BgL_sz00_10908, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13213;
BgL_nbpz00_13213 = 
(
(long)CINT(BgL_bpz00_13208)+BgL_siza7eza7_10905); 
VECTOR_SET(
((obj_t)BgL_sz00_10908),((long)0),
BINT(BgL_nbpz00_13213)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_18949;
BgL_tmpz00_18949 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_18949, BgL_locz00_10906); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13214;
BgL_rz00_13214 = 
PROCEDURE_ENTRY(BgL_cfunz00_10907)(BgL_cfunz00_10907, BgL_a1z00_13209, BgL_a2z00_13210, BgL_a3z00_13211, BgL_a4z00_13212, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10908),((long)0),BgL_bpz00_13208); 
return BgL_rz00_13214;} } } } } } 

}



/* &<@anonymous:2336> */
obj_t BGl_z62zc3z04anonymousza32336ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10909, obj_t BgL_sz00_10916)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_10910;obj_t BgL_a2z00_10911;obj_t BgL_a3z00_10912;obj_t BgL_a4z00_10913;long BgL_siza7eza7_10914;obj_t BgL_cfunz00_10915;
BgL_a1z00_10910 = 
PROCEDURE_REF(BgL_envz00_10909, 
(int)(((long)0))); 
BgL_a2z00_10911 = 
PROCEDURE_REF(BgL_envz00_10909, 
(int)(((long)1))); 
BgL_a3z00_10912 = 
PROCEDURE_REF(BgL_envz00_10909, 
(int)(((long)2))); 
BgL_a4z00_10913 = 
PROCEDURE_REF(BgL_envz00_10909, 
(int)(((long)3))); 
BgL_siza7eza7_10914 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10909, 
(int)(((long)4)))); 
BgL_cfunz00_10915 = 
PROCEDURE_REF(BgL_envz00_10909, 
(int)(((long)5))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13215;
BgL_bpz00_13215 = 
VECTOR_REF(
((obj_t)BgL_sz00_10916),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_a1z00_13216;obj_t BgL_a2z00_13217;obj_t BgL_a3z00_13218;obj_t BgL_a4z00_13219;
BgL_a1z00_13216 = 
PROCEDURE_ENTRY(BgL_a1z00_10910)(BgL_a1z00_10910, BgL_sz00_10916, BEOA); 
BgL_a2z00_13217 = 
PROCEDURE_ENTRY(BgL_a2z00_10911)(BgL_a2z00_10911, BgL_sz00_10916, BEOA); 
BgL_a3z00_13218 = 
PROCEDURE_ENTRY(BgL_a3z00_10912)(BgL_a3z00_10912, BgL_sz00_10916, BEOA); 
BgL_a4z00_13219 = 
PROCEDURE_ENTRY(BgL_a4z00_10913)(BgL_a4z00_10913, BgL_sz00_10916, BEOA); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13220;
BgL_nbpz00_13220 = 
(
(long)CINT(BgL_bpz00_13215)+BgL_siza7eza7_10914); 
VECTOR_SET(
((obj_t)BgL_sz00_10916),((long)0),
BINT(BgL_nbpz00_13220)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13221;
BgL_rz00_13221 = 
PROCEDURE_ENTRY(BgL_cfunz00_10915)(BgL_cfunz00_10915, BgL_a1z00_13216, BgL_a2z00_13217, BgL_a3z00_13218, BgL_a4z00_13219, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10916),((long)0),BgL_bpz00_13215); 
return BgL_rz00_13221;} } } } } } 

}



/* &<@anonymous:2340> */
obj_t BGl_z62zc3z04anonymousza32340ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10917, obj_t BgL_sz00_10926)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10918;obj_t BgL_a1z00_10919;obj_t BgL_a2z00_10920;obj_t BgL_a3z00_10921;obj_t BgL_a4z00_10922;obj_t BgL_locz00_10923;obj_t BgL_symbzd2funzd2_10924;long BgL_siza7eza7_10925;
BgL_funz00_10918 = 
PROCEDURE_REF(BgL_envz00_10917, 
(int)(((long)0))); 
BgL_a1z00_10919 = 
PROCEDURE_REF(BgL_envz00_10917, 
(int)(((long)1))); 
BgL_a2z00_10920 = 
PROCEDURE_REF(BgL_envz00_10917, 
(int)(((long)2))); 
BgL_a3z00_10921 = 
PROCEDURE_REF(BgL_envz00_10917, 
(int)(((long)3))); 
BgL_a4z00_10922 = 
PROCEDURE_REF(BgL_envz00_10917, 
(int)(((long)4))); 
BgL_locz00_10923 = 
PROCEDURE_REF(BgL_envz00_10917, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10924 = 
PROCEDURE_REF(BgL_envz00_10917, 
(int)(((long)6))); 
BgL_siza7eza7_10925 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10917, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13222;
BgL_bpz00_13222 = 
VECTOR_REF(
((obj_t)BgL_sz00_10926),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13223;obj_t BgL_a1z00_13224;obj_t BgL_a2z00_13225;obj_t BgL_a3z00_13226;obj_t BgL_a4z00_13227;
BgL_fz00_13223 = 
PROCEDURE_ENTRY(BgL_funz00_10918)(BgL_funz00_10918, BgL_sz00_10926, BEOA); 
BgL_a1z00_13224 = 
PROCEDURE_ENTRY(BgL_a1z00_10919)(BgL_a1z00_10919, BgL_sz00_10926, BEOA); 
BgL_a2z00_13225 = 
PROCEDURE_ENTRY(BgL_a2z00_10920)(BgL_a2z00_10920, BgL_sz00_10926, BEOA); 
BgL_a3z00_13226 = 
PROCEDURE_ENTRY(BgL_a3z00_10921)(BgL_a3z00_10921, BgL_sz00_10926, BEOA); 
BgL_a4z00_13227 = 
PROCEDURE_ENTRY(BgL_a4z00_10922)(BgL_a4z00_10922, BgL_sz00_10926, BEOA); 
if(
PROCEDUREP(BgL_fz00_13223))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10923, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_13223); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13228;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19048;
BgL_tmpz00_19048 = 
((obj_t)BgL_fz00_13223); 
BgL_ufz00_13228 = 
PROCEDURE_ATTR(BgL_tmpz00_19048); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5742z00_19051;
if(
STRUCTP(BgL_ufz00_13228))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5742z00_19051 = 
(
STRUCT_KEY(BgL_ufz00_13228)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5742z00_19051 = ((bool_t)0)
; } 
if(BgL_test5742z00_19051)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13229;obj_t BgL_runz00_13230;obj_t BgL_sfz00_13231;
BgL_arityz00_13229 = 
STRUCT_REF(BgL_ufz00_13228, 
(int)(((long)0))); 
BgL_runz00_13230 = 
STRUCT_REF(BgL_ufz00_13228, 
(int)(((long)1))); 
BgL_sfz00_13231 = 
STRUCT_REF(BgL_ufz00_13228, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13229)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2344z00_13232;
BgL_arg2344z00_13232 = 
(
(long)CINT(BgL_bpz00_13222)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2344z00_13232,BgL_a1z00_13224); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2345z00_13233;
BgL_arg2345z00_13233 = 
(
(long)CINT(BgL_bpz00_13222)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2345z00_13233,BgL_a2z00_13225); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2346z00_13234;
BgL_arg2346z00_13234 = 
(
(long)CINT(BgL_bpz00_13222)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2346z00_13234,BgL_a3z00_13226); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2347z00_13235;
BgL_arg2347z00_13235 = 
(
(long)CINT(BgL_bpz00_13222)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2347z00_13235,BgL_a4z00_13227); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13229))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13229)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2349z00_13238;obj_t BgL_arg2350z00_13239;
BgL_arg2349z00_13238 = 
(
(long)CINT(BgL_bpz00_13222)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2351z00_13240;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2352z00_13241;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2353z00_13242;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2354z00_13243;
BgL_arg2354z00_13243 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13227, BNIL); 
BgL_arg2353z00_13242 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13226, BgL_arg2354z00_13243); } 
BgL_arg2352z00_13241 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13225, BgL_arg2353z00_13242); } 
BgL_list2351z00_13240 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13224, BgL_arg2352z00_13241); } 
BgL_arg2350z00_13239 = BgL_list2351z00_13240; } 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2349z00_13238,BgL_arg2350z00_13239); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2355z00_13244;
BgL_arg2355z00_13244 = 
(
(long)CINT(BgL_bpz00_13222)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2355z00_13244,BgL_a1z00_13224); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2356z00_13245;obj_t BgL_arg2357z00_13246;
BgL_arg2356z00_13245 = 
(
(long)CINT(BgL_bpz00_13222)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2358z00_13247;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2359z00_13248;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2360z00_13249;
BgL_arg2360z00_13249 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13227, BNIL); 
BgL_arg2359z00_13248 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13226, BgL_arg2360z00_13249); } 
BgL_list2358z00_13247 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13225, BgL_arg2359z00_13248); } 
BgL_arg2357z00_13246 = BgL_list2358z00_13247; } 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2356z00_13245,BgL_arg2357z00_13246); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2361z00_13250;
BgL_arg2361z00_13250 = 
(
(long)CINT(BgL_bpz00_13222)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2361z00_13250,BgL_a1z00_13224); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2362z00_13251;
BgL_arg2362z00_13251 = 
(
(long)CINT(BgL_bpz00_13222)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2362z00_13251,BgL_a2z00_13225); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2363z00_13252;obj_t BgL_arg2364z00_13253;
BgL_arg2363z00_13252 = 
(
(long)CINT(BgL_bpz00_13222)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2365z00_13254;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2366z00_13255;
BgL_arg2366z00_13255 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13227, BNIL); 
BgL_list2365z00_13254 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13226, BgL_arg2366z00_13255); } 
BgL_arg2364z00_13253 = BgL_list2365z00_13254; } 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2363z00_13252,BgL_arg2364z00_13253); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2367z00_13256;
BgL_arg2367z00_13256 = 
(
(long)CINT(BgL_bpz00_13222)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2367z00_13256,BgL_a1z00_13224); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2368z00_13257;
BgL_arg2368z00_13257 = 
(
(long)CINT(BgL_bpz00_13222)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2368z00_13257,BgL_a2z00_13225); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2369z00_13258;
BgL_arg2369z00_13258 = 
(
(long)CINT(BgL_bpz00_13222)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2369z00_13258,BgL_a3z00_13226); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2370z00_13259;obj_t BgL_arg2371z00_13260;
BgL_arg2370z00_13259 = 
(
(long)CINT(BgL_bpz00_13222)+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2372z00_13261;
BgL_list2372z00_13261 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13227, BNIL); 
BgL_arg2371z00_13260 = BgL_list2372z00_13261; } 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2370z00_13259,BgL_arg2371z00_13260); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2373z00_13262;
BgL_arg2373z00_13262 = 
(
(long)CINT(BgL_bpz00_13222)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2373z00_13262,BgL_a1z00_13224); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2374z00_13263;
BgL_arg2374z00_13263 = 
(
(long)CINT(BgL_bpz00_13222)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2374z00_13263,BgL_a2z00_13225); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2375z00_13264;
BgL_arg2375z00_13264 = 
(
(long)CINT(BgL_bpz00_13222)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2375z00_13264,BgL_a3z00_13226); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2376z00_13265;
BgL_arg2376z00_13265 = 
(
(long)CINT(BgL_bpz00_13222)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2376z00_13265,BgL_a4z00_13227); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2377z00_13266;obj_t BgL_arg2378z00_13267;
BgL_arg2377z00_13266 = 
(
(long)CINT(BgL_bpz00_13222)+((long)4)); 
BgL_arg2378z00_13267 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10926),BgL_arg2377z00_13266,BgL_arg2378z00_13267); } break;
default: 
BgL_case_else1201z00_13236:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2380z00_13237;
BgL_arg2380z00_13237 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13228), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10923, BgL_arg2380z00_13237, 
(int)(((long)4)), 
CINT(BgL_arityz00_13229)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1201z00_13236;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13268;
BgL_z12denvz12_13268 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13268, BgL_locz00_10923); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10926, BgL_bpz00_13222, BgL_sfz00_13231))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_13230;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13269;
BgL_nsz00_13269 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2382z00_13270;
BgL_arg2382z00_13270 = 
(
(long)CINT(BgL_bpz00_13222)+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13269, ((long)2), BgL_sz00_10926, BgL_bpz00_13222, 
BINT(BgL_arg2382z00_13270)); } 
VECTOR_SET(BgL_nsz00_13269,((long)1),BgL_sz00_10926); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13268, BgL_nsz00_13269); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13271;
BgL_ez00_13271 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13271, BgL_sz00_10926); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13272;
BgL_____rz00_13272 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13230, BgL_nsz00_13269, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13271); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13268, BgL_sz00_10926); 
return BgL_____rz00_13272;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13223, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13273;
BgL_nbpz00_13273 = 
(
(long)CINT(BgL_bpz00_13222)+BgL_siza7eza7_10925); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),((long)0),
BINT(BgL_nbpz00_13273)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19186;
BgL_tmpz00_19186 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19186, BgL_locz00_10923); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13274;
BgL_rz00_13274 = 
PROCEDURE_ENTRY(BgL_fz00_13223)(BgL_fz00_13223, BgL_a1z00_13224, BgL_a2z00_13225, BgL_a3z00_13226, BgL_a4z00_13227, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10926),((long)0),BgL_bpz00_13222); 
return BgL_rz00_13274;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10923, BgL_symbzd2funzd2_10924, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13223));} } } } } } } } 

}



/* &<@anonymous:2386> */
obj_t BGl_z62zc3z04anonymousza32386ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10927, obj_t BgL_sz00_10936)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10928;obj_t BgL_a1z00_10929;obj_t BgL_a2z00_10930;obj_t BgL_a3z00_10931;obj_t BgL_a4z00_10932;obj_t BgL_locz00_10933;obj_t BgL_symbzd2funzd2_10934;long BgL_siza7eza7_10935;
BgL_funz00_10928 = 
PROCEDURE_REF(BgL_envz00_10927, 
(int)(((long)0))); 
BgL_a1z00_10929 = 
PROCEDURE_REF(BgL_envz00_10927, 
(int)(((long)1))); 
BgL_a2z00_10930 = 
PROCEDURE_REF(BgL_envz00_10927, 
(int)(((long)2))); 
BgL_a3z00_10931 = 
PROCEDURE_REF(BgL_envz00_10927, 
(int)(((long)3))); 
BgL_a4z00_10932 = 
PROCEDURE_REF(BgL_envz00_10927, 
(int)(((long)4))); 
BgL_locz00_10933 = 
PROCEDURE_REF(BgL_envz00_10927, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10934 = 
PROCEDURE_REF(BgL_envz00_10927, 
(int)(((long)6))); 
BgL_siza7eza7_10935 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10927, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13275;
BgL_bpz00_13275 = 
VECTOR_REF(
((obj_t)BgL_sz00_10936),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13276;obj_t BgL_a1z00_13277;obj_t BgL_a2z00_13278;obj_t BgL_a3z00_13279;obj_t BgL_a4z00_13280;
BgL_fz00_13276 = 
PROCEDURE_ENTRY(BgL_funz00_10928)(BgL_funz00_10928, BgL_sz00_10936, BEOA); 
BgL_a1z00_13277 = 
PROCEDURE_ENTRY(BgL_a1z00_10929)(BgL_a1z00_10929, BgL_sz00_10936, BEOA); 
BgL_a2z00_13278 = 
PROCEDURE_ENTRY(BgL_a2z00_10930)(BgL_a2z00_10930, BgL_sz00_10936, BEOA); 
BgL_a3z00_13279 = 
PROCEDURE_ENTRY(BgL_a3z00_10931)(BgL_a3z00_10931, BgL_sz00_10936, BEOA); 
BgL_a4z00_13280 = 
PROCEDURE_ENTRY(BgL_a4z00_10932)(BgL_a4z00_10932, BgL_sz00_10936, BEOA); 
if(
PROCEDUREP(BgL_fz00_13276))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10933, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_13276); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13281;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19243;
BgL_tmpz00_19243 = 
((obj_t)BgL_fz00_13276); 
BgL_ufz00_13281 = 
PROCEDURE_ATTR(BgL_tmpz00_19243); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5749z00_19246;
if(
STRUCTP(BgL_ufz00_13281))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5749z00_19246 = 
(
STRUCT_KEY(BgL_ufz00_13281)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5749z00_19246 = ((bool_t)0)
; } 
if(BgL_test5749z00_19246)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13282;obj_t BgL_runz00_13283;obj_t BgL_sfz00_13284;
BgL_arityz00_13282 = 
STRUCT_REF(BgL_ufz00_13281, 
(int)(((long)0))); 
BgL_runz00_13283 = 
STRUCT_REF(BgL_ufz00_13281, 
(int)(((long)1))); 
BgL_sfz00_13284 = 
STRUCT_REF(BgL_ufz00_13281, 
(int)(((long)2))); 
if(
(
(long)CINT(BgL_arityz00_13282)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2390z00_13285;
BgL_arg2390z00_13285 = 
(
(long)CINT(BgL_bpz00_13275)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2390z00_13285,BgL_a1z00_13277); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2391z00_13286;
BgL_arg2391z00_13286 = 
(
(long)CINT(BgL_bpz00_13275)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2391z00_13286,BgL_a2z00_13278); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2392z00_13287;
BgL_arg2392z00_13287 = 
(
(long)CINT(BgL_bpz00_13275)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2392z00_13287,BgL_a3z00_13279); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2393z00_13288;
BgL_arg2393z00_13288 = 
(
(long)CINT(BgL_bpz00_13275)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2393z00_13288,BgL_a4z00_13280); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13282))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13282)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2395z00_13291;obj_t BgL_arg2396z00_13292;
BgL_arg2395z00_13291 = 
(
(long)CINT(BgL_bpz00_13275)+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2397z00_13293;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2398z00_13294;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2399z00_13295;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2400z00_13296;
BgL_arg2400z00_13296 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13280, BNIL); 
BgL_arg2399z00_13295 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13279, BgL_arg2400z00_13296); } 
BgL_arg2398z00_13294 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13278, BgL_arg2399z00_13295); } 
BgL_list2397z00_13293 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13277, BgL_arg2398z00_13294); } 
BgL_arg2396z00_13292 = BgL_list2397z00_13293; } 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2395z00_13291,BgL_arg2396z00_13292); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2401z00_13297;
BgL_arg2401z00_13297 = 
(
(long)CINT(BgL_bpz00_13275)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2401z00_13297,BgL_a1z00_13277); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2402z00_13298;obj_t BgL_arg2403z00_13299;
BgL_arg2402z00_13298 = 
(
(long)CINT(BgL_bpz00_13275)+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2404z00_13300;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2405z00_13301;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2406z00_13302;
BgL_arg2406z00_13302 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13280, BNIL); 
BgL_arg2405z00_13301 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13279, BgL_arg2406z00_13302); } 
BgL_list2404z00_13300 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13278, BgL_arg2405z00_13301); } 
BgL_arg2403z00_13299 = BgL_list2404z00_13300; } 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2402z00_13298,BgL_arg2403z00_13299); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2407z00_13303;
BgL_arg2407z00_13303 = 
(
(long)CINT(BgL_bpz00_13275)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2407z00_13303,BgL_a1z00_13277); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2408z00_13304;
BgL_arg2408z00_13304 = 
(
(long)CINT(BgL_bpz00_13275)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2408z00_13304,BgL_a2z00_13278); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2409z00_13305;obj_t BgL_arg2410z00_13306;
BgL_arg2409z00_13305 = 
(
(long)CINT(BgL_bpz00_13275)+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2411z00_13307;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2412z00_13308;
BgL_arg2412z00_13308 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13280, BNIL); 
BgL_list2411z00_13307 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13279, BgL_arg2412z00_13308); } 
BgL_arg2410z00_13306 = BgL_list2411z00_13307; } 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2409z00_13305,BgL_arg2410z00_13306); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2413z00_13309;
BgL_arg2413z00_13309 = 
(
(long)CINT(BgL_bpz00_13275)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2413z00_13309,BgL_a1z00_13277); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2414z00_13310;
BgL_arg2414z00_13310 = 
(
(long)CINT(BgL_bpz00_13275)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2414z00_13310,BgL_a2z00_13278); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2415z00_13311;
BgL_arg2415z00_13311 = 
(
(long)CINT(BgL_bpz00_13275)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2415z00_13311,BgL_a3z00_13279); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2416z00_13312;obj_t BgL_arg2417z00_13313;
BgL_arg2416z00_13312 = 
(
(long)CINT(BgL_bpz00_13275)+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2418z00_13314;
BgL_list2418z00_13314 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13280, BNIL); 
BgL_arg2417z00_13313 = BgL_list2418z00_13314; } 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2416z00_13312,BgL_arg2417z00_13313); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2419z00_13315;
BgL_arg2419z00_13315 = 
(
(long)CINT(BgL_bpz00_13275)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2419z00_13315,BgL_a1z00_13277); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2420z00_13316;
BgL_arg2420z00_13316 = 
(
(long)CINT(BgL_bpz00_13275)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2420z00_13316,BgL_a2z00_13278); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2421z00_13317;
BgL_arg2421z00_13317 = 
(
(long)CINT(BgL_bpz00_13275)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2421z00_13317,BgL_a3z00_13279); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2422z00_13318;
BgL_arg2422z00_13318 = 
(
(long)CINT(BgL_bpz00_13275)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2422z00_13318,BgL_a4z00_13280); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2423z00_13319;obj_t BgL_arg2424z00_13320;
BgL_arg2423z00_13319 = 
(
(long)CINT(BgL_bpz00_13275)+((long)4)); 
BgL_arg2424z00_13320 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10936),BgL_arg2423z00_13319,BgL_arg2424z00_13320); } break;
default: 
BgL_case_else1203z00_13289:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2426z00_13290;
BgL_arg2426z00_13290 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13281), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10933, BgL_arg2426z00_13290, 
(int)(((long)4)), 
CINT(BgL_arityz00_13282)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1203z00_13289;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13321;
BgL_z12denvz12_13321 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10936, BgL_bpz00_13275, BgL_sfz00_13284))
{ /* Eval/evaluate_comp.scm 896 */
return BgL_runz00_13283;}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13322;
BgL_nsz00_13322 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2428z00_13323;
BgL_arg2428z00_13323 = 
(
(long)CINT(BgL_bpz00_13275)+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13322, ((long)2), BgL_sz00_10936, BgL_bpz00_13275, 
BINT(BgL_arg2428z00_13323)); } 
VECTOR_SET(BgL_nsz00_13322,((long)1),BgL_sz00_10936); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13321, BgL_nsz00_13322); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13324;
BgL_ez00_13324 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13324, BgL_sz00_10936); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13325;
BgL_____rz00_13325 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13283, BgL_nsz00_13322, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13324); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13321, BgL_sz00_10936); 
return BgL_____rz00_13325;} } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13276, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13326;
BgL_nbpz00_13326 = 
(
(long)CINT(BgL_bpz00_13275)+BgL_siza7eza7_10935); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),((long)0),
BINT(BgL_nbpz00_13326)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13327;
BgL_rz00_13327 = 
PROCEDURE_ENTRY(BgL_fz00_13276)(BgL_fz00_13276, BgL_a1z00_13277, BgL_a2z00_13278, BgL_a3z00_13279, BgL_a4z00_13280, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10936),((long)0),BgL_bpz00_13275); 
return BgL_rz00_13327;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10933, BgL_symbzd2funzd2_10934, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13276));} } } } } } } } 

}



/* &<@anonymous:2434> */
obj_t BGl_z62zc3z04anonymousza32434ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10937, obj_t BgL_sz00_10946)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10938;obj_t BgL_a1z00_10939;obj_t BgL_a2z00_10940;obj_t BgL_a3z00_10941;obj_t BgL_a4z00_10942;obj_t BgL_locz00_10943;obj_t BgL_symbzd2funzd2_10944;long BgL_siza7eza7_10945;
BgL_funz00_10938 = 
PROCEDURE_REF(BgL_envz00_10937, 
(int)(((long)0))); 
BgL_a1z00_10939 = 
PROCEDURE_REF(BgL_envz00_10937, 
(int)(((long)1))); 
BgL_a2z00_10940 = 
PROCEDURE_REF(BgL_envz00_10937, 
(int)(((long)2))); 
BgL_a3z00_10941 = 
PROCEDURE_REF(BgL_envz00_10937, 
(int)(((long)3))); 
BgL_a4z00_10942 = 
PROCEDURE_REF(BgL_envz00_10937, 
(int)(((long)4))); 
BgL_locz00_10943 = 
PROCEDURE_REF(BgL_envz00_10937, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10944 = 
PROCEDURE_REF(BgL_envz00_10937, 
(int)(((long)6))); 
BgL_siza7eza7_10945 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10937, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13328;
BgL_bpz00_13328 = 
VECTOR_REF(
((obj_t)BgL_sz00_10946),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13329;obj_t BgL_a1z00_13330;obj_t BgL_a2z00_13331;obj_t BgL_a3z00_13332;obj_t BgL_a4z00_13333;
BgL_fz00_13329 = 
PROCEDURE_ENTRY(BgL_funz00_10938)(BgL_funz00_10938, BgL_sz00_10946, BEOA); 
BgL_a1z00_13330 = 
PROCEDURE_ENTRY(BgL_a1z00_10939)(BgL_a1z00_10939, BgL_sz00_10946, BEOA); 
BgL_a2z00_13331 = 
PROCEDURE_ENTRY(BgL_a2z00_10940)(BgL_a2z00_10940, BgL_sz00_10946, BEOA); 
BgL_a3z00_13332 = 
PROCEDURE_ENTRY(BgL_a3z00_10941)(BgL_a3z00_10941, BgL_sz00_10946, BEOA); 
BgL_a4z00_13333 = 
PROCEDURE_ENTRY(BgL_a4z00_10942)(BgL_a4z00_10942, BgL_sz00_10946, BEOA); 
if(
PROCEDUREP(BgL_fz00_13329))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10943, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_13329); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13334;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19434;
BgL_tmpz00_19434 = 
((obj_t)BgL_fz00_13329); 
BgL_ufz00_13334 = 
PROCEDURE_ATTR(BgL_tmpz00_19434); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5756z00_19437;
if(
STRUCTP(BgL_ufz00_13334))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5756z00_19437 = 
(
STRUCT_KEY(BgL_ufz00_13334)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5756z00_19437 = ((bool_t)0)
; } 
if(BgL_test5756z00_19437)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13335;obj_t BgL_runz00_13336;obj_t BgL_sfz00_13337;
BgL_arityz00_13335 = 
STRUCT_REF(BgL_ufz00_13334, 
(int)(((long)0))); 
BgL_runz00_13336 = 
STRUCT_REF(BgL_ufz00_13334, 
(int)(((long)1))); 
BgL_sfz00_13337 = 
STRUCT_REF(BgL_ufz00_13334, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13338;
BgL_spz00_13338 = 
(
(long)CINT(BgL_bpz00_13328)+BgL_siza7eza7_10945); 
if(
(
(long)CINT(BgL_arityz00_13335)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2438z00_13339;
BgL_arg2438z00_13339 = 
(BgL_spz00_13338+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2438z00_13339,BgL_a1z00_13330); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2439z00_13340;
BgL_arg2439z00_13340 = 
(BgL_spz00_13338+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2439z00_13340,BgL_a2z00_13331); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2440z00_13341;
BgL_arg2440z00_13341 = 
(BgL_spz00_13338+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2440z00_13341,BgL_a3z00_13332); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2441z00_13342;
BgL_arg2441z00_13342 = 
(BgL_spz00_13338+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2441z00_13342,BgL_a4z00_13333); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13335))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13335)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2443z00_13345;obj_t BgL_arg2444z00_13346;
BgL_arg2443z00_13345 = 
(BgL_spz00_13338+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2445z00_13347;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2446z00_13348;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2447z00_13349;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2448z00_13350;
BgL_arg2448z00_13350 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13333, BNIL); 
BgL_arg2447z00_13349 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13332, BgL_arg2448z00_13350); } 
BgL_arg2446z00_13348 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13331, BgL_arg2447z00_13349); } 
BgL_list2445z00_13347 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13330, BgL_arg2446z00_13348); } 
BgL_arg2444z00_13346 = BgL_list2445z00_13347; } 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2443z00_13345,BgL_arg2444z00_13346); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2449z00_13351;
BgL_arg2449z00_13351 = 
(BgL_spz00_13338+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2449z00_13351,BgL_a1z00_13330); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2450z00_13352;obj_t BgL_arg2451z00_13353;
BgL_arg2450z00_13352 = 
(BgL_spz00_13338+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2452z00_13354;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2453z00_13355;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2454z00_13356;
BgL_arg2454z00_13356 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13333, BNIL); 
BgL_arg2453z00_13355 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13332, BgL_arg2454z00_13356); } 
BgL_list2452z00_13354 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13331, BgL_arg2453z00_13355); } 
BgL_arg2451z00_13353 = BgL_list2452z00_13354; } 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2450z00_13352,BgL_arg2451z00_13353); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2455z00_13357;
BgL_arg2455z00_13357 = 
(BgL_spz00_13338+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2455z00_13357,BgL_a1z00_13330); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2456z00_13358;
BgL_arg2456z00_13358 = 
(BgL_spz00_13338+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2456z00_13358,BgL_a2z00_13331); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2457z00_13359;obj_t BgL_arg2458z00_13360;
BgL_arg2457z00_13359 = 
(BgL_spz00_13338+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2459z00_13361;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2460z00_13362;
BgL_arg2460z00_13362 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13333, BNIL); 
BgL_list2459z00_13361 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13332, BgL_arg2460z00_13362); } 
BgL_arg2458z00_13360 = BgL_list2459z00_13361; } 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2457z00_13359,BgL_arg2458z00_13360); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2461z00_13363;
BgL_arg2461z00_13363 = 
(BgL_spz00_13338+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2461z00_13363,BgL_a1z00_13330); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2462z00_13364;
BgL_arg2462z00_13364 = 
(BgL_spz00_13338+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2462z00_13364,BgL_a2z00_13331); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2463z00_13365;
BgL_arg2463z00_13365 = 
(BgL_spz00_13338+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2463z00_13365,BgL_a3z00_13332); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2464z00_13366;obj_t BgL_arg2465z00_13367;
BgL_arg2464z00_13366 = 
(BgL_spz00_13338+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2466z00_13368;
BgL_list2466z00_13368 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13333, BNIL); 
BgL_arg2465z00_13367 = BgL_list2466z00_13368; } 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2464z00_13366,BgL_arg2465z00_13367); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2467z00_13369;
BgL_arg2467z00_13369 = 
(BgL_spz00_13338+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2467z00_13369,BgL_a1z00_13330); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2468z00_13370;
BgL_arg2468z00_13370 = 
(BgL_spz00_13338+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2468z00_13370,BgL_a2z00_13331); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2469z00_13371;
BgL_arg2469z00_13371 = 
(BgL_spz00_13338+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2469z00_13371,BgL_a3z00_13332); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2470z00_13372;
BgL_arg2470z00_13372 = 
(BgL_spz00_13338+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2470z00_13372,BgL_a4z00_13333); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2471z00_13373;obj_t BgL_arg2472z00_13374;
BgL_arg2471z00_13373 = 
(BgL_spz00_13338+((long)4)); 
BgL_arg2472z00_13374 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10946),BgL_arg2471z00_13373,BgL_arg2472z00_13374); } break;
default: 
BgL_case_else1205z00_13343:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2474z00_13344;
BgL_arg2474z00_13344 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13334), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10943, BgL_arg2474z00_13344, 
(int)(((long)4)), 
CINT(BgL_arityz00_13335)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1205z00_13343;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13375;
BgL_z12denvz12_13375 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_13375, BgL_locz00_10943); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10946, 
BINT(BgL_spz00_13338), BgL_sfz00_13337))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13336, BgL_sz00_10946, 
BINT(BgL_spz00_13338));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13376;
BgL_nsz00_13376 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2476z00_13377;
BgL_arg2476z00_13377 = 
(BgL_spz00_13338+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13376, ((long)2), BgL_sz00_10946, 
BINT(BgL_spz00_13338), 
BINT(BgL_arg2476z00_13377)); } 
VECTOR_SET(BgL_nsz00_13376,((long)1),BgL_sz00_10946); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13375, BgL_nsz00_13376); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13378;
BgL_ez00_13378 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13378, BgL_sz00_10946); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13379;
BgL_____rz00_13379 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13336, BgL_nsz00_13376, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13378); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13375, BgL_sz00_10946); 
return BgL_____rz00_13379;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13329, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13380;
BgL_nbpz00_13380 = 
(
(long)CINT(BgL_bpz00_13328)+BgL_siza7eza7_10945); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),((long)0),
BINT(BgL_nbpz00_13380)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19558;
BgL_tmpz00_19558 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19558, BgL_locz00_10943); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13381;
BgL_rz00_13381 = 
PROCEDURE_ENTRY(BgL_fz00_13329)(BgL_fz00_13329, BgL_a1z00_13330, BgL_a2z00_13331, BgL_a3z00_13332, BgL_a4z00_13333, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10946),((long)0),BgL_bpz00_13328); 
return BgL_rz00_13381;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10943, BgL_symbzd2funzd2_10944, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13329));} } } } } } } } 

}



/* &<@anonymous:2480> */
obj_t BGl_z62zc3z04anonymousza32480ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10947, obj_t BgL_sz00_10956)
{
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_funz00_10948;obj_t BgL_a1z00_10949;obj_t BgL_a2z00_10950;obj_t BgL_a3z00_10951;obj_t BgL_a4z00_10952;obj_t BgL_locz00_10953;obj_t BgL_symbzd2funzd2_10954;long BgL_siza7eza7_10955;
BgL_funz00_10948 = 
PROCEDURE_REF(BgL_envz00_10947, 
(int)(((long)0))); 
BgL_a1z00_10949 = 
PROCEDURE_REF(BgL_envz00_10947, 
(int)(((long)1))); 
BgL_a2z00_10950 = 
PROCEDURE_REF(BgL_envz00_10947, 
(int)(((long)2))); 
BgL_a3z00_10951 = 
PROCEDURE_REF(BgL_envz00_10947, 
(int)(((long)3))); 
BgL_a4z00_10952 = 
PROCEDURE_REF(BgL_envz00_10947, 
(int)(((long)4))); 
BgL_locz00_10953 = 
PROCEDURE_REF(BgL_envz00_10947, 
(int)(((long)5))); 
BgL_symbzd2funzd2_10954 = 
PROCEDURE_REF(BgL_envz00_10947, 
(int)(((long)6))); 
BgL_siza7eza7_10955 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_10947, 
(int)(((long)7)))); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_bpz00_13382;
BgL_bpz00_13382 = 
VECTOR_REF(
((obj_t)BgL_sz00_10956),((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_fz00_13383;obj_t BgL_a1z00_13384;obj_t BgL_a2z00_13385;obj_t BgL_a3z00_13386;obj_t BgL_a4z00_13387;
BgL_fz00_13383 = 
PROCEDURE_ENTRY(BgL_funz00_10948)(BgL_funz00_10948, BgL_sz00_10956, BEOA); 
BgL_a1z00_13384 = 
PROCEDURE_ENTRY(BgL_a1z00_10949)(BgL_a1z00_10949, BgL_sz00_10956, BEOA); 
BgL_a2z00_13385 = 
PROCEDURE_ENTRY(BgL_a2z00_10950)(BgL_a2z00_10950, BgL_sz00_10956, BEOA); 
BgL_a3z00_13386 = 
PROCEDURE_ENTRY(BgL_a3z00_10951)(BgL_a3z00_10951, BgL_sz00_10956, BEOA); 
BgL_a4z00_13387 = 
PROCEDURE_ENTRY(BgL_a4z00_10952)(BgL_a4z00_10952, BgL_sz00_10956, BEOA); 
if(
PROCEDUREP(BgL_fz00_13383))
{ /* Eval/evaluate_comp.scm 896 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 896 */
BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_10953, BGl_string5246z00zz__evaluate_compz00, BGl_string5262z00zz__evaluate_compz00, BgL_fz00_13383); } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ufz00_13388;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_tmpz00_19615;
BgL_tmpz00_19615 = 
((obj_t)BgL_fz00_13383); 
BgL_ufz00_13388 = 
PROCEDURE_ATTR(BgL_tmpz00_19615); } 
{ /* Eval/evaluate_comp.scm 896 */
bool_t BgL_test5763z00_19618;
if(
STRUCTP(BgL_ufz00_13388))
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5763z00_19618 = 
(
STRUCT_KEY(BgL_ufz00_13388)==BGl_symbol5263z00zz__evaluate_compz00)
; }  else 
{ /* Eval/evaluate_comp.scm 683 */
BgL_test5763z00_19618 = ((bool_t)0)
; } 
if(BgL_test5763z00_19618)
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arityz00_13389;obj_t BgL_runz00_13390;obj_t BgL_sfz00_13391;
BgL_arityz00_13389 = 
STRUCT_REF(BgL_ufz00_13388, 
(int)(((long)0))); 
BgL_runz00_13390 = 
STRUCT_REF(BgL_ufz00_13388, 
(int)(((long)1))); 
BgL_sfz00_13391 = 
STRUCT_REF(BgL_ufz00_13388, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_spz00_13392;
BgL_spz00_13392 = 
(
(long)CINT(BgL_bpz00_13382)+BgL_siza7eza7_10955); 
if(
(
(long)CINT(BgL_arityz00_13389)==((long)4)))
{ /* Eval/evaluate_comp.scm 896 */
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2484z00_13393;
BgL_arg2484z00_13393 = 
(BgL_spz00_13392+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2484z00_13393,BgL_a1z00_13384); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2485z00_13394;
BgL_arg2485z00_13394 = 
(BgL_spz00_13392+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2485z00_13394,BgL_a2z00_13385); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2486z00_13395;
BgL_arg2486z00_13395 = 
(BgL_spz00_13392+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2486z00_13395,BgL_a3z00_13386); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2487z00_13396;
BgL_arg2487z00_13396 = 
(BgL_spz00_13392+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2487z00_13396,BgL_a4z00_13387); } }  else 
{ 

if(
INTEGERP(BgL_arityz00_13389))
{ /* Eval/evaluate_comp.scm 896 */
switch( 
(long)CINT(BgL_arityz00_13389)) { case ((long)-1) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2489z00_13399;obj_t BgL_arg2490z00_13400;
BgL_arg2489z00_13399 = 
(BgL_spz00_13392+((long)0)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2491z00_13401;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2492z00_13402;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2493z00_13403;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2494z00_13404;
BgL_arg2494z00_13404 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13387, BNIL); 
BgL_arg2493z00_13403 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13386, BgL_arg2494z00_13404); } 
BgL_arg2492z00_13402 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13385, BgL_arg2493z00_13403); } 
BgL_list2491z00_13401 = 
MAKE_YOUNG_PAIR(BgL_a1z00_13384, BgL_arg2492z00_13402); } 
BgL_arg2490z00_13400 = BgL_list2491z00_13401; } 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2489z00_13399,BgL_arg2490z00_13400); } break;case ((long)-2) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2495z00_13405;
BgL_arg2495z00_13405 = 
(BgL_spz00_13392+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2495z00_13405,BgL_a1z00_13384); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2496z00_13406;obj_t BgL_arg2497z00_13407;
BgL_arg2496z00_13406 = 
(BgL_spz00_13392+((long)1)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2498z00_13408;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2499z00_13409;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2500z00_13410;
BgL_arg2500z00_13410 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13387, BNIL); 
BgL_arg2499z00_13409 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13386, BgL_arg2500z00_13410); } 
BgL_list2498z00_13408 = 
MAKE_YOUNG_PAIR(BgL_a2z00_13385, BgL_arg2499z00_13409); } 
BgL_arg2497z00_13407 = BgL_list2498z00_13408; } 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2496z00_13406,BgL_arg2497z00_13407); } break;case ((long)-3) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2501z00_13411;
BgL_arg2501z00_13411 = 
(BgL_spz00_13392+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2501z00_13411,BgL_a1z00_13384); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2502z00_13412;
BgL_arg2502z00_13412 = 
(BgL_spz00_13392+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2502z00_13412,BgL_a2z00_13385); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2503z00_13413;obj_t BgL_arg2504z00_13414;
BgL_arg2503z00_13413 = 
(BgL_spz00_13392+((long)2)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2505z00_13415;
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2506z00_13416;
BgL_arg2506z00_13416 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13387, BNIL); 
BgL_list2505z00_13415 = 
MAKE_YOUNG_PAIR(BgL_a3z00_13386, BgL_arg2506z00_13416); } 
BgL_arg2504z00_13414 = BgL_list2505z00_13415; } 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2503z00_13413,BgL_arg2504z00_13414); } break;case ((long)-4) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2507z00_13417;
BgL_arg2507z00_13417 = 
(BgL_spz00_13392+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2507z00_13417,BgL_a1z00_13384); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2508z00_13418;
BgL_arg2508z00_13418 = 
(BgL_spz00_13392+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2508z00_13418,BgL_a2z00_13385); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2509z00_13419;
BgL_arg2509z00_13419 = 
(BgL_spz00_13392+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2509z00_13419,BgL_a3z00_13386); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2510z00_13420;obj_t BgL_arg2511z00_13421;
BgL_arg2510z00_13420 = 
(BgL_spz00_13392+((long)3)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_list2512z00_13422;
BgL_list2512z00_13422 = 
MAKE_YOUNG_PAIR(BgL_a4z00_13387, BNIL); 
BgL_arg2511z00_13421 = BgL_list2512z00_13422; } 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2510z00_13420,BgL_arg2511z00_13421); } break;case ((long)-5) : 

{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2513z00_13423;
BgL_arg2513z00_13423 = 
(BgL_spz00_13392+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2513z00_13423,BgL_a1z00_13384); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2514z00_13424;
BgL_arg2514z00_13424 = 
(BgL_spz00_13392+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2514z00_13424,BgL_a2z00_13385); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2515z00_13425;
BgL_arg2515z00_13425 = 
(BgL_spz00_13392+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2515z00_13425,BgL_a3z00_13386); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2516z00_13426;
BgL_arg2516z00_13426 = 
(BgL_spz00_13392+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2516z00_13426,BgL_a4z00_13387); } 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2517z00_13427;obj_t BgL_arg2518z00_13428;
BgL_arg2517z00_13427 = 
(BgL_spz00_13392+((long)4)); 
BgL_arg2518z00_13428 = BNIL; 
VECTOR_SET(
((obj_t)BgL_sz00_10956),BgL_arg2517z00_13427,BgL_arg2518z00_13428); } break;
default: 
BgL_case_else1207z00_13397:
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_arg2520z00_13398;
BgL_arg2520z00_13398 = 
STRUCT_REF(
((obj_t)BgL_ufz00_13388), 
(int)(((long)3))); 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10953, BgL_arg2520z00_13398, 
(int)(((long)4)), 
CINT(BgL_arityz00_13389)); } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
goto BgL_case_else1207z00_13397;} } 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_z12denvz12_13429;
BgL_z12denvz12_13429 = 
BGL_CURRENT_DYNAMIC_ENV(); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_10956, 
BINT(BgL_spz00_13392), BgL_sfz00_13391))
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13390, BgL_sz00_10956, 
BINT(BgL_spz00_13392));}  else 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_nsz00_13430;
BgL_nsz00_13430 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 896 */
long BgL_arg2522z00_13431;
BgL_arg2522z00_13431 = 
(BgL_spz00_13392+((long)4)); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_nsz00_13430, ((long)2), BgL_sz00_10956, 
BINT(BgL_spz00_13392), 
BINT(BgL_arg2522z00_13431)); } 
VECTOR_SET(BgL_nsz00_13430,((long)1),BgL_sz00_10956); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13429, BgL_nsz00_13430); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_ez00_13432;
BgL_ez00_13432 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13432, BgL_sz00_10956); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_____rz00_13433;
BgL_____rz00_13433 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_13390, BgL_nsz00_13430, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13432); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13429, BgL_sz00_10956); 
return BgL_____rz00_13433;} } } } } }  else 
{ /* Eval/evaluate_comp.scm 896 */
if(
PROCEDURE_CORRECT_ARITYP(BgL_fz00_13383, 
(int)(((long)4))))
{ /* Eval/evaluate_comp.scm 896 */
long BgL_nbpz00_13434;
BgL_nbpz00_13434 = 
(
(long)CINT(BgL_bpz00_13382)+BgL_siza7eza7_10955); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),((long)0),
BINT(BgL_nbpz00_13434)); 
{ /* Eval/evaluate_comp.scm 896 */
obj_t BgL_rz00_13435;
BgL_rz00_13435 = 
PROCEDURE_ENTRY(BgL_fz00_13383)(BgL_fz00_13383, BgL_a1z00_13384, BgL_a2z00_13385, BgL_a3z00_13386, BgL_a4z00_13387, BEOA); 
VECTOR_SET(
((obj_t)BgL_sz00_10956),((long)0),BgL_bpz00_13382); 
return BgL_rz00_13435;} }  else 
{ /* Eval/evaluate_comp.scm 896 */
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_10953, BgL_symbzd2funzd2_10954, 
(int)(((long)4)), 
PROCEDURE_ARITY(BgL_fz00_13383));} } } } } } } } 

}



/* is-constant-fun? */
obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185, obj_t BgL_symbzd2funzd2_186)
{
{ /* Eval/evaluate_comp.scm 899 */
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 903 */
obj_t BgL_gz00_3033;
{ /* Eval/evaluate_comp.scm 903 */
obj_t BgL_arg2532z00_3041;obj_t BgL_arg2533z00_3042;
BgL_arg2532z00_3041 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_funz00_183)))->BgL_modz00); 
BgL_arg2533z00_3042 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_funz00_183)))->BgL_namez00); 
BgL_gz00_3033 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2532z00_3041, BgL_arg2533z00_3042); } 
if(
CBOOL(BgL_gz00_3033))
{ /* Eval/evaluate_comp.scm 905 */
bool_t BgL_test5771z00_19760;
{ /* Eval/evaluate_comp.scm 905 */
int BgL_arg2531z00_3040;
{ /* Eval/evaluate_comp.scm 905 */
int BgL_res4580z00_8201;
BgL_res4580z00_8201 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_3033),((long)0))); 
BgL_arg2531z00_3040 = BgL_res4580z00_8201; } 
BgL_test5771z00_19760 = 
(
(long)(BgL_arg2531z00_3040)==((long)0)); } 
if(BgL_test5771z00_19760)
{ /* Eval/evaluate_comp.scm 906 */
obj_t BgL_valz00_3036;
BgL_valz00_3036 = 
VECTOR_REF(
((obj_t)BgL_gz00_3033),((long)2)); 
{ /* Eval/evaluate_comp.scm 907 */
bool_t BgL_test5772z00_19768;
if(
PROCEDUREP(BgL_valz00_3036))
{ /* Eval/evaluate_comp.scm 907 */
BgL_test5772z00_19768 = 
PROCEDURE_CORRECT_ARITYP(BgL_valz00_3036, 
(int)(BgL_nbargsz00_184))
; }  else 
{ /* Eval/evaluate_comp.scm 907 */
BgL_test5772z00_19768 = ((bool_t)0)
; } 
if(BgL_test5772z00_19768)
{ /* Eval/evaluate_comp.scm 907 */
return BgL_valz00_3036;}  else 
{ /* Eval/evaluate_comp.scm 907 */
return BFALSE;} } }  else 
{ /* Eval/evaluate_comp.scm 905 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 904 */
return BFALSE;} }  else 
{ /* Eval/evaluate_comp.scm 910 */
bool_t BgL_test5774z00_19773;
if(
BGl_isazf3zf3zz__objectz00(
((obj_t)BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 911 */
obj_t BgL_tmpz00_19777;
BgL_tmpz00_19777 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_test5774z00_19773 = 
PROCEDUREP(BgL_tmpz00_19777); }  else 
{ /* Eval/evaluate_comp.scm 910 */
BgL_test5774z00_19773 = ((bool_t)0)
; } 
if(BgL_test5774z00_19773)
{ /* Eval/evaluate_comp.scm 913 */
bool_t BgL_test5776z00_19781;
{ /* Eval/evaluate_comp.scm 913 */
obj_t BgL_arg2541z00_3052;
BgL_arg2541z00_3052 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_test5776z00_19781 = 
PROCEDURE_CORRECT_ARITYP(BgL_arg2541z00_3052, 
(int)(BgL_nbargsz00_184)); } 
if(BgL_test5776z00_19781)
{ /* Eval/evaluate_comp.scm 913 */
return 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00);}  else 
{ /* Eval/evaluate_comp.scm 915 */
int BgL_arg2539z00_3050;
{ /* Eval/evaluate_comp.scm 915 */
obj_t BgL_arg2540z00_3051;
BgL_arg2540z00_3051 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_funz00_183)))->BgL_valuez00); 
BgL_arg2539z00_3050 = 
PROCEDURE_ARITY(BgL_arg2540z00_3051); } 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185, BgL_symbzd2funzd2_186, 
(int)(BgL_nbargsz00_184), BgL_arg2539z00_3050);} }  else 
{ /* Eval/evaluate_comp.scm 910 */
return BFALSE;} } } 

}



/* compile-float-arith */
obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_exprz00_187, obj_t BgL_stkz00_188)
{
{ /* Eval/evaluate_comp.scm 918 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_littz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 922 */
if(
INTEGERP(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00)))
{ /* Eval/evaluate_comp.scm 924 */
obj_t BgL_v1346z00_3061;
BgL_v1346z00_3061 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1346z00_3061,((long)0),
BINT(((long)1))); 
{ /* Eval/evaluate_comp.scm 924 */
double BgL_arg2546z00_3062;
BgL_arg2546z00_3062 = 
(double)(
(long)CINT(
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00))); 
VECTOR_SET(BgL_v1346z00_3061,((long)1),
DOUBLE_TO_REAL(BgL_arg2546z00_3062)); } 
return BgL_v1346z00_3061;}  else 
{ /* Eval/evaluate_comp.scm 925 */
bool_t BgL_test5779z00_19808;
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_tmpz00_19809;
BgL_tmpz00_19809 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00); 
BgL_test5779z00_19808 = 
REALP(BgL_tmpz00_19809); } 
if(BgL_test5779z00_19808)
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_v1347z00_3066;
BgL_v1347z00_3066 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1347z00_3066,((long)0),
BINT(((long)1))); 
{ /* Eval/evaluate_comp.scm 925 */
obj_t BgL_arg2550z00_3067;
BgL_arg2550z00_3067 = 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_exprz00_187)))->BgL_valuez00); 
VECTOR_SET(BgL_v1347z00_3066,((long)1),BgL_arg2550z00_3067); } 
return BgL_v1347z00_3066;}  else 
{ /* Eval/evaluate_comp.scm 926 */
obj_t BgL_v1348z00_3068;
BgL_v1348z00_3068 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1348z00_3068,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 926 */
obj_t BgL_arg2551z00_3069;
BgL_arg2551z00_3069 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_littz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1348z00_3068,((long)1),BgL_arg2551z00_3069); } 
return BgL_v1348z00_3068;} } }  else 
{ /* Eval/evaluate_comp.scm 922 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_varz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 927 */
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_exprz00_187)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 930 */
obj_t BgL_v1349z00_3075;
BgL_v1349z00_3075 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1349z00_3075,((long)0),
BINT(((long)3))); 
VECTOR_SET(BgL_v1349z00_3075,((long)1),
BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187, BgL_stkz00_188)); 
return BgL_v1349z00_3075;}  else 
{ /* Eval/evaluate_comp.scm 931 */
obj_t BgL_v1350z00_3077;
BgL_v1350z00_3077 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1350z00_3077,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1350z00_3077,((long)1),
BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187, BgL_stkz00_188)); 
return BgL_v1350z00_3077;} }  else 
{ /* Eval/evaluate_comp.scm 927 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_globalz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 934 */
obj_t BgL_gz00_3081;
{ /* Eval/evaluate_comp.scm 934 */
obj_t BgL_arg2563z00_3089;obj_t BgL_arg2564z00_3090;
BgL_arg2563z00_3089 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_exprz00_187)))->BgL_modz00); 
BgL_arg2564z00_3090 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_exprz00_187)))->BgL_namez00); 
BgL_gz00_3081 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2563z00_3089, BgL_arg2564z00_3090); } 
if(
CBOOL(BgL_gz00_3081))
{ /* Eval/evaluate_comp.scm 936 */
bool_t BgL_test5784z00_19851;
{ /* Eval/evaluate_comp.scm 936 */
int BgL_arg2561z00_3086;
{ /* Eval/evaluate_comp.scm 936 */
int BgL_res4587z00_8224;
BgL_res4587z00_8224 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_3081),((long)0))); 
BgL_arg2561z00_3086 = BgL_res4587z00_8224; } 
BgL_test5784z00_19851 = 
(
BINT(BgL_arg2561z00_3086)==
BINT(((long)1))); } 
if(BgL_test5784z00_19851)
{ /* Eval/evaluate_comp.scm 937 */
obj_t BgL_v1351z00_3084;
BgL_v1351z00_3084 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1351z00_3084,((long)0),
BINT(((long)4))); 
VECTOR_SET(BgL_v1351z00_3084,((long)1),BgL_gz00_3081); 
return BgL_v1351z00_3084;}  else 
{ /* Eval/evaluate_comp.scm 938 */
obj_t BgL_v1352z00_3085;
BgL_v1352z00_3085 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1352z00_3085,((long)0),
BINT(((long)5))); 
VECTOR_SET(BgL_v1352z00_3085,((long)1),BgL_gz00_3081); 
return BgL_v1352z00_3085;} }  else 
{ /* Eval/evaluate_comp.scm 939 */
obj_t BgL_v1353z00_3087;
BgL_v1353z00_3087 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1353z00_3087,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 939 */
obj_t BgL_arg2562z00_3088;
BgL_arg2562z00_3088 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_globalz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1353z00_3087,((long)1),BgL_arg2562z00_3088); } 
return BgL_v1353z00_3087;} }  else 
{ /* Eval/evaluate_comp.scm 932 */
if(
BGl_isazf3zf3zz__objectz00(BgL_exprz00_187, BGl_ev_appz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 942 */
obj_t BgL_fvalz00_3093;
{ /* Eval/evaluate_comp.scm 942 */
BgL_ev_exprz00_bglt BgL_arg2606z00_3141;
BgL_arg2606z00_3141 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_funz00); 
BgL_fvalz00_3093 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_arg2606z00_3141); } 
if(
(BgL_fvalz00_3093==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_v1354z00_3095;
BgL_v1354z00_3095 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1354z00_3095,((long)0),
BINT(((long)6))); 
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2567z00_3096;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2568z00_3097;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_pairz00_8232;
BgL_pairz00_8232 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2568z00_3097 = 
CAR(BgL_pairz00_8232); } 
BgL_arg2567z00_3096 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2568z00_3097, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1354z00_3095,((long)1),BgL_arg2567z00_3096); } 
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2570z00_3099;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_arg2571z00_3100;
{ /* Eval/evaluate_comp.scm 945 */
obj_t BgL_pairz00_8234;
BgL_pairz00_8234 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2571z00_3100 = 
CAR(
CDR(BgL_pairz00_8234)); } 
BgL_arg2570z00_3099 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2571z00_3100, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1354z00_3095,((long)2),BgL_arg2570z00_3099); } 
return BgL_v1354z00_3095;}  else 
{ /* Eval/evaluate_comp.scm 944 */
if(
(BgL_fvalz00_3093==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_v1355z00_3103;
BgL_v1355z00_3103 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1355z00_3103,((long)0),
BINT(((long)7))); 
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2574z00_3104;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2575z00_3105;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_pairz00_8240;
BgL_pairz00_8240 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2575z00_3105 = 
CAR(BgL_pairz00_8240); } 
BgL_arg2574z00_3104 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2575z00_3105, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1355z00_3103,((long)1),BgL_arg2574z00_3104); } 
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2577z00_3107;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_arg2578z00_3108;
{ /* Eval/evaluate_comp.scm 947 */
obj_t BgL_pairz00_8242;
BgL_pairz00_8242 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2578z00_3108 = 
CAR(
CDR(BgL_pairz00_8242)); } 
BgL_arg2577z00_3107 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2578z00_3108, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1355z00_3103,((long)2),BgL_arg2577z00_3107); } 
return BgL_v1355z00_3103;}  else 
{ /* Eval/evaluate_comp.scm 946 */
if(
(BgL_fvalz00_3093==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_v1356z00_3111;
BgL_v1356z00_3111 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1356z00_3111,((long)0),
BINT(((long)8))); 
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2581z00_3112;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2582z00_3113;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_pairz00_8248;
BgL_pairz00_8248 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2582z00_3113 = 
CAR(BgL_pairz00_8248); } 
BgL_arg2581z00_3112 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2582z00_3113, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1356z00_3111,((long)1),BgL_arg2581z00_3112); } 
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2584z00_3115;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_arg2585z00_3116;
{ /* Eval/evaluate_comp.scm 949 */
obj_t BgL_pairz00_8250;
BgL_pairz00_8250 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2585z00_3116 = 
CAR(
CDR(BgL_pairz00_8250)); } 
BgL_arg2584z00_3115 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2585z00_3116, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1356z00_3111,((long)2),BgL_arg2584z00_3115); } 
return BgL_v1356z00_3111;}  else 
{ /* Eval/evaluate_comp.scm 948 */
if(
(BgL_fvalz00_3093==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_v1357z00_3119;
BgL_v1357z00_3119 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1357z00_3119,((long)0),
BINT(((long)9))); 
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2588z00_3120;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2589z00_3121;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_pairz00_8256;
BgL_pairz00_8256 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2589z00_3121 = 
CAR(BgL_pairz00_8256); } 
BgL_arg2588z00_3120 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2589z00_3121, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1357z00_3119,((long)1),BgL_arg2588z00_3120); } 
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2591z00_3123;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_arg2592z00_3124;
{ /* Eval/evaluate_comp.scm 951 */
obj_t BgL_pairz00_8258;
BgL_pairz00_8258 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2592z00_3124 = 
CAR(
CDR(BgL_pairz00_8258)); } 
BgL_arg2591z00_3123 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(BgL_arg2592z00_3124, BgL_stkz00_188); } 
VECTOR_SET(BgL_v1357z00_3119,((long)2),BgL_arg2591z00_3123); } 
return BgL_v1357z00_3119;}  else 
{ /* Eval/evaluate_comp.scm 950 */
if(
(BgL_fvalz00_3093==BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_v1358z00_3127;
BgL_v1358z00_3127 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1358z00_3127,((long)0),
BINT(((long)10))); 
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_arg2595z00_3128;
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_arg2596z00_3129;
{ /* Eval/evaluate_comp.scm 953 */
obj_t BgL_pairz00_8264;
BgL_pairz00_8264 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2596z00_3129 = 
CAR(BgL_pairz00_8264); } 
BgL_arg2595z00_3128 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2596z00_3129), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1358z00_3127,((long)1),BgL_arg2595z00_3128); } 
return BgL_v1358z00_3127;}  else 
{ /* Eval/evaluate_comp.scm 952 */
if(
(BgL_fvalz00_3093==BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_v1359z00_3132;
BgL_v1359z00_3132 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1359z00_3132,((long)0),
BINT(((long)11))); 
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2599z00_3133;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2600z00_3134;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_pairz00_8267;
BgL_pairz00_8267 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2600z00_3134 = 
CAR(BgL_pairz00_8267); } 
BgL_arg2599z00_3133 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2600z00_3134), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1359z00_3132,((long)1),BgL_arg2599z00_3133); } 
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2602z00_3136;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_arg2603z00_3137;
{ /* Eval/evaluate_comp.scm 955 */
obj_t BgL_pairz00_8269;
BgL_pairz00_8269 = 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_exprz00_187)))->BgL_argsz00); 
BgL_arg2603z00_3137 = 
CAR(
CDR(BgL_pairz00_8269)); } 
BgL_arg2602z00_3136 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg2603z00_3137), BgL_stkz00_188); } 
VECTOR_SET(BgL_v1359z00_3132,((long)2),BgL_arg2602z00_3136); } 
return BgL_v1359z00_3132;}  else 
{ /* Eval/evaluate_comp.scm 957 */
obj_t BgL_v1360z00_3139;
BgL_v1360z00_3139 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1360z00_3139,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 957 */
obj_t BgL_arg2605z00_3140;
BgL_arg2605z00_3140 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)
((BgL_ev_appz00_bglt)BgL_exprz00_187)), BgL_stkz00_188); 
VECTOR_SET(BgL_v1360z00_3139,((long)1),BgL_arg2605z00_3140); } 
return BgL_v1360z00_3139;} } } } } } }  else 
{ /* Eval/evaluate_comp.scm 958 */
obj_t BgL_v1361z00_3142;
BgL_v1361z00_3142 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1361z00_3142,((long)0),
BINT(((long)0))); 
{ /* Eval/evaluate_comp.scm 958 */
obj_t BgL_arg2607z00_3143;
BgL_arg2607z00_3143 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_exprz00_187), BgL_stkz00_188); 
VECTOR_SET(BgL_v1361z00_3142,((long)1),BgL_arg2607z00_3143); } 
return BgL_v1361z00_3142;} } } } } 

}



/* eval-float-arith */
double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189, obj_t BgL_sz00_190)
{
{ /* Eval/evaluate_comp.scm 960 */
return 
REAL_TO_DOUBLE(
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190, BgL_bcz00_189));} 

}



/* E~0 */
obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_12619, obj_t BgL_bcz00_3148)
{
{ /* Eval/evaluate_comp.scm 975 */
{ 

{ /* Eval/evaluate_comp.scm 962 */
obj_t BgL_aux1217z00_3151;
BgL_aux1217z00_3151 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)0)); 
if(
INTEGERP(BgL_aux1217z00_3151))
{ /* Eval/evaluate_comp.scm 962 */
switch( 
(long)CINT(BgL_aux1217z00_3151)) { case ((long)0) : 

{ /* Eval/evaluate_comp.scm 963 */
obj_t BgL_fun2611z00_3153;
BgL_fun2611z00_3153 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
return 
PROCEDURE_ENTRY(BgL_fun2611z00_3153)(BgL_fun2611z00_3153, BgL_sz00_12619, BEOA);} break;case ((long)1) : 

return 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1));break;case ((long)2) : 

{ /* Eval/evaluate_comp.scm 965 */
long BgL_arg2612z00_3154;
{ /* Eval/evaluate_comp.scm 965 */
obj_t BgL_arg2613z00_3155;obj_t BgL_arg2614z00_3156;
BgL_arg2613z00_3155 = 
VECTOR_REF(
((obj_t)BgL_sz00_12619),((long)0)); 
BgL_arg2614z00_3156 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2612z00_3154 = 
(
(long)CINT(BgL_arg2613z00_3155)+
(long)CINT(BgL_arg2614z00_3156)); } 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12619),BgL_arg2612z00_3154);} break;case ((long)3) : 

{ /* Eval/evaluate_comp.scm 966 */
obj_t BgL_arg2615z00_3157;
{ /* Eval/evaluate_comp.scm 966 */
long BgL_arg2616z00_3158;
{ /* Eval/evaluate_comp.scm 966 */
obj_t BgL_arg2617z00_3159;obj_t BgL_arg2618z00_3160;
BgL_arg2617z00_3159 = 
VECTOR_REF(
((obj_t)BgL_sz00_12619),((long)0)); 
BgL_arg2618z00_3160 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2616z00_3158 = 
(
(long)CINT(BgL_arg2617z00_3159)+
(long)CINT(BgL_arg2618z00_3160)); } 
BgL_arg2615z00_3157 = 
VECTOR_REF(
((obj_t)BgL_sz00_12619),BgL_arg2616z00_3158); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2615z00_3157), 
(int)(((long)0)));} break;case ((long)4) : 

{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_arg2619z00_3161;
{ /* Eval/evaluate_comp.scm 967 */
obj_t BgL_arg2620z00_3162;
BgL_arg2620z00_3162 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2619z00_3161 = 
VECTOR_REF(
((obj_t)BgL_arg2620z00_3162),((long)2)); } 
return 
__EVMEANING_ADDRESS_REF(BgL_arg2619z00_3161);} break;case ((long)5) : 

{ /* Eval/evaluate_comp.scm 968 */
obj_t BgL_arg2621z00_3163;
BgL_arg2621z00_3163 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
return 
VECTOR_REF(
((obj_t)BgL_arg2621z00_3163),((long)2));} break;case ((long)6) : 

{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2622z00_3164;obj_t BgL_arg2623z00_3165;
{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2624z00_3166;
BgL_arg2624z00_3166 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2622z00_3164 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12619, BgL_arg2624z00_3166); } 
{ /* Eval/evaluate_comp.scm 969 */
obj_t BgL_arg2625z00_3167;
BgL_arg2625z00_3167 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)2)); 
BgL_arg2623z00_3165 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12619, BgL_arg2625z00_3167); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2622z00_3164)+
REAL_TO_DOUBLE(BgL_arg2623z00_3165)));} break;case ((long)7) : 

{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2626z00_3168;obj_t BgL_arg2627z00_3169;
{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2628z00_3170;
BgL_arg2628z00_3170 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2626z00_3168 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12619, BgL_arg2628z00_3170); } 
{ /* Eval/evaluate_comp.scm 970 */
obj_t BgL_arg2629z00_3171;
BgL_arg2629z00_3171 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)2)); 
BgL_arg2627z00_3169 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12619, BgL_arg2629z00_3171); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2626z00_3168)-
REAL_TO_DOUBLE(BgL_arg2627z00_3169)));} break;case ((long)8) : 

{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2630z00_3172;obj_t BgL_arg2631z00_3173;
{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2632z00_3174;
BgL_arg2632z00_3174 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2630z00_3172 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12619, BgL_arg2632z00_3174); } 
{ /* Eval/evaluate_comp.scm 971 */
obj_t BgL_arg2633z00_3175;
BgL_arg2633z00_3175 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)2)); 
BgL_arg2631z00_3173 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12619, BgL_arg2633z00_3175); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2630z00_3172)*
REAL_TO_DOUBLE(BgL_arg2631z00_3173)));} break;case ((long)9) : 

{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2634z00_3176;obj_t BgL_arg2635z00_3177;
{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2636z00_3178;
BgL_arg2636z00_3178 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2634z00_3176 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12619, BgL_arg2636z00_3178); } 
{ /* Eval/evaluate_comp.scm 972 */
obj_t BgL_arg2637z00_3179;
BgL_arg2637z00_3179 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)2)); 
BgL_arg2635z00_3177 = 
BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_12619, BgL_arg2637z00_3179); } 
return 
DOUBLE_TO_REAL(
(
REAL_TO_DOUBLE(BgL_arg2634z00_3176)/
REAL_TO_DOUBLE(BgL_arg2635z00_3177)));} break;case ((long)10) : 

{ /* Eval/evaluate_comp.scm 973 */
obj_t BgL_arg2638z00_3180;
{ /* Eval/evaluate_comp.scm 973 */
obj_t BgL_fun2639z00_3181;
BgL_fun2639z00_3181 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2638z00_3180 = 
PROCEDURE_ENTRY(BgL_fun2639z00_3181)(BgL_fun2639z00_3181, BgL_sz00_12619, BEOA); } 
return 
DOUBLE_TO_REAL(
(double)(
(long)CINT(BgL_arg2638z00_3180)));} break;case ((long)11) : 

{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_arg2640z00_3182;obj_t BgL_arg2641z00_3183;
{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_fun2642z00_3184;
BgL_fun2642z00_3184 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)1)); 
BgL_arg2640z00_3182 = 
PROCEDURE_ENTRY(BgL_fun2642z00_3184)(BgL_fun2642z00_3184, BgL_sz00_12619, BEOA); } 
{ /* Eval/evaluate_comp.scm 974 */
obj_t BgL_fun2643z00_3185;
BgL_fun2643z00_3185 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)2)); 
BgL_arg2641z00_3183 = 
PROCEDURE_ENTRY(BgL_fun2643z00_3185)(BgL_fun2643z00_3185, BgL_sz00_12619, BEOA); } 
{ /* Eval/evaluate_comp.scm 974 */
double BgL_tmpz00_20089;
{ /* Eval/evaluate_comp.scm 974 */
long BgL_tmpz00_20090;
BgL_tmpz00_20090 = 
(long)CINT(BgL_arg2641z00_3183); 
BgL_tmpz00_20089 = 
BGL_F64VREF(BgL_arg2640z00_3182, BgL_tmpz00_20090); } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20089);} } break;
default: 
BgL_case_else1216z00_3150:
{ /* Eval/evaluate_comp.scm 975 */
obj_t BgL_arg2644z00_3186;
BgL_arg2644z00_3186 = 
VECTOR_REF(
((obj_t)BgL_bcz00_3148),((long)0)); 
return 
BGl_errorz00zz__errorz00(BGl_string5246z00zz__evaluate_compz00, BGl_string5265z00zz__evaluate_compz00, BgL_arg2644z00_3186);} } }  else 
{ /* Eval/evaluate_comp.scm 962 */
goto BgL_case_else1216z00_3150;} } } } 

}



/* arith-expression */
obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt BgL_exprz00_191, obj_t BgL_stkz00_192)
{
{ /* Eval/evaluate_comp.scm 978 */
{ /* Eval/evaluate_comp.scm 980 */
obj_t BgL_fvalz00_3189;
BgL_fvalz00_3189 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(BgL_exprz00_191))->BgL_funz00)); 
{ /* Eval/evaluate_comp.scm 981 */
bool_t BgL_test5793z00_20101;
if(
(BgL_fvalz00_3189==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test5793z00_20101 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
if(
(BgL_fvalz00_3189==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test5793z00_20101 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
if(
(BgL_fvalz00_3189==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 981 */
BgL_test5793z00_20101 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 981 */
BgL_test5793z00_20101 = 
(BgL_fvalz00_3189==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00)
; } } } 
if(BgL_test5793z00_20101)
{ /* Eval/evaluate_comp.scm 982 */
obj_t BgL_bcz00_3194;
BgL_bcz00_3194 = 
BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
((obj_t)BgL_exprz00_191), BgL_stkz00_192); 
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_zc3z04anonymousza32649ze3z87_10974;
BgL_zc3z04anonymousza32649ze3z87_10974 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32649ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32649ze3z87_10974, 
(int)(((long)0)), BgL_bcz00_3194); 
return BgL_zc3z04anonymousza32649ze3z87_10974;} }  else 
{ /* Eval/evaluate_comp.scm 981 */
return BFALSE;} } } } 

}



/* &<@anonymous:2649> */
obj_t BGl_z62zc3z04anonymousza32649ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_10975, obj_t BgL_sz00_10977)
{
{ /* Eval/evaluate_comp.scm 983 */
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_bcz00_10976;
BgL_bcz00_10976 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_10975, 
(int)(((long)0)))); 
{ /* Eval/evaluate_comp.scm 983 */
double BgL_tmpz00_20119;
{ /* Eval/evaluate_comp.scm 983 */
obj_t BgL_bpz00_13436;
BgL_bpz00_13436 = 
VECTOR_REF(
((obj_t)BgL_sz00_10977),((long)0)); 
BgL_tmpz00_20119 = 
BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_10976, BgL_sz00_10977); } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_20119);} } } 

}



/* inline-call */
obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193, BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195, obj_t BgL_stkz00_196)
{
{ /* Eval/evaluate_comp.scm 1012 */
{ /* Eval/evaluate_comp.scm 1013 */
obj_t BgL_valz00_3202;
BgL_valz00_3202 = 
BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194); 
if(
CBOOL(BgL_valz00_3202))
{ /* Eval/evaluate_comp.scm 1015 */
long BgL_nz00_3203;
BgL_nz00_3203 = 
bgl_list_length(BgL_argsz00_195); 
{ /* Eval/evaluate_comp.scm 1016 */
obj_t BgL__ortest_1223z00_3204;
if(
(BgL_nz00_3203==((long)1)))
{ /* Eval/evaluate_comp.scm 1017 */
obj_t BgL_a1z00_3495;
BgL_a1z00_3495 = 
CAR(
((obj_t)BgL_argsz00_195)); 
if(
(BgL_valz00_3202==BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3497;
BgL_a1z00_3497 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3495), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32766ze3z87_11007;
BgL_zc3z04anonymousza32766ze3z87_11007 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32766ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32766ze3z87_11007, 
(int)(((long)0)), BgL_a1z00_3497); 
PROCEDURE_SET(BgL_zc3z04anonymousza32766ze3z87_11007, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1223z00_3204 = BgL_zc3z04anonymousza32766ze3z87_11007; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
if(
(BgL_valz00_3202==BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3504;
BgL_a1z00_3504 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3495), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32769ze3z87_11008;
BgL_zc3z04anonymousza32769ze3z87_11008 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32769ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32769ze3z87_11008, 
(int)(((long)0)), BgL_a1z00_3504); 
PROCEDURE_SET(BgL_zc3z04anonymousza32769ze3z87_11008, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1223z00_3204 = BgL_zc3z04anonymousza32769ze3z87_11008; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
if(
(BgL_valz00_3202==BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_3511;
BgL_a1z00_3511 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3495), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_zc3z04anonymousza32772ze3z87_11009;
BgL_zc3z04anonymousza32772ze3z87_11009 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32772ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32772ze3z87_11009, 
(int)(((long)0)), BgL_a1z00_3511); 
PROCEDURE_SET(BgL_zc3z04anonymousza32772ze3z87_11009, 
(int)(((long)1)), BgL_locz00_193); 
BgL__ortest_1223z00_3204 = BgL_zc3z04anonymousza32772ze3z87_11009; } }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BgL__ortest_1223z00_3204 = BFALSE; } } } }  else 
{ /* Eval/evaluate_comp.scm 1016 */
BgL__ortest_1223z00_3204 = BFALSE; } 
if(
CBOOL(BgL__ortest_1223z00_3204))
{ /* Eval/evaluate_comp.scm 1016 */
return BgL__ortest_1223z00_3204;}  else 
{ /* Eval/evaluate_comp.scm 1016 */
if(
(BgL_nz00_3203==((long)2)))
{ /* Eval/evaluate_comp.scm 1020 */
obj_t BgL_a1z00_3206;obj_t BgL_a2z00_3207;
BgL_a1z00_3206 = 
CAR(
((obj_t)BgL_argsz00_195)); 
{ /* Eval/evaluate_comp.scm 1020 */
obj_t BgL_pairz00_8349;
BgL_pairz00_8349 = 
CDR(
((obj_t)BgL_argsz00_195)); 
BgL_a2z00_3207 = 
CAR(BgL_pairz00_8349); } 
if(
(BgL_valz00_3202==BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3209;obj_t BgL_a2z00_3210;
BgL_a1z00_3209 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3210 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32653ze3z87_10978;
BgL_zc3z04anonymousza32653ze3z87_10978 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32653ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32653ze3z87_10978, 
(int)(((long)0)), BgL_a1z00_3209); 
PROCEDURE_SET(BgL_zc3z04anonymousza32653ze3z87_10978, 
(int)(((long)1)), BgL_a2z00_3210); 
PROCEDURE_SET(BgL_zc3z04anonymousza32653ze3z87_10978, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32653ze3z87_10978;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3219;obj_t BgL_a2z00_3220;
BgL_a1z00_3219 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3220 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32657ze3z87_10979;
BgL_zc3z04anonymousza32657ze3z87_10979 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32657ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32657ze3z87_10979, 
(int)(((long)0)), BgL_a1z00_3219); 
PROCEDURE_SET(BgL_zc3z04anonymousza32657ze3z87_10979, 
(int)(((long)1)), BgL_a2z00_3220); 
PROCEDURE_SET(BgL_zc3z04anonymousza32657ze3z87_10979, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32657ze3z87_10979;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_za2zd2envz70zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3229;obj_t BgL_a2z00_3230;
BgL_a1z00_3229 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3230 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32661ze3z87_10980;
BgL_zc3z04anonymousza32661ze3z87_10980 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32661ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32661ze3z87_10980, 
(int)(((long)0)), BgL_a1z00_3229); 
PROCEDURE_SET(BgL_zc3z04anonymousza32661ze3z87_10980, 
(int)(((long)1)), BgL_a2z00_3230); 
PROCEDURE_SET(BgL_zc3z04anonymousza32661ze3z87_10980, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32661ze3z87_10980;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3239;obj_t BgL_a2z00_3240;
BgL_a1z00_3239 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3240 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32665ze3z87_10981;
BgL_zc3z04anonymousza32665ze3z87_10981 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32665ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32665ze3z87_10981, 
(int)(((long)0)), BgL_a1z00_3239); 
PROCEDURE_SET(BgL_zc3z04anonymousza32665ze3z87_10981, 
(int)(((long)1)), BgL_a2z00_3240); 
PROCEDURE_SET(BgL_zc3z04anonymousza32665ze3z87_10981, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32665ze3z87_10981;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3249;obj_t BgL_a2z00_3250;
BgL_a1z00_3249 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3250 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32669ze3z87_10982;
BgL_zc3z04anonymousza32669ze3z87_10982 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32669ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32669ze3z87_10982, 
(int)(((long)0)), BgL_a1z00_3249); 
PROCEDURE_SET(BgL_zc3z04anonymousza32669ze3z87_10982, 
(int)(((long)1)), BgL_a2z00_3250); 
PROCEDURE_SET(BgL_zc3z04anonymousza32669ze3z87_10982, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32669ze3z87_10982;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3259;obj_t BgL_a2z00_3260;
BgL_a1z00_3259 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3260 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32673ze3z87_10983;
BgL_zc3z04anonymousza32673ze3z87_10983 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32673ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32673ze3z87_10983, 
(int)(((long)0)), BgL_a1z00_3259); 
PROCEDURE_SET(BgL_zc3z04anonymousza32673ze3z87_10983, 
(int)(((long)1)), BgL_a2z00_3260); 
PROCEDURE_SET(BgL_zc3z04anonymousza32673ze3z87_10983, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32673ze3z87_10983;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3269;obj_t BgL_a2z00_3270;
BgL_a1z00_3269 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3270 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32677ze3z87_10984;
BgL_zc3z04anonymousza32677ze3z87_10984 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32677ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32677ze3z87_10984, 
(int)(((long)0)), BgL_a1z00_3269); 
PROCEDURE_SET(BgL_zc3z04anonymousza32677ze3z87_10984, 
(int)(((long)1)), BgL_a2z00_3270); 
PROCEDURE_SET(BgL_zc3z04anonymousza32677ze3z87_10984, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32677ze3z87_10984;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3279;obj_t BgL_a2z00_3280;
BgL_a1z00_3279 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3280 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32681ze3z87_10985;
BgL_zc3z04anonymousza32681ze3z87_10985 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32681ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32681ze3z87_10985, 
(int)(((long)0)), BgL_a1z00_3279); 
PROCEDURE_SET(BgL_zc3z04anonymousza32681ze3z87_10985, 
(int)(((long)1)), BgL_a2z00_3280); 
PROCEDURE_SET(BgL_zc3z04anonymousza32681ze3z87_10985, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32681ze3z87_10985;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3289;obj_t BgL_a2z00_3290;
BgL_a1z00_3289 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3290 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32685ze3z87_10986;
BgL_zc3z04anonymousza32685ze3z87_10986 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32685ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32685ze3z87_10986, 
(int)(((long)0)), BgL_a1z00_3289); 
PROCEDURE_SET(BgL_zc3z04anonymousza32685ze3z87_10986, 
(int)(((long)1)), BgL_a2z00_3290); 
PROCEDURE_SET(BgL_zc3z04anonymousza32685ze3z87_10986, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32685ze3z87_10986;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3299;obj_t BgL_a2z00_3300;
BgL_a1z00_3299 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3300 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32689ze3z87_10987;
BgL_zc3z04anonymousza32689ze3z87_10987 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32689ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32689ze3z87_10987, 
(int)(((long)0)), BgL_a1z00_3299); 
PROCEDURE_SET(BgL_zc3z04anonymousza32689ze3z87_10987, 
(int)(((long)1)), BgL_a2z00_3300); 
PROCEDURE_SET(BgL_zc3z04anonymousza32689ze3z87_10987, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32689ze3z87_10987;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3309;obj_t BgL_a2z00_3310;
BgL_a1z00_3309 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3310 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32693ze3z87_10988;
BgL_zc3z04anonymousza32693ze3z87_10988 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32693ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32693ze3z87_10988, 
(int)(((long)0)), BgL_a1z00_3309); 
PROCEDURE_SET(BgL_zc3z04anonymousza32693ze3z87_10988, 
(int)(((long)1)), BgL_a2z00_3310); 
PROCEDURE_SET(BgL_zc3z04anonymousza32693ze3z87_10988, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32693ze3z87_10988;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3319;obj_t BgL_a2z00_3320;
BgL_a1z00_3319 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3320 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32697ze3z87_10989;
BgL_zc3z04anonymousza32697ze3z87_10989 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32697ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32697ze3z87_10989, 
(int)(((long)0)), BgL_a1z00_3319); 
PROCEDURE_SET(BgL_zc3z04anonymousza32697ze3z87_10989, 
(int)(((long)1)), BgL_a2z00_3320); 
PROCEDURE_SET(BgL_zc3z04anonymousza32697ze3z87_10989, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32697ze3z87_10989;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3329;obj_t BgL_a2z00_3330;
BgL_a1z00_3329 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3330 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32701ze3z87_10990;
BgL_zc3z04anonymousza32701ze3z87_10990 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32701ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32701ze3z87_10990, 
(int)(((long)0)), BgL_a1z00_3329); 
PROCEDURE_SET(BgL_zc3z04anonymousza32701ze3z87_10990, 
(int)(((long)1)), BgL_a2z00_3330); 
PROCEDURE_SET(BgL_zc3z04anonymousza32701ze3z87_10990, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32701ze3z87_10990;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3339;obj_t BgL_a2z00_3340;
BgL_a1z00_3339 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3340 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32705ze3z87_10991;
BgL_zc3z04anonymousza32705ze3z87_10991 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32705ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32705ze3z87_10991, 
(int)(((long)0)), BgL_a1z00_3339); 
PROCEDURE_SET(BgL_zc3z04anonymousza32705ze3z87_10991, 
(int)(((long)1)), BgL_a2z00_3340); 
PROCEDURE_SET(BgL_zc3z04anonymousza32705ze3z87_10991, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32705ze3z87_10991;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3349;obj_t BgL_a2z00_3350;
BgL_a1z00_3349 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3350 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32709ze3z87_10992;
BgL_zc3z04anonymousza32709ze3z87_10992 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32709ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32709ze3z87_10992, 
(int)(((long)0)), BgL_a1z00_3349); 
PROCEDURE_SET(BgL_zc3z04anonymousza32709ze3z87_10992, 
(int)(((long)1)), BgL_a2z00_3350); 
PROCEDURE_SET(BgL_zc3z04anonymousza32709ze3z87_10992, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32709ze3z87_10992;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3359;obj_t BgL_a2z00_3360;
BgL_a1z00_3359 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3360 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32713ze3z87_10993;
BgL_zc3z04anonymousza32713ze3z87_10993 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32713ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32713ze3z87_10993, 
(int)(((long)0)), BgL_a1z00_3359); 
PROCEDURE_SET(BgL_zc3z04anonymousza32713ze3z87_10993, 
(int)(((long)1)), BgL_a2z00_3360); 
PROCEDURE_SET(BgL_zc3z04anonymousza32713ze3z87_10993, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32713ze3z87_10993;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3369;obj_t BgL_a2z00_3370;
BgL_a1z00_3369 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3370 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32717ze3z87_10994;
BgL_zc3z04anonymousza32717ze3z87_10994 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32717ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32717ze3z87_10994, 
(int)(((long)0)), BgL_a1z00_3369); 
PROCEDURE_SET(BgL_zc3z04anonymousza32717ze3z87_10994, 
(int)(((long)1)), BgL_a2z00_3370); 
PROCEDURE_SET(BgL_zc3z04anonymousza32717ze3z87_10994, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32717ze3z87_10994;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3379;obj_t BgL_a2z00_3380;
BgL_a1z00_3379 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3380 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32721ze3z87_10995;
BgL_zc3z04anonymousza32721ze3z87_10995 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32721ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32721ze3z87_10995, 
(int)(((long)0)), BgL_a1z00_3379); 
PROCEDURE_SET(BgL_zc3z04anonymousza32721ze3z87_10995, 
(int)(((long)1)), BgL_a2z00_3380); 
PROCEDURE_SET(BgL_zc3z04anonymousza32721ze3z87_10995, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32721ze3z87_10995;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3389;obj_t BgL_a2z00_3390;
BgL_a1z00_3389 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3390 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32725ze3z87_10996;
BgL_zc3z04anonymousza32725ze3z87_10996 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32725ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32725ze3z87_10996, 
(int)(((long)0)), BgL_a1z00_3389); 
PROCEDURE_SET(BgL_zc3z04anonymousza32725ze3z87_10996, 
(int)(((long)1)), BgL_a2z00_3390); 
PROCEDURE_SET(BgL_zc3z04anonymousza32725ze3z87_10996, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32725ze3z87_10996;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3399;obj_t BgL_a2z00_3400;
BgL_a1z00_3399 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3400 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32729ze3z87_10997;
BgL_zc3z04anonymousza32729ze3z87_10997 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32729ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32729ze3z87_10997, 
(int)(((long)0)), BgL_a1z00_3399); 
PROCEDURE_SET(BgL_zc3z04anonymousza32729ze3z87_10997, 
(int)(((long)1)), BgL_a2z00_3400); 
PROCEDURE_SET(BgL_zc3z04anonymousza32729ze3z87_10997, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32729ze3z87_10997;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3409;obj_t BgL_a2z00_3410;
BgL_a1z00_3409 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3410 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32733ze3z87_10998;
BgL_zc3z04anonymousza32733ze3z87_10998 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32733ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32733ze3z87_10998, 
(int)(((long)0)), BgL_a1z00_3409); 
PROCEDURE_SET(BgL_zc3z04anonymousza32733ze3z87_10998, 
(int)(((long)1)), BgL_a2z00_3410); 
PROCEDURE_SET(BgL_zc3z04anonymousza32733ze3z87_10998, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32733ze3z87_10998;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3419;obj_t BgL_a2z00_3420;
BgL_a1z00_3419 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3420 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32737ze3z87_10999;
BgL_zc3z04anonymousza32737ze3z87_10999 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32737ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32737ze3z87_10999, 
(int)(((long)0)), BgL_a1z00_3419); 
PROCEDURE_SET(BgL_zc3z04anonymousza32737ze3z87_10999, 
(int)(((long)1)), BgL_a2z00_3420); 
PROCEDURE_SET(BgL_zc3z04anonymousza32737ze3z87_10999, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32737ze3z87_10999;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3429;obj_t BgL_a2z00_3430;
BgL_a1z00_3429 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3430 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32741ze3z87_11000;
BgL_zc3z04anonymousza32741ze3z87_11000 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32741ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32741ze3z87_11000, 
(int)(((long)0)), BgL_a1z00_3429); 
PROCEDURE_SET(BgL_zc3z04anonymousza32741ze3z87_11000, 
(int)(((long)1)), BgL_a2z00_3430); 
PROCEDURE_SET(BgL_zc3z04anonymousza32741ze3z87_11000, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32741ze3z87_11000;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3439;obj_t BgL_a2z00_3440;
BgL_a1z00_3439 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3440 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32745ze3z87_11001;
BgL_zc3z04anonymousza32745ze3z87_11001 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32745ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32745ze3z87_11001, 
(int)(((long)0)), BgL_a1z00_3439); 
PROCEDURE_SET(BgL_zc3z04anonymousza32745ze3z87_11001, 
(int)(((long)1)), BgL_a2z00_3440); 
PROCEDURE_SET(BgL_zc3z04anonymousza32745ze3z87_11001, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32745ze3z87_11001;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3449;obj_t BgL_a2z00_3450;
BgL_a1z00_3449 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3450 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32749ze3z87_11002;
BgL_zc3z04anonymousza32749ze3z87_11002 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32749ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32749ze3z87_11002, 
(int)(((long)0)), BgL_a1z00_3449); 
PROCEDURE_SET(BgL_zc3z04anonymousza32749ze3z87_11002, 
(int)(((long)1)), BgL_a2z00_3450); 
PROCEDURE_SET(BgL_zc3z04anonymousza32749ze3z87_11002, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32749ze3z87_11002;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3459;obj_t BgL_a2z00_3460;
BgL_a1z00_3459 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3460 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32753ze3z87_11003;
BgL_zc3z04anonymousza32753ze3z87_11003 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32753ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32753ze3z87_11003, 
(int)(((long)0)), BgL_a1z00_3459); 
PROCEDURE_SET(BgL_zc3z04anonymousza32753ze3z87_11003, 
(int)(((long)1)), BgL_a2z00_3460); 
PROCEDURE_SET(BgL_zc3z04anonymousza32753ze3z87_11003, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32753ze3z87_11003;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3469;obj_t BgL_a2z00_3470;
BgL_a1z00_3469 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3470 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32757ze3z87_11004;
BgL_zc3z04anonymousza32757ze3z87_11004 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32757ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32757ze3z87_11004, 
(int)(((long)0)), BgL_a1z00_3469); 
PROCEDURE_SET(BgL_zc3z04anonymousza32757ze3z87_11004, 
(int)(((long)1)), BgL_a2z00_3470); 
PROCEDURE_SET(BgL_zc3z04anonymousza32757ze3z87_11004, 
(int)(((long)2)), BgL_locz00_193); 
return BgL_zc3z04anonymousza32757ze3z87_11004;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3479;obj_t BgL_a2z00_3480;
BgL_a1z00_3479 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3480 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32761ze3z87_11005;
BgL_zc3z04anonymousza32761ze3z87_11005 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32761ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32761ze3z87_11005, 
(int)(((long)0)), BgL_a1z00_3479); 
PROCEDURE_SET(BgL_zc3z04anonymousza32761ze3z87_11005, 
(int)(((long)1)), BgL_a2z00_3480); 
return BgL_zc3z04anonymousza32761ze3z87_11005;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
if(
(BgL_valz00_3202==BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_3487;obj_t BgL_a2z00_3488;
BgL_a1z00_3487 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a1z00_3206), BgL_stkz00_196); 
BgL_a2z00_3488 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_a2z00_3207), BgL_stkz00_196); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_zc3z04anonymousza32763ze3z87_11006;
BgL_zc3z04anonymousza32763ze3z87_11006 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32763ze3z87_11006, 
(int)(((long)0)), BgL_a1z00_3487); 
PROCEDURE_SET(BgL_zc3z04anonymousza32763ze3z87_11006, 
(int)(((long)1)), BgL_a2z00_3488); 
return BgL_zc3z04anonymousza32763ze3z87_11006;} }  else 
{ /* Eval/evaluate_comp.scm 1021 */
return BFALSE;} } } } } } } } } } } } } } } } } } } } } } } } } } } } } }  else 
{ /* Eval/evaluate_comp.scm 1019 */
return BFALSE;} } } }  else 
{ /* Eval/evaluate_comp.scm 1014 */
return BFALSE;} } } 

}



/* &<@anonymous:2653> */
obj_t BGl_z62zc3z04anonymousza32653ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11010, obj_t BgL_sz00_11014)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11011;obj_t BgL_a2z00_11012;obj_t BgL_locz00_11013;
BgL_a1z00_11011 = 
PROCEDURE_REF(BgL_envz00_11010, 
(int)(((long)0))); 
BgL_a2z00_11012 = 
PROCEDURE_REF(BgL_envz00_11010, 
(int)(((long)1))); 
BgL_locz00_11013 = 
PROCEDURE_REF(BgL_envz00_11010, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13437;
BgL_bpz00_13437 = 
VECTOR_REF(
((obj_t)BgL_sz00_11014),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13438;obj_t BgL_a2z00_13439;
BgL_a1z00_13438 = 
PROCEDURE_ENTRY(BgL_a1z00_11011)(BgL_a1z00_11011, BgL_sz00_11014, BEOA); 
BgL_a2z00_13439 = 
PROCEDURE_ENTRY(BgL_a2z00_11012)(BgL_a2z00_11012, BgL_sz00_11014, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13438))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5266z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13438, BgL_locz00_11013); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13439))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5266z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13439, BgL_locz00_11013); } 
return 
BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_13438, BgL_a2z00_13439);} } } } 

}



/* &<@anonymous:2657> */
obj_t BGl_z62zc3z04anonymousza32657ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11015, obj_t BgL_sz00_11019)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11016;obj_t BgL_a2z00_11017;obj_t BgL_locz00_11018;
BgL_a1z00_11016 = 
PROCEDURE_REF(BgL_envz00_11015, 
(int)(((long)0))); 
BgL_a2z00_11017 = 
PROCEDURE_REF(BgL_envz00_11015, 
(int)(((long)1))); 
BgL_locz00_11018 = 
PROCEDURE_REF(BgL_envz00_11015, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13440;
BgL_bpz00_13440 = 
VECTOR_REF(
((obj_t)BgL_sz00_11019),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13441;obj_t BgL_a2z00_13442;
BgL_a1z00_13441 = 
PROCEDURE_ENTRY(BgL_a1z00_11016)(BgL_a1z00_11016, BgL_sz00_11019, BEOA); 
BgL_a2z00_13442 = 
PROCEDURE_ENTRY(BgL_a2z00_11017)(BgL_a2z00_11017, BgL_sz00_11019, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13441))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5270z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13441, BgL_locz00_11018); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13442))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5270z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13442, BgL_locz00_11018); } 
return 
BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_13441, BgL_a2z00_13442);} } } } 

}



/* &<@anonymous:2661> */
obj_t BGl_z62zc3z04anonymousza32661ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11020, obj_t BgL_sz00_11024)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11021;obj_t BgL_a2z00_11022;obj_t BgL_locz00_11023;
BgL_a1z00_11021 = 
PROCEDURE_REF(BgL_envz00_11020, 
(int)(((long)0))); 
BgL_a2z00_11022 = 
PROCEDURE_REF(BgL_envz00_11020, 
(int)(((long)1))); 
BgL_locz00_11023 = 
PROCEDURE_REF(BgL_envz00_11020, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13443;
BgL_bpz00_13443 = 
VECTOR_REF(
((obj_t)BgL_sz00_11024),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13444;obj_t BgL_a2z00_13445;
BgL_a1z00_13444 = 
PROCEDURE_ENTRY(BgL_a1z00_11021)(BgL_a1z00_11021, BgL_sz00_11024, BEOA); 
BgL_a2z00_13445 = 
PROCEDURE_ENTRY(BgL_a2z00_11022)(BgL_a2z00_11022, BgL_sz00_11024, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13444))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5272z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13444, BgL_locz00_11023); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13445))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5272z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13445, BgL_locz00_11023); } 
return 
BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_13444, BgL_a2z00_13445);} } } } 

}



/* &<@anonymous:2665> */
obj_t BGl_z62zc3z04anonymousza32665ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11025, obj_t BgL_sz00_11029)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11026;obj_t BgL_a2z00_11027;obj_t BgL_locz00_11028;
BgL_a1z00_11026 = 
PROCEDURE_REF(BgL_envz00_11025, 
(int)(((long)0))); 
BgL_a2z00_11027 = 
PROCEDURE_REF(BgL_envz00_11025, 
(int)(((long)1))); 
BgL_locz00_11028 = 
PROCEDURE_REF(BgL_envz00_11025, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13446;
BgL_bpz00_13446 = 
VECTOR_REF(
((obj_t)BgL_sz00_11029),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13447;obj_t BgL_a2z00_13448;
BgL_a1z00_13447 = 
PROCEDURE_ENTRY(BgL_a1z00_11026)(BgL_a1z00_11026, BgL_sz00_11029, BEOA); 
BgL_a2z00_13448 = 
PROCEDURE_ENTRY(BgL_a2z00_11027)(BgL_a2z00_11027, BgL_sz00_11029, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13447))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5274z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13447, BgL_locz00_11028); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13448))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5274z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13448, BgL_locz00_11028); } 
return 
BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_13447, BgL_a2z00_13448);} } } } 

}



/* &<@anonymous:2669> */
obj_t BGl_z62zc3z04anonymousza32669ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11030, obj_t BgL_sz00_11034)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11031;obj_t BgL_a2z00_11032;obj_t BgL_locz00_11033;
BgL_a1z00_11031 = 
PROCEDURE_REF(BgL_envz00_11030, 
(int)(((long)0))); 
BgL_a2z00_11032 = 
PROCEDURE_REF(BgL_envz00_11030, 
(int)(((long)1))); 
BgL_locz00_11033 = 
PROCEDURE_REF(BgL_envz00_11030, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20703;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13449;
BgL_bpz00_13449 = 
VECTOR_REF(
((obj_t)BgL_sz00_11034),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13450;obj_t BgL_a2z00_13451;
BgL_a1z00_13450 = 
PROCEDURE_ENTRY(BgL_a1z00_11031)(BgL_a1z00_11031, BgL_sz00_11034, BEOA); 
BgL_a2z00_13451 = 
PROCEDURE_ENTRY(BgL_a2z00_11032)(BgL_a2z00_11032, BgL_sz00_11034, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13450))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5276z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13450, BgL_locz00_11033); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13451))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5276z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13451, BgL_locz00_11033); } 
BgL_tmpz00_20703 = 
BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_13450, BgL_a2z00_13451); } } 
return 
BBOOL(BgL_tmpz00_20703);} } } 

}



/* &<@anonymous:2673> */
obj_t BGl_z62zc3z04anonymousza32673ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11035, obj_t BgL_sz00_11039)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11036;obj_t BgL_a2z00_11037;obj_t BgL_locz00_11038;
BgL_a1z00_11036 = 
PROCEDURE_REF(BgL_envz00_11035, 
(int)(((long)0))); 
BgL_a2z00_11037 = 
PROCEDURE_REF(BgL_envz00_11035, 
(int)(((long)1))); 
BgL_locz00_11038 = 
PROCEDURE_REF(BgL_envz00_11035, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20728;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13452;
BgL_bpz00_13452 = 
VECTOR_REF(
((obj_t)BgL_sz00_11039),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13453;obj_t BgL_a2z00_13454;
BgL_a1z00_13453 = 
PROCEDURE_ENTRY(BgL_a1z00_11036)(BgL_a1z00_11036, BgL_sz00_11039, BEOA); 
BgL_a2z00_13454 = 
PROCEDURE_ENTRY(BgL_a2z00_11037)(BgL_a2z00_11037, BgL_sz00_11039, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13453))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5278z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13453, BgL_locz00_11038); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13454))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5278z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13454, BgL_locz00_11038); } 
BgL_tmpz00_20728 = 
BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_13453, BgL_a2z00_13454); } } 
return 
BBOOL(BgL_tmpz00_20728);} } } 

}



/* &<@anonymous:2677> */
obj_t BGl_z62zc3z04anonymousza32677ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11040, obj_t BgL_sz00_11044)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11041;obj_t BgL_a2z00_11042;obj_t BgL_locz00_11043;
BgL_a1z00_11041 = 
PROCEDURE_REF(BgL_envz00_11040, 
(int)(((long)0))); 
BgL_a2z00_11042 = 
PROCEDURE_REF(BgL_envz00_11040, 
(int)(((long)1))); 
BgL_locz00_11043 = 
PROCEDURE_REF(BgL_envz00_11040, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20753;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13455;
BgL_bpz00_13455 = 
VECTOR_REF(
((obj_t)BgL_sz00_11044),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13456;obj_t BgL_a2z00_13457;
BgL_a1z00_13456 = 
PROCEDURE_ENTRY(BgL_a1z00_11041)(BgL_a1z00_11041, BgL_sz00_11044, BEOA); 
BgL_a2z00_13457 = 
PROCEDURE_ENTRY(BgL_a2z00_11042)(BgL_a2z00_11042, BgL_sz00_11044, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13456))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5280z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13456, BgL_locz00_11043); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13457))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5280z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13457, BgL_locz00_11043); } 
BgL_tmpz00_20753 = 
BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_13456, BgL_a2z00_13457); } } 
return 
BBOOL(BgL_tmpz00_20753);} } } 

}



/* &<@anonymous:2681> */
obj_t BGl_z62zc3z04anonymousza32681ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11045, obj_t BgL_sz00_11049)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11046;obj_t BgL_a2z00_11047;obj_t BgL_locz00_11048;
BgL_a1z00_11046 = 
PROCEDURE_REF(BgL_envz00_11045, 
(int)(((long)0))); 
BgL_a2z00_11047 = 
PROCEDURE_REF(BgL_envz00_11045, 
(int)(((long)1))); 
BgL_locz00_11048 = 
PROCEDURE_REF(BgL_envz00_11045, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20778;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13458;
BgL_bpz00_13458 = 
VECTOR_REF(
((obj_t)BgL_sz00_11049),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13459;obj_t BgL_a2z00_13460;
BgL_a1z00_13459 = 
PROCEDURE_ENTRY(BgL_a1z00_11046)(BgL_a1z00_11046, BgL_sz00_11049, BEOA); 
BgL_a2z00_13460 = 
PROCEDURE_ENTRY(BgL_a2z00_11047)(BgL_a2z00_11047, BgL_sz00_11049, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13459))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5282z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13459, BgL_locz00_11048); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13460))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5282z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13460, BgL_locz00_11048); } 
BgL_tmpz00_20778 = 
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_13459, BgL_a2z00_13460); } } 
return 
BBOOL(BgL_tmpz00_20778);} } } 

}



/* &<@anonymous:2685> */
obj_t BGl_z62zc3z04anonymousza32685ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11050, obj_t BgL_sz00_11054)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11051;obj_t BgL_a2z00_11052;obj_t BgL_locz00_11053;
BgL_a1z00_11051 = 
PROCEDURE_REF(BgL_envz00_11050, 
(int)(((long)0))); 
BgL_a2z00_11052 = 
PROCEDURE_REF(BgL_envz00_11050, 
(int)(((long)1))); 
BgL_locz00_11053 = 
PROCEDURE_REF(BgL_envz00_11050, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20803;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13461;
BgL_bpz00_13461 = 
VECTOR_REF(
((obj_t)BgL_sz00_11054),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13462;obj_t BgL_a2z00_13463;
BgL_a1z00_13462 = 
PROCEDURE_ENTRY(BgL_a1z00_11051)(BgL_a1z00_11051, BgL_sz00_11054, BEOA); 
BgL_a2z00_13463 = 
PROCEDURE_ENTRY(BgL_a2z00_11052)(BgL_a2z00_11052, BgL_sz00_11054, BEOA); 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_13462))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5284z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a1z00_13462, BgL_locz00_11053); } 
if(
BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_13463))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5284z00zz__evaluate_compz00, BGl_symbol5268z00zz__evaluate_compz00, BgL_a2z00_13463, BgL_locz00_11053); } 
BgL_tmpz00_20803 = 
BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_13462, BgL_a2z00_13463); } } 
return 
BBOOL(BgL_tmpz00_20803);} } } 

}



/* &<@anonymous:2689> */
obj_t BGl_z62zc3z04anonymousza32689ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11055, obj_t BgL_sz00_11059)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11056;obj_t BgL_a2z00_11057;obj_t BgL_locz00_11058;
BgL_a1z00_11056 = 
PROCEDURE_REF(BgL_envz00_11055, 
(int)(((long)0))); 
BgL_a2z00_11057 = 
PROCEDURE_REF(BgL_envz00_11055, 
(int)(((long)1))); 
BgL_locz00_11058 = 
PROCEDURE_REF(BgL_envz00_11055, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_20828;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13464;
BgL_bpz00_13464 = 
VECTOR_REF(
((obj_t)BgL_sz00_11059),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13465;obj_t BgL_a2z00_13466;
BgL_a1z00_13465 = 
PROCEDURE_ENTRY(BgL_a1z00_11056)(BgL_a1z00_11056, BgL_sz00_11059, BEOA); 
BgL_a2z00_13466 = 
PROCEDURE_ENTRY(BgL_a2z00_11057)(BgL_a2z00_11057, BgL_sz00_11059, BEOA); 
if(
INTEGERP(BgL_a1z00_13465))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5286z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13465, BgL_locz00_11058); } 
if(
INTEGERP(BgL_a2z00_13466))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5286z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13466, BgL_locz00_11058); } 
BgL_tmpz00_20828 = 
(
(long)CINT(BgL_a1z00_13465)+
(long)CINT(BgL_a2z00_13466)); } } 
return 
BINT(BgL_tmpz00_20828);} } } 

}



/* &<@anonymous:2693> */
obj_t BGl_z62zc3z04anonymousza32693ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11060, obj_t BgL_sz00_11064)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11061;obj_t BgL_a2z00_11062;obj_t BgL_locz00_11063;
BgL_a1z00_11061 = 
PROCEDURE_REF(BgL_envz00_11060, 
(int)(((long)0))); 
BgL_a2z00_11062 = 
PROCEDURE_REF(BgL_envz00_11060, 
(int)(((long)1))); 
BgL_locz00_11063 = 
PROCEDURE_REF(BgL_envz00_11060, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_20855;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13467;
BgL_bpz00_13467 = 
VECTOR_REF(
((obj_t)BgL_sz00_11064),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13468;obj_t BgL_a2z00_13469;
BgL_a1z00_13468 = 
PROCEDURE_ENTRY(BgL_a1z00_11061)(BgL_a1z00_11061, BgL_sz00_11064, BEOA); 
BgL_a2z00_13469 = 
PROCEDURE_ENTRY(BgL_a2z00_11062)(BgL_a2z00_11062, BgL_sz00_11064, BEOA); 
if(
INTEGERP(BgL_a1z00_13468))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5290z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13468, BgL_locz00_11063); } 
if(
INTEGERP(BgL_a2z00_13469))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5290z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13469, BgL_locz00_11063); } 
BgL_tmpz00_20855 = 
(
(long)CINT(BgL_a1z00_13468)-
(long)CINT(BgL_a2z00_13469)); } } 
return 
BINT(BgL_tmpz00_20855);} } } 

}



/* &<@anonymous:2697> */
obj_t BGl_z62zc3z04anonymousza32697ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11065, obj_t BgL_sz00_11069)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11066;obj_t BgL_a2z00_11067;obj_t BgL_locz00_11068;
BgL_a1z00_11066 = 
PROCEDURE_REF(BgL_envz00_11065, 
(int)(((long)0))); 
BgL_a2z00_11067 = 
PROCEDURE_REF(BgL_envz00_11065, 
(int)(((long)1))); 
BgL_locz00_11068 = 
PROCEDURE_REF(BgL_envz00_11065, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_20882;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13470;
BgL_bpz00_13470 = 
VECTOR_REF(
((obj_t)BgL_sz00_11069),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13471;obj_t BgL_a2z00_13472;
BgL_a1z00_13471 = 
PROCEDURE_ENTRY(BgL_a1z00_11066)(BgL_a1z00_11066, BgL_sz00_11069, BEOA); 
BgL_a2z00_13472 = 
PROCEDURE_ENTRY(BgL_a2z00_11067)(BgL_a2z00_11067, BgL_sz00_11069, BEOA); 
if(
INTEGERP(BgL_a1z00_13471))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5292z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13471, BgL_locz00_11068); } 
if(
INTEGERP(BgL_a2z00_13472))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5292z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13472, BgL_locz00_11068); } 
BgL_tmpz00_20882 = 
(
(long)CINT(BgL_a1z00_13471)*
(long)CINT(BgL_a2z00_13472)); } } 
return 
BINT(BgL_tmpz00_20882);} } } 

}



/* &<@anonymous:2701> */
obj_t BGl_z62zc3z04anonymousza32701ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11070, obj_t BgL_sz00_11074)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11071;obj_t BgL_a2z00_11072;obj_t BgL_locz00_11073;
BgL_a1z00_11071 = 
PROCEDURE_REF(BgL_envz00_11070, 
(int)(((long)0))); 
BgL_a2z00_11072 = 
PROCEDURE_REF(BgL_envz00_11070, 
(int)(((long)1))); 
BgL_locz00_11073 = 
PROCEDURE_REF(BgL_envz00_11070, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
long BgL_tmpz00_20909;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13473;
BgL_bpz00_13473 = 
VECTOR_REF(
((obj_t)BgL_sz00_11074),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13474;obj_t BgL_a2z00_13475;
BgL_a1z00_13474 = 
PROCEDURE_ENTRY(BgL_a1z00_11071)(BgL_a1z00_11071, BgL_sz00_11074, BEOA); 
BgL_a2z00_13475 = 
PROCEDURE_ENTRY(BgL_a2z00_11072)(BgL_a2z00_11072, BgL_sz00_11074, BEOA); 
if(
INTEGERP(BgL_a1z00_13474))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5294z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13474, BgL_locz00_11073); } 
if(
INTEGERP(BgL_a2z00_13475))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5294z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13475, BgL_locz00_11073); } 
BgL_tmpz00_20909 = 
(
(long)CINT(BgL_a1z00_13474)/
(long)CINT(BgL_a2z00_13475)); } } 
return 
BINT(BgL_tmpz00_20909);} } } 

}



/* &<@anonymous:2705> */
obj_t BGl_z62zc3z04anonymousza32705ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11075, obj_t BgL_sz00_11079)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11076;obj_t BgL_a2z00_11077;obj_t BgL_locz00_11078;
BgL_a1z00_11076 = 
PROCEDURE_REF(BgL_envz00_11075, 
(int)(((long)0))); 
BgL_a2z00_11077 = 
PROCEDURE_REF(BgL_envz00_11075, 
(int)(((long)1))); 
BgL_locz00_11078 = 
PROCEDURE_REF(BgL_envz00_11075, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20936;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13476;
BgL_bpz00_13476 = 
VECTOR_REF(
((obj_t)BgL_sz00_11079),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13477;obj_t BgL_a2z00_13478;
BgL_a1z00_13477 = 
PROCEDURE_ENTRY(BgL_a1z00_11076)(BgL_a1z00_11076, BgL_sz00_11079, BEOA); 
BgL_a2z00_13478 = 
PROCEDURE_ENTRY(BgL_a2z00_11077)(BgL_a2z00_11077, BgL_sz00_11079, BEOA); 
if(
INTEGERP(BgL_a1z00_13477))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5296z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13477, BgL_locz00_11078); } 
if(
INTEGERP(BgL_a2z00_13478))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5296z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13478, BgL_locz00_11078); } 
BgL_tmpz00_20936 = 
(
(long)CINT(BgL_a1z00_13477)<
(long)CINT(BgL_a2z00_13478)); } } 
return 
BBOOL(BgL_tmpz00_20936);} } } 

}



/* &<@anonymous:2709> */
obj_t BGl_z62zc3z04anonymousza32709ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11080, obj_t BgL_sz00_11084)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11081;obj_t BgL_a2z00_11082;obj_t BgL_locz00_11083;
BgL_a1z00_11081 = 
PROCEDURE_REF(BgL_envz00_11080, 
(int)(((long)0))); 
BgL_a2z00_11082 = 
PROCEDURE_REF(BgL_envz00_11080, 
(int)(((long)1))); 
BgL_locz00_11083 = 
PROCEDURE_REF(BgL_envz00_11080, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20963;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13479;
BgL_bpz00_13479 = 
VECTOR_REF(
((obj_t)BgL_sz00_11084),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13480;obj_t BgL_a2z00_13481;
BgL_a1z00_13480 = 
PROCEDURE_ENTRY(BgL_a1z00_11081)(BgL_a1z00_11081, BgL_sz00_11084, BEOA); 
BgL_a2z00_13481 = 
PROCEDURE_ENTRY(BgL_a2z00_11082)(BgL_a2z00_11082, BgL_sz00_11084, BEOA); 
if(
INTEGERP(BgL_a1z00_13480))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5298z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13480, BgL_locz00_11083); } 
if(
INTEGERP(BgL_a2z00_13481))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5298z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13481, BgL_locz00_11083); } 
BgL_tmpz00_20963 = 
(
(long)CINT(BgL_a1z00_13480)>
(long)CINT(BgL_a2z00_13481)); } } 
return 
BBOOL(BgL_tmpz00_20963);} } } 

}



/* &<@anonymous:2713> */
obj_t BGl_z62zc3z04anonymousza32713ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11085, obj_t BgL_sz00_11089)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11086;obj_t BgL_a2z00_11087;obj_t BgL_locz00_11088;
BgL_a1z00_11086 = 
PROCEDURE_REF(BgL_envz00_11085, 
(int)(((long)0))); 
BgL_a2z00_11087 = 
PROCEDURE_REF(BgL_envz00_11085, 
(int)(((long)1))); 
BgL_locz00_11088 = 
PROCEDURE_REF(BgL_envz00_11085, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_20990;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13482;
BgL_bpz00_13482 = 
VECTOR_REF(
((obj_t)BgL_sz00_11089),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13483;obj_t BgL_a2z00_13484;
BgL_a1z00_13483 = 
PROCEDURE_ENTRY(BgL_a1z00_11086)(BgL_a1z00_11086, BgL_sz00_11089, BEOA); 
BgL_a2z00_13484 = 
PROCEDURE_ENTRY(BgL_a2z00_11087)(BgL_a2z00_11087, BgL_sz00_11089, BEOA); 
if(
INTEGERP(BgL_a1z00_13483))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5300z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13483, BgL_locz00_11088); } 
if(
INTEGERP(BgL_a2z00_13484))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5300z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13484, BgL_locz00_11088); } 
BgL_tmpz00_20990 = 
(
(long)CINT(BgL_a1z00_13483)<=
(long)CINT(BgL_a2z00_13484)); } } 
return 
BBOOL(BgL_tmpz00_20990);} } } 

}



/* &<@anonymous:2717> */
obj_t BGl_z62zc3z04anonymousza32717ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11090, obj_t BgL_sz00_11094)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11091;obj_t BgL_a2z00_11092;obj_t BgL_locz00_11093;
BgL_a1z00_11091 = 
PROCEDURE_REF(BgL_envz00_11090, 
(int)(((long)0))); 
BgL_a2z00_11092 = 
PROCEDURE_REF(BgL_envz00_11090, 
(int)(((long)1))); 
BgL_locz00_11093 = 
PROCEDURE_REF(BgL_envz00_11090, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21017;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13485;
BgL_bpz00_13485 = 
VECTOR_REF(
((obj_t)BgL_sz00_11094),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13486;obj_t BgL_a2z00_13487;
BgL_a1z00_13486 = 
PROCEDURE_ENTRY(BgL_a1z00_11091)(BgL_a1z00_11091, BgL_sz00_11094, BEOA); 
BgL_a2z00_13487 = 
PROCEDURE_ENTRY(BgL_a2z00_11092)(BgL_a2z00_11092, BgL_sz00_11094, BEOA); 
if(
INTEGERP(BgL_a1z00_13486))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5302z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13486, BgL_locz00_11093); } 
if(
INTEGERP(BgL_a2z00_13487))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5302z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13487, BgL_locz00_11093); } 
BgL_tmpz00_21017 = 
(
(long)CINT(BgL_a1z00_13486)>=
(long)CINT(BgL_a2z00_13487)); } } 
return 
BBOOL(BgL_tmpz00_21017);} } } 

}



/* &<@anonymous:2721> */
obj_t BGl_z62zc3z04anonymousza32721ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11095, obj_t BgL_sz00_11099)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11096;obj_t BgL_a2z00_11097;obj_t BgL_locz00_11098;
BgL_a1z00_11096 = 
PROCEDURE_REF(BgL_envz00_11095, 
(int)(((long)0))); 
BgL_a2z00_11097 = 
PROCEDURE_REF(BgL_envz00_11095, 
(int)(((long)1))); 
BgL_locz00_11098 = 
PROCEDURE_REF(BgL_envz00_11095, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21044;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13488;
BgL_bpz00_13488 = 
VECTOR_REF(
((obj_t)BgL_sz00_11099),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13489;obj_t BgL_a2z00_13490;
BgL_a1z00_13489 = 
PROCEDURE_ENTRY(BgL_a1z00_11096)(BgL_a1z00_11096, BgL_sz00_11099, BEOA); 
BgL_a2z00_13490 = 
PROCEDURE_ENTRY(BgL_a2z00_11097)(BgL_a2z00_11097, BgL_sz00_11099, BEOA); 
if(
INTEGERP(BgL_a1z00_13489))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5304z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a1z00_13489, BgL_locz00_11098); } 
if(
INTEGERP(BgL_a2z00_13490))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5304z00zz__evaluate_compz00, BGl_symbol5288z00zz__evaluate_compz00, BgL_a2z00_13490, BgL_locz00_11098); } 
BgL_tmpz00_21044 = 
(
(long)CINT(BgL_a1z00_13489)==
(long)CINT(BgL_a2z00_13490)); } } 
return 
BBOOL(BgL_tmpz00_21044);} } } 

}



/* &<@anonymous:2725> */
obj_t BGl_z62zc3z04anonymousza32725ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11100, obj_t BgL_sz00_11104)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11101;obj_t BgL_a2z00_11102;obj_t BgL_locz00_11103;
BgL_a1z00_11101 = 
PROCEDURE_REF(BgL_envz00_11100, 
(int)(((long)0))); 
BgL_a2z00_11102 = 
PROCEDURE_REF(BgL_envz00_11100, 
(int)(((long)1))); 
BgL_locz00_11103 = 
PROCEDURE_REF(BgL_envz00_11100, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_21071;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13491;
BgL_bpz00_13491 = 
VECTOR_REF(
((obj_t)BgL_sz00_11104),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13492;obj_t BgL_a2z00_13493;
BgL_a1z00_13492 = 
PROCEDURE_ENTRY(BgL_a1z00_11101)(BgL_a1z00_11101, BgL_sz00_11104, BEOA); 
BgL_a2z00_13493 = 
PROCEDURE_ENTRY(BgL_a2z00_11102)(BgL_a2z00_11102, BgL_sz00_11104, BEOA); 
if(
REALP(BgL_a1z00_13492))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5306z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13492, BgL_locz00_11103); } 
if(
REALP(BgL_a2z00_13493))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5306z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13493, BgL_locz00_11103); } 
BgL_tmpz00_21071 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13492)+
REAL_TO_DOUBLE(BgL_a2z00_13493)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21071);} } } 

}



/* &<@anonymous:2729> */
obj_t BGl_z62zc3z04anonymousza32729ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11105, obj_t BgL_sz00_11109)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11106;obj_t BgL_a2z00_11107;obj_t BgL_locz00_11108;
BgL_a1z00_11106 = 
PROCEDURE_REF(BgL_envz00_11105, 
(int)(((long)0))); 
BgL_a2z00_11107 = 
PROCEDURE_REF(BgL_envz00_11105, 
(int)(((long)1))); 
BgL_locz00_11108 = 
PROCEDURE_REF(BgL_envz00_11105, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_21098;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13494;
BgL_bpz00_13494 = 
VECTOR_REF(
((obj_t)BgL_sz00_11109),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13495;obj_t BgL_a2z00_13496;
BgL_a1z00_13495 = 
PROCEDURE_ENTRY(BgL_a1z00_11106)(BgL_a1z00_11106, BgL_sz00_11109, BEOA); 
BgL_a2z00_13496 = 
PROCEDURE_ENTRY(BgL_a2z00_11107)(BgL_a2z00_11107, BgL_sz00_11109, BEOA); 
if(
REALP(BgL_a1z00_13495))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5310z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13495, BgL_locz00_11108); } 
if(
REALP(BgL_a2z00_13496))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5310z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13496, BgL_locz00_11108); } 
BgL_tmpz00_21098 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13495)-
REAL_TO_DOUBLE(BgL_a2z00_13496)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21098);} } } 

}



/* &<@anonymous:2733> */
obj_t BGl_z62zc3z04anonymousza32733ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11110, obj_t BgL_sz00_11114)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11111;obj_t BgL_a2z00_11112;obj_t BgL_locz00_11113;
BgL_a1z00_11111 = 
PROCEDURE_REF(BgL_envz00_11110, 
(int)(((long)0))); 
BgL_a2z00_11112 = 
PROCEDURE_REF(BgL_envz00_11110, 
(int)(((long)1))); 
BgL_locz00_11113 = 
PROCEDURE_REF(BgL_envz00_11110, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_21125;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13497;
BgL_bpz00_13497 = 
VECTOR_REF(
((obj_t)BgL_sz00_11114),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13498;obj_t BgL_a2z00_13499;
BgL_a1z00_13498 = 
PROCEDURE_ENTRY(BgL_a1z00_11111)(BgL_a1z00_11111, BgL_sz00_11114, BEOA); 
BgL_a2z00_13499 = 
PROCEDURE_ENTRY(BgL_a2z00_11112)(BgL_a2z00_11112, BgL_sz00_11114, BEOA); 
if(
REALP(BgL_a1z00_13498))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5312z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13498, BgL_locz00_11113); } 
if(
REALP(BgL_a2z00_13499))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5312z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13499, BgL_locz00_11113); } 
BgL_tmpz00_21125 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13498)*
REAL_TO_DOUBLE(BgL_a2z00_13499)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21125);} } } 

}



/* &<@anonymous:2737> */
obj_t BGl_z62zc3z04anonymousza32737ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11115, obj_t BgL_sz00_11119)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11116;obj_t BgL_a2z00_11117;obj_t BgL_locz00_11118;
BgL_a1z00_11116 = 
PROCEDURE_REF(BgL_envz00_11115, 
(int)(((long)0))); 
BgL_a2z00_11117 = 
PROCEDURE_REF(BgL_envz00_11115, 
(int)(((long)1))); 
BgL_locz00_11118 = 
PROCEDURE_REF(BgL_envz00_11115, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
double BgL_tmpz00_21152;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13500;
BgL_bpz00_13500 = 
VECTOR_REF(
((obj_t)BgL_sz00_11119),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13501;obj_t BgL_a2z00_13502;
BgL_a1z00_13501 = 
PROCEDURE_ENTRY(BgL_a1z00_11116)(BgL_a1z00_11116, BgL_sz00_11119, BEOA); 
BgL_a2z00_13502 = 
PROCEDURE_ENTRY(BgL_a2z00_11117)(BgL_a2z00_11117, BgL_sz00_11119, BEOA); 
if(
REALP(BgL_a1z00_13501))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5314z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13501, BgL_locz00_11118); } 
if(
REALP(BgL_a2z00_13502))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5314z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13502, BgL_locz00_11118); } 
BgL_tmpz00_21152 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13501)/
REAL_TO_DOUBLE(BgL_a2z00_13502)); } } 
return 
DOUBLE_TO_REAL(BgL_tmpz00_21152);} } } 

}



/* &<@anonymous:2741> */
obj_t BGl_z62zc3z04anonymousza32741ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11120, obj_t BgL_sz00_11124)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11121;obj_t BgL_a2z00_11122;obj_t BgL_locz00_11123;
BgL_a1z00_11121 = 
PROCEDURE_REF(BgL_envz00_11120, 
(int)(((long)0))); 
BgL_a2z00_11122 = 
PROCEDURE_REF(BgL_envz00_11120, 
(int)(((long)1))); 
BgL_locz00_11123 = 
PROCEDURE_REF(BgL_envz00_11120, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21179;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13503;
BgL_bpz00_13503 = 
VECTOR_REF(
((obj_t)BgL_sz00_11124),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13504;obj_t BgL_a2z00_13505;
BgL_a1z00_13504 = 
PROCEDURE_ENTRY(BgL_a1z00_11121)(BgL_a1z00_11121, BgL_sz00_11124, BEOA); 
BgL_a2z00_13505 = 
PROCEDURE_ENTRY(BgL_a2z00_11122)(BgL_a2z00_11122, BgL_sz00_11124, BEOA); 
if(
REALP(BgL_a1z00_13504))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5316z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13504, BgL_locz00_11123); } 
if(
REALP(BgL_a2z00_13505))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5316z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13505, BgL_locz00_11123); } 
BgL_tmpz00_21179 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13504)<
REAL_TO_DOUBLE(BgL_a2z00_13505)); } } 
return 
BBOOL(BgL_tmpz00_21179);} } } 

}



/* &<@anonymous:2745> */
obj_t BGl_z62zc3z04anonymousza32745ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11125, obj_t BgL_sz00_11129)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11126;obj_t BgL_a2z00_11127;obj_t BgL_locz00_11128;
BgL_a1z00_11126 = 
PROCEDURE_REF(BgL_envz00_11125, 
(int)(((long)0))); 
BgL_a2z00_11127 = 
PROCEDURE_REF(BgL_envz00_11125, 
(int)(((long)1))); 
BgL_locz00_11128 = 
PROCEDURE_REF(BgL_envz00_11125, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21206;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13506;
BgL_bpz00_13506 = 
VECTOR_REF(
((obj_t)BgL_sz00_11129),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13507;obj_t BgL_a2z00_13508;
BgL_a1z00_13507 = 
PROCEDURE_ENTRY(BgL_a1z00_11126)(BgL_a1z00_11126, BgL_sz00_11129, BEOA); 
BgL_a2z00_13508 = 
PROCEDURE_ENTRY(BgL_a2z00_11127)(BgL_a2z00_11127, BgL_sz00_11129, BEOA); 
if(
REALP(BgL_a1z00_13507))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5318z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13507, BgL_locz00_11128); } 
if(
REALP(BgL_a2z00_13508))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5318z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13508, BgL_locz00_11128); } 
BgL_tmpz00_21206 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13507)>
REAL_TO_DOUBLE(BgL_a2z00_13508)); } } 
return 
BBOOL(BgL_tmpz00_21206);} } } 

}



/* &<@anonymous:2749> */
obj_t BGl_z62zc3z04anonymousza32749ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11130, obj_t BgL_sz00_11134)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11131;obj_t BgL_a2z00_11132;obj_t BgL_locz00_11133;
BgL_a1z00_11131 = 
PROCEDURE_REF(BgL_envz00_11130, 
(int)(((long)0))); 
BgL_a2z00_11132 = 
PROCEDURE_REF(BgL_envz00_11130, 
(int)(((long)1))); 
BgL_locz00_11133 = 
PROCEDURE_REF(BgL_envz00_11130, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21233;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13509;
BgL_bpz00_13509 = 
VECTOR_REF(
((obj_t)BgL_sz00_11134),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13510;obj_t BgL_a2z00_13511;
BgL_a1z00_13510 = 
PROCEDURE_ENTRY(BgL_a1z00_11131)(BgL_a1z00_11131, BgL_sz00_11134, BEOA); 
BgL_a2z00_13511 = 
PROCEDURE_ENTRY(BgL_a2z00_11132)(BgL_a2z00_11132, BgL_sz00_11134, BEOA); 
if(
REALP(BgL_a1z00_13510))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5320z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13510, BgL_locz00_11133); } 
if(
REALP(BgL_a2z00_13511))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5320z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13511, BgL_locz00_11133); } 
BgL_tmpz00_21233 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13510)<=
REAL_TO_DOUBLE(BgL_a2z00_13511)); } } 
return 
BBOOL(BgL_tmpz00_21233);} } } 

}



/* &<@anonymous:2753> */
obj_t BGl_z62zc3z04anonymousza32753ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11135, obj_t BgL_sz00_11139)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11136;obj_t BgL_a2z00_11137;obj_t BgL_locz00_11138;
BgL_a1z00_11136 = 
PROCEDURE_REF(BgL_envz00_11135, 
(int)(((long)0))); 
BgL_a2z00_11137 = 
PROCEDURE_REF(BgL_envz00_11135, 
(int)(((long)1))); 
BgL_locz00_11138 = 
PROCEDURE_REF(BgL_envz00_11135, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21260;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13512;
BgL_bpz00_13512 = 
VECTOR_REF(
((obj_t)BgL_sz00_11139),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13513;obj_t BgL_a2z00_13514;
BgL_a1z00_13513 = 
PROCEDURE_ENTRY(BgL_a1z00_11136)(BgL_a1z00_11136, BgL_sz00_11139, BEOA); 
BgL_a2z00_13514 = 
PROCEDURE_ENTRY(BgL_a2z00_11137)(BgL_a2z00_11137, BgL_sz00_11139, BEOA); 
if(
REALP(BgL_a1z00_13513))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5322z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13513, BgL_locz00_11138); } 
if(
REALP(BgL_a2z00_13514))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5322z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13514, BgL_locz00_11138); } 
BgL_tmpz00_21260 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13513)>=
REAL_TO_DOUBLE(BgL_a2z00_13514)); } } 
return 
BBOOL(BgL_tmpz00_21260);} } } 

}



/* &<@anonymous:2757> */
obj_t BGl_z62zc3z04anonymousza32757ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11140, obj_t BgL_sz00_11144)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11141;obj_t BgL_a2z00_11142;obj_t BgL_locz00_11143;
BgL_a1z00_11141 = 
PROCEDURE_REF(BgL_envz00_11140, 
(int)(((long)0))); 
BgL_a2z00_11142 = 
PROCEDURE_REF(BgL_envz00_11140, 
(int)(((long)1))); 
BgL_locz00_11143 = 
PROCEDURE_REF(BgL_envz00_11140, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21287;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13515;
BgL_bpz00_13515 = 
VECTOR_REF(
((obj_t)BgL_sz00_11144),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13516;obj_t BgL_a2z00_13517;
BgL_a1z00_13516 = 
PROCEDURE_ENTRY(BgL_a1z00_11141)(BgL_a1z00_11141, BgL_sz00_11144, BEOA); 
BgL_a2z00_13517 = 
PROCEDURE_ENTRY(BgL_a2z00_11142)(BgL_a2z00_11142, BgL_sz00_11144, BEOA); 
if(
REALP(BgL_a1z00_13516))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5324z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a1z00_13516, BgL_locz00_11143); } 
if(
REALP(BgL_a2z00_13517))
{ /* Eval/evaluate_comp.scm 1021 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1021 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5324z00zz__evaluate_compz00, BGl_symbol5308z00zz__evaluate_compz00, BgL_a2z00_13517, BgL_locz00_11143); } 
BgL_tmpz00_21287 = 
(
REAL_TO_DOUBLE(BgL_a1z00_13516)==
REAL_TO_DOUBLE(BgL_a2z00_13517)); } } 
return 
BBOOL(BgL_tmpz00_21287);} } } 

}



/* &<@anonymous:2761> */
obj_t BGl_z62zc3z04anonymousza32761ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11145, obj_t BgL_sz00_11148)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11146;obj_t BgL_a2z00_11147;
BgL_a1z00_11146 = 
PROCEDURE_REF(BgL_envz00_11145, 
(int)(((long)0))); 
BgL_a2z00_11147 = 
PROCEDURE_REF(BgL_envz00_11145, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1021 */
bool_t BgL_tmpz00_21312;
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13518;
BgL_bpz00_13518 = 
VECTOR_REF(
((obj_t)BgL_sz00_11148),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13519;obj_t BgL_a2z00_13520;
BgL_a1z00_13519 = 
PROCEDURE_ENTRY(BgL_a1z00_11146)(BgL_a1z00_11146, BgL_sz00_11148, BEOA); 
BgL_a2z00_13520 = 
PROCEDURE_ENTRY(BgL_a2z00_11147)(BgL_a2z00_11147, BgL_sz00_11148, BEOA); 
BgL_tmpz00_21312 = 
(BgL_a1z00_13519==BgL_a2z00_13520); } } 
return 
BBOOL(BgL_tmpz00_21312);} } } 

}



/* &<@anonymous:2763> */
obj_t BGl_z62zc3z04anonymousza32763ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11149, obj_t BgL_sz00_11152)
{
{ /* Eval/evaluate_comp.scm 1021 */
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_11150;obj_t BgL_a2z00_11151;
BgL_a1z00_11150 = 
PROCEDURE_REF(BgL_envz00_11149, 
(int)(((long)0))); 
BgL_a2z00_11151 = 
PROCEDURE_REF(BgL_envz00_11149, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_bpz00_13521;
BgL_bpz00_13521 = 
VECTOR_REF(
((obj_t)BgL_sz00_11152),((long)0)); 
{ /* Eval/evaluate_comp.scm 1021 */
obj_t BgL_a1z00_13522;obj_t BgL_a2z00_13523;
BgL_a1z00_13522 = 
PROCEDURE_ENTRY(BgL_a1z00_11150)(BgL_a1z00_11150, BgL_sz00_11152, BEOA); 
BgL_a2z00_13523 = 
PROCEDURE_ENTRY(BgL_a2z00_11151)(BgL_a2z00_11151, BgL_sz00_11152, BEOA); 
return 
MAKE_YOUNG_PAIR(BgL_a1z00_13522, BgL_a2z00_13523);} } } } 

}



/* &<@anonymous:2766> */
obj_t BGl_z62zc3z04anonymousza32766ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11153, obj_t BgL_sz00_11156)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_11154;obj_t BgL_locz00_11155;
BgL_a1z00_11154 = 
PROCEDURE_REF(BgL_envz00_11153, 
(int)(((long)0))); 
BgL_locz00_11155 = 
PROCEDURE_REF(BgL_envz00_11153, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_13524;
BgL_bpz00_13524 = 
VECTOR_REF(
((obj_t)BgL_sz00_11156),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_13525;
BgL_a1z00_13525 = 
PROCEDURE_ENTRY(BgL_a1z00_11154)(BgL_a1z00_11154, BgL_sz00_11156, BEOA); 
if(
PAIRP(BgL_a1z00_13525))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5326z00zz__evaluate_compz00, BGl_symbol5328z00zz__evaluate_compz00, BgL_a1z00_13525, BgL_locz00_11155); } 
return 
CAR(
((obj_t)BgL_a1z00_13525));} } } } 

}



/* &<@anonymous:2769> */
obj_t BGl_z62zc3z04anonymousza32769ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11157, obj_t BgL_sz00_11160)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_11158;obj_t BgL_locz00_11159;
BgL_a1z00_11158 = 
PROCEDURE_REF(BgL_envz00_11157, 
(int)(((long)0))); 
BgL_locz00_11159 = 
PROCEDURE_REF(BgL_envz00_11157, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_13526;
BgL_bpz00_13526 = 
VECTOR_REF(
((obj_t)BgL_sz00_11160),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_13527;
BgL_a1z00_13527 = 
PROCEDURE_ENTRY(BgL_a1z00_11158)(BgL_a1z00_11158, BgL_sz00_11160, BEOA); 
if(
PAIRP(BgL_a1z00_13527))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5330z00zz__evaluate_compz00, BGl_symbol5328z00zz__evaluate_compz00, BgL_a1z00_13527, BgL_locz00_11159); } 
return 
CDR(
((obj_t)BgL_a1z00_13527));} } } } 

}



/* &<@anonymous:2772> */
obj_t BGl_z62zc3z04anonymousza32772ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11161, obj_t BgL_sz00_11164)
{
{ /* Eval/evaluate_comp.scm 1018 */
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_11162;obj_t BgL_locz00_11163;
BgL_a1z00_11162 = 
PROCEDURE_REF(BgL_envz00_11161, 
(int)(((long)0))); 
BgL_locz00_11163 = 
PROCEDURE_REF(BgL_envz00_11161, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_bpz00_13528;
BgL_bpz00_13528 = 
VECTOR_REF(
((obj_t)BgL_sz00_11164),((long)0)); 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_a1z00_13529;
BgL_a1z00_13529 = 
PROCEDURE_ENTRY(BgL_a1z00_11162)(BgL_a1z00_11162, BgL_sz00_11164, BEOA); 
if(
BGl_cadrzf3zf3zz__evaluate_compz00(BgL_a1z00_13529))
{ /* Eval/evaluate_comp.scm 1018 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_arg2774z00_13530;
BgL_arg2774z00_13530 = 
BGl_cadrerrvz00zz__evaluate_compz00(BgL_a1z00_13529); 
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_symbol5332z00zz__evaluate_compz00, BGl_symbol5328z00zz__evaluate_compz00, BgL_arg2774z00_13530, BgL_locz00_11163); } 
{ /* Eval/evaluate_comp.scm 1018 */
obj_t BgL_pairz00_13531;
BgL_pairz00_13531 = 
CDR(
((obj_t)BgL_a1z00_13529)); 
return 
CAR(BgL_pairz00_13531);} } } } } 

}



/* cadr? */
bool_t BGl_cadrzf3zf3zz__evaluate_compz00(obj_t BgL_lz00_197)
{
{ /* Eval/evaluate_comp.scm 1026 */
if(
PAIRP(BgL_lz00_197))
{ /* Eval/evaluate_comp.scm 1027 */
obj_t BgL_tmpz00_21389;
BgL_tmpz00_21389 = 
CDR(BgL_lz00_197); 
return 
PAIRP(BgL_tmpz00_21389);}  else 
{ /* Eval/evaluate_comp.scm 1027 */
return ((bool_t)0);} } 

}



/* cadrerrv */
obj_t BGl_cadrerrvz00zz__evaluate_compz00(obj_t BgL_vz00_198)
{
{ /* Eval/evaluate_comp.scm 1029 */
if(
PAIRP(BgL_vz00_198))
{ /* Eval/evaluate_comp.scm 1030 */
return 
CDR(BgL_vz00_198);}  else 
{ /* Eval/evaluate_comp.scm 1030 */
return BgL_vz00_198;} } 

}



/* correct */
long BGl_correctz00zz__evaluate_compz00(obj_t BgL_nz00_201, long BgL_donez00_202)
{
{ /* Eval/evaluate_comp.scm 1058 */
if(
(
(long)CINT(BgL_nz00_201)<((long)0)))
{ /* Eval/evaluate_comp.scm 1059 */
return 
(
(long)CINT(BgL_nz00_201)+BgL_donez00_202);}  else 
{ /* Eval/evaluate_comp.scm 1059 */
return 
(
(long)CINT(BgL_nz00_201)-BgL_donez00_202);} } 

}



/* bind-frame */
obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203, obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206, obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
{
{ /* Eval/evaluate_comp.scm 1063 */
if(
(BgL_arityz00_206<((long)0)))
{ /* Eval/evaluate_comp.scm 1065 */
long BgL_g1233z00_3523;
BgL_g1233z00_3523 = 
(((long)-1)-BgL_arityz00_206); 
{ 
long BgL_rz00_3525;long BgL_spz00_3526;obj_t BgL_lz00_3527;
BgL_rz00_3525 = BgL_g1233z00_3523; 
BgL_spz00_3526 = BgL_spz00_205; 
BgL_lz00_3527 = BgL_valsz00_207; 
BgL_zc3z04anonymousza32779ze3z87_3528:
if(
(BgL_rz00_3525==((long)0)))
{ /* Eval/evaluate_comp.scm 1067 */
return 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3526,BgL_lz00_3527);}  else 
{ /* Eval/evaluate_comp.scm 1067 */
if(
PAIRP(BgL_lz00_3527))
{ /* Eval/evaluate_comp.scm 1069 */
{ /* Eval/evaluate_comp.scm 1072 */
obj_t BgL_arg2782z00_3531;
BgL_arg2782z00_3531 = 
CAR(BgL_lz00_3527); 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3526,BgL_arg2782z00_3531); } 
{ 
obj_t BgL_lz00_21418;long BgL_spz00_21416;long BgL_rz00_21414;
BgL_rz00_21414 = 
(BgL_rz00_3525-((long)1)); 
BgL_spz00_21416 = 
(BgL_spz00_3526+((long)1)); 
BgL_lz00_21418 = 
CDR(BgL_lz00_3527); 
BgL_lz00_3527 = BgL_lz00_21418; 
BgL_spz00_3526 = BgL_spz00_21416; 
BgL_rz00_3525 = BgL_rz00_21414; 
goto BgL_zc3z04anonymousza32779ze3z87_3528;} }  else 
{ /* Eval/evaluate_comp.scm 1070 */
long BgL_arg2786z00_3535;
BgL_arg2786z00_3535 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2786z00_3535));} } } }  else 
{ 
long BgL_rz00_3538;long BgL_spz00_3539;obj_t BgL_lz00_3540;
BgL_rz00_3538 = BgL_arityz00_206; 
BgL_spz00_3539 = BgL_spz00_205; 
BgL_lz00_3540 = BgL_valsz00_207; 
BgL_zc3z04anonymousza32787ze3z87_3541:
if(
(BgL_rz00_3538==((long)0)))
{ /* Eval/evaluate_comp.scm 1076 */
if(
NULLP(BgL_lz00_3540))
{ /* Eval/evaluate_comp.scm 1077 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 1078 */
long BgL_arg2790z00_3544;
BgL_arg2790z00_3544 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2790z00_3544));} }  else 
{ /* Eval/evaluate_comp.scm 1076 */
if(
PAIRP(BgL_lz00_3540))
{ /* Eval/evaluate_comp.scm 1079 */
{ /* Eval/evaluate_comp.scm 1082 */
obj_t BgL_arg2792z00_3546;
BgL_arg2792z00_3546 = 
CAR(BgL_lz00_3540); 
VECTOR_SET(
((obj_t)BgL_sz00_203),BgL_spz00_3539,BgL_arg2792z00_3546); } 
{ 
obj_t BgL_lz00_21441;long BgL_spz00_21439;long BgL_rz00_21437;
BgL_rz00_21437 = 
(BgL_rz00_3538-((long)1)); 
BgL_spz00_21439 = 
(BgL_spz00_3539+((long)1)); 
BgL_lz00_21441 = 
CDR(BgL_lz00_3540); 
BgL_lz00_3540 = BgL_lz00_21441; 
BgL_spz00_3539 = BgL_spz00_21439; 
BgL_rz00_3538 = BgL_rz00_21437; 
goto BgL_zc3z04anonymousza32787ze3z87_3541;} }  else 
{ /* Eval/evaluate_comp.scm 1080 */
long BgL_arg2796z00_3550;
BgL_arg2796z00_3550 = 
bgl_list_length(BgL_valsz00_207); 
return 
BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208, BgL_wherez00_204, 
(int)(BgL_arityz00_206), 
(int)(BgL_arg2796z00_3550));} } } } 

}



/* make-boxes */
bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211, obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
{
{ /* Eval/evaluate_comp.scm 1177 */
{ 
long BgL_iz00_3554;
BgL_iz00_3554 = ((long)0); 
BgL_zc3z04anonymousza32797ze3z87_3555:
{ /* Eval/evaluate_comp.scm 1180 */
long BgL_spz00_3556;
{ /* Eval/evaluate_comp.scm 1180 */
obj_t BgL_arg2801z00_3561;
BgL_arg2801z00_3561 = 
VECTOR_REF(
((obj_t)BgL_ibza2za2_212),BgL_iz00_3554); 
BgL_spz00_3556 = 
(
(long)CINT(BgL_bpz00_213)+
(long)CINT(BgL_arg2801z00_3561)); } 
{ /* Eval/evaluate_comp.scm 1181 */
obj_t BgL_arg2798z00_3557;
{ /* Eval/evaluate_comp.scm 1181 */
obj_t BgL_arg2799z00_3558;
BgL_arg2799z00_3558 = 
VECTOR_REF(
((obj_t)BgL_sz00_211),BgL_spz00_3556); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_8519;
BgL_newz00_8519 = 
create_struct(BGl_symbol5256z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_21456;
BgL_tmpz00_21456 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_8519, BgL_tmpz00_21456, BgL_arg2799z00_3558); } 
BgL_arg2798z00_3557 = BgL_newz00_8519; } } 
VECTOR_SET(
((obj_t)BgL_sz00_211),BgL_spz00_3556,BgL_arg2798z00_3557); } 
{ /* Eval/evaluate_comp.scm 1182 */
long BgL_niz00_3559;
BgL_niz00_3559 = 
(BgL_iz00_3554+((long)1)); 
if(
(BgL_niz00_3559<
VECTOR_LENGTH(
((obj_t)BgL_ibza2za2_212))))
{ 
long BgL_iz00_21466;
BgL_iz00_21466 = BgL_niz00_3559; 
BgL_iz00_3554 = BgL_iz00_21466; 
goto BgL_zc3z04anonymousza32797ze3z87_3555;}  else 
{ /* Eval/evaluate_comp.scm 1183 */
return ((bool_t)0);} } } } } 

}



/* free-collect */
obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214, obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
{
{ /* Eval/evaluate_comp.scm 1185 */
{ /* Eval/evaluate_comp.scm 1186 */
obj_t BgL_rz00_3564;
BgL_rz00_3564 = 
make_vector(
VECTOR_LENGTH(
((obj_t)BgL_iza2za2_216)), BUNSPEC); 
{ /* Eval/evaluate_comp.scm 1186 */

{ 
long BgL_iz00_3566;
BgL_iz00_3566 = ((long)0); 
BgL_zc3z04anonymousza32802ze3z87_3567:
if(
(BgL_iz00_3566>=
VECTOR_LENGTH(
((obj_t)BgL_iza2za2_216))))
{ /* Eval/evaluate_comp.scm 1188 */
return BgL_rz00_3564;}  else 
{ /* Eval/evaluate_comp.scm 1188 */
{ /* Eval/evaluate_comp.scm 1191 */
obj_t BgL_arg2804z00_3569;
{ /* Eval/evaluate_comp.scm 1191 */
long BgL_arg2805z00_3570;
{ /* Eval/evaluate_comp.scm 1191 */
obj_t BgL_arg2806z00_3571;
BgL_arg2806z00_3571 = 
VECTOR_REF(
((obj_t)BgL_iza2za2_216),BgL_iz00_3566); 
BgL_arg2805z00_3570 = 
(
(long)CINT(BgL_bpz00_215)+
(long)CINT(BgL_arg2806z00_3571)); } 
BgL_arg2804z00_3569 = 
VECTOR_REF(
((obj_t)BgL_sz00_214),BgL_arg2805z00_3570); } 
VECTOR_SET(BgL_rz00_3564,BgL_iz00_3566,BgL_arg2804z00_3569); } 
{ 
long BgL_iz00_21482;
BgL_iz00_21482 = 
(BgL_iz00_3566+((long)1)); 
BgL_iz00_3566 = BgL_iz00_21482; 
goto BgL_zc3z04anonymousza32802ze3z87_3567;} } } } } } 

}



/* free-restore */
bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217, obj_t BgL_valza2za2_218, long BgL_spz00_219)
{
{ /* Eval/evaluate_comp.scm 1194 */
{ /* Eval/evaluate_comp.scm 1195 */
long BgL_stopz00_3575;
BgL_stopz00_3575 = 
(BgL_spz00_219+
VECTOR_LENGTH(
((obj_t)BgL_valza2za2_218))); 
{ 
long BgL_iz00_3577;long BgL_spz00_3578;
BgL_iz00_3577 = ((long)0); 
BgL_spz00_3578 = BgL_spz00_219; 
BgL_zc3z04anonymousza32809ze3z87_3579:
if(
(BgL_spz00_3578<BgL_stopz00_3575))
{ /* Eval/evaluate_comp.scm 1197 */
{ /* Eval/evaluate_comp.scm 1198 */
obj_t BgL_arg2811z00_3581;
BgL_arg2811z00_3581 = 
VECTOR_REF(
((obj_t)BgL_valza2za2_218),BgL_iz00_3577); 
VECTOR_SET(
((obj_t)BgL_sz00_217),BgL_spz00_3578,BgL_arg2811z00_3581); } 
{ 
long BgL_spz00_21495;long BgL_iz00_21493;
BgL_iz00_21493 = 
(BgL_iz00_3577+((long)1)); 
BgL_spz00_21495 = 
(BgL_spz00_3578+((long)1)); 
BgL_spz00_3578 = BgL_spz00_21495; 
BgL_iz00_3577 = BgL_iz00_21493; 
goto BgL_zc3z04anonymousza32809ze3z87_3579;} }  else 
{ /* Eval/evaluate_comp.scm 1197 */
return ((bool_t)0);} } } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
return 
BGl_registerzd2genericz12zc0zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_proc5334z00zz__evaluate_compz00, BGl_ev_exprz00zz__evaluate_typesz00, BGl_string5335z00zz__evaluate_compz00);} 

}



/* &comp1385 */
obj_t BGl_z62comp1385z62zz__evaluate_compz00(obj_t BgL_envz00_11250, obj_t BgL_ez00_11251, obj_t BgL_stkz00_11252)
{
{ /* Eval/evaluate_comp.scm 276 */
return 
BGl_errorz00zz__errorz00(BGl_string5246z00zz__evaluate_compz00, BGl_string5336z00zz__evaluate_compz00, 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_ez00_11251)));} 

}



/* comp */
obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35, obj_t BgL_stkz00_36)
{
{ /* Eval/evaluate_comp.scm 276 */
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_method1386z00_3591;
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_res4691z00_8595;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_objzd2classzd2numz00_8560;
{ /* Eval/evaluate_comp.scm 276 */
long BgL_res4681z00_8563;
BgL_res4681z00_8563 = 
BGL_OBJECT_CLASS_NUM(
((BgL_objectz00_bglt)BgL_ez00_35)); 
BgL_objzd2classzd2numz00_8560 = BgL_res4681z00_8563; } 
{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_arg4012z00_8561;
BgL_arg4012z00_8561 = 
PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 276 */
int BgL_offsetz00_8565;
BgL_offsetz00_8565 = 
(int)(BgL_objzd2classzd2numz00_8560); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_offsetz00_8566;
BgL_offsetz00_8566 = 
(
(long)(BgL_offsetz00_8565)-OBJECT_TYPE); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_modz00_8567;
BgL_modz00_8567 = 
(BgL_offsetz00_8566 >> 
(int)(
(long)(
(int)(((long)4))))); 
{ /* Eval/evaluate_comp.scm 276 */
long BgL_restz00_8569;
BgL_restz00_8569 = 
(BgL_offsetz00_8566 & 
(long)(
(int)(
(
(long)(
(int)(
(((long)1) << 
(int)(
(long)(
(int)(((long)4)))))))-((long)1))))); 
{ /* Eval/evaluate_comp.scm 276 */

{ /* Eval/evaluate_comp.scm 276 */
obj_t BgL_bucketz00_8571;
BgL_bucketz00_8571 = 
VECTOR_REF(
((obj_t)BgL_arg4012z00_8561),BgL_modz00_8567); 
BgL_res4691z00_8595 = 
VECTOR_REF(
((obj_t)BgL_bucketz00_8571),BgL_restz00_8569); } } } } } } } } 
BgL_method1386z00_3591 = BgL_res4691z00_8595; } 
return 
PROCEDURE_ENTRY(BgL_method1386z00_3591)(BgL_method1386z00_3591, 
((obj_t)BgL_ez00_35), BgL_stkz00_36, BEOA);} } 

}



/* &comp */
obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_11253, obj_t BgL_ez00_11254, obj_t BgL_stkz00_11255)
{
{ /* Eval/evaluate_comp.scm 276 */
{ /* Eval/evaluate_comp.scm 276 */
BgL_ev_exprz00_bglt BgL_auxz00_21532;
if(
BGl_isazf3zf3zz__objectz00(BgL_ez00_11254, BGl_ev_exprz00zz__evaluate_typesz00))
{ /* Eval/evaluate_comp.scm 276 */
BgL_auxz00_21532 = 
((BgL_ev_exprz00_bglt)BgL_ez00_11254)
; }  else 
{ 
obj_t BgL_auxz00_21536;
BgL_auxz00_21536 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string5251z00zz__evaluate_compz00, 
BINT(((long)7022)), BGl_string5337z00zz__evaluate_compz00, BGl_string5253z00zz__evaluate_compz00, BgL_ez00_11254); 
FAILURE(BgL_auxz00_21536,BFALSE,BFALSE);} 
return 
BGl_compz00zz__evaluate_compz00(BgL_auxz00_21532, BgL_stkz00_11255);} } 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_trapz00zz__evaluate_typesz00, BGl_proc5338z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5340z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_setlocalz00zz__evaluate_typesz00, BGl_proc5341z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_globalz00zz__evaluate_typesz00, BGl_proc5342z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_setglobalz00zz__evaluate_typesz00, BGl_proc5343z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_defglobalz00zz__evaluate_typesz00, BGl_proc5344z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_littz00zz__evaluate_typesz00, BGl_proc5345z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5346z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5347z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5348z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_prog2z00zz__evaluate_typesz00, BGl_proc5349z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5350z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letza2za2zz__evaluate_typesz00, BGl_proc5351z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_letrecz00zz__evaluate_typesz00, BGl_proc5352z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_bindzd2exitzd2zz__evaluate_typesz00, BGl_proc5353z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00, BGl_proc5354z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_withzd2handlerzd2zz__evaluate_typesz00, BGl_proc5355z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_synchroniza7eza7zz__evaluate_typesz00, BGl_proc5356z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_labelsz00zz__evaluate_typesz00, BGl_proc5357z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_gotoz00zz__evaluate_typesz00, BGl_proc5358z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5359z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00); 
return 
BGl_genericzd2addzd2methodz12z12zz__objectz00(BGl_compzd2envzd2zz__evaluate_compz00, BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5360z00zz__evaluate_compz00, BGl_string5339z00zz__evaluate_compz00);} 

}



/* &comp-ev_abs1431 */
obj_t BGl_z62compzd2ev_abs1431zb0zz__evaluate_compz00(obj_t BgL_envz00_11450, obj_t BgL_ez00_11451, obj_t BgL_stkz00_11452)
{
{ /* Eval/evaluate_comp.scm 1165 */
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_ifreesz00_13534;obj_t BgL_iboxesz00_13535;long BgL_siza7eza7_13536;long BgL_siza7ezd2framez75_13537;obj_t BgL_nstkz00_13538;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3717z00_13539;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_l1362z00_13540;
BgL_l1362z00_13540 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_freez00); 
if(
NULLP(BgL_l1362z00_13540))
{ /* Eval/evaluate_comp.scm 1167 */
BgL_arg3717z00_13539 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_head1364z00_13541;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_res4781z00_13542;
BgL_res4781z00_13542 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1364z00_13541 = BgL_res4781z00_13542; } 
{ 
obj_t BgL_l1362z00_13544;obj_t BgL_tail1365z00_13545;
BgL_l1362z00_13544 = BgL_l1362z00_13540; 
BgL_tail1365z00_13545 = BgL_head1364z00_13541; 
BgL_zc3z04anonymousza33719ze3z87_13543:
if(
NULLP(BgL_l1362z00_13544))
{ /* Eval/evaluate_comp.scm 1167 */
BgL_arg3717z00_13539 = 
CDR(BgL_head1364z00_13541); }  else 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_newtail1366z00_13546;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3722z00_13547;
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_vz00_13548;
BgL_vz00_13548 = 
CAR(
((obj_t)BgL_l1362z00_13544)); 
BgL_arg3722z00_13547 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_13548, BgL_stkz00_11452); } 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_res4783z00_13549;
BgL_res4783z00_13549 = 
MAKE_YOUNG_PAIR(BgL_arg3722z00_13547, BNIL); 
BgL_newtail1366z00_13546 = BgL_res4783z00_13549; } } 
SET_CDR(BgL_tail1365z00_13545, BgL_newtail1366z00_13546); 
{ /* Eval/evaluate_comp.scm 1167 */
obj_t BgL_arg3721z00_13550;
BgL_arg3721z00_13550 = 
CDR(
((obj_t)BgL_l1362z00_13544)); 
{ 
obj_t BgL_tail1365z00_21579;obj_t BgL_l1362z00_21578;
BgL_l1362z00_21578 = BgL_arg3721z00_13550; 
BgL_tail1365z00_21579 = BgL_newtail1366z00_13546; 
BgL_tail1365z00_13545 = BgL_tail1365z00_21579; 
BgL_l1362z00_13544 = BgL_l1362z00_21578; 
goto BgL_zc3z04anonymousza33719ze3z87_13543;} } } } } } 
BgL_ifreesz00_13534 = 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3717z00_13539); } 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3723z00_13551;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_l1367z00_13552;
BgL_l1367z00_13552 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_boxesz00); 
if(
NULLP(BgL_l1367z00_13552))
{ /* Eval/evaluate_comp.scm 1168 */
BgL_arg3723z00_13551 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_head1369z00_13553;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_res4785z00_13554;
BgL_res4785z00_13554 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1369z00_13553 = BgL_res4785z00_13554; } 
{ 
obj_t BgL_l1367z00_13556;obj_t BgL_tail1370z00_13557;
BgL_l1367z00_13556 = BgL_l1367z00_13552; 
BgL_tail1370z00_13557 = BgL_head1369z00_13553; 
BgL_zc3z04anonymousza33725ze3z87_13555:
if(
NULLP(BgL_l1367z00_13556))
{ /* Eval/evaluate_comp.scm 1168 */
BgL_arg3723z00_13551 = 
CDR(BgL_head1369z00_13553); }  else 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_newtail1371z00_13558;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3728z00_13559;
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_vz00_13560;
BgL_vz00_13560 = 
CAR(
((obj_t)BgL_l1367z00_13556)); 
BgL_arg3728z00_13559 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_13560, 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_varsz00)); } 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_res4787z00_13561;
BgL_res4787z00_13561 = 
MAKE_YOUNG_PAIR(BgL_arg3728z00_13559, BNIL); 
BgL_newtail1371z00_13558 = BgL_res4787z00_13561; } } 
SET_CDR(BgL_tail1370z00_13557, BgL_newtail1371z00_13558); 
{ /* Eval/evaluate_comp.scm 1168 */
obj_t BgL_arg3727z00_13562;
BgL_arg3727z00_13562 = 
CDR(
((obj_t)BgL_l1367z00_13556)); 
{ 
obj_t BgL_tail1370z00_21599;obj_t BgL_l1367z00_21598;
BgL_l1367z00_21598 = BgL_arg3727z00_13562; 
BgL_tail1370z00_21599 = BgL_newtail1371z00_13558; 
BgL_tail1370z00_13557 = BgL_tail1370z00_21599; 
BgL_l1367z00_13556 = BgL_l1367z00_21598; 
goto BgL_zc3z04anonymousza33725ze3z87_13555;} } } } } } 
BgL_iboxesz00_13535 = 
BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg3723z00_13551); } 
BgL_siza7eza7_13536 = 
bgl_list_length(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_varsz00)); 
BgL_siza7ezd2framez75_13537 = 
(
(long)(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_siza7eza7))+
bgl_list_length(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_freez00))); 
BgL_nstkz00_13538 = 
BGl_appendzd221009zd2zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_varsz00), 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_freez00)); 
{ /* Eval/evaluate_comp.scm 1172 */
obj_t BgL_bodyz00_13563;
BgL_bodyz00_13563 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_bodyz00), BgL_nstkz00_13538); 
{ 

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_aux1245z00_13569;
BgL_aux1245z00_13569 = 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_ez00_11451)))->BgL_arityz00); 
if(
INTEGERP(BgL_aux1245z00_13569))
{ /* Eval/evaluate_comp.scm 1174 */
switch( 
(long)CINT(BgL_aux1245z00_13569)) { case ((long)0) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33179ze3z87_13570;
BgL_zc3z04anonymousza33179ze3z87_13570 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33179ze3z87_13570, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33179ze3z87_13570, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33179ze3z87_13570, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33179ze3z87_13570;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33185ze3z87_13571;
BgL_zc3z04anonymousza33185ze3z87_13571 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33185ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33185ze3z87_13571, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33185ze3z87_13571, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33185ze3z87_13571, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33185ze3z87_13571, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33185ze3z87_13571;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33194ze3z87_13572;
BgL_zc3z04anonymousza33194ze3z87_13572 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33194ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_13572, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_13572, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_13572, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_13572, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33194ze3z87_13572, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33194ze3z87_13572;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33201ze3z87_13573;
BgL_zc3z04anonymousza33201ze3z87_13573 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_13573, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_13573, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_13573, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_13573, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_13573, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_13573, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33201ze3z87_13573;} } break;case ((long)-1) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33214ze3z87_13574;
BgL_zc3z04anonymousza33214ze3z87_13574 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33214ze3z87_13574, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33214ze3z87_13574, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33214ze3z87_13574, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33214ze3z87_13574;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33221ze3z87_13575;
BgL_zc3z04anonymousza33221ze3z87_13575 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33221ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33221ze3z87_13575, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33221ze3z87_13575, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33221ze3z87_13575, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33221ze3z87_13575, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33221ze3z87_13575;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33231ze3z87_13576;
BgL_zc3z04anonymousza33231ze3z87_13576 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_13576, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_13576, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_13576, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_13576, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33231ze3z87_13576, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33231ze3z87_13576;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33239ze3z87_13577;
BgL_zc3z04anonymousza33239ze3z87_13577 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33239ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_13577, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_13577, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_13577, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_13577, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_13577, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33239ze3z87_13577, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33239ze3z87_13577;} } break;case ((long)1) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33253ze3z87_13578;
BgL_zc3z04anonymousza33253ze3z87_13578 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_13578, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_13578, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33253ze3z87_13578, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33253ze3z87_13578;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33260ze3z87_13579;
BgL_zc3z04anonymousza33260ze3z87_13579 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33260ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33260ze3z87_13579, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33260ze3z87_13579, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33260ze3z87_13579, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33260ze3z87_13579, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33260ze3z87_13579;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33270ze3z87_13580;
BgL_zc3z04anonymousza33270ze3z87_13580 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_13580, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_13580, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_13580, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_13580, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33270ze3z87_13580, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33270ze3z87_13580;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33278ze3z87_13581;
BgL_zc3z04anonymousza33278ze3z87_13581 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33278ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_13581, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_13581, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_13581, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_13581, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_13581, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33278ze3z87_13581, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33278ze3z87_13581;} } break;case ((long)-2) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33292ze3z87_13582;
BgL_zc3z04anonymousza33292ze3z87_13582 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33292ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33292ze3z87_13582, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33292ze3z87_13582, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33292ze3z87_13582, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33292ze3z87_13582;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33300ze3z87_13583;
BgL_zc3z04anonymousza33300ze3z87_13583 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33300ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33300ze3z87_13583, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33300ze3z87_13583, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33300ze3z87_13583, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33300ze3z87_13583, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33300ze3z87_13583;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33311ze3z87_13584;
BgL_zc3z04anonymousza33311ze3z87_13584 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33311ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_13584, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_13584, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_13584, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_13584, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33311ze3z87_13584, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33311ze3z87_13584;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33320ze3z87_13585;
BgL_zc3z04anonymousza33320ze3z87_13585 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13585, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13585, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13585, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13585, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13585, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33320ze3z87_13585, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33320ze3z87_13585;} } break;case ((long)2) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33335ze3z87_13586;
BgL_zc3z04anonymousza33335ze3z87_13586 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33335ze3z87_13586, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33335ze3z87_13586, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33335ze3z87_13586, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33335ze3z87_13586;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33343ze3z87_13587;
BgL_zc3z04anonymousza33343ze3z87_13587 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33343ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33343ze3z87_13587, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33343ze3z87_13587, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33343ze3z87_13587, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33343ze3z87_13587, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33343ze3z87_13587;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33354ze3z87_13588;
BgL_zc3z04anonymousza33354ze3z87_13588 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33354ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_13588, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_13588, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_13588, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_13588, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33354ze3z87_13588, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33354ze3z87_13588;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33363ze3z87_13589;
BgL_zc3z04anonymousza33363ze3z87_13589 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33363ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_13589, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_13589, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_13589, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_13589, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_13589, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33363ze3z87_13589, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33363ze3z87_13589;} } break;case ((long)-3) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33378ze3z87_13590;
BgL_zc3z04anonymousza33378ze3z87_13590 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33378ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33378ze3z87_13590, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33378ze3z87_13590, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33378ze3z87_13590, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33378ze3z87_13590;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33387ze3z87_13591;
BgL_zc3z04anonymousza33387ze3z87_13591 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_13591, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_13591, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_13591, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_13591, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33387ze3z87_13591;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33399ze3z87_13592;
BgL_zc3z04anonymousza33399ze3z87_13592 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33399ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_13592, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_13592, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_13592, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_13592, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33399ze3z87_13592, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33399ze3z87_13592;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33409ze3z87_13593;
BgL_zc3z04anonymousza33409ze3z87_13593 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33409ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_13593, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_13593, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_13593, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_13593, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_13593, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33409ze3z87_13593, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33409ze3z87_13593;} } break;case ((long)3) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33425ze3z87_13594;
BgL_zc3z04anonymousza33425ze3z87_13594 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33425ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33425ze3z87_13594, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33425ze3z87_13594, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33425ze3z87_13594, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33425ze3z87_13594;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33434ze3z87_13595;
BgL_zc3z04anonymousza33434ze3z87_13595 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33434ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33434ze3z87_13595, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33434ze3z87_13595, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33434ze3z87_13595, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33434ze3z87_13595, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33434ze3z87_13595;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33446ze3z87_13596;
BgL_zc3z04anonymousza33446ze3z87_13596 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33446ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_13596, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_13596, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_13596, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_13596, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33446ze3z87_13596, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33446ze3z87_13596;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33456ze3z87_13597;
BgL_zc3z04anonymousza33456ze3z87_13597 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33456ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_13597, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_13597, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_13597, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_13597, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_13597, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33456ze3z87_13597, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33456ze3z87_13597;} } break;case ((long)-4) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33472ze3z87_13598;
BgL_zc3z04anonymousza33472ze3z87_13598 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13598, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13598, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33472ze3z87_13598, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33472ze3z87_13598;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33482ze3z87_13599;
BgL_zc3z04anonymousza33482ze3z87_13599 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33482ze3z87_13599, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33482ze3z87_13599, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33482ze3z87_13599, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33482ze3z87_13599, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33482ze3z87_13599;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33495ze3z87_13600;
BgL_zc3z04anonymousza33495ze3z87_13600 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_13600, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_13600, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_13600, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_13600, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33495ze3z87_13600, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33495ze3z87_13600;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33506ze3z87_13601;
BgL_zc3z04anonymousza33506ze3z87_13601 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_13601, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_13601, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_13601, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_13601, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_13601, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33506ze3z87_13601, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33506ze3z87_13601;} } break;case ((long)4) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33523ze3z87_13602;
BgL_zc3z04anonymousza33523ze3z87_13602 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13602, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13602, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33523ze3z87_13602, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33523ze3z87_13602;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33533ze3z87_13603;
BgL_zc3z04anonymousza33533ze3z87_13603 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33533ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33533ze3z87_13603, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33533ze3z87_13603, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33533ze3z87_13603, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33533ze3z87_13603, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33533ze3z87_13603;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33546ze3z87_13604;
BgL_zc3z04anonymousza33546ze3z87_13604 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33546ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_13604, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_13604, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_13604, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_13604, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33546ze3z87_13604, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33546ze3z87_13604;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33557ze3z87_13605;
BgL_zc3z04anonymousza33557ze3z87_13605 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_13605, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_13605, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_13605, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_13605, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_13605, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33557ze3z87_13605, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33557ze3z87_13605;} } break;case ((long)-5) : 

if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33574ze3z87_13606;
BgL_zc3z04anonymousza33574ze3z87_13606 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33574ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33574ze3z87_13606, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33574ze3z87_13606, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33574ze3z87_13606, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33574ze3z87_13606;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33585ze3z87_13607;
BgL_zc3z04anonymousza33585ze3z87_13607 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33585ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33585ze3z87_13607, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33585ze3z87_13607, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33585ze3z87_13607, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33585ze3z87_13607, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33585ze3z87_13607;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33599ze3z87_13608;
BgL_zc3z04anonymousza33599ze3z87_13608 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33599ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_13608, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_13608, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_13608, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_13608, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33599ze3z87_13608, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33599ze3z87_13608;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33611ze3z87_13609;
BgL_zc3z04anonymousza33611ze3z87_13609 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33611ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_13609, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_13609, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_13609, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_13609, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_13609, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33611ze3z87_13609, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33611ze3z87_13609;} } break;
default: 
BgL_case_else1244z00_13564:
if(
(
VECTOR_LENGTH(BgL_ifreesz00_13534)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33629ze3z87_13565;
BgL_zc3z04anonymousza33629ze3z87_13565 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33629ze3z87_13565, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33629ze3z87_13565, 
(int)(((long)1)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33629ze3z87_13565, 
(int)(((long)2)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33629ze3z87_13565;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33649ze3z87_13566;
BgL_zc3z04anonymousza33649ze3z87_13566 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33649ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33649ze3z87_13566, 
(int)(((long)0)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33649ze3z87_13566, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33649ze3z87_13566, 
(int)(((long)2)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33649ze3z87_13566, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33649ze3z87_13566;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
if(
(
VECTOR_LENGTH(BgL_iboxesz00_13535)==((long)0)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33672ze3z87_13567;
BgL_zc3z04anonymousza33672ze3z87_13567 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_13567, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_13567, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_13567, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_13567, 
(int)(((long)3)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33672ze3z87_13567, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33672ze3z87_13567;}  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_zc3z04anonymousza33693ze3z87_13568;
BgL_zc3z04anonymousza33693ze3z87_13568 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33693ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_13568, 
(int)(((long)0)), BgL_ifreesz00_13534); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_13568, 
(int)(((long)1)), BgL_iboxesz00_13535); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_13568, 
(int)(((long)2)), 
BINT(BgL_siza7eza7_13536)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_13568, 
(int)(((long)3)), 
((obj_t)
((BgL_ev_absz00_bglt)BgL_ez00_11451))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_13568, 
(int)(((long)4)), BgL_bodyz00_13563); 
PROCEDURE_SET(BgL_zc3z04anonymousza33693ze3z87_13568, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_13537)); 
return BgL_zc3z04anonymousza33693ze3z87_13568;} } } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
goto BgL_case_else1244z00_13564;} } } } } } 

}



/* &<@anonymous:3574> */
obj_t BGl_z62zc3z04anonymousza33574ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11453, obj_t BgL_sz00_11457)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11454;obj_t BgL_bodyz00_11455;long BgL_siza7ezd2framez75_11456;
BgL_i1243z00_11454 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11453, 
(int)(((long)0)))); 
BgL_bodyz00_11455 = 
PROCEDURE_REF(BgL_envz00_11453, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11456 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11453, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13610;
BgL_bpz00_13610 = 
VECTOR_REF(
((obj_t)BgL_sz00_11457),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13611;
BgL_runz00_13611 = 
MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13611, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11454)); 
PROCEDURE_SET(BgL_runz00_13611, 
(int)(((long)1)), BgL_bodyz00_11455); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13612;
BgL_mainz00_13612 = 
MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13612, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11454)); 
PROCEDURE_SET(BgL_mainz00_13612, 
(int)(((long)1)), BgL_bodyz00_11455); 
PROCEDURE_SET(BgL_mainz00_13612, 
(int)(((long)2)), BgL_runz00_13611); 
PROCEDURE_SET(BgL_mainz00_13612, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11456)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13613;
BgL_objz00_13613 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13611, BgL_objz00_13613); BgL_objz00_13613; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3575z00_13614;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3576z00_13615;
BgL_arg3576z00_13615 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11454))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13616;
BgL_newz00_13616 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22441;
BgL_tmpz00_22441 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13616, BgL_tmpz00_22441, BgL_arg3576z00_13615); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22446;int BgL_tmpz00_22444;
BgL_auxz00_22446 = 
BINT(BgL_siza7ezd2framez75_11456); 
BgL_tmpz00_22444 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13616, BgL_tmpz00_22444, BgL_auxz00_22446); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22449;
BgL_tmpz00_22449 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13616, BgL_tmpz00_22449, BgL_runz00_13611); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22454;int BgL_tmpz00_22452;
BgL_auxz00_22454 = 
BINT(((long)-5)); 
BgL_tmpz00_22452 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13616, BgL_tmpz00_22452, BgL_auxz00_22454); } 
BgL_arg3575z00_13614 = BgL_newz00_13616; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13612, BgL_arg3575z00_13614); BgL_arg3575z00_13614; } 
return BgL_mainz00_13612;} } } } } } 

}



/* &main */
obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_11458, obj_t BgL_az00_11463, obj_t BgL_bz00_11464, obj_t BgL_cz00_11465, obj_t BgL_dz00_11466, obj_t BgL_lastz00_11467)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11461;long BgL_siza7ezd2framez75_11462;
BgL_runz00_11461 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11458, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11462 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11458, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13617;
BgL_sz00_13617 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13618;
BgL_bpz00_13618 = 
VECTOR_REF(
((obj_t)BgL_sz00_13617),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13617, BgL_bpz00_13618, 
BINT(BgL_siza7ezd2framez75_11462)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3579z00_13619;
BgL_arg3579z00_13619 = 
(
(long)CINT(BgL_bpz00_13618)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13617),BgL_arg3579z00_13619,BgL_az00_11463); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3580z00_13620;
BgL_arg3580z00_13620 = 
(
(long)CINT(BgL_bpz00_13618)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13617),BgL_arg3580z00_13620,BgL_bz00_11464); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3581z00_13621;
BgL_arg3581z00_13621 = 
(
(long)CINT(BgL_bpz00_13618)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13617),BgL_arg3581z00_13621,BgL_cz00_11465); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3582z00_13622;
BgL_arg3582z00_13622 = 
(
(long)CINT(BgL_bpz00_13618)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13617),BgL_arg3582z00_13622,BgL_dz00_11466); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3583z00_13623;
BgL_arg3583z00_13623 = 
(
(long)CINT(BgL_bpz00_13618)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13617),BgL_arg3583z00_13623,BgL_lastz00_11467); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13624;
BgL_ez00_13624 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13624, BgL_bpz00_13618); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13625;
BgL_accz00_13625 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11461, BgL_sz00_13617, BgL_bpz00_13618); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13624); 
VECTOR_SET(
((obj_t)BgL_sz00_13617),((long)0),BgL_bpz00_13618); 
return BgL_accz00_13625;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13626;
BgL_nsz00_13626 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13626,((long)1),BgL_sz00_13617); 
VECTOR_SET(BgL_nsz00_13626,((long)2),BgL_az00_11463); 
VECTOR_SET(BgL_nsz00_13626,((long)3),BgL_bz00_11464); 
VECTOR_SET(BgL_nsz00_13626,((long)4),BgL_cz00_11465); 
VECTOR_SET(BgL_nsz00_13626,((long)5),BgL_dz00_11466); 
VECTOR_SET(BgL_nsz00_13626,((long)6),BgL_lastz00_11467); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13627;
BgL_z12denvz12_13627 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13627, BgL_nsz00_13626); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13628;
BgL_ez00_13628 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13628, BgL_sz00_13617); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13629;
BgL_____rz00_13629 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11461, BgL_nsz00_13626, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13628); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13627, BgL_sz00_13617); 
return BgL_____rz00_13629;} } } } } } } } 

}



/* &run */
obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_11468, obj_t BgL_sz00_11471)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11469;obj_t BgL_bodyz00_11470;
BgL_i1243z00_11469 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11468, 
(int)(((long)0)))); 
BgL_bodyz00_11470 = 
PROCEDURE_REF(BgL_envz00_11468, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13630;
BgL_bpz00_13630 = 
VECTOR_REF(
((obj_t)BgL_sz00_11471),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13631;obj_t BgL_wherez00_13632;obj_t BgL_locz00_13633;
BgL_z12denvz12_13631 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13632 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11469))->BgL_wherez00); 
BgL_locz00_13633 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11469))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13631, BgL_wherez00_13632, BgL_locz00_13633); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13634;
BgL_za2za2resza2za2z00_13634 = 
PROCEDURE_ENTRY(BgL_bodyz00_11470)(BgL_bodyz00_11470, BgL_sz00_11471, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13631); 
return BgL_za2za2resza2za2z00_13634;} } } } } } 

}



/* &<@anonymous:3585> */
obj_t BGl_z62zc3z04anonymousza33585ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11472, obj_t BgL_sz00_11477)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11473;BgL_ev_absz00_bglt BgL_i1243z00_11474;obj_t BgL_bodyz00_11475;long BgL_siza7ezd2framez75_11476;
BgL_iboxesz00_11473 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11472, 
(int)(((long)0)))); 
BgL_i1243z00_11474 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11472, 
(int)(((long)1)))); 
BgL_bodyz00_11475 = 
PROCEDURE_REF(BgL_envz00_11472, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11476 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11472, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13635;
BgL_bpz00_13635 = 
VECTOR_REF(
((obj_t)BgL_sz00_11477),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13636;
BgL_runz00_13636 = 
MAKE_FX_PROCEDURE(BGl_z62run5149z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13636, 
(int)(((long)0)), BgL_iboxesz00_11473); 
PROCEDURE_SET(BgL_runz00_13636, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11474)); 
PROCEDURE_SET(BgL_runz00_13636, 
(int)(((long)2)), BgL_bodyz00_11475); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13637;
BgL_mainz00_13637 = 
MAKE_VA_PROCEDURE(BGl_z62main5148z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13637, 
(int)(((long)0)), BgL_iboxesz00_11473); 
PROCEDURE_SET(BgL_mainz00_13637, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11474)); 
PROCEDURE_SET(BgL_mainz00_13637, 
(int)(((long)2)), BgL_bodyz00_11475); 
PROCEDURE_SET(BgL_mainz00_13637, 
(int)(((long)3)), BgL_runz00_13636); 
PROCEDURE_SET(BgL_mainz00_13637, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11476)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13638;
BgL_objz00_13638 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13636, BgL_objz00_13638); BgL_objz00_13638; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3586z00_13639;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3587z00_13640;
BgL_arg3587z00_13640 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11474))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13641;
BgL_newz00_13641 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22569;
BgL_tmpz00_22569 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13641, BgL_tmpz00_22569, BgL_arg3587z00_13640); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22574;int BgL_tmpz00_22572;
BgL_auxz00_22574 = 
BINT(BgL_siza7ezd2framez75_11476); 
BgL_tmpz00_22572 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13641, BgL_tmpz00_22572, BgL_auxz00_22574); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22577;
BgL_tmpz00_22577 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13641, BgL_tmpz00_22577, BgL_runz00_13636); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22582;int BgL_tmpz00_22580;
BgL_auxz00_22582 = 
BINT(((long)-5)); 
BgL_tmpz00_22580 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13641, BgL_tmpz00_22580, BgL_auxz00_22582); } 
BgL_arg3586z00_13639 = BgL_newz00_13641; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13637, BgL_arg3586z00_13639); BgL_arg3586z00_13639; } 
return BgL_mainz00_13637;} } } } } } 

}



/* &main5148 */
obj_t BGl_z62main5148z62zz__evaluate_compz00(obj_t BgL_envz00_11478, obj_t BgL_az00_11484, obj_t BgL_bz00_11485, obj_t BgL_cz00_11486, obj_t BgL_dz00_11487, obj_t BgL_lastz00_11488)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11482;long BgL_siza7ezd2framez75_11483;
BgL_runz00_11482 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11478, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11483 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11478, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13642;
BgL_sz00_13642 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13643;
BgL_bpz00_13643 = 
VECTOR_REF(
((obj_t)BgL_sz00_13642),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13642, BgL_bpz00_13643, 
BINT(BgL_siza7ezd2framez75_11483)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3590z00_13644;
BgL_arg3590z00_13644 = 
(
(long)CINT(BgL_bpz00_13643)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13642),BgL_arg3590z00_13644,BgL_az00_11484); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3591z00_13645;
BgL_arg3591z00_13645 = 
(
(long)CINT(BgL_bpz00_13643)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13642),BgL_arg3591z00_13645,BgL_bz00_11485); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3592z00_13646;
BgL_arg3592z00_13646 = 
(
(long)CINT(BgL_bpz00_13643)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13642),BgL_arg3592z00_13646,BgL_cz00_11486); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3593z00_13647;
BgL_arg3593z00_13647 = 
(
(long)CINT(BgL_bpz00_13643)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13642),BgL_arg3593z00_13647,BgL_dz00_11487); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3594z00_13648;
BgL_arg3594z00_13648 = 
(
(long)CINT(BgL_bpz00_13643)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13642),BgL_arg3594z00_13648,BgL_lastz00_11488); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13649;
BgL_ez00_13649 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13649, BgL_bpz00_13643); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13650;
BgL_accz00_13650 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11482, BgL_sz00_13642, BgL_bpz00_13643); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13649); 
VECTOR_SET(
((obj_t)BgL_sz00_13642),((long)0),BgL_bpz00_13643); 
return BgL_accz00_13650;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13651;
BgL_nsz00_13651 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13651,((long)1),BgL_sz00_13642); 
VECTOR_SET(BgL_nsz00_13651,((long)2),BgL_az00_11484); 
VECTOR_SET(BgL_nsz00_13651,((long)3),BgL_bz00_11485); 
VECTOR_SET(BgL_nsz00_13651,((long)4),BgL_cz00_11486); 
VECTOR_SET(BgL_nsz00_13651,((long)5),BgL_dz00_11487); 
VECTOR_SET(BgL_nsz00_13651,((long)6),BgL_lastz00_11488); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13652;
BgL_z12denvz12_13652 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13652, BgL_nsz00_13651); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13653;
BgL_ez00_13653 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13653, BgL_sz00_13642); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13654;
BgL_____rz00_13654 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11482, BgL_nsz00_13651, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13653); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13652, BgL_sz00_13642); 
return BgL_____rz00_13654;} } } } } } } } 

}



/* &run5149 */
obj_t BGl_z62run5149z62zz__evaluate_compz00(obj_t BgL_envz00_11489, obj_t BgL_sz00_11493)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11490;BgL_ev_absz00_bglt BgL_i1243z00_11491;obj_t BgL_bodyz00_11492;
BgL_iboxesz00_11490 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11489, 
(int)(((long)0)))); 
BgL_i1243z00_11491 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11489, 
(int)(((long)1)))); 
BgL_bodyz00_11492 = 
PROCEDURE_REF(BgL_envz00_11489, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13655;
BgL_bpz00_13655 = 
VECTOR_REF(
((obj_t)BgL_sz00_11493),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11493, BgL_iboxesz00_11490, BgL_bpz00_13655); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13656;obj_t BgL_wherez00_13657;obj_t BgL_locz00_13658;
BgL_z12denvz12_13656 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13657 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11491))->BgL_wherez00); 
BgL_locz00_13658 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11491))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13656, BgL_wherez00_13657, BgL_locz00_13658); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13659;
BgL_za2za2resza2za2z00_13659 = 
PROCEDURE_ENTRY(BgL_bodyz00_11492)(BgL_bodyz00_11492, BgL_sz00_11493, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13656); 
return BgL_za2za2resza2za2z00_13659;} } } } } } 

}



/* &<@anonymous:3599> */
obj_t BGl_z62zc3z04anonymousza33599ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11494, obj_t BgL_sz00_11500)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11495;long BgL_siza7eza7_11496;BgL_ev_absz00_bglt BgL_i1243z00_11497;obj_t BgL_bodyz00_11498;long BgL_siza7ezd2framez75_11499;
BgL_ifreesz00_11495 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11494, 
(int)(((long)0)))); 
BgL_siza7eza7_11496 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11494, 
(int)(((long)1)))); 
BgL_i1243z00_11497 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11494, 
(int)(((long)2)))); 
BgL_bodyz00_11498 = 
PROCEDURE_REF(BgL_envz00_11494, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11499 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11494, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13660;
BgL_bpz00_13660 = 
VECTOR_REF(
((obj_t)BgL_sz00_11500),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13661;
BgL_valza2za2_13661 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11500, BgL_bpz00_13660, BgL_ifreesz00_11495); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13662;
BgL_runz00_13662 = 
MAKE_FX_PROCEDURE(BGl_z62run5151z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13662, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11496)); 
PROCEDURE_SET(BgL_runz00_13662, 
(int)(((long)1)), BgL_valza2za2_13661); 
PROCEDURE_SET(BgL_runz00_13662, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11497)); 
PROCEDURE_SET(BgL_runz00_13662, 
(int)(((long)3)), BgL_bodyz00_11498); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13663;
BgL_mainz00_13663 = 
MAKE_VA_PROCEDURE(BGl_z62main5150z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13663, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11496)); 
PROCEDURE_SET(BgL_mainz00_13663, 
(int)(((long)1)), BgL_valza2za2_13661); 
PROCEDURE_SET(BgL_mainz00_13663, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11497)); 
PROCEDURE_SET(BgL_mainz00_13663, 
(int)(((long)3)), BgL_bodyz00_11498); 
PROCEDURE_SET(BgL_mainz00_13663, 
(int)(((long)4)), BgL_runz00_13662); 
PROCEDURE_SET(BgL_mainz00_13663, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11499)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13664;
BgL_objz00_13664 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13662, BgL_objz00_13664); BgL_objz00_13664; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3600z00_13665;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3601z00_13666;
BgL_arg3601z00_13666 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11497))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13667;
BgL_newz00_13667 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22711;
BgL_tmpz00_22711 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13667, BgL_tmpz00_22711, BgL_arg3601z00_13666); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22716;int BgL_tmpz00_22714;
BgL_auxz00_22716 = 
BINT(BgL_siza7ezd2framez75_11499); 
BgL_tmpz00_22714 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13667, BgL_tmpz00_22714, BgL_auxz00_22716); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22719;
BgL_tmpz00_22719 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13667, BgL_tmpz00_22719, BgL_runz00_13662); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22724;int BgL_tmpz00_22722;
BgL_auxz00_22724 = 
BINT(((long)-5)); 
BgL_tmpz00_22722 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13667, BgL_tmpz00_22722, BgL_auxz00_22724); } 
BgL_arg3600z00_13665 = BgL_newz00_13667; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13663, BgL_arg3600z00_13665); BgL_arg3600z00_13665; } 
return BgL_mainz00_13663;} } } } } } 

}



/* &main5150 */
obj_t BGl_z62main5150z62zz__evaluate_compz00(obj_t BgL_envz00_11501, obj_t BgL_az00_11508, obj_t BgL_bz00_11509, obj_t BgL_cz00_11510, obj_t BgL_dz00_11511, obj_t BgL_lastz00_11512)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11506;long BgL_siza7ezd2framez75_11507;
BgL_runz00_11506 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11501, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11507 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11501, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13668;
BgL_sz00_13668 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13669;
BgL_bpz00_13669 = 
VECTOR_REF(
((obj_t)BgL_sz00_13668),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13668, BgL_bpz00_13669, 
BINT(BgL_siza7ezd2framez75_11507)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3604z00_13670;
BgL_arg3604z00_13670 = 
(
(long)CINT(BgL_bpz00_13669)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13668),BgL_arg3604z00_13670,BgL_az00_11508); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3605z00_13671;
BgL_arg3605z00_13671 = 
(
(long)CINT(BgL_bpz00_13669)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13668),BgL_arg3605z00_13671,BgL_bz00_11509); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3606z00_13672;
BgL_arg3606z00_13672 = 
(
(long)CINT(BgL_bpz00_13669)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13668),BgL_arg3606z00_13672,BgL_cz00_11510); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3607z00_13673;
BgL_arg3607z00_13673 = 
(
(long)CINT(BgL_bpz00_13669)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13668),BgL_arg3607z00_13673,BgL_dz00_11511); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3608z00_13674;
BgL_arg3608z00_13674 = 
(
(long)CINT(BgL_bpz00_13669)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13668),BgL_arg3608z00_13674,BgL_lastz00_11512); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13675;
BgL_ez00_13675 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13675, BgL_bpz00_13669); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13676;
BgL_accz00_13676 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11506, BgL_sz00_13668, BgL_bpz00_13669); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13675); 
VECTOR_SET(
((obj_t)BgL_sz00_13668),((long)0),BgL_bpz00_13669); 
return BgL_accz00_13676;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13677;
BgL_nsz00_13677 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13677,((long)1),BgL_sz00_13668); 
VECTOR_SET(BgL_nsz00_13677,((long)2),BgL_az00_11508); 
VECTOR_SET(BgL_nsz00_13677,((long)3),BgL_bz00_11509); 
VECTOR_SET(BgL_nsz00_13677,((long)4),BgL_cz00_11510); 
VECTOR_SET(BgL_nsz00_13677,((long)5),BgL_dz00_11511); 
VECTOR_SET(BgL_nsz00_13677,((long)6),BgL_lastz00_11512); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13678;
BgL_z12denvz12_13678 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13678, BgL_nsz00_13677); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13679;
BgL_ez00_13679 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13679, BgL_sz00_13668); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13680;
BgL_____rz00_13680 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11506, BgL_nsz00_13677, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13679); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13678, BgL_sz00_13668); 
return BgL_____rz00_13680;} } } } } } } } 

}



/* &run5151 */
obj_t BGl_z62run5151z62zz__evaluate_compz00(obj_t BgL_envz00_11513, obj_t BgL_sz00_11518)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11514;obj_t BgL_valza2za2_11515;BgL_ev_absz00_bglt BgL_i1243z00_11516;obj_t BgL_bodyz00_11517;
BgL_siza7eza7_11514 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11513, 
(int)(((long)0)))); 
BgL_valza2za2_11515 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11513, 
(int)(((long)1)))); 
BgL_i1243z00_11516 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11513, 
(int)(((long)2)))); 
BgL_bodyz00_11517 = 
PROCEDURE_REF(BgL_envz00_11513, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13681;
BgL_bpz00_13681 = 
VECTOR_REF(
((obj_t)BgL_sz00_11518),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11518, BgL_valza2za2_11515, 
(
(long)CINT(BgL_bpz00_13681)+BgL_siza7eza7_11514)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13682;obj_t BgL_wherez00_13683;obj_t BgL_locz00_13684;
BgL_z12denvz12_13682 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13683 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11516))->BgL_wherez00); 
BgL_locz00_13684 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11516))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13682, BgL_wherez00_13683, BgL_locz00_13684); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13685;
BgL_za2za2resza2za2z00_13685 = 
PROCEDURE_ENTRY(BgL_bodyz00_11517)(BgL_bodyz00_11517, BgL_sz00_11518, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13682); 
return BgL_za2za2resza2za2z00_13685;} } } } } } 

}



/* &<@anonymous:3611> */
obj_t BGl_z62zc3z04anonymousza33611ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11519, obj_t BgL_sz00_11526)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11520;obj_t BgL_iboxesz00_11521;long BgL_siza7eza7_11522;BgL_ev_absz00_bglt BgL_i1243z00_11523;obj_t BgL_bodyz00_11524;long BgL_siza7ezd2framez75_11525;
BgL_ifreesz00_11520 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11519, 
(int)(((long)0)))); 
BgL_iboxesz00_11521 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11519, 
(int)(((long)1)))); 
BgL_siza7eza7_11522 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11519, 
(int)(((long)2)))); 
BgL_i1243z00_11523 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11519, 
(int)(((long)3)))); 
BgL_bodyz00_11524 = 
PROCEDURE_REF(BgL_envz00_11519, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11525 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11519, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13686;
BgL_bpz00_13686 = 
VECTOR_REF(
((obj_t)BgL_sz00_11526),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13687;
BgL_valza2za2_13687 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11526, BgL_bpz00_13686, BgL_ifreesz00_11520); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13688;
BgL_runz00_13688 = 
MAKE_FX_PROCEDURE(BGl_z62run5153z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13688, 
(int)(((long)0)), BgL_iboxesz00_11521); 
PROCEDURE_SET(BgL_runz00_13688, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11522)); 
PROCEDURE_SET(BgL_runz00_13688, 
(int)(((long)2)), BgL_valza2za2_13687); 
PROCEDURE_SET(BgL_runz00_13688, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11523)); 
PROCEDURE_SET(BgL_runz00_13688, 
(int)(((long)4)), BgL_bodyz00_11524); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13689;
BgL_mainz00_13689 = 
MAKE_VA_PROCEDURE(BGl_z62main5152z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13689, 
(int)(((long)0)), BgL_iboxesz00_11521); 
PROCEDURE_SET(BgL_mainz00_13689, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11522)); 
PROCEDURE_SET(BgL_mainz00_13689, 
(int)(((long)2)), BgL_valza2za2_13687); 
PROCEDURE_SET(BgL_mainz00_13689, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11523)); 
PROCEDURE_SET(BgL_mainz00_13689, 
(int)(((long)4)), BgL_bodyz00_11524); 
PROCEDURE_SET(BgL_mainz00_13689, 
(int)(((long)5)), BgL_runz00_13688); 
PROCEDURE_SET(BgL_mainz00_13689, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11525)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13690;
BgL_objz00_13690 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13688, BgL_objz00_13690); BgL_objz00_13690; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3612z00_13691;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3613z00_13692;
BgL_arg3613z00_13692 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11523))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13693;
BgL_newz00_13693 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22865;
BgL_tmpz00_22865 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13693, BgL_tmpz00_22865, BgL_arg3613z00_13692); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22870;int BgL_tmpz00_22868;
BgL_auxz00_22870 = 
BINT(BgL_siza7ezd2framez75_11525); 
BgL_tmpz00_22868 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13693, BgL_tmpz00_22868, BgL_auxz00_22870); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22873;
BgL_tmpz00_22873 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13693, BgL_tmpz00_22873, BgL_runz00_13688); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_22878;int BgL_tmpz00_22876;
BgL_auxz00_22878 = 
BINT(((long)-5)); 
BgL_tmpz00_22876 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13693, BgL_tmpz00_22876, BgL_auxz00_22878); } 
BgL_arg3612z00_13691 = BgL_newz00_13693; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13689, BgL_arg3612z00_13691); BgL_arg3612z00_13691; } 
return BgL_mainz00_13689;} } } } } } 

}



/* &main5152 */
obj_t BGl_z62main5152z62zz__evaluate_compz00(obj_t BgL_envz00_11527, obj_t BgL_az00_11535, obj_t BgL_bz00_11536, obj_t BgL_cz00_11537, obj_t BgL_dz00_11538, obj_t BgL_lastz00_11539)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11533;long BgL_siza7ezd2framez75_11534;
BgL_runz00_11533 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11527, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11534 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11527, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13694;
BgL_sz00_13694 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13695;
BgL_bpz00_13695 = 
VECTOR_REF(
((obj_t)BgL_sz00_13694),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13694, BgL_bpz00_13695, 
BINT(BgL_siza7ezd2framez75_11534)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3616z00_13696;
BgL_arg3616z00_13696 = 
(
(long)CINT(BgL_bpz00_13695)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13694),BgL_arg3616z00_13696,BgL_az00_11535); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3617z00_13697;
BgL_arg3617z00_13697 = 
(
(long)CINT(BgL_bpz00_13695)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13694),BgL_arg3617z00_13697,BgL_bz00_11536); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3618z00_13698;
BgL_arg3618z00_13698 = 
(
(long)CINT(BgL_bpz00_13695)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13694),BgL_arg3618z00_13698,BgL_cz00_11537); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3619z00_13699;
BgL_arg3619z00_13699 = 
(
(long)CINT(BgL_bpz00_13695)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13694),BgL_arg3619z00_13699,BgL_dz00_11538); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3620z00_13700;
BgL_arg3620z00_13700 = 
(
(long)CINT(BgL_bpz00_13695)+((long)4)); 
VECTOR_SET(
((obj_t)BgL_sz00_13694),BgL_arg3620z00_13700,BgL_lastz00_11539); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13701;
BgL_ez00_13701 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13701, BgL_bpz00_13695); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13702;
BgL_accz00_13702 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11533, BgL_sz00_13694, BgL_bpz00_13695); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13701); 
VECTOR_SET(
((obj_t)BgL_sz00_13694),((long)0),BgL_bpz00_13695); 
return BgL_accz00_13702;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13703;
BgL_nsz00_13703 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13703,((long)1),BgL_sz00_13694); 
VECTOR_SET(BgL_nsz00_13703,((long)2),BgL_az00_11535); 
VECTOR_SET(BgL_nsz00_13703,((long)3),BgL_bz00_11536); 
VECTOR_SET(BgL_nsz00_13703,((long)4),BgL_cz00_11537); 
VECTOR_SET(BgL_nsz00_13703,((long)5),BgL_dz00_11538); 
VECTOR_SET(BgL_nsz00_13703,((long)6),BgL_lastz00_11539); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13704;
BgL_z12denvz12_13704 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13704, BgL_nsz00_13703); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13705;
BgL_ez00_13705 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13705, BgL_sz00_13694); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13706;
BgL_____rz00_13706 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11533, BgL_nsz00_13703, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13705); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13704, BgL_sz00_13694); 
return BgL_____rz00_13706;} } } } } } } } 

}



/* &run5153 */
obj_t BGl_z62run5153z62zz__evaluate_compz00(obj_t BgL_envz00_11540, obj_t BgL_sz00_11546)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11541;long BgL_siza7eza7_11542;obj_t BgL_valza2za2_11543;BgL_ev_absz00_bglt BgL_i1243z00_11544;obj_t BgL_bodyz00_11545;
BgL_iboxesz00_11541 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11540, 
(int)(((long)0)))); 
BgL_siza7eza7_11542 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11540, 
(int)(((long)1)))); 
BgL_valza2za2_11543 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11540, 
(int)(((long)2)))); 
BgL_i1243z00_11544 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11540, 
(int)(((long)3)))); 
BgL_bodyz00_11545 = 
PROCEDURE_REF(BgL_envz00_11540, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13707;
BgL_bpz00_13707 = 
VECTOR_REF(
((obj_t)BgL_sz00_11546),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11546, BgL_iboxesz00_11541, BgL_bpz00_13707); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11546, BgL_valza2za2_11543, 
(
(long)CINT(BgL_bpz00_13707)+BgL_siza7eza7_11542)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13708;obj_t BgL_wherez00_13709;obj_t BgL_locz00_13710;
BgL_z12denvz12_13708 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13709 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11544))->BgL_wherez00); 
BgL_locz00_13710 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11544))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13708, BgL_wherez00_13709, BgL_locz00_13710); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13711;
BgL_za2za2resza2za2z00_13711 = 
PROCEDURE_ENTRY(BgL_bodyz00_11545)(BgL_bodyz00_11545, BgL_sz00_11546, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13708); 
return BgL_za2za2resza2za2z00_13711;} } } } } } 

}



/* &<@anonymous:3523> */
obj_t BGl_z62zc3z04anonymousza33523ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11547, obj_t BgL_sz00_11551)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11548;obj_t BgL_bodyz00_11549;long BgL_siza7ezd2framez75_11550;
BgL_i1243z00_11548 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11547, 
(int)(((long)0)))); 
BgL_bodyz00_11549 = 
PROCEDURE_REF(BgL_envz00_11547, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11550 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11547, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13712;
BgL_bpz00_13712 = 
VECTOR_REF(
((obj_t)BgL_sz00_11551),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13713;
BgL_runz00_13713 = 
MAKE_FX_PROCEDURE(BGl_z62run5155z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13713, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11548)); 
PROCEDURE_SET(BgL_runz00_13713, 
(int)(((long)1)), BgL_bodyz00_11549); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13714;
BgL_mainz00_13714 = 
MAKE_FX_PROCEDURE(BGl_z62main5154z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13714, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11548)); 
PROCEDURE_SET(BgL_mainz00_13714, 
(int)(((long)1)), BgL_bodyz00_11549); 
PROCEDURE_SET(BgL_mainz00_13714, 
(int)(((long)2)), BgL_runz00_13713); 
PROCEDURE_SET(BgL_mainz00_13714, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11550)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13715;
BgL_objz00_13715 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13713, BgL_objz00_13715); BgL_objz00_13715; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3524z00_13716;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3525z00_13717;
BgL_arg3525z00_13717 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11548))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13718;
BgL_newz00_13718 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_22999;
BgL_tmpz00_22999 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13718, BgL_tmpz00_22999, BgL_arg3525z00_13717); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23004;int BgL_tmpz00_23002;
BgL_auxz00_23004 = 
BINT(BgL_siza7ezd2framez75_11550); 
BgL_tmpz00_23002 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13718, BgL_tmpz00_23002, BgL_auxz00_23004); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23007;
BgL_tmpz00_23007 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13718, BgL_tmpz00_23007, BgL_runz00_13713); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23012;int BgL_tmpz00_23010;
BgL_auxz00_23012 = 
BINT(((long)4)); 
BgL_tmpz00_23010 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13718, BgL_tmpz00_23010, BgL_auxz00_23012); } 
BgL_arg3524z00_13716 = BgL_newz00_13718; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13714, BgL_arg3524z00_13716); BgL_arg3524z00_13716; } 
return BgL_mainz00_13714;} } } } } } 

}



/* &main5154 */
obj_t BGl_z62main5154z62zz__evaluate_compz00(obj_t BgL_envz00_11552, obj_t BgL_az00_11557, obj_t BgL_bz00_11558, obj_t BgL_cz00_11559, obj_t BgL_dz00_11560)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11555;long BgL_siza7ezd2framez75_11556;
BgL_runz00_11555 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11552, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11556 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11552, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13719;
BgL_sz00_13719 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13720;
BgL_bpz00_13720 = 
VECTOR_REF(
((obj_t)BgL_sz00_13719),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13719, BgL_bpz00_13720, 
BINT(BgL_siza7ezd2framez75_11556)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3528z00_13721;
BgL_arg3528z00_13721 = 
(
(long)CINT(BgL_bpz00_13720)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13719),BgL_arg3528z00_13721,BgL_az00_11557); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3529z00_13722;
BgL_arg3529z00_13722 = 
(
(long)CINT(BgL_bpz00_13720)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13719),BgL_arg3529z00_13722,BgL_bz00_11558); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3530z00_13723;
BgL_arg3530z00_13723 = 
(
(long)CINT(BgL_bpz00_13720)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13719),BgL_arg3530z00_13723,BgL_cz00_11559); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3531z00_13724;
BgL_arg3531z00_13724 = 
(
(long)CINT(BgL_bpz00_13720)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13719),BgL_arg3531z00_13724,BgL_dz00_11560); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13725;
BgL_ez00_13725 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13725, BgL_bpz00_13720); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13726;
BgL_accz00_13726 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11555, BgL_sz00_13719, BgL_bpz00_13720); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13725); 
VECTOR_SET(
((obj_t)BgL_sz00_13719),((long)0),BgL_bpz00_13720); 
return BgL_accz00_13726;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13727;
BgL_nsz00_13727 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13727,((long)1),BgL_sz00_13719); 
VECTOR_SET(BgL_nsz00_13727,((long)2),BgL_az00_11557); 
VECTOR_SET(BgL_nsz00_13727,((long)3),BgL_bz00_11558); 
VECTOR_SET(BgL_nsz00_13727,((long)4),BgL_cz00_11559); 
VECTOR_SET(BgL_nsz00_13727,((long)5),BgL_dz00_11560); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13728;
BgL_z12denvz12_13728 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13728, BgL_nsz00_13727); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13729;
BgL_ez00_13729 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13729, BgL_sz00_13719); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13730;
BgL_____rz00_13730 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11555, BgL_nsz00_13727, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13729); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13728, BgL_sz00_13719); 
return BgL_____rz00_13730;} } } } } } } } 

}



/* &run5155 */
obj_t BGl_z62run5155z62zz__evaluate_compz00(obj_t BgL_envz00_11561, obj_t BgL_sz00_11564)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11562;obj_t BgL_bodyz00_11563;
BgL_i1243z00_11562 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)0)))); 
BgL_bodyz00_11563 = 
PROCEDURE_REF(BgL_envz00_11561, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13731;
BgL_bpz00_13731 = 
VECTOR_REF(
((obj_t)BgL_sz00_11564),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13732;obj_t BgL_wherez00_13733;obj_t BgL_locz00_13734;
BgL_z12denvz12_13732 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13733 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11562))->BgL_wherez00); 
BgL_locz00_13734 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11562))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13732, BgL_wherez00_13733, BgL_locz00_13734); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13735;
BgL_za2za2resza2za2z00_13735 = 
PROCEDURE_ENTRY(BgL_bodyz00_11563)(BgL_bodyz00_11563, BgL_sz00_11564, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13732); 
return BgL_za2za2resza2za2z00_13735;} } } } } } 

}



/* &<@anonymous:3533> */
obj_t BGl_z62zc3z04anonymousza33533ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11565, obj_t BgL_sz00_11570)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11566;BgL_ev_absz00_bglt BgL_i1243z00_11567;obj_t BgL_bodyz00_11568;long BgL_siza7ezd2framez75_11569;
BgL_iboxesz00_11566 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11565, 
(int)(((long)0)))); 
BgL_i1243z00_11567 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11565, 
(int)(((long)1)))); 
BgL_bodyz00_11568 = 
PROCEDURE_REF(BgL_envz00_11565, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11569 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11565, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13736;
BgL_bpz00_13736 = 
VECTOR_REF(
((obj_t)BgL_sz00_11570),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13737;
BgL_runz00_13737 = 
MAKE_FX_PROCEDURE(BGl_z62run5157z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13737, 
(int)(((long)0)), BgL_iboxesz00_11566); 
PROCEDURE_SET(BgL_runz00_13737, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11567)); 
PROCEDURE_SET(BgL_runz00_13737, 
(int)(((long)2)), BgL_bodyz00_11568); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13738;
BgL_mainz00_13738 = 
MAKE_FX_PROCEDURE(BGl_z62main5156z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13738, 
(int)(((long)0)), BgL_iboxesz00_11566); 
PROCEDURE_SET(BgL_mainz00_13738, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11567)); 
PROCEDURE_SET(BgL_mainz00_13738, 
(int)(((long)2)), BgL_bodyz00_11568); 
PROCEDURE_SET(BgL_mainz00_13738, 
(int)(((long)3)), BgL_runz00_13737); 
PROCEDURE_SET(BgL_mainz00_13738, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11569)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13739;
BgL_objz00_13739 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13737, BgL_objz00_13739); BgL_objz00_13739; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3534z00_13740;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3535z00_13741;
BgL_arg3535z00_13741 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11567))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13742;
BgL_newz00_13742 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23122;
BgL_tmpz00_23122 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13742, BgL_tmpz00_23122, BgL_arg3535z00_13741); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23127;int BgL_tmpz00_23125;
BgL_auxz00_23127 = 
BINT(BgL_siza7ezd2framez75_11569); 
BgL_tmpz00_23125 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13742, BgL_tmpz00_23125, BgL_auxz00_23127); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23130;
BgL_tmpz00_23130 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13742, BgL_tmpz00_23130, BgL_runz00_13737); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23135;int BgL_tmpz00_23133;
BgL_auxz00_23135 = 
BINT(((long)4)); 
BgL_tmpz00_23133 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13742, BgL_tmpz00_23133, BgL_auxz00_23135); } 
BgL_arg3534z00_13740 = BgL_newz00_13742; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13738, BgL_arg3534z00_13740); BgL_arg3534z00_13740; } 
return BgL_mainz00_13738;} } } } } } 

}



/* &main5156 */
obj_t BGl_z62main5156z62zz__evaluate_compz00(obj_t BgL_envz00_11571, obj_t BgL_az00_11577, obj_t BgL_bz00_11578, obj_t BgL_cz00_11579, obj_t BgL_dz00_11580)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11575;long BgL_siza7ezd2framez75_11576;
BgL_runz00_11575 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11571, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11576 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11571, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13743;
BgL_sz00_13743 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13744;
BgL_bpz00_13744 = 
VECTOR_REF(
((obj_t)BgL_sz00_13743),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13743, BgL_bpz00_13744, 
BINT(BgL_siza7ezd2framez75_11576)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3538z00_13745;
BgL_arg3538z00_13745 = 
(
(long)CINT(BgL_bpz00_13744)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13743),BgL_arg3538z00_13745,BgL_az00_11577); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3539z00_13746;
BgL_arg3539z00_13746 = 
(
(long)CINT(BgL_bpz00_13744)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13743),BgL_arg3539z00_13746,BgL_bz00_11578); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3540z00_13747;
BgL_arg3540z00_13747 = 
(
(long)CINT(BgL_bpz00_13744)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13743),BgL_arg3540z00_13747,BgL_cz00_11579); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3541z00_13748;
BgL_arg3541z00_13748 = 
(
(long)CINT(BgL_bpz00_13744)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13743),BgL_arg3541z00_13748,BgL_dz00_11580); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13749;
BgL_ez00_13749 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13749, BgL_bpz00_13744); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13750;
BgL_accz00_13750 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11575, BgL_sz00_13743, BgL_bpz00_13744); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13749); 
VECTOR_SET(
((obj_t)BgL_sz00_13743),((long)0),BgL_bpz00_13744); 
return BgL_accz00_13750;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13751;
BgL_nsz00_13751 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13751,((long)1),BgL_sz00_13743); 
VECTOR_SET(BgL_nsz00_13751,((long)2),BgL_az00_11577); 
VECTOR_SET(BgL_nsz00_13751,((long)3),BgL_bz00_11578); 
VECTOR_SET(BgL_nsz00_13751,((long)4),BgL_cz00_11579); 
VECTOR_SET(BgL_nsz00_13751,((long)5),BgL_dz00_11580); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13752;
BgL_z12denvz12_13752 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13752, BgL_nsz00_13751); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13753;
BgL_ez00_13753 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13753, BgL_sz00_13743); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13754;
BgL_____rz00_13754 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11575, BgL_nsz00_13751, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13753); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13752, BgL_sz00_13743); 
return BgL_____rz00_13754;} } } } } } } } 

}



/* &run5157 */
obj_t BGl_z62run5157z62zz__evaluate_compz00(obj_t BgL_envz00_11581, obj_t BgL_sz00_11585)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11582;BgL_ev_absz00_bglt BgL_i1243z00_11583;obj_t BgL_bodyz00_11584;
BgL_iboxesz00_11582 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11581, 
(int)(((long)0)))); 
BgL_i1243z00_11583 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11581, 
(int)(((long)1)))); 
BgL_bodyz00_11584 = 
PROCEDURE_REF(BgL_envz00_11581, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13755;
BgL_bpz00_13755 = 
VECTOR_REF(
((obj_t)BgL_sz00_11585),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11585, BgL_iboxesz00_11582, BgL_bpz00_13755); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13756;obj_t BgL_wherez00_13757;obj_t BgL_locz00_13758;
BgL_z12denvz12_13756 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13757 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11583))->BgL_wherez00); 
BgL_locz00_13758 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11583))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13756, BgL_wherez00_13757, BgL_locz00_13758); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13759;
BgL_za2za2resza2za2z00_13759 = 
PROCEDURE_ENTRY(BgL_bodyz00_11584)(BgL_bodyz00_11584, BgL_sz00_11585, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13756); 
return BgL_za2za2resza2za2z00_13759;} } } } } } 

}



/* &<@anonymous:3546> */
obj_t BGl_z62zc3z04anonymousza33546ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11586, obj_t BgL_sz00_11592)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11587;long BgL_siza7eza7_11588;BgL_ev_absz00_bglt BgL_i1243z00_11589;obj_t BgL_bodyz00_11590;long BgL_siza7ezd2framez75_11591;
BgL_ifreesz00_11587 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11586, 
(int)(((long)0)))); 
BgL_siza7eza7_11588 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11586, 
(int)(((long)1)))); 
BgL_i1243z00_11589 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11586, 
(int)(((long)2)))); 
BgL_bodyz00_11590 = 
PROCEDURE_REF(BgL_envz00_11586, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11591 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11586, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13760;
BgL_bpz00_13760 = 
VECTOR_REF(
((obj_t)BgL_sz00_11592),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13761;
BgL_valza2za2_13761 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11592, BgL_bpz00_13760, BgL_ifreesz00_11587); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13762;
BgL_runz00_13762 = 
MAKE_FX_PROCEDURE(BGl_z62run5159z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13762, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11588)); 
PROCEDURE_SET(BgL_runz00_13762, 
(int)(((long)1)), BgL_valza2za2_13761); 
PROCEDURE_SET(BgL_runz00_13762, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11589)); 
PROCEDURE_SET(BgL_runz00_13762, 
(int)(((long)3)), BgL_bodyz00_11590); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13763;
BgL_mainz00_13763 = 
MAKE_FX_PROCEDURE(BGl_z62main5158z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13763, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11588)); 
PROCEDURE_SET(BgL_mainz00_13763, 
(int)(((long)1)), BgL_valza2za2_13761); 
PROCEDURE_SET(BgL_mainz00_13763, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11589)); 
PROCEDURE_SET(BgL_mainz00_13763, 
(int)(((long)3)), BgL_bodyz00_11590); 
PROCEDURE_SET(BgL_mainz00_13763, 
(int)(((long)4)), BgL_runz00_13762); 
PROCEDURE_SET(BgL_mainz00_13763, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11591)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13764;
BgL_objz00_13764 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13762, BgL_objz00_13764); BgL_objz00_13764; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3547z00_13765;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3548z00_13766;
BgL_arg3548z00_13766 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11589))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13767;
BgL_newz00_13767 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23259;
BgL_tmpz00_23259 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13767, BgL_tmpz00_23259, BgL_arg3548z00_13766); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23264;int BgL_tmpz00_23262;
BgL_auxz00_23264 = 
BINT(BgL_siza7ezd2framez75_11591); 
BgL_tmpz00_23262 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13767, BgL_tmpz00_23262, BgL_auxz00_23264); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23267;
BgL_tmpz00_23267 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13767, BgL_tmpz00_23267, BgL_runz00_13762); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23272;int BgL_tmpz00_23270;
BgL_auxz00_23272 = 
BINT(((long)4)); 
BgL_tmpz00_23270 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13767, BgL_tmpz00_23270, BgL_auxz00_23272); } 
BgL_arg3547z00_13765 = BgL_newz00_13767; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13763, BgL_arg3547z00_13765); BgL_arg3547z00_13765; } 
return BgL_mainz00_13763;} } } } } } 

}



/* &main5158 */
obj_t BGl_z62main5158z62zz__evaluate_compz00(obj_t BgL_envz00_11593, obj_t BgL_az00_11600, obj_t BgL_bz00_11601, obj_t BgL_cz00_11602, obj_t BgL_dz00_11603)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11598;long BgL_siza7ezd2framez75_11599;
BgL_runz00_11598 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11593, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11599 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11593, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13768;
BgL_sz00_13768 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13769;
BgL_bpz00_13769 = 
VECTOR_REF(
((obj_t)BgL_sz00_13768),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13768, BgL_bpz00_13769, 
BINT(BgL_siza7ezd2framez75_11599)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3551z00_13770;
BgL_arg3551z00_13770 = 
(
(long)CINT(BgL_bpz00_13769)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13768),BgL_arg3551z00_13770,BgL_az00_11600); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3552z00_13771;
BgL_arg3552z00_13771 = 
(
(long)CINT(BgL_bpz00_13769)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13768),BgL_arg3552z00_13771,BgL_bz00_11601); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3553z00_13772;
BgL_arg3553z00_13772 = 
(
(long)CINT(BgL_bpz00_13769)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13768),BgL_arg3553z00_13772,BgL_cz00_11602); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3554z00_13773;
BgL_arg3554z00_13773 = 
(
(long)CINT(BgL_bpz00_13769)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13768),BgL_arg3554z00_13773,BgL_dz00_11603); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13774;
BgL_ez00_13774 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13774, BgL_bpz00_13769); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13775;
BgL_accz00_13775 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11598, BgL_sz00_13768, BgL_bpz00_13769); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13774); 
VECTOR_SET(
((obj_t)BgL_sz00_13768),((long)0),BgL_bpz00_13769); 
return BgL_accz00_13775;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13776;
BgL_nsz00_13776 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13776,((long)1),BgL_sz00_13768); 
VECTOR_SET(BgL_nsz00_13776,((long)2),BgL_az00_11600); 
VECTOR_SET(BgL_nsz00_13776,((long)3),BgL_bz00_11601); 
VECTOR_SET(BgL_nsz00_13776,((long)4),BgL_cz00_11602); 
VECTOR_SET(BgL_nsz00_13776,((long)5),BgL_dz00_11603); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13777;
BgL_z12denvz12_13777 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13777, BgL_nsz00_13776); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13778;
BgL_ez00_13778 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13778, BgL_sz00_13768); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13779;
BgL_____rz00_13779 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11598, BgL_nsz00_13776, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13778); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13777, BgL_sz00_13768); 
return BgL_____rz00_13779;} } } } } } } } 

}



/* &run5159 */
obj_t BGl_z62run5159z62zz__evaluate_compz00(obj_t BgL_envz00_11604, obj_t BgL_sz00_11609)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11605;obj_t BgL_valza2za2_11606;BgL_ev_absz00_bglt BgL_i1243z00_11607;obj_t BgL_bodyz00_11608;
BgL_siza7eza7_11605 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11604, 
(int)(((long)0)))); 
BgL_valza2za2_11606 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11604, 
(int)(((long)1)))); 
BgL_i1243z00_11607 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11604, 
(int)(((long)2)))); 
BgL_bodyz00_11608 = 
PROCEDURE_REF(BgL_envz00_11604, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13780;
BgL_bpz00_13780 = 
VECTOR_REF(
((obj_t)BgL_sz00_11609),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11609, BgL_valza2za2_11606, 
(
(long)CINT(BgL_bpz00_13780)+BgL_siza7eza7_11605)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13781;obj_t BgL_wherez00_13782;obj_t BgL_locz00_13783;
BgL_z12denvz12_13781 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13782 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11607))->BgL_wherez00); 
BgL_locz00_13783 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11607))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13781, BgL_wherez00_13782, BgL_locz00_13783); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13784;
BgL_za2za2resza2za2z00_13784 = 
PROCEDURE_ENTRY(BgL_bodyz00_11608)(BgL_bodyz00_11608, BgL_sz00_11609, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13781); 
return BgL_za2za2resza2za2z00_13784;} } } } } } 

}



/* &<@anonymous:3557> */
obj_t BGl_z62zc3z04anonymousza33557ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11610, obj_t BgL_sz00_11617)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11611;obj_t BgL_iboxesz00_11612;long BgL_siza7eza7_11613;BgL_ev_absz00_bglt BgL_i1243z00_11614;obj_t BgL_bodyz00_11615;long BgL_siza7ezd2framez75_11616;
BgL_ifreesz00_11611 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11610, 
(int)(((long)0)))); 
BgL_iboxesz00_11612 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11610, 
(int)(((long)1)))); 
BgL_siza7eza7_11613 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11610, 
(int)(((long)2)))); 
BgL_i1243z00_11614 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11610, 
(int)(((long)3)))); 
BgL_bodyz00_11615 = 
PROCEDURE_REF(BgL_envz00_11610, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11616 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11610, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13785;
BgL_bpz00_13785 = 
VECTOR_REF(
((obj_t)BgL_sz00_11617),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13786;
BgL_valza2za2_13786 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11617, BgL_bpz00_13785, BgL_ifreesz00_11611); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13787;
BgL_runz00_13787 = 
MAKE_FX_PROCEDURE(BGl_z62run5161z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13787, 
(int)(((long)0)), BgL_iboxesz00_11612); 
PROCEDURE_SET(BgL_runz00_13787, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11613)); 
PROCEDURE_SET(BgL_runz00_13787, 
(int)(((long)2)), BgL_valza2za2_13786); 
PROCEDURE_SET(BgL_runz00_13787, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11614)); 
PROCEDURE_SET(BgL_runz00_13787, 
(int)(((long)4)), BgL_bodyz00_11615); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13788;
BgL_mainz00_13788 = 
MAKE_FX_PROCEDURE(BGl_z62main5160z62zz__evaluate_compz00, 
(int)(((long)4)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13788, 
(int)(((long)0)), BgL_iboxesz00_11612); 
PROCEDURE_SET(BgL_mainz00_13788, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11613)); 
PROCEDURE_SET(BgL_mainz00_13788, 
(int)(((long)2)), BgL_valza2za2_13786); 
PROCEDURE_SET(BgL_mainz00_13788, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11614)); 
PROCEDURE_SET(BgL_mainz00_13788, 
(int)(((long)4)), BgL_bodyz00_11615); 
PROCEDURE_SET(BgL_mainz00_13788, 
(int)(((long)5)), BgL_runz00_13787); 
PROCEDURE_SET(BgL_mainz00_13788, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11616)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13789;
BgL_objz00_13789 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13787, BgL_objz00_13789); BgL_objz00_13789; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3558z00_13790;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3559z00_13791;
BgL_arg3559z00_13791 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11614))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13792;
BgL_newz00_13792 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23408;
BgL_tmpz00_23408 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13792, BgL_tmpz00_23408, BgL_arg3559z00_13791); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23413;int BgL_tmpz00_23411;
BgL_auxz00_23413 = 
BINT(BgL_siza7ezd2framez75_11616); 
BgL_tmpz00_23411 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13792, BgL_tmpz00_23411, BgL_auxz00_23413); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23416;
BgL_tmpz00_23416 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13792, BgL_tmpz00_23416, BgL_runz00_13787); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23421;int BgL_tmpz00_23419;
BgL_auxz00_23421 = 
BINT(((long)4)); 
BgL_tmpz00_23419 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13792, BgL_tmpz00_23419, BgL_auxz00_23421); } 
BgL_arg3558z00_13790 = BgL_newz00_13792; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13788, BgL_arg3558z00_13790); BgL_arg3558z00_13790; } 
return BgL_mainz00_13788;} } } } } } 

}



/* &main5160 */
obj_t BGl_z62main5160z62zz__evaluate_compz00(obj_t BgL_envz00_11618, obj_t BgL_az00_11626, obj_t BgL_bz00_11627, obj_t BgL_cz00_11628, obj_t BgL_dz00_11629)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11624;long BgL_siza7ezd2framez75_11625;
BgL_runz00_11624 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11618, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11625 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11618, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13793;
BgL_sz00_13793 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13794;
BgL_bpz00_13794 = 
VECTOR_REF(
((obj_t)BgL_sz00_13793),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13793, BgL_bpz00_13794, 
BINT(BgL_siza7ezd2framez75_11625)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3562z00_13795;
BgL_arg3562z00_13795 = 
(
(long)CINT(BgL_bpz00_13794)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13793),BgL_arg3562z00_13795,BgL_az00_11626); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3563z00_13796;
BgL_arg3563z00_13796 = 
(
(long)CINT(BgL_bpz00_13794)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13793),BgL_arg3563z00_13796,BgL_bz00_11627); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3564z00_13797;
BgL_arg3564z00_13797 = 
(
(long)CINT(BgL_bpz00_13794)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13793),BgL_arg3564z00_13797,BgL_cz00_11628); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3565z00_13798;
BgL_arg3565z00_13798 = 
(
(long)CINT(BgL_bpz00_13794)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13793),BgL_arg3565z00_13798,BgL_dz00_11629); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13799;
BgL_ez00_13799 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13799, BgL_bpz00_13794); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13800;
BgL_accz00_13800 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11624, BgL_sz00_13793, BgL_bpz00_13794); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13799); 
VECTOR_SET(
((obj_t)BgL_sz00_13793),((long)0),BgL_bpz00_13794); 
return BgL_accz00_13800;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13801;
BgL_nsz00_13801 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13801,((long)1),BgL_sz00_13793); 
VECTOR_SET(BgL_nsz00_13801,((long)2),BgL_az00_11626); 
VECTOR_SET(BgL_nsz00_13801,((long)3),BgL_bz00_11627); 
VECTOR_SET(BgL_nsz00_13801,((long)4),BgL_cz00_11628); 
VECTOR_SET(BgL_nsz00_13801,((long)5),BgL_dz00_11629); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13802;
BgL_z12denvz12_13802 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13802, BgL_nsz00_13801); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13803;
BgL_ez00_13803 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13803, BgL_sz00_13793); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13804;
BgL_____rz00_13804 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11624, BgL_nsz00_13801, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13803); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13802, BgL_sz00_13793); 
return BgL_____rz00_13804;} } } } } } } } 

}



/* &run5161 */
obj_t BGl_z62run5161z62zz__evaluate_compz00(obj_t BgL_envz00_11630, obj_t BgL_sz00_11636)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11631;long BgL_siza7eza7_11632;obj_t BgL_valza2za2_11633;BgL_ev_absz00_bglt BgL_i1243z00_11634;obj_t BgL_bodyz00_11635;
BgL_iboxesz00_11631 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11630, 
(int)(((long)0)))); 
BgL_siza7eza7_11632 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11630, 
(int)(((long)1)))); 
BgL_valza2za2_11633 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11630, 
(int)(((long)2)))); 
BgL_i1243z00_11634 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11630, 
(int)(((long)3)))); 
BgL_bodyz00_11635 = 
PROCEDURE_REF(BgL_envz00_11630, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13805;
BgL_bpz00_13805 = 
VECTOR_REF(
((obj_t)BgL_sz00_11636),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11636, BgL_iboxesz00_11631, BgL_bpz00_13805); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11636, BgL_valza2za2_11633, 
(
(long)CINT(BgL_bpz00_13805)+BgL_siza7eza7_11632)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13806;obj_t BgL_wherez00_13807;obj_t BgL_locz00_13808;
BgL_z12denvz12_13806 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13807 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11634))->BgL_wherez00); 
BgL_locz00_13808 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11634))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13806, BgL_wherez00_13807, BgL_locz00_13808); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13809;
BgL_za2za2resza2za2z00_13809 = 
PROCEDURE_ENTRY(BgL_bodyz00_11635)(BgL_bodyz00_11635, BgL_sz00_11636, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13806); 
return BgL_za2za2resza2za2z00_13809;} } } } } } 

}



/* &<@anonymous:3472> */
obj_t BGl_z62zc3z04anonymousza33472ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11637, obj_t BgL_sz00_11641)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11638;obj_t BgL_bodyz00_11639;long BgL_siza7ezd2framez75_11640;
BgL_i1243z00_11638 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11637, 
(int)(((long)0)))); 
BgL_bodyz00_11639 = 
PROCEDURE_REF(BgL_envz00_11637, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11640 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11637, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13810;
BgL_bpz00_13810 = 
VECTOR_REF(
((obj_t)BgL_sz00_11641),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13811;
BgL_runz00_13811 = 
MAKE_FX_PROCEDURE(BGl_z62run5163z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13811, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11638)); 
PROCEDURE_SET(BgL_runz00_13811, 
(int)(((long)1)), BgL_bodyz00_11639); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13812;
BgL_mainz00_13812 = 
MAKE_VA_PROCEDURE(BGl_z62main5162z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13812, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11638)); 
PROCEDURE_SET(BgL_mainz00_13812, 
(int)(((long)1)), BgL_bodyz00_11639); 
PROCEDURE_SET(BgL_mainz00_13812, 
(int)(((long)2)), BgL_runz00_13811); 
PROCEDURE_SET(BgL_mainz00_13812, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11640)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13813;
BgL_objz00_13813 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13811, BgL_objz00_13813); BgL_objz00_13813; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3473z00_13814;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3474z00_13815;
BgL_arg3474z00_13815 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11638))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13816;
BgL_newz00_13816 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23537;
BgL_tmpz00_23537 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13816, BgL_tmpz00_23537, BgL_arg3474z00_13815); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23542;int BgL_tmpz00_23540;
BgL_auxz00_23542 = 
BINT(BgL_siza7ezd2framez75_11640); 
BgL_tmpz00_23540 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13816, BgL_tmpz00_23540, BgL_auxz00_23542); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23545;
BgL_tmpz00_23545 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13816, BgL_tmpz00_23545, BgL_runz00_13811); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23550;int BgL_tmpz00_23548;
BgL_auxz00_23550 = 
BINT(((long)-4)); 
BgL_tmpz00_23548 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13816, BgL_tmpz00_23548, BgL_auxz00_23550); } 
BgL_arg3473z00_13814 = BgL_newz00_13816; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13812, BgL_arg3473z00_13814); BgL_arg3473z00_13814; } 
return BgL_mainz00_13812;} } } } } } 

}



/* &main5162 */
obj_t BGl_z62main5162z62zz__evaluate_compz00(obj_t BgL_envz00_11642, obj_t BgL_bz00_11647, obj_t BgL_cz00_11648, obj_t BgL_dz00_11649, obj_t BgL_lastz00_11650)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11645;long BgL_siza7ezd2framez75_11646;
BgL_runz00_11645 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11642, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11646 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11642, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13817;
BgL_sz00_13817 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13818;
BgL_bpz00_13818 = 
VECTOR_REF(
((obj_t)BgL_sz00_13817),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13817, BgL_bpz00_13818, 
BINT(BgL_siza7ezd2framez75_11646)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3477z00_13819;
BgL_arg3477z00_13819 = 
(
(long)CINT(BgL_bpz00_13818)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13817),BgL_arg3477z00_13819,BgL_bz00_11647); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3478z00_13820;
BgL_arg3478z00_13820 = 
(
(long)CINT(BgL_bpz00_13818)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13817),BgL_arg3478z00_13820,BgL_cz00_11648); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3479z00_13821;
BgL_arg3479z00_13821 = 
(
(long)CINT(BgL_bpz00_13818)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13817),BgL_arg3479z00_13821,BgL_dz00_11649); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3480z00_13822;
BgL_arg3480z00_13822 = 
(
(long)CINT(BgL_bpz00_13818)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13817),BgL_arg3480z00_13822,BgL_lastz00_11650); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13823;
BgL_ez00_13823 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13823, BgL_bpz00_13818); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13824;
BgL_accz00_13824 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11645, BgL_sz00_13817, BgL_bpz00_13818); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13823); 
VECTOR_SET(
((obj_t)BgL_sz00_13817),((long)0),BgL_bpz00_13818); 
return BgL_accz00_13824;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13825;
BgL_nsz00_13825 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13825,((long)1),BgL_sz00_13817); 
VECTOR_SET(BgL_nsz00_13825,((long)2),BgL_bz00_11647); 
VECTOR_SET(BgL_nsz00_13825,((long)3),BgL_cz00_11648); 
VECTOR_SET(BgL_nsz00_13825,((long)4),BgL_dz00_11649); 
VECTOR_SET(BgL_nsz00_13825,((long)5),BgL_lastz00_11650); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13826;
BgL_z12denvz12_13826 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13826, BgL_nsz00_13825); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13827;
BgL_ez00_13827 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13827, BgL_sz00_13817); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13828;
BgL_____rz00_13828 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11645, BgL_nsz00_13825, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13827); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13826, BgL_sz00_13817); 
return BgL_____rz00_13828;} } } } } } } } 

}



/* &run5163 */
obj_t BGl_z62run5163z62zz__evaluate_compz00(obj_t BgL_envz00_11651, obj_t BgL_sz00_11654)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11652;obj_t BgL_bodyz00_11653;
BgL_i1243z00_11652 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11651, 
(int)(((long)0)))); 
BgL_bodyz00_11653 = 
PROCEDURE_REF(BgL_envz00_11651, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13829;
BgL_bpz00_13829 = 
VECTOR_REF(
((obj_t)BgL_sz00_11654),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13830;obj_t BgL_wherez00_13831;obj_t BgL_locz00_13832;
BgL_z12denvz12_13830 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13831 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11652))->BgL_wherez00); 
BgL_locz00_13832 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11652))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13830, BgL_wherez00_13831, BgL_locz00_13832); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13833;
BgL_za2za2resza2za2z00_13833 = 
PROCEDURE_ENTRY(BgL_bodyz00_11653)(BgL_bodyz00_11653, BgL_sz00_11654, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13830); 
return BgL_za2za2resza2za2z00_13833;} } } } } } 

}



/* &<@anonymous:3482> */
obj_t BGl_z62zc3z04anonymousza33482ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11655, obj_t BgL_sz00_11660)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11656;BgL_ev_absz00_bglt BgL_i1243z00_11657;obj_t BgL_bodyz00_11658;long BgL_siza7ezd2framez75_11659;
BgL_iboxesz00_11656 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11655, 
(int)(((long)0)))); 
BgL_i1243z00_11657 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11655, 
(int)(((long)1)))); 
BgL_bodyz00_11658 = 
PROCEDURE_REF(BgL_envz00_11655, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11659 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11655, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13834;
BgL_bpz00_13834 = 
VECTOR_REF(
((obj_t)BgL_sz00_11660),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13835;
BgL_runz00_13835 = 
MAKE_FX_PROCEDURE(BGl_z62run5165z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13835, 
(int)(((long)0)), BgL_iboxesz00_11656); 
PROCEDURE_SET(BgL_runz00_13835, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11657)); 
PROCEDURE_SET(BgL_runz00_13835, 
(int)(((long)2)), BgL_bodyz00_11658); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13836;
BgL_mainz00_13836 = 
MAKE_VA_PROCEDURE(BGl_z62main5164z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13836, 
(int)(((long)0)), BgL_iboxesz00_11656); 
PROCEDURE_SET(BgL_mainz00_13836, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11657)); 
PROCEDURE_SET(BgL_mainz00_13836, 
(int)(((long)2)), BgL_bodyz00_11658); 
PROCEDURE_SET(BgL_mainz00_13836, 
(int)(((long)3)), BgL_runz00_13835); 
PROCEDURE_SET(BgL_mainz00_13836, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11659)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13837;
BgL_objz00_13837 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13835, BgL_objz00_13837); BgL_objz00_13837; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3483z00_13838;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3484z00_13839;
BgL_arg3484z00_13839 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11657))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13840;
BgL_newz00_13840 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23660;
BgL_tmpz00_23660 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13840, BgL_tmpz00_23660, BgL_arg3484z00_13839); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23665;int BgL_tmpz00_23663;
BgL_auxz00_23665 = 
BINT(BgL_siza7ezd2framez75_11659); 
BgL_tmpz00_23663 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13840, BgL_tmpz00_23663, BgL_auxz00_23665); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23668;
BgL_tmpz00_23668 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13840, BgL_tmpz00_23668, BgL_runz00_13835); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23673;int BgL_tmpz00_23671;
BgL_auxz00_23673 = 
BINT(((long)-4)); 
BgL_tmpz00_23671 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13840, BgL_tmpz00_23671, BgL_auxz00_23673); } 
BgL_arg3483z00_13838 = BgL_newz00_13840; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13836, BgL_arg3483z00_13838); BgL_arg3483z00_13838; } 
return BgL_mainz00_13836;} } } } } } 

}



/* &main5164 */
obj_t BGl_z62main5164z62zz__evaluate_compz00(obj_t BgL_envz00_11661, obj_t BgL_bz00_11667, obj_t BgL_cz00_11668, obj_t BgL_dz00_11669, obj_t BgL_lastz00_11670)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11665;long BgL_siza7ezd2framez75_11666;
BgL_runz00_11665 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11661, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11666 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11661, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13841;
BgL_sz00_13841 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13842;
BgL_bpz00_13842 = 
VECTOR_REF(
((obj_t)BgL_sz00_13841),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13841, BgL_bpz00_13842, 
BINT(BgL_siza7ezd2framez75_11666)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3487z00_13843;
BgL_arg3487z00_13843 = 
(
(long)CINT(BgL_bpz00_13842)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13841),BgL_arg3487z00_13843,BgL_bz00_11667); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3488z00_13844;
BgL_arg3488z00_13844 = 
(
(long)CINT(BgL_bpz00_13842)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13841),BgL_arg3488z00_13844,BgL_cz00_11668); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3489z00_13845;
BgL_arg3489z00_13845 = 
(
(long)CINT(BgL_bpz00_13842)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13841),BgL_arg3489z00_13845,BgL_dz00_11669); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3490z00_13846;
BgL_arg3490z00_13846 = 
(
(long)CINT(BgL_bpz00_13842)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13841),BgL_arg3490z00_13846,BgL_lastz00_11670); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13847;
BgL_ez00_13847 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13847, BgL_bpz00_13842); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13848;
BgL_accz00_13848 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11665, BgL_sz00_13841, BgL_bpz00_13842); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13847); 
VECTOR_SET(
((obj_t)BgL_sz00_13841),((long)0),BgL_bpz00_13842); 
return BgL_accz00_13848;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13849;
BgL_nsz00_13849 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13849,((long)1),BgL_sz00_13841); 
VECTOR_SET(BgL_nsz00_13849,((long)2),BgL_bz00_11667); 
VECTOR_SET(BgL_nsz00_13849,((long)3),BgL_cz00_11668); 
VECTOR_SET(BgL_nsz00_13849,((long)4),BgL_dz00_11669); 
VECTOR_SET(BgL_nsz00_13849,((long)5),BgL_lastz00_11670); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13850;
BgL_z12denvz12_13850 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13850, BgL_nsz00_13849); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13851;
BgL_ez00_13851 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13851, BgL_sz00_13841); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13852;
BgL_____rz00_13852 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11665, BgL_nsz00_13849, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13851); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13850, BgL_sz00_13841); 
return BgL_____rz00_13852;} } } } } } } } 

}



/* &run5165 */
obj_t BGl_z62run5165z62zz__evaluate_compz00(obj_t BgL_envz00_11671, obj_t BgL_sz00_11675)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11672;BgL_ev_absz00_bglt BgL_i1243z00_11673;obj_t BgL_bodyz00_11674;
BgL_iboxesz00_11672 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11671, 
(int)(((long)0)))); 
BgL_i1243z00_11673 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11671, 
(int)(((long)1)))); 
BgL_bodyz00_11674 = 
PROCEDURE_REF(BgL_envz00_11671, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13853;
BgL_bpz00_13853 = 
VECTOR_REF(
((obj_t)BgL_sz00_11675),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11675, BgL_iboxesz00_11672, BgL_bpz00_13853); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13854;obj_t BgL_wherez00_13855;obj_t BgL_locz00_13856;
BgL_z12denvz12_13854 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13855 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11673))->BgL_wherez00); 
BgL_locz00_13856 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11673))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13854, BgL_wherez00_13855, BgL_locz00_13856); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13857;
BgL_za2za2resza2za2z00_13857 = 
PROCEDURE_ENTRY(BgL_bodyz00_11674)(BgL_bodyz00_11674, BgL_sz00_11675, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13854); 
return BgL_za2za2resza2za2z00_13857;} } } } } } 

}



/* &<@anonymous:3495> */
obj_t BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11676, obj_t BgL_sz00_11682)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11677;long BgL_siza7eza7_11678;BgL_ev_absz00_bglt BgL_i1243z00_11679;obj_t BgL_bodyz00_11680;long BgL_siza7ezd2framez75_11681;
BgL_ifreesz00_11677 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11676, 
(int)(((long)0)))); 
BgL_siza7eza7_11678 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11676, 
(int)(((long)1)))); 
BgL_i1243z00_11679 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11676, 
(int)(((long)2)))); 
BgL_bodyz00_11680 = 
PROCEDURE_REF(BgL_envz00_11676, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11681 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11676, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13858;
BgL_bpz00_13858 = 
VECTOR_REF(
((obj_t)BgL_sz00_11682),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13859;
BgL_valza2za2_13859 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11682, BgL_bpz00_13858, BgL_ifreesz00_11677); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13860;
BgL_runz00_13860 = 
MAKE_FX_PROCEDURE(BGl_z62run5167z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13860, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11678)); 
PROCEDURE_SET(BgL_runz00_13860, 
(int)(((long)1)), BgL_valza2za2_13859); 
PROCEDURE_SET(BgL_runz00_13860, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11679)); 
PROCEDURE_SET(BgL_runz00_13860, 
(int)(((long)3)), BgL_bodyz00_11680); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13861;
BgL_mainz00_13861 = 
MAKE_VA_PROCEDURE(BGl_z62main5166z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13861, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11678)); 
PROCEDURE_SET(BgL_mainz00_13861, 
(int)(((long)1)), BgL_valza2za2_13859); 
PROCEDURE_SET(BgL_mainz00_13861, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11679)); 
PROCEDURE_SET(BgL_mainz00_13861, 
(int)(((long)3)), BgL_bodyz00_11680); 
PROCEDURE_SET(BgL_mainz00_13861, 
(int)(((long)4)), BgL_runz00_13860); 
PROCEDURE_SET(BgL_mainz00_13861, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11681)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13862;
BgL_objz00_13862 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13860, BgL_objz00_13862); BgL_objz00_13862; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3496z00_13863;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3497z00_13864;
BgL_arg3497z00_13864 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11679))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13865;
BgL_newz00_13865 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23797;
BgL_tmpz00_23797 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13865, BgL_tmpz00_23797, BgL_arg3497z00_13864); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23802;int BgL_tmpz00_23800;
BgL_auxz00_23802 = 
BINT(BgL_siza7ezd2framez75_11681); 
BgL_tmpz00_23800 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13865, BgL_tmpz00_23800, BgL_auxz00_23802); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23805;
BgL_tmpz00_23805 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13865, BgL_tmpz00_23805, BgL_runz00_13860); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23810;int BgL_tmpz00_23808;
BgL_auxz00_23810 = 
BINT(((long)-4)); 
BgL_tmpz00_23808 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13865, BgL_tmpz00_23808, BgL_auxz00_23810); } 
BgL_arg3496z00_13863 = BgL_newz00_13865; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13861, BgL_arg3496z00_13863); BgL_arg3496z00_13863; } 
return BgL_mainz00_13861;} } } } } } 

}



/* &main5166 */
obj_t BGl_z62main5166z62zz__evaluate_compz00(obj_t BgL_envz00_11683, obj_t BgL_bz00_11690, obj_t BgL_cz00_11691, obj_t BgL_dz00_11692, obj_t BgL_lastz00_11693)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11688;long BgL_siza7ezd2framez75_11689;
BgL_runz00_11688 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11683, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11689 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11683, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13866;
BgL_sz00_13866 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13867;
BgL_bpz00_13867 = 
VECTOR_REF(
((obj_t)BgL_sz00_13866),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13866, BgL_bpz00_13867, 
BINT(BgL_siza7ezd2framez75_11689)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3500z00_13868;
BgL_arg3500z00_13868 = 
(
(long)CINT(BgL_bpz00_13867)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13866),BgL_arg3500z00_13868,BgL_bz00_11690); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3501z00_13869;
BgL_arg3501z00_13869 = 
(
(long)CINT(BgL_bpz00_13867)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13866),BgL_arg3501z00_13869,BgL_cz00_11691); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3502z00_13870;
BgL_arg3502z00_13870 = 
(
(long)CINT(BgL_bpz00_13867)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13866),BgL_arg3502z00_13870,BgL_dz00_11692); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3503z00_13871;
BgL_arg3503z00_13871 = 
(
(long)CINT(BgL_bpz00_13867)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13866),BgL_arg3503z00_13871,BgL_lastz00_11693); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13872;
BgL_ez00_13872 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13872, BgL_bpz00_13867); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13873;
BgL_accz00_13873 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11688, BgL_sz00_13866, BgL_bpz00_13867); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13872); 
VECTOR_SET(
((obj_t)BgL_sz00_13866),((long)0),BgL_bpz00_13867); 
return BgL_accz00_13873;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13874;
BgL_nsz00_13874 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13874,((long)1),BgL_sz00_13866); 
VECTOR_SET(BgL_nsz00_13874,((long)2),BgL_bz00_11690); 
VECTOR_SET(BgL_nsz00_13874,((long)3),BgL_cz00_11691); 
VECTOR_SET(BgL_nsz00_13874,((long)4),BgL_dz00_11692); 
VECTOR_SET(BgL_nsz00_13874,((long)5),BgL_lastz00_11693); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13875;
BgL_z12denvz12_13875 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13875, BgL_nsz00_13874); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13876;
BgL_ez00_13876 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13876, BgL_sz00_13866); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13877;
BgL_____rz00_13877 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11688, BgL_nsz00_13874, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13876); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13875, BgL_sz00_13866); 
return BgL_____rz00_13877;} } } } } } } } 

}



/* &run5167 */
obj_t BGl_z62run5167z62zz__evaluate_compz00(obj_t BgL_envz00_11694, obj_t BgL_sz00_11699)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11695;obj_t BgL_valza2za2_11696;BgL_ev_absz00_bglt BgL_i1243z00_11697;obj_t BgL_bodyz00_11698;
BgL_siza7eza7_11695 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11694, 
(int)(((long)0)))); 
BgL_valza2za2_11696 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11694, 
(int)(((long)1)))); 
BgL_i1243z00_11697 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11694, 
(int)(((long)2)))); 
BgL_bodyz00_11698 = 
PROCEDURE_REF(BgL_envz00_11694, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13878;
BgL_bpz00_13878 = 
VECTOR_REF(
((obj_t)BgL_sz00_11699),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11699, BgL_valza2za2_11696, 
(
(long)CINT(BgL_bpz00_13878)+BgL_siza7eza7_11695)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13879;obj_t BgL_wherez00_13880;obj_t BgL_locz00_13881;
BgL_z12denvz12_13879 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13880 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11697))->BgL_wherez00); 
BgL_locz00_13881 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11697))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13879, BgL_wherez00_13880, BgL_locz00_13881); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13882;
BgL_za2za2resza2za2z00_13882 = 
PROCEDURE_ENTRY(BgL_bodyz00_11698)(BgL_bodyz00_11698, BgL_sz00_11699, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13879); 
return BgL_za2za2resza2za2z00_13882;} } } } } } 

}



/* &<@anonymous:3506> */
obj_t BGl_z62zc3z04anonymousza33506ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11700, obj_t BgL_sz00_11707)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11701;obj_t BgL_iboxesz00_11702;long BgL_siza7eza7_11703;BgL_ev_absz00_bglt BgL_i1243z00_11704;obj_t BgL_bodyz00_11705;long BgL_siza7ezd2framez75_11706;
BgL_ifreesz00_11701 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11700, 
(int)(((long)0)))); 
BgL_iboxesz00_11702 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11700, 
(int)(((long)1)))); 
BgL_siza7eza7_11703 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11700, 
(int)(((long)2)))); 
BgL_i1243z00_11704 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11700, 
(int)(((long)3)))); 
BgL_bodyz00_11705 = 
PROCEDURE_REF(BgL_envz00_11700, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11706 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11700, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13883;
BgL_bpz00_13883 = 
VECTOR_REF(
((obj_t)BgL_sz00_11707),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13884;
BgL_valza2za2_13884 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11707, BgL_bpz00_13883, BgL_ifreesz00_11701); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13885;
BgL_runz00_13885 = 
MAKE_FX_PROCEDURE(BGl_z62run5169z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13885, 
(int)(((long)0)), BgL_iboxesz00_11702); 
PROCEDURE_SET(BgL_runz00_13885, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11703)); 
PROCEDURE_SET(BgL_runz00_13885, 
(int)(((long)2)), BgL_valza2za2_13884); 
PROCEDURE_SET(BgL_runz00_13885, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11704)); 
PROCEDURE_SET(BgL_runz00_13885, 
(int)(((long)4)), BgL_bodyz00_11705); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13886;
BgL_mainz00_13886 = 
MAKE_VA_PROCEDURE(BGl_z62main5168z62zz__evaluate_compz00, 
(int)(((long)-4)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13886, 
(int)(((long)0)), BgL_iboxesz00_11702); 
PROCEDURE_SET(BgL_mainz00_13886, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11703)); 
PROCEDURE_SET(BgL_mainz00_13886, 
(int)(((long)2)), BgL_valza2za2_13884); 
PROCEDURE_SET(BgL_mainz00_13886, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11704)); 
PROCEDURE_SET(BgL_mainz00_13886, 
(int)(((long)4)), BgL_bodyz00_11705); 
PROCEDURE_SET(BgL_mainz00_13886, 
(int)(((long)5)), BgL_runz00_13885); 
PROCEDURE_SET(BgL_mainz00_13886, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11706)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13887;
BgL_objz00_13887 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13885, BgL_objz00_13887); BgL_objz00_13887; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3507z00_13888;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3508z00_13889;
BgL_arg3508z00_13889 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11704))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13890;
BgL_newz00_13890 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23946;
BgL_tmpz00_23946 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13890, BgL_tmpz00_23946, BgL_arg3508z00_13889); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23951;int BgL_tmpz00_23949;
BgL_auxz00_23951 = 
BINT(BgL_siza7ezd2framez75_11706); 
BgL_tmpz00_23949 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13890, BgL_tmpz00_23949, BgL_auxz00_23951); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_23954;
BgL_tmpz00_23954 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13890, BgL_tmpz00_23954, BgL_runz00_13885); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_23959;int BgL_tmpz00_23957;
BgL_auxz00_23959 = 
BINT(((long)-4)); 
BgL_tmpz00_23957 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13890, BgL_tmpz00_23957, BgL_auxz00_23959); } 
BgL_arg3507z00_13888 = BgL_newz00_13890; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13886, BgL_arg3507z00_13888); BgL_arg3507z00_13888; } 
return BgL_mainz00_13886;} } } } } } 

}



/* &main5168 */
obj_t BGl_z62main5168z62zz__evaluate_compz00(obj_t BgL_envz00_11708, obj_t BgL_bz00_11716, obj_t BgL_cz00_11717, obj_t BgL_dz00_11718, obj_t BgL_lastz00_11719)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11714;long BgL_siza7ezd2framez75_11715;
BgL_runz00_11714 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11708, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11715 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11708, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13891;
BgL_sz00_13891 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13892;
BgL_bpz00_13892 = 
VECTOR_REF(
((obj_t)BgL_sz00_13891),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13891, BgL_bpz00_13892, 
BINT(BgL_siza7ezd2framez75_11715)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3511z00_13893;
BgL_arg3511z00_13893 = 
(
(long)CINT(BgL_bpz00_13892)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13891),BgL_arg3511z00_13893,BgL_bz00_11716); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3512z00_13894;
BgL_arg3512z00_13894 = 
(
(long)CINT(BgL_bpz00_13892)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13891),BgL_arg3512z00_13894,BgL_cz00_11717); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3513z00_13895;
BgL_arg3513z00_13895 = 
(
(long)CINT(BgL_bpz00_13892)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13891),BgL_arg3513z00_13895,BgL_dz00_11718); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3514z00_13896;
BgL_arg3514z00_13896 = 
(
(long)CINT(BgL_bpz00_13892)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_13891),BgL_arg3514z00_13896,BgL_lastz00_11719); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13897;
BgL_ez00_13897 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13897, BgL_bpz00_13892); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13898;
BgL_accz00_13898 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11714, BgL_sz00_13891, BgL_bpz00_13892); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13897); 
VECTOR_SET(
((obj_t)BgL_sz00_13891),((long)0),BgL_bpz00_13892); 
return BgL_accz00_13898;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13899;
BgL_nsz00_13899 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13899,((long)1),BgL_sz00_13891); 
VECTOR_SET(BgL_nsz00_13899,((long)2),BgL_bz00_11716); 
VECTOR_SET(BgL_nsz00_13899,((long)3),BgL_cz00_11717); 
VECTOR_SET(BgL_nsz00_13899,((long)4),BgL_dz00_11718); 
VECTOR_SET(BgL_nsz00_13899,((long)5),BgL_lastz00_11719); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13900;
BgL_z12denvz12_13900 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13900, BgL_nsz00_13899); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13901;
BgL_ez00_13901 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13901, BgL_sz00_13891); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13902;
BgL_____rz00_13902 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11714, BgL_nsz00_13899, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13901); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13900, BgL_sz00_13891); 
return BgL_____rz00_13902;} } } } } } } } 

}



/* &run5169 */
obj_t BGl_z62run5169z62zz__evaluate_compz00(obj_t BgL_envz00_11720, obj_t BgL_sz00_11726)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11721;long BgL_siza7eza7_11722;obj_t BgL_valza2za2_11723;BgL_ev_absz00_bglt BgL_i1243z00_11724;obj_t BgL_bodyz00_11725;
BgL_iboxesz00_11721 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11720, 
(int)(((long)0)))); 
BgL_siza7eza7_11722 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11720, 
(int)(((long)1)))); 
BgL_valza2za2_11723 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11720, 
(int)(((long)2)))); 
BgL_i1243z00_11724 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11720, 
(int)(((long)3)))); 
BgL_bodyz00_11725 = 
PROCEDURE_REF(BgL_envz00_11720, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13903;
BgL_bpz00_13903 = 
VECTOR_REF(
((obj_t)BgL_sz00_11726),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11726, BgL_iboxesz00_11721, BgL_bpz00_13903); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11726, BgL_valza2za2_11723, 
(
(long)CINT(BgL_bpz00_13903)+BgL_siza7eza7_11722)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13904;obj_t BgL_wherez00_13905;obj_t BgL_locz00_13906;
BgL_z12denvz12_13904 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13905 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11724))->BgL_wherez00); 
BgL_locz00_13906 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11724))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13904, BgL_wherez00_13905, BgL_locz00_13906); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13907;
BgL_za2za2resza2za2z00_13907 = 
PROCEDURE_ENTRY(BgL_bodyz00_11725)(BgL_bodyz00_11725, BgL_sz00_11726, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13904); 
return BgL_za2za2resza2za2z00_13907;} } } } } } 

}



/* &<@anonymous:3425> */
obj_t BGl_z62zc3z04anonymousza33425ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11727, obj_t BgL_sz00_11731)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11728;obj_t BgL_bodyz00_11729;long BgL_siza7ezd2framez75_11730;
BgL_i1243z00_11728 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11727, 
(int)(((long)0)))); 
BgL_bodyz00_11729 = 
PROCEDURE_REF(BgL_envz00_11727, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11730 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11727, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13908;
BgL_bpz00_13908 = 
VECTOR_REF(
((obj_t)BgL_sz00_11731),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13909;
BgL_runz00_13909 = 
MAKE_FX_PROCEDURE(BGl_z62run5171z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_13909, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11728)); 
PROCEDURE_SET(BgL_runz00_13909, 
(int)(((long)1)), BgL_bodyz00_11729); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13910;
BgL_mainz00_13910 = 
MAKE_FX_PROCEDURE(BGl_z62main5170z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_13910, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11728)); 
PROCEDURE_SET(BgL_mainz00_13910, 
(int)(((long)1)), BgL_bodyz00_11729); 
PROCEDURE_SET(BgL_mainz00_13910, 
(int)(((long)2)), BgL_runz00_13909); 
PROCEDURE_SET(BgL_mainz00_13910, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11730)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13911;
BgL_objz00_13911 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13909, BgL_objz00_13911); BgL_objz00_13911; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3426z00_13912;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3427z00_13913;
BgL_arg3427z00_13913 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11728))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13914;
BgL_newz00_13914 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24075;
BgL_tmpz00_24075 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13914, BgL_tmpz00_24075, BgL_arg3427z00_13913); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24080;int BgL_tmpz00_24078;
BgL_auxz00_24080 = 
BINT(BgL_siza7ezd2framez75_11730); 
BgL_tmpz00_24078 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13914, BgL_tmpz00_24078, BgL_auxz00_24080); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24083;
BgL_tmpz00_24083 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13914, BgL_tmpz00_24083, BgL_runz00_13909); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24088;int BgL_tmpz00_24086;
BgL_auxz00_24088 = 
BINT(((long)3)); 
BgL_tmpz00_24086 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13914, BgL_tmpz00_24086, BgL_auxz00_24088); } 
BgL_arg3426z00_13912 = BgL_newz00_13914; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13910, BgL_arg3426z00_13912); BgL_arg3426z00_13912; } 
return BgL_mainz00_13910;} } } } } } 

}



/* &main5170 */
obj_t BGl_z62main5170z62zz__evaluate_compz00(obj_t BgL_envz00_11732, obj_t BgL_bz00_11737, obj_t BgL_cz00_11738, obj_t BgL_dz00_11739)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11735;long BgL_siza7ezd2framez75_11736;
BgL_runz00_11735 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11732, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11736 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11732, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13915;
BgL_sz00_13915 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13916;
BgL_bpz00_13916 = 
VECTOR_REF(
((obj_t)BgL_sz00_13915),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13915, BgL_bpz00_13916, 
BINT(BgL_siza7ezd2framez75_11736)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3430z00_13917;
BgL_arg3430z00_13917 = 
(
(long)CINT(BgL_bpz00_13916)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13915),BgL_arg3430z00_13917,BgL_bz00_11737); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3431z00_13918;
BgL_arg3431z00_13918 = 
(
(long)CINT(BgL_bpz00_13916)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13915),BgL_arg3431z00_13918,BgL_cz00_11738); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3432z00_13919;
BgL_arg3432z00_13919 = 
(
(long)CINT(BgL_bpz00_13916)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13915),BgL_arg3432z00_13919,BgL_dz00_11739); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13920;
BgL_ez00_13920 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13920, BgL_bpz00_13916); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13921;
BgL_accz00_13921 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11735, BgL_sz00_13915, BgL_bpz00_13916); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13920); 
VECTOR_SET(
((obj_t)BgL_sz00_13915),((long)0),BgL_bpz00_13916); 
return BgL_accz00_13921;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13922;
BgL_nsz00_13922 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13922,((long)1),BgL_sz00_13915); 
VECTOR_SET(BgL_nsz00_13922,((long)2),BgL_bz00_11737); 
VECTOR_SET(BgL_nsz00_13922,((long)3),BgL_cz00_11738); 
VECTOR_SET(BgL_nsz00_13922,((long)4),BgL_dz00_11739); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13923;
BgL_z12denvz12_13923 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13923, BgL_nsz00_13922); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13924;
BgL_ez00_13924 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13924, BgL_sz00_13915); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13925;
BgL_____rz00_13925 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11735, BgL_nsz00_13922, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13924); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13923, BgL_sz00_13915); 
return BgL_____rz00_13925;} } } } } } } } 

}



/* &run5171 */
obj_t BGl_z62run5171z62zz__evaluate_compz00(obj_t BgL_envz00_11740, obj_t BgL_sz00_11743)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11741;obj_t BgL_bodyz00_11742;
BgL_i1243z00_11741 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11740, 
(int)(((long)0)))); 
BgL_bodyz00_11742 = 
PROCEDURE_REF(BgL_envz00_11740, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13926;
BgL_bpz00_13926 = 
VECTOR_REF(
((obj_t)BgL_sz00_11743),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13927;obj_t BgL_wherez00_13928;obj_t BgL_locz00_13929;
BgL_z12denvz12_13927 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13928 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11741))->BgL_wherez00); 
BgL_locz00_13929 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11741))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13927, BgL_wherez00_13928, BgL_locz00_13929); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13930;
BgL_za2za2resza2za2z00_13930 = 
PROCEDURE_ENTRY(BgL_bodyz00_11742)(BgL_bodyz00_11742, BgL_sz00_11743, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13927); 
return BgL_za2za2resza2za2z00_13930;} } } } } } 

}



/* &<@anonymous:3434> */
obj_t BGl_z62zc3z04anonymousza33434ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11744, obj_t BgL_sz00_11749)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11745;BgL_ev_absz00_bglt BgL_i1243z00_11746;obj_t BgL_bodyz00_11747;long BgL_siza7ezd2framez75_11748;
BgL_iboxesz00_11745 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11744, 
(int)(((long)0)))); 
BgL_i1243z00_11746 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11744, 
(int)(((long)1)))); 
BgL_bodyz00_11747 = 
PROCEDURE_REF(BgL_envz00_11744, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11748 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11744, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13931;
BgL_bpz00_13931 = 
VECTOR_REF(
((obj_t)BgL_sz00_11749),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13932;
BgL_runz00_13932 = 
MAKE_FX_PROCEDURE(BGl_z62run5173z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_13932, 
(int)(((long)0)), BgL_iboxesz00_11745); 
PROCEDURE_SET(BgL_runz00_13932, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11746)); 
PROCEDURE_SET(BgL_runz00_13932, 
(int)(((long)2)), BgL_bodyz00_11747); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13933;
BgL_mainz00_13933 = 
MAKE_FX_PROCEDURE(BGl_z62main5172z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_13933, 
(int)(((long)0)), BgL_iboxesz00_11745); 
PROCEDURE_SET(BgL_mainz00_13933, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11746)); 
PROCEDURE_SET(BgL_mainz00_13933, 
(int)(((long)2)), BgL_bodyz00_11747); 
PROCEDURE_SET(BgL_mainz00_13933, 
(int)(((long)3)), BgL_runz00_13932); 
PROCEDURE_SET(BgL_mainz00_13933, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11748)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13934;
BgL_objz00_13934 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13932, BgL_objz00_13934); BgL_objz00_13934; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3435z00_13935;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3436z00_13936;
BgL_arg3436z00_13936 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11746))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13937;
BgL_newz00_13937 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24193;
BgL_tmpz00_24193 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13937, BgL_tmpz00_24193, BgL_arg3436z00_13936); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24198;int BgL_tmpz00_24196;
BgL_auxz00_24198 = 
BINT(BgL_siza7ezd2framez75_11748); 
BgL_tmpz00_24196 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13937, BgL_tmpz00_24196, BgL_auxz00_24198); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24201;
BgL_tmpz00_24201 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13937, BgL_tmpz00_24201, BgL_runz00_13932); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24206;int BgL_tmpz00_24204;
BgL_auxz00_24206 = 
BINT(((long)3)); 
BgL_tmpz00_24204 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13937, BgL_tmpz00_24204, BgL_auxz00_24206); } 
BgL_arg3435z00_13935 = BgL_newz00_13937; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13933, BgL_arg3435z00_13935); BgL_arg3435z00_13935; } 
return BgL_mainz00_13933;} } } } } } 

}



/* &main5172 */
obj_t BGl_z62main5172z62zz__evaluate_compz00(obj_t BgL_envz00_11750, obj_t BgL_bz00_11756, obj_t BgL_cz00_11757, obj_t BgL_dz00_11758)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11754;long BgL_siza7ezd2framez75_11755;
BgL_runz00_11754 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11750, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11755 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11750, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13938;
BgL_sz00_13938 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13939;
BgL_bpz00_13939 = 
VECTOR_REF(
((obj_t)BgL_sz00_13938),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13938, BgL_bpz00_13939, 
BINT(BgL_siza7ezd2framez75_11755)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3439z00_13940;
BgL_arg3439z00_13940 = 
(
(long)CINT(BgL_bpz00_13939)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13938),BgL_arg3439z00_13940,BgL_bz00_11756); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3440z00_13941;
BgL_arg3440z00_13941 = 
(
(long)CINT(BgL_bpz00_13939)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13938),BgL_arg3440z00_13941,BgL_cz00_11757); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3441z00_13942;
BgL_arg3441z00_13942 = 
(
(long)CINT(BgL_bpz00_13939)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13938),BgL_arg3441z00_13942,BgL_dz00_11758); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13943;
BgL_ez00_13943 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13943, BgL_bpz00_13939); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13944;
BgL_accz00_13944 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11754, BgL_sz00_13938, BgL_bpz00_13939); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13943); 
VECTOR_SET(
((obj_t)BgL_sz00_13938),((long)0),BgL_bpz00_13939); 
return BgL_accz00_13944;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13945;
BgL_nsz00_13945 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13945,((long)1),BgL_sz00_13938); 
VECTOR_SET(BgL_nsz00_13945,((long)2),BgL_bz00_11756); 
VECTOR_SET(BgL_nsz00_13945,((long)3),BgL_cz00_11757); 
VECTOR_SET(BgL_nsz00_13945,((long)4),BgL_dz00_11758); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13946;
BgL_z12denvz12_13946 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13946, BgL_nsz00_13945); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13947;
BgL_ez00_13947 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13947, BgL_sz00_13938); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13948;
BgL_____rz00_13948 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11754, BgL_nsz00_13945, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13947); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13946, BgL_sz00_13938); 
return BgL_____rz00_13948;} } } } } } } } 

}



/* &run5173 */
obj_t BGl_z62run5173z62zz__evaluate_compz00(obj_t BgL_envz00_11759, obj_t BgL_sz00_11763)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11760;BgL_ev_absz00_bglt BgL_i1243z00_11761;obj_t BgL_bodyz00_11762;
BgL_iboxesz00_11760 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11759, 
(int)(((long)0)))); 
BgL_i1243z00_11761 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11759, 
(int)(((long)1)))); 
BgL_bodyz00_11762 = 
PROCEDURE_REF(BgL_envz00_11759, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13949;
BgL_bpz00_13949 = 
VECTOR_REF(
((obj_t)BgL_sz00_11763),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11763, BgL_iboxesz00_11760, BgL_bpz00_13949); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13950;obj_t BgL_wherez00_13951;obj_t BgL_locz00_13952;
BgL_z12denvz12_13950 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13951 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11761))->BgL_wherez00); 
BgL_locz00_13952 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11761))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13950, BgL_wherez00_13951, BgL_locz00_13952); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_13953;
BgL_za2za2resza2za2z00_13953 = 
PROCEDURE_ENTRY(BgL_bodyz00_11762)(BgL_bodyz00_11762, BgL_sz00_11763, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13950); 
return BgL_za2za2resza2za2z00_13953;} } } } } } 

}



/* &<@anonymous:3446> */
obj_t BGl_z62zc3z04anonymousza33446ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11764, obj_t BgL_sz00_11770)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11765;long BgL_siza7eza7_11766;BgL_ev_absz00_bglt BgL_i1243z00_11767;obj_t BgL_bodyz00_11768;long BgL_siza7ezd2framez75_11769;
BgL_ifreesz00_11765 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11764, 
(int)(((long)0)))); 
BgL_siza7eza7_11766 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11764, 
(int)(((long)1)))); 
BgL_i1243z00_11767 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11764, 
(int)(((long)2)))); 
BgL_bodyz00_11768 = 
PROCEDURE_REF(BgL_envz00_11764, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11769 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11764, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13954;
BgL_bpz00_13954 = 
VECTOR_REF(
((obj_t)BgL_sz00_11770),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13955;
BgL_valza2za2_13955 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11770, BgL_bpz00_13954, BgL_ifreesz00_11765); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13956;
BgL_runz00_13956 = 
MAKE_FX_PROCEDURE(BGl_z62run5175z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_13956, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11766)); 
PROCEDURE_SET(BgL_runz00_13956, 
(int)(((long)1)), BgL_valza2za2_13955); 
PROCEDURE_SET(BgL_runz00_13956, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11767)); 
PROCEDURE_SET(BgL_runz00_13956, 
(int)(((long)3)), BgL_bodyz00_11768); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13957;
BgL_mainz00_13957 = 
MAKE_FX_PROCEDURE(BGl_z62main5174z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_13957, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11766)); 
PROCEDURE_SET(BgL_mainz00_13957, 
(int)(((long)1)), BgL_valza2za2_13955); 
PROCEDURE_SET(BgL_mainz00_13957, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11767)); 
PROCEDURE_SET(BgL_mainz00_13957, 
(int)(((long)3)), BgL_bodyz00_11768); 
PROCEDURE_SET(BgL_mainz00_13957, 
(int)(((long)4)), BgL_runz00_13956); 
PROCEDURE_SET(BgL_mainz00_13957, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11769)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13958;
BgL_objz00_13958 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13956, BgL_objz00_13958); BgL_objz00_13958; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3447z00_13959;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3448z00_13960;
BgL_arg3448z00_13960 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11767))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13961;
BgL_newz00_13961 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24325;
BgL_tmpz00_24325 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13961, BgL_tmpz00_24325, BgL_arg3448z00_13960); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24330;int BgL_tmpz00_24328;
BgL_auxz00_24330 = 
BINT(BgL_siza7ezd2framez75_11769); 
BgL_tmpz00_24328 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13961, BgL_tmpz00_24328, BgL_auxz00_24330); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24333;
BgL_tmpz00_24333 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13961, BgL_tmpz00_24333, BgL_runz00_13956); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24338;int BgL_tmpz00_24336;
BgL_auxz00_24338 = 
BINT(((long)3)); 
BgL_tmpz00_24336 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13961, BgL_tmpz00_24336, BgL_auxz00_24338); } 
BgL_arg3447z00_13959 = BgL_newz00_13961; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13957, BgL_arg3447z00_13959); BgL_arg3447z00_13959; } 
return BgL_mainz00_13957;} } } } } } 

}



/* &main5174 */
obj_t BGl_z62main5174z62zz__evaluate_compz00(obj_t BgL_envz00_11771, obj_t BgL_bz00_11778, obj_t BgL_cz00_11779, obj_t BgL_dz00_11780)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11776;long BgL_siza7ezd2framez75_11777;
BgL_runz00_11776 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11771, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11777 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11771, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13962;
BgL_sz00_13962 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13963;
BgL_bpz00_13963 = 
VECTOR_REF(
((obj_t)BgL_sz00_13962),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13962, BgL_bpz00_13963, 
BINT(BgL_siza7ezd2framez75_11777)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3451z00_13964;
BgL_arg3451z00_13964 = 
(
(long)CINT(BgL_bpz00_13963)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13962),BgL_arg3451z00_13964,BgL_bz00_11778); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3452z00_13965;
BgL_arg3452z00_13965 = 
(
(long)CINT(BgL_bpz00_13963)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13962),BgL_arg3452z00_13965,BgL_cz00_11779); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3453z00_13966;
BgL_arg3453z00_13966 = 
(
(long)CINT(BgL_bpz00_13963)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13962),BgL_arg3453z00_13966,BgL_dz00_11780); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13967;
BgL_ez00_13967 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13967, BgL_bpz00_13963); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13968;
BgL_accz00_13968 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11776, BgL_sz00_13962, BgL_bpz00_13963); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13967); 
VECTOR_SET(
((obj_t)BgL_sz00_13962),((long)0),BgL_bpz00_13963); 
return BgL_accz00_13968;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13969;
BgL_nsz00_13969 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13969,((long)1),BgL_sz00_13962); 
VECTOR_SET(BgL_nsz00_13969,((long)2),BgL_bz00_11778); 
VECTOR_SET(BgL_nsz00_13969,((long)3),BgL_cz00_11779); 
VECTOR_SET(BgL_nsz00_13969,((long)4),BgL_dz00_11780); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13970;
BgL_z12denvz12_13970 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13970, BgL_nsz00_13969); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13971;
BgL_ez00_13971 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13971, BgL_sz00_13962); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13972;
BgL_____rz00_13972 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11776, BgL_nsz00_13969, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13971); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13970, BgL_sz00_13962); 
return BgL_____rz00_13972;} } } } } } } } 

}



/* &run5175 */
obj_t BGl_z62run5175z62zz__evaluate_compz00(obj_t BgL_envz00_11781, obj_t BgL_sz00_11786)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11782;obj_t BgL_valza2za2_11783;BgL_ev_absz00_bglt BgL_i1243z00_11784;obj_t BgL_bodyz00_11785;
BgL_siza7eza7_11782 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11781, 
(int)(((long)0)))); 
BgL_valza2za2_11783 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11781, 
(int)(((long)1)))); 
BgL_i1243z00_11784 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11781, 
(int)(((long)2)))); 
BgL_bodyz00_11785 = 
PROCEDURE_REF(BgL_envz00_11781, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13973;
BgL_bpz00_13973 = 
VECTOR_REF(
((obj_t)BgL_sz00_11786),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11786, BgL_valza2za2_11783, 
(
(long)CINT(BgL_bpz00_13973)+BgL_siza7eza7_11782)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13974;obj_t BgL_wherez00_13975;obj_t BgL_locz00_13976;
BgL_z12denvz12_13974 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13975 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11784))->BgL_wherez00); 
BgL_locz00_13976 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11784))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13974, BgL_wherez00_13975, BgL_locz00_13976); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_13977;
BgL_za2za2resza2za2z00_13977 = 
PROCEDURE_ENTRY(BgL_bodyz00_11785)(BgL_bodyz00_11785, BgL_sz00_11786, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13974); 
return BgL_za2za2resza2za2z00_13977;} } } } } } 

}



/* &<@anonymous:3456> */
obj_t BGl_z62zc3z04anonymousza33456ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11787, obj_t BgL_sz00_11794)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11788;obj_t BgL_iboxesz00_11789;long BgL_siza7eza7_11790;BgL_ev_absz00_bglt BgL_i1243z00_11791;obj_t BgL_bodyz00_11792;long BgL_siza7ezd2framez75_11793;
BgL_ifreesz00_11788 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11787, 
(int)(((long)0)))); 
BgL_iboxesz00_11789 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11787, 
(int)(((long)1)))); 
BgL_siza7eza7_11790 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11787, 
(int)(((long)2)))); 
BgL_i1243z00_11791 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11787, 
(int)(((long)3)))); 
BgL_bodyz00_11792 = 
PROCEDURE_REF(BgL_envz00_11787, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11793 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11787, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13978;
BgL_bpz00_13978 = 
VECTOR_REF(
((obj_t)BgL_sz00_11794),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_13979;
BgL_valza2za2_13979 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11794, BgL_bpz00_13978, BgL_ifreesz00_11788); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_13980;
BgL_runz00_13980 = 
MAKE_FX_PROCEDURE(BGl_z62run5177z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_13980, 
(int)(((long)0)), BgL_iboxesz00_11789); 
PROCEDURE_SET(BgL_runz00_13980, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11790)); 
PROCEDURE_SET(BgL_runz00_13980, 
(int)(((long)2)), BgL_valza2za2_13979); 
PROCEDURE_SET(BgL_runz00_13980, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11791)); 
PROCEDURE_SET(BgL_runz00_13980, 
(int)(((long)4)), BgL_bodyz00_11792); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_13981;
BgL_mainz00_13981 = 
MAKE_FX_PROCEDURE(BGl_z62main5176z62zz__evaluate_compz00, 
(int)(((long)3)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_13981, 
(int)(((long)0)), BgL_iboxesz00_11789); 
PROCEDURE_SET(BgL_mainz00_13981, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11790)); 
PROCEDURE_SET(BgL_mainz00_13981, 
(int)(((long)2)), BgL_valza2za2_13979); 
PROCEDURE_SET(BgL_mainz00_13981, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11791)); 
PROCEDURE_SET(BgL_mainz00_13981, 
(int)(((long)4)), BgL_bodyz00_11792); 
PROCEDURE_SET(BgL_mainz00_13981, 
(int)(((long)5)), BgL_runz00_13980); 
PROCEDURE_SET(BgL_mainz00_13981, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11793)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_13982;
BgL_objz00_13982 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_13980, BgL_objz00_13982); BgL_objz00_13982; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3457z00_13983;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3458z00_13984;
BgL_arg3458z00_13984 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11791))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_13985;
BgL_newz00_13985 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24469;
BgL_tmpz00_24469 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_13985, BgL_tmpz00_24469, BgL_arg3458z00_13984); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24474;int BgL_tmpz00_24472;
BgL_auxz00_24474 = 
BINT(BgL_siza7ezd2framez75_11793); 
BgL_tmpz00_24472 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_13985, BgL_tmpz00_24472, BgL_auxz00_24474); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24477;
BgL_tmpz00_24477 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_13985, BgL_tmpz00_24477, BgL_runz00_13980); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24482;int BgL_tmpz00_24480;
BgL_auxz00_24482 = 
BINT(((long)3)); 
BgL_tmpz00_24480 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_13985, BgL_tmpz00_24480, BgL_auxz00_24482); } 
BgL_arg3457z00_13983 = BgL_newz00_13985; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_13981, BgL_arg3457z00_13983); BgL_arg3457z00_13983; } 
return BgL_mainz00_13981;} } } } } } 

}



/* &main5176 */
obj_t BGl_z62main5176z62zz__evaluate_compz00(obj_t BgL_envz00_11795, obj_t BgL_bz00_11803, obj_t BgL_cz00_11804, obj_t BgL_dz00_11805)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11801;long BgL_siza7ezd2framez75_11802;
BgL_runz00_11801 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11795, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11802 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11795, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_13986;
BgL_sz00_13986 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13987;
BgL_bpz00_13987 = 
VECTOR_REF(
((obj_t)BgL_sz00_13986),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_13986, BgL_bpz00_13987, 
BINT(BgL_siza7ezd2framez75_11802)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3461z00_13988;
BgL_arg3461z00_13988 = 
(
(long)CINT(BgL_bpz00_13987)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_13986),BgL_arg3461z00_13988,BgL_bz00_11803); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3462z00_13989;
BgL_arg3462z00_13989 = 
(
(long)CINT(BgL_bpz00_13987)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_13986),BgL_arg3462z00_13989,BgL_cz00_11804); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3463z00_13990;
BgL_arg3463z00_13990 = 
(
(long)CINT(BgL_bpz00_13987)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_13986),BgL_arg3463z00_13990,BgL_dz00_11805); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13991;
BgL_ez00_13991 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13991, BgL_bpz00_13987); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_13992;
BgL_accz00_13992 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11801, BgL_sz00_13986, BgL_bpz00_13987); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13991); 
VECTOR_SET(
((obj_t)BgL_sz00_13986),((long)0),BgL_bpz00_13987); 
return BgL_accz00_13992;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_13993;
BgL_nsz00_13993 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_13993,((long)1),BgL_sz00_13986); 
VECTOR_SET(BgL_nsz00_13993,((long)2),BgL_bz00_11803); 
VECTOR_SET(BgL_nsz00_13993,((long)3),BgL_cz00_11804); 
VECTOR_SET(BgL_nsz00_13993,((long)4),BgL_dz00_11805); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_13994;
BgL_z12denvz12_13994 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13994, BgL_nsz00_13993); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_13995;
BgL_ez00_13995 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_13995, BgL_sz00_13986); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_13996;
BgL_____rz00_13996 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11801, BgL_nsz00_13993, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_13995); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_13994, BgL_sz00_13986); 
return BgL_____rz00_13996;} } } } } } } } 

}



/* &run5177 */
obj_t BGl_z62run5177z62zz__evaluate_compz00(obj_t BgL_envz00_11806, obj_t BgL_sz00_11812)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11807;long BgL_siza7eza7_11808;obj_t BgL_valza2za2_11809;BgL_ev_absz00_bglt BgL_i1243z00_11810;obj_t BgL_bodyz00_11811;
BgL_iboxesz00_11807 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11806, 
(int)(((long)0)))); 
BgL_siza7eza7_11808 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11806, 
(int)(((long)1)))); 
BgL_valza2za2_11809 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11806, 
(int)(((long)2)))); 
BgL_i1243z00_11810 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11806, 
(int)(((long)3)))); 
BgL_bodyz00_11811 = 
PROCEDURE_REF(BgL_envz00_11806, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_13997;
BgL_bpz00_13997 = 
VECTOR_REF(
((obj_t)BgL_sz00_11812),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11812, BgL_iboxesz00_11807, BgL_bpz00_13997); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11812, BgL_valza2za2_11809, 
(
(long)CINT(BgL_bpz00_13997)+BgL_siza7eza7_11808)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_13998;obj_t BgL_wherez00_13999;obj_t BgL_locz00_14000;
BgL_z12denvz12_13998 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_13999 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11810))->BgL_wherez00); 
BgL_locz00_14000 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11810))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_13998, BgL_wherez00_13999, BgL_locz00_14000); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14001;
BgL_za2za2resza2za2z00_14001 = 
PROCEDURE_ENTRY(BgL_bodyz00_11811)(BgL_bodyz00_11811, BgL_sz00_11812, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_13998); 
return BgL_za2za2resza2za2z00_14001;} } } } } } 

}



/* &<@anonymous:3378> */
obj_t BGl_z62zc3z04anonymousza33378ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11813, obj_t BgL_sz00_11817)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11814;obj_t BgL_bodyz00_11815;long BgL_siza7ezd2framez75_11816;
BgL_i1243z00_11814 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11813, 
(int)(((long)0)))); 
BgL_bodyz00_11815 = 
PROCEDURE_REF(BgL_envz00_11813, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11816 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11813, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14002;
BgL_bpz00_14002 = 
VECTOR_REF(
((obj_t)BgL_sz00_11817),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14003;
BgL_runz00_14003 = 
MAKE_FX_PROCEDURE(BGl_z62run5179z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14003, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11814)); 
PROCEDURE_SET(BgL_runz00_14003, 
(int)(((long)1)), BgL_bodyz00_11815); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14004;
BgL_mainz00_14004 = 
MAKE_VA_PROCEDURE(BGl_z62main5178z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14004, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11814)); 
PROCEDURE_SET(BgL_mainz00_14004, 
(int)(((long)1)), BgL_bodyz00_11815); 
PROCEDURE_SET(BgL_mainz00_14004, 
(int)(((long)2)), BgL_runz00_14003); 
PROCEDURE_SET(BgL_mainz00_14004, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11816)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14005;
BgL_objz00_14005 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14003, BgL_objz00_14005); BgL_objz00_14005; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3379z00_14006;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3380z00_14007;
BgL_arg3380z00_14007 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11814))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14008;
BgL_newz00_14008 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24593;
BgL_tmpz00_24593 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14008, BgL_tmpz00_24593, BgL_arg3380z00_14007); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24598;int BgL_tmpz00_24596;
BgL_auxz00_24598 = 
BINT(BgL_siza7ezd2framez75_11816); 
BgL_tmpz00_24596 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14008, BgL_tmpz00_24596, BgL_auxz00_24598); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24601;
BgL_tmpz00_24601 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14008, BgL_tmpz00_24601, BgL_runz00_14003); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24606;int BgL_tmpz00_24604;
BgL_auxz00_24606 = 
BINT(((long)-3)); 
BgL_tmpz00_24604 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14008, BgL_tmpz00_24604, BgL_auxz00_24606); } 
BgL_arg3379z00_14006 = BgL_newz00_14008; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14004, BgL_arg3379z00_14006); BgL_arg3379z00_14006; } 
return BgL_mainz00_14004;} } } } } } 

}



/* &main5178 */
obj_t BGl_z62main5178z62zz__evaluate_compz00(obj_t BgL_envz00_11818, obj_t BgL_cz00_11823, obj_t BgL_dz00_11824, obj_t BgL_lastz00_11825)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11821;long BgL_siza7ezd2framez75_11822;
BgL_runz00_11821 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11818, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11822 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11818, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14009;
BgL_sz00_14009 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14010;
BgL_bpz00_14010 = 
VECTOR_REF(
((obj_t)BgL_sz00_14009),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14009, BgL_bpz00_14010, 
BINT(BgL_siza7ezd2framez75_11822)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3383z00_14011;
BgL_arg3383z00_14011 = 
(
(long)CINT(BgL_bpz00_14010)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14009),BgL_arg3383z00_14011,BgL_cz00_11823); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3384z00_14012;
BgL_arg3384z00_14012 = 
(
(long)CINT(BgL_bpz00_14010)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14009),BgL_arg3384z00_14012,BgL_dz00_11824); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3385z00_14013;
BgL_arg3385z00_14013 = 
(
(long)CINT(BgL_bpz00_14010)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14009),BgL_arg3385z00_14013,BgL_lastz00_11825); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14014;
BgL_ez00_14014 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14014, BgL_bpz00_14010); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14015;
BgL_accz00_14015 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11821, BgL_sz00_14009, BgL_bpz00_14010); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14014); 
VECTOR_SET(
((obj_t)BgL_sz00_14009),((long)0),BgL_bpz00_14010); 
return BgL_accz00_14015;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14016;
BgL_nsz00_14016 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14016,((long)1),BgL_sz00_14009); 
VECTOR_SET(BgL_nsz00_14016,((long)2),BgL_cz00_11823); 
VECTOR_SET(BgL_nsz00_14016,((long)3),BgL_dz00_11824); 
VECTOR_SET(BgL_nsz00_14016,((long)4),BgL_lastz00_11825); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14017;
BgL_z12denvz12_14017 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14017, BgL_nsz00_14016); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14018;
BgL_ez00_14018 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14018, BgL_sz00_14009); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14019;
BgL_____rz00_14019 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11821, BgL_nsz00_14016, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14018); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14017, BgL_sz00_14009); 
return BgL_____rz00_14019;} } } } } } } } 

}



/* &run5179 */
obj_t BGl_z62run5179z62zz__evaluate_compz00(obj_t BgL_envz00_11826, obj_t BgL_sz00_11829)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11827;obj_t BgL_bodyz00_11828;
BgL_i1243z00_11827 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11826, 
(int)(((long)0)))); 
BgL_bodyz00_11828 = 
PROCEDURE_REF(BgL_envz00_11826, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14020;
BgL_bpz00_14020 = 
VECTOR_REF(
((obj_t)BgL_sz00_11829),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14021;obj_t BgL_wherez00_14022;obj_t BgL_locz00_14023;
BgL_z12denvz12_14021 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14022 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11827))->BgL_wherez00); 
BgL_locz00_14023 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11827))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14021, BgL_wherez00_14022, BgL_locz00_14023); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14024;
BgL_za2za2resza2za2z00_14024 = 
PROCEDURE_ENTRY(BgL_bodyz00_11828)(BgL_bodyz00_11828, BgL_sz00_11829, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14021); 
return BgL_za2za2resza2za2z00_14024;} } } } } } 

}



/* &<@anonymous:3387> */
obj_t BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11830, obj_t BgL_sz00_11835)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11831;BgL_ev_absz00_bglt BgL_i1243z00_11832;obj_t BgL_bodyz00_11833;long BgL_siza7ezd2framez75_11834;
BgL_iboxesz00_11831 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11830, 
(int)(((long)0)))); 
BgL_i1243z00_11832 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11830, 
(int)(((long)1)))); 
BgL_bodyz00_11833 = 
PROCEDURE_REF(BgL_envz00_11830, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11834 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11830, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14025;
BgL_bpz00_14025 = 
VECTOR_REF(
((obj_t)BgL_sz00_11835),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14026;
BgL_runz00_14026 = 
MAKE_FX_PROCEDURE(BGl_z62run5181z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14026, 
(int)(((long)0)), BgL_iboxesz00_11831); 
PROCEDURE_SET(BgL_runz00_14026, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11832)); 
PROCEDURE_SET(BgL_runz00_14026, 
(int)(((long)2)), BgL_bodyz00_11833); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14027;
BgL_mainz00_14027 = 
MAKE_VA_PROCEDURE(BGl_z62main5180z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14027, 
(int)(((long)0)), BgL_iboxesz00_11831); 
PROCEDURE_SET(BgL_mainz00_14027, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11832)); 
PROCEDURE_SET(BgL_mainz00_14027, 
(int)(((long)2)), BgL_bodyz00_11833); 
PROCEDURE_SET(BgL_mainz00_14027, 
(int)(((long)3)), BgL_runz00_14026); 
PROCEDURE_SET(BgL_mainz00_14027, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11834)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14028;
BgL_objz00_14028 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14026, BgL_objz00_14028); BgL_objz00_14028; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3388z00_14029;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3389z00_14030;
BgL_arg3389z00_14030 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11832))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14031;
BgL_newz00_14031 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24711;
BgL_tmpz00_24711 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14031, BgL_tmpz00_24711, BgL_arg3389z00_14030); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24716;int BgL_tmpz00_24714;
BgL_auxz00_24716 = 
BINT(BgL_siza7ezd2framez75_11834); 
BgL_tmpz00_24714 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14031, BgL_tmpz00_24714, BgL_auxz00_24716); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24719;
BgL_tmpz00_24719 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14031, BgL_tmpz00_24719, BgL_runz00_14026); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24724;int BgL_tmpz00_24722;
BgL_auxz00_24724 = 
BINT(((long)-3)); 
BgL_tmpz00_24722 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14031, BgL_tmpz00_24722, BgL_auxz00_24724); } 
BgL_arg3388z00_14029 = BgL_newz00_14031; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14027, BgL_arg3388z00_14029); BgL_arg3388z00_14029; } 
return BgL_mainz00_14027;} } } } } } 

}



/* &main5180 */
obj_t BGl_z62main5180z62zz__evaluate_compz00(obj_t BgL_envz00_11836, obj_t BgL_cz00_11842, obj_t BgL_dz00_11843, obj_t BgL_lastz00_11844)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11840;long BgL_siza7ezd2framez75_11841;
BgL_runz00_11840 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11836, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11841 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11836, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14032;
BgL_sz00_14032 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14033;
BgL_bpz00_14033 = 
VECTOR_REF(
((obj_t)BgL_sz00_14032),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14032, BgL_bpz00_14033, 
BINT(BgL_siza7ezd2framez75_11841)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3392z00_14034;
BgL_arg3392z00_14034 = 
(
(long)CINT(BgL_bpz00_14033)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14032),BgL_arg3392z00_14034,BgL_cz00_11842); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3393z00_14035;
BgL_arg3393z00_14035 = 
(
(long)CINT(BgL_bpz00_14033)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14032),BgL_arg3393z00_14035,BgL_dz00_11843); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3394z00_14036;
BgL_arg3394z00_14036 = 
(
(long)CINT(BgL_bpz00_14033)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14032),BgL_arg3394z00_14036,BgL_lastz00_11844); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14037;
BgL_ez00_14037 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14037, BgL_bpz00_14033); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14038;
BgL_accz00_14038 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11840, BgL_sz00_14032, BgL_bpz00_14033); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14037); 
VECTOR_SET(
((obj_t)BgL_sz00_14032),((long)0),BgL_bpz00_14033); 
return BgL_accz00_14038;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14039;
BgL_nsz00_14039 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14039,((long)1),BgL_sz00_14032); 
VECTOR_SET(BgL_nsz00_14039,((long)2),BgL_cz00_11842); 
VECTOR_SET(BgL_nsz00_14039,((long)3),BgL_dz00_11843); 
VECTOR_SET(BgL_nsz00_14039,((long)4),BgL_lastz00_11844); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14040;
BgL_z12denvz12_14040 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14040, BgL_nsz00_14039); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14041;
BgL_ez00_14041 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14041, BgL_sz00_14032); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14042;
BgL_____rz00_14042 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11840, BgL_nsz00_14039, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14041); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14040, BgL_sz00_14032); 
return BgL_____rz00_14042;} } } } } } } } 

}



/* &run5181 */
obj_t BGl_z62run5181z62zz__evaluate_compz00(obj_t BgL_envz00_11845, obj_t BgL_sz00_11849)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11846;BgL_ev_absz00_bglt BgL_i1243z00_11847;obj_t BgL_bodyz00_11848;
BgL_iboxesz00_11846 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11845, 
(int)(((long)0)))); 
BgL_i1243z00_11847 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11845, 
(int)(((long)1)))); 
BgL_bodyz00_11848 = 
PROCEDURE_REF(BgL_envz00_11845, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14043;
BgL_bpz00_14043 = 
VECTOR_REF(
((obj_t)BgL_sz00_11849),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11849, BgL_iboxesz00_11846, BgL_bpz00_14043); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14044;obj_t BgL_wherez00_14045;obj_t BgL_locz00_14046;
BgL_z12denvz12_14044 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14045 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11847))->BgL_wherez00); 
BgL_locz00_14046 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11847))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14044, BgL_wherez00_14045, BgL_locz00_14046); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14047;
BgL_za2za2resza2za2z00_14047 = 
PROCEDURE_ENTRY(BgL_bodyz00_11848)(BgL_bodyz00_11848, BgL_sz00_11849, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14044); 
return BgL_za2za2resza2za2z00_14047;} } } } } } 

}



/* &<@anonymous:3399> */
obj_t BGl_z62zc3z04anonymousza33399ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11850, obj_t BgL_sz00_11856)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11851;long BgL_siza7eza7_11852;BgL_ev_absz00_bglt BgL_i1243z00_11853;obj_t BgL_bodyz00_11854;long BgL_siza7ezd2framez75_11855;
BgL_ifreesz00_11851 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11850, 
(int)(((long)0)))); 
BgL_siza7eza7_11852 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11850, 
(int)(((long)1)))); 
BgL_i1243z00_11853 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11850, 
(int)(((long)2)))); 
BgL_bodyz00_11854 = 
PROCEDURE_REF(BgL_envz00_11850, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11855 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11850, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14048;
BgL_bpz00_14048 = 
VECTOR_REF(
((obj_t)BgL_sz00_11856),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14049;
BgL_valza2za2_14049 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11856, BgL_bpz00_14048, BgL_ifreesz00_11851); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14050;
BgL_runz00_14050 = 
MAKE_FX_PROCEDURE(BGl_z62run5183z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14050, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11852)); 
PROCEDURE_SET(BgL_runz00_14050, 
(int)(((long)1)), BgL_valza2za2_14049); 
PROCEDURE_SET(BgL_runz00_14050, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11853)); 
PROCEDURE_SET(BgL_runz00_14050, 
(int)(((long)3)), BgL_bodyz00_11854); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14051;
BgL_mainz00_14051 = 
MAKE_VA_PROCEDURE(BGl_z62main5182z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14051, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11852)); 
PROCEDURE_SET(BgL_mainz00_14051, 
(int)(((long)1)), BgL_valza2za2_14049); 
PROCEDURE_SET(BgL_mainz00_14051, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11853)); 
PROCEDURE_SET(BgL_mainz00_14051, 
(int)(((long)3)), BgL_bodyz00_11854); 
PROCEDURE_SET(BgL_mainz00_14051, 
(int)(((long)4)), BgL_runz00_14050); 
PROCEDURE_SET(BgL_mainz00_14051, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11855)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14052;
BgL_objz00_14052 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14050, BgL_objz00_14052); BgL_objz00_14052; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3400z00_14053;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3401z00_14054;
BgL_arg3401z00_14054 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11853))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14055;
BgL_newz00_14055 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24843;
BgL_tmpz00_24843 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14055, BgL_tmpz00_24843, BgL_arg3401z00_14054); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24848;int BgL_tmpz00_24846;
BgL_auxz00_24848 = 
BINT(BgL_siza7ezd2framez75_11855); 
BgL_tmpz00_24846 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14055, BgL_tmpz00_24846, BgL_auxz00_24848); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24851;
BgL_tmpz00_24851 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14055, BgL_tmpz00_24851, BgL_runz00_14050); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24856;int BgL_tmpz00_24854;
BgL_auxz00_24856 = 
BINT(((long)-3)); 
BgL_tmpz00_24854 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14055, BgL_tmpz00_24854, BgL_auxz00_24856); } 
BgL_arg3400z00_14053 = BgL_newz00_14055; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14051, BgL_arg3400z00_14053); BgL_arg3400z00_14053; } 
return BgL_mainz00_14051;} } } } } } 

}



/* &main5182 */
obj_t BGl_z62main5182z62zz__evaluate_compz00(obj_t BgL_envz00_11857, obj_t BgL_cz00_11864, obj_t BgL_dz00_11865, obj_t BgL_lastz00_11866)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11862;long BgL_siza7ezd2framez75_11863;
BgL_runz00_11862 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11857, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11863 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11857, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14056;
BgL_sz00_14056 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14057;
BgL_bpz00_14057 = 
VECTOR_REF(
((obj_t)BgL_sz00_14056),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14056, BgL_bpz00_14057, 
BINT(BgL_siza7ezd2framez75_11863)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3404z00_14058;
BgL_arg3404z00_14058 = 
(
(long)CINT(BgL_bpz00_14057)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14056),BgL_arg3404z00_14058,BgL_cz00_11864); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3405z00_14059;
BgL_arg3405z00_14059 = 
(
(long)CINT(BgL_bpz00_14057)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14056),BgL_arg3405z00_14059,BgL_dz00_11865); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3406z00_14060;
BgL_arg3406z00_14060 = 
(
(long)CINT(BgL_bpz00_14057)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14056),BgL_arg3406z00_14060,BgL_lastz00_11866); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14061;
BgL_ez00_14061 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14061, BgL_bpz00_14057); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14062;
BgL_accz00_14062 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11862, BgL_sz00_14056, BgL_bpz00_14057); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14061); 
VECTOR_SET(
((obj_t)BgL_sz00_14056),((long)0),BgL_bpz00_14057); 
return BgL_accz00_14062;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14063;
BgL_nsz00_14063 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14063,((long)1),BgL_sz00_14056); 
VECTOR_SET(BgL_nsz00_14063,((long)2),BgL_cz00_11864); 
VECTOR_SET(BgL_nsz00_14063,((long)3),BgL_dz00_11865); 
VECTOR_SET(BgL_nsz00_14063,((long)4),BgL_lastz00_11866); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14064;
BgL_z12denvz12_14064 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14064, BgL_nsz00_14063); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14065;
BgL_ez00_14065 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14065, BgL_sz00_14056); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14066;
BgL_____rz00_14066 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11862, BgL_nsz00_14063, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14065); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14064, BgL_sz00_14056); 
return BgL_____rz00_14066;} } } } } } } } 

}



/* &run5183 */
obj_t BGl_z62run5183z62zz__evaluate_compz00(obj_t BgL_envz00_11867, obj_t BgL_sz00_11872)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11868;obj_t BgL_valza2za2_11869;BgL_ev_absz00_bglt BgL_i1243z00_11870;obj_t BgL_bodyz00_11871;
BgL_siza7eza7_11868 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11867, 
(int)(((long)0)))); 
BgL_valza2za2_11869 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11867, 
(int)(((long)1)))); 
BgL_i1243z00_11870 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11867, 
(int)(((long)2)))); 
BgL_bodyz00_11871 = 
PROCEDURE_REF(BgL_envz00_11867, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14067;
BgL_bpz00_14067 = 
VECTOR_REF(
((obj_t)BgL_sz00_11872),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11872, BgL_valza2za2_11869, 
(
(long)CINT(BgL_bpz00_14067)+BgL_siza7eza7_11868)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14068;obj_t BgL_wherez00_14069;obj_t BgL_locz00_14070;
BgL_z12denvz12_14068 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14069 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11870))->BgL_wherez00); 
BgL_locz00_14070 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11870))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14068, BgL_wherez00_14069, BgL_locz00_14070); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14071;
BgL_za2za2resza2za2z00_14071 = 
PROCEDURE_ENTRY(BgL_bodyz00_11871)(BgL_bodyz00_11871, BgL_sz00_11872, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14068); 
return BgL_za2za2resza2za2z00_14071;} } } } } } 

}



/* &<@anonymous:3409> */
obj_t BGl_z62zc3z04anonymousza33409ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11873, obj_t BgL_sz00_11880)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11874;obj_t BgL_iboxesz00_11875;long BgL_siza7eza7_11876;BgL_ev_absz00_bglt BgL_i1243z00_11877;obj_t BgL_bodyz00_11878;long BgL_siza7ezd2framez75_11879;
BgL_ifreesz00_11874 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11873, 
(int)(((long)0)))); 
BgL_iboxesz00_11875 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11873, 
(int)(((long)1)))); 
BgL_siza7eza7_11876 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11873, 
(int)(((long)2)))); 
BgL_i1243z00_11877 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11873, 
(int)(((long)3)))); 
BgL_bodyz00_11878 = 
PROCEDURE_REF(BgL_envz00_11873, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11879 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11873, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14072;
BgL_bpz00_14072 = 
VECTOR_REF(
((obj_t)BgL_sz00_11880),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14073;
BgL_valza2za2_14073 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11880, BgL_bpz00_14072, BgL_ifreesz00_11874); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14074;
BgL_runz00_14074 = 
MAKE_FX_PROCEDURE(BGl_z62run5185z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14074, 
(int)(((long)0)), BgL_iboxesz00_11875); 
PROCEDURE_SET(BgL_runz00_14074, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11876)); 
PROCEDURE_SET(BgL_runz00_14074, 
(int)(((long)2)), BgL_valza2za2_14073); 
PROCEDURE_SET(BgL_runz00_14074, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11877)); 
PROCEDURE_SET(BgL_runz00_14074, 
(int)(((long)4)), BgL_bodyz00_11878); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14075;
BgL_mainz00_14075 = 
MAKE_VA_PROCEDURE(BGl_z62main5184z62zz__evaluate_compz00, 
(int)(((long)-3)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14075, 
(int)(((long)0)), BgL_iboxesz00_11875); 
PROCEDURE_SET(BgL_mainz00_14075, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11876)); 
PROCEDURE_SET(BgL_mainz00_14075, 
(int)(((long)2)), BgL_valza2za2_14073); 
PROCEDURE_SET(BgL_mainz00_14075, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11877)); 
PROCEDURE_SET(BgL_mainz00_14075, 
(int)(((long)4)), BgL_bodyz00_11878); 
PROCEDURE_SET(BgL_mainz00_14075, 
(int)(((long)5)), BgL_runz00_14074); 
PROCEDURE_SET(BgL_mainz00_14075, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11879)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14076;
BgL_objz00_14076 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14074, BgL_objz00_14076); BgL_objz00_14076; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3410z00_14077;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3411z00_14078;
BgL_arg3411z00_14078 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11877))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14079;
BgL_newz00_14079 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24987;
BgL_tmpz00_24987 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14079, BgL_tmpz00_24987, BgL_arg3411z00_14078); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_24992;int BgL_tmpz00_24990;
BgL_auxz00_24992 = 
BINT(BgL_siza7ezd2framez75_11879); 
BgL_tmpz00_24990 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14079, BgL_tmpz00_24990, BgL_auxz00_24992); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_24995;
BgL_tmpz00_24995 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14079, BgL_tmpz00_24995, BgL_runz00_14074); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25000;int BgL_tmpz00_24998;
BgL_auxz00_25000 = 
BINT(((long)-3)); 
BgL_tmpz00_24998 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14079, BgL_tmpz00_24998, BgL_auxz00_25000); } 
BgL_arg3410z00_14077 = BgL_newz00_14079; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14075, BgL_arg3410z00_14077); BgL_arg3410z00_14077; } 
return BgL_mainz00_14075;} } } } } } 

}



/* &main5184 */
obj_t BGl_z62main5184z62zz__evaluate_compz00(obj_t BgL_envz00_11881, obj_t BgL_cz00_11889, obj_t BgL_dz00_11890, obj_t BgL_lastz00_11891)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11887;long BgL_siza7ezd2framez75_11888;
BgL_runz00_11887 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11881, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11888 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11881, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14080;
BgL_sz00_14080 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14081;
BgL_bpz00_14081 = 
VECTOR_REF(
((obj_t)BgL_sz00_14080),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14080, BgL_bpz00_14081, 
BINT(BgL_siza7ezd2framez75_11888)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3414z00_14082;
BgL_arg3414z00_14082 = 
(
(long)CINT(BgL_bpz00_14081)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14080),BgL_arg3414z00_14082,BgL_cz00_11889); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3415z00_14083;
BgL_arg3415z00_14083 = 
(
(long)CINT(BgL_bpz00_14081)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14080),BgL_arg3415z00_14083,BgL_dz00_11890); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3416z00_14084;
BgL_arg3416z00_14084 = 
(
(long)CINT(BgL_bpz00_14081)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14080),BgL_arg3416z00_14084,BgL_lastz00_11891); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14085;
BgL_ez00_14085 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14085, BgL_bpz00_14081); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14086;
BgL_accz00_14086 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11887, BgL_sz00_14080, BgL_bpz00_14081); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14085); 
VECTOR_SET(
((obj_t)BgL_sz00_14080),((long)0),BgL_bpz00_14081); 
return BgL_accz00_14086;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14087;
BgL_nsz00_14087 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14087,((long)1),BgL_sz00_14080); 
VECTOR_SET(BgL_nsz00_14087,((long)2),BgL_cz00_11889); 
VECTOR_SET(BgL_nsz00_14087,((long)3),BgL_dz00_11890); 
VECTOR_SET(BgL_nsz00_14087,((long)4),BgL_lastz00_11891); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14088;
BgL_z12denvz12_14088 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14088, BgL_nsz00_14087); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14089;
BgL_ez00_14089 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14089, BgL_sz00_14080); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14090;
BgL_____rz00_14090 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11887, BgL_nsz00_14087, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14089); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14088, BgL_sz00_14080); 
return BgL_____rz00_14090;} } } } } } } } 

}



/* &run5185 */
obj_t BGl_z62run5185z62zz__evaluate_compz00(obj_t BgL_envz00_11892, obj_t BgL_sz00_11898)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11893;long BgL_siza7eza7_11894;obj_t BgL_valza2za2_11895;BgL_ev_absz00_bglt BgL_i1243z00_11896;obj_t BgL_bodyz00_11897;
BgL_iboxesz00_11893 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11892, 
(int)(((long)0)))); 
BgL_siza7eza7_11894 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11892, 
(int)(((long)1)))); 
BgL_valza2za2_11895 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11892, 
(int)(((long)2)))); 
BgL_i1243z00_11896 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11892, 
(int)(((long)3)))); 
BgL_bodyz00_11897 = 
PROCEDURE_REF(BgL_envz00_11892, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14091;
BgL_bpz00_14091 = 
VECTOR_REF(
((obj_t)BgL_sz00_11898),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11898, BgL_iboxesz00_11893, BgL_bpz00_14091); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11898, BgL_valza2za2_11895, 
(
(long)CINT(BgL_bpz00_14091)+BgL_siza7eza7_11894)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14092;obj_t BgL_wherez00_14093;obj_t BgL_locz00_14094;
BgL_z12denvz12_14092 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14093 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11896))->BgL_wherez00); 
BgL_locz00_14094 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11896))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14092, BgL_wherez00_14093, BgL_locz00_14094); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14095;
BgL_za2za2resza2za2z00_14095 = 
PROCEDURE_ENTRY(BgL_bodyz00_11897)(BgL_bodyz00_11897, BgL_sz00_11898, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14092); 
return BgL_za2za2resza2za2z00_14095;} } } } } } 

}



/* &<@anonymous:3335> */
obj_t BGl_z62zc3z04anonymousza33335ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11899, obj_t BgL_sz00_11903)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11900;obj_t BgL_bodyz00_11901;long BgL_siza7ezd2framez75_11902;
BgL_i1243z00_11900 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11899, 
(int)(((long)0)))); 
BgL_bodyz00_11901 = 
PROCEDURE_REF(BgL_envz00_11899, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11902 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11899, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14096;
BgL_bpz00_14096 = 
VECTOR_REF(
((obj_t)BgL_sz00_11903),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14097;
BgL_runz00_14097 = 
MAKE_FX_PROCEDURE(BGl_z62run5187z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14097, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11900)); 
PROCEDURE_SET(BgL_runz00_14097, 
(int)(((long)1)), BgL_bodyz00_11901); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14098;
BgL_mainz00_14098 = 
MAKE_FX_PROCEDURE(BGl_z62main5186z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14098, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11900)); 
PROCEDURE_SET(BgL_mainz00_14098, 
(int)(((long)1)), BgL_bodyz00_11901); 
PROCEDURE_SET(BgL_mainz00_14098, 
(int)(((long)2)), BgL_runz00_14097); 
PROCEDURE_SET(BgL_mainz00_14098, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11902)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14099;
BgL_objz00_14099 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14097, BgL_objz00_14099); BgL_objz00_14099; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3336z00_14100;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3337z00_14101;
BgL_arg3337z00_14101 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11900))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14102;
BgL_newz00_14102 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25111;
BgL_tmpz00_25111 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14102, BgL_tmpz00_25111, BgL_arg3337z00_14101); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25116;int BgL_tmpz00_25114;
BgL_auxz00_25116 = 
BINT(BgL_siza7ezd2framez75_11902); 
BgL_tmpz00_25114 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14102, BgL_tmpz00_25114, BgL_auxz00_25116); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25119;
BgL_tmpz00_25119 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14102, BgL_tmpz00_25119, BgL_runz00_14097); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25124;int BgL_tmpz00_25122;
BgL_auxz00_25124 = 
BINT(((long)2)); 
BgL_tmpz00_25122 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14102, BgL_tmpz00_25122, BgL_auxz00_25124); } 
BgL_arg3336z00_14100 = BgL_newz00_14102; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14098, BgL_arg3336z00_14100); BgL_arg3336z00_14100; } 
return BgL_mainz00_14098;} } } } } } 

}



/* &main5186 */
obj_t BGl_z62main5186z62zz__evaluate_compz00(obj_t BgL_envz00_11904, obj_t BgL_cz00_11909, obj_t BgL_dz00_11910)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11907;long BgL_siza7ezd2framez75_11908;
BgL_runz00_11907 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11904, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11908 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11904, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14103;
BgL_sz00_14103 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14104;
BgL_bpz00_14104 = 
VECTOR_REF(
((obj_t)BgL_sz00_14103),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14103, BgL_bpz00_14104, 
BINT(BgL_siza7ezd2framez75_11908)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3340z00_14105;
BgL_arg3340z00_14105 = 
(
(long)CINT(BgL_bpz00_14104)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14103),BgL_arg3340z00_14105,BgL_cz00_11909); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3341z00_14106;
BgL_arg3341z00_14106 = 
(
(long)CINT(BgL_bpz00_14104)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14103),BgL_arg3341z00_14106,BgL_dz00_11910); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14107;
BgL_ez00_14107 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14107, BgL_bpz00_14104); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14108;
BgL_accz00_14108 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11907, BgL_sz00_14103, BgL_bpz00_14104); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14107); 
VECTOR_SET(
((obj_t)BgL_sz00_14103),((long)0),BgL_bpz00_14104); 
return BgL_accz00_14108;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14109;
BgL_nsz00_14109 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14109,((long)1),BgL_sz00_14103); 
VECTOR_SET(BgL_nsz00_14109,((long)2),BgL_cz00_11909); 
VECTOR_SET(BgL_nsz00_14109,((long)3),BgL_dz00_11910); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14110;
BgL_z12denvz12_14110 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14110, BgL_nsz00_14109); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14111;
BgL_ez00_14111 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14111, BgL_sz00_14103); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14112;
BgL_____rz00_14112 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11907, BgL_nsz00_14109, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14111); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14110, BgL_sz00_14103); 
return BgL_____rz00_14112;} } } } } } } } 

}



/* &run5187 */
obj_t BGl_z62run5187z62zz__evaluate_compz00(obj_t BgL_envz00_11911, obj_t BgL_sz00_11914)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11912;obj_t BgL_bodyz00_11913;
BgL_i1243z00_11912 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11911, 
(int)(((long)0)))); 
BgL_bodyz00_11913 = 
PROCEDURE_REF(BgL_envz00_11911, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14113;
BgL_bpz00_14113 = 
VECTOR_REF(
((obj_t)BgL_sz00_11914),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14114;obj_t BgL_wherez00_14115;obj_t BgL_locz00_14116;
BgL_z12denvz12_14114 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14115 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11912))->BgL_wherez00); 
BgL_locz00_14116 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11912))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14114, BgL_wherez00_14115, BgL_locz00_14116); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14117;
BgL_za2za2resza2za2z00_14117 = 
PROCEDURE_ENTRY(BgL_bodyz00_11913)(BgL_bodyz00_11913, BgL_sz00_11914, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14114); 
return BgL_za2za2resza2za2z00_14117;} } } } } } 

}



/* &<@anonymous:3343> */
obj_t BGl_z62zc3z04anonymousza33343ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11915, obj_t BgL_sz00_11920)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11916;BgL_ev_absz00_bglt BgL_i1243z00_11917;obj_t BgL_bodyz00_11918;long BgL_siza7ezd2framez75_11919;
BgL_iboxesz00_11916 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11915, 
(int)(((long)0)))); 
BgL_i1243z00_11917 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11915, 
(int)(((long)1)))); 
BgL_bodyz00_11918 = 
PROCEDURE_REF(BgL_envz00_11915, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_11919 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11915, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14118;
BgL_bpz00_14118 = 
VECTOR_REF(
((obj_t)BgL_sz00_11920),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14119;
BgL_runz00_14119 = 
MAKE_FX_PROCEDURE(BGl_z62run5189z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14119, 
(int)(((long)0)), BgL_iboxesz00_11916); 
PROCEDURE_SET(BgL_runz00_14119, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11917)); 
PROCEDURE_SET(BgL_runz00_14119, 
(int)(((long)2)), BgL_bodyz00_11918); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14120;
BgL_mainz00_14120 = 
MAKE_FX_PROCEDURE(BGl_z62main5188z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14120, 
(int)(((long)0)), BgL_iboxesz00_11916); 
PROCEDURE_SET(BgL_mainz00_14120, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11917)); 
PROCEDURE_SET(BgL_mainz00_14120, 
(int)(((long)2)), BgL_bodyz00_11918); 
PROCEDURE_SET(BgL_mainz00_14120, 
(int)(((long)3)), BgL_runz00_14119); 
PROCEDURE_SET(BgL_mainz00_14120, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_11919)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14121;
BgL_objz00_14121 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14119, BgL_objz00_14121); BgL_objz00_14121; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3344z00_14122;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3345z00_14123;
BgL_arg3345z00_14123 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11917))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14124;
BgL_newz00_14124 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25224;
BgL_tmpz00_25224 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14124, BgL_tmpz00_25224, BgL_arg3345z00_14123); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25229;int BgL_tmpz00_25227;
BgL_auxz00_25229 = 
BINT(BgL_siza7ezd2framez75_11919); 
BgL_tmpz00_25227 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14124, BgL_tmpz00_25227, BgL_auxz00_25229); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25232;
BgL_tmpz00_25232 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14124, BgL_tmpz00_25232, BgL_runz00_14119); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25237;int BgL_tmpz00_25235;
BgL_auxz00_25237 = 
BINT(((long)2)); 
BgL_tmpz00_25235 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14124, BgL_tmpz00_25235, BgL_auxz00_25237); } 
BgL_arg3344z00_14122 = BgL_newz00_14124; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14120, BgL_arg3344z00_14122); BgL_arg3344z00_14122; } 
return BgL_mainz00_14120;} } } } } } 

}



/* &main5188 */
obj_t BGl_z62main5188z62zz__evaluate_compz00(obj_t BgL_envz00_11921, obj_t BgL_cz00_11927, obj_t BgL_dz00_11928)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11925;long BgL_siza7ezd2framez75_11926;
BgL_runz00_11925 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11921, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_11926 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11921, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14125;
BgL_sz00_14125 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14126;
BgL_bpz00_14126 = 
VECTOR_REF(
((obj_t)BgL_sz00_14125),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14125, BgL_bpz00_14126, 
BINT(BgL_siza7ezd2framez75_11926)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3348z00_14127;
BgL_arg3348z00_14127 = 
(
(long)CINT(BgL_bpz00_14126)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14125),BgL_arg3348z00_14127,BgL_cz00_11927); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3349z00_14128;
BgL_arg3349z00_14128 = 
(
(long)CINT(BgL_bpz00_14126)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14125),BgL_arg3349z00_14128,BgL_dz00_11928); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14129;
BgL_ez00_14129 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14129, BgL_bpz00_14126); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14130;
BgL_accz00_14130 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11925, BgL_sz00_14125, BgL_bpz00_14126); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14129); 
VECTOR_SET(
((obj_t)BgL_sz00_14125),((long)0),BgL_bpz00_14126); 
return BgL_accz00_14130;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14131;
BgL_nsz00_14131 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14131,((long)1),BgL_sz00_14125); 
VECTOR_SET(BgL_nsz00_14131,((long)2),BgL_cz00_11927); 
VECTOR_SET(BgL_nsz00_14131,((long)3),BgL_dz00_11928); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14132;
BgL_z12denvz12_14132 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14132, BgL_nsz00_14131); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14133;
BgL_ez00_14133 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14133, BgL_sz00_14125); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14134;
BgL_____rz00_14134 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11925, BgL_nsz00_14131, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14133); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14132, BgL_sz00_14125); 
return BgL_____rz00_14134;} } } } } } } } 

}



/* &run5189 */
obj_t BGl_z62run5189z62zz__evaluate_compz00(obj_t BgL_envz00_11929, obj_t BgL_sz00_11933)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11930;BgL_ev_absz00_bglt BgL_i1243z00_11931;obj_t BgL_bodyz00_11932;
BgL_iboxesz00_11930 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11929, 
(int)(((long)0)))); 
BgL_i1243z00_11931 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11929, 
(int)(((long)1)))); 
BgL_bodyz00_11932 = 
PROCEDURE_REF(BgL_envz00_11929, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14135;
BgL_bpz00_14135 = 
VECTOR_REF(
((obj_t)BgL_sz00_11933),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11933, BgL_iboxesz00_11930, BgL_bpz00_14135); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14136;obj_t BgL_wherez00_14137;obj_t BgL_locz00_14138;
BgL_z12denvz12_14136 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14137 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11931))->BgL_wherez00); 
BgL_locz00_14138 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11931))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14136, BgL_wherez00_14137, BgL_locz00_14138); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14139;
BgL_za2za2resza2za2z00_14139 = 
PROCEDURE_ENTRY(BgL_bodyz00_11932)(BgL_bodyz00_11932, BgL_sz00_11933, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14136); 
return BgL_za2za2resza2za2z00_14139;} } } } } } 

}



/* &<@anonymous:3354> */
obj_t BGl_z62zc3z04anonymousza33354ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11934, obj_t BgL_sz00_11940)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11935;long BgL_siza7eza7_11936;BgL_ev_absz00_bglt BgL_i1243z00_11937;obj_t BgL_bodyz00_11938;long BgL_siza7ezd2framez75_11939;
BgL_ifreesz00_11935 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11934, 
(int)(((long)0)))); 
BgL_siza7eza7_11936 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11934, 
(int)(((long)1)))); 
BgL_i1243z00_11937 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11934, 
(int)(((long)2)))); 
BgL_bodyz00_11938 = 
PROCEDURE_REF(BgL_envz00_11934, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_11939 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11934, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14140;
BgL_bpz00_14140 = 
VECTOR_REF(
((obj_t)BgL_sz00_11940),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14141;
BgL_valza2za2_14141 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11940, BgL_bpz00_14140, BgL_ifreesz00_11935); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14142;
BgL_runz00_14142 = 
MAKE_FX_PROCEDURE(BGl_z62run5191z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14142, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11936)); 
PROCEDURE_SET(BgL_runz00_14142, 
(int)(((long)1)), BgL_valza2za2_14141); 
PROCEDURE_SET(BgL_runz00_14142, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11937)); 
PROCEDURE_SET(BgL_runz00_14142, 
(int)(((long)3)), BgL_bodyz00_11938); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14143;
BgL_mainz00_14143 = 
MAKE_FX_PROCEDURE(BGl_z62main5190z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14143, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_11936)); 
PROCEDURE_SET(BgL_mainz00_14143, 
(int)(((long)1)), BgL_valza2za2_14141); 
PROCEDURE_SET(BgL_mainz00_14143, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_11937)); 
PROCEDURE_SET(BgL_mainz00_14143, 
(int)(((long)3)), BgL_bodyz00_11938); 
PROCEDURE_SET(BgL_mainz00_14143, 
(int)(((long)4)), BgL_runz00_14142); 
PROCEDURE_SET(BgL_mainz00_14143, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_11939)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14144;
BgL_objz00_14144 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14142, BgL_objz00_14144); BgL_objz00_14144; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3355z00_14145;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3356z00_14146;
BgL_arg3356z00_14146 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11937))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14147;
BgL_newz00_14147 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25351;
BgL_tmpz00_25351 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14147, BgL_tmpz00_25351, BgL_arg3356z00_14146); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25356;int BgL_tmpz00_25354;
BgL_auxz00_25356 = 
BINT(BgL_siza7ezd2framez75_11939); 
BgL_tmpz00_25354 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14147, BgL_tmpz00_25354, BgL_auxz00_25356); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25359;
BgL_tmpz00_25359 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14147, BgL_tmpz00_25359, BgL_runz00_14142); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25364;int BgL_tmpz00_25362;
BgL_auxz00_25364 = 
BINT(((long)2)); 
BgL_tmpz00_25362 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14147, BgL_tmpz00_25362, BgL_auxz00_25364); } 
BgL_arg3355z00_14145 = BgL_newz00_14147; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14143, BgL_arg3355z00_14145); BgL_arg3355z00_14145; } 
return BgL_mainz00_14143;} } } } } } 

}



/* &main5190 */
obj_t BGl_z62main5190z62zz__evaluate_compz00(obj_t BgL_envz00_11941, obj_t BgL_cz00_11948, obj_t BgL_dz00_11949)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11946;long BgL_siza7ezd2framez75_11947;
BgL_runz00_11946 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11941, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_11947 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11941, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14148;
BgL_sz00_14148 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14149;
BgL_bpz00_14149 = 
VECTOR_REF(
((obj_t)BgL_sz00_14148),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14148, BgL_bpz00_14149, 
BINT(BgL_siza7ezd2framez75_11947)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3359z00_14150;
BgL_arg3359z00_14150 = 
(
(long)CINT(BgL_bpz00_14149)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14148),BgL_arg3359z00_14150,BgL_cz00_11948); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3360z00_14151;
BgL_arg3360z00_14151 = 
(
(long)CINT(BgL_bpz00_14149)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14148),BgL_arg3360z00_14151,BgL_dz00_11949); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14152;
BgL_ez00_14152 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14152, BgL_bpz00_14149); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14153;
BgL_accz00_14153 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11946, BgL_sz00_14148, BgL_bpz00_14149); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14152); 
VECTOR_SET(
((obj_t)BgL_sz00_14148),((long)0),BgL_bpz00_14149); 
return BgL_accz00_14153;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14154;
BgL_nsz00_14154 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14154,((long)1),BgL_sz00_14148); 
VECTOR_SET(BgL_nsz00_14154,((long)2),BgL_cz00_11948); 
VECTOR_SET(BgL_nsz00_14154,((long)3),BgL_dz00_11949); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14155;
BgL_z12denvz12_14155 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14155, BgL_nsz00_14154); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14156;
BgL_ez00_14156 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14156, BgL_sz00_14148); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14157;
BgL_____rz00_14157 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11946, BgL_nsz00_14154, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14156); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14155, BgL_sz00_14148); 
return BgL_____rz00_14157;} } } } } } } } 

}



/* &run5191 */
obj_t BGl_z62run5191z62zz__evaluate_compz00(obj_t BgL_envz00_11950, obj_t BgL_sz00_11955)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_11951;obj_t BgL_valza2za2_11952;BgL_ev_absz00_bglt BgL_i1243z00_11953;obj_t BgL_bodyz00_11954;
BgL_siza7eza7_11951 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11950, 
(int)(((long)0)))); 
BgL_valza2za2_11952 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11950, 
(int)(((long)1)))); 
BgL_i1243z00_11953 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11950, 
(int)(((long)2)))); 
BgL_bodyz00_11954 = 
PROCEDURE_REF(BgL_envz00_11950, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14158;
BgL_bpz00_14158 = 
VECTOR_REF(
((obj_t)BgL_sz00_11955),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11955, BgL_valza2za2_11952, 
(
(long)CINT(BgL_bpz00_14158)+BgL_siza7eza7_11951)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14159;obj_t BgL_wherez00_14160;obj_t BgL_locz00_14161;
BgL_z12denvz12_14159 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14160 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11953))->BgL_wherez00); 
BgL_locz00_14161 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11953))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14159, BgL_wherez00_14160, BgL_locz00_14161); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14162;
BgL_za2za2resza2za2z00_14162 = 
PROCEDURE_ENTRY(BgL_bodyz00_11954)(BgL_bodyz00_11954, BgL_sz00_11955, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14159); 
return BgL_za2za2resza2za2z00_14162;} } } } } } 

}



/* &<@anonymous:3363> */
obj_t BGl_z62zc3z04anonymousza33363ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11956, obj_t BgL_sz00_11963)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_11957;obj_t BgL_iboxesz00_11958;long BgL_siza7eza7_11959;BgL_ev_absz00_bglt BgL_i1243z00_11960;obj_t BgL_bodyz00_11961;long BgL_siza7ezd2framez75_11962;
BgL_ifreesz00_11957 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11956, 
(int)(((long)0)))); 
BgL_iboxesz00_11958 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11956, 
(int)(((long)1)))); 
BgL_siza7eza7_11959 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11956, 
(int)(((long)2)))); 
BgL_i1243z00_11960 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11956, 
(int)(((long)3)))); 
BgL_bodyz00_11961 = 
PROCEDURE_REF(BgL_envz00_11956, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_11962 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11956, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14163;
BgL_bpz00_14163 = 
VECTOR_REF(
((obj_t)BgL_sz00_11963),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14164;
BgL_valza2za2_14164 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_11963, BgL_bpz00_14163, BgL_ifreesz00_11957); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14165;
BgL_runz00_14165 = 
MAKE_FX_PROCEDURE(BGl_z62run5193z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14165, 
(int)(((long)0)), BgL_iboxesz00_11958); 
PROCEDURE_SET(BgL_runz00_14165, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11959)); 
PROCEDURE_SET(BgL_runz00_14165, 
(int)(((long)2)), BgL_valza2za2_14164); 
PROCEDURE_SET(BgL_runz00_14165, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11960)); 
PROCEDURE_SET(BgL_runz00_14165, 
(int)(((long)4)), BgL_bodyz00_11961); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14166;
BgL_mainz00_14166 = 
MAKE_FX_PROCEDURE(BGl_z62main5192z62zz__evaluate_compz00, 
(int)(((long)2)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14166, 
(int)(((long)0)), BgL_iboxesz00_11958); 
PROCEDURE_SET(BgL_mainz00_14166, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_11959)); 
PROCEDURE_SET(BgL_mainz00_14166, 
(int)(((long)2)), BgL_valza2za2_14164); 
PROCEDURE_SET(BgL_mainz00_14166, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_11960)); 
PROCEDURE_SET(BgL_mainz00_14166, 
(int)(((long)4)), BgL_bodyz00_11961); 
PROCEDURE_SET(BgL_mainz00_14166, 
(int)(((long)5)), BgL_runz00_14165); 
PROCEDURE_SET(BgL_mainz00_14166, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_11962)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14167;
BgL_objz00_14167 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14165, BgL_objz00_14167); BgL_objz00_14167; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3364z00_14168;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3365z00_14169;
BgL_arg3365z00_14169 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11960))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14170;
BgL_newz00_14170 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25490;
BgL_tmpz00_25490 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14170, BgL_tmpz00_25490, BgL_arg3365z00_14169); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25495;int BgL_tmpz00_25493;
BgL_auxz00_25495 = 
BINT(BgL_siza7ezd2framez75_11962); 
BgL_tmpz00_25493 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14170, BgL_tmpz00_25493, BgL_auxz00_25495); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25498;
BgL_tmpz00_25498 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14170, BgL_tmpz00_25498, BgL_runz00_14165); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25503;int BgL_tmpz00_25501;
BgL_auxz00_25503 = 
BINT(((long)2)); 
BgL_tmpz00_25501 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14170, BgL_tmpz00_25501, BgL_auxz00_25503); } 
BgL_arg3364z00_14168 = BgL_newz00_14170; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14166, BgL_arg3364z00_14168); BgL_arg3364z00_14168; } 
return BgL_mainz00_14166;} } } } } } 

}



/* &main5192 */
obj_t BGl_z62main5192z62zz__evaluate_compz00(obj_t BgL_envz00_11964, obj_t BgL_cz00_11972, obj_t BgL_dz00_11973)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11970;long BgL_siza7ezd2framez75_11971;
BgL_runz00_11970 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11964, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_11971 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11964, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14171;
BgL_sz00_14171 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14172;
BgL_bpz00_14172 = 
VECTOR_REF(
((obj_t)BgL_sz00_14171),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14171, BgL_bpz00_14172, 
BINT(BgL_siza7ezd2framez75_11971)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3368z00_14173;
BgL_arg3368z00_14173 = 
(
(long)CINT(BgL_bpz00_14172)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14171),BgL_arg3368z00_14173,BgL_cz00_11972); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3369z00_14174;
BgL_arg3369z00_14174 = 
(
(long)CINT(BgL_bpz00_14172)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14171),BgL_arg3369z00_14174,BgL_dz00_11973); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14175;
BgL_ez00_14175 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14175, BgL_bpz00_14172); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14176;
BgL_accz00_14176 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11970, BgL_sz00_14171, BgL_bpz00_14172); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14175); 
VECTOR_SET(
((obj_t)BgL_sz00_14171),((long)0),BgL_bpz00_14172); 
return BgL_accz00_14176;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14177;
BgL_nsz00_14177 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14177,((long)1),BgL_sz00_14171); 
VECTOR_SET(BgL_nsz00_14177,((long)2),BgL_cz00_11972); 
VECTOR_SET(BgL_nsz00_14177,((long)3),BgL_dz00_11973); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14178;
BgL_z12denvz12_14178 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14178, BgL_nsz00_14177); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14179;
BgL_ez00_14179 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14179, BgL_sz00_14171); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14180;
BgL_____rz00_14180 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11970, BgL_nsz00_14177, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14179); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14178, BgL_sz00_14171); 
return BgL_____rz00_14180;} } } } } } } } 

}



/* &run5193 */
obj_t BGl_z62run5193z62zz__evaluate_compz00(obj_t BgL_envz00_11974, obj_t BgL_sz00_11980)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11975;long BgL_siza7eza7_11976;obj_t BgL_valza2za2_11977;BgL_ev_absz00_bglt BgL_i1243z00_11978;obj_t BgL_bodyz00_11979;
BgL_iboxesz00_11975 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11974, 
(int)(((long)0)))); 
BgL_siza7eza7_11976 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11974, 
(int)(((long)1)))); 
BgL_valza2za2_11977 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11974, 
(int)(((long)2)))); 
BgL_i1243z00_11978 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11974, 
(int)(((long)3)))); 
BgL_bodyz00_11979 = 
PROCEDURE_REF(BgL_envz00_11974, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14181;
BgL_bpz00_14181 = 
VECTOR_REF(
((obj_t)BgL_sz00_11980),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_11980, BgL_iboxesz00_11975, BgL_bpz00_14181); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_11980, BgL_valza2za2_11977, 
(
(long)CINT(BgL_bpz00_14181)+BgL_siza7eza7_11976)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14182;obj_t BgL_wherez00_14183;obj_t BgL_locz00_14184;
BgL_z12denvz12_14182 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14183 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11978))->BgL_wherez00); 
BgL_locz00_14184 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11978))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14182, BgL_wherez00_14183, BgL_locz00_14184); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14185;
BgL_za2za2resza2za2z00_14185 = 
PROCEDURE_ENTRY(BgL_bodyz00_11979)(BgL_bodyz00_11979, BgL_sz00_11980, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14182); 
return BgL_za2za2resza2za2z00_14185;} } } } } } 

}



/* &<@anonymous:3292> */
obj_t BGl_z62zc3z04anonymousza33292ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11981, obj_t BgL_sz00_11985)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11982;obj_t BgL_bodyz00_11983;long BgL_siza7ezd2framez75_11984;
BgL_i1243z00_11982 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11981, 
(int)(((long)0)))); 
BgL_bodyz00_11983 = 
PROCEDURE_REF(BgL_envz00_11981, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_11984 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11981, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14186;
BgL_bpz00_14186 = 
VECTOR_REF(
((obj_t)BgL_sz00_11985),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14187;
BgL_runz00_14187 = 
MAKE_FX_PROCEDURE(BGl_z62run5195z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14187, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11982)); 
PROCEDURE_SET(BgL_runz00_14187, 
(int)(((long)1)), BgL_bodyz00_11983); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14188;
BgL_mainz00_14188 = 
MAKE_VA_PROCEDURE(BGl_z62main5194z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14188, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_11982)); 
PROCEDURE_SET(BgL_mainz00_14188, 
(int)(((long)1)), BgL_bodyz00_11983); 
PROCEDURE_SET(BgL_mainz00_14188, 
(int)(((long)2)), BgL_runz00_14187); 
PROCEDURE_SET(BgL_mainz00_14188, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_11984)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14189;
BgL_objz00_14189 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14187, BgL_objz00_14189); BgL_objz00_14189; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3293z00_14190;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3294z00_14191;
BgL_arg3294z00_14191 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11982))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14192;
BgL_newz00_14192 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25609;
BgL_tmpz00_25609 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14192, BgL_tmpz00_25609, BgL_arg3294z00_14191); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25614;int BgL_tmpz00_25612;
BgL_auxz00_25614 = 
BINT(BgL_siza7ezd2framez75_11984); 
BgL_tmpz00_25612 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14192, BgL_tmpz00_25612, BgL_auxz00_25614); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25617;
BgL_tmpz00_25617 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14192, BgL_tmpz00_25617, BgL_runz00_14187); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25622;int BgL_tmpz00_25620;
BgL_auxz00_25622 = 
BINT(((long)-2)); 
BgL_tmpz00_25620 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14192, BgL_tmpz00_25620, BgL_auxz00_25622); } 
BgL_arg3293z00_14190 = BgL_newz00_14192; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14188, BgL_arg3293z00_14190); BgL_arg3293z00_14190; } 
return BgL_mainz00_14188;} } } } } } 

}



/* &main5194 */
obj_t BGl_z62main5194z62zz__evaluate_compz00(obj_t BgL_envz00_11986, obj_t BgL_dz00_11991, obj_t BgL_lastz00_11992)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_11989;long BgL_siza7ezd2framez75_11990;
BgL_runz00_11989 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11986, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_11990 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11986, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14193;
BgL_sz00_14193 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14194;
BgL_bpz00_14194 = 
VECTOR_REF(
((obj_t)BgL_sz00_14193),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14193, BgL_bpz00_14194, 
BINT(BgL_siza7ezd2framez75_11990)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3297z00_14195;
BgL_arg3297z00_14195 = 
(
(long)CINT(BgL_bpz00_14194)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14193),BgL_arg3297z00_14195,BgL_dz00_11991); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3298z00_14196;
BgL_arg3298z00_14196 = 
(
(long)CINT(BgL_bpz00_14194)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14193),BgL_arg3298z00_14196,BgL_lastz00_11992); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14197;
BgL_ez00_14197 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14197, BgL_bpz00_14194); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14198;
BgL_accz00_14198 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11989, BgL_sz00_14193, BgL_bpz00_14194); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14197); 
VECTOR_SET(
((obj_t)BgL_sz00_14193),((long)0),BgL_bpz00_14194); 
return BgL_accz00_14198;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14199;
BgL_nsz00_14199 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14199,((long)1),BgL_sz00_14193); 
VECTOR_SET(BgL_nsz00_14199,((long)2),BgL_dz00_11991); 
VECTOR_SET(BgL_nsz00_14199,((long)3),BgL_lastz00_11992); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14200;
BgL_z12denvz12_14200 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14200, BgL_nsz00_14199); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14201;
BgL_ez00_14201 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14201, BgL_sz00_14193); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14202;
BgL_____rz00_14202 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_11989, BgL_nsz00_14199, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14201); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14200, BgL_sz00_14193); 
return BgL_____rz00_14202;} } } } } } } } 

}



/* &run5195 */
obj_t BGl_z62run5195z62zz__evaluate_compz00(obj_t BgL_envz00_11993, obj_t BgL_sz00_11996)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_11994;obj_t BgL_bodyz00_11995;
BgL_i1243z00_11994 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11993, 
(int)(((long)0)))); 
BgL_bodyz00_11995 = 
PROCEDURE_REF(BgL_envz00_11993, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14203;
BgL_bpz00_14203 = 
VECTOR_REF(
((obj_t)BgL_sz00_11996),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14204;obj_t BgL_wherez00_14205;obj_t BgL_locz00_14206;
BgL_z12denvz12_14204 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14205 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11994))->BgL_wherez00); 
BgL_locz00_14206 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11994))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14204, BgL_wherez00_14205, BgL_locz00_14206); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14207;
BgL_za2za2resza2za2z00_14207 = 
PROCEDURE_ENTRY(BgL_bodyz00_11995)(BgL_bodyz00_11995, BgL_sz00_11996, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14204); 
return BgL_za2za2resza2za2z00_14207;} } } } } } 

}



/* &<@anonymous:3300> */
obj_t BGl_z62zc3z04anonymousza33300ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_11997, obj_t BgL_sz00_12002)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_11998;BgL_ev_absz00_bglt BgL_i1243z00_11999;obj_t BgL_bodyz00_12000;long BgL_siza7ezd2framez75_12001;
BgL_iboxesz00_11998 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_11997, 
(int)(((long)0)))); 
BgL_i1243z00_11999 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_11997, 
(int)(((long)1)))); 
BgL_bodyz00_12000 = 
PROCEDURE_REF(BgL_envz00_11997, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12001 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_11997, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14208;
BgL_bpz00_14208 = 
VECTOR_REF(
((obj_t)BgL_sz00_12002),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14209;
BgL_runz00_14209 = 
MAKE_FX_PROCEDURE(BGl_z62run5197z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14209, 
(int)(((long)0)), BgL_iboxesz00_11998); 
PROCEDURE_SET(BgL_runz00_14209, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11999)); 
PROCEDURE_SET(BgL_runz00_14209, 
(int)(((long)2)), BgL_bodyz00_12000); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14210;
BgL_mainz00_14210 = 
MAKE_VA_PROCEDURE(BGl_z62main5196z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14210, 
(int)(((long)0)), BgL_iboxesz00_11998); 
PROCEDURE_SET(BgL_mainz00_14210, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_11999)); 
PROCEDURE_SET(BgL_mainz00_14210, 
(int)(((long)2)), BgL_bodyz00_12000); 
PROCEDURE_SET(BgL_mainz00_14210, 
(int)(((long)3)), BgL_runz00_14209); 
PROCEDURE_SET(BgL_mainz00_14210, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12001)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14211;
BgL_objz00_14211 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14209, BgL_objz00_14211); BgL_objz00_14211; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3301z00_14212;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3302z00_14213;
BgL_arg3302z00_14213 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_11999))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14214;
BgL_newz00_14214 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25722;
BgL_tmpz00_25722 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14214, BgL_tmpz00_25722, BgL_arg3302z00_14213); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25727;int BgL_tmpz00_25725;
BgL_auxz00_25727 = 
BINT(BgL_siza7ezd2framez75_12001); 
BgL_tmpz00_25725 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14214, BgL_tmpz00_25725, BgL_auxz00_25727); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25730;
BgL_tmpz00_25730 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14214, BgL_tmpz00_25730, BgL_runz00_14209); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25735;int BgL_tmpz00_25733;
BgL_auxz00_25735 = 
BINT(((long)-2)); 
BgL_tmpz00_25733 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14214, BgL_tmpz00_25733, BgL_auxz00_25735); } 
BgL_arg3301z00_14212 = BgL_newz00_14214; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14210, BgL_arg3301z00_14212); BgL_arg3301z00_14212; } 
return BgL_mainz00_14210;} } } } } } 

}



/* &main5196 */
obj_t BGl_z62main5196z62zz__evaluate_compz00(obj_t BgL_envz00_12003, obj_t BgL_dz00_12009, obj_t BgL_lastz00_12010)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12007;long BgL_siza7ezd2framez75_12008;
BgL_runz00_12007 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12003, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12008 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12003, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14215;
BgL_sz00_14215 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14216;
BgL_bpz00_14216 = 
VECTOR_REF(
((obj_t)BgL_sz00_14215),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14215, BgL_bpz00_14216, 
BINT(BgL_siza7ezd2framez75_12008)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3305z00_14217;
BgL_arg3305z00_14217 = 
(
(long)CINT(BgL_bpz00_14216)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14215),BgL_arg3305z00_14217,BgL_dz00_12009); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3306z00_14218;
BgL_arg3306z00_14218 = 
(
(long)CINT(BgL_bpz00_14216)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14215),BgL_arg3306z00_14218,BgL_lastz00_12010); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14219;
BgL_ez00_14219 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14219, BgL_bpz00_14216); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14220;
BgL_accz00_14220 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12007, BgL_sz00_14215, BgL_bpz00_14216); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14219); 
VECTOR_SET(
((obj_t)BgL_sz00_14215),((long)0),BgL_bpz00_14216); 
return BgL_accz00_14220;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14221;
BgL_nsz00_14221 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14221,((long)1),BgL_sz00_14215); 
VECTOR_SET(BgL_nsz00_14221,((long)2),BgL_dz00_12009); 
VECTOR_SET(BgL_nsz00_14221,((long)3),BgL_lastz00_12010); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14222;
BgL_z12denvz12_14222 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14222, BgL_nsz00_14221); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14223;
BgL_ez00_14223 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14223, BgL_sz00_14215); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14224;
BgL_____rz00_14224 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12007, BgL_nsz00_14221, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14223); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14222, BgL_sz00_14215); 
return BgL_____rz00_14224;} } } } } } } } 

}



/* &run5197 */
obj_t BGl_z62run5197z62zz__evaluate_compz00(obj_t BgL_envz00_12011, obj_t BgL_sz00_12015)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12012;BgL_ev_absz00_bglt BgL_i1243z00_12013;obj_t BgL_bodyz00_12014;
BgL_iboxesz00_12012 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12011, 
(int)(((long)0)))); 
BgL_i1243z00_12013 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12011, 
(int)(((long)1)))); 
BgL_bodyz00_12014 = 
PROCEDURE_REF(BgL_envz00_12011, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14225;
BgL_bpz00_14225 = 
VECTOR_REF(
((obj_t)BgL_sz00_12015),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12015, BgL_iboxesz00_12012, BgL_bpz00_14225); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14226;obj_t BgL_wherez00_14227;obj_t BgL_locz00_14228;
BgL_z12denvz12_14226 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14227 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12013))->BgL_wherez00); 
BgL_locz00_14228 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12013))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14226, BgL_wherez00_14227, BgL_locz00_14228); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14229;
BgL_za2za2resza2za2z00_14229 = 
PROCEDURE_ENTRY(BgL_bodyz00_12014)(BgL_bodyz00_12014, BgL_sz00_12015, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14226); 
return BgL_za2za2resza2za2z00_14229;} } } } } } 

}



/* &<@anonymous:3311> */
obj_t BGl_z62zc3z04anonymousza33311ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12016, obj_t BgL_sz00_12022)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12017;long BgL_siza7eza7_12018;BgL_ev_absz00_bglt BgL_i1243z00_12019;obj_t BgL_bodyz00_12020;long BgL_siza7ezd2framez75_12021;
BgL_ifreesz00_12017 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12016, 
(int)(((long)0)))); 
BgL_siza7eza7_12018 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12016, 
(int)(((long)1)))); 
BgL_i1243z00_12019 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12016, 
(int)(((long)2)))); 
BgL_bodyz00_12020 = 
PROCEDURE_REF(BgL_envz00_12016, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12021 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12016, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14230;
BgL_bpz00_14230 = 
VECTOR_REF(
((obj_t)BgL_sz00_12022),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14231;
BgL_valza2za2_14231 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12022, BgL_bpz00_14230, BgL_ifreesz00_12017); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14232;
BgL_runz00_14232 = 
MAKE_FX_PROCEDURE(BGl_z62run5199z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14232, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12018)); 
PROCEDURE_SET(BgL_runz00_14232, 
(int)(((long)1)), BgL_valza2za2_14231); 
PROCEDURE_SET(BgL_runz00_14232, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12019)); 
PROCEDURE_SET(BgL_runz00_14232, 
(int)(((long)3)), BgL_bodyz00_12020); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14233;
BgL_mainz00_14233 = 
MAKE_VA_PROCEDURE(BGl_z62main5198z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14233, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12018)); 
PROCEDURE_SET(BgL_mainz00_14233, 
(int)(((long)1)), BgL_valza2za2_14231); 
PROCEDURE_SET(BgL_mainz00_14233, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12019)); 
PROCEDURE_SET(BgL_mainz00_14233, 
(int)(((long)3)), BgL_bodyz00_12020); 
PROCEDURE_SET(BgL_mainz00_14233, 
(int)(((long)4)), BgL_runz00_14232); 
PROCEDURE_SET(BgL_mainz00_14233, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12021)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14234;
BgL_objz00_14234 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14232, BgL_objz00_14234); BgL_objz00_14234; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3312z00_14235;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3313z00_14236;
BgL_arg3313z00_14236 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12019))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14237;
BgL_newz00_14237 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25849;
BgL_tmpz00_25849 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14237, BgL_tmpz00_25849, BgL_arg3313z00_14236); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25854;int BgL_tmpz00_25852;
BgL_auxz00_25854 = 
BINT(BgL_siza7ezd2framez75_12021); 
BgL_tmpz00_25852 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14237, BgL_tmpz00_25852, BgL_auxz00_25854); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25857;
BgL_tmpz00_25857 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14237, BgL_tmpz00_25857, BgL_runz00_14232); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25862;int BgL_tmpz00_25860;
BgL_auxz00_25862 = 
BINT(((long)-2)); 
BgL_tmpz00_25860 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14237, BgL_tmpz00_25860, BgL_auxz00_25862); } 
BgL_arg3312z00_14235 = BgL_newz00_14237; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14233, BgL_arg3312z00_14235); BgL_arg3312z00_14235; } 
return BgL_mainz00_14233;} } } } } } 

}



/* &main5198 */
obj_t BGl_z62main5198z62zz__evaluate_compz00(obj_t BgL_envz00_12023, obj_t BgL_dz00_12030, obj_t BgL_lastz00_12031)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12028;long BgL_siza7ezd2framez75_12029;
BgL_runz00_12028 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12023, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12029 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12023, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14238;
BgL_sz00_14238 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14239;
BgL_bpz00_14239 = 
VECTOR_REF(
((obj_t)BgL_sz00_14238),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14238, BgL_bpz00_14239, 
BINT(BgL_siza7ezd2framez75_12029)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3316z00_14240;
BgL_arg3316z00_14240 = 
(
(long)CINT(BgL_bpz00_14239)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14238),BgL_arg3316z00_14240,BgL_dz00_12030); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3317z00_14241;
BgL_arg3317z00_14241 = 
(
(long)CINT(BgL_bpz00_14239)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14238),BgL_arg3317z00_14241,BgL_lastz00_12031); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14242;
BgL_ez00_14242 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14242, BgL_bpz00_14239); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14243;
BgL_accz00_14243 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12028, BgL_sz00_14238, BgL_bpz00_14239); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14242); 
VECTOR_SET(
((obj_t)BgL_sz00_14238),((long)0),BgL_bpz00_14239); 
return BgL_accz00_14243;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14244;
BgL_nsz00_14244 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14244,((long)1),BgL_sz00_14238); 
VECTOR_SET(BgL_nsz00_14244,((long)2),BgL_dz00_12030); 
VECTOR_SET(BgL_nsz00_14244,((long)3),BgL_lastz00_12031); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14245;
BgL_z12denvz12_14245 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14245, BgL_nsz00_14244); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14246;
BgL_ez00_14246 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14246, BgL_sz00_14238); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14247;
BgL_____rz00_14247 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12028, BgL_nsz00_14244, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14246); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14245, BgL_sz00_14238); 
return BgL_____rz00_14247;} } } } } } } } 

}



/* &run5199 */
obj_t BGl_z62run5199z62zz__evaluate_compz00(obj_t BgL_envz00_12032, obj_t BgL_sz00_12037)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12033;obj_t BgL_valza2za2_12034;BgL_ev_absz00_bglt BgL_i1243z00_12035;obj_t BgL_bodyz00_12036;
BgL_siza7eza7_12033 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12032, 
(int)(((long)0)))); 
BgL_valza2za2_12034 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12032, 
(int)(((long)1)))); 
BgL_i1243z00_12035 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12032, 
(int)(((long)2)))); 
BgL_bodyz00_12036 = 
PROCEDURE_REF(BgL_envz00_12032, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14248;
BgL_bpz00_14248 = 
VECTOR_REF(
((obj_t)BgL_sz00_12037),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12037, BgL_valza2za2_12034, 
(
(long)CINT(BgL_bpz00_14248)+BgL_siza7eza7_12033)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14249;obj_t BgL_wherez00_14250;obj_t BgL_locz00_14251;
BgL_z12denvz12_14249 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14250 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12035))->BgL_wherez00); 
BgL_locz00_14251 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12035))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14249, BgL_wherez00_14250, BgL_locz00_14251); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14252;
BgL_za2za2resza2za2z00_14252 = 
PROCEDURE_ENTRY(BgL_bodyz00_12036)(BgL_bodyz00_12036, BgL_sz00_12037, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14249); 
return BgL_za2za2resza2za2z00_14252;} } } } } } 

}



/* &<@anonymous:3320> */
obj_t BGl_z62zc3z04anonymousza33320ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12038, obj_t BgL_sz00_12045)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12039;obj_t BgL_iboxesz00_12040;long BgL_siza7eza7_12041;BgL_ev_absz00_bglt BgL_i1243z00_12042;obj_t BgL_bodyz00_12043;long BgL_siza7ezd2framez75_12044;
BgL_ifreesz00_12039 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12038, 
(int)(((long)0)))); 
BgL_iboxesz00_12040 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12038, 
(int)(((long)1)))); 
BgL_siza7eza7_12041 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12038, 
(int)(((long)2)))); 
BgL_i1243z00_12042 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12038, 
(int)(((long)3)))); 
BgL_bodyz00_12043 = 
PROCEDURE_REF(BgL_envz00_12038, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12044 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12038, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14253;
BgL_bpz00_14253 = 
VECTOR_REF(
((obj_t)BgL_sz00_12045),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14254;
BgL_valza2za2_14254 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12045, BgL_bpz00_14253, BgL_ifreesz00_12039); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14255;
BgL_runz00_14255 = 
MAKE_FX_PROCEDURE(BGl_z62run5201z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14255, 
(int)(((long)0)), BgL_iboxesz00_12040); 
PROCEDURE_SET(BgL_runz00_14255, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12041)); 
PROCEDURE_SET(BgL_runz00_14255, 
(int)(((long)2)), BgL_valza2za2_14254); 
PROCEDURE_SET(BgL_runz00_14255, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12042)); 
PROCEDURE_SET(BgL_runz00_14255, 
(int)(((long)4)), BgL_bodyz00_12043); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14256;
BgL_mainz00_14256 = 
MAKE_VA_PROCEDURE(BGl_z62main5200z62zz__evaluate_compz00, 
(int)(((long)-2)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14256, 
(int)(((long)0)), BgL_iboxesz00_12040); 
PROCEDURE_SET(BgL_mainz00_14256, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12041)); 
PROCEDURE_SET(BgL_mainz00_14256, 
(int)(((long)2)), BgL_valza2za2_14254); 
PROCEDURE_SET(BgL_mainz00_14256, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12042)); 
PROCEDURE_SET(BgL_mainz00_14256, 
(int)(((long)4)), BgL_bodyz00_12043); 
PROCEDURE_SET(BgL_mainz00_14256, 
(int)(((long)5)), BgL_runz00_14255); 
PROCEDURE_SET(BgL_mainz00_14256, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12044)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14257;
BgL_objz00_14257 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14255, BgL_objz00_14257); BgL_objz00_14257; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3321z00_14258;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3322z00_14259;
BgL_arg3322z00_14259 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12042))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14260;
BgL_newz00_14260 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25988;
BgL_tmpz00_25988 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14260, BgL_tmpz00_25988, BgL_arg3322z00_14259); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_25993;int BgL_tmpz00_25991;
BgL_auxz00_25993 = 
BINT(BgL_siza7ezd2framez75_12044); 
BgL_tmpz00_25991 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14260, BgL_tmpz00_25991, BgL_auxz00_25993); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_25996;
BgL_tmpz00_25996 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14260, BgL_tmpz00_25996, BgL_runz00_14255); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26001;int BgL_tmpz00_25999;
BgL_auxz00_26001 = 
BINT(((long)-2)); 
BgL_tmpz00_25999 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14260, BgL_tmpz00_25999, BgL_auxz00_26001); } 
BgL_arg3321z00_14258 = BgL_newz00_14260; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14256, BgL_arg3321z00_14258); BgL_arg3321z00_14258; } 
return BgL_mainz00_14256;} } } } } } 

}



/* &main5200 */
obj_t BGl_z62main5200z62zz__evaluate_compz00(obj_t BgL_envz00_12046, obj_t BgL_dz00_12054, obj_t BgL_lastz00_12055)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12052;long BgL_siza7ezd2framez75_12053;
BgL_runz00_12052 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12046, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12053 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12046, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14261;
BgL_sz00_14261 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14262;
BgL_bpz00_14262 = 
VECTOR_REF(
((obj_t)BgL_sz00_14261),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14261, BgL_bpz00_14262, 
BINT(BgL_siza7ezd2framez75_12053)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3325z00_14263;
BgL_arg3325z00_14263 = 
(
(long)CINT(BgL_bpz00_14262)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14261),BgL_arg3325z00_14263,BgL_dz00_12054); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3326z00_14264;
BgL_arg3326z00_14264 = 
(
(long)CINT(BgL_bpz00_14262)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14261),BgL_arg3326z00_14264,BgL_lastz00_12055); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14265;
BgL_ez00_14265 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14265, BgL_bpz00_14262); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14266;
BgL_accz00_14266 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12052, BgL_sz00_14261, BgL_bpz00_14262); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14265); 
VECTOR_SET(
((obj_t)BgL_sz00_14261),((long)0),BgL_bpz00_14262); 
return BgL_accz00_14266;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14267;
BgL_nsz00_14267 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14267,((long)1),BgL_sz00_14261); 
VECTOR_SET(BgL_nsz00_14267,((long)2),BgL_dz00_12054); 
VECTOR_SET(BgL_nsz00_14267,((long)3),BgL_lastz00_12055); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14268;
BgL_z12denvz12_14268 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14268, BgL_nsz00_14267); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14269;
BgL_ez00_14269 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14269, BgL_sz00_14261); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14270;
BgL_____rz00_14270 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12052, BgL_nsz00_14267, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14269); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14268, BgL_sz00_14261); 
return BgL_____rz00_14270;} } } } } } } } 

}



/* &run5201 */
obj_t BGl_z62run5201z62zz__evaluate_compz00(obj_t BgL_envz00_12056, obj_t BgL_sz00_12062)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12057;long BgL_siza7eza7_12058;obj_t BgL_valza2za2_12059;BgL_ev_absz00_bglt BgL_i1243z00_12060;obj_t BgL_bodyz00_12061;
BgL_iboxesz00_12057 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12056, 
(int)(((long)0)))); 
BgL_siza7eza7_12058 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12056, 
(int)(((long)1)))); 
BgL_valza2za2_12059 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12056, 
(int)(((long)2)))); 
BgL_i1243z00_12060 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12056, 
(int)(((long)3)))); 
BgL_bodyz00_12061 = 
PROCEDURE_REF(BgL_envz00_12056, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14271;
BgL_bpz00_14271 = 
VECTOR_REF(
((obj_t)BgL_sz00_12062),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12062, BgL_iboxesz00_12057, BgL_bpz00_14271); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12062, BgL_valza2za2_12059, 
(
(long)CINT(BgL_bpz00_14271)+BgL_siza7eza7_12058)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14272;obj_t BgL_wherez00_14273;obj_t BgL_locz00_14274;
BgL_z12denvz12_14272 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14273 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12060))->BgL_wherez00); 
BgL_locz00_14274 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12060))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14272, BgL_wherez00_14273, BgL_locz00_14274); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14275;
BgL_za2za2resza2za2z00_14275 = 
PROCEDURE_ENTRY(BgL_bodyz00_12061)(BgL_bodyz00_12061, BgL_sz00_12062, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14272); 
return BgL_za2za2resza2za2z00_14275;} } } } } } 

}



/* &<@anonymous:3253> */
obj_t BGl_z62zc3z04anonymousza33253ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12063, obj_t BgL_sz00_12067)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12064;obj_t BgL_bodyz00_12065;long BgL_siza7ezd2framez75_12066;
BgL_i1243z00_12064 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12063, 
(int)(((long)0)))); 
BgL_bodyz00_12065 = 
PROCEDURE_REF(BgL_envz00_12063, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12066 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12063, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14276;
BgL_bpz00_14276 = 
VECTOR_REF(
((obj_t)BgL_sz00_12067),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14277;
BgL_runz00_14277 = 
MAKE_FX_PROCEDURE(BGl_z62run5203z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14277, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12064)); 
PROCEDURE_SET(BgL_runz00_14277, 
(int)(((long)1)), BgL_bodyz00_12065); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14278;
BgL_mainz00_14278 = 
MAKE_FX_PROCEDURE(BGl_z62main5202z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14278, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12064)); 
PROCEDURE_SET(BgL_mainz00_14278, 
(int)(((long)1)), BgL_bodyz00_12065); 
PROCEDURE_SET(BgL_mainz00_14278, 
(int)(((long)2)), BgL_runz00_14277); 
PROCEDURE_SET(BgL_mainz00_14278, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12066)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14279;
BgL_objz00_14279 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14277, BgL_objz00_14279); BgL_objz00_14279; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3254z00_14280;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3255z00_14281;
BgL_arg3255z00_14281 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12064))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14282;
BgL_newz00_14282 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26107;
BgL_tmpz00_26107 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14282, BgL_tmpz00_26107, BgL_arg3255z00_14281); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26112;int BgL_tmpz00_26110;
BgL_auxz00_26112 = 
BINT(BgL_siza7ezd2framez75_12066); 
BgL_tmpz00_26110 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14282, BgL_tmpz00_26110, BgL_auxz00_26112); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26115;
BgL_tmpz00_26115 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14282, BgL_tmpz00_26115, BgL_runz00_14277); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26120;int BgL_tmpz00_26118;
BgL_auxz00_26120 = 
BINT(((long)1)); 
BgL_tmpz00_26118 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14282, BgL_tmpz00_26118, BgL_auxz00_26120); } 
BgL_arg3254z00_14280 = BgL_newz00_14282; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14278, BgL_arg3254z00_14280); BgL_arg3254z00_14280; } 
return BgL_mainz00_14278;} } } } } } 

}



/* &main5202 */
obj_t BGl_z62main5202z62zz__evaluate_compz00(obj_t BgL_envz00_12068, obj_t BgL_dz00_12073)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12071;long BgL_siza7ezd2framez75_12072;
BgL_runz00_12071 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12068, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12072 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12068, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14283;
BgL_sz00_14283 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14284;
BgL_bpz00_14284 = 
VECTOR_REF(
((obj_t)BgL_sz00_14283),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14283, BgL_bpz00_14284, 
BINT(BgL_siza7ezd2framez75_12072)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3258z00_14285;
BgL_arg3258z00_14285 = 
(
(long)CINT(BgL_bpz00_14284)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14283),BgL_arg3258z00_14285,BgL_dz00_12073); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14286;
BgL_ez00_14286 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14286, BgL_bpz00_14284); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14287;
BgL_accz00_14287 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12071, BgL_sz00_14283, BgL_bpz00_14284); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14286); 
VECTOR_SET(
((obj_t)BgL_sz00_14283),((long)0),BgL_bpz00_14284); 
return BgL_accz00_14287;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14288;
BgL_nsz00_14288 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14288,((long)1),BgL_sz00_14283); 
VECTOR_SET(BgL_nsz00_14288,((long)2),BgL_dz00_12073); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14289;
BgL_z12denvz12_14289 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14289, BgL_nsz00_14288); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14290;
BgL_ez00_14290 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14290, BgL_sz00_14283); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14291;
BgL_____rz00_14291 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12071, BgL_nsz00_14288, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14290); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14289, BgL_sz00_14283); 
return BgL_____rz00_14291;} } } } } } } } 

}



/* &run5203 */
obj_t BGl_z62run5203z62zz__evaluate_compz00(obj_t BgL_envz00_12074, obj_t BgL_sz00_12077)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12075;obj_t BgL_bodyz00_12076;
BgL_i1243z00_12075 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12074, 
(int)(((long)0)))); 
BgL_bodyz00_12076 = 
PROCEDURE_REF(BgL_envz00_12074, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14292;
BgL_bpz00_14292 = 
VECTOR_REF(
((obj_t)BgL_sz00_12077),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14293;obj_t BgL_wherez00_14294;obj_t BgL_locz00_14295;
BgL_z12denvz12_14293 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14294 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12075))->BgL_wherez00); 
BgL_locz00_14295 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12075))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14293, BgL_wherez00_14294, BgL_locz00_14295); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14296;
BgL_za2za2resza2za2z00_14296 = 
PROCEDURE_ENTRY(BgL_bodyz00_12076)(BgL_bodyz00_12076, BgL_sz00_12077, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14293); 
return BgL_za2za2resza2za2z00_14296;} } } } } } 

}



/* &<@anonymous:3260> */
obj_t BGl_z62zc3z04anonymousza33260ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12078, obj_t BgL_sz00_12083)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12079;BgL_ev_absz00_bglt BgL_i1243z00_12080;obj_t BgL_bodyz00_12081;long BgL_siza7ezd2framez75_12082;
BgL_iboxesz00_12079 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12078, 
(int)(((long)0)))); 
BgL_i1243z00_12080 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12078, 
(int)(((long)1)))); 
BgL_bodyz00_12081 = 
PROCEDURE_REF(BgL_envz00_12078, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12082 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12078, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14297;
BgL_bpz00_14297 = 
VECTOR_REF(
((obj_t)BgL_sz00_12083),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14298;
BgL_runz00_14298 = 
MAKE_FX_PROCEDURE(BGl_z62run5205z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14298, 
(int)(((long)0)), BgL_iboxesz00_12079); 
PROCEDURE_SET(BgL_runz00_14298, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12080)); 
PROCEDURE_SET(BgL_runz00_14298, 
(int)(((long)2)), BgL_bodyz00_12081); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14299;
BgL_mainz00_14299 = 
MAKE_FX_PROCEDURE(BGl_z62main5204z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14299, 
(int)(((long)0)), BgL_iboxesz00_12079); 
PROCEDURE_SET(BgL_mainz00_14299, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12080)); 
PROCEDURE_SET(BgL_mainz00_14299, 
(int)(((long)2)), BgL_bodyz00_12081); 
PROCEDURE_SET(BgL_mainz00_14299, 
(int)(((long)3)), BgL_runz00_14298); 
PROCEDURE_SET(BgL_mainz00_14299, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12082)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14300;
BgL_objz00_14300 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14298, BgL_objz00_14300); BgL_objz00_14300; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3261z00_14301;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3262z00_14302;
BgL_arg3262z00_14302 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12080))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14303;
BgL_newz00_14303 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26215;
BgL_tmpz00_26215 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14303, BgL_tmpz00_26215, BgL_arg3262z00_14302); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26220;int BgL_tmpz00_26218;
BgL_auxz00_26220 = 
BINT(BgL_siza7ezd2framez75_12082); 
BgL_tmpz00_26218 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14303, BgL_tmpz00_26218, BgL_auxz00_26220); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26223;
BgL_tmpz00_26223 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14303, BgL_tmpz00_26223, BgL_runz00_14298); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26228;int BgL_tmpz00_26226;
BgL_auxz00_26228 = 
BINT(((long)1)); 
BgL_tmpz00_26226 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14303, BgL_tmpz00_26226, BgL_auxz00_26228); } 
BgL_arg3261z00_14301 = BgL_newz00_14303; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14299, BgL_arg3261z00_14301); BgL_arg3261z00_14301; } 
return BgL_mainz00_14299;} } } } } } 

}



/* &main5204 */
obj_t BGl_z62main5204z62zz__evaluate_compz00(obj_t BgL_envz00_12084, obj_t BgL_dz00_12090)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12088;long BgL_siza7ezd2framez75_12089;
BgL_runz00_12088 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12084, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12089 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12084, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14304;
BgL_sz00_14304 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14305;
BgL_bpz00_14305 = 
VECTOR_REF(
((obj_t)BgL_sz00_14304),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14304, BgL_bpz00_14305, 
BINT(BgL_siza7ezd2framez75_12089)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3265z00_14306;
BgL_arg3265z00_14306 = 
(
(long)CINT(BgL_bpz00_14305)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14304),BgL_arg3265z00_14306,BgL_dz00_12090); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14307;
BgL_ez00_14307 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14307, BgL_bpz00_14305); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14308;
BgL_accz00_14308 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12088, BgL_sz00_14304, BgL_bpz00_14305); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14307); 
VECTOR_SET(
((obj_t)BgL_sz00_14304),((long)0),BgL_bpz00_14305); 
return BgL_accz00_14308;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14309;
BgL_nsz00_14309 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14309,((long)1),BgL_sz00_14304); 
VECTOR_SET(BgL_nsz00_14309,((long)2),BgL_dz00_12090); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14310;
BgL_z12denvz12_14310 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14310, BgL_nsz00_14309); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14311;
BgL_ez00_14311 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14311, BgL_sz00_14304); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14312;
BgL_____rz00_14312 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12088, BgL_nsz00_14309, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14311); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14310, BgL_sz00_14304); 
return BgL_____rz00_14312;} } } } } } } } 

}



/* &run5205 */
obj_t BGl_z62run5205z62zz__evaluate_compz00(obj_t BgL_envz00_12091, obj_t BgL_sz00_12095)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12092;BgL_ev_absz00_bglt BgL_i1243z00_12093;obj_t BgL_bodyz00_12094;
BgL_iboxesz00_12092 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12091, 
(int)(((long)0)))); 
BgL_i1243z00_12093 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12091, 
(int)(((long)1)))); 
BgL_bodyz00_12094 = 
PROCEDURE_REF(BgL_envz00_12091, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14313;
BgL_bpz00_14313 = 
VECTOR_REF(
((obj_t)BgL_sz00_12095),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12095, BgL_iboxesz00_12092, BgL_bpz00_14313); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14314;obj_t BgL_wherez00_14315;obj_t BgL_locz00_14316;
BgL_z12denvz12_14314 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14315 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12093))->BgL_wherez00); 
BgL_locz00_14316 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12093))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14314, BgL_wherez00_14315, BgL_locz00_14316); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14317;
BgL_za2za2resza2za2z00_14317 = 
PROCEDURE_ENTRY(BgL_bodyz00_12094)(BgL_bodyz00_12094, BgL_sz00_12095, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14314); 
return BgL_za2za2resza2za2z00_14317;} } } } } } 

}



/* &<@anonymous:3270> */
obj_t BGl_z62zc3z04anonymousza33270ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12096, obj_t BgL_sz00_12102)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12097;long BgL_siza7eza7_12098;BgL_ev_absz00_bglt BgL_i1243z00_12099;obj_t BgL_bodyz00_12100;long BgL_siza7ezd2framez75_12101;
BgL_ifreesz00_12097 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12096, 
(int)(((long)0)))); 
BgL_siza7eza7_12098 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12096, 
(int)(((long)1)))); 
BgL_i1243z00_12099 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12096, 
(int)(((long)2)))); 
BgL_bodyz00_12100 = 
PROCEDURE_REF(BgL_envz00_12096, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12101 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12096, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14318;
BgL_bpz00_14318 = 
VECTOR_REF(
((obj_t)BgL_sz00_12102),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14319;
BgL_valza2za2_14319 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12102, BgL_bpz00_14318, BgL_ifreesz00_12097); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14320;
BgL_runz00_14320 = 
MAKE_FX_PROCEDURE(BGl_z62run5207z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14320, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12098)); 
PROCEDURE_SET(BgL_runz00_14320, 
(int)(((long)1)), BgL_valza2za2_14319); 
PROCEDURE_SET(BgL_runz00_14320, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12099)); 
PROCEDURE_SET(BgL_runz00_14320, 
(int)(((long)3)), BgL_bodyz00_12100); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14321;
BgL_mainz00_14321 = 
MAKE_FX_PROCEDURE(BGl_z62main5206z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14321, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12098)); 
PROCEDURE_SET(BgL_mainz00_14321, 
(int)(((long)1)), BgL_valza2za2_14319); 
PROCEDURE_SET(BgL_mainz00_14321, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12099)); 
PROCEDURE_SET(BgL_mainz00_14321, 
(int)(((long)3)), BgL_bodyz00_12100); 
PROCEDURE_SET(BgL_mainz00_14321, 
(int)(((long)4)), BgL_runz00_14320); 
PROCEDURE_SET(BgL_mainz00_14321, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12101)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14322;
BgL_objz00_14322 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14320, BgL_objz00_14322); BgL_objz00_14322; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3271z00_14323;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3272z00_14324;
BgL_arg3272z00_14324 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12099))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14325;
BgL_newz00_14325 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26337;
BgL_tmpz00_26337 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14325, BgL_tmpz00_26337, BgL_arg3272z00_14324); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26342;int BgL_tmpz00_26340;
BgL_auxz00_26342 = 
BINT(BgL_siza7ezd2framez75_12101); 
BgL_tmpz00_26340 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14325, BgL_tmpz00_26340, BgL_auxz00_26342); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26345;
BgL_tmpz00_26345 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14325, BgL_tmpz00_26345, BgL_runz00_14320); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26350;int BgL_tmpz00_26348;
BgL_auxz00_26350 = 
BINT(((long)1)); 
BgL_tmpz00_26348 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14325, BgL_tmpz00_26348, BgL_auxz00_26350); } 
BgL_arg3271z00_14323 = BgL_newz00_14325; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14321, BgL_arg3271z00_14323); BgL_arg3271z00_14323; } 
return BgL_mainz00_14321;} } } } } } 

}



/* &main5206 */
obj_t BGl_z62main5206z62zz__evaluate_compz00(obj_t BgL_envz00_12103, obj_t BgL_dz00_12110)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12108;long BgL_siza7ezd2framez75_12109;
BgL_runz00_12108 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12103, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12109 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12103, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14326;
BgL_sz00_14326 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14327;
BgL_bpz00_14327 = 
VECTOR_REF(
((obj_t)BgL_sz00_14326),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14326, BgL_bpz00_14327, 
BINT(BgL_siza7ezd2framez75_12109)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3275z00_14328;
BgL_arg3275z00_14328 = 
(
(long)CINT(BgL_bpz00_14327)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14326),BgL_arg3275z00_14328,BgL_dz00_12110); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14329;
BgL_ez00_14329 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14329, BgL_bpz00_14327); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14330;
BgL_accz00_14330 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12108, BgL_sz00_14326, BgL_bpz00_14327); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14329); 
VECTOR_SET(
((obj_t)BgL_sz00_14326),((long)0),BgL_bpz00_14327); 
return BgL_accz00_14330;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14331;
BgL_nsz00_14331 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14331,((long)1),BgL_sz00_14326); 
VECTOR_SET(BgL_nsz00_14331,((long)2),BgL_dz00_12110); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14332;
BgL_z12denvz12_14332 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14332, BgL_nsz00_14331); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14333;
BgL_ez00_14333 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14333, BgL_sz00_14326); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14334;
BgL_____rz00_14334 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12108, BgL_nsz00_14331, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14333); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14332, BgL_sz00_14326); 
return BgL_____rz00_14334;} } } } } } } } 

}



/* &run5207 */
obj_t BGl_z62run5207z62zz__evaluate_compz00(obj_t BgL_envz00_12111, obj_t BgL_sz00_12116)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12112;obj_t BgL_valza2za2_12113;BgL_ev_absz00_bglt BgL_i1243z00_12114;obj_t BgL_bodyz00_12115;
BgL_siza7eza7_12112 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12111, 
(int)(((long)0)))); 
BgL_valza2za2_12113 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12111, 
(int)(((long)1)))); 
BgL_i1243z00_12114 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12111, 
(int)(((long)2)))); 
BgL_bodyz00_12115 = 
PROCEDURE_REF(BgL_envz00_12111, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14335;
BgL_bpz00_14335 = 
VECTOR_REF(
((obj_t)BgL_sz00_12116),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12116, BgL_valza2za2_12113, 
(
(long)CINT(BgL_bpz00_14335)+BgL_siza7eza7_12112)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14336;obj_t BgL_wherez00_14337;obj_t BgL_locz00_14338;
BgL_z12denvz12_14336 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14337 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12114))->BgL_wherez00); 
BgL_locz00_14338 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12114))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14336, BgL_wherez00_14337, BgL_locz00_14338); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14339;
BgL_za2za2resza2za2z00_14339 = 
PROCEDURE_ENTRY(BgL_bodyz00_12115)(BgL_bodyz00_12115, BgL_sz00_12116, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14336); 
return BgL_za2za2resza2za2z00_14339;} } } } } } 

}



/* &<@anonymous:3278> */
obj_t BGl_z62zc3z04anonymousza33278ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12117, obj_t BgL_sz00_12124)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12118;obj_t BgL_iboxesz00_12119;long BgL_siza7eza7_12120;BgL_ev_absz00_bglt BgL_i1243z00_12121;obj_t BgL_bodyz00_12122;long BgL_siza7ezd2framez75_12123;
BgL_ifreesz00_12118 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12117, 
(int)(((long)0)))); 
BgL_iboxesz00_12119 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12117, 
(int)(((long)1)))); 
BgL_siza7eza7_12120 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12117, 
(int)(((long)2)))); 
BgL_i1243z00_12121 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12117, 
(int)(((long)3)))); 
BgL_bodyz00_12122 = 
PROCEDURE_REF(BgL_envz00_12117, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12123 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12117, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14340;
BgL_bpz00_14340 = 
VECTOR_REF(
((obj_t)BgL_sz00_12124),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14341;
BgL_valza2za2_14341 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12124, BgL_bpz00_14340, BgL_ifreesz00_12118); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14342;
BgL_runz00_14342 = 
MAKE_FX_PROCEDURE(BGl_z62run5209z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14342, 
(int)(((long)0)), BgL_iboxesz00_12119); 
PROCEDURE_SET(BgL_runz00_14342, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12120)); 
PROCEDURE_SET(BgL_runz00_14342, 
(int)(((long)2)), BgL_valza2za2_14341); 
PROCEDURE_SET(BgL_runz00_14342, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12121)); 
PROCEDURE_SET(BgL_runz00_14342, 
(int)(((long)4)), BgL_bodyz00_12122); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14343;
BgL_mainz00_14343 = 
MAKE_FX_PROCEDURE(BGl_z62main5208z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14343, 
(int)(((long)0)), BgL_iboxesz00_12119); 
PROCEDURE_SET(BgL_mainz00_14343, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12120)); 
PROCEDURE_SET(BgL_mainz00_14343, 
(int)(((long)2)), BgL_valza2za2_14341); 
PROCEDURE_SET(BgL_mainz00_14343, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12121)); 
PROCEDURE_SET(BgL_mainz00_14343, 
(int)(((long)4)), BgL_bodyz00_12122); 
PROCEDURE_SET(BgL_mainz00_14343, 
(int)(((long)5)), BgL_runz00_14342); 
PROCEDURE_SET(BgL_mainz00_14343, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12123)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14344;
BgL_objz00_14344 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14342, BgL_objz00_14344); BgL_objz00_14344; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3279z00_14345;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3280z00_14346;
BgL_arg3280z00_14346 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12121))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14347;
BgL_newz00_14347 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26471;
BgL_tmpz00_26471 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14347, BgL_tmpz00_26471, BgL_arg3280z00_14346); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26476;int BgL_tmpz00_26474;
BgL_auxz00_26476 = 
BINT(BgL_siza7ezd2framez75_12123); 
BgL_tmpz00_26474 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14347, BgL_tmpz00_26474, BgL_auxz00_26476); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26479;
BgL_tmpz00_26479 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14347, BgL_tmpz00_26479, BgL_runz00_14342); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26484;int BgL_tmpz00_26482;
BgL_auxz00_26484 = 
BINT(((long)1)); 
BgL_tmpz00_26482 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14347, BgL_tmpz00_26482, BgL_auxz00_26484); } 
BgL_arg3279z00_14345 = BgL_newz00_14347; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14343, BgL_arg3279z00_14345); BgL_arg3279z00_14345; } 
return BgL_mainz00_14343;} } } } } } 

}



/* &main5208 */
obj_t BGl_z62main5208z62zz__evaluate_compz00(obj_t BgL_envz00_12125, obj_t BgL_dz00_12133)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12131;long BgL_siza7ezd2framez75_12132;
BgL_runz00_12131 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12125, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12132 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12125, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14348;
BgL_sz00_14348 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14349;
BgL_bpz00_14349 = 
VECTOR_REF(
((obj_t)BgL_sz00_14348),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14348, BgL_bpz00_14349, 
BINT(BgL_siza7ezd2framez75_12132)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3283z00_14350;
BgL_arg3283z00_14350 = 
(
(long)CINT(BgL_bpz00_14349)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14348),BgL_arg3283z00_14350,BgL_dz00_12133); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14351;
BgL_ez00_14351 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14351, BgL_bpz00_14349); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14352;
BgL_accz00_14352 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12131, BgL_sz00_14348, BgL_bpz00_14349); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14351); 
VECTOR_SET(
((obj_t)BgL_sz00_14348),((long)0),BgL_bpz00_14349); 
return BgL_accz00_14352;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14353;
BgL_nsz00_14353 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14353,((long)1),BgL_sz00_14348); 
VECTOR_SET(BgL_nsz00_14353,((long)2),BgL_dz00_12133); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14354;
BgL_z12denvz12_14354 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14354, BgL_nsz00_14353); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14355;
BgL_ez00_14355 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14355, BgL_sz00_14348); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14356;
BgL_____rz00_14356 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12131, BgL_nsz00_14353, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14355); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14354, BgL_sz00_14348); 
return BgL_____rz00_14356;} } } } } } } } 

}



/* &run5209 */
obj_t BGl_z62run5209z62zz__evaluate_compz00(obj_t BgL_envz00_12134, obj_t BgL_sz00_12140)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12135;long BgL_siza7eza7_12136;obj_t BgL_valza2za2_12137;BgL_ev_absz00_bglt BgL_i1243z00_12138;obj_t BgL_bodyz00_12139;
BgL_iboxesz00_12135 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12134, 
(int)(((long)0)))); 
BgL_siza7eza7_12136 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12134, 
(int)(((long)1)))); 
BgL_valza2za2_12137 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12134, 
(int)(((long)2)))); 
BgL_i1243z00_12138 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12134, 
(int)(((long)3)))); 
BgL_bodyz00_12139 = 
PROCEDURE_REF(BgL_envz00_12134, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14357;
BgL_bpz00_14357 = 
VECTOR_REF(
((obj_t)BgL_sz00_12140),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12140, BgL_iboxesz00_12135, BgL_bpz00_14357); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12140, BgL_valza2za2_12137, 
(
(long)CINT(BgL_bpz00_14357)+BgL_siza7eza7_12136)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14358;obj_t BgL_wherez00_14359;obj_t BgL_locz00_14360;
BgL_z12denvz12_14358 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14359 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12138))->BgL_wherez00); 
BgL_locz00_14360 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12138))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14358, BgL_wherez00_14359, BgL_locz00_14360); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14361;
BgL_za2za2resza2za2z00_14361 = 
PROCEDURE_ENTRY(BgL_bodyz00_12139)(BgL_bodyz00_12139, BgL_sz00_12140, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14358); 
return BgL_za2za2resza2za2z00_14361;} } } } } } 

}



/* &<@anonymous:3214> */
obj_t BGl_z62zc3z04anonymousza33214ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12141, obj_t BgL_sz00_12145)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12142;obj_t BgL_bodyz00_12143;long BgL_siza7ezd2framez75_12144;
BgL_i1243z00_12142 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12141, 
(int)(((long)0)))); 
BgL_bodyz00_12143 = 
PROCEDURE_REF(BgL_envz00_12141, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12144 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12141, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14362;
BgL_bpz00_14362 = 
VECTOR_REF(
((obj_t)BgL_sz00_12145),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14363;
BgL_runz00_14363 = 
MAKE_FX_PROCEDURE(BGl_z62run5211z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14363, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12142)); 
PROCEDURE_SET(BgL_runz00_14363, 
(int)(((long)1)), BgL_bodyz00_12143); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14364;
BgL_mainz00_14364 = 
MAKE_VA_PROCEDURE(BGl_z62main5210z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14364, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12142)); 
PROCEDURE_SET(BgL_mainz00_14364, 
(int)(((long)1)), BgL_bodyz00_12143); 
PROCEDURE_SET(BgL_mainz00_14364, 
(int)(((long)2)), BgL_runz00_14363); 
PROCEDURE_SET(BgL_mainz00_14364, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12144)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14365;
BgL_objz00_14365 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14363, BgL_objz00_14365); BgL_objz00_14365; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3215z00_14366;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3216z00_14367;
BgL_arg3216z00_14367 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12142))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14368;
BgL_newz00_14368 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26585;
BgL_tmpz00_26585 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14368, BgL_tmpz00_26585, BgL_arg3216z00_14367); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26590;int BgL_tmpz00_26588;
BgL_auxz00_26590 = 
BINT(BgL_siza7ezd2framez75_12144); 
BgL_tmpz00_26588 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14368, BgL_tmpz00_26588, BgL_auxz00_26590); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26593;
BgL_tmpz00_26593 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14368, BgL_tmpz00_26593, BgL_runz00_14363); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26598;int BgL_tmpz00_26596;
BgL_auxz00_26598 = 
BINT(((long)-1)); 
BgL_tmpz00_26596 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14368, BgL_tmpz00_26596, BgL_auxz00_26598); } 
BgL_arg3215z00_14366 = BgL_newz00_14368; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14364, BgL_arg3215z00_14366); BgL_arg3215z00_14366; } 
return BgL_mainz00_14364;} } } } } } 

}



/* &main5210 */
obj_t BGl_z62main5210z62zz__evaluate_compz00(obj_t BgL_envz00_12146, obj_t BgL_lastz00_12151)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12149;long BgL_siza7ezd2framez75_12150;
BgL_runz00_12149 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12146, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12150 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12146, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14369;
BgL_sz00_14369 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14370;
BgL_bpz00_14370 = 
VECTOR_REF(
((obj_t)BgL_sz00_14369),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14369, BgL_bpz00_14370, 
BINT(BgL_siza7ezd2framez75_12150)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3219z00_14371;
BgL_arg3219z00_14371 = 
(
(long)CINT(BgL_bpz00_14370)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14369),BgL_arg3219z00_14371,BgL_lastz00_12151); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14372;
BgL_ez00_14372 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14372, BgL_bpz00_14370); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14373;
BgL_accz00_14373 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12149, BgL_sz00_14369, BgL_bpz00_14370); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14372); 
VECTOR_SET(
((obj_t)BgL_sz00_14369),((long)0),BgL_bpz00_14370); 
return BgL_accz00_14373;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14374;
BgL_nsz00_14374 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14374,((long)1),BgL_sz00_14369); 
VECTOR_SET(BgL_nsz00_14374,((long)2),BgL_lastz00_12151); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14375;
BgL_z12denvz12_14375 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14375, BgL_nsz00_14374); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14376;
BgL_ez00_14376 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14376, BgL_sz00_14369); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14377;
BgL_____rz00_14377 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12149, BgL_nsz00_14374, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14376); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14375, BgL_sz00_14369); 
return BgL_____rz00_14377;} } } } } } } } 

}



/* &run5211 */
obj_t BGl_z62run5211z62zz__evaluate_compz00(obj_t BgL_envz00_12152, obj_t BgL_sz00_12155)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12153;obj_t BgL_bodyz00_12154;
BgL_i1243z00_12153 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12152, 
(int)(((long)0)))); 
BgL_bodyz00_12154 = 
PROCEDURE_REF(BgL_envz00_12152, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14378;
BgL_bpz00_14378 = 
VECTOR_REF(
((obj_t)BgL_sz00_12155),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14379;obj_t BgL_wherez00_14380;obj_t BgL_locz00_14381;
BgL_z12denvz12_14379 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14380 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12153))->BgL_wherez00); 
BgL_locz00_14381 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12153))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14379, BgL_wherez00_14380, BgL_locz00_14381); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14382;
BgL_za2za2resza2za2z00_14382 = 
PROCEDURE_ENTRY(BgL_bodyz00_12154)(BgL_bodyz00_12154, BgL_sz00_12155, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14379); 
return BgL_za2za2resza2za2z00_14382;} } } } } } 

}



/* &<@anonymous:3221> */
obj_t BGl_z62zc3z04anonymousza33221ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12156, obj_t BgL_sz00_12161)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12157;BgL_ev_absz00_bglt BgL_i1243z00_12158;obj_t BgL_bodyz00_12159;long BgL_siza7ezd2framez75_12160;
BgL_iboxesz00_12157 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12156, 
(int)(((long)0)))); 
BgL_i1243z00_12158 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12156, 
(int)(((long)1)))); 
BgL_bodyz00_12159 = 
PROCEDURE_REF(BgL_envz00_12156, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12160 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12156, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14383;
BgL_bpz00_14383 = 
VECTOR_REF(
((obj_t)BgL_sz00_12161),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14384;
BgL_runz00_14384 = 
MAKE_FX_PROCEDURE(BGl_z62run5213z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14384, 
(int)(((long)0)), BgL_iboxesz00_12157); 
PROCEDURE_SET(BgL_runz00_14384, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12158)); 
PROCEDURE_SET(BgL_runz00_14384, 
(int)(((long)2)), BgL_bodyz00_12159); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14385;
BgL_mainz00_14385 = 
MAKE_VA_PROCEDURE(BGl_z62main5212z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14385, 
(int)(((long)0)), BgL_iboxesz00_12157); 
PROCEDURE_SET(BgL_mainz00_14385, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12158)); 
PROCEDURE_SET(BgL_mainz00_14385, 
(int)(((long)2)), BgL_bodyz00_12159); 
PROCEDURE_SET(BgL_mainz00_14385, 
(int)(((long)3)), BgL_runz00_14384); 
PROCEDURE_SET(BgL_mainz00_14385, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12160)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14386;
BgL_objz00_14386 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14384, BgL_objz00_14386); BgL_objz00_14386; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3222z00_14387;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3223z00_14388;
BgL_arg3223z00_14388 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12158))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14389;
BgL_newz00_14389 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26693;
BgL_tmpz00_26693 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14389, BgL_tmpz00_26693, BgL_arg3223z00_14388); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26698;int BgL_tmpz00_26696;
BgL_auxz00_26698 = 
BINT(BgL_siza7ezd2framez75_12160); 
BgL_tmpz00_26696 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14389, BgL_tmpz00_26696, BgL_auxz00_26698); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26701;
BgL_tmpz00_26701 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14389, BgL_tmpz00_26701, BgL_runz00_14384); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26706;int BgL_tmpz00_26704;
BgL_auxz00_26706 = 
BINT(((long)-1)); 
BgL_tmpz00_26704 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14389, BgL_tmpz00_26704, BgL_auxz00_26706); } 
BgL_arg3222z00_14387 = BgL_newz00_14389; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14385, BgL_arg3222z00_14387); BgL_arg3222z00_14387; } 
return BgL_mainz00_14385;} } } } } } 

}



/* &main5212 */
obj_t BGl_z62main5212z62zz__evaluate_compz00(obj_t BgL_envz00_12162, obj_t BgL_lastz00_12168)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12166;long BgL_siza7ezd2framez75_12167;
BgL_runz00_12166 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12162, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12167 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12162, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14390;
BgL_sz00_14390 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14391;
BgL_bpz00_14391 = 
VECTOR_REF(
((obj_t)BgL_sz00_14390),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14390, BgL_bpz00_14391, 
BINT(BgL_siza7ezd2framez75_12167)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3226z00_14392;
BgL_arg3226z00_14392 = 
(
(long)CINT(BgL_bpz00_14391)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14390),BgL_arg3226z00_14392,BgL_lastz00_12168); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14393;
BgL_ez00_14393 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14393, BgL_bpz00_14391); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14394;
BgL_accz00_14394 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12166, BgL_sz00_14390, BgL_bpz00_14391); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14393); 
VECTOR_SET(
((obj_t)BgL_sz00_14390),((long)0),BgL_bpz00_14391); 
return BgL_accz00_14394;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14395;
BgL_nsz00_14395 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14395,((long)1),BgL_sz00_14390); 
VECTOR_SET(BgL_nsz00_14395,((long)2),BgL_lastz00_12168); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14396;
BgL_z12denvz12_14396 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14396, BgL_nsz00_14395); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14397;
BgL_ez00_14397 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14397, BgL_sz00_14390); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14398;
BgL_____rz00_14398 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12166, BgL_nsz00_14395, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14397); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14396, BgL_sz00_14390); 
return BgL_____rz00_14398;} } } } } } } } 

}



/* &run5213 */
obj_t BGl_z62run5213z62zz__evaluate_compz00(obj_t BgL_envz00_12169, obj_t BgL_sz00_12173)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12170;BgL_ev_absz00_bglt BgL_i1243z00_12171;obj_t BgL_bodyz00_12172;
BgL_iboxesz00_12170 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12169, 
(int)(((long)0)))); 
BgL_i1243z00_12171 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12169, 
(int)(((long)1)))); 
BgL_bodyz00_12172 = 
PROCEDURE_REF(BgL_envz00_12169, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14399;
BgL_bpz00_14399 = 
VECTOR_REF(
((obj_t)BgL_sz00_12173),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12173, BgL_iboxesz00_12170, BgL_bpz00_14399); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14400;obj_t BgL_wherez00_14401;obj_t BgL_locz00_14402;
BgL_z12denvz12_14400 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14401 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12171))->BgL_wherez00); 
BgL_locz00_14402 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12171))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14400, BgL_wherez00_14401, BgL_locz00_14402); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14403;
BgL_za2za2resza2za2z00_14403 = 
PROCEDURE_ENTRY(BgL_bodyz00_12172)(BgL_bodyz00_12172, BgL_sz00_12173, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14400); 
return BgL_za2za2resza2za2z00_14403;} } } } } } 

}



/* &<@anonymous:3231> */
obj_t BGl_z62zc3z04anonymousza33231ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12174, obj_t BgL_sz00_12180)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12175;long BgL_siza7eza7_12176;BgL_ev_absz00_bglt BgL_i1243z00_12177;obj_t BgL_bodyz00_12178;long BgL_siza7ezd2framez75_12179;
BgL_ifreesz00_12175 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12174, 
(int)(((long)0)))); 
BgL_siza7eza7_12176 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12174, 
(int)(((long)1)))); 
BgL_i1243z00_12177 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12174, 
(int)(((long)2)))); 
BgL_bodyz00_12178 = 
PROCEDURE_REF(BgL_envz00_12174, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12179 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12174, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14404;
BgL_bpz00_14404 = 
VECTOR_REF(
((obj_t)BgL_sz00_12180),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14405;
BgL_valza2za2_14405 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12180, BgL_bpz00_14404, BgL_ifreesz00_12175); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14406;
BgL_runz00_14406 = 
MAKE_FX_PROCEDURE(BGl_z62run5215z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14406, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12176)); 
PROCEDURE_SET(BgL_runz00_14406, 
(int)(((long)1)), BgL_valza2za2_14405); 
PROCEDURE_SET(BgL_runz00_14406, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12177)); 
PROCEDURE_SET(BgL_runz00_14406, 
(int)(((long)3)), BgL_bodyz00_12178); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14407;
BgL_mainz00_14407 = 
MAKE_VA_PROCEDURE(BGl_z62main5214z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14407, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12176)); 
PROCEDURE_SET(BgL_mainz00_14407, 
(int)(((long)1)), BgL_valza2za2_14405); 
PROCEDURE_SET(BgL_mainz00_14407, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12177)); 
PROCEDURE_SET(BgL_mainz00_14407, 
(int)(((long)3)), BgL_bodyz00_12178); 
PROCEDURE_SET(BgL_mainz00_14407, 
(int)(((long)4)), BgL_runz00_14406); 
PROCEDURE_SET(BgL_mainz00_14407, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12179)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14408;
BgL_objz00_14408 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14406, BgL_objz00_14408); BgL_objz00_14408; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3232z00_14409;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3233z00_14410;
BgL_arg3233z00_14410 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12177))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14411;
BgL_newz00_14411 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26815;
BgL_tmpz00_26815 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14411, BgL_tmpz00_26815, BgL_arg3233z00_14410); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26820;int BgL_tmpz00_26818;
BgL_auxz00_26820 = 
BINT(BgL_siza7ezd2framez75_12179); 
BgL_tmpz00_26818 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14411, BgL_tmpz00_26818, BgL_auxz00_26820); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26823;
BgL_tmpz00_26823 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14411, BgL_tmpz00_26823, BgL_runz00_14406); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26828;int BgL_tmpz00_26826;
BgL_auxz00_26828 = 
BINT(((long)-1)); 
BgL_tmpz00_26826 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14411, BgL_tmpz00_26826, BgL_auxz00_26828); } 
BgL_arg3232z00_14409 = BgL_newz00_14411; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14407, BgL_arg3232z00_14409); BgL_arg3232z00_14409; } 
return BgL_mainz00_14407;} } } } } } 

}



/* &main5214 */
obj_t BGl_z62main5214z62zz__evaluate_compz00(obj_t BgL_envz00_12181, obj_t BgL_lastz00_12188)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12186;long BgL_siza7ezd2framez75_12187;
BgL_runz00_12186 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12181, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12187 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12181, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14412;
BgL_sz00_14412 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14413;
BgL_bpz00_14413 = 
VECTOR_REF(
((obj_t)BgL_sz00_14412),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14412, BgL_bpz00_14413, 
BINT(BgL_siza7ezd2framez75_12187)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3236z00_14414;
BgL_arg3236z00_14414 = 
(
(long)CINT(BgL_bpz00_14413)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14412),BgL_arg3236z00_14414,BgL_lastz00_12188); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14415;
BgL_ez00_14415 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14415, BgL_bpz00_14413); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14416;
BgL_accz00_14416 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12186, BgL_sz00_14412, BgL_bpz00_14413); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14415); 
VECTOR_SET(
((obj_t)BgL_sz00_14412),((long)0),BgL_bpz00_14413); 
return BgL_accz00_14416;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14417;
BgL_nsz00_14417 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14417,((long)1),BgL_sz00_14412); 
VECTOR_SET(BgL_nsz00_14417,((long)2),BgL_lastz00_12188); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14418;
BgL_z12denvz12_14418 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14418, BgL_nsz00_14417); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14419;
BgL_ez00_14419 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14419, BgL_sz00_14412); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14420;
BgL_____rz00_14420 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12186, BgL_nsz00_14417, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14419); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14418, BgL_sz00_14412); 
return BgL_____rz00_14420;} } } } } } } } 

}



/* &run5215 */
obj_t BGl_z62run5215z62zz__evaluate_compz00(obj_t BgL_envz00_12189, obj_t BgL_sz00_12194)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12190;obj_t BgL_valza2za2_12191;BgL_ev_absz00_bglt BgL_i1243z00_12192;obj_t BgL_bodyz00_12193;
BgL_siza7eza7_12190 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12189, 
(int)(((long)0)))); 
BgL_valza2za2_12191 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12189, 
(int)(((long)1)))); 
BgL_i1243z00_12192 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12189, 
(int)(((long)2)))); 
BgL_bodyz00_12193 = 
PROCEDURE_REF(BgL_envz00_12189, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14421;
BgL_bpz00_14421 = 
VECTOR_REF(
((obj_t)BgL_sz00_12194),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12194, BgL_valza2za2_12191, 
(
(long)CINT(BgL_bpz00_14421)+BgL_siza7eza7_12190)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14422;obj_t BgL_wherez00_14423;obj_t BgL_locz00_14424;
BgL_z12denvz12_14422 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14423 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12192))->BgL_wherez00); 
BgL_locz00_14424 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12192))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14422, BgL_wherez00_14423, BgL_locz00_14424); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14425;
BgL_za2za2resza2za2z00_14425 = 
PROCEDURE_ENTRY(BgL_bodyz00_12193)(BgL_bodyz00_12193, BgL_sz00_12194, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14422); 
return BgL_za2za2resza2za2z00_14425;} } } } } } 

}



/* &<@anonymous:3239> */
obj_t BGl_z62zc3z04anonymousza33239ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12195, obj_t BgL_sz00_12202)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12196;obj_t BgL_iboxesz00_12197;long BgL_siza7eza7_12198;BgL_ev_absz00_bglt BgL_i1243z00_12199;obj_t BgL_bodyz00_12200;long BgL_siza7ezd2framez75_12201;
BgL_ifreesz00_12196 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12195, 
(int)(((long)0)))); 
BgL_iboxesz00_12197 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12195, 
(int)(((long)1)))); 
BgL_siza7eza7_12198 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12195, 
(int)(((long)2)))); 
BgL_i1243z00_12199 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12195, 
(int)(((long)3)))); 
BgL_bodyz00_12200 = 
PROCEDURE_REF(BgL_envz00_12195, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12201 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12195, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14426;
BgL_bpz00_14426 = 
VECTOR_REF(
((obj_t)BgL_sz00_12202),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14427;
BgL_valza2za2_14427 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12202, BgL_bpz00_14426, BgL_ifreesz00_12196); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14428;
BgL_runz00_14428 = 
MAKE_FX_PROCEDURE(BGl_z62run5217z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14428, 
(int)(((long)0)), BgL_iboxesz00_12197); 
PROCEDURE_SET(BgL_runz00_14428, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12198)); 
PROCEDURE_SET(BgL_runz00_14428, 
(int)(((long)2)), BgL_valza2za2_14427); 
PROCEDURE_SET(BgL_runz00_14428, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12199)); 
PROCEDURE_SET(BgL_runz00_14428, 
(int)(((long)4)), BgL_bodyz00_12200); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14429;
BgL_mainz00_14429 = 
MAKE_VA_PROCEDURE(BGl_z62main5216z62zz__evaluate_compz00, 
(int)(((long)-1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14429, 
(int)(((long)0)), BgL_iboxesz00_12197); 
PROCEDURE_SET(BgL_mainz00_14429, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12198)); 
PROCEDURE_SET(BgL_mainz00_14429, 
(int)(((long)2)), BgL_valza2za2_14427); 
PROCEDURE_SET(BgL_mainz00_14429, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12199)); 
PROCEDURE_SET(BgL_mainz00_14429, 
(int)(((long)4)), BgL_bodyz00_12200); 
PROCEDURE_SET(BgL_mainz00_14429, 
(int)(((long)5)), BgL_runz00_14428); 
PROCEDURE_SET(BgL_mainz00_14429, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12201)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14430;
BgL_objz00_14430 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14428, BgL_objz00_14430); BgL_objz00_14430; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3240z00_14431;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3241z00_14432;
BgL_arg3241z00_14432 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12199))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14433;
BgL_newz00_14433 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26949;
BgL_tmpz00_26949 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14433, BgL_tmpz00_26949, BgL_arg3241z00_14432); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26954;int BgL_tmpz00_26952;
BgL_auxz00_26954 = 
BINT(BgL_siza7ezd2framez75_12201); 
BgL_tmpz00_26952 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14433, BgL_tmpz00_26952, BgL_auxz00_26954); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_26957;
BgL_tmpz00_26957 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14433, BgL_tmpz00_26957, BgL_runz00_14428); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_26962;int BgL_tmpz00_26960;
BgL_auxz00_26962 = 
BINT(((long)-1)); 
BgL_tmpz00_26960 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14433, BgL_tmpz00_26960, BgL_auxz00_26962); } 
BgL_arg3240z00_14431 = BgL_newz00_14433; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14429, BgL_arg3240z00_14431); BgL_arg3240z00_14431; } 
return BgL_mainz00_14429;} } } } } } 

}



/* &main5216 */
obj_t BGl_z62main5216z62zz__evaluate_compz00(obj_t BgL_envz00_12203, obj_t BgL_lastz00_12211)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12209;long BgL_siza7ezd2framez75_12210;
BgL_runz00_12209 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12203, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12210 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12203, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14434;
BgL_sz00_14434 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14435;
BgL_bpz00_14435 = 
VECTOR_REF(
((obj_t)BgL_sz00_14434),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14434, BgL_bpz00_14435, 
BINT(BgL_siza7ezd2framez75_12210)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3244z00_14436;
BgL_arg3244z00_14436 = 
(
(long)CINT(BgL_bpz00_14435)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14434),BgL_arg3244z00_14436,BgL_lastz00_12211); } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14437;
BgL_ez00_14437 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14437, BgL_bpz00_14435); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14438;
BgL_accz00_14438 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12209, BgL_sz00_14434, BgL_bpz00_14435); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14437); 
VECTOR_SET(
((obj_t)BgL_sz00_14434),((long)0),BgL_bpz00_14435); 
return BgL_accz00_14438;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14439;
BgL_nsz00_14439 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14439,((long)1),BgL_sz00_14434); 
VECTOR_SET(BgL_nsz00_14439,((long)2),BgL_lastz00_12211); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14440;
BgL_z12denvz12_14440 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14440, BgL_nsz00_14439); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14441;
BgL_ez00_14441 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14441, BgL_sz00_14434); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14442;
BgL_____rz00_14442 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12209, BgL_nsz00_14439, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14441); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14440, BgL_sz00_14434); 
return BgL_____rz00_14442;} } } } } } } } 

}



/* &run5217 */
obj_t BGl_z62run5217z62zz__evaluate_compz00(obj_t BgL_envz00_12212, obj_t BgL_sz00_12218)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12213;long BgL_siza7eza7_12214;obj_t BgL_valza2za2_12215;BgL_ev_absz00_bglt BgL_i1243z00_12216;obj_t BgL_bodyz00_12217;
BgL_iboxesz00_12213 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12212, 
(int)(((long)0)))); 
BgL_siza7eza7_12214 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12212, 
(int)(((long)1)))); 
BgL_valza2za2_12215 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12212, 
(int)(((long)2)))); 
BgL_i1243z00_12216 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12212, 
(int)(((long)3)))); 
BgL_bodyz00_12217 = 
PROCEDURE_REF(BgL_envz00_12212, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14443;
BgL_bpz00_14443 = 
VECTOR_REF(
((obj_t)BgL_sz00_12218),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12218, BgL_iboxesz00_12213, BgL_bpz00_14443); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12218, BgL_valza2za2_12215, 
(
(long)CINT(BgL_bpz00_14443)+BgL_siza7eza7_12214)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14444;obj_t BgL_wherez00_14445;obj_t BgL_locz00_14446;
BgL_z12denvz12_14444 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14445 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12216))->BgL_wherez00); 
BgL_locz00_14446 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12216))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14444, BgL_wherez00_14445, BgL_locz00_14446); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14447;
BgL_za2za2resza2za2z00_14447 = 
PROCEDURE_ENTRY(BgL_bodyz00_12217)(BgL_bodyz00_12217, BgL_sz00_12218, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14444); 
return BgL_za2za2resza2za2z00_14447;} } } } } } 

}



/* &<@anonymous:3179> */
obj_t BGl_z62zc3z04anonymousza33179ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12219, obj_t BgL_sz00_12223)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12220;obj_t BgL_bodyz00_12221;long BgL_siza7ezd2framez75_12222;
BgL_i1243z00_12220 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12219, 
(int)(((long)0)))); 
BgL_bodyz00_12221 = 
PROCEDURE_REF(BgL_envz00_12219, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12222 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12219, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14448;
BgL_bpz00_14448 = 
VECTOR_REF(
((obj_t)BgL_sz00_12223),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14449;
BgL_runz00_14449 = 
MAKE_FX_PROCEDURE(BGl_z62run5219z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14449, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12220)); 
PROCEDURE_SET(BgL_runz00_14449, 
(int)(((long)1)), BgL_bodyz00_12221); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14450;
BgL_mainz00_14450 = 
MAKE_FX_PROCEDURE(BGl_z62main5218z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14450, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12220)); 
PROCEDURE_SET(BgL_mainz00_14450, 
(int)(((long)1)), BgL_bodyz00_12221); 
PROCEDURE_SET(BgL_mainz00_14450, 
(int)(((long)2)), BgL_runz00_14449); 
PROCEDURE_SET(BgL_mainz00_14450, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12222)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14451;
BgL_objz00_14451 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14449, BgL_objz00_14451); BgL_objz00_14451; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3180z00_14452;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3181z00_14453;
BgL_arg3181z00_14453 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12220))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14454;
BgL_newz00_14454 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27063;
BgL_tmpz00_27063 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14454, BgL_tmpz00_27063, BgL_arg3181z00_14453); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27068;int BgL_tmpz00_27066;
BgL_auxz00_27068 = 
BINT(BgL_siza7ezd2framez75_12222); 
BgL_tmpz00_27066 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14454, BgL_tmpz00_27066, BgL_auxz00_27068); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27071;
BgL_tmpz00_27071 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14454, BgL_tmpz00_27071, BgL_runz00_14449); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27076;int BgL_tmpz00_27074;
BgL_auxz00_27076 = 
BINT(((long)0)); 
BgL_tmpz00_27074 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14454, BgL_tmpz00_27074, BgL_auxz00_27076); } 
BgL_arg3180z00_14452 = BgL_newz00_14454; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14450, BgL_arg3180z00_14452); BgL_arg3180z00_14452; } 
return BgL_mainz00_14450;} } } } } } 

}



/* &main5218 */
obj_t BGl_z62main5218z62zz__evaluate_compz00(obj_t BgL_envz00_12224)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12227;long BgL_siza7ezd2framez75_12228;
BgL_runz00_12227 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12224, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12228 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12224, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14455;
BgL_sz00_14455 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14456;
BgL_bpz00_14456 = 
VECTOR_REF(
((obj_t)BgL_sz00_14455),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14455, BgL_bpz00_14456, 
BINT(BgL_siza7ezd2framez75_12228)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14457;
BgL_ez00_14457 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14457, BgL_bpz00_14456); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14458;
BgL_accz00_14458 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12227, BgL_sz00_14455, BgL_bpz00_14456); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14457); 
VECTOR_SET(
((obj_t)BgL_sz00_14455),((long)0),BgL_bpz00_14456); 
return BgL_accz00_14458;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14459;
BgL_nsz00_14459 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14459,((long)1),BgL_sz00_14455); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14460;
BgL_z12denvz12_14460 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14460, BgL_nsz00_14459); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14461;
BgL_ez00_14461 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14461, BgL_sz00_14455); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14462;
BgL_____rz00_14462 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12227, BgL_nsz00_14459, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14461); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14460, BgL_sz00_14455); 
return BgL_____rz00_14462;} } } } } } } } 

}



/* &run5219 */
obj_t BGl_z62run5219z62zz__evaluate_compz00(obj_t BgL_envz00_12229, obj_t BgL_sz00_12232)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12230;obj_t BgL_bodyz00_12231;
BgL_i1243z00_12230 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12229, 
(int)(((long)0)))); 
BgL_bodyz00_12231 = 
PROCEDURE_REF(BgL_envz00_12229, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14463;
BgL_bpz00_14463 = 
VECTOR_REF(
((obj_t)BgL_sz00_12232),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14464;obj_t BgL_wherez00_14465;obj_t BgL_locz00_14466;
BgL_z12denvz12_14464 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14465 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12230))->BgL_wherez00); 
BgL_locz00_14466 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12230))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14464, BgL_wherez00_14465, BgL_locz00_14466); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14467;
BgL_za2za2resza2za2z00_14467 = 
PROCEDURE_ENTRY(BgL_bodyz00_12231)(BgL_bodyz00_12231, BgL_sz00_12232, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14464); 
return BgL_za2za2resza2za2z00_14467;} } } } } } 

}



/* &<@anonymous:3185> */
obj_t BGl_z62zc3z04anonymousza33185ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12233, obj_t BgL_sz00_12238)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12234;BgL_ev_absz00_bglt BgL_i1243z00_12235;obj_t BgL_bodyz00_12236;long BgL_siza7ezd2framez75_12237;
BgL_iboxesz00_12234 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12233, 
(int)(((long)0)))); 
BgL_i1243z00_12235 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12233, 
(int)(((long)1)))); 
BgL_bodyz00_12236 = 
PROCEDURE_REF(BgL_envz00_12233, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12237 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12233, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14468;
BgL_bpz00_14468 = 
VECTOR_REF(
((obj_t)BgL_sz00_12238),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14469;
BgL_runz00_14469 = 
MAKE_FX_PROCEDURE(BGl_z62run5221z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14469, 
(int)(((long)0)), BgL_iboxesz00_12234); 
PROCEDURE_SET(BgL_runz00_14469, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12235)); 
PROCEDURE_SET(BgL_runz00_14469, 
(int)(((long)2)), BgL_bodyz00_12236); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14470;
BgL_mainz00_14470 = 
MAKE_FX_PROCEDURE(BGl_z62main5220z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14470, 
(int)(((long)0)), BgL_iboxesz00_12234); 
PROCEDURE_SET(BgL_mainz00_14470, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12235)); 
PROCEDURE_SET(BgL_mainz00_14470, 
(int)(((long)2)), BgL_bodyz00_12236); 
PROCEDURE_SET(BgL_mainz00_14470, 
(int)(((long)3)), BgL_runz00_14469); 
PROCEDURE_SET(BgL_mainz00_14470, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12237)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14471;
BgL_objz00_14471 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14469, BgL_objz00_14471); BgL_objz00_14471; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3186z00_14472;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3187z00_14473;
BgL_arg3187z00_14473 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12235))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14474;
BgL_newz00_14474 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27166;
BgL_tmpz00_27166 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14474, BgL_tmpz00_27166, BgL_arg3187z00_14473); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27171;int BgL_tmpz00_27169;
BgL_auxz00_27171 = 
BINT(BgL_siza7ezd2framez75_12237); 
BgL_tmpz00_27169 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14474, BgL_tmpz00_27169, BgL_auxz00_27171); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27174;
BgL_tmpz00_27174 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14474, BgL_tmpz00_27174, BgL_runz00_14469); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27179;int BgL_tmpz00_27177;
BgL_auxz00_27179 = 
BINT(((long)0)); 
BgL_tmpz00_27177 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14474, BgL_tmpz00_27177, BgL_auxz00_27179); } 
BgL_arg3186z00_14472 = BgL_newz00_14474; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14470, BgL_arg3186z00_14472); BgL_arg3186z00_14472; } 
return BgL_mainz00_14470;} } } } } } 

}



/* &main5220 */
obj_t BGl_z62main5220z62zz__evaluate_compz00(obj_t BgL_envz00_12239)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12243;long BgL_siza7ezd2framez75_12244;
BgL_runz00_12243 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12239, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12244 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12239, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14475;
BgL_sz00_14475 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14476;
BgL_bpz00_14476 = 
VECTOR_REF(
((obj_t)BgL_sz00_14475),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14475, BgL_bpz00_14476, 
BINT(BgL_siza7ezd2framez75_12244)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14477;
BgL_ez00_14477 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14477, BgL_bpz00_14476); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14478;
BgL_accz00_14478 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12243, BgL_sz00_14475, BgL_bpz00_14476); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14477); 
VECTOR_SET(
((obj_t)BgL_sz00_14475),((long)0),BgL_bpz00_14476); 
return BgL_accz00_14478;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14479;
BgL_nsz00_14479 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14479,((long)1),BgL_sz00_14475); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14480;
BgL_z12denvz12_14480 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14480, BgL_nsz00_14479); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14481;
BgL_ez00_14481 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14481, BgL_sz00_14475); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14482;
BgL_____rz00_14482 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12243, BgL_nsz00_14479, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14481); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14480, BgL_sz00_14475); 
return BgL_____rz00_14482;} } } } } } } } 

}



/* &run5221 */
obj_t BGl_z62run5221z62zz__evaluate_compz00(obj_t BgL_envz00_12245, obj_t BgL_sz00_12249)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12246;BgL_ev_absz00_bglt BgL_i1243z00_12247;obj_t BgL_bodyz00_12248;
BgL_iboxesz00_12246 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12245, 
(int)(((long)0)))); 
BgL_i1243z00_12247 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12245, 
(int)(((long)1)))); 
BgL_bodyz00_12248 = 
PROCEDURE_REF(BgL_envz00_12245, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14483;
BgL_bpz00_14483 = 
VECTOR_REF(
((obj_t)BgL_sz00_12249),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12249, BgL_iboxesz00_12246, BgL_bpz00_14483); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14484;obj_t BgL_wherez00_14485;obj_t BgL_locz00_14486;
BgL_z12denvz12_14484 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14485 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12247))->BgL_wherez00); 
BgL_locz00_14486 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12247))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14484, BgL_wherez00_14485, BgL_locz00_14486); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14487;
BgL_za2za2resza2za2z00_14487 = 
PROCEDURE_ENTRY(BgL_bodyz00_12248)(BgL_bodyz00_12248, BgL_sz00_12249, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14484); 
return BgL_za2za2resza2za2z00_14487;} } } } } } 

}



/* &<@anonymous:3194> */
obj_t BGl_z62zc3z04anonymousza33194ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12250, obj_t BgL_sz00_12256)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12251;long BgL_siza7eza7_12252;BgL_ev_absz00_bglt BgL_i1243z00_12253;obj_t BgL_bodyz00_12254;long BgL_siza7ezd2framez75_12255;
BgL_ifreesz00_12251 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12250, 
(int)(((long)0)))); 
BgL_siza7eza7_12252 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12250, 
(int)(((long)1)))); 
BgL_i1243z00_12253 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12250, 
(int)(((long)2)))); 
BgL_bodyz00_12254 = 
PROCEDURE_REF(BgL_envz00_12250, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12255 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12250, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14488;
BgL_bpz00_14488 = 
VECTOR_REF(
((obj_t)BgL_sz00_12256),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14489;
BgL_valza2za2_14489 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12256, BgL_bpz00_14488, BgL_ifreesz00_12251); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14490;
BgL_runz00_14490 = 
MAKE_FX_PROCEDURE(BGl_z62run5223z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14490, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12252)); 
PROCEDURE_SET(BgL_runz00_14490, 
(int)(((long)1)), BgL_valza2za2_14489); 
PROCEDURE_SET(BgL_runz00_14490, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12253)); 
PROCEDURE_SET(BgL_runz00_14490, 
(int)(((long)3)), BgL_bodyz00_12254); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14491;
BgL_mainz00_14491 = 
MAKE_FX_PROCEDURE(BGl_z62main5222z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14491, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12252)); 
PROCEDURE_SET(BgL_mainz00_14491, 
(int)(((long)1)), BgL_valza2za2_14489); 
PROCEDURE_SET(BgL_mainz00_14491, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12253)); 
PROCEDURE_SET(BgL_mainz00_14491, 
(int)(((long)3)), BgL_bodyz00_12254); 
PROCEDURE_SET(BgL_mainz00_14491, 
(int)(((long)4)), BgL_runz00_14490); 
PROCEDURE_SET(BgL_mainz00_14491, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12255)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14492;
BgL_objz00_14492 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14490, BgL_objz00_14492); BgL_objz00_14492; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3195z00_14493;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3196z00_14494;
BgL_arg3196z00_14494 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12253))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14495;
BgL_newz00_14495 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27283;
BgL_tmpz00_27283 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14495, BgL_tmpz00_27283, BgL_arg3196z00_14494); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27288;int BgL_tmpz00_27286;
BgL_auxz00_27288 = 
BINT(BgL_siza7ezd2framez75_12255); 
BgL_tmpz00_27286 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14495, BgL_tmpz00_27286, BgL_auxz00_27288); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27291;
BgL_tmpz00_27291 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14495, BgL_tmpz00_27291, BgL_runz00_14490); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27296;int BgL_tmpz00_27294;
BgL_auxz00_27296 = 
BINT(((long)0)); 
BgL_tmpz00_27294 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14495, BgL_tmpz00_27294, BgL_auxz00_27296); } 
BgL_arg3195z00_14493 = BgL_newz00_14495; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14491, BgL_arg3195z00_14493); BgL_arg3195z00_14493; } 
return BgL_mainz00_14491;} } } } } } 

}



/* &main5222 */
obj_t BGl_z62main5222z62zz__evaluate_compz00(obj_t BgL_envz00_12257)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12262;long BgL_siza7ezd2framez75_12263;
BgL_runz00_12262 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12257, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12263 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12257, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14496;
BgL_sz00_14496 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14497;
BgL_bpz00_14497 = 
VECTOR_REF(
((obj_t)BgL_sz00_14496),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14496, BgL_bpz00_14497, 
BINT(BgL_siza7ezd2framez75_12263)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14498;
BgL_ez00_14498 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14498, BgL_bpz00_14497); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14499;
BgL_accz00_14499 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12262, BgL_sz00_14496, BgL_bpz00_14497); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14498); 
VECTOR_SET(
((obj_t)BgL_sz00_14496),((long)0),BgL_bpz00_14497); 
return BgL_accz00_14499;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14500;
BgL_nsz00_14500 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14500,((long)1),BgL_sz00_14496); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14501;
BgL_z12denvz12_14501 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14501, BgL_nsz00_14500); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14502;
BgL_ez00_14502 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14502, BgL_sz00_14496); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14503;
BgL_____rz00_14503 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12262, BgL_nsz00_14500, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14502); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14501, BgL_sz00_14496); 
return BgL_____rz00_14503;} } } } } } } } 

}



/* &run5223 */
obj_t BGl_z62run5223z62zz__evaluate_compz00(obj_t BgL_envz00_12264, obj_t BgL_sz00_12269)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12265;obj_t BgL_valza2za2_12266;BgL_ev_absz00_bglt BgL_i1243z00_12267;obj_t BgL_bodyz00_12268;
BgL_siza7eza7_12265 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12264, 
(int)(((long)0)))); 
BgL_valza2za2_12266 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12264, 
(int)(((long)1)))); 
BgL_i1243z00_12267 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12264, 
(int)(((long)2)))); 
BgL_bodyz00_12268 = 
PROCEDURE_REF(BgL_envz00_12264, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14504;
BgL_bpz00_14504 = 
VECTOR_REF(
((obj_t)BgL_sz00_12269),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12269, BgL_valza2za2_12266, 
(
(long)CINT(BgL_bpz00_14504)+BgL_siza7eza7_12265)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14505;obj_t BgL_wherez00_14506;obj_t BgL_locz00_14507;
BgL_z12denvz12_14505 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14506 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12267))->BgL_wherez00); 
BgL_locz00_14507 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12267))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14505, BgL_wherez00_14506, BgL_locz00_14507); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14508;
BgL_za2za2resza2za2z00_14508 = 
PROCEDURE_ENTRY(BgL_bodyz00_12268)(BgL_bodyz00_12268, BgL_sz00_12269, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14505); 
return BgL_za2za2resza2za2z00_14508;} } } } } } 

}



/* &<@anonymous:3201> */
obj_t BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12270, obj_t BgL_sz00_12277)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12271;obj_t BgL_iboxesz00_12272;long BgL_siza7eza7_12273;BgL_ev_absz00_bglt BgL_i1243z00_12274;obj_t BgL_bodyz00_12275;long BgL_siza7ezd2framez75_12276;
BgL_ifreesz00_12271 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12270, 
(int)(((long)0)))); 
BgL_iboxesz00_12272 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12270, 
(int)(((long)1)))); 
BgL_siza7eza7_12273 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12270, 
(int)(((long)2)))); 
BgL_i1243z00_12274 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12270, 
(int)(((long)3)))); 
BgL_bodyz00_12275 = 
PROCEDURE_REF(BgL_envz00_12270, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12276 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12270, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14509;
BgL_bpz00_14509 = 
VECTOR_REF(
((obj_t)BgL_sz00_12277),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14510;
BgL_valza2za2_14510 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12277, BgL_bpz00_14509, BgL_ifreesz00_12271); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14511;
BgL_runz00_14511 = 
MAKE_FX_PROCEDURE(BGl_z62run5225z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14511, 
(int)(((long)0)), BgL_iboxesz00_12272); 
PROCEDURE_SET(BgL_runz00_14511, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12273)); 
PROCEDURE_SET(BgL_runz00_14511, 
(int)(((long)2)), BgL_valza2za2_14510); 
PROCEDURE_SET(BgL_runz00_14511, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12274)); 
PROCEDURE_SET(BgL_runz00_14511, 
(int)(((long)4)), BgL_bodyz00_12275); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14512;
BgL_mainz00_14512 = 
MAKE_FX_PROCEDURE(BGl_z62main5224z62zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14512, 
(int)(((long)0)), BgL_iboxesz00_12272); 
PROCEDURE_SET(BgL_mainz00_14512, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12273)); 
PROCEDURE_SET(BgL_mainz00_14512, 
(int)(((long)2)), BgL_valza2za2_14510); 
PROCEDURE_SET(BgL_mainz00_14512, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12274)); 
PROCEDURE_SET(BgL_mainz00_14512, 
(int)(((long)4)), BgL_bodyz00_12275); 
PROCEDURE_SET(BgL_mainz00_14512, 
(int)(((long)5)), BgL_runz00_14511); 
PROCEDURE_SET(BgL_mainz00_14512, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12276)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14513;
BgL_objz00_14513 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14511, BgL_objz00_14513); BgL_objz00_14513; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3202z00_14514;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3203z00_14515;
BgL_arg3203z00_14515 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12274))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14516;
BgL_newz00_14516 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27412;
BgL_tmpz00_27412 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14516, BgL_tmpz00_27412, BgL_arg3203z00_14515); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27417;int BgL_tmpz00_27415;
BgL_auxz00_27417 = 
BINT(BgL_siza7ezd2framez75_12276); 
BgL_tmpz00_27415 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14516, BgL_tmpz00_27415, BgL_auxz00_27417); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27420;
BgL_tmpz00_27420 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14516, BgL_tmpz00_27420, BgL_runz00_14511); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27425;int BgL_tmpz00_27423;
BgL_auxz00_27425 = 
BINT(((long)0)); 
BgL_tmpz00_27423 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14516, BgL_tmpz00_27423, BgL_auxz00_27425); } 
BgL_arg3202z00_14514 = BgL_newz00_14516; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14512, BgL_arg3202z00_14514); BgL_arg3202z00_14514; } 
return BgL_mainz00_14512;} } } } } } 

}



/* &main5224 */
obj_t BGl_z62main5224z62zz__evaluate_compz00(obj_t BgL_envz00_12278)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_12284;long BgL_siza7ezd2framez75_12285;
BgL_runz00_12284 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12278, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12285 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12278, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14517;
BgL_sz00_14517 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14518;
BgL_bpz00_14518 = 
VECTOR_REF(
((obj_t)BgL_sz00_14517),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14517, BgL_bpz00_14518, 
BINT(BgL_siza7ezd2framez75_12285)))
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14519;
BgL_ez00_14519 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14519, BgL_bpz00_14518); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14520;
BgL_accz00_14520 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12284, BgL_sz00_14517, BgL_bpz00_14518); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14519); 
VECTOR_SET(
((obj_t)BgL_sz00_14517),((long)0),BgL_bpz00_14518); 
return BgL_accz00_14520;} }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14521;
BgL_nsz00_14521 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14521,((long)1),BgL_sz00_14517); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14522;
BgL_z12denvz12_14522 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14522, BgL_nsz00_14521); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14523;
BgL_ez00_14523 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14523, BgL_sz00_14517); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14524;
BgL_____rz00_14524 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12284, BgL_nsz00_14521, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14523); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14522, BgL_sz00_14517); 
return BgL_____rz00_14524;} } } } } } } } 

}



/* &run5225 */
obj_t BGl_z62run5225z62zz__evaluate_compz00(obj_t BgL_envz00_12286, obj_t BgL_sz00_12292)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12287;long BgL_siza7eza7_12288;obj_t BgL_valza2za2_12289;BgL_ev_absz00_bglt BgL_i1243z00_12290;obj_t BgL_bodyz00_12291;
BgL_iboxesz00_12287 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12286, 
(int)(((long)0)))); 
BgL_siza7eza7_12288 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12286, 
(int)(((long)1)))); 
BgL_valza2za2_12289 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12286, 
(int)(((long)2)))); 
BgL_i1243z00_12290 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12286, 
(int)(((long)3)))); 
BgL_bodyz00_12291 = 
PROCEDURE_REF(BgL_envz00_12286, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14525;
BgL_bpz00_14525 = 
VECTOR_REF(
((obj_t)BgL_sz00_12292),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12292, BgL_iboxesz00_12287, BgL_bpz00_14525); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12292, BgL_valza2za2_12289, 
(
(long)CINT(BgL_bpz00_14525)+BgL_siza7eza7_12288)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14526;obj_t BgL_wherez00_14527;obj_t BgL_locz00_14528;
BgL_z12denvz12_14526 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14527 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12290))->BgL_wherez00); 
BgL_locz00_14528 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12290))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14526, BgL_wherez00_14527, BgL_locz00_14528); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14529;
BgL_za2za2resza2za2z00_14529 = 
PROCEDURE_ENTRY(BgL_bodyz00_12291)(BgL_bodyz00_12291, BgL_sz00_12292, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14526); 
return BgL_za2za2resza2za2z00_14529;} } } } } } 

}



/* &<@anonymous:3629> */
obj_t BGl_z62zc3z04anonymousza33629ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12293, obj_t BgL_sz00_12297)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12294;obj_t BgL_bodyz00_12295;long BgL_siza7ezd2framez75_12296;
BgL_i1243z00_12294 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12293, 
(int)(((long)0)))); 
BgL_bodyz00_12295 = 
PROCEDURE_REF(BgL_envz00_12293, 
(int)(((long)1))); 
BgL_siza7ezd2framez75_12296 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12293, 
(int)(((long)2)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14530;
BgL_bpz00_14530 = 
VECTOR_REF(
((obj_t)BgL_sz00_12297),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14531;
BgL_runz00_14531 = 
MAKE_FX_PROCEDURE(BGl_z62run5227z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_runz00_14531, 
(int)(((long)0)), 
((obj_t)BgL_i1243z00_12294)); 
PROCEDURE_SET(BgL_runz00_14531, 
(int)(((long)1)), BgL_bodyz00_12295); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14532;
BgL_mainz00_14532 = 
MAKE_VA_PROCEDURE(BGl_z62main5226z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_mainz00_14532, 
(int)(((long)0)), BgL_bodyz00_12295); 
PROCEDURE_SET(BgL_mainz00_14532, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12294)); 
PROCEDURE_SET(BgL_mainz00_14532, 
(int)(((long)2)), BgL_runz00_14531); 
PROCEDURE_SET(BgL_mainz00_14532, 
(int)(((long)3)), 
BINT(BgL_siza7ezd2framez75_12296)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14533;
BgL_objz00_14533 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14531, BgL_objz00_14533); BgL_objz00_14533; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3630z00_14534;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3631z00_14535;obj_t BgL_arg3632z00_14536;
BgL_arg3631z00_14535 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12294))->BgL_arityz00); 
BgL_arg3632z00_14536 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12294))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14537;
BgL_newz00_14537 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27522;
BgL_tmpz00_27522 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14537, BgL_tmpz00_27522, BgL_arg3632z00_14536); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27527;int BgL_tmpz00_27525;
BgL_auxz00_27527 = 
BINT(BgL_siza7ezd2framez75_12296); 
BgL_tmpz00_27525 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14537, BgL_tmpz00_27525, BgL_auxz00_27527); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27530;
BgL_tmpz00_27530 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14537, BgL_tmpz00_27530, BgL_runz00_14531); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27533;
BgL_tmpz00_27533 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14537, BgL_tmpz00_27533, BgL_arg3631z00_14535); } 
BgL_arg3630z00_14534 = BgL_newz00_14537; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14532, BgL_arg3630z00_14534); BgL_arg3630z00_14534; } 
return BgL_mainz00_14532;} } } } } } 

}



/* &main5226 */
obj_t BGl_z62main5226z62zz__evaluate_compz00(obj_t BgL_envz00_12298, obj_t BgL_az00_12303, obj_t BgL_bz00_12304, obj_t BgL_cz00_12305, obj_t BgL_dz00_12306, obj_t BgL_restz00_12307)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12300;obj_t BgL_runz00_12301;long BgL_siza7ezd2framez75_12302;
BgL_i1243z00_12300 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12298, 
(int)(((long)1)))); 
BgL_runz00_12301 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12298, 
(int)(((long)2)))); 
BgL_siza7ezd2framez75_12302 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12298, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14538;
BgL_sz00_14538 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14539;
BgL_bpz00_14539 = 
VECTOR_REF(
((obj_t)BgL_sz00_14538),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14538, BgL_bpz00_14539, 
BINT(BgL_siza7ezd2framez75_12302)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3635z00_14540;
BgL_arg3635z00_14540 = 
(
(long)CINT(BgL_bpz00_14539)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14538),BgL_arg3635z00_14540,BgL_az00_12303); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3636z00_14541;
BgL_arg3636z00_14541 = 
(
(long)CINT(BgL_bpz00_14539)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14538),BgL_arg3636z00_14541,BgL_bz00_12304); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3637z00_14542;
BgL_arg3637z00_14542 = 
(
(long)CINT(BgL_bpz00_14539)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14538),BgL_arg3637z00_14542,BgL_cz00_12305); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3638z00_14543;
BgL_arg3638z00_14543 = 
(
(long)CINT(BgL_bpz00_14539)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14538),BgL_arg3638z00_14543,BgL_dz00_12306); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14538, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12300))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14539)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12300))->BgL_arityz00), ((long)4)), BgL_restz00_12307, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12300))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14544;
BgL_ez00_14544 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14544, BgL_bpz00_14539); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14545;
BgL_accz00_14545 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12301, BgL_sz00_14538, BgL_bpz00_14539); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14544); 
VECTOR_SET(
((obj_t)BgL_sz00_14538),((long)0),BgL_bpz00_14539); 
return BgL_accz00_14545;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14546;
BgL_nsz00_14546 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14546,((long)1),BgL_sz00_14538); 
VECTOR_SET(BgL_nsz00_14546,((long)2),BgL_az00_12303); 
VECTOR_SET(BgL_nsz00_14546,((long)3),BgL_bz00_12304); 
VECTOR_SET(BgL_nsz00_14546,((long)4),BgL_cz00_12305); 
VECTOR_SET(BgL_nsz00_14546,((long)5),BgL_dz00_12306); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14546, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12300))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12300))->BgL_arityz00), ((long)4)), BgL_restz00_12307, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12300))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14547;
BgL_z12denvz12_14547 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14547, BgL_nsz00_14546); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14548;
BgL_ez00_14548 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14548, BgL_sz00_14538); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14549;
BgL_____rz00_14549 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12301, BgL_nsz00_14546, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14548); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14547, BgL_sz00_14538); 
return BgL_____rz00_14549;} } } } } } } } 

}



/* &run5227 */
obj_t BGl_z62run5227z62zz__evaluate_compz00(obj_t BgL_envz00_12308, obj_t BgL_sz00_12311)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12309;obj_t BgL_bodyz00_12310;
BgL_i1243z00_12309 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12308, 
(int)(((long)0)))); 
BgL_bodyz00_12310 = 
PROCEDURE_REF(BgL_envz00_12308, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14550;
BgL_bpz00_14550 = 
VECTOR_REF(
((obj_t)BgL_sz00_12311),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14551;obj_t BgL_wherez00_14552;obj_t BgL_locz00_14553;
BgL_z12denvz12_14551 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14552 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12309))->BgL_wherez00); 
BgL_locz00_14553 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12309))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14551, BgL_wherez00_14552, BgL_locz00_14553); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14554;
BgL_za2za2resza2za2z00_14554 = 
PROCEDURE_ENTRY(BgL_bodyz00_12310)(BgL_bodyz00_12310, BgL_sz00_12311, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14551); 
return BgL_za2za2resza2za2z00_14554;} } } } } } 

}



/* &<@anonymous:3649> */
obj_t BGl_z62zc3z04anonymousza33649ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12312, obj_t BgL_sz00_12317)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12313;BgL_ev_absz00_bglt BgL_i1243z00_12314;obj_t BgL_bodyz00_12315;long BgL_siza7ezd2framez75_12316;
BgL_iboxesz00_12313 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12312, 
(int)(((long)0)))); 
BgL_i1243z00_12314 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12312, 
(int)(((long)1)))); 
BgL_bodyz00_12315 = 
PROCEDURE_REF(BgL_envz00_12312, 
(int)(((long)2))); 
BgL_siza7ezd2framez75_12316 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12312, 
(int)(((long)3)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14555;
BgL_bpz00_14555 = 
VECTOR_REF(
((obj_t)BgL_sz00_12317),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */

{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14556;
BgL_runz00_14556 = 
MAKE_FX_PROCEDURE(BGl_z62run5229z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_runz00_14556, 
(int)(((long)0)), BgL_iboxesz00_12313); 
PROCEDURE_SET(BgL_runz00_14556, 
(int)(((long)1)), 
((obj_t)BgL_i1243z00_12314)); 
PROCEDURE_SET(BgL_runz00_14556, 
(int)(((long)2)), BgL_bodyz00_12315); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14557;
BgL_mainz00_14557 = 
MAKE_VA_PROCEDURE(BGl_z62main5228z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_mainz00_14557, 
(int)(((long)0)), BgL_iboxesz00_12313); 
PROCEDURE_SET(BgL_mainz00_14557, 
(int)(((long)1)), BgL_bodyz00_12315); 
PROCEDURE_SET(BgL_mainz00_14557, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12314)); 
PROCEDURE_SET(BgL_mainz00_14557, 
(int)(((long)3)), BgL_runz00_14556); 
PROCEDURE_SET(BgL_mainz00_14557, 
(int)(((long)4)), 
BINT(BgL_siza7ezd2framez75_12316)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14558;
BgL_objz00_14558 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14556, BgL_objz00_14558); BgL_objz00_14558; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3650z00_14559;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3651z00_14560;obj_t BgL_arg3652z00_14561;
BgL_arg3651z00_14560 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12314))->BgL_arityz00); 
BgL_arg3652z00_14561 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12314))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14562;
BgL_newz00_14562 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27659;
BgL_tmpz00_27659 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14562, BgL_tmpz00_27659, BgL_arg3652z00_14561); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27664;int BgL_tmpz00_27662;
BgL_auxz00_27664 = 
BINT(BgL_siza7ezd2framez75_12316); 
BgL_tmpz00_27662 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14562, BgL_tmpz00_27662, BgL_auxz00_27664); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27667;
BgL_tmpz00_27667 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14562, BgL_tmpz00_27667, BgL_runz00_14556); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27670;
BgL_tmpz00_27670 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14562, BgL_tmpz00_27670, BgL_arg3651z00_14560); } 
BgL_arg3650z00_14559 = BgL_newz00_14562; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14557, BgL_arg3650z00_14559); BgL_arg3650z00_14559; } 
return BgL_mainz00_14557;} } } } } } 

}



/* &main5228 */
obj_t BGl_z62main5228z62zz__evaluate_compz00(obj_t BgL_envz00_12318, obj_t BgL_az00_12324, obj_t BgL_bz00_12325, obj_t BgL_cz00_12326, obj_t BgL_dz00_12327, obj_t BgL_restz00_12328)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12321;obj_t BgL_runz00_12322;long BgL_siza7ezd2framez75_12323;
BgL_i1243z00_12321 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12318, 
(int)(((long)2)))); 
BgL_runz00_12322 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12318, 
(int)(((long)3)))); 
BgL_siza7ezd2framez75_12323 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12318, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14563;
BgL_sz00_14563 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14564;
BgL_bpz00_14564 = 
VECTOR_REF(
((obj_t)BgL_sz00_14563),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14563, BgL_bpz00_14564, 
BINT(BgL_siza7ezd2framez75_12323)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3655z00_14565;
BgL_arg3655z00_14565 = 
(
(long)CINT(BgL_bpz00_14564)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14563),BgL_arg3655z00_14565,BgL_az00_12324); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3656z00_14566;
BgL_arg3656z00_14566 = 
(
(long)CINT(BgL_bpz00_14564)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14563),BgL_arg3656z00_14566,BgL_bz00_12325); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3657z00_14567;
BgL_arg3657z00_14567 = 
(
(long)CINT(BgL_bpz00_14564)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14563),BgL_arg3657z00_14567,BgL_cz00_12326); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3658z00_14568;
BgL_arg3658z00_14568 = 
(
(long)CINT(BgL_bpz00_14564)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14563),BgL_arg3658z00_14568,BgL_dz00_12327); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14563, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12321))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14564)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12321))->BgL_arityz00), ((long)4)), BgL_restz00_12328, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12321))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14569;
BgL_ez00_14569 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14569, BgL_bpz00_14564); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14570;
BgL_accz00_14570 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12322, BgL_sz00_14563, BgL_bpz00_14564); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14569); 
VECTOR_SET(
((obj_t)BgL_sz00_14563),((long)0),BgL_bpz00_14564); 
return BgL_accz00_14570;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14571;
BgL_nsz00_14571 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14571,((long)1),BgL_sz00_14563); 
VECTOR_SET(BgL_nsz00_14571,((long)2),BgL_az00_12324); 
VECTOR_SET(BgL_nsz00_14571,((long)3),BgL_bz00_12325); 
VECTOR_SET(BgL_nsz00_14571,((long)4),BgL_cz00_12326); 
VECTOR_SET(BgL_nsz00_14571,((long)5),BgL_dz00_12327); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14571, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12321))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12321))->BgL_arityz00), ((long)4)), BgL_restz00_12328, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12321))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14572;
BgL_z12denvz12_14572 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14572, BgL_nsz00_14571); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14573;
BgL_ez00_14573 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14573, BgL_sz00_14563); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14574;
BgL_____rz00_14574 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12322, BgL_nsz00_14571, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14573); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14572, BgL_sz00_14563); 
return BgL_____rz00_14574;} } } } } } } } 

}



/* &run5229 */
obj_t BGl_z62run5229z62zz__evaluate_compz00(obj_t BgL_envz00_12329, obj_t BgL_sz00_12333)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12330;BgL_ev_absz00_bglt BgL_i1243z00_12331;obj_t BgL_bodyz00_12332;
BgL_iboxesz00_12330 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12329, 
(int)(((long)0)))); 
BgL_i1243z00_12331 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12329, 
(int)(((long)1)))); 
BgL_bodyz00_12332 = 
PROCEDURE_REF(BgL_envz00_12329, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14575;
BgL_bpz00_14575 = 
VECTOR_REF(
((obj_t)BgL_sz00_12333),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12333, BgL_iboxesz00_12330, BgL_bpz00_14575); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14576;obj_t BgL_wherez00_14577;obj_t BgL_locz00_14578;
BgL_z12denvz12_14576 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14577 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12331))->BgL_wherez00); 
BgL_locz00_14578 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12331))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1174 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14576, BgL_wherez00_14577, BgL_locz00_14578); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_za2za2resza2za2z00_14579;
BgL_za2za2resza2za2z00_14579 = 
PROCEDURE_ENTRY(BgL_bodyz00_12332)(BgL_bodyz00_12332, BgL_sz00_12333, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14576); 
return BgL_za2za2resza2za2z00_14579;} } } } } } 

}



/* &<@anonymous:3672> */
obj_t BGl_z62zc3z04anonymousza33672ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12334, obj_t BgL_sz00_12340)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12335;long BgL_siza7eza7_12336;BgL_ev_absz00_bglt BgL_i1243z00_12337;obj_t BgL_bodyz00_12338;long BgL_siza7ezd2framez75_12339;
BgL_ifreesz00_12335 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12334, 
(int)(((long)0)))); 
BgL_siza7eza7_12336 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12334, 
(int)(((long)1)))); 
BgL_i1243z00_12337 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12334, 
(int)(((long)2)))); 
BgL_bodyz00_12338 = 
PROCEDURE_REF(BgL_envz00_12334, 
(int)(((long)3))); 
BgL_siza7ezd2framez75_12339 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12334, 
(int)(((long)4)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14580;
BgL_bpz00_14580 = 
VECTOR_REF(
((obj_t)BgL_sz00_12340),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14581;
BgL_valza2za2_14581 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12340, BgL_bpz00_14580, BgL_ifreesz00_12335); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14582;
BgL_runz00_14582 = 
MAKE_FX_PROCEDURE(BGl_z62run5231z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_runz00_14582, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12336)); 
PROCEDURE_SET(BgL_runz00_14582, 
(int)(((long)1)), BgL_valza2za2_14581); 
PROCEDURE_SET(BgL_runz00_14582, 
(int)(((long)2)), 
((obj_t)BgL_i1243z00_12337)); 
PROCEDURE_SET(BgL_runz00_14582, 
(int)(((long)3)), BgL_bodyz00_12338); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14583;
BgL_mainz00_14583 = 
MAKE_VA_PROCEDURE(BGl_z62main5230z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)6))); 
PROCEDURE_SET(BgL_mainz00_14583, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_12336)); 
PROCEDURE_SET(BgL_mainz00_14583, 
(int)(((long)1)), BgL_valza2za2_14581); 
PROCEDURE_SET(BgL_mainz00_14583, 
(int)(((long)2)), BgL_bodyz00_12338); 
PROCEDURE_SET(BgL_mainz00_14583, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12337)); 
PROCEDURE_SET(BgL_mainz00_14583, 
(int)(((long)4)), BgL_runz00_14582); 
PROCEDURE_SET(BgL_mainz00_14583, 
(int)(((long)5)), 
BINT(BgL_siza7ezd2framez75_12339)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14584;
BgL_objz00_14584 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14582, BgL_objz00_14584); BgL_objz00_14584; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3673z00_14585;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3674z00_14586;obj_t BgL_arg3675z00_14587;
BgL_arg3674z00_14586 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12337))->BgL_arityz00); 
BgL_arg3675z00_14587 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12337))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14588;
BgL_newz00_14588 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27810;
BgL_tmpz00_27810 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14588, BgL_tmpz00_27810, BgL_arg3675z00_14587); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27815;int BgL_tmpz00_27813;
BgL_auxz00_27815 = 
BINT(BgL_siza7ezd2framez75_12339); 
BgL_tmpz00_27813 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14588, BgL_tmpz00_27813, BgL_auxz00_27815); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27818;
BgL_tmpz00_27818 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14588, BgL_tmpz00_27818, BgL_runz00_14582); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27821;
BgL_tmpz00_27821 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14588, BgL_tmpz00_27821, BgL_arg3674z00_14586); } 
BgL_arg3673z00_14585 = BgL_newz00_14588; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14583, BgL_arg3673z00_14585); BgL_arg3673z00_14585; } 
return BgL_mainz00_14583;} } } } } } 

}



/* &main5230 */
obj_t BGl_z62main5230z62zz__evaluate_compz00(obj_t BgL_envz00_12341, obj_t BgL_az00_12348, obj_t BgL_bz00_12349, obj_t BgL_cz00_12350, obj_t BgL_dz00_12351, obj_t BgL_restz00_12352)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12345;obj_t BgL_runz00_12346;long BgL_siza7ezd2framez75_12347;
BgL_i1243z00_12345 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12341, 
(int)(((long)3)))); 
BgL_runz00_12346 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12341, 
(int)(((long)4)))); 
BgL_siza7ezd2framez75_12347 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12341, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14589;
BgL_sz00_14589 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14590;
BgL_bpz00_14590 = 
VECTOR_REF(
((obj_t)BgL_sz00_14589),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14589, BgL_bpz00_14590, 
BINT(BgL_siza7ezd2framez75_12347)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3678z00_14591;
BgL_arg3678z00_14591 = 
(
(long)CINT(BgL_bpz00_14590)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14589),BgL_arg3678z00_14591,BgL_az00_12348); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3679z00_14592;
BgL_arg3679z00_14592 = 
(
(long)CINT(BgL_bpz00_14590)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14589),BgL_arg3679z00_14592,BgL_bz00_12349); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3680z00_14593;
BgL_arg3680z00_14593 = 
(
(long)CINT(BgL_bpz00_14590)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14589),BgL_arg3680z00_14593,BgL_cz00_12350); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3681z00_14594;
BgL_arg3681z00_14594 = 
(
(long)CINT(BgL_bpz00_14590)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14589),BgL_arg3681z00_14594,BgL_dz00_12351); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14589, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12345))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14590)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12345))->BgL_arityz00), ((long)4)), BgL_restz00_12352, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12345))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14595;
BgL_ez00_14595 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14595, BgL_bpz00_14590); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14596;
BgL_accz00_14596 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12346, BgL_sz00_14589, BgL_bpz00_14590); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14595); 
VECTOR_SET(
((obj_t)BgL_sz00_14589),((long)0),BgL_bpz00_14590); 
return BgL_accz00_14596;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14597;
BgL_nsz00_14597 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14597,((long)1),BgL_sz00_14589); 
VECTOR_SET(BgL_nsz00_14597,((long)2),BgL_az00_12348); 
VECTOR_SET(BgL_nsz00_14597,((long)3),BgL_bz00_12349); 
VECTOR_SET(BgL_nsz00_14597,((long)4),BgL_cz00_12350); 
VECTOR_SET(BgL_nsz00_14597,((long)5),BgL_dz00_12351); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14597, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12345))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12345))->BgL_arityz00), ((long)4)), BgL_restz00_12352, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12345))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14598;
BgL_z12denvz12_14598 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14598, BgL_nsz00_14597); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14599;
BgL_ez00_14599 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14599, BgL_sz00_14589); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14600;
BgL_____rz00_14600 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12346, BgL_nsz00_14597, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14599); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14598, BgL_sz00_14589); 
return BgL_____rz00_14600;} } } } } } } } 

}



/* &run5231 */
obj_t BGl_z62run5231z62zz__evaluate_compz00(obj_t BgL_envz00_12353, obj_t BgL_sz00_12358)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_siza7eza7_12354;obj_t BgL_valza2za2_12355;BgL_ev_absz00_bglt BgL_i1243z00_12356;obj_t BgL_bodyz00_12357;
BgL_siza7eza7_12354 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12353, 
(int)(((long)0)))); 
BgL_valza2za2_12355 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12353, 
(int)(((long)1)))); 
BgL_i1243z00_12356 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12353, 
(int)(((long)2)))); 
BgL_bodyz00_12357 = 
PROCEDURE_REF(BgL_envz00_12353, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14601;
BgL_bpz00_14601 = 
VECTOR_REF(
((obj_t)BgL_sz00_12358),((long)0)); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12358, BgL_valza2za2_12355, 
(
(long)CINT(BgL_bpz00_14601)+BgL_siza7eza7_12354)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14602;obj_t BgL_wherez00_14603;obj_t BgL_locz00_14604;
BgL_z12denvz12_14602 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14603 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12356))->BgL_wherez00); 
BgL_locz00_14604 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12356))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14602, BgL_wherez00_14603, BgL_locz00_14604); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14605;
BgL_za2za2resza2za2z00_14605 = 
PROCEDURE_ENTRY(BgL_bodyz00_12357)(BgL_bodyz00_12357, BgL_sz00_12358, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14602); 
return BgL_za2za2resza2za2z00_14605;} } } } } } 

}



/* &<@anonymous:3693> */
obj_t BGl_z62zc3z04anonymousza33693ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12359, obj_t BgL_sz00_12366)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ifreesz00_12360;obj_t BgL_iboxesz00_12361;long BgL_siza7eza7_12362;BgL_ev_absz00_bglt BgL_i1243z00_12363;obj_t BgL_bodyz00_12364;long BgL_siza7ezd2framez75_12365;
BgL_ifreesz00_12360 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12359, 
(int)(((long)0)))); 
BgL_iboxesz00_12361 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12359, 
(int)(((long)1)))); 
BgL_siza7eza7_12362 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12359, 
(int)(((long)2)))); 
BgL_i1243z00_12363 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12359, 
(int)(((long)3)))); 
BgL_bodyz00_12364 = 
PROCEDURE_REF(BgL_envz00_12359, 
(int)(((long)4))); 
BgL_siza7ezd2framez75_12365 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12359, 
(int)(((long)5)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14606;
BgL_bpz00_14606 = 
VECTOR_REF(
((obj_t)BgL_sz00_12366),((long)0)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_valza2za2_14607;
BgL_valza2za2_14607 = 
BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_12366, BgL_bpz00_14606, BgL_ifreesz00_12360); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_runz00_14608;
BgL_runz00_14608 = 
MAKE_FX_PROCEDURE(BGl_z62run5233z62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_runz00_14608, 
(int)(((long)0)), BgL_iboxesz00_12361); 
PROCEDURE_SET(BgL_runz00_14608, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12362)); 
PROCEDURE_SET(BgL_runz00_14608, 
(int)(((long)2)), BgL_valza2za2_14607); 
PROCEDURE_SET(BgL_runz00_14608, 
(int)(((long)3)), 
((obj_t)BgL_i1243z00_12363)); 
PROCEDURE_SET(BgL_runz00_14608, 
(int)(((long)4)), BgL_bodyz00_12364); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_mainz00_14609;
BgL_mainz00_14609 = 
MAKE_VA_PROCEDURE(BGl_z62main5232z62zz__evaluate_compz00, 
(int)(((long)-5)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_mainz00_14609, 
(int)(((long)0)), BgL_iboxesz00_12361); 
PROCEDURE_SET(BgL_mainz00_14609, 
(int)(((long)1)), 
BINT(BgL_siza7eza7_12362)); 
PROCEDURE_SET(BgL_mainz00_14609, 
(int)(((long)2)), BgL_valza2za2_14607); 
PROCEDURE_SET(BgL_mainz00_14609, 
(int)(((long)3)), BgL_bodyz00_12364); 
PROCEDURE_SET(BgL_mainz00_14609, 
(int)(((long)4)), 
((obj_t)BgL_i1243z00_12363)); 
PROCEDURE_SET(BgL_mainz00_14609, 
(int)(((long)5)), BgL_runz00_14608); 
PROCEDURE_SET(BgL_mainz00_14609, 
(int)(((long)6)), 
BINT(BgL_siza7ezd2framez75_12365)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_objz00_14610;
BgL_objz00_14610 = BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00; 
PROCEDURE_ATTR_SET(BgL_runz00_14608, BgL_objz00_14610); BgL_objz00_14610; } 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3694z00_14611;
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_arg3695z00_14612;obj_t BgL_arg3696z00_14613;
BgL_arg3695z00_14612 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12363))->BgL_arityz00); 
BgL_arg3696z00_14613 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12363))->BgL_wherez00); 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_newz00_14614;
BgL_newz00_14614 = 
create_struct(BGl_symbol5263z00zz__evaluate_compz00, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27973;
BgL_tmpz00_27973 = 
(int)(((long)3)); 
STRUCT_SET(BgL_newz00_14614, BgL_tmpz00_27973, BgL_arg3696z00_14613); } 
{ /* Eval/evaluate_comp.scm 683 */
obj_t BgL_auxz00_27978;int BgL_tmpz00_27976;
BgL_auxz00_27978 = 
BINT(BgL_siza7ezd2framez75_12365); 
BgL_tmpz00_27976 = 
(int)(((long)2)); 
STRUCT_SET(BgL_newz00_14614, BgL_tmpz00_27976, BgL_auxz00_27978); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27981;
BgL_tmpz00_27981 = 
(int)(((long)1)); 
STRUCT_SET(BgL_newz00_14614, BgL_tmpz00_27981, BgL_runz00_14608); } 
{ /* Eval/evaluate_comp.scm 683 */
int BgL_tmpz00_27984;
BgL_tmpz00_27984 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14614, BgL_tmpz00_27984, BgL_arg3695z00_14612); } 
BgL_arg3694z00_14611 = BgL_newz00_14614; } } 
PROCEDURE_ATTR_SET(BgL_mainz00_14609, BgL_arg3694z00_14611); BgL_arg3694z00_14611; } 
return BgL_mainz00_14609;} } } } } } 

}



/* &main5232 */
obj_t BGl_z62main5232z62zz__evaluate_compz00(obj_t BgL_envz00_12367, obj_t BgL_az00_12375, obj_t BgL_bz00_12376, obj_t BgL_cz00_12377, obj_t BgL_dz00_12378, obj_t BgL_restz00_12379)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
BgL_ev_absz00_bglt BgL_i1243z00_12372;obj_t BgL_runz00_12373;long BgL_siza7ezd2framez75_12374;
BgL_i1243z00_12372 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12367, 
(int)(((long)4)))); 
BgL_runz00_12373 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12367, 
(int)(((long)5)))); 
BgL_siza7ezd2framez75_12374 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12367, 
(int)(((long)6)))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_sz00_14615;
BgL_sz00_14615 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14616;
BgL_bpz00_14616 = 
VECTOR_REF(
((obj_t)BgL_sz00_14615),((long)0)); 
if(
BGl_checkzd2stackzd2zz__evaluate_compz00(BgL_sz00_14615, BgL_bpz00_14616, 
BINT(BgL_siza7ezd2framez75_12374)))
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3699z00_14617;
BgL_arg3699z00_14617 = 
(
(long)CINT(BgL_bpz00_14616)+((long)0)); 
VECTOR_SET(
((obj_t)BgL_sz00_14615),BgL_arg3699z00_14617,BgL_az00_12375); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3700z00_14618;
BgL_arg3700z00_14618 = 
(
(long)CINT(BgL_bpz00_14616)+((long)1)); 
VECTOR_SET(
((obj_t)BgL_sz00_14615),BgL_arg3700z00_14618,BgL_bz00_12376); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3701z00_14619;
BgL_arg3701z00_14619 = 
(
(long)CINT(BgL_bpz00_14616)+((long)2)); 
VECTOR_SET(
((obj_t)BgL_sz00_14615),BgL_arg3701z00_14619,BgL_cz00_12377); } 
{ /* Eval/evaluate_comp.scm 1174 */
long BgL_arg3702z00_14620;
BgL_arg3702z00_14620 = 
(
(long)CINT(BgL_bpz00_14616)+((long)3)); 
VECTOR_SET(
((obj_t)BgL_sz00_14615),BgL_arg3702z00_14620,BgL_dz00_12378); } 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_14615, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12372))->BgL_wherez00), 
(
(long)CINT(BgL_bpz00_14616)+((long)4)), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12372))->BgL_arityz00), ((long)4)), BgL_restz00_12379, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12372))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14621;
BgL_ez00_14621 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14621, BgL_bpz00_14616); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_accz00_14622;
BgL_accz00_14622 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12373, BgL_sz00_14615, BgL_bpz00_14616); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14621); 
VECTOR_SET(
((obj_t)BgL_sz00_14615),((long)0),BgL_bpz00_14616); 
return BgL_accz00_14622;} } }  else 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_nsz00_14623;
BgL_nsz00_14623 = 
BGl_makezd2statezd2zz__evaluate_compz00(); 
VECTOR_SET(BgL_nsz00_14623,((long)1),BgL_sz00_14615); 
VECTOR_SET(BgL_nsz00_14623,((long)2),BgL_az00_12375); 
VECTOR_SET(BgL_nsz00_14623,((long)3),BgL_bz00_12376); 
VECTOR_SET(BgL_nsz00_14623,((long)4),BgL_cz00_12377); 
VECTOR_SET(BgL_nsz00_14623,((long)5),BgL_dz00_12378); 
BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_14623, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12372))->BgL_wherez00), ((long)6), 
BGl_correctz00zz__evaluate_compz00(
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12372))->BgL_arityz00), ((long)4)), BgL_restz00_12379, 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12372))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_z12denvz12_14624;
BgL_z12denvz12_14624 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14624, BgL_nsz00_14623); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_ez00_14625;
BgL_ez00_14625 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_14625, BgL_sz00_14615); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_____rz00_14626;
BgL_____rz00_14626 = 
BGl_catchzd2trampolinezd2zz__evaluate_compz00(BgL_runz00_12373, BgL_nsz00_14623, 
BINT(((long)2))); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_14625); 
BGL_ENV_EVSTATE_SET(BgL_z12denvz12_14624, BgL_sz00_14615); 
return BgL_____rz00_14626;} } } } } } } } 

}



/* &run5233 */
obj_t BGl_z62run5233z62zz__evaluate_compz00(obj_t BgL_envz00_12380, obj_t BgL_sz00_12386)
{
{ /* Eval/evaluate_comp.scm 1174 */
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_iboxesz00_12381;long BgL_siza7eza7_12382;obj_t BgL_valza2za2_12383;BgL_ev_absz00_bglt BgL_i1243z00_12384;obj_t BgL_bodyz00_12385;
BgL_iboxesz00_12381 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12380, 
(int)(((long)0)))); 
BgL_siza7eza7_12382 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12380, 
(int)(((long)1)))); 
BgL_valza2za2_12383 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12380, 
(int)(((long)2)))); 
BgL_i1243z00_12384 = 
((BgL_ev_absz00_bglt)
PROCEDURE_REF(BgL_envz00_12380, 
(int)(((long)3)))); 
BgL_bodyz00_12385 = 
PROCEDURE_REF(BgL_envz00_12380, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 1174 */
obj_t BgL_bpz00_14627;
BgL_bpz00_14627 = 
VECTOR_REF(
((obj_t)BgL_sz00_12386),((long)0)); 
BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_12386, BgL_iboxesz00_12381, BgL_bpz00_14627); 
BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_12386, BgL_valza2za2_12383, 
(
(long)CINT(BgL_bpz00_14627)+BgL_siza7eza7_12382)); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_z12denvz12_14628;obj_t BgL_wherez00_14629;obj_t BgL_locz00_14630;
BgL_z12denvz12_14628 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_wherez00_14629 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12384))->BgL_wherez00); 
BgL_locz00_14630 = 
(((BgL_ev_absz00_bglt)COBJECT(BgL_i1243z00_12384))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 1095 */

BGL_ENV_PUSH_TRACE(BgL_z12denvz12_14628, BgL_wherez00_14629, BgL_locz00_14630); 
{ /* Eval/evaluate_comp.scm 1095 */
obj_t BgL_za2za2resza2za2z00_14631;
BgL_za2za2resza2za2z00_14631 = 
PROCEDURE_ENTRY(BgL_bodyz00_12385)(BgL_bodyz00_12385, BgL_sz00_12386, BEOA); 
BGL_ENV_POP_TRACE(BgL_z12denvz12_14628); 
return BgL_za2za2resza2za2z00_14631;} } } } } } 

}



/* &comp-ev_app1429 */
obj_t BGl_z62compzd2ev_app1429zb0zz__evaluate_compz00(obj_t BgL_envz00_12387, obj_t BgL_ez00_12388, obj_t BgL_stkz00_12389)
{
{ /* Eval/evaluate_comp.scm 1044 */
{ /* Eval/evaluate_comp.scm 1046 */
obj_t BgL__ortest_1229z00_14633;
BgL__ortest_1229z00_14633 = 
BGl_arithzd2expressionzd2zz__evaluate_compz00(
((BgL_ev_appz00_bglt)BgL_ez00_12388), BgL_stkz00_12389); 
if(
CBOOL(BgL__ortest_1229z00_14633))
{ /* Eval/evaluate_comp.scm 1046 */
return BgL__ortest_1229z00_14633;}  else 
{ /* Eval/evaluate_comp.scm 1047 */
obj_t BgL__ortest_1230z00_14634;
BgL__ortest_1230z00_14634 = 
BGl_inlinezd2callzd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_funz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_argsz00), BgL_stkz00_12389); 
if(
CBOOL(BgL__ortest_1230z00_14634))
{ /* Eval/evaluate_comp.scm 1047 */
return BgL__ortest_1230z00_14634;}  else 
{ /* Eval/evaluate_comp.scm 1047 */
if(
(
bgl_list_length(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_argsz00))>((long)4)))
{ /* Eval/evaluate_comp.scm 1048 */
return 
BGl_compzd2oldzd2callz00zz__evaluate_compz00(
((BgL_ev_appz00_bglt)BgL_ez00_12388), BgL_stkz00_12389);}  else 
{ /* Eval/evaluate_comp.scm 1050 */
obj_t BgL_fz00_14635;long BgL_siza7eza7_14636;obj_t BgL_symbzd2funzd2_14637;
BgL_fz00_14635 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_funz00), BgL_stkz00_12389); 
BgL_siza7eza7_14636 = 
bgl_list_length(BgL_stkz00_12389); 
BgL_symbzd2funzd2_14637 = 
BGl_uncompilez00zz__evaluate_uncompz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_funz00)); 
if(
NULLP(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_argsz00)))
{ /* Eval/evaluate_comp.scm 1051 */
return 
BGl_compzd2call0zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_funz00), BgL_symbzd2funzd2_14637, BgL_fz00_14635, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_tailzf3zf3), BgL_stkz00_12389, BgL_siza7eza7_14636);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a1z00_14638;obj_t BgL_argsz00_14639;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3163z00_14640;
BgL_arg3163z00_14640 = 
CAR(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_argsz00)); 
BgL_a1z00_14638 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3163z00_14640), BgL_stkz00_12389); } 
BgL_argsz00_14639 = 
CDR(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_argsz00)); 
if(
NULLP(BgL_argsz00_14639))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call1zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_funz00), BgL_symbzd2funzd2_14637, BgL_fz00_14635, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_tailzf3zf3), BgL_stkz00_12389, BgL_siza7eza7_14636, BgL_a1z00_14638);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a2z00_14641;obj_t BgL_argsz00_14642;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3162z00_14643;
BgL_arg3162z00_14643 = 
CAR(
((obj_t)BgL_argsz00_14639)); 
BgL_a2z00_14641 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3162z00_14643), BgL_stkz00_12389); } 
BgL_argsz00_14642 = 
CDR(
((obj_t)BgL_argsz00_14639)); 
if(
NULLP(BgL_argsz00_14642))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call2zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_funz00), BgL_symbzd2funzd2_14637, BgL_fz00_14635, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_tailzf3zf3), BgL_stkz00_12389, BgL_siza7eza7_14636, BgL_a1z00_14638, BgL_a2z00_14641);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a3z00_14644;obj_t BgL_argsz00_14645;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3161z00_14646;
BgL_arg3161z00_14646 = 
CAR(
((obj_t)BgL_argsz00_14642)); 
BgL_a3z00_14644 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3161z00_14646), BgL_stkz00_12389); } 
BgL_argsz00_14645 = 
CDR(
((obj_t)BgL_argsz00_14642)); 
if(
NULLP(BgL_argsz00_14645))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call3zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_funz00), BgL_symbzd2funzd2_14637, BgL_fz00_14635, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_tailzf3zf3), BgL_stkz00_12389, BgL_siza7eza7_14636, BgL_a1z00_14638, BgL_a2z00_14641, BgL_a3z00_14644);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_a4z00_14647;obj_t BgL_argsz00_14648;
{ /* Eval/evaluate_comp.scm 1053 */
obj_t BgL_arg3160z00_14649;
BgL_arg3160z00_14649 = 
CAR(
((obj_t)BgL_argsz00_14645)); 
BgL_a4z00_14647 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3160z00_14649), BgL_stkz00_12389); } 
BgL_argsz00_14648 = 
CDR(
((obj_t)BgL_argsz00_14645)); 
if(
NULLP(BgL_argsz00_14648))
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_compzd2call4zd2zz__evaluate_compz00(
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_locz00), 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_funz00), BgL_symbzd2funzd2_14637, BgL_fz00_14635, 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_ez00_12388)))->BgL_tailzf3zf3), BgL_stkz00_12389, BgL_siza7eza7_14636, BgL_a1z00_14638, BgL_a2z00_14641, BgL_a3z00_14644, BgL_a4z00_14647);}  else 
{ /* Eval/evaluate_comp.scm 1053 */
return 
BGl_errorz00zz__errorz00(BGl_string5246z00zz__evaluate_compz00, BGl_string5361z00zz__evaluate_compz00, BGl_string5362z00zz__evaluate_compz00);} } } } } } } } } } 

}



/* &comp-ev_goto1427 */
obj_t BGl_z62compzd2ev_goto1427zb0zz__evaluate_compz00(obj_t BgL_envz00_12390, obj_t BgL_ez00_12391, obj_t BgL_stkz00_12392)
{
{ /* Eval/evaluate_comp.scm 604 */
{ /* Eval/evaluate_comp.scm 607 */
obj_t BgL_slotz00_14653;long BgL_siza7eza7_14654;obj_t BgL_lstkz00_14655;
BgL_slotz00_14653 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_labelz00)), 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_labelsz00)))->BgL_envz00)); 
BgL_siza7eza7_14654 = 
bgl_list_length(BgL_stkz00_12392); 
BgL_lstkz00_14655 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_labelsz00)))->BgL_stkz00); 
{ /* Eval/evaluate_comp.scm 609 */
long BgL_llstkz00_14656;obj_t BgL_substkz00_14657;obj_t BgL_boxesz00_14658;
BgL_llstkz00_14656 = 
bgl_list_length(BgL_lstkz00_14655); 
BgL_substkz00_14657 = 
BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_14655, BgL_stkz00_12392); 
{ /* Eval/evaluate_comp.scm 609 */
obj_t BgL_pairz00_14659;
BgL_pairz00_14659 = 
BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
((obj_t)
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_labelz00)), 
(((BgL_ev_labelsz00_bglt)COBJECT(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_labelsz00)))->BgL_boxesz00)); 
BgL_boxesz00_14658 = 
CDR(BgL_pairz00_14659); } 
if(
BGl_needzd2shiftzd2zz__evaluate_compz00(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_argsz00), BgL_substkz00_14657))
{ /* Eval/evaluate_comp.scm 612 */
obj_t BgL_argsz00_14660;long BgL_nbargsz00_14661;
BgL_argsz00_14660 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_argsz00), BgL_stkz00_12392); 
BgL_nbargsz00_14661 = 
bgl_list_length(
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_argsz00)); 
{ /* Eval/evaluate_comp.scm 613 */
obj_t BgL_zc3z04anonymousza33118ze3z87_14662;
BgL_zc3z04anonymousza33118ze3z87_14662 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)7))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_14662, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14654)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_14662, 
(int)(((long)1)), 
BINT(BgL_llstkz00_14656)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_14662, 
(int)(((long)2)), 
((obj_t)
((BgL_ev_gotoz00_bglt)BgL_ez00_12391))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_14662, 
(int)(((long)3)), BgL_argsz00_14660); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_14662, 
(int)(((long)4)), BgL_boxesz00_14658); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_14662, 
(int)(((long)5)), 
BINT(BgL_nbargsz00_14661)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33118ze3z87_14662, 
(int)(((long)6)), BgL_slotz00_14653); 
return BgL_zc3z04anonymousza33118ze3z87_14662;} }  else 
{ /* Eval/evaluate_comp.scm 618 */
obj_t BgL_argsz00_14663;
{ /* Eval/evaluate_comp.scm 618 */
obj_t BgL_lz00_14664;long BgL_nz00_14665;
BgL_lz00_14664 = 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_ez00_12391)))->BgL_argsz00); 
BgL_nz00_14665 = 
(BgL_siza7eza7_14654-BgL_llstkz00_14656); 
BgL_argsz00_14663 = 
BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_12392, BgL_lz00_14664, BgL_nz00_14665); } 
{ /* Eval/evaluate_comp.scm 619 */
obj_t BgL_zc3z04anonymousza33124ze3z87_14666;
BgL_zc3z04anonymousza33124ze3z87_14666 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33124ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)5))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_14666, 
(int)(((long)0)), 
BINT(BgL_llstkz00_14656)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_14666, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_gotoz00_bglt)BgL_ez00_12391))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_14666, 
(int)(((long)2)), BgL_argsz00_14663); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_14666, 
(int)(((long)3)), BgL_boxesz00_14658); 
PROCEDURE_SET(BgL_zc3z04anonymousza33124ze3z87_14666, 
(int)(((long)4)), BgL_slotz00_14653); 
return BgL_zc3z04anonymousza33124ze3z87_14666;} } } } } 

}



/* &<@anonymous:3118> */
obj_t BGl_z62zc3z04anonymousza33118ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12393, obj_t BgL_sz00_12401)
{
{ /* Eval/evaluate_comp.scm 613 */
{ /* Eval/evaluate_comp.scm 613 */
long BgL_siza7eza7_12394;long BgL_llstkz00_12395;BgL_ev_gotoz00_bglt BgL_i1141z00_12396;obj_t BgL_argsz00_12397;obj_t BgL_boxesz00_12398;long BgL_nbargsz00_12399;obj_t BgL_slotz00_12400;
BgL_siza7eza7_12394 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12393, 
(int)(((long)0)))); 
BgL_llstkz00_12395 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12393, 
(int)(((long)1)))); 
BgL_i1141z00_12396 = 
((BgL_ev_gotoz00_bglt)
PROCEDURE_REF(BgL_envz00_12393, 
(int)(((long)2)))); 
BgL_argsz00_12397 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12393, 
(int)(((long)3)))); 
BgL_boxesz00_12398 = 
PROCEDURE_REF(BgL_envz00_12393, 
(int)(((long)4))); 
BgL_nbargsz00_12399 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12393, 
(int)(((long)5)))); 
BgL_slotz00_12400 = 
PROCEDURE_REF(BgL_envz00_12393, 
(int)(((long)6))); 
{ /* Eval/evaluate_comp.scm 613 */
obj_t BgL_bpz00_14667;
BgL_bpz00_14667 = 
VECTOR_REF(
((obj_t)BgL_sz00_12401),((long)0)); 
{ /* Eval/evaluate_comp.scm 614 */
long BgL_spz00_14668;long BgL_lspz00_14669;
BgL_spz00_14668 = 
(
(long)CINT(BgL_bpz00_14667)+BgL_siza7eza7_12394); 
BgL_lspz00_14669 = 
(
(long)CINT(BgL_bpz00_14667)+BgL_llstkz00_12395); 
BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(BgL_sz00_12401, BgL_argsz00_12397, BgL_boxesz00_12398, BgL_spz00_14668, 
(((BgL_ev_gotoz00_bglt)COBJECT(BgL_i1141z00_12396))->BgL_locz00)); 
{ /* Eval/evaluate_comp.scm 616 */
long BgL_arg3120z00_14670;
BgL_arg3120z00_14670 = 
(BgL_spz00_14668+BgL_nbargsz00_12399); 
BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_12401, BgL_lspz00_14669, BgL_sz00_12401, 
BINT(BgL_spz00_14668), 
BINT(BgL_arg3120z00_14670)); } 
return 
CDR(
((obj_t)BgL_slotz00_12400));} } } } 

}



/* &<@anonymous:3124> */
obj_t BGl_z62zc3z04anonymousza33124ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12402, obj_t BgL_sz00_12408)
{
{ /* Eval/evaluate_comp.scm 619 */
{ /* Eval/evaluate_comp.scm 619 */
long BgL_llstkz00_12403;BgL_ev_gotoz00_bglt BgL_i1141z00_12404;obj_t BgL_argsz00_12405;obj_t BgL_boxesz00_12406;obj_t BgL_slotz00_12407;
BgL_llstkz00_12403 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12402, 
(int)(((long)0)))); 
BgL_i1141z00_12404 = 
((BgL_ev_gotoz00_bglt)
PROCEDURE_REF(BgL_envz00_12402, 
(int)(((long)1)))); 
BgL_argsz00_12405 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12402, 
(int)(((long)2)))); 
BgL_boxesz00_12406 = 
PROCEDURE_REF(BgL_envz00_12402, 
(int)(((long)3))); 
BgL_slotz00_12407 = 
PROCEDURE_REF(BgL_envz00_12402, 
(int)(((long)4))); 
{ /* Eval/evaluate_comp.scm 619 */
obj_t BgL_bpz00_14671;
BgL_bpz00_14671 = 
VECTOR_REF(
((obj_t)BgL_sz00_12408),((long)0)); 
BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(BgL_sz00_12408, BgL_argsz00_12405, BgL_boxesz00_12406, 
(
(long)CINT(BgL_bpz00_14671)+BgL_llstkz00_12403), 
(((BgL_ev_gotoz00_bglt)COBJECT(BgL_i1141z00_12404))->BgL_locz00)); 
return 
CDR(
((obj_t)BgL_slotz00_12407));} } } 

}



/* &comp-ev_labels1425 */
obj_t BGl_z62compzd2ev_labels1425zb0zz__evaluate_compz00(obj_t BgL_envz00_12409, obj_t BgL_ez00_12410, obj_t BgL_stkz00_12411)
{
{ /* Eval/evaluate_comp.scm 572 */
{ 
obj_t BgL_fz00_14674;
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12410)))->BgL_stkz00)=((obj_t)BgL_stkz00_12411),BUNSPEC); 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_envz00_14676;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_l1328z00_14677;
BgL_l1328z00_14677 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12410)))->BgL_varsz00); 
if(
NULLP(BgL_l1328z00_14677))
{ /* Eval/evaluate_comp.scm 579 */
BgL_envz00_14676 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_head1330z00_14678;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_res4765z00_14679;
BgL_res4765z00_14679 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1330z00_14678 = BgL_res4765z00_14679; } 
{ 
obj_t BgL_l1328z00_14681;obj_t BgL_tail1331z00_14682;
BgL_l1328z00_14681 = BgL_l1328z00_14677; 
BgL_tail1331z00_14682 = BgL_head1330z00_14678; 
BgL_zc3z04anonymousza33109ze3z87_14680:
if(
NULLP(BgL_l1328z00_14681))
{ /* Eval/evaluate_comp.scm 579 */
BgL_envz00_14676 = 
CDR(BgL_head1330z00_14678); }  else 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_newtail1332z00_14683;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_arg3112z00_14684;
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_vz00_14685;
BgL_vz00_14685 = 
CAR(
((obj_t)BgL_l1328z00_14681)); 
BgL_arg3112z00_14684 = 
MAKE_YOUNG_PAIR(BgL_vz00_14685, BGl_symbol5363z00zz__evaluate_compz00); } 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_res4767z00_14686;
BgL_res4767z00_14686 = 
MAKE_YOUNG_PAIR(BgL_arg3112z00_14684, BNIL); 
BgL_newtail1332z00_14683 = BgL_res4767z00_14686; } } 
SET_CDR(BgL_tail1331z00_14682, BgL_newtail1332z00_14683); 
{ /* Eval/evaluate_comp.scm 579 */
obj_t BgL_arg3111z00_14687;
BgL_arg3111z00_14687 = 
CDR(
((obj_t)BgL_l1328z00_14681)); 
{ 
obj_t BgL_tail1331z00_28326;obj_t BgL_l1328z00_28325;
BgL_l1328z00_28325 = BgL_arg3111z00_14687; 
BgL_tail1331z00_28326 = BgL_newtail1332z00_14683; 
BgL_tail1331z00_14682 = BgL_tail1331z00_28326; 
BgL_l1328z00_14681 = BgL_l1328z00_28325; 
goto BgL_zc3z04anonymousza33109ze3z87_14680;} } } } } } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12410)))->BgL_envz00)=((obj_t)BgL_envz00_14676),BUNSPEC); 
{ /* Eval/evaluate_comp.scm 582 */
obj_t BgL_g1336z00_14688;
BgL_g1336z00_14688 = 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12410)))->BgL_valsz00); 
{ 
obj_t BgL_ll1333z00_14690;obj_t BgL_ll1334z00_14691;
BgL_ll1333z00_14690 = BgL_envz00_14676; 
BgL_ll1334z00_14691 = BgL_g1336z00_14688; 
BgL_zc3z04anonymousza33099ze3z87_14689:
if(
NULLP(BgL_ll1333z00_14690))
{ /* Eval/evaluate_comp.scm 582 */((bool_t)1); }  else 
{ /* Eval/evaluate_comp.scm 582 */
{ /* Eval/evaluate_comp.scm 584 */
obj_t BgL_slotz00_14692;obj_t BgL_valz00_14693;
BgL_slotz00_14692 = 
CAR(
((obj_t)BgL_ll1333z00_14690)); 
BgL_valz00_14693 = 
CAR(
((obj_t)BgL_ll1334z00_14691)); 
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3101z00_14694;
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3102z00_14695;
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3103z00_14696;obj_t BgL_arg3104z00_14697;
BgL_arg3103z00_14696 = 
CDR(
((obj_t)BgL_valz00_14693)); 
{ /* Eval/evaluate_comp.scm 585 */
obj_t BgL_arg3105z00_14698;
BgL_arg3105z00_14698 = 
CAR(
((obj_t)BgL_valz00_14693)); 
BgL_arg3104z00_14697 = 
BGl_appendzd221009zd2zz__evaluate_compz00(BgL_stkz00_12411, BgL_arg3105z00_14698); } 
BgL_arg3102z00_14695 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_arg3103z00_14696), BgL_arg3104z00_14697); } 
BgL_fz00_14674 = BgL_arg3102z00_14695; 
{ /* Eval/evaluate_comp.scm 574 */
obj_t BgL_objz00_14675;
BgL_objz00_14675 = BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00; 
{ /* Eval/evaluate_comp.scm 574 */
obj_t BgL_tmpz00_28344;
BgL_tmpz00_28344 = 
((obj_t)BgL_fz00_14674); 
PROCEDURE_ATTR_SET(BgL_tmpz00_28344, BgL_objz00_14675); } BgL_objz00_14675; } 
BgL_arg3101z00_14694 = BgL_fz00_14674; } 
{ /* Eval/evaluate_comp.scm 584 */
obj_t BgL_tmpz00_28347;
BgL_tmpz00_28347 = 
((obj_t)BgL_slotz00_14692); 
SET_CDR(BgL_tmpz00_28347, BgL_arg3101z00_14694); } } } 
{ /* Eval/evaluate_comp.scm 582 */
obj_t BgL_arg3106z00_14699;obj_t BgL_arg3107z00_14700;
BgL_arg3106z00_14699 = 
CDR(
((obj_t)BgL_ll1333z00_14690)); 
BgL_arg3107z00_14700 = 
CDR(
((obj_t)BgL_ll1334z00_14691)); 
{ 
obj_t BgL_ll1334z00_28355;obj_t BgL_ll1333z00_28354;
BgL_ll1333z00_28354 = BgL_arg3106z00_14699; 
BgL_ll1334z00_28355 = BgL_arg3107z00_14700; 
BgL_ll1334z00_14691 = BgL_ll1334z00_28355; 
BgL_ll1333z00_14690 = BgL_ll1333z00_28354; 
goto BgL_zc3z04anonymousza33099ze3z87_14689;} } } } } } 
{ /* Eval/evaluate_comp.scm 589 */
obj_t BgL_bodyz00_14701;
BgL_bodyz00_14701 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_ez00_12410)))->BgL_bodyz00), BgL_stkz00_12411); 
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_zc3z04anonymousza33113ze3z87_14702;
BgL_zc3z04anonymousza33113ze3z87_14702 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33113ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33113ze3z87_14702, 
(int)(((long)0)), BgL_bodyz00_14701); 
return BgL_zc3z04anonymousza33113ze3z87_14702;} } } } 

}



/* &<@anonymous:3113> */
obj_t BGl_z62zc3z04anonymousza33113ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12412, obj_t BgL_sz00_12414)
{
{ /* Eval/evaluate_comp.scm 590 */
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_bodyz00_12413;
BgL_bodyz00_12413 = 
PROCEDURE_REF(BgL_envz00_12412, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 590 */
obj_t BgL_bpz00_14703;
BgL_bpz00_14703 = 
VECTOR_REF(
((obj_t)BgL_sz00_12414),((long)0)); 
return 
BGl_catchzd2gotozd2trampolinez00zz__evaluate_compz00(BgL_bodyz00_12413, BgL_sz00_12414);} } } 

}



/* &comp-ev_synchronize1423 */
obj_t BGl_z62compzd2ev_synchroniza7e1423z17zz__evaluate_compz00(obj_t BgL_envz00_12415, obj_t BgL_ez00_12416, obj_t BgL_stkz00_12417)
{
{ /* Eval/evaluate_comp.scm 552 */
{ /* Eval/evaluate_comp.scm 554 */
obj_t BgL_mutexz00_14705;obj_t BgL_prelockz00_14706;obj_t BgL_bodyz00_14707;
BgL_mutexz00_14705 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12416)))->BgL_mutexz00), BgL_stkz00_12417); 
BgL_prelockz00_14706 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12416)))->BgL_prelockz00), BgL_stkz00_12417); 
BgL_bodyz00_14707 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12416)))->BgL_bodyz00), BgL_stkz00_12417); 
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_zc3z04anonymousza33092ze3z87_14708;
BgL_zc3z04anonymousza33092ze3z87_14708 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33092ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33092ze3z87_14708, 
(int)(((long)0)), BgL_mutexz00_14705); 
PROCEDURE_SET(BgL_zc3z04anonymousza33092ze3z87_14708, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_synchroniza7eza7_bglt)BgL_ez00_12416))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33092ze3z87_14708, 
(int)(((long)2)), BgL_prelockz00_14706); 
PROCEDURE_SET(BgL_zc3z04anonymousza33092ze3z87_14708, 
(int)(((long)3)), BgL_bodyz00_14707); 
return BgL_zc3z04anonymousza33092ze3z87_14708;} } } 

}



/* &<@anonymous:3092> */
obj_t BGl_z62zc3z04anonymousza33092ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12418, obj_t BgL_sz00_12423)
{
{ /* Eval/evaluate_comp.scm 557 */
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_mutexz00_12419;BgL_ev_synchroniza7eza7_bglt BgL_i1138z00_12420;obj_t BgL_prelockz00_12421;obj_t BgL_bodyz00_12422;
BgL_mutexz00_12419 = 
PROCEDURE_REF(BgL_envz00_12418, 
(int)(((long)0))); 
BgL_i1138z00_12420 = 
((BgL_ev_synchroniza7eza7_bglt)
PROCEDURE_REF(BgL_envz00_12418, 
(int)(((long)1)))); 
BgL_prelockz00_12421 = 
PROCEDURE_REF(BgL_envz00_12418, 
(int)(((long)2))); 
BgL_bodyz00_12422 = 
PROCEDURE_REF(BgL_envz00_12418, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 557 */
obj_t BgL_bpz00_14709;
BgL_bpz00_14709 = 
VECTOR_REF(
((obj_t)BgL_sz00_12423),((long)0)); 
{ /* Eval/evaluate_comp.scm 558 */
obj_t BgL_mz00_14710;
BgL_mz00_14710 = 
PROCEDURE_ENTRY(BgL_mutexz00_12419)(BgL_mutexz00_12419, BgL_sz00_12423, BEOA); 
{ /* Eval/evaluate_comp.scm 559 */
bool_t BgL_test5997z00_28406;
{ /* Eval/evaluate_comp.scm 559 */
bool_t BgL_res4762z00_14711;
BgL_res4762z00_14711 = 
BGL_MUTEXP(BgL_mz00_14710); 
BgL_test5997z00_28406 = BgL_res4762z00_14711; } 
if(BgL_test5997z00_28406)
{ /* Eval/evaluate_comp.scm 560 */
obj_t BgL_pz00_14712;
BgL_pz00_14712 = 
PROCEDURE_ENTRY(BgL_prelockz00_12421)(BgL_prelockz00_12421, BgL_sz00_12423, BEOA); 
{ /* Eval/evaluate_comp.scm 562 */
obj_t BgL_za2za2resza2za2z00_14713;
if(
PAIRP(BgL_pz00_14712))
{ /* Eval/evaluate_comp.scm 563 */
obj_t BgL_top6000z00_28415;
BgL_top6000z00_28415 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_14710, BgL_pz00_14712); 
BGL_EXITD_PUSH_PROTECT(BgL_top6000z00_28415, BgL_mz00_14710); BUNSPEC; 
{ /* Eval/evaluate_comp.scm 563 */
obj_t BgL_tmp5999z00_28414;
BgL_tmp5999z00_28414 = 
PROCEDURE_ENTRY(BgL_bodyz00_12422)(BgL_bodyz00_12422, BgL_sz00_12423, BEOA); 
BGL_EXITD_POP_PROTECT(BgL_top6000z00_28415); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mz00_14710); 
BgL_za2za2resza2za2z00_14713 = BgL_tmp5999z00_28414; } }  else 
{ /* Eval/evaluate_comp.scm 564 */
obj_t BgL_top6002z00_28426;
BgL_top6002z00_28426 = 
BGL_EXITD_TOP_AS_OBJ(); 
BGL_MUTEX_LOCK(BgL_mz00_14710); 
BGL_EXITD_PUSH_PROTECT(BgL_top6002z00_28426, BgL_mz00_14710); BUNSPEC; 
{ /* Eval/evaluate_comp.scm 564 */
obj_t BgL_tmp6001z00_28425;
BgL_tmp6001z00_28425 = 
PROCEDURE_ENTRY(BgL_bodyz00_12422)(BgL_bodyz00_12422, BgL_sz00_12423, BEOA); 
BGL_EXITD_POP_PROTECT(BgL_top6002z00_28426); BUNSPEC; 
BGL_MUTEX_UNLOCK(BgL_mz00_14710); 
BgL_za2za2resza2za2z00_14713 = BgL_tmp6001z00_28425; } } 
VECTOR_SET(
((obj_t)BgL_sz00_12423),((long)0),BgL_bpz00_14709); 
return BgL_za2za2resza2za2z00_14713;} }  else 
{ /* Eval/evaluate_comp.scm 559 */
return 
BGl_loczd2typezd2errorz00zz__evaluate_compz00(BGl_string5365z00zz__evaluate_compz00, BGl_string5366z00zz__evaluate_compz00, BgL_mz00_14710, 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_i1138z00_12420))->BgL_locz00));} } } } } } 

}



/* &comp-ev_with-handler1421 */
obj_t BGl_z62compzd2ev_withzd2handler1421z62zz__evaluate_compz00(obj_t BgL_envz00_12424, obj_t BgL_ez00_12425, obj_t BgL_stkz00_12426)
{
{ /* Eval/evaluate_comp.scm 543 */
{ /* Eval/evaluate_comp.scm 545 */
obj_t BgL_handlerz00_14715;obj_t BgL_bodyz00_14716;
BgL_handlerz00_14715 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_12425)))->BgL_handlerz00), BgL_stkz00_12426); 
BgL_bodyz00_14716 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_ez00_12425)))->BgL_bodyz00), BgL_stkz00_12426); 
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_zc3z04anonymousza33078ze3z87_14717;
BgL_zc3z04anonymousza33078ze3z87_14717 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33078ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33078ze3z87_14717, 
(int)(((long)0)), BgL_handlerz00_14715); 
PROCEDURE_SET(BgL_zc3z04anonymousza33078ze3z87_14717, 
(int)(((long)1)), BgL_bodyz00_14716); 
return BgL_zc3z04anonymousza33078ze3z87_14717;} } } 

}



/* &<@anonymous:3078> */
obj_t BGl_z62zc3z04anonymousza33078ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12427, obj_t BgL_sz00_12430)
{
{ /* Eval/evaluate_comp.scm 546 */
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_handlerz00_12428;obj_t BgL_bodyz00_12429;
BgL_handlerz00_12428 = 
PROCEDURE_REF(BgL_envz00_12427, 
(int)(((long)0))); 
BgL_bodyz00_12429 = 
PROCEDURE_REF(BgL_envz00_12427, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 546 */
obj_t BgL_bpz00_14718;
BgL_bpz00_14718 = 
VECTOR_REF(
((obj_t)BgL_sz00_12430),((long)0)); 
{ /* Eval/evaluate_comp.scm 547 */
obj_t BgL_hz00_14719;
BgL_hz00_14719 = 
PROCEDURE_ENTRY(BgL_handlerz00_12428)(BgL_handlerz00_12428, BgL_sz00_12430, BEOA); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_za2za2resza2za2z00_14720;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_res1128z00_14721;
BgL_res1128z00_14721 = 
MAKE_CELL(BUNSPEC); 
if(
CBOOL(
BGl_zc3z04exitza33085ze3ze70z60zz__evaluate_compz00(BgL_sz00_12430, BgL_bodyz00_12429, BgL_res1128z00_14721)))
{ /* Eval/evaluate_comp.scm 549 */
BgL_za2za2resza2za2z00_14720 = 
PROCEDURE_ENTRY(BgL_hz00_14719)(BgL_hz00_14719, 
CELL_REF(BgL_res1128z00_14721), BEOA); }  else 
{ /* Eval/evaluate_comp.scm 549 */
BgL_za2za2resza2za2z00_14720 = 
CELL_REF(BgL_res1128z00_14721); } } 
VECTOR_SET(
((obj_t)BgL_sz00_12430),((long)0),BgL_bpz00_14718); 
return BgL_za2za2resza2za2z00_14720;} } } } } 

}



/* <@exit:3085>~0 */
obj_t BGl_zc3z04exitza33085ze3ze70z60zz__evaluate_compz00(obj_t BgL_sz00_12618, obj_t BgL_bodyz00_12617, obj_t BgL_res1128z00_12616)
{
{ /* Eval/evaluate_comp.scm 549 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1134z00_4223;
if( SET_EXIT(BgL_an_exit1134z00_4223) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1134z00_4223 = 
(void *)jmpbuf; 
{ /* Eval/evaluate_comp.scm 549 */

PUSH_EXIT(BgL_an_exit1134z00_4223, ((long)1)); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_an_exitd1135z00_4224;
BgL_an_exitd1135z00_4224 = 
((obj_t)(&exitd)); 
{ /* Eval/evaluate_comp.scm 549 */
bool_t BgL_res1137z00_4227;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_ohs1126z00_4228;
BgL_ohs1126z00_4228 = 
BGL_ERROR_HANDLER_GET(); 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_exitd1131z00_4229;
BgL_exitd1131z00_4229 = 
((obj_t)(&exitd)); 
{ 
obj_t BgL_zc3z04anonymousza33089ze3z87_11398;
BgL_zc3z04anonymousza33089ze3z87_11398 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33089ze3z87_11398, 
(int)(((long)0)), BgL_ohs1126z00_4228); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1131z00_4229, BgL_zc3z04anonymousza33089ze3z87_11398); 
{ /* Eval/evaluate_comp.scm 549 */
bool_t BgL_tmp1133z00_4231;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_arg3086z00_4232;
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_zc3z04anonymousza33088ze3z87_11397;
BgL_zc3z04anonymousza33088ze3z87_11397 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33088ze3z87_11397, 
(int)(((long)0)), 
((obj_t)BgL_res1128z00_12616)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33088ze3z87_11397, 
(int)(((long)1)), BgL_an_exitd1135z00_4224); 
BgL_arg3086z00_4232 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza33088ze3z87_11397, BgL_ohs1126z00_4228); } 
BGL_ERROR_HANDLER_SET(BgL_arg3086z00_4232); BUNSPEC; } 
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_auxz00_12432;
BgL_auxz00_12432 = 
PROCEDURE_ENTRY(BgL_bodyz00_12617)(BgL_bodyz00_12617, BgL_sz00_12618, BEOA); 
CELL_SET(BgL_res1128z00_12616, BgL_auxz00_12432); } 
BgL_tmp1133z00_4231 = ((bool_t)0); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1131z00_4229); 
BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00(BgL_zc3z04anonymousza33089ze3z87_11398); 
BgL_res1137z00_4227 = BgL_tmp1133z00_4231; } } } } 
POP_EXIT(); 
return 
BBOOL(BgL_res1137z00_4227);} } } 
} } 

}



/* &<@anonymous:3088> */
obj_t BGl_z62zc3z04anonymousza33088ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12434, obj_t BgL_ez00_12437)
{
{ /* Eval/evaluate_comp.scm 549 */
{ /* Eval/evaluate_comp.scm 549 */
obj_t BgL_res1128z00_12435;obj_t BgL_an_exitd1135z00_12436;
BgL_res1128z00_12435 = 
PROCEDURE_REF(BgL_envz00_12434, 
(int)(((long)0))); 
BgL_an_exitd1135z00_12436 = 
PROCEDURE_REF(BgL_envz00_12434, 
(int)(((long)1))); 
CELL_SET(BgL_res1128z00_12435, BgL_ez00_12437); 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1135z00_12436, BTRUE);} } 

}



/* &<@anonymous:3089> */
obj_t BGl_z62zc3z04anonymousza33089ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12439)
{
{ /* Eval/evaluate_comp.scm 549 */
{ 
obj_t BgL_ohs1126z00_12440;
BgL_ohs1126z00_12440 = 
PROCEDURE_REF(BgL_envz00_12439, 
(int)(((long)0))); 
BGL_ERROR_HANDLER_SET(BgL_ohs1126z00_12440); 
return BUNSPEC;} } 

}



/* &comp-ev_unwind-prote1419 */
obj_t BGl_z62compzd2ev_unwindzd2prote1419z62zz__evaluate_compz00(obj_t BgL_envz00_12441, obj_t BgL_ez00_12442, obj_t BgL_stkz00_12443)
{
{ /* Eval/evaluate_comp.scm 534 */
{ /* Eval/evaluate_comp.scm 536 */
obj_t BgL_ez00_14723;obj_t BgL_bodyz00_14724;
BgL_ez00_14723 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_12442)))->BgL_ez00), BgL_stkz00_12443); 
BgL_bodyz00_14724 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_ez00_12442)))->BgL_bodyz00), BgL_stkz00_12443); 
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_zc3z04anonymousza33074ze3z87_14725;
BgL_zc3z04anonymousza33074ze3z87_14725 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33074ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33074ze3z87_14725, 
(int)(((long)0)), BgL_bodyz00_14724); 
PROCEDURE_SET(BgL_zc3z04anonymousza33074ze3z87_14725, 
(int)(((long)1)), BgL_ez00_14723); 
return BgL_zc3z04anonymousza33074ze3z87_14725;} } } 

}



/* &<@anonymous:3074> */
obj_t BGl_z62zc3z04anonymousza33074ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12444, obj_t BgL_sz00_12447)
{
{ /* Eval/evaluate_comp.scm 537 */
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_bodyz00_12445;obj_t BgL_ez00_12446;
BgL_bodyz00_12445 = 
PROCEDURE_REF(BgL_envz00_12444, 
(int)(((long)0))); 
BgL_ez00_12446 = 
PROCEDURE_REF(BgL_envz00_12444, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 537 */
obj_t BgL_bpz00_14726;
BgL_bpz00_14726 = 
VECTOR_REF(
((obj_t)BgL_sz00_12447),((long)0)); 
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_exitd1122z00_14727;
BgL_exitd1122z00_14727 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Eval/evaluate_comp.scm 540 */
obj_t BgL_zc3z04anonymousza33075ze3z87_14728;
BgL_zc3z04anonymousza33075ze3z87_14728 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33075ze3ze5zz__evaluate_compz00, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33075ze3z87_14728, 
(int)(((long)0)), BgL_sz00_12447); 
PROCEDURE_SET(BgL_zc3z04anonymousza33075ze3z87_14728, 
(int)(((long)1)), BgL_bpz00_14726); 
PROCEDURE_SET(BgL_zc3z04anonymousza33075ze3z87_14728, 
(int)(((long)2)), BgL_bodyz00_12445); 
BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_exitd1122z00_14727, BgL_zc3z04anonymousza33075ze3z87_14728); 
{ /* Eval/evaluate_comp.scm 539 */
obj_t BgL_tmp1124z00_14729;
BgL_tmp1124z00_14729 = 
PROCEDURE_ENTRY(BgL_ez00_12446)(BgL_ez00_12446, BgL_sz00_12447, BEOA); 
BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_exitd1122z00_14727); 
BGl_z62zc3z04anonymousza33075ze3ze5zz__evaluate_compz00(BgL_zc3z04anonymousza33075ze3z87_14728); 
return BgL_tmp1124z00_14729;} } } } } } 

}



/* &<@anonymous:3075> */
obj_t BGl_z62zc3z04anonymousza33075ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12448)
{
{ /* Eval/evaluate_comp.scm 539 */
{ /* Eval/evaluate_comp.scm 540 */
obj_t BgL_sz00_12449;obj_t BgL_savedzd2bpzd2_12450;obj_t BgL_bodyz00_12451;
BgL_sz00_12449 = 
PROCEDURE_REF(BgL_envz00_12448, 
(int)(((long)0))); 
BgL_savedzd2bpzd2_12450 = 
PROCEDURE_REF(BgL_envz00_12448, 
(int)(((long)1))); 
BgL_bodyz00_12451 = 
PROCEDURE_REF(BgL_envz00_12448, 
(int)(((long)2))); 
VECTOR_SET(
((obj_t)BgL_sz00_12449),((long)0),BgL_savedzd2bpzd2_12450); 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12451)(BgL_bodyz00_12451, BgL_sz00_12449, BEOA);} } 

}



/* &comp-ev_bind-exit1417 */
obj_t BGl_z62compzd2ev_bindzd2exit1417z62zz__evaluate_compz00(obj_t BgL_envz00_12452, obj_t BgL_ez00_12453, obj_t BgL_stkz00_12454)
{
{ /* Eval/evaluate_comp.scm 523 */
{ /* Eval/evaluate_comp.scm 525 */
long BgL_siza7eza7_14731;obj_t BgL_nstkz00_14732;
BgL_siza7eza7_14731 = 
bgl_list_length(BgL_stkz00_12454); 
{ /* Eval/evaluate_comp.scm 525 */
obj_t BgL_arg3072z00_14733;
{ /* Eval/evaluate_comp.scm 525 */
BgL_ev_varz00_bglt BgL_arg3073z00_14734;
BgL_arg3073z00_14734 = 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12453)))->BgL_varz00); 
BgL_arg3072z00_14733 = 
MAKE_YOUNG_PAIR(
((obj_t)BgL_arg3073z00_14734), BNIL); } 
BgL_nstkz00_14732 = 
BGl_appendzd221009zd2zz__evaluate_compz00(BgL_stkz00_12454, BgL_arg3072z00_14733); } 
{ /* Eval/evaluate_comp.scm 526 */
obj_t BgL_bodyz00_14735;obj_t BgL_effzf3zf3_14736;
BgL_bodyz00_14735 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12453)))->BgL_bodyz00), BgL_nstkz00_14732); 
BgL_effzf3zf3_14736 = 
(((BgL_ev_varz00_bglt)COBJECT(
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_ez00_12453)))->BgL_varz00)))->BgL_effz00); 
{ /* Eval/evaluate_comp.scm 527 */
obj_t BgL_zc3z04anonymousza33067ze3z87_14737;
BgL_zc3z04anonymousza33067ze3z87_14737 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33067ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33067ze3z87_14737, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14731)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33067ze3z87_14737, 
(int)(((long)1)), BgL_effzf3zf3_14736); 
PROCEDURE_SET(BgL_zc3z04anonymousza33067ze3z87_14737, 
(int)(((long)2)), BgL_bodyz00_14735); 
return BgL_zc3z04anonymousza33067ze3z87_14737;} } } } 

}



/* &<@anonymous:3067> */
obj_t BGl_z62zc3z04anonymousza33067ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12455, obj_t BgL_sz00_12459)
{
{ /* Eval/evaluate_comp.scm 527 */
{ /* Eval/evaluate_comp.scm 527 */
long BgL_siza7eza7_12456;obj_t BgL_effzf3zf3_12457;obj_t BgL_bodyz00_12458;
BgL_siza7eza7_12456 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12455, 
(int)(((long)0)))); 
BgL_effzf3zf3_12457 = 
PROCEDURE_REF(BgL_envz00_12455, 
(int)(((long)1))); 
BgL_bodyz00_12458 = 
PROCEDURE_REF(BgL_envz00_12455, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 527 */
obj_t BgL_bpz00_14738;
BgL_bpz00_14738 = 
VECTOR_REF(
((obj_t)BgL_sz00_12459),((long)0)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_za2za2resza2za2z00_14739;
BgL_za2za2resza2za2z00_14739 = 
BGl_zc3z04exitza33068ze3ze70z60zz__evaluate_compz00(BgL_bodyz00_12458, BgL_sz00_12459, BgL_effzf3zf3_12457, BgL_siza7eza7_12456, BgL_bpz00_14738); 
VECTOR_SET(
((obj_t)BgL_sz00_12459),((long)0),BgL_bpz00_14738); 
return BgL_za2za2resza2za2z00_14739;} } } } 

}



/* <@exit:3068>~0 */
obj_t BGl_zc3z04exitza33068ze3ze70z60zz__evaluate_compz00(obj_t BgL_bodyz00_12615, obj_t BgL_sz00_12614, obj_t BgL_effzf3zf3_12613, long BgL_siza7eza7_12612, obj_t BgL_bpz00_12611)
{
{ /* Eval/evaluate_comp.scm 529 */
jmp_buf_t jmpbuf; 
void * BgL_an_exit1117z00_4158;
if( SET_EXIT(BgL_an_exit1117z00_4158) ) { 
return 
BGL_EXIT_VALUE();
} else {
#if( SIGSETJMP_SAVESIGS == 0 )
  bgl_restore_signal_handlers();
#endif

BgL_an_exit1117z00_4158 = 
(void *)jmpbuf; 
{ /* Eval/evaluate_comp.scm 529 */

PUSH_EXIT(BgL_an_exit1117z00_4158, ((long)1)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_an_exitd1118z00_4159;
BgL_an_exitd1118z00_4159 = 
((obj_t)(&exitd)); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_exitz00_11404;
BgL_exitz00_11404 = 
MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_exitz00_11404, 
(int)(((long)0)), BgL_an_exitd1118z00_4159); 
{ /* Eval/evaluate_comp.scm 529 */
obj_t BgL_res1120z00_4162;
{ /* Eval/evaluate_comp.scm 530 */
long BgL_arg3069z00_4163;obj_t BgL_arg3070z00_4164;
BgL_arg3069z00_4163 = 
(
(long)CINT(BgL_bpz00_12611)+BgL_siza7eza7_12612); 
if(
CBOOL(BgL_effzf3zf3_12613))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_8900;
BgL_newz00_8900 = 
create_struct(BGl_symbol5256z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28604;
BgL_tmpz00_28604 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_8900, BgL_tmpz00_28604, BgL_exitz00_11404); } 
BgL_arg3070z00_4164 = BgL_newz00_8900; }  else 
{ /* Eval/evaluate_comp.scm 530 */
BgL_arg3070z00_4164 = BgL_exitz00_11404; } 
VECTOR_SET(
((obj_t)BgL_sz00_12614),BgL_arg3069z00_4163,BgL_arg3070z00_4164); } 
BgL_res1120z00_4162 = 
PROCEDURE_ENTRY(BgL_bodyz00_12615)(BgL_bodyz00_12615, BgL_sz00_12614, BEOA); 
POP_EXIT(); 
return BgL_res1120z00_4162;} } } } 
} } 

}



/* &exit */
obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_12460, obj_t BgL_val1119z00_12462)
{
{ /* Eval/evaluate_comp.scm 529 */
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(
PROCEDURE_REF(BgL_envz00_12460, 
(int)(((long)0))), BgL_val1119z00_12462);} 

}



/* &comp-ev_letrec1415 */
obj_t BGl_z62compzd2ev_letrec1415zb0zz__evaluate_compz00(obj_t BgL_envz00_12463, obj_t BgL_ez00_12464, obj_t BgL_stkz00_12465)
{
{ /* Eval/evaluate_comp.scm 494 */
{ /* Eval/evaluate_comp.scm 496 */
long BgL_siza7eza7_14741;obj_t BgL_nstkz00_14742;
BgL_siza7eza7_14741 = 
bgl_list_length(BgL_stkz00_12465); 
{ /* Eval/evaluate_comp.scm 496 */
obj_t BgL_arg3066z00_14743;
BgL_arg3066z00_14743 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12464))))->BgL_varsz00); 
BgL_nstkz00_14742 = 
BGl_appendzd221009zd2zz__evaluate_compz00(BgL_stkz00_12465, BgL_arg3066z00_14743); } 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_cvalsz00_14744;obj_t BgL_bodyz00_14745;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_l1314z00_14746;
BgL_l1314z00_14746 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12464))))->BgL_valsz00); 
if(
NULLP(BgL_l1314z00_14746))
{ /* Eval/evaluate_comp.scm 497 */
BgL_cvalsz00_14744 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_head1316z00_14747;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_res4741z00_14748;
BgL_res4741z00_14748 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1316z00_14747 = BgL_res4741z00_14748; } 
{ 
obj_t BgL_l1314z00_14750;obj_t BgL_tail1317z00_14751;
BgL_l1314z00_14750 = BgL_l1314z00_14746; 
BgL_tail1317z00_14751 = BgL_head1316z00_14747; 
BgL_zc3z04anonymousza33061ze3z87_14749:
if(
NULLP(BgL_l1314z00_14750))
{ /* Eval/evaluate_comp.scm 497 */
BgL_cvalsz00_14744 = 
CDR(BgL_head1316z00_14747); }  else 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_newtail1318z00_14752;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_arg3064z00_14753;
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_vz00_14754;
BgL_vz00_14754 = 
CAR(
((obj_t)BgL_l1314z00_14750)); 
BgL_arg3064z00_14753 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_vz00_14754), BgL_nstkz00_14742); } 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_res4743z00_14755;
BgL_res4743z00_14755 = 
MAKE_YOUNG_PAIR(BgL_arg3064z00_14753, BNIL); 
BgL_newtail1318z00_14752 = BgL_res4743z00_14755; } } 
SET_CDR(BgL_tail1317z00_14751, BgL_newtail1318z00_14752); 
{ /* Eval/evaluate_comp.scm 497 */
obj_t BgL_arg3063z00_14756;
BgL_arg3063z00_14756 = 
CDR(
((obj_t)BgL_l1314z00_14750)); 
{ 
obj_t BgL_tail1317z00_28640;obj_t BgL_l1314z00_28639;
BgL_l1314z00_28639 = BgL_arg3063z00_14756; 
BgL_tail1317z00_28640 = BgL_newtail1318z00_14752; 
BgL_tail1317z00_14751 = BgL_tail1317z00_28640; 
BgL_l1314z00_14750 = BgL_l1314z00_28639; 
goto BgL_zc3z04anonymousza33061ze3z87_14749;} } } } } } 
{ /* Eval/evaluate_comp.scm 498 */
BgL_ev_exprz00_bglt BgL_arg3065z00_14757;
BgL_arg3065z00_14757 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12464))))->BgL_bodyz00); 
BgL_bodyz00_14745 = 
BGl_compz00zz__evaluate_compz00(BgL_arg3065z00_14757, BgL_nstkz00_14742); } 
{ /* Eval/evaluate_comp.scm 499 */
bool_t BgL_test6007z00_28645;
{ 
obj_t BgL_l1319z00_14759;
BgL_l1319z00_14759 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_ez00_12464))))->BgL_valsz00); 
BgL_zc3z04anonymousza33058ze3z87_14758:
if(
NULLP(BgL_l1319z00_14759))
{ /* Eval/evaluate_comp.scm 499 */
BgL_test6007z00_28645 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 499 */
bool_t BgL_test6009z00_28648;
{ /* Eval/evaluate_comp.scm 499 */
obj_t BgL_vz00_14760;
BgL_vz00_14760 = 
CAR(
((obj_t)BgL_l1319z00_14759)); 
BgL_test6009z00_28648 = 
BGl_isazf3zf3zz__objectz00(BgL_vz00_14760, BGl_ev_absz00zz__evaluate_typesz00); } 
if(BgL_test6009z00_28648)
{ 
obj_t BgL_l1319z00_28652;
BgL_l1319z00_28652 = 
CDR(
((obj_t)BgL_l1319z00_14759)); 
BgL_l1319z00_14759 = BgL_l1319z00_28652; 
goto BgL_zc3z04anonymousza33058ze3z87_14758;}  else 
{ /* Eval/evaluate_comp.scm 499 */
BgL_test6007z00_28645 = ((bool_t)0)
; } } } 
if(BgL_test6007z00_28645)
{ /* Eval/evaluate_comp.scm 500 */
obj_t BgL_zc3z04anonymousza33028ze3z87_14761;
BgL_zc3z04anonymousza33028ze3z87_14761 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33028ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33028ze3z87_14761, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14741)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33028ze3z87_14761, 
(int)(((long)1)), BgL_cvalsz00_14744); 
PROCEDURE_SET(BgL_zc3z04anonymousza33028ze3z87_14761, 
(int)(((long)2)), BgL_bodyz00_14745); 
return BgL_zc3z04anonymousza33028ze3z87_14761;}  else 
{ /* Eval/evaluate_comp.scm 510 */
obj_t BgL_zc3z04anonymousza33041ze3z87_14762;
BgL_zc3z04anonymousza33041ze3z87_14762 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33041ze3z87_14762, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14741)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33041ze3z87_14762, 
(int)(((long)1)), BgL_cvalsz00_14744); 
PROCEDURE_SET(BgL_zc3z04anonymousza33041ze3z87_14762, 
(int)(((long)2)), BgL_bodyz00_14745); 
return BgL_zc3z04anonymousza33041ze3z87_14762;} } } } } 

}



/* &<@anonymous:3028> */
obj_t BGl_z62zc3z04anonymousza33028ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12466, obj_t BgL_sz00_12470)
{
{ /* Eval/evaluate_comp.scm 500 */
{ /* Eval/evaluate_comp.scm 500 */
long BgL_siza7eza7_12467;obj_t BgL_cvalsz00_12468;obj_t BgL_bodyz00_12469;
BgL_siza7eza7_12467 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12466, 
(int)(((long)0)))); 
BgL_cvalsz00_12468 = 
PROCEDURE_REF(BgL_envz00_12466, 
(int)(((long)1))); 
BgL_bodyz00_12469 = 
PROCEDURE_REF(BgL_envz00_12466, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 500 */
obj_t BgL_bpz00_14763;
BgL_bpz00_14763 = 
VECTOR_REF(
((obj_t)BgL_sz00_12470),((long)0)); 
{ /* Eval/evaluate_comp.scm 501 */
long BgL_g1111z00_14764;
BgL_g1111z00_14764 = 
(
(long)CINT(BgL_bpz00_14763)+BgL_siza7eza7_12467); 
{ 
obj_t BgL_lz00_14766;long BgL_iz00_14767;
BgL_lz00_14766 = BgL_cvalsz00_12468; 
BgL_iz00_14767 = BgL_g1111z00_14764; 
BgL_recz00_14765:
if(
NULLP(BgL_lz00_14766))
{ /* Eval/evaluate_comp.scm 502 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 502 */
{ /* Eval/evaluate_comp.scm 503 */
obj_t BgL_arg3031z00_14768;
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14769;
BgL_newz00_14769 = 
create_struct(BGl_symbol5256z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28693;
BgL_tmpz00_28693 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14769, BgL_tmpz00_28693, BUNSPEC); } 
BgL_arg3031z00_14768 = BgL_newz00_14769; } 
VECTOR_SET(
((obj_t)BgL_sz00_12470),BgL_iz00_14767,BgL_arg3031z00_14768); } 
{ /* Eval/evaluate_comp.scm 504 */
obj_t BgL_arg3032z00_14770;long BgL_arg3033z00_14771;
BgL_arg3032z00_14770 = 
CDR(
((obj_t)BgL_lz00_14766)); 
BgL_arg3033z00_14771 = 
(BgL_iz00_14767+((long)1)); 
{ 
long BgL_iz00_28702;obj_t BgL_lz00_28701;
BgL_lz00_28701 = BgL_arg3032z00_14770; 
BgL_iz00_28702 = BgL_arg3033z00_14771; 
BgL_iz00_14767 = BgL_iz00_28702; 
BgL_lz00_14766 = BgL_lz00_28701; 
goto BgL_recz00_14765;} } } } } 
{ /* Eval/evaluate_comp.scm 505 */
long BgL_g1112z00_14772;
BgL_g1112z00_14772 = 
(
(long)CINT(BgL_bpz00_14763)+BgL_siza7eza7_12467); 
{ 
obj_t BgL_lz00_14774;long BgL_iz00_14775;
BgL_lz00_14774 = BgL_cvalsz00_12468; 
BgL_iz00_14775 = BgL_g1112z00_14772; 
BgL_recz00_14773:
if(
NULLP(BgL_lz00_14774))
{ /* Eval/evaluate_comp.scm 506 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 506 */
{ /* Eval/evaluate_comp.scm 507 */
obj_t BgL_arg3036z00_14776;obj_t BgL_arg3037z00_14777;
BgL_arg3036z00_14776 = 
VECTOR_REF(
((obj_t)BgL_sz00_12470),BgL_iz00_14775); 
{ /* Eval/evaluate_comp.scm 507 */
obj_t BgL_fun3038z00_14778;
BgL_fun3038z00_14778 = 
CAR(
((obj_t)BgL_lz00_14774)); 
BgL_arg3037z00_14777 = 
PROCEDURE_ENTRY(BgL_fun3038z00_14778)(BgL_fun3038z00_14778, BgL_sz00_12470, BEOA); } 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_28717;obj_t BgL_tmpz00_28715;
BgL_auxz00_28717 = 
(int)(((long)0)); 
BgL_tmpz00_28715 = 
((obj_t)BgL_arg3036z00_14776); 
STRUCT_SET(BgL_tmpz00_28715, BgL_auxz00_28717, BgL_arg3037z00_14777); } } 
{ /* Eval/evaluate_comp.scm 508 */
obj_t BgL_arg3039z00_14779;long BgL_arg3040z00_14780;
BgL_arg3039z00_14779 = 
CDR(
((obj_t)BgL_lz00_14774)); 
BgL_arg3040z00_14780 = 
(BgL_iz00_14775+((long)1)); 
{ 
long BgL_iz00_28724;obj_t BgL_lz00_28723;
BgL_lz00_28723 = BgL_arg3039z00_14779; 
BgL_iz00_28724 = BgL_arg3040z00_14780; 
BgL_iz00_14775 = BgL_iz00_28724; 
BgL_lz00_14774 = BgL_lz00_28723; 
goto BgL_recz00_14773;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12469)(BgL_bodyz00_12469, BgL_sz00_12470, BEOA);} } } 

}



/* &<@anonymous:3041> */
obj_t BGl_z62zc3z04anonymousza33041ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12471, obj_t BgL_sz00_12475)
{
{ /* Eval/evaluate_comp.scm 510 */
{ /* Eval/evaluate_comp.scm 510 */
long BgL_siza7eza7_12472;obj_t BgL_cvalsz00_12473;obj_t BgL_bodyz00_12474;
BgL_siza7eza7_12472 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12471, 
(int)(((long)0)))); 
BgL_cvalsz00_12473 = 
PROCEDURE_REF(BgL_envz00_12471, 
(int)(((long)1))); 
BgL_bodyz00_12474 = 
PROCEDURE_REF(BgL_envz00_12471, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 510 */
obj_t BgL_bpz00_14781;
BgL_bpz00_14781 = 
VECTOR_REF(
((obj_t)BgL_sz00_12475),((long)0)); 
{ /* Eval/evaluate_comp.scm 511 */
long BgL_g1113z00_14782;
BgL_g1113z00_14782 = 
(
(long)CINT(BgL_bpz00_14781)+BgL_siza7eza7_12472); 
{ 
obj_t BgL_lz00_14784;long BgL_iz00_14785;
BgL_lz00_14784 = BgL_cvalsz00_12473; 
BgL_iz00_14785 = BgL_g1113z00_14782; 
BgL_recz00_14783:
if(
NULLP(BgL_lz00_14784))
{ /* Eval/evaluate_comp.scm 512 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 512 */
{ /* Eval/evaluate_comp.scm 513 */
obj_t BgL_arg3044z00_14786;
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14787;
BgL_newz00_14787 = 
create_struct(BGl_symbol5256z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28744;
BgL_tmpz00_28744 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14787, BgL_tmpz00_28744, BUNSPEC); } 
BgL_arg3044z00_14786 = BgL_newz00_14787; } 
VECTOR_SET(
((obj_t)BgL_sz00_12475),BgL_iz00_14785,BgL_arg3044z00_14786); } 
{ /* Eval/evaluate_comp.scm 514 */
obj_t BgL_arg3045z00_14788;long BgL_arg3046z00_14789;
BgL_arg3045z00_14788 = 
CDR(
((obj_t)BgL_lz00_14784)); 
BgL_arg3046z00_14789 = 
(BgL_iz00_14785+((long)1)); 
{ 
long BgL_iz00_28753;obj_t BgL_lz00_28752;
BgL_lz00_28752 = BgL_arg3045z00_14788; 
BgL_iz00_28753 = BgL_arg3046z00_14789; 
BgL_iz00_14785 = BgL_iz00_28753; 
BgL_lz00_14784 = BgL_lz00_28752; 
goto BgL_recz00_14783;} } } } } 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_rvalsz00_14790;
if(
NULLP(BgL_cvalsz00_12473))
{ /* Eval/evaluate_comp.scm 515 */
BgL_rvalsz00_14790 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_head1325z00_14791;
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_res4755z00_14792;
BgL_res4755z00_14792 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1325z00_14791 = BgL_res4755z00_14792; } 
{ 
obj_t BgL_l1323z00_14794;obj_t BgL_tail1326z00_14795;
BgL_l1323z00_14794 = BgL_cvalsz00_12473; 
BgL_tail1326z00_14795 = BgL_head1325z00_14791; 
BgL_zc3z04anonymousza33054ze3z87_14793:
if(
NULLP(BgL_l1323z00_14794))
{ /* Eval/evaluate_comp.scm 515 */
BgL_rvalsz00_14790 = 
CDR(BgL_head1325z00_14791); }  else 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_newtail1327z00_14796;
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_arg3057z00_14797;
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_vz00_14798;
BgL_vz00_14798 = 
CAR(
((obj_t)BgL_l1323z00_14794)); 
BgL_arg3057z00_14797 = 
PROCEDURE_ENTRY(BgL_vz00_14798)(BgL_vz00_14798, BgL_sz00_12475, BEOA); } 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_res4757z00_14799;
BgL_res4757z00_14799 = 
MAKE_YOUNG_PAIR(BgL_arg3057z00_14797, BNIL); 
BgL_newtail1327z00_14796 = BgL_res4757z00_14799; } } 
SET_CDR(BgL_tail1326z00_14795, BgL_newtail1327z00_14796); 
{ /* Eval/evaluate_comp.scm 515 */
obj_t BgL_arg3056z00_14800;
BgL_arg3056z00_14800 = 
CDR(
((obj_t)BgL_l1323z00_14794)); 
{ 
obj_t BgL_tail1326z00_28771;obj_t BgL_l1323z00_28770;
BgL_l1323z00_28770 = BgL_arg3056z00_14800; 
BgL_tail1326z00_28771 = BgL_newtail1327z00_14796; 
BgL_tail1326z00_14795 = BgL_tail1326z00_28771; 
BgL_l1323z00_14794 = BgL_l1323z00_28770; 
goto BgL_zc3z04anonymousza33054ze3z87_14793;} } } } } 
{ /* Eval/evaluate_comp.scm 516 */
long BgL_g1114z00_14801;
BgL_g1114z00_14801 = 
(
(long)CINT(BgL_bpz00_14781)+BgL_siza7eza7_12472); 
{ 
obj_t BgL_lz00_14803;long BgL_iz00_14804;
BgL_lz00_14803 = BgL_rvalsz00_14790; 
BgL_iz00_14804 = BgL_g1114z00_14801; 
BgL_recz00_14802:
if(
NULLP(BgL_lz00_14803))
{ /* Eval/evaluate_comp.scm 517 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 517 */
{ /* Eval/evaluate_comp.scm 518 */
obj_t BgL_arg3049z00_14805;obj_t BgL_arg3050z00_14806;
BgL_arg3049z00_14805 = 
VECTOR_REF(
((obj_t)BgL_sz00_12475),BgL_iz00_14804); 
BgL_arg3050z00_14806 = 
CAR(
((obj_t)BgL_lz00_14803)); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_28782;obj_t BgL_tmpz00_28780;
BgL_auxz00_28782 = 
(int)(((long)0)); 
BgL_tmpz00_28780 = 
((obj_t)BgL_arg3049z00_14805); 
STRUCT_SET(BgL_tmpz00_28780, BgL_auxz00_28782, BgL_arg3050z00_14806); } } 
{ /* Eval/evaluate_comp.scm 519 */
obj_t BgL_arg3051z00_14807;long BgL_arg3052z00_14808;
BgL_arg3051z00_14807 = 
CDR(
((obj_t)BgL_lz00_14803)); 
BgL_arg3052z00_14808 = 
(BgL_iz00_14804+((long)1)); 
{ 
long BgL_iz00_28789;obj_t BgL_lz00_28788;
BgL_lz00_28788 = BgL_arg3051z00_14807; 
BgL_iz00_28789 = BgL_arg3052z00_14808; 
BgL_iz00_14804 = BgL_iz00_28789; 
BgL_lz00_14803 = BgL_lz00_28788; 
goto BgL_recz00_14802;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12474)(BgL_bodyz00_12474, BgL_sz00_12475, BEOA);} } } } 

}



/* &comp-ev_let*1413 */
obj_t BGl_z62compzd2ev_letza21413z12zz__evaluate_compz00(obj_t BgL_envz00_12476, obj_t BgL_ez00_12477, obj_t BgL_stkz00_12478)
{
{ /* Eval/evaluate_comp.scm 481 */
{ /* Eval/evaluate_comp.scm 483 */
long BgL_siza7eza7_14810;obj_t BgL_nstkz00_14811;
BgL_siza7eza7_14810 = 
bgl_list_length(BgL_stkz00_12478); 
{ /* Eval/evaluate_comp.scm 483 */
obj_t BgL_arg3023z00_14812;
BgL_arg3023z00_14812 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12477))))->BgL_varsz00); 
BgL_nstkz00_14811 = 
BGl_appendzd221009zd2zz__evaluate_compz00(BgL_stkz00_12478, BgL_arg3023z00_14812); } 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_valsz00_14813;obj_t BgL_bodyz00_14814;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_l1309z00_14815;
BgL_l1309z00_14815 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12477))))->BgL_valsz00); 
if(
NULLP(BgL_l1309z00_14815))
{ /* Eval/evaluate_comp.scm 484 */
BgL_valsz00_14813 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_head1311z00_14816;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_res4734z00_14817;
BgL_res4734z00_14817 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1311z00_14816 = BgL_res4734z00_14817; } 
{ 
obj_t BgL_l1309z00_14819;obj_t BgL_tail1312z00_14820;
BgL_l1309z00_14819 = BgL_l1309z00_14815; 
BgL_tail1312z00_14820 = BgL_head1311z00_14816; 
BgL_zc3z04anonymousza33018ze3z87_14818:
if(
NULLP(BgL_l1309z00_14819))
{ /* Eval/evaluate_comp.scm 484 */
BgL_valsz00_14813 = 
CDR(BgL_head1311z00_14816); }  else 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_newtail1313z00_14821;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_arg3021z00_14822;
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_vz00_14823;
BgL_vz00_14823 = 
CAR(
((obj_t)BgL_l1309z00_14819)); 
BgL_arg3021z00_14822 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_vz00_14823), BgL_nstkz00_14811); } 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_res4736z00_14824;
BgL_res4736z00_14824 = 
MAKE_YOUNG_PAIR(BgL_arg3021z00_14822, BNIL); 
BgL_newtail1313z00_14821 = BgL_res4736z00_14824; } } 
SET_CDR(BgL_tail1312z00_14820, BgL_newtail1313z00_14821); 
{ /* Eval/evaluate_comp.scm 484 */
obj_t BgL_arg3020z00_14825;
BgL_arg3020z00_14825 = 
CDR(
((obj_t)BgL_l1309z00_14819)); 
{ 
obj_t BgL_tail1312z00_28817;obj_t BgL_l1309z00_28816;
BgL_l1309z00_28816 = BgL_arg3020z00_14825; 
BgL_tail1312z00_28817 = BgL_newtail1313z00_14821; 
BgL_tail1312z00_14820 = BgL_tail1312z00_28817; 
BgL_l1309z00_14819 = BgL_l1309z00_28816; 
goto BgL_zc3z04anonymousza33018ze3z87_14818;} } } } } } 
{ /* Eval/evaluate_comp.scm 485 */
BgL_ev_exprz00_bglt BgL_arg3022z00_14826;
BgL_arg3022z00_14826 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_ez00_12477))))->BgL_bodyz00); 
BgL_bodyz00_14814 = 
BGl_compz00zz__evaluate_compz00(BgL_arg3022z00_14826, BgL_nstkz00_14811); } 
{ /* Eval/evaluate_comp.scm 486 */
obj_t BgL_zc3z04anonymousza33007ze3z87_14827;
BgL_zc3z04anonymousza33007ze3z87_14827 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza33007ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33007ze3z87_14827, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14810)); 
PROCEDURE_SET(BgL_zc3z04anonymousza33007ze3z87_14827, 
(int)(((long)1)), 
((obj_t)
((BgL_ev_letza2za2_bglt)BgL_ez00_12477))); 
PROCEDURE_SET(BgL_zc3z04anonymousza33007ze3z87_14827, 
(int)(((long)2)), BgL_valsz00_14813); 
PROCEDURE_SET(BgL_zc3z04anonymousza33007ze3z87_14827, 
(int)(((long)3)), BgL_bodyz00_14814); 
return BgL_zc3z04anonymousza33007ze3z87_14827;} } } } 

}



/* &<@anonymous:3007> */
obj_t BGl_z62zc3z04anonymousza33007ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12479, obj_t BgL_sz00_12484)
{
{ /* Eval/evaluate_comp.scm 486 */
{ /* Eval/evaluate_comp.scm 486 */
long BgL_siza7eza7_12480;BgL_ev_letza2za2_bglt BgL_i1108z00_12481;obj_t BgL_valsz00_12482;obj_t BgL_bodyz00_12483;
BgL_siza7eza7_12480 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12479, 
(int)(((long)0)))); 
BgL_i1108z00_12481 = 
((BgL_ev_letza2za2_bglt)
PROCEDURE_REF(BgL_envz00_12479, 
(int)(((long)1)))); 
BgL_valsz00_12482 = 
PROCEDURE_REF(BgL_envz00_12479, 
(int)(((long)2))); 
BgL_bodyz00_12483 = 
PROCEDURE_REF(BgL_envz00_12479, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 486 */
obj_t BgL_bpz00_14828;
BgL_bpz00_14828 = 
VECTOR_REF(
((obj_t)BgL_sz00_12484),((long)0)); 
{ /* Eval/evaluate_comp.scm 487 */
long BgL_g1109z00_14829;
BgL_g1109z00_14829 = 
(
(long)CINT(BgL_bpz00_14828)+BgL_siza7eza7_12480); 
{ 
obj_t BgL_lz00_14831;long BgL_iz00_14832;obj_t BgL_bza2za2_14833;
BgL_lz00_14831 = BgL_valsz00_12482; 
BgL_iz00_14832 = BgL_g1109z00_14829; 
BgL_bza2za2_14833 = 
(((BgL_ev_letza2za2_bglt)COBJECT(BgL_i1108z00_12481))->BgL_boxesz00); 
BgL_recz00_14830:
if(
NULLP(BgL_lz00_14831))
{ /* Eval/evaluate_comp.scm 488 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 488 */
{ /* Eval/evaluate_comp.scm 489 */
obj_t BgL_valz00_14834;
{ /* Eval/evaluate_comp.scm 489 */
obj_t BgL_fun3013z00_14835;
BgL_fun3013z00_14835 = 
CAR(
((obj_t)BgL_lz00_14831)); 
BgL_valz00_14834 = 
PROCEDURE_ENTRY(BgL_fun3013z00_14835)(BgL_fun3013z00_14835, BgL_sz00_12484, BEOA); } 
{ /* Eval/evaluate_comp.scm 490 */
obj_t BgL_arg3011z00_14836;
if(
CBOOL(
CAR(
((obj_t)BgL_bza2za2_14833))))
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14837;
BgL_newz00_14837 = 
create_struct(BGl_symbol5256z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28864;
BgL_tmpz00_28864 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14837, BgL_tmpz00_28864, BgL_valz00_14834); } 
BgL_arg3011z00_14836 = BgL_newz00_14837; }  else 
{ /* Eval/evaluate_comp.scm 490 */
BgL_arg3011z00_14836 = BgL_valz00_14834; } 
VECTOR_SET(
((obj_t)BgL_sz00_12484),BgL_iz00_14832,BgL_arg3011z00_14836); } } 
{ /* Eval/evaluate_comp.scm 491 */
obj_t BgL_arg3014z00_14838;long BgL_arg3015z00_14839;obj_t BgL_arg3016z00_14840;
BgL_arg3014z00_14838 = 
CDR(
((obj_t)BgL_lz00_14831)); 
BgL_arg3015z00_14839 = 
(BgL_iz00_14832+((long)1)); 
BgL_arg3016z00_14840 = 
CDR(
((obj_t)BgL_bza2za2_14833)); 
{ 
obj_t BgL_bza2za2_28876;long BgL_iz00_28875;obj_t BgL_lz00_28874;
BgL_lz00_28874 = BgL_arg3014z00_14838; 
BgL_iz00_28875 = BgL_arg3015z00_14839; 
BgL_bza2za2_28876 = BgL_arg3016z00_14840; 
BgL_bza2za2_14833 = BgL_bza2za2_28876; 
BgL_iz00_14832 = BgL_iz00_28875; 
BgL_lz00_14831 = BgL_lz00_28874; 
goto BgL_recz00_14830;} } } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12483)(BgL_bodyz00_12483, BgL_sz00_12484, BEOA);} } } 

}



/* &comp-ev_let1411 */
obj_t BGl_z62compzd2ev_let1411zb0zz__evaluate_compz00(obj_t BgL_envz00_12485, obj_t BgL_ez00_12486, obj_t BgL_stkz00_12487)
{
{ /* Eval/evaluate_comp.scm 462 */
{ /* Eval/evaluate_comp.scm 464 */
long BgL_siza7eza7_14842;obj_t BgL_nstkz00_14843;
BgL_siza7eza7_14842 = 
bgl_list_length(BgL_stkz00_12487); 
{ /* Eval/evaluate_comp.scm 464 */
obj_t BgL_arg3006z00_14844;
BgL_arg3006z00_14844 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12486))))->BgL_varsz00); 
BgL_nstkz00_14843 = 
BGl_appendzd221009zd2zz__evaluate_compz00(BgL_stkz00_12487, BgL_arg3006z00_14844); } 
{ /* Eval/evaluate_comp.scm 465 */
obj_t BgL_valsz00_14845;obj_t BgL_iboxesz00_14846;obj_t BgL_bodyz00_14847;
{ /* Eval/evaluate_comp.scm 466 */
obj_t BgL_arg2999z00_14848;
BgL_arg2999z00_14848 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12486))))->BgL_valsz00); 
BgL_valsz00_14845 = 
BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg2999z00_14848, BgL_stkz00_12487); } 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_l1304z00_14849;
BgL_l1304z00_14849 = 
(((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_ez00_12486)))->BgL_boxesz00); 
if(
NULLP(BgL_l1304z00_14849))
{ /* Eval/evaluate_comp.scm 467 */
BgL_iboxesz00_14846 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_head1306z00_14850;
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_res4725z00_14851;
BgL_res4725z00_14851 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1306z00_14850 = BgL_res4725z00_14851; } 
{ 
obj_t BgL_l1304z00_14853;obj_t BgL_tail1307z00_14854;
BgL_l1304z00_14853 = BgL_l1304z00_14849; 
BgL_tail1307z00_14854 = BgL_head1306z00_14850; 
BgL_zc3z04anonymousza33001ze3z87_14852:
if(
NULLP(BgL_l1304z00_14853))
{ /* Eval/evaluate_comp.scm 467 */
BgL_iboxesz00_14846 = 
CDR(BgL_head1306z00_14850); }  else 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_newtail1308z00_14855;
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_arg3004z00_14856;
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_vz00_14857;
BgL_vz00_14857 = 
CAR(
((obj_t)BgL_l1304z00_14853)); 
BgL_arg3004z00_14856 = 
BGl__indexz00zz__evaluate_compz00(BgL_vz00_14857, BgL_nstkz00_14843); } 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_res4727z00_14858;
BgL_res4727z00_14858 = 
MAKE_YOUNG_PAIR(BgL_arg3004z00_14856, BNIL); 
BgL_newtail1308z00_14855 = BgL_res4727z00_14858; } } 
SET_CDR(BgL_tail1307z00_14854, BgL_newtail1308z00_14855); 
{ /* Eval/evaluate_comp.scm 467 */
obj_t BgL_arg3003z00_14859;
BgL_arg3003z00_14859 = 
CDR(
((obj_t)BgL_l1304z00_14853)); 
{ 
obj_t BgL_tail1307z00_28907;obj_t BgL_l1304z00_28906;
BgL_l1304z00_28906 = BgL_arg3003z00_14859; 
BgL_tail1307z00_28907 = BgL_newtail1308z00_14855; 
BgL_tail1307z00_14854 = BgL_tail1307z00_28907; 
BgL_l1304z00_14853 = BgL_l1304z00_28906; 
goto BgL_zc3z04anonymousza33001ze3z87_14852;} } } } } } 
{ /* Eval/evaluate_comp.scm 468 */
BgL_ev_exprz00_bglt BgL_arg3005z00_14860;
BgL_arg3005z00_14860 = 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_ez00_12486))))->BgL_bodyz00); 
BgL_bodyz00_14847 = 
BGl_compz00zz__evaluate_compz00(BgL_arg3005z00_14860, BgL_nstkz00_14843); } 
{ /* Eval/evaluate_comp.scm 469 */
obj_t BgL_zc3z04anonymousza32986ze3z87_14861;
BgL_zc3z04anonymousza32986ze3z87_14861 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32986ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)4))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32986ze3z87_14861, 
(int)(((long)0)), 
BINT(BgL_siza7eza7_14842)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32986ze3z87_14861, 
(int)(((long)1)), BgL_valsz00_14845); 
PROCEDURE_SET(BgL_zc3z04anonymousza32986ze3z87_14861, 
(int)(((long)2)), BgL_iboxesz00_14846); 
PROCEDURE_SET(BgL_zc3z04anonymousza32986ze3z87_14861, 
(int)(((long)3)), BgL_bodyz00_14847); 
return BgL_zc3z04anonymousza32986ze3z87_14861;} } } } 

}



/* &<@anonymous:2986> */
obj_t BGl_z62zc3z04anonymousza32986ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12488, obj_t BgL_sz00_12493)
{
{ /* Eval/evaluate_comp.scm 469 */
{ /* Eval/evaluate_comp.scm 469 */
long BgL_siza7eza7_12489;obj_t BgL_valsz00_12490;obj_t BgL_iboxesz00_12491;obj_t BgL_bodyz00_12492;
BgL_siza7eza7_12489 = 
(long)CINT(
PROCEDURE_REF(BgL_envz00_12488, 
(int)(((long)0)))); 
BgL_valsz00_12490 = 
((obj_t)
PROCEDURE_REF(BgL_envz00_12488, 
(int)(((long)1)))); 
BgL_iboxesz00_12491 = 
PROCEDURE_REF(BgL_envz00_12488, 
(int)(((long)2))); 
BgL_bodyz00_12492 = 
PROCEDURE_REF(BgL_envz00_12488, 
(int)(((long)3))); 
{ /* Eval/evaluate_comp.scm 469 */
obj_t BgL_bpz00_14862;
BgL_bpz00_14862 = 
VECTOR_REF(
((obj_t)BgL_sz00_12493),((long)0)); 
{ /* Eval/evaluate_comp.scm 470 */
long BgL_g1107z00_14863;
BgL_g1107z00_14863 = 
(
(long)CINT(BgL_bpz00_14862)+BgL_siza7eza7_12489); 
{ 
obj_t BgL_lz00_14865;long BgL_iz00_14866;
BgL_lz00_14865 = BgL_valsz00_12490; 
BgL_iz00_14866 = BgL_g1107z00_14863; 
BgL_recz00_14864:
if(
NULLP(BgL_lz00_14865))
{ /* Eval/evaluate_comp.scm 471 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 471 */
{ /* Eval/evaluate_comp.scm 472 */
obj_t BgL_arg2989z00_14867;
{ /* Eval/evaluate_comp.scm 472 */
obj_t BgL_fun2990z00_14868;
BgL_fun2990z00_14868 = 
CAR(
((obj_t)BgL_lz00_14865)); 
BgL_arg2989z00_14867 = 
PROCEDURE_ENTRY(BgL_fun2990z00_14868)(BgL_fun2990z00_14868, BgL_sz00_12493, BEOA); } 
VECTOR_SET(
((obj_t)BgL_sz00_12493),BgL_iz00_14866,BgL_arg2989z00_14867); } 
{ /* Eval/evaluate_comp.scm 473 */
obj_t BgL_arg2991z00_14869;long BgL_arg2992z00_14870;
BgL_arg2991z00_14869 = 
CDR(
((obj_t)BgL_lz00_14865)); 
BgL_arg2992z00_14870 = 
(BgL_iz00_14866+((long)1)); 
{ 
long BgL_iz00_28952;obj_t BgL_lz00_28951;
BgL_lz00_28951 = BgL_arg2991z00_14869; 
BgL_iz00_28952 = BgL_arg2992z00_14870; 
BgL_iz00_14866 = BgL_iz00_28952; 
BgL_lz00_14865 = BgL_lz00_28951; 
goto BgL_recz00_14864;} } } } } 
{ 
obj_t BgL_lz00_14872;
BgL_lz00_14872 = BgL_iboxesz00_12491; 
BgL_recz00_14871:
if(
NULLP(BgL_lz00_14872))
{ /* Eval/evaluate_comp.scm 475 */((bool_t)0); }  else 
{ /* Eval/evaluate_comp.scm 475 */
{ /* Eval/evaluate_comp.scm 476 */
long BgL_iz00_14873;
BgL_iz00_14873 = 
(
(long)CINT(BgL_bpz00_14862)+
(long)CINT(
CAR(
((obj_t)BgL_lz00_14872)))); 
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_arg2995z00_14874;
{ /* Eval/evaluate_comp.scm 477 */
obj_t BgL_arg2996z00_14875;
BgL_arg2996z00_14875 = 
VECTOR_REF(
((obj_t)BgL_sz00_12493),BgL_iz00_14873); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_newz00_14876;
BgL_newz00_14876 = 
create_struct(BGl_symbol5256z00zz__evaluate_compz00, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 202 */
int BgL_tmpz00_28964;
BgL_tmpz00_28964 = 
(int)(((long)0)); 
STRUCT_SET(BgL_newz00_14876, BgL_tmpz00_28964, BgL_arg2996z00_14875); } 
BgL_arg2995z00_14874 = BgL_newz00_14876; } } 
VECTOR_SET(
((obj_t)BgL_sz00_12493),BgL_iz00_14873,BgL_arg2995z00_14874); } } 
{ /* Eval/evaluate_comp.scm 478 */
obj_t BgL_arg2998z00_14877;
BgL_arg2998z00_14877 = 
CDR(
((obj_t)BgL_lz00_14872)); 
{ 
obj_t BgL_lz00_28971;
BgL_lz00_28971 = BgL_arg2998z00_14877; 
BgL_lz00_14872 = BgL_lz00_28971; 
goto BgL_recz00_14871;} } } } 
return 
PROCEDURE_ENTRY(BgL_bodyz00_12492)(BgL_bodyz00_12492, BgL_sz00_12493, BEOA);} } } 

}



/* &comp-ev_prog21409 */
obj_t BGl_z62compzd2ev_prog21409zb0zz__evaluate_compz00(obj_t BgL_envz00_12494, obj_t BgL_ez00_12495, obj_t BgL_stkz00_12496)
{
{ /* Eval/evaluate_comp.scm 456 */
{ /* Eval/evaluate_comp.scm 458 */
obj_t BgL_e1z00_14879;obj_t BgL_e2z00_14880;
BgL_e1z00_14879 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_12495)))->BgL_e1z00), BgL_stkz00_12496); 
BgL_e2z00_14880 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_ez00_12495)))->BgL_e2z00), BgL_stkz00_12496); 
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_zc3z04anonymousza32983ze3z87_14881;
BgL_zc3z04anonymousza32983ze3z87_14881 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32983ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32983ze3z87_14881, 
(int)(((long)0)), BgL_e1z00_14879); 
PROCEDURE_SET(BgL_zc3z04anonymousza32983ze3z87_14881, 
(int)(((long)1)), BgL_e2z00_14880); 
return BgL_zc3z04anonymousza32983ze3z87_14881;} } } 

}



/* &<@anonymous:2983> */
obj_t BGl_z62zc3z04anonymousza32983ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12497, obj_t BgL_sz00_12500)
{
{ /* Eval/evaluate_comp.scm 459 */
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_e1z00_12498;obj_t BgL_e2z00_12499;
BgL_e1z00_12498 = 
PROCEDURE_REF(BgL_envz00_12497, 
(int)(((long)0))); 
BgL_e2z00_12499 = 
PROCEDURE_REF(BgL_envz00_12497, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 459 */
obj_t BgL_bpz00_14882;
BgL_bpz00_14882 = 
VECTOR_REF(
((obj_t)BgL_sz00_12500),((long)0)); 
PROCEDURE_ENTRY(BgL_e1z00_12498)(BgL_e1z00_12498, BgL_sz00_12500, BEOA); 
return 
PROCEDURE_ENTRY(BgL_e2z00_12499)(BgL_e2z00_12499, BgL_sz00_12500, BEOA);} } } 

}



/* &comp-ev_and1406 */
obj_t BGl_z62compzd2ev_and1406zb0zz__evaluate_compz00(obj_t BgL_envz00_12501, obj_t BgL_ez00_12502, obj_t BgL_stkz00_12503)
{
{ /* Eval/evaluate_comp.scm 446 */
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_argsz00_14884;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_l1299z00_14885;
BgL_l1299z00_14885 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_ez00_12502))))->BgL_argsz00); 
if(
NULLP(BgL_l1299z00_14885))
{ /* Eval/evaluate_comp.scm 448 */
BgL_argsz00_14884 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_head1301z00_14886;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_res4720z00_14887;
BgL_res4720z00_14887 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1301z00_14886 = BgL_res4720z00_14887; } 
{ 
obj_t BgL_l1299z00_14889;obj_t BgL_tail1302z00_14890;
BgL_l1299z00_14889 = BgL_l1299z00_14885; 
BgL_tail1302z00_14890 = BgL_head1301z00_14886; 
BgL_zc3z04anonymousza32979ze3z87_14888:
if(
NULLP(BgL_l1299z00_14889))
{ /* Eval/evaluate_comp.scm 448 */
BgL_argsz00_14884 = 
CDR(BgL_head1301z00_14886); }  else 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_newtail1303z00_14891;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_arg2982z00_14892;
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_ez00_14893;
BgL_ez00_14893 = 
CAR(
((obj_t)BgL_l1299z00_14889)); 
BgL_arg2982z00_14892 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_ez00_14893), BgL_stkz00_12503); } 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_res4722z00_14894;
BgL_res4722z00_14894 = 
MAKE_YOUNG_PAIR(BgL_arg2982z00_14892, BNIL); 
BgL_newtail1303z00_14891 = BgL_res4722z00_14894; } } 
SET_CDR(BgL_tail1302z00_14890, BgL_newtail1303z00_14891); 
{ /* Eval/evaluate_comp.scm 448 */
obj_t BgL_arg2981z00_14895;
BgL_arg2981z00_14895 = 
CDR(
((obj_t)BgL_l1299z00_14889)); 
{ 
obj_t BgL_tail1302z00_29021;obj_t BgL_l1299z00_29020;
BgL_l1299z00_29020 = BgL_arg2981z00_14895; 
BgL_tail1302z00_29021 = BgL_newtail1303z00_14891; 
BgL_tail1302z00_14890 = BgL_tail1302z00_29021; 
BgL_l1299z00_14889 = BgL_l1299z00_29020; 
goto BgL_zc3z04anonymousza32979ze3z87_14888;} } } } } } 
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_zc3z04anonymousza32973ze3z87_14896;
BgL_zc3z04anonymousza32973ze3z87_14896 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32973ze3z87_14896, 
(int)(((long)0)), BgL_argsz00_14884); 
return BgL_zc3z04anonymousza32973ze3z87_14896;} } } 

}



/* &<@anonymous:2973> */
obj_t BGl_z62zc3z04anonymousza32973ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12504, obj_t BgL_sz00_12506)
{
{ /* Eval/evaluate_comp.scm 449 */
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_argsz00_12505;
BgL_argsz00_12505 = 
PROCEDURE_REF(BgL_envz00_12504, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 449 */
obj_t BgL_bpz00_14897;
BgL_bpz00_14897 = 
VECTOR_REF(
((obj_t)BgL_sz00_12506),((long)0)); 
{ 
obj_t BgL_lz00_14899;obj_t BgL_rz00_14900;
BgL_lz00_14899 = BgL_argsz00_12505; 
BgL_rz00_14900 = BTRUE; 
BgL_recz00_14898:
if(
NULLP(BgL_lz00_14899))
{ /* Eval/evaluate_comp.scm 451 */
return BgL_rz00_14900;}  else 
{ /* Eval/evaluate_comp.scm 453 */
obj_t BgL_vz00_14901;
{ /* Eval/evaluate_comp.scm 453 */
obj_t BgL_fun2977z00_14902;
BgL_fun2977z00_14902 = 
CAR(
((obj_t)BgL_lz00_14899)); 
BgL_vz00_14901 = 
PROCEDURE_ENTRY(BgL_fun2977z00_14902)(BgL_fun2977z00_14902, BgL_sz00_12506, BEOA); } 
if(
CBOOL(BgL_vz00_14901))
{ /* Eval/evaluate_comp.scm 454 */
obj_t BgL_arg2976z00_14903;
BgL_arg2976z00_14903 = 
CDR(
((obj_t)BgL_lz00_14899)); 
{ 
obj_t BgL_rz00_29044;obj_t BgL_lz00_29043;
BgL_lz00_29043 = BgL_arg2976z00_14903; 
BgL_rz00_29044 = BgL_vz00_14901; 
BgL_rz00_14900 = BgL_rz00_29044; 
BgL_lz00_14899 = BgL_lz00_29043; 
goto BgL_recz00_14898;} }  else 
{ /* Eval/evaluate_comp.scm 454 */
return BFALSE;} } } } } } 

}



/* &comp-ev_or1404 */
obj_t BGl_z62compzd2ev_or1404zb0zz__evaluate_compz00(obj_t BgL_envz00_12507, obj_t BgL_ez00_12508, obj_t BgL_stkz00_12509)
{
{ /* Eval/evaluate_comp.scm 437 */
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_argsz00_14905;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_l1294z00_14906;
BgL_l1294z00_14906 = 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_ez00_12508))))->BgL_argsz00); 
if(
NULLP(BgL_l1294z00_14906))
{ /* Eval/evaluate_comp.scm 439 */
BgL_argsz00_14905 = BNIL; }  else 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_head1296z00_14907;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_res4715z00_14908;
BgL_res4715z00_14908 = 
MAKE_YOUNG_PAIR(BNIL, BNIL); 
BgL_head1296z00_14907 = BgL_res4715z00_14908; } 
{ 
obj_t BgL_l1294z00_14910;obj_t BgL_tail1297z00_14911;
BgL_l1294z00_14910 = BgL_l1294z00_14906; 
BgL_tail1297z00_14911 = BgL_head1296z00_14907; 
BgL_zc3z04anonymousza32969ze3z87_14909:
if(
NULLP(BgL_l1294z00_14910))
{ /* Eval/evaluate_comp.scm 439 */
BgL_argsz00_14905 = 
CDR(BgL_head1296z00_14907); }  else 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_newtail1298z00_14912;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_arg2972z00_14913;
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_ez00_14914;
BgL_ez00_14914 = 
CAR(
((obj_t)BgL_l1294z00_14910)); 
BgL_arg2972z00_14913 = 
BGl_compz00zz__evaluate_compz00(
((BgL_ev_exprz00_bglt)BgL_ez00_14914), BgL_stkz00_12509); } 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_res4717z00_14915;
BgL_res4717z00_14915 = 
MAKE_YOUNG_PAIR(BgL_arg2972z00_14913, BNIL); 
BgL_newtail1298z00_14912 = BgL_res4717z00_14915; } } 
SET_CDR(BgL_tail1297z00_14911, BgL_newtail1298z00_14912); 
{ /* Eval/evaluate_comp.scm 439 */
obj_t BgL_arg2971z00_14916;
BgL_arg2971z00_14916 = 
CDR(
((obj_t)BgL_l1294z00_14910)); 
{ 
obj_t BgL_tail1297z00_29063;obj_t BgL_l1294z00_29062;
BgL_l1294z00_29062 = BgL_arg2971z00_14916; 
BgL_tail1297z00_29063 = BgL_newtail1298z00_14912; 
BgL_tail1297z00_14911 = BgL_tail1297z00_29063; 
BgL_l1294z00_14910 = BgL_l1294z00_29062; 
goto BgL_zc3z04anonymousza32969ze3z87_14909;} } } } } } 
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_zc3z04anonymousza32963ze3z87_14917;
BgL_zc3z04anonymousza32963ze3z87_14917 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32963ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32963ze3z87_14917, 
(int)(((long)0)), BgL_argsz00_14905); 
return BgL_zc3z04anonymousza32963ze3z87_14917;} } } 

}



/* &<@anonymous:2963> */
obj_t BGl_z62zc3z04anonymousza32963ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12510, obj_t BgL_sz00_12512)
{
{ /* Eval/evaluate_comp.scm 440 */
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_argsz00_12511;
BgL_argsz00_12511 = 
PROCEDURE_REF(BgL_envz00_12510, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 440 */
obj_t BgL_bpz00_14918;
BgL_bpz00_14918 = 
VECTOR_REF(
((obj_t)BgL_sz00_12512),((long)0)); 
{ 
obj_t BgL_lz00_14920;
BgL_lz00_14920 = BgL_argsz00_12511; 
BgL_recz00_14919:
if(
NULLP(BgL_lz00_14920))
{ /* Eval/evaluate_comp.scm 442 */
return BFALSE;}  else 
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL__ortest_1102z00_14921;
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL_fun2967z00_14922;
BgL_fun2967z00_14922 = 
CAR(
((obj_t)BgL_lz00_14920)); 
BgL__ortest_1102z00_14921 = 
PROCEDURE_ENTRY(BgL_fun2967z00_14922)(BgL_fun2967z00_14922, BgL_sz00_12512, BEOA); } 
if(
CBOOL(BgL__ortest_1102z00_14921))
{ /* Eval/evaluate_comp.scm 444 */
return BgL__ortest_1102z00_14921;}  else 
{ /* Eval/evaluate_comp.scm 444 */
obj_t BgL_arg2966z00_14923;
BgL_arg2966z00_14923 = 
CDR(
((obj_t)BgL_lz00_14920)); 
{ 
obj_t BgL_lz00_29085;
BgL_lz00_29085 = BgL_arg2966z00_14923; 
BgL_lz00_14920 = BgL_lz00_29085; 
goto BgL_recz00_14919;} } } } } } } 

}



/* &comp-ev_if1402 */
obj_t BGl_z62compzd2ev_if1402zb0zz__evaluate_compz00(obj_t BgL_envz00_12513, obj_t BgL_ez00_12514, obj_t BgL_stkz00_12515)
{
{ /* Eval/evaluate_comp.scm 431 */
{ /* Eval/evaluate_comp.scm 433 */
obj_t BgL_pz00_14925;obj_t BgL_tz00_14926;obj_t BgL_ez00_14927;
BgL_pz00_14925 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12514)))->BgL_pz00), BgL_stkz00_12515); 
BgL_tz00_14926 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12514)))->BgL_tz00), BgL_stkz00_12515); 
BgL_ez00_14927 = 
BGl_compz00zz__evaluate_compz00(
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_ez00_12514)))->BgL_ez00), BgL_stkz00_12515); 
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_zc3z04anonymousza32958ze3z87_14928;
BgL_zc3z04anonymousza32958ze3z87_14928 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32958ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32958ze3z87_14928, 
(int)(((long)0)), BgL_ez00_14927); 
PROCEDURE_SET(BgL_zc3z04anonymousza32958ze3z87_14928, 
(int)(((long)1)), BgL_tz00_14926); 
PROCEDURE_SET(BgL_zc3z04anonymousza32958ze3z87_14928, 
(int)(((long)2)), BgL_pz00_14925); 
return BgL_zc3z04anonymousza32958ze3z87_14928;} } } 

}



/* &<@anonymous:2958> */
obj_t BGl_z62zc3z04anonymousza32958ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12516, obj_t BgL_sz00_12520)
{
{ /* Eval/evaluate_comp.scm 434 */
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_ez00_12517;obj_t BgL_tz00_12518;obj_t BgL_pz00_12519;
BgL_ez00_12517 = 
PROCEDURE_REF(BgL_envz00_12516, 
(int)(((long)0))); 
BgL_tz00_12518 = 
PROCEDURE_REF(BgL_envz00_12516, 
(int)(((long)1))); 
BgL_pz00_12519 = 
PROCEDURE_REF(BgL_envz00_12516, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 434 */
obj_t BgL_bpz00_14929;
BgL_bpz00_14929 = 
VECTOR_REF(
((obj_t)BgL_sz00_12520),((long)0)); 
if(
CBOOL(
PROCEDURE_ENTRY(BgL_pz00_12519)(BgL_pz00_12519, BgL_sz00_12520, BEOA)))
{ /* Eval/evaluate_comp.scm 435 */
return 
PROCEDURE_ENTRY(BgL_tz00_12518)(BgL_tz00_12518, BgL_sz00_12520, BEOA);}  else 
{ /* Eval/evaluate_comp.scm 435 */
return 
PROCEDURE_ENTRY(BgL_ez00_12517)(BgL_ez00_12517, BgL_sz00_12520, BEOA);} } } } 

}



/* &comp-ev_litt1400 */
obj_t BGl_z62compzd2ev_litt1400zb0zz__evaluate_compz00(obj_t BgL_envz00_12521, obj_t BgL_ez00_12522, obj_t BgL_stkz00_12523)
{
{ /* Eval/evaluate_comp.scm 426 */
{ /* Eval/evaluate_comp.scm 428 */
obj_t BgL_zc3z04anonymousza32957ze3z87_14931;
BgL_zc3z04anonymousza32957ze3z87_14931 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32957ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32957ze3z87_14931, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_littz00_bglt)BgL_ez00_12522))); 
return BgL_zc3z04anonymousza32957ze3z87_14931;} } 

}



/* &<@anonymous:2957> */
obj_t BGl_z62zc3z04anonymousza32957ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12524, obj_t BgL_sz00_12526)
{
{ /* Eval/evaluate_comp.scm 428 */
{ /* Eval/evaluate_comp.scm 428 */
BgL_ev_littz00_bglt BgL_i1099z00_12525;
BgL_i1099z00_12525 = 
((BgL_ev_littz00_bglt)
PROCEDURE_REF(BgL_envz00_12524, 
(int)(((long)0)))); 
{ /* Eval/evaluate_comp.scm 428 */
obj_t BgL_bpz00_14932;
BgL_bpz00_14932 = 
VECTOR_REF(
((obj_t)BgL_sz00_12526),((long)0)); 
return 
(((BgL_ev_littz00_bglt)COBJECT(BgL_i1099z00_12525))->BgL_valuez00);} } } 

}



/* &comp-ev_defglobal1398 */
obj_t BGl_z62compzd2ev_defglobal1398zb0zz__evaluate_compz00(obj_t BgL_envz00_12527, obj_t BgL_ez00_12528, obj_t BgL_stkz00_12529)
{
{ /* Eval/evaluate_comp.scm 395 */
{ /* Eval/evaluate_comp.scm 397 */
obj_t BgL_ez00_14934;
{ /* Eval/evaluate_comp.scm 397 */
BgL_ev_exprz00_bglt BgL_arg2956z00_14935;
BgL_arg2956z00_14935 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_ez00_12528))))->BgL_ez00); 
BgL_ez00_14934 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2956z00_14935, BgL_stkz00_12529); } 
{ /* Eval/evaluate_comp.scm 398 */
obj_t BgL_zc3z04anonymousza32931ze3z87_14936;
BgL_zc3z04anonymousza32931ze3z87_14936 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32931ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32931ze3z87_14936, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_defglobalz00_bglt)BgL_ez00_12528))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32931ze3z87_14936, 
(int)(((long)1)), BgL_ez00_14934); 
return BgL_zc3z04anonymousza32931ze3z87_14936;} } } 

}



/* &<@anonymous:2931> */
obj_t BGl_z62zc3z04anonymousza32931ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12530, obj_t BgL_sz00_12533)
{
{ /* Eval/evaluate_comp.scm 398 */
{ /* Eval/evaluate_comp.scm 398 */
BgL_ev_defglobalz00_bglt BgL_i1096z00_12531;obj_t BgL_ez00_12532;
BgL_i1096z00_12531 = 
((BgL_ev_defglobalz00_bglt)
PROCEDURE_REF(BgL_envz00_12530, 
(int)(((long)0)))); 
BgL_ez00_12532 = 
PROCEDURE_REF(BgL_envz00_12530, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 398 */
obj_t BgL_bpz00_14937;
BgL_bpz00_14937 = 
VECTOR_REF(
((obj_t)BgL_sz00_12533),((long)0)); 
{ /* Eval/evaluate_comp.scm 399 */
obj_t BgL_gz00_14938;
{ /* Eval/evaluate_comp.scm 399 */
obj_t BgL_arg2954z00_14939;obj_t BgL_arg2955z00_14940;
BgL_arg2954z00_14939 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_modz00); 
BgL_arg2955z00_14940 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_namez00); 
BgL_gz00_14938 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(BgL_arg2954z00_14939, BgL_arg2955z00_14940); } 
if(
CBOOL(BgL_gz00_14938))
{ /* Eval/evaluate_comp.scm 401 */
{ 

{ /* Eval/evaluate_comp.scm 403 */
int BgL_aux1098z00_14944;
{ /* Eval/evaluate_comp.scm 403 */
int BgL_res4713z00_14945;
BgL_res4713z00_14945 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14938),((long)0))); 
BgL_aux1098z00_14944 = BgL_res4713z00_14945; } 
switch( 
(long)(BgL_aux1098z00_14944)) { case ((long)0) : 

{ /* Eval/evaluate_comp.scm 405 */
obj_t BgL_arg2933z00_14946;obj_t BgL_arg2934z00_14947;
BgL_arg2933z00_14946 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_locz00); 
BgL_arg2934z00_14947 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_namez00); 
BGl_everrorz00zz__everrorz00(BgL_arg2933z00_14946, BGl_string5367z00zz__evaluate_compz00, BGl_string5368z00zz__evaluate_compz00, BgL_arg2934z00_14947); } break;case ((long)1) : 

{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2935z00_14948;obj_t BgL_arg2936z00_14949;
BgL_arg2935z00_14948 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_locz00); 
BgL_arg2936z00_14949 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_namez00); 
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_list2937z00_14950;
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2938z00_14951;
{ /* Eval/evaluate_comp.scm 407 */
obj_t BgL_arg2939z00_14952;
BgL_arg2939z00_14952 = 
MAKE_YOUNG_PAIR(BgL_arg2936z00_14949, BNIL); 
BgL_arg2938z00_14951 = 
MAKE_YOUNG_PAIR(BGl_string5369z00zz__evaluate_compz00, BgL_arg2939z00_14952); } 
BgL_list2937z00_14950 = 
MAKE_YOUNG_PAIR(BGl_string5246z00zz__evaluate_compz00, BgL_arg2938z00_14951); } 
BGl_evwarningz00zz__everrorz00(BgL_arg2935z00_14948, BgL_list2937z00_14950); } } 
{ /* Eval/evaluate_comp.scm 409 */
obj_t BgL_arg2940z00_14953;obj_t BgL_arg2941z00_14954;
BgL_arg2940z00_14953 = 
VECTOR_REF(
((obj_t)BgL_gz00_14938),((long)2)); 
BgL_arg2941z00_14954 = 
PROCEDURE_ENTRY(BgL_ez00_12532)(BgL_ez00_12532, BgL_sz00_12533, BEOA); 
__EVMEANING_ADDRESS_SET(BgL_arg2940z00_14953, BgL_arg2941z00_14954); } break;case ((long)2) : 

{ /* Eval/evaluate_comp.scm 411 */
obj_t BgL_arg2942z00_14955;
BgL_arg2942z00_14955 = 
PROCEDURE_ENTRY(BgL_ez00_12532)(BgL_ez00_12532, BgL_sz00_12533, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14938),((long)2),BgL_arg2942z00_14955); } break;case ((long)3) : 

{ /* Eval/evaluate_comp.scm 413 */
obj_t BgL_arg2943z00_14956;
BgL_arg2943z00_14956 = 
PROCEDURE_ENTRY(BgL_ez00_12532)(BgL_ez00_12532, BgL_sz00_12533, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14938),((long)2),BgL_arg2943z00_14956); } 
VECTOR_SET(
((obj_t)BgL_gz00_14938),((long)0),
BINT(((long)2))); break;case ((long)4) : 

{ /* Eval/evaluate_comp.scm 416 */
obj_t BgL_arg2944z00_14957;
BgL_arg2944z00_14957 = 
PROCEDURE_ENTRY(BgL_ez00_12532)(BgL_ez00_12532, BgL_sz00_12533, BEOA); 
VECTOR_SET(
((obj_t)BgL_gz00_14938),((long)2),BgL_arg2944z00_14957); } 
VECTOR_SET(
((obj_t)BgL_gz00_14938),((long)0),
BINT(((long)5))); break;
default: 
{ /* Eval/evaluate_comp.scm 419 */
obj_t BgL_arg2945z00_14942;obj_t BgL_arg2946z00_14943;
BgL_arg2945z00_14942 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_locz00); 
BgL_arg2946z00_14943 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_namez00); 
BGl_everrorz00zz__everrorz00(BgL_arg2945z00_14942, BGl_string5367z00zz__evaluate_compz00, BGl_string5368z00zz__evaluate_compz00, BgL_arg2946z00_14943); } } } } 
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_namez00);}  else 
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_gz00_14958;
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_arg2951z00_14959;obj_t BgL_arg2952z00_14960;obj_t BgL_arg2953z00_14961;
BgL_arg2951z00_14959 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_namez00); 
BgL_arg2952z00_14960 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_modz00); 
BgL_arg2953z00_14961 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 421 */
obj_t BgL_v1372z00_14962;
BgL_v1372z00_14962 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1372z00_14962,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1372z00_14962,((long)1),BgL_arg2951z00_14959); 
VECTOR_SET(BgL_v1372z00_14962,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1372z00_14962,((long)3),BgL_arg2952z00_14960); 
VECTOR_SET(BgL_v1372z00_14962,((long)4),BgL_arg2953z00_14961); 
BgL_gz00_14958 = BgL_v1372z00_14962; } } 
{ /* Eval/evaluate_comp.scm 422 */
obj_t BgL_arg2947z00_14963;
BgL_arg2947z00_14963 = 
PROCEDURE_ENTRY(BgL_ez00_12532)(BgL_ez00_12532, BgL_sz00_12533, BEOA); 
VECTOR_SET(BgL_gz00_14958,((long)2),BgL_arg2947z00_14963); } 
{ /* Eval/evaluate_comp.scm 423 */
obj_t BgL_arg2948z00_14964;obj_t BgL_arg2949z00_14965;obj_t BgL_arg2950z00_14966;
BgL_arg2948z00_14964 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_modz00); 
BgL_arg2949z00_14965 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_namez00); 
BgL_arg2950z00_14966 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_locz00); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(BgL_arg2948z00_14964, BgL_arg2949z00_14965, BgL_gz00_14958, BgL_arg2950z00_14966); } 
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_i1096z00_12531)))->BgL_namez00);} } } } } 

}



/* &comp-ev_setglobal1396 */
obj_t BGl_z62compzd2ev_setglobal1396zb0zz__evaluate_compz00(obj_t BgL_envz00_12534, obj_t BgL_ez00_12535, obj_t BgL_stkz00_12536)
{
{ /* Eval/evaluate_comp.scm 372 */
{ /* Eval/evaluate_comp.scm 374 */
obj_t BgL_gz00_14968;obj_t BgL_ez00_14969;
BgL_gz00_14968 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_namez00)); 
{ /* Eval/evaluate_comp.scm 374 */
BgL_ev_exprz00_bglt BgL_arg2930z00_14970;
BgL_arg2930z00_14970 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535))))->BgL_ez00); 
BgL_ez00_14969 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2930z00_14970, BgL_stkz00_12536); } 
if(
CBOOL(BgL_gz00_14968))
{ 

{ /* Eval/evaluate_comp.scm 376 */
int BgL_aux1095z00_14973;
{ /* Eval/evaluate_comp.scm 376 */
int BgL_res4712z00_14974;
BgL_res4712z00_14974 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14968),((long)0))); 
BgL_aux1095z00_14973 = BgL_res4712z00_14974; } 
switch( 
(long)(BgL_aux1095z00_14973)) { case ((long)1) : 

{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_zc3z04anonymousza32906ze3z87_14975;
BgL_zc3z04anonymousza32906ze3z87_14975 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32906ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32906ze3z87_14975, 
(int)(((long)0)), BgL_gz00_14968); 
PROCEDURE_SET(BgL_zc3z04anonymousza32906ze3z87_14975, 
(int)(((long)1)), BgL_ez00_14969); 
return BgL_zc3z04anonymousza32906ze3z87_14975;} break;case ((long)0) : 
case ((long)4) : 
case ((long)5) : 

return 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_locz00), BGl_string5367z00zz__evaluate_compz00, BGl_string5368z00zz__evaluate_compz00, 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_namez00));break;
default: 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_zc3z04anonymousza32911ze3z87_14972;
BgL_zc3z04anonymousza32911ze3z87_14972 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32911ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32911ze3z87_14972, 
(int)(((long)0)), BgL_ez00_14969); 
PROCEDURE_SET(BgL_zc3z04anonymousza32911ze3z87_14972, 
(int)(((long)1)), BgL_gz00_14968); 
return BgL_zc3z04anonymousza32911ze3z87_14972;} } } }  else 
{ /* Eval/evaluate_comp.scm 384 */
obj_t BgL_slotz00_14976;
BgL_slotz00_14976 = 
MAKE_CELL(BFALSE); 
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_gz00_14977;
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_arg2918z00_14978;obj_t BgL_arg2919z00_14979;obj_t BgL_arg2920z00_14980;
BgL_arg2918z00_14978 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_namez00); 
BgL_arg2919z00_14979 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_modz00); 
BgL_arg2920z00_14980 = 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 386 */
obj_t BgL_v1372z00_14981;
BgL_v1372z00_14981 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1372z00_14981,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1372z00_14981,((long)1),BgL_arg2918z00_14978); 
VECTOR_SET(BgL_v1372z00_14981,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1372z00_14981,((long)3),BgL_arg2919z00_14979); 
VECTOR_SET(BgL_v1372z00_14981,((long)4),BgL_arg2920z00_14980); 
BgL_gz00_14977 = BgL_v1372z00_14981; } } 
VECTOR_SET(BgL_gz00_14977,((long)0),
BINT(((long)3))); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_namez00), BgL_gz00_14977, 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535)))->BgL_locz00)); }  else 
{ /* Eval/evaluate_comp.scm 385 */BFALSE; } 
{ /* Eval/evaluate_comp.scm 389 */
obj_t BgL_zc3z04anonymousza32922ze3z87_14982;
BgL_zc3z04anonymousza32922ze3z87_14982 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32922ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32922ze3z87_14982, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_setglobalz00_bglt)BgL_ez00_12535))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32922ze3z87_14982, 
(int)(((long)1)), 
((obj_t)BgL_slotz00_14976)); 
PROCEDURE_SET(BgL_zc3z04anonymousza32922ze3z87_14982, 
(int)(((long)2)), BgL_ez00_14969); 
return BgL_zc3z04anonymousza32922ze3z87_14982;} } } } 

}



/* &<@anonymous:2906> */
obj_t BGl_z62zc3z04anonymousza32906ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12539, obj_t BgL_sz00_12542)
{
{ /* Eval/evaluate_comp.scm 378 */
{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_gz00_12540;obj_t BgL_ez00_12541;
BgL_gz00_12540 = 
PROCEDURE_REF(BgL_envz00_12539, 
(int)(((long)0))); 
BgL_ez00_12541 = 
PROCEDURE_REF(BgL_envz00_12539, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 378 */
obj_t BgL_bpz00_14983;
BgL_bpz00_14983 = 
VECTOR_REF(
((obj_t)BgL_sz00_12542),((long)0)); 
{ /* Eval/evaluate_comp.scm 379 */
obj_t BgL_arg2907z00_14984;obj_t BgL_arg2908z00_14985;
BgL_arg2907z00_14984 = 
VECTOR_REF(
((obj_t)BgL_gz00_12540),((long)2)); 
BgL_arg2908z00_14985 = 
PROCEDURE_ENTRY(BgL_ez00_12541)(BgL_ez00_12541, BgL_sz00_12542, BEOA); 
return 
__EVMEANING_ADDRESS_SET(BgL_arg2907z00_14984, BgL_arg2908z00_14985);} } } } 

}



/* &<@anonymous:2911> */
obj_t BGl_z62zc3z04anonymousza32911ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12543, obj_t BgL_sz00_12546)
{
{ /* Eval/evaluate_comp.scm 383 */
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_ez00_12544;obj_t BgL_gz00_12545;
BgL_ez00_12544 = 
PROCEDURE_REF(BgL_envz00_12543, 
(int)(((long)0))); 
BgL_gz00_12545 = 
PROCEDURE_REF(BgL_envz00_12543, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_bpz00_14986;
BgL_bpz00_14986 = 
VECTOR_REF(
((obj_t)BgL_sz00_12546),((long)0)); 
{ /* Eval/evaluate_comp.scm 383 */
obj_t BgL_arg2912z00_14987;
BgL_arg2912z00_14987 = 
PROCEDURE_ENTRY(BgL_ez00_12544)(BgL_ez00_12544, BgL_sz00_12546, BEOA); 
return 
VECTOR_SET(
((obj_t)BgL_gz00_12545),((long)2),BgL_arg2912z00_14987);} } } } 

}



/* &<@anonymous:2922> */
obj_t BGl_z62zc3z04anonymousza32922ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12547, obj_t BgL_sz00_12551)
{
{ /* Eval/evaluate_comp.scm 389 */
{ /* Eval/evaluate_comp.scm 389 */
BgL_ev_setglobalz00_bglt BgL_i1093z00_12548;obj_t BgL_slotz00_12549;obj_t BgL_ez00_12550;
BgL_i1093z00_12548 = 
((BgL_ev_setglobalz00_bglt)
PROCEDURE_REF(BgL_envz00_12547, 
(int)(((long)0)))); 
BgL_slotz00_12549 = 
PROCEDURE_REF(BgL_envz00_12547, 
(int)(((long)1))); 
BgL_ez00_12550 = 
PROCEDURE_REF(BgL_envz00_12547, 
(int)(((long)2))); 
{ /* Eval/evaluate_comp.scm 389 */
obj_t BgL_bpz00_14988;
BgL_bpz00_14988 = 
VECTOR_REF(
((obj_t)BgL_sz00_12551),((long)0)); 
if(
CBOOL(
CELL_REF(BgL_slotz00_12549)))
{ /* Eval/evaluate_comp.scm 390 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 390 */
{ /* Eval/evaluate_comp.scm 391 */
obj_t BgL_auxz00_14989;
BgL_auxz00_14989 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1093z00_12548))->BgL_modz00), 
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1093z00_12548))->BgL_namez00)); 
CELL_SET(BgL_slotz00_12549, BgL_auxz00_14989); } 
if(
CBOOL(
CELL_REF(BgL_slotz00_12549)))
{ /* Eval/evaluate_comp.scm 392 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 392 */
BGl_everrorz00zz__everrorz00(
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1093z00_12548))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5370z00zz__evaluate_compz00, 
(((BgL_ev_setglobalz00_bglt)COBJECT(BgL_i1093z00_12548))->BgL_namez00)); } } 
{ /* Eval/evaluate_comp.scm 393 */
obj_t BgL_arg2927z00_14990;
BgL_arg2927z00_14990 = 
PROCEDURE_ENTRY(BgL_ez00_12550)(BgL_ez00_12550, BgL_sz00_12551, BEOA); 
{ /* Eval/evaluate_comp.scm 393 */
obj_t BgL_evalzd2globalzd2_14991;
BgL_evalzd2globalzd2_14991 = 
CELL_REF(BgL_slotz00_12549); 
return 
VECTOR_SET(BgL_evalzd2globalzd2_14991,((long)2),BgL_arg2927z00_14990);} } } } } 

}



/* &comp-ev_global1394 */
obj_t BGl_z62compzd2ev_global1394zb0zz__evaluate_compz00(obj_t BgL_envz00_12553, obj_t BgL_varz00_12554, obj_t BgL_stkz00_12555)
{
{ /* Eval/evaluate_comp.scm 339 */
{ /* Eval/evaluate_comp.scm 341 */
obj_t BgL_gz00_14993;
BgL_gz00_14993 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_namez00)); 
if(
CBOOL(BgL_gz00_14993))
{ /* Eval/evaluate_comp.scm 343 */
bool_t BgL_test6039z00_29378;
{ /* Eval/evaluate_comp.scm 343 */
int BgL_arg2869z00_14994;
{ /* Eval/evaluate_comp.scm 343 */
int BgL_res4708z00_14995;
BgL_res4708z00_14995 = 
CINT(
VECTOR_REF(
((obj_t)BgL_gz00_14993),((long)0))); 
BgL_arg2869z00_14994 = BgL_res4708z00_14995; } 
BgL_test6039z00_29378 = 
(
BINT(BgL_arg2869z00_14994)==
BINT(((long)1))); } 
if(BgL_test6039z00_29378)
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_zc3z04anonymousza32866ze3z87_14996;
BgL_zc3z04anonymousza32866ze3z87_14996 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32866ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32866ze3z87_14996, 
(int)(((long)0)), BgL_gz00_14993); 
return BgL_zc3z04anonymousza32866ze3z87_14996;}  else 
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_zc3z04anonymousza32868ze3z87_14997;
BgL_zc3z04anonymousza32868ze3z87_14997 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32868ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32868ze3z87_14997, 
(int)(((long)0)), BgL_gz00_14993); 
return BgL_zc3z04anonymousza32868ze3z87_14997;} }  else 
{ /* Eval/evaluate_comp.scm 348 */
obj_t BgL_slotz00_14998;
BgL_slotz00_14998 = 
MAKE_CELL(BFALSE); 
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_gz00_14999;
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_arg2875z00_15000;obj_t BgL_arg2876z00_15001;obj_t BgL_arg2877z00_15002;
BgL_arg2875z00_15000 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_namez00); 
BgL_arg2876z00_15001 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_modz00); 
BgL_arg2877z00_15002 = 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_locz00); 
{ /* Eval/evaluate_comp.scm 350 */
obj_t BgL_v1372z00_15003;
BgL_v1372z00_15003 = 
create_vector(((long)5)); 
VECTOR_SET(BgL_v1372z00_15003,((long)0),
BINT(((long)2))); 
VECTOR_SET(BgL_v1372z00_15003,((long)1),BgL_arg2875z00_15000); 
VECTOR_SET(BgL_v1372z00_15003,((long)2),BUNSPEC); 
VECTOR_SET(BgL_v1372z00_15003,((long)3),BgL_arg2876z00_15001); 
VECTOR_SET(BgL_v1372z00_15003,((long)4),BgL_arg2877z00_15002); 
BgL_gz00_14999 = BgL_v1372z00_15003; } } 
VECTOR_SET(BgL_gz00_14999,((long)0),
BINT(((long)3))); 
BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_namez00), BgL_gz00_14999, 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_varz00_12554)))->BgL_locz00)); }  else 
{ /* Eval/evaluate_comp.scm 349 */BFALSE; } 
{ /* Eval/evaluate_comp.scm 353 */
obj_t BgL_zc3z04anonymousza32879ze3z87_15004;
BgL_zc3z04anonymousza32879ze3z87_15004 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32879ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32879ze3z87_15004, 
(int)(((long)0)), 
((obj_t)
((BgL_ev_globalz00_bglt)BgL_varz00_12554))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32879ze3z87_15004, 
(int)(((long)1)), 
((obj_t)BgL_slotz00_14998)); 
return BgL_zc3z04anonymousza32879ze3z87_15004;} } } } 

}



/* &<@anonymous:2866> */
obj_t BGl_z62zc3z04anonymousza32866ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12558, obj_t BgL_sz00_12560)
{
{ /* Eval/evaluate_comp.scm 344 */
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_gz00_12559;
BgL_gz00_12559 = 
PROCEDURE_REF(BgL_envz00_12558, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 344 */
obj_t BgL_bpz00_15005;
BgL_bpz00_15005 = 
VECTOR_REF(
((obj_t)BgL_sz00_12560),((long)0)); 
{ /* Eval/evaluate_comp.scm 345 */
obj_t BgL_arg2867z00_15006;
BgL_arg2867z00_15006 = 
VECTOR_REF(
((obj_t)BgL_gz00_12559),((long)2)); 
return 
__EVMEANING_ADDRESS_REF(BgL_arg2867z00_15006);} } } } 

}



/* &<@anonymous:2868> */
obj_t BGl_z62zc3z04anonymousza32868ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12561, obj_t BgL_sz00_12563)
{
{ /* Eval/evaluate_comp.scm 346 */
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_gz00_12562;
BgL_gz00_12562 = 
PROCEDURE_REF(BgL_envz00_12561, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 346 */
obj_t BgL_bpz00_15007;
BgL_bpz00_15007 = 
VECTOR_REF(
((obj_t)BgL_sz00_12563),((long)0)); 
return 
VECTOR_REF(
((obj_t)BgL_gz00_12562),((long)2));} } } 

}



/* &<@anonymous:2879> */
obj_t BGl_z62zc3z04anonymousza32879ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12564, obj_t BgL_sz00_12567)
{
{ /* Eval/evaluate_comp.scm 353 */
{ /* Eval/evaluate_comp.scm 353 */
BgL_ev_globalz00_bglt BgL_i1092z00_12565;obj_t BgL_slotz00_12566;
BgL_i1092z00_12565 = 
((BgL_ev_globalz00_bglt)
PROCEDURE_REF(BgL_envz00_12564, 
(int)(((long)0)))); 
BgL_slotz00_12566 = 
PROCEDURE_REF(BgL_envz00_12564, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 353 */
obj_t BgL_bpz00_15008;
BgL_bpz00_15008 = 
VECTOR_REF(
((obj_t)BgL_sz00_12567),((long)0)); 
if(
CBOOL(
CELL_REF(BgL_slotz00_12566)))
{ /* Eval/evaluate_comp.scm 354 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 354 */
{ /* Eval/evaluate_comp.scm 355 */
obj_t BgL_auxz00_15009;
BgL_auxz00_15009 = 
BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_modz00), 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_namez00)); 
CELL_SET(BgL_slotz00_12566, BgL_auxz00_15009); } 
if(
CBOOL(
CELL_REF(BgL_slotz00_12566)))
{ /* Eval/evaluate_comp.scm 356 */BFALSE; }  else 
{ /* Eval/evaluate_comp.scm 357 */
obj_t BgL_idz00_15010;
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 358 */
obj_t BgL_arg2885z00_15011;
{ /* Eval/evaluate_comp.scm 358 */
obj_t BgL_arg2886z00_15012;obj_t BgL_arg2887z00_15013;
BgL_arg2886z00_15012 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_namez00); 
BgL_arg2887z00_15013 = 
MAKE_YOUNG_PAIR(
BGl_evmodulezd2namezd2zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_modz00)), BNIL); 
BgL_arg2885z00_15011 = 
MAKE_YOUNG_PAIR(BgL_arg2886z00_15012, BgL_arg2887z00_15013); } 
BgL_idz00_15010 = 
MAKE_YOUNG_PAIR(BGl_symbol5371z00zz__evaluate_compz00, BgL_arg2885z00_15011); }  else 
{ /* Eval/evaluate_comp.scm 357 */
BgL_idz00_15010 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_namez00); } 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5370z00zz__evaluate_compz00, BgL_idz00_15010); } } 
{ /* Eval/evaluate_comp.scm 361 */
obj_t BgL_vz00_15014;
{ /* Eval/evaluate_comp.scm 361 */
obj_t BgL_evalzd2globalzd2_15015;
BgL_evalzd2globalzd2_15015 = 
CELL_REF(BgL_slotz00_12566); 
BgL_vz00_15014 = 
VECTOR_REF(BgL_evalzd2globalzd2_15015,((long)2)); } 
if(
(BgL_vz00_15014==BUNSPEC))
{ /* Eval/evaluate_comp.scm 363 */
int BgL_tz00_15016;
{ /* Eval/evaluate_comp.scm 363 */
int BgL_res4709z00_15017;
{ /* Eval/evaluate_comp.scm 363 */
obj_t BgL_evalzd2globalzd2_15018;
BgL_evalzd2globalzd2_15018 = 
CELL_REF(BgL_slotz00_12566); 
BgL_res4709z00_15017 = 
CINT(
VECTOR_REF(BgL_evalzd2globalzd2_15018,((long)0))); } 
BgL_tz00_15016 = BgL_res4709z00_15017; } 
{ /* Eval/evaluate_comp.scm 364 */
bool_t BgL_test6045z00_29475;
if(
(
(long)(BgL_tz00_15016)==((long)3)))
{ /* Eval/evaluate_comp.scm 364 */
BgL_test6045z00_29475 = ((bool_t)1)
; }  else 
{ /* Eval/evaluate_comp.scm 364 */
BgL_test6045z00_29475 = 
(
(long)(BgL_tz00_15016)==((long)4))
; } 
if(BgL_test6045z00_29475)
{ /* Eval/evaluate_comp.scm 365 */
obj_t BgL_idz00_15019;
if(
BGl_evmodulezf3zf3zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_modz00)))
{ /* Eval/evaluate_comp.scm 366 */
obj_t BgL_arg2897z00_15020;
{ /* Eval/evaluate_comp.scm 366 */
obj_t BgL_arg2898z00_15021;obj_t BgL_arg2899z00_15022;
BgL_arg2898z00_15021 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_namez00); 
BgL_arg2899z00_15022 = 
MAKE_YOUNG_PAIR(
BGl_evmodulezd2namezd2zz__evmodulez00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_modz00)), BNIL); 
BgL_arg2897z00_15020 = 
MAKE_YOUNG_PAIR(BgL_arg2898z00_15021, BgL_arg2899z00_15022); } 
BgL_idz00_15019 = 
MAKE_YOUNG_PAIR(BGl_symbol5371z00zz__evaluate_compz00, BgL_arg2897z00_15020); }  else 
{ /* Eval/evaluate_comp.scm 365 */
BgL_idz00_15019 = 
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_namez00); } 
return 
BGl_everrorz00zz__everrorz00(
(((BgL_ev_globalz00_bglt)COBJECT(BgL_i1092z00_12565))->BgL_locz00), BGl_string5246z00zz__evaluate_compz00, BGl_string5373z00zz__evaluate_compz00, BgL_idz00_15019);}  else 
{ /* Eval/evaluate_comp.scm 364 */
return BgL_vz00_15014;} } }  else 
{ /* Eval/evaluate_comp.scm 362 */
return BgL_vz00_15014;} } } } } 

}



/* &comp-ev_setlocal1392 */
obj_t BGl_z62compzd2ev_setlocal1392zb0zz__evaluate_compz00(obj_t BgL_envz00_12569, obj_t BgL_ez00_12570, obj_t BgL_stkz00_12571)
{
{ /* Eval/evaluate_comp.scm 321 */
{ /* Eval/evaluate_comp.scm 323 */
obj_t BgL_iz00_15024;obj_t BgL_ez00_15025;
{ /* Eval/evaluate_comp.scm 323 */
BgL_ev_varz00_bglt BgL_arg2862z00_15026;
BgL_arg2862z00_15026 = 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_12570)))->BgL_vz00); 
BgL_iz00_15024 = 
BGl__indexz00zz__evaluate_compz00(
((obj_t)BgL_arg2862z00_15026), BgL_stkz00_12571); } 
{ /* Eval/evaluate_comp.scm 323 */
BgL_ev_exprz00_bglt BgL_arg2863z00_15027;
BgL_arg2863z00_15027 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_ez00_12570))))->BgL_ez00); 
BgL_ez00_15025 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2863z00_15027, BgL_stkz00_12571); } 
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_ez00_12570)))->BgL_vz00)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_zc3z04anonymousza32855ze3z87_15028;
BgL_zc3z04anonymousza32855ze3z87_15028 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32855ze3z87_15028, 
(int)(((long)0)), BgL_iz00_15024); 
PROCEDURE_SET(BgL_zc3z04anonymousza32855ze3z87_15028, 
(int)(((long)1)), BgL_ez00_15025); 
return BgL_zc3z04anonymousza32855ze3z87_15028;}  else 
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_zc3z04anonymousza32859ze3z87_15029;
BgL_zc3z04anonymousza32859ze3z87_15029 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32859ze3z87_15029, 
(int)(((long)0)), BgL_iz00_15024); 
PROCEDURE_SET(BgL_zc3z04anonymousza32859ze3z87_15029, 
(int)(((long)1)), BgL_ez00_15025); 
return BgL_zc3z04anonymousza32859ze3z87_15029;} } } 

}



/* &<@anonymous:2855> */
obj_t BGl_z62zc3z04anonymousza32855ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12572, obj_t BgL_sz00_12575)
{
{ /* Eval/evaluate_comp.scm 326 */
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_iz00_12573;obj_t BgL_ez00_12574;
BgL_iz00_12573 = 
PROCEDURE_REF(BgL_envz00_12572, 
(int)(((long)0))); 
BgL_ez00_12574 = 
PROCEDURE_REF(BgL_envz00_12572, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 326 */
obj_t BgL_bpz00_15030;
BgL_bpz00_15030 = 
VECTOR_REF(
((obj_t)BgL_sz00_12575),((long)0)); 
{ /* Eval/evaluate_comp.scm 327 */
obj_t BgL_arg2856z00_15031;obj_t BgL_arg2857z00_15032;
{ /* Eval/evaluate_comp.scm 327 */
long BgL_arg2858z00_15033;
BgL_arg2858z00_15033 = 
(
(long)CINT(BgL_bpz00_15030)+
(long)CINT(BgL_iz00_12573)); 
BgL_arg2856z00_15031 = 
VECTOR_REF(
((obj_t)BgL_sz00_12575),BgL_arg2858z00_15033); } 
BgL_arg2857z00_15032 = 
PROCEDURE_ENTRY(BgL_ez00_12574)(BgL_ez00_12574, BgL_sz00_12575, BEOA); 
{ /* Eval/evaluate_comp.scm 202 */
obj_t BgL_xz00_15034;
{ /* Eval/evaluate_comp.scm 202 */
int BgL_auxz00_29537;obj_t BgL_tmpz00_29535;
BgL_auxz00_29537 = 
(int)(((long)0)); 
BgL_tmpz00_29535 = 
((obj_t)BgL_arg2856z00_15031); 
BgL_xz00_15034 = 
STRUCT_SET(BgL_tmpz00_29535, BgL_auxz00_29537, BgL_arg2857z00_15032); } 
return BUNSPEC;} } } } } 

}



/* &<@anonymous:2859> */
obj_t BGl_z62zc3z04anonymousza32859ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12576, obj_t BgL_sz00_12579)
{
{ /* Eval/evaluate_comp.scm 328 */
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_iz00_12577;obj_t BgL_ez00_12578;
BgL_iz00_12577 = 
PROCEDURE_REF(BgL_envz00_12576, 
(int)(((long)0))); 
BgL_ez00_12578 = 
PROCEDURE_REF(BgL_envz00_12576, 
(int)(((long)1))); 
{ /* Eval/evaluate_comp.scm 328 */
obj_t BgL_bpz00_15035;
BgL_bpz00_15035 = 
VECTOR_REF(
((obj_t)BgL_sz00_12579),((long)0)); 
{ /* Eval/evaluate_comp.scm 329 */
long BgL_arg2860z00_15036;obj_t BgL_arg2861z00_15037;
BgL_arg2860z00_15036 = 
(
(long)CINT(BgL_bpz00_15035)+
(long)CINT(BgL_iz00_12577)); 
BgL_arg2861z00_15037 = 
PROCEDURE_ENTRY(BgL_ez00_12578)(BgL_ez00_12578, BgL_sz00_12579, BEOA); 
return 
VECTOR_SET(
((obj_t)BgL_sz00_12579),BgL_arg2860z00_15036,BgL_arg2861z00_15037);} } } } 

}



/* &comp-ev_var1390 */
obj_t BGl_z62compzd2ev_var1390zb0zz__evaluate_compz00(obj_t BgL_envz00_12580, obj_t BgL_varz00_12581, obj_t BgL_stkz00_12582)
{
{ /* Eval/evaluate_comp.scm 316 */
{ /* Eval/evaluate_comp.scm 317 */
obj_t BgL_iz00_15039;
BgL_iz00_15039 = 
BGl__indexz00zz__evaluate_compz00(
((obj_t)
((BgL_ev_varz00_bglt)BgL_varz00_12581)), BgL_stkz00_12582); 
{ 

if(
INTEGERP(BgL_iz00_15039))
{ /* Eval/evaluate_comp.scm 319 */
switch( 
(long)CINT(BgL_iz00_15039)) { case ((long)0) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12581)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5374z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5375z00zz__evaluate_compz00;} break;case ((long)1) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12581)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5376z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5377z00zz__evaluate_compz00;} break;case ((long)2) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12581)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5378z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5379z00zz__evaluate_compz00;} break;case ((long)3) : 

if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12581)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5380z00zz__evaluate_compz00;}  else 
{ /* Eval/evaluate_comp.scm 319 */
return BGl_proc5381z00zz__evaluate_compz00;} break;
default: 
BgL_case_else1087z00_15040:
if(
CBOOL(
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_varz00_12581)))->BgL_effz00)))
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_zc3z04anonymousza32849ze3z87_15041;
BgL_zc3z04anonymousza32849ze3z87_15041 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32849ze3z87_15041, 
(int)(((long)0)), BgL_iz00_15039); 
return BgL_zc3z04anonymousza32849ze3z87_15041;}  else 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_zc3z04anonymousza32852ze3z87_15042;
BgL_zc3z04anonymousza32852ze3z87_15042 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32852ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32852ze3z87_15042, 
(int)(((long)0)), BgL_iz00_15039); 
return BgL_zc3z04anonymousza32852ze3z87_15042;} } }  else 
{ /* Eval/evaluate_comp.scm 319 */
goto BgL_case_else1087z00_15040;} } } } 

}



/* &<@anonymous:2843> */
obj_t BGl_z62zc3z04anonymousza32843ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12583, obj_t BgL_sz00_12584)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15043;
BgL_bpz00_15043 = 
VECTOR_REF(
((obj_t)BgL_sz00_12584),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2844z00_15044;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2845z00_15045;
BgL_arg2845z00_15045 = 
(
(long)CINT(BgL_bpz00_15043)+((long)3)); 
BgL_arg2844z00_15044 = 
VECTOR_REF(
((obj_t)BgL_sz00_12584),BgL_arg2845z00_15045); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2844z00_15044), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2846> */
obj_t BGl_z62zc3z04anonymousza32846ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12585, obj_t BgL_sz00_12586)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15046;
BgL_bpz00_15046 = 
VECTOR_REF(
((obj_t)BgL_sz00_12586),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2847z00_15047;
BgL_arg2847z00_15047 = 
(
(long)CINT(BgL_bpz00_15046)+((long)3)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12586),BgL_arg2847z00_15047);} } } 

}



/* &<@anonymous:2837> */
obj_t BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12587, obj_t BgL_sz00_12588)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15048;
BgL_bpz00_15048 = 
VECTOR_REF(
((obj_t)BgL_sz00_12588),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2838z00_15049;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2839z00_15050;
BgL_arg2839z00_15050 = 
(
(long)CINT(BgL_bpz00_15048)+((long)2)); 
BgL_arg2838z00_15049 = 
VECTOR_REF(
((obj_t)BgL_sz00_12588),BgL_arg2839z00_15050); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2838z00_15049), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2840> */
obj_t BGl_z62zc3z04anonymousza32840ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12589, obj_t BgL_sz00_12590)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15051;
BgL_bpz00_15051 = 
VECTOR_REF(
((obj_t)BgL_sz00_12590),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2841z00_15052;
BgL_arg2841z00_15052 = 
(
(long)CINT(BgL_bpz00_15051)+((long)2)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12590),BgL_arg2841z00_15052);} } } 

}



/* &<@anonymous:2831> */
obj_t BGl_z62zc3z04anonymousza32831ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12591, obj_t BgL_sz00_12592)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15053;
BgL_bpz00_15053 = 
VECTOR_REF(
((obj_t)BgL_sz00_12592),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2832z00_15054;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2833z00_15055;
BgL_arg2833z00_15055 = 
(
(long)CINT(BgL_bpz00_15053)+((long)1)); 
BgL_arg2832z00_15054 = 
VECTOR_REF(
((obj_t)BgL_sz00_12592),BgL_arg2833z00_15055); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2832z00_15054), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2834> */
obj_t BGl_z62zc3z04anonymousza32834ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12593, obj_t BgL_sz00_12594)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15056;
BgL_bpz00_15056 = 
VECTOR_REF(
((obj_t)BgL_sz00_12594),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2835z00_15057;
BgL_arg2835z00_15057 = 
(
(long)CINT(BgL_bpz00_15056)+((long)1)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12594),BgL_arg2835z00_15057);} } } 

}



/* &<@anonymous:2825> */
obj_t BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12595, obj_t BgL_sz00_12596)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15058;
BgL_bpz00_15058 = 
VECTOR_REF(
((obj_t)BgL_sz00_12596),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2826z00_15059;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2827z00_15060;
BgL_arg2827z00_15060 = 
(
(long)CINT(BgL_bpz00_15058)+((long)0)); 
BgL_arg2826z00_15059 = 
VECTOR_REF(
((obj_t)BgL_sz00_12596),BgL_arg2827z00_15060); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2826z00_15059), 
(int)(((long)0)));} } } 

}



/* &<@anonymous:2828> */
obj_t BGl_z62zc3z04anonymousza32828ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12597, obj_t BgL_sz00_12598)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15061;
BgL_bpz00_15061 = 
VECTOR_REF(
((obj_t)BgL_sz00_12598),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2829z00_15062;
BgL_arg2829z00_15062 = 
(
(long)CINT(BgL_bpz00_15061)+((long)0)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12598),BgL_arg2829z00_15062);} } } 

}



/* &<@anonymous:2849> */
obj_t BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12599, obj_t BgL_sz00_12601)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_iz00_12600;
BgL_iz00_12600 = 
PROCEDURE_REF(BgL_envz00_12599, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15063;
BgL_bpz00_15063 = 
VECTOR_REF(
((obj_t)BgL_sz00_12601),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_arg2850z00_15064;
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2851z00_15065;
BgL_arg2851z00_15065 = 
(
(long)CINT(BgL_bpz00_15063)+
(long)CINT(BgL_iz00_12600)); 
BgL_arg2850z00_15064 = 
VECTOR_REF(
((obj_t)BgL_sz00_12601),BgL_arg2851z00_15065); } 
return 
STRUCT_REF(
((obj_t)BgL_arg2850z00_15064), 
(int)(((long)0)));} } } } 

}



/* &<@anonymous:2852> */
obj_t BGl_z62zc3z04anonymousza32852ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12602, obj_t BgL_sz00_12604)
{
{ /* Eval/evaluate_comp.scm 319 */
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_iz00_12603;
BgL_iz00_12603 = 
PROCEDURE_REF(BgL_envz00_12602, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 319 */
obj_t BgL_bpz00_15066;
BgL_bpz00_15066 = 
VECTOR_REF(
((obj_t)BgL_sz00_12604),((long)0)); 
{ /* Eval/evaluate_comp.scm 319 */
long BgL_arg2853z00_15067;
BgL_arg2853z00_15067 = 
(
(long)CINT(BgL_bpz00_15066)+
(long)CINT(BgL_iz00_12603)); 
return 
VECTOR_REF(
((obj_t)BgL_sz00_12604),BgL_arg2853z00_15067);} } } } 

}



/* &comp-ev_trap1388 */
obj_t BGl_z62compzd2ev_trap1388zb0zz__evaluate_compz00(obj_t BgL_envz00_12605, obj_t BgL_ez00_12606, obj_t BgL_stkz00_12607)
{
{ /* Eval/evaluate_comp.scm 289 */
{ /* Eval/evaluate_comp.scm 291 */
obj_t BgL_ez00_15069;
{ /* Eval/evaluate_comp.scm 291 */
BgL_ev_exprz00_bglt BgL_arg2822z00_15070;
BgL_arg2822z00_15070 = 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_ez00_12606))))->BgL_ez00); 
BgL_ez00_15069 = 
BGl_compz00zz__evaluate_compz00(BgL_arg2822z00_15070, BgL_stkz00_12607); } 
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_zc3z04anonymousza32816ze3z87_15071;
BgL_zc3z04anonymousza32816ze3z87_15071 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza32816ze3ze5zz__evaluate_compz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza32816ze3z87_15071, 
(int)(((long)0)), BgL_ez00_15069); 
return BgL_zc3z04anonymousza32816ze3z87_15071;} } } 

}



/* &<@anonymous:2816> */
obj_t BGl_z62zc3z04anonymousza32816ze3ze5zz__evaluate_compz00(obj_t BgL_envz00_12608, obj_t BgL_sz00_12610)
{
{ /* Eval/evaluate_comp.scm 292 */
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_ez00_12609;
BgL_ez00_12609 = 
PROCEDURE_REF(BgL_envz00_12608, 
(int)(((long)0))); 
{ /* Eval/evaluate_comp.scm 292 */
obj_t BgL_bpz00_15072;
BgL_bpz00_15072 = 
VECTOR_REF(
((obj_t)BgL_sz00_12610),((long)0)); 
{ /* Eval/evaluate_comp.scm 293 */
obj_t BgL_cmdz00_15073;
BgL_cmdz00_15073 = 
PROCEDURE_ENTRY(BgL_ez00_12609)(BgL_ez00_12609, BgL_sz00_12610, BEOA); 
if(
(BgL_cmdz00_15073==BGl_symbol5382z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return BgL_bpz00_15072;}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15073==BGl_symbol5384z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_reset_profilez00zz__evaluate_compz00();}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15073==BGl_symbol5386z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_get_profilez00zz__evaluate_compz00();}  else 
{ /* Eval/evaluate_comp.scm 294 */
if(
(BgL_cmdz00_15073==BGl_symbol5388z00zz__evaluate_compz00))
{ /* Eval/evaluate_comp.scm 302 */
obj_t BgL_arg2821z00_15074;
BgL_arg2821z00_15074 = 
BGl_findzd2statezd2zz__evaluate_compz00(); 
return 
VECTOR_SET(
((obj_t)BgL_arg2821z00_15074),((long)0),
BINT(((long)2)));}  else 
{ /* Eval/evaluate_comp.scm 294 */
return 
BGl_errorz00zz__errorz00(BGl_string5246z00zz__evaluate_compz00, BGl_string5390z00zz__evaluate_compz00, BgL_cmdz00_15073);} } } } } } } } 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
{
{ /* Eval/evaluate_comp.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046386), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)37115357), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)70989162), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135277364), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218115), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267996), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519875), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251315035), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936798), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439352636), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453938973), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)193422032), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967910), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__srfi4z00(((long)467925662), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68572481), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)420334581), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057945), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155874), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198621048), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309694), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519474), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460263341), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-44274296), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614573), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927845), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151379), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)190906089), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540733), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988972), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__ppz00(((long)233942106), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)220647683), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__prognz00(((long)177147628), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__expandz00(((long)414007030), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evenvz00(((long)528345319), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evcompilez00(((long)492753248), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__everrorz00(((long)375872251), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evmodulez00(((long)505900559), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long)0), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long)193509655), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00)); 
return 
BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)20669922), 
BSTRING_TO_STRING(BGl_string5391z00zz__evaluate_compz00));} 

}

#ifdef __cplusplus
}
#endif
