/*===========================================================================*/
/*   (Eval/evaluate_types.scm)                                               */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon 09 Nov 2020 08:06:47 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4a/bin/bigloo -srfi enable-resolv -srfi enable-unistring -srfi enable-pcre -srfi enable-gmp -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -rm -copt -w -lib-dir /builddir/build/BUILD/bigloo-4.4a/lib/bigloo/4.4a -O4 -mklib -unsafe -safee -cc gcc -fsharing -q -no-hello -p -srfi bigloo-profile -c Eval/evaluate_types.scm -o objs/obj_p/Eval/evaluate_types.o) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif

/* object type definitions */
typedef struct BgL_ev_exprz00_bgl {
   header_t header;
   obj_t widening;
} *BgL_ev_exprz00_bglt;

typedef struct BgL_ev_varz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_effz00;
   obj_t BgL_typez00;
} *BgL_ev_varz00_bglt;

typedef struct BgL_ev_globalz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_globalz00_bglt;

typedef struct BgL_ev_littz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_valuez00;
} *BgL_ev_littz00_bglt;

typedef struct BgL_ev_ifz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_pz00;
   struct BgL_ev_exprz00_bgl * BgL_tz00;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_ifz00_bglt;

typedef struct BgL_ev_listz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_listz00_bglt;

typedef struct BgL_ev_orz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_orz00_bglt;

typedef struct BgL_ev_andz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_argsz00;
} *BgL_ev_andz00_bglt;

typedef struct BgL_ev_prog2z00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_e1z00;
   struct BgL_ev_exprz00_bgl * BgL_e2z00;
} *BgL_ev_prog2z00_bglt;

typedef struct BgL_ev_hookz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_hookz00_bglt;

typedef struct BgL_ev_trapz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
} *BgL_ev_trapz00_bglt;

typedef struct BgL_ev_setlocalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_varz00_bgl * BgL_vz00;
} *BgL_ev_setlocalz00_bglt;

typedef struct BgL_ev_setglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_setglobalz00_bglt;

typedef struct BgL_ev_defglobalz00_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   obj_t BgL_locz00;
   obj_t BgL_namez00;
   obj_t BgL_modz00;
} *BgL_ev_defglobalz00_bglt;

typedef struct BgL_ev_bindzd2exitzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_varz00_bgl * BgL_varz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_bindzd2exitzd2_bglt;

typedef struct BgL_ev_unwindzd2protectzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_ez00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_unwindzd2protectzd2_bglt;

typedef struct BgL_ev_withzd2handlerzd2_bgl {
   header_t header;
   obj_t widening;
   struct BgL_ev_exprz00_bgl * BgL_handlerz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_withzd2handlerzd2_bglt;

typedef struct BgL_ev_synchroniza7eza7_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_mutexz00;
   struct BgL_ev_exprz00_bgl * BgL_prelockz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_synchroniza7eza7_bglt;

typedef struct BgL_ev_binderz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_binderz00_bglt;

typedef struct BgL_ev_letz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letz00_bglt;

typedef struct BgL_ev_letza2za2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_letza2za2_bglt;

typedef struct BgL_ev_letrecz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
} *BgL_ev_letrecz00_bglt;

typedef struct BgL_ev_labelsz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_varsz00;
   obj_t BgL_valsz00;
   obj_t BgL_envz00;
   obj_t BgL_stkz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   obj_t BgL_boxesz00;
} *BgL_ev_labelsz00_bglt;

typedef struct BgL_ev_gotoz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_varz00_bgl * BgL_labelz00;
   struct BgL_ev_labelsz00_bgl * BgL_labelsz00;
   obj_t BgL_argsz00;
} *BgL_ev_gotoz00_bglt;

typedef struct BgL_ev_appz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   struct BgL_ev_exprz00_bgl * BgL_funz00;
   obj_t BgL_argsz00;
   obj_t BgL_tailzf3zf3;
} *BgL_ev_appz00_bglt;

typedef struct BgL_ev_absz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_locz00;
   obj_t BgL_wherez00;
   obj_t BgL_arityz00;
   obj_t BgL_varsz00;
   struct BgL_ev_exprz00_bgl * BgL_bodyz00;
   int BgL_siza7eza7;
   obj_t BgL_bindz00;
   obj_t BgL_freez00;
   obj_t BgL_innerz00;
   obj_t BgL_boxesz00;
} *BgL_ev_absz00_bglt;


static BgL_ev_exprz00_bglt BGl_z62lambda1761z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_appz00_bglt BGl_z62lambda1923z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1762z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_appz00_bglt BGl_z62lambda1925z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1766z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1767z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2721z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2561z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2565z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2729z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32010ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1931z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1932z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1771z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1937z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_binderz00_bglt BGl_z62lambda1778z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol2731z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2572z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2578z00zz__evaluate_typesz00 = BUNSPEC;
extern obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
static obj_t BGl_z62lambda1941z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_binderz00_bglt BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1942z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1947z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1787z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2582z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2589z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1791z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_absz00_bglt BGl_z62lambda1953z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1792z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_absz00_bglt BGl_z62lambda1955z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1796z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1797z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2593z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2597z00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_letrecz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1961z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1962z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1966z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1967z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1971z62zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_letz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1972z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1976z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1981z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1982z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1987z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31689ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62lambda1994z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1995z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31957ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31868ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_typesz00(obj_t);
extern obj_t bstring_to_symbol(obj_t);
static obj_t BGl_z62zc3z04anonymousza31887ze3ze5zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_labelsz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_methodzd2initzd2zz__evaluate_typesz00();
BGL_EXPORTED_DEF obj_t BGl_ev_absz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_ifz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31450ze3ze5zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_gotoz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_orz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31632ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31438ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_varz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1422z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1424z62zz__evaluate_typesz00(obj_t);
extern obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00();
static BgL_ev_varz00_bglt BGl_z62lambda1434z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1436z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_andz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_hookz00_bglt BGl_z62lambda1601z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1442z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1443z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1609z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1448z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1449z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2405z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2407z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1610z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1456z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_trapz00_bglt BGl_z62lambda1618z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1457z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31814ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2411z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2413z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2418z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_trapz00_bglt BGl_z62lambda1620z62zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_appz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_globalz00_bglt BGl_z62lambda1465z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31831ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31580ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_setlocalz00_bglt BGl_z62lambda1628z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_globalz00_bglt BGl_z62lambda1467z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2420z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2424z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2429z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_setlocalz00_bglt BGl_z62lambda1630z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1473z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1474z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1636z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1637z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1479z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2433z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2439z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_letz00_bglt BGl_z62lambda1803z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1480z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_setglobalz00_bglt BGl_z62lambda1643z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_letz00_bglt BGl_z62lambda1805z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_profzd2initzd2zz__evaluate_typesz00();
static BgL_ev_setglobalz00_bglt BGl_z62lambda1645z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1484z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1485z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2604z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2444z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2609z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2448z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1813z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1653z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1654z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_littz00_bglt BGl_z62lambda1493z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_littz00_bglt BGl_z62lambda1495z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1658z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1659z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2614z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2453z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2457z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_letza2za2_bglt BGl_z62lambda1820z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_letza2za2_bglt BGl_z62lambda1822z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1664z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1665z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31851ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1829z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2622z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2461z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2627z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2465z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_defglobalz00_bglt BGl_z62lambda1672z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_letrecz00_bglt BGl_z62lambda1837z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_defglobalz00_bglt BGl_z62lambda1676z62zz__evaluate_typesz00(obj_t);
static BgL_ev_letrecz00_bglt BGl_z62lambda1839z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31569ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2470z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2636z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2474z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2479z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1685z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_labelsz00_bglt BGl_z62lambda1847z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1687z62zz__evaluate_typesz00(obj_t);
static BgL_ev_labelsz00_bglt BGl_z62lambda1849z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31497ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2641z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2484z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2489z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1855z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1694z62zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_defglobalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1856z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1695z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31927ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2651z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2493z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2657z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2497z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1860z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1861z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31782ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1866z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1867z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2661z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2668z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1873z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1874z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31678ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1879z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2674z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1880z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1885z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1886z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_symbol2680z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2685z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00();
static BgL_ev_gotoz00_bglt BGl_z62lambda1893z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static BgL_ev_gotoz00_bglt BGl_z62lambda1895z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_symbol2691z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2695z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_genericzd2initzd2zz__evaluate_typesz00();
static obj_t BGl_z62zc3z04anonymousza31875ze3ze5zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_prog2z00zz__evaluate_typesz00 = BUNSPEC;
extern obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t, bool_t, bool_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_letza2za2zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_trapz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31897ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_setglobalz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda2001z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2002z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda2008z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2009z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31989ze3ze5zz__evaluate_typesz00(obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_hookz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda2015z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda2016z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31514ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31604ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31426ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31622ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
BGL_EXPORTED_DEF obj_t BGl_ev_globalz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_binderz00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_listz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62zc3z04anonymousza31712ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_littz00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1502z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1503z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00();
static BgL_ev_ifz00_bglt BGl_z62lambda1510z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t);
static BgL_ev_ifz00_bglt BGl_z62lambda1512z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00();
static BgL_ev_exprz00_bglt BGl_z62lambda1518z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1519z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1523z62zz__evaluate_typesz00(obj_t, obj_t);
extern obj_t BGl_objectz00zz__objectz00;
static obj_t BGl_z62lambda1524z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1528z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31732ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1529z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_listz00_bglt BGl_z62lambda1535z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_listz00_bglt BGl_z62lambda1537z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31539ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1701z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1702z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1543z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1544z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
BGL_EXPORTED_DEF obj_t BGl_ev_exprz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1708z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31807ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2502z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2509z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1710z62zz__evaluate_typesz00(obj_t);
static BgL_ev_orz00_bglt BGl_z62lambda1553z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1716z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_orz00_bglt BGl_z62lambda1555z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1717z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31824ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31557ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2514z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2518z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_exprz00_bglt BGl_z62lambda1721z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1722z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_andz00_bglt BGl_z62lambda1565z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31841ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1728z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_andz00_bglt BGl_z62lambda1567z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31469ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2523z00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1730z62zz__evaluate_typesz00(obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1736z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_prog2z00_bglt BGl_z62lambda1575z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1737z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_prog2z00_bglt BGl_z62lambda1577z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62zc3z04anonymousza31648ze3ze5zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2534z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2539z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_z62lambda1901z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1902z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1741z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1742z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_varz00_bglt BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1907z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1585z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1586z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1748z62zz__evaluate_typesz00(obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_symbol2704z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2543z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2706z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2547z00zz__evaluate_typesz00 = BUNSPEC;
BGL_EXPORTED_DEF obj_t BGl_ev_setlocalz00zz__evaluate_typesz00 = BUNSPEC;
static BgL_ev_labelsz00_bglt BGl_z62lambda1911z62zz__evaluate_typesz00(obj_t, obj_t);
static BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t);
static obj_t BGl_z62lambda1912z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_exprz00_bglt BGl_z62lambda1591z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1592z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1916z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1917z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static obj_t BGl_z62lambda1756z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_z62lambda1757z62zz__evaluate_typesz00(obj_t, obj_t, obj_t);
static BgL_ev_hookz00_bglt BGl_z62lambda1599z62zz__evaluate_typesz00(obj_t, obj_t);
static obj_t BGl_symbol2711z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2552z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t BGl_symbol2716z00zz__evaluate_typesz00 = BUNSPEC;
static obj_t *__cnst;


DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2402z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2733za7, BGl_z62zc3z04anonymousza31426ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2403z00zz__evaluate_typesz00, BgL_bgl_za762lambda1424za7622734z00, BGl_z62lambda1424z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2404z00zz__evaluate_typesz00, BgL_bgl_za762lambda1422za7622735z00, BGl_z62lambda1422z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2409z00zz__evaluate_typesz00, BgL_bgl_za762lambda1443za7622736z00, BGl_z62lambda1443z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2410z00zz__evaluate_typesz00, BgL_bgl_za762lambda1442za7622737z00, BGl_z62lambda1442z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2415z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2738za7, BGl_z62zc3z04anonymousza31450ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2416z00zz__evaluate_typesz00, BgL_bgl_za762lambda1449za7622739z00, BGl_z62lambda1449z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2417z00zz__evaluate_typesz00, BgL_bgl_za762lambda1448za7622740z00, BGl_z62lambda1448z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2503z00zz__evaluate_typesz00, BgL_bgl_string2503za700za7za7_2741za7, "ev_prog2", 8 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2422z00zz__evaluate_typesz00, BgL_bgl_za762lambda1457za7622742z00, BGl_z62lambda1457z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2423z00zz__evaluate_typesz00, BgL_bgl_za762lambda1456za7622743z00, BGl_z62lambda1456z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2510z00zz__evaluate_typesz00, BgL_bgl_string2510za700za7za7_2744za7, "ev_hook", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2426z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2745za7, BGl_z62zc3z04anonymousza31438ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2427z00zz__evaluate_typesz00, BgL_bgl_za762lambda1436za7622746z00, BGl_z62lambda1436z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2428z00zz__evaluate_typesz00, BgL_bgl_za762lambda1434za7622747z00, BGl_z62lambda1434z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2515z00zz__evaluate_typesz00, BgL_bgl_string2515za700za7za7_2748za7, "ev_trap", 7 );
DEFINE_STRING( BGl_string2519z00zz__evaluate_typesz00, BgL_bgl_string2519za700za7za7_2749za7, "v", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2431z00zz__evaluate_typesz00, BgL_bgl_za762lambda1474za7622750z00, BGl_z62lambda1474z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2432z00zz__evaluate_typesz00, BgL_bgl_za762lambda1473za7622751z00, BGl_z62lambda1473z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2435z00zz__evaluate_typesz00, BgL_bgl_za762lambda1480za7622752z00, BGl_z62lambda1480z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2436z00zz__evaluate_typesz00, BgL_bgl_za762lambda1479za7622753z00, BGl_z62lambda1479z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2437z00zz__evaluate_typesz00, BgL_bgl_za762lambda1485za7622754z00, BGl_z62lambda1485z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2438z00zz__evaluate_typesz00, BgL_bgl_za762lambda1484za7622755z00, BGl_z62lambda1484z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2524z00zz__evaluate_typesz00, BgL_bgl_string2524za700za7za7_2756za7, "ev_setlocal", 11 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2600z00zz__evaluate_typesz00, BgL_bgl_za762lambda1796za7622757z00, BGl_z62lambda1796z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2601z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2758za7, BGl_z62zc3z04anonymousza31782ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2602z00zz__evaluate_typesz00, BgL_bgl_za762lambda1780za7622759z00, BGl_z62lambda1780z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2603z00zz__evaluate_typesz00, BgL_bgl_za762lambda1778za7622760z00, BGl_z62lambda1778z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2441z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2761za7, BGl_z62zc3z04anonymousza31469ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2442z00zz__evaluate_typesz00, BgL_bgl_za762lambda1467za7622762z00, BGl_z62lambda1467z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2443z00zz__evaluate_typesz00, BgL_bgl_za762lambda1465za7622763z00, BGl_z62lambda1465z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2606z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2764za7, BGl_z62zc3z04anonymousza31814ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2607z00zz__evaluate_typesz00, BgL_bgl_za762lambda1813za7622765z00, BGl_z62lambda1813z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2608z00zz__evaluate_typesz00, BgL_bgl_za762lambda1812za7622766z00, BGl_z62lambda1812z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2446z00zz__evaluate_typesz00, BgL_bgl_za762lambda1503za7622767z00, BGl_z62lambda1503z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2447z00zz__evaluate_typesz00, BgL_bgl_za762lambda1502za7622768z00, BGl_z62lambda1502z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2535z00zz__evaluate_typesz00, BgL_bgl_string2535za700za7za7_2769za7, "ev_setglobal", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2611z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2770za7, BGl_z62zc3z04anonymousza31807ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2612z00zz__evaluate_typesz00, BgL_bgl_za762lambda1805za7622771z00, BGl_z62lambda1805z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2450z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2772za7, BGl_z62zc3z04anonymousza31497ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2613z00zz__evaluate_typesz00, BgL_bgl_za762lambda1803za7622773z00, BGl_z62lambda1803z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2451z00zz__evaluate_typesz00, BgL_bgl_za762lambda1495za7622774z00, BGl_z62lambda1495z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2452z00zz__evaluate_typesz00, BgL_bgl_za762lambda1493za7622775z00, BGl_z62lambda1493z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2616z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2776za7, BGl_z62zc3z04anonymousza31831ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2617z00zz__evaluate_typesz00, BgL_bgl_za762lambda1830za7622777z00, BGl_z62lambda1830z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2540z00zz__evaluate_typesz00, BgL_bgl_string2540za700za7za7_2778za7, "ev_defglobal", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2455z00zz__evaluate_typesz00, BgL_bgl_za762lambda1519za7622779z00, BGl_z62lambda1519z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2618z00zz__evaluate_typesz00, BgL_bgl_za762lambda1829za7622780z00, BGl_z62lambda1829z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2456z00zz__evaluate_typesz00, BgL_bgl_za762lambda1518za7622781z00, BGl_z62lambda1518z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2619z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2782za7, BGl_z62zc3z04anonymousza31824ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2705z00zz__evaluate_typesz00, BgL_bgl_string2705za700za7za7_2783za7, "size", 4 );
DEFINE_STRING( BGl_string2544z00zz__evaluate_typesz00, BgL_bgl_string2544za700za7za7_2784za7, "var", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2459z00zz__evaluate_typesz00, BgL_bgl_za762lambda1524za7622785z00, BGl_z62lambda1524z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2707z00zz__evaluate_typesz00, BgL_bgl_string2707za700za7za7_2786za7, "int", 3 );
DEFINE_STRING( BGl_string2548z00zz__evaluate_typesz00, BgL_bgl_string2548za700za7za7_2787za7, "body", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2620z00zz__evaluate_typesz00, BgL_bgl_za762lambda1822za7622788z00, BGl_z62lambda1822z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2621z00zz__evaluate_typesz00, BgL_bgl_za762lambda1820za7622789z00, BGl_z62lambda1820z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2460z00zz__evaluate_typesz00, BgL_bgl_za762lambda1523za7622790z00, BGl_z62lambda1523z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2624z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2791za7, BGl_z62zc3z04anonymousza31841ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2625z00zz__evaluate_typesz00, BgL_bgl_za762lambda1839za7622792z00, BGl_z62lambda1839z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2463z00zz__evaluate_typesz00, BgL_bgl_za762lambda1529za7622793z00, BGl_z62lambda1529z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2626z00zz__evaluate_typesz00, BgL_bgl_za762lambda1837za7622794z00, BGl_z62lambda1837z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2464z00zz__evaluate_typesz00, BgL_bgl_za762lambda1528za7622795z00, BGl_z62lambda1528z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2712z00zz__evaluate_typesz00, BgL_bgl_string2712za700za7za7_2796za7, "bind", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2629z00zz__evaluate_typesz00, BgL_bgl_za762lambda1856za7622797z00, BGl_z62lambda1856z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2467z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2798za7, BGl_z62zc3z04anonymousza31514ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2553z00zz__evaluate_typesz00, BgL_bgl_string2553za700za7za7_2799za7, "ev_bind-exit", 12 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2468z00zz__evaluate_typesz00, BgL_bgl_za762lambda1512za7622800z00, BGl_z62lambda1512z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2469z00zz__evaluate_typesz00, BgL_bgl_za762lambda1510za7622801z00, BGl_z62lambda1510z62zz__evaluate_typesz00, 0L, BUNSPEC, 3 );
DEFINE_STRING( BGl_string2717z00zz__evaluate_typesz00, BgL_bgl_string2717za700za7za7_2802za7, "free", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2630z00zz__evaluate_typesz00, BgL_bgl_za762lambda1855za7622803z00, BGl_z62lambda1855z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2631z00zz__evaluate_typesz00, BgL_bgl_za762lambda1861za7622804z00, BGl_z62lambda1861z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2632z00zz__evaluate_typesz00, BgL_bgl_za762lambda1860za7622805z00, BGl_z62lambda1860z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2633z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2806za7, BGl_z62zc3z04anonymousza31868ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2634z00zz__evaluate_typesz00, BgL_bgl_za762lambda1867za7622807z00, BGl_z62lambda1867z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2472z00zz__evaluate_typesz00, BgL_bgl_za762lambda1544za7622808z00, BGl_z62lambda1544z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2635z00zz__evaluate_typesz00, BgL_bgl_za762lambda1866za7622809z00, BGl_z62lambda1866z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2473z00zz__evaluate_typesz00, BgL_bgl_za762lambda1543za7622810z00, BGl_z62lambda1543z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2722z00zz__evaluate_typesz00, BgL_bgl_string2722za700za7za7_2811za7, "inner", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2638z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2812za7, BGl_z62zc3z04anonymousza31875ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2476z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2813za7, BGl_z62zc3z04anonymousza31539ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2639z00zz__evaluate_typesz00, BgL_bgl_za762lambda1874za7622814z00, BGl_z62lambda1874z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2562z00zz__evaluate_typesz00, BgL_bgl_string2562za700za7za7_2815za7, "ev_unwind-protect", 17 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2477z00zz__evaluate_typesz00, BgL_bgl_za762lambda1537za7622816z00, BGl_z62lambda1537z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2478z00zz__evaluate_typesz00, BgL_bgl_za762lambda1535za7622817z00, BGl_z62lambda1535z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2566z00zz__evaluate_typesz00, BgL_bgl_string2566za700za7za7_2818za7, "handler", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2640z00zz__evaluate_typesz00, BgL_bgl_za762lambda1873za7622819z00, BGl_z62lambda1873z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2643z00zz__evaluate_typesz00, BgL_bgl_za762lambda1880za7622820z00, BGl_z62lambda1880z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2481z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2821za7, BGl_z62zc3z04anonymousza31557ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2644z00zz__evaluate_typesz00, BgL_bgl_za762lambda1879za7622822z00, BGl_z62lambda1879z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2482z00zz__evaluate_typesz00, BgL_bgl_za762lambda1555za7622823z00, BGl_z62lambda1555z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2730z00zz__evaluate_typesz00, BgL_bgl_string2730za700za7za7_2824za7, "ev_abs", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2645z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2825za7, BGl_z62zc3z04anonymousza31887ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2483z00zz__evaluate_typesz00, BgL_bgl_za762lambda1553za7622826z00, BGl_z62lambda1553z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2646z00zz__evaluate_typesz00, BgL_bgl_za762lambda1886za7622827z00, BGl_z62lambda1886z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2732z00zz__evaluate_typesz00, BgL_bgl_string2732za700za7za7_2828za7, "_", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2647z00zz__evaluate_typesz00, BgL_bgl_za762lambda1885za7622829z00, BGl_z62lambda1885z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2648z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2830za7, BGl_z62zc3z04anonymousza31851ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2486z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2831za7, BGl_z62zc3z04anonymousza31569ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2649z00zz__evaluate_typesz00, BgL_bgl_za762lambda1849za7622832z00, BGl_z62lambda1849z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2487z00zz__evaluate_typesz00, BgL_bgl_za762lambda1567za7622833z00, BGl_z62lambda1567z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2573z00zz__evaluate_typesz00, BgL_bgl_string2573za700za7za7_2834za7, "ev_with-handler", 15 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2488z00zz__evaluate_typesz00, BgL_bgl_za762lambda1565za7622835z00, BGl_z62lambda1565z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2579z00zz__evaluate_typesz00, BgL_bgl_string2579za700za7za7_2836za7, "mutex", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2650z00zz__evaluate_typesz00, BgL_bgl_za762lambda1847za7622837z00, BGl_z62lambda1847z62zz__evaluate_typesz00, 0L, BUNSPEC, 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2653z00zz__evaluate_typesz00, BgL_bgl_za762lambda1902za7622838z00, BGl_z62lambda1902z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2491z00zz__evaluate_typesz00, BgL_bgl_za762lambda1586za7622839z00, BGl_z62lambda1586z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2654z00zz__evaluate_typesz00, BgL_bgl_za762lambda1901za7622840z00, BGl_z62lambda1901z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2492z00zz__evaluate_typesz00, BgL_bgl_za762lambda1585za7622841z00, BGl_z62lambda1585z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2655z00zz__evaluate_typesz00, BgL_bgl_za762lambda1907za7622842z00, BGl_z62lambda1907z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2656z00zz__evaluate_typesz00, BgL_bgl_za762lambda1906za7622843z00, BGl_z62lambda1906z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2495z00zz__evaluate_typesz00, BgL_bgl_za762lambda1592za7622844z00, BGl_z62lambda1592z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2496z00zz__evaluate_typesz00, BgL_bgl_za762lambda1591za7622845z00, BGl_z62lambda1591z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2659z00zz__evaluate_typesz00, BgL_bgl_za762lambda1912za7622846z00, BGl_z62lambda1912z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2583z00zz__evaluate_typesz00, BgL_bgl_string2583za700za7za7_2847za7, "prelock", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2499z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2848za7, BGl_z62zc3z04anonymousza31580ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2660z00zz__evaluate_typesz00, BgL_bgl_za762lambda1911za7622849z00, BGl_z62lambda1911z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2663z00zz__evaluate_typesz00, BgL_bgl_za762lambda1917za7622850z00, BGl_z62lambda1917z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2664z00zz__evaluate_typesz00, BgL_bgl_za762lambda1916za7622851z00, BGl_z62lambda1916z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2665z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2852za7, BGl_z62zc3z04anonymousza31897ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2666z00zz__evaluate_typesz00, BgL_bgl_za762lambda1895za7622853z00, BGl_z62lambda1895z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2667z00zz__evaluate_typesz00, BgL_bgl_za762lambda1893za7622854z00, BGl_z62lambda1893z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2590z00zz__evaluate_typesz00, BgL_bgl_string2590za700za7za7_2855za7, "ev_synchronize", 14 );
DEFINE_STRING( BGl_string2594z00zz__evaluate_typesz00, BgL_bgl_string2594za700za7za7_2856za7, "vars", 4 );
DEFINE_STRING( BGl_string2598z00zz__evaluate_typesz00, BgL_bgl_string2598za700za7za7_2857za7, "vals", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2670z00zz__evaluate_typesz00, BgL_bgl_za762lambda1932za7622858z00, BGl_z62lambda1932z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2671z00zz__evaluate_typesz00, BgL_bgl_za762lambda1931za7622859z00, BGl_z62lambda1931z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2672z00zz__evaluate_typesz00, BgL_bgl_za762lambda1937za7622860z00, BGl_z62lambda1937z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2673z00zz__evaluate_typesz00, BgL_bgl_za762lambda1936za7622861z00, BGl_z62lambda1936z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2676z00zz__evaluate_typesz00, BgL_bgl_za762lambda1942za7622862z00, BGl_z62lambda1942z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2677z00zz__evaluate_typesz00, BgL_bgl_za762lambda1941za7622863z00, BGl_z62lambda1941z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2678z00zz__evaluate_typesz00, BgL_bgl_za762lambda1947za7622864z00, BGl_z62lambda1947z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2679z00zz__evaluate_typesz00, BgL_bgl_za762lambda1946za7622865z00, BGl_z62lambda1946z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2682z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2866za7, BGl_z62zc3z04anonymousza31927ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2683z00zz__evaluate_typesz00, BgL_bgl_za762lambda1925za7622867z00, BGl_z62lambda1925z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2684z00zz__evaluate_typesz00, BgL_bgl_za762lambda1923za7622868z00, BGl_z62lambda1923z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2687z00zz__evaluate_typesz00, BgL_bgl_za762lambda1962za7622869z00, BGl_z62lambda1962z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2688z00zz__evaluate_typesz00, BgL_bgl_za762lambda1961za7622870z00, BGl_z62lambda1961z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2689z00zz__evaluate_typesz00, BgL_bgl_za762lambda1967za7622871z00, BGl_z62lambda1967z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2690z00zz__evaluate_typesz00, BgL_bgl_za762lambda1966za7622872z00, BGl_z62lambda1966z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2693z00zz__evaluate_typesz00, BgL_bgl_za762lambda1972za7622873z00, BGl_z62lambda1972z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2694z00zz__evaluate_typesz00, BgL_bgl_za762lambda1971za7622874z00, BGl_z62lambda1971z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2697z00zz__evaluate_typesz00, BgL_bgl_za762lambda1977za7622875z00, BGl_z62lambda1977z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2698z00zz__evaluate_typesz00, BgL_bgl_za762lambda1976za7622876z00, BGl_z62lambda1976z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2699z00zz__evaluate_typesz00, BgL_bgl_za762lambda1982za7622877z00, BGl_z62lambda1982z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2406z00zz__evaluate_typesz00, BgL_bgl_string2406za700za7za7_2878za7, "ev_expr", 7 );
DEFINE_STRING( BGl_string2408z00zz__evaluate_typesz00, BgL_bgl_string2408za700za7za7_2879za7, "__evaluate_types", 16 );
DEFINE_STRING( BGl_string2412z00zz__evaluate_typesz00, BgL_bgl_string2412za700za7za7_2880za7, "name", 4 );
DEFINE_STRING( BGl_string2414z00zz__evaluate_typesz00, BgL_bgl_string2414za700za7za7_2881za7, "symbol", 6 );
DEFINE_STRING( BGl_string2419z00zz__evaluate_typesz00, BgL_bgl_string2419za700za7za7_2882za7, "eff", 3 );
DEFINE_STRING( BGl_string2421z00zz__evaluate_typesz00, BgL_bgl_string2421za700za7za7_2883za7, "obj", 3 );
DEFINE_STRING( BGl_string2425z00zz__evaluate_typesz00, BgL_bgl_string2425za700za7za7_2884za7, "type", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2500z00zz__evaluate_typesz00, BgL_bgl_za762lambda1577za7622885z00, BGl_z62lambda1577z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2501z00zz__evaluate_typesz00, BgL_bgl_za762lambda1575za7622886z00, BGl_z62lambda1575z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2504z00zz__evaluate_typesz00, BgL_bgl_za762lambda1610za7622887z00, BGl_z62lambda1610z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2505z00zz__evaluate_typesz00, BgL_bgl_za762lambda1609za7622888z00, BGl_z62lambda1609z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2506z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2889za7, BGl_z62zc3z04anonymousza31604ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2507z00zz__evaluate_typesz00, BgL_bgl_za762lambda1601za7622890z00, BGl_z62lambda1601z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2430z00zz__evaluate_typesz00, BgL_bgl_string2430za700za7za7_2891za7, "ev_var", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2508z00zz__evaluate_typesz00, BgL_bgl_za762lambda1599za7622892z00, BGl_z62lambda1599z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2434z00zz__evaluate_typesz00, BgL_bgl_string2434za700za7za7_2893za7, "loc", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2511z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2894za7, BGl_z62zc3z04anonymousza31622ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2512z00zz__evaluate_typesz00, BgL_bgl_za762lambda1620za7622895z00, BGl_z62lambda1620z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2513z00zz__evaluate_typesz00, BgL_bgl_za762lambda1618za7622896z00, BGl_z62lambda1618z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2516z00zz__evaluate_typesz00, BgL_bgl_za762lambda1637za7622897z00, BGl_z62lambda1637z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2517z00zz__evaluate_typesz00, BgL_bgl_za762lambda1636za7622898z00, BGl_z62lambda1636z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2440z00zz__evaluate_typesz00, BgL_bgl_string2440za700za7za7_2899za7, "mod", 3 );
DEFINE_STRING( BGl_string2605z00zz__evaluate_typesz00, BgL_bgl_string2605za700za7za7_2900za7, "ev_binder", 9 );
DEFINE_STRING( BGl_string2445z00zz__evaluate_typesz00, BgL_bgl_string2445za700za7za7_2901za7, "ev_global", 9 );
DEFINE_STRING( BGl_string2449z00zz__evaluate_typesz00, BgL_bgl_string2449za700za7za7_2902za7, "value", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2520z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2903za7, BGl_z62zc3z04anonymousza31632ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2521z00zz__evaluate_typesz00, BgL_bgl_za762lambda1630za7622904z00, BGl_z62lambda1630z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2522z00zz__evaluate_typesz00, BgL_bgl_za762lambda1628za7622905z00, BGl_z62lambda1628z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2610z00zz__evaluate_typesz00, BgL_bgl_string2610za700za7za7_2906za7, "boxes", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2525z00zz__evaluate_typesz00, BgL_bgl_za762lambda1654za7622907z00, BGl_z62lambda1654z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2526z00zz__evaluate_typesz00, BgL_bgl_za762lambda1653za7622908z00, BGl_z62lambda1653z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2527z00zz__evaluate_typesz00, BgL_bgl_za762lambda1659za7622909z00, BGl_z62lambda1659z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2528z00zz__evaluate_typesz00, BgL_bgl_za762lambda1658za7622910z00, BGl_z62lambda1658z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2529z00zz__evaluate_typesz00, BgL_bgl_za762lambda1665za7622911z00, BGl_z62lambda1665z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2615z00zz__evaluate_typesz00, BgL_bgl_string2615za700za7za7_2912za7, "ev_let", 6 );
DEFINE_STRING( BGl_string2454z00zz__evaluate_typesz00, BgL_bgl_string2454za700za7za7_2913za7, "ev_litt", 7 );
DEFINE_STRING( BGl_string2458z00zz__evaluate_typesz00, BgL_bgl_string2458za700za7za7_2914za7, "p", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2530z00zz__evaluate_typesz00, BgL_bgl_za762lambda1664za7622915z00, BGl_z62lambda1664z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2531z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2916za7, BGl_z62zc3z04anonymousza31648ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2532z00zz__evaluate_typesz00, BgL_bgl_za762lambda1645za7622917z00, BGl_z62lambda1645z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2533z00zz__evaluate_typesz00, BgL_bgl_za762lambda1643za7622918z00, BGl_z62lambda1643z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2536z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2919za7, BGl_z62zc3z04anonymousza31678ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2537z00zz__evaluate_typesz00, BgL_bgl_za762lambda1676za7622920z00, BGl_z62lambda1676z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2623z00zz__evaluate_typesz00, BgL_bgl_string2623za700za7za7_2921za7, "ev_let*", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2538z00zz__evaluate_typesz00, BgL_bgl_za762lambda1672za7622922z00, BGl_z62lambda1672z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2462z00zz__evaluate_typesz00, BgL_bgl_string2462za700za7za7_2923za7, "t", 1 );
DEFINE_STRING( BGl_string2628z00zz__evaluate_typesz00, BgL_bgl_string2628za700za7za7_2924za7, "ev_letrec", 9 );
DEFINE_STRING( BGl_string2466z00zz__evaluate_typesz00, BgL_bgl_string2466za700za7za7_2925za7, "e", 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2700z00zz__evaluate_typesz00, BgL_bgl_za762lambda1981za7622926z00, BGl_z62lambda1981z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2701z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2927za7, BGl_z62zc3z04anonymousza31989ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2702z00zz__evaluate_typesz00, BgL_bgl_za762lambda1988za7622928z00, BGl_z62lambda1988z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2703z00zz__evaluate_typesz00, BgL_bgl_za762lambda1987za7622929z00, BGl_z62lambda1987z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2541z00zz__evaluate_typesz00, BgL_bgl_za762lambda1695za7622930z00, BGl_z62lambda1695z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2542z00zz__evaluate_typesz00, BgL_bgl_za762lambda1694za7622931z00, BGl_z62lambda1694z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2545z00zz__evaluate_typesz00, BgL_bgl_za762lambda1702za7622932z00, BGl_z62lambda1702z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2708z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2933za7, BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2546z00zz__evaluate_typesz00, BgL_bgl_za762lambda1701za7622934z00, BGl_z62lambda1701z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2709z00zz__evaluate_typesz00, BgL_bgl_za762lambda1995za7622935z00, BGl_z62lambda1995z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2471z00zz__evaluate_typesz00, BgL_bgl_string2471za700za7za7_2936za7, "ev_if", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2549z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2937za7, BGl_z62zc3z04anonymousza31689ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2637z00zz__evaluate_typesz00, BgL_bgl_string2637za700za7za7_2938za7, "env", 3 );
DEFINE_STRING( BGl_string2475z00zz__evaluate_typesz00, BgL_bgl_string2475za700za7za7_2939za7, "args", 4 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2710z00zz__evaluate_typesz00, BgL_bgl_za762lambda1994za7622940z00, BGl_z62lambda1994z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2550z00zz__evaluate_typesz00, BgL_bgl_za762lambda1687za7622941z00, BGl_z62lambda1687z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2713z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2942za7, BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2551z00zz__evaluate_typesz00, BgL_bgl_za762lambda1685za7622943z00, BGl_z62lambda1685z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2714z00zz__evaluate_typesz00, BgL_bgl_za762lambda2002za7622944z00, BGl_z62lambda2002z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2715z00zz__evaluate_typesz00, BgL_bgl_za762lambda2001za7622945z00, BGl_z62lambda2001z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2554z00zz__evaluate_typesz00, BgL_bgl_za762lambda1717za7622946z00, BGl_z62lambda1717z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2555z00zz__evaluate_typesz00, BgL_bgl_za762lambda1716za7622947z00, BGl_z62lambda1716z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2718z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2948za7, BGl_z62zc3z04anonymousza32010ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2556z00zz__evaluate_typesz00, BgL_bgl_za762lambda1722za7622949z00, BGl_z62lambda1722z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2719z00zz__evaluate_typesz00, BgL_bgl_za762lambda2009za7622950z00, BGl_z62lambda2009z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2642z00zz__evaluate_typesz00, BgL_bgl_string2642za700za7za7_2951za7, "stk", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2557z00zz__evaluate_typesz00, BgL_bgl_za762lambda1721za7622952z00, BGl_z62lambda1721z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2480z00zz__evaluate_typesz00, BgL_bgl_string2480za700za7za7_2953za7, "ev_list", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2558z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2954za7, BGl_z62zc3z04anonymousza31712ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2559z00zz__evaluate_typesz00, BgL_bgl_za762lambda1710za7622955z00, BGl_z62lambda1710z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STRING( BGl_string2485z00zz__evaluate_typesz00, BgL_bgl_string2485za700za7za7_2956za7, "ev_or", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2720z00zz__evaluate_typesz00, BgL_bgl_za762lambda2008za7622957z00, BGl_z62lambda2008z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2560z00zz__evaluate_typesz00, BgL_bgl_za762lambda1708za7622958z00, BGl_z62lambda1708z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2723z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2959za7, BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2724z00zz__evaluate_typesz00, BgL_bgl_za762lambda2016za7622960z00, BGl_z62lambda2016z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2725z00zz__evaluate_typesz00, BgL_bgl_za762lambda2015za7622961z00, BGl_z62lambda2015z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2563z00zz__evaluate_typesz00, BgL_bgl_za762lambda1737za7622962z00, BGl_z62lambda1737z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2726z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2963za7, BGl_z62zc3z04anonymousza31957ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2564z00zz__evaluate_typesz00, BgL_bgl_za762lambda1736za7622964z00, BGl_z62lambda1736z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2727z00zz__evaluate_typesz00, BgL_bgl_za762lambda1955za7622965z00, BGl_z62lambda1955z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2728z00zz__evaluate_typesz00, BgL_bgl_za762lambda1953za7622966z00, BGl_z62lambda1953z62zz__evaluate_typesz00, 0L, BUNSPEC, 10 );
DEFINE_STRING( BGl_string2652z00zz__evaluate_typesz00, BgL_bgl_string2652za700za7za7_2967za7, "ev_labels", 9 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2567z00zz__evaluate_typesz00, BgL_bgl_za762lambda1742za7622968z00, BGl_z62lambda1742z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2490z00zz__evaluate_typesz00, BgL_bgl_string2490za700za7za7_2969za7, "ev_and", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2568z00zz__evaluate_typesz00, BgL_bgl_za762lambda1741za7622970z00, BGl_z62lambda1741z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2569z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2971za7, BGl_z62zc3z04anonymousza31732ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2494z00zz__evaluate_typesz00, BgL_bgl_string2494za700za7za7_2972za7, "e1", 2 );
DEFINE_STRING( BGl_string2658z00zz__evaluate_typesz00, BgL_bgl_string2658za700za7za7_2973za7, "label", 5 );
DEFINE_STRING( BGl_string2498z00zz__evaluate_typesz00, BgL_bgl_string2498za700za7za7_2974za7, "e2", 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2570z00zz__evaluate_typesz00, BgL_bgl_za762lambda1730za7622975z00, BGl_z62lambda1730z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2571z00zz__evaluate_typesz00, BgL_bgl_za762lambda1728za7622976z00, BGl_z62lambda1728z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2574z00zz__evaluate_typesz00, BgL_bgl_za762lambda1757za7622977z00, BGl_z62lambda1757z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2575z00zz__evaluate_typesz00, BgL_bgl_za762lambda1756za7622978z00, BGl_z62lambda1756z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2576z00zz__evaluate_typesz00, BgL_bgl_za762lambda1762za7622979z00, BGl_z62lambda1762z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2662z00zz__evaluate_typesz00, BgL_bgl_string2662za700za7za7_2980za7, "labels", 6 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2577z00zz__evaluate_typesz00, BgL_bgl_za762lambda1761za7622981z00, BGl_z62lambda1761z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string2669z00zz__evaluate_typesz00, BgL_bgl_string2669za700za7za7_2982za7, "ev_goto", 7 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2580z00zz__evaluate_typesz00, BgL_bgl_za762lambda1767za7622983z00, BGl_z62lambda1767z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2581z00zz__evaluate_typesz00, BgL_bgl_za762lambda1766za7622984z00, BGl_z62lambda1766z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2584z00zz__evaluate_typesz00, BgL_bgl_za762lambda1772za7622985z00, BGl_z62lambda1772z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2585z00zz__evaluate_typesz00, BgL_bgl_za762lambda1771za7622986z00, BGl_z62lambda1771z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2586z00zz__evaluate_typesz00, BgL_bgl_za762za7c3za704anonymo2987za7, BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2587z00zz__evaluate_typesz00, BgL_bgl_za762lambda1750za7622988z00, BGl_z62lambda1750z62zz__evaluate_typesz00, 0L, BUNSPEC, 0 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2588z00zz__evaluate_typesz00, BgL_bgl_za762lambda1748za7622989z00, BGl_z62lambda1748z62zz__evaluate_typesz00, 0L, BUNSPEC, 4 );
DEFINE_STRING( BGl_string2675z00zz__evaluate_typesz00, BgL_bgl_string2675za700za7za7_2990za7, "fun", 3 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2591z00zz__evaluate_typesz00, BgL_bgl_za762lambda1787za7622991z00, BGl_z62lambda1787z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2592z00zz__evaluate_typesz00, BgL_bgl_za762lambda1786za7622992z00, BGl_z62lambda1786z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2595z00zz__evaluate_typesz00, BgL_bgl_za762lambda1792za7622993z00, BGl_z62lambda1792z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2681z00zz__evaluate_typesz00, BgL_bgl_string2681za700za7za7_2994za7, "tail?", 5 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2596z00zz__evaluate_typesz00, BgL_bgl_za762lambda1791za7622995z00, BGl_z62lambda1791z62zz__evaluate_typesz00, 0L, BUNSPEC, 1 );
DEFINE_STATIC_BGL_PROCEDURE( BGl_proc2599z00zz__evaluate_typesz00, BgL_bgl_za762lambda1797za7622996z00, BGl_z62lambda1797z62zz__evaluate_typesz00, 0L, BUNSPEC, 2 );
DEFINE_STRING( BGl_string2686z00zz__evaluate_typesz00, BgL_bgl_string2686za700za7za7_2997za7, "ev_app", 6 );
DEFINE_STRING( BGl_string2692z00zz__evaluate_typesz00, BgL_bgl_string2692za700za7za7_2998za7, "where", 5 );
DEFINE_STRING( BGl_string2696z00zz__evaluate_typesz00, BgL_bgl_string2696za700za7za7_2999za7, "arity", 5 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_symbol2721z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2561z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2565z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2729z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2731z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2572z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2578z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2582z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2589z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2593z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2597z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letrecz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_labelsz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_absz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_ifz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_gotoz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_orz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_varz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_andz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2405z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2407z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2411z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2413z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2418z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_appz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2420z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2424z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2429z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2433z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2439z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_synchroniza7eza7zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2604z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2444z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2609z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2448z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2614z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2453z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2457z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2622z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2461z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2627z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2465z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2470z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2636z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2474z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2479z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2641z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2484z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2489z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_defglobalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2651z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2493z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2657z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2497z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2661z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2668z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2674z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2680z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2685z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2691z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2695z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_prog2z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_bindzd2exitzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_letza2za2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_trapz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_setglobalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_hookz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_globalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_binderz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_listz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_littz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_withzd2handlerzd2zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_exprz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2502z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2509z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2514z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2518z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2523z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2534z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2539z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2704z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2543z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2706z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2547z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_ev_setlocalz00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2711z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2552z00zz__evaluate_typesz00) );
ADD_ROOT( (void *)(&BGl_symbol2716z00zz__evaluate_typesz00) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* prof association table */
static obj_t write_bprof_table() {
   extern obj_t bprof_port;
   if( bprof_port == BUNSPEC ) bprof_port = (obj_t)fopen( "bmon.out", "w" );
   if( bprof_port ) {
      fputs( "(\"module-initialization\" \"BGl_modulezd2initializa7ationz75zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"toplevel-init\" \"Eval/evaluate_types.scm\" 963) \"BGl_toplevelzd2initzd2zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1957>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31957ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2017>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2010>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza32010ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:2003>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1996>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1989>\" \"Eval/evaluate_types.scm\" 3347) \"BGl_z62zc3z04anonymousza31989ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1927>\" \"Eval/evaluate_types.scm\" 3265) \"BGl_z62zc3z04anonymousza31927ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1897>\" \"Eval/evaluate_types.scm\" 3154) \"BGl_z62zc3z04anonymousza31897ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1851>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31851ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1887>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31887ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1875>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31875ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1868>\" \"Eval/evaluate_types.scm\" 2941) \"BGl_z62zc3z04anonymousza31868ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1841>\" \"Eval/evaluate_types.scm\" 2908) \"BGl_z62zc3z04anonymousza31841ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1824>\" \"Eval/evaluate_types.scm\" 2848) \"BGl_z62zc3z04anonymousza31824ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1831>\" \"Eval/evaluate_types.scm\" 2848) \"BGl_z62zc3z04anonymousza31831ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1807>\" \"Eval/evaluate_types.scm\" 2789) \"BGl_z62zc3z04anonymousza31807ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1814>\" \"Eval/evaluate_types.scm\" 2789) \"BGl_z62zc3z04anonymousza31814ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1782>\" \"Eval/evaluate_types.scm\" 2713) \"BGl_z62zc3z04anonymousza31782ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1752>\" \"Eval/evaluate_types.scm\" 2587) \"BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1732>\" \"Eval/evaluate_types.scm\" 2505) \"BGl_z62zc3z04anonymousza31732ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1712>\" \"Eval/evaluate_types.scm\" 2427) \"BGl_z62zc3z04anonymousza31712ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1689>\" \"Eval/evaluate_types.scm\" 2353) \"BGl_z62zc3z04anonymousza31689ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1678>\" \"Eval/evaluate_types.scm\" 2314) \"BGl_z62zc3z04anonymousza31678ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1648>\" \"Eval/evaluate_types.scm\" 2226) \"BGl_z62zc3z04anonymousza31648ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1632>\" \"Eval/evaluate_types.scm\" 2176) \"BGl_z62zc3z04anonymousza31632ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1622>\" \"Eval/evaluate_types.scm\" 2147) \"BGl_z62zc3z04anonymousza31622ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1604>\" \"Eval/evaluate_types.scm\" 2100) \"BGl_z62zc3z04anonymousza31604ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1580>\" \"Eval/evaluate_types.scm\" 2032) \"BGl_z62zc3z04anonymousza31580ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1569>\" \"Eval/evaluate_types.scm\" 2004) \"BGl_z62zc3z04anonymousza31569ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1557>\" \"Eval/evaluate_types.scm\" 1977) \"BGl_z62zc3z04anonymousza31557ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1539>\" \"Eval/evaluate_types.scm\" 1936) \"BGl_z62zc3z04anonymousza31539ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1514>\" \"Eval/evaluate_types.scm\" 1855) \"BGl_z62zc3z04anonymousza31514ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1497>\" \"Eval/evaluate_types.scm\" 1813) \"BGl_z62zc3z04anonymousza31497ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1469>\" \"Eval/evaluate_types.scm\" 1723) \"BGl_z62zc3z04anonymousza31469ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1438>\" \"Eval/evaluate_types.scm\" 1637) \"BGl_z62zc3z04anonymousza31438ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1450>\" \"Eval/evaluate_types.scm\" 1637) \"BGl_z62zc3z04anonymousza31450ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "((\"&<@anonymous:1426>\" \"Eval/evaluate_types.scm\" 1612) \"BGl_z62zc3z04anonymousza31426ze3ze5zz__evaluate_typesz00\")\n", (FILE *)bprof_port );
      fputs( "(\"CONS\" \"make_pair\")\n", (FILE *)bprof_port );
      fputs( "(\"%STRING->SYMBOL\" \"make_symbol\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-STRING\" \"string_to_bstring_len\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-OUTPUT-PORT\" \"bgl_make_output_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-INPUT-PORT\" \"bgl_make_input_port\")\n", (FILE *)bprof_port );
      fputs( "(\"%MAKE-ERROR-PORT\" \"make_error_port\")\n", (FILE *)bprof_port );
   }
   return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long BgL_checksumz00_4303, char * BgL_fromz00_4304)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_typesz00))
{ 
BGl_requirezd2initializa7ationz75zz__evaluate_typesz00 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__evaluate_typesz00(); 
BGl_cnstzd2initzd2zz__evaluate_typesz00(); 
BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00(); 
BGl_objectzd2initzd2zz__evaluate_typesz00(); 
return 
BGl_profzd2initzd2zz__evaluate_typesz00();}  else 
{ 
return BUNSPEC;} } 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
BGl_symbol2405z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2406z00zz__evaluate_typesz00); 
BGl_symbol2407z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2408z00zz__evaluate_typesz00); 
BGl_symbol2411z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2412z00zz__evaluate_typesz00); 
BGl_symbol2413z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2414z00zz__evaluate_typesz00); 
BGl_symbol2418z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2419z00zz__evaluate_typesz00); 
BGl_symbol2420z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2421z00zz__evaluate_typesz00); 
BGl_symbol2424z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2425z00zz__evaluate_typesz00); 
BGl_symbol2429z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2430z00zz__evaluate_typesz00); 
BGl_symbol2433z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2434z00zz__evaluate_typesz00); 
BGl_symbol2439z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2440z00zz__evaluate_typesz00); 
BGl_symbol2444z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2445z00zz__evaluate_typesz00); 
BGl_symbol2448z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2449z00zz__evaluate_typesz00); 
BGl_symbol2453z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2454z00zz__evaluate_typesz00); 
BGl_symbol2457z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2458z00zz__evaluate_typesz00); 
BGl_symbol2461z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2462z00zz__evaluate_typesz00); 
BGl_symbol2465z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2466z00zz__evaluate_typesz00); 
BGl_symbol2470z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2471z00zz__evaluate_typesz00); 
BGl_symbol2474z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2475z00zz__evaluate_typesz00); 
BGl_symbol2479z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2480z00zz__evaluate_typesz00); 
BGl_symbol2484z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2485z00zz__evaluate_typesz00); 
BGl_symbol2489z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2490z00zz__evaluate_typesz00); 
BGl_symbol2493z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2494z00zz__evaluate_typesz00); 
BGl_symbol2497z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2498z00zz__evaluate_typesz00); 
BGl_symbol2502z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2503z00zz__evaluate_typesz00); 
BGl_symbol2509z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2510z00zz__evaluate_typesz00); 
BGl_symbol2514z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2515z00zz__evaluate_typesz00); 
BGl_symbol2518z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2519z00zz__evaluate_typesz00); 
BGl_symbol2523z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2524z00zz__evaluate_typesz00); 
BGl_symbol2534z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2535z00zz__evaluate_typesz00); 
BGl_symbol2539z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2540z00zz__evaluate_typesz00); 
BGl_symbol2543z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2544z00zz__evaluate_typesz00); 
BGl_symbol2547z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2548z00zz__evaluate_typesz00); 
BGl_symbol2552z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2553z00zz__evaluate_typesz00); 
BGl_symbol2561z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2562z00zz__evaluate_typesz00); 
BGl_symbol2565z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2566z00zz__evaluate_typesz00); 
BGl_symbol2572z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2573z00zz__evaluate_typesz00); 
BGl_symbol2578z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2579z00zz__evaluate_typesz00); 
BGl_symbol2582z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2583z00zz__evaluate_typesz00); 
BGl_symbol2589z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2590z00zz__evaluate_typesz00); 
BGl_symbol2593z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2594z00zz__evaluate_typesz00); 
BGl_symbol2597z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2598z00zz__evaluate_typesz00); 
BGl_symbol2604z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2605z00zz__evaluate_typesz00); 
BGl_symbol2609z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2610z00zz__evaluate_typesz00); 
BGl_symbol2614z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2615z00zz__evaluate_typesz00); 
BGl_symbol2622z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2623z00zz__evaluate_typesz00); 
BGl_symbol2627z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2628z00zz__evaluate_typesz00); 
BGl_symbol2636z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2637z00zz__evaluate_typesz00); 
BGl_symbol2641z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2642z00zz__evaluate_typesz00); 
BGl_symbol2651z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2652z00zz__evaluate_typesz00); 
BGl_symbol2657z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2658z00zz__evaluate_typesz00); 
BGl_symbol2661z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2662z00zz__evaluate_typesz00); 
BGl_symbol2668z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2669z00zz__evaluate_typesz00); 
BGl_symbol2674z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2675z00zz__evaluate_typesz00); 
BGl_symbol2680z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2681z00zz__evaluate_typesz00); 
BGl_symbol2685z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2686z00zz__evaluate_typesz00); 
BGl_symbol2691z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2692z00zz__evaluate_typesz00); 
BGl_symbol2695z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2696z00zz__evaluate_typesz00); 
BGl_symbol2704z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2705z00zz__evaluate_typesz00); 
BGl_symbol2706z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2707z00zz__evaluate_typesz00); 
BGl_symbol2711z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2712z00zz__evaluate_typesz00); 
BGl_symbol2716z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2717z00zz__evaluate_typesz00); 
BGl_symbol2721z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2722z00zz__evaluate_typesz00); 
BGl_symbol2729z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2730z00zz__evaluate_typesz00); 
return ( 
BGl_symbol2731z00zz__evaluate_typesz00 = 
bstring_to_symbol(BGl_string2732z00zz__evaluate_typesz00), BUNSPEC) ;} 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return 
bgl_gc_roots_register();} 

}



/* prof-init */
obj_t BGl_profzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return 
write_bprof_table();} 

}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_arg1420z00_1060;obj_t BgL_arg1421z00_1061;
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_v1283z00_1071;
BgL_v1283z00_1071 = 
create_vector(((long)0)); 
BgL_arg1420z00_1060 = BgL_v1283z00_1071; } 
{ /* Eval/evaluate_types.scm 49 */
obj_t BgL_v1284z00_1072;
BgL_v1284z00_1072 = 
create_vector(((long)0)); 
BgL_arg1421z00_1061 = BgL_v1284z00_1072; } 
BGl_ev_exprz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2405z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_objectz00zz__objectz00, ((long)36622), BGl_proc2404z00zz__evaluate_typesz00, BGl_proc2403z00zz__evaluate_typesz00, BFALSE, BGl_proc2402z00zz__evaluate_typesz00, BFALSE, BgL_arg1420z00_1060, BgL_arg1421z00_1061); } 
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_arg1432z00_1079;obj_t BgL_arg1433z00_1080;
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_v1285z00_1093;
BgL_v1285z00_1093 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1285z00_1093,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2411z00zz__evaluate_typesz00, BGl_proc2410z00zz__evaluate_typesz00, BGl_proc2409z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2413z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1285z00_1093,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2418z00zz__evaluate_typesz00, BGl_proc2417z00zz__evaluate_typesz00, BGl_proc2416z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2415z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1285z00_1093,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2424z00zz__evaluate_typesz00, BGl_proc2423z00zz__evaluate_typesz00, BGl_proc2422z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1432z00_1079 = BgL_v1285z00_1093; } 
{ /* Eval/evaluate_types.scm 51 */
obj_t BgL_v1286z00_1127;
BgL_v1286z00_1127 = 
create_vector(((long)0)); 
BgL_arg1433z00_1080 = BgL_v1286z00_1127; } 
BGl_ev_varz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2429z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)7207), BGl_proc2428z00zz__evaluate_typesz00, BGl_proc2427z00zz__evaluate_typesz00, BFALSE, BGl_proc2426z00zz__evaluate_typesz00, BFALSE, BgL_arg1432z00_1079, BgL_arg1433z00_1080); } 
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_arg1463z00_1134;obj_t BgL_arg1464z00_1135;
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_v1287z00_1148;
BgL_v1287z00_1148 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1287z00_1148,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2433z00zz__evaluate_typesz00, BGl_proc2432z00zz__evaluate_typesz00, BGl_proc2431z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1287z00_1148,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2411z00zz__evaluate_typesz00, BGl_proc2436z00zz__evaluate_typesz00, BGl_proc2435z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2413z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1287z00_1148,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2439z00zz__evaluate_typesz00, BGl_proc2438z00zz__evaluate_typesz00, BGl_proc2437z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1463z00_1134 = BgL_v1287z00_1148; } 
{ /* Eval/evaluate_types.scm 55 */
obj_t BgL_v1288z00_1179;
BgL_v1288z00_1179 = 
create_vector(((long)0)); 
BgL_arg1464z00_1135 = BgL_v1288z00_1179; } 
BGl_ev_globalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2444z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)59391), BGl_proc2443z00zz__evaluate_typesz00, BGl_proc2442z00zz__evaluate_typesz00, BFALSE, BGl_proc2441z00zz__evaluate_typesz00, BFALSE, BgL_arg1463z00_1134, BgL_arg1464z00_1135); } 
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_arg1491z00_1186;obj_t BgL_arg1492z00_1187;
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_v1289z00_1198;
BgL_v1289z00_1198 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1289z00_1198,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2448z00zz__evaluate_typesz00, BGl_proc2447z00zz__evaluate_typesz00, BGl_proc2446z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1491z00_1186 = BgL_v1289z00_1198; } 
{ /* Eval/evaluate_types.scm 60 */
obj_t BgL_v1290z00_1209;
BgL_v1290z00_1209 = 
create_vector(((long)0)); 
BgL_arg1492z00_1187 = BgL_v1290z00_1209; } 
BGl_ev_littz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2453z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)42388), BGl_proc2452z00zz__evaluate_typesz00, BGl_proc2451z00zz__evaluate_typesz00, BFALSE, BGl_proc2450z00zz__evaluate_typesz00, BFALSE, BgL_arg1491z00_1186, BgL_arg1492z00_1187); } 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_arg1508z00_1216;obj_t BgL_arg1509z00_1217;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_v1291z00_1230;
BgL_v1291z00_1230 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1291z00_1230,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2457z00zz__evaluate_typesz00, BGl_proc2456z00zz__evaluate_typesz00, BGl_proc2455z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1291z00_1230,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2461z00zz__evaluate_typesz00, BGl_proc2460z00zz__evaluate_typesz00, BGl_proc2459z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1291z00_1230,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2465z00zz__evaluate_typesz00, BGl_proc2464z00zz__evaluate_typesz00, BGl_proc2463z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1508z00_1216 = BgL_v1291z00_1230; } 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_v1292z00_1261;
BgL_v1292z00_1261 = 
create_vector(((long)0)); 
BgL_arg1509z00_1217 = BgL_v1292z00_1261; } 
BGl_ev_ifz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2470z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)19122), BGl_proc2469z00zz__evaluate_typesz00, BGl_proc2468z00zz__evaluate_typesz00, BFALSE, BGl_proc2467z00zz__evaluate_typesz00, BFALSE, BgL_arg1508z00_1216, BgL_arg1509z00_1217); } 
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_arg1533z00_1268;obj_t BgL_arg1534z00_1269;
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_v1293z00_1280;
BgL_v1293z00_1280 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1293z00_1280,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2474z00zz__evaluate_typesz00, BGl_proc2473z00zz__evaluate_typesz00, BGl_proc2472z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1533z00_1268 = BgL_v1293z00_1280; } 
{ /* Eval/evaluate_types.scm 66 */
obj_t BgL_v1294z00_1291;
BgL_v1294z00_1291 = 
create_vector(((long)0)); 
BgL_arg1534z00_1269 = BgL_v1294z00_1291; } 
BGl_ev_listz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2479z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)39656), BGl_proc2478z00zz__evaluate_typesz00, BGl_proc2477z00zz__evaluate_typesz00, BFALSE, BGl_proc2476z00zz__evaluate_typesz00, BFALSE, BgL_arg1533z00_1268, BgL_arg1534z00_1269); } 
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_arg1550z00_1298;obj_t BgL_arg1552z00_1299;
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_v1295z00_1310;
BgL_v1295z00_1310 = 
create_vector(((long)0)); 
BgL_arg1550z00_1298 = BgL_v1295z00_1310; } 
{ /* Eval/evaluate_types.scm 68 */
obj_t BgL_v1296z00_1311;
BgL_v1296z00_1311 = 
create_vector(((long)0)); 
BgL_arg1552z00_1299 = BgL_v1296z00_1311; } 
BGl_ev_orz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2484z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_listz00zz__evaluate_typesz00, ((long)50353), BGl_proc2483z00zz__evaluate_typesz00, BGl_proc2482z00zz__evaluate_typesz00, BFALSE, BGl_proc2481z00zz__evaluate_typesz00, BFALSE, BgL_arg1550z00_1298, BgL_arg1552z00_1299); } 
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_arg1563z00_1318;obj_t BgL_arg1564z00_1319;
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_v1297z00_1330;
BgL_v1297z00_1330 = 
create_vector(((long)0)); 
BgL_arg1563z00_1318 = BgL_v1297z00_1330; } 
{ /* Eval/evaluate_types.scm 69 */
obj_t BgL_v1298z00_1331;
BgL_v1298z00_1331 = 
create_vector(((long)0)); 
BgL_arg1564z00_1319 = BgL_v1298z00_1331; } 
BGl_ev_andz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2489z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_listz00zz__evaluate_typesz00, ((long)27076), BGl_proc2488z00zz__evaluate_typesz00, BGl_proc2487z00zz__evaluate_typesz00, BFALSE, BGl_proc2486z00zz__evaluate_typesz00, BFALSE, BgL_arg1563z00_1318, BgL_arg1564z00_1319); } 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_arg1573z00_1338;obj_t BgL_arg1574z00_1339;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_v1299z00_1351;
BgL_v1299z00_1351 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1299z00_1351,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2493z00zz__evaluate_typesz00, BGl_proc2492z00zz__evaluate_typesz00, BGl_proc2491z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1299z00_1351,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2497z00zz__evaluate_typesz00, BGl_proc2496z00zz__evaluate_typesz00, BGl_proc2495z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1573z00_1338 = BgL_v1299z00_1351; } 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_v1300z00_1372;
BgL_v1300z00_1372 = 
create_vector(((long)0)); 
BgL_arg1574z00_1339 = BgL_v1300z00_1372; } 
BGl_ev_prog2z00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2502z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)13473), BGl_proc2501z00zz__evaluate_typesz00, BGl_proc2500z00zz__evaluate_typesz00, BFALSE, BGl_proc2499z00zz__evaluate_typesz00, BFALSE, BgL_arg1573z00_1338, BgL_arg1574z00_1339); } 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_arg1597z00_1379;obj_t BgL_arg1598z00_1380;
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_v1301z00_1391;
BgL_v1301z00_1391 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1301z00_1391,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2465z00zz__evaluate_typesz00, BGl_proc2505z00zz__evaluate_typesz00, BGl_proc2504z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1597z00_1379 = BgL_v1301z00_1391; } 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_v1302z00_1402;
BgL_v1302z00_1402 = 
create_vector(((long)0)); 
BgL_arg1598z00_1380 = BgL_v1302z00_1402; } 
BGl_ev_hookz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2509z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)31882), BGl_proc2508z00zz__evaluate_typesz00, BGl_proc2507z00zz__evaluate_typesz00, BFALSE, BGl_proc2506z00zz__evaluate_typesz00, BFALSE, BgL_arg1597z00_1379, BgL_arg1598z00_1380); } 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_arg1616z00_1409;obj_t BgL_arg1617z00_1410;
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_v1303z00_1421;
BgL_v1303z00_1421 = 
create_vector(((long)0)); 
BgL_arg1616z00_1409 = BgL_v1303z00_1421; } 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_v1304z00_1422;
BgL_v1304z00_1422 = 
create_vector(((long)0)); 
BgL_arg1617z00_1410 = BgL_v1304z00_1422; } 
BGl_ev_trapz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2514z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)20558), BGl_proc2513z00zz__evaluate_typesz00, BGl_proc2512z00zz__evaluate_typesz00, BFALSE, BGl_proc2511z00zz__evaluate_typesz00, BFALSE, BgL_arg1616z00_1409, BgL_arg1617z00_1410); } 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_arg1626z00_1429;obj_t BgL_arg1627z00_1430;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_v1305z00_1442;
BgL_v1305z00_1442 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1305z00_1442,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2518z00zz__evaluate_typesz00, BGl_proc2517z00zz__evaluate_typesz00, BGl_proc2516z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
BgL_arg1626z00_1429 = BgL_v1305z00_1442; } 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_v1306z00_1453;
BgL_v1306z00_1453 = 
create_vector(((long)0)); 
BgL_arg1627z00_1430 = BgL_v1306z00_1453; } 
BGl_ev_setlocalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2523z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)37936), BGl_proc2522z00zz__evaluate_typesz00, BGl_proc2521z00zz__evaluate_typesz00, BFALSE, BGl_proc2520z00zz__evaluate_typesz00, BFALSE, BgL_arg1626z00_1429, BgL_arg1627z00_1430); } 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_arg1641z00_1460;obj_t BgL_arg1642z00_1461;
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_v1307z00_1475;
BgL_v1307z00_1475 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1307z00_1475,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2433z00zz__evaluate_typesz00, BGl_proc2526z00zz__evaluate_typesz00, BGl_proc2525z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1307z00_1475,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2411z00zz__evaluate_typesz00, BGl_proc2528z00zz__evaluate_typesz00, BGl_proc2527z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2413z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1307z00_1475,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2439z00zz__evaluate_typesz00, BGl_proc2530z00zz__evaluate_typesz00, BGl_proc2529z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1641z00_1460 = BgL_v1307z00_1475; } 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_v1308z00_1506;
BgL_v1308z00_1506 = 
create_vector(((long)0)); 
BgL_arg1642z00_1461 = BgL_v1308z00_1506; } 
BGl_ev_setglobalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2534z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_hookz00zz__evaluate_typesz00, ((long)62334), BGl_proc2533z00zz__evaluate_typesz00, BGl_proc2532z00zz__evaluate_typesz00, BFALSE, BGl_proc2531z00zz__evaluate_typesz00, BFALSE, BgL_arg1641z00_1460, BgL_arg1642z00_1461); } 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_arg1670z00_1513;obj_t BgL_arg1671z00_1514;
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_v1309z00_1528;
BgL_v1309z00_1528 = 
create_vector(((long)0)); 
BgL_arg1670z00_1513 = BgL_v1309z00_1528; } 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_v1310z00_1529;
BgL_v1310z00_1529 = 
create_vector(((long)0)); 
BgL_arg1671z00_1514 = BgL_v1310z00_1529; } 
BGl_ev_defglobalz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2539z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_setglobalz00zz__evaluate_typesz00, ((long)36141), BGl_proc2538z00zz__evaluate_typesz00, BGl_proc2537z00zz__evaluate_typesz00, BFALSE, BGl_proc2536z00zz__evaluate_typesz00, BFALSE, BgL_arg1670z00_1513, BgL_arg1671z00_1514); } 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_arg1683z00_1536;obj_t BgL_arg1684z00_1537;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_v1311z00_1549;
BgL_v1311z00_1549 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1311z00_1549,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2543z00zz__evaluate_typesz00, BGl_proc2542z00zz__evaluate_typesz00, BGl_proc2541z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1311z00_1549,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2547z00zz__evaluate_typesz00, BGl_proc2546z00zz__evaluate_typesz00, BGl_proc2545z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1683z00_1536 = BgL_v1311z00_1549; } 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_v1312z00_1570;
BgL_v1312z00_1570 = 
create_vector(((long)0)); 
BgL_arg1684z00_1537 = BgL_v1312z00_1570; } 
BGl_ev_bindzd2exitzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2552z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)10737), BGl_proc2551z00zz__evaluate_typesz00, BGl_proc2550z00zz__evaluate_typesz00, BFALSE, BGl_proc2549z00zz__evaluate_typesz00, BFALSE, BgL_arg1683z00_1536, BgL_arg1684z00_1537); } 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_arg1706z00_1577;obj_t BgL_arg1707z00_1578;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_v1313z00_1590;
BgL_v1313z00_1590 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1313z00_1590,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2465z00zz__evaluate_typesz00, BGl_proc2555z00zz__evaluate_typesz00, BGl_proc2554z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1313z00_1590,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2547z00zz__evaluate_typesz00, BGl_proc2557z00zz__evaluate_typesz00, BGl_proc2556z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1706z00_1577 = BgL_v1313z00_1590; } 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_v1314z00_1611;
BgL_v1314z00_1611 = 
create_vector(((long)0)); 
BgL_arg1707z00_1578 = BgL_v1314z00_1611; } 
BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2561z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)59406), BGl_proc2560z00zz__evaluate_typesz00, BGl_proc2559z00zz__evaluate_typesz00, BFALSE, BGl_proc2558z00zz__evaluate_typesz00, BFALSE, BgL_arg1706z00_1577, BgL_arg1707z00_1578); } 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_arg1726z00_1618;obj_t BgL_arg1727z00_1619;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_v1315z00_1631;
BgL_v1315z00_1631 = 
create_vector(((long)2)); 
VECTOR_SET(BgL_v1315z00_1631,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2565z00zz__evaluate_typesz00, BGl_proc2564z00zz__evaluate_typesz00, BGl_proc2563z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1315z00_1631,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2547z00zz__evaluate_typesz00, BGl_proc2568z00zz__evaluate_typesz00, BGl_proc2567z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1726z00_1618 = BgL_v1315z00_1631; } 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_v1316z00_1652;
BgL_v1316z00_1652 = 
create_vector(((long)0)); 
BgL_arg1727z00_1619 = BgL_v1316z00_1652; } 
BGl_ev_withzd2handlerzd2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2572z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)54187), BGl_proc2571z00zz__evaluate_typesz00, BGl_proc2570z00zz__evaluate_typesz00, BFALSE, BGl_proc2569z00zz__evaluate_typesz00, BFALSE, BgL_arg1726z00_1618, BgL_arg1727z00_1619); } 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_arg1746z00_1659;obj_t BgL_arg1747z00_1660;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_v1317z00_1674;
BgL_v1317z00_1674 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1317z00_1674,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2433z00zz__evaluate_typesz00, BGl_proc2575z00zz__evaluate_typesz00, BGl_proc2574z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1317z00_1674,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2578z00zz__evaluate_typesz00, BGl_proc2577z00zz__evaluate_typesz00, BGl_proc2576z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1317z00_1674,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2582z00zz__evaluate_typesz00, BGl_proc2581z00zz__evaluate_typesz00, BGl_proc2580z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1317z00_1674,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2547z00zz__evaluate_typesz00, BGl_proc2585z00zz__evaluate_typesz00, BGl_proc2584z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1746z00_1659 = BgL_v1317z00_1674; } 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_v1318z00_1715;
BgL_v1318z00_1715 = 
create_vector(((long)0)); 
BgL_arg1747z00_1660 = BgL_v1318z00_1715; } 
BGl_ev_synchroniza7eza7zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2589z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)40732), BGl_proc2588z00zz__evaluate_typesz00, BGl_proc2587z00zz__evaluate_typesz00, BFALSE, BGl_proc2586z00zz__evaluate_typesz00, BFALSE, BgL_arg1746z00_1659, BgL_arg1747z00_1660); } 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_arg1776z00_1722;obj_t BgL_arg1777z00_1723;
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_v1319z00_1736;
BgL_v1319z00_1736 = 
create_vector(((long)3)); 
VECTOR_SET(BgL_v1319z00_1736,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2593z00zz__evaluate_typesz00, BGl_proc2592z00zz__evaluate_typesz00, BGl_proc2591z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1319z00_1736,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2597z00zz__evaluate_typesz00, BGl_proc2596z00zz__evaluate_typesz00, BGl_proc2595z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1319z00_1736,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2547z00zz__evaluate_typesz00, BGl_proc2600z00zz__evaluate_typesz00, BGl_proc2599z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
BgL_arg1776z00_1722 = BgL_v1319z00_1736; } 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_v1320z00_1767;
BgL_v1320z00_1767 = 
create_vector(((long)0)); 
BgL_arg1777z00_1723 = BgL_v1320z00_1767; } 
BGl_ev_binderz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2604z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)50429), BGl_proc2603z00zz__evaluate_typesz00, BGl_proc2602z00zz__evaluate_typesz00, BFALSE, BGl_proc2601z00zz__evaluate_typesz00, BFALSE, BgL_arg1776z00_1722, BgL_arg1777z00_1723); } 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_arg1801z00_1774;obj_t BgL_arg1802z00_1775;
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_v1321z00_1789;
BgL_v1321z00_1789 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1321z00_1789,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2609z00zz__evaluate_typesz00, BGl_proc2608z00zz__evaluate_typesz00, BGl_proc2607z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2606z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1801z00_1774 = BgL_v1321z00_1789; } 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_v1322z00_1803;
BgL_v1322z00_1803 = 
create_vector(((long)0)); 
BgL_arg1802z00_1775 = BgL_v1322z00_1803; } 
BGl_ev_letz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2614z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)20537), BGl_proc2613z00zz__evaluate_typesz00, BGl_proc2612z00zz__evaluate_typesz00, BFALSE, BGl_proc2611z00zz__evaluate_typesz00, BFALSE, BgL_arg1801z00_1774, BgL_arg1802z00_1775); } 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_arg1818z00_1810;obj_t BgL_arg1819z00_1811;
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_v1323z00_1825;
BgL_v1323z00_1825 = 
create_vector(((long)1)); 
VECTOR_SET(BgL_v1323z00_1825,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2609z00zz__evaluate_typesz00, BGl_proc2618z00zz__evaluate_typesz00, BGl_proc2617z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2616z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1818z00_1810 = BgL_v1323z00_1825; } 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_v1324z00_1839;
BgL_v1324z00_1839 = 
create_vector(((long)0)); 
BgL_arg1819z00_1811 = BgL_v1324z00_1839; } 
BGl_ev_letza2za2zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2622z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)9890), BGl_proc2621z00zz__evaluate_typesz00, BGl_proc2620z00zz__evaluate_typesz00, BFALSE, BGl_proc2619z00zz__evaluate_typesz00, BFALSE, BgL_arg1818z00_1810, BgL_arg1819z00_1811); } 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_arg1835z00_1846;obj_t BgL_arg1836z00_1847;
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_v1325z00_1860;
BgL_v1325z00_1860 = 
create_vector(((long)0)); 
BgL_arg1835z00_1846 = BgL_v1325z00_1860; } 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_v1326z00_1861;
BgL_v1326z00_1861 = 
create_vector(((long)0)); 
BgL_arg1836z00_1847 = BgL_v1326z00_1861; } 
BGl_ev_letrecz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2627z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_binderz00zz__evaluate_typesz00, ((long)43933), BGl_proc2626z00zz__evaluate_typesz00, BGl_proc2625z00zz__evaluate_typesz00, BFALSE, BGl_proc2624z00zz__evaluate_typesz00, BFALSE, BgL_arg1835z00_1846, BgL_arg1836z00_1847); } 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_arg1845z00_1868;obj_t BgL_arg1846z00_1869;
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_v1327z00_1885;
BgL_v1327z00_1885 = 
create_vector(((long)6)); 
VECTOR_SET(BgL_v1327z00_1885,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2593z00zz__evaluate_typesz00, BGl_proc2630z00zz__evaluate_typesz00, BGl_proc2629z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1327z00_1885,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2597z00zz__evaluate_typesz00, BGl_proc2632z00zz__evaluate_typesz00, BGl_proc2631z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1327z00_1885,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2636z00zz__evaluate_typesz00, BGl_proc2635z00zz__evaluate_typesz00, BGl_proc2634z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2633z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1327z00_1885,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2641z00zz__evaluate_typesz00, BGl_proc2640z00zz__evaluate_typesz00, BGl_proc2639z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2638z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1327z00_1885,((long)4),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2547z00zz__evaluate_typesz00, BGl_proc2644z00zz__evaluate_typesz00, BGl_proc2643z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1327z00_1885,((long)5),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2609z00zz__evaluate_typesz00, BGl_proc2647z00zz__evaluate_typesz00, BGl_proc2646z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2645z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1845z00_1868 = BgL_v1327z00_1885; } 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_v1328z00_1955;
BgL_v1328z00_1955 = 
create_vector(((long)0)); 
BgL_arg1846z00_1869 = BgL_v1328z00_1955; } 
BGl_ev_labelsz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2651z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)51900), BGl_proc2650z00zz__evaluate_typesz00, BGl_proc2649z00zz__evaluate_typesz00, BFALSE, BGl_proc2648z00zz__evaluate_typesz00, BFALSE, BgL_arg1845z00_1868, BgL_arg1846z00_1869); } 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_arg1891z00_1962;obj_t BgL_arg1892z00_1963;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_v1329z00_1977;
BgL_v1329z00_1977 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1329z00_1977,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2433z00zz__evaluate_typesz00, BGl_proc2654z00zz__evaluate_typesz00, BGl_proc2653z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1329z00_1977,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2657z00zz__evaluate_typesz00, BGl_proc2656z00zz__evaluate_typesz00, BGl_proc2655z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_varz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1329z00_1977,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2661z00zz__evaluate_typesz00, BGl_proc2660z00zz__evaluate_typesz00, BGl_proc2659z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_labelsz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1329z00_1977,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2474z00zz__evaluate_typesz00, BGl_proc2664z00zz__evaluate_typesz00, BGl_proc2663z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1891z00_1962 = BgL_v1329z00_1977; } 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_v1330z00_2018;
BgL_v1330z00_2018 = 
create_vector(((long)0)); 
BgL_arg1892z00_1963 = BgL_v1330z00_2018; } 
BGl_ev_gotoz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2668z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)25845), BGl_proc2667z00zz__evaluate_typesz00, BGl_proc2666z00zz__evaluate_typesz00, BFALSE, BGl_proc2665z00zz__evaluate_typesz00, BFALSE, BgL_arg1891z00_1962, BgL_arg1892z00_1963); } 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_arg1921z00_2025;obj_t BgL_arg1922z00_2026;
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_v1331z00_2040;
BgL_v1331z00_2040 = 
create_vector(((long)4)); 
VECTOR_SET(BgL_v1331z00_2040,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2433z00zz__evaluate_typesz00, BGl_proc2671z00zz__evaluate_typesz00, BGl_proc2670z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2040,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2674z00zz__evaluate_typesz00, BGl_proc2673z00zz__evaluate_typesz00, BGl_proc2672z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2040,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2474z00zz__evaluate_typesz00, BGl_proc2677z00zz__evaluate_typesz00, BGl_proc2676z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1331z00_2040,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2680z00zz__evaluate_typesz00, BGl_proc2679z00zz__evaluate_typesz00, BGl_proc2678z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1921z00_2025 = BgL_v1331z00_2040; } 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_v1332z00_2081;
BgL_v1332z00_2081 = 
create_vector(((long)0)); 
BgL_arg1922z00_2026 = BgL_v1332z00_2081; } 
BGl_ev_appz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2685z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)55811), BGl_proc2684z00zz__evaluate_typesz00, BGl_proc2683z00zz__evaluate_typesz00, BFALSE, BGl_proc2682z00zz__evaluate_typesz00, BFALSE, BgL_arg1921z00_2025, BgL_arg1922z00_2026); } 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_arg1951z00_2088;obj_t BgL_arg1952z00_2089;
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_v1333z00_2109;
BgL_v1333z00_2109 = 
create_vector(((long)10)); 
VECTOR_SET(BgL_v1333z00_2109,((long)0),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2433z00zz__evaluate_typesz00, BGl_proc2688z00zz__evaluate_typesz00, BGl_proc2687z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)1),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2691z00zz__evaluate_typesz00, BGl_proc2690z00zz__evaluate_typesz00, BGl_proc2689z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)2),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2695z00zz__evaluate_typesz00, BGl_proc2694z00zz__evaluate_typesz00, BGl_proc2693z00zz__evaluate_typesz00, ((bool_t)1), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)3),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2593z00zz__evaluate_typesz00, BGl_proc2698z00zz__evaluate_typesz00, BGl_proc2697z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)4),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2547z00zz__evaluate_typesz00, BGl_proc2700z00zz__evaluate_typesz00, BGl_proc2699z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BFALSE, BGl_ev_exprz00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)5),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2704z00zz__evaluate_typesz00, BGl_proc2703z00zz__evaluate_typesz00, BGl_proc2702z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2701z00zz__evaluate_typesz00, BGl_symbol2706z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)6),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2711z00zz__evaluate_typesz00, BGl_proc2710z00zz__evaluate_typesz00, BGl_proc2709z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2708z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)7),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2716z00zz__evaluate_typesz00, BGl_proc2715z00zz__evaluate_typesz00, BGl_proc2714z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2713z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)8),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2721z00zz__evaluate_typesz00, BGl_proc2720z00zz__evaluate_typesz00, BGl_proc2719z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2718z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
VECTOR_SET(BgL_v1333z00_2109,((long)9),
BGl_makezd2classzd2fieldz00zz__objectz00(BGl_symbol2609z00zz__evaluate_typesz00, BGl_proc2725z00zz__evaluate_typesz00, BGl_proc2724z00zz__evaluate_typesz00, ((bool_t)0), ((bool_t)0), BFALSE, BGl_proc2723z00zz__evaluate_typesz00, BGl_symbol2420z00zz__evaluate_typesz00)); 
BgL_arg1951z00_2088 = BgL_v1333z00_2109; } 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_v1334z00_2225;
BgL_v1334z00_2225 = 
create_vector(((long)0)); 
BgL_arg1952z00_2089 = BgL_v1334z00_2225; } 
return ( 
BGl_ev_absz00zz__evaluate_typesz00 = 
BGl_registerzd2classz12zc0zz__objectz00(BGl_symbol2729z00zz__evaluate_typesz00, BGl_symbol2407z00zz__evaluate_typesz00, BGl_ev_exprz00zz__evaluate_typesz00, ((long)22790), BGl_proc2728z00zz__evaluate_typesz00, BGl_proc2727z00zz__evaluate_typesz00, BFALSE, BGl_proc2726z00zz__evaluate_typesz00, BFALSE, BgL_arg1951z00_2088, BgL_arg1952z00_2089), BUNSPEC) ;} } 

}



/* &<@anonymous:1957> */
obj_t BGl_z62zc3z04anonymousza31957ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3388, obj_t BgL_new1191z00_3389)
{
{ /* Eval/evaluate_types.scm 122 */
{ 
BgL_ev_absz00_bglt BgL_auxz00_4571;
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_wherez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_arityz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4580;
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL_classz00_3864;
BgL_classz00_3864 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 122 */
obj_t BgL__ortest_1282z00_3865;
BgL__ortest_1282z00_3865 = 
BGL_CLASS_NIL(BgL_classz00_3864); 
if(
CBOOL(BgL__ortest_1282z00_3865))
{ /* Eval/evaluate_types.scm 122 */
BgL_auxz00_4580 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_3865)
; }  else 
{ /* Eval/evaluate_types.scm 122 */
BgL_auxz00_4580 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3864))
; } } } 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4580),BUNSPEC); } 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_siza7eza7)=((int)
(int)(((long)0))),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_bindz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_freez00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_innerz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_new1191z00_3389)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4571 = 
((BgL_ev_absz00_bglt)BgL_new1191z00_3389); 
return 
((obj_t)BgL_auxz00_4571);} } 

}



/* &lambda1955 */
BgL_ev_absz00_bglt BGl_z62lambda1955z62zz__evaluate_typesz00(obj_t BgL_envz00_3390)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1190z00_3866;
BgL_new1190z00_3866 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 122 */
long BgL_arg1956z00_3867;
{ /* Eval/evaluate_types.scm 122 */
long BgL_res2351z00_3868;
BgL_res2351z00_3868 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BgL_arg1956z00_3867 = BgL_res2351z00_3868; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1190z00_3866), BgL_arg1956z00_3867); } 
return BgL_new1190z00_3866;} } 

}



/* &lambda1953 */
BgL_ev_absz00_bglt BGl_z62lambda1953z62zz__evaluate_typesz00(obj_t BgL_envz00_3391, obj_t BgL_loc1180z00_3392, obj_t BgL_where1181z00_3393, obj_t BgL_arity1182z00_3394, obj_t BgL_vars1183z00_3395, obj_t BgL_body1184z00_3396, obj_t BgL_siza7e1185za7_3397, obj_t BgL_bind1186z00_3398, obj_t BgL_free1187z00_3399, obj_t BgL_inner1188z00_3400, obj_t BgL_boxes1189z00_3401)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
int BgL_siza7e1185za7_3870;
BgL_siza7e1185za7_3870 = 
CINT(BgL_siza7e1185za7_3397); 
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1243z00_3871;
{ /* Eval/evaluate_types.scm 122 */
BgL_ev_absz00_bglt BgL_new1242z00_3872;
BgL_new1242z00_3872 = 
((BgL_ev_absz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_absz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 122 */
long BgL_arg1954z00_3873;
{ /* Eval/evaluate_types.scm 122 */
long BgL_res2350z00_3874;
BgL_res2350z00_3874 = 
BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00); 
BgL_arg1954z00_3873 = BgL_res2350z00_3874; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1242z00_3872), BgL_arg1954z00_3873); } 
BgL_new1243z00_3871 = BgL_new1242z00_3872; } 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_locz00)=((obj_t)BgL_loc1180z00_3392),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_wherez00)=((obj_t)BgL_where1181z00_3393),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_arityz00)=((obj_t)BgL_arity1182z00_3394),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_varsz00)=((obj_t)BgL_vars1183z00_3395),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1184z00_3396)),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_siza7eza7)=((int)BgL_siza7e1185za7_3870),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_bindz00)=((obj_t)BgL_bind1186z00_3398),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_freez00)=((obj_t)BgL_free1187z00_3399),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_innerz00)=((obj_t)BgL_inner1188z00_3400),BUNSPEC); 
((((BgL_ev_absz00_bglt)COBJECT(BgL_new1243z00_3871))->BgL_boxesz00)=((obj_t)BgL_boxes1189z00_3401),BUNSPEC); 
return BgL_new1243z00_3871;} } } 

}



/* &<@anonymous:2017> */
obj_t BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3402)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda2016 */
obj_t BGl_z62lambda2016z62zz__evaluate_typesz00(obj_t BgL_envz00_3403, obj_t BgL_oz00_3404, obj_t BgL_vz00_3405)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3404)))->BgL_boxesz00)=((obj_t)BgL_vz00_3405),BUNSPEC);} 

}



/* &lambda2015 */
obj_t BGl_z62lambda2015z62zz__evaluate_typesz00(obj_t BgL_envz00_3406, obj_t BgL_oz00_3407)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3407)))->BgL_boxesz00);} 

}



/* &<@anonymous:2010> */
obj_t BGl_z62zc3z04anonymousza32010ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3408)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda2009 */
obj_t BGl_z62lambda2009z62zz__evaluate_typesz00(obj_t BgL_envz00_3409, obj_t BgL_oz00_3410, obj_t BgL_vz00_3411)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3410)))->BgL_innerz00)=((obj_t)BgL_vz00_3411),BUNSPEC);} 

}



/* &lambda2008 */
obj_t BGl_z62lambda2008z62zz__evaluate_typesz00(obj_t BgL_envz00_3412, obj_t BgL_oz00_3413)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3413)))->BgL_innerz00);} 

}



/* &<@anonymous:2003> */
obj_t BGl_z62zc3z04anonymousza32003ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3414)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda2002 */
obj_t BGl_z62lambda2002z62zz__evaluate_typesz00(obj_t BgL_envz00_3415, obj_t BgL_oz00_3416, obj_t BgL_vz00_3417)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3416)))->BgL_freez00)=((obj_t)BgL_vz00_3417),BUNSPEC);} 

}



/* &lambda2001 */
obj_t BGl_z62lambda2001z62zz__evaluate_typesz00(obj_t BgL_envz00_3418, obj_t BgL_oz00_3419)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3419)))->BgL_freez00);} 

}



/* &<@anonymous:1996> */
obj_t BGl_z62zc3z04anonymousza31996ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3420)
{
{ /* Eval/evaluate_types.scm 122 */
return BNIL;} 

}



/* &lambda1995 */
obj_t BGl_z62lambda1995z62zz__evaluate_typesz00(obj_t BgL_envz00_3421, obj_t BgL_oz00_3422, obj_t BgL_vz00_3423)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3422)))->BgL_bindz00)=((obj_t)BgL_vz00_3423),BUNSPEC);} 

}



/* &lambda1994 */
obj_t BGl_z62lambda1994z62zz__evaluate_typesz00(obj_t BgL_envz00_3424, obj_t BgL_oz00_3425)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3425)))->BgL_bindz00);} 

}



/* &<@anonymous:1989> */
obj_t BGl_z62zc3z04anonymousza31989ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3426)
{
{ /* Eval/evaluate_types.scm 122 */
return 
BINT(((long)0));} 

}



/* &lambda1988 */
obj_t BGl_z62lambda1988z62zz__evaluate_typesz00(obj_t BgL_envz00_3427, obj_t BgL_oz00_3428, obj_t BgL_vz00_3429)
{
{ /* Eval/evaluate_types.scm 122 */
{ /* Eval/evaluate_types.scm 122 */
int BgL_vz00_3884;
BgL_vz00_3884 = 
CINT(BgL_vz00_3429); 
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3428)))->BgL_siza7eza7)=((int)BgL_vz00_3884),BUNSPEC);} } 

}



/* &lambda1987 */
obj_t BGl_z62lambda1987z62zz__evaluate_typesz00(obj_t BgL_envz00_3430, obj_t BgL_oz00_3431)
{
{ /* Eval/evaluate_types.scm 122 */
return 
BINT(
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3431)))->BgL_siza7eza7));} 

}



/* &lambda1982 */
obj_t BGl_z62lambda1982z62zz__evaluate_typesz00(obj_t BgL_envz00_3432, obj_t BgL_oz00_3433, obj_t BgL_vz00_3434)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3433)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3434)),BUNSPEC);} 

}



/* &lambda1981 */
BgL_ev_exprz00_bglt BGl_z62lambda1981z62zz__evaluate_typesz00(obj_t BgL_envz00_3435, obj_t BgL_oz00_3436)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3436)))->BgL_bodyz00);} 

}



/* &lambda1977 */
obj_t BGl_z62lambda1977z62zz__evaluate_typesz00(obj_t BgL_envz00_3437, obj_t BgL_oz00_3438, obj_t BgL_vz00_3439)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3438)))->BgL_varsz00)=((obj_t)BgL_vz00_3439),BUNSPEC);} 

}



/* &lambda1976 */
obj_t BGl_z62lambda1976z62zz__evaluate_typesz00(obj_t BgL_envz00_3440, obj_t BgL_oz00_3441)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3441)))->BgL_varsz00);} 

}



/* &lambda1972 */
obj_t BGl_z62lambda1972z62zz__evaluate_typesz00(obj_t BgL_envz00_3442, obj_t BgL_oz00_3443, obj_t BgL_vz00_3444)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3443)))->BgL_arityz00)=((obj_t)BgL_vz00_3444),BUNSPEC);} 

}



/* &lambda1971 */
obj_t BGl_z62lambda1971z62zz__evaluate_typesz00(obj_t BgL_envz00_3445, obj_t BgL_oz00_3446)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3446)))->BgL_arityz00);} 

}



/* &lambda1967 */
obj_t BGl_z62lambda1967z62zz__evaluate_typesz00(obj_t BgL_envz00_3447, obj_t BgL_oz00_3448, obj_t BgL_vz00_3449)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3448)))->BgL_wherez00)=((obj_t)BgL_vz00_3449),BUNSPEC);} 

}



/* &lambda1966 */
obj_t BGl_z62lambda1966z62zz__evaluate_typesz00(obj_t BgL_envz00_3450, obj_t BgL_oz00_3451)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3451)))->BgL_wherez00);} 

}



/* &lambda1962 */
obj_t BGl_z62lambda1962z62zz__evaluate_typesz00(obj_t BgL_envz00_3452, obj_t BgL_oz00_3453, obj_t BgL_vz00_3454)
{
{ /* Eval/evaluate_types.scm 122 */
return 
((((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3453)))->BgL_locz00)=((obj_t)BgL_vz00_3454),BUNSPEC);} 

}



/* &lambda1961 */
obj_t BGl_z62lambda1961z62zz__evaluate_typesz00(obj_t BgL_envz00_3455, obj_t BgL_oz00_3456)
{
{ /* Eval/evaluate_types.scm 122 */
return 
(((BgL_ev_absz00_bglt)COBJECT(
((BgL_ev_absz00_bglt)BgL_oz00_3456)))->BgL_locz00);} 

}



/* &<@anonymous:1927> */
obj_t BGl_z62zc3z04anonymousza31927ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3457, obj_t BgL_new1178z00_3458)
{
{ /* Eval/evaluate_types.scm 119 */
{ 
BgL_ev_appz00_bglt BgL_auxz00_4666;
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1178z00_3458)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4669;
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL_classz00_3898;
BgL_classz00_3898 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 119 */
obj_t BgL__ortest_1282z00_3899;
BgL__ortest_1282z00_3899 = 
BGL_CLASS_NIL(BgL_classz00_3898); 
if(
CBOOL(BgL__ortest_1282z00_3899))
{ /* Eval/evaluate_types.scm 119 */
BgL_auxz00_4669 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_3899)
; }  else 
{ /* Eval/evaluate_types.scm 119 */
BgL_auxz00_4669 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3898))
; } } } 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1178z00_3458)))->BgL_funz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4669),BUNSPEC); } 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1178z00_3458)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_new1178z00_3458)))->BgL_tailzf3zf3)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4666 = 
((BgL_ev_appz00_bglt)BgL_new1178z00_3458); 
return 
((obj_t)BgL_auxz00_4666);} } 

}



/* &lambda1925 */
BgL_ev_appz00_bglt BGl_z62lambda1925z62zz__evaluate_typesz00(obj_t BgL_envz00_3459)
{
{ /* Eval/evaluate_types.scm 119 */
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1177z00_3900;
BgL_new1177z00_3900 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 119 */
long BgL_arg1926z00_3901;
{ /* Eval/evaluate_types.scm 119 */
long BgL_res2349z00_3902;
BgL_res2349z00_3902 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1926z00_3901 = BgL_res2349z00_3902; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1177z00_3900), BgL_arg1926z00_3901); } 
return BgL_new1177z00_3900;} } 

}



/* &lambda1923 */
BgL_ev_appz00_bglt BGl_z62lambda1923z62zz__evaluate_typesz00(obj_t BgL_envz00_3460, obj_t BgL_loc1173z00_3461, obj_t BgL_fun1174z00_3462, obj_t BgL_args1175z00_3463, obj_t BgL_tailzf31176zf3_3464)
{
{ /* Eval/evaluate_types.scm 119 */
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1241z00_3904;
{ /* Eval/evaluate_types.scm 119 */
BgL_ev_appz00_bglt BgL_new1240z00_3905;
BgL_new1240z00_3905 = 
((BgL_ev_appz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_appz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 119 */
long BgL_arg1924z00_3906;
{ /* Eval/evaluate_types.scm 119 */
long BgL_res2348z00_3907;
BgL_res2348z00_3907 = 
BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00); 
BgL_arg1924z00_3906 = BgL_res2348z00_3907; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1240z00_3905), BgL_arg1924z00_3906); } 
BgL_new1241z00_3904 = BgL_new1240z00_3905; } 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1241z00_3904))->BgL_locz00)=((obj_t)BgL_loc1173z00_3461),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1241z00_3904))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_fun1174z00_3462)),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1241z00_3904))->BgL_argsz00)=((obj_t)BgL_args1175z00_3463),BUNSPEC); 
((((BgL_ev_appz00_bglt)COBJECT(BgL_new1241z00_3904))->BgL_tailzf3zf3)=((obj_t)BgL_tailzf31176zf3_3464),BUNSPEC); 
return BgL_new1241z00_3904;} } 

}



/* &lambda1947 */
obj_t BGl_z62lambda1947z62zz__evaluate_typesz00(obj_t BgL_envz00_3465, obj_t BgL_oz00_3466, obj_t BgL_vz00_3467)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3466)))->BgL_tailzf3zf3)=((obj_t)BgL_vz00_3467),BUNSPEC);} 

}



/* &lambda1946 */
obj_t BGl_z62lambda1946z62zz__evaluate_typesz00(obj_t BgL_envz00_3468, obj_t BgL_oz00_3469)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3469)))->BgL_tailzf3zf3);} 

}



/* &lambda1942 */
obj_t BGl_z62lambda1942z62zz__evaluate_typesz00(obj_t BgL_envz00_3470, obj_t BgL_oz00_3471, obj_t BgL_vz00_3472)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3471)))->BgL_argsz00)=((obj_t)BgL_vz00_3472),BUNSPEC);} 

}



/* &lambda1941 */
obj_t BGl_z62lambda1941z62zz__evaluate_typesz00(obj_t BgL_envz00_3473, obj_t BgL_oz00_3474)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3474)))->BgL_argsz00);} 

}



/* &lambda1937 */
obj_t BGl_z62lambda1937z62zz__evaluate_typesz00(obj_t BgL_envz00_3475, obj_t BgL_oz00_3476, obj_t BgL_vz00_3477)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3476)))->BgL_funz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3477)),BUNSPEC);} 

}



/* &lambda1936 */
BgL_ev_exprz00_bglt BGl_z62lambda1936z62zz__evaluate_typesz00(obj_t BgL_envz00_3478, obj_t BgL_oz00_3479)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3479)))->BgL_funz00);} 

}



/* &lambda1932 */
obj_t BGl_z62lambda1932z62zz__evaluate_typesz00(obj_t BgL_envz00_3480, obj_t BgL_oz00_3481, obj_t BgL_vz00_3482)
{
{ /* Eval/evaluate_types.scm 119 */
return 
((((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3481)))->BgL_locz00)=((obj_t)BgL_vz00_3482),BUNSPEC);} 

}



/* &lambda1931 */
obj_t BGl_z62lambda1931z62zz__evaluate_typesz00(obj_t BgL_envz00_3483, obj_t BgL_oz00_3484)
{
{ /* Eval/evaluate_types.scm 119 */
return 
(((BgL_ev_appz00_bglt)COBJECT(
((BgL_ev_appz00_bglt)BgL_oz00_3484)))->BgL_locz00);} 

}



/* &<@anonymous:1897> */
obj_t BGl_z62zc3z04anonymousza31897ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3485, obj_t BgL_new1171z00_3486)
{
{ /* Eval/evaluate_types.scm 114 */
{ 
BgL_ev_gotoz00_bglt BgL_auxz00_4714;
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1171z00_3486)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_varz00_bglt BgL_auxz00_4717;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_classz00_3918;
BgL_classz00_3918 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL__ortest_1282z00_3919;
BgL__ortest_1282z00_3919 = 
BGL_CLASS_NIL(BgL_classz00_3918); 
if(
CBOOL(BgL__ortest_1282z00_3919))
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4717 = 
((BgL_ev_varz00_bglt)BgL__ortest_1282z00_3919)
; }  else 
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4717 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3918))
; } } } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1171z00_3486)))->BgL_labelz00)=((BgL_ev_varz00_bglt)BgL_auxz00_4717),BUNSPEC); } 
{ 
BgL_ev_labelsz00_bglt BgL_auxz00_4726;
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL_classz00_3920;
BgL_classz00_3920 = BGl_ev_labelsz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 114 */
obj_t BgL__ortest_1282z00_3921;
BgL__ortest_1282z00_3921 = 
BGL_CLASS_NIL(BgL_classz00_3920); 
if(
CBOOL(BgL__ortest_1282z00_3921))
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4726 = 
((BgL_ev_labelsz00_bglt)BgL__ortest_1282z00_3921)
; }  else 
{ /* Eval/evaluate_types.scm 114 */
BgL_auxz00_4726 = 
((BgL_ev_labelsz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3920))
; } } } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1171z00_3486)))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)BgL_auxz00_4726),BUNSPEC); } 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_new1171z00_3486)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4714 = 
((BgL_ev_gotoz00_bglt)BgL_new1171z00_3486); 
return 
((obj_t)BgL_auxz00_4714);} } 

}



/* &lambda1895 */
BgL_ev_gotoz00_bglt BGl_z62lambda1895z62zz__evaluate_typesz00(obj_t BgL_envz00_3487)
{
{ /* Eval/evaluate_types.scm 114 */
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1170z00_3922;
BgL_new1170z00_3922 = 
((BgL_ev_gotoz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_gotoz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 114 */
long BgL_arg1896z00_3923;
{ /* Eval/evaluate_types.scm 114 */
long BgL_res2347z00_3924;
BgL_res2347z00_3924 = 
BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00); 
BgL_arg1896z00_3923 = BgL_res2347z00_3924; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1170z00_3922), BgL_arg1896z00_3923); } 
return BgL_new1170z00_3922;} } 

}



/* &lambda1893 */
BgL_ev_gotoz00_bglt BGl_z62lambda1893z62zz__evaluate_typesz00(obj_t BgL_envz00_3488, obj_t BgL_loc1166z00_3489, obj_t BgL_label1167z00_3490, obj_t BgL_labels1168z00_3491, obj_t BgL_args1169z00_3492)
{
{ /* Eval/evaluate_types.scm 114 */
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1239z00_3927;
{ /* Eval/evaluate_types.scm 114 */
BgL_ev_gotoz00_bglt BgL_new1238z00_3928;
BgL_new1238z00_3928 = 
((BgL_ev_gotoz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_gotoz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 114 */
long BgL_arg1894z00_3929;
{ /* Eval/evaluate_types.scm 114 */
long BgL_res2346z00_3930;
BgL_res2346z00_3930 = 
BGL_CLASS_INDEX(BGl_ev_gotoz00zz__evaluate_typesz00); 
BgL_arg1894z00_3929 = BgL_res2346z00_3930; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1238z00_3928), BgL_arg1894z00_3929); } 
BgL_new1239z00_3927 = BgL_new1238z00_3928; } 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1239z00_3927))->BgL_locz00)=((obj_t)BgL_loc1166z00_3489),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1239z00_3927))->BgL_labelz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_label1167z00_3490)),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1239z00_3927))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)
((BgL_ev_labelsz00_bglt)BgL_labels1168z00_3491)),BUNSPEC); 
((((BgL_ev_gotoz00_bglt)COBJECT(BgL_new1239z00_3927))->BgL_argsz00)=((obj_t)BgL_args1169z00_3492),BUNSPEC); 
return BgL_new1239z00_3927;} } 

}



/* &lambda1917 */
obj_t BGl_z62lambda1917z62zz__evaluate_typesz00(obj_t BgL_envz00_3493, obj_t BgL_oz00_3494, obj_t BgL_vz00_3495)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3494)))->BgL_argsz00)=((obj_t)BgL_vz00_3495),BUNSPEC);} 

}



/* &lambda1916 */
obj_t BGl_z62lambda1916z62zz__evaluate_typesz00(obj_t BgL_envz00_3496, obj_t BgL_oz00_3497)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3497)))->BgL_argsz00);} 

}



/* &lambda1912 */
obj_t BGl_z62lambda1912z62zz__evaluate_typesz00(obj_t BgL_envz00_3498, obj_t BgL_oz00_3499, obj_t BgL_vz00_3500)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3499)))->BgL_labelsz00)=((BgL_ev_labelsz00_bglt)
((BgL_ev_labelsz00_bglt)BgL_vz00_3500)),BUNSPEC);} 

}



/* &lambda1911 */
BgL_ev_labelsz00_bglt BGl_z62lambda1911z62zz__evaluate_typesz00(obj_t BgL_envz00_3501, obj_t BgL_oz00_3502)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3502)))->BgL_labelsz00);} 

}



/* &lambda1907 */
obj_t BGl_z62lambda1907z62zz__evaluate_typesz00(obj_t BgL_envz00_3503, obj_t BgL_oz00_3504, obj_t BgL_vz00_3505)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3504)))->BgL_labelz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3505)),BUNSPEC);} 

}



/* &lambda1906 */
BgL_ev_varz00_bglt BGl_z62lambda1906z62zz__evaluate_typesz00(obj_t BgL_envz00_3506, obj_t BgL_oz00_3507)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3507)))->BgL_labelz00);} 

}



/* &lambda1902 */
obj_t BGl_z62lambda1902z62zz__evaluate_typesz00(obj_t BgL_envz00_3508, obj_t BgL_oz00_3509, obj_t BgL_vz00_3510)
{
{ /* Eval/evaluate_types.scm 114 */
return 
((((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3509)))->BgL_locz00)=((obj_t)BgL_vz00_3510),BUNSPEC);} 

}



/* &lambda1901 */
obj_t BGl_z62lambda1901z62zz__evaluate_typesz00(obj_t BgL_envz00_3511, obj_t BgL_oz00_3512)
{
{ /* Eval/evaluate_types.scm 114 */
return 
(((BgL_ev_gotoz00_bglt)COBJECT(
((BgL_ev_gotoz00_bglt)BgL_oz00_3512)))->BgL_locz00);} 

}



/* &<@anonymous:1851> */
obj_t BGl_z62zc3z04anonymousza31851ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3513, obj_t BgL_new1164z00_3514)
{
{ /* Eval/evaluate_types.scm 106 */
{ 
BgL_ev_labelsz00_bglt BgL_auxz00_4771;
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1164z00_3514)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1164z00_3514)))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1164z00_3514)))->BgL_envz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1164z00_3514)))->BgL_stkz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4780;
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL_classz00_3942;
BgL_classz00_3942 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 106 */
obj_t BgL__ortest_1282z00_3943;
BgL__ortest_1282z00_3943 = 
BGL_CLASS_NIL(BgL_classz00_3942); 
if(
CBOOL(BgL__ortest_1282z00_3943))
{ /* Eval/evaluate_types.scm 106 */
BgL_auxz00_4780 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_3943)
; }  else 
{ /* Eval/evaluate_types.scm 106 */
BgL_auxz00_4780 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3942))
; } } } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1164z00_3514)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4780),BUNSPEC); } 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_new1164z00_3514)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4771 = 
((BgL_ev_labelsz00_bglt)BgL_new1164z00_3514); 
return 
((obj_t)BgL_auxz00_4771);} } 

}



/* &lambda1849 */
BgL_ev_labelsz00_bglt BGl_z62lambda1849z62zz__evaluate_typesz00(obj_t BgL_envz00_3515)
{
{ /* Eval/evaluate_types.scm 106 */
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1163z00_3944;
BgL_new1163z00_3944 = 
((BgL_ev_labelsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_labelsz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 106 */
long BgL_arg1850z00_3945;
{ /* Eval/evaluate_types.scm 106 */
long BgL_res2345z00_3946;
BgL_res2345z00_3946 = 
BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00); 
BgL_arg1850z00_3945 = BgL_res2345z00_3946; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1163z00_3944), BgL_arg1850z00_3945); } 
return BgL_new1163z00_3944;} } 

}



/* &lambda1847 */
BgL_ev_labelsz00_bglt BGl_z62lambda1847z62zz__evaluate_typesz00(obj_t BgL_envz00_3516, obj_t BgL_vars1157z00_3517, obj_t BgL_vals1158z00_3518, obj_t BgL_env1159z00_3519, obj_t BgL_stk1160z00_3520, obj_t BgL_body1161z00_3521, obj_t BgL_boxes1162z00_3522)
{
{ /* Eval/evaluate_types.scm 106 */
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1237z00_3948;
{ /* Eval/evaluate_types.scm 106 */
BgL_ev_labelsz00_bglt BgL_new1236z00_3949;
BgL_new1236z00_3949 = 
((BgL_ev_labelsz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_labelsz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 106 */
long BgL_arg1848z00_3950;
{ /* Eval/evaluate_types.scm 106 */
long BgL_res2344z00_3951;
BgL_res2344z00_3951 = 
BGL_CLASS_INDEX(BGl_ev_labelsz00zz__evaluate_typesz00); 
BgL_arg1848z00_3950 = BgL_res2344z00_3951; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1236z00_3949), BgL_arg1848z00_3950); } 
BgL_new1237z00_3948 = BgL_new1236z00_3949; } 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1237z00_3948))->BgL_varsz00)=((obj_t)BgL_vars1157z00_3517),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1237z00_3948))->BgL_valsz00)=((obj_t)BgL_vals1158z00_3518),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1237z00_3948))->BgL_envz00)=((obj_t)BgL_env1159z00_3519),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1237z00_3948))->BgL_stkz00)=((obj_t)BgL_stk1160z00_3520),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1237z00_3948))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1161z00_3521)),BUNSPEC); 
((((BgL_ev_labelsz00_bglt)COBJECT(BgL_new1237z00_3948))->BgL_boxesz00)=((obj_t)BgL_boxes1162z00_3522),BUNSPEC); 
return BgL_new1237z00_3948;} } 

}



/* &<@anonymous:1887> */
obj_t BGl_z62zc3z04anonymousza31887ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3523)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1886 */
obj_t BGl_z62lambda1886z62zz__evaluate_typesz00(obj_t BgL_envz00_3524, obj_t BgL_oz00_3525, obj_t BgL_vz00_3526)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3525)))->BgL_boxesz00)=((obj_t)BgL_vz00_3526),BUNSPEC);} 

}



/* &lambda1885 */
obj_t BGl_z62lambda1885z62zz__evaluate_typesz00(obj_t BgL_envz00_3527, obj_t BgL_oz00_3528)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3528)))->BgL_boxesz00);} 

}



/* &lambda1880 */
obj_t BGl_z62lambda1880z62zz__evaluate_typesz00(obj_t BgL_envz00_3529, obj_t BgL_oz00_3530, obj_t BgL_vz00_3531)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3530)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3531)),BUNSPEC);} 

}



/* &lambda1879 */
BgL_ev_exprz00_bglt BGl_z62lambda1879z62zz__evaluate_typesz00(obj_t BgL_envz00_3532, obj_t BgL_oz00_3533)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3533)))->BgL_bodyz00);} 

}



/* &<@anonymous:1875> */
obj_t BGl_z62zc3z04anonymousza31875ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3534)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1874 */
obj_t BGl_z62lambda1874z62zz__evaluate_typesz00(obj_t BgL_envz00_3535, obj_t BgL_oz00_3536, obj_t BgL_vz00_3537)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3536)))->BgL_stkz00)=((obj_t)BgL_vz00_3537),BUNSPEC);} 

}



/* &lambda1873 */
obj_t BGl_z62lambda1873z62zz__evaluate_typesz00(obj_t BgL_envz00_3538, obj_t BgL_oz00_3539)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3539)))->BgL_stkz00);} 

}



/* &<@anonymous:1868> */
obj_t BGl_z62zc3z04anonymousza31868ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3540)
{
{ /* Eval/evaluate_types.scm 106 */
return BNIL;} 

}



/* &lambda1867 */
obj_t BGl_z62lambda1867z62zz__evaluate_typesz00(obj_t BgL_envz00_3541, obj_t BgL_oz00_3542, obj_t BgL_vz00_3543)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3542)))->BgL_envz00)=((obj_t)BgL_vz00_3543),BUNSPEC);} 

}



/* &lambda1866 */
obj_t BGl_z62lambda1866z62zz__evaluate_typesz00(obj_t BgL_envz00_3544, obj_t BgL_oz00_3545)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3545)))->BgL_envz00);} 

}



/* &lambda1861 */
obj_t BGl_z62lambda1861z62zz__evaluate_typesz00(obj_t BgL_envz00_3546, obj_t BgL_oz00_3547, obj_t BgL_vz00_3548)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3547)))->BgL_valsz00)=((obj_t)BgL_vz00_3548),BUNSPEC);} 

}



/* &lambda1860 */
obj_t BGl_z62lambda1860z62zz__evaluate_typesz00(obj_t BgL_envz00_3549, obj_t BgL_oz00_3550)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3550)))->BgL_valsz00);} 

}



/* &lambda1856 */
obj_t BGl_z62lambda1856z62zz__evaluate_typesz00(obj_t BgL_envz00_3551, obj_t BgL_oz00_3552, obj_t BgL_vz00_3553)
{
{ /* Eval/evaluate_types.scm 106 */
return 
((((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3552)))->BgL_varsz00)=((obj_t)BgL_vz00_3553),BUNSPEC);} 

}



/* &lambda1855 */
obj_t BGl_z62lambda1855z62zz__evaluate_typesz00(obj_t BgL_envz00_3554, obj_t BgL_oz00_3555)
{
{ /* Eval/evaluate_types.scm 106 */
return 
(((BgL_ev_labelsz00_bglt)COBJECT(
((BgL_ev_labelsz00_bglt)BgL_oz00_3555)))->BgL_varsz00);} 

}



/* &<@anonymous:1841> */
obj_t BGl_z62zc3z04anonymousza31841ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3556, obj_t BgL_new1155z00_3557)
{
{ /* Eval/evaluate_types.scm 105 */
{ 
BgL_ev_letrecz00_bglt BgL_auxz00_4833;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1155z00_3557))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1155z00_3557))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4840;
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL_classz00_3966;
BgL_classz00_3966 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 105 */
obj_t BgL__ortest_1282z00_3967;
BgL__ortest_1282z00_3967 = 
BGL_CLASS_NIL(BgL_classz00_3966); 
if(
CBOOL(BgL__ortest_1282z00_3967))
{ /* Eval/evaluate_types.scm 105 */
BgL_auxz00_4840 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_3967)
; }  else 
{ /* Eval/evaluate_types.scm 105 */
BgL_auxz00_4840 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3966))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letrecz00_bglt)BgL_new1155z00_3557))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4840),BUNSPEC); } 
BgL_auxz00_4833 = 
((BgL_ev_letrecz00_bglt)BgL_new1155z00_3557); 
return 
((obj_t)BgL_auxz00_4833);} } 

}



/* &lambda1839 */
BgL_ev_letrecz00_bglt BGl_z62lambda1839z62zz__evaluate_typesz00(obj_t BgL_envz00_3558)
{
{ /* Eval/evaluate_types.scm 105 */
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1154z00_3968;
BgL_new1154z00_3968 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 105 */
long BgL_arg1840z00_3969;
{ /* Eval/evaluate_types.scm 105 */
long BgL_res2343z00_3970;
BgL_res2343z00_3970 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BgL_arg1840z00_3969 = BgL_res2343z00_3970; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1154z00_3968), BgL_arg1840z00_3969); } 
return BgL_new1154z00_3968;} } 

}



/* &lambda1837 */
BgL_ev_letrecz00_bglt BGl_z62lambda1837z62zz__evaluate_typesz00(obj_t BgL_envz00_3559, obj_t BgL_vars1151z00_3560, obj_t BgL_vals1152z00_3561, obj_t BgL_body1153z00_3562)
{
{ /* Eval/evaluate_types.scm 105 */
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1235z00_3972;
{ /* Eval/evaluate_types.scm 105 */
BgL_ev_letrecz00_bglt BgL_new1234z00_3973;
BgL_new1234z00_3973 = 
((BgL_ev_letrecz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letrecz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 105 */
long BgL_arg1838z00_3974;
{ /* Eval/evaluate_types.scm 105 */
long BgL_res2342z00_3975;
BgL_res2342z00_3975 = 
BGL_CLASS_INDEX(BGl_ev_letrecz00zz__evaluate_typesz00); 
BgL_arg1838z00_3974 = BgL_res2342z00_3975; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1234z00_3973), BgL_arg1838z00_3974); } 
BgL_new1235z00_3972 = BgL_new1234z00_3973; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1235z00_3972)))->BgL_varsz00)=((obj_t)BgL_vars1151z00_3560),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1235z00_3972)))->BgL_valsz00)=((obj_t)BgL_vals1152z00_3561),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1235z00_3972)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1153z00_3562)),BUNSPEC); 
return BgL_new1235z00_3972;} } 

}



/* &<@anonymous:1824> */
obj_t BGl_z62zc3z04anonymousza31824ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3563, obj_t BgL_new1149z00_3564)
{
{ /* Eval/evaluate_types.scm 103 */
{ 
BgL_ev_letza2za2_bglt BgL_auxz00_4867;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1149z00_3564))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1149z00_3564))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4874;
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL_classz00_3977;
BgL_classz00_3977 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 103 */
obj_t BgL__ortest_1282z00_3978;
BgL__ortest_1282z00_3978 = 
BGL_CLASS_NIL(BgL_classz00_3977); 
if(
CBOOL(BgL__ortest_1282z00_3978))
{ /* Eval/evaluate_types.scm 103 */
BgL_auxz00_4874 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_3978)
; }  else 
{ /* Eval/evaluate_types.scm 103 */
BgL_auxz00_4874 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3977))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letza2za2_bglt)BgL_new1149z00_3564))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4874),BUNSPEC); } 
((((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_new1149z00_3564)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4867 = 
((BgL_ev_letza2za2_bglt)BgL_new1149z00_3564); 
return 
((obj_t)BgL_auxz00_4867);} } 

}



/* &lambda1822 */
BgL_ev_letza2za2_bglt BGl_z62lambda1822z62zz__evaluate_typesz00(obj_t BgL_envz00_3565)
{
{ /* Eval/evaluate_types.scm 103 */
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1148z00_3979;
BgL_new1148z00_3979 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate_types.scm 103 */
long BgL_arg1823z00_3980;
{ /* Eval/evaluate_types.scm 103 */
long BgL_res2341z00_3981;
BgL_res2341z00_3981 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BgL_arg1823z00_3980 = BgL_res2341z00_3981; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1148z00_3979), BgL_arg1823z00_3980); } 
return BgL_new1148z00_3979;} } 

}



/* &lambda1820 */
BgL_ev_letza2za2_bglt BGl_z62lambda1820z62zz__evaluate_typesz00(obj_t BgL_envz00_3566, obj_t BgL_vars1144z00_3567, obj_t BgL_vals1145z00_3568, obj_t BgL_body1146z00_3569, obj_t BgL_boxes1147z00_3570)
{
{ /* Eval/evaluate_types.scm 103 */
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1233z00_3983;
{ /* Eval/evaluate_types.scm 103 */
BgL_ev_letza2za2_bglt BgL_new1232z00_3984;
BgL_new1232z00_3984 = 
((BgL_ev_letza2za2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letza2za2_bgl) ))); 
{ /* Eval/evaluate_types.scm 103 */
long BgL_arg1821z00_3985;
{ /* Eval/evaluate_types.scm 103 */
long BgL_res2340z00_3986;
BgL_res2340z00_3986 = 
BGL_CLASS_INDEX(BGl_ev_letza2za2zz__evaluate_typesz00); 
BgL_arg1821z00_3985 = BgL_res2340z00_3986; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1232z00_3984), BgL_arg1821z00_3985); } 
BgL_new1233z00_3983 = BgL_new1232z00_3984; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1233z00_3983)))->BgL_varsz00)=((obj_t)BgL_vars1144z00_3567),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1233z00_3983)))->BgL_valsz00)=((obj_t)BgL_vals1145z00_3568),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1233z00_3983)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1146z00_3569)),BUNSPEC); 
((((BgL_ev_letza2za2_bglt)COBJECT(BgL_new1233z00_3983))->BgL_boxesz00)=((obj_t)BgL_boxes1147z00_3570),BUNSPEC); 
return BgL_new1233z00_3983;} } 

}



/* &<@anonymous:1831> */
obj_t BGl_z62zc3z04anonymousza31831ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3571)
{
{ /* Eval/evaluate_types.scm 103 */
return BNIL;} 

}



/* &lambda1830 */
obj_t BGl_z62lambda1830z62zz__evaluate_typesz00(obj_t BgL_envz00_3572, obj_t BgL_oz00_3573, obj_t BgL_vz00_3574)
{
{ /* Eval/evaluate_types.scm 103 */
return 
((((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_oz00_3573)))->BgL_boxesz00)=((obj_t)BgL_vz00_3574),BUNSPEC);} 

}



/* &lambda1829 */
obj_t BGl_z62lambda1829z62zz__evaluate_typesz00(obj_t BgL_envz00_3575, obj_t BgL_oz00_3576)
{
{ /* Eval/evaluate_types.scm 103 */
return 
(((BgL_ev_letza2za2_bglt)COBJECT(
((BgL_ev_letza2za2_bglt)BgL_oz00_3576)))->BgL_boxesz00);} 

}



/* &<@anonymous:1807> */
obj_t BGl_z62zc3z04anonymousza31807ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3577, obj_t BgL_new1142z00_3578)
{
{ /* Eval/evaluate_types.scm 101 */
{ 
BgL_ev_letz00_bglt BgL_auxz00_4908;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1142z00_3578))))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1142z00_3578))))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4915;
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL_classz00_3990;
BgL_classz00_3990 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 101 */
obj_t BgL__ortest_1282z00_3991;
BgL__ortest_1282z00_3991 = 
BGL_CLASS_NIL(BgL_classz00_3990); 
if(
CBOOL(BgL__ortest_1282z00_3991))
{ /* Eval/evaluate_types.scm 101 */
BgL_auxz00_4915 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_3991)
; }  else 
{ /* Eval/evaluate_types.scm 101 */
BgL_auxz00_4915 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_3990))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)
((BgL_ev_letz00_bglt)BgL_new1142z00_3578))))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4915),BUNSPEC); } 
((((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_new1142z00_3578)))->BgL_boxesz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_4908 = 
((BgL_ev_letz00_bglt)BgL_new1142z00_3578); 
return 
((obj_t)BgL_auxz00_4908);} } 

}



/* &lambda1805 */
BgL_ev_letz00_bglt BGl_z62lambda1805z62zz__evaluate_typesz00(obj_t BgL_envz00_3579)
{
{ /* Eval/evaluate_types.scm 101 */
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1141z00_3992;
BgL_new1141z00_3992 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 101 */
long BgL_arg1806z00_3993;
{ /* Eval/evaluate_types.scm 101 */
long BgL_res2339z00_3994;
BgL_res2339z00_3994 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BgL_arg1806z00_3993 = BgL_res2339z00_3994; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1141z00_3992), BgL_arg1806z00_3993); } 
return BgL_new1141z00_3992;} } 

}



/* &lambda1803 */
BgL_ev_letz00_bglt BGl_z62lambda1803z62zz__evaluate_typesz00(obj_t BgL_envz00_3580, obj_t BgL_vars1137z00_3581, obj_t BgL_vals1138z00_3582, obj_t BgL_body1139z00_3583, obj_t BgL_boxes1140z00_3584)
{
{ /* Eval/evaluate_types.scm 101 */
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1231z00_3996;
{ /* Eval/evaluate_types.scm 101 */
BgL_ev_letz00_bglt BgL_new1230z00_3997;
BgL_new1230z00_3997 = 
((BgL_ev_letz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_letz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 101 */
long BgL_arg1804z00_3998;
{ /* Eval/evaluate_types.scm 101 */
long BgL_res2338z00_3999;
BgL_res2338z00_3999 = 
BGL_CLASS_INDEX(BGl_ev_letz00zz__evaluate_typesz00); 
BgL_arg1804z00_3998 = BgL_res2338z00_3999; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1230z00_3997), BgL_arg1804z00_3998); } 
BgL_new1231z00_3996 = BgL_new1230z00_3997; } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1231z00_3996)))->BgL_varsz00)=((obj_t)BgL_vars1137z00_3581),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1231z00_3996)))->BgL_valsz00)=((obj_t)BgL_vals1138z00_3582),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1231z00_3996)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1139z00_3583)),BUNSPEC); 
((((BgL_ev_letz00_bglt)COBJECT(BgL_new1231z00_3996))->BgL_boxesz00)=((obj_t)BgL_boxes1140z00_3584),BUNSPEC); 
return BgL_new1231z00_3996;} } 

}



/* &<@anonymous:1814> */
obj_t BGl_z62zc3z04anonymousza31814ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3585)
{
{ /* Eval/evaluate_types.scm 101 */
return BNIL;} 

}



/* &lambda1813 */
obj_t BGl_z62lambda1813z62zz__evaluate_typesz00(obj_t BgL_envz00_3586, obj_t BgL_oz00_3587, obj_t BgL_vz00_3588)
{
{ /* Eval/evaluate_types.scm 101 */
return 
((((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_oz00_3587)))->BgL_boxesz00)=((obj_t)BgL_vz00_3588),BUNSPEC);} 

}



/* &lambda1812 */
obj_t BGl_z62lambda1812z62zz__evaluate_typesz00(obj_t BgL_envz00_3589, obj_t BgL_oz00_3590)
{
{ /* Eval/evaluate_types.scm 101 */
return 
(((BgL_ev_letz00_bglt)COBJECT(
((BgL_ev_letz00_bglt)BgL_oz00_3590)))->BgL_boxesz00);} 

}



/* &<@anonymous:1782> */
obj_t BGl_z62zc3z04anonymousza31782ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3591, obj_t BgL_new1135z00_3592)
{
{ /* Eval/evaluate_types.scm 97 */
{ 
BgL_ev_binderz00_bglt BgL_auxz00_4949;
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1135z00_3592)))->BgL_varsz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1135z00_3592)))->BgL_valsz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4954;
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL_classz00_4003;
BgL_classz00_4003 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 97 */
obj_t BgL__ortest_1282z00_4004;
BgL__ortest_1282z00_4004 = 
BGL_CLASS_NIL(BgL_classz00_4003); 
if(
CBOOL(BgL__ortest_1282z00_4004))
{ /* Eval/evaluate_types.scm 97 */
BgL_auxz00_4954 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4004)
; }  else 
{ /* Eval/evaluate_types.scm 97 */
BgL_auxz00_4954 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4003))
; } } } 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_new1135z00_3592)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4954),BUNSPEC); } 
BgL_auxz00_4949 = 
((BgL_ev_binderz00_bglt)BgL_new1135z00_3592); 
return 
((obj_t)BgL_auxz00_4949);} } 

}



/* &lambda1780 */
BgL_ev_binderz00_bglt BGl_z62lambda1780z62zz__evaluate_typesz00(obj_t BgL_envz00_3593)
{
{ /* Eval/evaluate_types.scm 97 */
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1134z00_4005;
BgL_new1134z00_4005 = 
((BgL_ev_binderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_binderz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 97 */
long BgL_arg1781z00_4006;
{ /* Eval/evaluate_types.scm 97 */
long BgL_res2337z00_4007;
BgL_res2337z00_4007 = 
BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00); 
BgL_arg1781z00_4006 = BgL_res2337z00_4007; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1134z00_4005), BgL_arg1781z00_4006); } 
return BgL_new1134z00_4005;} } 

}



/* &lambda1778 */
BgL_ev_binderz00_bglt BGl_z62lambda1778z62zz__evaluate_typesz00(obj_t BgL_envz00_3594, obj_t BgL_vars1131z00_3595, obj_t BgL_vals1132z00_3596, obj_t BgL_body1133z00_3597)
{
{ /* Eval/evaluate_types.scm 97 */
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1229z00_4009;
{ /* Eval/evaluate_types.scm 97 */
BgL_ev_binderz00_bglt BgL_new1228z00_4010;
BgL_new1228z00_4010 = 
((BgL_ev_binderz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_binderz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 97 */
long BgL_arg1779z00_4011;
{ /* Eval/evaluate_types.scm 97 */
long BgL_res2336z00_4012;
BgL_res2336z00_4012 = 
BGL_CLASS_INDEX(BGl_ev_binderz00zz__evaluate_typesz00); 
BgL_arg1779z00_4011 = BgL_res2336z00_4012; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1228z00_4010), BgL_arg1779z00_4011); } 
BgL_new1229z00_4009 = BgL_new1228z00_4010; } 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1229z00_4009))->BgL_varsz00)=((obj_t)BgL_vars1131z00_3595),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1229z00_4009))->BgL_valsz00)=((obj_t)BgL_vals1132z00_3596),BUNSPEC); 
((((BgL_ev_binderz00_bglt)COBJECT(BgL_new1229z00_4009))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1133z00_3597)),BUNSPEC); 
return BgL_new1229z00_4009;} } 

}



/* &lambda1797 */
obj_t BGl_z62lambda1797z62zz__evaluate_typesz00(obj_t BgL_envz00_3598, obj_t BgL_oz00_3599, obj_t BgL_vz00_3600)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3599)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3600)),BUNSPEC);} 

}



/* &lambda1796 */
BgL_ev_exprz00_bglt BGl_z62lambda1796z62zz__evaluate_typesz00(obj_t BgL_envz00_3601, obj_t BgL_oz00_3602)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3602)))->BgL_bodyz00);} 

}



/* &lambda1792 */
obj_t BGl_z62lambda1792z62zz__evaluate_typesz00(obj_t BgL_envz00_3603, obj_t BgL_oz00_3604, obj_t BgL_vz00_3605)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3604)))->BgL_valsz00)=((obj_t)BgL_vz00_3605),BUNSPEC);} 

}



/* &lambda1791 */
obj_t BGl_z62lambda1791z62zz__evaluate_typesz00(obj_t BgL_envz00_3606, obj_t BgL_oz00_3607)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3607)))->BgL_valsz00);} 

}



/* &lambda1787 */
obj_t BGl_z62lambda1787z62zz__evaluate_typesz00(obj_t BgL_envz00_3608, obj_t BgL_oz00_3609, obj_t BgL_vz00_3610)
{
{ /* Eval/evaluate_types.scm 97 */
return 
((((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3609)))->BgL_varsz00)=((obj_t)BgL_vz00_3610),BUNSPEC);} 

}



/* &lambda1786 */
obj_t BGl_z62lambda1786z62zz__evaluate_typesz00(obj_t BgL_envz00_3611, obj_t BgL_oz00_3612)
{
{ /* Eval/evaluate_types.scm 97 */
return 
(((BgL_ev_binderz00_bglt)COBJECT(
((BgL_ev_binderz00_bglt)BgL_oz00_3612)))->BgL_varsz00);} 

}



/* &<@anonymous:1752> */
obj_t BGl_z62zc3z04anonymousza31752ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3613, obj_t BgL_new1129z00_3614)
{
{ /* Eval/evaluate_types.scm 92 */
{ 
BgL_ev_synchroniza7eza7_bglt BgL_auxz00_4990;
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1129z00_3614)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_4993;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4021;
BgL_classz00_4021 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1282z00_4022;
BgL__ortest_1282z00_4022 = 
BGL_CLASS_NIL(BgL_classz00_4021); 
if(
CBOOL(BgL__ortest_1282z00_4022))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4993 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4022)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_4993 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4021))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1129z00_3614)))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_4993),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5002;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4023;
BgL_classz00_4023 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1282z00_4024;
BgL__ortest_1282z00_4024 = 
BGL_CLASS_NIL(BgL_classz00_4023); 
if(
CBOOL(BgL__ortest_1282z00_4024))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_5002 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4024)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_5002 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4023))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1129z00_3614)))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5002),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5011;
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL_classz00_4025;
BgL_classz00_4025 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 92 */
obj_t BgL__ortest_1282z00_4026;
BgL__ortest_1282z00_4026 = 
BGL_CLASS_NIL(BgL_classz00_4025); 
if(
CBOOL(BgL__ortest_1282z00_4026))
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_5011 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4026)
; }  else 
{ /* Eval/evaluate_types.scm 92 */
BgL_auxz00_5011 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4025))
; } } } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_new1129z00_3614)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5011),BUNSPEC); } 
BgL_auxz00_4990 = 
((BgL_ev_synchroniza7eza7_bglt)BgL_new1129z00_3614); 
return 
((obj_t)BgL_auxz00_4990);} } 

}



/* &lambda1750 */
BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1750z62zz__evaluate_typesz00(obj_t BgL_envz00_3615)
{
{ /* Eval/evaluate_types.scm 92 */
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1128z00_4027;
BgL_new1128z00_4027 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate_types.scm 92 */
long BgL_arg1751z00_4028;
{ /* Eval/evaluate_types.scm 92 */
long BgL_res2335z00_4029;
BgL_res2335z00_4029 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg1751z00_4028 = BgL_res2335z00_4029; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1128z00_4027), BgL_arg1751z00_4028); } 
return BgL_new1128z00_4027;} } 

}



/* &lambda1748 */
BgL_ev_synchroniza7eza7_bglt BGl_z62lambda1748z62zz__evaluate_typesz00(obj_t BgL_envz00_3616, obj_t BgL_loc1124z00_3617, obj_t BgL_mutex1125z00_3618, obj_t BgL_prelock1126z00_3619, obj_t BgL_body1127z00_3620)
{
{ /* Eval/evaluate_types.scm 92 */
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1227z00_4033;
{ /* Eval/evaluate_types.scm 92 */
BgL_ev_synchroniza7eza7_bglt BgL_new1226z00_4034;
BgL_new1226z00_4034 = 
((BgL_ev_synchroniza7eza7_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_synchroniza7eza7_bgl) ))); 
{ /* Eval/evaluate_types.scm 92 */
long BgL_arg1749z00_4035;
{ /* Eval/evaluate_types.scm 92 */
long BgL_res2334z00_4036;
BgL_res2334z00_4036 = 
BGL_CLASS_INDEX(BGl_ev_synchroniza7eza7zz__evaluate_typesz00); 
BgL_arg1749z00_4035 = BgL_res2334z00_4036; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1226z00_4034), BgL_arg1749z00_4035); } 
BgL_new1227z00_4033 = BgL_new1226z00_4034; } 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1227z00_4033))->BgL_locz00)=((obj_t)BgL_loc1124z00_3617),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1227z00_4033))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_mutex1125z00_3618)),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1227z00_4033))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_prelock1126z00_3619)),BUNSPEC); 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(BgL_new1227z00_4033))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1127z00_3620)),BUNSPEC); 
return BgL_new1227z00_4033;} } 

}



/* &lambda1772 */
obj_t BGl_z62lambda1772z62zz__evaluate_typesz00(obj_t BgL_envz00_3621, obj_t BgL_oz00_3622, obj_t BgL_vz00_3623)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3622)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3623)),BUNSPEC);} 

}



/* &lambda1771 */
BgL_ev_exprz00_bglt BGl_z62lambda1771z62zz__evaluate_typesz00(obj_t BgL_envz00_3624, obj_t BgL_oz00_3625)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3625)))->BgL_bodyz00);} 

}



/* &lambda1767 */
obj_t BGl_z62lambda1767z62zz__evaluate_typesz00(obj_t BgL_envz00_3626, obj_t BgL_oz00_3627, obj_t BgL_vz00_3628)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3627)))->BgL_prelockz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3628)),BUNSPEC);} 

}



/* &lambda1766 */
BgL_ev_exprz00_bglt BGl_z62lambda1766z62zz__evaluate_typesz00(obj_t BgL_envz00_3629, obj_t BgL_oz00_3630)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3630)))->BgL_prelockz00);} 

}



/* &lambda1762 */
obj_t BGl_z62lambda1762z62zz__evaluate_typesz00(obj_t BgL_envz00_3631, obj_t BgL_oz00_3632, obj_t BgL_vz00_3633)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3632)))->BgL_mutexz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3633)),BUNSPEC);} 

}



/* &lambda1761 */
BgL_ev_exprz00_bglt BGl_z62lambda1761z62zz__evaluate_typesz00(obj_t BgL_envz00_3634, obj_t BgL_oz00_3635)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3635)))->BgL_mutexz00);} 

}



/* &lambda1757 */
obj_t BGl_z62lambda1757z62zz__evaluate_typesz00(obj_t BgL_envz00_3636, obj_t BgL_oz00_3637, obj_t BgL_vz00_3638)
{
{ /* Eval/evaluate_types.scm 92 */
return 
((((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3637)))->BgL_locz00)=((obj_t)BgL_vz00_3638),BUNSPEC);} 

}



/* &lambda1756 */
obj_t BGl_z62lambda1756z62zz__evaluate_typesz00(obj_t BgL_envz00_3639, obj_t BgL_oz00_3640)
{
{ /* Eval/evaluate_types.scm 92 */
return 
(((BgL_ev_synchroniza7eza7_bglt)COBJECT(
((BgL_ev_synchroniza7eza7_bglt)BgL_oz00_3640)))->BgL_locz00);} 

}



/* &<@anonymous:1732> */
obj_t BGl_z62zc3z04anonymousza31732ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3641, obj_t BgL_new1122z00_3642)
{
{ /* Eval/evaluate_types.scm 89 */
{ 
BgL_ev_withzd2handlerzd2_bglt BgL_auxz00_5056;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5057;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_classz00_4049;
BgL_classz00_4049 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL__ortest_1282z00_4050;
BgL__ortest_1282z00_4050 = 
BGL_CLASS_NIL(BgL_classz00_4049); 
if(
CBOOL(BgL__ortest_1282z00_4050))
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5057 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4050)
; }  else 
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5057 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4049))
; } } } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1122z00_3642)))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5057),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5066;
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL_classz00_4051;
BgL_classz00_4051 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 89 */
obj_t BgL__ortest_1282z00_4052;
BgL__ortest_1282z00_4052 = 
BGL_CLASS_NIL(BgL_classz00_4051); 
if(
CBOOL(BgL__ortest_1282z00_4052))
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5066 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4052)
; }  else 
{ /* Eval/evaluate_types.scm 89 */
BgL_auxz00_5066 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4051))
; } } } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1122z00_3642)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5066),BUNSPEC); } 
BgL_auxz00_5056 = 
((BgL_ev_withzd2handlerzd2_bglt)BgL_new1122z00_3642); 
return 
((obj_t)BgL_auxz00_5056);} } 

}



/* &lambda1730 */
BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1730z62zz__evaluate_typesz00(obj_t BgL_envz00_3643)
{
{ /* Eval/evaluate_types.scm 89 */
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1121z00_4053;
BgL_new1121z00_4053 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 89 */
long BgL_arg1731z00_4054;
{ /* Eval/evaluate_types.scm 89 */
long BgL_res2333z00_4055;
BgL_res2333z00_4055 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BgL_arg1731z00_4054 = BgL_res2333z00_4055; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1121z00_4053), BgL_arg1731z00_4054); } 
return BgL_new1121z00_4053;} } 

}



/* &lambda1728 */
BgL_ev_withzd2handlerzd2_bglt BGl_z62lambda1728z62zz__evaluate_typesz00(obj_t BgL_envz00_3644, obj_t BgL_handler1119z00_3645, obj_t BgL_body1120z00_3646)
{
{ /* Eval/evaluate_types.scm 89 */
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1225z00_4058;
{ /* Eval/evaluate_types.scm 89 */
BgL_ev_withzd2handlerzd2_bglt BgL_new1224z00_4059;
BgL_new1224z00_4059 = 
((BgL_ev_withzd2handlerzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_withzd2handlerzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 89 */
long BgL_arg1729z00_4060;
{ /* Eval/evaluate_types.scm 89 */
long BgL_res2332z00_4061;
BgL_res2332z00_4061 = 
BGL_CLASS_INDEX(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00); 
BgL_arg1729z00_4060 = BgL_res2332z00_4061; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1224z00_4059), BgL_arg1729z00_4060); } 
BgL_new1225z00_4058 = BgL_new1224z00_4059; } 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1225z00_4058))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_handler1119z00_3645)),BUNSPEC); 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(BgL_new1225z00_4058))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1120z00_3646)),BUNSPEC); 
return BgL_new1225z00_4058;} } 

}



/* &lambda1742 */
obj_t BGl_z62lambda1742z62zz__evaluate_typesz00(obj_t BgL_envz00_3647, obj_t BgL_oz00_3648, obj_t BgL_vz00_3649)
{
{ /* Eval/evaluate_types.scm 89 */
return 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3648)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3649)),BUNSPEC);} 

}



/* &lambda1741 */
BgL_ev_exprz00_bglt BGl_z62lambda1741z62zz__evaluate_typesz00(obj_t BgL_envz00_3650, obj_t BgL_oz00_3651)
{
{ /* Eval/evaluate_types.scm 89 */
return 
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3651)))->BgL_bodyz00);} 

}



/* &lambda1737 */
obj_t BGl_z62lambda1737z62zz__evaluate_typesz00(obj_t BgL_envz00_3652, obj_t BgL_oz00_3653, obj_t BgL_vz00_3654)
{
{ /* Eval/evaluate_types.scm 89 */
return 
((((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3653)))->BgL_handlerz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3654)),BUNSPEC);} 

}



/* &lambda1736 */
BgL_ev_exprz00_bglt BGl_z62lambda1736z62zz__evaluate_typesz00(obj_t BgL_envz00_3655, obj_t BgL_oz00_3656)
{
{ /* Eval/evaluate_types.scm 89 */
return 
(((BgL_ev_withzd2handlerzd2_bglt)COBJECT(
((BgL_ev_withzd2handlerzd2_bglt)BgL_oz00_3656)))->BgL_handlerz00);} 

}



/* &<@anonymous:1712> */
obj_t BGl_z62zc3z04anonymousza31712ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3657, obj_t BgL_new1117z00_3658)
{
{ /* Eval/evaluate_types.scm 86 */
{ 
BgL_ev_unwindzd2protectzd2_bglt BgL_auxz00_5099;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5100;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_classz00_4069;
BgL_classz00_4069 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL__ortest_1282z00_4070;
BgL__ortest_1282z00_4070 = 
BGL_CLASS_NIL(BgL_classz00_4069); 
if(
CBOOL(BgL__ortest_1282z00_4070))
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5100 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4070)
; }  else 
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5100 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4069))
; } } } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1117z00_3658)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5100),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5109;
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL_classz00_4071;
BgL_classz00_4071 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 86 */
obj_t BgL__ortest_1282z00_4072;
BgL__ortest_1282z00_4072 = 
BGL_CLASS_NIL(BgL_classz00_4071); 
if(
CBOOL(BgL__ortest_1282z00_4072))
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5109 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4072)
; }  else 
{ /* Eval/evaluate_types.scm 86 */
BgL_auxz00_5109 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4071))
; } } } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1117z00_3658)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5109),BUNSPEC); } 
BgL_auxz00_5099 = 
((BgL_ev_unwindzd2protectzd2_bglt)BgL_new1117z00_3658); 
return 
((obj_t)BgL_auxz00_5099);} } 

}



/* &lambda1710 */
BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1710z62zz__evaluate_typesz00(obj_t BgL_envz00_3659)
{
{ /* Eval/evaluate_types.scm 86 */
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1116z00_4073;
BgL_new1116z00_4073 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 86 */
long BgL_arg1711z00_4074;
{ /* Eval/evaluate_types.scm 86 */
long BgL_res2331z00_4075;
BgL_res2331z00_4075 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BgL_arg1711z00_4074 = BgL_res2331z00_4075; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1116z00_4073), BgL_arg1711z00_4074); } 
return BgL_new1116z00_4073;} } 

}



/* &lambda1708 */
BgL_ev_unwindzd2protectzd2_bglt BGl_z62lambda1708z62zz__evaluate_typesz00(obj_t BgL_envz00_3660, obj_t BgL_e1114z00_3661, obj_t BgL_body1115z00_3662)
{
{ /* Eval/evaluate_types.scm 86 */
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1223z00_4078;
{ /* Eval/evaluate_types.scm 86 */
BgL_ev_unwindzd2protectzd2_bglt BgL_new1222z00_4079;
BgL_new1222z00_4079 = 
((BgL_ev_unwindzd2protectzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_unwindzd2protectzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 86 */
long BgL_arg1709z00_4080;
{ /* Eval/evaluate_types.scm 86 */
long BgL_res2330z00_4081;
BgL_res2330z00_4081 = 
BGL_CLASS_INDEX(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00); 
BgL_arg1709z00_4080 = BgL_res2330z00_4081; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1222z00_4079), BgL_arg1709z00_4080); } 
BgL_new1223z00_4078 = BgL_new1222z00_4079; } 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1223z00_4078))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1114z00_3661)),BUNSPEC); 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(BgL_new1223z00_4078))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1115z00_3662)),BUNSPEC); 
return BgL_new1223z00_4078;} } 

}



/* &lambda1722 */
obj_t BGl_z62lambda1722z62zz__evaluate_typesz00(obj_t BgL_envz00_3663, obj_t BgL_oz00_3664, obj_t BgL_vz00_3665)
{
{ /* Eval/evaluate_types.scm 86 */
return 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3664)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3665)),BUNSPEC);} 

}



/* &lambda1721 */
BgL_ev_exprz00_bglt BGl_z62lambda1721z62zz__evaluate_typesz00(obj_t BgL_envz00_3666, obj_t BgL_oz00_3667)
{
{ /* Eval/evaluate_types.scm 86 */
return 
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3667)))->BgL_bodyz00);} 

}



/* &lambda1717 */
obj_t BGl_z62lambda1717z62zz__evaluate_typesz00(obj_t BgL_envz00_3668, obj_t BgL_oz00_3669, obj_t BgL_vz00_3670)
{
{ /* Eval/evaluate_types.scm 86 */
return 
((((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3669)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3670)),BUNSPEC);} 

}



/* &lambda1716 */
BgL_ev_exprz00_bglt BGl_z62lambda1716z62zz__evaluate_typesz00(obj_t BgL_envz00_3671, obj_t BgL_oz00_3672)
{
{ /* Eval/evaluate_types.scm 86 */
return 
(((BgL_ev_unwindzd2protectzd2_bglt)COBJECT(
((BgL_ev_unwindzd2protectzd2_bglt)BgL_oz00_3672)))->BgL_ez00);} 

}



/* &<@anonymous:1689> */
obj_t BGl_z62zc3z04anonymousza31689ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3673, obj_t BgL_new1112z00_3674)
{
{ /* Eval/evaluate_types.scm 83 */
{ 
BgL_ev_bindzd2exitzd2_bglt BgL_auxz00_5142;
{ 
BgL_ev_varz00_bglt BgL_auxz00_5143;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_classz00_4089;
BgL_classz00_4089 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL__ortest_1282z00_4090;
BgL__ortest_1282z00_4090 = 
BGL_CLASS_NIL(BgL_classz00_4089); 
if(
CBOOL(BgL__ortest_1282z00_4090))
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5143 = 
((BgL_ev_varz00_bglt)BgL__ortest_1282z00_4090)
; }  else 
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5143 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4089))
; } } } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1112z00_3674)))->BgL_varz00)=((BgL_ev_varz00_bglt)BgL_auxz00_5143),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5152;
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL_classz00_4091;
BgL_classz00_4091 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 83 */
obj_t BgL__ortest_1282z00_4092;
BgL__ortest_1282z00_4092 = 
BGL_CLASS_NIL(BgL_classz00_4091); 
if(
CBOOL(BgL__ortest_1282z00_4092))
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5152 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4092)
; }  else 
{ /* Eval/evaluate_types.scm 83 */
BgL_auxz00_5152 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4091))
; } } } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1112z00_3674)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5152),BUNSPEC); } 
BgL_auxz00_5142 = 
((BgL_ev_bindzd2exitzd2_bglt)BgL_new1112z00_3674); 
return 
((obj_t)BgL_auxz00_5142);} } 

}



/* &lambda1687 */
BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1687z62zz__evaluate_typesz00(obj_t BgL_envz00_3675)
{
{ /* Eval/evaluate_types.scm 83 */
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1111z00_4093;
BgL_new1111z00_4093 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 83 */
long BgL_arg1688z00_4094;
{ /* Eval/evaluate_types.scm 83 */
long BgL_res2329z00_4095;
BgL_res2329z00_4095 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BgL_arg1688z00_4094 = BgL_res2329z00_4095; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1111z00_4093), BgL_arg1688z00_4094); } 
return BgL_new1111z00_4093;} } 

}



/* &lambda1685 */
BgL_ev_bindzd2exitzd2_bglt BGl_z62lambda1685z62zz__evaluate_typesz00(obj_t BgL_envz00_3676, obj_t BgL_var1109z00_3677, obj_t BgL_body1110z00_3678)
{
{ /* Eval/evaluate_types.scm 83 */
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1221z00_4098;
{ /* Eval/evaluate_types.scm 83 */
BgL_ev_bindzd2exitzd2_bglt BgL_new1220z00_4099;
BgL_new1220z00_4099 = 
((BgL_ev_bindzd2exitzd2_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_bindzd2exitzd2_bgl) ))); 
{ /* Eval/evaluate_types.scm 83 */
long BgL_arg1686z00_4100;
{ /* Eval/evaluate_types.scm 83 */
long BgL_res2328z00_4101;
BgL_res2328z00_4101 = 
BGL_CLASS_INDEX(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00); 
BgL_arg1686z00_4100 = BgL_res2328z00_4101; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1220z00_4099), BgL_arg1686z00_4100); } 
BgL_new1221z00_4098 = BgL_new1220z00_4099; } 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1221z00_4098))->BgL_varz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_var1109z00_3677)),BUNSPEC); 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(BgL_new1221z00_4098))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_body1110z00_3678)),BUNSPEC); 
return BgL_new1221z00_4098;} } 

}



/* &lambda1702 */
obj_t BGl_z62lambda1702z62zz__evaluate_typesz00(obj_t BgL_envz00_3679, obj_t BgL_oz00_3680, obj_t BgL_vz00_3681)
{
{ /* Eval/evaluate_types.scm 83 */
return 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3680)))->BgL_bodyz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3681)),BUNSPEC);} 

}



/* &lambda1701 */
BgL_ev_exprz00_bglt BGl_z62lambda1701z62zz__evaluate_typesz00(obj_t BgL_envz00_3682, obj_t BgL_oz00_3683)
{
{ /* Eval/evaluate_types.scm 83 */
return 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3683)))->BgL_bodyz00);} 

}



/* &lambda1695 */
obj_t BGl_z62lambda1695z62zz__evaluate_typesz00(obj_t BgL_envz00_3684, obj_t BgL_oz00_3685, obj_t BgL_vz00_3686)
{
{ /* Eval/evaluate_types.scm 83 */
return 
((((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3685)))->BgL_varz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3686)),BUNSPEC);} 

}



/* &lambda1694 */
BgL_ev_varz00_bglt BGl_z62lambda1694z62zz__evaluate_typesz00(obj_t BgL_envz00_3687, obj_t BgL_oz00_3688)
{
{ /* Eval/evaluate_types.scm 83 */
return 
(((BgL_ev_bindzd2exitzd2_bglt)COBJECT(
((BgL_ev_bindzd2exitzd2_bglt)BgL_oz00_3688)))->BgL_varz00);} 

}



/* &<@anonymous:1678> */
obj_t BGl_z62zc3z04anonymousza31678ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3689, obj_t BgL_new1107z00_3690)
{
{ /* Eval/evaluate_types.scm 82 */
{ 
BgL_ev_defglobalz00_bglt BgL_auxz00_5185;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5186;
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL_classz00_4109;
BgL_classz00_4109 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 82 */
obj_t BgL__ortest_1282z00_4110;
BgL__ortest_1282z00_4110 = 
BGL_CLASS_NIL(BgL_classz00_4109); 
if(
CBOOL(BgL__ortest_1282z00_4110))
{ /* Eval/evaluate_types.scm 82 */
BgL_auxz00_5186 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4110)
; }  else 
{ /* Eval/evaluate_types.scm 82 */
BgL_auxz00_5186 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4109))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1107z00_3690))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5186),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1107z00_3690))))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1107z00_3690))))->BgL_namez00)=((obj_t)BGl_symbol2731z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)
((BgL_ev_defglobalz00_bglt)BgL_new1107z00_3690))))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5185 = 
((BgL_ev_defglobalz00_bglt)BgL_new1107z00_3690); 
return 
((obj_t)BgL_auxz00_5185);} } 

}



/* &lambda1676 */
BgL_ev_defglobalz00_bglt BGl_z62lambda1676z62zz__evaluate_typesz00(obj_t BgL_envz00_3691)
{
{ /* Eval/evaluate_types.scm 82 */
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1106z00_4111;
BgL_new1106z00_4111 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 82 */
long BgL_arg1677z00_4112;
{ /* Eval/evaluate_types.scm 82 */
long BgL_res2327z00_4113;
BgL_res2327z00_4113 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg1677z00_4112 = BgL_res2327z00_4113; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1106z00_4111), BgL_arg1677z00_4112); } 
return BgL_new1106z00_4111;} } 

}



/* &lambda1672 */
BgL_ev_defglobalz00_bglt BGl_z62lambda1672z62zz__evaluate_typesz00(obj_t BgL_envz00_3692, obj_t BgL_e1101z00_3693, obj_t BgL_loc1102z00_3694, obj_t BgL_name1103z00_3695, obj_t BgL_mod1104z00_3696)
{
{ /* Eval/evaluate_types.scm 82 */
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1219z00_4116;
{ /* Eval/evaluate_types.scm 82 */
BgL_ev_defglobalz00_bglt BgL_new1218z00_4117;
BgL_new1218z00_4117 = 
((BgL_ev_defglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_defglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 82 */
long BgL_arg1675z00_4118;
{ /* Eval/evaluate_types.scm 82 */
long BgL_res2326z00_4119;
BgL_res2326z00_4119 = 
BGL_CLASS_INDEX(BGl_ev_defglobalz00zz__evaluate_typesz00); 
BgL_arg1675z00_4118 = BgL_res2326z00_4119; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1218z00_4117), BgL_arg1675z00_4118); } 
BgL_new1219z00_4116 = BgL_new1218z00_4117; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1219z00_4116)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1101z00_3693)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1219z00_4116)))->BgL_locz00)=((obj_t)BgL_loc1102z00_3694),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1219z00_4116)))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1103z00_3695)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1219z00_4116)))->BgL_modz00)=((obj_t)BgL_mod1104z00_3696),BUNSPEC); 
return BgL_new1219z00_4116;} } 

}



/* &<@anonymous:1648> */
obj_t BGl_z62zc3z04anonymousza31648ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3697, obj_t BgL_new1099z00_3698)
{
{ /* Eval/evaluate_types.scm 78 */
{ 
BgL_ev_setglobalz00_bglt BgL_auxz00_5225;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5226;
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL_classz00_4121;
BgL_classz00_4121 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 78 */
obj_t BgL__ortest_1282z00_4122;
BgL__ortest_1282z00_4122 = 
BGL_CLASS_NIL(BgL_classz00_4121); 
if(
CBOOL(BgL__ortest_1282z00_4122))
{ /* Eval/evaluate_types.scm 78 */
BgL_auxz00_5226 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4122)
; }  else 
{ /* Eval/evaluate_types.scm 78 */
BgL_auxz00_5226 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4121))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3698))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5226),BUNSPEC); } 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3698)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3698)))->BgL_namez00)=((obj_t)BGl_symbol2731z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3698)))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5225 = 
((BgL_ev_setglobalz00_bglt)BgL_new1099z00_3698); 
return 
((obj_t)BgL_auxz00_5225);} } 

}



/* &lambda1645 */
BgL_ev_setglobalz00_bglt BGl_z62lambda1645z62zz__evaluate_typesz00(obj_t BgL_envz00_3699)
{
{ /* Eval/evaluate_types.scm 78 */
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1098z00_4123;
BgL_new1098z00_4123 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 78 */
long BgL_arg1647z00_4124;
{ /* Eval/evaluate_types.scm 78 */
long BgL_res2325z00_4125;
BgL_res2325z00_4125 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg1647z00_4124 = BgL_res2325z00_4125; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1098z00_4123), BgL_arg1647z00_4124); } 
return BgL_new1098z00_4123;} } 

}



/* &lambda1643 */
BgL_ev_setglobalz00_bglt BGl_z62lambda1643z62zz__evaluate_typesz00(obj_t BgL_envz00_3700, obj_t BgL_e1094z00_3701, obj_t BgL_loc1095z00_3702, obj_t BgL_name1096z00_3703, obj_t BgL_mod1097z00_3704)
{
{ /* Eval/evaluate_types.scm 78 */
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1217z00_4128;
{ /* Eval/evaluate_types.scm 78 */
BgL_ev_setglobalz00_bglt BgL_new1216z00_4129;
BgL_new1216z00_4129 = 
((BgL_ev_setglobalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setglobalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 78 */
long BgL_arg1644z00_4130;
{ /* Eval/evaluate_types.scm 78 */
long BgL_res2324z00_4131;
BgL_res2324z00_4131 = 
BGL_CLASS_INDEX(BGl_ev_setglobalz00zz__evaluate_typesz00); 
BgL_arg1644z00_4130 = BgL_res2324z00_4131; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1216z00_4129), BgL_arg1644z00_4130); } 
BgL_new1217z00_4128 = BgL_new1216z00_4129; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1217z00_4128)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1094z00_3701)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1217z00_4128))->BgL_locz00)=((obj_t)BgL_loc1095z00_3702),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1217z00_4128))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1096z00_3703)),BUNSPEC); 
((((BgL_ev_setglobalz00_bglt)COBJECT(BgL_new1217z00_4128))->BgL_modz00)=((obj_t)BgL_mod1097z00_3704),BUNSPEC); 
return BgL_new1217z00_4128;} } 

}



/* &lambda1665 */
obj_t BGl_z62lambda1665z62zz__evaluate_typesz00(obj_t BgL_envz00_3705, obj_t BgL_oz00_3706, obj_t BgL_vz00_3707)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3706)))->BgL_modz00)=((obj_t)BgL_vz00_3707),BUNSPEC);} 

}



/* &lambda1664 */
obj_t BGl_z62lambda1664z62zz__evaluate_typesz00(obj_t BgL_envz00_3708, obj_t BgL_oz00_3709)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3709)))->BgL_modz00);} 

}



/* &lambda1659 */
obj_t BGl_z62lambda1659z62zz__evaluate_typesz00(obj_t BgL_envz00_3710, obj_t BgL_oz00_3711, obj_t BgL_vz00_3712)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3711)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3712)),BUNSPEC);} 

}



/* &lambda1658 */
obj_t BGl_z62lambda1658z62zz__evaluate_typesz00(obj_t BgL_envz00_3713, obj_t BgL_oz00_3714)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3714)))->BgL_namez00);} 

}



/* &lambda1654 */
obj_t BGl_z62lambda1654z62zz__evaluate_typesz00(obj_t BgL_envz00_3715, obj_t BgL_oz00_3716, obj_t BgL_vz00_3717)
{
{ /* Eval/evaluate_types.scm 78 */
return 
((((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3716)))->BgL_locz00)=((obj_t)BgL_vz00_3717),BUNSPEC);} 

}



/* &lambda1653 */
obj_t BGl_z62lambda1653z62zz__evaluate_typesz00(obj_t BgL_envz00_3718, obj_t BgL_oz00_3719)
{
{ /* Eval/evaluate_types.scm 78 */
return 
(((BgL_ev_setglobalz00_bglt)COBJECT(
((BgL_ev_setglobalz00_bglt)BgL_oz00_3719)))->BgL_locz00);} 

}



/* &<@anonymous:1632> */
obj_t BGl_z62zc3z04anonymousza31632ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3720, obj_t BgL_new1092z00_3721)
{
{ /* Eval/evaluate_types.scm 76 */
{ 
BgL_ev_setlocalz00_bglt BgL_auxz00_5272;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5273;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_classz00_4140;
BgL_classz00_4140 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL__ortest_1282z00_4141;
BgL__ortest_1282z00_4141 = 
BGL_CLASS_NIL(BgL_classz00_4140); 
if(
CBOOL(BgL__ortest_1282z00_4141))
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5273 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4141)
; }  else 
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5273 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4140))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3721))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5273),BUNSPEC); } 
{ 
BgL_ev_varz00_bglt BgL_auxz00_5283;
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL_classz00_4142;
BgL_classz00_4142 = BGl_ev_varz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 76 */
obj_t BgL__ortest_1282z00_4143;
BgL__ortest_1282z00_4143 = 
BGL_CLASS_NIL(BgL_classz00_4142); 
if(
CBOOL(BgL__ortest_1282z00_4143))
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5283 = 
((BgL_ev_varz00_bglt)BgL__ortest_1282z00_4143)
; }  else 
{ /* Eval/evaluate_types.scm 76 */
BgL_auxz00_5283 = 
((BgL_ev_varz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4142))
; } } } 
((((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3721)))->BgL_vz00)=((BgL_ev_varz00_bglt)BgL_auxz00_5283),BUNSPEC); } 
BgL_auxz00_5272 = 
((BgL_ev_setlocalz00_bglt)BgL_new1092z00_3721); 
return 
((obj_t)BgL_auxz00_5272);} } 

}



/* &lambda1630 */
BgL_ev_setlocalz00_bglt BGl_z62lambda1630z62zz__evaluate_typesz00(obj_t BgL_envz00_3722)
{
{ /* Eval/evaluate_types.scm 76 */
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1091z00_4144;
BgL_new1091z00_4144 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 76 */
long BgL_arg1631z00_4145;
{ /* Eval/evaluate_types.scm 76 */
long BgL_res2323z00_4146;
BgL_res2323z00_4146 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BgL_arg1631z00_4145 = BgL_res2323z00_4146; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1091z00_4144), BgL_arg1631z00_4145); } 
return BgL_new1091z00_4144;} } 

}



/* &lambda1628 */
BgL_ev_setlocalz00_bglt BGl_z62lambda1628z62zz__evaluate_typesz00(obj_t BgL_envz00_3723, obj_t BgL_e1089z00_3724, obj_t BgL_v1090z00_3725)
{
{ /* Eval/evaluate_types.scm 76 */
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1215z00_4149;
{ /* Eval/evaluate_types.scm 76 */
BgL_ev_setlocalz00_bglt BgL_new1214z00_4150;
BgL_new1214z00_4150 = 
((BgL_ev_setlocalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_setlocalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 76 */
long BgL_arg1629z00_4151;
{ /* Eval/evaluate_types.scm 76 */
long BgL_res2322z00_4152;
BgL_res2322z00_4152 = 
BGL_CLASS_INDEX(BGl_ev_setlocalz00zz__evaluate_typesz00); 
BgL_arg1629z00_4151 = BgL_res2322z00_4152; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1214z00_4150), BgL_arg1629z00_4151); } 
BgL_new1215z00_4149 = BgL_new1214z00_4150; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1215z00_4149)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1089z00_3724)),BUNSPEC); 
((((BgL_ev_setlocalz00_bglt)COBJECT(BgL_new1215z00_4149))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_v1090z00_3725)),BUNSPEC); 
return BgL_new1215z00_4149;} } 

}



/* &lambda1637 */
obj_t BGl_z62lambda1637z62zz__evaluate_typesz00(obj_t BgL_envz00_3726, obj_t BgL_oz00_3727, obj_t BgL_vz00_3728)
{
{ /* Eval/evaluate_types.scm 76 */
return 
((((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_oz00_3727)))->BgL_vz00)=((BgL_ev_varz00_bglt)
((BgL_ev_varz00_bglt)BgL_vz00_3728)),BUNSPEC);} 

}



/* &lambda1636 */
BgL_ev_varz00_bglt BGl_z62lambda1636z62zz__evaluate_typesz00(obj_t BgL_envz00_3729, obj_t BgL_oz00_3730)
{
{ /* Eval/evaluate_types.scm 76 */
return 
(((BgL_ev_setlocalz00_bglt)COBJECT(
((BgL_ev_setlocalz00_bglt)BgL_oz00_3730)))->BgL_vz00);} 

}



/* &<@anonymous:1622> */
obj_t BGl_z62zc3z04anonymousza31622ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3731, obj_t BgL_new1087z00_3732)
{
{ /* Eval/evaluate_types.scm 75 */
{ 
BgL_ev_trapz00_bglt BgL_auxz00_5312;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5313;
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL_classz00_4157;
BgL_classz00_4157 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 75 */
obj_t BgL__ortest_1282z00_4158;
BgL__ortest_1282z00_4158 = 
BGL_CLASS_NIL(BgL_classz00_4157); 
if(
CBOOL(BgL__ortest_1282z00_4158))
{ /* Eval/evaluate_types.scm 75 */
BgL_auxz00_5313 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4158)
; }  else 
{ /* Eval/evaluate_types.scm 75 */
BgL_auxz00_5313 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4157))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)
((BgL_ev_trapz00_bglt)BgL_new1087z00_3732))))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5313),BUNSPEC); } 
BgL_auxz00_5312 = 
((BgL_ev_trapz00_bglt)BgL_new1087z00_3732); 
return 
((obj_t)BgL_auxz00_5312);} } 

}



/* &lambda1620 */
BgL_ev_trapz00_bglt BGl_z62lambda1620z62zz__evaluate_typesz00(obj_t BgL_envz00_3733)
{
{ /* Eval/evaluate_types.scm 75 */
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1086z00_4159;
BgL_new1086z00_4159 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 75 */
long BgL_arg1621z00_4160;
{ /* Eval/evaluate_types.scm 75 */
long BgL_res2321z00_4161;
BgL_res2321z00_4161 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BgL_arg1621z00_4160 = BgL_res2321z00_4161; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1086z00_4159), BgL_arg1621z00_4160); } 
return BgL_new1086z00_4159;} } 

}



/* &lambda1618 */
BgL_ev_trapz00_bglt BGl_z62lambda1618z62zz__evaluate_typesz00(obj_t BgL_envz00_3734, obj_t BgL_e1085z00_3735)
{
{ /* Eval/evaluate_types.scm 75 */
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1213z00_4163;
{ /* Eval/evaluate_types.scm 75 */
BgL_ev_trapz00_bglt BgL_new1212z00_4164;
BgL_new1212z00_4164 = 
((BgL_ev_trapz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_trapz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 75 */
long BgL_arg1619z00_4165;
{ /* Eval/evaluate_types.scm 75 */
long BgL_res2320z00_4166;
BgL_res2320z00_4166 = 
BGL_CLASS_INDEX(BGl_ev_trapz00zz__evaluate_typesz00); 
BgL_arg1619z00_4165 = BgL_res2320z00_4166; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1212z00_4164), BgL_arg1619z00_4165); } 
BgL_new1213z00_4163 = BgL_new1212z00_4164; } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1213z00_4163)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1085z00_3735)),BUNSPEC); 
return BgL_new1213z00_4163;} } 

}



/* &<@anonymous:1604> */
obj_t BGl_z62zc3z04anonymousza31604ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3736, obj_t BgL_new1083z00_3737)
{
{ /* Eval/evaluate_types.scm 73 */
{ 
BgL_ev_hookz00_bglt BgL_auxz00_5336;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5337;
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL_classz00_4168;
BgL_classz00_4168 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 73 */
obj_t BgL__ortest_1282z00_4169;
BgL__ortest_1282z00_4169 = 
BGL_CLASS_NIL(BgL_classz00_4168); 
if(
CBOOL(BgL__ortest_1282z00_4169))
{ /* Eval/evaluate_types.scm 73 */
BgL_auxz00_5337 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4169)
; }  else 
{ /* Eval/evaluate_types.scm 73 */
BgL_auxz00_5337 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4168))
; } } } 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_new1083z00_3737)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5337),BUNSPEC); } 
BgL_auxz00_5336 = 
((BgL_ev_hookz00_bglt)BgL_new1083z00_3737); 
return 
((obj_t)BgL_auxz00_5336);} } 

}



/* &lambda1601 */
BgL_ev_hookz00_bglt BGl_z62lambda1601z62zz__evaluate_typesz00(obj_t BgL_envz00_3738)
{
{ /* Eval/evaluate_types.scm 73 */
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1082z00_4170;
BgL_new1082z00_4170 = 
((BgL_ev_hookz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_hookz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 73 */
long BgL_arg1603z00_4171;
{ /* Eval/evaluate_types.scm 73 */
long BgL_res2319z00_4172;
BgL_res2319z00_4172 = 
BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00); 
BgL_arg1603z00_4171 = BgL_res2319z00_4172; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1082z00_4170), BgL_arg1603z00_4171); } 
return BgL_new1082z00_4170;} } 

}



/* &lambda1599 */
BgL_ev_hookz00_bglt BGl_z62lambda1599z62zz__evaluate_typesz00(obj_t BgL_envz00_3739, obj_t BgL_e1081z00_3740)
{
{ /* Eval/evaluate_types.scm 73 */
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1211z00_4174;
{ /* Eval/evaluate_types.scm 73 */
BgL_ev_hookz00_bglt BgL_new1210z00_4175;
BgL_new1210z00_4175 = 
((BgL_ev_hookz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_hookz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 73 */
long BgL_arg1600z00_4176;
{ /* Eval/evaluate_types.scm 73 */
long BgL_res2318z00_4177;
BgL_res2318z00_4177 = 
BGL_CLASS_INDEX(BGl_ev_hookz00zz__evaluate_typesz00); 
BgL_arg1600z00_4176 = BgL_res2318z00_4177; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1210z00_4175), BgL_arg1600z00_4176); } 
BgL_new1211z00_4174 = BgL_new1210z00_4175; } 
((((BgL_ev_hookz00_bglt)COBJECT(BgL_new1211z00_4174))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1081z00_3740)),BUNSPEC); 
return BgL_new1211z00_4174;} } 

}



/* &lambda1610 */
obj_t BGl_z62lambda1610z62zz__evaluate_typesz00(obj_t BgL_envz00_3741, obj_t BgL_oz00_3742, obj_t BgL_vz00_3743)
{
{ /* Eval/evaluate_types.scm 73 */
return 
((((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_oz00_3742)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3743)),BUNSPEC);} 

}



/* &lambda1609 */
BgL_ev_exprz00_bglt BGl_z62lambda1609z62zz__evaluate_typesz00(obj_t BgL_envz00_3744, obj_t BgL_oz00_3745)
{
{ /* Eval/evaluate_types.scm 73 */
return 
(((BgL_ev_hookz00_bglt)COBJECT(
((BgL_ev_hookz00_bglt)BgL_oz00_3745)))->BgL_ez00);} 

}



/* &<@anonymous:1580> */
obj_t BGl_z62zc3z04anonymousza31580ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3746, obj_t BgL_new1079z00_3747)
{
{ /* Eval/evaluate_types.scm 70 */
{ 
BgL_ev_prog2z00_bglt BgL_auxz00_5363;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5364;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_classz00_4182;
BgL_classz00_4182 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL__ortest_1282z00_4183;
BgL__ortest_1282z00_4183 = 
BGL_CLASS_NIL(BgL_classz00_4182); 
if(
CBOOL(BgL__ortest_1282z00_4183))
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5364 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4183)
; }  else 
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5364 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4182))
; } } } 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3747)))->BgL_e1z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5364),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5373;
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL_classz00_4184;
BgL_classz00_4184 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 70 */
obj_t BgL__ortest_1282z00_4185;
BgL__ortest_1282z00_4185 = 
BGL_CLASS_NIL(BgL_classz00_4184); 
if(
CBOOL(BgL__ortest_1282z00_4185))
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5373 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4185)
; }  else 
{ /* Eval/evaluate_types.scm 70 */
BgL_auxz00_5373 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4184))
; } } } 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3747)))->BgL_e2z00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5373),BUNSPEC); } 
BgL_auxz00_5363 = 
((BgL_ev_prog2z00_bglt)BgL_new1079z00_3747); 
return 
((obj_t)BgL_auxz00_5363);} } 

}



/* &lambda1577 */
BgL_ev_prog2z00_bglt BGl_z62lambda1577z62zz__evaluate_typesz00(obj_t BgL_envz00_3748)
{
{ /* Eval/evaluate_types.scm 70 */
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1078z00_4186;
BgL_new1078z00_4186 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate_types.scm 70 */
long BgL_arg1579z00_4187;
{ /* Eval/evaluate_types.scm 70 */
long BgL_res2317z00_4188;
BgL_res2317z00_4188 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BgL_arg1579z00_4187 = BgL_res2317z00_4188; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1078z00_4186), BgL_arg1579z00_4187); } 
return BgL_new1078z00_4186;} } 

}



/* &lambda1575 */
BgL_ev_prog2z00_bglt BGl_z62lambda1575z62zz__evaluate_typesz00(obj_t BgL_envz00_3749, obj_t BgL_e11076z00_3750, obj_t BgL_e21077z00_3751)
{
{ /* Eval/evaluate_types.scm 70 */
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1209z00_4191;
{ /* Eval/evaluate_types.scm 70 */
BgL_ev_prog2z00_bglt BgL_new1208z00_4192;
BgL_new1208z00_4192 = 
((BgL_ev_prog2z00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_prog2z00_bgl) ))); 
{ /* Eval/evaluate_types.scm 70 */
long BgL_arg1576z00_4193;
{ /* Eval/evaluate_types.scm 70 */
long BgL_res2316z00_4194;
BgL_res2316z00_4194 = 
BGL_CLASS_INDEX(BGl_ev_prog2z00zz__evaluate_typesz00); 
BgL_arg1576z00_4193 = BgL_res2316z00_4194; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1208z00_4192), BgL_arg1576z00_4193); } 
BgL_new1209z00_4191 = BgL_new1208z00_4192; } 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1209z00_4191))->BgL_e1z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e11076z00_3750)),BUNSPEC); 
((((BgL_ev_prog2z00_bglt)COBJECT(BgL_new1209z00_4191))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e21077z00_3751)),BUNSPEC); 
return BgL_new1209z00_4191;} } 

}



/* &lambda1592 */
obj_t BGl_z62lambda1592z62zz__evaluate_typesz00(obj_t BgL_envz00_3752, obj_t BgL_oz00_3753, obj_t BgL_vz00_3754)
{
{ /* Eval/evaluate_types.scm 70 */
return 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3753)))->BgL_e2z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3754)),BUNSPEC);} 

}



/* &lambda1591 */
BgL_ev_exprz00_bglt BGl_z62lambda1591z62zz__evaluate_typesz00(obj_t BgL_envz00_3755, obj_t BgL_oz00_3756)
{
{ /* Eval/evaluate_types.scm 70 */
return 
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3756)))->BgL_e2z00);} 

}



/* &lambda1586 */
obj_t BGl_z62lambda1586z62zz__evaluate_typesz00(obj_t BgL_envz00_3757, obj_t BgL_oz00_3758, obj_t BgL_vz00_3759)
{
{ /* Eval/evaluate_types.scm 70 */
return 
((((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3758)))->BgL_e1z00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3759)),BUNSPEC);} 

}



/* &lambda1585 */
BgL_ev_exprz00_bglt BGl_z62lambda1585z62zz__evaluate_typesz00(obj_t BgL_envz00_3760, obj_t BgL_oz00_3761)
{
{ /* Eval/evaluate_types.scm 70 */
return 
(((BgL_ev_prog2z00_bglt)COBJECT(
((BgL_ev_prog2z00_bglt)BgL_oz00_3761)))->BgL_e1z00);} 

}



/* &<@anonymous:1569> */
obj_t BGl_z62zc3z04anonymousza31569ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3762, obj_t BgL_new1074z00_3763)
{
{ /* Eval/evaluate_types.scm 69 */
{ 
BgL_ev_andz00_bglt BgL_auxz00_5406;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_andz00_bglt)BgL_new1074z00_3763))))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5406 = 
((BgL_ev_andz00_bglt)BgL_new1074z00_3763); 
return 
((obj_t)BgL_auxz00_5406);} } 

}



/* &lambda1567 */
BgL_ev_andz00_bglt BGl_z62lambda1567z62zz__evaluate_typesz00(obj_t BgL_envz00_3764)
{
{ /* Eval/evaluate_types.scm 69 */
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1073z00_4202;
BgL_new1073z00_4202 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 69 */
long BgL_arg1568z00_4203;
{ /* Eval/evaluate_types.scm 69 */
long BgL_res2315z00_4204;
BgL_res2315z00_4204 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BgL_arg1568z00_4203 = BgL_res2315z00_4204; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1073z00_4202), BgL_arg1568z00_4203); } 
return BgL_new1073z00_4202;} } 

}



/* &lambda1565 */
BgL_ev_andz00_bglt BGl_z62lambda1565z62zz__evaluate_typesz00(obj_t BgL_envz00_3765, obj_t BgL_args1072z00_3766)
{
{ /* Eval/evaluate_types.scm 69 */
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1207z00_4205;
{ /* Eval/evaluate_types.scm 69 */
BgL_ev_andz00_bglt BgL_new1206z00_4206;
BgL_new1206z00_4206 = 
((BgL_ev_andz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_andz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 69 */
long BgL_arg1566z00_4207;
{ /* Eval/evaluate_types.scm 69 */
long BgL_res2314z00_4208;
BgL_res2314z00_4208 = 
BGL_CLASS_INDEX(BGl_ev_andz00zz__evaluate_typesz00); 
BgL_arg1566z00_4207 = BgL_res2314z00_4208; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1206z00_4206), BgL_arg1566z00_4207); } 
BgL_new1207z00_4205 = BgL_new1206z00_4206; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1207z00_4205)))->BgL_argsz00)=((obj_t)BgL_args1072z00_3766),BUNSPEC); 
return BgL_new1207z00_4205;} } 

}



/* &<@anonymous:1557> */
obj_t BGl_z62zc3z04anonymousza31557ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3767, obj_t BgL_new1070z00_3768)
{
{ /* Eval/evaluate_types.scm 68 */
{ 
BgL_ev_orz00_bglt BgL_auxz00_5422;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)
((BgL_ev_orz00_bglt)BgL_new1070z00_3768))))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5422 = 
((BgL_ev_orz00_bglt)BgL_new1070z00_3768); 
return 
((obj_t)BgL_auxz00_5422);} } 

}



/* &lambda1555 */
BgL_ev_orz00_bglt BGl_z62lambda1555z62zz__evaluate_typesz00(obj_t BgL_envz00_3769)
{
{ /* Eval/evaluate_types.scm 68 */
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1069z00_4210;
BgL_new1069z00_4210 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 68 */
long BgL_arg1556z00_4211;
{ /* Eval/evaluate_types.scm 68 */
long BgL_res2313z00_4212;
BgL_res2313z00_4212 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BgL_arg1556z00_4211 = BgL_res2313z00_4212; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1069z00_4210), BgL_arg1556z00_4211); } 
return BgL_new1069z00_4210;} } 

}



/* &lambda1553 */
BgL_ev_orz00_bglt BGl_z62lambda1553z62zz__evaluate_typesz00(obj_t BgL_envz00_3770, obj_t BgL_args1068z00_3771)
{
{ /* Eval/evaluate_types.scm 68 */
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1205z00_4213;
{ /* Eval/evaluate_types.scm 68 */
BgL_ev_orz00_bglt BgL_new1204z00_4214;
BgL_new1204z00_4214 = 
((BgL_ev_orz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_orz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 68 */
long BgL_arg1554z00_4215;
{ /* Eval/evaluate_types.scm 68 */
long BgL_res2312z00_4216;
BgL_res2312z00_4216 = 
BGL_CLASS_INDEX(BGl_ev_orz00zz__evaluate_typesz00); 
BgL_arg1554z00_4215 = BgL_res2312z00_4216; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1204z00_4214), BgL_arg1554z00_4215); } 
BgL_new1205z00_4213 = BgL_new1204z00_4214; } 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1205z00_4213)))->BgL_argsz00)=((obj_t)BgL_args1068z00_3771),BUNSPEC); 
return BgL_new1205z00_4213;} } 

}



/* &<@anonymous:1539> */
obj_t BGl_z62zc3z04anonymousza31539ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3772, obj_t BgL_new1066z00_3773)
{
{ /* Eval/evaluate_types.scm 66 */
{ 
BgL_ev_listz00_bglt BgL_auxz00_5438;
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_new1066z00_3773)))->BgL_argsz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5438 = 
((BgL_ev_listz00_bglt)BgL_new1066z00_3773); 
return 
((obj_t)BgL_auxz00_5438);} } 

}



/* &lambda1537 */
BgL_ev_listz00_bglt BGl_z62lambda1537z62zz__evaluate_typesz00(obj_t BgL_envz00_3774)
{
{ /* Eval/evaluate_types.scm 66 */
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1065z00_4218;
BgL_new1065z00_4218 = 
((BgL_ev_listz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_listz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 66 */
long BgL_arg1538z00_4219;
{ /* Eval/evaluate_types.scm 66 */
long BgL_res2311z00_4220;
BgL_res2311z00_4220 = 
BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00); 
BgL_arg1538z00_4219 = BgL_res2311z00_4220; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1065z00_4218), BgL_arg1538z00_4219); } 
return BgL_new1065z00_4218;} } 

}



/* &lambda1535 */
BgL_ev_listz00_bglt BGl_z62lambda1535z62zz__evaluate_typesz00(obj_t BgL_envz00_3775, obj_t BgL_args1064z00_3776)
{
{ /* Eval/evaluate_types.scm 66 */
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1203z00_4221;
{ /* Eval/evaluate_types.scm 66 */
BgL_ev_listz00_bglt BgL_new1202z00_4222;
BgL_new1202z00_4222 = 
((BgL_ev_listz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_listz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 66 */
long BgL_arg1536z00_4223;
{ /* Eval/evaluate_types.scm 66 */
long BgL_res2310z00_4224;
BgL_res2310z00_4224 = 
BGL_CLASS_INDEX(BGl_ev_listz00zz__evaluate_typesz00); 
BgL_arg1536z00_4223 = BgL_res2310z00_4224; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1202z00_4222), BgL_arg1536z00_4223); } 
BgL_new1203z00_4221 = BgL_new1202z00_4222; } 
((((BgL_ev_listz00_bglt)COBJECT(BgL_new1203z00_4221))->BgL_argsz00)=((obj_t)BgL_args1064z00_3776),BUNSPEC); 
return BgL_new1203z00_4221;} } 

}



/* &lambda1544 */
obj_t BGl_z62lambda1544z62zz__evaluate_typesz00(obj_t BgL_envz00_3777, obj_t BgL_oz00_3778, obj_t BgL_vz00_3779)
{
{ /* Eval/evaluate_types.scm 66 */
return 
((((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_oz00_3778)))->BgL_argsz00)=((obj_t)BgL_vz00_3779),BUNSPEC);} 

}



/* &lambda1543 */
obj_t BGl_z62lambda1543z62zz__evaluate_typesz00(obj_t BgL_envz00_3780, obj_t BgL_oz00_3781)
{
{ /* Eval/evaluate_types.scm 66 */
return 
(((BgL_ev_listz00_bglt)COBJECT(
((BgL_ev_listz00_bglt)BgL_oz00_3781)))->BgL_argsz00);} 

}



/* &<@anonymous:1514> */
obj_t BGl_z62zc3z04anonymousza31514ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3782, obj_t BgL_new1062z00_3783)
{
{ /* Eval/evaluate_types.scm 62 */
{ 
BgL_ev_ifz00_bglt BgL_auxz00_5456;
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5457;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4228;
BgL_classz00_4228 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1282z00_4229;
BgL__ortest_1282z00_4229 = 
BGL_CLASS_NIL(BgL_classz00_4228); 
if(
CBOOL(BgL__ortest_1282z00_4229))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5457 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4229)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5457 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4228))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3783)))->BgL_pz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5457),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5466;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4230;
BgL_classz00_4230 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1282z00_4231;
BgL__ortest_1282z00_4231 = 
BGL_CLASS_NIL(BgL_classz00_4230); 
if(
CBOOL(BgL__ortest_1282z00_4231))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5466 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4231)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5466 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4230))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3783)))->BgL_tz00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5466),BUNSPEC); } 
{ 
BgL_ev_exprz00_bglt BgL_auxz00_5475;
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL_classz00_4232;
BgL_classz00_4232 = BGl_ev_exprz00zz__evaluate_typesz00; 
{ /* Eval/evaluate_types.scm 62 */
obj_t BgL__ortest_1282z00_4233;
BgL__ortest_1282z00_4233 = 
BGL_CLASS_NIL(BgL_classz00_4232); 
if(
CBOOL(BgL__ortest_1282z00_4233))
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5475 = 
((BgL_ev_exprz00_bglt)BgL__ortest_1282z00_4233)
; }  else 
{ /* Eval/evaluate_types.scm 62 */
BgL_auxz00_5475 = 
((BgL_ev_exprz00_bglt)
BGl_classzd2nilzd2initz12z12zz__objectz00(BgL_classz00_4232))
; } } } 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_new1062z00_3783)))->BgL_ez00)=((BgL_ev_exprz00_bglt)BgL_auxz00_5475),BUNSPEC); } 
BgL_auxz00_5456 = 
((BgL_ev_ifz00_bglt)BgL_new1062z00_3783); 
return 
((obj_t)BgL_auxz00_5456);} } 

}



/* &lambda1512 */
BgL_ev_ifz00_bglt BGl_z62lambda1512z62zz__evaluate_typesz00(obj_t BgL_envz00_3784)
{
{ /* Eval/evaluate_types.scm 62 */
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1060z00_4234;
BgL_new1060z00_4234 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 62 */
long BgL_arg1513z00_4235;
{ /* Eval/evaluate_types.scm 62 */
long BgL_res2309z00_4236;
BgL_res2309z00_4236 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg1513z00_4235 = BgL_res2309z00_4236; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1060z00_4234), BgL_arg1513z00_4235); } 
return BgL_new1060z00_4234;} } 

}



/* &lambda1510 */
BgL_ev_ifz00_bglt BGl_z62lambda1510z62zz__evaluate_typesz00(obj_t BgL_envz00_3785, obj_t BgL_p1057z00_3786, obj_t BgL_t1058z00_3787, obj_t BgL_e1059z00_3788)
{
{ /* Eval/evaluate_types.scm 62 */
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1201z00_4240;
{ /* Eval/evaluate_types.scm 62 */
BgL_ev_ifz00_bglt BgL_new1200z00_4241;
BgL_new1200z00_4241 = 
((BgL_ev_ifz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_ifz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 62 */
long BgL_arg1511z00_4242;
{ /* Eval/evaluate_types.scm 62 */
long BgL_res2308z00_4243;
BgL_res2308z00_4243 = 
BGL_CLASS_INDEX(BGl_ev_ifz00zz__evaluate_typesz00); 
BgL_arg1511z00_4242 = BgL_res2308z00_4243; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1200z00_4241), BgL_arg1511z00_4242); } 
BgL_new1201z00_4240 = BgL_new1200z00_4241; } 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1201z00_4240))->BgL_pz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_p1057z00_3786)),BUNSPEC); 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1201z00_4240))->BgL_tz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_t1058z00_3787)),BUNSPEC); 
((((BgL_ev_ifz00_bglt)COBJECT(BgL_new1201z00_4240))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_e1059z00_3788)),BUNSPEC); 
return BgL_new1201z00_4240;} } 

}



/* &lambda1529 */
obj_t BGl_z62lambda1529z62zz__evaluate_typesz00(obj_t BgL_envz00_3789, obj_t BgL_oz00_3790, obj_t BgL_vz00_3791)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3790)))->BgL_ez00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3791)),BUNSPEC);} 

}



/* &lambda1528 */
BgL_ev_exprz00_bglt BGl_z62lambda1528z62zz__evaluate_typesz00(obj_t BgL_envz00_3792, obj_t BgL_oz00_3793)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3793)))->BgL_ez00);} 

}



/* &lambda1524 */
obj_t BGl_z62lambda1524z62zz__evaluate_typesz00(obj_t BgL_envz00_3794, obj_t BgL_oz00_3795, obj_t BgL_vz00_3796)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3795)))->BgL_tz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3796)),BUNSPEC);} 

}



/* &lambda1523 */
BgL_ev_exprz00_bglt BGl_z62lambda1523z62zz__evaluate_typesz00(obj_t BgL_envz00_3797, obj_t BgL_oz00_3798)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3798)))->BgL_tz00);} 

}



/* &lambda1519 */
obj_t BGl_z62lambda1519z62zz__evaluate_typesz00(obj_t BgL_envz00_3799, obj_t BgL_oz00_3800, obj_t BgL_vz00_3801)
{
{ /* Eval/evaluate_types.scm 62 */
return 
((((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3800)))->BgL_pz00)=((BgL_ev_exprz00_bglt)
((BgL_ev_exprz00_bglt)BgL_vz00_3801)),BUNSPEC);} 

}



/* &lambda1518 */
BgL_ev_exprz00_bglt BGl_z62lambda1518z62zz__evaluate_typesz00(obj_t BgL_envz00_3802, obj_t BgL_oz00_3803)
{
{ /* Eval/evaluate_types.scm 62 */
return 
(((BgL_ev_ifz00_bglt)COBJECT(
((BgL_ev_ifz00_bglt)BgL_oz00_3803)))->BgL_pz00);} 

}



/* &<@anonymous:1497> */
obj_t BGl_z62zc3z04anonymousza31497ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3804, obj_t BgL_new1055z00_3805)
{
{ /* Eval/evaluate_types.scm 60 */
{ 
BgL_ev_littz00_bglt BgL_auxz00_5515;
((((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_new1055z00_3805)))->BgL_valuez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5515 = 
((BgL_ev_littz00_bglt)BgL_new1055z00_3805); 
return 
((obj_t)BgL_auxz00_5515);} } 

}



/* &lambda1495 */
BgL_ev_littz00_bglt BGl_z62lambda1495z62zz__evaluate_typesz00(obj_t BgL_envz00_3806)
{
{ /* Eval/evaluate_types.scm 60 */
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1054z00_4254;
BgL_new1054z00_4254 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 60 */
long BgL_arg1496z00_4255;
{ /* Eval/evaluate_types.scm 60 */
long BgL_res2307z00_4256;
BgL_res2307z00_4256 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg1496z00_4255 = BgL_res2307z00_4256; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1054z00_4254), BgL_arg1496z00_4255); } 
return BgL_new1054z00_4254;} } 

}



/* &lambda1493 */
BgL_ev_littz00_bglt BGl_z62lambda1493z62zz__evaluate_typesz00(obj_t BgL_envz00_3807, obj_t BgL_value1053z00_3808)
{
{ /* Eval/evaluate_types.scm 60 */
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1199z00_4257;
{ /* Eval/evaluate_types.scm 60 */
BgL_ev_littz00_bglt BgL_new1198z00_4258;
BgL_new1198z00_4258 = 
((BgL_ev_littz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_littz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 60 */
long BgL_arg1494z00_4259;
{ /* Eval/evaluate_types.scm 60 */
long BgL_res2306z00_4260;
BgL_res2306z00_4260 = 
BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00); 
BgL_arg1494z00_4259 = BgL_res2306z00_4260; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1198z00_4258), BgL_arg1494z00_4259); } 
BgL_new1199z00_4257 = BgL_new1198z00_4258; } 
((((BgL_ev_littz00_bglt)COBJECT(BgL_new1199z00_4257))->BgL_valuez00)=((obj_t)BgL_value1053z00_3808),BUNSPEC); 
return BgL_new1199z00_4257;} } 

}



/* &lambda1503 */
obj_t BGl_z62lambda1503z62zz__evaluate_typesz00(obj_t BgL_envz00_3809, obj_t BgL_oz00_3810, obj_t BgL_vz00_3811)
{
{ /* Eval/evaluate_types.scm 60 */
return 
((((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_oz00_3810)))->BgL_valuez00)=((obj_t)BgL_vz00_3811),BUNSPEC);} 

}



/* &lambda1502 */
obj_t BGl_z62lambda1502z62zz__evaluate_typesz00(obj_t BgL_envz00_3812, obj_t BgL_oz00_3813)
{
{ /* Eval/evaluate_types.scm 60 */
return 
(((BgL_ev_littz00_bglt)COBJECT(
((BgL_ev_littz00_bglt)BgL_oz00_3813)))->BgL_valuez00);} 

}



/* &<@anonymous:1469> */
obj_t BGl_z62zc3z04anonymousza31469ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3814, obj_t BgL_new1051z00_3815)
{
{ /* Eval/evaluate_types.scm 55 */
{ 
BgL_ev_globalz00_bglt BgL_auxz00_5533;
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1051z00_3815)))->BgL_locz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1051z00_3815)))->BgL_namez00)=((obj_t)BGl_symbol2731z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_new1051z00_3815)))->BgL_modz00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5533 = 
((BgL_ev_globalz00_bglt)BgL_new1051z00_3815); 
return 
((obj_t)BgL_auxz00_5533);} } 

}



/* &lambda1467 */
BgL_ev_globalz00_bglt BGl_z62lambda1467z62zz__evaluate_typesz00(obj_t BgL_envz00_3816)
{
{ /* Eval/evaluate_types.scm 55 */
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1050z00_4264;
BgL_new1050z00_4264 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 55 */
long BgL_arg1468z00_4265;
{ /* Eval/evaluate_types.scm 55 */
long BgL_res2305z00_4266;
BgL_res2305z00_4266 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg1468z00_4265 = BgL_res2305z00_4266; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1050z00_4264), BgL_arg1468z00_4265); } 
return BgL_new1050z00_4264;} } 

}



/* &lambda1465 */
BgL_ev_globalz00_bglt BGl_z62lambda1465z62zz__evaluate_typesz00(obj_t BgL_envz00_3817, obj_t BgL_loc1047z00_3818, obj_t BgL_name1048z00_3819, obj_t BgL_mod1049z00_3820)
{
{ /* Eval/evaluate_types.scm 55 */
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1197z00_4268;
{ /* Eval/evaluate_types.scm 55 */
BgL_ev_globalz00_bglt BgL_new1196z00_4269;
BgL_new1196z00_4269 = 
((BgL_ev_globalz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_globalz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 55 */
long BgL_arg1466z00_4270;
{ /* Eval/evaluate_types.scm 55 */
long BgL_res2304z00_4271;
BgL_res2304z00_4271 = 
BGL_CLASS_INDEX(BGl_ev_globalz00zz__evaluate_typesz00); 
BgL_arg1466z00_4270 = BgL_res2304z00_4271; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1196z00_4269), BgL_arg1466z00_4270); } 
BgL_new1197z00_4268 = BgL_new1196z00_4269; } 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1197z00_4268))->BgL_locz00)=((obj_t)BgL_loc1047z00_3818),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1197z00_4268))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1048z00_3819)),BUNSPEC); 
((((BgL_ev_globalz00_bglt)COBJECT(BgL_new1197z00_4268))->BgL_modz00)=((obj_t)BgL_mod1049z00_3820),BUNSPEC); 
return BgL_new1197z00_4268;} } 

}



/* &lambda1485 */
obj_t BGl_z62lambda1485z62zz__evaluate_typesz00(obj_t BgL_envz00_3821, obj_t BgL_oz00_3822, obj_t BgL_vz00_3823)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3822)))->BgL_modz00)=((obj_t)BgL_vz00_3823),BUNSPEC);} 

}



/* &lambda1484 */
obj_t BGl_z62lambda1484z62zz__evaluate_typesz00(obj_t BgL_envz00_3824, obj_t BgL_oz00_3825)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3825)))->BgL_modz00);} 

}



/* &lambda1480 */
obj_t BGl_z62lambda1480z62zz__evaluate_typesz00(obj_t BgL_envz00_3826, obj_t BgL_oz00_3827, obj_t BgL_vz00_3828)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3827)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3828)),BUNSPEC);} 

}



/* &lambda1479 */
obj_t BGl_z62lambda1479z62zz__evaluate_typesz00(obj_t BgL_envz00_3829, obj_t BgL_oz00_3830)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3830)))->BgL_namez00);} 

}



/* &lambda1474 */
obj_t BGl_z62lambda1474z62zz__evaluate_typesz00(obj_t BgL_envz00_3831, obj_t BgL_oz00_3832, obj_t BgL_vz00_3833)
{
{ /* Eval/evaluate_types.scm 55 */
return 
((((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3832)))->BgL_locz00)=((obj_t)BgL_vz00_3833),BUNSPEC);} 

}



/* &lambda1473 */
obj_t BGl_z62lambda1473z62zz__evaluate_typesz00(obj_t BgL_envz00_3834, obj_t BgL_oz00_3835)
{
{ /* Eval/evaluate_types.scm 55 */
return 
(((BgL_ev_globalz00_bglt)COBJECT(
((BgL_ev_globalz00_bglt)BgL_oz00_3835)))->BgL_locz00);} 

}



/* &<@anonymous:1438> */
obj_t BGl_z62zc3z04anonymousza31438ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3836, obj_t BgL_new1045z00_3837)
{
{ /* Eval/evaluate_types.scm 51 */
{ 
BgL_ev_varz00_bglt BgL_auxz00_5567;
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1045z00_3837)))->BgL_namez00)=((obj_t)BGl_symbol2731z00zz__evaluate_typesz00),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1045z00_3837)))->BgL_effz00)=((obj_t)BUNSPEC),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_new1045z00_3837)))->BgL_typez00)=((obj_t)BUNSPEC),BUNSPEC); 
BgL_auxz00_5567 = 
((BgL_ev_varz00_bglt)BgL_new1045z00_3837); 
return 
((obj_t)BgL_auxz00_5567);} } 

}



/* &lambda1436 */
BgL_ev_varz00_bglt BGl_z62lambda1436z62zz__evaluate_typesz00(obj_t BgL_envz00_3838)
{
{ /* Eval/evaluate_types.scm 51 */
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1044z00_4280;
BgL_new1044z00_4280 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 51 */
long BgL_arg1437z00_4281;
{ /* Eval/evaluate_types.scm 51 */
long BgL_res2303z00_4282;
BgL_res2303z00_4282 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg1437z00_4281 = BgL_res2303z00_4282; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1044z00_4280), BgL_arg1437z00_4281); } 
return BgL_new1044z00_4280;} } 

}



/* &lambda1434 */
BgL_ev_varz00_bglt BGl_z62lambda1434z62zz__evaluate_typesz00(obj_t BgL_envz00_3839, obj_t BgL_name1041z00_3840, obj_t BgL_eff1042z00_3841, obj_t BgL_type1043z00_3842)
{
{ /* Eval/evaluate_types.scm 51 */
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1195z00_4284;
{ /* Eval/evaluate_types.scm 51 */
BgL_ev_varz00_bglt BgL_new1194z00_4285;
BgL_new1194z00_4285 = 
((BgL_ev_varz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_varz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 51 */
long BgL_arg1435z00_4286;
{ /* Eval/evaluate_types.scm 51 */
long BgL_res2302z00_4287;
BgL_res2302z00_4287 = 
BGL_CLASS_INDEX(BGl_ev_varz00zz__evaluate_typesz00); 
BgL_arg1435z00_4286 = BgL_res2302z00_4287; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1194z00_4285), BgL_arg1435z00_4286); } 
BgL_new1195z00_4284 = BgL_new1194z00_4285; } 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1195z00_4284))->BgL_namez00)=((obj_t)
((obj_t)BgL_name1041z00_3840)),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1195z00_4284))->BgL_effz00)=((obj_t)BgL_eff1042z00_3841),BUNSPEC); 
((((BgL_ev_varz00_bglt)COBJECT(BgL_new1195z00_4284))->BgL_typez00)=((obj_t)BgL_type1043z00_3842),BUNSPEC); 
return BgL_new1195z00_4284;} } 

}



/* &lambda1457 */
obj_t BGl_z62lambda1457z62zz__evaluate_typesz00(obj_t BgL_envz00_3843, obj_t BgL_oz00_3844, obj_t BgL_vz00_3845)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3844)))->BgL_typez00)=((obj_t)BgL_vz00_3845),BUNSPEC);} 

}



/* &lambda1456 */
obj_t BGl_z62lambda1456z62zz__evaluate_typesz00(obj_t BgL_envz00_3846, obj_t BgL_oz00_3847)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3847)))->BgL_typez00);} 

}



/* &<@anonymous:1450> */
obj_t BGl_z62zc3z04anonymousza31450ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3848)
{
{ /* Eval/evaluate_types.scm 51 */
return 
BBOOL(((bool_t)0));} 

}



/* &lambda1449 */
obj_t BGl_z62lambda1449z62zz__evaluate_typesz00(obj_t BgL_envz00_3849, obj_t BgL_oz00_3850, obj_t BgL_vz00_3851)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3850)))->BgL_effz00)=((obj_t)BgL_vz00_3851),BUNSPEC);} 

}



/* &lambda1448 */
obj_t BGl_z62lambda1448z62zz__evaluate_typesz00(obj_t BgL_envz00_3852, obj_t BgL_oz00_3853)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3853)))->BgL_effz00);} 

}



/* &lambda1443 */
obj_t BGl_z62lambda1443z62zz__evaluate_typesz00(obj_t BgL_envz00_3854, obj_t BgL_oz00_3855, obj_t BgL_vz00_3856)
{
{ /* Eval/evaluate_types.scm 51 */
return 
((((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3855)))->BgL_namez00)=((obj_t)
((obj_t)BgL_vz00_3856)),BUNSPEC);} 

}



/* &lambda1442 */
obj_t BGl_z62lambda1442z62zz__evaluate_typesz00(obj_t BgL_envz00_3857, obj_t BgL_oz00_3858)
{
{ /* Eval/evaluate_types.scm 51 */
return 
(((BgL_ev_varz00_bglt)COBJECT(
((BgL_ev_varz00_bglt)BgL_oz00_3858)))->BgL_namez00);} 

}



/* &<@anonymous:1426> */
obj_t BGl_z62zc3z04anonymousza31426ze3ze5zz__evaluate_typesz00(obj_t BgL_envz00_3859, obj_t BgL_new1039z00_3860)
{
{ /* Eval/evaluate_types.scm 49 */
return 
((obj_t)
((BgL_ev_exprz00_bglt)BgL_new1039z00_3860));} 

}



/* &lambda1424 */
BgL_ev_exprz00_bglt BGl_z62lambda1424z62zz__evaluate_typesz00(obj_t BgL_envz00_3861)
{
{ /* Eval/evaluate_types.scm 49 */
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1038z00_4296;
BgL_new1038z00_4296 = 
((BgL_ev_exprz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_exprz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 49 */
long BgL_arg1425z00_4297;
{ /* Eval/evaluate_types.scm 49 */
long BgL_res2301z00_4298;
BgL_res2301z00_4298 = 
BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00); 
BgL_arg1425z00_4297 = BgL_res2301z00_4298; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1038z00_4296), BgL_arg1425z00_4297); } 
return BgL_new1038z00_4296;} } 

}



/* &lambda1422 */
BgL_ev_exprz00_bglt BGl_z62lambda1422z62zz__evaluate_typesz00(obj_t BgL_envz00_3862)
{
{ /* Eval/evaluate_types.scm 49 */
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1193z00_4299;
{ /* Eval/evaluate_types.scm 49 */
BgL_ev_exprz00_bglt BgL_new1192z00_4300;
BgL_new1192z00_4300 = 
((BgL_ev_exprz00_bglt)BOBJECT( GC_MALLOC( sizeof(struct BgL_ev_exprz00_bgl) ))); 
{ /* Eval/evaluate_types.scm 49 */
long BgL_arg1423z00_4301;
{ /* Eval/evaluate_types.scm 49 */
long BgL_res2300z00_4302;
BgL_res2300z00_4302 = 
BGL_CLASS_INDEX(BGl_ev_exprz00zz__evaluate_typesz00); 
BgL_arg1423z00_4301 = BgL_res2300z00_4302; } 
BGL_OBJECT_CLASS_NUM_SET(
((BgL_objectz00_bglt)BgL_new1192z00_4300), BgL_arg1423z00_4301); } 
BgL_new1193z00_4299 = BgL_new1192z00_4300; } 
return BgL_new1193z00_4299;} } 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
return BUNSPEC;} 

}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_typesz00()
{
{ /* Eval/evaluate_types.scm 15 */
BGl_modulezd2initializa7ationz75zz__typez00(((long)121046386), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)37115357), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__biglooz00(((long)70989162), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__tvectorz00(((long)135277364), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__structurez00(((long)128218115), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)340267996), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bignumz00(((long)6519875), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__osz00(((long)251315035), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__dssslz00(((long)443936798), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)439352636), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__paramz00(((long)453938973), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)193422032), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__threadz00(((long)224967910), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)68572481), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)420334581), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)437057945), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)268155874), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)198621048), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)473309694), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long)459519474), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)460263341), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)-44274296), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)9614573), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)376927845), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)228151379), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)190906089), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)331540733), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00)); 
return 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)86988972), 
BSTRING_TO_STRING(BGl_string2408z00zz__evaluate_typesz00));} 

}

#ifdef __cplusplus
}
#endif
