/*===========================================================================*/
/*   (Eval/evaluate_comp.scm)                                                */
/*   Bigloo (4.4a)                                                           */
/*   Inria -- Sophia Antipolis (c)       Sun 01 Nov 2020 07:23:42 AM CET     */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4a -rm -copt -w -lib-dir /home/serrano/prgm/project/bigloo/bigloo/lib/bigloo/4.4a -mklib -cc gcc -fsharing -q -no-hello -unsafe -safee -O4 -c Eval/evaluate_comp.scm -indent -o objs/obj_u/Eval/evaluate_comp.c) */
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_labelsz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		obj_t BgL_envz00;
		obj_t BgL_stkz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_labelsz00_bglt;

	typedef struct BgL_ev_gotoz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_varz00_bgl *BgL_labelz00;
		struct BgL_ev_labelsz00_bgl *BgL_labelsz00;
		obj_t BgL_argsz00;
	}                 *BgL_ev_gotoz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	static obj_t BGl_z62main5811z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32841ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5813z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33643ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5815z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33538ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5817z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62main5819z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5821z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza33822ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5823z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5825z62zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5827z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5829z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62main5831z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32932ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5833z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33718ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32917ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33914ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32829ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33575ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33559ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32104ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_2za2za2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zd2zd2zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_2zf2zf2zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33739ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33488ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2zc3zc3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2zd3zd3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33013ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32881ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32865ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33951ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33846ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32035ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33863ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33774ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33596ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t make_vector(long, obj_t);
	extern obj_t BGl_ev_labelsz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33210ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33016ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t, obj_t, long, long,
		obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t, obj_t, long);
	static obj_t BGl_methodzd2initzd2zz__evaluate_compz00();
	static bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t);
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza34013ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32215ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32126ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32037ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_everrorz00zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32885ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5839z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32410ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33034ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33939ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5841z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5843z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5849z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32160ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_reset_profilez00zz__evaluate_compz00();
	static obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32128ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5857z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5859z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33141ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33303ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5861z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5864z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5867z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5869z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33037ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(obj_t, long, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_labels1432zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33796ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32889ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5871z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5873z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5875z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5877z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5879z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza34034ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32414ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33886ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5881z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5883z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5885z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_gotoz00zz__evaluate_typesz00;
	static obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5887z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5889z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza33411ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5891z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5893z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5895z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5897z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5899z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62runz62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33161ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza33129ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
	extern bool_t BGl_numberzf3zf3zz__r4_numbers_6_5z00(obj_t);
	extern int bgl_debug();
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	static double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33074ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33236ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32999ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_global1399zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t,
		obj_t, obj_t, long, obj_t);
	extern obj_t create_struct(obj_t, int);
	static obj_t BGl_get_profilez00zz__evaluate_compz00();
	static obj_t BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33059ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern long bgl_list_length(obj_t);
	extern obj_t BGl_evarityzd2errorzd2zz__everrorz00(obj_t, obj_t, int, int);
	extern obj_t BGl_evwarningz00zz__everrorz00(obj_t, obj_t);
	static obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33505ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33416ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	extern obj_t BGl_evmodulezd2findzd2globalz00zz__evmodulez00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_withzd2handler1428z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33701ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza31815ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_lnamez00zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32901ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33274ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32189ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62run5750z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62run5752z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5754z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5756z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compz62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	static obj_t BGl_z62run5758z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33631ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32813ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32368ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5760z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static obj_t BGl_z62run5762z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5764z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5766z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5768z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5770z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5772z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5774z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5776z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5778z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33382ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33528ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_usez00zz__evaluate_usez00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62run5780z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5782z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5784z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5786z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5788z62zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33812ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32921ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32905ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33383ze3ze5zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62run5790z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5792z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5794z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5796z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5798z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32817ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33368ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_makezd2statezd2zz__evaluate_compz00();
	static obj_t
		BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt, long,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33369ze3ze5zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62main5749z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_trap1393zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5751z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33653ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62main5753z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5755z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5757z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5759z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33670ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5761z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31872ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33727ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5763z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32909ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33549ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5765z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5767z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62main5769z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31962ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32853ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5771z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32926ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5773z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5775z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5777z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5779z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62main5781z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5783z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5785z62zz__evaluate_compz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62main5787z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	static obj_t BGl_z62main5789z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33835ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33584ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31964ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5791z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62main5793z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	static obj_t BGl_z62main5795z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5797z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5799z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33020ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evtypezd2errorzd2zz__everrorz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33690ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33925ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza32929ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32589ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t bgl_reverse_bang(obj_t);
	static obj_t BGl_z62zc3z04anonymousza31982ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32873ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static long BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00;
	static obj_t BGl_z62zc3z04anonymousza32042ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33006ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33765ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33749ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33023ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32132ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31895ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza31968ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33202ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_evmodulezd2namezd2zz__evmodulez00(obj_t);
	static obj_t BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5901z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5903z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_goto1434zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_symbol5905z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5907z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5909z00zz__evaluate_compz00 = BUNSPEC;
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33009ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32982ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33873ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32893ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33679ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5911z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5913z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5915z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5917z00zz__evaluate_compz00 = BUNSPEC;
	static bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5919z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_indexz00zz__evaluate_compz00(obj_t, obj_t);
	extern obj_t BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_symbol5921z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5923z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5925z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5927z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5929z00zz__evaluate_compz00 = BUNSPEC;
	static bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t, obj_t, long);
	static obj_t BGl_z62zc3z04anonymousza32063ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33027ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t
		BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33786ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_symbol5931z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5933z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32331ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_synchroniza7e1430z17zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl__indexz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33061ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32243ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32897ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33240ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33119ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_var1395zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_symbol5964z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62compzd2ev_app1436zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33225ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32245ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t bigloo_string_lt(obj_t, obj_t);
	static obj_t BGl_symbol5972z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t);
	static obj_t BGl_z62zc3z04anonymousza32408ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33048ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33969ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_usez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__srfi4z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	static obj_t BGl_symbol5983z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5985z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5987z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_symbol5989z00zz__evaluate_compz00 = BUNSPEC;
	static obj_t BGl_z62zc3z04anonymousza32085ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33897ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	extern obj_t BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(long,
		long);
	static obj_t BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33423ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33318ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32249ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
	static obj_t BGl_z62zc3z04anonymousza33513ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32533ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33989ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_abs1438zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5800z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5802z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5804z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5806z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5808z62zz__evaluate_compz00(obj_t, obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_z62run5810z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long);
	static obj_t BGl_z62run5812z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t);
	static obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t);
	static obj_t BGl_z62run5814z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t);
	static obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t,
		BgL_ev_exprz00_bglt, obj_t, obj_t, obj_t, obj_t, long, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62run5816z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5818z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_exprz00zz__evaluate_typesz00;
	static obj_t BGl_z62zc3z04anonymousza33605ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5820z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5822z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5824z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5826z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5828z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33622ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62run5830z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62comp1389z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62run5832z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62run5834z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_zc3z04exitza33379ze3ze70z60zz__evaluate_compz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza33372ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32465ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	extern bool_t BGl_2zc3zd3z10zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_zc3z04exitza33360ze3ze70z60zz__evaluate_compz00(obj_t, obj_t,
		obj_t, long, obj_t);
	static obj_t BGl_z62compzd2ev_setlocal1397zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32806ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62zc3z04anonymousza32288ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt, obj_t);
	static obj_t BGl_z62compzd2ev_defglobal1405zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31843ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62compzd2ev_setglobal1401zb0zz__evaluate_compz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_z62main5801z62zz__evaluate_compz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62main5803z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza32913ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt,
		obj_t);
	static obj_t BGl_z62main5805z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza31917ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5807z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t BGl_z62zc3z04anonymousza33359ze3ze5zz__evaluate_compz00(obj_t,
		obj_t);
	static obj_t BGl_z62main5809z62zz__evaluate_compz00(obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STRING(BGl_string5984z00zz__evaluate_compz00,
		BgL_bgl_string5984za700za7za7_5993za7, "get_sp", 6);
	      DEFINE_STRING(BGl_string5986z00zz__evaluate_compz00,
		BgL_bgl_string5986za700za7za7_5994za7, "reset_profile", 13);
	      DEFINE_STRING(BGl_string5988z00zz__evaluate_compz00,
		BgL_bgl_string5988za700za7za7_5995za7, "get_profile", 11);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_zc3lexintzd2envz11zz__evaluate_compz00,
		BgL_bgl_za762za7c3lexintza7a1za75996z00,
		BGl_z62zc3lexintza1zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5990z00zz__evaluate_compz00,
		BgL_bgl_string5990za700za7za7_5997za7, "reset_stack", 11);
	      DEFINE_STRING(BGl_string5991z00zz__evaluate_compz00,
		BgL_bgl_string5991za700za7za7_5998za7, "internal error: unknown command",
		31);
	      DEFINE_STRING(BGl_string5992z00zz__evaluate_compz00,
		BgL_bgl_string5992za700za7za7_5999za7, "__evaluate_comp", 15);
	extern obj_t BGl_zd2zd2envz00zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd3zd2envz01zz__r4_numbers_6_5z00;
	extern obj_t BGl_f64vectorzd2refzd2envz00zz__srfi4z00;
	extern obj_t BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_compilezd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compileza762za7za7_6000z00,
		BGl_z62compilez62zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3zd2envz31zz__r4_numbers_6_5z00;
	extern obj_t BGl_zf2zd2envz20zz__r4_numbers_6_5z00;
	extern obj_t BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_findzd2statezd2envz00zz__evaluate_compz00,
		BgL_bgl_za762findza7d2stateza76001za7,
		BGl_z62findzd2statezb0zz__evaluate_compz00, 0L, BUNSPEC, 0);
	extern obj_t BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00;
	extern obj_t BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STATIC_BGL_GENERIC(BGl_compzd2envzd2zz__evaluate_compz00,
		BgL_bgl_za762compza762za7za7__ev6002z00, BGl_z62compz62zz__evaluate_compz00,
		0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5840z00zz__evaluate_compz00,
		BgL_bgl_string5840za700za7za7_6003za7, "all", 3);
	      DEFINE_STRING(BGl_string5842z00zz__evaluate_compz00,
		BgL_bgl_string5842za700za7za7_6004za7, "label-tag", 9);
	      DEFINE_STRING(BGl_string5844z00zz__evaluate_compz00,
		BgL_bgl_string5844za700za7za7_6005za7, "bounce", 6);
	      DEFINE_STRING(BGl_string5845z00zz__evaluate_compz00,
		BgL_bgl_string5845za700za7za7_6006za7, "non non non", 11);
	      DEFINE_STRING(BGl_string5846z00zz__evaluate_compz00,
		BgL_bgl_string5846za700za7za7_6007za7, " in ", 4);
	      DEFINE_STRING(BGl_string5847z00zz__evaluate_compz00,
		BgL_bgl_string5847za700za7za7_6008za7, "eval", 4);
	      DEFINE_STRING(BGl_string5848z00zz__evaluate_compz00,
		BgL_bgl_string5848za700za7za7_6009za7, "internal error: not found", 25);
	extern obj_t BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5850z00zz__evaluate_compz00,
		BgL_bgl_string5850za700za7za7_6010za7, "at", 2);
	      DEFINE_STRING(BGl_string5851z00zz__evaluate_compz00,
		BgL_bgl_string5851za700za7za7_6011za7, "", 0);
	      DEFINE_STRING(BGl_string5852z00zz__evaluate_compz00,
		BgL_bgl_string5852za700za7za7_6012za7,
		"/tmp/bigloo/runtime/Eval/evaluate_comp.scm", 42);
	      DEFINE_STRING(BGl_string5853z00zz__evaluate_compz00,
		BgL_bgl_string5853za700za7za7_6013za7, "&compile", 8);
	      DEFINE_STRING(BGl_string5854z00zz__evaluate_compz00,
		BgL_bgl_string5854za700za7za7_6014za7, "ev_expr", 7);
	      DEFINE_STRING(BGl_string5855z00zz__evaluate_compz00,
		BgL_bgl_string5855za700za7za7_6015za7, "expecting ~a, got ~a", 20);
	      DEFINE_STRING(BGl_string5856z00zz__evaluate_compz00,
		BgL_bgl_string5856za700za7za7_6016za7, "wrong number of argument", 24);
	      DEFINE_STRING(BGl_string5858z00zz__evaluate_compz00,
		BgL_bgl_string5858za700za7za7_6017za7, "mcell", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5935z00zz__evaluate_compz00,
		BgL_bgl_za762comp1389za762za7za76018z00,
		BGl_z62comp1389z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5860z00zz__evaluate_compz00,
		BgL_bgl_string5860za700za7za7_6019za7, "internal", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5939z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_tra6020z00,
		BGl_z62compzd2ev_trap1393zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5862z00zz__evaluate_compz00,
		BgL_bgl_string5862za700za7za7_6021za7, "impossible", 10);
	      DEFINE_STRING(BGl_string5863z00zz__evaluate_compz00,
		BgL_bgl_string5863za700za7za7_6022za7, "procedure", 9);
	      DEFINE_STRING(BGl_string5865z00zz__evaluate_compz00,
		BgL_bgl_string5865za700za7za7_6023za7, "user", 4);
	      DEFINE_STRING(BGl_string5866z00zz__evaluate_compz00,
		BgL_bgl_string5866za700za7za7_6024za7, "invalid byte code", 17);
	      DEFINE_STRING(BGl_string5868z00zz__evaluate_compz00,
		BgL_bgl_string5868za700za7za7_6025za7, "+", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5941z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_var6026z00,
		BGl_z62compzd2ev_var1395zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5942z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set6027z00,
		BGl_z62compzd2ev_setlocal1397zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5943z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_glo6028z00,
		BGl_z62compzd2ev_global1399zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5944z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_set6029z00,
		BGl_z62compzd2ev_setglobal1401zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5945z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_def6030z00,
		BGl_z62compzd2ev_defglobal1405zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5946z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lit6031z00,
		BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5947z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_if16032z00,
		BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5870z00zz__evaluate_compz00,
		BgL_bgl_string5870za700za7za7_6033za7, "number", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5948z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_or16034z00,
		BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5949z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_and6035z00,
		BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5872z00zz__evaluate_compz00,
		BgL_bgl_string5872za700za7za7_6036za7, "-", 1);
	      DEFINE_STRING(BGl_string5874z00zz__evaluate_compz00,
		BgL_bgl_string5874za700za7za7_6037za7, "*", 1);
	      DEFINE_STRING(BGl_string5876z00zz__evaluate_compz00,
		BgL_bgl_string5876za700za7za7_6038za7, "/", 1);
	      DEFINE_STRING(BGl_string5878z00zz__evaluate_compz00,
		BgL_bgl_string5878za700za7za7_6039za7, "<", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5950z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_pro6040z00,
		BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5951z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let6041z00,
		BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5952z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let6042z00,
		BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5953z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_let6043z00,
		BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5954z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_bin6044z00,
		BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5955z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_unw6045z00,
		BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5956z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_wit6046z00,
		BGl_z62compzd2ev_withzd2handler1428z62zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5957z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_syn6047z00,
		BGl_z62compzd2ev_synchroniza7e1430z17zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5880z00zz__evaluate_compz00,
		BgL_bgl_string5880za700za7za7_6048za7, ">", 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5958z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_lab6049z00,
		BGl_z62compzd2ev_labels1432zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5959z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_got6050z00,
		BGl_z62compzd2ev_goto1434zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string5882z00zz__evaluate_compz00,
		BgL_bgl_string5882za700za7za7_6051za7, "<=", 2);
	      DEFINE_STRING(BGl_string5884z00zz__evaluate_compz00,
		BgL_bgl_string5884za700za7za7_6052za7, ">=", 2);
	      DEFINE_STRING(BGl_string5886z00zz__evaluate_compz00,
		BgL_bgl_string5886za700za7za7_6053za7, "=", 1);
	      DEFINE_STRING(BGl_string5888z00zz__evaluate_compz00,
		BgL_bgl_string5888za700za7za7_6054za7, "+fx", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5960z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_app6055z00,
		BGl_z62compzd2ev_app1436zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5961z00zz__evaluate_compz00,
		BgL_bgl_za762compza7d2ev_abs6056z00,
		BGl_z62compzd2ev_abs1438zb0zz__evaluate_compz00, 0L, BUNSPEC, 2);
	extern obj_t BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	   
		 
		DEFINE_STRING(BGl_string5890z00zz__evaluate_compz00,
		BgL_bgl_string5890za700za7za7_6057za7, "fixnum", 6);
	extern obj_t BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00;
	extern obj_t BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	   
		 
		DEFINE_STRING(BGl_string5892z00zz__evaluate_compz00,
		BgL_bgl_string5892za700za7za7_6058za7, "-fx", 3);
	      DEFINE_STRING(BGl_string5894z00zz__evaluate_compz00,
		BgL_bgl_string5894za700za7za7_6059za7, "*fx", 3);
	      DEFINE_STRING(BGl_string5896z00zz__evaluate_compz00,
		BgL_bgl_string5896za700za7za7_6060za7, "/fx", 3);
	      DEFINE_STRING(BGl_string5898z00zz__evaluate_compz00,
		BgL_bgl_string5898za700za7za7_6061za7, "<fx", 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5975z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6062za7,
		BGl_z62zc3z04anonymousza32999ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5976z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6063za7,
		BGl_z62zc3z04anonymousza33006ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5977z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6064za7,
		BGl_z62zc3z04anonymousza33009ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5978z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6065za7,
		BGl_z62zc3z04anonymousza33013ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5979z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6066za7,
		BGl_z62zc3z04anonymousza33016ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5980z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6067za7,
		BGl_z62zc3z04anonymousza33020ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5981z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6068za7,
		BGl_z62zc3z04anonymousza33023ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc5982z00zz__evaluate_compz00,
		BgL_bgl_za762za7c3za704anonymo6069za7,
		BGl_z62zc3z04anonymousza33027ze3ze5zz__evaluate_compz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00;
	extern obj_t BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00;
	extern obj_t BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00;
	extern obj_t BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00;
	extern obj_t BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00;
	extern obj_t BGl_za2zd2envz70zz__r4_numbers_6_5z00;
	extern obj_t BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5900z00zz__evaluate_compz00,
		BgL_bgl_string5900za700za7za7_6070za7, ">fx", 3);
	      DEFINE_STRING(BGl_string5902z00zz__evaluate_compz00,
		BgL_bgl_string5902za700za7za7_6071za7, "<=fx", 4);
	      DEFINE_STRING(BGl_string5904z00zz__evaluate_compz00,
		BgL_bgl_string5904za700za7za7_6072za7, ">=fx", 4);
	      DEFINE_STRING(BGl_string5906z00zz__evaluate_compz00,
		BgL_bgl_string5906za700za7za7_6073za7, "=fx", 3);
	      DEFINE_STRING(BGl_string5908z00zz__evaluate_compz00,
		BgL_bgl_string5908za700za7za7_6074za7, "+fl", 3);
	      DEFINE_STRING(BGl_string5910z00zz__evaluate_compz00,
		BgL_bgl_string5910za700za7za7_6075za7, "flonum", 6);
	      DEFINE_STRING(BGl_string5912z00zz__evaluate_compz00,
		BgL_bgl_string5912za700za7za7_6076za7, "-fl", 3);
	      DEFINE_STRING(BGl_string5914z00zz__evaluate_compz00,
		BgL_bgl_string5914za700za7za7_6077za7, "*fl", 3);
	      DEFINE_STRING(BGl_string5916z00zz__evaluate_compz00,
		BgL_bgl_string5916za700za7za7_6078za7, "/fl", 3);
	      DEFINE_STRING(BGl_string5918z00zz__evaluate_compz00,
		BgL_bgl_string5918za700za7za7_6079za7, "<fl", 3);
	extern obj_t BGl_zb2zd2envz60zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5920z00zz__evaluate_compz00,
		BgL_bgl_string5920za700za7za7_6080za7, ">fl", 3);
	      DEFINE_STRING(BGl_string5922z00zz__evaluate_compz00,
		BgL_bgl_string5922za700za7za7_6081za7, "<=fl", 4);
	      DEFINE_STRING(BGl_string5924z00zz__evaluate_compz00,
		BgL_bgl_string5924za700za7za7_6082za7, ">=fl", 4);
	      DEFINE_STRING(BGl_string5926z00zz__evaluate_compz00,
		BgL_bgl_string5926za700za7za7_6083za7, "=fl", 3);
	      DEFINE_STRING(BGl_string5928z00zz__evaluate_compz00,
		BgL_bgl_string5928za700za7za7_6084za7, "car", 3);
	extern obj_t BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00;
	   
		 
		DEFINE_STRING(BGl_string5930z00zz__evaluate_compz00,
		BgL_bgl_string5930za700za7za7_6085za7, "pair", 4);
	      DEFINE_STRING(BGl_string5932z00zz__evaluate_compz00,
		BgL_bgl_string5932za700za7za7_6086za7, "cdr", 3);
	      DEFINE_STRING(BGl_string5934z00zz__evaluate_compz00,
		BgL_bgl_string5934za700za7za7_6087za7, "cadr", 4);
	      DEFINE_STRING(BGl_string5936z00zz__evaluate_compz00,
		BgL_bgl_string5936za700za7za7_6088za7, "comp1389", 8);
	      DEFINE_STRING(BGl_string5937z00zz__evaluate_compz00,
		BgL_bgl_string5937za700za7za7_6089za7, "internal error: not defined for",
		31);
	      DEFINE_STRING(BGl_string5938z00zz__evaluate_compz00,
		BgL_bgl_string5938za700za7za7_6090za7, "&comp", 5);
	      DEFINE_STRING(BGl_string5940z00zz__evaluate_compz00,
		BgL_bgl_string5940za700za7za7_6091za7, "comp", 4);
	      DEFINE_STRING(BGl_string5962z00zz__evaluate_compz00,
		BgL_bgl_string5962za700za7za7_6092za7, "internal error", 14);
	extern obj_t BGl_zc3zd2envz11zz__r4_numbers_6_5z00;
	   
		 
		DEFINE_STRING(BGl_string5963z00zz__evaluate_compz00,
		BgL_bgl_string5963za700za7za7_6093za7, "must be dead code", 17);
	      DEFINE_STRING(BGl_string5965z00zz__evaluate_compz00,
		BgL_bgl_string5965za700za7za7_6094za7, "notyet", 6);
	      DEFINE_STRING(BGl_string5966z00zz__evaluate_compz00,
		BgL_bgl_string5966za700za7za7_6095za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string5967z00zz__evaluate_compz00,
		BgL_bgl_string5967za700za7za7_6096za7, "mutex", 5);
	      DEFINE_STRING(BGl_string5968z00zz__evaluate_compz00,
		BgL_bgl_string5968za700za7za7_6097za7, "set!", 4);
	      DEFINE_STRING(BGl_string5969z00zz__evaluate_compz00,
		BgL_bgl_string5969za700za7za7_6098za7, "read-only variable", 18);
	extern obj_t BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00;
	   
		 
		DEFINE_STRING(BGl_string5970z00zz__evaluate_compz00,
		BgL_bgl_string5970za700za7za7_6099za7,
		"\nRedefinition of compiled variable -- ", 38);
	      DEFINE_STRING(BGl_string5971z00zz__evaluate_compz00,
		BgL_bgl_string5971za700za7za7_6100za7, "Unbound variable", 16);
	      DEFINE_STRING(BGl_string5973z00zz__evaluate_compz00,
		BgL_bgl_string5973za700za7za7_6101za7, "@", 1);
	      DEFINE_STRING(BGl_string5974z00zz__evaluate_compz00,
		BgL_bgl_string5974za700za7za7_6102za7, "Uninitialized variable", 22);

/* GC roots registration */
	static obj_t bgl_gc_roots_register()
	{
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
		void *roots_min = (void *) ULONG_MAX, *roots_max = 0;
		   
			 ADD_ROOT((void *) (&BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5839z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5841z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5843z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5849z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5857z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5859z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5861z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5864z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5867z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5869z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5871z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5873z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5875z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5877z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5879z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5881z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5883z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5885z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5887z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5889z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5891z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5893z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5895z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5897z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5899z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_requirezd2initializa7ationz75zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5901z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5903z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5905z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5907z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5909z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5911z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5913z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5915z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5917z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5919z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5921z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5923z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5925z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5927z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5929z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5931z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5933z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5964z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5972z00zz__evaluate_compz00));
		   
			 ADD_ROOT((void
				*) (&BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5983z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5985z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5987z00zz__evaluate_compz00));
		     ADD_ROOT((void *) (&BGl_symbol5989z00zz__evaluate_compz00));
#undef ADD_ROOT
		if   (roots_max > 0)
			     GC_add_roots(roots_min, ((void **) roots_max) + 1);
#endif
		     return BUNSPEC;
	}



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long
		BgL_checksumz00_18391, char *BgL_fromz00_18392)
	{
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluate_compz00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluate_compz00 =
						BBOOL(((bool_t) 0));
					BGl_gczd2rootszd2initz00zz__evaluate_compz00();
					BGl_cnstzd2initzd2zz__evaluate_compz00();
					BGl_importedzd2moduleszd2initz00zz__evaluate_compz00();
					BGl_genericzd2initzd2zz__evaluate_compz00();
					BGl_methodzd2initzd2zz__evaluate_compz00();
					return BGl_toplevelzd2initzd2zz__evaluate_compz00();
				}
			else
				{
					return BUNSPEC;
				}
		}

	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_symbol5839z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5840z00zz__evaluate_compz00);
			BGl_symbol5841z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5842z00zz__evaluate_compz00);
			BGl_symbol5843z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5844z00zz__evaluate_compz00);
			BGl_symbol5849z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5850z00zz__evaluate_compz00);
			BGl_symbol5857z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5858z00zz__evaluate_compz00);
			BGl_symbol5859z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5860z00zz__evaluate_compz00);
			BGl_symbol5861z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5862z00zz__evaluate_compz00);
			BGl_symbol5864z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5865z00zz__evaluate_compz00);
			BGl_symbol5867z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5868z00zz__evaluate_compz00);
			BGl_symbol5869z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5870z00zz__evaluate_compz00);
			BGl_symbol5871z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5872z00zz__evaluate_compz00);
			BGl_symbol5873z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5874z00zz__evaluate_compz00);
			BGl_symbol5875z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5876z00zz__evaluate_compz00);
			BGl_symbol5877z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5878z00zz__evaluate_compz00);
			BGl_symbol5879z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5880z00zz__evaluate_compz00);
			BGl_symbol5881z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5882z00zz__evaluate_compz00);
			BGl_symbol5883z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5884z00zz__evaluate_compz00);
			BGl_symbol5885z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5886z00zz__evaluate_compz00);
			BGl_symbol5887z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5888z00zz__evaluate_compz00);
			BGl_symbol5889z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5890z00zz__evaluate_compz00);
			BGl_symbol5891z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5892z00zz__evaluate_compz00);
			BGl_symbol5893z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5894z00zz__evaluate_compz00);
			BGl_symbol5895z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5896z00zz__evaluate_compz00);
			BGl_symbol5897z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5898z00zz__evaluate_compz00);
			BGl_symbol5899z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5900z00zz__evaluate_compz00);
			BGl_symbol5901z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5902z00zz__evaluate_compz00);
			BGl_symbol5903z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5904z00zz__evaluate_compz00);
			BGl_symbol5905z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5906z00zz__evaluate_compz00);
			BGl_symbol5907z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5908z00zz__evaluate_compz00);
			BGl_symbol5909z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5910z00zz__evaluate_compz00);
			BGl_symbol5911z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5912z00zz__evaluate_compz00);
			BGl_symbol5913z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5914z00zz__evaluate_compz00);
			BGl_symbol5915z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5916z00zz__evaluate_compz00);
			BGl_symbol5917z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5918z00zz__evaluate_compz00);
			BGl_symbol5919z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5920z00zz__evaluate_compz00);
			BGl_symbol5921z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5922z00zz__evaluate_compz00);
			BGl_symbol5923z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5924z00zz__evaluate_compz00);
			BGl_symbol5925z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5926z00zz__evaluate_compz00);
			BGl_symbol5927z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5928z00zz__evaluate_compz00);
			BGl_symbol5929z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5930z00zz__evaluate_compz00);
			BGl_symbol5931z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5932z00zz__evaluate_compz00);
			BGl_symbol5933z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5934z00zz__evaluate_compz00);
			BGl_symbol5964z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5965z00zz__evaluate_compz00);
			BGl_symbol5972z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5973z00zz__evaluate_compz00);
			BGl_symbol5983z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5984z00zz__evaluate_compz00);
			BGl_symbol5985z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5986z00zz__evaluate_compz00);
			BGl_symbol5987z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5988z00zz__evaluate_compz00);
			return (BGl_symbol5989z00zz__evaluate_compz00 =
				bstring_to_symbol(BGl_string5990z00zz__evaluate_compz00), BUNSPEC);
		}

	}



/* gc-roots-init */
	obj_t BGl_gczd2rootszd2initz00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return bgl_gc_roots_register();
		}

	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			{	/* Eval/evaluate_comp.scm 114 */
				BGL_LONGLONG_T BgL_arg1505z00_1352;

				{	/* Eval/evaluate_comp.scm 114 */
					BGL_LONGLONG_T BgL_res4361z00_6424;

					BgL_res4361z00_6424 = LONG_TO_LLONG(((long) 0));
					BgL_arg1505z00_1352 = BgL_res4361z00_6424;
				}
				{	/* Eval/evaluate_comp.scm 114 */
					obj_t BgL_list1508z00_1353;

					{	/* Eval/evaluate_comp.scm 114 */
						obj_t BgL_arg1510z00_1354;

						BgL_arg1510z00_1354 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1505z00_1352), BNIL);
						BgL_list1508z00_1353 =
							MAKE_YOUNG_PAIR(BGl_symbol5839z00zz__evaluate_compz00,
							BgL_arg1510z00_1354);
					}
					BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1508z00_1353;
			}}
			BGl_za2za2siza7ezd2stackza2za2z75zz__evaluate_compz00 = ((long) 8192);
			BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5841z00zz__evaluate_compz00,
				(int) (((long) 0)));
			BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00 =
				create_struct(BGl_symbol5843z00zz__evaluate_compz00,
				(int) (((long) 0)));
			return BUNSPEC;
		}

	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluate_compz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		{
			{
				obj_t BgL_headz00_1355;

				BgL_headz00_1355 = MAKE_YOUNG_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_6449;
					obj_t BgL_tailz00_6450;

					BgL_prevz00_6449 = BgL_headz00_1355;
					BgL_tailz00_6450 = BgL_l1z00_1;
				BgL_loopz00_6448:
					if (PAIRP(BgL_tailz00_6450))
						{
							obj_t BgL_newzd2prevzd2_6456;

							BgL_newzd2prevzd2_6456 =
								MAKE_YOUNG_PAIR(CAR(BgL_tailz00_6450), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_6449, BgL_newzd2prevzd2_6456);
							{
								obj_t BgL_tailz00_18466;
								obj_t BgL_prevz00_18465;

								BgL_prevz00_18465 = BgL_newzd2prevzd2_6456;
								BgL_tailz00_18466 = CDR(BgL_tailz00_6450);
								BgL_tailz00_6450 = BgL_tailz00_18466;
								BgL_prevz00_6449 = BgL_prevz00_18465;
								goto BgL_loopz00_6448;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1355);
			}
		}

	}



/* reset_profile */
	obj_t BGl_reset_profilez00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 132 */
			{	/* Eval/evaluate_comp.scm 133 */
				BGL_LONGLONG_T BgL_arg1530z00_1383;

				{	/* Eval/evaluate_comp.scm 133 */
					BGL_LONGLONG_T BgL_res4370z00_6464;

					BgL_res4370z00_6464 = LONG_TO_LLONG(((long) 0));
					BgL_arg1530z00_1383 = BgL_res4370z00_6464;
				}
				{	/* Eval/evaluate_comp.scm 133 */
					obj_t BgL_list1531z00_1384;

					{	/* Eval/evaluate_comp.scm 133 */
						obj_t BgL_arg1532z00_1385;

						BgL_arg1532z00_1385 =
							MAKE_YOUNG_PAIR(make_bllong(BgL_arg1530z00_1383), BNIL);
						BgL_list1531z00_1384 =
							MAKE_YOUNG_PAIR(BGl_symbol5839z00zz__evaluate_compz00,
							BgL_arg1532z00_1385);
					}
					return (BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00 =
						BgL_list1531z00_1384, BUNSPEC);
				}
			}
		}

	}



/* o->s~0 */
	obj_t BGl_ozd2ze3sze70zd6zz__evaluate_compz00(obj_t BgL_vz00_1394)
	{
		{	/* Eval/evaluate_comp.scm 141 */
			if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_vz00_1394))
				{	/* Ieee/fixnum.scm 979 */

					return
						BGl_integerzd2ze3stringz31zz__r4_numbers_6_5_fixnumz00(
						(long) CINT(BgL_vz00_1394), ((long) 10));
				}
			else
				{	/* Eval/evaluate_comp.scm 138 */
					if (SYMBOLP(BgL_vz00_1394))
						{	/* Eval/evaluate_comp.scm 139 */
							obj_t BgL_res4373z00_6469;

							{	/* Eval/evaluate_comp.scm 139 */
								obj_t BgL_arg4208z00_6468;

								BgL_arg4208z00_6468 = SYMBOL_TO_STRING(BgL_vz00_1394);
								BgL_res4373z00_6469 =
									BGl_stringzd2copyzd2zz__r4_strings_6_7z00
									(BgL_arg4208z00_6468);
							}
							return BgL_res4373z00_6469;
						}
					else
						{	/* Eval/evaluate_comp.scm 139 */
							if (STRINGP(BgL_vz00_1394))
								{	/* Eval/evaluate_comp.scm 140 */
									return BgL_vz00_1394;
								}
							else
								{	/* Eval/evaluate_comp.scm 140 */
									return BGl_string5845z00zz__evaluate_compz00;
								}
						}
				}
		}

	}



/* &<lexint */
	obj_t BGl_z62zc3lexintza1zz__evaluate_compz00(obj_t BgL_envz00_13569,
		obj_t BgL_t1z00_13570, obj_t BgL_t2z00_13571)
	{
		{	/* Eval/evaluate_comp.scm 135 */
			{	/* Eval/evaluate_comp.scm 138 */
				bool_t BgL_tmpz00_18483;

				{	/* Eval/evaluate_comp.scm 142 */
					obj_t BgL_v1z00_15560;
					obj_t BgL_v2z00_15561;

					BgL_v1z00_15560 = CAR(((obj_t) BgL_t1z00_13570));
					BgL_v2z00_15561 = CAR(((obj_t) BgL_t2z00_13571));
					{	/* Eval/evaluate_comp.scm 143 */
						bool_t BgL_test6108z00_18488;

						if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(BgL_v1z00_15560))
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_test6108z00_18488 =
									BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BgL_v2z00_15561);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_test6108z00_18488 = ((bool_t) 0);
							}
						if (BgL_test6108z00_18488)
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_18483 =
									BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_v1z00_15560,
									BgL_v2z00_15561);
							}
						else
							{	/* Eval/evaluate_comp.scm 143 */
								BgL_tmpz00_18483 =
									bigloo_string_lt(BGl_ozd2ze3sze70zd6zz__evaluate_compz00
									(BgL_v1z00_15560),
									BGl_ozd2ze3sze70zd6zz__evaluate_compz00(BgL_v2z00_15561));
							}
					}
				}
				return BBOOL(BgL_tmpz00_18483);
			}
		}

	}



/* get_profile */
	obj_t BGl_get_profilez00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 147 */
			BGl_recze71ze7zz__evaluate_compz00
				(BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00);
			return BGl_za2za2prof_resultsza2za2z00zz__evaluate_compz00;
		}

	}



/* rec~1 */
	bool_t BGl_recze71ze7zz__evaluate_compz00(obj_t BgL_tz00_1403)
	{
		{	/* Eval/evaluate_comp.scm 148 */
			{	/* Eval/evaluate_comp.scm 149 */
				obj_t BgL_arg1543z00_1405;
				obj_t BgL_arg1545z00_1406;

				BgL_arg1543z00_1405 = CDR(((obj_t) BgL_tz00_1403));
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_arg1546z00_1407;

					{	/* Eval/evaluate_comp.scm 149 */
						obj_t BgL_pairz00_6480;

						BgL_pairz00_6480 = CDR(((obj_t) BgL_tz00_1403));
						BgL_arg1546z00_1407 = CDR(BgL_pairz00_6480);
					}
					BgL_arg1545z00_1406 =
						BGl_sortz00zz__r4_vectors_6_8z00
						(BGl_zc3lexintzd2envz11zz__evaluate_compz00, BgL_arg1546z00_1407);
				}
				{	/* Eval/evaluate_comp.scm 149 */
					obj_t BgL_tmpz00_18504;

					BgL_tmpz00_18504 = ((obj_t) BgL_arg1543z00_1405);
					SET_CDR(BgL_tmpz00_18504, BgL_arg1545z00_1406);
				}
			}
			{	/* Eval/evaluate_comp.scm 150 */
				obj_t BgL_g1291z00_1408;

				{	/* Eval/evaluate_comp.scm 150 */
					obj_t BgL_pairz00_6485;

					BgL_pairz00_6485 = CDR(((obj_t) BgL_tz00_1403));
					BgL_g1291z00_1408 = CDR(BgL_pairz00_6485);
				}
				{
					obj_t BgL_l1289z00_6499;

					BgL_l1289z00_6499 = BgL_g1291z00_1408;
				BgL_zc3z04anonymousza31547ze3z87_6498:
					if (PAIRP(BgL_l1289z00_6499))
						{	/* Eval/evaluate_comp.scm 150 */
							BGl_recze71ze7zz__evaluate_compz00(CAR(BgL_l1289z00_6499));
							{
								obj_t BgL_l1289z00_18514;

								BgL_l1289z00_18514 = CDR(BgL_l1289z00_6499);
								BgL_l1289z00_6499 = BgL_l1289z00_18514;
								goto BgL_zc3z04anonymousza31547ze3z87_6498;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 150 */
							return ((bool_t) 1);
						}
				}
			}
		}

	}



/* index */
	obj_t BGl_indexz00zz__evaluate_compz00(obj_t BgL_xz00_6, obj_t BgL_lz00_7)
	{
		{	/* Eval/evaluate_comp.scm 156 */
			{
				obj_t BgL_lz00_6530;
				long BgL_nz00_6531;

				BgL_lz00_6530 = BgL_lz00_7;
				BgL_nz00_6531 = ((long) 0);
			BgL_walkz00_6529:
				if (NULLP(BgL_lz00_6530))
					{	/* Eval/evaluate_comp.scm 158 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate_comp.scm 158 */
						if ((BgL_xz00_6 == CAR(((obj_t) BgL_lz00_6530))))
							{	/* Eval/evaluate_comp.scm 159 */
								return BINT(BgL_nz00_6531);
							}
						else
							{
								long BgL_nz00_18526;
								obj_t BgL_lz00_18523;

								BgL_lz00_18523 = CDR(((obj_t) BgL_lz00_6530));
								BgL_nz00_18526 = (BgL_nz00_6531 + ((long) 1));
								BgL_nz00_6531 = BgL_nz00_18526;
								BgL_lz00_6530 = BgL_lz00_18523;
								goto BgL_walkz00_6529;
							}
					}
			}
		}

	}



/* _index */
	obj_t BGl__indexz00zz__evaluate_compz00(obj_t BgL_xz00_8, obj_t BgL_lz00_9)
	{
		{	/* Eval/evaluate_comp.scm 163 */
			{	/* Eval/evaluate_comp.scm 164 */
				obj_t BgL__ortest_1079z00_1428;

				BgL__ortest_1079z00_1428 =
					BGl_indexz00zz__evaluate_compz00(BgL_xz00_8, BgL_lz00_9);
				if (CBOOL(BgL__ortest_1079z00_1428))
					{	/* Eval/evaluate_comp.scm 164 */
						return BgL__ortest_1079z00_1428;
					}
				else
					{	/* Eval/evaluate_comp.scm 164 */
						obj_t BgL_arg1560z00_1429;

						{	/* Eval/evaluate_comp.scm 164 */
							obj_t BgL_arg1563z00_1430;

							if (NULLP(BgL_lz00_9))
								{	/* Eval/evaluate_comp.scm 164 */
									BgL_arg1563z00_1430 = BNIL;
								}
							else
								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_head1294z00_1436;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1573z00_1448;

										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_arg1574z00_1449;

											BgL_arg1574z00_1449 = CAR(((obj_t) BgL_lz00_9));
											if (BGl_isazf3zf3zz__objectz00(BgL_arg1574z00_1449,
													BGl_ev_varz00zz__evaluate_typesz00))
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1573z00_1448 =
														(((BgL_ev_varz00_bglt) COBJECT(
																((BgL_ev_varz00_bglt) BgL_arg1574z00_1449)))->
														BgL_namez00);
												}
											else
												{	/* Eval/evaluate_comp.scm 189 */
													BgL_arg1573z00_1448 = BgL_arg1574z00_1449;
												}
										}
										{	/* Eval/evaluate_comp.scm 164 */
											obj_t BgL_res4386z00_6551;

											BgL_res4386z00_6551 =
												MAKE_YOUNG_PAIR(BgL_arg1573z00_1448, BNIL);
											BgL_head1294z00_1436 = BgL_res4386z00_6551;
										}
									}
									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_g1297z00_1437;

										BgL_g1297z00_1437 = CDR(((obj_t) BgL_lz00_9));
										{
											obj_t BgL_l1292z00_6576;
											obj_t BgL_tail1295z00_6577;

											BgL_l1292z00_6576 = BgL_g1297z00_1437;
											BgL_tail1295z00_6577 = BgL_head1294z00_1436;
										BgL_zc3z04anonymousza31568ze3z87_6575:
											if (NULLP(BgL_l1292z00_6576))
												{	/* Eval/evaluate_comp.scm 164 */
													BgL_arg1563z00_1430 = BgL_head1294z00_1436;
												}
											else
												{	/* Eval/evaluate_comp.scm 164 */
													obj_t BgL_newtail1296z00_6584;

													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1571z00_6585;

														BgL_arg1571z00_6585 =
															BGl_lnamez00zz__evaluate_compz00(CAR(
																((obj_t) BgL_l1292z00_6576)));
														{	/* Eval/evaluate_comp.scm 164 */
															obj_t BgL_res4392z00_6590;

															BgL_res4392z00_6590 =
																MAKE_YOUNG_PAIR(BgL_arg1571z00_6585, BNIL);
															BgL_newtail1296z00_6584 = BgL_res4392z00_6590;
														}
													}
													SET_CDR(BgL_tail1295z00_6577,
														BgL_newtail1296z00_6584);
													{	/* Eval/evaluate_comp.scm 164 */
														obj_t BgL_arg1570z00_6587;

														BgL_arg1570z00_6587 =
															CDR(((obj_t) BgL_l1292z00_6576));
														{
															obj_t BgL_tail1295z00_18552;
															obj_t BgL_l1292z00_18551;

															BgL_l1292z00_18551 = BgL_arg1570z00_6587;
															BgL_tail1295z00_18552 = BgL_newtail1296z00_6584;
															BgL_tail1295z00_6577 = BgL_tail1295z00_18552;
															BgL_l1292z00_6576 = BgL_l1292z00_18551;
															goto BgL_zc3z04anonymousza31568ze3z87_6575;
														}
													}
												}
										}
									}
								}
							{	/* Eval/evaluate_comp.scm 164 */
								obj_t BgL_list1564z00_1431;

								{	/* Eval/evaluate_comp.scm 164 */
									obj_t BgL_arg1565z00_1432;

									{	/* Eval/evaluate_comp.scm 164 */
										obj_t BgL_arg1566z00_1433;

										BgL_arg1566z00_1433 =
											MAKE_YOUNG_PAIR(BgL_arg1563z00_1430, BNIL);
										BgL_arg1565z00_1432 =
											MAKE_YOUNG_PAIR(BGl_string5846z00zz__evaluate_compz00,
											BgL_arg1566z00_1433);
									}
									BgL_list1564z00_1431 =
										MAKE_YOUNG_PAIR(BgL_xz00_8, BgL_arg1565z00_1432);
								}
								BgL_arg1560z00_1429 = BgL_list1564z00_1431;
							}
						}
						return
							BGl_errorz00zz__errorz00(BGl_string5847z00zz__evaluate_compz00,
							BGl_string5848z00zz__evaluate_compz00, BgL_arg1560z00_1429);
					}
			}
		}

	}



/* lname */
	obj_t BGl_lnamez00zz__evaluate_compz00(obj_t BgL_vz00_16)
	{
		{	/* Eval/evaluate_comp.scm 188 */
			if (BGl_isazf3zf3zz__objectz00(BgL_vz00_16,
					BGl_ev_varz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 189 */
					return
						(((BgL_ev_varz00_bglt) COBJECT(
								((BgL_ev_varz00_bglt) BgL_vz00_16)))->BgL_namez00);
				}
			else
				{	/* Eval/evaluate_comp.scm 189 */
					return BgL_vz00_16;
				}
		}

	}



/* loc-type-error */
	obj_t BGl_loczd2typezd2errorz00zz__evaluate_compz00(obj_t BgL_fz00_17,
		obj_t BgL_mz00_18, obj_t BgL_vz00_19, obj_t BgL_locz00_20)
	{
		{	/* Eval/evaluate_comp.scm 193 */
			if (PAIRP(BgL_locz00_20))
				{	/* Eval/evaluate_comp.scm 194 */
					obj_t BgL_cdrzd2194zd2_1475;

					BgL_cdrzd2194zd2_1475 = CDR(BgL_locz00_20);
					if ((CAR(BgL_locz00_20) == BGl_symbol5849z00zz__evaluate_compz00))
						{	/* Eval/evaluate_comp.scm 194 */
							if (PAIRP(BgL_cdrzd2194zd2_1475))
								{	/* Eval/evaluate_comp.scm 194 */
									obj_t BgL_cdrzd2198zd2_1479;

									BgL_cdrzd2198zd2_1479 = CDR(BgL_cdrzd2194zd2_1475);
									if (PAIRP(BgL_cdrzd2198zd2_1479))
										{	/* Eval/evaluate_comp.scm 194 */
											if (NULLP(CDR(BgL_cdrzd2198zd2_1479)))
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorzf2locationzf2zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19,
														CAR(BgL_cdrzd2194zd2_1475),
														CAR(BgL_cdrzd2198zd2_1479));
												}
											else
												{	/* Eval/evaluate_comp.scm 194 */
													return
														BGl_bigloozd2typezd2errorz00zz__errorz00
														(BgL_fz00_17, BgL_mz00_18, BgL_vz00_19);
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 194 */
											return
												BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
												BgL_mz00_18, BgL_vz00_19);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 194 */
									return
										BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
										BgL_mz00_18, BgL_vz00_19);
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 194 */
							return
								BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17,
								BgL_mz00_18, BgL_vz00_19);
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 194 */
					return
						BGl_bigloozd2typezd2errorz00zz__errorz00(BgL_fz00_17, BgL_mz00_18,
						BgL_vz00_19);
				}
		}

	}



/* make-state */
	obj_t BGl_makezd2statezd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 206 */
			{	/* Eval/evaluate_comp.scm 207 */
				obj_t BgL_stkz00_1497;

				BgL_stkz00_1497 =
					make_vector(((long) 8192), BGl_string5851z00zz__evaluate_compz00);
				VECTOR_SET(BgL_stkz00_1497, ((long) 0), BINT(((long) 2)));
				return BgL_stkz00_1497;
			}
		}

	}



/* find-state */
	BGL_EXPORTED_DEF obj_t BGl_findzd2statezd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 211 */
			{	/* Eval/evaluate_comp.scm 212 */
				obj_t BgL_sz00_1498;

				{	/* Eval/evaluate_comp.scm 212 */
					obj_t BgL_tmpz00_18586;

					BgL_tmpz00_18586 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_1498 = BGL_ENV_EVSTATE(BgL_tmpz00_18586);
				}
				if (VECTORP(BgL_sz00_1498))
					{	/* Eval/evaluate_comp.scm 213 */
						return BgL_sz00_1498;
					}
				else
					{	/* Eval/evaluate_comp.scm 214 */
						obj_t BgL_statez00_1500;

						BgL_statez00_1500 = BGl_makezd2statezd2zz__evaluate_compz00();
						{	/* Eval/evaluate_comp.scm 215 */
							obj_t BgL_tmpz00_18592;

							BgL_tmpz00_18592 = BGL_CURRENT_DYNAMIC_ENV();
							BGL_ENV_EVSTATE_SET(BgL_tmpz00_18592, BgL_statez00_1500);
						}
						return BgL_statez00_1500;
					}
			}
		}

	}



/* &find-state */
	obj_t BGl_z62findzd2statezb0zz__evaluate_compz00(obj_t BgL_envz00_13572)
	{
		{	/* Eval/evaluate_comp.scm 211 */
			return BGl_findzd2statezd2zz__evaluate_compz00();
		}

	}



/* compile */
	BGL_EXPORTED_DEF obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_34)
	{
		{	/* Eval/evaluate_comp.scm 273 */
			return BGl_compz00zz__evaluate_compz00(BgL_ez00_34, BNIL);
		}

	}



/* &compile */
	obj_t BGl_z62compilez62zz__evaluate_compz00(obj_t BgL_envz00_13573,
		obj_t BgL_ez00_13574)
	{
		{	/* Eval/evaluate_comp.scm 273 */
			{	/* Eval/evaluate_comp.scm 274 */
				BgL_ev_exprz00_bglt BgL_auxz00_18597;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_13574,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 274 */
						BgL_auxz00_18597 = ((BgL_ev_exprz00_bglt) BgL_ez00_13574);
					}
				else
					{
						obj_t BgL_auxz00_18601;

						BgL_auxz00_18601 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5852z00zz__evaluate_compz00, BINT(((long) 7006)),
							BGl_string5853z00zz__evaluate_compz00,
							BGl_string5854z00zz__evaluate_compz00, BgL_ez00_13574);
						FAILURE(BgL_auxz00_18601, BFALSE, BFALSE);
					}
				return BGl_compilez00zz__evaluate_compz00(BgL_auxz00_18597);
			}
		}

	}



/* global-fun-value */
	obj_t BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_ez00_43)
	{
		{	/* Eval/evaluate_comp.scm 332 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_ez00_43), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 335 */
					obj_t BgL_gz00_1556;

					{	/* Eval/evaluate_comp.scm 335 */
						obj_t BgL_arg1662z00_1557;
						obj_t BgL_arg1663z00_1558;

						BgL_arg1662z00_1557 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_modz00);
						BgL_arg1663z00_1558 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_ez00_43)))->BgL_namez00);
						BgL_gz00_1556 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg1662z00_1557, BgL_arg1663z00_1558);
					}
					if (CBOOL(BgL_gz00_1556))
						{	/* Eval/evaluate_comp.scm 336 */
							return VECTOR_REF(((obj_t) BgL_gz00_1556), ((long) 2));
						}
					else
						{	/* Eval/evaluate_comp.scm 336 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 333 */
					return BFALSE;
				}
		}

	}



/* push-boxes-args-on-sp */
	obj_t BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00(obj_t
		BgL_sz00_82, obj_t BgL_argsz00_83, obj_t BgL_boxesz00_84, long BgL_spz00_85,
		obj_t BgL_locz00_86)
	{
		{	/* Eval/evaluate_comp.scm 623 */
			{
				obj_t BgL_lz00_1578;
				obj_t BgL_bsz00_1579;
				long BgL_spz00_1580;

				BgL_lz00_1578 = BgL_argsz00_83;
				BgL_bsz00_1579 = BgL_boxesz00_84;
				BgL_spz00_1580 = BgL_spz00_85;
			BgL_zc3z04anonymousza31680ze3z87_1581:
				if (NULLP(BgL_lz00_1578))
					{	/* Eval/evaluate_comp.scm 625 */
						if (NULLP(BgL_bsz00_1579))
							{	/* Eval/evaluate_comp.scm 626 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 629 */
								obj_t BgL_arg1684z00_1584;

								{	/* Eval/evaluate_comp.scm 629 */
									long BgL_arg1685z00_1585;
									long BgL_arg1689z00_1586;

									BgL_arg1685z00_1585 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1689z00_1586 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 628 */
										obj_t BgL_list1690z00_1587;

										{	/* Eval/evaluate_comp.scm 628 */
											obj_t BgL_arg1695z00_1588;

											BgL_arg1695z00_1588 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1689z00_1586), BNIL);
											BgL_list1690z00_1587 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1685z00_1585),
												BgL_arg1695z00_1588);
										}
										BgL_arg1684z00_1584 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5855z00zz__evaluate_compz00,
											BgL_list1690z00_1587);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5856z00zz__evaluate_compz00, BgL_arg1684z00_1584);
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 625 */
						if (NULLP(BgL_bsz00_1579))
							{	/* Eval/evaluate_comp.scm 633 */
								obj_t BgL_arg1698z00_1590;

								{	/* Eval/evaluate_comp.scm 633 */
									long BgL_arg1699z00_1591;
									long BgL_arg1700z00_1592;

									BgL_arg1699z00_1591 = bgl_list_length(BgL_boxesz00_84);
									BgL_arg1700z00_1592 = bgl_list_length(BgL_argsz00_83);
									{	/* Eval/evaluate_comp.scm 632 */
										obj_t BgL_list1701z00_1593;

										{	/* Eval/evaluate_comp.scm 632 */
											obj_t BgL_arg1702z00_1594;

											BgL_arg1702z00_1594 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1700z00_1592), BNIL);
											BgL_list1701z00_1593 =
												MAKE_YOUNG_PAIR(BINT(BgL_arg1699z00_1591),
												BgL_arg1702z00_1594);
										}
										BgL_arg1698z00_1590 =
											BGl_formatz00zz__r4_output_6_10_3z00
											(BGl_string5855z00zz__evaluate_compz00,
											BgL_list1701z00_1593);
								}}
								return
									BGl_everrorz00zz__everrorz00(BgL_locz00_86,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5856z00zz__evaluate_compz00, BgL_arg1698z00_1590);
							}
						else
							{	/* Eval/evaluate_comp.scm 630 */
								{	/* Eval/evaluate_comp.scm 636 */
									obj_t BgL_arg1703z00_1595;

									{	/* Eval/evaluate_comp.scm 636 */
										obj_t BgL_vz00_1596;

										{	/* Eval/evaluate_comp.scm 636 */
											obj_t BgL_fun1705z00_1598;

											BgL_fun1705z00_1598 = CAR(((obj_t) BgL_lz00_1578));
											BgL_vz00_1596 =
												PROCEDURE_ENTRY(BgL_fun1705z00_1598)
												(BgL_fun1705z00_1598, BgL_sz00_82, BEOA);
										}
										if (CBOOL(CAR(((obj_t) BgL_bsz00_1579))))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_6640;

												BgL_newz00_6640 =
													create_struct(BGl_symbol5857z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_18652;

													BgL_tmpz00_18652 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_6640, BgL_tmpz00_18652,
														BgL_vz00_1596);
												}
												BgL_arg1703z00_1595 = BgL_newz00_6640;
											}
										else
											{	/* Eval/evaluate_comp.scm 637 */
												BgL_arg1703z00_1595 = BgL_vz00_1596;
											}
									}
									VECTOR_SET(
										((obj_t) BgL_sz00_82), BgL_spz00_1580, BgL_arg1703z00_1595);
								}
								{	/* Eval/evaluate_comp.scm 640 */
									obj_t BgL_arg1706z00_1599;
									obj_t BgL_arg1708z00_1600;
									long BgL_arg1709z00_1601;

									BgL_arg1706z00_1599 = CDR(((obj_t) BgL_lz00_1578));
									BgL_arg1708z00_1600 = CDR(((obj_t) BgL_bsz00_1579));
									BgL_arg1709z00_1601 = (BgL_spz00_1580 + ((long) 1));
									{
										long BgL_spz00_18664;
										obj_t BgL_bsz00_18663;
										obj_t BgL_lz00_18662;

										BgL_lz00_18662 = BgL_arg1706z00_1599;
										BgL_bsz00_18663 = BgL_arg1708z00_1600;
										BgL_spz00_18664 = BgL_arg1709z00_1601;
										BgL_spz00_1580 = BgL_spz00_18664;
										BgL_bsz00_1579 = BgL_bsz00_18663;
										BgL_lz00_1578 = BgL_lz00_18662;
										goto BgL_zc3z04anonymousza31680ze3z87_1581;
									}
								}
							}
					}
			}
		}

	}



/* sub-stk */
	obj_t BGl_subzd2stkzd2zz__evaluate_compz00(obj_t BgL_l1z00_88,
		obj_t BgL_l2z00_89)
	{
		{	/* Eval/evaluate_comp.scm 645 */
		BGl_subzd2stkzd2zz__evaluate_compz00:
			if (NULLP(BgL_l1z00_88))
				{	/* Eval/evaluate_comp.scm 646 */
					return BgL_l2z00_89;
				}
			else
				{	/* Eval/evaluate_comp.scm 646 */
					if ((CAR(((obj_t) BgL_l1z00_88)) == CAR(((obj_t) BgL_l2z00_89))))
						{	/* Eval/evaluate_comp.scm 649 */
							obj_t BgL_arg1714z00_1607;
							obj_t BgL_arg1715z00_1608;

							BgL_arg1714z00_1607 = CDR(((obj_t) BgL_l1z00_88));
							BgL_arg1715z00_1608 = CDR(((obj_t) BgL_l2z00_89));
							{
								obj_t BgL_l2z00_18678;
								obj_t BgL_l1z00_18677;

								BgL_l1z00_18677 = BgL_arg1714z00_1607;
								BgL_l2z00_18678 = BgL_arg1715z00_1608;
								BgL_l2z00_89 = BgL_l2z00_18678;
								BgL_l1z00_88 = BgL_l1z00_18677;
								goto BGl_subzd2stkzd2zz__evaluate_compz00;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 647 */
							return
								BGl_errorz00zz__errorz00(BGl_string5847z00zz__evaluate_compz00,
								BGl_symbol5859z00zz__evaluate_compz00,
								BGl_symbol5861z00zz__evaluate_compz00);
						}
				}
		}

	}



/* catch-trampoline */
	obj_t BGl_catchzd2trampolinezd2zz__evaluate_compz00(obj_t BgL_fz00_93,
		obj_t BgL_sz00_94, obj_t BgL_bpz00_95)
	{
		{	/* Eval/evaluate_comp.scm 669 */
			{	/* Eval/evaluate_comp.scm 670 */
				obj_t BgL_savedzd2bpzd2_1619;

				BgL_savedzd2bpzd2_1619 = VECTOR_REF(((obj_t) BgL_sz00_94), ((long) 0));
				VECTOR_SET(((obj_t) BgL_sz00_94), ((long) 0), BgL_bpz00_95);
				{
					obj_t BgL_fz00_1621;

					BgL_fz00_1621 = BgL_fz00_93;
				BgL_zc3z04anonymousza31727ze3z87_1622:
					{	/* Eval/evaluate_comp.scm 673 */
						obj_t BgL_rz00_1623;

						BgL_rz00_1623 =
							PROCEDURE_ENTRY(BgL_fz00_1621) (BgL_fz00_1621, BgL_sz00_94, BEOA);
						{	/* Eval/evaluate_comp.scm 674 */
							bool_t BgL_test6133z00_18688;

							if (PROCEDUREP(BgL_rz00_1623))
								{	/* Eval/evaluate_comp.scm 674 */
									obj_t BgL_arg1732z00_1628;

									BgL_arg1732z00_1628 = PROCEDURE_ATTR(BgL_rz00_1623);
									if (STRUCTP(BgL_arg1732z00_1628))
										{	/* Eval/evaluate_comp.scm 654 */
											BgL_test6133z00_18688 =
												(STRUCT_KEY(BgL_arg1732z00_1628) ==
												BGl_symbol5843z00zz__evaluate_compz00);
										}
									else
										{	/* Eval/evaluate_comp.scm 654 */
											BgL_test6133z00_18688 = ((bool_t) 0);
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 674 */
									BgL_test6133z00_18688 = ((bool_t) 0);
								}
							if (BgL_test6133z00_18688)
								{
									obj_t BgL_fz00_18696;

									BgL_fz00_18696 = BgL_rz00_1623;
									BgL_fz00_1621 = BgL_fz00_18696;
									goto BgL_zc3z04anonymousza31727ze3z87_1622;
								}
							else
								{	/* Eval/evaluate_comp.scm 674 */
									VECTOR_SET(
										((obj_t) BgL_sz00_94), ((long) 0), BgL_savedzd2bpzd2_1619);
									return BgL_rz00_1623;
								}
						}
					}
				}
			}
		}

	}



/* comp-with-push */
	obj_t BGl_compzd2withzd2pushz00zz__evaluate_compz00(obj_t BgL_eza2za2_117,
		obj_t BgL_stkz00_118)
	{
		{	/* Eval/evaluate_comp.scm 688 */
			if (NULLP(BgL_eza2za2_117))
				{	/* Eval/evaluate_comp.scm 690 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 692 */
					obj_t BgL_arg1748z00_1646;
					obj_t BgL_arg1749z00_1647;

					{	/* Eval/evaluate_comp.scm 692 */
						obj_t BgL_arg1750z00_1648;

						BgL_arg1750z00_1648 = CAR(((obj_t) BgL_eza2za2_117));
						BgL_arg1748z00_1646 =
							BGl_compz00zz__evaluate_compz00(
							((BgL_ev_exprz00_bglt) BgL_arg1750z00_1648), BgL_stkz00_118);
					}
					{	/* Eval/evaluate_comp.scm 693 */
						obj_t BgL_arg1751z00_1649;
						obj_t BgL_arg1752z00_1650;

						BgL_arg1751z00_1649 = CDR(((obj_t) BgL_eza2za2_117));
						{	/* Eval/evaluate_comp.scm 693 */
							obj_t BgL_arg1753z00_1651;

							BgL_arg1753z00_1651 = MAKE_YOUNG_PAIR(BFALSE, BNIL);
							BgL_arg1752z00_1650 =
								BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_118,
								BgL_arg1753z00_1651);
						}
						BgL_arg1749z00_1647 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_arg1751z00_1649,
							BgL_arg1752z00_1650);
					}
					return MAKE_YOUNG_PAIR(BgL_arg1748z00_1646, BgL_arg1749z00_1647);
				}
		}

	}



/* rec~0 */
	obj_t BGl_recze70ze7zz__evaluate_compz00(obj_t BgL_stkz00_15545,
		obj_t BgL_lz00_1653, long BgL_iz00_1654)
	{
		{	/* Eval/evaluate_comp.scm 696 */
			if (NULLP(BgL_lz00_1653))
				{	/* Eval/evaluate_comp.scm 697 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate_comp.scm 697 */
					if ((BgL_iz00_1654 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 698 */
							return
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(BgL_lz00_1653,
								BgL_stkz00_15545);
						}
					else
						{	/* Eval/evaluate_comp.scm 699 */
							obj_t BgL_arg1758z00_1658;
							obj_t BgL_arg1760z00_1659;

							{	/* Eval/evaluate_comp.scm 699 */
								obj_t BgL_arg1761z00_1660;

								BgL_arg1761z00_1660 = CAR(((obj_t) BgL_lz00_1653));
								BgL_arg1758z00_1658 =
									BGl_compz00zz__evaluate_compz00(
									((BgL_ev_exprz00_bglt) BgL_arg1761z00_1660),
									BgL_stkz00_15545);
							}
							{	/* Eval/evaluate_comp.scm 700 */
								obj_t BgL_arg1764z00_1661;
								long BgL_arg1765z00_1662;

								BgL_arg1764z00_1661 = CDR(((obj_t) BgL_lz00_1653));
								BgL_arg1765z00_1662 = (BgL_iz00_1654 - ((long) 1));
								BgL_arg1760z00_1659 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_15545,
									BgL_arg1764z00_1661, BgL_arg1765z00_1662);
							}
							return MAKE_YOUNG_PAIR(BgL_arg1758z00_1658, BgL_arg1760z00_1659);
						}
				}
		}

	}



/* subr-call-with-push */
	obj_t BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00(obj_t BgL_sz00_122,
		obj_t BgL_fz00_123, obj_t BgL_argsz00_124, obj_t BgL_bpz00_125,
		obj_t BgL_siza7eza7_126)
	{
		{	/* Eval/evaluate_comp.scm 702 */
			{	/* Eval/evaluate_comp.scm 704 */
				obj_t BgL_argsz00_1664;

				if (NULLP(BgL_argsz00_124))
					{	/* Eval/evaluate_comp.scm 704 */
						BgL_argsz00_1664 = BNIL;
					}
				else
					{	/* Eval/evaluate_comp.scm 704 */
						obj_t BgL_head1343z00_1669;

						{	/* Eval/evaluate_comp.scm 704 */
							obj_t BgL_res4425z00_6707;

							BgL_res4425z00_6707 = MAKE_YOUNG_PAIR(BNIL, BNIL);
							BgL_head1343z00_1669 = BgL_res4425z00_6707;
						}
						{
							obj_t BgL_l1341z00_6731;
							obj_t BgL_tail1344z00_6732;

							BgL_l1341z00_6731 = BgL_argsz00_124;
							BgL_tail1344z00_6732 = BgL_head1343z00_1669;
						BgL_zc3z04anonymousza31768ze3z87_6730:
							if (NULLP(BgL_l1341z00_6731))
								{	/* Eval/evaluate_comp.scm 704 */
									BgL_argsz00_1664 = CDR(BgL_head1343z00_1669);
								}
							else
								{	/* Eval/evaluate_comp.scm 704 */
									obj_t BgL_newtail1345z00_6739;

									{	/* Eval/evaluate_comp.scm 704 */
										obj_t BgL_arg1771z00_6740;

										{	/* Eval/evaluate_comp.scm 704 */
											obj_t BgL_az00_6741;

											BgL_az00_6741 = CAR(((obj_t) BgL_l1341z00_6731));
											BgL_arg1771z00_6740 =
												PROCEDURE_ENTRY(BgL_az00_6741) (BgL_az00_6741,
												BgL_sz00_122, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 704 */
											obj_t BgL_res4431z00_6746;

											BgL_res4431z00_6746 =
												MAKE_YOUNG_PAIR(BgL_arg1771z00_6740, BNIL);
											BgL_newtail1345z00_6739 = BgL_res4431z00_6746;
										}
									}
									SET_CDR(BgL_tail1344z00_6732, BgL_newtail1345z00_6739);
									{	/* Eval/evaluate_comp.scm 704 */
										obj_t BgL_arg1770z00_6742;

										BgL_arg1770z00_6742 = CDR(((obj_t) BgL_l1341z00_6731));
										{
											obj_t BgL_tail1344z00_18742;
											obj_t BgL_l1341z00_18741;

											BgL_l1341z00_18741 = BgL_arg1770z00_6742;
											BgL_tail1344z00_18742 = BgL_newtail1345z00_6739;
											BgL_tail1344z00_6732 = BgL_tail1344z00_18742;
											BgL_l1341z00_6731 = BgL_l1341z00_18741;
											goto BgL_zc3z04anonymousza31768ze3z87_6730;
										}
									}
								}
						}
					}
				{	/* Eval/evaluate_comp.scm 705 */
					long BgL_arg1766z00_1665;

					BgL_arg1766z00_1665 =
						((long) CINT(BgL_bpz00_125) + (long) CINT(BgL_siza7eza7_126));
					VECTOR_SET(
						((obj_t) BgL_sz00_122), ((long) 0), BINT(BgL_arg1766z00_1665));
				}
				{	/* Eval/evaluate_comp.scm 706 */
					obj_t BgL_za2za2resza2za2z00_1666;

					BgL_za2za2resza2za2z00_1666 = apply(BgL_fz00_123, BgL_argsz00_1664);
					VECTOR_SET(((obj_t) BgL_sz00_122), ((long) 0), BgL_bpz00_125);
					return BgL_za2za2resza2za2z00_1666;
				}
			}
		}

	}



/* push-nargs-on-sp */
	obj_t BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00(obj_t
		BgL_arityz00_130, obj_t BgL_sz00_131, obj_t BgL_argsz00_132,
		obj_t BgL_spz00_133)
	{
		{	/* Eval/evaluate_comp.scm 715 */
			{	/* Eval/evaluate_comp.scm 716 */
				long BgL_g1149z00_1690;

				BgL_g1149z00_1690 = (((long) -1) - (long) CINT(BgL_arityz00_130));
				{
					obj_t BgL_lz00_1692;
					obj_t BgL_spz00_1693;
					long BgL_nz00_1694;

					BgL_lz00_1692 = BgL_argsz00_132;
					BgL_spz00_1693 = BgL_spz00_133;
					BgL_nz00_1694 = BgL_g1149z00_1690;
				BgL_zc3z04anonymousza31778ze3z87_1695:
					if ((BgL_nz00_1694 == ((long) 0)))
						{
							obj_t BgL_lz00_6833;
							obj_t BgL_rz00_6834;

							BgL_lz00_6833 = BgL_lz00_1692;
							BgL_rz00_6834 = BNIL;
						BgL_rec2z00_6832:
							if (NULLP(BgL_lz00_6833))
								{	/* Eval/evaluate_comp.scm 720 */
									obj_t BgL_arg1782z00_6842;

									BgL_arg1782z00_6842 = bgl_reverse_bang(BgL_rz00_6834);
									{	/* Eval/evaluate_comp.scm 720 */
										long BgL_kz00_6849;

										BgL_kz00_6849 = (long) CINT(BgL_spz00_1693);
										return
											VECTOR_SET(
											((obj_t) BgL_sz00_131), BgL_kz00_6849,
											BgL_arg1782z00_6842);
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 721 */
									obj_t BgL_arg1783z00_6843;
									obj_t BgL_arg1784z00_6844;

									BgL_arg1783z00_6843 = CDR(((obj_t) BgL_lz00_6833));
									{	/* Eval/evaluate_comp.scm 721 */
										obj_t BgL_arg1785z00_6845;

										{	/* Eval/evaluate_comp.scm 721 */
											obj_t BgL_fun1786z00_6846;

											BgL_fun1786z00_6846 = CAR(((obj_t) BgL_lz00_6833));
											BgL_arg1785z00_6845 =
												PROCEDURE_ENTRY(BgL_fun1786z00_6846)
												(BgL_fun1786z00_6846, BgL_sz00_131, BEOA);
										}
										BgL_arg1784z00_6844 =
											MAKE_YOUNG_PAIR(BgL_arg1785z00_6845, BgL_rz00_6834);
									}
									{
										obj_t BgL_rz00_18773;
										obj_t BgL_lz00_18772;

										BgL_lz00_18772 = BgL_arg1783z00_6843;
										BgL_rz00_18773 = BgL_arg1784z00_6844;
										BgL_rz00_6834 = BgL_rz00_18773;
										BgL_lz00_6833 = BgL_lz00_18772;
										goto BgL_rec2z00_6832;
									}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 717 */
							{	/* Eval/evaluate_comp.scm 722 */
								obj_t BgL_arg1787z00_1709;

								{	/* Eval/evaluate_comp.scm 722 */
									obj_t BgL_fun1788z00_1710;

									BgL_fun1788z00_1710 = CAR(((obj_t) BgL_lz00_1692));
									BgL_arg1787z00_1709 =
										PROCEDURE_ENTRY(BgL_fun1788z00_1710) (BgL_fun1788z00_1710,
										BgL_sz00_131, BEOA);
								}
								{	/* Eval/evaluate_comp.scm 722 */
									long BgL_kz00_6854;

									BgL_kz00_6854 = (long) CINT(BgL_spz00_1693);
									VECTOR_SET(
										((obj_t) BgL_sz00_131), BgL_kz00_6854, BgL_arg1787z00_1709);
							}}
							{	/* Eval/evaluate_comp.scm 723 */
								obj_t BgL_arg1789z00_1711;
								long BgL_arg1790z00_1712;
								long BgL_arg1791z00_1713;

								BgL_arg1789z00_1711 = CDR(((obj_t) BgL_lz00_1692));
								BgL_arg1790z00_1712 =
									((long) CINT(BgL_spz00_1693) + ((long) 1));
								BgL_arg1791z00_1713 = (BgL_nz00_1694 - ((long) 1));
								{
									long BgL_nz00_18791;
									obj_t BgL_spz00_18789;
									obj_t BgL_lz00_18788;

									BgL_lz00_18788 = BgL_arg1789z00_1711;
									BgL_spz00_18789 = BINT(BgL_arg1790z00_1712);
									BgL_nz00_18791 = BgL_arg1791z00_1713;
									BgL_nz00_1694 = BgL_nz00_18791;
									BgL_spz00_1693 = BgL_spz00_18789;
									BgL_lz00_1692 = BgL_lz00_18788;
									goto BgL_zc3z04anonymousza31778ze3z87_1695;
								}
							}
						}
				}
			}
		}

	}



/* need-shift */
	bool_t BGl_needzd2shiftzd2zz__evaluate_compz00(obj_t BgL_argsz00_134,
		obj_t BgL_stkz00_135)
	{
		{	/* Eval/evaluate_comp.scm 766 */
			{
				obj_t BgL_lz00_1716;
				obj_t BgL_stkz00_1717;

				BgL_lz00_1716 = BgL_argsz00_134;
				BgL_stkz00_1717 = BgL_stkz00_135;
			BgL_zc3z04anonymousza31792ze3z87_1718:
				{	/* Eval/evaluate_comp.scm 770 */
					bool_t BgL_test6143z00_18792;

					if (NULLP(BgL_lz00_1716))
						{	/* Eval/evaluate_comp.scm 770 */
							BgL_test6143z00_18792 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 770 */
							BgL_test6143z00_18792 = NULLP(BgL_stkz00_1717);
						}
					if (BgL_test6143z00_18792)
						{	/* Eval/evaluate_comp.scm 770 */
							return ((bool_t) 0);
						}
					else
						{	/* Eval/evaluate_comp.scm 772 */
							bool_t BgL_test6145z00_18796;

							{	/* Eval/evaluate_comp.scm 772 */
								obj_t BgL_g1348z00_1735;

								BgL_g1348z00_1735 = CDR(((obj_t) BgL_lz00_1716));
								{
									obj_t BgL_l1346z00_1737;

									{	/* Eval/evaluate_comp.scm 772 */
										obj_t BgL_tmpz00_18799;

										BgL_l1346z00_1737 = BgL_g1348z00_1735;
									BgL_zc3z04anonymousza31806ze3z87_1738:
										if (NULLP(BgL_l1346z00_1737))
											{	/* Eval/evaluate_comp.scm 772 */
												BgL_tmpz00_18799 = BFALSE;
											}
										else
											{	/* Eval/evaluate_comp.scm 772 */
												obj_t BgL__ortest_1349z00_1740;

												{	/* Eval/evaluate_comp.scm 772 */
													obj_t BgL_ez00_1742;

													BgL_ez00_1742 = CAR(((obj_t) BgL_l1346z00_1737));
													{	/* Eval/evaluate_comp.scm 772 */
														obj_t BgL_arg1808z00_1743;
														obj_t BgL_arg1809z00_1744;

														BgL_arg1808z00_1743 =
															CAR(((obj_t) BgL_stkz00_1717));
														BgL_arg1809z00_1744 =
															BGl_usez00zz__evaluate_usez00(
															((BgL_ev_exprz00_bglt) BgL_ez00_1742), BNIL);
														BgL__ortest_1349z00_1740 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(BgL_arg1808z00_1743, BgL_arg1809z00_1744);
													}
												}
												if (CBOOL(BgL__ortest_1349z00_1740))
													{	/* Eval/evaluate_comp.scm 772 */
														BgL_tmpz00_18799 = BgL__ortest_1349z00_1740;
													}
												else
													{	/* Eval/evaluate_comp.scm 772 */
														obj_t BgL_arg1807z00_1741;

														BgL_arg1807z00_1741 =
															CDR(((obj_t) BgL_l1346z00_1737));
														{
															obj_t BgL_l1346z00_18813;

															BgL_l1346z00_18813 = BgL_arg1807z00_1741;
															BgL_l1346z00_1737 = BgL_l1346z00_18813;
															goto BgL_zc3z04anonymousza31806ze3z87_1738;
														}
													}
											}
										BgL_test6145z00_18796 = CBOOL(BgL_tmpz00_18799);
									}
								}
							}
							if (BgL_test6145z00_18796)
								{	/* Eval/evaluate_comp.scm 772 */
									return ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 774 */
									obj_t BgL_arg1804z00_1733;
									obj_t BgL_arg1805z00_1734;

									BgL_arg1804z00_1733 = CDR(((obj_t) BgL_lz00_1716));
									BgL_arg1805z00_1734 = CDR(((obj_t) BgL_stkz00_1717));
									{
										obj_t BgL_stkz00_18820;
										obj_t BgL_lz00_18819;

										BgL_lz00_18819 = BgL_arg1804z00_1733;
										BgL_stkz00_18820 = BgL_arg1805z00_1734;
										BgL_stkz00_1717 = BgL_stkz00_18820;
										BgL_lz00_1716 = BgL_lz00_18819;
										goto BgL_zc3z04anonymousza31792ze3z87_1718;
									}
								}
						}
				}
			}
		}

	}



/* comp-old-call */
	obj_t BGl_compzd2oldzd2callz00zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_ez00_136, obj_t BgL_stkz00_137)
	{
		{	/* Eval/evaluate_comp.scm 776 */
			{	/* Eval/evaluate_comp.scm 778 */
				long BgL_siza7eza7_1749;
				long BgL_nbargsz00_1750;
				obj_t BgL_fz00_1751;
				obj_t BgL_symbzd2funzd2_1752;

				BgL_siza7eza7_1749 = bgl_list_length(BgL_stkz00_137);
				BgL_nbargsz00_1750 =
					bgl_list_length(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00));
				BgL_fz00_1751 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_funz00),
					BgL_stkz00_137);
				BgL_symbzd2funzd2_1752 =
					BGl_uncompilez00zz__evaluate_uncompz00((((BgL_ev_appz00_bglt)
							COBJECT(BgL_ez00_136))->BgL_funz00));
				if (CBOOL((((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
							BgL_tailzf3zf3)))
					{	/* Eval/evaluate_comp.scm 780 */
						if (BGl_needzd2shiftzd2zz__evaluate_compz00(
								(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
								BgL_stkz00_137))
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test6150z00_18834;

								{	/* Eval/evaluate_comp.scm 787 */
									int BgL_arg1869z00_1831;

									BgL_arg1869z00_1831 = bgl_debug();
									BgL_test6150z00_18834 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1869z00_1831),
										BINT(((long) 0)));
								}
								if (BgL_test6150z00_18834)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_argsz00_1758;

										BgL_argsz00_1758 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 787 */
											obj_t BgL_zc3z04anonymousza31815ze3z87_13575;

											BgL_zc3z04anonymousza31815ze3z87_13575 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31815ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31815ze3z87_13575,
												(int) (((long) 0)), BgL_fz00_1751);
											PROCEDURE_SET(BgL_zc3z04anonymousza31815ze3z87_13575,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31815ze3z87_13575,
												(int) (((long) 2)), BgL_symbzd2funzd2_1752);
											PROCEDURE_SET(BgL_zc3z04anonymousza31815ze3z87_13575,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1750));
											PROCEDURE_SET(BgL_zc3z04anonymousza31815ze3z87_13575,
												(int) (((long) 4)), BgL_argsz00_1758);
											PROCEDURE_SET(BgL_zc3z04anonymousza31815ze3z87_13575,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1749));
											return BgL_zc3z04anonymousza31815ze3z87_13575;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_argsz00_1796;

										BgL_argsz00_1796 =
											BGl_compzd2withzd2pushz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_stkz00_137);
										{	/* Eval/evaluate_comp.scm 787 */
											obj_t BgL_zc3z04anonymousza31843ze3z87_13576;

											BgL_zc3z04anonymousza31843ze3z87_13576 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31843ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 6)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31843ze3z87_13576,
												(int) (((long) 0)), BgL_fz00_1751);
											PROCEDURE_SET(BgL_zc3z04anonymousza31843ze3z87_13576,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31843ze3z87_13576,
												(int) (((long) 2)), BgL_symbzd2funzd2_1752);
											PROCEDURE_SET(BgL_zc3z04anonymousza31843ze3z87_13576,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1750));
											PROCEDURE_SET(BgL_zc3z04anonymousza31843ze3z87_13576,
												(int) (((long) 4)), BgL_argsz00_1796);
											PROCEDURE_SET(BgL_zc3z04anonymousza31843ze3z87_13576,
												(int) (((long) 5)), BINT(BgL_siza7eza7_1749));
											return BgL_zc3z04anonymousza31843ze3z87_13576;
										}
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test6151z00_18879;

								{	/* Eval/evaluate_comp.scm 795 */
									int BgL_arg1913z00_1901;

									BgL_arg1913z00_1901 = bgl_debug();
									BgL_test6151z00_18879 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1913z00_1901),
										BINT(((long) 0)));
								}
								if (BgL_test6151z00_18879)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_argsz00_1834;

										BgL_argsz00_1834 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1749);
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_zc3z04anonymousza31872ze3z87_13577;

											BgL_zc3z04anonymousza31872ze3z87_13577 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31872ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31872ze3z87_13577,
												(int) (((long) 0)), BgL_fz00_1751);
											PROCEDURE_SET(BgL_zc3z04anonymousza31872ze3z87_13577,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31872ze3z87_13577,
												(int) (((long) 2)), BgL_symbzd2funzd2_1752);
											PROCEDURE_SET(BgL_zc3z04anonymousza31872ze3z87_13577,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1750));
											PROCEDURE_SET(BgL_zc3z04anonymousza31872ze3z87_13577,
												(int) (((long) 4)), BgL_argsz00_1834);
											return BgL_zc3z04anonymousza31872ze3z87_13577;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_argsz00_1869;

										BgL_argsz00_1869 =
											BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_137,
											(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->
												BgL_argsz00), BgL_siza7eza7_1749);
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_zc3z04anonymousza31895ze3z87_13578;

											BgL_zc3z04anonymousza31895ze3z87_13578 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza31895ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 5)));
											PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_13578,
												(int) (((long) 0)), BgL_fz00_1751);
											PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_13578,
												(int) (((long) 1)), ((obj_t) BgL_ez00_136));
											PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_13578,
												(int) (((long) 2)), BgL_symbzd2funzd2_1752);
											PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_13578,
												(int) (((long) 3)), BINT(BgL_nbargsz00_1750));
											PROCEDURE_SET(BgL_zc3z04anonymousza31895ze3z87_13578,
												(int) (((long) 4)), BgL_argsz00_1869);
											return BgL_zc3z04anonymousza31895ze3z87_13578;
										}
									}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 781 */
						bool_t BgL_test6152z00_18918;

						{	/* Eval/evaluate_comp.scm 781 */
							int BgL_arg1955z00_1972;

							BgL_arg1955z00_1972 = bgl_debug();
							BgL_test6152z00_18918 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1955z00_1972),
								BINT(((long) 0)));
						}
						if (BgL_test6152z00_18918)
							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_argsz00_1905;

								BgL_argsz00_1905 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 781 */
									obj_t BgL_zc3z04anonymousza31917ze3z87_13579;

									BgL_zc3z04anonymousza31917ze3z87_13579 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31917ze3ze5zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31917ze3z87_13579,
										(int) (((long) 0)), BgL_fz00_1751);
									PROCEDURE_SET(BgL_zc3z04anonymousza31917ze3z87_13579,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3z04anonymousza31917ze3z87_13579,
										(int) (((long) 2)), BgL_symbzd2funzd2_1752);
									PROCEDURE_SET(BgL_zc3z04anonymousza31917ze3z87_13579,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1750));
									PROCEDURE_SET(BgL_zc3z04anonymousza31917ze3z87_13579,
										(int) (((long) 4)), BgL_argsz00_1905);
									PROCEDURE_SET(BgL_zc3z04anonymousza31917ze3z87_13579,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1749));
									return BgL_zc3z04anonymousza31917ze3z87_13579;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_argsz00_1940;

								BgL_argsz00_1940 =
									BGl_compzd2withzd2pushz00zz__evaluate_compz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_ez00_136))->BgL_argsz00),
									BgL_stkz00_137);
								{	/* Eval/evaluate_comp.scm 781 */
									obj_t BgL_zc3z04anonymousza31938ze3z87_13580;

									BgL_zc3z04anonymousza31938ze3z87_13580 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_compz00,
										(int) (((long) 1)), (int) (((long) 6)));
									PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_13580,
										(int) (((long) 0)), BgL_fz00_1751);
									PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_13580,
										(int) (((long) 1)), ((obj_t) BgL_ez00_136));
									PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_13580,
										(int) (((long) 2)), BgL_symbzd2funzd2_1752);
									PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_13580,
										(int) (((long) 3)), BINT(BgL_nbargsz00_1750));
									PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_13580,
										(int) (((long) 4)), BgL_argsz00_1940);
									PROCEDURE_SET(BgL_zc3z04anonymousza31938ze3z87_13580,
										(int) (((long) 5)), BINT(BgL_siza7eza7_1749));
									return BgL_zc3z04anonymousza31938ze3z87_13580;
								}
							}
					}
			}
		}

	}



/* &<@anonymous:1815> */
	obj_t BGl_z62zc3z04anonymousza31815ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13581, obj_t BgL_sz00_13588)
	{
		{	/* Eval/evaluate_comp.scm 787 */
			{	/* Eval/evaluate_comp.scm 787 */
				obj_t BgL_fz00_13582;
				BgL_ev_appz00_bglt BgL_i1157z00_13583;
				obj_t BgL_symbzd2funzd2_13584;
				long BgL_nbargsz00_13585;
				obj_t BgL_argsz00_13586;
				long BgL_siza7eza7_13587;

				BgL_fz00_13582 = PROCEDURE_REF(BgL_envz00_13581, (int) (((long) 0)));
				BgL_i1157z00_13583 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13581, (int) (((long) 1))));
				BgL_symbzd2funzd2_13584 =
					PROCEDURE_REF(BgL_envz00_13581, (int) (((long) 2)));
				BgL_nbargsz00_13585 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13581, (int) (((long) 3))));
				BgL_argsz00_13586 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13581, (int) (((long) 4))));
				BgL_siza7eza7_13587 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13581, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 787 */
					obj_t BgL_bpz00_15566;

					BgL_bpz00_15566 = VECTOR_REF(((obj_t) BgL_sz00_13588), ((long) 0));
					{	/* Eval/evaluate_comp.scm 787 */
						obj_t BgL_fz00_15567;

						BgL_fz00_15567 =
							PROCEDURE_ENTRY(BgL_fz00_13582) (BgL_fz00_13582, BgL_sz00_13588,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15567))
							{	/* Eval/evaluate_comp.scm 787 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 787 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13583))->
										BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15567);
							}
						{	/* Eval/evaluate_comp.scm 787 */
							obj_t BgL_ufz00_15568;

							{	/* Eval/evaluate_comp.scm 787 */
								obj_t BgL_tmpz00_18989;

								BgL_tmpz00_18989 = ((obj_t) BgL_fz00_15567);
								BgL_ufz00_15568 = PROCEDURE_ATTR(BgL_tmpz00_18989);
							}
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test6154z00_18992;

								if (STRUCTP(BgL_ufz00_15568))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6154z00_18992 =
											(STRUCT_KEY(BgL_ufz00_15568) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6154z00_18992 = ((bool_t) 0);
									}
								if (BgL_test6154z00_18992)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_arityz00_15569;
										obj_t BgL_runz00_15570;
										obj_t BgL_sfz00_15571;

										BgL_arityz00_15569 =
											STRUCT_REF(BgL_ufz00_15568, (int) (((long) 0)));
										BgL_runz00_15570 =
											STRUCT_REF(BgL_ufz00_15568, (int) (((long) 1)));
										BgL_sfz00_15571 =
											STRUCT_REF(BgL_ufz00_15568, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 787 */
											long BgL_spz00_15572;

											BgL_spz00_15572 =
												((long) CINT(BgL_bpz00_15566) + BgL_siza7eza7_13587);
											if (
												((long) CINT(BgL_arityz00_15569) ==
													BgL_nbargsz00_13585))
												{	/* Eval/evaluate_comp.scm 787 */
													{
														obj_t BgL_lz00_15574;
														long BgL_spz00_15575;

														BgL_lz00_15574 = BgL_argsz00_13586;
														BgL_spz00_15575 = BgL_spz00_15572;
													BgL_recz00_15573:
														if (NULLP(BgL_lz00_15574))
															{	/* Eval/evaluate_comp.scm 711 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1774z00_15576;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1775z00_15577;

																		BgL_fun1775z00_15577 =
																			CAR(((obj_t) BgL_lz00_15574));
																		BgL_arg1774z00_15576 =
																			PROCEDURE_ENTRY(BgL_fun1775z00_15577)
																			(BgL_fun1775z00_15577, BgL_sz00_13588,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13588), BgL_spz00_15575,
																		BgL_arg1774z00_15576);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1776z00_15578;
																	long BgL_arg1777z00_15579;

																	BgL_arg1776z00_15578 =
																		CDR(((obj_t) BgL_lz00_15574));
																	BgL_arg1777z00_15579 =
																		(BgL_spz00_15575 + ((long) 1));
																	{
																		long BgL_spz00_19022;
																		obj_t BgL_lz00_19021;

																		BgL_lz00_19021 = BgL_arg1776z00_15578;
																		BgL_spz00_19022 = BgL_arg1777z00_15579;
																		BgL_spz00_15575 = BgL_spz00_19022;
																		BgL_lz00_15574 = BgL_lz00_19021;
																		goto BgL_recz00_15573;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 791 */
														long BgL_arg1820z00_15580;

														BgL_arg1820z00_15580 =
															(BgL_spz00_15572 + BgL_nbargsz00_13585);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_13588, (long) CINT(BgL_bpz00_15566),
															BgL_sz00_13588, BINT(BgL_spz00_15572),
															BINT(BgL_arg1820z00_15580));
												}}
											else
												{	/* Eval/evaluate_comp.scm 787 */
													bool_t BgL_test6158z00_19028;

													if (((long) CINT(BgL_arityz00_15569) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test6158z00_19028 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test6158z00_19028 =
																(
																(long) CINT(BgL_arityz00_15569) <
																(((long) -1) - BgL_nbargsz00_13585));
														}
													if (BgL_test6158z00_19028)
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13583))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15568, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13585),
																CINT(BgL_arityz00_15569));
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15569, BgL_sz00_13588,
																BgL_argsz00_13586, BINT(BgL_spz00_15572));
															{	/* Eval/evaluate_comp.scm 793 */
																long BgL_arg1830z00_15581;

																BgL_arg1830z00_15581 =
																	(BgL_spz00_15572 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_15569)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_13588, (long) CINT(BgL_bpz00_15566),
																	BgL_sz00_13588, BINT(BgL_spz00_15572),
																	BINT(BgL_arg1830z00_15581));
												}}}
											{	/* Eval/evaluate_comp.scm 787 */
												obj_t BgL_z12denvz12_15582;

												BgL_z12denvz12_15582 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 787 */
													obj_t BgL_tmpz00_19051;

													BgL_tmpz00_19051 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13583))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15582,
														BgL_tmpz00_19051);
												}
												if (
													(((long) CINT(BgL_bpz00_15566) +
															(long) CINT(BgL_sfz00_15571)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13588))))
													{	/* Eval/evaluate_comp.scm 787 */
														return BgL_runz00_15570;
													}
												else
													{	/* Eval/evaluate_comp.scm 787 */
														obj_t BgL_nsz00_15583;

														BgL_nsz00_15583 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 787 */
															long BgL_arg1835z00_15584;

															BgL_arg1835z00_15584 =
																(
																(long) CINT(BgL_bpz00_15566) +
																BgL_nbargsz00_13585);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15583, ((long) 2), BgL_sz00_13588,
																BgL_bpz00_15566, BINT(BgL_arg1835z00_15584));
														}
														VECTOR_SET(BgL_nsz00_15583, ((long) 1),
															BgL_sz00_13588);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15582,
															BgL_nsz00_15583);
														{	/* Eval/evaluate_comp.scm 787 */
															obj_t BgL_ez00_15585;

															BgL_ez00_15585 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15585, BgL_sz00_13588);
															{	/* Eval/evaluate_comp.scm 787 */
																obj_t BgL_____rz00_15586;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15587;

																	BgL_savedzd2bpzd2_15587 =
																		VECTOR_REF(BgL_nsz00_15583, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15583, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15589;

																		BgL_fz00_15589 = BgL_runz00_15570;
																	BgL_recz00_15588:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15590;

																			BgL_rz00_15590 =
																				PROCEDURE_ENTRY(BgL_fz00_15589)
																				(BgL_fz00_15589, BgL_nsz00_15583, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6161z00_19077;

																				if (PROCEDUREP(BgL_rz00_15590))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_15591;

																						BgL_arg1732z00_15591 =
																							PROCEDURE_ATTR(BgL_rz00_15590);
																						if (STRUCTP(BgL_arg1732z00_15591))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6161z00_19077 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_15591) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6161z00_19077 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6161z00_19077 =
																							((bool_t) 0);
																					}
																				if (BgL_test6161z00_19077)
																					{
																						obj_t BgL_fz00_19085;

																						BgL_fz00_19085 = BgL_rz00_15590;
																						BgL_fz00_15589 = BgL_fz00_19085;
																						goto BgL_recz00_15588;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15583,
																							((long) 0),
																							BgL_savedzd2bpzd2_15587);
																						BgL_____rz00_15586 = BgL_rz00_15590;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15585);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15582,
																	BgL_sz00_13588);
																return BgL_____rz00_15586;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15567,
												(int) (BgL_nbargsz00_13585)))
											{	/* Eval/evaluate_comp.scm 787 */
												{	/* Eval/evaluate_comp.scm 787 */
													obj_t BgL_auxz00_19094;
													obj_t BgL_tmpz00_19092;

													BgL_auxz00_19094 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13583))->BgL_locz00);
													BgL_tmpz00_19092 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19092,
														BgL_auxz00_19094);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13588, BgL_fz00_15567, BgL_argsz00_13586,
													BgL_bpz00_15566, BINT(BgL_siza7eza7_13587));
											}
										else
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13583))->
														BgL_locz00), BgL_symbzd2funzd2_13584,
													(int) (BgL_nbargsz00_13585),
													PROCEDURE_ARITY(BgL_fz00_15567));
		}}}}}}}}

	}



/* &<@anonymous:1843> */
	obj_t BGl_z62zc3z04anonymousza31843ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13589, obj_t BgL_sz00_13596)
	{
		{	/* Eval/evaluate_comp.scm 787 */
			{	/* Eval/evaluate_comp.scm 787 */
				obj_t BgL_fz00_13590;
				BgL_ev_appz00_bglt BgL_i1157z00_13591;
				obj_t BgL_symbzd2funzd2_13592;
				long BgL_nbargsz00_13593;
				obj_t BgL_argsz00_13594;
				long BgL_siza7eza7_13595;

				BgL_fz00_13590 = PROCEDURE_REF(BgL_envz00_13589, (int) (((long) 0)));
				BgL_i1157z00_13591 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13589, (int) (((long) 1))));
				BgL_symbzd2funzd2_13592 =
					PROCEDURE_REF(BgL_envz00_13589, (int) (((long) 2)));
				BgL_nbargsz00_13593 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13589, (int) (((long) 3))));
				BgL_argsz00_13594 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13589, (int) (((long) 4))));
				BgL_siza7eza7_13595 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13589, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 787 */
					obj_t BgL_bpz00_15592;

					BgL_bpz00_15592 = VECTOR_REF(((obj_t) BgL_sz00_13596), ((long) 0));
					{	/* Eval/evaluate_comp.scm 787 */
						obj_t BgL_fz00_15593;

						BgL_fz00_15593 =
							PROCEDURE_ENTRY(BgL_fz00_13590) (BgL_fz00_13590, BgL_sz00_13596,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15593))
							{	/* Eval/evaluate_comp.scm 787 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 787 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13591))->
										BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15593);
							}
						{	/* Eval/evaluate_comp.scm 787 */
							obj_t BgL_ufz00_15594;

							{	/* Eval/evaluate_comp.scm 787 */
								obj_t BgL_tmpz00_19129;

								BgL_tmpz00_19129 = ((obj_t) BgL_fz00_15593);
								BgL_ufz00_15594 = PROCEDURE_ATTR(BgL_tmpz00_19129);
							}
							{	/* Eval/evaluate_comp.scm 787 */
								bool_t BgL_test6166z00_19132;

								if (STRUCTP(BgL_ufz00_15594))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6166z00_19132 =
											(STRUCT_KEY(BgL_ufz00_15594) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6166z00_19132 = ((bool_t) 0);
									}
								if (BgL_test6166z00_19132)
									{	/* Eval/evaluate_comp.scm 787 */
										obj_t BgL_arityz00_15595;
										obj_t BgL_runz00_15596;
										obj_t BgL_sfz00_15597;

										BgL_arityz00_15595 =
											STRUCT_REF(BgL_ufz00_15594, (int) (((long) 0)));
										BgL_runz00_15596 =
											STRUCT_REF(BgL_ufz00_15594, (int) (((long) 1)));
										BgL_sfz00_15597 =
											STRUCT_REF(BgL_ufz00_15594, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 787 */
											long BgL_spz00_15598;

											BgL_spz00_15598 =
												((long) CINT(BgL_bpz00_15592) + BgL_siza7eza7_13595);
											if (
												((long) CINT(BgL_arityz00_15595) ==
													BgL_nbargsz00_13593))
												{	/* Eval/evaluate_comp.scm 787 */
													{
														obj_t BgL_lz00_15600;
														long BgL_spz00_15601;

														BgL_lz00_15600 = BgL_argsz00_13594;
														BgL_spz00_15601 = BgL_spz00_15598;
													BgL_recz00_15599:
														if (NULLP(BgL_lz00_15600))
															{	/* Eval/evaluate_comp.scm 711 */
																((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1774z00_15602;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1775z00_15603;

																		BgL_fun1775z00_15603 =
																			CAR(((obj_t) BgL_lz00_15600));
																		BgL_arg1774z00_15602 =
																			PROCEDURE_ENTRY(BgL_fun1775z00_15603)
																			(BgL_fun1775z00_15603, BgL_sz00_13596,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13596), BgL_spz00_15601,
																		BgL_arg1774z00_15602);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1776z00_15604;
																	long BgL_arg1777z00_15605;

																	BgL_arg1776z00_15604 =
																		CDR(((obj_t) BgL_lz00_15600));
																	BgL_arg1777z00_15605 =
																		(BgL_spz00_15601 + ((long) 1));
																	{
																		long BgL_spz00_19162;
																		obj_t BgL_lz00_19161;

																		BgL_lz00_19161 = BgL_arg1776z00_15604;
																		BgL_spz00_19162 = BgL_arg1777z00_15605;
																		BgL_spz00_15601 = BgL_spz00_19162;
																		BgL_lz00_15600 = BgL_lz00_19161;
																		goto BgL_recz00_15599;
																	}
																}
															}
													}
													{	/* Eval/evaluate_comp.scm 791 */
														long BgL_arg1852z00_15606;

														BgL_arg1852z00_15606 =
															(BgL_spz00_15598 + BgL_nbargsz00_13593);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_sz00_13596, (long) CINT(BgL_bpz00_15592),
															BgL_sz00_13596, BINT(BgL_spz00_15598),
															BINT(BgL_arg1852z00_15606));
												}}
											else
												{	/* Eval/evaluate_comp.scm 787 */
													bool_t BgL_test6170z00_19168;

													if (((long) CINT(BgL_arityz00_15595) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test6170z00_19168 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BgL_test6170z00_19168 =
																(
																(long) CINT(BgL_arityz00_15595) <
																(((long) -1) - BgL_nbargsz00_13593));
														}
													if (BgL_test6170z00_19168)
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13591))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15594, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13593),
																CINT(BgL_arityz00_15595));
														}
													else
														{	/* Eval/evaluate_comp.scm 787 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15595, BgL_sz00_13596,
																BgL_argsz00_13594, BINT(BgL_spz00_15598));
															{	/* Eval/evaluate_comp.scm 793 */
																long BgL_arg1858z00_15607;

																BgL_arg1858z00_15607 =
																	(BgL_spz00_15598 +
																	(((long) 0) -
																		(long) CINT(BgL_arityz00_15595)));
																BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																	(BgL_sz00_13596, (long) CINT(BgL_bpz00_15592),
																	BgL_sz00_13596, BINT(BgL_spz00_15598),
																	BINT(BgL_arg1858z00_15607));
												}}}
											{	/* Eval/evaluate_comp.scm 787 */
												obj_t BgL_z12denvz12_15608;

												BgL_z12denvz12_15608 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													(((long) CINT(BgL_bpz00_15592) +
															(long) CINT(BgL_sfz00_15597)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13596))))
													{	/* Eval/evaluate_comp.scm 787 */
														return BgL_runz00_15596;
													}
												else
													{	/* Eval/evaluate_comp.scm 787 */
														obj_t BgL_nsz00_15609;

														BgL_nsz00_15609 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 787 */
															long BgL_arg1864z00_15610;

															BgL_arg1864z00_15610 =
																(
																(long) CINT(BgL_bpz00_15592) +
																BgL_nbargsz00_13593);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15609, ((long) 2), BgL_sz00_13596,
																BgL_bpz00_15592, BINT(BgL_arg1864z00_15610));
														}
														VECTOR_SET(BgL_nsz00_15609, ((long) 1),
															BgL_sz00_13596);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15608,
															BgL_nsz00_15609);
														{	/* Eval/evaluate_comp.scm 787 */
															obj_t BgL_ez00_15611;

															BgL_ez00_15611 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15611, BgL_sz00_13596);
															{	/* Eval/evaluate_comp.scm 787 */
																obj_t BgL_____rz00_15612;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15613;

																	BgL_savedzd2bpzd2_15613 =
																		VECTOR_REF(BgL_nsz00_15609, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15609, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15615;

																		BgL_fz00_15615 = BgL_runz00_15596;
																	BgL_recz00_15614:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15616;

																			BgL_rz00_15616 =
																				PROCEDURE_ENTRY(BgL_fz00_15615)
																				(BgL_fz00_15615, BgL_nsz00_15609, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6173z00_19214;

																				if (PROCEDUREP(BgL_rz00_15616))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_15617;

																						BgL_arg1732z00_15617 =
																							PROCEDURE_ATTR(BgL_rz00_15616);
																						if (STRUCTP(BgL_arg1732z00_15617))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6173z00_19214 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_15617) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6173z00_19214 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6173z00_19214 =
																							((bool_t) 0);
																					}
																				if (BgL_test6173z00_19214)
																					{
																						obj_t BgL_fz00_19222;

																						BgL_fz00_19222 = BgL_rz00_15616;
																						BgL_fz00_15615 = BgL_fz00_19222;
																						goto BgL_recz00_15614;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15609,
																							((long) 0),
																							BgL_savedzd2bpzd2_15613);
																						BgL_____rz00_15612 = BgL_rz00_15616;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15611);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15608,
																	BgL_sz00_13596);
																return BgL_____rz00_15612;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 787 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15593,
												(int) (BgL_nbargsz00_13593)))
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13596, BgL_fz00_15593, BgL_argsz00_13594,
													BgL_bpz00_15592, BINT(BgL_siza7eza7_13595));
											}
										else
											{	/* Eval/evaluate_comp.scm 787 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13591))->
														BgL_locz00), BgL_symbzd2funzd2_13592,
													(int) (BgL_nbargsz00_13593),
													PROCEDURE_ARITY(BgL_fz00_15593));
		}}}}}}}}

	}



/* &<@anonymous:1872> */
	obj_t BGl_z62zc3z04anonymousza31872ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13597, obj_t BgL_sz00_13603)
	{
		{	/* Eval/evaluate_comp.scm 795 */
			{	/* Eval/evaluate_comp.scm 795 */
				obj_t BgL_fz00_13598;
				BgL_ev_appz00_bglt BgL_i1157z00_13599;
				obj_t BgL_symbzd2funzd2_13600;
				long BgL_nbargsz00_13601;
				obj_t BgL_argsz00_13602;

				BgL_fz00_13598 = PROCEDURE_REF(BgL_envz00_13597, (int) (((long) 0)));
				BgL_i1157z00_13599 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13597, (int) (((long) 1))));
				BgL_symbzd2funzd2_13600 =
					PROCEDURE_REF(BgL_envz00_13597, (int) (((long) 2)));
				BgL_nbargsz00_13601 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13597, (int) (((long) 3))));
				BgL_argsz00_13602 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13597, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 795 */
					obj_t BgL_bpz00_15618;

					BgL_bpz00_15618 = VECTOR_REF(((obj_t) BgL_sz00_13603), ((long) 0));
					{	/* Eval/evaluate_comp.scm 795 */
						obj_t BgL_fz00_15619;

						BgL_fz00_15619 =
							PROCEDURE_ENTRY(BgL_fz00_13598) (BgL_fz00_13598, BgL_sz00_13603,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15619))
							{	/* Eval/evaluate_comp.scm 795 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13599))->
										BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15619);
							}
						{	/* Eval/evaluate_comp.scm 795 */
							obj_t BgL_ufz00_15620;

							{	/* Eval/evaluate_comp.scm 795 */
								obj_t BgL_tmpz00_19258;

								BgL_tmpz00_19258 = ((obj_t) BgL_fz00_15619);
								BgL_ufz00_15620 = PROCEDURE_ATTR(BgL_tmpz00_19258);
							}
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test6178z00_19261;

								if (STRUCTP(BgL_ufz00_15620))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6178z00_19261 =
											(STRUCT_KEY(BgL_ufz00_15620) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6178z00_19261 = ((bool_t) 0);
									}
								if (BgL_test6178z00_19261)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_arityz00_15621;
										obj_t BgL_runz00_15622;
										obj_t BgL_sfz00_15623;

										BgL_arityz00_15621 =
											STRUCT_REF(BgL_ufz00_15620, (int) (((long) 0)));
										BgL_runz00_15622 =
											STRUCT_REF(BgL_ufz00_15620, (int) (((long) 1)));
										BgL_sfz00_15623 =
											STRUCT_REF(BgL_ufz00_15620, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_15621) == BgL_nbargsz00_13601))
											{
												obj_t BgL_lz00_15625;
												obj_t BgL_spz00_15626;

												{	/* Eval/evaluate_comp.scm 710 */
													bool_t BgL_tmpz00_19275;

													BgL_lz00_15625 = BgL_argsz00_13602;
													BgL_spz00_15626 = BgL_bpz00_15618;
												BgL_recz00_15624:
													if (NULLP(BgL_lz00_15625))
														{	/* Eval/evaluate_comp.scm 711 */
															BgL_tmpz00_19275 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 711 */
															{	/* Eval/evaluate_comp.scm 712 */
																obj_t BgL_arg1774z00_15627;

																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_fun1775z00_15628;

																	BgL_fun1775z00_15628 =
																		CAR(((obj_t) BgL_lz00_15625));
																	BgL_arg1774z00_15627 =
																		PROCEDURE_ENTRY(BgL_fun1775z00_15628)
																		(BgL_fun1775z00_15628, BgL_sz00_13603,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 712 */
																	long BgL_kz00_15629;

																	BgL_kz00_15629 = (long) CINT(BgL_spz00_15626);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13603), BgL_kz00_15629,
																		BgL_arg1774z00_15627);
															}}
															{	/* Eval/evaluate_comp.scm 713 */
																obj_t BgL_arg1776z00_15630;
																long BgL_arg1777z00_15631;

																BgL_arg1776z00_15630 =
																	CDR(((obj_t) BgL_lz00_15625));
																BgL_arg1777z00_15631 =
																	((long) CINT(BgL_spz00_15626) + ((long) 1));
																{
																	obj_t BgL_spz00_19292;
																	obj_t BgL_lz00_19291;

																	BgL_lz00_19291 = BgL_arg1776z00_15630;
																	BgL_spz00_19292 = BINT(BgL_arg1777z00_15631);
																	BgL_spz00_15626 = BgL_spz00_19292;
																	BgL_lz00_15625 = BgL_lz00_19291;
																	goto BgL_recz00_15624;
																}
															}
														}
													BBOOL(BgL_tmpz00_19275);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												bool_t BgL_test6182z00_19295;

												if (((long) CINT(BgL_arityz00_15621) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test6182z00_19295 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test6182z00_19295 =
															(
															(long) CINT(BgL_arityz00_15621) <
															(((long) -1) - BgL_nbargsz00_13601));
													}
												if (BgL_test6182z00_19295)
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1157z00_13599))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_15620, (int) (((long) 3))),
															(int) (BgL_nbargsz00_13601),
															CINT(BgL_arityz00_15621));
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_15621, BgL_sz00_13603,
															BgL_argsz00_13602, BgL_bpz00_15618);
													}
											}
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_z12denvz12_15632;

											BgL_z12denvz12_15632 = BGL_CURRENT_DYNAMIC_ENV();
											{	/* Eval/evaluate_comp.scm 795 */
												obj_t BgL_tmpz00_19310;

												BgL_tmpz00_19310 =
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13599))->
													BgL_locz00);
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15632,
													BgL_tmpz00_19310);
											}
											if (
												(((long) CINT(BgL_bpz00_15618) +
														(long) CINT(BgL_sfz00_15623)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13603))))
												{	/* Eval/evaluate_comp.scm 795 */
													return BgL_runz00_15622;
												}
											else
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_nsz00_15633;

													BgL_nsz00_15633 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 795 */
														long BgL_arg1888z00_15634;

														BgL_arg1888z00_15634 =
															(
															(long) CINT(BgL_bpz00_15618) +
															BgL_nbargsz00_13601);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15633, ((long) 2), BgL_sz00_13603,
															BgL_bpz00_15618, BINT(BgL_arg1888z00_15634));
													}
													VECTOR_SET(BgL_nsz00_15633, ((long) 1),
														BgL_sz00_13603);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15632,
														BgL_nsz00_15633);
													{	/* Eval/evaluate_comp.scm 795 */
														obj_t BgL_ez00_15635;

														BgL_ez00_15635 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15635, BgL_sz00_13603);
														{	/* Eval/evaluate_comp.scm 795 */
															obj_t BgL_____rz00_15636;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15637;

																BgL_savedzd2bpzd2_15637 =
																	VECTOR_REF(BgL_nsz00_15633, ((long) 0));
																VECTOR_SET(BgL_nsz00_15633, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15639;

																	BgL_fz00_15639 = BgL_runz00_15622;
																BgL_recz00_15638:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15640;

																		BgL_rz00_15640 =
																			PROCEDURE_ENTRY(BgL_fz00_15639)
																			(BgL_fz00_15639, BgL_nsz00_15633, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6185z00_19336;

																			if (PROCEDUREP(BgL_rz00_15640))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_15641;

																					BgL_arg1732z00_15641 =
																						PROCEDURE_ATTR(BgL_rz00_15640);
																					if (STRUCTP(BgL_arg1732z00_15641))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6185z00_19336 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_15641) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6185z00_19336 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6185z00_19336 = ((bool_t) 0);
																				}
																			if (BgL_test6185z00_19336)
																				{
																					obj_t BgL_fz00_19344;

																					BgL_fz00_19344 = BgL_rz00_15640;
																					BgL_fz00_15639 = BgL_fz00_19344;
																					goto BgL_recz00_15638;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15633,
																						((long) 0),
																						BgL_savedzd2bpzd2_15637);
																					BgL_____rz00_15636 = BgL_rz00_15640;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15635);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15632,
																BgL_sz00_13603);
															return BgL_____rz00_15636;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15619,
												(int) (BgL_nbargsz00_13601)))
											{	/* Eval/evaluate_comp.scm 795 */
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_auxz00_19353;
													obj_t BgL_tmpz00_19351;

													BgL_auxz00_19353 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13599))->BgL_locz00);
													BgL_tmpz00_19351 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19351,
														BgL_auxz00_19353);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13603, BgL_fz00_15619, BgL_argsz00_13602,
													BgL_bpz00_15618, BINT(BgL_nbargsz00_13601));
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13599))->
														BgL_locz00), BgL_symbzd2funzd2_13600,
													(int) (BgL_nbargsz00_13601),
													PROCEDURE_ARITY(BgL_fz00_15619));
		}}}}}}}}

	}



/* &<@anonymous:1895> */
	obj_t BGl_z62zc3z04anonymousza31895ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13604, obj_t BgL_sz00_13610)
	{
		{	/* Eval/evaluate_comp.scm 795 */
			{	/* Eval/evaluate_comp.scm 795 */
				obj_t BgL_fz00_13605;
				BgL_ev_appz00_bglt BgL_i1157z00_13606;
				obj_t BgL_symbzd2funzd2_13607;
				long BgL_nbargsz00_13608;
				obj_t BgL_argsz00_13609;

				BgL_fz00_13605 = PROCEDURE_REF(BgL_envz00_13604, (int) (((long) 0)));
				BgL_i1157z00_13606 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13604, (int) (((long) 1))));
				BgL_symbzd2funzd2_13607 =
					PROCEDURE_REF(BgL_envz00_13604, (int) (((long) 2)));
				BgL_nbargsz00_13608 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13604, (int) (((long) 3))));
				BgL_argsz00_13609 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13604, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 795 */
					obj_t BgL_bpz00_15642;

					BgL_bpz00_15642 = VECTOR_REF(((obj_t) BgL_sz00_13610), ((long) 0));
					{	/* Eval/evaluate_comp.scm 795 */
						obj_t BgL_fz00_15643;

						BgL_fz00_15643 =
							PROCEDURE_ENTRY(BgL_fz00_13605) (BgL_fz00_13605, BgL_sz00_13610,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15643))
							{	/* Eval/evaluate_comp.scm 795 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 795 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13606))->
										BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15643);
							}
						{	/* Eval/evaluate_comp.scm 795 */
							obj_t BgL_ufz00_15644;

							{	/* Eval/evaluate_comp.scm 795 */
								obj_t BgL_tmpz00_19385;

								BgL_tmpz00_19385 = ((obj_t) BgL_fz00_15643);
								BgL_ufz00_15644 = PROCEDURE_ATTR(BgL_tmpz00_19385);
							}
							{	/* Eval/evaluate_comp.scm 795 */
								bool_t BgL_test6190z00_19388;

								if (STRUCTP(BgL_ufz00_15644))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6190z00_19388 =
											(STRUCT_KEY(BgL_ufz00_15644) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6190z00_19388 = ((bool_t) 0);
									}
								if (BgL_test6190z00_19388)
									{	/* Eval/evaluate_comp.scm 795 */
										obj_t BgL_arityz00_15645;
										obj_t BgL_runz00_15646;
										obj_t BgL_sfz00_15647;

										BgL_arityz00_15645 =
											STRUCT_REF(BgL_ufz00_15644, (int) (((long) 0)));
										BgL_runz00_15646 =
											STRUCT_REF(BgL_ufz00_15644, (int) (((long) 1)));
										BgL_sfz00_15647 =
											STRUCT_REF(BgL_ufz00_15644, (int) (((long) 2)));
										if (
											((long) CINT(BgL_arityz00_15645) == BgL_nbargsz00_13608))
											{
												obj_t BgL_lz00_15649;
												obj_t BgL_spz00_15650;

												{	/* Eval/evaluate_comp.scm 710 */
													bool_t BgL_tmpz00_19402;

													BgL_lz00_15649 = BgL_argsz00_13609;
													BgL_spz00_15650 = BgL_bpz00_15642;
												BgL_recz00_15648:
													if (NULLP(BgL_lz00_15649))
														{	/* Eval/evaluate_comp.scm 711 */
															BgL_tmpz00_19402 = ((bool_t) 0);
														}
													else
														{	/* Eval/evaluate_comp.scm 711 */
															{	/* Eval/evaluate_comp.scm 712 */
																obj_t BgL_arg1774z00_15651;

																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_fun1775z00_15652;

																	BgL_fun1775z00_15652 =
																		CAR(((obj_t) BgL_lz00_15649));
																	BgL_arg1774z00_15651 =
																		PROCEDURE_ENTRY(BgL_fun1775z00_15652)
																		(BgL_fun1775z00_15652, BgL_sz00_13610,
																		BEOA);
																}
																{	/* Eval/evaluate_comp.scm 712 */
																	long BgL_kz00_15653;

																	BgL_kz00_15653 = (long) CINT(BgL_spz00_15650);
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13610), BgL_kz00_15653,
																		BgL_arg1774z00_15651);
															}}
															{	/* Eval/evaluate_comp.scm 713 */
																obj_t BgL_arg1776z00_15654;
																long BgL_arg1777z00_15655;

																BgL_arg1776z00_15654 =
																	CDR(((obj_t) BgL_lz00_15649));
																BgL_arg1777z00_15655 =
																	((long) CINT(BgL_spz00_15650) + ((long) 1));
																{
																	obj_t BgL_spz00_19419;
																	obj_t BgL_lz00_19418;

																	BgL_lz00_19418 = BgL_arg1776z00_15654;
																	BgL_spz00_19419 = BINT(BgL_arg1777z00_15655);
																	BgL_spz00_15650 = BgL_spz00_19419;
																	BgL_lz00_15649 = BgL_lz00_19418;
																	goto BgL_recz00_15648;
																}
															}
														}
													BBOOL(BgL_tmpz00_19402);
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												bool_t BgL_test6194z00_19422;

												if (((long) CINT(BgL_arityz00_15645) >= ((long) 0)))
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test6194z00_19422 = ((bool_t) 1);
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BgL_test6194z00_19422 =
															(
															(long) CINT(BgL_arityz00_15645) <
															(((long) -1) - BgL_nbargsz00_13608));
													}
												if (BgL_test6194z00_19422)
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_evarityzd2errorzd2zz__everrorz00(
															(((BgL_ev_appz00_bglt)
																	COBJECT(BgL_i1157z00_13606))->BgL_locz00),
															STRUCT_REF(BgL_ufz00_15644, (int) (((long) 3))),
															(int) (BgL_nbargsz00_13608),
															CINT(BgL_arityz00_15645));
													}
												else
													{	/* Eval/evaluate_comp.scm 795 */
														BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
															(BgL_arityz00_15645, BgL_sz00_13610,
															BgL_argsz00_13609, BgL_bpz00_15642);
													}
											}
										{	/* Eval/evaluate_comp.scm 795 */
											obj_t BgL_z12denvz12_15656;

											BgL_z12denvz12_15656 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15642) +
														(long) CINT(BgL_sfz00_15647)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13610))))
												{	/* Eval/evaluate_comp.scm 795 */
													return BgL_runz00_15646;
												}
											else
												{	/* Eval/evaluate_comp.scm 795 */
													obj_t BgL_nsz00_15657;

													BgL_nsz00_15657 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 795 */
														long BgL_arg1908z00_15658;

														BgL_arg1908z00_15658 =
															(
															(long) CINT(BgL_bpz00_15642) +
															BgL_nbargsz00_13608);
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15657, ((long) 2), BgL_sz00_13610,
															BgL_bpz00_15642, BINT(BgL_arg1908z00_15658));
													}
													VECTOR_SET(BgL_nsz00_15657, ((long) 1),
														BgL_sz00_13610);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15656,
														BgL_nsz00_15657);
													{	/* Eval/evaluate_comp.scm 795 */
														obj_t BgL_ez00_15659;

														BgL_ez00_15659 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15659, BgL_sz00_13610);
														{	/* Eval/evaluate_comp.scm 795 */
															obj_t BgL_____rz00_15660;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15661;

																BgL_savedzd2bpzd2_15661 =
																	VECTOR_REF(BgL_nsz00_15657, ((long) 0));
																VECTOR_SET(BgL_nsz00_15657, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15663;

																	BgL_fz00_15663 = BgL_runz00_15646;
																BgL_recz00_15662:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15664;

																		BgL_rz00_15664 =
																			PROCEDURE_ENTRY(BgL_fz00_15663)
																			(BgL_fz00_15663, BgL_nsz00_15657, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6197z00_19460;

																			if (PROCEDUREP(BgL_rz00_15664))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_15665;

																					BgL_arg1732z00_15665 =
																						PROCEDURE_ATTR(BgL_rz00_15664);
																					if (STRUCTP(BgL_arg1732z00_15665))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6197z00_19460 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_15665) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6197z00_19460 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6197z00_19460 = ((bool_t) 0);
																				}
																			if (BgL_test6197z00_19460)
																				{
																					obj_t BgL_fz00_19468;

																					BgL_fz00_19468 = BgL_rz00_15664;
																					BgL_fz00_15663 = BgL_fz00_19468;
																					goto BgL_recz00_15662;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15657,
																						((long) 0),
																						BgL_savedzd2bpzd2_15661);
																					BgL_____rz00_15660 = BgL_rz00_15664;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15659);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15656,
																BgL_sz00_13610);
															return BgL_____rz00_15660;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 795 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15643,
												(int) (BgL_nbargsz00_13608)))
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13610, BgL_fz00_15643, BgL_argsz00_13609,
													BgL_bpz00_15642, BINT(BgL_nbargsz00_13608));
											}
										else
											{	/* Eval/evaluate_comp.scm 795 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13606))->
														BgL_locz00), BgL_symbzd2funzd2_13607,
													(int) (BgL_nbargsz00_13608),
													PROCEDURE_ARITY(BgL_fz00_15643));
		}}}}}}}}

	}



/* &<@anonymous:1917> */
	obj_t BGl_z62zc3z04anonymousza31917ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13611, obj_t BgL_sz00_13618)
	{
		{	/* Eval/evaluate_comp.scm 781 */
			{	/* Eval/evaluate_comp.scm 781 */
				obj_t BgL_fz00_13612;
				BgL_ev_appz00_bglt BgL_i1157z00_13613;
				obj_t BgL_symbzd2funzd2_13614;
				long BgL_nbargsz00_13615;
				obj_t BgL_argsz00_13616;
				long BgL_siza7eza7_13617;

				BgL_fz00_13612 = PROCEDURE_REF(BgL_envz00_13611, (int) (((long) 0)));
				BgL_i1157z00_13613 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13611, (int) (((long) 1))));
				BgL_symbzd2funzd2_13614 =
					PROCEDURE_REF(BgL_envz00_13611, (int) (((long) 2)));
				BgL_nbargsz00_13615 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13611, (int) (((long) 3))));
				BgL_argsz00_13616 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13611, (int) (((long) 4))));
				BgL_siza7eza7_13617 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13611, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 781 */
					obj_t BgL_bpz00_15666;

					BgL_bpz00_15666 = VECTOR_REF(((obj_t) BgL_sz00_13618), ((long) 0));
					{	/* Eval/evaluate_comp.scm 781 */
						obj_t BgL_fz00_15667;

						BgL_fz00_15667 =
							PROCEDURE_ENTRY(BgL_fz00_13612) (BgL_fz00_13612, BgL_sz00_13618,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15667))
							{	/* Eval/evaluate_comp.scm 781 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13613))->
										BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15667);
							}
						{	/* Eval/evaluate_comp.scm 781 */
							obj_t BgL_ufz00_15668;

							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_tmpz00_19507;

								BgL_tmpz00_19507 = ((obj_t) BgL_fz00_15667);
								BgL_ufz00_15668 = PROCEDURE_ATTR(BgL_tmpz00_19507);
							}
							{	/* Eval/evaluate_comp.scm 781 */
								bool_t BgL_test6202z00_19510;

								if (STRUCTP(BgL_ufz00_15668))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6202z00_19510 =
											(STRUCT_KEY(BgL_ufz00_15668) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6202z00_19510 = ((bool_t) 0);
									}
								if (BgL_test6202z00_19510)
									{	/* Eval/evaluate_comp.scm 781 */
										obj_t BgL_arityz00_15669;
										obj_t BgL_runz00_15670;
										obj_t BgL_sfz00_15671;

										BgL_arityz00_15669 =
											STRUCT_REF(BgL_ufz00_15668, (int) (((long) 0)));
										BgL_runz00_15670 =
											STRUCT_REF(BgL_ufz00_15668, (int) (((long) 1)));
										BgL_sfz00_15671 =
											STRUCT_REF(BgL_ufz00_15668, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 781 */
											long BgL_spz00_15672;

											BgL_spz00_15672 =
												((long) CINT(BgL_bpz00_15666) + BgL_siza7eza7_13617);
											if (
												((long) CINT(BgL_arityz00_15669) ==
													BgL_nbargsz00_13615))
												{
													obj_t BgL_lz00_15674;
													long BgL_spz00_15675;

													{	/* Eval/evaluate_comp.scm 710 */
														bool_t BgL_tmpz00_19526;

														BgL_lz00_15674 = BgL_argsz00_13616;
														BgL_spz00_15675 = BgL_spz00_15672;
													BgL_recz00_15673:
														if (NULLP(BgL_lz00_15674))
															{	/* Eval/evaluate_comp.scm 711 */
																BgL_tmpz00_19526 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1774z00_15676;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1775z00_15677;

																		BgL_fun1775z00_15677 =
																			CAR(((obj_t) BgL_lz00_15674));
																		BgL_arg1774z00_15676 =
																			PROCEDURE_ENTRY(BgL_fun1775z00_15677)
																			(BgL_fun1775z00_15677, BgL_sz00_13618,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13618), BgL_spz00_15675,
																		BgL_arg1774z00_15676);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1776z00_15678;
																	long BgL_arg1777z00_15679;

																	BgL_arg1776z00_15678 =
																		CDR(((obj_t) BgL_lz00_15674));
																	BgL_arg1777z00_15679 =
																		(BgL_spz00_15675 + ((long) 1));
																	{
																		long BgL_spz00_19541;
																		obj_t BgL_lz00_19540;

																		BgL_lz00_19540 = BgL_arg1776z00_15678;
																		BgL_spz00_19541 = BgL_arg1777z00_15679;
																		BgL_spz00_15675 = BgL_spz00_19541;
																		BgL_lz00_15674 = BgL_lz00_19540;
																		goto BgL_recz00_15673;
																	}
																}
															}
														BBOOL(BgL_tmpz00_19526);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 781 */
													bool_t BgL_test6206z00_19543;

													if (((long) CINT(BgL_arityz00_15669) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test6206z00_19543 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test6206z00_19543 =
																(
																(long) CINT(BgL_arityz00_15669) <
																(((long) -1) - BgL_nbargsz00_13615));
														}
													if (BgL_test6206z00_19543)
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13613))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15668, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13615),
																CINT(BgL_arityz00_15669));
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15669, BgL_sz00_13618,
																BgL_argsz00_13616, BINT(BgL_spz00_15672));
														}
												}
											{	/* Eval/evaluate_comp.scm 781 */
												obj_t BgL_z12denvz12_15680;

												BgL_z12denvz12_15680 = BGL_CURRENT_DYNAMIC_ENV();
												{	/* Eval/evaluate_comp.scm 781 */
													obj_t BgL_tmpz00_19559;

													BgL_tmpz00_19559 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13613))->BgL_locz00);
													BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15680,
														BgL_tmpz00_19559);
												}
												if (
													((BgL_spz00_15672 +
															(long) CINT(BgL_sfz00_15671)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13618))))
													{	/* Eval/evaluate_comp.scm 781 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15670, BgL_sz00_13618,
															BINT(BgL_spz00_15672));
													}
												else
													{	/* Eval/evaluate_comp.scm 781 */
														obj_t BgL_nsz00_15681;

														BgL_nsz00_15681 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 781 */
															long BgL_arg1930z00_15682;

															BgL_arg1930z00_15682 =
																(BgL_spz00_15672 + BgL_nbargsz00_13615);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15681, ((long) 2), BgL_sz00_13618,
																BINT(BgL_spz00_15672),
																BINT(BgL_arg1930z00_15682));
														}
														VECTOR_SET(BgL_nsz00_15681, ((long) 1),
															BgL_sz00_13618);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15680,
															BgL_nsz00_15681);
														{	/* Eval/evaluate_comp.scm 781 */
															obj_t BgL_ez00_15683;

															BgL_ez00_15683 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15683, BgL_sz00_13618);
															{	/* Eval/evaluate_comp.scm 781 */
																obj_t BgL_____rz00_15684;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15685;

																	BgL_savedzd2bpzd2_15685 =
																		VECTOR_REF(BgL_nsz00_15681, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15681, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15687;

																		BgL_fz00_15687 = BgL_runz00_15670;
																	BgL_recz00_15686:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15688;

																			BgL_rz00_15688 =
																				PROCEDURE_ENTRY(BgL_fz00_15687)
																				(BgL_fz00_15687, BgL_nsz00_15681, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6209z00_19586;

																				if (PROCEDUREP(BgL_rz00_15688))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_15689;

																						BgL_arg1732z00_15689 =
																							PROCEDURE_ATTR(BgL_rz00_15688);
																						if (STRUCTP(BgL_arg1732z00_15689))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6209z00_19586 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_15689) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6209z00_19586 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6209z00_19586 =
																							((bool_t) 0);
																					}
																				if (BgL_test6209z00_19586)
																					{
																						obj_t BgL_fz00_19594;

																						BgL_fz00_19594 = BgL_rz00_15688;
																						BgL_fz00_15687 = BgL_fz00_19594;
																						goto BgL_recz00_15686;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15681,
																							((long) 0),
																							BgL_savedzd2bpzd2_15685);
																						BgL_____rz00_15684 = BgL_rz00_15688;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15683);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15680,
																	BgL_sz00_13618);
																return BgL_____rz00_15684;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 781 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15667,
												(int) (BgL_nbargsz00_13615)))
											{	/* Eval/evaluate_comp.scm 781 */
												{	/* Eval/evaluate_comp.scm 781 */
													obj_t BgL_auxz00_19603;
													obj_t BgL_tmpz00_19601;

													BgL_auxz00_19603 =
														(((BgL_ev_appz00_bglt)
															COBJECT(BgL_i1157z00_13613))->BgL_locz00);
													BgL_tmpz00_19601 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19601,
														BgL_auxz00_19603);
												}
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13618, BgL_fz00_15667, BgL_argsz00_13616,
													BgL_bpz00_15666, BINT(BgL_siza7eza7_13617));
											}
										else
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13613))->
														BgL_locz00), BgL_symbzd2funzd2_13614,
													(int) (BgL_nbargsz00_13615),
													PROCEDURE_ARITY(BgL_fz00_15667));
		}}}}}}}}

	}



/* &<@anonymous:1938> */
	obj_t BGl_z62zc3z04anonymousza31938ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13619, obj_t BgL_sz00_13626)
	{
		{	/* Eval/evaluate_comp.scm 781 */
			{	/* Eval/evaluate_comp.scm 781 */
				obj_t BgL_fz00_13620;
				BgL_ev_appz00_bglt BgL_i1157z00_13621;
				obj_t BgL_symbzd2funzd2_13622;
				long BgL_nbargsz00_13623;
				obj_t BgL_argsz00_13624;
				long BgL_siza7eza7_13625;

				BgL_fz00_13620 = PROCEDURE_REF(BgL_envz00_13619, (int) (((long) 0)));
				BgL_i1157z00_13621 =
					((BgL_ev_appz00_bglt)
					PROCEDURE_REF(BgL_envz00_13619, (int) (((long) 1))));
				BgL_symbzd2funzd2_13622 =
					PROCEDURE_REF(BgL_envz00_13619, (int) (((long) 2)));
				BgL_nbargsz00_13623 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13619, (int) (((long) 3))));
				BgL_argsz00_13624 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13619, (int) (((long) 4))));
				BgL_siza7eza7_13625 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13619, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 781 */
					obj_t BgL_bpz00_15690;

					BgL_bpz00_15690 = VECTOR_REF(((obj_t) BgL_sz00_13626), ((long) 0));
					{	/* Eval/evaluate_comp.scm 781 */
						obj_t BgL_fz00_15691;

						BgL_fz00_15691 =
							PROCEDURE_ENTRY(BgL_fz00_13620) (BgL_fz00_13620, BgL_sz00_13626,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15691))
							{	/* Eval/evaluate_comp.scm 781 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 781 */
								BGl_evtypezd2errorzd2zz__everrorz00(
									(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13621))->
										BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15691);
							}
						{	/* Eval/evaluate_comp.scm 781 */
							obj_t BgL_ufz00_15692;

							{	/* Eval/evaluate_comp.scm 781 */
								obj_t BgL_tmpz00_19638;

								BgL_tmpz00_19638 = ((obj_t) BgL_fz00_15691);
								BgL_ufz00_15692 = PROCEDURE_ATTR(BgL_tmpz00_19638);
							}
							{	/* Eval/evaluate_comp.scm 781 */
								bool_t BgL_test6214z00_19641;

								if (STRUCTP(BgL_ufz00_15692))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6214z00_19641 =
											(STRUCT_KEY(BgL_ufz00_15692) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6214z00_19641 = ((bool_t) 0);
									}
								if (BgL_test6214z00_19641)
									{	/* Eval/evaluate_comp.scm 781 */
										obj_t BgL_arityz00_15693;
										obj_t BgL_runz00_15694;
										obj_t BgL_sfz00_15695;

										BgL_arityz00_15693 =
											STRUCT_REF(BgL_ufz00_15692, (int) (((long) 0)));
										BgL_runz00_15694 =
											STRUCT_REF(BgL_ufz00_15692, (int) (((long) 1)));
										BgL_sfz00_15695 =
											STRUCT_REF(BgL_ufz00_15692, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 781 */
											long BgL_spz00_15696;

											BgL_spz00_15696 =
												((long) CINT(BgL_bpz00_15690) + BgL_siza7eza7_13625);
											if (
												((long) CINT(BgL_arityz00_15693) ==
													BgL_nbargsz00_13623))
												{
													obj_t BgL_lz00_15698;
													long BgL_spz00_15699;

													{	/* Eval/evaluate_comp.scm 710 */
														bool_t BgL_tmpz00_19657;

														BgL_lz00_15698 = BgL_argsz00_13624;
														BgL_spz00_15699 = BgL_spz00_15696;
													BgL_recz00_15697:
														if (NULLP(BgL_lz00_15698))
															{	/* Eval/evaluate_comp.scm 711 */
																BgL_tmpz00_19657 = ((bool_t) 0);
															}
														else
															{	/* Eval/evaluate_comp.scm 711 */
																{	/* Eval/evaluate_comp.scm 712 */
																	obj_t BgL_arg1774z00_15700;

																	{	/* Eval/evaluate_comp.scm 712 */
																		obj_t BgL_fun1775z00_15701;

																		BgL_fun1775z00_15701 =
																			CAR(((obj_t) BgL_lz00_15698));
																		BgL_arg1774z00_15700 =
																			PROCEDURE_ENTRY(BgL_fun1775z00_15701)
																			(BgL_fun1775z00_15701, BgL_sz00_13626,
																			BEOA);
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13626), BgL_spz00_15699,
																		BgL_arg1774z00_15700);
																}
																{	/* Eval/evaluate_comp.scm 713 */
																	obj_t BgL_arg1776z00_15702;
																	long BgL_arg1777z00_15703;

																	BgL_arg1776z00_15702 =
																		CDR(((obj_t) BgL_lz00_15698));
																	BgL_arg1777z00_15703 =
																		(BgL_spz00_15699 + ((long) 1));
																	{
																		long BgL_spz00_19672;
																		obj_t BgL_lz00_19671;

																		BgL_lz00_19671 = BgL_arg1776z00_15702;
																		BgL_spz00_19672 = BgL_arg1777z00_15703;
																		BgL_spz00_15699 = BgL_spz00_19672;
																		BgL_lz00_15698 = BgL_lz00_19671;
																		goto BgL_recz00_15697;
																	}
																}
															}
														BBOOL(BgL_tmpz00_19657);
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 781 */
													bool_t BgL_test6218z00_19674;

													if (((long) CINT(BgL_arityz00_15693) >= ((long) 0)))
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test6218z00_19674 = ((bool_t) 1);
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BgL_test6218z00_19674 =
																(
																(long) CINT(BgL_arityz00_15693) <
																(((long) -1) - BgL_nbargsz00_13623));
														}
													if (BgL_test6218z00_19674)
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_evarityzd2errorzd2zz__everrorz00(
																(((BgL_ev_appz00_bglt)
																		COBJECT(BgL_i1157z00_13621))->BgL_locz00),
																STRUCT_REF(BgL_ufz00_15692, (int) (((long) 3))),
																(int) (BgL_nbargsz00_13623),
																CINT(BgL_arityz00_15693));
														}
													else
														{	/* Eval/evaluate_comp.scm 781 */
															BGl_pushzd2nargszd2onzd2spzd2zz__evaluate_compz00
																(BgL_arityz00_15693, BgL_sz00_13626,
																BgL_argsz00_13624, BINT(BgL_spz00_15696));
														}
												}
											{	/* Eval/evaluate_comp.scm 781 */
												obj_t BgL_z12denvz12_15704;

												BgL_z12denvz12_15704 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15696 +
															(long) CINT(BgL_sfz00_15695)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13626))))
													{	/* Eval/evaluate_comp.scm 781 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15694, BgL_sz00_13626,
															BINT(BgL_spz00_15696));
													}
												else
													{	/* Eval/evaluate_comp.scm 781 */
														obj_t BgL_nsz00_15705;

														BgL_nsz00_15705 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 781 */
															long BgL_arg1950z00_15706;

															BgL_arg1950z00_15706 =
																(BgL_spz00_15696 + BgL_nbargsz00_13623);
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15705, ((long) 2), BgL_sz00_13626,
																BINT(BgL_spz00_15696),
																BINT(BgL_arg1950z00_15706));
														}
														VECTOR_SET(BgL_nsz00_15705, ((long) 1),
															BgL_sz00_13626);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15704,
															BgL_nsz00_15705);
														{	/* Eval/evaluate_comp.scm 781 */
															obj_t BgL_ez00_15707;

															BgL_ez00_15707 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15707, BgL_sz00_13626);
															{	/* Eval/evaluate_comp.scm 781 */
																obj_t BgL_____rz00_15708;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15709;

																	BgL_savedzd2bpzd2_15709 =
																		VECTOR_REF(BgL_nsz00_15705, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15705, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15711;

																		BgL_fz00_15711 = BgL_runz00_15694;
																	BgL_recz00_15710:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15712;

																			BgL_rz00_15712 =
																				PROCEDURE_ENTRY(BgL_fz00_15711)
																				(BgL_fz00_15711, BgL_nsz00_15705, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6221z00_19714;

																				if (PROCEDUREP(BgL_rz00_15712))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_15713;

																						BgL_arg1732z00_15713 =
																							PROCEDURE_ATTR(BgL_rz00_15712);
																						if (STRUCTP(BgL_arg1732z00_15713))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6221z00_19714 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_15713) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6221z00_19714 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6221z00_19714 =
																							((bool_t) 0);
																					}
																				if (BgL_test6221z00_19714)
																					{
																						obj_t BgL_fz00_19722;

																						BgL_fz00_19722 = BgL_rz00_15712;
																						BgL_fz00_15711 = BgL_fz00_19722;
																						goto BgL_recz00_15710;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15705,
																							((long) 0),
																							BgL_savedzd2bpzd2_15709);
																						BgL_____rz00_15708 = BgL_rz00_15712;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15707);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15704,
																	BgL_sz00_13626);
																return BgL_____rz00_15708;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 781 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15691,
												(int) (BgL_nbargsz00_13623)))
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_subrzd2callzd2withzd2pushzd2zz__evaluate_compz00
													(BgL_sz00_13626, BgL_fz00_15691, BgL_argsz00_13624,
													BgL_bpz00_15690, BINT(BgL_siza7eza7_13625));
											}
										else
											{	/* Eval/evaluate_comp.scm 781 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(
													(((BgL_ev_appz00_bglt) COBJECT(BgL_i1157z00_13621))->
														BgL_locz00), BgL_symbzd2funzd2_13622,
													(int) (BgL_nbargsz00_13623),
													PROCEDURE_ARITY(BgL_fz00_15691));
		}}}}}}}}

	}



/* comp-call0 */
	obj_t BGl_compzd2call0zd2zz__evaluate_compz00(obj_t BgL_locz00_138,
		BgL_ev_exprz00_bglt BgL_vfunz00_139, obj_t BgL_symbzd2funzd2_140,
		obj_t BgL_funz00_141, obj_t BgL_tailzf3zf3_142, obj_t BgL_stkz00_143,
		long BgL_siza7eza7_144)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_1976;

				BgL_cfunz00_1976 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_139,
					((long) 0), BgL_locz00_138, BgL_symbzd2funzd2_140);
				if (CBOOL(BgL_cfunz00_1976))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6226z00_19738;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg1965z00_1990;

							BgL_arg1965z00_1990 = bgl_debug();
							BgL_test6226z00_19738 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1965z00_1990),
								BINT(((long) 0)));
						}
						if (BgL_test6226z00_19738)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza31962ze3z87_13627;

								BgL_zc3z04anonymousza31962ze3z87_13627 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31962ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31962ze3z87_13627,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3z04anonymousza31962ze3z87_13627,
									(int) (((long) 1)), BgL_locz00_138);
								PROCEDURE_SET(BgL_zc3z04anonymousza31962ze3z87_13627,
									(int) (((long) 2)), BgL_cfunz00_1976);
								return BgL_zc3z04anonymousza31962ze3z87_13627;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza31964ze3z87_13628;

								BgL_zc3z04anonymousza31964ze3z87_13628 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza31964ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 2)));
								PROCEDURE_SET(BgL_zc3z04anonymousza31964ze3z87_13628,
									(int) (((long) 0)), BINT(BgL_siza7eza7_144));
								PROCEDURE_SET(BgL_zc3z04anonymousza31964ze3z87_13628,
									(int) (((long) 1)), BgL_cfunz00_1976);
								return BgL_zc3z04anonymousza31964ze3z87_13628;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_142))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6228z00_19763;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg1996z00_2054;

									BgL_arg1996z00_2054 = bgl_debug();
									BgL_test6228z00_19763 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1996z00_2054),
										BINT(((long) 0)));
								}
								if (BgL_test6228z00_19763)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31968ze3z87_13629;

										BgL_zc3z04anonymousza31968ze3z87_13629 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31968ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31968ze3z87_13629,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31968ze3z87_13629,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31968ze3z87_13629,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31968ze3z87_13629,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31968ze3z87_13629;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza31982ze3z87_13630;

										BgL_zc3z04anonymousza31982ze3z87_13630 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza31982ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza31982ze3z87_13630,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza31982ze3z87_13630,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza31982ze3z87_13630,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza31982ze3z87_13630,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza31982ze3z87_13630;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6229z00_19792;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2031z00_2118;

									BgL_arg2031z00_2118 = bgl_debug();
									BgL_test6229z00_19792 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2031z00_2118),
										BINT(((long) 0)));
								}
								if (BgL_test6229z00_19792)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32000ze3z87_13631;

										BgL_zc3z04anonymousza32000ze3z87_13631 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32000ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32000ze3z87_13631,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza32000ze3z87_13631,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza32000ze3z87_13631,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza32000ze3z87_13631,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza32000ze3z87_13631;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32017ze3z87_13632;

										BgL_zc3z04anonymousza32017ze3z87_13632 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 4)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13632,
											(int) (((long) 0)), BgL_funz00_141);
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13632,
											(int) (((long) 1)), BgL_locz00_138);
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13632,
											(int) (((long) 2)), BgL_symbzd2funzd2_140);
										PROCEDURE_SET(BgL_zc3z04anonymousza32017ze3z87_13632,
											(int) (((long) 3)), BINT(BgL_siza7eza7_144));
										return BgL_zc3z04anonymousza32017ze3z87_13632;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:1962> */
	obj_t BGl_z62zc3z04anonymousza31962ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13633, obj_t BgL_sz00_13637)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				long BgL_siza7eza7_13634;
				obj_t BgL_locz00_13635;
				obj_t BgL_cfunz00_13636;

				BgL_siza7eza7_13634 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13633, (int) (((long) 0))));
				BgL_locz00_13635 = PROCEDURE_REF(BgL_envz00_13633, (int) (((long) 1)));
				BgL_cfunz00_13636 = PROCEDURE_REF(BgL_envz00_13633, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15714;

					BgL_bpz00_15714 = VECTOR_REF(((obj_t) BgL_sz00_13637), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */

						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15715;

							BgL_nbpz00_15715 =
								((long) CINT(BgL_bpz00_15714) + BgL_siza7eza7_13634);
							VECTOR_SET(
								((obj_t) BgL_sz00_13637), ((long) 0), BINT(BgL_nbpz00_15715));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19835;

								BgL_tmpz00_19835 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19835, BgL_locz00_13635);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15716;

								BgL_rz00_15716 =
									PROCEDURE_ENTRY(BgL_cfunz00_13636) (BgL_cfunz00_13636, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_13637), ((long) 0), BgL_bpz00_15714);
								return BgL_rz00_15716;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1964> */
	obj_t BGl_z62zc3z04anonymousza31964ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13638, obj_t BgL_sz00_13641)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				long BgL_siza7eza7_13639;
				obj_t BgL_cfunz00_13640;

				BgL_siza7eza7_13639 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13638, (int) (((long) 0))));
				BgL_cfunz00_13640 = PROCEDURE_REF(BgL_envz00_13638, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15717;

					BgL_bpz00_15717 = VECTOR_REF(((obj_t) BgL_sz00_13641), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */

						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15718;

							BgL_nbpz00_15718 =
								((long) CINT(BgL_bpz00_15717) + BgL_siza7eza7_13639);
							VECTOR_SET(
								((obj_t) BgL_sz00_13641), ((long) 0), BINT(BgL_nbpz00_15718));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15719;

								BgL_rz00_15719 =
									PROCEDURE_ENTRY(BgL_cfunz00_13640) (BgL_cfunz00_13640, BEOA);
								VECTOR_SET(
									((obj_t) BgL_sz00_13641), ((long) 0), BgL_bpz00_15717);
								return BgL_rz00_15719;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:1968> */
	obj_t BGl_z62zc3z04anonymousza31968ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13642, obj_t BgL_sz00_13647)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13643;
				obj_t BgL_locz00_13644;
				obj_t BgL_symbzd2funzd2_13645;
				long BgL_siza7eza7_13646;

				BgL_funz00_13643 = PROCEDURE_REF(BgL_envz00_13642, (int) (((long) 0)));
				BgL_locz00_13644 = PROCEDURE_REF(BgL_envz00_13642, (int) (((long) 1)));
				BgL_symbzd2funzd2_13645 =
					PROCEDURE_REF(BgL_envz00_13642, (int) (((long) 2)));
				BgL_siza7eza7_13646 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13642, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15720;

					BgL_bpz00_15720 = VECTOR_REF(((obj_t) BgL_sz00_13647), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15721;

						BgL_fz00_15721 =
							PROCEDURE_ENTRY(BgL_funz00_13643) (BgL_funz00_13643,
							BgL_sz00_13647, BEOA);
						if (PROCEDUREP(BgL_fz00_15721))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13644,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15721);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15722;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19878;

								BgL_tmpz00_19878 = ((obj_t) BgL_fz00_15721);
								BgL_ufz00_15722 = PROCEDURE_ATTR(BgL_tmpz00_19878);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6231z00_19881;

								if (STRUCTP(BgL_ufz00_15722))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6231z00_19881 =
											(STRUCT_KEY(BgL_ufz00_15722) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6231z00_19881 = ((bool_t) 0);
									}
								if (BgL_test6231z00_19881)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15723;
										obj_t BgL_runz00_15724;
										obj_t BgL_sfz00_15725;

										BgL_arityz00_15723 =
											STRUCT_REF(BgL_ufz00_15722, (int) (((long) 0)));
										BgL_runz00_15724 =
											STRUCT_REF(BgL_ufz00_15722, (int) (((long) 1)));
										BgL_sfz00_15725 =
											STRUCT_REF(BgL_ufz00_15722, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15723) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 896 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15723))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15723))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg1973z00_15726;
																	obj_t BgL_arg1974z00_15727;

																	BgL_arg1973z00_15726 =
																		((long) CINT(BgL_bpz00_15720) + ((long) 0));
																	BgL_arg1974z00_15727 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13647),
																		BgL_arg1973z00_15726, BgL_arg1974z00_15727);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13644, STRUCT_REF(BgL_ufz00_15722,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_15723));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13644, STRUCT_REF(BgL_ufz00_15722,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_15723));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15728;

											BgL_z12denvz12_15728 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15728,
												BgL_locz00_13644);
											if ((((long) CINT(BgL_bpz00_15720) +
														(long) CINT(BgL_sfz00_15725)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13647))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15724;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15729;

													BgL_nsz00_15729 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg1978z00_15730;

														BgL_arg1978z00_15730 =
															((long) CINT(BgL_bpz00_15720) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15729, ((long) 2), BgL_sz00_13647,
															BgL_bpz00_15720, BINT(BgL_arg1978z00_15730));
													}
													VECTOR_SET(BgL_nsz00_15729, ((long) 1),
														BgL_sz00_13647);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15728,
														BgL_nsz00_15729);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15731;

														BgL_ez00_15731 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15731, BgL_sz00_13647);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15732;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15733;

																BgL_savedzd2bpzd2_15733 =
																	VECTOR_REF(BgL_nsz00_15729, ((long) 0));
																VECTOR_SET(BgL_nsz00_15729, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15735;

																	BgL_fz00_15735 = BgL_runz00_15724;
																BgL_recz00_15734:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15736;

																		BgL_rz00_15736 =
																			PROCEDURE_ENTRY(BgL_fz00_15735)
																			(BgL_fz00_15735, BgL_nsz00_15729, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6236z00_19938;

																			if (PROCEDUREP(BgL_rz00_15736))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_15737;

																					BgL_arg1732z00_15737 =
																						PROCEDURE_ATTR(BgL_rz00_15736);
																					if (STRUCTP(BgL_arg1732z00_15737))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6236z00_19938 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_15737) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6236z00_19938 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6236z00_19938 = ((bool_t) 0);
																				}
																			if (BgL_test6236z00_19938)
																				{
																					obj_t BgL_fz00_19946;

																					BgL_fz00_19946 = BgL_rz00_15736;
																					BgL_fz00_15735 = BgL_fz00_19946;
																					goto BgL_recz00_15734;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15729,
																						((long) 0),
																						BgL_savedzd2bpzd2_15733);
																					BgL_____rz00_15732 = BgL_rz00_15736;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15731);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15728,
																BgL_sz00_13647);
															return BgL_____rz00_15732;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15721,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15738;

												BgL_nbpz00_15738 =
													((long) CINT(BgL_bpz00_15720) + BgL_siza7eza7_13646);
												VECTOR_SET(
													((obj_t) BgL_sz00_13647), ((long) 0),
													BINT(BgL_nbpz00_15738));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_19958;

													BgL_tmpz00_19958 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_19958,
														BgL_locz00_13644);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15739;

													BgL_rz00_15739 =
														PROCEDURE_ENTRY(BgL_fz00_15721) (BgL_fz00_15721,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13647), ((long) 0),
														BgL_bpz00_15720);
													return BgL_rz00_15739;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13644,
													BgL_symbzd2funzd2_13645, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15721));
		}}}}}}}}

	}



/* &<@anonymous:1982> */
	obj_t BGl_z62zc3z04anonymousza31982ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13648, obj_t BgL_sz00_13653)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13649;
				obj_t BgL_locz00_13650;
				obj_t BgL_symbzd2funzd2_13651;
				long BgL_siza7eza7_13652;

				BgL_funz00_13649 = PROCEDURE_REF(BgL_envz00_13648, (int) (((long) 0)));
				BgL_locz00_13650 = PROCEDURE_REF(BgL_envz00_13648, (int) (((long) 1)));
				BgL_symbzd2funzd2_13651 =
					PROCEDURE_REF(BgL_envz00_13648, (int) (((long) 2)));
				BgL_siza7eza7_13652 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13648, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15740;

					BgL_bpz00_15740 = VECTOR_REF(((obj_t) BgL_sz00_13653), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15741;

						BgL_fz00_15741 =
							PROCEDURE_ENTRY(BgL_funz00_13649) (BgL_funz00_13649,
							BgL_sz00_13653, BEOA);
						if (PROCEDUREP(BgL_fz00_15741))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13650,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15741);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15742;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_19987;

								BgL_tmpz00_19987 = ((obj_t) BgL_fz00_15741);
								BgL_ufz00_15742 = PROCEDURE_ATTR(BgL_tmpz00_19987);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6241z00_19990;

								if (STRUCTP(BgL_ufz00_15742))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6241z00_19990 =
											(STRUCT_KEY(BgL_ufz00_15742) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6241z00_19990 = ((bool_t) 0);
									}
								if (BgL_test6241z00_19990)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15743;
										obj_t BgL_runz00_15744;
										obj_t BgL_sfz00_15745;

										BgL_arityz00_15743 =
											STRUCT_REF(BgL_ufz00_15742, (int) (((long) 0)));
										BgL_runz00_15744 =
											STRUCT_REF(BgL_ufz00_15742, (int) (((long) 1)));
										BgL_sfz00_15745 =
											STRUCT_REF(BgL_ufz00_15742, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15743) == ((long) 0)))
											{	/* Eval/evaluate_comp.scm 896 */
												BUNSPEC;
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15743))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15743))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg1987z00_15746;
																	obj_t BgL_arg1988z00_15747;

																	BgL_arg1987z00_15746 =
																		((long) CINT(BgL_bpz00_15740) + ((long) 0));
																	BgL_arg1988z00_15747 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13653),
																		BgL_arg1987z00_15746, BgL_arg1988z00_15747);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13650, STRUCT_REF(BgL_ufz00_15742,
																		(int) (((long) 3))), (int) (((long) 0)),
																	CINT(BgL_arityz00_15743));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13650, STRUCT_REF(BgL_ufz00_15742,
																(int) (((long) 3))), (int) (((long) 0)),
															CINT(BgL_arityz00_15743));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15748;

											BgL_z12denvz12_15748 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15740) +
														(long) CINT(BgL_sfz00_15745)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13653))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15744;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15749;

													BgL_nsz00_15749 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg1993z00_15750;

														BgL_arg1993z00_15750 =
															((long) CINT(BgL_bpz00_15740) + ((long) 0));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15749, ((long) 2), BgL_sz00_13653,
															BgL_bpz00_15740, BINT(BgL_arg1993z00_15750));
													}
													VECTOR_SET(BgL_nsz00_15749, ((long) 1),
														BgL_sz00_13653);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15748,
														BgL_nsz00_15749);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15751;

														BgL_ez00_15751 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15751, BgL_sz00_13653);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15752;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15753;

																BgL_savedzd2bpzd2_15753 =
																	VECTOR_REF(BgL_nsz00_15749, ((long) 0));
																VECTOR_SET(BgL_nsz00_15749, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15755;

																	BgL_fz00_15755 = BgL_runz00_15744;
																BgL_recz00_15754:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15756;

																		BgL_rz00_15756 =
																			PROCEDURE_ENTRY(BgL_fz00_15755)
																			(BgL_fz00_15755, BgL_nsz00_15749, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6246z00_20046;

																			if (PROCEDUREP(BgL_rz00_15756))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_15757;

																					BgL_arg1732z00_15757 =
																						PROCEDURE_ATTR(BgL_rz00_15756);
																					if (STRUCTP(BgL_arg1732z00_15757))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6246z00_20046 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_15757) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6246z00_20046 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6246z00_20046 = ((bool_t) 0);
																				}
																			if (BgL_test6246z00_20046)
																				{
																					obj_t BgL_fz00_20054;

																					BgL_fz00_20054 = BgL_rz00_15756;
																					BgL_fz00_15755 = BgL_fz00_20054;
																					goto BgL_recz00_15754;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15749,
																						((long) 0),
																						BgL_savedzd2bpzd2_15753);
																					BgL_____rz00_15752 = BgL_rz00_15756;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15751);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15748,
																BgL_sz00_13653);
															return BgL_____rz00_15752;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15741,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15758;

												BgL_nbpz00_15758 =
													((long) CINT(BgL_bpz00_15740) + BgL_siza7eza7_13652);
												VECTOR_SET(
													((obj_t) BgL_sz00_13653), ((long) 0),
													BINT(BgL_nbpz00_15758));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15759;

													BgL_rz00_15759 =
														PROCEDURE_ENTRY(BgL_fz00_15741) (BgL_fz00_15741,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13653), ((long) 0),
														BgL_bpz00_15740);
													return BgL_rz00_15759;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13650,
													BgL_symbzd2funzd2_13651, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15741));
		}}}}}}}}

	}



/* &<@anonymous:2000> */
	obj_t BGl_z62zc3z04anonymousza32000ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13654, obj_t BgL_sz00_13659)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13655;
				obj_t BgL_locz00_13656;
				obj_t BgL_symbzd2funzd2_13657;
				long BgL_siza7eza7_13658;

				BgL_funz00_13655 = PROCEDURE_REF(BgL_envz00_13654, (int) (((long) 0)));
				BgL_locz00_13656 = PROCEDURE_REF(BgL_envz00_13654, (int) (((long) 1)));
				BgL_symbzd2funzd2_13657 =
					PROCEDURE_REF(BgL_envz00_13654, (int) (((long) 2)));
				BgL_siza7eza7_13658 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13654, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15760;

					BgL_bpz00_15760 = VECTOR_REF(((obj_t) BgL_sz00_13659), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15761;

						BgL_fz00_15761 =
							PROCEDURE_ENTRY(BgL_funz00_13655) (BgL_funz00_13655,
							BgL_sz00_13659, BEOA);
						if (PROCEDUREP(BgL_fz00_15761))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13656,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15761);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15762;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20092;

								BgL_tmpz00_20092 = ((obj_t) BgL_fz00_15761);
								BgL_ufz00_15762 = PROCEDURE_ATTR(BgL_tmpz00_20092);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6251z00_20095;

								if (STRUCTP(BgL_ufz00_15762))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6251z00_20095 =
											(STRUCT_KEY(BgL_ufz00_15762) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6251z00_20095 = ((bool_t) 0);
									}
								if (BgL_test6251z00_20095)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15763;
										obj_t BgL_runz00_15764;
										obj_t BgL_sfz00_15765;

										BgL_arityz00_15763 =
											STRUCT_REF(BgL_ufz00_15762, (int) (((long) 0)));
										BgL_runz00_15764 =
											STRUCT_REF(BgL_ufz00_15762, (int) (((long) 1)));
										BgL_sfz00_15765 =
											STRUCT_REF(BgL_ufz00_15762, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15766;

											BgL_spz00_15766 =
												((long) CINT(BgL_bpz00_15760) + BgL_siza7eza7_13658);
											if (((long) CINT(BgL_arityz00_15763) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 896 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15763))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15763))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2005z00_15767;
																		obj_t BgL_arg2006z00_15768;

																		BgL_arg2005z00_15767 =
																			(BgL_spz00_15766 + ((long) 0));
																		BgL_arg2006z00_15768 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13659),
																			BgL_arg2005z00_15767,
																			BgL_arg2006z00_15768);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13656,
																		STRUCT_REF(BgL_ufz00_15762,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_15763));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13656, STRUCT_REF(BgL_ufz00_15762,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_15763));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15769;

												BgL_z12denvz12_15769 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15769,
													BgL_locz00_13656);
												if (((BgL_spz00_15766 + (long) CINT(BgL_sfz00_15765)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13659))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15764, BgL_sz00_13659,
															BINT(BgL_spz00_15766));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15770;

														BgL_nsz00_15770 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2011z00_15771;

															BgL_arg2011z00_15771 =
																(BgL_spz00_15766 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15770, ((long) 2), BgL_sz00_13659,
																BINT(BgL_spz00_15766),
																BINT(BgL_arg2011z00_15771));
														}
														VECTOR_SET(BgL_nsz00_15770, ((long) 1),
															BgL_sz00_13659);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15769,
															BgL_nsz00_15770);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15772;

															BgL_ez00_15772 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15772, BgL_sz00_13659);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15773;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15774;

																	BgL_savedzd2bpzd2_15774 =
																		VECTOR_REF(BgL_nsz00_15770, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15770, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15776;

																		BgL_fz00_15776 = BgL_runz00_15764;
																	BgL_recz00_15775:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15777;

																			BgL_rz00_15777 =
																				PROCEDURE_ENTRY(BgL_fz00_15776)
																				(BgL_fz00_15776, BgL_nsz00_15770, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6256z00_20154;

																				if (PROCEDUREP(BgL_rz00_15777))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_15778;

																						BgL_arg1732z00_15778 =
																							PROCEDURE_ATTR(BgL_rz00_15777);
																						if (STRUCTP(BgL_arg1732z00_15778))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6256z00_20154 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_15778) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6256z00_20154 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6256z00_20154 =
																							((bool_t) 0);
																					}
																				if (BgL_test6256z00_20154)
																					{
																						obj_t BgL_fz00_20162;

																						BgL_fz00_20162 = BgL_rz00_15777;
																						BgL_fz00_15776 = BgL_fz00_20162;
																						goto BgL_recz00_15775;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15770,
																							((long) 0),
																							BgL_savedzd2bpzd2_15774);
																						BgL_____rz00_15773 = BgL_rz00_15777;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15772);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15769,
																	BgL_sz00_13659);
																return BgL_____rz00_15773;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15761,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15779;

												BgL_nbpz00_15779 =
													((long) CINT(BgL_bpz00_15760) + BgL_siza7eza7_13658);
												VECTOR_SET(
													((obj_t) BgL_sz00_13659), ((long) 0),
													BINT(BgL_nbpz00_15779));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_20174;

													BgL_tmpz00_20174 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20174,
														BgL_locz00_13656);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15780;

													BgL_rz00_15780 =
														PROCEDURE_ENTRY(BgL_fz00_15761) (BgL_fz00_15761,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13659), ((long) 0),
														BgL_bpz00_15760);
													return BgL_rz00_15780;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13656,
													BgL_symbzd2funzd2_13657, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15761));
		}}}}}}}}

	}



/* &<@anonymous:2017> */
	obj_t BGl_z62zc3z04anonymousza32017ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13660, obj_t BgL_sz00_13665)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13661;
				obj_t BgL_locz00_13662;
				obj_t BgL_symbzd2funzd2_13663;
				long BgL_siza7eza7_13664;

				BgL_funz00_13661 = PROCEDURE_REF(BgL_envz00_13660, (int) (((long) 0)));
				BgL_locz00_13662 = PROCEDURE_REF(BgL_envz00_13660, (int) (((long) 1)));
				BgL_symbzd2funzd2_13663 =
					PROCEDURE_REF(BgL_envz00_13660, (int) (((long) 2)));
				BgL_siza7eza7_13664 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13660, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15781;

					BgL_bpz00_15781 = VECTOR_REF(((obj_t) BgL_sz00_13665), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15782;

						BgL_fz00_15782 =
							PROCEDURE_ENTRY(BgL_funz00_13661) (BgL_funz00_13661,
							BgL_sz00_13665, BEOA);
						if (PROCEDUREP(BgL_fz00_15782))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13662,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15782);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15783;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20203;

								BgL_tmpz00_20203 = ((obj_t) BgL_fz00_15782);
								BgL_ufz00_15783 = PROCEDURE_ATTR(BgL_tmpz00_20203);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6261z00_20206;

								if (STRUCTP(BgL_ufz00_15783))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6261z00_20206 =
											(STRUCT_KEY(BgL_ufz00_15783) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6261z00_20206 = ((bool_t) 0);
									}
								if (BgL_test6261z00_20206)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15784;
										obj_t BgL_runz00_15785;
										obj_t BgL_sfz00_15786;

										BgL_arityz00_15784 =
											STRUCT_REF(BgL_ufz00_15783, (int) (((long) 0)));
										BgL_runz00_15785 =
											STRUCT_REF(BgL_ufz00_15783, (int) (((long) 1)));
										BgL_sfz00_15786 =
											STRUCT_REF(BgL_ufz00_15783, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15787;

											BgL_spz00_15787 =
												((long) CINT(BgL_bpz00_15781) + BgL_siza7eza7_13664);
											if (((long) CINT(BgL_arityz00_15784) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 896 */
													BUNSPEC;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15784))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15784))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2023z00_15788;
																		obj_t BgL_arg2024z00_15789;

																		BgL_arg2023z00_15788 =
																			(BgL_spz00_15787 + ((long) 0));
																		BgL_arg2024z00_15789 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13665),
																			BgL_arg2023z00_15788,
																			BgL_arg2024z00_15789);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13662,
																		STRUCT_REF(BgL_ufz00_15783,
																			(int) (((long) 3))), (int) (((long) 0)),
																		CINT(BgL_arityz00_15784));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13662, STRUCT_REF(BgL_ufz00_15783,
																	(int) (((long) 3))), (int) (((long) 0)),
																CINT(BgL_arityz00_15784));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15790;

												BgL_z12denvz12_15790 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15787 +
															(long) CINT(BgL_sfz00_15786)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13665))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15785, BgL_sz00_13665,
															BINT(BgL_spz00_15787));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15791;

														BgL_nsz00_15791 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2028z00_15792;

															BgL_arg2028z00_15792 =
																(BgL_spz00_15787 + ((long) 0));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15791, ((long) 2), BgL_sz00_13665,
																BINT(BgL_spz00_15787),
																BINT(BgL_arg2028z00_15792));
														}
														VECTOR_SET(BgL_nsz00_15791, ((long) 1),
															BgL_sz00_13665);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15790,
															BgL_nsz00_15791);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15793;

															BgL_ez00_15793 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15793, BgL_sz00_13665);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15794;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15795;

																	BgL_savedzd2bpzd2_15795 =
																		VECTOR_REF(BgL_nsz00_15791, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15791, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15797;

																		BgL_fz00_15797 = BgL_runz00_15785;
																	BgL_recz00_15796:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15798;

																			BgL_rz00_15798 =
																				PROCEDURE_ENTRY(BgL_fz00_15797)
																				(BgL_fz00_15797, BgL_nsz00_15791, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6266z00_20264;

																				if (PROCEDUREP(BgL_rz00_15798))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_15799;

																						BgL_arg1732z00_15799 =
																							PROCEDURE_ATTR(BgL_rz00_15798);
																						if (STRUCTP(BgL_arg1732z00_15799))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6266z00_20264 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_15799) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6266z00_20264 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6266z00_20264 =
																							((bool_t) 0);
																					}
																				if (BgL_test6266z00_20264)
																					{
																						obj_t BgL_fz00_20272;

																						BgL_fz00_20272 = BgL_rz00_15798;
																						BgL_fz00_15797 = BgL_fz00_20272;
																						goto BgL_recz00_15796;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15791,
																							((long) 0),
																							BgL_savedzd2bpzd2_15795);
																						BgL_____rz00_15794 = BgL_rz00_15798;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15793);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15790,
																	BgL_sz00_13665);
																return BgL_____rz00_15794;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15782,
												(int) (((long) 0))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15800;

												BgL_nbpz00_15800 =
													((long) CINT(BgL_bpz00_15781) + BgL_siza7eza7_13664);
												VECTOR_SET(
													((obj_t) BgL_sz00_13665), ((long) 0),
													BINT(BgL_nbpz00_15800));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15801;

													BgL_rz00_15801 =
														PROCEDURE_ENTRY(BgL_fz00_15782) (BgL_fz00_15782,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13665), ((long) 0),
														BgL_bpz00_15781);
													return BgL_rz00_15801;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13662,
													BgL_symbzd2funzd2_13663, (int) (((long) 0)),
													PROCEDURE_ARITY(BgL_fz00_15782));
		}}}}}}}}

	}



/* comp-call1 */
	obj_t BGl_compzd2call1zd2zz__evaluate_compz00(obj_t BgL_locz00_145,
		BgL_ev_exprz00_bglt BgL_vfunz00_146, obj_t BgL_symbzd2funzd2_147,
		obj_t BgL_funz00_148, obj_t BgL_tailzf3zf3_149, obj_t BgL_stkz00_150,
		long BgL_siza7eza7_151, obj_t BgL_a1z00_152)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2119;

				BgL_cfunz00_2119 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_146,
					((long) 1), BgL_locz00_145, BgL_symbzd2funzd2_147);
				if (CBOOL(BgL_cfunz00_2119))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6271z00_20295;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2039z00_2135;

							BgL_arg2039z00_2135 = bgl_debug();
							BgL_test6271z00_20295 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2039z00_2135),
								BINT(((long) 0)));
						}
						if (BgL_test6271z00_20295)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32035ze3z87_13666;

								BgL_zc3z04anonymousza32035ze3z87_13666 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32035ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32035ze3z87_13666,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3z04anonymousza32035ze3z87_13666,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3z04anonymousza32035ze3z87_13666,
									(int) (((long) 2)), BgL_locz00_145);
								PROCEDURE_SET(BgL_zc3z04anonymousza32035ze3z87_13666,
									(int) (((long) 3)), BgL_cfunz00_2119);
								return BgL_zc3z04anonymousza32035ze3z87_13666;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32037ze3z87_13667;

								BgL_zc3z04anonymousza32037ze3z87_13667 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32037ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32037ze3z87_13667,
									(int) (((long) 0)), BgL_a1z00_152);
								PROCEDURE_SET(BgL_zc3z04anonymousza32037ze3z87_13667,
									(int) (((long) 1)), BINT(BgL_siza7eza7_151));
								PROCEDURE_SET(BgL_zc3z04anonymousza32037ze3z87_13667,
									(int) (((long) 2)), BgL_cfunz00_2119);
								return BgL_zc3z04anonymousza32037ze3z87_13667;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_149))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6273z00_20324;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2082z00_2211;

									BgL_arg2082z00_2211 = bgl_debug();
									BgL_test6273z00_20324 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2082z00_2211),
										BINT(((long) 0)));
								}
								if (BgL_test6273z00_20324)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32042ze3z87_13668;

										BgL_zc3z04anonymousza32042ze3z87_13668 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32042ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32042ze3z87_13668,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32042ze3z87_13668,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32042ze3z87_13668,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32042ze3z87_13668,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32042ze3z87_13668,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32042ze3z87_13668;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32063ze3z87_13669;

										BgL_zc3z04anonymousza32063ze3z87_13669 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32063ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32063ze3z87_13669,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32063ze3z87_13669,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32063ze3z87_13669,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32063ze3z87_13669,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32063ze3z87_13669,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32063ze3z87_13669;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6274z00_20357;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2123z00_2287;

									BgL_arg2123z00_2287 = bgl_debug();
									BgL_test6274z00_20357 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2123z00_2287),
										BINT(((long) 0)));
								}
								if (BgL_test6274z00_20357)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32085ze3z87_13670;

										BgL_zc3z04anonymousza32085ze3z87_13670 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32085ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32085ze3z87_13670,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32085ze3z87_13670,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32085ze3z87_13670,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32085ze3z87_13670,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32085ze3z87_13670,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32085ze3z87_13670;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32104ze3z87_13671;

										BgL_zc3z04anonymousza32104ze3z87_13671 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32104ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 5)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32104ze3z87_13671,
											(int) (((long) 0)), BgL_funz00_148);
										PROCEDURE_SET(BgL_zc3z04anonymousza32104ze3z87_13671,
											(int) (((long) 1)), BgL_a1z00_152);
										PROCEDURE_SET(BgL_zc3z04anonymousza32104ze3z87_13671,
											(int) (((long) 2)), BgL_locz00_145);
										PROCEDURE_SET(BgL_zc3z04anonymousza32104ze3z87_13671,
											(int) (((long) 3)), BgL_symbzd2funzd2_147);
										PROCEDURE_SET(BgL_zc3z04anonymousza32104ze3z87_13671,
											(int) (((long) 4)), BINT(BgL_siza7eza7_151));
										return BgL_zc3z04anonymousza32104ze3z87_13671;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2035> */
	obj_t BGl_z62zc3z04anonymousza32035ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13672, obj_t BgL_sz00_13677)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13673;
				long BgL_siza7eza7_13674;
				obj_t BgL_locz00_13675;
				obj_t BgL_cfunz00_13676;

				BgL_a1z00_13673 = PROCEDURE_REF(BgL_envz00_13672, (int) (((long) 0)));
				BgL_siza7eza7_13674 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13672, (int) (((long) 1))));
				BgL_locz00_13675 = PROCEDURE_REF(BgL_envz00_13672, (int) (((long) 2)));
				BgL_cfunz00_13676 = PROCEDURE_REF(BgL_envz00_13672, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15802;

					BgL_bpz00_15802 = VECTOR_REF(((obj_t) BgL_sz00_13677), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_15803;

						BgL_a1z00_15803 =
							PROCEDURE_ENTRY(BgL_a1z00_13673) (BgL_a1z00_13673, BgL_sz00_13677,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15804;

							BgL_nbpz00_15804 =
								((long) CINT(BgL_bpz00_15802) + BgL_siza7eza7_13674);
							VECTOR_SET(
								((obj_t) BgL_sz00_13677), ((long) 0), BINT(BgL_nbpz00_15804));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20410;

								BgL_tmpz00_20410 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20410, BgL_locz00_13675);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15805;

								BgL_rz00_15805 =
									PROCEDURE_ENTRY(BgL_cfunz00_13676) (BgL_cfunz00_13676,
									BgL_a1z00_15803, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13677), ((long) 0),
									BgL_bpz00_15802);
								return BgL_rz00_15805;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2037> */
	obj_t BGl_z62zc3z04anonymousza32037ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13678, obj_t BgL_sz00_13682)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13679;
				long BgL_siza7eza7_13680;
				obj_t BgL_cfunz00_13681;

				BgL_a1z00_13679 = PROCEDURE_REF(BgL_envz00_13678, (int) (((long) 0)));
				BgL_siza7eza7_13680 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13678, (int) (((long) 1))));
				BgL_cfunz00_13681 = PROCEDURE_REF(BgL_envz00_13678, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15806;

					BgL_bpz00_15806 = VECTOR_REF(((obj_t) BgL_sz00_13682), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_15807;

						BgL_a1z00_15807 =
							PROCEDURE_ENTRY(BgL_a1z00_13679) (BgL_a1z00_13679, BgL_sz00_13682,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15808;

							BgL_nbpz00_15808 =
								((long) CINT(BgL_bpz00_15806) + BgL_siza7eza7_13680);
							VECTOR_SET(
								((obj_t) BgL_sz00_13682), ((long) 0), BINT(BgL_nbpz00_15808));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15809;

								BgL_rz00_15809 =
									PROCEDURE_ENTRY(BgL_cfunz00_13681) (BgL_cfunz00_13681,
									BgL_a1z00_15807, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13682), ((long) 0),
									BgL_bpz00_15806);
								return BgL_rz00_15809;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2042> */
	obj_t BGl_z62zc3z04anonymousza32042ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13683, obj_t BgL_sz00_13689)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13684;
				obj_t BgL_a1z00_13685;
				obj_t BgL_locz00_13686;
				obj_t BgL_symbzd2funzd2_13687;
				long BgL_siza7eza7_13688;

				BgL_funz00_13684 = PROCEDURE_REF(BgL_envz00_13683, (int) (((long) 0)));
				BgL_a1z00_13685 = PROCEDURE_REF(BgL_envz00_13683, (int) (((long) 1)));
				BgL_locz00_13686 = PROCEDURE_REF(BgL_envz00_13683, (int) (((long) 2)));
				BgL_symbzd2funzd2_13687 =
					PROCEDURE_REF(BgL_envz00_13683, (int) (((long) 3)));
				BgL_siza7eza7_13688 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13683, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15810;

					BgL_bpz00_15810 = VECTOR_REF(((obj_t) BgL_sz00_13689), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15811;
						obj_t BgL_a1z00_15812;

						BgL_fz00_15811 =
							PROCEDURE_ENTRY(BgL_funz00_13684) (BgL_funz00_13684,
							BgL_sz00_13689, BEOA);
						BgL_a1z00_15812 =
							PROCEDURE_ENTRY(BgL_a1z00_13685) (BgL_a1z00_13685, BgL_sz00_13689,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15811))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13686,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15811);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15813;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20467;

								BgL_tmpz00_20467 = ((obj_t) BgL_fz00_15811);
								BgL_ufz00_15813 = PROCEDURE_ATTR(BgL_tmpz00_20467);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6276z00_20470;

								if (STRUCTP(BgL_ufz00_15813))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6276z00_20470 =
											(STRUCT_KEY(BgL_ufz00_15813) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6276z00_20470 = ((bool_t) 0);
									}
								if (BgL_test6276z00_20470)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15814;
										obj_t BgL_runz00_15815;
										obj_t BgL_sfz00_15816;

										BgL_arityz00_15814 =
											STRUCT_REF(BgL_ufz00_15813, (int) (((long) 0)));
										BgL_runz00_15815 =
											STRUCT_REF(BgL_ufz00_15813, (int) (((long) 1)));
										BgL_sfz00_15816 =
											STRUCT_REF(BgL_ufz00_15813, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15814) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_arg2046z00_15817;

												BgL_arg2046z00_15817 =
													((long) CINT(BgL_bpz00_15810) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_13689), BgL_arg2046z00_15817,
													BgL_a1z00_15812);
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15814))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15814))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2048z00_15818;
																	obj_t BgL_arg2049z00_15819;

																	BgL_arg2048z00_15818 =
																		((long) CINT(BgL_bpz00_15810) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2050z00_15820;

																		BgL_list2050z00_15820 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_15812, BNIL);
																		BgL_arg2049z00_15819 =
																			BgL_list2050z00_15820;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13689),
																		BgL_arg2048z00_15818, BgL_arg2049z00_15819);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2051z00_15821;

																	BgL_arg2051z00_15821 =
																		((long) CINT(BgL_bpz00_15810) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13689),
																		BgL_arg2051z00_15821, BgL_a1z00_15812);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2052z00_15822;
																	obj_t BgL_arg2053z00_15823;

																	BgL_arg2052z00_15822 =
																		((long) CINT(BgL_bpz00_15810) + ((long) 1));
																	BgL_arg2053z00_15823 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13689),
																		BgL_arg2052z00_15822, BgL_arg2053z00_15823);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13686, STRUCT_REF(BgL_ufz00_15813,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_15814));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13686, STRUCT_REF(BgL_ufz00_15813,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_15814));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15824;

											BgL_z12denvz12_15824 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15824,
												BgL_locz00_13686);
											if ((((long) CINT(BgL_bpz00_15810) +
														(long) CINT(BgL_sfz00_15816)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13689))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15815;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15825;

													BgL_nsz00_15825 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2058z00_15826;

														BgL_arg2058z00_15826 =
															((long) CINT(BgL_bpz00_15810) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15825, ((long) 2), BgL_sz00_13689,
															BgL_bpz00_15810, BINT(BgL_arg2058z00_15826));
													}
													VECTOR_SET(BgL_nsz00_15825, ((long) 1),
														BgL_sz00_13689);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15824,
														BgL_nsz00_15825);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15827;

														BgL_ez00_15827 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15827, BgL_sz00_13689);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15828;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15829;

																BgL_savedzd2bpzd2_15829 =
																	VECTOR_REF(BgL_nsz00_15825, ((long) 0));
																VECTOR_SET(BgL_nsz00_15825, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15831;

																	BgL_fz00_15831 = BgL_runz00_15815;
																BgL_recz00_15830:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15832;

																		BgL_rz00_15832 =
																			PROCEDURE_ENTRY(BgL_fz00_15831)
																			(BgL_fz00_15831, BgL_nsz00_15825, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6281z00_20540;

																			if (PROCEDUREP(BgL_rz00_15832))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_15833;

																					BgL_arg1732z00_15833 =
																						PROCEDURE_ATTR(BgL_rz00_15832);
																					if (STRUCTP(BgL_arg1732z00_15833))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6281z00_20540 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_15833) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6281z00_20540 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6281z00_20540 = ((bool_t) 0);
																				}
																			if (BgL_test6281z00_20540)
																				{
																					obj_t BgL_fz00_20548;

																					BgL_fz00_20548 = BgL_rz00_15832;
																					BgL_fz00_15831 = BgL_fz00_20548;
																					goto BgL_recz00_15830;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15825,
																						((long) 0),
																						BgL_savedzd2bpzd2_15829);
																					BgL_____rz00_15828 = BgL_rz00_15832;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15827);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15824,
																BgL_sz00_13689);
															return BgL_____rz00_15828;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15811,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15834;

												BgL_nbpz00_15834 =
													((long) CINT(BgL_bpz00_15810) + BgL_siza7eza7_13688);
												VECTOR_SET(
													((obj_t) BgL_sz00_13689), ((long) 0),
													BINT(BgL_nbpz00_15834));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_20560;

													BgL_tmpz00_20560 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20560,
														BgL_locz00_13686);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15835;

													BgL_rz00_15835 =
														PROCEDURE_ENTRY(BgL_fz00_15811) (BgL_fz00_15811,
														BgL_a1z00_15812, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13689), ((long) 0),
														BgL_bpz00_15810);
													return BgL_rz00_15835;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13686,
													BgL_symbzd2funzd2_13687, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15811));
		}}}}}}}}

	}



/* &<@anonymous:2063> */
	obj_t BGl_z62zc3z04anonymousza32063ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13690, obj_t BgL_sz00_13696)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13691;
				obj_t BgL_a1z00_13692;
				obj_t BgL_locz00_13693;
				obj_t BgL_symbzd2funzd2_13694;
				long BgL_siza7eza7_13695;

				BgL_funz00_13691 = PROCEDURE_REF(BgL_envz00_13690, (int) (((long) 0)));
				BgL_a1z00_13692 = PROCEDURE_REF(BgL_envz00_13690, (int) (((long) 1)));
				BgL_locz00_13693 = PROCEDURE_REF(BgL_envz00_13690, (int) (((long) 2)));
				BgL_symbzd2funzd2_13694 =
					PROCEDURE_REF(BgL_envz00_13690, (int) (((long) 3)));
				BgL_siza7eza7_13695 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13690, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15836;

					BgL_bpz00_15836 = VECTOR_REF(((obj_t) BgL_sz00_13696), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15837;
						obj_t BgL_a1z00_15838;

						BgL_fz00_15837 =
							PROCEDURE_ENTRY(BgL_funz00_13691) (BgL_funz00_13691,
							BgL_sz00_13696, BEOA);
						BgL_a1z00_15838 =
							PROCEDURE_ENTRY(BgL_a1z00_13692) (BgL_a1z00_13692, BgL_sz00_13696,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15837))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13693,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15837);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15839;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20596;

								BgL_tmpz00_20596 = ((obj_t) BgL_fz00_15837);
								BgL_ufz00_15839 = PROCEDURE_ATTR(BgL_tmpz00_20596);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6286z00_20599;

								if (STRUCTP(BgL_ufz00_15839))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6286z00_20599 =
											(STRUCT_KEY(BgL_ufz00_15839) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6286z00_20599 = ((bool_t) 0);
									}
								if (BgL_test6286z00_20599)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15840;
										obj_t BgL_runz00_15841;
										obj_t BgL_sfz00_15842;

										BgL_arityz00_15840 =
											STRUCT_REF(BgL_ufz00_15839, (int) (((long) 0)));
										BgL_runz00_15841 =
											STRUCT_REF(BgL_ufz00_15839, (int) (((long) 1)));
										BgL_sfz00_15842 =
											STRUCT_REF(BgL_ufz00_15839, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15840) == ((long) 1)))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_arg2067z00_15843;

												BgL_arg2067z00_15843 =
													((long) CINT(BgL_bpz00_15836) + ((long) 0));
												VECTOR_SET(
													((obj_t) BgL_sz00_13696), BgL_arg2067z00_15843,
													BgL_a1z00_15838);
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15840))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15840))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2069z00_15844;
																	obj_t BgL_arg2070z00_15845;

																	BgL_arg2069z00_15844 =
																		((long) CINT(BgL_bpz00_15836) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2071z00_15846;

																		BgL_list2071z00_15846 =
																			MAKE_YOUNG_PAIR(BgL_a1z00_15838, BNIL);
																		BgL_arg2070z00_15845 =
																			BgL_list2071z00_15846;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13696),
																		BgL_arg2069z00_15844, BgL_arg2070z00_15845);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2072z00_15847;

																	BgL_arg2072z00_15847 =
																		((long) CINT(BgL_bpz00_15836) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13696),
																		BgL_arg2072z00_15847, BgL_a1z00_15838);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2073z00_15848;
																	obj_t BgL_arg2074z00_15849;

																	BgL_arg2073z00_15848 =
																		((long) CINT(BgL_bpz00_15836) + ((long) 1));
																	BgL_arg2074z00_15849 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13696),
																		BgL_arg2073z00_15848, BgL_arg2074z00_15849);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13693, STRUCT_REF(BgL_ufz00_15839,
																		(int) (((long) 3))), (int) (((long) 1)),
																	CINT(BgL_arityz00_15840));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13693, STRUCT_REF(BgL_ufz00_15839,
																(int) (((long) 3))), (int) (((long) 1)),
															CINT(BgL_arityz00_15840));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15850;

											BgL_z12denvz12_15850 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15836) +
														(long) CINT(BgL_sfz00_15842)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13696))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15841;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15851;

													BgL_nsz00_15851 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2079z00_15852;

														BgL_arg2079z00_15852 =
															((long) CINT(BgL_bpz00_15836) + ((long) 1));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15851, ((long) 2), BgL_sz00_13696,
															BgL_bpz00_15836, BINT(BgL_arg2079z00_15852));
													}
													VECTOR_SET(BgL_nsz00_15851, ((long) 1),
														BgL_sz00_13696);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15850,
														BgL_nsz00_15851);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15853;

														BgL_ez00_15853 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15853, BgL_sz00_13696);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15854;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15855;

																BgL_savedzd2bpzd2_15855 =
																	VECTOR_REF(BgL_nsz00_15851, ((long) 0));
																VECTOR_SET(BgL_nsz00_15851, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15857;

																	BgL_fz00_15857 = BgL_runz00_15841;
																BgL_recz00_15856:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15858;

																		BgL_rz00_15858 =
																			PROCEDURE_ENTRY(BgL_fz00_15857)
																			(BgL_fz00_15857, BgL_nsz00_15851, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6291z00_20668;

																			if (PROCEDUREP(BgL_rz00_15858))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_15859;

																					BgL_arg1732z00_15859 =
																						PROCEDURE_ATTR(BgL_rz00_15858);
																					if (STRUCTP(BgL_arg1732z00_15859))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6291z00_20668 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_15859) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6291z00_20668 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6291z00_20668 = ((bool_t) 0);
																				}
																			if (BgL_test6291z00_20668)
																				{
																					obj_t BgL_fz00_20676;

																					BgL_fz00_20676 = BgL_rz00_15858;
																					BgL_fz00_15857 = BgL_fz00_20676;
																					goto BgL_recz00_15856;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15851,
																						((long) 0),
																						BgL_savedzd2bpzd2_15855);
																					BgL_____rz00_15854 = BgL_rz00_15858;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15853);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15850,
																BgL_sz00_13696);
															return BgL_____rz00_15854;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15837,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15860;

												BgL_nbpz00_15860 =
													((long) CINT(BgL_bpz00_15836) + BgL_siza7eza7_13695);
												VECTOR_SET(
													((obj_t) BgL_sz00_13696), ((long) 0),
													BINT(BgL_nbpz00_15860));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15861;

													BgL_rz00_15861 =
														PROCEDURE_ENTRY(BgL_fz00_15837) (BgL_fz00_15837,
														BgL_a1z00_15838, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13696), ((long) 0),
														BgL_bpz00_15836);
													return BgL_rz00_15861;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13693,
													BgL_symbzd2funzd2_13694, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15837));
		}}}}}}}}

	}



/* &<@anonymous:2085> */
	obj_t BGl_z62zc3z04anonymousza32085ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13697, obj_t BgL_sz00_13703)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13698;
				obj_t BgL_a1z00_13699;
				obj_t BgL_locz00_13700;
				obj_t BgL_symbzd2funzd2_13701;
				long BgL_siza7eza7_13702;

				BgL_funz00_13698 = PROCEDURE_REF(BgL_envz00_13697, (int) (((long) 0)));
				BgL_a1z00_13699 = PROCEDURE_REF(BgL_envz00_13697, (int) (((long) 1)));
				BgL_locz00_13700 = PROCEDURE_REF(BgL_envz00_13697, (int) (((long) 2)));
				BgL_symbzd2funzd2_13701 =
					PROCEDURE_REF(BgL_envz00_13697, (int) (((long) 3)));
				BgL_siza7eza7_13702 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13697, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15862;

					BgL_bpz00_15862 = VECTOR_REF(((obj_t) BgL_sz00_13703), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15863;
						obj_t BgL_a1z00_15864;

						BgL_fz00_15863 =
							PROCEDURE_ENTRY(BgL_funz00_13698) (BgL_funz00_13698,
							BgL_sz00_13703, BEOA);
						BgL_a1z00_15864 =
							PROCEDURE_ENTRY(BgL_a1z00_13699) (BgL_a1z00_13699, BgL_sz00_13703,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15863))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13700,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15863);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15865;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20721;

								BgL_tmpz00_20721 = ((obj_t) BgL_fz00_15863);
								BgL_ufz00_15865 = PROCEDURE_ATTR(BgL_tmpz00_20721);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6296z00_20724;

								if (STRUCTP(BgL_ufz00_15865))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6296z00_20724 =
											(STRUCT_KEY(BgL_ufz00_15865) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6296z00_20724 = ((bool_t) 0);
									}
								if (BgL_test6296z00_20724)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15866;
										obj_t BgL_runz00_15867;
										obj_t BgL_sfz00_15868;

										BgL_arityz00_15866 =
											STRUCT_REF(BgL_ufz00_15865, (int) (((long) 0)));
										BgL_runz00_15867 =
											STRUCT_REF(BgL_ufz00_15865, (int) (((long) 1)));
										BgL_sfz00_15868 =
											STRUCT_REF(BgL_ufz00_15865, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15869;

											BgL_spz00_15869 =
												((long) CINT(BgL_bpz00_15862) + BgL_siza7eza7_13702);
											if (((long) CINT(BgL_arityz00_15866) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2089z00_15870;

													BgL_arg2089z00_15870 = (BgL_spz00_15869 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13703), BgL_arg2089z00_15870,
														BgL_a1z00_15864);
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15866))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15866))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2091z00_15871;
																		obj_t BgL_arg2092z00_15872;

																		BgL_arg2091z00_15871 =
																			(BgL_spz00_15869 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2093z00_15873;

																			BgL_list2093z00_15873 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15864, BNIL);
																			BgL_arg2092z00_15872 =
																				BgL_list2093z00_15873;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13703),
																			BgL_arg2091z00_15871,
																			BgL_arg2092z00_15872);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2094z00_15874;

																		BgL_arg2094z00_15874 =
																			(BgL_spz00_15869 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13703),
																			BgL_arg2094z00_15874, BgL_a1z00_15864);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2095z00_15875;
																		obj_t BgL_arg2096z00_15876;

																		BgL_arg2095z00_15875 =
																			(BgL_spz00_15869 + ((long) 1));
																		BgL_arg2096z00_15876 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13703),
																			BgL_arg2095z00_15875,
																			BgL_arg2096z00_15876);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13700,
																		STRUCT_REF(BgL_ufz00_15865,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_15866));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13700, STRUCT_REF(BgL_ufz00_15865,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_15866));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15877;

												BgL_z12denvz12_15877 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15877,
													BgL_locz00_13700);
												if (((BgL_spz00_15869 + (long) CINT(BgL_sfz00_15868)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13703))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15867, BgL_sz00_13703,
															BINT(BgL_spz00_15869));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15878;

														BgL_nsz00_15878 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2100z00_15879;

															BgL_arg2100z00_15879 =
																(BgL_spz00_15869 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15878, ((long) 2), BgL_sz00_13703,
																BINT(BgL_spz00_15869),
																BINT(BgL_arg2100z00_15879));
														}
														VECTOR_SET(BgL_nsz00_15878, ((long) 1),
															BgL_sz00_13703);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15877,
															BgL_nsz00_15878);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15880;

															BgL_ez00_15880 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15880, BgL_sz00_13703);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15881;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15882;

																	BgL_savedzd2bpzd2_15882 =
																		VECTOR_REF(BgL_nsz00_15878, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15878, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15884;

																		BgL_fz00_15884 = BgL_runz00_15867;
																	BgL_recz00_15883:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15885;

																			BgL_rz00_15885 =
																				PROCEDURE_ENTRY(BgL_fz00_15884)
																				(BgL_fz00_15884, BgL_nsz00_15878, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6301z00_20793;

																				if (PROCEDUREP(BgL_rz00_15885))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_15886;

																						BgL_arg1732z00_15886 =
																							PROCEDURE_ATTR(BgL_rz00_15885);
																						if (STRUCTP(BgL_arg1732z00_15886))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6301z00_20793 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_15886) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6301z00_20793 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6301z00_20793 =
																							((bool_t) 0);
																					}
																				if (BgL_test6301z00_20793)
																					{
																						obj_t BgL_fz00_20801;

																						BgL_fz00_20801 = BgL_rz00_15885;
																						BgL_fz00_15884 = BgL_fz00_20801;
																						goto BgL_recz00_15883;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15878,
																							((long) 0),
																							BgL_savedzd2bpzd2_15882);
																						BgL_____rz00_15881 = BgL_rz00_15885;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15880);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15877,
																	BgL_sz00_13703);
																return BgL_____rz00_15881;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15863,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15887;

												BgL_nbpz00_15887 =
													((long) CINT(BgL_bpz00_15862) + BgL_siza7eza7_13702);
												VECTOR_SET(
													((obj_t) BgL_sz00_13703), ((long) 0),
													BINT(BgL_nbpz00_15887));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_20813;

													BgL_tmpz00_20813 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_20813,
														BgL_locz00_13700);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15888;

													BgL_rz00_15888 =
														PROCEDURE_ENTRY(BgL_fz00_15863) (BgL_fz00_15863,
														BgL_a1z00_15864, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13703), ((long) 0),
														BgL_bpz00_15862);
													return BgL_rz00_15888;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13700,
													BgL_symbzd2funzd2_13701, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15863));
		}}}}}}}}

	}



/* &<@anonymous:2104> */
	obj_t BGl_z62zc3z04anonymousza32104ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13704, obj_t BgL_sz00_13710)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13705;
				obj_t BgL_a1z00_13706;
				obj_t BgL_locz00_13707;
				obj_t BgL_symbzd2funzd2_13708;
				long BgL_siza7eza7_13709;

				BgL_funz00_13705 = PROCEDURE_REF(BgL_envz00_13704, (int) (((long) 0)));
				BgL_a1z00_13706 = PROCEDURE_REF(BgL_envz00_13704, (int) (((long) 1)));
				BgL_locz00_13707 = PROCEDURE_REF(BgL_envz00_13704, (int) (((long) 2)));
				BgL_symbzd2funzd2_13708 =
					PROCEDURE_REF(BgL_envz00_13704, (int) (((long) 3)));
				BgL_siza7eza7_13709 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13704, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15889;

					BgL_bpz00_15889 = VECTOR_REF(((obj_t) BgL_sz00_13710), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15890;
						obj_t BgL_a1z00_15891;

						BgL_fz00_15890 =
							PROCEDURE_ENTRY(BgL_funz00_13705) (BgL_funz00_13705,
							BgL_sz00_13710, BEOA);
						BgL_a1z00_15891 =
							PROCEDURE_ENTRY(BgL_a1z00_13706) (BgL_a1z00_13706, BgL_sz00_13710,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15890))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13707,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15890);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15892;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_20849;

								BgL_tmpz00_20849 = ((obj_t) BgL_fz00_15890);
								BgL_ufz00_15892 = PROCEDURE_ATTR(BgL_tmpz00_20849);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6306z00_20852;

								if (STRUCTP(BgL_ufz00_15892))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6306z00_20852 =
											(STRUCT_KEY(BgL_ufz00_15892) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6306z00_20852 = ((bool_t) 0);
									}
								if (BgL_test6306z00_20852)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15893;
										obj_t BgL_runz00_15894;
										obj_t BgL_sfz00_15895;

										BgL_arityz00_15893 =
											STRUCT_REF(BgL_ufz00_15892, (int) (((long) 0)));
										BgL_runz00_15894 =
											STRUCT_REF(BgL_ufz00_15892, (int) (((long) 1)));
										BgL_sfz00_15895 =
											STRUCT_REF(BgL_ufz00_15892, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_15896;

											BgL_spz00_15896 =
												((long) CINT(BgL_bpz00_15889) + BgL_siza7eza7_13709);
											if (((long) CINT(BgL_arityz00_15893) == ((long) 1)))
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2108z00_15897;

													BgL_arg2108z00_15897 = (BgL_spz00_15896 + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13710), BgL_arg2108z00_15897,
														BgL_a1z00_15891);
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15893))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15893))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2110z00_15898;
																		obj_t BgL_arg2111z00_15899;

																		BgL_arg2110z00_15898 =
																			(BgL_spz00_15896 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2112z00_15900;

																			BgL_list2112z00_15900 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15891, BNIL);
																			BgL_arg2111z00_15899 =
																				BgL_list2112z00_15900;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13710),
																			BgL_arg2110z00_15898,
																			BgL_arg2111z00_15899);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2113z00_15901;

																		BgL_arg2113z00_15901 =
																			(BgL_spz00_15896 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13710),
																			BgL_arg2113z00_15901, BgL_a1z00_15891);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2114z00_15902;
																		obj_t BgL_arg2115z00_15903;

																		BgL_arg2114z00_15902 =
																			(BgL_spz00_15896 + ((long) 1));
																		BgL_arg2115z00_15903 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13710),
																			BgL_arg2114z00_15902,
																			BgL_arg2115z00_15903);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13707,
																		STRUCT_REF(BgL_ufz00_15892,
																			(int) (((long) 3))), (int) (((long) 1)),
																		CINT(BgL_arityz00_15893));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13707, STRUCT_REF(BgL_ufz00_15892,
																	(int) (((long) 3))), (int) (((long) 1)),
																CINT(BgL_arityz00_15893));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_15904;

												BgL_z12denvz12_15904 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_15896 +
															(long) CINT(BgL_sfz00_15895)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13710))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_15894, BgL_sz00_13710,
															BINT(BgL_spz00_15896));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_15905;

														BgL_nsz00_15905 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2119z00_15906;

															BgL_arg2119z00_15906 =
																(BgL_spz00_15896 + ((long) 1));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_15905, ((long) 2), BgL_sz00_13710,
																BINT(BgL_spz00_15896),
																BINT(BgL_arg2119z00_15906));
														}
														VECTOR_SET(BgL_nsz00_15905, ((long) 1),
															BgL_sz00_13710);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15904,
															BgL_nsz00_15905);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_15907;

															BgL_ez00_15907 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_15907, BgL_sz00_13710);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_15908;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_15909;

																	BgL_savedzd2bpzd2_15909 =
																		VECTOR_REF(BgL_nsz00_15905, ((long) 0));
																	VECTOR_SET(BgL_nsz00_15905, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_15911;

																		BgL_fz00_15911 = BgL_runz00_15894;
																	BgL_recz00_15910:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_15912;

																			BgL_rz00_15912 =
																				PROCEDURE_ENTRY(BgL_fz00_15911)
																				(BgL_fz00_15911, BgL_nsz00_15905, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6311z00_20920;

																				if (PROCEDUREP(BgL_rz00_15912))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_15913;

																						BgL_arg1732z00_15913 =
																							PROCEDURE_ATTR(BgL_rz00_15912);
																						if (STRUCTP(BgL_arg1732z00_15913))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6311z00_20920 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_15913) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6311z00_20920 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6311z00_20920 =
																							((bool_t) 0);
																					}
																				if (BgL_test6311z00_20920)
																					{
																						obj_t BgL_fz00_20928;

																						BgL_fz00_20928 = BgL_rz00_15912;
																						BgL_fz00_15911 = BgL_fz00_20928;
																						goto BgL_recz00_15910;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_15905,
																							((long) 0),
																							BgL_savedzd2bpzd2_15909);
																						BgL_____rz00_15908 = BgL_rz00_15912;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_15907);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15904,
																	BgL_sz00_13710);
																return BgL_____rz00_15908;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15890,
												(int) (((long) 1))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15914;

												BgL_nbpz00_15914 =
													((long) CINT(BgL_bpz00_15889) + BgL_siza7eza7_13709);
												VECTOR_SET(
													((obj_t) BgL_sz00_13710), ((long) 0),
													BINT(BgL_nbpz00_15914));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15915;

													BgL_rz00_15915 =
														PROCEDURE_ENTRY(BgL_fz00_15890) (BgL_fz00_15890,
														BgL_a1z00_15891, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13710), ((long) 0),
														BgL_bpz00_15889);
													return BgL_rz00_15915;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13707,
													BgL_symbzd2funzd2_13708, (int) (((long) 1)),
													PROCEDURE_ARITY(BgL_fz00_15890));
		}}}}}}}}

	}



/* comp-call2 */
	obj_t BGl_compzd2call2zd2zz__evaluate_compz00(obj_t BgL_locz00_153,
		BgL_ev_exprz00_bglt BgL_vfunz00_154, obj_t BgL_symbzd2funzd2_155,
		obj_t BgL_funz00_156, obj_t BgL_tailzf3zf3_157, obj_t BgL_stkz00_158,
		long BgL_siza7eza7_159, obj_t BgL_a1z00_160, obj_t BgL_a2z00_161)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2288;

				BgL_cfunz00_2288 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_154,
					((long) 2), BgL_locz00_153, BgL_symbzd2funzd2_155);
				if (CBOOL(BgL_cfunz00_2288))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6316z00_20952;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2129z00_2306;

							BgL_arg2129z00_2306 = bgl_debug();
							BgL_test6316z00_20952 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2129z00_2306),
								BINT(((long) 0)));
						}
						if (BgL_test6316z00_20952)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32126ze3z87_13711;

								BgL_zc3z04anonymousza32126ze3z87_13711 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32126ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32126ze3z87_13711,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3z04anonymousza32126ze3z87_13711,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3z04anonymousza32126ze3z87_13711,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3z04anonymousza32126ze3z87_13711,
									(int) (((long) 3)), BgL_locz00_153);
								PROCEDURE_SET(BgL_zc3z04anonymousza32126ze3z87_13711,
									(int) (((long) 4)), BgL_cfunz00_2288);
								return BgL_zc3z04anonymousza32126ze3z87_13711;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32128ze3z87_13712;

								BgL_zc3z04anonymousza32128ze3z87_13712 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32128ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32128ze3z87_13712,
									(int) (((long) 0)), BgL_a1z00_160);
								PROCEDURE_SET(BgL_zc3z04anonymousza32128ze3z87_13712,
									(int) (((long) 1)), BgL_a2z00_161);
								PROCEDURE_SET(BgL_zc3z04anonymousza32128ze3z87_13712,
									(int) (((long) 2)), BINT(BgL_siza7eza7_159));
								PROCEDURE_SET(BgL_zc3z04anonymousza32128ze3z87_13712,
									(int) (((long) 3)), BgL_cfunz00_2288);
								return BgL_zc3z04anonymousza32128ze3z87_13712;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_157))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6318z00_20985;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2186z00_2398;

									BgL_arg2186z00_2398 = bgl_debug();
									BgL_test6318z00_20985 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2186z00_2398),
										BINT(((long) 0)));
								}
								if (BgL_test6318z00_20985)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32132ze3z87_13713;

										BgL_zc3z04anonymousza32132ze3z87_13713 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32132ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32132ze3z87_13713,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32132ze3z87_13713,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32132ze3z87_13713,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32132ze3z87_13713,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32132ze3z87_13713,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32132ze3z87_13713,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32132ze3z87_13713;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32160ze3z87_13714;

										BgL_zc3z04anonymousza32160ze3z87_13714 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32160ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32160ze3z87_13714,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32160ze3z87_13714,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32160ze3z87_13714,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32160ze3z87_13714,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32160ze3z87_13714,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32160ze3z87_13714,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32160ze3z87_13714;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6319z00_21022;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2240z00_2490;

									BgL_arg2240z00_2490 = bgl_debug();
									BgL_test6319z00_21022 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2240z00_2490),
										BINT(((long) 0)));
								}
								if (BgL_test6319z00_21022)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32189ze3z87_13715;

										BgL_zc3z04anonymousza32189ze3z87_13715 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32189ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32189ze3z87_13715,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32189ze3z87_13715,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32189ze3z87_13715,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32189ze3z87_13715,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32189ze3z87_13715,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32189ze3z87_13715,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32189ze3z87_13715;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32215ze3z87_13716;

										BgL_zc3z04anonymousza32215ze3z87_13716 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32215ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 6)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32215ze3z87_13716,
											(int) (((long) 0)), BgL_funz00_156);
										PROCEDURE_SET(BgL_zc3z04anonymousza32215ze3z87_13716,
											(int) (((long) 1)), BgL_a1z00_160);
										PROCEDURE_SET(BgL_zc3z04anonymousza32215ze3z87_13716,
											(int) (((long) 2)), BgL_a2z00_161);
										PROCEDURE_SET(BgL_zc3z04anonymousza32215ze3z87_13716,
											(int) (((long) 3)), BgL_locz00_153);
										PROCEDURE_SET(BgL_zc3z04anonymousza32215ze3z87_13716,
											(int) (((long) 4)), BgL_symbzd2funzd2_155);
										PROCEDURE_SET(BgL_zc3z04anonymousza32215ze3z87_13716,
											(int) (((long) 5)), BINT(BgL_siza7eza7_159));
										return BgL_zc3z04anonymousza32215ze3z87_13716;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2126> */
	obj_t BGl_z62zc3z04anonymousza32126ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13717, obj_t BgL_sz00_13723)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13718;
				obj_t BgL_a2z00_13719;
				long BgL_siza7eza7_13720;
				obj_t BgL_locz00_13721;
				obj_t BgL_cfunz00_13722;

				BgL_a1z00_13718 = PROCEDURE_REF(BgL_envz00_13717, (int) (((long) 0)));
				BgL_a2z00_13719 = PROCEDURE_REF(BgL_envz00_13717, (int) (((long) 1)));
				BgL_siza7eza7_13720 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13717, (int) (((long) 2))));
				BgL_locz00_13721 = PROCEDURE_REF(BgL_envz00_13717, (int) (((long) 3)));
				BgL_cfunz00_13722 = PROCEDURE_REF(BgL_envz00_13717, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15916;

					BgL_bpz00_15916 = VECTOR_REF(((obj_t) BgL_sz00_13723), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_15917;
						obj_t BgL_a2z00_15918;

						BgL_a1z00_15917 =
							PROCEDURE_ENTRY(BgL_a1z00_13718) (BgL_a1z00_13718, BgL_sz00_13723,
							BEOA);
						BgL_a2z00_15918 =
							PROCEDURE_ENTRY(BgL_a2z00_13719) (BgL_a2z00_13719, BgL_sz00_13723,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15919;

							BgL_nbpz00_15919 =
								((long) CINT(BgL_bpz00_15916) + BgL_siza7eza7_13720);
							VECTOR_SET(
								((obj_t) BgL_sz00_13723), ((long) 0), BINT(BgL_nbpz00_15919));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21085;

								BgL_tmpz00_21085 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21085, BgL_locz00_13721);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15920;

								BgL_rz00_15920 =
									PROCEDURE_ENTRY(BgL_cfunz00_13722) (BgL_cfunz00_13722,
									BgL_a1z00_15917, BgL_a2z00_15918, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13723), ((long) 0),
									BgL_bpz00_15916);
								return BgL_rz00_15920;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2128> */
	obj_t BGl_z62zc3z04anonymousza32128ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13724, obj_t BgL_sz00_13729)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13725;
				obj_t BgL_a2z00_13726;
				long BgL_siza7eza7_13727;
				obj_t BgL_cfunz00_13728;

				BgL_a1z00_13725 = PROCEDURE_REF(BgL_envz00_13724, (int) (((long) 0)));
				BgL_a2z00_13726 = PROCEDURE_REF(BgL_envz00_13724, (int) (((long) 1)));
				BgL_siza7eza7_13727 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13724, (int) (((long) 2))));
				BgL_cfunz00_13728 = PROCEDURE_REF(BgL_envz00_13724, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15921;

					BgL_bpz00_15921 = VECTOR_REF(((obj_t) BgL_sz00_13729), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_15922;
						obj_t BgL_a2z00_15923;

						BgL_a1z00_15922 =
							PROCEDURE_ENTRY(BgL_a1z00_13725) (BgL_a1z00_13725, BgL_sz00_13729,
							BEOA);
						BgL_a2z00_15923 =
							PROCEDURE_ENTRY(BgL_a2z00_13726) (BgL_a2z00_13726, BgL_sz00_13729,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_15924;

							BgL_nbpz00_15924 =
								((long) CINT(BgL_bpz00_15921) + BgL_siza7eza7_13727);
							VECTOR_SET(
								((obj_t) BgL_sz00_13729), ((long) 0), BINT(BgL_nbpz00_15924));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_15925;

								BgL_rz00_15925 =
									PROCEDURE_ENTRY(BgL_cfunz00_13728) (BgL_cfunz00_13728,
									BgL_a1z00_15922, BgL_a2z00_15923, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13729), ((long) 0),
									BgL_bpz00_15921);
								return BgL_rz00_15925;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2132> */
	obj_t BGl_z62zc3z04anonymousza32132ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13730, obj_t BgL_sz00_13737)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13731;
				obj_t BgL_a1z00_13732;
				obj_t BgL_a2z00_13733;
				obj_t BgL_locz00_13734;
				obj_t BgL_symbzd2funzd2_13735;
				long BgL_siza7eza7_13736;

				BgL_funz00_13731 = PROCEDURE_REF(BgL_envz00_13730, (int) (((long) 0)));
				BgL_a1z00_13732 = PROCEDURE_REF(BgL_envz00_13730, (int) (((long) 1)));
				BgL_a2z00_13733 = PROCEDURE_REF(BgL_envz00_13730, (int) (((long) 2)));
				BgL_locz00_13734 = PROCEDURE_REF(BgL_envz00_13730, (int) (((long) 3)));
				BgL_symbzd2funzd2_13735 =
					PROCEDURE_REF(BgL_envz00_13730, (int) (((long) 4)));
				BgL_siza7eza7_13736 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13730, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15926;

					BgL_bpz00_15926 = VECTOR_REF(((obj_t) BgL_sz00_13737), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15927;
						obj_t BgL_a1z00_15928;
						obj_t BgL_a2z00_15929;

						BgL_fz00_15927 =
							PROCEDURE_ENTRY(BgL_funz00_13731) (BgL_funz00_13731,
							BgL_sz00_13737, BEOA);
						BgL_a1z00_15928 =
							PROCEDURE_ENTRY(BgL_a1z00_13732) (BgL_a1z00_13732, BgL_sz00_13737,
							BEOA);
						BgL_a2z00_15929 =
							PROCEDURE_ENTRY(BgL_a2z00_13733) (BgL_a2z00_13733, BgL_sz00_13737,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15927))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13734,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15927);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15930;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21156;

								BgL_tmpz00_21156 = ((obj_t) BgL_fz00_15927);
								BgL_ufz00_15930 = PROCEDURE_ATTR(BgL_tmpz00_21156);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6321z00_21159;

								if (STRUCTP(BgL_ufz00_15930))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6321z00_21159 =
											(STRUCT_KEY(BgL_ufz00_15930) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6321z00_21159 = ((bool_t) 0);
									}
								if (BgL_test6321z00_21159)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15931;
										obj_t BgL_runz00_15932;
										obj_t BgL_sfz00_15933;

										BgL_arityz00_15931 =
											STRUCT_REF(BgL_ufz00_15930, (int) (((long) 0)));
										BgL_runz00_15932 =
											STRUCT_REF(BgL_ufz00_15930, (int) (((long) 1)));
										BgL_sfz00_15933 =
											STRUCT_REF(BgL_ufz00_15930, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15931) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2136z00_15934;

													BgL_arg2136z00_15934 =
														((long) CINT(BgL_bpz00_15926) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13737), BgL_arg2136z00_15934,
														BgL_a1z00_15928);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2137z00_15935;

													BgL_arg2137z00_15935 =
														((long) CINT(BgL_bpz00_15926) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13737), BgL_arg2137z00_15935,
														BgL_a2z00_15929);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15931))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15931))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2139z00_15936;
																	obj_t BgL_arg2140z00_15937;

																	BgL_arg2139z00_15936 =
																		((long) CINT(BgL_bpz00_15926) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2141z00_15938;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2142z00_15939;

																			BgL_arg2142z00_15939 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15929, BNIL);
																			BgL_list2141z00_15938 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15928,
																				BgL_arg2142z00_15939);
																		}
																		BgL_arg2140z00_15937 =
																			BgL_list2141z00_15938;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13737),
																		BgL_arg2139z00_15936, BgL_arg2140z00_15937);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2143z00_15940;

																	BgL_arg2143z00_15940 =
																		((long) CINT(BgL_bpz00_15926) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13737),
																		BgL_arg2143z00_15940, BgL_a1z00_15928);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2145z00_15941;
																	obj_t BgL_arg2146z00_15942;

																	BgL_arg2145z00_15941 =
																		((long) CINT(BgL_bpz00_15926) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2147z00_15943;

																		BgL_list2147z00_15943 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_15929, BNIL);
																		BgL_arg2146z00_15942 =
																			BgL_list2147z00_15943;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13737),
																		BgL_arg2145z00_15941, BgL_arg2146z00_15942);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2148z00_15944;

																	BgL_arg2148z00_15944 =
																		((long) CINT(BgL_bpz00_15926) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13737),
																		BgL_arg2148z00_15944, BgL_a1z00_15928);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2150z00_15945;

																	BgL_arg2150z00_15945 =
																		((long) CINT(BgL_bpz00_15926) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13737),
																		BgL_arg2150z00_15945, BgL_a2z00_15929);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2151z00_15946;
																	obj_t BgL_arg2152z00_15947;

																	BgL_arg2151z00_15946 =
																		((long) CINT(BgL_bpz00_15926) + ((long) 2));
																	BgL_arg2152z00_15947 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13737),
																		BgL_arg2151z00_15946, BgL_arg2152z00_15947);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13734, STRUCT_REF(BgL_ufz00_15930,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_15931));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13734, STRUCT_REF(BgL_ufz00_15930,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_15931));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15948;

											BgL_z12denvz12_15948 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_15948,
												BgL_locz00_13734);
											if ((((long) CINT(BgL_bpz00_15926) +
														(long) CINT(BgL_sfz00_15933)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13737))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15932;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15949;

													BgL_nsz00_15949 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2156z00_15950;

														BgL_arg2156z00_15950 =
															((long) CINT(BgL_bpz00_15926) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15949, ((long) 2), BgL_sz00_13737,
															BgL_bpz00_15926, BINT(BgL_arg2156z00_15950));
													}
													VECTOR_SET(BgL_nsz00_15949, ((long) 1),
														BgL_sz00_13737);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15948,
														BgL_nsz00_15949);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15951;

														BgL_ez00_15951 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15951, BgL_sz00_13737);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15952;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15953;

																BgL_savedzd2bpzd2_15953 =
																	VECTOR_REF(BgL_nsz00_15949, ((long) 0));
																VECTOR_SET(BgL_nsz00_15949, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15955;

																	BgL_fz00_15955 = BgL_runz00_15932;
																BgL_recz00_15954:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15956;

																		BgL_rz00_15956 =
																			PROCEDURE_ENTRY(BgL_fz00_15955)
																			(BgL_fz00_15955, BgL_nsz00_15949, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6326z00_21247;

																			if (PROCEDUREP(BgL_rz00_15956))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_15957;

																					BgL_arg1732z00_15957 =
																						PROCEDURE_ATTR(BgL_rz00_15956);
																					if (STRUCTP(BgL_arg1732z00_15957))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6326z00_21247 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_15957) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6326z00_21247 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6326z00_21247 = ((bool_t) 0);
																				}
																			if (BgL_test6326z00_21247)
																				{
																					obj_t BgL_fz00_21255;

																					BgL_fz00_21255 = BgL_rz00_15956;
																					BgL_fz00_15955 = BgL_fz00_21255;
																					goto BgL_recz00_15954;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15949,
																						((long) 0),
																						BgL_savedzd2bpzd2_15953);
																					BgL_____rz00_15952 = BgL_rz00_15956;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15951);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15948,
																BgL_sz00_13737);
															return BgL_____rz00_15952;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15927,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15958;

												BgL_nbpz00_15958 =
													((long) CINT(BgL_bpz00_15926) + BgL_siza7eza7_13736);
												VECTOR_SET(
													((obj_t) BgL_sz00_13737), ((long) 0),
													BINT(BgL_nbpz00_15958));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_21267;

													BgL_tmpz00_21267 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21267,
														BgL_locz00_13734);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15959;

													BgL_rz00_15959 =
														PROCEDURE_ENTRY(BgL_fz00_15927) (BgL_fz00_15927,
														BgL_a1z00_15928, BgL_a2z00_15929, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13737), ((long) 0),
														BgL_bpz00_15926);
													return BgL_rz00_15959;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13734,
													BgL_symbzd2funzd2_13735, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15927));
		}}}}}}}}

	}



/* &<@anonymous:2160> */
	obj_t BGl_z62zc3z04anonymousza32160ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13738, obj_t BgL_sz00_13745)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13739;
				obj_t BgL_a1z00_13740;
				obj_t BgL_a2z00_13741;
				obj_t BgL_locz00_13742;
				obj_t BgL_symbzd2funzd2_13743;
				long BgL_siza7eza7_13744;

				BgL_funz00_13739 = PROCEDURE_REF(BgL_envz00_13738, (int) (((long) 0)));
				BgL_a1z00_13740 = PROCEDURE_REF(BgL_envz00_13738, (int) (((long) 1)));
				BgL_a2z00_13741 = PROCEDURE_REF(BgL_envz00_13738, (int) (((long) 2)));
				BgL_locz00_13742 = PROCEDURE_REF(BgL_envz00_13738, (int) (((long) 3)));
				BgL_symbzd2funzd2_13743 =
					PROCEDURE_REF(BgL_envz00_13738, (int) (((long) 4)));
				BgL_siza7eza7_13744 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13738, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15960;

					BgL_bpz00_15960 = VECTOR_REF(((obj_t) BgL_sz00_13745), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15961;
						obj_t BgL_a1z00_15962;
						obj_t BgL_a2z00_15963;

						BgL_fz00_15961 =
							PROCEDURE_ENTRY(BgL_funz00_13739) (BgL_funz00_13739,
							BgL_sz00_13745, BEOA);
						BgL_a1z00_15962 =
							PROCEDURE_ENTRY(BgL_a1z00_13740) (BgL_a1z00_13740, BgL_sz00_13745,
							BEOA);
						BgL_a2z00_15963 =
							PROCEDURE_ENTRY(BgL_a2z00_13741) (BgL_a2z00_13741, BgL_sz00_13745,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15961))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13742,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15961);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15964;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21310;

								BgL_tmpz00_21310 = ((obj_t) BgL_fz00_15961);
								BgL_ufz00_15964 = PROCEDURE_ATTR(BgL_tmpz00_21310);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6331z00_21313;

								if (STRUCTP(BgL_ufz00_15964))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6331z00_21313 =
											(STRUCT_KEY(BgL_ufz00_15964) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6331z00_21313 = ((bool_t) 0);
									}
								if (BgL_test6331z00_21313)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15965;
										obj_t BgL_runz00_15966;
										obj_t BgL_sfz00_15967;

										BgL_arityz00_15965 =
											STRUCT_REF(BgL_ufz00_15964, (int) (((long) 0)));
										BgL_runz00_15966 =
											STRUCT_REF(BgL_ufz00_15964, (int) (((long) 1)));
										BgL_sfz00_15967 =
											STRUCT_REF(BgL_ufz00_15964, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_15965) == ((long) 2)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2164z00_15968;

													BgL_arg2164z00_15968 =
														((long) CINT(BgL_bpz00_15960) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13745), BgL_arg2164z00_15968,
														BgL_a1z00_15962);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2165z00_15969;

													BgL_arg2165z00_15969 =
														((long) CINT(BgL_bpz00_15960) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13745), BgL_arg2165z00_15969,
														BgL_a2z00_15963);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_15965))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_15965))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2167z00_15970;
																	obj_t BgL_arg2168z00_15971;

																	BgL_arg2167z00_15970 =
																		((long) CINT(BgL_bpz00_15960) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2170z00_15972;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2171z00_15973;

																			BgL_arg2171z00_15973 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15963, BNIL);
																			BgL_list2170z00_15972 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_15962,
																				BgL_arg2171z00_15973);
																		}
																		BgL_arg2168z00_15971 =
																			BgL_list2170z00_15972;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13745),
																		BgL_arg2167z00_15970, BgL_arg2168z00_15971);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2172z00_15974;

																	BgL_arg2172z00_15974 =
																		((long) CINT(BgL_bpz00_15960) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13745),
																		BgL_arg2172z00_15974, BgL_a1z00_15962);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2173z00_15975;
																	obj_t BgL_arg2174z00_15976;

																	BgL_arg2173z00_15975 =
																		((long) CINT(BgL_bpz00_15960) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2175z00_15977;

																		BgL_list2175z00_15977 =
																			MAKE_YOUNG_PAIR(BgL_a2z00_15963, BNIL);
																		BgL_arg2174z00_15976 =
																			BgL_list2175z00_15977;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13745),
																		BgL_arg2173z00_15975, BgL_arg2174z00_15976);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2176z00_15978;

																	BgL_arg2176z00_15978 =
																		((long) CINT(BgL_bpz00_15960) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13745),
																		BgL_arg2176z00_15978, BgL_a1z00_15962);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2177z00_15979;

																	BgL_arg2177z00_15979 =
																		((long) CINT(BgL_bpz00_15960) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13745),
																		BgL_arg2177z00_15979, BgL_a2z00_15963);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2178z00_15980;
																	obj_t BgL_arg2179z00_15981;

																	BgL_arg2178z00_15980 =
																		((long) CINT(BgL_bpz00_15960) + ((long) 2));
																	BgL_arg2179z00_15981 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13745),
																		BgL_arg2178z00_15980, BgL_arg2179z00_15981);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13742, STRUCT_REF(BgL_ufz00_15964,
																		(int) (((long) 3))), (int) (((long) 2)),
																	CINT(BgL_arityz00_15965));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13742, STRUCT_REF(BgL_ufz00_15964,
																(int) (((long) 3))), (int) (((long) 2)),
															CINT(BgL_arityz00_15965));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_15982;

											BgL_z12denvz12_15982 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_15960) +
														(long) CINT(BgL_sfz00_15967)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13745))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_15966;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_15983;

													BgL_nsz00_15983 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2183z00_15984;

														BgL_arg2183z00_15984 =
															((long) CINT(BgL_bpz00_15960) + ((long) 2));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_15983, ((long) 2), BgL_sz00_13745,
															BgL_bpz00_15960, BINT(BgL_arg2183z00_15984));
													}
													VECTOR_SET(BgL_nsz00_15983, ((long) 1),
														BgL_sz00_13745);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15982,
														BgL_nsz00_15983);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_15985;

														BgL_ez00_15985 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_15985, BgL_sz00_13745);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_15986;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_15987;

																BgL_savedzd2bpzd2_15987 =
																	VECTOR_REF(BgL_nsz00_15983, ((long) 0));
																VECTOR_SET(BgL_nsz00_15983, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_15989;

																	BgL_fz00_15989 = BgL_runz00_15966;
																BgL_recz00_15988:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_15990;

																		BgL_rz00_15990 =
																			PROCEDURE_ENTRY(BgL_fz00_15989)
																			(BgL_fz00_15989, BgL_nsz00_15983, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6336z00_21400;

																			if (PROCEDUREP(BgL_rz00_15990))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_15991;

																					BgL_arg1732z00_15991 =
																						PROCEDURE_ATTR(BgL_rz00_15990);
																					if (STRUCTP(BgL_arg1732z00_15991))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6336z00_21400 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_15991) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6336z00_21400 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6336z00_21400 = ((bool_t) 0);
																				}
																			if (BgL_test6336z00_21400)
																				{
																					obj_t BgL_fz00_21408;

																					BgL_fz00_21408 = BgL_rz00_15990;
																					BgL_fz00_15989 = BgL_fz00_21408;
																					goto BgL_recz00_15988;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_15983,
																						((long) 0),
																						BgL_savedzd2bpzd2_15987);
																					BgL_____rz00_15986 = BgL_rz00_15990;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_15985);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_15982,
																BgL_sz00_13745);
															return BgL_____rz00_15986;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15961,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_15992;

												BgL_nbpz00_15992 =
													((long) CINT(BgL_bpz00_15960) + BgL_siza7eza7_13744);
												VECTOR_SET(
													((obj_t) BgL_sz00_13745), ((long) 0),
													BINT(BgL_nbpz00_15992));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_15993;

													BgL_rz00_15993 =
														PROCEDURE_ENTRY(BgL_fz00_15961) (BgL_fz00_15961,
														BgL_a1z00_15962, BgL_a2z00_15963, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13745), ((long) 0),
														BgL_bpz00_15960);
													return BgL_rz00_15993;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13742,
													BgL_symbzd2funzd2_13743, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15961));
		}}}}}}}}

	}



/* &<@anonymous:2189> */
	obj_t BGl_z62zc3z04anonymousza32189ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13746, obj_t BgL_sz00_13753)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13747;
				obj_t BgL_a1z00_13748;
				obj_t BgL_a2z00_13749;
				obj_t BgL_locz00_13750;
				obj_t BgL_symbzd2funzd2_13751;
				long BgL_siza7eza7_13752;

				BgL_funz00_13747 = PROCEDURE_REF(BgL_envz00_13746, (int) (((long) 0)));
				BgL_a1z00_13748 = PROCEDURE_REF(BgL_envz00_13746, (int) (((long) 1)));
				BgL_a2z00_13749 = PROCEDURE_REF(BgL_envz00_13746, (int) (((long) 2)));
				BgL_locz00_13750 = PROCEDURE_REF(BgL_envz00_13746, (int) (((long) 3)));
				BgL_symbzd2funzd2_13751 =
					PROCEDURE_REF(BgL_envz00_13746, (int) (((long) 4)));
				BgL_siza7eza7_13752 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13746, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_15994;

					BgL_bpz00_15994 = VECTOR_REF(((obj_t) BgL_sz00_13753), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_15995;
						obj_t BgL_a1z00_15996;
						obj_t BgL_a2z00_15997;

						BgL_fz00_15995 =
							PROCEDURE_ENTRY(BgL_funz00_13747) (BgL_funz00_13747,
							BgL_sz00_13753, BEOA);
						BgL_a1z00_15996 =
							PROCEDURE_ENTRY(BgL_a1z00_13748) (BgL_a1z00_13748, BgL_sz00_13753,
							BEOA);
						BgL_a2z00_15997 =
							PROCEDURE_ENTRY(BgL_a2z00_13749) (BgL_a2z00_13749, BgL_sz00_13753,
							BEOA);
						if (PROCEDUREP(BgL_fz00_15995))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13750,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_15995);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_15998;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21460;

								BgL_tmpz00_21460 = ((obj_t) BgL_fz00_15995);
								BgL_ufz00_15998 = PROCEDURE_ATTR(BgL_tmpz00_21460);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6341z00_21463;

								if (STRUCTP(BgL_ufz00_15998))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6341z00_21463 =
											(STRUCT_KEY(BgL_ufz00_15998) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6341z00_21463 = ((bool_t) 0);
									}
								if (BgL_test6341z00_21463)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_15999;
										obj_t BgL_runz00_16000;
										obj_t BgL_sfz00_16001;

										BgL_arityz00_15999 =
											STRUCT_REF(BgL_ufz00_15998, (int) (((long) 0)));
										BgL_runz00_16000 =
											STRUCT_REF(BgL_ufz00_15998, (int) (((long) 1)));
										BgL_sfz00_16001 =
											STRUCT_REF(BgL_ufz00_15998, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16002;

											BgL_spz00_16002 =
												((long) CINT(BgL_bpz00_15994) + BgL_siza7eza7_13752);
											if (((long) CINT(BgL_arityz00_15999) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2193z00_16003;

														BgL_arg2193z00_16003 =
															(BgL_spz00_16002 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13753), BgL_arg2193z00_16003,
															BgL_a1z00_15996);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2194z00_16004;

														BgL_arg2194z00_16004 =
															(BgL_spz00_16002 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13753), BgL_arg2194z00_16004,
															BgL_a2z00_15997);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_15999))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_15999))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2196z00_16005;
																		obj_t BgL_arg2197z00_16006;

																		BgL_arg2196z00_16005 =
																			(BgL_spz00_16002 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2198z00_16007;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2199z00_16008;

																				BgL_arg2199z00_16008 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_15997,
																					BNIL);
																				BgL_list2198z00_16007 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_15996,
																					BgL_arg2199z00_16008);
																			}
																			BgL_arg2197z00_16006 =
																				BgL_list2198z00_16007;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13753),
																			BgL_arg2196z00_16005,
																			BgL_arg2197z00_16006);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2200z00_16009;

																		BgL_arg2200z00_16009 =
																			(BgL_spz00_16002 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13753),
																			BgL_arg2200z00_16009, BgL_a1z00_15996);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2201z00_16010;
																		obj_t BgL_arg2202z00_16011;

																		BgL_arg2201z00_16010 =
																			(BgL_spz00_16002 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2203z00_16012;

																			BgL_list2203z00_16012 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_15997, BNIL);
																			BgL_arg2202z00_16011 =
																				BgL_list2203z00_16012;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13753),
																			BgL_arg2201z00_16010,
																			BgL_arg2202z00_16011);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2204z00_16013;

																		BgL_arg2204z00_16013 =
																			(BgL_spz00_16002 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13753),
																			BgL_arg2204z00_16013, BgL_a1z00_15996);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2205z00_16014;

																		BgL_arg2205z00_16014 =
																			(BgL_spz00_16002 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13753),
																			BgL_arg2205z00_16014, BgL_a2z00_15997);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2206z00_16015;
																		obj_t BgL_arg2207z00_16016;

																		BgL_arg2206z00_16015 =
																			(BgL_spz00_16002 + ((long) 2));
																		BgL_arg2207z00_16016 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13753),
																			BgL_arg2206z00_16015,
																			BgL_arg2207z00_16016);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13750,
																		STRUCT_REF(BgL_ufz00_15998,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_15999));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13750, STRUCT_REF(BgL_ufz00_15998,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_15999));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16017;

												BgL_z12denvz12_16017 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16017,
													BgL_locz00_13750);
												if (((BgL_spz00_16002 + (long) CINT(BgL_sfz00_16001)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13753))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16000, BgL_sz00_13753,
															BINT(BgL_spz00_16002));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16018;

														BgL_nsz00_16018 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2211z00_16019;

															BgL_arg2211z00_16019 =
																(BgL_spz00_16002 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16018, ((long) 2), BgL_sz00_13753,
																BINT(BgL_spz00_16002),
																BINT(BgL_arg2211z00_16019));
														}
														VECTOR_SET(BgL_nsz00_16018, ((long) 1),
															BgL_sz00_13753);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16017,
															BgL_nsz00_16018);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16020;

															BgL_ez00_16020 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16020, BgL_sz00_13753);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16021;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16022;

																	BgL_savedzd2bpzd2_16022 =
																		VECTOR_REF(BgL_nsz00_16018, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16018, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16024;

																		BgL_fz00_16024 = BgL_runz00_16000;
																	BgL_recz00_16023:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16025;

																			BgL_rz00_16025 =
																				PROCEDURE_ENTRY(BgL_fz00_16024)
																				(BgL_fz00_16024, BgL_nsz00_16018, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6346z00_21546;

																				if (PROCEDUREP(BgL_rz00_16025))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_16026;

																						BgL_arg1732z00_16026 =
																							PROCEDURE_ATTR(BgL_rz00_16025);
																						if (STRUCTP(BgL_arg1732z00_16026))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6346z00_21546 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_16026) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6346z00_21546 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6346z00_21546 =
																							((bool_t) 0);
																					}
																				if (BgL_test6346z00_21546)
																					{
																						obj_t BgL_fz00_21554;

																						BgL_fz00_21554 = BgL_rz00_16025;
																						BgL_fz00_16024 = BgL_fz00_21554;
																						goto BgL_recz00_16023;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16018,
																							((long) 0),
																							BgL_savedzd2bpzd2_16022);
																						BgL_____rz00_16021 = BgL_rz00_16025;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16020);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16017,
																	BgL_sz00_13753);
																return BgL_____rz00_16021;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_15995,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16027;

												BgL_nbpz00_16027 =
													((long) CINT(BgL_bpz00_15994) + BgL_siza7eza7_13752);
												VECTOR_SET(
													((obj_t) BgL_sz00_13753), ((long) 0),
													BINT(BgL_nbpz00_16027));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_21566;

													BgL_tmpz00_21566 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21566,
														BgL_locz00_13750);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16028;

													BgL_rz00_16028 =
														PROCEDURE_ENTRY(BgL_fz00_15995) (BgL_fz00_15995,
														BgL_a1z00_15996, BgL_a2z00_15997, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13753), ((long) 0),
														BgL_bpz00_15994);
													return BgL_rz00_16028;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13750,
													BgL_symbzd2funzd2_13751, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_15995));
		}}}}}}}}

	}



/* &<@anonymous:2215> */
	obj_t BGl_z62zc3z04anonymousza32215ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13754, obj_t BgL_sz00_13761)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13755;
				obj_t BgL_a1z00_13756;
				obj_t BgL_a2z00_13757;
				obj_t BgL_locz00_13758;
				obj_t BgL_symbzd2funzd2_13759;
				long BgL_siza7eza7_13760;

				BgL_funz00_13755 = PROCEDURE_REF(BgL_envz00_13754, (int) (((long) 0)));
				BgL_a1z00_13756 = PROCEDURE_REF(BgL_envz00_13754, (int) (((long) 1)));
				BgL_a2z00_13757 = PROCEDURE_REF(BgL_envz00_13754, (int) (((long) 2)));
				BgL_locz00_13758 = PROCEDURE_REF(BgL_envz00_13754, (int) (((long) 3)));
				BgL_symbzd2funzd2_13759 =
					PROCEDURE_REF(BgL_envz00_13754, (int) (((long) 4)));
				BgL_siza7eza7_13760 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13754, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16029;

					BgL_bpz00_16029 = VECTOR_REF(((obj_t) BgL_sz00_13761), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16030;
						obj_t BgL_a1z00_16031;
						obj_t BgL_a2z00_16032;

						BgL_fz00_16030 =
							PROCEDURE_ENTRY(BgL_funz00_13755) (BgL_funz00_13755,
							BgL_sz00_13761, BEOA);
						BgL_a1z00_16031 =
							PROCEDURE_ENTRY(BgL_a1z00_13756) (BgL_a1z00_13756, BgL_sz00_13761,
							BEOA);
						BgL_a2z00_16032 =
							PROCEDURE_ENTRY(BgL_a2z00_13757) (BgL_a2z00_13757, BgL_sz00_13761,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16030))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13758,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16030);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16033;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21609;

								BgL_tmpz00_21609 = ((obj_t) BgL_fz00_16030);
								BgL_ufz00_16033 = PROCEDURE_ATTR(BgL_tmpz00_21609);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6351z00_21612;

								if (STRUCTP(BgL_ufz00_16033))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6351z00_21612 =
											(STRUCT_KEY(BgL_ufz00_16033) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6351z00_21612 = ((bool_t) 0);
									}
								if (BgL_test6351z00_21612)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16034;
										obj_t BgL_runz00_16035;
										obj_t BgL_sfz00_16036;

										BgL_arityz00_16034 =
											STRUCT_REF(BgL_ufz00_16033, (int) (((long) 0)));
										BgL_runz00_16035 =
											STRUCT_REF(BgL_ufz00_16033, (int) (((long) 1)));
										BgL_sfz00_16036 =
											STRUCT_REF(BgL_ufz00_16033, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16037;

											BgL_spz00_16037 =
												((long) CINT(BgL_bpz00_16029) + BgL_siza7eza7_13760);
											if (((long) CINT(BgL_arityz00_16034) == ((long) 2)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2219z00_16038;

														BgL_arg2219z00_16038 =
															(BgL_spz00_16037 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13761), BgL_arg2219z00_16038,
															BgL_a1z00_16031);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2220z00_16039;

														BgL_arg2220z00_16039 =
															(BgL_spz00_16037 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13761), BgL_arg2220z00_16039,
															BgL_a2z00_16032);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16034))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16034))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2222z00_16040;
																		obj_t BgL_arg2223z00_16041;

																		BgL_arg2222z00_16040 =
																			(BgL_spz00_16037 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2224z00_16042;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2225z00_16043;

																				BgL_arg2225z00_16043 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16032,
																					BNIL);
																				BgL_list2224z00_16042 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16031,
																					BgL_arg2225z00_16043);
																			}
																			BgL_arg2223z00_16041 =
																				BgL_list2224z00_16042;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13761),
																			BgL_arg2222z00_16040,
																			BgL_arg2223z00_16041);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2226z00_16044;

																		BgL_arg2226z00_16044 =
																			(BgL_spz00_16037 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13761),
																			BgL_arg2226z00_16044, BgL_a1z00_16031);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2227z00_16045;
																		obj_t BgL_arg2228z00_16046;

																		BgL_arg2227z00_16045 =
																			(BgL_spz00_16037 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2229z00_16047;

																			BgL_list2229z00_16047 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16032, BNIL);
																			BgL_arg2228z00_16046 =
																				BgL_list2229z00_16047;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13761),
																			BgL_arg2227z00_16045,
																			BgL_arg2228z00_16046);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2230z00_16048;

																		BgL_arg2230z00_16048 =
																			(BgL_spz00_16037 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13761),
																			BgL_arg2230z00_16048, BgL_a1z00_16031);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2231z00_16049;

																		BgL_arg2231z00_16049 =
																			(BgL_spz00_16037 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13761),
																			BgL_arg2231z00_16049, BgL_a2z00_16032);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2232z00_16050;
																		obj_t BgL_arg2233z00_16051;

																		BgL_arg2232z00_16050 =
																			(BgL_spz00_16037 + ((long) 2));
																		BgL_arg2233z00_16051 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13761),
																			BgL_arg2232z00_16050,
																			BgL_arg2233z00_16051);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13758,
																		STRUCT_REF(BgL_ufz00_16033,
																			(int) (((long) 3))), (int) (((long) 2)),
																		CINT(BgL_arityz00_16034));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13758, STRUCT_REF(BgL_ufz00_16033,
																	(int) (((long) 3))), (int) (((long) 2)),
																CINT(BgL_arityz00_16034));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16052;

												BgL_z12denvz12_16052 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16037 +
															(long) CINT(BgL_sfz00_16036)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13761))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16035, BgL_sz00_13761,
															BINT(BgL_spz00_16037));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16053;

														BgL_nsz00_16053 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2237z00_16054;

															BgL_arg2237z00_16054 =
																(BgL_spz00_16037 + ((long) 2));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16053, ((long) 2), BgL_sz00_13761,
																BINT(BgL_spz00_16037),
																BINT(BgL_arg2237z00_16054));
														}
														VECTOR_SET(BgL_nsz00_16053, ((long) 1),
															BgL_sz00_13761);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16052,
															BgL_nsz00_16053);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16055;

															BgL_ez00_16055 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16055, BgL_sz00_13761);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16056;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16057;

																	BgL_savedzd2bpzd2_16057 =
																		VECTOR_REF(BgL_nsz00_16053, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16053, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16059;

																		BgL_fz00_16059 = BgL_runz00_16035;
																	BgL_recz00_16058:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16060;

																			BgL_rz00_16060 =
																				PROCEDURE_ENTRY(BgL_fz00_16059)
																				(BgL_fz00_16059, BgL_nsz00_16053, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6356z00_21694;

																				if (PROCEDUREP(BgL_rz00_16060))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_16061;

																						BgL_arg1732z00_16061 =
																							PROCEDURE_ATTR(BgL_rz00_16060);
																						if (STRUCTP(BgL_arg1732z00_16061))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6356z00_21694 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_16061) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6356z00_21694 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6356z00_21694 =
																							((bool_t) 0);
																					}
																				if (BgL_test6356z00_21694)
																					{
																						obj_t BgL_fz00_21702;

																						BgL_fz00_21702 = BgL_rz00_16060;
																						BgL_fz00_16059 = BgL_fz00_21702;
																						goto BgL_recz00_16058;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16053,
																							((long) 0),
																							BgL_savedzd2bpzd2_16057);
																						BgL_____rz00_16056 = BgL_rz00_16060;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16055);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16052,
																	BgL_sz00_13761);
																return BgL_____rz00_16056;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16030,
												(int) (((long) 2))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16062;

												BgL_nbpz00_16062 =
													((long) CINT(BgL_bpz00_16029) + BgL_siza7eza7_13760);
												VECTOR_SET(
													((obj_t) BgL_sz00_13761), ((long) 0),
													BINT(BgL_nbpz00_16062));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16063;

													BgL_rz00_16063 =
														PROCEDURE_ENTRY(BgL_fz00_16030) (BgL_fz00_16030,
														BgL_a1z00_16031, BgL_a2z00_16032, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13761), ((long) 0),
														BgL_bpz00_16029);
													return BgL_rz00_16063;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13758,
													BgL_symbzd2funzd2_13759, (int) (((long) 2)),
													PROCEDURE_ARITY(BgL_fz00_16030));
		}}}}}}}}

	}



/* comp-call3 */
	obj_t BGl_compzd2call3zd2zz__evaluate_compz00(obj_t BgL_locz00_162,
		BgL_ev_exprz00_bglt BgL_vfunz00_163, obj_t BgL_symbzd2funzd2_164,
		obj_t BgL_funz00_165, obj_t BgL_tailzf3zf3_166, obj_t BgL_stkz00_167,
		long BgL_siza7eza7_168, obj_t BgL_a1z00_169, obj_t BgL_a2z00_170,
		obj_t BgL_a3z00_171)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2491;

				BgL_cfunz00_2491 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_163,
					((long) 3), BgL_locz00_162, BgL_symbzd2funzd2_164);
				if (CBOOL(BgL_cfunz00_2491))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6361z00_21727;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2246z00_2511;

							BgL_arg2246z00_2511 = bgl_debug();
							BgL_test6361z00_21727 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2246z00_2511),
								BINT(((long) 0)));
						}
						if (BgL_test6361z00_21727)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32243ze3z87_13762;

								BgL_zc3z04anonymousza32243ze3z87_13762 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32243ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32243ze3z87_13762,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3z04anonymousza32243ze3z87_13762,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3z04anonymousza32243ze3z87_13762,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3z04anonymousza32243ze3z87_13762,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3z04anonymousza32243ze3z87_13762,
									(int) (((long) 4)), BgL_locz00_162);
								PROCEDURE_SET(BgL_zc3z04anonymousza32243ze3z87_13762,
									(int) (((long) 5)), BgL_cfunz00_2491);
								return BgL_zc3z04anonymousza32243ze3z87_13762;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32245ze3z87_13763;

								BgL_zc3z04anonymousza32245ze3z87_13763 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32245ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32245ze3z87_13763,
									(int) (((long) 0)), BgL_a1z00_169);
								PROCEDURE_SET(BgL_zc3z04anonymousza32245ze3z87_13763,
									(int) (((long) 1)), BgL_a2z00_170);
								PROCEDURE_SET(BgL_zc3z04anonymousza32245ze3z87_13763,
									(int) (((long) 2)), BgL_a3z00_171);
								PROCEDURE_SET(BgL_zc3z04anonymousza32245ze3z87_13763,
									(int) (((long) 3)), BINT(BgL_siza7eza7_168));
								PROCEDURE_SET(BgL_zc3z04anonymousza32245ze3z87_13763,
									(int) (((long) 4)), BgL_cfunz00_2491);
								return BgL_zc3z04anonymousza32245ze3z87_13763;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_166))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6363z00_21764;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2328z00_2623;

									BgL_arg2328z00_2623 = bgl_debug();
									BgL_test6363z00_21764 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2328z00_2623),
										BINT(((long) 0)));
								}
								if (BgL_test6363z00_21764)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32249ze3z87_13764;

										BgL_zc3z04anonymousza32249ze3z87_13764 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32249ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32249ze3z87_13764,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32249ze3z87_13764,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32249ze3z87_13764,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32249ze3z87_13764,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32249ze3z87_13764,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32249ze3z87_13764,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32249ze3z87_13764,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32249ze3z87_13764;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32288ze3z87_13765;

										BgL_zc3z04anonymousza32288ze3z87_13765 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32288ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32288ze3z87_13765,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32288ze3z87_13765,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32288ze3z87_13765,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32288ze3z87_13765,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32288ze3z87_13765,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32288ze3z87_13765,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32288ze3z87_13765,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32288ze3z87_13765;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6364z00_21805;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2405z00_2735;

									BgL_arg2405z00_2735 = bgl_debug();
									BgL_test6364z00_21805 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2405z00_2735),
										BINT(((long) 0)));
								}
								if (BgL_test6364z00_21805)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32331ze3z87_13766;

										BgL_zc3z04anonymousza32331ze3z87_13766 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32331ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13766,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13766,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13766,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13766,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13766,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13766,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32331ze3z87_13766,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32331ze3z87_13766;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32368ze3z87_13767;

										BgL_zc3z04anonymousza32368ze3z87_13767 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32368ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 7)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13767,
											(int) (((long) 0)), BgL_funz00_165);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13767,
											(int) (((long) 1)), BgL_a1z00_169);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13767,
											(int) (((long) 2)), BgL_a2z00_170);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13767,
											(int) (((long) 3)), BgL_a3z00_171);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13767,
											(int) (((long) 4)), BgL_locz00_162);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13767,
											(int) (((long) 5)), BgL_symbzd2funzd2_164);
										PROCEDURE_SET(BgL_zc3z04anonymousza32368ze3z87_13767,
											(int) (((long) 6)), BINT(BgL_siza7eza7_168));
										return BgL_zc3z04anonymousza32368ze3z87_13767;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2243> */
	obj_t BGl_z62zc3z04anonymousza32243ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13768, obj_t BgL_sz00_13775)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13769;
				obj_t BgL_a2z00_13770;
				obj_t BgL_a3z00_13771;
				long BgL_siza7eza7_13772;
				obj_t BgL_locz00_13773;
				obj_t BgL_cfunz00_13774;

				BgL_a1z00_13769 = PROCEDURE_REF(BgL_envz00_13768, (int) (((long) 0)));
				BgL_a2z00_13770 = PROCEDURE_REF(BgL_envz00_13768, (int) (((long) 1)));
				BgL_a3z00_13771 = PROCEDURE_REF(BgL_envz00_13768, (int) (((long) 2)));
				BgL_siza7eza7_13772 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13768, (int) (((long) 3))));
				BgL_locz00_13773 = PROCEDURE_REF(BgL_envz00_13768, (int) (((long) 4)));
				BgL_cfunz00_13774 = PROCEDURE_REF(BgL_envz00_13768, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16064;

					BgL_bpz00_16064 = VECTOR_REF(((obj_t) BgL_sz00_13775), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_16065;
						obj_t BgL_a2z00_16066;
						obj_t BgL_a3z00_16067;

						BgL_a1z00_16065 =
							PROCEDURE_ENTRY(BgL_a1z00_13769) (BgL_a1z00_13769, BgL_sz00_13775,
							BEOA);
						BgL_a2z00_16066 =
							PROCEDURE_ENTRY(BgL_a2z00_13770) (BgL_a2z00_13770, BgL_sz00_13775,
							BEOA);
						BgL_a3z00_16067 =
							PROCEDURE_ENTRY(BgL_a3z00_13771) (BgL_a3z00_13771, BgL_sz00_13775,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_16068;

							BgL_nbpz00_16068 =
								((long) CINT(BgL_bpz00_16064) + BgL_siza7eza7_13772);
							VECTOR_SET(
								((obj_t) BgL_sz00_13775), ((long) 0), BINT(BgL_nbpz00_16068));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21878;

								BgL_tmpz00_21878 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_21878, BgL_locz00_13773);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_16069;

								BgL_rz00_16069 =
									PROCEDURE_ENTRY(BgL_cfunz00_13774) (BgL_cfunz00_13774,
									BgL_a1z00_16065, BgL_a2z00_16066, BgL_a3z00_16067, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13775), ((long) 0),
									BgL_bpz00_16064);
								return BgL_rz00_16069;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2245> */
	obj_t BGl_z62zc3z04anonymousza32245ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13776, obj_t BgL_sz00_13782)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13777;
				obj_t BgL_a2z00_13778;
				obj_t BgL_a3z00_13779;
				long BgL_siza7eza7_13780;
				obj_t BgL_cfunz00_13781;

				BgL_a1z00_13777 = PROCEDURE_REF(BgL_envz00_13776, (int) (((long) 0)));
				BgL_a2z00_13778 = PROCEDURE_REF(BgL_envz00_13776, (int) (((long) 1)));
				BgL_a3z00_13779 = PROCEDURE_REF(BgL_envz00_13776, (int) (((long) 2)));
				BgL_siza7eza7_13780 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13776, (int) (((long) 3))));
				BgL_cfunz00_13781 = PROCEDURE_REF(BgL_envz00_13776, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16070;

					BgL_bpz00_16070 = VECTOR_REF(((obj_t) BgL_sz00_13782), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_16071;
						obj_t BgL_a2z00_16072;
						obj_t BgL_a3z00_16073;

						BgL_a1z00_16071 =
							PROCEDURE_ENTRY(BgL_a1z00_13777) (BgL_a1z00_13777, BgL_sz00_13782,
							BEOA);
						BgL_a2z00_16072 =
							PROCEDURE_ENTRY(BgL_a2z00_13778) (BgL_a2z00_13778, BgL_sz00_13782,
							BEOA);
						BgL_a3z00_16073 =
							PROCEDURE_ENTRY(BgL_a3z00_13779) (BgL_a3z00_13779, BgL_sz00_13782,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_16074;

							BgL_nbpz00_16074 =
								((long) CINT(BgL_bpz00_16070) + BgL_siza7eza7_13780);
							VECTOR_SET(
								((obj_t) BgL_sz00_13782), ((long) 0), BINT(BgL_nbpz00_16074));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_16075;

								BgL_rz00_16075 =
									PROCEDURE_ENTRY(BgL_cfunz00_13781) (BgL_cfunz00_13781,
									BgL_a1z00_16071, BgL_a2z00_16072, BgL_a3z00_16073, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13782), ((long) 0),
									BgL_bpz00_16070);
								return BgL_rz00_16075;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2249> */
	obj_t BGl_z62zc3z04anonymousza32249ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13783, obj_t BgL_sz00_13791)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13784;
				obj_t BgL_a1z00_13785;
				obj_t BgL_a2z00_13786;
				obj_t BgL_a3z00_13787;
				obj_t BgL_locz00_13788;
				obj_t BgL_symbzd2funzd2_13789;
				long BgL_siza7eza7_13790;

				BgL_funz00_13784 = PROCEDURE_REF(BgL_envz00_13783, (int) (((long) 0)));
				BgL_a1z00_13785 = PROCEDURE_REF(BgL_envz00_13783, (int) (((long) 1)));
				BgL_a2z00_13786 = PROCEDURE_REF(BgL_envz00_13783, (int) (((long) 2)));
				BgL_a3z00_13787 = PROCEDURE_REF(BgL_envz00_13783, (int) (((long) 3)));
				BgL_locz00_13788 = PROCEDURE_REF(BgL_envz00_13783, (int) (((long) 4)));
				BgL_symbzd2funzd2_13789 =
					PROCEDURE_REF(BgL_envz00_13783, (int) (((long) 5)));
				BgL_siza7eza7_13790 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13783, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16076;

					BgL_bpz00_16076 = VECTOR_REF(((obj_t) BgL_sz00_13791), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16077;
						obj_t BgL_a1z00_16078;
						obj_t BgL_a2z00_16079;
						obj_t BgL_a3z00_16080;

						BgL_fz00_16077 =
							PROCEDURE_ENTRY(BgL_funz00_13784) (BgL_funz00_13784,
							BgL_sz00_13791, BEOA);
						BgL_a1z00_16078 =
							PROCEDURE_ENTRY(BgL_a1z00_13785) (BgL_a1z00_13785, BgL_sz00_13791,
							BEOA);
						BgL_a2z00_16079 =
							PROCEDURE_ENTRY(BgL_a2z00_13786) (BgL_a2z00_13786, BgL_sz00_13791,
							BEOA);
						BgL_a3z00_16080 =
							PROCEDURE_ENTRY(BgL_a3z00_13787) (BgL_a3z00_13787, BgL_sz00_13791,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16077))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13788,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16077);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16081;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_21963;

								BgL_tmpz00_21963 = ((obj_t) BgL_fz00_16077);
								BgL_ufz00_16081 = PROCEDURE_ATTR(BgL_tmpz00_21963);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6366z00_21966;

								if (STRUCTP(BgL_ufz00_16081))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6366z00_21966 =
											(STRUCT_KEY(BgL_ufz00_16081) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6366z00_21966 = ((bool_t) 0);
									}
								if (BgL_test6366z00_21966)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16082;
										obj_t BgL_runz00_16083;
										obj_t BgL_sfz00_16084;

										BgL_arityz00_16082 =
											STRUCT_REF(BgL_ufz00_16081, (int) (((long) 0)));
										BgL_runz00_16083 =
											STRUCT_REF(BgL_ufz00_16081, (int) (((long) 1)));
										BgL_sfz00_16084 =
											STRUCT_REF(BgL_ufz00_16081, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16082) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2253z00_16085;

													BgL_arg2253z00_16085 =
														((long) CINT(BgL_bpz00_16076) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13791), BgL_arg2253z00_16085,
														BgL_a1z00_16078);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2254z00_16086;

													BgL_arg2254z00_16086 =
														((long) CINT(BgL_bpz00_16076) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13791), BgL_arg2254z00_16086,
														BgL_a2z00_16079);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2255z00_16087;

													BgL_arg2255z00_16087 =
														((long) CINT(BgL_bpz00_16076) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13791), BgL_arg2255z00_16087,
														BgL_a3z00_16080);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_16082))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_16082))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2258z00_16088;
																	obj_t BgL_arg2259z00_16089;

																	BgL_arg2258z00_16088 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2260z00_16090;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2261z00_16091;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2262z00_16092;

																				BgL_arg2262z00_16092 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16080,
																					BNIL);
																				BgL_arg2261z00_16091 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16079,
																					BgL_arg2262z00_16092);
																			}
																			BgL_list2260z00_16090 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16078,
																				BgL_arg2261z00_16091);
																		}
																		BgL_arg2259z00_16089 =
																			BgL_list2260z00_16090;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2258z00_16088, BgL_arg2259z00_16089);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2263z00_16093;

																	BgL_arg2263z00_16093 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2263z00_16093, BgL_a1z00_16078);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2264z00_16094;
																	obj_t BgL_arg2265z00_16095;

																	BgL_arg2264z00_16094 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2266z00_16096;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2268z00_16097;

																			BgL_arg2268z00_16097 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16080, BNIL);
																			BgL_list2266z00_16096 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16079,
																				BgL_arg2268z00_16097);
																		}
																		BgL_arg2265z00_16095 =
																			BgL_list2266z00_16096;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2264z00_16094, BgL_arg2265z00_16095);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2269z00_16098;

																	BgL_arg2269z00_16098 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2269z00_16098, BgL_a1z00_16078);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2270z00_16099;

																	BgL_arg2270z00_16099 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2270z00_16099, BgL_a2z00_16079);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2271z00_16100;
																	obj_t BgL_arg2272z00_16101;

																	BgL_arg2271z00_16100 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2273z00_16102;

																		BgL_list2273z00_16102 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_16080, BNIL);
																		BgL_arg2272z00_16101 =
																			BgL_list2273z00_16102;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2271z00_16100, BgL_arg2272z00_16101);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2275z00_16103;

																	BgL_arg2275z00_16103 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2275z00_16103, BgL_a1z00_16078);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2276z00_16104;

																	BgL_arg2276z00_16104 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2276z00_16104, BgL_a2z00_16079);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2278z00_16105;

																	BgL_arg2278z00_16105 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2278z00_16105, BgL_a3z00_16080);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2279z00_16106;
																	obj_t BgL_arg2280z00_16107;

																	BgL_arg2279z00_16106 =
																		((long) CINT(BgL_bpz00_16076) + ((long) 3));
																	BgL_arg2280z00_16107 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13791),
																		BgL_arg2279z00_16106, BgL_arg2280z00_16107);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13788, STRUCT_REF(BgL_ufz00_16081,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_16082));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13788, STRUCT_REF(BgL_ufz00_16081,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_16082));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_16108;

											BgL_z12denvz12_16108 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16108,
												BgL_locz00_13788);
											if ((((long) CINT(BgL_bpz00_16076) +
														(long) CINT(BgL_sfz00_16084)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13791))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_16083;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_16109;

													BgL_nsz00_16109 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2284z00_16110;

														BgL_arg2284z00_16110 =
															((long) CINT(BgL_bpz00_16076) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16109, ((long) 2), BgL_sz00_13791,
															BgL_bpz00_16076, BINT(BgL_arg2284z00_16110));
													}
													VECTOR_SET(BgL_nsz00_16109, ((long) 1),
														BgL_sz00_13791);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16108,
														BgL_nsz00_16109);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_16111;

														BgL_ez00_16111 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16111, BgL_sz00_13791);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_16112;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_16113;

																BgL_savedzd2bpzd2_16113 =
																	VECTOR_REF(BgL_nsz00_16109, ((long) 0));
																VECTOR_SET(BgL_nsz00_16109, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16115;

																	BgL_fz00_16115 = BgL_runz00_16083;
																BgL_recz00_16114:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_16116;

																		BgL_rz00_16116 =
																			PROCEDURE_ENTRY(BgL_fz00_16115)
																			(BgL_fz00_16115, BgL_nsz00_16109, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6371z00_22077;

																			if (PROCEDUREP(BgL_rz00_16116))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_16117;

																					BgL_arg1732z00_16117 =
																						PROCEDURE_ATTR(BgL_rz00_16116);
																					if (STRUCTP(BgL_arg1732z00_16117))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6371z00_22077 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_16117) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6371z00_22077 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6371z00_22077 = ((bool_t) 0);
																				}
																			if (BgL_test6371z00_22077)
																				{
																					obj_t BgL_fz00_22085;

																					BgL_fz00_22085 = BgL_rz00_16116;
																					BgL_fz00_16115 = BgL_fz00_22085;
																					goto BgL_recz00_16114;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_16109,
																						((long) 0),
																						BgL_savedzd2bpzd2_16113);
																					BgL_____rz00_16112 = BgL_rz00_16116;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16111);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16108,
																BgL_sz00_13791);
															return BgL_____rz00_16112;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16077,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16118;

												BgL_nbpz00_16118 =
													((long) CINT(BgL_bpz00_16076) + BgL_siza7eza7_13790);
												VECTOR_SET(
													((obj_t) BgL_sz00_13791), ((long) 0),
													BINT(BgL_nbpz00_16118));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_22097;

													BgL_tmpz00_22097 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22097,
														BgL_locz00_13788);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16119;

													BgL_rz00_16119 =
														PROCEDURE_ENTRY(BgL_fz00_16077) (BgL_fz00_16077,
														BgL_a1z00_16078, BgL_a2z00_16079, BgL_a3z00_16080,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13791), ((long) 0),
														BgL_bpz00_16076);
													return BgL_rz00_16119;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13788,
													BgL_symbzd2funzd2_13789, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16077));
		}}}}}}}}

	}



/* &<@anonymous:2288> */
	obj_t BGl_z62zc3z04anonymousza32288ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13792, obj_t BgL_sz00_13800)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13793;
				obj_t BgL_a1z00_13794;
				obj_t BgL_a2z00_13795;
				obj_t BgL_a3z00_13796;
				obj_t BgL_locz00_13797;
				obj_t BgL_symbzd2funzd2_13798;
				long BgL_siza7eza7_13799;

				BgL_funz00_13793 = PROCEDURE_REF(BgL_envz00_13792, (int) (((long) 0)));
				BgL_a1z00_13794 = PROCEDURE_REF(BgL_envz00_13792, (int) (((long) 1)));
				BgL_a2z00_13795 = PROCEDURE_REF(BgL_envz00_13792, (int) (((long) 2)));
				BgL_a3z00_13796 = PROCEDURE_REF(BgL_envz00_13792, (int) (((long) 3)));
				BgL_locz00_13797 = PROCEDURE_REF(BgL_envz00_13792, (int) (((long) 4)));
				BgL_symbzd2funzd2_13798 =
					PROCEDURE_REF(BgL_envz00_13792, (int) (((long) 5)));
				BgL_siza7eza7_13799 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13792, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16120;

					BgL_bpz00_16120 = VECTOR_REF(((obj_t) BgL_sz00_13800), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16121;
						obj_t BgL_a1z00_16122;
						obj_t BgL_a2z00_16123;
						obj_t BgL_a3z00_16124;

						BgL_fz00_16121 =
							PROCEDURE_ENTRY(BgL_funz00_13793) (BgL_funz00_13793,
							BgL_sz00_13800, BEOA);
						BgL_a1z00_16122 =
							PROCEDURE_ENTRY(BgL_a1z00_13794) (BgL_a1z00_13794, BgL_sz00_13800,
							BEOA);
						BgL_a2z00_16123 =
							PROCEDURE_ENTRY(BgL_a2z00_13795) (BgL_a2z00_13795, BgL_sz00_13800,
							BEOA);
						BgL_a3z00_16124 =
							PROCEDURE_ENTRY(BgL_a3z00_13796) (BgL_a3z00_13796, BgL_sz00_13800,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16121))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13797,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16121);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16125;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22147;

								BgL_tmpz00_22147 = ((obj_t) BgL_fz00_16121);
								BgL_ufz00_16125 = PROCEDURE_ATTR(BgL_tmpz00_22147);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6376z00_22150;

								if (STRUCTP(BgL_ufz00_16125))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6376z00_22150 =
											(STRUCT_KEY(BgL_ufz00_16125) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6376z00_22150 = ((bool_t) 0);
									}
								if (BgL_test6376z00_22150)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16126;
										obj_t BgL_runz00_16127;
										obj_t BgL_sfz00_16128;

										BgL_arityz00_16126 =
											STRUCT_REF(BgL_ufz00_16125, (int) (((long) 0)));
										BgL_runz00_16127 =
											STRUCT_REF(BgL_ufz00_16125, (int) (((long) 1)));
										BgL_sfz00_16128 =
											STRUCT_REF(BgL_ufz00_16125, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16126) == ((long) 3)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2292z00_16129;

													BgL_arg2292z00_16129 =
														((long) CINT(BgL_bpz00_16120) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13800), BgL_arg2292z00_16129,
														BgL_a1z00_16122);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2294z00_16130;

													BgL_arg2294z00_16130 =
														((long) CINT(BgL_bpz00_16120) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13800), BgL_arg2294z00_16130,
														BgL_a2z00_16123);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2295z00_16131;

													BgL_arg2295z00_16131 =
														((long) CINT(BgL_bpz00_16120) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13800), BgL_arg2295z00_16131,
														BgL_a3z00_16124);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_16126))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_16126))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2297z00_16132;
																	obj_t BgL_arg2298z00_16133;

																	BgL_arg2297z00_16132 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2299z00_16134;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2300z00_16135;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2301z00_16136;

																				BgL_arg2301z00_16136 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16124,
																					BNIL);
																				BgL_arg2300z00_16135 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16123,
																					BgL_arg2301z00_16136);
																			}
																			BgL_list2299z00_16134 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16122,
																				BgL_arg2300z00_16135);
																		}
																		BgL_arg2298z00_16133 =
																			BgL_list2299z00_16134;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2297z00_16132, BgL_arg2298z00_16133);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2302z00_16137;

																	BgL_arg2302z00_16137 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2302z00_16137, BgL_a1z00_16122);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2303z00_16138;
																	obj_t BgL_arg2306z00_16139;

																	BgL_arg2303z00_16138 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2307z00_16140;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2308z00_16141;

																			BgL_arg2308z00_16141 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16124, BNIL);
																			BgL_list2307z00_16140 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16123,
																				BgL_arg2308z00_16141);
																		}
																		BgL_arg2306z00_16139 =
																			BgL_list2307z00_16140;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2303z00_16138, BgL_arg2306z00_16139);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2309z00_16142;

																	BgL_arg2309z00_16142 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2309z00_16142, BgL_a1z00_16122);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2310z00_16143;

																	BgL_arg2310z00_16143 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2310z00_16143, BgL_a2z00_16123);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2311z00_16144;
																	obj_t BgL_arg2313z00_16145;

																	BgL_arg2311z00_16144 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2314z00_16146;

																		BgL_list2314z00_16146 =
																			MAKE_YOUNG_PAIR(BgL_a3z00_16124, BNIL);
																		BgL_arg2313z00_16145 =
																			BgL_list2314z00_16146;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2311z00_16144, BgL_arg2313z00_16145);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2315z00_16147;

																	BgL_arg2315z00_16147 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2315z00_16147, BgL_a1z00_16122);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2317z00_16148;

																	BgL_arg2317z00_16148 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2317z00_16148, BgL_a2z00_16123);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2319z00_16149;

																	BgL_arg2319z00_16149 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2319z00_16149, BgL_a3z00_16124);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2320z00_16150;
																	obj_t BgL_arg2321z00_16151;

																	BgL_arg2320z00_16150 =
																		((long) CINT(BgL_bpz00_16120) + ((long) 3));
																	BgL_arg2321z00_16151 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13800),
																		BgL_arg2320z00_16150, BgL_arg2321z00_16151);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13797, STRUCT_REF(BgL_ufz00_16125,
																		(int) (((long) 3))), (int) (((long) 3)),
																	CINT(BgL_arityz00_16126));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13797, STRUCT_REF(BgL_ufz00_16125,
																(int) (((long) 3))), (int) (((long) 3)),
															CINT(BgL_arityz00_16126));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_16152;

											BgL_z12denvz12_16152 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_16120) +
														(long) CINT(BgL_sfz00_16128)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13800))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_16127;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_16153;

													BgL_nsz00_16153 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2325z00_16154;

														BgL_arg2325z00_16154 =
															((long) CINT(BgL_bpz00_16120) + ((long) 3));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16153, ((long) 2), BgL_sz00_13800,
															BgL_bpz00_16120, BINT(BgL_arg2325z00_16154));
													}
													VECTOR_SET(BgL_nsz00_16153, ((long) 1),
														BgL_sz00_13800);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16152,
														BgL_nsz00_16153);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_16155;

														BgL_ez00_16155 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16155, BgL_sz00_13800);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_16156;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_16157;

																BgL_savedzd2bpzd2_16157 =
																	VECTOR_REF(BgL_nsz00_16153, ((long) 0));
																VECTOR_SET(BgL_nsz00_16153, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16159;

																	BgL_fz00_16159 = BgL_runz00_16127;
																BgL_recz00_16158:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_16160;

																		BgL_rz00_16160 =
																			PROCEDURE_ENTRY(BgL_fz00_16159)
																			(BgL_fz00_16159, BgL_nsz00_16153, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6381z00_22260;

																			if (PROCEDUREP(BgL_rz00_16160))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_16161;

																					BgL_arg1732z00_16161 =
																						PROCEDURE_ATTR(BgL_rz00_16160);
																					if (STRUCTP(BgL_arg1732z00_16161))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6381z00_22260 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_16161) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6381z00_22260 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6381z00_22260 = ((bool_t) 0);
																				}
																			if (BgL_test6381z00_22260)
																				{
																					obj_t BgL_fz00_22268;

																					BgL_fz00_22268 = BgL_rz00_16160;
																					BgL_fz00_16159 = BgL_fz00_22268;
																					goto BgL_recz00_16158;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_16153,
																						((long) 0),
																						BgL_savedzd2bpzd2_16157);
																					BgL_____rz00_16156 = BgL_rz00_16160;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16155);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16152,
																BgL_sz00_13800);
															return BgL_____rz00_16156;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16121,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16162;

												BgL_nbpz00_16162 =
													((long) CINT(BgL_bpz00_16120) + BgL_siza7eza7_13799);
												VECTOR_SET(
													((obj_t) BgL_sz00_13800), ((long) 0),
													BINT(BgL_nbpz00_16162));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16163;

													BgL_rz00_16163 =
														PROCEDURE_ENTRY(BgL_fz00_16121) (BgL_fz00_16121,
														BgL_a1z00_16122, BgL_a2z00_16123, BgL_a3z00_16124,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13800), ((long) 0),
														BgL_bpz00_16120);
													return BgL_rz00_16163;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13797,
													BgL_symbzd2funzd2_13798, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16121));
		}}}}}}}}

	}



/* &<@anonymous:2331> */
	obj_t BGl_z62zc3z04anonymousza32331ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13801, obj_t BgL_sz00_13809)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13802;
				obj_t BgL_a1z00_13803;
				obj_t BgL_a2z00_13804;
				obj_t BgL_a3z00_13805;
				obj_t BgL_locz00_13806;
				obj_t BgL_symbzd2funzd2_13807;
				long BgL_siza7eza7_13808;

				BgL_funz00_13802 = PROCEDURE_REF(BgL_envz00_13801, (int) (((long) 0)));
				BgL_a1z00_13803 = PROCEDURE_REF(BgL_envz00_13801, (int) (((long) 1)));
				BgL_a2z00_13804 = PROCEDURE_REF(BgL_envz00_13801, (int) (((long) 2)));
				BgL_a3z00_13805 = PROCEDURE_REF(BgL_envz00_13801, (int) (((long) 3)));
				BgL_locz00_13806 = PROCEDURE_REF(BgL_envz00_13801, (int) (((long) 4)));
				BgL_symbzd2funzd2_13807 =
					PROCEDURE_REF(BgL_envz00_13801, (int) (((long) 5)));
				BgL_siza7eza7_13808 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13801, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16164;

					BgL_bpz00_16164 = VECTOR_REF(((obj_t) BgL_sz00_13809), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16165;
						obj_t BgL_a1z00_16166;
						obj_t BgL_a2z00_16167;
						obj_t BgL_a3z00_16168;

						BgL_fz00_16165 =
							PROCEDURE_ENTRY(BgL_funz00_13802) (BgL_funz00_13802,
							BgL_sz00_13809, BEOA);
						BgL_a1z00_16166 =
							PROCEDURE_ENTRY(BgL_a1z00_13803) (BgL_a1z00_13803, BgL_sz00_13809,
							BEOA);
						BgL_a2z00_16167 =
							PROCEDURE_ENTRY(BgL_a2z00_13804) (BgL_a2z00_13804, BgL_sz00_13809,
							BEOA);
						BgL_a3z00_16168 =
							PROCEDURE_ENTRY(BgL_a3z00_13805) (BgL_a3z00_13805, BgL_sz00_13809,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16165))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13806,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16165);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16169;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22327;

								BgL_tmpz00_22327 = ((obj_t) BgL_fz00_16165);
								BgL_ufz00_16169 = PROCEDURE_ATTR(BgL_tmpz00_22327);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6386z00_22330;

								if (STRUCTP(BgL_ufz00_16169))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6386z00_22330 =
											(STRUCT_KEY(BgL_ufz00_16169) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6386z00_22330 = ((bool_t) 0);
									}
								if (BgL_test6386z00_22330)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16170;
										obj_t BgL_runz00_16171;
										obj_t BgL_sfz00_16172;

										BgL_arityz00_16170 =
											STRUCT_REF(BgL_ufz00_16169, (int) (((long) 0)));
										BgL_runz00_16171 =
											STRUCT_REF(BgL_ufz00_16169, (int) (((long) 1)));
										BgL_sfz00_16172 =
											STRUCT_REF(BgL_ufz00_16169, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16173;

											BgL_spz00_16173 =
												((long) CINT(BgL_bpz00_16164) + BgL_siza7eza7_13808);
											if (((long) CINT(BgL_arityz00_16170) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2335z00_16174;

														BgL_arg2335z00_16174 =
															(BgL_spz00_16173 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13809), BgL_arg2335z00_16174,
															BgL_a1z00_16166);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2337z00_16175;

														BgL_arg2337z00_16175 =
															(BgL_spz00_16173 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13809), BgL_arg2337z00_16175,
															BgL_a2z00_16167);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2338z00_16176;

														BgL_arg2338z00_16176 =
															(BgL_spz00_16173 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13809), BgL_arg2338z00_16176,
															BgL_a3z00_16168);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16170))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16170))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2341z00_16177;
																		obj_t BgL_arg2342z00_16178;

																		BgL_arg2341z00_16177 =
																			(BgL_spz00_16173 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2343z00_16179;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2344z00_16180;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2345z00_16181;

																					BgL_arg2345z00_16181 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16168,
																						BNIL);
																					BgL_arg2344z00_16180 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16167,
																						BgL_arg2345z00_16181);
																				}
																				BgL_list2343z00_16179 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16166,
																					BgL_arg2344z00_16180);
																			}
																			BgL_arg2342z00_16178 =
																				BgL_list2343z00_16179;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2341z00_16177,
																			BgL_arg2342z00_16178);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2346z00_16182;

																		BgL_arg2346z00_16182 =
																			(BgL_spz00_16173 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2346z00_16182, BgL_a1z00_16166);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2347z00_16183;
																		obj_t BgL_arg2348z00_16184;

																		BgL_arg2347z00_16183 =
																			(BgL_spz00_16173 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2349z00_16185;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2350z00_16186;

																				BgL_arg2350z00_16186 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16168,
																					BNIL);
																				BgL_list2349z00_16185 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16167,
																					BgL_arg2350z00_16186);
																			}
																			BgL_arg2348z00_16184 =
																				BgL_list2349z00_16185;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2347z00_16183,
																			BgL_arg2348z00_16184);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2351z00_16187;

																		BgL_arg2351z00_16187 =
																			(BgL_spz00_16173 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2351z00_16187, BgL_a1z00_16166);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2352z00_16188;

																		BgL_arg2352z00_16188 =
																			(BgL_spz00_16173 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2352z00_16188, BgL_a2z00_16167);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2353z00_16189;
																		obj_t BgL_arg2354z00_16190;

																		BgL_arg2353z00_16189 =
																			(BgL_spz00_16173 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2355z00_16191;

																			BgL_list2355z00_16191 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16168, BNIL);
																			BgL_arg2354z00_16190 =
																				BgL_list2355z00_16191;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2353z00_16189,
																			BgL_arg2354z00_16190);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2356z00_16192;

																		BgL_arg2356z00_16192 =
																			(BgL_spz00_16173 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2356z00_16192, BgL_a1z00_16166);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2357z00_16193;

																		BgL_arg2357z00_16193 =
																			(BgL_spz00_16173 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2357z00_16193, BgL_a2z00_16167);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2358z00_16194;

																		BgL_arg2358z00_16194 =
																			(BgL_spz00_16173 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2358z00_16194, BgL_a3z00_16168);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2359z00_16195;
																		obj_t BgL_arg2360z00_16196;

																		BgL_arg2359z00_16195 =
																			(BgL_spz00_16173 + ((long) 3));
																		BgL_arg2360z00_16196 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13809),
																			BgL_arg2359z00_16195,
																			BgL_arg2360z00_16196);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13806,
																		STRUCT_REF(BgL_ufz00_16169,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_16170));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13806, STRUCT_REF(BgL_ufz00_16169,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_16170));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16197;

												BgL_z12denvz12_16197 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16197,
													BgL_locz00_13806);
												if (((BgL_spz00_16173 + (long) CINT(BgL_sfz00_16172)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13809))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16171, BgL_sz00_13809,
															BINT(BgL_spz00_16173));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16198;

														BgL_nsz00_16198 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2364z00_16199;

															BgL_arg2364z00_16199 =
																(BgL_spz00_16173 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16198, ((long) 2), BgL_sz00_13809,
																BINT(BgL_spz00_16173),
																BINT(BgL_arg2364z00_16199));
														}
														VECTOR_SET(BgL_nsz00_16198, ((long) 1),
															BgL_sz00_13809);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16197,
															BgL_nsz00_16198);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16200;

															BgL_ez00_16200 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16200, BgL_sz00_13809);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16201;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16202;

																	BgL_savedzd2bpzd2_16202 =
																		VECTOR_REF(BgL_nsz00_16198, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16198, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16204;

																		BgL_fz00_16204 = BgL_runz00_16171;
																	BgL_recz00_16203:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16205;

																			BgL_rz00_16205 =
																				PROCEDURE_ENTRY(BgL_fz00_16204)
																				(BgL_fz00_16204, BgL_nsz00_16198, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6391z00_22431;

																				if (PROCEDUREP(BgL_rz00_16205))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_16206;

																						BgL_arg1732z00_16206 =
																							PROCEDURE_ATTR(BgL_rz00_16205);
																						if (STRUCTP(BgL_arg1732z00_16206))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6391z00_22431 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_16206) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6391z00_22431 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6391z00_22431 =
																							((bool_t) 0);
																					}
																				if (BgL_test6391z00_22431)
																					{
																						obj_t BgL_fz00_22439;

																						BgL_fz00_22439 = BgL_rz00_16205;
																						BgL_fz00_16204 = BgL_fz00_22439;
																						goto BgL_recz00_16203;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16198,
																							((long) 0),
																							BgL_savedzd2bpzd2_16202);
																						BgL_____rz00_16201 = BgL_rz00_16205;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16200);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16197,
																	BgL_sz00_13809);
																return BgL_____rz00_16201;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16165,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16207;

												BgL_nbpz00_16207 =
													((long) CINT(BgL_bpz00_16164) + BgL_siza7eza7_13808);
												VECTOR_SET(
													((obj_t) BgL_sz00_13809), ((long) 0),
													BINT(BgL_nbpz00_16207));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_22451;

													BgL_tmpz00_22451 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22451,
														BgL_locz00_13806);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16208;

													BgL_rz00_16208 =
														PROCEDURE_ENTRY(BgL_fz00_16165) (BgL_fz00_16165,
														BgL_a1z00_16166, BgL_a2z00_16167, BgL_a3z00_16168,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13809), ((long) 0),
														BgL_bpz00_16164);
													return BgL_rz00_16208;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13806,
													BgL_symbzd2funzd2_13807, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16165));
		}}}}}}}}

	}



/* &<@anonymous:2368> */
	obj_t BGl_z62zc3z04anonymousza32368ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13810, obj_t BgL_sz00_13818)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13811;
				obj_t BgL_a1z00_13812;
				obj_t BgL_a2z00_13813;
				obj_t BgL_a3z00_13814;
				obj_t BgL_locz00_13815;
				obj_t BgL_symbzd2funzd2_13816;
				long BgL_siza7eza7_13817;

				BgL_funz00_13811 = PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 0)));
				BgL_a1z00_13812 = PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 1)));
				BgL_a2z00_13813 = PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 2)));
				BgL_a3z00_13814 = PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 3)));
				BgL_locz00_13815 = PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 4)));
				BgL_symbzd2funzd2_13816 =
					PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 5)));
				BgL_siza7eza7_13817 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13810, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16209;

					BgL_bpz00_16209 = VECTOR_REF(((obj_t) BgL_sz00_13818), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16210;
						obj_t BgL_a1z00_16211;
						obj_t BgL_a2z00_16212;
						obj_t BgL_a3z00_16213;

						BgL_fz00_16210 =
							PROCEDURE_ENTRY(BgL_funz00_13811) (BgL_funz00_13811,
							BgL_sz00_13818, BEOA);
						BgL_a1z00_16211 =
							PROCEDURE_ENTRY(BgL_a1z00_13812) (BgL_a1z00_13812, BgL_sz00_13818,
							BEOA);
						BgL_a2z00_16212 =
							PROCEDURE_ENTRY(BgL_a2z00_13813) (BgL_a2z00_13813, BgL_sz00_13818,
							BEOA);
						BgL_a3z00_16213 =
							PROCEDURE_ENTRY(BgL_a3z00_13814) (BgL_a3z00_13814, BgL_sz00_13818,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16210))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13815,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16210);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16214;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22501;

								BgL_tmpz00_22501 = ((obj_t) BgL_fz00_16210);
								BgL_ufz00_16214 = PROCEDURE_ATTR(BgL_tmpz00_22501);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6396z00_22504;

								if (STRUCTP(BgL_ufz00_16214))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6396z00_22504 =
											(STRUCT_KEY(BgL_ufz00_16214) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6396z00_22504 = ((bool_t) 0);
									}
								if (BgL_test6396z00_22504)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16215;
										obj_t BgL_runz00_16216;
										obj_t BgL_sfz00_16217;

										BgL_arityz00_16215 =
											STRUCT_REF(BgL_ufz00_16214, (int) (((long) 0)));
										BgL_runz00_16216 =
											STRUCT_REF(BgL_ufz00_16214, (int) (((long) 1)));
										BgL_sfz00_16217 =
											STRUCT_REF(BgL_ufz00_16214, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16218;

											BgL_spz00_16218 =
												((long) CINT(BgL_bpz00_16209) + BgL_siza7eza7_13817);
											if (((long) CINT(BgL_arityz00_16215) == ((long) 3)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2372z00_16219;

														BgL_arg2372z00_16219 =
															(BgL_spz00_16218 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13818), BgL_arg2372z00_16219,
															BgL_a1z00_16211);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2373z00_16220;

														BgL_arg2373z00_16220 =
															(BgL_spz00_16218 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13818), BgL_arg2373z00_16220,
															BgL_a2z00_16212);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2374z00_16221;

														BgL_arg2374z00_16221 =
															(BgL_spz00_16218 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13818), BgL_arg2374z00_16221,
															BgL_a3z00_16213);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16215))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16215))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2376z00_16222;
																		obj_t BgL_arg2377z00_16223;

																		BgL_arg2376z00_16222 =
																			(BgL_spz00_16218 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2378z00_16224;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2379z00_16225;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2380z00_16226;

																					BgL_arg2380z00_16226 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16213,
																						BNIL);
																					BgL_arg2379z00_16225 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16212,
																						BgL_arg2380z00_16226);
																				}
																				BgL_list2378z00_16224 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16211,
																					BgL_arg2379z00_16225);
																			}
																			BgL_arg2377z00_16223 =
																				BgL_list2378z00_16224;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2376z00_16222,
																			BgL_arg2377z00_16223);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2382z00_16227;

																		BgL_arg2382z00_16227 =
																			(BgL_spz00_16218 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2382z00_16227, BgL_a1z00_16211);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2383z00_16228;
																		obj_t BgL_arg2384z00_16229;

																		BgL_arg2383z00_16228 =
																			(BgL_spz00_16218 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2385z00_16230;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2388z00_16231;

																				BgL_arg2388z00_16231 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16213,
																					BNIL);
																				BgL_list2385z00_16230 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16212,
																					BgL_arg2388z00_16231);
																			}
																			BgL_arg2384z00_16229 =
																				BgL_list2385z00_16230;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2383z00_16228,
																			BgL_arg2384z00_16229);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2389z00_16232;

																		BgL_arg2389z00_16232 =
																			(BgL_spz00_16218 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2389z00_16232, BgL_a1z00_16211);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2390z00_16233;

																		BgL_arg2390z00_16233 =
																			(BgL_spz00_16218 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2390z00_16233, BgL_a2z00_16212);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2391z00_16234;
																		obj_t BgL_arg2392z00_16235;

																		BgL_arg2391z00_16234 =
																			(BgL_spz00_16218 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2393z00_16236;

																			BgL_list2393z00_16236 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16213, BNIL);
																			BgL_arg2392z00_16235 =
																				BgL_list2393z00_16236;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2391z00_16234,
																			BgL_arg2392z00_16235);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2394z00_16237;

																		BgL_arg2394z00_16237 =
																			(BgL_spz00_16218 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2394z00_16237, BgL_a1z00_16211);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2395z00_16238;

																		BgL_arg2395z00_16238 =
																			(BgL_spz00_16218 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2395z00_16238, BgL_a2z00_16212);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2396z00_16239;

																		BgL_arg2396z00_16239 =
																			(BgL_spz00_16218 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2396z00_16239, BgL_a3z00_16213);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2397z00_16240;
																		obj_t BgL_arg2398z00_16241;

																		BgL_arg2397z00_16240 =
																			(BgL_spz00_16218 + ((long) 3));
																		BgL_arg2398z00_16241 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13818),
																			BgL_arg2397z00_16240,
																			BgL_arg2398z00_16241);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13815,
																		STRUCT_REF(BgL_ufz00_16214,
																			(int) (((long) 3))), (int) (((long) 3)),
																		CINT(BgL_arityz00_16215));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13815, STRUCT_REF(BgL_ufz00_16214,
																	(int) (((long) 3))), (int) (((long) 3)),
																CINT(BgL_arityz00_16215));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16242;

												BgL_z12denvz12_16242 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16218 +
															(long) CINT(BgL_sfz00_16217)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13818))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16216, BgL_sz00_13818,
															BINT(BgL_spz00_16218));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16243;

														BgL_nsz00_16243 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2402z00_16244;

															BgL_arg2402z00_16244 =
																(BgL_spz00_16218 + ((long) 3));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16243, ((long) 2), BgL_sz00_13818,
																BINT(BgL_spz00_16218),
																BINT(BgL_arg2402z00_16244));
														}
														VECTOR_SET(BgL_nsz00_16243, ((long) 1),
															BgL_sz00_13818);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16242,
															BgL_nsz00_16243);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16245;

															BgL_ez00_16245 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16245, BgL_sz00_13818);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16246;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16247;

																	BgL_savedzd2bpzd2_16247 =
																		VECTOR_REF(BgL_nsz00_16243, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16243, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16249;

																		BgL_fz00_16249 = BgL_runz00_16216;
																	BgL_recz00_16248:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16250;

																			BgL_rz00_16250 =
																				PROCEDURE_ENTRY(BgL_fz00_16249)
																				(BgL_fz00_16249, BgL_nsz00_16243, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6401z00_22604;

																				if (PROCEDUREP(BgL_rz00_16250))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_16251;

																						BgL_arg1732z00_16251 =
																							PROCEDURE_ATTR(BgL_rz00_16250);
																						if (STRUCTP(BgL_arg1732z00_16251))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6401z00_22604 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_16251) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6401z00_22604 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6401z00_22604 =
																							((bool_t) 0);
																					}
																				if (BgL_test6401z00_22604)
																					{
																						obj_t BgL_fz00_22612;

																						BgL_fz00_22612 = BgL_rz00_16250;
																						BgL_fz00_16249 = BgL_fz00_22612;
																						goto BgL_recz00_16248;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16243,
																							((long) 0),
																							BgL_savedzd2bpzd2_16247);
																						BgL_____rz00_16246 = BgL_rz00_16250;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16245);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16242,
																	BgL_sz00_13818);
																return BgL_____rz00_16246;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16210,
												(int) (((long) 3))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16252;

												BgL_nbpz00_16252 =
													((long) CINT(BgL_bpz00_16209) + BgL_siza7eza7_13817);
												VECTOR_SET(
													((obj_t) BgL_sz00_13818), ((long) 0),
													BINT(BgL_nbpz00_16252));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16253;

													BgL_rz00_16253 =
														PROCEDURE_ENTRY(BgL_fz00_16210) (BgL_fz00_16210,
														BgL_a1z00_16211, BgL_a2z00_16212, BgL_a3z00_16213,
														BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13818), ((long) 0),
														BgL_bpz00_16209);
													return BgL_rz00_16253;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13815,
													BgL_symbzd2funzd2_13816, (int) (((long) 3)),
													PROCEDURE_ARITY(BgL_fz00_16210));
		}}}}}}}}

	}



/* comp-call4 */
	obj_t BGl_compzd2call4zd2zz__evaluate_compz00(obj_t BgL_locz00_172,
		BgL_ev_exprz00_bglt BgL_vfunz00_173, obj_t BgL_symbzd2funzd2_174,
		obj_t BgL_funz00_175, obj_t BgL_tailzf3zf3_176, obj_t BgL_stkz00_177,
		long BgL_siza7eza7_178, obj_t BgL_a1z00_179, obj_t BgL_a2z00_180,
		obj_t BgL_a3z00_181, obj_t BgL_a4z00_182)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_cfunz00_2736;

				BgL_cfunz00_2736 =
					BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_vfunz00_173,
					((long) 4), BgL_locz00_172, BgL_symbzd2funzd2_174);
				if (CBOOL(BgL_cfunz00_2736))
					{	/* Eval/evaluate_comp.scm 896 */
						bool_t BgL_test6406z00_22638;

						{	/* Eval/evaluate_comp.scm 896 */
							int BgL_arg2411z00_2758;

							BgL_arg2411z00_2758 = bgl_debug();
							BgL_test6406z00_22638 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2411z00_2758),
								BINT(((long) 0)));
						}
						if (BgL_test6406z00_22638)
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32408ze3z87_13819;

								BgL_zc3z04anonymousza32408ze3z87_13819 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32408ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32408ze3z87_13819,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3z04anonymousza32408ze3z87_13819,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3z04anonymousza32408ze3z87_13819,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3z04anonymousza32408ze3z87_13819,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3z04anonymousza32408ze3z87_13819,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3z04anonymousza32408ze3z87_13819,
									(int) (((long) 5)), BgL_locz00_172);
								PROCEDURE_SET(BgL_zc3z04anonymousza32408ze3z87_13819,
									(int) (((long) 6)), BgL_cfunz00_2736);
								return BgL_zc3z04anonymousza32408ze3z87_13819;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_zc3z04anonymousza32410ze3z87_13820;

								BgL_zc3z04anonymousza32410ze3z87_13820 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32410ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32410ze3z87_13820,
									(int) (((long) 0)), BgL_a1z00_179);
								PROCEDURE_SET(BgL_zc3z04anonymousza32410ze3z87_13820,
									(int) (((long) 1)), BgL_a2z00_180);
								PROCEDURE_SET(BgL_zc3z04anonymousza32410ze3z87_13820,
									(int) (((long) 2)), BgL_a3z00_181);
								PROCEDURE_SET(BgL_zc3z04anonymousza32410ze3z87_13820,
									(int) (((long) 3)), BgL_a4z00_182);
								PROCEDURE_SET(BgL_zc3z04anonymousza32410ze3z87_13820,
									(int) (((long) 4)), BINT(BgL_siza7eza7_178));
								PROCEDURE_SET(BgL_zc3z04anonymousza32410ze3z87_13820,
									(int) (((long) 5)), BgL_cfunz00_2736);
								return BgL_zc3z04anonymousza32410ze3z87_13820;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 896 */
						if (CBOOL(BgL_tailzf3zf3_176))
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6408z00_22679;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2530z00_2894;

									BgL_arg2530z00_2894 = bgl_debug();
									BgL_test6408z00_22679 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2530z00_2894),
										BINT(((long) 0)));
								}
								if (BgL_test6408z00_22679)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32414ze3z87_13821;

										BgL_zc3z04anonymousza32414ze3z87_13821 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32414ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32414ze3z87_13821,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32414ze3z87_13821,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32414ze3z87_13821,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32414ze3z87_13821,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32414ze3z87_13821,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32414ze3z87_13821,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32414ze3z87_13821,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32414ze3z87_13821,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32414ze3z87_13821;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32465ze3z87_13822;

										BgL_zc3z04anonymousza32465ze3z87_13822 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32465ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32465ze3z87_13822,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32465ze3z87_13822,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32465ze3z87_13822,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32465ze3z87_13822,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32465ze3z87_13822,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32465ze3z87_13822,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32465ze3z87_13822,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32465ze3z87_13822,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32465ze3z87_13822;
									}
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6409z00_22724;

								{	/* Eval/evaluate_comp.scm 896 */
									int BgL_arg2643z00_3030;

									BgL_arg2643z00_3030 = bgl_debug();
									BgL_test6409z00_22724 =
										BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg2643z00_3030),
										BINT(((long) 0)));
								}
								if (BgL_test6409z00_22724)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32533ze3z87_13823;

										BgL_zc3z04anonymousza32533ze3z87_13823 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32533ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32533ze3z87_13823,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32533ze3z87_13823,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32533ze3z87_13823,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32533ze3z87_13823,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32533ze3z87_13823,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32533ze3z87_13823,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32533ze3z87_13823,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32533ze3z87_13823,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32533ze3z87_13823;
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_zc3z04anonymousza32589ze3z87_13824;

										BgL_zc3z04anonymousza32589ze3z87_13824 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza32589ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 8)));
										PROCEDURE_SET(BgL_zc3z04anonymousza32589ze3z87_13824,
											(int) (((long) 0)), BgL_funz00_175);
										PROCEDURE_SET(BgL_zc3z04anonymousza32589ze3z87_13824,
											(int) (((long) 1)), BgL_a1z00_179);
										PROCEDURE_SET(BgL_zc3z04anonymousza32589ze3z87_13824,
											(int) (((long) 2)), BgL_a2z00_180);
										PROCEDURE_SET(BgL_zc3z04anonymousza32589ze3z87_13824,
											(int) (((long) 3)), BgL_a3z00_181);
										PROCEDURE_SET(BgL_zc3z04anonymousza32589ze3z87_13824,
											(int) (((long) 4)), BgL_a4z00_182);
										PROCEDURE_SET(BgL_zc3z04anonymousza32589ze3z87_13824,
											(int) (((long) 5)), BgL_locz00_172);
										PROCEDURE_SET(BgL_zc3z04anonymousza32589ze3z87_13824,
											(int) (((long) 6)), BgL_symbzd2funzd2_174);
										PROCEDURE_SET(BgL_zc3z04anonymousza32589ze3z87_13824,
											(int) (((long) 7)), BINT(BgL_siza7eza7_178));
										return BgL_zc3z04anonymousza32589ze3z87_13824;
									}
							}
					}
			}
		}

	}



/* &<@anonymous:2408> */
	obj_t BGl_z62zc3z04anonymousza32408ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13825, obj_t BgL_sz00_13833)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13826;
				obj_t BgL_a2z00_13827;
				obj_t BgL_a3z00_13828;
				obj_t BgL_a4z00_13829;
				long BgL_siza7eza7_13830;
				obj_t BgL_locz00_13831;
				obj_t BgL_cfunz00_13832;

				BgL_a1z00_13826 = PROCEDURE_REF(BgL_envz00_13825, (int) (((long) 0)));
				BgL_a2z00_13827 = PROCEDURE_REF(BgL_envz00_13825, (int) (((long) 1)));
				BgL_a3z00_13828 = PROCEDURE_REF(BgL_envz00_13825, (int) (((long) 2)));
				BgL_a4z00_13829 = PROCEDURE_REF(BgL_envz00_13825, (int) (((long) 3)));
				BgL_siza7eza7_13830 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13825, (int) (((long) 4))));
				BgL_locz00_13831 = PROCEDURE_REF(BgL_envz00_13825, (int) (((long) 5)));
				BgL_cfunz00_13832 = PROCEDURE_REF(BgL_envz00_13825, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16254;

					BgL_bpz00_16254 = VECTOR_REF(((obj_t) BgL_sz00_13833), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_16255;
						obj_t BgL_a2z00_16256;
						obj_t BgL_a3z00_16257;
						obj_t BgL_a4z00_16258;

						BgL_a1z00_16255 =
							PROCEDURE_ENTRY(BgL_a1z00_13826) (BgL_a1z00_13826, BgL_sz00_13833,
							BEOA);
						BgL_a2z00_16256 =
							PROCEDURE_ENTRY(BgL_a2z00_13827) (BgL_a2z00_13827, BgL_sz00_13833,
							BEOA);
						BgL_a3z00_16257 =
							PROCEDURE_ENTRY(BgL_a3z00_13828) (BgL_a3z00_13828, BgL_sz00_13833,
							BEOA);
						BgL_a4z00_16258 =
							PROCEDURE_ENTRY(BgL_a4z00_13829) (BgL_a4z00_13829, BgL_sz00_13833,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_16259;

							BgL_nbpz00_16259 =
								((long) CINT(BgL_bpz00_16254) + BgL_siza7eza7_13830);
							VECTOR_SET(
								((obj_t) BgL_sz00_13833), ((long) 0), BINT(BgL_nbpz00_16259));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22807;

								BgL_tmpz00_22807 = BGL_CURRENT_DYNAMIC_ENV();
								BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_22807, BgL_locz00_13831);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_16260;

								BgL_rz00_16260 =
									PROCEDURE_ENTRY(BgL_cfunz00_13832) (BgL_cfunz00_13832,
									BgL_a1z00_16255, BgL_a2z00_16256, BgL_a3z00_16257,
									BgL_a4z00_16258, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13833), ((long) 0),
									BgL_bpz00_16254);
								return BgL_rz00_16260;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2410> */
	obj_t BGl_z62zc3z04anonymousza32410ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13834, obj_t BgL_sz00_13841)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_a1z00_13835;
				obj_t BgL_a2z00_13836;
				obj_t BgL_a3z00_13837;
				obj_t BgL_a4z00_13838;
				long BgL_siza7eza7_13839;
				obj_t BgL_cfunz00_13840;

				BgL_a1z00_13835 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 0)));
				BgL_a2z00_13836 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 1)));
				BgL_a3z00_13837 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 2)));
				BgL_a4z00_13838 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 3)));
				BgL_siza7eza7_13839 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 4))));
				BgL_cfunz00_13840 = PROCEDURE_REF(BgL_envz00_13834, (int) (((long) 5)));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16261;

					BgL_bpz00_16261 = VECTOR_REF(((obj_t) BgL_sz00_13841), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_a1z00_16262;
						obj_t BgL_a2z00_16263;
						obj_t BgL_a3z00_16264;
						obj_t BgL_a4z00_16265;

						BgL_a1z00_16262 =
							PROCEDURE_ENTRY(BgL_a1z00_13835) (BgL_a1z00_13835, BgL_sz00_13841,
							BEOA);
						BgL_a2z00_16263 =
							PROCEDURE_ENTRY(BgL_a2z00_13836) (BgL_a2z00_13836, BgL_sz00_13841,
							BEOA);
						BgL_a3z00_16264 =
							PROCEDURE_ENTRY(BgL_a3z00_13837) (BgL_a3z00_13837, BgL_sz00_13841,
							BEOA);
						BgL_a4z00_16265 =
							PROCEDURE_ENTRY(BgL_a4z00_13838) (BgL_a4z00_13838, BgL_sz00_13841,
							BEOA);
						{	/* Eval/evaluate_comp.scm 896 */
							long BgL_nbpz00_16266;

							BgL_nbpz00_16266 =
								((long) CINT(BgL_bpz00_16261) + BgL_siza7eza7_13839);
							VECTOR_SET(
								((obj_t) BgL_sz00_13841), ((long) 0), BINT(BgL_nbpz00_16266));
							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_rz00_16267;

								BgL_rz00_16267 =
									PROCEDURE_ENTRY(BgL_cfunz00_13840) (BgL_cfunz00_13840,
									BgL_a1z00_16262, BgL_a2z00_16263, BgL_a3z00_16264,
									BgL_a4z00_16265, BEOA);
								VECTOR_SET(((obj_t) BgL_sz00_13841), ((long) 0),
									BgL_bpz00_16261);
								return BgL_rz00_16267;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:2414> */
	obj_t BGl_z62zc3z04anonymousza32414ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13842, obj_t BgL_sz00_13851)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13843;
				obj_t BgL_a1z00_13844;
				obj_t BgL_a2z00_13845;
				obj_t BgL_a3z00_13846;
				obj_t BgL_a4z00_13847;
				obj_t BgL_locz00_13848;
				obj_t BgL_symbzd2funzd2_13849;
				long BgL_siza7eza7_13850;

				BgL_funz00_13843 = PROCEDURE_REF(BgL_envz00_13842, (int) (((long) 0)));
				BgL_a1z00_13844 = PROCEDURE_REF(BgL_envz00_13842, (int) (((long) 1)));
				BgL_a2z00_13845 = PROCEDURE_REF(BgL_envz00_13842, (int) (((long) 2)));
				BgL_a3z00_13846 = PROCEDURE_REF(BgL_envz00_13842, (int) (((long) 3)));
				BgL_a4z00_13847 = PROCEDURE_REF(BgL_envz00_13842, (int) (((long) 4)));
				BgL_locz00_13848 = PROCEDURE_REF(BgL_envz00_13842, (int) (((long) 5)));
				BgL_symbzd2funzd2_13849 =
					PROCEDURE_REF(BgL_envz00_13842, (int) (((long) 6)));
				BgL_siza7eza7_13850 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13842, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16268;

					BgL_bpz00_16268 = VECTOR_REF(((obj_t) BgL_sz00_13851), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16269;
						obj_t BgL_a1z00_16270;
						obj_t BgL_a2z00_16271;
						obj_t BgL_a3z00_16272;
						obj_t BgL_a4z00_16273;

						BgL_fz00_16269 =
							PROCEDURE_ENTRY(BgL_funz00_13843) (BgL_funz00_13843,
							BgL_sz00_13851, BEOA);
						BgL_a1z00_16270 =
							PROCEDURE_ENTRY(BgL_a1z00_13844) (BgL_a1z00_13844, BgL_sz00_13851,
							BEOA);
						BgL_a2z00_16271 =
							PROCEDURE_ENTRY(BgL_a2z00_13845) (BgL_a2z00_13845, BgL_sz00_13851,
							BEOA);
						BgL_a3z00_16272 =
							PROCEDURE_ENTRY(BgL_a3z00_13846) (BgL_a3z00_13846, BgL_sz00_13851,
							BEOA);
						BgL_a4z00_16273 =
							PROCEDURE_ENTRY(BgL_a4z00_13847) (BgL_a4z00_13847, BgL_sz00_13851,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16269))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13848,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16269);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16274;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_22906;

								BgL_tmpz00_22906 = ((obj_t) BgL_fz00_16269);
								BgL_ufz00_16274 = PROCEDURE_ATTR(BgL_tmpz00_22906);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6411z00_22909;

								if (STRUCTP(BgL_ufz00_16274))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6411z00_22909 =
											(STRUCT_KEY(BgL_ufz00_16274) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6411z00_22909 = ((bool_t) 0);
									}
								if (BgL_test6411z00_22909)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16275;
										obj_t BgL_runz00_16276;
										obj_t BgL_sfz00_16277;

										BgL_arityz00_16275 =
											STRUCT_REF(BgL_ufz00_16274, (int) (((long) 0)));
										BgL_runz00_16276 =
											STRUCT_REF(BgL_ufz00_16274, (int) (((long) 1)));
										BgL_sfz00_16277 =
											STRUCT_REF(BgL_ufz00_16274, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16275) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2418z00_16278;

													BgL_arg2418z00_16278 =
														((long) CINT(BgL_bpz00_16268) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13851), BgL_arg2418z00_16278,
														BgL_a1z00_16270);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2419z00_16279;

													BgL_arg2419z00_16279 =
														((long) CINT(BgL_bpz00_16268) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13851), BgL_arg2419z00_16279,
														BgL_a2z00_16271);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2420z00_16280;

													BgL_arg2420z00_16280 =
														((long) CINT(BgL_bpz00_16268) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13851), BgL_arg2420z00_16280,
														BgL_a3z00_16272);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2421z00_16281;

													BgL_arg2421z00_16281 =
														((long) CINT(BgL_bpz00_16268) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_13851), BgL_arg2421z00_16281,
														BgL_a4z00_16273);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_16275))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_16275))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2423z00_16282;
																	obj_t BgL_arg2424z00_16283;

																	BgL_arg2423z00_16282 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2425z00_16284;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2426z00_16285;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2428z00_16286;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2430z00_16287;

																					BgL_arg2430z00_16287 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16273,
																						BNIL);
																					BgL_arg2428z00_16286 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16272,
																						BgL_arg2430z00_16287);
																				}
																				BgL_arg2426z00_16285 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16271,
																					BgL_arg2428z00_16286);
																			}
																			BgL_list2425z00_16284 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16270,
																				BgL_arg2426z00_16285);
																		}
																		BgL_arg2424z00_16283 =
																			BgL_list2425z00_16284;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2423z00_16282, BgL_arg2424z00_16283);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2431z00_16288;

																	BgL_arg2431z00_16288 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2431z00_16288, BgL_a1z00_16270);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2432z00_16289;
																	obj_t BgL_arg2433z00_16290;

																	BgL_arg2432z00_16289 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2434z00_16291;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2436z00_16292;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2437z00_16293;

																				BgL_arg2437z00_16293 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16273,
																					BNIL);
																				BgL_arg2436z00_16292 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16272,
																					BgL_arg2437z00_16293);
																			}
																			BgL_list2434z00_16291 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16271,
																				BgL_arg2436z00_16292);
																		}
																		BgL_arg2433z00_16290 =
																			BgL_list2434z00_16291;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2432z00_16289, BgL_arg2433z00_16290);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2439z00_16294;

																	BgL_arg2439z00_16294 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2439z00_16294, BgL_a1z00_16270);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2440z00_16295;

																	BgL_arg2440z00_16295 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2440z00_16295, BgL_a2z00_16271);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2441z00_16296;
																	obj_t BgL_arg2442z00_16297;

																	BgL_arg2441z00_16296 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2443z00_16298;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2444z00_16299;

																			BgL_arg2444z00_16299 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16273, BNIL);
																			BgL_list2443z00_16298 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16272,
																				BgL_arg2444z00_16299);
																		}
																		BgL_arg2442z00_16297 =
																			BgL_list2443z00_16298;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2441z00_16296, BgL_arg2442z00_16297);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2445z00_16300;

																	BgL_arg2445z00_16300 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2445z00_16300, BgL_a1z00_16270);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2446z00_16301;

																	BgL_arg2446z00_16301 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2446z00_16301, BgL_a2z00_16271);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2447z00_16302;

																	BgL_arg2447z00_16302 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2447z00_16302, BgL_a3z00_16272);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2448z00_16303;
																	obj_t BgL_arg2449z00_16304;

																	BgL_arg2448z00_16303 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2450z00_16305;

																		BgL_list2450z00_16305 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_16273, BNIL);
																		BgL_arg2449z00_16304 =
																			BgL_list2450z00_16305;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2448z00_16303, BgL_arg2449z00_16304);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2451z00_16306;

																	BgL_arg2451z00_16306 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2451z00_16306, BgL_a1z00_16270);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2453z00_16307;

																	BgL_arg2453z00_16307 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2453z00_16307, BgL_a2z00_16271);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2454z00_16308;

																	BgL_arg2454z00_16308 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2454z00_16308, BgL_a3z00_16272);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2455z00_16309;

																	BgL_arg2455z00_16309 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2455z00_16309, BgL_a4z00_16273);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2456z00_16310;
																	obj_t BgL_arg2457z00_16311;

																	BgL_arg2456z00_16310 =
																		((long) CINT(BgL_bpz00_16268) + ((long) 4));
																	BgL_arg2457z00_16311 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13851),
																		BgL_arg2456z00_16310, BgL_arg2457z00_16311);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13848, STRUCT_REF(BgL_ufz00_16274,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_16275));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13848, STRUCT_REF(BgL_ufz00_16274,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_16275));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_16312;

											BgL_z12denvz12_16312 = BGL_CURRENT_DYNAMIC_ENV();
											BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16312,
												BgL_locz00_13848);
											if ((((long) CINT(BgL_bpz00_16268) +
														(long) CINT(BgL_sfz00_16277)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13851))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_16276;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_16313;

													BgL_nsz00_16313 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2461z00_16314;

														BgL_arg2461z00_16314 =
															((long) CINT(BgL_bpz00_16268) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16313, ((long) 2), BgL_sz00_13851,
															BgL_bpz00_16268, BINT(BgL_arg2461z00_16314));
													}
													VECTOR_SET(BgL_nsz00_16313, ((long) 1),
														BgL_sz00_13851);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16312,
														BgL_nsz00_16313);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_16315;

														BgL_ez00_16315 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16315, BgL_sz00_13851);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_16316;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_16317;

																BgL_savedzd2bpzd2_16317 =
																	VECTOR_REF(BgL_nsz00_16313, ((long) 0));
																VECTOR_SET(BgL_nsz00_16313, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16319;

																	BgL_fz00_16319 = BgL_runz00_16276;
																BgL_recz00_16318:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_16320;

																		BgL_rz00_16320 =
																			PROCEDURE_ENTRY(BgL_fz00_16319)
																			(BgL_fz00_16319, BgL_nsz00_16313, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6416z00_23048;

																			if (PROCEDUREP(BgL_rz00_16320))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_16321;

																					BgL_arg1732z00_16321 =
																						PROCEDURE_ATTR(BgL_rz00_16320);
																					if (STRUCTP(BgL_arg1732z00_16321))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6416z00_23048 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_16321) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6416z00_23048 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6416z00_23048 = ((bool_t) 0);
																				}
																			if (BgL_test6416z00_23048)
																				{
																					obj_t BgL_fz00_23056;

																					BgL_fz00_23056 = BgL_rz00_16320;
																					BgL_fz00_16319 = BgL_fz00_23056;
																					goto BgL_recz00_16318;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_16313,
																						((long) 0),
																						BgL_savedzd2bpzd2_16317);
																					BgL_____rz00_16316 = BgL_rz00_16320;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16315);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16312,
																BgL_sz00_13851);
															return BgL_____rz00_16316;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16269,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16322;

												BgL_nbpz00_16322 =
													((long) CINT(BgL_bpz00_16268) + BgL_siza7eza7_13850);
												VECTOR_SET(
													((obj_t) BgL_sz00_13851), ((long) 0),
													BINT(BgL_nbpz00_16322));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_23068;

													BgL_tmpz00_23068 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_23068,
														BgL_locz00_13848);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16323;

													BgL_rz00_16323 =
														PROCEDURE_ENTRY(BgL_fz00_16269) (BgL_fz00_16269,
														BgL_a1z00_16270, BgL_a2z00_16271, BgL_a3z00_16272,
														BgL_a4z00_16273, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13851), ((long) 0),
														BgL_bpz00_16268);
													return BgL_rz00_16323;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13848,
													BgL_symbzd2funzd2_13849, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16269));
		}}}}}}}}

	}



/* &<@anonymous:2465> */
	obj_t BGl_z62zc3z04anonymousza32465ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13852, obj_t BgL_sz00_13861)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13853;
				obj_t BgL_a1z00_13854;
				obj_t BgL_a2z00_13855;
				obj_t BgL_a3z00_13856;
				obj_t BgL_a4z00_13857;
				obj_t BgL_locz00_13858;
				obj_t BgL_symbzd2funzd2_13859;
				long BgL_siza7eza7_13860;

				BgL_funz00_13853 = PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 0)));
				BgL_a1z00_13854 = PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 1)));
				BgL_a2z00_13855 = PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 2)));
				BgL_a3z00_13856 = PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 3)));
				BgL_a4z00_13857 = PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 4)));
				BgL_locz00_13858 = PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 5)));
				BgL_symbzd2funzd2_13859 =
					PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 6)));
				BgL_siza7eza7_13860 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13852, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16324;

					BgL_bpz00_16324 = VECTOR_REF(((obj_t) BgL_sz00_13861), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16325;
						obj_t BgL_a1z00_16326;
						obj_t BgL_a2z00_16327;
						obj_t BgL_a3z00_16328;
						obj_t BgL_a4z00_16329;

						BgL_fz00_16325 =
							PROCEDURE_ENTRY(BgL_funz00_13853) (BgL_funz00_13853,
							BgL_sz00_13861, BEOA);
						BgL_a1z00_16326 =
							PROCEDURE_ENTRY(BgL_a1z00_13854) (BgL_a1z00_13854, BgL_sz00_13861,
							BEOA);
						BgL_a2z00_16327 =
							PROCEDURE_ENTRY(BgL_a2z00_13855) (BgL_a2z00_13855, BgL_sz00_13861,
							BEOA);
						BgL_a3z00_16328 =
							PROCEDURE_ENTRY(BgL_a3z00_13856) (BgL_a3z00_13856, BgL_sz00_13861,
							BEOA);
						BgL_a4z00_16329 =
							PROCEDURE_ENTRY(BgL_a4z00_13857) (BgL_a4z00_13857, BgL_sz00_13861,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16325))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13858,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16325);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16330;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_23125;

								BgL_tmpz00_23125 = ((obj_t) BgL_fz00_16325);
								BgL_ufz00_16330 = PROCEDURE_ATTR(BgL_tmpz00_23125);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6421z00_23128;

								if (STRUCTP(BgL_ufz00_16330))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6421z00_23128 =
											(STRUCT_KEY(BgL_ufz00_16330) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6421z00_23128 = ((bool_t) 0);
									}
								if (BgL_test6421z00_23128)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16331;
										obj_t BgL_runz00_16332;
										obj_t BgL_sfz00_16333;

										BgL_arityz00_16331 =
											STRUCT_REF(BgL_ufz00_16330, (int) (((long) 0)));
										BgL_runz00_16332 =
											STRUCT_REF(BgL_ufz00_16330, (int) (((long) 1)));
										BgL_sfz00_16333 =
											STRUCT_REF(BgL_ufz00_16330, (int) (((long) 2)));
										if (((long) CINT(BgL_arityz00_16331) == ((long) 4)))
											{	/* Eval/evaluate_comp.scm 896 */
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2470z00_16334;

													BgL_arg2470z00_16334 =
														((long) CINT(BgL_bpz00_16324) + ((long) 0));
													VECTOR_SET(
														((obj_t) BgL_sz00_13861), BgL_arg2470z00_16334,
														BgL_a1z00_16326);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2471z00_16335;

													BgL_arg2471z00_16335 =
														((long) CINT(BgL_bpz00_16324) + ((long) 1));
													VECTOR_SET(
														((obj_t) BgL_sz00_13861), BgL_arg2471z00_16335,
														BgL_a2z00_16327);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2473z00_16336;

													BgL_arg2473z00_16336 =
														((long) CINT(BgL_bpz00_16324) + ((long) 2));
													VECTOR_SET(
														((obj_t) BgL_sz00_13861), BgL_arg2473z00_16336,
														BgL_a3z00_16328);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													long BgL_arg2475z00_16337;

													BgL_arg2475z00_16337 =
														((long) CINT(BgL_bpz00_16324) + ((long) 3));
													VECTOR_SET(
														((obj_t) BgL_sz00_13861), BgL_arg2475z00_16337,
														BgL_a4z00_16329);
											}}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												if (INTEGERP(BgL_arityz00_16331))
													{	/* Eval/evaluate_comp.scm 896 */
														switch ((long) CINT(BgL_arityz00_16331))
															{
															case ((long) -1):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2478z00_16338;
																	obj_t BgL_arg2479z00_16339;

																	BgL_arg2478z00_16338 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 0));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2480z00_16340;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2481z00_16341;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2482z00_16342;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2483z00_16343;

																					BgL_arg2483z00_16343 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16329,
																						BNIL);
																					BgL_arg2482z00_16342 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16328,
																						BgL_arg2483z00_16343);
																				}
																				BgL_arg2481z00_16341 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16327,
																					BgL_arg2482z00_16342);
																			}
																			BgL_list2480z00_16340 =
																				MAKE_YOUNG_PAIR(BgL_a1z00_16326,
																				BgL_arg2481z00_16341);
																		}
																		BgL_arg2479z00_16339 =
																			BgL_list2480z00_16340;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2478z00_16338, BgL_arg2479z00_16339);
																} break;
															case ((long) -2):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2485z00_16344;

																	BgL_arg2485z00_16344 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2485z00_16344, BgL_a1z00_16326);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2487z00_16345;
																	obj_t BgL_arg2488z00_16346;

																	BgL_arg2487z00_16345 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 1));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2489z00_16347;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2490z00_16348;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2492z00_16349;

																				BgL_arg2492z00_16349 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16329,
																					BNIL);
																				BgL_arg2490z00_16348 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16328,
																					BgL_arg2492z00_16349);
																			}
																			BgL_list2489z00_16347 =
																				MAKE_YOUNG_PAIR(BgL_a2z00_16327,
																				BgL_arg2490z00_16348);
																		}
																		BgL_arg2488z00_16346 =
																			BgL_list2489z00_16347;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2487z00_16345, BgL_arg2488z00_16346);
																} break;
															case ((long) -3):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2494z00_16350;

																	BgL_arg2494z00_16350 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2494z00_16350, BgL_a1z00_16326);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2496z00_16351;

																	BgL_arg2496z00_16351 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2496z00_16351, BgL_a2z00_16327);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2497z00_16352;
																	obj_t BgL_arg2498z00_16353;

																	BgL_arg2497z00_16352 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 2));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2499z00_16354;

																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_arg2501z00_16355;

																			BgL_arg2501z00_16355 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16329, BNIL);
																			BgL_list2499z00_16354 =
																				MAKE_YOUNG_PAIR(BgL_a3z00_16328,
																				BgL_arg2501z00_16355);
																		}
																		BgL_arg2498z00_16353 =
																			BgL_list2499z00_16354;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2497z00_16352, BgL_arg2498z00_16353);
																} break;
															case ((long) -4):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2502z00_16356;

																	BgL_arg2502z00_16356 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2502z00_16356, BgL_a1z00_16326);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2506z00_16357;

																	BgL_arg2506z00_16357 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2506z00_16357, BgL_a2z00_16327);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2507z00_16358;

																	BgL_arg2507z00_16358 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2507z00_16358, BgL_a3z00_16328);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2508z00_16359;
																	obj_t BgL_arg2510z00_16360;

																	BgL_arg2508z00_16359 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 3));
																	{	/* Eval/evaluate_comp.scm 896 */
																		obj_t BgL_list2511z00_16361;

																		BgL_list2511z00_16361 =
																			MAKE_YOUNG_PAIR(BgL_a4z00_16329, BNIL);
																		BgL_arg2510z00_16360 =
																			BgL_list2511z00_16361;
																	}
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2508z00_16359, BgL_arg2510z00_16360);
																} break;
															case ((long) -5):

																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2512z00_16362;

																	BgL_arg2512z00_16362 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 0));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2512z00_16362, BgL_a1z00_16326);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2516z00_16363;

																	BgL_arg2516z00_16363 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 1));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2516z00_16363, BgL_a2z00_16327);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2517z00_16364;

																	BgL_arg2517z00_16364 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 2));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2517z00_16364, BgL_a3z00_16328);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2519z00_16365;

																	BgL_arg2519z00_16365 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 3));
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2519z00_16365, BgL_a4z00_16329);
																}
																{	/* Eval/evaluate_comp.scm 896 */
																	long BgL_arg2522z00_16366;
																	obj_t BgL_arg2523z00_16367;

																	BgL_arg2522z00_16366 =
																		((long) CINT(BgL_bpz00_16324) + ((long) 4));
																	BgL_arg2523z00_16367 = BNIL;
																	VECTOR_SET(
																		((obj_t) BgL_sz00_13861),
																		BgL_arg2522z00_16366, BgL_arg2523z00_16367);
																} break;
															default:
																BGl_evarityzd2errorzd2zz__everrorz00
																	(BgL_locz00_13858, STRUCT_REF(BgL_ufz00_16330,
																		(int) (((long) 3))), (int) (((long) 4)),
																	CINT(BgL_arityz00_16331));
													}}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														BGl_evarityzd2errorzd2zz__everrorz00
															(BgL_locz00_13858, STRUCT_REF(BgL_ufz00_16330,
																(int) (((long) 3))), (int) (((long) 4)),
															CINT(BgL_arityz00_16331));
											}}
										{	/* Eval/evaluate_comp.scm 896 */
											obj_t BgL_z12denvz12_16368;

											BgL_z12denvz12_16368 = BGL_CURRENT_DYNAMIC_ENV();
											if (
												(((long) CINT(BgL_bpz00_16324) +
														(long) CINT(BgL_sfz00_16333)) <
													VECTOR_LENGTH(((obj_t) BgL_sz00_13861))))
												{	/* Eval/evaluate_comp.scm 896 */
													return BgL_runz00_16332;
												}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_nsz00_16369;

													BgL_nsz00_16369 =
														BGl_makezd2statezd2zz__evaluate_compz00();
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2527z00_16370;

														BgL_arg2527z00_16370 =
															((long) CINT(BgL_bpz00_16324) + ((long) 4));
														BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
															(BgL_nsz00_16369, ((long) 2), BgL_sz00_13861,
															BgL_bpz00_16324, BINT(BgL_arg2527z00_16370));
													}
													VECTOR_SET(BgL_nsz00_16369, ((long) 1),
														BgL_sz00_13861);
													BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16368,
														BgL_nsz00_16369);
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_ez00_16371;

														BgL_ez00_16371 = BGL_EXITD_TOP_AS_OBJ();
														BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
															(BgL_ez00_16371, BgL_sz00_13861);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_____rz00_16372;

															{	/* Eval/evaluate_comp.scm 670 */
																obj_t BgL_savedzd2bpzd2_16373;

																BgL_savedzd2bpzd2_16373 =
																	VECTOR_REF(BgL_nsz00_16369, ((long) 0));
																VECTOR_SET(BgL_nsz00_16369, ((long) 0),
																	BINT(((long) 2)));
																{
																	obj_t BgL_fz00_16375;

																	BgL_fz00_16375 = BgL_runz00_16332;
																BgL_recz00_16374:
																	{	/* Eval/evaluate_comp.scm 673 */
																		obj_t BgL_rz00_16376;

																		BgL_rz00_16376 =
																			PROCEDURE_ENTRY(BgL_fz00_16375)
																			(BgL_fz00_16375, BgL_nsz00_16369, BEOA);
																		{	/* Eval/evaluate_comp.scm 674 */
																			bool_t BgL_test6426z00_23266;

																			if (PROCEDUREP(BgL_rz00_16376))
																				{	/* Eval/evaluate_comp.scm 674 */
																					obj_t BgL_arg1732z00_16377;

																					BgL_arg1732z00_16377 =
																						PROCEDURE_ATTR(BgL_rz00_16376);
																					if (STRUCTP(BgL_arg1732z00_16377))
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6426z00_23266 =
																								(STRUCT_KEY
																								(BgL_arg1732z00_16377) ==
																								BGl_symbol5843z00zz__evaluate_compz00);
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 654 */
																							BgL_test6426z00_23266 =
																								((bool_t) 0);
																						}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					BgL_test6426z00_23266 = ((bool_t) 0);
																				}
																			if (BgL_test6426z00_23266)
																				{
																					obj_t BgL_fz00_23274;

																					BgL_fz00_23274 = BgL_rz00_16376;
																					BgL_fz00_16375 = BgL_fz00_23274;
																					goto BgL_recz00_16374;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 674 */
																					VECTOR_SET(BgL_nsz00_16369,
																						((long) 0),
																						BgL_savedzd2bpzd2_16373);
																					BgL_____rz00_16372 = BgL_rz00_16376;
															}}}}}
															BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																(BgL_ez00_16371);
															BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16368,
																BgL_sz00_13861);
															return BgL_____rz00_16372;
														}
													}
												}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16325,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16378;

												BgL_nbpz00_16378 =
													((long) CINT(BgL_bpz00_16324) + BgL_siza7eza7_13860);
												VECTOR_SET(
													((obj_t) BgL_sz00_13861), ((long) 0),
													BINT(BgL_nbpz00_16378));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16379;

													BgL_rz00_16379 =
														PROCEDURE_ENTRY(BgL_fz00_16325) (BgL_fz00_16325,
														BgL_a1z00_16326, BgL_a2z00_16327, BgL_a3z00_16328,
														BgL_a4z00_16329, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13861), ((long) 0),
														BgL_bpz00_16324);
													return BgL_rz00_16379;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13858,
													BgL_symbzd2funzd2_13859, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16325));
		}}}}}}}}

	}



/* &<@anonymous:2533> */
	obj_t BGl_z62zc3z04anonymousza32533ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13862, obj_t BgL_sz00_13871)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13863;
				obj_t BgL_a1z00_13864;
				obj_t BgL_a2z00_13865;
				obj_t BgL_a3z00_13866;
				obj_t BgL_a4z00_13867;
				obj_t BgL_locz00_13868;
				obj_t BgL_symbzd2funzd2_13869;
				long BgL_siza7eza7_13870;

				BgL_funz00_13863 = PROCEDURE_REF(BgL_envz00_13862, (int) (((long) 0)));
				BgL_a1z00_13864 = PROCEDURE_REF(BgL_envz00_13862, (int) (((long) 1)));
				BgL_a2z00_13865 = PROCEDURE_REF(BgL_envz00_13862, (int) (((long) 2)));
				BgL_a3z00_13866 = PROCEDURE_REF(BgL_envz00_13862, (int) (((long) 3)));
				BgL_a4z00_13867 = PROCEDURE_REF(BgL_envz00_13862, (int) (((long) 4)));
				BgL_locz00_13868 = PROCEDURE_REF(BgL_envz00_13862, (int) (((long) 5)));
				BgL_symbzd2funzd2_13869 =
					PROCEDURE_REF(BgL_envz00_13862, (int) (((long) 6)));
				BgL_siza7eza7_13870 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13862, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16380;

					BgL_bpz00_16380 = VECTOR_REF(((obj_t) BgL_sz00_13871), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16381;
						obj_t BgL_a1z00_16382;
						obj_t BgL_a2z00_16383;
						obj_t BgL_a3z00_16384;
						obj_t BgL_a4z00_16385;

						BgL_fz00_16381 =
							PROCEDURE_ENTRY(BgL_funz00_13863) (BgL_funz00_13863,
							BgL_sz00_13871, BEOA);
						BgL_a1z00_16382 =
							PROCEDURE_ENTRY(BgL_a1z00_13864) (BgL_a1z00_13864, BgL_sz00_13871,
							BEOA);
						BgL_a2z00_16383 =
							PROCEDURE_ENTRY(BgL_a2z00_13865) (BgL_a2z00_13865, BgL_sz00_13871,
							BEOA);
						BgL_a3z00_16384 =
							PROCEDURE_ENTRY(BgL_a3z00_13866) (BgL_a3z00_13866, BgL_sz00_13871,
							BEOA);
						BgL_a4z00_16385 =
							PROCEDURE_ENTRY(BgL_a4z00_13867) (BgL_a4z00_13867, BgL_sz00_13871,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16381))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13868,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16381);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16386;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_23340;

								BgL_tmpz00_23340 = ((obj_t) BgL_fz00_16381);
								BgL_ufz00_16386 = PROCEDURE_ATTR(BgL_tmpz00_23340);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6431z00_23343;

								if (STRUCTP(BgL_ufz00_16386))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6431z00_23343 =
											(STRUCT_KEY(BgL_ufz00_16386) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6431z00_23343 = ((bool_t) 0);
									}
								if (BgL_test6431z00_23343)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16387;
										obj_t BgL_runz00_16388;
										obj_t BgL_sfz00_16389;

										BgL_arityz00_16387 =
											STRUCT_REF(BgL_ufz00_16386, (int) (((long) 0)));
										BgL_runz00_16388 =
											STRUCT_REF(BgL_ufz00_16386, (int) (((long) 1)));
										BgL_sfz00_16389 =
											STRUCT_REF(BgL_ufz00_16386, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16390;

											BgL_spz00_16390 =
												((long) CINT(BgL_bpz00_16380) + BgL_siza7eza7_13870);
											if (((long) CINT(BgL_arityz00_16387) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2537z00_16391;

														BgL_arg2537z00_16391 =
															(BgL_spz00_16390 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13871), BgL_arg2537z00_16391,
															BgL_a1z00_16382);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2538z00_16392;

														BgL_arg2538z00_16392 =
															(BgL_spz00_16390 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13871), BgL_arg2538z00_16392,
															BgL_a2z00_16383);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2539z00_16393;

														BgL_arg2539z00_16393 =
															(BgL_spz00_16390 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13871), BgL_arg2539z00_16393,
															BgL_a3z00_16384);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2540z00_16394;

														BgL_arg2540z00_16394 =
															(BgL_spz00_16390 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_13871), BgL_arg2540z00_16394,
															BgL_a4z00_16385);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16387))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16387))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2543z00_16395;
																		obj_t BgL_arg2544z00_16396;

																		BgL_arg2543z00_16395 =
																			(BgL_spz00_16390 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2545z00_16397;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2546z00_16398;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2549z00_16399;

																					{	/* Eval/evaluate_comp.scm 896 */
																						obj_t BgL_arg2550z00_16400;

																						BgL_arg2550z00_16400 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_16385,
																							BNIL);
																						BgL_arg2549z00_16399 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_16384,
																							BgL_arg2550z00_16400);
																					}
																					BgL_arg2546z00_16398 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16383,
																						BgL_arg2549z00_16399);
																				}
																				BgL_list2545z00_16397 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16382,
																					BgL_arg2546z00_16398);
																			}
																			BgL_arg2544z00_16396 =
																				BgL_list2545z00_16397;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2543z00_16395,
																			BgL_arg2544z00_16396);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2554z00_16401;

																		BgL_arg2554z00_16401 =
																			(BgL_spz00_16390 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2554z00_16401, BgL_a1z00_16382);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2557z00_16402;
																		obj_t BgL_arg2558z00_16403;

																		BgL_arg2557z00_16402 =
																			(BgL_spz00_16390 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2559z00_16404;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2560z00_16405;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2561z00_16406;

																					BgL_arg2561z00_16406 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16385,
																						BNIL);
																					BgL_arg2560z00_16405 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16384,
																						BgL_arg2561z00_16406);
																				}
																				BgL_list2559z00_16404 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16383,
																					BgL_arg2560z00_16405);
																			}
																			BgL_arg2558z00_16403 =
																				BgL_list2559z00_16404;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2557z00_16402,
																			BgL_arg2558z00_16403);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2562z00_16407;

																		BgL_arg2562z00_16407 =
																			(BgL_spz00_16390 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2562z00_16407, BgL_a1z00_16382);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2563z00_16408;

																		BgL_arg2563z00_16408 =
																			(BgL_spz00_16390 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2563z00_16408, BgL_a2z00_16383);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2564z00_16409;
																		obj_t BgL_arg2565z00_16410;

																		BgL_arg2564z00_16409 =
																			(BgL_spz00_16390 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2566z00_16411;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2567z00_16412;

																				BgL_arg2567z00_16412 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16385,
																					BNIL);
																				BgL_list2566z00_16411 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16384,
																					BgL_arg2567z00_16412);
																			}
																			BgL_arg2565z00_16410 =
																				BgL_list2566z00_16411;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2564z00_16409,
																			BgL_arg2565z00_16410);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2568z00_16413;

																		BgL_arg2568z00_16413 =
																			(BgL_spz00_16390 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2568z00_16413, BgL_a1z00_16382);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2569z00_16414;

																		BgL_arg2569z00_16414 =
																			(BgL_spz00_16390 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2569z00_16414, BgL_a2z00_16383);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2570z00_16415;

																		BgL_arg2570z00_16415 =
																			(BgL_spz00_16390 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2570z00_16415, BgL_a3z00_16384);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2571z00_16416;
																		obj_t BgL_arg2572z00_16417;

																		BgL_arg2571z00_16416 =
																			(BgL_spz00_16390 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2573z00_16418;

																			BgL_list2573z00_16418 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16385, BNIL);
																			BgL_arg2572z00_16417 =
																				BgL_list2573z00_16418;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2571z00_16416,
																			BgL_arg2572z00_16417);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2574z00_16419;

																		BgL_arg2574z00_16419 =
																			(BgL_spz00_16390 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2574z00_16419, BgL_a1z00_16382);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2575z00_16420;

																		BgL_arg2575z00_16420 =
																			(BgL_spz00_16390 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2575z00_16420, BgL_a2z00_16383);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2577z00_16421;

																		BgL_arg2577z00_16421 =
																			(BgL_spz00_16390 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2577z00_16421, BgL_a3z00_16384);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2578z00_16422;

																		BgL_arg2578z00_16422 =
																			(BgL_spz00_16390 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2578z00_16422, BgL_a4z00_16385);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2580z00_16423;
																		obj_t BgL_arg2581z00_16424;

																		BgL_arg2580z00_16423 =
																			(BgL_spz00_16390 + ((long) 4));
																		BgL_arg2581z00_16424 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13871),
																			BgL_arg2580z00_16423,
																			BgL_arg2581z00_16424);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13868,
																		STRUCT_REF(BgL_ufz00_16386,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_16387));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13868, STRUCT_REF(BgL_ufz00_16386,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_16387));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16425;

												BgL_z12denvz12_16425 = BGL_CURRENT_DYNAMIC_ENV();
												BGL_ENV_SET_TRACE_LOCATION(BgL_z12denvz12_16425,
													BgL_locz00_13868);
												if (((BgL_spz00_16390 + (long) CINT(BgL_sfz00_16389)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13871))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16388, BgL_sz00_13871,
															BINT(BgL_spz00_16390));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16426;

														BgL_nsz00_16426 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2585z00_16427;

															BgL_arg2585z00_16427 =
																(BgL_spz00_16390 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16426, ((long) 2), BgL_sz00_13871,
																BINT(BgL_spz00_16390),
																BINT(BgL_arg2585z00_16427));
														}
														VECTOR_SET(BgL_nsz00_16426, ((long) 1),
															BgL_sz00_13871);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16425,
															BgL_nsz00_16426);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16428;

															BgL_ez00_16428 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16428, BgL_sz00_13871);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16429;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16430;

																	BgL_savedzd2bpzd2_16430 =
																		VECTOR_REF(BgL_nsz00_16426, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16426, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16432;

																		BgL_fz00_16432 = BgL_runz00_16388;
																	BgL_recz00_16431:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16433;

																			BgL_rz00_16433 =
																				PROCEDURE_ENTRY(BgL_fz00_16432)
																				(BgL_fz00_16432, BgL_nsz00_16426, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6436z00_23466;

																				if (PROCEDUREP(BgL_rz00_16433))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_16434;

																						BgL_arg1732z00_16434 =
																							PROCEDURE_ATTR(BgL_rz00_16433);
																						if (STRUCTP(BgL_arg1732z00_16434))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6436z00_23466 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_16434) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6436z00_23466 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6436z00_23466 =
																							((bool_t) 0);
																					}
																				if (BgL_test6436z00_23466)
																					{
																						obj_t BgL_fz00_23474;

																						BgL_fz00_23474 = BgL_rz00_16433;
																						BgL_fz00_16432 = BgL_fz00_23474;
																						goto BgL_recz00_16431;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16426,
																							((long) 0),
																							BgL_savedzd2bpzd2_16430);
																						BgL_____rz00_16429 = BgL_rz00_16433;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16428);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16425,
																	BgL_sz00_13871);
																return BgL_____rz00_16429;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16381,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16435;

												BgL_nbpz00_16435 =
													((long) CINT(BgL_bpz00_16380) + BgL_siza7eza7_13870);
												VECTOR_SET(
													((obj_t) BgL_sz00_13871), ((long) 0),
													BINT(BgL_nbpz00_16435));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_tmpz00_23486;

													BgL_tmpz00_23486 = BGL_CURRENT_DYNAMIC_ENV();
													BGL_ENV_SET_TRACE_LOCATION(BgL_tmpz00_23486,
														BgL_locz00_13868);
												}
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16436;

													BgL_rz00_16436 =
														PROCEDURE_ENTRY(BgL_fz00_16381) (BgL_fz00_16381,
														BgL_a1z00_16382, BgL_a2z00_16383, BgL_a3z00_16384,
														BgL_a4z00_16385, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13871), ((long) 0),
														BgL_bpz00_16380);
													return BgL_rz00_16436;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13868,
													BgL_symbzd2funzd2_13869, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16381));
		}}}}}}}}

	}



/* &<@anonymous:2589> */
	obj_t BGl_z62zc3z04anonymousza32589ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13872, obj_t BgL_sz00_13881)
	{
		{	/* Eval/evaluate_comp.scm 896 */
			{	/* Eval/evaluate_comp.scm 896 */
				obj_t BgL_funz00_13873;
				obj_t BgL_a1z00_13874;
				obj_t BgL_a2z00_13875;
				obj_t BgL_a3z00_13876;
				obj_t BgL_a4z00_13877;
				obj_t BgL_locz00_13878;
				obj_t BgL_symbzd2funzd2_13879;
				long BgL_siza7eza7_13880;

				BgL_funz00_13873 = PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 0)));
				BgL_a1z00_13874 = PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 1)));
				BgL_a2z00_13875 = PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 2)));
				BgL_a3z00_13876 = PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 3)));
				BgL_a4z00_13877 = PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 4)));
				BgL_locz00_13878 = PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 5)));
				BgL_symbzd2funzd2_13879 =
					PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 6)));
				BgL_siza7eza7_13880 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_13872, (int) (((long) 7))));
				{	/* Eval/evaluate_comp.scm 896 */
					obj_t BgL_bpz00_16437;

					BgL_bpz00_16437 = VECTOR_REF(((obj_t) BgL_sz00_13881), ((long) 0));
					{	/* Eval/evaluate_comp.scm 896 */
						obj_t BgL_fz00_16438;
						obj_t BgL_a1z00_16439;
						obj_t BgL_a2z00_16440;
						obj_t BgL_a3z00_16441;
						obj_t BgL_a4z00_16442;

						BgL_fz00_16438 =
							PROCEDURE_ENTRY(BgL_funz00_13873) (BgL_funz00_13873,
							BgL_sz00_13881, BEOA);
						BgL_a1z00_16439 =
							PROCEDURE_ENTRY(BgL_a1z00_13874) (BgL_a1z00_13874, BgL_sz00_13881,
							BEOA);
						BgL_a2z00_16440 =
							PROCEDURE_ENTRY(BgL_a2z00_13875) (BgL_a2z00_13875, BgL_sz00_13881,
							BEOA);
						BgL_a3z00_16441 =
							PROCEDURE_ENTRY(BgL_a3z00_13876) (BgL_a3z00_13876, BgL_sz00_13881,
							BEOA);
						BgL_a4z00_16442 =
							PROCEDURE_ENTRY(BgL_a4z00_13877) (BgL_a4z00_13877, BgL_sz00_13881,
							BEOA);
						if (PROCEDUREP(BgL_fz00_16438))
							{	/* Eval/evaluate_comp.scm 896 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 896 */
								BGl_evtypezd2errorzd2zz__everrorz00(BgL_locz00_13878,
									BGl_string5847z00zz__evaluate_compz00,
									BGl_string5863z00zz__evaluate_compz00, BgL_fz00_16438);
							}
						{	/* Eval/evaluate_comp.scm 896 */
							obj_t BgL_ufz00_16443;

							{	/* Eval/evaluate_comp.scm 896 */
								obj_t BgL_tmpz00_23543;

								BgL_tmpz00_23543 = ((obj_t) BgL_fz00_16438);
								BgL_ufz00_16443 = PROCEDURE_ATTR(BgL_tmpz00_23543);
							}
							{	/* Eval/evaluate_comp.scm 896 */
								bool_t BgL_test6441z00_23546;

								if (STRUCTP(BgL_ufz00_16443))
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6441z00_23546 =
											(STRUCT_KEY(BgL_ufz00_16443) ==
											BGl_symbol5864z00zz__evaluate_compz00);
									}
								else
									{	/* Eval/evaluate_comp.scm 683 */
										BgL_test6441z00_23546 = ((bool_t) 0);
									}
								if (BgL_test6441z00_23546)
									{	/* Eval/evaluate_comp.scm 896 */
										obj_t BgL_arityz00_16444;
										obj_t BgL_runz00_16445;
										obj_t BgL_sfz00_16446;

										BgL_arityz00_16444 =
											STRUCT_REF(BgL_ufz00_16443, (int) (((long) 0)));
										BgL_runz00_16445 =
											STRUCT_REF(BgL_ufz00_16443, (int) (((long) 1)));
										BgL_sfz00_16446 =
											STRUCT_REF(BgL_ufz00_16443, (int) (((long) 2)));
										{	/* Eval/evaluate_comp.scm 896 */
											long BgL_spz00_16447;

											BgL_spz00_16447 =
												((long) CINT(BgL_bpz00_16437) + BgL_siza7eza7_13880);
											if (((long) CINT(BgL_arityz00_16444) == ((long) 4)))
												{	/* Eval/evaluate_comp.scm 896 */
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2593z00_16448;

														BgL_arg2593z00_16448 =
															(BgL_spz00_16447 + ((long) 0));
														VECTOR_SET(
															((obj_t) BgL_sz00_13881), BgL_arg2593z00_16448,
															BgL_a1z00_16439);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2594z00_16449;

														BgL_arg2594z00_16449 =
															(BgL_spz00_16447 + ((long) 1));
														VECTOR_SET(
															((obj_t) BgL_sz00_13881), BgL_arg2594z00_16449,
															BgL_a2z00_16440);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2595z00_16450;

														BgL_arg2595z00_16450 =
															(BgL_spz00_16447 + ((long) 2));
														VECTOR_SET(
															((obj_t) BgL_sz00_13881), BgL_arg2595z00_16450,
															BgL_a3z00_16441);
													}
													{	/* Eval/evaluate_comp.scm 896 */
														long BgL_arg2596z00_16451;

														BgL_arg2596z00_16451 =
															(BgL_spz00_16447 + ((long) 3));
														VECTOR_SET(
															((obj_t) BgL_sz00_13881), BgL_arg2596z00_16451,
															BgL_a4z00_16442);
												}}
											else
												{	/* Eval/evaluate_comp.scm 896 */
													if (INTEGERP(BgL_arityz00_16444))
														{	/* Eval/evaluate_comp.scm 896 */
															switch ((long) CINT(BgL_arityz00_16444))
																{
																case ((long) -1):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2598z00_16452;
																		obj_t BgL_arg2600z00_16453;

																		BgL_arg2598z00_16452 =
																			(BgL_spz00_16447 + ((long) 0));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2601z00_16454;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2602z00_16455;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2603z00_16456;

																					{	/* Eval/evaluate_comp.scm 896 */
																						obj_t BgL_arg2604z00_16457;

																						BgL_arg2604z00_16457 =
																							MAKE_YOUNG_PAIR(BgL_a4z00_16442,
																							BNIL);
																						BgL_arg2603z00_16456 =
																							MAKE_YOUNG_PAIR(BgL_a3z00_16441,
																							BgL_arg2604z00_16457);
																					}
																					BgL_arg2602z00_16455 =
																						MAKE_YOUNG_PAIR(BgL_a2z00_16440,
																						BgL_arg2603z00_16456);
																				}
																				BgL_list2601z00_16454 =
																					MAKE_YOUNG_PAIR(BgL_a1z00_16439,
																					BgL_arg2602z00_16455);
																			}
																			BgL_arg2600z00_16453 =
																				BgL_list2601z00_16454;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2598z00_16452,
																			BgL_arg2600z00_16453);
																	} break;
																case ((long) -2):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2605z00_16458;

																		BgL_arg2605z00_16458 =
																			(BgL_spz00_16447 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2605z00_16458, BgL_a1z00_16439);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2608z00_16459;
																		obj_t BgL_arg2609z00_16460;

																		BgL_arg2608z00_16459 =
																			(BgL_spz00_16447 + ((long) 1));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2610z00_16461;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2611z00_16462;

																				{	/* Eval/evaluate_comp.scm 896 */
																					obj_t BgL_arg2612z00_16463;

																					BgL_arg2612z00_16463 =
																						MAKE_YOUNG_PAIR(BgL_a4z00_16442,
																						BNIL);
																					BgL_arg2611z00_16462 =
																						MAKE_YOUNG_PAIR(BgL_a3z00_16441,
																						BgL_arg2612z00_16463);
																				}
																				BgL_list2610z00_16461 =
																					MAKE_YOUNG_PAIR(BgL_a2z00_16440,
																					BgL_arg2611z00_16462);
																			}
																			BgL_arg2609z00_16460 =
																				BgL_list2610z00_16461;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2608z00_16459,
																			BgL_arg2609z00_16460);
																	} break;
																case ((long) -3):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2613z00_16464;

																		BgL_arg2613z00_16464 =
																			(BgL_spz00_16447 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2613z00_16464, BgL_a1z00_16439);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2614z00_16465;

																		BgL_arg2614z00_16465 =
																			(BgL_spz00_16447 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2614z00_16465, BgL_a2z00_16440);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2615z00_16466;
																		obj_t BgL_arg2616z00_16467;

																		BgL_arg2615z00_16466 =
																			(BgL_spz00_16447 + ((long) 2));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2617z00_16468;

																			{	/* Eval/evaluate_comp.scm 896 */
																				obj_t BgL_arg2618z00_16469;

																				BgL_arg2618z00_16469 =
																					MAKE_YOUNG_PAIR(BgL_a4z00_16442,
																					BNIL);
																				BgL_list2617z00_16468 =
																					MAKE_YOUNG_PAIR(BgL_a3z00_16441,
																					BgL_arg2618z00_16469);
																			}
																			BgL_arg2616z00_16467 =
																				BgL_list2617z00_16468;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2615z00_16466,
																			BgL_arg2616z00_16467);
																	} break;
																case ((long) -4):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2620z00_16470;

																		BgL_arg2620z00_16470 =
																			(BgL_spz00_16447 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2620z00_16470, BgL_a1z00_16439);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2621z00_16471;

																		BgL_arg2621z00_16471 =
																			(BgL_spz00_16447 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2621z00_16471, BgL_a2z00_16440);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2622z00_16472;

																		BgL_arg2622z00_16472 =
																			(BgL_spz00_16447 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2622z00_16472, BgL_a3z00_16441);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2623z00_16473;
																		obj_t BgL_arg2624z00_16474;

																		BgL_arg2623z00_16473 =
																			(BgL_spz00_16447 + ((long) 3));
																		{	/* Eval/evaluate_comp.scm 896 */
																			obj_t BgL_list2625z00_16475;

																			BgL_list2625z00_16475 =
																				MAKE_YOUNG_PAIR(BgL_a4z00_16442, BNIL);
																			BgL_arg2624z00_16474 =
																				BgL_list2625z00_16475;
																		}
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2623z00_16473,
																			BgL_arg2624z00_16474);
																	} break;
																case ((long) -5):

																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2626z00_16476;

																		BgL_arg2626z00_16476 =
																			(BgL_spz00_16447 + ((long) 0));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2626z00_16476, BgL_a1z00_16439);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2627z00_16477;

																		BgL_arg2627z00_16477 =
																			(BgL_spz00_16447 + ((long) 1));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2627z00_16477, BgL_a2z00_16440);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2628z00_16478;

																		BgL_arg2628z00_16478 =
																			(BgL_spz00_16447 + ((long) 2));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2628z00_16478, BgL_a3z00_16441);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2631z00_16479;

																		BgL_arg2631z00_16479 =
																			(BgL_spz00_16447 + ((long) 3));
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2631z00_16479, BgL_a4z00_16442);
																	}
																	{	/* Eval/evaluate_comp.scm 896 */
																		long BgL_arg2633z00_16480;
																		obj_t BgL_arg2634z00_16481;

																		BgL_arg2633z00_16480 =
																			(BgL_spz00_16447 + ((long) 4));
																		BgL_arg2634z00_16481 = BNIL;
																		VECTOR_SET(
																			((obj_t) BgL_sz00_13881),
																			BgL_arg2633z00_16480,
																			BgL_arg2634z00_16481);
																	} break;
																default:
																	BGl_evarityzd2errorzd2zz__everrorz00
																		(BgL_locz00_13878,
																		STRUCT_REF(BgL_ufz00_16443,
																			(int) (((long) 3))), (int) (((long) 4)),
																		CINT(BgL_arityz00_16444));
														}}
													else
														{	/* Eval/evaluate_comp.scm 896 */
															BGl_evarityzd2errorzd2zz__everrorz00
																(BgL_locz00_13878, STRUCT_REF(BgL_ufz00_16443,
																	(int) (((long) 3))), (int) (((long) 4)),
																CINT(BgL_arityz00_16444));
												}}
											{	/* Eval/evaluate_comp.scm 896 */
												obj_t BgL_z12denvz12_16482;

												BgL_z12denvz12_16482 = BGL_CURRENT_DYNAMIC_ENV();
												if (
													((BgL_spz00_16447 +
															(long) CINT(BgL_sfz00_16446)) <
														VECTOR_LENGTH(((obj_t) BgL_sz00_13881))))
													{	/* Eval/evaluate_comp.scm 896 */
														return
															BGl_catchzd2trampolinezd2zz__evaluate_compz00
															(BgL_runz00_16445, BgL_sz00_13881,
															BINT(BgL_spz00_16447));
													}
												else
													{	/* Eval/evaluate_comp.scm 896 */
														obj_t BgL_nsz00_16483;

														BgL_nsz00_16483 =
															BGl_makezd2statezd2zz__evaluate_compz00();
														{	/* Eval/evaluate_comp.scm 896 */
															long BgL_arg2639z00_16484;

															BgL_arg2639z00_16484 =
																(BgL_spz00_16447 + ((long) 4));
															BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00
																(BgL_nsz00_16483, ((long) 2), BgL_sz00_13881,
																BINT(BgL_spz00_16447),
																BINT(BgL_arg2639z00_16484));
														}
														VECTOR_SET(BgL_nsz00_16483, ((long) 1),
															BgL_sz00_13881);
														BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16482,
															BgL_nsz00_16483);
														{	/* Eval/evaluate_comp.scm 896 */
															obj_t BgL_ez00_16485;

															BgL_ez00_16485 = BGL_EXITD_TOP_AS_OBJ();
															BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
																(BgL_ez00_16485, BgL_sz00_13881);
															{	/* Eval/evaluate_comp.scm 896 */
																obj_t BgL_____rz00_16486;

																{	/* Eval/evaluate_comp.scm 670 */
																	obj_t BgL_savedzd2bpzd2_16487;

																	BgL_savedzd2bpzd2_16487 =
																		VECTOR_REF(BgL_nsz00_16483, ((long) 0));
																	VECTOR_SET(BgL_nsz00_16483, ((long) 0),
																		BINT(((long) 2)));
																	{
																		obj_t BgL_fz00_16489;

																		BgL_fz00_16489 = BgL_runz00_16445;
																	BgL_recz00_16488:
																		{	/* Eval/evaluate_comp.scm 673 */
																			obj_t BgL_rz00_16490;

																			BgL_rz00_16490 =
																				PROCEDURE_ENTRY(BgL_fz00_16489)
																				(BgL_fz00_16489, BgL_nsz00_16483, BEOA);
																			{	/* Eval/evaluate_comp.scm 674 */
																				bool_t BgL_test6446z00_23668;

																				if (PROCEDUREP(BgL_rz00_16490))
																					{	/* Eval/evaluate_comp.scm 674 */
																						obj_t BgL_arg1732z00_16491;

																						BgL_arg1732z00_16491 =
																							PROCEDURE_ATTR(BgL_rz00_16490);
																						if (STRUCTP(BgL_arg1732z00_16491))
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6446z00_23668 =
																									(STRUCT_KEY
																									(BgL_arg1732z00_16491) ==
																									BGl_symbol5843z00zz__evaluate_compz00);
																							}
																						else
																							{	/* Eval/evaluate_comp.scm 654 */
																								BgL_test6446z00_23668 =
																									((bool_t) 0);
																							}
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						BgL_test6446z00_23668 =
																							((bool_t) 0);
																					}
																				if (BgL_test6446z00_23668)
																					{
																						obj_t BgL_fz00_23676;

																						BgL_fz00_23676 = BgL_rz00_16490;
																						BgL_fz00_16489 = BgL_fz00_23676;
																						goto BgL_recz00_16488;
																					}
																				else
																					{	/* Eval/evaluate_comp.scm 674 */
																						VECTOR_SET(BgL_nsz00_16483,
																							((long) 0),
																							BgL_savedzd2bpzd2_16487);
																						BgL_____rz00_16486 = BgL_rz00_16490;
																}}}}}
																BGl_exitdzd2popzd2protectz12z12zz__bexitz00
																	(BgL_ez00_16485);
																BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16482,
																	BgL_sz00_13881);
																return BgL_____rz00_16486;
															}
														}
													}
											}
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 896 */
										if (PROCEDURE_CORRECT_ARITYP(BgL_fz00_16438,
												(int) (((long) 4))))
											{	/* Eval/evaluate_comp.scm 896 */
												long BgL_nbpz00_16492;

												BgL_nbpz00_16492 =
													((long) CINT(BgL_bpz00_16437) + BgL_siza7eza7_13880);
												VECTOR_SET(
													((obj_t) BgL_sz00_13881), ((long) 0),
													BINT(BgL_nbpz00_16492));
												{	/* Eval/evaluate_comp.scm 896 */
													obj_t BgL_rz00_16493;

													BgL_rz00_16493 =
														PROCEDURE_ENTRY(BgL_fz00_16438) (BgL_fz00_16438,
														BgL_a1z00_16439, BgL_a2z00_16440, BgL_a3z00_16441,
														BgL_a4z00_16442, BEOA);
													VECTOR_SET(((obj_t) BgL_sz00_13881), ((long) 0),
														BgL_bpz00_16437);
													return BgL_rz00_16493;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 896 */
												return
													BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_13878,
													BgL_symbzd2funzd2_13879, (int) (((long) 4)),
													PROCEDURE_ARITY(BgL_fz00_16438));
		}}}}}}}}

	}



/* is-constant-fun? */
	obj_t BGl_iszd2constantzd2funzf3zf3zz__evaluate_compz00(BgL_ev_exprz00_bglt
		BgL_funz00_183, long BgL_nbargsz00_184, obj_t BgL_locz00_185,
		obj_t BgL_symbzd2funzd2_186)
	{
		{	/* Eval/evaluate_comp.scm 899 */
			if (BGl_isazf3zf3zz__objectz00(
					((obj_t) BgL_funz00_183), BGl_ev_globalz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 903 */
					obj_t BgL_gz00_3033;

					{	/* Eval/evaluate_comp.scm 903 */
						obj_t BgL_arg2650z00_3041;
						obj_t BgL_arg2651z00_3042;

						BgL_arg2650z00_3041 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_modz00);
						BgL_arg2651z00_3042 =
							(((BgL_ev_globalz00_bglt) COBJECT(
									((BgL_ev_globalz00_bglt) BgL_funz00_183)))->BgL_namez00);
						BgL_gz00_3033 =
							BGl_evmodulezd2findzd2globalz00zz__evmodulez00
							(BgL_arg2650z00_3041, BgL_arg2651z00_3042);
					}
					if (CBOOL(BgL_gz00_3033))
						{	/* Eval/evaluate_comp.scm 905 */
							bool_t BgL_test6452z00_23710;

							{	/* Eval/evaluate_comp.scm 905 */
								int BgL_arg2649z00_3040;

								{	/* Eval/evaluate_comp.scm 905 */
									int BgL_res5007z00_9341;

									BgL_res5007z00_9341 =
										CINT(VECTOR_REF(((obj_t) BgL_gz00_3033), ((long) 0)));
									BgL_arg2649z00_3040 = BgL_res5007z00_9341;
								}
								BgL_test6452z00_23710 =
									((long) (BgL_arg2649z00_3040) == ((long) 0));
							}
							if (BgL_test6452z00_23710)
								{	/* Eval/evaluate_comp.scm 906 */
									obj_t BgL_valz00_3036;

									BgL_valz00_3036 =
										VECTOR_REF(((obj_t) BgL_gz00_3033), ((long) 2));
									{	/* Eval/evaluate_comp.scm 907 */
										bool_t BgL_test6453z00_23718;

										if (PROCEDUREP(BgL_valz00_3036))
											{	/* Eval/evaluate_comp.scm 907 */
												BgL_test6453z00_23718 =
													PROCEDURE_CORRECT_ARITYP(BgL_valz00_3036,
													(int) (BgL_nbargsz00_184));
											}
										else
											{	/* Eval/evaluate_comp.scm 907 */
												BgL_test6453z00_23718 = ((bool_t) 0);
											}
										if (BgL_test6453z00_23718)
											{	/* Eval/evaluate_comp.scm 907 */
												return BgL_valz00_3036;
											}
										else
											{	/* Eval/evaluate_comp.scm 907 */
												return BFALSE;
											}
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 905 */
									return BFALSE;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 904 */
							return BFALSE;
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 910 */
					bool_t BgL_test6455z00_23723;

					if (BGl_isazf3zf3zz__objectz00(
							((obj_t) BgL_funz00_183), BGl_ev_littz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 911 */
							obj_t BgL_tmpz00_23727;

							BgL_tmpz00_23727 =
								(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
							BgL_test6455z00_23723 = PROCEDUREP(BgL_tmpz00_23727);
						}
					else
						{	/* Eval/evaluate_comp.scm 910 */
							BgL_test6455z00_23723 = ((bool_t) 0);
						}
					if (BgL_test6455z00_23723)
						{	/* Eval/evaluate_comp.scm 913 */
							bool_t BgL_test6457z00_23731;

							{	/* Eval/evaluate_comp.scm 913 */
								obj_t BgL_arg2662z00_3052;

								BgL_arg2662z00_3052 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								BgL_test6457z00_23731 =
									PROCEDURE_CORRECT_ARITYP(BgL_arg2662z00_3052,
									(int) (BgL_nbargsz00_184));
							}
							if (BgL_test6457z00_23731)
								{	/* Eval/evaluate_comp.scm 913 */
									return
										(((BgL_ev_littz00_bglt) COBJECT(
												((BgL_ev_littz00_bglt) BgL_funz00_183)))->BgL_valuez00);
								}
							else
								{	/* Eval/evaluate_comp.scm 915 */
									int BgL_arg2658z00_3050;

									{	/* Eval/evaluate_comp.scm 915 */
										obj_t BgL_arg2659z00_3051;

										BgL_arg2659z00_3051 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_funz00_183)))->
											BgL_valuez00);
										BgL_arg2658z00_3050 = PROCEDURE_ARITY(BgL_arg2659z00_3051);
									}
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_185,
										BgL_symbzd2funzd2_186, (int) (BgL_nbargsz00_184),
										BgL_arg2658z00_3050);
						}}
					else
						{	/* Eval/evaluate_comp.scm 910 */
							return BFALSE;
						}
				}
		}

	}



/* compile-float-arith */
	obj_t BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(obj_t
		BgL_exprz00_187, obj_t BgL_stkz00_188)
	{
		{	/* Eval/evaluate_comp.scm 918 */
			if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
					BGl_ev_littz00zz__evaluate_typesz00))
				{	/* Eval/evaluate_comp.scm 922 */
					if (INTEGERP(
							(((BgL_ev_littz00_bglt) COBJECT(
										((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00)))
						{	/* Eval/evaluate_comp.scm 924 */
							obj_t BgL_v1350z00_3061;

							BgL_v1350z00_3061 = create_vector(((long) 2));
							VECTOR_SET(BgL_v1350z00_3061, ((long) 0), BINT(((long) 1)));
							{	/* Eval/evaluate_comp.scm 924 */
								double BgL_arg2667z00_3062;

								BgL_arg2667z00_3062 =
									(double) (
									(long) CINT(
										(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00)));
								VECTOR_SET(BgL_v1350z00_3061, ((long) 1),
									DOUBLE_TO_REAL(BgL_arg2667z00_3062));
							}
							return BgL_v1350z00_3061;
						}
					else
						{	/* Eval/evaluate_comp.scm 925 */
							bool_t BgL_test6460z00_23758;

							{	/* Eval/evaluate_comp.scm 925 */
								obj_t BgL_tmpz00_23759;

								BgL_tmpz00_23759 =
									(((BgL_ev_littz00_bglt) COBJECT(
											((BgL_ev_littz00_bglt) BgL_exprz00_187)))->BgL_valuez00);
								BgL_test6460z00_23758 = REALP(BgL_tmpz00_23759);
							}
							if (BgL_test6460z00_23758)
								{	/* Eval/evaluate_comp.scm 925 */
									obj_t BgL_v1351z00_3066;

									BgL_v1351z00_3066 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1351z00_3066, ((long) 0), BINT(((long) 1)));
									{	/* Eval/evaluate_comp.scm 925 */
										obj_t BgL_arg2671z00_3067;

										BgL_arg2671z00_3067 =
											(((BgL_ev_littz00_bglt) COBJECT(
													((BgL_ev_littz00_bglt) BgL_exprz00_187)))->
											BgL_valuez00);
										VECTOR_SET(BgL_v1351z00_3066, ((long) 1),
											BgL_arg2671z00_3067);
									}
									return BgL_v1351z00_3066;
								}
							else
								{	/* Eval/evaluate_comp.scm 926 */
									obj_t BgL_v1352z00_3068;

									BgL_v1352z00_3068 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1352z00_3068, ((long) 0), BINT(((long) 0)));
									{	/* Eval/evaluate_comp.scm 926 */
										obj_t BgL_arg2672z00_3069;

										BgL_arg2672z00_3069 =
											BGl_compz00zz__evaluate_compz00(
											((BgL_ev_exprz00_bglt)
												((BgL_ev_littz00_bglt) BgL_exprz00_187)),
											BgL_stkz00_188);
										VECTOR_SET(BgL_v1352z00_3068, ((long) 1),
											BgL_arg2672z00_3069);
									}
									return BgL_v1352z00_3068;
								}
						}
				}
			else
				{	/* Eval/evaluate_comp.scm 922 */
					if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
							BGl_ev_varz00zz__evaluate_typesz00))
						{	/* Eval/evaluate_comp.scm 927 */
							if (CBOOL(
									(((BgL_ev_varz00_bglt) COBJECT(
												((BgL_ev_varz00_bglt) BgL_exprz00_187)))->BgL_effz00)))
								{	/* Eval/evaluate_comp.scm 930 */
									obj_t BgL_v1353z00_3075;

									BgL_v1353z00_3075 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1353z00_3075, ((long) 0), BINT(((long) 3)));
									VECTOR_SET(BgL_v1353z00_3075, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1353z00_3075;
								}
							else
								{	/* Eval/evaluate_comp.scm 931 */
									obj_t BgL_v1354z00_3077;

									BgL_v1354z00_3077 = create_vector(((long) 2));
									VECTOR_SET(BgL_v1354z00_3077, ((long) 0), BINT(((long) 2)));
									VECTOR_SET(BgL_v1354z00_3077, ((long) 1),
										BGl__indexz00zz__evaluate_compz00(BgL_exprz00_187,
											BgL_stkz00_188));
									return BgL_v1354z00_3077;
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 927 */
							if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
									BGl_ev_globalz00zz__evaluate_typesz00))
								{	/* Eval/evaluate_comp.scm 934 */
									obj_t BgL_gz00_3081;

									{	/* Eval/evaluate_comp.scm 934 */
										obj_t BgL_arg2686z00_3089;
										obj_t BgL_arg2687z00_3090;

										BgL_arg2686z00_3089 =
											(((BgL_ev_globalz00_bglt) COBJECT(
													((BgL_ev_globalz00_bglt) BgL_exprz00_187)))->
											BgL_modz00);
										BgL_arg2687z00_3090 =
											(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
														BgL_exprz00_187)))->BgL_namez00);
										BgL_gz00_3081 =
											BGl_evmodulezd2findzd2globalz00zz__evmodulez00
											(BgL_arg2686z00_3089, BgL_arg2687z00_3090);
									}
									if (CBOOL(BgL_gz00_3081))
										{	/* Eval/evaluate_comp.scm 936 */
											bool_t BgL_test6465z00_23801;

											{	/* Eval/evaluate_comp.scm 936 */
												int BgL_arg2683z00_3086;

												{	/* Eval/evaluate_comp.scm 936 */
													int BgL_res5014z00_9364;

													BgL_res5014z00_9364 =
														CINT(VECTOR_REF(
															((obj_t) BgL_gz00_3081), ((long) 0)));
													BgL_arg2683z00_3086 = BgL_res5014z00_9364;
												}
												BgL_test6465z00_23801 =
													(BINT(BgL_arg2683z00_3086) == BINT(((long) 1)));
											}
											if (BgL_test6465z00_23801)
												{	/* Eval/evaluate_comp.scm 937 */
													obj_t BgL_v1355z00_3084;

													BgL_v1355z00_3084 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1355z00_3084, ((long) 0),
														BINT(((long) 4)));
													VECTOR_SET(BgL_v1355z00_3084, ((long) 1),
														BgL_gz00_3081);
													return BgL_v1355z00_3084;
												}
											else
												{	/* Eval/evaluate_comp.scm 938 */
													obj_t BgL_v1356z00_3085;

													BgL_v1356z00_3085 = create_vector(((long) 2));
													VECTOR_SET(BgL_v1356z00_3085, ((long) 0),
														BINT(((long) 5)));
													VECTOR_SET(BgL_v1356z00_3085, ((long) 1),
														BgL_gz00_3081);
													return BgL_v1356z00_3085;
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 939 */
											obj_t BgL_v1357z00_3087;

											BgL_v1357z00_3087 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1357z00_3087, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 939 */
												obj_t BgL_arg2685z00_3088;

												BgL_arg2685z00_3088 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt)
														((BgL_ev_globalz00_bglt) BgL_exprz00_187)),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1357z00_3087, ((long) 1),
													BgL_arg2685z00_3088);
											}
											return BgL_v1357z00_3087;
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 932 */
									if (BGl_isazf3zf3zz__objectz00(BgL_exprz00_187,
											BGl_ev_appz00zz__evaluate_typesz00))
										{	/* Eval/evaluate_comp.scm 942 */
											obj_t BgL_fvalz00_3093;

											{	/* Eval/evaluate_comp.scm 942 */
												BgL_ev_exprz00_bglt BgL_arg2736z00_3141;

												BgL_arg2736z00_3141 =
													(((BgL_ev_appz00_bglt) COBJECT(
															((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
													BgL_funz00);
												BgL_fvalz00_3093 =
													BGl_globalzd2funzd2valuez00zz__evaluate_compz00
													(BgL_arg2736z00_3141);
											}
											if (
												(BgL_fvalz00_3093 ==
													BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
												{	/* Eval/evaluate_comp.scm 945 */
													obj_t BgL_v1358z00_3095;

													BgL_v1358z00_3095 = create_vector(((long) 3));
													VECTOR_SET(BgL_v1358z00_3095, ((long) 0),
														BINT(((long) 6)));
													{	/* Eval/evaluate_comp.scm 945 */
														obj_t BgL_arg2690z00_3096;

														{	/* Eval/evaluate_comp.scm 945 */
															obj_t BgL_arg2691z00_3097;

															{	/* Eval/evaluate_comp.scm 945 */
																obj_t BgL_pairz00_9372;

																BgL_pairz00_9372 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2691z00_3097 = CAR(BgL_pairz00_9372);
															}
															BgL_arg2690z00_3096 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2691z00_3097, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1358z00_3095, ((long) 1),
															BgL_arg2690z00_3096);
													}
													{	/* Eval/evaluate_comp.scm 945 */
														obj_t BgL_arg2694z00_3099;

														{	/* Eval/evaluate_comp.scm 945 */
															obj_t BgL_arg2695z00_3100;

															{	/* Eval/evaluate_comp.scm 945 */
																obj_t BgL_pairz00_9374;

																BgL_pairz00_9374 =
																	(((BgL_ev_appz00_bglt) COBJECT(
																			((BgL_ev_appz00_bglt) BgL_exprz00_187)))->
																	BgL_argsz00);
																BgL_arg2695z00_3100 =
																	CAR(CDR(BgL_pairz00_9374));
															}
															BgL_arg2694z00_3099 =
																BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																(BgL_arg2695z00_3100, BgL_stkz00_188);
														}
														VECTOR_SET(BgL_v1358z00_3095, ((long) 2),
															BgL_arg2694z00_3099);
													}
													return BgL_v1358z00_3095;
												}
											else
												{	/* Eval/evaluate_comp.scm 944 */
													if (
														(BgL_fvalz00_3093 ==
															BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
														{	/* Eval/evaluate_comp.scm 947 */
															obj_t BgL_v1359z00_3103;

															BgL_v1359z00_3103 = create_vector(((long) 3));
															VECTOR_SET(BgL_v1359z00_3103, ((long) 0),
																BINT(((long) 7)));
															{	/* Eval/evaluate_comp.scm 947 */
																obj_t BgL_arg2698z00_3104;

																{	/* Eval/evaluate_comp.scm 947 */
																	obj_t BgL_arg2699z00_3105;

																	{	/* Eval/evaluate_comp.scm 947 */
																		obj_t BgL_pairz00_9380;

																		BgL_pairz00_9380 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2699z00_3105 = CAR(BgL_pairz00_9380);
																	}
																	BgL_arg2698z00_3104 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2699z00_3105, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1359z00_3103, ((long) 1),
																	BgL_arg2698z00_3104);
															}
															{	/* Eval/evaluate_comp.scm 947 */
																obj_t BgL_arg2701z00_3107;

																{	/* Eval/evaluate_comp.scm 947 */
																	obj_t BgL_arg2702z00_3108;

																	{	/* Eval/evaluate_comp.scm 947 */
																		obj_t BgL_pairz00_9382;

																		BgL_pairz00_9382 =
																			(((BgL_ev_appz00_bglt) COBJECT(
																					((BgL_ev_appz00_bglt)
																						BgL_exprz00_187)))->BgL_argsz00);
																		BgL_arg2702z00_3108 =
																			CAR(CDR(BgL_pairz00_9382));
																	}
																	BgL_arg2701z00_3107 =
																		BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																		(BgL_arg2702z00_3108, BgL_stkz00_188);
																}
																VECTOR_SET(BgL_v1359z00_3103, ((long) 2),
																	BgL_arg2701z00_3107);
															}
															return BgL_v1359z00_3103;
														}
													else
														{	/* Eval/evaluate_comp.scm 946 */
															if (
																(BgL_fvalz00_3093 ==
																	BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																{	/* Eval/evaluate_comp.scm 949 */
																	obj_t BgL_v1360z00_3111;

																	BgL_v1360z00_3111 = create_vector(((long) 3));
																	VECTOR_SET(BgL_v1360z00_3111, ((long) 0),
																		BINT(((long) 8)));
																	{	/* Eval/evaluate_comp.scm 949 */
																		obj_t BgL_arg2705z00_3112;

																		{	/* Eval/evaluate_comp.scm 949 */
																			obj_t BgL_arg2706z00_3113;

																			{	/* Eval/evaluate_comp.scm 949 */
																				obj_t BgL_pairz00_9388;

																				BgL_pairz00_9388 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2706z00_3113 =
																					CAR(BgL_pairz00_9388);
																			}
																			BgL_arg2705z00_3112 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2706z00_3113, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1360z00_3111, ((long) 1),
																			BgL_arg2705z00_3112);
																	}
																	{	/* Eval/evaluate_comp.scm 949 */
																		obj_t BgL_arg2708z00_3115;

																		{	/* Eval/evaluate_comp.scm 949 */
																			obj_t BgL_arg2709z00_3116;

																			{	/* Eval/evaluate_comp.scm 949 */
																				obj_t BgL_pairz00_9390;

																				BgL_pairz00_9390 =
																					(((BgL_ev_appz00_bglt) COBJECT(
																							((BgL_ev_appz00_bglt)
																								BgL_exprz00_187)))->
																					BgL_argsz00);
																				BgL_arg2709z00_3116 =
																					CAR(CDR(BgL_pairz00_9390));
																			}
																			BgL_arg2708z00_3115 =
																				BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																				(BgL_arg2709z00_3116, BgL_stkz00_188);
																		}
																		VECTOR_SET(BgL_v1360z00_3111, ((long) 2),
																			BgL_arg2708z00_3115);
																	}
																	return BgL_v1360z00_3111;
																}
															else
																{	/* Eval/evaluate_comp.scm 948 */
																	if (
																		(BgL_fvalz00_3093 ==
																			BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																		{	/* Eval/evaluate_comp.scm 951 */
																			obj_t BgL_v1361z00_3119;

																			BgL_v1361z00_3119 =
																				create_vector(((long) 3));
																			VECTOR_SET(BgL_v1361z00_3119, ((long) 0),
																				BINT(((long) 9)));
																			{	/* Eval/evaluate_comp.scm 951 */
																				obj_t BgL_arg2713z00_3120;

																				{	/* Eval/evaluate_comp.scm 951 */
																					obj_t BgL_arg2714z00_3121;

																					{	/* Eval/evaluate_comp.scm 951 */
																						obj_t BgL_pairz00_9396;

																						BgL_pairz00_9396 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2714z00_3121 =
																							CAR(BgL_pairz00_9396);
																					}
																					BgL_arg2713z00_3120 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2714z00_3121,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1361z00_3119,
																					((long) 1), BgL_arg2713z00_3120);
																			}
																			{	/* Eval/evaluate_comp.scm 951 */
																				obj_t BgL_arg2716z00_3123;

																				{	/* Eval/evaluate_comp.scm 951 */
																					obj_t BgL_arg2717z00_3124;

																					{	/* Eval/evaluate_comp.scm 951 */
																						obj_t BgL_pairz00_9398;

																						BgL_pairz00_9398 =
																							(((BgL_ev_appz00_bglt) COBJECT(
																									((BgL_ev_appz00_bglt)
																										BgL_exprz00_187)))->
																							BgL_argsz00);
																						BgL_arg2717z00_3124 =
																							CAR(CDR(BgL_pairz00_9398));
																					}
																					BgL_arg2716z00_3123 =
																						BGl_compilezd2floatzd2arithz00zz__evaluate_compz00
																						(BgL_arg2717z00_3124,
																						BgL_stkz00_188);
																				}
																				VECTOR_SET(BgL_v1361z00_3119,
																					((long) 2), BgL_arg2716z00_3123);
																			}
																			return BgL_v1361z00_3119;
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 950 */
																			if (
																				(BgL_fvalz00_3093 ==
																					BGl_fixnumzd2ze3flonumzd2envze3zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 953 */
																					obj_t BgL_v1362z00_3127;

																					BgL_v1362z00_3127 =
																						create_vector(((long) 2));
																					VECTOR_SET(BgL_v1362z00_3127,
																						((long) 0), BINT(((long) 10)));
																					{	/* Eval/evaluate_comp.scm 953 */
																						obj_t BgL_arg2721z00_3128;

																						{	/* Eval/evaluate_comp.scm 953 */
																							obj_t BgL_arg2722z00_3129;

																							{	/* Eval/evaluate_comp.scm 953 */
																								obj_t BgL_pairz00_9404;

																								BgL_pairz00_9404 =
																									(((BgL_ev_appz00_bglt)
																										COBJECT((
																												(BgL_ev_appz00_bglt)
																												BgL_exprz00_187)))->
																									BgL_argsz00);
																								BgL_arg2722z00_3129 =
																									CAR(BgL_pairz00_9404);
																							}
																							BgL_arg2721z00_3128 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_arg2722z00_3129),
																								BgL_stkz00_188);
																						}
																						VECTOR_SET(BgL_v1362z00_3127,
																							((long) 1), BgL_arg2721z00_3128);
																					}
																					return BgL_v1362z00_3127;
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 952 */
																					if (
																						(BgL_fvalz00_3093 ==
																							BGl_f64vectorzd2refzd2envz00zz__srfi4z00))
																						{	/* Eval/evaluate_comp.scm 955 */
																							obj_t BgL_v1363z00_3132;

																							BgL_v1363z00_3132 =
																								create_vector(((long) 3));
																							VECTOR_SET(BgL_v1363z00_3132,
																								((long) 0), BINT(((long) 11)));
																							{	/* Eval/evaluate_comp.scm 955 */
																								obj_t BgL_arg2725z00_3133;

																								{	/* Eval/evaluate_comp.scm 955 */
																									obj_t BgL_arg2726z00_3134;

																									{	/* Eval/evaluate_comp.scm 955 */
																										obj_t BgL_pairz00_9407;

																										BgL_pairz00_9407 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2726z00_3134 =
																											CAR(BgL_pairz00_9407);
																									}
																									BgL_arg2725z00_3133 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2726z00_3134),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1363z00_3132,
																									((long) 1),
																									BgL_arg2725z00_3133);
																							}
																							{	/* Eval/evaluate_comp.scm 955 */
																								obj_t BgL_arg2728z00_3136;

																								{	/* Eval/evaluate_comp.scm 955 */
																									obj_t BgL_arg2729z00_3137;

																									{	/* Eval/evaluate_comp.scm 955 */
																										obj_t BgL_pairz00_9409;

																										BgL_pairz00_9409 =
																											(((BgL_ev_appz00_bglt)
																												COBJECT((
																														(BgL_ev_appz00_bglt)
																														BgL_exprz00_187)))->
																											BgL_argsz00);
																										BgL_arg2729z00_3137 =
																											CAR(CDR
																											(BgL_pairz00_9409));
																									}
																									BgL_arg2728z00_3136 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_arg2729z00_3137),
																										BgL_stkz00_188);
																								}
																								VECTOR_SET(BgL_v1363z00_3132,
																									((long) 2),
																									BgL_arg2728z00_3136);
																							}
																							return BgL_v1363z00_3132;
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 957 */
																							obj_t BgL_v1364z00_3139;

																							BgL_v1364z00_3139 =
																								create_vector(((long) 2));
																							VECTOR_SET(BgL_v1364z00_3139,
																								((long) 0), BINT(((long) 0)));
																							{	/* Eval/evaluate_comp.scm 957 */
																								obj_t BgL_arg2732z00_3140;

																								BgL_arg2732z00_3140 =
																									BGl_compz00zz__evaluate_compz00
																									(((BgL_ev_exprz00_bglt) (
																											(BgL_ev_appz00_bglt)
																											BgL_exprz00_187)),
																									BgL_stkz00_188);
																								VECTOR_SET(BgL_v1364z00_3139,
																									((long) 1),
																									BgL_arg2732z00_3140);
																							}
																							return BgL_v1364z00_3139;
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 958 */
											obj_t BgL_v1365z00_3142;

											BgL_v1365z00_3142 = create_vector(((long) 2));
											VECTOR_SET(BgL_v1365z00_3142, ((long) 0),
												BINT(((long) 0)));
											{	/* Eval/evaluate_comp.scm 958 */
												obj_t BgL_arg2738z00_3143;

												BgL_arg2738z00_3143 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_exprz00_187),
													BgL_stkz00_188);
												VECTOR_SET(BgL_v1365z00_3142, ((long) 1),
													BgL_arg2738z00_3143);
											}
											return BgL_v1365z00_3142;
										}
								}
						}
				}
		}

	}



/* eval-float-arith */
	double BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(obj_t BgL_bcz00_189,
		obj_t BgL_sz00_190)
	{
		{	/* Eval/evaluate_comp.scm 960 */
			return
				REAL_TO_DOUBLE(BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_190,
					BgL_bcz00_189));
		}

	}



/* E~0 */
	obj_t BGl_Eze70ze7zz__evaluate_compz00(obj_t BgL_sz00_15544,
		obj_t BgL_bcz00_3148)
	{
		{	/* Eval/evaluate_comp.scm 975 */
			{	/* Eval/evaluate_comp.scm 962 */
				obj_t BgL_aux1221z00_3151;

				BgL_aux1221z00_3151 = VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 0));
				if (INTEGERP(BgL_aux1221z00_3151))
					{	/* Eval/evaluate_comp.scm 962 */
						switch ((long) CINT(BgL_aux1221z00_3151))
							{
							case ((long) 0):

								{	/* Eval/evaluate_comp.scm 963 */
									obj_t BgL_fun2742z00_3153;

									BgL_fun2742z00_3153 =
										VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
									return
										PROCEDURE_ENTRY(BgL_fun2742z00_3153) (BgL_fun2742z00_3153,
										BgL_sz00_15544, BEOA);
								}
								break;
							case ((long) 1):

								return VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
								break;
							case ((long) 2):

								{	/* Eval/evaluate_comp.scm 965 */
									long BgL_arg2743z00_3154;

									{	/* Eval/evaluate_comp.scm 965 */
										obj_t BgL_arg2745z00_3155;
										obj_t BgL_arg2746z00_3156;

										BgL_arg2745z00_3155 =
											VECTOR_REF(((obj_t) BgL_sz00_15544), ((long) 0));
										BgL_arg2746z00_3156 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
										BgL_arg2743z00_3154 =
											(
											(long) CINT(BgL_arg2745z00_3155) +
											(long) CINT(BgL_arg2746z00_3156));
									}
									return
										VECTOR_REF(((obj_t) BgL_sz00_15544), BgL_arg2743z00_3154);
								}
								break;
							case ((long) 3):

								{	/* Eval/evaluate_comp.scm 966 */
									obj_t BgL_arg2747z00_3157;

									{	/* Eval/evaluate_comp.scm 966 */
										long BgL_arg2749z00_3158;

										{	/* Eval/evaluate_comp.scm 966 */
											obj_t BgL_arg2750z00_3159;
											obj_t BgL_arg2751z00_3160;

											BgL_arg2750z00_3159 =
												VECTOR_REF(((obj_t) BgL_sz00_15544), ((long) 0));
											BgL_arg2751z00_3160 =
												VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
											BgL_arg2749z00_3158 =
												(
												(long) CINT(BgL_arg2750z00_3159) +
												(long) CINT(BgL_arg2751z00_3160));
										}
										BgL_arg2747z00_3157 =
											VECTOR_REF(((obj_t) BgL_sz00_15544), BgL_arg2749z00_3158);
									}
									return
										STRUCT_REF(
										((obj_t) BgL_arg2747z00_3157), (int) (((long) 0)));
								} break;
							case ((long) 4):

								{	/* Eval/evaluate_comp.scm 967 */
									obj_t BgL_arg2752z00_3161;

									{	/* Eval/evaluate_comp.scm 967 */
										obj_t BgL_arg2756z00_3162;

										BgL_arg2756z00_3162 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
										BgL_arg2752z00_3161 =
											VECTOR_REF(((obj_t) BgL_arg2756z00_3162), ((long) 2));
									}
									return __EVMEANING_ADDRESS_REF(BgL_arg2752z00_3161);
								}
								break;
							case ((long) 5):

								{	/* Eval/evaluate_comp.scm 968 */
									obj_t BgL_arg2762z00_3163;

									BgL_arg2762z00_3163 =
										VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
									return VECTOR_REF(((obj_t) BgL_arg2762z00_3163), ((long) 2));
								} break;
							case ((long) 6):

								{	/* Eval/evaluate_comp.scm 969 */
									obj_t BgL_arg2765z00_3164;
									obj_t BgL_arg2768z00_3165;

									{	/* Eval/evaluate_comp.scm 969 */
										obj_t BgL_arg2770z00_3166;

										BgL_arg2770z00_3166 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
										BgL_arg2765z00_3164 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15544,
											BgL_arg2770z00_3166);
									}
									{	/* Eval/evaluate_comp.scm 969 */
										obj_t BgL_arg2771z00_3167;

										BgL_arg2771z00_3167 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 2));
										BgL_arg2768z00_3165 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15544,
											BgL_arg2771z00_3167);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2765z00_3164) +
											REAL_TO_DOUBLE(BgL_arg2768z00_3165)));
								}
								break;
							case ((long) 7):

								{	/* Eval/evaluate_comp.scm 970 */
									obj_t BgL_arg2772z00_3168;
									obj_t BgL_arg2773z00_3169;

									{	/* Eval/evaluate_comp.scm 970 */
										obj_t BgL_arg2774z00_3170;

										BgL_arg2774z00_3170 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
										BgL_arg2772z00_3168 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15544,
											BgL_arg2774z00_3170);
									}
									{	/* Eval/evaluate_comp.scm 970 */
										obj_t BgL_arg2775z00_3171;

										BgL_arg2775z00_3171 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 2));
										BgL_arg2773z00_3169 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15544,
											BgL_arg2775z00_3171);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2772z00_3168) -
											REAL_TO_DOUBLE(BgL_arg2773z00_3169)));
								}
								break;
							case ((long) 8):

								{	/* Eval/evaluate_comp.scm 971 */
									obj_t BgL_arg2777z00_3172;
									obj_t BgL_arg2778z00_3173;

									{	/* Eval/evaluate_comp.scm 971 */
										obj_t BgL_arg2781z00_3174;

										BgL_arg2781z00_3174 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
										BgL_arg2777z00_3172 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15544,
											BgL_arg2781z00_3174);
									}
									{	/* Eval/evaluate_comp.scm 971 */
										obj_t BgL_arg2784z00_3175;

										BgL_arg2784z00_3175 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 2));
										BgL_arg2778z00_3173 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15544,
											BgL_arg2784z00_3175);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2777z00_3172) *
											REAL_TO_DOUBLE(BgL_arg2778z00_3173)));
								}
								break;
							case ((long) 9):

								{	/* Eval/evaluate_comp.scm 972 */
									obj_t BgL_arg2785z00_3176;
									obj_t BgL_arg2786z00_3177;

									{	/* Eval/evaluate_comp.scm 972 */
										obj_t BgL_arg2787z00_3178;

										BgL_arg2787z00_3178 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
										BgL_arg2785z00_3176 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15544,
											BgL_arg2787z00_3178);
									}
									{	/* Eval/evaluate_comp.scm 972 */
										obj_t BgL_arg2788z00_3179;

										BgL_arg2788z00_3179 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 2));
										BgL_arg2786z00_3177 =
											BGl_Eze70ze7zz__evaluate_compz00(BgL_sz00_15544,
											BgL_arg2788z00_3179);
									}
									return
										DOUBLE_TO_REAL(
										(REAL_TO_DOUBLE(BgL_arg2785z00_3176) /
											REAL_TO_DOUBLE(BgL_arg2786z00_3177)));
								}
								break;
							case ((long) 10):

								{	/* Eval/evaluate_comp.scm 973 */
									obj_t BgL_arg2792z00_3180;

									{	/* Eval/evaluate_comp.scm 973 */
										obj_t BgL_fun2793z00_3181;

										BgL_fun2793z00_3181 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
										BgL_arg2792z00_3180 =
											PROCEDURE_ENTRY(BgL_fun2793z00_3181) (BgL_fun2793z00_3181,
											BgL_sz00_15544, BEOA);
									}
									return
										DOUBLE_TO_REAL((double) ((long) CINT(BgL_arg2792z00_3180)));
								} break;
							case ((long) 11):

								{	/* Eval/evaluate_comp.scm 974 */
									obj_t BgL_arg2794z00_3182;
									obj_t BgL_arg2795z00_3183;

									{	/* Eval/evaluate_comp.scm 974 */
										obj_t BgL_fun2796z00_3184;

										BgL_fun2796z00_3184 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 1));
										BgL_arg2794z00_3182 =
											PROCEDURE_ENTRY(BgL_fun2796z00_3184) (BgL_fun2796z00_3184,
											BgL_sz00_15544, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 974 */
										obj_t BgL_fun2797z00_3185;

										BgL_fun2797z00_3185 =
											VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 2));
										BgL_arg2795z00_3183 =
											PROCEDURE_ENTRY(BgL_fun2797z00_3185) (BgL_fun2797z00_3185,
											BgL_sz00_15544, BEOA);
									}
									{	/* Eval/evaluate_comp.scm 974 */
										double BgL_tmpz00_24039;

										{	/* Eval/evaluate_comp.scm 974 */
											long BgL_tmpz00_24040;

											BgL_tmpz00_24040 = (long) CINT(BgL_arg2795z00_3183);
											BgL_tmpz00_24039 =
												BGL_F64VREF(BgL_arg2794z00_3182, BgL_tmpz00_24040);
										}
										return DOUBLE_TO_REAL(BgL_tmpz00_24039);
									}
								}
								break;
							default:
								{	/* Eval/evaluate_comp.scm 975 */
									obj_t BgL_arg2801z00_9469;

									BgL_arg2801z00_9469 =
										VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 0));
									return
										BGl_errorz00zz__errorz00
										(BGl_string5847z00zz__evaluate_compz00,
										BGl_string5866z00zz__evaluate_compz00, BgL_arg2801z00_9469);
								}
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 975 */
						obj_t BgL_arg2801z00_9471;

						BgL_arg2801z00_9471 =
							VECTOR_REF(((obj_t) BgL_bcz00_3148), ((long) 0));
						return
							BGl_errorz00zz__errorz00(BGl_string5847z00zz__evaluate_compz00,
							BGl_string5866z00zz__evaluate_compz00, BgL_arg2801z00_9471);
					}
			}
		}

	}



/* arith-expression */
	obj_t BGl_arithzd2expressionzd2zz__evaluate_compz00(BgL_ev_appz00_bglt
		BgL_exprz00_191, obj_t BgL_stkz00_192)
	{
		{	/* Eval/evaluate_comp.scm 978 */
			{	/* Eval/evaluate_comp.scm 980 */
				obj_t BgL_fvalz00_3189;

				BgL_fvalz00_3189 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(
					(((BgL_ev_appz00_bglt) COBJECT(BgL_exprz00_191))->BgL_funz00));
				{	/* Eval/evaluate_comp.scm 981 */
					bool_t BgL_test6474z00_24054;

					if (
						(BgL_fvalz00_3189 ==
							BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
						{	/* Eval/evaluate_comp.scm 981 */
							BgL_test6474z00_24054 = ((bool_t) 1);
						}
					else
						{	/* Eval/evaluate_comp.scm 981 */
							if (
								(BgL_fvalz00_3189 ==
									BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
								{	/* Eval/evaluate_comp.scm 981 */
									BgL_test6474z00_24054 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 981 */
									if (
										(BgL_fvalz00_3189 ==
											BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
										{	/* Eval/evaluate_comp.scm 981 */
											BgL_test6474z00_24054 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 981 */
											BgL_test6474z00_24054 =
												(BgL_fvalz00_3189 ==
												BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00);
										}
								}
						}
					if (BgL_test6474z00_24054)
						{	/* Eval/evaluate_comp.scm 982 */
							obj_t BgL_bcz00_3194;

							BgL_bcz00_3194 =
								BGl_compilezd2floatzd2arithz00zz__evaluate_compz00(
								((obj_t) BgL_exprz00_191), BgL_stkz00_192);
							{	/* Eval/evaluate_comp.scm 983 */
								obj_t BgL_zc3z04anonymousza32806ze3z87_13899;

								BgL_zc3z04anonymousza32806ze3z87_13899 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza32806ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza32806ze3z87_13899,
									(int) (((long) 0)), BgL_bcz00_3194);
								return BgL_zc3z04anonymousza32806ze3z87_13899;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 981 */
							return BFALSE;
						}
				}
			}
		}

	}



/* &<@anonymous:2806> */
	obj_t BGl_z62zc3z04anonymousza32806ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13900, obj_t BgL_sz00_13902)
	{
		{	/* Eval/evaluate_comp.scm 983 */
			{	/* Eval/evaluate_comp.scm 983 */
				obj_t BgL_bcz00_13901;

				BgL_bcz00_13901 =
					((obj_t) PROCEDURE_REF(BgL_envz00_13900, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 983 */
					double BgL_tmpz00_24072;

					{	/* Eval/evaluate_comp.scm 983 */
						obj_t BgL_bpz00_16494;

						BgL_bpz00_16494 = VECTOR_REF(((obj_t) BgL_sz00_13902), ((long) 0));
						BgL_tmpz00_24072 =
							BGl_evalzd2floatzd2arithz00zz__evaluate_compz00(BgL_bcz00_13901,
							BgL_sz00_13902);
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_24072);
				}
			}
		}

	}



/* inline-call */
	obj_t BGl_inlinezd2callzd2zz__evaluate_compz00(obj_t BgL_locz00_193,
		BgL_ev_exprz00_bglt BgL_funz00_194, obj_t BgL_argsz00_195,
		obj_t BgL_stkz00_196)
	{
		{	/* Eval/evaluate_comp.scm 1012 */
			{	/* Eval/evaluate_comp.scm 1013 */
				obj_t BgL_valz00_3202;

				BgL_valz00_3202 =
					BGl_globalzd2funzd2valuez00zz__evaluate_compz00(BgL_funz00_194);
				if (CBOOL(BgL_valz00_3202))
					{	/* Eval/evaluate_comp.scm 1015 */
						long BgL_nz00_3203;

						BgL_nz00_3203 = bgl_list_length(BgL_argsz00_195);
						{	/* Eval/evaluate_comp.scm 1016 */
							obj_t BgL__ortest_1227z00_3204;

							if ((BgL_nz00_3203 == ((long) 1)))
								{	/* Eval/evaluate_comp.scm 1017 */
									obj_t BgL_a1z00_3495;

									BgL_a1z00_3495 = CAR(((obj_t) BgL_argsz00_195));
									if (
										(BgL_valz00_3202 ==
											BGl_carzd2envzd2zz__r4_pairs_and_lists_6_3z00))
										{	/* Eval/evaluate_comp.scm 1018 */
											obj_t BgL_a1z00_3497;

											BgL_a1z00_3497 =
												BGl_compz00zz__evaluate_compz00(
												((BgL_ev_exprz00_bglt) BgL_a1z00_3495), BgL_stkz00_196);
											{	/* Eval/evaluate_comp.scm 1018 */
												obj_t BgL_zc3z04anonymousza32926ze3z87_13932;

												BgL_zc3z04anonymousza32926ze3z87_13932 =
													MAKE_FX_PROCEDURE
													(BGl_z62zc3z04anonymousza32926ze3ze5zz__evaluate_compz00,
													(int) (((long) 1)), (int) (((long) 2)));
												PROCEDURE_SET(BgL_zc3z04anonymousza32926ze3z87_13932,
													(int) (((long) 0)), BgL_a1z00_3497);
												PROCEDURE_SET(BgL_zc3z04anonymousza32926ze3z87_13932,
													(int) (((long) 1)), BgL_locz00_193);
												BgL__ortest_1227z00_3204 =
													BgL_zc3z04anonymousza32926ze3z87_13932;
										}}
									else
										{	/* Eval/evaluate_comp.scm 1018 */
											if (
												(BgL_valz00_3202 ==
													BGl_cdrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
												{	/* Eval/evaluate_comp.scm 1018 */
													obj_t BgL_a1z00_3504;

													BgL_a1z00_3504 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3495),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1018 */
														obj_t BgL_zc3z04anonymousza32929ze3z87_13933;

														BgL_zc3z04anonymousza32929ze3z87_13933 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza32929ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32929ze3z87_13933,
															(int) (((long) 0)), BgL_a1z00_3504);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32929ze3z87_13933,
															(int) (((long) 1)), BgL_locz00_193);
														BgL__ortest_1227z00_3204 =
															BgL_zc3z04anonymousza32929ze3z87_13933;
												}}
											else
												{	/* Eval/evaluate_comp.scm 1018 */
													if (
														(BgL_valz00_3202 ==
															BGl_cadrzd2envzd2zz__r4_pairs_and_lists_6_3z00))
														{	/* Eval/evaluate_comp.scm 1018 */
															obj_t BgL_a1z00_3511;

															BgL_a1z00_3511 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3495),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1018 */
																obj_t BgL_zc3z04anonymousza32932ze3z87_13934;

																BgL_zc3z04anonymousza32932ze3z87_13934 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3z04anonymousza32932ze3ze5zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 2)));
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32932ze3z87_13934,
																	(int) (((long) 0)), BgL_a1z00_3511);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32932ze3z87_13934,
																	(int) (((long) 1)), BgL_locz00_193);
																BgL__ortest_1227z00_3204 =
																	BgL_zc3z04anonymousza32932ze3z87_13934;
														}}
													else
														{	/* Eval/evaluate_comp.scm 1018 */
															BgL__ortest_1227z00_3204 = BFALSE;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1016 */
									BgL__ortest_1227z00_3204 = BFALSE;
								}
							if (CBOOL(BgL__ortest_1227z00_3204))
								{	/* Eval/evaluate_comp.scm 1016 */
									return BgL__ortest_1227z00_3204;
								}
							else
								{	/* Eval/evaluate_comp.scm 1016 */
									if ((BgL_nz00_3203 == ((long) 2)))
										{	/* Eval/evaluate_comp.scm 1020 */
											obj_t BgL_a1z00_3206;
											obj_t BgL_a2z00_3207;

											BgL_a1z00_3206 = CAR(((obj_t) BgL_argsz00_195));
											{	/* Eval/evaluate_comp.scm 1020 */
												obj_t BgL_pairz00_9503;

												BgL_pairz00_9503 = CDR(((obj_t) BgL_argsz00_195));
												BgL_a2z00_3207 = CAR(BgL_pairz00_9503);
											}
											if (
												(BgL_valz00_3202 ==
													BGl_zb2zd2envz60zz__r4_numbers_6_5z00))
												{	/* Eval/evaluate_comp.scm 1021 */
													obj_t BgL_a1z00_3209;
													obj_t BgL_a2z00_3210;

													BgL_a1z00_3209 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_a1z00_3206),
														BgL_stkz00_196);
													BgL_a2z00_3210 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_a2z00_3207),
														BgL_stkz00_196);
													{	/* Eval/evaluate_comp.scm 1021 */
														obj_t BgL_zc3z04anonymousza32813ze3z87_13903;

														BgL_zc3z04anonymousza32813ze3z87_13903 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza32813ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 3)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32813ze3z87_13903,
															(int) (((long) 0)), BgL_a1z00_3209);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32813ze3z87_13903,
															(int) (((long) 1)), BgL_a2z00_3210);
														PROCEDURE_SET
															(BgL_zc3z04anonymousza32813ze3z87_13903,
															(int) (((long) 2)), BgL_locz00_193);
														return BgL_zc3z04anonymousza32813ze3z87_13903;
													}
												}
											else
												{	/* Eval/evaluate_comp.scm 1021 */
													if (
														(BgL_valz00_3202 ==
															BGl_zd2zd2envz00zz__r4_numbers_6_5z00))
														{	/* Eval/evaluate_comp.scm 1021 */
															obj_t BgL_a1z00_3219;
															obj_t BgL_a2z00_3220;

															BgL_a1z00_3219 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_a1z00_3206),
																BgL_stkz00_196);
															BgL_a2z00_3220 =
																BGl_compz00zz__evaluate_compz00((
																	(BgL_ev_exprz00_bglt) BgL_a2z00_3207),
																BgL_stkz00_196);
															{	/* Eval/evaluate_comp.scm 1021 */
																obj_t BgL_zc3z04anonymousza32817ze3z87_13904;

																BgL_zc3z04anonymousza32817ze3z87_13904 =
																	MAKE_FX_PROCEDURE
																	(BGl_z62zc3z04anonymousza32817ze3ze5zz__evaluate_compz00,
																	(int) (((long) 1)), (int) (((long) 3)));
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32817ze3z87_13904,
																	(int) (((long) 0)), BgL_a1z00_3219);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32817ze3z87_13904,
																	(int) (((long) 1)), BgL_a2z00_3220);
																PROCEDURE_SET
																	(BgL_zc3z04anonymousza32817ze3z87_13904,
																	(int) (((long) 2)), BgL_locz00_193);
																return BgL_zc3z04anonymousza32817ze3z87_13904;
															}
														}
													else
														{	/* Eval/evaluate_comp.scm 1021 */
															if (
																(BgL_valz00_3202 ==
																	BGl_za2zd2envz70zz__r4_numbers_6_5z00))
																{	/* Eval/evaluate_comp.scm 1021 */
																	obj_t BgL_a1z00_3229;
																	obj_t BgL_a2z00_3230;

																	BgL_a1z00_3229 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt) BgL_a1z00_3206),
																		BgL_stkz00_196);
																	BgL_a2z00_3230 =
																		BGl_compz00zz__evaluate_compz00((
																			(BgL_ev_exprz00_bglt) BgL_a2z00_3207),
																		BgL_stkz00_196);
																	{	/* Eval/evaluate_comp.scm 1021 */
																		obj_t
																			BgL_zc3z04anonymousza32821ze3z87_13905;
																		BgL_zc3z04anonymousza32821ze3z87_13905 =
																			MAKE_FX_PROCEDURE
																			(BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00,
																			(int) (((long) 1)), (int) (((long) 3)));
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32821ze3z87_13905,
																			(int) (((long) 0)), BgL_a1z00_3229);
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32821ze3z87_13905,
																			(int) (((long) 1)), BgL_a2z00_3230);
																		PROCEDURE_SET
																			(BgL_zc3z04anonymousza32821ze3z87_13905,
																			(int) (((long) 2)), BgL_locz00_193);
																		return
																			BgL_zc3z04anonymousza32821ze3z87_13905;
																	}
																}
															else
																{	/* Eval/evaluate_comp.scm 1021 */
																	if (
																		(BgL_valz00_3202 ==
																			BGl_zf2zd2envz20zz__r4_numbers_6_5z00))
																		{	/* Eval/evaluate_comp.scm 1021 */
																			obj_t BgL_a1z00_3239;
																			obj_t BgL_a2z00_3240;

																			BgL_a1z00_3239 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt) BgL_a1z00_3206),
																				BgL_stkz00_196);
																			BgL_a2z00_3240 =
																				BGl_compz00zz__evaluate_compz00((
																					(BgL_ev_exprz00_bglt) BgL_a2z00_3207),
																				BgL_stkz00_196);
																			{	/* Eval/evaluate_comp.scm 1021 */
																				obj_t
																					BgL_zc3z04anonymousza32825ze3z87_13906;
																				BgL_zc3z04anonymousza32825ze3z87_13906 =
																					MAKE_FX_PROCEDURE
																					(BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00,
																					(int) (((long) 1)),
																					(int) (((long) 3)));
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32825ze3z87_13906,
																					(int) (((long) 0)), BgL_a1z00_3239);
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32825ze3z87_13906,
																					(int) (((long) 1)), BgL_a2z00_3240);
																				PROCEDURE_SET
																					(BgL_zc3z04anonymousza32825ze3z87_13906,
																					(int) (((long) 2)), BgL_locz00_193);
																				return
																					BgL_zc3z04anonymousza32825ze3z87_13906;
																			}
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 1021 */
																			if (
																				(BgL_valz00_3202 ==
																					BGl_zc3zd2envz11zz__r4_numbers_6_5z00))
																				{	/* Eval/evaluate_comp.scm 1021 */
																					obj_t BgL_a1z00_3249;
																					obj_t BgL_a2z00_3250;

																					BgL_a1z00_3249 =
																						BGl_compz00zz__evaluate_compz00(
																						((BgL_ev_exprz00_bglt)
																							BgL_a1z00_3206), BgL_stkz00_196);
																					BgL_a2z00_3250 =
																						BGl_compz00zz__evaluate_compz00((
																							(BgL_ev_exprz00_bglt)
																							BgL_a2z00_3207), BgL_stkz00_196);
																					{	/* Eval/evaluate_comp.scm 1021 */
																						obj_t
																							BgL_zc3z04anonymousza32829ze3z87_13907;
																						BgL_zc3z04anonymousza32829ze3z87_13907
																							=
																							MAKE_FX_PROCEDURE
																							(BGl_z62zc3z04anonymousza32829ze3ze5zz__evaluate_compz00,
																							(int) (((long) 1)),
																							(int) (((long) 3)));
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32829ze3z87_13907,
																							(int) (((long) 0)),
																							BgL_a1z00_3249);
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32829ze3z87_13907,
																							(int) (((long) 1)),
																							BgL_a2z00_3250);
																						PROCEDURE_SET
																							(BgL_zc3z04anonymousza32829ze3z87_13907,
																							(int) (((long) 2)),
																							BgL_locz00_193);
																						return
																							BgL_zc3z04anonymousza32829ze3z87_13907;
																					}
																				}
																			else
																				{	/* Eval/evaluate_comp.scm 1021 */
																					if (
																						(BgL_valz00_3202 ==
																							BGl_ze3zd2envz31zz__r4_numbers_6_5z00))
																						{	/* Eval/evaluate_comp.scm 1021 */
																							obj_t BgL_a1z00_3259;
																							obj_t BgL_a2z00_3260;

																							BgL_a1z00_3259 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a1z00_3206),
																								BgL_stkz00_196);
																							BgL_a2z00_3260 =
																								BGl_compz00zz__evaluate_compz00(
																								((BgL_ev_exprz00_bglt)
																									BgL_a2z00_3207),
																								BgL_stkz00_196);
																							{	/* Eval/evaluate_comp.scm 1021 */
																								obj_t
																									BgL_zc3z04anonymousza32833ze3z87_13908;
																								BgL_zc3z04anonymousza32833ze3z87_13908
																									=
																									MAKE_FX_PROCEDURE
																									(BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00,
																									(int) (((long) 1)),
																									(int) (((long) 3)));
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32833ze3z87_13908,
																									(int) (((long) 0)),
																									BgL_a1z00_3259);
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32833ze3z87_13908,
																									(int) (((long) 1)),
																									BgL_a2z00_3260);
																								PROCEDURE_SET
																									(BgL_zc3z04anonymousza32833ze3z87_13908,
																									(int) (((long) 2)),
																									BgL_locz00_193);
																								return
																									BgL_zc3z04anonymousza32833ze3z87_13908;
																							}
																						}
																					else
																						{	/* Eval/evaluate_comp.scm 1021 */
																							if (
																								(BgL_valz00_3202 ==
																									BGl_zc3zd3zd2envzc2zz__r4_numbers_6_5z00))
																								{	/* Eval/evaluate_comp.scm 1021 */
																									obj_t BgL_a1z00_3269;
																									obj_t BgL_a2z00_3270;

																									BgL_a1z00_3269 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a1z00_3206),
																										BgL_stkz00_196);
																									BgL_a2z00_3270 =
																										BGl_compz00zz__evaluate_compz00
																										(((BgL_ev_exprz00_bglt)
																											BgL_a2z00_3207),
																										BgL_stkz00_196);
																									{	/* Eval/evaluate_comp.scm 1021 */
																										obj_t
																											BgL_zc3z04anonymousza32837ze3z87_13909;
																										BgL_zc3z04anonymousza32837ze3z87_13909
																											=
																											MAKE_FX_PROCEDURE
																											(BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00,
																											(int) (((long) 1)),
																											(int) (((long) 3)));
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32837ze3z87_13909,
																											(int) (((long) 0)),
																											BgL_a1z00_3269);
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32837ze3z87_13909,
																											(int) (((long) 1)),
																											BgL_a2z00_3270);
																										PROCEDURE_SET
																											(BgL_zc3z04anonymousza32837ze3z87_13909,
																											(int) (((long) 2)),
																											BgL_locz00_193);
																										return
																											BgL_zc3z04anonymousza32837ze3z87_13909;
																									}
																								}
																							else
																								{	/* Eval/evaluate_comp.scm 1021 */
																									if (
																										(BgL_valz00_3202 ==
																											BGl_ze3zd3zd2envze2zz__r4_numbers_6_5z00))
																										{	/* Eval/evaluate_comp.scm 1021 */
																											obj_t BgL_a1z00_3279;
																											obj_t BgL_a2z00_3280;

																											BgL_a1z00_3279 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a1z00_3206),
																												BgL_stkz00_196);
																											BgL_a2z00_3280 =
																												BGl_compz00zz__evaluate_compz00
																												(((BgL_ev_exprz00_bglt)
																													BgL_a2z00_3207),
																												BgL_stkz00_196);
																											{	/* Eval/evaluate_comp.scm 1021 */
																												obj_t
																													BgL_zc3z04anonymousza32841ze3z87_13910;
																												BgL_zc3z04anonymousza32841ze3z87_13910
																													=
																													MAKE_FX_PROCEDURE
																													(BGl_z62zc3z04anonymousza32841ze3ze5zz__evaluate_compz00,
																													(int) (((long) 1)),
																													(int) (((long) 3)));
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32841ze3z87_13910,
																													(int) (((long) 0)),
																													BgL_a1z00_3279);
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32841ze3z87_13910,
																													(int) (((long) 1)),
																													BgL_a2z00_3280);
																												PROCEDURE_SET
																													(BgL_zc3z04anonymousza32841ze3z87_13910,
																													(int) (((long) 2)),
																													BgL_locz00_193);
																												return
																													BgL_zc3z04anonymousza32841ze3z87_13910;
																											}
																										}
																									else
																										{	/* Eval/evaluate_comp.scm 1021 */
																											if (
																												(BgL_valz00_3202 ==
																													BGl_zd3zd2envz01zz__r4_numbers_6_5z00))
																												{	/* Eval/evaluate_comp.scm 1021 */
																													obj_t BgL_a1z00_3289;
																													obj_t BgL_a2z00_3290;

																													BgL_a1z00_3289 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																													BgL_a2z00_3290 =
																														BGl_compz00zz__evaluate_compz00
																														(((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																													{	/* Eval/evaluate_comp.scm 1021 */
																														obj_t
																															BgL_zc3z04anonymousza32845ze3z87_13911;
																														BgL_zc3z04anonymousza32845ze3z87_13911
																															=
																															MAKE_FX_PROCEDURE
																															(BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00,
																															(int) (((long)
																																	1)),
																															(int) (((long)
																																	3)));
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32845ze3z87_13911,
																															(int) (((long)
																																	0)),
																															BgL_a1z00_3289);
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32845ze3z87_13911,
																															(int) (((long)
																																	1)),
																															BgL_a2z00_3290);
																														PROCEDURE_SET
																															(BgL_zc3z04anonymousza32845ze3z87_13911,
																															(int) (((long)
																																	2)),
																															BgL_locz00_193);
																														return
																															BgL_zc3z04anonymousza32845ze3z87_13911;
																													}
																												}
																											else
																												{	/* Eval/evaluate_comp.scm 1021 */
																													if (
																														(BgL_valz00_3202 ==
																															BGl_zb2fxzd2envz60zz__r4_numbers_6_5_fixnumz00))
																														{	/* Eval/evaluate_comp.scm 1021 */
																															obj_t
																																BgL_a1z00_3299;
																															obj_t
																																BgL_a2z00_3300;
																															BgL_a1z00_3299 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																															BgL_a2z00_3300 =
																																BGl_compz00zz__evaluate_compz00
																																(((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																															{	/* Eval/evaluate_comp.scm 1021 */
																																obj_t
																																	BgL_zc3z04anonymousza32849ze3z87_13912;
																																BgL_zc3z04anonymousza32849ze3z87_13912
																																	=
																																	MAKE_FX_PROCEDURE
																																	(BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00,
																																	(int) (((long)
																																			1)),
																																	(int) (((long)
																																			3)));
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32849ze3z87_13912,
																																	(int) (((long)
																																			0)),
																																	BgL_a1z00_3299);
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32849ze3z87_13912,
																																	(int) (((long)
																																			1)),
																																	BgL_a2z00_3300);
																																PROCEDURE_SET
																																	(BgL_zc3z04anonymousza32849ze3z87_13912,
																																	(int) (((long)
																																			2)),
																																	BgL_locz00_193);
																																return
																																	BgL_zc3z04anonymousza32849ze3z87_13912;
																															}
																														}
																													else
																														{	/* Eval/evaluate_comp.scm 1021 */
																															if (
																																(BgL_valz00_3202
																																	==
																																	BGl_zd2fxzd2envz00zz__r4_numbers_6_5_fixnumz00))
																																{	/* Eval/evaluate_comp.scm 1021 */
																																	obj_t
																																		BgL_a1z00_3309;
																																	obj_t
																																		BgL_a2z00_3310;
																																	BgL_a1z00_3309
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																	BgL_a2z00_3310
																																		=
																																		BGl_compz00zz__evaluate_compz00
																																		(((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																	{	/* Eval/evaluate_comp.scm 1021 */
																																		obj_t
																																			BgL_zc3z04anonymousza32853ze3z87_13913;
																																		BgL_zc3z04anonymousza32853ze3z87_13913
																																			=
																																			MAKE_FX_PROCEDURE
																																			(BGl_z62zc3z04anonymousza32853ze3ze5zz__evaluate_compz00,
																																			(int) ((
																																					(long)
																																					1)),
																																			(int) ((
																																					(long)
																																					3)));
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32853ze3z87_13913,
																																			(int) ((
																																					(long)
																																					0)),
																																			BgL_a1z00_3309);
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32853ze3z87_13913,
																																			(int) ((
																																					(long)
																																					1)),
																																			BgL_a2z00_3310);
																																		PROCEDURE_SET
																																			(BgL_zc3z04anonymousza32853ze3z87_13913,
																																			(int) ((
																																					(long)
																																					2)),
																																			BgL_locz00_193);
																																		return
																																			BgL_zc3z04anonymousza32853ze3z87_13913;
																																	}
																																}
																															else
																																{	/* Eval/evaluate_comp.scm 1021 */
																																	if (
																																		(BgL_valz00_3202
																																			==
																																			BGl_za2fxzd2envz70zz__r4_numbers_6_5_fixnumz00))
																																		{	/* Eval/evaluate_comp.scm 1021 */
																																			obj_t
																																				BgL_a1z00_3319;
																																			obj_t
																																				BgL_a2z00_3320;
																																			BgL_a1z00_3319
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																			BgL_a2z00_3320
																																				=
																																				BGl_compz00zz__evaluate_compz00
																																				(((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																			{	/* Eval/evaluate_comp.scm 1021 */
																																				obj_t
																																					BgL_zc3z04anonymousza32857ze3z87_13914;
																																				BgL_zc3z04anonymousza32857ze3z87_13914
																																					=
																																					MAKE_FX_PROCEDURE
																																					(BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00,
																																					(int)
																																					(((long) 1)), (int) (((long) 3)));
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32857ze3z87_13914,
																																					(int)
																																					(((long) 0)), BgL_a1z00_3319);
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32857ze3z87_13914,
																																					(int)
																																					(((long) 1)), BgL_a2z00_3320);
																																				PROCEDURE_SET
																																					(BgL_zc3z04anonymousza32857ze3z87_13914,
																																					(int)
																																					(((long) 2)), BgL_locz00_193);
																																				return
																																					BgL_zc3z04anonymousza32857ze3z87_13914;
																																			}
																																		}
																																	else
																																		{	/* Eval/evaluate_comp.scm 1021 */
																																			if (
																																				(BgL_valz00_3202
																																					==
																																					BGl_zf2fxzd2envz20zz__r4_numbers_6_5_fixnumz00))
																																				{	/* Eval/evaluate_comp.scm 1021 */
																																					obj_t
																																						BgL_a1z00_3329;
																																					obj_t
																																						BgL_a2z00_3330;
																																					BgL_a1z00_3329
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																					BgL_a2z00_3330
																																						=
																																						BGl_compz00zz__evaluate_compz00
																																						(((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																					{	/* Eval/evaluate_comp.scm 1021 */
																																						obj_t
																																							BgL_zc3z04anonymousza32861ze3z87_13915;
																																						BgL_zc3z04anonymousza32861ze3z87_13915
																																							=
																																							MAKE_FX_PROCEDURE
																																							(BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00,
																																							(int)
																																							(((long) 1)), (int) (((long) 3)));
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32861ze3z87_13915,
																																							(int)
																																							(((long) 0)), BgL_a1z00_3329);
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32861ze3z87_13915,
																																							(int)
																																							(((long) 1)), BgL_a2z00_3330);
																																						PROCEDURE_SET
																																							(BgL_zc3z04anonymousza32861ze3z87_13915,
																																							(int)
																																							(((long) 2)), BgL_locz00_193);
																																						return
																																							BgL_zc3z04anonymousza32861ze3z87_13915;
																																					}
																																				}
																																			else
																																				{	/* Eval/evaluate_comp.scm 1021 */
																																					if (
																																						(BgL_valz00_3202
																																							==
																																							BGl_zc3fxzd2envz11zz__r4_numbers_6_5_fixnumz00))
																																						{	/* Eval/evaluate_comp.scm 1021 */
																																							obj_t
																																								BgL_a1z00_3339;
																																							obj_t
																																								BgL_a2z00_3340;
																																							BgL_a1z00_3339
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																							BgL_a2z00_3340
																																								=
																																								BGl_compz00zz__evaluate_compz00
																																								(
																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																							{	/* Eval/evaluate_comp.scm 1021 */
																																								obj_t
																																									BgL_zc3z04anonymousza32865ze3z87_13916;
																																								BgL_zc3z04anonymousza32865ze3z87_13916
																																									=
																																									MAKE_FX_PROCEDURE
																																									(BGl_z62zc3z04anonymousza32865ze3ze5zz__evaluate_compz00,
																																									(int)
																																									(((long) 1)), (int) (((long) 3)));
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32865ze3z87_13916,
																																									(int)
																																									(((long) 0)), BgL_a1z00_3339);
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32865ze3z87_13916,
																																									(int)
																																									(((long) 1)), BgL_a2z00_3340);
																																								PROCEDURE_SET
																																									(BgL_zc3z04anonymousza32865ze3z87_13916,
																																									(int)
																																									(((long) 2)), BgL_locz00_193);
																																								return
																																									BgL_zc3z04anonymousza32865ze3z87_13916;
																																							}
																																						}
																																					else
																																						{	/* Eval/evaluate_comp.scm 1021 */
																																							if ((BgL_valz00_3202 == BGl_ze3fxzd2envz31zz__r4_numbers_6_5_fixnumz00))
																																								{	/* Eval/evaluate_comp.scm 1021 */
																																									obj_t
																																										BgL_a1z00_3349;
																																									obj_t
																																										BgL_a2z00_3350;
																																									BgL_a1z00_3349
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																									BgL_a2z00_3350
																																										=
																																										BGl_compz00zz__evaluate_compz00
																																										(
																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																									{	/* Eval/evaluate_comp.scm 1021 */
																																										obj_t
																																											BgL_zc3z04anonymousza32869ze3z87_13917;
																																										BgL_zc3z04anonymousza32869ze3z87_13917
																																											=
																																											MAKE_FX_PROCEDURE
																																											(BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00,
																																											(int)
																																											(((long) 1)), (int) (((long) 3)));
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32869ze3z87_13917,
																																											(int)
																																											(((long) 0)), BgL_a1z00_3349);
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32869ze3z87_13917,
																																											(int)
																																											(((long) 1)), BgL_a2z00_3350);
																																										PROCEDURE_SET
																																											(BgL_zc3z04anonymousza32869ze3z87_13917,
																																											(int)
																																											(((long) 2)), BgL_locz00_193);
																																										return
																																											BgL_zc3z04anonymousza32869ze3z87_13917;
																																									}
																																								}
																																							else
																																								{	/* Eval/evaluate_comp.scm 1021 */
																																									if ((BgL_valz00_3202 == BGl_zc3zd3fxzd2envzc2zz__r4_numbers_6_5_fixnumz00))
																																										{	/* Eval/evaluate_comp.scm 1021 */
																																											obj_t
																																												BgL_a1z00_3359;
																																											obj_t
																																												BgL_a2z00_3360;
																																											BgL_a1z00_3359
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																											BgL_a2z00_3360
																																												=
																																												BGl_compz00zz__evaluate_compz00
																																												(
																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																											{	/* Eval/evaluate_comp.scm 1021 */
																																												obj_t
																																													BgL_zc3z04anonymousza32873ze3z87_13918;
																																												BgL_zc3z04anonymousza32873ze3z87_13918
																																													=
																																													MAKE_FX_PROCEDURE
																																													(BGl_z62zc3z04anonymousza32873ze3ze5zz__evaluate_compz00,
																																													(int)
																																													(((long) 1)), (int) (((long) 3)));
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32873ze3z87_13918,
																																													(int)
																																													(((long) 0)), BgL_a1z00_3359);
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32873ze3z87_13918,
																																													(int)
																																													(((long) 1)), BgL_a2z00_3360);
																																												PROCEDURE_SET
																																													(BgL_zc3z04anonymousza32873ze3z87_13918,
																																													(int)
																																													(((long) 2)), BgL_locz00_193);
																																												return
																																													BgL_zc3z04anonymousza32873ze3z87_13918;
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate_comp.scm 1021 */
																																											if ((BgL_valz00_3202 == BGl_ze3zd3fxzd2envze2zz__r4_numbers_6_5_fixnumz00))
																																												{	/* Eval/evaluate_comp.scm 1021 */
																																													obj_t
																																														BgL_a1z00_3369;
																																													obj_t
																																														BgL_a2z00_3370;
																																													BgL_a1z00_3369
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																													BgL_a2z00_3370
																																														=
																																														BGl_compz00zz__evaluate_compz00
																																														(
																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																													{	/* Eval/evaluate_comp.scm 1021 */
																																														obj_t
																																															BgL_zc3z04anonymousza32877ze3z87_13919;
																																														BgL_zc3z04anonymousza32877ze3z87_13919
																																															=
																																															MAKE_FX_PROCEDURE
																																															(BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00,
																																															(int)
																																															(((long) 1)), (int) (((long) 3)));
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32877ze3z87_13919,
																																															(int)
																																															(((long) 0)), BgL_a1z00_3369);
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32877ze3z87_13919,
																																															(int)
																																															(((long) 1)), BgL_a2z00_3370);
																																														PROCEDURE_SET
																																															(BgL_zc3z04anonymousza32877ze3z87_13919,
																																															(int)
																																															(((long) 2)), BgL_locz00_193);
																																														return
																																															BgL_zc3z04anonymousza32877ze3z87_13919;
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate_comp.scm 1021 */
																																													if ((BgL_valz00_3202 == BGl_zd3fxzd2envz01zz__r4_numbers_6_5_fixnumz00))
																																														{	/* Eval/evaluate_comp.scm 1021 */
																																															obj_t
																																																BgL_a1z00_3379;
																																															obj_t
																																																BgL_a2z00_3380;
																																															BgL_a1z00_3379
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																															BgL_a2z00_3380
																																																=
																																																BGl_compz00zz__evaluate_compz00
																																																(
																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																															{	/* Eval/evaluate_comp.scm 1021 */
																																																obj_t
																																																	BgL_zc3z04anonymousza32881ze3z87_13920;
																																																BgL_zc3z04anonymousza32881ze3z87_13920
																																																	=
																																																	MAKE_FX_PROCEDURE
																																																	(BGl_z62zc3z04anonymousza32881ze3ze5zz__evaluate_compz00,
																																																	(int)
																																																	(((long) 1)), (int) (((long) 3)));
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32881ze3z87_13920,
																																																	(int)
																																																	(((long) 0)), BgL_a1z00_3379);
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32881ze3z87_13920,
																																																	(int)
																																																	(((long) 1)), BgL_a2z00_3380);
																																																PROCEDURE_SET
																																																	(BgL_zc3z04anonymousza32881ze3z87_13920,
																																																	(int)
																																																	(((long) 2)), BgL_locz00_193);
																																																return
																																																	BgL_zc3z04anonymousza32881ze3z87_13920;
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate_comp.scm 1021 */
																																															if ((BgL_valz00_3202 == BGl_zb2flzd2envz60zz__r4_numbers_6_5_flonumz00))
																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																	obj_t
																																																		BgL_a1z00_3389;
																																																	obj_t
																																																		BgL_a2z00_3390;
																																																	BgL_a1z00_3389
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																	BgL_a2z00_3390
																																																		=
																																																		BGl_compz00zz__evaluate_compz00
																																																		(
																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																	{	/* Eval/evaluate_comp.scm 1021 */
																																																		obj_t
																																																			BgL_zc3z04anonymousza32885ze3z87_13921;
																																																		BgL_zc3z04anonymousza32885ze3z87_13921
																																																			=
																																																			MAKE_FX_PROCEDURE
																																																			(BGl_z62zc3z04anonymousza32885ze3ze5zz__evaluate_compz00,
																																																			(int)
																																																			(((long) 1)), (int) (((long) 3)));
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32885ze3z87_13921,
																																																			(int)
																																																			(((long) 0)), BgL_a1z00_3389);
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32885ze3z87_13921,
																																																			(int)
																																																			(((long) 1)), BgL_a2z00_3390);
																																																		PROCEDURE_SET
																																																			(BgL_zc3z04anonymousza32885ze3z87_13921,
																																																			(int)
																																																			(((long) 2)), BgL_locz00_193);
																																																		return
																																																			BgL_zc3z04anonymousza32885ze3z87_13921;
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																	if ((BgL_valz00_3202 == BGl_zd2flzd2envz00zz__r4_numbers_6_5_flonumz00))
																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																			obj_t
																																																				BgL_a1z00_3399;
																																																			obj_t
																																																				BgL_a2z00_3400;
																																																			BgL_a1z00_3399
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																			BgL_a2z00_3400
																																																				=
																																																				BGl_compz00zz__evaluate_compz00
																																																				(
																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																			{	/* Eval/evaluate_comp.scm 1021 */
																																																				obj_t
																																																					BgL_zc3z04anonymousza32889ze3z87_13922;
																																																				BgL_zc3z04anonymousza32889ze3z87_13922
																																																					=
																																																					MAKE_FX_PROCEDURE
																																																					(BGl_z62zc3z04anonymousza32889ze3ze5zz__evaluate_compz00,
																																																					(int)
																																																					(((long) 1)), (int) (((long) 3)));
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32889ze3z87_13922,
																																																					(int)
																																																					(((long) 0)), BgL_a1z00_3399);
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32889ze3z87_13922,
																																																					(int)
																																																					(((long) 1)), BgL_a2z00_3400);
																																																				PROCEDURE_SET
																																																					(BgL_zc3z04anonymousza32889ze3z87_13922,
																																																					(int)
																																																					(((long) 2)), BgL_locz00_193);
																																																				return
																																																					BgL_zc3z04anonymousza32889ze3z87_13922;
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																			if ((BgL_valz00_3202 == BGl_za2flzd2envz70zz__r4_numbers_6_5_flonumz00))
																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																					obj_t
																																																						BgL_a1z00_3409;
																																																					obj_t
																																																						BgL_a2z00_3410;
																																																					BgL_a1z00_3409
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																					BgL_a2z00_3410
																																																						=
																																																						BGl_compz00zz__evaluate_compz00
																																																						(
																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																					{	/* Eval/evaluate_comp.scm 1021 */
																																																						obj_t
																																																							BgL_zc3z04anonymousza32893ze3z87_13923;
																																																						BgL_zc3z04anonymousza32893ze3z87_13923
																																																							=
																																																							MAKE_FX_PROCEDURE
																																																							(BGl_z62zc3z04anonymousza32893ze3ze5zz__evaluate_compz00,
																																																							(int)
																																																							(((long) 1)), (int) (((long) 3)));
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32893ze3z87_13923,
																																																							(int)
																																																							(((long) 0)), BgL_a1z00_3409);
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32893ze3z87_13923,
																																																							(int)
																																																							(((long) 1)), BgL_a2z00_3410);
																																																						PROCEDURE_SET
																																																							(BgL_zc3z04anonymousza32893ze3z87_13923,
																																																							(int)
																																																							(((long) 2)), BgL_locz00_193);
																																																						return
																																																							BgL_zc3z04anonymousza32893ze3z87_13923;
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																					if ((BgL_valz00_3202 == BGl_zf2flzd2envz20zz__r4_numbers_6_5_flonumz00))
																																																						{	/* Eval/evaluate_comp.scm 1021 */
																																																							obj_t
																																																								BgL_a1z00_3419;
																																																							obj_t
																																																								BgL_a2z00_3420;
																																																							BgL_a1z00_3419
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																							BgL_a2z00_3420
																																																								=
																																																								BGl_compz00zz__evaluate_compz00
																																																								(
																																																								((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																							{	/* Eval/evaluate_comp.scm 1021 */
																																																								obj_t
																																																									BgL_zc3z04anonymousza32897ze3z87_13924;
																																																								BgL_zc3z04anonymousza32897ze3z87_13924
																																																									=
																																																									MAKE_FX_PROCEDURE
																																																									(BGl_z62zc3z04anonymousza32897ze3ze5zz__evaluate_compz00,
																																																									(int)
																																																									(((long) 1)), (int) (((long) 3)));
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32897ze3z87_13924,
																																																									(int)
																																																									(((long) 0)), BgL_a1z00_3419);
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32897ze3z87_13924,
																																																									(int)
																																																									(((long) 1)), BgL_a2z00_3420);
																																																								PROCEDURE_SET
																																																									(BgL_zc3z04anonymousza32897ze3z87_13924,
																																																									(int)
																																																									(((long) 2)), BgL_locz00_193);
																																																								return
																																																									BgL_zc3z04anonymousza32897ze3z87_13924;
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate_comp.scm 1021 */
																																																							if ((BgL_valz00_3202 == BGl_zc3flzd2envz11zz__r4_numbers_6_5_flonumz00))
																																																								{	/* Eval/evaluate_comp.scm 1021 */
																																																									obj_t
																																																										BgL_a1z00_3429;
																																																									obj_t
																																																										BgL_a2z00_3430;
																																																									BgL_a1z00_3429
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																									BgL_a2z00_3430
																																																										=
																																																										BGl_compz00zz__evaluate_compz00
																																																										(
																																																										((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																									{	/* Eval/evaluate_comp.scm 1021 */
																																																										obj_t
																																																											BgL_zc3z04anonymousza32901ze3z87_13925;
																																																										BgL_zc3z04anonymousza32901ze3z87_13925
																																																											=
																																																											MAKE_FX_PROCEDURE
																																																											(BGl_z62zc3z04anonymousza32901ze3ze5zz__evaluate_compz00,
																																																											(int)
																																																											(((long) 1)), (int) (((long) 3)));
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32901ze3z87_13925,
																																																											(int)
																																																											(((long) 0)), BgL_a1z00_3429);
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32901ze3z87_13925,
																																																											(int)
																																																											(((long) 1)), BgL_a2z00_3430);
																																																										PROCEDURE_SET
																																																											(BgL_zc3z04anonymousza32901ze3z87_13925,
																																																											(int)
																																																											(((long) 2)), BgL_locz00_193);
																																																										return
																																																											BgL_zc3z04anonymousza32901ze3z87_13925;
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate_comp.scm 1021 */
																																																									if ((BgL_valz00_3202 == BGl_ze3flzd2envz31zz__r4_numbers_6_5_flonumz00))
																																																										{	/* Eval/evaluate_comp.scm 1021 */
																																																											obj_t
																																																												BgL_a1z00_3439;
																																																											obj_t
																																																												BgL_a2z00_3440;
																																																											BgL_a1z00_3439
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																											BgL_a2z00_3440
																																																												=
																																																												BGl_compz00zz__evaluate_compz00
																																																												(
																																																												((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																											{	/* Eval/evaluate_comp.scm 1021 */
																																																												obj_t
																																																													BgL_zc3z04anonymousza32905ze3z87_13926;
																																																												BgL_zc3z04anonymousza32905ze3z87_13926
																																																													=
																																																													MAKE_FX_PROCEDURE
																																																													(BGl_z62zc3z04anonymousza32905ze3ze5zz__evaluate_compz00,
																																																													(int)
																																																													(((long) 1)), (int) (((long) 3)));
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32905ze3z87_13926,
																																																													(int)
																																																													(((long) 0)), BgL_a1z00_3439);
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32905ze3z87_13926,
																																																													(int)
																																																													(((long) 1)), BgL_a2z00_3440);
																																																												PROCEDURE_SET
																																																													(BgL_zc3z04anonymousza32905ze3z87_13926,
																																																													(int)
																																																													(((long) 2)), BgL_locz00_193);
																																																												return
																																																													BgL_zc3z04anonymousza32905ze3z87_13926;
																																																											}
																																																										}
																																																									else
																																																										{	/* Eval/evaluate_comp.scm 1021 */
																																																											if ((BgL_valz00_3202 == BGl_zc3zd3flzd2envzc2zz__r4_numbers_6_5_flonumz00))
																																																												{	/* Eval/evaluate_comp.scm 1021 */
																																																													obj_t
																																																														BgL_a1z00_3449;
																																																													obj_t
																																																														BgL_a2z00_3450;
																																																													BgL_a1z00_3449
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																													BgL_a2z00_3450
																																																														=
																																																														BGl_compz00zz__evaluate_compz00
																																																														(
																																																														((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																													{	/* Eval/evaluate_comp.scm 1021 */
																																																														obj_t
																																																															BgL_zc3z04anonymousza32909ze3z87_13927;
																																																														BgL_zc3z04anonymousza32909ze3z87_13927
																																																															=
																																																															MAKE_FX_PROCEDURE
																																																															(BGl_z62zc3z04anonymousza32909ze3ze5zz__evaluate_compz00,
																																																															(int)
																																																															(((long) 1)), (int) (((long) 3)));
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32909ze3z87_13927,
																																																															(int)
																																																															(((long) 0)), BgL_a1z00_3449);
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32909ze3z87_13927,
																																																															(int)
																																																															(((long) 1)), BgL_a2z00_3450);
																																																														PROCEDURE_SET
																																																															(BgL_zc3z04anonymousza32909ze3z87_13927,
																																																															(int)
																																																															(((long) 2)), BgL_locz00_193);
																																																														return
																																																															BgL_zc3z04anonymousza32909ze3z87_13927;
																																																													}
																																																												}
																																																											else
																																																												{	/* Eval/evaluate_comp.scm 1021 */
																																																													if ((BgL_valz00_3202 == BGl_ze3zd3flzd2envze2zz__r4_numbers_6_5_flonumz00))
																																																														{	/* Eval/evaluate_comp.scm 1021 */
																																																															obj_t
																																																																BgL_a1z00_3459;
																																																															obj_t
																																																																BgL_a2z00_3460;
																																																															BgL_a1z00_3459
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																															BgL_a2z00_3460
																																																																=
																																																																BGl_compz00zz__evaluate_compz00
																																																																(
																																																																((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																															{	/* Eval/evaluate_comp.scm 1021 */
																																																																obj_t
																																																																	BgL_zc3z04anonymousza32913ze3z87_13928;
																																																																BgL_zc3z04anonymousza32913ze3z87_13928
																																																																	=
																																																																	MAKE_FX_PROCEDURE
																																																																	(BGl_z62zc3z04anonymousza32913ze3ze5zz__evaluate_compz00,
																																																																	(int)
																																																																	(((long) 1)), (int) (((long) 3)));
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32913ze3z87_13928,
																																																																	(int)
																																																																	(((long) 0)), BgL_a1z00_3459);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32913ze3z87_13928,
																																																																	(int)
																																																																	(((long) 1)), BgL_a2z00_3460);
																																																																PROCEDURE_SET
																																																																	(BgL_zc3z04anonymousza32913ze3z87_13928,
																																																																	(int)
																																																																	(((long) 2)), BgL_locz00_193);
																																																																return
																																																																	BgL_zc3z04anonymousza32913ze3z87_13928;
																																																															}
																																																														}
																																																													else
																																																														{	/* Eval/evaluate_comp.scm 1021 */
																																																															if ((BgL_valz00_3202 == BGl_zd3flzd2envz01zz__r4_numbers_6_5_flonumz00))
																																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																																	obj_t
																																																																		BgL_a1z00_3469;
																																																																	obj_t
																																																																		BgL_a2z00_3470;
																																																																	BgL_a1z00_3469
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																																	BgL_a2z00_3470
																																																																		=
																																																																		BGl_compz00zz__evaluate_compz00
																																																																		(
																																																																		((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																																	{	/* Eval/evaluate_comp.scm 1021 */
																																																																		obj_t
																																																																			BgL_zc3z04anonymousza32917ze3z87_13929;
																																																																		BgL_zc3z04anonymousza32917ze3z87_13929
																																																																			=
																																																																			MAKE_FX_PROCEDURE
																																																																			(BGl_z62zc3z04anonymousza32917ze3ze5zz__evaluate_compz00,
																																																																			(int)
																																																																			(((long) 1)), (int) (((long) 3)));
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32917ze3z87_13929,
																																																																			(int)
																																																																			(((long) 0)), BgL_a1z00_3469);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32917ze3z87_13929,
																																																																			(int)
																																																																			(((long) 1)), BgL_a2z00_3470);
																																																																		PROCEDURE_SET
																																																																			(BgL_zc3z04anonymousza32917ze3z87_13929,
																																																																			(int)
																																																																			(((long) 2)), BgL_locz00_193);
																																																																		return
																																																																			BgL_zc3z04anonymousza32917ze3z87_13929;
																																																																	}
																																																																}
																																																															else
																																																																{	/* Eval/evaluate_comp.scm 1021 */
																																																																	if ((BgL_valz00_3202 == BGl_eqzf3zd2envz21zz__r4_equivalence_6_2z00))
																																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																																			obj_t
																																																																				BgL_a1z00_3479;
																																																																			obj_t
																																																																				BgL_a2z00_3480;
																																																																			BgL_a1z00_3479
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																																			BgL_a2z00_3480
																																																																				=
																																																																				BGl_compz00zz__evaluate_compz00
																																																																				(
																																																																				((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																																			{	/* Eval/evaluate_comp.scm 1021 */
																																																																				obj_t
																																																																					BgL_zc3z04anonymousza32921ze3z87_13930;
																																																																				BgL_zc3z04anonymousza32921ze3z87_13930
																																																																					=
																																																																					MAKE_FX_PROCEDURE
																																																																					(BGl_z62zc3z04anonymousza32921ze3ze5zz__evaluate_compz00,
																																																																					(int)
																																																																					(((long) 1)), (int) (((long) 2)));
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3z04anonymousza32921ze3z87_13930,
																																																																					(int)
																																																																					(((long) 0)), BgL_a1z00_3479);
																																																																				PROCEDURE_SET
																																																																					(BgL_zc3z04anonymousza32921ze3z87_13930,
																																																																					(int)
																																																																					(((long) 1)), BgL_a2z00_3480);
																																																																				return
																																																																					BgL_zc3z04anonymousza32921ze3z87_13930;
																																																																			}
																																																																		}
																																																																	else
																																																																		{	/* Eval/evaluate_comp.scm 1021 */
																																																																			if ((BgL_valz00_3202 == BGl_conszd2envzd2zz__r4_pairs_and_lists_6_3z00))
																																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																																					obj_t
																																																																						BgL_a1z00_3487;
																																																																					obj_t
																																																																						BgL_a2z00_3488;
																																																																					BgL_a1z00_3487
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a1z00_3206), BgL_stkz00_196);
																																																																					BgL_a2z00_3488
																																																																						=
																																																																						BGl_compz00zz__evaluate_compz00
																																																																						(
																																																																						((BgL_ev_exprz00_bglt) BgL_a2z00_3207), BgL_stkz00_196);
																																																																					{	/* Eval/evaluate_comp.scm 1021 */
																																																																						obj_t
																																																																							BgL_zc3z04anonymousza32923ze3z87_13931;
																																																																						BgL_zc3z04anonymousza32923ze3z87_13931
																																																																							=
																																																																							MAKE_FX_PROCEDURE
																																																																							(BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00,
																																																																							(int)
																																																																							(((long) 1)), (int) (((long) 2)));
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3z04anonymousza32923ze3z87_13931,
																																																																							(int)
																																																																							(((long) 0)), BgL_a1z00_3487);
																																																																						PROCEDURE_SET
																																																																							(BgL_zc3z04anonymousza32923ze3z87_13931,
																																																																							(int)
																																																																							(((long) 1)), BgL_a2z00_3488);
																																																																						return
																																																																							BgL_zc3z04anonymousza32923ze3z87_13931;
																																																																					}
																																																																				}
																																																																			else
																																																																				{	/* Eval/evaluate_comp.scm 1021 */
																																																																					return
																																																																						BFALSE;
																																																																				}
																																																																		}
																																																																}
																																																														}
																																																												}
																																																										}
																																																								}
																																																						}
																																																				}
																																																		}
																																																}
																																														}
																																												}
																																										}
																																								}
																																						}
																																				}
																																		}
																																}
																														}
																												}
																										}
																								}
																						}
																				}
																		}
																}
														}
												}
										}
									else
										{	/* Eval/evaluate_comp.scm 1019 */
											return BFALSE;
										}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 1014 */
						return BFALSE;
					}
			}
		}

	}



/* &<@anonymous:2813> */
	obj_t BGl_z62zc3z04anonymousza32813ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13935, obj_t BgL_sz00_13939)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13936;
				obj_t BgL_a2z00_13937;
				obj_t BgL_locz00_13938;

				BgL_a1z00_13936 = PROCEDURE_REF(BgL_envz00_13935, (int) (((long) 0)));
				BgL_a2z00_13937 = PROCEDURE_REF(BgL_envz00_13935, (int) (((long) 1)));
				BgL_locz00_13938 = PROCEDURE_REF(BgL_envz00_13935, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16495;

					BgL_bpz00_16495 = VECTOR_REF(((obj_t) BgL_sz00_13939), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16496;
						obj_t BgL_a2z00_16497;

						BgL_a1z00_16496 =
							PROCEDURE_ENTRY(BgL_a1z00_13936) (BgL_a1z00_13936, BgL_sz00_13939,
							BEOA);
						BgL_a2z00_16497 =
							PROCEDURE_ENTRY(BgL_a2z00_13937) (BgL_a2z00_13937, BgL_sz00_13939,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16496))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5867z00zz__evaluate_compz00,
									BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16496,
									BgL_locz00_13938);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16497))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5867z00zz__evaluate_compz00,
									BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16497,
									BgL_locz00_13938);
							}
						return
							BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_a1z00_16496,
							BgL_a2z00_16497);
					}
				}
			}
		}

	}



/* &<@anonymous:2817> */
	obj_t BGl_z62zc3z04anonymousza32817ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13940, obj_t BgL_sz00_13944)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13941;
				obj_t BgL_a2z00_13942;
				obj_t BgL_locz00_13943;

				BgL_a1z00_13941 = PROCEDURE_REF(BgL_envz00_13940, (int) (((long) 0)));
				BgL_a2z00_13942 = PROCEDURE_REF(BgL_envz00_13940, (int) (((long) 1)));
				BgL_locz00_13943 = PROCEDURE_REF(BgL_envz00_13940, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16498;

					BgL_bpz00_16498 = VECTOR_REF(((obj_t) BgL_sz00_13944), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16499;
						obj_t BgL_a2z00_16500;

						BgL_a1z00_16499 =
							PROCEDURE_ENTRY(BgL_a1z00_13941) (BgL_a1z00_13941, BgL_sz00_13944,
							BEOA);
						BgL_a2z00_16500 =
							PROCEDURE_ENTRY(BgL_a2z00_13942) (BgL_a2z00_13942, BgL_sz00_13944,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16499))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5871z00zz__evaluate_compz00,
									BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16499,
									BgL_locz00_13943);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16500))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5871z00zz__evaluate_compz00,
									BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16500,
									BgL_locz00_13943);
							}
						return
							BGl_2zd2zd2zz__r4_numbers_6_5z00(BgL_a1z00_16499,
							BgL_a2z00_16500);
					}
				}
			}
		}

	}



/* &<@anonymous:2821> */
	obj_t BGl_z62zc3z04anonymousza32821ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13945, obj_t BgL_sz00_13949)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13946;
				obj_t BgL_a2z00_13947;
				obj_t BgL_locz00_13948;

				BgL_a1z00_13946 = PROCEDURE_REF(BgL_envz00_13945, (int) (((long) 0)));
				BgL_a2z00_13947 = PROCEDURE_REF(BgL_envz00_13945, (int) (((long) 1)));
				BgL_locz00_13948 = PROCEDURE_REF(BgL_envz00_13945, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16501;

					BgL_bpz00_16501 = VECTOR_REF(((obj_t) BgL_sz00_13949), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16502;
						obj_t BgL_a2z00_16503;

						BgL_a1z00_16502 =
							PROCEDURE_ENTRY(BgL_a1z00_13946) (BgL_a1z00_13946, BgL_sz00_13949,
							BEOA);
						BgL_a2z00_16503 =
							PROCEDURE_ENTRY(BgL_a2z00_13947) (BgL_a2z00_13947, BgL_sz00_13949,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16502))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5873z00zz__evaluate_compz00,
									BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16502,
									BgL_locz00_13948);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16503))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5873z00zz__evaluate_compz00,
									BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16503,
									BgL_locz00_13948);
							}
						return
							BGl_2za2za2zz__r4_numbers_6_5z00(BgL_a1z00_16502,
							BgL_a2z00_16503);
					}
				}
			}
		}

	}



/* &<@anonymous:2825> */
	obj_t BGl_z62zc3z04anonymousza32825ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13950, obj_t BgL_sz00_13954)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13951;
				obj_t BgL_a2z00_13952;
				obj_t BgL_locz00_13953;

				BgL_a1z00_13951 = PROCEDURE_REF(BgL_envz00_13950, (int) (((long) 0)));
				BgL_a2z00_13952 = PROCEDURE_REF(BgL_envz00_13950, (int) (((long) 1)));
				BgL_locz00_13953 = PROCEDURE_REF(BgL_envz00_13950, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16504;

					BgL_bpz00_16504 = VECTOR_REF(((obj_t) BgL_sz00_13954), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16505;
						obj_t BgL_a2z00_16506;

						BgL_a1z00_16505 =
							PROCEDURE_ENTRY(BgL_a1z00_13951) (BgL_a1z00_13951, BgL_sz00_13954,
							BEOA);
						BgL_a2z00_16506 =
							PROCEDURE_ENTRY(BgL_a2z00_13952) (BgL_a2z00_13952, BgL_sz00_13954,
							BEOA);
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16505))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5875z00zz__evaluate_compz00,
									BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16505,
									BgL_locz00_13953);
							}
						if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16506))
							{	/* Eval/evaluate_comp.scm 1021 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1021 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5875z00zz__evaluate_compz00,
									BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16506,
									BgL_locz00_13953);
							}
						return
							BGl_2zf2zf2zz__r4_numbers_6_5z00(BgL_a1z00_16505,
							BgL_a2z00_16506);
					}
				}
			}
		}

	}



/* &<@anonymous:2829> */
	obj_t BGl_z62zc3z04anonymousza32829ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13955, obj_t BgL_sz00_13959)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13956;
				obj_t BgL_a2z00_13957;
				obj_t BgL_locz00_13958;

				BgL_a1z00_13956 = PROCEDURE_REF(BgL_envz00_13955, (int) (((long) 0)));
				BgL_a2z00_13957 = PROCEDURE_REF(BgL_envz00_13955, (int) (((long) 1)));
				BgL_locz00_13958 = PROCEDURE_REF(BgL_envz00_13955, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24656;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16507;

						BgL_bpz00_16507 = VECTOR_REF(((obj_t) BgL_sz00_13959), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16508;
							obj_t BgL_a2z00_16509;

							BgL_a1z00_16508 =
								PROCEDURE_ENTRY(BgL_a1z00_13956) (BgL_a1z00_13956,
								BgL_sz00_13959, BEOA);
							BgL_a2z00_16509 =
								PROCEDURE_ENTRY(BgL_a2z00_13957) (BgL_a2z00_13957,
								BgL_sz00_13959, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16508))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5877z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16508,
										BgL_locz00_13958);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16509))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5877z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16509,
										BgL_locz00_13958);
								}
							BgL_tmpz00_24656 =
								BGl_2zc3zc3zz__r4_numbers_6_5z00(BgL_a1z00_16508,
								BgL_a2z00_16509);
						}
					}
					return BBOOL(BgL_tmpz00_24656);
				}
			}
		}

	}



/* &<@anonymous:2833> */
	obj_t BGl_z62zc3z04anonymousza32833ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13960, obj_t BgL_sz00_13964)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13961;
				obj_t BgL_a2z00_13962;
				obj_t BgL_locz00_13963;

				BgL_a1z00_13961 = PROCEDURE_REF(BgL_envz00_13960, (int) (((long) 0)));
				BgL_a2z00_13962 = PROCEDURE_REF(BgL_envz00_13960, (int) (((long) 1)));
				BgL_locz00_13963 = PROCEDURE_REF(BgL_envz00_13960, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24681;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16510;

						BgL_bpz00_16510 = VECTOR_REF(((obj_t) BgL_sz00_13964), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16511;
							obj_t BgL_a2z00_16512;

							BgL_a1z00_16511 =
								PROCEDURE_ENTRY(BgL_a1z00_13961) (BgL_a1z00_13961,
								BgL_sz00_13964, BEOA);
							BgL_a2z00_16512 =
								PROCEDURE_ENTRY(BgL_a2z00_13962) (BgL_a2z00_13962,
								BgL_sz00_13964, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16511))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5879z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16511,
										BgL_locz00_13963);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16512))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5879z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16512,
										BgL_locz00_13963);
								}
							BgL_tmpz00_24681 =
								BGl_2ze3ze3zz__r4_numbers_6_5z00(BgL_a1z00_16511,
								BgL_a2z00_16512);
						}
					}
					return BBOOL(BgL_tmpz00_24681);
				}
			}
		}

	}



/* &<@anonymous:2837> */
	obj_t BGl_z62zc3z04anonymousza32837ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13965, obj_t BgL_sz00_13969)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13966;
				obj_t BgL_a2z00_13967;
				obj_t BgL_locz00_13968;

				BgL_a1z00_13966 = PROCEDURE_REF(BgL_envz00_13965, (int) (((long) 0)));
				BgL_a2z00_13967 = PROCEDURE_REF(BgL_envz00_13965, (int) (((long) 1)));
				BgL_locz00_13968 = PROCEDURE_REF(BgL_envz00_13965, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24706;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16513;

						BgL_bpz00_16513 = VECTOR_REF(((obj_t) BgL_sz00_13969), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16514;
							obj_t BgL_a2z00_16515;

							BgL_a1z00_16514 =
								PROCEDURE_ENTRY(BgL_a1z00_13966) (BgL_a1z00_13966,
								BgL_sz00_13969, BEOA);
							BgL_a2z00_16515 =
								PROCEDURE_ENTRY(BgL_a2z00_13967) (BgL_a2z00_13967,
								BgL_sz00_13969, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16514))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5881z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16514,
										BgL_locz00_13968);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16515))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5881z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16515,
										BgL_locz00_13968);
								}
							BgL_tmpz00_24706 =
								BGl_2zc3zd3z10zz__r4_numbers_6_5z00(BgL_a1z00_16514,
								BgL_a2z00_16515);
						}
					}
					return BBOOL(BgL_tmpz00_24706);
				}
			}
		}

	}



/* &<@anonymous:2841> */
	obj_t BGl_z62zc3z04anonymousza32841ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13970, obj_t BgL_sz00_13974)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13971;
				obj_t BgL_a2z00_13972;
				obj_t BgL_locz00_13973;

				BgL_a1z00_13971 = PROCEDURE_REF(BgL_envz00_13970, (int) (((long) 0)));
				BgL_a2z00_13972 = PROCEDURE_REF(BgL_envz00_13970, (int) (((long) 1)));
				BgL_locz00_13973 = PROCEDURE_REF(BgL_envz00_13970, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24731;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16516;

						BgL_bpz00_16516 = VECTOR_REF(((obj_t) BgL_sz00_13974), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16517;
							obj_t BgL_a2z00_16518;

							BgL_a1z00_16517 =
								PROCEDURE_ENTRY(BgL_a1z00_13971) (BgL_a1z00_13971,
								BgL_sz00_13974, BEOA);
							BgL_a2z00_16518 =
								PROCEDURE_ENTRY(BgL_a2z00_13972) (BgL_a2z00_13972,
								BgL_sz00_13974, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16517))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5883z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16517,
										BgL_locz00_13973);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16518))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5883z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16518,
										BgL_locz00_13973);
								}
							BgL_tmpz00_24731 =
								BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_a1z00_16517,
								BgL_a2z00_16518);
						}
					}
					return BBOOL(BgL_tmpz00_24731);
				}
			}
		}

	}



/* &<@anonymous:2845> */
	obj_t BGl_z62zc3z04anonymousza32845ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13975, obj_t BgL_sz00_13979)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13976;
				obj_t BgL_a2z00_13977;
				obj_t BgL_locz00_13978;

				BgL_a1z00_13976 = PROCEDURE_REF(BgL_envz00_13975, (int) (((long) 0)));
				BgL_a2z00_13977 = PROCEDURE_REF(BgL_envz00_13975, (int) (((long) 1)));
				BgL_locz00_13978 = PROCEDURE_REF(BgL_envz00_13975, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24756;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16519;

						BgL_bpz00_16519 = VECTOR_REF(((obj_t) BgL_sz00_13979), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16520;
							obj_t BgL_a2z00_16521;

							BgL_a1z00_16520 =
								PROCEDURE_ENTRY(BgL_a1z00_13976) (BgL_a1z00_13976,
								BgL_sz00_13979, BEOA);
							BgL_a2z00_16521 =
								PROCEDURE_ENTRY(BgL_a2z00_13977) (BgL_a2z00_13977,
								BgL_sz00_13979, BEOA);
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a1z00_16520))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5885z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a1z00_16520,
										BgL_locz00_13978);
								}
							if (BGl_numberzf3zf3zz__r4_numbers_6_5z00(BgL_a2z00_16521))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5885z00zz__evaluate_compz00,
										BGl_symbol5869z00zz__evaluate_compz00, BgL_a2z00_16521,
										BgL_locz00_13978);
								}
							BgL_tmpz00_24756 =
								BGl_2zd3zd3zz__r4_numbers_6_5z00(BgL_a1z00_16520,
								BgL_a2z00_16521);
						}
					}
					return BBOOL(BgL_tmpz00_24756);
				}
			}
		}

	}



/* &<@anonymous:2849> */
	obj_t BGl_z62zc3z04anonymousza32849ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13980, obj_t BgL_sz00_13984)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13981;
				obj_t BgL_a2z00_13982;
				obj_t BgL_locz00_13983;

				BgL_a1z00_13981 = PROCEDURE_REF(BgL_envz00_13980, (int) (((long) 0)));
				BgL_a2z00_13982 = PROCEDURE_REF(BgL_envz00_13980, (int) (((long) 1)));
				BgL_locz00_13983 = PROCEDURE_REF(BgL_envz00_13980, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_24781;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16522;

						BgL_bpz00_16522 = VECTOR_REF(((obj_t) BgL_sz00_13984), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16523;
							obj_t BgL_a2z00_16524;

							BgL_a1z00_16523 =
								PROCEDURE_ENTRY(BgL_a1z00_13981) (BgL_a1z00_13981,
								BgL_sz00_13984, BEOA);
							BgL_a2z00_16524 =
								PROCEDURE_ENTRY(BgL_a2z00_13982) (BgL_a2z00_13982,
								BgL_sz00_13984, BEOA);
							if (INTEGERP(BgL_a1z00_16523))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5887z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16523,
										BgL_locz00_13983);
								}
							if (INTEGERP(BgL_a2z00_16524))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5887z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16524,
										BgL_locz00_13983);
								}
							BgL_tmpz00_24781 =
								((long) CINT(BgL_a1z00_16523) + (long) CINT(BgL_a2z00_16524));
					}}
					return BINT(BgL_tmpz00_24781);
				}
			}
		}

	}



/* &<@anonymous:2853> */
	obj_t BGl_z62zc3z04anonymousza32853ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13985, obj_t BgL_sz00_13989)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13986;
				obj_t BgL_a2z00_13987;
				obj_t BgL_locz00_13988;

				BgL_a1z00_13986 = PROCEDURE_REF(BgL_envz00_13985, (int) (((long) 0)));
				BgL_a2z00_13987 = PROCEDURE_REF(BgL_envz00_13985, (int) (((long) 1)));
				BgL_locz00_13988 = PROCEDURE_REF(BgL_envz00_13985, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_24808;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16525;

						BgL_bpz00_16525 = VECTOR_REF(((obj_t) BgL_sz00_13989), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16526;
							obj_t BgL_a2z00_16527;

							BgL_a1z00_16526 =
								PROCEDURE_ENTRY(BgL_a1z00_13986) (BgL_a1z00_13986,
								BgL_sz00_13989, BEOA);
							BgL_a2z00_16527 =
								PROCEDURE_ENTRY(BgL_a2z00_13987) (BgL_a2z00_13987,
								BgL_sz00_13989, BEOA);
							if (INTEGERP(BgL_a1z00_16526))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5891z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16526,
										BgL_locz00_13988);
								}
							if (INTEGERP(BgL_a2z00_16527))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5891z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16527,
										BgL_locz00_13988);
								}
							BgL_tmpz00_24808 =
								((long) CINT(BgL_a1z00_16526) - (long) CINT(BgL_a2z00_16527));
					}}
					return BINT(BgL_tmpz00_24808);
				}
			}
		}

	}



/* &<@anonymous:2857> */
	obj_t BGl_z62zc3z04anonymousza32857ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13990, obj_t BgL_sz00_13994)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13991;
				obj_t BgL_a2z00_13992;
				obj_t BgL_locz00_13993;

				BgL_a1z00_13991 = PROCEDURE_REF(BgL_envz00_13990, (int) (((long) 0)));
				BgL_a2z00_13992 = PROCEDURE_REF(BgL_envz00_13990, (int) (((long) 1)));
				BgL_locz00_13993 = PROCEDURE_REF(BgL_envz00_13990, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_24835;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16528;

						BgL_bpz00_16528 = VECTOR_REF(((obj_t) BgL_sz00_13994), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16529;
							obj_t BgL_a2z00_16530;

							BgL_a1z00_16529 =
								PROCEDURE_ENTRY(BgL_a1z00_13991) (BgL_a1z00_13991,
								BgL_sz00_13994, BEOA);
							BgL_a2z00_16530 =
								PROCEDURE_ENTRY(BgL_a2z00_13992) (BgL_a2z00_13992,
								BgL_sz00_13994, BEOA);
							if (INTEGERP(BgL_a1z00_16529))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5893z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16529,
										BgL_locz00_13993);
								}
							if (INTEGERP(BgL_a2z00_16530))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5893z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16530,
										BgL_locz00_13993);
								}
							BgL_tmpz00_24835 =
								((long) CINT(BgL_a1z00_16529) * (long) CINT(BgL_a2z00_16530));
					}}
					return BINT(BgL_tmpz00_24835);
				}
			}
		}

	}



/* &<@anonymous:2861> */
	obj_t BGl_z62zc3z04anonymousza32861ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_13995, obj_t BgL_sz00_13999)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_13996;
				obj_t BgL_a2z00_13997;
				obj_t BgL_locz00_13998;

				BgL_a1z00_13996 = PROCEDURE_REF(BgL_envz00_13995, (int) (((long) 0)));
				BgL_a2z00_13997 = PROCEDURE_REF(BgL_envz00_13995, (int) (((long) 1)));
				BgL_locz00_13998 = PROCEDURE_REF(BgL_envz00_13995, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					long BgL_tmpz00_24862;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16531;

						BgL_bpz00_16531 = VECTOR_REF(((obj_t) BgL_sz00_13999), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16532;
							obj_t BgL_a2z00_16533;

							BgL_a1z00_16532 =
								PROCEDURE_ENTRY(BgL_a1z00_13996) (BgL_a1z00_13996,
								BgL_sz00_13999, BEOA);
							BgL_a2z00_16533 =
								PROCEDURE_ENTRY(BgL_a2z00_13997) (BgL_a2z00_13997,
								BgL_sz00_13999, BEOA);
							if (INTEGERP(BgL_a1z00_16532))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5895z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16532,
										BgL_locz00_13998);
								}
							if (INTEGERP(BgL_a2z00_16533))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5895z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16533,
										BgL_locz00_13998);
								}
							BgL_tmpz00_24862 =
								((long) CINT(BgL_a1z00_16532) / (long) CINT(BgL_a2z00_16533));
					}}
					return BINT(BgL_tmpz00_24862);
				}
			}
		}

	}



/* &<@anonymous:2865> */
	obj_t BGl_z62zc3z04anonymousza32865ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14000, obj_t BgL_sz00_14004)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14001;
				obj_t BgL_a2z00_14002;
				obj_t BgL_locz00_14003;

				BgL_a1z00_14001 = PROCEDURE_REF(BgL_envz00_14000, (int) (((long) 0)));
				BgL_a2z00_14002 = PROCEDURE_REF(BgL_envz00_14000, (int) (((long) 1)));
				BgL_locz00_14003 = PROCEDURE_REF(BgL_envz00_14000, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24889;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16534;

						BgL_bpz00_16534 = VECTOR_REF(((obj_t) BgL_sz00_14004), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16535;
							obj_t BgL_a2z00_16536;

							BgL_a1z00_16535 =
								PROCEDURE_ENTRY(BgL_a1z00_14001) (BgL_a1z00_14001,
								BgL_sz00_14004, BEOA);
							BgL_a2z00_16536 =
								PROCEDURE_ENTRY(BgL_a2z00_14002) (BgL_a2z00_14002,
								BgL_sz00_14004, BEOA);
							if (INTEGERP(BgL_a1z00_16535))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5897z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16535,
										BgL_locz00_14003);
								}
							if (INTEGERP(BgL_a2z00_16536))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5897z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16536,
										BgL_locz00_14003);
								}
							BgL_tmpz00_24889 =
								((long) CINT(BgL_a1z00_16535) < (long) CINT(BgL_a2z00_16536));
					}}
					return BBOOL(BgL_tmpz00_24889);
				}
			}
		}

	}



/* &<@anonymous:2869> */
	obj_t BGl_z62zc3z04anonymousza32869ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14005, obj_t BgL_sz00_14009)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14006;
				obj_t BgL_a2z00_14007;
				obj_t BgL_locz00_14008;

				BgL_a1z00_14006 = PROCEDURE_REF(BgL_envz00_14005, (int) (((long) 0)));
				BgL_a2z00_14007 = PROCEDURE_REF(BgL_envz00_14005, (int) (((long) 1)));
				BgL_locz00_14008 = PROCEDURE_REF(BgL_envz00_14005, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24916;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16537;

						BgL_bpz00_16537 = VECTOR_REF(((obj_t) BgL_sz00_14009), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16538;
							obj_t BgL_a2z00_16539;

							BgL_a1z00_16538 =
								PROCEDURE_ENTRY(BgL_a1z00_14006) (BgL_a1z00_14006,
								BgL_sz00_14009, BEOA);
							BgL_a2z00_16539 =
								PROCEDURE_ENTRY(BgL_a2z00_14007) (BgL_a2z00_14007,
								BgL_sz00_14009, BEOA);
							if (INTEGERP(BgL_a1z00_16538))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5899z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16538,
										BgL_locz00_14008);
								}
							if (INTEGERP(BgL_a2z00_16539))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5899z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16539,
										BgL_locz00_14008);
								}
							BgL_tmpz00_24916 =
								((long) CINT(BgL_a1z00_16538) > (long) CINT(BgL_a2z00_16539));
					}}
					return BBOOL(BgL_tmpz00_24916);
				}
			}
		}

	}



/* &<@anonymous:2873> */
	obj_t BGl_z62zc3z04anonymousza32873ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14010, obj_t BgL_sz00_14014)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14011;
				obj_t BgL_a2z00_14012;
				obj_t BgL_locz00_14013;

				BgL_a1z00_14011 = PROCEDURE_REF(BgL_envz00_14010, (int) (((long) 0)));
				BgL_a2z00_14012 = PROCEDURE_REF(BgL_envz00_14010, (int) (((long) 1)));
				BgL_locz00_14013 = PROCEDURE_REF(BgL_envz00_14010, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24943;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16540;

						BgL_bpz00_16540 = VECTOR_REF(((obj_t) BgL_sz00_14014), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16541;
							obj_t BgL_a2z00_16542;

							BgL_a1z00_16541 =
								PROCEDURE_ENTRY(BgL_a1z00_14011) (BgL_a1z00_14011,
								BgL_sz00_14014, BEOA);
							BgL_a2z00_16542 =
								PROCEDURE_ENTRY(BgL_a2z00_14012) (BgL_a2z00_14012,
								BgL_sz00_14014, BEOA);
							if (INTEGERP(BgL_a1z00_16541))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5901z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16541,
										BgL_locz00_14013);
								}
							if (INTEGERP(BgL_a2z00_16542))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5901z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16542,
										BgL_locz00_14013);
								}
							BgL_tmpz00_24943 =
								((long) CINT(BgL_a1z00_16541) <= (long) CINT(BgL_a2z00_16542));
					}}
					return BBOOL(BgL_tmpz00_24943);
				}
			}
		}

	}



/* &<@anonymous:2877> */
	obj_t BGl_z62zc3z04anonymousza32877ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14015, obj_t BgL_sz00_14019)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14016;
				obj_t BgL_a2z00_14017;
				obj_t BgL_locz00_14018;

				BgL_a1z00_14016 = PROCEDURE_REF(BgL_envz00_14015, (int) (((long) 0)));
				BgL_a2z00_14017 = PROCEDURE_REF(BgL_envz00_14015, (int) (((long) 1)));
				BgL_locz00_14018 = PROCEDURE_REF(BgL_envz00_14015, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24970;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16543;

						BgL_bpz00_16543 = VECTOR_REF(((obj_t) BgL_sz00_14019), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16544;
							obj_t BgL_a2z00_16545;

							BgL_a1z00_16544 =
								PROCEDURE_ENTRY(BgL_a1z00_14016) (BgL_a1z00_14016,
								BgL_sz00_14019, BEOA);
							BgL_a2z00_16545 =
								PROCEDURE_ENTRY(BgL_a2z00_14017) (BgL_a2z00_14017,
								BgL_sz00_14019, BEOA);
							if (INTEGERP(BgL_a1z00_16544))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5903z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16544,
										BgL_locz00_14018);
								}
							if (INTEGERP(BgL_a2z00_16545))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5903z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16545,
										BgL_locz00_14018);
								}
							BgL_tmpz00_24970 =
								((long) CINT(BgL_a1z00_16544) >= (long) CINT(BgL_a2z00_16545));
					}}
					return BBOOL(BgL_tmpz00_24970);
				}
			}
		}

	}



/* &<@anonymous:2881> */
	obj_t BGl_z62zc3z04anonymousza32881ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14020, obj_t BgL_sz00_14024)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14021;
				obj_t BgL_a2z00_14022;
				obj_t BgL_locz00_14023;

				BgL_a1z00_14021 = PROCEDURE_REF(BgL_envz00_14020, (int) (((long) 0)));
				BgL_a2z00_14022 = PROCEDURE_REF(BgL_envz00_14020, (int) (((long) 1)));
				BgL_locz00_14023 = PROCEDURE_REF(BgL_envz00_14020, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_24997;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16546;

						BgL_bpz00_16546 = VECTOR_REF(((obj_t) BgL_sz00_14024), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16547;
							obj_t BgL_a2z00_16548;

							BgL_a1z00_16547 =
								PROCEDURE_ENTRY(BgL_a1z00_14021) (BgL_a1z00_14021,
								BgL_sz00_14024, BEOA);
							BgL_a2z00_16548 =
								PROCEDURE_ENTRY(BgL_a2z00_14022) (BgL_a2z00_14022,
								BgL_sz00_14024, BEOA);
							if (INTEGERP(BgL_a1z00_16547))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5905z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a1z00_16547,
										BgL_locz00_14023);
								}
							if (INTEGERP(BgL_a2z00_16548))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5905z00zz__evaluate_compz00,
										BGl_symbol5889z00zz__evaluate_compz00, BgL_a2z00_16548,
										BgL_locz00_14023);
								}
							BgL_tmpz00_24997 =
								((long) CINT(BgL_a1z00_16547) == (long) CINT(BgL_a2z00_16548));
					}}
					return BBOOL(BgL_tmpz00_24997);
				}
			}
		}

	}



/* &<@anonymous:2885> */
	obj_t BGl_z62zc3z04anonymousza32885ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14025, obj_t BgL_sz00_14029)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14026;
				obj_t BgL_a2z00_14027;
				obj_t BgL_locz00_14028;

				BgL_a1z00_14026 = PROCEDURE_REF(BgL_envz00_14025, (int) (((long) 0)));
				BgL_a2z00_14027 = PROCEDURE_REF(BgL_envz00_14025, (int) (((long) 1)));
				BgL_locz00_14028 = PROCEDURE_REF(BgL_envz00_14025, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_25024;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16549;

						BgL_bpz00_16549 = VECTOR_REF(((obj_t) BgL_sz00_14029), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16550;
							obj_t BgL_a2z00_16551;

							BgL_a1z00_16550 =
								PROCEDURE_ENTRY(BgL_a1z00_14026) (BgL_a1z00_14026,
								BgL_sz00_14029, BEOA);
							BgL_a2z00_16551 =
								PROCEDURE_ENTRY(BgL_a2z00_14027) (BgL_a2z00_14027,
								BgL_sz00_14029, BEOA);
							if (REALP(BgL_a1z00_16550))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5907z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16550,
										BgL_locz00_14028);
								}
							if (REALP(BgL_a2z00_16551))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5907z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16551,
										BgL_locz00_14028);
								}
							BgL_tmpz00_25024 =
								(REAL_TO_DOUBLE(BgL_a1z00_16550) +
								REAL_TO_DOUBLE(BgL_a2z00_16551));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25024);
				}
			}
		}

	}



/* &<@anonymous:2889> */
	obj_t BGl_z62zc3z04anonymousza32889ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14030, obj_t BgL_sz00_14034)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14031;
				obj_t BgL_a2z00_14032;
				obj_t BgL_locz00_14033;

				BgL_a1z00_14031 = PROCEDURE_REF(BgL_envz00_14030, (int) (((long) 0)));
				BgL_a2z00_14032 = PROCEDURE_REF(BgL_envz00_14030, (int) (((long) 1)));
				BgL_locz00_14033 = PROCEDURE_REF(BgL_envz00_14030, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_25051;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16552;

						BgL_bpz00_16552 = VECTOR_REF(((obj_t) BgL_sz00_14034), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16553;
							obj_t BgL_a2z00_16554;

							BgL_a1z00_16553 =
								PROCEDURE_ENTRY(BgL_a1z00_14031) (BgL_a1z00_14031,
								BgL_sz00_14034, BEOA);
							BgL_a2z00_16554 =
								PROCEDURE_ENTRY(BgL_a2z00_14032) (BgL_a2z00_14032,
								BgL_sz00_14034, BEOA);
							if (REALP(BgL_a1z00_16553))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5911z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16553,
										BgL_locz00_14033);
								}
							if (REALP(BgL_a2z00_16554))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5911z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16554,
										BgL_locz00_14033);
								}
							BgL_tmpz00_25051 =
								(REAL_TO_DOUBLE(BgL_a1z00_16553) -
								REAL_TO_DOUBLE(BgL_a2z00_16554));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25051);
				}
			}
		}

	}



/* &<@anonymous:2893> */
	obj_t BGl_z62zc3z04anonymousza32893ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14035, obj_t BgL_sz00_14039)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14036;
				obj_t BgL_a2z00_14037;
				obj_t BgL_locz00_14038;

				BgL_a1z00_14036 = PROCEDURE_REF(BgL_envz00_14035, (int) (((long) 0)));
				BgL_a2z00_14037 = PROCEDURE_REF(BgL_envz00_14035, (int) (((long) 1)));
				BgL_locz00_14038 = PROCEDURE_REF(BgL_envz00_14035, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_25078;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16555;

						BgL_bpz00_16555 = VECTOR_REF(((obj_t) BgL_sz00_14039), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16556;
							obj_t BgL_a2z00_16557;

							BgL_a1z00_16556 =
								PROCEDURE_ENTRY(BgL_a1z00_14036) (BgL_a1z00_14036,
								BgL_sz00_14039, BEOA);
							BgL_a2z00_16557 =
								PROCEDURE_ENTRY(BgL_a2z00_14037) (BgL_a2z00_14037,
								BgL_sz00_14039, BEOA);
							if (REALP(BgL_a1z00_16556))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5913z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16556,
										BgL_locz00_14038);
								}
							if (REALP(BgL_a2z00_16557))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5913z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16557,
										BgL_locz00_14038);
								}
							BgL_tmpz00_25078 =
								(REAL_TO_DOUBLE(BgL_a1z00_16556) *
								REAL_TO_DOUBLE(BgL_a2z00_16557));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25078);
				}
			}
		}

	}



/* &<@anonymous:2897> */
	obj_t BGl_z62zc3z04anonymousza32897ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14040, obj_t BgL_sz00_14044)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14041;
				obj_t BgL_a2z00_14042;
				obj_t BgL_locz00_14043;

				BgL_a1z00_14041 = PROCEDURE_REF(BgL_envz00_14040, (int) (((long) 0)));
				BgL_a2z00_14042 = PROCEDURE_REF(BgL_envz00_14040, (int) (((long) 1)));
				BgL_locz00_14043 = PROCEDURE_REF(BgL_envz00_14040, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					double BgL_tmpz00_25105;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16558;

						BgL_bpz00_16558 = VECTOR_REF(((obj_t) BgL_sz00_14044), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16559;
							obj_t BgL_a2z00_16560;

							BgL_a1z00_16559 =
								PROCEDURE_ENTRY(BgL_a1z00_14041) (BgL_a1z00_14041,
								BgL_sz00_14044, BEOA);
							BgL_a2z00_16560 =
								PROCEDURE_ENTRY(BgL_a2z00_14042) (BgL_a2z00_14042,
								BgL_sz00_14044, BEOA);
							if (REALP(BgL_a1z00_16559))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5915z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16559,
										BgL_locz00_14043);
								}
							if (REALP(BgL_a2z00_16560))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5915z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16560,
										BgL_locz00_14043);
								}
							BgL_tmpz00_25105 =
								(REAL_TO_DOUBLE(BgL_a1z00_16559) /
								REAL_TO_DOUBLE(BgL_a2z00_16560));
						}
					}
					return DOUBLE_TO_REAL(BgL_tmpz00_25105);
				}
			}
		}

	}



/* &<@anonymous:2901> */
	obj_t BGl_z62zc3z04anonymousza32901ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14045, obj_t BgL_sz00_14049)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14046;
				obj_t BgL_a2z00_14047;
				obj_t BgL_locz00_14048;

				BgL_a1z00_14046 = PROCEDURE_REF(BgL_envz00_14045, (int) (((long) 0)));
				BgL_a2z00_14047 = PROCEDURE_REF(BgL_envz00_14045, (int) (((long) 1)));
				BgL_locz00_14048 = PROCEDURE_REF(BgL_envz00_14045, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25132;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16561;

						BgL_bpz00_16561 = VECTOR_REF(((obj_t) BgL_sz00_14049), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16562;
							obj_t BgL_a2z00_16563;

							BgL_a1z00_16562 =
								PROCEDURE_ENTRY(BgL_a1z00_14046) (BgL_a1z00_14046,
								BgL_sz00_14049, BEOA);
							BgL_a2z00_16563 =
								PROCEDURE_ENTRY(BgL_a2z00_14047) (BgL_a2z00_14047,
								BgL_sz00_14049, BEOA);
							if (REALP(BgL_a1z00_16562))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5917z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16562,
										BgL_locz00_14048);
								}
							if (REALP(BgL_a2z00_16563))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5917z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16563,
										BgL_locz00_14048);
								}
							BgL_tmpz00_25132 =
								(REAL_TO_DOUBLE(BgL_a1z00_16562) <
								REAL_TO_DOUBLE(BgL_a2z00_16563));
						}
					}
					return BBOOL(BgL_tmpz00_25132);
				}
			}
		}

	}



/* &<@anonymous:2905> */
	obj_t BGl_z62zc3z04anonymousza32905ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14050, obj_t BgL_sz00_14054)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14051;
				obj_t BgL_a2z00_14052;
				obj_t BgL_locz00_14053;

				BgL_a1z00_14051 = PROCEDURE_REF(BgL_envz00_14050, (int) (((long) 0)));
				BgL_a2z00_14052 = PROCEDURE_REF(BgL_envz00_14050, (int) (((long) 1)));
				BgL_locz00_14053 = PROCEDURE_REF(BgL_envz00_14050, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25159;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16564;

						BgL_bpz00_16564 = VECTOR_REF(((obj_t) BgL_sz00_14054), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16565;
							obj_t BgL_a2z00_16566;

							BgL_a1z00_16565 =
								PROCEDURE_ENTRY(BgL_a1z00_14051) (BgL_a1z00_14051,
								BgL_sz00_14054, BEOA);
							BgL_a2z00_16566 =
								PROCEDURE_ENTRY(BgL_a2z00_14052) (BgL_a2z00_14052,
								BgL_sz00_14054, BEOA);
							if (REALP(BgL_a1z00_16565))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5919z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16565,
										BgL_locz00_14053);
								}
							if (REALP(BgL_a2z00_16566))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5919z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16566,
										BgL_locz00_14053);
								}
							BgL_tmpz00_25159 =
								(REAL_TO_DOUBLE(BgL_a1z00_16565) >
								REAL_TO_DOUBLE(BgL_a2z00_16566));
						}
					}
					return BBOOL(BgL_tmpz00_25159);
				}
			}
		}

	}



/* &<@anonymous:2909> */
	obj_t BGl_z62zc3z04anonymousza32909ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14055, obj_t BgL_sz00_14059)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14056;
				obj_t BgL_a2z00_14057;
				obj_t BgL_locz00_14058;

				BgL_a1z00_14056 = PROCEDURE_REF(BgL_envz00_14055, (int) (((long) 0)));
				BgL_a2z00_14057 = PROCEDURE_REF(BgL_envz00_14055, (int) (((long) 1)));
				BgL_locz00_14058 = PROCEDURE_REF(BgL_envz00_14055, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25186;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16567;

						BgL_bpz00_16567 = VECTOR_REF(((obj_t) BgL_sz00_14059), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16568;
							obj_t BgL_a2z00_16569;

							BgL_a1z00_16568 =
								PROCEDURE_ENTRY(BgL_a1z00_14056) (BgL_a1z00_14056,
								BgL_sz00_14059, BEOA);
							BgL_a2z00_16569 =
								PROCEDURE_ENTRY(BgL_a2z00_14057) (BgL_a2z00_14057,
								BgL_sz00_14059, BEOA);
							if (REALP(BgL_a1z00_16568))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5921z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16568,
										BgL_locz00_14058);
								}
							if (REALP(BgL_a2z00_16569))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5921z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16569,
										BgL_locz00_14058);
								}
							BgL_tmpz00_25186 =
								(REAL_TO_DOUBLE(BgL_a1z00_16568) <=
								REAL_TO_DOUBLE(BgL_a2z00_16569));
						}
					}
					return BBOOL(BgL_tmpz00_25186);
				}
			}
		}

	}



/* &<@anonymous:2913> */
	obj_t BGl_z62zc3z04anonymousza32913ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14060, obj_t BgL_sz00_14064)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14061;
				obj_t BgL_a2z00_14062;
				obj_t BgL_locz00_14063;

				BgL_a1z00_14061 = PROCEDURE_REF(BgL_envz00_14060, (int) (((long) 0)));
				BgL_a2z00_14062 = PROCEDURE_REF(BgL_envz00_14060, (int) (((long) 1)));
				BgL_locz00_14063 = PROCEDURE_REF(BgL_envz00_14060, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25213;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16570;

						BgL_bpz00_16570 = VECTOR_REF(((obj_t) BgL_sz00_14064), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16571;
							obj_t BgL_a2z00_16572;

							BgL_a1z00_16571 =
								PROCEDURE_ENTRY(BgL_a1z00_14061) (BgL_a1z00_14061,
								BgL_sz00_14064, BEOA);
							BgL_a2z00_16572 =
								PROCEDURE_ENTRY(BgL_a2z00_14062) (BgL_a2z00_14062,
								BgL_sz00_14064, BEOA);
							if (REALP(BgL_a1z00_16571))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5923z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16571,
										BgL_locz00_14063);
								}
							if (REALP(BgL_a2z00_16572))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5923z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16572,
										BgL_locz00_14063);
								}
							BgL_tmpz00_25213 =
								(REAL_TO_DOUBLE(BgL_a1z00_16571) >=
								REAL_TO_DOUBLE(BgL_a2z00_16572));
						}
					}
					return BBOOL(BgL_tmpz00_25213);
				}
			}
		}

	}



/* &<@anonymous:2917> */
	obj_t BGl_z62zc3z04anonymousza32917ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14065, obj_t BgL_sz00_14069)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14066;
				obj_t BgL_a2z00_14067;
				obj_t BgL_locz00_14068;

				BgL_a1z00_14066 = PROCEDURE_REF(BgL_envz00_14065, (int) (((long) 0)));
				BgL_a2z00_14067 = PROCEDURE_REF(BgL_envz00_14065, (int) (((long) 1)));
				BgL_locz00_14068 = PROCEDURE_REF(BgL_envz00_14065, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25240;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16573;

						BgL_bpz00_16573 = VECTOR_REF(((obj_t) BgL_sz00_14069), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16574;
							obj_t BgL_a2z00_16575;

							BgL_a1z00_16574 =
								PROCEDURE_ENTRY(BgL_a1z00_14066) (BgL_a1z00_14066,
								BgL_sz00_14069, BEOA);
							BgL_a2z00_16575 =
								PROCEDURE_ENTRY(BgL_a2z00_14067) (BgL_a2z00_14067,
								BgL_sz00_14069, BEOA);
							if (REALP(BgL_a1z00_16574))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5925z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a1z00_16574,
										BgL_locz00_14068);
								}
							if (REALP(BgL_a2z00_16575))
								{	/* Eval/evaluate_comp.scm 1021 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1021 */
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5925z00zz__evaluate_compz00,
										BGl_symbol5909z00zz__evaluate_compz00, BgL_a2z00_16575,
										BgL_locz00_14068);
								}
							BgL_tmpz00_25240 =
								(REAL_TO_DOUBLE(BgL_a1z00_16574) ==
								REAL_TO_DOUBLE(BgL_a2z00_16575));
						}
					}
					return BBOOL(BgL_tmpz00_25240);
				}
			}
		}

	}



/* &<@anonymous:2921> */
	obj_t BGl_z62zc3z04anonymousza32921ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14070, obj_t BgL_sz00_14073)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14071;
				obj_t BgL_a2z00_14072;

				BgL_a1z00_14071 = PROCEDURE_REF(BgL_envz00_14070, (int) (((long) 0)));
				BgL_a2z00_14072 = PROCEDURE_REF(BgL_envz00_14070, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1021 */
					bool_t BgL_tmpz00_25265;

					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_bpz00_16576;

						BgL_bpz00_16576 = VECTOR_REF(((obj_t) BgL_sz00_14073), ((long) 0));
						{	/* Eval/evaluate_comp.scm 1021 */
							obj_t BgL_a1z00_16577;
							obj_t BgL_a2z00_16578;

							BgL_a1z00_16577 =
								PROCEDURE_ENTRY(BgL_a1z00_14071) (BgL_a1z00_14071,
								BgL_sz00_14073, BEOA);
							BgL_a2z00_16578 =
								PROCEDURE_ENTRY(BgL_a2z00_14072) (BgL_a2z00_14072,
								BgL_sz00_14073, BEOA);
							BgL_tmpz00_25265 = (BgL_a1z00_16577 == BgL_a2z00_16578);
					}}
					return BBOOL(BgL_tmpz00_25265);
				}
			}
		}

	}



/* &<@anonymous:2923> */
	obj_t BGl_z62zc3z04anonymousza32923ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14074, obj_t BgL_sz00_14077)
	{
		{	/* Eval/evaluate_comp.scm 1021 */
			{	/* Eval/evaluate_comp.scm 1021 */
				obj_t BgL_a1z00_14075;
				obj_t BgL_a2z00_14076;

				BgL_a1z00_14075 = PROCEDURE_REF(BgL_envz00_14074, (int) (((long) 0)));
				BgL_a2z00_14076 = PROCEDURE_REF(BgL_envz00_14074, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1021 */
					obj_t BgL_bpz00_16579;

					BgL_bpz00_16579 = VECTOR_REF(((obj_t) BgL_sz00_14077), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1021 */
						obj_t BgL_a1z00_16580;
						obj_t BgL_a2z00_16581;

						BgL_a1z00_16580 =
							PROCEDURE_ENTRY(BgL_a1z00_14075) (BgL_a1z00_14075, BgL_sz00_14077,
							BEOA);
						BgL_a2z00_16581 =
							PROCEDURE_ENTRY(BgL_a2z00_14076) (BgL_a2z00_14076, BgL_sz00_14077,
							BEOA);
						return MAKE_YOUNG_PAIR(BgL_a1z00_16580, BgL_a2z00_16581);
					}
				}
			}
		}

	}



/* &<@anonymous:2926> */
	obj_t BGl_z62zc3z04anonymousza32926ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14078, obj_t BgL_sz00_14081)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_14079;
				obj_t BgL_locz00_14080;

				BgL_a1z00_14079 = PROCEDURE_REF(BgL_envz00_14078, (int) (((long) 0)));
				BgL_locz00_14080 = PROCEDURE_REF(BgL_envz00_14078, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_16582;

					BgL_bpz00_16582 = VECTOR_REF(((obj_t) BgL_sz00_14081), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_16583;

						BgL_a1z00_16583 =
							PROCEDURE_ENTRY(BgL_a1z00_14079) (BgL_a1z00_14079, BgL_sz00_14081,
							BEOA);
						if (PAIRP(BgL_a1z00_16583))
							{	/* Eval/evaluate_comp.scm 1018 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1018 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5927z00zz__evaluate_compz00,
									BGl_symbol5929z00zz__evaluate_compz00, BgL_a1z00_16583,
									BgL_locz00_14080);
							}
						return CAR(((obj_t) BgL_a1z00_16583));
					}
				}
			}
		}

	}



/* &<@anonymous:2929> */
	obj_t BGl_z62zc3z04anonymousza32929ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14082, obj_t BgL_sz00_14085)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_14083;
				obj_t BgL_locz00_14084;

				BgL_a1z00_14083 = PROCEDURE_REF(BgL_envz00_14082, (int) (((long) 0)));
				BgL_locz00_14084 = PROCEDURE_REF(BgL_envz00_14082, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_16584;

					BgL_bpz00_16584 = VECTOR_REF(((obj_t) BgL_sz00_14085), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_16585;

						BgL_a1z00_16585 =
							PROCEDURE_ENTRY(BgL_a1z00_14083) (BgL_a1z00_14083, BgL_sz00_14085,
							BEOA);
						if (PAIRP(BgL_a1z00_16585))
							{	/* Eval/evaluate_comp.scm 1018 */
								BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 1018 */
								BGl_loczd2typezd2errorz00zz__evaluate_compz00
									(BGl_symbol5931z00zz__evaluate_compz00,
									BGl_symbol5929z00zz__evaluate_compz00, BgL_a1z00_16585,
									BgL_locz00_14084);
							}
						return CDR(((obj_t) BgL_a1z00_16585));
					}
				}
			}
		}

	}



/* &<@anonymous:2932> */
	obj_t BGl_z62zc3z04anonymousza32932ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14086, obj_t BgL_sz00_14089)
	{
		{	/* Eval/evaluate_comp.scm 1018 */
			{	/* Eval/evaluate_comp.scm 1018 */
				obj_t BgL_a1z00_14087;
				obj_t BgL_locz00_14088;

				BgL_a1z00_14087 = PROCEDURE_REF(BgL_envz00_14086, (int) (((long) 0)));
				BgL_locz00_14088 = PROCEDURE_REF(BgL_envz00_14086, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1018 */
					obj_t BgL_bpz00_16586;

					BgL_bpz00_16586 = VECTOR_REF(((obj_t) BgL_sz00_14089), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1018 */
						obj_t BgL_a1z00_16587;

						BgL_a1z00_16587 =
							PROCEDURE_ENTRY(BgL_a1z00_14087) (BgL_a1z00_14087, BgL_sz00_14089,
							BEOA);
						{	/* Eval/evaluate_comp.scm 1018 */
							bool_t BgL_test6570z00_25333;

							if (PAIRP(BgL_a1z00_16587))
								{	/* Eval/evaluate_comp.scm 1027 */
									obj_t BgL_tmpz00_25336;

									BgL_tmpz00_25336 = CDR(BgL_a1z00_16587);
									BgL_test6570z00_25333 = PAIRP(BgL_tmpz00_25336);
								}
							else
								{	/* Eval/evaluate_comp.scm 1027 */
									BgL_test6570z00_25333 = ((bool_t) 0);
								}
							if (BgL_test6570z00_25333)
								{	/* Eval/evaluate_comp.scm 1018 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1018 */
									obj_t BgL_arg2934z00_16588;

									if (PAIRP(BgL_a1z00_16587))
										{	/* Eval/evaluate_comp.scm 1030 */
											BgL_arg2934z00_16588 = CDR(BgL_a1z00_16587);
										}
									else
										{	/* Eval/evaluate_comp.scm 1030 */
											BgL_arg2934z00_16588 = BgL_a1z00_16587;
										}
									BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_symbol5933z00zz__evaluate_compz00,
										BGl_symbol5929z00zz__evaluate_compz00, BgL_arg2934z00_16588,
										BgL_locz00_14088);
								}
						}
						{	/* Eval/evaluate_comp.scm 1018 */
							obj_t BgL_pairz00_16589;

							BgL_pairz00_16589 = CDR(((obj_t) BgL_a1z00_16587));
							return CAR(BgL_pairz00_16589);
						}
					}
				}
			}
		}

	}



/* bind-frame */
	obj_t BGl_bindzd2framezd2zz__evaluate_compz00(obj_t BgL_sz00_203,
		obj_t BgL_wherez00_204, long BgL_spz00_205, long BgL_arityz00_206,
		obj_t BgL_valsz00_207, obj_t BgL_locz00_208)
	{
		{	/* Eval/evaluate_comp.scm 1063 */
			if ((BgL_arityz00_206 < ((long) 0)))
				{	/* Eval/evaluate_comp.scm 1065 */
					long BgL_g1237z00_3523;

					BgL_g1237z00_3523 = (((long) -1) - BgL_arityz00_206);
					{
						long BgL_rz00_3525;
						long BgL_spz00_3526;
						obj_t BgL_lz00_3527;

						BgL_rz00_3525 = BgL_g1237z00_3523;
						BgL_spz00_3526 = BgL_spz00_205;
						BgL_lz00_3527 = BgL_valsz00_207;
					BgL_zc3z04anonymousza32939ze3z87_3528:
						if ((BgL_rz00_3525 == ((long) 0)))
							{	/* Eval/evaluate_comp.scm 1067 */
								return
									VECTOR_SET(
									((obj_t) BgL_sz00_203), BgL_spz00_3526, BgL_lz00_3527);
							}
						else
							{	/* Eval/evaluate_comp.scm 1067 */
								if (PAIRP(BgL_lz00_3527))
									{	/* Eval/evaluate_comp.scm 1069 */
										{	/* Eval/evaluate_comp.scm 1072 */
											obj_t BgL_arg2942z00_3531;

											BgL_arg2942z00_3531 = CAR(BgL_lz00_3527);
											VECTOR_SET(
												((obj_t) BgL_sz00_203), BgL_spz00_3526,
												BgL_arg2942z00_3531);
										}
										{
											obj_t BgL_lz00_25362;
											long BgL_spz00_25360;
											long BgL_rz00_25358;

											BgL_rz00_25358 = (BgL_rz00_3525 - ((long) 1));
											BgL_spz00_25360 = (BgL_spz00_3526 + ((long) 1));
											BgL_lz00_25362 = CDR(BgL_lz00_3527);
											BgL_lz00_3527 = BgL_lz00_25362;
											BgL_spz00_3526 = BgL_spz00_25360;
											BgL_rz00_3525 = BgL_rz00_25358;
											goto BgL_zc3z04anonymousza32939ze3z87_3528;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 1070 */
										long BgL_arg2946z00_3535;

										BgL_arg2946z00_3535 = bgl_list_length(BgL_valsz00_207);
										return
											BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
											BgL_wherez00_204, (int) (BgL_arityz00_206),
											(int) (BgL_arg2946z00_3535));
				}}}}
			else
				{
					long BgL_rz00_3538;
					long BgL_spz00_3539;
					obj_t BgL_lz00_3540;

					BgL_rz00_3538 = BgL_arityz00_206;
					BgL_spz00_3539 = BgL_spz00_205;
					BgL_lz00_3540 = BgL_valsz00_207;
				BgL_zc3z04anonymousza32947ze3z87_3541:
					if ((BgL_rz00_3538 == ((long) 0)))
						{	/* Eval/evaluate_comp.scm 1076 */
							if (NULLP(BgL_lz00_3540))
								{	/* Eval/evaluate_comp.scm 1077 */
									return BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 1078 */
									long BgL_arg2950z00_3544;

									BgL_arg2950z00_3544 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2950z00_3544));
						}}
					else
						{	/* Eval/evaluate_comp.scm 1076 */
							if (PAIRP(BgL_lz00_3540))
								{	/* Eval/evaluate_comp.scm 1079 */
									{	/* Eval/evaluate_comp.scm 1082 */
										obj_t BgL_arg2953z00_3546;

										BgL_arg2953z00_3546 = CAR(BgL_lz00_3540);
										VECTOR_SET(
											((obj_t) BgL_sz00_203), BgL_spz00_3539,
											BgL_arg2953z00_3546);
									}
									{
										obj_t BgL_lz00_25385;
										long BgL_spz00_25383;
										long BgL_rz00_25381;

										BgL_rz00_25381 = (BgL_rz00_3538 - ((long) 1));
										BgL_spz00_25383 = (BgL_spz00_3539 + ((long) 1));
										BgL_lz00_25385 = CDR(BgL_lz00_3540);
										BgL_lz00_3540 = BgL_lz00_25385;
										BgL_spz00_3539 = BgL_spz00_25383;
										BgL_rz00_3538 = BgL_rz00_25381;
										goto BgL_zc3z04anonymousza32947ze3z87_3541;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 1080 */
									long BgL_arg2957z00_3550;

									BgL_arg2957z00_3550 = bgl_list_length(BgL_valsz00_207);
									return
										BGl_evarityzd2errorzd2zz__everrorz00(BgL_locz00_208,
										BgL_wherez00_204, (int) (BgL_arityz00_206),
										(int) (BgL_arg2957z00_3550));
		}}}}

	}



/* make-boxes */
	bool_t BGl_makezd2boxeszd2zz__evaluate_compz00(obj_t BgL_sz00_211,
		obj_t BgL_ibza2za2_212, obj_t BgL_bpz00_213)
	{
		{	/* Eval/evaluate_comp.scm 1177 */
			{
				long BgL_iz00_3554;

				BgL_iz00_3554 = ((long) 0);
			BgL_zc3z04anonymousza32958ze3z87_3555:
				{	/* Eval/evaluate_comp.scm 1180 */
					long BgL_spz00_3556;

					{	/* Eval/evaluate_comp.scm 1180 */
						obj_t BgL_arg2964z00_3561;

						BgL_arg2964z00_3561 =
							VECTOR_REF(((obj_t) BgL_ibza2za2_212), BgL_iz00_3554);
						BgL_spz00_3556 =
							((long) CINT(BgL_bpz00_213) + (long) CINT(BgL_arg2964z00_3561));
					}
					{	/* Eval/evaluate_comp.scm 1181 */
						obj_t BgL_arg2961z00_3557;

						{	/* Eval/evaluate_comp.scm 1181 */
							obj_t BgL_arg2962z00_3558;

							BgL_arg2962z00_3558 =
								VECTOR_REF(((obj_t) BgL_sz00_211), BgL_spz00_3556);
							{	/* Eval/evaluate_comp.scm 202 */
								obj_t BgL_newz00_9683;

								BgL_newz00_9683 =
									create_struct(BGl_symbol5857z00zz__evaluate_compz00,
									(int) (((long) 1)));
								{	/* Eval/evaluate_comp.scm 202 */
									int BgL_tmpz00_25400;

									BgL_tmpz00_25400 = (int) (((long) 0));
									STRUCT_SET(BgL_newz00_9683, BgL_tmpz00_25400,
										BgL_arg2962z00_3558);
								}
								BgL_arg2961z00_3557 = BgL_newz00_9683;
						}}
						VECTOR_SET(
							((obj_t) BgL_sz00_211), BgL_spz00_3556, BgL_arg2961z00_3557);
					}
					{	/* Eval/evaluate_comp.scm 1182 */
						long BgL_niz00_3559;

						BgL_niz00_3559 = (BgL_iz00_3554 + ((long) 1));
						if ((BgL_niz00_3559 < VECTOR_LENGTH(((obj_t) BgL_ibza2za2_212))))
							{
								long BgL_iz00_25410;

								BgL_iz00_25410 = BgL_niz00_3559;
								BgL_iz00_3554 = BgL_iz00_25410;
								goto BgL_zc3z04anonymousza32958ze3z87_3555;
							}
						else
							{	/* Eval/evaluate_comp.scm 1183 */
								return ((bool_t) 0);
							}
					}
				}
			}
		}

	}



/* free-collect */
	obj_t BGl_freezd2collectzd2zz__evaluate_compz00(obj_t BgL_sz00_214,
		obj_t BgL_bpz00_215, obj_t BgL_iza2za2_216)
	{
		{	/* Eval/evaluate_comp.scm 1185 */
			{	/* Eval/evaluate_comp.scm 1186 */
				obj_t BgL_rz00_3564;

				BgL_rz00_3564 =
					make_vector(VECTOR_LENGTH(((obj_t) BgL_iza2za2_216)), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 1186 */

					{
						long BgL_iz00_3566;

						BgL_iz00_3566 = ((long) 0);
					BgL_zc3z04anonymousza32965ze3z87_3567:
						if ((BgL_iz00_3566 >= VECTOR_LENGTH(((obj_t) BgL_iza2za2_216))))
							{	/* Eval/evaluate_comp.scm 1188 */
								return BgL_rz00_3564;
							}
						else
							{	/* Eval/evaluate_comp.scm 1188 */
								{	/* Eval/evaluate_comp.scm 1191 */
									obj_t BgL_arg2967z00_3569;

									{	/* Eval/evaluate_comp.scm 1191 */
										long BgL_arg2968z00_3570;

										{	/* Eval/evaluate_comp.scm 1191 */
											obj_t BgL_arg2969z00_3571;

											BgL_arg2969z00_3571 =
												VECTOR_REF(((obj_t) BgL_iza2za2_216), BgL_iz00_3566);
											BgL_arg2968z00_3570 =
												(
												(long) CINT(BgL_bpz00_215) +
												(long) CINT(BgL_arg2969z00_3571));
										}
										BgL_arg2967z00_3569 =
											VECTOR_REF(((obj_t) BgL_sz00_214), BgL_arg2968z00_3570);
									}
									VECTOR_SET(BgL_rz00_3564, BgL_iz00_3566, BgL_arg2967z00_3569);
								}
								{
									long BgL_iz00_25426;

									BgL_iz00_25426 = (BgL_iz00_3566 + ((long) 1));
									BgL_iz00_3566 = BgL_iz00_25426;
									goto BgL_zc3z04anonymousza32965ze3z87_3567;
								}
							}
					}
				}
			}
		}

	}



/* free-restore */
	bool_t BGl_freezd2restorezd2zz__evaluate_compz00(obj_t BgL_sz00_217,
		obj_t BgL_valza2za2_218, long BgL_spz00_219)
	{
		{	/* Eval/evaluate_comp.scm 1194 */
			{	/* Eval/evaluate_comp.scm 1195 */
				long BgL_stopz00_3575;

				BgL_stopz00_3575 =
					(BgL_spz00_219 + VECTOR_LENGTH(((obj_t) BgL_valza2za2_218)));
				{
					long BgL_iz00_9743;
					long BgL_spz00_9744;

					BgL_iz00_9743 = ((long) 0);
					BgL_spz00_9744 = BgL_spz00_219;
				BgL_recz00_9742:
					if ((BgL_spz00_9744 < BgL_stopz00_3575))
						{	/* Eval/evaluate_comp.scm 1197 */
							{	/* Eval/evaluate_comp.scm 1198 */
								obj_t BgL_arg2977z00_9750;

								BgL_arg2977z00_9750 =
									VECTOR_REF(((obj_t) BgL_valza2za2_218), BgL_iz00_9743);
								VECTOR_SET(
									((obj_t) BgL_sz00_217), BgL_spz00_9744, BgL_arg2977z00_9750);
							}
							{
								long BgL_spz00_25439;
								long BgL_iz00_25437;

								BgL_iz00_25437 = (BgL_iz00_9743 + ((long) 1));
								BgL_spz00_25439 = (BgL_spz00_9744 + ((long) 1));
								BgL_spz00_9744 = BgL_spz00_25439;
								BgL_iz00_9743 = BgL_iz00_25437;
								goto BgL_recz00_9742;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 1197 */
							return ((bool_t) 0);
						}
				}
			}
		}

	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return BUNSPEC;
		}

	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_proc5935z00zz__evaluate_compz00,
				BGl_ev_exprz00zz__evaluate_typesz00,
				BGl_string5936z00zz__evaluate_compz00);
		}

	}



/* &comp1389 */
	obj_t BGl_z62comp1389z62zz__evaluate_compz00(obj_t BgL_envz00_14175,
		obj_t BgL_ez00_14176, obj_t BgL_stkz00_14177)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			return
				BGl_errorz00zz__errorz00(BGl_string5847z00zz__evaluate_compz00,
				BGl_string5937z00zz__evaluate_compz00,
				((obj_t) ((BgL_ev_exprz00_bglt) BgL_ez00_14176)));
		}

	}



/* comp */
	obj_t BGl_compz00zz__evaluate_compz00(BgL_ev_exprz00_bglt BgL_ez00_35,
		obj_t BgL_stkz00_36)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				obj_t BgL_method1390z00_3591;

				{	/* Eval/evaluate_comp.scm 276 */
					obj_t BgL_res5127z00_9800;

					{	/* Eval/evaluate_comp.scm 276 */
						long BgL_objzd2classzd2numz00_9765;

						{	/* Eval/evaluate_comp.scm 276 */
							long BgL_res5117z00_9768;

							BgL_res5117z00_9768 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_ez00_35));
							BgL_objzd2classzd2numz00_9765 = BgL_res5117z00_9768;
						}
						{	/* Eval/evaluate_comp.scm 276 */
							obj_t BgL_arg4353z00_9766;

							BgL_arg4353z00_9766 =
								PROCEDURE_REF(BGl_compzd2envzd2zz__evaluate_compz00,
								(int) (((long) 1)));
							{	/* Eval/evaluate_comp.scm 276 */
								int BgL_offsetz00_9770;

								BgL_offsetz00_9770 = (int) (BgL_objzd2classzd2numz00_9765);
								{	/* Eval/evaluate_comp.scm 276 */
									long BgL_offsetz00_9771;

									BgL_offsetz00_9771 =
										((long) (BgL_offsetz00_9770) - OBJECT_TYPE);
									{	/* Eval/evaluate_comp.scm 276 */
										long BgL_modz00_9772;

										BgL_modz00_9772 =
											(BgL_offsetz00_9771 >>
											(int) ((long) ((int) (((long) 4)))));
										{	/* Eval/evaluate_comp.scm 276 */
											long BgL_restz00_9774;

											BgL_restz00_9774 =
												(BgL_offsetz00_9771 &
												(long) (
													(int) (
														((long) (
																(int) (
																	(((long) 1) <<
																		(int) (
																			(long) (
																				(int) (((long) 4))))))) -
															((long) 1)))));
											{	/* Eval/evaluate_comp.scm 276 */

												{	/* Eval/evaluate_comp.scm 276 */
													obj_t BgL_bucketz00_9776;

													BgL_bucketz00_9776 =
														VECTOR_REF(
														((obj_t) BgL_arg4353z00_9766), BgL_modz00_9772);
													BgL_res5127z00_9800 =
														VECTOR_REF(
														((obj_t) BgL_bucketz00_9776), BgL_restz00_9774);
					}}}}}}}}
					BgL_method1390z00_3591 = BgL_res5127z00_9800;
				}
				return
					PROCEDURE_ENTRY(BgL_method1390z00_3591) (BgL_method1390z00_3591,
					((obj_t) BgL_ez00_35), BgL_stkz00_36, BEOA);
			}
		}

	}



/* &comp */
	obj_t BGl_z62compz62zz__evaluate_compz00(obj_t BgL_envz00_14178,
		obj_t BgL_ez00_14179, obj_t BgL_stkz00_14180)
	{
		{	/* Eval/evaluate_comp.scm 276 */
			{	/* Eval/evaluate_comp.scm 276 */
				BgL_ev_exprz00_bglt BgL_auxz00_25476;

				if (BGl_isazf3zf3zz__objectz00(BgL_ez00_14179,
						BGl_ev_exprz00zz__evaluate_typesz00))
					{	/* Eval/evaluate_comp.scm 276 */
						BgL_auxz00_25476 = ((BgL_ev_exprz00_bglt) BgL_ez00_14179);
					}
				else
					{
						obj_t BgL_auxz00_25480;

						BgL_auxz00_25480 =
							BGl_typezd2errorzd2zz__errorz00
							(BGl_string5852z00zz__evaluate_compz00, BINT(((long) 7022)),
							BGl_string5938z00zz__evaluate_compz00,
							BGl_string5854z00zz__evaluate_compz00, BgL_ez00_14179);
						FAILURE(BgL_auxz00_25480, BFALSE, BFALSE);
					}
				return
					BGl_compz00zz__evaluate_compz00(BgL_auxz00_25476, BgL_stkz00_14180);
			}
		}

	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_trapz00zz__evaluate_typesz00,
				BGl_proc5939z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_varz00zz__evaluate_typesz00, BGl_proc5941z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setlocalz00zz__evaluate_typesz00,
				BGl_proc5942z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_globalz00zz__evaluate_typesz00,
				BGl_proc5943z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_setglobalz00zz__evaluate_typesz00,
				BGl_proc5944z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_defglobalz00zz__evaluate_typesz00,
				BGl_proc5945z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_littz00zz__evaluate_typesz00,
				BGl_proc5946z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_ifz00zz__evaluate_typesz00, BGl_proc5947z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_orz00zz__evaluate_typesz00, BGl_proc5948z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_andz00zz__evaluate_typesz00, BGl_proc5949z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_prog2z00zz__evaluate_typesz00,
				BGl_proc5950z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letz00zz__evaluate_typesz00, BGl_proc5951z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letza2za2zz__evaluate_typesz00,
				BGl_proc5952z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_letrecz00zz__evaluate_typesz00,
				BGl_proc5953z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_bindzd2exitzd2zz__evaluate_typesz00,
				BGl_proc5954z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00,
				BGl_proc5955z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_withzd2handlerzd2zz__evaluate_typesz00,
				BGl_proc5956z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_synchroniza7eza7zz__evaluate_typesz00,
				BGl_proc5957z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_labelsz00zz__evaluate_typesz00,
				BGl_proc5958z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_gotoz00zz__evaluate_typesz00,
				BGl_proc5959z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_appz00zz__evaluate_typesz00, BGl_proc5960z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_compzd2envzd2zz__evaluate_compz00,
				BGl_ev_absz00zz__evaluate_typesz00, BGl_proc5961z00zz__evaluate_compz00,
				BGl_string5940z00zz__evaluate_compz00);
		}

	}



/* &comp-ev_abs1438 */
	obj_t BGl_z62compzd2ev_abs1438zb0zz__evaluate_compz00(obj_t BgL_envz00_14375,
		obj_t BgL_ez00_14376, obj_t BgL_stkz00_14377)
	{
		{	/* Eval/evaluate_comp.scm 1165 */
			{	/* Eval/evaluate_comp.scm 1167 */
				obj_t BgL_ifreesz00_16592;
				obj_t BgL_iboxesz00_16593;
				long BgL_siza7eza7_16594;
				long BgL_siza7ezd2framez75_16595;
				obj_t BgL_nstkz00_16596;

				{	/* Eval/evaluate_comp.scm 1167 */
					obj_t BgL_arg4058z00_16597;

					{	/* Eval/evaluate_comp.scm 1167 */
						obj_t BgL_l1366z00_16598;

						BgL_l1366z00_16598 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_freez00);
						if (NULLP(BgL_l1366z00_16598))
							{	/* Eval/evaluate_comp.scm 1167 */
								BgL_arg4058z00_16597 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1167 */
								obj_t BgL_head1368z00_16599;

								{	/* Eval/evaluate_comp.scm 1167 */
									obj_t BgL_res5266z00_16600;

									BgL_res5266z00_16600 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1368z00_16599 = BgL_res5266z00_16600;
								}
								{
									obj_t BgL_l1366z00_16602;
									obj_t BgL_tail1369z00_16603;

									BgL_l1366z00_16602 = BgL_l1366z00_16598;
									BgL_tail1369z00_16603 = BgL_head1368z00_16599;
								BgL_zc3z04anonymousza34060ze3z87_16601:
									if (NULLP(BgL_l1366z00_16602))
										{	/* Eval/evaluate_comp.scm 1167 */
											BgL_arg4058z00_16597 = CDR(BgL_head1368z00_16599);
										}
									else
										{	/* Eval/evaluate_comp.scm 1167 */
											obj_t BgL_newtail1370z00_16604;

											{	/* Eval/evaluate_comp.scm 1167 */
												obj_t BgL_arg4063z00_16605;

												{	/* Eval/evaluate_comp.scm 1167 */
													obj_t BgL_vz00_16606;

													BgL_vz00_16606 = CAR(((obj_t) BgL_l1366z00_16602));
													BgL_arg4063z00_16605 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16606,
														BgL_stkz00_14377);
												}
												{	/* Eval/evaluate_comp.scm 1167 */
													obj_t BgL_res5272z00_16607;

													BgL_res5272z00_16607 =
														MAKE_YOUNG_PAIR(BgL_arg4063z00_16605, BNIL);
													BgL_newtail1370z00_16604 = BgL_res5272z00_16607;
												}
											}
											SET_CDR(BgL_tail1369z00_16603, BgL_newtail1370z00_16604);
											{	/* Eval/evaluate_comp.scm 1167 */
												obj_t BgL_arg4062z00_16608;

												BgL_arg4062z00_16608 =
													CDR(((obj_t) BgL_l1366z00_16602));
												{
													obj_t BgL_tail1369z00_25523;
													obj_t BgL_l1366z00_25522;

													BgL_l1366z00_25522 = BgL_arg4062z00_16608;
													BgL_tail1369z00_25523 = BgL_newtail1370z00_16604;
													BgL_tail1369z00_16603 = BgL_tail1369z00_25523;
													BgL_l1366z00_16602 = BgL_l1366z00_25522;
													goto BgL_zc3z04anonymousza34060ze3z87_16601;
												}
											}
										}
								}
							}
					}
					BgL_ifreesz00_16592 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4058z00_16597);
				}
				{	/* Eval/evaluate_comp.scm 1168 */
					obj_t BgL_arg4064z00_16609;

					{	/* Eval/evaluate_comp.scm 1168 */
						obj_t BgL_l1371z00_16610;

						BgL_l1371z00_16610 =
							(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_boxesz00);
						if (NULLP(BgL_l1371z00_16610))
							{	/* Eval/evaluate_comp.scm 1168 */
								BgL_arg4064z00_16609 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 1168 */
								obj_t BgL_head1373z00_16611;

								{	/* Eval/evaluate_comp.scm 1168 */
									obj_t BgL_res5274z00_16612;

									BgL_res5274z00_16612 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1373z00_16611 = BgL_res5274z00_16612;
								}
								{
									obj_t BgL_l1371z00_16614;
									obj_t BgL_tail1374z00_16615;

									BgL_l1371z00_16614 = BgL_l1371z00_16610;
									BgL_tail1374z00_16615 = BgL_head1373z00_16611;
								BgL_zc3z04anonymousza34066ze3z87_16613:
									if (NULLP(BgL_l1371z00_16614))
										{	/* Eval/evaluate_comp.scm 1168 */
											BgL_arg4064z00_16609 = CDR(BgL_head1373z00_16611);
										}
									else
										{	/* Eval/evaluate_comp.scm 1168 */
											obj_t BgL_newtail1375z00_16616;

											{	/* Eval/evaluate_comp.scm 1168 */
												obj_t BgL_arg4069z00_16617;

												{	/* Eval/evaluate_comp.scm 1168 */
													obj_t BgL_vz00_16618;

													BgL_vz00_16618 = CAR(((obj_t) BgL_l1371z00_16614));
													BgL_arg4069z00_16617 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_16618,
														(((BgL_ev_absz00_bglt) COBJECT(
																	((BgL_ev_absz00_bglt) BgL_ez00_14376)))->
															BgL_varsz00));
												}
												{	/* Eval/evaluate_comp.scm 1168 */
													obj_t BgL_res5276z00_16619;

													BgL_res5276z00_16619 =
														MAKE_YOUNG_PAIR(BgL_arg4069z00_16617, BNIL);
													BgL_newtail1375z00_16616 = BgL_res5276z00_16619;
												}
											}
											SET_CDR(BgL_tail1374z00_16615, BgL_newtail1375z00_16616);
											{	/* Eval/evaluate_comp.scm 1168 */
												obj_t BgL_arg4068z00_16620;

												BgL_arg4068z00_16620 =
													CDR(((obj_t) BgL_l1371z00_16614));
												{
													obj_t BgL_tail1374z00_25543;
													obj_t BgL_l1371z00_25542;

													BgL_l1371z00_25542 = BgL_arg4068z00_16620;
													BgL_tail1374z00_25543 = BgL_newtail1375z00_16616;
													BgL_tail1374z00_16615 = BgL_tail1374z00_25543;
													BgL_l1371z00_16614 = BgL_l1371z00_25542;
													goto BgL_zc3z04anonymousza34066ze3z87_16613;
												}
											}
										}
								}
							}
					}
					BgL_iboxesz00_16593 =
						BGl_listzd2ze3vectorz31zz__r4_vectors_6_8z00(BgL_arg4064z00_16609);
				}
				BgL_siza7eza7_16594 =
					bgl_list_length(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_varsz00));
				BgL_siza7ezd2framez75_16595 =
					(
					(long) (
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_siza7eza7)) +
					bgl_list_length(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_freez00)));
				BgL_nstkz00_16596 =
					BGl_appendzd221011zd2zz__evaluate_compz00(
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_varsz00),
					(((BgL_ev_absz00_bglt) COBJECT(
								((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_freez00));
				{	/* Eval/evaluate_comp.scm 1172 */
					obj_t BgL_bodyz00_16621;

					BgL_bodyz00_16621 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_absz00_bglt) COBJECT(
									((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_bodyz00),
						BgL_nstkz00_16596);
					{

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_aux1249z00_16627;

							BgL_aux1249z00_16627 =
								(((BgL_ev_absz00_bglt) COBJECT(
										((BgL_ev_absz00_bglt) BgL_ez00_14376)))->BgL_arityz00);
							if (INTEGERP(BgL_aux1249z00_16627))
								{	/* Eval/evaluate_comp.scm 1174 */
									switch ((long) CINT(BgL_aux1249z00_16627))
										{
										case ((long) 0):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33488ze3z87_16628;

															BgL_zc3z04anonymousza33488ze3z87_16628 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33488ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33488ze3z87_16628,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33488ze3z87_16628,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33488ze3z87_16628,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33488ze3z87_16628;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33495ze3z87_16629;

															BgL_zc3z04anonymousza33495ze3z87_16629 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33495ze3z87_16629,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33495ze3z87_16629,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33495ze3z87_16629,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33495ze3z87_16629,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33495ze3z87_16629;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33505ze3z87_16630;

															BgL_zc3z04anonymousza33505ze3z87_16630 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33505ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33505ze3z87_16630,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33505ze3z87_16630,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33505ze3z87_16630,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33505ze3z87_16630,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33505ze3z87_16630,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33505ze3z87_16630;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33513ze3z87_16631;

															BgL_zc3z04anonymousza33513ze3z87_16631 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33513ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33513ze3z87_16631,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33513ze3z87_16631,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33513ze3z87_16631,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33513ze3z87_16631,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33513ze3z87_16631,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33513ze3z87_16631,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33513ze3z87_16631;
														}
												}
											break;
										case ((long) -1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33528ze3z87_16632;

															BgL_zc3z04anonymousza33528ze3z87_16632 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33528ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33528ze3z87_16632,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33528ze3z87_16632,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33528ze3z87_16632,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33528ze3z87_16632;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33538ze3z87_16633;

															BgL_zc3z04anonymousza33538ze3z87_16633 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33538ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33538ze3z87_16633,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33538ze3z87_16633,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33538ze3z87_16633,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33538ze3z87_16633,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33538ze3z87_16633;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33549ze3z87_16634;

															BgL_zc3z04anonymousza33549ze3z87_16634 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33549ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33549ze3z87_16634,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33549ze3z87_16634,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33549ze3z87_16634,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33549ze3z87_16634,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33549ze3z87_16634,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33549ze3z87_16634;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33559ze3z87_16635;

															BgL_zc3z04anonymousza33559ze3z87_16635 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33559ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33559ze3z87_16635,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33559ze3z87_16635,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33559ze3z87_16635,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33559ze3z87_16635,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33559ze3z87_16635,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33559ze3z87_16635,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33559ze3z87_16635;
														}
												}
											break;
										case ((long) 1):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33575ze3z87_16636;

															BgL_zc3z04anonymousza33575ze3z87_16636 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33575ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33575ze3z87_16636,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33575ze3z87_16636,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33575ze3z87_16636,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33575ze3z87_16636;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33584ze3z87_16637;

															BgL_zc3z04anonymousza33584ze3z87_16637 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33584ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33584ze3z87_16637,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33584ze3z87_16637,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33584ze3z87_16637,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33584ze3z87_16637,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33584ze3z87_16637;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33596ze3z87_16638;

															BgL_zc3z04anonymousza33596ze3z87_16638 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33596ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33596ze3z87_16638,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33596ze3z87_16638,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33596ze3z87_16638,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33596ze3z87_16638,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33596ze3z87_16638,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33596ze3z87_16638;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33605ze3z87_16639;

															BgL_zc3z04anonymousza33605ze3z87_16639 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33605ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16639,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16639,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16639,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16639,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16639,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33605ze3z87_16639,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33605ze3z87_16639;
														}
												}
											break;
										case ((long) -2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33622ze3z87_16640;

															BgL_zc3z04anonymousza33622ze3z87_16640 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33622ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33622ze3z87_16640,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33622ze3z87_16640,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33622ze3z87_16640,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33622ze3z87_16640;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33631ze3z87_16641;

															BgL_zc3z04anonymousza33631ze3z87_16641 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33631ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33631ze3z87_16641,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33631ze3z87_16641,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33631ze3z87_16641,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33631ze3z87_16641,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33631ze3z87_16641;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33643ze3z87_16642;

															BgL_zc3z04anonymousza33643ze3z87_16642 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33643ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16642,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16642,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16642,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16642,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33643ze3z87_16642,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33643ze3z87_16642;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33653ze3z87_16643;

															BgL_zc3z04anonymousza33653ze3z87_16643 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33653ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33653ze3z87_16643,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33653ze3z87_16643,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33653ze3z87_16643,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33653ze3z87_16643,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33653ze3z87_16643,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33653ze3z87_16643,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33653ze3z87_16643;
														}
												}
											break;
										case ((long) 2):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33670ze3z87_16644;

															BgL_zc3z04anonymousza33670ze3z87_16644 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33670ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33670ze3z87_16644,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33670ze3z87_16644,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33670ze3z87_16644,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33670ze3z87_16644;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33679ze3z87_16645;

															BgL_zc3z04anonymousza33679ze3z87_16645 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33679ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33679ze3z87_16645,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33679ze3z87_16645,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33679ze3z87_16645,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33679ze3z87_16645,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33679ze3z87_16645;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33690ze3z87_16646;

															BgL_zc3z04anonymousza33690ze3z87_16646 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33690ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33690ze3z87_16646,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33690ze3z87_16646,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33690ze3z87_16646,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33690ze3z87_16646,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33690ze3z87_16646,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33690ze3z87_16646;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33701ze3z87_16647;

															BgL_zc3z04anonymousza33701ze3z87_16647 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33701ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33701ze3z87_16647,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33701ze3z87_16647,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33701ze3z87_16647,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33701ze3z87_16647,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33701ze3z87_16647,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33701ze3z87_16647,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33701ze3z87_16647;
														}
												}
											break;
										case ((long) -3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33718ze3z87_16648;

															BgL_zc3z04anonymousza33718ze3z87_16648 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33718ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33718ze3z87_16648,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33718ze3z87_16648,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33718ze3z87_16648,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33718ze3z87_16648;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33727ze3z87_16649;

															BgL_zc3z04anonymousza33727ze3z87_16649 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33727ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33727ze3z87_16649,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33727ze3z87_16649,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33727ze3z87_16649,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33727ze3z87_16649,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33727ze3z87_16649;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33739ze3z87_16650;

															BgL_zc3z04anonymousza33739ze3z87_16650 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33739ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33739ze3z87_16650,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33739ze3z87_16650,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33739ze3z87_16650,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33739ze3z87_16650,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33739ze3z87_16650,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33739ze3z87_16650;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33749ze3z87_16651;

															BgL_zc3z04anonymousza33749ze3z87_16651 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33749ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33749ze3z87_16651,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33749ze3z87_16651,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33749ze3z87_16651,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33749ze3z87_16651,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33749ze3z87_16651,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33749ze3z87_16651,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33749ze3z87_16651;
														}
												}
											break;
										case ((long) 3):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33765ze3z87_16652;

															BgL_zc3z04anonymousza33765ze3z87_16652 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33765ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33765ze3z87_16652,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33765ze3z87_16652,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33765ze3z87_16652,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33765ze3z87_16652;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33774ze3z87_16653;

															BgL_zc3z04anonymousza33774ze3z87_16653 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33774ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33774ze3z87_16653,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33774ze3z87_16653,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33774ze3z87_16653,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33774ze3z87_16653,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33774ze3z87_16653;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33786ze3z87_16654;

															BgL_zc3z04anonymousza33786ze3z87_16654 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33786ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16654,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16654,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16654,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16654,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33786ze3z87_16654,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33786ze3z87_16654;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33796ze3z87_16655;

															BgL_zc3z04anonymousza33796ze3z87_16655 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33796ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33796ze3z87_16655,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33796ze3z87_16655,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33796ze3z87_16655,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33796ze3z87_16655,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33796ze3z87_16655,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33796ze3z87_16655,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33796ze3z87_16655;
														}
												}
											break;
										case ((long) -4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33812ze3z87_16656;

															BgL_zc3z04anonymousza33812ze3z87_16656 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33812ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33812ze3z87_16656,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33812ze3z87_16656,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33812ze3z87_16656,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33812ze3z87_16656;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33822ze3z87_16657;

															BgL_zc3z04anonymousza33822ze3z87_16657 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33822ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33822ze3z87_16657,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33822ze3z87_16657,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33822ze3z87_16657,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33822ze3z87_16657,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33822ze3z87_16657;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33835ze3z87_16658;

															BgL_zc3z04anonymousza33835ze3z87_16658 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33835ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33835ze3z87_16658,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33835ze3z87_16658,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33835ze3z87_16658,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33835ze3z87_16658,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33835ze3z87_16658,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33835ze3z87_16658;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33846ze3z87_16659;

															BgL_zc3z04anonymousza33846ze3z87_16659 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33846ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33846ze3z87_16659,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33846ze3z87_16659,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33846ze3z87_16659,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33846ze3z87_16659,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33846ze3z87_16659,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33846ze3z87_16659,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33846ze3z87_16659;
														}
												}
											break;
										case ((long) 4):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33863ze3z87_16660;

															BgL_zc3z04anonymousza33863ze3z87_16660 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33863ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33863ze3z87_16660,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33863ze3z87_16660,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33863ze3z87_16660,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33863ze3z87_16660;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33873ze3z87_16661;

															BgL_zc3z04anonymousza33873ze3z87_16661 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33873ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33873ze3z87_16661,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33873ze3z87_16661,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33873ze3z87_16661,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33873ze3z87_16661,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33873ze3z87_16661;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33886ze3z87_16662;

															BgL_zc3z04anonymousza33886ze3z87_16662 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33886ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33886ze3z87_16662,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33886ze3z87_16662,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33886ze3z87_16662,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33886ze3z87_16662,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33886ze3z87_16662,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33886ze3z87_16662;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33897ze3z87_16663;

															BgL_zc3z04anonymousza33897ze3z87_16663 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33897ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33897ze3z87_16663,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33897ze3z87_16663,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33897ze3z87_16663,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33897ze3z87_16663,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33897ze3z87_16663,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33897ze3z87_16663,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33897ze3z87_16663;
														}
												}
											break;
										case ((long) -5):

											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33914ze3z87_16664;

															BgL_zc3z04anonymousza33914ze3z87_16664 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33914ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33914ze3z87_16664,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33914ze3z87_16664,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33914ze3z87_16664,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33914ze3z87_16664;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33925ze3z87_16665;

															BgL_zc3z04anonymousza33925ze3z87_16665 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33925ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33925ze3z87_16665,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33925ze3z87_16665,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33925ze3z87_16665,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33925ze3z87_16665,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33925ze3z87_16665;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33939ze3z87_16666;

															BgL_zc3z04anonymousza33939ze3z87_16666 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33939ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33939ze3z87_16666,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33939ze3z87_16666,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33939ze3z87_16666,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33939ze3z87_16666,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33939ze3z87_16666,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33939ze3z87_16666;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33951ze3z87_16667;

															BgL_zc3z04anonymousza33951ze3z87_16667 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33951ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33951ze3z87_16667,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33951ze3z87_16667,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33951ze3z87_16667,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33951ze3z87_16667,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33951ze3z87_16667,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33951ze3z87_16667,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33951ze3z87_16667;
														}
												}
											break;
										default:
										BgL_case_else1248z00_16622:
											if ((VECTOR_LENGTH(BgL_ifreesz00_16592) == ((long) 0)))
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33969ze3z87_16623;

															BgL_zc3z04anonymousza33969ze3z87_16623 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33969ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 3)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33969ze3z87_16623,
																(int) (((long) 0)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33969ze3z87_16623,
																(int) (((long) 1)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33969ze3z87_16623,
																(int) (((long) 2)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33969ze3z87_16623;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza33989ze3z87_16624;

															BgL_zc3z04anonymousza33989ze3z87_16624 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza33989ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 4)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33989ze3z87_16624,
																(int) (((long) 0)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33989ze3z87_16624,
																(int) (((long) 1)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33989ze3z87_16624,
																(int) (((long) 2)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza33989ze3z87_16624,
																(int) (((long) 3)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza33989ze3z87_16624;
														}
												}
											else
												{	/* Eval/evaluate_comp.scm 1174 */
													if (
														(VECTOR_LENGTH(BgL_iboxesz00_16593) == ((long) 0)))
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza34013ze3z87_16625;

															BgL_zc3z04anonymousza34013ze3z87_16625 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza34013ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 5)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34013ze3z87_16625,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34013ze3z87_16625,
																(int) (((long) 1)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34013ze3z87_16625,
																(int) (((long) 2)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34013ze3z87_16625,
																(int) (((long) 3)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34013ze3z87_16625,
																(int) (((long) 4)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza34013ze3z87_16625;
														}
													else
														{	/* Eval/evaluate_comp.scm 1174 */
															obj_t BgL_zc3z04anonymousza34034ze3z87_16626;

															BgL_zc3z04anonymousza34034ze3z87_16626 =
																MAKE_FX_PROCEDURE
																(BGl_z62zc3z04anonymousza34034ze3ze5zz__evaluate_compz00,
																(int) (((long) 1)), (int) (((long) 6)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34034ze3z87_16626,
																(int) (((long) 0)), BgL_ifreesz00_16592);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34034ze3z87_16626,
																(int) (((long) 1)), BgL_iboxesz00_16593);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34034ze3z87_16626,
																(int) (((long) 2)), BINT(BgL_siza7eza7_16594));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34034ze3z87_16626,
																(int) (((long) 3)),
																((obj_t) ((BgL_ev_absz00_bglt)
																		BgL_ez00_14376)));
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34034ze3z87_16626,
																(int) (((long) 4)), BgL_bodyz00_16621);
															PROCEDURE_SET
																(BgL_zc3z04anonymousza34034ze3z87_16626,
																(int) (((long) 5)),
																BINT(BgL_siza7ezd2framez75_16595));
															return BgL_zc3z04anonymousza34034ze3z87_16626;
														}
												}
										}
								}
							else
								{	/* Eval/evaluate_comp.scm 1174 */
									goto BgL_case_else1248z00_16622;
								}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3914> */
	obj_t BGl_z62zc3z04anonymousza33914ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14378, obj_t BgL_sz00_14382)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14379;
				obj_t BgL_bodyz00_14380;
				long BgL_siza7ezd2framez75_14381;

				BgL_i1247z00_14379 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14378, (int) (((long) 0))));
				BgL_bodyz00_14380 = PROCEDURE_REF(BgL_envz00_14378, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14381 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14378, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16668;

					BgL_bpz00_16668 = VECTOR_REF(((obj_t) BgL_sz00_14382), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16669;

							BgL_runz00_16669 =
								MAKE_FX_PROCEDURE(BGl_z62runz62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16669,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14379));
							PROCEDURE_SET(BgL_runz00_16669,
								(int) (((long) 1)), BgL_bodyz00_14380);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16670;

								BgL_mainz00_16670 =
									MAKE_VA_PROCEDURE(BGl_z62mainz62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16670,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14379));
								PROCEDURE_SET(BgL_mainz00_16670,
									(int) (((long) 1)), BgL_bodyz00_14380);
								PROCEDURE_SET(BgL_mainz00_16670,
									(int) (((long) 2)), BgL_runz00_16669);
								PROCEDURE_SET(BgL_mainz00_16670,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14381));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16671;

									BgL_objz00_16671 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16669, BgL_objz00_16671);
									BgL_objz00_16671;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3915z00_16672;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3916z00_16673;

										BgL_arg3916z00_16673 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14379))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16674;

											BgL_newz00_16674 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26385;

												BgL_tmpz00_26385 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16674, BgL_tmpz00_26385,
													BgL_arg3916z00_16673);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26390;
												int BgL_tmpz00_26388;

												BgL_auxz00_26390 = BINT(BgL_siza7ezd2framez75_14381);
												BgL_tmpz00_26388 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16674, BgL_tmpz00_26388,
													BgL_auxz00_26390);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26393;

												BgL_tmpz00_26393 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16674, BgL_tmpz00_26393,
													BgL_runz00_16669);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26398;
												int BgL_tmpz00_26396;

												BgL_auxz00_26398 = BINT(((long) -5));
												BgL_tmpz00_26396 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16674, BgL_tmpz00_26396,
													BgL_auxz00_26398);
											}
											BgL_arg3915z00_16672 = BgL_newz00_16674;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16670, BgL_arg3915z00_16672);
									BgL_arg3915z00_16672;
								}
								return BgL_mainz00_16670;
							}
						}
					}
				}
			}
		}

	}



/* &main */
	obj_t BGl_z62mainz62zz__evaluate_compz00(obj_t BgL_envz00_14383,
		obj_t BgL_az00_14388, obj_t BgL_bz00_14389, obj_t BgL_cz00_14390,
		obj_t BgL_dz00_14391, obj_t BgL_lastz00_14392)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14386;
				long BgL_siza7ezd2framez75_14387;

				BgL_runz00_14386 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14383, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14387 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14383, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16675;

					BgL_sz00_16675 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16676;

						BgL_bpz00_16676 = VECTOR_REF(((obj_t) BgL_sz00_16675), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16676) + BgL_siza7ezd2framez75_14387) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16675))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3919z00_16677;

									BgL_arg3919z00_16677 =
										((long) CINT(BgL_bpz00_16676) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16675), BgL_arg3919z00_16677,
										BgL_az00_14388);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3920z00_16678;

									BgL_arg3920z00_16678 =
										((long) CINT(BgL_bpz00_16676) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16675), BgL_arg3920z00_16678,
										BgL_bz00_14389);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3921z00_16679;

									BgL_arg3921z00_16679 =
										((long) CINT(BgL_bpz00_16676) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16675), BgL_arg3921z00_16679,
										BgL_cz00_14390);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3922z00_16680;

									BgL_arg3922z00_16680 =
										((long) CINT(BgL_bpz00_16676) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16675), BgL_arg3922z00_16680,
										BgL_dz00_14391);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3923z00_16681;

									BgL_arg3923z00_16681 =
										((long) CINT(BgL_bpz00_16676) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16675), BgL_arg3923z00_16681,
										BgL_lastz00_14392);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16682;

									BgL_ez00_16682 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16682,
										BgL_bpz00_16676);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16683;

										BgL_accz00_16683 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14386, BgL_sz00_16675, BgL_bpz00_16676);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16682);
										VECTOR_SET(
											((obj_t) BgL_sz00_16675), ((long) 0), BgL_bpz00_16676);
										return BgL_accz00_16683;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16684;

								BgL_nsz00_16684 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16684, ((long) 1), BgL_sz00_16675);
								VECTOR_SET(BgL_nsz00_16684, ((long) 2), BgL_az00_14388);
								VECTOR_SET(BgL_nsz00_16684, ((long) 3), BgL_bz00_14389);
								VECTOR_SET(BgL_nsz00_16684, ((long) 4), BgL_cz00_14390);
								VECTOR_SET(BgL_nsz00_16684, ((long) 5), BgL_dz00_14391);
								VECTOR_SET(BgL_nsz00_16684, ((long) 6), BgL_lastz00_14392);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16685;

									BgL_z12denvz12_16685 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16685, BgL_nsz00_16684);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16686;

										BgL_ez00_16686 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16686,
											BgL_sz00_16675);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16687;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16688;

												BgL_savedzd2bpzd2_16688 =
													VECTOR_REF(BgL_nsz00_16684, ((long) 0));
												VECTOR_SET(BgL_nsz00_16684, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16690;

													BgL_fz00_16690 = BgL_runz00_14386;
												BgL_recz00_16689:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16691;

														BgL_rz00_16691 =
															PROCEDURE_ENTRY(BgL_fz00_16690) (BgL_fz00_16690,
															BgL_nsz00_16684, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6622z00_26461;

															if (PROCEDUREP(BgL_rz00_16691))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16692;

																	BgL_arg1732z00_16692 =
																		PROCEDURE_ATTR(BgL_rz00_16691);
																	if (STRUCTP(BgL_arg1732z00_16692))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6622z00_26461 =
																				(STRUCT_KEY(BgL_arg1732z00_16692) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6622z00_26461 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6622z00_26461 = ((bool_t) 0);
																}
															if (BgL_test6622z00_26461)
																{
																	obj_t BgL_fz00_26469;

																	BgL_fz00_26469 = BgL_rz00_16691;
																	BgL_fz00_16690 = BgL_fz00_26469;
																	goto BgL_recz00_16689;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16684, ((long) 0),
																		BgL_savedzd2bpzd2_16688);
																	BgL_____rz00_16687 = BgL_rz00_16691;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16686);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16685, BgL_sz00_16675);
											return BgL_____rz00_16687;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run */
	obj_t BGl_z62runz62zz__evaluate_compz00(obj_t BgL_envz00_14393,
		obj_t BgL_sz00_14396)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14394;
				obj_t BgL_bodyz00_14395;

				BgL_i1247z00_14394 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14393, (int) (((long) 0))));
				BgL_bodyz00_14395 = PROCEDURE_REF(BgL_envz00_14393, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16693;

					BgL_bpz00_16693 = VECTOR_REF(((obj_t) BgL_sz00_14396), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16694;
						obj_t BgL_wherez00_16695;
						obj_t BgL_locz00_16696;

						BgL_z12denvz12_16694 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16695 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14394))->
							BgL_wherez00);
						BgL_locz00_16696 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14394))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16694, BgL_wherez00_16695,
								BgL_locz00_16696);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16697;

								BgL_za2za2resza2za2z00_16697 =
									PROCEDURE_ENTRY(BgL_bodyz00_14395) (BgL_bodyz00_14395,
									BgL_sz00_14396, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16694);
								return BgL_za2za2resza2za2z00_16697;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3925> */
	obj_t BGl_z62zc3z04anonymousza33925ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14397, obj_t BgL_sz00_14402)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14398;
				BgL_ev_absz00_bglt BgL_i1247z00_14399;
				obj_t BgL_bodyz00_14400;
				long BgL_siza7ezd2framez75_14401;

				BgL_iboxesz00_14398 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14397, (int) (((long) 0))));
				BgL_i1247z00_14399 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14397, (int) (((long) 1))));
				BgL_bodyz00_14400 = PROCEDURE_REF(BgL_envz00_14397, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14401 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14397, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16698;

					BgL_bpz00_16698 = VECTOR_REF(((obj_t) BgL_sz00_14402), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16699;

							BgL_runz00_16699 =
								MAKE_FX_PROCEDURE(BGl_z62run5750z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16699,
								(int) (((long) 0)), BgL_iboxesz00_14398);
							PROCEDURE_SET(BgL_runz00_16699,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14399));
							PROCEDURE_SET(BgL_runz00_16699,
								(int) (((long) 2)), BgL_bodyz00_14400);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16700;

								BgL_mainz00_16700 =
									MAKE_VA_PROCEDURE(BGl_z62main5749z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16700,
									(int) (((long) 0)), BgL_iboxesz00_14398);
								PROCEDURE_SET(BgL_mainz00_16700,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14399));
								PROCEDURE_SET(BgL_mainz00_16700,
									(int) (((long) 2)), BgL_bodyz00_14400);
								PROCEDURE_SET(BgL_mainz00_16700,
									(int) (((long) 3)), BgL_runz00_16699);
								PROCEDURE_SET(BgL_mainz00_16700,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14401));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16701;

									BgL_objz00_16701 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16699, BgL_objz00_16701);
									BgL_objz00_16701;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3926z00_16702;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3927z00_16703;

										BgL_arg3927z00_16703 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14399))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16704;

											BgL_newz00_16704 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26531;

												BgL_tmpz00_26531 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16704, BgL_tmpz00_26531,
													BgL_arg3927z00_16703);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26536;
												int BgL_tmpz00_26534;

												BgL_auxz00_26536 = BINT(BgL_siza7ezd2framez75_14401);
												BgL_tmpz00_26534 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16704, BgL_tmpz00_26534,
													BgL_auxz00_26536);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26539;

												BgL_tmpz00_26539 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16704, BgL_tmpz00_26539,
													BgL_runz00_16699);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26544;
												int BgL_tmpz00_26542;

												BgL_auxz00_26544 = BINT(((long) -5));
												BgL_tmpz00_26542 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16704, BgL_tmpz00_26542,
													BgL_auxz00_26544);
											}
											BgL_arg3926z00_16702 = BgL_newz00_16704;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16700, BgL_arg3926z00_16702);
									BgL_arg3926z00_16702;
								}
								return BgL_mainz00_16700;
							}
						}
					}
				}
			}
		}

	}



/* &main5749 */
	obj_t BGl_z62main5749z62zz__evaluate_compz00(obj_t BgL_envz00_14403,
		obj_t BgL_az00_14409, obj_t BgL_bz00_14410, obj_t BgL_cz00_14411,
		obj_t BgL_dz00_14412, obj_t BgL_lastz00_14413)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14407;
				long BgL_siza7ezd2framez75_14408;

				BgL_runz00_14407 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14403, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14408 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14403, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16705;

					BgL_sz00_16705 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16706;

						BgL_bpz00_16706 = VECTOR_REF(((obj_t) BgL_sz00_16705), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16706) + BgL_siza7ezd2framez75_14408) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16705))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3930z00_16707;

									BgL_arg3930z00_16707 =
										((long) CINT(BgL_bpz00_16706) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16705), BgL_arg3930z00_16707,
										BgL_az00_14409);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3931z00_16708;

									BgL_arg3931z00_16708 =
										((long) CINT(BgL_bpz00_16706) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16705), BgL_arg3931z00_16708,
										BgL_bz00_14410);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3932z00_16709;

									BgL_arg3932z00_16709 =
										((long) CINT(BgL_bpz00_16706) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16705), BgL_arg3932z00_16709,
										BgL_cz00_14411);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3933z00_16710;

									BgL_arg3933z00_16710 =
										((long) CINT(BgL_bpz00_16706) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16705), BgL_arg3933z00_16710,
										BgL_dz00_14412);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3934z00_16711;

									BgL_arg3934z00_16711 =
										((long) CINT(BgL_bpz00_16706) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16705), BgL_arg3934z00_16711,
										BgL_lastz00_14413);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16712;

									BgL_ez00_16712 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16712,
										BgL_bpz00_16706);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16713;

										BgL_accz00_16713 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14407, BgL_sz00_16705, BgL_bpz00_16706);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16712);
										VECTOR_SET(
											((obj_t) BgL_sz00_16705), ((long) 0), BgL_bpz00_16706);
										return BgL_accz00_16713;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16714;

								BgL_nsz00_16714 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16714, ((long) 1), BgL_sz00_16705);
								VECTOR_SET(BgL_nsz00_16714, ((long) 2), BgL_az00_14409);
								VECTOR_SET(BgL_nsz00_16714, ((long) 3), BgL_bz00_14410);
								VECTOR_SET(BgL_nsz00_16714, ((long) 4), BgL_cz00_14411);
								VECTOR_SET(BgL_nsz00_16714, ((long) 5), BgL_dz00_14412);
								VECTOR_SET(BgL_nsz00_16714, ((long) 6), BgL_lastz00_14413);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16715;

									BgL_z12denvz12_16715 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16715, BgL_nsz00_16714);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16716;

										BgL_ez00_16716 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16716,
											BgL_sz00_16705);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16717;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16718;

												BgL_savedzd2bpzd2_16718 =
													VECTOR_REF(BgL_nsz00_16714, ((long) 0));
												VECTOR_SET(BgL_nsz00_16714, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16720;

													BgL_fz00_16720 = BgL_runz00_14407;
												BgL_recz00_16719:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16721;

														BgL_rz00_16721 =
															PROCEDURE_ENTRY(BgL_fz00_16720) (BgL_fz00_16720,
															BgL_nsz00_16714, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6626z00_26607;

															if (PROCEDUREP(BgL_rz00_16721))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16722;

																	BgL_arg1732z00_16722 =
																		PROCEDURE_ATTR(BgL_rz00_16721);
																	if (STRUCTP(BgL_arg1732z00_16722))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6626z00_26607 =
																				(STRUCT_KEY(BgL_arg1732z00_16722) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6626z00_26607 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6626z00_26607 = ((bool_t) 0);
																}
															if (BgL_test6626z00_26607)
																{
																	obj_t BgL_fz00_26615;

																	BgL_fz00_26615 = BgL_rz00_16721;
																	BgL_fz00_16720 = BgL_fz00_26615;
																	goto BgL_recz00_16719;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16714, ((long) 0),
																		BgL_savedzd2bpzd2_16718);
																	BgL_____rz00_16717 = BgL_rz00_16721;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16716);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16715, BgL_sz00_16705);
											return BgL_____rz00_16717;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5750 */
	obj_t BGl_z62run5750z62zz__evaluate_compz00(obj_t BgL_envz00_14414,
		obj_t BgL_sz00_14418)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14415;
				BgL_ev_absz00_bglt BgL_i1247z00_14416;
				obj_t BgL_bodyz00_14417;

				BgL_iboxesz00_14415 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14414, (int) (((long) 0))));
				BgL_i1247z00_14416 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14414, (int) (((long) 1))));
				BgL_bodyz00_14417 = PROCEDURE_REF(BgL_envz00_14414, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16723;

					BgL_bpz00_16723 = VECTOR_REF(((obj_t) BgL_sz00_14418), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14418,
						BgL_iboxesz00_14415, BgL_bpz00_16723);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16724;
						obj_t BgL_wherez00_16725;
						obj_t BgL_locz00_16726;

						BgL_z12denvz12_16724 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16725 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14416))->
							BgL_wherez00);
						BgL_locz00_16726 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14416))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16724, BgL_wherez00_16725,
								BgL_locz00_16726);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16727;

								BgL_za2za2resza2za2z00_16727 =
									PROCEDURE_ENTRY(BgL_bodyz00_14417) (BgL_bodyz00_14417,
									BgL_sz00_14418, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16724);
								return BgL_za2za2resza2za2z00_16727;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3939> */
	obj_t BGl_z62zc3z04anonymousza33939ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14419, obj_t BgL_sz00_14425)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14420;
				long BgL_siza7eza7_14421;
				BgL_ev_absz00_bglt BgL_i1247z00_14422;
				obj_t BgL_bodyz00_14423;
				long BgL_siza7ezd2framez75_14424;

				BgL_ifreesz00_14420 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14419, (int) (((long) 0))));
				BgL_siza7eza7_14421 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14419, (int) (((long) 1))));
				BgL_i1247z00_14422 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14419, (int) (((long) 2))));
				BgL_bodyz00_14423 = PROCEDURE_REF(BgL_envz00_14419, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14424 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14419, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16728;

					BgL_bpz00_16728 = VECTOR_REF(((obj_t) BgL_sz00_14425), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16729;

						BgL_valza2za2_16729 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14425,
							BgL_bpz00_16728, BgL_ifreesz00_14420);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16730;

							BgL_runz00_16730 =
								MAKE_FX_PROCEDURE(BGl_z62run5752z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16730,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14421));
							PROCEDURE_SET(BgL_runz00_16730,
								(int) (((long) 1)), BgL_valza2za2_16729);
							PROCEDURE_SET(BgL_runz00_16730,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14422));
							PROCEDURE_SET(BgL_runz00_16730,
								(int) (((long) 3)), BgL_bodyz00_14423);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16731;

								BgL_mainz00_16731 =
									MAKE_VA_PROCEDURE(BGl_z62main5751z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16731,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14421));
								PROCEDURE_SET(BgL_mainz00_16731,
									(int) (((long) 1)), BgL_valza2za2_16729);
								PROCEDURE_SET(BgL_mainz00_16731,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14422));
								PROCEDURE_SET(BgL_mainz00_16731,
									(int) (((long) 3)), BgL_bodyz00_14423);
								PROCEDURE_SET(BgL_mainz00_16731,
									(int) (((long) 4)), BgL_runz00_16730);
								PROCEDURE_SET(BgL_mainz00_16731,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14424));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16732;

									BgL_objz00_16732 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16730, BgL_objz00_16732);
									BgL_objz00_16732;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3940z00_16733;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3941z00_16734;

										BgL_arg3941z00_16734 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14422))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16735;

											BgL_newz00_16735 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26691;

												BgL_tmpz00_26691 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16735, BgL_tmpz00_26691,
													BgL_arg3941z00_16734);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26696;
												int BgL_tmpz00_26694;

												BgL_auxz00_26696 = BINT(BgL_siza7ezd2framez75_14424);
												BgL_tmpz00_26694 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16735, BgL_tmpz00_26694,
													BgL_auxz00_26696);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26699;

												BgL_tmpz00_26699 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16735, BgL_tmpz00_26699,
													BgL_runz00_16730);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26704;
												int BgL_tmpz00_26702;

												BgL_auxz00_26704 = BINT(((long) -5));
												BgL_tmpz00_26702 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16735, BgL_tmpz00_26702,
													BgL_auxz00_26704);
											}
											BgL_arg3940z00_16733 = BgL_newz00_16735;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16731, BgL_arg3940z00_16733);
									BgL_arg3940z00_16733;
								}
								return BgL_mainz00_16731;
							}
						}
					}
				}
			}
		}

	}



/* &main5751 */
	obj_t BGl_z62main5751z62zz__evaluate_compz00(obj_t BgL_envz00_14426,
		obj_t BgL_az00_14433, obj_t BgL_bz00_14434, obj_t BgL_cz00_14435,
		obj_t BgL_dz00_14436, obj_t BgL_lastz00_14437)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14431;
				long BgL_siza7ezd2framez75_14432;

				BgL_runz00_14431 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14426, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14432 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14426, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16736;

					BgL_sz00_16736 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16737;

						BgL_bpz00_16737 = VECTOR_REF(((obj_t) BgL_sz00_16736), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16737) + BgL_siza7ezd2framez75_14432) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16736))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3944z00_16738;

									BgL_arg3944z00_16738 =
										((long) CINT(BgL_bpz00_16737) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16736), BgL_arg3944z00_16738,
										BgL_az00_14433);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3945z00_16739;

									BgL_arg3945z00_16739 =
										((long) CINT(BgL_bpz00_16737) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16736), BgL_arg3945z00_16739,
										BgL_bz00_14434);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3946z00_16740;

									BgL_arg3946z00_16740 =
										((long) CINT(BgL_bpz00_16737) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16736), BgL_arg3946z00_16740,
										BgL_cz00_14435);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3947z00_16741;

									BgL_arg3947z00_16741 =
										((long) CINT(BgL_bpz00_16737) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16736), BgL_arg3947z00_16741,
										BgL_dz00_14436);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3948z00_16742;

									BgL_arg3948z00_16742 =
										((long) CINT(BgL_bpz00_16737) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16736), BgL_arg3948z00_16742,
										BgL_lastz00_14437);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16743;

									BgL_ez00_16743 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16743,
										BgL_bpz00_16737);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16744;

										BgL_accz00_16744 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14431, BgL_sz00_16736, BgL_bpz00_16737);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16743);
										VECTOR_SET(
											((obj_t) BgL_sz00_16736), ((long) 0), BgL_bpz00_16737);
										return BgL_accz00_16744;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16745;

								BgL_nsz00_16745 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16745, ((long) 1), BgL_sz00_16736);
								VECTOR_SET(BgL_nsz00_16745, ((long) 2), BgL_az00_14433);
								VECTOR_SET(BgL_nsz00_16745, ((long) 3), BgL_bz00_14434);
								VECTOR_SET(BgL_nsz00_16745, ((long) 4), BgL_cz00_14435);
								VECTOR_SET(BgL_nsz00_16745, ((long) 5), BgL_dz00_14436);
								VECTOR_SET(BgL_nsz00_16745, ((long) 6), BgL_lastz00_14437);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16746;

									BgL_z12denvz12_16746 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16746, BgL_nsz00_16745);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16747;

										BgL_ez00_16747 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16747,
											BgL_sz00_16736);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16748;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16749;

												BgL_savedzd2bpzd2_16749 =
													VECTOR_REF(BgL_nsz00_16745, ((long) 0));
												VECTOR_SET(BgL_nsz00_16745, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16751;

													BgL_fz00_16751 = BgL_runz00_14431;
												BgL_recz00_16750:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16752;

														BgL_rz00_16752 =
															PROCEDURE_ENTRY(BgL_fz00_16751) (BgL_fz00_16751,
															BgL_nsz00_16745, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6630z00_26767;

															if (PROCEDUREP(BgL_rz00_16752))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16753;

																	BgL_arg1732z00_16753 =
																		PROCEDURE_ATTR(BgL_rz00_16752);
																	if (STRUCTP(BgL_arg1732z00_16753))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6630z00_26767 =
																				(STRUCT_KEY(BgL_arg1732z00_16753) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6630z00_26767 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6630z00_26767 = ((bool_t) 0);
																}
															if (BgL_test6630z00_26767)
																{
																	obj_t BgL_fz00_26775;

																	BgL_fz00_26775 = BgL_rz00_16752;
																	BgL_fz00_16751 = BgL_fz00_26775;
																	goto BgL_recz00_16750;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16745, ((long) 0),
																		BgL_savedzd2bpzd2_16749);
																	BgL_____rz00_16748 = BgL_rz00_16752;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16747);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16746, BgL_sz00_16736);
											return BgL_____rz00_16748;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5752 */
	obj_t BGl_z62run5752z62zz__evaluate_compz00(obj_t BgL_envz00_14438,
		obj_t BgL_sz00_14443)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14439;
				obj_t BgL_valza2za2_14440;
				BgL_ev_absz00_bglt BgL_i1247z00_14441;
				obj_t BgL_bodyz00_14442;

				BgL_siza7eza7_14439 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14438, (int) (((long) 0))));
				BgL_valza2za2_14440 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14438, (int) (((long) 1))));
				BgL_i1247z00_14441 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14438, (int) (((long) 2))));
				BgL_bodyz00_14442 = PROCEDURE_REF(BgL_envz00_14438, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16754;

					BgL_bpz00_16754 = VECTOR_REF(((obj_t) BgL_sz00_14443), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14443,
						BgL_valza2za2_14440,
						((long) CINT(BgL_bpz00_16754) + BgL_siza7eza7_14439));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16755;
						obj_t BgL_wherez00_16756;
						obj_t BgL_locz00_16757;

						BgL_z12denvz12_16755 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16756 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14441))->
							BgL_wherez00);
						BgL_locz00_16757 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14441))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16755, BgL_wherez00_16756,
								BgL_locz00_16757);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16758;

								BgL_za2za2resza2za2z00_16758 =
									PROCEDURE_ENTRY(BgL_bodyz00_14442) (BgL_bodyz00_14442,
									BgL_sz00_14443, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16755);
								return BgL_za2za2resza2za2z00_16758;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3951> */
	obj_t BGl_z62zc3z04anonymousza33951ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14444, obj_t BgL_sz00_14451)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14445;
				obj_t BgL_iboxesz00_14446;
				long BgL_siza7eza7_14447;
				BgL_ev_absz00_bglt BgL_i1247z00_14448;
				obj_t BgL_bodyz00_14449;
				long BgL_siza7ezd2framez75_14450;

				BgL_ifreesz00_14445 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 0))));
				BgL_iboxesz00_14446 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 1))));
				BgL_siza7eza7_14447 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 2))));
				BgL_i1247z00_14448 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 3))));
				BgL_bodyz00_14449 = PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14450 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14444, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16759;

					BgL_bpz00_16759 = VECTOR_REF(((obj_t) BgL_sz00_14451), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16760;

						BgL_valza2za2_16760 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14451,
							BgL_bpz00_16759, BgL_ifreesz00_14445);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16761;

							BgL_runz00_16761 =
								MAKE_FX_PROCEDURE(BGl_z62run5754z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16761,
								(int) (((long) 0)), BgL_iboxesz00_14446);
							PROCEDURE_SET(BgL_runz00_16761,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14447));
							PROCEDURE_SET(BgL_runz00_16761,
								(int) (((long) 2)), BgL_valza2za2_16760);
							PROCEDURE_SET(BgL_runz00_16761,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14448));
							PROCEDURE_SET(BgL_runz00_16761,
								(int) (((long) 4)), BgL_bodyz00_14449);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16762;

								BgL_mainz00_16762 =
									MAKE_VA_PROCEDURE(BGl_z62main5753z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16762,
									(int) (((long) 0)), BgL_iboxesz00_14446);
								PROCEDURE_SET(BgL_mainz00_16762,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14447));
								PROCEDURE_SET(BgL_mainz00_16762,
									(int) (((long) 2)), BgL_valza2za2_16760);
								PROCEDURE_SET(BgL_mainz00_16762,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14448));
								PROCEDURE_SET(BgL_mainz00_16762,
									(int) (((long) 4)), BgL_bodyz00_14449);
								PROCEDURE_SET(BgL_mainz00_16762,
									(int) (((long) 5)), BgL_runz00_16761);
								PROCEDURE_SET(BgL_mainz00_16762,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14450));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16763;

									BgL_objz00_16763 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16761, BgL_objz00_16763);
									BgL_objz00_16763;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3952z00_16764;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3953z00_16765;

										BgL_arg3953z00_16765 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14448))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16766;

											BgL_newz00_16766 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26863;

												BgL_tmpz00_26863 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16766, BgL_tmpz00_26863,
													BgL_arg3953z00_16765);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26868;
												int BgL_tmpz00_26866;

												BgL_auxz00_26868 = BINT(BgL_siza7ezd2framez75_14450);
												BgL_tmpz00_26866 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16766, BgL_tmpz00_26866,
													BgL_auxz00_26868);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_26871;

												BgL_tmpz00_26871 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16766, BgL_tmpz00_26871,
													BgL_runz00_16761);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_26876;
												int BgL_tmpz00_26874;

												BgL_auxz00_26876 = BINT(((long) -5));
												BgL_tmpz00_26874 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16766, BgL_tmpz00_26874,
													BgL_auxz00_26876);
											}
											BgL_arg3952z00_16764 = BgL_newz00_16766;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16762, BgL_arg3952z00_16764);
									BgL_arg3952z00_16764;
								}
								return BgL_mainz00_16762;
							}
						}
					}
				}
			}
		}

	}



/* &main5753 */
	obj_t BGl_z62main5753z62zz__evaluate_compz00(obj_t BgL_envz00_14452,
		obj_t BgL_az00_14460, obj_t BgL_bz00_14461, obj_t BgL_cz00_14462,
		obj_t BgL_dz00_14463, obj_t BgL_lastz00_14464)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14458;
				long BgL_siza7ezd2framez75_14459;

				BgL_runz00_14458 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14452, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14459 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14452, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16767;

					BgL_sz00_16767 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16768;

						BgL_bpz00_16768 = VECTOR_REF(((obj_t) BgL_sz00_16767), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16768) + BgL_siza7ezd2framez75_14459) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16767))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3956z00_16769;

									BgL_arg3956z00_16769 =
										((long) CINT(BgL_bpz00_16768) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16767), BgL_arg3956z00_16769,
										BgL_az00_14460);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3957z00_16770;

									BgL_arg3957z00_16770 =
										((long) CINT(BgL_bpz00_16768) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16767), BgL_arg3957z00_16770,
										BgL_bz00_14461);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3958z00_16771;

									BgL_arg3958z00_16771 =
										((long) CINT(BgL_bpz00_16768) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16767), BgL_arg3958z00_16771,
										BgL_cz00_14462);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3959z00_16772;

									BgL_arg3959z00_16772 =
										((long) CINT(BgL_bpz00_16768) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16767), BgL_arg3959z00_16772,
										BgL_dz00_14463);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3960z00_16773;

									BgL_arg3960z00_16773 =
										((long) CINT(BgL_bpz00_16768) + ((long) 4));
									VECTOR_SET(
										((obj_t) BgL_sz00_16767), BgL_arg3960z00_16773,
										BgL_lastz00_14464);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16774;

									BgL_ez00_16774 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16774,
										BgL_bpz00_16768);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16775;

										BgL_accz00_16775 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14458, BgL_sz00_16767, BgL_bpz00_16768);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16774);
										VECTOR_SET(
											((obj_t) BgL_sz00_16767), ((long) 0), BgL_bpz00_16768);
										return BgL_accz00_16775;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16776;

								BgL_nsz00_16776 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16776, ((long) 1), BgL_sz00_16767);
								VECTOR_SET(BgL_nsz00_16776, ((long) 2), BgL_az00_14460);
								VECTOR_SET(BgL_nsz00_16776, ((long) 3), BgL_bz00_14461);
								VECTOR_SET(BgL_nsz00_16776, ((long) 4), BgL_cz00_14462);
								VECTOR_SET(BgL_nsz00_16776, ((long) 5), BgL_dz00_14463);
								VECTOR_SET(BgL_nsz00_16776, ((long) 6), BgL_lastz00_14464);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16777;

									BgL_z12denvz12_16777 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16777, BgL_nsz00_16776);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16778;

										BgL_ez00_16778 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16778,
											BgL_sz00_16767);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16779;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16780;

												BgL_savedzd2bpzd2_16780 =
													VECTOR_REF(BgL_nsz00_16776, ((long) 0));
												VECTOR_SET(BgL_nsz00_16776, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16782;

													BgL_fz00_16782 = BgL_runz00_14458;
												BgL_recz00_16781:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16783;

														BgL_rz00_16783 =
															PROCEDURE_ENTRY(BgL_fz00_16782) (BgL_fz00_16782,
															BgL_nsz00_16776, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6634z00_26939;

															if (PROCEDUREP(BgL_rz00_16783))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16784;

																	BgL_arg1732z00_16784 =
																		PROCEDURE_ATTR(BgL_rz00_16783);
																	if (STRUCTP(BgL_arg1732z00_16784))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6634z00_26939 =
																				(STRUCT_KEY(BgL_arg1732z00_16784) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6634z00_26939 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6634z00_26939 = ((bool_t) 0);
																}
															if (BgL_test6634z00_26939)
																{
																	obj_t BgL_fz00_26947;

																	BgL_fz00_26947 = BgL_rz00_16783;
																	BgL_fz00_16782 = BgL_fz00_26947;
																	goto BgL_recz00_16781;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16776, ((long) 0),
																		BgL_savedzd2bpzd2_16780);
																	BgL_____rz00_16779 = BgL_rz00_16783;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16778);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16777, BgL_sz00_16767);
											return BgL_____rz00_16779;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5754 */
	obj_t BGl_z62run5754z62zz__evaluate_compz00(obj_t BgL_envz00_14465,
		obj_t BgL_sz00_14471)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14466;
				long BgL_siza7eza7_14467;
				obj_t BgL_valza2za2_14468;
				BgL_ev_absz00_bglt BgL_i1247z00_14469;
				obj_t BgL_bodyz00_14470;

				BgL_iboxesz00_14466 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14465, (int) (((long) 0))));
				BgL_siza7eza7_14467 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14465, (int) (((long) 1))));
				BgL_valza2za2_14468 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14465, (int) (((long) 2))));
				BgL_i1247z00_14469 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14465, (int) (((long) 3))));
				BgL_bodyz00_14470 = PROCEDURE_REF(BgL_envz00_14465, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16785;

					BgL_bpz00_16785 = VECTOR_REF(((obj_t) BgL_sz00_14471), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14471,
						BgL_iboxesz00_14466, BgL_bpz00_16785);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14471,
						BgL_valza2za2_14468,
						((long) CINT(BgL_bpz00_16785) + BgL_siza7eza7_14467));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16786;
						obj_t BgL_wherez00_16787;
						obj_t BgL_locz00_16788;

						BgL_z12denvz12_16786 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16787 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14469))->
							BgL_wherez00);
						BgL_locz00_16788 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14469))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16786, BgL_wherez00_16787,
								BgL_locz00_16788);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16789;

								BgL_za2za2resza2za2z00_16789 =
									PROCEDURE_ENTRY(BgL_bodyz00_14470) (BgL_bodyz00_14470,
									BgL_sz00_14471, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16786);
								return BgL_za2za2resza2za2z00_16789;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3863> */
	obj_t BGl_z62zc3z04anonymousza33863ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14472, obj_t BgL_sz00_14476)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14473;
				obj_t BgL_bodyz00_14474;
				long BgL_siza7ezd2framez75_14475;

				BgL_i1247z00_14473 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14472, (int) (((long) 0))));
				BgL_bodyz00_14474 = PROCEDURE_REF(BgL_envz00_14472, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14475 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14472, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16790;

					BgL_bpz00_16790 = VECTOR_REF(((obj_t) BgL_sz00_14476), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16791;

							BgL_runz00_16791 =
								MAKE_FX_PROCEDURE(BGl_z62run5756z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16791,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14473));
							PROCEDURE_SET(BgL_runz00_16791,
								(int) (((long) 1)), BgL_bodyz00_14474);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16792;

								BgL_mainz00_16792 =
									MAKE_FX_PROCEDURE(BGl_z62main5755z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16792,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14473));
								PROCEDURE_SET(BgL_mainz00_16792,
									(int) (((long) 1)), BgL_bodyz00_14474);
								PROCEDURE_SET(BgL_mainz00_16792,
									(int) (((long) 2)), BgL_runz00_16791);
								PROCEDURE_SET(BgL_mainz00_16792,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14475));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16793;

									BgL_objz00_16793 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16791, BgL_objz00_16793);
									BgL_objz00_16793;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3864z00_16794;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3865z00_16795;

										BgL_arg3865z00_16795 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14473))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16796;

											BgL_newz00_16796 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27015;

												BgL_tmpz00_27015 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16796, BgL_tmpz00_27015,
													BgL_arg3865z00_16795);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27020;
												int BgL_tmpz00_27018;

												BgL_auxz00_27020 = BINT(BgL_siza7ezd2framez75_14475);
												BgL_tmpz00_27018 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16796, BgL_tmpz00_27018,
													BgL_auxz00_27020);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27023;

												BgL_tmpz00_27023 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16796, BgL_tmpz00_27023,
													BgL_runz00_16791);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27028;
												int BgL_tmpz00_27026;

												BgL_auxz00_27028 = BINT(((long) 4));
												BgL_tmpz00_27026 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16796, BgL_tmpz00_27026,
													BgL_auxz00_27028);
											}
											BgL_arg3864z00_16794 = BgL_newz00_16796;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16792, BgL_arg3864z00_16794);
									BgL_arg3864z00_16794;
								}
								return BgL_mainz00_16792;
							}
						}
					}
				}
			}
		}

	}



/* &main5755 */
	obj_t BGl_z62main5755z62zz__evaluate_compz00(obj_t BgL_envz00_14477,
		obj_t BgL_az00_14482, obj_t BgL_bz00_14483, obj_t BgL_cz00_14484,
		obj_t BgL_dz00_14485)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14480;
				long BgL_siza7ezd2framez75_14481;

				BgL_runz00_14480 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14477, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14481 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14477, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16797;

					BgL_sz00_16797 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16798;

						BgL_bpz00_16798 = VECTOR_REF(((obj_t) BgL_sz00_16797), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16798) + BgL_siza7ezd2framez75_14481) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16797))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3868z00_16799;

									BgL_arg3868z00_16799 =
										((long) CINT(BgL_bpz00_16798) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16797), BgL_arg3868z00_16799,
										BgL_az00_14482);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3869z00_16800;

									BgL_arg3869z00_16800 =
										((long) CINT(BgL_bpz00_16798) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16797), BgL_arg3869z00_16800,
										BgL_bz00_14483);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3870z00_16801;

									BgL_arg3870z00_16801 =
										((long) CINT(BgL_bpz00_16798) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16797), BgL_arg3870z00_16801,
										BgL_cz00_14484);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3871z00_16802;

									BgL_arg3871z00_16802 =
										((long) CINT(BgL_bpz00_16798) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16797), BgL_arg3871z00_16802,
										BgL_dz00_14485);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16803;

									BgL_ez00_16803 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16803,
										BgL_bpz00_16798);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16804;

										BgL_accz00_16804 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14480, BgL_sz00_16797, BgL_bpz00_16798);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16803);
										VECTOR_SET(
											((obj_t) BgL_sz00_16797), ((long) 0), BgL_bpz00_16798);
										return BgL_accz00_16804;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16805;

								BgL_nsz00_16805 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16805, ((long) 1), BgL_sz00_16797);
								VECTOR_SET(BgL_nsz00_16805, ((long) 2), BgL_az00_14482);
								VECTOR_SET(BgL_nsz00_16805, ((long) 3), BgL_bz00_14483);
								VECTOR_SET(BgL_nsz00_16805, ((long) 4), BgL_cz00_14484);
								VECTOR_SET(BgL_nsz00_16805, ((long) 5), BgL_dz00_14485);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16806;

									BgL_z12denvz12_16806 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16806, BgL_nsz00_16805);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16807;

										BgL_ez00_16807 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16807,
											BgL_sz00_16797);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16808;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16809;

												BgL_savedzd2bpzd2_16809 =
													VECTOR_REF(BgL_nsz00_16805, ((long) 0));
												VECTOR_SET(BgL_nsz00_16805, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16811;

													BgL_fz00_16811 = BgL_runz00_14480;
												BgL_recz00_16810:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16812;

														BgL_rz00_16812 =
															PROCEDURE_ENTRY(BgL_fz00_16811) (BgL_fz00_16811,
															BgL_nsz00_16805, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6638z00_27086;

															if (PROCEDUREP(BgL_rz00_16812))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16813;

																	BgL_arg1732z00_16813 =
																		PROCEDURE_ATTR(BgL_rz00_16812);
																	if (STRUCTP(BgL_arg1732z00_16813))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6638z00_27086 =
																				(STRUCT_KEY(BgL_arg1732z00_16813) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6638z00_27086 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6638z00_27086 = ((bool_t) 0);
																}
															if (BgL_test6638z00_27086)
																{
																	obj_t BgL_fz00_27094;

																	BgL_fz00_27094 = BgL_rz00_16812;
																	BgL_fz00_16811 = BgL_fz00_27094;
																	goto BgL_recz00_16810;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16805, ((long) 0),
																		BgL_savedzd2bpzd2_16809);
																	BgL_____rz00_16808 = BgL_rz00_16812;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16807);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16806, BgL_sz00_16797);
											return BgL_____rz00_16808;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5756 */
	obj_t BGl_z62run5756z62zz__evaluate_compz00(obj_t BgL_envz00_14486,
		obj_t BgL_sz00_14489)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14487;
				obj_t BgL_bodyz00_14488;

				BgL_i1247z00_14487 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14486, (int) (((long) 0))));
				BgL_bodyz00_14488 = PROCEDURE_REF(BgL_envz00_14486, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16814;

					BgL_bpz00_16814 = VECTOR_REF(((obj_t) BgL_sz00_14489), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16815;
						obj_t BgL_wherez00_16816;
						obj_t BgL_locz00_16817;

						BgL_z12denvz12_16815 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16816 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14487))->
							BgL_wherez00);
						BgL_locz00_16817 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14487))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16815, BgL_wherez00_16816,
								BgL_locz00_16817);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16818;

								BgL_za2za2resza2za2z00_16818 =
									PROCEDURE_ENTRY(BgL_bodyz00_14488) (BgL_bodyz00_14488,
									BgL_sz00_14489, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16815);
								return BgL_za2za2resza2za2z00_16818;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3873> */
	obj_t BGl_z62zc3z04anonymousza33873ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14490, obj_t BgL_sz00_14495)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14491;
				BgL_ev_absz00_bglt BgL_i1247z00_14492;
				obj_t BgL_bodyz00_14493;
				long BgL_siza7ezd2framez75_14494;

				BgL_iboxesz00_14491 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14490, (int) (((long) 0))));
				BgL_i1247z00_14492 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14490, (int) (((long) 1))));
				BgL_bodyz00_14493 = PROCEDURE_REF(BgL_envz00_14490, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14494 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14490, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16819;

					BgL_bpz00_16819 = VECTOR_REF(((obj_t) BgL_sz00_14495), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16820;

							BgL_runz00_16820 =
								MAKE_FX_PROCEDURE(BGl_z62run5758z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16820,
								(int) (((long) 0)), BgL_iboxesz00_14491);
							PROCEDURE_SET(BgL_runz00_16820,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14492));
							PROCEDURE_SET(BgL_runz00_16820,
								(int) (((long) 2)), BgL_bodyz00_14493);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16821;

								BgL_mainz00_16821 =
									MAKE_FX_PROCEDURE(BGl_z62main5757z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16821,
									(int) (((long) 0)), BgL_iboxesz00_14491);
								PROCEDURE_SET(BgL_mainz00_16821,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14492));
								PROCEDURE_SET(BgL_mainz00_16821,
									(int) (((long) 2)), BgL_bodyz00_14493);
								PROCEDURE_SET(BgL_mainz00_16821,
									(int) (((long) 3)), BgL_runz00_16820);
								PROCEDURE_SET(BgL_mainz00_16821,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14494));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16822;

									BgL_objz00_16822 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16820, BgL_objz00_16822);
									BgL_objz00_16822;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3874z00_16823;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3875z00_16824;

										BgL_arg3875z00_16824 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14492))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16825;

											BgL_newz00_16825 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27156;

												BgL_tmpz00_27156 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16825, BgL_tmpz00_27156,
													BgL_arg3875z00_16824);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27161;
												int BgL_tmpz00_27159;

												BgL_auxz00_27161 = BINT(BgL_siza7ezd2framez75_14494);
												BgL_tmpz00_27159 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16825, BgL_tmpz00_27159,
													BgL_auxz00_27161);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27164;

												BgL_tmpz00_27164 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16825, BgL_tmpz00_27164,
													BgL_runz00_16820);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27169;
												int BgL_tmpz00_27167;

												BgL_auxz00_27169 = BINT(((long) 4));
												BgL_tmpz00_27167 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16825, BgL_tmpz00_27167,
													BgL_auxz00_27169);
											}
											BgL_arg3874z00_16823 = BgL_newz00_16825;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16821, BgL_arg3874z00_16823);
									BgL_arg3874z00_16823;
								}
								return BgL_mainz00_16821;
							}
						}
					}
				}
			}
		}

	}



/* &main5757 */
	obj_t BGl_z62main5757z62zz__evaluate_compz00(obj_t BgL_envz00_14496,
		obj_t BgL_az00_14502, obj_t BgL_bz00_14503, obj_t BgL_cz00_14504,
		obj_t BgL_dz00_14505)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14500;
				long BgL_siza7ezd2framez75_14501;

				BgL_runz00_14500 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14496, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14501 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14496, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16826;

					BgL_sz00_16826 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16827;

						BgL_bpz00_16827 = VECTOR_REF(((obj_t) BgL_sz00_16826), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16827) + BgL_siza7ezd2framez75_14501) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16826))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3878z00_16828;

									BgL_arg3878z00_16828 =
										((long) CINT(BgL_bpz00_16827) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16826), BgL_arg3878z00_16828,
										BgL_az00_14502);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3879z00_16829;

									BgL_arg3879z00_16829 =
										((long) CINT(BgL_bpz00_16827) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16826), BgL_arg3879z00_16829,
										BgL_bz00_14503);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3880z00_16830;

									BgL_arg3880z00_16830 =
										((long) CINT(BgL_bpz00_16827) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16826), BgL_arg3880z00_16830,
										BgL_cz00_14504);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3881z00_16831;

									BgL_arg3881z00_16831 =
										((long) CINT(BgL_bpz00_16827) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16826), BgL_arg3881z00_16831,
										BgL_dz00_14505);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16832;

									BgL_ez00_16832 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16832,
										BgL_bpz00_16827);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16833;

										BgL_accz00_16833 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14500, BgL_sz00_16826, BgL_bpz00_16827);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16832);
										VECTOR_SET(
											((obj_t) BgL_sz00_16826), ((long) 0), BgL_bpz00_16827);
										return BgL_accz00_16833;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16834;

								BgL_nsz00_16834 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16834, ((long) 1), BgL_sz00_16826);
								VECTOR_SET(BgL_nsz00_16834, ((long) 2), BgL_az00_14502);
								VECTOR_SET(BgL_nsz00_16834, ((long) 3), BgL_bz00_14503);
								VECTOR_SET(BgL_nsz00_16834, ((long) 4), BgL_cz00_14504);
								VECTOR_SET(BgL_nsz00_16834, ((long) 5), BgL_dz00_14505);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16835;

									BgL_z12denvz12_16835 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16835, BgL_nsz00_16834);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16836;

										BgL_ez00_16836 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16836,
											BgL_sz00_16826);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16837;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16838;

												BgL_savedzd2bpzd2_16838 =
													VECTOR_REF(BgL_nsz00_16834, ((long) 0));
												VECTOR_SET(BgL_nsz00_16834, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16840;

													BgL_fz00_16840 = BgL_runz00_14500;
												BgL_recz00_16839:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16841;

														BgL_rz00_16841 =
															PROCEDURE_ENTRY(BgL_fz00_16840) (BgL_fz00_16840,
															BgL_nsz00_16834, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6642z00_27227;

															if (PROCEDUREP(BgL_rz00_16841))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16842;

																	BgL_arg1732z00_16842 =
																		PROCEDURE_ATTR(BgL_rz00_16841);
																	if (STRUCTP(BgL_arg1732z00_16842))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6642z00_27227 =
																				(STRUCT_KEY(BgL_arg1732z00_16842) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6642z00_27227 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6642z00_27227 = ((bool_t) 0);
																}
															if (BgL_test6642z00_27227)
																{
																	obj_t BgL_fz00_27235;

																	BgL_fz00_27235 = BgL_rz00_16841;
																	BgL_fz00_16840 = BgL_fz00_27235;
																	goto BgL_recz00_16839;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16834, ((long) 0),
																		BgL_savedzd2bpzd2_16838);
																	BgL_____rz00_16837 = BgL_rz00_16841;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16836);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16835, BgL_sz00_16826);
											return BgL_____rz00_16837;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5758 */
	obj_t BGl_z62run5758z62zz__evaluate_compz00(obj_t BgL_envz00_14506,
		obj_t BgL_sz00_14510)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14507;
				BgL_ev_absz00_bglt BgL_i1247z00_14508;
				obj_t BgL_bodyz00_14509;

				BgL_iboxesz00_14507 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14506, (int) (((long) 0))));
				BgL_i1247z00_14508 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14506, (int) (((long) 1))));
				BgL_bodyz00_14509 = PROCEDURE_REF(BgL_envz00_14506, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16843;

					BgL_bpz00_16843 = VECTOR_REF(((obj_t) BgL_sz00_14510), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14510,
						BgL_iboxesz00_14507, BgL_bpz00_16843);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16844;
						obj_t BgL_wherez00_16845;
						obj_t BgL_locz00_16846;

						BgL_z12denvz12_16844 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16845 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14508))->
							BgL_wherez00);
						BgL_locz00_16846 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14508))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16844, BgL_wherez00_16845,
								BgL_locz00_16846);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16847;

								BgL_za2za2resza2za2z00_16847 =
									PROCEDURE_ENTRY(BgL_bodyz00_14509) (BgL_bodyz00_14509,
									BgL_sz00_14510, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16844);
								return BgL_za2za2resza2za2z00_16847;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3886> */
	obj_t BGl_z62zc3z04anonymousza33886ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14511, obj_t BgL_sz00_14517)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14512;
				long BgL_siza7eza7_14513;
				BgL_ev_absz00_bglt BgL_i1247z00_14514;
				obj_t BgL_bodyz00_14515;
				long BgL_siza7ezd2framez75_14516;

				BgL_ifreesz00_14512 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14511, (int) (((long) 0))));
				BgL_siza7eza7_14513 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14511, (int) (((long) 1))));
				BgL_i1247z00_14514 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14511, (int) (((long) 2))));
				BgL_bodyz00_14515 = PROCEDURE_REF(BgL_envz00_14511, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14516 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14511, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16848;

					BgL_bpz00_16848 = VECTOR_REF(((obj_t) BgL_sz00_14517), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16849;

						BgL_valza2za2_16849 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14517,
							BgL_bpz00_16848, BgL_ifreesz00_14512);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16850;

							BgL_runz00_16850 =
								MAKE_FX_PROCEDURE(BGl_z62run5760z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16850,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14513));
							PROCEDURE_SET(BgL_runz00_16850,
								(int) (((long) 1)), BgL_valza2za2_16849);
							PROCEDURE_SET(BgL_runz00_16850,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14514));
							PROCEDURE_SET(BgL_runz00_16850,
								(int) (((long) 3)), BgL_bodyz00_14515);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16851;

								BgL_mainz00_16851 =
									MAKE_FX_PROCEDURE(BGl_z62main5759z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16851,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14513));
								PROCEDURE_SET(BgL_mainz00_16851,
									(int) (((long) 1)), BgL_valza2za2_16849);
								PROCEDURE_SET(BgL_mainz00_16851,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14514));
								PROCEDURE_SET(BgL_mainz00_16851,
									(int) (((long) 3)), BgL_bodyz00_14515);
								PROCEDURE_SET(BgL_mainz00_16851,
									(int) (((long) 4)), BgL_runz00_16850);
								PROCEDURE_SET(BgL_mainz00_16851,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14516));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16852;

									BgL_objz00_16852 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16850, BgL_objz00_16852);
									BgL_objz00_16852;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3887z00_16853;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3888z00_16854;

										BgL_arg3888z00_16854 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14514))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16855;

											BgL_newz00_16855 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27311;

												BgL_tmpz00_27311 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16855, BgL_tmpz00_27311,
													BgL_arg3888z00_16854);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27316;
												int BgL_tmpz00_27314;

												BgL_auxz00_27316 = BINT(BgL_siza7ezd2framez75_14516);
												BgL_tmpz00_27314 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16855, BgL_tmpz00_27314,
													BgL_auxz00_27316);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27319;

												BgL_tmpz00_27319 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16855, BgL_tmpz00_27319,
													BgL_runz00_16850);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27324;
												int BgL_tmpz00_27322;

												BgL_auxz00_27324 = BINT(((long) 4));
												BgL_tmpz00_27322 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16855, BgL_tmpz00_27322,
													BgL_auxz00_27324);
											}
											BgL_arg3887z00_16853 = BgL_newz00_16855;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16851, BgL_arg3887z00_16853);
									BgL_arg3887z00_16853;
								}
								return BgL_mainz00_16851;
							}
						}
					}
				}
			}
		}

	}



/* &main5759 */
	obj_t BGl_z62main5759z62zz__evaluate_compz00(obj_t BgL_envz00_14518,
		obj_t BgL_az00_14525, obj_t BgL_bz00_14526, obj_t BgL_cz00_14527,
		obj_t BgL_dz00_14528)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14523;
				long BgL_siza7ezd2framez75_14524;

				BgL_runz00_14523 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14518, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14524 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14518, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16856;

					BgL_sz00_16856 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16857;

						BgL_bpz00_16857 = VECTOR_REF(((obj_t) BgL_sz00_16856), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16857) + BgL_siza7ezd2framez75_14524) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16856))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3891z00_16858;

									BgL_arg3891z00_16858 =
										((long) CINT(BgL_bpz00_16857) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16856), BgL_arg3891z00_16858,
										BgL_az00_14525);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3892z00_16859;

									BgL_arg3892z00_16859 =
										((long) CINT(BgL_bpz00_16857) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16856), BgL_arg3892z00_16859,
										BgL_bz00_14526);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3893z00_16860;

									BgL_arg3893z00_16860 =
										((long) CINT(BgL_bpz00_16857) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16856), BgL_arg3893z00_16860,
										BgL_cz00_14527);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3894z00_16861;

									BgL_arg3894z00_16861 =
										((long) CINT(BgL_bpz00_16857) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16856), BgL_arg3894z00_16861,
										BgL_dz00_14528);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16862;

									BgL_ez00_16862 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16862,
										BgL_bpz00_16857);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16863;

										BgL_accz00_16863 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14523, BgL_sz00_16856, BgL_bpz00_16857);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16862);
										VECTOR_SET(
											((obj_t) BgL_sz00_16856), ((long) 0), BgL_bpz00_16857);
										return BgL_accz00_16863;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16864;

								BgL_nsz00_16864 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16864, ((long) 1), BgL_sz00_16856);
								VECTOR_SET(BgL_nsz00_16864, ((long) 2), BgL_az00_14525);
								VECTOR_SET(BgL_nsz00_16864, ((long) 3), BgL_bz00_14526);
								VECTOR_SET(BgL_nsz00_16864, ((long) 4), BgL_cz00_14527);
								VECTOR_SET(BgL_nsz00_16864, ((long) 5), BgL_dz00_14528);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16865;

									BgL_z12denvz12_16865 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16865, BgL_nsz00_16864);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16866;

										BgL_ez00_16866 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16866,
											BgL_sz00_16856);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16867;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16868;

												BgL_savedzd2bpzd2_16868 =
													VECTOR_REF(BgL_nsz00_16864, ((long) 0));
												VECTOR_SET(BgL_nsz00_16864, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16870;

													BgL_fz00_16870 = BgL_runz00_14523;
												BgL_recz00_16869:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16871;

														BgL_rz00_16871 =
															PROCEDURE_ENTRY(BgL_fz00_16870) (BgL_fz00_16870,
															BgL_nsz00_16864, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6646z00_27382;

															if (PROCEDUREP(BgL_rz00_16871))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16872;

																	BgL_arg1732z00_16872 =
																		PROCEDURE_ATTR(BgL_rz00_16871);
																	if (STRUCTP(BgL_arg1732z00_16872))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6646z00_27382 =
																				(STRUCT_KEY(BgL_arg1732z00_16872) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6646z00_27382 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6646z00_27382 = ((bool_t) 0);
																}
															if (BgL_test6646z00_27382)
																{
																	obj_t BgL_fz00_27390;

																	BgL_fz00_27390 = BgL_rz00_16871;
																	BgL_fz00_16870 = BgL_fz00_27390;
																	goto BgL_recz00_16869;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16864, ((long) 0),
																		BgL_savedzd2bpzd2_16868);
																	BgL_____rz00_16867 = BgL_rz00_16871;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16866);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16865, BgL_sz00_16856);
											return BgL_____rz00_16867;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5760 */
	obj_t BGl_z62run5760z62zz__evaluate_compz00(obj_t BgL_envz00_14529,
		obj_t BgL_sz00_14534)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14530;
				obj_t BgL_valza2za2_14531;
				BgL_ev_absz00_bglt BgL_i1247z00_14532;
				obj_t BgL_bodyz00_14533;

				BgL_siza7eza7_14530 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14529, (int) (((long) 0))));
				BgL_valza2za2_14531 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14529, (int) (((long) 1))));
				BgL_i1247z00_14532 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14529, (int) (((long) 2))));
				BgL_bodyz00_14533 = PROCEDURE_REF(BgL_envz00_14529, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16873;

					BgL_bpz00_16873 = VECTOR_REF(((obj_t) BgL_sz00_14534), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14534,
						BgL_valza2za2_14531,
						((long) CINT(BgL_bpz00_16873) + BgL_siza7eza7_14530));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16874;
						obj_t BgL_wherez00_16875;
						obj_t BgL_locz00_16876;

						BgL_z12denvz12_16874 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16875 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14532))->
							BgL_wherez00);
						BgL_locz00_16876 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14532))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16874, BgL_wherez00_16875,
								BgL_locz00_16876);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16877;

								BgL_za2za2resza2za2z00_16877 =
									PROCEDURE_ENTRY(BgL_bodyz00_14533) (BgL_bodyz00_14533,
									BgL_sz00_14534, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16874);
								return BgL_za2za2resza2za2z00_16877;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3897> */
	obj_t BGl_z62zc3z04anonymousza33897ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14535, obj_t BgL_sz00_14542)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14536;
				obj_t BgL_iboxesz00_14537;
				long BgL_siza7eza7_14538;
				BgL_ev_absz00_bglt BgL_i1247z00_14539;
				obj_t BgL_bodyz00_14540;
				long BgL_siza7ezd2framez75_14541;

				BgL_ifreesz00_14536 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14535, (int) (((long) 0))));
				BgL_iboxesz00_14537 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14535, (int) (((long) 1))));
				BgL_siza7eza7_14538 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14535, (int) (((long) 2))));
				BgL_i1247z00_14539 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14535, (int) (((long) 3))));
				BgL_bodyz00_14540 = PROCEDURE_REF(BgL_envz00_14535, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14541 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14535, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16878;

					BgL_bpz00_16878 = VECTOR_REF(((obj_t) BgL_sz00_14542), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16879;

						BgL_valza2za2_16879 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14542,
							BgL_bpz00_16878, BgL_ifreesz00_14536);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16880;

							BgL_runz00_16880 =
								MAKE_FX_PROCEDURE(BGl_z62run5762z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16880,
								(int) (((long) 0)), BgL_iboxesz00_14537);
							PROCEDURE_SET(BgL_runz00_16880,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14538));
							PROCEDURE_SET(BgL_runz00_16880,
								(int) (((long) 2)), BgL_valza2za2_16879);
							PROCEDURE_SET(BgL_runz00_16880,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14539));
							PROCEDURE_SET(BgL_runz00_16880,
								(int) (((long) 4)), BgL_bodyz00_14540);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16881;

								BgL_mainz00_16881 =
									MAKE_FX_PROCEDURE(BGl_z62main5761z62zz__evaluate_compz00,
									(int) (((long) 4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16881,
									(int) (((long) 0)), BgL_iboxesz00_14537);
								PROCEDURE_SET(BgL_mainz00_16881,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14538));
								PROCEDURE_SET(BgL_mainz00_16881,
									(int) (((long) 2)), BgL_valza2za2_16879);
								PROCEDURE_SET(BgL_mainz00_16881,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14539));
								PROCEDURE_SET(BgL_mainz00_16881,
									(int) (((long) 4)), BgL_bodyz00_14540);
								PROCEDURE_SET(BgL_mainz00_16881,
									(int) (((long) 5)), BgL_runz00_16880);
								PROCEDURE_SET(BgL_mainz00_16881,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14541));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16882;

									BgL_objz00_16882 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16880, BgL_objz00_16882);
									BgL_objz00_16882;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3898z00_16883;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3899z00_16884;

										BgL_arg3899z00_16884 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14539))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16885;

											BgL_newz00_16885 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27478;

												BgL_tmpz00_27478 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16885, BgL_tmpz00_27478,
													BgL_arg3899z00_16884);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27483;
												int BgL_tmpz00_27481;

												BgL_auxz00_27483 = BINT(BgL_siza7ezd2framez75_14541);
												BgL_tmpz00_27481 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16885, BgL_tmpz00_27481,
													BgL_auxz00_27483);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27486;

												BgL_tmpz00_27486 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16885, BgL_tmpz00_27486,
													BgL_runz00_16880);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27491;
												int BgL_tmpz00_27489;

												BgL_auxz00_27491 = BINT(((long) 4));
												BgL_tmpz00_27489 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16885, BgL_tmpz00_27489,
													BgL_auxz00_27491);
											}
											BgL_arg3898z00_16883 = BgL_newz00_16885;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16881, BgL_arg3898z00_16883);
									BgL_arg3898z00_16883;
								}
								return BgL_mainz00_16881;
							}
						}
					}
				}
			}
		}

	}



/* &main5761 */
	obj_t BGl_z62main5761z62zz__evaluate_compz00(obj_t BgL_envz00_14543,
		obj_t BgL_az00_14551, obj_t BgL_bz00_14552, obj_t BgL_cz00_14553,
		obj_t BgL_dz00_14554)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14549;
				long BgL_siza7ezd2framez75_14550;

				BgL_runz00_14549 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14543, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14550 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14543, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16886;

					BgL_sz00_16886 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16887;

						BgL_bpz00_16887 = VECTOR_REF(((obj_t) BgL_sz00_16886), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16887) + BgL_siza7ezd2framez75_14550) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16886))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3902z00_16888;

									BgL_arg3902z00_16888 =
										((long) CINT(BgL_bpz00_16887) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16886), BgL_arg3902z00_16888,
										BgL_az00_14551);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3903z00_16889;

									BgL_arg3903z00_16889 =
										((long) CINT(BgL_bpz00_16887) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16886), BgL_arg3903z00_16889,
										BgL_bz00_14552);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3904z00_16890;

									BgL_arg3904z00_16890 =
										((long) CINT(BgL_bpz00_16887) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16886), BgL_arg3904z00_16890,
										BgL_cz00_14553);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3905z00_16891;

									BgL_arg3905z00_16891 =
										((long) CINT(BgL_bpz00_16887) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16886), BgL_arg3905z00_16891,
										BgL_dz00_14554);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16892;

									BgL_ez00_16892 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16892,
										BgL_bpz00_16887);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16893;

										BgL_accz00_16893 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14549, BgL_sz00_16886, BgL_bpz00_16887);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16892);
										VECTOR_SET(
											((obj_t) BgL_sz00_16886), ((long) 0), BgL_bpz00_16887);
										return BgL_accz00_16893;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16894;

								BgL_nsz00_16894 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16894, ((long) 1), BgL_sz00_16886);
								VECTOR_SET(BgL_nsz00_16894, ((long) 2), BgL_az00_14551);
								VECTOR_SET(BgL_nsz00_16894, ((long) 3), BgL_bz00_14552);
								VECTOR_SET(BgL_nsz00_16894, ((long) 4), BgL_cz00_14553);
								VECTOR_SET(BgL_nsz00_16894, ((long) 5), BgL_dz00_14554);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16895;

									BgL_z12denvz12_16895 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16895, BgL_nsz00_16894);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16896;

										BgL_ez00_16896 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16896,
											BgL_sz00_16886);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16897;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16898;

												BgL_savedzd2bpzd2_16898 =
													VECTOR_REF(BgL_nsz00_16894, ((long) 0));
												VECTOR_SET(BgL_nsz00_16894, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16900;

													BgL_fz00_16900 = BgL_runz00_14549;
												BgL_recz00_16899:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16901;

														BgL_rz00_16901 =
															PROCEDURE_ENTRY(BgL_fz00_16900) (BgL_fz00_16900,
															BgL_nsz00_16894, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6650z00_27549;

															if (PROCEDUREP(BgL_rz00_16901))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16902;

																	BgL_arg1732z00_16902 =
																		PROCEDURE_ATTR(BgL_rz00_16901);
																	if (STRUCTP(BgL_arg1732z00_16902))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6650z00_27549 =
																				(STRUCT_KEY(BgL_arg1732z00_16902) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6650z00_27549 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6650z00_27549 = ((bool_t) 0);
																}
															if (BgL_test6650z00_27549)
																{
																	obj_t BgL_fz00_27557;

																	BgL_fz00_27557 = BgL_rz00_16901;
																	BgL_fz00_16900 = BgL_fz00_27557;
																	goto BgL_recz00_16899;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16894, ((long) 0),
																		BgL_savedzd2bpzd2_16898);
																	BgL_____rz00_16897 = BgL_rz00_16901;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16896);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16895, BgL_sz00_16886);
											return BgL_____rz00_16897;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5762 */
	obj_t BGl_z62run5762z62zz__evaluate_compz00(obj_t BgL_envz00_14555,
		obj_t BgL_sz00_14561)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14556;
				long BgL_siza7eza7_14557;
				obj_t BgL_valza2za2_14558;
				BgL_ev_absz00_bglt BgL_i1247z00_14559;
				obj_t BgL_bodyz00_14560;

				BgL_iboxesz00_14556 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14555, (int) (((long) 0))));
				BgL_siza7eza7_14557 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14555, (int) (((long) 1))));
				BgL_valza2za2_14558 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14555, (int) (((long) 2))));
				BgL_i1247z00_14559 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14555, (int) (((long) 3))));
				BgL_bodyz00_14560 = PROCEDURE_REF(BgL_envz00_14555, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16903;

					BgL_bpz00_16903 = VECTOR_REF(((obj_t) BgL_sz00_14561), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14561,
						BgL_iboxesz00_14556, BgL_bpz00_16903);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14561,
						BgL_valza2za2_14558,
						((long) CINT(BgL_bpz00_16903) + BgL_siza7eza7_14557));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16904;
						obj_t BgL_wherez00_16905;
						obj_t BgL_locz00_16906;

						BgL_z12denvz12_16904 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16905 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14559))->
							BgL_wherez00);
						BgL_locz00_16906 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14559))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16904, BgL_wherez00_16905,
								BgL_locz00_16906);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16907;

								BgL_za2za2resza2za2z00_16907 =
									PROCEDURE_ENTRY(BgL_bodyz00_14560) (BgL_bodyz00_14560,
									BgL_sz00_14561, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16904);
								return BgL_za2za2resza2za2z00_16907;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3812> */
	obj_t BGl_z62zc3z04anonymousza33812ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14562, obj_t BgL_sz00_14566)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14563;
				obj_t BgL_bodyz00_14564;
				long BgL_siza7ezd2framez75_14565;

				BgL_i1247z00_14563 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14562, (int) (((long) 0))));
				BgL_bodyz00_14564 = PROCEDURE_REF(BgL_envz00_14562, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14565 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14562, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16908;

					BgL_bpz00_16908 = VECTOR_REF(((obj_t) BgL_sz00_14566), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16909;

							BgL_runz00_16909 =
								MAKE_FX_PROCEDURE(BGl_z62run5764z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_16909,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14563));
							PROCEDURE_SET(BgL_runz00_16909,
								(int) (((long) 1)), BgL_bodyz00_14564);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16910;

								BgL_mainz00_16910 =
									MAKE_VA_PROCEDURE(BGl_z62main5763z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_16910,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14563));
								PROCEDURE_SET(BgL_mainz00_16910,
									(int) (((long) 1)), BgL_bodyz00_14564);
								PROCEDURE_SET(BgL_mainz00_16910,
									(int) (((long) 2)), BgL_runz00_16909);
								PROCEDURE_SET(BgL_mainz00_16910,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14565));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16911;

									BgL_objz00_16911 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16909, BgL_objz00_16911);
									BgL_objz00_16911;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3813z00_16912;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3814z00_16913;

										BgL_arg3814z00_16913 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14563))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16914;

											BgL_newz00_16914 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27625;

												BgL_tmpz00_27625 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16914, BgL_tmpz00_27625,
													BgL_arg3814z00_16913);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27630;
												int BgL_tmpz00_27628;

												BgL_auxz00_27630 = BINT(BgL_siza7ezd2framez75_14565);
												BgL_tmpz00_27628 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16914, BgL_tmpz00_27628,
													BgL_auxz00_27630);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27633;

												BgL_tmpz00_27633 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16914, BgL_tmpz00_27633,
													BgL_runz00_16909);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27638;
												int BgL_tmpz00_27636;

												BgL_auxz00_27638 = BINT(((long) -4));
												BgL_tmpz00_27636 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16914, BgL_tmpz00_27636,
													BgL_auxz00_27638);
											}
											BgL_arg3813z00_16912 = BgL_newz00_16914;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16910, BgL_arg3813z00_16912);
									BgL_arg3813z00_16912;
								}
								return BgL_mainz00_16910;
							}
						}
					}
				}
			}
		}

	}



/* &main5763 */
	obj_t BGl_z62main5763z62zz__evaluate_compz00(obj_t BgL_envz00_14567,
		obj_t BgL_bz00_14572, obj_t BgL_cz00_14573, obj_t BgL_dz00_14574,
		obj_t BgL_lastz00_14575)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14570;
				long BgL_siza7ezd2framez75_14571;

				BgL_runz00_14570 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14567, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14571 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14567, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16915;

					BgL_sz00_16915 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16916;

						BgL_bpz00_16916 = VECTOR_REF(((obj_t) BgL_sz00_16915), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16916) + BgL_siza7ezd2framez75_14571) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16915))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3817z00_16917;

									BgL_arg3817z00_16917 =
										((long) CINT(BgL_bpz00_16916) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16915), BgL_arg3817z00_16917,
										BgL_bz00_14572);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3818z00_16918;

									BgL_arg3818z00_16918 =
										((long) CINT(BgL_bpz00_16916) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16915), BgL_arg3818z00_16918,
										BgL_cz00_14573);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3819z00_16919;

									BgL_arg3819z00_16919 =
										((long) CINT(BgL_bpz00_16916) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16915), BgL_arg3819z00_16919,
										BgL_dz00_14574);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3820z00_16920;

									BgL_arg3820z00_16920 =
										((long) CINT(BgL_bpz00_16916) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16915), BgL_arg3820z00_16920,
										BgL_lastz00_14575);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16921;

									BgL_ez00_16921 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16921,
										BgL_bpz00_16916);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16922;

										BgL_accz00_16922 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14570, BgL_sz00_16915, BgL_bpz00_16916);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16921);
										VECTOR_SET(
											((obj_t) BgL_sz00_16915), ((long) 0), BgL_bpz00_16916);
										return BgL_accz00_16922;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16923;

								BgL_nsz00_16923 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16923, ((long) 1), BgL_sz00_16915);
								VECTOR_SET(BgL_nsz00_16923, ((long) 2), BgL_bz00_14572);
								VECTOR_SET(BgL_nsz00_16923, ((long) 3), BgL_cz00_14573);
								VECTOR_SET(BgL_nsz00_16923, ((long) 4), BgL_dz00_14574);
								VECTOR_SET(BgL_nsz00_16923, ((long) 5), BgL_lastz00_14575);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16924;

									BgL_z12denvz12_16924 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16924, BgL_nsz00_16923);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16925;

										BgL_ez00_16925 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16925,
											BgL_sz00_16915);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16926;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16927;

												BgL_savedzd2bpzd2_16927 =
													VECTOR_REF(BgL_nsz00_16923, ((long) 0));
												VECTOR_SET(BgL_nsz00_16923, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16929;

													BgL_fz00_16929 = BgL_runz00_14570;
												BgL_recz00_16928:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16930;

														BgL_rz00_16930 =
															PROCEDURE_ENTRY(BgL_fz00_16929) (BgL_fz00_16929,
															BgL_nsz00_16923, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6654z00_27696;

															if (PROCEDUREP(BgL_rz00_16930))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16931;

																	BgL_arg1732z00_16931 =
																		PROCEDURE_ATTR(BgL_rz00_16930);
																	if (STRUCTP(BgL_arg1732z00_16931))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6654z00_27696 =
																				(STRUCT_KEY(BgL_arg1732z00_16931) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6654z00_27696 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6654z00_27696 = ((bool_t) 0);
																}
															if (BgL_test6654z00_27696)
																{
																	obj_t BgL_fz00_27704;

																	BgL_fz00_27704 = BgL_rz00_16930;
																	BgL_fz00_16929 = BgL_fz00_27704;
																	goto BgL_recz00_16928;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16923, ((long) 0),
																		BgL_savedzd2bpzd2_16927);
																	BgL_____rz00_16926 = BgL_rz00_16930;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16925);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16924, BgL_sz00_16915);
											return BgL_____rz00_16926;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5764 */
	obj_t BGl_z62run5764z62zz__evaluate_compz00(obj_t BgL_envz00_14576,
		obj_t BgL_sz00_14579)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14577;
				obj_t BgL_bodyz00_14578;

				BgL_i1247z00_14577 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14576, (int) (((long) 0))));
				BgL_bodyz00_14578 = PROCEDURE_REF(BgL_envz00_14576, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16932;

					BgL_bpz00_16932 = VECTOR_REF(((obj_t) BgL_sz00_14579), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16933;
						obj_t BgL_wherez00_16934;
						obj_t BgL_locz00_16935;

						BgL_z12denvz12_16933 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16934 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14577))->
							BgL_wherez00);
						BgL_locz00_16935 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14577))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16933, BgL_wherez00_16934,
								BgL_locz00_16935);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16936;

								BgL_za2za2resza2za2z00_16936 =
									PROCEDURE_ENTRY(BgL_bodyz00_14578) (BgL_bodyz00_14578,
									BgL_sz00_14579, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16933);
								return BgL_za2za2resza2za2z00_16936;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3822> */
	obj_t BGl_z62zc3z04anonymousza33822ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14580, obj_t BgL_sz00_14585)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14581;
				BgL_ev_absz00_bglt BgL_i1247z00_14582;
				obj_t BgL_bodyz00_14583;
				long BgL_siza7ezd2framez75_14584;

				BgL_iboxesz00_14581 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14580, (int) (((long) 0))));
				BgL_i1247z00_14582 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14580, (int) (((long) 1))));
				BgL_bodyz00_14583 = PROCEDURE_REF(BgL_envz00_14580, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14584 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14580, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16937;

					BgL_bpz00_16937 = VECTOR_REF(((obj_t) BgL_sz00_14585), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16938;

							BgL_runz00_16938 =
								MAKE_FX_PROCEDURE(BGl_z62run5766z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_16938,
								(int) (((long) 0)), BgL_iboxesz00_14581);
							PROCEDURE_SET(BgL_runz00_16938,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14582));
							PROCEDURE_SET(BgL_runz00_16938,
								(int) (((long) 2)), BgL_bodyz00_14583);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16939;

								BgL_mainz00_16939 =
									MAKE_VA_PROCEDURE(BGl_z62main5765z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_16939,
									(int) (((long) 0)), BgL_iboxesz00_14581);
								PROCEDURE_SET(BgL_mainz00_16939,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14582));
								PROCEDURE_SET(BgL_mainz00_16939,
									(int) (((long) 2)), BgL_bodyz00_14583);
								PROCEDURE_SET(BgL_mainz00_16939,
									(int) (((long) 3)), BgL_runz00_16938);
								PROCEDURE_SET(BgL_mainz00_16939,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14584));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16940;

									BgL_objz00_16940 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16938, BgL_objz00_16940);
									BgL_objz00_16940;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3823z00_16941;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3824z00_16942;

										BgL_arg3824z00_16942 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14582))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16943;

											BgL_newz00_16943 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27766;

												BgL_tmpz00_27766 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16943, BgL_tmpz00_27766,
													BgL_arg3824z00_16942);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27771;
												int BgL_tmpz00_27769;

												BgL_auxz00_27771 = BINT(BgL_siza7ezd2framez75_14584);
												BgL_tmpz00_27769 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16943, BgL_tmpz00_27769,
													BgL_auxz00_27771);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27774;

												BgL_tmpz00_27774 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16943, BgL_tmpz00_27774,
													BgL_runz00_16938);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27779;
												int BgL_tmpz00_27777;

												BgL_auxz00_27779 = BINT(((long) -4));
												BgL_tmpz00_27777 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16943, BgL_tmpz00_27777,
													BgL_auxz00_27779);
											}
											BgL_arg3823z00_16941 = BgL_newz00_16943;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16939, BgL_arg3823z00_16941);
									BgL_arg3823z00_16941;
								}
								return BgL_mainz00_16939;
							}
						}
					}
				}
			}
		}

	}



/* &main5765 */
	obj_t BGl_z62main5765z62zz__evaluate_compz00(obj_t BgL_envz00_14586,
		obj_t BgL_bz00_14592, obj_t BgL_cz00_14593, obj_t BgL_dz00_14594,
		obj_t BgL_lastz00_14595)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14590;
				long BgL_siza7ezd2framez75_14591;

				BgL_runz00_14590 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14586, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14591 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14586, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16944;

					BgL_sz00_16944 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16945;

						BgL_bpz00_16945 = VECTOR_REF(((obj_t) BgL_sz00_16944), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16945) + BgL_siza7ezd2framez75_14591) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16944))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3827z00_16946;

									BgL_arg3827z00_16946 =
										((long) CINT(BgL_bpz00_16945) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16944), BgL_arg3827z00_16946,
										BgL_bz00_14592);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3828z00_16947;

									BgL_arg3828z00_16947 =
										((long) CINT(BgL_bpz00_16945) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16944), BgL_arg3828z00_16947,
										BgL_cz00_14593);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3829z00_16948;

									BgL_arg3829z00_16948 =
										((long) CINT(BgL_bpz00_16945) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16944), BgL_arg3829z00_16948,
										BgL_dz00_14594);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3830z00_16949;

									BgL_arg3830z00_16949 =
										((long) CINT(BgL_bpz00_16945) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16944), BgL_arg3830z00_16949,
										BgL_lastz00_14595);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16950;

									BgL_ez00_16950 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16950,
										BgL_bpz00_16945);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16951;

										BgL_accz00_16951 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14590, BgL_sz00_16944, BgL_bpz00_16945);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16950);
										VECTOR_SET(
											((obj_t) BgL_sz00_16944), ((long) 0), BgL_bpz00_16945);
										return BgL_accz00_16951;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16952;

								BgL_nsz00_16952 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16952, ((long) 1), BgL_sz00_16944);
								VECTOR_SET(BgL_nsz00_16952, ((long) 2), BgL_bz00_14592);
								VECTOR_SET(BgL_nsz00_16952, ((long) 3), BgL_cz00_14593);
								VECTOR_SET(BgL_nsz00_16952, ((long) 4), BgL_dz00_14594);
								VECTOR_SET(BgL_nsz00_16952, ((long) 5), BgL_lastz00_14595);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16953;

									BgL_z12denvz12_16953 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16953, BgL_nsz00_16952);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16954;

										BgL_ez00_16954 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16954,
											BgL_sz00_16944);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16955;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16956;

												BgL_savedzd2bpzd2_16956 =
													VECTOR_REF(BgL_nsz00_16952, ((long) 0));
												VECTOR_SET(BgL_nsz00_16952, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16958;

													BgL_fz00_16958 = BgL_runz00_14590;
												BgL_recz00_16957:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16959;

														BgL_rz00_16959 =
															PROCEDURE_ENTRY(BgL_fz00_16958) (BgL_fz00_16958,
															BgL_nsz00_16952, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6658z00_27837;

															if (PROCEDUREP(BgL_rz00_16959))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16960;

																	BgL_arg1732z00_16960 =
																		PROCEDURE_ATTR(BgL_rz00_16959);
																	if (STRUCTP(BgL_arg1732z00_16960))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6658z00_27837 =
																				(STRUCT_KEY(BgL_arg1732z00_16960) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6658z00_27837 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6658z00_27837 = ((bool_t) 0);
																}
															if (BgL_test6658z00_27837)
																{
																	obj_t BgL_fz00_27845;

																	BgL_fz00_27845 = BgL_rz00_16959;
																	BgL_fz00_16958 = BgL_fz00_27845;
																	goto BgL_recz00_16957;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16952, ((long) 0),
																		BgL_savedzd2bpzd2_16956);
																	BgL_____rz00_16955 = BgL_rz00_16959;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16954);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16953, BgL_sz00_16944);
											return BgL_____rz00_16955;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5766 */
	obj_t BGl_z62run5766z62zz__evaluate_compz00(obj_t BgL_envz00_14596,
		obj_t BgL_sz00_14600)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14597;
				BgL_ev_absz00_bglt BgL_i1247z00_14598;
				obj_t BgL_bodyz00_14599;

				BgL_iboxesz00_14597 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14596, (int) (((long) 0))));
				BgL_i1247z00_14598 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14596, (int) (((long) 1))));
				BgL_bodyz00_14599 = PROCEDURE_REF(BgL_envz00_14596, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16961;

					BgL_bpz00_16961 = VECTOR_REF(((obj_t) BgL_sz00_14600), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14600,
						BgL_iboxesz00_14597, BgL_bpz00_16961);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_16962;
						obj_t BgL_wherez00_16963;
						obj_t BgL_locz00_16964;

						BgL_z12denvz12_16962 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16963 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14598))->
							BgL_wherez00);
						BgL_locz00_16964 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14598))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16962, BgL_wherez00_16963,
								BgL_locz00_16964);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_16965;

								BgL_za2za2resza2za2z00_16965 =
									PROCEDURE_ENTRY(BgL_bodyz00_14599) (BgL_bodyz00_14599,
									BgL_sz00_14600, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16962);
								return BgL_za2za2resza2za2z00_16965;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3835> */
	obj_t BGl_z62zc3z04anonymousza33835ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14601, obj_t BgL_sz00_14607)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14602;
				long BgL_siza7eza7_14603;
				BgL_ev_absz00_bglt BgL_i1247z00_14604;
				obj_t BgL_bodyz00_14605;
				long BgL_siza7ezd2framez75_14606;

				BgL_ifreesz00_14602 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14601, (int) (((long) 0))));
				BgL_siza7eza7_14603 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14601, (int) (((long) 1))));
				BgL_i1247z00_14604 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14601, (int) (((long) 2))));
				BgL_bodyz00_14605 = PROCEDURE_REF(BgL_envz00_14601, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14606 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14601, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16966;

					BgL_bpz00_16966 = VECTOR_REF(((obj_t) BgL_sz00_14607), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16967;

						BgL_valza2za2_16967 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14607,
							BgL_bpz00_16966, BgL_ifreesz00_14602);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16968;

							BgL_runz00_16968 =
								MAKE_FX_PROCEDURE(BGl_z62run5768z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_16968,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14603));
							PROCEDURE_SET(BgL_runz00_16968,
								(int) (((long) 1)), BgL_valza2za2_16967);
							PROCEDURE_SET(BgL_runz00_16968,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14604));
							PROCEDURE_SET(BgL_runz00_16968,
								(int) (((long) 3)), BgL_bodyz00_14605);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16969;

								BgL_mainz00_16969 =
									MAKE_VA_PROCEDURE(BGl_z62main5767z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_16969,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14603));
								PROCEDURE_SET(BgL_mainz00_16969,
									(int) (((long) 1)), BgL_valza2za2_16967);
								PROCEDURE_SET(BgL_mainz00_16969,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14604));
								PROCEDURE_SET(BgL_mainz00_16969,
									(int) (((long) 3)), BgL_bodyz00_14605);
								PROCEDURE_SET(BgL_mainz00_16969,
									(int) (((long) 4)), BgL_runz00_16968);
								PROCEDURE_SET(BgL_mainz00_16969,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14606));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_16970;

									BgL_objz00_16970 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16968, BgL_objz00_16970);
									BgL_objz00_16970;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3836z00_16971;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3837z00_16972;

										BgL_arg3837z00_16972 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14604))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_16973;

											BgL_newz00_16973 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27921;

												BgL_tmpz00_27921 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_16973, BgL_tmpz00_27921,
													BgL_arg3837z00_16972);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27926;
												int BgL_tmpz00_27924;

												BgL_auxz00_27926 = BINT(BgL_siza7ezd2framez75_14606);
												BgL_tmpz00_27924 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_16973, BgL_tmpz00_27924,
													BgL_auxz00_27926);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_27929;

												BgL_tmpz00_27929 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_16973, BgL_tmpz00_27929,
													BgL_runz00_16968);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_27934;
												int BgL_tmpz00_27932;

												BgL_auxz00_27934 = BINT(((long) -4));
												BgL_tmpz00_27932 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_16973, BgL_tmpz00_27932,
													BgL_auxz00_27934);
											}
											BgL_arg3836z00_16971 = BgL_newz00_16973;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16969, BgL_arg3836z00_16971);
									BgL_arg3836z00_16971;
								}
								return BgL_mainz00_16969;
							}
						}
					}
				}
			}
		}

	}



/* &main5767 */
	obj_t BGl_z62main5767z62zz__evaluate_compz00(obj_t BgL_envz00_14608,
		obj_t BgL_bz00_14615, obj_t BgL_cz00_14616, obj_t BgL_dz00_14617,
		obj_t BgL_lastz00_14618)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14613;
				long BgL_siza7ezd2framez75_14614;

				BgL_runz00_14613 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14608, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14614 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14608, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_16974;

					BgL_sz00_16974 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_16975;

						BgL_bpz00_16975 = VECTOR_REF(((obj_t) BgL_sz00_16974), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_16975) + BgL_siza7ezd2framez75_14614) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_16974))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3840z00_16976;

									BgL_arg3840z00_16976 =
										((long) CINT(BgL_bpz00_16975) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_16974), BgL_arg3840z00_16976,
										BgL_bz00_14615);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3841z00_16977;

									BgL_arg3841z00_16977 =
										((long) CINT(BgL_bpz00_16975) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_16974), BgL_arg3841z00_16977,
										BgL_cz00_14616);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3842z00_16978;

									BgL_arg3842z00_16978 =
										((long) CINT(BgL_bpz00_16975) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_16974), BgL_arg3842z00_16978,
										BgL_dz00_14617);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3843z00_16979;

									BgL_arg3843z00_16979 =
										((long) CINT(BgL_bpz00_16975) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_16974), BgL_arg3843z00_16979,
										BgL_lastz00_14618);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_16980;

									BgL_ez00_16980 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16980,
										BgL_bpz00_16975);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_16981;

										BgL_accz00_16981 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14613, BgL_sz00_16974, BgL_bpz00_16975);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_16980);
										VECTOR_SET(
											((obj_t) BgL_sz00_16974), ((long) 0), BgL_bpz00_16975);
										return BgL_accz00_16981;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_16982;

								BgL_nsz00_16982 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_16982, ((long) 1), BgL_sz00_16974);
								VECTOR_SET(BgL_nsz00_16982, ((long) 2), BgL_bz00_14615);
								VECTOR_SET(BgL_nsz00_16982, ((long) 3), BgL_cz00_14616);
								VECTOR_SET(BgL_nsz00_16982, ((long) 4), BgL_dz00_14617);
								VECTOR_SET(BgL_nsz00_16982, ((long) 5), BgL_lastz00_14618);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_16983;

									BgL_z12denvz12_16983 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16983, BgL_nsz00_16982);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_16984;

										BgL_ez00_16984 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_16984,
											BgL_sz00_16974);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_16985;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_16986;

												BgL_savedzd2bpzd2_16986 =
													VECTOR_REF(BgL_nsz00_16982, ((long) 0));
												VECTOR_SET(BgL_nsz00_16982, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_16988;

													BgL_fz00_16988 = BgL_runz00_14613;
												BgL_recz00_16987:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_16989;

														BgL_rz00_16989 =
															PROCEDURE_ENTRY(BgL_fz00_16988) (BgL_fz00_16988,
															BgL_nsz00_16982, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6662z00_27992;

															if (PROCEDUREP(BgL_rz00_16989))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_16990;

																	BgL_arg1732z00_16990 =
																		PROCEDURE_ATTR(BgL_rz00_16989);
																	if (STRUCTP(BgL_arg1732z00_16990))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6662z00_27992 =
																				(STRUCT_KEY(BgL_arg1732z00_16990) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6662z00_27992 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6662z00_27992 = ((bool_t) 0);
																}
															if (BgL_test6662z00_27992)
																{
																	obj_t BgL_fz00_28000;

																	BgL_fz00_28000 = BgL_rz00_16989;
																	BgL_fz00_16988 = BgL_fz00_28000;
																	goto BgL_recz00_16987;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_16982, ((long) 0),
																		BgL_savedzd2bpzd2_16986);
																	BgL_____rz00_16985 = BgL_rz00_16989;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_16984);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_16983, BgL_sz00_16974);
											return BgL_____rz00_16985;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5768 */
	obj_t BGl_z62run5768z62zz__evaluate_compz00(obj_t BgL_envz00_14619,
		obj_t BgL_sz00_14624)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14620;
				obj_t BgL_valza2za2_14621;
				BgL_ev_absz00_bglt BgL_i1247z00_14622;
				obj_t BgL_bodyz00_14623;

				BgL_siza7eza7_14620 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14619, (int) (((long) 0))));
				BgL_valza2za2_14621 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14619, (int) (((long) 1))));
				BgL_i1247z00_14622 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14619, (int) (((long) 2))));
				BgL_bodyz00_14623 = PROCEDURE_REF(BgL_envz00_14619, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16991;

					BgL_bpz00_16991 = VECTOR_REF(((obj_t) BgL_sz00_14624), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14624,
						BgL_valza2za2_14621,
						((long) CINT(BgL_bpz00_16991) + BgL_siza7eza7_14620));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_16992;
						obj_t BgL_wherez00_16993;
						obj_t BgL_locz00_16994;

						BgL_z12denvz12_16992 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_16993 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14622))->
							BgL_wherez00);
						BgL_locz00_16994 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14622))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_16992, BgL_wherez00_16993,
								BgL_locz00_16994);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_16995;

								BgL_za2za2resza2za2z00_16995 =
									PROCEDURE_ENTRY(BgL_bodyz00_14623) (BgL_bodyz00_14623,
									BgL_sz00_14624, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_16992);
								return BgL_za2za2resza2za2z00_16995;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3846> */
	obj_t BGl_z62zc3z04anonymousza33846ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14625, obj_t BgL_sz00_14632)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14626;
				obj_t BgL_iboxesz00_14627;
				long BgL_siza7eza7_14628;
				BgL_ev_absz00_bglt BgL_i1247z00_14629;
				obj_t BgL_bodyz00_14630;
				long BgL_siza7ezd2framez75_14631;

				BgL_ifreesz00_14626 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14625, (int) (((long) 0))));
				BgL_iboxesz00_14627 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14625, (int) (((long) 1))));
				BgL_siza7eza7_14628 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14625, (int) (((long) 2))));
				BgL_i1247z00_14629 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14625, (int) (((long) 3))));
				BgL_bodyz00_14630 = PROCEDURE_REF(BgL_envz00_14625, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14631 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14625, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_16996;

					BgL_bpz00_16996 = VECTOR_REF(((obj_t) BgL_sz00_14632), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_16997;

						BgL_valza2za2_16997 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14632,
							BgL_bpz00_16996, BgL_ifreesz00_14626);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_16998;

							BgL_runz00_16998 =
								MAKE_FX_PROCEDURE(BGl_z62run5770z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_16998,
								(int) (((long) 0)), BgL_iboxesz00_14627);
							PROCEDURE_SET(BgL_runz00_16998,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14628));
							PROCEDURE_SET(BgL_runz00_16998,
								(int) (((long) 2)), BgL_valza2za2_16997);
							PROCEDURE_SET(BgL_runz00_16998,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14629));
							PROCEDURE_SET(BgL_runz00_16998,
								(int) (((long) 4)), BgL_bodyz00_14630);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_16999;

								BgL_mainz00_16999 =
									MAKE_VA_PROCEDURE(BGl_z62main5769z62zz__evaluate_compz00,
									(int) (((long) -4)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_16999,
									(int) (((long) 0)), BgL_iboxesz00_14627);
								PROCEDURE_SET(BgL_mainz00_16999,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14628));
								PROCEDURE_SET(BgL_mainz00_16999,
									(int) (((long) 2)), BgL_valza2za2_16997);
								PROCEDURE_SET(BgL_mainz00_16999,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14629));
								PROCEDURE_SET(BgL_mainz00_16999,
									(int) (((long) 4)), BgL_bodyz00_14630);
								PROCEDURE_SET(BgL_mainz00_16999,
									(int) (((long) 5)), BgL_runz00_16998);
								PROCEDURE_SET(BgL_mainz00_16999,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14631));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17000;

									BgL_objz00_17000 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_16998, BgL_objz00_17000);
									BgL_objz00_17000;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3847z00_17001;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3848z00_17002;

										BgL_arg3848z00_17002 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14629))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17003;

											BgL_newz00_17003 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28088;

												BgL_tmpz00_28088 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17003, BgL_tmpz00_28088,
													BgL_arg3848z00_17002);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28093;
												int BgL_tmpz00_28091;

												BgL_auxz00_28093 = BINT(BgL_siza7ezd2framez75_14631);
												BgL_tmpz00_28091 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17003, BgL_tmpz00_28091,
													BgL_auxz00_28093);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28096;

												BgL_tmpz00_28096 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17003, BgL_tmpz00_28096,
													BgL_runz00_16998);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28101;
												int BgL_tmpz00_28099;

												BgL_auxz00_28101 = BINT(((long) -4));
												BgL_tmpz00_28099 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17003, BgL_tmpz00_28099,
													BgL_auxz00_28101);
											}
											BgL_arg3847z00_17001 = BgL_newz00_17003;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_16999, BgL_arg3847z00_17001);
									BgL_arg3847z00_17001;
								}
								return BgL_mainz00_16999;
							}
						}
					}
				}
			}
		}

	}



/* &main5769 */
	obj_t BGl_z62main5769z62zz__evaluate_compz00(obj_t BgL_envz00_14633,
		obj_t BgL_bz00_14641, obj_t BgL_cz00_14642, obj_t BgL_dz00_14643,
		obj_t BgL_lastz00_14644)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14639;
				long BgL_siza7ezd2framez75_14640;

				BgL_runz00_14639 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14633, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14640 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14633, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17004;

					BgL_sz00_17004 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17005;

						BgL_bpz00_17005 = VECTOR_REF(((obj_t) BgL_sz00_17004), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17005) + BgL_siza7ezd2framez75_14640) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17004))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3851z00_17006;

									BgL_arg3851z00_17006 =
										((long) CINT(BgL_bpz00_17005) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17004), BgL_arg3851z00_17006,
										BgL_bz00_14641);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3852z00_17007;

									BgL_arg3852z00_17007 =
										((long) CINT(BgL_bpz00_17005) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17004), BgL_arg3852z00_17007,
										BgL_cz00_14642);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3853z00_17008;

									BgL_arg3853z00_17008 =
										((long) CINT(BgL_bpz00_17005) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17004), BgL_arg3853z00_17008,
										BgL_dz00_14643);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3854z00_17009;

									BgL_arg3854z00_17009 =
										((long) CINT(BgL_bpz00_17005) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17004), BgL_arg3854z00_17009,
										BgL_lastz00_14644);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17010;

									BgL_ez00_17010 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17010,
										BgL_bpz00_17005);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17011;

										BgL_accz00_17011 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14639, BgL_sz00_17004, BgL_bpz00_17005);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17010);
										VECTOR_SET(
											((obj_t) BgL_sz00_17004), ((long) 0), BgL_bpz00_17005);
										return BgL_accz00_17011;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17012;

								BgL_nsz00_17012 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17012, ((long) 1), BgL_sz00_17004);
								VECTOR_SET(BgL_nsz00_17012, ((long) 2), BgL_bz00_14641);
								VECTOR_SET(BgL_nsz00_17012, ((long) 3), BgL_cz00_14642);
								VECTOR_SET(BgL_nsz00_17012, ((long) 4), BgL_dz00_14643);
								VECTOR_SET(BgL_nsz00_17012, ((long) 5), BgL_lastz00_14644);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17013;

									BgL_z12denvz12_17013 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17013, BgL_nsz00_17012);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17014;

										BgL_ez00_17014 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17014,
											BgL_sz00_17004);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17015;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17016;

												BgL_savedzd2bpzd2_17016 =
													VECTOR_REF(BgL_nsz00_17012, ((long) 0));
												VECTOR_SET(BgL_nsz00_17012, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17018;

													BgL_fz00_17018 = BgL_runz00_14639;
												BgL_recz00_17017:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17019;

														BgL_rz00_17019 =
															PROCEDURE_ENTRY(BgL_fz00_17018) (BgL_fz00_17018,
															BgL_nsz00_17012, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6666z00_28159;

															if (PROCEDUREP(BgL_rz00_17019))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17020;

																	BgL_arg1732z00_17020 =
																		PROCEDURE_ATTR(BgL_rz00_17019);
																	if (STRUCTP(BgL_arg1732z00_17020))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6666z00_28159 =
																				(STRUCT_KEY(BgL_arg1732z00_17020) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6666z00_28159 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6666z00_28159 = ((bool_t) 0);
																}
															if (BgL_test6666z00_28159)
																{
																	obj_t BgL_fz00_28167;

																	BgL_fz00_28167 = BgL_rz00_17019;
																	BgL_fz00_17018 = BgL_fz00_28167;
																	goto BgL_recz00_17017;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17012, ((long) 0),
																		BgL_savedzd2bpzd2_17016);
																	BgL_____rz00_17015 = BgL_rz00_17019;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17014);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17013, BgL_sz00_17004);
											return BgL_____rz00_17015;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5770 */
	obj_t BGl_z62run5770z62zz__evaluate_compz00(obj_t BgL_envz00_14645,
		obj_t BgL_sz00_14651)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14646;
				long BgL_siza7eza7_14647;
				obj_t BgL_valza2za2_14648;
				BgL_ev_absz00_bglt BgL_i1247z00_14649;
				obj_t BgL_bodyz00_14650;

				BgL_iboxesz00_14646 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14645, (int) (((long) 0))));
				BgL_siza7eza7_14647 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14645, (int) (((long) 1))));
				BgL_valza2za2_14648 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14645, (int) (((long) 2))));
				BgL_i1247z00_14649 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14645, (int) (((long) 3))));
				BgL_bodyz00_14650 = PROCEDURE_REF(BgL_envz00_14645, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17021;

					BgL_bpz00_17021 = VECTOR_REF(((obj_t) BgL_sz00_14651), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14651,
						BgL_iboxesz00_14646, BgL_bpz00_17021);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14651,
						BgL_valza2za2_14648,
						((long) CINT(BgL_bpz00_17021) + BgL_siza7eza7_14647));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17022;
						obj_t BgL_wherez00_17023;
						obj_t BgL_locz00_17024;

						BgL_z12denvz12_17022 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17023 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14649))->
							BgL_wherez00);
						BgL_locz00_17024 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14649))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17022, BgL_wherez00_17023,
								BgL_locz00_17024);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17025;

								BgL_za2za2resza2za2z00_17025 =
									PROCEDURE_ENTRY(BgL_bodyz00_14650) (BgL_bodyz00_14650,
									BgL_sz00_14651, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17022);
								return BgL_za2za2resza2za2z00_17025;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3765> */
	obj_t BGl_z62zc3z04anonymousza33765ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14652, obj_t BgL_sz00_14656)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14653;
				obj_t BgL_bodyz00_14654;
				long BgL_siza7ezd2framez75_14655;

				BgL_i1247z00_14653 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14652, (int) (((long) 0))));
				BgL_bodyz00_14654 = PROCEDURE_REF(BgL_envz00_14652, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14655 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14652, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17026;

					BgL_bpz00_17026 = VECTOR_REF(((obj_t) BgL_sz00_14656), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17027;

							BgL_runz00_17027 =
								MAKE_FX_PROCEDURE(BGl_z62run5772z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17027,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14653));
							PROCEDURE_SET(BgL_runz00_17027,
								(int) (((long) 1)), BgL_bodyz00_14654);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17028;

								BgL_mainz00_17028 =
									MAKE_FX_PROCEDURE(BGl_z62main5771z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14653));
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 1)), BgL_bodyz00_14654);
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 2)), BgL_runz00_17027);
								PROCEDURE_SET(BgL_mainz00_17028,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14655));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17029;

									BgL_objz00_17029 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17027, BgL_objz00_17029);
									BgL_objz00_17029;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3766z00_17030;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3767z00_17031;

										BgL_arg3767z00_17031 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14653))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17032;

											BgL_newz00_17032 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28235;

												BgL_tmpz00_28235 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17032, BgL_tmpz00_28235,
													BgL_arg3767z00_17031);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28240;
												int BgL_tmpz00_28238;

												BgL_auxz00_28240 = BINT(BgL_siza7ezd2framez75_14655);
												BgL_tmpz00_28238 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17032, BgL_tmpz00_28238,
													BgL_auxz00_28240);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28243;

												BgL_tmpz00_28243 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17032, BgL_tmpz00_28243,
													BgL_runz00_17027);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28248;
												int BgL_tmpz00_28246;

												BgL_auxz00_28248 = BINT(((long) 3));
												BgL_tmpz00_28246 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17032, BgL_tmpz00_28246,
													BgL_auxz00_28248);
											}
											BgL_arg3766z00_17030 = BgL_newz00_17032;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17028, BgL_arg3766z00_17030);
									BgL_arg3766z00_17030;
								}
								return BgL_mainz00_17028;
							}
						}
					}
				}
			}
		}

	}



/* &main5771 */
	obj_t BGl_z62main5771z62zz__evaluate_compz00(obj_t BgL_envz00_14657,
		obj_t BgL_bz00_14662, obj_t BgL_cz00_14663, obj_t BgL_dz00_14664)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14660;
				long BgL_siza7ezd2framez75_14661;

				BgL_runz00_14660 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14657, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14661 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14657, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17033;

					BgL_sz00_17033 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17034;

						BgL_bpz00_17034 = VECTOR_REF(((obj_t) BgL_sz00_17033), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17034) + BgL_siza7ezd2framez75_14661) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17033))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3770z00_17035;

									BgL_arg3770z00_17035 =
										((long) CINT(BgL_bpz00_17034) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17033), BgL_arg3770z00_17035,
										BgL_bz00_14662);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3771z00_17036;

									BgL_arg3771z00_17036 =
										((long) CINT(BgL_bpz00_17034) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17033), BgL_arg3771z00_17036,
										BgL_cz00_14663);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3772z00_17037;

									BgL_arg3772z00_17037 =
										((long) CINT(BgL_bpz00_17034) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17033), BgL_arg3772z00_17037,
										BgL_dz00_14664);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17038;

									BgL_ez00_17038 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17038,
										BgL_bpz00_17034);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17039;

										BgL_accz00_17039 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14660, BgL_sz00_17033, BgL_bpz00_17034);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17038);
										VECTOR_SET(
											((obj_t) BgL_sz00_17033), ((long) 0), BgL_bpz00_17034);
										return BgL_accz00_17039;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17040;

								BgL_nsz00_17040 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17040, ((long) 1), BgL_sz00_17033);
								VECTOR_SET(BgL_nsz00_17040, ((long) 2), BgL_bz00_14662);
								VECTOR_SET(BgL_nsz00_17040, ((long) 3), BgL_cz00_14663);
								VECTOR_SET(BgL_nsz00_17040, ((long) 4), BgL_dz00_14664);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17041;

									BgL_z12denvz12_17041 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17041, BgL_nsz00_17040);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17042;

										BgL_ez00_17042 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17042,
											BgL_sz00_17033);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17043;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17044;

												BgL_savedzd2bpzd2_17044 =
													VECTOR_REF(BgL_nsz00_17040, ((long) 0));
												VECTOR_SET(BgL_nsz00_17040, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17046;

													BgL_fz00_17046 = BgL_runz00_14660;
												BgL_recz00_17045:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17047;

														BgL_rz00_17047 =
															PROCEDURE_ENTRY(BgL_fz00_17046) (BgL_fz00_17046,
															BgL_nsz00_17040, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6670z00_28301;

															if (PROCEDUREP(BgL_rz00_17047))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17048;

																	BgL_arg1732z00_17048 =
																		PROCEDURE_ATTR(BgL_rz00_17047);
																	if (STRUCTP(BgL_arg1732z00_17048))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6670z00_28301 =
																				(STRUCT_KEY(BgL_arg1732z00_17048) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6670z00_28301 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6670z00_28301 = ((bool_t) 0);
																}
															if (BgL_test6670z00_28301)
																{
																	obj_t BgL_fz00_28309;

																	BgL_fz00_28309 = BgL_rz00_17047;
																	BgL_fz00_17046 = BgL_fz00_28309;
																	goto BgL_recz00_17045;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17040, ((long) 0),
																		BgL_savedzd2bpzd2_17044);
																	BgL_____rz00_17043 = BgL_rz00_17047;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17042);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17041, BgL_sz00_17033);
											return BgL_____rz00_17043;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5772 */
	obj_t BGl_z62run5772z62zz__evaluate_compz00(obj_t BgL_envz00_14665,
		obj_t BgL_sz00_14668)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14666;
				obj_t BgL_bodyz00_14667;

				BgL_i1247z00_14666 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14665, (int) (((long) 0))));
				BgL_bodyz00_14667 = PROCEDURE_REF(BgL_envz00_14665, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17049;

					BgL_bpz00_17049 = VECTOR_REF(((obj_t) BgL_sz00_14668), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17050;
						obj_t BgL_wherez00_17051;
						obj_t BgL_locz00_17052;

						BgL_z12denvz12_17050 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17051 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14666))->
							BgL_wherez00);
						BgL_locz00_17052 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14666))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17050, BgL_wherez00_17051,
								BgL_locz00_17052);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17053;

								BgL_za2za2resza2za2z00_17053 =
									PROCEDURE_ENTRY(BgL_bodyz00_14667) (BgL_bodyz00_14667,
									BgL_sz00_14668, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17050);
								return BgL_za2za2resza2za2z00_17053;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3774> */
	obj_t BGl_z62zc3z04anonymousza33774ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14669, obj_t BgL_sz00_14674)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14670;
				BgL_ev_absz00_bglt BgL_i1247z00_14671;
				obj_t BgL_bodyz00_14672;
				long BgL_siza7ezd2framez75_14673;

				BgL_iboxesz00_14670 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14669, (int) (((long) 0))));
				BgL_i1247z00_14671 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14669, (int) (((long) 1))));
				BgL_bodyz00_14672 = PROCEDURE_REF(BgL_envz00_14669, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14673 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14669, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17054;

					BgL_bpz00_17054 = VECTOR_REF(((obj_t) BgL_sz00_14674), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17055;

							BgL_runz00_17055 =
								MAKE_FX_PROCEDURE(BGl_z62run5774z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17055,
								(int) (((long) 0)), BgL_iboxesz00_14670);
							PROCEDURE_SET(BgL_runz00_17055,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14671));
							PROCEDURE_SET(BgL_runz00_17055,
								(int) (((long) 2)), BgL_bodyz00_14672);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17056;

								BgL_mainz00_17056 =
									MAKE_FX_PROCEDURE(BGl_z62main5773z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17056,
									(int) (((long) 0)), BgL_iboxesz00_14670);
								PROCEDURE_SET(BgL_mainz00_17056,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14671));
								PROCEDURE_SET(BgL_mainz00_17056,
									(int) (((long) 2)), BgL_bodyz00_14672);
								PROCEDURE_SET(BgL_mainz00_17056,
									(int) (((long) 3)), BgL_runz00_17055);
								PROCEDURE_SET(BgL_mainz00_17056,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14673));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17057;

									BgL_objz00_17057 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17055, BgL_objz00_17057);
									BgL_objz00_17057;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3775z00_17058;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3776z00_17059;

										BgL_arg3776z00_17059 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14671))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17060;

											BgL_newz00_17060 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28371;

												BgL_tmpz00_28371 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17060, BgL_tmpz00_28371,
													BgL_arg3776z00_17059);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28376;
												int BgL_tmpz00_28374;

												BgL_auxz00_28376 = BINT(BgL_siza7ezd2framez75_14673);
												BgL_tmpz00_28374 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17060, BgL_tmpz00_28374,
													BgL_auxz00_28376);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28379;

												BgL_tmpz00_28379 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17060, BgL_tmpz00_28379,
													BgL_runz00_17055);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28384;
												int BgL_tmpz00_28382;

												BgL_auxz00_28384 = BINT(((long) 3));
												BgL_tmpz00_28382 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17060, BgL_tmpz00_28382,
													BgL_auxz00_28384);
											}
											BgL_arg3775z00_17058 = BgL_newz00_17060;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17056, BgL_arg3775z00_17058);
									BgL_arg3775z00_17058;
								}
								return BgL_mainz00_17056;
							}
						}
					}
				}
			}
		}

	}



/* &main5773 */
	obj_t BGl_z62main5773z62zz__evaluate_compz00(obj_t BgL_envz00_14675,
		obj_t BgL_bz00_14681, obj_t BgL_cz00_14682, obj_t BgL_dz00_14683)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14679;
				long BgL_siza7ezd2framez75_14680;

				BgL_runz00_14679 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14675, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14680 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14675, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17061;

					BgL_sz00_17061 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17062;

						BgL_bpz00_17062 = VECTOR_REF(((obj_t) BgL_sz00_17061), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17062) + BgL_siza7ezd2framez75_14680) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17061))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3779z00_17063;

									BgL_arg3779z00_17063 =
										((long) CINT(BgL_bpz00_17062) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17061), BgL_arg3779z00_17063,
										BgL_bz00_14681);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3780z00_17064;

									BgL_arg3780z00_17064 =
										((long) CINT(BgL_bpz00_17062) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17061), BgL_arg3780z00_17064,
										BgL_cz00_14682);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3781z00_17065;

									BgL_arg3781z00_17065 =
										((long) CINT(BgL_bpz00_17062) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17061), BgL_arg3781z00_17065,
										BgL_dz00_14683);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17066;

									BgL_ez00_17066 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17066,
										BgL_bpz00_17062);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17067;

										BgL_accz00_17067 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14679, BgL_sz00_17061, BgL_bpz00_17062);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17066);
										VECTOR_SET(
											((obj_t) BgL_sz00_17061), ((long) 0), BgL_bpz00_17062);
										return BgL_accz00_17067;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17068;

								BgL_nsz00_17068 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17068, ((long) 1), BgL_sz00_17061);
								VECTOR_SET(BgL_nsz00_17068, ((long) 2), BgL_bz00_14681);
								VECTOR_SET(BgL_nsz00_17068, ((long) 3), BgL_cz00_14682);
								VECTOR_SET(BgL_nsz00_17068, ((long) 4), BgL_dz00_14683);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17069;

									BgL_z12denvz12_17069 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17069, BgL_nsz00_17068);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17070;

										BgL_ez00_17070 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17070,
											BgL_sz00_17061);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17071;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17072;

												BgL_savedzd2bpzd2_17072 =
													VECTOR_REF(BgL_nsz00_17068, ((long) 0));
												VECTOR_SET(BgL_nsz00_17068, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17074;

													BgL_fz00_17074 = BgL_runz00_14679;
												BgL_recz00_17073:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17075;

														BgL_rz00_17075 =
															PROCEDURE_ENTRY(BgL_fz00_17074) (BgL_fz00_17074,
															BgL_nsz00_17068, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6674z00_28437;

															if (PROCEDUREP(BgL_rz00_17075))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17076;

																	BgL_arg1732z00_17076 =
																		PROCEDURE_ATTR(BgL_rz00_17075);
																	if (STRUCTP(BgL_arg1732z00_17076))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6674z00_28437 =
																				(STRUCT_KEY(BgL_arg1732z00_17076) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6674z00_28437 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6674z00_28437 = ((bool_t) 0);
																}
															if (BgL_test6674z00_28437)
																{
																	obj_t BgL_fz00_28445;

																	BgL_fz00_28445 = BgL_rz00_17075;
																	BgL_fz00_17074 = BgL_fz00_28445;
																	goto BgL_recz00_17073;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17068, ((long) 0),
																		BgL_savedzd2bpzd2_17072);
																	BgL_____rz00_17071 = BgL_rz00_17075;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17070);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17069, BgL_sz00_17061);
											return BgL_____rz00_17071;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5774 */
	obj_t BGl_z62run5774z62zz__evaluate_compz00(obj_t BgL_envz00_14684,
		obj_t BgL_sz00_14688)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14685;
				BgL_ev_absz00_bglt BgL_i1247z00_14686;
				obj_t BgL_bodyz00_14687;

				BgL_iboxesz00_14685 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 0))));
				BgL_i1247z00_14686 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 1))));
				BgL_bodyz00_14687 = PROCEDURE_REF(BgL_envz00_14684, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17077;

					BgL_bpz00_17077 = VECTOR_REF(((obj_t) BgL_sz00_14688), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14688,
						BgL_iboxesz00_14685, BgL_bpz00_17077);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17078;
						obj_t BgL_wherez00_17079;
						obj_t BgL_locz00_17080;

						BgL_z12denvz12_17078 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17079 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14686))->
							BgL_wherez00);
						BgL_locz00_17080 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14686))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17078, BgL_wherez00_17079,
								BgL_locz00_17080);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17081;

								BgL_za2za2resza2za2z00_17081 =
									PROCEDURE_ENTRY(BgL_bodyz00_14687) (BgL_bodyz00_14687,
									BgL_sz00_14688, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17078);
								return BgL_za2za2resza2za2z00_17081;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3786> */
	obj_t BGl_z62zc3z04anonymousza33786ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14689, obj_t BgL_sz00_14695)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14690;
				long BgL_siza7eza7_14691;
				BgL_ev_absz00_bglt BgL_i1247z00_14692;
				obj_t BgL_bodyz00_14693;
				long BgL_siza7ezd2framez75_14694;

				BgL_ifreesz00_14690 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14689, (int) (((long) 0))));
				BgL_siza7eza7_14691 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14689, (int) (((long) 1))));
				BgL_i1247z00_14692 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14689, (int) (((long) 2))));
				BgL_bodyz00_14693 = PROCEDURE_REF(BgL_envz00_14689, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14694 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14689, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17082;

					BgL_bpz00_17082 = VECTOR_REF(((obj_t) BgL_sz00_14695), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17083;

						BgL_valza2za2_17083 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14695,
							BgL_bpz00_17082, BgL_ifreesz00_14690);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17084;

							BgL_runz00_17084 =
								MAKE_FX_PROCEDURE(BGl_z62run5776z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17084,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14691));
							PROCEDURE_SET(BgL_runz00_17084,
								(int) (((long) 1)), BgL_valza2za2_17083);
							PROCEDURE_SET(BgL_runz00_17084,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14692));
							PROCEDURE_SET(BgL_runz00_17084,
								(int) (((long) 3)), BgL_bodyz00_14693);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17085;

								BgL_mainz00_17085 =
									MAKE_FX_PROCEDURE(BGl_z62main5775z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17085,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14691));
								PROCEDURE_SET(BgL_mainz00_17085,
									(int) (((long) 1)), BgL_valza2za2_17083);
								PROCEDURE_SET(BgL_mainz00_17085,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14692));
								PROCEDURE_SET(BgL_mainz00_17085,
									(int) (((long) 3)), BgL_bodyz00_14693);
								PROCEDURE_SET(BgL_mainz00_17085,
									(int) (((long) 4)), BgL_runz00_17084);
								PROCEDURE_SET(BgL_mainz00_17085,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14694));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17086;

									BgL_objz00_17086 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17084, BgL_objz00_17086);
									BgL_objz00_17086;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3787z00_17087;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3788z00_17088;

										BgL_arg3788z00_17088 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14692))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17089;

											BgL_newz00_17089 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28521;

												BgL_tmpz00_28521 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17089, BgL_tmpz00_28521,
													BgL_arg3788z00_17088);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28526;
												int BgL_tmpz00_28524;

												BgL_auxz00_28526 = BINT(BgL_siza7ezd2framez75_14694);
												BgL_tmpz00_28524 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17089, BgL_tmpz00_28524,
													BgL_auxz00_28526);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28529;

												BgL_tmpz00_28529 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17089, BgL_tmpz00_28529,
													BgL_runz00_17084);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28534;
												int BgL_tmpz00_28532;

												BgL_auxz00_28534 = BINT(((long) 3));
												BgL_tmpz00_28532 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17089, BgL_tmpz00_28532,
													BgL_auxz00_28534);
											}
											BgL_arg3787z00_17087 = BgL_newz00_17089;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17085, BgL_arg3787z00_17087);
									BgL_arg3787z00_17087;
								}
								return BgL_mainz00_17085;
							}
						}
					}
				}
			}
		}

	}



/* &main5775 */
	obj_t BGl_z62main5775z62zz__evaluate_compz00(obj_t BgL_envz00_14696,
		obj_t BgL_bz00_14703, obj_t BgL_cz00_14704, obj_t BgL_dz00_14705)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14701;
				long BgL_siza7ezd2framez75_14702;

				BgL_runz00_14701 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14696, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14702 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14696, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17090;

					BgL_sz00_17090 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17091;

						BgL_bpz00_17091 = VECTOR_REF(((obj_t) BgL_sz00_17090), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17091) + BgL_siza7ezd2framez75_14702) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17090))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3791z00_17092;

									BgL_arg3791z00_17092 =
										((long) CINT(BgL_bpz00_17091) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17090), BgL_arg3791z00_17092,
										BgL_bz00_14703);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3792z00_17093;

									BgL_arg3792z00_17093 =
										((long) CINT(BgL_bpz00_17091) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17090), BgL_arg3792z00_17093,
										BgL_cz00_14704);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3793z00_17094;

									BgL_arg3793z00_17094 =
										((long) CINT(BgL_bpz00_17091) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17090), BgL_arg3793z00_17094,
										BgL_dz00_14705);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17095;

									BgL_ez00_17095 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17095,
										BgL_bpz00_17091);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17096;

										BgL_accz00_17096 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14701, BgL_sz00_17090, BgL_bpz00_17091);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17095);
										VECTOR_SET(
											((obj_t) BgL_sz00_17090), ((long) 0), BgL_bpz00_17091);
										return BgL_accz00_17096;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17097;

								BgL_nsz00_17097 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17097, ((long) 1), BgL_sz00_17090);
								VECTOR_SET(BgL_nsz00_17097, ((long) 2), BgL_bz00_14703);
								VECTOR_SET(BgL_nsz00_17097, ((long) 3), BgL_cz00_14704);
								VECTOR_SET(BgL_nsz00_17097, ((long) 4), BgL_dz00_14705);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17098;

									BgL_z12denvz12_17098 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17098, BgL_nsz00_17097);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17099;

										BgL_ez00_17099 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17099,
											BgL_sz00_17090);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17100;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17101;

												BgL_savedzd2bpzd2_17101 =
													VECTOR_REF(BgL_nsz00_17097, ((long) 0));
												VECTOR_SET(BgL_nsz00_17097, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17103;

													BgL_fz00_17103 = BgL_runz00_14701;
												BgL_recz00_17102:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17104;

														BgL_rz00_17104 =
															PROCEDURE_ENTRY(BgL_fz00_17103) (BgL_fz00_17103,
															BgL_nsz00_17097, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6678z00_28587;

															if (PROCEDUREP(BgL_rz00_17104))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17105;

																	BgL_arg1732z00_17105 =
																		PROCEDURE_ATTR(BgL_rz00_17104);
																	if (STRUCTP(BgL_arg1732z00_17105))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6678z00_28587 =
																				(STRUCT_KEY(BgL_arg1732z00_17105) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6678z00_28587 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6678z00_28587 = ((bool_t) 0);
																}
															if (BgL_test6678z00_28587)
																{
																	obj_t BgL_fz00_28595;

																	BgL_fz00_28595 = BgL_rz00_17104;
																	BgL_fz00_17103 = BgL_fz00_28595;
																	goto BgL_recz00_17102;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17097, ((long) 0),
																		BgL_savedzd2bpzd2_17101);
																	BgL_____rz00_17100 = BgL_rz00_17104;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17099);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17098, BgL_sz00_17090);
											return BgL_____rz00_17100;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5776 */
	obj_t BGl_z62run5776z62zz__evaluate_compz00(obj_t BgL_envz00_14706,
		obj_t BgL_sz00_14711)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14707;
				obj_t BgL_valza2za2_14708;
				BgL_ev_absz00_bglt BgL_i1247z00_14709;
				obj_t BgL_bodyz00_14710;

				BgL_siza7eza7_14707 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14706, (int) (((long) 0))));
				BgL_valza2za2_14708 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14706, (int) (((long) 1))));
				BgL_i1247z00_14709 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14706, (int) (((long) 2))));
				BgL_bodyz00_14710 = PROCEDURE_REF(BgL_envz00_14706, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17106;

					BgL_bpz00_17106 = VECTOR_REF(((obj_t) BgL_sz00_14711), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14711,
						BgL_valza2za2_14708,
						((long) CINT(BgL_bpz00_17106) + BgL_siza7eza7_14707));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17107;
						obj_t BgL_wherez00_17108;
						obj_t BgL_locz00_17109;

						BgL_z12denvz12_17107 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17108 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14709))->
							BgL_wherez00);
						BgL_locz00_17109 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14709))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17107, BgL_wherez00_17108,
								BgL_locz00_17109);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17110;

								BgL_za2za2resza2za2z00_17110 =
									PROCEDURE_ENTRY(BgL_bodyz00_14710) (BgL_bodyz00_14710,
									BgL_sz00_14711, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17107);
								return BgL_za2za2resza2za2z00_17110;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3796> */
	obj_t BGl_z62zc3z04anonymousza33796ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14712, obj_t BgL_sz00_14719)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14713;
				obj_t BgL_iboxesz00_14714;
				long BgL_siza7eza7_14715;
				BgL_ev_absz00_bglt BgL_i1247z00_14716;
				obj_t BgL_bodyz00_14717;
				long BgL_siza7ezd2framez75_14718;

				BgL_ifreesz00_14713 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14712, (int) (((long) 0))));
				BgL_iboxesz00_14714 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14712, (int) (((long) 1))));
				BgL_siza7eza7_14715 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14712, (int) (((long) 2))));
				BgL_i1247z00_14716 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14712, (int) (((long) 3))));
				BgL_bodyz00_14717 = PROCEDURE_REF(BgL_envz00_14712, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14718 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14712, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17111;

					BgL_bpz00_17111 = VECTOR_REF(((obj_t) BgL_sz00_14719), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17112;

						BgL_valza2za2_17112 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14719,
							BgL_bpz00_17111, BgL_ifreesz00_14713);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17113;

							BgL_runz00_17113 =
								MAKE_FX_PROCEDURE(BGl_z62run5778z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17113,
								(int) (((long) 0)), BgL_iboxesz00_14714);
							PROCEDURE_SET(BgL_runz00_17113,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14715));
							PROCEDURE_SET(BgL_runz00_17113,
								(int) (((long) 2)), BgL_valza2za2_17112);
							PROCEDURE_SET(BgL_runz00_17113,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14716));
							PROCEDURE_SET(BgL_runz00_17113,
								(int) (((long) 4)), BgL_bodyz00_14717);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17114;

								BgL_mainz00_17114 =
									MAKE_FX_PROCEDURE(BGl_z62main5777z62zz__evaluate_compz00,
									(int) (((long) 3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 0)), BgL_iboxesz00_14714);
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14715));
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 2)), BgL_valza2za2_17112);
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14716));
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 4)), BgL_bodyz00_14717);
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 5)), BgL_runz00_17113);
								PROCEDURE_SET(BgL_mainz00_17114,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14718));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17115;

									BgL_objz00_17115 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17113, BgL_objz00_17115);
									BgL_objz00_17115;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3797z00_17116;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3798z00_17117;

										BgL_arg3798z00_17117 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14716))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17118;

											BgL_newz00_17118 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28683;

												BgL_tmpz00_28683 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17118, BgL_tmpz00_28683,
													BgL_arg3798z00_17117);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28688;
												int BgL_tmpz00_28686;

												BgL_auxz00_28688 = BINT(BgL_siza7ezd2framez75_14718);
												BgL_tmpz00_28686 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17118, BgL_tmpz00_28686,
													BgL_auxz00_28688);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28691;

												BgL_tmpz00_28691 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17118, BgL_tmpz00_28691,
													BgL_runz00_17113);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28696;
												int BgL_tmpz00_28694;

												BgL_auxz00_28696 = BINT(((long) 3));
												BgL_tmpz00_28694 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17118, BgL_tmpz00_28694,
													BgL_auxz00_28696);
											}
											BgL_arg3797z00_17116 = BgL_newz00_17118;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17114, BgL_arg3797z00_17116);
									BgL_arg3797z00_17116;
								}
								return BgL_mainz00_17114;
							}
						}
					}
				}
			}
		}

	}



/* &main5777 */
	obj_t BGl_z62main5777z62zz__evaluate_compz00(obj_t BgL_envz00_14720,
		obj_t BgL_bz00_14728, obj_t BgL_cz00_14729, obj_t BgL_dz00_14730)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14726;
				long BgL_siza7ezd2framez75_14727;

				BgL_runz00_14726 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14720, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14727 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14720, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17119;

					BgL_sz00_17119 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17120;

						BgL_bpz00_17120 = VECTOR_REF(((obj_t) BgL_sz00_17119), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17120) + BgL_siza7ezd2framez75_14727) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17119))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3801z00_17121;

									BgL_arg3801z00_17121 =
										((long) CINT(BgL_bpz00_17120) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17119), BgL_arg3801z00_17121,
										BgL_bz00_14728);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3802z00_17122;

									BgL_arg3802z00_17122 =
										((long) CINT(BgL_bpz00_17120) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17119), BgL_arg3802z00_17122,
										BgL_cz00_14729);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3803z00_17123;

									BgL_arg3803z00_17123 =
										((long) CINT(BgL_bpz00_17120) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17119), BgL_arg3803z00_17123,
										BgL_dz00_14730);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17124;

									BgL_ez00_17124 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17124,
										BgL_bpz00_17120);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17125;

										BgL_accz00_17125 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14726, BgL_sz00_17119, BgL_bpz00_17120);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17124);
										VECTOR_SET(
											((obj_t) BgL_sz00_17119), ((long) 0), BgL_bpz00_17120);
										return BgL_accz00_17125;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17126;

								BgL_nsz00_17126 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17126, ((long) 1), BgL_sz00_17119);
								VECTOR_SET(BgL_nsz00_17126, ((long) 2), BgL_bz00_14728);
								VECTOR_SET(BgL_nsz00_17126, ((long) 3), BgL_cz00_14729);
								VECTOR_SET(BgL_nsz00_17126, ((long) 4), BgL_dz00_14730);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17127;

									BgL_z12denvz12_17127 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17127, BgL_nsz00_17126);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17128;

										BgL_ez00_17128 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17128,
											BgL_sz00_17119);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17129;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17130;

												BgL_savedzd2bpzd2_17130 =
													VECTOR_REF(BgL_nsz00_17126, ((long) 0));
												VECTOR_SET(BgL_nsz00_17126, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17132;

													BgL_fz00_17132 = BgL_runz00_14726;
												BgL_recz00_17131:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17133;

														BgL_rz00_17133 =
															PROCEDURE_ENTRY(BgL_fz00_17132) (BgL_fz00_17132,
															BgL_nsz00_17126, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6682z00_28749;

															if (PROCEDUREP(BgL_rz00_17133))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17134;

																	BgL_arg1732z00_17134 =
																		PROCEDURE_ATTR(BgL_rz00_17133);
																	if (STRUCTP(BgL_arg1732z00_17134))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6682z00_28749 =
																				(STRUCT_KEY(BgL_arg1732z00_17134) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6682z00_28749 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6682z00_28749 = ((bool_t) 0);
																}
															if (BgL_test6682z00_28749)
																{
																	obj_t BgL_fz00_28757;

																	BgL_fz00_28757 = BgL_rz00_17133;
																	BgL_fz00_17132 = BgL_fz00_28757;
																	goto BgL_recz00_17131;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17126, ((long) 0),
																		BgL_savedzd2bpzd2_17130);
																	BgL_____rz00_17129 = BgL_rz00_17133;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17128);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17127, BgL_sz00_17119);
											return BgL_____rz00_17129;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5778 */
	obj_t BGl_z62run5778z62zz__evaluate_compz00(obj_t BgL_envz00_14731,
		obj_t BgL_sz00_14737)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14732;
				long BgL_siza7eza7_14733;
				obj_t BgL_valza2za2_14734;
				BgL_ev_absz00_bglt BgL_i1247z00_14735;
				obj_t BgL_bodyz00_14736;

				BgL_iboxesz00_14732 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14731, (int) (((long) 0))));
				BgL_siza7eza7_14733 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14731, (int) (((long) 1))));
				BgL_valza2za2_14734 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14731, (int) (((long) 2))));
				BgL_i1247z00_14735 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14731, (int) (((long) 3))));
				BgL_bodyz00_14736 = PROCEDURE_REF(BgL_envz00_14731, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17135;

					BgL_bpz00_17135 = VECTOR_REF(((obj_t) BgL_sz00_14737), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14737,
						BgL_iboxesz00_14732, BgL_bpz00_17135);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14737,
						BgL_valza2za2_14734,
						((long) CINT(BgL_bpz00_17135) + BgL_siza7eza7_14733));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17136;
						obj_t BgL_wherez00_17137;
						obj_t BgL_locz00_17138;

						BgL_z12denvz12_17136 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17137 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14735))->
							BgL_wherez00);
						BgL_locz00_17138 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14735))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17136, BgL_wherez00_17137,
								BgL_locz00_17138);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17139;

								BgL_za2za2resza2za2z00_17139 =
									PROCEDURE_ENTRY(BgL_bodyz00_14736) (BgL_bodyz00_14736,
									BgL_sz00_14737, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17136);
								return BgL_za2za2resza2za2z00_17139;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3718> */
	obj_t BGl_z62zc3z04anonymousza33718ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14738, obj_t BgL_sz00_14742)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14739;
				obj_t BgL_bodyz00_14740;
				long BgL_siza7ezd2framez75_14741;

				BgL_i1247z00_14739 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14738, (int) (((long) 0))));
				BgL_bodyz00_14740 = PROCEDURE_REF(BgL_envz00_14738, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14741 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14738, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17140;

					BgL_bpz00_17140 = VECTOR_REF(((obj_t) BgL_sz00_14742), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17141;

							BgL_runz00_17141 =
								MAKE_FX_PROCEDURE(BGl_z62run5780z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17141,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14739));
							PROCEDURE_SET(BgL_runz00_17141,
								(int) (((long) 1)), BgL_bodyz00_14740);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17142;

								BgL_mainz00_17142 =
									MAKE_VA_PROCEDURE(BGl_z62main5779z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14739));
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 1)), BgL_bodyz00_14740);
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 2)), BgL_runz00_17141);
								PROCEDURE_SET(BgL_mainz00_17142,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14741));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17143;

									BgL_objz00_17143 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17141, BgL_objz00_17143);
									BgL_objz00_17143;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3719z00_17144;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3720z00_17145;

										BgL_arg3720z00_17145 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14739))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17146;

											BgL_newz00_17146 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28825;

												BgL_tmpz00_28825 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17146, BgL_tmpz00_28825,
													BgL_arg3720z00_17145);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28830;
												int BgL_tmpz00_28828;

												BgL_auxz00_28830 = BINT(BgL_siza7ezd2framez75_14741);
												BgL_tmpz00_28828 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17146, BgL_tmpz00_28828,
													BgL_auxz00_28830);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28833;

												BgL_tmpz00_28833 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17146, BgL_tmpz00_28833,
													BgL_runz00_17141);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28838;
												int BgL_tmpz00_28836;

												BgL_auxz00_28838 = BINT(((long) -3));
												BgL_tmpz00_28836 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17146, BgL_tmpz00_28836,
													BgL_auxz00_28838);
											}
											BgL_arg3719z00_17144 = BgL_newz00_17146;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17142, BgL_arg3719z00_17144);
									BgL_arg3719z00_17144;
								}
								return BgL_mainz00_17142;
							}
						}
					}
				}
			}
		}

	}



/* &main5779 */
	obj_t BGl_z62main5779z62zz__evaluate_compz00(obj_t BgL_envz00_14743,
		obj_t BgL_cz00_14748, obj_t BgL_dz00_14749, obj_t BgL_lastz00_14750)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14746;
				long BgL_siza7ezd2framez75_14747;

				BgL_runz00_14746 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14743, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14747 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14743, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17147;

					BgL_sz00_17147 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17148;

						BgL_bpz00_17148 = VECTOR_REF(((obj_t) BgL_sz00_17147), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17148) + BgL_siza7ezd2framez75_14747) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17147))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3723z00_17149;

									BgL_arg3723z00_17149 =
										((long) CINT(BgL_bpz00_17148) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17147), BgL_arg3723z00_17149,
										BgL_cz00_14748);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3724z00_17150;

									BgL_arg3724z00_17150 =
										((long) CINT(BgL_bpz00_17148) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17147), BgL_arg3724z00_17150,
										BgL_dz00_14749);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3725z00_17151;

									BgL_arg3725z00_17151 =
										((long) CINT(BgL_bpz00_17148) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17147), BgL_arg3725z00_17151,
										BgL_lastz00_14750);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17152;

									BgL_ez00_17152 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17152,
										BgL_bpz00_17148);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17153;

										BgL_accz00_17153 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14746, BgL_sz00_17147, BgL_bpz00_17148);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17152);
										VECTOR_SET(
											((obj_t) BgL_sz00_17147), ((long) 0), BgL_bpz00_17148);
										return BgL_accz00_17153;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17154;

								BgL_nsz00_17154 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17154, ((long) 1), BgL_sz00_17147);
								VECTOR_SET(BgL_nsz00_17154, ((long) 2), BgL_cz00_14748);
								VECTOR_SET(BgL_nsz00_17154, ((long) 3), BgL_dz00_14749);
								VECTOR_SET(BgL_nsz00_17154, ((long) 4), BgL_lastz00_14750);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17155;

									BgL_z12denvz12_17155 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17155, BgL_nsz00_17154);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17156;

										BgL_ez00_17156 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17156,
											BgL_sz00_17147);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17157;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17158;

												BgL_savedzd2bpzd2_17158 =
													VECTOR_REF(BgL_nsz00_17154, ((long) 0));
												VECTOR_SET(BgL_nsz00_17154, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17160;

													BgL_fz00_17160 = BgL_runz00_14746;
												BgL_recz00_17159:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17161;

														BgL_rz00_17161 =
															PROCEDURE_ENTRY(BgL_fz00_17160) (BgL_fz00_17160,
															BgL_nsz00_17154, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6686z00_28891;

															if (PROCEDUREP(BgL_rz00_17161))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17162;

																	BgL_arg1732z00_17162 =
																		PROCEDURE_ATTR(BgL_rz00_17161);
																	if (STRUCTP(BgL_arg1732z00_17162))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6686z00_28891 =
																				(STRUCT_KEY(BgL_arg1732z00_17162) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6686z00_28891 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6686z00_28891 = ((bool_t) 0);
																}
															if (BgL_test6686z00_28891)
																{
																	obj_t BgL_fz00_28899;

																	BgL_fz00_28899 = BgL_rz00_17161;
																	BgL_fz00_17160 = BgL_fz00_28899;
																	goto BgL_recz00_17159;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17154, ((long) 0),
																		BgL_savedzd2bpzd2_17158);
																	BgL_____rz00_17157 = BgL_rz00_17161;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17156);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17155, BgL_sz00_17147);
											return BgL_____rz00_17157;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5780 */
	obj_t BGl_z62run5780z62zz__evaluate_compz00(obj_t BgL_envz00_14751,
		obj_t BgL_sz00_14754)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14752;
				obj_t BgL_bodyz00_14753;

				BgL_i1247z00_14752 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14751, (int) (((long) 0))));
				BgL_bodyz00_14753 = PROCEDURE_REF(BgL_envz00_14751, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17163;

					BgL_bpz00_17163 = VECTOR_REF(((obj_t) BgL_sz00_14754), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17164;
						obj_t BgL_wherez00_17165;
						obj_t BgL_locz00_17166;

						BgL_z12denvz12_17164 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17165 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14752))->
							BgL_wherez00);
						BgL_locz00_17166 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14752))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17164, BgL_wherez00_17165,
								BgL_locz00_17166);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17167;

								BgL_za2za2resza2za2z00_17167 =
									PROCEDURE_ENTRY(BgL_bodyz00_14753) (BgL_bodyz00_14753,
									BgL_sz00_14754, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17164);
								return BgL_za2za2resza2za2z00_17167;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3727> */
	obj_t BGl_z62zc3z04anonymousza33727ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14755, obj_t BgL_sz00_14760)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14756;
				BgL_ev_absz00_bglt BgL_i1247z00_14757;
				obj_t BgL_bodyz00_14758;
				long BgL_siza7ezd2framez75_14759;

				BgL_iboxesz00_14756 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14755, (int) (((long) 0))));
				BgL_i1247z00_14757 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14755, (int) (((long) 1))));
				BgL_bodyz00_14758 = PROCEDURE_REF(BgL_envz00_14755, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14759 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14755, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17168;

					BgL_bpz00_17168 = VECTOR_REF(((obj_t) BgL_sz00_14760), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17169;

							BgL_runz00_17169 =
								MAKE_FX_PROCEDURE(BGl_z62run5782z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17169,
								(int) (((long) 0)), BgL_iboxesz00_14756);
							PROCEDURE_SET(BgL_runz00_17169,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14757));
							PROCEDURE_SET(BgL_runz00_17169,
								(int) (((long) 2)), BgL_bodyz00_14758);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17170;

								BgL_mainz00_17170 =
									MAKE_VA_PROCEDURE(BGl_z62main5781z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17170,
									(int) (((long) 0)), BgL_iboxesz00_14756);
								PROCEDURE_SET(BgL_mainz00_17170,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14757));
								PROCEDURE_SET(BgL_mainz00_17170,
									(int) (((long) 2)), BgL_bodyz00_14758);
								PROCEDURE_SET(BgL_mainz00_17170,
									(int) (((long) 3)), BgL_runz00_17169);
								PROCEDURE_SET(BgL_mainz00_17170,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14759));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17171;

									BgL_objz00_17171 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17169, BgL_objz00_17171);
									BgL_objz00_17171;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3728z00_17172;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3729z00_17173;

										BgL_arg3729z00_17173 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14757))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17174;

											BgL_newz00_17174 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28961;

												BgL_tmpz00_28961 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17174, BgL_tmpz00_28961,
													BgL_arg3729z00_17173);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28966;
												int BgL_tmpz00_28964;

												BgL_auxz00_28966 = BINT(BgL_siza7ezd2framez75_14759);
												BgL_tmpz00_28964 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17174, BgL_tmpz00_28964,
													BgL_auxz00_28966);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_28969;

												BgL_tmpz00_28969 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17174, BgL_tmpz00_28969,
													BgL_runz00_17169);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_28974;
												int BgL_tmpz00_28972;

												BgL_auxz00_28974 = BINT(((long) -3));
												BgL_tmpz00_28972 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17174, BgL_tmpz00_28972,
													BgL_auxz00_28974);
											}
											BgL_arg3728z00_17172 = BgL_newz00_17174;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17170, BgL_arg3728z00_17172);
									BgL_arg3728z00_17172;
								}
								return BgL_mainz00_17170;
							}
						}
					}
				}
			}
		}

	}



/* &main5781 */
	obj_t BGl_z62main5781z62zz__evaluate_compz00(obj_t BgL_envz00_14761,
		obj_t BgL_cz00_14767, obj_t BgL_dz00_14768, obj_t BgL_lastz00_14769)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14765;
				long BgL_siza7ezd2framez75_14766;

				BgL_runz00_14765 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14761, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14766 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14761, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17175;

					BgL_sz00_17175 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17176;

						BgL_bpz00_17176 = VECTOR_REF(((obj_t) BgL_sz00_17175), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17176) + BgL_siza7ezd2framez75_14766) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17175))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3732z00_17177;

									BgL_arg3732z00_17177 =
										((long) CINT(BgL_bpz00_17176) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17175), BgL_arg3732z00_17177,
										BgL_cz00_14767);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3733z00_17178;

									BgL_arg3733z00_17178 =
										((long) CINT(BgL_bpz00_17176) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17175), BgL_arg3733z00_17178,
										BgL_dz00_14768);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3734z00_17179;

									BgL_arg3734z00_17179 =
										((long) CINT(BgL_bpz00_17176) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17175), BgL_arg3734z00_17179,
										BgL_lastz00_14769);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17180;

									BgL_ez00_17180 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17180,
										BgL_bpz00_17176);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17181;

										BgL_accz00_17181 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14765, BgL_sz00_17175, BgL_bpz00_17176);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17180);
										VECTOR_SET(
											((obj_t) BgL_sz00_17175), ((long) 0), BgL_bpz00_17176);
										return BgL_accz00_17181;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17182;

								BgL_nsz00_17182 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17182, ((long) 1), BgL_sz00_17175);
								VECTOR_SET(BgL_nsz00_17182, ((long) 2), BgL_cz00_14767);
								VECTOR_SET(BgL_nsz00_17182, ((long) 3), BgL_dz00_14768);
								VECTOR_SET(BgL_nsz00_17182, ((long) 4), BgL_lastz00_14769);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17183;

									BgL_z12denvz12_17183 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17183, BgL_nsz00_17182);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17184;

										BgL_ez00_17184 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17184,
											BgL_sz00_17175);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17185;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17186;

												BgL_savedzd2bpzd2_17186 =
													VECTOR_REF(BgL_nsz00_17182, ((long) 0));
												VECTOR_SET(BgL_nsz00_17182, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17188;

													BgL_fz00_17188 = BgL_runz00_14765;
												BgL_recz00_17187:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17189;

														BgL_rz00_17189 =
															PROCEDURE_ENTRY(BgL_fz00_17188) (BgL_fz00_17188,
															BgL_nsz00_17182, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6690z00_29027;

															if (PROCEDUREP(BgL_rz00_17189))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17190;

																	BgL_arg1732z00_17190 =
																		PROCEDURE_ATTR(BgL_rz00_17189);
																	if (STRUCTP(BgL_arg1732z00_17190))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6690z00_29027 =
																				(STRUCT_KEY(BgL_arg1732z00_17190) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6690z00_29027 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6690z00_29027 = ((bool_t) 0);
																}
															if (BgL_test6690z00_29027)
																{
																	obj_t BgL_fz00_29035;

																	BgL_fz00_29035 = BgL_rz00_17189;
																	BgL_fz00_17188 = BgL_fz00_29035;
																	goto BgL_recz00_17187;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17182, ((long) 0),
																		BgL_savedzd2bpzd2_17186);
																	BgL_____rz00_17185 = BgL_rz00_17189;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17184);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17183, BgL_sz00_17175);
											return BgL_____rz00_17185;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5782 */
	obj_t BGl_z62run5782z62zz__evaluate_compz00(obj_t BgL_envz00_14770,
		obj_t BgL_sz00_14774)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14771;
				BgL_ev_absz00_bglt BgL_i1247z00_14772;
				obj_t BgL_bodyz00_14773;

				BgL_iboxesz00_14771 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 0))));
				BgL_i1247z00_14772 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 1))));
				BgL_bodyz00_14773 = PROCEDURE_REF(BgL_envz00_14770, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17191;

					BgL_bpz00_17191 = VECTOR_REF(((obj_t) BgL_sz00_14774), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14774,
						BgL_iboxesz00_14771, BgL_bpz00_17191);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17192;
						obj_t BgL_wherez00_17193;
						obj_t BgL_locz00_17194;

						BgL_z12denvz12_17192 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17193 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14772))->
							BgL_wherez00);
						BgL_locz00_17194 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14772))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17192, BgL_wherez00_17193,
								BgL_locz00_17194);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17195;

								BgL_za2za2resza2za2z00_17195 =
									PROCEDURE_ENTRY(BgL_bodyz00_14773) (BgL_bodyz00_14773,
									BgL_sz00_14774, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17192);
								return BgL_za2za2resza2za2z00_17195;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3739> */
	obj_t BGl_z62zc3z04anonymousza33739ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14775, obj_t BgL_sz00_14781)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14776;
				long BgL_siza7eza7_14777;
				BgL_ev_absz00_bglt BgL_i1247z00_14778;
				obj_t BgL_bodyz00_14779;
				long BgL_siza7ezd2framez75_14780;

				BgL_ifreesz00_14776 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14775, (int) (((long) 0))));
				BgL_siza7eza7_14777 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14775, (int) (((long) 1))));
				BgL_i1247z00_14778 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14775, (int) (((long) 2))));
				BgL_bodyz00_14779 = PROCEDURE_REF(BgL_envz00_14775, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14780 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14775, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17196;

					BgL_bpz00_17196 = VECTOR_REF(((obj_t) BgL_sz00_14781), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17197;

						BgL_valza2za2_17197 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14781,
							BgL_bpz00_17196, BgL_ifreesz00_14776);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17198;

							BgL_runz00_17198 =
								MAKE_FX_PROCEDURE(BGl_z62run5784z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17198,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14777));
							PROCEDURE_SET(BgL_runz00_17198,
								(int) (((long) 1)), BgL_valza2za2_17197);
							PROCEDURE_SET(BgL_runz00_17198,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14778));
							PROCEDURE_SET(BgL_runz00_17198,
								(int) (((long) 3)), BgL_bodyz00_14779);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17199;

								BgL_mainz00_17199 =
									MAKE_VA_PROCEDURE(BGl_z62main5783z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17199,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14777));
								PROCEDURE_SET(BgL_mainz00_17199,
									(int) (((long) 1)), BgL_valza2za2_17197);
								PROCEDURE_SET(BgL_mainz00_17199,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14778));
								PROCEDURE_SET(BgL_mainz00_17199,
									(int) (((long) 3)), BgL_bodyz00_14779);
								PROCEDURE_SET(BgL_mainz00_17199,
									(int) (((long) 4)), BgL_runz00_17198);
								PROCEDURE_SET(BgL_mainz00_17199,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14780));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17200;

									BgL_objz00_17200 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17198, BgL_objz00_17200);
									BgL_objz00_17200;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3740z00_17201;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3741z00_17202;

										BgL_arg3741z00_17202 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14778))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17203;

											BgL_newz00_17203 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29111;

												BgL_tmpz00_29111 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17203, BgL_tmpz00_29111,
													BgL_arg3741z00_17202);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29116;
												int BgL_tmpz00_29114;

												BgL_auxz00_29116 = BINT(BgL_siza7ezd2framez75_14780);
												BgL_tmpz00_29114 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17203, BgL_tmpz00_29114,
													BgL_auxz00_29116);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29119;

												BgL_tmpz00_29119 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17203, BgL_tmpz00_29119,
													BgL_runz00_17198);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29124;
												int BgL_tmpz00_29122;

												BgL_auxz00_29124 = BINT(((long) -3));
												BgL_tmpz00_29122 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17203, BgL_tmpz00_29122,
													BgL_auxz00_29124);
											}
											BgL_arg3740z00_17201 = BgL_newz00_17203;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17199, BgL_arg3740z00_17201);
									BgL_arg3740z00_17201;
								}
								return BgL_mainz00_17199;
							}
						}
					}
				}
			}
		}

	}



/* &main5783 */
	obj_t BGl_z62main5783z62zz__evaluate_compz00(obj_t BgL_envz00_14782,
		obj_t BgL_cz00_14789, obj_t BgL_dz00_14790, obj_t BgL_lastz00_14791)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14787;
				long BgL_siza7ezd2framez75_14788;

				BgL_runz00_14787 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14782, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14788 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14782, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17204;

					BgL_sz00_17204 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17205;

						BgL_bpz00_17205 = VECTOR_REF(((obj_t) BgL_sz00_17204), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17205) + BgL_siza7ezd2framez75_14788) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17204))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3744z00_17206;

									BgL_arg3744z00_17206 =
										((long) CINT(BgL_bpz00_17205) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17204), BgL_arg3744z00_17206,
										BgL_cz00_14789);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3745z00_17207;

									BgL_arg3745z00_17207 =
										((long) CINT(BgL_bpz00_17205) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17204), BgL_arg3745z00_17207,
										BgL_dz00_14790);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3746z00_17208;

									BgL_arg3746z00_17208 =
										((long) CINT(BgL_bpz00_17205) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17204), BgL_arg3746z00_17208,
										BgL_lastz00_14791);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17209;

									BgL_ez00_17209 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17209,
										BgL_bpz00_17205);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17210;

										BgL_accz00_17210 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14787, BgL_sz00_17204, BgL_bpz00_17205);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17209);
										VECTOR_SET(
											((obj_t) BgL_sz00_17204), ((long) 0), BgL_bpz00_17205);
										return BgL_accz00_17210;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17211;

								BgL_nsz00_17211 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17211, ((long) 1), BgL_sz00_17204);
								VECTOR_SET(BgL_nsz00_17211, ((long) 2), BgL_cz00_14789);
								VECTOR_SET(BgL_nsz00_17211, ((long) 3), BgL_dz00_14790);
								VECTOR_SET(BgL_nsz00_17211, ((long) 4), BgL_lastz00_14791);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17212;

									BgL_z12denvz12_17212 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17212, BgL_nsz00_17211);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17213;

										BgL_ez00_17213 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17213,
											BgL_sz00_17204);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17214;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17215;

												BgL_savedzd2bpzd2_17215 =
													VECTOR_REF(BgL_nsz00_17211, ((long) 0));
												VECTOR_SET(BgL_nsz00_17211, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17217;

													BgL_fz00_17217 = BgL_runz00_14787;
												BgL_recz00_17216:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17218;

														BgL_rz00_17218 =
															PROCEDURE_ENTRY(BgL_fz00_17217) (BgL_fz00_17217,
															BgL_nsz00_17211, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6694z00_29177;

															if (PROCEDUREP(BgL_rz00_17218))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17219;

																	BgL_arg1732z00_17219 =
																		PROCEDURE_ATTR(BgL_rz00_17218);
																	if (STRUCTP(BgL_arg1732z00_17219))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6694z00_29177 =
																				(STRUCT_KEY(BgL_arg1732z00_17219) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6694z00_29177 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6694z00_29177 = ((bool_t) 0);
																}
															if (BgL_test6694z00_29177)
																{
																	obj_t BgL_fz00_29185;

																	BgL_fz00_29185 = BgL_rz00_17218;
																	BgL_fz00_17217 = BgL_fz00_29185;
																	goto BgL_recz00_17216;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17211, ((long) 0),
																		BgL_savedzd2bpzd2_17215);
																	BgL_____rz00_17214 = BgL_rz00_17218;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17213);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17212, BgL_sz00_17204);
											return BgL_____rz00_17214;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5784 */
	obj_t BGl_z62run5784z62zz__evaluate_compz00(obj_t BgL_envz00_14792,
		obj_t BgL_sz00_14797)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14793;
				obj_t BgL_valza2za2_14794;
				BgL_ev_absz00_bglt BgL_i1247z00_14795;
				obj_t BgL_bodyz00_14796;

				BgL_siza7eza7_14793 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14792, (int) (((long) 0))));
				BgL_valza2za2_14794 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14792, (int) (((long) 1))));
				BgL_i1247z00_14795 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14792, (int) (((long) 2))));
				BgL_bodyz00_14796 = PROCEDURE_REF(BgL_envz00_14792, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17220;

					BgL_bpz00_17220 = VECTOR_REF(((obj_t) BgL_sz00_14797), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14797,
						BgL_valza2za2_14794,
						((long) CINT(BgL_bpz00_17220) + BgL_siza7eza7_14793));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17221;
						obj_t BgL_wherez00_17222;
						obj_t BgL_locz00_17223;

						BgL_z12denvz12_17221 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17222 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14795))->
							BgL_wherez00);
						BgL_locz00_17223 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14795))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17221, BgL_wherez00_17222,
								BgL_locz00_17223);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17224;

								BgL_za2za2resza2za2z00_17224 =
									PROCEDURE_ENTRY(BgL_bodyz00_14796) (BgL_bodyz00_14796,
									BgL_sz00_14797, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17221);
								return BgL_za2za2resza2za2z00_17224;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3749> */
	obj_t BGl_z62zc3z04anonymousza33749ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14798, obj_t BgL_sz00_14805)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14799;
				obj_t BgL_iboxesz00_14800;
				long BgL_siza7eza7_14801;
				BgL_ev_absz00_bglt BgL_i1247z00_14802;
				obj_t BgL_bodyz00_14803;
				long BgL_siza7ezd2framez75_14804;

				BgL_ifreesz00_14799 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14798, (int) (((long) 0))));
				BgL_iboxesz00_14800 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14798, (int) (((long) 1))));
				BgL_siza7eza7_14801 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14798, (int) (((long) 2))));
				BgL_i1247z00_14802 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14798, (int) (((long) 3))));
				BgL_bodyz00_14803 = PROCEDURE_REF(BgL_envz00_14798, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14804 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14798, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17225;

					BgL_bpz00_17225 = VECTOR_REF(((obj_t) BgL_sz00_14805), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17226;

						BgL_valza2za2_17226 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14805,
							BgL_bpz00_17225, BgL_ifreesz00_14799);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17227;

							BgL_runz00_17227 =
								MAKE_FX_PROCEDURE(BGl_z62run5786z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17227,
								(int) (((long) 0)), BgL_iboxesz00_14800);
							PROCEDURE_SET(BgL_runz00_17227,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14801));
							PROCEDURE_SET(BgL_runz00_17227,
								(int) (((long) 2)), BgL_valza2za2_17226);
							PROCEDURE_SET(BgL_runz00_17227,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14802));
							PROCEDURE_SET(BgL_runz00_17227,
								(int) (((long) 4)), BgL_bodyz00_14803);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17228;

								BgL_mainz00_17228 =
									MAKE_VA_PROCEDURE(BGl_z62main5785z62zz__evaluate_compz00,
									(int) (((long) -3)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 0)), BgL_iboxesz00_14800);
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14801));
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 2)), BgL_valza2za2_17226);
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14802));
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 4)), BgL_bodyz00_14803);
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 5)), BgL_runz00_17227);
								PROCEDURE_SET(BgL_mainz00_17228,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14804));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17229;

									BgL_objz00_17229 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17227, BgL_objz00_17229);
									BgL_objz00_17229;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3750z00_17230;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3751z00_17231;

										BgL_arg3751z00_17231 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14802))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17232;

											BgL_newz00_17232 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29273;

												BgL_tmpz00_29273 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17232, BgL_tmpz00_29273,
													BgL_arg3751z00_17231);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29278;
												int BgL_tmpz00_29276;

												BgL_auxz00_29278 = BINT(BgL_siza7ezd2framez75_14804);
												BgL_tmpz00_29276 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17232, BgL_tmpz00_29276,
													BgL_auxz00_29278);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29281;

												BgL_tmpz00_29281 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17232, BgL_tmpz00_29281,
													BgL_runz00_17227);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29286;
												int BgL_tmpz00_29284;

												BgL_auxz00_29286 = BINT(((long) -3));
												BgL_tmpz00_29284 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17232, BgL_tmpz00_29284,
													BgL_auxz00_29286);
											}
											BgL_arg3750z00_17230 = BgL_newz00_17232;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17228, BgL_arg3750z00_17230);
									BgL_arg3750z00_17230;
								}
								return BgL_mainz00_17228;
							}
						}
					}
				}
			}
		}

	}



/* &main5785 */
	obj_t BGl_z62main5785z62zz__evaluate_compz00(obj_t BgL_envz00_14806,
		obj_t BgL_cz00_14814, obj_t BgL_dz00_14815, obj_t BgL_lastz00_14816)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14812;
				long BgL_siza7ezd2framez75_14813;

				BgL_runz00_14812 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14806, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14813 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14806, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17233;

					BgL_sz00_17233 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17234;

						BgL_bpz00_17234 = VECTOR_REF(((obj_t) BgL_sz00_17233), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17234) + BgL_siza7ezd2framez75_14813) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17233))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3754z00_17235;

									BgL_arg3754z00_17235 =
										((long) CINT(BgL_bpz00_17234) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17233), BgL_arg3754z00_17235,
										BgL_cz00_14814);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3755z00_17236;

									BgL_arg3755z00_17236 =
										((long) CINT(BgL_bpz00_17234) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17233), BgL_arg3755z00_17236,
										BgL_dz00_14815);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3756z00_17237;

									BgL_arg3756z00_17237 =
										((long) CINT(BgL_bpz00_17234) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17233), BgL_arg3756z00_17237,
										BgL_lastz00_14816);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17238;

									BgL_ez00_17238 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17238,
										BgL_bpz00_17234);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17239;

										BgL_accz00_17239 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14812, BgL_sz00_17233, BgL_bpz00_17234);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17238);
										VECTOR_SET(
											((obj_t) BgL_sz00_17233), ((long) 0), BgL_bpz00_17234);
										return BgL_accz00_17239;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17240;

								BgL_nsz00_17240 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17240, ((long) 1), BgL_sz00_17233);
								VECTOR_SET(BgL_nsz00_17240, ((long) 2), BgL_cz00_14814);
								VECTOR_SET(BgL_nsz00_17240, ((long) 3), BgL_dz00_14815);
								VECTOR_SET(BgL_nsz00_17240, ((long) 4), BgL_lastz00_14816);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17241;

									BgL_z12denvz12_17241 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17241, BgL_nsz00_17240);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17242;

										BgL_ez00_17242 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17242,
											BgL_sz00_17233);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17243;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17244;

												BgL_savedzd2bpzd2_17244 =
													VECTOR_REF(BgL_nsz00_17240, ((long) 0));
												VECTOR_SET(BgL_nsz00_17240, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17246;

													BgL_fz00_17246 = BgL_runz00_14812;
												BgL_recz00_17245:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17247;

														BgL_rz00_17247 =
															PROCEDURE_ENTRY(BgL_fz00_17246) (BgL_fz00_17246,
															BgL_nsz00_17240, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6698z00_29339;

															if (PROCEDUREP(BgL_rz00_17247))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17248;

																	BgL_arg1732z00_17248 =
																		PROCEDURE_ATTR(BgL_rz00_17247);
																	if (STRUCTP(BgL_arg1732z00_17248))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6698z00_29339 =
																				(STRUCT_KEY(BgL_arg1732z00_17248) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6698z00_29339 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6698z00_29339 = ((bool_t) 0);
																}
															if (BgL_test6698z00_29339)
																{
																	obj_t BgL_fz00_29347;

																	BgL_fz00_29347 = BgL_rz00_17247;
																	BgL_fz00_17246 = BgL_fz00_29347;
																	goto BgL_recz00_17245;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17240, ((long) 0),
																		BgL_savedzd2bpzd2_17244);
																	BgL_____rz00_17243 = BgL_rz00_17247;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17242);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17241, BgL_sz00_17233);
											return BgL_____rz00_17243;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5786 */
	obj_t BGl_z62run5786z62zz__evaluate_compz00(obj_t BgL_envz00_14817,
		obj_t BgL_sz00_14823)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14818;
				long BgL_siza7eza7_14819;
				obj_t BgL_valza2za2_14820;
				BgL_ev_absz00_bglt BgL_i1247z00_14821;
				obj_t BgL_bodyz00_14822;

				BgL_iboxesz00_14818 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14817, (int) (((long) 0))));
				BgL_siza7eza7_14819 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14817, (int) (((long) 1))));
				BgL_valza2za2_14820 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14817, (int) (((long) 2))));
				BgL_i1247z00_14821 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14817, (int) (((long) 3))));
				BgL_bodyz00_14822 = PROCEDURE_REF(BgL_envz00_14817, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17249;

					BgL_bpz00_17249 = VECTOR_REF(((obj_t) BgL_sz00_14823), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14823,
						BgL_iboxesz00_14818, BgL_bpz00_17249);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14823,
						BgL_valza2za2_14820,
						((long) CINT(BgL_bpz00_17249) + BgL_siza7eza7_14819));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17250;
						obj_t BgL_wherez00_17251;
						obj_t BgL_locz00_17252;

						BgL_z12denvz12_17250 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17251 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14821))->
							BgL_wherez00);
						BgL_locz00_17252 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14821))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17250, BgL_wherez00_17251,
								BgL_locz00_17252);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17253;

								BgL_za2za2resza2za2z00_17253 =
									PROCEDURE_ENTRY(BgL_bodyz00_14822) (BgL_bodyz00_14822,
									BgL_sz00_14823, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17250);
								return BgL_za2za2resza2za2z00_17253;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3670> */
	obj_t BGl_z62zc3z04anonymousza33670ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14824, obj_t BgL_sz00_14828)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14825;
				obj_t BgL_bodyz00_14826;
				long BgL_siza7ezd2framez75_14827;

				BgL_i1247z00_14825 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14824, (int) (((long) 0))));
				BgL_bodyz00_14826 = PROCEDURE_REF(BgL_envz00_14824, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14827 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14824, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17254;

					BgL_bpz00_17254 = VECTOR_REF(((obj_t) BgL_sz00_14828), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17255;

							BgL_runz00_17255 =
								MAKE_FX_PROCEDURE(BGl_z62run5788z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17255,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14825));
							PROCEDURE_SET(BgL_runz00_17255,
								(int) (((long) 1)), BgL_bodyz00_14826);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17256;

								BgL_mainz00_17256 =
									MAKE_FX_PROCEDURE(BGl_z62main5787z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17256,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14825));
								PROCEDURE_SET(BgL_mainz00_17256,
									(int) (((long) 1)), BgL_bodyz00_14826);
								PROCEDURE_SET(BgL_mainz00_17256,
									(int) (((long) 2)), BgL_runz00_17255);
								PROCEDURE_SET(BgL_mainz00_17256,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14827));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17257;

									BgL_objz00_17257 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17255, BgL_objz00_17257);
									BgL_objz00_17257;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3671z00_17258;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3672z00_17259;

										BgL_arg3672z00_17259 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14825))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17260;

											BgL_newz00_17260 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29415;

												BgL_tmpz00_29415 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17260, BgL_tmpz00_29415,
													BgL_arg3672z00_17259);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29420;
												int BgL_tmpz00_29418;

												BgL_auxz00_29420 = BINT(BgL_siza7ezd2framez75_14827);
												BgL_tmpz00_29418 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17260, BgL_tmpz00_29418,
													BgL_auxz00_29420);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29423;

												BgL_tmpz00_29423 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17260, BgL_tmpz00_29423,
													BgL_runz00_17255);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29428;
												int BgL_tmpz00_29426;

												BgL_auxz00_29428 = BINT(((long) 2));
												BgL_tmpz00_29426 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17260, BgL_tmpz00_29426,
													BgL_auxz00_29428);
											}
											BgL_arg3671z00_17258 = BgL_newz00_17260;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17256, BgL_arg3671z00_17258);
									BgL_arg3671z00_17258;
								}
								return BgL_mainz00_17256;
							}
						}
					}
				}
			}
		}

	}



/* &main5787 */
	obj_t BGl_z62main5787z62zz__evaluate_compz00(obj_t BgL_envz00_14829,
		obj_t BgL_cz00_14834, obj_t BgL_dz00_14835)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14832;
				long BgL_siza7ezd2framez75_14833;

				BgL_runz00_14832 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14829, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14833 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14829, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17261;

					BgL_sz00_17261 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17262;

						BgL_bpz00_17262 = VECTOR_REF(((obj_t) BgL_sz00_17261), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17262) + BgL_siza7ezd2framez75_14833) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17261))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3675z00_17263;

									BgL_arg3675z00_17263 =
										((long) CINT(BgL_bpz00_17262) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17261), BgL_arg3675z00_17263,
										BgL_cz00_14834);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3677z00_17264;

									BgL_arg3677z00_17264 =
										((long) CINT(BgL_bpz00_17262) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17261), BgL_arg3677z00_17264,
										BgL_dz00_14835);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17265;

									BgL_ez00_17265 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17265,
										BgL_bpz00_17262);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17266;

										BgL_accz00_17266 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14832, BgL_sz00_17261, BgL_bpz00_17262);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17265);
										VECTOR_SET(
											((obj_t) BgL_sz00_17261), ((long) 0), BgL_bpz00_17262);
										return BgL_accz00_17266;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17267;

								BgL_nsz00_17267 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17267, ((long) 1), BgL_sz00_17261);
								VECTOR_SET(BgL_nsz00_17267, ((long) 2), BgL_cz00_14834);
								VECTOR_SET(BgL_nsz00_17267, ((long) 3), BgL_dz00_14835);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17268;

									BgL_z12denvz12_17268 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17268, BgL_nsz00_17267);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17269;

										BgL_ez00_17269 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17269,
											BgL_sz00_17261);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17270;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17271;

												BgL_savedzd2bpzd2_17271 =
													VECTOR_REF(BgL_nsz00_17267, ((long) 0));
												VECTOR_SET(BgL_nsz00_17267, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17273;

													BgL_fz00_17273 = BgL_runz00_14832;
												BgL_recz00_17272:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17274;

														BgL_rz00_17274 =
															PROCEDURE_ENTRY(BgL_fz00_17273) (BgL_fz00_17273,
															BgL_nsz00_17267, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6702z00_29476;

															if (PROCEDUREP(BgL_rz00_17274))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17275;

																	BgL_arg1732z00_17275 =
																		PROCEDURE_ATTR(BgL_rz00_17274);
																	if (STRUCTP(BgL_arg1732z00_17275))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6702z00_29476 =
																				(STRUCT_KEY(BgL_arg1732z00_17275) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6702z00_29476 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6702z00_29476 = ((bool_t) 0);
																}
															if (BgL_test6702z00_29476)
																{
																	obj_t BgL_fz00_29484;

																	BgL_fz00_29484 = BgL_rz00_17274;
																	BgL_fz00_17273 = BgL_fz00_29484;
																	goto BgL_recz00_17272;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17267, ((long) 0),
																		BgL_savedzd2bpzd2_17271);
																	BgL_____rz00_17270 = BgL_rz00_17274;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17269);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17268, BgL_sz00_17261);
											return BgL_____rz00_17270;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5788 */
	obj_t BGl_z62run5788z62zz__evaluate_compz00(obj_t BgL_envz00_14836,
		obj_t BgL_sz00_14839)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14837;
				obj_t BgL_bodyz00_14838;

				BgL_i1247z00_14837 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14836, (int) (((long) 0))));
				BgL_bodyz00_14838 = PROCEDURE_REF(BgL_envz00_14836, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17276;

					BgL_bpz00_17276 = VECTOR_REF(((obj_t) BgL_sz00_14839), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17277;
						obj_t BgL_wherez00_17278;
						obj_t BgL_locz00_17279;

						BgL_z12denvz12_17277 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17278 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14837))->
							BgL_wherez00);
						BgL_locz00_17279 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14837))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17277, BgL_wherez00_17278,
								BgL_locz00_17279);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17280;

								BgL_za2za2resza2za2z00_17280 =
									PROCEDURE_ENTRY(BgL_bodyz00_14838) (BgL_bodyz00_14838,
									BgL_sz00_14839, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17277);
								return BgL_za2za2resza2za2z00_17280;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3679> */
	obj_t BGl_z62zc3z04anonymousza33679ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14840, obj_t BgL_sz00_14845)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14841;
				BgL_ev_absz00_bglt BgL_i1247z00_14842;
				obj_t BgL_bodyz00_14843;
				long BgL_siza7ezd2framez75_14844;

				BgL_iboxesz00_14841 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14840, (int) (((long) 0))));
				BgL_i1247z00_14842 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14840, (int) (((long) 1))));
				BgL_bodyz00_14843 = PROCEDURE_REF(BgL_envz00_14840, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14844 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14840, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17281;

					BgL_bpz00_17281 = VECTOR_REF(((obj_t) BgL_sz00_14845), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17282;

							BgL_runz00_17282 =
								MAKE_FX_PROCEDURE(BGl_z62run5790z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17282,
								(int) (((long) 0)), BgL_iboxesz00_14841);
							PROCEDURE_SET(BgL_runz00_17282,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14842));
							PROCEDURE_SET(BgL_runz00_17282,
								(int) (((long) 2)), BgL_bodyz00_14843);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17283;

								BgL_mainz00_17283 =
									MAKE_FX_PROCEDURE(BGl_z62main5789z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 0)), BgL_iboxesz00_14841);
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14842));
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 2)), BgL_bodyz00_14843);
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 3)), BgL_runz00_17282);
								PROCEDURE_SET(BgL_mainz00_17283,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14844));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17284;

									BgL_objz00_17284 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17282, BgL_objz00_17284);
									BgL_objz00_17284;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3680z00_17285;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3681z00_17286;

										BgL_arg3681z00_17286 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14842))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17287;

											BgL_newz00_17287 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29546;

												BgL_tmpz00_29546 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17287, BgL_tmpz00_29546,
													BgL_arg3681z00_17286);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29551;
												int BgL_tmpz00_29549;

												BgL_auxz00_29551 = BINT(BgL_siza7ezd2framez75_14844);
												BgL_tmpz00_29549 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17287, BgL_tmpz00_29549,
													BgL_auxz00_29551);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29554;

												BgL_tmpz00_29554 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17287, BgL_tmpz00_29554,
													BgL_runz00_17282);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29559;
												int BgL_tmpz00_29557;

												BgL_auxz00_29559 = BINT(((long) 2));
												BgL_tmpz00_29557 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17287, BgL_tmpz00_29557,
													BgL_auxz00_29559);
											}
											BgL_arg3680z00_17285 = BgL_newz00_17287;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17283, BgL_arg3680z00_17285);
									BgL_arg3680z00_17285;
								}
								return BgL_mainz00_17283;
							}
						}
					}
				}
			}
		}

	}



/* &main5789 */
	obj_t BGl_z62main5789z62zz__evaluate_compz00(obj_t BgL_envz00_14846,
		obj_t BgL_cz00_14852, obj_t BgL_dz00_14853)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14850;
				long BgL_siza7ezd2framez75_14851;

				BgL_runz00_14850 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14846, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14851 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14846, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17288;

					BgL_sz00_17288 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17289;

						BgL_bpz00_17289 = VECTOR_REF(((obj_t) BgL_sz00_17288), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17289) + BgL_siza7ezd2framez75_14851) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17288))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3684z00_17290;

									BgL_arg3684z00_17290 =
										((long) CINT(BgL_bpz00_17289) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17288), BgL_arg3684z00_17290,
										BgL_cz00_14852);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3685z00_17291;

									BgL_arg3685z00_17291 =
										((long) CINT(BgL_bpz00_17289) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17288), BgL_arg3685z00_17291,
										BgL_dz00_14853);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17292;

									BgL_ez00_17292 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17292,
										BgL_bpz00_17289);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17293;

										BgL_accz00_17293 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14850, BgL_sz00_17288, BgL_bpz00_17289);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17292);
										VECTOR_SET(
											((obj_t) BgL_sz00_17288), ((long) 0), BgL_bpz00_17289);
										return BgL_accz00_17293;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17294;

								BgL_nsz00_17294 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17294, ((long) 1), BgL_sz00_17288);
								VECTOR_SET(BgL_nsz00_17294, ((long) 2), BgL_cz00_14852);
								VECTOR_SET(BgL_nsz00_17294, ((long) 3), BgL_dz00_14853);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17295;

									BgL_z12denvz12_17295 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17295, BgL_nsz00_17294);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17296;

										BgL_ez00_17296 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17296,
											BgL_sz00_17288);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17297;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17298;

												BgL_savedzd2bpzd2_17298 =
													VECTOR_REF(BgL_nsz00_17294, ((long) 0));
												VECTOR_SET(BgL_nsz00_17294, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17300;

													BgL_fz00_17300 = BgL_runz00_14850;
												BgL_recz00_17299:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17301;

														BgL_rz00_17301 =
															PROCEDURE_ENTRY(BgL_fz00_17300) (BgL_fz00_17300,
															BgL_nsz00_17294, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6706z00_29607;

															if (PROCEDUREP(BgL_rz00_17301))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17302;

																	BgL_arg1732z00_17302 =
																		PROCEDURE_ATTR(BgL_rz00_17301);
																	if (STRUCTP(BgL_arg1732z00_17302))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6706z00_29607 =
																				(STRUCT_KEY(BgL_arg1732z00_17302) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6706z00_29607 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6706z00_29607 = ((bool_t) 0);
																}
															if (BgL_test6706z00_29607)
																{
																	obj_t BgL_fz00_29615;

																	BgL_fz00_29615 = BgL_rz00_17301;
																	BgL_fz00_17300 = BgL_fz00_29615;
																	goto BgL_recz00_17299;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17294, ((long) 0),
																		BgL_savedzd2bpzd2_17298);
																	BgL_____rz00_17297 = BgL_rz00_17301;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17296);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17295, BgL_sz00_17288);
											return BgL_____rz00_17297;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5790 */
	obj_t BGl_z62run5790z62zz__evaluate_compz00(obj_t BgL_envz00_14854,
		obj_t BgL_sz00_14858)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14855;
				BgL_ev_absz00_bglt BgL_i1247z00_14856;
				obj_t BgL_bodyz00_14857;

				BgL_iboxesz00_14855 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14854, (int) (((long) 0))));
				BgL_i1247z00_14856 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14854, (int) (((long) 1))));
				BgL_bodyz00_14857 = PROCEDURE_REF(BgL_envz00_14854, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17303;

					BgL_bpz00_17303 = VECTOR_REF(((obj_t) BgL_sz00_14858), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14858,
						BgL_iboxesz00_14855, BgL_bpz00_17303);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17304;
						obj_t BgL_wherez00_17305;
						obj_t BgL_locz00_17306;

						BgL_z12denvz12_17304 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17305 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14856))->
							BgL_wherez00);
						BgL_locz00_17306 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14856))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17304, BgL_wherez00_17305,
								BgL_locz00_17306);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17307;

								BgL_za2za2resza2za2z00_17307 =
									PROCEDURE_ENTRY(BgL_bodyz00_14857) (BgL_bodyz00_14857,
									BgL_sz00_14858, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17304);
								return BgL_za2za2resza2za2z00_17307;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3690> */
	obj_t BGl_z62zc3z04anonymousza33690ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14859, obj_t BgL_sz00_14865)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14860;
				long BgL_siza7eza7_14861;
				BgL_ev_absz00_bglt BgL_i1247z00_14862;
				obj_t BgL_bodyz00_14863;
				long BgL_siza7ezd2framez75_14864;

				BgL_ifreesz00_14860 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14859, (int) (((long) 0))));
				BgL_siza7eza7_14861 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14859, (int) (((long) 1))));
				BgL_i1247z00_14862 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14859, (int) (((long) 2))));
				BgL_bodyz00_14863 = PROCEDURE_REF(BgL_envz00_14859, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14864 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14859, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17308;

					BgL_bpz00_17308 = VECTOR_REF(((obj_t) BgL_sz00_14865), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17309;

						BgL_valza2za2_17309 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14865,
							BgL_bpz00_17308, BgL_ifreesz00_14860);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17310;

							BgL_runz00_17310 =
								MAKE_FX_PROCEDURE(BGl_z62run5792z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14861));
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 1)), BgL_valza2za2_17309);
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14862));
							PROCEDURE_SET(BgL_runz00_17310,
								(int) (((long) 3)), BgL_bodyz00_14863);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17311;

								BgL_mainz00_17311 =
									MAKE_FX_PROCEDURE(BGl_z62main5791z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14861));
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 1)), BgL_valza2za2_17309);
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14862));
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 3)), BgL_bodyz00_14863);
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 4)), BgL_runz00_17310);
								PROCEDURE_SET(BgL_mainz00_17311,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14864));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17312;

									BgL_objz00_17312 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17310, BgL_objz00_17312);
									BgL_objz00_17312;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3691z00_17313;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3692z00_17314;

										BgL_arg3692z00_17314 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14862))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17315;

											BgL_newz00_17315 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29691;

												BgL_tmpz00_29691 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17315, BgL_tmpz00_29691,
													BgL_arg3692z00_17314);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29696;
												int BgL_tmpz00_29694;

												BgL_auxz00_29696 = BINT(BgL_siza7ezd2framez75_14864);
												BgL_tmpz00_29694 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17315, BgL_tmpz00_29694,
													BgL_auxz00_29696);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29699;

												BgL_tmpz00_29699 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17315, BgL_tmpz00_29699,
													BgL_runz00_17310);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29704;
												int BgL_tmpz00_29702;

												BgL_auxz00_29704 = BINT(((long) 2));
												BgL_tmpz00_29702 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17315, BgL_tmpz00_29702,
													BgL_auxz00_29704);
											}
											BgL_arg3691z00_17313 = BgL_newz00_17315;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17311, BgL_arg3691z00_17313);
									BgL_arg3691z00_17313;
								}
								return BgL_mainz00_17311;
							}
						}
					}
				}
			}
		}

	}



/* &main5791 */
	obj_t BGl_z62main5791z62zz__evaluate_compz00(obj_t BgL_envz00_14866,
		obj_t BgL_cz00_14873, obj_t BgL_dz00_14874)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14871;
				long BgL_siza7ezd2framez75_14872;

				BgL_runz00_14871 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14866, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14872 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14866, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17316;

					BgL_sz00_17316 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17317;

						BgL_bpz00_17317 = VECTOR_REF(((obj_t) BgL_sz00_17316), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17317) + BgL_siza7ezd2framez75_14872) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17316))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3695z00_17318;

									BgL_arg3695z00_17318 =
										((long) CINT(BgL_bpz00_17317) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17316), BgL_arg3695z00_17318,
										BgL_cz00_14873);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3697z00_17319;

									BgL_arg3697z00_17319 =
										((long) CINT(BgL_bpz00_17317) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17316), BgL_arg3697z00_17319,
										BgL_dz00_14874);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17320;

									BgL_ez00_17320 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17320,
										BgL_bpz00_17317);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17321;

										BgL_accz00_17321 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14871, BgL_sz00_17316, BgL_bpz00_17317);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17320);
										VECTOR_SET(
											((obj_t) BgL_sz00_17316), ((long) 0), BgL_bpz00_17317);
										return BgL_accz00_17321;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17322;

								BgL_nsz00_17322 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17322, ((long) 1), BgL_sz00_17316);
								VECTOR_SET(BgL_nsz00_17322, ((long) 2), BgL_cz00_14873);
								VECTOR_SET(BgL_nsz00_17322, ((long) 3), BgL_dz00_14874);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17323;

									BgL_z12denvz12_17323 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17323, BgL_nsz00_17322);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17324;

										BgL_ez00_17324 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17324,
											BgL_sz00_17316);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17325;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17326;

												BgL_savedzd2bpzd2_17326 =
													VECTOR_REF(BgL_nsz00_17322, ((long) 0));
												VECTOR_SET(BgL_nsz00_17322, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17328;

													BgL_fz00_17328 = BgL_runz00_14871;
												BgL_recz00_17327:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17329;

														BgL_rz00_17329 =
															PROCEDURE_ENTRY(BgL_fz00_17328) (BgL_fz00_17328,
															BgL_nsz00_17322, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6710z00_29752;

															if (PROCEDUREP(BgL_rz00_17329))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17330;

																	BgL_arg1732z00_17330 =
																		PROCEDURE_ATTR(BgL_rz00_17329);
																	if (STRUCTP(BgL_arg1732z00_17330))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6710z00_29752 =
																				(STRUCT_KEY(BgL_arg1732z00_17330) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6710z00_29752 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6710z00_29752 = ((bool_t) 0);
																}
															if (BgL_test6710z00_29752)
																{
																	obj_t BgL_fz00_29760;

																	BgL_fz00_29760 = BgL_rz00_17329;
																	BgL_fz00_17328 = BgL_fz00_29760;
																	goto BgL_recz00_17327;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17322, ((long) 0),
																		BgL_savedzd2bpzd2_17326);
																	BgL_____rz00_17325 = BgL_rz00_17329;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17324);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17323, BgL_sz00_17316);
											return BgL_____rz00_17325;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5792 */
	obj_t BGl_z62run5792z62zz__evaluate_compz00(obj_t BgL_envz00_14875,
		obj_t BgL_sz00_14880)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14876;
				obj_t BgL_valza2za2_14877;
				BgL_ev_absz00_bglt BgL_i1247z00_14878;
				obj_t BgL_bodyz00_14879;

				BgL_siza7eza7_14876 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14875, (int) (((long) 0))));
				BgL_valza2za2_14877 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14875, (int) (((long) 1))));
				BgL_i1247z00_14878 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14875, (int) (((long) 2))));
				BgL_bodyz00_14879 = PROCEDURE_REF(BgL_envz00_14875, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17331;

					BgL_bpz00_17331 = VECTOR_REF(((obj_t) BgL_sz00_14880), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14880,
						BgL_valza2za2_14877,
						((long) CINT(BgL_bpz00_17331) + BgL_siza7eza7_14876));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17332;
						obj_t BgL_wherez00_17333;
						obj_t BgL_locz00_17334;

						BgL_z12denvz12_17332 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17333 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14878))->
							BgL_wherez00);
						BgL_locz00_17334 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14878))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17332, BgL_wherez00_17333,
								BgL_locz00_17334);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17335;

								BgL_za2za2resza2za2z00_17335 =
									PROCEDURE_ENTRY(BgL_bodyz00_14879) (BgL_bodyz00_14879,
									BgL_sz00_14880, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17332);
								return BgL_za2za2resza2za2z00_17335;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3701> */
	obj_t BGl_z62zc3z04anonymousza33701ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14881, obj_t BgL_sz00_14888)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14882;
				obj_t BgL_iboxesz00_14883;
				long BgL_siza7eza7_14884;
				BgL_ev_absz00_bglt BgL_i1247z00_14885;
				obj_t BgL_bodyz00_14886;
				long BgL_siza7ezd2framez75_14887;

				BgL_ifreesz00_14882 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14881, (int) (((long) 0))));
				BgL_iboxesz00_14883 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14881, (int) (((long) 1))));
				BgL_siza7eza7_14884 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14881, (int) (((long) 2))));
				BgL_i1247z00_14885 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14881, (int) (((long) 3))));
				BgL_bodyz00_14886 = PROCEDURE_REF(BgL_envz00_14881, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14887 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14881, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17336;

					BgL_bpz00_17336 = VECTOR_REF(((obj_t) BgL_sz00_14888), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17337;

						BgL_valza2za2_17337 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14888,
							BgL_bpz00_17336, BgL_ifreesz00_14882);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17338;

							BgL_runz00_17338 =
								MAKE_FX_PROCEDURE(BGl_z62run5794z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17338,
								(int) (((long) 0)), BgL_iboxesz00_14883);
							PROCEDURE_SET(BgL_runz00_17338,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14884));
							PROCEDURE_SET(BgL_runz00_17338,
								(int) (((long) 2)), BgL_valza2za2_17337);
							PROCEDURE_SET(BgL_runz00_17338,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14885));
							PROCEDURE_SET(BgL_runz00_17338,
								(int) (((long) 4)), BgL_bodyz00_14886);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17339;

								BgL_mainz00_17339 =
									MAKE_FX_PROCEDURE(BGl_z62main5793z62zz__evaluate_compz00,
									(int) (((long) 2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17339,
									(int) (((long) 0)), BgL_iboxesz00_14883);
								PROCEDURE_SET(BgL_mainz00_17339,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14884));
								PROCEDURE_SET(BgL_mainz00_17339,
									(int) (((long) 2)), BgL_valza2za2_17337);
								PROCEDURE_SET(BgL_mainz00_17339,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14885));
								PROCEDURE_SET(BgL_mainz00_17339,
									(int) (((long) 4)), BgL_bodyz00_14886);
								PROCEDURE_SET(BgL_mainz00_17339,
									(int) (((long) 5)), BgL_runz00_17338);
								PROCEDURE_SET(BgL_mainz00_17339,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14887));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17340;

									BgL_objz00_17340 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17338, BgL_objz00_17340);
									BgL_objz00_17340;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3702z00_17341;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3703z00_17342;

										BgL_arg3703z00_17342 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14885))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17343;

											BgL_newz00_17343 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29848;

												BgL_tmpz00_29848 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17343, BgL_tmpz00_29848,
													BgL_arg3703z00_17342);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29853;
												int BgL_tmpz00_29851;

												BgL_auxz00_29853 = BINT(BgL_siza7ezd2framez75_14887);
												BgL_tmpz00_29851 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17343, BgL_tmpz00_29851,
													BgL_auxz00_29853);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29856;

												BgL_tmpz00_29856 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17343, BgL_tmpz00_29856,
													BgL_runz00_17338);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29861;
												int BgL_tmpz00_29859;

												BgL_auxz00_29861 = BINT(((long) 2));
												BgL_tmpz00_29859 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17343, BgL_tmpz00_29859,
													BgL_auxz00_29861);
											}
											BgL_arg3702z00_17341 = BgL_newz00_17343;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17339, BgL_arg3702z00_17341);
									BgL_arg3702z00_17341;
								}
								return BgL_mainz00_17339;
							}
						}
					}
				}
			}
		}

	}



/* &main5793 */
	obj_t BGl_z62main5793z62zz__evaluate_compz00(obj_t BgL_envz00_14889,
		obj_t BgL_cz00_14897, obj_t BgL_dz00_14898)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14895;
				long BgL_siza7ezd2framez75_14896;

				BgL_runz00_14895 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14889, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14896 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14889, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17344;

					BgL_sz00_17344 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17345;

						BgL_bpz00_17345 = VECTOR_REF(((obj_t) BgL_sz00_17344), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17345) + BgL_siza7ezd2framez75_14896) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17344))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3706z00_17346;

									BgL_arg3706z00_17346 =
										((long) CINT(BgL_bpz00_17345) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17344), BgL_arg3706z00_17346,
										BgL_cz00_14897);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3708z00_17347;

									BgL_arg3708z00_17347 =
										((long) CINT(BgL_bpz00_17345) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17344), BgL_arg3708z00_17347,
										BgL_dz00_14898);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17348;

									BgL_ez00_17348 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17348,
										BgL_bpz00_17345);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17349;

										BgL_accz00_17349 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14895, BgL_sz00_17344, BgL_bpz00_17345);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17348);
										VECTOR_SET(
											((obj_t) BgL_sz00_17344), ((long) 0), BgL_bpz00_17345);
										return BgL_accz00_17349;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17350;

								BgL_nsz00_17350 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17350, ((long) 1), BgL_sz00_17344);
								VECTOR_SET(BgL_nsz00_17350, ((long) 2), BgL_cz00_14897);
								VECTOR_SET(BgL_nsz00_17350, ((long) 3), BgL_dz00_14898);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17351;

									BgL_z12denvz12_17351 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17351, BgL_nsz00_17350);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17352;

										BgL_ez00_17352 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17352,
											BgL_sz00_17344);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17353;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17354;

												BgL_savedzd2bpzd2_17354 =
													VECTOR_REF(BgL_nsz00_17350, ((long) 0));
												VECTOR_SET(BgL_nsz00_17350, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17356;

													BgL_fz00_17356 = BgL_runz00_14895;
												BgL_recz00_17355:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17357;

														BgL_rz00_17357 =
															PROCEDURE_ENTRY(BgL_fz00_17356) (BgL_fz00_17356,
															BgL_nsz00_17350, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6714z00_29909;

															if (PROCEDUREP(BgL_rz00_17357))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17358;

																	BgL_arg1732z00_17358 =
																		PROCEDURE_ATTR(BgL_rz00_17357);
																	if (STRUCTP(BgL_arg1732z00_17358))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6714z00_29909 =
																				(STRUCT_KEY(BgL_arg1732z00_17358) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6714z00_29909 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6714z00_29909 = ((bool_t) 0);
																}
															if (BgL_test6714z00_29909)
																{
																	obj_t BgL_fz00_29917;

																	BgL_fz00_29917 = BgL_rz00_17357;
																	BgL_fz00_17356 = BgL_fz00_29917;
																	goto BgL_recz00_17355;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17350, ((long) 0),
																		BgL_savedzd2bpzd2_17354);
																	BgL_____rz00_17353 = BgL_rz00_17357;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17352);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17351, BgL_sz00_17344);
											return BgL_____rz00_17353;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5794 */
	obj_t BGl_z62run5794z62zz__evaluate_compz00(obj_t BgL_envz00_14899,
		obj_t BgL_sz00_14905)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14900;
				long BgL_siza7eza7_14901;
				obj_t BgL_valza2za2_14902;
				BgL_ev_absz00_bglt BgL_i1247z00_14903;
				obj_t BgL_bodyz00_14904;

				BgL_iboxesz00_14900 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14899, (int) (((long) 0))));
				BgL_siza7eza7_14901 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14899, (int) (((long) 1))));
				BgL_valza2za2_14902 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14899, (int) (((long) 2))));
				BgL_i1247z00_14903 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14899, (int) (((long) 3))));
				BgL_bodyz00_14904 = PROCEDURE_REF(BgL_envz00_14899, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17359;

					BgL_bpz00_17359 = VECTOR_REF(((obj_t) BgL_sz00_14905), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14905,
						BgL_iboxesz00_14900, BgL_bpz00_17359);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14905,
						BgL_valza2za2_14902,
						((long) CINT(BgL_bpz00_17359) + BgL_siza7eza7_14901));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17360;
						obj_t BgL_wherez00_17361;
						obj_t BgL_locz00_17362;

						BgL_z12denvz12_17360 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17361 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14903))->
							BgL_wherez00);
						BgL_locz00_17362 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14903))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17360, BgL_wherez00_17361,
								BgL_locz00_17362);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17363;

								BgL_za2za2resza2za2z00_17363 =
									PROCEDURE_ENTRY(BgL_bodyz00_14904) (BgL_bodyz00_14904,
									BgL_sz00_14905, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17360);
								return BgL_za2za2resza2za2z00_17363;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3622> */
	obj_t BGl_z62zc3z04anonymousza33622ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14906, obj_t BgL_sz00_14910)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14907;
				obj_t BgL_bodyz00_14908;
				long BgL_siza7ezd2framez75_14909;

				BgL_i1247z00_14907 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14906, (int) (((long) 0))));
				BgL_bodyz00_14908 = PROCEDURE_REF(BgL_envz00_14906, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14909 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14906, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17364;

					BgL_bpz00_17364 = VECTOR_REF(((obj_t) BgL_sz00_14910), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17365;

							BgL_runz00_17365 =
								MAKE_FX_PROCEDURE(BGl_z62run5796z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17365,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14907));
							PROCEDURE_SET(BgL_runz00_17365,
								(int) (((long) 1)), BgL_bodyz00_14908);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17366;

								BgL_mainz00_17366 =
									MAKE_VA_PROCEDURE(BGl_z62main5795z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17366,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14907));
								PROCEDURE_SET(BgL_mainz00_17366,
									(int) (((long) 1)), BgL_bodyz00_14908);
								PROCEDURE_SET(BgL_mainz00_17366,
									(int) (((long) 2)), BgL_runz00_17365);
								PROCEDURE_SET(BgL_mainz00_17366,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14909));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17367;

									BgL_objz00_17367 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17365, BgL_objz00_17367);
									BgL_objz00_17367;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3623z00_17368;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3625z00_17369;

										BgL_arg3625z00_17369 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14907))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17370;

											BgL_newz00_17370 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29985;

												BgL_tmpz00_29985 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17370, BgL_tmpz00_29985,
													BgL_arg3625z00_17369);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29990;
												int BgL_tmpz00_29988;

												BgL_auxz00_29990 = BINT(BgL_siza7ezd2framez75_14909);
												BgL_tmpz00_29988 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17370, BgL_tmpz00_29988,
													BgL_auxz00_29990);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_29993;

												BgL_tmpz00_29993 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17370, BgL_tmpz00_29993,
													BgL_runz00_17365);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_29998;
												int BgL_tmpz00_29996;

												BgL_auxz00_29998 = BINT(((long) -2));
												BgL_tmpz00_29996 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17370, BgL_tmpz00_29996,
													BgL_auxz00_29998);
											}
											BgL_arg3623z00_17368 = BgL_newz00_17370;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17366, BgL_arg3623z00_17368);
									BgL_arg3623z00_17368;
								}
								return BgL_mainz00_17366;
							}
						}
					}
				}
			}
		}

	}



/* &main5795 */
	obj_t BGl_z62main5795z62zz__evaluate_compz00(obj_t BgL_envz00_14911,
		obj_t BgL_dz00_14916, obj_t BgL_lastz00_14917)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14914;
				long BgL_siza7ezd2framez75_14915;

				BgL_runz00_14914 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14911, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14915 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14911, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17371;

					BgL_sz00_17371 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17372;

						BgL_bpz00_17372 = VECTOR_REF(((obj_t) BgL_sz00_17371), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17372) + BgL_siza7ezd2framez75_14915) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17371))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3628z00_17373;

									BgL_arg3628z00_17373 =
										((long) CINT(BgL_bpz00_17372) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17371), BgL_arg3628z00_17373,
										BgL_dz00_14916);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3629z00_17374;

									BgL_arg3629z00_17374 =
										((long) CINT(BgL_bpz00_17372) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17371), BgL_arg3629z00_17374,
										BgL_lastz00_14917);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17375;

									BgL_ez00_17375 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17375,
										BgL_bpz00_17372);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17376;

										BgL_accz00_17376 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14914, BgL_sz00_17371, BgL_bpz00_17372);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17375);
										VECTOR_SET(
											((obj_t) BgL_sz00_17371), ((long) 0), BgL_bpz00_17372);
										return BgL_accz00_17376;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17377;

								BgL_nsz00_17377 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17377, ((long) 1), BgL_sz00_17371);
								VECTOR_SET(BgL_nsz00_17377, ((long) 2), BgL_dz00_14916);
								VECTOR_SET(BgL_nsz00_17377, ((long) 3), BgL_lastz00_14917);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17378;

									BgL_z12denvz12_17378 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17378, BgL_nsz00_17377);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17379;

										BgL_ez00_17379 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17379,
											BgL_sz00_17371);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17380;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17381;

												BgL_savedzd2bpzd2_17381 =
													VECTOR_REF(BgL_nsz00_17377, ((long) 0));
												VECTOR_SET(BgL_nsz00_17377, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17383;

													BgL_fz00_17383 = BgL_runz00_14914;
												BgL_recz00_17382:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17384;

														BgL_rz00_17384 =
															PROCEDURE_ENTRY(BgL_fz00_17383) (BgL_fz00_17383,
															BgL_nsz00_17377, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6718z00_30046;

															if (PROCEDUREP(BgL_rz00_17384))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17385;

																	BgL_arg1732z00_17385 =
																		PROCEDURE_ATTR(BgL_rz00_17384);
																	if (STRUCTP(BgL_arg1732z00_17385))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6718z00_30046 =
																				(STRUCT_KEY(BgL_arg1732z00_17385) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6718z00_30046 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6718z00_30046 = ((bool_t) 0);
																}
															if (BgL_test6718z00_30046)
																{
																	obj_t BgL_fz00_30054;

																	BgL_fz00_30054 = BgL_rz00_17384;
																	BgL_fz00_17383 = BgL_fz00_30054;
																	goto BgL_recz00_17382;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17377, ((long) 0),
																		BgL_savedzd2bpzd2_17381);
																	BgL_____rz00_17380 = BgL_rz00_17384;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17379);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17378, BgL_sz00_17371);
											return BgL_____rz00_17380;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5796 */
	obj_t BGl_z62run5796z62zz__evaluate_compz00(obj_t BgL_envz00_14918,
		obj_t BgL_sz00_14921)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14919;
				obj_t BgL_bodyz00_14920;

				BgL_i1247z00_14919 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14918, (int) (((long) 0))));
				BgL_bodyz00_14920 = PROCEDURE_REF(BgL_envz00_14918, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17386;

					BgL_bpz00_17386 = VECTOR_REF(((obj_t) BgL_sz00_14921), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17387;
						obj_t BgL_wherez00_17388;
						obj_t BgL_locz00_17389;

						BgL_z12denvz12_17387 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17388 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14919))->
							BgL_wherez00);
						BgL_locz00_17389 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14919))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17387, BgL_wherez00_17388,
								BgL_locz00_17389);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17390;

								BgL_za2za2resza2za2z00_17390 =
									PROCEDURE_ENTRY(BgL_bodyz00_14920) (BgL_bodyz00_14920,
									BgL_sz00_14921, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17387);
								return BgL_za2za2resza2za2z00_17390;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3631> */
	obj_t BGl_z62zc3z04anonymousza33631ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14922, obj_t BgL_sz00_14927)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14923;
				BgL_ev_absz00_bglt BgL_i1247z00_14924;
				obj_t BgL_bodyz00_14925;
				long BgL_siza7ezd2framez75_14926;

				BgL_iboxesz00_14923 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14922, (int) (((long) 0))));
				BgL_i1247z00_14924 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14922, (int) (((long) 1))));
				BgL_bodyz00_14925 = PROCEDURE_REF(BgL_envz00_14922, (int) (((long) 2)));
				BgL_siza7ezd2framez75_14926 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14922, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17391;

					BgL_bpz00_17391 = VECTOR_REF(((obj_t) BgL_sz00_14927), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17392;

							BgL_runz00_17392 =
								MAKE_FX_PROCEDURE(BGl_z62run5798z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17392,
								(int) (((long) 0)), BgL_iboxesz00_14923);
							PROCEDURE_SET(BgL_runz00_17392,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_14924));
							PROCEDURE_SET(BgL_runz00_17392,
								(int) (((long) 2)), BgL_bodyz00_14925);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17393;

								BgL_mainz00_17393 =
									MAKE_VA_PROCEDURE(BGl_z62main5797z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 0)), BgL_iboxesz00_14923);
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_14924));
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 2)), BgL_bodyz00_14925);
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 3)), BgL_runz00_17392);
								PROCEDURE_SET(BgL_mainz00_17393,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_14926));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17394;

									BgL_objz00_17394 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17392, BgL_objz00_17394);
									BgL_objz00_17394;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3632z00_17395;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3634z00_17396;

										BgL_arg3634z00_17396 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14924))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17397;

											BgL_newz00_17397 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30116;

												BgL_tmpz00_30116 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17397, BgL_tmpz00_30116,
													BgL_arg3634z00_17396);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30121;
												int BgL_tmpz00_30119;

												BgL_auxz00_30121 = BINT(BgL_siza7ezd2framez75_14926);
												BgL_tmpz00_30119 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17397, BgL_tmpz00_30119,
													BgL_auxz00_30121);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30124;

												BgL_tmpz00_30124 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17397, BgL_tmpz00_30124,
													BgL_runz00_17392);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30129;
												int BgL_tmpz00_30127;

												BgL_auxz00_30129 = BINT(((long) -2));
												BgL_tmpz00_30127 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17397, BgL_tmpz00_30127,
													BgL_auxz00_30129);
											}
											BgL_arg3632z00_17395 = BgL_newz00_17397;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17393, BgL_arg3632z00_17395);
									BgL_arg3632z00_17395;
								}
								return BgL_mainz00_17393;
							}
						}
					}
				}
			}
		}

	}



/* &main5797 */
	obj_t BGl_z62main5797z62zz__evaluate_compz00(obj_t BgL_envz00_14928,
		obj_t BgL_dz00_14934, obj_t BgL_lastz00_14935)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14932;
				long BgL_siza7ezd2framez75_14933;

				BgL_runz00_14932 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14928, (int) (((long) 3))));
				BgL_siza7ezd2framez75_14933 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14928, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17398;

					BgL_sz00_17398 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17399;

						BgL_bpz00_17399 = VECTOR_REF(((obj_t) BgL_sz00_17398), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17399) + BgL_siza7ezd2framez75_14933) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17398))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3637z00_17400;

									BgL_arg3637z00_17400 =
										((long) CINT(BgL_bpz00_17399) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17398), BgL_arg3637z00_17400,
										BgL_dz00_14934);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3638z00_17401;

									BgL_arg3638z00_17401 =
										((long) CINT(BgL_bpz00_17399) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17398), BgL_arg3638z00_17401,
										BgL_lastz00_14935);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17402;

									BgL_ez00_17402 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17402,
										BgL_bpz00_17399);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17403;

										BgL_accz00_17403 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14932, BgL_sz00_17398, BgL_bpz00_17399);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17402);
										VECTOR_SET(
											((obj_t) BgL_sz00_17398), ((long) 0), BgL_bpz00_17399);
										return BgL_accz00_17403;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17404;

								BgL_nsz00_17404 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17404, ((long) 1), BgL_sz00_17398);
								VECTOR_SET(BgL_nsz00_17404, ((long) 2), BgL_dz00_14934);
								VECTOR_SET(BgL_nsz00_17404, ((long) 3), BgL_lastz00_14935);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17405;

									BgL_z12denvz12_17405 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17405, BgL_nsz00_17404);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17406;

										BgL_ez00_17406 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17406,
											BgL_sz00_17398);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17407;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17408;

												BgL_savedzd2bpzd2_17408 =
													VECTOR_REF(BgL_nsz00_17404, ((long) 0));
												VECTOR_SET(BgL_nsz00_17404, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17410;

													BgL_fz00_17410 = BgL_runz00_14932;
												BgL_recz00_17409:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17411;

														BgL_rz00_17411 =
															PROCEDURE_ENTRY(BgL_fz00_17410) (BgL_fz00_17410,
															BgL_nsz00_17404, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6722z00_30177;

															if (PROCEDUREP(BgL_rz00_17411))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17412;

																	BgL_arg1732z00_17412 =
																		PROCEDURE_ATTR(BgL_rz00_17411);
																	if (STRUCTP(BgL_arg1732z00_17412))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6722z00_30177 =
																				(STRUCT_KEY(BgL_arg1732z00_17412) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6722z00_30177 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6722z00_30177 = ((bool_t) 0);
																}
															if (BgL_test6722z00_30177)
																{
																	obj_t BgL_fz00_30185;

																	BgL_fz00_30185 = BgL_rz00_17411;
																	BgL_fz00_17410 = BgL_fz00_30185;
																	goto BgL_recz00_17409;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17404, ((long) 0),
																		BgL_savedzd2bpzd2_17408);
																	BgL_____rz00_17407 = BgL_rz00_17411;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17406);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17405, BgL_sz00_17398);
											return BgL_____rz00_17407;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5798 */
	obj_t BGl_z62run5798z62zz__evaluate_compz00(obj_t BgL_envz00_14936,
		obj_t BgL_sz00_14940)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14937;
				BgL_ev_absz00_bglt BgL_i1247z00_14938;
				obj_t BgL_bodyz00_14939;

				BgL_iboxesz00_14937 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14936, (int) (((long) 0))));
				BgL_i1247z00_14938 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14936, (int) (((long) 1))));
				BgL_bodyz00_14939 = PROCEDURE_REF(BgL_envz00_14936, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17413;

					BgL_bpz00_17413 = VECTOR_REF(((obj_t) BgL_sz00_14940), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14940,
						BgL_iboxesz00_14937, BgL_bpz00_17413);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17414;
						obj_t BgL_wherez00_17415;
						obj_t BgL_locz00_17416;

						BgL_z12denvz12_17414 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17415 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14938))->
							BgL_wherez00);
						BgL_locz00_17416 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14938))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17414, BgL_wherez00_17415,
								BgL_locz00_17416);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17417;

								BgL_za2za2resza2za2z00_17417 =
									PROCEDURE_ENTRY(BgL_bodyz00_14939) (BgL_bodyz00_14939,
									BgL_sz00_14940, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17414);
								return BgL_za2za2resza2za2z00_17417;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3643> */
	obj_t BGl_z62zc3z04anonymousza33643ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14941, obj_t BgL_sz00_14947)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14942;
				long BgL_siza7eza7_14943;
				BgL_ev_absz00_bglt BgL_i1247z00_14944;
				obj_t BgL_bodyz00_14945;
				long BgL_siza7ezd2framez75_14946;

				BgL_ifreesz00_14942 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14941, (int) (((long) 0))));
				BgL_siza7eza7_14943 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14941, (int) (((long) 1))));
				BgL_i1247z00_14944 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14941, (int) (((long) 2))));
				BgL_bodyz00_14945 = PROCEDURE_REF(BgL_envz00_14941, (int) (((long) 3)));
				BgL_siza7ezd2framez75_14946 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14941, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17418;

					BgL_bpz00_17418 = VECTOR_REF(((obj_t) BgL_sz00_14947), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17419;

						BgL_valza2za2_17419 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14947,
							BgL_bpz00_17418, BgL_ifreesz00_14942);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17420;

							BgL_runz00_17420 =
								MAKE_FX_PROCEDURE(BGl_z62run5800z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 0)), BINT(BgL_siza7eza7_14943));
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 1)), BgL_valza2za2_17419);
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_14944));
							PROCEDURE_SET(BgL_runz00_17420,
								(int) (((long) 3)), BgL_bodyz00_14945);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17421;

								BgL_mainz00_17421 =
									MAKE_VA_PROCEDURE(BGl_z62main5799z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 0)), BINT(BgL_siza7eza7_14943));
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 1)), BgL_valza2za2_17419);
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_14944));
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 3)), BgL_bodyz00_14945);
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 4)), BgL_runz00_17420);
								PROCEDURE_SET(BgL_mainz00_17421,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_14946));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17422;

									BgL_objz00_17422 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17420, BgL_objz00_17422);
									BgL_objz00_17422;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3644z00_17423;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3646z00_17424;

										BgL_arg3646z00_17424 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14944))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17425;

											BgL_newz00_17425 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30261;

												BgL_tmpz00_30261 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17425, BgL_tmpz00_30261,
													BgL_arg3646z00_17424);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30266;
												int BgL_tmpz00_30264;

												BgL_auxz00_30266 = BINT(BgL_siza7ezd2framez75_14946);
												BgL_tmpz00_30264 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17425, BgL_tmpz00_30264,
													BgL_auxz00_30266);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30269;

												BgL_tmpz00_30269 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17425, BgL_tmpz00_30269,
													BgL_runz00_17420);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30274;
												int BgL_tmpz00_30272;

												BgL_auxz00_30274 = BINT(((long) -2));
												BgL_tmpz00_30272 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17425, BgL_tmpz00_30272,
													BgL_auxz00_30274);
											}
											BgL_arg3644z00_17423 = BgL_newz00_17425;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17421, BgL_arg3644z00_17423);
									BgL_arg3644z00_17423;
								}
								return BgL_mainz00_17421;
							}
						}
					}
				}
			}
		}

	}



/* &main5799 */
	obj_t BGl_z62main5799z62zz__evaluate_compz00(obj_t BgL_envz00_14948,
		obj_t BgL_dz00_14955, obj_t BgL_lastz00_14956)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14953;
				long BgL_siza7ezd2framez75_14954;

				BgL_runz00_14953 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14948, (int) (((long) 4))));
				BgL_siza7ezd2framez75_14954 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14948, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17426;

					BgL_sz00_17426 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17427;

						BgL_bpz00_17427 = VECTOR_REF(((obj_t) BgL_sz00_17426), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17427) + BgL_siza7ezd2framez75_14954) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17426))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3649z00_17428;

									BgL_arg3649z00_17428 =
										((long) CINT(BgL_bpz00_17427) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17426), BgL_arg3649z00_17428,
										BgL_dz00_14955);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3650z00_17429;

									BgL_arg3650z00_17429 =
										((long) CINT(BgL_bpz00_17427) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17426), BgL_arg3650z00_17429,
										BgL_lastz00_14956);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17430;

									BgL_ez00_17430 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17430,
										BgL_bpz00_17427);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17431;

										BgL_accz00_17431 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14953, BgL_sz00_17426, BgL_bpz00_17427);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17430);
										VECTOR_SET(
											((obj_t) BgL_sz00_17426), ((long) 0), BgL_bpz00_17427);
										return BgL_accz00_17431;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17432;

								BgL_nsz00_17432 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17432, ((long) 1), BgL_sz00_17426);
								VECTOR_SET(BgL_nsz00_17432, ((long) 2), BgL_dz00_14955);
								VECTOR_SET(BgL_nsz00_17432, ((long) 3), BgL_lastz00_14956);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17433;

									BgL_z12denvz12_17433 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17433, BgL_nsz00_17432);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17434;

										BgL_ez00_17434 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17434,
											BgL_sz00_17426);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17435;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17436;

												BgL_savedzd2bpzd2_17436 =
													VECTOR_REF(BgL_nsz00_17432, ((long) 0));
												VECTOR_SET(BgL_nsz00_17432, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17438;

													BgL_fz00_17438 = BgL_runz00_14953;
												BgL_recz00_17437:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17439;

														BgL_rz00_17439 =
															PROCEDURE_ENTRY(BgL_fz00_17438) (BgL_fz00_17438,
															BgL_nsz00_17432, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6726z00_30322;

															if (PROCEDUREP(BgL_rz00_17439))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17440;

																	BgL_arg1732z00_17440 =
																		PROCEDURE_ATTR(BgL_rz00_17439);
																	if (STRUCTP(BgL_arg1732z00_17440))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6726z00_30322 =
																				(STRUCT_KEY(BgL_arg1732z00_17440) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6726z00_30322 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6726z00_30322 = ((bool_t) 0);
																}
															if (BgL_test6726z00_30322)
																{
																	obj_t BgL_fz00_30330;

																	BgL_fz00_30330 = BgL_rz00_17439;
																	BgL_fz00_17438 = BgL_fz00_30330;
																	goto BgL_recz00_17437;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17432, ((long) 0),
																		BgL_savedzd2bpzd2_17436);
																	BgL_____rz00_17435 = BgL_rz00_17439;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17434);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17433, BgL_sz00_17426);
											return BgL_____rz00_17435;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5800 */
	obj_t BGl_z62run5800z62zz__evaluate_compz00(obj_t BgL_envz00_14957,
		obj_t BgL_sz00_14962)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_14958;
				obj_t BgL_valza2za2_14959;
				BgL_ev_absz00_bglt BgL_i1247z00_14960;
				obj_t BgL_bodyz00_14961;

				BgL_siza7eza7_14958 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14957, (int) (((long) 0))));
				BgL_valza2za2_14959 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14957, (int) (((long) 1))));
				BgL_i1247z00_14960 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14957, (int) (((long) 2))));
				BgL_bodyz00_14961 = PROCEDURE_REF(BgL_envz00_14957, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17441;

					BgL_bpz00_17441 = VECTOR_REF(((obj_t) BgL_sz00_14962), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14962,
						BgL_valza2za2_14959,
						((long) CINT(BgL_bpz00_17441) + BgL_siza7eza7_14958));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17442;
						obj_t BgL_wherez00_17443;
						obj_t BgL_locz00_17444;

						BgL_z12denvz12_17442 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17443 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14960))->
							BgL_wherez00);
						BgL_locz00_17444 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14960))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17442, BgL_wherez00_17443,
								BgL_locz00_17444);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17445;

								BgL_za2za2resza2za2z00_17445 =
									PROCEDURE_ENTRY(BgL_bodyz00_14961) (BgL_bodyz00_14961,
									BgL_sz00_14962, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17442);
								return BgL_za2za2resza2za2z00_17445;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3653> */
	obj_t BGl_z62zc3z04anonymousza33653ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14963, obj_t BgL_sz00_14970)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_14964;
				obj_t BgL_iboxesz00_14965;
				long BgL_siza7eza7_14966;
				BgL_ev_absz00_bglt BgL_i1247z00_14967;
				obj_t BgL_bodyz00_14968;
				long BgL_siza7ezd2framez75_14969;

				BgL_ifreesz00_14964 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14963, (int) (((long) 0))));
				BgL_iboxesz00_14965 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14963, (int) (((long) 1))));
				BgL_siza7eza7_14966 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14963, (int) (((long) 2))));
				BgL_i1247z00_14967 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14963, (int) (((long) 3))));
				BgL_bodyz00_14968 = PROCEDURE_REF(BgL_envz00_14963, (int) (((long) 4)));
				BgL_siza7ezd2framez75_14969 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14963, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17446;

					BgL_bpz00_17446 = VECTOR_REF(((obj_t) BgL_sz00_14970), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17447;

						BgL_valza2za2_17447 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_14970,
							BgL_bpz00_17446, BgL_ifreesz00_14964);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17448;

							BgL_runz00_17448 =
								MAKE_FX_PROCEDURE(BGl_z62run5802z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17448,
								(int) (((long) 0)), BgL_iboxesz00_14965);
							PROCEDURE_SET(BgL_runz00_17448,
								(int) (((long) 1)), BINT(BgL_siza7eza7_14966));
							PROCEDURE_SET(BgL_runz00_17448,
								(int) (((long) 2)), BgL_valza2za2_17447);
							PROCEDURE_SET(BgL_runz00_17448,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_14967));
							PROCEDURE_SET(BgL_runz00_17448,
								(int) (((long) 4)), BgL_bodyz00_14968);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17449;

								BgL_mainz00_17449 =
									MAKE_VA_PROCEDURE(BGl_z62main5801z62zz__evaluate_compz00,
									(int) (((long) -2)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17449,
									(int) (((long) 0)), BgL_iboxesz00_14965);
								PROCEDURE_SET(BgL_mainz00_17449,
									(int) (((long) 1)), BINT(BgL_siza7eza7_14966));
								PROCEDURE_SET(BgL_mainz00_17449,
									(int) (((long) 2)), BgL_valza2za2_17447);
								PROCEDURE_SET(BgL_mainz00_17449,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_14967));
								PROCEDURE_SET(BgL_mainz00_17449,
									(int) (((long) 4)), BgL_bodyz00_14968);
								PROCEDURE_SET(BgL_mainz00_17449,
									(int) (((long) 5)), BgL_runz00_17448);
								PROCEDURE_SET(BgL_mainz00_17449,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_14969));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17450;

									BgL_objz00_17450 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17448, BgL_objz00_17450);
									BgL_objz00_17450;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3654z00_17451;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3655z00_17452;

										BgL_arg3655z00_17452 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14967))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17453;

											BgL_newz00_17453 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30418;

												BgL_tmpz00_30418 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17453, BgL_tmpz00_30418,
													BgL_arg3655z00_17452);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30423;
												int BgL_tmpz00_30421;

												BgL_auxz00_30423 = BINT(BgL_siza7ezd2framez75_14969);
												BgL_tmpz00_30421 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17453, BgL_tmpz00_30421,
													BgL_auxz00_30423);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30426;

												BgL_tmpz00_30426 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17453, BgL_tmpz00_30426,
													BgL_runz00_17448);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30431;
												int BgL_tmpz00_30429;

												BgL_auxz00_30431 = BINT(((long) -2));
												BgL_tmpz00_30429 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17453, BgL_tmpz00_30429,
													BgL_auxz00_30431);
											}
											BgL_arg3654z00_17451 = BgL_newz00_17453;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17449, BgL_arg3654z00_17451);
									BgL_arg3654z00_17451;
								}
								return BgL_mainz00_17449;
							}
						}
					}
				}
			}
		}

	}



/* &main5801 */
	obj_t BGl_z62main5801z62zz__evaluate_compz00(obj_t BgL_envz00_14971,
		obj_t BgL_dz00_14979, obj_t BgL_lastz00_14980)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14977;
				long BgL_siza7ezd2framez75_14978;

				BgL_runz00_14977 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14971, (int) (((long) 5))));
				BgL_siza7ezd2framez75_14978 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14971, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17454;

					BgL_sz00_17454 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17455;

						BgL_bpz00_17455 = VECTOR_REF(((obj_t) BgL_sz00_17454), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17455) + BgL_siza7ezd2framez75_14978) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17454))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3659z00_17456;

									BgL_arg3659z00_17456 =
										((long) CINT(BgL_bpz00_17455) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17454), BgL_arg3659z00_17456,
										BgL_dz00_14979);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3660z00_17457;

									BgL_arg3660z00_17457 =
										((long) CINT(BgL_bpz00_17455) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17454), BgL_arg3660z00_17457,
										BgL_lastz00_14980);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17458;

									BgL_ez00_17458 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17458,
										BgL_bpz00_17455);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17459;

										BgL_accz00_17459 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14977, BgL_sz00_17454, BgL_bpz00_17455);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17458);
										VECTOR_SET(
											((obj_t) BgL_sz00_17454), ((long) 0), BgL_bpz00_17455);
										return BgL_accz00_17459;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17460;

								BgL_nsz00_17460 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17460, ((long) 1), BgL_sz00_17454);
								VECTOR_SET(BgL_nsz00_17460, ((long) 2), BgL_dz00_14979);
								VECTOR_SET(BgL_nsz00_17460, ((long) 3), BgL_lastz00_14980);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17461;

									BgL_z12denvz12_17461 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17461, BgL_nsz00_17460);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17462;

										BgL_ez00_17462 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17462,
											BgL_sz00_17454);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17463;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17464;

												BgL_savedzd2bpzd2_17464 =
													VECTOR_REF(BgL_nsz00_17460, ((long) 0));
												VECTOR_SET(BgL_nsz00_17460, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17466;

													BgL_fz00_17466 = BgL_runz00_14977;
												BgL_recz00_17465:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17467;

														BgL_rz00_17467 =
															PROCEDURE_ENTRY(BgL_fz00_17466) (BgL_fz00_17466,
															BgL_nsz00_17460, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6730z00_30479;

															if (PROCEDUREP(BgL_rz00_17467))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17468;

																	BgL_arg1732z00_17468 =
																		PROCEDURE_ATTR(BgL_rz00_17467);
																	if (STRUCTP(BgL_arg1732z00_17468))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6730z00_30479 =
																				(STRUCT_KEY(BgL_arg1732z00_17468) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6730z00_30479 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6730z00_30479 = ((bool_t) 0);
																}
															if (BgL_test6730z00_30479)
																{
																	obj_t BgL_fz00_30487;

																	BgL_fz00_30487 = BgL_rz00_17467;
																	BgL_fz00_17466 = BgL_fz00_30487;
																	goto BgL_recz00_17465;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17460, ((long) 0),
																		BgL_savedzd2bpzd2_17464);
																	BgL_____rz00_17463 = BgL_rz00_17467;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17462);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17461, BgL_sz00_17454);
											return BgL_____rz00_17463;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5802 */
	obj_t BGl_z62run5802z62zz__evaluate_compz00(obj_t BgL_envz00_14981,
		obj_t BgL_sz00_14987)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_14982;
				long BgL_siza7eza7_14983;
				obj_t BgL_valza2za2_14984;
				BgL_ev_absz00_bglt BgL_i1247z00_14985;
				obj_t BgL_bodyz00_14986;

				BgL_iboxesz00_14982 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 0))));
				BgL_siza7eza7_14983 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 1))));
				BgL_valza2za2_14984 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 2))));
				BgL_i1247z00_14985 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 3))));
				BgL_bodyz00_14986 = PROCEDURE_REF(BgL_envz00_14981, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17469;

					BgL_bpz00_17469 = VECTOR_REF(((obj_t) BgL_sz00_14987), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_14987,
						BgL_iboxesz00_14982, BgL_bpz00_17469);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_14987,
						BgL_valza2za2_14984,
						((long) CINT(BgL_bpz00_17469) + BgL_siza7eza7_14983));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17470;
						obj_t BgL_wherez00_17471;
						obj_t BgL_locz00_17472;

						BgL_z12denvz12_17470 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17471 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14985))->
							BgL_wherez00);
						BgL_locz00_17472 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14985))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17470, BgL_wherez00_17471,
								BgL_locz00_17472);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17473;

								BgL_za2za2resza2za2z00_17473 =
									PROCEDURE_ENTRY(BgL_bodyz00_14986) (BgL_bodyz00_14986,
									BgL_sz00_14987, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17470);
								return BgL_za2za2resza2za2z00_17473;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3575> */
	obj_t BGl_z62zc3z04anonymousza33575ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_14988, obj_t BgL_sz00_14992)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_14989;
				obj_t BgL_bodyz00_14990;
				long BgL_siza7ezd2framez75_14991;

				BgL_i1247z00_14989 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14988, (int) (((long) 0))));
				BgL_bodyz00_14990 = PROCEDURE_REF(BgL_envz00_14988, (int) (((long) 1)));
				BgL_siza7ezd2framez75_14991 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14988, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17474;

					BgL_bpz00_17474 = VECTOR_REF(((obj_t) BgL_sz00_14992), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17475;

							BgL_runz00_17475 =
								MAKE_FX_PROCEDURE(BGl_z62run5804z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17475,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_14989));
							PROCEDURE_SET(BgL_runz00_17475,
								(int) (((long) 1)), BgL_bodyz00_14990);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17476;

								BgL_mainz00_17476 =
									MAKE_FX_PROCEDURE(BGl_z62main5803z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17476,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_14989));
								PROCEDURE_SET(BgL_mainz00_17476,
									(int) (((long) 1)), BgL_bodyz00_14990);
								PROCEDURE_SET(BgL_mainz00_17476,
									(int) (((long) 2)), BgL_runz00_17475);
								PROCEDURE_SET(BgL_mainz00_17476,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_14991));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17477;

									BgL_objz00_17477 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17475, BgL_objz00_17477);
									BgL_objz00_17477;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3577z00_17478;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3578z00_17479;

										BgL_arg3578z00_17479 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_14989))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17480;

											BgL_newz00_17480 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30555;

												BgL_tmpz00_30555 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17480, BgL_tmpz00_30555,
													BgL_arg3578z00_17479);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30560;
												int BgL_tmpz00_30558;

												BgL_auxz00_30560 = BINT(BgL_siza7ezd2framez75_14991);
												BgL_tmpz00_30558 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17480, BgL_tmpz00_30558,
													BgL_auxz00_30560);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30563;

												BgL_tmpz00_30563 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17480, BgL_tmpz00_30563,
													BgL_runz00_17475);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30568;
												int BgL_tmpz00_30566;

												BgL_auxz00_30568 = BINT(((long) 1));
												BgL_tmpz00_30566 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17480, BgL_tmpz00_30566,
													BgL_auxz00_30568);
											}
											BgL_arg3577z00_17478 = BgL_newz00_17480;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17476, BgL_arg3577z00_17478);
									BgL_arg3577z00_17478;
								}
								return BgL_mainz00_17476;
							}
						}
					}
				}
			}
		}

	}



/* &main5803 */
	obj_t BGl_z62main5803z62zz__evaluate_compz00(obj_t BgL_envz00_14993,
		obj_t BgL_dz00_14998)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_14996;
				long BgL_siza7ezd2framez75_14997;

				BgL_runz00_14996 =
					((obj_t) PROCEDURE_REF(BgL_envz00_14993, (int) (((long) 2))));
				BgL_siza7ezd2framez75_14997 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_14993, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17481;

					BgL_sz00_17481 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17482;

						BgL_bpz00_17482 = VECTOR_REF(((obj_t) BgL_sz00_17481), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17482) + BgL_siza7ezd2framez75_14997) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17481))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3582z00_17483;

									BgL_arg3582z00_17483 =
										((long) CINT(BgL_bpz00_17482) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17481), BgL_arg3582z00_17483,
										BgL_dz00_14998);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17484;

									BgL_ez00_17484 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17484,
										BgL_bpz00_17482);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17485;

										BgL_accz00_17485 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_14996, BgL_sz00_17481, BgL_bpz00_17482);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17484);
										VECTOR_SET(
											((obj_t) BgL_sz00_17481), ((long) 0), BgL_bpz00_17482);
										return BgL_accz00_17485;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17486;

								BgL_nsz00_17486 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17486, ((long) 1), BgL_sz00_17481);
								VECTOR_SET(BgL_nsz00_17486, ((long) 2), BgL_dz00_14998);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17487;

									BgL_z12denvz12_17487 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17487, BgL_nsz00_17486);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17488;

										BgL_ez00_17488 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17488,
											BgL_sz00_17481);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17489;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17490;

												BgL_savedzd2bpzd2_17490 =
													VECTOR_REF(BgL_nsz00_17486, ((long) 0));
												VECTOR_SET(BgL_nsz00_17486, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17492;

													BgL_fz00_17492 = BgL_runz00_14996;
												BgL_recz00_17491:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17493;

														BgL_rz00_17493 =
															PROCEDURE_ENTRY(BgL_fz00_17492) (BgL_fz00_17492,
															BgL_nsz00_17486, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6734z00_30611;

															if (PROCEDUREP(BgL_rz00_17493))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17494;

																	BgL_arg1732z00_17494 =
																		PROCEDURE_ATTR(BgL_rz00_17493);
																	if (STRUCTP(BgL_arg1732z00_17494))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6734z00_30611 =
																				(STRUCT_KEY(BgL_arg1732z00_17494) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6734z00_30611 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6734z00_30611 = ((bool_t) 0);
																}
															if (BgL_test6734z00_30611)
																{
																	obj_t BgL_fz00_30619;

																	BgL_fz00_30619 = BgL_rz00_17493;
																	BgL_fz00_17492 = BgL_fz00_30619;
																	goto BgL_recz00_17491;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17486, ((long) 0),
																		BgL_savedzd2bpzd2_17490);
																	BgL_____rz00_17489 = BgL_rz00_17493;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17488);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17487, BgL_sz00_17481);
											return BgL_____rz00_17489;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5804 */
	obj_t BGl_z62run5804z62zz__evaluate_compz00(obj_t BgL_envz00_14999,
		obj_t BgL_sz00_15002)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15000;
				obj_t BgL_bodyz00_15001;

				BgL_i1247z00_15000 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_14999, (int) (((long) 0))));
				BgL_bodyz00_15001 = PROCEDURE_REF(BgL_envz00_14999, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17495;

					BgL_bpz00_17495 = VECTOR_REF(((obj_t) BgL_sz00_15002), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17496;
						obj_t BgL_wherez00_17497;
						obj_t BgL_locz00_17498;

						BgL_z12denvz12_17496 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17497 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15000))->
							BgL_wherez00);
						BgL_locz00_17498 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15000))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17496, BgL_wherez00_17497,
								BgL_locz00_17498);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17499;

								BgL_za2za2resza2za2z00_17499 =
									PROCEDURE_ENTRY(BgL_bodyz00_15001) (BgL_bodyz00_15001,
									BgL_sz00_15002, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17496);
								return BgL_za2za2resza2za2z00_17499;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3584> */
	obj_t BGl_z62zc3z04anonymousza33584ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15003, obj_t BgL_sz00_15008)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15004;
				BgL_ev_absz00_bglt BgL_i1247z00_15005;
				obj_t BgL_bodyz00_15006;
				long BgL_siza7ezd2framez75_15007;

				BgL_iboxesz00_15004 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15003, (int) (((long) 0))));
				BgL_i1247z00_15005 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15003, (int) (((long) 1))));
				BgL_bodyz00_15006 = PROCEDURE_REF(BgL_envz00_15003, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15007 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15003, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17500;

					BgL_bpz00_17500 = VECTOR_REF(((obj_t) BgL_sz00_15008), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17501;

							BgL_runz00_17501 =
								MAKE_FX_PROCEDURE(BGl_z62run5806z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17501,
								(int) (((long) 0)), BgL_iboxesz00_15004);
							PROCEDURE_SET(BgL_runz00_17501,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15005));
							PROCEDURE_SET(BgL_runz00_17501,
								(int) (((long) 2)), BgL_bodyz00_15006);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17502;

								BgL_mainz00_17502 =
									MAKE_FX_PROCEDURE(BGl_z62main5805z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17502,
									(int) (((long) 0)), BgL_iboxesz00_15004);
								PROCEDURE_SET(BgL_mainz00_17502,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15005));
								PROCEDURE_SET(BgL_mainz00_17502,
									(int) (((long) 2)), BgL_bodyz00_15006);
								PROCEDURE_SET(BgL_mainz00_17502,
									(int) (((long) 3)), BgL_runz00_17501);
								PROCEDURE_SET(BgL_mainz00_17502,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15007));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17503;

									BgL_objz00_17503 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17501, BgL_objz00_17503);
									BgL_objz00_17503;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3586z00_17504;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3587z00_17505;

										BgL_arg3587z00_17505 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15005))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17506;

											BgL_newz00_17506 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30681;

												BgL_tmpz00_30681 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17506, BgL_tmpz00_30681,
													BgL_arg3587z00_17505);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30686;
												int BgL_tmpz00_30684;

												BgL_auxz00_30686 = BINT(BgL_siza7ezd2framez75_15007);
												BgL_tmpz00_30684 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17506, BgL_tmpz00_30684,
													BgL_auxz00_30686);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30689;

												BgL_tmpz00_30689 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17506, BgL_tmpz00_30689,
													BgL_runz00_17501);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30694;
												int BgL_tmpz00_30692;

												BgL_auxz00_30694 = BINT(((long) 1));
												BgL_tmpz00_30692 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17506, BgL_tmpz00_30692,
													BgL_auxz00_30694);
											}
											BgL_arg3586z00_17504 = BgL_newz00_17506;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17502, BgL_arg3586z00_17504);
									BgL_arg3586z00_17504;
								}
								return BgL_mainz00_17502;
							}
						}
					}
				}
			}
		}

	}



/* &main5805 */
	obj_t BGl_z62main5805z62zz__evaluate_compz00(obj_t BgL_envz00_15009,
		obj_t BgL_dz00_15015)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15013;
				long BgL_siza7ezd2framez75_15014;

				BgL_runz00_15013 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15009, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15014 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15009, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17507;

					BgL_sz00_17507 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17508;

						BgL_bpz00_17508 = VECTOR_REF(((obj_t) BgL_sz00_17507), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17508) + BgL_siza7ezd2framez75_15014) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17507))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3590z00_17509;

									BgL_arg3590z00_17509 =
										((long) CINT(BgL_bpz00_17508) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17507), BgL_arg3590z00_17509,
										BgL_dz00_15015);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17510;

									BgL_ez00_17510 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17510,
										BgL_bpz00_17508);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17511;

										BgL_accz00_17511 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15013, BgL_sz00_17507, BgL_bpz00_17508);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17510);
										VECTOR_SET(
											((obj_t) BgL_sz00_17507), ((long) 0), BgL_bpz00_17508);
										return BgL_accz00_17511;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17512;

								BgL_nsz00_17512 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17512, ((long) 1), BgL_sz00_17507);
								VECTOR_SET(BgL_nsz00_17512, ((long) 2), BgL_dz00_15015);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17513;

									BgL_z12denvz12_17513 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17513, BgL_nsz00_17512);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17514;

										BgL_ez00_17514 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17514,
											BgL_sz00_17507);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17515;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17516;

												BgL_savedzd2bpzd2_17516 =
													VECTOR_REF(BgL_nsz00_17512, ((long) 0));
												VECTOR_SET(BgL_nsz00_17512, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17518;

													BgL_fz00_17518 = BgL_runz00_15013;
												BgL_recz00_17517:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17519;

														BgL_rz00_17519 =
															PROCEDURE_ENTRY(BgL_fz00_17518) (BgL_fz00_17518,
															BgL_nsz00_17512, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6738z00_30737;

															if (PROCEDUREP(BgL_rz00_17519))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17520;

																	BgL_arg1732z00_17520 =
																		PROCEDURE_ATTR(BgL_rz00_17519);
																	if (STRUCTP(BgL_arg1732z00_17520))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6738z00_30737 =
																				(STRUCT_KEY(BgL_arg1732z00_17520) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6738z00_30737 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6738z00_30737 = ((bool_t) 0);
																}
															if (BgL_test6738z00_30737)
																{
																	obj_t BgL_fz00_30745;

																	BgL_fz00_30745 = BgL_rz00_17519;
																	BgL_fz00_17518 = BgL_fz00_30745;
																	goto BgL_recz00_17517;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17512, ((long) 0),
																		BgL_savedzd2bpzd2_17516);
																	BgL_____rz00_17515 = BgL_rz00_17519;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17514);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17513, BgL_sz00_17507);
											return BgL_____rz00_17515;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5806 */
	obj_t BGl_z62run5806z62zz__evaluate_compz00(obj_t BgL_envz00_15016,
		obj_t BgL_sz00_15020)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15017;
				BgL_ev_absz00_bglt BgL_i1247z00_15018;
				obj_t BgL_bodyz00_15019;

				BgL_iboxesz00_15017 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15016, (int) (((long) 0))));
				BgL_i1247z00_15018 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15016, (int) (((long) 1))));
				BgL_bodyz00_15019 = PROCEDURE_REF(BgL_envz00_15016, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17521;

					BgL_bpz00_17521 = VECTOR_REF(((obj_t) BgL_sz00_15020), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15020,
						BgL_iboxesz00_15017, BgL_bpz00_17521);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17522;
						obj_t BgL_wherez00_17523;
						obj_t BgL_locz00_17524;

						BgL_z12denvz12_17522 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17523 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15018))->
							BgL_wherez00);
						BgL_locz00_17524 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15018))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17522, BgL_wherez00_17523,
								BgL_locz00_17524);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17525;

								BgL_za2za2resza2za2z00_17525 =
									PROCEDURE_ENTRY(BgL_bodyz00_15019) (BgL_bodyz00_15019,
									BgL_sz00_15020, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17522);
								return BgL_za2za2resza2za2z00_17525;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3596> */
	obj_t BGl_z62zc3z04anonymousza33596ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15021, obj_t BgL_sz00_15027)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15022;
				long BgL_siza7eza7_15023;
				BgL_ev_absz00_bglt BgL_i1247z00_15024;
				obj_t BgL_bodyz00_15025;
				long BgL_siza7ezd2framez75_15026;

				BgL_ifreesz00_15022 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15021, (int) (((long) 0))));
				BgL_siza7eza7_15023 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15021, (int) (((long) 1))));
				BgL_i1247z00_15024 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15021, (int) (((long) 2))));
				BgL_bodyz00_15025 = PROCEDURE_REF(BgL_envz00_15021, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15026 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15021, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17526;

					BgL_bpz00_17526 = VECTOR_REF(((obj_t) BgL_sz00_15027), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17527;

						BgL_valza2za2_17527 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15027,
							BgL_bpz00_17526, BgL_ifreesz00_15022);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17528;

							BgL_runz00_17528 =
								MAKE_FX_PROCEDURE(BGl_z62run5808z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17528,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15023));
							PROCEDURE_SET(BgL_runz00_17528,
								(int) (((long) 1)), BgL_valza2za2_17527);
							PROCEDURE_SET(BgL_runz00_17528,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15024));
							PROCEDURE_SET(BgL_runz00_17528,
								(int) (((long) 3)), BgL_bodyz00_15025);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17529;

								BgL_mainz00_17529 =
									MAKE_FX_PROCEDURE(BGl_z62main5807z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17529,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15023));
								PROCEDURE_SET(BgL_mainz00_17529,
									(int) (((long) 1)), BgL_valza2za2_17527);
								PROCEDURE_SET(BgL_mainz00_17529,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15024));
								PROCEDURE_SET(BgL_mainz00_17529,
									(int) (((long) 3)), BgL_bodyz00_15025);
								PROCEDURE_SET(BgL_mainz00_17529,
									(int) (((long) 4)), BgL_runz00_17528);
								PROCEDURE_SET(BgL_mainz00_17529,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15026));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17530;

									BgL_objz00_17530 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17528, BgL_objz00_17530);
									BgL_objz00_17530;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3597z00_17531;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3598z00_17532;

										BgL_arg3598z00_17532 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15024))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17533;

											BgL_newz00_17533 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30821;

												BgL_tmpz00_30821 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17533, BgL_tmpz00_30821,
													BgL_arg3598z00_17532);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30826;
												int BgL_tmpz00_30824;

												BgL_auxz00_30826 = BINT(BgL_siza7ezd2framez75_15026);
												BgL_tmpz00_30824 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17533, BgL_tmpz00_30824,
													BgL_auxz00_30826);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30829;

												BgL_tmpz00_30829 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17533, BgL_tmpz00_30829,
													BgL_runz00_17528);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30834;
												int BgL_tmpz00_30832;

												BgL_auxz00_30834 = BINT(((long) 1));
												BgL_tmpz00_30832 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17533, BgL_tmpz00_30832,
													BgL_auxz00_30834);
											}
											BgL_arg3597z00_17531 = BgL_newz00_17533;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17529, BgL_arg3597z00_17531);
									BgL_arg3597z00_17531;
								}
								return BgL_mainz00_17529;
							}
						}
					}
				}
			}
		}

	}



/* &main5807 */
	obj_t BGl_z62main5807z62zz__evaluate_compz00(obj_t BgL_envz00_15028,
		obj_t BgL_dz00_15035)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15033;
				long BgL_siza7ezd2framez75_15034;

				BgL_runz00_15033 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15028, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15034 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15028, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17534;

					BgL_sz00_17534 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17535;

						BgL_bpz00_17535 = VECTOR_REF(((obj_t) BgL_sz00_17534), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17535) + BgL_siza7ezd2framez75_15034) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17534))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3601z00_17536;

									BgL_arg3601z00_17536 =
										((long) CINT(BgL_bpz00_17535) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17534), BgL_arg3601z00_17536,
										BgL_dz00_15035);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17537;

									BgL_ez00_17537 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17537,
										BgL_bpz00_17535);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17538;

										BgL_accz00_17538 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15033, BgL_sz00_17534, BgL_bpz00_17535);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17537);
										VECTOR_SET(
											((obj_t) BgL_sz00_17534), ((long) 0), BgL_bpz00_17535);
										return BgL_accz00_17538;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17539;

								BgL_nsz00_17539 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17539, ((long) 1), BgL_sz00_17534);
								VECTOR_SET(BgL_nsz00_17539, ((long) 2), BgL_dz00_15035);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17540;

									BgL_z12denvz12_17540 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17540, BgL_nsz00_17539);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17541;

										BgL_ez00_17541 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17541,
											BgL_sz00_17534);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17542;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17543;

												BgL_savedzd2bpzd2_17543 =
													VECTOR_REF(BgL_nsz00_17539, ((long) 0));
												VECTOR_SET(BgL_nsz00_17539, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17545;

													BgL_fz00_17545 = BgL_runz00_15033;
												BgL_recz00_17544:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17546;

														BgL_rz00_17546 =
															PROCEDURE_ENTRY(BgL_fz00_17545) (BgL_fz00_17545,
															BgL_nsz00_17539, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6742z00_30877;

															if (PROCEDUREP(BgL_rz00_17546))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17547;

																	BgL_arg1732z00_17547 =
																		PROCEDURE_ATTR(BgL_rz00_17546);
																	if (STRUCTP(BgL_arg1732z00_17547))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6742z00_30877 =
																				(STRUCT_KEY(BgL_arg1732z00_17547) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6742z00_30877 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6742z00_30877 = ((bool_t) 0);
																}
															if (BgL_test6742z00_30877)
																{
																	obj_t BgL_fz00_30885;

																	BgL_fz00_30885 = BgL_rz00_17546;
																	BgL_fz00_17545 = BgL_fz00_30885;
																	goto BgL_recz00_17544;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17539, ((long) 0),
																		BgL_savedzd2bpzd2_17543);
																	BgL_____rz00_17542 = BgL_rz00_17546;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17541);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17540, BgL_sz00_17534);
											return BgL_____rz00_17542;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5808 */
	obj_t BGl_z62run5808z62zz__evaluate_compz00(obj_t BgL_envz00_15036,
		obj_t BgL_sz00_15041)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_15037;
				obj_t BgL_valza2za2_15038;
				BgL_ev_absz00_bglt BgL_i1247z00_15039;
				obj_t BgL_bodyz00_15040;

				BgL_siza7eza7_15037 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15036, (int) (((long) 0))));
				BgL_valza2za2_15038 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15036, (int) (((long) 1))));
				BgL_i1247z00_15039 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15036, (int) (((long) 2))));
				BgL_bodyz00_15040 = PROCEDURE_REF(BgL_envz00_15036, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17548;

					BgL_bpz00_17548 = VECTOR_REF(((obj_t) BgL_sz00_15041), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15041,
						BgL_valza2za2_15038,
						((long) CINT(BgL_bpz00_17548) + BgL_siza7eza7_15037));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17549;
						obj_t BgL_wherez00_17550;
						obj_t BgL_locz00_17551;

						BgL_z12denvz12_17549 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17550 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15039))->
							BgL_wherez00);
						BgL_locz00_17551 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15039))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17549, BgL_wherez00_17550,
								BgL_locz00_17551);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17552;

								BgL_za2za2resza2za2z00_17552 =
									PROCEDURE_ENTRY(BgL_bodyz00_15040) (BgL_bodyz00_15040,
									BgL_sz00_15041, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17549);
								return BgL_za2za2resza2za2z00_17552;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3605> */
	obj_t BGl_z62zc3z04anonymousza33605ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15042, obj_t BgL_sz00_15049)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15043;
				obj_t BgL_iboxesz00_15044;
				long BgL_siza7eza7_15045;
				BgL_ev_absz00_bglt BgL_i1247z00_15046;
				obj_t BgL_bodyz00_15047;
				long BgL_siza7ezd2framez75_15048;

				BgL_ifreesz00_15043 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15042, (int) (((long) 0))));
				BgL_iboxesz00_15044 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15042, (int) (((long) 1))));
				BgL_siza7eza7_15045 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15042, (int) (((long) 2))));
				BgL_i1247z00_15046 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15042, (int) (((long) 3))));
				BgL_bodyz00_15047 = PROCEDURE_REF(BgL_envz00_15042, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15048 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15042, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17553;

					BgL_bpz00_17553 = VECTOR_REF(((obj_t) BgL_sz00_15049), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17554;

						BgL_valza2za2_17554 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15049,
							BgL_bpz00_17553, BgL_ifreesz00_15043);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17555;

							BgL_runz00_17555 =
								MAKE_FX_PROCEDURE(BGl_z62run5810z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17555,
								(int) (((long) 0)), BgL_iboxesz00_15044);
							PROCEDURE_SET(BgL_runz00_17555,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15045));
							PROCEDURE_SET(BgL_runz00_17555,
								(int) (((long) 2)), BgL_valza2za2_17554);
							PROCEDURE_SET(BgL_runz00_17555,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15046));
							PROCEDURE_SET(BgL_runz00_17555,
								(int) (((long) 4)), BgL_bodyz00_15047);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17556;

								BgL_mainz00_17556 =
									MAKE_FX_PROCEDURE(BGl_z62main5809z62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17556,
									(int) (((long) 0)), BgL_iboxesz00_15044);
								PROCEDURE_SET(BgL_mainz00_17556,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15045));
								PROCEDURE_SET(BgL_mainz00_17556,
									(int) (((long) 2)), BgL_valza2za2_17554);
								PROCEDURE_SET(BgL_mainz00_17556,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15046));
								PROCEDURE_SET(BgL_mainz00_17556,
									(int) (((long) 4)), BgL_bodyz00_15047);
								PROCEDURE_SET(BgL_mainz00_17556,
									(int) (((long) 5)), BgL_runz00_17555);
								PROCEDURE_SET(BgL_mainz00_17556,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15048));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17557;

									BgL_objz00_17557 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17555, BgL_objz00_17557);
									BgL_objz00_17557;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3607z00_17558;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3608z00_17559;

										BgL_arg3608z00_17559 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15046))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17560;

											BgL_newz00_17560 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30973;

												BgL_tmpz00_30973 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17560, BgL_tmpz00_30973,
													BgL_arg3608z00_17559);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30978;
												int BgL_tmpz00_30976;

												BgL_auxz00_30978 = BINT(BgL_siza7ezd2framez75_15048);
												BgL_tmpz00_30976 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17560, BgL_tmpz00_30976,
													BgL_auxz00_30978);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_30981;

												BgL_tmpz00_30981 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17560, BgL_tmpz00_30981,
													BgL_runz00_17555);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_30986;
												int BgL_tmpz00_30984;

												BgL_auxz00_30986 = BINT(((long) 1));
												BgL_tmpz00_30984 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17560, BgL_tmpz00_30984,
													BgL_auxz00_30986);
											}
											BgL_arg3607z00_17558 = BgL_newz00_17560;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17556, BgL_arg3607z00_17558);
									BgL_arg3607z00_17558;
								}
								return BgL_mainz00_17556;
							}
						}
					}
				}
			}
		}

	}



/* &main5809 */
	obj_t BGl_z62main5809z62zz__evaluate_compz00(obj_t BgL_envz00_15050,
		obj_t BgL_dz00_15058)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15056;
				long BgL_siza7ezd2framez75_15057;

				BgL_runz00_15056 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15050, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15057 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15050, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17561;

					BgL_sz00_17561 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17562;

						BgL_bpz00_17562 = VECTOR_REF(((obj_t) BgL_sz00_17561), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17562) + BgL_siza7ezd2framez75_15057) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17561))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3611z00_17563;

									BgL_arg3611z00_17563 =
										((long) CINT(BgL_bpz00_17562) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17561), BgL_arg3611z00_17563,
										BgL_dz00_15058);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17564;

									BgL_ez00_17564 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17564,
										BgL_bpz00_17562);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17565;

										BgL_accz00_17565 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15056, BgL_sz00_17561, BgL_bpz00_17562);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17564);
										VECTOR_SET(
											((obj_t) BgL_sz00_17561), ((long) 0), BgL_bpz00_17562);
										return BgL_accz00_17565;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17566;

								BgL_nsz00_17566 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17566, ((long) 1), BgL_sz00_17561);
								VECTOR_SET(BgL_nsz00_17566, ((long) 2), BgL_dz00_15058);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17567;

									BgL_z12denvz12_17567 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17567, BgL_nsz00_17566);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17568;

										BgL_ez00_17568 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17568,
											BgL_sz00_17561);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17569;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17570;

												BgL_savedzd2bpzd2_17570 =
													VECTOR_REF(BgL_nsz00_17566, ((long) 0));
												VECTOR_SET(BgL_nsz00_17566, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17572;

													BgL_fz00_17572 = BgL_runz00_15056;
												BgL_recz00_17571:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17573;

														BgL_rz00_17573 =
															PROCEDURE_ENTRY(BgL_fz00_17572) (BgL_fz00_17572,
															BgL_nsz00_17566, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6746z00_31029;

															if (PROCEDUREP(BgL_rz00_17573))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17574;

																	BgL_arg1732z00_17574 =
																		PROCEDURE_ATTR(BgL_rz00_17573);
																	if (STRUCTP(BgL_arg1732z00_17574))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6746z00_31029 =
																				(STRUCT_KEY(BgL_arg1732z00_17574) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6746z00_31029 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6746z00_31029 = ((bool_t) 0);
																}
															if (BgL_test6746z00_31029)
																{
																	obj_t BgL_fz00_31037;

																	BgL_fz00_31037 = BgL_rz00_17573;
																	BgL_fz00_17572 = BgL_fz00_31037;
																	goto BgL_recz00_17571;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17566, ((long) 0),
																		BgL_savedzd2bpzd2_17570);
																	BgL_____rz00_17569 = BgL_rz00_17573;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17568);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17567, BgL_sz00_17561);
											return BgL_____rz00_17569;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5810 */
	obj_t BGl_z62run5810z62zz__evaluate_compz00(obj_t BgL_envz00_15059,
		obj_t BgL_sz00_15065)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15060;
				long BgL_siza7eza7_15061;
				obj_t BgL_valza2za2_15062;
				BgL_ev_absz00_bglt BgL_i1247z00_15063;
				obj_t BgL_bodyz00_15064;

				BgL_iboxesz00_15060 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 0))));
				BgL_siza7eza7_15061 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 1))));
				BgL_valza2za2_15062 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 2))));
				BgL_i1247z00_15063 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 3))));
				BgL_bodyz00_15064 = PROCEDURE_REF(BgL_envz00_15059, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17575;

					BgL_bpz00_17575 = VECTOR_REF(((obj_t) BgL_sz00_15065), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15065,
						BgL_iboxesz00_15060, BgL_bpz00_17575);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15065,
						BgL_valza2za2_15062,
						((long) CINT(BgL_bpz00_17575) + BgL_siza7eza7_15061));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17576;
						obj_t BgL_wherez00_17577;
						obj_t BgL_locz00_17578;

						BgL_z12denvz12_17576 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17577 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15063))->
							BgL_wherez00);
						BgL_locz00_17578 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15063))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17576, BgL_wherez00_17577,
								BgL_locz00_17578);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17579;

								BgL_za2za2resza2za2z00_17579 =
									PROCEDURE_ENTRY(BgL_bodyz00_15064) (BgL_bodyz00_15064,
									BgL_sz00_15065, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17576);
								return BgL_za2za2resza2za2z00_17579;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3528> */
	obj_t BGl_z62zc3z04anonymousza33528ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15066, obj_t BgL_sz00_15070)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15067;
				obj_t BgL_bodyz00_15068;
				long BgL_siza7ezd2framez75_15069;

				BgL_i1247z00_15067 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15066, (int) (((long) 0))));
				BgL_bodyz00_15068 = PROCEDURE_REF(BgL_envz00_15066, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15069 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15066, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17580;

					BgL_bpz00_17580 = VECTOR_REF(((obj_t) BgL_sz00_15070), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17581;

							BgL_runz00_17581 =
								MAKE_FX_PROCEDURE(BGl_z62run5812z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17581,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15067));
							PROCEDURE_SET(BgL_runz00_17581,
								(int) (((long) 1)), BgL_bodyz00_15068);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17582;

								BgL_mainz00_17582 =
									MAKE_VA_PROCEDURE(BGl_z62main5811z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17582,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_15067));
								PROCEDURE_SET(BgL_mainz00_17582,
									(int) (((long) 1)), BgL_bodyz00_15068);
								PROCEDURE_SET(BgL_mainz00_17582,
									(int) (((long) 2)), BgL_runz00_17581);
								PROCEDURE_SET(BgL_mainz00_17582,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15069));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17583;

									BgL_objz00_17583 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17581, BgL_objz00_17583);
									BgL_objz00_17583;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3531z00_17584;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3532z00_17585;

										BgL_arg3532z00_17585 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15067))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17586;

											BgL_newz00_17586 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31105;

												BgL_tmpz00_31105 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17586, BgL_tmpz00_31105,
													BgL_arg3532z00_17585);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31110;
												int BgL_tmpz00_31108;

												BgL_auxz00_31110 = BINT(BgL_siza7ezd2framez75_15069);
												BgL_tmpz00_31108 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17586, BgL_tmpz00_31108,
													BgL_auxz00_31110);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31113;

												BgL_tmpz00_31113 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17586, BgL_tmpz00_31113,
													BgL_runz00_17581);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31118;
												int BgL_tmpz00_31116;

												BgL_auxz00_31118 = BINT(((long) -1));
												BgL_tmpz00_31116 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17586, BgL_tmpz00_31116,
													BgL_auxz00_31118);
											}
											BgL_arg3531z00_17584 = BgL_newz00_17586;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17582, BgL_arg3531z00_17584);
									BgL_arg3531z00_17584;
								}
								return BgL_mainz00_17582;
							}
						}
					}
				}
			}
		}

	}



/* &main5811 */
	obj_t BGl_z62main5811z62zz__evaluate_compz00(obj_t BgL_envz00_15071,
		obj_t BgL_lastz00_15076)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15074;
				long BgL_siza7ezd2framez75_15075;

				BgL_runz00_15074 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15071, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15075 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15071, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17587;

					BgL_sz00_17587 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17588;

						BgL_bpz00_17588 = VECTOR_REF(((obj_t) BgL_sz00_17587), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17588) + BgL_siza7ezd2framez75_15075) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17587))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3536z00_17589;

									BgL_arg3536z00_17589 =
										((long) CINT(BgL_bpz00_17588) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17587), BgL_arg3536z00_17589,
										BgL_lastz00_15076);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17590;

									BgL_ez00_17590 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17590,
										BgL_bpz00_17588);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17591;

										BgL_accz00_17591 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15074, BgL_sz00_17587, BgL_bpz00_17588);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17590);
										VECTOR_SET(
											((obj_t) BgL_sz00_17587), ((long) 0), BgL_bpz00_17588);
										return BgL_accz00_17591;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17592;

								BgL_nsz00_17592 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17592, ((long) 1), BgL_sz00_17587);
								VECTOR_SET(BgL_nsz00_17592, ((long) 2), BgL_lastz00_15076);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17593;

									BgL_z12denvz12_17593 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17593, BgL_nsz00_17592);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17594;

										BgL_ez00_17594 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17594,
											BgL_sz00_17587);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17595;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17596;

												BgL_savedzd2bpzd2_17596 =
													VECTOR_REF(BgL_nsz00_17592, ((long) 0));
												VECTOR_SET(BgL_nsz00_17592, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17598;

													BgL_fz00_17598 = BgL_runz00_15074;
												BgL_recz00_17597:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17599;

														BgL_rz00_17599 =
															PROCEDURE_ENTRY(BgL_fz00_17598) (BgL_fz00_17598,
															BgL_nsz00_17592, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6750z00_31161;

															if (PROCEDUREP(BgL_rz00_17599))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17600;

																	BgL_arg1732z00_17600 =
																		PROCEDURE_ATTR(BgL_rz00_17599);
																	if (STRUCTP(BgL_arg1732z00_17600))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6750z00_31161 =
																				(STRUCT_KEY(BgL_arg1732z00_17600) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6750z00_31161 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6750z00_31161 = ((bool_t) 0);
																}
															if (BgL_test6750z00_31161)
																{
																	obj_t BgL_fz00_31169;

																	BgL_fz00_31169 = BgL_rz00_17599;
																	BgL_fz00_17598 = BgL_fz00_31169;
																	goto BgL_recz00_17597;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17592, ((long) 0),
																		BgL_savedzd2bpzd2_17596);
																	BgL_____rz00_17595 = BgL_rz00_17599;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17594);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17593, BgL_sz00_17587);
											return BgL_____rz00_17595;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5812 */
	obj_t BGl_z62run5812z62zz__evaluate_compz00(obj_t BgL_envz00_15077,
		obj_t BgL_sz00_15080)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15078;
				obj_t BgL_bodyz00_15079;

				BgL_i1247z00_15078 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15077, (int) (((long) 0))));
				BgL_bodyz00_15079 = PROCEDURE_REF(BgL_envz00_15077, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17601;

					BgL_bpz00_17601 = VECTOR_REF(((obj_t) BgL_sz00_15080), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17602;
						obj_t BgL_wherez00_17603;
						obj_t BgL_locz00_17604;

						BgL_z12denvz12_17602 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17603 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15078))->
							BgL_wherez00);
						BgL_locz00_17604 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15078))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17602, BgL_wherez00_17603,
								BgL_locz00_17604);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17605;

								BgL_za2za2resza2za2z00_17605 =
									PROCEDURE_ENTRY(BgL_bodyz00_15079) (BgL_bodyz00_15079,
									BgL_sz00_15080, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17602);
								return BgL_za2za2resza2za2z00_17605;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3538> */
	obj_t BGl_z62zc3z04anonymousza33538ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15081, obj_t BgL_sz00_15086)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15082;
				BgL_ev_absz00_bglt BgL_i1247z00_15083;
				obj_t BgL_bodyz00_15084;
				long BgL_siza7ezd2framez75_15085;

				BgL_iboxesz00_15082 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15081, (int) (((long) 0))));
				BgL_i1247z00_15083 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15081, (int) (((long) 1))));
				BgL_bodyz00_15084 = PROCEDURE_REF(BgL_envz00_15081, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15085 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15081, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17606;

					BgL_bpz00_17606 = VECTOR_REF(((obj_t) BgL_sz00_15086), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17607;

							BgL_runz00_17607 =
								MAKE_FX_PROCEDURE(BGl_z62run5814z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17607,
								(int) (((long) 0)), BgL_iboxesz00_15082);
							PROCEDURE_SET(BgL_runz00_17607,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15083));
							PROCEDURE_SET(BgL_runz00_17607,
								(int) (((long) 2)), BgL_bodyz00_15084);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17608;

								BgL_mainz00_17608 =
									MAKE_VA_PROCEDURE(BGl_z62main5813z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17608,
									(int) (((long) 0)), BgL_iboxesz00_15082);
								PROCEDURE_SET(BgL_mainz00_17608,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15083));
								PROCEDURE_SET(BgL_mainz00_17608,
									(int) (((long) 2)), BgL_bodyz00_15084);
								PROCEDURE_SET(BgL_mainz00_17608,
									(int) (((long) 3)), BgL_runz00_17607);
								PROCEDURE_SET(BgL_mainz00_17608,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15085));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17609;

									BgL_objz00_17609 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17607, BgL_objz00_17609);
									BgL_objz00_17609;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3539z00_17610;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3540z00_17611;

										BgL_arg3540z00_17611 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15083))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17612;

											BgL_newz00_17612 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31231;

												BgL_tmpz00_31231 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17612, BgL_tmpz00_31231,
													BgL_arg3540z00_17611);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31236;
												int BgL_tmpz00_31234;

												BgL_auxz00_31236 = BINT(BgL_siza7ezd2framez75_15085);
												BgL_tmpz00_31234 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17612, BgL_tmpz00_31234,
													BgL_auxz00_31236);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31239;

												BgL_tmpz00_31239 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17612, BgL_tmpz00_31239,
													BgL_runz00_17607);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31244;
												int BgL_tmpz00_31242;

												BgL_auxz00_31244 = BINT(((long) -1));
												BgL_tmpz00_31242 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17612, BgL_tmpz00_31242,
													BgL_auxz00_31244);
											}
											BgL_arg3539z00_17610 = BgL_newz00_17612;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17608, BgL_arg3539z00_17610);
									BgL_arg3539z00_17610;
								}
								return BgL_mainz00_17608;
							}
						}
					}
				}
			}
		}

	}



/* &main5813 */
	obj_t BGl_z62main5813z62zz__evaluate_compz00(obj_t BgL_envz00_15087,
		obj_t BgL_lastz00_15093)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15091;
				long BgL_siza7ezd2framez75_15092;

				BgL_runz00_15091 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15087, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15092 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15087, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17613;

					BgL_sz00_17613 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17614;

						BgL_bpz00_17614 = VECTOR_REF(((obj_t) BgL_sz00_17613), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17614) + BgL_siza7ezd2framez75_15092) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17613))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3543z00_17615;

									BgL_arg3543z00_17615 =
										((long) CINT(BgL_bpz00_17614) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17613), BgL_arg3543z00_17615,
										BgL_lastz00_15093);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17616;

									BgL_ez00_17616 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17616,
										BgL_bpz00_17614);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17617;

										BgL_accz00_17617 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15091, BgL_sz00_17613, BgL_bpz00_17614);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17616);
										VECTOR_SET(
											((obj_t) BgL_sz00_17613), ((long) 0), BgL_bpz00_17614);
										return BgL_accz00_17617;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17618;

								BgL_nsz00_17618 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17618, ((long) 1), BgL_sz00_17613);
								VECTOR_SET(BgL_nsz00_17618, ((long) 2), BgL_lastz00_15093);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17619;

									BgL_z12denvz12_17619 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17619, BgL_nsz00_17618);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17620;

										BgL_ez00_17620 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17620,
											BgL_sz00_17613);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17621;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17622;

												BgL_savedzd2bpzd2_17622 =
													VECTOR_REF(BgL_nsz00_17618, ((long) 0));
												VECTOR_SET(BgL_nsz00_17618, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17624;

													BgL_fz00_17624 = BgL_runz00_15091;
												BgL_recz00_17623:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17625;

														BgL_rz00_17625 =
															PROCEDURE_ENTRY(BgL_fz00_17624) (BgL_fz00_17624,
															BgL_nsz00_17618, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6754z00_31287;

															if (PROCEDUREP(BgL_rz00_17625))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17626;

																	BgL_arg1732z00_17626 =
																		PROCEDURE_ATTR(BgL_rz00_17625);
																	if (STRUCTP(BgL_arg1732z00_17626))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6754z00_31287 =
																				(STRUCT_KEY(BgL_arg1732z00_17626) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6754z00_31287 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6754z00_31287 = ((bool_t) 0);
																}
															if (BgL_test6754z00_31287)
																{
																	obj_t BgL_fz00_31295;

																	BgL_fz00_31295 = BgL_rz00_17625;
																	BgL_fz00_17624 = BgL_fz00_31295;
																	goto BgL_recz00_17623;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17618, ((long) 0),
																		BgL_savedzd2bpzd2_17622);
																	BgL_____rz00_17621 = BgL_rz00_17625;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17620);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17619, BgL_sz00_17613);
											return BgL_____rz00_17621;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5814 */
	obj_t BGl_z62run5814z62zz__evaluate_compz00(obj_t BgL_envz00_15094,
		obj_t BgL_sz00_15098)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15095;
				BgL_ev_absz00_bglt BgL_i1247z00_15096;
				obj_t BgL_bodyz00_15097;

				BgL_iboxesz00_15095 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15094, (int) (((long) 0))));
				BgL_i1247z00_15096 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15094, (int) (((long) 1))));
				BgL_bodyz00_15097 = PROCEDURE_REF(BgL_envz00_15094, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17627;

					BgL_bpz00_17627 = VECTOR_REF(((obj_t) BgL_sz00_15098), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15098,
						BgL_iboxesz00_15095, BgL_bpz00_17627);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17628;
						obj_t BgL_wherez00_17629;
						obj_t BgL_locz00_17630;

						BgL_z12denvz12_17628 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17629 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15096))->
							BgL_wherez00);
						BgL_locz00_17630 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15096))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17628, BgL_wherez00_17629,
								BgL_locz00_17630);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17631;

								BgL_za2za2resza2za2z00_17631 =
									PROCEDURE_ENTRY(BgL_bodyz00_15097) (BgL_bodyz00_15097,
									BgL_sz00_15098, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17628);
								return BgL_za2za2resza2za2z00_17631;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3549> */
	obj_t BGl_z62zc3z04anonymousza33549ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15099, obj_t BgL_sz00_15105)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15100;
				long BgL_siza7eza7_15101;
				BgL_ev_absz00_bglt BgL_i1247z00_15102;
				obj_t BgL_bodyz00_15103;
				long BgL_siza7ezd2framez75_15104;

				BgL_ifreesz00_15100 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15099, (int) (((long) 0))));
				BgL_siza7eza7_15101 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15099, (int) (((long) 1))));
				BgL_i1247z00_15102 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15099, (int) (((long) 2))));
				BgL_bodyz00_15103 = PROCEDURE_REF(BgL_envz00_15099, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15104 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15099, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17632;

					BgL_bpz00_17632 = VECTOR_REF(((obj_t) BgL_sz00_15105), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17633;

						BgL_valza2za2_17633 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15105,
							BgL_bpz00_17632, BgL_ifreesz00_15100);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17634;

							BgL_runz00_17634 =
								MAKE_FX_PROCEDURE(BGl_z62run5816z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17634,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15101));
							PROCEDURE_SET(BgL_runz00_17634,
								(int) (((long) 1)), BgL_valza2za2_17633);
							PROCEDURE_SET(BgL_runz00_17634,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15102));
							PROCEDURE_SET(BgL_runz00_17634,
								(int) (((long) 3)), BgL_bodyz00_15103);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17635;

								BgL_mainz00_17635 =
									MAKE_VA_PROCEDURE(BGl_z62main5815z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17635,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15101));
								PROCEDURE_SET(BgL_mainz00_17635,
									(int) (((long) 1)), BgL_valza2za2_17633);
								PROCEDURE_SET(BgL_mainz00_17635,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15102));
								PROCEDURE_SET(BgL_mainz00_17635,
									(int) (((long) 3)), BgL_bodyz00_15103);
								PROCEDURE_SET(BgL_mainz00_17635,
									(int) (((long) 4)), BgL_runz00_17634);
								PROCEDURE_SET(BgL_mainz00_17635,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15104));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17636;

									BgL_objz00_17636 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17634, BgL_objz00_17636);
									BgL_objz00_17636;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3550z00_17637;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3551z00_17638;

										BgL_arg3551z00_17638 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15102))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17639;

											BgL_newz00_17639 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31371;

												BgL_tmpz00_31371 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17639, BgL_tmpz00_31371,
													BgL_arg3551z00_17638);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31376;
												int BgL_tmpz00_31374;

												BgL_auxz00_31376 = BINT(BgL_siza7ezd2framez75_15104);
												BgL_tmpz00_31374 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17639, BgL_tmpz00_31374,
													BgL_auxz00_31376);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31379;

												BgL_tmpz00_31379 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17639, BgL_tmpz00_31379,
													BgL_runz00_17634);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31384;
												int BgL_tmpz00_31382;

												BgL_auxz00_31384 = BINT(((long) -1));
												BgL_tmpz00_31382 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17639, BgL_tmpz00_31382,
													BgL_auxz00_31384);
											}
											BgL_arg3550z00_17637 = BgL_newz00_17639;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17635, BgL_arg3550z00_17637);
									BgL_arg3550z00_17637;
								}
								return BgL_mainz00_17635;
							}
						}
					}
				}
			}
		}

	}



/* &main5815 */
	obj_t BGl_z62main5815z62zz__evaluate_compz00(obj_t BgL_envz00_15106,
		obj_t BgL_lastz00_15113)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15111;
				long BgL_siza7ezd2framez75_15112;

				BgL_runz00_15111 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15106, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15112 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15106, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17640;

					BgL_sz00_17640 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17641;

						BgL_bpz00_17641 = VECTOR_REF(((obj_t) BgL_sz00_17640), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17641) + BgL_siza7ezd2framez75_15112) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17640))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3555z00_17642;

									BgL_arg3555z00_17642 =
										((long) CINT(BgL_bpz00_17641) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17640), BgL_arg3555z00_17642,
										BgL_lastz00_15113);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17643;

									BgL_ez00_17643 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17643,
										BgL_bpz00_17641);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17644;

										BgL_accz00_17644 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15111, BgL_sz00_17640, BgL_bpz00_17641);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17643);
										VECTOR_SET(
											((obj_t) BgL_sz00_17640), ((long) 0), BgL_bpz00_17641);
										return BgL_accz00_17644;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17645;

								BgL_nsz00_17645 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17645, ((long) 1), BgL_sz00_17640);
								VECTOR_SET(BgL_nsz00_17645, ((long) 2), BgL_lastz00_15113);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17646;

									BgL_z12denvz12_17646 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17646, BgL_nsz00_17645);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17647;

										BgL_ez00_17647 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17647,
											BgL_sz00_17640);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17648;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17649;

												BgL_savedzd2bpzd2_17649 =
													VECTOR_REF(BgL_nsz00_17645, ((long) 0));
												VECTOR_SET(BgL_nsz00_17645, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17651;

													BgL_fz00_17651 = BgL_runz00_15111;
												BgL_recz00_17650:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17652;

														BgL_rz00_17652 =
															PROCEDURE_ENTRY(BgL_fz00_17651) (BgL_fz00_17651,
															BgL_nsz00_17645, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6758z00_31427;

															if (PROCEDUREP(BgL_rz00_17652))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17653;

																	BgL_arg1732z00_17653 =
																		PROCEDURE_ATTR(BgL_rz00_17652);
																	if (STRUCTP(BgL_arg1732z00_17653))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6758z00_31427 =
																				(STRUCT_KEY(BgL_arg1732z00_17653) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6758z00_31427 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6758z00_31427 = ((bool_t) 0);
																}
															if (BgL_test6758z00_31427)
																{
																	obj_t BgL_fz00_31435;

																	BgL_fz00_31435 = BgL_rz00_17652;
																	BgL_fz00_17651 = BgL_fz00_31435;
																	goto BgL_recz00_17650;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17645, ((long) 0),
																		BgL_savedzd2bpzd2_17649);
																	BgL_____rz00_17648 = BgL_rz00_17652;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17647);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17646, BgL_sz00_17640);
											return BgL_____rz00_17648;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5816 */
	obj_t BGl_z62run5816z62zz__evaluate_compz00(obj_t BgL_envz00_15114,
		obj_t BgL_sz00_15119)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_15115;
				obj_t BgL_valza2za2_15116;
				BgL_ev_absz00_bglt BgL_i1247z00_15117;
				obj_t BgL_bodyz00_15118;

				BgL_siza7eza7_15115 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15114, (int) (((long) 0))));
				BgL_valza2za2_15116 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15114, (int) (((long) 1))));
				BgL_i1247z00_15117 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15114, (int) (((long) 2))));
				BgL_bodyz00_15118 = PROCEDURE_REF(BgL_envz00_15114, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17654;

					BgL_bpz00_17654 = VECTOR_REF(((obj_t) BgL_sz00_15119), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15119,
						BgL_valza2za2_15116,
						((long) CINT(BgL_bpz00_17654) + BgL_siza7eza7_15115));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17655;
						obj_t BgL_wherez00_17656;
						obj_t BgL_locz00_17657;

						BgL_z12denvz12_17655 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17656 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15117))->
							BgL_wherez00);
						BgL_locz00_17657 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15117))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17655, BgL_wherez00_17656,
								BgL_locz00_17657);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17658;

								BgL_za2za2resza2za2z00_17658 =
									PROCEDURE_ENTRY(BgL_bodyz00_15118) (BgL_bodyz00_15118,
									BgL_sz00_15119, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17655);
								return BgL_za2za2resza2za2z00_17658;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3559> */
	obj_t BGl_z62zc3z04anonymousza33559ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15120, obj_t BgL_sz00_15127)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15121;
				obj_t BgL_iboxesz00_15122;
				long BgL_siza7eza7_15123;
				BgL_ev_absz00_bglt BgL_i1247z00_15124;
				obj_t BgL_bodyz00_15125;
				long BgL_siza7ezd2framez75_15126;

				BgL_ifreesz00_15121 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15120, (int) (((long) 0))));
				BgL_iboxesz00_15122 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15120, (int) (((long) 1))));
				BgL_siza7eza7_15123 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15120, (int) (((long) 2))));
				BgL_i1247z00_15124 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15120, (int) (((long) 3))));
				BgL_bodyz00_15125 = PROCEDURE_REF(BgL_envz00_15120, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15126 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15120, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17659;

					BgL_bpz00_17659 = VECTOR_REF(((obj_t) BgL_sz00_15127), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17660;

						BgL_valza2za2_17660 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15127,
							BgL_bpz00_17659, BgL_ifreesz00_15121);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17661;

							BgL_runz00_17661 =
								MAKE_FX_PROCEDURE(BGl_z62run5818z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17661,
								(int) (((long) 0)), BgL_iboxesz00_15122);
							PROCEDURE_SET(BgL_runz00_17661,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15123));
							PROCEDURE_SET(BgL_runz00_17661,
								(int) (((long) 2)), BgL_valza2za2_17660);
							PROCEDURE_SET(BgL_runz00_17661,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15124));
							PROCEDURE_SET(BgL_runz00_17661,
								(int) (((long) 4)), BgL_bodyz00_15125);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17662;

								BgL_mainz00_17662 =
									MAKE_VA_PROCEDURE(BGl_z62main5817z62zz__evaluate_compz00,
									(int) (((long) -1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17662,
									(int) (((long) 0)), BgL_iboxesz00_15122);
								PROCEDURE_SET(BgL_mainz00_17662,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15123));
								PROCEDURE_SET(BgL_mainz00_17662,
									(int) (((long) 2)), BgL_valza2za2_17660);
								PROCEDURE_SET(BgL_mainz00_17662,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15124));
								PROCEDURE_SET(BgL_mainz00_17662,
									(int) (((long) 4)), BgL_bodyz00_15125);
								PROCEDURE_SET(BgL_mainz00_17662,
									(int) (((long) 5)), BgL_runz00_17661);
								PROCEDURE_SET(BgL_mainz00_17662,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15126));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17663;

									BgL_objz00_17663 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17661, BgL_objz00_17663);
									BgL_objz00_17663;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3560z00_17664;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3561z00_17665;

										BgL_arg3561z00_17665 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15124))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17666;

											BgL_newz00_17666 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31523;

												BgL_tmpz00_31523 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17666, BgL_tmpz00_31523,
													BgL_arg3561z00_17665);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31528;
												int BgL_tmpz00_31526;

												BgL_auxz00_31528 = BINT(BgL_siza7ezd2framez75_15126);
												BgL_tmpz00_31526 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17666, BgL_tmpz00_31526,
													BgL_auxz00_31528);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31531;

												BgL_tmpz00_31531 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17666, BgL_tmpz00_31531,
													BgL_runz00_17661);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31536;
												int BgL_tmpz00_31534;

												BgL_auxz00_31536 = BINT(((long) -1));
												BgL_tmpz00_31534 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17666, BgL_tmpz00_31534,
													BgL_auxz00_31536);
											}
											BgL_arg3560z00_17664 = BgL_newz00_17666;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17662, BgL_arg3560z00_17664);
									BgL_arg3560z00_17664;
								}
								return BgL_mainz00_17662;
							}
						}
					}
				}
			}
		}

	}



/* &main5817 */
	obj_t BGl_z62main5817z62zz__evaluate_compz00(obj_t BgL_envz00_15128,
		obj_t BgL_lastz00_15136)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15134;
				long BgL_siza7ezd2framez75_15135;

				BgL_runz00_15134 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15128, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15135 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15128, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17667;

					BgL_sz00_17667 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17668;

						BgL_bpz00_17668 = VECTOR_REF(((obj_t) BgL_sz00_17667), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17668) + BgL_siza7ezd2framez75_15135) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17667))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3564z00_17669;

									BgL_arg3564z00_17669 =
										((long) CINT(BgL_bpz00_17668) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17667), BgL_arg3564z00_17669,
										BgL_lastz00_15136);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17670;

									BgL_ez00_17670 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17670,
										BgL_bpz00_17668);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17671;

										BgL_accz00_17671 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15134, BgL_sz00_17667, BgL_bpz00_17668);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17670);
										VECTOR_SET(
											((obj_t) BgL_sz00_17667), ((long) 0), BgL_bpz00_17668);
										return BgL_accz00_17671;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17672;

								BgL_nsz00_17672 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17672, ((long) 1), BgL_sz00_17667);
								VECTOR_SET(BgL_nsz00_17672, ((long) 2), BgL_lastz00_15136);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17673;

									BgL_z12denvz12_17673 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17673, BgL_nsz00_17672);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17674;

										BgL_ez00_17674 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17674,
											BgL_sz00_17667);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17675;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17676;

												BgL_savedzd2bpzd2_17676 =
													VECTOR_REF(BgL_nsz00_17672, ((long) 0));
												VECTOR_SET(BgL_nsz00_17672, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17678;

													BgL_fz00_17678 = BgL_runz00_15134;
												BgL_recz00_17677:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17679;

														BgL_rz00_17679 =
															PROCEDURE_ENTRY(BgL_fz00_17678) (BgL_fz00_17678,
															BgL_nsz00_17672, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6762z00_31579;

															if (PROCEDUREP(BgL_rz00_17679))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17680;

																	BgL_arg1732z00_17680 =
																		PROCEDURE_ATTR(BgL_rz00_17679);
																	if (STRUCTP(BgL_arg1732z00_17680))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6762z00_31579 =
																				(STRUCT_KEY(BgL_arg1732z00_17680) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6762z00_31579 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6762z00_31579 = ((bool_t) 0);
																}
															if (BgL_test6762z00_31579)
																{
																	obj_t BgL_fz00_31587;

																	BgL_fz00_31587 = BgL_rz00_17679;
																	BgL_fz00_17678 = BgL_fz00_31587;
																	goto BgL_recz00_17677;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17672, ((long) 0),
																		BgL_savedzd2bpzd2_17676);
																	BgL_____rz00_17675 = BgL_rz00_17679;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17674);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17673, BgL_sz00_17667);
											return BgL_____rz00_17675;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5818 */
	obj_t BGl_z62run5818z62zz__evaluate_compz00(obj_t BgL_envz00_15137,
		obj_t BgL_sz00_15143)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15138;
				long BgL_siza7eza7_15139;
				obj_t BgL_valza2za2_15140;
				BgL_ev_absz00_bglt BgL_i1247z00_15141;
				obj_t BgL_bodyz00_15142;

				BgL_iboxesz00_15138 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15137, (int) (((long) 0))));
				BgL_siza7eza7_15139 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15137, (int) (((long) 1))));
				BgL_valza2za2_15140 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15137, (int) (((long) 2))));
				BgL_i1247z00_15141 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15137, (int) (((long) 3))));
				BgL_bodyz00_15142 = PROCEDURE_REF(BgL_envz00_15137, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17681;

					BgL_bpz00_17681 = VECTOR_REF(((obj_t) BgL_sz00_15143), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15143,
						BgL_iboxesz00_15138, BgL_bpz00_17681);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15143,
						BgL_valza2za2_15140,
						((long) CINT(BgL_bpz00_17681) + BgL_siza7eza7_15139));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17682;
						obj_t BgL_wherez00_17683;
						obj_t BgL_locz00_17684;

						BgL_z12denvz12_17682 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17683 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15141))->
							BgL_wherez00);
						BgL_locz00_17684 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15141))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17682, BgL_wherez00_17683,
								BgL_locz00_17684);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17685;

								BgL_za2za2resza2za2z00_17685 =
									PROCEDURE_ENTRY(BgL_bodyz00_15142) (BgL_bodyz00_15142,
									BgL_sz00_15143, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17682);
								return BgL_za2za2resza2za2z00_17685;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3488> */
	obj_t BGl_z62zc3z04anonymousza33488ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15144, obj_t BgL_sz00_15148)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15145;
				obj_t BgL_bodyz00_15146;
				long BgL_siza7ezd2framez75_15147;

				BgL_i1247z00_15145 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15144, (int) (((long) 0))));
				BgL_bodyz00_15146 = PROCEDURE_REF(BgL_envz00_15144, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15147 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15144, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17686;

					BgL_bpz00_17686 = VECTOR_REF(((obj_t) BgL_sz00_15148), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17687;

							BgL_runz00_17687 =
								MAKE_FX_PROCEDURE(BGl_z62run5820z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17687,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15145));
							PROCEDURE_SET(BgL_runz00_17687,
								(int) (((long) 1)), BgL_bodyz00_15146);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17688;

								BgL_mainz00_17688 =
									MAKE_FX_PROCEDURE(BGl_z62main5819z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17688,
									(int) (((long) 0)), ((obj_t) BgL_i1247z00_15145));
								PROCEDURE_SET(BgL_mainz00_17688,
									(int) (((long) 1)), BgL_bodyz00_15146);
								PROCEDURE_SET(BgL_mainz00_17688,
									(int) (((long) 2)), BgL_runz00_17687);
								PROCEDURE_SET(BgL_mainz00_17688,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15147));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17689;

									BgL_objz00_17689 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17687, BgL_objz00_17689);
									BgL_objz00_17689;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3489z00_17690;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3491z00_17691;

										BgL_arg3491z00_17691 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15145))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17692;

											BgL_newz00_17692 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31655;

												BgL_tmpz00_31655 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17692, BgL_tmpz00_31655,
													BgL_arg3491z00_17691);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31660;
												int BgL_tmpz00_31658;

												BgL_auxz00_31660 = BINT(BgL_siza7ezd2framez75_15147);
												BgL_tmpz00_31658 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17692, BgL_tmpz00_31658,
													BgL_auxz00_31660);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31663;

												BgL_tmpz00_31663 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17692, BgL_tmpz00_31663,
													BgL_runz00_17687);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31668;
												int BgL_tmpz00_31666;

												BgL_auxz00_31668 = BINT(((long) 0));
												BgL_tmpz00_31666 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17692, BgL_tmpz00_31666,
													BgL_auxz00_31668);
											}
											BgL_arg3489z00_17690 = BgL_newz00_17692;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17688, BgL_arg3489z00_17690);
									BgL_arg3489z00_17690;
								}
								return BgL_mainz00_17688;
							}
						}
					}
				}
			}
		}

	}



/* &main5819 */
	obj_t BGl_z62main5819z62zz__evaluate_compz00(obj_t BgL_envz00_15149)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15152;
				long BgL_siza7ezd2framez75_15153;

				BgL_runz00_15152 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15149, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15153 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15149, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17693;

					BgL_sz00_17693 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17694;

						BgL_bpz00_17694 = VECTOR_REF(((obj_t) BgL_sz00_17693), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17694) + BgL_siza7ezd2framez75_15153) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17693))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_17695;

								BgL_ez00_17695 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17695,
									BgL_bpz00_17694);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_17696;

									BgL_accz00_17696 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15152, BgL_sz00_17693, BgL_bpz00_17694);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17695);
									VECTOR_SET(
										((obj_t) BgL_sz00_17693), ((long) 0), BgL_bpz00_17694);
									return BgL_accz00_17696;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17697;

								BgL_nsz00_17697 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17697, ((long) 1), BgL_sz00_17693);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17698;

									BgL_z12denvz12_17698 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17698, BgL_nsz00_17697);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17699;

										BgL_ez00_17699 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17699,
											BgL_sz00_17693);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17700;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17701;

												BgL_savedzd2bpzd2_17701 =
													VECTOR_REF(BgL_nsz00_17697, ((long) 0));
												VECTOR_SET(BgL_nsz00_17697, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17703;

													BgL_fz00_17703 = BgL_runz00_15152;
												BgL_recz00_17702:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17704;

														BgL_rz00_17704 =
															PROCEDURE_ENTRY(BgL_fz00_17703) (BgL_fz00_17703,
															BgL_nsz00_17697, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6766z00_31706;

															if (PROCEDUREP(BgL_rz00_17704))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17705;

																	BgL_arg1732z00_17705 =
																		PROCEDURE_ATTR(BgL_rz00_17704);
																	if (STRUCTP(BgL_arg1732z00_17705))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6766z00_31706 =
																				(STRUCT_KEY(BgL_arg1732z00_17705) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6766z00_31706 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6766z00_31706 = ((bool_t) 0);
																}
															if (BgL_test6766z00_31706)
																{
																	obj_t BgL_fz00_31714;

																	BgL_fz00_31714 = BgL_rz00_17704;
																	BgL_fz00_17703 = BgL_fz00_31714;
																	goto BgL_recz00_17702;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17697, ((long) 0),
																		BgL_savedzd2bpzd2_17701);
																	BgL_____rz00_17700 = BgL_rz00_17704;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17699);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17698, BgL_sz00_17693);
											return BgL_____rz00_17700;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5820 */
	obj_t BGl_z62run5820z62zz__evaluate_compz00(obj_t BgL_envz00_15154,
		obj_t BgL_sz00_15157)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15155;
				obj_t BgL_bodyz00_15156;

				BgL_i1247z00_15155 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15154, (int) (((long) 0))));
				BgL_bodyz00_15156 = PROCEDURE_REF(BgL_envz00_15154, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17706;

					BgL_bpz00_17706 = VECTOR_REF(((obj_t) BgL_sz00_15157), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17707;
						obj_t BgL_wherez00_17708;
						obj_t BgL_locz00_17709;

						BgL_z12denvz12_17707 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17708 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15155))->
							BgL_wherez00);
						BgL_locz00_17709 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15155))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17707, BgL_wherez00_17708,
								BgL_locz00_17709);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17710;

								BgL_za2za2resza2za2z00_17710 =
									PROCEDURE_ENTRY(BgL_bodyz00_15156) (BgL_bodyz00_15156,
									BgL_sz00_15157, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17707);
								return BgL_za2za2resza2za2z00_17710;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3495> */
	obj_t BGl_z62zc3z04anonymousza33495ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15158, obj_t BgL_sz00_15163)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15159;
				BgL_ev_absz00_bglt BgL_i1247z00_15160;
				obj_t BgL_bodyz00_15161;
				long BgL_siza7ezd2framez75_15162;

				BgL_iboxesz00_15159 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15158, (int) (((long) 0))));
				BgL_i1247z00_15160 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15158, (int) (((long) 1))));
				BgL_bodyz00_15161 = PROCEDURE_REF(BgL_envz00_15158, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15162 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15158, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17711;

					BgL_bpz00_17711 = VECTOR_REF(((obj_t) BgL_sz00_15163), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17712;

							BgL_runz00_17712 =
								MAKE_FX_PROCEDURE(BGl_z62run5822z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17712,
								(int) (((long) 0)), BgL_iboxesz00_15159);
							PROCEDURE_SET(BgL_runz00_17712,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15160));
							PROCEDURE_SET(BgL_runz00_17712,
								(int) (((long) 2)), BgL_bodyz00_15161);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17713;

								BgL_mainz00_17713 =
									MAKE_FX_PROCEDURE(BGl_z62main5821z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17713,
									(int) (((long) 0)), BgL_iboxesz00_15159);
								PROCEDURE_SET(BgL_mainz00_17713,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15160));
								PROCEDURE_SET(BgL_mainz00_17713,
									(int) (((long) 2)), BgL_bodyz00_15161);
								PROCEDURE_SET(BgL_mainz00_17713,
									(int) (((long) 3)), BgL_runz00_17712);
								PROCEDURE_SET(BgL_mainz00_17713,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15162));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17714;

									BgL_objz00_17714 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17712, BgL_objz00_17714);
									BgL_objz00_17714;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3496z00_17715;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3497z00_17716;

										BgL_arg3497z00_17716 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15160))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17717;

											BgL_newz00_17717 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31776;

												BgL_tmpz00_31776 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17717, BgL_tmpz00_31776,
													BgL_arg3497z00_17716);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31781;
												int BgL_tmpz00_31779;

												BgL_auxz00_31781 = BINT(BgL_siza7ezd2framez75_15162);
												BgL_tmpz00_31779 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17717, BgL_tmpz00_31779,
													BgL_auxz00_31781);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31784;

												BgL_tmpz00_31784 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17717, BgL_tmpz00_31784,
													BgL_runz00_17712);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31789;
												int BgL_tmpz00_31787;

												BgL_auxz00_31789 = BINT(((long) 0));
												BgL_tmpz00_31787 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17717, BgL_tmpz00_31787,
													BgL_auxz00_31789);
											}
											BgL_arg3496z00_17715 = BgL_newz00_17717;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17713, BgL_arg3496z00_17715);
									BgL_arg3496z00_17715;
								}
								return BgL_mainz00_17713;
							}
						}
					}
				}
			}
		}

	}



/* &main5821 */
	obj_t BGl_z62main5821z62zz__evaluate_compz00(obj_t BgL_envz00_15164)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15168;
				long BgL_siza7ezd2framez75_15169;

				BgL_runz00_15168 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15164, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15169 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15164, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17718;

					BgL_sz00_17718 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17719;

						BgL_bpz00_17719 = VECTOR_REF(((obj_t) BgL_sz00_17718), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17719) + BgL_siza7ezd2framez75_15169) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17718))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_17720;

								BgL_ez00_17720 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17720,
									BgL_bpz00_17719);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_17721;

									BgL_accz00_17721 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15168, BgL_sz00_17718, BgL_bpz00_17719);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17720);
									VECTOR_SET(
										((obj_t) BgL_sz00_17718), ((long) 0), BgL_bpz00_17719);
									return BgL_accz00_17721;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17722;

								BgL_nsz00_17722 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17722, ((long) 1), BgL_sz00_17718);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17723;

									BgL_z12denvz12_17723 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17723, BgL_nsz00_17722);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17724;

										BgL_ez00_17724 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17724,
											BgL_sz00_17718);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17725;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17726;

												BgL_savedzd2bpzd2_17726 =
													VECTOR_REF(BgL_nsz00_17722, ((long) 0));
												VECTOR_SET(BgL_nsz00_17722, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17728;

													BgL_fz00_17728 = BgL_runz00_15168;
												BgL_recz00_17727:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17729;

														BgL_rz00_17729 =
															PROCEDURE_ENTRY(BgL_fz00_17728) (BgL_fz00_17728,
															BgL_nsz00_17722, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6770z00_31827;

															if (PROCEDUREP(BgL_rz00_17729))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17730;

																	BgL_arg1732z00_17730 =
																		PROCEDURE_ATTR(BgL_rz00_17729);
																	if (STRUCTP(BgL_arg1732z00_17730))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6770z00_31827 =
																				(STRUCT_KEY(BgL_arg1732z00_17730) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6770z00_31827 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6770z00_31827 = ((bool_t) 0);
																}
															if (BgL_test6770z00_31827)
																{
																	obj_t BgL_fz00_31835;

																	BgL_fz00_31835 = BgL_rz00_17729;
																	BgL_fz00_17728 = BgL_fz00_31835;
																	goto BgL_recz00_17727;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17722, ((long) 0),
																		BgL_savedzd2bpzd2_17726);
																	BgL_____rz00_17725 = BgL_rz00_17729;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17724);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17723, BgL_sz00_17718);
											return BgL_____rz00_17725;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5822 */
	obj_t BGl_z62run5822z62zz__evaluate_compz00(obj_t BgL_envz00_15170,
		obj_t BgL_sz00_15174)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15171;
				BgL_ev_absz00_bglt BgL_i1247z00_15172;
				obj_t BgL_bodyz00_15173;

				BgL_iboxesz00_15171 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15170, (int) (((long) 0))));
				BgL_i1247z00_15172 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15170, (int) (((long) 1))));
				BgL_bodyz00_15173 = PROCEDURE_REF(BgL_envz00_15170, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17731;

					BgL_bpz00_17731 = VECTOR_REF(((obj_t) BgL_sz00_15174), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15174,
						BgL_iboxesz00_15171, BgL_bpz00_17731);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17732;
						obj_t BgL_wherez00_17733;
						obj_t BgL_locz00_17734;

						BgL_z12denvz12_17732 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17733 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15172))->
							BgL_wherez00);
						BgL_locz00_17734 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15172))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17732, BgL_wherez00_17733,
								BgL_locz00_17734);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17735;

								BgL_za2za2resza2za2z00_17735 =
									PROCEDURE_ENTRY(BgL_bodyz00_15173) (BgL_bodyz00_15173,
									BgL_sz00_15174, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17732);
								return BgL_za2za2resza2za2z00_17735;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3505> */
	obj_t BGl_z62zc3z04anonymousza33505ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15175, obj_t BgL_sz00_15181)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15176;
				long BgL_siza7eza7_15177;
				BgL_ev_absz00_bglt BgL_i1247z00_15178;
				obj_t BgL_bodyz00_15179;
				long BgL_siza7ezd2framez75_15180;

				BgL_ifreesz00_15176 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15175, (int) (((long) 0))));
				BgL_siza7eza7_15177 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15175, (int) (((long) 1))));
				BgL_i1247z00_15178 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15175, (int) (((long) 2))));
				BgL_bodyz00_15179 = PROCEDURE_REF(BgL_envz00_15175, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15180 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15175, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17736;

					BgL_bpz00_17736 = VECTOR_REF(((obj_t) BgL_sz00_15181), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17737;

						BgL_valza2za2_17737 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15181,
							BgL_bpz00_17736, BgL_ifreesz00_15176);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17738;

							BgL_runz00_17738 =
								MAKE_FX_PROCEDURE(BGl_z62run5824z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17738,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15177));
							PROCEDURE_SET(BgL_runz00_17738,
								(int) (((long) 1)), BgL_valza2za2_17737);
							PROCEDURE_SET(BgL_runz00_17738,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15178));
							PROCEDURE_SET(BgL_runz00_17738,
								(int) (((long) 3)), BgL_bodyz00_15179);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17739;

								BgL_mainz00_17739 =
									MAKE_FX_PROCEDURE(BGl_z62main5823z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17739,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15177));
								PROCEDURE_SET(BgL_mainz00_17739,
									(int) (((long) 1)), BgL_valza2za2_17737);
								PROCEDURE_SET(BgL_mainz00_17739,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15178));
								PROCEDURE_SET(BgL_mainz00_17739,
									(int) (((long) 3)), BgL_bodyz00_15179);
								PROCEDURE_SET(BgL_mainz00_17739,
									(int) (((long) 4)), BgL_runz00_17738);
								PROCEDURE_SET(BgL_mainz00_17739,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15180));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17740;

									BgL_objz00_17740 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17738, BgL_objz00_17740);
									BgL_objz00_17740;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3507z00_17741;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3508z00_17742;

										BgL_arg3508z00_17742 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15178))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17743;

											BgL_newz00_17743 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31911;

												BgL_tmpz00_31911 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17743, BgL_tmpz00_31911,
													BgL_arg3508z00_17742);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31916;
												int BgL_tmpz00_31914;

												BgL_auxz00_31916 = BINT(BgL_siza7ezd2framez75_15180);
												BgL_tmpz00_31914 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17743, BgL_tmpz00_31914,
													BgL_auxz00_31916);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_31919;

												BgL_tmpz00_31919 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17743, BgL_tmpz00_31919,
													BgL_runz00_17738);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_31924;
												int BgL_tmpz00_31922;

												BgL_auxz00_31924 = BINT(((long) 0));
												BgL_tmpz00_31922 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17743, BgL_tmpz00_31922,
													BgL_auxz00_31924);
											}
											BgL_arg3507z00_17741 = BgL_newz00_17743;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17739, BgL_arg3507z00_17741);
									BgL_arg3507z00_17741;
								}
								return BgL_mainz00_17739;
							}
						}
					}
				}
			}
		}

	}



/* &main5823 */
	obj_t BGl_z62main5823z62zz__evaluate_compz00(obj_t BgL_envz00_15182)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15187;
				long BgL_siza7ezd2framez75_15188;

				BgL_runz00_15187 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15182, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15188 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15182, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17744;

					BgL_sz00_17744 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17745;

						BgL_bpz00_17745 = VECTOR_REF(((obj_t) BgL_sz00_17744), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17745) + BgL_siza7ezd2framez75_15188) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17744))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_17746;

								BgL_ez00_17746 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17746,
									BgL_bpz00_17745);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_17747;

									BgL_accz00_17747 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15187, BgL_sz00_17744, BgL_bpz00_17745);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17746);
									VECTOR_SET(
										((obj_t) BgL_sz00_17744), ((long) 0), BgL_bpz00_17745);
									return BgL_accz00_17747;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17748;

								BgL_nsz00_17748 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17748, ((long) 1), BgL_sz00_17744);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17749;

									BgL_z12denvz12_17749 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17749, BgL_nsz00_17748);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17750;

										BgL_ez00_17750 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17750,
											BgL_sz00_17744);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17751;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17752;

												BgL_savedzd2bpzd2_17752 =
													VECTOR_REF(BgL_nsz00_17748, ((long) 0));
												VECTOR_SET(BgL_nsz00_17748, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17754;

													BgL_fz00_17754 = BgL_runz00_15187;
												BgL_recz00_17753:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17755;

														BgL_rz00_17755 =
															PROCEDURE_ENTRY(BgL_fz00_17754) (BgL_fz00_17754,
															BgL_nsz00_17748, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6774z00_31962;

															if (PROCEDUREP(BgL_rz00_17755))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17756;

																	BgL_arg1732z00_17756 =
																		PROCEDURE_ATTR(BgL_rz00_17755);
																	if (STRUCTP(BgL_arg1732z00_17756))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6774z00_31962 =
																				(STRUCT_KEY(BgL_arg1732z00_17756) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6774z00_31962 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6774z00_31962 = ((bool_t) 0);
																}
															if (BgL_test6774z00_31962)
																{
																	obj_t BgL_fz00_31970;

																	BgL_fz00_31970 = BgL_rz00_17755;
																	BgL_fz00_17754 = BgL_fz00_31970;
																	goto BgL_recz00_17753;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17748, ((long) 0),
																		BgL_savedzd2bpzd2_17752);
																	BgL_____rz00_17751 = BgL_rz00_17755;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17750);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17749, BgL_sz00_17744);
											return BgL_____rz00_17751;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5824 */
	obj_t BGl_z62run5824z62zz__evaluate_compz00(obj_t BgL_envz00_15189,
		obj_t BgL_sz00_15194)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_15190;
				obj_t BgL_valza2za2_15191;
				BgL_ev_absz00_bglt BgL_i1247z00_15192;
				obj_t BgL_bodyz00_15193;

				BgL_siza7eza7_15190 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15189, (int) (((long) 0))));
				BgL_valza2za2_15191 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15189, (int) (((long) 1))));
				BgL_i1247z00_15192 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15189, (int) (((long) 2))));
				BgL_bodyz00_15193 = PROCEDURE_REF(BgL_envz00_15189, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17757;

					BgL_bpz00_17757 = VECTOR_REF(((obj_t) BgL_sz00_15194), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15194,
						BgL_valza2za2_15191,
						((long) CINT(BgL_bpz00_17757) + BgL_siza7eza7_15190));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17758;
						obj_t BgL_wherez00_17759;
						obj_t BgL_locz00_17760;

						BgL_z12denvz12_17758 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17759 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15192))->
							BgL_wherez00);
						BgL_locz00_17760 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15192))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17758, BgL_wherez00_17759,
								BgL_locz00_17760);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17761;

								BgL_za2za2resza2za2z00_17761 =
									PROCEDURE_ENTRY(BgL_bodyz00_15193) (BgL_bodyz00_15193,
									BgL_sz00_15194, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17758);
								return BgL_za2za2resza2za2z00_17761;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3513> */
	obj_t BGl_z62zc3z04anonymousza33513ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15195, obj_t BgL_sz00_15202)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15196;
				obj_t BgL_iboxesz00_15197;
				long BgL_siza7eza7_15198;
				BgL_ev_absz00_bglt BgL_i1247z00_15199;
				obj_t BgL_bodyz00_15200;
				long BgL_siza7ezd2framez75_15201;

				BgL_ifreesz00_15196 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 0))));
				BgL_iboxesz00_15197 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 1))));
				BgL_siza7eza7_15198 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 2))));
				BgL_i1247z00_15199 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 3))));
				BgL_bodyz00_15200 = PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15201 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15195, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17762;

					BgL_bpz00_17762 = VECTOR_REF(((obj_t) BgL_sz00_15202), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17763;

						BgL_valza2za2_17763 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15202,
							BgL_bpz00_17762, BgL_ifreesz00_15196);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17764;

							BgL_runz00_17764 =
								MAKE_FX_PROCEDURE(BGl_z62run5826z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17764,
								(int) (((long) 0)), BgL_iboxesz00_15197);
							PROCEDURE_SET(BgL_runz00_17764,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15198));
							PROCEDURE_SET(BgL_runz00_17764,
								(int) (((long) 2)), BgL_valza2za2_17763);
							PROCEDURE_SET(BgL_runz00_17764,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15199));
							PROCEDURE_SET(BgL_runz00_17764,
								(int) (((long) 4)), BgL_bodyz00_15200);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17765;

								BgL_mainz00_17765 =
									MAKE_FX_PROCEDURE(BGl_z62main5825z62zz__evaluate_compz00,
									(int) (((long) 0)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17765,
									(int) (((long) 0)), BgL_iboxesz00_15197);
								PROCEDURE_SET(BgL_mainz00_17765,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15198));
								PROCEDURE_SET(BgL_mainz00_17765,
									(int) (((long) 2)), BgL_valza2za2_17763);
								PROCEDURE_SET(BgL_mainz00_17765,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15199));
								PROCEDURE_SET(BgL_mainz00_17765,
									(int) (((long) 4)), BgL_bodyz00_15200);
								PROCEDURE_SET(BgL_mainz00_17765,
									(int) (((long) 5)), BgL_runz00_17764);
								PROCEDURE_SET(BgL_mainz00_17765,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15201));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17766;

									BgL_objz00_17766 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17764, BgL_objz00_17766);
									BgL_objz00_17766;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3514z00_17767;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3515z00_17768;

										BgL_arg3515z00_17768 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15199))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17769;

											BgL_newz00_17769 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32058;

												BgL_tmpz00_32058 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17769, BgL_tmpz00_32058,
													BgL_arg3515z00_17768);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32063;
												int BgL_tmpz00_32061;

												BgL_auxz00_32063 = BINT(BgL_siza7ezd2framez75_15201);
												BgL_tmpz00_32061 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17769, BgL_tmpz00_32061,
													BgL_auxz00_32063);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32066;

												BgL_tmpz00_32066 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17769, BgL_tmpz00_32066,
													BgL_runz00_17764);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32071;
												int BgL_tmpz00_32069;

												BgL_auxz00_32071 = BINT(((long) 0));
												BgL_tmpz00_32069 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17769, BgL_tmpz00_32069,
													BgL_auxz00_32071);
											}
											BgL_arg3514z00_17767 = BgL_newz00_17769;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17765, BgL_arg3514z00_17767);
									BgL_arg3514z00_17767;
								}
								return BgL_mainz00_17765;
							}
						}
					}
				}
			}
		}

	}



/* &main5825 */
	obj_t BGl_z62main5825z62zz__evaluate_compz00(obj_t BgL_envz00_15203)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_runz00_15209;
				long BgL_siza7ezd2framez75_15210;

				BgL_runz00_15209 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15203, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15210 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15203, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17770;

					BgL_sz00_17770 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17771;

						BgL_bpz00_17771 = VECTOR_REF(((obj_t) BgL_sz00_17770), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17771) + BgL_siza7ezd2framez75_15210) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17770))))
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_ez00_17772;

								BgL_ez00_17772 = BGL_EXITD_TOP_AS_OBJ();
								BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17772,
									BgL_bpz00_17771);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_accz00_17773;

									BgL_accz00_17773 =
										BGl_catchzd2trampolinezd2zz__evaluate_compz00
										(BgL_runz00_15209, BgL_sz00_17770, BgL_bpz00_17771);
									BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17772);
									VECTOR_SET(
										((obj_t) BgL_sz00_17770), ((long) 0), BgL_bpz00_17771);
									return BgL_accz00_17773;
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17774;

								BgL_nsz00_17774 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17774, ((long) 1), BgL_sz00_17770);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17775;

									BgL_z12denvz12_17775 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17775, BgL_nsz00_17774);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17776;

										BgL_ez00_17776 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17776,
											BgL_sz00_17770);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17777;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17778;

												BgL_savedzd2bpzd2_17778 =
													VECTOR_REF(BgL_nsz00_17774, ((long) 0));
												VECTOR_SET(BgL_nsz00_17774, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17780;

													BgL_fz00_17780 = BgL_runz00_15209;
												BgL_recz00_17779:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17781;

														BgL_rz00_17781 =
															PROCEDURE_ENTRY(BgL_fz00_17780) (BgL_fz00_17780,
															BgL_nsz00_17774, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6778z00_32109;

															if (PROCEDUREP(BgL_rz00_17781))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17782;

																	BgL_arg1732z00_17782 =
																		PROCEDURE_ATTR(BgL_rz00_17781);
																	if (STRUCTP(BgL_arg1732z00_17782))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6778z00_32109 =
																				(STRUCT_KEY(BgL_arg1732z00_17782) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6778z00_32109 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6778z00_32109 = ((bool_t) 0);
																}
															if (BgL_test6778z00_32109)
																{
																	obj_t BgL_fz00_32117;

																	BgL_fz00_32117 = BgL_rz00_17781;
																	BgL_fz00_17780 = BgL_fz00_32117;
																	goto BgL_recz00_17779;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17774, ((long) 0),
																		BgL_savedzd2bpzd2_17778);
																	BgL_____rz00_17777 = BgL_rz00_17781;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17776);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17775, BgL_sz00_17770);
											return BgL_____rz00_17777;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5826 */
	obj_t BGl_z62run5826z62zz__evaluate_compz00(obj_t BgL_envz00_15211,
		obj_t BgL_sz00_15217)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15212;
				long BgL_siza7eza7_15213;
				obj_t BgL_valza2za2_15214;
				BgL_ev_absz00_bglt BgL_i1247z00_15215;
				obj_t BgL_bodyz00_15216;

				BgL_iboxesz00_15212 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15211, (int) (((long) 0))));
				BgL_siza7eza7_15213 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15211, (int) (((long) 1))));
				BgL_valza2za2_15214 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15211, (int) (((long) 2))));
				BgL_i1247z00_15215 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15211, (int) (((long) 3))));
				BgL_bodyz00_15216 = PROCEDURE_REF(BgL_envz00_15211, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17783;

					BgL_bpz00_17783 = VECTOR_REF(((obj_t) BgL_sz00_15217), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15217,
						BgL_iboxesz00_15212, BgL_bpz00_17783);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15217,
						BgL_valza2za2_15214,
						((long) CINT(BgL_bpz00_17783) + BgL_siza7eza7_15213));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17784;
						obj_t BgL_wherez00_17785;
						obj_t BgL_locz00_17786;

						BgL_z12denvz12_17784 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17785 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15215))->
							BgL_wherez00);
						BgL_locz00_17786 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15215))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17784, BgL_wherez00_17785,
								BgL_locz00_17786);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17787;

								BgL_za2za2resza2za2z00_17787 =
									PROCEDURE_ENTRY(BgL_bodyz00_15216) (BgL_bodyz00_15216,
									BgL_sz00_15217, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17784);
								return BgL_za2za2resza2za2z00_17787;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3969> */
	obj_t BGl_z62zc3z04anonymousza33969ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15218, obj_t BgL_sz00_15222)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15219;
				obj_t BgL_bodyz00_15220;
				long BgL_siza7ezd2framez75_15221;

				BgL_i1247z00_15219 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15218, (int) (((long) 0))));
				BgL_bodyz00_15220 = PROCEDURE_REF(BgL_envz00_15218, (int) (((long) 1)));
				BgL_siza7ezd2framez75_15221 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15218, (int) (((long) 2))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17788;

					BgL_bpz00_17788 = VECTOR_REF(((obj_t) BgL_sz00_15222), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17789;

							BgL_runz00_17789 =
								MAKE_FX_PROCEDURE(BGl_z62run5828z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_runz00_17789,
								(int) (((long) 0)), ((obj_t) BgL_i1247z00_15219));
							PROCEDURE_SET(BgL_runz00_17789,
								(int) (((long) 1)), BgL_bodyz00_15220);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17790;

								BgL_mainz00_17790 =
									MAKE_VA_PROCEDURE(BGl_z62main5827z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 4)));
								PROCEDURE_SET(BgL_mainz00_17790,
									(int) (((long) 0)), BgL_bodyz00_15220);
								PROCEDURE_SET(BgL_mainz00_17790,
									(int) (((long) 1)), ((obj_t) BgL_i1247z00_15219));
								PROCEDURE_SET(BgL_mainz00_17790,
									(int) (((long) 2)), BgL_runz00_17789);
								PROCEDURE_SET(BgL_mainz00_17790,
									(int) (((long) 3)), BINT(BgL_siza7ezd2framez75_15221));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17791;

									BgL_objz00_17791 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17789, BgL_objz00_17791);
									BgL_objz00_17791;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3970z00_17792;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3971z00_17793;
										obj_t BgL_arg3972z00_17794;

										BgL_arg3971z00_17793 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15219))->
											BgL_arityz00);
										BgL_arg3972z00_17794 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15219))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17795;

											BgL_newz00_17795 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32186;

												BgL_tmpz00_32186 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17795, BgL_tmpz00_32186,
													BgL_arg3972z00_17794);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32191;
												int BgL_tmpz00_32189;

												BgL_auxz00_32191 = BINT(BgL_siza7ezd2framez75_15221);
												BgL_tmpz00_32189 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17795, BgL_tmpz00_32189,
													BgL_auxz00_32191);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32194;

												BgL_tmpz00_32194 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17795, BgL_tmpz00_32194,
													BgL_runz00_17789);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32197;

												BgL_tmpz00_32197 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17795, BgL_tmpz00_32197,
													BgL_arg3971z00_17793);
											}
											BgL_arg3970z00_17792 = BgL_newz00_17795;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17790, BgL_arg3970z00_17792);
									BgL_arg3970z00_17792;
								}
								return BgL_mainz00_17790;
							}
						}
					}
				}
			}
		}

	}



/* &main5827 */
	obj_t BGl_z62main5827z62zz__evaluate_compz00(obj_t BgL_envz00_15223,
		obj_t BgL_az00_15228, obj_t BgL_bz00_15229, obj_t BgL_cz00_15230,
		obj_t BgL_dz00_15231, obj_t BgL_restz00_15232)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15225;
				obj_t BgL_runz00_15226;
				long BgL_siza7ezd2framez75_15227;

				BgL_i1247z00_15225 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15223, (int) (((long) 1))));
				BgL_runz00_15226 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15223, (int) (((long) 2))));
				BgL_siza7ezd2framez75_15227 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15223, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17796;

					BgL_sz00_17796 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17797;

						BgL_bpz00_17797 = VECTOR_REF(((obj_t) BgL_sz00_17796), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17797) + BgL_siza7ezd2framez75_15227) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17796))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3975z00_17798;

									BgL_arg3975z00_17798 =
										((long) CINT(BgL_bpz00_17797) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17796), BgL_arg3975z00_17798,
										BgL_az00_15228);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3976z00_17799;

									BgL_arg3976z00_17799 =
										((long) CINT(BgL_bpz00_17797) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17796), BgL_arg3976z00_17799,
										BgL_bz00_15229);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3977z00_17800;

									BgL_arg3977z00_17800 =
										((long) CINT(BgL_bpz00_17797) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17796), BgL_arg3977z00_17800,
										BgL_cz00_15230);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3978z00_17801;

									BgL_arg3978z00_17801 =
										((long) CINT(BgL_bpz00_17797) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17796), BgL_arg3978z00_17801,
										BgL_dz00_15231);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3979z00_17802;
									long BgL_arg3980z00_17803;
									long BgL_arg3981z00_17804;
									obj_t BgL_arg3982z00_17805;

									BgL_arg3979z00_17802 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15225))->
										BgL_wherez00);
									BgL_arg3980z00_17803 =
										((long) CINT(BgL_bpz00_17797) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3983z00_17806;

										BgL_arg3983z00_17806 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15225))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3983z00_17806) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3981z00_17804 =
													((long) CINT(BgL_arg3983z00_17806) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3981z00_17804 =
													((long) CINT(BgL_arg3983z00_17806) - ((long) 4));
									}}
									BgL_arg3982z00_17805 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15225))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17796,
										BgL_arg3979z00_17802, BgL_arg3980z00_17803,
										BgL_arg3981z00_17804, BgL_restz00_15232,
										BgL_arg3982z00_17805);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17807;

									BgL_ez00_17807 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17807,
										BgL_bpz00_17797);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17808;

										BgL_accz00_17808 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15226, BgL_sz00_17796, BgL_bpz00_17797);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17807);
										VECTOR_SET(
											((obj_t) BgL_sz00_17796), ((long) 0), BgL_bpz00_17797);
										return BgL_accz00_17808;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17809;

								BgL_nsz00_17809 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17809, ((long) 1), BgL_sz00_17796);
								VECTOR_SET(BgL_nsz00_17809, ((long) 2), BgL_az00_15228);
								VECTOR_SET(BgL_nsz00_17809, ((long) 3), BgL_bz00_15229);
								VECTOR_SET(BgL_nsz00_17809, ((long) 4), BgL_cz00_15230);
								VECTOR_SET(BgL_nsz00_17809, ((long) 5), BgL_dz00_15231);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3984z00_17810;
									long BgL_arg3985z00_17811;
									obj_t BgL_arg3986z00_17812;

									BgL_arg3984z00_17810 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15225))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3987z00_17813;

										BgL_arg3987z00_17813 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15225))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg3987z00_17813) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3985z00_17811 =
													((long) CINT(BgL_arg3987z00_17813) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg3985z00_17811 =
													((long) CINT(BgL_arg3987z00_17813) - ((long) 4));
									}}
									BgL_arg3986z00_17812 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15225))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17809,
										BgL_arg3984z00_17810, ((long) 6), BgL_arg3985z00_17811,
										BgL_restz00_15232, BgL_arg3986z00_17812);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17814;

									BgL_z12denvz12_17814 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17814, BgL_nsz00_17809);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17815;

										BgL_ez00_17815 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17815,
											BgL_sz00_17796);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17816;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17817;

												BgL_savedzd2bpzd2_17817 =
													VECTOR_REF(BgL_nsz00_17809, ((long) 0));
												VECTOR_SET(BgL_nsz00_17809, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17819;

													BgL_fz00_17819 = BgL_runz00_15226;
												BgL_recz00_17818:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17820;

														BgL_rz00_17820 =
															PROCEDURE_ENTRY(BgL_fz00_17819) (BgL_fz00_17819,
															BgL_nsz00_17809, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6784z00_32282;

															if (PROCEDUREP(BgL_rz00_17820))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17821;

																	BgL_arg1732z00_17821 =
																		PROCEDURE_ATTR(BgL_rz00_17820);
																	if (STRUCTP(BgL_arg1732z00_17821))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6784z00_32282 =
																				(STRUCT_KEY(BgL_arg1732z00_17821) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6784z00_32282 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6784z00_32282 = ((bool_t) 0);
																}
															if (BgL_test6784z00_32282)
																{
																	obj_t BgL_fz00_32290;

																	BgL_fz00_32290 = BgL_rz00_17820;
																	BgL_fz00_17819 = BgL_fz00_32290;
																	goto BgL_recz00_17818;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17809, ((long) 0),
																		BgL_savedzd2bpzd2_17817);
																	BgL_____rz00_17816 = BgL_rz00_17820;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17815);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17814, BgL_sz00_17796);
											return BgL_____rz00_17816;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5828 */
	obj_t BGl_z62run5828z62zz__evaluate_compz00(obj_t BgL_envz00_15233,
		obj_t BgL_sz00_15236)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15234;
				obj_t BgL_bodyz00_15235;

				BgL_i1247z00_15234 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15233, (int) (((long) 0))));
				BgL_bodyz00_15235 = PROCEDURE_REF(BgL_envz00_15233, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17822;

					BgL_bpz00_17822 = VECTOR_REF(((obj_t) BgL_sz00_15236), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17823;
						obj_t BgL_wherez00_17824;
						obj_t BgL_locz00_17825;

						BgL_z12denvz12_17823 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17824 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->
							BgL_wherez00);
						BgL_locz00_17825 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15234))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17823, BgL_wherez00_17824,
								BgL_locz00_17825);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17826;

								BgL_za2za2resza2za2z00_17826 =
									PROCEDURE_ENTRY(BgL_bodyz00_15235) (BgL_bodyz00_15235,
									BgL_sz00_15236, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17823);
								return BgL_za2za2resza2za2z00_17826;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3989> */
	obj_t BGl_z62zc3z04anonymousza33989ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15237, obj_t BgL_sz00_15242)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15238;
				BgL_ev_absz00_bglt BgL_i1247z00_15239;
				obj_t BgL_bodyz00_15240;
				long BgL_siza7ezd2framez75_15241;

				BgL_iboxesz00_15238 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15237, (int) (((long) 0))));
				BgL_i1247z00_15239 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15237, (int) (((long) 1))));
				BgL_bodyz00_15240 = PROCEDURE_REF(BgL_envz00_15237, (int) (((long) 2)));
				BgL_siza7ezd2framez75_15241 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15237, (int) (((long) 3))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17827;

					BgL_bpz00_17827 = VECTOR_REF(((obj_t) BgL_sz00_15242), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */

						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17828;

							BgL_runz00_17828 =
								MAKE_FX_PROCEDURE(BGl_z62run5830z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_runz00_17828,
								(int) (((long) 0)), BgL_iboxesz00_15238);
							PROCEDURE_SET(BgL_runz00_17828,
								(int) (((long) 1)), ((obj_t) BgL_i1247z00_15239));
							PROCEDURE_SET(BgL_runz00_17828,
								(int) (((long) 2)), BgL_bodyz00_15240);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17829;

								BgL_mainz00_17829 =
									MAKE_VA_PROCEDURE(BGl_z62main5829z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_mainz00_17829,
									(int) (((long) 0)), BgL_iboxesz00_15238);
								PROCEDURE_SET(BgL_mainz00_17829,
									(int) (((long) 1)), BgL_bodyz00_15240);
								PROCEDURE_SET(BgL_mainz00_17829,
									(int) (((long) 2)), ((obj_t) BgL_i1247z00_15239));
								PROCEDURE_SET(BgL_mainz00_17829,
									(int) (((long) 3)), BgL_runz00_17828);
								PROCEDURE_SET(BgL_mainz00_17829,
									(int) (((long) 4)), BINT(BgL_siza7ezd2framez75_15241));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17830;

									BgL_objz00_17830 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17828, BgL_objz00_17830);
									BgL_objz00_17830;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg3990z00_17831;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg3992z00_17832;
										obj_t BgL_arg3993z00_17833;

										BgL_arg3992z00_17832 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15239))->
											BgL_arityz00);
										BgL_arg3993z00_17833 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15239))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17834;

											BgL_newz00_17834 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32353;

												BgL_tmpz00_32353 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17834, BgL_tmpz00_32353,
													BgL_arg3993z00_17833);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32358;
												int BgL_tmpz00_32356;

												BgL_auxz00_32358 = BINT(BgL_siza7ezd2framez75_15241);
												BgL_tmpz00_32356 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17834, BgL_tmpz00_32356,
													BgL_auxz00_32358);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32361;

												BgL_tmpz00_32361 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17834, BgL_tmpz00_32361,
													BgL_runz00_17828);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32364;

												BgL_tmpz00_32364 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17834, BgL_tmpz00_32364,
													BgL_arg3992z00_17832);
											}
											BgL_arg3990z00_17831 = BgL_newz00_17834;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17829, BgL_arg3990z00_17831);
									BgL_arg3990z00_17831;
								}
								return BgL_mainz00_17829;
							}
						}
					}
				}
			}
		}

	}



/* &main5829 */
	obj_t BGl_z62main5829z62zz__evaluate_compz00(obj_t BgL_envz00_15243,
		obj_t BgL_az00_15249, obj_t BgL_bz00_15250, obj_t BgL_cz00_15251,
		obj_t BgL_dz00_15252, obj_t BgL_restz00_15253)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15246;
				obj_t BgL_runz00_15247;
				long BgL_siza7ezd2framez75_15248;

				BgL_i1247z00_15246 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15243, (int) (((long) 2))));
				BgL_runz00_15247 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15243, (int) (((long) 3))));
				BgL_siza7ezd2framez75_15248 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15243, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17835;

					BgL_sz00_17835 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17836;

						BgL_bpz00_17836 = VECTOR_REF(((obj_t) BgL_sz00_17835), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17836) + BgL_siza7ezd2framez75_15248) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17835))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3996z00_17837;

									BgL_arg3996z00_17837 =
										((long) CINT(BgL_bpz00_17836) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17835), BgL_arg3996z00_17837,
										BgL_az00_15249);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3997z00_17838;

									BgL_arg3997z00_17838 =
										((long) CINT(BgL_bpz00_17836) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17835), BgL_arg3997z00_17838,
										BgL_bz00_15250);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3998z00_17839;

									BgL_arg3998z00_17839 =
										((long) CINT(BgL_bpz00_17836) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17835), BgL_arg3998z00_17839,
										BgL_cz00_15251);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg3999z00_17840;

									BgL_arg3999z00_17840 =
										((long) CINT(BgL_bpz00_17836) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17835), BgL_arg3999z00_17840,
										BgL_dz00_15252);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4000z00_17841;
									long BgL_arg4001z00_17842;
									long BgL_arg4002z00_17843;
									obj_t BgL_arg4003z00_17844;

									BgL_arg4000z00_17841 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15246))->
										BgL_wherez00);
									BgL_arg4001z00_17842 =
										((long) CINT(BgL_bpz00_17836) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4004z00_17845;

										BgL_arg4004z00_17845 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15246))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4004z00_17845) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4002z00_17843 =
													((long) CINT(BgL_arg4004z00_17845) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4002z00_17843 =
													((long) CINT(BgL_arg4004z00_17845) - ((long) 4));
									}}
									BgL_arg4003z00_17844 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15246))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17835,
										BgL_arg4000z00_17841, BgL_arg4001z00_17842,
										BgL_arg4002z00_17843, BgL_restz00_15253,
										BgL_arg4003z00_17844);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17846;

									BgL_ez00_17846 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17846,
										BgL_bpz00_17836);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17847;

										BgL_accz00_17847 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15247, BgL_sz00_17835, BgL_bpz00_17836);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17846);
										VECTOR_SET(
											((obj_t) BgL_sz00_17835), ((long) 0), BgL_bpz00_17836);
										return BgL_accz00_17847;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17848;

								BgL_nsz00_17848 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17848, ((long) 1), BgL_sz00_17835);
								VECTOR_SET(BgL_nsz00_17848, ((long) 2), BgL_az00_15249);
								VECTOR_SET(BgL_nsz00_17848, ((long) 3), BgL_bz00_15250);
								VECTOR_SET(BgL_nsz00_17848, ((long) 4), BgL_cz00_15251);
								VECTOR_SET(BgL_nsz00_17848, ((long) 5), BgL_dz00_15252);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4005z00_17849;
									long BgL_arg4006z00_17850;
									obj_t BgL_arg4007z00_17851;

									BgL_arg4005z00_17849 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15246))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4008z00_17852;

										BgL_arg4008z00_17852 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15246))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4008z00_17852) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4006z00_17850 =
													((long) CINT(BgL_arg4008z00_17852) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4006z00_17850 =
													((long) CINT(BgL_arg4008z00_17852) - ((long) 4));
									}}
									BgL_arg4007z00_17851 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15246))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17848,
										BgL_arg4005z00_17849, ((long) 6), BgL_arg4006z00_17850,
										BgL_restz00_15253, BgL_arg4007z00_17851);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17853;

									BgL_z12denvz12_17853 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17853, BgL_nsz00_17848);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17854;

										BgL_ez00_17854 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17854,
											BgL_sz00_17835);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17855;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17856;

												BgL_savedzd2bpzd2_17856 =
													VECTOR_REF(BgL_nsz00_17848, ((long) 0));
												VECTOR_SET(BgL_nsz00_17848, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17858;

													BgL_fz00_17858 = BgL_runz00_15247;
												BgL_recz00_17857:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17859;

														BgL_rz00_17859 =
															PROCEDURE_ENTRY(BgL_fz00_17858) (BgL_fz00_17858,
															BgL_nsz00_17848, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6790z00_32449;

															if (PROCEDUREP(BgL_rz00_17859))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17860;

																	BgL_arg1732z00_17860 =
																		PROCEDURE_ATTR(BgL_rz00_17859);
																	if (STRUCTP(BgL_arg1732z00_17860))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6790z00_32449 =
																				(STRUCT_KEY(BgL_arg1732z00_17860) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6790z00_32449 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6790z00_32449 = ((bool_t) 0);
																}
															if (BgL_test6790z00_32449)
																{
																	obj_t BgL_fz00_32457;

																	BgL_fz00_32457 = BgL_rz00_17859;
																	BgL_fz00_17858 = BgL_fz00_32457;
																	goto BgL_recz00_17857;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17848, ((long) 0),
																		BgL_savedzd2bpzd2_17856);
																	BgL_____rz00_17855 = BgL_rz00_17859;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17854);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17853, BgL_sz00_17835);
											return BgL_____rz00_17855;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5830 */
	obj_t BGl_z62run5830z62zz__evaluate_compz00(obj_t BgL_envz00_15254,
		obj_t BgL_sz00_15258)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15255;
				BgL_ev_absz00_bglt BgL_i1247z00_15256;
				obj_t BgL_bodyz00_15257;

				BgL_iboxesz00_15255 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15254, (int) (((long) 0))));
				BgL_i1247z00_15256 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15254, (int) (((long) 1))));
				BgL_bodyz00_15257 = PROCEDURE_REF(BgL_envz00_15254, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17861;

					BgL_bpz00_17861 = VECTOR_REF(((obj_t) BgL_sz00_15258), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15258,
						BgL_iboxesz00_15255, BgL_bpz00_17861);
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_z12denvz12_17862;
						obj_t BgL_wherez00_17863;
						obj_t BgL_locz00_17864;

						BgL_z12denvz12_17862 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17863 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15256))->
							BgL_wherez00);
						BgL_locz00_17864 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15256))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1174 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17862, BgL_wherez00_17863,
								BgL_locz00_17864);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_za2za2resza2za2z00_17865;

								BgL_za2za2resza2za2z00_17865 =
									PROCEDURE_ENTRY(BgL_bodyz00_15257) (BgL_bodyz00_15257,
									BgL_sz00_15258, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17862);
								return BgL_za2za2resza2za2z00_17865;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:4013> */
	obj_t BGl_z62zc3z04anonymousza34013ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15259, obj_t BgL_sz00_15265)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15260;
				long BgL_siza7eza7_15261;
				BgL_ev_absz00_bglt BgL_i1247z00_15262;
				obj_t BgL_bodyz00_15263;
				long BgL_siza7ezd2framez75_15264;

				BgL_ifreesz00_15260 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15259, (int) (((long) 0))));
				BgL_siza7eza7_15261 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15259, (int) (((long) 1))));
				BgL_i1247z00_15262 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15259, (int) (((long) 2))));
				BgL_bodyz00_15263 = PROCEDURE_REF(BgL_envz00_15259, (int) (((long) 3)));
				BgL_siza7ezd2framez75_15264 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15259, (int) (((long) 4))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17866;

					BgL_bpz00_17866 = VECTOR_REF(((obj_t) BgL_sz00_15265), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17867;

						BgL_valza2za2_17867 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15265,
							BgL_bpz00_17866, BgL_ifreesz00_15260);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17868;

							BgL_runz00_17868 =
								MAKE_FX_PROCEDURE(BGl_z62run5832z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 4)));
							PROCEDURE_SET(BgL_runz00_17868,
								(int) (((long) 0)), BINT(BgL_siza7eza7_15261));
							PROCEDURE_SET(BgL_runz00_17868,
								(int) (((long) 1)), BgL_valza2za2_17867);
							PROCEDURE_SET(BgL_runz00_17868,
								(int) (((long) 2)), ((obj_t) BgL_i1247z00_15262));
							PROCEDURE_SET(BgL_runz00_17868,
								(int) (((long) 3)), BgL_bodyz00_15263);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17869;

								BgL_mainz00_17869 =
									MAKE_VA_PROCEDURE(BGl_z62main5831z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 6)));
								PROCEDURE_SET(BgL_mainz00_17869,
									(int) (((long) 0)), BINT(BgL_siza7eza7_15261));
								PROCEDURE_SET(BgL_mainz00_17869,
									(int) (((long) 1)), BgL_valza2za2_17867);
								PROCEDURE_SET(BgL_mainz00_17869,
									(int) (((long) 2)), BgL_bodyz00_15263);
								PROCEDURE_SET(BgL_mainz00_17869,
									(int) (((long) 3)), ((obj_t) BgL_i1247z00_15262));
								PROCEDURE_SET(BgL_mainz00_17869,
									(int) (((long) 4)), BgL_runz00_17868);
								PROCEDURE_SET(BgL_mainz00_17869,
									(int) (((long) 5)), BINT(BgL_siza7ezd2framez75_15264));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17870;

									BgL_objz00_17870 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17868, BgL_objz00_17870);
									BgL_objz00_17870;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4014z00_17871;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4015z00_17872;
										obj_t BgL_arg4016z00_17873;

										BgL_arg4015z00_17872 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15262))->
											BgL_arityz00);
										BgL_arg4016z00_17873 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15262))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17874;

											BgL_newz00_17874 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32534;

												BgL_tmpz00_32534 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17874, BgL_tmpz00_32534,
													BgL_arg4016z00_17873);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32539;
												int BgL_tmpz00_32537;

												BgL_auxz00_32539 = BINT(BgL_siza7ezd2framez75_15264);
												BgL_tmpz00_32537 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17874, BgL_tmpz00_32537,
													BgL_auxz00_32539);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32542;

												BgL_tmpz00_32542 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17874, BgL_tmpz00_32542,
													BgL_runz00_17868);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32545;

												BgL_tmpz00_32545 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17874, BgL_tmpz00_32545,
													BgL_arg4015z00_17872);
											}
											BgL_arg4014z00_17871 = BgL_newz00_17874;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17869, BgL_arg4014z00_17871);
									BgL_arg4014z00_17871;
								}
								return BgL_mainz00_17869;
							}
						}
					}
				}
			}
		}

	}



/* &main5831 */
	obj_t BGl_z62main5831z62zz__evaluate_compz00(obj_t BgL_envz00_15266,
		obj_t BgL_az00_15273, obj_t BgL_bz00_15274, obj_t BgL_cz00_15275,
		obj_t BgL_dz00_15276, obj_t BgL_restz00_15277)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15270;
				obj_t BgL_runz00_15271;
				long BgL_siza7ezd2framez75_15272;

				BgL_i1247z00_15270 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15266, (int) (((long) 3))));
				BgL_runz00_15271 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15266, (int) (((long) 4))));
				BgL_siza7ezd2framez75_15272 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15266, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17875;

					BgL_sz00_17875 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17876;

						BgL_bpz00_17876 = VECTOR_REF(((obj_t) BgL_sz00_17875), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17876) + BgL_siza7ezd2framez75_15272) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17875))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4019z00_17877;

									BgL_arg4019z00_17877 =
										((long) CINT(BgL_bpz00_17876) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17875), BgL_arg4019z00_17877,
										BgL_az00_15273);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4020z00_17878;

									BgL_arg4020z00_17878 =
										((long) CINT(BgL_bpz00_17876) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17875), BgL_arg4020z00_17878,
										BgL_bz00_15274);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4021z00_17879;

									BgL_arg4021z00_17879 =
										((long) CINT(BgL_bpz00_17876) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17875), BgL_arg4021z00_17879,
										BgL_cz00_15275);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4022z00_17880;

									BgL_arg4022z00_17880 =
										((long) CINT(BgL_bpz00_17876) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17875), BgL_arg4022z00_17880,
										BgL_dz00_15276);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4023z00_17881;
									long BgL_arg4024z00_17882;
									long BgL_arg4025z00_17883;
									obj_t BgL_arg4026z00_17884;

									BgL_arg4023z00_17881 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15270))->
										BgL_wherez00);
									BgL_arg4024z00_17882 =
										((long) CINT(BgL_bpz00_17876) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4027z00_17885;

										BgL_arg4027z00_17885 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15270))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4027z00_17885) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4025z00_17883 =
													((long) CINT(BgL_arg4027z00_17885) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4025z00_17883 =
													((long) CINT(BgL_arg4027z00_17885) - ((long) 4));
									}}
									BgL_arg4026z00_17884 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15270))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17875,
										BgL_arg4023z00_17881, BgL_arg4024z00_17882,
										BgL_arg4025z00_17883, BgL_restz00_15277,
										BgL_arg4026z00_17884);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17886;

									BgL_ez00_17886 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17886,
										BgL_bpz00_17876);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17887;

										BgL_accz00_17887 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15271, BgL_sz00_17875, BgL_bpz00_17876);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17886);
										VECTOR_SET(
											((obj_t) BgL_sz00_17875), ((long) 0), BgL_bpz00_17876);
										return BgL_accz00_17887;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17888;

								BgL_nsz00_17888 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17888, ((long) 1), BgL_sz00_17875);
								VECTOR_SET(BgL_nsz00_17888, ((long) 2), BgL_az00_15273);
								VECTOR_SET(BgL_nsz00_17888, ((long) 3), BgL_bz00_15274);
								VECTOR_SET(BgL_nsz00_17888, ((long) 4), BgL_cz00_15275);
								VECTOR_SET(BgL_nsz00_17888, ((long) 5), BgL_dz00_15276);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4028z00_17889;
									long BgL_arg4029z00_17890;
									obj_t BgL_arg4030z00_17891;

									BgL_arg4028z00_17889 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15270))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4031z00_17892;

										BgL_arg4031z00_17892 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15270))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4031z00_17892) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4029z00_17890 =
													((long) CINT(BgL_arg4031z00_17892) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4029z00_17890 =
													((long) CINT(BgL_arg4031z00_17892) - ((long) 4));
									}}
									BgL_arg4030z00_17891 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15270))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17888,
										BgL_arg4028z00_17889, ((long) 6), BgL_arg4029z00_17890,
										BgL_restz00_15277, BgL_arg4030z00_17891);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17893;

									BgL_z12denvz12_17893 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17893, BgL_nsz00_17888);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17894;

										BgL_ez00_17894 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17894,
											BgL_sz00_17875);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17895;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17896;

												BgL_savedzd2bpzd2_17896 =
													VECTOR_REF(BgL_nsz00_17888, ((long) 0));
												VECTOR_SET(BgL_nsz00_17888, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17898;

													BgL_fz00_17898 = BgL_runz00_15271;
												BgL_recz00_17897:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17899;

														BgL_rz00_17899 =
															PROCEDURE_ENTRY(BgL_fz00_17898) (BgL_fz00_17898,
															BgL_nsz00_17888, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6796z00_32630;

															if (PROCEDUREP(BgL_rz00_17899))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17900;

																	BgL_arg1732z00_17900 =
																		PROCEDURE_ATTR(BgL_rz00_17899);
																	if (STRUCTP(BgL_arg1732z00_17900))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6796z00_32630 =
																				(STRUCT_KEY(BgL_arg1732z00_17900) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6796z00_32630 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6796z00_32630 = ((bool_t) 0);
																}
															if (BgL_test6796z00_32630)
																{
																	obj_t BgL_fz00_32638;

																	BgL_fz00_32638 = BgL_rz00_17899;
																	BgL_fz00_17898 = BgL_fz00_32638;
																	goto BgL_recz00_17897;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17888, ((long) 0),
																		BgL_savedzd2bpzd2_17896);
																	BgL_____rz00_17895 = BgL_rz00_17899;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17894);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17893, BgL_sz00_17875);
											return BgL_____rz00_17895;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5832 */
	obj_t BGl_z62run5832z62zz__evaluate_compz00(obj_t BgL_envz00_15278,
		obj_t BgL_sz00_15283)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				long BgL_siza7eza7_15279;
				obj_t BgL_valza2za2_15280;
				BgL_ev_absz00_bglt BgL_i1247z00_15281;
				obj_t BgL_bodyz00_15282;

				BgL_siza7eza7_15279 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15278, (int) (((long) 0))));
				BgL_valza2za2_15280 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15278, (int) (((long) 1))));
				BgL_i1247z00_15281 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15278, (int) (((long) 2))));
				BgL_bodyz00_15282 = PROCEDURE_REF(BgL_envz00_15278, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17901;

					BgL_bpz00_17901 = VECTOR_REF(((obj_t) BgL_sz00_15283), ((long) 0));
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15283,
						BgL_valza2za2_15280,
						((long) CINT(BgL_bpz00_17901) + BgL_siza7eza7_15279));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17902;
						obj_t BgL_wherez00_17903;
						obj_t BgL_locz00_17904;

						BgL_z12denvz12_17902 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17903 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15281))->
							BgL_wherez00);
						BgL_locz00_17904 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15281))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17902, BgL_wherez00_17903,
								BgL_locz00_17904);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17905;

								BgL_za2za2resza2za2z00_17905 =
									PROCEDURE_ENTRY(BgL_bodyz00_15282) (BgL_bodyz00_15282,
									BgL_sz00_15283, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17902);
								return BgL_za2za2resza2za2z00_17905;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:4034> */
	obj_t BGl_z62zc3z04anonymousza34034ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15284, obj_t BgL_sz00_15291)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_ifreesz00_15285;
				obj_t BgL_iboxesz00_15286;
				long BgL_siza7eza7_15287;
				BgL_ev_absz00_bglt BgL_i1247z00_15288;
				obj_t BgL_bodyz00_15289;
				long BgL_siza7ezd2framez75_15290;

				BgL_ifreesz00_15285 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15284, (int) (((long) 0))));
				BgL_iboxesz00_15286 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15284, (int) (((long) 1))));
				BgL_siza7eza7_15287 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15284, (int) (((long) 2))));
				BgL_i1247z00_15288 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15284, (int) (((long) 3))));
				BgL_bodyz00_15289 = PROCEDURE_REF(BgL_envz00_15284, (int) (((long) 4)));
				BgL_siza7ezd2framez75_15290 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15284, (int) (((long) 5))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17906;

					BgL_bpz00_17906 = VECTOR_REF(((obj_t) BgL_sz00_15291), ((long) 0));
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_valza2za2_17907;

						BgL_valza2za2_17907 =
							BGl_freezd2collectzd2zz__evaluate_compz00(BgL_sz00_15291,
							BgL_bpz00_17906, BgL_ifreesz00_15285);
						{	/* Eval/evaluate_comp.scm 1174 */
							obj_t BgL_runz00_17908;

							BgL_runz00_17908 =
								MAKE_FX_PROCEDURE(BGl_z62run5834z62zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 5)));
							PROCEDURE_SET(BgL_runz00_17908,
								(int) (((long) 0)), BgL_iboxesz00_15286);
							PROCEDURE_SET(BgL_runz00_17908,
								(int) (((long) 1)), BINT(BgL_siza7eza7_15287));
							PROCEDURE_SET(BgL_runz00_17908,
								(int) (((long) 2)), BgL_valza2za2_17907);
							PROCEDURE_SET(BgL_runz00_17908,
								(int) (((long) 3)), ((obj_t) BgL_i1247z00_15288));
							PROCEDURE_SET(BgL_runz00_17908,
								(int) (((long) 4)), BgL_bodyz00_15289);
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_mainz00_17909;

								BgL_mainz00_17909 =
									MAKE_VA_PROCEDURE(BGl_z62main5833z62zz__evaluate_compz00,
									(int) (((long) -5)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_mainz00_17909,
									(int) (((long) 0)), BgL_iboxesz00_15286);
								PROCEDURE_SET(BgL_mainz00_17909,
									(int) (((long) 1)), BINT(BgL_siza7eza7_15287));
								PROCEDURE_SET(BgL_mainz00_17909,
									(int) (((long) 2)), BgL_valza2za2_17907);
								PROCEDURE_SET(BgL_mainz00_17909,
									(int) (((long) 3)), BgL_bodyz00_15289);
								PROCEDURE_SET(BgL_mainz00_17909,
									(int) (((long) 4)), ((obj_t) BgL_i1247z00_15288));
								PROCEDURE_SET(BgL_mainz00_17909,
									(int) (((long) 5)), BgL_runz00_17908);
								PROCEDURE_SET(BgL_mainz00_17909,
									(int) (((long) 6)), BINT(BgL_siza7ezd2framez75_15290));
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_objz00_17910;

									BgL_objz00_17910 =
										BGl_za2za2azd2bounceza2za2zd2zz__evaluate_compz00;
									PROCEDURE_ATTR_SET(BgL_runz00_17908, BgL_objz00_17910);
									BgL_objz00_17910;
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4035z00_17911;

									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4036z00_17912;
										obj_t BgL_arg4037z00_17913;

										BgL_arg4036z00_17912 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15288))->
											BgL_arityz00);
										BgL_arg4037z00_17913 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15288))->
											BgL_wherez00);
										{	/* Eval/evaluate_comp.scm 683 */
											obj_t BgL_newz00_17914;

											BgL_newz00_17914 =
												create_struct(BGl_symbol5864z00zz__evaluate_compz00,
												(int) (((long) 4)));
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32727;

												BgL_tmpz00_32727 = (int) (((long) 3));
												STRUCT_SET(BgL_newz00_17914, BgL_tmpz00_32727,
													BgL_arg4037z00_17913);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												obj_t BgL_auxz00_32732;
												int BgL_tmpz00_32730;

												BgL_auxz00_32732 = BINT(BgL_siza7ezd2framez75_15290);
												BgL_tmpz00_32730 = (int) (((long) 2));
												STRUCT_SET(BgL_newz00_17914, BgL_tmpz00_32730,
													BgL_auxz00_32732);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32735;

												BgL_tmpz00_32735 = (int) (((long) 1));
												STRUCT_SET(BgL_newz00_17914, BgL_tmpz00_32735,
													BgL_runz00_17908);
											}
											{	/* Eval/evaluate_comp.scm 683 */
												int BgL_tmpz00_32738;

												BgL_tmpz00_32738 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_17914, BgL_tmpz00_32738,
													BgL_arg4036z00_17912);
											}
											BgL_arg4035z00_17911 = BgL_newz00_17914;
									}}
									PROCEDURE_ATTR_SET(BgL_mainz00_17909, BgL_arg4035z00_17911);
									BgL_arg4035z00_17911;
								}
								return BgL_mainz00_17909;
							}
						}
					}
				}
			}
		}

	}



/* &main5833 */
	obj_t BGl_z62main5833z62zz__evaluate_compz00(obj_t BgL_envz00_15292,
		obj_t BgL_az00_15300, obj_t BgL_bz00_15301, obj_t BgL_cz00_15302,
		obj_t BgL_dz00_15303, obj_t BgL_restz00_15304)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				BgL_ev_absz00_bglt BgL_i1247z00_15297;
				obj_t BgL_runz00_15298;
				long BgL_siza7ezd2framez75_15299;

				BgL_i1247z00_15297 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15292, (int) (((long) 4))));
				BgL_runz00_15298 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15292, (int) (((long) 5))));
				BgL_siza7ezd2framez75_15299 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15292, (int) (((long) 6))));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_sz00_17915;

					BgL_sz00_17915 = BGl_findzd2statezd2zz__evaluate_compz00();
					{	/* Eval/evaluate_comp.scm 1174 */
						obj_t BgL_bpz00_17916;

						BgL_bpz00_17916 = VECTOR_REF(((obj_t) BgL_sz00_17915), ((long) 0));
						if (
							(((long) CINT(BgL_bpz00_17916) + BgL_siza7ezd2framez75_15299) <
								VECTOR_LENGTH(((obj_t) BgL_sz00_17915))))
							{	/* Eval/evaluate_comp.scm 1174 */
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4040z00_17917;

									BgL_arg4040z00_17917 =
										((long) CINT(BgL_bpz00_17916) + ((long) 0));
									VECTOR_SET(
										((obj_t) BgL_sz00_17915), BgL_arg4040z00_17917,
										BgL_az00_15300);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4041z00_17918;

									BgL_arg4041z00_17918 =
										((long) CINT(BgL_bpz00_17916) + ((long) 1));
									VECTOR_SET(
										((obj_t) BgL_sz00_17915), BgL_arg4041z00_17918,
										BgL_bz00_15301);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4042z00_17919;

									BgL_arg4042z00_17919 =
										((long) CINT(BgL_bpz00_17916) + ((long) 2));
									VECTOR_SET(
										((obj_t) BgL_sz00_17915), BgL_arg4042z00_17919,
										BgL_cz00_15302);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									long BgL_arg4043z00_17920;

									BgL_arg4043z00_17920 =
										((long) CINT(BgL_bpz00_17916) + ((long) 3));
									VECTOR_SET(
										((obj_t) BgL_sz00_17915), BgL_arg4043z00_17920,
										BgL_dz00_15303);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4044z00_17921;
									long BgL_arg4045z00_17922;
									long BgL_arg4046z00_17923;
									obj_t BgL_arg4047z00_17924;

									BgL_arg4044z00_17921 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15297))->
										BgL_wherez00);
									BgL_arg4045z00_17922 =
										((long) CINT(BgL_bpz00_17916) + ((long) 4));
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4048z00_17925;

										BgL_arg4048z00_17925 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15297))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4048z00_17925) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4046z00_17923 =
													((long) CINT(BgL_arg4048z00_17925) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4046z00_17923 =
													((long) CINT(BgL_arg4048z00_17925) - ((long) 4));
									}}
									BgL_arg4047z00_17924 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15297))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_sz00_17915,
										BgL_arg4044z00_17921, BgL_arg4045z00_17922,
										BgL_arg4046z00_17923, BgL_restz00_15304,
										BgL_arg4047z00_17924);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_ez00_17926;

									BgL_ez00_17926 = BGL_EXITD_TOP_AS_OBJ();
									BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17926,
										BgL_bpz00_17916);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_accz00_17927;

										BgL_accz00_17927 =
											BGl_catchzd2trampolinezd2zz__evaluate_compz00
											(BgL_runz00_15298, BgL_sz00_17915, BgL_bpz00_17916);
										BGl_exitdzd2popzd2protectz12z12zz__bexitz00(BgL_ez00_17926);
										VECTOR_SET(
											((obj_t) BgL_sz00_17915), ((long) 0), BgL_bpz00_17916);
										return BgL_accz00_17927;
									}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 1174 */
								obj_t BgL_nsz00_17928;

								BgL_nsz00_17928 = BGl_makezd2statezd2zz__evaluate_compz00();
								VECTOR_SET(BgL_nsz00_17928, ((long) 1), BgL_sz00_17915);
								VECTOR_SET(BgL_nsz00_17928, ((long) 2), BgL_az00_15300);
								VECTOR_SET(BgL_nsz00_17928, ((long) 3), BgL_bz00_15301);
								VECTOR_SET(BgL_nsz00_17928, ((long) 4), BgL_cz00_15302);
								VECTOR_SET(BgL_nsz00_17928, ((long) 5), BgL_dz00_15303);
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_arg4049z00_17929;
									long BgL_arg4050z00_17930;
									obj_t BgL_arg4051z00_17931;

									BgL_arg4049z00_17929 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15297))->
										BgL_wherez00);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_arg4052z00_17932;

										BgL_arg4052z00_17932 =
											(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15297))->
											BgL_arityz00);
										if (((long) CINT(BgL_arg4052z00_17932) < ((long) 0)))
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4050z00_17930 =
													((long) CINT(BgL_arg4052z00_17932) + ((long) 4));
											}
										else
											{	/* Eval/evaluate_comp.scm 1059 */
												BgL_arg4050z00_17930 =
													((long) CINT(BgL_arg4052z00_17932) - ((long) 4));
									}}
									BgL_arg4051z00_17931 =
										(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15297))->
										BgL_locz00);
									BGl_bindzd2framezd2zz__evaluate_compz00(BgL_nsz00_17928,
										BgL_arg4049z00_17929, ((long) 6), BgL_arg4050z00_17930,
										BgL_restz00_15304, BgL_arg4051z00_17931);
								}
								{	/* Eval/evaluate_comp.scm 1174 */
									obj_t BgL_z12denvz12_17933;

									BgL_z12denvz12_17933 = BGL_CURRENT_DYNAMIC_ENV();
									BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17933, BgL_nsz00_17928);
									{	/* Eval/evaluate_comp.scm 1174 */
										obj_t BgL_ez00_17934;

										BgL_ez00_17934 = BGL_EXITD_TOP_AS_OBJ();
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(BgL_ez00_17934,
											BgL_sz00_17915);
										{	/* Eval/evaluate_comp.scm 1174 */
											obj_t BgL_____rz00_17935;

											{	/* Eval/evaluate_comp.scm 670 */
												obj_t BgL_savedzd2bpzd2_17936;

												BgL_savedzd2bpzd2_17936 =
													VECTOR_REF(BgL_nsz00_17928, ((long) 0));
												VECTOR_SET(BgL_nsz00_17928, ((long) 0),
													BINT(((long) 2)));
												{
													obj_t BgL_fz00_17938;

													BgL_fz00_17938 = BgL_runz00_15298;
												BgL_recz00_17937:
													{	/* Eval/evaluate_comp.scm 673 */
														obj_t BgL_rz00_17939;

														BgL_rz00_17939 =
															PROCEDURE_ENTRY(BgL_fz00_17938) (BgL_fz00_17938,
															BgL_nsz00_17928, BEOA);
														{	/* Eval/evaluate_comp.scm 674 */
															bool_t BgL_test6802z00_32823;

															if (PROCEDUREP(BgL_rz00_17939))
																{	/* Eval/evaluate_comp.scm 674 */
																	obj_t BgL_arg1732z00_17940;

																	BgL_arg1732z00_17940 =
																		PROCEDURE_ATTR(BgL_rz00_17939);
																	if (STRUCTP(BgL_arg1732z00_17940))
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6802z00_32823 =
																				(STRUCT_KEY(BgL_arg1732z00_17940) ==
																				BGl_symbol5843z00zz__evaluate_compz00);
																		}
																	else
																		{	/* Eval/evaluate_comp.scm 654 */
																			BgL_test6802z00_32823 = ((bool_t) 0);
																		}
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	BgL_test6802z00_32823 = ((bool_t) 0);
																}
															if (BgL_test6802z00_32823)
																{
																	obj_t BgL_fz00_32831;

																	BgL_fz00_32831 = BgL_rz00_17939;
																	BgL_fz00_17938 = BgL_fz00_32831;
																	goto BgL_recz00_17937;
																}
															else
																{	/* Eval/evaluate_comp.scm 674 */
																	VECTOR_SET(BgL_nsz00_17928, ((long) 0),
																		BgL_savedzd2bpzd2_17936);
																	BgL_____rz00_17935 = BgL_rz00_17939;
											}}}}}
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_ez00_17934);
											BGL_ENV_EVSTATE_SET(BgL_z12denvz12_17933, BgL_sz00_17915);
											return BgL_____rz00_17935;
										}
									}
								}
							}
					}
				}
			}
		}

	}



/* &run5834 */
	obj_t BGl_z62run5834z62zz__evaluate_compz00(obj_t BgL_envz00_15305,
		obj_t BgL_sz00_15311)
	{
		{	/* Eval/evaluate_comp.scm 1174 */
			{	/* Eval/evaluate_comp.scm 1174 */
				obj_t BgL_iboxesz00_15306;
				long BgL_siza7eza7_15307;
				obj_t BgL_valza2za2_15308;
				BgL_ev_absz00_bglt BgL_i1247z00_15309;
				obj_t BgL_bodyz00_15310;

				BgL_iboxesz00_15306 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15305, (int) (((long) 0))));
				BgL_siza7eza7_15307 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15305, (int) (((long) 1))));
				BgL_valza2za2_15308 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15305, (int) (((long) 2))));
				BgL_i1247z00_15309 =
					((BgL_ev_absz00_bglt)
					PROCEDURE_REF(BgL_envz00_15305, (int) (((long) 3))));
				BgL_bodyz00_15310 = PROCEDURE_REF(BgL_envz00_15305, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 1174 */
					obj_t BgL_bpz00_17941;

					BgL_bpz00_17941 = VECTOR_REF(((obj_t) BgL_sz00_15311), ((long) 0));
					BGl_makezd2boxeszd2zz__evaluate_compz00(BgL_sz00_15311,
						BgL_iboxesz00_15306, BgL_bpz00_17941);
					BGl_freezd2restorezd2zz__evaluate_compz00(BgL_sz00_15311,
						BgL_valza2za2_15308,
						((long) CINT(BgL_bpz00_17941) + BgL_siza7eza7_15307));
					{	/* Eval/evaluate_comp.scm 1095 */
						obj_t BgL_z12denvz12_17942;
						obj_t BgL_wherez00_17943;
						obj_t BgL_locz00_17944;

						BgL_z12denvz12_17942 = BGL_CURRENT_DYNAMIC_ENV();
						BgL_wherez00_17943 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15309))->
							BgL_wherez00);
						BgL_locz00_17944 =
							(((BgL_ev_absz00_bglt) COBJECT(BgL_i1247z00_15309))->BgL_locz00);
						{	/* Eval/evaluate_comp.scm 1095 */

							BGL_ENV_PUSH_TRACE(BgL_z12denvz12_17942, BgL_wherez00_17943,
								BgL_locz00_17944);
							{	/* Eval/evaluate_comp.scm 1095 */
								obj_t BgL_za2za2resza2za2z00_17945;

								BgL_za2za2resza2za2z00_17945 =
									PROCEDURE_ENTRY(BgL_bodyz00_15310) (BgL_bodyz00_15310,
									BgL_sz00_15311, BEOA);
								BGL_ENV_POP_TRACE(BgL_z12denvz12_17942);
								return BgL_za2za2resza2za2z00_17945;
							}
						}
					}
				}
			}
		}

	}



/* &comp-ev_app1436 */
	obj_t BGl_z62compzd2ev_app1436zb0zz__evaluate_compz00(obj_t BgL_envz00_15312,
		obj_t BgL_ez00_15313, obj_t BgL_stkz00_15314)
	{
		{	/* Eval/evaluate_comp.scm 1044 */
			{	/* Eval/evaluate_comp.scm 1046 */
				obj_t BgL__ortest_1233z00_17947;

				BgL__ortest_1233z00_17947 =
					BGl_arithzd2expressionzd2zz__evaluate_compz00(
					((BgL_ev_appz00_bglt) BgL_ez00_15313), BgL_stkz00_15314);
				if (CBOOL(BgL__ortest_1233z00_17947))
					{	/* Eval/evaluate_comp.scm 1046 */
						return BgL__ortest_1233z00_17947;
					}
				else
					{	/* Eval/evaluate_comp.scm 1047 */
						obj_t BgL__ortest_1234z00_17948;

						BgL__ortest_1234z00_17948 =
							BGl_inlinezd2callzd2zz__evaluate_compz00(
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15313)))->BgL_locz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15313)))->BgL_funz00),
							(((BgL_ev_appz00_bglt) COBJECT(
										((BgL_ev_appz00_bglt) BgL_ez00_15313)))->BgL_argsz00),
							BgL_stkz00_15314);
						if (CBOOL(BgL__ortest_1234z00_17948))
							{	/* Eval/evaluate_comp.scm 1047 */
								return BgL__ortest_1234z00_17948;
							}
						else
							{	/* Eval/evaluate_comp.scm 1047 */
								if (
									(bgl_list_length(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15313)))->
												BgL_argsz00)) > ((long) 4)))
									{	/* Eval/evaluate_comp.scm 1048 */
										return
											BGl_compzd2oldzd2callz00zz__evaluate_compz00(
											((BgL_ev_appz00_bglt) BgL_ez00_15313), BgL_stkz00_15314);
									}
								else
									{	/* Eval/evaluate_comp.scm 1050 */
										obj_t BgL_fz00_17949;
										long BgL_siza7eza7_17950;
										obj_t BgL_symbzd2funzd2_17951;

										BgL_fz00_17949 =
											BGl_compz00zz__evaluate_compz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15313)))->
												BgL_funz00), BgL_stkz00_15314);
										BgL_siza7eza7_17950 = bgl_list_length(BgL_stkz00_15314);
										BgL_symbzd2funzd2_17951 =
											BGl_uncompilez00zz__evaluate_uncompz00(
											(((BgL_ev_appz00_bglt) COBJECT(
														((BgL_ev_appz00_bglt) BgL_ez00_15313)))->
												BgL_funz00));
										if (NULLP((((BgL_ev_appz00_bglt)
														COBJECT(((BgL_ev_appz00_bglt) BgL_ez00_15313)))->
													BgL_argsz00)))
											{	/* Eval/evaluate_comp.scm 1051 */
												return
													BGl_compzd2call0zd2zz__evaluate_compz00(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_15313)))->
														BgL_locz00),
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_15313)))->BgL_funz00),
													BgL_symbzd2funzd2_17951, BgL_fz00_17949,
													(((BgL_ev_appz00_bglt) COBJECT(((BgL_ev_appz00_bglt)
																	BgL_ez00_15313)))->BgL_tailzf3zf3),
													BgL_stkz00_15314, BgL_siza7eza7_17950);
											}
										else
											{	/* Eval/evaluate_comp.scm 1053 */
												obj_t BgL_a1z00_17952;
												obj_t BgL_argsz00_17953;

												{	/* Eval/evaluate_comp.scm 1053 */
													obj_t BgL_arg3470z00_17954;

													BgL_arg3470z00_17954 =
														CAR(
														(((BgL_ev_appz00_bglt) COBJECT(
																	((BgL_ev_appz00_bglt) BgL_ez00_15313)))->
															BgL_argsz00));
													BgL_a1z00_17952 =
														BGl_compz00zz__evaluate_compz00((
															(BgL_ev_exprz00_bglt) BgL_arg3470z00_17954),
														BgL_stkz00_15314);
												}
												BgL_argsz00_17953 =
													CDR(
													(((BgL_ev_appz00_bglt) COBJECT(
																((BgL_ev_appz00_bglt) BgL_ez00_15313)))->
														BgL_argsz00));
												if (NULLP(BgL_argsz00_17953))
													{	/* Eval/evaluate_comp.scm 1053 */
														return
															BGl_compzd2call1zd2zz__evaluate_compz00(
															(((BgL_ev_appz00_bglt) COBJECT(
																		((BgL_ev_appz00_bglt) BgL_ez00_15313)))->
																BgL_locz00),
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_15313)))->BgL_funz00),
															BgL_symbzd2funzd2_17951, BgL_fz00_17949,
															(((BgL_ev_appz00_bglt)
																	COBJECT(((BgL_ev_appz00_bglt)
																			BgL_ez00_15313)))->BgL_tailzf3zf3),
															BgL_stkz00_15314, BgL_siza7eza7_17950,
															BgL_a1z00_17952);
													}
												else
													{	/* Eval/evaluate_comp.scm 1053 */
														obj_t BgL_a2z00_17955;
														obj_t BgL_argsz00_17956;

														{	/* Eval/evaluate_comp.scm 1053 */
															obj_t BgL_arg3469z00_17957;

															BgL_arg3469z00_17957 =
																CAR(((obj_t) BgL_argsz00_17953));
															BgL_a2z00_17955 =
																BGl_compz00zz__evaluate_compz00(
																((BgL_ev_exprz00_bglt) BgL_arg3469z00_17957),
																BgL_stkz00_15314);
														}
														BgL_argsz00_17956 =
															CDR(((obj_t) BgL_argsz00_17953));
														if (NULLP(BgL_argsz00_17956))
															{	/* Eval/evaluate_comp.scm 1053 */
																return
																	BGl_compzd2call2zd2zz__evaluate_compz00(
																	(((BgL_ev_appz00_bglt) COBJECT(
																				((BgL_ev_appz00_bglt)
																					BgL_ez00_15313)))->BgL_locz00),
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_15313)))->BgL_funz00),
																	BgL_symbzd2funzd2_17951, BgL_fz00_17949,
																	(((BgL_ev_appz00_bglt)
																			COBJECT(((BgL_ev_appz00_bglt)
																					BgL_ez00_15313)))->BgL_tailzf3zf3),
																	BgL_stkz00_15314, BgL_siza7eza7_17950,
																	BgL_a1z00_17952, BgL_a2z00_17955);
															}
														else
															{	/* Eval/evaluate_comp.scm 1053 */
																obj_t BgL_a3z00_17958;
																obj_t BgL_argsz00_17959;

																{	/* Eval/evaluate_comp.scm 1053 */
																	obj_t BgL_arg3467z00_17960;

																	BgL_arg3467z00_17960 =
																		CAR(((obj_t) BgL_argsz00_17956));
																	BgL_a3z00_17958 =
																		BGl_compz00zz__evaluate_compz00(
																		((BgL_ev_exprz00_bglt)
																			BgL_arg3467z00_17960), BgL_stkz00_15314);
																}
																BgL_argsz00_17959 =
																	CDR(((obj_t) BgL_argsz00_17956));
																if (NULLP(BgL_argsz00_17959))
																	{	/* Eval/evaluate_comp.scm 1053 */
																		return
																			BGl_compzd2call3zd2zz__evaluate_compz00(
																			(((BgL_ev_appz00_bglt) COBJECT(
																						((BgL_ev_appz00_bglt)
																							BgL_ez00_15313)))->BgL_locz00),
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_15313)))->BgL_funz00),
																			BgL_symbzd2funzd2_17951, BgL_fz00_17949,
																			(((BgL_ev_appz00_bglt)
																					COBJECT(((BgL_ev_appz00_bglt)
																							BgL_ez00_15313)))->
																				BgL_tailzf3zf3), BgL_stkz00_15314,
																			BgL_siza7eza7_17950, BgL_a1z00_17952,
																			BgL_a2z00_17955, BgL_a3z00_17958);
																	}
																else
																	{	/* Eval/evaluate_comp.scm 1053 */
																		obj_t BgL_a4z00_17961;
																		obj_t BgL_argsz00_17962;

																		{	/* Eval/evaluate_comp.scm 1053 */
																			obj_t BgL_arg3466z00_17963;

																			BgL_arg3466z00_17963 =
																				CAR(((obj_t) BgL_argsz00_17959));
																			BgL_a4z00_17961 =
																				BGl_compz00zz__evaluate_compz00(
																				((BgL_ev_exprz00_bglt)
																					BgL_arg3466z00_17963),
																				BgL_stkz00_15314);
																		}
																		BgL_argsz00_17962 =
																			CDR(((obj_t) BgL_argsz00_17959));
																		if (NULLP(BgL_argsz00_17962))
																			{	/* Eval/evaluate_comp.scm 1053 */
																				return
																					BGl_compzd2call4zd2zz__evaluate_compz00
																					((((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15313)))->
																						BgL_locz00),
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15313)))->
																						BgL_funz00),
																					BgL_symbzd2funzd2_17951,
																					BgL_fz00_17949,
																					(((BgL_ev_appz00_bglt)
																							COBJECT(((BgL_ev_appz00_bglt)
																									BgL_ez00_15313)))->
																						BgL_tailzf3zf3), BgL_stkz00_15314,
																					BgL_siza7eza7_17950, BgL_a1z00_17952,
																					BgL_a2z00_17955, BgL_a3z00_17958,
																					BgL_a4z00_17961);
																			}
																		else
																			{	/* Eval/evaluate_comp.scm 1053 */
																				return
																					BGl_errorz00zz__errorz00
																					(BGl_string5847z00zz__evaluate_compz00,
																					BGl_string5962z00zz__evaluate_compz00,
																					BGl_string5963z00zz__evaluate_compz00);
																			}
																	}
															}
													}
											}
									}
							}
					}
			}
		}

	}



/* &comp-ev_goto1434 */
	obj_t BGl_z62compzd2ev_goto1434zb0zz__evaluate_compz00(obj_t BgL_envz00_15315,
		obj_t BgL_ez00_15316, obj_t BgL_stkz00_15317)
	{
		{	/* Eval/evaluate_comp.scm 604 */
			{	/* Eval/evaluate_comp.scm 607 */
				obj_t BgL_slotz00_17967;
				long BgL_siza7eza7_17968;
				obj_t BgL_lstkz00_17969;

				BgL_slotz00_17967 =
					BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
					((obj_t)
						(((BgL_ev_gotoz00_bglt) COBJECT(
									((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->BgL_labelz00)),
					(((BgL_ev_labelsz00_bglt) COBJECT(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->
									BgL_labelsz00)))->BgL_envz00));
				BgL_siza7eza7_17968 = bgl_list_length(BgL_stkz00_15317);
				BgL_lstkz00_17969 =
					(((BgL_ev_labelsz00_bglt) COBJECT(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->BgL_labelsz00)))->
					BgL_stkz00);
				{	/* Eval/evaluate_comp.scm 609 */
					long BgL_llstkz00_17970;
					obj_t BgL_substkz00_17971;
					obj_t BgL_boxesz00_17972;

					BgL_llstkz00_17970 = bgl_list_length(BgL_lstkz00_17969);
					BgL_substkz00_17971 =
						BGl_subzd2stkzd2zz__evaluate_compz00(BgL_lstkz00_17969,
						BgL_stkz00_15317);
					{	/* Eval/evaluate_comp.scm 609 */
						obj_t BgL_pairz00_17973;

						BgL_pairz00_17973 =
							BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
							((obj_t)
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->BgL_labelz00)),
							(((BgL_ev_labelsz00_bglt) COBJECT(
										(((BgL_ev_gotoz00_bglt) COBJECT(
													((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->
											BgL_labelsz00)))->BgL_boxesz00));
						BgL_boxesz00_17972 = CDR(BgL_pairz00_17973);
					}
					if (BGl_needzd2shiftzd2zz__evaluate_compz00(
							(((BgL_ev_gotoz00_bglt) COBJECT(
										((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->BgL_argsz00),
							BgL_substkz00_17971))
						{	/* Eval/evaluate_comp.scm 612 */
							obj_t BgL_argsz00_17974;
							long BgL_nbargsz00_17975;

							BgL_argsz00_17974 =
								BGl_compzd2withzd2pushz00zz__evaluate_compz00(
								(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->BgL_argsz00),
								BgL_stkz00_15317);
							BgL_nbargsz00_17975 =
								bgl_list_length((((BgL_ev_gotoz00_bglt)
										COBJECT(((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->
									BgL_argsz00));
							{	/* Eval/evaluate_comp.scm 613 */
								obj_t BgL_zc3z04anonymousza33416ze3z87_17976;

								BgL_zc3z04anonymousza33416ze3z87_17976 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33416ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 7)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33416ze3z87_17976,
									(int) (((long) 0)), BINT(BgL_siza7eza7_17968));
								PROCEDURE_SET(BgL_zc3z04anonymousza33416ze3z87_17976,
									(int) (((long) 1)), BINT(BgL_llstkz00_17970));
								PROCEDURE_SET(BgL_zc3z04anonymousza33416ze3z87_17976,
									(int) (((long) 2)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_15316)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33416ze3z87_17976,
									(int) (((long) 3)), BgL_argsz00_17974);
								PROCEDURE_SET(BgL_zc3z04anonymousza33416ze3z87_17976,
									(int) (((long) 4)), BgL_boxesz00_17972);
								PROCEDURE_SET(BgL_zc3z04anonymousza33416ze3z87_17976,
									(int) (((long) 5)), BINT(BgL_nbargsz00_17975));
								PROCEDURE_SET(BgL_zc3z04anonymousza33416ze3z87_17976,
									(int) (((long) 6)), BgL_slotz00_17967);
								return BgL_zc3z04anonymousza33416ze3z87_17976;
							}
						}
					else
						{	/* Eval/evaluate_comp.scm 618 */
							obj_t BgL_argsz00_17977;

							{	/* Eval/evaluate_comp.scm 618 */
								obj_t BgL_lz00_17978;
								long BgL_nz00_17979;

								BgL_lz00_17978 =
									(((BgL_ev_gotoz00_bglt) COBJECT(
											((BgL_ev_gotoz00_bglt) BgL_ez00_15316)))->BgL_argsz00);
								BgL_nz00_17979 = (BgL_siza7eza7_17968 - BgL_llstkz00_17970);
								BgL_argsz00_17977 =
									BGl_recze70ze7zz__evaluate_compz00(BgL_stkz00_15317,
									BgL_lz00_17978, BgL_nz00_17979);
							}
							{	/* Eval/evaluate_comp.scm 619 */
								obj_t BgL_zc3z04anonymousza33423ze3z87_17980;

								BgL_zc3z04anonymousza33423ze3z87_17980 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33423ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 5)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33423ze3z87_17980,
									(int) (((long) 0)), BINT(BgL_llstkz00_17970));
								PROCEDURE_SET(BgL_zc3z04anonymousza33423ze3z87_17980,
									(int) (((long) 1)),
									((obj_t) ((BgL_ev_gotoz00_bglt) BgL_ez00_15316)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33423ze3z87_17980,
									(int) (((long) 2)), BgL_argsz00_17977);
								PROCEDURE_SET(BgL_zc3z04anonymousza33423ze3z87_17980,
									(int) (((long) 3)), BgL_boxesz00_17972);
								PROCEDURE_SET(BgL_zc3z04anonymousza33423ze3z87_17980,
									(int) (((long) 4)), BgL_slotz00_17967);
								return BgL_zc3z04anonymousza33423ze3z87_17980;
							}
						}
				}
			}
		}

	}



/* &<@anonymous:3416> */
	obj_t BGl_z62zc3z04anonymousza33416ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15318, obj_t BgL_sz00_15326)
	{
		{	/* Eval/evaluate_comp.scm 613 */
			{	/* Eval/evaluate_comp.scm 613 */
				long BgL_siza7eza7_15319;
				long BgL_llstkz00_15320;
				BgL_ev_gotoz00_bglt BgL_i1145z00_15321;
				obj_t BgL_argsz00_15322;
				obj_t BgL_boxesz00_15323;
				long BgL_nbargsz00_15324;
				obj_t BgL_slotz00_15325;

				BgL_siza7eza7_15319 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15318, (int) (((long) 0))));
				BgL_llstkz00_15320 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15318, (int) (((long) 1))));
				BgL_i1145z00_15321 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_15318, (int) (((long) 2))));
				BgL_argsz00_15322 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15318, (int) (((long) 3))));
				BgL_boxesz00_15323 =
					PROCEDURE_REF(BgL_envz00_15318, (int) (((long) 4)));
				BgL_nbargsz00_15324 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15318, (int) (((long) 5))));
				BgL_slotz00_15325 = PROCEDURE_REF(BgL_envz00_15318, (int) (((long) 6)));
				{	/* Eval/evaluate_comp.scm 613 */
					obj_t BgL_bpz00_17981;

					BgL_bpz00_17981 = VECTOR_REF(((obj_t) BgL_sz00_15326), ((long) 0));
					{	/* Eval/evaluate_comp.scm 614 */
						long BgL_spz00_17982;
						long BgL_lspz00_17983;

						BgL_spz00_17982 =
							((long) CINT(BgL_bpz00_17981) + BgL_siza7eza7_15319);
						BgL_lspz00_17983 =
							((long) CINT(BgL_bpz00_17981) + BgL_llstkz00_15320);
						BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
							(BgL_sz00_15326, BgL_argsz00_15322, BgL_boxesz00_15323,
							BgL_spz00_17982,
							(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1145z00_15321))->
								BgL_locz00));
						{	/* Eval/evaluate_comp.scm 616 */
							long BgL_arg3418z00_17984;

							BgL_arg3418z00_17984 = (BgL_spz00_17982 + BgL_nbargsz00_15324);
							BGl_vectorzd2copyz12zc0zz__r4_vectors_6_8z00(BgL_sz00_15326,
								BgL_lspz00_17983, BgL_sz00_15326, BINT(BgL_spz00_17982),
								BINT(BgL_arg3418z00_17984));
						}
						return CDR(((obj_t) BgL_slotz00_15325));
					}
				}
			}
		}

	}



/* &<@anonymous:3423> */
	obj_t BGl_z62zc3z04anonymousza33423ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15327, obj_t BgL_sz00_15333)
	{
		{	/* Eval/evaluate_comp.scm 619 */
			{	/* Eval/evaluate_comp.scm 619 */
				long BgL_llstkz00_15328;
				BgL_ev_gotoz00_bglt BgL_i1145z00_15329;
				obj_t BgL_argsz00_15330;
				obj_t BgL_boxesz00_15331;
				obj_t BgL_slotz00_15332;

				BgL_llstkz00_15328 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15327, (int) (((long) 0))));
				BgL_i1145z00_15329 =
					((BgL_ev_gotoz00_bglt)
					PROCEDURE_REF(BgL_envz00_15327, (int) (((long) 1))));
				BgL_argsz00_15330 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15327, (int) (((long) 2))));
				BgL_boxesz00_15331 =
					PROCEDURE_REF(BgL_envz00_15327, (int) (((long) 3)));
				BgL_slotz00_15332 = PROCEDURE_REF(BgL_envz00_15327, (int) (((long) 4)));
				{	/* Eval/evaluate_comp.scm 619 */
					obj_t BgL_bpz00_17985;

					BgL_bpz00_17985 = VECTOR_REF(((obj_t) BgL_sz00_15333), ((long) 0));
					BGl_pushzd2boxeszd2argszd2onzd2spz00zz__evaluate_compz00
						(BgL_sz00_15333, BgL_argsz00_15330, BgL_boxesz00_15331,
						((long) CINT(BgL_bpz00_17985) + BgL_llstkz00_15328),
						(((BgL_ev_gotoz00_bglt) COBJECT(BgL_i1145z00_15329))->BgL_locz00));
					return CDR(((obj_t) BgL_slotz00_15332));
				}
			}
		}

	}



/* &comp-ev_labels1432 */
	obj_t BGl_z62compzd2ev_labels1432zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15334, obj_t BgL_ez00_15335, obj_t BgL_stkz00_15336)
	{
		{	/* Eval/evaluate_comp.scm 572 */
			((((BgL_ev_labelsz00_bglt) COBJECT(
							((BgL_ev_labelsz00_bglt) BgL_ez00_15335)))->BgL_stkz00) =
				((obj_t) BgL_stkz00_15336), BUNSPEC);
			{	/* Eval/evaluate_comp.scm 579 */
				obj_t BgL_envz00_17987;

				{	/* Eval/evaluate_comp.scm 579 */
					obj_t BgL_l1332z00_17988;

					BgL_l1332z00_17988 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15335)))->BgL_varsz00);
					if (NULLP(BgL_l1332z00_17988))
						{	/* Eval/evaluate_comp.scm 579 */
							BgL_envz00_17987 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 579 */
							obj_t BgL_head1334z00_17989;

							{	/* Eval/evaluate_comp.scm 579 */
								obj_t BgL_res5243z00_17990;

								BgL_res5243z00_17990 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1334z00_17989 = BgL_res5243z00_17990;
							}
							{
								obj_t BgL_l1332z00_17992;
								obj_t BgL_tail1335z00_17993;

								BgL_l1332z00_17992 = BgL_l1332z00_17988;
								BgL_tail1335z00_17993 = BgL_head1334z00_17989;
							BgL_zc3z04anonymousza33406ze3z87_17991:
								if (NULLP(BgL_l1332z00_17992))
									{	/* Eval/evaluate_comp.scm 579 */
										BgL_envz00_17987 = CDR(BgL_head1334z00_17989);
									}
								else
									{	/* Eval/evaluate_comp.scm 579 */
										obj_t BgL_newtail1336z00_17994;

										{	/* Eval/evaluate_comp.scm 579 */
											obj_t BgL_arg3410z00_17995;

											{	/* Eval/evaluate_comp.scm 579 */
												obj_t BgL_vz00_17996;

												BgL_vz00_17996 = CAR(((obj_t) BgL_l1332z00_17992));
												BgL_arg3410z00_17995 =
													MAKE_YOUNG_PAIR(BgL_vz00_17996,
													BGl_symbol5964z00zz__evaluate_compz00);
											}
											{	/* Eval/evaluate_comp.scm 579 */
												obj_t BgL_res5249z00_17997;

												BgL_res5249z00_17997 =
													MAKE_YOUNG_PAIR(BgL_arg3410z00_17995, BNIL);
												BgL_newtail1336z00_17994 = BgL_res5249z00_17997;
											}
										}
										SET_CDR(BgL_tail1335z00_17993, BgL_newtail1336z00_17994);
										{	/* Eval/evaluate_comp.scm 579 */
											obj_t BgL_arg3408z00_17998;

											BgL_arg3408z00_17998 = CDR(((obj_t) BgL_l1332z00_17992));
											{
												obj_t BgL_tail1335z00_33110;
												obj_t BgL_l1332z00_33109;

												BgL_l1332z00_33109 = BgL_arg3408z00_17998;
												BgL_tail1335z00_33110 = BgL_newtail1336z00_17994;
												BgL_tail1335z00_17993 = BgL_tail1335z00_33110;
												BgL_l1332z00_17992 = BgL_l1332z00_33109;
												goto BgL_zc3z04anonymousza33406ze3z87_17991;
											}
										}
									}
							}
						}
				}
				((((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15335)))->BgL_envz00) =
					((obj_t) BgL_envz00_17987), BUNSPEC);
				{	/* Eval/evaluate_comp.scm 582 */
					obj_t BgL_g1340z00_17999;

					BgL_g1340z00_17999 =
						(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15335)))->BgL_valsz00);
					{
						obj_t BgL_ll1337z00_18001;
						obj_t BgL_ll1338z00_18002;

						BgL_ll1337z00_18001 = BgL_envz00_17987;
						BgL_ll1338z00_18002 = BgL_g1340z00_17999;
					BgL_zc3z04anonymousza33394ze3z87_18000:
						if (NULLP(BgL_ll1337z00_18001))
							{	/* Eval/evaluate_comp.scm 582 */
								((bool_t) 1);
							}
						else
							{	/* Eval/evaluate_comp.scm 582 */
								{	/* Eval/evaluate_comp.scm 584 */
									obj_t BgL_slotz00_18003;
									obj_t BgL_valz00_18004;

									BgL_slotz00_18003 = CAR(((obj_t) BgL_ll1337z00_18001));
									BgL_valz00_18004 = CAR(((obj_t) BgL_ll1338z00_18002));
									{	/* Eval/evaluate_comp.scm 585 */
										obj_t BgL_arg3396z00_18005;

										{	/* Eval/evaluate_comp.scm 585 */
											obj_t BgL_arg3398z00_18006;

											{	/* Eval/evaluate_comp.scm 585 */
												obj_t BgL_arg3399z00_18007;
												obj_t BgL_arg3400z00_18008;

												BgL_arg3399z00_18007 = CDR(((obj_t) BgL_valz00_18004));
												{	/* Eval/evaluate_comp.scm 585 */
													obj_t BgL_arg3401z00_18009;

													BgL_arg3401z00_18009 =
														CAR(((obj_t) BgL_valz00_18004));
													BgL_arg3400z00_18008 =
														BGl_appendzd221011zd2zz__evaluate_compz00
														(BgL_stkz00_15336, BgL_arg3401z00_18009);
												}
												BgL_arg3398z00_18006 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_arg3399z00_18007),
													BgL_arg3400z00_18008);
											}
											{	/* Eval/evaluate_comp.scm 574 */
												obj_t BgL_objz00_18010;

												BgL_objz00_18010 =
													BGl_za2za2azd2labelza2za2zd2zz__evaluate_compz00;
												{	/* Eval/evaluate_comp.scm 574 */
													obj_t BgL_tmpz00_33128;

													BgL_tmpz00_33128 = ((obj_t) BgL_arg3398z00_18006);
													PROCEDURE_ATTR_SET(BgL_tmpz00_33128,
														BgL_objz00_18010);
												}
												BgL_objz00_18010;
											}
											BgL_arg3396z00_18005 = BgL_arg3398z00_18006;
										}
										{	/* Eval/evaluate_comp.scm 584 */
											obj_t BgL_tmpz00_33131;

											BgL_tmpz00_33131 = ((obj_t) BgL_slotz00_18003);
											SET_CDR(BgL_tmpz00_33131, BgL_arg3396z00_18005);
										}
									}
								}
								{	/* Eval/evaluate_comp.scm 582 */
									obj_t BgL_arg3402z00_18011;
									obj_t BgL_arg3404z00_18012;

									BgL_arg3402z00_18011 = CDR(((obj_t) BgL_ll1337z00_18001));
									BgL_arg3404z00_18012 = CDR(((obj_t) BgL_ll1338z00_18002));
									{
										obj_t BgL_ll1338z00_33139;
										obj_t BgL_ll1337z00_33138;

										BgL_ll1337z00_33138 = BgL_arg3402z00_18011;
										BgL_ll1338z00_33139 = BgL_arg3404z00_18012;
										BgL_ll1338z00_18002 = BgL_ll1338z00_33139;
										BgL_ll1337z00_18001 = BgL_ll1337z00_33138;
										goto BgL_zc3z04anonymousza33394ze3z87_18000;
									}
								}
							}
					}
				}
			}
			{	/* Eval/evaluate_comp.scm 589 */
				obj_t BgL_bodyz00_18013;

				BgL_bodyz00_18013 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_labelsz00_bglt) COBJECT(
								((BgL_ev_labelsz00_bglt) BgL_ez00_15335)))->BgL_bodyz00),
					BgL_stkz00_15336);
				{	/* Eval/evaluate_comp.scm 590 */
					obj_t BgL_zc3z04anonymousza33411ze3z87_18014;

					BgL_zc3z04anonymousza33411ze3z87_18014 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33411ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33411ze3z87_18014,
						(int) (((long) 0)), BgL_bodyz00_18013);
					return BgL_zc3z04anonymousza33411ze3z87_18014;
				}
			}
		}

	}



/* &<@anonymous:3411> */
	obj_t BGl_z62zc3z04anonymousza33411ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15337, obj_t BgL_sz00_15339)
	{
		{	/* Eval/evaluate_comp.scm 590 */
			{	/* Eval/evaluate_comp.scm 590 */
				obj_t BgL_bodyz00_15338;

				BgL_bodyz00_15338 = PROCEDURE_REF(BgL_envz00_15337, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 590 */
					obj_t BgL_bpz00_18015;

					BgL_bpz00_18015 = VECTOR_REF(((obj_t) BgL_sz00_15339), ((long) 0));
					{
						obj_t BgL_fz00_18017;

						BgL_fz00_18017 = BgL_bodyz00_15338;
					BgL_recz00_18016:
						{	/* Eval/evaluate_comp.scm 597 */
							obj_t BgL_rz00_18018;

							BgL_rz00_18018 =
								PROCEDURE_ENTRY(BgL_fz00_18017) (BgL_fz00_18017, BgL_sz00_15339,
								BEOA);
							{	/* Eval/evaluate_comp.scm 599 */
								bool_t BgL_test6817z00_33156;

								if (PROCEDUREP(BgL_rz00_18018))
									{	/* Eval/evaluate_comp.scm 599 */
										obj_t BgL_arg1679z00_18019;

										BgL_arg1679z00_18019 = PROCEDURE_ATTR(BgL_rz00_18018);
										if (STRUCTP(BgL_arg1679z00_18019))
											{	/* Eval/evaluate_comp.scm 569 */
												BgL_test6817z00_33156 =
													(STRUCT_KEY(BgL_arg1679z00_18019) ==
													BGl_symbol5841z00zz__evaluate_compz00);
											}
										else
											{	/* Eval/evaluate_comp.scm 569 */
												BgL_test6817z00_33156 = ((bool_t) 0);
											}
									}
								else
									{	/* Eval/evaluate_comp.scm 599 */
										BgL_test6817z00_33156 = ((bool_t) 0);
									}
								if (BgL_test6817z00_33156)
									{
										obj_t BgL_fz00_33164;

										BgL_fz00_33164 = BgL_rz00_18018;
										BgL_fz00_18017 = BgL_fz00_33164;
										goto BgL_recz00_18016;
									}
								else
									{	/* Eval/evaluate_comp.scm 599 */
										return BgL_rz00_18018;
									}
							}
						}
					}
				}
			}
		}

	}



/* &comp-ev_synchronize1430 */
	obj_t BGl_z62compzd2ev_synchroniza7e1430z17zz__evaluate_compz00(obj_t
		BgL_envz00_15340, obj_t BgL_ez00_15341, obj_t BgL_stkz00_15342)
	{
		{	/* Eval/evaluate_comp.scm 552 */
			{	/* Eval/evaluate_comp.scm 554 */
				obj_t BgL_mutexz00_18021;
				obj_t BgL_prelockz00_18022;
				obj_t BgL_bodyz00_18023;

				BgL_mutexz00_18021 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_synchroniza7eza7_bglt) COBJECT(
								((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15341)))->
						BgL_mutexz00), BgL_stkz00_15342);
				BgL_prelockz00_18022 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15341)))->
						BgL_prelockz00), BgL_stkz00_15342);
				BgL_bodyz00_18023 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_synchroniza7eza7_bglt)
							COBJECT(((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15341)))->
						BgL_bodyz00), BgL_stkz00_15342);
				{	/* Eval/evaluate_comp.scm 557 */
					obj_t BgL_zc3z04anonymousza33387ze3z87_18024;

					BgL_zc3z04anonymousza33387ze3z87_18024 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 4)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_18024,
						(int) (((long) 0)), BgL_mutexz00_18021);
					PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_18024,
						(int) (((long) 1)),
						((obj_t) ((BgL_ev_synchroniza7eza7_bglt) BgL_ez00_15341)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_18024,
						(int) (((long) 2)), BgL_prelockz00_18022);
					PROCEDURE_SET(BgL_zc3z04anonymousza33387ze3z87_18024,
						(int) (((long) 3)), BgL_bodyz00_18023);
					return BgL_zc3z04anonymousza33387ze3z87_18024;
				}
			}
		}

	}



/* &<@anonymous:3387> */
	obj_t BGl_z62zc3z04anonymousza33387ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15343, obj_t BgL_sz00_15348)
	{
		{	/* Eval/evaluate_comp.scm 557 */
			{	/* Eval/evaluate_comp.scm 557 */
				obj_t BgL_mutexz00_15344;
				BgL_ev_synchroniza7eza7_bglt BgL_i1142z00_15345;
				obj_t BgL_prelockz00_15346;
				obj_t BgL_bodyz00_15347;

				BgL_mutexz00_15344 =
					PROCEDURE_REF(BgL_envz00_15343, (int) (((long) 0)));
				BgL_i1142z00_15345 =
					((BgL_ev_synchroniza7eza7_bglt)
					PROCEDURE_REF(BgL_envz00_15343, (int) (((long) 1))));
				BgL_prelockz00_15346 =
					PROCEDURE_REF(BgL_envz00_15343, (int) (((long) 2)));
				BgL_bodyz00_15347 = PROCEDURE_REF(BgL_envz00_15343, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 557 */
					obj_t BgL_bpz00_18025;

					BgL_bpz00_18025 = VECTOR_REF(((obj_t) BgL_sz00_15348), ((long) 0));
					{	/* Eval/evaluate_comp.scm 558 */
						obj_t BgL_mz00_18026;

						BgL_mz00_18026 =
							PROCEDURE_ENTRY(BgL_mutexz00_15344) (BgL_mutexz00_15344,
							BgL_sz00_15348, BEOA);
						{	/* Eval/evaluate_comp.scm 559 */
							bool_t BgL_test6820z00_33202;

							{	/* Eval/evaluate_comp.scm 559 */
								bool_t BgL_res5240z00_18027;

								BgL_res5240z00_18027 = BGL_MUTEXP(BgL_mz00_18026);
								BgL_test6820z00_33202 = BgL_res5240z00_18027;
							}
							if (BgL_test6820z00_33202)
								{	/* Eval/evaluate_comp.scm 560 */
									obj_t BgL_pz00_18028;

									BgL_pz00_18028 =
										PROCEDURE_ENTRY(BgL_prelockz00_15346) (BgL_prelockz00_15346,
										BgL_sz00_15348, BEOA);
									{	/* Eval/evaluate_comp.scm 562 */
										obj_t BgL_za2za2resza2za2z00_18029;

										if (PAIRP(BgL_pz00_18028))
											{	/* Eval/evaluate_comp.scm 563 */
												obj_t BgL_top6823z00_33211;

												BgL_top6823z00_33211 = BGL_EXITD_TOP_AS_OBJ();
												BGL_MUTEX_LOCK_PRELOCK(BgL_mz00_18026, BgL_pz00_18028);
												BGL_EXITD_PUSH_PROTECT(BgL_top6823z00_33211,
													BgL_mz00_18026);
												BUNSPEC;
												{	/* Eval/evaluate_comp.scm 563 */
													obj_t BgL_tmp6822z00_33210;

													BgL_tmp6822z00_33210 =
														PROCEDURE_ENTRY(BgL_bodyz00_15347)
														(BgL_bodyz00_15347, BgL_sz00_15348, BEOA);
													BGL_EXITD_POP_PROTECT(BgL_top6823z00_33211);
													BUNSPEC;
													BGL_MUTEX_UNLOCK(BgL_mz00_18026);
													BgL_za2za2resza2za2z00_18029 = BgL_tmp6822z00_33210;
												}
											}
										else
											{	/* Eval/evaluate_comp.scm 564 */
												obj_t BgL_top6825z00_33222;

												BgL_top6825z00_33222 = BGL_EXITD_TOP_AS_OBJ();
												BGL_MUTEX_LOCK(BgL_mz00_18026);
												BGL_EXITD_PUSH_PROTECT(BgL_top6825z00_33222,
													BgL_mz00_18026);
												BUNSPEC;
												{	/* Eval/evaluate_comp.scm 564 */
													obj_t BgL_tmp6824z00_33221;

													BgL_tmp6824z00_33221 =
														PROCEDURE_ENTRY(BgL_bodyz00_15347)
														(BgL_bodyz00_15347, BgL_sz00_15348, BEOA);
													BGL_EXITD_POP_PROTECT(BgL_top6825z00_33222);
													BUNSPEC;
													BGL_MUTEX_UNLOCK(BgL_mz00_18026);
													BgL_za2za2resza2za2z00_18029 = BgL_tmp6824z00_33221;
												}
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_15348), ((long) 0), BgL_bpz00_18025);
										return BgL_za2za2resza2za2z00_18029;
									}
								}
							else
								{	/* Eval/evaluate_comp.scm 559 */
									return
										BGl_loczd2typezd2errorz00zz__evaluate_compz00
										(BGl_string5966z00zz__evaluate_compz00,
										BGl_string5967z00zz__evaluate_compz00, BgL_mz00_18026,
										(((BgL_ev_synchroniza7eza7_bglt)
												COBJECT(BgL_i1142z00_15345))->BgL_locz00));
								}
						}
					}
				}
			}
		}

	}



/* &comp-ev_with-handler1428 */
	obj_t BGl_z62compzd2ev_withzd2handler1428z62zz__evaluate_compz00(obj_t
		BgL_envz00_15349, obj_t BgL_ez00_15350, obj_t BgL_stkz00_15351)
	{
		{	/* Eval/evaluate_comp.scm 543 */
			{	/* Eval/evaluate_comp.scm 545 */
				obj_t BgL_handlerz00_18031;
				obj_t BgL_bodyz00_18032;

				BgL_handlerz00_18031 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_withzd2handlerzd2_bglt) COBJECT(
								((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_15350)))->
						BgL_handlerz00), BgL_stkz00_15351);
				BgL_bodyz00_18032 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_withzd2handlerzd2_bglt)
							COBJECT(((BgL_ev_withzd2handlerzd2_bglt) BgL_ez00_15350)))->
						BgL_bodyz00), BgL_stkz00_15351);
				{	/* Eval/evaluate_comp.scm 546 */
					obj_t BgL_zc3z04anonymousza33372ze3z87_18033;

					BgL_zc3z04anonymousza33372ze3z87_18033 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33372ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33372ze3z87_18033,
						(int) (((long) 0)), BgL_handlerz00_18031);
					PROCEDURE_SET(BgL_zc3z04anonymousza33372ze3z87_18033,
						(int) (((long) 1)), BgL_bodyz00_18032);
					return BgL_zc3z04anonymousza33372ze3z87_18033;
				}
			}
		}

	}



/* &<@anonymous:3372> */
	obj_t BGl_z62zc3z04anonymousza33372ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15352, obj_t BgL_sz00_15355)
	{
		{	/* Eval/evaluate_comp.scm 546 */
			{	/* Eval/evaluate_comp.scm 546 */
				obj_t BgL_handlerz00_15353;
				obj_t BgL_bodyz00_15354;

				BgL_handlerz00_15353 =
					PROCEDURE_REF(BgL_envz00_15352, (int) (((long) 0)));
				BgL_bodyz00_15354 = PROCEDURE_REF(BgL_envz00_15352, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 546 */
					obj_t BgL_bpz00_18034;

					BgL_bpz00_18034 = VECTOR_REF(((obj_t) BgL_sz00_15355), ((long) 0));
					{	/* Eval/evaluate_comp.scm 547 */
						obj_t BgL_hz00_18035;

						BgL_hz00_18035 =
							PROCEDURE_ENTRY(BgL_handlerz00_15353) (BgL_handlerz00_15353,
							BgL_sz00_15355, BEOA);
						{	/* Eval/evaluate_comp.scm 549 */
							obj_t BgL_za2za2resza2za2z00_18036;

							{	/* Eval/evaluate_comp.scm 549 */
								obj_t BgL_res1132z00_18037;

								BgL_res1132z00_18037 = MAKE_CELL(BUNSPEC);
								if (CBOOL(BGl_zc3z04exitza33379ze3ze70z60zz__evaluate_compz00
										(BgL_sz00_15355, BgL_bodyz00_15354, BgL_res1132z00_18037)))
									{	/* Eval/evaluate_comp.scm 549 */
										BgL_za2za2resza2za2z00_18036 =
											PROCEDURE_ENTRY(BgL_hz00_18035) (BgL_hz00_18035,
											CELL_REF(BgL_res1132z00_18037), BEOA);
									}
								else
									{	/* Eval/evaluate_comp.scm 549 */
										BgL_za2za2resza2za2z00_18036 =
											CELL_REF(BgL_res1132z00_18037);
									}
							}
							VECTOR_SET(((obj_t) BgL_sz00_15355), ((long) 0), BgL_bpz00_18034);
							return BgL_za2za2resza2za2z00_18036;
						}
					}
				}
			}
		}

	}



/* <@exit:3379>~0 */
	obj_t BGl_zc3z04exitza33379ze3ze70z60zz__evaluate_compz00(obj_t
		BgL_sz00_15543, obj_t BgL_bodyz00_15542, obj_t BgL_res1132z00_15541)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1138z00_4223;

			if (SET_EXIT(BgL_an_exit1138z00_4223))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1138z00_4223 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 549 */

						PUSH_EXIT(BgL_an_exit1138z00_4223, ((long) 1));
						{	/* Eval/evaluate_comp.scm 549 */
							obj_t BgL_an_exitd1139z00_4224;

							BgL_an_exitd1139z00_4224 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 549 */
								bool_t BgL_res1141z00_4227;

								{	/* Eval/evaluate_comp.scm 549 */
									obj_t BgL_ohs1130z00_4228;

									BgL_ohs1130z00_4228 = BGL_ERROR_HANDLER_GET();
									{	/* Eval/evaluate_comp.scm 549 */
										obj_t BgL_exitd1135z00_4229;

										BgL_exitd1135z00_4229 = ((obj_t) (&exitd));
										{
											obj_t BgL_zc3z04anonymousza33383ze3z87_14322;

											BgL_zc3z04anonymousza33383ze3z87_14322 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33383ze3ze5zz__evaluate_compz00,
												(int) (((long) 0)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33383ze3z87_14322,
												(int) (((long) 0)), BgL_ohs1130z00_4228);
											BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
												(BgL_exitd1135z00_4229,
												BgL_zc3z04anonymousza33383ze3z87_14322);
											{	/* Eval/evaluate_comp.scm 549 */
												bool_t BgL_tmp1137z00_4231;

												{	/* Eval/evaluate_comp.scm 549 */
													obj_t BgL_arg3380z00_4232;

													{	/* Eval/evaluate_comp.scm 549 */
														obj_t BgL_zc3z04anonymousza33382ze3z87_14323;

														BgL_zc3z04anonymousza33382ze3z87_14323 =
															MAKE_FX_PROCEDURE
															(BGl_z62zc3z04anonymousza33382ze3ze5zz__evaluate_compz00,
															(int) (((long) 1)), (int) (((long) 2)));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza33382ze3z87_14323,
															(int) (((long) 0)),
															((obj_t) BgL_res1132z00_15541));
														PROCEDURE_SET
															(BgL_zc3z04anonymousza33382ze3z87_14323,
															(int) (((long) 1)), BgL_an_exitd1139z00_4224);
														BgL_arg3380z00_4232 =
															MAKE_YOUNG_PAIR
															(BgL_zc3z04anonymousza33382ze3z87_14323,
															BgL_ohs1130z00_4228);
													}
													BGL_ERROR_HANDLER_SET(BgL_arg3380z00_4232);
													BUNSPEC;
												}
												{	/* Eval/evaluate_comp.scm 549 */
													obj_t BgL_auxz00_15357;

													BgL_auxz00_15357 =
														PROCEDURE_ENTRY(BgL_bodyz00_15542)
														(BgL_bodyz00_15542, BgL_sz00_15543, BEOA);
													CELL_SET(BgL_res1132z00_15541, BgL_auxz00_15357);
												}
												BgL_tmp1137z00_4231 = ((bool_t) 0);
												BGl_exitdzd2popzd2protectz12z12zz__bexitz00
													(BgL_exitd1135z00_4229);
												BGL_ERROR_HANDLER_SET(BgL_ohs1130z00_4228);
												BUNSPEC;
												BgL_res1141z00_4227 = BgL_tmp1137z00_4231;
								}}}}
								POP_EXIT();
								return BBOOL(BgL_res1141z00_4227);
							}
						}
					}
				}
		}

	}



/* &<@anonymous:3382> */
	obj_t BGl_z62zc3z04anonymousza33382ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15359, obj_t BgL_ez00_15362)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			{	/* Eval/evaluate_comp.scm 549 */
				obj_t BgL_res1132z00_15360;
				obj_t BgL_an_exitd1139z00_15361;

				BgL_res1132z00_15360 =
					PROCEDURE_REF(BgL_envz00_15359, (int) (((long) 0)));
				BgL_an_exitd1139z00_15361 =
					PROCEDURE_REF(BgL_envz00_15359, (int) (((long) 1)));
				CELL_SET(BgL_res1132z00_15360, BgL_ez00_15362);
				return
					BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_an_exitd1139z00_15361,
					BTRUE);
			}
		}

	}



/* &<@anonymous:3383> */
	obj_t BGl_z62zc3z04anonymousza33383ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15364)
	{
		{	/* Eval/evaluate_comp.scm 549 */
			{
				obj_t BgL_ohs1130z00_15365;

				BgL_ohs1130z00_15365 =
					PROCEDURE_REF(BgL_envz00_15364, (int) (((long) 0)));
				BGL_ERROR_HANDLER_SET(BgL_ohs1130z00_15365);
				return BUNSPEC;
			}
		}

	}



/* &comp-ev_unwind-prote1426 */
	obj_t BGl_z62compzd2ev_unwindzd2prote1426z62zz__evaluate_compz00(obj_t
		BgL_envz00_15366, obj_t BgL_ez00_15367, obj_t BgL_stkz00_15368)
	{
		{	/* Eval/evaluate_comp.scm 534 */
			{	/* Eval/evaluate_comp.scm 536 */
				obj_t BgL_ez00_18039;
				obj_t BgL_bodyz00_18040;

				BgL_ez00_18039 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_unwindzd2protectzd2_bglt) COBJECT(
								((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_15367)))->BgL_ez00),
					BgL_stkz00_15368);
				BgL_bodyz00_18040 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_unwindzd2protectzd2_bglt)
							COBJECT(((BgL_ev_unwindzd2protectzd2_bglt) BgL_ez00_15367)))->
						BgL_bodyz00), BgL_stkz00_15368);
				{	/* Eval/evaluate_comp.scm 537 */
					obj_t BgL_zc3z04anonymousza33368ze3z87_18041;

					BgL_zc3z04anonymousza33368ze3z87_18041 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33368ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33368ze3z87_18041,
						(int) (((long) 0)), BgL_bodyz00_18040);
					PROCEDURE_SET(BgL_zc3z04anonymousza33368ze3z87_18041,
						(int) (((long) 1)), BgL_ez00_18039);
					return BgL_zc3z04anonymousza33368ze3z87_18041;
				}
			}
		}

	}



/* &<@anonymous:3368> */
	obj_t BGl_z62zc3z04anonymousza33368ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15369, obj_t BgL_sz00_15372)
	{
		{	/* Eval/evaluate_comp.scm 537 */
			{	/* Eval/evaluate_comp.scm 537 */
				obj_t BgL_bodyz00_15370;
				obj_t BgL_ez00_15371;

				BgL_bodyz00_15370 = PROCEDURE_REF(BgL_envz00_15369, (int) (((long) 0)));
				BgL_ez00_15371 = PROCEDURE_REF(BgL_envz00_15369, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 537 */
					obj_t BgL_bpz00_18042;

					BgL_bpz00_18042 = VECTOR_REF(((obj_t) BgL_sz00_15372), ((long) 0));
					{	/* Eval/evaluate_comp.scm 539 */
						obj_t BgL_exitd1126z00_18043;

						BgL_exitd1126z00_18043 = BGL_EXITD_TOP_AS_OBJ();
						{	/* Eval/evaluate_comp.scm 540 */
							obj_t BgL_zc3z04anonymousza33369ze3z87_18044;

							BgL_zc3z04anonymousza33369ze3z87_18044 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33369ze3ze5zz__evaluate_compz00,
								(int) (((long) 0)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33369ze3z87_18044,
								(int) (((long) 0)), BgL_sz00_15372);
							PROCEDURE_SET(BgL_zc3z04anonymousza33369ze3z87_18044,
								(int) (((long) 1)), BgL_bpz00_18042);
							PROCEDURE_SET(BgL_zc3z04anonymousza33369ze3z87_18044,
								(int) (((long) 2)), BgL_bodyz00_15370);
							BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
								(BgL_exitd1126z00_18043,
								BgL_zc3z04anonymousza33369ze3z87_18044);
							{	/* Eval/evaluate_comp.scm 539 */
								obj_t BgL_tmp1128z00_18045;

								BgL_tmp1128z00_18045 =
									PROCEDURE_ENTRY(BgL_ez00_15371) (BgL_ez00_15371,
									BgL_sz00_15372, BEOA);
								BGl_exitdzd2popzd2protectz12z12zz__bexitz00
									(BgL_exitd1126z00_18043);
								VECTOR_SET(((obj_t) BgL_sz00_15372), ((long) 0),
									BgL_bpz00_18042);
								PROCEDURE_ENTRY(BgL_bodyz00_15370) (BgL_bodyz00_15370,
									BgL_sz00_15372, BEOA);
								return BgL_tmp1128z00_18045;
							}
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3369> */
	obj_t BGl_z62zc3z04anonymousza33369ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15373)
	{
		{	/* Eval/evaluate_comp.scm 539 */
			{	/* Eval/evaluate_comp.scm 540 */
				obj_t BgL_sz00_15374;
				obj_t BgL_savedzd2bpzd2_15375;
				obj_t BgL_bodyz00_15376;

				BgL_sz00_15374 = PROCEDURE_REF(BgL_envz00_15373, (int) (((long) 0)));
				BgL_savedzd2bpzd2_15375 =
					PROCEDURE_REF(BgL_envz00_15373, (int) (((long) 1)));
				BgL_bodyz00_15376 = PROCEDURE_REF(BgL_envz00_15373, (int) (((long) 2)));
				VECTOR_SET(
					((obj_t) BgL_sz00_15374), ((long) 0), BgL_savedzd2bpzd2_15375);
				return
					PROCEDURE_ENTRY(BgL_bodyz00_15376) (BgL_bodyz00_15376, BgL_sz00_15374,
					BEOA);
			}
		}

	}



/* &comp-ev_bind-exit1424 */
	obj_t BGl_z62compzd2ev_bindzd2exit1424z62zz__evaluate_compz00(obj_t
		BgL_envz00_15377, obj_t BgL_ez00_15378, obj_t BgL_stkz00_15379)
	{
		{	/* Eval/evaluate_comp.scm 523 */
			{	/* Eval/evaluate_comp.scm 525 */
				long BgL_siza7eza7_18047;
				obj_t BgL_nstkz00_18048;

				BgL_siza7eza7_18047 = bgl_list_length(BgL_stkz00_15379);
				{	/* Eval/evaluate_comp.scm 525 */
					obj_t BgL_arg3366z00_18049;

					{	/* Eval/evaluate_comp.scm 525 */
						BgL_ev_varz00_bglt BgL_arg3367z00_18050;

						BgL_arg3367z00_18050 =
							(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15378)))->BgL_varz00);
						BgL_arg3366z00_18049 =
							MAKE_YOUNG_PAIR(((obj_t) BgL_arg3367z00_18050), BNIL);
					}
					BgL_nstkz00_18048 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15379,
						BgL_arg3366z00_18049);
				}
				{	/* Eval/evaluate_comp.scm 526 */
					obj_t BgL_bodyz00_18051;
					obj_t BgL_effzf3zf3_18052;

					BgL_bodyz00_18051 =
						BGl_compz00zz__evaluate_compz00(
						(((BgL_ev_bindzd2exitzd2_bglt) COBJECT(
									((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15378)))->BgL_bodyz00),
						BgL_nstkz00_18048);
					BgL_effzf3zf3_18052 =
						(((BgL_ev_varz00_bglt) COBJECT((((BgL_ev_bindzd2exitzd2_bglt)
										COBJECT(((BgL_ev_bindzd2exitzd2_bglt) BgL_ez00_15378)))->
									BgL_varz00)))->BgL_effz00);
					{	/* Eval/evaluate_comp.scm 527 */
						obj_t BgL_zc3z04anonymousza33359ze3z87_18053;

						BgL_zc3z04anonymousza33359ze3z87_18053 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33359ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 3)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33359ze3z87_18053,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18047));
						PROCEDURE_SET(BgL_zc3z04anonymousza33359ze3z87_18053,
							(int) (((long) 1)), BgL_effzf3zf3_18052);
						PROCEDURE_SET(BgL_zc3z04anonymousza33359ze3z87_18053,
							(int) (((long) 2)), BgL_bodyz00_18051);
						return BgL_zc3z04anonymousza33359ze3z87_18053;
					}
				}
			}
		}

	}



/* &<@anonymous:3359> */
	obj_t BGl_z62zc3z04anonymousza33359ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15380, obj_t BgL_sz00_15384)
	{
		{	/* Eval/evaluate_comp.scm 527 */
			{	/* Eval/evaluate_comp.scm 527 */
				long BgL_siza7eza7_15381;
				obj_t BgL_effzf3zf3_15382;
				obj_t BgL_bodyz00_15383;

				BgL_siza7eza7_15381 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15380, (int) (((long) 0))));
				BgL_effzf3zf3_15382 =
					PROCEDURE_REF(BgL_envz00_15380, (int) (((long) 1)));
				BgL_bodyz00_15383 = PROCEDURE_REF(BgL_envz00_15380, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 527 */
					obj_t BgL_bpz00_18054;

					BgL_bpz00_18054 = VECTOR_REF(((obj_t) BgL_sz00_15384), ((long) 0));
					{	/* Eval/evaluate_comp.scm 529 */
						obj_t BgL_za2za2resza2za2z00_18055;

						BgL_za2za2resza2za2z00_18055 =
							BGl_zc3z04exitza33360ze3ze70z60zz__evaluate_compz00
							(BgL_bodyz00_15383, BgL_sz00_15384, BgL_effzf3zf3_15382,
							BgL_siza7eza7_15381, BgL_bpz00_18054);
						VECTOR_SET(((obj_t) BgL_sz00_15384), ((long) 0), BgL_bpz00_18054);
						return BgL_za2za2resza2za2z00_18055;
					}
				}
			}
		}

	}



/* <@exit:3360>~0 */
	obj_t BGl_zc3z04exitza33360ze3ze70z60zz__evaluate_compz00(obj_t
		BgL_bodyz00_15540, obj_t BgL_sz00_15539, obj_t BgL_effzf3zf3_15538,
		long BgL_siza7eza7_15537, obj_t BgL_bpz00_15536)
	{
		{	/* Eval/evaluate_comp.scm 529 */
			jmp_buf_t jmpbuf;
			void *BgL_an_exit1121z00_4158;

			if (SET_EXIT(BgL_an_exit1121z00_4158))
				{
					return BGL_EXIT_VALUE();
				}
			else
				{
#if( SIGSETJMP_SAVESIGS == 0 )
					bgl_restore_signal_handlers();
#endif

					BgL_an_exit1121z00_4158 = (void *) jmpbuf;
					{	/* Eval/evaluate_comp.scm 529 */

						PUSH_EXIT(BgL_an_exit1121z00_4158, ((long) 1));
						{	/* Eval/evaluate_comp.scm 529 */
							obj_t BgL_an_exitd1122z00_4159;

							BgL_an_exitd1122z00_4159 = ((obj_t) (&exitd));
							{	/* Eval/evaluate_comp.scm 529 */
								obj_t BgL_exitz00_14329;

								BgL_exitz00_14329 =
									MAKE_FX_PROCEDURE(BGl_z62exitz62zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_exitz00_14329,
									(int) (((long) 0)), BgL_an_exitd1122z00_4159);
								{	/* Eval/evaluate_comp.scm 529 */
									obj_t BgL_res1124z00_4162;

									{	/* Eval/evaluate_comp.scm 530 */
										long BgL_arg3361z00_4163;
										obj_t BgL_arg3363z00_4164;

										BgL_arg3361z00_4163 =
											((long) CINT(BgL_bpz00_15536) + BgL_siza7eza7_15537);
										if (CBOOL(BgL_effzf3zf3_15538))
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_10538;

												BgL_newz00_10538 =
													create_struct(BGl_symbol5857z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_33405;

													BgL_tmpz00_33405 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_10538, BgL_tmpz00_33405,
														BgL_exitz00_14329);
												}
												BgL_arg3363z00_4164 = BgL_newz00_10538;
											}
										else
											{	/* Eval/evaluate_comp.scm 530 */
												BgL_arg3363z00_4164 = BgL_exitz00_14329;
											}
										VECTOR_SET(
											((obj_t) BgL_sz00_15539), BgL_arg3361z00_4163,
											BgL_arg3363z00_4164);
									}
									BgL_res1124z00_4162 =
										PROCEDURE_ENTRY(BgL_bodyz00_15540) (BgL_bodyz00_15540,
										BgL_sz00_15539, BEOA);
									POP_EXIT();
									return BgL_res1124z00_4162;
								}
							}
						}
					}
				}
		}

	}



/* &exit */
	obj_t BGl_z62exitz62zz__evaluate_compz00(obj_t BgL_envz00_15385,
		obj_t BgL_val1123z00_15387)
	{
		{	/* Eval/evaluate_comp.scm 529 */
			return
				BGl_unwindzd2untilz12zc0zz__bexitz00(PROCEDURE_REF(BgL_envz00_15385,
					(int) (((long) 0))), BgL_val1123z00_15387);
		}

	}



/* &comp-ev_letrec1422 */
	obj_t BGl_z62compzd2ev_letrec1422zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15388, obj_t BgL_ez00_15389, obj_t BgL_stkz00_15390)
	{
		{	/* Eval/evaluate_comp.scm 494 */
			{	/* Eval/evaluate_comp.scm 496 */
				long BgL_siza7eza7_18057;
				obj_t BgL_nstkz00_18058;

				BgL_siza7eza7_18057 = bgl_list_length(BgL_stkz00_15390);
				{	/* Eval/evaluate_comp.scm 496 */
					obj_t BgL_arg3358z00_18059;

					BgL_arg3358z00_18059 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letrecz00_bglt) BgL_ez00_15389))))->BgL_varsz00);
					BgL_nstkz00_18058 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15390,
						BgL_arg3358z00_18059);
				}
				{	/* Eval/evaluate_comp.scm 497 */
					obj_t BgL_cvalsz00_18060;
					obj_t BgL_bodyz00_18061;

					{	/* Eval/evaluate_comp.scm 497 */
						obj_t BgL_l1318z00_18062;

						BgL_l1318z00_18062 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_15389))))->BgL_valsz00);
						if (NULLP(BgL_l1318z00_18062))
							{	/* Eval/evaluate_comp.scm 497 */
								BgL_cvalsz00_18060 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 497 */
								obj_t BgL_head1320z00_18063;

								{	/* Eval/evaluate_comp.scm 497 */
									obj_t BgL_res5199z00_18064;

									BgL_res5199z00_18064 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1320z00_18063 = BgL_res5199z00_18064;
								}
								{
									obj_t BgL_l1318z00_18066;
									obj_t BgL_tail1321z00_18067;

									BgL_l1318z00_18066 = BgL_l1318z00_18062;
									BgL_tail1321z00_18067 = BgL_head1320z00_18063;
								BgL_zc3z04anonymousza33343ze3z87_18065:
									if (NULLP(BgL_l1318z00_18066))
										{	/* Eval/evaluate_comp.scm 497 */
											BgL_cvalsz00_18060 = CDR(BgL_head1320z00_18063);
										}
									else
										{	/* Eval/evaluate_comp.scm 497 */
											obj_t BgL_newtail1322z00_18068;

											{	/* Eval/evaluate_comp.scm 497 */
												obj_t BgL_arg3349z00_18069;

												{	/* Eval/evaluate_comp.scm 497 */
													obj_t BgL_vz00_18070;

													BgL_vz00_18070 = CAR(((obj_t) BgL_l1318z00_18066));
													BgL_arg3349z00_18069 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_18070),
														BgL_nstkz00_18058);
												}
												{	/* Eval/evaluate_comp.scm 497 */
													obj_t BgL_res5205z00_18071;

													BgL_res5205z00_18071 =
														MAKE_YOUNG_PAIR(BgL_arg3349z00_18069, BNIL);
													BgL_newtail1322z00_18068 = BgL_res5205z00_18071;
												}
											}
											SET_CDR(BgL_tail1321z00_18067, BgL_newtail1322z00_18068);
											{	/* Eval/evaluate_comp.scm 497 */
												obj_t BgL_arg3348z00_18072;

												BgL_arg3348z00_18072 =
													CDR(((obj_t) BgL_l1318z00_18066));
												{
													obj_t BgL_tail1321z00_33441;
													obj_t BgL_l1318z00_33440;

													BgL_l1318z00_33440 = BgL_arg3348z00_18072;
													BgL_tail1321z00_33441 = BgL_newtail1322z00_18068;
													BgL_tail1321z00_18067 = BgL_tail1321z00_33441;
													BgL_l1318z00_18066 = BgL_l1318z00_33440;
													goto BgL_zc3z04anonymousza33343ze3z87_18065;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 498 */
						BgL_ev_exprz00_bglt BgL_arg3350z00_18073;

						BgL_arg3350z00_18073 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letrecz00_bglt) BgL_ez00_15389))))->BgL_bodyz00);
						BgL_bodyz00_18061 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3350z00_18073,
							BgL_nstkz00_18058);
					}
					{	/* Eval/evaluate_comp.scm 499 */
						bool_t BgL_test6830z00_33446;

						{
							obj_t BgL_l1323z00_18075;

							BgL_l1323z00_18075 =
								(((BgL_ev_binderz00_bglt) COBJECT(
										((BgL_ev_binderz00_bglt)
											((BgL_ev_letrecz00_bglt) BgL_ez00_15389))))->BgL_valsz00);
						BgL_zc3z04anonymousza33338ze3z87_18074:
							if (NULLP(BgL_l1323z00_18075))
								{	/* Eval/evaluate_comp.scm 499 */
									BgL_test6830z00_33446 = ((bool_t) 1);
								}
							else
								{	/* Eval/evaluate_comp.scm 499 */
									bool_t BgL_test6832z00_33449;

									{	/* Eval/evaluate_comp.scm 499 */
										obj_t BgL_vz00_18076;

										BgL_vz00_18076 = CAR(((obj_t) BgL_l1323z00_18075));
										BgL_test6832z00_33449 =
											BGl_isazf3zf3zz__objectz00(BgL_vz00_18076,
											BGl_ev_absz00zz__evaluate_typesz00);
									}
									if (BgL_test6832z00_33449)
										{
											obj_t BgL_l1323z00_33453;

											BgL_l1323z00_33453 = CDR(((obj_t) BgL_l1323z00_18075));
											BgL_l1323z00_18075 = BgL_l1323z00_33453;
											goto BgL_zc3z04anonymousza33338ze3z87_18074;
										}
									else
										{	/* Eval/evaluate_comp.scm 499 */
											BgL_test6830z00_33446 = ((bool_t) 0);
										}
								}
						}
						if (BgL_test6830z00_33446)
							{	/* Eval/evaluate_comp.scm 500 */
								obj_t BgL_zc3z04anonymousza33303ze3z87_18077;

								BgL_zc3z04anonymousza33303ze3z87_18077 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33303ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33303ze3z87_18077,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18057));
								PROCEDURE_SET(BgL_zc3z04anonymousza33303ze3z87_18077,
									(int) (((long) 1)), BgL_cvalsz00_18060);
								PROCEDURE_SET(BgL_zc3z04anonymousza33303ze3z87_18077,
									(int) (((long) 2)), BgL_bodyz00_18061);
								return BgL_zc3z04anonymousza33303ze3z87_18077;
							}
						else
							{	/* Eval/evaluate_comp.scm 510 */
								obj_t BgL_zc3z04anonymousza33318ze3z87_18078;

								BgL_zc3z04anonymousza33318ze3z87_18078 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33318ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 3)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33318ze3z87_18078,
									(int) (((long) 0)), BINT(BgL_siza7eza7_18057));
								PROCEDURE_SET(BgL_zc3z04anonymousza33318ze3z87_18078,
									(int) (((long) 1)), BgL_cvalsz00_18060);
								PROCEDURE_SET(BgL_zc3z04anonymousza33318ze3z87_18078,
									(int) (((long) 2)), BgL_bodyz00_18061);
								return BgL_zc3z04anonymousza33318ze3z87_18078;
							}
					}
				}
			}
		}

	}



/* &<@anonymous:3303> */
	obj_t BGl_z62zc3z04anonymousza33303ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15391, obj_t BgL_sz00_15395)
	{
		{	/* Eval/evaluate_comp.scm 500 */
			{	/* Eval/evaluate_comp.scm 500 */
				long BgL_siza7eza7_15392;
				obj_t BgL_cvalsz00_15393;
				obj_t BgL_bodyz00_15394;

				BgL_siza7eza7_15392 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15391, (int) (((long) 0))));
				BgL_cvalsz00_15393 =
					PROCEDURE_REF(BgL_envz00_15391, (int) (((long) 1)));
				BgL_bodyz00_15394 = PROCEDURE_REF(BgL_envz00_15391, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 500 */
					obj_t BgL_bpz00_18079;

					BgL_bpz00_18079 = VECTOR_REF(((obj_t) BgL_sz00_15395), ((long) 0));
					{	/* Eval/evaluate_comp.scm 501 */
						long BgL_g1115z00_18080;

						BgL_g1115z00_18080 =
							((long) CINT(BgL_bpz00_18079) + BgL_siza7eza7_15392);
						{
							obj_t BgL_lz00_18082;
							long BgL_iz00_18083;

							BgL_lz00_18082 = BgL_cvalsz00_15393;
							BgL_iz00_18083 = BgL_g1115z00_18080;
						BgL_recz00_18081:
							if (NULLP(BgL_lz00_18082))
								{	/* Eval/evaluate_comp.scm 502 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 502 */
									{	/* Eval/evaluate_comp.scm 503 */
										obj_t BgL_arg3306z00_18084;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_18085;

											BgL_newz00_18085 =
												create_struct(BGl_symbol5857z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_33494;

												BgL_tmpz00_33494 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_18085, BgL_tmpz00_33494, BUNSPEC);
											}
											BgL_arg3306z00_18084 = BgL_newz00_18085;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15395), BgL_iz00_18083,
											BgL_arg3306z00_18084);
									}
									{	/* Eval/evaluate_comp.scm 504 */
										obj_t BgL_arg3307z00_18086;
										long BgL_arg3308z00_18087;

										BgL_arg3307z00_18086 = CDR(((obj_t) BgL_lz00_18082));
										BgL_arg3308z00_18087 = (BgL_iz00_18083 + ((long) 1));
										{
											long BgL_iz00_33503;
											obj_t BgL_lz00_33502;

											BgL_lz00_33502 = BgL_arg3307z00_18086;
											BgL_iz00_33503 = BgL_arg3308z00_18087;
											BgL_iz00_18083 = BgL_iz00_33503;
											BgL_lz00_18082 = BgL_lz00_33502;
											goto BgL_recz00_18081;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 505 */
						long BgL_g1116z00_18088;

						BgL_g1116z00_18088 =
							((long) CINT(BgL_bpz00_18079) + BgL_siza7eza7_15392);
						{
							obj_t BgL_lz00_18090;
							long BgL_iz00_18091;

							BgL_lz00_18090 = BgL_cvalsz00_15393;
							BgL_iz00_18091 = BgL_g1116z00_18088;
						BgL_recz00_18089:
							if (NULLP(BgL_lz00_18090))
								{	/* Eval/evaluate_comp.scm 506 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 506 */
									{	/* Eval/evaluate_comp.scm 507 */
										obj_t BgL_arg3311z00_18092;
										obj_t BgL_arg3312z00_18093;

										BgL_arg3311z00_18092 =
											VECTOR_REF(((obj_t) BgL_sz00_15395), BgL_iz00_18091);
										{	/* Eval/evaluate_comp.scm 507 */
											obj_t BgL_fun3313z00_18094;

											BgL_fun3313z00_18094 = CAR(((obj_t) BgL_lz00_18090));
											BgL_arg3312z00_18093 =
												PROCEDURE_ENTRY(BgL_fun3313z00_18094)
												(BgL_fun3313z00_18094, BgL_sz00_15395, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 202 */
											int BgL_auxz00_33518;
											obj_t BgL_tmpz00_33516;

											BgL_auxz00_33518 = (int) (((long) 0));
											BgL_tmpz00_33516 = ((obj_t) BgL_arg3311z00_18092);
											STRUCT_SET(BgL_tmpz00_33516, BgL_auxz00_33518,
												BgL_arg3312z00_18093);
									}}
									{	/* Eval/evaluate_comp.scm 508 */
										obj_t BgL_arg3314z00_18095;
										long BgL_arg3317z00_18096;

										BgL_arg3314z00_18095 = CDR(((obj_t) BgL_lz00_18090));
										BgL_arg3317z00_18096 = (BgL_iz00_18091 + ((long) 1));
										{
											long BgL_iz00_33525;
											obj_t BgL_lz00_33524;

											BgL_lz00_33524 = BgL_arg3314z00_18095;
											BgL_iz00_33525 = BgL_arg3317z00_18096;
											BgL_iz00_18091 = BgL_iz00_33525;
											BgL_lz00_18090 = BgL_lz00_33524;
											goto BgL_recz00_18089;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15394) (BgL_bodyz00_15394,
						BgL_sz00_15395, BEOA);
				}
			}
		}

	}



/* &<@anonymous:3318> */
	obj_t BGl_z62zc3z04anonymousza33318ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15396, obj_t BgL_sz00_15400)
	{
		{	/* Eval/evaluate_comp.scm 510 */
			{	/* Eval/evaluate_comp.scm 510 */
				long BgL_siza7eza7_15397;
				obj_t BgL_cvalsz00_15398;
				obj_t BgL_bodyz00_15399;

				BgL_siza7eza7_15397 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15396, (int) (((long) 0))));
				BgL_cvalsz00_15398 =
					PROCEDURE_REF(BgL_envz00_15396, (int) (((long) 1)));
				BgL_bodyz00_15399 = PROCEDURE_REF(BgL_envz00_15396, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 510 */
					obj_t BgL_bpz00_18097;

					BgL_bpz00_18097 = VECTOR_REF(((obj_t) BgL_sz00_15400), ((long) 0));
					{	/* Eval/evaluate_comp.scm 511 */
						long BgL_g1117z00_18098;

						BgL_g1117z00_18098 =
							((long) CINT(BgL_bpz00_18097) + BgL_siza7eza7_15397);
						{
							obj_t BgL_lz00_18100;
							long BgL_iz00_18101;

							BgL_lz00_18100 = BgL_cvalsz00_15398;
							BgL_iz00_18101 = BgL_g1117z00_18098;
						BgL_recz00_18099:
							if (NULLP(BgL_lz00_18100))
								{	/* Eval/evaluate_comp.scm 512 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 512 */
									{	/* Eval/evaluate_comp.scm 513 */
										obj_t BgL_arg3321z00_18102;

										{	/* Eval/evaluate_comp.scm 202 */
											obj_t BgL_newz00_18103;

											BgL_newz00_18103 =
												create_struct(BGl_symbol5857z00zz__evaluate_compz00,
												(int) (((long) 1)));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_tmpz00_33545;

												BgL_tmpz00_33545 = (int) (((long) 0));
												STRUCT_SET(BgL_newz00_18103, BgL_tmpz00_33545, BUNSPEC);
											}
											BgL_arg3321z00_18102 = BgL_newz00_18103;
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15400), BgL_iz00_18101,
											BgL_arg3321z00_18102);
									}
									{	/* Eval/evaluate_comp.scm 514 */
										obj_t BgL_arg3322z00_18104;
										long BgL_arg3323z00_18105;

										BgL_arg3322z00_18104 = CDR(((obj_t) BgL_lz00_18100));
										BgL_arg3323z00_18105 = (BgL_iz00_18101 + ((long) 1));
										{
											long BgL_iz00_33554;
											obj_t BgL_lz00_33553;

											BgL_lz00_33553 = BgL_arg3322z00_18104;
											BgL_iz00_33554 = BgL_arg3323z00_18105;
											BgL_iz00_18101 = BgL_iz00_33554;
											BgL_lz00_18100 = BgL_lz00_33553;
											goto BgL_recz00_18099;
										}
									}
								}
						}
					}
					{	/* Eval/evaluate_comp.scm 515 */
						obj_t BgL_rvalsz00_18106;

						if (NULLP(BgL_cvalsz00_15398))
							{	/* Eval/evaluate_comp.scm 515 */
								BgL_rvalsz00_18106 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 515 */
								obj_t BgL_head1329z00_18107;

								{	/* Eval/evaluate_comp.scm 515 */
									obj_t BgL_res5225z00_18108;

									BgL_res5225z00_18108 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1329z00_18107 = BgL_res5225z00_18108;
								}
								{
									obj_t BgL_l1327z00_18110;
									obj_t BgL_tail1330z00_18111;

									BgL_l1327z00_18110 = BgL_cvalsz00_15398;
									BgL_tail1330z00_18111 = BgL_head1329z00_18107;
								BgL_zc3z04anonymousza33334ze3z87_18109:
									if (NULLP(BgL_l1327z00_18110))
										{	/* Eval/evaluate_comp.scm 515 */
											BgL_rvalsz00_18106 = CDR(BgL_head1329z00_18107);
										}
									else
										{	/* Eval/evaluate_comp.scm 515 */
											obj_t BgL_newtail1331z00_18112;

											{	/* Eval/evaluate_comp.scm 515 */
												obj_t BgL_arg3337z00_18113;

												{	/* Eval/evaluate_comp.scm 515 */
													obj_t BgL_vz00_18114;

													BgL_vz00_18114 = CAR(((obj_t) BgL_l1327z00_18110));
													BgL_arg3337z00_18113 =
														PROCEDURE_ENTRY(BgL_vz00_18114) (BgL_vz00_18114,
														BgL_sz00_15400, BEOA);
												}
												{	/* Eval/evaluate_comp.scm 515 */
													obj_t BgL_res5231z00_18115;

													BgL_res5231z00_18115 =
														MAKE_YOUNG_PAIR(BgL_arg3337z00_18113, BNIL);
													BgL_newtail1331z00_18112 = BgL_res5231z00_18115;
												}
											}
											SET_CDR(BgL_tail1330z00_18111, BgL_newtail1331z00_18112);
											{	/* Eval/evaluate_comp.scm 515 */
												obj_t BgL_arg3336z00_18116;

												BgL_arg3336z00_18116 =
													CDR(((obj_t) BgL_l1327z00_18110));
												{
													obj_t BgL_tail1330z00_33572;
													obj_t BgL_l1327z00_33571;

													BgL_l1327z00_33571 = BgL_arg3336z00_18116;
													BgL_tail1330z00_33572 = BgL_newtail1331z00_18112;
													BgL_tail1330z00_18111 = BgL_tail1330z00_33572;
													BgL_l1327z00_18110 = BgL_l1327z00_33571;
													goto BgL_zc3z04anonymousza33334ze3z87_18109;
												}
											}
										}
								}
							}
						{	/* Eval/evaluate_comp.scm 516 */
							long BgL_g1118z00_18117;

							BgL_g1118z00_18117 =
								((long) CINT(BgL_bpz00_18097) + BgL_siza7eza7_15397);
							{
								obj_t BgL_lz00_18119;
								long BgL_iz00_18120;

								BgL_lz00_18119 = BgL_rvalsz00_18106;
								BgL_iz00_18120 = BgL_g1118z00_18117;
							BgL_recz00_18118:
								if (NULLP(BgL_lz00_18119))
									{	/* Eval/evaluate_comp.scm 517 */
										((bool_t) 0);
									}
								else
									{	/* Eval/evaluate_comp.scm 517 */
										{	/* Eval/evaluate_comp.scm 518 */
											obj_t BgL_arg3326z00_18121;
											obj_t BgL_arg3329z00_18122;

											BgL_arg3326z00_18121 =
												VECTOR_REF(((obj_t) BgL_sz00_15400), BgL_iz00_18120);
											BgL_arg3329z00_18122 = CAR(((obj_t) BgL_lz00_18119));
											{	/* Eval/evaluate_comp.scm 202 */
												int BgL_auxz00_33583;
												obj_t BgL_tmpz00_33581;

												BgL_auxz00_33583 = (int) (((long) 0));
												BgL_tmpz00_33581 = ((obj_t) BgL_arg3326z00_18121);
												STRUCT_SET(BgL_tmpz00_33581, BgL_auxz00_33583,
													BgL_arg3329z00_18122);
										}}
										{	/* Eval/evaluate_comp.scm 519 */
											obj_t BgL_arg3331z00_18123;
											long BgL_arg3332z00_18124;

											BgL_arg3331z00_18123 = CDR(((obj_t) BgL_lz00_18119));
											BgL_arg3332z00_18124 = (BgL_iz00_18120 + ((long) 1));
											{
												long BgL_iz00_33590;
												obj_t BgL_lz00_33589;

												BgL_lz00_33589 = BgL_arg3331z00_18123;
												BgL_iz00_33590 = BgL_arg3332z00_18124;
												BgL_iz00_18120 = BgL_iz00_33590;
												BgL_lz00_18119 = BgL_lz00_33589;
												goto BgL_recz00_18118;
											}
										}
									}
							}
						}
						return
							PROCEDURE_ENTRY(BgL_bodyz00_15399) (BgL_bodyz00_15399,
							BgL_sz00_15400, BEOA);
					}
				}
			}
		}

	}



/* &comp-ev_let*1420 */
	obj_t BGl_z62compzd2ev_letza21420z12zz__evaluate_compz00(obj_t
		BgL_envz00_15401, obj_t BgL_ez00_15402, obj_t BgL_stkz00_15403)
	{
		{	/* Eval/evaluate_comp.scm 481 */
			{	/* Eval/evaluate_comp.scm 483 */
				long BgL_siza7eza7_18126;
				obj_t BgL_nstkz00_18127;

				BgL_siza7eza7_18126 = bgl_list_length(BgL_stkz00_15403);
				{	/* Eval/evaluate_comp.scm 483 */
					obj_t BgL_arg3298z00_18128;

					BgL_arg3298z00_18128 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letza2za2_bglt) BgL_ez00_15402))))->BgL_varsz00);
					BgL_nstkz00_18127 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15403,
						BgL_arg3298z00_18128);
				}
				{	/* Eval/evaluate_comp.scm 484 */
					obj_t BgL_valsz00_18129;
					obj_t BgL_bodyz00_18130;

					{	/* Eval/evaluate_comp.scm 484 */
						obj_t BgL_l1313z00_18131;

						BgL_l1313z00_18131 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_15402))))->BgL_valsz00);
						if (NULLP(BgL_l1313z00_18131))
							{	/* Eval/evaluate_comp.scm 484 */
								BgL_valsz00_18129 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 484 */
								obj_t BgL_head1315z00_18132;

								{	/* Eval/evaluate_comp.scm 484 */
									obj_t BgL_res5188z00_18133;

									BgL_res5188z00_18133 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1315z00_18132 = BgL_res5188z00_18133;
								}
								{
									obj_t BgL_l1313z00_18135;
									obj_t BgL_tail1316z00_18136;

									BgL_l1313z00_18135 = BgL_l1313z00_18131;
									BgL_tail1316z00_18136 = BgL_head1315z00_18132;
								BgL_zc3z04anonymousza33290ze3z87_18134:
									if (NULLP(BgL_l1313z00_18135))
										{	/* Eval/evaluate_comp.scm 484 */
											BgL_valsz00_18129 = CDR(BgL_head1315z00_18132);
										}
									else
										{	/* Eval/evaluate_comp.scm 484 */
											obj_t BgL_newtail1317z00_18137;

											{	/* Eval/evaluate_comp.scm 484 */
												obj_t BgL_arg3296z00_18138;

												{	/* Eval/evaluate_comp.scm 484 */
													obj_t BgL_vz00_18139;

													BgL_vz00_18139 = CAR(((obj_t) BgL_l1313z00_18135));
													BgL_arg3296z00_18138 =
														BGl_compz00zz__evaluate_compz00(
														((BgL_ev_exprz00_bglt) BgL_vz00_18139),
														BgL_nstkz00_18127);
												}
												{	/* Eval/evaluate_comp.scm 484 */
													obj_t BgL_res5194z00_18140;

													BgL_res5194z00_18140 =
														MAKE_YOUNG_PAIR(BgL_arg3296z00_18138, BNIL);
													BgL_newtail1317z00_18137 = BgL_res5194z00_18140;
												}
											}
											SET_CDR(BgL_tail1316z00_18136, BgL_newtail1317z00_18137);
											{	/* Eval/evaluate_comp.scm 484 */
												obj_t BgL_arg3295z00_18141;

												BgL_arg3295z00_18141 =
													CDR(((obj_t) BgL_l1313z00_18135));
												{
													obj_t BgL_tail1316z00_33618;
													obj_t BgL_l1313z00_33617;

													BgL_l1313z00_33617 = BgL_arg3295z00_18141;
													BgL_tail1316z00_33618 = BgL_newtail1317z00_18137;
													BgL_tail1316z00_18136 = BgL_tail1316z00_33618;
													BgL_l1313z00_18135 = BgL_l1313z00_33617;
													goto BgL_zc3z04anonymousza33290ze3z87_18134;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 485 */
						BgL_ev_exprz00_bglt BgL_arg3297z00_18142;

						BgL_arg3297z00_18142 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letza2za2_bglt) BgL_ez00_15402))))->BgL_bodyz00);
						BgL_bodyz00_18130 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3297z00_18142,
							BgL_nstkz00_18127);
					}
					{	/* Eval/evaluate_comp.scm 486 */
						obj_t BgL_zc3z04anonymousza33274ze3z87_18143;

						BgL_zc3z04anonymousza33274ze3z87_18143 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33274ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33274ze3z87_18143,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18126));
						PROCEDURE_SET(BgL_zc3z04anonymousza33274ze3z87_18143,
							(int) (((long) 1)),
							((obj_t) ((BgL_ev_letza2za2_bglt) BgL_ez00_15402)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33274ze3z87_18143,
							(int) (((long) 2)), BgL_valsz00_18129);
						PROCEDURE_SET(BgL_zc3z04anonymousza33274ze3z87_18143,
							(int) (((long) 3)), BgL_bodyz00_18130);
						return BgL_zc3z04anonymousza33274ze3z87_18143;
					}
				}
			}
		}

	}



/* &<@anonymous:3274> */
	obj_t BGl_z62zc3z04anonymousza33274ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15404, obj_t BgL_sz00_15409)
	{
		{	/* Eval/evaluate_comp.scm 486 */
			{	/* Eval/evaluate_comp.scm 486 */
				long BgL_siza7eza7_15405;
				BgL_ev_letza2za2_bglt BgL_i1112z00_15406;
				obj_t BgL_valsz00_15407;
				obj_t BgL_bodyz00_15408;

				BgL_siza7eza7_15405 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15404, (int) (((long) 0))));
				BgL_i1112z00_15406 =
					((BgL_ev_letza2za2_bglt)
					PROCEDURE_REF(BgL_envz00_15404, (int) (((long) 1))));
				BgL_valsz00_15407 = PROCEDURE_REF(BgL_envz00_15404, (int) (((long) 2)));
				BgL_bodyz00_15408 = PROCEDURE_REF(BgL_envz00_15404, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 486 */
					obj_t BgL_bpz00_18144;

					BgL_bpz00_18144 = VECTOR_REF(((obj_t) BgL_sz00_15409), ((long) 0));
					{	/* Eval/evaluate_comp.scm 487 */
						long BgL_g1113z00_18145;

						BgL_g1113z00_18145 =
							((long) CINT(BgL_bpz00_18144) + BgL_siza7eza7_15405);
						{
							obj_t BgL_lz00_18147;
							long BgL_iz00_18148;
							obj_t BgL_bza2za2_18149;

							BgL_lz00_18147 = BgL_valsz00_15407;
							BgL_iz00_18148 = BgL_g1113z00_18145;
							BgL_bza2za2_18149 =
								(((BgL_ev_letza2za2_bglt) COBJECT(BgL_i1112z00_15406))->
								BgL_boxesz00);
						BgL_recz00_18146:
							if (NULLP(BgL_lz00_18147))
								{	/* Eval/evaluate_comp.scm 488 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 488 */
									{	/* Eval/evaluate_comp.scm 489 */
										obj_t BgL_valz00_18150;

										{	/* Eval/evaluate_comp.scm 489 */
											obj_t BgL_fun3280z00_18151;

											BgL_fun3280z00_18151 = CAR(((obj_t) BgL_lz00_18147));
											BgL_valz00_18150 =
												PROCEDURE_ENTRY(BgL_fun3280z00_18151)
												(BgL_fun3280z00_18151, BgL_sz00_15409, BEOA);
										}
										{	/* Eval/evaluate_comp.scm 490 */
											obj_t BgL_arg3278z00_18152;

											if (CBOOL(CAR(((obj_t) BgL_bza2za2_18149))))
												{	/* Eval/evaluate_comp.scm 202 */
													obj_t BgL_newz00_18153;

													BgL_newz00_18153 =
														create_struct(BGl_symbol5857z00zz__evaluate_compz00,
														(int) (((long) 1)));
													{	/* Eval/evaluate_comp.scm 202 */
														int BgL_tmpz00_33665;

														BgL_tmpz00_33665 = (int) (((long) 0));
														STRUCT_SET(BgL_newz00_18153, BgL_tmpz00_33665,
															BgL_valz00_18150);
													}
													BgL_arg3278z00_18152 = BgL_newz00_18153;
												}
											else
												{	/* Eval/evaluate_comp.scm 490 */
													BgL_arg3278z00_18152 = BgL_valz00_18150;
												}
											VECTOR_SET(
												((obj_t) BgL_sz00_15409), BgL_iz00_18148,
												BgL_arg3278z00_18152);
										}
									}
									{	/* Eval/evaluate_comp.scm 491 */
										obj_t BgL_arg3286z00_18154;
										long BgL_arg3287z00_18155;
										obj_t BgL_arg3288z00_18156;

										BgL_arg3286z00_18154 = CDR(((obj_t) BgL_lz00_18147));
										BgL_arg3287z00_18155 = (BgL_iz00_18148 + ((long) 1));
										BgL_arg3288z00_18156 = CDR(((obj_t) BgL_bza2za2_18149));
										{
											obj_t BgL_bza2za2_33677;
											long BgL_iz00_33676;
											obj_t BgL_lz00_33675;

											BgL_lz00_33675 = BgL_arg3286z00_18154;
											BgL_iz00_33676 = BgL_arg3287z00_18155;
											BgL_bza2za2_33677 = BgL_arg3288z00_18156;
											BgL_bza2za2_18149 = BgL_bza2za2_33677;
											BgL_iz00_18148 = BgL_iz00_33676;
											BgL_lz00_18147 = BgL_lz00_33675;
											goto BgL_recz00_18146;
										}
									}
								}
						}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15408) (BgL_bodyz00_15408,
						BgL_sz00_15409, BEOA);
				}
			}
		}

	}



/* &comp-ev_let1418 */
	obj_t BGl_z62compzd2ev_let1418zb0zz__evaluate_compz00(obj_t BgL_envz00_15410,
		obj_t BgL_ez00_15411, obj_t BgL_stkz00_15412)
	{
		{	/* Eval/evaluate_comp.scm 462 */
			{	/* Eval/evaluate_comp.scm 464 */
				long BgL_siza7eza7_18158;
				obj_t BgL_nstkz00_18159;

				BgL_siza7eza7_18158 = bgl_list_length(BgL_stkz00_15412);
				{	/* Eval/evaluate_comp.scm 464 */
					obj_t BgL_arg3273z00_18160;

					BgL_arg3273z00_18160 =
						(((BgL_ev_binderz00_bglt) COBJECT(
								((BgL_ev_binderz00_bglt)
									((BgL_ev_letz00_bglt) BgL_ez00_15411))))->BgL_varsz00);
					BgL_nstkz00_18159 =
						BGl_appendzd221011zd2zz__evaluate_compz00(BgL_stkz00_15412,
						BgL_arg3273z00_18160);
				}
				{	/* Eval/evaluate_comp.scm 465 */
					obj_t BgL_valsz00_18161;
					obj_t BgL_iboxesz00_18162;
					obj_t BgL_bodyz00_18163;

					{	/* Eval/evaluate_comp.scm 466 */
						obj_t BgL_arg3259z00_18164;

						BgL_arg3259z00_18164 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_15411))))->BgL_valsz00);
						BgL_valsz00_18161 =
							BGl_compzd2withzd2pushz00zz__evaluate_compz00
							(BgL_arg3259z00_18164, BgL_stkz00_15412);
					}
					{	/* Eval/evaluate_comp.scm 467 */
						obj_t BgL_l1308z00_18165;

						BgL_l1308z00_18165 =
							(((BgL_ev_letz00_bglt) COBJECT(
									((BgL_ev_letz00_bglt) BgL_ez00_15411)))->BgL_boxesz00);
						if (NULLP(BgL_l1308z00_18165))
							{	/* Eval/evaluate_comp.scm 467 */
								BgL_iboxesz00_18162 = BNIL;
							}
						else
							{	/* Eval/evaluate_comp.scm 467 */
								obj_t BgL_head1310z00_18166;

								{	/* Eval/evaluate_comp.scm 467 */
									obj_t BgL_res5171z00_18167;

									BgL_res5171z00_18167 = MAKE_YOUNG_PAIR(BNIL, BNIL);
									BgL_head1310z00_18166 = BgL_res5171z00_18167;
								}
								{
									obj_t BgL_l1308z00_18169;
									obj_t BgL_tail1311z00_18170;

									BgL_l1308z00_18169 = BgL_l1308z00_18165;
									BgL_tail1311z00_18170 = BgL_head1310z00_18166;
								BgL_zc3z04anonymousza33261ze3z87_18168:
									if (NULLP(BgL_l1308z00_18169))
										{	/* Eval/evaluate_comp.scm 467 */
											BgL_iboxesz00_18162 = CDR(BgL_head1310z00_18166);
										}
									else
										{	/* Eval/evaluate_comp.scm 467 */
											obj_t BgL_newtail1312z00_18171;

											{	/* Eval/evaluate_comp.scm 467 */
												obj_t BgL_arg3268z00_18172;

												{	/* Eval/evaluate_comp.scm 467 */
													obj_t BgL_vz00_18173;

													BgL_vz00_18173 = CAR(((obj_t) BgL_l1308z00_18169));
													BgL_arg3268z00_18172 =
														BGl__indexz00zz__evaluate_compz00(BgL_vz00_18173,
														BgL_nstkz00_18159);
												}
												{	/* Eval/evaluate_comp.scm 467 */
													obj_t BgL_res5177z00_18174;

													BgL_res5177z00_18174 =
														MAKE_YOUNG_PAIR(BgL_arg3268z00_18172, BNIL);
													BgL_newtail1312z00_18171 = BgL_res5177z00_18174;
												}
											}
											SET_CDR(BgL_tail1311z00_18170, BgL_newtail1312z00_18171);
											{	/* Eval/evaluate_comp.scm 467 */
												obj_t BgL_arg3263z00_18175;

												BgL_arg3263z00_18175 =
													CDR(((obj_t) BgL_l1308z00_18169));
												{
													obj_t BgL_tail1311z00_33708;
													obj_t BgL_l1308z00_33707;

													BgL_l1308z00_33707 = BgL_arg3263z00_18175;
													BgL_tail1311z00_33708 = BgL_newtail1312z00_18171;
													BgL_tail1311z00_18170 = BgL_tail1311z00_33708;
													BgL_l1308z00_18169 = BgL_l1308z00_33707;
													goto BgL_zc3z04anonymousza33261ze3z87_18168;
												}
											}
										}
								}
							}
					}
					{	/* Eval/evaluate_comp.scm 468 */
						BgL_ev_exprz00_bglt BgL_arg3269z00_18176;

						BgL_arg3269z00_18176 =
							(((BgL_ev_binderz00_bglt) COBJECT(
									((BgL_ev_binderz00_bglt)
										((BgL_ev_letz00_bglt) BgL_ez00_15411))))->BgL_bodyz00);
						BgL_bodyz00_18163 =
							BGl_compz00zz__evaluate_compz00(BgL_arg3269z00_18176,
							BgL_nstkz00_18159);
					}
					{	/* Eval/evaluate_comp.scm 469 */
						obj_t BgL_zc3z04anonymousza33240ze3z87_18177;

						BgL_zc3z04anonymousza33240ze3z87_18177 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33240ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 4)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33240ze3z87_18177,
							(int) (((long) 0)), BINT(BgL_siza7eza7_18158));
						PROCEDURE_SET(BgL_zc3z04anonymousza33240ze3z87_18177,
							(int) (((long) 1)), BgL_valsz00_18161);
						PROCEDURE_SET(BgL_zc3z04anonymousza33240ze3z87_18177,
							(int) (((long) 2)), BgL_iboxesz00_18162);
						PROCEDURE_SET(BgL_zc3z04anonymousza33240ze3z87_18177,
							(int) (((long) 3)), BgL_bodyz00_18163);
						return BgL_zc3z04anonymousza33240ze3z87_18177;
					}
				}
			}
		}

	}



/* &<@anonymous:3240> */
	obj_t BGl_z62zc3z04anonymousza33240ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15413, obj_t BgL_sz00_15418)
	{
		{	/* Eval/evaluate_comp.scm 469 */
			{	/* Eval/evaluate_comp.scm 469 */
				long BgL_siza7eza7_15414;
				obj_t BgL_valsz00_15415;
				obj_t BgL_iboxesz00_15416;
				obj_t BgL_bodyz00_15417;

				BgL_siza7eza7_15414 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_15413, (int) (((long) 0))));
				BgL_valsz00_15415 =
					((obj_t) PROCEDURE_REF(BgL_envz00_15413, (int) (((long) 1))));
				BgL_iboxesz00_15416 =
					PROCEDURE_REF(BgL_envz00_15413, (int) (((long) 2)));
				BgL_bodyz00_15417 = PROCEDURE_REF(BgL_envz00_15413, (int) (((long) 3)));
				{	/* Eval/evaluate_comp.scm 469 */
					obj_t BgL_bpz00_18178;

					BgL_bpz00_18178 = VECTOR_REF(((obj_t) BgL_sz00_15418), ((long) 0));
					{	/* Eval/evaluate_comp.scm 470 */
						long BgL_g1111z00_18179;

						BgL_g1111z00_18179 =
							((long) CINT(BgL_bpz00_18178) + BgL_siza7eza7_15414);
						{
							obj_t BgL_lz00_18181;
							long BgL_iz00_18182;

							BgL_lz00_18181 = BgL_valsz00_15415;
							BgL_iz00_18182 = BgL_g1111z00_18179;
						BgL_recz00_18180:
							if (NULLP(BgL_lz00_18181))
								{	/* Eval/evaluate_comp.scm 471 */
									((bool_t) 0);
								}
							else
								{	/* Eval/evaluate_comp.scm 471 */
									{	/* Eval/evaluate_comp.scm 472 */
										obj_t BgL_arg3243z00_18183;

										{	/* Eval/evaluate_comp.scm 472 */
											obj_t BgL_fun3244z00_18184;

											BgL_fun3244z00_18184 = CAR(((obj_t) BgL_lz00_18181));
											BgL_arg3243z00_18183 =
												PROCEDURE_ENTRY(BgL_fun3244z00_18184)
												(BgL_fun3244z00_18184, BgL_sz00_15418, BEOA);
										}
										VECTOR_SET(
											((obj_t) BgL_sz00_15418), BgL_iz00_18182,
											BgL_arg3243z00_18183);
									}
									{	/* Eval/evaluate_comp.scm 473 */
										obj_t BgL_arg3245z00_18185;
										long BgL_arg3246z00_18186;

										BgL_arg3245z00_18185 = CDR(((obj_t) BgL_lz00_18181));
										BgL_arg3246z00_18186 = (BgL_iz00_18182 + ((long) 1));
										{
											long BgL_iz00_33753;
											obj_t BgL_lz00_33752;

											BgL_lz00_33752 = BgL_arg3245z00_18185;
											BgL_iz00_33753 = BgL_arg3246z00_18186;
											BgL_iz00_18182 = BgL_iz00_33753;
											BgL_lz00_18181 = BgL_lz00_33752;
											goto BgL_recz00_18180;
										}
									}
								}
						}
					}
					{
						obj_t BgL_lz00_18188;

						BgL_lz00_18188 = BgL_iboxesz00_15416;
					BgL_recz00_18187:
						if (NULLP(BgL_lz00_18188))
							{	/* Eval/evaluate_comp.scm 475 */
								((bool_t) 0);
							}
						else
							{	/* Eval/evaluate_comp.scm 475 */
								{	/* Eval/evaluate_comp.scm 476 */
									long BgL_iz00_18189;

									BgL_iz00_18189 =
										(
										(long) CINT(BgL_bpz00_18178) +
										(long) CINT(CAR(((obj_t) BgL_lz00_18188))));
									{	/* Eval/evaluate_comp.scm 477 */
										obj_t BgL_arg3249z00_18190;

										{	/* Eval/evaluate_comp.scm 477 */
											obj_t BgL_arg3250z00_18191;

											BgL_arg3250z00_18191 =
												VECTOR_REF(((obj_t) BgL_sz00_15418), BgL_iz00_18189);
											{	/* Eval/evaluate_comp.scm 202 */
												obj_t BgL_newz00_18192;

												BgL_newz00_18192 =
													create_struct(BGl_symbol5857z00zz__evaluate_compz00,
													(int) (((long) 1)));
												{	/* Eval/evaluate_comp.scm 202 */
													int BgL_tmpz00_33765;

													BgL_tmpz00_33765 = (int) (((long) 0));
													STRUCT_SET(BgL_newz00_18192, BgL_tmpz00_33765,
														BgL_arg3250z00_18191);
												}
												BgL_arg3249z00_18190 = BgL_newz00_18192;
										}}
										VECTOR_SET(
											((obj_t) BgL_sz00_15418), BgL_iz00_18189,
											BgL_arg3249z00_18190);
								}}
								{	/* Eval/evaluate_comp.scm 478 */
									obj_t BgL_arg3256z00_18193;

									BgL_arg3256z00_18193 = CDR(((obj_t) BgL_lz00_18188));
									{
										obj_t BgL_lz00_33772;

										BgL_lz00_33772 = BgL_arg3256z00_18193;
										BgL_lz00_18188 = BgL_lz00_33772;
										goto BgL_recz00_18187;
									}
								}
							}
					}
					return
						PROCEDURE_ENTRY(BgL_bodyz00_15417) (BgL_bodyz00_15417,
						BgL_sz00_15418, BEOA);
				}
			}
		}

	}



/* &comp-ev_prog21416 */
	obj_t BGl_z62compzd2ev_prog21416zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15419, obj_t BgL_ez00_15420, obj_t BgL_stkz00_15421)
	{
		{	/* Eval/evaluate_comp.scm 456 */
			{	/* Eval/evaluate_comp.scm 458 */
				obj_t BgL_e1z00_18195;
				obj_t BgL_e2z00_18196;

				BgL_e1z00_18195 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_prog2z00_bglt) COBJECT(
								((BgL_ev_prog2z00_bglt) BgL_ez00_15420)))->BgL_e1z00),
					BgL_stkz00_15421);
				BgL_e2z00_18196 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_prog2z00_bglt)
							COBJECT(((BgL_ev_prog2z00_bglt) BgL_ez00_15420)))->BgL_e2z00),
					BgL_stkz00_15421);
				{	/* Eval/evaluate_comp.scm 459 */
					obj_t BgL_zc3z04anonymousza33236ze3z87_18197;

					BgL_zc3z04anonymousza33236ze3z87_18197 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33236ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33236ze3z87_18197,
						(int) (((long) 0)), BgL_e1z00_18195);
					PROCEDURE_SET(BgL_zc3z04anonymousza33236ze3z87_18197,
						(int) (((long) 1)), BgL_e2z00_18196);
					return BgL_zc3z04anonymousza33236ze3z87_18197;
				}
			}
		}

	}



/* &<@anonymous:3236> */
	obj_t BGl_z62zc3z04anonymousza33236ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15422, obj_t BgL_sz00_15425)
	{
		{	/* Eval/evaluate_comp.scm 459 */
			{	/* Eval/evaluate_comp.scm 459 */
				obj_t BgL_e1z00_15423;
				obj_t BgL_e2z00_15424;

				BgL_e1z00_15423 = PROCEDURE_REF(BgL_envz00_15422, (int) (((long) 0)));
				BgL_e2z00_15424 = PROCEDURE_REF(BgL_envz00_15422, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 459 */
					obj_t BgL_bpz00_18198;

					BgL_bpz00_18198 = VECTOR_REF(((obj_t) BgL_sz00_15425), ((long) 0));
					PROCEDURE_ENTRY(BgL_e1z00_15423) (BgL_e1z00_15423, BgL_sz00_15425,
						BEOA);
					return PROCEDURE_ENTRY(BgL_e2z00_15424) (BgL_e2z00_15424,
						BgL_sz00_15425, BEOA);
				}
			}
		}

	}



/* &comp-ev_and1414 */
	obj_t BGl_z62compzd2ev_and1414zb0zz__evaluate_compz00(obj_t BgL_envz00_15426,
		obj_t BgL_ez00_15427, obj_t BgL_stkz00_15428)
	{
		{	/* Eval/evaluate_comp.scm 446 */
			{	/* Eval/evaluate_comp.scm 448 */
				obj_t BgL_argsz00_18200;

				{	/* Eval/evaluate_comp.scm 448 */
					obj_t BgL_l1303z00_18201;

					BgL_l1303z00_18201 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_andz00_bglt) BgL_ez00_15427))))->BgL_argsz00);
					if (NULLP(BgL_l1303z00_18201))
						{	/* Eval/evaluate_comp.scm 448 */
							BgL_argsz00_18200 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 448 */
							obj_t BgL_head1305z00_18202;

							{	/* Eval/evaluate_comp.scm 448 */
								obj_t BgL_res5160z00_18203;

								BgL_res5160z00_18203 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1305z00_18202 = BgL_res5160z00_18203;
							}
							{
								obj_t BgL_l1303z00_18205;
								obj_t BgL_tail1306z00_18206;

								BgL_l1303z00_18205 = BgL_l1303z00_18201;
								BgL_tail1306z00_18206 = BgL_head1305z00_18202;
							BgL_zc3z04anonymousza33231ze3z87_18204:
								if (NULLP(BgL_l1303z00_18205))
									{	/* Eval/evaluate_comp.scm 448 */
										BgL_argsz00_18200 = CDR(BgL_head1305z00_18202);
									}
								else
									{	/* Eval/evaluate_comp.scm 448 */
										obj_t BgL_newtail1307z00_18207;

										{	/* Eval/evaluate_comp.scm 448 */
											obj_t BgL_arg3235z00_18208;

											{	/* Eval/evaluate_comp.scm 448 */
												obj_t BgL_ez00_18209;

												BgL_ez00_18209 = CAR(((obj_t) BgL_l1303z00_18205));
												BgL_arg3235z00_18208 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_18209),
													BgL_stkz00_15428);
											}
											{	/* Eval/evaluate_comp.scm 448 */
												obj_t BgL_res5166z00_18210;

												BgL_res5166z00_18210 =
													MAKE_YOUNG_PAIR(BgL_arg3235z00_18208, BNIL);
												BgL_newtail1307z00_18207 = BgL_res5166z00_18210;
											}
										}
										SET_CDR(BgL_tail1306z00_18206, BgL_newtail1307z00_18207);
										{	/* Eval/evaluate_comp.scm 448 */
											obj_t BgL_arg3234z00_18211;

											BgL_arg3234z00_18211 = CDR(((obj_t) BgL_l1303z00_18205));
											{
												obj_t BgL_tail1306z00_33822;
												obj_t BgL_l1303z00_33821;

												BgL_l1303z00_33821 = BgL_arg3234z00_18211;
												BgL_tail1306z00_33822 = BgL_newtail1307z00_18207;
												BgL_tail1306z00_18206 = BgL_tail1306z00_33822;
												BgL_l1303z00_18205 = BgL_l1303z00_33821;
												goto BgL_zc3z04anonymousza33231ze3z87_18204;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 449 */
					obj_t BgL_zc3z04anonymousza33225ze3z87_18212;

					BgL_zc3z04anonymousza33225ze3z87_18212 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33225ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33225ze3z87_18212,
						(int) (((long) 0)), BgL_argsz00_18200);
					return BgL_zc3z04anonymousza33225ze3z87_18212;
				}
			}
		}

	}



/* &<@anonymous:3225> */
	obj_t BGl_z62zc3z04anonymousza33225ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15429, obj_t BgL_sz00_15431)
	{
		{	/* Eval/evaluate_comp.scm 449 */
			{	/* Eval/evaluate_comp.scm 449 */
				obj_t BgL_argsz00_15430;

				BgL_argsz00_15430 = PROCEDURE_REF(BgL_envz00_15429, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 449 */
					obj_t BgL_bpz00_18213;

					BgL_bpz00_18213 = VECTOR_REF(((obj_t) BgL_sz00_15431), ((long) 0));
					{
						obj_t BgL_lz00_18215;
						obj_t BgL_rz00_18216;

						BgL_lz00_18215 = BgL_argsz00_15430;
						BgL_rz00_18216 = BTRUE;
					BgL_recz00_18214:
						if (NULLP(BgL_lz00_18215))
							{	/* Eval/evaluate_comp.scm 451 */
								return BgL_rz00_18216;
							}
						else
							{	/* Eval/evaluate_comp.scm 453 */
								obj_t BgL_vz00_18217;

								{	/* Eval/evaluate_comp.scm 453 */
									obj_t BgL_fun3229z00_18218;

									BgL_fun3229z00_18218 = CAR(((obj_t) BgL_lz00_18215));
									BgL_vz00_18217 =
										PROCEDURE_ENTRY(BgL_fun3229z00_18218) (BgL_fun3229z00_18218,
										BgL_sz00_15431, BEOA);
								}
								if (CBOOL(BgL_vz00_18217))
									{	/* Eval/evaluate_comp.scm 454 */
										obj_t BgL_arg3228z00_18219;

										BgL_arg3228z00_18219 = CDR(((obj_t) BgL_lz00_18215));
										{
											obj_t BgL_rz00_33845;
											obj_t BgL_lz00_33844;

											BgL_lz00_33844 = BgL_arg3228z00_18219;
											BgL_rz00_33845 = BgL_vz00_18217;
											BgL_rz00_18216 = BgL_rz00_33845;
											BgL_lz00_18215 = BgL_lz00_33844;
											goto BgL_recz00_18214;
										}
									}
								else
									{	/* Eval/evaluate_comp.scm 454 */
										return BFALSE;
									}
							}
					}
				}
			}
		}

	}



/* &comp-ev_or1412 */
	obj_t BGl_z62compzd2ev_or1412zb0zz__evaluate_compz00(obj_t BgL_envz00_15432,
		obj_t BgL_ez00_15433, obj_t BgL_stkz00_15434)
	{
		{	/* Eval/evaluate_comp.scm 437 */
			{	/* Eval/evaluate_comp.scm 439 */
				obj_t BgL_argsz00_18221;

				{	/* Eval/evaluate_comp.scm 439 */
					obj_t BgL_l1298z00_18222;

					BgL_l1298z00_18222 =
						(((BgL_ev_listz00_bglt) COBJECT(
								((BgL_ev_listz00_bglt)
									((BgL_ev_orz00_bglt) BgL_ez00_15433))))->BgL_argsz00);
					if (NULLP(BgL_l1298z00_18222))
						{	/* Eval/evaluate_comp.scm 439 */
							BgL_argsz00_18221 = BNIL;
						}
					else
						{	/* Eval/evaluate_comp.scm 439 */
							obj_t BgL_head1300z00_18223;

							{	/* Eval/evaluate_comp.scm 439 */
								obj_t BgL_res5151z00_18224;

								BgL_res5151z00_18224 = MAKE_YOUNG_PAIR(BNIL, BNIL);
								BgL_head1300z00_18223 = BgL_res5151z00_18224;
							}
							{
								obj_t BgL_l1298z00_18226;
								obj_t BgL_tail1301z00_18227;

								BgL_l1298z00_18226 = BgL_l1298z00_18222;
								BgL_tail1301z00_18227 = BgL_head1300z00_18223;
							BgL_zc3z04anonymousza33220ze3z87_18225:
								if (NULLP(BgL_l1298z00_18226))
									{	/* Eval/evaluate_comp.scm 439 */
										BgL_argsz00_18221 = CDR(BgL_head1300z00_18223);
									}
								else
									{	/* Eval/evaluate_comp.scm 439 */
										obj_t BgL_newtail1302z00_18228;

										{	/* Eval/evaluate_comp.scm 439 */
											obj_t BgL_arg3224z00_18229;

											{	/* Eval/evaluate_comp.scm 439 */
												obj_t BgL_ez00_18230;

												BgL_ez00_18230 = CAR(((obj_t) BgL_l1298z00_18226));
												BgL_arg3224z00_18229 =
													BGl_compz00zz__evaluate_compz00(
													((BgL_ev_exprz00_bglt) BgL_ez00_18230),
													BgL_stkz00_15434);
											}
											{	/* Eval/evaluate_comp.scm 439 */
												obj_t BgL_res5157z00_18231;

												BgL_res5157z00_18231 =
													MAKE_YOUNG_PAIR(BgL_arg3224z00_18229, BNIL);
												BgL_newtail1302z00_18228 = BgL_res5157z00_18231;
											}
										}
										SET_CDR(BgL_tail1301z00_18227, BgL_newtail1302z00_18228);
										{	/* Eval/evaluate_comp.scm 439 */
											obj_t BgL_arg3223z00_18232;

											BgL_arg3223z00_18232 = CDR(((obj_t) BgL_l1298z00_18226));
											{
												obj_t BgL_tail1301z00_33864;
												obj_t BgL_l1298z00_33863;

												BgL_l1298z00_33863 = BgL_arg3223z00_18232;
												BgL_tail1301z00_33864 = BgL_newtail1302z00_18228;
												BgL_tail1301z00_18227 = BgL_tail1301z00_33864;
												BgL_l1298z00_18226 = BgL_l1298z00_33863;
												goto BgL_zc3z04anonymousza33220ze3z87_18225;
											}
										}
									}
							}
						}
				}
				{	/* Eval/evaluate_comp.scm 440 */
					obj_t BgL_zc3z04anonymousza33210ze3z87_18233;

					BgL_zc3z04anonymousza33210ze3z87_18233 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33210ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33210ze3z87_18233,
						(int) (((long) 0)), BgL_argsz00_18221);
					return BgL_zc3z04anonymousza33210ze3z87_18233;
				}
			}
		}

	}



/* &<@anonymous:3210> */
	obj_t BGl_z62zc3z04anonymousza33210ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15435, obj_t BgL_sz00_15437)
	{
		{	/* Eval/evaluate_comp.scm 440 */
			{	/* Eval/evaluate_comp.scm 440 */
				obj_t BgL_argsz00_15436;

				BgL_argsz00_15436 = PROCEDURE_REF(BgL_envz00_15435, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 440 */
					obj_t BgL_bpz00_18234;

					BgL_bpz00_18234 = VECTOR_REF(((obj_t) BgL_sz00_15437), ((long) 0));
					{
						obj_t BgL_lz00_18236;

						BgL_lz00_18236 = BgL_argsz00_15436;
					BgL_recz00_18235:
						if (NULLP(BgL_lz00_18236))
							{	/* Eval/evaluate_comp.scm 442 */
								return BFALSE;
							}
						else
							{	/* Eval/evaluate_comp.scm 444 */
								obj_t BgL__ortest_1106z00_18237;

								{	/* Eval/evaluate_comp.scm 444 */
									obj_t BgL_fun3218z00_18238;

									BgL_fun3218z00_18238 = CAR(((obj_t) BgL_lz00_18236));
									BgL__ortest_1106z00_18237 =
										PROCEDURE_ENTRY(BgL_fun3218z00_18238) (BgL_fun3218z00_18238,
										BgL_sz00_15437, BEOA);
								}
								if (CBOOL(BgL__ortest_1106z00_18237))
									{	/* Eval/evaluate_comp.scm 444 */
										return BgL__ortest_1106z00_18237;
									}
								else
									{	/* Eval/evaluate_comp.scm 444 */
										obj_t BgL_arg3217z00_18239;

										BgL_arg3217z00_18239 = CDR(((obj_t) BgL_lz00_18236));
										{
											obj_t BgL_lz00_33886;

											BgL_lz00_33886 = BgL_arg3217z00_18239;
											BgL_lz00_18236 = BgL_lz00_33886;
											goto BgL_recz00_18235;
										}
									}
							}
					}
				}
			}
		}

	}



/* &comp-ev_if1410 */
	obj_t BGl_z62compzd2ev_if1410zb0zz__evaluate_compz00(obj_t BgL_envz00_15438,
		obj_t BgL_ez00_15439, obj_t BgL_stkz00_15440)
	{
		{	/* Eval/evaluate_comp.scm 431 */
			{	/* Eval/evaluate_comp.scm 433 */
				obj_t BgL_pz00_18241;
				obj_t BgL_tz00_18242;
				obj_t BgL_ez00_18243;

				BgL_pz00_18241 =
					BGl_compz00zz__evaluate_compz00(
					(((BgL_ev_ifz00_bglt) COBJECT(
								((BgL_ev_ifz00_bglt) BgL_ez00_15439)))->BgL_pz00),
					BgL_stkz00_15440);
				BgL_tz00_18242 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_15439)))->BgL_tz00),
					BgL_stkz00_15440);
				BgL_ez00_18243 =
					BGl_compz00zz__evaluate_compz00((((BgL_ev_ifz00_bglt)
							COBJECT(((BgL_ev_ifz00_bglt) BgL_ez00_15439)))->BgL_ez00),
					BgL_stkz00_15440);
				{	/* Eval/evaluate_comp.scm 434 */
					obj_t BgL_zc3z04anonymousza33202ze3z87_18244;

					BgL_zc3z04anonymousza33202ze3z87_18244 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33202ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 3)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33202ze3z87_18244,
						(int) (((long) 0)), BgL_ez00_18243);
					PROCEDURE_SET(BgL_zc3z04anonymousza33202ze3z87_18244,
						(int) (((long) 1)), BgL_tz00_18242);
					PROCEDURE_SET(BgL_zc3z04anonymousza33202ze3z87_18244,
						(int) (((long) 2)), BgL_pz00_18241);
					return BgL_zc3z04anonymousza33202ze3z87_18244;
				}
			}
		}

	}



/* &<@anonymous:3202> */
	obj_t BGl_z62zc3z04anonymousza33202ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15441, obj_t BgL_sz00_15445)
	{
		{	/* Eval/evaluate_comp.scm 434 */
			{	/* Eval/evaluate_comp.scm 434 */
				obj_t BgL_ez00_15442;
				obj_t BgL_tz00_15443;
				obj_t BgL_pz00_15444;

				BgL_ez00_15442 = PROCEDURE_REF(BgL_envz00_15441, (int) (((long) 0)));
				BgL_tz00_15443 = PROCEDURE_REF(BgL_envz00_15441, (int) (((long) 1)));
				BgL_pz00_15444 = PROCEDURE_REF(BgL_envz00_15441, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 434 */
					obj_t BgL_bpz00_18245;

					BgL_bpz00_18245 = VECTOR_REF(((obj_t) BgL_sz00_15445), ((long) 0));
					if (CBOOL(PROCEDURE_ENTRY(BgL_pz00_15444) (BgL_pz00_15444,
								BgL_sz00_15445, BEOA)))
						{	/* Eval/evaluate_comp.scm 435 */
							return
								PROCEDURE_ENTRY(BgL_tz00_15443) (BgL_tz00_15443, BgL_sz00_15445,
								BEOA);
						}
					else
						{	/* Eval/evaluate_comp.scm 435 */
							return
								PROCEDURE_ENTRY(BgL_ez00_15442) (BgL_ez00_15442, BgL_sz00_15445,
								BEOA);
						}
				}
			}
		}

	}



/* &comp-ev_litt1408 */
	obj_t BGl_z62compzd2ev_litt1408zb0zz__evaluate_compz00(obj_t BgL_envz00_15446,
		obj_t BgL_ez00_15447, obj_t BgL_stkz00_15448)
	{
		{	/* Eval/evaluate_comp.scm 426 */
			{	/* Eval/evaluate_comp.scm 428 */
				obj_t BgL_zc3z04anonymousza33201ze3z87_18247;

				BgL_zc3z04anonymousza33201ze3z87_18247 =
					MAKE_FX_PROCEDURE
					(BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00,
					(int) (((long) 1)), (int) (((long) 1)));
				PROCEDURE_SET(BgL_zc3z04anonymousza33201ze3z87_18247,
					(int) (((long) 0)), ((obj_t) ((BgL_ev_littz00_bglt) BgL_ez00_15447)));
				return BgL_zc3z04anonymousza33201ze3z87_18247;
			}
		}

	}



/* &<@anonymous:3201> */
	obj_t BGl_z62zc3z04anonymousza33201ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15449, obj_t BgL_sz00_15451)
	{
		{	/* Eval/evaluate_comp.scm 428 */
			{	/* Eval/evaluate_comp.scm 428 */
				BgL_ev_littz00_bglt BgL_i1103z00_15450;

				BgL_i1103z00_15450 =
					((BgL_ev_littz00_bglt)
					PROCEDURE_REF(BgL_envz00_15449, (int) (((long) 0))));
				{	/* Eval/evaluate_comp.scm 428 */
					obj_t BgL_bpz00_18248;

					BgL_bpz00_18248 = VECTOR_REF(((obj_t) BgL_sz00_15451), ((long) 0));
					return
						(((BgL_ev_littz00_bglt) COBJECT(BgL_i1103z00_15450))->BgL_valuez00);
				}
			}
		}

	}



/* &comp-ev_defglobal1405 */
	obj_t BGl_z62compzd2ev_defglobal1405zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15452, obj_t BgL_ez00_15453, obj_t BgL_stkz00_15454)
	{
		{	/* Eval/evaluate_comp.scm 395 */
			{	/* Eval/evaluate_comp.scm 397 */
				obj_t BgL_ez00_18250;

				{	/* Eval/evaluate_comp.scm 397 */
					BgL_ev_exprz00_bglt BgL_arg3200z00_18251;

					BgL_arg3200z00_18251 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_defglobalz00_bglt) BgL_ez00_15453))))->BgL_ez00);
					BgL_ez00_18250 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3200z00_18251,
						BgL_stkz00_15454);
				}
				{	/* Eval/evaluate_comp.scm 398 */
					obj_t BgL_zc3z04anonymousza33161ze3z87_18252;

					BgL_zc3z04anonymousza33161ze3z87_18252 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza33161ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 2)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33161ze3z87_18252,
						(int) (((long) 0)),
						((obj_t) ((BgL_ev_defglobalz00_bglt) BgL_ez00_15453)));
					PROCEDURE_SET(BgL_zc3z04anonymousza33161ze3z87_18252,
						(int) (((long) 1)), BgL_ez00_18250);
					return BgL_zc3z04anonymousza33161ze3z87_18252;
				}
			}
		}

	}



/* &<@anonymous:3161> */
	obj_t BGl_z62zc3z04anonymousza33161ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15455, obj_t BgL_sz00_15458)
	{
		{	/* Eval/evaluate_comp.scm 398 */
			{	/* Eval/evaluate_comp.scm 398 */
				BgL_ev_defglobalz00_bglt BgL_i1100z00_15456;
				obj_t BgL_ez00_15457;

				BgL_i1100z00_15456 =
					((BgL_ev_defglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15455, (int) (((long) 0))));
				BgL_ez00_15457 = PROCEDURE_REF(BgL_envz00_15455, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 398 */
					obj_t BgL_bpz00_18253;

					BgL_bpz00_18253 = VECTOR_REF(((obj_t) BgL_sz00_15458), ((long) 0));
					{	/* Eval/evaluate_comp.scm 399 */
						obj_t BgL_gz00_18254;

						{	/* Eval/evaluate_comp.scm 399 */
							obj_t BgL_arg3198z00_18255;
							obj_t BgL_arg3199z00_18256;

							BgL_arg3198z00_18255 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(
										((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15456)))->
								BgL_modz00);
							BgL_arg3199z00_18256 =
								(((BgL_ev_setglobalz00_bglt) COBJECT(((BgL_ev_setglobalz00_bglt)
											BgL_i1100z00_15456)))->BgL_namez00);
							BgL_gz00_18254 =
								BGl_evmodulezd2findzd2globalz00zz__evmodulez00
								(BgL_arg3198z00_18255, BgL_arg3199z00_18256);
						}
						if (CBOOL(BgL_gz00_18254))
							{	/* Eval/evaluate_comp.scm 401 */
								{

									{	/* Eval/evaluate_comp.scm 403 */
										int BgL_aux1102z00_18260;

										{	/* Eval/evaluate_comp.scm 403 */
											int BgL_res5149z00_18261;

											BgL_res5149z00_18261 =
												CINT(VECTOR_REF(((obj_t) BgL_gz00_18254), ((long) 0)));
											BgL_aux1102z00_18260 = BgL_res5149z00_18261;
										}
										switch ((long) (BgL_aux1102z00_18260))
											{
											case ((long) 0):

												{	/* Eval/evaluate_comp.scm 405 */
													obj_t BgL_arg3164z00_18262;
													obj_t BgL_arg3165z00_18263;

													BgL_arg3164z00_18262 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15456)))->BgL_locz00);
													BgL_arg3165z00_18263 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15456)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3164z00_18262,
														BGl_string5968z00zz__evaluate_compz00,
														BGl_string5969z00zz__evaluate_compz00,
														BgL_arg3165z00_18263);
												} break;
											case ((long) 1):

												{	/* Eval/evaluate_comp.scm 407 */
													obj_t BgL_arg3167z00_18264;
													obj_t BgL_arg3168z00_18265;

													BgL_arg3167z00_18264 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15456)))->BgL_locz00);
													BgL_arg3168z00_18265 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15456)))->BgL_namez00);
													{	/* Eval/evaluate_comp.scm 407 */
														obj_t BgL_list3169z00_18266;

														{	/* Eval/evaluate_comp.scm 407 */
															obj_t BgL_arg3171z00_18267;

															{	/* Eval/evaluate_comp.scm 407 */
																obj_t BgL_arg3172z00_18268;

																BgL_arg3172z00_18268 =
																	MAKE_YOUNG_PAIR(BgL_arg3168z00_18265, BNIL);
																BgL_arg3171z00_18267 =
																	MAKE_YOUNG_PAIR
																	(BGl_string5970z00zz__evaluate_compz00,
																	BgL_arg3172z00_18268);
															}
															BgL_list3169z00_18266 =
																MAKE_YOUNG_PAIR
																(BGl_string5847z00zz__evaluate_compz00,
																BgL_arg3171z00_18267);
														}
														BGl_evwarningz00zz__everrorz00(BgL_arg3167z00_18264,
															BgL_list3169z00_18266);
												}}
												{	/* Eval/evaluate_comp.scm 409 */
													obj_t BgL_arg3176z00_18269;
													obj_t BgL_arg3177z00_18270;

													BgL_arg3176z00_18269 =
														VECTOR_REF(((obj_t) BgL_gz00_18254), ((long) 2));
													BgL_arg3177z00_18270 =
														PROCEDURE_ENTRY(BgL_ez00_15457) (BgL_ez00_15457,
														BgL_sz00_15458, BEOA);
													__EVMEANING_ADDRESS_SET(BgL_arg3176z00_18269,
														BgL_arg3177z00_18270);
												} break;
											case ((long) 2):

												{	/* Eval/evaluate_comp.scm 411 */
													obj_t BgL_arg3178z00_18271;

													BgL_arg3178z00_18271 =
														PROCEDURE_ENTRY(BgL_ez00_15457) (BgL_ez00_15457,
														BgL_sz00_15458, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18254), ((long) 2),
														BgL_arg3178z00_18271);
												} break;
											case ((long) 3):

												{	/* Eval/evaluate_comp.scm 413 */
													obj_t BgL_arg3180z00_18272;

													BgL_arg3180z00_18272 =
														PROCEDURE_ENTRY(BgL_ez00_15457) (BgL_ez00_15457,
														BgL_sz00_15458, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18254), ((long) 2),
														BgL_arg3180z00_18272);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_18254), ((long) 0),
													BINT(((long) 2)));
												break;
											case ((long) 4):

												{	/* Eval/evaluate_comp.scm 416 */
													obj_t BgL_arg3181z00_18273;

													BgL_arg3181z00_18273 =
														PROCEDURE_ENTRY(BgL_ez00_15457) (BgL_ez00_15457,
														BgL_sz00_15458, BEOA);
													VECTOR_SET(((obj_t) BgL_gz00_18254), ((long) 2),
														BgL_arg3181z00_18273);
												}
												VECTOR_SET(
													((obj_t) BgL_gz00_18254), ((long) 0),
													BINT(((long) 5)));
												break;
											default:
												{	/* Eval/evaluate_comp.scm 419 */
													obj_t BgL_arg3182z00_18258;
													obj_t BgL_arg3186z00_18259;

													BgL_arg3182z00_18258 =
														(((BgL_ev_setglobalz00_bglt) COBJECT(
																((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15456)))->BgL_locz00);
													BgL_arg3186z00_18259 =
														(((BgL_ev_setglobalz00_bglt)
															COBJECT(((BgL_ev_setglobalz00_bglt)
																	BgL_i1100z00_15456)))->BgL_namez00);
													BGl_everrorz00zz__everrorz00(BgL_arg3182z00_18258,
														BGl_string5968z00zz__evaluate_compz00,
														BGl_string5969z00zz__evaluate_compz00,
														BgL_arg3186z00_18259);
												}
											}
									}
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15456)))->
									BgL_namez00);
							}
						else
							{	/* Eval/evaluate_comp.scm 421 */
								obj_t BgL_gz00_18274;

								{	/* Eval/evaluate_comp.scm 421 */
									obj_t BgL_arg3194z00_18275;
									obj_t BgL_arg3195z00_18276;
									obj_t BgL_arg3197z00_18277;

									BgL_arg3194z00_18275 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15456)))->
										BgL_namez00);
									BgL_arg3195z00_18276 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15456)))->BgL_modz00);
									BgL_arg3197z00_18277 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15456)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 421 */
										obj_t BgL_v1376z00_18278;

										BgL_v1376z00_18278 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18278, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18278, ((long) 1),
											BgL_arg3194z00_18275);
										VECTOR_SET(BgL_v1376z00_18278, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18278, ((long) 3),
											BgL_arg3195z00_18276);
										VECTOR_SET(BgL_v1376z00_18278, ((long) 4),
											BgL_arg3197z00_18277);
										BgL_gz00_18274 = BgL_v1376z00_18278;
								}}
								{	/* Eval/evaluate_comp.scm 422 */
									obj_t BgL_arg3188z00_18279;

									BgL_arg3188z00_18279 =
										PROCEDURE_ENTRY(BgL_ez00_15457) (BgL_ez00_15457,
										BgL_sz00_15458, BEOA);
									VECTOR_SET(BgL_gz00_18274, ((long) 2), BgL_arg3188z00_18279);
								}
								{	/* Eval/evaluate_comp.scm 423 */
									obj_t BgL_arg3189z00_18280;
									obj_t BgL_arg3191z00_18281;
									obj_t BgL_arg3192z00_18282;

									BgL_arg3189z00_18280 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15456)))->
										BgL_modz00);
									BgL_arg3191z00_18281 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15456)))->BgL_namez00);
									BgL_arg3192z00_18282 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt)
													BgL_i1100z00_15456)))->BgL_locz00);
									BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00
										(BgL_arg3189z00_18280, BgL_arg3191z00_18281, BgL_gz00_18274,
										BgL_arg3192z00_18282);
								}
								return
									(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_i1100z00_15456)))->
									BgL_namez00);
							}
					}
				}
			}
		}

	}



/* &comp-ev_setglobal1401 */
	obj_t BGl_z62compzd2ev_setglobal1401zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15459, obj_t BgL_ez00_15460, obj_t BgL_stkz00_15461)
	{
		{	/* Eval/evaluate_comp.scm 372 */
			{	/* Eval/evaluate_comp.scm 374 */
				obj_t BgL_gz00_18284;
				obj_t BgL_ez00_18285;

				BgL_gz00_18284 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->BgL_modz00),
					(((BgL_ev_setglobalz00_bglt) COBJECT(
								((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->BgL_namez00));
				{	/* Eval/evaluate_comp.scm 374 */
					BgL_ev_exprz00_bglt BgL_arg3160z00_18286;

					BgL_arg3160z00_18286 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setglobalz00_bglt) BgL_ez00_15460))))->BgL_ez00);
					BgL_ez00_18285 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3160z00_18286,
						BgL_stkz00_15461);
				}
				if (CBOOL(BgL_gz00_18284))
					{

						{	/* Eval/evaluate_comp.scm 376 */
							int BgL_aux1099z00_18289;

							{	/* Eval/evaluate_comp.scm 376 */
								int BgL_res5148z00_18290;

								BgL_res5148z00_18290 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_18284), ((long) 0)));
								BgL_aux1099z00_18289 = BgL_res5148z00_18290;
							}
							switch ((long) (BgL_aux1099z00_18289))
								{
								case ((long) 1):

									{	/* Eval/evaluate_comp.scm 378 */
										obj_t BgL_zc3z04anonymousza33119ze3z87_18291;

										BgL_zc3z04anonymousza33119ze3z87_18291 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza33119ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza33119ze3z87_18291,
											(int) (((long) 0)), BgL_gz00_18284);
										PROCEDURE_SET(BgL_zc3z04anonymousza33119ze3z87_18291,
											(int) (((long) 1)), BgL_ez00_18285);
										return BgL_zc3z04anonymousza33119ze3z87_18291;
									}
									break;
								case ((long) 0):
								case ((long) 4):
								case ((long) 5):

									return
										BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(
													((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
											BgL_locz00), BGl_string5968z00zz__evaluate_compz00,
										BGl_string5969z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt)
												COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
											BgL_namez00));
									break;
								default:
									{	/* Eval/evaluate_comp.scm 383 */
										obj_t BgL_zc3z04anonymousza33129ze3z87_18288;

										BgL_zc3z04anonymousza33129ze3z87_18288 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3z04anonymousza33129ze3ze5zz__evaluate_compz00,
											(int) (((long) 1)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3z04anonymousza33129ze3z87_18288,
											(int) (((long) 0)), BgL_ez00_18285);
										PROCEDURE_SET(BgL_zc3z04anonymousza33129ze3z87_18288,
											(int) (((long) 1)), BgL_gz00_18284);
										return BgL_zc3z04anonymousza33129ze3z87_18288;
									}
								}
						}
					}
				else
					{	/* Eval/evaluate_comp.scm 384 */
						obj_t BgL_slotz00_18292;

						BgL_slotz00_18292 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_setglobalz00_bglt) COBJECT(
											((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 386 */
								obj_t BgL_gz00_18293;

								{	/* Eval/evaluate_comp.scm 386 */
									obj_t BgL_arg3136z00_18294;
									obj_t BgL_arg3137z00_18295;
									obj_t BgL_arg3139z00_18296;

									BgL_arg3136z00_18294 =
										(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
										BgL_namez00);
									BgL_arg3137z00_18295 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
										BgL_modz00);
									BgL_arg3139z00_18296 =
										(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
										BgL_locz00);
									{	/* Eval/evaluate_comp.scm 386 */
										obj_t BgL_v1376z00_18297;

										BgL_v1376z00_18297 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18297, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18297, ((long) 1),
											BgL_arg3136z00_18294);
										VECTOR_SET(BgL_v1376z00_18297, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18297, ((long) 3),
											BgL_arg3137z00_18295);
										VECTOR_SET(BgL_v1376z00_18297, ((long) 4),
											BgL_arg3139z00_18296);
										BgL_gz00_18293 = BgL_v1376z00_18297;
								}}
								VECTOR_SET(BgL_gz00_18293, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(
												((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
										BgL_namez00), BgL_gz00_18293,
									(((BgL_ev_setglobalz00_bglt)
											COBJECT(((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)))->
										BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 385 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 389 */
							obj_t BgL_zc3z04anonymousza33141ze3z87_18298;

							BgL_zc3z04anonymousza33141ze3z87_18298 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33141ze3ze5zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 3)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33141ze3z87_18298,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_setglobalz00_bglt) BgL_ez00_15460)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33141ze3z87_18298,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_18292));
							PROCEDURE_SET(BgL_zc3z04anonymousza33141ze3z87_18298,
								(int) (((long) 2)), BgL_ez00_18285);
							return BgL_zc3z04anonymousza33141ze3z87_18298;
						}
					}
			}
		}

	}



/* &<@anonymous:3119> */
	obj_t BGl_z62zc3z04anonymousza33119ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15464, obj_t BgL_sz00_15467)
	{
		{	/* Eval/evaluate_comp.scm 378 */
			{	/* Eval/evaluate_comp.scm 378 */
				obj_t BgL_gz00_15465;
				obj_t BgL_ez00_15466;

				BgL_gz00_15465 = PROCEDURE_REF(BgL_envz00_15464, (int) (((long) 0)));
				BgL_ez00_15466 = PROCEDURE_REF(BgL_envz00_15464, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 378 */
					obj_t BgL_bpz00_18299;

					BgL_bpz00_18299 = VECTOR_REF(((obj_t) BgL_sz00_15467), ((long) 0));
					{	/* Eval/evaluate_comp.scm 379 */
						obj_t BgL_arg3120z00_18300;
						obj_t BgL_arg3123z00_18301;

						BgL_arg3120z00_18300 =
							VECTOR_REF(((obj_t) BgL_gz00_15465), ((long) 2));
						BgL_arg3123z00_18301 =
							PROCEDURE_ENTRY(BgL_ez00_15466) (BgL_ez00_15466, BgL_sz00_15467,
							BEOA);
						return __EVMEANING_ADDRESS_SET(BgL_arg3120z00_18300,
							BgL_arg3123z00_18301);
					}
				}
			}
		}

	}



/* &<@anonymous:3129> */
	obj_t BGl_z62zc3z04anonymousza33129ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15468, obj_t BgL_sz00_15471)
	{
		{	/* Eval/evaluate_comp.scm 383 */
			{	/* Eval/evaluate_comp.scm 383 */
				obj_t BgL_ez00_15469;
				obj_t BgL_gz00_15470;

				BgL_ez00_15469 = PROCEDURE_REF(BgL_envz00_15468, (int) (((long) 0)));
				BgL_gz00_15470 = PROCEDURE_REF(BgL_envz00_15468, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 383 */
					obj_t BgL_bpz00_18302;

					BgL_bpz00_18302 = VECTOR_REF(((obj_t) BgL_sz00_15471), ((long) 0));
					{	/* Eval/evaluate_comp.scm 383 */
						obj_t BgL_arg3130z00_18303;

						BgL_arg3130z00_18303 =
							PROCEDURE_ENTRY(BgL_ez00_15469) (BgL_ez00_15469, BgL_sz00_15471,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_gz00_15470), ((long) 2),
							BgL_arg3130z00_18303);
		}}}}

	}



/* &<@anonymous:3141> */
	obj_t BGl_z62zc3z04anonymousza33141ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15472, obj_t BgL_sz00_15476)
	{
		{	/* Eval/evaluate_comp.scm 389 */
			{	/* Eval/evaluate_comp.scm 389 */
				BgL_ev_setglobalz00_bglt BgL_i1097z00_15473;
				obj_t BgL_slotz00_15474;
				obj_t BgL_ez00_15475;

				BgL_i1097z00_15473 =
					((BgL_ev_setglobalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15472, (int) (((long) 0))));
				BgL_slotz00_15474 = PROCEDURE_REF(BgL_envz00_15472, (int) (((long) 1)));
				BgL_ez00_15475 = PROCEDURE_REF(BgL_envz00_15472, (int) (((long) 2)));
				{	/* Eval/evaluate_comp.scm 389 */
					obj_t BgL_bpz00_18304;

					BgL_bpz00_18304 = VECTOR_REF(((obj_t) BgL_sz00_15476), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_15474)))
						{	/* Eval/evaluate_comp.scm 390 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 390 */
							{	/* Eval/evaluate_comp.scm 391 */
								obj_t BgL_auxz00_18305;

								BgL_auxz00_18305 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15473))->
										BgL_modz00),
									(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15473))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_15474, BgL_auxz00_18305);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_15474)))
								{	/* Eval/evaluate_comp.scm 392 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 392 */
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15473))->
											BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
										BGl_string5971z00zz__evaluate_compz00,
										(((BgL_ev_setglobalz00_bglt) COBJECT(BgL_i1097z00_15473))->
											BgL_namez00));
								}
						}
					{	/* Eval/evaluate_comp.scm 393 */
						obj_t BgL_arg3149z00_18306;

						BgL_arg3149z00_18306 =
							PROCEDURE_ENTRY(BgL_ez00_15475) (BgL_ez00_15475, BgL_sz00_15476,
							BEOA);
						{	/* Eval/evaluate_comp.scm 393 */
							obj_t BgL_evalzd2globalzd2_18307;

							BgL_evalzd2globalzd2_18307 = CELL_REF(BgL_slotz00_15474);
							return
								VECTOR_SET(BgL_evalzd2globalzd2_18307, ((long) 2),
								BgL_arg3149z00_18306);
		}}}}}

	}



/* &comp-ev_global1399 */
	obj_t BGl_z62compzd2ev_global1399zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15478, obj_t BgL_varz00_15479, obj_t BgL_stkz00_15480)
	{
		{	/* Eval/evaluate_comp.scm 339 */
			{	/* Eval/evaluate_comp.scm 341 */
				obj_t BgL_gz00_18309;

				BgL_gz00_18309 =
					BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_15479)))->BgL_modz00),
					(((BgL_ev_globalz00_bglt) COBJECT(
								((BgL_ev_globalz00_bglt) BgL_varz00_15479)))->BgL_namez00));
				if (CBOOL(BgL_gz00_18309))
					{	/* Eval/evaluate_comp.scm 343 */
						bool_t BgL_test6862z00_34179;

						{	/* Eval/evaluate_comp.scm 343 */
							int BgL_arg3062z00_18310;

							{	/* Eval/evaluate_comp.scm 343 */
								int BgL_res5144z00_18311;

								BgL_res5144z00_18311 =
									CINT(VECTOR_REF(((obj_t) BgL_gz00_18309), ((long) 0)));
								BgL_arg3062z00_18310 = BgL_res5144z00_18311;
							}
							BgL_test6862z00_34179 =
								(BINT(BgL_arg3062z00_18310) == BINT(((long) 1)));
						}
						if (BgL_test6862z00_34179)
							{	/* Eval/evaluate_comp.scm 344 */
								obj_t BgL_zc3z04anonymousza33059ze3z87_18312;

								BgL_zc3z04anonymousza33059ze3z87_18312 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33059ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33059ze3z87_18312,
									(int) (((long) 0)), BgL_gz00_18309);
								return BgL_zc3z04anonymousza33059ze3z87_18312;
							}
						else
							{	/* Eval/evaluate_comp.scm 346 */
								obj_t BgL_zc3z04anonymousza33061ze3z87_18313;

								BgL_zc3z04anonymousza33061ze3z87_18313 =
									MAKE_FX_PROCEDURE
									(BGl_z62zc3z04anonymousza33061ze3ze5zz__evaluate_compz00,
									(int) (((long) 1)), (int) (((long) 1)));
								PROCEDURE_SET(BgL_zc3z04anonymousza33061ze3z87_18313,
									(int) (((long) 0)), BgL_gz00_18309);
								return BgL_zc3z04anonymousza33061ze3z87_18313;
							}
					}
				else
					{	/* Eval/evaluate_comp.scm 348 */
						obj_t BgL_slotz00_18314;

						BgL_slotz00_18314 = MAKE_CELL(BFALSE);
						if (BGl_evmodulezf3zf3zz__evmodulez00(
								(((BgL_ev_globalz00_bglt) COBJECT(
											((BgL_ev_globalz00_bglt) BgL_varz00_15479)))->
									BgL_modz00)))
							{	/* Eval/evaluate_comp.scm 350 */
								obj_t BgL_gz00_18315;

								{	/* Eval/evaluate_comp.scm 350 */
									obj_t BgL_arg3070z00_18316;
									obj_t BgL_arg3071z00_18317;
									obj_t BgL_arg3072z00_18318;

									BgL_arg3070z00_18316 =
										(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_15479)))->
										BgL_namez00);
									BgL_arg3071z00_18317 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15479)))->BgL_modz00);
									BgL_arg3072z00_18318 =
										(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15479)))->BgL_locz00);
									{	/* Eval/evaluate_comp.scm 350 */
										obj_t BgL_v1376z00_18319;

										BgL_v1376z00_18319 = create_vector(((long) 5));
										VECTOR_SET(BgL_v1376z00_18319, ((long) 0),
											BINT(((long) 2)));
										VECTOR_SET(BgL_v1376z00_18319, ((long) 1),
											BgL_arg3070z00_18316);
										VECTOR_SET(BgL_v1376z00_18319, ((long) 2), BUNSPEC);
										VECTOR_SET(BgL_v1376z00_18319, ((long) 3),
											BgL_arg3071z00_18317);
										VECTOR_SET(BgL_v1376z00_18319, ((long) 4),
											BgL_arg3072z00_18318);
										BgL_gz00_18315 = BgL_v1376z00_18319;
								}}
								VECTOR_SET(BgL_gz00_18315, ((long) 0), BINT(((long) 3)));
								BGl_evmodulezd2bindzd2globalz12z12zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(
												((BgL_ev_globalz00_bglt) BgL_varz00_15479)))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15479)))->BgL_namez00), BgL_gz00_18315,
									(((BgL_ev_globalz00_bglt) COBJECT(((BgL_ev_globalz00_bglt)
													BgL_varz00_15479)))->BgL_locz00));
							}
						else
							{	/* Eval/evaluate_comp.scm 349 */
								BFALSE;
							}
						{	/* Eval/evaluate_comp.scm 353 */
							obj_t BgL_zc3z04anonymousza33074ze3z87_18320;

							BgL_zc3z04anonymousza33074ze3z87_18320 =
								MAKE_FX_PROCEDURE
								(BGl_z62zc3z04anonymousza33074ze3ze5zz__evaluate_compz00,
								(int) (((long) 1)), (int) (((long) 2)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33074ze3z87_18320,
								(int) (((long) 0)),
								((obj_t) ((BgL_ev_globalz00_bglt) BgL_varz00_15479)));
							PROCEDURE_SET(BgL_zc3z04anonymousza33074ze3z87_18320,
								(int) (((long) 1)), ((obj_t) BgL_slotz00_18314));
							return BgL_zc3z04anonymousza33074ze3z87_18320;
						}
					}
			}
		}

	}



/* &<@anonymous:3059> */
	obj_t BGl_z62zc3z04anonymousza33059ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15483, obj_t BgL_sz00_15485)
	{
		{	/* Eval/evaluate_comp.scm 344 */
			{	/* Eval/evaluate_comp.scm 344 */
				obj_t BgL_gz00_15484;

				BgL_gz00_15484 = PROCEDURE_REF(BgL_envz00_15483, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 344 */
					obj_t BgL_bpz00_18321;

					BgL_bpz00_18321 = VECTOR_REF(((obj_t) BgL_sz00_15485), ((long) 0));
					{	/* Eval/evaluate_comp.scm 345 */
						obj_t BgL_arg3060z00_18322;

						BgL_arg3060z00_18322 =
							VECTOR_REF(((obj_t) BgL_gz00_15484), ((long) 2));
						return __EVMEANING_ADDRESS_REF(BgL_arg3060z00_18322);
					}
				}
			}
		}

	}



/* &<@anonymous:3061> */
	obj_t BGl_z62zc3z04anonymousza33061ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15486, obj_t BgL_sz00_15488)
	{
		{	/* Eval/evaluate_comp.scm 346 */
			{	/* Eval/evaluate_comp.scm 346 */
				obj_t BgL_gz00_15487;

				BgL_gz00_15487 = PROCEDURE_REF(BgL_envz00_15486, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 346 */
					obj_t BgL_bpz00_18323;

					BgL_bpz00_18323 = VECTOR_REF(((obj_t) BgL_sz00_15488), ((long) 0));
					return VECTOR_REF(((obj_t) BgL_gz00_15487), ((long) 2));
		}}}

	}



/* &<@anonymous:3074> */
	obj_t BGl_z62zc3z04anonymousza33074ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15489, obj_t BgL_sz00_15492)
	{
		{	/* Eval/evaluate_comp.scm 353 */
			{	/* Eval/evaluate_comp.scm 353 */
				BgL_ev_globalz00_bglt BgL_i1096z00_15490;
				obj_t BgL_slotz00_15491;

				BgL_i1096z00_15490 =
					((BgL_ev_globalz00_bglt)
					PROCEDURE_REF(BgL_envz00_15489, (int) (((long) 0))));
				BgL_slotz00_15491 = PROCEDURE_REF(BgL_envz00_15489, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 353 */
					obj_t BgL_bpz00_18324;

					BgL_bpz00_18324 = VECTOR_REF(((obj_t) BgL_sz00_15492), ((long) 0));
					if (CBOOL(CELL_REF(BgL_slotz00_15491)))
						{	/* Eval/evaluate_comp.scm 354 */
							BFALSE;
						}
					else
						{	/* Eval/evaluate_comp.scm 354 */
							{	/* Eval/evaluate_comp.scm 355 */
								obj_t BgL_auxz00_18325;

								BgL_auxz00_18325 =
									BGl_evmodulezd2findzd2globalz00zz__evmodulez00(
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15490))->
										BgL_modz00),
									(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15490))->
										BgL_namez00));
								CELL_SET(BgL_slotz00_15491, BgL_auxz00_18325);
							}
							if (CBOOL(CELL_REF(BgL_slotz00_15491)))
								{	/* Eval/evaluate_comp.scm 356 */
									BFALSE;
								}
							else
								{	/* Eval/evaluate_comp.scm 357 */
									obj_t BgL_idz00_18326;

									if (BGl_evmodulezf3zf3zz__evmodulez00(
											(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15490))->
												BgL_modz00)))
										{	/* Eval/evaluate_comp.scm 358 */
											obj_t BgL_arg3093z00_18327;

											{	/* Eval/evaluate_comp.scm 358 */
												obj_t BgL_arg3094z00_18328;
												obj_t BgL_arg3095z00_18329;

												BgL_arg3094z00_18328 =
													(((BgL_ev_globalz00_bglt)
														COBJECT(BgL_i1096z00_15490))->BgL_namez00);
												BgL_arg3095z00_18329 =
													MAKE_YOUNG_PAIR(BGl_evmodulezd2namezd2zz__evmodulez00(
														(((BgL_ev_globalz00_bglt)
																COBJECT(BgL_i1096z00_15490))->BgL_modz00)),
													BNIL);
												BgL_arg3093z00_18327 =
													MAKE_YOUNG_PAIR(BgL_arg3094z00_18328,
													BgL_arg3095z00_18329);
											}
											BgL_idz00_18326 =
												MAKE_YOUNG_PAIR(BGl_symbol5972z00zz__evaluate_compz00,
												BgL_arg3093z00_18327);
										}
									else
										{	/* Eval/evaluate_comp.scm 357 */
											BgL_idz00_18326 =
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15490))->
												BgL_namez00);
										}
									BGl_everrorz00zz__everrorz00(
										(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15490))->
											BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
										BGl_string5971z00zz__evaluate_compz00, BgL_idz00_18326);
								}
						}
					{	/* Eval/evaluate_comp.scm 361 */
						obj_t BgL_vz00_18330;

						{	/* Eval/evaluate_comp.scm 361 */
							obj_t BgL_evalzd2globalzd2_18331;

							BgL_evalzd2globalzd2_18331 = CELL_REF(BgL_slotz00_15491);
							BgL_vz00_18330 =
								VECTOR_REF(BgL_evalzd2globalzd2_18331, ((long) 2));
						}
						if ((BgL_vz00_18330 == BUNSPEC))
							{	/* Eval/evaluate_comp.scm 363 */
								int BgL_tz00_18332;

								{	/* Eval/evaluate_comp.scm 363 */
									int BgL_res5145z00_18333;

									{	/* Eval/evaluate_comp.scm 363 */
										obj_t BgL_evalzd2globalzd2_18334;

										BgL_evalzd2globalzd2_18334 = CELL_REF(BgL_slotz00_15491);
										BgL_res5145z00_18333 =
											CINT(VECTOR_REF(BgL_evalzd2globalzd2_18334, ((long) 0)));
									}
									BgL_tz00_18332 = BgL_res5145z00_18333;
								}
								{	/* Eval/evaluate_comp.scm 364 */
									bool_t BgL_test6868z00_34276;

									if (((long) (BgL_tz00_18332) == ((long) 3)))
										{	/* Eval/evaluate_comp.scm 364 */
											BgL_test6868z00_34276 = ((bool_t) 1);
										}
									else
										{	/* Eval/evaluate_comp.scm 364 */
											BgL_test6868z00_34276 =
												((long) (BgL_tz00_18332) == ((long) 4));
										}
									if (BgL_test6868z00_34276)
										{	/* Eval/evaluate_comp.scm 365 */
											obj_t BgL_idz00_18335;

											if (BGl_evmodulezf3zf3zz__evmodulez00(
													(((BgL_ev_globalz00_bglt)
															COBJECT(BgL_i1096z00_15490))->BgL_modz00)))
												{	/* Eval/evaluate_comp.scm 366 */
													obj_t BgL_arg3107z00_18336;

													{	/* Eval/evaluate_comp.scm 366 */
														obj_t BgL_arg3108z00_18337;
														obj_t BgL_arg3110z00_18338;

														BgL_arg3108z00_18337 =
															(((BgL_ev_globalz00_bglt)
																COBJECT(BgL_i1096z00_15490))->BgL_namez00);
														BgL_arg3110z00_18338 =
															MAKE_YOUNG_PAIR
															(BGl_evmodulezd2namezd2zz__evmodulez00(((
																		(BgL_ev_globalz00_bglt)
																		COBJECT(BgL_i1096z00_15490))->BgL_modz00)),
															BNIL);
														BgL_arg3107z00_18336 =
															MAKE_YOUNG_PAIR(BgL_arg3108z00_18337,
															BgL_arg3110z00_18338);
													}
													BgL_idz00_18335 =
														MAKE_YOUNG_PAIR
														(BGl_symbol5972z00zz__evaluate_compz00,
														BgL_arg3107z00_18336);
												}
											else
												{	/* Eval/evaluate_comp.scm 365 */
													BgL_idz00_18335 =
														(((BgL_ev_globalz00_bglt)
															COBJECT(BgL_i1096z00_15490))->BgL_namez00);
												}
											return
												BGl_everrorz00zz__everrorz00(
												(((BgL_ev_globalz00_bglt) COBJECT(BgL_i1096z00_15490))->
													BgL_locz00), BGl_string5847z00zz__evaluate_compz00,
												BGl_string5974z00zz__evaluate_compz00, BgL_idz00_18335);
										}
									else
										{	/* Eval/evaluate_comp.scm 364 */
											return BgL_vz00_18330;
										}
								}
							}
						else
							{	/* Eval/evaluate_comp.scm 362 */
								return BgL_vz00_18330;
							}
					}
				}
			}
		}

	}



/* &comp-ev_setlocal1397 */
	obj_t BGl_z62compzd2ev_setlocal1397zb0zz__evaluate_compz00(obj_t
		BgL_envz00_15494, obj_t BgL_ez00_15495, obj_t BgL_stkz00_15496)
	{
		{	/* Eval/evaluate_comp.scm 321 */
			{	/* Eval/evaluate_comp.scm 323 */
				obj_t BgL_iz00_18340;
				obj_t BgL_ez00_18341;

				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_varz00_bglt BgL_arg3053z00_18342;

					BgL_arg3053z00_18342 =
						(((BgL_ev_setlocalz00_bglt) COBJECT(
								((BgL_ev_setlocalz00_bglt) BgL_ez00_15495)))->BgL_vz00);
					BgL_iz00_18340 =
						BGl__indexz00zz__evaluate_compz00(
						((obj_t) BgL_arg3053z00_18342), BgL_stkz00_15496);
				}
				{	/* Eval/evaluate_comp.scm 323 */
					BgL_ev_exprz00_bglt BgL_arg3054z00_18343;

					BgL_arg3054z00_18343 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_setlocalz00_bglt) BgL_ez00_15495))))->BgL_ez00);
					BgL_ez00_18341 =
						BGl_compz00zz__evaluate_compz00(BgL_arg3054z00_18343,
						BgL_stkz00_15496);
				}
				if (CBOOL(
						(((BgL_ev_varz00_bglt) COBJECT(
									(((BgL_ev_setlocalz00_bglt) COBJECT(
												((BgL_ev_setlocalz00_bglt) BgL_ez00_15495)))->
										BgL_vz00)))->BgL_effz00)))
					{	/* Eval/evaluate_comp.scm 326 */
						obj_t BgL_zc3z04anonymousza33037ze3z87_18344;

						BgL_zc3z04anonymousza33037ze3z87_18344 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33037ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33037ze3z87_18344,
							(int) (((long) 0)), BgL_iz00_18340);
						PROCEDURE_SET(BgL_zc3z04anonymousza33037ze3z87_18344,
							(int) (((long) 1)), BgL_ez00_18341);
						return BgL_zc3z04anonymousza33037ze3z87_18344;
					}
				else
					{	/* Eval/evaluate_comp.scm 328 */
						obj_t BgL_zc3z04anonymousza33048ze3z87_18345;

						BgL_zc3z04anonymousza33048ze3z87_18345 =
							MAKE_FX_PROCEDURE
							(BGl_z62zc3z04anonymousza33048ze3ze5zz__evaluate_compz00,
							(int) (((long) 1)), (int) (((long) 2)));
						PROCEDURE_SET(BgL_zc3z04anonymousza33048ze3z87_18345,
							(int) (((long) 0)), BgL_iz00_18340);
						PROCEDURE_SET(BgL_zc3z04anonymousza33048ze3z87_18345,
							(int) (((long) 1)), BgL_ez00_18341);
						return BgL_zc3z04anonymousza33048ze3z87_18345;
					}
			}
		}

	}



/* &<@anonymous:3037> */
	obj_t BGl_z62zc3z04anonymousza33037ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15497, obj_t BgL_sz00_15500)
	{
		{	/* Eval/evaluate_comp.scm 326 */
			{	/* Eval/evaluate_comp.scm 326 */
				obj_t BgL_iz00_15498;
				obj_t BgL_ez00_15499;

				BgL_iz00_15498 = PROCEDURE_REF(BgL_envz00_15497, (int) (((long) 0)));
				BgL_ez00_15499 = PROCEDURE_REF(BgL_envz00_15497, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 326 */
					obj_t BgL_bpz00_18346;

					BgL_bpz00_18346 = VECTOR_REF(((obj_t) BgL_sz00_15500), ((long) 0));
					{	/* Eval/evaluate_comp.scm 327 */
						obj_t BgL_arg3039z00_18347;
						obj_t BgL_arg3046z00_18348;

						{	/* Eval/evaluate_comp.scm 327 */
							long BgL_arg3047z00_18349;

							BgL_arg3047z00_18349 =
								((long) CINT(BgL_bpz00_18346) + (long) CINT(BgL_iz00_15498));
							BgL_arg3039z00_18347 =
								VECTOR_REF(((obj_t) BgL_sz00_15500), BgL_arg3047z00_18349);
						}
						BgL_arg3046z00_18348 =
							PROCEDURE_ENTRY(BgL_ez00_15499) (BgL_ez00_15499, BgL_sz00_15500,
							BEOA);
						{	/* Eval/evaluate_comp.scm 202 */
							obj_t BgL_xz00_18350;

							{	/* Eval/evaluate_comp.scm 202 */
								int BgL_auxz00_34338;
								obj_t BgL_tmpz00_34336;

								BgL_auxz00_34338 = (int) (((long) 0));
								BgL_tmpz00_34336 = ((obj_t) BgL_arg3039z00_18347);
								BgL_xz00_18350 =
									STRUCT_SET(BgL_tmpz00_34336, BgL_auxz00_34338,
									BgL_arg3046z00_18348);
							}
							return BUNSPEC;
						}
					}
				}
			}
		}

	}



/* &<@anonymous:3048> */
	obj_t BGl_z62zc3z04anonymousza33048ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15501, obj_t BgL_sz00_15504)
	{
		{	/* Eval/evaluate_comp.scm 328 */
			{	/* Eval/evaluate_comp.scm 328 */
				obj_t BgL_iz00_15502;
				obj_t BgL_ez00_15503;

				BgL_iz00_15502 = PROCEDURE_REF(BgL_envz00_15501, (int) (((long) 0)));
				BgL_ez00_15503 = PROCEDURE_REF(BgL_envz00_15501, (int) (((long) 1)));
				{	/* Eval/evaluate_comp.scm 328 */
					obj_t BgL_bpz00_18351;

					BgL_bpz00_18351 = VECTOR_REF(((obj_t) BgL_sz00_15504), ((long) 0));
					{	/* Eval/evaluate_comp.scm 329 */
						long BgL_arg3049z00_18352;
						obj_t BgL_arg3052z00_18353;

						BgL_arg3049z00_18352 =
							((long) CINT(BgL_bpz00_18351) + (long) CINT(BgL_iz00_15502));
						BgL_arg3052z00_18353 =
							PROCEDURE_ENTRY(BgL_ez00_15503) (BgL_ez00_15503, BgL_sz00_15504,
							BEOA);
						return VECTOR_SET(((obj_t) BgL_sz00_15504), BgL_arg3049z00_18352,
							BgL_arg3052z00_18353);
					}
				}
			}
		}

	}



/* &comp-ev_var1395 */
	obj_t BGl_z62compzd2ev_var1395zb0zz__evaluate_compz00(obj_t BgL_envz00_15505,
		obj_t BgL_varz00_15506, obj_t BgL_stkz00_15507)
	{
		{	/* Eval/evaluate_comp.scm 316 */
			{	/* Eval/evaluate_comp.scm 317 */
				obj_t BgL_iz00_18355;

				BgL_iz00_18355 =
					BGl__indexz00zz__evaluate_compz00(
					((obj_t) ((BgL_ev_varz00_bglt) BgL_varz00_15506)), BgL_stkz00_15507);
				{

					if (INTEGERP(BgL_iz00_18355))
						{	/* Eval/evaluate_comp.scm 319 */
							switch ((long) CINT(BgL_iz00_18355))
								{
								case ((long) 0):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15506)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5975z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5976z00zz__evaluate_compz00;
										}
									break;
								case ((long) 1):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15506)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5977z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5978z00zz__evaluate_compz00;
										}
									break;
								case ((long) 2):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15506)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5979z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5980z00zz__evaluate_compz00;
										}
									break;
								case ((long) 3):

									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15506)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5981z00zz__evaluate_compz00;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											return BGl_proc5982z00zz__evaluate_compz00;
										}
									break;
								default:
								BgL_case_else1091z00_18356:
									if (CBOOL(
											(((BgL_ev_varz00_bglt) COBJECT(
														((BgL_ev_varz00_bglt) BgL_varz00_15506)))->
												BgL_effz00)))
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3z04anonymousza33030ze3z87_18357;

											BgL_zc3z04anonymousza33030ze3z87_18357 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33030ze3z87_18357,
												(int) (((long) 0)), BgL_iz00_18355);
											return BgL_zc3z04anonymousza33030ze3z87_18357;
										}
									else
										{	/* Eval/evaluate_comp.scm 319 */
											obj_t BgL_zc3z04anonymousza33034ze3z87_18358;

											BgL_zc3z04anonymousza33034ze3z87_18358 =
												MAKE_FX_PROCEDURE
												(BGl_z62zc3z04anonymousza33034ze3ze5zz__evaluate_compz00,
												(int) (((long) 1)), (int) (((long) 1)));
											PROCEDURE_SET(BgL_zc3z04anonymousza33034ze3z87_18358,
												(int) (((long) 0)), BgL_iz00_18355);
											return BgL_zc3z04anonymousza33034ze3z87_18358;
										}
								}
						}
					else
						{	/* Eval/evaluate_comp.scm 319 */
							goto BgL_case_else1091z00_18356;
						}
				}
			}
		}

	}



/* &<@anonymous:3023> */
	obj_t BGl_z62zc3z04anonymousza33023ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15508, obj_t BgL_sz00_15509)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18359;

				BgL_bpz00_18359 = VECTOR_REF(((obj_t) BgL_sz00_15509), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg3025z00_18360;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3026z00_18361;

						BgL_arg3026z00_18361 = ((long) CINT(BgL_bpz00_18359) + ((long) 3));
						BgL_arg3025z00_18360 =
							VECTOR_REF(((obj_t) BgL_sz00_15509), BgL_arg3026z00_18361);
					}
					return STRUCT_REF(((obj_t) BgL_arg3025z00_18360), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:3027> */
	obj_t BGl_z62zc3z04anonymousza33027ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15510, obj_t BgL_sz00_15511)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18362;

				BgL_bpz00_18362 = VECTOR_REF(((obj_t) BgL_sz00_15511), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg3028z00_18363;

					BgL_arg3028z00_18363 = ((long) CINT(BgL_bpz00_18362) + ((long) 3));
					return VECTOR_REF(((obj_t) BgL_sz00_15511), BgL_arg3028z00_18363);
				}
			}
		}

	}



/* &<@anonymous:3016> */
	obj_t BGl_z62zc3z04anonymousza33016ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15512, obj_t BgL_sz00_15513)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18364;

				BgL_bpz00_18364 = VECTOR_REF(((obj_t) BgL_sz00_15513), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg3017z00_18365;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3019z00_18366;

						BgL_arg3019z00_18366 = ((long) CINT(BgL_bpz00_18364) + ((long) 2));
						BgL_arg3017z00_18365 =
							VECTOR_REF(((obj_t) BgL_sz00_15513), BgL_arg3019z00_18366);
					}
					return STRUCT_REF(((obj_t) BgL_arg3017z00_18365), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:3020> */
	obj_t BGl_z62zc3z04anonymousza33020ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15514, obj_t BgL_sz00_15515)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18367;

				BgL_bpz00_18367 = VECTOR_REF(((obj_t) BgL_sz00_15515), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg3021z00_18368;

					BgL_arg3021z00_18368 = ((long) CINT(BgL_bpz00_18367) + ((long) 2));
					return VECTOR_REF(((obj_t) BgL_sz00_15515), BgL_arg3021z00_18368);
				}
			}
		}

	}



/* &<@anonymous:3009> */
	obj_t BGl_z62zc3z04anonymousza33009ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15516, obj_t BgL_sz00_15517)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18369;

				BgL_bpz00_18369 = VECTOR_REF(((obj_t) BgL_sz00_15517), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg3011z00_18370;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3012z00_18371;

						BgL_arg3012z00_18371 = ((long) CINT(BgL_bpz00_18369) + ((long) 1));
						BgL_arg3011z00_18370 =
							VECTOR_REF(((obj_t) BgL_sz00_15517), BgL_arg3012z00_18371);
					}
					return STRUCT_REF(((obj_t) BgL_arg3011z00_18370), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:3013> */
	obj_t BGl_z62zc3z04anonymousza33013ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15518, obj_t BgL_sz00_15519)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18372;

				BgL_bpz00_18372 = VECTOR_REF(((obj_t) BgL_sz00_15519), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg3014z00_18373;

					BgL_arg3014z00_18373 = ((long) CINT(BgL_bpz00_18372) + ((long) 1));
					return VECTOR_REF(((obj_t) BgL_sz00_15519), BgL_arg3014z00_18373);
				}
			}
		}

	}



/* &<@anonymous:2999> */
	obj_t BGl_z62zc3z04anonymousza32999ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15520, obj_t BgL_sz00_15521)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18374;

				BgL_bpz00_18374 = VECTOR_REF(((obj_t) BgL_sz00_15521), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_arg3004z00_18375;

					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3005z00_18376;

						BgL_arg3005z00_18376 = ((long) CINT(BgL_bpz00_18374) + ((long) 0));
						BgL_arg3004z00_18375 =
							VECTOR_REF(((obj_t) BgL_sz00_15521), BgL_arg3005z00_18376);
					}
					return STRUCT_REF(((obj_t) BgL_arg3004z00_18375), (int) (((long) 0)));
		}}}

	}



/* &<@anonymous:3006> */
	obj_t BGl_z62zc3z04anonymousza33006ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15522, obj_t BgL_sz00_15523)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_bpz00_18377;

				BgL_bpz00_18377 = VECTOR_REF(((obj_t) BgL_sz00_15523), ((long) 0));
				{	/* Eval/evaluate_comp.scm 319 */
					long BgL_arg3007z00_18378;

					BgL_arg3007z00_18378 = ((long) CINT(BgL_bpz00_18377) + ((long) 0));
					return VECTOR_REF(((obj_t) BgL_sz00_15523), BgL_arg3007z00_18378);
				}
			}
		}

	}



/* &<@anonymous:3030> */
	obj_t BGl_z62zc3z04anonymousza33030ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15524, obj_t BgL_sz00_15526)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_15525;

				BgL_iz00_15525 = PROCEDURE_REF(BgL_envz00_15524, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_18379;

					BgL_bpz00_18379 = VECTOR_REF(((obj_t) BgL_sz00_15526), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						obj_t BgL_arg3032z00_18380;

						{	/* Eval/evaluate_comp.scm 319 */
							long BgL_arg3033z00_18381;

							BgL_arg3033z00_18381 =
								((long) CINT(BgL_bpz00_18379) + (long) CINT(BgL_iz00_15525));
							BgL_arg3032z00_18380 =
								VECTOR_REF(((obj_t) BgL_sz00_15526), BgL_arg3033z00_18381);
						}
						return
							STRUCT_REF(((obj_t) BgL_arg3032z00_18380), (int) (((long) 0)));
		}}}}

	}



/* &<@anonymous:3034> */
	obj_t BGl_z62zc3z04anonymousza33034ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15527, obj_t BgL_sz00_15529)
	{
		{	/* Eval/evaluate_comp.scm 319 */
			{	/* Eval/evaluate_comp.scm 319 */
				obj_t BgL_iz00_15528;

				BgL_iz00_15528 = PROCEDURE_REF(BgL_envz00_15527, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 319 */
					obj_t BgL_bpz00_18382;

					BgL_bpz00_18382 = VECTOR_REF(((obj_t) BgL_sz00_15529), ((long) 0));
					{	/* Eval/evaluate_comp.scm 319 */
						long BgL_arg3035z00_18383;

						BgL_arg3035z00_18383 =
							((long) CINT(BgL_bpz00_18382) + (long) CINT(BgL_iz00_15528));
						return VECTOR_REF(((obj_t) BgL_sz00_15529), BgL_arg3035z00_18383);
					}
				}
			}
		}

	}



/* &comp-ev_trap1393 */
	obj_t BGl_z62compzd2ev_trap1393zb0zz__evaluate_compz00(obj_t BgL_envz00_15530,
		obj_t BgL_ez00_15531, obj_t BgL_stkz00_15532)
	{
		{	/* Eval/evaluate_comp.scm 289 */
			{	/* Eval/evaluate_comp.scm 291 */
				obj_t BgL_ez00_18385;

				{	/* Eval/evaluate_comp.scm 291 */
					BgL_ev_exprz00_bglt BgL_arg2996z00_18386;

					BgL_arg2996z00_18386 =
						(((BgL_ev_hookz00_bglt) COBJECT(
								((BgL_ev_hookz00_bglt)
									((BgL_ev_trapz00_bglt) BgL_ez00_15531))))->BgL_ez00);
					BgL_ez00_18385 =
						BGl_compz00zz__evaluate_compz00(BgL_arg2996z00_18386,
						BgL_stkz00_15532);
				}
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_zc3z04anonymousza32982ze3z87_18387;

					BgL_zc3z04anonymousza32982ze3z87_18387 =
						MAKE_FX_PROCEDURE
						(BGl_z62zc3z04anonymousza32982ze3ze5zz__evaluate_compz00,
						(int) (((long) 1)), (int) (((long) 1)));
					PROCEDURE_SET(BgL_zc3z04anonymousza32982ze3z87_18387,
						(int) (((long) 0)), BgL_ez00_18385);
					return BgL_zc3z04anonymousza32982ze3z87_18387;
				}
			}
		}

	}



/* &<@anonymous:2982> */
	obj_t BGl_z62zc3z04anonymousza32982ze3ze5zz__evaluate_compz00(obj_t
		BgL_envz00_15533, obj_t BgL_sz00_15535)
	{
		{	/* Eval/evaluate_comp.scm 292 */
			{	/* Eval/evaluate_comp.scm 292 */
				obj_t BgL_ez00_15534;

				BgL_ez00_15534 = PROCEDURE_REF(BgL_envz00_15533, (int) (((long) 0)));
				{	/* Eval/evaluate_comp.scm 292 */
					obj_t BgL_bpz00_18388;

					BgL_bpz00_18388 = VECTOR_REF(((obj_t) BgL_sz00_15535), ((long) 0));
					{	/* Eval/evaluate_comp.scm 293 */
						obj_t BgL_cmdz00_18389;

						BgL_cmdz00_18389 =
							PROCEDURE_ENTRY(BgL_ez00_15534) (BgL_ez00_15534, BgL_sz00_15535,
							BEOA);
						if ((BgL_cmdz00_18389 == BGl_symbol5983z00zz__evaluate_compz00))
							{	/* Eval/evaluate_comp.scm 294 */
								return BgL_bpz00_18388;
							}
						else
							{	/* Eval/evaluate_comp.scm 294 */
								if ((BgL_cmdz00_18389 == BGl_symbol5985z00zz__evaluate_compz00))
									{	/* Eval/evaluate_comp.scm 294 */
										return BGl_reset_profilez00zz__evaluate_compz00();
									}
								else
									{	/* Eval/evaluate_comp.scm 294 */
										if (
											(BgL_cmdz00_18389 ==
												BGl_symbol5987z00zz__evaluate_compz00))
											{	/* Eval/evaluate_comp.scm 294 */
												return BGl_get_profilez00zz__evaluate_compz00();
											}
										else
											{	/* Eval/evaluate_comp.scm 294 */
												if (
													(BgL_cmdz00_18389 ==
														BGl_symbol5989z00zz__evaluate_compz00))
													{	/* Eval/evaluate_comp.scm 302 */
														obj_t BgL_arg2991z00_18390;

														BgL_arg2991z00_18390 =
															BGl_findzd2statezd2zz__evaluate_compz00();
														return
															VECTOR_SET(
															((obj_t) BgL_arg2991z00_18390), ((long) 0),
															BINT(((long) 2)));
													}
												else
													{	/* Eval/evaluate_comp.scm 294 */
														return
															BGl_errorz00zz__errorz00
															(BGl_string5847z00zz__evaluate_compz00,
															BGl_string5991z00zz__evaluate_compz00,
															BgL_cmdz00_18389);
													}
											}
									}
							}
					}
				}
			}
		}

	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluate_compz00()
	{
		{	/* Eval/evaluate_comp.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 121046386),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 37115357),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 70989162),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135277364),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218115),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267996),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519875),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 251315035),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936798),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 439352636),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453938973),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 193422032),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 224967910),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__srfi4z00(((long) 467925662),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 68572481),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					420334581), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					437057945), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155874), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198621048), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309694), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519474),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460263341),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) -44274296),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					9614573), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927845), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151379), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 190906089),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 331540733),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 86988972),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942106),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220647683),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147628),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007030),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 528345319),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492753248),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872251),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 505900559),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509655),
				BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_usez00(((long)
					20669922), BSTRING_TO_STRING(BGl_string5992z00zz__evaluate_compz00));
		}

	}

#ifdef __cplusplus
}
#endif
